                       
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_association_tie_role
                            
                            	S2L Association Tie Role
                            	**type**\:   :py:class:`TeAssociationTieRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAssociationTieRole>`
                            
                            .. attribute:: s2l_association_type
                            
                            	S2L Association Type                          (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_extended_id
                            
                            	S2L Extended ID Array
                            	**type**\: list of    :py:class:`S2LExtendedId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.Association.S2LExtendedId>`
                            
                            .. attribute:: s2l_global_source
                            
                            	S2L Global Source
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.Association, self).__init__()

                                self.yang_name = "association"
                                self.yang_parent_name = "s2l"

                                self.s2l_association_id = YLeaf(YType.uint16, "s2l-association-id")

                                self.s2l_association_source = YLeaf(YType.str, "s2l-association-source")

                                self.s2l_association_tie_role = YLeaf(YType.enumeration, "s2l-association-tie-role")

                                self.s2l_association_type = YLeaf(YType.uint16, "s2l-association-type")

                                self.s2l_global_source = YLeaf(YType.uint32, "s2l-global-source")

                                self.s2l_extended_id = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("s2l_association_id",
                                                "s2l_association_source",
                                                "s2l_association_tie_role",
                                                "s2l_association_type",
                                                "s2l_global_source") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.Association, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.Association, self).__setattr__(name, value)


                            class S2LExtendedId(Entity):
                                """
                                S2L Extended ID Array
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.Association.S2LExtendedId, self).__init__()

                                    self.yang_name = "s2l-extended-id"
                                    self.yang_parent_name = "association"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.Association.S2LExtendedId, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.Association.S2LExtendedId, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "s2l-extended-id" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.s2l_extended_id:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.s2l_association_id.is_set or
                                    self.s2l_association_source.is_set or
                                    self.s2l_association_tie_role.is_set or
                                    self.s2l_association_type.is_set or
                                    self.s2l_global_source.is_set)

                            def has_operation(self):
                                for c in self.s2l_extended_id:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.s2l_association_id.yfilter != YFilter.not_set or
                                    self.s2l_association_source.yfilter != YFilter.not_set or
                                    self.s2l_association_tie_role.yfilter != YFilter.not_set or
                                    self.s2l_association_type.yfilter != YFilter.not_set or
                                    self.s2l_global_source.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "association" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.s2l_association_id.is_set or self.s2l_association_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_id.get_name_leafdata())
                                if (self.s2l_association_source.is_set or self.s2l_association_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_source.get_name_leafdata())
                                if (self.s2l_association_tie_role.is_set or self.s2l_association_tie_role.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_tie_role.get_name_leafdata())
                                if (self.s2l_association_type.is_set or self.s2l_association_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_type.get_name_leafdata())
                                if (self.s2l_global_source.is_set or self.s2l_global_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_global_source.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "s2l-extended-id"):
                                    for c in self.s2l_extended_id:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.Association.S2LExtendedId()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.s2l_extended_id.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "s2l-extended-id" or name == "s2l-association-id" or name == "s2l-association-source" or name == "s2l-association-tie-role" or name == "s2l-association-type" or name == "s2l-global-source"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "s2l-association-id"):
                                    self.s2l_association_id = value
                                    self.s2l_association_id.value_namespace = name_space
                                    self.s2l_association_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-source"):
                                    self.s2l_association_source = value
                                    self.s2l_association_source.value_namespace = name_space
                                    self.s2l_association_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-tie-role"):
                                    self.s2l_association_tie_role = value
                                    self.s2l_association_tie_role.value_namespace = name_space
                                    self.s2l_association_tie_role.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-type"):
                                    self.s2l_association_type = value
                                    self.s2l_association_type.value_namespace = name_space
                                    self.s2l_association_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-global-source"):
                                    self.s2l_global_source = value
                                    self.s2l_global_source.value_namespace = name_space
                                    self.s2l_global_source.value_namespace_prefix = name_space_prefix


                        class Protection(Entity):
                            """
                            Protection Object
                            
                            .. attribute:: any
                            
                            	Any
                            	**type**\:  bool
                            
                            .. attribute:: ded1_plus1
                            
                            	Dedicated 1+1 Protection
                            	**type**\:  bool
                            
                            .. attribute:: ded1_to1
                            
                            	Dedicated 1\:1 Protection
                            	**type**\:  bool
                            
                            .. attribute:: enhanced
                            
                            	Indicates Enhanced Protection Scheme
                            	**type**\:  bool
                            
                            .. attribute:: extra_traffic
                            
                            	LSP should use Links that are protecting other (primary) traffic
                            	**type**\:  bool
                            
                            .. attribute:: link_unprotected
                            
                            	LSP should not use any Link Layer Protection
                            	**type**\:  bool
                            
                            .. attribute:: lsp_unprotected
                            
                            	LSP Flags Unprotected
                            	**type**\:  bool
                            
                            .. attribute:: one_plus_one_bi
                            
                            	1+1 Bidirectional Protection
                            	**type**\:  bool
                            
                            .. attribute:: one_plus_one_uni
                            
                            	1+1 Unidirectional Protection
                            	**type**\:  bool
                            
                            .. attribute:: one_to_n_protection_et
                            
                            	1\:N Protection with Extra\-Traffic
                            	**type**\:  bool
                            
                            .. attribute:: rerouting
                            
                            	Full Rerouting
                            	**type**\:  bool
                            
                            .. attribute:: rerouting_no_et
                            
                            	Rerouting Without Extra\-Traffic
                            	**type**\:  bool
                            
                            .. attribute:: s2l_notification
                            
                            	 S2L Protection Notification Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_operational
                            
                            	 S2L Protection Operational Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_protecting
                            
                            	 S2L Protection Protecting Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_secondary
                            
                            	 S2L Protection Secondary Bit
                            	**type**\:  bool
                            
                            .. attribute:: shared
                            
                            	Shared Link Layer Protection
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.Protection, self).__init__()

                                self.yang_name = "protection"
                                self.yang_parent_name = "s2l"

                                self.any = YLeaf(YType.boolean, "any")

                                self.ded1_plus1 = YLeaf(YType.boolean, "ded1-plus1")

                                self.ded1_to1 = YLeaf(YType.boolean, "ded1-to1")

                                self.enhanced = YLeaf(YType.boolean, "enhanced")

                                self.extra_traffic = YLeaf(YType.boolean, "extra-traffic")

                                self.link_unprotected = YLeaf(YType.boolean, "link-unprotected")

                                self.lsp_unprotected = YLeaf(YType.boolean, "lsp-unprotected")

                                self.one_plus_one_bi = YLeaf(YType.boolean, "one-plus-one-bi")

                                self.one_plus_one_uni = YLeaf(YType.boolean, "one-plus-one-uni")

                                self.one_to_n_protection_et = YLeaf(YType.boolean, "one-to-n-protection-et")

                                self.rerouting = YLeaf(YType.boolean, "rerouting")

                                self.rerouting_no_et = YLeaf(YType.boolean, "rerouting-no-et")

                                self.s2l_notification = YLeaf(YType.boolean, "s2l-notification")

                                self.s2l_operational = YLeaf(YType.boolean, "s2l-operational")

                                self.s2l_protecting = YLeaf(YType.boolean, "s2l-protecting")

                                self.s2l_secondary = YLeaf(YType.boolean, "s2l-secondary")

                                self.shared = YLeaf(YType.boolean, "shared")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("any",
                                                "ded1_plus1",
                                                "ded1_to1",
                                                "enhanced",
                                                "extra_traffic",
                                                "link_unprotected",
                                                "lsp_unprotected",
                                                "one_plus_one_bi",
                                                "one_plus_one_uni",
                                                "one_to_n_protection_et",
                                                "rerouting",
                                                "rerouting_no_et",
                                                "s2l_notification",
                                                "s2l_operational",
                                                "s2l_protecting",
                                                "s2l_secondary",
                                                "shared") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.Protection, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.Protection, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.any.is_set or
                                    self.ded1_plus1.is_set or
                                    self.ded1_to1.is_set or
                                    self.enhanced.is_set or
                                    self.extra_traffic.is_set or
                                    self.link_unprotected.is_set or
                                    self.lsp_unprotected.is_set or
                                    self.one_plus_one_bi.is_set or
                                    self.one_plus_one_uni.is_set or
                                    self.one_to_n_protection_et.is_set or
                                    self.rerouting.is_set or
                                    self.rerouting_no_et.is_set or
                                    self.s2l_notification.is_set or
                                    self.s2l_operational.is_set or
                                    self.s2l_protecting.is_set or
                                    self.s2l_secondary.is_set or
                                    self.shared.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.any.yfilter != YFilter.not_set or
                                    self.ded1_plus1.yfilter != YFilter.not_set or
                                    self.ded1_to1.yfilter != YFilter.not_set or
                                    self.enhanced.yfilter != YFilter.not_set or
                                    self.extra_traffic.yfilter != YFilter.not_set or
                                    self.link_unprotected.yfilter != YFilter.not_set or
                                    self.lsp_unprotected.yfilter != YFilter.not_set or
                                    self.one_plus_one_bi.yfilter != YFilter.not_set or
                                    self.one_plus_one_uni.yfilter != YFilter.not_set or
                                    self.one_to_n_protection_et.yfilter != YFilter.not_set or
                                    self.rerouting.yfilter != YFilter.not_set or
                                    self.rerouting_no_et.yfilter != YFilter.not_set or
                                    self.s2l_notification.yfilter != YFilter.not_set or
                                    self.s2l_operational.yfilter != YFilter.not_set or
                                    self.s2l_protecting.yfilter != YFilter.not_set or
                                    self.s2l_secondary.yfilter != YFilter.not_set or
                                    self.shared.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "protection" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.any.is_set or self.any.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.any.get_name_leafdata())
                                if (self.ded1_plus1.is_set or self.ded1_plus1.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ded1_plus1.get_name_leafdata())
                                if (self.ded1_to1.is_set or self.ded1_to1.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ded1_to1.get_name_leafdata())
                                if (self.enhanced.is_set or self.enhanced.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.enhanced.get_name_leafdata())
                                if (self.extra_traffic.is_set or self.extra_traffic.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.extra_traffic.get_name_leafdata())
                                if (self.link_unprotected.is_set or self.link_unprotected.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.link_unprotected.get_name_leafdata())
                                if (self.lsp_unprotected.is_set or self.lsp_unprotected.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_unprotected.get_name_leafdata())
                                if (self.one_plus_one_bi.is_set or self.one_plus_one_bi.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_plus_one_bi.get_name_leafdata())
                                if (self.one_plus_one_uni.is_set or self.one_plus_one_uni.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_plus_one_uni.get_name_leafdata())
                                if (self.one_to_n_protection_et.is_set or self.one_to_n_protection_et.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_to_n_protection_et.get_name_leafdata())
                                if (self.rerouting.is_set or self.rerouting.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rerouting.get_name_leafdata())
                                if (self.rerouting_no_et.is_set or self.rerouting_no_et.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rerouting_no_et.get_name_leafdata())
                                if (self.s2l_notification.is_set or self.s2l_notification.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_notification.get_name_leafdata())
                                if (self.s2l_operational.is_set or self.s2l_operational.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_operational.get_name_leafdata())
                                if (self.s2l_protecting.is_set or self.s2l_protecting.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_protecting.get_name_leafdata())
                                if (self.s2l_secondary.is_set or self.s2l_secondary.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_secondary.get_name_leafdata())
                                if (self.shared.is_set or self.shared.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.shared.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "any" or name == "ded1-plus1" or name == "ded1-to1" or name == "enhanced" or name == "extra-traffic" or name == "link-unprotected" or name == "lsp-unprotected" or name == "one-plus-one-bi" or name == "one-plus-one-uni" or name == "one-to-n-protection-et" or name == "rerouting" or name == "rerouting-no-et" or name == "s2l-notification" or name == "s2l-operational" or name == "s2l-protecting" or name == "s2l-secondary" or name == "shared"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "any"):
                                    self.any = value
                                    self.any.value_namespace = name_space
                                    self.any.value_namespace_prefix = name_space_prefix
                                if(value_path == "ded1-plus1"):
                                    self.ded1_plus1 = value
                                    self.ded1_plus1.value_namespace = name_space
                                    self.ded1_plus1.value_namespace_prefix = name_space_prefix
                                if(value_path == "ded1-to1"):
                                    self.ded1_to1 = value
                                    self.ded1_to1.value_namespace = name_space
                                    self.ded1_to1.value_namespace_prefix = name_space_prefix
                                if(value_path == "enhanced"):
                                    self.enhanced = value
                                    self.enhanced.value_namespace = name_space
                                    self.enhanced.value_namespace_prefix = name_space_prefix
                                if(value_path == "extra-traffic"):
                                    self.extra_traffic = value
                                    self.extra_traffic.value_namespace = name_space
                                    self.extra_traffic.value_namespace_prefix = name_space_prefix
                                if(value_path == "link-unprotected"):
                                    self.link_unprotected = value
                                    self.link_unprotected.value_namespace = name_space
                                    self.link_unprotected.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-unprotected"):
                                    self.lsp_unprotected = value
                                    self.lsp_unprotected.value_namespace = name_space
                                    self.lsp_unprotected.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-plus-one-bi"):
                                    self.one_plus_one_bi = value
                                    self.one_plus_one_bi.value_namespace = name_space
                                    self.one_plus_one_bi.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-plus-one-uni"):
                                    self.one_plus_one_uni = value
                                    self.one_plus_one_uni.value_namespace = name_space
                                    self.one_plus_one_uni.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-to-n-protection-et"):
                                    self.one_to_n_protection_et = value
                                    self.one_to_n_protection_et.value_namespace = name_space
                                    self.one_to_n_protection_et.value_namespace_prefix = name_space_prefix
                                if(value_path == "rerouting"):
                                    self.rerouting = value
                                    self.rerouting.value_namespace = name_space
                                    self.rerouting.value_namespace_prefix = name_space_prefix
                                if(value_path == "rerouting-no-et"):
                                    self.rerouting_no_et = value
                                    self.rerouting_no_et.value_namespace = name_space
                                    self.rerouting_no_et.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-notification"):
                                    self.s2l_notification = value
                                    self.s2l_notification.value_namespace = name_space
                                    self.s2l_notification.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-operational"):
                                    self.s2l_operational = value
                                    self.s2l_operational.value_namespace = name_space
                                    self.s2l_operational.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-protecting"):
                                    self.s2l_protecting = value
                                    self.s2l_protecting.value_namespace = name_space
                                    self.s2l_protecting.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-secondary"):
                                    self.s2l_secondary = value
                                    self.s2l_secondary.value_namespace = name_space
                                    self.s2l_secondary.value_namespace_prefix = name_space_prefix
                                if(value_path == "shared"):
                                    self.shared = value
                                    self.shared.value_namespace = name_space
                                    self.shared.value_namespace_prefix = name_space_prefix


                        class ReverseLspFec(Entity):
                            """
                            Reverse Associated Bidir LSP FEC
                            
                            .. attribute:: fec_destination_info
                            
                            	Destination or P2MP ID
                            	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ReverseLspFec.FecDestinationInfo>`
                            
                            .. attribute:: fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: fec_lsp_id
                            
                            	LSP ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: fec_source
                            
                            	Tunnel source address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ReverseLspFec, self).__init__()

                                self.yang_name = "reverse-lsp-fec"
                                self.yang_parent_name = "s2l"

                                self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                self.fec_source = YLeaf(YType.str, "fec-source")

                                self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ReverseLspFec.FecDestinationInfo()
                                self.fec_destination_info.parent = self
                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                self._children_yang_names.add("fec-destination-info")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fec_extended_tunnel_id",
                                                "fec_lsp_id",
                                                "fec_source",
                                                "fec_tunnel_id",
                                                "fec_vrf") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ReverseLspFec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ReverseLspFec, self).__setattr__(name, value)


                            class FecDestinationInfo(Entity):
                                """
                                Destination or P2MP ID
                                
                                .. attribute:: fec_ctype
                                
                                	FEC CType
                                	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                .. attribute:: fec_destination_p2mp_id
                                
                                	P2MP ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: p2p_lsp_destination
                                
                                	P2P LSP destination
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__init__()

                                    self.yang_name = "fec-destination-info"
                                    self.yang_parent_name = "reverse-lsp-fec"

                                    self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                    self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                    self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("fec_ctype",
                                                    "fec_destination_p2mp_id",
                                                    "p2p_lsp_destination") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.fec_ctype.is_set or
                                        self.fec_destination_p2mp_id.is_set or
                                        self.p2p_lsp_destination.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.fec_ctype.yfilter != YFilter.not_set or
                                        self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                        self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "fec-destination-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                    if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                    if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "fec-ctype"):
                                        self.fec_ctype = value
                                        self.fec_ctype.value_namespace = name_space
                                        self.fec_ctype.value_namespace_prefix = name_space_prefix
                                    if(value_path == "fec-destination-p2mp-id"):
                                        self.fec_destination_p2mp_id = value
                                        self.fec_destination_p2mp_id.value_namespace = name_space
                                        self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "p2p-lsp-destination"):
                                        self.p2p_lsp_destination = value
                                        self.p2p_lsp_destination.value_namespace = name_space
                                        self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.fec_extended_tunnel_id.is_set or
                                    self.fec_lsp_id.is_set or
                                    self.fec_source.is_set or
                                    self.fec_tunnel_id.is_set or
                                    self.fec_vrf.is_set or
                                    (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                    self.fec_lsp_id.yfilter != YFilter.not_set or
                                    self.fec_source.yfilter != YFilter.not_set or
                                    self.fec_tunnel_id.yfilter != YFilter.not_set or
                                    self.fec_vrf.yfilter != YFilter.not_set or
                                    (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-lsp-fec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_source.get_name_leafdata())
                                if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "fec-destination-info"):
                                    if (self.fec_destination_info is None):
                                        self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ReverseLspFec.FecDestinationInfo()
                                        self.fec_destination_info.parent = self
                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                    return self.fec_destination_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fec-extended-tunnel-id"):
                                    self.fec_extended_tunnel_id = value
                                    self.fec_extended_tunnel_id.value_namespace = name_space
                                    self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-lsp-id"):
                                    self.fec_lsp_id = value
                                    self.fec_lsp_id.value_namespace = name_space
                                    self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-source"):
                                    self.fec_source = value
                                    self.fec_source.value_namespace = name_space
                                    self.fec_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-tunnel-id"):
                                    self.fec_tunnel_id = value
                                    self.fec_tunnel_id.value_namespace = name_space
                                    self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-vrf"):
                                    self.fec_vrf = value
                                    self.fec_vrf.value_namespace = name_space
                                    self.fec_vrf.value_namespace_prefix = name_space_prefix


                        class ReverseTspec(Entity):
                            """
                            The Reverse T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ReverseTspec, self).__init__()

                                self.yang_name = "reverse-tspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ReverseTspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ReverseTspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class FlexInfo(Entity):
                            """
                            FlexLSP S2L Information
                            
                            .. attribute:: bfd_created
                            
                            	GAL BFD Session Created
                            	**type**\:  bool
                            
                            .. attribute:: bfd_egress_label
                            
                            	BFD Egress Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: bfd_int_label
                            
                            	BFD Internal Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: bfd_next_hop
                            
                            	BFD Next Hop
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: bfd_out_ifh
                            
                            	BFD Out Interface Handle
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: bfd_tun_ifh
                            
                            	BFD Tunnel Interface Handle
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: bfd_up
                            
                            	GAL BFD Session Up
                            	**type**\:  bool
                            
                            .. attribute:: entry_exists
                            
                            	FlexLSP Entry Exists
                            	**type**\:  bool
                            
                            .. attribute:: fault_ais
                            
                            	Fault AIS
                            	**type**\:  bool
                            
                            .. attribute:: fault_ldi
                            
                            	Fault LDI
                            	**type**\:  bool
                            
                            .. attribute:: fault_ldi_lockout
                            
                            	Fault LDI Lockout
                            	**type**\:  bool
                            
                            .. attribute:: fault_lkr
                            
                            	Fault LKR
                            	**type**\:  bool
                            
                            .. attribute:: fault_time
                            
                            	Fault Time
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: flex_fec
                            
                            	FEC for the FlexLSP Entry
                            	**type**\:   :py:class:`FlexFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.FlexInfo.FlexFec>`
                            
                            .. attribute:: in_label
                            
                            	In Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: oam_created
                            
                            	OAM Entry Created
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.FlexInfo, self).__init__()

                                self.yang_name = "flex-info"
                                self.yang_parent_name = "s2l"

                                self.bfd_created = YLeaf(YType.boolean, "bfd-created")

                                self.bfd_egress_label = YLeaf(YType.uint32, "bfd-egress-label")

                                self.bfd_int_label = YLeaf(YType.uint32, "bfd-int-label")

                                self.bfd_next_hop = YLeaf(YType.str, "bfd-next-hop")

                                self.bfd_out_ifh = YLeaf(YType.str, "bfd-out-ifh")

                                self.bfd_tun_ifh = YLeaf(YType.str, "bfd-tun-ifh")

                                self.bfd_up = YLeaf(YType.boolean, "bfd-up")

                                self.entry_exists = YLeaf(YType.boolean, "entry-exists")

                                self.fault_ais = YLeaf(YType.boolean, "fault-ais")

                                self.fault_ldi = YLeaf(YType.boolean, "fault-ldi")

                                self.fault_ldi_lockout = YLeaf(YType.boolean, "fault-ldi-lockout")

                                self.fault_lkr = YLeaf(YType.boolean, "fault-lkr")

                                self.fault_time = YLeaf(YType.uint32, "fault-time")

                                self.in_label = YLeaf(YType.uint32, "in-label")

                                self.oam_created = YLeaf(YType.boolean, "oam-created")

                                self.flex_fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.FlexInfo.FlexFec()
                                self.flex_fec.parent = self
                                self._children_name_map["flex_fec"] = "flex-fec"
                                self._children_yang_names.add("flex-fec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("bfd_created",
                                                "bfd_egress_label",
                                                "bfd_int_label",
                                                "bfd_next_hop",
                                                "bfd_out_ifh",
                                                "bfd_tun_ifh",
                                                "bfd_up",
                                                "entry_exists",
                                                "fault_ais",
                                                "fault_ldi",
                                                "fault_ldi_lockout",
                                                "fault_lkr",
                                                "fault_time",
                                                "in_label",
                                                "oam_created") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.FlexInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.FlexInfo, self).__setattr__(name, value)


                            class FlexFec(Entity):
                                """
                                FEC for the FlexLSP Entry
                                
                                .. attribute:: s2l_fec_ctype
                                
                                	Session identifier (ctype)
                                	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                .. attribute:: s2l_fec_dest
                                
                                	sub\-LSP destination address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_extended_tunnel_id
                                
                                	Extended tunnel ID
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_lsp_id
                                
                                	LSP ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_p2mp_id
                                
                                	P2MP ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: s2l_fec_source
                                
                                	LSP source address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_subgroup_id
                                
                                	sub\-LSP subgroup ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_subgroup_originator
                                
                                	Subgroup Originator
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_tunnel_id
                                
                                	Tunnel ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_vrf
                                
                                	VRF; currently only for GMPLS tunnels
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.FlexInfo.FlexFec, self).__init__()

                                    self.yang_name = "flex-fec"
                                    self.yang_parent_name = "flex-info"

                                    self.s2l_fec_ctype = YLeaf(YType.enumeration, "s2l-fec-ctype")

                                    self.s2l_fec_dest = YLeaf(YType.str, "s2l-fec-dest")

                                    self.s2l_fec_extended_tunnel_id = YLeaf(YType.str, "s2l-fec-extended-tunnel-id")

                                    self.s2l_fec_lsp_id = YLeaf(YType.uint16, "s2l-fec-lsp-id")

                                    self.s2l_fec_p2mp_id = YLeaf(YType.uint32, "s2l-fec-p2mp-id")

                                    self.s2l_fec_source = YLeaf(YType.str, "s2l-fec-source")

                                    self.s2l_fec_subgroup_id = YLeaf(YType.uint16, "s2l-fec-subgroup-id")

                                    self.s2l_fec_subgroup_originator = YLeaf(YType.str, "s2l-fec-subgroup-originator")

                                    self.s2l_fec_tunnel_id = YLeaf(YType.uint16, "s2l-fec-tunnel-id")

                                    self.s2l_fec_vrf = YLeaf(YType.str, "s2l-fec-vrf")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("s2l_fec_ctype",
                                                    "s2l_fec_dest",
                                                    "s2l_fec_extended_tunnel_id",
                                                    "s2l_fec_lsp_id",
                                                    "s2l_fec_p2mp_id",
                                                    "s2l_fec_source",
                                                    "s2l_fec_subgroup_id",
                                                    "s2l_fec_subgroup_originator",
                                                    "s2l_fec_tunnel_id",
                                                    "s2l_fec_vrf") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.FlexInfo.FlexFec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.FlexInfo.FlexFec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.s2l_fec_ctype.is_set or
                                        self.s2l_fec_dest.is_set or
                                        self.s2l_fec_extended_tunnel_id.is_set or
                                        self.s2l_fec_lsp_id.is_set or
                                        self.s2l_fec_p2mp_id.is_set or
                                        self.s2l_fec_source.is_set or
                                        self.s2l_fec_subgroup_id.is_set or
                                        self.s2l_fec_subgroup_originator.is_set or
                                        self.s2l_fec_tunnel_id.is_set or
                                        self.s2l_fec_vrf.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.s2l_fec_ctype.yfilter != YFilter.not_set or
                                        self.s2l_fec_dest.yfilter != YFilter.not_set or
                                        self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_lsp_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_p2mp_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_source.yfilter != YFilter.not_set or
                                        self.s2l_fec_subgroup_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set or
                                        self.s2l_fec_tunnel_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_vrf.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "flex-fec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.s2l_fec_ctype.is_set or self.s2l_fec_ctype.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_ctype.get_name_leafdata())
                                    if (self.s2l_fec_dest.is_set or self.s2l_fec_dest.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_dest.get_name_leafdata())
                                    if (self.s2l_fec_extended_tunnel_id.is_set or self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_extended_tunnel_id.get_name_leafdata())
                                    if (self.s2l_fec_lsp_id.is_set or self.s2l_fec_lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_lsp_id.get_name_leafdata())
                                    if (self.s2l_fec_p2mp_id.is_set or self.s2l_fec_p2mp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_p2mp_id.get_name_leafdata())
                                    if (self.s2l_fec_source.is_set or self.s2l_fec_source.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_source.get_name_leafdata())
                                    if (self.s2l_fec_subgroup_id.is_set or self.s2l_fec_subgroup_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_subgroup_id.get_name_leafdata())
                                    if (self.s2l_fec_subgroup_originator.is_set or self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_subgroup_originator.get_name_leafdata())
                                    if (self.s2l_fec_tunnel_id.is_set or self.s2l_fec_tunnel_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_tunnel_id.get_name_leafdata())
                                    if (self.s2l_fec_vrf.is_set or self.s2l_fec_vrf.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_vrf.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "s2l-fec-ctype" or name == "s2l-fec-dest" or name == "s2l-fec-extended-tunnel-id" or name == "s2l-fec-lsp-id" or name == "s2l-fec-p2mp-id" or name == "s2l-fec-source" or name == "s2l-fec-subgroup-id" or name == "s2l-fec-subgroup-originator" or name == "s2l-fec-tunnel-id" or name == "s2l-fec-vrf"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "s2l-fec-ctype"):
                                        self.s2l_fec_ctype = value
                                        self.s2l_fec_ctype.value_namespace = name_space
                                        self.s2l_fec_ctype.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-dest"):
                                        self.s2l_fec_dest = value
                                        self.s2l_fec_dest.value_namespace = name_space
                                        self.s2l_fec_dest.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-extended-tunnel-id"):
                                        self.s2l_fec_extended_tunnel_id = value
                                        self.s2l_fec_extended_tunnel_id.value_namespace = name_space
                                        self.s2l_fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-lsp-id"):
                                        self.s2l_fec_lsp_id = value
                                        self.s2l_fec_lsp_id.value_namespace = name_space
                                        self.s2l_fec_lsp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-p2mp-id"):
                                        self.s2l_fec_p2mp_id = value
                                        self.s2l_fec_p2mp_id.value_namespace = name_space
                                        self.s2l_fec_p2mp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-source"):
                                        self.s2l_fec_source = value
                                        self.s2l_fec_source.value_namespace = name_space
                                        self.s2l_fec_source.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-subgroup-id"):
                                        self.s2l_fec_subgroup_id = value
                                        self.s2l_fec_subgroup_id.value_namespace = name_space
                                        self.s2l_fec_subgroup_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-subgroup-originator"):
                                        self.s2l_fec_subgroup_originator = value
                                        self.s2l_fec_subgroup_originator.value_namespace = name_space
                                        self.s2l_fec_subgroup_originator.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-tunnel-id"):
                                        self.s2l_fec_tunnel_id = value
                                        self.s2l_fec_tunnel_id.value_namespace = name_space
                                        self.s2l_fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-vrf"):
                                        self.s2l_fec_vrf = value
                                        self.s2l_fec_vrf.value_namespace = name_space
                                        self.s2l_fec_vrf.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.bfd_created.is_set or
                                    self.bfd_egress_label.is_set or
                                    self.bfd_int_label.is_set or
                                    self.bfd_next_hop.is_set or
                                    self.bfd_out_ifh.is_set or
                                    self.bfd_tun_ifh.is_set or
                                    self.bfd_up.is_set or
                                    self.entry_exists.is_set or
                                    self.fault_ais.is_set or
                                    self.fault_ldi.is_set or
                                    self.fault_ldi_lockout.is_set or
                                    self.fault_lkr.is_set or
                                    self.fault_time.is_set or
                                    self.in_label.is_set or
                                    self.oam_created.is_set or
                                    (self.flex_fec is not None and self.flex_fec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.bfd_created.yfilter != YFilter.not_set or
                                    self.bfd_egress_label.yfilter != YFilter.not_set or
                                    self.bfd_int_label.yfilter != YFilter.not_set or
                                    self.bfd_next_hop.yfilter != YFilter.not_set or
                                    self.bfd_out_ifh.yfilter != YFilter.not_set or
                                    self.bfd_tun_ifh.yfilter != YFilter.not_set or
                                    self.bfd_up.yfilter != YFilter.not_set or
                                    self.entry_exists.yfilter != YFilter.not_set or
                                    self.fault_ais.yfilter != YFilter.not_set or
                                    self.fault_ldi.yfilter != YFilter.not_set or
                                    self.fault_ldi_lockout.yfilter != YFilter.not_set or
                                    self.fault_lkr.yfilter != YFilter.not_set or
                                    self.fault_time.yfilter != YFilter.not_set or
                                    self.in_label.yfilter != YFilter.not_set or
                                    self.oam_created.yfilter != YFilter.not_set or
                                    (self.flex_fec is not None and self.flex_fec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "flex-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.bfd_created.is_set or self.bfd_created.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_created.get_name_leafdata())
                                if (self.bfd_egress_label.is_set or self.bfd_egress_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_egress_label.get_name_leafdata())
                                if (self.bfd_int_label.is_set or self.bfd_int_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_int_label.get_name_leafdata())
                                if (self.bfd_next_hop.is_set or self.bfd_next_hop.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_next_hop.get_name_leafdata())
                                if (self.bfd_out_ifh.is_set or self.bfd_out_ifh.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_out_ifh.get_name_leafdata())
                                if (self.bfd_tun_ifh.is_set or self.bfd_tun_ifh.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_tun_ifh.get_name_leafdata())
                                if (self.bfd_up.is_set or self.bfd_up.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_up.get_name_leafdata())
                                if (self.entry_exists.is_set or self.entry_exists.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry_exists.get_name_leafdata())
                                if (self.fault_ais.is_set or self.fault_ais.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ais.get_name_leafdata())
                                if (self.fault_ldi.is_set or self.fault_ldi.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ldi.get_name_leafdata())
                                if (self.fault_ldi_lockout.is_set or self.fault_ldi_lockout.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ldi_lockout.get_name_leafdata())
                                if (self.fault_lkr.is_set or self.fault_lkr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_lkr.get_name_leafdata())
                                if (self.fault_time.is_set or self.fault_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_time.get_name_leafdata())
                                if (self.in_label.is_set or self.in_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.in_label.get_name_leafdata())
                                if (self.oam_created.is_set or self.oam_created.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.oam_created.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "flex-fec"):
                                    if (self.flex_fec is None):
                                        self.flex_fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.FlexInfo.FlexFec()
                                        self.flex_fec.parent = self
                                        self._children_name_map["flex_fec"] = "flex-fec"
                                    return self.flex_fec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "flex-fec" or name == "bfd-created" or name == "bfd-egress-label" or name == "bfd-int-label" or name == "bfd-next-hop" or name == "bfd-out-ifh" or name == "bfd-tun-ifh" or name == "bfd-up" or name == "entry-exists" or name == "fault-ais" or name == "fault-ldi" or name == "fault-ldi-lockout" or name == "fault-lkr" or name == "fault-time" or name == "in-label" or name == "oam-created"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "bfd-created"):
                                    self.bfd_created = value
                                    self.bfd_created.value_namespace = name_space
                                    self.bfd_created.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-egress-label"):
                                    self.bfd_egress_label = value
                                    self.bfd_egress_label.value_namespace = name_space
                                    self.bfd_egress_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-int-label"):
                                    self.bfd_int_label = value
                                    self.bfd_int_label.value_namespace = name_space
                                    self.bfd_int_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-next-hop"):
                                    self.bfd_next_hop = value
                                    self.bfd_next_hop.value_namespace = name_space
                                    self.bfd_next_hop.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-out-ifh"):
                                    self.bfd_out_ifh = value
                                    self.bfd_out_ifh.value_namespace = name_space
                                    self.bfd_out_ifh.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-tun-ifh"):
                                    self.bfd_tun_ifh = value
                                    self.bfd_tun_ifh.value_namespace = name_space
                                    self.bfd_tun_ifh.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-up"):
                                    self.bfd_up = value
                                    self.bfd_up.value_namespace = name_space
                                    self.bfd_up.value_namespace_prefix = name_space_prefix
                                if(value_path == "entry-exists"):
                                    self.entry_exists = value
                                    self.entry_exists.value_namespace = name_space
                                    self.entry_exists.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ais"):
                                    self.fault_ais = value
                                    self.fault_ais.value_namespace = name_space
                                    self.fault_ais.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ldi"):
                                    self.fault_ldi = value
                                    self.fault_ldi.value_namespace = name_space
                                    self.fault_ldi.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ldi-lockout"):
                                    self.fault_ldi_lockout = value
                                    self.fault_ldi_lockout.value_namespace = name_space
                                    self.fault_ldi_lockout.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-lkr"):
                                    self.fault_lkr = value
                                    self.fault_lkr.value_namespace = name_space
                                    self.fault_lkr.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-time"):
                                    self.fault_time = value
                                    self.fault_time.value_namespace = name_space
                                    self.fault_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "in-label"):
                                    self.in_label = value
                                    self.in_label.value_namespace = name_space
                                    self.in_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "oam-created"):
                                    self.oam_created = value
                                    self.oam_created.value_namespace = name_space
                                    self.oam_created.value_namespace_prefix = name_space_prefix


                        class LspWrapInfo(Entity):
                            """
                            Lsp Wrap  Related information
                            
                            .. attribute:: lsp_wrap_protection_enable
                            
                            	LSP Wrap protection enabled
                            	**type**\:  bool
                            
                            .. attribute:: lsp_wrap_protection_label
                            
                            	LSP Wrap Merge Point Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: lsp_wrap_protection_state
                            
                            	LSP wrap protection state
                            	**type**\:   :py:class:`MplsTeLspWrapState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspWrapState>`
                            
                            .. attribute:: reverse_egress_interface
                            
                            	Reverse Egress Interface
                            	**type**\:  str
                            
                            .. attribute:: reverse_lsp_label
                            
                            	Reverse LSP label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.LspWrapInfo, self).__init__()

                                self.yang_name = "lsp-wrap-info"
                                self.yang_parent_name = "s2l"

                                self.lsp_wrap_protection_enable = YLeaf(YType.boolean, "lsp-wrap-protection-enable")

                                self.lsp_wrap_protection_label = YLeaf(YType.uint32, "lsp-wrap-protection-label")

                                self.lsp_wrap_protection_state = YLeaf(YType.enumeration, "lsp-wrap-protection-state")

                                self.reverse_egress_interface = YLeaf(YType.str, "reverse-egress-interface")

                                self.reverse_lsp_label = YLeaf(YType.uint32, "reverse-lsp-label")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("lsp_wrap_protection_enable",
                                                "lsp_wrap_protection_label",
                                                "lsp_wrap_protection_state",
                                                "reverse_egress_interface",
                                                "reverse_lsp_label") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.LspWrapInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.LspWrapInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.lsp_wrap_protection_enable.is_set or
                                    self.lsp_wrap_protection_label.is_set or
                                    self.lsp_wrap_protection_state.is_set or
                                    self.reverse_egress_interface.is_set or
                                    self.reverse_lsp_label.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_enable.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_label.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_state.yfilter != YFilter.not_set or
                                    self.reverse_egress_interface.yfilter != YFilter.not_set or
                                    self.reverse_lsp_label.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "lsp-wrap-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.lsp_wrap_protection_enable.is_set or self.lsp_wrap_protection_enable.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_enable.get_name_leafdata())
                                if (self.lsp_wrap_protection_label.is_set or self.lsp_wrap_protection_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_label.get_name_leafdata())
                                if (self.lsp_wrap_protection_state.is_set or self.lsp_wrap_protection_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_state.get_name_leafdata())
                                if (self.reverse_egress_interface.is_set or self.reverse_egress_interface.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reverse_egress_interface.get_name_leafdata())
                                if (self.reverse_lsp_label.is_set or self.reverse_lsp_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reverse_lsp_label.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "lsp-wrap-protection-enable" or name == "lsp-wrap-protection-label" or name == "lsp-wrap-protection-state" or name == "reverse-egress-interface" or name == "reverse-lsp-label"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "lsp-wrap-protection-enable"):
                                    self.lsp_wrap_protection_enable = value
                                    self.lsp_wrap_protection_enable.value_namespace = name_space
                                    self.lsp_wrap_protection_enable.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-wrap-protection-label"):
                                    self.lsp_wrap_protection_label = value
                                    self.lsp_wrap_protection_label.value_namespace = name_space
                                    self.lsp_wrap_protection_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-wrap-protection-state"):
                                    self.lsp_wrap_protection_state = value
                                    self.lsp_wrap_protection_state.value_namespace = name_space
                                    self.lsp_wrap_protection_state.value_namespace_prefix = name_space_prefix
                                if(value_path == "reverse-egress-interface"):
                                    self.reverse_egress_interface = value
                                    self.reverse_egress_interface.value_namespace = name_space
                                    self.reverse_egress_interface.value_namespace_prefix = name_space_prefix
                                if(value_path == "reverse-lsp-label"):
                                    self.reverse_lsp_label = value
                                    self.reverse_lsp_label.value_namespace = name_space
                                    self.reverse_lsp_label.value_namespace_prefix = name_space_prefix


                        class DiversityInfo(Entity):
                            """
                            S2L Diversity Information
                            
                            .. attribute:: diversity_type
                            
                            	S2L path diversity type
                            	**type**\:   :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.DiversityInfo, self).__init__()

                                self.yang_name = "diversity-info"
                                self.yang_parent_name = "s2l"

                                self.diversity_type = YLeaf(YType.enumeration, "diversity-type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("diversity_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.DiversityInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.DiversityInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return self.diversity_type.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.diversity_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "diversity-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.diversity_type.is_set or self.diversity_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.diversity_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "diversity-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "diversity-type"):
                                    self.diversity_type = value
                                    self.diversity_type.value_namespace = name_space
                                    self.diversity_type.value_namespace_prefix = name_space_prefix


                        class S2LReverseLspSubObj(Entity):
                            """
                            Reverse LSP Sub Objects
                            
                            .. attribute:: entry
                            
                            	
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.S2LReverseLspSubObj, self).__init__()

                                self.yang_name = "s2l-reverse-lsp-sub-obj"
                                self.yang_parent_name = "s2l"

                                self.entry = YLeaf(YType.uint8, "entry")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("entry") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.S2LReverseLspSubObj, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.S2LReverseLspSubObj, self).__setattr__(name, value)

                            def has_data(self):
                                return self.entry.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.entry.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-reverse-lsp-sub-obj" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "entry"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "entry"):
                                    self.entry = value
                                    self.entry.value_namespace = name_space
                                    self.entry.value_namespace_prefix = name_space_prefix


                        class SharedRiskLinkGroup(Entity):
                            """
                            The S2L's excluded srlg groups
                            
                            .. attribute:: shared_risk_group
                            
                            	SRLG number
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: srlg_name
                            
                            	SRLG name
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.SharedRiskLinkGroup, self).__init__()

                                self.yang_name = "shared-risk-link-group"
                                self.yang_parent_name = "s2l"

                                self.shared_risk_group = YLeaf(YType.uint32, "shared-risk-group")

                                self.srlg_name = YLeaf(YType.str, "srlg-name")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("shared_risk_group",
                                                "srlg_name") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.SharedRiskLinkGroup, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.SharedRiskLinkGroup, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.shared_risk_group.is_set or
                                    self.srlg_name.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.shared_risk_group.yfilter != YFilter.not_set or
                                    self.srlg_name.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "shared-risk-link-group" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.shared_risk_group.is_set or self.shared_risk_group.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.shared_risk_group.get_name_leafdata())
                                if (self.srlg_name.is_set or self.srlg_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.srlg_name.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "shared-risk-group" or name == "srlg-name"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "shared-risk-group"):
                                    self.shared_risk_group = value
                                    self.shared_risk_group.value_namespace = name_space
                                    self.shared_risk_group.value_namespace_prefix = name_space_prefix
                                if(value_path == "srlg-name"):
                                    self.srlg_name = value
                                    self.srlg_name.value_namespace = name_space
                                    self.srlg_name.value_namespace_prefix = name_space_prefix


                        class OutEro(Entity):
                            """
                            Outgoing ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutEro.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutEro.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutEro, self).__init__()

                                self.yang_name = "out-ero"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutEro.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutEro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutEro, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutEro.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "out-ero"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutEro.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutEro.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "out-ero"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutEro.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutEro.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "out-ero" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutEro.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutEro.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class InEro(Entity):
                            """
                            Incoming ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InEro.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InEro.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InEro, self).__init__()

                                self.yang_name = "in-ero"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InEro.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InEro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InEro, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InEro.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "in-ero"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InEro.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InEro.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "in-ero"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InEro.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InEro.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "in-ero" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InEro.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InEro.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class PathRro(Entity):
                            """
                            Path RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:   :py:class:`Ipv4RroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.Ipv4RroSubObject>`
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:   :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.LabelRroSubObject>`
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:   :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:   :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.SrlgRroSubObject>`
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:   :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.UnnumberedRroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro, self).__init__()

                                self.yang_name = "path-rro"
                                self.yang_parent_name = "s2l"

                                self.rro_type = YLeaf(YType.enumeration, "rro-type")

                                self.ipv4rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.Ipv4RroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                self._children_yang_names.add("ipv4rro-sub-object")

                                self.label_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                self._children_yang_names.add("label-rro-sub-object")

                                self.srlg_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._children_yang_names.add("srlg-rro-sub-object")

                                self.unnumbered_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                self._children_yang_names.add("unnumbered-rro-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("rro_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro, self).__setattr__(name, value)


                            class Ipv4RroSubObject(Entity):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.Ipv4RroSubObject.Flags>`
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.Ipv4RroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.rro_address = YLeaf(YType.str, "rro-address")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.Ipv4RroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("rro_address") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.Ipv4RroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.Ipv4RroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.rro_address.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.rro_address.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.rro_address.is_set or self.rro_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rro_address.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.Ipv4RroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "rro-address"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "rro-address"):
                                        self.rro_address = value
                                        self.rro_address.value_namespace = name_space
                                        self.rro_address.value_namespace_prefix = name_space_prefix


                            class LabelRroSubObject(Entity):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.LabelRroSubObject.Flags>`
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\:  bool
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of    :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.is_label_variable_length = YLeaf(YType.boolean, "is-label-variable-length")

                                    self.label = YLeaf(YType.uint32, "label")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                    self.variable_length_label = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_label_variable_length",
                                                    "label") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.LabelRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.LabelRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.is_global_label = YLeaf(YType.boolean, "is-global-label")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_global_label") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.is_global_label.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_global_label.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_global_label.is_set or self.is_global_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_global_label.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-global-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-global-label"):
                                            self.is_global_label = value
                                            self.is_global_label.value_namespace = name_space
                                            self.is_global_label.value_namespace_prefix = name_space_prefix


                                class VariableLengthLabel(Entity):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "variable-length-label" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.variable_length_label:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.is_label_variable_length.is_set or
                                        self.label.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    for c in self.variable_length_label:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_label_variable_length.yfilter != YFilter.not_set or
                                        self.label.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "label-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_label_variable_length.is_set or self.is_label_variable_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_label_variable_length.get_name_leafdata())
                                    if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.LabelRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    if (child_yang_name == "variable-length-label"):
                                        for c in self.variable_length_label:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.variable_length_label.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "variable-length-label" or name == "is-label-variable-length" or name == "label"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-label-variable-length"):
                                        self.is_label_variable_length = value
                                        self.is_label_variable_length.value_namespace = name_space
                                        self.is_label_variable_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label"):
                                        self.label = value
                                        self.label.value_namespace = name_space
                                        self.label.value_namespace_prefix = name_space_prefix


                            class UnnumberedRroSubObject(Entity):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.UnnumberedRroSubObject.Flags>`
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.interface_address = YLeaf(YType.str, "interface-address")

                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_address",
                                                    "interface_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.UnnumberedRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.UnnumberedRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.interface_address.is_set or
                                        self.interface_id.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_address.yfilter != YFilter.not_set or
                                        self.interface_id.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_address.is_set or self.interface_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_address.get_name_leafdata())
                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.UnnumberedRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "interface-address" or name == "interface-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-address"):
                                        self.interface_address = value
                                        self.interface_address.value_namespace = name_space
                                        self.interface_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-id"):
                                        self.interface_id = value
                                        self.interface_id.value_namespace = name_space
                                        self.interface_id.value_namespace_prefix = name_space_prefix


                            class SrlgRroSubObject(Entity):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of    :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.SrlgRroSubObject.SrlGs>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.srl_gs = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.SrlgRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.SrlgRroSubObject, self).__setattr__(name, value)


                                class SrlGs(Entity):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srl-gs" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.srl_gs:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.srl_gs:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "srlg-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "srl-gs"):
                                        for c in self.srl_gs:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.SrlgRroSubObject.SrlGs()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.srl_gs.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "srl-gs"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    self.rro_type.is_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_data()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_data()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_data()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.rro_type.yfilter != YFilter.not_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_operation()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_operation()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_operation()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-rro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.rro_type.is_set or self.rro_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rro_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4rro-sub-object"):
                                    if (self.ipv4rro_sub_object is None):
                                        self.ipv4rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.Ipv4RroSubObject()
                                        self.ipv4rro_sub_object.parent = self
                                        self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                    return self.ipv4rro_sub_object

                                if (child_yang_name == "label-rro-sub-object"):
                                    if (self.label_rro_sub_object is None):
                                        self.label_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.LabelRroSubObject()
                                        self.label_rro_sub_object.parent = self
                                        self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                    return self.label_rro_sub_object

                                if (child_yang_name == "srlg-rro-sub-object"):
                                    if (self.srlg_rro_sub_object is None):
                                        self.srlg_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.SrlgRroSubObject()
                                        self.srlg_rro_sub_object.parent = self
                                        self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                    return self.srlg_rro_sub_object

                                if (child_yang_name == "unnumbered-rro-sub-object"):
                                    if (self.unnumbered_rro_sub_object is None):
                                        self.unnumbered_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro.UnnumberedRroSubObject()
                                        self.unnumbered_rro_sub_object.parent = self
                                        self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                    return self.unnumbered_rro_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4rro-sub-object" or name == "label-rro-sub-object" or name == "srlg-rro-sub-object" or name == "unnumbered-rro-sub-object" or name == "rro-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "rro-type"):
                                    self.rro_type = value
                                    self.rro_type.value_namespace = name_space
                                    self.rro_type.value_namespace_prefix = name_space_prefix


                        class ResvRro(Entity):
                            """
                            Resv RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:   :py:class:`Ipv4RroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.Ipv4RroSubObject>`
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:   :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.LabelRroSubObject>`
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:   :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:   :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.SrlgRroSubObject>`
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:   :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.UnnumberedRroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro, self).__init__()

                                self.yang_name = "resv-rro"
                                self.yang_parent_name = "s2l"

                                self.rro_type = YLeaf(YType.enumeration, "rro-type")

                                self.ipv4rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.Ipv4RroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                self._children_yang_names.add("ipv4rro-sub-object")

                                self.label_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                self._children_yang_names.add("label-rro-sub-object")

                                self.srlg_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._children_yang_names.add("srlg-rro-sub-object")

                                self.unnumbered_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                self._children_yang_names.add("unnumbered-rro-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("rro_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro, self).__setattr__(name, value)


                            class Ipv4RroSubObject(Entity):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.Ipv4RroSubObject.Flags>`
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.Ipv4RroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.rro_address = YLeaf(YType.str, "rro-address")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.Ipv4RroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("rro_address") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.Ipv4RroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.Ipv4RroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.rro_address.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.rro_address.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.rro_address.is_set or self.rro_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rro_address.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.Ipv4RroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "rro-address"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "rro-address"):
                                        self.rro_address = value
                                        self.rro_address.value_namespace = name_space
                                        self.rro_address.value_namespace_prefix = name_space_prefix


                            class LabelRroSubObject(Entity):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.LabelRroSubObject.Flags>`
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\:  bool
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of    :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.is_label_variable_length = YLeaf(YType.boolean, "is-label-variable-length")

                                    self.label = YLeaf(YType.uint32, "label")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                    self.variable_length_label = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_label_variable_length",
                                                    "label") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.LabelRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.LabelRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.is_global_label = YLeaf(YType.boolean, "is-global-label")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_global_label") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.is_global_label.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_global_label.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_global_label.is_set or self.is_global_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_global_label.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-global-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-global-label"):
                                            self.is_global_label = value
                                            self.is_global_label.value_namespace = name_space
                                            self.is_global_label.value_namespace_prefix = name_space_prefix


                                class VariableLengthLabel(Entity):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "variable-length-label" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.variable_length_label:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.is_label_variable_length.is_set or
                                        self.label.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    for c in self.variable_length_label:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_label_variable_length.yfilter != YFilter.not_set or
                                        self.label.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "label-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_label_variable_length.is_set or self.is_label_variable_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_label_variable_length.get_name_leafdata())
                                    if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.LabelRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    if (child_yang_name == "variable-length-label"):
                                        for c in self.variable_length_label:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.variable_length_label.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "variable-length-label" or name == "is-label-variable-length" or name == "label"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-label-variable-length"):
                                        self.is_label_variable_length = value
                                        self.is_label_variable_length.value_namespace = name_space
                                        self.is_label_variable_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label"):
                                        self.label = value
                                        self.label.value_namespace = name_space
                                        self.label.value_namespace_prefix = name_space_prefix


                            class UnnumberedRroSubObject(Entity):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags>`
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.interface_address = YLeaf(YType.str, "interface-address")

                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_address",
                                                    "interface_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.interface_address.is_set or
                                        self.interface_id.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_address.yfilter != YFilter.not_set or
                                        self.interface_id.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_address.is_set or self.interface_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_address.get_name_leafdata())
                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "interface-address" or name == "interface-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-address"):
                                        self.interface_address = value
                                        self.interface_address.value_namespace = name_space
                                        self.interface_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-id"):
                                        self.interface_id = value
                                        self.interface_id.value_namespace = name_space
                                        self.interface_id.value_namespace_prefix = name_space_prefix


                            class SrlgRroSubObject(Entity):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of    :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.srl_gs = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.SrlgRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.SrlgRroSubObject, self).__setattr__(name, value)


                                class SrlGs(Entity):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srl-gs" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.srl_gs:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.srl_gs:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "srlg-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "srl-gs"):
                                        for c in self.srl_gs:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.srl_gs.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "srl-gs"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    self.rro_type.is_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_data()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_data()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_data()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.rro_type.yfilter != YFilter.not_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_operation()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_operation()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_operation()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "resv-rro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.rro_type.is_set or self.rro_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rro_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4rro-sub-object"):
                                    if (self.ipv4rro_sub_object is None):
                                        self.ipv4rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.Ipv4RroSubObject()
                                        self.ipv4rro_sub_object.parent = self
                                        self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                    return self.ipv4rro_sub_object

                                if (child_yang_name == "label-rro-sub-object"):
                                    if (self.label_rro_sub_object is None):
                                        self.label_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.LabelRroSubObject()
                                        self.label_rro_sub_object.parent = self
                                        self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                    return self.label_rro_sub_object

                                if (child_yang_name == "srlg-rro-sub-object"):
                                    if (self.srlg_rro_sub_object is None):
                                        self.srlg_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.SrlgRroSubObject()
                                        self.srlg_rro_sub_object.parent = self
                                        self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                    return self.srlg_rro_sub_object

                                if (child_yang_name == "unnumbered-rro-sub-object"):
                                    if (self.unnumbered_rro_sub_object is None):
                                        self.unnumbered_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro.UnnumberedRroSubObject()
                                        self.unnumbered_rro_sub_object.parent = self
                                        self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                    return self.unnumbered_rro_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4rro-sub-object" or name == "label-rro-sub-object" or name == "srlg-rro-sub-object" or name == "unnumbered-rro-sub-object" or name == "rro-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "rro-type"):
                                    self.rro_type = value
                                    self.rro_type.value_namespace = name_space
                                    self.rro_type.value_namespace_prefix = name_space_prefix


                        class PathAffinityArray(Entity):
                            """
                            Tunnel's Path hops with affinity
                            
                            .. attribute:: hop_address
                            
                            	Hop address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: hop_affinity
                            
                            	Deprecated
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: hop_extended_affinity
                            
                            	Hop affinity
                            	**type**\: list of    :py:class:`HopExtendedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathAffinityArray.HopExtendedAffinity>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathAffinityArray, self).__init__()

                                self.yang_name = "path-affinity-array"
                                self.yang_parent_name = "s2l"

                                self.hop_address = YLeaf(YType.str, "hop-address")

                                self.hop_affinity = YLeaf(YType.uint32, "hop-affinity")

                                self.hop_extended_affinity = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("hop_address",
                                                "hop_affinity") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathAffinityArray, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathAffinityArray, self).__setattr__(name, value)


                            class HopExtendedAffinity(Entity):
                                """
                                Hop affinity
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__init__()

                                    self.yang_name = "hop-extended-affinity"
                                    self.yang_parent_name = "path-affinity-array"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "hop-extended-affinity" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.hop_extended_affinity:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.hop_address.is_set or
                                    self.hop_affinity.is_set)

                            def has_operation(self):
                                for c in self.hop_extended_affinity:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.hop_address.yfilter != YFilter.not_set or
                                    self.hop_affinity.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-affinity-array" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.hop_address.is_set or self.hop_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hop_address.get_name_leafdata())
                                if (self.hop_affinity.is_set or self.hop_affinity.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hop_affinity.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "hop-extended-affinity"):
                                    for c in self.hop_extended_affinity:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathAffinityArray.HopExtendedAffinity()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.hop_extended_affinity.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "hop-extended-affinity" or name == "hop-address" or name == "hop-affinity"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "hop-address"):
                                    self.hop_address = value
                                    self.hop_address.value_namespace = name_space
                                    self.hop_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "hop-affinity"):
                                    self.hop_affinity = value
                                    self.hop_affinity.value_namespace = name_space
                                    self.hop_affinity.value_namespace_prefix = name_space_prefix


                        class ReverseEroIn(Entity):
                            """
                             Reverse Incoming ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ReverseEroIn.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ReverseEroIn.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ReverseEroIn, self).__init__()

                                self.yang_name = "reverse-ero-in"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ReverseEroIn.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ReverseEroIn.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ReverseEroIn, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ReverseEroIn, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-ero-in" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ReverseEroIn.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ReverseEroIn.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class S2LSegmentRoutingPath(Entity):
                            """
                            Segment\-Routing S2L path info
                            
                            .. attribute:: has_entropy_label
                            
                            	Hop has EL specified
                            	**type**\:  bool
                            
                            .. attribute:: has_ip_addresses
                            
                            	Node has IP addresses specified
                            	**type**\:  bool
                            
                            .. attribute:: has_mpls_label
                            
                            	Hop has MPLS label specified
                            	**type**\:  bool
                            
                            .. attribute:: local_addr
                            
                            	Local IP address of adjacency or Node ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: mpls_label_value
                            
                            	The MPLS label value
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: remote_addr
                            
                            	Remote IP address of adjacency
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: sid_type
                            
                            	Type of the SID
                            	**type**\:   :py:class:`TeSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrSid>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.S2LSegmentRoutingPath, self).__init__()

                                self.yang_name = "s2l-segment-routing-path"
                                self.yang_parent_name = "s2l"

                                self.has_entropy_label = YLeaf(YType.boolean, "has-entropy-label")

                                self.has_ip_addresses = YLeaf(YType.boolean, "has-ip-addresses")

                                self.has_mpls_label = YLeaf(YType.boolean, "has-mpls-label")

                                self.local_addr = YLeaf(YType.str, "local-addr")

                                self.mpls_label_value = YLeaf(YType.uint32, "mpls-label-value")

                                self.remote_addr = YLeaf(YType.str, "remote-addr")

                                self.sid_type = YLeaf(YType.enumeration, "sid-type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("has_entropy_label",
                                                "has_ip_addresses",
                                                "has_mpls_label",
                                                "local_addr",
                                                "mpls_label_value",
                                                "remote_addr",
                                                "sid_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.S2LSegmentRoutingPath, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.S2LSegmentRoutingPath, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.has_entropy_label.is_set or
                                    self.has_ip_addresses.is_set or
                                    self.has_mpls_label.is_set or
                                    self.local_addr.is_set or
                                    self.mpls_label_value.is_set or
                                    self.remote_addr.is_set or
                                    self.sid_type.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.has_entropy_label.yfilter != YFilter.not_set or
                                    self.has_ip_addresses.yfilter != YFilter.not_set or
                                    self.has_mpls_label.yfilter != YFilter.not_set or
                                    self.local_addr.yfilter != YFilter.not_set or
                                    self.mpls_label_value.yfilter != YFilter.not_set or
                                    self.remote_addr.yfilter != YFilter.not_set or
                                    self.sid_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-segment-routing-path" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.has_entropy_label.is_set or self.has_entropy_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_entropy_label.get_name_leafdata())
                                if (self.has_ip_addresses.is_set or self.has_ip_addresses.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_ip_addresses.get_name_leafdata())
                                if (self.has_mpls_label.is_set or self.has_mpls_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_mpls_label.get_name_leafdata())
                                if (self.local_addr.is_set or self.local_addr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_addr.get_name_leafdata())
                                if (self.mpls_label_value.is_set or self.mpls_label_value.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mpls_label_value.get_name_leafdata())
                                if (self.remote_addr.is_set or self.remote_addr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.remote_addr.get_name_leafdata())
                                if (self.sid_type.is_set or self.sid_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.sid_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "has-entropy-label" or name == "has-ip-addresses" or name == "has-mpls-label" or name == "local-addr" or name == "mpls-label-value" or name == "remote-addr" or name == "sid-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "has-entropy-label"):
                                    self.has_entropy_label = value
                                    self.has_entropy_label.value_namespace = name_space
                                    self.has_entropy_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-ip-addresses"):
                                    self.has_ip_addresses = value
                                    self.has_ip_addresses.value_namespace = name_space
                                    self.has_ip_addresses.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-mpls-label"):
                                    self.has_mpls_label = value
                                    self.has_mpls_label.value_namespace = name_space
                                    self.has_mpls_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "local-addr"):
                                    self.local_addr = value
                                    self.local_addr.value_namespace = name_space
                                    self.local_addr.value_namespace_prefix = name_space_prefix
                                if(value_path == "mpls-label-value"):
                                    self.mpls_label_value = value
                                    self.mpls_label_value.value_namespace = name_space
                                    self.mpls_label_value.value_namespace_prefix = name_space_prefix
                                if(value_path == "remote-addr"):
                                    self.remote_addr = value
                                    self.remote_addr.value_namespace = name_space
                                    self.remote_addr.value_namespace_prefix = name_space_prefix
                                if(value_path == "sid-type"):
                                    self.sid_type = value
                                    self.sid_type.value_namespace = name_space
                                    self.sid_type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.in_ero:
                                if (c.has_data()):
                                    return True
                            for c in self.out_ero:
                                if (c.has_data()):
                                    return True
                            for c in self.path_affinity_array:
                                if (c.has_data()):
                                    return True
                            for c in self.path_rro:
                                if (c.has_data()):
                                    return True
                            for c in self.resv_rro:
                                if (c.has_data()):
                                    return True
                            for c in self.reverse_ero_in:
                                if (c.has_data()):
                                    return True
                            for c in self.s2l_reverse_lsp_sub_obj:
                                if (c.has_data()):
                                    return True
                            for c in self.s2l_segment_routing_path:
                                if (c.has_data()):
                                    return True
                            for c in self.shared_risk_link_group:
                                if (c.has_data()):
                                    return True
                            return (
                                self.abr_auto_discovered.is_set or
                                self.backup_tunnel_interface.is_set or
                                self.downstream_router_id.is_set or
                                self.egress_interface.is_set or
                                self.egress_interface_brief.is_set or
                                self.egress_interface_state.is_set or
                                self.expanded_ero_affinity_bits.is_set or
                                self.expanded_ero_affinity_mask.is_set or
                                self.expanded_ero_area_id.is_set or
                                self.expanded_ero_metric.is_set or
                                self.expanded_ero_metric_type.is_set or
                                self.frr_out_tunnel_interface.is_set or
                                self.incoming_address.is_set or
                                self.ingress_interface.is_set or
                                self.ingress_interface_brief.is_set or
                                self.ingress_interface_state.is_set or
                                self.is_bandwidth_protect.is_set or
                                self.is_expanded_ero.is_set or
                                self.is_frr_enabled.is_set or
                                self.is_node_protected.is_set or
                                self.is_optical.is_set or
                                self.local_router_id.is_set or
                                self.next_hop_address.is_set or
                                self.node_hop_count.is_set or
                                self.outbound_frr_state.is_set or
                                self.path_reeval_query_mid.is_set or
                                self.path_rro_enabled.is_set or
                                self.path_using_strict_spf.is_set or
                                self.pcalc_area.is_set or
                                self.previous_hop_address.is_set or
                                self.reverse_lsp_connected.is_set or
                                self.reverse_lsp_name.is_set or
                                self.reverse_lsp_present.is_set or
                                self.reverse_weight.is_set or
                                self.role.is_set or
                                self.s2l_local_label.is_set or
                                self.s2l_out_label.is_set or
                                self.s2l_reverse_ero_obj_present.is_set or
                                self.s2l_reverse_tspec_obj_present.is_set or
                                self.signalling_status.is_set or
                                self.time_since_last_preferred_path_exists_send_mid.is_set or
                                self.time_since_last_preferred_tree_exists_send_mid.is_set or
                                self.time_since_last_query_received_mid.is_set or
                                self.upstream_router_id.is_set or
                                self.uptime.is_set or
                                self.weight.is_set or
                                (self.active_path_option is not None and self.active_path_option.has_data()) or
                                (self.association is not None and self.association.has_data()) or
                                (self.diversity_info is not None and self.diversity_info.has_data()) or
                                (self.flex_info is not None and self.flex_info.has_data()) or
                                (self.fspec is not None and self.fspec.has_data()) or
                                (self.generic_fspec is not None and self.generic_fspec.has_data()) or
                                (self.generic_tspec is not None and self.generic_tspec.has_data()) or
                                (self.gmpls_labels is not None and self.gmpls_labels.has_data()) or
                                (self.head_end_bfd_info is not None and self.head_end_bfd_info.has_data()) or
                                (self.in_xro is not None and self.in_xro.has_data()) or
                                (self.incoming_address_generic is not None and self.incoming_address_generic.has_data()) or
                                (self.lsp_wrap_info is not None and self.lsp_wrap_info.has_data()) or
                                (self.next_hop_address_generic is not None and self.next_hop_address_generic.has_data()) or
                                (self.otn_s2l is not None and self.otn_s2l.has_data()) or
                                (self.out_xro is not None and self.out_xro.has_data()) or
                                (self.previous_hop_address_generic is not None and self.previous_hop_address_generic.has_data()) or
                                (self.protection is not None and self.protection.has_data()) or
                                (self.reverse_lsp_fec is not None and self.reverse_lsp_fec.has_data()) or
                                (self.reverse_tspec is not None and self.reverse_tspec.has_data()) or
                                (self.s2l_convergence is not None and self.s2l_convergence.has_data()) or
                                (self.s2l_fec is not None and self.s2l_fec.has_data()) or
                                (self.soft_preemption is not None and self.soft_preemption.has_data()) or
                                (self.srlg_collection is not None and self.srlg_collection.has_data()) or
                                (self.tail_end_bfd_info is not None and self.tail_end_bfd_info.has_data()) or
                                (self.tspec is not None and self.tspec.has_data()))

                        def has_operation(self):
                            for c in self.in_ero:
                                if (c.has_operation()):
                                    return True
                            for c in self.out_ero:
                                if (c.has_operation()):
                                    return True
                            for c in self.path_affinity_array:
                                if (c.has_operation()):
                                    return True
                            for c in self.path_rro:
                                if (c.has_operation()):
                                    return True
                            for c in self.resv_rro:
                                if (c.has_operation()):
                                    return True
                            for c in self.reverse_ero_in:
                                if (c.has_operation()):
                                    return True
                            for c in self.s2l_reverse_lsp_sub_obj:
                                if (c.has_operation()):
                                    return True
                            for c in self.s2l_segment_routing_path:
                                if (c.has_operation()):
                                    return True
                            for c in self.shared_risk_link_group:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.abr_auto_discovered.yfilter != YFilter.not_set or
                                self.backup_tunnel_interface.yfilter != YFilter.not_set or
                                self.downstream_router_id.yfilter != YFilter.not_set or
                                self.egress_interface.yfilter != YFilter.not_set or
                                self.egress_interface_brief.yfilter != YFilter.not_set or
                                self.egress_interface_state.yfilter != YFilter.not_set or
                                self.expanded_ero_affinity_bits.yfilter != YFilter.not_set or
                                self.expanded_ero_affinity_mask.yfilter != YFilter.not_set or
                                self.expanded_ero_area_id.yfilter != YFilter.not_set or
                                self.expanded_ero_metric.yfilter != YFilter.not_set or
                                self.expanded_ero_metric_type.yfilter != YFilter.not_set or
                                self.frr_out_tunnel_interface.yfilter != YFilter.not_set or
                                self.incoming_address.yfilter != YFilter.not_set or
                                self.ingress_interface.yfilter != YFilter.not_set or
                                self.ingress_interface_brief.yfilter != YFilter.not_set or
                                self.ingress_interface_state.yfilter != YFilter.not_set or
                                self.is_bandwidth_protect.yfilter != YFilter.not_set or
                                self.is_expanded_ero.yfilter != YFilter.not_set or
                                self.is_frr_enabled.yfilter != YFilter.not_set or
                                self.is_node_protected.yfilter != YFilter.not_set or
                                self.is_optical.yfilter != YFilter.not_set or
                                self.local_router_id.yfilter != YFilter.not_set or
                                self.next_hop_address.yfilter != YFilter.not_set or
                                self.node_hop_count.yfilter != YFilter.not_set or
                                self.outbound_frr_state.yfilter != YFilter.not_set or
                                self.path_reeval_query_mid.yfilter != YFilter.not_set or
                                self.path_rro_enabled.yfilter != YFilter.not_set or
                                self.path_using_strict_spf.yfilter != YFilter.not_set or
                                self.pcalc_area.yfilter != YFilter.not_set or
                                self.previous_hop_address.yfilter != YFilter.not_set or
                                self.reverse_lsp_connected.yfilter != YFilter.not_set or
                                self.reverse_lsp_name.yfilter != YFilter.not_set or
                                self.reverse_lsp_present.yfilter != YFilter.not_set or
                                self.reverse_weight.yfilter != YFilter.not_set or
                                self.role.yfilter != YFilter.not_set or
                                self.s2l_local_label.yfilter != YFilter.not_set or
                                self.s2l_out_label.yfilter != YFilter.not_set or
                                self.s2l_reverse_ero_obj_present.yfilter != YFilter.not_set or
                                self.s2l_reverse_tspec_obj_present.yfilter != YFilter.not_set or
                                self.signalling_status.yfilter != YFilter.not_set or
                                self.time_since_last_preferred_path_exists_send_mid.yfilter != YFilter.not_set or
                                self.time_since_last_preferred_tree_exists_send_mid.yfilter != YFilter.not_set or
                                self.time_since_last_query_received_mid.yfilter != YFilter.not_set or
                                self.upstream_router_id.yfilter != YFilter.not_set or
                                self.uptime.yfilter != YFilter.not_set or
                                self.weight.yfilter != YFilter.not_set or
                                (self.active_path_option is not None and self.active_path_option.has_operation()) or
                                (self.association is not None and self.association.has_operation()) or
                                (self.diversity_info is not None and self.diversity_info.has_operation()) or
                                (self.flex_info is not None and self.flex_info.has_operation()) or
                                (self.fspec is not None and self.fspec.has_operation()) or
                                (self.generic_fspec is not None and self.generic_fspec.has_operation()) or
                                (self.generic_tspec is not None and self.generic_tspec.has_operation()) or
                                (self.gmpls_labels is not None and self.gmpls_labels.has_operation()) or
                                (self.head_end_bfd_info is not None and self.head_end_bfd_info.has_operation()) or
                                (self.in_xro is not None and self.in_xro.has_operation()) or
                                (self.incoming_address_generic is not None and self.incoming_address_generic.has_operation()) or
                                (self.lsp_wrap_info is not None and self.lsp_wrap_info.has_operation()) or
                                (self.next_hop_address_generic is not None and self.next_hop_address_generic.has_operation()) or
                                (self.otn_s2l is not None and self.otn_s2l.has_operation()) or
                                (self.out_xro is not None and self.out_xro.has_operation()) or
                                (self.previous_hop_address_generic is not None and self.previous_hop_address_generic.has_operation()) or
                                (self.protection is not None and self.protection.has_operation()) or
                                (self.reverse_lsp_fec is not None and self.reverse_lsp_fec.has_operation()) or
                                (self.reverse_tspec is not None and self.reverse_tspec.has_operation()) or
                                (self.s2l_convergence is not None and self.s2l_convergence.has_operation()) or
                                (self.s2l_fec is not None and self.s2l_fec.has_operation()) or
                                (self.soft_preemption is not None and self.soft_preemption.has_operation()) or
                                (self.srlg_collection is not None and self.srlg_collection.has_operation()) or
                                (self.tail_end_bfd_info is not None and self.tail_end_bfd_info.has_operation()) or
                                (self.tspec is not None and self.tspec.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "s2l" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.abr_auto_discovered.is_set or self.abr_auto_discovered.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.abr_auto_discovered.get_name_leafdata())
                            if (self.backup_tunnel_interface.is_set or self.backup_tunnel_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.backup_tunnel_interface.get_name_leafdata())
                            if (self.downstream_router_id.is_set or self.downstream_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.downstream_router_id.get_name_leafdata())
                            if (self.egress_interface.is_set or self.egress_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface.get_name_leafdata())
                            if (self.egress_interface_brief.is_set or self.egress_interface_brief.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface_brief.get_name_leafdata())
                            if (self.egress_interface_state.is_set or self.egress_interface_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface_state.get_name_leafdata())
                            if (self.expanded_ero_affinity_bits.is_set or self.expanded_ero_affinity_bits.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_affinity_bits.get_name_leafdata())
                            if (self.expanded_ero_affinity_mask.is_set or self.expanded_ero_affinity_mask.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_affinity_mask.get_name_leafdata())
                            if (self.expanded_ero_area_id.is_set or self.expanded_ero_area_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_area_id.get_name_leafdata())
                            if (self.expanded_ero_metric.is_set or self.expanded_ero_metric.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_metric.get_name_leafdata())
                            if (self.expanded_ero_metric_type.is_set or self.expanded_ero_metric_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_metric_type.get_name_leafdata())
                            if (self.frr_out_tunnel_interface.is_set or self.frr_out_tunnel_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.frr_out_tunnel_interface.get_name_leafdata())
                            if (self.incoming_address.is_set or self.incoming_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.incoming_address.get_name_leafdata())
                            if (self.ingress_interface.is_set or self.ingress_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface.get_name_leafdata())
                            if (self.ingress_interface_brief.is_set or self.ingress_interface_brief.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface_brief.get_name_leafdata())
                            if (self.ingress_interface_state.is_set or self.ingress_interface_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface_state.get_name_leafdata())
                            if (self.is_bandwidth_protect.is_set or self.is_bandwidth_protect.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_bandwidth_protect.get_name_leafdata())
                            if (self.is_expanded_ero.is_set or self.is_expanded_ero.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_expanded_ero.get_name_leafdata())
                            if (self.is_frr_enabled.is_set or self.is_frr_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_frr_enabled.get_name_leafdata())
                            if (self.is_node_protected.is_set or self.is_node_protected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_node_protected.get_name_leafdata())
                            if (self.is_optical.is_set or self.is_optical.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_optical.get_name_leafdata())
                            if (self.local_router_id.is_set or self.local_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.local_router_id.get_name_leafdata())
                            if (self.next_hop_address.is_set or self.next_hop_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.next_hop_address.get_name_leafdata())
                            if (self.node_hop_count.is_set or self.node_hop_count.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.node_hop_count.get_name_leafdata())
                            if (self.outbound_frr_state.is_set or self.outbound_frr_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.outbound_frr_state.get_name_leafdata())
                            if (self.path_reeval_query_mid.is_set or self.path_reeval_query_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reeval_query_mid.get_name_leafdata())
                            if (self.path_rro_enabled.is_set or self.path_rro_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_rro_enabled.get_name_leafdata())
                            if (self.path_using_strict_spf.is_set or self.path_using_strict_spf.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_using_strict_spf.get_name_leafdata())
                            if (self.pcalc_area.is_set or self.pcalc_area.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.pcalc_area.get_name_leafdata())
                            if (self.previous_hop_address.is_set or self.previous_hop_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.previous_hop_address.get_name_leafdata())
                            if (self.reverse_lsp_connected.is_set or self.reverse_lsp_connected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_connected.get_name_leafdata())
                            if (self.reverse_lsp_name.is_set or self.reverse_lsp_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_name.get_name_leafdata())
                            if (self.reverse_lsp_present.is_set or self.reverse_lsp_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_present.get_name_leafdata())
                            if (self.reverse_weight.is_set or self.reverse_weight.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_weight.get_name_leafdata())
                            if (self.role.is_set or self.role.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.role.get_name_leafdata())
                            if (self.s2l_local_label.is_set or self.s2l_local_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_local_label.get_name_leafdata())
                            if (self.s2l_out_label.is_set or self.s2l_out_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_out_label.get_name_leafdata())
                            if (self.s2l_reverse_ero_obj_present.is_set or self.s2l_reverse_ero_obj_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_reverse_ero_obj_present.get_name_leafdata())
                            if (self.s2l_reverse_tspec_obj_present.is_set or self.s2l_reverse_tspec_obj_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_reverse_tspec_obj_present.get_name_leafdata())
                            if (self.signalling_status.is_set or self.signalling_status.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.signalling_status.get_name_leafdata())
                            if (self.time_since_last_preferred_path_exists_send_mid.is_set or self.time_since_last_preferred_path_exists_send_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_preferred_path_exists_send_mid.get_name_leafdata())
                            if (self.time_since_last_preferred_tree_exists_send_mid.is_set or self.time_since_last_preferred_tree_exists_send_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_preferred_tree_exists_send_mid.get_name_leafdata())
                            if (self.time_since_last_query_received_mid.is_set or self.time_since_last_query_received_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_query_received_mid.get_name_leafdata())
                            if (self.upstream_router_id.is_set or self.upstream_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.upstream_router_id.get_name_leafdata())
                            if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.uptime.get_name_leafdata())
                            if (self.weight.is_set or self.weight.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.weight.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "active-path-option"):
                                if (self.active_path_option is None):
                                    self.active_path_option = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ActivePathOption()
                                    self.active_path_option.parent = self
                                    self._children_name_map["active_path_option"] = "active-path-option"
                                return self.active_path_option

                            if (child_yang_name == "association"):
                                if (self.association is None):
                                    self.association = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.Association()
                                    self.association.parent = self
                                    self._children_name_map["association"] = "association"
                                return self.association

                            if (child_yang_name == "diversity-info"):
                                if (self.diversity_info is None):
                                    self.diversity_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.DiversityInfo()
                                    self.diversity_info.parent = self
                                    self._children_name_map["diversity_info"] = "diversity-info"
                                return self.diversity_info

                            if (child_yang_name == "flex-info"):
                                if (self.flex_info is None):
                                    self.flex_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.FlexInfo()
                                    self.flex_info.parent = self
                                    self._children_name_map["flex_info"] = "flex-info"
                                return self.flex_info

                            if (child_yang_name == "fspec"):
                                if (self.fspec is None):
                                    self.fspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.Fspec()
                                    self.fspec.parent = self
                                    self._children_name_map["fspec"] = "fspec"
                                return self.fspec

                            if (child_yang_name == "generic-fspec"):
                                if (self.generic_fspec is None):
                                    self.generic_fspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GenericFspec()
                                    self.generic_fspec.parent = self
                                    self._children_name_map["generic_fspec"] = "generic-fspec"
                                return self.generic_fspec

                            if (child_yang_name == "generic-tspec"):
                                if (self.generic_tspec is None):
                                    self.generic_tspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GenericTspec()
                                    self.generic_tspec.parent = self
                                    self._children_name_map["generic_tspec"] = "generic-tspec"
                                return self.generic_tspec

                            if (child_yang_name == "gmpls-labels"):
                                if (self.gmpls_labels is None):
                                    self.gmpls_labels = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.GmplsLabels()
                                    self.gmpls_labels.parent = self
                                    self._children_name_map["gmpls_labels"] = "gmpls-labels"
                                return self.gmpls_labels

                            if (child_yang_name == "head-end-bfd-info"):
                                if (self.head_end_bfd_info is None):
                                    self.head_end_bfd_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.HeadEndBfdInfo()
                                    self.head_end_bfd_info.parent = self
                                    self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"
                                return self.head_end_bfd_info

                            if (child_yang_name == "in-ero"):
                                for c in self.in_ero:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InEro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.in_ero.append(c)
                                return c

                            if (child_yang_name == "in-xro"):
                                if (self.in_xro is None):
                                    self.in_xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.InXro()
                                    self.in_xro.parent = self
                                    self._children_name_map["in_xro"] = "in-xro"
                                return self.in_xro

                            if (child_yang_name == "incoming-address-generic"):
                                if (self.incoming_address_generic is None):
                                    self.incoming_address_generic = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.IncomingAddressGeneric()
                                    self.incoming_address_generic.parent = self
                                    self._children_name_map["incoming_address_generic"] = "incoming-address-generic"
                                return self.incoming_address_generic

                            if (child_yang_name == "lsp-wrap-info"):
                                if (self.lsp_wrap_info is None):
                                    self.lsp_wrap_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.LspWrapInfo()
                                    self.lsp_wrap_info.parent = self
                                    self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"
                                return self.lsp_wrap_info

                            if (child_yang_name == "next-hop-address-generic"):
                                if (self.next_hop_address_generic is None):
                                    self.next_hop_address_generic = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.NextHopAddressGeneric()
                                    self.next_hop_address_generic.parent = self
                                    self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"
                                return self.next_hop_address_generic

                            if (child_yang_name == "otn-s2l"):
                                if (self.otn_s2l is None):
                                    self.otn_s2l = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OtnS2L()
                                    self.otn_s2l.parent = self
                                    self._children_name_map["otn_s2l"] = "otn-s2l"
                                return self.otn_s2l

                            if (child_yang_name == "out-ero"):
                                for c in self.out_ero:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutEro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.out_ero.append(c)
                                return c

                            if (child_yang_name == "out-xro"):
                                if (self.out_xro is None):
                                    self.out_xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.OutXro()
                                    self.out_xro.parent = self
                                    self._children_name_map["out_xro"] = "out-xro"
                                return self.out_xro

                            if (child_yang_name == "path-affinity-array"):
                                for c in self.path_affinity_array:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathAffinityArray()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_affinity_array.append(c)
                                return c

                            if (child_yang_name == "path-rro"):
                                for c in self.path_rro:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PathRro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_rro.append(c)
                                return c

                            if (child_yang_name == "previous-hop-address-generic"):
                                if (self.previous_hop_address_generic is None):
                                    self.previous_hop_address_generic = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.PreviousHopAddressGeneric()
                                    self.previous_hop_address_generic.parent = self
                                    self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"
                                return self.previous_hop_address_generic

                            if (child_yang_name == "protection"):
                                if (self.protection is None):
                                    self.protection = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.Protection()
                                    self.protection.parent = self
                                    self._children_name_map["protection"] = "protection"
                                return self.protection

                            if (child_yang_name == "resv-rro"):
                                for c in self.resv_rro:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ResvRro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.resv_rro.append(c)
                                return c

                            if (child_yang_name == "reverse-ero-in"):
                                for c in self.reverse_ero_in:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ReverseEroIn()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.reverse_ero_in.append(c)
                                return c

                            if (child_yang_name == "reverse-lsp-fec"):
                                if (self.reverse_lsp_fec is None):
                                    self.reverse_lsp_fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ReverseLspFec()
                                    self.reverse_lsp_fec.parent = self
                                    self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"
                                return self.reverse_lsp_fec

                            if (child_yang_name == "reverse-tspec"):
                                if (self.reverse_tspec is None):
                                    self.reverse_tspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.ReverseTspec()
                                    self.reverse_tspec.parent = self
                                    self._children_name_map["reverse_tspec"] = "reverse-tspec"
                                return self.reverse_tspec

                            if (child_yang_name == "s2l-convergence"):
                                if (self.s2l_convergence is None):
                                    self.s2l_convergence = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.S2LConvergence()
                                    self.s2l_convergence.parent = self
                                    self._children_name_map["s2l_convergence"] = "s2l-convergence"
                                return self.s2l_convergence

                            if (child_yang_name == "s2l-fec"):
                                if (self.s2l_fec is None):
                                    self.s2l_fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.S2LFec()
                                    self.s2l_fec.parent = self
                                    self._children_name_map["s2l_fec"] = "s2l-fec"
                                return self.s2l_fec

                            if (child_yang_name == "s2l-reverse-lsp-sub-obj"):
                                for c in self.s2l_reverse_lsp_sub_obj:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.S2LReverseLspSubObj()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.s2l_reverse_lsp_sub_obj.append(c)
                                return c

                            if (child_yang_name == "s2l-segment-routing-path"):
                                for c in self.s2l_segment_routing_path:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.S2LSegmentRoutingPath()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.s2l_segment_routing_path.append(c)
                                return c

                            if (child_yang_name == "shared-risk-link-group"):
                                for c in self.shared_risk_link_group:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.SharedRiskLinkGroup()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.shared_risk_link_group.append(c)
                                return c

                            if (child_yang_name == "soft-preemption"):
                                if (self.soft_preemption is None):
                                    self.soft_preemption = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.SoftPreemption()
                                    self.soft_preemption.parent = self
                                    self._children_name_map["soft_preemption"] = "soft-preemption"
                                return self.soft_preemption

                            if (child_yang_name == "srlg-collection"):
                                if (self.srlg_collection is None):
                                    self.srlg_collection = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.SrlgCollection()
                                    self.srlg_collection.parent = self
                                    self._children_name_map["srlg_collection"] = "srlg-collection"
                                return self.srlg_collection

                            if (child_yang_name == "tail-end-bfd-info"):
                                if (self.tail_end_bfd_info is None):
                                    self.tail_end_bfd_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.TailEndBfdInfo()
                                    self.tail_end_bfd_info.parent = self
                                    self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"
                                return self.tail_end_bfd_info

                            if (child_yang_name == "tspec"):
                                if (self.tspec is None):
                                    self.tspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L.Tspec()
                                    self.tspec.parent = self
                                    self._children_name_map["tspec"] = "tspec"
                                return self.tspec

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "active-path-option" or name == "association" or name == "diversity-info" or name == "flex-info" or name == "fspec" or name == "generic-fspec" or name == "generic-tspec" or name == "gmpls-labels" or name == "head-end-bfd-info" or name == "in-ero" or name == "in-xro" or name == "incoming-address-generic" or name == "lsp-wrap-info" or name == "next-hop-address-generic" or name == "otn-s2l" or name == "out-ero" or name == "out-xro" or name == "path-affinity-array" or name == "path-rro" or name == "previous-hop-address-generic" or name == "protection" or name == "resv-rro" or name == "reverse-ero-in" or name == "reverse-lsp-fec" or name == "reverse-tspec" or name == "s2l-convergence" or name == "s2l-fec" or name == "s2l-reverse-lsp-sub-obj" or name == "s2l-segment-routing-path" or name == "shared-risk-link-group" or name == "soft-preemption" or name == "srlg-collection" or name == "tail-end-bfd-info" or name == "tspec" or name == "abr-auto-discovered" or name == "backup-tunnel-interface" or name == "downstream-router-id" or name == "egress-interface" or name == "egress-interface-brief" or name == "egress-interface-state" or name == "expanded-ero-affinity-bits" or name == "expanded-ero-affinity-mask" or name == "expanded-ero-area-id" or name == "expanded-ero-metric" or name == "expanded-ero-metric-type" or name == "frr-out-tunnel-interface" or name == "incoming-address" or name == "ingress-interface" or name == "ingress-interface-brief" or name == "ingress-interface-state" or name == "is-bandwidth-protect" or name == "is-expanded-ero" or name == "is-frr-enabled" or name == "is-node-protected" or name == "is-optical" or name == "local-router-id" or name == "next-hop-address" or name == "node-hop-count" or name == "outbound-frr-state" or name == "path-reeval-query-mid" or name == "path-rro-enabled" or name == "path-using-strict-spf" or name == "pcalc-area" or name == "previous-hop-address" or name == "reverse-lsp-connected" or name == "reverse-lsp-name" or name == "reverse-lsp-present" or name == "reverse-weight" or name == "role" or name == "s2l-local-label" or name == "s2l-out-label" or name == "s2l-reverse-ero-obj-present" or name == "s2l-reverse-tspec-obj-present" or name == "signalling-status" or name == "time-since-last-preferred-path-exists-send-mid" or name == "time-since-last-preferred-tree-exists-send-mid" or name == "time-since-last-query-received-mid" or name == "upstream-router-id" or name == "uptime" or name == "weight"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "abr-auto-discovered"):
                                self.abr_auto_discovered = value
                                self.abr_auto_discovered.value_namespace = name_space
                                self.abr_auto_discovered.value_namespace_prefix = name_space_prefix
                            if(value_path == "backup-tunnel-interface"):
                                self.backup_tunnel_interface = value
                                self.backup_tunnel_interface.value_namespace = name_space
                                self.backup_tunnel_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "downstream-router-id"):
                                self.downstream_router_id = value
                                self.downstream_router_id.value_namespace = name_space
                                self.downstream_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface"):
                                self.egress_interface = value
                                self.egress_interface.value_namespace = name_space
                                self.egress_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface-brief"):
                                self.egress_interface_brief = value
                                self.egress_interface_brief.value_namespace = name_space
                                self.egress_interface_brief.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface-state"):
                                self.egress_interface_state = value
                                self.egress_interface_state.value_namespace = name_space
                                self.egress_interface_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-affinity-bits"):
                                self.expanded_ero_affinity_bits = value
                                self.expanded_ero_affinity_bits.value_namespace = name_space
                                self.expanded_ero_affinity_bits.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-affinity-mask"):
                                self.expanded_ero_affinity_mask = value
                                self.expanded_ero_affinity_mask.value_namespace = name_space
                                self.expanded_ero_affinity_mask.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-area-id"):
                                self.expanded_ero_area_id = value
                                self.expanded_ero_area_id.value_namespace = name_space
                                self.expanded_ero_area_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-metric"):
                                self.expanded_ero_metric = value
                                self.expanded_ero_metric.value_namespace = name_space
                                self.expanded_ero_metric.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-metric-type"):
                                self.expanded_ero_metric_type = value
                                self.expanded_ero_metric_type.value_namespace = name_space
                                self.expanded_ero_metric_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "frr-out-tunnel-interface"):
                                self.frr_out_tunnel_interface = value
                                self.frr_out_tunnel_interface.value_namespace = name_space
                                self.frr_out_tunnel_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "incoming-address"):
                                self.incoming_address = value
                                self.incoming_address.value_namespace = name_space
                                self.incoming_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface"):
                                self.ingress_interface = value
                                self.ingress_interface.value_namespace = name_space
                                self.ingress_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface-brief"):
                                self.ingress_interface_brief = value
                                self.ingress_interface_brief.value_namespace = name_space
                                self.ingress_interface_brief.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface-state"):
                                self.ingress_interface_state = value
                                self.ingress_interface_state.value_namespace = name_space
                                self.ingress_interface_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-bandwidth-protect"):
                                self.is_bandwidth_protect = value
                                self.is_bandwidth_protect.value_namespace = name_space
                                self.is_bandwidth_protect.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-expanded-ero"):
                                self.is_expanded_ero = value
                                self.is_expanded_ero.value_namespace = name_space
                                self.is_expanded_ero.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-frr-enabled"):
                                self.is_frr_enabled = value
                                self.is_frr_enabled.value_namespace = name_space
                                self.is_frr_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-node-protected"):
                                self.is_node_protected = value
                                self.is_node_protected.value_namespace = name_space
                                self.is_node_protected.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-optical"):
                                self.is_optical = value
                                self.is_optical.value_namespace = name_space
                                self.is_optical.value_namespace_prefix = name_space_prefix
                            if(value_path == "local-router-id"):
                                self.local_router_id = value
                                self.local_router_id.value_namespace = name_space
                                self.local_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "next-hop-address"):
                                self.next_hop_address = value
                                self.next_hop_address.value_namespace = name_space
                                self.next_hop_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "node-hop-count"):
                                self.node_hop_count = value
                                self.node_hop_count.value_namespace = name_space
                                self.node_hop_count.value_namespace_prefix = name_space_prefix
                            if(value_path == "outbound-frr-state"):
                                self.outbound_frr_state = value
                                self.outbound_frr_state.value_namespace = name_space
                                self.outbound_frr_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reeval-query-mid"):
                                self.path_reeval_query_mid = value
                                self.path_reeval_query_mid.value_namespace = name_space
                                self.path_reeval_query_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-rro-enabled"):
                                self.path_rro_enabled = value
                                self.path_rro_enabled.value_namespace = name_space
                                self.path_rro_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-using-strict-spf"):
                                self.path_using_strict_spf = value
                                self.path_using_strict_spf.value_namespace = name_space
                                self.path_using_strict_spf.value_namespace_prefix = name_space_prefix
                            if(value_path == "pcalc-area"):
                                self.pcalc_area = value
                                self.pcalc_area.value_namespace = name_space
                                self.pcalc_area.value_namespace_prefix = name_space_prefix
                            if(value_path == "previous-hop-address"):
                                self.previous_hop_address = value
                                self.previous_hop_address.value_namespace = name_space
                                self.previous_hop_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-connected"):
                                self.reverse_lsp_connected = value
                                self.reverse_lsp_connected.value_namespace = name_space
                                self.reverse_lsp_connected.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-name"):
                                self.reverse_lsp_name = value
                                self.reverse_lsp_name.value_namespace = name_space
                                self.reverse_lsp_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-present"):
                                self.reverse_lsp_present = value
                                self.reverse_lsp_present.value_namespace = name_space
                                self.reverse_lsp_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-weight"):
                                self.reverse_weight = value
                                self.reverse_weight.value_namespace = name_space
                                self.reverse_weight.value_namespace_prefix = name_space_prefix
                            if(value_path == "role"):
                                self.role = value
                                self.role.value_namespace = name_space
                                self.role.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-local-label"):
                                self.s2l_local_label = value
                                self.s2l_local_label.value_namespace = name_space
                                self.s2l_local_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-out-label"):
                                self.s2l_out_label = value
                                self.s2l_out_label.value_namespace = name_space
                                self.s2l_out_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-reverse-ero-obj-present"):
                                self.s2l_reverse_ero_obj_present = value
                                self.s2l_reverse_ero_obj_present.value_namespace = name_space
                                self.s2l_reverse_ero_obj_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-reverse-tspec-obj-present"):
                                self.s2l_reverse_tspec_obj_present = value
                                self.s2l_reverse_tspec_obj_present.value_namespace = name_space
                                self.s2l_reverse_tspec_obj_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "signalling-status"):
                                self.signalling_status = value
                                self.signalling_status.value_namespace = name_space
                                self.signalling_status.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-preferred-path-exists-send-mid"):
                                self.time_since_last_preferred_path_exists_send_mid = value
                                self.time_since_last_preferred_path_exists_send_mid.value_namespace = name_space
                                self.time_since_last_preferred_path_exists_send_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-preferred-tree-exists-send-mid"):
                                self.time_since_last_preferred_tree_exists_send_mid = value
                                self.time_since_last_preferred_tree_exists_send_mid.value_namespace = name_space
                                self.time_since_last_preferred_tree_exists_send_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-query-received-mid"):
                                self.time_since_last_query_received_mid = value
                                self.time_since_last_query_received_mid.value_namespace = name_space
                                self.time_since_last_query_received_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "upstream-router-id"):
                                self.upstream_router_id = value
                                self.upstream_router_id.value_namespace = name_space
                                self.upstream_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "uptime"):
                                self.uptime = value
                                self.uptime.value_namespace = name_space
                                self.uptime.value_namespace_prefix = name_space_prefix
                            if(value_path == "weight"):
                                self.weight = value
                                self.weight.value_namespace = name_space
                                self.weight.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.s2l:
                            if (c.has_data()):
                                return True
                        return (
                            self.dste_class_index.is_set or
                            self.dste_class_match.is_set or
                            self.frr_active_reason.is_set or
                            self.is_frr_failed.is_set or
                            self.is_interface.is_set or
                            self.is_passive.is_set or
                            self.last_path_change.is_set or
                            self.lsp_bandwidth.is_set or
                            self.lsp_bandwidth_type.is_set or
                            self.lsp_hold_priority.is_set or
                            self.lsp_setup_priority.is_set or
                            self.persistent_bytes.is_set or
                            self.persistent_packets.is_set or
                            self.reoptimize_reason.is_set or
                            self.reoptimize_trigger.is_set or
                            self.s2_ls_down.is_set or
                            self.s2_ls_proceeding.is_set or
                            self.s2_ls_up.is_set or
                            self.signaled_name.is_set or
                            self.timer_left.is_set or
                            self.type.is_set or
                            self.uptime.is_set or
                            (self.lsp_fec is not None and self.lsp_fec.has_data()))

                    def has_operation(self):
                        for c in self.s2l:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.dste_class_index.yfilter != YFilter.not_set or
                            self.dste_class_match.yfilter != YFilter.not_set or
                            self.frr_active_reason.yfilter != YFilter.not_set or
                            self.is_frr_failed.yfilter != YFilter.not_set or
                            self.is_interface.yfilter != YFilter.not_set or
                            self.is_passive.yfilter != YFilter.not_set or
                            self.last_path_change.yfilter != YFilter.not_set or
                            self.lsp_bandwidth.yfilter != YFilter.not_set or
                            self.lsp_bandwidth_type.yfilter != YFilter.not_set or
                            self.lsp_hold_priority.yfilter != YFilter.not_set or
                            self.lsp_setup_priority.yfilter != YFilter.not_set or
                            self.persistent_bytes.yfilter != YFilter.not_set or
                            self.persistent_packets.yfilter != YFilter.not_set or
                            self.reoptimize_reason.yfilter != YFilter.not_set or
                            self.reoptimize_trigger.yfilter != YFilter.not_set or
                            self.s2_ls_down.yfilter != YFilter.not_set or
                            self.s2_ls_proceeding.yfilter != YFilter.not_set or
                            self.s2_ls_up.yfilter != YFilter.not_set or
                            self.signaled_name.yfilter != YFilter.not_set or
                            self.timer_left.yfilter != YFilter.not_set or
                            self.type.yfilter != YFilter.not_set or
                            self.uptime.yfilter != YFilter.not_set or
                            (self.lsp_fec is not None and self.lsp_fec.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "tunnel-standby-lsp" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.dste_class_index.is_set or self.dste_class_index.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.dste_class_index.get_name_leafdata())
                        if (self.dste_class_match.is_set or self.dste_class_match.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.dste_class_match.get_name_leafdata())
                        if (self.frr_active_reason.is_set or self.frr_active_reason.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.frr_active_reason.get_name_leafdata())
                        if (self.is_frr_failed.is_set or self.is_frr_failed.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_frr_failed.get_name_leafdata())
                        if (self.is_interface.is_set or self.is_interface.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_interface.get_name_leafdata())
                        if (self.is_passive.is_set or self.is_passive.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_passive.get_name_leafdata())
                        if (self.last_path_change.is_set or self.last_path_change.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.last_path_change.get_name_leafdata())
                        if (self.lsp_bandwidth.is_set or self.lsp_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_bandwidth.get_name_leafdata())
                        if (self.lsp_bandwidth_type.is_set or self.lsp_bandwidth_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_bandwidth_type.get_name_leafdata())
                        if (self.lsp_hold_priority.is_set or self.lsp_hold_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_hold_priority.get_name_leafdata())
                        if (self.lsp_setup_priority.is_set or self.lsp_setup_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_setup_priority.get_name_leafdata())
                        if (self.persistent_bytes.is_set or self.persistent_bytes.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.persistent_bytes.get_name_leafdata())
                        if (self.persistent_packets.is_set or self.persistent_packets.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.persistent_packets.get_name_leafdata())
                        if (self.reoptimize_reason.is_set or self.reoptimize_reason.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reoptimize_reason.get_name_leafdata())
                        if (self.reoptimize_trigger.is_set or self.reoptimize_trigger.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reoptimize_trigger.get_name_leafdata())
                        if (self.s2_ls_down.is_set or self.s2_ls_down.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_down.get_name_leafdata())
                        if (self.s2_ls_proceeding.is_set or self.s2_ls_proceeding.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_proceeding.get_name_leafdata())
                        if (self.s2_ls_up.is_set or self.s2_ls_up.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_up.get_name_leafdata())
                        if (self.signaled_name.is_set or self.signaled_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.signaled_name.get_name_leafdata())
                        if (self.timer_left.is_set or self.timer_left.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.timer_left.get_name_leafdata())
                        if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.type.get_name_leafdata())
                        if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.uptime.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "lsp-fec"):
                            if (self.lsp_fec is None):
                                self.lsp_fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.LspFec()
                                self.lsp_fec.parent = self
                                self._children_name_map["lsp_fec"] = "lsp-fec"
                            return self.lsp_fec

                        if (child_yang_name == "s2l"):
                            for c in self.s2l:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp.S2L()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.s2l.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "lsp-fec" or name == "s2l" or name == "dste-class-index" or name == "dste-class-match" or name == "frr-active-reason" or name == "is-frr-failed" or name == "is-interface" or name == "is-passive" or name == "last-path-change" or name == "lsp-bandwidth" or name == "lsp-bandwidth-type" or name == "lsp-hold-priority" or name == "lsp-setup-priority" or name == "persistent-bytes" or name == "persistent-packets" or name == "reoptimize-reason" or name == "reoptimize-trigger" or name == "s2-ls-down" or name == "s2-ls-proceeding" or name == "s2-ls-up" or name == "signaled-name" or name == "timer-left" or name == "type" or name == "uptime"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "dste-class-index"):
                            self.dste_class_index = value
                            self.dste_class_index.value_namespace = name_space
                            self.dste_class_index.value_namespace_prefix = name_space_prefix
                        if(value_path == "dste-class-match"):
                            self.dste_class_match = value
                            self.dste_class_match.value_namespace = name_space
                            self.dste_class_match.value_namespace_prefix = name_space_prefix
                        if(value_path == "frr-active-reason"):
                            self.frr_active_reason = value
                            self.frr_active_reason.value_namespace = name_space
                            self.frr_active_reason.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-frr-failed"):
                            self.is_frr_failed = value
                            self.is_frr_failed.value_namespace = name_space
                            self.is_frr_failed.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-interface"):
                            self.is_interface = value
                            self.is_interface.value_namespace = name_space
                            self.is_interface.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-passive"):
                            self.is_passive = value
                            self.is_passive.value_namespace = name_space
                            self.is_passive.value_namespace_prefix = name_space_prefix
                        if(value_path == "last-path-change"):
                            self.last_path_change = value
                            self.last_path_change.value_namespace = name_space
                            self.last_path_change.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-bandwidth"):
                            self.lsp_bandwidth = value
                            self.lsp_bandwidth.value_namespace = name_space
                            self.lsp_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-bandwidth-type"):
                            self.lsp_bandwidth_type = value
                            self.lsp_bandwidth_type.value_namespace = name_space
                            self.lsp_bandwidth_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-hold-priority"):
                            self.lsp_hold_priority = value
                            self.lsp_hold_priority.value_namespace = name_space
                            self.lsp_hold_priority.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-setup-priority"):
                            self.lsp_setup_priority = value
                            self.lsp_setup_priority.value_namespace = name_space
                            self.lsp_setup_priority.value_namespace_prefix = name_space_prefix
                        if(value_path == "persistent-bytes"):
                            self.persistent_bytes = value
                            self.persistent_bytes.value_namespace = name_space
                            self.persistent_bytes.value_namespace_prefix = name_space_prefix
                        if(value_path == "persistent-packets"):
                            self.persistent_packets = value
                            self.persistent_packets.value_namespace = name_space
                            self.persistent_packets.value_namespace_prefix = name_space_prefix
                        if(value_path == "reoptimize-reason"):
                            self.reoptimize_reason = value
                            self.reoptimize_reason.value_namespace = name_space
                            self.reoptimize_reason.value_namespace_prefix = name_space_prefix
                        if(value_path == "reoptimize-trigger"):
                            self.reoptimize_trigger = value
                            self.reoptimize_trigger.value_namespace = name_space
                            self.reoptimize_trigger.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-down"):
                            self.s2_ls_down = value
                            self.s2_ls_down.value_namespace = name_space
                            self.s2_ls_down.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-proceeding"):
                            self.s2_ls_proceeding = value
                            self.s2_ls_proceeding.value_namespace = name_space
                            self.s2_ls_proceeding.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-up"):
                            self.s2_ls_up = value
                            self.s2_ls_up.value_namespace = name_space
                            self.s2_ls_up.value_namespace_prefix = name_space_prefix
                        if(value_path == "signaled-name"):
                            self.signaled_name = value
                            self.signaled_name.value_namespace = name_space
                            self.signaled_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "timer-left"):
                            self.timer_left = value
                            self.timer_left.value_namespace = name_space
                            self.timer_left.value_namespace_prefix = name_space_prefix
                        if(value_path == "type"):
                            self.type = value
                            self.type.value_namespace = name_space
                            self.type.value_namespace_prefix = name_space_prefix
                        if(value_path == "uptime"):
                            self.uptime = value
                            self.uptime.value_namespace = name_space
                            self.uptime.value_namespace_prefix = name_space_prefix


                class ReoptimizedStandbyP2MpLsp(Entity):
                    """
                    Standby Reopt LSP
                    
                    .. attribute:: dste_class_index
                    
                    	Matching DSTE class index
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: dste_class_match
                    
                    	Do the class type and priority match a DSTE class
                    	**type**\:  bool
                    
                    .. attribute:: frr_active_reason
                    
                    	P2MP LSP FRR active reason
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: is_frr_failed
                    
                    	P2MP LSP has FRR Failed
                    	**type**\:  bool
                    
                    .. attribute:: is_interface
                    
                    	True for tunnel head
                    	**type**\:  bool
                    
                    .. attribute:: is_passive
                    
                    	True for passive tunnel
                    	**type**\:  bool
                    
                    .. attribute:: last_path_change
                    
                    	Time in seconds since the last path change
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: lsp_bandwidth
                    
                    	P2MP LSP Bandwidth
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: lsp_bandwidth_type
                    
                    	The LSP bandwidth type
                    	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                    
                    .. attribute:: lsp_fec
                    
                    	FEC for the LSP
                    	**type**\:   :py:class:`LspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.LspFec>`
                    
                    .. attribute:: lsp_hold_priority
                    
                    	LSP hold priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: lsp_setup_priority
                    
                    	LSP setup priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: persistent_bytes
                    
                    	Persistent forwarding statistics for number of bytes. Clear counters will not reset the counter
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**units**\: byte
                    
                    .. attribute:: persistent_packets
                    
                    	Persistent forwarding statistics for Number of packets. Clear counters will not reset the counter
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: reoptimize_reason
                    
                    	Reason for re\-optimization
                    	**type**\:   :py:class:`MplsTeReoptDecisionReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReoptDecisionReason>`
                    
                    .. attribute:: reoptimize_trigger
                    
                    	Re\-optimize trigger
                    	**type**\:   :py:class:`MteReoptTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteReoptTrigger>`
                    
                    .. attribute:: s2_ls_down
                    
                    	Number of down S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2_ls_proceeding
                    
                    	Number of proceeding S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2_ls_up
                    
                    	Number of connected S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2l
                    
                    	array of S2L structures
                    	**type**\: list of    :py:class:`S2L <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L>`
                    
                    .. attribute:: signaled_name
                    
                    	Signaled Name
                    	**type**\:  str
                    
                    .. attribute:: timer_left
                    
                    	Time in seconds left to take next action if any
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: type
                    
                    	The type of this LSP
                    	**type**\:   :py:class:`MplsTeLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLsp>`
                    
                    .. attribute:: uptime
                    
                    	Time in seconds since the tunnel was up
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp, self).__init__()

                        self.yang_name = "reoptimized-standby-p2mp-lsp"
                        self.yang_parent_name = "tunnel-head"

                        self.dste_class_index = YLeaf(YType.uint8, "dste-class-index")

                        self.dste_class_match = YLeaf(YType.boolean, "dste-class-match")

                        self.frr_active_reason = YLeaf(YType.uint32, "frr-active-reason")

                        self.is_frr_failed = YLeaf(YType.boolean, "is-frr-failed")

                        self.is_interface = YLeaf(YType.boolean, "is-interface")

                        self.is_passive = YLeaf(YType.boolean, "is-passive")

                        self.last_path_change = YLeaf(YType.uint32, "last-path-change")

                        self.lsp_bandwidth = YLeaf(YType.uint32, "lsp-bandwidth")

                        self.lsp_bandwidth_type = YLeaf(YType.enumeration, "lsp-bandwidth-type")

                        self.lsp_hold_priority = YLeaf(YType.uint8, "lsp-hold-priority")

                        self.lsp_setup_priority = YLeaf(YType.uint8, "lsp-setup-priority")

                        self.persistent_bytes = YLeaf(YType.uint64, "persistent-bytes")

                        self.persistent_packets = YLeaf(YType.uint64, "persistent-packets")

                        self.reoptimize_reason = YLeaf(YType.enumeration, "reoptimize-reason")

                        self.reoptimize_trigger = YLeaf(YType.enumeration, "reoptimize-trigger")

                        self.s2_ls_down = YLeaf(YType.uint32, "s2-ls-down")

                        self.s2_ls_proceeding = YLeaf(YType.uint32, "s2-ls-proceeding")

                        self.s2_ls_up = YLeaf(YType.uint32, "s2-ls-up")

                        self.signaled_name = YLeaf(YType.str, "signaled-name")

                        self.timer_left = YLeaf(YType.uint32, "timer-left")

                        self.type = YLeaf(YType.enumeration, "type")

                        self.uptime = YLeaf(YType.uint32, "uptime")

                        self.lsp_fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.LspFec()
                        self.lsp_fec.parent = self
                        self._children_name_map["lsp_fec"] = "lsp-fec"
                        self._children_yang_names.add("lsp-fec")

                        self.s2l = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("dste_class_index",
                                        "dste_class_match",
                                        "frr_active_reason",
                                        "is_frr_failed",
                                        "is_interface",
                                        "is_passive",
                                        "last_path_change",
                                        "lsp_bandwidth",
                                        "lsp_bandwidth_type",
                                        "lsp_hold_priority",
                                        "lsp_setup_priority",
                                        "persistent_bytes",
                                        "persistent_packets",
                                        "reoptimize_reason",
                                        "reoptimize_trigger",
                                        "s2_ls_down",
                                        "s2_ls_proceeding",
                                        "s2_ls_up",
                                        "signaled_name",
                                        "timer_left",
                                        "type",
                                        "uptime") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp, self).__setattr__(name, value)


                    class LspFec(Entity):
                        """
                        FEC for the LSP
                        
                        .. attribute:: fec_destination_info
                        
                        	Destination or P2MP ID
                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.LspFec.FecDestinationInfo>`
                        
                        .. attribute:: fec_extended_tunnel_id
                        
                        	Extended tunnel ID
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: fec_lsp_id
                        
                        	LSP ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: fec_source
                        
                        	Tunnel source address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: fec_tunnel_id
                        
                        	Tunnel ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: fec_vrf
                        
                        	VRF; currently only for GMPLS tunnels
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.LspFec, self).__init__()

                            self.yang_name = "lsp-fec"
                            self.yang_parent_name = "reoptimized-standby-p2mp-lsp"

                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                            self.fec_source = YLeaf(YType.str, "fec-source")

                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                            self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.LspFec.FecDestinationInfo()
                            self.fec_destination_info.parent = self
                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                            self._children_yang_names.add("fec-destination-info")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("fec_extended_tunnel_id",
                                            "fec_lsp_id",
                                            "fec_source",
                                            "fec_tunnel_id",
                                            "fec_vrf") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.LspFec, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.LspFec, self).__setattr__(name, value)


                        class FecDestinationInfo(Entity):
                            """
                            Destination or P2MP ID
                            
                            .. attribute:: fec_ctype
                            
                            	FEC CType
                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            .. attribute:: fec_destination_p2mp_id
                            
                            	P2MP ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: p2p_lsp_destination
                            
                            	P2P LSP destination
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.LspFec.FecDestinationInfo, self).__init__()

                                self.yang_name = "fec-destination-info"
                                self.yang_parent_name = "lsp-fec"

                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fec_ctype",
                                                "fec_destination_p2mp_id",
                                                "p2p_lsp_destination") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.LspFec.FecDestinationInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.LspFec.FecDestinationInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.fec_ctype.is_set or
                                    self.fec_destination_p2mp_id.is_set or
                                    self.p2p_lsp_destination.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fec_ctype.yfilter != YFilter.not_set or
                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fec-destination-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fec-ctype"):
                                    self.fec_ctype = value
                                    self.fec_ctype.value_namespace = name_space
                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-destination-p2mp-id"):
                                    self.fec_destination_p2mp_id = value
                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "p2p-lsp-destination"):
                                    self.p2p_lsp_destination = value
                                    self.p2p_lsp_destination.value_namespace = name_space
                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.fec_extended_tunnel_id.is_set or
                                self.fec_lsp_id.is_set or
                                self.fec_source.is_set or
                                self.fec_tunnel_id.is_set or
                                self.fec_vrf.is_set or
                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                self.fec_source.yfilter != YFilter.not_set or
                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                self.fec_vrf.yfilter != YFilter.not_set or
                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "lsp-fec" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "fec-destination-info"):
                                if (self.fec_destination_info is None):
                                    self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.LspFec.FecDestinationInfo()
                                    self.fec_destination_info.parent = self
                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                return self.fec_destination_info

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "fec-extended-tunnel-id"):
                                self.fec_extended_tunnel_id = value
                                self.fec_extended_tunnel_id.value_namespace = name_space
                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-lsp-id"):
                                self.fec_lsp_id = value
                                self.fec_lsp_id.value_namespace = name_space
                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-source"):
                                self.fec_source = value
                                self.fec_source.value_namespace = name_space
                                self.fec_source.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-tunnel-id"):
                                self.fec_tunnel_id = value
                                self.fec_tunnel_id.value_namespace = name_space
                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-vrf"):
                                self.fec_vrf = value
                                self.fec_vrf.value_namespace = name_space
                                self.fec_vrf.value_namespace_prefix = name_space_prefix


                    class S2L(Entity):
                        """
                        array of S2L structures
                        
                        .. attribute:: abr_auto_discovered
                        
                        	Next ABR auto discovered
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: active_path_option
                        
                        	The path option used to find the path for this S2L
                        	**type**\:   :py:class:`ActivePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption>`
                        
                        .. attribute:: association
                        
                        	Association Object
                        	**type**\:   :py:class:`Association <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.Association>`
                        
                        .. attribute:: backup_tunnel_interface
                        
                        	Interface handle of the backup tunnel
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        .. attribute:: diversity_info
                        
                        	S2L Diversity Information
                        	**type**\:   :py:class:`DiversityInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.DiversityInfo>`
                        
                        .. attribute:: downstream_router_id
                        
                        	Downstream router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: egress_interface
                        
                        	Egress Interface
                        	**type**\:  str
                        
                        .. attribute:: egress_interface_brief
                        
                        	Egress Interface in brief format
                        	**type**\:  str
                        
                        .. attribute:: egress_interface_state
                        
                        	State of Outgoing Interface
                        	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        .. attribute:: expanded_ero_affinity_bits
                        
                        	The Outgoing ERO's affinity bits (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_affinity_mask
                        
                        	The Outgoing ERO's affinity mask (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_area_id
                        
                        	Indicates the protocol and area used to find Outgoing ERO
                        	**type**\:  str
                        
                        .. attribute:: expanded_ero_metric
                        
                        	The metric value of the expanded path
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_metric_type
                        
                        	The Outgoing ERO's selection metric
                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                        
                        .. attribute:: flex_info
                        
                        	FlexLSP S2L Information
                        	**type**\:   :py:class:`FlexInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.FlexInfo>`
                        
                        .. attribute:: frr_out_tunnel_interface
                        
                        	FRR out tunnel intface
                        	**type**\:  str
                        
                        .. attribute:: fspec
                        
                        	The F spec info
                        	**type**\:   :py:class:`Fspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.Fspec>`
                        
                        .. attribute:: generic_fspec
                        
                        	Generic FSpec
                        	**type**\:   :py:class:`GenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GenericFspec>`
                        
                        .. attribute:: generic_tspec
                        
                        	Generic TSpec
                        	**type**\:   :py:class:`GenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GenericTspec>`
                        
                        .. attribute:: gmpls_labels
                        
                        	GMPLS labels
                        	**type**\:   :py:class:`GmplsLabels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels>`
                        
                        .. attribute:: head_end_bfd_info
                        
                        	The Head\-end BFD info
                        	**type**\:   :py:class:`HeadEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo>`
                        
                        .. attribute:: in_ero
                        
                        	Incoming ERO for this S2L
                        	**type**\: list of    :py:class:`InEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InEro>`
                        
                        .. attribute:: in_xro
                        
                        	Incoming XRO for this S2L
                        	**type**\:   :py:class:`InXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro>`
                        
                        .. attribute:: incoming_address
                        
                        	Incoming interface address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: incoming_address_generic
                        
                        	Incoming interface address
                        	**type**\:   :py:class:`IncomingAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.IncomingAddressGeneric>`
                        
                        .. attribute:: ingress_interface
                        
                        	Ingress Interface
                        	**type**\:  str
                        
                        .. attribute:: ingress_interface_brief
                        
                        	Ingress Interface in brief format
                        	**type**\:  str
                        
                        .. attribute:: ingress_interface_state
                        
                        	State of Incoming Interface
                        	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        .. attribute:: is_bandwidth_protect
                        
                        	BW Protection Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_expanded_ero
                        
                        	TRUE if this LSR expanded a loose path
                        	**type**\:  bool
                        
                        .. attribute:: is_frr_enabled
                        
                        	FRR Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_node_protected
                        
                        	Node Protection Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_optical
                        
                        	Is Optical
                        	**type**\:  bool
                        
                        .. attribute:: local_router_id
                        
                        	Local router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: lsp_wrap_info
                        
                        	Lsp Wrap  Related information
                        	**type**\:   :py:class:`LspWrapInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.LspWrapInfo>`
                        
                        .. attribute:: next_hop_address
                        
                        	Next hop address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: next_hop_address_generic
                        
                        	Next hop address
                        	**type**\:   :py:class:`NextHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.NextHopAddressGeneric>`
                        
                        .. attribute:: node_hop_count
                        
                        	Hop count
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        .. attribute:: otn_s2l
                        
                        	Otn S2L Information
                        	**type**\:   :py:class:`OtnS2L <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L>`
                        
                        .. attribute:: out_ero
                        
                        	Outgoing ERO for this S2L
                        	**type**\: list of    :py:class:`OutEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutEro>`
                        
                        .. attribute:: out_xro
                        
                        	Outgoing XRO for this S2L
                        	**type**\:   :py:class:`OutXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro>`
                        
                        .. attribute:: outbound_frr_state
                        
                        	Indicates outbound FRR state
                        	**type**\:   :py:class:`MplsTeFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrState>`
                        
                        .. attribute:: path_affinity_array
                        
                        	Tunnel's Path hops with affinity
                        	**type**\: list of    :py:class:`PathAffinityArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathAffinityArray>`
                        
                        .. attribute:: path_reeval_query_mid
                        
                        	Loose path reevaluation query received at mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: path_rro
                        
                        	Path RRO for this S2L
                        	**type**\: list of    :py:class:`PathRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro>`
                        
                        .. attribute:: path_rro_enabled
                        
                        	Path RRO Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: path_using_strict_spf
                        
                        	Path is using Strict SPF
                        	**type**\:  bool
                        
                        .. attribute:: pcalc_area
                        
                        	IGP\-area in which the S2L path was calculated
                        	**type**\:  str
                        
                        .. attribute:: previous_hop_address
                        
                        	Previous hop address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: previous_hop_address_generic
                        
                        	Previous hop address
                        	**type**\:   :py:class:`PreviousHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PreviousHopAddressGeneric>`
                        
                        .. attribute:: protection
                        
                        	Protection Object
                        	**type**\:   :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.Protection>`
                        
                        .. attribute:: resv_rro
                        
                        	Resv RRO for this S2L
                        	**type**\: list of    :py:class:`ResvRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro>`
                        
                        .. attribute:: reverse_ero_in
                        
                        	 Reverse Incoming ERO for this S2L
                        	**type**\: list of    :py:class:`ReverseEroIn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ReverseEroIn>`
                        
                        .. attribute:: reverse_lsp_connected
                        
                        	Reverse Associated Bidir LSP Connected
                        	**type**\:  bool
                        
                        .. attribute:: reverse_lsp_fec
                        
                        	Reverse Associated Bidir LSP FEC
                        	**type**\:   :py:class:`ReverseLspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ReverseLspFec>`
                        
                        .. attribute:: reverse_lsp_name
                        
                        	Reverse Associated Bidir LSP Name
                        	**type**\:  str
                        
                        .. attribute:: reverse_lsp_present
                        
                        	Reverse Associated Bidir LSP Present
                        	**type**\:  bool
                        
                        .. attribute:: reverse_tspec
                        
                        	The Reverse T spec info
                        	**type**\:   :py:class:`ReverseTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ReverseTspec>`
                        
                        .. attribute:: reverse_weight
                        
                        	The reverse path weight
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: role
                        
                        	Role of S2L
                        	**type**\:   :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        .. attribute:: s2l_convergence
                        
                        	TE LSP convergence related information
                        	**type**\:   :py:class:`S2LConvergence <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.S2LConvergence>`
                        
                        .. attribute:: s2l_fec
                        
                        	FEC for the S2L
                        	**type**\:   :py:class:`S2LFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.S2LFec>`
                        
                        .. attribute:: s2l_local_label
                        
                        	Local label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: s2l_out_label
                        
                        	Outgoing label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: s2l_reverse_ero_obj_present
                        
                        	 S2l Reverse ERO Object Present
                        	**type**\:  bool
                        
                        .. attribute:: s2l_reverse_lsp_sub_obj
                        
                        	Reverse LSP Sub Objects
                        	**type**\: list of    :py:class:`S2LReverseLspSubObj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.S2LReverseLspSubObj>`
                        
                        .. attribute:: s2l_reverse_tspec_obj_present
                        
                        	 S2L Reverse TSpec Object Present
                        	**type**\:  bool
                        
                        .. attribute:: s2l_segment_routing_path
                        
                        	Segment\-Routing S2L path info
                        	**type**\: list of    :py:class:`S2LSegmentRoutingPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.S2LSegmentRoutingPath>`
                        
                        .. attribute:: shared_risk_link_group
                        
                        	The S2L's excluded srlg groups
                        	**type**\: list of    :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.SharedRiskLinkGroup>`
                        
                        .. attribute:: signalling_status
                        
                        	Signaling status
                        	**type**\:   :py:class:`MplsTeTunnelsSignalingStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelsSignalingStatus>`
                        
                        .. attribute:: soft_preemption
                        
                        	The soft preemption info for this LSP
                        	**type**\:   :py:class:`SoftPreemption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.SoftPreemption>`
                        
                        .. attribute:: srlg_collection
                        
                        	SRLG\-collection data
                        	**type**\:   :py:class:`SrlgCollection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.SrlgCollection>`
                        
                        .. attribute:: tail_end_bfd_info
                        
                        	The Tail\-end BFD info
                        	**type**\:   :py:class:`TailEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.TailEndBfdInfo>`
                        
                        .. attribute:: time_since_last_preferred_path_exists_send_mid
                        
                        	Time since last preferred path exists msg send from mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: time_since_last_preferred_tree_exists_send_mid
                        
                        	Time since last preferred tree exists msg send from mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: time_since_last_query_received_mid
                        
                        	Time since last reevaluation query received at mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tspec
                        
                        	The T spec info
                        	**type**\:   :py:class:`Tspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.Tspec>`
                        
                        .. attribute:: upstream_router_id
                        
                        	Upstream router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: uptime
                        
                        	Time in seconds since the tunnel was up
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: weight
                        
                        	The path's weight
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L, self).__init__()

                            self.yang_name = "s2l"
                            self.yang_parent_name = "reoptimized-standby-p2mp-lsp"

                            self.abr_auto_discovered = YLeaf(YType.str, "abr-auto-discovered")

                            self.backup_tunnel_interface = YLeaf(YType.str, "backup-tunnel-interface")

                            self.downstream_router_id = YLeaf(YType.str, "downstream-router-id")

                            self.egress_interface = YLeaf(YType.str, "egress-interface")

                            self.egress_interface_brief = YLeaf(YType.str, "egress-interface-brief")

                            self.egress_interface_state = YLeaf(YType.enumeration, "egress-interface-state")

                            self.expanded_ero_affinity_bits = YLeaf(YType.uint32, "expanded-ero-affinity-bits")

                            self.expanded_ero_affinity_mask = YLeaf(YType.uint32, "expanded-ero-affinity-mask")

                            self.expanded_ero_area_id = YLeaf(YType.str, "expanded-ero-area-id")

                            self.expanded_ero_metric = YLeaf(YType.uint32, "expanded-ero-metric")

                            self.expanded_ero_metric_type = YLeaf(YType.enumeration, "expanded-ero-metric-type")

                            self.frr_out_tunnel_interface = YLeaf(YType.str, "frr-out-tunnel-interface")

                            self.incoming_address = YLeaf(YType.str, "incoming-address")

                            self.ingress_interface = YLeaf(YType.str, "ingress-interface")

                            self.ingress_interface_brief = YLeaf(YType.str, "ingress-interface-brief")

                            self.ingress_interface_state = YLeaf(YType.enumeration, "ingress-interface-state")

                            self.is_bandwidth_protect = YLeaf(YType.boolean, "is-bandwidth-protect")

                            self.is_expanded_ero = YLeaf(YType.boolean, "is-expanded-ero")

                            self.is_frr_enabled = YLeaf(YType.boolean, "is-frr-enabled")

                            self.is_node_protected = YLeaf(YType.boolean, "is-node-protected")

                            self.is_optical = YLeaf(YType.boolean, "is-optical")

                            self.local_router_id = YLeaf(YType.str, "local-router-id")

                            self.next_hop_address = YLeaf(YType.str, "next-hop-address")

                            self.node_hop_count = YLeaf(YType.uint8, "node-hop-count")

                            self.outbound_frr_state = YLeaf(YType.enumeration, "outbound-frr-state")

                            self.path_reeval_query_mid = YLeaf(YType.uint32, "path-reeval-query-mid")

                            self.path_rro_enabled = YLeaf(YType.boolean, "path-rro-enabled")

                            self.path_using_strict_spf = YLeaf(YType.boolean, "path-using-strict-spf")

                            self.pcalc_area = YLeaf(YType.str, "pcalc-area")

                            self.previous_hop_address = YLeaf(YType.str, "previous-hop-address")

                            self.reverse_lsp_connected = YLeaf(YType.boolean, "reverse-lsp-connected")

                            self.reverse_lsp_name = YLeaf(YType.str, "reverse-lsp-name")

                            self.reverse_lsp_present = YLeaf(YType.boolean, "reverse-lsp-present")

                            self.reverse_weight = YLeaf(YType.uint64, "reverse-weight")

                            self.role = YLeaf(YType.enumeration, "role")

                            self.s2l_local_label = YLeaf(YType.uint32, "s2l-local-label")

                            self.s2l_out_label = YLeaf(YType.uint32, "s2l-out-label")

                            self.s2l_reverse_ero_obj_present = YLeaf(YType.boolean, "s2l-reverse-ero-obj-present")

                            self.s2l_reverse_tspec_obj_present = YLeaf(YType.boolean, "s2l-reverse-tspec-obj-present")

                            self.signalling_status = YLeaf(YType.enumeration, "signalling-status")

                            self.time_since_last_preferred_path_exists_send_mid = YLeaf(YType.uint32, "time-since-last-preferred-path-exists-send-mid")

                            self.time_since_last_preferred_tree_exists_send_mid = YLeaf(YType.uint32, "time-since-last-preferred-tree-exists-send-mid")

                            self.time_since_last_query_received_mid = YLeaf(YType.uint32, "time-since-last-query-received-mid")

                            self.upstream_router_id = YLeaf(YType.str, "upstream-router-id")

                            self.uptime = YLeaf(YType.uint32, "uptime")

                            self.weight = YLeaf(YType.uint64, "weight")

                            self.active_path_option = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption()
                            self.active_path_option.parent = self
                            self._children_name_map["active_path_option"] = "active-path-option"
                            self._children_yang_names.add("active-path-option")

                            self.association = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.Association()
                            self.association.parent = self
                            self._children_name_map["association"] = "association"
                            self._children_yang_names.add("association")

                            self.diversity_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.DiversityInfo()
                            self.diversity_info.parent = self
                            self._children_name_map["diversity_info"] = "diversity-info"
                            self._children_yang_names.add("diversity-info")

                            self.flex_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.FlexInfo()
                            self.flex_info.parent = self
                            self._children_name_map["flex_info"] = "flex-info"
                            self._children_yang_names.add("flex-info")

                            self.fspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.Fspec()
                            self.fspec.parent = self
                            self._children_name_map["fspec"] = "fspec"
                            self._children_yang_names.add("fspec")

                            self.generic_fspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GenericFspec()
                            self.generic_fspec.parent = self
                            self._children_name_map["generic_fspec"] = "generic-fspec"
                            self._children_yang_names.add("generic-fspec")

                            self.generic_tspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GenericTspec()
                            self.generic_tspec.parent = self
                            self._children_name_map["generic_tspec"] = "generic-tspec"
                            self._children_yang_names.add("generic-tspec")

                            self.gmpls_labels = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels()
                            self.gmpls_labels.parent = self
                            self._children_name_map["gmpls_labels"] = "gmpls-labels"
                            self._children_yang_names.add("gmpls-labels")

                            self.head_end_bfd_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo()
                            self.head_end_bfd_info.parent = self
                            self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"
                            self._children_yang_names.add("head-end-bfd-info")

                            self.in_xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro()
                            self.in_xro.parent = self
                            self._children_name_map["in_xro"] = "in-xro"
                            self._children_yang_names.add("in-xro")

                            self.incoming_address_generic = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.IncomingAddressGeneric()
                            self.incoming_address_generic.parent = self
                            self._children_name_map["incoming_address_generic"] = "incoming-address-generic"
                            self._children_yang_names.add("incoming-address-generic")

                            self.lsp_wrap_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.LspWrapInfo()
                            self.lsp_wrap_info.parent = self
                            self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"
                            self._children_yang_names.add("lsp-wrap-info")

                            self.next_hop_address_generic = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.NextHopAddressGeneric()
                            self.next_hop_address_generic.parent = self
                            self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"
                            self._children_yang_names.add("next-hop-address-generic")

                            self.otn_s2l = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L()
                            self.otn_s2l.parent = self
                            self._children_name_map["otn_s2l"] = "otn-s2l"
                            self._children_yang_names.add("otn-s2l")

                            self.out_xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro()
                            self.out_xro.parent = self
                            self._children_name_map["out_xro"] = "out-xro"
                            self._children_yang_names.add("out-xro")

                            self.previous_hop_address_generic = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PreviousHopAddressGeneric()
                            self.previous_hop_address_generic.parent = self
                            self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"
                            self._children_yang_names.add("previous-hop-address-generic")

                            self.protection = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.Protection()
                            self.protection.parent = self
                            self._children_name_map["protection"] = "protection"
                            self._children_yang_names.add("protection")

                            self.reverse_lsp_fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ReverseLspFec()
                            self.reverse_lsp_fec.parent = self
                            self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"
                            self._children_yang_names.add("reverse-lsp-fec")

                            self.reverse_tspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ReverseTspec()
                            self.reverse_tspec.parent = self
                            self._children_name_map["reverse_tspec"] = "reverse-tspec"
                            self._children_yang_names.add("reverse-tspec")

                            self.s2l_convergence = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.S2LConvergence()
                            self.s2l_convergence.parent = self
                            self._children_name_map["s2l_convergence"] = "s2l-convergence"
                            self._children_yang_names.add("s2l-convergence")

                            self.s2l_fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.S2LFec()
                            self.s2l_fec.parent = self
                            self._children_name_map["s2l_fec"] = "s2l-fec"
                            self._children_yang_names.add("s2l-fec")

                            self.soft_preemption = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.SoftPreemption()
                            self.soft_preemption.parent = self
                            self._children_name_map["soft_preemption"] = "soft-preemption"
                            self._children_yang_names.add("soft-preemption")

                            self.srlg_collection = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.SrlgCollection()
                            self.srlg_collection.parent = self
                            self._children_name_map["srlg_collection"] = "srlg-collection"
                            self._children_yang_names.add("srlg-collection")

                            self.tail_end_bfd_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.TailEndBfdInfo()
                            self.tail_end_bfd_info.parent = self
                            self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"
                            self._children_yang_names.add("tail-end-bfd-info")

                            self.tspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.Tspec()
                            self.tspec.parent = self
                            self._children_name_map["tspec"] = "tspec"
                            self._children_yang_names.add("tspec")

                            self.in_ero = YList(self)
                            self.out_ero = YList(self)
                            self.path_affinity_array = YList(self)
                            self.path_rro = YList(self)
                            self.resv_rro = YList(self)
                            self.reverse_ero_in = YList(self)
                            self.s2l_reverse_lsp_sub_obj = YList(self)
                            self.s2l_segment_routing_path = YList(self)
                            self.shared_risk_link_group = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("abr_auto_discovered",
                                            "backup_tunnel_interface",
                                            "downstream_router_id",
                                            "egress_interface",
                                            "egress_interface_brief",
                                            "egress_interface_state",
                                            "expanded_ero_affinity_bits",
                                            "expanded_ero_affinity_mask",
                                            "expanded_ero_area_id",
                                            "expanded_ero_metric",
                                            "expanded_ero_metric_type",
                                            "frr_out_tunnel_interface",
                                            "incoming_address",
                                            "ingress_interface",
                                            "ingress_interface_brief",
                                            "ingress_interface_state",
                                            "is_bandwidth_protect",
                                            "is_expanded_ero",
                                            "is_frr_enabled",
                                            "is_node_protected",
                                            "is_optical",
                                            "local_router_id",
                                            "next_hop_address",
                                            "node_hop_count",
                                            "outbound_frr_state",
                                            "path_reeval_query_mid",
                                            "path_rro_enabled",
                                            "path_using_strict_spf",
                                            "pcalc_area",
                                            "previous_hop_address",
                                            "reverse_lsp_connected",
                                            "reverse_lsp_name",
                                            "reverse_lsp_present",
                                            "reverse_weight",
                                            "role",
                                            "s2l_local_label",
                                            "s2l_out_label",
                                            "s2l_reverse_ero_obj_present",
                                            "s2l_reverse_tspec_obj_present",
                                            "signalling_status",
                                            "time_since_last_preferred_path_exists_send_mid",
                                            "time_since_last_preferred_tree_exists_send_mid",
                                            "time_since_last_query_received_mid",
                                            "upstream_router_id",
                                            "uptime",
                                            "weight") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L, self).__setattr__(name, value)


                        class S2LFec(Entity):
                            """
                            FEC for the S2L
                            
                            .. attribute:: s2l_fec_ctype
                            
                            	Session identifier (ctype)
                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            .. attribute:: s2l_fec_dest
                            
                            	sub\-LSP destination address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_lsp_id
                            
                            	LSP ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_p2mp_id
                            
                            	P2MP ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: s2l_fec_source
                            
                            	LSP source address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_subgroup_id
                            
                            	sub\-LSP subgroup ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_subgroup_originator
                            
                            	Subgroup Originator
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.S2LFec, self).__init__()

                                self.yang_name = "s2l-fec"
                                self.yang_parent_name = "s2l"

                                self.s2l_fec_ctype = YLeaf(YType.enumeration, "s2l-fec-ctype")

                                self.s2l_fec_dest = YLeaf(YType.str, "s2l-fec-dest")

                                self.s2l_fec_extended_tunnel_id = YLeaf(YType.str, "s2l-fec-extended-tunnel-id")

                                self.s2l_fec_lsp_id = YLeaf(YType.uint16, "s2l-fec-lsp-id")

                                self.s2l_fec_p2mp_id = YLeaf(YType.uint32, "s2l-fec-p2mp-id")

                                self.s2l_fec_source = YLeaf(YType.str, "s2l-fec-source")

                                self.s2l_fec_subgroup_id = YLeaf(YType.uint16, "s2l-fec-subgroup-id")

                                self.s2l_fec_subgroup_originator = YLeaf(YType.str, "s2l-fec-subgroup-originator")

                                self.s2l_fec_tunnel_id = YLeaf(YType.uint16, "s2l-fec-tunnel-id")

                                self.s2l_fec_vrf = YLeaf(YType.str, "s2l-fec-vrf")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("s2l_fec_ctype",
                                                "s2l_fec_dest",
                                                "s2l_fec_extended_tunnel_id",
                                                "s2l_fec_lsp_id",
                                                "s2l_fec_p2mp_id",
                                                "s2l_fec_source",
                                                "s2l_fec_subgroup_id",
                                                "s2l_fec_subgroup_originator",
                                                "s2l_fec_tunnel_id",
                                                "s2l_fec_vrf") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.S2LFec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.S2LFec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.s2l_fec_ctype.is_set or
                                    self.s2l_fec_dest.is_set or
                                    self.s2l_fec_extended_tunnel_id.is_set or
                                    self.s2l_fec_lsp_id.is_set or
                                    self.s2l_fec_p2mp_id.is_set or
                                    self.s2l_fec_source.is_set or
                                    self.s2l_fec_subgroup_id.is_set or
                                    self.s2l_fec_subgroup_originator.is_set or
                                    self.s2l_fec_tunnel_id.is_set or
                                    self.s2l_fec_vrf.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.s2l_fec_ctype.yfilter != YFilter.not_set or
                                    self.s2l_fec_dest.yfilter != YFilter.not_set or
                                    self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_lsp_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_p2mp_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_source.yfilter != YFilter.not_set or
                                    self.s2l_fec_subgroup_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set or
                                    self.s2l_fec_tunnel_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_vrf.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-fec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.s2l_fec_ctype.is_set or self.s2l_fec_ctype.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_ctype.get_name_leafdata())
                                if (self.s2l_fec_dest.is_set or self.s2l_fec_dest.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_dest.get_name_leafdata())
                                if (self.s2l_fec_extended_tunnel_id.is_set or self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_extended_tunnel_id.get_name_leafdata())
                                if (self.s2l_fec_lsp_id.is_set or self.s2l_fec_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_lsp_id.get_name_leafdata())
                                if (self.s2l_fec_p2mp_id.is_set or self.s2l_fec_p2mp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_p2mp_id.get_name_leafdata())
                                if (self.s2l_fec_source.is_set or self.s2l_fec_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_source.get_name_leafdata())
                                if (self.s2l_fec_subgroup_id.is_set or self.s2l_fec_subgroup_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_subgroup_id.get_name_leafdata())
                                if (self.s2l_fec_subgroup_originator.is_set or self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_subgroup_originator.get_name_leafdata())
                                if (self.s2l_fec_tunnel_id.is_set or self.s2l_fec_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_tunnel_id.get_name_leafdata())
                                if (self.s2l_fec_vrf.is_set or self.s2l_fec_vrf.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_vrf.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "s2l-fec-ctype" or name == "s2l-fec-dest" or name == "s2l-fec-extended-tunnel-id" or name == "s2l-fec-lsp-id" or name == "s2l-fec-p2mp-id" or name == "s2l-fec-source" or name == "s2l-fec-subgroup-id" or name == "s2l-fec-subgroup-originator" or name == "s2l-fec-tunnel-id" or name == "s2l-fec-vrf"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "s2l-fec-ctype"):
                                    self.s2l_fec_ctype = value
                                    self.s2l_fec_ctype.value_namespace = name_space
                                    self.s2l_fec_ctype.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-dest"):
                                    self.s2l_fec_dest = value
                                    self.s2l_fec_dest.value_namespace = name_space
                                    self.s2l_fec_dest.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-extended-tunnel-id"):
                                    self.s2l_fec_extended_tunnel_id = value
                                    self.s2l_fec_extended_tunnel_id.value_namespace = name_space
                                    self.s2l_fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-lsp-id"):
                                    self.s2l_fec_lsp_id = value
                                    self.s2l_fec_lsp_id.value_namespace = name_space
                                    self.s2l_fec_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-p2mp-id"):
                                    self.s2l_fec_p2mp_id = value
                                    self.s2l_fec_p2mp_id.value_namespace = name_space
                                    self.s2l_fec_p2mp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-source"):
                                    self.s2l_fec_source = value
                                    self.s2l_fec_source.value_namespace = name_space
                                    self.s2l_fec_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-subgroup-id"):
                                    self.s2l_fec_subgroup_id = value
                                    self.s2l_fec_subgroup_id.value_namespace = name_space
                                    self.s2l_fec_subgroup_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-subgroup-originator"):
                                    self.s2l_fec_subgroup_originator = value
                                    self.s2l_fec_subgroup_originator.value_namespace = name_space
                                    self.s2l_fec_subgroup_originator.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-tunnel-id"):
                                    self.s2l_fec_tunnel_id = value
                                    self.s2l_fec_tunnel_id.value_namespace = name_space
                                    self.s2l_fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-vrf"):
                                    self.s2l_fec_vrf = value
                                    self.s2l_fec_vrf.value_namespace = name_space
                                    self.s2l_fec_vrf.value_namespace_prefix = name_space_prefix


                        class ActivePathOption(Entity):
                            """
                            The path option used to find the path for this
                            S2L
                            
                            .. attribute:: attribute_set
                            
                            	The path option attribute set used by this path
                            	**type**\:   :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet>`
                            
                            .. attribute:: attribute_set_found
                            
                            	TRUE if the path has found the defined attribute set
                            	**type**\:  bool
                            
                            .. attribute:: explicit_path_id
                            
                            	Explicit Path ID, this is the key to table ExplicitPaths.IdentifierTable
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: explicit_path_name
                            
                            	Explicit Path Name, this is the key to table ExplicitPaths.NameTable
                            	**type**\:  str
                            
                            .. attribute:: has_attribute_set
                            
                            	TRUE if the path has an attribute set defined
                            	**type**\:  bool
                            
                            .. attribute:: has_xro_attribute_set
                            
                            	TRUE if the path has an XRO attribute set configured
                            	**type**\:  bool
                            
                            .. attribute:: holddown_duration
                            
                            	Holddown Duration (seconds)
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            	**units**\: second
                            
                            .. attribute:: is_disabled
                            
                            	TRUE if the path option is disabled
                            	**type**\:  bool
                            
                            .. attribute:: is_helddown
                            
                            	TRUE if path is helddown
                            	**type**\:  bool
                            
                            .. attribute:: is_lockdown
                            
                            	TRUE if the path is locked down
                            	**type**\:  bool
                            
                            .. attribute:: is_segment_routing
                            
                            	TRUE if the path is Segment\-Routing
                            	**type**\:  bool
                            
                            .. attribute:: is_strict_explicit_path
                            
                            	TRUE if explicit path is strict
                            	**type**\:  bool
                            
                            .. attribute:: is_verbatim
                            
                            	TRUE if the path is verbatim
                            	**type**\:  bool
                            
                            .. attribute:: option_index
                            
                            	Path option index
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: option_index_is_valid
                            
                            	The path option index is valid
                            	**type**\:  bool
                            
                            .. attribute:: path_calculation_error
                            
                            	Path computation information
                            	**type**\: list of    :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.PathCalculationError>`
                            
                            .. attribute:: path_option_area_id
                            
                            	The path\-option area constraint
                            	**type**\:  str
                            
                            .. attribute:: path_option_name
                            
                            	Path option name
                            	**type**\:  str
                            
                            .. attribute:: path_option_type
                            
                            	Path option type
                            	**type**\:   :py:class:`MplsTePathoption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathoption>`
                            
                            .. attribute:: pce_address
                            
                            	PCE server address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: protected_by_path_option_index
                            
                            	Path option index for Protect path options
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: remerge_error
                            
                            	Path computation remerge resolve info
                            	**type**\: list of    :py:class:`RemergeError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.RemergeError>`
                            
                            .. attribute:: restored_from_path_option_index
                            
                            	Path option index for Restore path options
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: signalling_error
                            
                            	Signalling information
                            	**type**\: list of    :py:class:`SignallingError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.SignallingError>`
                            
                            .. attribute:: xro_attribute_set
                            
                            	The XRO attribute set used by this path\-option
                            	**type**\:   :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet>`
                            
                            .. attribute:: xro_attribute_set_found
                            
                            	TRUE if the path's XRO attribute set is known
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption, self).__init__()

                                self.yang_name = "active-path-option"
                                self.yang_parent_name = "s2l"

                                self.attribute_set_found = YLeaf(YType.boolean, "attribute-set-found")

                                self.explicit_path_id = YLeaf(YType.uint16, "explicit-path-id")

                                self.explicit_path_name = YLeaf(YType.str, "explicit-path-name")

                                self.has_attribute_set = YLeaf(YType.boolean, "has-attribute-set")

                                self.has_xro_attribute_set = YLeaf(YType.boolean, "has-xro-attribute-set")

                                self.holddown_duration = YLeaf(YType.uint16, "holddown-duration")

                                self.is_disabled = YLeaf(YType.boolean, "is-disabled")

                                self.is_helddown = YLeaf(YType.boolean, "is-helddown")

                                self.is_lockdown = YLeaf(YType.boolean, "is-lockdown")

                                self.is_segment_routing = YLeaf(YType.boolean, "is-segment-routing")

                                self.is_strict_explicit_path = YLeaf(YType.boolean, "is-strict-explicit-path")

                                self.is_verbatim = YLeaf(YType.boolean, "is-verbatim")

                                self.option_index = YLeaf(YType.uint32, "option-index")

                                self.option_index_is_valid = YLeaf(YType.boolean, "option-index-is-valid")

                                self.path_option_area_id = YLeaf(YType.str, "path-option-area-id")

                                self.path_option_name = YLeaf(YType.str, "path-option-name")

                                self.path_option_type = YLeaf(YType.enumeration, "path-option-type")

                                self.pce_address = YLeaf(YType.str, "pce-address")

                                self.protected_by_path_option_index = YLeaf(YType.uint32, "protected-by-path-option-index")

                                self.restored_from_path_option_index = YLeaf(YType.uint32, "restored-from-path-option-index")

                                self.xro_attribute_set_found = YLeaf(YType.boolean, "xro-attribute-set-found")

                                self.attribute_set = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet()
                                self.attribute_set.parent = self
                                self._children_name_map["attribute_set"] = "attribute-set"
                                self._children_yang_names.add("attribute-set")

                                self.xro_attribute_set = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet()
                                self.xro_attribute_set.parent = self
                                self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                                self._children_yang_names.add("xro-attribute-set")

                                self.path_calculation_error = YList(self)
                                self.remerge_error = YList(self)
                                self.signalling_error = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("attribute_set_found",
                                                "explicit_path_id",
                                                "explicit_path_name",
                                                "has_attribute_set",
                                                "has_xro_attribute_set",
                                                "holddown_duration",
                                                "is_disabled",
                                                "is_helddown",
                                                "is_lockdown",
                                                "is_segment_routing",
                                                "is_strict_explicit_path",
                                                "is_verbatim",
                                                "option_index",
                                                "option_index_is_valid",
                                                "path_option_area_id",
                                                "path_option_name",
                                                "path_option_type",
                                                "pce_address",
                                                "protected_by_path_option_index",
                                                "restored_from_path_option_index",
                                                "xro_attribute_set_found") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption, self).__setattr__(name, value)


                            class AttributeSet(Entity):
                                """
                                The path option attribute set used by this path
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion>`
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\:  str
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet, self).__init__()

                                    self.yang_name = "attribute-set"
                                    self.yang_parent_name = "active-path-option"

                                    self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                                    self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                                    self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._children_yang_names.add("attribute-set-union")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("tunnel_attribute_set_name",
                                                    "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet, self).__setattr__(name, value)


                                class AttributeSetUnion(Entity):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "attribute-set"

                                        self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                                        self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                        self._children_yang_names.add("attribute-set-aps-pp")

                                        self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                        self._children_yang_names.add("attribute-set-autobackup")

                                        self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                        self._children_yang_names.add("attribute-set-automesh")

                                        self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                        self._children_yang_names.add("attribute-set-p2mpte")

                                        self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._children_yang_names.add("attribute-set-p2p-te")

                                        self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                        self._children_yang_names.add("attribute-set-path-option")

                                        self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                        self._children_yang_names.add("attribute-set-xro")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                                    class AttributeSetPathOption(Entity):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\:  str
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                            self.generation = YLeaf(YType.uint32, "generation")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                            self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                            self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                            self._children_yang_names.add("bfd-reverse-path")

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bandwidth_type",
                                                            "configured_bandwidth",
                                                            "cost_limit",
                                                            "dste_class_type",
                                                            "exclude_list_name",
                                                            "generation",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_bfd_reverse_pat_configured",
                                                            "is_cost_limit_configured",
                                                            "is_exclude_list_name_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "path_invalidation_action",
                                                            "path_invalidation_timeout",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class BfdReversePath(Entity):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.binding_label = YLeaf(YType.uint32, "binding-label")

                                                self.path_type = YLeaf(YType.enumeration, "path-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("binding_label",
                                                                "path_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.binding_label.is_set or
                                                    self.path_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.binding_label.yfilter != YFilter.not_set or
                                                    self.path_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "bfd-reverse-path" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.binding_label.get_name_leafdata())
                                                if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.path_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "binding-label" or name == "path-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "binding-label"):
                                                    self.binding_label = value
                                                    self.binding_label.value_namespace = name_space
                                                    self.binding_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "path-type"):
                                                    self.path_type = value
                                                    self.path_type.value_namespace = name_space
                                                    self.path_type.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class VersionInfo(Entity):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\:  str
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.attribute_type = YLeaf(YType.str, "attribute-type")

                                                self.generation = YLeaf(YType.uint32, "generation")

                                                self.is_default = YLeaf(YType.boolean, "is-default")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("attribute_type",
                                                                "generation",
                                                                "is_default") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.attribute_type.is_set or
                                                    self.generation.is_set or
                                                    self.is_default.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.attribute_type.yfilter != YFilter.not_set or
                                                    self.generation.yfilter != YFilter.not_set or
                                                    self.is_default.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "version-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                                if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.generation.get_name_leafdata())
                                                if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_default.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "attribute-type"):
                                                    self.attribute_type = value
                                                    self.attribute_type.value_namespace = name_space
                                                    self.attribute_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "generation"):
                                                    self.generation = value
                                                    self.generation.value_namespace = name_space
                                                    self.generation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-default"):
                                                    self.is_default = value
                                                    self.is_default.value_namespace = name_space
                                                    self.is_default.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.bandwidth_type.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.cost_limit.is_set or
                                                self.dste_class_type.is_set or
                                                self.exclude_list_name.is_set or
                                                self.generation.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_bfd_reverse_pat_configured.is_set or
                                                self.is_cost_limit_configured.is_set or
                                                self.is_exclude_list_name_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.path_invalidation_action.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bandwidth_type.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.cost_limit.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.exclude_list_name.yfilter != YFilter.not_set or
                                                self.generation.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                                self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                                self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-path-option" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.generation.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                            if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                            if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "bfd-reverse-path"):
                                                if (self.bfd_reverse_path is None):
                                                    self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                                    self.bfd_reverse_path.parent = self
                                                    self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                                return self.bfd_reverse_path

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            if (child_yang_name == "version-info"):
                                                for c in self.version_info:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.version_info.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bandwidth-type"):
                                                self.bandwidth_type = value
                                                self.bandwidth_type.value_namespace = name_space
                                                self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "cost-limit"):
                                                self.cost_limit = value
                                                self.cost_limit.value_namespace = name_space
                                                self.cost_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exclude-list-name"):
                                                self.exclude_list_name = value
                                                self.exclude_list_name.value_namespace = name_space
                                                self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "generation"):
                                                self.generation = value
                                                self.generation.value_namespace = name_space
                                                self.generation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bfd-reverse-pat-configured"):
                                                self.is_bfd_reverse_pat_configured = value
                                                self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                                self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-cost-limit-configured"):
                                                self.is_cost_limit_configured = value
                                                self.is_cost_limit_configured.value_namespace = name_space
                                                self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-exclude-list-name-configured"):
                                                self.is_exclude_list_name_configured = value
                                                self.is_exclude_list_name_configured.value_namespace = name_space
                                                self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-action"):
                                                self.path_invalidation_action = value
                                                self.path_invalidation_action.value_namespace = name_space
                                                self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutobackup(Entity):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.signalled_name = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"
                                            self._children_yang_names.add("signalled-name")

                                            self.policy_class_entry = YList(self)
                                            self.protected_interface = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_priority",
                                                            "is_affinity_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "is_signalled_name_configured",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                                        class SignalledName(Entity):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\:  bool
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\:  str
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                                self.name = YLeaf(YType.str, "name")

                                                self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                                self.source_type = YLeaf(YType.enumeration, "source-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("is_mp_addresses",
                                                                "name",
                                                                "protected_interface_type",
                                                                "source_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.is_mp_addresses.is_set or
                                                    self.name.is_set or
                                                    self.protected_interface_type.is_set or
                                                    self.source_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.is_mp_addresses.yfilter != YFilter.not_set or
                                                    self.name.yfilter != YFilter.not_set or
                                                    self.protected_interface_type.yfilter != YFilter.not_set or
                                                    self.source_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "signalled-name" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.name.get_name_leafdata())
                                                if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                                if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.source_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "is-mp-addresses"):
                                                    self.is_mp_addresses = value
                                                    self.is_mp_addresses.value_namespace = name_space
                                                    self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                                if(value_path == "name"):
                                                    self.name = value
                                                    self.name.value_namespace = name_space
                                                    self.name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "protected-interface-type"):
                                                    self.protected_interface_type = value
                                                    self.protected_interface_type.value_namespace = name_space
                                                    self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "source-type"):
                                                    self.source_type = value
                                                    self.source_type.value_namespace = name_space
                                                    self.source_type.value_namespace_prefix = name_space_prefix


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class ProtectedInterface(Entity):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.protected_interface = YLeaf(YType.str, "protected-interface")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("protected_interface") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.protected_interface.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.protected_interface.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "protected-interface" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "protected-interface"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "protected-interface"):
                                                    self.protected_interface = value
                                                    self.protected_interface.value_namespace = name_space
                                                    self.protected_interface.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.is_signalled_name_configured.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.signalled_name is not None and self.signalled_name.has_data()))

                                        def has_operation(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.signalled_name is not None and self.signalled_name.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-autobackup" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "protected-interface"):
                                                for c in self.protected_interface:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.protected_interface.append(c)
                                                return c

                                            if (child_yang_name == "signalled-name"):
                                                if (self.signalled_name is None):
                                                    self.signalled_name = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                                    self.signalled_name.parent = self
                                                    self._children_name_map["signalled_name"] = "signalled-name"
                                                return self.signalled_name

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-signalled-name-configured"):
                                                self.is_signalled_name_configured = value
                                                self.is_signalled_name_configured.value_namespace = name_space
                                                self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutomesh(Entity):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\:  bool
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\:  bool
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                            self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                            self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.forward_class = YLeaf(YType.uint32, "forward-class")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.load_share = YLeaf(YType.uint32, "load-share")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.mesh_group_id = YList(self)
                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("auto_bandwidth_collect",
                                                            "auto_route_announce",
                                                            "bandwidth",
                                                            "configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "forward_class",
                                                            "frr_bandwidth_protection",
                                                            "frr_node_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_interface_bw_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "load_share",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority",
                                                            "soft_preemption_configured") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class MeshGroupId(Entity):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint32, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "mesh-group-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.auto_bandwidth_collect.is_set or
                                                self.auto_route_announce.is_set or
                                                self.bandwidth.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.forward_class.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.frr_node_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_interface_bw_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.load_share.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                self.soft_preemption_configured.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()))

                                        def has_operation(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                                self.auto_route_announce.yfilter != YFilter.not_set or
                                                self.bandwidth.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.forward_class.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.frr_node_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.load_share.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                self.soft_preemption_configured.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-automesh" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                            if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                            if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.forward_class.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.load_share.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                            if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "mesh-group-id"):
                                                for c in self.mesh_group_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.mesh_group_id.append(c)
                                                return c

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "auto-bandwidth-collect"):
                                                self.auto_bandwidth_collect = value
                                                self.auto_bandwidth_collect.value_namespace = name_space
                                                self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                            if(value_path == "auto-route-announce"):
                                                self.auto_route_announce = value
                                                self.auto_route_announce.value_namespace = name_space
                                                self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                            if(value_path == "bandwidth"):
                                                self.bandwidth = value
                                                self.bandwidth.value_namespace = name_space
                                                self.bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "forward-class"):
                                                self.forward_class = value
                                                self.forward_class.value_namespace = name_space
                                                self.forward_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-node-protection"):
                                                self.frr_node_protection = value
                                                self.frr_node_protection.value_namespace = name_space
                                                self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-interface-bw-configured"):
                                                self.is_interface_bw_configured = value
                                                self.is_interface_bw_configured.value_namespace = name_space
                                                self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "load-share"):
                                                self.load_share = value
                                                self.load_share.value_namespace = name_space
                                                self.load_share.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "soft-preemption-configured"):
                                                self.soft_preemption_configured = value
                                                self.soft_preemption_configured.value_namespace = name_space
                                                self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                                    class AttributeSetXro(Entity):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._children_yang_names.add("xro")


                                        class Xro(Entity):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\:  bool
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"

                                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                                self.xro_subobject = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                            class XroSubobject(Entity):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                    self.as_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"
                                                    self._children_yang_names.add("as-subobject")

                                                    self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                    self._children_yang_names.add("ipv4-subobject")

                                                    self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                    self._children_yang_names.add("ipv6-subobject")

                                                    self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._children_yang_names.add("lsp-subobject")

                                                    self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                    self._children_yang_names.add("srlg-subobject")

                                                    self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                    self._children_yang_names.add("unnumbered-subobject")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                                class Ipv4Subobject(Entity):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv4-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class Ipv6Subobject(Entity):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv6-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class UnnumberedSubobject(Entity):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("attribute",
                                                                        "exclusion_type",
                                                                        "interface_id",
                                                                        "te_router_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.interface_id.is_set or
                                                            self.te_router_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.interface_id.yfilter != YFilter.not_set or
                                                            self.te_router_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "unnumbered-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "interface-id"):
                                                            self.interface_id = value
                                                            self.interface_id.value_namespace = name_space
                                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "te-router-id"):
                                                            self.te_router_id = value
                                                            self.te_router_id.value_namespace = name_space
                                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                                class AsSubobject(Entity):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("as_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.as_number.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.as_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "as-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "as-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "as-number"):
                                                            self.as_number = value
                                                            self.as_number.value_namespace = name_space
                                                            self.as_number.value_namespace_prefix = name_space_prefix


                                                class SrlgSubobject(Entity):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("exclusion_type",
                                                                        "srlg_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.exclusion_type.is_set or
                                                            self.srlg_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.srlg_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "srlg-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "exclusion-type" or name == "srlg-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "srlg-id"):
                                                            self.srlg_id = value
                                                            self.srlg_id.value_namespace = name_space
                                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                                class LspSubobject(Entity):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                                        self.fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._children_yang_names.add("fec")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("destination_node_exception",
                                                                        "exclusion_type",
                                                                        "ignore_lsp_id",
                                                                        "penultimate_node_exception",
                                                                        "processing_node_exception") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                                    class Fec(Entity):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\:  str
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"

                                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                            self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._children_yang_names.add("fec-destination-info")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("fec_extended_tunnel_id",
                                                                            "fec_lsp_id",
                                                                            "fec_source",
                                                                            "fec_tunnel_id",
                                                                            "fec_vrf") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                                        class FecDestinationInfo(Entity):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\:  str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"

                                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("fec_ctype",
                                                                                "fec_destination_p2mp_id",
                                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.fec_ctype.is_set or
                                                                    self.fec_destination_p2mp_id.is_set or
                                                                    self.p2p_lsp_destination.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "fec-destination-info" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "fec-ctype"):
                                                                    self.fec_ctype = value
                                                                    self.fec_ctype.value_namespace = name_space
                                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "fec-destination-p2mp-id"):
                                                                    self.fec_destination_p2mp_id = value
                                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "p2p-lsp-destination"):
                                                                    self.p2p_lsp_destination = value
                                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.fec_extended_tunnel_id.is_set or
                                                                self.fec_lsp_id.is_set or
                                                                self.fec_source.is_set or
                                                                self.fec_tunnel_id.is_set or
                                                                self.fec_vrf.is_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                                self.fec_source.yfilter != YFilter.not_set or
                                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "fec" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "fec-destination-info"):
                                                                if (self.fec_destination_info is None):
                                                                    self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                                    self.fec_destination_info.parent = self
                                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                                return self.fec_destination_info

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "fec-extended-tunnel-id"):
                                                                self.fec_extended_tunnel_id = value
                                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-lsp-id"):
                                                                self.fec_lsp_id = value
                                                                self.fec_lsp_id.value_namespace = name_space
                                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-source"):
                                                                self.fec_source = value
                                                                self.fec_source.value_namespace = name_space
                                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-tunnel-id"):
                                                                self.fec_tunnel_id = value
                                                                self.fec_tunnel_id.value_namespace = name_space
                                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-vrf"):
                                                                self.fec_vrf = value
                                                                self.fec_vrf.value_namespace = name_space
                                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.destination_node_exception.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.ignore_lsp_id.is_set or
                                                            self.penultimate_node_exception.is_set or
                                                            self.processing_node_exception.is_set or
                                                            (self.fec is not None and self.fec.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                                            (self.fec is not None and self.fec.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsp-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "fec"):
                                                            if (self.fec is None):
                                                                self.fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                                self.fec.parent = self
                                                                self._children_name_map["fec"] = "fec"
                                                            return self.fec

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "destination-node-exception"):
                                                            self.destination_node_exception = value
                                                            self.destination_node_exception.value_namespace = name_space
                                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ignore-lsp-id"):
                                                            self.ignore_lsp_id = value
                                                            self.ignore_lsp_id.value_namespace = name_space
                                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "penultimate-node-exception"):
                                                            self.penultimate_node_exception = value
                                                            self.penultimate_node_exception.value_namespace = name_space
                                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "processing-node-exception"):
                                                            self.processing_node_exception = value
                                                            self.processing_node_exception.value_namespace = name_space
                                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.type.is_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "xro-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "as-subobject"):
                                                        if (self.as_subobject is None):
                                                            self.as_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                            self.as_subobject.parent = self
                                                            self._children_name_map["as_subobject"] = "as-subobject"
                                                        return self.as_subobject

                                                    if (child_yang_name == "ipv4-subobject"):
                                                        if (self.ipv4_subobject is None):
                                                            self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                            self.ipv4_subobject.parent = self
                                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                        return self.ipv4_subobject

                                                    if (child_yang_name == "ipv6-subobject"):
                                                        if (self.ipv6_subobject is None):
                                                            self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                            self.ipv6_subobject.parent = self
                                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                        return self.ipv6_subobject

                                                    if (child_yang_name == "lsp-subobject"):
                                                        if (self.lsp_subobject is None):
                                                            self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                            self.lsp_subobject.parent = self
                                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                        return self.lsp_subobject

                                                    if (child_yang_name == "srlg-subobject"):
                                                        if (self.srlg_subobject is None):
                                                            self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                            self.srlg_subobject.parent = self
                                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                        return self.srlg_subobject

                                                    if (child_yang_name == "unnumbered-subobject"):
                                                        if (self.unnumbered_subobject is None):
                                                            self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                            self.unnumbered_subobject.parent = self
                                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                        return self.unnumbered_subobject

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_data()):
                                                        return True
                                                return self.mutual_diversity_flag.is_set

                                            def has_operation(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "xro" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "xro-subobject"):
                                                    for c in self.xro_subobject:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.xro_subobject.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "mutual-diversity-flag"):
                                                    self.mutual_diversity_flag = value
                                                    self.mutual_diversity_flag.value_namespace = name_space
                                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (self.xro is not None and self.xro.has_data())

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.xro is not None and self.xro.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-xro" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "xro"):
                                                if (self.xro is None):
                                                    self.xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                                    self.xro.parent = self
                                                    self._children_name_map["xro"] = "xro"
                                                return self.xro

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "xro"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class AttributeSetP2Mpte(Entity):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "frr_bandwidth_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_priority_configured",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2mpte" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetApsPp(Entity):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                            self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                            self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                            self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                            self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                            self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                            self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                            self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                            self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._children_yang_names.add("revert-schedule")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_off_time",
                                                            "path_prot_profile_type",
                                                            "protection_mode",
                                                            "protection_type",
                                                            "restoration_style",
                                                            "snc_mode",
                                                            "tcm_id",
                                                            "wait_to_restore_time") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                                        class RevertSchedule(Entity):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"

                                                self.duration = YLeaf(YType.uint32, "duration")

                                                self.max_tries = YLeaf(YType.uint32, "max-tries")

                                                self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                                self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                                self.schedulename = YLeaf(YType.str, "schedulename")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("duration",
                                                                "max_tries",
                                                                "schedule_date",
                                                                "schedule_frequency",
                                                                "schedulename") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.duration.is_set or
                                                    self.max_tries.is_set or
                                                    self.schedule_date.is_set or
                                                    self.schedule_frequency.is_set or
                                                    self.schedulename.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.duration.yfilter != YFilter.not_set or
                                                    self.max_tries.yfilter != YFilter.not_set or
                                                    self.schedule_date.yfilter != YFilter.not_set or
                                                    self.schedule_frequency.yfilter != YFilter.not_set or
                                                    self.schedulename.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "revert-schedule" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.duration.get_name_leafdata())
                                                if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_tries.get_name_leafdata())
                                                if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                                if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                                if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedulename.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "duration"):
                                                    self.duration = value
                                                    self.duration.value_namespace = name_space
                                                    self.duration.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-tries"):
                                                    self.max_tries = value
                                                    self.max_tries.value_namespace = name_space
                                                    self.max_tries.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-date"):
                                                    self.schedule_date = value
                                                    self.schedule_date.value_namespace = name_space
                                                    self.schedule_date.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-frequency"):
                                                    self.schedule_frequency = value
                                                    self.schedule_frequency.value_namespace = name_space
                                                    self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedulename"):
                                                    self.schedulename = value
                                                    self.schedulename.value_namespace = name_space
                                                    self.schedulename.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.hold_off_time.is_set or
                                                self.path_prot_profile_type.is_set or
                                                self.protection_mode.is_set or
                                                self.protection_type.is_set or
                                                self.restoration_style.is_set or
                                                self.snc_mode.is_set or
                                                self.tcm_id.is_set or
                                                self.wait_to_restore_time.is_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_off_time.yfilter != YFilter.not_set or
                                                self.path_prot_profile_type.yfilter != YFilter.not_set or
                                                self.protection_mode.yfilter != YFilter.not_set or
                                                self.protection_type.yfilter != YFilter.not_set or
                                                self.restoration_style.yfilter != YFilter.not_set or
                                                self.snc_mode.yfilter != YFilter.not_set or
                                                self.tcm_id.yfilter != YFilter.not_set or
                                                self.wait_to_restore_time.yfilter != YFilter.not_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-aps-pp" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                            if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                            if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                            if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_type.get_name_leafdata())
                                            if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                            if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                            if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                            if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "revert-schedule"):
                                                if (self.revert_schedule is None):
                                                    self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                                    self.revert_schedule.parent = self
                                                    self._children_name_map["revert_schedule"] = "revert-schedule"
                                                return self.revert_schedule

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-off-time"):
                                                self.hold_off_time = value
                                                self.hold_off_time.value_namespace = name_space
                                                self.hold_off_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-prot-profile-type"):
                                                self.path_prot_profile_type = value
                                                self.path_prot_profile_type.value_namespace = name_space
                                                self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-mode"):
                                                self.protection_mode = value
                                                self.protection_mode.value_namespace = name_space
                                                self.protection_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-type"):
                                                self.protection_type = value
                                                self.protection_type.value_namespace = name_space
                                                self.protection_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "restoration-style"):
                                                self.restoration_style = value
                                                self.restoration_style.value_namespace = name_space
                                                self.restoration_style.value_namespace_prefix = name_space_prefix
                                            if(value_path == "snc-mode"):
                                                self.snc_mode = value
                                                self.snc_mode.value_namespace = name_space
                                                self.snc_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcm-id"):
                                                self.tcm_id = value
                                                self.tcm_id.value_namespace = name_space
                                                self.tcm_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "wait-to-restore-time"):
                                                self.wait_to_restore_time = value
                                                self.wait_to_restore_time.value_namespace = name_space
                                                self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                                    class AttributeSetP2PTe(Entity):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                            self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                            self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                            self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                            self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                            self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                            self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                            self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                            self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                            self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.prepend_list = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"
                                            self._children_yang_names.add("prepend-list")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_affinity_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_path_select_configured",
                                                            "is_path_selection_metric_configured",
                                                            "is_path_selection_segment_routing_adjacency_protection_configured",
                                                            "is_path_selection_segment_routing_margin_configured",
                                                            "is_path_selection_segment_routing_margin_relative",
                                                            "is_path_selection_segment_routing_segment_limit_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "is_prepend_list_configured",
                                                            "path_invalidation_timeout",
                                                            "path_selection_invalidation_action",
                                                            "path_selection_metric",
                                                            "path_selection_segment_routing_adjacency_protection",
                                                            "path_selection_segment_routing_margin",
                                                            "path_selection_segment_routing_segment_limit",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PrependList(Entity):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.prepend_entry = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in () and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                            class PrependEntry(Entity):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"

                                                    self.index = YLeaf(YType.uint32, "index")

                                                    self.next_label = YLeaf(YType.uint32, "next-label")

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("index",
                                                                    "next_label",
                                                                    "type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.index.is_set or
                                                        self.next_label.is_set or
                                                        self.type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.index.yfilter != YFilter.not_set or
                                                        self.next_label.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "prepend-entry" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.index.get_name_leafdata())
                                                    if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.next_label.get_name_leafdata())
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "index" or name == "next-label" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "index"):
                                                        self.index = value
                                                        self.index.value_namespace = name_space
                                                        self.index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "next-label"):
                                                        self.next_label = value
                                                        self.next_label.value_namespace = name_space
                                                        self.next_label.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_data()):
                                                        return True
                                                return False

                                            def has_operation(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_operation()):
                                                        return True
                                                return self.yfilter != YFilter.not_set

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prepend-list" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "prepend-entry"):
                                                    for c in self.prepend_entry:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.prepend_entry.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "prepend-entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                pass


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.is_affinity_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_path_select_configured.is_set or
                                                self.is_path_selection_metric_configured.is_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_relative.is_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.is_prepend_list_configured.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.path_selection_invalidation_action.is_set or
                                                self.path_selection_metric.is_set or
                                                self.path_selection_segment_routing_adjacency_protection.is_set or
                                                self.path_selection_segment_routing_margin.is_set or
                                                self.path_selection_segment_routing_segment_limit.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.prepend_list is not None and self.prepend_list.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_path_select_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_selection_metric.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.prepend_list is not None and self.prepend_list.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2p-te" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                            if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                            if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                            if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                            if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                            if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "prepend-list"):
                                                if (self.prepend_list is None):
                                                    self.prepend_list = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                                    self.prepend_list.parent = self
                                                    self._children_name_map["prepend_list"] = "prepend-list"
                                                return self.prepend_list

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-select-configured"):
                                                self.is_path_select_configured = value
                                                self.is_path_select_configured.value_namespace = name_space
                                                self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-metric-configured"):
                                                self.is_path_selection_metric_configured = value
                                                self.is_path_selection_metric_configured.value_namespace = name_space
                                                self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                                self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                                self.is_path_selection_segment_routing_margin_configured = value
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                                self.is_path_selection_segment_routing_margin_relative = value
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                                self.is_path_selection_segment_routing_segment_limit_configured = value
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-prepend-list-configured"):
                                                self.is_prepend_list_configured = value
                                                self.is_prepend_list_configured.value_namespace = name_space
                                                self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-invalidation-action"):
                                                self.path_selection_invalidation_action = value
                                                self.path_selection_invalidation_action.value_namespace = name_space
                                                self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-metric"):
                                                self.path_selection_metric = value
                                                self.path_selection_metric.value_namespace = name_space
                                                self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                                self.path_selection_segment_routing_adjacency_protection = value
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-margin"):
                                                self.path_selection_segment_routing_margin = value
                                                self.path_selection_segment_routing_margin.value_namespace = name_space
                                                self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-segment-limit"):
                                                self.path_selection_segment_routing_segment_limit = value
                                                self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                                self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.tunnel_attribute_set_type.is_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-union" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "attribute-set-aps-pp"):
                                            if (self.attribute_set_aps_pp is None):
                                                self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                                self.attribute_set_aps_pp.parent = self
                                                self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                            return self.attribute_set_aps_pp

                                        if (child_yang_name == "attribute-set-autobackup"):
                                            if (self.attribute_set_autobackup is None):
                                                self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                                self.attribute_set_autobackup.parent = self
                                                self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                            return self.attribute_set_autobackup

                                        if (child_yang_name == "attribute-set-automesh"):
                                            if (self.attribute_set_automesh is None):
                                                self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                                self.attribute_set_automesh.parent = self
                                                self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                            return self.attribute_set_automesh

                                        if (child_yang_name == "attribute-set-p2mpte"):
                                            if (self.attribute_set_p2mpte is None):
                                                self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                                self.attribute_set_p2mpte.parent = self
                                                self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                            return self.attribute_set_p2mpte

                                        if (child_yang_name == "attribute-set-p2p-te"):
                                            if (self.attribute_set_p2p_te is None):
                                                self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                                self.attribute_set_p2p_te.parent = self
                                                self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                            return self.attribute_set_p2p_te

                                        if (child_yang_name == "attribute-set-path-option"):
                                            if (self.attribute_set_path_option is None):
                                                self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                                self.attribute_set_path_option.parent = self
                                                self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                            return self.attribute_set_path_option

                                        if (child_yang_name == "attribute-set-xro"):
                                            if (self.attribute_set_xro is None):
                                                self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                                self.attribute_set_xro.parent = self
                                                self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                            return self.attribute_set_xro

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "tunnel-attribute-set-type"):
                                            self.tunnel_attribute_set_type = value
                                            self.tunnel_attribute_set_type.value_namespace = name_space
                                            self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.tunnel_attribute_set_name.is_set or
                                        self.tunnel_attribute_set_name_crc32.is_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "attribute-set" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                                    if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "attribute-set-union"):
                                        if (self.attribute_set_union is None):
                                            self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion()
                                            self.attribute_set_union.parent = self
                                            self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                        return self.attribute_set_union

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "tunnel-attribute-set-name"):
                                        self.tunnel_attribute_set_name = value
                                        self.tunnel_attribute_set_name.value_namespace = name_space
                                        self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-attribute-set-name-crc32"):
                                        self.tunnel_attribute_set_name_crc32 = value
                                        self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                                        self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                            class XroAttributeSet(Entity):
                                """
                                The XRO attribute set used by this path\-option
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion>`
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\:  str
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet, self).__init__()

                                    self.yang_name = "xro-attribute-set"
                                    self.yang_parent_name = "active-path-option"

                                    self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                                    self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                                    self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._children_yang_names.add("attribute-set-union")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("tunnel_attribute_set_name",
                                                    "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet, self).__setattr__(name, value)


                                class AttributeSetUnion(Entity):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "xro-attribute-set"

                                        self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                                        self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                        self._children_yang_names.add("attribute-set-aps-pp")

                                        self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                        self._children_yang_names.add("attribute-set-autobackup")

                                        self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                        self._children_yang_names.add("attribute-set-automesh")

                                        self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                        self._children_yang_names.add("attribute-set-p2mpte")

                                        self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._children_yang_names.add("attribute-set-p2p-te")

                                        self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                        self._children_yang_names.add("attribute-set-path-option")

                                        self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                        self._children_yang_names.add("attribute-set-xro")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                                    class AttributeSetPathOption(Entity):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\:  str
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                            self.generation = YLeaf(YType.uint32, "generation")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                            self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                            self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                            self._children_yang_names.add("bfd-reverse-path")

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bandwidth_type",
                                                            "configured_bandwidth",
                                                            "cost_limit",
                                                            "dste_class_type",
                                                            "exclude_list_name",
                                                            "generation",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_bfd_reverse_pat_configured",
                                                            "is_cost_limit_configured",
                                                            "is_exclude_list_name_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "path_invalidation_action",
                                                            "path_invalidation_timeout",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class BfdReversePath(Entity):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.binding_label = YLeaf(YType.uint32, "binding-label")

                                                self.path_type = YLeaf(YType.enumeration, "path-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("binding_label",
                                                                "path_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.binding_label.is_set or
                                                    self.path_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.binding_label.yfilter != YFilter.not_set or
                                                    self.path_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "bfd-reverse-path" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.binding_label.get_name_leafdata())
                                                if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.path_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "binding-label" or name == "path-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "binding-label"):
                                                    self.binding_label = value
                                                    self.binding_label.value_namespace = name_space
                                                    self.binding_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "path-type"):
                                                    self.path_type = value
                                                    self.path_type.value_namespace = name_space
                                                    self.path_type.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class VersionInfo(Entity):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\:  str
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.attribute_type = YLeaf(YType.str, "attribute-type")

                                                self.generation = YLeaf(YType.uint32, "generation")

                                                self.is_default = YLeaf(YType.boolean, "is-default")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("attribute_type",
                                                                "generation",
                                                                "is_default") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.attribute_type.is_set or
                                                    self.generation.is_set or
                                                    self.is_default.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.attribute_type.yfilter != YFilter.not_set or
                                                    self.generation.yfilter != YFilter.not_set or
                                                    self.is_default.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "version-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                                if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.generation.get_name_leafdata())
                                                if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_default.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "attribute-type"):
                                                    self.attribute_type = value
                                                    self.attribute_type.value_namespace = name_space
                                                    self.attribute_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "generation"):
                                                    self.generation = value
                                                    self.generation.value_namespace = name_space
                                                    self.generation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-default"):
                                                    self.is_default = value
                                                    self.is_default.value_namespace = name_space
                                                    self.is_default.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.bandwidth_type.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.cost_limit.is_set or
                                                self.dste_class_type.is_set or
                                                self.exclude_list_name.is_set or
                                                self.generation.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_bfd_reverse_pat_configured.is_set or
                                                self.is_cost_limit_configured.is_set or
                                                self.is_exclude_list_name_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.path_invalidation_action.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bandwidth_type.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.cost_limit.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.exclude_list_name.yfilter != YFilter.not_set or
                                                self.generation.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                                self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                                self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-path-option" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.generation.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                            if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                            if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "bfd-reverse-path"):
                                                if (self.bfd_reverse_path is None):
                                                    self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                                    self.bfd_reverse_path.parent = self
                                                    self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                                return self.bfd_reverse_path

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            if (child_yang_name == "version-info"):
                                                for c in self.version_info:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.version_info.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bandwidth-type"):
                                                self.bandwidth_type = value
                                                self.bandwidth_type.value_namespace = name_space
                                                self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "cost-limit"):
                                                self.cost_limit = value
                                                self.cost_limit.value_namespace = name_space
                                                self.cost_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exclude-list-name"):
                                                self.exclude_list_name = value
                                                self.exclude_list_name.value_namespace = name_space
                                                self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "generation"):
                                                self.generation = value
                                                self.generation.value_namespace = name_space
                                                self.generation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bfd-reverse-pat-configured"):
                                                self.is_bfd_reverse_pat_configured = value
                                                self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                                self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-cost-limit-configured"):
                                                self.is_cost_limit_configured = value
                                                self.is_cost_limit_configured.value_namespace = name_space
                                                self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-exclude-list-name-configured"):
                                                self.is_exclude_list_name_configured = value
                                                self.is_exclude_list_name_configured.value_namespace = name_space
                                                self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-action"):
                                                self.path_invalidation_action = value
                                                self.path_invalidation_action.value_namespace = name_space
                                                self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutobackup(Entity):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.signalled_name = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"
                                            self._children_yang_names.add("signalled-name")

                                            self.policy_class_entry = YList(self)
                                            self.protected_interface = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_priority",
                                                            "is_affinity_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "is_signalled_name_configured",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                                        class SignalledName(Entity):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\:  bool
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\:  str
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                                self.name = YLeaf(YType.str, "name")

                                                self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                                self.source_type = YLeaf(YType.enumeration, "source-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("is_mp_addresses",
                                                                "name",
                                                                "protected_interface_type",
                                                                "source_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.is_mp_addresses.is_set or
                                                    self.name.is_set or
                                                    self.protected_interface_type.is_set or
                                                    self.source_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.is_mp_addresses.yfilter != YFilter.not_set or
                                                    self.name.yfilter != YFilter.not_set or
                                                    self.protected_interface_type.yfilter != YFilter.not_set or
                                                    self.source_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "signalled-name" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.name.get_name_leafdata())
                                                if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                                if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.source_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "is-mp-addresses"):
                                                    self.is_mp_addresses = value
                                                    self.is_mp_addresses.value_namespace = name_space
                                                    self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                                if(value_path == "name"):
                                                    self.name = value
                                                    self.name.value_namespace = name_space
                                                    self.name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "protected-interface-type"):
                                                    self.protected_interface_type = value
                                                    self.protected_interface_type.value_namespace = name_space
                                                    self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "source-type"):
                                                    self.source_type = value
                                                    self.source_type.value_namespace = name_space
                                                    self.source_type.value_namespace_prefix = name_space_prefix


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class ProtectedInterface(Entity):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.protected_interface = YLeaf(YType.str, "protected-interface")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("protected_interface") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.protected_interface.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.protected_interface.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "protected-interface" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "protected-interface"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "protected-interface"):
                                                    self.protected_interface = value
                                                    self.protected_interface.value_namespace = name_space
                                                    self.protected_interface.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.is_signalled_name_configured.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.signalled_name is not None and self.signalled_name.has_data()))

                                        def has_operation(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.signalled_name is not None and self.signalled_name.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-autobackup" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "protected-interface"):
                                                for c in self.protected_interface:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.protected_interface.append(c)
                                                return c

                                            if (child_yang_name == "signalled-name"):
                                                if (self.signalled_name is None):
                                                    self.signalled_name = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                                    self.signalled_name.parent = self
                                                    self._children_name_map["signalled_name"] = "signalled-name"
                                                return self.signalled_name

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-signalled-name-configured"):
                                                self.is_signalled_name_configured = value
                                                self.is_signalled_name_configured.value_namespace = name_space
                                                self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutomesh(Entity):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\:  bool
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\:  bool
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                            self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                            self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.forward_class = YLeaf(YType.uint32, "forward-class")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.load_share = YLeaf(YType.uint32, "load-share")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.mesh_group_id = YList(self)
                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("auto_bandwidth_collect",
                                                            "auto_route_announce",
                                                            "bandwidth",
                                                            "configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "forward_class",
                                                            "frr_bandwidth_protection",
                                                            "frr_node_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_interface_bw_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "load_share",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority",
                                                            "soft_preemption_configured") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class MeshGroupId(Entity):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint32, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "mesh-group-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.auto_bandwidth_collect.is_set or
                                                self.auto_route_announce.is_set or
                                                self.bandwidth.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.forward_class.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.frr_node_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_interface_bw_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.load_share.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                self.soft_preemption_configured.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()))

                                        def has_operation(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                                self.auto_route_announce.yfilter != YFilter.not_set or
                                                self.bandwidth.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.forward_class.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.frr_node_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.load_share.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                self.soft_preemption_configured.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-automesh" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                            if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                            if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.forward_class.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.load_share.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                            if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "mesh-group-id"):
                                                for c in self.mesh_group_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.mesh_group_id.append(c)
                                                return c

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "auto-bandwidth-collect"):
                                                self.auto_bandwidth_collect = value
                                                self.auto_bandwidth_collect.value_namespace = name_space
                                                self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                            if(value_path == "auto-route-announce"):
                                                self.auto_route_announce = value
                                                self.auto_route_announce.value_namespace = name_space
                                                self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                            if(value_path == "bandwidth"):
                                                self.bandwidth = value
                                                self.bandwidth.value_namespace = name_space
                                                self.bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "forward-class"):
                                                self.forward_class = value
                                                self.forward_class.value_namespace = name_space
                                                self.forward_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-node-protection"):
                                                self.frr_node_protection = value
                                                self.frr_node_protection.value_namespace = name_space
                                                self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-interface-bw-configured"):
                                                self.is_interface_bw_configured = value
                                                self.is_interface_bw_configured.value_namespace = name_space
                                                self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "load-share"):
                                                self.load_share = value
                                                self.load_share.value_namespace = name_space
                                                self.load_share.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "soft-preemption-configured"):
                                                self.soft_preemption_configured = value
                                                self.soft_preemption_configured.value_namespace = name_space
                                                self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                                    class AttributeSetXro(Entity):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._children_yang_names.add("xro")


                                        class Xro(Entity):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\:  bool
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"

                                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                                self.xro_subobject = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                            class XroSubobject(Entity):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                    self.as_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"
                                                    self._children_yang_names.add("as-subobject")

                                                    self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                    self._children_yang_names.add("ipv4-subobject")

                                                    self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                    self._children_yang_names.add("ipv6-subobject")

                                                    self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._children_yang_names.add("lsp-subobject")

                                                    self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                    self._children_yang_names.add("srlg-subobject")

                                                    self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                    self._children_yang_names.add("unnumbered-subobject")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                                class Ipv4Subobject(Entity):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv4-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class Ipv6Subobject(Entity):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv6-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class UnnumberedSubobject(Entity):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("attribute",
                                                                        "exclusion_type",
                                                                        "interface_id",
                                                                        "te_router_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.interface_id.is_set or
                                                            self.te_router_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.interface_id.yfilter != YFilter.not_set or
                                                            self.te_router_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "unnumbered-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "interface-id"):
                                                            self.interface_id = value
                                                            self.interface_id.value_namespace = name_space
                                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "te-router-id"):
                                                            self.te_router_id = value
                                                            self.te_router_id.value_namespace = name_space
                                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                                class AsSubobject(Entity):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("as_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.as_number.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.as_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "as-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "as-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "as-number"):
                                                            self.as_number = value
                                                            self.as_number.value_namespace = name_space
                                                            self.as_number.value_namespace_prefix = name_space_prefix


                                                class SrlgSubobject(Entity):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("exclusion_type",
                                                                        "srlg_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.exclusion_type.is_set or
                                                            self.srlg_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.srlg_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "srlg-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "exclusion-type" or name == "srlg-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "srlg-id"):
                                                            self.srlg_id = value
                                                            self.srlg_id.value_namespace = name_space
                                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                                class LspSubobject(Entity):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                                        self.fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._children_yang_names.add("fec")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("destination_node_exception",
                                                                        "exclusion_type",
                                                                        "ignore_lsp_id",
                                                                        "penultimate_node_exception",
                                                                        "processing_node_exception") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                                    class Fec(Entity):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\:  str
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"

                                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                            self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._children_yang_names.add("fec-destination-info")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("fec_extended_tunnel_id",
                                                                            "fec_lsp_id",
                                                                            "fec_source",
                                                                            "fec_tunnel_id",
                                                                            "fec_vrf") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                                        class FecDestinationInfo(Entity):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\:  str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"

                                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("fec_ctype",
                                                                                "fec_destination_p2mp_id",
                                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.fec_ctype.is_set or
                                                                    self.fec_destination_p2mp_id.is_set or
                                                                    self.p2p_lsp_destination.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "fec-destination-info" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "fec-ctype"):
                                                                    self.fec_ctype = value
                                                                    self.fec_ctype.value_namespace = name_space
                                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "fec-destination-p2mp-id"):
                                                                    self.fec_destination_p2mp_id = value
                                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "p2p-lsp-destination"):
                                                                    self.p2p_lsp_destination = value
                                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.fec_extended_tunnel_id.is_set or
                                                                self.fec_lsp_id.is_set or
                                                                self.fec_source.is_set or
                                                                self.fec_tunnel_id.is_set or
                                                                self.fec_vrf.is_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                                self.fec_source.yfilter != YFilter.not_set or
                                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "fec" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "fec-destination-info"):
                                                                if (self.fec_destination_info is None):
                                                                    self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                                    self.fec_destination_info.parent = self
                                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                                return self.fec_destination_info

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "fec-extended-tunnel-id"):
                                                                self.fec_extended_tunnel_id = value
                                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-lsp-id"):
                                                                self.fec_lsp_id = value
                                                                self.fec_lsp_id.value_namespace = name_space
                                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-source"):
                                                                self.fec_source = value
                                                                self.fec_source.value_namespace = name_space
                                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-tunnel-id"):
                                                                self.fec_tunnel_id = value
                                                                self.fec_tunnel_id.value_namespace = name_space
                                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-vrf"):
                                                                self.fec_vrf = value
                                                                self.fec_vrf.value_namespace = name_space
                                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.destination_node_exception.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.ignore_lsp_id.is_set or
                                                            self.penultimate_node_exception.is_set or
                                                            self.processing_node_exception.is_set or
                                                            (self.fec is not None and self.fec.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                                            (self.fec is not None and self.fec.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsp-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "fec"):
                                                            if (self.fec is None):
                                                                self.fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                                self.fec.parent = self
                                                                self._children_name_map["fec"] = "fec"
                                                            return self.fec

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "destination-node-exception"):
                                                            self.destination_node_exception = value
                                                            self.destination_node_exception.value_namespace = name_space
                                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ignore-lsp-id"):
                                                            self.ignore_lsp_id = value
                                                            self.ignore_lsp_id.value_namespace = name_space
                                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "penultimate-node-exception"):
                                                            self.penultimate_node_exception = value
                                                            self.penultimate_node_exception.value_namespace = name_space
                                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "processing-node-exception"):
                                                            self.processing_node_exception = value
                                                            self.processing_node_exception.value_namespace = name_space
                                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.type.is_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "xro-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "as-subobject"):
                                                        if (self.as_subobject is None):
                                                            self.as_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                            self.as_subobject.parent = self
                                                            self._children_name_map["as_subobject"] = "as-subobject"
                                                        return self.as_subobject

                                                    if (child_yang_name == "ipv4-subobject"):
                                                        if (self.ipv4_subobject is None):
                                                            self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                            self.ipv4_subobject.parent = self
                                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                        return self.ipv4_subobject

                                                    if (child_yang_name == "ipv6-subobject"):
                                                        if (self.ipv6_subobject is None):
                                                            self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                            self.ipv6_subobject.parent = self
                                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                        return self.ipv6_subobject

                                                    if (child_yang_name == "lsp-subobject"):
                                                        if (self.lsp_subobject is None):
                                                            self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                            self.lsp_subobject.parent = self
                                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                        return self.lsp_subobject

                                                    if (child_yang_name == "srlg-subobject"):
                                                        if (self.srlg_subobject is None):
                                                            self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                            self.srlg_subobject.parent = self
                                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                        return self.srlg_subobject

                                                    if (child_yang_name == "unnumbered-subobject"):
                                                        if (self.unnumbered_subobject is None):
                                                            self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                            self.unnumbered_subobject.parent = self
                                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                        return self.unnumbered_subobject

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_data()):
                                                        return True
                                                return self.mutual_diversity_flag.is_set

                                            def has_operation(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "xro" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "xro-subobject"):
                                                    for c in self.xro_subobject:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.xro_subobject.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "mutual-diversity-flag"):
                                                    self.mutual_diversity_flag = value
                                                    self.mutual_diversity_flag.value_namespace = name_space
                                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (self.xro is not None and self.xro.has_data())

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.xro is not None and self.xro.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-xro" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "xro"):
                                                if (self.xro is None):
                                                    self.xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                                    self.xro.parent = self
                                                    self._children_name_map["xro"] = "xro"
                                                return self.xro

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "xro"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class AttributeSetP2Mpte(Entity):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "frr_bandwidth_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_priority_configured",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2mpte" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetApsPp(Entity):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                            self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                            self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                            self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                            self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                            self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                            self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                            self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                            self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._children_yang_names.add("revert-schedule")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_off_time",
                                                            "path_prot_profile_type",
                                                            "protection_mode",
                                                            "protection_type",
                                                            "restoration_style",
                                                            "snc_mode",
                                                            "tcm_id",
                                                            "wait_to_restore_time") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                                        class RevertSchedule(Entity):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"

                                                self.duration = YLeaf(YType.uint32, "duration")

                                                self.max_tries = YLeaf(YType.uint32, "max-tries")

                                                self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                                self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                                self.schedulename = YLeaf(YType.str, "schedulename")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("duration",
                                                                "max_tries",
                                                                "schedule_date",
                                                                "schedule_frequency",
                                                                "schedulename") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.duration.is_set or
                                                    self.max_tries.is_set or
                                                    self.schedule_date.is_set or
                                                    self.schedule_frequency.is_set or
                                                    self.schedulename.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.duration.yfilter != YFilter.not_set or
                                                    self.max_tries.yfilter != YFilter.not_set or
                                                    self.schedule_date.yfilter != YFilter.not_set or
                                                    self.schedule_frequency.yfilter != YFilter.not_set or
                                                    self.schedulename.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "revert-schedule" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.duration.get_name_leafdata())
                                                if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_tries.get_name_leafdata())
                                                if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                                if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                                if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedulename.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "duration"):
                                                    self.duration = value
                                                    self.duration.value_namespace = name_space
                                                    self.duration.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-tries"):
                                                    self.max_tries = value
                                                    self.max_tries.value_namespace = name_space
                                                    self.max_tries.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-date"):
                                                    self.schedule_date = value
                                                    self.schedule_date.value_namespace = name_space
                                                    self.schedule_date.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-frequency"):
                                                    self.schedule_frequency = value
                                                    self.schedule_frequency.value_namespace = name_space
                                                    self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedulename"):
                                                    self.schedulename = value
                                                    self.schedulename.value_namespace = name_space
                                                    self.schedulename.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.hold_off_time.is_set or
                                                self.path_prot_profile_type.is_set or
                                                self.protection_mode.is_set or
                                                self.protection_type.is_set or
                                                self.restoration_style.is_set or
                                                self.snc_mode.is_set or
                                                self.tcm_id.is_set or
                                                self.wait_to_restore_time.is_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_off_time.yfilter != YFilter.not_set or
                                                self.path_prot_profile_type.yfilter != YFilter.not_set or
                                                self.protection_mode.yfilter != YFilter.not_set or
                                                self.protection_type.yfilter != YFilter.not_set or
                                                self.restoration_style.yfilter != YFilter.not_set or
                                                self.snc_mode.yfilter != YFilter.not_set or
                                                self.tcm_id.yfilter != YFilter.not_set or
                                                self.wait_to_restore_time.yfilter != YFilter.not_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-aps-pp" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                            if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                            if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                            if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_type.get_name_leafdata())
                                            if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                            if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                            if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                            if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "revert-schedule"):
                                                if (self.revert_schedule is None):
                                                    self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                                    self.revert_schedule.parent = self
                                                    self._children_name_map["revert_schedule"] = "revert-schedule"
                                                return self.revert_schedule

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-off-time"):
                                                self.hold_off_time = value
                                                self.hold_off_time.value_namespace = name_space
                                                self.hold_off_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-prot-profile-type"):
                                                self.path_prot_profile_type = value
                                                self.path_prot_profile_type.value_namespace = name_space
                                                self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-mode"):
                                                self.protection_mode = value
                                                self.protection_mode.value_namespace = name_space
                                                self.protection_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-type"):
                                                self.protection_type = value
                                                self.protection_type.value_namespace = name_space
                                                self.protection_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "restoration-style"):
                                                self.restoration_style = value
                                                self.restoration_style.value_namespace = name_space
                                                self.restoration_style.value_namespace_prefix = name_space_prefix
                                            if(value_path == "snc-mode"):
                                                self.snc_mode = value
                                                self.snc_mode.value_namespace = name_space
                                                self.snc_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcm-id"):
                                                self.tcm_id = value
                                                self.tcm_id.value_namespace = name_space
                                                self.tcm_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "wait-to-restore-time"):
                                                self.wait_to_restore_time = value
                                                self.wait_to_restore_time.value_namespace = name_space
                                                self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                                    class AttributeSetP2PTe(Entity):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                            self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                            self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                            self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                            self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                            self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                            self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                            self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                            self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                            self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.prepend_list = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"
                                            self._children_yang_names.add("prepend-list")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_affinity_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_path_select_configured",
                                                            "is_path_selection_metric_configured",
                                                            "is_path_selection_segment_routing_adjacency_protection_configured",
                                                            "is_path_selection_segment_routing_margin_configured",
                                                            "is_path_selection_segment_routing_margin_relative",
                                                            "is_path_selection_segment_routing_segment_limit_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "is_prepend_list_configured",
                                                            "path_invalidation_timeout",
                                                            "path_selection_invalidation_action",
                                                            "path_selection_metric",
                                                            "path_selection_segment_routing_adjacency_protection",
                                                            "path_selection_segment_routing_margin",
                                                            "path_selection_segment_routing_segment_limit",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PrependList(Entity):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.prepend_entry = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in () and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                            class PrependEntry(Entity):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"

                                                    self.index = YLeaf(YType.uint32, "index")

                                                    self.next_label = YLeaf(YType.uint32, "next-label")

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("index",
                                                                    "next_label",
                                                                    "type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.index.is_set or
                                                        self.next_label.is_set or
                                                        self.type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.index.yfilter != YFilter.not_set or
                                                        self.next_label.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "prepend-entry" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.index.get_name_leafdata())
                                                    if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.next_label.get_name_leafdata())
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "index" or name == "next-label" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "index"):
                                                        self.index = value
                                                        self.index.value_namespace = name_space
                                                        self.index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "next-label"):
                                                        self.next_label = value
                                                        self.next_label.value_namespace = name_space
                                                        self.next_label.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_data()):
                                                        return True
                                                return False

                                            def has_operation(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_operation()):
                                                        return True
                                                return self.yfilter != YFilter.not_set

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prepend-list" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "prepend-entry"):
                                                    for c in self.prepend_entry:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.prepend_entry.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "prepend-entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                pass


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.is_affinity_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_path_select_configured.is_set or
                                                self.is_path_selection_metric_configured.is_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_relative.is_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.is_prepend_list_configured.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.path_selection_invalidation_action.is_set or
                                                self.path_selection_metric.is_set or
                                                self.path_selection_segment_routing_adjacency_protection.is_set or
                                                self.path_selection_segment_routing_margin.is_set or
                                                self.path_selection_segment_routing_segment_limit.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.prepend_list is not None and self.prepend_list.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_path_select_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_selection_metric.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.prepend_list is not None and self.prepend_list.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2p-te" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                            if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                            if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                            if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                            if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                            if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "prepend-list"):
                                                if (self.prepend_list is None):
                                                    self.prepend_list = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                                    self.prepend_list.parent = self
                                                    self._children_name_map["prepend_list"] = "prepend-list"
                                                return self.prepend_list

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-select-configured"):
                                                self.is_path_select_configured = value
                                                self.is_path_select_configured.value_namespace = name_space
                                                self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-metric-configured"):
                                                self.is_path_selection_metric_configured = value
                                                self.is_path_selection_metric_configured.value_namespace = name_space
                                                self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                                self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                                self.is_path_selection_segment_routing_margin_configured = value
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                                self.is_path_selection_segment_routing_margin_relative = value
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                                self.is_path_selection_segment_routing_segment_limit_configured = value
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-prepend-list-configured"):
                                                self.is_prepend_list_configured = value
                                                self.is_prepend_list_configured.value_namespace = name_space
                                                self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-invalidation-action"):
                                                self.path_selection_invalidation_action = value
                                                self.path_selection_invalidation_action.value_namespace = name_space
                                                self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-metric"):
                                                self.path_selection_metric = value
                                                self.path_selection_metric.value_namespace = name_space
                                                self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                                self.path_selection_segment_routing_adjacency_protection = value
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-margin"):
                                                self.path_selection_segment_routing_margin = value
                                                self.path_selection_segment_routing_margin.value_namespace = name_space
                                                self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-segment-limit"):
                                                self.path_selection_segment_routing_segment_limit = value
                                                self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                                self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.tunnel_attribute_set_type.is_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-union" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "attribute-set-aps-pp"):
                                            if (self.attribute_set_aps_pp is None):
                                                self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                                self.attribute_set_aps_pp.parent = self
                                                self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                            return self.attribute_set_aps_pp

                                        if (child_yang_name == "attribute-set-autobackup"):
                                            if (self.attribute_set_autobackup is None):
                                                self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                                self.attribute_set_autobackup.parent = self
                                                self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                            return self.attribute_set_autobackup

                                        if (child_yang_name == "attribute-set-automesh"):
                                            if (self.attribute_set_automesh is None):
                                                self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                                self.attribute_set_automesh.parent = self
                                                self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                            return self.attribute_set_automesh

                                        if (child_yang_name == "attribute-set-p2mpte"):
                                            if (self.attribute_set_p2mpte is None):
                                                self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                                self.attribute_set_p2mpte.parent = self
                                                self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                            return self.attribute_set_p2mpte

                                        if (child_yang_name == "attribute-set-p2p-te"):
                                            if (self.attribute_set_p2p_te is None):
                                                self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                                self.attribute_set_p2p_te.parent = self
                                                self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                            return self.attribute_set_p2p_te

                                        if (child_yang_name == "attribute-set-path-option"):
                                            if (self.attribute_set_path_option is None):
                                                self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                                self.attribute_set_path_option.parent = self
                                                self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                            return self.attribute_set_path_option

                                        if (child_yang_name == "attribute-set-xro"):
                                            if (self.attribute_set_xro is None):
                                                self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                                self.attribute_set_xro.parent = self
                                                self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                            return self.attribute_set_xro

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "tunnel-attribute-set-type"):
                                            self.tunnel_attribute_set_type = value
                                            self.tunnel_attribute_set_type.value_namespace = name_space
                                            self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.tunnel_attribute_set_name.is_set or
                                        self.tunnel_attribute_set_name_crc32.is_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-attribute-set" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                                    if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "attribute-set-union"):
                                        if (self.attribute_set_union is None):
                                            self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                            self.attribute_set_union.parent = self
                                            self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                        return self.attribute_set_union

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "tunnel-attribute-set-name"):
                                        self.tunnel_attribute_set_name = value
                                        self.tunnel_attribute_set_name.value_namespace = name_space
                                        self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-attribute-set-name-crc32"):
                                        self.tunnel_attribute_set_name_crc32 = value
                                        self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                                        self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                            class PathCalculationError(Entity):
                                """
                                Path computation information
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.PathCalculationError, self).__init__()

                                    self.yang_name = "path-calculation-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error_message",
                                                    "log_time",
                                                    "lsp_mode") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.PathCalculationError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.PathCalculationError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error_message.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-calculation-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix


                            class RemergeError(Entity):
                                """
                                Path computation remerge resolve info
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.RemergeError, self).__init__()

                                    self.yang_name = "remerge-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error_message",
                                                    "log_time",
                                                    "lsp_mode") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.RemergeError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.RemergeError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error_message.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "remerge-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix


                            class SignallingError(Entity):
                                """
                                Signalling information
                                
                                .. attribute:: error
                                
                                	Path Error code
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: error_node
                                
                                	Source address of the error generating node
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: log_time
                                
                                	Time in seconds when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSPMode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                .. attribute:: reverse_lsp
                                
                                	Indicates if error is on the reverse LSP
                                	**type**\:  bool
                                
                                .. attribute:: signalling_lsp_id
                                
                                	LSP\-id for which the error was received
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: sub_code
                                
                                	Path Error subcode
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.SignallingError, self).__init__()

                                    self.yang_name = "signalling-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error = YLeaf(YType.uint8, "error")

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.error_node = YLeaf(YType.uint32, "error-node")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                    self.reverse_lsp = YLeaf(YType.boolean, "reverse-lsp")

                                    self.signalling_lsp_id = YLeaf(YType.uint16, "signalling-lsp-id")

                                    self.sub_code = YLeaf(YType.uint16, "sub-code")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error",
                                                    "error_message",
                                                    "error_node",
                                                    "log_time",
                                                    "lsp_mode",
                                                    "reverse_lsp",
                                                    "signalling_lsp_id",
                                                    "sub_code") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.SignallingError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.SignallingError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error.is_set or
                                        self.error_message.is_set or
                                        self.error_node.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set or
                                        self.reverse_lsp.is_set or
                                        self.signalling_lsp_id.is_set or
                                        self.sub_code.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.error_node.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set or
                                        self.reverse_lsp.yfilter != YFilter.not_set or
                                        self.signalling_lsp_id.yfilter != YFilter.not_set or
                                        self.sub_code.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "signalling-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error.is_set or self.error.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error.get_name_leafdata())
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.error_node.is_set or self.error_node.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_node.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())
                                    if (self.reverse_lsp.is_set or self.reverse_lsp.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.reverse_lsp.get_name_leafdata())
                                    if (self.signalling_lsp_id.is_set or self.signalling_lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signalling_lsp_id.get_name_leafdata())
                                    if (self.sub_code.is_set or self.sub_code.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.sub_code.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error" or name == "error-message" or name == "error-node" or name == "log-time" or name == "lsp-mode" or name == "reverse-lsp" or name == "signalling-lsp-id" or name == "sub-code"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error"):
                                        self.error = value
                                        self.error.value_namespace = name_space
                                        self.error.value_namespace_prefix = name_space_prefix
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "error-node"):
                                        self.error_node = value
                                        self.error_node.value_namespace = name_space
                                        self.error_node.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "reverse-lsp"):
                                        self.reverse_lsp = value
                                        self.reverse_lsp.value_namespace = name_space
                                        self.reverse_lsp.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signalling-lsp-id"):
                                        self.signalling_lsp_id = value
                                        self.signalling_lsp_id.value_namespace = name_space
                                        self.signalling_lsp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "sub-code"):
                                        self.sub_code = value
                                        self.sub_code.value_namespace = name_space
                                        self.sub_code.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.path_calculation_error:
                                    if (c.has_data()):
                                        return True
                                for c in self.remerge_error:
                                    if (c.has_data()):
                                        return True
                                for c in self.signalling_error:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.attribute_set_found.is_set or
                                    self.explicit_path_id.is_set or
                                    self.explicit_path_name.is_set or
                                    self.has_attribute_set.is_set or
                                    self.has_xro_attribute_set.is_set or
                                    self.holddown_duration.is_set or
                                    self.is_disabled.is_set or
                                    self.is_helddown.is_set or
                                    self.is_lockdown.is_set or
                                    self.is_segment_routing.is_set or
                                    self.is_strict_explicit_path.is_set or
                                    self.is_verbatim.is_set or
                                    self.option_index.is_set or
                                    self.option_index_is_valid.is_set or
                                    self.path_option_area_id.is_set or
                                    self.path_option_name.is_set or
                                    self.path_option_type.is_set or
                                    self.pce_address.is_set or
                                    self.protected_by_path_option_index.is_set or
                                    self.restored_from_path_option_index.is_set or
                                    self.xro_attribute_set_found.is_set or
                                    (self.attribute_set is not None and self.attribute_set.has_data()) or
                                    (self.xro_attribute_set is not None and self.xro_attribute_set.has_data()))

                            def has_operation(self):
                                for c in self.path_calculation_error:
                                    if (c.has_operation()):
                                        return True
                                for c in self.remerge_error:
                                    if (c.has_operation()):
                                        return True
                                for c in self.signalling_error:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.attribute_set_found.yfilter != YFilter.not_set or
                                    self.explicit_path_id.yfilter != YFilter.not_set or
                                    self.explicit_path_name.yfilter != YFilter.not_set or
                                    self.has_attribute_set.yfilter != YFilter.not_set or
                                    self.has_xro_attribute_set.yfilter != YFilter.not_set or
                                    self.holddown_duration.yfilter != YFilter.not_set or
                                    self.is_disabled.yfilter != YFilter.not_set or
                                    self.is_helddown.yfilter != YFilter.not_set or
                                    self.is_lockdown.yfilter != YFilter.not_set or
                                    self.is_segment_routing.yfilter != YFilter.not_set or
                                    self.is_strict_explicit_path.yfilter != YFilter.not_set or
                                    self.is_verbatim.yfilter != YFilter.not_set or
                                    self.option_index.yfilter != YFilter.not_set or
                                    self.option_index_is_valid.yfilter != YFilter.not_set or
                                    self.path_option_area_id.yfilter != YFilter.not_set or
                                    self.path_option_name.yfilter != YFilter.not_set or
                                    self.path_option_type.yfilter != YFilter.not_set or
                                    self.pce_address.yfilter != YFilter.not_set or
                                    self.protected_by_path_option_index.yfilter != YFilter.not_set or
                                    self.restored_from_path_option_index.yfilter != YFilter.not_set or
                                    self.xro_attribute_set_found.yfilter != YFilter.not_set or
                                    (self.attribute_set is not None and self.attribute_set.has_operation()) or
                                    (self.xro_attribute_set is not None and self.xro_attribute_set.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "active-path-option" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.attribute_set_found.is_set or self.attribute_set_found.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.attribute_set_found.get_name_leafdata())
                                if (self.explicit_path_id.is_set or self.explicit_path_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.explicit_path_id.get_name_leafdata())
                                if (self.explicit_path_name.is_set or self.explicit_path_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.explicit_path_name.get_name_leafdata())
                                if (self.has_attribute_set.is_set or self.has_attribute_set.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_attribute_set.get_name_leafdata())
                                if (self.has_xro_attribute_set.is_set or self.has_xro_attribute_set.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_xro_attribute_set.get_name_leafdata())
                                if (self.holddown_duration.is_set or self.holddown_duration.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.holddown_duration.get_name_leafdata())
                                if (self.is_disabled.is_set or self.is_disabled.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_disabled.get_name_leafdata())
                                if (self.is_helddown.is_set or self.is_helddown.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_helddown.get_name_leafdata())
                                if (self.is_lockdown.is_set or self.is_lockdown.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_lockdown.get_name_leafdata())
                                if (self.is_segment_routing.is_set or self.is_segment_routing.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_segment_routing.get_name_leafdata())
                                if (self.is_strict_explicit_path.is_set or self.is_strict_explicit_path.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_strict_explicit_path.get_name_leafdata())
                                if (self.is_verbatim.is_set or self.is_verbatim.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_verbatim.get_name_leafdata())
                                if (self.option_index.is_set or self.option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.option_index.get_name_leafdata())
                                if (self.option_index_is_valid.is_set or self.option_index_is_valid.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.option_index_is_valid.get_name_leafdata())
                                if (self.path_option_area_id.is_set or self.path_option_area_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_area_id.get_name_leafdata())
                                if (self.path_option_name.is_set or self.path_option_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_name.get_name_leafdata())
                                if (self.path_option_type.is_set or self.path_option_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_type.get_name_leafdata())
                                if (self.pce_address.is_set or self.pce_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pce_address.get_name_leafdata())
                                if (self.protected_by_path_option_index.is_set or self.protected_by_path_option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.protected_by_path_option_index.get_name_leafdata())
                                if (self.restored_from_path_option_index.is_set or self.restored_from_path_option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.restored_from_path_option_index.get_name_leafdata())
                                if (self.xro_attribute_set_found.is_set or self.xro_attribute_set_found.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.xro_attribute_set_found.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "attribute-set"):
                                    if (self.attribute_set is None):
                                        self.attribute_set = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.AttributeSet()
                                        self.attribute_set.parent = self
                                        self._children_name_map["attribute_set"] = "attribute-set"
                                    return self.attribute_set

                                if (child_yang_name == "path-calculation-error"):
                                    for c in self.path_calculation_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.PathCalculationError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.path_calculation_error.append(c)
                                    return c

                                if (child_yang_name == "remerge-error"):
                                    for c in self.remerge_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.RemergeError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.remerge_error.append(c)
                                    return c

                                if (child_yang_name == "signalling-error"):
                                    for c in self.signalling_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.SignallingError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.signalling_error.append(c)
                                    return c

                                if (child_yang_name == "xro-attribute-set"):
                                    if (self.xro_attribute_set is None):
                                        self.xro_attribute_set = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption.XroAttributeSet()
                                        self.xro_attribute_set.parent = self
                                        self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                                    return self.xro_attribute_set

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "attribute-set" or name == "path-calculation-error" or name == "remerge-error" or name == "signalling-error" or name == "xro-attribute-set" or name == "attribute-set-found" or name == "explicit-path-id" or name == "explicit-path-name" or name == "has-attribute-set" or name == "has-xro-attribute-set" or name == "holddown-duration" or name == "is-disabled" or name == "is-helddown" or name == "is-lockdown" or name == "is-segment-routing" or name == "is-strict-explicit-path" or name == "is-verbatim" or name == "option-index" or name == "option-index-is-valid" or name == "path-option-area-id" or name == "path-option-name" or name == "path-option-type" or name == "pce-address" or name == "protected-by-path-option-index" or name == "restored-from-path-option-index" or name == "xro-attribute-set-found"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "attribute-set-found"):
                                    self.attribute_set_found = value
                                    self.attribute_set_found.value_namespace = name_space
                                    self.attribute_set_found.value_namespace_prefix = name_space_prefix
                                if(value_path == "explicit-path-id"):
                                    self.explicit_path_id = value
                                    self.explicit_path_id.value_namespace = name_space
                                    self.explicit_path_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "explicit-path-name"):
                                    self.explicit_path_name = value
                                    self.explicit_path_name.value_namespace = name_space
                                    self.explicit_path_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-attribute-set"):
                                    self.has_attribute_set = value
                                    self.has_attribute_set.value_namespace = name_space
                                    self.has_attribute_set.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-xro-attribute-set"):
                                    self.has_xro_attribute_set = value
                                    self.has_xro_attribute_set.value_namespace = name_space
                                    self.has_xro_attribute_set.value_namespace_prefix = name_space_prefix
                                if(value_path == "holddown-duration"):
                                    self.holddown_duration = value
                                    self.holddown_duration.value_namespace = name_space
                                    self.holddown_duration.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-disabled"):
                                    self.is_disabled = value
                                    self.is_disabled.value_namespace = name_space
                                    self.is_disabled.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-helddown"):
                                    self.is_helddown = value
                                    self.is_helddown.value_namespace = name_space
                                    self.is_helddown.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-lockdown"):
                                    self.is_lockdown = value
                                    self.is_lockdown.value_namespace = name_space
                                    self.is_lockdown.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-segment-routing"):
                                    self.is_segment_routing = value
                                    self.is_segment_routing.value_namespace = name_space
                                    self.is_segment_routing.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-strict-explicit-path"):
                                    self.is_strict_explicit_path = value
                                    self.is_strict_explicit_path.value_namespace = name_space
                                    self.is_strict_explicit_path.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-verbatim"):
                                    self.is_verbatim = value
                                    self.is_verbatim.value_namespace = name_space
                                    self.is_verbatim.value_namespace_prefix = name_space_prefix
                                if(value_path == "option-index"):
                                    self.option_index = value
                                    self.option_index.value_namespace = name_space
                                    self.option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "option-index-is-valid"):
                                    self.option_index_is_valid = value
                                    self.option_index_is_valid.value_namespace = name_space
                                    self.option_index_is_valid.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-area-id"):
                                    self.path_option_area_id = value
                                    self.path_option_area_id.value_namespace = name_space
                                    self.path_option_area_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-name"):
                                    self.path_option_name = value
                                    self.path_option_name.value_namespace = name_space
                                    self.path_option_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-type"):
                                    self.path_option_type = value
                                    self.path_option_type.value_namespace = name_space
                                    self.path_option_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "pce-address"):
                                    self.pce_address = value
                                    self.pce_address.value_namespace = name_space
                                    self.pce_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "protected-by-path-option-index"):
                                    self.protected_by_path_option_index = value
                                    self.protected_by_path_option_index.value_namespace = name_space
                                    self.protected_by_path_option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "restored-from-path-option-index"):
                                    self.restored_from_path_option_index = value
                                    self.restored_from_path_option_index.value_namespace = name_space
                                    self.restored_from_path_option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "xro-attribute-set-found"):
                                    self.xro_attribute_set_found = value
                                    self.xro_attribute_set_found.value_namespace = name_space
                                    self.xro_attribute_set_found.value_namespace_prefix = name_space_prefix


                        class OutXro(Entity):
                            """
                            Outgoing XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\:  bool
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro, self).__init__()

                                self.yang_name = "out-xro"
                                self.yang_parent_name = "s2l"

                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                self.xro_subobject = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro, self).__setattr__(name, value)


                            class XroSubobject(Entity):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.AsSubobject>`
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.Ipv4Subobject>`
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.Ipv6Subobject>`
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject>`
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.SrlgSubobject>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "out-xro"

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.as_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"
                                    self._children_yang_names.add("as-subobject")

                                    self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                    self._children_yang_names.add("ipv4-subobject")

                                    self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                    self._children_yang_names.add("ipv6-subobject")

                                    self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._children_yang_names.add("lsp-subobject")

                                    self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                    self._children_yang_names.add("srlg-subobject")

                                    self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                    self._children_yang_names.add("unnumbered-subobject")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject, self).__setattr__(name, value)


                                class Ipv4Subobject(Entity):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class Ipv6Subobject(Entity):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class UnnumberedSubobject(Entity):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("attribute",
                                                        "exclusion_type",
                                                        "interface_id",
                                                        "te_router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.interface_id.is_set or
                                            self.te_router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.interface_id.yfilter != YFilter.not_set or
                                            self.te_router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "unnumbered-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-id"):
                                            self.interface_id = value
                                            self.interface_id.value_namespace = name_space
                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "te-router-id"):
                                            self.te_router_id = value
                                            self.te_router_id.value_namespace = name_space
                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                class AsSubobject(Entity):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("as_number") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.as_number.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.as_number.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "as-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "as-number"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "as-number"):
                                            self.as_number = value
                                            self.as_number.value_namespace = name_space
                                            self.as_number.value_namespace_prefix = name_space_prefix


                                class SrlgSubobject(Entity):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("exclusion_type",
                                                        "srlg_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.exclusion_type.is_set or
                                            self.srlg_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.srlg_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srlg-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "exclusion-type" or name == "srlg-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "srlg-id"):
                                            self.srlg_id = value
                                            self.srlg_id.value_namespace = name_space
                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                class LspSubobject(Entity):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\:  bool
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                        self.fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._children_yang_names.add("fec")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("destination_node_exception",
                                                        "exclusion_type",
                                                        "ignore_lsp_id",
                                                        "penultimate_node_exception",
                                                        "processing_node_exception") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                    class Fec(Entity):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"

                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                            self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._children_yang_names.add("fec-destination-info")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("fec_extended_tunnel_id",
                                                            "fec_lsp_id",
                                                            "fec_source",
                                                            "fec_tunnel_id",
                                                            "fec_vrf") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                        class FecDestinationInfo(Entity):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"

                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("fec_ctype",
                                                                "fec_destination_p2mp_id",
                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.fec_ctype.is_set or
                                                    self.fec_destination_p2mp_id.is_set or
                                                    self.p2p_lsp_destination.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "fec-destination-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "fec-ctype"):
                                                    self.fec_ctype = value
                                                    self.fec_ctype.value_namespace = name_space
                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                if(value_path == "fec-destination-p2mp-id"):
                                                    self.fec_destination_p2mp_id = value
                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "p2p-lsp-destination"):
                                                    self.p2p_lsp_destination = value
                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.fec_extended_tunnel_id.is_set or
                                                self.fec_lsp_id.is_set or
                                                self.fec_source.is_set or
                                                self.fec_tunnel_id.is_set or
                                                self.fec_vrf.is_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                self.fec_source.yfilter != YFilter.not_set or
                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "fec" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "fec-destination-info"):
                                                if (self.fec_destination_info is None):
                                                    self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                    self.fec_destination_info.parent = self
                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                return self.fec_destination_info

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "fec-extended-tunnel-id"):
                                                self.fec_extended_tunnel_id = value
                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-lsp-id"):
                                                self.fec_lsp_id = value
                                                self.fec_lsp_id.value_namespace = name_space
                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-source"):
                                                self.fec_source = value
                                                self.fec_source.value_namespace = name_space
                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-tunnel-id"):
                                                self.fec_tunnel_id = value
                                                self.fec_tunnel_id.value_namespace = name_space
                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-vrf"):
                                                self.fec_vrf = value
                                                self.fec_vrf.value_namespace = name_space
                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.destination_node_exception.is_set or
                                            self.exclusion_type.is_set or
                                            self.ignore_lsp_id.is_set or
                                            self.penultimate_node_exception.is_set or
                                            self.processing_node_exception.is_set or
                                            (self.fec is not None and self.fec.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                            (self.fec is not None and self.fec.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "lsp-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "fec"):
                                            if (self.fec is None):
                                                self.fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec()
                                                self.fec.parent = self
                                                self._children_name_map["fec"] = "fec"
                                            return self.fec

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "destination-node-exception"):
                                            self.destination_node_exception = value
                                            self.destination_node_exception.value_namespace = name_space
                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ignore-lsp-id"):
                                            self.ignore_lsp_id = value
                                            self.ignore_lsp_id.value_namespace = name_space
                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "penultimate-node-exception"):
                                            self.penultimate_node_exception = value
                                            self.penultimate_node_exception.value_namespace = name_space
                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "processing-node-exception"):
                                            self.processing_node_exception = value
                                            self.processing_node_exception.value_namespace = name_space
                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.type.is_set or
                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "as-subobject"):
                                        if (self.as_subobject is None):
                                            self.as_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.AsSubobject()
                                            self.as_subobject.parent = self
                                            self._children_name_map["as_subobject"] = "as-subobject"
                                        return self.as_subobject

                                    if (child_yang_name == "ipv4-subobject"):
                                        if (self.ipv4_subobject is None):
                                            self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.Ipv4Subobject()
                                            self.ipv4_subobject.parent = self
                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                        return self.ipv4_subobject

                                    if (child_yang_name == "ipv6-subobject"):
                                        if (self.ipv6_subobject is None):
                                            self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.Ipv6Subobject()
                                            self.ipv6_subobject.parent = self
                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                        return self.ipv6_subobject

                                    if (child_yang_name == "lsp-subobject"):
                                        if (self.lsp_subobject is None):
                                            self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.LspSubobject()
                                            self.lsp_subobject.parent = self
                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                        return self.lsp_subobject

                                    if (child_yang_name == "srlg-subobject"):
                                        if (self.srlg_subobject is None):
                                            self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.SrlgSubobject()
                                            self.srlg_subobject.parent = self
                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                        return self.srlg_subobject

                                    if (child_yang_name == "unnumbered-subobject"):
                                        if (self.unnumbered_subobject is None):
                                            self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject()
                                            self.unnumbered_subobject.parent = self
                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                        return self.unnumbered_subobject

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.xro_subobject:
                                    if (c.has_data()):
                                        return True
                                return self.mutual_diversity_flag.is_set

                            def has_operation(self):
                                for c in self.xro_subobject:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "out-xro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "xro-subobject"):
                                    for c in self.xro_subobject:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro.XroSubobject()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.xro_subobject.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "mutual-diversity-flag"):
                                    self.mutual_diversity_flag = value
                                    self.mutual_diversity_flag.value_namespace = name_space
                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix


                        class InXro(Entity):
                            """
                            Incoming XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\:  bool
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro, self).__init__()

                                self.yang_name = "in-xro"
                                self.yang_parent_name = "s2l"

                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                self.xro_subobject = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro, self).__setattr__(name, value)


                            class XroSubobject(Entity):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.AsSubobject>`
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.Ipv4Subobject>`
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.Ipv6Subobject>`
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.LspSubobject>`
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.SrlgSubobject>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.UnnumberedSubobject>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "in-xro"

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.as_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"
                                    self._children_yang_names.add("as-subobject")

                                    self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                    self._children_yang_names.add("ipv4-subobject")

                                    self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                    self._children_yang_names.add("ipv6-subobject")

                                    self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._children_yang_names.add("lsp-subobject")

                                    self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                    self._children_yang_names.add("srlg-subobject")

                                    self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                    self._children_yang_names.add("unnumbered-subobject")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject, self).__setattr__(name, value)


                                class Ipv4Subobject(Entity):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class Ipv6Subobject(Entity):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class UnnumberedSubobject(Entity):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("attribute",
                                                        "exclusion_type",
                                                        "interface_id",
                                                        "te_router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.interface_id.is_set or
                                            self.te_router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.interface_id.yfilter != YFilter.not_set or
                                            self.te_router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "unnumbered-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-id"):
                                            self.interface_id = value
                                            self.interface_id.value_namespace = name_space
                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "te-router-id"):
                                            self.te_router_id = value
                                            self.te_router_id.value_namespace = name_space
                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                class AsSubobject(Entity):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("as_number") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.as_number.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.as_number.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "as-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "as-number"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "as-number"):
                                            self.as_number = value
                                            self.as_number.value_namespace = name_space
                                            self.as_number.value_namespace_prefix = name_space_prefix


                                class SrlgSubobject(Entity):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("exclusion_type",
                                                        "srlg_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.exclusion_type.is_set or
                                            self.srlg_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.srlg_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srlg-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "exclusion-type" or name == "srlg-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "srlg-id"):
                                            self.srlg_id = value
                                            self.srlg_id.value_namespace = name_space
                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                class LspSubobject(Entity):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\:  bool
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                        self.fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._children_yang_names.add("fec")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("destination_node_exception",
                                                        "exclusion_type",
                                                        "ignore_lsp_id",
                                                        "penultimate_node_exception",
                                                        "processing_node_exception") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                    class Fec(Entity):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"

                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                            self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._children_yang_names.add("fec-destination-info")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("fec_extended_tunnel_id",
                                                            "fec_lsp_id",
                                                            "fec_source",
                                                            "fec_tunnel_id",
                                                            "fec_vrf") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                        class FecDestinationInfo(Entity):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"

                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("fec_ctype",
                                                                "fec_destination_p2mp_id",
                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.fec_ctype.is_set or
                                                    self.fec_destination_p2mp_id.is_set or
                                                    self.p2p_lsp_destination.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "fec-destination-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "fec-ctype"):
                                                    self.fec_ctype = value
                                                    self.fec_ctype.value_namespace = name_space
                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                if(value_path == "fec-destination-p2mp-id"):
                                                    self.fec_destination_p2mp_id = value
                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "p2p-lsp-destination"):
                                                    self.p2p_lsp_destination = value
                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.fec_extended_tunnel_id.is_set or
                                                self.fec_lsp_id.is_set or
                                                self.fec_source.is_set or
                                                self.fec_tunnel_id.is_set or
                                                self.fec_vrf.is_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                self.fec_source.yfilter != YFilter.not_set or
                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "fec" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "fec-destination-info"):
                                                if (self.fec_destination_info is None):
                                                    self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                    self.fec_destination_info.parent = self
                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                return self.fec_destination_info

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "fec-extended-tunnel-id"):
                                                self.fec_extended_tunnel_id = value
                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-lsp-id"):
                                                self.fec_lsp_id = value
                                                self.fec_lsp_id.value_namespace = name_space
                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-source"):
                                                self.fec_source = value
                                                self.fec_source.value_namespace = name_space
                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-tunnel-id"):
                                                self.fec_tunnel_id = value
                                                self.fec_tunnel_id.value_namespace = name_space
                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-vrf"):
                                                self.fec_vrf = value
                                                self.fec_vrf.value_namespace = name_space
                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.destination_node_exception.is_set or
                                            self.exclusion_type.is_set or
                                            self.ignore_lsp_id.is_set or
                                            self.penultimate_node_exception.is_set or
                                            self.processing_node_exception.is_set or
                                            (self.fec is not None and self.fec.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                            (self.fec is not None and self.fec.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "lsp-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "fec"):
                                            if (self.fec is None):
                                                self.fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec()
                                                self.fec.parent = self
                                                self._children_name_map["fec"] = "fec"
                                            return self.fec

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "destination-node-exception"):
                                            self.destination_node_exception = value
                                            self.destination_node_exception.value_namespace = name_space
                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ignore-lsp-id"):
                                            self.ignore_lsp_id = value
                                            self.ignore_lsp_id.value_namespace = name_space
                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "penultimate-node-exception"):
                                            self.penultimate_node_exception = value
                                            self.penultimate_node_exception.value_namespace = name_space
                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "processing-node-exception"):
                                            self.processing_node_exception = value
                                            self.processing_node_exception.value_namespace = name_space
                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.type.is_set or
                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "as-subobject"):
                                        if (self.as_subobject is None):
                                            self.as_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.AsSubobject()
                                            self.as_subobject.parent = self
                                            self._children_name_map["as_subobject"] = "as-subobject"
                                        return self.as_subobject

                                    if (child_yang_name == "ipv4-subobject"):
                                        if (self.ipv4_subobject is None):
                                            self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.Ipv4Subobject()
                                            self.ipv4_subobject.parent = self
                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                        return self.ipv4_subobject

                                    if (child_yang_name == "ipv6-subobject"):
                                        if (self.ipv6_subobject is None):
                                            self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.Ipv6Subobject()
                                            self.ipv6_subobject.parent = self
                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                        return self.ipv6_subobject

                                    if (child_yang_name == "lsp-subobject"):
                                        if (self.lsp_subobject is None):
                                            self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.LspSubobject()
                                            self.lsp_subobject.parent = self
                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                        return self.lsp_subobject

                                    if (child_yang_name == "srlg-subobject"):
                                        if (self.srlg_subobject is None):
                                            self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.SrlgSubobject()
                                            self.srlg_subobject.parent = self
                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                        return self.srlg_subobject

                                    if (child_yang_name == "unnumbered-subobject"):
                                        if (self.unnumbered_subobject is None):
                                            self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject.UnnumberedSubobject()
                                            self.unnumbered_subobject.parent = self
                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                        return self.unnumbered_subobject

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.xro_subobject:
                                    if (c.has_data()):
                                        return True
                                return self.mutual_diversity_flag.is_set

                            def has_operation(self):
                                for c in self.xro_subobject:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "in-xro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "xro-subobject"):
                                    for c in self.xro_subobject:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro.XroSubobject()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.xro_subobject.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "mutual-diversity-flag"):
                                    self.mutual_diversity_flag = value
                                    self.mutual_diversity_flag.value_namespace = name_space
                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix


                        class Tspec(Entity):
                            """
                            The T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.Tspec, self).__init__()

                                self.yang_name = "tspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.Tspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.Tspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class GenericTspec(Entity):
                            """
                            Generic TSpec
                            
                            .. attribute:: otntspec
                            
                            	TE TSpec for G709 OTN
                            	**type**\:   :py:class:`Otntspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GenericTspec.Otntspec>`
                            
                            .. attribute:: tspec_type
                            
                            	TSpecType
                            	**type**\:   :py:class:`TeMgmtGenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericTspec>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GenericTspec, self).__init__()

                                self.yang_name = "generic-tspec"
                                self.yang_parent_name = "s2l"

                                self.tspec_type = YLeaf(YType.enumeration, "tspec-type")

                                self.otntspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GenericTspec.Otntspec()
                                self.otntspec.parent = self
                                self._children_name_map["otntspec"] = "otntspec"
                                self._children_yang_names.add("otntspec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("tspec_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GenericTspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GenericTspec, self).__setattr__(name, value)


                            class Otntspec(Entity):
                                """
                                TE TSpec for G709 OTN
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GenericTspec.Otntspec, self).__init__()

                                    self.yang_name = "otntspec"
                                    self.yang_parent_name = "generic-tspec"

                                    self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                    self.multiplier = YLeaf(YType.uint16, "multiplier")

                                    self.nmc_or_tolerance = YLeaf(YType.uint16, "nmc-or-tolerance")

                                    self.nvc = YLeaf(YType.uint16, "nvc")

                                    self.signal_type = YLeaf(YType.uint8, "signal-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bit_rate",
                                                    "multiplier",
                                                    "nmc_or_tolerance",
                                                    "nvc",
                                                    "signal_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GenericTspec.Otntspec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GenericTspec.Otntspec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.bit_rate.is_set or
                                        self.multiplier.is_set or
                                        self.nmc_or_tolerance.is_set or
                                        self.nvc.is_set or
                                        self.signal_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bit_rate.yfilter != YFilter.not_set or
                                        self.multiplier.yfilter != YFilter.not_set or
                                        self.nmc_or_tolerance.yfilter != YFilter.not_set or
                                        self.nvc.yfilter != YFilter.not_set or
                                        self.signal_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otntspec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                    if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.multiplier.get_name_leafdata())
                                    if (self.nmc_or_tolerance.is_set or self.nmc_or_tolerance.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nmc_or_tolerance.get_name_leafdata())
                                    if (self.nvc.is_set or self.nvc.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nvc.get_name_leafdata())
                                    if (self.signal_type.is_set or self.signal_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signal_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bit-rate" or name == "multiplier" or name == "nmc-or-tolerance" or name == "nvc" or name == "signal-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bit-rate"):
                                        self.bit_rate = value
                                        self.bit_rate.value_namespace = name_space
                                        self.bit_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "multiplier"):
                                        self.multiplier = value
                                        self.multiplier.value_namespace = name_space
                                        self.multiplier.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nmc-or-tolerance"):
                                        self.nmc_or_tolerance = value
                                        self.nmc_or_tolerance.value_namespace = name_space
                                        self.nmc_or_tolerance.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nvc"):
                                        self.nvc = value
                                        self.nvc.value_namespace = name_space
                                        self.nvc.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signal-type"):
                                        self.signal_type = value
                                        self.signal_type.value_namespace = name_space
                                        self.signal_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.tspec_type.is_set or
                                    (self.otntspec is not None and self.otntspec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.tspec_type.yfilter != YFilter.not_set or
                                    (self.otntspec is not None and self.otntspec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "generic-tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.tspec_type.is_set or self.tspec_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tspec_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "otntspec"):
                                    if (self.otntspec is None):
                                        self.otntspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GenericTspec.Otntspec()
                                        self.otntspec.parent = self
                                        self._children_name_map["otntspec"] = "otntspec"
                                    return self.otntspec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "otntspec" or name == "tspec-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "tspec-type"):
                                    self.tspec_type = value
                                    self.tspec_type.value_namespace = name_space
                                    self.tspec_type.value_namespace_prefix = name_space_prefix


                        class Fspec(Entity):
                            """
                            The F spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.Fspec, self).__init__()

                                self.yang_name = "fspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.Fspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.Fspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class GenericFspec(Entity):
                            """
                            Generic FSpec
                            
                            .. attribute:: fspec_type
                            
                            	FSpecType
                            	**type**\:   :py:class:`TeMgmtGenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericFspec>`
                            
                            .. attribute:: otnfspec
                            
                            	TE FSpec for G709 OTN
                            	**type**\:   :py:class:`Otnfspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GenericFspec.Otnfspec>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GenericFspec, self).__init__()

                                self.yang_name = "generic-fspec"
                                self.yang_parent_name = "s2l"

                                self.fspec_type = YLeaf(YType.enumeration, "fspec-type")

                                self.otnfspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GenericFspec.Otnfspec()
                                self.otnfspec.parent = self
                                self._children_name_map["otnfspec"] = "otnfspec"
                                self._children_yang_names.add("otnfspec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fspec_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GenericFspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GenericFspec, self).__setattr__(name, value)


                            class Otnfspec(Entity):
                                """
                                TE FSpec for G709 OTN
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GenericFspec.Otnfspec, self).__init__()

                                    self.yang_name = "otnfspec"
                                    self.yang_parent_name = "generic-fspec"

                                    self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                    self.multiplier = YLeaf(YType.uint16, "multiplier")

                                    self.nmc_or_tolerance = YLeaf(YType.uint16, "nmc-or-tolerance")

                                    self.nvc = YLeaf(YType.uint16, "nvc")

                                    self.signal_type = YLeaf(YType.uint8, "signal-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bit_rate",
                                                    "multiplier",
                                                    "nmc_or_tolerance",
                                                    "nvc",
                                                    "signal_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GenericFspec.Otnfspec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GenericFspec.Otnfspec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.bit_rate.is_set or
                                        self.multiplier.is_set or
                                        self.nmc_or_tolerance.is_set or
                                        self.nvc.is_set or
                                        self.signal_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bit_rate.yfilter != YFilter.not_set or
                                        self.multiplier.yfilter != YFilter.not_set or
                                        self.nmc_or_tolerance.yfilter != YFilter.not_set or
                                        self.nvc.yfilter != YFilter.not_set or
                                        self.signal_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otnfspec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                    if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.multiplier.get_name_leafdata())
                                    if (self.nmc_or_tolerance.is_set or self.nmc_or_tolerance.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nmc_or_tolerance.get_name_leafdata())
                                    if (self.nvc.is_set or self.nvc.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nvc.get_name_leafdata())
                                    if (self.signal_type.is_set or self.signal_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signal_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bit-rate" or name == "multiplier" or name == "nmc-or-tolerance" or name == "nvc" or name == "signal-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bit-rate"):
                                        self.bit_rate = value
                                        self.bit_rate.value_namespace = name_space
                                        self.bit_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "multiplier"):
                                        self.multiplier = value
                                        self.multiplier.value_namespace = name_space
                                        self.multiplier.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nmc-or-tolerance"):
                                        self.nmc_or_tolerance = value
                                        self.nmc_or_tolerance.value_namespace = name_space
                                        self.nmc_or_tolerance.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nvc"):
                                        self.nvc = value
                                        self.nvc.value_namespace = name_space
                                        self.nvc.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signal-type"):
                                        self.signal_type = value
                                        self.signal_type.value_namespace = name_space
                                        self.signal_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.fspec_type.is_set or
                                    (self.otnfspec is not None and self.otnfspec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fspec_type.yfilter != YFilter.not_set or
                                    (self.otnfspec is not None and self.otnfspec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "generic-fspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fspec_type.is_set or self.fspec_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fspec_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "otnfspec"):
                                    if (self.otnfspec is None):
                                        self.otnfspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GenericFspec.Otnfspec()
                                        self.otnfspec.parent = self
                                        self._children_name_map["otnfspec"] = "otnfspec"
                                    return self.otnfspec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "otnfspec" or name == "fspec-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fspec-type"):
                                    self.fspec_type = value
                                    self.fspec_type.value_namespace = name_space
                                    self.fspec_type.value_namespace_prefix = name_space_prefix


                        class NextHopAddressGeneric(Entity):
                            """
                            Next hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.NextHopAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.NextHopAddressGeneric, self).__init__()

                                self.yang_name = "next-hop-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.NextHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.NextHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "next-hop-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.NextHopAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.NextHopAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "next-hop-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.NextHopAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class PreviousHopAddressGeneric(Entity):
                            """
                            Previous hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PreviousHopAddressGeneric, self).__init__()

                                self.yang_name = "previous-hop-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "previous-hop-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "previous-hop-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PreviousHopAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class IncomingAddressGeneric(Entity):
                            """
                            Incoming interface address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.IncomingAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.IncomingAddressGeneric, self).__init__()

                                self.yang_name = "incoming-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.IncomingAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.IncomingAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "incoming-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.IncomingAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.IncomingAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "incoming-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.IncomingAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class S2LConvergence(Entity):
                            """
                            TE LSP convergence related information
                            
                            .. attribute:: creation_time
                            
                            	Tunnel creation timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: label_rewrite
                            
                            	LSP Label rewrite timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_in
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_out
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_in
                            
                            	LSP RSVP Resv\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_out
                            
                            	LSP RSVP Resv\-out timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: tunnel_rewrite
                            
                            	Tunnel rewrite timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.S2LConvergence, self).__init__()

                                self.yang_name = "s2l-convergence"
                                self.yang_parent_name = "s2l"

                                self.creation_time = YLeaf(YType.uint64, "creation-time")

                                self.label_rewrite = YLeaf(YType.uint64, "label-rewrite")

                                self.path_in = YLeaf(YType.uint64, "path-in")

                                self.path_out = YLeaf(YType.uint64, "path-out")

                                self.resv_in = YLeaf(YType.uint64, "resv-in")

                                self.resv_out = YLeaf(YType.uint64, "resv-out")

                                self.tunnel_rewrite = YLeaf(YType.uint64, "tunnel-rewrite")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("creation_time",
                                                "label_rewrite",
                                                "path_in",
                                                "path_out",
                                                "resv_in",
                                                "resv_out",
                                                "tunnel_rewrite") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.S2LConvergence, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.S2LConvergence, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.creation_time.is_set or
                                    self.label_rewrite.is_set or
                                    self.path_in.is_set or
                                    self.path_out.is_set or
                                    self.resv_in.is_set or
                                    self.resv_out.is_set or
                                    self.tunnel_rewrite.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.creation_time.yfilter != YFilter.not_set or
                                    self.label_rewrite.yfilter != YFilter.not_set or
                                    self.path_in.yfilter != YFilter.not_set or
                                    self.path_out.yfilter != YFilter.not_set or
                                    self.resv_in.yfilter != YFilter.not_set or
                                    self.resv_out.yfilter != YFilter.not_set or
                                    self.tunnel_rewrite.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-convergence" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.creation_time.is_set or self.creation_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.creation_time.get_name_leafdata())
                                if (self.label_rewrite.is_set or self.label_rewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_rewrite.get_name_leafdata())
                                if (self.path_in.is_set or self.path_in.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_in.get_name_leafdata())
                                if (self.path_out.is_set or self.path_out.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_out.get_name_leafdata())
                                if (self.resv_in.is_set or self.resv_in.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.resv_in.get_name_leafdata())
                                if (self.resv_out.is_set or self.resv_out.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.resv_out.get_name_leafdata())
                                if (self.tunnel_rewrite.is_set or self.tunnel_rewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_rewrite.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "creation-time" or name == "label-rewrite" or name == "path-in" or name == "path-out" or name == "resv-in" or name == "resv-out" or name == "tunnel-rewrite"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "creation-time"):
                                    self.creation_time = value
                                    self.creation_time.value_namespace = name_space
                                    self.creation_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "label-rewrite"):
                                    self.label_rewrite = value
                                    self.label_rewrite.value_namespace = name_space
                                    self.label_rewrite.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-in"):
                                    self.path_in = value
                                    self.path_in.value_namespace = name_space
                                    self.path_in.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-out"):
                                    self.path_out = value
                                    self.path_out.value_namespace = name_space
                                    self.path_out.value_namespace_prefix = name_space_prefix
                                if(value_path == "resv-in"):
                                    self.resv_in = value
                                    self.resv_in.value_namespace = name_space
                                    self.resv_in.value_namespace_prefix = name_space_prefix
                                if(value_path == "resv-out"):
                                    self.resv_out = value
                                    self.resv_out.value_namespace = name_space
                                    self.resv_out.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-rewrite"):
                                    self.tunnel_rewrite = value
                                    self.tunnel_rewrite.value_namespace = name_space
                                    self.tunnel_rewrite.value_namespace_prefix = name_space_prefix


                        class SoftPreemption(Entity):
                            """
                            The soft preemption info for this LSP.
                            
                            .. attribute:: fr_rrewrite
                            
                            	FRR\-rewrite during soft preemption
                            	**type**\:  bool
                            
                            .. attribute:: fr_rrewrite_tunnel_name
                            
                            	The tunnel name of the backup
                            	**type**\:  str
                            
                            .. attribute:: preempting_link_address
                            
                            	The address of the link where the preemption happened
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: soft_preemption_link
                            
                            	Name of the link where the soft preemption occurred
                            	**type**\:  str
                            
                            .. attribute:: soft_preemption_timestamp
                            
                            	The POSIX timestamp when the soft preemption occurred
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: status
                            
                            	The current state of the soft preemption operation
                            	**type**\:   :py:class:`MplsTeSoftPreemptionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeSoftPreemptionState>`
                            
                            .. attribute:: time_to_hard_preemption
                            
                            	The number of seconds until hard preemption is triggered
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.SoftPreemption, self).__init__()

                                self.yang_name = "soft-preemption"
                                self.yang_parent_name = "s2l"

                                self.fr_rrewrite = YLeaf(YType.boolean, "fr-rrewrite")

                                self.fr_rrewrite_tunnel_name = YLeaf(YType.str, "fr-rrewrite-tunnel-name")

                                self.preempting_link_address = YLeaf(YType.str, "preempting-link-address")

                                self.soft_preemption_link = YLeaf(YType.str, "soft-preemption-link")

                                self.soft_preemption_timestamp = YLeaf(YType.uint32, "soft-preemption-timestamp")

                                self.status = YLeaf(YType.enumeration, "status")

                                self.time_to_hard_preemption = YLeaf(YType.uint16, "time-to-hard-preemption")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fr_rrewrite",
                                                "fr_rrewrite_tunnel_name",
                                                "preempting_link_address",
                                                "soft_preemption_link",
                                                "soft_preemption_timestamp",
                                                "status",
                                                "time_to_hard_preemption") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.SoftPreemption, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.SoftPreemption, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.fr_rrewrite.is_set or
                                    self.fr_rrewrite_tunnel_name.is_set or
                                    self.preempting_link_address.is_set or
                                    self.soft_preemption_link.is_set or
                                    self.soft_preemption_timestamp.is_set or
                                    self.status.is_set or
                                    self.time_to_hard_preemption.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fr_rrewrite.yfilter != YFilter.not_set or
                                    self.fr_rrewrite_tunnel_name.yfilter != YFilter.not_set or
                                    self.preempting_link_address.yfilter != YFilter.not_set or
                                    self.soft_preemption_link.yfilter != YFilter.not_set or
                                    self.soft_preemption_timestamp.yfilter != YFilter.not_set or
                                    self.status.yfilter != YFilter.not_set or
                                    self.time_to_hard_preemption.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "soft-preemption" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fr_rrewrite.is_set or self.fr_rrewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fr_rrewrite.get_name_leafdata())
                                if (self.fr_rrewrite_tunnel_name.is_set or self.fr_rrewrite_tunnel_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fr_rrewrite_tunnel_name.get_name_leafdata())
                                if (self.preempting_link_address.is_set or self.preempting_link_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.preempting_link_address.get_name_leafdata())
                                if (self.soft_preemption_link.is_set or self.soft_preemption_link.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.soft_preemption_link.get_name_leafdata())
                                if (self.soft_preemption_timestamp.is_set or self.soft_preemption_timestamp.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.soft_preemption_timestamp.get_name_leafdata())
                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.status.get_name_leafdata())
                                if (self.time_to_hard_preemption.is_set or self.time_to_hard_preemption.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.time_to_hard_preemption.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fr-rrewrite" or name == "fr-rrewrite-tunnel-name" or name == "preempting-link-address" or name == "soft-preemption-link" or name == "soft-preemption-timestamp" or name == "status" or name == "time-to-hard-preemption"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fr-rrewrite"):
                                    self.fr_rrewrite = value
                                    self.fr_rrewrite.value_namespace = name_space
                                    self.fr_rrewrite.value_namespace_prefix = name_space_prefix
                                if(value_path == "fr-rrewrite-tunnel-name"):
                                    self.fr_rrewrite_tunnel_name = value
                                    self.fr_rrewrite_tunnel_name.value_namespace = name_space
                                    self.fr_rrewrite_tunnel_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "preempting-link-address"):
                                    self.preempting_link_address = value
                                    self.preempting_link_address.value_namespace = name_space
                                    self.preempting_link_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "soft-preemption-link"):
                                    self.soft_preemption_link = value
                                    self.soft_preemption_link.value_namespace = name_space
                                    self.soft_preemption_link.value_namespace_prefix = name_space_prefix
                                if(value_path == "soft-preemption-timestamp"):
                                    self.soft_preemption_timestamp = value
                                    self.soft_preemption_timestamp.value_namespace = name_space
                                    self.soft_preemption_timestamp.value_namespace_prefix = name_space_prefix
                                if(value_path == "status"):
                                    self.status = value
                                    self.status.value_namespace = name_space
                                    self.status.value_namespace_prefix = name_space_prefix
                                if(value_path == "time-to-hard-preemption"):
                                    self.time_to_hard_preemption = value
                                    self.time_to_hard_preemption.value_namespace = name_space
                                    self.time_to_hard_preemption.value_namespace_prefix = name_space_prefix


                        class GmplsLabels(Entity):
                            """
                            GMPLS labels
                            
                            .. attribute:: path_egress_label
                            
                            	Path message (upstream) egress label
                            	**type**\:   :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel>`
                            
                            .. attribute:: path_ingress_label
                            
                            	Path message (upstream) ingress label
                            	**type**\:   :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel>`
                            
                            .. attribute:: resv_egress_label
                            
                            	Resv message (downstream) egress label
                            	**type**\:   :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel>`
                            
                            .. attribute:: resv_ingress_label
                            
                            	Resv message (downstream) ingress label
                            	**type**\:   :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels, self).__init__()

                                self.yang_name = "gmpls-labels"
                                self.yang_parent_name = "s2l"

                                self.path_egress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel()
                                self.path_egress_label.parent = self
                                self._children_name_map["path_egress_label"] = "path-egress-label"
                                self._children_yang_names.add("path-egress-label")

                                self.path_ingress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel()
                                self.path_ingress_label.parent = self
                                self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                self._children_yang_names.add("path-ingress-label")

                                self.resv_egress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel()
                                self.resv_egress_label.parent = self
                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                self._children_yang_names.add("resv-egress-label")

                                self.resv_ingress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel()
                                self.resv_ingress_label.parent = self
                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                self._children_yang_names.add("resv-ingress-label")


                            class PathIngressLabel(Entity):
                                """
                                Path message (upstream) ingress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel, self).__init__()

                                    self.yang_name = "path-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-ingress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-ingress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-ingress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class PathEgressLabel(Entity):
                                """
                                Path message (upstream) egress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel, self).__init__()

                                    self.yang_name = "path-egress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-egress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-egress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-egress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class ResvIngressLabel(Entity):
                                """
                                Resv message (downstream) ingress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel, self).__init__()

                                    self.yang_name = "resv-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-ingress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-ingress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "resv-ingress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class ResvEgressLabel(Entity):
                                """
                                Resv message (downstream) egress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel, self).__init__()

                                    self.yang_name = "resv-egress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-egress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-egress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "resv-egress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    (self.path_egress_label is not None and self.path_egress_label.has_data()) or
                                    (self.path_ingress_label is not None and self.path_ingress_label.has_data()) or
                                    (self.resv_egress_label is not None and self.resv_egress_label.has_data()) or
                                    (self.resv_ingress_label is not None and self.resv_ingress_label.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.path_egress_label is not None and self.path_egress_label.has_operation()) or
                                    (self.path_ingress_label is not None and self.path_ingress_label.has_operation()) or
                                    (self.resv_egress_label is not None and self.resv_egress_label.has_operation()) or
                                    (self.resv_ingress_label is not None and self.resv_ingress_label.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "gmpls-labels" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "path-egress-label"):
                                    if (self.path_egress_label is None):
                                        self.path_egress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"
                                    return self.path_egress_label

                                if (child_yang_name == "path-ingress-label"):
                                    if (self.path_ingress_label is None):
                                        self.path_ingress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                    return self.path_ingress_label

                                if (child_yang_name == "resv-egress-label"):
                                    if (self.resv_egress_label is None):
                                        self.resv_egress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                    return self.resv_egress_label

                                if (child_yang_name == "resv-ingress-label"):
                                    if (self.resv_ingress_label is None):
                                        self.resv_ingress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                    return self.resv_ingress_label

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "path-egress-label" or name == "path-ingress-label" or name == "resv-egress-label" or name == "resv-ingress-label"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class OtnS2L(Entity):
                            """
                            Otn S2L Information
                            
                            .. attribute:: aps
                            
                            	APS Info for OTN S2L
                            	**type**\:   :py:class:`Aps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Aps>`
                            
                            .. attribute:: otn
                            
                            	Info Related to OTN technology in S2L
                            	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L, self).__init__()

                                self.yang_name = "otn-s2l"
                                self.yang_parent_name = "s2l"

                                self.aps = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Aps()
                                self.aps.parent = self
                                self._children_name_map["aps"] = "aps"
                                self._children_yang_names.add("aps")

                                self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn()
                                self.otn.parent = self
                                self._children_name_map["otn"] = "otn"
                                self._children_yang_names.add("otn")


                            class Otn(Entity):
                                """
                                Info Related to OTN technology in S2L
                                
                                .. attribute:: bandwidth
                                
                                	OTN Bandwidth for s2l
                                	**type**\:   :py:class:`Bandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth>`
                                
                                .. attribute:: cross_connect_id
                                
                                	Cross connect id
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: gpid
                                
                                	Gpid Payload
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: incoming_controller
                                
                                	Incoming Controller
                                	**type**\:  str
                                
                                .. attribute:: incoming_controller_ifhandle
                                
                                	Incoming Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: incoming_controller_state
                                
                                	State of Incoming Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: incoming_sub_controller
                                
                                	Incoming Sub Controller
                                	**type**\:  str
                                
                                .. attribute:: incoming_sub_controller_ifhandle
                                
                                	Incoming Sub Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: incoming_sub_controller_state
                                
                                	State of Incoming Sub Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: is_connected
                                
                                	True if subcontrollers are connected
                                	**type**\:  bool
                                
                                .. attribute:: labels
                                
                                	Labels
                                	**type**\:   :py:class:`Labels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels>`
                                
                                .. attribute:: outgoing_controller
                                
                                	Outgoing Controller
                                	**type**\:  str
                                
                                .. attribute:: outgoing_controller_ifhandle
                                
                                	Outgoing Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: outgoing_controller_state
                                
                                	State of Outgoing Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: outgoing_sub_controller
                                
                                	Outgoing Sub Controller
                                	**type**\:  str
                                
                                .. attribute:: outgoing_sub_controller_ifhandle
                                
                                	Outgoing Sub Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: outgoing_sub_controller_state
                                
                                	State of Outgoing Sub Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: uptime
                                
                                	XC Uptime
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn, self).__init__()

                                    self.yang_name = "otn"
                                    self.yang_parent_name = "otn-s2l"

                                    self.cross_connect_id = YLeaf(YType.uint32, "cross-connect-id")

                                    self.gpid = YLeaf(YType.uint16, "gpid")

                                    self.incoming_controller = YLeaf(YType.str, "incoming-controller")

                                    self.incoming_controller_ifhandle = YLeaf(YType.str, "incoming-controller-ifhandle")

                                    self.incoming_controller_state = YLeaf(YType.enumeration, "incoming-controller-state")

                                    self.incoming_sub_controller = YLeaf(YType.str, "incoming-sub-controller")

                                    self.incoming_sub_controller_ifhandle = YLeaf(YType.str, "incoming-sub-controller-ifhandle")

                                    self.incoming_sub_controller_state = YLeaf(YType.enumeration, "incoming-sub-controller-state")

                                    self.is_connected = YLeaf(YType.boolean, "is-connected")

                                    self.outgoing_controller = YLeaf(YType.str, "outgoing-controller")

                                    self.outgoing_controller_ifhandle = YLeaf(YType.str, "outgoing-controller-ifhandle")

                                    self.outgoing_controller_state = YLeaf(YType.enumeration, "outgoing-controller-state")

                                    self.outgoing_sub_controller = YLeaf(YType.str, "outgoing-sub-controller")

                                    self.outgoing_sub_controller_ifhandle = YLeaf(YType.str, "outgoing-sub-controller-ifhandle")

                                    self.outgoing_sub_controller_state = YLeaf(YType.enumeration, "outgoing-sub-controller-state")

                                    self.uptime = YLeaf(YType.uint32, "uptime")

                                    self.bandwidth = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth()
                                    self.bandwidth.parent = self
                                    self._children_name_map["bandwidth"] = "bandwidth"
                                    self._children_yang_names.add("bandwidth")

                                    self.labels = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels()
                                    self.labels.parent = self
                                    self._children_name_map["labels"] = "labels"
                                    self._children_yang_names.add("labels")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("cross_connect_id",
                                                    "gpid",
                                                    "incoming_controller",
                                                    "incoming_controller_ifhandle",
                                                    "incoming_controller_state",
                                                    "incoming_sub_controller",
                                                    "incoming_sub_controller_ifhandle",
                                                    "incoming_sub_controller_state",
                                                    "is_connected",
                                                    "outgoing_controller",
                                                    "outgoing_controller_ifhandle",
                                                    "outgoing_controller_state",
                                                    "outgoing_sub_controller",
                                                    "outgoing_sub_controller_ifhandle",
                                                    "outgoing_sub_controller_state",
                                                    "uptime") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn, self).__setattr__(name, value)


                                class Bandwidth(Entity):
                                    """
                                    OTN Bandwidth for s2l
                                    
                                    .. attribute:: odu_flex_cbr
                                    
                                    	Odu flex CBR info
                                    	**type**\:   :py:class:`OduFlexCbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr>`
                                    
                                    .. attribute:: odu_flex_gfp_f_non_res
                                    
                                    	Odu flex GFP\-F non\-resizable info
                                    	**type**\:   :py:class:`OduFlexGfpFNonRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes>`
                                    
                                    .. attribute:: odu_flex_gfp_f_res
                                    
                                    	Odu flex GFP\-F resizable info
                                    	**type**\:   :py:class:`OduFlexGfpFRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes>`
                                    
                                    .. attribute:: odu_level
                                    
                                    	ODULevel
                                    	**type**\:   :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth, self).__init__()

                                        self.yang_name = "bandwidth"
                                        self.yang_parent_name = "otn"

                                        self.odu_level = YLeaf(YType.enumeration, "odu-level")

                                        self.odu_flex_cbr = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr()
                                        self.odu_flex_cbr.parent = self
                                        self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"
                                        self._children_yang_names.add("odu-flex-cbr")

                                        self.odu_flex_gfp_f_non_res = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes()
                                        self.odu_flex_gfp_f_non_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                        self._children_yang_names.add("odu-flex-gfp-f-non-res")

                                        self.odu_flex_gfp_f_res = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes()
                                        self.odu_flex_gfp_f_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"
                                        self._children_yang_names.add("odu-flex-gfp-f-res")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("odu_level") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth, self).__setattr__(name, value)


                                    class OduFlexCbr(Entity):
                                        """
                                        Odu flex CBR info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: tolerance
                                        
                                        	Tolerance
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__init__()

                                            self.yang_name = "odu-flex-cbr"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                            self.tolerance = YLeaf(YType.uint16, "tolerance")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate",
                                                            "tolerance") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.bit_rate.is_set or
                                                self.tolerance.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set or
                                                self.tolerance.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-cbr" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                            if (self.tolerance.is_set or self.tolerance.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tolerance.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate" or name == "tolerance"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tolerance"):
                                                self.tolerance = value
                                                self.tolerance.value_namespace = name_space
                                                self.tolerance.value_namespace_prefix = name_space_prefix


                                    class OduFlexGfpFRes(Entity):
                                        """
                                        Odu flex GFP\-F resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-res"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.bit_rate.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-gfp-f-res" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix


                                    class OduFlexGfpFNonRes(Entity):
                                        """
                                        Odu flex GFP\-F non\-resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-non-res"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.bit_rate.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-gfp-f-non-res" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.odu_level.is_set or
                                            (self.odu_flex_cbr is not None and self.odu_flex_cbr.has_data()) or
                                            (self.odu_flex_gfp_f_non_res is not None and self.odu_flex_gfp_f_non_res.has_data()) or
                                            (self.odu_flex_gfp_f_res is not None and self.odu_flex_gfp_f_res.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.odu_level.yfilter != YFilter.not_set or
                                            (self.odu_flex_cbr is not None and self.odu_flex_cbr.has_operation()) or
                                            (self.odu_flex_gfp_f_non_res is not None and self.odu_flex_gfp_f_non_res.has_operation()) or
                                            (self.odu_flex_gfp_f_res is not None and self.odu_flex_gfp_f_res.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "bandwidth" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.odu_level.is_set or self.odu_level.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.odu_level.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "odu-flex-cbr"):
                                            if (self.odu_flex_cbr is None):
                                                self.odu_flex_cbr = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr()
                                                self.odu_flex_cbr.parent = self
                                                self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"
                                            return self.odu_flex_cbr

                                        if (child_yang_name == "odu-flex-gfp-f-non-res"):
                                            if (self.odu_flex_gfp_f_non_res is None):
                                                self.odu_flex_gfp_f_non_res = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes()
                                                self.odu_flex_gfp_f_non_res.parent = self
                                                self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                            return self.odu_flex_gfp_f_non_res

                                        if (child_yang_name == "odu-flex-gfp-f-res"):
                                            if (self.odu_flex_gfp_f_res is None):
                                                self.odu_flex_gfp_f_res = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes()
                                                self.odu_flex_gfp_f_res.parent = self
                                                self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"
                                            return self.odu_flex_gfp_f_res

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "odu-flex-cbr" or name == "odu-flex-gfp-f-non-res" or name == "odu-flex-gfp-f-res" or name == "odu-level"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "odu-level"):
                                            self.odu_level = value
                                            self.odu_level.value_namespace = name_space
                                            self.odu_level.value_namespace_prefix = name_space_prefix


                                class Labels(Entity):
                                    """
                                    Labels
                                    
                                    .. attribute:: path_egress_label
                                    
                                    	Path message (upstream) egress label
                                    	**type**\:   :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel>`
                                    
                                    .. attribute:: path_ingress_label
                                    
                                    	Path message (upstream) ingress label
                                    	**type**\:   :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel>`
                                    
                                    .. attribute:: resv_egress_label
                                    
                                    	Resv message (downstream) egress label
                                    	**type**\:   :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel>`
                                    
                                    .. attribute:: resv_ingress_label
                                    
                                    	Resv message (downstream) ingress label
                                    	**type**\:   :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels, self).__init__()

                                        self.yang_name = "labels"
                                        self.yang_parent_name = "otn"

                                        self.path_egress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"
                                        self._children_yang_names.add("path-egress-label")

                                        self.path_ingress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                        self._children_yang_names.add("path-ingress-label")

                                        self.resv_egress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                        self._children_yang_names.add("resv-egress-label")

                                        self.resv_ingress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                        self._children_yang_names.add("resv-ingress-label")


                                    class PathIngressLabel(Entity):
                                        """
                                        Path message (upstream) ingress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__init__()

                                            self.yang_name = "path-ingress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-ingress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-ingress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "path-ingress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class PathEgressLabel(Entity):
                                        """
                                        Path message (upstream) egress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__init__()

                                            self.yang_name = "path-egress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-egress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-egress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "path-egress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class ResvIngressLabel(Entity):
                                        """
                                        Resv message (downstream) ingress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__init__()

                                            self.yang_name = "resv-ingress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-ingress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-ingress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "resv-ingress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class ResvEgressLabel(Entity):
                                        """
                                        Resv message (downstream) egress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__init__()

                                            self.yang_name = "resv-egress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-egress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-egress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "resv-egress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            (self.path_egress_label is not None and self.path_egress_label.has_data()) or
                                            (self.path_ingress_label is not None and self.path_ingress_label.has_data()) or
                                            (self.resv_egress_label is not None and self.resv_egress_label.has_data()) or
                                            (self.resv_ingress_label is not None and self.resv_ingress_label.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.path_egress_label is not None and self.path_egress_label.has_operation()) or
                                            (self.path_ingress_label is not None and self.path_ingress_label.has_operation()) or
                                            (self.resv_egress_label is not None and self.resv_egress_label.has_operation()) or
                                            (self.resv_ingress_label is not None and self.resv_ingress_label.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "labels" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "path-egress-label"):
                                            if (self.path_egress_label is None):
                                                self.path_egress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel()
                                                self.path_egress_label.parent = self
                                                self._children_name_map["path_egress_label"] = "path-egress-label"
                                            return self.path_egress_label

                                        if (child_yang_name == "path-ingress-label"):
                                            if (self.path_ingress_label is None):
                                                self.path_ingress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel()
                                                self.path_ingress_label.parent = self
                                                self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                            return self.path_ingress_label

                                        if (child_yang_name == "resv-egress-label"):
                                            if (self.resv_egress_label is None):
                                                self.resv_egress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel()
                                                self.resv_egress_label.parent = self
                                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                            return self.resv_egress_label

                                        if (child_yang_name == "resv-ingress-label"):
                                            if (self.resv_ingress_label is None):
                                                self.resv_ingress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel()
                                                self.resv_ingress_label.parent = self
                                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                            return self.resv_ingress_label

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "path-egress-label" or name == "path-ingress-label" or name == "resv-egress-label" or name == "resv-ingress-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass

                                def has_data(self):
                                    return (
                                        self.cross_connect_id.is_set or
                                        self.gpid.is_set or
                                        self.incoming_controller.is_set or
                                        self.incoming_controller_ifhandle.is_set or
                                        self.incoming_controller_state.is_set or
                                        self.incoming_sub_controller.is_set or
                                        self.incoming_sub_controller_ifhandle.is_set or
                                        self.incoming_sub_controller_state.is_set or
                                        self.is_connected.is_set or
                                        self.outgoing_controller.is_set or
                                        self.outgoing_controller_ifhandle.is_set or
                                        self.outgoing_controller_state.is_set or
                                        self.outgoing_sub_controller.is_set or
                                        self.outgoing_sub_controller_ifhandle.is_set or
                                        self.outgoing_sub_controller_state.is_set or
                                        self.uptime.is_set or
                                        (self.bandwidth is not None and self.bandwidth.has_data()) or
                                        (self.labels is not None and self.labels.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.cross_connect_id.yfilter != YFilter.not_set or
                                        self.gpid.yfilter != YFilter.not_set or
                                        self.incoming_controller.yfilter != YFilter.not_set or
                                        self.incoming_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.incoming_controller_state.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller_state.yfilter != YFilter.not_set or
                                        self.is_connected.yfilter != YFilter.not_set or
                                        self.outgoing_controller.yfilter != YFilter.not_set or
                                        self.outgoing_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.outgoing_controller_state.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller_state.yfilter != YFilter.not_set or
                                        self.uptime.yfilter != YFilter.not_set or
                                        (self.bandwidth is not None and self.bandwidth.has_operation()) or
                                        (self.labels is not None and self.labels.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otn" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.cross_connect_id.is_set or self.cross_connect_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.cross_connect_id.get_name_leafdata())
                                    if (self.gpid.is_set or self.gpid.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.gpid.get_name_leafdata())
                                    if (self.incoming_controller.is_set or self.incoming_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller.get_name_leafdata())
                                    if (self.incoming_controller_ifhandle.is_set or self.incoming_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller_ifhandle.get_name_leafdata())
                                    if (self.incoming_controller_state.is_set or self.incoming_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller_state.get_name_leafdata())
                                    if (self.incoming_sub_controller.is_set or self.incoming_sub_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller.get_name_leafdata())
                                    if (self.incoming_sub_controller_ifhandle.is_set or self.incoming_sub_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller_ifhandle.get_name_leafdata())
                                    if (self.incoming_sub_controller_state.is_set or self.incoming_sub_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller_state.get_name_leafdata())
                                    if (self.is_connected.is_set or self.is_connected.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_connected.get_name_leafdata())
                                    if (self.outgoing_controller.is_set or self.outgoing_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller.get_name_leafdata())
                                    if (self.outgoing_controller_ifhandle.is_set or self.outgoing_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller_ifhandle.get_name_leafdata())
                                    if (self.outgoing_controller_state.is_set or self.outgoing_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller_state.get_name_leafdata())
                                    if (self.outgoing_sub_controller.is_set or self.outgoing_sub_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller.get_name_leafdata())
                                    if (self.outgoing_sub_controller_ifhandle.is_set or self.outgoing_sub_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller_ifhandle.get_name_leafdata())
                                    if (self.outgoing_sub_controller_state.is_set or self.outgoing_sub_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller_state.get_name_leafdata())
                                    if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.uptime.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "bandwidth"):
                                        if (self.bandwidth is None):
                                            self.bandwidth = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Bandwidth()
                                            self.bandwidth.parent = self
                                            self._children_name_map["bandwidth"] = "bandwidth"
                                        return self.bandwidth

                                    if (child_yang_name == "labels"):
                                        if (self.labels is None):
                                            self.labels = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn.Labels()
                                            self.labels.parent = self
                                            self._children_name_map["labels"] = "labels"
                                        return self.labels

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bandwidth" or name == "labels" or name == "cross-connect-id" or name == "gpid" or name == "incoming-controller" or name == "incoming-controller-ifhandle" or name == "incoming-controller-state" or name == "incoming-sub-controller" or name == "incoming-sub-controller-ifhandle" or name == "incoming-sub-controller-state" or name == "is-connected" or name == "outgoing-controller" or name == "outgoing-controller-ifhandle" or name == "outgoing-controller-state" or name == "outgoing-sub-controller" or name == "outgoing-sub-controller-ifhandle" or name == "outgoing-sub-controller-state" or name == "uptime"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "cross-connect-id"):
                                        self.cross_connect_id = value
                                        self.cross_connect_id.value_namespace = name_space
                                        self.cross_connect_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "gpid"):
                                        self.gpid = value
                                        self.gpid.value_namespace = name_space
                                        self.gpid.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller"):
                                        self.incoming_controller = value
                                        self.incoming_controller.value_namespace = name_space
                                        self.incoming_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller-ifhandle"):
                                        self.incoming_controller_ifhandle = value
                                        self.incoming_controller_ifhandle.value_namespace = name_space
                                        self.incoming_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller-state"):
                                        self.incoming_controller_state = value
                                        self.incoming_controller_state.value_namespace = name_space
                                        self.incoming_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller"):
                                        self.incoming_sub_controller = value
                                        self.incoming_sub_controller.value_namespace = name_space
                                        self.incoming_sub_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller-ifhandle"):
                                        self.incoming_sub_controller_ifhandle = value
                                        self.incoming_sub_controller_ifhandle.value_namespace = name_space
                                        self.incoming_sub_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller-state"):
                                        self.incoming_sub_controller_state = value
                                        self.incoming_sub_controller_state.value_namespace = name_space
                                        self.incoming_sub_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-connected"):
                                        self.is_connected = value
                                        self.is_connected.value_namespace = name_space
                                        self.is_connected.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller"):
                                        self.outgoing_controller = value
                                        self.outgoing_controller.value_namespace = name_space
                                        self.outgoing_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller-ifhandle"):
                                        self.outgoing_controller_ifhandle = value
                                        self.outgoing_controller_ifhandle.value_namespace = name_space
                                        self.outgoing_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller-state"):
                                        self.outgoing_controller_state = value
                                        self.outgoing_controller_state.value_namespace = name_space
                                        self.outgoing_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller"):
                                        self.outgoing_sub_controller = value
                                        self.outgoing_sub_controller.value_namespace = name_space
                                        self.outgoing_sub_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller-ifhandle"):
                                        self.outgoing_sub_controller_ifhandle = value
                                        self.outgoing_sub_controller_ifhandle.value_namespace = name_space
                                        self.outgoing_sub_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller-state"):
                                        self.outgoing_sub_controller_state = value
                                        self.outgoing_sub_controller_state.value_namespace = name_space
                                        self.outgoing_sub_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "uptime"):
                                        self.uptime = value
                                        self.uptime.value_namespace = name_space
                                        self.uptime.value_namespace_prefix = name_space_prefix


                            class Aps(Entity):
                                """
                                APS Info for OTN S2L
                                
                                .. attribute:: protection_info
                                
                                	Protection Info
                                	**type**\:   :py:class:`ProtectionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Aps.ProtectionInfo>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Aps, self).__init__()

                                    self.yang_name = "aps"
                                    self.yang_parent_name = "otn-s2l"

                                    self.protection_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Aps.ProtectionInfo()
                                    self.protection_info.parent = self
                                    self._children_name_map["protection_info"] = "protection-info"
                                    self._children_yang_names.add("protection-info")


                                class ProtectionInfo(Entity):
                                    """
                                    Protection Info
                                    
                                    .. attribute:: ho_timeout
                                    
                                    	Hold\-Off timeout
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: is_hopresent
                                    
                                    	Is Hold\-Off timeout present
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_snc_mode_present
                                    
                                    	Is SNC mode present
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_wtr_present
                                    
                                    	Is Wait\-to\-Restore timeout present
                                    	**type**\:  bool
                                    
                                    .. attribute:: nbit
                                    
                                    	Notification bit 
                                    	**type**\:  bool
                                    
                                    .. attribute:: obit
                                    
                                    	Operational bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path protection profile type
                                    	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    .. attribute:: pbit
                                    
                                    	Protecting bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: protect_type
                                    
                                    	LSP Protect Type
                                    	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    .. attribute:: sbit
                                    
                                    	Secondary bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: snc_mode
                                    
                                    	SNC mode
                                    	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    .. attribute:: tcm_id
                                    
                                    	TCM ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: wtr_timeout
                                    
                                    	Wait\-to\-Restore timeout
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__init__()

                                        self.yang_name = "protection-info"
                                        self.yang_parent_name = "aps"

                                        self.ho_timeout = YLeaf(YType.uint32, "ho-timeout")

                                        self.is_hopresent = YLeaf(YType.boolean, "is-hopresent")

                                        self.is_snc_mode_present = YLeaf(YType.boolean, "is-snc-mode-present")

                                        self.is_wtr_present = YLeaf(YType.boolean, "is-wtr-present")

                                        self.nbit = YLeaf(YType.boolean, "nbit")

                                        self.obit = YLeaf(YType.boolean, "obit")

                                        self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                        self.pbit = YLeaf(YType.boolean, "pbit")

                                        self.protect_type = YLeaf(YType.enumeration, "protect-type")

                                        self.sbit = YLeaf(YType.boolean, "sbit")

                                        self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                        self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                        self.wtr_timeout = YLeaf(YType.uint32, "wtr-timeout")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("ho_timeout",
                                                        "is_hopresent",
                                                        "is_snc_mode_present",
                                                        "is_wtr_present",
                                                        "nbit",
                                                        "obit",
                                                        "path_prot_profile_type",
                                                        "pbit",
                                                        "protect_type",
                                                        "sbit",
                                                        "snc_mode",
                                                        "tcm_id",
                                                        "wtr_timeout") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.ho_timeout.is_set or
                                            self.is_hopresent.is_set or
                                            self.is_snc_mode_present.is_set or
                                            self.is_wtr_present.is_set or
                                            self.nbit.is_set or
                                            self.obit.is_set or
                                            self.path_prot_profile_type.is_set or
                                            self.pbit.is_set or
                                            self.protect_type.is_set or
                                            self.sbit.is_set or
                                            self.snc_mode.is_set or
                                            self.tcm_id.is_set or
                                            self.wtr_timeout.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.ho_timeout.yfilter != YFilter.not_set or
                                            self.is_hopresent.yfilter != YFilter.not_set or
                                            self.is_snc_mode_present.yfilter != YFilter.not_set or
                                            self.is_wtr_present.yfilter != YFilter.not_set or
                                            self.nbit.yfilter != YFilter.not_set or
                                            self.obit.yfilter != YFilter.not_set or
                                            self.path_prot_profile_type.yfilter != YFilter.not_set or
                                            self.pbit.yfilter != YFilter.not_set or
                                            self.protect_type.yfilter != YFilter.not_set or
                                            self.sbit.yfilter != YFilter.not_set or
                                            self.snc_mode.yfilter != YFilter.not_set or
                                            self.tcm_id.yfilter != YFilter.not_set or
                                            self.wtr_timeout.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "protection-info" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.ho_timeout.is_set or self.ho_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ho_timeout.get_name_leafdata())
                                        if (self.is_hopresent.is_set or self.is_hopresent.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_hopresent.get_name_leafdata())
                                        if (self.is_snc_mode_present.is_set or self.is_snc_mode_present.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_snc_mode_present.get_name_leafdata())
                                        if (self.is_wtr_present.is_set or self.is_wtr_present.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_wtr_present.get_name_leafdata())
                                        if (self.nbit.is_set or self.nbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.nbit.get_name_leafdata())
                                        if (self.obit.is_set or self.obit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.obit.get_name_leafdata())
                                        if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                        if (self.pbit.is_set or self.pbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pbit.get_name_leafdata())
                                        if (self.protect_type.is_set or self.protect_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.protect_type.get_name_leafdata())
                                        if (self.sbit.is_set or self.sbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.sbit.get_name_leafdata())
                                        if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                        if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                        if (self.wtr_timeout.is_set or self.wtr_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.wtr_timeout.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "ho-timeout" or name == "is-hopresent" or name == "is-snc-mode-present" or name == "is-wtr-present" or name == "nbit" or name == "obit" or name == "path-prot-profile-type" or name == "pbit" or name == "protect-type" or name == "sbit" or name == "snc-mode" or name == "tcm-id" or name == "wtr-timeout"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "ho-timeout"):
                                            self.ho_timeout = value
                                            self.ho_timeout.value_namespace = name_space
                                            self.ho_timeout.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-hopresent"):
                                            self.is_hopresent = value
                                            self.is_hopresent.value_namespace = name_space
                                            self.is_hopresent.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-snc-mode-present"):
                                            self.is_snc_mode_present = value
                                            self.is_snc_mode_present.value_namespace = name_space
                                            self.is_snc_mode_present.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-wtr-present"):
                                            self.is_wtr_present = value
                                            self.is_wtr_present.value_namespace = name_space
                                            self.is_wtr_present.value_namespace_prefix = name_space_prefix
                                        if(value_path == "nbit"):
                                            self.nbit = value
                                            self.nbit.value_namespace = name_space
                                            self.nbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "obit"):
                                            self.obit = value
                                            self.obit.value_namespace = name_space
                                            self.obit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-prot-profile-type"):
                                            self.path_prot_profile_type = value
                                            self.path_prot_profile_type.value_namespace = name_space
                                            self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pbit"):
                                            self.pbit = value
                                            self.pbit.value_namespace = name_space
                                            self.pbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "protect-type"):
                                            self.protect_type = value
                                            self.protect_type.value_namespace = name_space
                                            self.protect_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "sbit"):
                                            self.sbit = value
                                            self.sbit.value_namespace = name_space
                                            self.sbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "snc-mode"):
                                            self.snc_mode = value
                                            self.snc_mode.value_namespace = name_space
                                            self.snc_mode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcm-id"):
                                            self.tcm_id = value
                                            self.tcm_id.value_namespace = name_space
                                            self.tcm_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "wtr-timeout"):
                                            self.wtr_timeout = value
                                            self.wtr_timeout.value_namespace = name_space
                                            self.wtr_timeout.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (self.protection_info is not None and self.protection_info.has_data())

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.protection_info is not None and self.protection_info.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "aps" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "protection-info"):
                                        if (self.protection_info is None):
                                            self.protection_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Aps.ProtectionInfo()
                                            self.protection_info.parent = self
                                            self._children_name_map["protection_info"] = "protection-info"
                                        return self.protection_info

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "protection-info"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    (self.aps is not None and self.aps.has_data()) or
                                    (self.otn is not None and self.otn.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.aps is not None and self.aps.has_operation()) or
                                    (self.otn is not None and self.otn.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "otn-s2l" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "aps"):
                                    if (self.aps is None):
                                        self.aps = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Aps()
                                        self.aps.parent = self
                                        self._children_name_map["aps"] = "aps"
                                    return self.aps

                                if (child_yang_name == "otn"):
                                    if (self.otn is None):
                                        self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L.Otn()
                                        self.otn.parent = self
                                        self._children_name_map["otn"] = "otn"
                                    return self.otn

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "aps" or name == "otn"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class HeadEndBfdInfo(Entity):
                            """
                            The Head\-end BFD info
                            
                            .. attribute:: bfd_reverse_path_label
                            
                            	BFD reverse path labels
                            	**type**\: list of    :py:class:`BfdReversePathLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel>`
                            
                            .. attribute:: bfd_reverse_path_stale
                            
                            	The BFD reverse path is stale compared to configuration
                            	**type**\:  bool
                            
                            .. attribute:: creation_time
                            
                            	Time in seconds since the BFD session created
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: deletion_history
                            
                            	BFD Session Deletion History
                            	**type**\:   :py:class:`DeletionHistory <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo.DeletionHistory>`
                            
                            .. attribute:: is_redundant
                            
                            	sBFD session is redundant
                            	**type**\:  bool
                            
                            .. attribute:: lspbfd_type
                            
                            	LSP BFD type
                            	**type**\:   :py:class:`TeVifBfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfd>`
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:   :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo.SessionInfo>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo, self).__init__()

                                self.yang_name = "head-end-bfd-info"
                                self.yang_parent_name = "s2l"

                                self.bfd_reverse_path_stale = YLeaf(YType.boolean, "bfd-reverse-path-stale")

                                self.creation_time = YLeaf(YType.uint32, "creation-time")

                                self.is_redundant = YLeaf(YType.boolean, "is-redundant")

                                self.lspbfd_type = YLeaf(YType.enumeration, "lspbfd-type")

                                self.deletion_history = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo.DeletionHistory()
                                self.deletion_history.parent = self
                                self._children_name_map["deletion_history"] = "deletion-history"
                                self._children_yang_names.add("deletion-history")

                                self.session_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._children_yang_names.add("session-info")

                                self.bfd_reverse_path_label = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("bfd_reverse_path_stale",
                                                "creation_time",
                                                "is_redundant",
                                                "lspbfd_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo, self).__setattr__(name, value)


                            class SessionInfo(Entity):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:   :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.state = YLeaf(YType.enumeration, "state")

                                    self.state_change_time = YLeaf(YType.uint32, "state-change-time")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("state",
                                                    "state_change_time") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.state.is_set or
                                        self.state_change_time.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.state.yfilter != YFilter.not_set or
                                        self.state_change_time.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "session-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state.get_name_leafdata())
                                    if (self.state_change_time.is_set or self.state_change_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state_change_time.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "state" or name == "state-change-time"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "state"):
                                        self.state = value
                                        self.state.value_namespace = name_space
                                        self.state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "state-change-time"):
                                        self.state_change_time = value
                                        self.state_change_time.value_namespace = name_space
                                        self.state_change_time.value_namespace_prefix = name_space_prefix


                            class DeletionHistory(Entity):
                                """
                                BFD Session Deletion History
                                
                                .. attribute:: deletion_diagnostic_code
                                
                                	Diagnostic Code for the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: deletion_reason
                                
                                	Reason for the BFD session get deleted
                                	**type**\:  str
                                
                                .. attribute:: deletion_time
                                
                                	Time stamp of the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: lsp_id
                                
                                	LSP ID of the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__init__()

                                    self.yang_name = "deletion-history"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.deletion_diagnostic_code = YLeaf(YType.uint32, "deletion-diagnostic-code")

                                    self.deletion_reason = YLeaf(YType.str, "deletion-reason")

                                    self.deletion_time = YLeaf(YType.uint32, "deletion-time")

                                    self.lsp_id = YLeaf(YType.uint16, "lsp-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("deletion_diagnostic_code",
                                                    "deletion_reason",
                                                    "deletion_time",
                                                    "lsp_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.deletion_diagnostic_code.is_set or
                                        self.deletion_reason.is_set or
                                        self.deletion_time.is_set or
                                        self.lsp_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.deletion_diagnostic_code.yfilter != YFilter.not_set or
                                        self.deletion_reason.yfilter != YFilter.not_set or
                                        self.deletion_time.yfilter != YFilter.not_set or
                                        self.lsp_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "deletion-history" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.deletion_diagnostic_code.is_set or self.deletion_diagnostic_code.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_diagnostic_code.get_name_leafdata())
                                    if (self.deletion_reason.is_set or self.deletion_reason.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_reason.get_name_leafdata())
                                    if (self.deletion_time.is_set or self.deletion_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_time.get_name_leafdata())
                                    if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "deletion-diagnostic-code" or name == "deletion-reason" or name == "deletion-time" or name == "lsp-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "deletion-diagnostic-code"):
                                        self.deletion_diagnostic_code = value
                                        self.deletion_diagnostic_code.value_namespace = name_space
                                        self.deletion_diagnostic_code.value_namespace_prefix = name_space_prefix
                                    if(value_path == "deletion-reason"):
                                        self.deletion_reason = value
                                        self.deletion_reason.value_namespace = name_space
                                        self.deletion_reason.value_namespace_prefix = name_space_prefix
                                    if(value_path == "deletion-time"):
                                        self.deletion_time = value
                                        self.deletion_time.value_namespace = name_space
                                        self.deletion_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-id"):
                                        self.lsp_id = value
                                        self.lsp_id.value_namespace = name_space
                                        self.lsp_id.value_namespace_prefix = name_space_prefix


                            class BfdReversePathLabel(Entity):
                                """
                                BFD reverse path labels
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__init__()

                                    self.yang_name = "bfd-reverse-path-label"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "bfd-reverse-path-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.bfd_reverse_path_label:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.bfd_reverse_path_stale.is_set or
                                    self.creation_time.is_set or
                                    self.is_redundant.is_set or
                                    self.lspbfd_type.is_set or
                                    (self.deletion_history is not None and self.deletion_history.has_data()) or
                                    (self.session_info is not None and self.session_info.has_data()))

                            def has_operation(self):
                                for c in self.bfd_reverse_path_label:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.bfd_reverse_path_stale.yfilter != YFilter.not_set or
                                    self.creation_time.yfilter != YFilter.not_set or
                                    self.is_redundant.yfilter != YFilter.not_set or
                                    self.lspbfd_type.yfilter != YFilter.not_set or
                                    (self.deletion_history is not None and self.deletion_history.has_operation()) or
                                    (self.session_info is not None and self.session_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "head-end-bfd-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.bfd_reverse_path_stale.is_set or self.bfd_reverse_path_stale.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_reverse_path_stale.get_name_leafdata())
                                if (self.creation_time.is_set or self.creation_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.creation_time.get_name_leafdata())
                                if (self.is_redundant.is_set or self.is_redundant.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_redundant.get_name_leafdata())
                                if (self.lspbfd_type.is_set or self.lspbfd_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lspbfd_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "bfd-reverse-path-label"):
                                    for c in self.bfd_reverse_path_label:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.bfd_reverse_path_label.append(c)
                                    return c

                                if (child_yang_name == "deletion-history"):
                                    if (self.deletion_history is None):
                                        self.deletion_history = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo.DeletionHistory()
                                        self.deletion_history.parent = self
                                        self._children_name_map["deletion_history"] = "deletion-history"
                                    return self.deletion_history

                                if (child_yang_name == "session-info"):
                                    if (self.session_info is None):
                                        self.session_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo.SessionInfo()
                                        self.session_info.parent = self
                                        self._children_name_map["session_info"] = "session-info"
                                    return self.session_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "bfd-reverse-path-label" or name == "deletion-history" or name == "session-info" or name == "bfd-reverse-path-stale" or name == "creation-time" or name == "is-redundant" or name == "lspbfd-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "bfd-reverse-path-stale"):
                                    self.bfd_reverse_path_stale = value
                                    self.bfd_reverse_path_stale.value_namespace = name_space
                                    self.bfd_reverse_path_stale.value_namespace_prefix = name_space_prefix
                                if(value_path == "creation-time"):
                                    self.creation_time = value
                                    self.creation_time.value_namespace = name_space
                                    self.creation_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-redundant"):
                                    self.is_redundant = value
                                    self.is_redundant.value_namespace = name_space
                                    self.is_redundant.value_namespace_prefix = name_space_prefix
                                if(value_path == "lspbfd-type"):
                                    self.lspbfd_type = value
                                    self.lspbfd_type.value_namespace = name_space
                                    self.lspbfd_type.value_namespace_prefix = name_space_prefix


                        class TailEndBfdInfo(Entity):
                            """
                            The Tail\-end BFD info
                            
                            .. attribute:: failure_diagnostic_code
                            
                            	BFD session failure diagnostic code
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: failure_reason
                            
                            	BFD session failure reason
                            	**type**\:  str
                            
                            .. attribute:: local_discriminator
                            
                            	BFD Local Discriminator
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: min_interval
                            
                            	Hello interval in mini second
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: min_interval_default
                            
                            	Is default hello interval
                            	**type**\:  bool
                            
                            .. attribute:: multiplier
                            
                            	Multiplier
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: multiplier_default
                            
                            	Is default multiplier
                            	**type**\:  bool
                            
                            .. attribute:: remote_discriminator
                            
                            	BFD Remote Discrminator
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:   :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.TailEndBfdInfo.SessionInfo>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.TailEndBfdInfo, self).__init__()

                                self.yang_name = "tail-end-bfd-info"
                                self.yang_parent_name = "s2l"

                                self.failure_diagnostic_code = YLeaf(YType.uint32, "failure-diagnostic-code")

                                self.failure_reason = YLeaf(YType.str, "failure-reason")

                                self.local_discriminator = YLeaf(YType.uint32, "local-discriminator")

                                self.min_interval = YLeaf(YType.uint32, "min-interval")

                                self.min_interval_default = YLeaf(YType.boolean, "min-interval-default")

                                self.multiplier = YLeaf(YType.uint8, "multiplier")

                                self.multiplier_default = YLeaf(YType.boolean, "multiplier-default")

                                self.remote_discriminator = YLeaf(YType.uint32, "remote-discriminator")

                                self.session_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.TailEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._children_yang_names.add("session-info")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("failure_diagnostic_code",
                                                "failure_reason",
                                                "local_discriminator",
                                                "min_interval",
                                                "min_interval_default",
                                                "multiplier",
                                                "multiplier_default",
                                                "remote_discriminator") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.TailEndBfdInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.TailEndBfdInfo, self).__setattr__(name, value)


                            class SessionInfo(Entity):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:   :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.TailEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "tail-end-bfd-info"

                                    self.state = YLeaf(YType.enumeration, "state")

                                    self.state_change_time = YLeaf(YType.uint32, "state-change-time")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("state",
                                                    "state_change_time") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.TailEndBfdInfo.SessionInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.TailEndBfdInfo.SessionInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.state.is_set or
                                        self.state_change_time.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.state.yfilter != YFilter.not_set or
                                        self.state_change_time.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "session-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state.get_name_leafdata())
                                    if (self.state_change_time.is_set or self.state_change_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state_change_time.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "state" or name == "state-change-time"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "state"):
                                        self.state = value
                                        self.state.value_namespace = name_space
                                        self.state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "state-change-time"):
                                        self.state_change_time = value
                                        self.state_change_time.value_namespace = name_space
                                        self.state_change_time.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.failure_diagnostic_code.is_set or
                                    self.failure_reason.is_set or
                                    self.local_discriminator.is_set or
                                    self.min_interval.is_set or
                                    self.min_interval_default.is_set or
                                    self.multiplier.is_set or
                                    self.multiplier_default.is_set or
                                    self.remote_discriminator.is_set or
                                    (self.session_info is not None and self.session_info.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.failure_diagnostic_code.yfilter != YFilter.not_set or
                                    self.failure_reason.yfilter != YFilter.not_set or
                                    self.local_discriminator.yfilter != YFilter.not_set or
                                    self.min_interval.yfilter != YFilter.not_set or
                                    self.min_interval_default.yfilter != YFilter.not_set or
                                    self.multiplier.yfilter != YFilter.not_set or
                                    self.multiplier_default.yfilter != YFilter.not_set or
                                    self.remote_discriminator.yfilter != YFilter.not_set or
                                    (self.session_info is not None and self.session_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "tail-end-bfd-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.failure_diagnostic_code.is_set or self.failure_diagnostic_code.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.failure_diagnostic_code.get_name_leafdata())
                                if (self.failure_reason.is_set or self.failure_reason.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.failure_reason.get_name_leafdata())
                                if (self.local_discriminator.is_set or self.local_discriminator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_discriminator.get_name_leafdata())
                                if (self.min_interval.is_set or self.min_interval.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.min_interval.get_name_leafdata())
                                if (self.min_interval_default.is_set or self.min_interval_default.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.min_interval_default.get_name_leafdata())
                                if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.multiplier.get_name_leafdata())
                                if (self.multiplier_default.is_set or self.multiplier_default.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.multiplier_default.get_name_leafdata())
                                if (self.remote_discriminator.is_set or self.remote_discriminator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.remote_discriminator.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "session-info"):
                                    if (self.session_info is None):
                                        self.session_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.TailEndBfdInfo.SessionInfo()
                                        self.session_info.parent = self
                                        self._children_name_map["session_info"] = "session-info"
                                    return self.session_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "session-info" or name == "failure-diagnostic-code" or name == "failure-reason" or name == "local-discriminator" or name == "min-interval" or name == "min-interval-default" or name == "multiplier" or name == "multiplier-default" or name == "remote-discriminator"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "failure-diagnostic-code"):
                                    self.failure_diagnostic_code = value
                                    self.failure_diagnostic_code.value_namespace = name_space
                                    self.failure_diagnostic_code.value_namespace_prefix = name_space_prefix
                                if(value_path == "failure-reason"):
                                    self.failure_reason = value
                                    self.failure_reason.value_namespace = name_space
                                    self.failure_reason.value_namespace_prefix = name_space_prefix
                                if(value_path == "local-discriminator"):
                                    self.local_discriminator = value
                                    self.local_discriminator.value_namespace = name_space
                                    self.local_discriminator.value_namespace_prefix = name_space_prefix
                                if(value_path == "min-interval"):
                                    self.min_interval = value
                                    self.min_interval.value_namespace = name_space
                                    self.min_interval.value_namespace_prefix = name_space_prefix
                                if(value_path == "min-interval-default"):
                                    self.min_interval_default = value
                                    self.min_interval_default.value_namespace = name_space
                                    self.min_interval_default.value_namespace_prefix = name_space_prefix
                                if(value_path == "multiplier"):
                                    self.multiplier = value
                                    self.multiplier.value_namespace = name_space
                                    self.multiplier.value_namespace_prefix = name_space_prefix
                                if(value_path == "multiplier-default"):
                                    self.multiplier_default = value
                                    self.multiplier_default.value_namespace = name_space
                                    self.multiplier_default.value_namespace_prefix = name_space_prefix
                                if(value_path == "remote-discriminator"):
                                    self.remote_discriminator = value
                                    self.remote_discriminator.value_namespace = name_space
                                    self.remote_discriminator.value_namespace_prefix = name_space_prefix


                        class SrlgCollection(Entity):
                            """
                            SRLG\-collection data
                            
                            .. attribute:: discovered_srlg
                            
                            	Discovered SRLGs
                            	**type**\: list of    :py:class:`DiscoveredSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.SrlgCollection.DiscoveredSrlg>`
                            
                            .. attribute:: srlg_collect_type
                            
                            	SRLG\-collection mechanism
                            	**type**\:   :py:class:`TeSrlgCollectRequest <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrlgCollectRequest>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.SrlgCollection, self).__init__()

                                self.yang_name = "srlg-collection"
                                self.yang_parent_name = "s2l"

                                self.srlg_collect_type = YLeaf(YType.enumeration, "srlg-collect-type")

                                self.discovered_srlg = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("srlg_collect_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.SrlgCollection, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.SrlgCollection, self).__setattr__(name, value)


                            class DiscoveredSrlg(Entity):
                                """
                                Discovered SRLGs
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__init__()

                                    self.yang_name = "discovered-srlg"
                                    self.yang_parent_name = "srlg-collection"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "discovered-srlg" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.discovered_srlg:
                                    if (c.has_data()):
                                        return True
                                return self.srlg_collect_type.is_set

                            def has_operation(self):
                                for c in self.discovered_srlg:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.srlg_collect_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "srlg-collection" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.srlg_collect_type.is_set or self.srlg_collect_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.srlg_collect_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "discovered-srlg"):
                                    for c in self.discovered_srlg:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.SrlgCollection.DiscoveredSrlg()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.discovered_srlg.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "discovered-srlg" or name == "srlg-collect-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "srlg-collect-type"):
                                    self.srlg_collect_type = value
                                    self.srlg_collect_type.value_namespace = name_space
                                    self.srlg_collect_type.value_namespace_prefix = name_space_prefix


                        class Association(Entity):
                            """
                            Association Object
                            
                            .. attribute:: s2l_association_id
                            
                            	S2L Association ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_association_source
                            
                            	S2L Association Source
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_association_tie_role
                            
                            	S2L Association Tie Role
                            	**type**\:   :py:class:`TeAssociationTieRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAssociationTieRole>`
                            
                            .. attribute:: s2l_association_type
                            
                            	S2L Association Type                          (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_extended_id
                            
                            	S2L Extended ID Array
                            	**type**\: list of    :py:class:`S2LExtendedId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.Association.S2LExtendedId>`
                            
                            .. attribute:: s2l_global_source
                            
                            	S2L Global Source
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.Association, self).__init__()

                                self.yang_name = "association"
                                self.yang_parent_name = "s2l"

                                self.s2l_association_id = YLeaf(YType.uint16, "s2l-association-id")

                                self.s2l_association_source = YLeaf(YType.str, "s2l-association-source")

                                self.s2l_association_tie_role = YLeaf(YType.enumeration, "s2l-association-tie-role")

                                self.s2l_association_type = YLeaf(YType.uint16, "s2l-association-type")

                                self.s2l_global_source = YLeaf(YType.uint32, "s2l-global-source")

                                self.s2l_extended_id = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("s2l_association_id",
                                                "s2l_association_source",
                                                "s2l_association_tie_role",
                                                "s2l_association_type",
                                                "s2l_global_source") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.Association, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.Association, self).__setattr__(name, value)


                            class S2LExtendedId(Entity):
                                """
                                S2L Extended ID Array
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.Association.S2LExtendedId, self).__init__()

                                    self.yang_name = "s2l-extended-id"
                                    self.yang_parent_name = "association"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.Association.S2LExtendedId, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.Association.S2LExtendedId, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "s2l-extended-id" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.s2l_extended_id:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.s2l_association_id.is_set or
                                    self.s2l_association_source.is_set or
                                    self.s2l_association_tie_role.is_set or
                                    self.s2l_association_type.is_set or
                                    self.s2l_global_source.is_set)

                            def has_operation(self):
                                for c in self.s2l_extended_id:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.s2l_association_id.yfilter != YFilter.not_set or
                                    self.s2l_association_source.yfilter != YFilter.not_set or
                                    self.s2l_association_tie_role.yfilter != YFilter.not_set or
                                    self.s2l_association_type.yfilter != YFilter.not_set or
                                    self.s2l_global_source.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "association" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.s2l_association_id.is_set or self.s2l_association_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_id.get_name_leafdata())
                                if (self.s2l_association_source.is_set or self.s2l_association_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_source.get_name_leafdata())
                                if (self.s2l_association_tie_role.is_set or self.s2l_association_tie_role.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_tie_role.get_name_leafdata())
                                if (self.s2l_association_type.is_set or self.s2l_association_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_type.get_name_leafdata())
                                if (self.s2l_global_source.is_set or self.s2l_global_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_global_source.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "s2l-extended-id"):
                                    for c in self.s2l_extended_id:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.Association.S2LExtendedId()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.s2l_extended_id.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "s2l-extended-id" or name == "s2l-association-id" or name == "s2l-association-source" or name == "s2l-association-tie-role" or name == "s2l-association-type" or name == "s2l-global-source"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "s2l-association-id"):
                                    self.s2l_association_id = value
                                    self.s2l_association_id.value_namespace = name_space
                                    self.s2l_association_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-source"):
                                    self.s2l_association_source = value
                                    self.s2l_association_source.value_namespace = name_space
                                    self.s2l_association_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-tie-role"):
                                    self.s2l_association_tie_role = value
                                    self.s2l_association_tie_role.value_namespace = name_space
                                    self.s2l_association_tie_role.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-type"):
                                    self.s2l_association_type = value
                                    self.s2l_association_type.value_namespace = name_space
                                    self.s2l_association_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-global-source"):
                                    self.s2l_global_source = value
                                    self.s2l_global_source.value_namespace = name_space
                                    self.s2l_global_source.value_namespace_prefix = name_space_prefix


                        class Protection(Entity):
                            """
                            Protection Object
                            
                            .. attribute:: any
                            
                            	Any
                            	**type**\:  bool
                            
                            .. attribute:: ded1_plus1
                            
                            	Dedicated 1+1 Protection
                            	**type**\:  bool
                            
                            .. attribute:: ded1_to1
                            
                            	Dedicated 1\:1 Protection
                            	**type**\:  bool
                            
                            .. attribute:: enhanced
                            
                            	Indicates Enhanced Protection Scheme
                            	**type**\:  bool
                            
                            .. attribute:: extra_traffic
                            
                            	LSP should use Links that are protecting other (primary) traffic
                            	**type**\:  bool
                            
                            .. attribute:: link_unprotected
                            
                            	LSP should not use any Link Layer Protection
                            	**type**\:  bool
                            
                            .. attribute:: lsp_unprotected
                            
                            	LSP Flags Unprotected
                            	**type**\:  bool
                            
                            .. attribute:: one_plus_one_bi
                            
                            	1+1 Bidirectional Protection
                            	**type**\:  bool
                            
                            .. attribute:: one_plus_one_uni
                            
                            	1+1 Unidirectional Protection
                            	**type**\:  bool
                            
                            .. attribute:: one_to_n_protection_et
                            
                            	1\:N Protection with Extra\-Traffic
                            	**type**\:  bool
                            
                            .. attribute:: rerouting
                            
                            	Full Rerouting
                            	**type**\:  bool
                            
                            .. attribute:: rerouting_no_et
                            
                            	Rerouting Without Extra\-Traffic
                            	**type**\:  bool
                            
                            .. attribute:: s2l_notification
                            
                            	 S2L Protection Notification Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_operational
                            
                            	 S2L Protection Operational Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_protecting
                            
                            	 S2L Protection Protecting Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_secondary
                            
                            	 S2L Protection Secondary Bit
                            	**type**\:  bool
                            
                            .. attribute:: shared
                            
                            	Shared Link Layer Protection
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.Protection, self).__init__()

                                self.yang_name = "protection"
                                self.yang_parent_name = "s2l"

                                self.any = YLeaf(YType.boolean, "any")

                                self.ded1_plus1 = YLeaf(YType.boolean, "ded1-plus1")

                                self.ded1_to1 = YLeaf(YType.boolean, "ded1-to1")

                                self.enhanced = YLeaf(YType.boolean, "enhanced")

                                self.extra_traffic = YLeaf(YType.boolean, "extra-traffic")

                                self.link_unprotected = YLeaf(YType.boolean, "link-unprotected")

                                self.lsp_unprotected = YLeaf(YType.boolean, "lsp-unprotected")

                                self.one_plus_one_bi = YLeaf(YType.boolean, "one-plus-one-bi")

                                self.one_plus_one_uni = YLeaf(YType.boolean, "one-plus-one-uni")

                                self.one_to_n_protection_et = YLeaf(YType.boolean, "one-to-n-protection-et")

                                self.rerouting = YLeaf(YType.boolean, "rerouting")

                                self.rerouting_no_et = YLeaf(YType.boolean, "rerouting-no-et")

                                self.s2l_notification = YLeaf(YType.boolean, "s2l-notification")

                                self.s2l_operational = YLeaf(YType.boolean, "s2l-operational")

                                self.s2l_protecting = YLeaf(YType.boolean, "s2l-protecting")

                                self.s2l_secondary = YLeaf(YType.boolean, "s2l-secondary")

                                self.shared = YLeaf(YType.boolean, "shared")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("any",
                                                "ded1_plus1",
                                                "ded1_to1",
                                                "enhanced",
                                                "extra_traffic",
                                                "link_unprotected",
                                                "lsp_unprotected",
                                                "one_plus_one_bi",
                                                "one_plus_one_uni",
                                                "one_to_n_protection_et",
                                                "rerouting",
                                                "rerouting_no_et",
                                                "s2l_notification",
                                                "s2l_operational",
                                                "s2l_protecting",
                                                "s2l_secondary",
                                                "shared") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.Protection, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.Protection, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.any.is_set or
                                    self.ded1_plus1.is_set or
                                    self.ded1_to1.is_set or
                                    self.enhanced.is_set or
                                    self.extra_traffic.is_set or
                                    self.link_unprotected.is_set or
                                    self.lsp_unprotected.is_set or
                                    self.one_plus_one_bi.is_set or
                                    self.one_plus_one_uni.is_set or
                                    self.one_to_n_protection_et.is_set or
                                    self.rerouting.is_set or
                                    self.rerouting_no_et.is_set or
                                    self.s2l_notification.is_set or
                                    self.s2l_operational.is_set or
                                    self.s2l_protecting.is_set or
                                    self.s2l_secondary.is_set or
                                    self.shared.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.any.yfilter != YFilter.not_set or
                                    self.ded1_plus1.yfilter != YFilter.not_set or
                                    self.ded1_to1.yfilter != YFilter.not_set or
                                    self.enhanced.yfilter != YFilter.not_set or
                                    self.extra_traffic.yfilter != YFilter.not_set or
                                    self.link_unprotected.yfilter != YFilter.not_set or
                                    self.lsp_unprotected.yfilter != YFilter.not_set or
                                    self.one_plus_one_bi.yfilter != YFilter.not_set or
                                    self.one_plus_one_uni.yfilter != YFilter.not_set or
                                    self.one_to_n_protection_et.yfilter != YFilter.not_set or
                                    self.rerouting.yfilter != YFilter.not_set or
                                    self.rerouting_no_et.yfilter != YFilter.not_set or
                                    self.s2l_notification.yfilter != YFilter.not_set or
                                    self.s2l_operational.yfilter != YFilter.not_set or
                                    self.s2l_protecting.yfilter != YFilter.not_set or
                                    self.s2l_secondary.yfilter != YFilter.not_set or
                                    self.shared.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "protection" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.any.is_set or self.any.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.any.get_name_leafdata())
                                if (self.ded1_plus1.is_set or self.ded1_plus1.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ded1_plus1.get_name_leafdata())
                                if (self.ded1_to1.is_set or self.ded1_to1.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ded1_to1.get_name_leafdata())
                                if (self.enhanced.is_set or self.enhanced.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.enhanced.get_name_leafdata())
                                if (self.extra_traffic.is_set or self.extra_traffic.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.extra_traffic.get_name_leafdata())
                                if (self.link_unprotected.is_set or self.link_unprotected.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.link_unprotected.get_name_leafdata())
                                if (self.lsp_unprotected.is_set or self.lsp_unprotected.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_unprotected.get_name_leafdata())
                                if (self.one_plus_one_bi.is_set or self.one_plus_one_bi.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_plus_one_bi.get_name_leafdata())
                                if (self.one_plus_one_uni.is_set or self.one_plus_one_uni.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_plus_one_uni.get_name_leafdata())
                                if (self.one_to_n_protection_et.is_set or self.one_to_n_protection_et.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_to_n_protection_et.get_name_leafdata())
                                if (self.rerouting.is_set or self.rerouting.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rerouting.get_name_leafdata())
                                if (self.rerouting_no_et.is_set or self.rerouting_no_et.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rerouting_no_et.get_name_leafdata())
                                if (self.s2l_notification.is_set or self.s2l_notification.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_notification.get_name_leafdata())
                                if (self.s2l_operational.is_set or self.s2l_operational.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_operational.get_name_leafdata())
                                if (self.s2l_protecting.is_set or self.s2l_protecting.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_protecting.get_name_leafdata())
                                if (self.s2l_secondary.is_set or self.s2l_secondary.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_secondary.get_name_leafdata())
                                if (self.shared.is_set or self.shared.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.shared.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "any" or name == "ded1-plus1" or name == "ded1-to1" or name == "enhanced" or name == "extra-traffic" or name == "link-unprotected" or name == "lsp-unprotected" or name == "one-plus-one-bi" or name == "one-plus-one-uni" or name == "one-to-n-protection-et" or name == "rerouting" or name == "rerouting-no-et" or name == "s2l-notification" or name == "s2l-operational" or name == "s2l-protecting" or name == "s2l-secondary" or name == "shared"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "any"):
                                    self.any = value
                                    self.any.value_namespace = name_space
                                    self.any.value_namespace_prefix = name_space_prefix
                                if(value_path == "ded1-plus1"):
                                    self.ded1_plus1 = value
                                    self.ded1_plus1.value_namespace = name_space
                                    self.ded1_plus1.value_namespace_prefix = name_space_prefix
                                if(value_path == "ded1-to1"):
                                    self.ded1_to1 = value
                                    self.ded1_to1.value_namespace = name_space
                                    self.ded1_to1.value_namespace_prefix = name_space_prefix
                                if(value_path == "enhanced"):
                                    self.enhanced = value
                                    self.enhanced.value_namespace = name_space
                                    self.enhanced.value_namespace_prefix = name_space_prefix
                                if(value_path == "extra-traffic"):
                                    self.extra_traffic = value
                                    self.extra_traffic.value_namespace = name_space
                                    self.extra_traffic.value_namespace_prefix = name_space_prefix
                                if(value_path == "link-unprotected"):
                                    self.link_unprotected = value
                                    self.link_unprotected.value_namespace = name_space
                                    self.link_unprotected.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-unprotected"):
                                    self.lsp_unprotected = value
                                    self.lsp_unprotected.value_namespace = name_space
                                    self.lsp_unprotected.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-plus-one-bi"):
                                    self.one_plus_one_bi = value
                                    self.one_plus_one_bi.value_namespace = name_space
                                    self.one_plus_one_bi.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-plus-one-uni"):
                                    self.one_plus_one_uni = value
                                    self.one_plus_one_uni.value_namespace = name_space
                                    self.one_plus_one_uni.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-to-n-protection-et"):
                                    self.one_to_n_protection_et = value
                                    self.one_to_n_protection_et.value_namespace = name_space
                                    self.one_to_n_protection_et.value_namespace_prefix = name_space_prefix
                                if(value_path == "rerouting"):
                                    self.rerouting = value
                                    self.rerouting.value_namespace = name_space
                                    self.rerouting.value_namespace_prefix = name_space_prefix
                                if(value_path == "rerouting-no-et"):
                                    self.rerouting_no_et = value
                                    self.rerouting_no_et.value_namespace = name_space
                                    self.rerouting_no_et.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-notification"):
                                    self.s2l_notification = value
                                    self.s2l_notification.value_namespace = name_space
                                    self.s2l_notification.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-operational"):
                                    self.s2l_operational = value
                                    self.s2l_operational.value_namespace = name_space
                                    self.s2l_operational.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-protecting"):
                                    self.s2l_protecting = value
                                    self.s2l_protecting.value_namespace = name_space
                                    self.s2l_protecting.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-secondary"):
                                    self.s2l_secondary = value
                                    self.s2l_secondary.value_namespace = name_space
                                    self.s2l_secondary.value_namespace_prefix = name_space_prefix
                                if(value_path == "shared"):
                                    self.shared = value
                                    self.shared.value_namespace = name_space
                                    self.shared.value_namespace_prefix = name_space_prefix


                        class ReverseLspFec(Entity):
                            """
                            Reverse Associated Bidir LSP FEC
                            
                            .. attribute:: fec_destination_info
                            
                            	Destination or P2MP ID
                            	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ReverseLspFec.FecDestinationInfo>`
                            
                            .. attribute:: fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: fec_lsp_id
                            
                            	LSP ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: fec_source
                            
                            	Tunnel source address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ReverseLspFec, self).__init__()

                                self.yang_name = "reverse-lsp-fec"
                                self.yang_parent_name = "s2l"

                                self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                self.fec_source = YLeaf(YType.str, "fec-source")

                                self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ReverseLspFec.FecDestinationInfo()
                                self.fec_destination_info.parent = self
                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                self._children_yang_names.add("fec-destination-info")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fec_extended_tunnel_id",
                                                "fec_lsp_id",
                                                "fec_source",
                                                "fec_tunnel_id",
                                                "fec_vrf") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ReverseLspFec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ReverseLspFec, self).__setattr__(name, value)


                            class FecDestinationInfo(Entity):
                                """
                                Destination or P2MP ID
                                
                                .. attribute:: fec_ctype
                                
                                	FEC CType
                                	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                .. attribute:: fec_destination_p2mp_id
                                
                                	P2MP ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: p2p_lsp_destination
                                
                                	P2P LSP destination
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__init__()

                                    self.yang_name = "fec-destination-info"
                                    self.yang_parent_name = "reverse-lsp-fec"

                                    self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                    self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                    self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("fec_ctype",
                                                    "fec_destination_p2mp_id",
                                                    "p2p_lsp_destination") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.fec_ctype.is_set or
                                        self.fec_destination_p2mp_id.is_set or
                                        self.p2p_lsp_destination.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.fec_ctype.yfilter != YFilter.not_set or
                                        self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                        self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "fec-destination-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                    if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                    if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "fec-ctype"):
                                        self.fec_ctype = value
                                        self.fec_ctype.value_namespace = name_space
                                        self.fec_ctype.value_namespace_prefix = name_space_prefix
                                    if(value_path == "fec-destination-p2mp-id"):
                                        self.fec_destination_p2mp_id = value
                                        self.fec_destination_p2mp_id.value_namespace = name_space
                                        self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "p2p-lsp-destination"):
                                        self.p2p_lsp_destination = value
                                        self.p2p_lsp_destination.value_namespace = name_space
                                        self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.fec_extended_tunnel_id.is_set or
                                    self.fec_lsp_id.is_set or
                                    self.fec_source.is_set or
                                    self.fec_tunnel_id.is_set or
                                    self.fec_vrf.is_set or
                                    (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                    self.fec_lsp_id.yfilter != YFilter.not_set or
                                    self.fec_source.yfilter != YFilter.not_set or
                                    self.fec_tunnel_id.yfilter != YFilter.not_set or
                                    self.fec_vrf.yfilter != YFilter.not_set or
                                    (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-lsp-fec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_source.get_name_leafdata())
                                if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "fec-destination-info"):
                                    if (self.fec_destination_info is None):
                                        self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ReverseLspFec.FecDestinationInfo()
                                        self.fec_destination_info.parent = self
                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                    return self.fec_destination_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fec-extended-tunnel-id"):
                                    self.fec_extended_tunnel_id = value
                                    self.fec_extended_tunnel_id.value_namespace = name_space
                                    self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-lsp-id"):
                                    self.fec_lsp_id = value
                                    self.fec_lsp_id.value_namespace = name_space
                                    self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-source"):
                                    self.fec_source = value
                                    self.fec_source.value_namespace = name_space
                                    self.fec_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-tunnel-id"):
                                    self.fec_tunnel_id = value
                                    self.fec_tunnel_id.value_namespace = name_space
                                    self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-vrf"):
                                    self.fec_vrf = value
                                    self.fec_vrf.value_namespace = name_space
                                    self.fec_vrf.value_namespace_prefix = name_space_prefix


                        class ReverseTspec(Entity):
                            """
                            The Reverse T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ReverseTspec, self).__init__()

                                self.yang_name = "reverse-tspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ReverseTspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ReverseTspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class FlexInfo(Entity):
                            """
                            FlexLSP S2L Information
                            
                            .. attribute:: bfd_created
                            
                            	GAL BFD Session Created
                            	**type**\:  bool
                            
                            .. attribute:: bfd_egress_label
                            
                            	BFD Egress Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: bfd_int_label
                            
                            	BFD Internal Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: bfd_next_hop
                            
                            	BFD Next Hop
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: bfd_out_ifh
                            
                            	BFD Out Interface Handle
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: bfd_tun_ifh
                            
                            	BFD Tunnel Interface Handle
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: bfd_up
                            
                            	GAL BFD Session Up
                            	**type**\:  bool
                            
                            .. attribute:: entry_exists
                            
                            	FlexLSP Entry Exists
                            	**type**\:  bool
                            
                            .. attribute:: fault_ais
                            
                            	Fault AIS
                            	**type**\:  bool
                            
                            .. attribute:: fault_ldi
                            
                            	Fault LDI
                            	**type**\:  bool
                            
                            .. attribute:: fault_ldi_lockout
                            
                            	Fault LDI Lockout
                            	**type**\:  bool
                            
                            .. attribute:: fault_lkr
                            
                            	Fault LKR
                            	**type**\:  bool
                            
                            .. attribute:: fault_time
                            
                            	Fault Time
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: flex_fec
                            
                            	FEC for the FlexLSP Entry
                            	**type**\:   :py:class:`FlexFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.FlexInfo.FlexFec>`
                            
                            .. attribute:: in_label
                            
                            	In Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: oam_created
                            
                            	OAM Entry Created
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.FlexInfo, self).__init__()

                                self.yang_name = "flex-info"
                                self.yang_parent_name = "s2l"

                                self.bfd_created = YLeaf(YType.boolean, "bfd-created")

                                self.bfd_egress_label = YLeaf(YType.uint32, "bfd-egress-label")

                                self.bfd_int_label = YLeaf(YType.uint32, "bfd-int-label")

                                self.bfd_next_hop = YLeaf(YType.str, "bfd-next-hop")

                                self.bfd_out_ifh = YLeaf(YType.str, "bfd-out-ifh")

                                self.bfd_tun_ifh = YLeaf(YType.str, "bfd-tun-ifh")

                                self.bfd_up = YLeaf(YType.boolean, "bfd-up")

                                self.entry_exists = YLeaf(YType.boolean, "entry-exists")

                                self.fault_ais = YLeaf(YType.boolean, "fault-ais")

                                self.fault_ldi = YLeaf(YType.boolean, "fault-ldi")

                                self.fault_ldi_lockout = YLeaf(YType.boolean, "fault-ldi-lockout")

                                self.fault_lkr = YLeaf(YType.boolean, "fault-lkr")

                                self.fault_time = YLeaf(YType.uint32, "fault-time")

                                self.in_label = YLeaf(YType.uint32, "in-label")

                                self.oam_created = YLeaf(YType.boolean, "oam-created")

                                self.flex_fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.FlexInfo.FlexFec()
                                self.flex_fec.parent = self
                                self._children_name_map["flex_fec"] = "flex-fec"
                                self._children_yang_names.add("flex-fec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("bfd_created",
                                                "bfd_egress_label",
                                                "bfd_int_label",
                                                "bfd_next_hop",
                                                "bfd_out_ifh",
                                                "bfd_tun_ifh",
                                                "bfd_up",
                                                "entry_exists",
                                                "fault_ais",
                                                "fault_ldi",
                                                "fault_ldi_lockout",
                                                "fault_lkr",
                                                "fault_time",
                                                "in_label",
                                                "oam_created") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.FlexInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.FlexInfo, self).__setattr__(name, value)


                            class FlexFec(Entity):
                                """
                                FEC for the FlexLSP Entry
                                
                                .. attribute:: s2l_fec_ctype
                                
                                	Session identifier (ctype)
                                	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                .. attribute:: s2l_fec_dest
                                
                                	sub\-LSP destination address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_extended_tunnel_id
                                
                                	Extended tunnel ID
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_lsp_id
                                
                                	LSP ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_p2mp_id
                                
                                	P2MP ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: s2l_fec_source
                                
                                	LSP source address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_subgroup_id
                                
                                	sub\-LSP subgroup ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_subgroup_originator
                                
                                	Subgroup Originator
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_tunnel_id
                                
                                	Tunnel ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_vrf
                                
                                	VRF; currently only for GMPLS tunnels
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.FlexInfo.FlexFec, self).__init__()

                                    self.yang_name = "flex-fec"
                                    self.yang_parent_name = "flex-info"

                                    self.s2l_fec_ctype = YLeaf(YType.enumeration, "s2l-fec-ctype")

                                    self.s2l_fec_dest = YLeaf(YType.str, "s2l-fec-dest")

                                    self.s2l_fec_extended_tunnel_id = YLeaf(YType.str, "s2l-fec-extended-tunnel-id")

                                    self.s2l_fec_lsp_id = YLeaf(YType.uint16, "s2l-fec-lsp-id")

                                    self.s2l_fec_p2mp_id = YLeaf(YType.uint32, "s2l-fec-p2mp-id")

                                    self.s2l_fec_source = YLeaf(YType.str, "s2l-fec-source")

                                    self.s2l_fec_subgroup_id = YLeaf(YType.uint16, "s2l-fec-subgroup-id")

                                    self.s2l_fec_subgroup_originator = YLeaf(YType.str, "s2l-fec-subgroup-originator")

                                    self.s2l_fec_tunnel_id = YLeaf(YType.uint16, "s2l-fec-tunnel-id")

                                    self.s2l_fec_vrf = YLeaf(YType.str, "s2l-fec-vrf")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("s2l_fec_ctype",
                                                    "s2l_fec_dest",
                                                    "s2l_fec_extended_tunnel_id",
                                                    "s2l_fec_lsp_id",
                                                    "s2l_fec_p2mp_id",
                                                    "s2l_fec_source",
                                                    "s2l_fec_subgroup_id",
                                                    "s2l_fec_subgroup_originator",
                                                    "s2l_fec_tunnel_id",
                                                    "s2l_fec_vrf") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.FlexInfo.FlexFec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.FlexInfo.FlexFec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.s2l_fec_ctype.is_set or
                                        self.s2l_fec_dest.is_set or
                                        self.s2l_fec_extended_tunnel_id.is_set or
                                        self.s2l_fec_lsp_id.is_set or
                                        self.s2l_fec_p2mp_id.is_set or
                                        self.s2l_fec_source.is_set or
                                        self.s2l_fec_subgroup_id.is_set or
                                        self.s2l_fec_subgroup_originator.is_set or
                                        self.s2l_fec_tunnel_id.is_set or
                                        self.s2l_fec_vrf.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.s2l_fec_ctype.yfilter != YFilter.not_set or
                                        self.s2l_fec_dest.yfilter != YFilter.not_set or
                                        self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_lsp_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_p2mp_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_source.yfilter != YFilter.not_set or
                                        self.s2l_fec_subgroup_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set or
                                        self.s2l_fec_tunnel_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_vrf.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "flex-fec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.s2l_fec_ctype.is_set or self.s2l_fec_ctype.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_ctype.get_name_leafdata())
                                    if (self.s2l_fec_dest.is_set or self.s2l_fec_dest.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_dest.get_name_leafdata())
                                    if (self.s2l_fec_extended_tunnel_id.is_set or self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_extended_tunnel_id.get_name_leafdata())
                                    if (self.s2l_fec_lsp_id.is_set or self.s2l_fec_lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_lsp_id.get_name_leafdata())
                                    if (self.s2l_fec_p2mp_id.is_set or self.s2l_fec_p2mp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_p2mp_id.get_name_leafdata())
                                    if (self.s2l_fec_source.is_set or self.s2l_fec_source.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_source.get_name_leafdata())
                                    if (self.s2l_fec_subgroup_id.is_set or self.s2l_fec_subgroup_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_subgroup_id.get_name_leafdata())
                                    if (self.s2l_fec_subgroup_originator.is_set or self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_subgroup_originator.get_name_leafdata())
                                    if (self.s2l_fec_tunnel_id.is_set or self.s2l_fec_tunnel_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_tunnel_id.get_name_leafdata())
                                    if (self.s2l_fec_vrf.is_set or self.s2l_fec_vrf.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_vrf.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "s2l-fec-ctype" or name == "s2l-fec-dest" or name == "s2l-fec-extended-tunnel-id" or name == "s2l-fec-lsp-id" or name == "s2l-fec-p2mp-id" or name == "s2l-fec-source" or name == "s2l-fec-subgroup-id" or name == "s2l-fec-subgroup-originator" or name == "s2l-fec-tunnel-id" or name == "s2l-fec-vrf"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "s2l-fec-ctype"):
                                        self.s2l_fec_ctype = value
                                        self.s2l_fec_ctype.value_namespace = name_space
                                        self.s2l_fec_ctype.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-dest"):
                                        self.s2l_fec_dest = value
                                        self.s2l_fec_dest.value_namespace = name_space
                                        self.s2l_fec_dest.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-extended-tunnel-id"):
                                        self.s2l_fec_extended_tunnel_id = value
                                        self.s2l_fec_extended_tunnel_id.value_namespace = name_space
                                        self.s2l_fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-lsp-id"):
                                        self.s2l_fec_lsp_id = value
                                        self.s2l_fec_lsp_id.value_namespace = name_space
                                        self.s2l_fec_lsp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-p2mp-id"):
                                        self.s2l_fec_p2mp_id = value
                                        self.s2l_fec_p2mp_id.value_namespace = name_space
                                        self.s2l_fec_p2mp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-source"):
                                        self.s2l_fec_source = value
                                        self.s2l_fec_source.value_namespace = name_space
                                        self.s2l_fec_source.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-subgroup-id"):
                                        self.s2l_fec_subgroup_id = value
                                        self.s2l_fec_subgroup_id.value_namespace = name_space
                                        self.s2l_fec_subgroup_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-subgroup-originator"):
                                        self.s2l_fec_subgroup_originator = value
                                        self.s2l_fec_subgroup_originator.value_namespace = name_space
                                        self.s2l_fec_subgroup_originator.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-tunnel-id"):
                                        self.s2l_fec_tunnel_id = value
                                        self.s2l_fec_tunnel_id.value_namespace = name_space
                                        self.s2l_fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-vrf"):
                                        self.s2l_fec_vrf = value
                                        self.s2l_fec_vrf.value_namespace = name_space
                                        self.s2l_fec_vrf.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.bfd_created.is_set or
                                    self.bfd_egress_label.is_set or
                                    self.bfd_int_label.is_set or
                                    self.bfd_next_hop.is_set or
                                    self.bfd_out_ifh.is_set or
                                    self.bfd_tun_ifh.is_set or
                                    self.bfd_up.is_set or
                                    self.entry_exists.is_set or
                                    self.fault_ais.is_set or
                                    self.fault_ldi.is_set or
                                    self.fault_ldi_lockout.is_set or
                                    self.fault_lkr.is_set or
                                    self.fault_time.is_set or
                                    self.in_label.is_set or
                                    self.oam_created.is_set or
                                    (self.flex_fec is not None and self.flex_fec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.bfd_created.yfilter != YFilter.not_set or
                                    self.bfd_egress_label.yfilter != YFilter.not_set or
                                    self.bfd_int_label.yfilter != YFilter.not_set or
                                    self.bfd_next_hop.yfilter != YFilter.not_set or
                                    self.bfd_out_ifh.yfilter != YFilter.not_set or
                                    self.bfd_tun_ifh.yfilter != YFilter.not_set or
                                    self.bfd_up.yfilter != YFilter.not_set or
                                    self.entry_exists.yfilter != YFilter.not_set or
                                    self.fault_ais.yfilter != YFilter.not_set or
                                    self.fault_ldi.yfilter != YFilter.not_set or
                                    self.fault_ldi_lockout.yfilter != YFilter.not_set or
                                    self.fault_lkr.yfilter != YFilter.not_set or
                                    self.fault_time.yfilter != YFilter.not_set or
                                    self.in_label.yfilter != YFilter.not_set or
                                    self.oam_created.yfilter != YFilter.not_set or
                                    (self.flex_fec is not None and self.flex_fec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "flex-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.bfd_created.is_set or self.bfd_created.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_created.get_name_leafdata())
                                if (self.bfd_egress_label.is_set or self.bfd_egress_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_egress_label.get_name_leafdata())
                                if (self.bfd_int_label.is_set or self.bfd_int_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_int_label.get_name_leafdata())
                                if (self.bfd_next_hop.is_set or self.bfd_next_hop.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_next_hop.get_name_leafdata())
                                if (self.bfd_out_ifh.is_set or self.bfd_out_ifh.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_out_ifh.get_name_leafdata())
                                if (self.bfd_tun_ifh.is_set or self.bfd_tun_ifh.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_tun_ifh.get_name_leafdata())
                                if (self.bfd_up.is_set or self.bfd_up.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_up.get_name_leafdata())
                                if (self.entry_exists.is_set or self.entry_exists.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry_exists.get_name_leafdata())
                                if (self.fault_ais.is_set or self.fault_ais.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ais.get_name_leafdata())
                                if (self.fault_ldi.is_set or self.fault_ldi.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ldi.get_name_leafdata())
                                if (self.fault_ldi_lockout.is_set or self.fault_ldi_lockout.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ldi_lockout.get_name_leafdata())
                                if (self.fault_lkr.is_set or self.fault_lkr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_lkr.get_name_leafdata())
                                if (self.fault_time.is_set or self.fault_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_time.get_name_leafdata())
                                if (self.in_label.is_set or self.in_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.in_label.get_name_leafdata())
                                if (self.oam_created.is_set or self.oam_created.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.oam_created.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "flex-fec"):
                                    if (self.flex_fec is None):
                                        self.flex_fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.FlexInfo.FlexFec()
                                        self.flex_fec.parent = self
                                        self._children_name_map["flex_fec"] = "flex-fec"
                                    return self.flex_fec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "flex-fec" or name == "bfd-created" or name == "bfd-egress-label" or name == "bfd-int-label" or name == "bfd-next-hop" or name == "bfd-out-ifh" or name == "bfd-tun-ifh" or name == "bfd-up" or name == "entry-exists" or name == "fault-ais" or name == "fault-ldi" or name == "fault-ldi-lockout" or name == "fault-lkr" or name == "fault-time" or name == "in-label" or name == "oam-created"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "bfd-created"):
                                    self.bfd_created = value
                                    self.bfd_created.value_namespace = name_space
                                    self.bfd_created.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-egress-label"):
                                    self.bfd_egress_label = value
                                    self.bfd_egress_label.value_namespace = name_space
                                    self.bfd_egress_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-int-label"):
                                    self.bfd_int_label = value
                                    self.bfd_int_label.value_namespace = name_space
                                    self.bfd_int_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-next-hop"):
                                    self.bfd_next_hop = value
                                    self.bfd_next_hop.value_namespace = name_space
                                    self.bfd_next_hop.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-out-ifh"):
                                    self.bfd_out_ifh = value
                                    self.bfd_out_ifh.value_namespace = name_space
                                    self.bfd_out_ifh.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-tun-ifh"):
                                    self.bfd_tun_ifh = value
                                    self.bfd_tun_ifh.value_namespace = name_space
                                    self.bfd_tun_ifh.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-up"):
                                    self.bfd_up = value
                                    self.bfd_up.value_namespace = name_space
                                    self.bfd_up.value_namespace_prefix = name_space_prefix
                                if(value_path == "entry-exists"):
                                    self.entry_exists = value
                                    self.entry_exists.value_namespace = name_space
                                    self.entry_exists.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ais"):
                                    self.fault_ais = value
                                    self.fault_ais.value_namespace = name_space
                                    self.fault_ais.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ldi"):
                                    self.fault_ldi = value
                                    self.fault_ldi.value_namespace = name_space
                                    self.fault_ldi.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ldi-lockout"):
                                    self.fault_ldi_lockout = value
                                    self.fault_ldi_lockout.value_namespace = name_space
                                    self.fault_ldi_lockout.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-lkr"):
                                    self.fault_lkr = value
                                    self.fault_lkr.value_namespace = name_space
                                    self.fault_lkr.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-time"):
                                    self.fault_time = value
                                    self.fault_time.value_namespace = name_space
                                    self.fault_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "in-label"):
                                    self.in_label = value
                                    self.in_label.value_namespace = name_space
                                    self.in_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "oam-created"):
                                    self.oam_created = value
                                    self.oam_created.value_namespace = name_space
                                    self.oam_created.value_namespace_prefix = name_space_prefix


                        class LspWrapInfo(Entity):
                            """
                            Lsp Wrap  Related information
                            
                            .. attribute:: lsp_wrap_protection_enable
                            
                            	LSP Wrap protection enabled
                            	**type**\:  bool
                            
                            .. attribute:: lsp_wrap_protection_label
                            
                            	LSP Wrap Merge Point Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: lsp_wrap_protection_state
                            
                            	LSP wrap protection state
                            	**type**\:   :py:class:`MplsTeLspWrapState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspWrapState>`
                            
                            .. attribute:: reverse_egress_interface
                            
                            	Reverse Egress Interface
                            	**type**\:  str
                            
                            .. attribute:: reverse_lsp_label
                            
                            	Reverse LSP label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.LspWrapInfo, self).__init__()

                                self.yang_name = "lsp-wrap-info"
                                self.yang_parent_name = "s2l"

                                self.lsp_wrap_protection_enable = YLeaf(YType.boolean, "lsp-wrap-protection-enable")

                                self.lsp_wrap_protection_label = YLeaf(YType.uint32, "lsp-wrap-protection-label")

                                self.lsp_wrap_protection_state = YLeaf(YType.enumeration, "lsp-wrap-protection-state")

                                self.reverse_egress_interface = YLeaf(YType.str, "reverse-egress-interface")

                                self.reverse_lsp_label = YLeaf(YType.uint32, "reverse-lsp-label")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("lsp_wrap_protection_enable",
                                                "lsp_wrap_protection_label",
                                                "lsp_wrap_protection_state",
                                                "reverse_egress_interface",
                                                "reverse_lsp_label") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.LspWrapInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.LspWrapInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.lsp_wrap_protection_enable.is_set or
                                    self.lsp_wrap_protection_label.is_set or
                                    self.lsp_wrap_protection_state.is_set or
                                    self.reverse_egress_interface.is_set or
                                    self.reverse_lsp_label.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_enable.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_label.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_state.yfilter != YFilter.not_set or
                                    self.reverse_egress_interface.yfilter != YFilter.not_set or
                                    self.reverse_lsp_label.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "lsp-wrap-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.lsp_wrap_protection_enable.is_set or self.lsp_wrap_protection_enable.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_enable.get_name_leafdata())
                                if (self.lsp_wrap_protection_label.is_set or self.lsp_wrap_protection_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_label.get_name_leafdata())
                                if (self.lsp_wrap_protection_state.is_set or self.lsp_wrap_protection_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_state.get_name_leafdata())
                                if (self.reverse_egress_interface.is_set or self.reverse_egress_interface.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reverse_egress_interface.get_name_leafdata())
                                if (self.reverse_lsp_label.is_set or self.reverse_lsp_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reverse_lsp_label.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "lsp-wrap-protection-enable" or name == "lsp-wrap-protection-label" or name == "lsp-wrap-protection-state" or name == "reverse-egress-interface" or name == "reverse-lsp-label"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "lsp-wrap-protection-enable"):
                                    self.lsp_wrap_protection_enable = value
                                    self.lsp_wrap_protection_enable.value_namespace = name_space
                                    self.lsp_wrap_protection_enable.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-wrap-protection-label"):
                                    self.lsp_wrap_protection_label = value
                                    self.lsp_wrap_protection_label.value_namespace = name_space
                                    self.lsp_wrap_protection_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-wrap-protection-state"):
                                    self.lsp_wrap_protection_state = value
                                    self.lsp_wrap_protection_state.value_namespace = name_space
                                    self.lsp_wrap_protection_state.value_namespace_prefix = name_space_prefix
                                if(value_path == "reverse-egress-interface"):
                                    self.reverse_egress_interface = value
                                    self.reverse_egress_interface.value_namespace = name_space
                                    self.reverse_egress_interface.value_namespace_prefix = name_space_prefix
                                if(value_path == "reverse-lsp-label"):
                                    self.reverse_lsp_label = value
                                    self.reverse_lsp_label.value_namespace = name_space
                                    self.reverse_lsp_label.value_namespace_prefix = name_space_prefix


                        class DiversityInfo(Entity):
                            """
                            S2L Diversity Information
                            
                            .. attribute:: diversity_type
                            
                            	S2L path diversity type
                            	**type**\:   :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.DiversityInfo, self).__init__()

                                self.yang_name = "diversity-info"
                                self.yang_parent_name = "s2l"

                                self.diversity_type = YLeaf(YType.enumeration, "diversity-type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("diversity_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.DiversityInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.DiversityInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return self.diversity_type.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.diversity_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "diversity-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.diversity_type.is_set or self.diversity_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.diversity_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "diversity-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "diversity-type"):
                                    self.diversity_type = value
                                    self.diversity_type.value_namespace = name_space
                                    self.diversity_type.value_namespace_prefix = name_space_prefix


                        class S2LReverseLspSubObj(Entity):
                            """
                            Reverse LSP Sub Objects
                            
                            .. attribute:: entry
                            
                            	
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.S2LReverseLspSubObj, self).__init__()

                                self.yang_name = "s2l-reverse-lsp-sub-obj"
                                self.yang_parent_name = "s2l"

                                self.entry = YLeaf(YType.uint8, "entry")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("entry") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.S2LReverseLspSubObj, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.S2LReverseLspSubObj, self).__setattr__(name, value)

                            def has_data(self):
                                return self.entry.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.entry.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-reverse-lsp-sub-obj" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "entry"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "entry"):
                                    self.entry = value
                                    self.entry.value_namespace = name_space
                                    self.entry.value_namespace_prefix = name_space_prefix


                        class SharedRiskLinkGroup(Entity):
                            """
                            The S2L's excluded srlg groups
                            
                            .. attribute:: shared_risk_group
                            
                            	SRLG number
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: srlg_name
                            
                            	SRLG name
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.SharedRiskLinkGroup, self).__init__()

                                self.yang_name = "shared-risk-link-group"
                                self.yang_parent_name = "s2l"

                                self.shared_risk_group = YLeaf(YType.uint32, "shared-risk-group")

                                self.srlg_name = YLeaf(YType.str, "srlg-name")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("shared_risk_group",
                                                "srlg_name") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.SharedRiskLinkGroup, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.SharedRiskLinkGroup, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.shared_risk_group.is_set or
                                    self.srlg_name.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.shared_risk_group.yfilter != YFilter.not_set or
                                    self.srlg_name.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "shared-risk-link-group" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.shared_risk_group.is_set or self.shared_risk_group.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.shared_risk_group.get_name_leafdata())
                                if (self.srlg_name.is_set or self.srlg_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.srlg_name.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "shared-risk-group" or name == "srlg-name"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "shared-risk-group"):
                                    self.shared_risk_group = value
                                    self.shared_risk_group.value_namespace = name_space
                                    self.shared_risk_group.value_namespace_prefix = name_space_prefix
                                if(value_path == "srlg-name"):
                                    self.srlg_name = value
                                    self.srlg_name.value_namespace = name_space
                                    self.srlg_name.value_namespace_prefix = name_space_prefix


                        class OutEro(Entity):
                            """
                            Outgoing ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutEro.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutEro.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutEro, self).__init__()

                                self.yang_name = "out-ero"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutEro.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutEro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutEro, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutEro.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "out-ero"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutEro.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutEro.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "out-ero"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutEro.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutEro.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "out-ero" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutEro.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutEro.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class InEro(Entity):
                            """
                            Incoming ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InEro.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InEro.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InEro, self).__init__()

                                self.yang_name = "in-ero"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InEro.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InEro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InEro, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InEro.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "in-ero"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InEro.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InEro.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "in-ero"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InEro.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InEro.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "in-ero" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InEro.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InEro.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class PathRro(Entity):
                            """
                            Path RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:   :py:class:`Ipv4RroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.Ipv4RroSubObject>`
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:   :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.LabelRroSubObject>`
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:   :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:   :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.SrlgRroSubObject>`
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:   :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.UnnumberedRroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro, self).__init__()

                                self.yang_name = "path-rro"
                                self.yang_parent_name = "s2l"

                                self.rro_type = YLeaf(YType.enumeration, "rro-type")

                                self.ipv4rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.Ipv4RroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                self._children_yang_names.add("ipv4rro-sub-object")

                                self.label_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                self._children_yang_names.add("label-rro-sub-object")

                                self.srlg_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._children_yang_names.add("srlg-rro-sub-object")

                                self.unnumbered_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                self._children_yang_names.add("unnumbered-rro-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("rro_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro, self).__setattr__(name, value)


                            class Ipv4RroSubObject(Entity):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.Ipv4RroSubObject.Flags>`
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.Ipv4RroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.rro_address = YLeaf(YType.str, "rro-address")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.Ipv4RroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("rro_address") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.Ipv4RroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.Ipv4RroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.rro_address.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.rro_address.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.rro_address.is_set or self.rro_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rro_address.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.Ipv4RroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "rro-address"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "rro-address"):
                                        self.rro_address = value
                                        self.rro_address.value_namespace = name_space
                                        self.rro_address.value_namespace_prefix = name_space_prefix


                            class LabelRroSubObject(Entity):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.LabelRroSubObject.Flags>`
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\:  bool
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of    :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.is_label_variable_length = YLeaf(YType.boolean, "is-label-variable-length")

                                    self.label = YLeaf(YType.uint32, "label")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                    self.variable_length_label = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_label_variable_length",
                                                    "label") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.LabelRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.LabelRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.is_global_label = YLeaf(YType.boolean, "is-global-label")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_global_label") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.is_global_label.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_global_label.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_global_label.is_set or self.is_global_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_global_label.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-global-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-global-label"):
                                            self.is_global_label = value
                                            self.is_global_label.value_namespace = name_space
                                            self.is_global_label.value_namespace_prefix = name_space_prefix


                                class VariableLengthLabel(Entity):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "variable-length-label" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.variable_length_label:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.is_label_variable_length.is_set or
                                        self.label.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    for c in self.variable_length_label:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_label_variable_length.yfilter != YFilter.not_set or
                                        self.label.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "label-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_label_variable_length.is_set or self.is_label_variable_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_label_variable_length.get_name_leafdata())
                                    if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.LabelRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    if (child_yang_name == "variable-length-label"):
                                        for c in self.variable_length_label:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.variable_length_label.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "variable-length-label" or name == "is-label-variable-length" or name == "label"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-label-variable-length"):
                                        self.is_label_variable_length = value
                                        self.is_label_variable_length.value_namespace = name_space
                                        self.is_label_variable_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label"):
                                        self.label = value
                                        self.label.value_namespace = name_space
                                        self.label.value_namespace_prefix = name_space_prefix


                            class UnnumberedRroSubObject(Entity):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.UnnumberedRroSubObject.Flags>`
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.interface_address = YLeaf(YType.str, "interface-address")

                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_address",
                                                    "interface_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.UnnumberedRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.UnnumberedRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.interface_address.is_set or
                                        self.interface_id.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_address.yfilter != YFilter.not_set or
                                        self.interface_id.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_address.is_set or self.interface_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_address.get_name_leafdata())
                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.UnnumberedRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "interface-address" or name == "interface-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-address"):
                                        self.interface_address = value
                                        self.interface_address.value_namespace = name_space
                                        self.interface_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-id"):
                                        self.interface_id = value
                                        self.interface_id.value_namespace = name_space
                                        self.interface_id.value_namespace_prefix = name_space_prefix


                            class SrlgRroSubObject(Entity):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of    :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.SrlgRroSubObject.SrlGs>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.srl_gs = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.SrlgRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.SrlgRroSubObject, self).__setattr__(name, value)


                                class SrlGs(Entity):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srl-gs" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.srl_gs:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.srl_gs:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "srlg-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "srl-gs"):
                                        for c in self.srl_gs:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.SrlgRroSubObject.SrlGs()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.srl_gs.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "srl-gs"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    self.rro_type.is_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_data()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_data()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_data()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.rro_type.yfilter != YFilter.not_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_operation()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_operation()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_operation()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-rro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.rro_type.is_set or self.rro_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rro_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4rro-sub-object"):
                                    if (self.ipv4rro_sub_object is None):
                                        self.ipv4rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.Ipv4RroSubObject()
                                        self.ipv4rro_sub_object.parent = self
                                        self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                    return self.ipv4rro_sub_object

                                if (child_yang_name == "label-rro-sub-object"):
                                    if (self.label_rro_sub_object is None):
                                        self.label_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.LabelRroSubObject()
                                        self.label_rro_sub_object.parent = self
                                        self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                    return self.label_rro_sub_object

                                if (child_yang_name == "srlg-rro-sub-object"):
                                    if (self.srlg_rro_sub_object is None):
                                        self.srlg_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.SrlgRroSubObject()
                                        self.srlg_rro_sub_object.parent = self
                                        self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                    return self.srlg_rro_sub_object

                                if (child_yang_name == "unnumbered-rro-sub-object"):
                                    if (self.unnumbered_rro_sub_object is None):
                                        self.unnumbered_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro.UnnumberedRroSubObject()
                                        self.unnumbered_rro_sub_object.parent = self
                                        self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                    return self.unnumbered_rro_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4rro-sub-object" or name == "label-rro-sub-object" or name == "srlg-rro-sub-object" or name == "unnumbered-rro-sub-object" or name == "rro-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "rro-type"):
                                    self.rro_type = value
                                    self.rro_type.value_namespace = name_space
                                    self.rro_type.value_namespace_prefix = name_space_prefix


                        class ResvRro(Entity):
                            """
                            Resv RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:   :py:class:`Ipv4RroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.Ipv4RroSubObject>`
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:   :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.LabelRroSubObject>`
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:   :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:   :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.SrlgRroSubObject>`
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:   :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro, self).__init__()

                                self.yang_name = "resv-rro"
                                self.yang_parent_name = "s2l"

                                self.rro_type = YLeaf(YType.enumeration, "rro-type")

                                self.ipv4rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.Ipv4RroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                self._children_yang_names.add("ipv4rro-sub-object")

                                self.label_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                self._children_yang_names.add("label-rro-sub-object")

                                self.srlg_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._children_yang_names.add("srlg-rro-sub-object")

                                self.unnumbered_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                self._children_yang_names.add("unnumbered-rro-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("rro_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro, self).__setattr__(name, value)


                            class Ipv4RroSubObject(Entity):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.Ipv4RroSubObject.Flags>`
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.Ipv4RroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.rro_address = YLeaf(YType.str, "rro-address")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.Ipv4RroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("rro_address") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.Ipv4RroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.Ipv4RroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.rro_address.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.rro_address.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.rro_address.is_set or self.rro_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rro_address.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.Ipv4RroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "rro-address"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "rro-address"):
                                        self.rro_address = value
                                        self.rro_address.value_namespace = name_space
                                        self.rro_address.value_namespace_prefix = name_space_prefix


                            class LabelRroSubObject(Entity):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.LabelRroSubObject.Flags>`
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\:  bool
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of    :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.is_label_variable_length = YLeaf(YType.boolean, "is-label-variable-length")

                                    self.label = YLeaf(YType.uint32, "label")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                    self.variable_length_label = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_label_variable_length",
                                                    "label") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.LabelRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.LabelRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.is_global_label = YLeaf(YType.boolean, "is-global-label")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_global_label") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.is_global_label.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_global_label.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_global_label.is_set or self.is_global_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_global_label.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-global-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-global-label"):
                                            self.is_global_label = value
                                            self.is_global_label.value_namespace = name_space
                                            self.is_global_label.value_namespace_prefix = name_space_prefix


                                class VariableLengthLabel(Entity):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "variable-length-label" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.variable_length_label:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.is_label_variable_length.is_set or
                                        self.label.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    for c in self.variable_length_label:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_label_variable_length.yfilter != YFilter.not_set or
                                        self.label.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "label-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_label_variable_length.is_set or self.is_label_variable_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_label_variable_length.get_name_leafdata())
                                    if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.LabelRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    if (child_yang_name == "variable-length-label"):
                                        for c in self.variable_length_label:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.variable_length_label.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "variable-length-label" or name == "is-label-variable-length" or name == "label"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-label-variable-length"):
                                        self.is_label_variable_length = value
                                        self.is_label_variable_length.value_namespace = name_space
                                        self.is_label_variable_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label"):
                                        self.label = value
                                        self.label.value_namespace = name_space
                                        self.label.value_namespace_prefix = name_space_prefix


                            class UnnumberedRroSubObject(Entity):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags>`
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.interface_address = YLeaf(YType.str, "interface-address")

                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_address",
                                                    "interface_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.interface_address.is_set or
                                        self.interface_id.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_address.yfilter != YFilter.not_set or
                                        self.interface_id.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_address.is_set or self.interface_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_address.get_name_leafdata())
                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "interface-address" or name == "interface-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-address"):
                                        self.interface_address = value
                                        self.interface_address.value_namespace = name_space
                                        self.interface_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-id"):
                                        self.interface_id = value
                                        self.interface_id.value_namespace = name_space
                                        self.interface_id.value_namespace_prefix = name_space_prefix


                            class SrlgRroSubObject(Entity):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of    :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.srl_gs = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.SrlgRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.SrlgRroSubObject, self).__setattr__(name, value)


                                class SrlGs(Entity):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srl-gs" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.srl_gs:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.srl_gs:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "srlg-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "srl-gs"):
                                        for c in self.srl_gs:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.srl_gs.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "srl-gs"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    self.rro_type.is_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_data()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_data()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_data()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.rro_type.yfilter != YFilter.not_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_operation()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_operation()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_operation()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "resv-rro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.rro_type.is_set or self.rro_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rro_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4rro-sub-object"):
                                    if (self.ipv4rro_sub_object is None):
                                        self.ipv4rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.Ipv4RroSubObject()
                                        self.ipv4rro_sub_object.parent = self
                                        self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                    return self.ipv4rro_sub_object

                                if (child_yang_name == "label-rro-sub-object"):
                                    if (self.label_rro_sub_object is None):
                                        self.label_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.LabelRroSubObject()
                                        self.label_rro_sub_object.parent = self
                                        self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                    return self.label_rro_sub_object

                                if (child_yang_name == "srlg-rro-sub-object"):
                                    if (self.srlg_rro_sub_object is None):
                                        self.srlg_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.SrlgRroSubObject()
                                        self.srlg_rro_sub_object.parent = self
                                        self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                    return self.srlg_rro_sub_object

                                if (child_yang_name == "unnumbered-rro-sub-object"):
                                    if (self.unnumbered_rro_sub_object is None):
                                        self.unnumbered_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro.UnnumberedRroSubObject()
                                        self.unnumbered_rro_sub_object.parent = self
                                        self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                    return self.unnumbered_rro_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4rro-sub-object" or name == "label-rro-sub-object" or name == "srlg-rro-sub-object" or name == "unnumbered-rro-sub-object" or name == "rro-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "rro-type"):
                                    self.rro_type = value
                                    self.rro_type.value_namespace = name_space
                                    self.rro_type.value_namespace_prefix = name_space_prefix


                        class PathAffinityArray(Entity):
                            """
                            Tunnel's Path hops with affinity
                            
                            .. attribute:: hop_address
                            
                            	Hop address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: hop_affinity
                            
                            	Deprecated
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: hop_extended_affinity
                            
                            	Hop affinity
                            	**type**\: list of    :py:class:`HopExtendedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathAffinityArray.HopExtendedAffinity>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathAffinityArray, self).__init__()

                                self.yang_name = "path-affinity-array"
                                self.yang_parent_name = "s2l"

                                self.hop_address = YLeaf(YType.str, "hop-address")

                                self.hop_affinity = YLeaf(YType.uint32, "hop-affinity")

                                self.hop_extended_affinity = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("hop_address",
                                                "hop_affinity") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathAffinityArray, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathAffinityArray, self).__setattr__(name, value)


                            class HopExtendedAffinity(Entity):
                                """
                                Hop affinity
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__init__()

                                    self.yang_name = "hop-extended-affinity"
                                    self.yang_parent_name = "path-affinity-array"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "hop-extended-affinity" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.hop_extended_affinity:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.hop_address.is_set or
                                    self.hop_affinity.is_set)

                            def has_operation(self):
                                for c in self.hop_extended_affinity:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.hop_address.yfilter != YFilter.not_set or
                                    self.hop_affinity.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-affinity-array" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.hop_address.is_set or self.hop_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hop_address.get_name_leafdata())
                                if (self.hop_affinity.is_set or self.hop_affinity.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hop_affinity.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "hop-extended-affinity"):
                                    for c in self.hop_extended_affinity:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathAffinityArray.HopExtendedAffinity()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.hop_extended_affinity.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "hop-extended-affinity" or name == "hop-address" or name == "hop-affinity"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "hop-address"):
                                    self.hop_address = value
                                    self.hop_address.value_namespace = name_space
                                    self.hop_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "hop-affinity"):
                                    self.hop_affinity = value
                                    self.hop_affinity.value_namespace = name_space
                                    self.hop_affinity.value_namespace_prefix = name_space_prefix


                        class ReverseEroIn(Entity):
                            """
                             Reverse Incoming ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ReverseEroIn.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ReverseEroIn.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ReverseEroIn, self).__init__()

                                self.yang_name = "reverse-ero-in"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ReverseEroIn.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ReverseEroIn.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ReverseEroIn, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ReverseEroIn, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-ero-in" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ReverseEroIn.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ReverseEroIn.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class S2LSegmentRoutingPath(Entity):
                            """
                            Segment\-Routing S2L path info
                            
                            .. attribute:: has_entropy_label
                            
                            	Hop has EL specified
                            	**type**\:  bool
                            
                            .. attribute:: has_ip_addresses
                            
                            	Node has IP addresses specified
                            	**type**\:  bool
                            
                            .. attribute:: has_mpls_label
                            
                            	Hop has MPLS label specified
                            	**type**\:  bool
                            
                            .. attribute:: local_addr
                            
                            	Local IP address of adjacency or Node ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: mpls_label_value
                            
                            	The MPLS label value
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: remote_addr
                            
                            	Remote IP address of adjacency
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: sid_type
                            
                            	Type of the SID
                            	**type**\:   :py:class:`TeSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrSid>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.S2LSegmentRoutingPath, self).__init__()

                                self.yang_name = "s2l-segment-routing-path"
                                self.yang_parent_name = "s2l"

                                self.has_entropy_label = YLeaf(YType.boolean, "has-entropy-label")

                                self.has_ip_addresses = YLeaf(YType.boolean, "has-ip-addresses")

                                self.has_mpls_label = YLeaf(YType.boolean, "has-mpls-label")

                                self.local_addr = YLeaf(YType.str, "local-addr")

                                self.mpls_label_value = YLeaf(YType.uint32, "mpls-label-value")

                                self.remote_addr = YLeaf(YType.str, "remote-addr")

                                self.sid_type = YLeaf(YType.enumeration, "sid-type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("has_entropy_label",
                                                "has_ip_addresses",
                                                "has_mpls_label",
                                                "local_addr",
                                                "mpls_label_value",
                                                "remote_addr",
                                                "sid_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.S2LSegmentRoutingPath, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.S2LSegmentRoutingPath, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.has_entropy_label.is_set or
                                    self.has_ip_addresses.is_set or
                                    self.has_mpls_label.is_set or
                                    self.local_addr.is_set or
                                    self.mpls_label_value.is_set or
                                    self.remote_addr.is_set or
                                    self.sid_type.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.has_entropy_label.yfilter != YFilter.not_set or
                                    self.has_ip_addresses.yfilter != YFilter.not_set or
                                    self.has_mpls_label.yfilter != YFilter.not_set or
                                    self.local_addr.yfilter != YFilter.not_set or
                                    self.mpls_label_value.yfilter != YFilter.not_set or
                                    self.remote_addr.yfilter != YFilter.not_set or
                                    self.sid_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-segment-routing-path" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.has_entropy_label.is_set or self.has_entropy_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_entropy_label.get_name_leafdata())
                                if (self.has_ip_addresses.is_set or self.has_ip_addresses.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_ip_addresses.get_name_leafdata())
                                if (self.has_mpls_label.is_set or self.has_mpls_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_mpls_label.get_name_leafdata())
                                if (self.local_addr.is_set or self.local_addr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_addr.get_name_leafdata())
                                if (self.mpls_label_value.is_set or self.mpls_label_value.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mpls_label_value.get_name_leafdata())
                                if (self.remote_addr.is_set or self.remote_addr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.remote_addr.get_name_leafdata())
                                if (self.sid_type.is_set or self.sid_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.sid_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "has-entropy-label" or name == "has-ip-addresses" or name == "has-mpls-label" or name == "local-addr" or name == "mpls-label-value" or name == "remote-addr" or name == "sid-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "has-entropy-label"):
                                    self.has_entropy_label = value
                                    self.has_entropy_label.value_namespace = name_space
                                    self.has_entropy_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-ip-addresses"):
                                    self.has_ip_addresses = value
                                    self.has_ip_addresses.value_namespace = name_space
                                    self.has_ip_addresses.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-mpls-label"):
                                    self.has_mpls_label = value
                                    self.has_mpls_label.value_namespace = name_space
                                    self.has_mpls_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "local-addr"):
                                    self.local_addr = value
                                    self.local_addr.value_namespace = name_space
                                    self.local_addr.value_namespace_prefix = name_space_prefix
                                if(value_path == "mpls-label-value"):
                                    self.mpls_label_value = value
                                    self.mpls_label_value.value_namespace = name_space
                                    self.mpls_label_value.value_namespace_prefix = name_space_prefix
                                if(value_path == "remote-addr"):
                                    self.remote_addr = value
                                    self.remote_addr.value_namespace = name_space
                                    self.remote_addr.value_namespace_prefix = name_space_prefix
                                if(value_path == "sid-type"):
                                    self.sid_type = value
                                    self.sid_type.value_namespace = name_space
                                    self.sid_type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.in_ero:
                                if (c.has_data()):
                                    return True
                            for c in self.out_ero:
                                if (c.has_data()):
                                    return True
                            for c in self.path_affinity_array:
                                if (c.has_data()):
                                    return True
                            for c in self.path_rro:
                                if (c.has_data()):
                                    return True
                            for c in self.resv_rro:
                                if (c.has_data()):
                                    return True
                            for c in self.reverse_ero_in:
                                if (c.has_data()):
                                    return True
                            for c in self.s2l_reverse_lsp_sub_obj:
                                if (c.has_data()):
                                    return True
                            for c in self.s2l_segment_routing_path:
                                if (c.has_data()):
                                    return True
                            for c in self.shared_risk_link_group:
                                if (c.has_data()):
                                    return True
                            return (
                                self.abr_auto_discovered.is_set or
                                self.backup_tunnel_interface.is_set or
                                self.downstream_router_id.is_set or
                                self.egress_interface.is_set or
                                self.egress_interface_brief.is_set or
                                self.egress_interface_state.is_set or
                                self.expanded_ero_affinity_bits.is_set or
                                self.expanded_ero_affinity_mask.is_set or
                                self.expanded_ero_area_id.is_set or
                                self.expanded_ero_metric.is_set or
                                self.expanded_ero_metric_type.is_set or
                                self.frr_out_tunnel_interface.is_set or
                                self.incoming_address.is_set or
                                self.ingress_interface.is_set or
                                self.ingress_interface_brief.is_set or
                                self.ingress_interface_state.is_set or
                                self.is_bandwidth_protect.is_set or
                                self.is_expanded_ero.is_set or
                                self.is_frr_enabled.is_set or
                                self.is_node_protected.is_set or
                                self.is_optical.is_set or
                                self.local_router_id.is_set or
                                self.next_hop_address.is_set or
                                self.node_hop_count.is_set or
                                self.outbound_frr_state.is_set or
                                self.path_reeval_query_mid.is_set or
                                self.path_rro_enabled.is_set or
                                self.path_using_strict_spf.is_set or
                                self.pcalc_area.is_set or
                                self.previous_hop_address.is_set or
                                self.reverse_lsp_connected.is_set or
                                self.reverse_lsp_name.is_set or
                                self.reverse_lsp_present.is_set or
                                self.reverse_weight.is_set or
                                self.role.is_set or
                                self.s2l_local_label.is_set or
                                self.s2l_out_label.is_set or
                                self.s2l_reverse_ero_obj_present.is_set or
                                self.s2l_reverse_tspec_obj_present.is_set or
                                self.signalling_status.is_set or
                                self.time_since_last_preferred_path_exists_send_mid.is_set or
                                self.time_since_last_preferred_tree_exists_send_mid.is_set or
                                self.time_since_last_query_received_mid.is_set or
                                self.upstream_router_id.is_set or
                                self.uptime.is_set or
                                self.weight.is_set or
                                (self.active_path_option is not None and self.active_path_option.has_data()) or
                                (self.association is not None and self.association.has_data()) or
                                (self.diversity_info is not None and self.diversity_info.has_data()) or
                                (self.flex_info is not None and self.flex_info.has_data()) or
                                (self.fspec is not None and self.fspec.has_data()) or
                                (self.generic_fspec is not None and self.generic_fspec.has_data()) or
                                (self.generic_tspec is not None and self.generic_tspec.has_data()) or
                                (self.gmpls_labels is not None and self.gmpls_labels.has_data()) or
                                (self.head_end_bfd_info is not None and self.head_end_bfd_info.has_data()) or
                                (self.in_xro is not None and self.in_xro.has_data()) or
                                (self.incoming_address_generic is not None and self.incoming_address_generic.has_data()) or
                                (self.lsp_wrap_info is not None and self.lsp_wrap_info.has_data()) or
                                (self.next_hop_address_generic is not None and self.next_hop_address_generic.has_data()) or
                                (self.otn_s2l is not None and self.otn_s2l.has_data()) or
                                (self.out_xro is not None and self.out_xro.has_data()) or
                                (self.previous_hop_address_generic is not None and self.previous_hop_address_generic.has_data()) or
                                (self.protection is not None and self.protection.has_data()) or
                                (self.reverse_lsp_fec is not None and self.reverse_lsp_fec.has_data()) or
                                (self.reverse_tspec is not None and self.reverse_tspec.has_data()) or
                                (self.s2l_convergence is not None and self.s2l_convergence.has_data()) or
                                (self.s2l_fec is not None and self.s2l_fec.has_data()) or
                                (self.soft_preemption is not None and self.soft_preemption.has_data()) or
                                (self.srlg_collection is not None and self.srlg_collection.has_data()) or
                                (self.tail_end_bfd_info is not None and self.tail_end_bfd_info.has_data()) or
                                (self.tspec is not None and self.tspec.has_data()))

                        def has_operation(self):
                            for c in self.in_ero:
                                if (c.has_operation()):
                                    return True
                            for c in self.out_ero:
                                if (c.has_operation()):
                                    return True
                            for c in self.path_affinity_array:
                                if (c.has_operation()):
                                    return True
                            for c in self.path_rro:
                                if (c.has_operation()):
                                    return True
                            for c in self.resv_rro:
                                if (c.has_operation()):
                                    return True
                            for c in self.reverse_ero_in:
                                if (c.has_operation()):
                                    return True
                            for c in self.s2l_reverse_lsp_sub_obj:
                                if (c.has_operation()):
                                    return True
                            for c in self.s2l_segment_routing_path:
                                if (c.has_operation()):
                                    return True
                            for c in self.shared_risk_link_group:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.abr_auto_discovered.yfilter != YFilter.not_set or
                                self.backup_tunnel_interface.yfilter != YFilter.not_set or
                                self.downstream_router_id.yfilter != YFilter.not_set or
                                self.egress_interface.yfilter != YFilter.not_set or
                                self.egress_interface_brief.yfilter != YFilter.not_set or
                                self.egress_interface_state.yfilter != YFilter.not_set or
                                self.expanded_ero_affinity_bits.yfilter != YFilter.not_set or
                                self.expanded_ero_affinity_mask.yfilter != YFilter.not_set or
                                self.expanded_ero_area_id.yfilter != YFilter.not_set or
                                self.expanded_ero_metric.yfilter != YFilter.not_set or
                                self.expanded_ero_metric_type.yfilter != YFilter.not_set or
                                self.frr_out_tunnel_interface.yfilter != YFilter.not_set or
                                self.incoming_address.yfilter != YFilter.not_set or
                                self.ingress_interface.yfilter != YFilter.not_set or
                                self.ingress_interface_brief.yfilter != YFilter.not_set or
                                self.ingress_interface_state.yfilter != YFilter.not_set or
                                self.is_bandwidth_protect.yfilter != YFilter.not_set or
                                self.is_expanded_ero.yfilter != YFilter.not_set or
                                self.is_frr_enabled.yfilter != YFilter.not_set or
                                self.is_node_protected.yfilter != YFilter.not_set or
                                self.is_optical.yfilter != YFilter.not_set or
                                self.local_router_id.yfilter != YFilter.not_set or
                                self.next_hop_address.yfilter != YFilter.not_set or
                                self.node_hop_count.yfilter != YFilter.not_set or
                                self.outbound_frr_state.yfilter != YFilter.not_set or
                                self.path_reeval_query_mid.yfilter != YFilter.not_set or
                                self.path_rro_enabled.yfilter != YFilter.not_set or
                                self.path_using_strict_spf.yfilter != YFilter.not_set or
                                self.pcalc_area.yfilter != YFilter.not_set or
                                self.previous_hop_address.yfilter != YFilter.not_set or
                                self.reverse_lsp_connected.yfilter != YFilter.not_set or
                                self.reverse_lsp_name.yfilter != YFilter.not_set or
                                self.reverse_lsp_present.yfilter != YFilter.not_set or
                                self.reverse_weight.yfilter != YFilter.not_set or
                                self.role.yfilter != YFilter.not_set or
                                self.s2l_local_label.yfilter != YFilter.not_set or
                                self.s2l_out_label.yfilter != YFilter.not_set or
                                self.s2l_reverse_ero_obj_present.yfilter != YFilter.not_set or
                                self.s2l_reverse_tspec_obj_present.yfilter != YFilter.not_set or
                                self.signalling_status.yfilter != YFilter.not_set or
                                self.time_since_last_preferred_path_exists_send_mid.yfilter != YFilter.not_set or
                                self.time_since_last_preferred_tree_exists_send_mid.yfilter != YFilter.not_set or
                                self.time_since_last_query_received_mid.yfilter != YFilter.not_set or
                                self.upstream_router_id.yfilter != YFilter.not_set or
                                self.uptime.yfilter != YFilter.not_set or
                                self.weight.yfilter != YFilter.not_set or
                                (self.active_path_option is not None and self.active_path_option.has_operation()) or
                                (self.association is not None and self.association.has_operation()) or
                                (self.diversity_info is not None and self.diversity_info.has_operation()) or
                                (self.flex_info is not None and self.flex_info.has_operation()) or
                                (self.fspec is not None and self.fspec.has_operation()) or
                                (self.generic_fspec is not None and self.generic_fspec.has_operation()) or
                                (self.generic_tspec is not None and self.generic_tspec.has_operation()) or
                                (self.gmpls_labels is not None and self.gmpls_labels.has_operation()) or
                                (self.head_end_bfd_info is not None and self.head_end_bfd_info.has_operation()) or
                                (self.in_xro is not None and self.in_xro.has_operation()) or
                                (self.incoming_address_generic is not None and self.incoming_address_generic.has_operation()) or
                                (self.lsp_wrap_info is not None and self.lsp_wrap_info.has_operation()) or
                                (self.next_hop_address_generic is not None and self.next_hop_address_generic.has_operation()) or
                                (self.otn_s2l is not None and self.otn_s2l.has_operation()) or
                                (self.out_xro is not None and self.out_xro.has_operation()) or
                                (self.previous_hop_address_generic is not None and self.previous_hop_address_generic.has_operation()) or
                                (self.protection is not None and self.protection.has_operation()) or
                                (self.reverse_lsp_fec is not None and self.reverse_lsp_fec.has_operation()) or
                                (self.reverse_tspec is not None and self.reverse_tspec.has_operation()) or
                                (self.s2l_convergence is not None and self.s2l_convergence.has_operation()) or
                                (self.s2l_fec is not None and self.s2l_fec.has_operation()) or
                                (self.soft_preemption is not None and self.soft_preemption.has_operation()) or
                                (self.srlg_collection is not None and self.srlg_collection.has_operation()) or
                                (self.tail_end_bfd_info is not None and self.tail_end_bfd_info.has_operation()) or
                                (self.tspec is not None and self.tspec.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "s2l" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.abr_auto_discovered.is_set or self.abr_auto_discovered.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.abr_auto_discovered.get_name_leafdata())
                            if (self.backup_tunnel_interface.is_set or self.backup_tunnel_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.backup_tunnel_interface.get_name_leafdata())
                            if (self.downstream_router_id.is_set or self.downstream_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.downstream_router_id.get_name_leafdata())
                            if (self.egress_interface.is_set or self.egress_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface.get_name_leafdata())
                            if (self.egress_interface_brief.is_set or self.egress_interface_brief.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface_brief.get_name_leafdata())
                            if (self.egress_interface_state.is_set or self.egress_interface_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface_state.get_name_leafdata())
                            if (self.expanded_ero_affinity_bits.is_set or self.expanded_ero_affinity_bits.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_affinity_bits.get_name_leafdata())
                            if (self.expanded_ero_affinity_mask.is_set or self.expanded_ero_affinity_mask.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_affinity_mask.get_name_leafdata())
                            if (self.expanded_ero_area_id.is_set or self.expanded_ero_area_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_area_id.get_name_leafdata())
                            if (self.expanded_ero_metric.is_set or self.expanded_ero_metric.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_metric.get_name_leafdata())
                            if (self.expanded_ero_metric_type.is_set or self.expanded_ero_metric_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_metric_type.get_name_leafdata())
                            if (self.frr_out_tunnel_interface.is_set or self.frr_out_tunnel_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.frr_out_tunnel_interface.get_name_leafdata())
                            if (self.incoming_address.is_set or self.incoming_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.incoming_address.get_name_leafdata())
                            if (self.ingress_interface.is_set or self.ingress_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface.get_name_leafdata())
                            if (self.ingress_interface_brief.is_set or self.ingress_interface_brief.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface_brief.get_name_leafdata())
                            if (self.ingress_interface_state.is_set or self.ingress_interface_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface_state.get_name_leafdata())
                            if (self.is_bandwidth_protect.is_set or self.is_bandwidth_protect.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_bandwidth_protect.get_name_leafdata())
                            if (self.is_expanded_ero.is_set or self.is_expanded_ero.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_expanded_ero.get_name_leafdata())
                            if (self.is_frr_enabled.is_set or self.is_frr_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_frr_enabled.get_name_leafdata())
                            if (self.is_node_protected.is_set or self.is_node_protected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_node_protected.get_name_leafdata())
                            if (self.is_optical.is_set or self.is_optical.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_optical.get_name_leafdata())
                            if (self.local_router_id.is_set or self.local_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.local_router_id.get_name_leafdata())
                            if (self.next_hop_address.is_set or self.next_hop_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.next_hop_address.get_name_leafdata())
                            if (self.node_hop_count.is_set or self.node_hop_count.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.node_hop_count.get_name_leafdata())
                            if (self.outbound_frr_state.is_set or self.outbound_frr_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.outbound_frr_state.get_name_leafdata())
                            if (self.path_reeval_query_mid.is_set or self.path_reeval_query_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reeval_query_mid.get_name_leafdata())
                            if (self.path_rro_enabled.is_set or self.path_rro_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_rro_enabled.get_name_leafdata())
                            if (self.path_using_strict_spf.is_set or self.path_using_strict_spf.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_using_strict_spf.get_name_leafdata())
                            if (self.pcalc_area.is_set or self.pcalc_area.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.pcalc_area.get_name_leafdata())
                            if (self.previous_hop_address.is_set or self.previous_hop_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.previous_hop_address.get_name_leafdata())
                            if (self.reverse_lsp_connected.is_set or self.reverse_lsp_connected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_connected.get_name_leafdata())
                            if (self.reverse_lsp_name.is_set or self.reverse_lsp_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_name.get_name_leafdata())
                            if (self.reverse_lsp_present.is_set or self.reverse_lsp_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_present.get_name_leafdata())
                            if (self.reverse_weight.is_set or self.reverse_weight.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_weight.get_name_leafdata())
                            if (self.role.is_set or self.role.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.role.get_name_leafdata())
                            if (self.s2l_local_label.is_set or self.s2l_local_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_local_label.get_name_leafdata())
                            if (self.s2l_out_label.is_set or self.s2l_out_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_out_label.get_name_leafdata())
                            if (self.s2l_reverse_ero_obj_present.is_set or self.s2l_reverse_ero_obj_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_reverse_ero_obj_present.get_name_leafdata())
                            if (self.s2l_reverse_tspec_obj_present.is_set or self.s2l_reverse_tspec_obj_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_reverse_tspec_obj_present.get_name_leafdata())
                            if (self.signalling_status.is_set or self.signalling_status.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.signalling_status.get_name_leafdata())
                            if (self.time_since_last_preferred_path_exists_send_mid.is_set or self.time_since_last_preferred_path_exists_send_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_preferred_path_exists_send_mid.get_name_leafdata())
                            if (self.time_since_last_preferred_tree_exists_send_mid.is_set or self.time_since_last_preferred_tree_exists_send_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_preferred_tree_exists_send_mid.get_name_leafdata())
                            if (self.time_since_last_query_received_mid.is_set or self.time_since_last_query_received_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_query_received_mid.get_name_leafdata())
                            if (self.upstream_router_id.is_set or self.upstream_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.upstream_router_id.get_name_leafdata())
                            if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.uptime.get_name_leafdata())
                            if (self.weight.is_set or self.weight.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.weight.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "active-path-option"):
                                if (self.active_path_option is None):
                                    self.active_path_option = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ActivePathOption()
                                    self.active_path_option.parent = self
                                    self._children_name_map["active_path_option"] = "active-path-option"
                                return self.active_path_option

                            if (child_yang_name == "association"):
                                if (self.association is None):
                                    self.association = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.Association()
                                    self.association.parent = self
                                    self._children_name_map["association"] = "association"
                                return self.association

                            if (child_yang_name == "diversity-info"):
                                if (self.diversity_info is None):
                                    self.diversity_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.DiversityInfo()
                                    self.diversity_info.parent = self
                                    self._children_name_map["diversity_info"] = "diversity-info"
                                return self.diversity_info

                            if (child_yang_name == "flex-info"):
                                if (self.flex_info is None):
                                    self.flex_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.FlexInfo()
                                    self.flex_info.parent = self
                                    self._children_name_map["flex_info"] = "flex-info"
                                return self.flex_info

                            if (child_yang_name == "fspec"):
                                if (self.fspec is None):
                                    self.fspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.Fspec()
                                    self.fspec.parent = self
                                    self._children_name_map["fspec"] = "fspec"
                                return self.fspec

                            if (child_yang_name == "generic-fspec"):
                                if (self.generic_fspec is None):
                                    self.generic_fspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GenericFspec()
                                    self.generic_fspec.parent = self
                                    self._children_name_map["generic_fspec"] = "generic-fspec"
                                return self.generic_fspec

                            if (child_yang_name == "generic-tspec"):
                                if (self.generic_tspec is None):
                                    self.generic_tspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GenericTspec()
                                    self.generic_tspec.parent = self
                                    self._children_name_map["generic_tspec"] = "generic-tspec"
                                return self.generic_tspec

                            if (child_yang_name == "gmpls-labels"):
                                if (self.gmpls_labels is None):
                                    self.gmpls_labels = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.GmplsLabels()
                                    self.gmpls_labels.parent = self
                                    self._children_name_map["gmpls_labels"] = "gmpls-labels"
                                return self.gmpls_labels

                            if (child_yang_name == "head-end-bfd-info"):
                                if (self.head_end_bfd_info is None):
                                    self.head_end_bfd_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.HeadEndBfdInfo()
                                    self.head_end_bfd_info.parent = self
                                    self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"
                                return self.head_end_bfd_info

                            if (child_yang_name == "in-ero"):
                                for c in self.in_ero:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InEro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.in_ero.append(c)
                                return c

                            if (child_yang_name == "in-xro"):
                                if (self.in_xro is None):
                                    self.in_xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.InXro()
                                    self.in_xro.parent = self
                                    self._children_name_map["in_xro"] = "in-xro"
                                return self.in_xro

                            if (child_yang_name == "incoming-address-generic"):
                                if (self.incoming_address_generic is None):
                                    self.incoming_address_generic = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.IncomingAddressGeneric()
                                    self.incoming_address_generic.parent = self
                                    self._children_name_map["incoming_address_generic"] = "incoming-address-generic"
                                return self.incoming_address_generic

                            if (child_yang_name == "lsp-wrap-info"):
                                if (self.lsp_wrap_info is None):
                                    self.lsp_wrap_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.LspWrapInfo()
                                    self.lsp_wrap_info.parent = self
                                    self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"
                                return self.lsp_wrap_info

                            if (child_yang_name == "next-hop-address-generic"):
                                if (self.next_hop_address_generic is None):
                                    self.next_hop_address_generic = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.NextHopAddressGeneric()
                                    self.next_hop_address_generic.parent = self
                                    self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"
                                return self.next_hop_address_generic

                            if (child_yang_name == "otn-s2l"):
                                if (self.otn_s2l is None):
                                    self.otn_s2l = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OtnS2L()
                                    self.otn_s2l.parent = self
                                    self._children_name_map["otn_s2l"] = "otn-s2l"
                                return self.otn_s2l

                            if (child_yang_name == "out-ero"):
                                for c in self.out_ero:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutEro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.out_ero.append(c)
                                return c

                            if (child_yang_name == "out-xro"):
                                if (self.out_xro is None):
                                    self.out_xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.OutXro()
                                    self.out_xro.parent = self
                                    self._children_name_map["out_xro"] = "out-xro"
                                return self.out_xro

                            if (child_yang_name == "path-affinity-array"):
                                for c in self.path_affinity_array:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathAffinityArray()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_affinity_array.append(c)
                                return c

                            if (child_yang_name == "path-rro"):
                                for c in self.path_rro:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PathRro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_rro.append(c)
                                return c

                            if (child_yang_name == "previous-hop-address-generic"):
                                if (self.previous_hop_address_generic is None):
                                    self.previous_hop_address_generic = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.PreviousHopAddressGeneric()
                                    self.previous_hop_address_generic.parent = self
                                    self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"
                                return self.previous_hop_address_generic

                            if (child_yang_name == "protection"):
                                if (self.protection is None):
                                    self.protection = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.Protection()
                                    self.protection.parent = self
                                    self._children_name_map["protection"] = "protection"
                                return self.protection

                            if (child_yang_name == "resv-rro"):
                                for c in self.resv_rro:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ResvRro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.resv_rro.append(c)
                                return c

                            if (child_yang_name == "reverse-ero-in"):
                                for c in self.reverse_ero_in:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ReverseEroIn()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.reverse_ero_in.append(c)
                                return c

                            if (child_yang_name == "reverse-lsp-fec"):
                                if (self.reverse_lsp_fec is None):
                                    self.reverse_lsp_fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ReverseLspFec()
                                    self.reverse_lsp_fec.parent = self
                                    self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"
                                return self.reverse_lsp_fec

                            if (child_yang_name == "reverse-tspec"):
                                if (self.reverse_tspec is None):
                                    self.reverse_tspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.ReverseTspec()
                                    self.reverse_tspec.parent = self
                                    self._children_name_map["reverse_tspec"] = "reverse-tspec"
                                return self.reverse_tspec

                            if (child_yang_name == "s2l-convergence"):
                                if (self.s2l_convergence is None):
                                    self.s2l_convergence = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.S2LConvergence()
                                    self.s2l_convergence.parent = self
                                    self._children_name_map["s2l_convergence"] = "s2l-convergence"
                                return self.s2l_convergence

                            if (child_yang_name == "s2l-fec"):
                                if (self.s2l_fec is None):
                                    self.s2l_fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.S2LFec()
                                    self.s2l_fec.parent = self
                                    self._children_name_map["s2l_fec"] = "s2l-fec"
                                return self.s2l_fec

                            if (child_yang_name == "s2l-reverse-lsp-sub-obj"):
                                for c in self.s2l_reverse_lsp_sub_obj:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.S2LReverseLspSubObj()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.s2l_reverse_lsp_sub_obj.append(c)
                                return c

                            if (child_yang_name == "s2l-segment-routing-path"):
                                for c in self.s2l_segment_routing_path:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.S2LSegmentRoutingPath()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.s2l_segment_routing_path.append(c)
                                return c

                            if (child_yang_name == "shared-risk-link-group"):
                                for c in self.shared_risk_link_group:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.SharedRiskLinkGroup()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.shared_risk_link_group.append(c)
                                return c

                            if (child_yang_name == "soft-preemption"):
                                if (self.soft_preemption is None):
                                    self.soft_preemption = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.SoftPreemption()
                                    self.soft_preemption.parent = self
                                    self._children_name_map["soft_preemption"] = "soft-preemption"
                                return self.soft_preemption

                            if (child_yang_name == "srlg-collection"):
                                if (self.srlg_collection is None):
                                    self.srlg_collection = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.SrlgCollection()
                                    self.srlg_collection.parent = self
                                    self._children_name_map["srlg_collection"] = "srlg-collection"
                                return self.srlg_collection

                            if (child_yang_name == "tail-end-bfd-info"):
                                if (self.tail_end_bfd_info is None):
                                    self.tail_end_bfd_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.TailEndBfdInfo()
                                    self.tail_end_bfd_info.parent = self
                                    self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"
                                return self.tail_end_bfd_info

                            if (child_yang_name == "tspec"):
                                if (self.tspec is None):
                                    self.tspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L.Tspec()
                                    self.tspec.parent = self
                                    self._children_name_map["tspec"] = "tspec"
                                return self.tspec

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "active-path-option" or name == "association" or name == "diversity-info" or name == "flex-info" or name == "fspec" or name == "generic-fspec" or name == "generic-tspec" or name == "gmpls-labels" or name == "head-end-bfd-info" or name == "in-ero" or name == "in-xro" or name == "incoming-address-generic" or name == "lsp-wrap-info" or name == "next-hop-address-generic" or name == "otn-s2l" or name == "out-ero" or name == "out-xro" or name == "path-affinity-array" or name == "path-rro" or name == "previous-hop-address-generic" or name == "protection" or name == "resv-rro" or name == "reverse-ero-in" or name == "reverse-lsp-fec" or name == "reverse-tspec" or name == "s2l-convergence" or name == "s2l-fec" or name == "s2l-reverse-lsp-sub-obj" or name == "s2l-segment-routing-path" or name == "shared-risk-link-group" or name == "soft-preemption" or name == "srlg-collection" or name == "tail-end-bfd-info" or name == "tspec" or name == "abr-auto-discovered" or name == "backup-tunnel-interface" or name == "downstream-router-id" or name == "egress-interface" or name == "egress-interface-brief" or name == "egress-interface-state" or name == "expanded-ero-affinity-bits" or name == "expanded-ero-affinity-mask" or name == "expanded-ero-area-id" or name == "expanded-ero-metric" or name == "expanded-ero-metric-type" or name == "frr-out-tunnel-interface" or name == "incoming-address" or name == "ingress-interface" or name == "ingress-interface-brief" or name == "ingress-interface-state" or name == "is-bandwidth-protect" or name == "is-expanded-ero" or name == "is-frr-enabled" or name == "is-node-protected" or name == "is-optical" or name == "local-router-id" or name == "next-hop-address" or name == "node-hop-count" or name == "outbound-frr-state" or name == "path-reeval-query-mid" or name == "path-rro-enabled" or name == "path-using-strict-spf" or name == "pcalc-area" or name == "previous-hop-address" or name == "reverse-lsp-connected" or name == "reverse-lsp-name" or name == "reverse-lsp-present" or name == "reverse-weight" or name == "role" or name == "s2l-local-label" or name == "s2l-out-label" or name == "s2l-reverse-ero-obj-present" or name == "s2l-reverse-tspec-obj-present" or name == "signalling-status" or name == "time-since-last-preferred-path-exists-send-mid" or name == "time-since-last-preferred-tree-exists-send-mid" or name == "time-since-last-query-received-mid" or name == "upstream-router-id" or name == "uptime" or name == "weight"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "abr-auto-discovered"):
                                self.abr_auto_discovered = value
                                self.abr_auto_discovered.value_namespace = name_space
                                self.abr_auto_discovered.value_namespace_prefix = name_space_prefix
                            if(value_path == "backup-tunnel-interface"):
                                self.backup_tunnel_interface = value
                                self.backup_tunnel_interface.value_namespace = name_space
                                self.backup_tunnel_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "downstream-router-id"):
                                self.downstream_router_id = value
                                self.downstream_router_id.value_namespace = name_space
                                self.downstream_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface"):
                                self.egress_interface = value
                                self.egress_interface.value_namespace = name_space
                                self.egress_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface-brief"):
                                self.egress_interface_brief = value
                                self.egress_interface_brief.value_namespace = name_space
                                self.egress_interface_brief.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface-state"):
                                self.egress_interface_state = value
                                self.egress_interface_state.value_namespace = name_space
                                self.egress_interface_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-affinity-bits"):
                                self.expanded_ero_affinity_bits = value
                                self.expanded_ero_affinity_bits.value_namespace = name_space
                                self.expanded_ero_affinity_bits.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-affinity-mask"):
                                self.expanded_ero_affinity_mask = value
                                self.expanded_ero_affinity_mask.value_namespace = name_space
                                self.expanded_ero_affinity_mask.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-area-id"):
                                self.expanded_ero_area_id = value
                                self.expanded_ero_area_id.value_namespace = name_space
                                self.expanded_ero_area_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-metric"):
                                self.expanded_ero_metric = value
                                self.expanded_ero_metric.value_namespace = name_space
                                self.expanded_ero_metric.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-metric-type"):
                                self.expanded_ero_metric_type = value
                                self.expanded_ero_metric_type.value_namespace = name_space
                                self.expanded_ero_metric_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "frr-out-tunnel-interface"):
                                self.frr_out_tunnel_interface = value
                                self.frr_out_tunnel_interface.value_namespace = name_space
                                self.frr_out_tunnel_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "incoming-address"):
                                self.incoming_address = value
                                self.incoming_address.value_namespace = name_space
                                self.incoming_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface"):
                                self.ingress_interface = value
                                self.ingress_interface.value_namespace = name_space
                                self.ingress_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface-brief"):
                                self.ingress_interface_brief = value
                                self.ingress_interface_brief.value_namespace = name_space
                                self.ingress_interface_brief.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface-state"):
                                self.ingress_interface_state = value
                                self.ingress_interface_state.value_namespace = name_space
                                self.ingress_interface_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-bandwidth-protect"):
                                self.is_bandwidth_protect = value
                                self.is_bandwidth_protect.value_namespace = name_space
                                self.is_bandwidth_protect.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-expanded-ero"):
                                self.is_expanded_ero = value
                                self.is_expanded_ero.value_namespace = name_space
                                self.is_expanded_ero.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-frr-enabled"):
                                self.is_frr_enabled = value
                                self.is_frr_enabled.value_namespace = name_space
                                self.is_frr_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-node-protected"):
                                self.is_node_protected = value
                                self.is_node_protected.value_namespace = name_space
                                self.is_node_protected.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-optical"):
                                self.is_optical = value
                                self.is_optical.value_namespace = name_space
                                self.is_optical.value_namespace_prefix = name_space_prefix
                            if(value_path == "local-router-id"):
                                self.local_router_id = value
                                self.local_router_id.value_namespace = name_space
                                self.local_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "next-hop-address"):
                                self.next_hop_address = value
                                self.next_hop_address.value_namespace = name_space
                                self.next_hop_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "node-hop-count"):
                                self.node_hop_count = value
                                self.node_hop_count.value_namespace = name_space
                                self.node_hop_count.value_namespace_prefix = name_space_prefix
                            if(value_path == "outbound-frr-state"):
                                self.outbound_frr_state = value
                                self.outbound_frr_state.value_namespace = name_space
                                self.outbound_frr_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reeval-query-mid"):
                                self.path_reeval_query_mid = value
                                self.path_reeval_query_mid.value_namespace = name_space
                                self.path_reeval_query_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-rro-enabled"):
                                self.path_rro_enabled = value
                                self.path_rro_enabled.value_namespace = name_space
                                self.path_rro_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-using-strict-spf"):
                                self.path_using_strict_spf = value
                                self.path_using_strict_spf.value_namespace = name_space
                                self.path_using_strict_spf.value_namespace_prefix = name_space_prefix
                            if(value_path == "pcalc-area"):
                                self.pcalc_area = value
                                self.pcalc_area.value_namespace = name_space
                                self.pcalc_area.value_namespace_prefix = name_space_prefix
                            if(value_path == "previous-hop-address"):
                                self.previous_hop_address = value
                                self.previous_hop_address.value_namespace = name_space
                                self.previous_hop_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-connected"):
                                self.reverse_lsp_connected = value
                                self.reverse_lsp_connected.value_namespace = name_space
                                self.reverse_lsp_connected.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-name"):
                                self.reverse_lsp_name = value
                                self.reverse_lsp_name.value_namespace = name_space
                                self.reverse_lsp_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-present"):
                                self.reverse_lsp_present = value
                                self.reverse_lsp_present.value_namespace = name_space
                                self.reverse_lsp_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-weight"):
                                self.reverse_weight = value
                                self.reverse_weight.value_namespace = name_space
                                self.reverse_weight.value_namespace_prefix = name_space_prefix
                            if(value_path == "role"):
                                self.role = value
                                self.role.value_namespace = name_space
                                self.role.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-local-label"):
                                self.s2l_local_label = value
                                self.s2l_local_label.value_namespace = name_space
                                self.s2l_local_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-out-label"):
                                self.s2l_out_label = value
                                self.s2l_out_label.value_namespace = name_space
                                self.s2l_out_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-reverse-ero-obj-present"):
                                self.s2l_reverse_ero_obj_present = value
                                self.s2l_reverse_ero_obj_present.value_namespace = name_space
                                self.s2l_reverse_ero_obj_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-reverse-tspec-obj-present"):
                                self.s2l_reverse_tspec_obj_present = value
                                self.s2l_reverse_tspec_obj_present.value_namespace = name_space
                                self.s2l_reverse_tspec_obj_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "signalling-status"):
                                self.signalling_status = value
                                self.signalling_status.value_namespace = name_space
                                self.signalling_status.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-preferred-path-exists-send-mid"):
                                self.time_since_last_preferred_path_exists_send_mid = value
                                self.time_since_last_preferred_path_exists_send_mid.value_namespace = name_space
                                self.time_since_last_preferred_path_exists_send_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-preferred-tree-exists-send-mid"):
                                self.time_since_last_preferred_tree_exists_send_mid = value
                                self.time_since_last_preferred_tree_exists_send_mid.value_namespace = name_space
                                self.time_since_last_preferred_tree_exists_send_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-query-received-mid"):
                                self.time_since_last_query_received_mid = value
                                self.time_since_last_query_received_mid.value_namespace = name_space
                                self.time_since_last_query_received_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "upstream-router-id"):
                                self.upstream_router_id = value
                                self.upstream_router_id.value_namespace = name_space
                                self.upstream_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "uptime"):
                                self.uptime = value
                                self.uptime.value_namespace = name_space
                                self.uptime.value_namespace_prefix = name_space_prefix
                            if(value_path == "weight"):
                                self.weight = value
                                self.weight.value_namespace = name_space
                                self.weight.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.s2l:
                            if (c.has_data()):
                                return True
                        return (
                            self.dste_class_index.is_set or
                            self.dste_class_match.is_set or
                            self.frr_active_reason.is_set or
                            self.is_frr_failed.is_set or
                            self.is_interface.is_set or
                            self.is_passive.is_set or
                            self.last_path_change.is_set or
                            self.lsp_bandwidth.is_set or
                            self.lsp_bandwidth_type.is_set or
                            self.lsp_hold_priority.is_set or
                            self.lsp_setup_priority.is_set or
                            self.persistent_bytes.is_set or
                            self.persistent_packets.is_set or
                            self.reoptimize_reason.is_set or
                            self.reoptimize_trigger.is_set or
                            self.s2_ls_down.is_set or
                            self.s2_ls_proceeding.is_set or
                            self.s2_ls_up.is_set or
                            self.signaled_name.is_set or
                            self.timer_left.is_set or
                            self.type.is_set or
                            self.uptime.is_set or
                            (self.lsp_fec is not None and self.lsp_fec.has_data()))

                    def has_operation(self):
                        for c in self.s2l:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.dste_class_index.yfilter != YFilter.not_set or
                            self.dste_class_match.yfilter != YFilter.not_set or
                            self.frr_active_reason.yfilter != YFilter.not_set or
                            self.is_frr_failed.yfilter != YFilter.not_set or
                            self.is_interface.yfilter != YFilter.not_set or
                            self.is_passive.yfilter != YFilter.not_set or
                            self.last_path_change.yfilter != YFilter.not_set or
                            self.lsp_bandwidth.yfilter != YFilter.not_set or
                            self.lsp_bandwidth_type.yfilter != YFilter.not_set or
                            self.lsp_hold_priority.yfilter != YFilter.not_set or
                            self.lsp_setup_priority.yfilter != YFilter.not_set or
                            self.persistent_bytes.yfilter != YFilter.not_set or
                            self.persistent_packets.yfilter != YFilter.not_set or
                            self.reoptimize_reason.yfilter != YFilter.not_set or
                            self.reoptimize_trigger.yfilter != YFilter.not_set or
                            self.s2_ls_down.yfilter != YFilter.not_set or
                            self.s2_ls_proceeding.yfilter != YFilter.not_set or
                            self.s2_ls_up.yfilter != YFilter.not_set or
                            self.signaled_name.yfilter != YFilter.not_set or
                            self.timer_left.yfilter != YFilter.not_set or
                            self.type.yfilter != YFilter.not_set or
                            self.uptime.yfilter != YFilter.not_set or
                            (self.lsp_fec is not None and self.lsp_fec.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "reoptimized-standby-p2mp-lsp" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.dste_class_index.is_set or self.dste_class_index.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.dste_class_index.get_name_leafdata())
                        if (self.dste_class_match.is_set or self.dste_class_match.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.dste_class_match.get_name_leafdata())
                        if (self.frr_active_reason.is_set or self.frr_active_reason.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.frr_active_reason.get_name_leafdata())
                        if (self.is_frr_failed.is_set or self.is_frr_failed.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_frr_failed.get_name_leafdata())
                        if (self.is_interface.is_set or self.is_interface.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_interface.get_name_leafdata())
                        if (self.is_passive.is_set or self.is_passive.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_passive.get_name_leafdata())
                        if (self.last_path_change.is_set or self.last_path_change.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.last_path_change.get_name_leafdata())
                        if (self.lsp_bandwidth.is_set or self.lsp_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_bandwidth.get_name_leafdata())
                        if (self.lsp_bandwidth_type.is_set or self.lsp_bandwidth_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_bandwidth_type.get_name_leafdata())
                        if (self.lsp_hold_priority.is_set or self.lsp_hold_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_hold_priority.get_name_leafdata())
                        if (self.lsp_setup_priority.is_set or self.lsp_setup_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_setup_priority.get_name_leafdata())
                        if (self.persistent_bytes.is_set or self.persistent_bytes.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.persistent_bytes.get_name_leafdata())
                        if (self.persistent_packets.is_set or self.persistent_packets.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.persistent_packets.get_name_leafdata())
                        if (self.reoptimize_reason.is_set or self.reoptimize_reason.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reoptimize_reason.get_name_leafdata())
                        if (self.reoptimize_trigger.is_set or self.reoptimize_trigger.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reoptimize_trigger.get_name_leafdata())
                        if (self.s2_ls_down.is_set or self.s2_ls_down.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_down.get_name_leafdata())
                        if (self.s2_ls_proceeding.is_set or self.s2_ls_proceeding.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_proceeding.get_name_leafdata())
                        if (self.s2_ls_up.is_set or self.s2_ls_up.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_up.get_name_leafdata())
                        if (self.signaled_name.is_set or self.signaled_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.signaled_name.get_name_leafdata())
                        if (self.timer_left.is_set or self.timer_left.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.timer_left.get_name_leafdata())
                        if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.type.get_name_leafdata())
                        if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.uptime.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "lsp-fec"):
                            if (self.lsp_fec is None):
                                self.lsp_fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.LspFec()
                                self.lsp_fec.parent = self
                                self._children_name_map["lsp_fec"] = "lsp-fec"
                            return self.lsp_fec

                        if (child_yang_name == "s2l"):
                            for c in self.s2l:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp.S2L()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.s2l.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "lsp-fec" or name == "s2l" or name == "dste-class-index" or name == "dste-class-match" or name == "frr-active-reason" or name == "is-frr-failed" or name == "is-interface" or name == "is-passive" or name == "last-path-change" or name == "lsp-bandwidth" or name == "lsp-bandwidth-type" or name == "lsp-hold-priority" or name == "lsp-setup-priority" or name == "persistent-bytes" or name == "persistent-packets" or name == "reoptimize-reason" or name == "reoptimize-trigger" or name == "s2-ls-down" or name == "s2-ls-proceeding" or name == "s2-ls-up" or name == "signaled-name" or name == "timer-left" or name == "type" or name == "uptime"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "dste-class-index"):
                            self.dste_class_index = value
                            self.dste_class_index.value_namespace = name_space
                            self.dste_class_index.value_namespace_prefix = name_space_prefix
                        if(value_path == "dste-class-match"):
                            self.dste_class_match = value
                            self.dste_class_match.value_namespace = name_space
                            self.dste_class_match.value_namespace_prefix = name_space_prefix
                        if(value_path == "frr-active-reason"):
                            self.frr_active_reason = value
                            self.frr_active_reason.value_namespace = name_space
                            self.frr_active_reason.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-frr-failed"):
                            self.is_frr_failed = value
                            self.is_frr_failed.value_namespace = name_space
                            self.is_frr_failed.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-interface"):
                            self.is_interface = value
                            self.is_interface.value_namespace = name_space
                            self.is_interface.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-passive"):
                            self.is_passive = value
                            self.is_passive.value_namespace = name_space
                            self.is_passive.value_namespace_prefix = name_space_prefix
                        if(value_path == "last-path-change"):
                            self.last_path_change = value
                            self.last_path_change.value_namespace = name_space
                            self.last_path_change.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-bandwidth"):
                            self.lsp_bandwidth = value
                            self.lsp_bandwidth.value_namespace = name_space
                            self.lsp_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-bandwidth-type"):
                            self.lsp_bandwidth_type = value
                            self.lsp_bandwidth_type.value_namespace = name_space
                            self.lsp_bandwidth_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-hold-priority"):
                            self.lsp_hold_priority = value
                            self.lsp_hold_priority.value_namespace = name_space
                            self.lsp_hold_priority.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-setup-priority"):
                            self.lsp_setup_priority = value
                            self.lsp_setup_priority.value_namespace = name_space
                            self.lsp_setup_priority.value_namespace_prefix = name_space_prefix
                        if(value_path == "persistent-bytes"):
                            self.persistent_bytes = value
                            self.persistent_bytes.value_namespace = name_space
                            self.persistent_bytes.value_namespace_prefix = name_space_prefix
                        if(value_path == "persistent-packets"):
                            self.persistent_packets = value
                            self.persistent_packets.value_namespace = name_space
                            self.persistent_packets.value_namespace_prefix = name_space_prefix
                        if(value_path == "reoptimize-reason"):
                            self.reoptimize_reason = value
                            self.reoptimize_reason.value_namespace = name_space
                            self.reoptimize_reason.value_namespace_prefix = name_space_prefix
                        if(value_path == "reoptimize-trigger"):
                            self.reoptimize_trigger = value
                            self.reoptimize_trigger.value_namespace = name_space
                            self.reoptimize_trigger.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-down"):
                            self.s2_ls_down = value
                            self.s2_ls_down.value_namespace = name_space
                            self.s2_ls_down.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-proceeding"):
                            self.s2_ls_proceeding = value
                            self.s2_ls_proceeding.value_namespace = name_space
                            self.s2_ls_proceeding.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-up"):
                            self.s2_ls_up = value
                            self.s2_ls_up.value_namespace = name_space
                            self.s2_ls_up.value_namespace_prefix = name_space_prefix
                        if(value_path == "signaled-name"):
                            self.signaled_name = value
                            self.signaled_name.value_namespace = name_space
                            self.signaled_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "timer-left"):
                            self.timer_left = value
                            self.timer_left.value_namespace = name_space
                            self.timer_left.value_namespace_prefix = name_space_prefix
                        if(value_path == "type"):
                            self.type = value
                            self.type.value_namespace = name_space
                            self.type.value_namespace_prefix = name_space_prefix
                        if(value_path == "uptime"):
                            self.uptime = value
                            self.uptime.value_namespace = name_space
                            self.uptime.value_namespace_prefix = name_space_prefix


                class TunnelRestorationLsp(Entity):
                    """
                    Restoration LSP
                    
                    .. attribute:: dste_class_index
                    
                    	Matching DSTE class index
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: dste_class_match
                    
                    	Do the class type and priority match a DSTE class
                    	**type**\:  bool
                    
                    .. attribute:: frr_active_reason
                    
                    	P2MP LSP FRR active reason
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: is_frr_failed
                    
                    	P2MP LSP has FRR Failed
                    	**type**\:  bool
                    
                    .. attribute:: is_interface
                    
                    	True for tunnel head
                    	**type**\:  bool
                    
                    .. attribute:: is_passive
                    
                    	True for passive tunnel
                    	**type**\:  bool
                    
                    .. attribute:: last_path_change
                    
                    	Time in seconds since the last path change
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: lsp_bandwidth
                    
                    	P2MP LSP Bandwidth
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: lsp_bandwidth_type
                    
                    	The LSP bandwidth type
                    	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                    
                    .. attribute:: lsp_fec
                    
                    	FEC for the LSP
                    	**type**\:   :py:class:`LspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.LspFec>`
                    
                    .. attribute:: lsp_hold_priority
                    
                    	LSP hold priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: lsp_setup_priority
                    
                    	LSP setup priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: persistent_bytes
                    
                    	Persistent forwarding statistics for number of bytes. Clear counters will not reset the counter
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**units**\: byte
                    
                    .. attribute:: persistent_packets
                    
                    	Persistent forwarding statistics for Number of packets. Clear counters will not reset the counter
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: reoptimize_reason
                    
                    	Reason for re\-optimization
                    	**type**\:   :py:class:`MplsTeReoptDecisionReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReoptDecisionReason>`
                    
                    .. attribute:: reoptimize_trigger
                    
                    	Re\-optimize trigger
                    	**type**\:   :py:class:`MteReoptTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteReoptTrigger>`
                    
                    .. attribute:: s2_ls_down
                    
                    	Number of down S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2_ls_proceeding
                    
                    	Number of proceeding S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2_ls_up
                    
                    	Number of connected S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2l
                    
                    	array of S2L structures
                    	**type**\: list of    :py:class:`S2L <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L>`
                    
                    .. attribute:: signaled_name
                    
                    	Signaled Name
                    	**type**\:  str
                    
                    .. attribute:: timer_left
                    
                    	Time in seconds left to take next action if any
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: type
                    
                    	The type of this LSP
                    	**type**\:   :py:class:`MplsTeLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLsp>`
                    
                    .. attribute:: uptime
                    
                    	Time in seconds since the tunnel was up
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp, self).__init__()

                        self.yang_name = "tunnel-restoration-lsp"
                        self.yang_parent_name = "tunnel-head"

                        self.dste_class_index = YLeaf(YType.uint8, "dste-class-index")

                        self.dste_class_match = YLeaf(YType.boolean, "dste-class-match")

                        self.frr_active_reason = YLeaf(YType.uint32, "frr-active-reason")

                        self.is_frr_failed = YLeaf(YType.boolean, "is-frr-failed")

                        self.is_interface = YLeaf(YType.boolean, "is-interface")

                        self.is_passive = YLeaf(YType.boolean, "is-passive")

                        self.last_path_change = YLeaf(YType.uint32, "last-path-change")

                        self.lsp_bandwidth = YLeaf(YType.uint32, "lsp-bandwidth")

                        self.lsp_bandwidth_type = YLeaf(YType.enumeration, "lsp-bandwidth-type")

                        self.lsp_hold_priority = YLeaf(YType.uint8, "lsp-hold-priority")

                        self.lsp_setup_priority = YLeaf(YType.uint8, "lsp-setup-priority")

                        self.persistent_bytes = YLeaf(YType.uint64, "persistent-bytes")

                        self.persistent_packets = YLeaf(YType.uint64, "persistent-packets")

                        self.reoptimize_reason = YLeaf(YType.enumeration, "reoptimize-reason")

                        self.reoptimize_trigger = YLeaf(YType.enumeration, "reoptimize-trigger")

                        self.s2_ls_down = YLeaf(YType.uint32, "s2-ls-down")

                        self.s2_ls_proceeding = YLeaf(YType.uint32, "s2-ls-proceeding")

                        self.s2_ls_up = YLeaf(YType.uint32, "s2-ls-up")

                        self.signaled_name = YLeaf(YType.str, "signaled-name")

                        self.timer_left = YLeaf(YType.uint32, "timer-left")

                        self.type = YLeaf(YType.enumeration, "type")

                        self.uptime = YLeaf(YType.uint32, "uptime")

                        self.lsp_fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.LspFec()
                        self.lsp_fec.parent = self
                        self._children_name_map["lsp_fec"] = "lsp-fec"
                        self._children_yang_names.add("lsp-fec")

                        self.s2l = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("dste_class_index",
                                        "dste_class_match",
                                        "frr_active_reason",
                                        "is_frr_failed",
                                        "is_interface",
                                        "is_passive",
                                        "last_path_change",
                                        "lsp_bandwidth",
                                        "lsp_bandwidth_type",
                                        "lsp_hold_priority",
                                        "lsp_setup_priority",
                                        "persistent_bytes",
                                        "persistent_packets",
                                        "reoptimize_reason",
                                        "reoptimize_trigger",
                                        "s2_ls_down",
                                        "s2_ls_proceeding",
                                        "s2_ls_up",
                                        "signaled_name",
                                        "timer_left",
                                        "type",
                                        "uptime") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp, self).__setattr__(name, value)


                    class LspFec(Entity):
                        """
                        FEC for the LSP
                        
                        .. attribute:: fec_destination_info
                        
                        	Destination or P2MP ID
                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.LspFec.FecDestinationInfo>`
                        
                        .. attribute:: fec_extended_tunnel_id
                        
                        	Extended tunnel ID
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: fec_lsp_id
                        
                        	LSP ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: fec_source
                        
                        	Tunnel source address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: fec_tunnel_id
                        
                        	Tunnel ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: fec_vrf
                        
                        	VRF; currently only for GMPLS tunnels
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.LspFec, self).__init__()

                            self.yang_name = "lsp-fec"
                            self.yang_parent_name = "tunnel-restoration-lsp"

                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                            self.fec_source = YLeaf(YType.str, "fec-source")

                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                            self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.LspFec.FecDestinationInfo()
                            self.fec_destination_info.parent = self
                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                            self._children_yang_names.add("fec-destination-info")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("fec_extended_tunnel_id",
                                            "fec_lsp_id",
                                            "fec_source",
                                            "fec_tunnel_id",
                                            "fec_vrf") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.LspFec, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.LspFec, self).__setattr__(name, value)


                        class FecDestinationInfo(Entity):
                            """
                            Destination or P2MP ID
                            
                            .. attribute:: fec_ctype
                            
                            	FEC CType
                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            .. attribute:: fec_destination_p2mp_id
                            
                            	P2MP ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: p2p_lsp_destination
                            
                            	P2P LSP destination
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.LspFec.FecDestinationInfo, self).__init__()

                                self.yang_name = "fec-destination-info"
                                self.yang_parent_name = "lsp-fec"

                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fec_ctype",
                                                "fec_destination_p2mp_id",
                                                "p2p_lsp_destination") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.LspFec.FecDestinationInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.LspFec.FecDestinationInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.fec_ctype.is_set or
                                    self.fec_destination_p2mp_id.is_set or
                                    self.p2p_lsp_destination.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fec_ctype.yfilter != YFilter.not_set or
                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fec-destination-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fec-ctype"):
                                    self.fec_ctype = value
                                    self.fec_ctype.value_namespace = name_space
                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-destination-p2mp-id"):
                                    self.fec_destination_p2mp_id = value
                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "p2p-lsp-destination"):
                                    self.p2p_lsp_destination = value
                                    self.p2p_lsp_destination.value_namespace = name_space
                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.fec_extended_tunnel_id.is_set or
                                self.fec_lsp_id.is_set or
                                self.fec_source.is_set or
                                self.fec_tunnel_id.is_set or
                                self.fec_vrf.is_set or
                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                self.fec_source.yfilter != YFilter.not_set or
                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                self.fec_vrf.yfilter != YFilter.not_set or
                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "lsp-fec" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "fec-destination-info"):
                                if (self.fec_destination_info is None):
                                    self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.LspFec.FecDestinationInfo()
                                    self.fec_destination_info.parent = self
                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                return self.fec_destination_info

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "fec-extended-tunnel-id"):
                                self.fec_extended_tunnel_id = value
                                self.fec_extended_tunnel_id.value_namespace = name_space
                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-lsp-id"):
                                self.fec_lsp_id = value
                                self.fec_lsp_id.value_namespace = name_space
                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-source"):
                                self.fec_source = value
                                self.fec_source.value_namespace = name_space
                                self.fec_source.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-tunnel-id"):
                                self.fec_tunnel_id = value
                                self.fec_tunnel_id.value_namespace = name_space
                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-vrf"):
                                self.fec_vrf = value
                                self.fec_vrf.value_namespace = name_space
                                self.fec_vrf.value_namespace_prefix = name_space_prefix


                    class S2L(Entity):
                        """
                        array of S2L structures
                        
                        .. attribute:: abr_auto_discovered
                        
                        	Next ABR auto discovered
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: active_path_option
                        
                        	The path option used to find the path for this S2L
                        	**type**\:   :py:class:`ActivePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption>`
                        
                        .. attribute:: association
                        
                        	Association Object
                        	**type**\:   :py:class:`Association <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.Association>`
                        
                        .. attribute:: backup_tunnel_interface
                        
                        	Interface handle of the backup tunnel
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        .. attribute:: diversity_info
                        
                        	S2L Diversity Information
                        	**type**\:   :py:class:`DiversityInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.DiversityInfo>`
                        
                        .. attribute:: downstream_router_id
                        
                        	Downstream router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: egress_interface
                        
                        	Egress Interface
                        	**type**\:  str
                        
                        .. attribute:: egress_interface_brief
                        
                        	Egress Interface in brief format
                        	**type**\:  str
                        
                        .. attribute:: egress_interface_state
                        
                        	State of Outgoing Interface
                        	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        .. attribute:: expanded_ero_affinity_bits
                        
                        	The Outgoing ERO's affinity bits (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_affinity_mask
                        
                        	The Outgoing ERO's affinity mask (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_area_id
                        
                        	Indicates the protocol and area used to find Outgoing ERO
                        	**type**\:  str
                        
                        .. attribute:: expanded_ero_metric
                        
                        	The metric value of the expanded path
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_metric_type
                        
                        	The Outgoing ERO's selection metric
                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                        
                        .. attribute:: flex_info
                        
                        	FlexLSP S2L Information
                        	**type**\:   :py:class:`FlexInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.FlexInfo>`
                        
                        .. attribute:: frr_out_tunnel_interface
                        
                        	FRR out tunnel intface
                        	**type**\:  str
                        
                        .. attribute:: fspec
                        
                        	The F spec info
                        	**type**\:   :py:class:`Fspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.Fspec>`
                        
                        .. attribute:: generic_fspec
                        
                        	Generic FSpec
                        	**type**\:   :py:class:`GenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GenericFspec>`
                        
                        .. attribute:: generic_tspec
                        
                        	Generic TSpec
                        	**type**\:   :py:class:`GenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GenericTspec>`
                        
                        .. attribute:: gmpls_labels
                        
                        	GMPLS labels
                        	**type**\:   :py:class:`GmplsLabels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels>`
                        
                        .. attribute:: head_end_bfd_info
                        
                        	The Head\-end BFD info
                        	**type**\:   :py:class:`HeadEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.HeadEndBfdInfo>`
                        
                        .. attribute:: in_ero
                        
                        	Incoming ERO for this S2L
                        	**type**\: list of    :py:class:`InEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InEro>`
                        
                        .. attribute:: in_xro
                        
                        	Incoming XRO for this S2L
                        	**type**\:   :py:class:`InXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro>`
                        
                        .. attribute:: incoming_address
                        
                        	Incoming interface address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: incoming_address_generic
                        
                        	Incoming interface address
                        	**type**\:   :py:class:`IncomingAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.IncomingAddressGeneric>`
                        
                        .. attribute:: ingress_interface
                        
                        	Ingress Interface
                        	**type**\:  str
                        
                        .. attribute:: ingress_interface_brief
                        
                        	Ingress Interface in brief format
                        	**type**\:  str
                        
                        .. attribute:: ingress_interface_state
                        
                        	State of Incoming Interface
                        	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        .. attribute:: is_bandwidth_protect
                        
                        	BW Protection Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_expanded_ero
                        
                        	TRUE if this LSR expanded a loose path
                        	**type**\:  bool
                        
                        .. attribute:: is_frr_enabled
                        
                        	FRR Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_node_protected
                        
                        	Node Protection Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_optical
                        
                        	Is Optical
                        	**type**\:  bool
                        
                        .. attribute:: local_router_id
                        
                        	Local router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: lsp_wrap_info
                        
                        	Lsp Wrap  Related information
                        	**type**\:   :py:class:`LspWrapInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.LspWrapInfo>`
                        
                        .. attribute:: next_hop_address
                        
                        	Next hop address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: next_hop_address_generic
                        
                        	Next hop address
                        	**type**\:   :py:class:`NextHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.NextHopAddressGeneric>`
                        
                        .. attribute:: node_hop_count
                        
                        	Hop count
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        .. attribute:: otn_s2l
                        
                        	Otn S2L Information
                        	**type**\:   :py:class:`OtnS2L <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L>`
                        
                        .. attribute:: out_ero
                        
                        	Outgoing ERO for this S2L
                        	**type**\: list of    :py:class:`OutEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutEro>`
                        
                        .. attribute:: out_xro
                        
                        	Outgoing XRO for this S2L
                        	**type**\:   :py:class:`OutXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro>`
                        
                        .. attribute:: outbound_frr_state
                        
                        	Indicates outbound FRR state
                        	**type**\:   :py:class:`MplsTeFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrState>`
                        
                        .. attribute:: path_affinity_array
                        
                        	Tunnel's Path hops with affinity
                        	**type**\: list of    :py:class:`PathAffinityArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathAffinityArray>`
                        
                        .. attribute:: path_reeval_query_mid
                        
                        	Loose path reevaluation query received at mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: path_rro
                        
                        	Path RRO for this S2L
                        	**type**\: list of    :py:class:`PathRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro>`
                        
                        .. attribute:: path_rro_enabled
                        
                        	Path RRO Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: path_using_strict_spf
                        
                        	Path is using Strict SPF
                        	**type**\:  bool
                        
                        .. attribute:: pcalc_area
                        
                        	IGP\-area in which the S2L path was calculated
                        	**type**\:  str
                        
                        .. attribute:: previous_hop_address
                        
                        	Previous hop address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: previous_hop_address_generic
                        
                        	Previous hop address
                        	**type**\:   :py:class:`PreviousHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PreviousHopAddressGeneric>`
                        
                        .. attribute:: protection
                        
                        	Protection Object
                        	**type**\:   :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.Protection>`
                        
                        .. attribute:: resv_rro
                        
                        	Resv RRO for this S2L
                        	**type**\: list of    :py:class:`ResvRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro>`
                        
                        .. attribute:: reverse_ero_in
                        
                        	 Reverse Incoming ERO for this S2L
                        	**type**\: list of    :py:class:`ReverseEroIn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ReverseEroIn>`
                        
                        .. attribute:: reverse_lsp_connected
                        
                        	Reverse Associated Bidir LSP Connected
                        	**type**\:  bool
                        
                        .. attribute:: reverse_lsp_fec
                        
                        	Reverse Associated Bidir LSP FEC
                        	**type**\:   :py:class:`ReverseLspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ReverseLspFec>`
                        
                        .. attribute:: reverse_lsp_name
                        
                        	Reverse Associated Bidir LSP Name
                        	**type**\:  str
                        
                        .. attribute:: reverse_lsp_present
                        
                        	Reverse Associated Bidir LSP Present
                        	**type**\:  bool
                        
                        .. attribute:: reverse_tspec
                        
                        	The Reverse T spec info
                        	**type**\:   :py:class:`ReverseTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ReverseTspec>`
                        
                        .. attribute:: reverse_weight
                        
                        	The reverse path weight
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: role
                        
                        	Role of S2L
                        	**type**\:   :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        .. attribute:: s2l_convergence
                        
                        	TE LSP convergence related information
                        	**type**\:   :py:class:`S2LConvergence <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.S2LConvergence>`
                        
                        .. attribute:: s2l_fec
                        
                        	FEC for the S2L
                        	**type**\:   :py:class:`S2LFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.S2LFec>`
                        
                        .. attribute:: s2l_local_label
                        
                        	Local label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: s2l_out_label
                        
                        	Outgoing label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: s2l_reverse_ero_obj_present
                        
                        	 S2l Reverse ERO Object Present
                        	**type**\:  bool
                        
                        .. attribute:: s2l_reverse_lsp_sub_obj
                        
                        	Reverse LSP Sub Objects
                        	**type**\: list of    :py:class:`S2LReverseLspSubObj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.S2LReverseLspSubObj>`
                        
                        .. attribute:: s2l_reverse_tspec_obj_present
                        
                        	 S2L Reverse TSpec Object Present
                        	**type**\:  bool
                        
                        .. attribute:: s2l_segment_routing_path
                        
                        	Segment\-Routing S2L path info
                        	**type**\: list of    :py:class:`S2LSegmentRoutingPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.S2LSegmentRoutingPath>`
                        
                        .. attribute:: shared_risk_link_group
                        
                        	The S2L's excluded srlg groups
                        	**type**\: list of    :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.SharedRiskLinkGroup>`
                        
                        .. attribute:: signalling_status
                        
                        	Signaling status
                        	**type**\:   :py:class:`MplsTeTunnelsSignalingStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelsSignalingStatus>`
                        
                        .. attribute:: soft_preemption
                        
                        	The soft preemption info for this LSP
                        	**type**\:   :py:class:`SoftPreemption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.SoftPreemption>`
                        
                        .. attribute:: srlg_collection
                        
                        	SRLG\-collection data
                        	**type**\:   :py:class:`SrlgCollection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.SrlgCollection>`
                        
                        .. attribute:: tail_end_bfd_info
                        
                        	The Tail\-end BFD info
                        	**type**\:   :py:class:`TailEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.TailEndBfdInfo>`
                        
                        .. attribute:: time_since_last_preferred_path_exists_send_mid
                        
                        	Time since last preferred path exists msg send from mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: time_since_last_preferred_tree_exists_send_mid
                        
                        	Time since last preferred tree exists msg send from mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: time_since_last_query_received_mid
                        
                        	Time since last reevaluation query received at mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tspec
                        
                        	The T spec info
                        	**type**\:   :py:class:`Tspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.Tspec>`
                        
                        .. attribute:: upstream_router_id
                        
                        	Upstream router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: uptime
                        
                        	Time in seconds since the tunnel was up
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: weight
                        
                        	The path's weight
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L, self).__init__()

                            self.yang_name = "s2l"
                            self.yang_parent_name = "tunnel-restoration-lsp"

                            self.abr_auto_discovered = YLeaf(YType.str, "abr-auto-discovered")

                            self.backup_tunnel_interface = YLeaf(YType.str, "backup-tunnel-interface")

                            self.downstream_router_id = YLeaf(YType.str, "downstream-router-id")

                            self.egress_interface = YLeaf(YType.str, "egress-interface")

                            self.egress_interface_brief = YLeaf(YType.str, "egress-interface-brief")

                            self.egress_interface_state = YLeaf(YType.enumeration, "egress-interface-state")

                            self.expanded_ero_affinity_bits = YLeaf(YType.uint32, "expanded-ero-affinity-bits")

                            self.expanded_ero_affinity_mask = YLeaf(YType.uint32, "expanded-ero-affinity-mask")

                            self.expanded_ero_area_id = YLeaf(YType.str, "expanded-ero-area-id")

                            self.expanded_ero_metric = YLeaf(YType.uint32, "expanded-ero-metric")

                            self.expanded_ero_metric_type = YLeaf(YType.enumeration, "expanded-ero-metric-type")

                            self.frr_out_tunnel_interface = YLeaf(YType.str, "frr-out-tunnel-interface")

                            self.incoming_address = YLeaf(YType.str, "incoming-address")

                            self.ingress_interface = YLeaf(YType.str, "ingress-interface")

                            self.ingress_interface_brief = YLeaf(YType.str, "ingress-interface-brief")

                            self.ingress_interface_state = YLeaf(YType.enumeration, "ingress-interface-state")

                            self.is_bandwidth_protect = YLeaf(YType.boolean, "is-bandwidth-protect")

                            self.is_expanded_ero = YLeaf(YType.boolean, "is-expanded-ero")

                            self.is_frr_enabled = YLeaf(YType.boolean, "is-frr-enabled")

                            self.is_node_protected = YLeaf(YType.boolean, "is-node-protected")

                            self.is_optical = YLeaf(YType.boolean, "is-optical")

                            self.local_router_id = YLeaf(YType.str, "local-router-id")

                            self.next_hop_address = YLeaf(YType.str, "next-hop-address")

                            self.node_hop_count = YLeaf(YType.uint8, "node-hop-count")

                            self.outbound_frr_state = YLeaf(YType.enumeration, "outbound-frr-state")

                            self.path_reeval_query_mid = YLeaf(YType.uint32, "path-reeval-query-mid")

                            self.path_rro_enabled = YLeaf(YType.boolean, "path-rro-enabled")

                            self.path_using_strict_spf = YLeaf(YType.boolean, "path-using-strict-spf")

                            self.pcalc_area = YLeaf(YType.str, "pcalc-area")

                            self.previous_hop_address = YLeaf(YType.str, "previous-hop-address")

                            self.reverse_lsp_connected = YLeaf(YType.boolean, "reverse-lsp-connected")

                            self.reverse_lsp_name = YLeaf(YType.str, "reverse-lsp-name")

                            self.reverse_lsp_present = YLeaf(YType.boolean, "reverse-lsp-present")

                            self.reverse_weight = YLeaf(YType.uint64, "reverse-weight")

                            self.role = YLeaf(YType.enumeration, "role")

                            self.s2l_local_label = YLeaf(YType.uint32, "s2l-local-label")

                            self.s2l_out_label = YLeaf(YType.uint32, "s2l-out-label")

                            self.s2l_reverse_ero_obj_present = YLeaf(YType.boolean, "s2l-reverse-ero-obj-present")

                            self.s2l_reverse_tspec_obj_present = YLeaf(YType.boolean, "s2l-reverse-tspec-obj-present")

                            self.signalling_status = YLeaf(YType.enumeration, "signalling-status")

                            self.time_since_last_preferred_path_exists_send_mid = YLeaf(YType.uint32, "time-since-last-preferred-path-exists-send-mid")

                            self.time_since_last_preferred_tree_exists_send_mid = YLeaf(YType.uint32, "time-since-last-preferred-tree-exists-send-mid")

                            self.time_since_last_query_received_mid = YLeaf(YType.uint32, "time-since-last-query-received-mid")

                            self.upstream_router_id = YLeaf(YType.str, "upstream-router-id")

                            self.uptime = YLeaf(YType.uint32, "uptime")

                            self.weight = YLeaf(YType.uint64, "weight")

                            self.active_path_option = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption()
                            self.active_path_option.parent = self
                            self._children_name_map["active_path_option"] = "active-path-option"
                            self._children_yang_names.add("active-path-option")

                            self.association = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.Association()
                            self.association.parent = self
                            self._children_name_map["association"] = "association"
                            self._children_yang_names.add("association")

                            self.diversity_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.DiversityInfo()
                            self.diversity_info.parent = self
                            self._children_name_map["diversity_info"] = "diversity-info"
                            self._children_yang_names.add("diversity-info")

                            self.flex_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.FlexInfo()
                            self.flex_info.parent = self
                            self._children_name_map["flex_info"] = "flex-info"
                            self._children_yang_names.add("flex-info")

                            self.fspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.Fspec()
                            self.fspec.parent = self
                            self._children_name_map["fspec"] = "fspec"
                            self._children_yang_names.add("fspec")

                            self.generic_fspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GenericFspec()
                            self.generic_fspec.parent = self
                            self._children_name_map["generic_fspec"] = "generic-fspec"
                            self._children_yang_names.add("generic-fspec")

                            self.generic_tspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GenericTspec()
                            self.generic_tspec.parent = self
                            self._children_name_map["generic_tspec"] = "generic-tspec"
                            self._children_yang_names.add("generic-tspec")

                            self.gmpls_labels = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels()
                            self.gmpls_labels.parent = self
                            self._children_name_map["gmpls_labels"] = "gmpls-labels"
                            self._children_yang_names.add("gmpls-labels")

                            self.head_end_bfd_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.HeadEndBfdInfo()
                            self.head_end_bfd_info.parent = self
                            self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"
                            self._children_yang_names.add("head-end-bfd-info")

                            self.in_xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro()
                            self.in_xro.parent = self
                            self._children_name_map["in_xro"] = "in-xro"
                            self._children_yang_names.add("in-xro")

                            self.incoming_address_generic = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.IncomingAddressGeneric()
                            self.incoming_address_generic.parent = self
                            self._children_name_map["incoming_address_generic"] = "incoming-address-generic"
                            self._children_yang_names.add("incoming-address-generic")

                            self.lsp_wrap_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.LspWrapInfo()
                            self.lsp_wrap_info.parent = self
                            self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"
                            self._children_yang_names.add("lsp-wrap-info")

                            self.next_hop_address_generic = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.NextHopAddressGeneric()
                            self.next_hop_address_generic.parent = self
                            self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"
                            self._children_yang_names.add("next-hop-address-generic")

                            self.otn_s2l = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L()
                            self.otn_s2l.parent = self
                            self._children_name_map["otn_s2l"] = "otn-s2l"
                            self._children_yang_names.add("otn-s2l")

                            self.out_xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro()
                            self.out_xro.parent = self
                            self._children_name_map["out_xro"] = "out-xro"
                            self._children_yang_names.add("out-xro")

                            self.previous_hop_address_generic = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PreviousHopAddressGeneric()
                            self.previous_hop_address_generic.parent = self
                            self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"
                            self._children_yang_names.add("previous-hop-address-generic")

                            self.protection = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.Protection()
                            self.protection.parent = self
                            self._children_name_map["protection"] = "protection"
                            self._children_yang_names.add("protection")

                            self.reverse_lsp_fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ReverseLspFec()
                            self.reverse_lsp_fec.parent = self
                            self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"
                            self._children_yang_names.add("reverse-lsp-fec")

                            self.reverse_tspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ReverseTspec()
                            self.reverse_tspec.parent = self
                            self._children_name_map["reverse_tspec"] = "reverse-tspec"
                            self._children_yang_names.add("reverse-tspec")

                            self.s2l_convergence = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.S2LConvergence()
                            self.s2l_convergence.parent = self
                            self._children_name_map["s2l_convergence"] = "s2l-convergence"
                            self._children_yang_names.add("s2l-convergence")

                            self.s2l_fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.S2LFec()
                            self.s2l_fec.parent = self
                            self._children_name_map["s2l_fec"] = "s2l-fec"
                            self._children_yang_names.add("s2l-fec")

                            self.soft_preemption = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.SoftPreemption()
                            self.soft_preemption.parent = self
                            self._children_name_map["soft_preemption"] = "soft-preemption"
                            self._children_yang_names.add("soft-preemption")

                            self.srlg_collection = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.SrlgCollection()
                            self.srlg_collection.parent = self
                            self._children_name_map["srlg_collection"] = "srlg-collection"
                            self._children_yang_names.add("srlg-collection")

                            self.tail_end_bfd_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.TailEndBfdInfo()
                            self.tail_end_bfd_info.parent = self
                            self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"
                            self._children_yang_names.add("tail-end-bfd-info")

                            self.tspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.Tspec()
                            self.tspec.parent = self
                            self._children_name_map["tspec"] = "tspec"
                            self._children_yang_names.add("tspec")

                            self.in_ero = YList(self)
                            self.out_ero = YList(self)
                            self.path_affinity_array = YList(self)
                            self.path_rro = YList(self)
                            self.resv_rro = YList(self)
                            self.reverse_ero_in = YList(self)
                            self.s2l_reverse_lsp_sub_obj = YList(self)
                            self.s2l_segment_routing_path = YList(self)
                            self.shared_risk_link_group = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("abr_auto_discovered",
                                            "backup_tunnel_interface",
                                            "downstream_router_id",
                                            "egress_interface",
                                            "egress_interface_brief",
                                            "egress_interface_state",
                                            "expanded_ero_affinity_bits",
                                            "expanded_ero_affinity_mask",
                                            "expanded_ero_area_id",
                                            "expanded_ero_metric",
                                            "expanded_ero_metric_type",
                                            "frr_out_tunnel_interface",
                                            "incoming_address",
                                            "ingress_interface",
                                            "ingress_interface_brief",
                                            "ingress_interface_state",
                                            "is_bandwidth_protect",
                                            "is_expanded_ero",
                                            "is_frr_enabled",
                                            "is_node_protected",
                                            "is_optical",
                                            "local_router_id",
                                            "next_hop_address",
                                            "node_hop_count",
                                            "outbound_frr_state",
                                            "path_reeval_query_mid",
                                            "path_rro_enabled",
                                            "path_using_strict_spf",
                                            "pcalc_area",
                                            "previous_hop_address",
                                            "reverse_lsp_connected",
                                            "reverse_lsp_name",
                                            "reverse_lsp_present",
                                            "reverse_weight",
                                            "role",
                                            "s2l_local_label",
                                            "s2l_out_label",
                                            "s2l_reverse_ero_obj_present",
                                            "s2l_reverse_tspec_obj_present",
                                            "signalling_status",
                                            "time_since_last_preferred_path_exists_send_mid",
                                            "time_since_last_preferred_tree_exists_send_mid",
                                            "time_since_last_query_received_mid",
                                            "upstream_router_id",
                                            "uptime",
                                            "weight") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L, self).__setattr__(name, value)


                        class S2LFec(Entity):
                            """
                            FEC for the S2L
                            
                            .. attribute:: s2l_fec_ctype
                            
                            	Session identifier (ctype)
                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            .. attribute:: s2l_fec_dest
                            
                            	sub\-LSP destination address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_lsp_id
                            
                            	LSP ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_p2mp_id
                            
                            	P2MP ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: s2l_fec_source
                            
                            	LSP source address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_subgroup_id
                            
                            	sub\-LSP subgroup ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_subgroup_originator
                            
                            	Subgroup Originator
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.S2LFec, self).__init__()

                                self.yang_name = "s2l-fec"
                                self.yang_parent_name = "s2l"

                                self.s2l_fec_ctype = YLeaf(YType.enumeration, "s2l-fec-ctype")

                                self.s2l_fec_dest = YLeaf(YType.str, "s2l-fec-dest")

                                self.s2l_fec_extended_tunnel_id = YLeaf(YType.str, "s2l-fec-extended-tunnel-id")

                                self.s2l_fec_lsp_id = YLeaf(YType.uint16, "s2l-fec-lsp-id")

                                self.s2l_fec_p2mp_id = YLeaf(YType.uint32, "s2l-fec-p2mp-id")

                                self.s2l_fec_source = YLeaf(YType.str, "s2l-fec-source")

                                self.s2l_fec_subgroup_id = YLeaf(YType.uint16, "s2l-fec-subgroup-id")

                                self.s2l_fec_subgroup_originator = YLeaf(YType.str, "s2l-fec-subgroup-originator")

                                self.s2l_fec_tunnel_id = YLeaf(YType.uint16, "s2l-fec-tunnel-id")

                                self.s2l_fec_vrf = YLeaf(YType.str, "s2l-fec-vrf")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("s2l_fec_ctype",
                                                "s2l_fec_dest",
                                                "s2l_fec_extended_tunnel_id",
                                                "s2l_fec_lsp_id",
                                                "s2l_fec_p2mp_id",
                                                "s2l_fec_source",
                                                "s2l_fec_subgroup_id",
                                                "s2l_fec_subgroup_originator",
                                                "s2l_fec_tunnel_id",
                                                "s2l_fec_vrf") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.S2LFec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.S2LFec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.s2l_fec_ctype.is_set or
                                    self.s2l_fec_dest.is_set or
                                    self.s2l_fec_extended_tunnel_id.is_set or
                                    self.s2l_fec_lsp_id.is_set or
                                    self.s2l_fec_p2mp_id.is_set or
                                    self.s2l_fec_source.is_set or
                                    self.s2l_fec_subgroup_id.is_set or
                                    self.s2l_fec_subgroup_originator.is_set or
                                    self.s2l_fec_tunnel_id.is_set or
                                    self.s2l_fec_vrf.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.s2l_fec_ctype.yfilter != YFilter.not_set or
                                    self.s2l_fec_dest.yfilter != YFilter.not_set or
                                    self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_lsp_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_p2mp_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_source.yfilter != YFilter.not_set or
                                    self.s2l_fec_subgroup_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set or
                                    self.s2l_fec_tunnel_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_vrf.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-fec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.s2l_fec_ctype.is_set or self.s2l_fec_ctype.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_ctype.get_name_leafdata())
                                if (self.s2l_fec_dest.is_set or self.s2l_fec_dest.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_dest.get_name_leafdata())
                                if (self.s2l_fec_extended_tunnel_id.is_set or self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_extended_tunnel_id.get_name_leafdata())
                                if (self.s2l_fec_lsp_id.is_set or self.s2l_fec_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_lsp_id.get_name_leafdata())
                                if (self.s2l_fec_p2mp_id.is_set or self.s2l_fec_p2mp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_p2mp_id.get_name_leafdata())
                                if (self.s2l_fec_source.is_set or self.s2l_fec_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_source.get_name_leafdata())
                                if (self.s2l_fec_subgroup_id.is_set or self.s2l_fec_subgroup_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_subgroup_id.get_name_leafdata())
                                if (self.s2l_fec_subgroup_originator.is_set or self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_subgroup_originator.get_name_leafdata())
                                if (self.s2l_fec_tunnel_id.is_set or self.s2l_fec_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_tunnel_id.get_name_leafdata())
                                if (self.s2l_fec_vrf.is_set or self.s2l_fec_vrf.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_vrf.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "s2l-fec-ctype" or name == "s2l-fec-dest" or name == "s2l-fec-extended-tunnel-id" or name == "s2l-fec-lsp-id" or name == "s2l-fec-p2mp-id" or name == "s2l-fec-source" or name == "s2l-fec-subgroup-id" or name == "s2l-fec-subgroup-originator" or name == "s2l-fec-tunnel-id" or name == "s2l-fec-vrf"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "s2l-fec-ctype"):
                                    self.s2l_fec_ctype = value
                                    self.s2l_fec_ctype.value_namespace = name_space
                                    self.s2l_fec_ctype.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-dest"):
                                    self.s2l_fec_dest = value
                                    self.s2l_fec_dest.value_namespace = name_space
                                    self.s2l_fec_dest.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-extended-tunnel-id"):
                                    self.s2l_fec_extended_tunnel_id = value
                                    self.s2l_fec_extended_tunnel_id.value_namespace = name_space
                                    self.s2l_fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-lsp-id"):
                                    self.s2l_fec_lsp_id = value
                                    self.s2l_fec_lsp_id.value_namespace = name_space
                                    self.s2l_fec_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-p2mp-id"):
                                    self.s2l_fec_p2mp_id = value
                                    self.s2l_fec_p2mp_id.value_namespace = name_space
                                    self.s2l_fec_p2mp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-source"):
                                    self.s2l_fec_source = value
                                    self.s2l_fec_source.value_namespace = name_space
                                    self.s2l_fec_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-subgroup-id"):
                                    self.s2l_fec_subgroup_id = value
                                    self.s2l_fec_subgroup_id.value_namespace = name_space
                                    self.s2l_fec_subgroup_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-subgroup-originator"):
                                    self.s2l_fec_subgroup_originator = value
                                    self.s2l_fec_subgroup_originator.value_namespace = name_space
                                    self.s2l_fec_subgroup_originator.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-tunnel-id"):
                                    self.s2l_fec_tunnel_id = value
                                    self.s2l_fec_tunnel_id.value_namespace = name_space
                                    self.s2l_fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-vrf"):
                                    self.s2l_fec_vrf = value
                                    self.s2l_fec_vrf.value_namespace = name_space
                                    self.s2l_fec_vrf.value_namespace_prefix = name_space_prefix


                        class ActivePathOption(Entity):
                            """
                            The path option used to find the path for this
                            S2L
                            
                            .. attribute:: attribute_set
                            
                            	The path option attribute set used by this path
                            	**type**\:   :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet>`
                            
                            .. attribute:: attribute_set_found
                            
                            	TRUE if the path has found the defined attribute set
                            	**type**\:  bool
                            
                            .. attribute:: explicit_path_id
                            
                            	Explicit Path ID, this is the key to table ExplicitPaths.IdentifierTable
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: explicit_path_name
                            
                            	Explicit Path Name, this is the key to table ExplicitPaths.NameTable
                            	**type**\:  str
                            
                            .. attribute:: has_attribute_set
                            
                            	TRUE if the path has an attribute set defined
                            	**type**\:  bool
                            
                            .. attribute:: has_xro_attribute_set
                            
                            	TRUE if the path has an XRO attribute set configured
                            	**type**\:  bool
                            
                            .. attribute:: holddown_duration
                            
                            	Holddown Duration (seconds)
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            	**units**\: second
                            
                            .. attribute:: is_disabled
                            
                            	TRUE if the path option is disabled
                            	**type**\:  bool
                            
                            .. attribute:: is_helddown
                            
                            	TRUE if path is helddown
                            	**type**\:  bool
                            
                            .. attribute:: is_lockdown
                            
                            	TRUE if the path is locked down
                            	**type**\:  bool
                            
                            .. attribute:: is_segment_routing
                            
                            	TRUE if the path is Segment\-Routing
                            	**type**\:  bool
                            
                            .. attribute:: is_strict_explicit_path
                            
                            	TRUE if explicit path is strict
                            	**type**\:  bool
                            
                            .. attribute:: is_verbatim
                            
                            	TRUE if the path is verbatim
                            	**type**\:  bool
                            
                            .. attribute:: option_index
                            
                            	Path option index
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: option_index_is_valid
                            
                            	The path option index is valid
                            	**type**\:  bool
                            
                            .. attribute:: path_calculation_error
                            
                            	Path computation information
                            	**type**\: list of    :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.PathCalculationError>`
                            
                            .. attribute:: path_option_area_id
                            
                            	The path\-option area constraint
                            	**type**\:  str
                            
                            .. attribute:: path_option_name
                            
                            	Path option name
                            	**type**\:  str
                            
                            .. attribute:: path_option_type
                            
                            	Path option type
                            	**type**\:   :py:class:`MplsTePathoption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathoption>`
                            
                            .. attribute:: pce_address
                            
                            	PCE server address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: protected_by_path_option_index
                            
                            	Path option index for Protect path options
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: remerge_error
                            
                            	Path computation remerge resolve info
                            	**type**\: list of    :py:class:`RemergeError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.RemergeError>`
                            
                            .. attribute:: restored_from_path_option_index
                            
                            	Path option index for Restore path options
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: signalling_error
                            
                            	Signalling information
                            	**type**\: list of    :py:class:`SignallingError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.SignallingError>`
                            
                            .. attribute:: xro_attribute_set
                            
                            	The XRO attribute set used by this path\-option
                            	**type**\:   :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet>`
                            
                            .. attribute:: xro_attribute_set_found
                            
                            	TRUE if the path's XRO attribute set is known
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption, self).__init__()

                                self.yang_name = "active-path-option"
                                self.yang_parent_name = "s2l"

                                self.attribute_set_found = YLeaf(YType.boolean, "attribute-set-found")

                                self.explicit_path_id = YLeaf(YType.uint16, "explicit-path-id")

                                self.explicit_path_name = YLeaf(YType.str, "explicit-path-name")

                                self.has_attribute_set = YLeaf(YType.boolean, "has-attribute-set")

                                self.has_xro_attribute_set = YLeaf(YType.boolean, "has-xro-attribute-set")

                                self.holddown_duration = YLeaf(YType.uint16, "holddown-duration")

                                self.is_disabled = YLeaf(YType.boolean, "is-disabled")

                                self.is_helddown = YLeaf(YType.boolean, "is-helddown")

                                self.is_lockdown = YLeaf(YType.boolean, "is-lockdown")

                                self.is_segment_routing = YLeaf(YType.boolean, "is-segment-routing")

                                self.is_strict_explicit_path = YLeaf(YType.boolean, "is-strict-explicit-path")

                                self.is_verbatim = YLeaf(YType.boolean, "is-verbatim")

                                self.option_index = YLeaf(YType.uint32, "option-index")

                                self.option_index_is_valid = YLeaf(YType.boolean, "option-index-is-valid")

                                self.path_option_area_id = YLeaf(YType.str, "path-option-area-id")

                                self.path_option_name = YLeaf(YType.str, "path-option-name")

                                self.path_option_type = YLeaf(YType.enumeration, "path-option-type")

                                self.pce_address = YLeaf(YType.str, "pce-address")

                                self.protected_by_path_option_index = YLeaf(YType.uint32, "protected-by-path-option-index")

                                self.restored_from_path_option_index = YLeaf(YType.uint32, "restored-from-path-option-index")

                                self.xro_attribute_set_found = YLeaf(YType.boolean, "xro-attribute-set-found")

                                self.attribute_set = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet()
                                self.attribute_set.parent = self
                                self._children_name_map["attribute_set"] = "attribute-set"
                                self._children_yang_names.add("attribute-set")

                                self.xro_attribute_set = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet()
                                self.xro_attribute_set.parent = self
                                self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                                self._children_yang_names.add("xro-attribute-set")

                                self.path_calculation_error = YList(self)
                                self.remerge_error = YList(self)
                                self.signalling_error = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("attribute_set_found",
                                                "explicit_path_id",
                                                "explicit_path_name",
                                                "has_attribute_set",
                                                "has_xro_attribute_set",
                                                "holddown_duration",
                                                "is_disabled",
                                                "is_helddown",
                                                "is_lockdown",
                                                "is_segment_routing",
                                                "is_strict_explicit_path",
                                                "is_verbatim",
                                                "option_index",
                                                "option_index_is_valid",
                                                "path_option_area_id",
                                                "path_option_name",
                                                "path_option_type",
                                                "pce_address",
                                                "protected_by_path_option_index",
                                                "restored_from_path_option_index",
                                                "xro_attribute_set_found") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption, self).__setattr__(name, value)


                            class AttributeSet(Entity):
                                """
                                The path option attribute set used by this path
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion>`
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\:  str
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet, self).__init__()

                                    self.yang_name = "attribute-set"
                                    self.yang_parent_name = "active-path-option"

                                    self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                                    self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                                    self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._children_yang_names.add("attribute-set-union")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("tunnel_attribute_set_name",
                                                    "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet, self).__setattr__(name, value)


                                class AttributeSetUnion(Entity):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "attribute-set"

                                        self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                                        self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                        self._children_yang_names.add("attribute-set-aps-pp")

                                        self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                        self._children_yang_names.add("attribute-set-autobackup")

                                        self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                        self._children_yang_names.add("attribute-set-automesh")

                                        self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                        self._children_yang_names.add("attribute-set-p2mpte")

                                        self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._children_yang_names.add("attribute-set-p2p-te")

                                        self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                        self._children_yang_names.add("attribute-set-path-option")

                                        self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                        self._children_yang_names.add("attribute-set-xro")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                                    class AttributeSetPathOption(Entity):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\:  str
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                            self.generation = YLeaf(YType.uint32, "generation")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                            self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                            self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                            self._children_yang_names.add("bfd-reverse-path")

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bandwidth_type",
                                                            "configured_bandwidth",
                                                            "cost_limit",
                                                            "dste_class_type",
                                                            "exclude_list_name",
                                                            "generation",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_bfd_reverse_pat_configured",
                                                            "is_cost_limit_configured",
                                                            "is_exclude_list_name_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "path_invalidation_action",
                                                            "path_invalidation_timeout",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class BfdReversePath(Entity):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.binding_label = YLeaf(YType.uint32, "binding-label")

                                                self.path_type = YLeaf(YType.enumeration, "path-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("binding_label",
                                                                "path_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.binding_label.is_set or
                                                    self.path_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.binding_label.yfilter != YFilter.not_set or
                                                    self.path_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "bfd-reverse-path" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.binding_label.get_name_leafdata())
                                                if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.path_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "binding-label" or name == "path-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "binding-label"):
                                                    self.binding_label = value
                                                    self.binding_label.value_namespace = name_space
                                                    self.binding_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "path-type"):
                                                    self.path_type = value
                                                    self.path_type.value_namespace = name_space
                                                    self.path_type.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class VersionInfo(Entity):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\:  str
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.attribute_type = YLeaf(YType.str, "attribute-type")

                                                self.generation = YLeaf(YType.uint32, "generation")

                                                self.is_default = YLeaf(YType.boolean, "is-default")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("attribute_type",
                                                                "generation",
                                                                "is_default") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.attribute_type.is_set or
                                                    self.generation.is_set or
                                                    self.is_default.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.attribute_type.yfilter != YFilter.not_set or
                                                    self.generation.yfilter != YFilter.not_set or
                                                    self.is_default.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "version-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                                if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.generation.get_name_leafdata())
                                                if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_default.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "attribute-type"):
                                                    self.attribute_type = value
                                                    self.attribute_type.value_namespace = name_space
                                                    self.attribute_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "generation"):
                                                    self.generation = value
                                                    self.generation.value_namespace = name_space
                                                    self.generation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-default"):
                                                    self.is_default = value
                                                    self.is_default.value_namespace = name_space
                                                    self.is_default.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.bandwidth_type.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.cost_limit.is_set or
                                                self.dste_class_type.is_set or
                                                self.exclude_list_name.is_set or
                                                self.generation.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_bfd_reverse_pat_configured.is_set or
                                                self.is_cost_limit_configured.is_set or
                                                self.is_exclude_list_name_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.path_invalidation_action.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bandwidth_type.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.cost_limit.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.exclude_list_name.yfilter != YFilter.not_set or
                                                self.generation.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                                self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                                self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-path-option" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.generation.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                            if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                            if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "bfd-reverse-path"):
                                                if (self.bfd_reverse_path is None):
                                                    self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                                    self.bfd_reverse_path.parent = self
                                                    self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                                return self.bfd_reverse_path

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            if (child_yang_name == "version-info"):
                                                for c in self.version_info:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.version_info.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bandwidth-type"):
                                                self.bandwidth_type = value
                                                self.bandwidth_type.value_namespace = name_space
                                                self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "cost-limit"):
                                                self.cost_limit = value
                                                self.cost_limit.value_namespace = name_space
                                                self.cost_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exclude-list-name"):
                                                self.exclude_list_name = value
                                                self.exclude_list_name.value_namespace = name_space
                                                self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "generation"):
                                                self.generation = value
                                                self.generation.value_namespace = name_space
                                                self.generation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bfd-reverse-pat-configured"):
                                                self.is_bfd_reverse_pat_configured = value
                                                self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                                self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-cost-limit-configured"):
                                                self.is_cost_limit_configured = value
                                                self.is_cost_limit_configured.value_namespace = name_space
                                                self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-exclude-list-name-configured"):
                                                self.is_exclude_list_name_configured = value
                                                self.is_exclude_list_name_configured.value_namespace = name_space
                                                self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-action"):
                                                self.path_invalidation_action = value
                                                self.path_invalidation_action.value_namespace = name_space
                                                self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutobackup(Entity):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.signalled_name = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"
                                            self._children_yang_names.add("signalled-name")

                                            self.policy_class_entry = YList(self)
                                            self.protected_interface = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_priority",
                                                            "is_affinity_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "is_signalled_name_configured",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                                        class SignalledName(Entity):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\:  bool
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\:  str
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                                self.name = YLeaf(YType.str, "name")

                                                self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                                self.source_type = YLeaf(YType.enumeration, "source-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("is_mp_addresses",
                                                                "name",
                                                                "protected_interface_type",
                                                                "source_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.is_mp_addresses.is_set or
                                                    self.name.is_set or
                                                    self.protected_interface_type.is_set or
                                                    self.source_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.is_mp_addresses.yfilter != YFilter.not_set or
                                                    self.name.yfilter != YFilter.not_set or
                                                    self.protected_interface_type.yfilter != YFilter.not_set or
                                                    self.source_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "signalled-name" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.name.get_name_leafdata())
                                                if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                                if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.source_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "is-mp-addresses"):
                                                    self.is_mp_addresses = value
                                                    self.is_mp_addresses.value_namespace = name_space
                                                    self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                                if(value_path == "name"):
                                                    self.name = value
                                                    self.name.value_namespace = name_space
                                                    self.name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "protected-interface-type"):
                                                    self.protected_interface_type = value
                                                    self.protected_interface_type.value_namespace = name_space
                                                    self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "source-type"):
                                                    self.source_type = value
                                                    self.source_type.value_namespace = name_space
                                                    self.source_type.value_namespace_prefix = name_space_prefix


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class ProtectedInterface(Entity):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.protected_interface = YLeaf(YType.str, "protected-interface")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("protected_interface") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.protected_interface.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.protected_interface.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "protected-interface" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "protected-interface"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "protected-interface"):
                                                    self.protected_interface = value
                                                    self.protected_interface.value_namespace = name_space
                                                    self.protected_interface.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.is_signalled_name_configured.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.signalled_name is not None and self.signalled_name.has_data()))

                                        def has_operation(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.signalled_name is not None and self.signalled_name.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-autobackup" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "protected-interface"):
                                                for c in self.protected_interface:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.protected_interface.append(c)
                                                return c

                                            if (child_yang_name == "signalled-name"):
                                                if (self.signalled_name is None):
                                                    self.signalled_name = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                                    self.signalled_name.parent = self
                                                    self._children_name_map["signalled_name"] = "signalled-name"
                                                return self.signalled_name

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-signalled-name-configured"):
                                                self.is_signalled_name_configured = value
                                                self.is_signalled_name_configured.value_namespace = name_space
                                                self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutomesh(Entity):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\:  bool
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\:  bool
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                            self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                            self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.forward_class = YLeaf(YType.uint32, "forward-class")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.load_share = YLeaf(YType.uint32, "load-share")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.mesh_group_id = YList(self)
                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("auto_bandwidth_collect",
                                                            "auto_route_announce",
                                                            "bandwidth",
                                                            "configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "forward_class",
                                                            "frr_bandwidth_protection",
                                                            "frr_node_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_interface_bw_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "load_share",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority",
                                                            "soft_preemption_configured") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class MeshGroupId(Entity):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint32, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "mesh-group-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.auto_bandwidth_collect.is_set or
                                                self.auto_route_announce.is_set or
                                                self.bandwidth.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.forward_class.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.frr_node_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_interface_bw_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.load_share.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                self.soft_preemption_configured.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()))

                                        def has_operation(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                                self.auto_route_announce.yfilter != YFilter.not_set or
                                                self.bandwidth.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.forward_class.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.frr_node_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.load_share.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                self.soft_preemption_configured.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-automesh" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                            if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                            if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.forward_class.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.load_share.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                            if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "mesh-group-id"):
                                                for c in self.mesh_group_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.mesh_group_id.append(c)
                                                return c

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "auto-bandwidth-collect"):
                                                self.auto_bandwidth_collect = value
                                                self.auto_bandwidth_collect.value_namespace = name_space
                                                self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                            if(value_path == "auto-route-announce"):
                                                self.auto_route_announce = value
                                                self.auto_route_announce.value_namespace = name_space
                                                self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                            if(value_path == "bandwidth"):
                                                self.bandwidth = value
                                                self.bandwidth.value_namespace = name_space
                                                self.bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "forward-class"):
                                                self.forward_class = value
                                                self.forward_class.value_namespace = name_space
                                                self.forward_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-node-protection"):
                                                self.frr_node_protection = value
                                                self.frr_node_protection.value_namespace = name_space
                                                self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-interface-bw-configured"):
                                                self.is_interface_bw_configured = value
                                                self.is_interface_bw_configured.value_namespace = name_space
                                                self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "load-share"):
                                                self.load_share = value
                                                self.load_share.value_namespace = name_space
                                                self.load_share.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "soft-preemption-configured"):
                                                self.soft_preemption_configured = value
                                                self.soft_preemption_configured.value_namespace = name_space
                                                self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                                    class AttributeSetXro(Entity):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._children_yang_names.add("xro")


                                        class Xro(Entity):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\:  bool
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"

                                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                                self.xro_subobject = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                            class XroSubobject(Entity):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                    self.as_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"
                                                    self._children_yang_names.add("as-subobject")

                                                    self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                    self._children_yang_names.add("ipv4-subobject")

                                                    self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                    self._children_yang_names.add("ipv6-subobject")

                                                    self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._children_yang_names.add("lsp-subobject")

                                                    self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                    self._children_yang_names.add("srlg-subobject")

                                                    self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                    self._children_yang_names.add("unnumbered-subobject")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                                class Ipv4Subobject(Entity):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv4-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class Ipv6Subobject(Entity):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv6-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class UnnumberedSubobject(Entity):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("attribute",
                                                                        "exclusion_type",
                                                                        "interface_id",
                                                                        "te_router_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.interface_id.is_set or
                                                            self.te_router_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.interface_id.yfilter != YFilter.not_set or
                                                            self.te_router_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "unnumbered-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "interface-id"):
                                                            self.interface_id = value
                                                            self.interface_id.value_namespace = name_space
                                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "te-router-id"):
                                                            self.te_router_id = value
                                                            self.te_router_id.value_namespace = name_space
                                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                                class AsSubobject(Entity):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("as_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.as_number.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.as_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "as-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "as-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "as-number"):
                                                            self.as_number = value
                                                            self.as_number.value_namespace = name_space
                                                            self.as_number.value_namespace_prefix = name_space_prefix


                                                class SrlgSubobject(Entity):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("exclusion_type",
                                                                        "srlg_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.exclusion_type.is_set or
                                                            self.srlg_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.srlg_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "srlg-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "exclusion-type" or name == "srlg-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "srlg-id"):
                                                            self.srlg_id = value
                                                            self.srlg_id.value_namespace = name_space
                                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                                class LspSubobject(Entity):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                                        self.fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._children_yang_names.add("fec")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("destination_node_exception",
                                                                        "exclusion_type",
                                                                        "ignore_lsp_id",
                                                                        "penultimate_node_exception",
                                                                        "processing_node_exception") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                                    class Fec(Entity):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\:  str
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"

                                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                            self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._children_yang_names.add("fec-destination-info")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("fec_extended_tunnel_id",
                                                                            "fec_lsp_id",
                                                                            "fec_source",
                                                                            "fec_tunnel_id",
                                                                            "fec_vrf") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                                        class FecDestinationInfo(Entity):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\:  str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"

                                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("fec_ctype",
                                                                                "fec_destination_p2mp_id",
                                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.fec_ctype.is_set or
                                                                    self.fec_destination_p2mp_id.is_set or
                                                                    self.p2p_lsp_destination.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "fec-destination-info" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "fec-ctype"):
                                                                    self.fec_ctype = value
                                                                    self.fec_ctype.value_namespace = name_space
                                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "fec-destination-p2mp-id"):
                                                                    self.fec_destination_p2mp_id = value
                                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "p2p-lsp-destination"):
                                                                    self.p2p_lsp_destination = value
                                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.fec_extended_tunnel_id.is_set or
                                                                self.fec_lsp_id.is_set or
                                                                self.fec_source.is_set or
                                                                self.fec_tunnel_id.is_set or
                                                                self.fec_vrf.is_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                                self.fec_source.yfilter != YFilter.not_set or
                                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "fec" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "fec-destination-info"):
                                                                if (self.fec_destination_info is None):
                                                                    self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                                    self.fec_destination_info.parent = self
                                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                                return self.fec_destination_info

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "fec-extended-tunnel-id"):
                                                                self.fec_extended_tunnel_id = value
                                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-lsp-id"):
                                                                self.fec_lsp_id = value
                                                                self.fec_lsp_id.value_namespace = name_space
                                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-source"):
                                                                self.fec_source = value
                                                                self.fec_source.value_namespace = name_space
                                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-tunnel-id"):
                                                                self.fec_tunnel_id = value
                                                                self.fec_tunnel_id.value_namespace = name_space
                                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-vrf"):
                                                                self.fec_vrf = value
                                                                self.fec_vrf.value_namespace = name_space
                                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.destination_node_exception.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.ignore_lsp_id.is_set or
                                                            self.penultimate_node_exception.is_set or
                                                            self.processing_node_exception.is_set or
                                                            (self.fec is not None and self.fec.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                                            (self.fec is not None and self.fec.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsp-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "fec"):
                                                            if (self.fec is None):
                                                                self.fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                                self.fec.parent = self
                                                                self._children_name_map["fec"] = "fec"
                                                            return self.fec

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "destination-node-exception"):
                                                            self.destination_node_exception = value
                                                            self.destination_node_exception.value_namespace = name_space
                                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ignore-lsp-id"):
                                                            self.ignore_lsp_id = value
                                                            self.ignore_lsp_id.value_namespace = name_space
                                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "penultimate-node-exception"):
                                                            self.penultimate_node_exception = value
                                                            self.penultimate_node_exception.value_namespace = name_space
                                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "processing-node-exception"):
                                                            self.processing_node_exception = value
                                                            self.processing_node_exception.value_namespace = name_space
                                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.type.is_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "xro-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "as-subobject"):
                                                        if (self.as_subobject is None):
                                                            self.as_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                            self.as_subobject.parent = self
                                                            self._children_name_map["as_subobject"] = "as-subobject"
                                                        return self.as_subobject

                                                    if (child_yang_name == "ipv4-subobject"):
                                                        if (self.ipv4_subobject is None):
                                                            self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                            self.ipv4_subobject.parent = self
                                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                        return self.ipv4_subobject

                                                    if (child_yang_name == "ipv6-subobject"):
                                                        if (self.ipv6_subobject is None):
                                                            self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                            self.ipv6_subobject.parent = self
                                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                        return self.ipv6_subobject

                                                    if (child_yang_name == "lsp-subobject"):
                                                        if (self.lsp_subobject is None):
                                                            self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                            self.lsp_subobject.parent = self
                                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                        return self.lsp_subobject

                                                    if (child_yang_name == "srlg-subobject"):
                                                        if (self.srlg_subobject is None):
                                                            self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                            self.srlg_subobject.parent = self
                                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                        return self.srlg_subobject

                                                    if (child_yang_name == "unnumbered-subobject"):
                                                        if (self.unnumbered_subobject is None):
                                                            self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                            self.unnumbered_subobject.parent = self
                                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                        return self.unnumbered_subobject

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_data()):
                                                        return True
                                                return self.mutual_diversity_flag.is_set

                                            def has_operation(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "xro" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "xro-subobject"):
                                                    for c in self.xro_subobject:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.xro_subobject.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "mutual-diversity-flag"):
                                                    self.mutual_diversity_flag = value
                                                    self.mutual_diversity_flag.value_namespace = name_space
                                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (self.xro is not None and self.xro.has_data())

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.xro is not None and self.xro.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-xro" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "xro"):
                                                if (self.xro is None):
                                                    self.xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                                    self.xro.parent = self
                                                    self._children_name_map["xro"] = "xro"
                                                return self.xro

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "xro"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class AttributeSetP2Mpte(Entity):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "frr_bandwidth_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_priority_configured",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2mpte" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetApsPp(Entity):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                            self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                            self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                            self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                            self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                            self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                            self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                            self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                            self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._children_yang_names.add("revert-schedule")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_off_time",
                                                            "path_prot_profile_type",
                                                            "protection_mode",
                                                            "protection_type",
                                                            "restoration_style",
                                                            "snc_mode",
                                                            "tcm_id",
                                                            "wait_to_restore_time") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                                        class RevertSchedule(Entity):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"

                                                self.duration = YLeaf(YType.uint32, "duration")

                                                self.max_tries = YLeaf(YType.uint32, "max-tries")

                                                self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                                self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                                self.schedulename = YLeaf(YType.str, "schedulename")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("duration",
                                                                "max_tries",
                                                                "schedule_date",
                                                                "schedule_frequency",
                                                                "schedulename") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.duration.is_set or
                                                    self.max_tries.is_set or
                                                    self.schedule_date.is_set or
                                                    self.schedule_frequency.is_set or
                                                    self.schedulename.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.duration.yfilter != YFilter.not_set or
                                                    self.max_tries.yfilter != YFilter.not_set or
                                                    self.schedule_date.yfilter != YFilter.not_set or
                                                    self.schedule_frequency.yfilter != YFilter.not_set or
                                                    self.schedulename.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "revert-schedule" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.duration.get_name_leafdata())
                                                if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_tries.get_name_leafdata())
                                                if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                                if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                                if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedulename.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "duration"):
                                                    self.duration = value
                                                    self.duration.value_namespace = name_space
                                                    self.duration.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-tries"):
                                                    self.max_tries = value
                                                    self.max_tries.value_namespace = name_space
                                                    self.max_tries.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-date"):
                                                    self.schedule_date = value
                                                    self.schedule_date.value_namespace = name_space
                                                    self.schedule_date.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-frequency"):
                                                    self.schedule_frequency = value
                                                    self.schedule_frequency.value_namespace = name_space
                                                    self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedulename"):
                                                    self.schedulename = value
                                                    self.schedulename.value_namespace = name_space
                                                    self.schedulename.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.hold_off_time.is_set or
                                                self.path_prot_profile_type.is_set or
                                                self.protection_mode.is_set or
                                                self.protection_type.is_set or
                                                self.restoration_style.is_set or
                                                self.snc_mode.is_set or
                                                self.tcm_id.is_set or
                                                self.wait_to_restore_time.is_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_off_time.yfilter != YFilter.not_set or
                                                self.path_prot_profile_type.yfilter != YFilter.not_set or
                                                self.protection_mode.yfilter != YFilter.not_set or
                                                self.protection_type.yfilter != YFilter.not_set or
                                                self.restoration_style.yfilter != YFilter.not_set or
                                                self.snc_mode.yfilter != YFilter.not_set or
                                                self.tcm_id.yfilter != YFilter.not_set or
                                                self.wait_to_restore_time.yfilter != YFilter.not_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-aps-pp" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                            if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                            if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                            if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_type.get_name_leafdata())
                                            if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                            if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                            if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                            if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "revert-schedule"):
                                                if (self.revert_schedule is None):
                                                    self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                                    self.revert_schedule.parent = self
                                                    self._children_name_map["revert_schedule"] = "revert-schedule"
                                                return self.revert_schedule

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-off-time"):
                                                self.hold_off_time = value
                                                self.hold_off_time.value_namespace = name_space
                                                self.hold_off_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-prot-profile-type"):
                                                self.path_prot_profile_type = value
                                                self.path_prot_profile_type.value_namespace = name_space
                                                self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-mode"):
                                                self.protection_mode = value
                                                self.protection_mode.value_namespace = name_space
                                                self.protection_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-type"):
                                                self.protection_type = value
                                                self.protection_type.value_namespace = name_space
                                                self.protection_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "restoration-style"):
                                                self.restoration_style = value
                                                self.restoration_style.value_namespace = name_space
                                                self.restoration_style.value_namespace_prefix = name_space_prefix
                                            if(value_path == "snc-mode"):
                                                self.snc_mode = value
                                                self.snc_mode.value_namespace = name_space
                                                self.snc_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcm-id"):
                                                self.tcm_id = value
                                                self.tcm_id.value_namespace = name_space
                                                self.tcm_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "wait-to-restore-time"):
                                                self.wait_to_restore_time = value
                                                self.wait_to_restore_time.value_namespace = name_space
                                                self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                                    class AttributeSetP2PTe(Entity):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                            self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                            self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                            self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                            self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                            self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                            self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                            self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                            self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                            self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.prepend_list = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"
                                            self._children_yang_names.add("prepend-list")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_affinity_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_path_select_configured",
                                                            "is_path_selection_metric_configured",
                                                            "is_path_selection_segment_routing_adjacency_protection_configured",
                                                            "is_path_selection_segment_routing_margin_configured",
                                                            "is_path_selection_segment_routing_margin_relative",
                                                            "is_path_selection_segment_routing_segment_limit_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "is_prepend_list_configured",
                                                            "path_invalidation_timeout",
                                                            "path_selection_invalidation_action",
                                                            "path_selection_metric",
                                                            "path_selection_segment_routing_adjacency_protection",
                                                            "path_selection_segment_routing_margin",
                                                            "path_selection_segment_routing_segment_limit",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PrependList(Entity):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.prepend_entry = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in () and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                            class PrependEntry(Entity):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"

                                                    self.index = YLeaf(YType.uint32, "index")

                                                    self.next_label = YLeaf(YType.uint32, "next-label")

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("index",
                                                                    "next_label",
                                                                    "type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.index.is_set or
                                                        self.next_label.is_set or
                                                        self.type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.index.yfilter != YFilter.not_set or
                                                        self.next_label.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "prepend-entry" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.index.get_name_leafdata())
                                                    if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.next_label.get_name_leafdata())
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "index" or name == "next-label" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "index"):
                                                        self.index = value
                                                        self.index.value_namespace = name_space
                                                        self.index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "next-label"):
                                                        self.next_label = value
                                                        self.next_label.value_namespace = name_space
                                                        self.next_label.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_data()):
                                                        return True
                                                return False

                                            def has_operation(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_operation()):
                                                        return True
                                                return self.yfilter != YFilter.not_set

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prepend-list" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "prepend-entry"):
                                                    for c in self.prepend_entry:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.prepend_entry.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "prepend-entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                pass


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.is_affinity_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_path_select_configured.is_set or
                                                self.is_path_selection_metric_configured.is_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_relative.is_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.is_prepend_list_configured.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.path_selection_invalidation_action.is_set or
                                                self.path_selection_metric.is_set or
                                                self.path_selection_segment_routing_adjacency_protection.is_set or
                                                self.path_selection_segment_routing_margin.is_set or
                                                self.path_selection_segment_routing_segment_limit.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.prepend_list is not None and self.prepend_list.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_path_select_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_selection_metric.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.prepend_list is not None and self.prepend_list.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2p-te" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                            if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                            if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                            if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                            if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                            if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "prepend-list"):
                                                if (self.prepend_list is None):
                                                    self.prepend_list = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                                    self.prepend_list.parent = self
                                                    self._children_name_map["prepend_list"] = "prepend-list"
                                                return self.prepend_list

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-select-configured"):
                                                self.is_path_select_configured = value
                                                self.is_path_select_configured.value_namespace = name_space
                                                self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-metric-configured"):
                                                self.is_path_selection_metric_configured = value
                                                self.is_path_selection_metric_configured.value_namespace = name_space
                                                self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                                self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                                self.is_path_selection_segment_routing_margin_configured = value
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                                self.is_path_selection_segment_routing_margin_relative = value
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                                self.is_path_selection_segment_routing_segment_limit_configured = value
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-prepend-list-configured"):
                                                self.is_prepend_list_configured = value
                                                self.is_prepend_list_configured.value_namespace = name_space
                                                self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-invalidation-action"):
                                                self.path_selection_invalidation_action = value
                                                self.path_selection_invalidation_action.value_namespace = name_space
                                                self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-metric"):
                                                self.path_selection_metric = value
                                                self.path_selection_metric.value_namespace = name_space
                                                self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                                self.path_selection_segment_routing_adjacency_protection = value
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-margin"):
                                                self.path_selection_segment_routing_margin = value
                                                self.path_selection_segment_routing_margin.value_namespace = name_space
                                                self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-segment-limit"):
                                                self.path_selection_segment_routing_segment_limit = value
                                                self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                                self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.tunnel_attribute_set_type.is_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-union" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "attribute-set-aps-pp"):
                                            if (self.attribute_set_aps_pp is None):
                                                self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                                self.attribute_set_aps_pp.parent = self
                                                self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                            return self.attribute_set_aps_pp

                                        if (child_yang_name == "attribute-set-autobackup"):
                                            if (self.attribute_set_autobackup is None):
                                                self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                                self.attribute_set_autobackup.parent = self
                                                self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                            return self.attribute_set_autobackup

                                        if (child_yang_name == "attribute-set-automesh"):
                                            if (self.attribute_set_automesh is None):
                                                self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                                self.attribute_set_automesh.parent = self
                                                self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                            return self.attribute_set_automesh

                                        if (child_yang_name == "attribute-set-p2mpte"):
                                            if (self.attribute_set_p2mpte is None):
                                                self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                                self.attribute_set_p2mpte.parent = self
                                                self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                            return self.attribute_set_p2mpte

                                        if (child_yang_name == "attribute-set-p2p-te"):
                                            if (self.attribute_set_p2p_te is None):
                                                self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                                self.attribute_set_p2p_te.parent = self
                                                self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                            return self.attribute_set_p2p_te

                                        if (child_yang_name == "attribute-set-path-option"):
                                            if (self.attribute_set_path_option is None):
                                                self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                                self.attribute_set_path_option.parent = self
                                                self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                            return self.attribute_set_path_option

                                        if (child_yang_name == "attribute-set-xro"):
                                            if (self.attribute_set_xro is None):
                                                self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                                self.attribute_set_xro.parent = self
                                                self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                            return self.attribute_set_xro

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "tunnel-attribute-set-type"):
                                            self.tunnel_attribute_set_type = value
                                            self.tunnel_attribute_set_type.value_namespace = name_space
                                            self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.tunnel_attribute_set_name.is_set or
                                        self.tunnel_attribute_set_name_crc32.is_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "attribute-set" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                                    if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "attribute-set-union"):
                                        if (self.attribute_set_union is None):
                                            self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion()
                                            self.attribute_set_union.parent = self
                                            self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                        return self.attribute_set_union

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "tunnel-attribute-set-name"):
                                        self.tunnel_attribute_set_name = value
                                        self.tunnel_attribute_set_name.value_namespace = name_space
                                        self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-attribute-set-name-crc32"):
                                        self.tunnel_attribute_set_name_crc32 = value
                                        self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                                        self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                            class XroAttributeSet(Entity):
                                """
                                The XRO attribute set used by this path\-option
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion>`
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\:  str
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet, self).__init__()

                                    self.yang_name = "xro-attribute-set"
                                    self.yang_parent_name = "active-path-option"

                                    self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                                    self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                                    self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._children_yang_names.add("attribute-set-union")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("tunnel_attribute_set_name",
                                                    "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet, self).__setattr__(name, value)


                                class AttributeSetUnion(Entity):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "xro-attribute-set"

                                        self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                                        self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                        self._children_yang_names.add("attribute-set-aps-pp")

                                        self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                        self._children_yang_names.add("attribute-set-autobackup")

                                        self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                        self._children_yang_names.add("attribute-set-automesh")

                                        self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                        self._children_yang_names.add("attribute-set-p2mpte")

                                        self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._children_yang_names.add("attribute-set-p2p-te")

                                        self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                        self._children_yang_names.add("attribute-set-path-option")

                                        self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                        self._children_yang_names.add("attribute-set-xro")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                                    class AttributeSetPathOption(Entity):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\:  str
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                            self.generation = YLeaf(YType.uint32, "generation")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                            self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                            self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                            self._children_yang_names.add("bfd-reverse-path")

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bandwidth_type",
                                                            "configured_bandwidth",
                                                            "cost_limit",
                                                            "dste_class_type",
                                                            "exclude_list_name",
                                                            "generation",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_bfd_reverse_pat_configured",
                                                            "is_cost_limit_configured",
                                                            "is_exclude_list_name_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "path_invalidation_action",
                                                            "path_invalidation_timeout",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class BfdReversePath(Entity):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.binding_label = YLeaf(YType.uint32, "binding-label")

                                                self.path_type = YLeaf(YType.enumeration, "path-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("binding_label",
                                                                "path_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.binding_label.is_set or
                                                    self.path_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.binding_label.yfilter != YFilter.not_set or
                                                    self.path_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "bfd-reverse-path" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.binding_label.get_name_leafdata())
                                                if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.path_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "binding-label" or name == "path-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "binding-label"):
                                                    self.binding_label = value
                                                    self.binding_label.value_namespace = name_space
                                                    self.binding_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "path-type"):
                                                    self.path_type = value
                                                    self.path_type.value_namespace = name_space
                                                    self.path_type.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class VersionInfo(Entity):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\:  str
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.attribute_type = YLeaf(YType.str, "attribute-type")

                                                self.generation = YLeaf(YType.uint32, "generation")

                                                self.is_default = YLeaf(YType.boolean, "is-default")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("attribute_type",
                                                                "generation",
                                                                "is_default") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.attribute_type.is_set or
                                                    self.generation.is_set or
                                                    self.is_default.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.attribute_type.yfilter != YFilter.not_set or
                                                    self.generation.yfilter != YFilter.not_set or
                                                    self.is_default.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "version-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                                if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.generation.get_name_leafdata())
                                                if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_default.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "attribute-type"):
                                                    self.attribute_type = value
                                                    self.attribute_type.value_namespace = name_space
                                                    self.attribute_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "generation"):
                                                    self.generation = value
                                                    self.generation.value_namespace = name_space
                                                    self.generation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-default"):
                                                    self.is_default = value
                                                    self.is_default.value_namespace = name_space
                                                    self.is_default.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.bandwidth_type.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.cost_limit.is_set or
                                                self.dste_class_type.is_set or
                                                self.exclude_list_name.is_set or
                                                self.generation.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_bfd_reverse_pat_configured.is_set or
                                                self.is_cost_limit_configured.is_set or
                                                self.is_exclude_list_name_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.path_invalidation_action.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bandwidth_type.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.cost_limit.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.exclude_list_name.yfilter != YFilter.not_set or
                                                self.generation.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                                self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                                self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-path-option" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.generation.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                            if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                            if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "bfd-reverse-path"):
                                                if (self.bfd_reverse_path is None):
                                                    self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                                    self.bfd_reverse_path.parent = self
                                                    self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                                return self.bfd_reverse_path

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            if (child_yang_name == "version-info"):
                                                for c in self.version_info:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.version_info.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bandwidth-type"):
                                                self.bandwidth_type = value
                                                self.bandwidth_type.value_namespace = name_space
                                                self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "cost-limit"):
                                                self.cost_limit = value
                                                self.cost_limit.value_namespace = name_space
                                                self.cost_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exclude-list-name"):
                                                self.exclude_list_name = value
                                                self.exclude_list_name.value_namespace = name_space
                                                self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "generation"):
                                                self.generation = value
                                                self.generation.value_namespace = name_space
                                                self.generation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bfd-reverse-pat-configured"):
                                                self.is_bfd_reverse_pat_configured = value
                                                self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                                self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-cost-limit-configured"):
                                                self.is_cost_limit_configured = value
                                                self.is_cost_limit_configured.value_namespace = name_space
                                                self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-exclude-list-name-configured"):
                                                self.is_exclude_list_name_configured = value
                                                self.is_exclude_list_name_configured.value_namespace = name_space
                                                self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-action"):
                                                self.path_invalidation_action = value
                                                self.path_invalidation_action.value_namespace = name_space
                                                self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutobackup(Entity):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.signalled_name = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"
                                            self._children_yang_names.add("signalled-name")

                                            self.policy_class_entry = YList(self)
                                            self.protected_interface = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_priority",
                                                            "is_affinity_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "is_signalled_name_configured",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                                        class SignalledName(Entity):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\:  bool
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\:  str
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                                self.name = YLeaf(YType.str, "name")

                                                self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                                self.source_type = YLeaf(YType.enumeration, "source-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("is_mp_addresses",
                                                                "name",
                                                                "protected_interface_type",
                                                                "source_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.is_mp_addresses.is_set or
                                                    self.name.is_set or
                                                    self.protected_interface_type.is_set or
                                                    self.source_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.is_mp_addresses.yfilter != YFilter.not_set or
                                                    self.name.yfilter != YFilter.not_set or
                                                    self.protected_interface_type.yfilter != YFilter.not_set or
                                                    self.source_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "signalled-name" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.name.get_name_leafdata())
                                                if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                                if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.source_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "is-mp-addresses"):
                                                    self.is_mp_addresses = value
                                                    self.is_mp_addresses.value_namespace = name_space
                                                    self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                                if(value_path == "name"):
                                                    self.name = value
                                                    self.name.value_namespace = name_space
                                                    self.name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "protected-interface-type"):
                                                    self.protected_interface_type = value
                                                    self.protected_interface_type.value_namespace = name_space
                                                    self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "source-type"):
                                                    self.source_type = value
                                                    self.source_type.value_namespace = name_space
                                                    self.source_type.value_namespace_prefix = name_space_prefix


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class ProtectedInterface(Entity):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.protected_interface = YLeaf(YType.str, "protected-interface")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("protected_interface") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.protected_interface.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.protected_interface.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "protected-interface" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "protected-interface"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "protected-interface"):
                                                    self.protected_interface = value
                                                    self.protected_interface.value_namespace = name_space
                                                    self.protected_interface.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.is_signalled_name_configured.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.signalled_name is not None and self.signalled_name.has_data()))

                                        def has_operation(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.signalled_name is not None and self.signalled_name.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-autobackup" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "protected-interface"):
                                                for c in self.protected_interface:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.protected_interface.append(c)
                                                return c

                                            if (child_yang_name == "signalled-name"):
                                                if (self.signalled_name is None):
                                                    self.signalled_name = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                                    self.signalled_name.parent = self
                                                    self._children_name_map["signalled_name"] = "signalled-name"
                                                return self.signalled_name

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-signalled-name-configured"):
                                                self.is_signalled_name_configured = value
                                                self.is_signalled_name_configured.value_namespace = name_space
                                                self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutomesh(Entity):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\:  bool
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\:  bool
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                            self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                            self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.forward_class = YLeaf(YType.uint32, "forward-class")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.load_share = YLeaf(YType.uint32, "load-share")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.mesh_group_id = YList(self)
                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("auto_bandwidth_collect",
                                                            "auto_route_announce",
                                                            "bandwidth",
                                                            "configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "forward_class",
                                                            "frr_bandwidth_protection",
                                                            "frr_node_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_interface_bw_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "load_share",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority",
                                                            "soft_preemption_configured") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class MeshGroupId(Entity):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint32, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "mesh-group-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.auto_bandwidth_collect.is_set or
                                                self.auto_route_announce.is_set or
                                                self.bandwidth.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.forward_class.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.frr_node_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_interface_bw_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.load_share.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                self.soft_preemption_configured.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()))

                                        def has_operation(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                                self.auto_route_announce.yfilter != YFilter.not_set or
                                                self.bandwidth.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.forward_class.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.frr_node_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.load_share.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                self.soft_preemption_configured.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-automesh" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                            if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                            if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.forward_class.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.load_share.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                            if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "mesh-group-id"):
                                                for c in self.mesh_group_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.mesh_group_id.append(c)
                                                return c

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "auto-bandwidth-collect"):
                                                self.auto_bandwidth_collect = value
                                                self.auto_bandwidth_collect.value_namespace = name_space
                                                self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                            if(value_path == "auto-route-announce"):
                                                self.auto_route_announce = value
                                                self.auto_route_announce.value_namespace = name_space
                                                self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                            if(value_path == "bandwidth"):
                                                self.bandwidth = value
                                                self.bandwidth.value_namespace = name_space
                                                self.bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "forward-class"):
                                                self.forward_class = value
                                                self.forward_class.value_namespace = name_space
                                                self.forward_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-node-protection"):
                                                self.frr_node_protection = value
                                                self.frr_node_protection.value_namespace = name_space
                                                self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-interface-bw-configured"):
                                                self.is_interface_bw_configured = value
                                                self.is_interface_bw_configured.value_namespace = name_space
                                                self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "load-share"):
                                                self.load_share = value
                                                self.load_share.value_namespace = name_space
                                                self.load_share.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "soft-preemption-configured"):
                                                self.soft_preemption_configured = value
                                                self.soft_preemption_configured.value_namespace = name_space
                                                self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                                    class AttributeSetXro(Entity):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._children_yang_names.add("xro")


                                        class Xro(Entity):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\:  bool
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"

                                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                                self.xro_subobject = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                            class XroSubobject(Entity):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                    self.as_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"
                                                    self._children_yang_names.add("as-subobject")

                                                    self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                    self._children_yang_names.add("ipv4-subobject")

                                                    self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                    self._children_yang_names.add("ipv6-subobject")

                                                    self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._children_yang_names.add("lsp-subobject")

                                                    self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                    self._children_yang_names.add("srlg-subobject")

                                                    self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                    self._children_yang_names.add("unnumbered-subobject")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                                class Ipv4Subobject(Entity):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv4-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class Ipv6Subobject(Entity):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv6-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class UnnumberedSubobject(Entity):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("attribute",
                                                                        "exclusion_type",
                                                                        "interface_id",
                                                                        "te_router_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.interface_id.is_set or
                                                            self.te_router_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.interface_id.yfilter != YFilter.not_set or
                                                            self.te_router_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "unnumbered-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "interface-id"):
                                                            self.interface_id = value
                                                            self.interface_id.value_namespace = name_space
                                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "te-router-id"):
                                                            self.te_router_id = value
                                                            self.te_router_id.value_namespace = name_space
                                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                                class AsSubobject(Entity):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("as_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.as_number.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.as_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "as-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "as-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "as-number"):
                                                            self.as_number = value
                                                            self.as_number.value_namespace = name_space
                                                            self.as_number.value_namespace_prefix = name_space_prefix


                                                class SrlgSubobject(Entity):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("exclusion_type",
                                                                        "srlg_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.exclusion_type.is_set or
                                                            self.srlg_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.srlg_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "srlg-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "exclusion-type" or name == "srlg-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "srlg-id"):
                                                            self.srlg_id = value
                                                            self.srlg_id.value_namespace = name_space
                                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                                class LspSubobject(Entity):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                                        self.fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._children_yang_names.add("fec")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("destination_node_exception",
                                                                        "exclusion_type",
                                                                        "ignore_lsp_id",
                                                                        "penultimate_node_exception",
                                                                        "processing_node_exception") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                                    class Fec(Entity):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\:  str
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"

                                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                            self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._children_yang_names.add("fec-destination-info")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("fec_extended_tunnel_id",
                                                                            "fec_lsp_id",
                                                                            "fec_source",
                                                                            "fec_tunnel_id",
                                                                            "fec_vrf") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                                        class FecDestinationInfo(Entity):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\:  str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"

                                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("fec_ctype",
                                                                                "fec_destination_p2mp_id",
                                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.fec_ctype.is_set or
                                                                    self.fec_destination_p2mp_id.is_set or
                                                                    self.p2p_lsp_destination.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "fec-destination-info" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "fec-ctype"):
                                                                    self.fec_ctype = value
                                                                    self.fec_ctype.value_namespace = name_space
                                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "fec-destination-p2mp-id"):
                                                                    self.fec_destination_p2mp_id = value
                                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "p2p-lsp-destination"):
                                                                    self.p2p_lsp_destination = value
                                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.fec_extended_tunnel_id.is_set or
                                                                self.fec_lsp_id.is_set or
                                                                self.fec_source.is_set or
                                                                self.fec_tunnel_id.is_set or
                                                                self.fec_vrf.is_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                                self.fec_source.yfilter != YFilter.not_set or
                                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "fec" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "fec-destination-info"):
                                                                if (self.fec_destination_info is None):
                                                                    self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                                    self.fec_destination_info.parent = self
                                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                                return self.fec_destination_info

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "fec-extended-tunnel-id"):
                                                                self.fec_extended_tunnel_id = value
                                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-lsp-id"):
                                                                self.fec_lsp_id = value
                                                                self.fec_lsp_id.value_namespace = name_space
                                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-source"):
                                                                self.fec_source = value
                                                                self.fec_source.value_namespace = name_space
                                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-tunnel-id"):
                                                                self.fec_tunnel_id = value
                                                                self.fec_tunnel_id.value_namespace = name_space
                                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-vrf"):
                                                                self.fec_vrf = value
                                                                self.fec_vrf.value_namespace = name_space
                                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.destination_node_exception.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.ignore_lsp_id.is_set or
                                                            self.penultimate_node_exception.is_set or
                                                            self.processing_node_exception.is_set or
                                                            (self.fec is not None and self.fec.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                                            (self.fec is not None and self.fec.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsp-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "fec"):
                                                            if (self.fec is None):
                                                                self.fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                                self.fec.parent = self
                                                                self._children_name_map["fec"] = "fec"
                                                            return self.fec

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "destination-node-exception"):
                                                            self.destination_node_exception = value
                                                            self.destination_node_exception.value_namespace = name_space
                                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ignore-lsp-id"):
                                                            self.ignore_lsp_id = value
                                                            self.ignore_lsp_id.value_namespace = name_space
                                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "penultimate-node-exception"):
                                                            self.penultimate_node_exception = value
                                                            self.penultimate_node_exception.value_namespace = name_space
                                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "processing-node-exception"):
                                                            self.processing_node_exception = value
                                                            self.processing_node_exception.value_namespace = name_space
                                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.type.is_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "xro-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "as-subobject"):
                                                        if (self.as_subobject is None):
                                                            self.as_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                            self.as_subobject.parent = self
                                                            self._children_name_map["as_subobject"] = "as-subobject"
                                                        return self.as_subobject

                                                    if (child_yang_name == "ipv4-subobject"):
                                                        if (self.ipv4_subobject is None):
                                                            self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                            self.ipv4_subobject.parent = self
                                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                        return self.ipv4_subobject

                                                    if (child_yang_name == "ipv6-subobject"):
                                                        if (self.ipv6_subobject is None):
                                                            self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                            self.ipv6_subobject.parent = self
                                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                        return self.ipv6_subobject

                                                    if (child_yang_name == "lsp-subobject"):
                                                        if (self.lsp_subobject is None):
                                                            self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                            self.lsp_subobject.parent = self
                                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                        return self.lsp_subobject

                                                    if (child_yang_name == "srlg-subobject"):
                                                        if (self.srlg_subobject is None):
                                                            self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                            self.srlg_subobject.parent = self
                                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                        return self.srlg_subobject

                                                    if (child_yang_name == "unnumbered-subobject"):
                                                        if (self.unnumbered_subobject is None):
                                                            self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                            self.unnumbered_subobject.parent = self
                                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                        return self.unnumbered_subobject

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_data()):
                                                        return True
                                                return self.mutual_diversity_flag.is_set

                                            def has_operation(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "xro" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "xro-subobject"):
                                                    for c in self.xro_subobject:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.xro_subobject.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "mutual-diversity-flag"):
                                                    self.mutual_diversity_flag = value
                                                    self.mutual_diversity_flag.value_namespace = name_space
                                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (self.xro is not None and self.xro.has_data())

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.xro is not None and self.xro.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-xro" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "xro"):
                                                if (self.xro is None):
                                                    self.xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                                    self.xro.parent = self
                                                    self._children_name_map["xro"] = "xro"
                                                return self.xro

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "xro"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class AttributeSetP2Mpte(Entity):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "frr_bandwidth_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_priority_configured",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2mpte" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetApsPp(Entity):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                            self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                            self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                            self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                            self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                            self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                            self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                            self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                            self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._children_yang_names.add("revert-schedule")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_off_time",
                                                            "path_prot_profile_type",
                                                            "protection_mode",
                                                            "protection_type",
                                                            "restoration_style",
                                                            "snc_mode",
                                                            "tcm_id",
                                                            "wait_to_restore_time") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                                        class RevertSchedule(Entity):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"

                                                self.duration = YLeaf(YType.uint32, "duration")

                                                self.max_tries = YLeaf(YType.uint32, "max-tries")

                                                self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                                self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                                self.schedulename = YLeaf(YType.str, "schedulename")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("duration",
                                                                "max_tries",
                                                                "schedule_date",
                                                                "schedule_frequency",
                                                                "schedulename") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.duration.is_set or
                                                    self.max_tries.is_set or
                                                    self.schedule_date.is_set or
                                                    self.schedule_frequency.is_set or
                                                    self.schedulename.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.duration.yfilter != YFilter.not_set or
                                                    self.max_tries.yfilter != YFilter.not_set or
                                                    self.schedule_date.yfilter != YFilter.not_set or
                                                    self.schedule_frequency.yfilter != YFilter.not_set or
                                                    self.schedulename.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "revert-schedule" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.duration.get_name_leafdata())
                                                if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_tries.get_name_leafdata())
                                                if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                                if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                                if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedulename.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "duration"):
                                                    self.duration = value
                                                    self.duration.value_namespace = name_space
                                                    self.duration.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-tries"):
                                                    self.max_tries = value
                                                    self.max_tries.value_namespace = name_space
                                                    self.max_tries.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-date"):
                                                    self.schedule_date = value
                                                    self.schedule_date.value_namespace = name_space
                                                    self.schedule_date.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-frequency"):
                                                    self.schedule_frequency = value
                                                    self.schedule_frequency.value_namespace = name_space
                                                    self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedulename"):
                                                    self.schedulename = value
                                                    self.schedulename.value_namespace = name_space
                                                    self.schedulename.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.hold_off_time.is_set or
                                                self.path_prot_profile_type.is_set or
                                                self.protection_mode.is_set or
                                                self.protection_type.is_set or
                                                self.restoration_style.is_set or
                                                self.snc_mode.is_set or
                                                self.tcm_id.is_set or
                                                self.wait_to_restore_time.is_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_off_time.yfilter != YFilter.not_set or
                                                self.path_prot_profile_type.yfilter != YFilter.not_set or
                                                self.protection_mode.yfilter != YFilter.not_set or
                                                self.protection_type.yfilter != YFilter.not_set or
                                                self.restoration_style.yfilter != YFilter.not_set or
                                                self.snc_mode.yfilter != YFilter.not_set or
                                                self.tcm_id.yfilter != YFilter.not_set or
                                                self.wait_to_restore_time.yfilter != YFilter.not_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-aps-pp" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                            if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                            if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                            if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_type.get_name_leafdata())
                                            if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                            if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                            if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                            if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "revert-schedule"):
                                                if (self.revert_schedule is None):
                                                    self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                                    self.revert_schedule.parent = self
                                                    self._children_name_map["revert_schedule"] = "revert-schedule"
                                                return self.revert_schedule

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-off-time"):
                                                self.hold_off_time = value
                                                self.hold_off_time.value_namespace = name_space
                                                self.hold_off_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-prot-profile-type"):
                                                self.path_prot_profile_type = value
                                                self.path_prot_profile_type.value_namespace = name_space
                                                self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-mode"):
                                                self.protection_mode = value
                                                self.protection_mode.value_namespace = name_space
                                                self.protection_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-type"):
                                                self.protection_type = value
                                                self.protection_type.value_namespace = name_space
                                                self.protection_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "restoration-style"):
                                                self.restoration_style = value
                                                self.restoration_style.value_namespace = name_space
                                                self.restoration_style.value_namespace_prefix = name_space_prefix
                                            if(value_path == "snc-mode"):
                                                self.snc_mode = value
                                                self.snc_mode.value_namespace = name_space
                                                self.snc_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcm-id"):
                                                self.tcm_id = value
                                                self.tcm_id.value_namespace = name_space
                                                self.tcm_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "wait-to-restore-time"):
                                                self.wait_to_restore_time = value
                                                self.wait_to_restore_time.value_namespace = name_space
                                                self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                                    class AttributeSetP2PTe(Entity):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                            self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                            self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                            self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                            self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                            self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                            self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                            self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                            self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                            self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.prepend_list = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"
                                            self._children_yang_names.add("prepend-list")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_affinity_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_path_select_configured",
                                                            "is_path_selection_metric_configured",
                                                            "is_path_selection_segment_routing_adjacency_protection_configured",
                                                            "is_path_selection_segment_routing_margin_configured",
                                                            "is_path_selection_segment_routing_margin_relative",
                                                            "is_path_selection_segment_routing_segment_limit_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "is_prepend_list_configured",
                                                            "path_invalidation_timeout",
                                                            "path_selection_invalidation_action",
                                                            "path_selection_metric",
                                                            "path_selection_segment_routing_adjacency_protection",
                                                            "path_selection_segment_routing_margin",
                                                            "path_selection_segment_routing_segment_limit",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PrependList(Entity):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.prepend_entry = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in () and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                            class PrependEntry(Entity):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"

                                                    self.index = YLeaf(YType.uint32, "index")

                                                    self.next_label = YLeaf(YType.uint32, "next-label")

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("index",
                                                                    "next_label",
                                                                    "type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.index.is_set or
                                                        self.next_label.is_set or
                                                        self.type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.index.yfilter != YFilter.not_set or
                                                        self.next_label.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "prepend-entry" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.index.get_name_leafdata())
                                                    if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.next_label.get_name_leafdata())
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "index" or name == "next-label" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "index"):
                                                        self.index = value
                                                        self.index.value_namespace = name_space
                                                        self.index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "next-label"):
                                                        self.next_label = value
                                                        self.next_label.value_namespace = name_space
                                                        self.next_label.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_data()):
                                                        return True
                                                return False

                                            def has_operation(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_operation()):
                                                        return True
                                                return self.yfilter != YFilter.not_set

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prepend-list" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "prepend-entry"):
                                                    for c in self.prepend_entry:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.prepend_entry.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "prepend-entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                pass


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.is_affinity_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_path_select_configured.is_set or
                                                self.is_path_selection_metric_configured.is_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_relative.is_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.is_prepend_list_configured.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.path_selection_invalidation_action.is_set or
                                                self.path_selection_metric.is_set or
                                                self.path_selection_segment_routing_adjacency_protection.is_set or
                                                self.path_selection_segment_routing_margin.is_set or
                                                self.path_selection_segment_routing_segment_limit.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.prepend_list is not None and self.prepend_list.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_path_select_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_selection_metric.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.prepend_list is not None and self.prepend_list.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2p-te" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                            if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                            if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                            if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                            if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                            if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "prepend-list"):
                                                if (self.prepend_list is None):
                                                    self.prepend_list = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                                    self.prepend_list.parent = self
                                                    self._children_name_map["prepend_list"] = "prepend-list"
                                                return self.prepend_list

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-select-configured"):
                                                self.is_path_select_configured = value
                                                self.is_path_select_configured.value_namespace = name_space
                                                self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-metric-configured"):
                                                self.is_path_selection_metric_configured = value
                                                self.is_path_selection_metric_configured.value_namespace = name_space
                                                self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                                self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                                self.is_path_selection_segment_routing_margin_configured = value
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                                self.is_path_selection_segment_routing_margin_relative = value
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                                self.is_path_selection_segment_routing_segment_limit_configured = value
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-prepend-list-configured"):
                                                self.is_prepend_list_configured = value
                                                self.is_prepend_list_configured.value_namespace = name_space
                                                self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-invalidation-action"):
                                                self.path_selection_invalidation_action = value
                                                self.path_selection_invalidation_action.value_namespace = name_space
                                                self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-metric"):
                                                self.path_selection_metric = value
                                                self.path_selection_metric.value_namespace = name_space
                                                self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                                self.path_selection_segment_routing_adjacency_protection = value
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-margin"):
                                                self.path_selection_segment_routing_margin = value
                                                self.path_selection_segment_routing_margin.value_namespace = name_space
                                                self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-segment-limit"):
                                                self.path_selection_segment_routing_segment_limit = value
                                                self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                                self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.tunnel_attribute_set_type.is_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-union" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "attribute-set-aps-pp"):
                                            if (self.attribute_set_aps_pp is None):
                                                self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                                self.attribute_set_aps_pp.parent = self
                                                self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                            return self.attribute_set_aps_pp

                                        if (child_yang_name == "attribute-set-autobackup"):
                                            if (self.attribute_set_autobackup is None):
                                                self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                                self.attribute_set_autobackup.parent = self
                                                self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                            return self.attribute_set_autobackup

                                        if (child_yang_name == "attribute-set-automesh"):
                                            if (self.attribute_set_automesh is None):
                                                self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                                self.attribute_set_automesh.parent = self
                                                self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                            return self.attribute_set_automesh

                                        if (child_yang_name == "attribute-set-p2mpte"):
                                            if (self.attribute_set_p2mpte is None):
                                                self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                                self.attribute_set_p2mpte.parent = self
                                                self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                            return self.attribute_set_p2mpte

                                        if (child_yang_name == "attribute-set-p2p-te"):
                                            if (self.attribute_set_p2p_te is None):
                                                self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                                self.attribute_set_p2p_te.parent = self
                                                self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                            return self.attribute_set_p2p_te

                                        if (child_yang_name == "attribute-set-path-option"):
                                            if (self.attribute_set_path_option is None):
                                                self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                                self.attribute_set_path_option.parent = self
                                                self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                            return self.attribute_set_path_option

                                        if (child_yang_name == "attribute-set-xro"):
                                            if (self.attribute_set_xro is None):
                                                self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                                self.attribute_set_xro.parent = self
                                                self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                            return self.attribute_set_xro

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "tunnel-attribute-set-type"):
                                            self.tunnel_attribute_set_type = value
                                            self.tunnel_attribute_set_type.value_namespace = name_space
                                            self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.tunnel_attribute_set_name.is_set or
                                        self.tunnel_attribute_set_name_crc32.is_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-attribute-set" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                                    if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "attribute-set-union"):
                                        if (self.attribute_set_union is None):
                                            self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                            self.attribute_set_union.parent = self
                                            self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                        return self.attribute_set_union

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "tunnel-attribute-set-name"):
                                        self.tunnel_attribute_set_name = value
                                        self.tunnel_attribute_set_name.value_namespace = name_space
                                        self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-attribute-set-name-crc32"):
                                        self.tunnel_attribute_set_name_crc32 = value
                                        self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                                        self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                            class PathCalculationError(Entity):
                                """
                                Path computation information
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.PathCalculationError, self).__init__()

                                    self.yang_name = "path-calculation-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error_message",
                                                    "log_time",
                                                    "lsp_mode") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.PathCalculationError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.PathCalculationError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error_message.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-calculation-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix


                            class RemergeError(Entity):
                                """
                                Path computation remerge resolve info
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.RemergeError, self).__init__()

                                    self.yang_name = "remerge-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error_message",
                                                    "log_time",
                                                    "lsp_mode") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.RemergeError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.RemergeError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error_message.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "remerge-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix


                            class SignallingError(Entity):
                                """
                                Signalling information
                                
                                .. attribute:: error
                                
                                	Path Error code
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: error_node
                                
                                	Source address of the error generating node
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: log_time
                                
                                	Time in seconds when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSPMode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                .. attribute:: reverse_lsp
                                
                                	Indicates if error is on the reverse LSP
                                	**type**\:  bool
                                
                                .. attribute:: signalling_lsp_id
                                
                                	LSP\-id for which the error was received
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: sub_code
                                
                                	Path Error subcode
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.SignallingError, self).__init__()

                                    self.yang_name = "signalling-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error = YLeaf(YType.uint8, "error")

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.error_node = YLeaf(YType.uint32, "error-node")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                    self.reverse_lsp = YLeaf(YType.boolean, "reverse-lsp")

                                    self.signalling_lsp_id = YLeaf(YType.uint16, "signalling-lsp-id")

                                    self.sub_code = YLeaf(YType.uint16, "sub-code")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error",
                                                    "error_message",
                                                    "error_node",
                                                    "log_time",
                                                    "lsp_mode",
                                                    "reverse_lsp",
                                                    "signalling_lsp_id",
                                                    "sub_code") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.SignallingError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.SignallingError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error.is_set or
                                        self.error_message.is_set or
                                        self.error_node.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set or
                                        self.reverse_lsp.is_set or
                                        self.signalling_lsp_id.is_set or
                                        self.sub_code.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.error_node.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set or
                                        self.reverse_lsp.yfilter != YFilter.not_set or
                                        self.signalling_lsp_id.yfilter != YFilter.not_set or
                                        self.sub_code.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "signalling-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error.is_set or self.error.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error.get_name_leafdata())
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.error_node.is_set or self.error_node.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_node.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())
                                    if (self.reverse_lsp.is_set or self.reverse_lsp.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.reverse_lsp.get_name_leafdata())
                                    if (self.signalling_lsp_id.is_set or self.signalling_lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signalling_lsp_id.get_name_leafdata())
                                    if (self.sub_code.is_set or self.sub_code.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.sub_code.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error" or name == "error-message" or name == "error-node" or name == "log-time" or name == "lsp-mode" or name == "reverse-lsp" or name == "signalling-lsp-id" or name == "sub-code"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error"):
                                        self.error = value
                                        self.error.value_namespace = name_space
                                        self.error.value_namespace_prefix = name_space_prefix
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "error-node"):
                                        self.error_node = value
                                        self.error_node.value_namespace = name_space
                                        self.error_node.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "reverse-lsp"):
                                        self.reverse_lsp = value
                                        self.reverse_lsp.value_namespace = name_space
                                        self.reverse_lsp.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signalling-lsp-id"):
                                        self.signalling_lsp_id = value
                                        self.signalling_lsp_id.value_namespace = name_space
                                        self.signalling_lsp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "sub-code"):
                                        self.sub_code = value
                                        self.sub_code.value_namespace = name_space
                                        self.sub_code.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.path_calculation_error:
                                    if (c.has_data()):
                                        return True
                                for c in self.remerge_error:
                                    if (c.has_data()):
                                        return True
                                for c in self.signalling_error:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.attribute_set_found.is_set or
                                    self.explicit_path_id.is_set or
                                    self.explicit_path_name.is_set or
                                    self.has_attribute_set.is_set or
                                    self.has_xro_attribute_set.is_set or
                                    self.holddown_duration.is_set or
                                    self.is_disabled.is_set or
                                    self.is_helddown.is_set or
                                    self.is_lockdown.is_set or
                                    self.is_segment_routing.is_set or
                                    self.is_strict_explicit_path.is_set or
                                    self.is_verbatim.is_set or
                                    self.option_index.is_set or
                                    self.option_index_is_valid.is_set or
                                    self.path_option_area_id.is_set or
                                    self.path_option_name.is_set or
                                    self.path_option_type.is_set or
                                    self.pce_address.is_set or
                                    self.protected_by_path_option_index.is_set or
                                    self.restored_from_path_option_index.is_set or
                                    self.xro_attribute_set_found.is_set or
                                    (self.attribute_set is not None and self.attribute_set.has_data()) or
                                    (self.xro_attribute_set is not None and self.xro_attribute_set.has_data()))

                            def has_operation(self):
                                for c in self.path_calculation_error:
                                    if (c.has_operation()):
                                        return True
                                for c in self.remerge_error:
                                    if (c.has_operation()):
                                        return True
                                for c in self.signalling_error:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.attribute_set_found.yfilter != YFilter.not_set or
                                    self.explicit_path_id.yfilter != YFilter.not_set or
                                    self.explicit_path_name.yfilter != YFilter.not_set or
                                    self.has_attribute_set.yfilter != YFilter.not_set or
                                    self.has_xro_attribute_set.yfilter != YFilter.not_set or
                                    self.holddown_duration.yfilter != YFilter.not_set or
                                    self.is_disabled.yfilter != YFilter.not_set or
                                    self.is_helddown.yfilter != YFilter.not_set or
                                    self.is_lockdown.yfilter != YFilter.not_set or
                                    self.is_segment_routing.yfilter != YFilter.not_set or
                                    self.is_strict_explicit_path.yfilter != YFilter.not_set or
                                    self.is_verbatim.yfilter != YFilter.not_set or
                                    self.option_index.yfilter != YFilter.not_set or
                                    self.option_index_is_valid.yfilter != YFilter.not_set or
                                    self.path_option_area_id.yfilter != YFilter.not_set or
                                    self.path_option_name.yfilter != YFilter.not_set or
                                    self.path_option_type.yfilter != YFilter.not_set or
                                    self.pce_address.yfilter != YFilter.not_set or
                                    self.protected_by_path_option_index.yfilter != YFilter.not_set or
                                    self.restored_from_path_option_index.yfilter != YFilter.not_set or
                                    self.xro_attribute_set_found.yfilter != YFilter.not_set or
                                    (self.attribute_set is not None and self.attribute_set.has_operation()) or
                                    (self.xro_attribute_set is not None and self.xro_attribute_set.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "active-path-option" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.attribute_set_found.is_set or self.attribute_set_found.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.attribute_set_found.get_name_leafdata())
                                if (self.explicit_path_id.is_set or self.explicit_path_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.explicit_path_id.get_name_leafdata())
                                if (self.explicit_path_name.is_set or self.explicit_path_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.explicit_path_name.get_name_leafdata())
                                if (self.has_attribute_set.is_set or self.has_attribute_set.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_attribute_set.get_name_leafdata())
                                if (self.has_xro_attribute_set.is_set or self.has_xro_attribute_set.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_xro_attribute_set.get_name_leafdata())
                                if (self.holddown_duration.is_set or self.holddown_duration.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.holddown_duration.get_name_leafdata())
                                if (self.is_disabled.is_set or self.is_disabled.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_disabled.get_name_leafdata())
                                if (self.is_helddown.is_set or self.is_helddown.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_helddown.get_name_leafdata())
                                if (self.is_lockdown.is_set or self.is_lockdown.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_lockdown.get_name_leafdata())
                                if (self.is_segment_routing.is_set or self.is_segment_routing.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_segment_routing.get_name_leafdata())
                                if (self.is_strict_explicit_path.is_set or self.is_strict_explicit_path.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_strict_explicit_path.get_name_leafdata())
                                if (self.is_verbatim.is_set or self.is_verbatim.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_verbatim.get_name_leafdata())
                                if (self.option_index.is_set or self.option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.option_index.get_name_leafdata())
                                if (self.option_index_is_valid.is_set or self.option_index_is_valid.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.option_index_is_valid.get_name_leafdata())
                                if (self.path_option_area_id.is_set or self.path_option_area_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_area_id.get_name_leafdata())
                                if (self.path_option_name.is_set or self.path_option_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_name.get_name_leafdata())
                                if (self.path_option_type.is_set or self.path_option_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_type.get_name_leafdata())
                                if (self.pce_address.is_set or self.pce_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pce_address.get_name_leafdata())
                                if (self.protected_by_path_option_index.is_set or self.protected_by_path_option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.protected_by_path_option_index.get_name_leafdata())
                                if (self.restored_from_path_option_index.is_set or self.restored_from_path_option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.restored_from_path_option_index.get_name_leafdata())
                                if (self.xro_attribute_set_found.is_set or self.xro_attribute_set_found.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.xro_attribute_set_found.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "attribute-set"):
                                    if (self.attribute_set is None):
                                        self.attribute_set = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.AttributeSet()
                                        self.attribute_set.parent = self
                                        self._children_name_map["attribute_set"] = "attribute-set"
                                    return self.attribute_set

                                if (child_yang_name == "path-calculation-error"):
                                    for c in self.path_calculation_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.PathCalculationError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.path_calculation_error.append(c)
                                    return c

                                if (child_yang_name == "remerge-error"):
                                    for c in self.remerge_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.RemergeError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.remerge_error.append(c)
                                    return c

                                if (child_yang_name == "signalling-error"):
                                    for c in self.signalling_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.SignallingError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.signalling_error.append(c)
                                    return c

                                if (child_yang_name == "xro-attribute-set"):
                                    if (self.xro_attribute_set is None):
                                        self.xro_attribute_set = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption.XroAttributeSet()
                                        self.xro_attribute_set.parent = self
                                        self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                                    return self.xro_attribute_set

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "attribute-set" or name == "path-calculation-error" or name == "remerge-error" or name == "signalling-error" or name == "xro-attribute-set" or name == "attribute-set-found" or name == "explicit-path-id" or name == "explicit-path-name" or name == "has-attribute-set" or name == "has-xro-attribute-set" or name == "holddown-duration" or name == "is-disabled" or name == "is-helddown" or name == "is-lockdown" or name == "is-segment-routing" or name == "is-strict-explicit-path" or name == "is-verbatim" or name == "option-index" or name == "option-index-is-valid" or name == "path-option-area-id" or name == "path-option-name" or name == "path-option-type" or name == "pce-address" or name == "protected-by-path-option-index" or name == "restored-from-path-option-index" or name == "xro-attribute-set-found"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "attribute-set-found"):
                                    self.attribute_set_found = value
                                    self.attribute_set_found.value_namespace = name_space
                                    self.attribute_set_found.value_namespace_prefix = name_space_prefix
                                if(value_path == "explicit-path-id"):
                                    self.explicit_path_id = value
                                    self.explicit_path_id.value_namespace = name_space
                                    self.explicit_path_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "explicit-path-name"):
                                    self.explicit_path_name = value
                                    self.explicit_path_name.value_namespace = name_space
                                    self.explicit_path_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-attribute-set"):
                                    self.has_attribute_set = value
                                    self.has_attribute_set.value_namespace = name_space
                                    self.has_attribute_set.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-xro-attribute-set"):
                                    self.has_xro_attribute_set = value
                                    self.has_xro_attribute_set.value_namespace = name_space
                                    self.has_xro_attribute_set.value_namespace_prefix = name_space_prefix
                                if(value_path == "holddown-duration"):
                                    self.holddown_duration = value
                                    self.holddown_duration.value_namespace = name_space
                                    self.holddown_duration.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-disabled"):
                                    self.is_disabled = value
                                    self.is_disabled.value_namespace = name_space
                                    self.is_disabled.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-helddown"):
                                    self.is_helddown = value
                                    self.is_helddown.value_namespace = name_space
                                    self.is_helddown.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-lockdown"):
                                    self.is_lockdown = value
                                    self.is_lockdown.value_namespace = name_space
                                    self.is_lockdown.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-segment-routing"):
                                    self.is_segment_routing = value
                                    self.is_segment_routing.value_namespace = name_space
                                    self.is_segment_routing.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-strict-explicit-path"):
                                    self.is_strict_explicit_path = value
                                    self.is_strict_explicit_path.value_namespace = name_space
                                    self.is_strict_explicit_path.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-verbatim"):
                                    self.is_verbatim = value
                                    self.is_verbatim.value_namespace = name_space
                                    self.is_verbatim.value_namespace_prefix = name_space_prefix
                                if(value_path == "option-index"):
                                    self.option_index = value
                                    self.option_index.value_namespace = name_space
                                    self.option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "option-index-is-valid"):
                                    self.option_index_is_valid = value
                                    self.option_index_is_valid.value_namespace = name_space
                                    self.option_index_is_valid.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-area-id"):
                                    self.path_option_area_id = value
                                    self.path_option_area_id.value_namespace = name_space
                                    self.path_option_area_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-name"):
                                    self.path_option_name = value
                                    self.path_option_name.value_namespace = name_space
                                    self.path_option_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-type"):
                                    self.path_option_type = value
                                    self.path_option_type.value_namespace = name_space
                                    self.path_option_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "pce-address"):
                                    self.pce_address = value
                                    self.pce_address.value_namespace = name_space
                                    self.pce_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "protected-by-path-option-index"):
                                    self.protected_by_path_option_index = value
                                    self.protected_by_path_option_index.value_namespace = name_space
                                    self.protected_by_path_option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "restored-from-path-option-index"):
                                    self.restored_from_path_option_index = value
                                    self.restored_from_path_option_index.value_namespace = name_space
                                    self.restored_from_path_option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "xro-attribute-set-found"):
                                    self.xro_attribute_set_found = value
                                    self.xro_attribute_set_found.value_namespace = name_space
                                    self.xro_attribute_set_found.value_namespace_prefix = name_space_prefix


                        class OutXro(Entity):
                            """
                            Outgoing XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\:  bool
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro, self).__init__()

                                self.yang_name = "out-xro"
                                self.yang_parent_name = "s2l"

                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                self.xro_subobject = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro, self).__setattr__(name, value)


                            class XroSubobject(Entity):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.AsSubobject>`
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.Ipv4Subobject>`
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.Ipv6Subobject>`
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.LspSubobject>`
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.SrlgSubobject>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "out-xro"

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.as_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"
                                    self._children_yang_names.add("as-subobject")

                                    self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                    self._children_yang_names.add("ipv4-subobject")

                                    self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                    self._children_yang_names.add("ipv6-subobject")

                                    self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._children_yang_names.add("lsp-subobject")

                                    self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                    self._children_yang_names.add("srlg-subobject")

                                    self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                    self._children_yang_names.add("unnumbered-subobject")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject, self).__setattr__(name, value)


                                class Ipv4Subobject(Entity):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class Ipv6Subobject(Entity):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class UnnumberedSubobject(Entity):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("attribute",
                                                        "exclusion_type",
                                                        "interface_id",
                                                        "te_router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.interface_id.is_set or
                                            self.te_router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.interface_id.yfilter != YFilter.not_set or
                                            self.te_router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "unnumbered-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-id"):
                                            self.interface_id = value
                                            self.interface_id.value_namespace = name_space
                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "te-router-id"):
                                            self.te_router_id = value
                                            self.te_router_id.value_namespace = name_space
                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                class AsSubobject(Entity):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("as_number") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.as_number.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.as_number.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "as-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "as-number"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "as-number"):
                                            self.as_number = value
                                            self.as_number.value_namespace = name_space
                                            self.as_number.value_namespace_prefix = name_space_prefix


                                class SrlgSubobject(Entity):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("exclusion_type",
                                                        "srlg_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.exclusion_type.is_set or
                                            self.srlg_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.srlg_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srlg-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "exclusion-type" or name == "srlg-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "srlg-id"):
                                            self.srlg_id = value
                                            self.srlg_id.value_namespace = name_space
                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                class LspSubobject(Entity):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\:  bool
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                        self.fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._children_yang_names.add("fec")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("destination_node_exception",
                                                        "exclusion_type",
                                                        "ignore_lsp_id",
                                                        "penultimate_node_exception",
                                                        "processing_node_exception") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                    class Fec(Entity):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"

                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                            self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._children_yang_names.add("fec-destination-info")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("fec_extended_tunnel_id",
                                                            "fec_lsp_id",
                                                            "fec_source",
                                                            "fec_tunnel_id",
                                                            "fec_vrf") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                        class FecDestinationInfo(Entity):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"

                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("fec_ctype",
                                                                "fec_destination_p2mp_id",
                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.fec_ctype.is_set or
                                                    self.fec_destination_p2mp_id.is_set or
                                                    self.p2p_lsp_destination.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "fec-destination-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "fec-ctype"):
                                                    self.fec_ctype = value
                                                    self.fec_ctype.value_namespace = name_space
                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                if(value_path == "fec-destination-p2mp-id"):
                                                    self.fec_destination_p2mp_id = value
                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "p2p-lsp-destination"):
                                                    self.p2p_lsp_destination = value
                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.fec_extended_tunnel_id.is_set or
                                                self.fec_lsp_id.is_set or
                                                self.fec_source.is_set or
                                                self.fec_tunnel_id.is_set or
                                                self.fec_vrf.is_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                self.fec_source.yfilter != YFilter.not_set or
                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "fec" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "fec-destination-info"):
                                                if (self.fec_destination_info is None):
                                                    self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                    self.fec_destination_info.parent = self
                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                return self.fec_destination_info

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "fec-extended-tunnel-id"):
                                                self.fec_extended_tunnel_id = value
                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-lsp-id"):
                                                self.fec_lsp_id = value
                                                self.fec_lsp_id.value_namespace = name_space
                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-source"):
                                                self.fec_source = value
                                                self.fec_source.value_namespace = name_space
                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-tunnel-id"):
                                                self.fec_tunnel_id = value
                                                self.fec_tunnel_id.value_namespace = name_space
                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-vrf"):
                                                self.fec_vrf = value
                                                self.fec_vrf.value_namespace = name_space
                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.destination_node_exception.is_set or
                                            self.exclusion_type.is_set or
                                            self.ignore_lsp_id.is_set or
                                            self.penultimate_node_exception.is_set or
                                            self.processing_node_exception.is_set or
                                            (self.fec is not None and self.fec.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                            (self.fec is not None and self.fec.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "lsp-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "fec"):
                                            if (self.fec is None):
                                                self.fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec()
                                                self.fec.parent = self
                                                self._children_name_map["fec"] = "fec"
                                            return self.fec

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "destination-node-exception"):
                                            self.destination_node_exception = value
                                            self.destination_node_exception.value_namespace = name_space
                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ignore-lsp-id"):
                                            self.ignore_lsp_id = value
                                            self.ignore_lsp_id.value_namespace = name_space
                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "penultimate-node-exception"):
                                            self.penultimate_node_exception = value
                                            self.penultimate_node_exception.value_namespace = name_space
                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "processing-node-exception"):
                                            self.processing_node_exception = value
                                            self.processing_node_exception.value_namespace = name_space
                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.type.is_set or
                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "as-subobject"):
                                        if (self.as_subobject is None):
                                            self.as_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.AsSubobject()
                                            self.as_subobject.parent = self
                                            self._children_name_map["as_subobject"] = "as-subobject"
                                        return self.as_subobject

                                    if (child_yang_name == "ipv4-subobject"):
                                        if (self.ipv4_subobject is None):
                                            self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.Ipv4Subobject()
                                            self.ipv4_subobject.parent = self
                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                        return self.ipv4_subobject

                                    if (child_yang_name == "ipv6-subobject"):
                                        if (self.ipv6_subobject is None):
                                            self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.Ipv6Subobject()
                                            self.ipv6_subobject.parent = self
                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                        return self.ipv6_subobject

                                    if (child_yang_name == "lsp-subobject"):
                                        if (self.lsp_subobject is None):
                                            self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.LspSubobject()
                                            self.lsp_subobject.parent = self
                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                        return self.lsp_subobject

                                    if (child_yang_name == "srlg-subobject"):
                                        if (self.srlg_subobject is None):
                                            self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.SrlgSubobject()
                                            self.srlg_subobject.parent = self
                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                        return self.srlg_subobject

                                    if (child_yang_name == "unnumbered-subobject"):
                                        if (self.unnumbered_subobject is None):
                                            self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject()
                                            self.unnumbered_subobject.parent = self
                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                        return self.unnumbered_subobject

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.xro_subobject:
                                    if (c.has_data()):
                                        return True
                                return self.mutual_diversity_flag.is_set

                            def has_operation(self):
                                for c in self.xro_subobject:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "out-xro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "xro-subobject"):
                                    for c in self.xro_subobject:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro.XroSubobject()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.xro_subobject.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "mutual-diversity-flag"):
                                    self.mutual_diversity_flag = value
                                    self.mutual_diversity_flag.value_namespace = name_space
                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix


                        class InXro(Entity):
                            """
                            Incoming XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\:  bool
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro, self).__init__()

                                self.yang_name = "in-xro"
                                self.yang_parent_name = "s2l"

                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                self.xro_subobject = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro, self).__setattr__(name, value)


                            class XroSubobject(Entity):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.AsSubobject>`
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.Ipv4Subobject>`
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.Ipv6Subobject>`
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.LspSubobject>`
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.SrlgSubobject>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.UnnumberedSubobject>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "in-xro"

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.as_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"
                                    self._children_yang_names.add("as-subobject")

                                    self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                    self._children_yang_names.add("ipv4-subobject")

                                    self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                    self._children_yang_names.add("ipv6-subobject")

                                    self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._children_yang_names.add("lsp-subobject")

                                    self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                    self._children_yang_names.add("srlg-subobject")

                                    self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                    self._children_yang_names.add("unnumbered-subobject")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject, self).__setattr__(name, value)


                                class Ipv4Subobject(Entity):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class Ipv6Subobject(Entity):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class UnnumberedSubobject(Entity):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("attribute",
                                                        "exclusion_type",
                                                        "interface_id",
                                                        "te_router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.interface_id.is_set or
                                            self.te_router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.interface_id.yfilter != YFilter.not_set or
                                            self.te_router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "unnumbered-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-id"):
                                            self.interface_id = value
                                            self.interface_id.value_namespace = name_space
                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "te-router-id"):
                                            self.te_router_id = value
                                            self.te_router_id.value_namespace = name_space
                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                class AsSubobject(Entity):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("as_number") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.as_number.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.as_number.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "as-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "as-number"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "as-number"):
                                            self.as_number = value
                                            self.as_number.value_namespace = name_space
                                            self.as_number.value_namespace_prefix = name_space_prefix


                                class SrlgSubobject(Entity):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("exclusion_type",
                                                        "srlg_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.exclusion_type.is_set or
                                            self.srlg_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.srlg_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srlg-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "exclusion-type" or name == "srlg-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "srlg-id"):
                                            self.srlg_id = value
                                            self.srlg_id.value_namespace = name_space
                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                class LspSubobject(Entity):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\:  bool
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                        self.fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._children_yang_names.add("fec")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("destination_node_exception",
                                                        "exclusion_type",
                                                        "ignore_lsp_id",
                                                        "penultimate_node_exception",
                                                        "processing_node_exception") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                    class Fec(Entity):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"

                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                            self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._children_yang_names.add("fec-destination-info")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("fec_extended_tunnel_id",
                                                            "fec_lsp_id",
                                                            "fec_source",
                                                            "fec_tunnel_id",
                                                            "fec_vrf") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                        class FecDestinationInfo(Entity):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"

                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("fec_ctype",
                                                                "fec_destination_p2mp_id",
                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.fec_ctype.is_set or
                                                    self.fec_destination_p2mp_id.is_set or
                                                    self.p2p_lsp_destination.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "fec-destination-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "fec-ctype"):
                                                    self.fec_ctype = value
                                                    self.fec_ctype.value_namespace = name_space
                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                if(value_path == "fec-destination-p2mp-id"):
                                                    self.fec_destination_p2mp_id = value
                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "p2p-lsp-destination"):
                                                    self.p2p_lsp_destination = value
                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.fec_extended_tunnel_id.is_set or
                                                self.fec_lsp_id.is_set or
                                                self.fec_source.is_set or
                                                self.fec_tunnel_id.is_set or
                                                self.fec_vrf.is_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                self.fec_source.yfilter != YFilter.not_set or
                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "fec" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "fec-destination-info"):
                                                if (self.fec_destination_info is None):
                                                    self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                    self.fec_destination_info.parent = self
                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                return self.fec_destination_info

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "fec-extended-tunnel-id"):
                                                self.fec_extended_tunnel_id = value
                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-lsp-id"):
                                                self.fec_lsp_id = value
                                                self.fec_lsp_id.value_namespace = name_space
                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-source"):
                                                self.fec_source = value
                                                self.fec_source.value_namespace = name_space
                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-tunnel-id"):
                                                self.fec_tunnel_id = value
                                                self.fec_tunnel_id.value_namespace = name_space
                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-vrf"):
                                                self.fec_vrf = value
                                                self.fec_vrf.value_namespace = name_space
                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.destination_node_exception.is_set or
                                            self.exclusion_type.is_set or
                                            self.ignore_lsp_id.is_set or
                                            self.penultimate_node_exception.is_set or
                                            self.processing_node_exception.is_set or
                                            (self.fec is not None and self.fec.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                            (self.fec is not None and self.fec.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "lsp-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "fec"):
                                            if (self.fec is None):
                                                self.fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.LspSubobject.Fec()
                                                self.fec.parent = self
                                                self._children_name_map["fec"] = "fec"
                                            return self.fec

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "destination-node-exception"):
                                            self.destination_node_exception = value
                                            self.destination_node_exception.value_namespace = name_space
                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ignore-lsp-id"):
                                            self.ignore_lsp_id = value
                                            self.ignore_lsp_id.value_namespace = name_space
                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "penultimate-node-exception"):
                                            self.penultimate_node_exception = value
                                            self.penultimate_node_exception.value_namespace = name_space
                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "processing-node-exception"):
                                            self.processing_node_exception = value
                                            self.processing_node_exception.value_namespace = name_space
                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.type.is_set or
                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "as-subobject"):
                                        if (self.as_subobject is None):
                                            self.as_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.AsSubobject()
                                            self.as_subobject.parent = self
                                            self._children_name_map["as_subobject"] = "as-subobject"
                                        return self.as_subobject

                                    if (child_yang_name == "ipv4-subobject"):
                                        if (self.ipv4_subobject is None):
                                            self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.Ipv4Subobject()
                                            self.ipv4_subobject.parent = self
                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                        return self.ipv4_subobject

                                    if (child_yang_name == "ipv6-subobject"):
                                        if (self.ipv6_subobject is None):
                                            self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.Ipv6Subobject()
                                            self.ipv6_subobject.parent = self
                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                        return self.ipv6_subobject

                                    if (child_yang_name == "lsp-subobject"):
                                        if (self.lsp_subobject is None):
                                            self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.LspSubobject()
                                            self.lsp_subobject.parent = self
                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                        return self.lsp_subobject

                                    if (child_yang_name == "srlg-subobject"):
                                        if (self.srlg_subobject is None):
                                            self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.SrlgSubobject()
                                            self.srlg_subobject.parent = self
                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                        return self.srlg_subobject

                                    if (child_yang_name == "unnumbered-subobject"):
                                        if (self.unnumbered_subobject is None):
                                            self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject.UnnumberedSubobject()
                                            self.unnumbered_subobject.parent = self
                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                        return self.unnumbered_subobject

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.xro_subobject:
                                    if (c.has_data()):
                                        return True
                                return self.mutual_diversity_flag.is_set

                            def has_operation(self):
                                for c in self.xro_subobject:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "in-xro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "xro-subobject"):
                                    for c in self.xro_subobject:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro.XroSubobject()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.xro_subobject.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "mutual-diversity-flag"):
                                    self.mutual_diversity_flag = value
                                    self.mutual_diversity_flag.value_namespace = name_space
                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix


                        class Tspec(Entity):
                            """
                            The T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.Tspec, self).__init__()

                                self.yang_name = "tspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.Tspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.Tspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class GenericTspec(Entity):
                            """
                            Generic TSpec
                            
                            .. attribute:: otntspec
                            
                            	TE TSpec for G709 OTN
                            	**type**\:   :py:class:`Otntspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GenericTspec.Otntspec>`
                            
                            .. attribute:: tspec_type
                            
                            	TSpecType
                            	**type**\:   :py:class:`TeMgmtGenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericTspec>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GenericTspec, self).__init__()

                                self.yang_name = "generic-tspec"
                                self.yang_parent_name = "s2l"

                                self.tspec_type = YLeaf(YType.enumeration, "tspec-type")

                                self.otntspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GenericTspec.Otntspec()
                                self.otntspec.parent = self
                                self._children_name_map["otntspec"] = "otntspec"
                                self._children_yang_names.add("otntspec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("tspec_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GenericTspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GenericTspec, self).__setattr__(name, value)


                            class Otntspec(Entity):
                                """
                                TE TSpec for G709 OTN
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GenericTspec.Otntspec, self).__init__()

                                    self.yang_name = "otntspec"
                                    self.yang_parent_name = "generic-tspec"

                                    self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                    self.multiplier = YLeaf(YType.uint16, "multiplier")

                                    self.nmc_or_tolerance = YLeaf(YType.uint16, "nmc-or-tolerance")

                                    self.nvc = YLeaf(YType.uint16, "nvc")

                                    self.signal_type = YLeaf(YType.uint8, "signal-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bit_rate",
                                                    "multiplier",
                                                    "nmc_or_tolerance",
                                                    "nvc",
                                                    "signal_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GenericTspec.Otntspec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GenericTspec.Otntspec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.bit_rate.is_set or
                                        self.multiplier.is_set or
                                        self.nmc_or_tolerance.is_set or
                                        self.nvc.is_set or
                                        self.signal_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bit_rate.yfilter != YFilter.not_set or
                                        self.multiplier.yfilter != YFilter.not_set or
                                        self.nmc_or_tolerance.yfilter != YFilter.not_set or
                                        self.nvc.yfilter != YFilter.not_set or
                                        self.signal_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otntspec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                    if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.multiplier.get_name_leafdata())
                                    if (self.nmc_or_tolerance.is_set or self.nmc_or_tolerance.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nmc_or_tolerance.get_name_leafdata())
                                    if (self.nvc.is_set or self.nvc.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nvc.get_name_leafdata())
                                    if (self.signal_type.is_set or self.signal_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signal_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bit-rate" or name == "multiplier" or name == "nmc-or-tolerance" or name == "nvc" or name == "signal-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bit-rate"):
                                        self.bit_rate = value
                                        self.bit_rate.value_namespace = name_space
                                        self.bit_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "multiplier"):
                                        self.multiplier = value
                                        self.multiplier.value_namespace = name_space
                                        self.multiplier.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nmc-or-tolerance"):
                                        self.nmc_or_tolerance = value
                                        self.nmc_or_tolerance.value_namespace = name_space
                                        self.nmc_or_tolerance.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nvc"):
                                        self.nvc = value
                                        self.nvc.value_namespace = name_space
                                        self.nvc.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signal-type"):
                                        self.signal_type = value
                                        self.signal_type.value_namespace = name_space
                                        self.signal_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.tspec_type.is_set or
                                    (self.otntspec is not None and self.otntspec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.tspec_type.yfilter != YFilter.not_set or
                                    (self.otntspec is not None and self.otntspec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "generic-tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.tspec_type.is_set or self.tspec_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tspec_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "otntspec"):
                                    if (self.otntspec is None):
                                        self.otntspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GenericTspec.Otntspec()
                                        self.otntspec.parent = self
                                        self._children_name_map["otntspec"] = "otntspec"
                                    return self.otntspec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "otntspec" or name == "tspec-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "tspec-type"):
                                    self.tspec_type = value
                                    self.tspec_type.value_namespace = name_space
                                    self.tspec_type.value_namespace_prefix = name_space_prefix


                        class Fspec(Entity):
                            """
                            The F spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.Fspec, self).__init__()

                                self.yang_name = "fspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.Fspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.Fspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class GenericFspec(Entity):
                            """
                            Generic FSpec
                            
                            .. attribute:: fspec_type
                            
                            	FSpecType
                            	**type**\:   :py:class:`TeMgmtGenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericFspec>`
                            
                            .. attribute:: otnfspec
                            
                            	TE FSpec for G709 OTN
                            	**type**\:   :py:class:`Otnfspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GenericFspec.Otnfspec>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GenericFspec, self).__init__()

                                self.yang_name = "generic-fspec"
                                self.yang_parent_name = "s2l"

                                self.fspec_type = YLeaf(YType.enumeration, "fspec-type")

                                self.otnfspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GenericFspec.Otnfspec()
                                self.otnfspec.parent = self
                                self._children_name_map["otnfspec"] = "otnfspec"
                                self._children_yang_names.add("otnfspec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fspec_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GenericFspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GenericFspec, self).__setattr__(name, value)


                            class Otnfspec(Entity):
                                """
                                TE FSpec for G709 OTN
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GenericFspec.Otnfspec, self).__init__()

                                    self.yang_name = "otnfspec"
                                    self.yang_parent_name = "generic-fspec"

                                    self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                    self.multiplier = YLeaf(YType.uint16, "multiplier")

                                    self.nmc_or_tolerance = YLeaf(YType.uint16, "nmc-or-tolerance")

                                    self.nvc = YLeaf(YType.uint16, "nvc")

                                    self.signal_type = YLeaf(YType.uint8, "signal-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bit_rate",
                                                    "multiplier",
                                                    "nmc_or_tolerance",
                                                    "nvc",
                                                    "signal_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GenericFspec.Otnfspec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GenericFspec.Otnfspec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.bit_rate.is_set or
                                        self.multiplier.is_set or
                                        self.nmc_or_tolerance.is_set or
                                        self.nvc.is_set or
                                        self.signal_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bit_rate.yfilter != YFilter.not_set or
                                        self.multiplier.yfilter != YFilter.not_set or
                                        self.nmc_or_tolerance.yfilter != YFilter.not_set or
                                        self.nvc.yfilter != YFilter.not_set or
                                        self.signal_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otnfspec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                    if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.multiplier.get_name_leafdata())
                                    if (self.nmc_or_tolerance.is_set or self.nmc_or_tolerance.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nmc_or_tolerance.get_name_leafdata())
                                    if (self.nvc.is_set or self.nvc.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nvc.get_name_leafdata())
                                    if (self.signal_type.is_set or self.signal_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signal_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bit-rate" or name == "multiplier" or name == "nmc-or-tolerance" or name == "nvc" or name == "signal-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bit-rate"):
                                        self.bit_rate = value
                                        self.bit_rate.value_namespace = name_space
                                        self.bit_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "multiplier"):
                                        self.multiplier = value
                                        self.multiplier.value_namespace = name_space
                                        self.multiplier.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nmc-or-tolerance"):
                                        self.nmc_or_tolerance = value
                                        self.nmc_or_tolerance.value_namespace = name_space
                                        self.nmc_or_tolerance.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nvc"):
                                        self.nvc = value
                                        self.nvc.value_namespace = name_space
                                        self.nvc.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signal-type"):
                                        self.signal_type = value
                                        self.signal_type.value_namespace = name_space
                                        self.signal_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.fspec_type.is_set or
                                    (self.otnfspec is not None and self.otnfspec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fspec_type.yfilter != YFilter.not_set or
                                    (self.otnfspec is not None and self.otnfspec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "generic-fspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fspec_type.is_set or self.fspec_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fspec_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "otnfspec"):
                                    if (self.otnfspec is None):
                                        self.otnfspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GenericFspec.Otnfspec()
                                        self.otnfspec.parent = self
                                        self._children_name_map["otnfspec"] = "otnfspec"
                                    return self.otnfspec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "otnfspec" or name == "fspec-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fspec-type"):
                                    self.fspec_type = value
                                    self.fspec_type.value_namespace = name_space
                                    self.fspec_type.value_namespace_prefix = name_space_prefix


                        class NextHopAddressGeneric(Entity):
                            """
                            Next hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.NextHopAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.NextHopAddressGeneric, self).__init__()

                                self.yang_name = "next-hop-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.NextHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.NextHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "next-hop-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.NextHopAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.NextHopAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "next-hop-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.NextHopAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class PreviousHopAddressGeneric(Entity):
                            """
                            Previous hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PreviousHopAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PreviousHopAddressGeneric, self).__init__()

                                self.yang_name = "previous-hop-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PreviousHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "previous-hop-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "previous-hop-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PreviousHopAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class IncomingAddressGeneric(Entity):
                            """
                            Incoming interface address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.IncomingAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.IncomingAddressGeneric, self).__init__()

                                self.yang_name = "incoming-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.IncomingAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.IncomingAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "incoming-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.IncomingAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.IncomingAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "incoming-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.IncomingAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class S2LConvergence(Entity):
                            """
                            TE LSP convergence related information
                            
                            .. attribute:: creation_time
                            
                            	Tunnel creation timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: label_rewrite
                            
                            	LSP Label rewrite timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_in
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_out
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_in
                            
                            	LSP RSVP Resv\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_out
                            
                            	LSP RSVP Resv\-out timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: tunnel_rewrite
                            
                            	Tunnel rewrite timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.S2LConvergence, self).__init__()

                                self.yang_name = "s2l-convergence"
                                self.yang_parent_name = "s2l"

                                self.creation_time = YLeaf(YType.uint64, "creation-time")

                                self.label_rewrite = YLeaf(YType.uint64, "label-rewrite")

                                self.path_in = YLeaf(YType.uint64, "path-in")

                                self.path_out = YLeaf(YType.uint64, "path-out")

                                self.resv_in = YLeaf(YType.uint64, "resv-in")

                                self.resv_out = YLeaf(YType.uint64, "resv-out")

                                self.tunnel_rewrite = YLeaf(YType.uint64, "tunnel-rewrite")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("creation_time",
                                                "label_rewrite",
                                                "path_in",
                                                "path_out",
                                                "resv_in",
                                                "resv_out",
                                                "tunnel_rewrite") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.S2LConvergence, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.S2LConvergence, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.creation_time.is_set or
                                    self.label_rewrite.is_set or
                                    self.path_in.is_set or
                                    self.path_out.is_set or
                                    self.resv_in.is_set or
                                    self.resv_out.is_set or
                                    self.tunnel_rewrite.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.creation_time.yfilter != YFilter.not_set or
                                    self.label_rewrite.yfilter != YFilter.not_set or
                                    self.path_in.yfilter != YFilter.not_set or
                                    self.path_out.yfilter != YFilter.not_set or
                                    self.resv_in.yfilter != YFilter.not_set or
                                    self.resv_out.yfilter != YFilter.not_set or
                                    self.tunnel_rewrite.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-convergence" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.creation_time.is_set or self.creation_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.creation_time.get_name_leafdata())
                                if (self.label_rewrite.is_set or self.label_rewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_rewrite.get_name_leafdata())
                                if (self.path_in.is_set or self.path_in.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_in.get_name_leafdata())
                                if (self.path_out.is_set or self.path_out.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_out.get_name_leafdata())
                                if (self.resv_in.is_set or self.resv_in.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.resv_in.get_name_leafdata())
                                if (self.resv_out.is_set or self.resv_out.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.resv_out.get_name_leafdata())
                                if (self.tunnel_rewrite.is_set or self.tunnel_rewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_rewrite.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "creation-time" or name == "label-rewrite" or name == "path-in" or name == "path-out" or name == "resv-in" or name == "resv-out" or name == "tunnel-rewrite"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "creation-time"):
                                    self.creation_time = value
                                    self.creation_time.value_namespace = name_space
                                    self.creation_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "label-rewrite"):
                                    self.label_rewrite = value
                                    self.label_rewrite.value_namespace = name_space
                                    self.label_rewrite.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-in"):
                                    self.path_in = value
                                    self.path_in.value_namespace = name_space
                                    self.path_in.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-out"):
                                    self.path_out = value
                                    self.path_out.value_namespace = name_space
                                    self.path_out.value_namespace_prefix = name_space_prefix
                                if(value_path == "resv-in"):
                                    self.resv_in = value
                                    self.resv_in.value_namespace = name_space
                                    self.resv_in.value_namespace_prefix = name_space_prefix
                                if(value_path == "resv-out"):
                                    self.resv_out = value
                                    self.resv_out.value_namespace = name_space
                                    self.resv_out.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-rewrite"):
                                    self.tunnel_rewrite = value
                                    self.tunnel_rewrite.value_namespace = name_space
                                    self.tunnel_rewrite.value_namespace_prefix = name_space_prefix


                        class SoftPreemption(Entity):
                            """
                            The soft preemption info for this LSP.
                            
                            .. attribute:: fr_rrewrite
                            
                            	FRR\-rewrite during soft preemption
                            	**type**\:  bool
                            
                            .. attribute:: fr_rrewrite_tunnel_name
                            
                            	The tunnel name of the backup
                            	**type**\:  str
                            
                            .. attribute:: preempting_link_address
                            
                            	The address of the link where the preemption happened
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: soft_preemption_link
                            
                            	Name of the link where the soft preemption occurred
                            	**type**\:  str
                            
                            .. attribute:: soft_preemption_timestamp
                            
                            	The POSIX timestamp when the soft preemption occurred
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: status
                            
                            	The current state of the soft preemption operation
                            	**type**\:   :py:class:`MplsTeSoftPreemptionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeSoftPreemptionState>`
                            
                            .. attribute:: time_to_hard_preemption
                            
                            	The number of seconds until hard preemption is triggered
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.SoftPreemption, self).__init__()

                                self.yang_name = "soft-preemption"
                                self.yang_parent_name = "s2l"

                                self.fr_rrewrite = YLeaf(YType.boolean, "fr-rrewrite")

                                self.fr_rrewrite_tunnel_name = YLeaf(YType.str, "fr-rrewrite-tunnel-name")

                                self.preempting_link_address = YLeaf(YType.str, "preempting-link-address")

                                self.soft_preemption_link = YLeaf(YType.str, "soft-preemption-link")

                                self.soft_preemption_timestamp = YLeaf(YType.uint32, "soft-preemption-timestamp")

                                self.status = YLeaf(YType.enumeration, "status")

                                self.time_to_hard_preemption = YLeaf(YType.uint16, "time-to-hard-preemption")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fr_rrewrite",
                                                "fr_rrewrite_tunnel_name",
                                                "preempting_link_address",
                                                "soft_preemption_link",
                                                "soft_preemption_timestamp",
                                                "status",
                                                "time_to_hard_preemption") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.SoftPreemption, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.SoftPreemption, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.fr_rrewrite.is_set or
                                    self.fr_rrewrite_tunnel_name.is_set or
                                    self.preempting_link_address.is_set or
                                    self.soft_preemption_link.is_set or
                                    self.soft_preemption_timestamp.is_set or
                                    self.status.is_set or
                                    self.time_to_hard_preemption.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fr_rrewrite.yfilter != YFilter.not_set or
                                    self.fr_rrewrite_tunnel_name.yfilter != YFilter.not_set or
                                    self.preempting_link_address.yfilter != YFilter.not_set or
                                    self.soft_preemption_link.yfilter != YFilter.not_set or
                                    self.soft_preemption_timestamp.yfilter != YFilter.not_set or
                                    self.status.yfilter != YFilter.not_set or
                                    self.time_to_hard_preemption.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "soft-preemption" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fr_rrewrite.is_set or self.fr_rrewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fr_rrewrite.get_name_leafdata())
                                if (self.fr_rrewrite_tunnel_name.is_set or self.fr_rrewrite_tunnel_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fr_rrewrite_tunnel_name.get_name_leafdata())
                                if (self.preempting_link_address.is_set or self.preempting_link_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.preempting_link_address.get_name_leafdata())
                                if (self.soft_preemption_link.is_set or self.soft_preemption_link.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.soft_preemption_link.get_name_leafdata())
                                if (self.soft_preemption_timestamp.is_set or self.soft_preemption_timestamp.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.soft_preemption_timestamp.get_name_leafdata())
                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.status.get_name_leafdata())
                                if (self.time_to_hard_preemption.is_set or self.time_to_hard_preemption.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.time_to_hard_preemption.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fr-rrewrite" or name == "fr-rrewrite-tunnel-name" or name == "preempting-link-address" or name == "soft-preemption-link" or name == "soft-preemption-timestamp" or name == "status" or name == "time-to-hard-preemption"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fr-rrewrite"):
                                    self.fr_rrewrite = value
                                    self.fr_rrewrite.value_namespace = name_space
                                    self.fr_rrewrite.value_namespace_prefix = name_space_prefix
                                if(value_path == "fr-rrewrite-tunnel-name"):
                                    self.fr_rrewrite_tunnel_name = value
                                    self.fr_rrewrite_tunnel_name.value_namespace = name_space
                                    self.fr_rrewrite_tunnel_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "preempting-link-address"):
                                    self.preempting_link_address = value
                                    self.preempting_link_address.value_namespace = name_space
                                    self.preempting_link_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "soft-preemption-link"):
                                    self.soft_preemption_link = value
                                    self.soft_preemption_link.value_namespace = name_space
                                    self.soft_preemption_link.value_namespace_prefix = name_space_prefix
                                if(value_path == "soft-preemption-timestamp"):
                                    self.soft_preemption_timestamp = value
                                    self.soft_preemption_timestamp.value_namespace = name_space
                                    self.soft_preemption_timestamp.value_namespace_prefix = name_space_prefix
                                if(value_path == "status"):
                                    self.status = value
                                    self.status.value_namespace = name_space
                                    self.status.value_namespace_prefix = name_space_prefix
                                if(value_path == "time-to-hard-preemption"):
                                    self.time_to_hard_preemption = value
                                    self.time_to_hard_preemption.value_namespace = name_space
                                    self.time_to_hard_preemption.value_namespace_prefix = name_space_prefix


                        class GmplsLabels(Entity):
                            """
                            GMPLS labels
                            
                            .. attribute:: path_egress_label
                            
                            	Path message (upstream) egress label
                            	**type**\:   :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel>`
                            
                            .. attribute:: path_ingress_label
                            
                            	Path message (upstream) ingress label
                            	**type**\:   :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel>`
                            
                            .. attribute:: resv_egress_label
                            
                            	Resv message (downstream) egress label
                            	**type**\:   :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel>`
                            
                            .. attribute:: resv_ingress_label
                            
                            	Resv message (downstream) ingress label
                            	**type**\:   :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels, self).__init__()

                                self.yang_name = "gmpls-labels"
                                self.yang_parent_name = "s2l"

                                self.path_egress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel()
                                self.path_egress_label.parent = self
                                self._children_name_map["path_egress_label"] = "path-egress-label"
                                self._children_yang_names.add("path-egress-label")

                                self.path_ingress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel()
                                self.path_ingress_label.parent = self
                                self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                self._children_yang_names.add("path-ingress-label")

                                self.resv_egress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel()
                                self.resv_egress_label.parent = self
                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                self._children_yang_names.add("resv-egress-label")

                                self.resv_ingress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel()
                                self.resv_ingress_label.parent = self
                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                self._children_yang_names.add("resv-ingress-label")


                            class PathIngressLabel(Entity):
                                """
                                Path message (upstream) ingress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel, self).__init__()

                                    self.yang_name = "path-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-ingress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-ingress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-ingress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class PathEgressLabel(Entity):
                                """
                                Path message (upstream) egress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel, self).__init__()

                                    self.yang_name = "path-egress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-egress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-egress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-egress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class ResvIngressLabel(Entity):
                                """
                                Resv message (downstream) ingress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel, self).__init__()

                                    self.yang_name = "resv-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-ingress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-ingress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "resv-ingress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class ResvEgressLabel(Entity):
                                """
                                Resv message (downstream) egress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel, self).__init__()

                                    self.yang_name = "resv-egress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-egress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-egress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "resv-egress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    (self.path_egress_label is not None and self.path_egress_label.has_data()) or
                                    (self.path_ingress_label is not None and self.path_ingress_label.has_data()) or
                                    (self.resv_egress_label is not None and self.resv_egress_label.has_data()) or
                                    (self.resv_ingress_label is not None and self.resv_ingress_label.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.path_egress_label is not None and self.path_egress_label.has_operation()) or
                                    (self.path_ingress_label is not None and self.path_ingress_label.has_operation()) or
                                    (self.resv_egress_label is not None and self.resv_egress_label.has_operation()) or
                                    (self.resv_ingress_label is not None and self.resv_ingress_label.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "gmpls-labels" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "path-egress-label"):
                                    if (self.path_egress_label is None):
                                        self.path_egress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"
                                    return self.path_egress_label

                                if (child_yang_name == "path-ingress-label"):
                                    if (self.path_ingress_label is None):
                                        self.path_ingress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                    return self.path_ingress_label

                                if (child_yang_name == "resv-egress-label"):
                                    if (self.resv_egress_label is None):
                                        self.resv_egress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                    return self.resv_egress_label

                                if (child_yang_name == "resv-ingress-label"):
                                    if (self.resv_ingress_label is None):
                                        self.resv_ingress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                    return self.resv_ingress_label

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "path-egress-label" or name == "path-ingress-label" or name == "resv-egress-label" or name == "resv-ingress-label"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class OtnS2L(Entity):
                            """
                            Otn S2L Information
                            
                            .. attribute:: aps
                            
                            	APS Info for OTN S2L
                            	**type**\:   :py:class:`Aps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Aps>`
                            
                            .. attribute:: otn
                            
                            	Info Related to OTN technology in S2L
                            	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L, self).__init__()

                                self.yang_name = "otn-s2l"
                                self.yang_parent_name = "s2l"

                                self.aps = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Aps()
                                self.aps.parent = self
                                self._children_name_map["aps"] = "aps"
                                self._children_yang_names.add("aps")

                                self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn()
                                self.otn.parent = self
                                self._children_name_map["otn"] = "otn"
                                self._children_yang_names.add("otn")


                            class Otn(Entity):
                                """
                                Info Related to OTN technology in S2L
                                
                                .. attribute:: bandwidth
                                
                                	OTN Bandwidth for s2l
                                	**type**\:   :py:class:`Bandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth>`
                                
                                .. attribute:: cross_connect_id
                                
                                	Cross connect id
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: gpid
                                
                                	Gpid Payload
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: incoming_controller
                                
                                	Incoming Controller
                                	**type**\:  str
                                
                                .. attribute:: incoming_controller_ifhandle
                                
                                	Incoming Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: incoming_controller_state
                                
                                	State of Incoming Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: incoming_sub_controller
                                
                                	Incoming Sub Controller
                                	**type**\:  str
                                
                                .. attribute:: incoming_sub_controller_ifhandle
                                
                                	Incoming Sub Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: incoming_sub_controller_state
                                
                                	State of Incoming Sub Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: is_connected
                                
                                	True if subcontrollers are connected
                                	**type**\:  bool
                                
                                .. attribute:: labels
                                
                                	Labels
                                	**type**\:   :py:class:`Labels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels>`
                                
                                .. attribute:: outgoing_controller
                                
                                	Outgoing Controller
                                	**type**\:  str
                                
                                .. attribute:: outgoing_controller_ifhandle
                                
                                	Outgoing Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: outgoing_controller_state
                                
                                	State of Outgoing Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: outgoing_sub_controller
                                
                                	Outgoing Sub Controller
                                	**type**\:  str
                                
                                .. attribute:: outgoing_sub_controller_ifhandle
                                
                                	Outgoing Sub Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: outgoing_sub_controller_state
                                
                                	State of Outgoing Sub Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: uptime
                                
                                	XC Uptime
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn, self).__init__()

                                    self.yang_name = "otn"
                                    self.yang_parent_name = "otn-s2l"

                                    self.cross_connect_id = YLeaf(YType.uint32, "cross-connect-id")

                                    self.gpid = YLeaf(YType.uint16, "gpid")

                                    self.incoming_controller = YLeaf(YType.str, "incoming-controller")

                                    self.incoming_controller_ifhandle = YLeaf(YType.str, "incoming-controller-ifhandle")

                                    self.incoming_controller_state = YLeaf(YType.enumeration, "incoming-controller-state")

                                    self.incoming_sub_controller = YLeaf(YType.str, "incoming-sub-controller")

                                    self.incoming_sub_controller_ifhandle = YLeaf(YType.str, "incoming-sub-controller-ifhandle")

                                    self.incoming_sub_controller_state = YLeaf(YType.enumeration, "incoming-sub-controller-state")

                                    self.is_connected = YLeaf(YType.boolean, "is-connected")

                                    self.outgoing_controller = YLeaf(YType.str, "outgoing-controller")

                                    self.outgoing_controller_ifhandle = YLeaf(YType.str, "outgoing-controller-ifhandle")

                                    self.outgoing_controller_state = YLeaf(YType.enumeration, "outgoing-controller-state")

                                    self.outgoing_sub_controller = YLeaf(YType.str, "outgoing-sub-controller")

                                    self.outgoing_sub_controller_ifhandle = YLeaf(YType.str, "outgoing-sub-controller-ifhandle")

                                    self.outgoing_sub_controller_state = YLeaf(YType.enumeration, "outgoing-sub-controller-state")

                                    self.uptime = YLeaf(YType.uint32, "uptime")

                                    self.bandwidth = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth()
                                    self.bandwidth.parent = self
                                    self._children_name_map["bandwidth"] = "bandwidth"
                                    self._children_yang_names.add("bandwidth")

                                    self.labels = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels()
                                    self.labels.parent = self
                                    self._children_name_map["labels"] = "labels"
                                    self._children_yang_names.add("labels")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("cross_connect_id",
                                                    "gpid",
                                                    "incoming_controller",
                                                    "incoming_controller_ifhandle",
                                                    "incoming_controller_state",
                                                    "incoming_sub_controller",
                                                    "incoming_sub_controller_ifhandle",
                                                    "incoming_sub_controller_state",
                                                    "is_connected",
                                                    "outgoing_controller",
                                                    "outgoing_controller_ifhandle",
                                                    "outgoing_controller_state",
                                                    "outgoing_sub_controller",
                                                    "outgoing_sub_controller_ifhandle",
                                                    "outgoing_sub_controller_state",
                                                    "uptime") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn, self).__setattr__(name, value)


                                class Bandwidth(Entity):
                                    """
                                    OTN Bandwidth for s2l
                                    
                                    .. attribute:: odu_flex_cbr
                                    
                                    	Odu flex CBR info
                                    	**type**\:   :py:class:`OduFlexCbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr>`
                                    
                                    .. attribute:: odu_flex_gfp_f_non_res
                                    
                                    	Odu flex GFP\-F non\-resizable info
                                    	**type**\:   :py:class:`OduFlexGfpFNonRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes>`
                                    
                                    .. attribute:: odu_flex_gfp_f_res
                                    
                                    	Odu flex GFP\-F resizable info
                                    	**type**\:   :py:class:`OduFlexGfpFRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes>`
                                    
                                    .. attribute:: odu_level
                                    
                                    	ODULevel
                                    	**type**\:   :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth, self).__init__()

                                        self.yang_name = "bandwidth"
                                        self.yang_parent_name = "otn"

                                        self.odu_level = YLeaf(YType.enumeration, "odu-level")

                                        self.odu_flex_cbr = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr()
                                        self.odu_flex_cbr.parent = self
                                        self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"
                                        self._children_yang_names.add("odu-flex-cbr")

                                        self.odu_flex_gfp_f_non_res = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes()
                                        self.odu_flex_gfp_f_non_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                        self._children_yang_names.add("odu-flex-gfp-f-non-res")

                                        self.odu_flex_gfp_f_res = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes()
                                        self.odu_flex_gfp_f_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"
                                        self._children_yang_names.add("odu-flex-gfp-f-res")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("odu_level") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth, self).__setattr__(name, value)


                                    class OduFlexCbr(Entity):
                                        """
                                        Odu flex CBR info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: tolerance
                                        
                                        	Tolerance
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__init__()

                                            self.yang_name = "odu-flex-cbr"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                            self.tolerance = YLeaf(YType.uint16, "tolerance")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate",
                                                            "tolerance") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.bit_rate.is_set or
                                                self.tolerance.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set or
                                                self.tolerance.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-cbr" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                            if (self.tolerance.is_set or self.tolerance.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tolerance.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate" or name == "tolerance"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tolerance"):
                                                self.tolerance = value
                                                self.tolerance.value_namespace = name_space
                                                self.tolerance.value_namespace_prefix = name_space_prefix


                                    class OduFlexGfpFRes(Entity):
                                        """
                                        Odu flex GFP\-F resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-res"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.bit_rate.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-gfp-f-res" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix


                                    class OduFlexGfpFNonRes(Entity):
                                        """
                                        Odu flex GFP\-F non\-resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-non-res"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.bit_rate.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-gfp-f-non-res" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.odu_level.is_set or
                                            (self.odu_flex_cbr is not None and self.odu_flex_cbr.has_data()) or
                                            (self.odu_flex_gfp_f_non_res is not None and self.odu_flex_gfp_f_non_res.has_data()) or
                                            (self.odu_flex_gfp_f_res is not None and self.odu_flex_gfp_f_res.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.odu_level.yfilter != YFilter.not_set or
                                            (self.odu_flex_cbr is not None and self.odu_flex_cbr.has_operation()) or
                                            (self.odu_flex_gfp_f_non_res is not None and self.odu_flex_gfp_f_non_res.has_operation()) or
                                            (self.odu_flex_gfp_f_res is not None and self.odu_flex_gfp_f_res.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "bandwidth" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.odu_level.is_set or self.odu_level.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.odu_level.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "odu-flex-cbr"):
                                            if (self.odu_flex_cbr is None):
                                                self.odu_flex_cbr = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr()
                                                self.odu_flex_cbr.parent = self
                                                self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"
                                            return self.odu_flex_cbr

                                        if (child_yang_name == "odu-flex-gfp-f-non-res"):
                                            if (self.odu_flex_gfp_f_non_res is None):
                                                self.odu_flex_gfp_f_non_res = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes()
                                                self.odu_flex_gfp_f_non_res.parent = self
                                                self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                            return self.odu_flex_gfp_f_non_res

                                        if (child_yang_name == "odu-flex-gfp-f-res"):
                                            if (self.odu_flex_gfp_f_res is None):
                                                self.odu_flex_gfp_f_res = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes()
                                                self.odu_flex_gfp_f_res.parent = self
                                                self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"
                                            return self.odu_flex_gfp_f_res

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "odu-flex-cbr" or name == "odu-flex-gfp-f-non-res" or name == "odu-flex-gfp-f-res" or name == "odu-level"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "odu-level"):
                                            self.odu_level = value
                                            self.odu_level.value_namespace = name_space
                                            self.odu_level.value_namespace_prefix = name_space_prefix


                                class Labels(Entity):
                                    """
                                    Labels
                                    
                                    .. attribute:: path_egress_label
                                    
                                    	Path message (upstream) egress label
                                    	**type**\:   :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel>`
                                    
                                    .. attribute:: path_ingress_label
                                    
                                    	Path message (upstream) ingress label
                                    	**type**\:   :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel>`
                                    
                                    .. attribute:: resv_egress_label
                                    
                                    	Resv message (downstream) egress label
                                    	**type**\:   :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel>`
                                    
                                    .. attribute:: resv_ingress_label
                                    
                                    	Resv message (downstream) ingress label
                                    	**type**\:   :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels, self).__init__()

                                        self.yang_name = "labels"
                                        self.yang_parent_name = "otn"

                                        self.path_egress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"
                                        self._children_yang_names.add("path-egress-label")

                                        self.path_ingress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                        self._children_yang_names.add("path-ingress-label")

                                        self.resv_egress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                        self._children_yang_names.add("resv-egress-label")

                                        self.resv_ingress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                        self._children_yang_names.add("resv-ingress-label")


                                    class PathIngressLabel(Entity):
                                        """
                                        Path message (upstream) ingress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__init__()

                                            self.yang_name = "path-ingress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-ingress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-ingress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "path-ingress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class PathEgressLabel(Entity):
                                        """
                                        Path message (upstream) egress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__init__()

                                            self.yang_name = "path-egress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-egress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-egress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "path-egress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class ResvIngressLabel(Entity):
                                        """
                                        Resv message (downstream) ingress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__init__()

                                            self.yang_name = "resv-ingress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-ingress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-ingress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "resv-ingress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class ResvEgressLabel(Entity):
                                        """
                                        Resv message (downstream) egress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__init__()

                                            self.yang_name = "resv-egress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-egress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-egress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "resv-egress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            (self.path_egress_label is not None and self.path_egress_label.has_data()) or
                                            (self.path_ingress_label is not None and self.path_ingress_label.has_data()) or
                                            (self.resv_egress_label is not None and self.resv_egress_label.has_data()) or
                                            (self.resv_ingress_label is not None and self.resv_ingress_label.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.path_egress_label is not None and self.path_egress_label.has_operation()) or
                                            (self.path_ingress_label is not None and self.path_ingress_label.has_operation()) or
                                            (self.resv_egress_label is not None and self.resv_egress_label.has_operation()) or
                                            (self.resv_ingress_label is not None and self.resv_ingress_label.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "labels" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "path-egress-label"):
                                            if (self.path_egress_label is None):
                                                self.path_egress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel()
                                                self.path_egress_label.parent = self
                                                self._children_name_map["path_egress_label"] = "path-egress-label"
                                            return self.path_egress_label

                                        if (child_yang_name == "path-ingress-label"):
                                            if (self.path_ingress_label is None):
                                                self.path_ingress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel()
                                                self.path_ingress_label.parent = self
                                                self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                            return self.path_ingress_label

                                        if (child_yang_name == "resv-egress-label"):
                                            if (self.resv_egress_label is None):
                                                self.resv_egress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel()
                                                self.resv_egress_label.parent = self
                                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                            return self.resv_egress_label

                                        if (child_yang_name == "resv-ingress-label"):
                                            if (self.resv_ingress_label is None):
                                                self.resv_ingress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel()
                                                self.resv_ingress_label.parent = self
                                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                            return self.resv_ingress_label

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "path-egress-label" or name == "path-ingress-label" or name == "resv-egress-label" or name == "resv-ingress-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass

                                def has_data(self):
                                    return (
                                        self.cross_connect_id.is_set or
                                        self.gpid.is_set or
                                        self.incoming_controller.is_set or
                                        self.incoming_controller_ifhandle.is_set or
                                        self.incoming_controller_state.is_set or
                                        self.incoming_sub_controller.is_set or
                                        self.incoming_sub_controller_ifhandle.is_set or
                                        self.incoming_sub_controller_state.is_set or
                                        self.is_connected.is_set or
                                        self.outgoing_controller.is_set or
                                        self.outgoing_controller_ifhandle.is_set or
                                        self.outgoing_controller_state.is_set or
                                        self.outgoing_sub_controller.is_set or
                                        self.outgoing_sub_controller_ifhandle.is_set or
                                        self.outgoing_sub_controller_state.is_set or
                                        self.uptime.is_set or
                                        (self.bandwidth is not None and self.bandwidth.has_data()) or
                                        (self.labels is not None and self.labels.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.cross_connect_id.yfilter != YFilter.not_set or
                                        self.gpid.yfilter != YFilter.not_set or
                                        self.incoming_controller.yfilter != YFilter.not_set or
                                        self.incoming_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.incoming_controller_state.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller_state.yfilter != YFilter.not_set or
                                        self.is_connected.yfilter != YFilter.not_set or
                                        self.outgoing_controller.yfilter != YFilter.not_set or
                                        self.outgoing_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.outgoing_controller_state.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller_state.yfilter != YFilter.not_set or
                                        self.uptime.yfilter != YFilter.not_set or
                                        (self.bandwidth is not None and self.bandwidth.has_operation()) or
                                        (self.labels is not None and self.labels.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otn" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.cross_connect_id.is_set or self.cross_connect_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.cross_connect_id.get_name_leafdata())
                                    if (self.gpid.is_set or self.gpid.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.gpid.get_name_leafdata())
                                    if (self.incoming_controller.is_set or self.incoming_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller.get_name_leafdata())
                                    if (self.incoming_controller_ifhandle.is_set or self.incoming_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller_ifhandle.get_name_leafdata())
                                    if (self.incoming_controller_state.is_set or self.incoming_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller_state.get_name_leafdata())
                                    if (self.incoming_sub_controller.is_set or self.incoming_sub_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller.get_name_leafdata())
                                    if (self.incoming_sub_controller_ifhandle.is_set or self.incoming_sub_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller_ifhandle.get_name_leafdata())
                                    if (self.incoming_sub_controller_state.is_set or self.incoming_sub_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller_state.get_name_leafdata())
                                    if (self.is_connected.is_set or self.is_connected.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_connected.get_name_leafdata())
                                    if (self.outgoing_controller.is_set or self.outgoing_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller.get_name_leafdata())
                                    if (self.outgoing_controller_ifhandle.is_set or self.outgoing_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller_ifhandle.get_name_leafdata())
                                    if (self.outgoing_controller_state.is_set or self.outgoing_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller_state.get_name_leafdata())
                                    if (self.outgoing_sub_controller.is_set or self.outgoing_sub_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller.get_name_leafdata())
                                    if (self.outgoing_sub_controller_ifhandle.is_set or self.outgoing_sub_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller_ifhandle.get_name_leafdata())
                                    if (self.outgoing_sub_controller_state.is_set or self.outgoing_sub_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller_state.get_name_leafdata())
                                    if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.uptime.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "bandwidth"):
                                        if (self.bandwidth is None):
                                            self.bandwidth = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Bandwidth()
                                            self.bandwidth.parent = self
                                            self._children_name_map["bandwidth"] = "bandwidth"
                                        return self.bandwidth

                                    if (child_yang_name == "labels"):
                                        if (self.labels is None):
                                            self.labels = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn.Labels()
                                            self.labels.parent = self
                                            self._children_name_map["labels"] = "labels"
                                        return self.labels

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bandwidth" or name == "labels" or name == "cross-connect-id" or name == "gpid" or name == "incoming-controller" or name == "incoming-controller-ifhandle" or name == "incoming-controller-state" or name == "incoming-sub-controller" or name == "incoming-sub-controller-ifhandle" or name == "incoming-sub-controller-state" or name == "is-connected" or name == "outgoing-controller" or name == "outgoing-controller-ifhandle" or name == "outgoing-controller-state" or name == "outgoing-sub-controller" or name == "outgoing-sub-controller-ifhandle" or name == "outgoing-sub-controller-state" or name == "uptime"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "cross-connect-id"):
                                        self.cross_connect_id = value
                                        self.cross_connect_id.value_namespace = name_space
                                        self.cross_connect_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "gpid"):
                                        self.gpid = value
                                        self.gpid.value_namespace = name_space
                                        self.gpid.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller"):
                                        self.incoming_controller = value
                                        self.incoming_controller.value_namespace = name_space
                                        self.incoming_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller-ifhandle"):
                                        self.incoming_controller_ifhandle = value
                                        self.incoming_controller_ifhandle.value_namespace = name_space
                                        self.incoming_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller-state"):
                                        self.incoming_controller_state = value
                                        self.incoming_controller_state.value_namespace = name_space
                                        self.incoming_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller"):
                                        self.incoming_sub_controller = value
                                        self.incoming_sub_controller.value_namespace = name_space
                                        self.incoming_sub_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller-ifhandle"):
                                        self.incoming_sub_controller_ifhandle = value
                                        self.incoming_sub_controller_ifhandle.value_namespace = name_space
                                        self.incoming_sub_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller-state"):
                                        self.incoming_sub_controller_state = value
                                        self.incoming_sub_controller_state.value_namespace = name_space
                                        self.incoming_sub_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-connected"):
                                        self.is_connected = value
                                        self.is_connected.value_namespace = name_space
                                        self.is_connected.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller"):
                                        self.outgoing_controller = value
                                        self.outgoing_controller.value_namespace = name_space
                                        self.outgoing_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller-ifhandle"):
                                        self.outgoing_controller_ifhandle = value
                                        self.outgoing_controller_ifhandle.value_namespace = name_space
                                        self.outgoing_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller-state"):
                                        self.outgoing_controller_state = value
                                        self.outgoing_controller_state.value_namespace = name_space
                                        self.outgoing_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller"):
                                        self.outgoing_sub_controller = value
                                        self.outgoing_sub_controller.value_namespace = name_space
                                        self.outgoing_sub_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller-ifhandle"):
                                        self.outgoing_sub_controller_ifhandle = value
                                        self.outgoing_sub_controller_ifhandle.value_namespace = name_space
                                        self.outgoing_sub_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller-state"):
                                        self.outgoing_sub_controller_state = value
                                        self.outgoing_sub_controller_state.value_namespace = name_space
                                        self.outgoing_sub_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "uptime"):
                                        self.uptime = value
                                        self.uptime.value_namespace = name_space
                                        self.uptime.value_namespace_prefix = name_space_prefix


                            class Aps(Entity):
                                """
                                APS Info for OTN S2L
                                
                                .. attribute:: protection_info
                                
                                	Protection Info
                                	**type**\:   :py:class:`ProtectionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Aps.ProtectionInfo>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Aps, self).__init__()

                                    self.yang_name = "aps"
                                    self.yang_parent_name = "otn-s2l"

                                    self.protection_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Aps.ProtectionInfo()
                                    self.protection_info.parent = self
                                    self._children_name_map["protection_info"] = "protection-info"
                                    self._children_yang_names.add("protection-info")


                                class ProtectionInfo(Entity):
                                    """
                                    Protection Info
                                    
                                    .. attribute:: ho_timeout
                                    
                                    	Hold\-Off timeout
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: is_hopresent
                                    
                                    	Is Hold\-Off timeout present
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_snc_mode_present
                                    
                                    	Is SNC mode present
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_wtr_present
                                    
                                    	Is Wait\-to\-Restore timeout present
                                    	**type**\:  bool
                                    
                                    .. attribute:: nbit
                                    
                                    	Notification bit 
                                    	**type**\:  bool
                                    
                                    .. attribute:: obit
                                    
                                    	Operational bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path protection profile type
                                    	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    .. attribute:: pbit
                                    
                                    	Protecting bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: protect_type
                                    
                                    	LSP Protect Type
                                    	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    .. attribute:: sbit
                                    
                                    	Secondary bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: snc_mode
                                    
                                    	SNC mode
                                    	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    .. attribute:: tcm_id
                                    
                                    	TCM ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: wtr_timeout
                                    
                                    	Wait\-to\-Restore timeout
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__init__()

                                        self.yang_name = "protection-info"
                                        self.yang_parent_name = "aps"

                                        self.ho_timeout = YLeaf(YType.uint32, "ho-timeout")

                                        self.is_hopresent = YLeaf(YType.boolean, "is-hopresent")

                                        self.is_snc_mode_present = YLeaf(YType.boolean, "is-snc-mode-present")

                                        self.is_wtr_present = YLeaf(YType.boolean, "is-wtr-present")

                                        self.nbit = YLeaf(YType.boolean, "nbit")

                                        self.obit = YLeaf(YType.boolean, "obit")

                                        self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                        self.pbit = YLeaf(YType.boolean, "pbit")

                                        self.protect_type = YLeaf(YType.enumeration, "protect-type")

                                        self.sbit = YLeaf(YType.boolean, "sbit")

                                        self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                        self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                        self.wtr_timeout = YLeaf(YType.uint32, "wtr-timeout")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("ho_timeout",
                                                        "is_hopresent",
                                                        "is_snc_mode_present",
                                                        "is_wtr_present",
                                                        "nbit",
                                                        "obit",
                                                        "path_prot_profile_type",
                                                        "pbit",
                                                        "protect_type",
                                                        "sbit",
                                                        "snc_mode",
                                                        "tcm_id",
                                                        "wtr_timeout") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.ho_timeout.is_set or
                                            self.is_hopresent.is_set or
                                            self.is_snc_mode_present.is_set or
                                            self.is_wtr_present.is_set or
                                            self.nbit.is_set or
                                            self.obit.is_set or
                                            self.path_prot_profile_type.is_set or
                                            self.pbit.is_set or
                                            self.protect_type.is_set or
                                            self.sbit.is_set or
                                            self.snc_mode.is_set or
                                            self.tcm_id.is_set or
                                            self.wtr_timeout.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.ho_timeout.yfilter != YFilter.not_set or
                                            self.is_hopresent.yfilter != YFilter.not_set or
                                            self.is_snc_mode_present.yfilter != YFilter.not_set or
                                            self.is_wtr_present.yfilter != YFilter.not_set or
                                            self.nbit.yfilter != YFilter.not_set or
                                            self.obit.yfilter != YFilter.not_set or
                                            self.path_prot_profile_type.yfilter != YFilter.not_set or
                                            self.pbit.yfilter != YFilter.not_set or
                                            self.protect_type.yfilter != YFilter.not_set or
                                            self.sbit.yfilter != YFilter.not_set or
                                            self.snc_mode.yfilter != YFilter.not_set or
                                            self.tcm_id.yfilter != YFilter.not_set or
                                            self.wtr_timeout.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "protection-info" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.ho_timeout.is_set or self.ho_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ho_timeout.get_name_leafdata())
                                        if (self.is_hopresent.is_set or self.is_hopresent.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_hopresent.get_name_leafdata())
                                        if (self.is_snc_mode_present.is_set or self.is_snc_mode_present.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_snc_mode_present.get_name_leafdata())
                                        if (self.is_wtr_present.is_set or self.is_wtr_present.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_wtr_present.get_name_leafdata())
                                        if (self.nbit.is_set or self.nbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.nbit.get_name_leafdata())
                                        if (self.obit.is_set or self.obit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.obit.get_name_leafdata())
                                        if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                        if (self.pbit.is_set or self.pbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pbit.get_name_leafdata())
                                        if (self.protect_type.is_set or self.protect_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.protect_type.get_name_leafdata())
                                        if (self.sbit.is_set or self.sbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.sbit.get_name_leafdata())
                                        if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                        if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                        if (self.wtr_timeout.is_set or self.wtr_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.wtr_timeout.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "ho-timeout" or name == "is-hopresent" or name == "is-snc-mode-present" or name == "is-wtr-present" or name == "nbit" or name == "obit" or name == "path-prot-profile-type" or name == "pbit" or name == "protect-type" or name == "sbit" or name == "snc-mode" or name == "tcm-id" or name == "wtr-timeout"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "ho-timeout"):
                                            self.ho_timeout = value
                                            self.ho_timeout.value_namespace = name_space
                                            self.ho_timeout.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-hopresent"):
                                            self.is_hopresent = value
                                            self.is_hopresent.value_namespace = name_space
                                            self.is_hopresent.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-snc-mode-present"):
                                            self.is_snc_mode_present = value
                                            self.is_snc_mode_present.value_namespace = name_space
                                            self.is_snc_mode_present.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-wtr-present"):
                                            self.is_wtr_present = value
                                            self.is_wtr_present.value_namespace = name_space
                                            self.is_wtr_present.value_namespace_prefix = name_space_prefix
                                        if(value_path == "nbit"):
                                            self.nbit = value
                                            self.nbit.value_namespace = name_space
                                            self.nbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "obit"):
                                            self.obit = value
                                            self.obit.value_namespace = name_space
                                            self.obit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-prot-profile-type"):
                                            self.path_prot_profile_type = value
                                            self.path_prot_profile_type.value_namespace = name_space
                                            self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pbit"):
                                            self.pbit = value
                                            self.pbit.value_namespace = name_space
                                            self.pbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "protect-type"):
                                            self.protect_type = value
                                            self.protect_type.value_namespace = name_space
                                            self.protect_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "sbit"):
                                            self.sbit = value
                                            self.sbit.value_namespace = name_space
                                            self.sbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "snc-mode"):
                                            self.snc_mode = value
                                            self.snc_mode.value_namespace = name_space
                                            self.snc_mode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcm-id"):
                                            self.tcm_id = value
                                            self.tcm_id.value_namespace = name_space
                                            self.tcm_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "wtr-timeout"):
                                            self.wtr_timeout = value
                                            self.wtr_timeout.value_namespace = name_space
                                            self.wtr_timeout.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (self.protection_info is not None and self.protection_info.has_data())

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.protection_info is not None and self.protection_info.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "aps" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "protection-info"):
                                        if (self.protection_info is None):
                                            self.protection_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Aps.ProtectionInfo()
                                            self.protection_info.parent = self
                                            self._children_name_map["protection_info"] = "protection-info"
                                        return self.protection_info

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "protection-info"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    (self.aps is not None and self.aps.has_data()) or
                                    (self.otn is not None and self.otn.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.aps is not None and self.aps.has_operation()) or
                                    (self.otn is not None and self.otn.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "otn-s2l" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "aps"):
                                    if (self.aps is None):
                                        self.aps = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Aps()
                                        self.aps.parent = self
                                        self._children_name_map["aps"] = "aps"
                                    return self.aps

                                if (child_yang_name == "otn"):
                                    if (self.otn is None):
                                        self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L.Otn()
                                        self.otn.parent = self
                                        self._children_name_map["otn"] = "otn"
                                    return self.otn

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "aps" or name == "otn"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class HeadEndBfdInfo(Entity):
                            """
                            The Head\-end BFD info
                            
                            .. attribute:: bfd_reverse_path_label
                            
                            	BFD reverse path labels
                            	**type**\: list of    :py:class:`BfdReversePathLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel>`
                            
                            .. attribute:: bfd_reverse_path_stale
                            
                            	The BFD reverse path is stale compared to configuration
                            	**type**\:  bool
                            
                            .. attribute:: creation_time
                            
                            	Time in seconds since the BFD session created
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: deletion_history
                            
                            	BFD Session Deletion History
                            	**type**\:   :py:class:`DeletionHistory <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.HeadEndBfdInfo.DeletionHistory>`
                            
                            .. attribute:: is_redundant
                            
                            	sBFD session is redundant
                            	**type**\:  bool
                            
                            .. attribute:: lspbfd_type
                            
                            	LSP BFD type
                            	**type**\:   :py:class:`TeVifBfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfd>`
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:   :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.HeadEndBfdInfo.SessionInfo>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.HeadEndBfdInfo, self).__init__()

                                self.yang_name = "head-end-bfd-info"
                                self.yang_parent_name = "s2l"

                                self.bfd_reverse_path_stale = YLeaf(YType.boolean, "bfd-reverse-path-stale")

                                self.creation_time = YLeaf(YType.uint32, "creation-time")

                                self.is_redundant = YLeaf(YType.boolean, "is-redundant")

                                self.lspbfd_type = YLeaf(YType.enumeration, "lspbfd-type")

                                self.deletion_history = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.HeadEndBfdInfo.DeletionHistory()
                                self.deletion_history.parent = self
                                self._children_name_map["deletion_history"] = "deletion-history"
                                self._children_yang_names.add("deletion-history")

                                self.session_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.HeadEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._children_yang_names.add("session-info")

                                self.bfd_reverse_path_label = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("bfd_reverse_path_stale",
                                                "creation_time",
                                                "is_redundant",
                                                "lspbfd_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.HeadEndBfdInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.HeadEndBfdInfo, self).__setattr__(name, value)


                            class SessionInfo(Entity):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:   :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.state = YLeaf(YType.enumeration, "state")

                                    self.state_change_time = YLeaf(YType.uint32, "state-change-time")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("state",
                                                    "state_change_time") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.state.is_set or
                                        self.state_change_time.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.state.yfilter != YFilter.not_set or
                                        self.state_change_time.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "session-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state.get_name_leafdata())
                                    if (self.state_change_time.is_set or self.state_change_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state_change_time.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "state" or name == "state-change-time"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "state"):
                                        self.state = value
                                        self.state.value_namespace = name_space
                                        self.state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "state-change-time"):
                                        self.state_change_time = value
                                        self.state_change_time.value_namespace = name_space
                                        self.state_change_time.value_namespace_prefix = name_space_prefix


                            class DeletionHistory(Entity):
                                """
                                BFD Session Deletion History
                                
                                .. attribute:: deletion_diagnostic_code
                                
                                	Diagnostic Code for the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: deletion_reason
                                
                                	Reason for the BFD session get deleted
                                	**type**\:  str
                                
                                .. attribute:: deletion_time
                                
                                	Time stamp of the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: lsp_id
                                
                                	LSP ID of the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__init__()

                                    self.yang_name = "deletion-history"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.deletion_diagnostic_code = YLeaf(YType.uint32, "deletion-diagnostic-code")

                                    self.deletion_reason = YLeaf(YType.str, "deletion-reason")

                                    self.deletion_time = YLeaf(YType.uint32, "deletion-time")

                                    self.lsp_id = YLeaf(YType.uint16, "lsp-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("deletion_diagnostic_code",
                                                    "deletion_reason",
                                                    "deletion_time",
                                                    "lsp_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.deletion_diagnostic_code.is_set or
                                        self.deletion_reason.is_set or
                                        self.deletion_time.is_set or
                                        self.lsp_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.deletion_diagnostic_code.yfilter != YFilter.not_set or
                                        self.deletion_reason.yfilter != YFilter.not_set or
                                        self.deletion_time.yfilter != YFilter.not_set or
                                        self.lsp_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "deletion-history" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.deletion_diagnostic_code.is_set or self.deletion_diagnostic_code.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_diagnostic_code.get_name_leafdata())
                                    if (self.deletion_reason.is_set or self.deletion_reason.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_reason.get_name_leafdata())
                                    if (self.deletion_time.is_set or self.deletion_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_time.get_name_leafdata())
                                    if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "deletion-diagnostic-code" or name == "deletion-reason" or name == "deletion-time" or name == "lsp-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "deletion-diagnostic-code"):
                                        self.deletion_diagnostic_code = value
                                        self.deletion_diagnostic_code.value_namespace = name_space
                                        self.deletion_diagnostic_code.value_namespace_prefix = name_space_prefix
                                    if(value_path == "deletion-reason"):
                                        self.deletion_reason = value
                                        self.deletion_reason.value_namespace = name_space
                                        self.deletion_reason.value_namespace_prefix = name_space_prefix
                                    if(value_path == "deletion-time"):
                                        self.deletion_time = value
                                        self.deletion_time.value_namespace = name_space
                                        self.deletion_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-id"):
                                        self.lsp_id = value
                                        self.lsp_id.value_namespace = name_space
                                        self.lsp_id.value_namespace_prefix = name_space_prefix


                            class BfdReversePathLabel(Entity):
                                """
                                BFD reverse path labels
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__init__()

                                    self.yang_name = "bfd-reverse-path-label"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "bfd-reverse-path-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.bfd_reverse_path_label:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.bfd_reverse_path_stale.is_set or
                                    self.creation_time.is_set or
                                    self.is_redundant.is_set or
                                    self.lspbfd_type.is_set or
                                    (self.deletion_history is not None and self.deletion_history.has_data()) or
                                    (self.session_info is not None and self.session_info.has_data()))

                            def has_operation(self):
                                for c in self.bfd_reverse_path_label:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.bfd_reverse_path_stale.yfilter != YFilter.not_set or
                                    self.creation_time.yfilter != YFilter.not_set or
                                    self.is_redundant.yfilter != YFilter.not_set or
                                    self.lspbfd_type.yfilter != YFilter.not_set or
                                    (self.deletion_history is not None and self.deletion_history.has_operation()) or
                                    (self.session_info is not None and self.session_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "head-end-bfd-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.bfd_reverse_path_stale.is_set or self.bfd_reverse_path_stale.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_reverse_path_stale.get_name_leafdata())
                                if (self.creation_time.is_set or self.creation_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.creation_time.get_name_leafdata())
                                if (self.is_redundant.is_set or self.is_redundant.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_redundant.get_name_leafdata())
                                if (self.lspbfd_type.is_set or self.lspbfd_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lspbfd_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "bfd-reverse-path-label"):
                                    for c in self.bfd_reverse_path_label:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.bfd_reverse_path_label.append(c)
                                    return c

                                if (child_yang_name == "deletion-history"):
                                    if (self.deletion_history is None):
                                        self.deletion_history = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.HeadEndBfdInfo.DeletionHistory()
                                        self.deletion_history.parent = self
                                        self._children_name_map["deletion_history"] = "deletion-history"
                                    return self.deletion_history

                                if (child_yang_name == "session-info"):
                                    if (self.session_info is None):
                                        self.session_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.HeadEndBfdInfo.SessionInfo()
                                        self.session_info.parent = self
                                        self._children_name_map["session_info"] = "session-info"
                                    return self.session_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "bfd-reverse-path-label" or name == "deletion-history" or name == "session-info" or name == "bfd-reverse-path-stale" or name == "creation-time" or name == "is-redundant" or name == "lspbfd-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "bfd-reverse-path-stale"):
                                    self.bfd_reverse_path_stale = value
                                    self.bfd_reverse_path_stale.value_namespace = name_space
                                    self.bfd_reverse_path_stale.value_namespace_prefix = name_space_prefix
                                if(value_path == "creation-time"):
                                    self.creation_time = value
                                    self.creation_time.value_namespace = name_space
                                    self.creation_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-redundant"):
                                    self.is_redundant = value
                                    self.is_redundant.value_namespace = name_space
                                    self.is_redundant.value_namespace_prefix = name_space_prefix
                                if(value_path == "lspbfd-type"):
                                    self.lspbfd_type = value
                                    self.lspbfd_type.value_namespace = name_space
                                    self.lspbfd_type.value_namespace_prefix = name_space_prefix


                        class TailEndBfdInfo(Entity):
                            """
                            The Tail\-end BFD info
                            
                            .. attribute:: failure_diagnostic_code
                            
                            	BFD session failure diagnostic code
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: failure_reason
                            
                            	BFD session failure reason
                            	**type**\:  str
                            
                            .. attribute:: local_discriminator
                            
                            	BFD Local Discriminator
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: min_interval
                            
                            	Hello interval in mini second
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: min_interval_default
                            
                            	Is default hello interval
                            	**type**\:  bool
                            
                            .. attribute:: multiplier
                            
                            	Multiplier
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: multiplier_default
                            
                            	Is default multiplier
                            	**type**\:  bool
                            
                            .. attribute:: remote_discriminator
                            
                            	BFD Remote Discrminator
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:   :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.TailEndBfdInfo.SessionInfo>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.TailEndBfdInfo, self).__init__()

                                self.yang_name = "tail-end-bfd-info"
                                self.yang_parent_name = "s2l"

                                self.failure_diagnostic_code = YLeaf(YType.uint32, "failure-diagnostic-code")

                                self.failure_reason = YLeaf(YType.str, "failure-reason")

                                self.local_discriminator = YLeaf(YType.uint32, "local-discriminator")

                                self.min_interval = YLeaf(YType.uint32, "min-interval")

                                self.min_interval_default = YLeaf(YType.boolean, "min-interval-default")

                                self.multiplier = YLeaf(YType.uint8, "multiplier")

                                self.multiplier_default = YLeaf(YType.boolean, "multiplier-default")

                                self.remote_discriminator = YLeaf(YType.uint32, "remote-discriminator")

                                self.session_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.TailEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._children_yang_names.add("session-info")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("failure_diagnostic_code",
                                                "failure_reason",
                                                "local_discriminator",
                                                "min_interval",
                                                "min_interval_default",
                                                "multiplier",
                                                "multiplier_default",
                                                "remote_discriminator") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.TailEndBfdInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.TailEndBfdInfo, self).__setattr__(name, value)


                            class SessionInfo(Entity):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:   :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.TailEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "tail-end-bfd-info"

                                    self.state = YLeaf(YType.enumeration, "state")

                                    self.state_change_time = YLeaf(YType.uint32, "state-change-time")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("state",
                                                    "state_change_time") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.TailEndBfdInfo.SessionInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.TailEndBfdInfo.SessionInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.state.is_set or
                                        self.state_change_time.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.state.yfilter != YFilter.not_set or
                                        self.state_change_time.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "session-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state.get_name_leafdata())
                                    if (self.state_change_time.is_set or self.state_change_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state_change_time.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "state" or name == "state-change-time"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "state"):
                                        self.state = value
                                        self.state.value_namespace = name_space
                                        self.state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "state-change-time"):
                                        self.state_change_time = value
                                        self.state_change_time.value_namespace = name_space
                                        self.state_change_time.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.failure_diagnostic_code.is_set or
                                    self.failure_reason.is_set or
                                    self.local_discriminator.is_set or
                                    self.min_interval.is_set or
                                    self.min_interval_default.is_set or
                                    self.multiplier.is_set or
                                    self.multiplier_default.is_set or
                                    self.remote_discriminator.is_set or
                                    (self.session_info is not None and self.session_info.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.failure_diagnostic_code.yfilter != YFilter.not_set or
                                    self.failure_reason.yfilter != YFilter.not_set or
                                    self.local_discriminator.yfilter != YFilter.not_set or
                                    self.min_interval.yfilter != YFilter.not_set or
                                    self.min_interval_default.yfilter != YFilter.not_set or
                                    self.multiplier.yfilter != YFilter.not_set or
                                    self.multiplier_default.yfilter != YFilter.not_set or
                                    self.remote_discriminator.yfilter != YFilter.not_set or
                                    (self.session_info is not None and self.session_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "tail-end-bfd-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.failure_diagnostic_code.is_set or self.failure_diagnostic_code.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.failure_diagnostic_code.get_name_leafdata())
                                if (self.failure_reason.is_set or self.failure_reason.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.failure_reason.get_name_leafdata())
                                if (self.local_discriminator.is_set or self.local_discriminator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_discriminator.get_name_leafdata())
                                if (self.min_interval.is_set or self.min_interval.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.min_interval.get_name_leafdata())
                                if (self.min_interval_default.is_set or self.min_interval_default.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.min_interval_default.get_name_leafdata())
                                if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.multiplier.get_name_leafdata())
                                if (self.multiplier_default.is_set or self.multiplier_default.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.multiplier_default.get_name_leafdata())
                                if (self.remote_discriminator.is_set or self.remote_discriminator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.remote_discriminator.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "session-info"):
                                    if (self.session_info is None):
                                        self.session_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.TailEndBfdInfo.SessionInfo()
                                        self.session_info.parent = self
                                        self._children_name_map["session_info"] = "session-info"
                                    return self.session_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "session-info" or name == "failure-diagnostic-code" or name == "failure-reason" or name == "local-discriminator" or name == "min-interval" or name == "min-interval-default" or name == "multiplier" or name == "multiplier-default" or name == "remote-discriminator"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "failure-diagnostic-code"):
                                    self.failure_diagnostic_code = value
                                    self.failure_diagnostic_code.value_namespace = name_space
                                    self.failure_diagnostic_code.value_namespace_prefix = name_space_prefix
                                if(value_path == "failure-reason"):
                                    self.failure_reason = value
                                    self.failure_reason.value_namespace = name_space
                                    self.failure_reason.value_namespace_prefix = name_space_prefix
                                if(value_path == "local-discriminator"):
                                    self.local_discriminator = value
                                    self.local_discriminator.value_namespace = name_space
                                    self.local_discriminator.value_namespace_prefix = name_space_prefix
                                if(value_path == "min-interval"):
                                    self.min_interval = value
                                    self.min_interval.value_namespace = name_space
                                    self.min_interval.value_namespace_prefix = name_space_prefix
                                if(value_path == "min-interval-default"):
                                    self.min_interval_default = value
                                    self.min_interval_default.value_namespace = name_space
                                    self.min_interval_default.value_namespace_prefix = name_space_prefix
                                if(value_path == "multiplier"):
                                    self.multiplier = value
                                    self.multiplier.value_namespace = name_space
                                    self.multiplier.value_namespace_prefix = name_space_prefix
                                if(value_path == "multiplier-default"):
                                    self.multiplier_default = value
                                    self.multiplier_default.value_namespace = name_space
                                    self.multiplier_default.value_namespace_prefix = name_space_prefix
                                if(value_path == "remote-discriminator"):
                                    self.remote_discriminator = value
                                    self.remote_discriminator.value_namespace = name_space
                                    self.remote_discriminator.value_namespace_prefix = name_space_prefix


                        class SrlgCollection(Entity):
                            """
                            SRLG\-collection data
                            
                            .. attribute:: discovered_srlg
                            
                            	Discovered SRLGs
                            	**type**\: list of    :py:class:`DiscoveredSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.SrlgCollection.DiscoveredSrlg>`
                            
                            .. attribute:: srlg_collect_type
                            
                            	SRLG\-collection mechanism
                            	**type**\:   :py:class:`TeSrlgCollectRequest <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrlgCollectRequest>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.SrlgCollection, self).__init__()

                                self.yang_name = "srlg-collection"
                                self.yang_parent_name = "s2l"

                                self.srlg_collect_type = YLeaf(YType.enumeration, "srlg-collect-type")

                                self.discovered_srlg = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("srlg_collect_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.SrlgCollection, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.SrlgCollection, self).__setattr__(name, value)


                            class DiscoveredSrlg(Entity):
                                """
                                Discovered SRLGs
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__init__()

                                    self.yang_name = "discovered-srlg"
                                    self.yang_parent_name = "srlg-collection"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "discovered-srlg" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.discovered_srlg:
                                    if (c.has_data()):
                                        return True
                                return self.srlg_collect_type.is_set

                            def has_operation(self):
                                for c in self.discovered_srlg:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.srlg_collect_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "srlg-collection" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.srlg_collect_type.is_set or self.srlg_collect_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.srlg_collect_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "discovered-srlg"):
                                    for c in self.discovered_srlg:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.SrlgCollection.DiscoveredSrlg()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.discovered_srlg.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "discovered-srlg" or name == "srlg-collect-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "srlg-collect-type"):
                                    self.srlg_collect_type = value
                                    self.srlg_collect_type.value_namespace = name_space
                                    self.srlg_collect_type.value_namespace_prefix = name_space_prefix


                        class Association(Entity):
                            """
                            Association Object
                            
                            .. attribute:: s2l_association_id
                            
                            	S2L Association ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_association_source
                            
                            	S2L Association Source
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_association_tie_role
                            
                            	S2L Association Tie Role
                            	**type**\:   :py:class:`TeAssociationTieRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAssociationTieRole>`
                            
                            .. attribute:: s2l_association_type
                            
                            	S2L Association Type                          (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_extended_id
                            
                            	S2L Extended ID Array
                            	**type**\: list of    :py:class:`S2LExtendedId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.Association.S2LExtendedId>`
                            
                            .. attribute:: s2l_global_source
                            
                            	S2L Global Source
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.Association, self).__init__()

                                self.yang_name = "association"
                                self.yang_parent_name = "s2l"

                                self.s2l_association_id = YLeaf(YType.uint16, "s2l-association-id")

                                self.s2l_association_source = YLeaf(YType.str, "s2l-association-source")

                                self.s2l_association_tie_role = YLeaf(YType.enumeration, "s2l-association-tie-role")

                                self.s2l_association_type = YLeaf(YType.uint16, "s2l-association-type")

                                self.s2l_global_source = YLeaf(YType.uint32, "s2l-global-source")

                                self.s2l_extended_id = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("s2l_association_id",
                                                "s2l_association_source",
                                                "s2l_association_tie_role",
                                                "s2l_association_type",
                                                "s2l_global_source") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.Association, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.Association, self).__setattr__(name, value)


                            class S2LExtendedId(Entity):
                                """
                                S2L Extended ID Array
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.Association.S2LExtendedId, self).__init__()

                                    self.yang_name = "s2l-extended-id"
                                    self.yang_parent_name = "association"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.Association.S2LExtendedId, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.Association.S2LExtendedId, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "s2l-extended-id" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.s2l_extended_id:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.s2l_association_id.is_set or
                                    self.s2l_association_source.is_set or
                                    self.s2l_association_tie_role.is_set or
                                    self.s2l_association_type.is_set or
                                    self.s2l_global_source.is_set)

                            def has_operation(self):
                                for c in self.s2l_extended_id:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.s2l_association_id.yfilter != YFilter.not_set or
                                    self.s2l_association_source.yfilter != YFilter.not_set or
                                    self.s2l_association_tie_role.yfilter != YFilter.not_set or
                                    self.s2l_association_type.yfilter != YFilter.not_set or
                                    self.s2l_global_source.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "association" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.s2l_association_id.is_set or self.s2l_association_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_id.get_name_leafdata())
                                if (self.s2l_association_source.is_set or self.s2l_association_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_source.get_name_leafdata())
                                if (self.s2l_association_tie_role.is_set or self.s2l_association_tie_role.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_tie_role.get_name_leafdata())
                                if (self.s2l_association_type.is_set or self.s2l_association_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_type.get_name_leafdata())
                                if (self.s2l_global_source.is_set or self.s2l_global_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_global_source.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "s2l-extended-id"):
                                    for c in self.s2l_extended_id:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.Association.S2LExtendedId()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.s2l_extended_id.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "s2l-extended-id" or name == "s2l-association-id" or name == "s2l-association-source" or name == "s2l-association-tie-role" or name == "s2l-association-type" or name == "s2l-global-source"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "s2l-association-id"):
                                    self.s2l_association_id = value
                                    self.s2l_association_id.value_namespace = name_space
                                    self.s2l_association_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-source"):
                                    self.s2l_association_source = value
                                    self.s2l_association_source.value_namespace = name_space
                                    self.s2l_association_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-tie-role"):
                                    self.s2l_association_tie_role = value
                                    self.s2l_association_tie_role.value_namespace = name_space
                                    self.s2l_association_tie_role.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-type"):
                                    self.s2l_association_type = value
                                    self.s2l_association_type.value_namespace = name_space
                                    self.s2l_association_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-global-source"):
                                    self.s2l_global_source = value
                                    self.s2l_global_source.value_namespace = name_space
                                    self.s2l_global_source.value_namespace_prefix = name_space_prefix


                        class Protection(Entity):
                            """
                            Protection Object
                            
                            .. attribute:: any
                            
                            	Any
                            	**type**\:  bool
                            
                            .. attribute:: ded1_plus1
                            
                            	Dedicated 1+1 Protection
                            	**type**\:  bool
                            
                            .. attribute:: ded1_to1
                            
                            	Dedicated 1\:1 Protection
                            	**type**\:  bool
                            
                            .. attribute:: enhanced
                            
                            	Indicates Enhanced Protection Scheme
                            	**type**\:  bool
                            
                            .. attribute:: extra_traffic
                            
                            	LSP should use Links that are protecting other (primary) traffic
                            	**type**\:  bool
                            
                            .. attribute:: link_unprotected
                            
                            	LSP should not use any Link Layer Protection
                            	**type**\:  bool
                            
                            .. attribute:: lsp_unprotected
                            
                            	LSP Flags Unprotected
                            	**type**\:  bool
                            
                            .. attribute:: one_plus_one_bi
                            
                            	1+1 Bidirectional Protection
                            	**type**\:  bool
                            
                            .. attribute:: one_plus_one_uni
                            
                            	1+1 Unidirectional Protection
                            	**type**\:  bool
                            
                            .. attribute:: one_to_n_protection_et
                            
                            	1\:N Protection with Extra\-Traffic
                            	**type**\:  bool
                            
                            .. attribute:: rerouting
                            
                            	Full Rerouting
                            	**type**\:  bool
                            
                            .. attribute:: rerouting_no_et
                            
                            	Rerouting Without Extra\-Traffic
                            	**type**\:  bool
                            
                            .. attribute:: s2l_notification
                            
                            	 S2L Protection Notification Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_operational
                            
                            	 S2L Protection Operational Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_protecting
                            
                            	 S2L Protection Protecting Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_secondary
                            
                            	 S2L Protection Secondary Bit
                            	**type**\:  bool
                            
                            .. attribute:: shared
                            
                            	Shared Link Layer Protection
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.Protection, self).__init__()

                                self.yang_name = "protection"
                                self.yang_parent_name = "s2l"

                                self.any = YLeaf(YType.boolean, "any")

                                self.ded1_plus1 = YLeaf(YType.boolean, "ded1-plus1")

                                self.ded1_to1 = YLeaf(YType.boolean, "ded1-to1")

                                self.enhanced = YLeaf(YType.boolean, "enhanced")

                                self.extra_traffic = YLeaf(YType.boolean, "extra-traffic")

                                self.link_unprotected = YLeaf(YType.boolean, "link-unprotected")

                                self.lsp_unprotected = YLeaf(YType.boolean, "lsp-unprotected")

                                self.one_plus_one_bi = YLeaf(YType.boolean, "one-plus-one-bi")

                                self.one_plus_one_uni = YLeaf(YType.boolean, "one-plus-one-uni")

                                self.one_to_n_protection_et = YLeaf(YType.boolean, "one-to-n-protection-et")

                                self.rerouting = YLeaf(YType.boolean, "rerouting")

                                self.rerouting_no_et = YLeaf(YType.boolean, "rerouting-no-et")

                                self.s2l_notification = YLeaf(YType.boolean, "s2l-notification")

                                self.s2l_operational = YLeaf(YType.boolean, "s2l-operational")

                                self.s2l_protecting = YLeaf(YType.boolean, "s2l-protecting")

                                self.s2l_secondary = YLeaf(YType.boolean, "s2l-secondary")

                                self.shared = YLeaf(YType.boolean, "shared")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("any",
                                                "ded1_plus1",
                                                "ded1_to1",
                                                "enhanced",
                                                "extra_traffic",
                                                "link_unprotected",
                                                "lsp_unprotected",
                                                "one_plus_one_bi",
                                                "one_plus_one_uni",
                                                "one_to_n_protection_et",
                                                "rerouting",
                                                "rerouting_no_et",
                                                "s2l_notification",
                                                "s2l_operational",
                                                "s2l_protecting",
                                                "s2l_secondary",
                                                "shared") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.Protection, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.Protection, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.any.is_set or
                                    self.ded1_plus1.is_set or
                                    self.ded1_to1.is_set or
                                    self.enhanced.is_set or
                                    self.extra_traffic.is_set or
                                    self.link_unprotected.is_set or
                                    self.lsp_unprotected.is_set or
                                    self.one_plus_one_bi.is_set or
                                    self.one_plus_one_uni.is_set or
                                    self.one_to_n_protection_et.is_set or
                                    self.rerouting.is_set or
                                    self.rerouting_no_et.is_set or
                                    self.s2l_notification.is_set or
                                    self.s2l_operational.is_set or
                                    self.s2l_protecting.is_set or
                                    self.s2l_secondary.is_set or
                                    self.shared.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.any.yfilter != YFilter.not_set or
                                    self.ded1_plus1.yfilter != YFilter.not_set or
                                    self.ded1_to1.yfilter != YFilter.not_set or
                                    self.enhanced.yfilter != YFilter.not_set or
                                    self.extra_traffic.yfilter != YFilter.not_set or
                                    self.link_unprotected.yfilter != YFilter.not_set or
                                    self.lsp_unprotected.yfilter != YFilter.not_set or
                                    self.one_plus_one_bi.yfilter != YFilter.not_set or
                                    self.one_plus_one_uni.yfilter != YFilter.not_set or
                                    self.one_to_n_protection_et.yfilter != YFilter.not_set or
                                    self.rerouting.yfilter != YFilter.not_set or
                                    self.rerouting_no_et.yfilter != YFilter.not_set or
                                    self.s2l_notification.yfilter != YFilter.not_set or
                                    self.s2l_operational.yfilter != YFilter.not_set or
                                    self.s2l_protecting.yfilter != YFilter.not_set or
                                    self.s2l_secondary.yfilter != YFilter.not_set or
                                    self.shared.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "protection" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.any.is_set or self.any.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.any.get_name_leafdata())
                                if (self.ded1_plus1.is_set or self.ded1_plus1.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ded1_plus1.get_name_leafdata())
                                if (self.ded1_to1.is_set or self.ded1_to1.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ded1_to1.get_name_leafdata())
                                if (self.enhanced.is_set or self.enhanced.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.enhanced.get_name_leafdata())
                                if (self.extra_traffic.is_set or self.extra_traffic.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.extra_traffic.get_name_leafdata())
                                if (self.link_unprotected.is_set or self.link_unprotected.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.link_unprotected.get_name_leafdata())
                                if (self.lsp_unprotected.is_set or self.lsp_unprotected.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_unprotected.get_name_leafdata())
                                if (self.one_plus_one_bi.is_set or self.one_plus_one_bi.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_plus_one_bi.get_name_leafdata())
                                if (self.one_plus_one_uni.is_set or self.one_plus_one_uni.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_plus_one_uni.get_name_leafdata())
                                if (self.one_to_n_protection_et.is_set or self.one_to_n_protection_et.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_to_n_protection_et.get_name_leafdata())
                                if (self.rerouting.is_set or self.rerouting.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rerouting.get_name_leafdata())
                                if (self.rerouting_no_et.is_set or self.rerouting_no_et.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rerouting_no_et.get_name_leafdata())
                                if (self.s2l_notification.is_set or self.s2l_notification.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_notification.get_name_leafdata())
                                if (self.s2l_operational.is_set or self.s2l_operational.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_operational.get_name_leafdata())
                                if (self.s2l_protecting.is_set or self.s2l_protecting.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_protecting.get_name_leafdata())
                                if (self.s2l_secondary.is_set or self.s2l_secondary.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_secondary.get_name_leafdata())
                                if (self.shared.is_set or self.shared.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.shared.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "any" or name == "ded1-plus1" or name == "ded1-to1" or name == "enhanced" or name == "extra-traffic" or name == "link-unprotected" or name == "lsp-unprotected" or name == "one-plus-one-bi" or name == "one-plus-one-uni" or name == "one-to-n-protection-et" or name == "rerouting" or name == "rerouting-no-et" or name == "s2l-notification" or name == "s2l-operational" or name == "s2l-protecting" or name == "s2l-secondary" or name == "shared"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "any"):
                                    self.any = value
                                    self.any.value_namespace = name_space
                                    self.any.value_namespace_prefix = name_space_prefix
                                if(value_path == "ded1-plus1"):
                                    self.ded1_plus1 = value
                                    self.ded1_plus1.value_namespace = name_space
                                    self.ded1_plus1.value_namespace_prefix = name_space_prefix
                                if(value_path == "ded1-to1"):
                                    self.ded1_to1 = value
                                    self.ded1_to1.value_namespace = name_space
                                    self.ded1_to1.value_namespace_prefix = name_space_prefix
                                if(value_path == "enhanced"):
                                    self.enhanced = value
                                    self.enhanced.value_namespace = name_space
                                    self.enhanced.value_namespace_prefix = name_space_prefix
                                if(value_path == "extra-traffic"):
                                    self.extra_traffic = value
                                    self.extra_traffic.value_namespace = name_space
                                    self.extra_traffic.value_namespace_prefix = name_space_prefix
                                if(value_path == "link-unprotected"):
                                    self.link_unprotected = value
                                    self.link_unprotected.value_namespace = name_space
                                    self.link_unprotected.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-unprotected"):
                                    self.lsp_unprotected = value
                                    self.lsp_unprotected.value_namespace = name_space
                                    self.lsp_unprotected.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-plus-one-bi"):
                                    self.one_plus_one_bi = value
                                    self.one_plus_one_bi.value_namespace = name_space
                                    self.one_plus_one_bi.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-plus-one-uni"):
                                    self.one_plus_one_uni = value
                                    self.one_plus_one_uni.value_namespace = name_space
                                    self.one_plus_one_uni.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-to-n-protection-et"):
                                    self.one_to_n_protection_et = value
                                    self.one_to_n_protection_et.value_namespace = name_space
                                    self.one_to_n_protection_et.value_namespace_prefix = name_space_prefix
                                if(value_path == "rerouting"):
                                    self.rerouting = value
                                    self.rerouting.value_namespace = name_space
                                    self.rerouting.value_namespace_prefix = name_space_prefix
                                if(value_path == "rerouting-no-et"):
                                    self.rerouting_no_et = value
                                    self.rerouting_no_et.value_namespace = name_space
                                    self.rerouting_no_et.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-notification"):
                                    self.s2l_notification = value
                                    self.s2l_notification.value_namespace = name_space
                                    self.s2l_notification.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-operational"):
                                    self.s2l_operational = value
                                    self.s2l_operational.value_namespace = name_space
                                    self.s2l_operational.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-protecting"):
                                    self.s2l_protecting = value
                                    self.s2l_protecting.value_namespace = name_space
                                    self.s2l_protecting.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-secondary"):
                                    self.s2l_secondary = value
                                    self.s2l_secondary.value_namespace = name_space
                                    self.s2l_secondary.value_namespace_prefix = name_space_prefix
                                if(value_path == "shared"):
                                    self.shared = value
                                    self.shared.value_namespace = name_space
                                    self.shared.value_namespace_prefix = name_space_prefix


                        class ReverseLspFec(Entity):
                            """
                            Reverse Associated Bidir LSP FEC
                            
                            .. attribute:: fec_destination_info
                            
                            	Destination or P2MP ID
                            	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ReverseLspFec.FecDestinationInfo>`
                            
                            .. attribute:: fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: fec_lsp_id
                            
                            	LSP ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: fec_source
                            
                            	Tunnel source address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ReverseLspFec, self).__init__()

                                self.yang_name = "reverse-lsp-fec"
                                self.yang_parent_name = "s2l"

                                self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                self.fec_source = YLeaf(YType.str, "fec-source")

                                self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ReverseLspFec.FecDestinationInfo()
                                self.fec_destination_info.parent = self
                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                self._children_yang_names.add("fec-destination-info")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fec_extended_tunnel_id",
                                                "fec_lsp_id",
                                                "fec_source",
                                                "fec_tunnel_id",
                                                "fec_vrf") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ReverseLspFec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ReverseLspFec, self).__setattr__(name, value)


                            class FecDestinationInfo(Entity):
                                """
                                Destination or P2MP ID
                                
                                .. attribute:: fec_ctype
                                
                                	FEC CType
                                	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                .. attribute:: fec_destination_p2mp_id
                                
                                	P2MP ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: p2p_lsp_destination
                                
                                	P2P LSP destination
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__init__()

                                    self.yang_name = "fec-destination-info"
                                    self.yang_parent_name = "reverse-lsp-fec"

                                    self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                    self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                    self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("fec_ctype",
                                                    "fec_destination_p2mp_id",
                                                    "p2p_lsp_destination") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.fec_ctype.is_set or
                                        self.fec_destination_p2mp_id.is_set or
                                        self.p2p_lsp_destination.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.fec_ctype.yfilter != YFilter.not_set or
                                        self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                        self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "fec-destination-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                    if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                    if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "fec-ctype"):
                                        self.fec_ctype = value
                                        self.fec_ctype.value_namespace = name_space
                                        self.fec_ctype.value_namespace_prefix = name_space_prefix
                                    if(value_path == "fec-destination-p2mp-id"):
                                        self.fec_destination_p2mp_id = value
                                        self.fec_destination_p2mp_id.value_namespace = name_space
                                        self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "p2p-lsp-destination"):
                                        self.p2p_lsp_destination = value
                                        self.p2p_lsp_destination.value_namespace = name_space
                                        self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.fec_extended_tunnel_id.is_set or
                                    self.fec_lsp_id.is_set or
                                    self.fec_source.is_set or
                                    self.fec_tunnel_id.is_set or
                                    self.fec_vrf.is_set or
                                    (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                    self.fec_lsp_id.yfilter != YFilter.not_set or
                                    self.fec_source.yfilter != YFilter.not_set or
                                    self.fec_tunnel_id.yfilter != YFilter.not_set or
                                    self.fec_vrf.yfilter != YFilter.not_set or
                                    (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-lsp-fec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_source.get_name_leafdata())
                                if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "fec-destination-info"):
                                    if (self.fec_destination_info is None):
                                        self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ReverseLspFec.FecDestinationInfo()
                                        self.fec_destination_info.parent = self
                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                    return self.fec_destination_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fec-extended-tunnel-id"):
                                    self.fec_extended_tunnel_id = value
                                    self.fec_extended_tunnel_id.value_namespace = name_space
                                    self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-lsp-id"):
                                    self.fec_lsp_id = value
                                    self.fec_lsp_id.value_namespace = name_space
                                    self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-source"):
                                    self.fec_source = value
                                    self.fec_source.value_namespace = name_space
                                    self.fec_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-tunnel-id"):
                                    self.fec_tunnel_id = value
                                    self.fec_tunnel_id.value_namespace = name_space
                                    self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-vrf"):
                                    self.fec_vrf = value
                                    self.fec_vrf.value_namespace = name_space
                                    self.fec_vrf.value_namespace_prefix = name_space_prefix


                        class ReverseTspec(Entity):
                            """
                            The Reverse T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ReverseTspec, self).__init__()

                                self.yang_name = "reverse-tspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ReverseTspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ReverseTspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class FlexInfo(Entity):
                            """
                            FlexLSP S2L Information
                            
                            .. attribute:: bfd_created
                            
                            	GAL BFD Session Created
                            	**type**\:  bool
                            
                            .. attribute:: bfd_egress_label
                            
                            	BFD Egress Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: bfd_int_label
                            
                            	BFD Internal Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: bfd_next_hop
                            
                            	BFD Next Hop
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: bfd_out_ifh
                            
                            	BFD Out Interface Handle
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: bfd_tun_ifh
                            
                            	BFD Tunnel Interface Handle
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: bfd_up
                            
                            	GAL BFD Session Up
                            	**type**\:  bool
                            
                            .. attribute:: entry_exists
                            
                            	FlexLSP Entry Exists
                            	**type**\:  bool
                            
                            .. attribute:: fault_ais
                            
                            	Fault AIS
                            	**type**\:  bool
                            
                            .. attribute:: fault_ldi
                            
                            	Fault LDI
                            	**type**\:  bool
                            
                            .. attribute:: fault_ldi_lockout
                            
                            	Fault LDI Lockout
                            	**type**\:  bool
                            
                            .. attribute:: fault_lkr
                            
                            	Fault LKR
                            	**type**\:  bool
                            
                            .. attribute:: fault_time
                            
                            	Fault Time
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: flex_fec
                            
                            	FEC for the FlexLSP Entry
                            	**type**\:   :py:class:`FlexFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.FlexInfo.FlexFec>`
                            
                            .. attribute:: in_label
                            
                            	In Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: oam_created
                            
                            	OAM Entry Created
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.FlexInfo, self).__init__()

                                self.yang_name = "flex-info"
                                self.yang_parent_name = "s2l"

                                self.bfd_created = YLeaf(YType.boolean, "bfd-created")

                                self.bfd_egress_label = YLeaf(YType.uint32, "bfd-egress-label")

                                self.bfd_int_label = YLeaf(YType.uint32, "bfd-int-label")

                                self.bfd_next_hop = YLeaf(YType.str, "bfd-next-hop")

                                self.bfd_out_ifh = YLeaf(YType.str, "bfd-out-ifh")

                                self.bfd_tun_ifh = YLeaf(YType.str, "bfd-tun-ifh")

                                self.bfd_up = YLeaf(YType.boolean, "bfd-up")

                                self.entry_exists = YLeaf(YType.boolean, "entry-exists")

                                self.fault_ais = YLeaf(YType.boolean, "fault-ais")

                                self.fault_ldi = YLeaf(YType.boolean, "fault-ldi")

                                self.fault_ldi_lockout = YLeaf(YType.boolean, "fault-ldi-lockout")

                                self.fault_lkr = YLeaf(YType.boolean, "fault-lkr")

                                self.fault_time = YLeaf(YType.uint32, "fault-time")

                                self.in_label = YLeaf(YType.uint32, "in-label")

                                self.oam_created = YLeaf(YType.boolean, "oam-created")

                                self.flex_fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.FlexInfo.FlexFec()
                                self.flex_fec.parent = self
                                self._children_name_map["flex_fec"] = "flex-fec"
                                self._children_yang_names.add("flex-fec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("bfd_created",
                                                "bfd_egress_label",
                                                "bfd_int_label",
                                                "bfd_next_hop",
                                                "bfd_out_ifh",
                                                "bfd_tun_ifh",
                                                "bfd_up",
                                                "entry_exists",
                                                "fault_ais",
                                                "fault_ldi",
                                                "fault_ldi_lockout",
                                                "fault_lkr",
                                                "fault_time",
                                                "in_label",
                                                "oam_created") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.FlexInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.FlexInfo, self).__setattr__(name, value)


                            class FlexFec(Entity):
                                """
                                FEC for the FlexLSP Entry
                                
                                .. attribute:: s2l_fec_ctype
                                
                                	Session identifier (ctype)
                                	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                .. attribute:: s2l_fec_dest
                                
                                	sub\-LSP destination address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_extended_tunnel_id
                                
                                	Extended tunnel ID
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_lsp_id
                                
                                	LSP ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_p2mp_id
                                
                                	P2MP ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: s2l_fec_source
                                
                                	LSP source address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_subgroup_id
                                
                                	sub\-LSP subgroup ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_subgroup_originator
                                
                                	Subgroup Originator
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_tunnel_id
                                
                                	Tunnel ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_vrf
                                
                                	VRF; currently only for GMPLS tunnels
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.FlexInfo.FlexFec, self).__init__()

                                    self.yang_name = "flex-fec"
                                    self.yang_parent_name = "flex-info"

                                    self.s2l_fec_ctype = YLeaf(YType.enumeration, "s2l-fec-ctype")

                                    self.s2l_fec_dest = YLeaf(YType.str, "s2l-fec-dest")

                                    self.s2l_fec_extended_tunnel_id = YLeaf(YType.str, "s2l-fec-extended-tunnel-id")

                                    self.s2l_fec_lsp_id = YLeaf(YType.uint16, "s2l-fec-lsp-id")

                                    self.s2l_fec_p2mp_id = YLeaf(YType.uint32, "s2l-fec-p2mp-id")

                                    self.s2l_fec_source = YLeaf(YType.str, "s2l-fec-source")

                                    self.s2l_fec_subgroup_id = YLeaf(YType.uint16, "s2l-fec-subgroup-id")

                                    self.s2l_fec_subgroup_originator = YLeaf(YType.str, "s2l-fec-subgroup-originator")

                                    self.s2l_fec_tunnel_id = YLeaf(YType.uint16, "s2l-fec-tunnel-id")

                                    self.s2l_fec_vrf = YLeaf(YType.str, "s2l-fec-vrf")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("s2l_fec_ctype",
                                                    "s2l_fec_dest",
                                                    "s2l_fec_extended_tunnel_id",
                                                    "s2l_fec_lsp_id",
                                                    "s2l_fec_p2mp_id",
                                                    "s2l_fec_source",
                                                    "s2l_fec_subgroup_id",
                                                    "s2l_fec_subgroup_originator",
                                                    "s2l_fec_tunnel_id",
                                                    "s2l_fec_vrf") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.FlexInfo.FlexFec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.FlexInfo.FlexFec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.s2l_fec_ctype.is_set or
                                        self.s2l_fec_dest.is_set or
                                        self.s2l_fec_extended_tunnel_id.is_set or
                                        self.s2l_fec_lsp_id.is_set or
                                        self.s2l_fec_p2mp_id.is_set or
                                        self.s2l_fec_source.is_set or
                                        self.s2l_fec_subgroup_id.is_set or
                                        self.s2l_fec_subgroup_originator.is_set or
                                        self.s2l_fec_tunnel_id.is_set or
                                        self.s2l_fec_vrf.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.s2l_fec_ctype.yfilter != YFilter.not_set or
                                        self.s2l_fec_dest.yfilter != YFilter.not_set or
                                        self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_lsp_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_p2mp_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_source.yfilter != YFilter.not_set or
                                        self.s2l_fec_subgroup_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set or
                                        self.s2l_fec_tunnel_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_vrf.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "flex-fec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.s2l_fec_ctype.is_set or self.s2l_fec_ctype.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_ctype.get_name_leafdata())
                                    if (self.s2l_fec_dest.is_set or self.s2l_fec_dest.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_dest.get_name_leafdata())
                                    if (self.s2l_fec_extended_tunnel_id.is_set or self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_extended_tunnel_id.get_name_leafdata())
                                    if (self.s2l_fec_lsp_id.is_set or self.s2l_fec_lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_lsp_id.get_name_leafdata())
                                    if (self.s2l_fec_p2mp_id.is_set or self.s2l_fec_p2mp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_p2mp_id.get_name_leafdata())
                                    if (self.s2l_fec_source.is_set or self.s2l_fec_source.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_source.get_name_leafdata())
                                    if (self.s2l_fec_subgroup_id.is_set or self.s2l_fec_subgroup_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_subgroup_id.get_name_leafdata())
                                    if (self.s2l_fec_subgroup_originator.is_set or self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_subgroup_originator.get_name_leafdata())
                                    if (self.s2l_fec_tunnel_id.is_set or self.s2l_fec_tunnel_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_tunnel_id.get_name_leafdata())
                                    if (self.s2l_fec_vrf.is_set or self.s2l_fec_vrf.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_vrf.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "s2l-fec-ctype" or name == "s2l-fec-dest" or name == "s2l-fec-extended-tunnel-id" or name == "s2l-fec-lsp-id" or name == "s2l-fec-p2mp-id" or name == "s2l-fec-source" or name == "s2l-fec-subgroup-id" or name == "s2l-fec-subgroup-originator" or name == "s2l-fec-tunnel-id" or name == "s2l-fec-vrf"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "s2l-fec-ctype"):
                                        self.s2l_fec_ctype = value
                                        self.s2l_fec_ctype.value_namespace = name_space
                                        self.s2l_fec_ctype.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-dest"):
                                        self.s2l_fec_dest = value
                                        self.s2l_fec_dest.value_namespace = name_space
                                        self.s2l_fec_dest.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-extended-tunnel-id"):
                                        self.s2l_fec_extended_tunnel_id = value
                                        self.s2l_fec_extended_tunnel_id.value_namespace = name_space
                                        self.s2l_fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-lsp-id"):
                                        self.s2l_fec_lsp_id = value
                                        self.s2l_fec_lsp_id.value_namespace = name_space
                                        self.s2l_fec_lsp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-p2mp-id"):
                                        self.s2l_fec_p2mp_id = value
                                        self.s2l_fec_p2mp_id.value_namespace = name_space
                                        self.s2l_fec_p2mp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-source"):
                                        self.s2l_fec_source = value
                                        self.s2l_fec_source.value_namespace = name_space
                                        self.s2l_fec_source.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-subgroup-id"):
                                        self.s2l_fec_subgroup_id = value
                                        self.s2l_fec_subgroup_id.value_namespace = name_space
                                        self.s2l_fec_subgroup_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-subgroup-originator"):
                                        self.s2l_fec_subgroup_originator = value
                                        self.s2l_fec_subgroup_originator.value_namespace = name_space
                                        self.s2l_fec_subgroup_originator.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-tunnel-id"):
                                        self.s2l_fec_tunnel_id = value
                                        self.s2l_fec_tunnel_id.value_namespace = name_space
                                        self.s2l_fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-vrf"):
                                        self.s2l_fec_vrf = value
                                        self.s2l_fec_vrf.value_namespace = name_space
                                        self.s2l_fec_vrf.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.bfd_created.is_set or
                                    self.bfd_egress_label.is_set or
                                    self.bfd_int_label.is_set or
                                    self.bfd_next_hop.is_set or
                                    self.bfd_out_ifh.is_set or
                                    self.bfd_tun_ifh.is_set or
                                    self.bfd_up.is_set or
                                    self.entry_exists.is_set or
                                    self.fault_ais.is_set or
                                    self.fault_ldi.is_set or
                                    self.fault_ldi_lockout.is_set or
                                    self.fault_lkr.is_set or
                                    self.fault_time.is_set or
                                    self.in_label.is_set or
                                    self.oam_created.is_set or
                                    (self.flex_fec is not None and self.flex_fec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.bfd_created.yfilter != YFilter.not_set or
                                    self.bfd_egress_label.yfilter != YFilter.not_set or
                                    self.bfd_int_label.yfilter != YFilter.not_set or
                                    self.bfd_next_hop.yfilter != YFilter.not_set or
                                    self.bfd_out_ifh.yfilter != YFilter.not_set or
                                    self.bfd_tun_ifh.yfilter != YFilter.not_set or
                                    self.bfd_up.yfilter != YFilter.not_set or
                                    self.entry_exists.yfilter != YFilter.not_set or
                                    self.fault_ais.yfilter != YFilter.not_set or
                                    self.fault_ldi.yfilter != YFilter.not_set or
                                    self.fault_ldi_lockout.yfilter != YFilter.not_set or
                                    self.fault_lkr.yfilter != YFilter.not_set or
                                    self.fault_time.yfilter != YFilter.not_set or
                                    self.in_label.yfilter != YFilter.not_set or
                                    self.oam_created.yfilter != YFilter.not_set or
                                    (self.flex_fec is not None and self.flex_fec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "flex-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.bfd_created.is_set or self.bfd_created.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_created.get_name_leafdata())
                                if (self.bfd_egress_label.is_set or self.bfd_egress_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_egress_label.get_name_leafdata())
                                if (self.bfd_int_label.is_set or self.bfd_int_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_int_label.get_name_leafdata())
                                if (self.bfd_next_hop.is_set or self.bfd_next_hop.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_next_hop.get_name_leafdata())
                                if (self.bfd_out_ifh.is_set or self.bfd_out_ifh.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_out_ifh.get_name_leafdata())
                                if (self.bfd_tun_ifh.is_set or self.bfd_tun_ifh.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_tun_ifh.get_name_leafdata())
                                if (self.bfd_up.is_set or self.bfd_up.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_up.get_name_leafdata())
                                if (self.entry_exists.is_set or self.entry_exists.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry_exists.get_name_leafdata())
                                if (self.fault_ais.is_set or self.fault_ais.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ais.get_name_leafdata())
                                if (self.fault_ldi.is_set or self.fault_ldi.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ldi.get_name_leafdata())
                                if (self.fault_ldi_lockout.is_set or self.fault_ldi_lockout.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ldi_lockout.get_name_leafdata())
                                if (self.fault_lkr.is_set or self.fault_lkr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_lkr.get_name_leafdata())
                                if (self.fault_time.is_set or self.fault_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_time.get_name_leafdata())
                                if (self.in_label.is_set or self.in_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.in_label.get_name_leafdata())
                                if (self.oam_created.is_set or self.oam_created.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.oam_created.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "flex-fec"):
                                    if (self.flex_fec is None):
                                        self.flex_fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.FlexInfo.FlexFec()
                                        self.flex_fec.parent = self
                                        self._children_name_map["flex_fec"] = "flex-fec"
                                    return self.flex_fec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "flex-fec" or name == "bfd-created" or name == "bfd-egress-label" or name == "bfd-int-label" or name == "bfd-next-hop" or name == "bfd-out-ifh" or name == "bfd-tun-ifh" or name == "bfd-up" or name == "entry-exists" or name == "fault-ais" or name == "fault-ldi" or name == "fault-ldi-lockout" or name == "fault-lkr" or name == "fault-time" or name == "in-label" or name == "oam-created"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "bfd-created"):
                                    self.bfd_created = value
                                    self.bfd_created.value_namespace = name_space
                                    self.bfd_created.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-egress-label"):
                                    self.bfd_egress_label = value
                                    self.bfd_egress_label.value_namespace = name_space
                                    self.bfd_egress_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-int-label"):
                                    self.bfd_int_label = value
                                    self.bfd_int_label.value_namespace = name_space
                                    self.bfd_int_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-next-hop"):
                                    self.bfd_next_hop = value
                                    self.bfd_next_hop.value_namespace = name_space
                                    self.bfd_next_hop.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-out-ifh"):
                                    self.bfd_out_ifh = value
                                    self.bfd_out_ifh.value_namespace = name_space
                                    self.bfd_out_ifh.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-tun-ifh"):
                                    self.bfd_tun_ifh = value
                                    self.bfd_tun_ifh.value_namespace = name_space
                                    self.bfd_tun_ifh.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-up"):
                                    self.bfd_up = value
                                    self.bfd_up.value_namespace = name_space
                                    self.bfd_up.value_namespace_prefix = name_space_prefix
                                if(value_path == "entry-exists"):
                                    self.entry_exists = value
                                    self.entry_exists.value_namespace = name_space
                                    self.entry_exists.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ais"):
                                    self.fault_ais = value
                                    self.fault_ais.value_namespace = name_space
                                    self.fault_ais.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ldi"):
                                    self.fault_ldi = value
                                    self.fault_ldi.value_namespace = name_space
                                    self.fault_ldi.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ldi-lockout"):
                                    self.fault_ldi_lockout = value
                                    self.fault_ldi_lockout.value_namespace = name_space
                                    self.fault_ldi_lockout.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-lkr"):
                                    self.fault_lkr = value
                                    self.fault_lkr.value_namespace = name_space
                                    self.fault_lkr.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-time"):
                                    self.fault_time = value
                                    self.fault_time.value_namespace = name_space
                                    self.fault_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "in-label"):
                                    self.in_label = value
                                    self.in_label.value_namespace = name_space
                                    self.in_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "oam-created"):
                                    self.oam_created = value
                                    self.oam_created.value_namespace = name_space
                                    self.oam_created.value_namespace_prefix = name_space_prefix


                        class LspWrapInfo(Entity):
                            """
                            Lsp Wrap  Related information
                            
                            .. attribute:: lsp_wrap_protection_enable
                            
                            	LSP Wrap protection enabled
                            	**type**\:  bool
                            
                            .. attribute:: lsp_wrap_protection_label
                            
                            	LSP Wrap Merge Point Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: lsp_wrap_protection_state
                            
                            	LSP wrap protection state
                            	**type**\:   :py:class:`MplsTeLspWrapState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspWrapState>`
                            
                            .. attribute:: reverse_egress_interface
                            
                            	Reverse Egress Interface
                            	**type**\:  str
                            
                            .. attribute:: reverse_lsp_label
                            
                            	Reverse LSP label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.LspWrapInfo, self).__init__()

                                self.yang_name = "lsp-wrap-info"
                                self.yang_parent_name = "s2l"

                                self.lsp_wrap_protection_enable = YLeaf(YType.boolean, "lsp-wrap-protection-enable")

                                self.lsp_wrap_protection_label = YLeaf(YType.uint32, "lsp-wrap-protection-label")

                                self.lsp_wrap_protection_state = YLeaf(YType.enumeration, "lsp-wrap-protection-state")

                                self.reverse_egress_interface = YLeaf(YType.str, "reverse-egress-interface")

                                self.reverse_lsp_label = YLeaf(YType.uint32, "reverse-lsp-label")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("lsp_wrap_protection_enable",
                                                "lsp_wrap_protection_label",
                                                "lsp_wrap_protection_state",
                                                "reverse_egress_interface",
                                                "reverse_lsp_label") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.LspWrapInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.LspWrapInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.lsp_wrap_protection_enable.is_set or
                                    self.lsp_wrap_protection_label.is_set or
                                    self.lsp_wrap_protection_state.is_set or
                                    self.reverse_egress_interface.is_set or
                                    self.reverse_lsp_label.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_enable.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_label.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_state.yfilter != YFilter.not_set or
                                    self.reverse_egress_interface.yfilter != YFilter.not_set or
                                    self.reverse_lsp_label.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "lsp-wrap-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.lsp_wrap_protection_enable.is_set or self.lsp_wrap_protection_enable.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_enable.get_name_leafdata())
                                if (self.lsp_wrap_protection_label.is_set or self.lsp_wrap_protection_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_label.get_name_leafdata())
                                if (self.lsp_wrap_protection_state.is_set or self.lsp_wrap_protection_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_state.get_name_leafdata())
                                if (self.reverse_egress_interface.is_set or self.reverse_egress_interface.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reverse_egress_interface.get_name_leafdata())
                                if (self.reverse_lsp_label.is_set or self.reverse_lsp_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reverse_lsp_label.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "lsp-wrap-protection-enable" or name == "lsp-wrap-protection-label" or name == "lsp-wrap-protection-state" or name == "reverse-egress-interface" or name == "reverse-lsp-label"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "lsp-wrap-protection-enable"):
                                    self.lsp_wrap_protection_enable = value
                                    self.lsp_wrap_protection_enable.value_namespace = name_space
                                    self.lsp_wrap_protection_enable.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-wrap-protection-label"):
                                    self.lsp_wrap_protection_label = value
                                    self.lsp_wrap_protection_label.value_namespace = name_space
                                    self.lsp_wrap_protection_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-wrap-protection-state"):
                                    self.lsp_wrap_protection_state = value
                                    self.lsp_wrap_protection_state.value_namespace = name_space
                                    self.lsp_wrap_protection_state.value_namespace_prefix = name_space_prefix
                                if(value_path == "reverse-egress-interface"):
                                    self.reverse_egress_interface = value
                                    self.reverse_egress_interface.value_namespace = name_space
                                    self.reverse_egress_interface.value_namespace_prefix = name_space_prefix
                                if(value_path == "reverse-lsp-label"):
                                    self.reverse_lsp_label = value
                                    self.reverse_lsp_label.value_namespace = name_space
                                    self.reverse_lsp_label.value_namespace_prefix = name_space_prefix


                        class DiversityInfo(Entity):
                            """
                            S2L Diversity Information
                            
                            .. attribute:: diversity_type
                            
                            	S2L path diversity type
                            	**type**\:   :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.DiversityInfo, self).__init__()

                                self.yang_name = "diversity-info"
                                self.yang_parent_name = "s2l"

                                self.diversity_type = YLeaf(YType.enumeration, "diversity-type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("diversity_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.DiversityInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.DiversityInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return self.diversity_type.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.diversity_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "diversity-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.diversity_type.is_set or self.diversity_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.diversity_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "diversity-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "diversity-type"):
                                    self.diversity_type = value
                                    self.diversity_type.value_namespace = name_space
                                    self.diversity_type.value_namespace_prefix = name_space_prefix


                        class S2LReverseLspSubObj(Entity):
                            """
                            Reverse LSP Sub Objects
                            
                            .. attribute:: entry
                            
                            	
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.S2LReverseLspSubObj, self).__init__()

                                self.yang_name = "s2l-reverse-lsp-sub-obj"
                                self.yang_parent_name = "s2l"

                                self.entry = YLeaf(YType.uint8, "entry")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("entry") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.S2LReverseLspSubObj, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.S2LReverseLspSubObj, self).__setattr__(name, value)

                            def has_data(self):
                                return self.entry.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.entry.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-reverse-lsp-sub-obj" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "entry"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "entry"):
                                    self.entry = value
                                    self.entry.value_namespace = name_space
                                    self.entry.value_namespace_prefix = name_space_prefix


                        class SharedRiskLinkGroup(Entity):
                            """
                            The S2L's excluded srlg groups
                            
                            .. attribute:: shared_risk_group
                            
                            	SRLG number
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: srlg_name
                            
                            	SRLG name
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.SharedRiskLinkGroup, self).__init__()

                                self.yang_name = "shared-risk-link-group"
                                self.yang_parent_name = "s2l"

                                self.shared_risk_group = YLeaf(YType.uint32, "shared-risk-group")

                                self.srlg_name = YLeaf(YType.str, "srlg-name")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("shared_risk_group",
                                                "srlg_name") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.SharedRiskLinkGroup, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.SharedRiskLinkGroup, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.shared_risk_group.is_set or
                                    self.srlg_name.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.shared_risk_group.yfilter != YFilter.not_set or
                                    self.srlg_name.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "shared-risk-link-group" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.shared_risk_group.is_set or self.shared_risk_group.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.shared_risk_group.get_name_leafdata())
                                if (self.srlg_name.is_set or self.srlg_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.srlg_name.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "shared-risk-group" or name == "srlg-name"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "shared-risk-group"):
                                    self.shared_risk_group = value
                                    self.shared_risk_group.value_namespace = name_space
                                    self.shared_risk_group.value_namespace_prefix = name_space_prefix
                                if(value_path == "srlg-name"):
                                    self.srlg_name = value
                                    self.srlg_name.value_namespace = name_space
                                    self.srlg_name.value_namespace_prefix = name_space_prefix


                        class OutEro(Entity):
                            """
                            Outgoing ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutEro.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutEro.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutEro, self).__init__()

                                self.yang_name = "out-ero"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutEro.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutEro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutEro, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutEro.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "out-ero"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutEro.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutEro.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "out-ero"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutEro.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutEro.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "out-ero" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutEro.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutEro.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class InEro(Entity):
                            """
                            Incoming ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InEro.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InEro.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InEro, self).__init__()

                                self.yang_name = "in-ero"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InEro.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InEro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InEro, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InEro.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "in-ero"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InEro.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InEro.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "in-ero"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InEro.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InEro.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "in-ero" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InEro.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InEro.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class PathRro(Entity):
                            """
                            Path RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:   :py:class:`Ipv4RroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.Ipv4RroSubObject>`
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:   :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.LabelRroSubObject>`
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:   :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:   :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.SrlgRroSubObject>`
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:   :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.UnnumberedRroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro, self).__init__()

                                self.yang_name = "path-rro"
                                self.yang_parent_name = "s2l"

                                self.rro_type = YLeaf(YType.enumeration, "rro-type")

                                self.ipv4rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.Ipv4RroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                self._children_yang_names.add("ipv4rro-sub-object")

                                self.label_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                self._children_yang_names.add("label-rro-sub-object")

                                self.srlg_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._children_yang_names.add("srlg-rro-sub-object")

                                self.unnumbered_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                self._children_yang_names.add("unnumbered-rro-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("rro_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro, self).__setattr__(name, value)


                            class Ipv4RroSubObject(Entity):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.Ipv4RroSubObject.Flags>`
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.Ipv4RroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.rro_address = YLeaf(YType.str, "rro-address")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.Ipv4RroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("rro_address") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.Ipv4RroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.Ipv4RroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.rro_address.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.rro_address.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.rro_address.is_set or self.rro_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rro_address.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.Ipv4RroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "rro-address"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "rro-address"):
                                        self.rro_address = value
                                        self.rro_address.value_namespace = name_space
                                        self.rro_address.value_namespace_prefix = name_space_prefix


                            class LabelRroSubObject(Entity):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.LabelRroSubObject.Flags>`
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\:  bool
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of    :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.is_label_variable_length = YLeaf(YType.boolean, "is-label-variable-length")

                                    self.label = YLeaf(YType.uint32, "label")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                    self.variable_length_label = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_label_variable_length",
                                                    "label") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.LabelRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.LabelRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.is_global_label = YLeaf(YType.boolean, "is-global-label")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_global_label") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.is_global_label.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_global_label.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_global_label.is_set or self.is_global_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_global_label.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-global-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-global-label"):
                                            self.is_global_label = value
                                            self.is_global_label.value_namespace = name_space
                                            self.is_global_label.value_namespace_prefix = name_space_prefix


                                class VariableLengthLabel(Entity):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "variable-length-label" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.variable_length_label:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.is_label_variable_length.is_set or
                                        self.label.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    for c in self.variable_length_label:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_label_variable_length.yfilter != YFilter.not_set or
                                        self.label.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "label-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_label_variable_length.is_set or self.is_label_variable_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_label_variable_length.get_name_leafdata())
                                    if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.LabelRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    if (child_yang_name == "variable-length-label"):
                                        for c in self.variable_length_label:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.variable_length_label.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "variable-length-label" or name == "is-label-variable-length" or name == "label"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-label-variable-length"):
                                        self.is_label_variable_length = value
                                        self.is_label_variable_length.value_namespace = name_space
                                        self.is_label_variable_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label"):
                                        self.label = value
                                        self.label.value_namespace = name_space
                                        self.label.value_namespace_prefix = name_space_prefix


                            class UnnumberedRroSubObject(Entity):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.UnnumberedRroSubObject.Flags>`
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.interface_address = YLeaf(YType.str, "interface-address")

                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_address",
                                                    "interface_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.UnnumberedRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.UnnumberedRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.interface_address.is_set or
                                        self.interface_id.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_address.yfilter != YFilter.not_set or
                                        self.interface_id.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_address.is_set or self.interface_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_address.get_name_leafdata())
                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.UnnumberedRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "interface-address" or name == "interface-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-address"):
                                        self.interface_address = value
                                        self.interface_address.value_namespace = name_space
                                        self.interface_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-id"):
                                        self.interface_id = value
                                        self.interface_id.value_namespace = name_space
                                        self.interface_id.value_namespace_prefix = name_space_prefix


                            class SrlgRroSubObject(Entity):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of    :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.SrlgRroSubObject.SrlGs>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.srl_gs = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.SrlgRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.SrlgRroSubObject, self).__setattr__(name, value)


                                class SrlGs(Entity):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srl-gs" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.srl_gs:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.srl_gs:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "srlg-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "srl-gs"):
                                        for c in self.srl_gs:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.SrlgRroSubObject.SrlGs()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.srl_gs.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "srl-gs"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    self.rro_type.is_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_data()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_data()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_data()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.rro_type.yfilter != YFilter.not_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_operation()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_operation()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_operation()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-rro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.rro_type.is_set or self.rro_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rro_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4rro-sub-object"):
                                    if (self.ipv4rro_sub_object is None):
                                        self.ipv4rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.Ipv4RroSubObject()
                                        self.ipv4rro_sub_object.parent = self
                                        self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                    return self.ipv4rro_sub_object

                                if (child_yang_name == "label-rro-sub-object"):
                                    if (self.label_rro_sub_object is None):
                                        self.label_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.LabelRroSubObject()
                                        self.label_rro_sub_object.parent = self
                                        self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                    return self.label_rro_sub_object

                                if (child_yang_name == "srlg-rro-sub-object"):
                                    if (self.srlg_rro_sub_object is None):
                                        self.srlg_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.SrlgRroSubObject()
                                        self.srlg_rro_sub_object.parent = self
                                        self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                    return self.srlg_rro_sub_object

                                if (child_yang_name == "unnumbered-rro-sub-object"):
                                    if (self.unnumbered_rro_sub_object is None):
                                        self.unnumbered_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro.UnnumberedRroSubObject()
                                        self.unnumbered_rro_sub_object.parent = self
                                        self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                    return self.unnumbered_rro_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4rro-sub-object" or name == "label-rro-sub-object" or name == "srlg-rro-sub-object" or name == "unnumbered-rro-sub-object" or name == "rro-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "rro-type"):
                                    self.rro_type = value
                                    self.rro_type.value_namespace = name_space
                                    self.rro_type.value_namespace_prefix = name_space_prefix


                        class ResvRro(Entity):
                            """
                            Resv RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:   :py:class:`Ipv4RroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.Ipv4RroSubObject>`
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:   :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.LabelRroSubObject>`
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:   :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:   :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.SrlgRroSubObject>`
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:   :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.UnnumberedRroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro, self).__init__()

                                self.yang_name = "resv-rro"
                                self.yang_parent_name = "s2l"

                                self.rro_type = YLeaf(YType.enumeration, "rro-type")

                                self.ipv4rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.Ipv4RroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                self._children_yang_names.add("ipv4rro-sub-object")

                                self.label_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                self._children_yang_names.add("label-rro-sub-object")

                                self.srlg_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._children_yang_names.add("srlg-rro-sub-object")

                                self.unnumbered_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                self._children_yang_names.add("unnumbered-rro-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("rro_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro, self).__setattr__(name, value)


                            class Ipv4RroSubObject(Entity):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.Ipv4RroSubObject.Flags>`
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.Ipv4RroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.rro_address = YLeaf(YType.str, "rro-address")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.Ipv4RroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("rro_address") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.Ipv4RroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.Ipv4RroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.rro_address.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.rro_address.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.rro_address.is_set or self.rro_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rro_address.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.Ipv4RroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "rro-address"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "rro-address"):
                                        self.rro_address = value
                                        self.rro_address.value_namespace = name_space
                                        self.rro_address.value_namespace_prefix = name_space_prefix


                            class LabelRroSubObject(Entity):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.LabelRroSubObject.Flags>`
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\:  bool
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of    :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.is_label_variable_length = YLeaf(YType.boolean, "is-label-variable-length")

                                    self.label = YLeaf(YType.uint32, "label")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                    self.variable_length_label = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_label_variable_length",
                                                    "label") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.LabelRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.LabelRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.is_global_label = YLeaf(YType.boolean, "is-global-label")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_global_label") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.is_global_label.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_global_label.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_global_label.is_set or self.is_global_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_global_label.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-global-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-global-label"):
                                            self.is_global_label = value
                                            self.is_global_label.value_namespace = name_space
                                            self.is_global_label.value_namespace_prefix = name_space_prefix


                                class VariableLengthLabel(Entity):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "variable-length-label" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.variable_length_label:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.is_label_variable_length.is_set or
                                        self.label.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    for c in self.variable_length_label:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_label_variable_length.yfilter != YFilter.not_set or
                                        self.label.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "label-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_label_variable_length.is_set or self.is_label_variable_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_label_variable_length.get_name_leafdata())
                                    if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.LabelRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    if (child_yang_name == "variable-length-label"):
                                        for c in self.variable_length_label:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.variable_length_label.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "variable-length-label" or name == "is-label-variable-length" or name == "label"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-label-variable-length"):
                                        self.is_label_variable_length = value
                                        self.is_label_variable_length.value_namespace = name_space
                                        self.is_label_variable_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label"):
                                        self.label = value
                                        self.label.value_namespace = name_space
                                        self.label.value_namespace_prefix = name_space_prefix


                            class UnnumberedRroSubObject(Entity):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags>`
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.interface_address = YLeaf(YType.str, "interface-address")

                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_address",
                                                    "interface_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.interface_address.is_set or
                                        self.interface_id.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_address.yfilter != YFilter.not_set or
                                        self.interface_id.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_address.is_set or self.interface_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_address.get_name_leafdata())
                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "interface-address" or name == "interface-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-address"):
                                        self.interface_address = value
                                        self.interface_address.value_namespace = name_space
                                        self.interface_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-id"):
                                        self.interface_id = value
                                        self.interface_id.value_namespace = name_space
                                        self.interface_id.value_namespace_prefix = name_space_prefix


                            class SrlgRroSubObject(Entity):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of    :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.srl_gs = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.SrlgRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.SrlgRroSubObject, self).__setattr__(name, value)


                                class SrlGs(Entity):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srl-gs" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.srl_gs:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.srl_gs:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "srlg-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "srl-gs"):
                                        for c in self.srl_gs:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.srl_gs.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "srl-gs"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    self.rro_type.is_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_data()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_data()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_data()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.rro_type.yfilter != YFilter.not_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_operation()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_operation()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_operation()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "resv-rro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.rro_type.is_set or self.rro_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rro_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4rro-sub-object"):
                                    if (self.ipv4rro_sub_object is None):
                                        self.ipv4rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.Ipv4RroSubObject()
                                        self.ipv4rro_sub_object.parent = self
                                        self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                    return self.ipv4rro_sub_object

                                if (child_yang_name == "label-rro-sub-object"):
                                    if (self.label_rro_sub_object is None):
                                        self.label_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.LabelRroSubObject()
                                        self.label_rro_sub_object.parent = self
                                        self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                    return self.label_rro_sub_object

                                if (child_yang_name == "srlg-rro-sub-object"):
                                    if (self.srlg_rro_sub_object is None):
                                        self.srlg_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.SrlgRroSubObject()
                                        self.srlg_rro_sub_object.parent = self
                                        self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                    return self.srlg_rro_sub_object

                                if (child_yang_name == "unnumbered-rro-sub-object"):
                                    if (self.unnumbered_rro_sub_object is None):
                                        self.unnumbered_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro.UnnumberedRroSubObject()
                                        self.unnumbered_rro_sub_object.parent = self
                                        self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                    return self.unnumbered_rro_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4rro-sub-object" or name == "label-rro-sub-object" or name == "srlg-rro-sub-object" or name == "unnumbered-rro-sub-object" or name == "rro-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "rro-type"):
                                    self.rro_type = value
                                    self.rro_type.value_namespace = name_space
                                    self.rro_type.value_namespace_prefix = name_space_prefix


                        class PathAffinityArray(Entity):
                            """
                            Tunnel's Path hops with affinity
                            
                            .. attribute:: hop_address
                            
                            	Hop address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: hop_affinity
                            
                            	Deprecated
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: hop_extended_affinity
                            
                            	Hop affinity
                            	**type**\: list of    :py:class:`HopExtendedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathAffinityArray.HopExtendedAffinity>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathAffinityArray, self).__init__()

                                self.yang_name = "path-affinity-array"
                                self.yang_parent_name = "s2l"

                                self.hop_address = YLeaf(YType.str, "hop-address")

                                self.hop_affinity = YLeaf(YType.uint32, "hop-affinity")

                                self.hop_extended_affinity = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("hop_address",
                                                "hop_affinity") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathAffinityArray, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathAffinityArray, self).__setattr__(name, value)


                            class HopExtendedAffinity(Entity):
                                """
                                Hop affinity
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__init__()

                                    self.yang_name = "hop-extended-affinity"
                                    self.yang_parent_name = "path-affinity-array"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "hop-extended-affinity" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.hop_extended_affinity:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.hop_address.is_set or
                                    self.hop_affinity.is_set)

                            def has_operation(self):
                                for c in self.hop_extended_affinity:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.hop_address.yfilter != YFilter.not_set or
                                    self.hop_affinity.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-affinity-array" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.hop_address.is_set or self.hop_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hop_address.get_name_leafdata())
                                if (self.hop_affinity.is_set or self.hop_affinity.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hop_affinity.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "hop-extended-affinity"):
                                    for c in self.hop_extended_affinity:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathAffinityArray.HopExtendedAffinity()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.hop_extended_affinity.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "hop-extended-affinity" or name == "hop-address" or name == "hop-affinity"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "hop-address"):
                                    self.hop_address = value
                                    self.hop_address.value_namespace = name_space
                                    self.hop_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "hop-affinity"):
                                    self.hop_affinity = value
                                    self.hop_affinity.value_namespace = name_space
                                    self.hop_affinity.value_namespace_prefix = name_space_prefix


                        class ReverseEroIn(Entity):
                            """
                             Reverse Incoming ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ReverseEroIn.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ReverseEroIn.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ReverseEroIn, self).__init__()

                                self.yang_name = "reverse-ero-in"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ReverseEroIn.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ReverseEroIn.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ReverseEroIn, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ReverseEroIn, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-ero-in" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ReverseEroIn.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ReverseEroIn.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class S2LSegmentRoutingPath(Entity):
                            """
                            Segment\-Routing S2L path info
                            
                            .. attribute:: has_entropy_label
                            
                            	Hop has EL specified
                            	**type**\:  bool
                            
                            .. attribute:: has_ip_addresses
                            
                            	Node has IP addresses specified
                            	**type**\:  bool
                            
                            .. attribute:: has_mpls_label
                            
                            	Hop has MPLS label specified
                            	**type**\:  bool
                            
                            .. attribute:: local_addr
                            
                            	Local IP address of adjacency or Node ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: mpls_label_value
                            
                            	The MPLS label value
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: remote_addr
                            
                            	Remote IP address of adjacency
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: sid_type
                            
                            	Type of the SID
                            	**type**\:   :py:class:`TeSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrSid>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.S2LSegmentRoutingPath, self).__init__()

                                self.yang_name = "s2l-segment-routing-path"
                                self.yang_parent_name = "s2l"

                                self.has_entropy_label = YLeaf(YType.boolean, "has-entropy-label")

                                self.has_ip_addresses = YLeaf(YType.boolean, "has-ip-addresses")

                                self.has_mpls_label = YLeaf(YType.boolean, "has-mpls-label")

                                self.local_addr = YLeaf(YType.str, "local-addr")

                                self.mpls_label_value = YLeaf(YType.uint32, "mpls-label-value")

                                self.remote_addr = YLeaf(YType.str, "remote-addr")

                                self.sid_type = YLeaf(YType.enumeration, "sid-type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("has_entropy_label",
                                                "has_ip_addresses",
                                                "has_mpls_label",
                                                "local_addr",
                                                "mpls_label_value",
                                                "remote_addr",
                                                "sid_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.S2LSegmentRoutingPath, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.S2LSegmentRoutingPath, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.has_entropy_label.is_set or
                                    self.has_ip_addresses.is_set or
                                    self.has_mpls_label.is_set or
                                    self.local_addr.is_set or
                                    self.mpls_label_value.is_set or
                                    self.remote_addr.is_set or
                                    self.sid_type.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.has_entropy_label.yfilter != YFilter.not_set or
                                    self.has_ip_addresses.yfilter != YFilter.not_set or
                                    self.has_mpls_label.yfilter != YFilter.not_set or
                                    self.local_addr.yfilter != YFilter.not_set or
                                    self.mpls_label_value.yfilter != YFilter.not_set or
                                    self.remote_addr.yfilter != YFilter.not_set or
                                    self.sid_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-segment-routing-path" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.has_entropy_label.is_set or self.has_entropy_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_entropy_label.get_name_leafdata())
                                if (self.has_ip_addresses.is_set or self.has_ip_addresses.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_ip_addresses.get_name_leafdata())
                                if (self.has_mpls_label.is_set or self.has_mpls_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_mpls_label.get_name_leafdata())
                                if (self.local_addr.is_set or self.local_addr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_addr.get_name_leafdata())
                                if (self.mpls_label_value.is_set or self.mpls_label_value.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mpls_label_value.get_name_leafdata())
                                if (self.remote_addr.is_set or self.remote_addr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.remote_addr.get_name_leafdata())
                                if (self.sid_type.is_set or self.sid_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.sid_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "has-entropy-label" or name == "has-ip-addresses" or name == "has-mpls-label" or name == "local-addr" or name == "mpls-label-value" or name == "remote-addr" or name == "sid-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "has-entropy-label"):
                                    self.has_entropy_label = value
                                    self.has_entropy_label.value_namespace = name_space
                                    self.has_entropy_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-ip-addresses"):
                                    self.has_ip_addresses = value
                                    self.has_ip_addresses.value_namespace = name_space
                                    self.has_ip_addresses.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-mpls-label"):
                                    self.has_mpls_label = value
                                    self.has_mpls_label.value_namespace = name_space
                                    self.has_mpls_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "local-addr"):
                                    self.local_addr = value
                                    self.local_addr.value_namespace = name_space
                                    self.local_addr.value_namespace_prefix = name_space_prefix
                                if(value_path == "mpls-label-value"):
                                    self.mpls_label_value = value
                                    self.mpls_label_value.value_namespace = name_space
                                    self.mpls_label_value.value_namespace_prefix = name_space_prefix
                                if(value_path == "remote-addr"):
                                    self.remote_addr = value
                                    self.remote_addr.value_namespace = name_space
                                    self.remote_addr.value_namespace_prefix = name_space_prefix
                                if(value_path == "sid-type"):
                                    self.sid_type = value
                                    self.sid_type.value_namespace = name_space
                                    self.sid_type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.in_ero:
                                if (c.has_data()):
                                    return True
                            for c in self.out_ero:
                                if (c.has_data()):
                                    return True
                            for c in self.path_affinity_array:
                                if (c.has_data()):
                                    return True
                            for c in self.path_rro:
                                if (c.has_data()):
                                    return True
                            for c in self.resv_rro:
                                if (c.has_data()):
                                    return True
                            for c in self.reverse_ero_in:
                                if (c.has_data()):
                                    return True
                            for c in self.s2l_reverse_lsp_sub_obj:
                                if (c.has_data()):
                                    return True
                            for c in self.s2l_segment_routing_path:
                                if (c.has_data()):
                                    return True
                            for c in self.shared_risk_link_group:
                                if (c.has_data()):
                                    return True
                            return (
                                self.abr_auto_discovered.is_set or
                                self.backup_tunnel_interface.is_set or
                                self.downstream_router_id.is_set or
                                self.egress_interface.is_set or
                                self.egress_interface_brief.is_set or
                                self.egress_interface_state.is_set or
                                self.expanded_ero_affinity_bits.is_set or
                                self.expanded_ero_affinity_mask.is_set or
                                self.expanded_ero_area_id.is_set or
                                self.expanded_ero_metric.is_set or
                                self.expanded_ero_metric_type.is_set or
                                self.frr_out_tunnel_interface.is_set or
                                self.incoming_address.is_set or
                                self.ingress_interface.is_set or
                                self.ingress_interface_brief.is_set or
                                self.ingress_interface_state.is_set or
                                self.is_bandwidth_protect.is_set or
                                self.is_expanded_ero.is_set or
                                self.is_frr_enabled.is_set or
                                self.is_node_protected.is_set or
                                self.is_optical.is_set or
                                self.local_router_id.is_set or
                                self.next_hop_address.is_set or
                                self.node_hop_count.is_set or
                                self.outbound_frr_state.is_set or
                                self.path_reeval_query_mid.is_set or
                                self.path_rro_enabled.is_set or
                                self.path_using_strict_spf.is_set or
                                self.pcalc_area.is_set or
                                self.previous_hop_address.is_set or
                                self.reverse_lsp_connected.is_set or
                                self.reverse_lsp_name.is_set or
                                self.reverse_lsp_present.is_set or
                                self.reverse_weight.is_set or
                                self.role.is_set or
                                self.s2l_local_label.is_set or
                                self.s2l_out_label.is_set or
                                self.s2l_reverse_ero_obj_present.is_set or
                                self.s2l_reverse_tspec_obj_present.is_set or
                                self.signalling_status.is_set or
                                self.time_since_last_preferred_path_exists_send_mid.is_set or
                                self.time_since_last_preferred_tree_exists_send_mid.is_set or
                                self.time_since_last_query_received_mid.is_set or
                                self.upstream_router_id.is_set or
                                self.uptime.is_set or
                                self.weight.is_set or
                                (self.active_path_option is not None and self.active_path_option.has_data()) or
                                (self.association is not None and self.association.has_data()) or
                                (self.diversity_info is not None and self.diversity_info.has_data()) or
                                (self.flex_info is not None and self.flex_info.has_data()) or
                                (self.fspec is not None and self.fspec.has_data()) or
                                (self.generic_fspec is not None and self.generic_fspec.has_data()) or
                                (self.generic_tspec is not None and self.generic_tspec.has_data()) or
                                (self.gmpls_labels is not None and self.gmpls_labels.has_data()) or
                                (self.head_end_bfd_info is not None and self.head_end_bfd_info.has_data()) or
                                (self.in_xro is not None and self.in_xro.has_data()) or
                                (self.incoming_address_generic is not None and self.incoming_address_generic.has_data()) or
                                (self.lsp_wrap_info is not None and self.lsp_wrap_info.has_data()) or
                                (self.next_hop_address_generic is not None and self.next_hop_address_generic.has_data()) or
                                (self.otn_s2l is not None and self.otn_s2l.has_data()) or
                                (self.out_xro is not None and self.out_xro.has_data()) or
                                (self.previous_hop_address_generic is not None and self.previous_hop_address_generic.has_data()) or
                                (self.protection is not None and self.protection.has_data()) or
                                (self.reverse_lsp_fec is not None and self.reverse_lsp_fec.has_data()) or
                                (self.reverse_tspec is not None and self.reverse_tspec.has_data()) or
                                (self.s2l_convergence is not None and self.s2l_convergence.has_data()) or
                                (self.s2l_fec is not None and self.s2l_fec.has_data()) or
                                (self.soft_preemption is not None and self.soft_preemption.has_data()) or
                                (self.srlg_collection is not None and self.srlg_collection.has_data()) or
                                (self.tail_end_bfd_info is not None and self.tail_end_bfd_info.has_data()) or
                                (self.tspec is not None and self.tspec.has_data()))

                        def has_operation(self):
                            for c in self.in_ero:
                                if (c.has_operation()):
                                    return True
                            for c in self.out_ero:
                                if (c.has_operation()):
                                    return True
                            for c in self.path_affinity_array:
                                if (c.has_operation()):
                                    return True
                            for c in self.path_rro:
                                if (c.has_operation()):
                                    return True
                            for c in self.resv_rro:
                                if (c.has_operation()):
                                    return True
                            for c in self.reverse_ero_in:
                                if (c.has_operation()):
                                    return True
                            for c in self.s2l_reverse_lsp_sub_obj:
                                if (c.has_operation()):
                                    return True
                            for c in self.s2l_segment_routing_path:
                                if (c.has_operation()):
                                    return True
                            for c in self.shared_risk_link_group:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.abr_auto_discovered.yfilter != YFilter.not_set or
                                self.backup_tunnel_interface.yfilter != YFilter.not_set or
                                self.downstream_router_id.yfilter != YFilter.not_set or
                                self.egress_interface.yfilter != YFilter.not_set or
                                self.egress_interface_brief.yfilter != YFilter.not_set or
                                self.egress_interface_state.yfilter != YFilter.not_set or
                                self.expanded_ero_affinity_bits.yfilter != YFilter.not_set or
                                self.expanded_ero_affinity_mask.yfilter != YFilter.not_set or
                                self.expanded_ero_area_id.yfilter != YFilter.not_set or
                                self.expanded_ero_metric.yfilter != YFilter.not_set or
                                self.expanded_ero_metric_type.yfilter != YFilter.not_set or
                                self.frr_out_tunnel_interface.yfilter != YFilter.not_set or
                                self.incoming_address.yfilter != YFilter.not_set or
                                self.ingress_interface.yfilter != YFilter.not_set or
                                self.ingress_interface_brief.yfilter != YFilter.not_set or
                                self.ingress_interface_state.yfilter != YFilter.not_set or
                                self.is_bandwidth_protect.yfilter != YFilter.not_set or
                                self.is_expanded_ero.yfilter != YFilter.not_set or
                                self.is_frr_enabled.yfilter != YFilter.not_set or
                                self.is_node_protected.yfilter != YFilter.not_set or
                                self.is_optical.yfilter != YFilter.not_set or
                                self.local_router_id.yfilter != YFilter.not_set or
                                self.next_hop_address.yfilter != YFilter.not_set or
                                self.node_hop_count.yfilter != YFilter.not_set or
                                self.outbound_frr_state.yfilter != YFilter.not_set or
                                self.path_reeval_query_mid.yfilter != YFilter.not_set or
                                self.path_rro_enabled.yfilter != YFilter.not_set or
                                self.path_using_strict_spf.yfilter != YFilter.not_set or
                                self.pcalc_area.yfilter != YFilter.not_set or
                                self.previous_hop_address.yfilter != YFilter.not_set or
                                self.reverse_lsp_connected.yfilter != YFilter.not_set or
                                self.reverse_lsp_name.yfilter != YFilter.not_set or
                                self.reverse_lsp_present.yfilter != YFilter.not_set or
                                self.reverse_weight.yfilter != YFilter.not_set or
                                self.role.yfilter != YFilter.not_set or
                                self.s2l_local_label.yfilter != YFilter.not_set or
                                self.s2l_out_label.yfilter != YFilter.not_set or
                                self.s2l_reverse_ero_obj_present.yfilter != YFilter.not_set or
                                self.s2l_reverse_tspec_obj_present.yfilter != YFilter.not_set or
                                self.signalling_status.yfilter != YFilter.not_set or
                                self.time_since_last_preferred_path_exists_send_mid.yfilter != YFilter.not_set or
                                self.time_since_last_preferred_tree_exists_send_mid.yfilter != YFilter.not_set or
                                self.time_since_last_query_received_mid.yfilter != YFilter.not_set or
                                self.upstream_router_id.yfilter != YFilter.not_set or
                                self.uptime.yfilter != YFilter.not_set or
                                self.weight.yfilter != YFilter.not_set or
                                (self.active_path_option is not None and self.active_path_option.has_operation()) or
                                (self.association is not None and self.association.has_operation()) or
                                (self.diversity_info is not None and self.diversity_info.has_operation()) or
                                (self.flex_info is not None and self.flex_info.has_operation()) or
                                (self.fspec is not None and self.fspec.has_operation()) or
                                (self.generic_fspec is not None and self.generic_fspec.has_operation()) or
                                (self.generic_tspec is not None and self.generic_tspec.has_operation()) or
                                (self.gmpls_labels is not None and self.gmpls_labels.has_operation()) or
                                (self.head_end_bfd_info is not None and self.head_end_bfd_info.has_operation()) or
                                (self.in_xro is not None and self.in_xro.has_operation()) or
                                (self.incoming_address_generic is not None and self.incoming_address_generic.has_operation()) or
                                (self.lsp_wrap_info is not None and self.lsp_wrap_info.has_operation()) or
                                (self.next_hop_address_generic is not None and self.next_hop_address_generic.has_operation()) or
                                (self.otn_s2l is not None and self.otn_s2l.has_operation()) or
                                (self.out_xro is not None and self.out_xro.has_operation()) or
                                (self.previous_hop_address_generic is not None and self.previous_hop_address_generic.has_operation()) or
                                (self.protection is not None and self.protection.has_operation()) or
                                (self.reverse_lsp_fec is not None and self.reverse_lsp_fec.has_operation()) or
                                (self.reverse_tspec is not None and self.reverse_tspec.has_operation()) or
                                (self.s2l_convergence is not None and self.s2l_convergence.has_operation()) or
                                (self.s2l_fec is not None and self.s2l_fec.has_operation()) or
                                (self.soft_preemption is not None and self.soft_preemption.has_operation()) or
                                (self.srlg_collection is not None and self.srlg_collection.has_operation()) or
                                (self.tail_end_bfd_info is not None and self.tail_end_bfd_info.has_operation()) or
                                (self.tspec is not None and self.tspec.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "s2l" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.abr_auto_discovered.is_set or self.abr_auto_discovered.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.abr_auto_discovered.get_name_leafdata())
                            if (self.backup_tunnel_interface.is_set or self.backup_tunnel_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.backup_tunnel_interface.get_name_leafdata())
                            if (self.downstream_router_id.is_set or self.downstream_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.downstream_router_id.get_name_leafdata())
                            if (self.egress_interface.is_set or self.egress_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface.get_name_leafdata())
                            if (self.egress_interface_brief.is_set or self.egress_interface_brief.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface_brief.get_name_leafdata())
                            if (self.egress_interface_state.is_set or self.egress_interface_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface_state.get_name_leafdata())
                            if (self.expanded_ero_affinity_bits.is_set or self.expanded_ero_affinity_bits.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_affinity_bits.get_name_leafdata())
                            if (self.expanded_ero_affinity_mask.is_set or self.expanded_ero_affinity_mask.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_affinity_mask.get_name_leafdata())
                            if (self.expanded_ero_area_id.is_set or self.expanded_ero_area_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_area_id.get_name_leafdata())
                            if (self.expanded_ero_metric.is_set or self.expanded_ero_metric.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_metric.get_name_leafdata())
                            if (self.expanded_ero_metric_type.is_set or self.expanded_ero_metric_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_metric_type.get_name_leafdata())
                            if (self.frr_out_tunnel_interface.is_set or self.frr_out_tunnel_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.frr_out_tunnel_interface.get_name_leafdata())
                            if (self.incoming_address.is_set or self.incoming_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.incoming_address.get_name_leafdata())
                            if (self.ingress_interface.is_set or self.ingress_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface.get_name_leafdata())
                            if (self.ingress_interface_brief.is_set or self.ingress_interface_brief.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface_brief.get_name_leafdata())
                            if (self.ingress_interface_state.is_set or self.ingress_interface_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface_state.get_name_leafdata())
                            if (self.is_bandwidth_protect.is_set or self.is_bandwidth_protect.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_bandwidth_protect.get_name_leafdata())
                            if (self.is_expanded_ero.is_set or self.is_expanded_ero.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_expanded_ero.get_name_leafdata())
                            if (self.is_frr_enabled.is_set or self.is_frr_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_frr_enabled.get_name_leafdata())
                            if (self.is_node_protected.is_set or self.is_node_protected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_node_protected.get_name_leafdata())
                            if (self.is_optical.is_set or self.is_optical.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_optical.get_name_leafdata())
                            if (self.local_router_id.is_set or self.local_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.local_router_id.get_name_leafdata())
                            if (self.next_hop_address.is_set or self.next_hop_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.next_hop_address.get_name_leafdata())
                            if (self.node_hop_count.is_set or self.node_hop_count.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.node_hop_count.get_name_leafdata())
                            if (self.outbound_frr_state.is_set or self.outbound_frr_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.outbound_frr_state.get_name_leafdata())
                            if (self.path_reeval_query_mid.is_set or self.path_reeval_query_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reeval_query_mid.get_name_leafdata())
                            if (self.path_rro_enabled.is_set or self.path_rro_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_rro_enabled.get_name_leafdata())
                            if (self.path_using_strict_spf.is_set or self.path_using_strict_spf.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_using_strict_spf.get_name_leafdata())
                            if (self.pcalc_area.is_set or self.pcalc_area.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.pcalc_area.get_name_leafdata())
                            if (self.previous_hop_address.is_set or self.previous_hop_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.previous_hop_address.get_name_leafdata())
                            if (self.reverse_lsp_connected.is_set or self.reverse_lsp_connected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_connected.get_name_leafdata())
                            if (self.reverse_lsp_name.is_set or self.reverse_lsp_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_name.get_name_leafdata())
                            if (self.reverse_lsp_present.is_set or self.reverse_lsp_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_present.get_name_leafdata())
                            if (self.reverse_weight.is_set or self.reverse_weight.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_weight.get_name_leafdata())
                            if (self.role.is_set or self.role.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.role.get_name_leafdata())
                            if (self.s2l_local_label.is_set or self.s2l_local_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_local_label.get_name_leafdata())
                            if (self.s2l_out_label.is_set or self.s2l_out_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_out_label.get_name_leafdata())
                            if (self.s2l_reverse_ero_obj_present.is_set or self.s2l_reverse_ero_obj_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_reverse_ero_obj_present.get_name_leafdata())
                            if (self.s2l_reverse_tspec_obj_present.is_set or self.s2l_reverse_tspec_obj_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_reverse_tspec_obj_present.get_name_leafdata())
                            if (self.signalling_status.is_set or self.signalling_status.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.signalling_status.get_name_leafdata())
                            if (self.time_since_last_preferred_path_exists_send_mid.is_set or self.time_since_last_preferred_path_exists_send_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_preferred_path_exists_send_mid.get_name_leafdata())
                            if (self.time_since_last_preferred_tree_exists_send_mid.is_set or self.time_since_last_preferred_tree_exists_send_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_preferred_tree_exists_send_mid.get_name_leafdata())
                            if (self.time_since_last_query_received_mid.is_set or self.time_since_last_query_received_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_query_received_mid.get_name_leafdata())
                            if (self.upstream_router_id.is_set or self.upstream_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.upstream_router_id.get_name_leafdata())
                            if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.uptime.get_name_leafdata())
                            if (self.weight.is_set or self.weight.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.weight.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "active-path-option"):
                                if (self.active_path_option is None):
                                    self.active_path_option = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ActivePathOption()
                                    self.active_path_option.parent = self
                                    self._children_name_map["active_path_option"] = "active-path-option"
                                return self.active_path_option

                            if (child_yang_name == "association"):
                                if (self.association is None):
                                    self.association = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.Association()
                                    self.association.parent = self
                                    self._children_name_map["association"] = "association"
                                return self.association

                            if (child_yang_name == "diversity-info"):
                                if (self.diversity_info is None):
                                    self.diversity_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.DiversityInfo()
                                    self.diversity_info.parent = self
                                    self._children_name_map["diversity_info"] = "diversity-info"
                                return self.diversity_info

                            if (child_yang_name == "flex-info"):
                                if (self.flex_info is None):
                                    self.flex_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.FlexInfo()
                                    self.flex_info.parent = self
                                    self._children_name_map["flex_info"] = "flex-info"
                                return self.flex_info

                            if (child_yang_name == "fspec"):
                                if (self.fspec is None):
                                    self.fspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.Fspec()
                                    self.fspec.parent = self
                                    self._children_name_map["fspec"] = "fspec"
                                return self.fspec

                            if (child_yang_name == "generic-fspec"):
                                if (self.generic_fspec is None):
                                    self.generic_fspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GenericFspec()
                                    self.generic_fspec.parent = self
                                    self._children_name_map["generic_fspec"] = "generic-fspec"
                                return self.generic_fspec

                            if (child_yang_name == "generic-tspec"):
                                if (self.generic_tspec is None):
                                    self.generic_tspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GenericTspec()
                                    self.generic_tspec.parent = self
                                    self._children_name_map["generic_tspec"] = "generic-tspec"
                                return self.generic_tspec

                            if (child_yang_name == "gmpls-labels"):
                                if (self.gmpls_labels is None):
                                    self.gmpls_labels = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.GmplsLabels()
                                    self.gmpls_labels.parent = self
                                    self._children_name_map["gmpls_labels"] = "gmpls-labels"
                                return self.gmpls_labels

                            if (child_yang_name == "head-end-bfd-info"):
                                if (self.head_end_bfd_info is None):
                                    self.head_end_bfd_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.HeadEndBfdInfo()
                                    self.head_end_bfd_info.parent = self
                                    self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"
                                return self.head_end_bfd_info

                            if (child_yang_name == "in-ero"):
                                for c in self.in_ero:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InEro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.in_ero.append(c)
                                return c

                            if (child_yang_name == "in-xro"):
                                if (self.in_xro is None):
                                    self.in_xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.InXro()
                                    self.in_xro.parent = self
                                    self._children_name_map["in_xro"] = "in-xro"
                                return self.in_xro

                            if (child_yang_name == "incoming-address-generic"):
                                if (self.incoming_address_generic is None):
                                    self.incoming_address_generic = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.IncomingAddressGeneric()
                                    self.incoming_address_generic.parent = self
                                    self._children_name_map["incoming_address_generic"] = "incoming-address-generic"
                                return self.incoming_address_generic

                            if (child_yang_name == "lsp-wrap-info"):
                                if (self.lsp_wrap_info is None):
                                    self.lsp_wrap_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.LspWrapInfo()
                                    self.lsp_wrap_info.parent = self
                                    self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"
                                return self.lsp_wrap_info

                            if (child_yang_name == "next-hop-address-generic"):
                                if (self.next_hop_address_generic is None):
                                    self.next_hop_address_generic = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.NextHopAddressGeneric()
                                    self.next_hop_address_generic.parent = self
                                    self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"
                                return self.next_hop_address_generic

                            if (child_yang_name == "otn-s2l"):
                                if (self.otn_s2l is None):
                                    self.otn_s2l = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OtnS2L()
                                    self.otn_s2l.parent = self
                                    self._children_name_map["otn_s2l"] = "otn-s2l"
                                return self.otn_s2l

                            if (child_yang_name == "out-ero"):
                                for c in self.out_ero:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutEro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.out_ero.append(c)
                                return c

                            if (child_yang_name == "out-xro"):
                                if (self.out_xro is None):
                                    self.out_xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.OutXro()
                                    self.out_xro.parent = self
                                    self._children_name_map["out_xro"] = "out-xro"
                                return self.out_xro

                            if (child_yang_name == "path-affinity-array"):
                                for c in self.path_affinity_array:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathAffinityArray()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_affinity_array.append(c)
                                return c

                            if (child_yang_name == "path-rro"):
                                for c in self.path_rro:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PathRro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_rro.append(c)
                                return c

                            if (child_yang_name == "previous-hop-address-generic"):
                                if (self.previous_hop_address_generic is None):
                                    self.previous_hop_address_generic = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.PreviousHopAddressGeneric()
                                    self.previous_hop_address_generic.parent = self
                                    self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"
                                return self.previous_hop_address_generic

                            if (child_yang_name == "protection"):
                                if (self.protection is None):
                                    self.protection = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.Protection()
                                    self.protection.parent = self
                                    self._children_name_map["protection"] = "protection"
                                return self.protection

                            if (child_yang_name == "resv-rro"):
                                for c in self.resv_rro:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ResvRro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.resv_rro.append(c)
                                return c

                            if (child_yang_name == "reverse-ero-in"):
                                for c in self.reverse_ero_in:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ReverseEroIn()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.reverse_ero_in.append(c)
                                return c

                            if (child_yang_name == "reverse-lsp-fec"):
                                if (self.reverse_lsp_fec is None):
                                    self.reverse_lsp_fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ReverseLspFec()
                                    self.reverse_lsp_fec.parent = self
                                    self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"
                                return self.reverse_lsp_fec

                            if (child_yang_name == "reverse-tspec"):
                                if (self.reverse_tspec is None):
                                    self.reverse_tspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.ReverseTspec()
                                    self.reverse_tspec.parent = self
                                    self._children_name_map["reverse_tspec"] = "reverse-tspec"
                                return self.reverse_tspec

                            if (child_yang_name == "s2l-convergence"):
                                if (self.s2l_convergence is None):
                                    self.s2l_convergence = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.S2LConvergence()
                                    self.s2l_convergence.parent = self
                                    self._children_name_map["s2l_convergence"] = "s2l-convergence"
                                return self.s2l_convergence

                            if (child_yang_name == "s2l-fec"):
                                if (self.s2l_fec is None):
                                    self.s2l_fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.S2LFec()
                                    self.s2l_fec.parent = self
                                    self._children_name_map["s2l_fec"] = "s2l-fec"
                                return self.s2l_fec

                            if (child_yang_name == "s2l-reverse-lsp-sub-obj"):
                                for c in self.s2l_reverse_lsp_sub_obj:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.S2LReverseLspSubObj()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.s2l_reverse_lsp_sub_obj.append(c)
                                return c

                            if (child_yang_name == "s2l-segment-routing-path"):
                                for c in self.s2l_segment_routing_path:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.S2LSegmentRoutingPath()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.s2l_segment_routing_path.append(c)
                                return c

                            if (child_yang_name == "shared-risk-link-group"):
                                for c in self.shared_risk_link_group:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.SharedRiskLinkGroup()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.shared_risk_link_group.append(c)
                                return c

                            if (child_yang_name == "soft-preemption"):
                                if (self.soft_preemption is None):
                                    self.soft_preemption = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.SoftPreemption()
                                    self.soft_preemption.parent = self
                                    self._children_name_map["soft_preemption"] = "soft-preemption"
                                return self.soft_preemption

                            if (child_yang_name == "srlg-collection"):
                                if (self.srlg_collection is None):
                                    self.srlg_collection = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.SrlgCollection()
                                    self.srlg_collection.parent = self
                                    self._children_name_map["srlg_collection"] = "srlg-collection"
                                return self.srlg_collection

                            if (child_yang_name == "tail-end-bfd-info"):
                                if (self.tail_end_bfd_info is None):
                                    self.tail_end_bfd_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.TailEndBfdInfo()
                                    self.tail_end_bfd_info.parent = self
                                    self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"
                                return self.tail_end_bfd_info

                            if (child_yang_name == "tspec"):
                                if (self.tspec is None):
                                    self.tspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L.Tspec()
                                    self.tspec.parent = self
                                    self._children_name_map["tspec"] = "tspec"
                                return self.tspec

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "active-path-option" or name == "association" or name == "diversity-info" or name == "flex-info" or name == "fspec" or name == "generic-fspec" or name == "generic-tspec" or name == "gmpls-labels" or name == "head-end-bfd-info" or name == "in-ero" or name == "in-xro" or name == "incoming-address-generic" or name == "lsp-wrap-info" or name == "next-hop-address-generic" or name == "otn-s2l" or name == "out-ero" or name == "out-xro" or name == "path-affinity-array" or name == "path-rro" or name == "previous-hop-address-generic" or name == "protection" or name == "resv-rro" or name == "reverse-ero-in" or name == "reverse-lsp-fec" or name == "reverse-tspec" or name == "s2l-convergence" or name == "s2l-fec" or name == "s2l-reverse-lsp-sub-obj" or name == "s2l-segment-routing-path" or name == "shared-risk-link-group" or name == "soft-preemption" or name == "srlg-collection" or name == "tail-end-bfd-info" or name == "tspec" or name == "abr-auto-discovered" or name == "backup-tunnel-interface" or name == "downstream-router-id" or name == "egress-interface" or name == "egress-interface-brief" or name == "egress-interface-state" or name == "expanded-ero-affinity-bits" or name == "expanded-ero-affinity-mask" or name == "expanded-ero-area-id" or name == "expanded-ero-metric" or name == "expanded-ero-metric-type" or name == "frr-out-tunnel-interface" or name == "incoming-address" or name == "ingress-interface" or name == "ingress-interface-brief" or name == "ingress-interface-state" or name == "is-bandwidth-protect" or name == "is-expanded-ero" or name == "is-frr-enabled" or name == "is-node-protected" or name == "is-optical" or name == "local-router-id" or name == "next-hop-address" or name == "node-hop-count" or name == "outbound-frr-state" or name == "path-reeval-query-mid" or name == "path-rro-enabled" or name == "path-using-strict-spf" or name == "pcalc-area" or name == "previous-hop-address" or name == "reverse-lsp-connected" or name == "reverse-lsp-name" or name == "reverse-lsp-present" or name == "reverse-weight" or name == "role" or name == "s2l-local-label" or name == "s2l-out-label" or name == "s2l-reverse-ero-obj-present" or name == "s2l-reverse-tspec-obj-present" or name == "signalling-status" or name == "time-since-last-preferred-path-exists-send-mid" or name == "time-since-last-preferred-tree-exists-send-mid" or name == "time-since-last-query-received-mid" or name == "upstream-router-id" or name == "uptime" or name == "weight"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "abr-auto-discovered"):
                                self.abr_auto_discovered = value
                                self.abr_auto_discovered.value_namespace = name_space
                                self.abr_auto_discovered.value_namespace_prefix = name_space_prefix
                            if(value_path == "backup-tunnel-interface"):
                                self.backup_tunnel_interface = value
                                self.backup_tunnel_interface.value_namespace = name_space
                                self.backup_tunnel_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "downstream-router-id"):
                                self.downstream_router_id = value
                                self.downstream_router_id.value_namespace = name_space
                                self.downstream_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface"):
                                self.egress_interface = value
                                self.egress_interface.value_namespace = name_space
                                self.egress_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface-brief"):
                                self.egress_interface_brief = value
                                self.egress_interface_brief.value_namespace = name_space
                                self.egress_interface_brief.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface-state"):
                                self.egress_interface_state = value
                                self.egress_interface_state.value_namespace = name_space
                                self.egress_interface_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-affinity-bits"):
                                self.expanded_ero_affinity_bits = value
                                self.expanded_ero_affinity_bits.value_namespace = name_space
                                self.expanded_ero_affinity_bits.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-affinity-mask"):
                                self.expanded_ero_affinity_mask = value
                                self.expanded_ero_affinity_mask.value_namespace = name_space
                                self.expanded_ero_affinity_mask.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-area-id"):
                                self.expanded_ero_area_id = value
                                self.expanded_ero_area_id.value_namespace = name_space
                                self.expanded_ero_area_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-metric"):
                                self.expanded_ero_metric = value
                                self.expanded_ero_metric.value_namespace = name_space
                                self.expanded_ero_metric.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-metric-type"):
                                self.expanded_ero_metric_type = value
                                self.expanded_ero_metric_type.value_namespace = name_space
                                self.expanded_ero_metric_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "frr-out-tunnel-interface"):
                                self.frr_out_tunnel_interface = value
                                self.frr_out_tunnel_interface.value_namespace = name_space
                                self.frr_out_tunnel_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "incoming-address"):
                                self.incoming_address = value
                                self.incoming_address.value_namespace = name_space
                                self.incoming_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface"):
                                self.ingress_interface = value
                                self.ingress_interface.value_namespace = name_space
                                self.ingress_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface-brief"):
                                self.ingress_interface_brief = value
                                self.ingress_interface_brief.value_namespace = name_space
                                self.ingress_interface_brief.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface-state"):
                                self.ingress_interface_state = value
                                self.ingress_interface_state.value_namespace = name_space
                                self.ingress_interface_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-bandwidth-protect"):
                                self.is_bandwidth_protect = value
                                self.is_bandwidth_protect.value_namespace = name_space
                                self.is_bandwidth_protect.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-expanded-ero"):
                                self.is_expanded_ero = value
                                self.is_expanded_ero.value_namespace = name_space
                                self.is_expanded_ero.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-frr-enabled"):
                                self.is_frr_enabled = value
                                self.is_frr_enabled.value_namespace = name_space
                                self.is_frr_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-node-protected"):
                                self.is_node_protected = value
                                self.is_node_protected.value_namespace = name_space
                                self.is_node_protected.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-optical"):
                                self.is_optical = value
                                self.is_optical.value_namespace = name_space
                                self.is_optical.value_namespace_prefix = name_space_prefix
                            if(value_path == "local-router-id"):
                                self.local_router_id = value
                                self.local_router_id.value_namespace = name_space
                                self.local_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "next-hop-address"):
                                self.next_hop_address = value
                                self.next_hop_address.value_namespace = name_space
                                self.next_hop_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "node-hop-count"):
                                self.node_hop_count = value
                                self.node_hop_count.value_namespace = name_space
                                self.node_hop_count.value_namespace_prefix = name_space_prefix
                            if(value_path == "outbound-frr-state"):
                                self.outbound_frr_state = value
                                self.outbound_frr_state.value_namespace = name_space
                                self.outbound_frr_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reeval-query-mid"):
                                self.path_reeval_query_mid = value
                                self.path_reeval_query_mid.value_namespace = name_space
                                self.path_reeval_query_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-rro-enabled"):
                                self.path_rro_enabled = value
                                self.path_rro_enabled.value_namespace = name_space
                                self.path_rro_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-using-strict-spf"):
                                self.path_using_strict_spf = value
                                self.path_using_strict_spf.value_namespace = name_space
                                self.path_using_strict_spf.value_namespace_prefix = name_space_prefix
                            if(value_path == "pcalc-area"):
                                self.pcalc_area = value
                                self.pcalc_area.value_namespace = name_space
                                self.pcalc_area.value_namespace_prefix = name_space_prefix
                            if(value_path == "previous-hop-address"):
                                self.previous_hop_address = value
                                self.previous_hop_address.value_namespace = name_space
                                self.previous_hop_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-connected"):
                                self.reverse_lsp_connected = value
                                self.reverse_lsp_connected.value_namespace = name_space
                                self.reverse_lsp_connected.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-name"):
                                self.reverse_lsp_name = value
                                self.reverse_lsp_name.value_namespace = name_space
                                self.reverse_lsp_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-present"):
                                self.reverse_lsp_present = value
                                self.reverse_lsp_present.value_namespace = name_space
                                self.reverse_lsp_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-weight"):
                                self.reverse_weight = value
                                self.reverse_weight.value_namespace = name_space
                                self.reverse_weight.value_namespace_prefix = name_space_prefix
                            if(value_path == "role"):
                                self.role = value
                                self.role.value_namespace = name_space
                                self.role.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-local-label"):
                                self.s2l_local_label = value
                                self.s2l_local_label.value_namespace = name_space
                                self.s2l_local_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-out-label"):
                                self.s2l_out_label = value
                                self.s2l_out_label.value_namespace = name_space
                                self.s2l_out_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-reverse-ero-obj-present"):
                                self.s2l_reverse_ero_obj_present = value
                                self.s2l_reverse_ero_obj_present.value_namespace = name_space
                                self.s2l_reverse_ero_obj_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-reverse-tspec-obj-present"):
                                self.s2l_reverse_tspec_obj_present = value
                                self.s2l_reverse_tspec_obj_present.value_namespace = name_space
                                self.s2l_reverse_tspec_obj_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "signalling-status"):
                                self.signalling_status = value
                                self.signalling_status.value_namespace = name_space
                                self.signalling_status.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-preferred-path-exists-send-mid"):
                                self.time_since_last_preferred_path_exists_send_mid = value
                                self.time_since_last_preferred_path_exists_send_mid.value_namespace = name_space
                                self.time_since_last_preferred_path_exists_send_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-preferred-tree-exists-send-mid"):
                                self.time_since_last_preferred_tree_exists_send_mid = value
                                self.time_since_last_preferred_tree_exists_send_mid.value_namespace = name_space
                                self.time_since_last_preferred_tree_exists_send_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-query-received-mid"):
                                self.time_since_last_query_received_mid = value
                                self.time_since_last_query_received_mid.value_namespace = name_space
                                self.time_since_last_query_received_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "upstream-router-id"):
                                self.upstream_router_id = value
                                self.upstream_router_id.value_namespace = name_space
                                self.upstream_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "uptime"):
                                self.uptime = value
                                self.uptime.value_namespace = name_space
                                self.uptime.value_namespace_prefix = name_space_prefix
                            if(value_path == "weight"):
                                self.weight = value
                                self.weight.value_namespace = name_space
                                self.weight.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.s2l:
                            if (c.has_data()):
                                return True
                        return (
                            self.dste_class_index.is_set or
                            self.dste_class_match.is_set or
                            self.frr_active_reason.is_set or
                            self.is_frr_failed.is_set or
                            self.is_interface.is_set or
                            self.is_passive.is_set or
                            self.last_path_change.is_set or
                            self.lsp_bandwidth.is_set or
                            self.lsp_bandwidth_type.is_set or
                            self.lsp_hold_priority.is_set or
                            self.lsp_setup_priority.is_set or
                            self.persistent_bytes.is_set or
                            self.persistent_packets.is_set or
                            self.reoptimize_reason.is_set or
                            self.reoptimize_trigger.is_set or
                            self.s2_ls_down.is_set or
                            self.s2_ls_proceeding.is_set or
                            self.s2_ls_up.is_set or
                            self.signaled_name.is_set or
                            self.timer_left.is_set or
                            self.type.is_set or
                            self.uptime.is_set or
                            (self.lsp_fec is not None and self.lsp_fec.has_data()))

                    def has_operation(self):
                        for c in self.s2l:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.dste_class_index.yfilter != YFilter.not_set or
                            self.dste_class_match.yfilter != YFilter.not_set or
                            self.frr_active_reason.yfilter != YFilter.not_set or
                            self.is_frr_failed.yfilter != YFilter.not_set or
                            self.is_interface.yfilter != YFilter.not_set or
                            self.is_passive.yfilter != YFilter.not_set or
                            self.last_path_change.yfilter != YFilter.not_set or
                            self.lsp_bandwidth.yfilter != YFilter.not_set or
                            self.lsp_bandwidth_type.yfilter != YFilter.not_set or
                            self.lsp_hold_priority.yfilter != YFilter.not_set or
                            self.lsp_setup_priority.yfilter != YFilter.not_set or
                            self.persistent_bytes.yfilter != YFilter.not_set or
                            self.persistent_packets.yfilter != YFilter.not_set or
                            self.reoptimize_reason.yfilter != YFilter.not_set or
                            self.reoptimize_trigger.yfilter != YFilter.not_set or
                            self.s2_ls_down.yfilter != YFilter.not_set or
                            self.s2_ls_proceeding.yfilter != YFilter.not_set or
                            self.s2_ls_up.yfilter != YFilter.not_set or
                            self.signaled_name.yfilter != YFilter.not_set or
                            self.timer_left.yfilter != YFilter.not_set or
                            self.type.yfilter != YFilter.not_set or
                            self.uptime.yfilter != YFilter.not_set or
                            (self.lsp_fec is not None and self.lsp_fec.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "tunnel-restoration-lsp" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.dste_class_index.is_set or self.dste_class_index.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.dste_class_index.get_name_leafdata())
                        if (self.dste_class_match.is_set or self.dste_class_match.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.dste_class_match.get_name_leafdata())
                        if (self.frr_active_reason.is_set or self.frr_active_reason.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.frr_active_reason.get_name_leafdata())
                        if (self.is_frr_failed.is_set or self.is_frr_failed.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_frr_failed.get_name_leafdata())
                        if (self.is_interface.is_set or self.is_interface.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_interface.get_name_leafdata())
                        if (self.is_passive.is_set or self.is_passive.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_passive.get_name_leafdata())
                        if (self.last_path_change.is_set or self.last_path_change.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.last_path_change.get_name_leafdata())
                        if (self.lsp_bandwidth.is_set or self.lsp_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_bandwidth.get_name_leafdata())
                        if (self.lsp_bandwidth_type.is_set or self.lsp_bandwidth_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_bandwidth_type.get_name_leafdata())
                        if (self.lsp_hold_priority.is_set or self.lsp_hold_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_hold_priority.get_name_leafdata())
                        if (self.lsp_setup_priority.is_set or self.lsp_setup_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_setup_priority.get_name_leafdata())
                        if (self.persistent_bytes.is_set or self.persistent_bytes.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.persistent_bytes.get_name_leafdata())
                        if (self.persistent_packets.is_set or self.persistent_packets.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.persistent_packets.get_name_leafdata())
                        if (self.reoptimize_reason.is_set or self.reoptimize_reason.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reoptimize_reason.get_name_leafdata())
                        if (self.reoptimize_trigger.is_set or self.reoptimize_trigger.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reoptimize_trigger.get_name_leafdata())
                        if (self.s2_ls_down.is_set or self.s2_ls_down.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_down.get_name_leafdata())
                        if (self.s2_ls_proceeding.is_set or self.s2_ls_proceeding.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_proceeding.get_name_leafdata())
                        if (self.s2_ls_up.is_set or self.s2_ls_up.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_up.get_name_leafdata())
                        if (self.signaled_name.is_set or self.signaled_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.signaled_name.get_name_leafdata())
                        if (self.timer_left.is_set or self.timer_left.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.timer_left.get_name_leafdata())
                        if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.type.get_name_leafdata())
                        if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.uptime.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "lsp-fec"):
                            if (self.lsp_fec is None):
                                self.lsp_fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.LspFec()
                                self.lsp_fec.parent = self
                                self._children_name_map["lsp_fec"] = "lsp-fec"
                            return self.lsp_fec

                        if (child_yang_name == "s2l"):
                            for c in self.s2l:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp.S2L()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.s2l.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "lsp-fec" or name == "s2l" or name == "dste-class-index" or name == "dste-class-match" or name == "frr-active-reason" or name == "is-frr-failed" or name == "is-interface" or name == "is-passive" or name == "last-path-change" or name == "lsp-bandwidth" or name == "lsp-bandwidth-type" or name == "lsp-hold-priority" or name == "lsp-setup-priority" or name == "persistent-bytes" or name == "persistent-packets" or name == "reoptimize-reason" or name == "reoptimize-trigger" or name == "s2-ls-down" or name == "s2-ls-proceeding" or name == "s2-ls-up" or name == "signaled-name" or name == "timer-left" or name == "type" or name == "uptime"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "dste-class-index"):
                            self.dste_class_index = value
                            self.dste_class_index.value_namespace = name_space
                            self.dste_class_index.value_namespace_prefix = name_space_prefix
                        if(value_path == "dste-class-match"):
                            self.dste_class_match = value
                            self.dste_class_match.value_namespace = name_space
                            self.dste_class_match.value_namespace_prefix = name_space_prefix
                        if(value_path == "frr-active-reason"):
                            self.frr_active_reason = value
                            self.frr_active_reason.value_namespace = name_space
                            self.frr_active_reason.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-frr-failed"):
                            self.is_frr_failed = value
                            self.is_frr_failed.value_namespace = name_space
                            self.is_frr_failed.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-interface"):
                            self.is_interface = value
                            self.is_interface.value_namespace = name_space
                            self.is_interface.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-passive"):
                            self.is_passive = value
                            self.is_passive.value_namespace = name_space
                            self.is_passive.value_namespace_prefix = name_space_prefix
                        if(value_path == "last-path-change"):
                            self.last_path_change = value
                            self.last_path_change.value_namespace = name_space
                            self.last_path_change.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-bandwidth"):
                            self.lsp_bandwidth = value
                            self.lsp_bandwidth.value_namespace = name_space
                            self.lsp_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-bandwidth-type"):
                            self.lsp_bandwidth_type = value
                            self.lsp_bandwidth_type.value_namespace = name_space
                            self.lsp_bandwidth_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-hold-priority"):
                            self.lsp_hold_priority = value
                            self.lsp_hold_priority.value_namespace = name_space
                            self.lsp_hold_priority.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-setup-priority"):
                            self.lsp_setup_priority = value
                            self.lsp_setup_priority.value_namespace = name_space
                            self.lsp_setup_priority.value_namespace_prefix = name_space_prefix
                        if(value_path == "persistent-bytes"):
                            self.persistent_bytes = value
                            self.persistent_bytes.value_namespace = name_space
                            self.persistent_bytes.value_namespace_prefix = name_space_prefix
                        if(value_path == "persistent-packets"):
                            self.persistent_packets = value
                            self.persistent_packets.value_namespace = name_space
                            self.persistent_packets.value_namespace_prefix = name_space_prefix
                        if(value_path == "reoptimize-reason"):
                            self.reoptimize_reason = value
                            self.reoptimize_reason.value_namespace = name_space
                            self.reoptimize_reason.value_namespace_prefix = name_space_prefix
                        if(value_path == "reoptimize-trigger"):
                            self.reoptimize_trigger = value
                            self.reoptimize_trigger.value_namespace = name_space
                            self.reoptimize_trigger.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-down"):
                            self.s2_ls_down = value
                            self.s2_ls_down.value_namespace = name_space
                            self.s2_ls_down.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-proceeding"):
                            self.s2_ls_proceeding = value
                            self.s2_ls_proceeding.value_namespace = name_space
                            self.s2_ls_proceeding.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-up"):
                            self.s2_ls_up = value
                            self.s2_ls_up.value_namespace = name_space
                            self.s2_ls_up.value_namespace_prefix = name_space_prefix
                        if(value_path == "signaled-name"):
                            self.signaled_name = value
                            self.signaled_name.value_namespace = name_space
                            self.signaled_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "timer-left"):
                            self.timer_left = value
                            self.timer_left.value_namespace = name_space
                            self.timer_left.value_namespace_prefix = name_space_prefix
                        if(value_path == "type"):
                            self.type = value
                            self.type.value_namespace = name_space
                            self.type.value_namespace_prefix = name_space_prefix
                        if(value_path == "uptime"):
                            self.uptime = value
                            self.uptime.value_namespace = name_space
                            self.uptime.value_namespace_prefix = name_space_prefix


                class DelayCleanPpLsp(Entity):
                    """
                    Delay Clean PP LSP
                    
                    .. attribute:: dste_class_index
                    
                    	Matching DSTE class index
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: dste_class_match
                    
                    	Do the class type and priority match a DSTE class
                    	**type**\:  bool
                    
                    .. attribute:: frr_active_reason
                    
                    	P2MP LSP FRR active reason
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: is_frr_failed
                    
                    	P2MP LSP has FRR Failed
                    	**type**\:  bool
                    
                    .. attribute:: is_interface
                    
                    	True for tunnel head
                    	**type**\:  bool
                    
                    .. attribute:: is_passive
                    
                    	True for passive tunnel
                    	**type**\:  bool
                    
                    .. attribute:: last_path_change
                    
                    	Time in seconds since the last path change
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: lsp_bandwidth
                    
                    	P2MP LSP Bandwidth
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: lsp_bandwidth_type
                    
                    	The LSP bandwidth type
                    	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                    
                    .. attribute:: lsp_fec
                    
                    	FEC for the LSP
                    	**type**\:   :py:class:`LspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.LspFec>`
                    
                    .. attribute:: lsp_hold_priority
                    
                    	LSP hold priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: lsp_setup_priority
                    
                    	LSP setup priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: persistent_bytes
                    
                    	Persistent forwarding statistics for number of bytes. Clear counters will not reset the counter
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**units**\: byte
                    
                    .. attribute:: persistent_packets
                    
                    	Persistent forwarding statistics for Number of packets. Clear counters will not reset the counter
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: reoptimize_reason
                    
                    	Reason for re\-optimization
                    	**type**\:   :py:class:`MplsTeReoptDecisionReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReoptDecisionReason>`
                    
                    .. attribute:: reoptimize_trigger
                    
                    	Re\-optimize trigger
                    	**type**\:   :py:class:`MteReoptTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteReoptTrigger>`
                    
                    .. attribute:: s2_ls_down
                    
                    	Number of down S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2_ls_proceeding
                    
                    	Number of proceeding S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2_ls_up
                    
                    	Number of connected S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2l
                    
                    	array of S2L structures
                    	**type**\: list of    :py:class:`S2L <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L>`
                    
                    .. attribute:: signaled_name
                    
                    	Signaled Name
                    	**type**\:  str
                    
                    .. attribute:: timer_left
                    
                    	Time in seconds left to take next action if any
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: type
                    
                    	The type of this LSP
                    	**type**\:   :py:class:`MplsTeLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLsp>`
                    
                    .. attribute:: uptime
                    
                    	Time in seconds since the tunnel was up
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp, self).__init__()

                        self.yang_name = "delay-clean-pp-lsp"
                        self.yang_parent_name = "tunnel-head"

                        self.dste_class_index = YLeaf(YType.uint8, "dste-class-index")

                        self.dste_class_match = YLeaf(YType.boolean, "dste-class-match")

                        self.frr_active_reason = YLeaf(YType.uint32, "frr-active-reason")

                        self.is_frr_failed = YLeaf(YType.boolean, "is-frr-failed")

                        self.is_interface = YLeaf(YType.boolean, "is-interface")

                        self.is_passive = YLeaf(YType.boolean, "is-passive")

                        self.last_path_change = YLeaf(YType.uint32, "last-path-change")

                        self.lsp_bandwidth = YLeaf(YType.uint32, "lsp-bandwidth")

                        self.lsp_bandwidth_type = YLeaf(YType.enumeration, "lsp-bandwidth-type")

                        self.lsp_hold_priority = YLeaf(YType.uint8, "lsp-hold-priority")

                        self.lsp_setup_priority = YLeaf(YType.uint8, "lsp-setup-priority")

                        self.persistent_bytes = YLeaf(YType.uint64, "persistent-bytes")

                        self.persistent_packets = YLeaf(YType.uint64, "persistent-packets")

                        self.reoptimize_reason = YLeaf(YType.enumeration, "reoptimize-reason")

                        self.reoptimize_trigger = YLeaf(YType.enumeration, "reoptimize-trigger")

                        self.s2_ls_down = YLeaf(YType.uint32, "s2-ls-down")

                        self.s2_ls_proceeding = YLeaf(YType.uint32, "s2-ls-proceeding")

                        self.s2_ls_up = YLeaf(YType.uint32, "s2-ls-up")

                        self.signaled_name = YLeaf(YType.str, "signaled-name")

                        self.timer_left = YLeaf(YType.uint32, "timer-left")

                        self.type = YLeaf(YType.enumeration, "type")

                        self.uptime = YLeaf(YType.uint32, "uptime")

                        self.lsp_fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.LspFec()
                        self.lsp_fec.parent = self
                        self._children_name_map["lsp_fec"] = "lsp-fec"
                        self._children_yang_names.add("lsp-fec")

                        self.s2l = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("dste_class_index",
                                        "dste_class_match",
                                        "frr_active_reason",
                                        "is_frr_failed",
                                        "is_interface",
                                        "is_passive",
                                        "last_path_change",
                                        "lsp_bandwidth",
                                        "lsp_bandwidth_type",
                                        "lsp_hold_priority",
                                        "lsp_setup_priority",
                                        "persistent_bytes",
                                        "persistent_packets",
                                        "reoptimize_reason",
                                        "reoptimize_trigger",
                                        "s2_ls_down",
                                        "s2_ls_proceeding",
                                        "s2_ls_up",
                                        "signaled_name",
                                        "timer_left",
                                        "type",
                                        "uptime") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp, self).__setattr__(name, value)


                    class LspFec(Entity):
                        """
                        FEC for the LSP
                        
                        .. attribute:: fec_destination_info
                        
                        	Destination or P2MP ID
                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.LspFec.FecDestinationInfo>`
                        
                        .. attribute:: fec_extended_tunnel_id
                        
                        	Extended tunnel ID
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: fec_lsp_id
                        
                        	LSP ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: fec_source
                        
                        	Tunnel source address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: fec_tunnel_id
                        
                        	Tunnel ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: fec_vrf
                        
                        	VRF; currently only for GMPLS tunnels
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.LspFec, self).__init__()

                            self.yang_name = "lsp-fec"
                            self.yang_parent_name = "delay-clean-pp-lsp"

                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                            self.fec_source = YLeaf(YType.str, "fec-source")

                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                            self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.LspFec.FecDestinationInfo()
                            self.fec_destination_info.parent = self
                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                            self._children_yang_names.add("fec-destination-info")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("fec_extended_tunnel_id",
                                            "fec_lsp_id",
                                            "fec_source",
                                            "fec_tunnel_id",
                                            "fec_vrf") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.LspFec, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.LspFec, self).__setattr__(name, value)


                        class FecDestinationInfo(Entity):
                            """
                            Destination or P2MP ID
                            
                            .. attribute:: fec_ctype
                            
                            	FEC CType
                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            .. attribute:: fec_destination_p2mp_id
                            
                            	P2MP ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: p2p_lsp_destination
                            
                            	P2P LSP destination
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.LspFec.FecDestinationInfo, self).__init__()

                                self.yang_name = "fec-destination-info"
                                self.yang_parent_name = "lsp-fec"

                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fec_ctype",
                                                "fec_destination_p2mp_id",
                                                "p2p_lsp_destination") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.LspFec.FecDestinationInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.LspFec.FecDestinationInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.fec_ctype.is_set or
                                    self.fec_destination_p2mp_id.is_set or
                                    self.p2p_lsp_destination.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fec_ctype.yfilter != YFilter.not_set or
                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fec-destination-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fec-ctype"):
                                    self.fec_ctype = value
                                    self.fec_ctype.value_namespace = name_space
                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-destination-p2mp-id"):
                                    self.fec_destination_p2mp_id = value
                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "p2p-lsp-destination"):
                                    self.p2p_lsp_destination = value
                                    self.p2p_lsp_destination.value_namespace = name_space
                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.fec_extended_tunnel_id.is_set or
                                self.fec_lsp_id.is_set or
                                self.fec_source.is_set or
                                self.fec_tunnel_id.is_set or
                                self.fec_vrf.is_set or
                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                self.fec_source.yfilter != YFilter.not_set or
                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                self.fec_vrf.yfilter != YFilter.not_set or
                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "lsp-fec" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "fec-destination-info"):
                                if (self.fec_destination_info is None):
                                    self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.LspFec.FecDestinationInfo()
                                    self.fec_destination_info.parent = self
                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                return self.fec_destination_info

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "fec-extended-tunnel-id"):
                                self.fec_extended_tunnel_id = value
                                self.fec_extended_tunnel_id.value_namespace = name_space
                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-lsp-id"):
                                self.fec_lsp_id = value
                                self.fec_lsp_id.value_namespace = name_space
                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-source"):
                                self.fec_source = value
                                self.fec_source.value_namespace = name_space
                                self.fec_source.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-tunnel-id"):
                                self.fec_tunnel_id = value
                                self.fec_tunnel_id.value_namespace = name_space
                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-vrf"):
                                self.fec_vrf = value
                                self.fec_vrf.value_namespace = name_space
                                self.fec_vrf.value_namespace_prefix = name_space_prefix


                    class S2L(Entity):
                        """
                        array of S2L structures
                        
                        .. attribute:: abr_auto_discovered
                        
                        	Next ABR auto discovered
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: active_path_option
                        
                        	The path option used to find the path for this S2L
                        	**type**\:   :py:class:`ActivePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption>`
                        
                        .. attribute:: association
                        
                        	Association Object
                        	**type**\:   :py:class:`Association <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.Association>`
                        
                        .. attribute:: backup_tunnel_interface
                        
                        	Interface handle of the backup tunnel
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        .. attribute:: diversity_info
                        
                        	S2L Diversity Information
                        	**type**\:   :py:class:`DiversityInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.DiversityInfo>`
                        
                        .. attribute:: downstream_router_id
                        
                        	Downstream router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: egress_interface
                        
                        	Egress Interface
                        	**type**\:  str
                        
                        .. attribute:: egress_interface_brief
                        
                        	Egress Interface in brief format
                        	**type**\:  str
                        
                        .. attribute:: egress_interface_state
                        
                        	State of Outgoing Interface
                        	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        .. attribute:: expanded_ero_affinity_bits
                        
                        	The Outgoing ERO's affinity bits (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_affinity_mask
                        
                        	The Outgoing ERO's affinity mask (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_area_id
                        
                        	Indicates the protocol and area used to find Outgoing ERO
                        	**type**\:  str
                        
                        .. attribute:: expanded_ero_metric
                        
                        	The metric value of the expanded path
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_metric_type
                        
                        	The Outgoing ERO's selection metric
                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                        
                        .. attribute:: flex_info
                        
                        	FlexLSP S2L Information
                        	**type**\:   :py:class:`FlexInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.FlexInfo>`
                        
                        .. attribute:: frr_out_tunnel_interface
                        
                        	FRR out tunnel intface
                        	**type**\:  str
                        
                        .. attribute:: fspec
                        
                        	The F spec info
                        	**type**\:   :py:class:`Fspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.Fspec>`
                        
                        .. attribute:: generic_fspec
                        
                        	Generic FSpec
                        	**type**\:   :py:class:`GenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GenericFspec>`
                        
                        .. attribute:: generic_tspec
                        
                        	Generic TSpec
                        	**type**\:   :py:class:`GenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GenericTspec>`
                        
                        .. attribute:: gmpls_labels
                        
                        	GMPLS labels
                        	**type**\:   :py:class:`GmplsLabels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels>`
                        
                        .. attribute:: head_end_bfd_info
                        
                        	The Head\-end BFD info
                        	**type**\:   :py:class:`HeadEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.HeadEndBfdInfo>`
                        
                        .. attribute:: in_ero
                        
                        	Incoming ERO for this S2L
                        	**type**\: list of    :py:class:`InEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InEro>`
                        
                        .. attribute:: in_xro
                        
                        	Incoming XRO for this S2L
                        	**type**\:   :py:class:`InXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro>`
                        
                        .. attribute:: incoming_address
                        
                        	Incoming interface address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: incoming_address_generic
                        
                        	Incoming interface address
                        	**type**\:   :py:class:`IncomingAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.IncomingAddressGeneric>`
                        
                        .. attribute:: ingress_interface
                        
                        	Ingress Interface
                        	**type**\:  str
                        
                        .. attribute:: ingress_interface_brief
                        
                        	Ingress Interface in brief format
                        	**type**\:  str
                        
                        .. attribute:: ingress_interface_state
                        
                        	State of Incoming Interface
                        	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        .. attribute:: is_bandwidth_protect
                        
                        	BW Protection Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_expanded_ero
                        
                        	TRUE if this LSR expanded a loose path
                        	**type**\:  bool
                        
                        .. attribute:: is_frr_enabled
                        
                        	FRR Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_node_protected
                        
                        	Node Protection Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_optical
                        
                        	Is Optical
                        	**type**\:  bool
                        
                        .. attribute:: local_router_id
                        
                        	Local router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: lsp_wrap_info
                        
                        	Lsp Wrap  Related information
                        	**type**\:   :py:class:`LspWrapInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.LspWrapInfo>`
                        
                        .. attribute:: next_hop_address
                        
                        	Next hop address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: next_hop_address_generic
                        
                        	Next hop address
                        	**type**\:   :py:class:`NextHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.NextHopAddressGeneric>`
                        
                        .. attribute:: node_hop_count
                        
                        	Hop count
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        .. attribute:: otn_s2l
                        
                        	Otn S2L Information
                        	**type**\:   :py:class:`OtnS2L <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L>`
                        
                        .. attribute:: out_ero
                        
                        	Outgoing ERO for this S2L
                        	**type**\: list of    :py:class:`OutEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutEro>`
                        
                        .. attribute:: out_xro
                        
                        	Outgoing XRO for this S2L
                        	**type**\:   :py:class:`OutXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro>`
                        
                        .. attribute:: outbound_frr_state
                        
                        	Indicates outbound FRR state
                        	**type**\:   :py:class:`MplsTeFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrState>`
                        
                        .. attribute:: path_affinity_array
                        
                        	Tunnel's Path hops with affinity
                        	**type**\: list of    :py:class:`PathAffinityArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathAffinityArray>`
                        
                        .. attribute:: path_reeval_query_mid
                        
                        	Loose path reevaluation query received at mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: path_rro
                        
                        	Path RRO for this S2L
                        	**type**\: list of    :py:class:`PathRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro>`
                        
                        .. attribute:: path_rro_enabled
                        
                        	Path RRO Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: path_using_strict_spf
                        
                        	Path is using Strict SPF
                        	**type**\:  bool
                        
                        .. attribute:: pcalc_area
                        
                        	IGP\-area in which the S2L path was calculated
                        	**type**\:  str
                        
                        .. attribute:: previous_hop_address
                        
                        	Previous hop address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: previous_hop_address_generic
                        
                        	Previous hop address
                        	**type**\:   :py:class:`PreviousHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PreviousHopAddressGeneric>`
                        
                        .. attribute:: protection
                        
                        	Protection Object
                        	**type**\:   :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.Protection>`
                        
                        .. attribute:: resv_rro
                        
                        	Resv RRO for this S2L
                        	**type**\: list of    :py:class:`ResvRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro>`
                        
                        .. attribute:: reverse_ero_in
                        
                        	 Reverse Incoming ERO for this S2L
                        	**type**\: list of    :py:class:`ReverseEroIn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ReverseEroIn>`
                        
                        .. attribute:: reverse_lsp_connected
                        
                        	Reverse Associated Bidir LSP Connected
                        	**type**\:  bool
                        
                        .. attribute:: reverse_lsp_fec
                        
                        	Reverse Associated Bidir LSP FEC
                        	**type**\:   :py:class:`ReverseLspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ReverseLspFec>`
                        
                        .. attribute:: reverse_lsp_name
                        
                        	Reverse Associated Bidir LSP Name
                        	**type**\:  str
                        
                        .. attribute:: reverse_lsp_present
                        
                        	Reverse Associated Bidir LSP Present
                        	**type**\:  bool
                        
                        .. attribute:: reverse_tspec
                        
                        	The Reverse T spec info
                        	**type**\:   :py:class:`ReverseTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ReverseTspec>`
                        
                        .. attribute:: reverse_weight
                        
                        	The reverse path weight
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: role
                        
                        	Role of S2L
                        	**type**\:   :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        .. attribute:: s2l_convergence
                        
                        	TE LSP convergence related information
                        	**type**\:   :py:class:`S2LConvergence <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.S2LConvergence>`
                        
                        .. attribute:: s2l_fec
                        
                        	FEC for the S2L
                        	**type**\:   :py:class:`S2LFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.S2LFec>`
                        
                        .. attribute:: s2l_local_label
                        
                        	Local label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: s2l_out_label
                        
                        	Outgoing label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: s2l_reverse_ero_obj_present
                        
                        	 S2l Reverse ERO Object Present
                        	**type**\:  bool
                        
                        .. attribute:: s2l_reverse_lsp_sub_obj
                        
                        	Reverse LSP Sub Objects
                        	**type**\: list of    :py:class:`S2LReverseLspSubObj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.S2LReverseLspSubObj>`
                        
                        .. attribute:: s2l_reverse_tspec_obj_present
                        
                        	 S2L Reverse TSpec Object Present
                        	**type**\:  bool
                        
                        .. attribute:: s2l_segment_routing_path
                        
                        	Segment\-Routing S2L path info
                        	**type**\: list of    :py:class:`S2LSegmentRoutingPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.S2LSegmentRoutingPath>`
                        
                        .. attribute:: shared_risk_link_group
                        
                        	The S2L's excluded srlg groups
                        	**type**\: list of    :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.SharedRiskLinkGroup>`
                        
                        .. attribute:: signalling_status
                        
                        	Signaling status
                        	**type**\:   :py:class:`MplsTeTunnelsSignalingStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelsSignalingStatus>`
                        
                        .. attribute:: soft_preemption
                        
                        	The soft preemption info for this LSP
                        	**type**\:   :py:class:`SoftPreemption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.SoftPreemption>`
                        
                        .. attribute:: srlg_collection
                        
                        	SRLG\-collection data
                        	**type**\:   :py:class:`SrlgCollection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.SrlgCollection>`
                        
                        .. attribute:: tail_end_bfd_info
                        
                        	The Tail\-end BFD info
                        	**type**\:   :py:class:`TailEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.TailEndBfdInfo>`
                        
                        .. attribute:: time_since_last_preferred_path_exists_send_mid
                        
                        	Time since last preferred path exists msg send from mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: time_since_last_preferred_tree_exists_send_mid
                        
                        	Time since last preferred tree exists msg send from mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: time_since_last_query_received_mid
                        
                        	Time since last reevaluation query received at mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tspec
                        
                        	The T spec info
                        	**type**\:   :py:class:`Tspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.Tspec>`
                        
                        .. attribute:: upstream_router_id
                        
                        	Upstream router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: uptime
                        
                        	Time in seconds since the tunnel was up
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: weight
                        
                        	The path's weight
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L, self).__init__()

                            self.yang_name = "s2l"
                            self.yang_parent_name = "delay-clean-pp-lsp"

                            self.abr_auto_discovered = YLeaf(YType.str, "abr-auto-discovered")

                            self.backup_tunnel_interface = YLeaf(YType.str, "backup-tunnel-interface")

                            self.downstream_router_id = YLeaf(YType.str, "downstream-router-id")

                            self.egress_interface = YLeaf(YType.str, "egress-interface")

                            self.egress_interface_brief = YLeaf(YType.str, "egress-interface-brief")

                            self.egress_interface_state = YLeaf(YType.enumeration, "egress-interface-state")

                            self.expanded_ero_affinity_bits = YLeaf(YType.uint32, "expanded-ero-affinity-bits")

                            self.expanded_ero_affinity_mask = YLeaf(YType.uint32, "expanded-ero-affinity-mask")

                            self.expanded_ero_area_id = YLeaf(YType.str, "expanded-ero-area-id")

                            self.expanded_ero_metric = YLeaf(YType.uint32, "expanded-ero-metric")

                            self.expanded_ero_metric_type = YLeaf(YType.enumeration, "expanded-ero-metric-type")

                            self.frr_out_tunnel_interface = YLeaf(YType.str, "frr-out-tunnel-interface")

                            self.incoming_address = YLeaf(YType.str, "incoming-address")

                            self.ingress_interface = YLeaf(YType.str, "ingress-interface")

                            self.ingress_interface_brief = YLeaf(YType.str, "ingress-interface-brief")

                            self.ingress_interface_state = YLeaf(YType.enumeration, "ingress-interface-state")

                            self.is_bandwidth_protect = YLeaf(YType.boolean, "is-bandwidth-protect")

                            self.is_expanded_ero = YLeaf(YType.boolean, "is-expanded-ero")

                            self.is_frr_enabled = YLeaf(YType.boolean, "is-frr-enabled")

                            self.is_node_protected = YLeaf(YType.boolean, "is-node-protected")

                            self.is_optical = YLeaf(YType.boolean, "is-optical")

                            self.local_router_id = YLeaf(YType.str, "local-router-id")

                            self.next_hop_address = YLeaf(YType.str, "next-hop-address")

                            self.node_hop_count = YLeaf(YType.uint8, "node-hop-count")

                            self.outbound_frr_state = YLeaf(YType.enumeration, "outbound-frr-state")

                            self.path_reeval_query_mid = YLeaf(YType.uint32, "path-reeval-query-mid")

                            self.path_rro_enabled = YLeaf(YType.boolean, "path-rro-enabled")

                            self.path_using_strict_spf = YLeaf(YType.boolean, "path-using-strict-spf")

                            self.pcalc_area = YLeaf(YType.str, "pcalc-area")

                            self.previous_hop_address = YLeaf(YType.str, "previous-hop-address")

                            self.reverse_lsp_connected = YLeaf(YType.boolean, "reverse-lsp-connected")

                            self.reverse_lsp_name = YLeaf(YType.str, "reverse-lsp-name")

                            self.reverse_lsp_present = YLeaf(YType.boolean, "reverse-lsp-present")

                            self.reverse_weight = YLeaf(YType.uint64, "reverse-weight")

                            self.role = YLeaf(YType.enumeration, "role")

                            self.s2l_local_label = YLeaf(YType.uint32, "s2l-local-label")

                            self.s2l_out_label = YLeaf(YType.uint32, "s2l-out-label")

                            self.s2l_reverse_ero_obj_present = YLeaf(YType.boolean, "s2l-reverse-ero-obj-present")

                            self.s2l_reverse_tspec_obj_present = YLeaf(YType.boolean, "s2l-reverse-tspec-obj-present")

                            self.signalling_status = YLeaf(YType.enumeration, "signalling-status")

                            self.time_since_last_preferred_path_exists_send_mid = YLeaf(YType.uint32, "time-since-last-preferred-path-exists-send-mid")

                            self.time_since_last_preferred_tree_exists_send_mid = YLeaf(YType.uint32, "time-since-last-preferred-tree-exists-send-mid")

                            self.time_since_last_query_received_mid = YLeaf(YType.uint32, "time-since-last-query-received-mid")

                            self.upstream_router_id = YLeaf(YType.str, "upstream-router-id")

                            self.uptime = YLeaf(YType.uint32, "uptime")

                            self.weight = YLeaf(YType.uint64, "weight")

                            self.active_path_option = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption()
                            self.active_path_option.parent = self
                            self._children_name_map["active_path_option"] = "active-path-option"
                            self._children_yang_names.add("active-path-option")

                            self.association = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.Association()
                            self.association.parent = self
                            self._children_name_map["association"] = "association"
                            self._children_yang_names.add("association")

                            self.diversity_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.DiversityInfo()
                            self.diversity_info.parent = self
                            self._children_name_map["diversity_info"] = "diversity-info"
                            self._children_yang_names.add("diversity-info")

                            self.flex_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.FlexInfo()
                            self.flex_info.parent = self
                            self._children_name_map["flex_info"] = "flex-info"
                            self._children_yang_names.add("flex-info")

                            self.fspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.Fspec()
                            self.fspec.parent = self
                            self._children_name_map["fspec"] = "fspec"
                            self._children_yang_names.add("fspec")

                            self.generic_fspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GenericFspec()
                            self.generic_fspec.parent = self
                            self._children_name_map["generic_fspec"] = "generic-fspec"
                            self._children_yang_names.add("generic-fspec")

                            self.generic_tspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GenericTspec()
                            self.generic_tspec.parent = self
                            self._children_name_map["generic_tspec"] = "generic-tspec"
                            self._children_yang_names.add("generic-tspec")

                            self.gmpls_labels = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels()
                            self.gmpls_labels.parent = self
                            self._children_name_map["gmpls_labels"] = "gmpls-labels"
                            self._children_yang_names.add("gmpls-labels")

                            self.head_end_bfd_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.HeadEndBfdInfo()
                            self.head_end_bfd_info.parent = self
                            self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"
                            self._children_yang_names.add("head-end-bfd-info")

                            self.in_xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro()
                            self.in_xro.parent = self
                            self._children_name_map["in_xro"] = "in-xro"
                            self._children_yang_names.add("in-xro")

                            self.incoming_address_generic = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.IncomingAddressGeneric()
                            self.incoming_address_generic.parent = self
                            self._children_name_map["incoming_address_generic"] = "incoming-address-generic"
                            self._children_yang_names.add("incoming-address-generic")

                            self.lsp_wrap_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.LspWrapInfo()
                            self.lsp_wrap_info.parent = self
                            self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"
                            self._children_yang_names.add("lsp-wrap-info")

                            self.next_hop_address_generic = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.NextHopAddressGeneric()
                            self.next_hop_address_generic.parent = self
                            self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"
                            self._children_yang_names.add("next-hop-address-generic")

                            self.otn_s2l = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L()
                            self.otn_s2l.parent = self
                            self._children_name_map["otn_s2l"] = "otn-s2l"
                            self._children_yang_names.add("otn-s2l")

                            self.out_xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro()
                            self.out_xro.parent = self
                            self._children_name_map["out_xro"] = "out-xro"
                            self._children_yang_names.add("out-xro")

                            self.previous_hop_address_generic = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PreviousHopAddressGeneric()
                            self.previous_hop_address_generic.parent = self
                            self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"
                            self._children_yang_names.add("previous-hop-address-generic")

                            self.protection = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.Protection()
                            self.protection.parent = self
                            self._children_name_map["protection"] = "protection"
                            self._children_yang_names.add("protection")

                            self.reverse_lsp_fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ReverseLspFec()
                            self.reverse_lsp_fec.parent = self
                            self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"
                            self._children_yang_names.add("reverse-lsp-fec")

                            self.reverse_tspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ReverseTspec()
                            self.reverse_tspec.parent = self
                            self._children_name_map["reverse_tspec"] = "reverse-tspec"
                            self._children_yang_names.add("reverse-tspec")

                            self.s2l_convergence = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.S2LConvergence()
                            self.s2l_convergence.parent = self
                            self._children_name_map["s2l_convergence"] = "s2l-convergence"
                            self._children_yang_names.add("s2l-convergence")

                            self.s2l_fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.S2LFec()
                            self.s2l_fec.parent = self
                            self._children_name_map["s2l_fec"] = "s2l-fec"
                            self._children_yang_names.add("s2l-fec")

                            self.soft_preemption = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.SoftPreemption()
                            self.soft_preemption.parent = self
                            self._children_name_map["soft_preemption"] = "soft-preemption"
                            self._children_yang_names.add("soft-preemption")

                            self.srlg_collection = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.SrlgCollection()
                            self.srlg_collection.parent = self
                            self._children_name_map["srlg_collection"] = "srlg-collection"
                            self._children_yang_names.add("srlg-collection")

                            self.tail_end_bfd_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.TailEndBfdInfo()
                            self.tail_end_bfd_info.parent = self
                            self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"
                            self._children_yang_names.add("tail-end-bfd-info")

                            self.tspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.Tspec()
                            self.tspec.parent = self
                            self._children_name_map["tspec"] = "tspec"
                            self._children_yang_names.add("tspec")

                            self.in_ero = YList(self)
                            self.out_ero = YList(self)
                            self.path_affinity_array = YList(self)
                            self.path_rro = YList(self)
                            self.resv_rro = YList(self)
                            self.reverse_ero_in = YList(self)
                            self.s2l_reverse_lsp_sub_obj = YList(self)
                            self.s2l_segment_routing_path = YList(self)
                            self.shared_risk_link_group = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("abr_auto_discovered",
                                            "backup_tunnel_interface",
                                            "downstream_router_id",
                                            "egress_interface",
                                            "egress_interface_brief",
                                            "egress_interface_state",
                                            "expanded_ero_affinity_bits",
                                            "expanded_ero_affinity_mask",
                                            "expanded_ero_area_id",
                                            "expanded_ero_metric",
                                            "expanded_ero_metric_type",
                                            "frr_out_tunnel_interface",
                                            "incoming_address",
                                            "ingress_interface",
                                            "ingress_interface_brief",
                                            "ingress_interface_state",
                                            "is_bandwidth_protect",
                                            "is_expanded_ero",
                                            "is_frr_enabled",
                                            "is_node_protected",
                                            "is_optical",
                                            "local_router_id",
                                            "next_hop_address",
                                            "node_hop_count",
                                            "outbound_frr_state",
                                            "path_reeval_query_mid",
                                            "path_rro_enabled",
                                            "path_using_strict_spf",
                                            "pcalc_area",
                                            "previous_hop_address",
                                            "reverse_lsp_connected",
                                            "reverse_lsp_name",
                                            "reverse_lsp_present",
                                            "reverse_weight",
                                            "role",
                                            "s2l_local_label",
                                            "s2l_out_label",
                                            "s2l_reverse_ero_obj_present",
                                            "s2l_reverse_tspec_obj_present",
                                            "signalling_status",
                                            "time_since_last_preferred_path_exists_send_mid",
                                            "time_since_last_preferred_tree_exists_send_mid",
                                            "time_since_last_query_received_mid",
                                            "upstream_router_id",
                                            "uptime",
                                            "weight") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L, self).__setattr__(name, value)


                        class S2LFec(Entity):
                            """
                            FEC for the S2L
                            
                            .. attribute:: s2l_fec_ctype
                            
                            	Session identifier (ctype)
                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            .. attribute:: s2l_fec_dest
                            
                            	sub\-LSP destination address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_lsp_id
                            
                            	LSP ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_p2mp_id
                            
                            	P2MP ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: s2l_fec_source
                            
                            	LSP source address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_subgroup_id
                            
                            	sub\-LSP subgroup ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_subgroup_originator
                            
                            	Subgroup Originator
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.S2LFec, self).__init__()

                                self.yang_name = "s2l-fec"
                                self.yang_parent_name = "s2l"

                                self.s2l_fec_ctype = YLeaf(YType.enumeration, "s2l-fec-ctype")

                                self.s2l_fec_dest = YLeaf(YType.str, "s2l-fec-dest")

                                self.s2l_fec_extended_tunnel_id = YLeaf(YType.str, "s2l-fec-extended-tunnel-id")

                                self.s2l_fec_lsp_id = YLeaf(YType.uint16, "s2l-fec-lsp-id")

                                self.s2l_fec_p2mp_id = YLeaf(YType.uint32, "s2l-fec-p2mp-id")

                                self.s2l_fec_source = YLeaf(YType.str, "s2l-fec-source")

                                self.s2l_fec_subgroup_id = YLeaf(YType.uint16, "s2l-fec-subgroup-id")

                                self.s2l_fec_subgroup_originator = YLeaf(YType.str, "s2l-fec-subgroup-originator")

                                self.s2l_fec_tunnel_id = YLeaf(YType.uint16, "s2l-fec-tunnel-id")

                                self.s2l_fec_vrf = YLeaf(YType.str, "s2l-fec-vrf")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("s2l_fec_ctype",
                                                "s2l_fec_dest",
                                                "s2l_fec_extended_tunnel_id",
                                                "s2l_fec_lsp_id",
                                                "s2l_fec_p2mp_id",
                                                "s2l_fec_source",
                                                "s2l_fec_subgroup_id",
                                                "s2l_fec_subgroup_originator",
                                                "s2l_fec_tunnel_id",
                                                "s2l_fec_vrf") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.S2LFec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.S2LFec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.s2l_fec_ctype.is_set or
                                    self.s2l_fec_dest.is_set or
                                    self.s2l_fec_extended_tunnel_id.is_set or
                                    self.s2l_fec_lsp_id.is_set or
                                    self.s2l_fec_p2mp_id.is_set or
                                    self.s2l_fec_source.is_set or
                                    self.s2l_fec_subgroup_id.is_set or
                                    self.s2l_fec_subgroup_originator.is_set or
                                    self.s2l_fec_tunnel_id.is_set or
                                    self.s2l_fec_vrf.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.s2l_fec_ctype.yfilter != YFilter.not_set or
                                    self.s2l_fec_dest.yfilter != YFilter.not_set or
                                    self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_lsp_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_p2mp_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_source.yfilter != YFilter.not_set or
                                    self.s2l_fec_subgroup_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set or
                                    self.s2l_fec_tunnel_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_vrf.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-fec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.s2l_fec_ctype.is_set or self.s2l_fec_ctype.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_ctype.get_name_leafdata())
                                if (self.s2l_fec_dest.is_set or self.s2l_fec_dest.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_dest.get_name_leafdata())
                                if (self.s2l_fec_extended_tunnel_id.is_set or self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_extended_tunnel_id.get_name_leafdata())
                                if (self.s2l_fec_lsp_id.is_set or self.s2l_fec_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_lsp_id.get_name_leafdata())
                                if (self.s2l_fec_p2mp_id.is_set or self.s2l_fec_p2mp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_p2mp_id.get_name_leafdata())
                                if (self.s2l_fec_source.is_set or self.s2l_fec_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_source.get_name_leafdata())
                                if (self.s2l_fec_subgroup_id.is_set or self.s2l_fec_subgroup_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_subgroup_id.get_name_leafdata())
                                if (self.s2l_fec_subgroup_originator.is_set or self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_subgroup_originator.get_name_leafdata())
                                if (self.s2l_fec_tunnel_id.is_set or self.s2l_fec_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_tunnel_id.get_name_leafdata())
                                if (self.s2l_fec_vrf.is_set or self.s2l_fec_vrf.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_vrf.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "s2l-fec-ctype" or name == "s2l-fec-dest" or name == "s2l-fec-extended-tunnel-id" or name == "s2l-fec-lsp-id" or name == "s2l-fec-p2mp-id" or name == "s2l-fec-source" or name == "s2l-fec-subgroup-id" or name == "s2l-fec-subgroup-originator" or name == "s2l-fec-tunnel-id" or name == "s2l-fec-vrf"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "s2l-fec-ctype"):
                                    self.s2l_fec_ctype = value
                                    self.s2l_fec_ctype.value_namespace = name_space
                                    self.s2l_fec_ctype.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-dest"):
                                    self.s2l_fec_dest = value
                                    self.s2l_fec_dest.value_namespace = name_space
                                    self.s2l_fec_dest.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-extended-tunnel-id"):
                                    self.s2l_fec_extended_tunnel_id = value
                                    self.s2l_fec_extended_tunnel_id.value_namespace = name_space
                                    self.s2l_fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-lsp-id"):
                                    self.s2l_fec_lsp_id = value
                                    self.s2l_fec_lsp_id.value_namespace = name_space
                                    self.s2l_fec_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-p2mp-id"):
                                    self.s2l_fec_p2mp_id = value
                                    self.s2l_fec_p2mp_id.value_namespace = name_space
                                    self.s2l_fec_p2mp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-source"):
                                    self.s2l_fec_source = value
                                    self.s2l_fec_source.value_namespace = name_space
                                    self.s2l_fec_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-subgroup-id"):
                                    self.s2l_fec_subgroup_id = value
                                    self.s2l_fec_subgroup_id.value_namespace = name_space
                                    self.s2l_fec_subgroup_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-subgroup-originator"):
                                    self.s2l_fec_subgroup_originator = value
                                    self.s2l_fec_subgroup_originator.value_namespace = name_space
                                    self.s2l_fec_subgroup_originator.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-tunnel-id"):
                                    self.s2l_fec_tunnel_id = value
                                    self.s2l_fec_tunnel_id.value_namespace = name_space
                                    self.s2l_fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-vrf"):
                                    self.s2l_fec_vrf = value
                                    self.s2l_fec_vrf.value_namespace = name_space
                                    self.s2l_fec_vrf.value_namespace_prefix = name_space_prefix


                        class ActivePathOption(Entity):
                            """
                            The path option used to find the path for this
                            S2L
                            
                            .. attribute:: attribute_set
                            
                            	The path option attribute set used by this path
                            	**type**\:   :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet>`
                            
                            .. attribute:: attribute_set_found
                            
                            	TRUE if the path has found the defined attribute set
                            	**type**\:  bool
                            
                            .. attribute:: explicit_path_id
                            
                            	Explicit Path ID, this is the key to table ExplicitPaths.IdentifierTable
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: explicit_path_name
                            
                            	Explicit Path Name, this is the key to table ExplicitPaths.NameTable
                            	**type**\:  str
                            
                            .. attribute:: has_attribute_set
                            
                            	TRUE if the path has an attribute set defined
                            	**type**\:  bool
                            
                            .. attribute:: has_xro_attribute_set
                            
                            	TRUE if the path has an XRO attribute set configured
                            	**type**\:  bool
                            
                            .. attribute:: holddown_duration
                            
                            	Holddown Duration (seconds)
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            	**units**\: second
                            
                            .. attribute:: is_disabled
                            
                            	TRUE if the path option is disabled
                            	**type**\:  bool
                            
                            .. attribute:: is_helddown
                            
                            	TRUE if path is helddown
                            	**type**\:  bool
                            
                            .. attribute:: is_lockdown
                            
                            	TRUE if the path is locked down
                            	**type**\:  bool
                            
                            .. attribute:: is_segment_routing
                            
                            	TRUE if the path is Segment\-Routing
                            	**type**\:  bool
                            
                            .. attribute:: is_strict_explicit_path
                            
                            	TRUE if explicit path is strict
                            	**type**\:  bool
                            
                            .. attribute:: is_verbatim
                            
                            	TRUE if the path is verbatim
                            	**type**\:  bool
                            
                            .. attribute:: option_index
                            
                            	Path option index
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: option_index_is_valid
                            
                            	The path option index is valid
                            	**type**\:  bool
                            
                            .. attribute:: path_calculation_error
                            
                            	Path computation information
                            	**type**\: list of    :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.PathCalculationError>`
                            
                            .. attribute:: path_option_area_id
                            
                            	The path\-option area constraint
                            	**type**\:  str
                            
                            .. attribute:: path_option_name
                            
                            	Path option name
                            	**type**\:  str
                            
                            .. attribute:: path_option_type
                            
                            	Path option type
                            	**type**\:   :py:class:`MplsTePathoption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathoption>`
                            
                            .. attribute:: pce_address
                            
                            	PCE server address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: protected_by_path_option_index
                            
                            	Path option index for Protect path options
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: remerge_error
                            
                            	Path computation remerge resolve info
                            	**type**\: list of    :py:class:`RemergeError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.RemergeError>`
                            
                            .. attribute:: restored_from_path_option_index
                            
                            	Path option index for Restore path options
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: signalling_error
                            
                            	Signalling information
                            	**type**\: list of    :py:class:`SignallingError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.SignallingError>`
                            
                            .. attribute:: xro_attribute_set
                            
                            	The XRO attribute set used by this path\-option
                            	**type**\:   :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet>`
                            
                            .. attribute:: xro_attribute_set_found
                            
                            	TRUE if the path's XRO attribute set is known
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption, self).__init__()

                                self.yang_name = "active-path-option"
                                self.yang_parent_name = "s2l"

                                self.attribute_set_found = YLeaf(YType.boolean, "attribute-set-found")

                                self.explicit_path_id = YLeaf(YType.uint16, "explicit-path-id")

                                self.explicit_path_name = YLeaf(YType.str, "explicit-path-name")

                                self.has_attribute_set = YLeaf(YType.boolean, "has-attribute-set")

                                self.has_xro_attribute_set = YLeaf(YType.boolean, "has-xro-attribute-set")

                                self.holddown_duration = YLeaf(YType.uint16, "holddown-duration")

                                self.is_disabled = YLeaf(YType.boolean, "is-disabled")

                                self.is_helddown = YLeaf(YType.boolean, "is-helddown")

                                self.is_lockdown = YLeaf(YType.boolean, "is-lockdown")

                                self.is_segment_routing = YLeaf(YType.boolean, "is-segment-routing")

                                self.is_strict_explicit_path = YLeaf(YType.boolean, "is-strict-explicit-path")

                                self.is_verbatim = YLeaf(YType.boolean, "is-verbatim")

                                self.option_index = YLeaf(YType.uint32, "option-index")

                                self.option_index_is_valid = YLeaf(YType.boolean, "option-index-is-valid")

                                self.path_option_area_id = YLeaf(YType.str, "path-option-area-id")

                                self.path_option_name = YLeaf(YType.str, "path-option-name")

                                self.path_option_type = YLeaf(YType.enumeration, "path-option-type")

                                self.pce_address = YLeaf(YType.str, "pce-address")

                                self.protected_by_path_option_index = YLeaf(YType.uint32, "protected-by-path-option-index")

                                self.restored_from_path_option_index = YLeaf(YType.uint32, "restored-from-path-option-index")

                                self.xro_attribute_set_found = YLeaf(YType.boolean, "xro-attribute-set-found")

                                self.attribute_set = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet()
                                self.attribute_set.parent = self
                                self._children_name_map["attribute_set"] = "attribute-set"
                                self._children_yang_names.add("attribute-set")

                                self.xro_attribute_set = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet()
                                self.xro_attribute_set.parent = self
                                self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                                self._children_yang_names.add("xro-attribute-set")

                                self.path_calculation_error = YList(self)
                                self.remerge_error = YList(self)
                                self.signalling_error = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("attribute_set_found",
                                                "explicit_path_id",
                                                "explicit_path_name",
                                                "has_attribute_set",
                                                "has_xro_attribute_set",
                                                "holddown_duration",
                                                "is_disabled",
                                                "is_helddown",
                                                "is_lockdown",
                                                "is_segment_routing",
                                                "is_strict_explicit_path",
                                                "is_verbatim",
                                                "option_index",
                                                "option_index_is_valid",
                                                "path_option_area_id",
                                                "path_option_name",
                                                "path_option_type",
                                                "pce_address",
                                                "protected_by_path_option_index",
                                                "restored_from_path_option_index",
                                                "xro_attribute_set_found") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption, self).__setattr__(name, value)


                            class AttributeSet(Entity):
                                """
                                The path option attribute set used by this path
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion>`
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\:  str
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet, self).__init__()

                                    self.yang_name = "attribute-set"
                                    self.yang_parent_name = "active-path-option"

                                    self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                                    self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                                    self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._children_yang_names.add("attribute-set-union")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("tunnel_attribute_set_name",
                                                    "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet, self).__setattr__(name, value)


                                class AttributeSetUnion(Entity):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "attribute-set"

                                        self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                                        self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                        self._children_yang_names.add("attribute-set-aps-pp")

                                        self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                        self._children_yang_names.add("attribute-set-autobackup")

                                        self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                        self._children_yang_names.add("attribute-set-automesh")

                                        self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                        self._children_yang_names.add("attribute-set-p2mpte")

                                        self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._children_yang_names.add("attribute-set-p2p-te")

                                        self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                        self._children_yang_names.add("attribute-set-path-option")

                                        self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                        self._children_yang_names.add("attribute-set-xro")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                                    class AttributeSetPathOption(Entity):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\:  str
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                            self.generation = YLeaf(YType.uint32, "generation")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                            self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                            self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                            self._children_yang_names.add("bfd-reverse-path")

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bandwidth_type",
                                                            "configured_bandwidth",
                                                            "cost_limit",
                                                            "dste_class_type",
                                                            "exclude_list_name",
                                                            "generation",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_bfd_reverse_pat_configured",
                                                            "is_cost_limit_configured",
                                                            "is_exclude_list_name_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "path_invalidation_action",
                                                            "path_invalidation_timeout",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class BfdReversePath(Entity):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.binding_label = YLeaf(YType.uint32, "binding-label")

                                                self.path_type = YLeaf(YType.enumeration, "path-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("binding_label",
                                                                "path_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.binding_label.is_set or
                                                    self.path_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.binding_label.yfilter != YFilter.not_set or
                                                    self.path_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "bfd-reverse-path" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.binding_label.get_name_leafdata())
                                                if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.path_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "binding-label" or name == "path-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "binding-label"):
                                                    self.binding_label = value
                                                    self.binding_label.value_namespace = name_space
                                                    self.binding_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "path-type"):
                                                    self.path_type = value
                                                    self.path_type.value_namespace = name_space
                                                    self.path_type.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class VersionInfo(Entity):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\:  str
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.attribute_type = YLeaf(YType.str, "attribute-type")

                                                self.generation = YLeaf(YType.uint32, "generation")

                                                self.is_default = YLeaf(YType.boolean, "is-default")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("attribute_type",
                                                                "generation",
                                                                "is_default") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.attribute_type.is_set or
                                                    self.generation.is_set or
                                                    self.is_default.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.attribute_type.yfilter != YFilter.not_set or
                                                    self.generation.yfilter != YFilter.not_set or
                                                    self.is_default.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "version-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                                if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.generation.get_name_leafdata())
                                                if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_default.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "attribute-type"):
                                                    self.attribute_type = value
                                                    self.attribute_type.value_namespace = name_space
                                                    self.attribute_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "generation"):
                                                    self.generation = value
                                                    self.generation.value_namespace = name_space
                                                    self.generation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-default"):
                                                    self.is_default = value
                                                    self.is_default.value_namespace = name_space
                                                    self.is_default.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.bandwidth_type.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.cost_limit.is_set or
                                                self.dste_class_type.is_set or
                                                self.exclude_list_name.is_set or
                                                self.generation.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_bfd_reverse_pat_configured.is_set or
                                                self.is_cost_limit_configured.is_set or
                                                self.is_exclude_list_name_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.path_invalidation_action.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bandwidth_type.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.cost_limit.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.exclude_list_name.yfilter != YFilter.not_set or
                                                self.generation.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                                self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                                self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-path-option" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.generation.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                            if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                            if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "bfd-reverse-path"):
                                                if (self.bfd_reverse_path is None):
                                                    self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                                    self.bfd_reverse_path.parent = self
                                                    self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                                return self.bfd_reverse_path

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            if (child_yang_name == "version-info"):
                                                for c in self.version_info:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.version_info.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bandwidth-type"):
                                                self.bandwidth_type = value
                                                self.bandwidth_type.value_namespace = name_space
                                                self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "cost-limit"):
                                                self.cost_limit = value
                                                self.cost_limit.value_namespace = name_space
                                                self.cost_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exclude-list-name"):
                                                self.exclude_list_name = value
                                                self.exclude_list_name.value_namespace = name_space
                                                self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "generation"):
                                                self.generation = value
                                                self.generation.value_namespace = name_space
                                                self.generation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bfd-reverse-pat-configured"):
                                                self.is_bfd_reverse_pat_configured = value
                                                self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                                self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-cost-limit-configured"):
                                                self.is_cost_limit_configured = value
                                                self.is_cost_limit_configured.value_namespace = name_space
                                                self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-exclude-list-name-configured"):
                                                self.is_exclude_list_name_configured = value
                                                self.is_exclude_list_name_configured.value_namespace = name_space
                                                self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-action"):
                                                self.path_invalidation_action = value
                                                self.path_invalidation_action.value_namespace = name_space
                                                self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutobackup(Entity):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.signalled_name = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"
                                            self._children_yang_names.add("signalled-name")

                                            self.policy_class_entry = YList(self)
                                            self.protected_interface = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_priority",
                                                            "is_affinity_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "is_signalled_name_configured",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                                        class SignalledName(Entity):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\:  bool
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\:  str
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                                self.name = YLeaf(YType.str, "name")

                                                self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                                self.source_type = YLeaf(YType.enumeration, "source-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("is_mp_addresses",
                                                                "name",
                                                                "protected_interface_type",
                                                                "source_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.is_mp_addresses.is_set or
                                                    self.name.is_set or
                                                    self.protected_interface_type.is_set or
                                                    self.source_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.is_mp_addresses.yfilter != YFilter.not_set or
                                                    self.name.yfilter != YFilter.not_set or
                                                    self.protected_interface_type.yfilter != YFilter.not_set or
                                                    self.source_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "signalled-name" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.name.get_name_leafdata())
                                                if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                                if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.source_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "is-mp-addresses"):
                                                    self.is_mp_addresses = value
                                                    self.is_mp_addresses.value_namespace = name_space
                                                    self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                                if(value_path == "name"):
                                                    self.name = value
                                                    self.name.value_namespace = name_space
                                                    self.name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "protected-interface-type"):
                                                    self.protected_interface_type = value
                                                    self.protected_interface_type.value_namespace = name_space
                                                    self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "source-type"):
                                                    self.source_type = value
                                                    self.source_type.value_namespace = name_space
                                                    self.source_type.value_namespace_prefix = name_space_prefix


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class ProtectedInterface(Entity):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.protected_interface = YLeaf(YType.str, "protected-interface")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("protected_interface") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.protected_interface.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.protected_interface.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "protected-interface" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "protected-interface"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "protected-interface"):
                                                    self.protected_interface = value
                                                    self.protected_interface.value_namespace = name_space
                                                    self.protected_interface.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.is_signalled_name_configured.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.signalled_name is not None and self.signalled_name.has_data()))

                                        def has_operation(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.signalled_name is not None and self.signalled_name.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-autobackup" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "protected-interface"):
                                                for c in self.protected_interface:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.protected_interface.append(c)
                                                return c

                                            if (child_yang_name == "signalled-name"):
                                                if (self.signalled_name is None):
                                                    self.signalled_name = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                                    self.signalled_name.parent = self
                                                    self._children_name_map["signalled_name"] = "signalled-name"
                                                return self.signalled_name

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-signalled-name-configured"):
                                                self.is_signalled_name_configured = value
                                                self.is_signalled_name_configured.value_namespace = name_space
                                                self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutomesh(Entity):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\:  bool
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\:  bool
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                            self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                            self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.forward_class = YLeaf(YType.uint32, "forward-class")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.load_share = YLeaf(YType.uint32, "load-share")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.mesh_group_id = YList(self)
                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("auto_bandwidth_collect",
                                                            "auto_route_announce",
                                                            "bandwidth",
                                                            "configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "forward_class",
                                                            "frr_bandwidth_protection",
                                                            "frr_node_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_interface_bw_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "load_share",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority",
                                                            "soft_preemption_configured") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class MeshGroupId(Entity):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint32, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "mesh-group-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.auto_bandwidth_collect.is_set or
                                                self.auto_route_announce.is_set or
                                                self.bandwidth.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.forward_class.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.frr_node_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_interface_bw_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.load_share.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                self.soft_preemption_configured.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()))

                                        def has_operation(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                                self.auto_route_announce.yfilter != YFilter.not_set or
                                                self.bandwidth.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.forward_class.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.frr_node_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.load_share.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                self.soft_preemption_configured.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-automesh" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                            if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                            if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.forward_class.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.load_share.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                            if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "mesh-group-id"):
                                                for c in self.mesh_group_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.mesh_group_id.append(c)
                                                return c

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "auto-bandwidth-collect"):
                                                self.auto_bandwidth_collect = value
                                                self.auto_bandwidth_collect.value_namespace = name_space
                                                self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                            if(value_path == "auto-route-announce"):
                                                self.auto_route_announce = value
                                                self.auto_route_announce.value_namespace = name_space
                                                self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                            if(value_path == "bandwidth"):
                                                self.bandwidth = value
                                                self.bandwidth.value_namespace = name_space
                                                self.bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "forward-class"):
                                                self.forward_class = value
                                                self.forward_class.value_namespace = name_space
                                                self.forward_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-node-protection"):
                                                self.frr_node_protection = value
                                                self.frr_node_protection.value_namespace = name_space
                                                self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-interface-bw-configured"):
                                                self.is_interface_bw_configured = value
                                                self.is_interface_bw_configured.value_namespace = name_space
                                                self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "load-share"):
                                                self.load_share = value
                                                self.load_share.value_namespace = name_space
                                                self.load_share.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "soft-preemption-configured"):
                                                self.soft_preemption_configured = value
                                                self.soft_preemption_configured.value_namespace = name_space
                                                self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                                    class AttributeSetXro(Entity):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._children_yang_names.add("xro")


                                        class Xro(Entity):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\:  bool
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"

                                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                                self.xro_subobject = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                            class XroSubobject(Entity):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                    self.as_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"
                                                    self._children_yang_names.add("as-subobject")

                                                    self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                    self._children_yang_names.add("ipv4-subobject")

                                                    self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                    self._children_yang_names.add("ipv6-subobject")

                                                    self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._children_yang_names.add("lsp-subobject")

                                                    self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                    self._children_yang_names.add("srlg-subobject")

                                                    self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                    self._children_yang_names.add("unnumbered-subobject")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                                class Ipv4Subobject(Entity):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv4-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class Ipv6Subobject(Entity):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv6-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class UnnumberedSubobject(Entity):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("attribute",
                                                                        "exclusion_type",
                                                                        "interface_id",
                                                                        "te_router_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.interface_id.is_set or
                                                            self.te_router_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.interface_id.yfilter != YFilter.not_set or
                                                            self.te_router_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "unnumbered-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "interface-id"):
                                                            self.interface_id = value
                                                            self.interface_id.value_namespace = name_space
                                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "te-router-id"):
                                                            self.te_router_id = value
                                                            self.te_router_id.value_namespace = name_space
                                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                                class AsSubobject(Entity):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("as_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.as_number.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.as_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "as-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "as-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "as-number"):
                                                            self.as_number = value
                                                            self.as_number.value_namespace = name_space
                                                            self.as_number.value_namespace_prefix = name_space_prefix


                                                class SrlgSubobject(Entity):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("exclusion_type",
                                                                        "srlg_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.exclusion_type.is_set or
                                                            self.srlg_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.srlg_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "srlg-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "exclusion-type" or name == "srlg-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "srlg-id"):
                                                            self.srlg_id = value
                                                            self.srlg_id.value_namespace = name_space
                                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                                class LspSubobject(Entity):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                                        self.fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._children_yang_names.add("fec")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("destination_node_exception",
                                                                        "exclusion_type",
                                                                        "ignore_lsp_id",
                                                                        "penultimate_node_exception",
                                                                        "processing_node_exception") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                                    class Fec(Entity):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\:  str
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"

                                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                            self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._children_yang_names.add("fec-destination-info")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("fec_extended_tunnel_id",
                                                                            "fec_lsp_id",
                                                                            "fec_source",
                                                                            "fec_tunnel_id",
                                                                            "fec_vrf") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                                        class FecDestinationInfo(Entity):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\:  str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"

                                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("fec_ctype",
                                                                                "fec_destination_p2mp_id",
                                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.fec_ctype.is_set or
                                                                    self.fec_destination_p2mp_id.is_set or
                                                                    self.p2p_lsp_destination.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "fec-destination-info" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "fec-ctype"):
                                                                    self.fec_ctype = value
                                                                    self.fec_ctype.value_namespace = name_space
                                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "fec-destination-p2mp-id"):
                                                                    self.fec_destination_p2mp_id = value
                                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "p2p-lsp-destination"):
                                                                    self.p2p_lsp_destination = value
                                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.fec_extended_tunnel_id.is_set or
                                                                self.fec_lsp_id.is_set or
                                                                self.fec_source.is_set or
                                                                self.fec_tunnel_id.is_set or
                                                                self.fec_vrf.is_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                                self.fec_source.yfilter != YFilter.not_set or
                                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "fec" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "fec-destination-info"):
                                                                if (self.fec_destination_info is None):
                                                                    self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                                    self.fec_destination_info.parent = self
                                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                                return self.fec_destination_info

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "fec-extended-tunnel-id"):
                                                                self.fec_extended_tunnel_id = value
                                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-lsp-id"):
                                                                self.fec_lsp_id = value
                                                                self.fec_lsp_id.value_namespace = name_space
                                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-source"):
                                                                self.fec_source = value
                                                                self.fec_source.value_namespace = name_space
                                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-tunnel-id"):
                                                                self.fec_tunnel_id = value
                                                                self.fec_tunnel_id.value_namespace = name_space
                                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-vrf"):
                                                                self.fec_vrf = value
                                                                self.fec_vrf.value_namespace = name_space
                                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.destination_node_exception.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.ignore_lsp_id.is_set or
                                                            self.penultimate_node_exception.is_set or
                                                            self.processing_node_exception.is_set or
                                                            (self.fec is not None and self.fec.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                                            (self.fec is not None and self.fec.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsp-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "fec"):
                                                            if (self.fec is None):
                                                                self.fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                                self.fec.parent = self
                                                                self._children_name_map["fec"] = "fec"
                                                            return self.fec

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "destination-node-exception"):
                                                            self.destination_node_exception = value
                                                            self.destination_node_exception.value_namespace = name_space
                                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ignore-lsp-id"):
                                                            self.ignore_lsp_id = value
                                                            self.ignore_lsp_id.value_namespace = name_space
                                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "penultimate-node-exception"):
                                                            self.penultimate_node_exception = value
                                                            self.penultimate_node_exception.value_namespace = name_space
                                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "processing-node-exception"):
                                                            self.processing_node_exception = value
                                                            self.processing_node_exception.value_namespace = name_space
                                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.type.is_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "xro-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "as-subobject"):
                                                        if (self.as_subobject is None):
                                                            self.as_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                            self.as_subobject.parent = self
                                                            self._children_name_map["as_subobject"] = "as-subobject"
                                                        return self.as_subobject

                                                    if (child_yang_name == "ipv4-subobject"):
                                                        if (self.ipv4_subobject is None):
                                                            self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                            self.ipv4_subobject.parent = self
                                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                        return self.ipv4_subobject

                                                    if (child_yang_name == "ipv6-subobject"):
                                                        if (self.ipv6_subobject is None):
                                                            self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                            self.ipv6_subobject.parent = self
                                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                        return self.ipv6_subobject

                                                    if (child_yang_name == "lsp-subobject"):
                                                        if (self.lsp_subobject is None):
                                                            self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                            self.lsp_subobject.parent = self
                                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                        return self.lsp_subobject

                                                    if (child_yang_name == "srlg-subobject"):
                                                        if (self.srlg_subobject is None):
                                                            self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                            self.srlg_subobject.parent = self
                                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                        return self.srlg_subobject

                                                    if (child_yang_name == "unnumbered-subobject"):
                                                        if (self.unnumbered_subobject is None):
                                                            self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                            self.unnumbered_subobject.parent = self
                                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                        return self.unnumbered_subobject

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_data()):
                                                        return True
                                                return self.mutual_diversity_flag.is_set

                                            def has_operation(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "xro" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "xro-subobject"):
                                                    for c in self.xro_subobject:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.xro_subobject.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "mutual-diversity-flag"):
                                                    self.mutual_diversity_flag = value
                                                    self.mutual_diversity_flag.value_namespace = name_space
                                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (self.xro is not None and self.xro.has_data())

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.xro is not None and self.xro.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-xro" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "xro"):
                                                if (self.xro is None):
                                                    self.xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                                    self.xro.parent = self
                                                    self._children_name_map["xro"] = "xro"
                                                return self.xro

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "xro"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class AttributeSetP2Mpte(Entity):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "frr_bandwidth_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_priority_configured",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2mpte" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetApsPp(Entity):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                            self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                            self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                            self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                            self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                            self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                            self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                            self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                            self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._children_yang_names.add("revert-schedule")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_off_time",
                                                            "path_prot_profile_type",
                                                            "protection_mode",
                                                            "protection_type",
                                                            "restoration_style",
                                                            "snc_mode",
                                                            "tcm_id",
                                                            "wait_to_restore_time") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                                        class RevertSchedule(Entity):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"

                                                self.duration = YLeaf(YType.uint32, "duration")

                                                self.max_tries = YLeaf(YType.uint32, "max-tries")

                                                self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                                self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                                self.schedulename = YLeaf(YType.str, "schedulename")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("duration",
                                                                "max_tries",
                                                                "schedule_date",
                                                                "schedule_frequency",
                                                                "schedulename") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.duration.is_set or
                                                    self.max_tries.is_set or
                                                    self.schedule_date.is_set or
                                                    self.schedule_frequency.is_set or
                                                    self.schedulename.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.duration.yfilter != YFilter.not_set or
                                                    self.max_tries.yfilter != YFilter.not_set or
                                                    self.schedule_date.yfilter != YFilter.not_set or
                                                    self.schedule_frequency.yfilter != YFilter.not_set or
                                                    self.schedulename.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "revert-schedule" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.duration.get_name_leafdata())
                                                if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_tries.get_name_leafdata())
                                                if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                                if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                                if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedulename.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "duration"):
                                                    self.duration = value
                                                    self.duration.value_namespace = name_space
                                                    self.duration.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-tries"):
                                                    self.max_tries = value
                                                    self.max_tries.value_namespace = name_space
                                                    self.max_tries.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-date"):
                                                    self.schedule_date = value
                                                    self.schedule_date.value_namespace = name_space
                                                    self.schedule_date.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-frequency"):
                                                    self.schedule_frequency = value
                                                    self.schedule_frequency.value_namespace = name_space
                                                    self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedulename"):
                                                    self.schedulename = value
                                                    self.schedulename.value_namespace = name_space
                                                    self.schedulename.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.hold_off_time.is_set or
                                                self.path_prot_profile_type.is_set or
                                                self.protection_mode.is_set or
                                                self.protection_type.is_set or
                                                self.restoration_style.is_set or
                                                self.snc_mode.is_set or
                                                self.tcm_id.is_set or
                                                self.wait_to_restore_time.is_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_off_time.yfilter != YFilter.not_set or
                                                self.path_prot_profile_type.yfilter != YFilter.not_set or
                                                self.protection_mode.yfilter != YFilter.not_set or
                                                self.protection_type.yfilter != YFilter.not_set or
                                                self.restoration_style.yfilter != YFilter.not_set or
                                                self.snc_mode.yfilter != YFilter.not_set or
                                                self.tcm_id.yfilter != YFilter.not_set or
                                                self.wait_to_restore_time.yfilter != YFilter.not_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-aps-pp" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                            if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                            if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                            if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_type.get_name_leafdata())
                                            if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                            if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                            if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                            if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "revert-schedule"):
                                                if (self.revert_schedule is None):
                                                    self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                                    self.revert_schedule.parent = self
                                                    self._children_name_map["revert_schedule"] = "revert-schedule"
                                                return self.revert_schedule

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-off-time"):
                                                self.hold_off_time = value
                                                self.hold_off_time.value_namespace = name_space
                                                self.hold_off_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-prot-profile-type"):
                                                self.path_prot_profile_type = value
                                                self.path_prot_profile_type.value_namespace = name_space
                                                self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-mode"):
                                                self.protection_mode = value
                                                self.protection_mode.value_namespace = name_space
                                                self.protection_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-type"):
                                                self.protection_type = value
                                                self.protection_type.value_namespace = name_space
                                                self.protection_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "restoration-style"):
                                                self.restoration_style = value
                                                self.restoration_style.value_namespace = name_space
                                                self.restoration_style.value_namespace_prefix = name_space_prefix
                                            if(value_path == "snc-mode"):
                                                self.snc_mode = value
                                                self.snc_mode.value_namespace = name_space
                                                self.snc_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcm-id"):
                                                self.tcm_id = value
                                                self.tcm_id.value_namespace = name_space
                                                self.tcm_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "wait-to-restore-time"):
                                                self.wait_to_restore_time = value
                                                self.wait_to_restore_time.value_namespace = name_space
                                                self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                                    class AttributeSetP2PTe(Entity):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                            self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                            self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                            self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                            self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                            self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                            self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                            self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                            self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                            self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.prepend_list = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"
                                            self._children_yang_names.add("prepend-list")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_affinity_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_path_select_configured",
                                                            "is_path_selection_metric_configured",
                                                            "is_path_selection_segment_routing_adjacency_protection_configured",
                                                            "is_path_selection_segment_routing_margin_configured",
                                                            "is_path_selection_segment_routing_margin_relative",
                                                            "is_path_selection_segment_routing_segment_limit_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "is_prepend_list_configured",
                                                            "path_invalidation_timeout",
                                                            "path_selection_invalidation_action",
                                                            "path_selection_metric",
                                                            "path_selection_segment_routing_adjacency_protection",
                                                            "path_selection_segment_routing_margin",
                                                            "path_selection_segment_routing_segment_limit",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PrependList(Entity):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.prepend_entry = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in () and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                            class PrependEntry(Entity):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"

                                                    self.index = YLeaf(YType.uint32, "index")

                                                    self.next_label = YLeaf(YType.uint32, "next-label")

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("index",
                                                                    "next_label",
                                                                    "type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.index.is_set or
                                                        self.next_label.is_set or
                                                        self.type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.index.yfilter != YFilter.not_set or
                                                        self.next_label.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "prepend-entry" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.index.get_name_leafdata())
                                                    if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.next_label.get_name_leafdata())
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "index" or name == "next-label" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "index"):
                                                        self.index = value
                                                        self.index.value_namespace = name_space
                                                        self.index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "next-label"):
                                                        self.next_label = value
                                                        self.next_label.value_namespace = name_space
                                                        self.next_label.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_data()):
                                                        return True
                                                return False

                                            def has_operation(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_operation()):
                                                        return True
                                                return self.yfilter != YFilter.not_set

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prepend-list" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "prepend-entry"):
                                                    for c in self.prepend_entry:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.prepend_entry.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "prepend-entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                pass


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.is_affinity_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_path_select_configured.is_set or
                                                self.is_path_selection_metric_configured.is_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_relative.is_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.is_prepend_list_configured.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.path_selection_invalidation_action.is_set or
                                                self.path_selection_metric.is_set or
                                                self.path_selection_segment_routing_adjacency_protection.is_set or
                                                self.path_selection_segment_routing_margin.is_set or
                                                self.path_selection_segment_routing_segment_limit.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.prepend_list is not None and self.prepend_list.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_path_select_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_selection_metric.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.prepend_list is not None and self.prepend_list.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2p-te" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                            if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                            if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                            if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                            if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                            if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "prepend-list"):
                                                if (self.prepend_list is None):
                                                    self.prepend_list = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                                    self.prepend_list.parent = self
                                                    self._children_name_map["prepend_list"] = "prepend-list"
                                                return self.prepend_list

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-select-configured"):
                                                self.is_path_select_configured = value
                                                self.is_path_select_configured.value_namespace = name_space
                                                self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-metric-configured"):
                                                self.is_path_selection_metric_configured = value
                                                self.is_path_selection_metric_configured.value_namespace = name_space
                                                self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                                self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                                self.is_path_selection_segment_routing_margin_configured = value
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                                self.is_path_selection_segment_routing_margin_relative = value
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                                self.is_path_selection_segment_routing_segment_limit_configured = value
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-prepend-list-configured"):
                                                self.is_prepend_list_configured = value
                                                self.is_prepend_list_configured.value_namespace = name_space
                                                self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-invalidation-action"):
                                                self.path_selection_invalidation_action = value
                                                self.path_selection_invalidation_action.value_namespace = name_space
                                                self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-metric"):
                                                self.path_selection_metric = value
                                                self.path_selection_metric.value_namespace = name_space
                                                self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                                self.path_selection_segment_routing_adjacency_protection = value
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-margin"):
                                                self.path_selection_segment_routing_margin = value
                                                self.path_selection_segment_routing_margin.value_namespace = name_space
                                                self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-segment-limit"):
                                                self.path_selection_segment_routing_segment_limit = value
                                                self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                                self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.tunnel_attribute_set_type.is_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-union" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "attribute-set-aps-pp"):
                                            if (self.attribute_set_aps_pp is None):
                                                self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                                self.attribute_set_aps_pp.parent = self
                                                self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                            return self.attribute_set_aps_pp

                                        if (child_yang_name == "attribute-set-autobackup"):
                                            if (self.attribute_set_autobackup is None):
                                                self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                                self.attribute_set_autobackup.parent = self
                                                self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                            return self.attribute_set_autobackup

                                        if (child_yang_name == "attribute-set-automesh"):
                                            if (self.attribute_set_automesh is None):
                                                self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                                self.attribute_set_automesh.parent = self
                                                self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                            return self.attribute_set_automesh

                                        if (child_yang_name == "attribute-set-p2mpte"):
                                            if (self.attribute_set_p2mpte is None):
                                                self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                                self.attribute_set_p2mpte.parent = self
                                                self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                            return self.attribute_set_p2mpte

                                        if (child_yang_name == "attribute-set-p2p-te"):
                                            if (self.attribute_set_p2p_te is None):
                                                self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                                self.attribute_set_p2p_te.parent = self
                                                self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                            return self.attribute_set_p2p_te

                                        if (child_yang_name == "attribute-set-path-option"):
                                            if (self.attribute_set_path_option is None):
                                                self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                                self.attribute_set_path_option.parent = self
                                                self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                            return self.attribute_set_path_option

                                        if (child_yang_name == "attribute-set-xro"):
                                            if (self.attribute_set_xro is None):
                                                self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                                self.attribute_set_xro.parent = self
                                                self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                            return self.attribute_set_xro

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "tunnel-attribute-set-type"):
                                            self.tunnel_attribute_set_type = value
                                            self.tunnel_attribute_set_type.value_namespace = name_space
                                            self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.tunnel_attribute_set_name.is_set or
                                        self.tunnel_attribute_set_name_crc32.is_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "attribute-set" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                                    if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "attribute-set-union"):
                                        if (self.attribute_set_union is None):
                                            self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion()
                                            self.attribute_set_union.parent = self
                                            self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                        return self.attribute_set_union

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "tunnel-attribute-set-name"):
                                        self.tunnel_attribute_set_name = value
                                        self.tunnel_attribute_set_name.value_namespace = name_space
                                        self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-attribute-set-name-crc32"):
                                        self.tunnel_attribute_set_name_crc32 = value
                                        self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                                        self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                            class XroAttributeSet(Entity):
                                """
                                The XRO attribute set used by this path\-option
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion>`
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\:  str
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet, self).__init__()

                                    self.yang_name = "xro-attribute-set"
                                    self.yang_parent_name = "active-path-option"

                                    self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                                    self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                                    self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._children_yang_names.add("attribute-set-union")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("tunnel_attribute_set_name",
                                                    "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet, self).__setattr__(name, value)


                                class AttributeSetUnion(Entity):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "xro-attribute-set"

                                        self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                                        self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                        self._children_yang_names.add("attribute-set-aps-pp")

                                        self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                        self._children_yang_names.add("attribute-set-autobackup")

                                        self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                        self._children_yang_names.add("attribute-set-automesh")

                                        self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                        self._children_yang_names.add("attribute-set-p2mpte")

                                        self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._children_yang_names.add("attribute-set-p2p-te")

                                        self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                        self._children_yang_names.add("attribute-set-path-option")

                                        self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                        self._children_yang_names.add("attribute-set-xro")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                                    class AttributeSetPathOption(Entity):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\:  str
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                            self.generation = YLeaf(YType.uint32, "generation")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                            self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                            self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                            self._children_yang_names.add("bfd-reverse-path")

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bandwidth_type",
                                                            "configured_bandwidth",
                                                            "cost_limit",
                                                            "dste_class_type",
                                                            "exclude_list_name",
                                                            "generation",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_bfd_reverse_pat_configured",
                                                            "is_cost_limit_configured",
                                                            "is_exclude_list_name_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "path_invalidation_action",
                                                            "path_invalidation_timeout",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class BfdReversePath(Entity):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.binding_label = YLeaf(YType.uint32, "binding-label")

                                                self.path_type = YLeaf(YType.enumeration, "path-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("binding_label",
                                                                "path_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.binding_label.is_set or
                                                    self.path_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.binding_label.yfilter != YFilter.not_set or
                                                    self.path_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "bfd-reverse-path" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.binding_label.get_name_leafdata())
                                                if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.path_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "binding-label" or name == "path-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "binding-label"):
                                                    self.binding_label = value
                                                    self.binding_label.value_namespace = name_space
                                                    self.binding_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "path-type"):
                                                    self.path_type = value
                                                    self.path_type.value_namespace = name_space
                                                    self.path_type.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class VersionInfo(Entity):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\:  str
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.attribute_type = YLeaf(YType.str, "attribute-type")

                                                self.generation = YLeaf(YType.uint32, "generation")

                                                self.is_default = YLeaf(YType.boolean, "is-default")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("attribute_type",
                                                                "generation",
                                                                "is_default") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.attribute_type.is_set or
                                                    self.generation.is_set or
                                                    self.is_default.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.attribute_type.yfilter != YFilter.not_set or
                                                    self.generation.yfilter != YFilter.not_set or
                                                    self.is_default.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "version-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                                if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.generation.get_name_leafdata())
                                                if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_default.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "attribute-type"):
                                                    self.attribute_type = value
                                                    self.attribute_type.value_namespace = name_space
                                                    self.attribute_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "generation"):
                                                    self.generation = value
                                                    self.generation.value_namespace = name_space
                                                    self.generation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-default"):
                                                    self.is_default = value
                                                    self.is_default.value_namespace = name_space
                                                    self.is_default.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.bandwidth_type.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.cost_limit.is_set or
                                                self.dste_class_type.is_set or
                                                self.exclude_list_name.is_set or
                                                self.generation.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_bfd_reverse_pat_configured.is_set or
                                                self.is_cost_limit_configured.is_set or
                                                self.is_exclude_list_name_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.path_invalidation_action.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bandwidth_type.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.cost_limit.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.exclude_list_name.yfilter != YFilter.not_set or
                                                self.generation.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                                self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                                self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-path-option" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.generation.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                            if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                            if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "bfd-reverse-path"):
                                                if (self.bfd_reverse_path is None):
                                                    self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                                    self.bfd_reverse_path.parent = self
                                                    self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                                return self.bfd_reverse_path

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            if (child_yang_name == "version-info"):
                                                for c in self.version_info:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.version_info.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bandwidth-type"):
                                                self.bandwidth_type = value
                                                self.bandwidth_type.value_namespace = name_space
                                                self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "cost-limit"):
                                                self.cost_limit = value
                                                self.cost_limit.value_namespace = name_space
                                                self.cost_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exclude-list-name"):
                                                self.exclude_list_name = value
                                                self.exclude_list_name.value_namespace = name_space
                                                self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "generation"):
                                                self.generation = value
                                                self.generation.value_namespace = name_space
                                                self.generation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bfd-reverse-pat-configured"):
                                                self.is_bfd_reverse_pat_configured = value
                                                self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                                self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-cost-limit-configured"):
                                                self.is_cost_limit_configured = value
                                                self.is_cost_limit_configured.value_namespace = name_space
                                                self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-exclude-list-name-configured"):
                                                self.is_exclude_list_name_configured = value
                                                self.is_exclude_list_name_configured.value_namespace = name_space
                                                self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-action"):
                                                self.path_invalidation_action = value
                                                self.path_invalidation_action.value_namespace = name_space
                                                self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutobackup(Entity):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.signalled_name = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"
                                            self._children_yang_names.add("signalled-name")

                                            self.policy_class_entry = YList(self)
                                            self.protected_interface = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_priority",
                                                            "is_affinity_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "is_signalled_name_configured",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                                        class SignalledName(Entity):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\:  bool
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\:  str
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                                self.name = YLeaf(YType.str, "name")

                                                self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                                self.source_type = YLeaf(YType.enumeration, "source-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("is_mp_addresses",
                                                                "name",
                                                                "protected_interface_type",
                                                                "source_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.is_mp_addresses.is_set or
                                                    self.name.is_set or
                                                    self.protected_interface_type.is_set or
                                                    self.source_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.is_mp_addresses.yfilter != YFilter.not_set or
                                                    self.name.yfilter != YFilter.not_set or
                                                    self.protected_interface_type.yfilter != YFilter.not_set or
                                                    self.source_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "signalled-name" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.name.get_name_leafdata())
                                                if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                                if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.source_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "is-mp-addresses"):
                                                    self.is_mp_addresses = value
                                                    self.is_mp_addresses.value_namespace = name_space
                                                    self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                                if(value_path == "name"):
                                                    self.name = value
                                                    self.name.value_namespace = name_space
                                                    self.name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "protected-interface-type"):
                                                    self.protected_interface_type = value
                                                    self.protected_interface_type.value_namespace = name_space
                                                    self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "source-type"):
                                                    self.source_type = value
                                                    self.source_type.value_namespace = name_space
                                                    self.source_type.value_namespace_prefix = name_space_prefix


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class ProtectedInterface(Entity):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.protected_interface = YLeaf(YType.str, "protected-interface")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("protected_interface") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.protected_interface.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.protected_interface.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "protected-interface" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "protected-interface"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "protected-interface"):
                                                    self.protected_interface = value
                                                    self.protected_interface.value_namespace = name_space
                                                    self.protected_interface.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.is_signalled_name_configured.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.signalled_name is not None and self.signalled_name.has_data()))

                                        def has_operation(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.signalled_name is not None and self.signalled_name.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-autobackup" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "protected-interface"):
                                                for c in self.protected_interface:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.protected_interface.append(c)
                                                return c

                                            if (child_yang_name == "signalled-name"):
                                                if (self.signalled_name is None):
                                                    self.signalled_name = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                                    self.signalled_name.parent = self
                                                    self._children_name_map["signalled_name"] = "signalled-name"
                                                return self.signalled_name

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-signalled-name-configured"):
                                                self.is_signalled_name_configured = value
                                                self.is_signalled_name_configured.value_namespace = name_space
                                                self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutomesh(Entity):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\:  bool
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\:  bool
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                            self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                            self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.forward_class = YLeaf(YType.uint32, "forward-class")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.load_share = YLeaf(YType.uint32, "load-share")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.mesh_group_id = YList(self)
                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("auto_bandwidth_collect",
                                                            "auto_route_announce",
                                                            "bandwidth",
                                                            "configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "forward_class",
                                                            "frr_bandwidth_protection",
                                                            "frr_node_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_interface_bw_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "load_share",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority",
                                                            "soft_preemption_configured") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class MeshGroupId(Entity):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint32, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "mesh-group-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.auto_bandwidth_collect.is_set or
                                                self.auto_route_announce.is_set or
                                                self.bandwidth.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.forward_class.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.frr_node_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_interface_bw_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.load_share.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                self.soft_preemption_configured.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()))

                                        def has_operation(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                                self.auto_route_announce.yfilter != YFilter.not_set or
                                                self.bandwidth.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.forward_class.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.frr_node_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.load_share.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                self.soft_preemption_configured.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-automesh" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                            if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                            if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.forward_class.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.load_share.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                            if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "mesh-group-id"):
                                                for c in self.mesh_group_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.mesh_group_id.append(c)
                                                return c

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "auto-bandwidth-collect"):
                                                self.auto_bandwidth_collect = value
                                                self.auto_bandwidth_collect.value_namespace = name_space
                                                self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                            if(value_path == "auto-route-announce"):
                                                self.auto_route_announce = value
                                                self.auto_route_announce.value_namespace = name_space
                                                self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                            if(value_path == "bandwidth"):
                                                self.bandwidth = value
                                                self.bandwidth.value_namespace = name_space
                                                self.bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "forward-class"):
                                                self.forward_class = value
                                                self.forward_class.value_namespace = name_space
                                                self.forward_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-node-protection"):
                                                self.frr_node_protection = value
                                                self.frr_node_protection.value_namespace = name_space
                                                self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-interface-bw-configured"):
                                                self.is_interface_bw_configured = value
                                                self.is_interface_bw_configured.value_namespace = name_space
                                                self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "load-share"):
                                                self.load_share = value
                                                self.load_share.value_namespace = name_space
                                                self.load_share.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "soft-preemption-configured"):
                                                self.soft_preemption_configured = value
                                                self.soft_preemption_configured.value_namespace = name_space
                                                self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                                    class AttributeSetXro(Entity):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._children_yang_names.add("xro")


                                        class Xro(Entity):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\:  bool
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"

                                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                                self.xro_subobject = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                            class XroSubobject(Entity):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                    self.as_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"
                                                    self._children_yang_names.add("as-subobject")

                                                    self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                    self._children_yang_names.add("ipv4-subobject")

                                                    self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                    self._children_yang_names.add("ipv6-subobject")

                                                    self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._children_yang_names.add("lsp-subobject")

                                                    self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                    self._children_yang_names.add("srlg-subobject")

                                                    self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                    self._children_yang_names.add("unnumbered-subobject")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                                class Ipv4Subobject(Entity):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv4-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class Ipv6Subobject(Entity):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv6-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class UnnumberedSubobject(Entity):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("attribute",
                                                                        "exclusion_type",
                                                                        "interface_id",
                                                                        "te_router_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.interface_id.is_set or
                                                            self.te_router_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.interface_id.yfilter != YFilter.not_set or
                                                            self.te_router_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "unnumbered-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "interface-id"):
                                                            self.interface_id = value
                                                            self.interface_id.value_namespace = name_space
                                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "te-router-id"):
                                                            self.te_router_id = value
                                                            self.te_router_id.value_namespace = name_space
                                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                                class AsSubobject(Entity):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("as_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.as_number.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.as_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "as-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "as-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "as-number"):
                                                            self.as_number = value
                                                            self.as_number.value_namespace = name_space
                                                            self.as_number.value_namespace_prefix = name_space_prefix


                                                class SrlgSubobject(Entity):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("exclusion_type",
                                                                        "srlg_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.exclusion_type.is_set or
                                                            self.srlg_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.srlg_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "srlg-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "exclusion-type" or name == "srlg-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "srlg-id"):
                                                            self.srlg_id = value
                                                            self.srlg_id.value_namespace = name_space
                                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                                class LspSubobject(Entity):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                                        self.fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._children_yang_names.add("fec")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("destination_node_exception",
                                                                        "exclusion_type",
                                                                        "ignore_lsp_id",
                                                                        "penultimate_node_exception",
                                                                        "processing_node_exception") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                                    class Fec(Entity):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\:  str
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"

                                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                            self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._children_yang_names.add("fec-destination-info")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("fec_extended_tunnel_id",
                                                                            "fec_lsp_id",
                                                                            "fec_source",
                                                                            "fec_tunnel_id",
                                                                            "fec_vrf") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                                        class FecDestinationInfo(Entity):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\:  str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"

                                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("fec_ctype",
                                                                                "fec_destination_p2mp_id",
                                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.fec_ctype.is_set or
                                                                    self.fec_destination_p2mp_id.is_set or
                                                                    self.p2p_lsp_destination.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "fec-destination-info" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "fec-ctype"):
                                                                    self.fec_ctype = value
                                                                    self.fec_ctype.value_namespace = name_space
                                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "fec-destination-p2mp-id"):
                                                                    self.fec_destination_p2mp_id = value
                                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "p2p-lsp-destination"):
                                                                    self.p2p_lsp_destination = value
                                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.fec_extended_tunnel_id.is_set or
                                                                self.fec_lsp_id.is_set or
                                                                self.fec_source.is_set or
                                                                self.fec_tunnel_id.is_set or
                                                                self.fec_vrf.is_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                                self.fec_source.yfilter != YFilter.not_set or
                                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "fec" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "fec-destination-info"):
                                                                if (self.fec_destination_info is None):
                                                                    self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                                    self.fec_destination_info.parent = self
                                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                                return self.fec_destination_info

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "fec-extended-tunnel-id"):
                                                                self.fec_extended_tunnel_id = value
                                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-lsp-id"):
                                                                self.fec_lsp_id = value
                                                                self.fec_lsp_id.value_namespace = name_space
                                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-source"):
                                                                self.fec_source = value
                                                                self.fec_source.value_namespace = name_space
                                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-tunnel-id"):
                                                                self.fec_tunnel_id = value
                                                                self.fec_tunnel_id.value_namespace = name_space
                                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-vrf"):
                                                                self.fec_vrf = value
                                                                self.fec_vrf.value_namespace = name_space
                                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.destination_node_exception.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.ignore_lsp_id.is_set or
                                                            self.penultimate_node_exception.is_set or
                                                            self.processing_node_exception.is_set or
                                                            (self.fec is not None and self.fec.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                                            (self.fec is not None and self.fec.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsp-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "fec"):
                                                            if (self.fec is None):
                                                                self.fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                                self.fec.parent = self
                                                                self._children_name_map["fec"] = "fec"
                                                            return self.fec

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "destination-node-exception"):
                                                            self.destination_node_exception = value
                                                            self.destination_node_exception.value_namespace = name_space
                                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ignore-lsp-id"):
                                                            self.ignore_lsp_id = value
                                                            self.ignore_lsp_id.value_namespace = name_space
                                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "penultimate-node-exception"):
                                                            self.penultimate_node_exception = value
                                                            self.penultimate_node_exception.value_namespace = name_space
                                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "processing-node-exception"):
                                                            self.processing_node_exception = value
                                                            self.processing_node_exception.value_namespace = name_space
                                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.type.is_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "xro-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "as-subobject"):
                                                        if (self.as_subobject is None):
                                                            self.as_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                            self.as_subobject.parent = self
                                                            self._children_name_map["as_subobject"] = "as-subobject"
                                                        return self.as_subobject

                                                    if (child_yang_name == "ipv4-subobject"):
                                                        if (self.ipv4_subobject is None):
                                                            self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                            self.ipv4_subobject.parent = self
                                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                        return self.ipv4_subobject

                                                    if (child_yang_name == "ipv6-subobject"):
                                                        if (self.ipv6_subobject is None):
                                                            self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                            self.ipv6_subobject.parent = self
                                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                        return self.ipv6_subobject

                                                    if (child_yang_name == "lsp-subobject"):
                                                        if (self.lsp_subobject is None):
                                                            self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                            self.lsp_subobject.parent = self
                                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                        return self.lsp_subobject

                                                    if (child_yang_name == "srlg-subobject"):
                                                        if (self.srlg_subobject is None):
                                                            self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                            self.srlg_subobject.parent = self
                                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                        return self.srlg_subobject

                                                    if (child_yang_name == "unnumbered-subobject"):
                                                        if (self.unnumbered_subobject is None):
                                                            self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                            self.unnumbered_subobject.parent = self
                                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                        return self.unnumbered_subobject

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_data()):
                                                        return True
                                                return self.mutual_diversity_flag.is_set

                                            def has_operation(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "xro" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "xro-subobject"):
                                                    for c in self.xro_subobject:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.xro_subobject.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "mutual-diversity-flag"):
                                                    self.mutual_diversity_flag = value
                                                    self.mutual_diversity_flag.value_namespace = name_space
                                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (self.xro is not None and self.xro.has_data())

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.xro is not None and self.xro.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-xro" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "xro"):
                                                if (self.xro is None):
                                                    self.xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                                    self.xro.parent = self
                                                    self._children_name_map["xro"] = "xro"
                                                return self.xro

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "xro"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class AttributeSetP2Mpte(Entity):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "frr_bandwidth_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_priority_configured",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2mpte" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetApsPp(Entity):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                            self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                            self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                            self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                            self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                            self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                            self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                            self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                            self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._children_yang_names.add("revert-schedule")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_off_time",
                                                            "path_prot_profile_type",
                                                            "protection_mode",
                                                            "protection_type",
                                                            "restoration_style",
                                                            "snc_mode",
                                                            "tcm_id",
                                                            "wait_to_restore_time") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                                        class RevertSchedule(Entity):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"

                                                self.duration = YLeaf(YType.uint32, "duration")

                                                self.max_tries = YLeaf(YType.uint32, "max-tries")

                                                self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                                self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                                self.schedulename = YLeaf(YType.str, "schedulename")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("duration",
                                                                "max_tries",
                                                                "schedule_date",
                                                                "schedule_frequency",
                                                                "schedulename") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.duration.is_set or
                                                    self.max_tries.is_set or
                                                    self.schedule_date.is_set or
                                                    self.schedule_frequency.is_set or
                                                    self.schedulename.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.duration.yfilter != YFilter.not_set or
                                                    self.max_tries.yfilter != YFilter.not_set or
                                                    self.schedule_date.yfilter != YFilter.not_set or
                                                    self.schedule_frequency.yfilter != YFilter.not_set or
                                                    self.schedulename.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "revert-schedule" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.duration.get_name_leafdata())
                                                if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_tries.get_name_leafdata())
                                                if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                                if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                                if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedulename.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "duration"):
                                                    self.duration = value
                                                    self.duration.value_namespace = name_space
                                                    self.duration.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-tries"):
                                                    self.max_tries = value
                                                    self.max_tries.value_namespace = name_space
                                                    self.max_tries.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-date"):
                                                    self.schedule_date = value
                                                    self.schedule_date.value_namespace = name_space
                                                    self.schedule_date.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-frequency"):
                                                    self.schedule_frequency = value
                                                    self.schedule_frequency.value_namespace = name_space
                                                    self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedulename"):
                                                    self.schedulename = value
                                                    self.schedulename.value_namespace = name_space
                                                    self.schedulename.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.hold_off_time.is_set or
                                                self.path_prot_profile_type.is_set or
                                                self.protection_mode.is_set or
                                                self.protection_type.is_set or
                                                self.restoration_style.is_set or
                                                self.snc_mode.is_set or
                                                self.tcm_id.is_set or
                                                self.wait_to_restore_time.is_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_off_time.yfilter != YFilter.not_set or
                                                self.path_prot_profile_type.yfilter != YFilter.not_set or
                                                self.protection_mode.yfilter != YFilter.not_set or
                                                self.protection_type.yfilter != YFilter.not_set or
                                                self.restoration_style.yfilter != YFilter.not_set or
                                                self.snc_mode.yfilter != YFilter.not_set or
                                                self.tcm_id.yfilter != YFilter.not_set or
                                                self.wait_to_restore_time.yfilter != YFilter.not_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-aps-pp" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                            if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                            if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                            if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_type.get_name_leafdata())
                                            if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                            if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                            if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                            if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "revert-schedule"):
                                                if (self.revert_schedule is None):
                                                    self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                                    self.revert_schedule.parent = self
                                                    self._children_name_map["revert_schedule"] = "revert-schedule"
                                                return self.revert_schedule

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-off-time"):
                                                self.hold_off_time = value
                                                self.hold_off_time.value_namespace = name_space
                                                self.hold_off_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-prot-profile-type"):
                                                self.path_prot_profile_type = value
                                                self.path_prot_profile_type.value_namespace = name_space
                                                self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-mode"):
                                                self.protection_mode = value
                                                self.protection_mode.value_namespace = name_space
                                                self.protection_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-type"):
                                                self.protection_type = value
                                                self.protection_type.value_namespace = name_space
                                                self.protection_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "restoration-style"):
                                                self.restoration_style = value
                                                self.restoration_style.value_namespace = name_space
                                                self.restoration_style.value_namespace_prefix = name_space_prefix
                                            if(value_path == "snc-mode"):
                                                self.snc_mode = value
                                                self.snc_mode.value_namespace = name_space
                                                self.snc_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcm-id"):
                                                self.tcm_id = value
                                                self.tcm_id.value_namespace = name_space
                                                self.tcm_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "wait-to-restore-time"):
                                                self.wait_to_restore_time = value
                                                self.wait_to_restore_time.value_namespace = name_space
                                                self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                                    class AttributeSetP2PTe(Entity):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                            self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                            self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                            self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                            self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                            self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                            self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                            self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                            self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                            self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.prepend_list = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"
                                            self._children_yang_names.add("prepend-list")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_affinity_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_path_select_configured",
                                                            "is_path_selection_metric_configured",
                                                            "is_path_selection_segment_routing_adjacency_protection_configured",
                                                            "is_path_selection_segment_routing_margin_configured",
                                                            "is_path_selection_segment_routing_margin_relative",
                                                            "is_path_selection_segment_routing_segment_limit_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "is_prepend_list_configured",
                                                            "path_invalidation_timeout",
                                                            "path_selection_invalidation_action",
                                                            "path_selection_metric",
                                                            "path_selection_segment_routing_adjacency_protection",
                                                            "path_selection_segment_routing_margin",
                                                            "path_selection_segment_routing_segment_limit",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PrependList(Entity):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.prepend_entry = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in () and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                            class PrependEntry(Entity):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"

                                                    self.index = YLeaf(YType.uint32, "index")

                                                    self.next_label = YLeaf(YType.uint32, "next-label")

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("index",
                                                                    "next_label",
                                                                    "type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.index.is_set or
                                                        self.next_label.is_set or
                                                        self.type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.index.yfilter != YFilter.not_set or
                                                        self.next_label.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "prepend-entry" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.index.get_name_leafdata())
                                                    if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.next_label.get_name_leafdata())
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "index" or name == "next-label" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "index"):
                                                        self.index = value
                                                        self.index.value_namespace = name_space
                                                        self.index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "next-label"):
                                                        self.next_label = value
                                                        self.next_label.value_namespace = name_space
                                                        self.next_label.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_data()):
                                                        return True
                                                return False

                                            def has_operation(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_operation()):
                                                        return True
                                                return self.yfilter != YFilter.not_set

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prepend-list" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "prepend-entry"):
                                                    for c in self.prepend_entry:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.prepend_entry.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "prepend-entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                pass


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.is_affinity_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_path_select_configured.is_set or
                                                self.is_path_selection_metric_configured.is_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_relative.is_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.is_prepend_list_configured.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.path_selection_invalidation_action.is_set or
                                                self.path_selection_metric.is_set or
                                                self.path_selection_segment_routing_adjacency_protection.is_set or
                                                self.path_selection_segment_routing_margin.is_set or
                                                self.path_selection_segment_routing_segment_limit.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.prepend_list is not None and self.prepend_list.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_path_select_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_selection_metric.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.prepend_list is not None and self.prepend_list.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2p-te" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                            if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                            if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                            if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                            if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                            if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "prepend-list"):
                                                if (self.prepend_list is None):
                                                    self.prepend_list = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                                    self.prepend_list.parent = self
                                                    self._children_name_map["prepend_list"] = "prepend-list"
                                                return self.prepend_list

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-select-configured"):
                                                self.is_path_select_configured = value
                                                self.is_path_select_configured.value_namespace = name_space
                                                self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-metric-configured"):
                                                self.is_path_selection_metric_configured = value
                                                self.is_path_selection_metric_configured.value_namespace = name_space
                                                self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                                self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                                self.is_path_selection_segment_routing_margin_configured = value
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                                self.is_path_selection_segment_routing_margin_relative = value
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                                self.is_path_selection_segment_routing_segment_limit_configured = value
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-prepend-list-configured"):
                                                self.is_prepend_list_configured = value
                                                self.is_prepend_list_configured.value_namespace = name_space
                                                self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-invalidation-action"):
                                                self.path_selection_invalidation_action = value
                                                self.path_selection_invalidation_action.value_namespace = name_space
                                                self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-metric"):
                                                self.path_selection_metric = value
                                                self.path_selection_metric.value_namespace = name_space
                                                self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                                self.path_selection_segment_routing_adjacency_protection = value
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-margin"):
                                                self.path_selection_segment_routing_margin = value
                                                self.path_selection_segment_routing_margin.value_namespace = name_space
                                                self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-segment-limit"):
                                                self.path_selection_segment_routing_segment_limit = value
                                                self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                                self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.tunnel_attribute_set_type.is_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-union" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "attribute-set-aps-pp"):
                                            if (self.attribute_set_aps_pp is None):
                                                self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                                self.attribute_set_aps_pp.parent = self
                                                self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                            return self.attribute_set_aps_pp

                                        if (child_yang_name == "attribute-set-autobackup"):
                                            if (self.attribute_set_autobackup is None):
                                                self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                                self.attribute_set_autobackup.parent = self
                                                self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                            return self.attribute_set_autobackup

                                        if (child_yang_name == "attribute-set-automesh"):
                                            if (self.attribute_set_automesh is None):
                                                self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                                self.attribute_set_automesh.parent = self
                                                self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                            return self.attribute_set_automesh

                                        if (child_yang_name == "attribute-set-p2mpte"):
                                            if (self.attribute_set_p2mpte is None):
                                                self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                                self.attribute_set_p2mpte.parent = self
                                                self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                            return self.attribute_set_p2mpte

                                        if (child_yang_name == "attribute-set-p2p-te"):
                                            if (self.attribute_set_p2p_te is None):
                                                self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                                self.attribute_set_p2p_te.parent = self
                                                self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                            return self.attribute_set_p2p_te

                                        if (child_yang_name == "attribute-set-path-option"):
                                            if (self.attribute_set_path_option is None):
                                                self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                                self.attribute_set_path_option.parent = self
                                                self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                            return self.attribute_set_path_option

                                        if (child_yang_name == "attribute-set-xro"):
                                            if (self.attribute_set_xro is None):
                                                self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                                self.attribute_set_xro.parent = self
                                                self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                            return self.attribute_set_xro

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "tunnel-attribute-set-type"):
                                            self.tunnel_attribute_set_type = value
                                            self.tunnel_attribute_set_type.value_namespace = name_space
                                            self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.tunnel_attribute_set_name.is_set or
                                        self.tunnel_attribute_set_name_crc32.is_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-attribute-set" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                                    if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "attribute-set-union"):
                                        if (self.attribute_set_union is None):
                                            self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                            self.attribute_set_union.parent = self
                                            self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                        return self.attribute_set_union

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "tunnel-attribute-set-name"):
                                        self.tunnel_attribute_set_name = value
                                        self.tunnel_attribute_set_name.value_namespace = name_space
                                        self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-attribute-set-name-crc32"):
                                        self.tunnel_attribute_set_name_crc32 = value
                                        self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                                        self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                            class PathCalculationError(Entity):
                                """
                                Path computation information
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.PathCalculationError, self).__init__()

                                    self.yang_name = "path-calculation-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error_message",
                                                    "log_time",
                                                    "lsp_mode") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.PathCalculationError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.PathCalculationError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error_message.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-calculation-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix


                            class RemergeError(Entity):
                                """
                                Path computation remerge resolve info
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.RemergeError, self).__init__()

                                    self.yang_name = "remerge-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error_message",
                                                    "log_time",
                                                    "lsp_mode") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.RemergeError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.RemergeError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error_message.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "remerge-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix


                            class SignallingError(Entity):
                                """
                                Signalling information
                                
                                .. attribute:: error
                                
                                	Path Error code
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: error_node
                                
                                	Source address of the error generating node
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: log_time
                                
                                	Time in seconds when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSPMode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                .. attribute:: reverse_lsp
                                
                                	Indicates if error is on the reverse LSP
                                	**type**\:  bool
                                
                                .. attribute:: signalling_lsp_id
                                
                                	LSP\-id for which the error was received
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: sub_code
                                
                                	Path Error subcode
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.SignallingError, self).__init__()

                                    self.yang_name = "signalling-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error = YLeaf(YType.uint8, "error")

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.error_node = YLeaf(YType.uint32, "error-node")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                    self.reverse_lsp = YLeaf(YType.boolean, "reverse-lsp")

                                    self.signalling_lsp_id = YLeaf(YType.uint16, "signalling-lsp-id")

                                    self.sub_code = YLeaf(YType.uint16, "sub-code")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error",
                                                    "error_message",
                                                    "error_node",
                                                    "log_time",
                                                    "lsp_mode",
                                                    "reverse_lsp",
                                                    "signalling_lsp_id",
                                                    "sub_code") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.SignallingError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.SignallingError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error.is_set or
                                        self.error_message.is_set or
                                        self.error_node.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set or
                                        self.reverse_lsp.is_set or
                                        self.signalling_lsp_id.is_set or
                                        self.sub_code.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.error_node.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set or
                                        self.reverse_lsp.yfilter != YFilter.not_set or
                                        self.signalling_lsp_id.yfilter != YFilter.not_set or
                                        self.sub_code.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "signalling-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error.is_set or self.error.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error.get_name_leafdata())
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.error_node.is_set or self.error_node.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_node.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())
                                    if (self.reverse_lsp.is_set or self.reverse_lsp.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.reverse_lsp.get_name_leafdata())
                                    if (self.signalling_lsp_id.is_set or self.signalling_lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signalling_lsp_id.get_name_leafdata())
                                    if (self.sub_code.is_set or self.sub_code.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.sub_code.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error" or name == "error-message" or name == "error-node" or name == "log-time" or name == "lsp-mode" or name == "reverse-lsp" or name == "signalling-lsp-id" or name == "sub-code"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error"):
                                        self.error = value
                                        self.error.value_namespace = name_space
                                        self.error.value_namespace_prefix = name_space_prefix
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "error-node"):
                                        self.error_node = value
                                        self.error_node.value_namespace = name_space
                                        self.error_node.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "reverse-lsp"):
                                        self.reverse_lsp = value
                                        self.reverse_lsp.value_namespace = name_space
                                        self.reverse_lsp.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signalling-lsp-id"):
                                        self.signalling_lsp_id = value
                                        self.signalling_lsp_id.value_namespace = name_space
                                        self.signalling_lsp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "sub-code"):
                                        self.sub_code = value
                                        self.sub_code.value_namespace = name_space
                                        self.sub_code.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.path_calculation_error:
                                    if (c.has_data()):
                                        return True
                                for c in self.remerge_error:
                                    if (c.has_data()):
                                        return True
                                for c in self.signalling_error:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.attribute_set_found.is_set or
                                    self.explicit_path_id.is_set or
                                    self.explicit_path_name.is_set or
                                    self.has_attribute_set.is_set or
                                    self.has_xro_attribute_set.is_set or
                                    self.holddown_duration.is_set or
                                    self.is_disabled.is_set or
                                    self.is_helddown.is_set or
                                    self.is_lockdown.is_set or
                                    self.is_segment_routing.is_set or
                                    self.is_strict_explicit_path.is_set or
                                    self.is_verbatim.is_set or
                                    self.option_index.is_set or
                                    self.option_index_is_valid.is_set or
                                    self.path_option_area_id.is_set or
                                    self.path_option_name.is_set or
                                    self.path_option_type.is_set or
                                    self.pce_address.is_set or
                                    self.protected_by_path_option_index.is_set or
                                    self.restored_from_path_option_index.is_set or
                                    self.xro_attribute_set_found.is_set or
                                    (self.attribute_set is not None and self.attribute_set.has_data()) or
                                    (self.xro_attribute_set is not None and self.xro_attribute_set.has_data()))

                            def has_operation(self):
                                for c in self.path_calculation_error:
                                    if (c.has_operation()):
                                        return True
                                for c in self.remerge_error:
                                    if (c.has_operation()):
                                        return True
                                for c in self.signalling_error:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.attribute_set_found.yfilter != YFilter.not_set or
                                    self.explicit_path_id.yfilter != YFilter.not_set or
                                    self.explicit_path_name.yfilter != YFilter.not_set or
                                    self.has_attribute_set.yfilter != YFilter.not_set or
                                    self.has_xro_attribute_set.yfilter != YFilter.not_set or
                                    self.holddown_duration.yfilter != YFilter.not_set or
                                    self.is_disabled.yfilter != YFilter.not_set or
                                    self.is_helddown.yfilter != YFilter.not_set or
                                    self.is_lockdown.yfilter != YFilter.not_set or
                                    self.is_segment_routing.yfilter != YFilter.not_set or
                                    self.is_strict_explicit_path.yfilter != YFilter.not_set or
                                    self.is_verbatim.yfilter != YFilter.not_set or
                                    self.option_index.yfilter != YFilter.not_set or
                                    self.option_index_is_valid.yfilter != YFilter.not_set or
                                    self.path_option_area_id.yfilter != YFilter.not_set or
                                    self.path_option_name.yfilter != YFilter.not_set or
                                    self.path_option_type.yfilter != YFilter.not_set or
                                    self.pce_address.yfilter != YFilter.not_set or
                                    self.protected_by_path_option_index.yfilter != YFilter.not_set or
                                    self.restored_from_path_option_index.yfilter != YFilter.not_set or
                                    self.xro_attribute_set_found.yfilter != YFilter.not_set or
                                    (self.attribute_set is not None and self.attribute_set.has_operation()) or
                                    (self.xro_attribute_set is not None and self.xro_attribute_set.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "active-path-option" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.attribute_set_found.is_set or self.attribute_set_found.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.attribute_set_found.get_name_leafdata())
                                if (self.explicit_path_id.is_set or self.explicit_path_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.explicit_path_id.get_name_leafdata())
                                if (self.explicit_path_name.is_set or self.explicit_path_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.explicit_path_name.get_name_leafdata())
                                if (self.has_attribute_set.is_set or self.has_attribute_set.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_attribute_set.get_name_leafdata())
                                if (self.has_xro_attribute_set.is_set or self.has_xro_attribute_set.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_xro_attribute_set.get_name_leafdata())
                                if (self.holddown_duration.is_set or self.holddown_duration.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.holddown_duration.get_name_leafdata())
                                if (self.is_disabled.is_set or self.is_disabled.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_disabled.get_name_leafdata())
                                if (self.is_helddown.is_set or self.is_helddown.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_helddown.get_name_leafdata())
                                if (self.is_lockdown.is_set or self.is_lockdown.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_lockdown.get_name_leafdata())
                                if (self.is_segment_routing.is_set or self.is_segment_routing.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_segment_routing.get_name_leafdata())
                                if (self.is_strict_explicit_path.is_set or self.is_strict_explicit_path.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_strict_explicit_path.get_name_leafdata())
                                if (self.is_verbatim.is_set or self.is_verbatim.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_verbatim.get_name_leafdata())
                                if (self.option_index.is_set or self.option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.option_index.get_name_leafdata())
                                if (self.option_index_is_valid.is_set or self.option_index_is_valid.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.option_index_is_valid.get_name_leafdata())
                                if (self.path_option_area_id.is_set or self.path_option_area_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_area_id.get_name_leafdata())
                                if (self.path_option_name.is_set or self.path_option_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_name.get_name_leafdata())
                                if (self.path_option_type.is_set or self.path_option_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_type.get_name_leafdata())
                                if (self.pce_address.is_set or self.pce_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pce_address.get_name_leafdata())
                                if (self.protected_by_path_option_index.is_set or self.protected_by_path_option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.protected_by_path_option_index.get_name_leafdata())
                                if (self.restored_from_path_option_index.is_set or self.restored_from_path_option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.restored_from_path_option_index.get_name_leafdata())
                                if (self.xro_attribute_set_found.is_set or self.xro_attribute_set_found.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.xro_attribute_set_found.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "attribute-set"):
                                    if (self.attribute_set is None):
                                        self.attribute_set = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.AttributeSet()
                                        self.attribute_set.parent = self
                                        self._children_name_map["attribute_set"] = "attribute-set"
                                    return self.attribute_set

                                if (child_yang_name == "path-calculation-error"):
                                    for c in self.path_calculation_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.PathCalculationError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.path_calculation_error.append(c)
                                    return c

                                if (child_yang_name == "remerge-error"):
                                    for c in self.remerge_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.RemergeError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.remerge_error.append(c)
                                    return c

                                if (child_yang_name == "signalling-error"):
                                    for c in self.signalling_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.SignallingError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.signalling_error.append(c)
                                    return c

                                if (child_yang_name == "xro-attribute-set"):
                                    if (self.xro_attribute_set is None):
                                        self.xro_attribute_set = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption.XroAttributeSet()
                                        self.xro_attribute_set.parent = self
                                        self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                                    return self.xro_attribute_set

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "attribute-set" or name == "path-calculation-error" or name == "remerge-error" or name == "signalling-error" or name == "xro-attribute-set" or name == "attribute-set-found" or name == "explicit-path-id" or name == "explicit-path-name" or name == "has-attribute-set" or name == "has-xro-attribute-set" or name == "holddown-duration" or name == "is-disabled" or name == "is-helddown" or name == "is-lockdown" or name == "is-segment-routing" or name == "is-strict-explicit-path" or name == "is-verbatim" or name == "option-index" or name == "option-index-is-valid" or name == "path-option-area-id" or name == "path-option-name" or name == "path-option-type" or name == "pce-address" or name == "protected-by-path-option-index" or name == "restored-from-path-option-index" or name == "xro-attribute-set-found"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "attribute-set-found"):
                                    self.attribute_set_found = value
                                    self.attribute_set_found.value_namespace = name_space
                                    self.attribute_set_found.value_namespace_prefix = name_space_prefix
                                if(value_path == "explicit-path-id"):
                                    self.explicit_path_id = value
                                    self.explicit_path_id.value_namespace = name_space
                                    self.explicit_path_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "explicit-path-name"):
                                    self.explicit_path_name = value
                                    self.explicit_path_name.value_namespace = name_space
                                    self.explicit_path_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-attribute-set"):
                                    self.has_attribute_set = value
                                    self.has_attribute_set.value_namespace = name_space
                                    self.has_attribute_set.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-xro-attribute-set"):
                                    self.has_xro_attribute_set = value
                                    self.has_xro_attribute_set.value_namespace = name_space
                                    self.has_xro_attribute_set.value_namespace_prefix = name_space_prefix
                                if(value_path == "holddown-duration"):
                                    self.holddown_duration = value
                                    self.holddown_duration.value_namespace = name_space
                                    self.holddown_duration.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-disabled"):
                                    self.is_disabled = value
                                    self.is_disabled.value_namespace = name_space
                                    self.is_disabled.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-helddown"):
                                    self.is_helddown = value
                                    self.is_helddown.value_namespace = name_space
                                    self.is_helddown.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-lockdown"):
                                    self.is_lockdown = value
                                    self.is_lockdown.value_namespace = name_space
                                    self.is_lockdown.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-segment-routing"):
                                    self.is_segment_routing = value
                                    self.is_segment_routing.value_namespace = name_space
                                    self.is_segment_routing.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-strict-explicit-path"):
                                    self.is_strict_explicit_path = value
                                    self.is_strict_explicit_path.value_namespace = name_space
                                    self.is_strict_explicit_path.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-verbatim"):
                                    self.is_verbatim = value
                                    self.is_verbatim.value_namespace = name_space
                                    self.is_verbatim.value_namespace_prefix = name_space_prefix
                                if(value_path == "option-index"):
                                    self.option_index = value
                                    self.option_index.value_namespace = name_space
                                    self.option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "option-index-is-valid"):
                                    self.option_index_is_valid = value
                                    self.option_index_is_valid.value_namespace = name_space
                                    self.option_index_is_valid.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-area-id"):
                                    self.path_option_area_id = value
                                    self.path_option_area_id.value_namespace = name_space
                                    self.path_option_area_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-name"):
                                    self.path_option_name = value
                                    self.path_option_name.value_namespace = name_space
                                    self.path_option_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-type"):
                                    self.path_option_type = value
                                    self.path_option_type.value_namespace = name_space
                                    self.path_option_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "pce-address"):
                                    self.pce_address = value
                                    self.pce_address.value_namespace = name_space
                                    self.pce_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "protected-by-path-option-index"):
                                    self.protected_by_path_option_index = value
                                    self.protected_by_path_option_index.value_namespace = name_space
                                    self.protected_by_path_option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "restored-from-path-option-index"):
                                    self.restored_from_path_option_index = value
                                    self.restored_from_path_option_index.value_namespace = name_space
                                    self.restored_from_path_option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "xro-attribute-set-found"):
                                    self.xro_attribute_set_found = value
                                    self.xro_attribute_set_found.value_namespace = name_space
                                    self.xro_attribute_set_found.value_namespace_prefix = name_space_prefix


                        class OutXro(Entity):
                            """
                            Outgoing XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\:  bool
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro, self).__init__()

                                self.yang_name = "out-xro"
                                self.yang_parent_name = "s2l"

                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                self.xro_subobject = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro, self).__setattr__(name, value)


                            class XroSubobject(Entity):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.AsSubobject>`
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.Ipv4Subobject>`
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.Ipv6Subobject>`
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.LspSubobject>`
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.SrlgSubobject>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "out-xro"

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.as_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"
                                    self._children_yang_names.add("as-subobject")

                                    self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                    self._children_yang_names.add("ipv4-subobject")

                                    self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                    self._children_yang_names.add("ipv6-subobject")

                                    self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._children_yang_names.add("lsp-subobject")

                                    self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                    self._children_yang_names.add("srlg-subobject")

                                    self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                    self._children_yang_names.add("unnumbered-subobject")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject, self).__setattr__(name, value)


                                class Ipv4Subobject(Entity):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class Ipv6Subobject(Entity):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class UnnumberedSubobject(Entity):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("attribute",
                                                        "exclusion_type",
                                                        "interface_id",
                                                        "te_router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.interface_id.is_set or
                                            self.te_router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.interface_id.yfilter != YFilter.not_set or
                                            self.te_router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "unnumbered-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-id"):
                                            self.interface_id = value
                                            self.interface_id.value_namespace = name_space
                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "te-router-id"):
                                            self.te_router_id = value
                                            self.te_router_id.value_namespace = name_space
                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                class AsSubobject(Entity):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("as_number") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.as_number.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.as_number.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "as-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "as-number"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "as-number"):
                                            self.as_number = value
                                            self.as_number.value_namespace = name_space
                                            self.as_number.value_namespace_prefix = name_space_prefix


                                class SrlgSubobject(Entity):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("exclusion_type",
                                                        "srlg_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.exclusion_type.is_set or
                                            self.srlg_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.srlg_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srlg-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "exclusion-type" or name == "srlg-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "srlg-id"):
                                            self.srlg_id = value
                                            self.srlg_id.value_namespace = name_space
                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                class LspSubobject(Entity):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\:  bool
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                        self.fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._children_yang_names.add("fec")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("destination_node_exception",
                                                        "exclusion_type",
                                                        "ignore_lsp_id",
                                                        "penultimate_node_exception",
                                                        "processing_node_exception") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                    class Fec(Entity):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"

                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                            self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._children_yang_names.add("fec-destination-info")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("fec_extended_tunnel_id",
                                                            "fec_lsp_id",
                                                            "fec_source",
                                                            "fec_tunnel_id",
                                                            "fec_vrf") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                        class FecDestinationInfo(Entity):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"

                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("fec_ctype",
                                                                "fec_destination_p2mp_id",
                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.fec_ctype.is_set or
                                                    self.fec_destination_p2mp_id.is_set or
                                                    self.p2p_lsp_destination.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "fec-destination-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "fec-ctype"):
                                                    self.fec_ctype = value
                                                    self.fec_ctype.value_namespace = name_space
                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                if(value_path == "fec-destination-p2mp-id"):
                                                    self.fec_destination_p2mp_id = value
                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "p2p-lsp-destination"):
                                                    self.p2p_lsp_destination = value
                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.fec_extended_tunnel_id.is_set or
                                                self.fec_lsp_id.is_set or
                                                self.fec_source.is_set or
                                                self.fec_tunnel_id.is_set or
                                                self.fec_vrf.is_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                self.fec_source.yfilter != YFilter.not_set or
                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "fec" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "fec-destination-info"):
                                                if (self.fec_destination_info is None):
                                                    self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                    self.fec_destination_info.parent = self
                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                return self.fec_destination_info

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "fec-extended-tunnel-id"):
                                                self.fec_extended_tunnel_id = value
                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-lsp-id"):
                                                self.fec_lsp_id = value
                                                self.fec_lsp_id.value_namespace = name_space
                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-source"):
                                                self.fec_source = value
                                                self.fec_source.value_namespace = name_space
                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-tunnel-id"):
                                                self.fec_tunnel_id = value
                                                self.fec_tunnel_id.value_namespace = name_space
                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-vrf"):
                                                self.fec_vrf = value
                                                self.fec_vrf.value_namespace = name_space
                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.destination_node_exception.is_set or
                                            self.exclusion_type.is_set or
                                            self.ignore_lsp_id.is_set or
                                            self.penultimate_node_exception.is_set or
                                            self.processing_node_exception.is_set or
                                            (self.fec is not None and self.fec.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                            (self.fec is not None and self.fec.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "lsp-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "fec"):
                                            if (self.fec is None):
                                                self.fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec()
                                                self.fec.parent = self
                                                self._children_name_map["fec"] = "fec"
                                            return self.fec

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "destination-node-exception"):
                                            self.destination_node_exception = value
                                            self.destination_node_exception.value_namespace = name_space
                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ignore-lsp-id"):
                                            self.ignore_lsp_id = value
                                            self.ignore_lsp_id.value_namespace = name_space
                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "penultimate-node-exception"):
                                            self.penultimate_node_exception = value
                                            self.penultimate_node_exception.value_namespace = name_space
                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "processing-node-exception"):
                                            self.processing_node_exception = value
                                            self.processing_node_exception.value_namespace = name_space
                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.type.is_set or
                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "as-subobject"):
                                        if (self.as_subobject is None):
                                            self.as_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.AsSubobject()
                                            self.as_subobject.parent = self
                                            self._children_name_map["as_subobject"] = "as-subobject"
                                        return self.as_subobject

                                    if (child_yang_name == "ipv4-subobject"):
                                        if (self.ipv4_subobject is None):
                                            self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.Ipv4Subobject()
                                            self.ipv4_subobject.parent = self
                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                        return self.ipv4_subobject

                                    if (child_yang_name == "ipv6-subobject"):
                                        if (self.ipv6_subobject is None):
                                            self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.Ipv6Subobject()
                                            self.ipv6_subobject.parent = self
                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                        return self.ipv6_subobject

                                    if (child_yang_name == "lsp-subobject"):
                                        if (self.lsp_subobject is None):
                                            self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.LspSubobject()
                                            self.lsp_subobject.parent = self
                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                        return self.lsp_subobject

                                    if (child_yang_name == "srlg-subobject"):
                                        if (self.srlg_subobject is None):
                                            self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.SrlgSubobject()
                                            self.srlg_subobject.parent = self
                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                        return self.srlg_subobject

                                    if (child_yang_name == "unnumbered-subobject"):
                                        if (self.unnumbered_subobject is None):
                                            self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject()
                                            self.unnumbered_subobject.parent = self
                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                        return self.unnumbered_subobject

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.xro_subobject:
                                    if (c.has_data()):
                                        return True
                                return self.mutual_diversity_flag.is_set

                            def has_operation(self):
                                for c in self.xro_subobject:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "out-xro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "xro-subobject"):
                                    for c in self.xro_subobject:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro.XroSubobject()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.xro_subobject.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "mutual-diversity-flag"):
                                    self.mutual_diversity_flag = value
                                    self.mutual_diversity_flag.value_namespace = name_space
                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix


                        class InXro(Entity):
                            """
                            Incoming XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\:  bool
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro, self).__init__()

                                self.yang_name = "in-xro"
                                self.yang_parent_name = "s2l"

                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                self.xro_subobject = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro, self).__setattr__(name, value)


                            class XroSubobject(Entity):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.AsSubobject>`
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.Ipv4Subobject>`
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.Ipv6Subobject>`
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.LspSubobject>`
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.SrlgSubobject>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.UnnumberedSubobject>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "in-xro"

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.as_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"
                                    self._children_yang_names.add("as-subobject")

                                    self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                    self._children_yang_names.add("ipv4-subobject")

                                    self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                    self._children_yang_names.add("ipv6-subobject")

                                    self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._children_yang_names.add("lsp-subobject")

                                    self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                    self._children_yang_names.add("srlg-subobject")

                                    self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                    self._children_yang_names.add("unnumbered-subobject")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject, self).__setattr__(name, value)


                                class Ipv4Subobject(Entity):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class Ipv6Subobject(Entity):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class UnnumberedSubobject(Entity):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("attribute",
                                                        "exclusion_type",
                                                        "interface_id",
                                                        "te_router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.interface_id.is_set or
                                            self.te_router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.interface_id.yfilter != YFilter.not_set or
                                            self.te_router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "unnumbered-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-id"):
                                            self.interface_id = value
                                            self.interface_id.value_namespace = name_space
                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "te-router-id"):
                                            self.te_router_id = value
                                            self.te_router_id.value_namespace = name_space
                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                class AsSubobject(Entity):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("as_number") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.as_number.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.as_number.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "as-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "as-number"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "as-number"):
                                            self.as_number = value
                                            self.as_number.value_namespace = name_space
                                            self.as_number.value_namespace_prefix = name_space_prefix


                                class SrlgSubobject(Entity):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("exclusion_type",
                                                        "srlg_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.exclusion_type.is_set or
                                            self.srlg_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.srlg_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srlg-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "exclusion-type" or name == "srlg-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "srlg-id"):
                                            self.srlg_id = value
                                            self.srlg_id.value_namespace = name_space
                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                class LspSubobject(Entity):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\:  bool
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                        self.fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._children_yang_names.add("fec")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("destination_node_exception",
                                                        "exclusion_type",
                                                        "ignore_lsp_id",
                                                        "penultimate_node_exception",
                                                        "processing_node_exception") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                    class Fec(Entity):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"

                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                            self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._children_yang_names.add("fec-destination-info")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("fec_extended_tunnel_id",
                                                            "fec_lsp_id",
                                                            "fec_source",
                                                            "fec_tunnel_id",
                                                            "fec_vrf") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                        class FecDestinationInfo(Entity):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"

                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("fec_ctype",
                                                                "fec_destination_p2mp_id",
                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.fec_ctype.is_set or
                                                    self.fec_destination_p2mp_id.is_set or
                                                    self.p2p_lsp_destination.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "fec-destination-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "fec-ctype"):
                                                    self.fec_ctype = value
                                                    self.fec_ctype.value_namespace = name_space
                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                if(value_path == "fec-destination-p2mp-id"):
                                                    self.fec_destination_p2mp_id = value
                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "p2p-lsp-destination"):
                                                    self.p2p_lsp_destination = value
                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.fec_extended_tunnel_id.is_set or
                                                self.fec_lsp_id.is_set or
                                                self.fec_source.is_set or
                                                self.fec_tunnel_id.is_set or
                                                self.fec_vrf.is_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                self.fec_source.yfilter != YFilter.not_set or
                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "fec" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "fec-destination-info"):
                                                if (self.fec_destination_info is None):
                                                    self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                    self.fec_destination_info.parent = self
                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                return self.fec_destination_info

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "fec-extended-tunnel-id"):
                                                self.fec_extended_tunnel_id = value
                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-lsp-id"):
                                                self.fec_lsp_id = value
                                                self.fec_lsp_id.value_namespace = name_space
                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-source"):
                                                self.fec_source = value
                                                self.fec_source.value_namespace = name_space
                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-tunnel-id"):
                                                self.fec_tunnel_id = value
                                                self.fec_tunnel_id.value_namespace = name_space
                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-vrf"):
                                                self.fec_vrf = value
                                                self.fec_vrf.value_namespace = name_space
                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.destination_node_exception.is_set or
                                            self.exclusion_type.is_set or
                                            self.ignore_lsp_id.is_set or
                                            self.penultimate_node_exception.is_set or
                                            self.processing_node_exception.is_set or
                                            (self.fec is not None and self.fec.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                            (self.fec is not None and self.fec.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "lsp-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "fec"):
                                            if (self.fec is None):
                                                self.fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.LspSubobject.Fec()
                                                self.fec.parent = self
                                                self._children_name_map["fec"] = "fec"
                                            return self.fec

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "destination-node-exception"):
                                            self.destination_node_exception = value
                                            self.destination_node_exception.value_namespace = name_space
                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ignore-lsp-id"):
                                            self.ignore_lsp_id = value
                                            self.ignore_lsp_id.value_namespace = name_space
                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "penultimate-node-exception"):
                                            self.penultimate_node_exception = value
                                            self.penultimate_node_exception.value_namespace = name_space
                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "processing-node-exception"):
                                            self.processing_node_exception = value
                                            self.processing_node_exception.value_namespace = name_space
                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.type.is_set or
                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "as-subobject"):
                                        if (self.as_subobject is None):
                                            self.as_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.AsSubobject()
                                            self.as_subobject.parent = self
                                            self._children_name_map["as_subobject"] = "as-subobject"
                                        return self.as_subobject

                                    if (child_yang_name == "ipv4-subobject"):
                                        if (self.ipv4_subobject is None):
                                            self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.Ipv4Subobject()
                                            self.ipv4_subobject.parent = self
                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                        return self.ipv4_subobject

                                    if (child_yang_name == "ipv6-subobject"):
                                        if (self.ipv6_subobject is None):
                                            self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.Ipv6Subobject()
                                            self.ipv6_subobject.parent = self
                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                        return self.ipv6_subobject

                                    if (child_yang_name == "lsp-subobject"):
                                        if (self.lsp_subobject is None):
                                            self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.LspSubobject()
                                            self.lsp_subobject.parent = self
                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                        return self.lsp_subobject

                                    if (child_yang_name == "srlg-subobject"):
                                        if (self.srlg_subobject is None):
                                            self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.SrlgSubobject()
                                            self.srlg_subobject.parent = self
                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                        return self.srlg_subobject

                                    if (child_yang_name == "unnumbered-subobject"):
                                        if (self.unnumbered_subobject is None):
                                            self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject.UnnumberedSubobject()
                                            self.unnumbered_subobject.parent = self
                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                        return self.unnumbered_subobject

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.xro_subobject:
                                    if (c.has_data()):
                                        return True
                                return self.mutual_diversity_flag.is_set

                            def has_operation(self):
                                for c in self.xro_subobject:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "in-xro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "xro-subobject"):
                                    for c in self.xro_subobject:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro.XroSubobject()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.xro_subobject.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "mutual-diversity-flag"):
                                    self.mutual_diversity_flag = value
                                    self.mutual_diversity_flag.value_namespace = name_space
                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix


                        class Tspec(Entity):
                            """
                            The T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.Tspec, self).__init__()

                                self.yang_name = "tspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.Tspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.Tspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class GenericTspec(Entity):
                            """
                            Generic TSpec
                            
                            .. attribute:: otntspec
                            
                            	TE TSpec for G709 OTN
                            	**type**\:   :py:class:`Otntspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GenericTspec.Otntspec>`
                            
                            .. attribute:: tspec_type
                            
                            	TSpecType
                            	**type**\:   :py:class:`TeMgmtGenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericTspec>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GenericTspec, self).__init__()

                                self.yang_name = "generic-tspec"
                                self.yang_parent_name = "s2l"

                                self.tspec_type = YLeaf(YType.enumeration, "tspec-type")

                                self.otntspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GenericTspec.Otntspec()
                                self.otntspec.parent = self
                                self._children_name_map["otntspec"] = "otntspec"
                                self._children_yang_names.add("otntspec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("tspec_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GenericTspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GenericTspec, self).__setattr__(name, value)


                            class Otntspec(Entity):
                                """
                                TE TSpec for G709 OTN
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GenericTspec.Otntspec, self).__init__()

                                    self.yang_name = "otntspec"
                                    self.yang_parent_name = "generic-tspec"

                                    self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                    self.multiplier = YLeaf(YType.uint16, "multiplier")

                                    self.nmc_or_tolerance = YLeaf(YType.uint16, "nmc-or-tolerance")

                                    self.nvc = YLeaf(YType.uint16, "nvc")

                                    self.signal_type = YLeaf(YType.uint8, "signal-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bit_rate",
                                                    "multiplier",
                                                    "nmc_or_tolerance",
                                                    "nvc",
                                                    "signal_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GenericTspec.Otntspec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GenericTspec.Otntspec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.bit_rate.is_set or
                                        self.multiplier.is_set or
                                        self.nmc_or_tolerance.is_set or
                                        self.nvc.is_set or
                                        self.signal_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bit_rate.yfilter != YFilter.not_set or
                                        self.multiplier.yfilter != YFilter.not_set or
                                        self.nmc_or_tolerance.yfilter != YFilter.not_set or
                                        self.nvc.yfilter != YFilter.not_set or
                                        self.signal_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otntspec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                    if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.multiplier.get_name_leafdata())
                                    if (self.nmc_or_tolerance.is_set or self.nmc_or_tolerance.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nmc_or_tolerance.get_name_leafdata())
                                    if (self.nvc.is_set or self.nvc.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nvc.get_name_leafdata())
                                    if (self.signal_type.is_set or self.signal_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signal_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bit-rate" or name == "multiplier" or name == "nmc-or-tolerance" or name == "nvc" or name == "signal-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bit-rate"):
                                        self.bit_rate = value
                                        self.bit_rate.value_namespace = name_space
                                        self.bit_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "multiplier"):
                                        self.multiplier = value
                                        self.multiplier.value_namespace = name_space
                                        self.multiplier.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nmc-or-tolerance"):
                                        self.nmc_or_tolerance = value
                                        self.nmc_or_tolerance.value_namespace = name_space
                                        self.nmc_or_tolerance.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nvc"):
                                        self.nvc = value
                                        self.nvc.value_namespace = name_space
                                        self.nvc.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signal-type"):
                                        self.signal_type = value
                                        self.signal_type.value_namespace = name_space
                                        self.signal_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.tspec_type.is_set or
                                    (self.otntspec is not None and self.otntspec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.tspec_type.yfilter != YFilter.not_set or
                                    (self.otntspec is not None and self.otntspec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "generic-tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.tspec_type.is_set or self.tspec_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tspec_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "otntspec"):
                                    if (self.otntspec is None):
                                        self.otntspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GenericTspec.Otntspec()
                                        self.otntspec.parent = self
                                        self._children_name_map["otntspec"] = "otntspec"
                                    return self.otntspec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "otntspec" or name == "tspec-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "tspec-type"):
                                    self.tspec_type = value
                                    self.tspec_type.value_namespace = name_space
                                    self.tspec_type.value_namespace_prefix = name_space_prefix


                        class Fspec(Entity):
                            """
                            The F spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.Fspec, self).__init__()

                                self.yang_name = "fspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.Fspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.Fspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class GenericFspec(Entity):
                            """
                            Generic FSpec
                            
                            .. attribute:: fspec_type
                            
                            	FSpecType
                            	**type**\:   :py:class:`TeMgmtGenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericFspec>`
                            
                            .. attribute:: otnfspec
                            
                            	TE FSpec for G709 OTN
                            	**type**\:   :py:class:`Otnfspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GenericFspec.Otnfspec>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GenericFspec, self).__init__()

                                self.yang_name = "generic-fspec"
                                self.yang_parent_name = "s2l"

                                self.fspec_type = YLeaf(YType.enumeration, "fspec-type")

                                self.otnfspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GenericFspec.Otnfspec()
                                self.otnfspec.parent = self
                                self._children_name_map["otnfspec"] = "otnfspec"
                                self._children_yang_names.add("otnfspec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fspec_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GenericFspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GenericFspec, self).__setattr__(name, value)


                            class Otnfspec(Entity):
                                """
                                TE FSpec for G709 OTN
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GenericFspec.Otnfspec, self).__init__()

                                    self.yang_name = "otnfspec"
                                    self.yang_parent_name = "generic-fspec"

                                    self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                    self.multiplier = YLeaf(YType.uint16, "multiplier")

                                    self.nmc_or_tolerance = YLeaf(YType.uint16, "nmc-or-tolerance")

                                    self.nvc = YLeaf(YType.uint16, "nvc")

                                    self.signal_type = YLeaf(YType.uint8, "signal-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bit_rate",
                                                    "multiplier",
                                                    "nmc_or_tolerance",
                                                    "nvc",
                                                    "signal_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GenericFspec.Otnfspec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GenericFspec.Otnfspec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.bit_rate.is_set or
                                        self.multiplier.is_set or
                                        self.nmc_or_tolerance.is_set or
                                        self.nvc.is_set or
                                        self.signal_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bit_rate.yfilter != YFilter.not_set or
                                        self.multiplier.yfilter != YFilter.not_set or
                                        self.nmc_or_tolerance.yfilter != YFilter.not_set or
                                        self.nvc.yfilter != YFilter.not_set or
                                        self.signal_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otnfspec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                    if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.multiplier.get_name_leafdata())
                                    if (self.nmc_or_tolerance.is_set or self.nmc_or_tolerance.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nmc_or_tolerance.get_name_leafdata())
                                    if (self.nvc.is_set or self.nvc.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nvc.get_name_leafdata())
                                    if (self.signal_type.is_set or self.signal_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signal_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bit-rate" or name == "multiplier" or name == "nmc-or-tolerance" or name == "nvc" or name == "signal-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bit-rate"):
                                        self.bit_rate = value
                                        self.bit_rate.value_namespace = name_space
                                        self.bit_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "multiplier"):
                                        self.multiplier = value
                                        self.multiplier.value_namespace = name_space
                                        self.multiplier.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nmc-or-tolerance"):
                                        self.nmc_or_tolerance = value
                                        self.nmc_or_tolerance.value_namespace = name_space
                                        self.nmc_or_tolerance.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nvc"):
                                        self.nvc = value
                                        self.nvc.value_namespace = name_space
                                        self.nvc.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signal-type"):
                                        self.signal_type = value
                                        self.signal_type.value_namespace = name_space
                                        self.signal_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.fspec_type.is_set or
                                    (self.otnfspec is not None and self.otnfspec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fspec_type.yfilter != YFilter.not_set or
                                    (self.otnfspec is not None and self.otnfspec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "generic-fspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fspec_type.is_set or self.fspec_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fspec_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "otnfspec"):
                                    if (self.otnfspec is None):
                                        self.otnfspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GenericFspec.Otnfspec()
                                        self.otnfspec.parent = self
                                        self._children_name_map["otnfspec"] = "otnfspec"
                                    return self.otnfspec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "otnfspec" or name == "fspec-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fspec-type"):
                                    self.fspec_type = value
                                    self.fspec_type.value_namespace = name_space
                                    self.fspec_type.value_namespace_prefix = name_space_prefix


                        class NextHopAddressGeneric(Entity):
                            """
                            Next hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.NextHopAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.NextHopAddressGeneric, self).__init__()

                                self.yang_name = "next-hop-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.NextHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.NextHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "next-hop-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.NextHopAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.NextHopAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "next-hop-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.NextHopAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class PreviousHopAddressGeneric(Entity):
                            """
                            Previous hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PreviousHopAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PreviousHopAddressGeneric, self).__init__()

                                self.yang_name = "previous-hop-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PreviousHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "previous-hop-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "previous-hop-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PreviousHopAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class IncomingAddressGeneric(Entity):
                            """
                            Incoming interface address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.IncomingAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.IncomingAddressGeneric, self).__init__()

                                self.yang_name = "incoming-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.IncomingAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.IncomingAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "incoming-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.IncomingAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.IncomingAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "incoming-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.IncomingAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class S2LConvergence(Entity):
                            """
                            TE LSP convergence related information
                            
                            .. attribute:: creation_time
                            
                            	Tunnel creation timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: label_rewrite
                            
                            	LSP Label rewrite timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_in
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_out
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_in
                            
                            	LSP RSVP Resv\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_out
                            
                            	LSP RSVP Resv\-out timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: tunnel_rewrite
                            
                            	Tunnel rewrite timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.S2LConvergence, self).__init__()

                                self.yang_name = "s2l-convergence"
                                self.yang_parent_name = "s2l"

                                self.creation_time = YLeaf(YType.uint64, "creation-time")

                                self.label_rewrite = YLeaf(YType.uint64, "label-rewrite")

                                self.path_in = YLeaf(YType.uint64, "path-in")

                                self.path_out = YLeaf(YType.uint64, "path-out")

                                self.resv_in = YLeaf(YType.uint64, "resv-in")

                                self.resv_out = YLeaf(YType.uint64, "resv-out")

                                self.tunnel_rewrite = YLeaf(YType.uint64, "tunnel-rewrite")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("creation_time",
                                                "label_rewrite",
                                                "path_in",
                                                "path_out",
                                                "resv_in",
                                                "resv_out",
                                                "tunnel_rewrite") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.S2LConvergence, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.S2LConvergence, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.creation_time.is_set or
                                    self.label_rewrite.is_set or
                                    self.path_in.is_set or
                                    self.path_out.is_set or
                                    self.resv_in.is_set or
                                    self.resv_out.is_set or
                                    self.tunnel_rewrite.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.creation_time.yfilter != YFilter.not_set or
                                    self.label_rewrite.yfilter != YFilter.not_set or
                                    self.path_in.yfilter != YFilter.not_set or
                                    self.path_out.yfilter != YFilter.not_set or
                                    self.resv_in.yfilter != YFilter.not_set or
                                    self.resv_out.yfilter != YFilter.not_set or
                                    self.tunnel_rewrite.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-convergence" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.creation_time.is_set or self.creation_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.creation_time.get_name_leafdata())
                                if (self.label_rewrite.is_set or self.label_rewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_rewrite.get_name_leafdata())
                                if (self.path_in.is_set or self.path_in.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_in.get_name_leafdata())
                                if (self.path_out.is_set or self.path_out.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_out.get_name_leafdata())
                                if (self.resv_in.is_set or self.resv_in.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.resv_in.get_name_leafdata())
                                if (self.resv_out.is_set or self.resv_out.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.resv_out.get_name_leafdata())
                                if (self.tunnel_rewrite.is_set or self.tunnel_rewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_rewrite.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "creation-time" or name == "label-rewrite" or name == "path-in" or name == "path-out" or name == "resv-in" or name == "resv-out" or name == "tunnel-rewrite"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "creation-time"):
                                    self.creation_time = value
                                    self.creation_time.value_namespace = name_space
                                    self.creation_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "label-rewrite"):
                                    self.label_rewrite = value
                                    self.label_rewrite.value_namespace = name_space
                                    self.label_rewrite.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-in"):
                                    self.path_in = value
                                    self.path_in.value_namespace = name_space
                                    self.path_in.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-out"):
                                    self.path_out = value
                                    self.path_out.value_namespace = name_space
                                    self.path_out.value_namespace_prefix = name_space_prefix
                                if(value_path == "resv-in"):
                                    self.resv_in = value
                                    self.resv_in.value_namespace = name_space
                                    self.resv_in.value_namespace_prefix = name_space_prefix
                                if(value_path == "resv-out"):
                                    self.resv_out = value
                                    self.resv_out.value_namespace = name_space
                                    self.resv_out.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-rewrite"):
                                    self.tunnel_rewrite = value
                                    self.tunnel_rewrite.value_namespace = name_space
                                    self.tunnel_rewrite.value_namespace_prefix = name_space_prefix


                        class SoftPreemption(Entity):
                            """
                            The soft preemption info for this LSP.
                            
                            .. attribute:: fr_rrewrite
                            
                            	FRR\-rewrite during soft preemption
                            	**type**\:  bool
                            
                            .. attribute:: fr_rrewrite_tunnel_name
                            
                            	The tunnel name of the backup
                            	**type**\:  str
                            
                            .. attribute:: preempting_link_address
                            
                            	The address of the link where the preemption happened
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: soft_preemption_link
                            
                            	Name of the link where the soft preemption occurred
                            	**type**\:  str
                            
                            .. attribute:: soft_preemption_timestamp
                            
                            	The POSIX timestamp when the soft preemption occurred
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: status
                            
                            	The current state of the soft preemption operation
                            	**type**\:   :py:class:`MplsTeSoftPreemptionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeSoftPreemptionState>`
                            
                            .. attribute:: time_to_hard_preemption
                            
                            	The number of seconds until hard preemption is triggered
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.SoftPreemption, self).__init__()

                                self.yang_name = "soft-preemption"
                                self.yang_parent_name = "s2l"

                                self.fr_rrewrite = YLeaf(YType.boolean, "fr-rrewrite")

                                self.fr_rrewrite_tunnel_name = YLeaf(YType.str, "fr-rrewrite-tunnel-name")

                                self.preempting_link_address = YLeaf(YType.str, "preempting-link-address")

                                self.soft_preemption_link = YLeaf(YType.str, "soft-preemption-link")

                                self.soft_preemption_timestamp = YLeaf(YType.uint32, "soft-preemption-timestamp")

                                self.status = YLeaf(YType.enumeration, "status")

                                self.time_to_hard_preemption = YLeaf(YType.uint16, "time-to-hard-preemption")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fr_rrewrite",
                                                "fr_rrewrite_tunnel_name",
                                                "preempting_link_address",
                                                "soft_preemption_link",
                                                "soft_preemption_timestamp",
                                                "status",
                                                "time_to_hard_preemption") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.SoftPreemption, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.SoftPreemption, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.fr_rrewrite.is_set or
                                    self.fr_rrewrite_tunnel_name.is_set or
                                    self.preempting_link_address.is_set or
                                    self.soft_preemption_link.is_set or
                                    self.soft_preemption_timestamp.is_set or
                                    self.status.is_set or
                                    self.time_to_hard_preemption.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fr_rrewrite.yfilter != YFilter.not_set or
                                    self.fr_rrewrite_tunnel_name.yfilter != YFilter.not_set or
                                    self.preempting_link_address.yfilter != YFilter.not_set or
                                    self.soft_preemption_link.yfilter != YFilter.not_set or
                                    self.soft_preemption_timestamp.yfilter != YFilter.not_set or
                                    self.status.yfilter != YFilter.not_set or
                                    self.time_to_hard_preemption.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "soft-preemption" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fr_rrewrite.is_set or self.fr_rrewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fr_rrewrite.get_name_leafdata())
                                if (self.fr_rrewrite_tunnel_name.is_set or self.fr_rrewrite_tunnel_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fr_rrewrite_tunnel_name.get_name_leafdata())
                                if (self.preempting_link_address.is_set or self.preempting_link_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.preempting_link_address.get_name_leafdata())
                                if (self.soft_preemption_link.is_set or self.soft_preemption_link.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.soft_preemption_link.get_name_leafdata())
                                if (self.soft_preemption_timestamp.is_set or self.soft_preemption_timestamp.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.soft_preemption_timestamp.get_name_leafdata())
                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.status.get_name_leafdata())
                                if (self.time_to_hard_preemption.is_set or self.time_to_hard_preemption.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.time_to_hard_preemption.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fr-rrewrite" or name == "fr-rrewrite-tunnel-name" or name == "preempting-link-address" or name == "soft-preemption-link" or name == "soft-preemption-timestamp" or name == "status" or name == "time-to-hard-preemption"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fr-rrewrite"):
                                    self.fr_rrewrite = value
                                    self.fr_rrewrite.value_namespace = name_space
                                    self.fr_rrewrite.value_namespace_prefix = name_space_prefix
                                if(value_path == "fr-rrewrite-tunnel-name"):
                                    self.fr_rrewrite_tunnel_name = value
                                    self.fr_rrewrite_tunnel_name.value_namespace = name_space
                                    self.fr_rrewrite_tunnel_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "preempting-link-address"):
                                    self.preempting_link_address = value
                                    self.preempting_link_address.value_namespace = name_space
                                    self.preempting_link_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "soft-preemption-link"):
                                    self.soft_preemption_link = value
                                    self.soft_preemption_link.value_namespace = name_space
                                    self.soft_preemption_link.value_namespace_prefix = name_space_prefix
                                if(value_path == "soft-preemption-timestamp"):
                                    self.soft_preemption_timestamp = value
                                    self.soft_preemption_timestamp.value_namespace = name_space
                                    self.soft_preemption_timestamp.value_namespace_prefix = name_space_prefix
                                if(value_path == "status"):
                                    self.status = value
                                    self.status.value_namespace = name_space
                                    self.status.value_namespace_prefix = name_space_prefix
                                if(value_path == "time-to-hard-preemption"):
                                    self.time_to_hard_preemption = value
                                    self.time_to_hard_preemption.value_namespace = name_space
                                    self.time_to_hard_preemption.value_namespace_prefix = name_space_prefix


                        class GmplsLabels(Entity):
                            """
                            GMPLS labels
                            
                            .. attribute:: path_egress_label
                            
                            	Path message (upstream) egress label
                            	**type**\:   :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel>`
                            
                            .. attribute:: path_ingress_label
                            
                            	Path message (upstream) ingress label
                            	**type**\:   :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel>`
                            
                            .. attribute:: resv_egress_label
                            
                            	Resv message (downstream) egress label
                            	**type**\:   :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel>`
                            
                            .. attribute:: resv_ingress_label
                            
                            	Resv message (downstream) ingress label
                            	**type**\:   :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels, self).__init__()

                                self.yang_name = "gmpls-labels"
                                self.yang_parent_name = "s2l"

                                self.path_egress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel()
                                self.path_egress_label.parent = self
                                self._children_name_map["path_egress_label"] = "path-egress-label"
                                self._children_yang_names.add("path-egress-label")

                                self.path_ingress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel()
                                self.path_ingress_label.parent = self
                                self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                self._children_yang_names.add("path-ingress-label")

                                self.resv_egress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel()
                                self.resv_egress_label.parent = self
                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                self._children_yang_names.add("resv-egress-label")

                                self.resv_ingress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel()
                                self.resv_ingress_label.parent = self
                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                self._children_yang_names.add("resv-ingress-label")


                            class PathIngressLabel(Entity):
                                """
                                Path message (upstream) ingress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel, self).__init__()

                                    self.yang_name = "path-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-ingress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-ingress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-ingress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class PathEgressLabel(Entity):
                                """
                                Path message (upstream) egress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel, self).__init__()

                                    self.yang_name = "path-egress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-egress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-egress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-egress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class ResvIngressLabel(Entity):
                                """
                                Resv message (downstream) ingress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel, self).__init__()

                                    self.yang_name = "resv-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-ingress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-ingress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "resv-ingress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class ResvEgressLabel(Entity):
                                """
                                Resv message (downstream) egress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel, self).__init__()

                                    self.yang_name = "resv-egress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-egress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-egress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "resv-egress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    (self.path_egress_label is not None and self.path_egress_label.has_data()) or
                                    (self.path_ingress_label is not None and self.path_ingress_label.has_data()) or
                                    (self.resv_egress_label is not None and self.resv_egress_label.has_data()) or
                                    (self.resv_ingress_label is not None and self.resv_ingress_label.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.path_egress_label is not None and self.path_egress_label.has_operation()) or
                                    (self.path_ingress_label is not None and self.path_ingress_label.has_operation()) or
                                    (self.resv_egress_label is not None and self.resv_egress_label.has_operation()) or
                                    (self.resv_ingress_label is not None and self.resv_ingress_label.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "gmpls-labels" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "path-egress-label"):
                                    if (self.path_egress_label is None):
                                        self.path_egress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"
                                    return self.path_egress_label

                                if (child_yang_name == "path-ingress-label"):
                                    if (self.path_ingress_label is None):
                                        self.path_ingress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                    return self.path_ingress_label

                                if (child_yang_name == "resv-egress-label"):
                                    if (self.resv_egress_label is None):
                                        self.resv_egress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                    return self.resv_egress_label

                                if (child_yang_name == "resv-ingress-label"):
                                    if (self.resv_ingress_label is None):
                                        self.resv_ingress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                    return self.resv_ingress_label

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "path-egress-label" or name == "path-ingress-label" or name == "resv-egress-label" or name == "resv-ingress-label"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class OtnS2L(Entity):
                            """
                            Otn S2L Information
                            
                            .. attribute:: aps
                            
                            	APS Info for OTN S2L
                            	**type**\:   :py:class:`Aps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Aps>`
                            
                            .. attribute:: otn
                            
                            	Info Related to OTN technology in S2L
                            	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L, self).__init__()

                                self.yang_name = "otn-s2l"
                                self.yang_parent_name = "s2l"

                                self.aps = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Aps()
                                self.aps.parent = self
                                self._children_name_map["aps"] = "aps"
                                self._children_yang_names.add("aps")

                                self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn()
                                self.otn.parent = self
                                self._children_name_map["otn"] = "otn"
                                self._children_yang_names.add("otn")


                            class Otn(Entity):
                                """
                                Info Related to OTN technology in S2L
                                
                                .. attribute:: bandwidth
                                
                                	OTN Bandwidth for s2l
                                	**type**\:   :py:class:`Bandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth>`
                                
                                .. attribute:: cross_connect_id
                                
                                	Cross connect id
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: gpid
                                
                                	Gpid Payload
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: incoming_controller
                                
                                	Incoming Controller
                                	**type**\:  str
                                
                                .. attribute:: incoming_controller_ifhandle
                                
                                	Incoming Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: incoming_controller_state
                                
                                	State of Incoming Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: incoming_sub_controller
                                
                                	Incoming Sub Controller
                                	**type**\:  str
                                
                                .. attribute:: incoming_sub_controller_ifhandle
                                
                                	Incoming Sub Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: incoming_sub_controller_state
                                
                                	State of Incoming Sub Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: is_connected
                                
                                	True if subcontrollers are connected
                                	**type**\:  bool
                                
                                .. attribute:: labels
                                
                                	Labels
                                	**type**\:   :py:class:`Labels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels>`
                                
                                .. attribute:: outgoing_controller
                                
                                	Outgoing Controller
                                	**type**\:  str
                                
                                .. attribute:: outgoing_controller_ifhandle
                                
                                	Outgoing Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: outgoing_controller_state
                                
                                	State of Outgoing Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: outgoing_sub_controller
                                
                                	Outgoing Sub Controller
                                	**type**\:  str
                                
                                .. attribute:: outgoing_sub_controller_ifhandle
                                
                                	Outgoing Sub Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: outgoing_sub_controller_state
                                
                                	State of Outgoing Sub Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: uptime
                                
                                	XC Uptime
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn, self).__init__()

                                    self.yang_name = "otn"
                                    self.yang_parent_name = "otn-s2l"

                                    self.cross_connect_id = YLeaf(YType.uint32, "cross-connect-id")

                                    self.gpid = YLeaf(YType.uint16, "gpid")

                                    self.incoming_controller = YLeaf(YType.str, "incoming-controller")

                                    self.incoming_controller_ifhandle = YLeaf(YType.str, "incoming-controller-ifhandle")

                                    self.incoming_controller_state = YLeaf(YType.enumeration, "incoming-controller-state")

                                    self.incoming_sub_controller = YLeaf(YType.str, "incoming-sub-controller")

                                    self.incoming_sub_controller_ifhandle = YLeaf(YType.str, "incoming-sub-controller-ifhandle")

                                    self.incoming_sub_controller_state = YLeaf(YType.enumeration, "incoming-sub-controller-state")

                                    self.is_connected = YLeaf(YType.boolean, "is-connected")

                                    self.outgoing_controller = YLeaf(YType.str, "outgoing-controller")

                                    self.outgoing_controller_ifhandle = YLeaf(YType.str, "outgoing-controller-ifhandle")

                                    self.outgoing_controller_state = YLeaf(YType.enumeration, "outgoing-controller-state")

                                    self.outgoing_sub_controller = YLeaf(YType.str, "outgoing-sub-controller")

                                    self.outgoing_sub_controller_ifhandle = YLeaf(YType.str, "outgoing-sub-controller-ifhandle")

                                    self.outgoing_sub_controller_state = YLeaf(YType.enumeration, "outgoing-sub-controller-state")

                                    self.uptime = YLeaf(YType.uint32, "uptime")

                                    self.bandwidth = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth()
                                    self.bandwidth.parent = self
                                    self._children_name_map["bandwidth"] = "bandwidth"
                                    self._children_yang_names.add("bandwidth")

                                    self.labels = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels()
                                    self.labels.parent = self
                                    self._children_name_map["labels"] = "labels"
                                    self._children_yang_names.add("labels")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("cross_connect_id",
                                                    "gpid",
                                                    "incoming_controller",
                                                    "incoming_controller_ifhandle",
                                                    "incoming_controller_state",
                                                    "incoming_sub_controller",
                                                    "incoming_sub_controller_ifhandle",
                                                    "incoming_sub_controller_state",
                                                    "is_connected",
                                                    "outgoing_controller",
                                                    "outgoing_controller_ifhandle",
                                                    "outgoing_controller_state",
                                                    "outgoing_sub_controller",
                                                    "outgoing_sub_controller_ifhandle",
                                                    "outgoing_sub_controller_state",
                                                    "uptime") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn, self).__setattr__(name, value)


                                class Bandwidth(Entity):
                                    """
                                    OTN Bandwidth for s2l
                                    
                                    .. attribute:: odu_flex_cbr
                                    
                                    	Odu flex CBR info
                                    	**type**\:   :py:class:`OduFlexCbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr>`
                                    
                                    .. attribute:: odu_flex_gfp_f_non_res
                                    
                                    	Odu flex GFP\-F non\-resizable info
                                    	**type**\:   :py:class:`OduFlexGfpFNonRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes>`
                                    
                                    .. attribute:: odu_flex_gfp_f_res
                                    
                                    	Odu flex GFP\-F resizable info
                                    	**type**\:   :py:class:`OduFlexGfpFRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes>`
                                    
                                    .. attribute:: odu_level
                                    
                                    	ODULevel
                                    	**type**\:   :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth, self).__init__()

                                        self.yang_name = "bandwidth"
                                        self.yang_parent_name = "otn"

                                        self.odu_level = YLeaf(YType.enumeration, "odu-level")

                                        self.odu_flex_cbr = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr()
                                        self.odu_flex_cbr.parent = self
                                        self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"
                                        self._children_yang_names.add("odu-flex-cbr")

                                        self.odu_flex_gfp_f_non_res = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes()
                                        self.odu_flex_gfp_f_non_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                        self._children_yang_names.add("odu-flex-gfp-f-non-res")

                                        self.odu_flex_gfp_f_res = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes()
                                        self.odu_flex_gfp_f_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"
                                        self._children_yang_names.add("odu-flex-gfp-f-res")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("odu_level") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth, self).__setattr__(name, value)


                                    class OduFlexCbr(Entity):
                                        """
                                        Odu flex CBR info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: tolerance
                                        
                                        	Tolerance
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__init__()

                                            self.yang_name = "odu-flex-cbr"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                            self.tolerance = YLeaf(YType.uint16, "tolerance")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate",
                                                            "tolerance") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.bit_rate.is_set or
                                                self.tolerance.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set or
                                                self.tolerance.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-cbr" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                            if (self.tolerance.is_set or self.tolerance.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tolerance.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate" or name == "tolerance"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tolerance"):
                                                self.tolerance = value
                                                self.tolerance.value_namespace = name_space
                                                self.tolerance.value_namespace_prefix = name_space_prefix


                                    class OduFlexGfpFRes(Entity):
                                        """
                                        Odu flex GFP\-F resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-res"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.bit_rate.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-gfp-f-res" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix


                                    class OduFlexGfpFNonRes(Entity):
                                        """
                                        Odu flex GFP\-F non\-resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-non-res"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.bit_rate.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-gfp-f-non-res" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.odu_level.is_set or
                                            (self.odu_flex_cbr is not None and self.odu_flex_cbr.has_data()) or
                                            (self.odu_flex_gfp_f_non_res is not None and self.odu_flex_gfp_f_non_res.has_data()) or
                                            (self.odu_flex_gfp_f_res is not None and self.odu_flex_gfp_f_res.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.odu_level.yfilter != YFilter.not_set or
                                            (self.odu_flex_cbr is not None and self.odu_flex_cbr.has_operation()) or
                                            (self.odu_flex_gfp_f_non_res is not None and self.odu_flex_gfp_f_non_res.has_operation()) or
                                            (self.odu_flex_gfp_f_res is not None and self.odu_flex_gfp_f_res.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "bandwidth" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.odu_level.is_set or self.odu_level.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.odu_level.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "odu-flex-cbr"):
                                            if (self.odu_flex_cbr is None):
                                                self.odu_flex_cbr = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr()
                                                self.odu_flex_cbr.parent = self
                                                self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"
                                            return self.odu_flex_cbr

                                        if (child_yang_name == "odu-flex-gfp-f-non-res"):
                                            if (self.odu_flex_gfp_f_non_res is None):
                                                self.odu_flex_gfp_f_non_res = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes()
                                                self.odu_flex_gfp_f_non_res.parent = self
                                                self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                            return self.odu_flex_gfp_f_non_res

                                        if (child_yang_name == "odu-flex-gfp-f-res"):
                                            if (self.odu_flex_gfp_f_res is None):
                                                self.odu_flex_gfp_f_res = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes()
                                                self.odu_flex_gfp_f_res.parent = self
                                                self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"
                                            return self.odu_flex_gfp_f_res

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "odu-flex-cbr" or name == "odu-flex-gfp-f-non-res" or name == "odu-flex-gfp-f-res" or name == "odu-level"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "odu-level"):
                                            self.odu_level = value
                                            self.odu_level.value_namespace = name_space
                                            self.odu_level.value_namespace_prefix = name_space_prefix


                                class Labels(Entity):
                                    """
                                    Labels
                                    
                                    .. attribute:: path_egress_label
                                    
                                    	Path message (upstream) egress label
                                    	**type**\:   :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel>`
                                    
                                    .. attribute:: path_ingress_label
                                    
                                    	Path message (upstream) ingress label
                                    	**type**\:   :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel>`
                                    
                                    .. attribute:: resv_egress_label
                                    
                                    	Resv message (downstream) egress label
                                    	**type**\:   :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel>`
                                    
                                    .. attribute:: resv_ingress_label
                                    
                                    	Resv message (downstream) ingress label
                                    	**type**\:   :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels, self).__init__()

                                        self.yang_name = "labels"
                                        self.yang_parent_name = "otn"

                                        self.path_egress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"
                                        self._children_yang_names.add("path-egress-label")

                                        self.path_ingress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                        self._children_yang_names.add("path-ingress-label")

                                        self.resv_egress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                        self._children_yang_names.add("resv-egress-label")

                                        self.resv_ingress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                        self._children_yang_names.add("resv-ingress-label")


                                    class PathIngressLabel(Entity):
                                        """
                                        Path message (upstream) ingress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__init__()

                                            self.yang_name = "path-ingress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-ingress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-ingress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "path-ingress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class PathEgressLabel(Entity):
                                        """
                                        Path message (upstream) egress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__init__()

                                            self.yang_name = "path-egress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-egress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-egress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "path-egress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class ResvIngressLabel(Entity):
                                        """
                                        Resv message (downstream) ingress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__init__()

                                            self.yang_name = "resv-ingress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-ingress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-ingress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "resv-ingress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class ResvEgressLabel(Entity):
                                        """
                                        Resv message (downstream) egress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__init__()

                                            self.yang_name = "resv-egress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-egress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-egress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "resv-egress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            (self.path_egress_label is not None and self.path_egress_label.has_data()) or
                                            (self.path_ingress_label is not None and self.path_ingress_label.has_data()) or
                                            (self.resv_egress_label is not None and self.resv_egress_label.has_data()) or
                                            (self.resv_ingress_label is not None and self.resv_ingress_label.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.path_egress_label is not None and self.path_egress_label.has_operation()) or
                                            (self.path_ingress_label is not None and self.path_ingress_label.has_operation()) or
                                            (self.resv_egress_label is not None and self.resv_egress_label.has_operation()) or
                                            (self.resv_ingress_label is not None and self.resv_ingress_label.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "labels" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "path-egress-label"):
                                            if (self.path_egress_label is None):
                                                self.path_egress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel()
                                                self.path_egress_label.parent = self
                                                self._children_name_map["path_egress_label"] = "path-egress-label"
                                            return self.path_egress_label

                                        if (child_yang_name == "path-ingress-label"):
                                            if (self.path_ingress_label is None):
                                                self.path_ingress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel()
                                                self.path_ingress_label.parent = self
                                                self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                            return self.path_ingress_label

                                        if (child_yang_name == "resv-egress-label"):
                                            if (self.resv_egress_label is None):
                                                self.resv_egress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel()
                                                self.resv_egress_label.parent = self
                                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                            return self.resv_egress_label

                                        if (child_yang_name == "resv-ingress-label"):
                                            if (self.resv_ingress_label is None):
                                                self.resv_ingress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel()
                                                self.resv_ingress_label.parent = self
                                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                            return self.resv_ingress_label

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "path-egress-label" or name == "path-ingress-label" or name == "resv-egress-label" or name == "resv-ingress-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass

                                def has_data(self):
                                    return (
                                        self.cross_connect_id.is_set or
                                        self.gpid.is_set or
                                        self.incoming_controller.is_set or
                                        self.incoming_controller_ifhandle.is_set or
                                        self.incoming_controller_state.is_set or
                                        self.incoming_sub_controller.is_set or
                                        self.incoming_sub_controller_ifhandle.is_set or
                                        self.incoming_sub_controller_state.is_set or
                                        self.is_connected.is_set or
                                        self.outgoing_controller.is_set or
                                        self.outgoing_controller_ifhandle.is_set or
                                        self.outgoing_controller_state.is_set or
                                        self.outgoing_sub_controller.is_set or
                                        self.outgoing_sub_controller_ifhandle.is_set or
                                        self.outgoing_sub_controller_state.is_set or
                                        self.uptime.is_set or
                                        (self.bandwidth is not None and self.bandwidth.has_data()) or
                                        (self.labels is not None and self.labels.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.cross_connect_id.yfilter != YFilter.not_set or
                                        self.gpid.yfilter != YFilter.not_set or
                                        self.incoming_controller.yfilter != YFilter.not_set or
                                        self.incoming_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.incoming_controller_state.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller_state.yfilter != YFilter.not_set or
                                        self.is_connected.yfilter != YFilter.not_set or
                                        self.outgoing_controller.yfilter != YFilter.not_set or
                                        self.outgoing_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.outgoing_controller_state.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller_state.yfilter != YFilter.not_set or
                                        self.uptime.yfilter != YFilter.not_set or
                                        (self.bandwidth is not None and self.bandwidth.has_operation()) or
                                        (self.labels is not None and self.labels.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otn" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.cross_connect_id.is_set or self.cross_connect_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.cross_connect_id.get_name_leafdata())
                                    if (self.gpid.is_set or self.gpid.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.gpid.get_name_leafdata())
                                    if (self.incoming_controller.is_set or self.incoming_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller.get_name_leafdata())
                                    if (self.incoming_controller_ifhandle.is_set or self.incoming_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller_ifhandle.get_name_leafdata())
                                    if (self.incoming_controller_state.is_set or self.incoming_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller_state.get_name_leafdata())
                                    if (self.incoming_sub_controller.is_set or self.incoming_sub_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller.get_name_leafdata())
                                    if (self.incoming_sub_controller_ifhandle.is_set or self.incoming_sub_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller_ifhandle.get_name_leafdata())
                                    if (self.incoming_sub_controller_state.is_set or self.incoming_sub_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller_state.get_name_leafdata())
                                    if (self.is_connected.is_set or self.is_connected.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_connected.get_name_leafdata())
                                    if (self.outgoing_controller.is_set or self.outgoing_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller.get_name_leafdata())
                                    if (self.outgoing_controller_ifhandle.is_set or self.outgoing_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller_ifhandle.get_name_leafdata())
                                    if (self.outgoing_controller_state.is_set or self.outgoing_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller_state.get_name_leafdata())
                                    if (self.outgoing_sub_controller.is_set or self.outgoing_sub_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller.get_name_leafdata())
                                    if (self.outgoing_sub_controller_ifhandle.is_set or self.outgoing_sub_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller_ifhandle.get_name_leafdata())
                                    if (self.outgoing_sub_controller_state.is_set or self.outgoing_sub_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller_state.get_name_leafdata())
                                    if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.uptime.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "bandwidth"):
                                        if (self.bandwidth is None):
                                            self.bandwidth = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Bandwidth()
                                            self.bandwidth.parent = self
                                            self._children_name_map["bandwidth"] = "bandwidth"
                                        return self.bandwidth

                                    if (child_yang_name == "labels"):
                                        if (self.labels is None):
                                            self.labels = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn.Labels()
                                            self.labels.parent = self
                                            self._children_name_map["labels"] = "labels"
                                        return self.labels

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bandwidth" or name == "labels" or name == "cross-connect-id" or name == "gpid" or name == "incoming-controller" or name == "incoming-controller-ifhandle" or name == "incoming-controller-state" or name == "incoming-sub-controller" or name == "incoming-sub-controller-ifhandle" or name == "incoming-sub-controller-state" or name == "is-connected" or name == "outgoing-controller" or name == "outgoing-controller-ifhandle" or name == "outgoing-controller-state" or name == "outgoing-sub-controller" or name == "outgoing-sub-controller-ifhandle" or name == "outgoing-sub-controller-state" or name == "uptime"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "cross-connect-id"):
                                        self.cross_connect_id = value
                                        self.cross_connect_id.value_namespace = name_space
                                        self.cross_connect_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "gpid"):
                                        self.gpid = value
                                        self.gpid.value_namespace = name_space
                                        self.gpid.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller"):
                                        self.incoming_controller = value
                                        self.incoming_controller.value_namespace = name_space
                                        self.incoming_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller-ifhandle"):
                                        self.incoming_controller_ifhandle = value
                                        self.incoming_controller_ifhandle.value_namespace = name_space
                                        self.incoming_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller-state"):
                                        self.incoming_controller_state = value
                                        self.incoming_controller_state.value_namespace = name_space
                                        self.incoming_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller"):
                                        self.incoming_sub_controller = value
                                        self.incoming_sub_controller.value_namespace = name_space
                                        self.incoming_sub_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller-ifhandle"):
                                        self.incoming_sub_controller_ifhandle = value
                                        self.incoming_sub_controller_ifhandle.value_namespace = name_space
                                        self.incoming_sub_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller-state"):
                                        self.incoming_sub_controller_state = value
                                        self.incoming_sub_controller_state.value_namespace = name_space
                                        self.incoming_sub_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-connected"):
                                        self.is_connected = value
                                        self.is_connected.value_namespace = name_space
                                        self.is_connected.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller"):
                                        self.outgoing_controller = value
                                        self.outgoing_controller.value_namespace = name_space
                                        self.outgoing_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller-ifhandle"):
                                        self.outgoing_controller_ifhandle = value
                                        self.outgoing_controller_ifhandle.value_namespace = name_space
                                        self.outgoing_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller-state"):
                                        self.outgoing_controller_state = value
                                        self.outgoing_controller_state.value_namespace = name_space
                                        self.outgoing_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller"):
                                        self.outgoing_sub_controller = value
                                        self.outgoing_sub_controller.value_namespace = name_space
                                        self.outgoing_sub_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller-ifhandle"):
                                        self.outgoing_sub_controller_ifhandle = value
                                        self.outgoing_sub_controller_ifhandle.value_namespace = name_space
                                        self.outgoing_sub_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller-state"):
                                        self.outgoing_sub_controller_state = value
                                        self.outgoing_sub_controller_state.value_namespace = name_space
                                        self.outgoing_sub_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "uptime"):
                                        self.uptime = value
                                        self.uptime.value_namespace = name_space
                                        self.uptime.value_namespace_prefix = name_space_prefix


                            class Aps(Entity):
                                """
                                APS Info for OTN S2L
                                
                                .. attribute:: protection_info
                                
                                	Protection Info
                                	**type**\:   :py:class:`ProtectionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Aps.ProtectionInfo>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Aps, self).__init__()

                                    self.yang_name = "aps"
                                    self.yang_parent_name = "otn-s2l"

                                    self.protection_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Aps.ProtectionInfo()
                                    self.protection_info.parent = self
                                    self._children_name_map["protection_info"] = "protection-info"
                                    self._children_yang_names.add("protection-info")


                                class ProtectionInfo(Entity):
                                    """
                                    Protection Info
                                    
                                    .. attribute:: ho_timeout
                                    
                                    	Hold\-Off timeout
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: is_hopresent
                                    
                                    	Is Hold\-Off timeout present
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_snc_mode_present
                                    
                                    	Is SNC mode present
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_wtr_present
                                    
                                    	Is Wait\-to\-Restore timeout present
                                    	**type**\:  bool
                                    
                                    .. attribute:: nbit
                                    
                                    	Notification bit 
                                    	**type**\:  bool
                                    
                                    .. attribute:: obit
                                    
                                    	Operational bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path protection profile type
                                    	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    .. attribute:: pbit
                                    
                                    	Protecting bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: protect_type
                                    
                                    	LSP Protect Type
                                    	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    .. attribute:: sbit
                                    
                                    	Secondary bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: snc_mode
                                    
                                    	SNC mode
                                    	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    .. attribute:: tcm_id
                                    
                                    	TCM ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: wtr_timeout
                                    
                                    	Wait\-to\-Restore timeout
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__init__()

                                        self.yang_name = "protection-info"
                                        self.yang_parent_name = "aps"

                                        self.ho_timeout = YLeaf(YType.uint32, "ho-timeout")

                                        self.is_hopresent = YLeaf(YType.boolean, "is-hopresent")

                                        self.is_snc_mode_present = YLeaf(YType.boolean, "is-snc-mode-present")

                                        self.is_wtr_present = YLeaf(YType.boolean, "is-wtr-present")

                                        self.nbit = YLeaf(YType.boolean, "nbit")

                                        self.obit = YLeaf(YType.boolean, "obit")

                                        self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                        self.pbit = YLeaf(YType.boolean, "pbit")

                                        self.protect_type = YLeaf(YType.enumeration, "protect-type")

                                        self.sbit = YLeaf(YType.boolean, "sbit")

                                        self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                        self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                        self.wtr_timeout = YLeaf(YType.uint32, "wtr-timeout")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("ho_timeout",
                                                        "is_hopresent",
                                                        "is_snc_mode_present",
                                                        "is_wtr_present",
                                                        "nbit",
                                                        "obit",
                                                        "path_prot_profile_type",
                                                        "pbit",
                                                        "protect_type",
                                                        "sbit",
                                                        "snc_mode",
                                                        "tcm_id",
                                                        "wtr_timeout") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.ho_timeout.is_set or
                                            self.is_hopresent.is_set or
                                            self.is_snc_mode_present.is_set or
                                            self.is_wtr_present.is_set or
                                            self.nbit.is_set or
                                            self.obit.is_set or
                                            self.path_prot_profile_type.is_set or
                                            self.pbit.is_set or
                                            self.protect_type.is_set or
                                            self.sbit.is_set or
                                            self.snc_mode.is_set or
                                            self.tcm_id.is_set or
                                            self.wtr_timeout.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.ho_timeout.yfilter != YFilter.not_set or
                                            self.is_hopresent.yfilter != YFilter.not_set or
                                            self.is_snc_mode_present.yfilter != YFilter.not_set or
                                            self.is_wtr_present.yfilter != YFilter.not_set or
                                            self.nbit.yfilter != YFilter.not_set or
                                            self.obit.yfilter != YFilter.not_set or
                                            self.path_prot_profile_type.yfilter != YFilter.not_set or
                                            self.pbit.yfilter != YFilter.not_set or
                                            self.protect_type.yfilter != YFilter.not_set or
                                            self.sbit.yfilter != YFilter.not_set or
                                            self.snc_mode.yfilter != YFilter.not_set or
                                            self.tcm_id.yfilter != YFilter.not_set or
                                            self.wtr_timeout.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "protection-info" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.ho_timeout.is_set or self.ho_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ho_timeout.get_name_leafdata())
                                        if (self.is_hopresent.is_set or self.is_hopresent.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_hopresent.get_name_leafdata())
                                        if (self.is_snc_mode_present.is_set or self.is_snc_mode_present.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_snc_mode_present.get_name_leafdata())
                                        if (self.is_wtr_present.is_set or self.is_wtr_present.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_wtr_present.get_name_leafdata())
                                        if (self.nbit.is_set or self.nbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.nbit.get_name_leafdata())
                                        if (self.obit.is_set or self.obit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.obit.get_name_leafdata())
                                        if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                        if (self.pbit.is_set or self.pbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pbit.get_name_leafdata())
                                        if (self.protect_type.is_set or self.protect_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.protect_type.get_name_leafdata())
                                        if (self.sbit.is_set or self.sbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.sbit.get_name_leafdata())
                                        if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                        if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                        if (self.wtr_timeout.is_set or self.wtr_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.wtr_timeout.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "ho-timeout" or name == "is-hopresent" or name == "is-snc-mode-present" or name == "is-wtr-present" or name == "nbit" or name == "obit" or name == "path-prot-profile-type" or name == "pbit" or name == "protect-type" or name == "sbit" or name == "snc-mode" or name == "tcm-id" or name == "wtr-timeout"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "ho-timeout"):
                                            self.ho_timeout = value
                                            self.ho_timeout.value_namespace = name_space
                                            self.ho_timeout.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-hopresent"):
                                            self.is_hopresent = value
                                            self.is_hopresent.value_namespace = name_space
                                            self.is_hopresent.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-snc-mode-present"):
                                            self.is_snc_mode_present = value
                                            self.is_snc_mode_present.value_namespace = name_space
                                            self.is_snc_mode_present.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-wtr-present"):
                                            self.is_wtr_present = value
                                            self.is_wtr_present.value_namespace = name_space
                                            self.is_wtr_present.value_namespace_prefix = name_space_prefix
                                        if(value_path == "nbit"):
                                            self.nbit = value
                                            self.nbit.value_namespace = name_space
                                            self.nbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "obit"):
                                            self.obit = value
                                            self.obit.value_namespace = name_space
                                            self.obit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-prot-profile-type"):
                                            self.path_prot_profile_type = value
                                            self.path_prot_profile_type.value_namespace = name_space
                                            self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pbit"):
                                            self.pbit = value
                                            self.pbit.value_namespace = name_space
                                            self.pbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "protect-type"):
                                            self.protect_type = value
                                            self.protect_type.value_namespace = name_space
                                            self.protect_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "sbit"):
                                            self.sbit = value
                                            self.sbit.value_namespace = name_space
                                            self.sbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "snc-mode"):
                                            self.snc_mode = value
                                            self.snc_mode.value_namespace = name_space
                                            self.snc_mode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcm-id"):
                                            self.tcm_id = value
                                            self.tcm_id.value_namespace = name_space
                                            self.tcm_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "wtr-timeout"):
                                            self.wtr_timeout = value
                                            self.wtr_timeout.value_namespace = name_space
                                            self.wtr_timeout.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (self.protection_info is not None and self.protection_info.has_data())

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.protection_info is not None and self.protection_info.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "aps" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "protection-info"):
                                        if (self.protection_info is None):
                                            self.protection_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Aps.ProtectionInfo()
                                            self.protection_info.parent = self
                                            self._children_name_map["protection_info"] = "protection-info"
                                        return self.protection_info

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "protection-info"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    (self.aps is not None and self.aps.has_data()) or
                                    (self.otn is not None and self.otn.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.aps is not None and self.aps.has_operation()) or
                                    (self.otn is not None and self.otn.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "otn-s2l" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "aps"):
                                    if (self.aps is None):
                                        self.aps = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Aps()
                                        self.aps.parent = self
                                        self._children_name_map["aps"] = "aps"
                                    return self.aps

                                if (child_yang_name == "otn"):
                                    if (self.otn is None):
                                        self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L.Otn()
                                        self.otn.parent = self
                                        self._children_name_map["otn"] = "otn"
                                    return self.otn

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "aps" or name == "otn"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class HeadEndBfdInfo(Entity):
                            """
                            The Head\-end BFD info
                            
                            .. attribute:: bfd_reverse_path_label
                            
                            	BFD reverse path labels
                            	**type**\: list of    :py:class:`BfdReversePathLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel>`
                            
                            .. attribute:: bfd_reverse_path_stale
                            
                            	The BFD reverse path is stale compared to configuration
                            	**type**\:  bool
                            
                            .. attribute:: creation_time
                            
                            	Time in seconds since the BFD session created
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: deletion_history
                            
                            	BFD Session Deletion History
                            	**type**\:   :py:class:`DeletionHistory <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.HeadEndBfdInfo.DeletionHistory>`
                            
                            .. attribute:: is_redundant
                            
                            	sBFD session is redundant
                            	**type**\:  bool
                            
                            .. attribute:: lspbfd_type
                            
                            	LSP BFD type
                            	**type**\:   :py:class:`TeVifBfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfd>`
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:   :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.HeadEndBfdInfo.SessionInfo>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.HeadEndBfdInfo, self).__init__()

                                self.yang_name = "head-end-bfd-info"
                                self.yang_parent_name = "s2l"

                                self.bfd_reverse_path_stale = YLeaf(YType.boolean, "bfd-reverse-path-stale")

                                self.creation_time = YLeaf(YType.uint32, "creation-time")

                                self.is_redundant = YLeaf(YType.boolean, "is-redundant")

                                self.lspbfd_type = YLeaf(YType.enumeration, "lspbfd-type")

                                self.deletion_history = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.HeadEndBfdInfo.DeletionHistory()
                                self.deletion_history.parent = self
                                self._children_name_map["deletion_history"] = "deletion-history"
                                self._children_yang_names.add("deletion-history")

                                self.session_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.HeadEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._children_yang_names.add("session-info")

                                self.bfd_reverse_path_label = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("bfd_reverse_path_stale",
                                                "creation_time",
                                                "is_redundant",
                                                "lspbfd_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.HeadEndBfdInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.HeadEndBfdInfo, self).__setattr__(name, value)


                            class SessionInfo(Entity):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:   :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.state = YLeaf(YType.enumeration, "state")

                                    self.state_change_time = YLeaf(YType.uint32, "state-change-time")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("state",
                                                    "state_change_time") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.state.is_set or
                                        self.state_change_time.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.state.yfilter != YFilter.not_set or
                                        self.state_change_time.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "session-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state.get_name_leafdata())
                                    if (self.state_change_time.is_set or self.state_change_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state_change_time.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "state" or name == "state-change-time"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "state"):
                                        self.state = value
                                        self.state.value_namespace = name_space
                                        self.state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "state-change-time"):
                                        self.state_change_time = value
                                        self.state_change_time.value_namespace = name_space
                                        self.state_change_time.value_namespace_prefix = name_space_prefix


                            class DeletionHistory(Entity):
                                """
                                BFD Session Deletion History
                                
                                .. attribute:: deletion_diagnostic_code
                                
                                	Diagnostic Code for the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: deletion_reason
                                
                                	Reason for the BFD session get deleted
                                	**type**\:  str
                                
                                .. attribute:: deletion_time
                                
                                	Time stamp of the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: lsp_id
                                
                                	LSP ID of the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__init__()

                                    self.yang_name = "deletion-history"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.deletion_diagnostic_code = YLeaf(YType.uint32, "deletion-diagnostic-code")

                                    self.deletion_reason = YLeaf(YType.str, "deletion-reason")

                                    self.deletion_time = YLeaf(YType.uint32, "deletion-time")

                                    self.lsp_id = YLeaf(YType.uint16, "lsp-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("deletion_diagnostic_code",
                                                    "deletion_reason",
                                                    "deletion_time",
                                                    "lsp_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.deletion_diagnostic_code.is_set or
                                        self.deletion_reason.is_set or
                                        self.deletion_time.is_set or
                                        self.lsp_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.deletion_diagnostic_code.yfilter != YFilter.not_set or
                                        self.deletion_reason.yfilter != YFilter.not_set or
                                        self.deletion_time.yfilter != YFilter.not_set or
                                        self.lsp_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "deletion-history" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.deletion_diagnostic_code.is_set or self.deletion_diagnostic_code.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_diagnostic_code.get_name_leafdata())
                                    if (self.deletion_reason.is_set or self.deletion_reason.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_reason.get_name_leafdata())
                                    if (self.deletion_time.is_set or self.deletion_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_time.get_name_leafdata())
                                    if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "deletion-diagnostic-code" or name == "deletion-reason" or name == "deletion-time" or name == "lsp-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "deletion-diagnostic-code"):
                                        self.deletion_diagnostic_code = value
                                        self.deletion_diagnostic_code.value_namespace = name_space
                                        self.deletion_diagnostic_code.value_namespace_prefix = name_space_prefix
                                    if(value_path == "deletion-reason"):
                                        self.deletion_reason = value
                                        self.deletion_reason.value_namespace = name_space
                                        self.deletion_reason.value_namespace_prefix = name_space_prefix
                                    if(value_path == "deletion-time"):
                                        self.deletion_time = value
                                        self.deletion_time.value_namespace = name_space
                                        self.deletion_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-id"):
                                        self.lsp_id = value
                                        self.lsp_id.value_namespace = name_space
                                        self.lsp_id.value_namespace_prefix = name_space_prefix


                            class BfdReversePathLabel(Entity):
                                """
                                BFD reverse path labels
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__init__()

                                    self.yang_name = "bfd-reverse-path-label"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "bfd-reverse-path-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.bfd_reverse_path_label:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.bfd_reverse_path_stale.is_set or
                                    self.creation_time.is_set or
                                    self.is_redundant.is_set or
                                    self.lspbfd_type.is_set or
                                    (self.deletion_history is not None and self.deletion_history.has_data()) or
                                    (self.session_info is not None and self.session_info.has_data()))

                            def has_operation(self):
                                for c in self.bfd_reverse_path_label:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.bfd_reverse_path_stale.yfilter != YFilter.not_set or
                                    self.creation_time.yfilter != YFilter.not_set or
                                    self.is_redundant.yfilter != YFilter.not_set or
                                    self.lspbfd_type.yfilter != YFilter.not_set or
                                    (self.deletion_history is not None and self.deletion_history.has_operation()) or
                                    (self.session_info is not None and self.session_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "head-end-bfd-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.bfd_reverse_path_stale.is_set or self.bfd_reverse_path_stale.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_reverse_path_stale.get_name_leafdata())
                                if (self.creation_time.is_set or self.creation_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.creation_time.get_name_leafdata())
                                if (self.is_redundant.is_set or self.is_redundant.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_redundant.get_name_leafdata())
                                if (self.lspbfd_type.is_set or self.lspbfd_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lspbfd_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "bfd-reverse-path-label"):
                                    for c in self.bfd_reverse_path_label:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.bfd_reverse_path_label.append(c)
                                    return c

                                if (child_yang_name == "deletion-history"):
                                    if (self.deletion_history is None):
                                        self.deletion_history = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.HeadEndBfdInfo.DeletionHistory()
                                        self.deletion_history.parent = self
                                        self._children_name_map["deletion_history"] = "deletion-history"
                                    return self.deletion_history

                                if (child_yang_name == "session-info"):
                                    if (self.session_info is None):
                                        self.session_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.HeadEndBfdInfo.SessionInfo()
                                        self.session_info.parent = self
                                        self._children_name_map["session_info"] = "session-info"
                                    return self.session_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "bfd-reverse-path-label" or name == "deletion-history" or name == "session-info" or name == "bfd-reverse-path-stale" or name == "creation-time" or name == "is-redundant" or name == "lspbfd-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "bfd-reverse-path-stale"):
                                    self.bfd_reverse_path_stale = value
                                    self.bfd_reverse_path_stale.value_namespace = name_space
                                    self.bfd_reverse_path_stale.value_namespace_prefix = name_space_prefix
                                if(value_path == "creation-time"):
                                    self.creation_time = value
                                    self.creation_time.value_namespace = name_space
                                    self.creation_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-redundant"):
                                    self.is_redundant = value
                                    self.is_redundant.value_namespace = name_space
                                    self.is_redundant.value_namespace_prefix = name_space_prefix
                                if(value_path == "lspbfd-type"):
                                    self.lspbfd_type = value
                                    self.lspbfd_type.value_namespace = name_space
                                    self.lspbfd_type.value_namespace_prefix = name_space_prefix


                        class TailEndBfdInfo(Entity):
                            """
                            The Tail\-end BFD info
                            
                            .. attribute:: failure_diagnostic_code
                            
                            	BFD session failure diagnostic code
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: failure_reason
                            
                            	BFD session failure reason
                            	**type**\:  str
                            
                            .. attribute:: local_discriminator
                            
                            	BFD Local Discriminator
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: min_interval
                            
                            	Hello interval in mini second
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: min_interval_default
                            
                            	Is default hello interval
                            	**type**\:  bool
                            
                            .. attribute:: multiplier
                            
                            	Multiplier
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: multiplier_default
                            
                            	Is default multiplier
                            	**type**\:  bool
                            
                            .. attribute:: remote_discriminator
                            
                            	BFD Remote Discrminator
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:   :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.TailEndBfdInfo.SessionInfo>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.TailEndBfdInfo, self).__init__()

                                self.yang_name = "tail-end-bfd-info"
                                self.yang_parent_name = "s2l"

                                self.failure_diagnostic_code = YLeaf(YType.uint32, "failure-diagnostic-code")

                                self.failure_reason = YLeaf(YType.str, "failure-reason")

                                self.local_discriminator = YLeaf(YType.uint32, "local-discriminator")

                                self.min_interval = YLeaf(YType.uint32, "min-interval")

                                self.min_interval_default = YLeaf(YType.boolean, "min-interval-default")

                                self.multiplier = YLeaf(YType.uint8, "multiplier")

                                self.multiplier_default = YLeaf(YType.boolean, "multiplier-default")

                                self.remote_discriminator = YLeaf(YType.uint32, "remote-discriminator")

                                self.session_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.TailEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._children_yang_names.add("session-info")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("failure_diagnostic_code",
                                                "failure_reason",
                                                "local_discriminator",
                                                "min_interval",
                                                "min_interval_default",
                                                "multiplier",
                                                "multiplier_default",
                                                "remote_discriminator") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.TailEndBfdInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.TailEndBfdInfo, self).__setattr__(name, value)


                            class SessionInfo(Entity):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:   :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.TailEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "tail-end-bfd-info"

                                    self.state = YLeaf(YType.enumeration, "state")

                                    self.state_change_time = YLeaf(YType.uint32, "state-change-time")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("state",
                                                    "state_change_time") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.TailEndBfdInfo.SessionInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.TailEndBfdInfo.SessionInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.state.is_set or
                                        self.state_change_time.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.state.yfilter != YFilter.not_set or
                                        self.state_change_time.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "session-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state.get_name_leafdata())
                                    if (self.state_change_time.is_set or self.state_change_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state_change_time.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "state" or name == "state-change-time"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "state"):
                                        self.state = value
                                        self.state.value_namespace = name_space
                                        self.state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "state-change-time"):
                                        self.state_change_time = value
                                        self.state_change_time.value_namespace = name_space
                                        self.state_change_time.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.failure_diagnostic_code.is_set or
                                    self.failure_reason.is_set or
                                    self.local_discriminator.is_set or
                                    self.min_interval.is_set or
                                    self.min_interval_default.is_set or
                                    self.multiplier.is_set or
                                    self.multiplier_default.is_set or
                                    self.remote_discriminator.is_set or
                                    (self.session_info is not None and self.session_info.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.failure_diagnostic_code.yfilter != YFilter.not_set or
                                    self.failure_reason.yfilter != YFilter.not_set or
                                    self.local_discriminator.yfilter != YFilter.not_set or
                                    self.min_interval.yfilter != YFilter.not_set or
                                    self.min_interval_default.yfilter != YFilter.not_set or
                                    self.multiplier.yfilter != YFilter.not_set or
                                    self.multiplier_default.yfilter != YFilter.not_set or
                                    self.remote_discriminator.yfilter != YFilter.not_set or
                                    (self.session_info is not None and self.session_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "tail-end-bfd-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.failure_diagnostic_code.is_set or self.failure_diagnostic_code.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.failure_diagnostic_code.get_name_leafdata())
                                if (self.failure_reason.is_set or self.failure_reason.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.failure_reason.get_name_leafdata())
                                if (self.local_discriminator.is_set or self.local_discriminator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_discriminator.get_name_leafdata())
                                if (self.min_interval.is_set or self.min_interval.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.min_interval.get_name_leafdata())
                                if (self.min_interval_default.is_set or self.min_interval_default.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.min_interval_default.get_name_leafdata())
                                if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.multiplier.get_name_leafdata())
                                if (self.multiplier_default.is_set or self.multiplier_default.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.multiplier_default.get_name_leafdata())
                                if (self.remote_discriminator.is_set or self.remote_discriminator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.remote_discriminator.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "session-info"):
                                    if (self.session_info is None):
                                        self.session_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.TailEndBfdInfo.SessionInfo()
                                        self.session_info.parent = self
                                        self._children_name_map["session_info"] = "session-info"
                                    return self.session_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "session-info" or name == "failure-diagnostic-code" or name == "failure-reason" or name == "local-discriminator" or name == "min-interval" or name == "min-interval-default" or name == "multiplier" or name == "multiplier-default" or name == "remote-discriminator"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "failure-diagnostic-code"):
                                    self.failure_diagnostic_code = value
                                    self.failure_diagnostic_code.value_namespace = name_space
                                    self.failure_diagnostic_code.value_namespace_prefix = name_space_prefix
                                if(value_path == "failure-reason"):
                                    self.failure_reason = value
                                    self.failure_reason.value_namespace = name_space
                                    self.failure_reason.value_namespace_prefix = name_space_prefix
                                if(value_path == "local-discriminator"):
                                    self.local_discriminator = value
                                    self.local_discriminator.value_namespace = name_space
                                    self.local_discriminator.value_namespace_prefix = name_space_prefix
                                if(value_path == "min-interval"):
                                    self.min_interval = value
                                    self.min_interval.value_namespace = name_space
                                    self.min_interval.value_namespace_prefix = name_space_prefix
                                if(value_path == "min-interval-default"):
                                    self.min_interval_default = value
                                    self.min_interval_default.value_namespace = name_space
                                    self.min_interval_default.value_namespace_prefix = name_space_prefix
                                if(value_path == "multiplier"):
                                    self.multiplier = value
                                    self.multiplier.value_namespace = name_space
                                    self.multiplier.value_namespace_prefix = name_space_prefix
                                if(value_path == "multiplier-default"):
                                    self.multiplier_default = value
                                    self.multiplier_default.value_namespace = name_space
                                    self.multiplier_default.value_namespace_prefix = name_space_prefix
                                if(value_path == "remote-discriminator"):
                                    self.remote_discriminator = value
                                    self.remote_discriminator.value_namespace = name_space
                                    self.remote_discriminator.value_namespace_prefix = name_space_prefix


                        class SrlgCollection(Entity):
                            """
                            SRLG\-collection data
                            
                            .. attribute:: discovered_srlg
                            
                            	Discovered SRLGs
                            	**type**\: list of    :py:class:`DiscoveredSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.SrlgCollection.DiscoveredSrlg>`
                            
                            .. attribute:: srlg_collect_type
                            
                            	SRLG\-collection mechanism
                            	**type**\:   :py:class:`TeSrlgCollectRequest <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrlgCollectRequest>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.SrlgCollection, self).__init__()

                                self.yang_name = "srlg-collection"
                                self.yang_parent_name = "s2l"

                                self.srlg_collect_type = YLeaf(YType.enumeration, "srlg-collect-type")

                                self.discovered_srlg = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("srlg_collect_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.SrlgCollection, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.SrlgCollection, self).__setattr__(name, value)


                            class DiscoveredSrlg(Entity):
                                """
                                Discovered SRLGs
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__init__()

                                    self.yang_name = "discovered-srlg"
                                    self.yang_parent_name = "srlg-collection"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "discovered-srlg" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.discovered_srlg:
                                    if (c.has_data()):
                                        return True
                                return self.srlg_collect_type.is_set

                            def has_operation(self):
                                for c in self.discovered_srlg:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.srlg_collect_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "srlg-collection" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.srlg_collect_type.is_set or self.srlg_collect_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.srlg_collect_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "discovered-srlg"):
                                    for c in self.discovered_srlg:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.SrlgCollection.DiscoveredSrlg()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.discovered_srlg.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "discovered-srlg" or name == "srlg-collect-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "srlg-collect-type"):
                                    self.srlg_collect_type = value
                                    self.srlg_collect_type.value_namespace = name_space
                                    self.srlg_collect_type.value_namespace_prefix = name_space_prefix


                        class Association(Entity):
                            """
                            Association Object
                            
                            .. attribute:: s2l_association_id
                            
                            	S2L Association ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_association_source
                            
                            	S2L Association Source
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_association_tie_role
                            
                            	S2L Association Tie Role
                            	**type**\:   :py:class:`TeAssociationTieRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAssociationTieRole>`
                            
                            .. attribute:: s2l_association_type
                            
                            	S2L Association Type                          (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_extended_id
                            
                            	S2L Extended ID Array
                            	**type**\: list of    :py:class:`S2LExtendedId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.Association.S2LExtendedId>`
                            
                            .. attribute:: s2l_global_source
                            
                            	S2L Global Source
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.Association, self).__init__()

                                self.yang_name = "association"
                                self.yang_parent_name = "s2l"

                                self.s2l_association_id = YLeaf(YType.uint16, "s2l-association-id")

                                self.s2l_association_source = YLeaf(YType.str, "s2l-association-source")

                                self.s2l_association_tie_role = YLeaf(YType.enumeration, "s2l-association-tie-role")

                                self.s2l_association_type = YLeaf(YType.uint16, "s2l-association-type")

                                self.s2l_global_source = YLeaf(YType.uint32, "s2l-global-source")

                                self.s2l_extended_id = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("s2l_association_id",
                                                "s2l_association_source",
                                                "s2l_association_tie_role",
                                                "s2l_association_type",
                                                "s2l_global_source") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.Association, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.Association, self).__setattr__(name, value)


                            class S2LExtendedId(Entity):
                                """
                                S2L Extended ID Array
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.Association.S2LExtendedId, self).__init__()

                                    self.yang_name = "s2l-extended-id"
                                    self.yang_parent_name = "association"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.Association.S2LExtendedId, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.Association.S2LExtendedId, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "s2l-extended-id" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.s2l_extended_id:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.s2l_association_id.is_set or
                                    self.s2l_association_source.is_set or
                                    self.s2l_association_tie_role.is_set or
                                    self.s2l_association_type.is_set or
                                    self.s2l_global_source.is_set)

                            def has_operation(self):
                                for c in self.s2l_extended_id:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.s2l_association_id.yfilter != YFilter.not_set or
                                    self.s2l_association_source.yfilter != YFilter.not_set or
                                    self.s2l_association_tie_role.yfilter != YFilter.not_set or
                                    self.s2l_association_type.yfilter != YFilter.not_set or
                                    self.s2l_global_source.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "association" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.s2l_association_id.is_set or self.s2l_association_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_id.get_name_leafdata())
                                if (self.s2l_association_source.is_set or self.s2l_association_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_source.get_name_leafdata())
                                if (self.s2l_association_tie_role.is_set or self.s2l_association_tie_role.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_tie_role.get_name_leafdata())
                                if (self.s2l_association_type.is_set or self.s2l_association_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_type.get_name_leafdata())
                                if (self.s2l_global_source.is_set or self.s2l_global_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_global_source.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "s2l-extended-id"):
                                    for c in self.s2l_extended_id:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.Association.S2LExtendedId()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.s2l_extended_id.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "s2l-extended-id" or name == "s2l-association-id" or name == "s2l-association-source" or name == "s2l-association-tie-role" or name == "s2l-association-type" or name == "s2l-global-source"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "s2l-association-id"):
                                    self.s2l_association_id = value
                                    self.s2l_association_id.value_namespace = name_space
                                    self.s2l_association_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-source"):
                                    self.s2l_association_source = value
                                    self.s2l_association_source.value_namespace = name_space
                                    self.s2l_association_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-tie-role"):
                                    self.s2l_association_tie_role = value
                                    self.s2l_association_tie_role.value_namespace = name_space
                                    self.s2l_association_tie_role.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-type"):
                                    self.s2l_association_type = value
                                    self.s2l_association_type.value_namespace = name_space
                                    self.s2l_association_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-global-source"):
                                    self.s2l_global_source = value
                                    self.s2l_global_source.value_namespace = name_space
                                    self.s2l_global_source.value_namespace_prefix = name_space_prefix


                        class Protection(Entity):
                            """
                            Protection Object
                            
                            .. attribute:: any
                            
                            	Any
                            	**type**\:  bool
                            
                            .. attribute:: ded1_plus1
                            
                            	Dedicated 1+1 Protection
                            	**type**\:  bool
                            
                            .. attribute:: ded1_to1
                            
                            	Dedicated 1\:1 Protection
                            	**type**\:  bool
                            
                            .. attribute:: enhanced
                            
                            	Indicates Enhanced Protection Scheme
                            	**type**\:  bool
                            
                            .. attribute:: extra_traffic
                            
                            	LSP should use Links that are protecting other (primary) traffic
                            	**type**\:  bool
                            
                            .. attribute:: link_unprotected
                            
                            	LSP should not use any Link Layer Protection
                            	**type**\:  bool
                            
                            .. attribute:: lsp_unprotected
                            
                            	LSP Flags Unprotected
                            	**type**\:  bool
                            
                            .. attribute:: one_plus_one_bi
                            
                            	1+1 Bidirectional Protection
                            	**type**\:  bool
                            
                            .. attribute:: one_plus_one_uni
                            
                            	1+1 Unidirectional Protection
                            	**type**\:  bool
                            
                            .. attribute:: one_to_n_protection_et
                            
                            	1\:N Protection with Extra\-Traffic
                            	**type**\:  bool
                            
                            .. attribute:: rerouting
                            
                            	Full Rerouting
                            	**type**\:  bool
                            
                            .. attribute:: rerouting_no_et
                            
                            	Rerouting Without Extra\-Traffic
                            	**type**\:  bool
                            
                            .. attribute:: s2l_notification
                            
                            	 S2L Protection Notification Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_operational
                            
                            	 S2L Protection Operational Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_protecting
                            
                            	 S2L Protection Protecting Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_secondary
                            
                            	 S2L Protection Secondary Bit
                            	**type**\:  bool
                            
                            .. attribute:: shared
                            
                            	Shared Link Layer Protection
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.Protection, self).__init__()

                                self.yang_name = "protection"
                                self.yang_parent_name = "s2l"

                                self.any = YLeaf(YType.boolean, "any")

                                self.ded1_plus1 = YLeaf(YType.boolean, "ded1-plus1")

                                self.ded1_to1 = YLeaf(YType.boolean, "ded1-to1")

                                self.enhanced = YLeaf(YType.boolean, "enhanced")

                                self.extra_traffic = YLeaf(YType.boolean, "extra-traffic")

                                self.link_unprotected = YLeaf(YType.boolean, "link-unprotected")

                                self.lsp_unprotected = YLeaf(YType.boolean, "lsp-unprotected")

                                self.one_plus_one_bi = YLeaf(YType.boolean, "one-plus-one-bi")

                                self.one_plus_one_uni = YLeaf(YType.boolean, "one-plus-one-uni")

                                self.one_to_n_protection_et = YLeaf(YType.boolean, "one-to-n-protection-et")

                                self.rerouting = YLeaf(YType.boolean, "rerouting")

                                self.rerouting_no_et = YLeaf(YType.boolean, "rerouting-no-et")

                                self.s2l_notification = YLeaf(YType.boolean, "s2l-notification")

                                self.s2l_operational = YLeaf(YType.boolean, "s2l-operational")

                                self.s2l_protecting = YLeaf(YType.boolean, "s2l-protecting")

                                self.s2l_secondary = YLeaf(YType.boolean, "s2l-secondary")

                                self.shared = YLeaf(YType.boolean, "shared")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("any",
                                                "ded1_plus1",
                                                "ded1_to1",
                                                "enhanced",
                                                "extra_traffic",
                                                "link_unprotected",
                                                "lsp_unprotected",
                                                "one_plus_one_bi",
                                                "one_plus_one_uni",
                                                "one_to_n_protection_et",
                                                "rerouting",
                                                "rerouting_no_et",
                                                "s2l_notification",
                                                "s2l_operational",
                                                "s2l_protecting",
                                                "s2l_secondary",
                                                "shared") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.Protection, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.Protection, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.any.is_set or
                                    self.ded1_plus1.is_set or
                                    self.ded1_to1.is_set or
                                    self.enhanced.is_set or
                                    self.extra_traffic.is_set or
                                    self.link_unprotected.is_set or
                                    self.lsp_unprotected.is_set or
                                    self.one_plus_one_bi.is_set or
                                    self.one_plus_one_uni.is_set or
                                    self.one_to_n_protection_et.is_set or
                                    self.rerouting.is_set or
                                    self.rerouting_no_et.is_set or
                                    self.s2l_notification.is_set or
                                    self.s2l_operational.is_set or
                                    self.s2l_protecting.is_set or
                                    self.s2l_secondary.is_set or
                                    self.shared.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.any.yfilter != YFilter.not_set or
                                    self.ded1_plus1.yfilter != YFilter.not_set or
                                    self.ded1_to1.yfilter != YFilter.not_set or
                                    self.enhanced.yfilter != YFilter.not_set or
                                    self.extra_traffic.yfilter != YFilter.not_set or
                                    self.link_unprotected.yfilter != YFilter.not_set or
                                    self.lsp_unprotected.yfilter != YFilter.not_set or
                                    self.one_plus_one_bi.yfilter != YFilter.not_set or
                                    self.one_plus_one_uni.yfilter != YFilter.not_set or
                                    self.one_to_n_protection_et.yfilter != YFilter.not_set or
                                    self.rerouting.yfilter != YFilter.not_set or
                                    self.rerouting_no_et.yfilter != YFilter.not_set or
                                    self.s2l_notification.yfilter != YFilter.not_set or
                                    self.s2l_operational.yfilter != YFilter.not_set or
                                    self.s2l_protecting.yfilter != YFilter.not_set or
                                    self.s2l_secondary.yfilter != YFilter.not_set or
                                    self.shared.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "protection" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.any.is_set or self.any.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.any.get_name_leafdata())
                                if (self.ded1_plus1.is_set or self.ded1_plus1.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ded1_plus1.get_name_leafdata())
                                if (self.ded1_to1.is_set or self.ded1_to1.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ded1_to1.get_name_leafdata())
                                if (self.enhanced.is_set or self.enhanced.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.enhanced.get_name_leafdata())
                                if (self.extra_traffic.is_set or self.extra_traffic.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.extra_traffic.get_name_leafdata())
                                if (self.link_unprotected.is_set or self.link_unprotected.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.link_unprotected.get_name_leafdata())
                                if (self.lsp_unprotected.is_set or self.lsp_unprotected.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_unprotected.get_name_leafdata())
                                if (self.one_plus_one_bi.is_set or self.one_plus_one_bi.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_plus_one_bi.get_name_leafdata())
                                if (self.one_plus_one_uni.is_set or self.one_plus_one_uni.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_plus_one_uni.get_name_leafdata())
                                if (self.one_to_n_protection_et.is_set or self.one_to_n_protection_et.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_to_n_protection_et.get_name_leafdata())
                                if (self.rerouting.is_set or self.rerouting.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rerouting.get_name_leafdata())
                                if (self.rerouting_no_et.is_set or self.rerouting_no_et.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rerouting_no_et.get_name_leafdata())
                                if (self.s2l_notification.is_set or self.s2l_notification.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_notification.get_name_leafdata())
                                if (self.s2l_operational.is_set or self.s2l_operational.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_operational.get_name_leafdata())
                                if (self.s2l_protecting.is_set or self.s2l_protecting.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_protecting.get_name_leafdata())
                                if (self.s2l_secondary.is_set or self.s2l_secondary.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_secondary.get_name_leafdata())
                                if (self.shared.is_set or self.shared.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.shared.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "any" or name == "ded1-plus1" or name == "ded1-to1" or name == "enhanced" or name == "extra-traffic" or name == "link-unprotected" or name == "lsp-unprotected" or name == "one-plus-one-bi" or name == "one-plus-one-uni" or name == "one-to-n-protection-et" or name == "rerouting" or name == "rerouting-no-et" or name == "s2l-notification" or name == "s2l-operational" or name == "s2l-protecting" or name == "s2l-secondary" or name == "shared"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "any"):
                                    self.any = value
                                    self.any.value_namespace = name_space
                                    self.any.value_namespace_prefix = name_space_prefix
                                if(value_path == "ded1-plus1"):
                                    self.ded1_plus1 = value
                                    self.ded1_plus1.value_namespace = name_space
                                    self.ded1_plus1.value_namespace_prefix = name_space_prefix
                                if(value_path == "ded1-to1"):
                                    self.ded1_to1 = value
                                    self.ded1_to1.value_namespace = name_space
                                    self.ded1_to1.value_namespace_prefix = name_space_prefix
                                if(value_path == "enhanced"):
                                    self.enhanced = value
                                    self.enhanced.value_namespace = name_space
                                    self.enhanced.value_namespace_prefix = name_space_prefix
                                if(value_path == "extra-traffic"):
                                    self.extra_traffic = value
                                    self.extra_traffic.value_namespace = name_space
                                    self.extra_traffic.value_namespace_prefix = name_space_prefix
                                if(value_path == "link-unprotected"):
                                    self.link_unprotected = value
                                    self.link_unprotected.value_namespace = name_space
                                    self.link_unprotected.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-unprotected"):
                                    self.lsp_unprotected = value
                                    self.lsp_unprotected.value_namespace = name_space
                                    self.lsp_unprotected.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-plus-one-bi"):
                                    self.one_plus_one_bi = value
                                    self.one_plus_one_bi.value_namespace = name_space
                                    self.one_plus_one_bi.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-plus-one-uni"):
                                    self.one_plus_one_uni = value
                                    self.one_plus_one_uni.value_namespace = name_space
                                    self.one_plus_one_uni.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-to-n-protection-et"):
                                    self.one_to_n_protection_et = value
                                    self.one_to_n_protection_et.value_namespace = name_space
                                    self.one_to_n_protection_et.value_namespace_prefix = name_space_prefix
                                if(value_path == "rerouting"):
                                    self.rerouting = value
                                    self.rerouting.value_namespace = name_space
                                    self.rerouting.value_namespace_prefix = name_space_prefix
                                if(value_path == "rerouting-no-et"):
                                    self.rerouting_no_et = value
                                    self.rerouting_no_et.value_namespace = name_space
                                    self.rerouting_no_et.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-notification"):
                                    self.s2l_notification = value
                                    self.s2l_notification.value_namespace = name_space
                                    self.s2l_notification.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-operational"):
                                    self.s2l_operational = value
                                    self.s2l_operational.value_namespace = name_space
                                    self.s2l_operational.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-protecting"):
                                    self.s2l_protecting = value
                                    self.s2l_protecting.value_namespace = name_space
                                    self.s2l_protecting.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-secondary"):
                                    self.s2l_secondary = value
                                    self.s2l_secondary.value_namespace = name_space
                                    self.s2l_secondary.value_namespace_prefix = name_space_prefix
                                if(value_path == "shared"):
                                    self.shared = value
                                    self.shared.value_namespace = name_space
                                    self.shared.value_namespace_prefix = name_space_prefix


                        class ReverseLspFec(Entity):
                            """
                            Reverse Associated Bidir LSP FEC
                            
                            .. attribute:: fec_destination_info
                            
                            	Destination or P2MP ID
                            	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ReverseLspFec.FecDestinationInfo>`
                            
                            .. attribute:: fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: fec_lsp_id
                            
                            	LSP ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: fec_source
                            
                            	Tunnel source address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ReverseLspFec, self).__init__()

                                self.yang_name = "reverse-lsp-fec"
                                self.yang_parent_name = "s2l"

                                self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                self.fec_source = YLeaf(YType.str, "fec-source")

                                self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ReverseLspFec.FecDestinationInfo()
                                self.fec_destination_info.parent = self
                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                self._children_yang_names.add("fec-destination-info")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fec_extended_tunnel_id",
                                                "fec_lsp_id",
                                                "fec_source",
                                                "fec_tunnel_id",
                                                "fec_vrf") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ReverseLspFec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ReverseLspFec, self).__setattr__(name, value)


                            class FecDestinationInfo(Entity):
                                """
                                Destination or P2MP ID
                                
                                .. attribute:: fec_ctype
                                
                                	FEC CType
                                	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                .. attribute:: fec_destination_p2mp_id
                                
                                	P2MP ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: p2p_lsp_destination
                                
                                	P2P LSP destination
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__init__()

                                    self.yang_name = "fec-destination-info"
                                    self.yang_parent_name = "reverse-lsp-fec"

                                    self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                    self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                    self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("fec_ctype",
                                                    "fec_destination_p2mp_id",
                                                    "p2p_lsp_destination") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.fec_ctype.is_set or
                                        self.fec_destination_p2mp_id.is_set or
                                        self.p2p_lsp_destination.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.fec_ctype.yfilter != YFilter.not_set or
                                        self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                        self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "fec-destination-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                    if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                    if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "fec-ctype"):
                                        self.fec_ctype = value
                                        self.fec_ctype.value_namespace = name_space
                                        self.fec_ctype.value_namespace_prefix = name_space_prefix
                                    if(value_path == "fec-destination-p2mp-id"):
                                        self.fec_destination_p2mp_id = value
                                        self.fec_destination_p2mp_id.value_namespace = name_space
                                        self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "p2p-lsp-destination"):
                                        self.p2p_lsp_destination = value
                                        self.p2p_lsp_destination.value_namespace = name_space
                                        self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.fec_extended_tunnel_id.is_set or
                                    self.fec_lsp_id.is_set or
                                    self.fec_source.is_set or
                                    self.fec_tunnel_id.is_set or
                                    self.fec_vrf.is_set or
                                    (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                    self.fec_lsp_id.yfilter != YFilter.not_set or
                                    self.fec_source.yfilter != YFilter.not_set or
                                    self.fec_tunnel_id.yfilter != YFilter.not_set or
                                    self.fec_vrf.yfilter != YFilter.not_set or
                                    (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-lsp-fec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_source.get_name_leafdata())
                                if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "fec-destination-info"):
                                    if (self.fec_destination_info is None):
                                        self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ReverseLspFec.FecDestinationInfo()
                                        self.fec_destination_info.parent = self
                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                    return self.fec_destination_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fec-extended-tunnel-id"):
                                    self.fec_extended_tunnel_id = value
                                    self.fec_extended_tunnel_id.value_namespace = name_space
                                    self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-lsp-id"):
                                    self.fec_lsp_id = value
                                    self.fec_lsp_id.value_namespace = name_space
                                    self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-source"):
                                    self.fec_source = value
                                    self.fec_source.value_namespace = name_space
                                    self.fec_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-tunnel-id"):
                                    self.fec_tunnel_id = value
                                    self.fec_tunnel_id.value_namespace = name_space
                                    self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-vrf"):
                                    self.fec_vrf = value
                                    self.fec_vrf.value_namespace = name_space
                                    self.fec_vrf.value_namespace_prefix = name_space_prefix


                        class ReverseTspec(Entity):
                            """
                            The Reverse T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ReverseTspec, self).__init__()

                                self.yang_name = "reverse-tspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ReverseTspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ReverseTspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class FlexInfo(Entity):
                            """
                            FlexLSP S2L Information
                            
                            .. attribute:: bfd_created
                            
                            	GAL BFD Session Created
                            	**type**\:  bool
                            
                            .. attribute:: bfd_egress_label
                            
                            	BFD Egress Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: bfd_int_label
                            
                            	BFD Internal Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: bfd_next_hop
                            
                            	BFD Next Hop
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: bfd_out_ifh
                            
                            	BFD Out Interface Handle
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: bfd_tun_ifh
                            
                            	BFD Tunnel Interface Handle
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: bfd_up
                            
                            	GAL BFD Session Up
                            	**type**\:  bool
                            
                            .. attribute:: entry_exists
                            
                            	FlexLSP Entry Exists
                            	**type**\:  bool
                            
                            .. attribute:: fault_ais
                            
                            	Fault AIS
                            	**type**\:  bool
                            
                            .. attribute:: fault_ldi
                            
                            	Fault LDI
                            	**type**\:  bool
                            
                            .. attribute:: fault_ldi_lockout
                            
                            	Fault LDI Lockout
                            	**type**\:  bool
                            
                            .. attribute:: fault_lkr
                            
                            	Fault LKR
                            	**type**\:  bool
                            
                            .. attribute:: fault_time
                            
                            	Fault Time
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: flex_fec
                            
                            	FEC for the FlexLSP Entry
                            	**type**\:   :py:class:`FlexFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.FlexInfo.FlexFec>`
                            
                            .. attribute:: in_label
                            
                            	In Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: oam_created
                            
                            	OAM Entry Created
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.FlexInfo, self).__init__()

                                self.yang_name = "flex-info"
                                self.yang_parent_name = "s2l"

                                self.bfd_created = YLeaf(YType.boolean, "bfd-created")

                                self.bfd_egress_label = YLeaf(YType.uint32, "bfd-egress-label")

                                self.bfd_int_label = YLeaf(YType.uint32, "bfd-int-label")

                                self.bfd_next_hop = YLeaf(YType.str, "bfd-next-hop")

                                self.bfd_out_ifh = YLeaf(YType.str, "bfd-out-ifh")

                                self.bfd_tun_ifh = YLeaf(YType.str, "bfd-tun-ifh")

                                self.bfd_up = YLeaf(YType.boolean, "bfd-up")

                                self.entry_exists = YLeaf(YType.boolean, "entry-exists")

                                self.fault_ais = YLeaf(YType.boolean, "fault-ais")

                                self.fault_ldi = YLeaf(YType.boolean, "fault-ldi")

                                self.fault_ldi_lockout = YLeaf(YType.boolean, "fault-ldi-lockout")

                                self.fault_lkr = YLeaf(YType.boolean, "fault-lkr")

                                self.fault_time = YLeaf(YType.uint32, "fault-time")

                                self.in_label = YLeaf(YType.uint32, "in-label")

                                self.oam_created = YLeaf(YType.boolean, "oam-created")

                                self.flex_fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.FlexInfo.FlexFec()
                                self.flex_fec.parent = self
                                self._children_name_map["flex_fec"] = "flex-fec"
                                self._children_yang_names.add("flex-fec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("bfd_created",
                                                "bfd_egress_label",
                                                "bfd_int_label",
                                                "bfd_next_hop",
                                                "bfd_out_ifh",
                                                "bfd_tun_ifh",
                                                "bfd_up",
                                                "entry_exists",
                                                "fault_ais",
                                                "fault_ldi",
                                                "fault_ldi_lockout",
                                                "fault_lkr",
                                                "fault_time",
                                                "in_label",
                                                "oam_created") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.FlexInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.FlexInfo, self).__setattr__(name, value)


                            class FlexFec(Entity):
                                """
                                FEC for the FlexLSP Entry
                                
                                .. attribute:: s2l_fec_ctype
                                
                                	Session identifier (ctype)
                                	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                .. attribute:: s2l_fec_dest
                                
                                	sub\-LSP destination address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_extended_tunnel_id
                                
                                	Extended tunnel ID
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_lsp_id
                                
                                	LSP ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_p2mp_id
                                
                                	P2MP ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: s2l_fec_source
                                
                                	LSP source address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_subgroup_id
                                
                                	sub\-LSP subgroup ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_subgroup_originator
                                
                                	Subgroup Originator
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_tunnel_id
                                
                                	Tunnel ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_vrf
                                
                                	VRF; currently only for GMPLS tunnels
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.FlexInfo.FlexFec, self).__init__()

                                    self.yang_name = "flex-fec"
                                    self.yang_parent_name = "flex-info"

                                    self.s2l_fec_ctype = YLeaf(YType.enumeration, "s2l-fec-ctype")

                                    self.s2l_fec_dest = YLeaf(YType.str, "s2l-fec-dest")

                                    self.s2l_fec_extended_tunnel_id = YLeaf(YType.str, "s2l-fec-extended-tunnel-id")

                                    self.s2l_fec_lsp_id = YLeaf(YType.uint16, "s2l-fec-lsp-id")

                                    self.s2l_fec_p2mp_id = YLeaf(YType.uint32, "s2l-fec-p2mp-id")

                                    self.s2l_fec_source = YLeaf(YType.str, "s2l-fec-source")

                                    self.s2l_fec_subgroup_id = YLeaf(YType.uint16, "s2l-fec-subgroup-id")

                                    self.s2l_fec_subgroup_originator = YLeaf(YType.str, "s2l-fec-subgroup-originator")

                                    self.s2l_fec_tunnel_id = YLeaf(YType.uint16, "s2l-fec-tunnel-id")

                                    self.s2l_fec_vrf = YLeaf(YType.str, "s2l-fec-vrf")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("s2l_fec_ctype",
                                                    "s2l_fec_dest",
                                                    "s2l_fec_extended_tunnel_id",
                                                    "s2l_fec_lsp_id",
                                                    "s2l_fec_p2mp_id",
                                                    "s2l_fec_source",
                                                    "s2l_fec_subgroup_id",
                                                    "s2l_fec_subgroup_originator",
                                                    "s2l_fec_tunnel_id",
                                                    "s2l_fec_vrf") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.FlexInfo.FlexFec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.FlexInfo.FlexFec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.s2l_fec_ctype.is_set or
                                        self.s2l_fec_dest.is_set or
                                        self.s2l_fec_extended_tunnel_id.is_set or
                                        self.s2l_fec_lsp_id.is_set or
                                        self.s2l_fec_p2mp_id.is_set or
                                        self.s2l_fec_source.is_set or
                                        self.s2l_fec_subgroup_id.is_set or
                                        self.s2l_fec_subgroup_originator.is_set or
                                        self.s2l_fec_tunnel_id.is_set or
                                        self.s2l_fec_vrf.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.s2l_fec_ctype.yfilter != YFilter.not_set or
                                        self.s2l_fec_dest.yfilter != YFilter.not_set or
                                        self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_lsp_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_p2mp_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_source.yfilter != YFilter.not_set or
                                        self.s2l_fec_subgroup_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set or
                                        self.s2l_fec_tunnel_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_vrf.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "flex-fec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.s2l_fec_ctype.is_set or self.s2l_fec_ctype.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_ctype.get_name_leafdata())
                                    if (self.s2l_fec_dest.is_set or self.s2l_fec_dest.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_dest.get_name_leafdata())
                                    if (self.s2l_fec_extended_tunnel_id.is_set or self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_extended_tunnel_id.get_name_leafdata())
                                    if (self.s2l_fec_lsp_id.is_set or self.s2l_fec_lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_lsp_id.get_name_leafdata())
                                    if (self.s2l_fec_p2mp_id.is_set or self.s2l_fec_p2mp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_p2mp_id.get_name_leafdata())
                                    if (self.s2l_fec_source.is_set or self.s2l_fec_source.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_source.get_name_leafdata())
                                    if (self.s2l_fec_subgroup_id.is_set or self.s2l_fec_subgroup_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_subgroup_id.get_name_leafdata())
                                    if (self.s2l_fec_subgroup_originator.is_set or self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_subgroup_originator.get_name_leafdata())
                                    if (self.s2l_fec_tunnel_id.is_set or self.s2l_fec_tunnel_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_tunnel_id.get_name_leafdata())
                                    if (self.s2l_fec_vrf.is_set or self.s2l_fec_vrf.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_vrf.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "s2l-fec-ctype" or name == "s2l-fec-dest" or name == "s2l-fec-extended-tunnel-id" or name == "s2l-fec-lsp-id" or name == "s2l-fec-p2mp-id" or name == "s2l-fec-source" or name == "s2l-fec-subgroup-id" or name == "s2l-fec-subgroup-originator" or name == "s2l-fec-tunnel-id" or name == "s2l-fec-vrf"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "s2l-fec-ctype"):
                                        self.s2l_fec_ctype = value
                                        self.s2l_fec_ctype.value_namespace = name_space
                                        self.s2l_fec_ctype.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-dest"):
                                        self.s2l_fec_dest = value
                                        self.s2l_fec_dest.value_namespace = name_space
                                        self.s2l_fec_dest.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-extended-tunnel-id"):
                                        self.s2l_fec_extended_tunnel_id = value
                                        self.s2l_fec_extended_tunnel_id.value_namespace = name_space
                                        self.s2l_fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-lsp-id"):
                                        self.s2l_fec_lsp_id = value
                                        self.s2l_fec_lsp_id.value_namespace = name_space
                                        self.s2l_fec_lsp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-p2mp-id"):
                                        self.s2l_fec_p2mp_id = value
                                        self.s2l_fec_p2mp_id.value_namespace = name_space
                                        self.s2l_fec_p2mp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-source"):
                                        self.s2l_fec_source = value
                                        self.s2l_fec_source.value_namespace = name_space
                                        self.s2l_fec_source.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-subgroup-id"):
                                        self.s2l_fec_subgroup_id = value
                                        self.s2l_fec_subgroup_id.value_namespace = name_space
                                        self.s2l_fec_subgroup_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-subgroup-originator"):
                                        self.s2l_fec_subgroup_originator = value
                                        self.s2l_fec_subgroup_originator.value_namespace = name_space
                                        self.s2l_fec_subgroup_originator.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-tunnel-id"):
                                        self.s2l_fec_tunnel_id = value
                                        self.s2l_fec_tunnel_id.value_namespace = name_space
                                        self.s2l_fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-vrf"):
                                        self.s2l_fec_vrf = value
                                        self.s2l_fec_vrf.value_namespace = name_space
                                        self.s2l_fec_vrf.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.bfd_created.is_set or
                                    self.bfd_egress_label.is_set or
                                    self.bfd_int_label.is_set or
                                    self.bfd_next_hop.is_set or
                                    self.bfd_out_ifh.is_set or
                                    self.bfd_tun_ifh.is_set or
                                    self.bfd_up.is_set or
                                    self.entry_exists.is_set or
                                    self.fault_ais.is_set or
                                    self.fault_ldi.is_set or
                                    self.fault_ldi_lockout.is_set or
                                    self.fault_lkr.is_set or
                                    self.fault_time.is_set or
                                    self.in_label.is_set or
                                    self.oam_created.is_set or
                                    (self.flex_fec is not None and self.flex_fec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.bfd_created.yfilter != YFilter.not_set or
                                    self.bfd_egress_label.yfilter != YFilter.not_set or
                                    self.bfd_int_label.yfilter != YFilter.not_set or
                                    self.bfd_next_hop.yfilter != YFilter.not_set or
                                    self.bfd_out_ifh.yfilter != YFilter.not_set or
                                    self.bfd_tun_ifh.yfilter != YFilter.not_set or
                                    self.bfd_up.yfilter != YFilter.not_set or
                                    self.entry_exists.yfilter != YFilter.not_set or
                                    self.fault_ais.yfilter != YFilter.not_set or
                                    self.fault_ldi.yfilter != YFilter.not_set or
                                    self.fault_ldi_lockout.yfilter != YFilter.not_set or
                                    self.fault_lkr.yfilter != YFilter.not_set or
                                    self.fault_time.yfilter != YFilter.not_set or
                                    self.in_label.yfilter != YFilter.not_set or
                                    self.oam_created.yfilter != YFilter.not_set or
                                    (self.flex_fec is not None and self.flex_fec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "flex-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.bfd_created.is_set or self.bfd_created.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_created.get_name_leafdata())
                                if (self.bfd_egress_label.is_set or self.bfd_egress_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_egress_label.get_name_leafdata())
                                if (self.bfd_int_label.is_set or self.bfd_int_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_int_label.get_name_leafdata())
                                if (self.bfd_next_hop.is_set or self.bfd_next_hop.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_next_hop.get_name_leafdata())
                                if (self.bfd_out_ifh.is_set or self.bfd_out_ifh.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_out_ifh.get_name_leafdata())
                                if (self.bfd_tun_ifh.is_set or self.bfd_tun_ifh.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_tun_ifh.get_name_leafdata())
                                if (self.bfd_up.is_set or self.bfd_up.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_up.get_name_leafdata())
                                if (self.entry_exists.is_set or self.entry_exists.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry_exists.get_name_leafdata())
                                if (self.fault_ais.is_set or self.fault_ais.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ais.get_name_leafdata())
                                if (self.fault_ldi.is_set or self.fault_ldi.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ldi.get_name_leafdata())
                                if (self.fault_ldi_lockout.is_set or self.fault_ldi_lockout.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ldi_lockout.get_name_leafdata())
                                if (self.fault_lkr.is_set or self.fault_lkr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_lkr.get_name_leafdata())
                                if (self.fault_time.is_set or self.fault_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_time.get_name_leafdata())
                                if (self.in_label.is_set or self.in_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.in_label.get_name_leafdata())
                                if (self.oam_created.is_set or self.oam_created.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.oam_created.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "flex-fec"):
                                    if (self.flex_fec is None):
                                        self.flex_fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.FlexInfo.FlexFec()
                                        self.flex_fec.parent = self
                                        self._children_name_map["flex_fec"] = "flex-fec"
                                    return self.flex_fec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "flex-fec" or name == "bfd-created" or name == "bfd-egress-label" or name == "bfd-int-label" or name == "bfd-next-hop" or name == "bfd-out-ifh" or name == "bfd-tun-ifh" or name == "bfd-up" or name == "entry-exists" or name == "fault-ais" or name == "fault-ldi" or name == "fault-ldi-lockout" or name == "fault-lkr" or name == "fault-time" or name == "in-label" or name == "oam-created"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "bfd-created"):
                                    self.bfd_created = value
                                    self.bfd_created.value_namespace = name_space
                                    self.bfd_created.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-egress-label"):
                                    self.bfd_egress_label = value
                                    self.bfd_egress_label.value_namespace = name_space
                                    self.bfd_egress_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-int-label"):
                                    self.bfd_int_label = value
                                    self.bfd_int_label.value_namespace = name_space
                                    self.bfd_int_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-next-hop"):
                                    self.bfd_next_hop = value
                                    self.bfd_next_hop.value_namespace = name_space
                                    self.bfd_next_hop.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-out-ifh"):
                                    self.bfd_out_ifh = value
                                    self.bfd_out_ifh.value_namespace = name_space
                                    self.bfd_out_ifh.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-tun-ifh"):
                                    self.bfd_tun_ifh = value
                                    self.bfd_tun_ifh.value_namespace = name_space
                                    self.bfd_tun_ifh.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-up"):
                                    self.bfd_up = value
                                    self.bfd_up.value_namespace = name_space
                                    self.bfd_up.value_namespace_prefix = name_space_prefix
                                if(value_path == "entry-exists"):
                                    self.entry_exists = value
                                    self.entry_exists.value_namespace = name_space
                                    self.entry_exists.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ais"):
                                    self.fault_ais = value
                                    self.fault_ais.value_namespace = name_space
                                    self.fault_ais.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ldi"):
                                    self.fault_ldi = value
                                    self.fault_ldi.value_namespace = name_space
                                    self.fault_ldi.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ldi-lockout"):
                                    self.fault_ldi_lockout = value
                                    self.fault_ldi_lockout.value_namespace = name_space
                                    self.fault_ldi_lockout.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-lkr"):
                                    self.fault_lkr = value
                                    self.fault_lkr.value_namespace = name_space
                                    self.fault_lkr.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-time"):
                                    self.fault_time = value
                                    self.fault_time.value_namespace = name_space
                                    self.fault_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "in-label"):
                                    self.in_label = value
                                    self.in_label.value_namespace = name_space
                                    self.in_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "oam-created"):
                                    self.oam_created = value
                                    self.oam_created.value_namespace = name_space
                                    self.oam_created.value_namespace_prefix = name_space_prefix


                        class LspWrapInfo(Entity):
                            """
                            Lsp Wrap  Related information
                            
                            .. attribute:: lsp_wrap_protection_enable
                            
                            	LSP Wrap protection enabled
                            	**type**\:  bool
                            
                            .. attribute:: lsp_wrap_protection_label
                            
                            	LSP Wrap Merge Point Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: lsp_wrap_protection_state
                            
                            	LSP wrap protection state
                            	**type**\:   :py:class:`MplsTeLspWrapState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspWrapState>`
                            
                            .. attribute:: reverse_egress_interface
                            
                            	Reverse Egress Interface
                            	**type**\:  str
                            
                            .. attribute:: reverse_lsp_label
                            
                            	Reverse LSP label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.LspWrapInfo, self).__init__()

                                self.yang_name = "lsp-wrap-info"
                                self.yang_parent_name = "s2l"

                                self.lsp_wrap_protection_enable = YLeaf(YType.boolean, "lsp-wrap-protection-enable")

                                self.lsp_wrap_protection_label = YLeaf(YType.uint32, "lsp-wrap-protection-label")

                                self.lsp_wrap_protection_state = YLeaf(YType.enumeration, "lsp-wrap-protection-state")

                                self.reverse_egress_interface = YLeaf(YType.str, "reverse-egress-interface")

                                self.reverse_lsp_label = YLeaf(YType.uint32, "reverse-lsp-label")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("lsp_wrap_protection_enable",
                                                "lsp_wrap_protection_label",
                                                "lsp_wrap_protection_state",
                                                "reverse_egress_interface",
                                                "reverse_lsp_label") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.LspWrapInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.LspWrapInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.lsp_wrap_protection_enable.is_set or
                                    self.lsp_wrap_protection_label.is_set or
                                    self.lsp_wrap_protection_state.is_set or
                                    self.reverse_egress_interface.is_set or
                                    self.reverse_lsp_label.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_enable.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_label.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_state.yfilter != YFilter.not_set or
                                    self.reverse_egress_interface.yfilter != YFilter.not_set or
                                    self.reverse_lsp_label.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "lsp-wrap-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.lsp_wrap_protection_enable.is_set or self.lsp_wrap_protection_enable.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_enable.get_name_leafdata())
                                if (self.lsp_wrap_protection_label.is_set or self.lsp_wrap_protection_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_label.get_name_leafdata())
                                if (self.lsp_wrap_protection_state.is_set or self.lsp_wrap_protection_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_state.get_name_leafdata())
                                if (self.reverse_egress_interface.is_set or self.reverse_egress_interface.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reverse_egress_interface.get_name_leafdata())
                                if (self.reverse_lsp_label.is_set or self.reverse_lsp_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reverse_lsp_label.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "lsp-wrap-protection-enable" or name == "lsp-wrap-protection-label" or name == "lsp-wrap-protection-state" or name == "reverse-egress-interface" or name == "reverse-lsp-label"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "lsp-wrap-protection-enable"):
                                    self.lsp_wrap_protection_enable = value
                                    self.lsp_wrap_protection_enable.value_namespace = name_space
                                    self.lsp_wrap_protection_enable.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-wrap-protection-label"):
                                    self.lsp_wrap_protection_label = value
                                    self.lsp_wrap_protection_label.value_namespace = name_space
                                    self.lsp_wrap_protection_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-wrap-protection-state"):
                                    self.lsp_wrap_protection_state = value
                                    self.lsp_wrap_protection_state.value_namespace = name_space
                                    self.lsp_wrap_protection_state.value_namespace_prefix = name_space_prefix
                                if(value_path == "reverse-egress-interface"):
                                    self.reverse_egress_interface = value
                                    self.reverse_egress_interface.value_namespace = name_space
                                    self.reverse_egress_interface.value_namespace_prefix = name_space_prefix
                                if(value_path == "reverse-lsp-label"):
                                    self.reverse_lsp_label = value
                                    self.reverse_lsp_label.value_namespace = name_space
                                    self.reverse_lsp_label.value_namespace_prefix = name_space_prefix


                        class DiversityInfo(Entity):
                            """
                            S2L Diversity Information
                            
                            .. attribute:: diversity_type
                            
                            	S2L path diversity type
                            	**type**\:   :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.DiversityInfo, self).__init__()

                                self.yang_name = "diversity-info"
                                self.yang_parent_name = "s2l"

                                self.diversity_type = YLeaf(YType.enumeration, "diversity-type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("diversity_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.DiversityInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.DiversityInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return self.diversity_type.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.diversity_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "diversity-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.diversity_type.is_set or self.diversity_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.diversity_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "diversity-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "diversity-type"):
                                    self.diversity_type = value
                                    self.diversity_type.value_namespace = name_space
                                    self.diversity_type.value_namespace_prefix = name_space_prefix


                        class S2LReverseLspSubObj(Entity):
                            """
                            Reverse LSP Sub Objects
                            
                            .. attribute:: entry
                            
                            	
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.S2LReverseLspSubObj, self).__init__()

                                self.yang_name = "s2l-reverse-lsp-sub-obj"
                                self.yang_parent_name = "s2l"

                                self.entry = YLeaf(YType.uint8, "entry")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("entry") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.S2LReverseLspSubObj, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.S2LReverseLspSubObj, self).__setattr__(name, value)

                            def has_data(self):
                                return self.entry.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.entry.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-reverse-lsp-sub-obj" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "entry"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "entry"):
                                    self.entry = value
                                    self.entry.value_namespace = name_space
                                    self.entry.value_namespace_prefix = name_space_prefix


                        class SharedRiskLinkGroup(Entity):
                            """
                            The S2L's excluded srlg groups
                            
                            .. attribute:: shared_risk_group
                            
                            	SRLG number
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: srlg_name
                            
                            	SRLG name
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.SharedRiskLinkGroup, self).__init__()

                                self.yang_name = "shared-risk-link-group"
                                self.yang_parent_name = "s2l"

                                self.shared_risk_group = YLeaf(YType.uint32, "shared-risk-group")

                                self.srlg_name = YLeaf(YType.str, "srlg-name")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("shared_risk_group",
                                                "srlg_name") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.SharedRiskLinkGroup, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.SharedRiskLinkGroup, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.shared_risk_group.is_set or
                                    self.srlg_name.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.shared_risk_group.yfilter != YFilter.not_set or
                                    self.srlg_name.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "shared-risk-link-group" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.shared_risk_group.is_set or self.shared_risk_group.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.shared_risk_group.get_name_leafdata())
                                if (self.srlg_name.is_set or self.srlg_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.srlg_name.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "shared-risk-group" or name == "srlg-name"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "shared-risk-group"):
                                    self.shared_risk_group = value
                                    self.shared_risk_group.value_namespace = name_space
                                    self.shared_risk_group.value_namespace_prefix = name_space_prefix
                                if(value_path == "srlg-name"):
                                    self.srlg_name = value
                                    self.srlg_name.value_namespace = name_space
                                    self.srlg_name.value_namespace_prefix = name_space_prefix


                        class OutEro(Entity):
                            """
                            Outgoing ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutEro.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutEro.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutEro, self).__init__()

                                self.yang_name = "out-ero"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutEro.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutEro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutEro, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutEro.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "out-ero"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutEro.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutEro.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "out-ero"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutEro.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutEro.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "out-ero" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutEro.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutEro.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class InEro(Entity):
                            """
                            Incoming ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InEro.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InEro.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InEro, self).__init__()

                                self.yang_name = "in-ero"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InEro.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InEro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InEro, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InEro.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "in-ero"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InEro.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InEro.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "in-ero"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InEro.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InEro.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "in-ero" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InEro.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InEro.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class PathRro(Entity):
                            """
                            Path RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:   :py:class:`Ipv4RroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.Ipv4RroSubObject>`
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:   :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.LabelRroSubObject>`
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:   :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:   :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.SrlgRroSubObject>`
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:   :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.UnnumberedRroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro, self).__init__()

                                self.yang_name = "path-rro"
                                self.yang_parent_name = "s2l"

                                self.rro_type = YLeaf(YType.enumeration, "rro-type")

                                self.ipv4rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.Ipv4RroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                self._children_yang_names.add("ipv4rro-sub-object")

                                self.label_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                self._children_yang_names.add("label-rro-sub-object")

                                self.srlg_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._children_yang_names.add("srlg-rro-sub-object")

                                self.unnumbered_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                self._children_yang_names.add("unnumbered-rro-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("rro_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro, self).__setattr__(name, value)


                            class Ipv4RroSubObject(Entity):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.Ipv4RroSubObject.Flags>`
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.Ipv4RroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.rro_address = YLeaf(YType.str, "rro-address")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.Ipv4RroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("rro_address") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.Ipv4RroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.Ipv4RroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.rro_address.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.rro_address.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.rro_address.is_set or self.rro_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rro_address.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.Ipv4RroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "rro-address"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "rro-address"):
                                        self.rro_address = value
                                        self.rro_address.value_namespace = name_space
                                        self.rro_address.value_namespace_prefix = name_space_prefix


                            class LabelRroSubObject(Entity):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.LabelRroSubObject.Flags>`
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\:  bool
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of    :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.is_label_variable_length = YLeaf(YType.boolean, "is-label-variable-length")

                                    self.label = YLeaf(YType.uint32, "label")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                    self.variable_length_label = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_label_variable_length",
                                                    "label") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.LabelRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.LabelRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.is_global_label = YLeaf(YType.boolean, "is-global-label")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_global_label") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.is_global_label.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_global_label.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_global_label.is_set or self.is_global_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_global_label.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-global-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-global-label"):
                                            self.is_global_label = value
                                            self.is_global_label.value_namespace = name_space
                                            self.is_global_label.value_namespace_prefix = name_space_prefix


                                class VariableLengthLabel(Entity):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "variable-length-label" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.variable_length_label:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.is_label_variable_length.is_set or
                                        self.label.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    for c in self.variable_length_label:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_label_variable_length.yfilter != YFilter.not_set or
                                        self.label.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "label-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_label_variable_length.is_set or self.is_label_variable_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_label_variable_length.get_name_leafdata())
                                    if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.LabelRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    if (child_yang_name == "variable-length-label"):
                                        for c in self.variable_length_label:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.variable_length_label.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "variable-length-label" or name == "is-label-variable-length" or name == "label"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-label-variable-length"):
                                        self.is_label_variable_length = value
                                        self.is_label_variable_length.value_namespace = name_space
                                        self.is_label_variable_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label"):
                                        self.label = value
                                        self.label.value_namespace = name_space
                                        self.label.value_namespace_prefix = name_space_prefix


                            class UnnumberedRroSubObject(Entity):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.UnnumberedRroSubObject.Flags>`
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.interface_address = YLeaf(YType.str, "interface-address")

                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_address",
                                                    "interface_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.UnnumberedRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.UnnumberedRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.interface_address.is_set or
                                        self.interface_id.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_address.yfilter != YFilter.not_set or
                                        self.interface_id.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_address.is_set or self.interface_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_address.get_name_leafdata())
                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.UnnumberedRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "interface-address" or name == "interface-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-address"):
                                        self.interface_address = value
                                        self.interface_address.value_namespace = name_space
                                        self.interface_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-id"):
                                        self.interface_id = value
                                        self.interface_id.value_namespace = name_space
                                        self.interface_id.value_namespace_prefix = name_space_prefix


                            class SrlgRroSubObject(Entity):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of    :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.SrlgRroSubObject.SrlGs>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.srl_gs = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.SrlgRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.SrlgRroSubObject, self).__setattr__(name, value)


                                class SrlGs(Entity):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srl-gs" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.srl_gs:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.srl_gs:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "srlg-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "srl-gs"):
                                        for c in self.srl_gs:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.SrlgRroSubObject.SrlGs()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.srl_gs.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "srl-gs"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    self.rro_type.is_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_data()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_data()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_data()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.rro_type.yfilter != YFilter.not_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_operation()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_operation()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_operation()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-rro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.rro_type.is_set or self.rro_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rro_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4rro-sub-object"):
                                    if (self.ipv4rro_sub_object is None):
                                        self.ipv4rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.Ipv4RroSubObject()
                                        self.ipv4rro_sub_object.parent = self
                                        self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                    return self.ipv4rro_sub_object

                                if (child_yang_name == "label-rro-sub-object"):
                                    if (self.label_rro_sub_object is None):
                                        self.label_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.LabelRroSubObject()
                                        self.label_rro_sub_object.parent = self
                                        self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                    return self.label_rro_sub_object

                                if (child_yang_name == "srlg-rro-sub-object"):
                                    if (self.srlg_rro_sub_object is None):
                                        self.srlg_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.SrlgRroSubObject()
                                        self.srlg_rro_sub_object.parent = self
                                        self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                    return self.srlg_rro_sub_object

                                if (child_yang_name == "unnumbered-rro-sub-object"):
                                    if (self.unnumbered_rro_sub_object is None):
                                        self.unnumbered_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro.UnnumberedRroSubObject()
                                        self.unnumbered_rro_sub_object.parent = self
                                        self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                    return self.unnumbered_rro_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4rro-sub-object" or name == "label-rro-sub-object" or name == "srlg-rro-sub-object" or name == "unnumbered-rro-sub-object" or name == "rro-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "rro-type"):
                                    self.rro_type = value
                                    self.rro_type.value_namespace = name_space
                                    self.rro_type.value_namespace_prefix = name_space_prefix


                        class ResvRro(Entity):
                            """
                            Resv RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:   :py:class:`Ipv4RroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.Ipv4RroSubObject>`
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:   :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.LabelRroSubObject>`
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:   :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:   :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.SrlgRroSubObject>`
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:   :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.UnnumberedRroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro, self).__init__()

                                self.yang_name = "resv-rro"
                                self.yang_parent_name = "s2l"

                                self.rro_type = YLeaf(YType.enumeration, "rro-type")

                                self.ipv4rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.Ipv4RroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                self._children_yang_names.add("ipv4rro-sub-object")

                                self.label_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                self._children_yang_names.add("label-rro-sub-object")

                                self.srlg_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._children_yang_names.add("srlg-rro-sub-object")

                                self.unnumbered_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                self._children_yang_names.add("unnumbered-rro-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("rro_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro, self).__setattr__(name, value)


                            class Ipv4RroSubObject(Entity):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.Ipv4RroSubObject.Flags>`
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.Ipv4RroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.rro_address = YLeaf(YType.str, "rro-address")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.Ipv4RroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("rro_address") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.Ipv4RroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.Ipv4RroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.rro_address.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.rro_address.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.rro_address.is_set or self.rro_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rro_address.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.Ipv4RroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "rro-address"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "rro-address"):
                                        self.rro_address = value
                                        self.rro_address.value_namespace = name_space
                                        self.rro_address.value_namespace_prefix = name_space_prefix


                            class LabelRroSubObject(Entity):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.LabelRroSubObject.Flags>`
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\:  bool
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of    :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.is_label_variable_length = YLeaf(YType.boolean, "is-label-variable-length")

                                    self.label = YLeaf(YType.uint32, "label")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                    self.variable_length_label = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_label_variable_length",
                                                    "label") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.LabelRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.LabelRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.is_global_label = YLeaf(YType.boolean, "is-global-label")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_global_label") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.is_global_label.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_global_label.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_global_label.is_set or self.is_global_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_global_label.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-global-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-global-label"):
                                            self.is_global_label = value
                                            self.is_global_label.value_namespace = name_space
                                            self.is_global_label.value_namespace_prefix = name_space_prefix


                                class VariableLengthLabel(Entity):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "variable-length-label" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.variable_length_label:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.is_label_variable_length.is_set or
                                        self.label.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    for c in self.variable_length_label:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_label_variable_length.yfilter != YFilter.not_set or
                                        self.label.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "label-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_label_variable_length.is_set or self.is_label_variable_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_label_variable_length.get_name_leafdata())
                                    if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.LabelRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    if (child_yang_name == "variable-length-label"):
                                        for c in self.variable_length_label:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.variable_length_label.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "variable-length-label" or name == "is-label-variable-length" or name == "label"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-label-variable-length"):
                                        self.is_label_variable_length = value
                                        self.is_label_variable_length.value_namespace = name_space
                                        self.is_label_variable_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label"):
                                        self.label = value
                                        self.label.value_namespace = name_space
                                        self.label.value_namespace_prefix = name_space_prefix


                            class UnnumberedRroSubObject(Entity):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags>`
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.interface_address = YLeaf(YType.str, "interface-address")

                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_address",
                                                    "interface_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.interface_address.is_set or
                                        self.interface_id.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_address.yfilter != YFilter.not_set or
                                        self.interface_id.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_address.is_set or self.interface_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_address.get_name_leafdata())
                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "interface-address" or name == "interface-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-address"):
                                        self.interface_address = value
                                        self.interface_address.value_namespace = name_space
                                        self.interface_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-id"):
                                        self.interface_id = value
                                        self.interface_id.value_namespace = name_space
                                        self.interface_id.value_namespace_prefix = name_space_prefix


                            class SrlgRroSubObject(Entity):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of    :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.srl_gs = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.SrlgRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.SrlgRroSubObject, self).__setattr__(name, value)


                                class SrlGs(Entity):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srl-gs" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.srl_gs:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.srl_gs:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "srlg-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "srl-gs"):
                                        for c in self.srl_gs:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.srl_gs.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "srl-gs"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    self.rro_type.is_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_data()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_data()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_data()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.rro_type.yfilter != YFilter.not_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_operation()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_operation()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_operation()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "resv-rro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.rro_type.is_set or self.rro_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rro_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4rro-sub-object"):
                                    if (self.ipv4rro_sub_object is None):
                                        self.ipv4rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.Ipv4RroSubObject()
                                        self.ipv4rro_sub_object.parent = self
                                        self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                    return self.ipv4rro_sub_object

                                if (child_yang_name == "label-rro-sub-object"):
                                    if (self.label_rro_sub_object is None):
                                        self.label_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.LabelRroSubObject()
                                        self.label_rro_sub_object.parent = self
                                        self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                    return self.label_rro_sub_object

                                if (child_yang_name == "srlg-rro-sub-object"):
                                    if (self.srlg_rro_sub_object is None):
                                        self.srlg_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.SrlgRroSubObject()
                                        self.srlg_rro_sub_object.parent = self
                                        self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                    return self.srlg_rro_sub_object

                                if (child_yang_name == "unnumbered-rro-sub-object"):
                                    if (self.unnumbered_rro_sub_object is None):
                                        self.unnumbered_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro.UnnumberedRroSubObject()
                                        self.unnumbered_rro_sub_object.parent = self
                                        self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                    return self.unnumbered_rro_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4rro-sub-object" or name == "label-rro-sub-object" or name == "srlg-rro-sub-object" or name == "unnumbered-rro-sub-object" or name == "rro-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "rro-type"):
                                    self.rro_type = value
                                    self.rro_type.value_namespace = name_space
                                    self.rro_type.value_namespace_prefix = name_space_prefix


                        class PathAffinityArray(Entity):
                            """
                            Tunnel's Path hops with affinity
                            
                            .. attribute:: hop_address
                            
                            	Hop address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: hop_affinity
                            
                            	Deprecated
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: hop_extended_affinity
                            
                            	Hop affinity
                            	**type**\: list of    :py:class:`HopExtendedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathAffinityArray.HopExtendedAffinity>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathAffinityArray, self).__init__()

                                self.yang_name = "path-affinity-array"
                                self.yang_parent_name = "s2l"

                                self.hop_address = YLeaf(YType.str, "hop-address")

                                self.hop_affinity = YLeaf(YType.uint32, "hop-affinity")

                                self.hop_extended_affinity = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("hop_address",
                                                "hop_affinity") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathAffinityArray, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathAffinityArray, self).__setattr__(name, value)


                            class HopExtendedAffinity(Entity):
                                """
                                Hop affinity
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__init__()

                                    self.yang_name = "hop-extended-affinity"
                                    self.yang_parent_name = "path-affinity-array"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "hop-extended-affinity" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.hop_extended_affinity:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.hop_address.is_set or
                                    self.hop_affinity.is_set)

                            def has_operation(self):
                                for c in self.hop_extended_affinity:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.hop_address.yfilter != YFilter.not_set or
                                    self.hop_affinity.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-affinity-array" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.hop_address.is_set or self.hop_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hop_address.get_name_leafdata())
                                if (self.hop_affinity.is_set or self.hop_affinity.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hop_affinity.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "hop-extended-affinity"):
                                    for c in self.hop_extended_affinity:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathAffinityArray.HopExtendedAffinity()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.hop_extended_affinity.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "hop-extended-affinity" or name == "hop-address" or name == "hop-affinity"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "hop-address"):
                                    self.hop_address = value
                                    self.hop_address.value_namespace = name_space
                                    self.hop_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "hop-affinity"):
                                    self.hop_affinity = value
                                    self.hop_affinity.value_namespace = name_space
                                    self.hop_affinity.value_namespace_prefix = name_space_prefix


                        class ReverseEroIn(Entity):
                            """
                             Reverse Incoming ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ReverseEroIn.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ReverseEroIn.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ReverseEroIn, self).__init__()

                                self.yang_name = "reverse-ero-in"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ReverseEroIn.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ReverseEroIn.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ReverseEroIn, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ReverseEroIn, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-ero-in" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ReverseEroIn.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ReverseEroIn.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class S2LSegmentRoutingPath(Entity):
                            """
                            Segment\-Routing S2L path info
                            
                            .. attribute:: has_entropy_label
                            
                            	Hop has EL specified
                            	**type**\:  bool
                            
                            .. attribute:: has_ip_addresses
                            
                            	Node has IP addresses specified
                            	**type**\:  bool
                            
                            .. attribute:: has_mpls_label
                            
                            	Hop has MPLS label specified
                            	**type**\:  bool
                            
                            .. attribute:: local_addr
                            
                            	Local IP address of adjacency or Node ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: mpls_label_value
                            
                            	The MPLS label value
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: remote_addr
                            
                            	Remote IP address of adjacency
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: sid_type
                            
                            	Type of the SID
                            	**type**\:   :py:class:`TeSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrSid>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.S2LSegmentRoutingPath, self).__init__()

                                self.yang_name = "s2l-segment-routing-path"
                                self.yang_parent_name = "s2l"

                                self.has_entropy_label = YLeaf(YType.boolean, "has-entropy-label")

                                self.has_ip_addresses = YLeaf(YType.boolean, "has-ip-addresses")

                                self.has_mpls_label = YLeaf(YType.boolean, "has-mpls-label")

                                self.local_addr = YLeaf(YType.str, "local-addr")

                                self.mpls_label_value = YLeaf(YType.uint32, "mpls-label-value")

                                self.remote_addr = YLeaf(YType.str, "remote-addr")

                                self.sid_type = YLeaf(YType.enumeration, "sid-type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("has_entropy_label",
                                                "has_ip_addresses",
                                                "has_mpls_label",
                                                "local_addr",
                                                "mpls_label_value",
                                                "remote_addr",
                                                "sid_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.S2LSegmentRoutingPath, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.S2LSegmentRoutingPath, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.has_entropy_label.is_set or
                                    self.has_ip_addresses.is_set or
                                    self.has_mpls_label.is_set or
                                    self.local_addr.is_set or
                                    self.mpls_label_value.is_set or
                                    self.remote_addr.is_set or
                                    self.sid_type.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.has_entropy_label.yfilter != YFilter.not_set or
                                    self.has_ip_addresses.yfilter != YFilter.not_set or
                                    self.has_mpls_label.yfilter != YFilter.not_set or
                                    self.local_addr.yfilter != YFilter.not_set or
                                    self.mpls_label_value.yfilter != YFilter.not_set or
                                    self.remote_addr.yfilter != YFilter.not_set or
                                    self.sid_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-segment-routing-path" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.has_entropy_label.is_set or self.has_entropy_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_entropy_label.get_name_leafdata())
                                if (self.has_ip_addresses.is_set or self.has_ip_addresses.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_ip_addresses.get_name_leafdata())
                                if (self.has_mpls_label.is_set or self.has_mpls_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_mpls_label.get_name_leafdata())
                                if (self.local_addr.is_set or self.local_addr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_addr.get_name_leafdata())
                                if (self.mpls_label_value.is_set or self.mpls_label_value.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mpls_label_value.get_name_leafdata())
                                if (self.remote_addr.is_set or self.remote_addr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.remote_addr.get_name_leafdata())
                                if (self.sid_type.is_set or self.sid_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.sid_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "has-entropy-label" or name == "has-ip-addresses" or name == "has-mpls-label" or name == "local-addr" or name == "mpls-label-value" or name == "remote-addr" or name == "sid-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "has-entropy-label"):
                                    self.has_entropy_label = value
                                    self.has_entropy_label.value_namespace = name_space
                                    self.has_entropy_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-ip-addresses"):
                                    self.has_ip_addresses = value
                                    self.has_ip_addresses.value_namespace = name_space
                                    self.has_ip_addresses.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-mpls-label"):
                                    self.has_mpls_label = value
                                    self.has_mpls_label.value_namespace = name_space
                                    self.has_mpls_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "local-addr"):
                                    self.local_addr = value
                                    self.local_addr.value_namespace = name_space
                                    self.local_addr.value_namespace_prefix = name_space_prefix
                                if(value_path == "mpls-label-value"):
                                    self.mpls_label_value = value
                                    self.mpls_label_value.value_namespace = name_space
                                    self.mpls_label_value.value_namespace_prefix = name_space_prefix
                                if(value_path == "remote-addr"):
                                    self.remote_addr = value
                                    self.remote_addr.value_namespace = name_space
                                    self.remote_addr.value_namespace_prefix = name_space_prefix
                                if(value_path == "sid-type"):
                                    self.sid_type = value
                                    self.sid_type.value_namespace = name_space
                                    self.sid_type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.in_ero:
                                if (c.has_data()):
                                    return True
                            for c in self.out_ero:
                                if (c.has_data()):
                                    return True
                            for c in self.path_affinity_array:
                                if (c.has_data()):
                                    return True
                            for c in self.path_rro:
                                if (c.has_data()):
                                    return True
                            for c in self.resv_rro:
                                if (c.has_data()):
                                    return True
                            for c in self.reverse_ero_in:
                                if (c.has_data()):
                                    return True
                            for c in self.s2l_reverse_lsp_sub_obj:
                                if (c.has_data()):
                                    return True
                            for c in self.s2l_segment_routing_path:
                                if (c.has_data()):
                                    return True
                            for c in self.shared_risk_link_group:
                                if (c.has_data()):
                                    return True
                            return (
                                self.abr_auto_discovered.is_set or
                                self.backup_tunnel_interface.is_set or
                                self.downstream_router_id.is_set or
                                self.egress_interface.is_set or
                                self.egress_interface_brief.is_set or
                                self.egress_interface_state.is_set or
                                self.expanded_ero_affinity_bits.is_set or
                                self.expanded_ero_affinity_mask.is_set or
                                self.expanded_ero_area_id.is_set or
                                self.expanded_ero_metric.is_set or
                                self.expanded_ero_metric_type.is_set or
                                self.frr_out_tunnel_interface.is_set or
                                self.incoming_address.is_set or
                                self.ingress_interface.is_set or
                                self.ingress_interface_brief.is_set or
                                self.ingress_interface_state.is_set or
                                self.is_bandwidth_protect.is_set or
                                self.is_expanded_ero.is_set or
                                self.is_frr_enabled.is_set or
                                self.is_node_protected.is_set or
                                self.is_optical.is_set or
                                self.local_router_id.is_set or
                                self.next_hop_address.is_set or
                                self.node_hop_count.is_set or
                                self.outbound_frr_state.is_set or
                                self.path_reeval_query_mid.is_set or
                                self.path_rro_enabled.is_set or
                                self.path_using_strict_spf.is_set or
                                self.pcalc_area.is_set or
                                self.previous_hop_address.is_set or
                                self.reverse_lsp_connected.is_set or
                                self.reverse_lsp_name.is_set or
                                self.reverse_lsp_present.is_set or
                                self.reverse_weight.is_set or
                                self.role.is_set or
                                self.s2l_local_label.is_set or
                                self.s2l_out_label.is_set or
                                self.s2l_reverse_ero_obj_present.is_set or
                                self.s2l_reverse_tspec_obj_present.is_set or
                                self.signalling_status.is_set or
                                self.time_since_last_preferred_path_exists_send_mid.is_set or
                                self.time_since_last_preferred_tree_exists_send_mid.is_set or
                                self.time_since_last_query_received_mid.is_set or
                                self.upstream_router_id.is_set or
                                self.uptime.is_set or
                                self.weight.is_set or
                                (self.active_path_option is not None and self.active_path_option.has_data()) or
                                (self.association is not None and self.association.has_data()) or
                                (self.diversity_info is not None and self.diversity_info.has_data()) or
                                (self.flex_info is not None and self.flex_info.has_data()) or
                                (self.fspec is not None and self.fspec.has_data()) or
                                (self.generic_fspec is not None and self.generic_fspec.has_data()) or
                                (self.generic_tspec is not None and self.generic_tspec.has_data()) or
                                (self.gmpls_labels is not None and self.gmpls_labels.has_data()) or
                                (self.head_end_bfd_info is not None and self.head_end_bfd_info.has_data()) or
                                (self.in_xro is not None and self.in_xro.has_data()) or
                                (self.incoming_address_generic is not None and self.incoming_address_generic.has_data()) or
                                (self.lsp_wrap_info is not None and self.lsp_wrap_info.has_data()) or
                                (self.next_hop_address_generic is not None and self.next_hop_address_generic.has_data()) or
                                (self.otn_s2l is not None and self.otn_s2l.has_data()) or
                                (self.out_xro is not None and self.out_xro.has_data()) or
                                (self.previous_hop_address_generic is not None and self.previous_hop_address_generic.has_data()) or
                                (self.protection is not None and self.protection.has_data()) or
                                (self.reverse_lsp_fec is not None and self.reverse_lsp_fec.has_data()) or
                                (self.reverse_tspec is not None and self.reverse_tspec.has_data()) or
                                (self.s2l_convergence is not None and self.s2l_convergence.has_data()) or
                                (self.s2l_fec is not None and self.s2l_fec.has_data()) or
                                (self.soft_preemption is not None and self.soft_preemption.has_data()) or
                                (self.srlg_collection is not None and self.srlg_collection.has_data()) or
                                (self.tail_end_bfd_info is not None and self.tail_end_bfd_info.has_data()) or
                                (self.tspec is not None and self.tspec.has_data()))

                        def has_operation(self):
                            for c in self.in_ero:
                                if (c.has_operation()):
                                    return True
                            for c in self.out_ero:
                                if (c.has_operation()):
                                    return True
                            for c in self.path_affinity_array:
                                if (c.has_operation()):
                                    return True
                            for c in self.path_rro:
                                if (c.has_operation()):
                                    return True
                            for c in self.resv_rro:
                                if (c.has_operation()):
                                    return True
                            for c in self.reverse_ero_in:
                                if (c.has_operation()):
                                    return True
                            for c in self.s2l_reverse_lsp_sub_obj:
                                if (c.has_operation()):
                                    return True
                            for c in self.s2l_segment_routing_path:
                                if (c.has_operation()):
                                    return True
                            for c in self.shared_risk_link_group:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.abr_auto_discovered.yfilter != YFilter.not_set or
                                self.backup_tunnel_interface.yfilter != YFilter.not_set or
                                self.downstream_router_id.yfilter != YFilter.not_set or
                                self.egress_interface.yfilter != YFilter.not_set or
                                self.egress_interface_brief.yfilter != YFilter.not_set or
                                self.egress_interface_state.yfilter != YFilter.not_set or
                                self.expanded_ero_affinity_bits.yfilter != YFilter.not_set or
                                self.expanded_ero_affinity_mask.yfilter != YFilter.not_set or
                                self.expanded_ero_area_id.yfilter != YFilter.not_set or
                                self.expanded_ero_metric.yfilter != YFilter.not_set or
                                self.expanded_ero_metric_type.yfilter != YFilter.not_set or
                                self.frr_out_tunnel_interface.yfilter != YFilter.not_set or
                                self.incoming_address.yfilter != YFilter.not_set or
                                self.ingress_interface.yfilter != YFilter.not_set or
                                self.ingress_interface_brief.yfilter != YFilter.not_set or
                                self.ingress_interface_state.yfilter != YFilter.not_set or
                                self.is_bandwidth_protect.yfilter != YFilter.not_set or
                                self.is_expanded_ero.yfilter != YFilter.not_set or
                                self.is_frr_enabled.yfilter != YFilter.not_set or
                                self.is_node_protected.yfilter != YFilter.not_set or
                                self.is_optical.yfilter != YFilter.not_set or
                                self.local_router_id.yfilter != YFilter.not_set or
                                self.next_hop_address.yfilter != YFilter.not_set or
                                self.node_hop_count.yfilter != YFilter.not_set or
                                self.outbound_frr_state.yfilter != YFilter.not_set or
                                self.path_reeval_query_mid.yfilter != YFilter.not_set or
                                self.path_rro_enabled.yfilter != YFilter.not_set or
                                self.path_using_strict_spf.yfilter != YFilter.not_set or
                                self.pcalc_area.yfilter != YFilter.not_set or
                                self.previous_hop_address.yfilter != YFilter.not_set or
                                self.reverse_lsp_connected.yfilter != YFilter.not_set or
                                self.reverse_lsp_name.yfilter != YFilter.not_set or
                                self.reverse_lsp_present.yfilter != YFilter.not_set or
                                self.reverse_weight.yfilter != YFilter.not_set or
                                self.role.yfilter != YFilter.not_set or
                                self.s2l_local_label.yfilter != YFilter.not_set or
                                self.s2l_out_label.yfilter != YFilter.not_set or
                                self.s2l_reverse_ero_obj_present.yfilter != YFilter.not_set or
                                self.s2l_reverse_tspec_obj_present.yfilter != YFilter.not_set or
                                self.signalling_status.yfilter != YFilter.not_set or
                                self.time_since_last_preferred_path_exists_send_mid.yfilter != YFilter.not_set or
                                self.time_since_last_preferred_tree_exists_send_mid.yfilter != YFilter.not_set or
                                self.time_since_last_query_received_mid.yfilter != YFilter.not_set or
                                self.upstream_router_id.yfilter != YFilter.not_set or
                                self.uptime.yfilter != YFilter.not_set or
                                self.weight.yfilter != YFilter.not_set or
                                (self.active_path_option is not None and self.active_path_option.has_operation()) or
                                (self.association is not None and self.association.has_operation()) or
                                (self.diversity_info is not None and self.diversity_info.has_operation()) or
                                (self.flex_info is not None and self.flex_info.has_operation()) or
                                (self.fspec is not None and self.fspec.has_operation()) or
                                (self.generic_fspec is not None and self.generic_fspec.has_operation()) or
                                (self.generic_tspec is not None and self.generic_tspec.has_operation()) or
                                (self.gmpls_labels is not None and self.gmpls_labels.has_operation()) or
                                (self.head_end_bfd_info is not None and self.head_end_bfd_info.has_operation()) or
                                (self.in_xro is not None and self.in_xro.has_operation()) or
                                (self.incoming_address_generic is not None and self.incoming_address_generic.has_operation()) or
                                (self.lsp_wrap_info is not None and self.lsp_wrap_info.has_operation()) or
                                (self.next_hop_address_generic is not None and self.next_hop_address_generic.has_operation()) or
                                (self.otn_s2l is not None and self.otn_s2l.has_operation()) or
                                (self.out_xro is not None and self.out_xro.has_operation()) or
                                (self.previous_hop_address_generic is not None and self.previous_hop_address_generic.has_operation()) or
                                (self.protection is not None and self.protection.has_operation()) or
                                (self.reverse_lsp_fec is not None and self.reverse_lsp_fec.has_operation()) or
                                (self.reverse_tspec is not None and self.reverse_tspec.has_operation()) or
                                (self.s2l_convergence is not None and self.s2l_convergence.has_operation()) or
                                (self.s2l_fec is not None and self.s2l_fec.has_operation()) or
                                (self.soft_preemption is not None and self.soft_preemption.has_operation()) or
                                (self.srlg_collection is not None and self.srlg_collection.has_operation()) or
                                (self.tail_end_bfd_info is not None and self.tail_end_bfd_info.has_operation()) or
                                (self.tspec is not None and self.tspec.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "s2l" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.abr_auto_discovered.is_set or self.abr_auto_discovered.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.abr_auto_discovered.get_name_leafdata())
                            if (self.backup_tunnel_interface.is_set or self.backup_tunnel_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.backup_tunnel_interface.get_name_leafdata())
                            if (self.downstream_router_id.is_set or self.downstream_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.downstream_router_id.get_name_leafdata())
                            if (self.egress_interface.is_set or self.egress_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface.get_name_leafdata())
                            if (self.egress_interface_brief.is_set or self.egress_interface_brief.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface_brief.get_name_leafdata())
                            if (self.egress_interface_state.is_set or self.egress_interface_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface_state.get_name_leafdata())
                            if (self.expanded_ero_affinity_bits.is_set or self.expanded_ero_affinity_bits.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_affinity_bits.get_name_leafdata())
                            if (self.expanded_ero_affinity_mask.is_set or self.expanded_ero_affinity_mask.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_affinity_mask.get_name_leafdata())
                            if (self.expanded_ero_area_id.is_set or self.expanded_ero_area_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_area_id.get_name_leafdata())
                            if (self.expanded_ero_metric.is_set or self.expanded_ero_metric.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_metric.get_name_leafdata())
                            if (self.expanded_ero_metric_type.is_set or self.expanded_ero_metric_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_metric_type.get_name_leafdata())
                            if (self.frr_out_tunnel_interface.is_set or self.frr_out_tunnel_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.frr_out_tunnel_interface.get_name_leafdata())
                            if (self.incoming_address.is_set or self.incoming_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.incoming_address.get_name_leafdata())
                            if (self.ingress_interface.is_set or self.ingress_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface.get_name_leafdata())
                            if (self.ingress_interface_brief.is_set or self.ingress_interface_brief.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface_brief.get_name_leafdata())
                            if (self.ingress_interface_state.is_set or self.ingress_interface_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface_state.get_name_leafdata())
                            if (self.is_bandwidth_protect.is_set or self.is_bandwidth_protect.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_bandwidth_protect.get_name_leafdata())
                            if (self.is_expanded_ero.is_set or self.is_expanded_ero.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_expanded_ero.get_name_leafdata())
                            if (self.is_frr_enabled.is_set or self.is_frr_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_frr_enabled.get_name_leafdata())
                            if (self.is_node_protected.is_set or self.is_node_protected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_node_protected.get_name_leafdata())
                            if (self.is_optical.is_set or self.is_optical.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_optical.get_name_leafdata())
                            if (self.local_router_id.is_set or self.local_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.local_router_id.get_name_leafdata())
                            if (self.next_hop_address.is_set or self.next_hop_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.next_hop_address.get_name_leafdata())
                            if (self.node_hop_count.is_set or self.node_hop_count.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.node_hop_count.get_name_leafdata())
                            if (self.outbound_frr_state.is_set or self.outbound_frr_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.outbound_frr_state.get_name_leafdata())
                            if (self.path_reeval_query_mid.is_set or self.path_reeval_query_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reeval_query_mid.get_name_leafdata())
                            if (self.path_rro_enabled.is_set or self.path_rro_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_rro_enabled.get_name_leafdata())
                            if (self.path_using_strict_spf.is_set or self.path_using_strict_spf.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_using_strict_spf.get_name_leafdata())
                            if (self.pcalc_area.is_set or self.pcalc_area.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.pcalc_area.get_name_leafdata())
                            if (self.previous_hop_address.is_set or self.previous_hop_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.previous_hop_address.get_name_leafdata())
                            if (self.reverse_lsp_connected.is_set or self.reverse_lsp_connected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_connected.get_name_leafdata())
                            if (self.reverse_lsp_name.is_set or self.reverse_lsp_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_name.get_name_leafdata())
                            if (self.reverse_lsp_present.is_set or self.reverse_lsp_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_present.get_name_leafdata())
                            if (self.reverse_weight.is_set or self.reverse_weight.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_weight.get_name_leafdata())
                            if (self.role.is_set or self.role.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.role.get_name_leafdata())
                            if (self.s2l_local_label.is_set or self.s2l_local_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_local_label.get_name_leafdata())
                            if (self.s2l_out_label.is_set or self.s2l_out_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_out_label.get_name_leafdata())
                            if (self.s2l_reverse_ero_obj_present.is_set or self.s2l_reverse_ero_obj_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_reverse_ero_obj_present.get_name_leafdata())
                            if (self.s2l_reverse_tspec_obj_present.is_set or self.s2l_reverse_tspec_obj_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_reverse_tspec_obj_present.get_name_leafdata())
                            if (self.signalling_status.is_set or self.signalling_status.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.signalling_status.get_name_leafdata())
                            if (self.time_since_last_preferred_path_exists_send_mid.is_set or self.time_since_last_preferred_path_exists_send_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_preferred_path_exists_send_mid.get_name_leafdata())
                            if (self.time_since_last_preferred_tree_exists_send_mid.is_set or self.time_since_last_preferred_tree_exists_send_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_preferred_tree_exists_send_mid.get_name_leafdata())
                            if (self.time_since_last_query_received_mid.is_set or self.time_since_last_query_received_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_query_received_mid.get_name_leafdata())
                            if (self.upstream_router_id.is_set or self.upstream_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.upstream_router_id.get_name_leafdata())
                            if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.uptime.get_name_leafdata())
                            if (self.weight.is_set or self.weight.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.weight.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "active-path-option"):
                                if (self.active_path_option is None):
                                    self.active_path_option = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ActivePathOption()
                                    self.active_path_option.parent = self
                                    self._children_name_map["active_path_option"] = "active-path-option"
                                return self.active_path_option

                            if (child_yang_name == "association"):
                                if (self.association is None):
                                    self.association = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.Association()
                                    self.association.parent = self
                                    self._children_name_map["association"] = "association"
                                return self.association

                            if (child_yang_name == "diversity-info"):
                                if (self.diversity_info is None):
                                    self.diversity_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.DiversityInfo()
                                    self.diversity_info.parent = self
                                    self._children_name_map["diversity_info"] = "diversity-info"
                                return self.diversity_info

                            if (child_yang_name == "flex-info"):
                                if (self.flex_info is None):
                                    self.flex_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.FlexInfo()
                                    self.flex_info.parent = self
                                    self._children_name_map["flex_info"] = "flex-info"
                                return self.flex_info

                            if (child_yang_name == "fspec"):
                                if (self.fspec is None):
                                    self.fspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.Fspec()
                                    self.fspec.parent = self
                                    self._children_name_map["fspec"] = "fspec"
                                return self.fspec

                            if (child_yang_name == "generic-fspec"):
                                if (self.generic_fspec is None):
                                    self.generic_fspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GenericFspec()
                                    self.generic_fspec.parent = self
                                    self._children_name_map["generic_fspec"] = "generic-fspec"
                                return self.generic_fspec

                            if (child_yang_name == "generic-tspec"):
                                if (self.generic_tspec is None):
                                    self.generic_tspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GenericTspec()
                                    self.generic_tspec.parent = self
                                    self._children_name_map["generic_tspec"] = "generic-tspec"
                                return self.generic_tspec

                            if (child_yang_name == "gmpls-labels"):
                                if (self.gmpls_labels is None):
                                    self.gmpls_labels = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.GmplsLabels()
                                    self.gmpls_labels.parent = self
                                    self._children_name_map["gmpls_labels"] = "gmpls-labels"
                                return self.gmpls_labels

                            if (child_yang_name == "head-end-bfd-info"):
                                if (self.head_end_bfd_info is None):
                                    self.head_end_bfd_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.HeadEndBfdInfo()
                                    self.head_end_bfd_info.parent = self
                                    self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"
                                return self.head_end_bfd_info

                            if (child_yang_name == "in-ero"):
                                for c in self.in_ero:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InEro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.in_ero.append(c)
                                return c

                            if (child_yang_name == "in-xro"):
                                if (self.in_xro is None):
                                    self.in_xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.InXro()
                                    self.in_xro.parent = self
                                    self._children_name_map["in_xro"] = "in-xro"
                                return self.in_xro

                            if (child_yang_name == "incoming-address-generic"):
                                if (self.incoming_address_generic is None):
                                    self.incoming_address_generic = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.IncomingAddressGeneric()
                                    self.incoming_address_generic.parent = self
                                    self._children_name_map["incoming_address_generic"] = "incoming-address-generic"
                                return self.incoming_address_generic

                            if (child_yang_name == "lsp-wrap-info"):
                                if (self.lsp_wrap_info is None):
                                    self.lsp_wrap_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.LspWrapInfo()
                                    self.lsp_wrap_info.parent = self
                                    self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"
                                return self.lsp_wrap_info

                            if (child_yang_name == "next-hop-address-generic"):
                                if (self.next_hop_address_generic is None):
                                    self.next_hop_address_generic = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.NextHopAddressGeneric()
                                    self.next_hop_address_generic.parent = self
                                    self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"
                                return self.next_hop_address_generic

                            if (child_yang_name == "otn-s2l"):
                                if (self.otn_s2l is None):
                                    self.otn_s2l = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OtnS2L()
                                    self.otn_s2l.parent = self
                                    self._children_name_map["otn_s2l"] = "otn-s2l"
                                return self.otn_s2l

                            if (child_yang_name == "out-ero"):
                                for c in self.out_ero:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutEro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.out_ero.append(c)
                                return c

                            if (child_yang_name == "out-xro"):
                                if (self.out_xro is None):
                                    self.out_xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.OutXro()
                                    self.out_xro.parent = self
                                    self._children_name_map["out_xro"] = "out-xro"
                                return self.out_xro

                            if (child_yang_name == "path-affinity-array"):
                                for c in self.path_affinity_array:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathAffinityArray()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_affinity_array.append(c)
                                return c

                            if (child_yang_name == "path-rro"):
                                for c in self.path_rro:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PathRro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_rro.append(c)
                                return c

                            if (child_yang_name == "previous-hop-address-generic"):
                                if (self.previous_hop_address_generic is None):
                                    self.previous_hop_address_generic = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.PreviousHopAddressGeneric()
                                    self.previous_hop_address_generic.parent = self
                                    self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"
                                return self.previous_hop_address_generic

                            if (child_yang_name == "protection"):
                                if (self.protection is None):
                                    self.protection = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.Protection()
                                    self.protection.parent = self
                                    self._children_name_map["protection"] = "protection"
                                return self.protection

                            if (child_yang_name == "resv-rro"):
                                for c in self.resv_rro:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ResvRro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.resv_rro.append(c)
                                return c

                            if (child_yang_name == "reverse-ero-in"):
                                for c in self.reverse_ero_in:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ReverseEroIn()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.reverse_ero_in.append(c)
                                return c

                            if (child_yang_name == "reverse-lsp-fec"):
                                if (self.reverse_lsp_fec is None):
                                    self.reverse_lsp_fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ReverseLspFec()
                                    self.reverse_lsp_fec.parent = self
                                    self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"
                                return self.reverse_lsp_fec

                            if (child_yang_name == "reverse-tspec"):
                                if (self.reverse_tspec is None):
                                    self.reverse_tspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.ReverseTspec()
                                    self.reverse_tspec.parent = self
                                    self._children_name_map["reverse_tspec"] = "reverse-tspec"
                                return self.reverse_tspec

                            if (child_yang_name == "s2l-convergence"):
                                if (self.s2l_convergence is None):
                                    self.s2l_convergence = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.S2LConvergence()
                                    self.s2l_convergence.parent = self
                                    self._children_name_map["s2l_convergence"] = "s2l-convergence"
                                return self.s2l_convergence

                            if (child_yang_name == "s2l-fec"):
                                if (self.s2l_fec is None):
                                    self.s2l_fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.S2LFec()
                                    self.s2l_fec.parent = self
                                    self._children_name_map["s2l_fec"] = "s2l-fec"
                                return self.s2l_fec

                            if (child_yang_name == "s2l-reverse-lsp-sub-obj"):
                                for c in self.s2l_reverse_lsp_sub_obj:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.S2LReverseLspSubObj()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.s2l_reverse_lsp_sub_obj.append(c)
                                return c

                            if (child_yang_name == "s2l-segment-routing-path"):
                                for c in self.s2l_segment_routing_path:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.S2LSegmentRoutingPath()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.s2l_segment_routing_path.append(c)
                                return c

                            if (child_yang_name == "shared-risk-link-group"):
                                for c in self.shared_risk_link_group:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.SharedRiskLinkGroup()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.shared_risk_link_group.append(c)
                                return c

                            if (child_yang_name == "soft-preemption"):
                                if (self.soft_preemption is None):
                                    self.soft_preemption = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.SoftPreemption()
                                    self.soft_preemption.parent = self
                                    self._children_name_map["soft_preemption"] = "soft-preemption"
                                return self.soft_preemption

                            if (child_yang_name == "srlg-collection"):
                                if (self.srlg_collection is None):
                                    self.srlg_collection = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.SrlgCollection()
                                    self.srlg_collection.parent = self
                                    self._children_name_map["srlg_collection"] = "srlg-collection"
                                return self.srlg_collection

                            if (child_yang_name == "tail-end-bfd-info"):
                                if (self.tail_end_bfd_info is None):
                                    self.tail_end_bfd_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.TailEndBfdInfo()
                                    self.tail_end_bfd_info.parent = self
                                    self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"
                                return self.tail_end_bfd_info

                            if (child_yang_name == "tspec"):
                                if (self.tspec is None):
                                    self.tspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L.Tspec()
                                    self.tspec.parent = self
                                    self._children_name_map["tspec"] = "tspec"
                                return self.tspec

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "active-path-option" or name == "association" or name == "diversity-info" or name == "flex-info" or name == "fspec" or name == "generic-fspec" or name == "generic-tspec" or name == "gmpls-labels" or name == "head-end-bfd-info" or name == "in-ero" or name == "in-xro" or name == "incoming-address-generic" or name == "lsp-wrap-info" or name == "next-hop-address-generic" or name == "otn-s2l" or name == "out-ero" or name == "out-xro" or name == "path-affinity-array" or name == "path-rro" or name == "previous-hop-address-generic" or name == "protection" or name == "resv-rro" or name == "reverse-ero-in" or name == "reverse-lsp-fec" or name == "reverse-tspec" or name == "s2l-convergence" or name == "s2l-fec" or name == "s2l-reverse-lsp-sub-obj" or name == "s2l-segment-routing-path" or name == "shared-risk-link-group" or name == "soft-preemption" or name == "srlg-collection" or name == "tail-end-bfd-info" or name == "tspec" or name == "abr-auto-discovered" or name == "backup-tunnel-interface" or name == "downstream-router-id" or name == "egress-interface" or name == "egress-interface-brief" or name == "egress-interface-state" or name == "expanded-ero-affinity-bits" or name == "expanded-ero-affinity-mask" or name == "expanded-ero-area-id" or name == "expanded-ero-metric" or name == "expanded-ero-metric-type" or name == "frr-out-tunnel-interface" or name == "incoming-address" or name == "ingress-interface" or name == "ingress-interface-brief" or name == "ingress-interface-state" or name == "is-bandwidth-protect" or name == "is-expanded-ero" or name == "is-frr-enabled" or name == "is-node-protected" or name == "is-optical" or name == "local-router-id" or name == "next-hop-address" or name == "node-hop-count" or name == "outbound-frr-state" or name == "path-reeval-query-mid" or name == "path-rro-enabled" or name == "path-using-strict-spf" or name == "pcalc-area" or name == "previous-hop-address" or name == "reverse-lsp-connected" or name == "reverse-lsp-name" or name == "reverse-lsp-present" or name == "reverse-weight" or name == "role" or name == "s2l-local-label" or name == "s2l-out-label" or name == "s2l-reverse-ero-obj-present" or name == "s2l-reverse-tspec-obj-present" or name == "signalling-status" or name == "time-since-last-preferred-path-exists-send-mid" or name == "time-since-last-preferred-tree-exists-send-mid" or name == "time-since-last-query-received-mid" or name == "upstream-router-id" or name == "uptime" or name == "weight"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "abr-auto-discovered"):
                                self.abr_auto_discovered = value
                                self.abr_auto_discovered.value_namespace = name_space
                                self.abr_auto_discovered.value_namespace_prefix = name_space_prefix
                            if(value_path == "backup-tunnel-interface"):
                                self.backup_tunnel_interface = value
                                self.backup_tunnel_interface.value_namespace = name_space
                                self.backup_tunnel_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "downstream-router-id"):
                                self.downstream_router_id = value
                                self.downstream_router_id.value_namespace = name_space
                                self.downstream_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface"):
                                self.egress_interface = value
                                self.egress_interface.value_namespace = name_space
                                self.egress_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface-brief"):
                                self.egress_interface_brief = value
                                self.egress_interface_brief.value_namespace = name_space
                                self.egress_interface_brief.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface-state"):
                                self.egress_interface_state = value
                                self.egress_interface_state.value_namespace = name_space
                                self.egress_interface_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-affinity-bits"):
                                self.expanded_ero_affinity_bits = value
                                self.expanded_ero_affinity_bits.value_namespace = name_space
                                self.expanded_ero_affinity_bits.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-affinity-mask"):
                                self.expanded_ero_affinity_mask = value
                                self.expanded_ero_affinity_mask.value_namespace = name_space
                                self.expanded_ero_affinity_mask.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-area-id"):
                                self.expanded_ero_area_id = value
                                self.expanded_ero_area_id.value_namespace = name_space
                                self.expanded_ero_area_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-metric"):
                                self.expanded_ero_metric = value
                                self.expanded_ero_metric.value_namespace = name_space
                                self.expanded_ero_metric.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-metric-type"):
                                self.expanded_ero_metric_type = value
                                self.expanded_ero_metric_type.value_namespace = name_space
                                self.expanded_ero_metric_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "frr-out-tunnel-interface"):
                                self.frr_out_tunnel_interface = value
                                self.frr_out_tunnel_interface.value_namespace = name_space
                                self.frr_out_tunnel_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "incoming-address"):
                                self.incoming_address = value
                                self.incoming_address.value_namespace = name_space
                                self.incoming_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface"):
                                self.ingress_interface = value
                                self.ingress_interface.value_namespace = name_space
                                self.ingress_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface-brief"):
                                self.ingress_interface_brief = value
                                self.ingress_interface_brief.value_namespace = name_space
                                self.ingress_interface_brief.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface-state"):
                                self.ingress_interface_state = value
                                self.ingress_interface_state.value_namespace = name_space
                                self.ingress_interface_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-bandwidth-protect"):
                                self.is_bandwidth_protect = value
                                self.is_bandwidth_protect.value_namespace = name_space
                                self.is_bandwidth_protect.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-expanded-ero"):
                                self.is_expanded_ero = value
                                self.is_expanded_ero.value_namespace = name_space
                                self.is_expanded_ero.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-frr-enabled"):
                                self.is_frr_enabled = value
                                self.is_frr_enabled.value_namespace = name_space
                                self.is_frr_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-node-protected"):
                                self.is_node_protected = value
                                self.is_node_protected.value_namespace = name_space
                                self.is_node_protected.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-optical"):
                                self.is_optical = value
                                self.is_optical.value_namespace = name_space
                                self.is_optical.value_namespace_prefix = name_space_prefix
                            if(value_path == "local-router-id"):
                                self.local_router_id = value
                                self.local_router_id.value_namespace = name_space
                                self.local_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "next-hop-address"):
                                self.next_hop_address = value
                                self.next_hop_address.value_namespace = name_space
                                self.next_hop_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "node-hop-count"):
                                self.node_hop_count = value
                                self.node_hop_count.value_namespace = name_space
                                self.node_hop_count.value_namespace_prefix = name_space_prefix
                            if(value_path == "outbound-frr-state"):
                                self.outbound_frr_state = value
                                self.outbound_frr_state.value_namespace = name_space
                                self.outbound_frr_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reeval-query-mid"):
                                self.path_reeval_query_mid = value
                                self.path_reeval_query_mid.value_namespace = name_space
                                self.path_reeval_query_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-rro-enabled"):
                                self.path_rro_enabled = value
                                self.path_rro_enabled.value_namespace = name_space
                                self.path_rro_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-using-strict-spf"):
                                self.path_using_strict_spf = value
                                self.path_using_strict_spf.value_namespace = name_space
                                self.path_using_strict_spf.value_namespace_prefix = name_space_prefix
                            if(value_path == "pcalc-area"):
                                self.pcalc_area = value
                                self.pcalc_area.value_namespace = name_space
                                self.pcalc_area.value_namespace_prefix = name_space_prefix
                            if(value_path == "previous-hop-address"):
                                self.previous_hop_address = value
                                self.previous_hop_address.value_namespace = name_space
                                self.previous_hop_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-connected"):
                                self.reverse_lsp_connected = value
                                self.reverse_lsp_connected.value_namespace = name_space
                                self.reverse_lsp_connected.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-name"):
                                self.reverse_lsp_name = value
                                self.reverse_lsp_name.value_namespace = name_space
                                self.reverse_lsp_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-present"):
                                self.reverse_lsp_present = value
                                self.reverse_lsp_present.value_namespace = name_space
                                self.reverse_lsp_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-weight"):
                                self.reverse_weight = value
                                self.reverse_weight.value_namespace = name_space
                                self.reverse_weight.value_namespace_prefix = name_space_prefix
                            if(value_path == "role"):
                                self.role = value
                                self.role.value_namespace = name_space
                                self.role.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-local-label"):
                                self.s2l_local_label = value
                                self.s2l_local_label.value_namespace = name_space
                                self.s2l_local_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-out-label"):
                                self.s2l_out_label = value
                                self.s2l_out_label.value_namespace = name_space
                                self.s2l_out_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-reverse-ero-obj-present"):
                                self.s2l_reverse_ero_obj_present = value
                                self.s2l_reverse_ero_obj_present.value_namespace = name_space
                                self.s2l_reverse_ero_obj_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-reverse-tspec-obj-present"):
                                self.s2l_reverse_tspec_obj_present = value
                                self.s2l_reverse_tspec_obj_present.value_namespace = name_space
                                self.s2l_reverse_tspec_obj_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "signalling-status"):
                                self.signalling_status = value
                                self.signalling_status.value_namespace = name_space
                                self.signalling_status.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-preferred-path-exists-send-mid"):
                                self.time_since_last_preferred_path_exists_send_mid = value
                                self.time_since_last_preferred_path_exists_send_mid.value_namespace = name_space
                                self.time_since_last_preferred_path_exists_send_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-preferred-tree-exists-send-mid"):
                                self.time_since_last_preferred_tree_exists_send_mid = value
                                self.time_since_last_preferred_tree_exists_send_mid.value_namespace = name_space
                                self.time_since_last_preferred_tree_exists_send_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-query-received-mid"):
                                self.time_since_last_query_received_mid = value
                                self.time_since_last_query_received_mid.value_namespace = name_space
                                self.time_since_last_query_received_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "upstream-router-id"):
                                self.upstream_router_id = value
                                self.upstream_router_id.value_namespace = name_space
                                self.upstream_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "uptime"):
                                self.uptime = value
                                self.uptime.value_namespace = name_space
                                self.uptime.value_namespace_prefix = name_space_prefix
                            if(value_path == "weight"):
                                self.weight = value
                                self.weight.value_namespace = name_space
                                self.weight.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.s2l:
                            if (c.has_data()):
                                return True
                        return (
                            self.dste_class_index.is_set or
                            self.dste_class_match.is_set or
                            self.frr_active_reason.is_set or
                            self.is_frr_failed.is_set or
                            self.is_interface.is_set or
                            self.is_passive.is_set or
                            self.last_path_change.is_set or
                            self.lsp_bandwidth.is_set or
                            self.lsp_bandwidth_type.is_set or
                            self.lsp_hold_priority.is_set or
                            self.lsp_setup_priority.is_set or
                            self.persistent_bytes.is_set or
                            self.persistent_packets.is_set or
                            self.reoptimize_reason.is_set or
                            self.reoptimize_trigger.is_set or
                            self.s2_ls_down.is_set or
                            self.s2_ls_proceeding.is_set or
                            self.s2_ls_up.is_set or
                            self.signaled_name.is_set or
                            self.timer_left.is_set or
                            self.type.is_set or
                            self.uptime.is_set or
                            (self.lsp_fec is not None and self.lsp_fec.has_data()))

                    def has_operation(self):
                        for c in self.s2l:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.dste_class_index.yfilter != YFilter.not_set or
                            self.dste_class_match.yfilter != YFilter.not_set or
                            self.frr_active_reason.yfilter != YFilter.not_set or
                            self.is_frr_failed.yfilter != YFilter.not_set or
                            self.is_interface.yfilter != YFilter.not_set or
                            self.is_passive.yfilter != YFilter.not_set or
                            self.last_path_change.yfilter != YFilter.not_set or
                            self.lsp_bandwidth.yfilter != YFilter.not_set or
                            self.lsp_bandwidth_type.yfilter != YFilter.not_set or
                            self.lsp_hold_priority.yfilter != YFilter.not_set or
                            self.lsp_setup_priority.yfilter != YFilter.not_set or
                            self.persistent_bytes.yfilter != YFilter.not_set or
                            self.persistent_packets.yfilter != YFilter.not_set or
                            self.reoptimize_reason.yfilter != YFilter.not_set or
                            self.reoptimize_trigger.yfilter != YFilter.not_set or
                            self.s2_ls_down.yfilter != YFilter.not_set or
                            self.s2_ls_proceeding.yfilter != YFilter.not_set or
                            self.s2_ls_up.yfilter != YFilter.not_set or
                            self.signaled_name.yfilter != YFilter.not_set or
                            self.timer_left.yfilter != YFilter.not_set or
                            self.type.yfilter != YFilter.not_set or
                            self.uptime.yfilter != YFilter.not_set or
                            (self.lsp_fec is not None and self.lsp_fec.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "delay-clean-pp-lsp" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.dste_class_index.is_set or self.dste_class_index.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.dste_class_index.get_name_leafdata())
                        if (self.dste_class_match.is_set or self.dste_class_match.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.dste_class_match.get_name_leafdata())
                        if (self.frr_active_reason.is_set or self.frr_active_reason.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.frr_active_reason.get_name_leafdata())
                        if (self.is_frr_failed.is_set or self.is_frr_failed.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_frr_failed.get_name_leafdata())
                        if (self.is_interface.is_set or self.is_interface.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_interface.get_name_leafdata())
                        if (self.is_passive.is_set or self.is_passive.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_passive.get_name_leafdata())
                        if (self.last_path_change.is_set or self.last_path_change.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.last_path_change.get_name_leafdata())
                        if (self.lsp_bandwidth.is_set or self.lsp_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_bandwidth.get_name_leafdata())
                        if (self.lsp_bandwidth_type.is_set or self.lsp_bandwidth_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_bandwidth_type.get_name_leafdata())
                        if (self.lsp_hold_priority.is_set or self.lsp_hold_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_hold_priority.get_name_leafdata())
                        if (self.lsp_setup_priority.is_set or self.lsp_setup_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_setup_priority.get_name_leafdata())
                        if (self.persistent_bytes.is_set or self.persistent_bytes.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.persistent_bytes.get_name_leafdata())
                        if (self.persistent_packets.is_set or self.persistent_packets.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.persistent_packets.get_name_leafdata())
                        if (self.reoptimize_reason.is_set or self.reoptimize_reason.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reoptimize_reason.get_name_leafdata())
                        if (self.reoptimize_trigger.is_set or self.reoptimize_trigger.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reoptimize_trigger.get_name_leafdata())
                        if (self.s2_ls_down.is_set or self.s2_ls_down.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_down.get_name_leafdata())
                        if (self.s2_ls_proceeding.is_set or self.s2_ls_proceeding.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_proceeding.get_name_leafdata())
                        if (self.s2_ls_up.is_set or self.s2_ls_up.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_up.get_name_leafdata())
                        if (self.signaled_name.is_set or self.signaled_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.signaled_name.get_name_leafdata())
                        if (self.timer_left.is_set or self.timer_left.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.timer_left.get_name_leafdata())
                        if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.type.get_name_leafdata())
                        if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.uptime.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "lsp-fec"):
                            if (self.lsp_fec is None):
                                self.lsp_fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.LspFec()
                                self.lsp_fec.parent = self
                                self._children_name_map["lsp_fec"] = "lsp-fec"
                            return self.lsp_fec

                        if (child_yang_name == "s2l"):
                            for c in self.s2l:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp.S2L()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.s2l.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "lsp-fec" or name == "s2l" or name == "dste-class-index" or name == "dste-class-match" or name == "frr-active-reason" or name == "is-frr-failed" or name == "is-interface" or name == "is-passive" or name == "last-path-change" or name == "lsp-bandwidth" or name == "lsp-bandwidth-type" or name == "lsp-hold-priority" or name == "lsp-setup-priority" or name == "persistent-bytes" or name == "persistent-packets" or name == "reoptimize-reason" or name == "reoptimize-trigger" or name == "s2-ls-down" or name == "s2-ls-proceeding" or name == "s2-ls-up" or name == "signaled-name" or name == "timer-left" or name == "type" or name == "uptime"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "dste-class-index"):
                            self.dste_class_index = value
                            self.dste_class_index.value_namespace = name_space
                            self.dste_class_index.value_namespace_prefix = name_space_prefix
                        if(value_path == "dste-class-match"):
                            self.dste_class_match = value
                            self.dste_class_match.value_namespace = name_space
                            self.dste_class_match.value_namespace_prefix = name_space_prefix
                        if(value_path == "frr-active-reason"):
                            self.frr_active_reason = value
                            self.frr_active_reason.value_namespace = name_space
                            self.frr_active_reason.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-frr-failed"):
                            self.is_frr_failed = value
                            self.is_frr_failed.value_namespace = name_space
                            self.is_frr_failed.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-interface"):
                            self.is_interface = value
                            self.is_interface.value_namespace = name_space
                            self.is_interface.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-passive"):
                            self.is_passive = value
                            self.is_passive.value_namespace = name_space
                            self.is_passive.value_namespace_prefix = name_space_prefix
                        if(value_path == "last-path-change"):
                            self.last_path_change = value
                            self.last_path_change.value_namespace = name_space
                            self.last_path_change.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-bandwidth"):
                            self.lsp_bandwidth = value
                            self.lsp_bandwidth.value_namespace = name_space
                            self.lsp_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-bandwidth-type"):
                            self.lsp_bandwidth_type = value
                            self.lsp_bandwidth_type.value_namespace = name_space
                            self.lsp_bandwidth_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-hold-priority"):
                            self.lsp_hold_priority = value
                            self.lsp_hold_priority.value_namespace = name_space
                            self.lsp_hold_priority.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-setup-priority"):
                            self.lsp_setup_priority = value
                            self.lsp_setup_priority.value_namespace = name_space
                            self.lsp_setup_priority.value_namespace_prefix = name_space_prefix
                        if(value_path == "persistent-bytes"):
                            self.persistent_bytes = value
                            self.persistent_bytes.value_namespace = name_space
                            self.persistent_bytes.value_namespace_prefix = name_space_prefix
                        if(value_path == "persistent-packets"):
                            self.persistent_packets = value
                            self.persistent_packets.value_namespace = name_space
                            self.persistent_packets.value_namespace_prefix = name_space_prefix
                        if(value_path == "reoptimize-reason"):
                            self.reoptimize_reason = value
                            self.reoptimize_reason.value_namespace = name_space
                            self.reoptimize_reason.value_namespace_prefix = name_space_prefix
                        if(value_path == "reoptimize-trigger"):
                            self.reoptimize_trigger = value
                            self.reoptimize_trigger.value_namespace = name_space
                            self.reoptimize_trigger.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-down"):
                            self.s2_ls_down = value
                            self.s2_ls_down.value_namespace = name_space
                            self.s2_ls_down.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-proceeding"):
                            self.s2_ls_proceeding = value
                            self.s2_ls_proceeding.value_namespace = name_space
                            self.s2_ls_proceeding.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-up"):
                            self.s2_ls_up = value
                            self.s2_ls_up.value_namespace = name_space
                            self.s2_ls_up.value_namespace_prefix = name_space_prefix
                        if(value_path == "signaled-name"):
                            self.signaled_name = value
                            self.signaled_name.value_namespace = name_space
                            self.signaled_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "timer-left"):
                            self.timer_left = value
                            self.timer_left.value_namespace = name_space
                            self.timer_left.value_namespace_prefix = name_space_prefix
                        if(value_path == "type"):
                            self.type = value
                            self.type.value_namespace = name_space
                            self.type.value_namespace_prefix = name_space_prefix
                        if(value_path == "uptime"):
                            self.uptime = value
                            self.uptime.value_namespace = name_space
                            self.uptime.value_namespace_prefix = name_space_prefix


                class CleanedLsp(Entity):
                    """
                    Cleaned LSP
                    
                    .. attribute:: dste_class_index
                    
                    	Matching DSTE class index
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: dste_class_match
                    
                    	Do the class type and priority match a DSTE class
                    	**type**\:  bool
                    
                    .. attribute:: frr_active_reason
                    
                    	P2MP LSP FRR active reason
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: is_frr_failed
                    
                    	P2MP LSP has FRR Failed
                    	**type**\:  bool
                    
                    .. attribute:: is_interface
                    
                    	True for tunnel head
                    	**type**\:  bool
                    
                    .. attribute:: is_passive
                    
                    	True for passive tunnel
                    	**type**\:  bool
                    
                    .. attribute:: last_path_change
                    
                    	Time in seconds since the last path change
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: lsp_bandwidth
                    
                    	P2MP LSP Bandwidth
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: lsp_bandwidth_type
                    
                    	The LSP bandwidth type
                    	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                    
                    .. attribute:: lsp_fec
                    
                    	FEC for the LSP
                    	**type**\:   :py:class:`LspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.LspFec>`
                    
                    .. attribute:: lsp_hold_priority
                    
                    	LSP hold priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: lsp_setup_priority
                    
                    	LSP setup priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: persistent_bytes
                    
                    	Persistent forwarding statistics for number of bytes. Clear counters will not reset the counter
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**units**\: byte
                    
                    .. attribute:: persistent_packets
                    
                    	Persistent forwarding statistics for Number of packets. Clear counters will not reset the counter
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: reoptimize_reason
                    
                    	Reason for re\-optimization
                    	**type**\:   :py:class:`MplsTeReoptDecisionReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReoptDecisionReason>`
                    
                    .. attribute:: reoptimize_trigger
                    
                    	Re\-optimize trigger
                    	**type**\:   :py:class:`MteReoptTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MteReoptTrigger>`
                    
                    .. attribute:: s2_ls_down
                    
                    	Number of down S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2_ls_proceeding
                    
                    	Number of proceeding S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2_ls_up
                    
                    	Number of connected S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2l
                    
                    	array of S2L structures
                    	**type**\: list of    :py:class:`S2L <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L>`
                    
                    .. attribute:: signaled_name
                    
                    	Signaled Name
                    	**type**\:  str
                    
                    .. attribute:: timer_left
                    
                    	Time in seconds left to take next action if any
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: type
                    
                    	The type of this LSP
                    	**type**\:   :py:class:`MplsTeLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLsp>`
                    
                    .. attribute:: uptime
                    
                    	Time in seconds since the tunnel was up
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp, self).__init__()

                        self.yang_name = "cleaned-lsp"
                        self.yang_parent_name = "tunnel-head"

                        self.dste_class_index = YLeaf(YType.uint8, "dste-class-index")

                        self.dste_class_match = YLeaf(YType.boolean, "dste-class-match")

                        self.frr_active_reason = YLeaf(YType.uint32, "frr-active-reason")

                        self.is_frr_failed = YLeaf(YType.boolean, "is-frr-failed")

                        self.is_interface = YLeaf(YType.boolean, "is-interface")

                        self.is_passive = YLeaf(YType.boolean, "is-passive")

                        self.last_path_change = YLeaf(YType.uint32, "last-path-change")

                        self.lsp_bandwidth = YLeaf(YType.uint32, "lsp-bandwidth")

                        self.lsp_bandwidth_type = YLeaf(YType.enumeration, "lsp-bandwidth-type")

                        self.lsp_hold_priority = YLeaf(YType.uint8, "lsp-hold-priority")

                        self.lsp_setup_priority = YLeaf(YType.uint8, "lsp-setup-priority")

                        self.persistent_bytes = YLeaf(YType.uint64, "persistent-bytes")

                        self.persistent_packets = YLeaf(YType.uint64, "persistent-packets")

                        self.reoptimize_reason = YLeaf(YType.enumeration, "reoptimize-reason")

                        self.reoptimize_trigger = YLeaf(YType.enumeration, "reoptimize-trigger")

                        self.s2_ls_down = YLeaf(YType.uint32, "s2-ls-down")

                        self.s2_ls_proceeding = YLeaf(YType.uint32, "s2-ls-proceeding")

                        self.s2_ls_up = YLeaf(YType.uint32, "s2-ls-up")

                        self.signaled_name = YLeaf(YType.str, "signaled-name")

                        self.timer_left = YLeaf(YType.uint32, "timer-left")

                        self.type = YLeaf(YType.enumeration, "type")

                        self.uptime = YLeaf(YType.uint32, "uptime")

                        self.lsp_fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.LspFec()
                        self.lsp_fec.parent = self
                        self._children_name_map["lsp_fec"] = "lsp-fec"
                        self._children_yang_names.add("lsp-fec")

                        self.s2l = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("dste_class_index",
                                        "dste_class_match",
                                        "frr_active_reason",
                                        "is_frr_failed",
                                        "is_interface",
                                        "is_passive",
                                        "last_path_change",
                                        "lsp_bandwidth",
                                        "lsp_bandwidth_type",
                                        "lsp_hold_priority",
                                        "lsp_setup_priority",
                                        "persistent_bytes",
                                        "persistent_packets",
                                        "reoptimize_reason",
                                        "reoptimize_trigger",
                                        "s2_ls_down",
                                        "s2_ls_proceeding",
                                        "s2_ls_up",
                                        "signaled_name",
                                        "timer_left",
                                        "type",
                                        "uptime") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp, self).__setattr__(name, value)


                    class LspFec(Entity):
                        """
                        FEC for the LSP
                        
                        .. attribute:: fec_destination_info
                        
                        	Destination or P2MP ID
                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.LspFec.FecDestinationInfo>`
                        
                        .. attribute:: fec_extended_tunnel_id
                        
                        	Extended tunnel ID
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: fec_lsp_id
                        
                        	LSP ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: fec_source
                        
                        	Tunnel source address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: fec_tunnel_id
                        
                        	Tunnel ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: fec_vrf
                        
                        	VRF; currently only for GMPLS tunnels
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.LspFec, self).__init__()

                            self.yang_name = "lsp-fec"
                            self.yang_parent_name = "cleaned-lsp"

                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                            self.fec_source = YLeaf(YType.str, "fec-source")

                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                            self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.LspFec.FecDestinationInfo()
                            self.fec_destination_info.parent = self
                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                            self._children_yang_names.add("fec-destination-info")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("fec_extended_tunnel_id",
                                            "fec_lsp_id",
                                            "fec_source",
                                            "fec_tunnel_id",
                                            "fec_vrf") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.LspFec, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.LspFec, self).__setattr__(name, value)


                        class FecDestinationInfo(Entity):
                            """
                            Destination or P2MP ID
                            
                            .. attribute:: fec_ctype
                            
                            	FEC CType
                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            .. attribute:: fec_destination_p2mp_id
                            
                            	P2MP ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: p2p_lsp_destination
                            
                            	P2P LSP destination
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.LspFec.FecDestinationInfo, self).__init__()

                                self.yang_name = "fec-destination-info"
                                self.yang_parent_name = "lsp-fec"

                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fec_ctype",
                                                "fec_destination_p2mp_id",
                                                "p2p_lsp_destination") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.LspFec.FecDestinationInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.LspFec.FecDestinationInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.fec_ctype.is_set or
                                    self.fec_destination_p2mp_id.is_set or
                                    self.p2p_lsp_destination.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fec_ctype.yfilter != YFilter.not_set or
                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fec-destination-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fec-ctype"):
                                    self.fec_ctype = value
                                    self.fec_ctype.value_namespace = name_space
                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-destination-p2mp-id"):
                                    self.fec_destination_p2mp_id = value
                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "p2p-lsp-destination"):
                                    self.p2p_lsp_destination = value
                                    self.p2p_lsp_destination.value_namespace = name_space
                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.fec_extended_tunnel_id.is_set or
                                self.fec_lsp_id.is_set or
                                self.fec_source.is_set or
                                self.fec_tunnel_id.is_set or
                                self.fec_vrf.is_set or
                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                self.fec_source.yfilter != YFilter.not_set or
                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                self.fec_vrf.yfilter != YFilter.not_set or
                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "lsp-fec" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "fec-destination-info"):
                                if (self.fec_destination_info is None):
                                    self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.LspFec.FecDestinationInfo()
                                    self.fec_destination_info.parent = self
                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                return self.fec_destination_info

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "fec-extended-tunnel-id"):
                                self.fec_extended_tunnel_id = value
                                self.fec_extended_tunnel_id.value_namespace = name_space
                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-lsp-id"):
                                self.fec_lsp_id = value
                                self.fec_lsp_id.value_namespace = name_space
                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-source"):
                                self.fec_source = value
                                self.fec_source.value_namespace = name_space
                                self.fec_source.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-tunnel-id"):
                                self.fec_tunnel_id = value
                                self.fec_tunnel_id.value_namespace = name_space
                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-vrf"):
                                self.fec_vrf = value
                                self.fec_vrf.value_namespace = name_space
                                self.fec_vrf.value_namespace_prefix = name_space_prefix


                    class S2L(Entity):
                        """
                        array of S2L structures
                        
                        .. attribute:: abr_auto_discovered
                        
                        	Next ABR auto discovered
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: active_path_option
                        
                        	The path option used to find the path for this S2L
                        	**type**\:   :py:class:`ActivePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption>`
                        
                        .. attribute:: association
                        
                        	Association Object
                        	**type**\:   :py:class:`Association <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.Association>`
                        
                        .. attribute:: backup_tunnel_interface
                        
                        	Interface handle of the backup tunnel
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        .. attribute:: diversity_info
                        
                        	S2L Diversity Information
                        	**type**\:   :py:class:`DiversityInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.DiversityInfo>`
                        
                        .. attribute:: downstream_router_id
                        
                        	Downstream router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: egress_interface
                        
                        	Egress Interface
                        	**type**\:  str
                        
                        .. attribute:: egress_interface_brief
                        
                        	Egress Interface in brief format
                        	**type**\:  str
                        
                        .. attribute:: egress_interface_state
                        
                        	State of Outgoing Interface
                        	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        .. attribute:: expanded_ero_affinity_bits
                        
                        	The Outgoing ERO's affinity bits (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_affinity_mask
                        
                        	The Outgoing ERO's affinity mask (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_area_id
                        
                        	Indicates the protocol and area used to find Outgoing ERO
                        	**type**\:  str
                        
                        .. attribute:: expanded_ero_metric
                        
                        	The metric value of the expanded path
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: expanded_ero_metric_type
                        
                        	The Outgoing ERO's selection metric
                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                        
                        .. attribute:: flex_info
                        
                        	FlexLSP S2L Information
                        	**type**\:   :py:class:`FlexInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.FlexInfo>`
                        
                        .. attribute:: frr_out_tunnel_interface
                        
                        	FRR out tunnel intface
                        	**type**\:  str
                        
                        .. attribute:: fspec
                        
                        	The F spec info
                        	**type**\:   :py:class:`Fspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.Fspec>`
                        
                        .. attribute:: generic_fspec
                        
                        	Generic FSpec
                        	**type**\:   :py:class:`GenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GenericFspec>`
                        
                        .. attribute:: generic_tspec
                        
                        	Generic TSpec
                        	**type**\:   :py:class:`GenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GenericTspec>`
                        
                        .. attribute:: gmpls_labels
                        
                        	GMPLS labels
                        	**type**\:   :py:class:`GmplsLabels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels>`
                        
                        .. attribute:: head_end_bfd_info
                        
                        	The Head\-end BFD info
                        	**type**\:   :py:class:`HeadEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.HeadEndBfdInfo>`
                        
                        .. attribute:: in_ero
                        
                        	Incoming ERO for this S2L
                        	**type**\: list of    :py:class:`InEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InEro>`
                        
                        .. attribute:: in_xro
                        
                        	Incoming XRO for this S2L
                        	**type**\:   :py:class:`InXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro>`
                        
                        .. attribute:: incoming_address
                        
                        	Incoming interface address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: incoming_address_generic
                        
                        	Incoming interface address
                        	**type**\:   :py:class:`IncomingAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.IncomingAddressGeneric>`
                        
                        .. attribute:: ingress_interface
                        
                        	Ingress Interface
                        	**type**\:  str
                        
                        .. attribute:: ingress_interface_brief
                        
                        	Ingress Interface in brief format
                        	**type**\:  str
                        
                        .. attribute:: ingress_interface_state
                        
                        	State of Incoming Interface
                        	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                        
                        .. attribute:: is_bandwidth_protect
                        
                        	BW Protection Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_expanded_ero
                        
                        	TRUE if this LSR expanded a loose path
                        	**type**\:  bool
                        
                        .. attribute:: is_frr_enabled
                        
                        	FRR Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_node_protected
                        
                        	Node Protection Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_optical
                        
                        	Is Optical
                        	**type**\:  bool
                        
                        .. attribute:: local_router_id
                        
                        	Local router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: lsp_wrap_info
                        
                        	Lsp Wrap  Related information
                        	**type**\:   :py:class:`LspWrapInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.LspWrapInfo>`
                        
                        .. attribute:: next_hop_address
                        
                        	Next hop address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: next_hop_address_generic
                        
                        	Next hop address
                        	**type**\:   :py:class:`NextHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.NextHopAddressGeneric>`
                        
                        .. attribute:: node_hop_count
                        
                        	Hop count
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        .. attribute:: otn_s2l
                        
                        	Otn S2L Information
                        	**type**\:   :py:class:`OtnS2L <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L>`
                        
                        .. attribute:: out_ero
                        
                        	Outgoing ERO for this S2L
                        	**type**\: list of    :py:class:`OutEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutEro>`
                        
                        .. attribute:: out_xro
                        
                        	Outgoing XRO for this S2L
                        	**type**\:   :py:class:`OutXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro>`
                        
                        .. attribute:: outbound_frr_state
                        
                        	Indicates outbound FRR state
                        	**type**\:   :py:class:`MplsTeFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrState>`
                        
                        .. attribute:: path_affinity_array
                        
                        	Tunnel's Path hops with affinity
                        	**type**\: list of    :py:class:`PathAffinityArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathAffinityArray>`
                        
                        .. attribute:: path_reeval_query_mid
                        
                        	Loose path reevaluation query received at mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: path_rro
                        
                        	Path RRO for this S2L
                        	**type**\: list of    :py:class:`PathRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro>`
                        
                        .. attribute:: path_rro_enabled
                        
                        	Path RRO Enabled or Disabled
                        	**type**\:  bool
                        
                        .. attribute:: path_using_strict_spf
                        
                        	Path is using Strict SPF
                        	**type**\:  bool
                        
                        .. attribute:: pcalc_area
                        
                        	IGP\-area in which the S2L path was calculated
                        	**type**\:  str
                        
                        .. attribute:: previous_hop_address
                        
                        	Previous hop address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: previous_hop_address_generic
                        
                        	Previous hop address
                        	**type**\:   :py:class:`PreviousHopAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PreviousHopAddressGeneric>`
                        
                        .. attribute:: protection
                        
                        	Protection Object
                        	**type**\:   :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.Protection>`
                        
                        .. attribute:: resv_rro
                        
                        	Resv RRO for this S2L
                        	**type**\: list of    :py:class:`ResvRro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro>`
                        
                        .. attribute:: reverse_ero_in
                        
                        	 Reverse Incoming ERO for this S2L
                        	**type**\: list of    :py:class:`ReverseEroIn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ReverseEroIn>`
                        
                        .. attribute:: reverse_lsp_connected
                        
                        	Reverse Associated Bidir LSP Connected
                        	**type**\:  bool
                        
                        .. attribute:: reverse_lsp_fec
                        
                        	Reverse Associated Bidir LSP FEC
                        	**type**\:   :py:class:`ReverseLspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ReverseLspFec>`
                        
                        .. attribute:: reverse_lsp_name
                        
                        	Reverse Associated Bidir LSP Name
                        	**type**\:  str
                        
                        .. attribute:: reverse_lsp_present
                        
                        	Reverse Associated Bidir LSP Present
                        	**type**\:  bool
                        
                        .. attribute:: reverse_tspec
                        
                        	The Reverse T spec info
                        	**type**\:   :py:class:`ReverseTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ReverseTspec>`
                        
                        .. attribute:: reverse_weight
                        
                        	The reverse path weight
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        .. attribute:: role
                        
                        	Role of S2L
                        	**type**\:   :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        .. attribute:: s2l_convergence
                        
                        	TE LSP convergence related information
                        	**type**\:   :py:class:`S2LConvergence <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.S2LConvergence>`
                        
                        .. attribute:: s2l_fec
                        
                        	FEC for the S2L
                        	**type**\:   :py:class:`S2LFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.S2LFec>`
                        
                        .. attribute:: s2l_local_label
                        
                        	Local label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: s2l_out_label
                        
                        	Outgoing label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: s2l_reverse_ero_obj_present
                        
                        	 S2l Reverse ERO Object Present
                        	**type**\:  bool
                        
                        .. attribute:: s2l_reverse_lsp_sub_obj
                        
                        	Reverse LSP Sub Objects
                        	**type**\: list of    :py:class:`S2LReverseLspSubObj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.S2LReverseLspSubObj>`
                        
                        .. attribute:: s2l_reverse_tspec_obj_present
                        
                        	 S2L Reverse TSpec Object Present
                        	**type**\:  bool
                        
                        .. attribute:: s2l_segment_routing_path
                        
                        	Segment\-Routing S2L path info
                        	**type**\: list of    :py:class:`S2LSegmentRoutingPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.S2LSegmentRoutingPath>`
                        
                        .. attribute:: shared_risk_link_group
                        
                        	The S2L's excluded srlg groups
                        	**type**\: list of    :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.SharedRiskLinkGroup>`
                        
                        .. attribute:: signalling_status
                        
                        	Signaling status
                        	**type**\:   :py:class:`MplsTeTunnelsSignalingStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelsSignalingStatus>`
                        
                        .. attribute:: soft_preemption
                        
                        	The soft preemption info for this LSP
                        	**type**\:   :py:class:`SoftPreemption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.SoftPreemption>`
                        
                        .. attribute:: srlg_collection
                        
                        	SRLG\-collection data
                        	**type**\:   :py:class:`SrlgCollection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.SrlgCollection>`
                        
                        .. attribute:: tail_end_bfd_info
                        
                        	The Tail\-end BFD info
                        	**type**\:   :py:class:`TailEndBfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.TailEndBfdInfo>`
                        
                        .. attribute:: time_since_last_preferred_path_exists_send_mid
                        
                        	Time since last preferred path exists msg send from mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: time_since_last_preferred_tree_exists_send_mid
                        
                        	Time since last preferred tree exists msg send from mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: time_since_last_query_received_mid
                        
                        	Time since last reevaluation query received at mid\-point
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tspec
                        
                        	The T spec info
                        	**type**\:   :py:class:`Tspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.Tspec>`
                        
                        .. attribute:: upstream_router_id
                        
                        	Upstream router id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: uptime
                        
                        	Time in seconds since the tunnel was up
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: weight
                        
                        	The path's weight
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L, self).__init__()

                            self.yang_name = "s2l"
                            self.yang_parent_name = "cleaned-lsp"

                            self.abr_auto_discovered = YLeaf(YType.str, "abr-auto-discovered")

                            self.backup_tunnel_interface = YLeaf(YType.str, "backup-tunnel-interface")

                            self.downstream_router_id = YLeaf(YType.str, "downstream-router-id")

                            self.egress_interface = YLeaf(YType.str, "egress-interface")

                            self.egress_interface_brief = YLeaf(YType.str, "egress-interface-brief")

                            self.egress_interface_state = YLeaf(YType.enumeration, "egress-interface-state")

                            self.expanded_ero_affinity_bits = YLeaf(YType.uint32, "expanded-ero-affinity-bits")

                            self.expanded_ero_affinity_mask = YLeaf(YType.uint32, "expanded-ero-affinity-mask")

                            self.expanded_ero_area_id = YLeaf(YType.str, "expanded-ero-area-id")

                            self.expanded_ero_metric = YLeaf(YType.uint32, "expanded-ero-metric")

                            self.expanded_ero_metric_type = YLeaf(YType.enumeration, "expanded-ero-metric-type")

                            self.frr_out_tunnel_interface = YLeaf(YType.str, "frr-out-tunnel-interface")

                            self.incoming_address = YLeaf(YType.str, "incoming-address")

                            self.ingress_interface = YLeaf(YType.str, "ingress-interface")

                            self.ingress_interface_brief = YLeaf(YType.str, "ingress-interface-brief")

                            self.ingress_interface_state = YLeaf(YType.enumeration, "ingress-interface-state")

                            self.is_bandwidth_protect = YLeaf(YType.boolean, "is-bandwidth-protect")

                            self.is_expanded_ero = YLeaf(YType.boolean, "is-expanded-ero")

                            self.is_frr_enabled = YLeaf(YType.boolean, "is-frr-enabled")

                            self.is_node_protected = YLeaf(YType.boolean, "is-node-protected")

                            self.is_optical = YLeaf(YType.boolean, "is-optical")

                            self.local_router_id = YLeaf(YType.str, "local-router-id")

                            self.next_hop_address = YLeaf(YType.str, "next-hop-address")

                            self.node_hop_count = YLeaf(YType.uint8, "node-hop-count")

                            self.outbound_frr_state = YLeaf(YType.enumeration, "outbound-frr-state")

                            self.path_reeval_query_mid = YLeaf(YType.uint32, "path-reeval-query-mid")

                            self.path_rro_enabled = YLeaf(YType.boolean, "path-rro-enabled")

                            self.path_using_strict_spf = YLeaf(YType.boolean, "path-using-strict-spf")

                            self.pcalc_area = YLeaf(YType.str, "pcalc-area")

                            self.previous_hop_address = YLeaf(YType.str, "previous-hop-address")

                            self.reverse_lsp_connected = YLeaf(YType.boolean, "reverse-lsp-connected")

                            self.reverse_lsp_name = YLeaf(YType.str, "reverse-lsp-name")

                            self.reverse_lsp_present = YLeaf(YType.boolean, "reverse-lsp-present")

                            self.reverse_weight = YLeaf(YType.uint64, "reverse-weight")

                            self.role = YLeaf(YType.enumeration, "role")

                            self.s2l_local_label = YLeaf(YType.uint32, "s2l-local-label")

                            self.s2l_out_label = YLeaf(YType.uint32, "s2l-out-label")

                            self.s2l_reverse_ero_obj_present = YLeaf(YType.boolean, "s2l-reverse-ero-obj-present")

                            self.s2l_reverse_tspec_obj_present = YLeaf(YType.boolean, "s2l-reverse-tspec-obj-present")

                            self.signalling_status = YLeaf(YType.enumeration, "signalling-status")

                            self.time_since_last_preferred_path_exists_send_mid = YLeaf(YType.uint32, "time-since-last-preferred-path-exists-send-mid")

                            self.time_since_last_preferred_tree_exists_send_mid = YLeaf(YType.uint32, "time-since-last-preferred-tree-exists-send-mid")

                            self.time_since_last_query_received_mid = YLeaf(YType.uint32, "time-since-last-query-received-mid")

                            self.upstream_router_id = YLeaf(YType.str, "upstream-router-id")

                            self.uptime = YLeaf(YType.uint32, "uptime")

                            self.weight = YLeaf(YType.uint64, "weight")

                            self.active_path_option = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption()
                            self.active_path_option.parent = self
                            self._children_name_map["active_path_option"] = "active-path-option"
                            self._children_yang_names.add("active-path-option")

                            self.association = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.Association()
                            self.association.parent = self
                            self._children_name_map["association"] = "association"
                            self._children_yang_names.add("association")

                            self.diversity_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.DiversityInfo()
                            self.diversity_info.parent = self
                            self._children_name_map["diversity_info"] = "diversity-info"
                            self._children_yang_names.add("diversity-info")

                            self.flex_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.FlexInfo()
                            self.flex_info.parent = self
                            self._children_name_map["flex_info"] = "flex-info"
                            self._children_yang_names.add("flex-info")

                            self.fspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.Fspec()
                            self.fspec.parent = self
                            self._children_name_map["fspec"] = "fspec"
                            self._children_yang_names.add("fspec")

                            self.generic_fspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GenericFspec()
                            self.generic_fspec.parent = self
                            self._children_name_map["generic_fspec"] = "generic-fspec"
                            self._children_yang_names.add("generic-fspec")

                            self.generic_tspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GenericTspec()
                            self.generic_tspec.parent = self
                            self._children_name_map["generic_tspec"] = "generic-tspec"
                            self._children_yang_names.add("generic-tspec")

                            self.gmpls_labels = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels()
                            self.gmpls_labels.parent = self
                            self._children_name_map["gmpls_labels"] = "gmpls-labels"
                            self._children_yang_names.add("gmpls-labels")

                            self.head_end_bfd_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.HeadEndBfdInfo()
                            self.head_end_bfd_info.parent = self
                            self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"
                            self._children_yang_names.add("head-end-bfd-info")

                            self.in_xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro()
                            self.in_xro.parent = self
                            self._children_name_map["in_xro"] = "in-xro"
                            self._children_yang_names.add("in-xro")

                            self.incoming_address_generic = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.IncomingAddressGeneric()
                            self.incoming_address_generic.parent = self
                            self._children_name_map["incoming_address_generic"] = "incoming-address-generic"
                            self._children_yang_names.add("incoming-address-generic")

                            self.lsp_wrap_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.LspWrapInfo()
                            self.lsp_wrap_info.parent = self
                            self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"
                            self._children_yang_names.add("lsp-wrap-info")

                            self.next_hop_address_generic = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.NextHopAddressGeneric()
                            self.next_hop_address_generic.parent = self
                            self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"
                            self._children_yang_names.add("next-hop-address-generic")

                            self.otn_s2l = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L()
                            self.otn_s2l.parent = self
                            self._children_name_map["otn_s2l"] = "otn-s2l"
                            self._children_yang_names.add("otn-s2l")

                            self.out_xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro()
                            self.out_xro.parent = self
                            self._children_name_map["out_xro"] = "out-xro"
                            self._children_yang_names.add("out-xro")

                            self.previous_hop_address_generic = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PreviousHopAddressGeneric()
                            self.previous_hop_address_generic.parent = self
                            self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"
                            self._children_yang_names.add("previous-hop-address-generic")

                            self.protection = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.Protection()
                            self.protection.parent = self
                            self._children_name_map["protection"] = "protection"
                            self._children_yang_names.add("protection")

                            self.reverse_lsp_fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ReverseLspFec()
                            self.reverse_lsp_fec.parent = self
                            self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"
                            self._children_yang_names.add("reverse-lsp-fec")

                            self.reverse_tspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ReverseTspec()
                            self.reverse_tspec.parent = self
                            self._children_name_map["reverse_tspec"] = "reverse-tspec"
                            self._children_yang_names.add("reverse-tspec")

                            self.s2l_convergence = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.S2LConvergence()
                            self.s2l_convergence.parent = self
                            self._children_name_map["s2l_convergence"] = "s2l-convergence"
                            self._children_yang_names.add("s2l-convergence")

                            self.s2l_fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.S2LFec()
                            self.s2l_fec.parent = self
                            self._children_name_map["s2l_fec"] = "s2l-fec"
                            self._children_yang_names.add("s2l-fec")

                            self.soft_preemption = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.SoftPreemption()
                            self.soft_preemption.parent = self
                            self._children_name_map["soft_preemption"] = "soft-preemption"
                            self._children_yang_names.add("soft-preemption")

                            self.srlg_collection = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.SrlgCollection()
                            self.srlg_collection.parent = self
                            self._children_name_map["srlg_collection"] = "srlg-collection"
                            self._children_yang_names.add("srlg-collection")

                            self.tail_end_bfd_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.TailEndBfdInfo()
                            self.tail_end_bfd_info.parent = self
                            self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"
                            self._children_yang_names.add("tail-end-bfd-info")

                            self.tspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.Tspec()
                            self.tspec.parent = self
                            self._children_name_map["tspec"] = "tspec"
                            self._children_yang_names.add("tspec")

                            self.in_ero = YList(self)
                            self.out_ero = YList(self)
                            self.path_affinity_array = YList(self)
                            self.path_rro = YList(self)
                            self.resv_rro = YList(self)
                            self.reverse_ero_in = YList(self)
                            self.s2l_reverse_lsp_sub_obj = YList(self)
                            self.s2l_segment_routing_path = YList(self)
                            self.shared_risk_link_group = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("abr_auto_discovered",
                                            "backup_tunnel_interface",
                                            "downstream_router_id",
                                            "egress_interface",
                                            "egress_interface_brief",
                                            "egress_interface_state",
                                            "expanded_ero_affinity_bits",
                                            "expanded_ero_affinity_mask",
                                            "expanded_ero_area_id",
                                            "expanded_ero_metric",
                                            "expanded_ero_metric_type",
                                            "frr_out_tunnel_interface",
                                            "incoming_address",
                                            "ingress_interface",
                                            "ingress_interface_brief",
                                            "ingress_interface_state",
                                            "is_bandwidth_protect",
                                            "is_expanded_ero",
                                            "is_frr_enabled",
                                            "is_node_protected",
                                            "is_optical",
                                            "local_router_id",
                                            "next_hop_address",
                                            "node_hop_count",
                                            "outbound_frr_state",
                                            "path_reeval_query_mid",
                                            "path_rro_enabled",
                                            "path_using_strict_spf",
                                            "pcalc_area",
                                            "previous_hop_address",
                                            "reverse_lsp_connected",
                                            "reverse_lsp_name",
                                            "reverse_lsp_present",
                                            "reverse_weight",
                                            "role",
                                            "s2l_local_label",
                                            "s2l_out_label",
                                            "s2l_reverse_ero_obj_present",
                                            "s2l_reverse_tspec_obj_present",
                                            "signalling_status",
                                            "time_since_last_preferred_path_exists_send_mid",
                                            "time_since_last_preferred_tree_exists_send_mid",
                                            "time_since_last_query_received_mid",
                                            "upstream_router_id",
                                            "uptime",
                                            "weight") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L, self).__setattr__(name, value)


                        class S2LFec(Entity):
                            """
                            FEC for the S2L
                            
                            .. attribute:: s2l_fec_ctype
                            
                            	Session identifier (ctype)
                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            .. attribute:: s2l_fec_dest
                            
                            	sub\-LSP destination address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_lsp_id
                            
                            	LSP ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_p2mp_id
                            
                            	P2MP ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: s2l_fec_source
                            
                            	LSP source address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_subgroup_id
                            
                            	sub\-LSP subgroup ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_subgroup_originator
                            
                            	Subgroup Originator
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.S2LFec, self).__init__()

                                self.yang_name = "s2l-fec"
                                self.yang_parent_name = "s2l"

                                self.s2l_fec_ctype = YLeaf(YType.enumeration, "s2l-fec-ctype")

                                self.s2l_fec_dest = YLeaf(YType.str, "s2l-fec-dest")

                                self.s2l_fec_extended_tunnel_id = YLeaf(YType.str, "s2l-fec-extended-tunnel-id")

                                self.s2l_fec_lsp_id = YLeaf(YType.uint16, "s2l-fec-lsp-id")

                                self.s2l_fec_p2mp_id = YLeaf(YType.uint32, "s2l-fec-p2mp-id")

                                self.s2l_fec_source = YLeaf(YType.str, "s2l-fec-source")

                                self.s2l_fec_subgroup_id = YLeaf(YType.uint16, "s2l-fec-subgroup-id")

                                self.s2l_fec_subgroup_originator = YLeaf(YType.str, "s2l-fec-subgroup-originator")

                                self.s2l_fec_tunnel_id = YLeaf(YType.uint16, "s2l-fec-tunnel-id")

                                self.s2l_fec_vrf = YLeaf(YType.str, "s2l-fec-vrf")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("s2l_fec_ctype",
                                                "s2l_fec_dest",
                                                "s2l_fec_extended_tunnel_id",
                                                "s2l_fec_lsp_id",
                                                "s2l_fec_p2mp_id",
                                                "s2l_fec_source",
                                                "s2l_fec_subgroup_id",
                                                "s2l_fec_subgroup_originator",
                                                "s2l_fec_tunnel_id",
                                                "s2l_fec_vrf") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.S2LFec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.S2LFec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.s2l_fec_ctype.is_set or
                                    self.s2l_fec_dest.is_set or
                                    self.s2l_fec_extended_tunnel_id.is_set or
                                    self.s2l_fec_lsp_id.is_set or
                                    self.s2l_fec_p2mp_id.is_set or
                                    self.s2l_fec_source.is_set or
                                    self.s2l_fec_subgroup_id.is_set or
                                    self.s2l_fec_subgroup_originator.is_set or
                                    self.s2l_fec_tunnel_id.is_set or
                                    self.s2l_fec_vrf.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.s2l_fec_ctype.yfilter != YFilter.not_set or
                                    self.s2l_fec_dest.yfilter != YFilter.not_set or
                                    self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_lsp_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_p2mp_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_source.yfilter != YFilter.not_set or
                                    self.s2l_fec_subgroup_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set or
                                    self.s2l_fec_tunnel_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_vrf.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-fec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.s2l_fec_ctype.is_set or self.s2l_fec_ctype.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_ctype.get_name_leafdata())
                                if (self.s2l_fec_dest.is_set or self.s2l_fec_dest.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_dest.get_name_leafdata())
                                if (self.s2l_fec_extended_tunnel_id.is_set or self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_extended_tunnel_id.get_name_leafdata())
                                if (self.s2l_fec_lsp_id.is_set or self.s2l_fec_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_lsp_id.get_name_leafdata())
                                if (self.s2l_fec_p2mp_id.is_set or self.s2l_fec_p2mp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_p2mp_id.get_name_leafdata())
                                if (self.s2l_fec_source.is_set or self.s2l_fec_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_source.get_name_leafdata())
                                if (self.s2l_fec_subgroup_id.is_set or self.s2l_fec_subgroup_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_subgroup_id.get_name_leafdata())
                                if (self.s2l_fec_subgroup_originator.is_set or self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_subgroup_originator.get_name_leafdata())
                                if (self.s2l_fec_tunnel_id.is_set or self.s2l_fec_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_tunnel_id.get_name_leafdata())
                                if (self.s2l_fec_vrf.is_set or self.s2l_fec_vrf.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_vrf.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "s2l-fec-ctype" or name == "s2l-fec-dest" or name == "s2l-fec-extended-tunnel-id" or name == "s2l-fec-lsp-id" or name == "s2l-fec-p2mp-id" or name == "s2l-fec-source" or name == "s2l-fec-subgroup-id" or name == "s2l-fec-subgroup-originator" or name == "s2l-fec-tunnel-id" or name == "s2l-fec-vrf"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "s2l-fec-ctype"):
                                    self.s2l_fec_ctype = value
                                    self.s2l_fec_ctype.value_namespace = name_space
                                    self.s2l_fec_ctype.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-dest"):
                                    self.s2l_fec_dest = value
                                    self.s2l_fec_dest.value_namespace = name_space
                                    self.s2l_fec_dest.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-extended-tunnel-id"):
                                    self.s2l_fec_extended_tunnel_id = value
                                    self.s2l_fec_extended_tunnel_id.value_namespace = name_space
                                    self.s2l_fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-lsp-id"):
                                    self.s2l_fec_lsp_id = value
                                    self.s2l_fec_lsp_id.value_namespace = name_space
                                    self.s2l_fec_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-p2mp-id"):
                                    self.s2l_fec_p2mp_id = value
                                    self.s2l_fec_p2mp_id.value_namespace = name_space
                                    self.s2l_fec_p2mp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-source"):
                                    self.s2l_fec_source = value
                                    self.s2l_fec_source.value_namespace = name_space
                                    self.s2l_fec_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-subgroup-id"):
                                    self.s2l_fec_subgroup_id = value
                                    self.s2l_fec_subgroup_id.value_namespace = name_space
                                    self.s2l_fec_subgroup_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-subgroup-originator"):
                                    self.s2l_fec_subgroup_originator = value
                                    self.s2l_fec_subgroup_originator.value_namespace = name_space
                                    self.s2l_fec_subgroup_originator.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-tunnel-id"):
                                    self.s2l_fec_tunnel_id = value
                                    self.s2l_fec_tunnel_id.value_namespace = name_space
                                    self.s2l_fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-vrf"):
                                    self.s2l_fec_vrf = value
                                    self.s2l_fec_vrf.value_namespace = name_space
                                    self.s2l_fec_vrf.value_namespace_prefix = name_space_prefix


                        class ActivePathOption(Entity):
                            """
                            The path option used to find the path for this
                            S2L
                            
                            .. attribute:: attribute_set
                            
                            	The path option attribute set used by this path
                            	**type**\:   :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet>`
                            
                            .. attribute:: attribute_set_found
                            
                            	TRUE if the path has found the defined attribute set
                            	**type**\:  bool
                            
                            .. attribute:: explicit_path_id
                            
                            	Explicit Path ID, this is the key to table ExplicitPaths.IdentifierTable
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: explicit_path_name
                            
                            	Explicit Path Name, this is the key to table ExplicitPaths.NameTable
                            	**type**\:  str
                            
                            .. attribute:: has_attribute_set
                            
                            	TRUE if the path has an attribute set defined
                            	**type**\:  bool
                            
                            .. attribute:: has_xro_attribute_set
                            
                            	TRUE if the path has an XRO attribute set configured
                            	**type**\:  bool
                            
                            .. attribute:: holddown_duration
                            
                            	Holddown Duration (seconds)
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            	**units**\: second
                            
                            .. attribute:: is_disabled
                            
                            	TRUE if the path option is disabled
                            	**type**\:  bool
                            
                            .. attribute:: is_helddown
                            
                            	TRUE if path is helddown
                            	**type**\:  bool
                            
                            .. attribute:: is_lockdown
                            
                            	TRUE if the path is locked down
                            	**type**\:  bool
                            
                            .. attribute:: is_segment_routing
                            
                            	TRUE if the path is Segment\-Routing
                            	**type**\:  bool
                            
                            .. attribute:: is_strict_explicit_path
                            
                            	TRUE if explicit path is strict
                            	**type**\:  bool
                            
                            .. attribute:: is_verbatim
                            
                            	TRUE if the path is verbatim
                            	**type**\:  bool
                            
                            .. attribute:: option_index
                            
                            	Path option index
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: option_index_is_valid
                            
                            	The path option index is valid
                            	**type**\:  bool
                            
                            .. attribute:: path_calculation_error
                            
                            	Path computation information
                            	**type**\: list of    :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.PathCalculationError>`
                            
                            .. attribute:: path_option_area_id
                            
                            	The path\-option area constraint
                            	**type**\:  str
                            
                            .. attribute:: path_option_name
                            
                            	Path option name
                            	**type**\:  str
                            
                            .. attribute:: path_option_type
                            
                            	Path option type
                            	**type**\:   :py:class:`MplsTePathoption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathoption>`
                            
                            .. attribute:: pce_address
                            
                            	PCE server address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: protected_by_path_option_index
                            
                            	Path option index for Protect path options
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: remerge_error
                            
                            	Path computation remerge resolve info
                            	**type**\: list of    :py:class:`RemergeError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.RemergeError>`
                            
                            .. attribute:: restored_from_path_option_index
                            
                            	Path option index for Restore path options
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: signalling_error
                            
                            	Signalling information
                            	**type**\: list of    :py:class:`SignallingError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.SignallingError>`
                            
                            .. attribute:: xro_attribute_set
                            
                            	The XRO attribute set used by this path\-option
                            	**type**\:   :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet>`
                            
                            .. attribute:: xro_attribute_set_found
                            
                            	TRUE if the path's XRO attribute set is known
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption, self).__init__()

                                self.yang_name = "active-path-option"
                                self.yang_parent_name = "s2l"

                                self.attribute_set_found = YLeaf(YType.boolean, "attribute-set-found")

                                self.explicit_path_id = YLeaf(YType.uint16, "explicit-path-id")

                                self.explicit_path_name = YLeaf(YType.str, "explicit-path-name")

                                self.has_attribute_set = YLeaf(YType.boolean, "has-attribute-set")

                                self.has_xro_attribute_set = YLeaf(YType.boolean, "has-xro-attribute-set")

                                self.holddown_duration = YLeaf(YType.uint16, "holddown-duration")

                                self.is_disabled = YLeaf(YType.boolean, "is-disabled")

                                self.is_helddown = YLeaf(YType.boolean, "is-helddown")

                                self.is_lockdown = YLeaf(YType.boolean, "is-lockdown")

                                self.is_segment_routing = YLeaf(YType.boolean, "is-segment-routing")

                                self.is_strict_explicit_path = YLeaf(YType.boolean, "is-strict-explicit-path")

                                self.is_verbatim = YLeaf(YType.boolean, "is-verbatim")

                                self.option_index = YLeaf(YType.uint32, "option-index")

                                self.option_index_is_valid = YLeaf(YType.boolean, "option-index-is-valid")

                                self.path_option_area_id = YLeaf(YType.str, "path-option-area-id")

                                self.path_option_name = YLeaf(YType.str, "path-option-name")

                                self.path_option_type = YLeaf(YType.enumeration, "path-option-type")

                                self.pce_address = YLeaf(YType.str, "pce-address")

                                self.protected_by_path_option_index = YLeaf(YType.uint32, "protected-by-path-option-index")

                                self.restored_from_path_option_index = YLeaf(YType.uint32, "restored-from-path-option-index")

                                self.xro_attribute_set_found = YLeaf(YType.boolean, "xro-attribute-set-found")

                                self.attribute_set = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet()
                                self.attribute_set.parent = self
                                self._children_name_map["attribute_set"] = "attribute-set"
                                self._children_yang_names.add("attribute-set")

                                self.xro_attribute_set = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet()
                                self.xro_attribute_set.parent = self
                                self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                                self._children_yang_names.add("xro-attribute-set")

                                self.path_calculation_error = YList(self)
                                self.remerge_error = YList(self)
                                self.signalling_error = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("attribute_set_found",
                                                "explicit_path_id",
                                                "explicit_path_name",
                                                "has_attribute_set",
                                                "has_xro_attribute_set",
                                                "holddown_duration",
                                                "is_disabled",
                                                "is_helddown",
                                                "is_lockdown",
                                                "is_segment_routing",
                                                "is_strict_explicit_path",
                                                "is_verbatim",
                                                "option_index",
                                                "option_index_is_valid",
                                                "path_option_area_id",
                                                "path_option_name",
                                                "path_option_type",
                                                "pce_address",
                                                "protected_by_path_option_index",
                                                "restored_from_path_option_index",
                                                "xro_attribute_set_found") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption, self).__setattr__(name, value)


                            class AttributeSet(Entity):
                                """
                                The path option attribute set used by this path
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion>`
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\:  str
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet, self).__init__()

                                    self.yang_name = "attribute-set"
                                    self.yang_parent_name = "active-path-option"

                                    self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                                    self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                                    self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._children_yang_names.add("attribute-set-union")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("tunnel_attribute_set_name",
                                                    "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet, self).__setattr__(name, value)


                                class AttributeSetUnion(Entity):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "attribute-set"

                                        self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                                        self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                        self._children_yang_names.add("attribute-set-aps-pp")

                                        self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                        self._children_yang_names.add("attribute-set-autobackup")

                                        self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                        self._children_yang_names.add("attribute-set-automesh")

                                        self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                        self._children_yang_names.add("attribute-set-p2mpte")

                                        self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._children_yang_names.add("attribute-set-p2p-te")

                                        self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                        self._children_yang_names.add("attribute-set-path-option")

                                        self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                        self._children_yang_names.add("attribute-set-xro")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                                    class AttributeSetPathOption(Entity):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\:  str
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                            self.generation = YLeaf(YType.uint32, "generation")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                            self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                            self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                            self._children_yang_names.add("bfd-reverse-path")

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bandwidth_type",
                                                            "configured_bandwidth",
                                                            "cost_limit",
                                                            "dste_class_type",
                                                            "exclude_list_name",
                                                            "generation",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_bfd_reverse_pat_configured",
                                                            "is_cost_limit_configured",
                                                            "is_exclude_list_name_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "path_invalidation_action",
                                                            "path_invalidation_timeout",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class BfdReversePath(Entity):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.binding_label = YLeaf(YType.uint32, "binding-label")

                                                self.path_type = YLeaf(YType.enumeration, "path-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("binding_label",
                                                                "path_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.binding_label.is_set or
                                                    self.path_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.binding_label.yfilter != YFilter.not_set or
                                                    self.path_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "bfd-reverse-path" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.binding_label.get_name_leafdata())
                                                if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.path_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "binding-label" or name == "path-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "binding-label"):
                                                    self.binding_label = value
                                                    self.binding_label.value_namespace = name_space
                                                    self.binding_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "path-type"):
                                                    self.path_type = value
                                                    self.path_type.value_namespace = name_space
                                                    self.path_type.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class VersionInfo(Entity):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\:  str
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.attribute_type = YLeaf(YType.str, "attribute-type")

                                                self.generation = YLeaf(YType.uint32, "generation")

                                                self.is_default = YLeaf(YType.boolean, "is-default")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("attribute_type",
                                                                "generation",
                                                                "is_default") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.attribute_type.is_set or
                                                    self.generation.is_set or
                                                    self.is_default.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.attribute_type.yfilter != YFilter.not_set or
                                                    self.generation.yfilter != YFilter.not_set or
                                                    self.is_default.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "version-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                                if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.generation.get_name_leafdata())
                                                if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_default.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "attribute-type"):
                                                    self.attribute_type = value
                                                    self.attribute_type.value_namespace = name_space
                                                    self.attribute_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "generation"):
                                                    self.generation = value
                                                    self.generation.value_namespace = name_space
                                                    self.generation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-default"):
                                                    self.is_default = value
                                                    self.is_default.value_namespace = name_space
                                                    self.is_default.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.bandwidth_type.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.cost_limit.is_set or
                                                self.dste_class_type.is_set or
                                                self.exclude_list_name.is_set or
                                                self.generation.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_bfd_reverse_pat_configured.is_set or
                                                self.is_cost_limit_configured.is_set or
                                                self.is_exclude_list_name_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.path_invalidation_action.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bandwidth_type.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.cost_limit.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.exclude_list_name.yfilter != YFilter.not_set or
                                                self.generation.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                                self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                                self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-path-option" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.generation.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                            if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                            if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "bfd-reverse-path"):
                                                if (self.bfd_reverse_path is None):
                                                    self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                                    self.bfd_reverse_path.parent = self
                                                    self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                                return self.bfd_reverse_path

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            if (child_yang_name == "version-info"):
                                                for c in self.version_info:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.version_info.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bandwidth-type"):
                                                self.bandwidth_type = value
                                                self.bandwidth_type.value_namespace = name_space
                                                self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "cost-limit"):
                                                self.cost_limit = value
                                                self.cost_limit.value_namespace = name_space
                                                self.cost_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exclude-list-name"):
                                                self.exclude_list_name = value
                                                self.exclude_list_name.value_namespace = name_space
                                                self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "generation"):
                                                self.generation = value
                                                self.generation.value_namespace = name_space
                                                self.generation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bfd-reverse-pat-configured"):
                                                self.is_bfd_reverse_pat_configured = value
                                                self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                                self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-cost-limit-configured"):
                                                self.is_cost_limit_configured = value
                                                self.is_cost_limit_configured.value_namespace = name_space
                                                self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-exclude-list-name-configured"):
                                                self.is_exclude_list_name_configured = value
                                                self.is_exclude_list_name_configured.value_namespace = name_space
                                                self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-action"):
                                                self.path_invalidation_action = value
                                                self.path_invalidation_action.value_namespace = name_space
                                                self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutobackup(Entity):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.signalled_name = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"
                                            self._children_yang_names.add("signalled-name")

                                            self.policy_class_entry = YList(self)
                                            self.protected_interface = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_priority",
                                                            "is_affinity_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "is_signalled_name_configured",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                                        class SignalledName(Entity):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\:  bool
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\:  str
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                                self.name = YLeaf(YType.str, "name")

                                                self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                                self.source_type = YLeaf(YType.enumeration, "source-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("is_mp_addresses",
                                                                "name",
                                                                "protected_interface_type",
                                                                "source_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.is_mp_addresses.is_set or
                                                    self.name.is_set or
                                                    self.protected_interface_type.is_set or
                                                    self.source_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.is_mp_addresses.yfilter != YFilter.not_set or
                                                    self.name.yfilter != YFilter.not_set or
                                                    self.protected_interface_type.yfilter != YFilter.not_set or
                                                    self.source_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "signalled-name" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.name.get_name_leafdata())
                                                if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                                if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.source_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "is-mp-addresses"):
                                                    self.is_mp_addresses = value
                                                    self.is_mp_addresses.value_namespace = name_space
                                                    self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                                if(value_path == "name"):
                                                    self.name = value
                                                    self.name.value_namespace = name_space
                                                    self.name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "protected-interface-type"):
                                                    self.protected_interface_type = value
                                                    self.protected_interface_type.value_namespace = name_space
                                                    self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "source-type"):
                                                    self.source_type = value
                                                    self.source_type.value_namespace = name_space
                                                    self.source_type.value_namespace_prefix = name_space_prefix


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class ProtectedInterface(Entity):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.protected_interface = YLeaf(YType.str, "protected-interface")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("protected_interface") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.protected_interface.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.protected_interface.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "protected-interface" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "protected-interface"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "protected-interface"):
                                                    self.protected_interface = value
                                                    self.protected_interface.value_namespace = name_space
                                                    self.protected_interface.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.is_signalled_name_configured.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.signalled_name is not None and self.signalled_name.has_data()))

                                        def has_operation(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.signalled_name is not None and self.signalled_name.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-autobackup" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "protected-interface"):
                                                for c in self.protected_interface:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.protected_interface.append(c)
                                                return c

                                            if (child_yang_name == "signalled-name"):
                                                if (self.signalled_name is None):
                                                    self.signalled_name = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                                    self.signalled_name.parent = self
                                                    self._children_name_map["signalled_name"] = "signalled-name"
                                                return self.signalled_name

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-signalled-name-configured"):
                                                self.is_signalled_name_configured = value
                                                self.is_signalled_name_configured.value_namespace = name_space
                                                self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutomesh(Entity):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\:  bool
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\:  bool
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                            self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                            self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.forward_class = YLeaf(YType.uint32, "forward-class")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.load_share = YLeaf(YType.uint32, "load-share")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.mesh_group_id = YList(self)
                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("auto_bandwidth_collect",
                                                            "auto_route_announce",
                                                            "bandwidth",
                                                            "configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "forward_class",
                                                            "frr_bandwidth_protection",
                                                            "frr_node_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_interface_bw_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "load_share",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority",
                                                            "soft_preemption_configured") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class MeshGroupId(Entity):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint32, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "mesh-group-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.auto_bandwidth_collect.is_set or
                                                self.auto_route_announce.is_set or
                                                self.bandwidth.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.forward_class.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.frr_node_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_interface_bw_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.load_share.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                self.soft_preemption_configured.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()))

                                        def has_operation(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                                self.auto_route_announce.yfilter != YFilter.not_set or
                                                self.bandwidth.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.forward_class.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.frr_node_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.load_share.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                self.soft_preemption_configured.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-automesh" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                            if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                            if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.forward_class.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.load_share.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                            if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "mesh-group-id"):
                                                for c in self.mesh_group_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.mesh_group_id.append(c)
                                                return c

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "auto-bandwidth-collect"):
                                                self.auto_bandwidth_collect = value
                                                self.auto_bandwidth_collect.value_namespace = name_space
                                                self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                            if(value_path == "auto-route-announce"):
                                                self.auto_route_announce = value
                                                self.auto_route_announce.value_namespace = name_space
                                                self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                            if(value_path == "bandwidth"):
                                                self.bandwidth = value
                                                self.bandwidth.value_namespace = name_space
                                                self.bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "forward-class"):
                                                self.forward_class = value
                                                self.forward_class.value_namespace = name_space
                                                self.forward_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-node-protection"):
                                                self.frr_node_protection = value
                                                self.frr_node_protection.value_namespace = name_space
                                                self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-interface-bw-configured"):
                                                self.is_interface_bw_configured = value
                                                self.is_interface_bw_configured.value_namespace = name_space
                                                self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "load-share"):
                                                self.load_share = value
                                                self.load_share.value_namespace = name_space
                                                self.load_share.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "soft-preemption-configured"):
                                                self.soft_preemption_configured = value
                                                self.soft_preemption_configured.value_namespace = name_space
                                                self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                                    class AttributeSetXro(Entity):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._children_yang_names.add("xro")


                                        class Xro(Entity):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\:  bool
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"

                                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                                self.xro_subobject = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                            class XroSubobject(Entity):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                    self.as_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"
                                                    self._children_yang_names.add("as-subobject")

                                                    self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                    self._children_yang_names.add("ipv4-subobject")

                                                    self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                    self._children_yang_names.add("ipv6-subobject")

                                                    self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._children_yang_names.add("lsp-subobject")

                                                    self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                    self._children_yang_names.add("srlg-subobject")

                                                    self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                    self._children_yang_names.add("unnumbered-subobject")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                                class Ipv4Subobject(Entity):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv4-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class Ipv6Subobject(Entity):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv6-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class UnnumberedSubobject(Entity):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("attribute",
                                                                        "exclusion_type",
                                                                        "interface_id",
                                                                        "te_router_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.interface_id.is_set or
                                                            self.te_router_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.interface_id.yfilter != YFilter.not_set or
                                                            self.te_router_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "unnumbered-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "interface-id"):
                                                            self.interface_id = value
                                                            self.interface_id.value_namespace = name_space
                                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "te-router-id"):
                                                            self.te_router_id = value
                                                            self.te_router_id.value_namespace = name_space
                                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                                class AsSubobject(Entity):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("as_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.as_number.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.as_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "as-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "as-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "as-number"):
                                                            self.as_number = value
                                                            self.as_number.value_namespace = name_space
                                                            self.as_number.value_namespace_prefix = name_space_prefix


                                                class SrlgSubobject(Entity):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("exclusion_type",
                                                                        "srlg_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.exclusion_type.is_set or
                                                            self.srlg_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.srlg_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "srlg-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "exclusion-type" or name == "srlg-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "srlg-id"):
                                                            self.srlg_id = value
                                                            self.srlg_id.value_namespace = name_space
                                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                                class LspSubobject(Entity):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                                        self.fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._children_yang_names.add("fec")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("destination_node_exception",
                                                                        "exclusion_type",
                                                                        "ignore_lsp_id",
                                                                        "penultimate_node_exception",
                                                                        "processing_node_exception") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                                    class Fec(Entity):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\:  str
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"

                                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                            self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._children_yang_names.add("fec-destination-info")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("fec_extended_tunnel_id",
                                                                            "fec_lsp_id",
                                                                            "fec_source",
                                                                            "fec_tunnel_id",
                                                                            "fec_vrf") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                                        class FecDestinationInfo(Entity):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\:  str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"

                                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("fec_ctype",
                                                                                "fec_destination_p2mp_id",
                                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.fec_ctype.is_set or
                                                                    self.fec_destination_p2mp_id.is_set or
                                                                    self.p2p_lsp_destination.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "fec-destination-info" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "fec-ctype"):
                                                                    self.fec_ctype = value
                                                                    self.fec_ctype.value_namespace = name_space
                                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "fec-destination-p2mp-id"):
                                                                    self.fec_destination_p2mp_id = value
                                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "p2p-lsp-destination"):
                                                                    self.p2p_lsp_destination = value
                                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.fec_extended_tunnel_id.is_set or
                                                                self.fec_lsp_id.is_set or
                                                                self.fec_source.is_set or
                                                                self.fec_tunnel_id.is_set or
                                                                self.fec_vrf.is_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                                self.fec_source.yfilter != YFilter.not_set or
                                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "fec" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "fec-destination-info"):
                                                                if (self.fec_destination_info is None):
                                                                    self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                                    self.fec_destination_info.parent = self
                                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                                return self.fec_destination_info

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "fec-extended-tunnel-id"):
                                                                self.fec_extended_tunnel_id = value
                                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-lsp-id"):
                                                                self.fec_lsp_id = value
                                                                self.fec_lsp_id.value_namespace = name_space
                                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-source"):
                                                                self.fec_source = value
                                                                self.fec_source.value_namespace = name_space
                                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-tunnel-id"):
                                                                self.fec_tunnel_id = value
                                                                self.fec_tunnel_id.value_namespace = name_space
                                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-vrf"):
                                                                self.fec_vrf = value
                                                                self.fec_vrf.value_namespace = name_space
                                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.destination_node_exception.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.ignore_lsp_id.is_set or
                                                            self.penultimate_node_exception.is_set or
                                                            self.processing_node_exception.is_set or
                                                            (self.fec is not None and self.fec.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                                            (self.fec is not None and self.fec.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsp-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "fec"):
                                                            if (self.fec is None):
                                                                self.fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                                self.fec.parent = self
                                                                self._children_name_map["fec"] = "fec"
                                                            return self.fec

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "destination-node-exception"):
                                                            self.destination_node_exception = value
                                                            self.destination_node_exception.value_namespace = name_space
                                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ignore-lsp-id"):
                                                            self.ignore_lsp_id = value
                                                            self.ignore_lsp_id.value_namespace = name_space
                                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "penultimate-node-exception"):
                                                            self.penultimate_node_exception = value
                                                            self.penultimate_node_exception.value_namespace = name_space
                                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "processing-node-exception"):
                                                            self.processing_node_exception = value
                                                            self.processing_node_exception.value_namespace = name_space
                                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.type.is_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "xro-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "as-subobject"):
                                                        if (self.as_subobject is None):
                                                            self.as_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                            self.as_subobject.parent = self
                                                            self._children_name_map["as_subobject"] = "as-subobject"
                                                        return self.as_subobject

                                                    if (child_yang_name == "ipv4-subobject"):
                                                        if (self.ipv4_subobject is None):
                                                            self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                            self.ipv4_subobject.parent = self
                                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                        return self.ipv4_subobject

                                                    if (child_yang_name == "ipv6-subobject"):
                                                        if (self.ipv6_subobject is None):
                                                            self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                            self.ipv6_subobject.parent = self
                                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                        return self.ipv6_subobject

                                                    if (child_yang_name == "lsp-subobject"):
                                                        if (self.lsp_subobject is None):
                                                            self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                            self.lsp_subobject.parent = self
                                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                        return self.lsp_subobject

                                                    if (child_yang_name == "srlg-subobject"):
                                                        if (self.srlg_subobject is None):
                                                            self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                            self.srlg_subobject.parent = self
                                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                        return self.srlg_subobject

                                                    if (child_yang_name == "unnumbered-subobject"):
                                                        if (self.unnumbered_subobject is None):
                                                            self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                            self.unnumbered_subobject.parent = self
                                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                        return self.unnumbered_subobject

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_data()):
                                                        return True
                                                return self.mutual_diversity_flag.is_set

                                            def has_operation(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "xro" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "xro-subobject"):
                                                    for c in self.xro_subobject:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.xro_subobject.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "mutual-diversity-flag"):
                                                    self.mutual_diversity_flag = value
                                                    self.mutual_diversity_flag.value_namespace = name_space
                                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (self.xro is not None and self.xro.has_data())

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.xro is not None and self.xro.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-xro" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "xro"):
                                                if (self.xro is None):
                                                    self.xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                                    self.xro.parent = self
                                                    self._children_name_map["xro"] = "xro"
                                                return self.xro

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "xro"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class AttributeSetP2Mpte(Entity):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "frr_bandwidth_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_priority_configured",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2mpte" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetApsPp(Entity):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                            self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                            self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                            self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                            self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                            self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                            self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                            self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                            self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._children_yang_names.add("revert-schedule")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_off_time",
                                                            "path_prot_profile_type",
                                                            "protection_mode",
                                                            "protection_type",
                                                            "restoration_style",
                                                            "snc_mode",
                                                            "tcm_id",
                                                            "wait_to_restore_time") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                                        class RevertSchedule(Entity):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"

                                                self.duration = YLeaf(YType.uint32, "duration")

                                                self.max_tries = YLeaf(YType.uint32, "max-tries")

                                                self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                                self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                                self.schedulename = YLeaf(YType.str, "schedulename")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("duration",
                                                                "max_tries",
                                                                "schedule_date",
                                                                "schedule_frequency",
                                                                "schedulename") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.duration.is_set or
                                                    self.max_tries.is_set or
                                                    self.schedule_date.is_set or
                                                    self.schedule_frequency.is_set or
                                                    self.schedulename.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.duration.yfilter != YFilter.not_set or
                                                    self.max_tries.yfilter != YFilter.not_set or
                                                    self.schedule_date.yfilter != YFilter.not_set or
                                                    self.schedule_frequency.yfilter != YFilter.not_set or
                                                    self.schedulename.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "revert-schedule" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.duration.get_name_leafdata())
                                                if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_tries.get_name_leafdata())
                                                if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                                if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                                if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedulename.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "duration"):
                                                    self.duration = value
                                                    self.duration.value_namespace = name_space
                                                    self.duration.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-tries"):
                                                    self.max_tries = value
                                                    self.max_tries.value_namespace = name_space
                                                    self.max_tries.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-date"):
                                                    self.schedule_date = value
                                                    self.schedule_date.value_namespace = name_space
                                                    self.schedule_date.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-frequency"):
                                                    self.schedule_frequency = value
                                                    self.schedule_frequency.value_namespace = name_space
                                                    self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedulename"):
                                                    self.schedulename = value
                                                    self.schedulename.value_namespace = name_space
                                                    self.schedulename.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.hold_off_time.is_set or
                                                self.path_prot_profile_type.is_set or
                                                self.protection_mode.is_set or
                                                self.protection_type.is_set or
                                                self.restoration_style.is_set or
                                                self.snc_mode.is_set or
                                                self.tcm_id.is_set or
                                                self.wait_to_restore_time.is_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_off_time.yfilter != YFilter.not_set or
                                                self.path_prot_profile_type.yfilter != YFilter.not_set or
                                                self.protection_mode.yfilter != YFilter.not_set or
                                                self.protection_type.yfilter != YFilter.not_set or
                                                self.restoration_style.yfilter != YFilter.not_set or
                                                self.snc_mode.yfilter != YFilter.not_set or
                                                self.tcm_id.yfilter != YFilter.not_set or
                                                self.wait_to_restore_time.yfilter != YFilter.not_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-aps-pp" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                            if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                            if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                            if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_type.get_name_leafdata())
                                            if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                            if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                            if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                            if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "revert-schedule"):
                                                if (self.revert_schedule is None):
                                                    self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                                    self.revert_schedule.parent = self
                                                    self._children_name_map["revert_schedule"] = "revert-schedule"
                                                return self.revert_schedule

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-off-time"):
                                                self.hold_off_time = value
                                                self.hold_off_time.value_namespace = name_space
                                                self.hold_off_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-prot-profile-type"):
                                                self.path_prot_profile_type = value
                                                self.path_prot_profile_type.value_namespace = name_space
                                                self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-mode"):
                                                self.protection_mode = value
                                                self.protection_mode.value_namespace = name_space
                                                self.protection_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-type"):
                                                self.protection_type = value
                                                self.protection_type.value_namespace = name_space
                                                self.protection_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "restoration-style"):
                                                self.restoration_style = value
                                                self.restoration_style.value_namespace = name_space
                                                self.restoration_style.value_namespace_prefix = name_space_prefix
                                            if(value_path == "snc-mode"):
                                                self.snc_mode = value
                                                self.snc_mode.value_namespace = name_space
                                                self.snc_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcm-id"):
                                                self.tcm_id = value
                                                self.tcm_id.value_namespace = name_space
                                                self.tcm_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "wait-to-restore-time"):
                                                self.wait_to_restore_time = value
                                                self.wait_to_restore_time.value_namespace = name_space
                                                self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                                    class AttributeSetP2PTe(Entity):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                            self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                            self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                            self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                            self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                            self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                            self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                            self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                            self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                            self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.prepend_list = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"
                                            self._children_yang_names.add("prepend-list")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_affinity_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_path_select_configured",
                                                            "is_path_selection_metric_configured",
                                                            "is_path_selection_segment_routing_adjacency_protection_configured",
                                                            "is_path_selection_segment_routing_margin_configured",
                                                            "is_path_selection_segment_routing_margin_relative",
                                                            "is_path_selection_segment_routing_segment_limit_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "is_prepend_list_configured",
                                                            "path_invalidation_timeout",
                                                            "path_selection_invalidation_action",
                                                            "path_selection_metric",
                                                            "path_selection_segment_routing_adjacency_protection",
                                                            "path_selection_segment_routing_margin",
                                                            "path_selection_segment_routing_segment_limit",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PrependList(Entity):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.prepend_entry = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in () and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                            class PrependEntry(Entity):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"

                                                    self.index = YLeaf(YType.uint32, "index")

                                                    self.next_label = YLeaf(YType.uint32, "next-label")

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("index",
                                                                    "next_label",
                                                                    "type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.index.is_set or
                                                        self.next_label.is_set or
                                                        self.type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.index.yfilter != YFilter.not_set or
                                                        self.next_label.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "prepend-entry" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.index.get_name_leafdata())
                                                    if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.next_label.get_name_leafdata())
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "index" or name == "next-label" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "index"):
                                                        self.index = value
                                                        self.index.value_namespace = name_space
                                                        self.index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "next-label"):
                                                        self.next_label = value
                                                        self.next_label.value_namespace = name_space
                                                        self.next_label.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_data()):
                                                        return True
                                                return False

                                            def has_operation(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_operation()):
                                                        return True
                                                return self.yfilter != YFilter.not_set

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prepend-list" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "prepend-entry"):
                                                    for c in self.prepend_entry:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.prepend_entry.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "prepend-entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                pass


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.is_affinity_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_path_select_configured.is_set or
                                                self.is_path_selection_metric_configured.is_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_relative.is_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.is_prepend_list_configured.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.path_selection_invalidation_action.is_set or
                                                self.path_selection_metric.is_set or
                                                self.path_selection_segment_routing_adjacency_protection.is_set or
                                                self.path_selection_segment_routing_margin.is_set or
                                                self.path_selection_segment_routing_segment_limit.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.prepend_list is not None and self.prepend_list.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_path_select_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_selection_metric.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.prepend_list is not None and self.prepend_list.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2p-te" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                            if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                            if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                            if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                            if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                            if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "prepend-list"):
                                                if (self.prepend_list is None):
                                                    self.prepend_list = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                                    self.prepend_list.parent = self
                                                    self._children_name_map["prepend_list"] = "prepend-list"
                                                return self.prepend_list

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-select-configured"):
                                                self.is_path_select_configured = value
                                                self.is_path_select_configured.value_namespace = name_space
                                                self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-metric-configured"):
                                                self.is_path_selection_metric_configured = value
                                                self.is_path_selection_metric_configured.value_namespace = name_space
                                                self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                                self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                                self.is_path_selection_segment_routing_margin_configured = value
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                                self.is_path_selection_segment_routing_margin_relative = value
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                                self.is_path_selection_segment_routing_segment_limit_configured = value
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-prepend-list-configured"):
                                                self.is_prepend_list_configured = value
                                                self.is_prepend_list_configured.value_namespace = name_space
                                                self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-invalidation-action"):
                                                self.path_selection_invalidation_action = value
                                                self.path_selection_invalidation_action.value_namespace = name_space
                                                self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-metric"):
                                                self.path_selection_metric = value
                                                self.path_selection_metric.value_namespace = name_space
                                                self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                                self.path_selection_segment_routing_adjacency_protection = value
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-margin"):
                                                self.path_selection_segment_routing_margin = value
                                                self.path_selection_segment_routing_margin.value_namespace = name_space
                                                self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-segment-limit"):
                                                self.path_selection_segment_routing_segment_limit = value
                                                self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                                self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.tunnel_attribute_set_type.is_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-union" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "attribute-set-aps-pp"):
                                            if (self.attribute_set_aps_pp is None):
                                                self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                                self.attribute_set_aps_pp.parent = self
                                                self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                            return self.attribute_set_aps_pp

                                        if (child_yang_name == "attribute-set-autobackup"):
                                            if (self.attribute_set_autobackup is None):
                                                self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                                self.attribute_set_autobackup.parent = self
                                                self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                            return self.attribute_set_autobackup

                                        if (child_yang_name == "attribute-set-automesh"):
                                            if (self.attribute_set_automesh is None):
                                                self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                                self.attribute_set_automesh.parent = self
                                                self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                            return self.attribute_set_automesh

                                        if (child_yang_name == "attribute-set-p2mpte"):
                                            if (self.attribute_set_p2mpte is None):
                                                self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                                self.attribute_set_p2mpte.parent = self
                                                self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                            return self.attribute_set_p2mpte

                                        if (child_yang_name == "attribute-set-p2p-te"):
                                            if (self.attribute_set_p2p_te is None):
                                                self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                                self.attribute_set_p2p_te.parent = self
                                                self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                            return self.attribute_set_p2p_te

                                        if (child_yang_name == "attribute-set-path-option"):
                                            if (self.attribute_set_path_option is None):
                                                self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                                self.attribute_set_path_option.parent = self
                                                self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                            return self.attribute_set_path_option

                                        if (child_yang_name == "attribute-set-xro"):
                                            if (self.attribute_set_xro is None):
                                                self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                                self.attribute_set_xro.parent = self
                                                self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                            return self.attribute_set_xro

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "tunnel-attribute-set-type"):
                                            self.tunnel_attribute_set_type = value
                                            self.tunnel_attribute_set_type.value_namespace = name_space
                                            self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.tunnel_attribute_set_name.is_set or
                                        self.tunnel_attribute_set_name_crc32.is_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "attribute-set" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                                    if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "attribute-set-union"):
                                        if (self.attribute_set_union is None):
                                            self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet.AttributeSetUnion()
                                            self.attribute_set_union.parent = self
                                            self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                        return self.attribute_set_union

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "tunnel-attribute-set-name"):
                                        self.tunnel_attribute_set_name = value
                                        self.tunnel_attribute_set_name.value_namespace = name_space
                                        self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-attribute-set-name-crc32"):
                                        self.tunnel_attribute_set_name_crc32 = value
                                        self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                                        self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                            class XroAttributeSet(Entity):
                                """
                                The XRO attribute set used by this path\-option
                                
                                .. attribute:: attribute_set_union
                                
                                	Union of Attribute Sets
                                	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion>`
                                
                                .. attribute:: tunnel_attribute_set_name
                                
                                	Attribute Set Name
                                	**type**\:  str
                                
                                .. attribute:: tunnel_attribute_set_name_crc32
                                
                                	Attribute Set name CRC32 value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet, self).__init__()

                                    self.yang_name = "xro-attribute-set"
                                    self.yang_parent_name = "active-path-option"

                                    self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                                    self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                                    self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                    self.attribute_set_union.parent = self
                                    self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    self._children_yang_names.add("attribute-set-union")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("tunnel_attribute_set_name",
                                                    "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet, self).__setattr__(name, value)


                                class AttributeSetUnion(Entity):
                                    """
                                    Union of Attribute Sets
                                    
                                    .. attribute:: attribute_set_aps_pp
                                    
                                    	Attribute Set OTN APS Path Protection
                                    	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                    
                                    .. attribute:: attribute_set_autobackup
                                    
                                    	MPLS TE Auto\-backup Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                    
                                    .. attribute:: attribute_set_automesh
                                    
                                    	MPLS TE Auto\-mesh Attribute Set
                                    	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                    
                                    .. attribute:: attribute_set_p2mpte
                                    
                                    	MPLS TE P2MP\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                                    
                                    .. attribute:: attribute_set_p2p_te
                                    
                                    	MPLS TE P2P\-TE Attribute Set
                                    	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                                    
                                    .. attribute:: attribute_set_path_option
                                    
                                    	MPLS TE Path Option Attribute Set
                                    	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                    
                                    .. attribute:: attribute_set_xro
                                    
                                    	Attribute Set XRO
                                    	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                                    
                                    .. attribute:: tunnel_attribute_set_type
                                    
                                    	TunnelAttributeSetType
                                    	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__init__()

                                        self.yang_name = "attribute-set-union"
                                        self.yang_parent_name = "xro-attribute-set"

                                        self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                                        self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                        self.attribute_set_aps_pp.parent = self
                                        self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                        self._children_yang_names.add("attribute-set-aps-pp")

                                        self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                        self.attribute_set_autobackup.parent = self
                                        self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                        self._children_yang_names.add("attribute-set-autobackup")

                                        self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                        self.attribute_set_automesh.parent = self
                                        self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                        self._children_yang_names.add("attribute-set-automesh")

                                        self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                        self.attribute_set_p2mpte.parent = self
                                        self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                        self._children_yang_names.add("attribute-set-p2mpte")

                                        self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                        self.attribute_set_p2p_te.parent = self
                                        self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        self._children_yang_names.add("attribute-set-p2p-te")

                                        self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                        self.attribute_set_path_option.parent = self
                                        self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                        self._children_yang_names.add("attribute-set-path-option")

                                        self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                        self.attribute_set_xro.parent = self
                                        self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                        self._children_yang_names.add("attribute-set-xro")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                                    class AttributeSetPathOption(Entity):
                                        """
                                        MPLS TE Path Option Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                        
                                        .. attribute:: bandwidth_type
                                        
                                        	The bandwidth type
                                        	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                        
                                        .. attribute:: bfd_reverse_path
                                        
                                        	BFD reverse path
                                        	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: cost_limit
                                        
                                        	Cost limit on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: exclude_list_name
                                        
                                        	Exclude list name
                                        	**type**\:  str
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bfd_reverse_pat_configured
                                        
                                        	Is BFD reverse path configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_cost_limit_configured
                                        
                                        	Is Cost Limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_exclude_list_name_configured
                                        
                                        	Is exclude list name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is path invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is path invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: path_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation interval on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                        
                                        .. attribute:: version_info
                                        
                                        	Version Info
                                        	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                            self.yang_name = "attribute-set-path-option"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                            self.generation = YLeaf(YType.uint32, "generation")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                            self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                            self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                            self.bfd_reverse_path.parent = self
                                            self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                            self._children_yang_names.add("bfd-reverse-path")

                                            self.tunnel_id = YList(self)
                                            self.version_info = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bandwidth_type",
                                                            "configured_bandwidth",
                                                            "cost_limit",
                                                            "dste_class_type",
                                                            "exclude_list_name",
                                                            "generation",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_bfd_reverse_pat_configured",
                                                            "is_cost_limit_configured",
                                                            "is_exclude_list_name_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "path_invalidation_action",
                                                            "path_invalidation_timeout",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class BfdReversePath(Entity):
                                            """
                                            BFD reverse path
                                            
                                            .. attribute:: binding_label
                                            
                                            	BFD reverse path binding label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: path_type
                                            
                                            	BFD reverse path type
                                            	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                                self.yang_name = "bfd-reverse-path"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.binding_label = YLeaf(YType.uint32, "binding-label")

                                                self.path_type = YLeaf(YType.enumeration, "path-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("binding_label",
                                                                "path_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.binding_label.is_set or
                                                    self.path_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.binding_label.yfilter != YFilter.not_set or
                                                    self.path_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "bfd-reverse-path" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.binding_label.get_name_leafdata())
                                                if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.path_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "binding-label" or name == "path-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "binding-label"):
                                                    self.binding_label = value
                                                    self.binding_label.value_namespace = name_space
                                                    self.binding_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "path-type"):
                                                    self.path_type = value
                                                    self.path_type.value_namespace = name_space
                                                    self.path_type.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class VersionInfo(Entity):
                                            """
                                            Version Info
                                            
                                            .. attribute:: attribute_type
                                            
                                            	Attribute Type
                                            	**type**\:  str
                                            
                                            .. attribute:: generation
                                            
                                            	Generation
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: is_default
                                            
                                            	Is default
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                                self.yang_name = "version-info"
                                                self.yang_parent_name = "attribute-set-path-option"

                                                self.attribute_type = YLeaf(YType.str, "attribute-type")

                                                self.generation = YLeaf(YType.uint32, "generation")

                                                self.is_default = YLeaf(YType.boolean, "is-default")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("attribute_type",
                                                                "generation",
                                                                "is_default") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.attribute_type.is_set or
                                                    self.generation.is_set or
                                                    self.is_default.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.attribute_type.yfilter != YFilter.not_set or
                                                    self.generation.yfilter != YFilter.not_set or
                                                    self.is_default.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "version-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                                if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.generation.get_name_leafdata())
                                                if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_default.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "attribute-type"):
                                                    self.attribute_type = value
                                                    self.attribute_type.value_namespace = name_space
                                                    self.attribute_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "generation"):
                                                    self.generation = value
                                                    self.generation.value_namespace = name_space
                                                    self.generation.value_namespace_prefix = name_space_prefix
                                                if(value_path == "is-default"):
                                                    self.is_default = value
                                                    self.is_default.value_namespace = name_space
                                                    self.is_default.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.bandwidth_type.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.cost_limit.is_set or
                                                self.dste_class_type.is_set or
                                                self.exclude_list_name.is_set or
                                                self.generation.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_bfd_reverse_pat_configured.is_set or
                                                self.is_cost_limit_configured.is_set or
                                                self.is_exclude_list_name_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.path_invalidation_action.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.version_info:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bandwidth_type.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.cost_limit.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.exclude_list_name.yfilter != YFilter.not_set or
                                                self.generation.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                                self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                                self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-path-option" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.generation.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                            if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                            if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "bfd-reverse-path"):
                                                if (self.bfd_reverse_path is None):
                                                    self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                                    self.bfd_reverse_path.parent = self
                                                    self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                                return self.bfd_reverse_path

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            if (child_yang_name == "version-info"):
                                                for c in self.version_info:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.version_info.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bandwidth-type"):
                                                self.bandwidth_type = value
                                                self.bandwidth_type.value_namespace = name_space
                                                self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "cost-limit"):
                                                self.cost_limit = value
                                                self.cost_limit.value_namespace = name_space
                                                self.cost_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exclude-list-name"):
                                                self.exclude_list_name = value
                                                self.exclude_list_name.value_namespace = name_space
                                                self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "generation"):
                                                self.generation = value
                                                self.generation.value_namespace = name_space
                                                self.generation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bfd-reverse-pat-configured"):
                                                self.is_bfd_reverse_pat_configured = value
                                                self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                                self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-cost-limit-configured"):
                                                self.is_cost_limit_configured = value
                                                self.is_cost_limit_configured.value_namespace = name_space
                                                self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-exclude-list-name-configured"):
                                                self.is_exclude_list_name_configured = value
                                                self.is_exclude_list_name_configured.value_namespace = name_space
                                                self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-action"):
                                                self.path_invalidation_action = value
                                                self.path_invalidation_action.value_namespace = name_space
                                                self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutobackup(Entity):
                                        """
                                        MPLS TE Auto\-backup Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_signalled_name_configured
                                        
                                        	Is signalled name configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Array of Protected Interface Names
                                        	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: signalled_name
                                        
                                        	Signalled name
                                        	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                            self.yang_name = "attribute-set-autobackup"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.signalled_name = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                            self.signalled_name.parent = self
                                            self._children_name_map["signalled_name"] = "signalled-name"
                                            self._children_yang_names.add("signalled-name")

                                            self.policy_class_entry = YList(self)
                                            self.protected_interface = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_priority",
                                                            "is_affinity_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "is_signalled_name_configured",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                                        class SignalledName(Entity):
                                            """
                                            Signalled name
                                            
                                            .. attribute:: is_mp_addresses
                                            
                                            	MP address appended
                                            	**type**\:  bool
                                            
                                            .. attribute:: name
                                            
                                            	Signalled name
                                            	**type**\:  str
                                            
                                            .. attribute:: protected_interface_type
                                            
                                            	Protected interface address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            .. attribute:: source_type
                                            
                                            	Source address or name
                                            	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                                self.yang_name = "signalled-name"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                                self.name = YLeaf(YType.str, "name")

                                                self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                                self.source_type = YLeaf(YType.enumeration, "source-type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("is_mp_addresses",
                                                                "name",
                                                                "protected_interface_type",
                                                                "source_type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.is_mp_addresses.is_set or
                                                    self.name.is_set or
                                                    self.protected_interface_type.is_set or
                                                    self.source_type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.is_mp_addresses.yfilter != YFilter.not_set or
                                                    self.name.yfilter != YFilter.not_set or
                                                    self.protected_interface_type.yfilter != YFilter.not_set or
                                                    self.source_type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "signalled-name" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                                if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.name.get_name_leafdata())
                                                if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                                if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.source_type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "is-mp-addresses"):
                                                    self.is_mp_addresses = value
                                                    self.is_mp_addresses.value_namespace = name_space
                                                    self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                                if(value_path == "name"):
                                                    self.name = value
                                                    self.name.value_namespace = name_space
                                                    self.name.value_namespace_prefix = name_space_prefix
                                                if(value_path == "protected-interface-type"):
                                                    self.protected_interface_type = value
                                                    self.protected_interface_type.value_namespace = name_space
                                                    self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "source-type"):
                                                    self.source_type = value
                                                    self.source_type.value_namespace = name_space
                                                    self.source_type.value_namespace_prefix = name_space_prefix


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class ProtectedInterface(Entity):
                                            """
                                            Array of Protected Interface Names
                                            
                                            .. attribute:: protected_interface
                                            
                                            	Protected Interface Name
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                                self.yang_name = "protected-interface"
                                                self.yang_parent_name = "attribute-set-autobackup"

                                                self.protected_interface = YLeaf(YType.str, "protected-interface")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("protected_interface") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.protected_interface.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.protected_interface.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "protected-interface" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "protected-interface"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "protected-interface"):
                                                    self.protected_interface = value
                                                    self.protected_interface.value_namespace = name_space
                                                    self.protected_interface.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.is_signalled_name_configured.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.signalled_name is not None and self.signalled_name.has_data()))

                                        def has_operation(self):
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.protected_interface:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.signalled_name is not None and self.signalled_name.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-autobackup" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "protected-interface"):
                                                for c in self.protected_interface:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.protected_interface.append(c)
                                                return c

                                            if (child_yang_name == "signalled-name"):
                                                if (self.signalled_name is None):
                                                    self.signalled_name = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                                    self.signalled_name.parent = self
                                                    self._children_name_map["signalled_name"] = "signalled-name"
                                                return self.signalled_name

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-signalled-name-configured"):
                                                self.is_signalled_name_configured = value
                                                self.is_signalled_name_configured.value_namespace = name_space
                                                self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetAutomesh(Entity):
                                        """
                                        MPLS TE Auto\-mesh Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                        
                                        .. attribute:: auto_bandwidth_collect
                                        
                                        	Auto bandwidth collect only
                                        	**type**\:  bool
                                        
                                        .. attribute:: auto_route_announce
                                        
                                        	Announce auto route to IGP
                                        	**type**\:  bool
                                        
                                        .. attribute:: bandwidth
                                        
                                        	IM bandwidth
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: forward_class
                                        
                                        	Forward class
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_node_protection
                                        
                                        	FRR Node protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_interface_bw_configured
                                        
                                        	Is Interface BW configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_policyclass_configured
                                        
                                        	Is policy class configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: load_share
                                        
                                        	Load Share
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                        
                                        .. attribute:: mesh_group_id
                                        
                                        	Meshgroup ID
                                        	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                        
                                        .. attribute:: policy_class
                                        
                                        	deprecated
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: policy_class_entry
                                        
                                        	PBTS policy classes
                                        	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                        
                                        .. attribute:: record_route
                                        
                                        	Record route
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: soft_preemption_configured
                                        
                                        	Soft preemption is configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                            self.yang_name = "attribute-set-automesh"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                            self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                            self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.forward_class = YLeaf(YType.uint32, "forward-class")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                            self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.load_share = YLeaf(YType.uint32, "load-share")

                                            self.policy_class = YLeaf(YType.uint8, "policy-class")

                                            self.record_route = YLeaf(YType.boolean, "record-route")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.mesh_group_id = YList(self)
                                            self.policy_class_entry = YList(self)
                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("auto_bandwidth_collect",
                                                            "auto_route_announce",
                                                            "bandwidth",
                                                            "configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "forward_class",
                                                            "frr_bandwidth_protection",
                                                            "frr_node_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_interface_bw_configured",
                                                            "is_policyclass_configured",
                                                            "is_priority_configured",
                                                            "load_share",
                                                            "policy_class",
                                                            "record_route",
                                                            "setup_priority",
                                                            "soft_preemption_configured") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PolicyClassEntry(Entity):
                                            """
                                            PBTS policy classes
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                                self.yang_name = "policy-class-entry"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint8, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "policy-class-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class MeshGroupId(Entity):
                                            """
                                            Meshgroup ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                                self.yang_name = "mesh-group-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint32, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "mesh-group-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-automesh"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_data()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.auto_bandwidth_collect.is_set or
                                                self.auto_route_announce.is_set or
                                                self.bandwidth.is_set or
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.forward_class.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.frr_node_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_interface_bw_configured.is_set or
                                                self.is_policyclass_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.load_share.is_set or
                                                self.policy_class.is_set or
                                                self.record_route.is_set or
                                                self.setup_priority.is_set or
                                                self.soft_preemption_configured.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()))

                                        def has_operation(self):
                                            for c in self.mesh_group_id:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.policy_class_entry:
                                                if (c.has_operation()):
                                                    return True
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                                self.auto_route_announce.yfilter != YFilter.not_set or
                                                self.bandwidth.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.forward_class.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.frr_node_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                                self.is_policyclass_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.load_share.yfilter != YFilter.not_set or
                                                self.policy_class.yfilter != YFilter.not_set or
                                                self.record_route.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                self.soft_preemption_configured.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-automesh" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                            if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                            if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.forward_class.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                            if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.load_share.get_name_leafdata())
                                            if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.policy_class.get_name_leafdata())
                                            if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.record_route.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                            if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "mesh-group-id"):
                                                for c in self.mesh_group_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.mesh_group_id.append(c)
                                                return c

                                            if (child_yang_name == "policy-class-entry"):
                                                for c in self.policy_class_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.policy_class_entry.append(c)
                                                return c

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "auto-bandwidth-collect"):
                                                self.auto_bandwidth_collect = value
                                                self.auto_bandwidth_collect.value_namespace = name_space
                                                self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                            if(value_path == "auto-route-announce"):
                                                self.auto_route_announce = value
                                                self.auto_route_announce.value_namespace = name_space
                                                self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                            if(value_path == "bandwidth"):
                                                self.bandwidth = value
                                                self.bandwidth.value_namespace = name_space
                                                self.bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "forward-class"):
                                                self.forward_class = value
                                                self.forward_class.value_namespace = name_space
                                                self.forward_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-node-protection"):
                                                self.frr_node_protection = value
                                                self.frr_node_protection.value_namespace = name_space
                                                self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-interface-bw-configured"):
                                                self.is_interface_bw_configured = value
                                                self.is_interface_bw_configured.value_namespace = name_space
                                                self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-policyclass-configured"):
                                                self.is_policyclass_configured = value
                                                self.is_policyclass_configured.value_namespace = name_space
                                                self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "load-share"):
                                                self.load_share = value
                                                self.load_share.value_namespace = name_space
                                                self.load_share.value_namespace_prefix = name_space_prefix
                                            if(value_path == "policy-class"):
                                                self.policy_class = value
                                                self.policy_class.value_namespace = name_space
                                                self.policy_class.value_namespace_prefix = name_space_prefix
                                            if(value_path == "record-route"):
                                                self.record_route = value
                                                self.record_route.value_namespace = name_space
                                                self.record_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "soft-preemption-configured"):
                                                self.soft_preemption_configured = value
                                                self.soft_preemption_configured.value_namespace = name_space
                                                self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                                    class AttributeSetXro(Entity):
                                        """
                                        Attribute Set XRO
                                        
                                        .. attribute:: xro
                                        
                                        	The XRO specified by this attribute\-set
                                        	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                            self.yang_name = "attribute-set-xro"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                            self.xro.parent = self
                                            self._children_name_map["xro"] = "xro"
                                            self._children_yang_names.add("xro")


                                        class Xro(Entity):
                                            """
                                            The XRO specified by this attribute\-set
                                            
                                            .. attribute:: mutual_diversity_flag
                                            
                                            	Mutual Diversity Flag
                                            	**type**\:  bool
                                            
                                            .. attribute:: xro_subobject
                                            
                                            	List of XRO sub\-objects
                                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                                self.yang_name = "xro"
                                                self.yang_parent_name = "attribute-set-xro"

                                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                                self.xro_subobject = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                            class XroSubobject(Entity):
                                                """
                                                List of XRO sub\-objects
                                                
                                                .. attribute:: as_subobject
                                                
                                                	AS sub\-object
                                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                                
                                                .. attribute:: ipv4_subobject
                                                
                                                	IPv4 sub\-object
                                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                                
                                                .. attribute:: ipv6_subobject
                                                
                                                	IPv6 sub\-object
                                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                                
                                                .. attribute:: lsp_subobject
                                                
                                                	P2P LSP sub\-object
                                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                                
                                                .. attribute:: srlg_subobject
                                                
                                                	SRLG sub\-object
                                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                                
                                                .. attribute:: type
                                                
                                                	Type
                                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                                
                                                .. attribute:: unnumbered_subobject
                                                
                                                	Unnumbered sub\-object
                                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                    self.yang_name = "xro-subobject"
                                                    self.yang_parent_name = "xro"

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                    self.as_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                    self.as_subobject.parent = self
                                                    self._children_name_map["as_subobject"] = "as-subobject"
                                                    self._children_yang_names.add("as-subobject")

                                                    self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                    self.ipv4_subobject.parent = self
                                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                    self._children_yang_names.add("ipv4-subobject")

                                                    self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                    self.ipv6_subobject.parent = self
                                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                    self._children_yang_names.add("ipv6-subobject")

                                                    self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                    self.lsp_subobject.parent = self
                                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    self._children_yang_names.add("lsp-subobject")

                                                    self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                    self.srlg_subobject.parent = self
                                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                    self._children_yang_names.add("srlg-subobject")

                                                    self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                    self.unnumbered_subobject.parent = self
                                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                    self._children_yang_names.add("unnumbered-subobject")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                                class Ipv4Subobject(Entity):
                                                    """
                                                    IPv4 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv4 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                        self.yang_name = "ipv4-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv4-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class Ipv6Subobject(Entity):
                                                    """
                                                    IPv6 sub\-object
                                                    
                                                    .. attribute:: address
                                                    
                                                    	IPv6 address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: prefix_len
                                                    
                                                    	Prefix length
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                        self.yang_name = "ipv6-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.address = YLeaf(YType.str, "address")

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("address",
                                                                        "attribute",
                                                                        "exclusion_type",
                                                                        "prefix_len") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.address.is_set or
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.prefix_len.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.address.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.prefix_len.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "ipv6-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.address.get_name_leafdata())
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "address"):
                                                            self.address = value
                                                            self.address.value_namespace = name_space
                                                            self.address.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "prefix-len"):
                                                            self.prefix_len = value
                                                            self.prefix_len.value_namespace = name_space
                                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                                class UnnumberedSubobject(Entity):
                                                    """
                                                    Unnumbered sub\-object
                                                    
                                                    .. attribute:: attribute
                                                    
                                                    	Attribute
                                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: interface_id
                                                    
                                                    	Interface ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: te_router_id
                                                    
                                                    	TE router\-id
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                        self.yang_name = "unnumbered-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("attribute",
                                                                        "exclusion_type",
                                                                        "interface_id",
                                                                        "te_router_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.attribute.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.interface_id.is_set or
                                                            self.te_router_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.attribute.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.interface_id.yfilter != YFilter.not_set or
                                                            self.te_router_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "unnumbered-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "attribute"):
                                                            self.attribute = value
                                                            self.attribute.value_namespace = name_space
                                                            self.attribute.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "interface-id"):
                                                            self.interface_id = value
                                                            self.interface_id.value_namespace = name_space
                                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "te-router-id"):
                                                            self.te_router_id = value
                                                            self.te_router_id.value_namespace = name_space
                                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                                class AsSubobject(Entity):
                                                    """
                                                    AS sub\-object
                                                    
                                                    .. attribute:: as_number
                                                    
                                                    	Autonomous System number
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                        self.yang_name = "as-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("as_number") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.as_number.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.as_number.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "as-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "as-number"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "as-number"):
                                                            self.as_number = value
                                                            self.as_number.value_namespace = name_space
                                                            self.as_number.value_namespace_prefix = name_space_prefix


                                                class SrlgSubobject(Entity):
                                                    """
                                                    SRLG sub\-object
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: srlg_id
                                                    
                                                    	SRLG ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                        self.yang_name = "srlg-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("exclusion_type",
                                                                        "srlg_id") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return (
                                                            self.exclusion_type.is_set or
                                                            self.srlg_id.is_set)

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.srlg_id.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "srlg-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "exclusion-type" or name == "srlg-id"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "srlg-id"):
                                                            self.srlg_id = value
                                                            self.srlg_id.value_namespace = name_space
                                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                                class LspSubobject(Entity):
                                                    """
                                                    P2P LSP sub\-object
                                                    
                                                    .. attribute:: destination_node_exception
                                                    
                                                    	Destination\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: exclusion_type
                                                    
                                                    	Exclusion Type
                                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                    
                                                    .. attribute:: fec
                                                    
                                                    	LSP FEC
                                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                    
                                                    .. attribute:: ignore_lsp_id
                                                    
                                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: penultimate_node_exception
                                                    
                                                    	Penultimate\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: processing_node_exception
                                                    
                                                    	Processing\-node exception flag
                                                    	**type**\:  bool
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                        self.yang_name = "lsp-subobject"
                                                        self.yang_parent_name = "xro-subobject"

                                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                                        self.fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                        self.fec.parent = self
                                                        self._children_name_map["fec"] = "fec"
                                                        self._children_yang_names.add("fec")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("destination_node_exception",
                                                                        "exclusion_type",
                                                                        "ignore_lsp_id",
                                                                        "penultimate_node_exception",
                                                                        "processing_node_exception") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                                    class Fec(Entity):
                                                        """
                                                        LSP FEC
                                                        
                                                        .. attribute:: fec_destination_info
                                                        
                                                        	Destination or P2MP ID
                                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                        
                                                        .. attribute:: fec_extended_tunnel_id
                                                        
                                                        	Extended tunnel ID
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_lsp_id
                                                        
                                                        	LSP ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_source
                                                        
                                                        	Tunnel source address
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: fec_tunnel_id
                                                        
                                                        	Tunnel ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: fec_vrf
                                                        
                                                        	VRF; currently only for GMPLS tunnels
                                                        	**type**\:  str
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                            self.yang_name = "fec"
                                                            self.yang_parent_name = "lsp-subobject"

                                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                            self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                            self.fec_destination_info.parent = self
                                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            self._children_yang_names.add("fec-destination-info")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("fec_extended_tunnel_id",
                                                                            "fec_lsp_id",
                                                                            "fec_source",
                                                                            "fec_tunnel_id",
                                                                            "fec_vrf") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                                        class FecDestinationInfo(Entity):
                                                            """
                                                            Destination or P2MP ID
                                                            
                                                            .. attribute:: fec_ctype
                                                            
                                                            	FEC CType
                                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                            
                                                            .. attribute:: fec_destination_p2mp_id
                                                            
                                                            	P2MP ID
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: p2p_lsp_destination
                                                            
                                                            	P2P LSP destination
                                                            	**type**\:  str
                                                            
                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                            
                                                            

                                                            """

                                                            _prefix = 'mpls-te-oper'
                                                            _revision = '2015-11-09'

                                                            def __init__(self):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                                self.yang_name = "fec-destination-info"
                                                                self.yang_parent_name = "fec"

                                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                            def __setattr__(self, name, value):
                                                                self._check_monkey_patching_error(name, value)
                                                                with _handle_type_error():
                                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                            "Please use list append or extend method."
                                                                                            .format(value))
                                                                    if isinstance(value, Enum.YLeaf):
                                                                        value = value.name
                                                                    if name in ("fec_ctype",
                                                                                "fec_destination_p2mp_id",
                                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                                        if isinstance(value, YLeaf):
                                                                            self.__dict__[name].set(value.get())
                                                                        elif isinstance(value, YLeafList):
                                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                                        else:
                                                                            self.__dict__[name].set(value)
                                                                    else:
                                                                        if hasattr(value, "parent") and name != "parent":
                                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                                value.parent = self
                                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                                value.parent = self
                                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                            def has_data(self):
                                                                return (
                                                                    self.fec_ctype.is_set or
                                                                    self.fec_destination_p2mp_id.is_set or
                                                                    self.p2p_lsp_destination.is_set)

                                                            def has_operation(self):
                                                                return (
                                                                    self.yfilter != YFilter.not_set or
                                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                            def get_segment_path(self):
                                                                path_buffer = ""
                                                                path_buffer = "fec-destination-info" + path_buffer

                                                                return path_buffer

                                                            def get_entity_path(self, ancestor):
                                                                path_buffer = ""
                                                                if (ancestor is None):
                                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                                else:
                                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                                leaf_name_data = LeafDataList()
                                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                                return entity_path

                                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                                if child is not None:
                                                                    return child

                                                                return None

                                                            def has_leaf_or_child_of_name(self, name):
                                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                                    return True
                                                                return False

                                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                                if(value_path == "fec-ctype"):
                                                                    self.fec_ctype = value
                                                                    self.fec_ctype.value_namespace = name_space
                                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "fec-destination-p2mp-id"):
                                                                    self.fec_destination_p2mp_id = value
                                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                                if(value_path == "p2p-lsp-destination"):
                                                                    self.p2p_lsp_destination = value
                                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                                        def has_data(self):
                                                            return (
                                                                self.fec_extended_tunnel_id.is_set or
                                                                self.fec_lsp_id.is_set or
                                                                self.fec_source.is_set or
                                                                self.fec_tunnel_id.is_set or
                                                                self.fec_vrf.is_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                                self.fec_source.yfilter != YFilter.not_set or
                                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "fec" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            if (child_yang_name == "fec-destination-info"):
                                                                if (self.fec_destination_info is None):
                                                                    self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                                    self.fec_destination_info.parent = self
                                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                                return self.fec_destination_info

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "fec-extended-tunnel-id"):
                                                                self.fec_extended_tunnel_id = value
                                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-lsp-id"):
                                                                self.fec_lsp_id = value
                                                                self.fec_lsp_id.value_namespace = name_space
                                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-source"):
                                                                self.fec_source = value
                                                                self.fec_source.value_namespace = name_space
                                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-tunnel-id"):
                                                                self.fec_tunnel_id = value
                                                                self.fec_tunnel_id.value_namespace = name_space
                                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-vrf"):
                                                                self.fec_vrf = value
                                                                self.fec_vrf.value_namespace = name_space
                                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.destination_node_exception.is_set or
                                                            self.exclusion_type.is_set or
                                                            self.ignore_lsp_id.is_set or
                                                            self.penultimate_node_exception.is_set or
                                                            self.processing_node_exception.is_set or
                                                            (self.fec is not None and self.fec.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                                            self.exclusion_type.yfilter != YFilter.not_set or
                                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                                            (self.fec is not None and self.fec.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "lsp-subobject" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "fec"):
                                                            if (self.fec is None):
                                                                self.fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                                self.fec.parent = self
                                                                self._children_name_map["fec"] = "fec"
                                                            return self.fec

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "destination-node-exception"):
                                                            self.destination_node_exception = value
                                                            self.destination_node_exception.value_namespace = name_space
                                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "exclusion-type"):
                                                            self.exclusion_type = value
                                                            self.exclusion_type.value_namespace = name_space
                                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "ignore-lsp-id"):
                                                            self.ignore_lsp_id = value
                                                            self.ignore_lsp_id.value_namespace = name_space
                                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "penultimate-node-exception"):
                                                            self.penultimate_node_exception = value
                                                            self.penultimate_node_exception.value_namespace = name_space
                                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "processing-node-exception"):
                                                            self.processing_node_exception = value
                                                            self.processing_node_exception.value_namespace = name_space
                                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.type.is_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set or
                                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "xro-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "as-subobject"):
                                                        if (self.as_subobject is None):
                                                            self.as_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                            self.as_subobject.parent = self
                                                            self._children_name_map["as_subobject"] = "as-subobject"
                                                        return self.as_subobject

                                                    if (child_yang_name == "ipv4-subobject"):
                                                        if (self.ipv4_subobject is None):
                                                            self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                            self.ipv4_subobject.parent = self
                                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                        return self.ipv4_subobject

                                                    if (child_yang_name == "ipv6-subobject"):
                                                        if (self.ipv6_subobject is None):
                                                            self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                            self.ipv6_subobject.parent = self
                                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                        return self.ipv6_subobject

                                                    if (child_yang_name == "lsp-subobject"):
                                                        if (self.lsp_subobject is None):
                                                            self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                            self.lsp_subobject.parent = self
                                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                        return self.lsp_subobject

                                                    if (child_yang_name == "srlg-subobject"):
                                                        if (self.srlg_subobject is None):
                                                            self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                            self.srlg_subobject.parent = self
                                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                        return self.srlg_subobject

                                                    if (child_yang_name == "unnumbered-subobject"):
                                                        if (self.unnumbered_subobject is None):
                                                            self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                            self.unnumbered_subobject.parent = self
                                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                        return self.unnumbered_subobject

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_data()):
                                                        return True
                                                return self.mutual_diversity_flag.is_set

                                            def has_operation(self):
                                                for c in self.xro_subobject:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "xro" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "xro-subobject"):
                                                    for c in self.xro_subobject:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.xro_subobject.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "mutual-diversity-flag"):
                                                    self.mutual_diversity_flag = value
                                                    self.mutual_diversity_flag.value_namespace = name_space
                                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (self.xro is not None and self.xro.has_data())

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                (self.xro is not None and self.xro.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-xro" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "xro"):
                                                if (self.xro is None):
                                                    self.xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                                    self.xro.parent = self
                                                    self._children_name_map["xro"] = "xro"
                                                return self.xro

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "xro"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class AttributeSetP2Mpte(Entity):
                                        """
                                        MPLS TE P2MP\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                                        
                                        .. attribute:: configured_bandwidth
                                        
                                        	Bandwidth value in kbps
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        	**units**\: kbit/s
                                        
                                        .. attribute:: dste_class_type
                                        
                                        	DSTE Class
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: fast_reroute
                                        
                                        	Fast reroute
                                        	**type**\:  bool
                                        
                                        .. attribute:: frr_bandwidth_protection
                                        
                                        	FRR bandwidth protection
                                        	**type**\:  bool
                                        
                                        .. attribute:: hold_priority
                                        
                                        	Hold priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_bandwidth_configured
                                        
                                        	Is bandwidth configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_priority_configured
                                        
                                        	Is priority configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: setup_priority
                                        
                                        	Setup priority
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                            self.yang_name = "attribute-set-p2mpte"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                            self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                            self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                            self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                            self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                            self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                            self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("configured_bandwidth",
                                                            "dste_class_type",
                                                            "fast_reroute",
                                                            "frr_bandwidth_protection",
                                                            "hold_priority",
                                                            "is_affinity_configured",
                                                            "is_bandwidth_configured",
                                                            "is_priority_configured",
                                                            "setup_priority") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2mpte"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.configured_bandwidth.is_set or
                                                self.dste_class_type.is_set or
                                                self.fast_reroute.is_set or
                                                self.frr_bandwidth_protection.is_set or
                                                self.hold_priority.is_set or
                                                self.is_affinity_configured.is_set or
                                                self.is_bandwidth_configured.is_set or
                                                self.is_priority_configured.is_set or
                                                self.setup_priority.is_set or
                                                (self.affinity is not None and self.affinity.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.configured_bandwidth.yfilter != YFilter.not_set or
                                                self.dste_class_type.yfilter != YFilter.not_set or
                                                self.fast_reroute.yfilter != YFilter.not_set or
                                                self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                                self.hold_priority.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                                self.is_priority_configured.yfilter != YFilter.not_set or
                                                self.setup_priority.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2mpte" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                            if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                            if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                            if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                            if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                            if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                            if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "configured-bandwidth"):
                                                self.configured_bandwidth = value
                                                self.configured_bandwidth.value_namespace = name_space
                                                self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                            if(value_path == "dste-class-type"):
                                                self.dste_class_type = value
                                                self.dste_class_type.value_namespace = name_space
                                                self.dste_class_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fast-reroute"):
                                                self.fast_reroute = value
                                                self.fast_reroute.value_namespace = name_space
                                                self.fast_reroute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "frr-bandwidth-protection"):
                                                self.frr_bandwidth_protection = value
                                                self.frr_bandwidth_protection.value_namespace = name_space
                                                self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "hold-priority"):
                                                self.hold_priority = value
                                                self.hold_priority.value_namespace = name_space
                                                self.hold_priority.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-bandwidth-configured"):
                                                self.is_bandwidth_configured = value
                                                self.is_bandwidth_configured.value_namespace = name_space
                                                self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-priority-configured"):
                                                self.is_priority_configured = value
                                                self.is_priority_configured.value_namespace = name_space
                                                self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "setup-priority"):
                                                self.setup_priority = value
                                                self.setup_priority.value_namespace = name_space
                                                self.setup_priority.value_namespace_prefix = name_space_prefix


                                    class AttributeSetApsPp(Entity):
                                        """
                                        Attribute Set OTN APS Path Protection
                                        
                                        .. attribute:: hold_off_time
                                        
                                        	Hold\-off time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_prot_profile_type
                                        
                                        	Path Protection Profile Type
                                        	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                        
                                        .. attribute:: protection_mode
                                        
                                        	Protection Restoration Mode
                                        	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                        
                                        .. attribute:: protection_type
                                        
                                        	Protection Type
                                        	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                        
                                        .. attribute:: restoration_style
                                        
                                        	Restoration Style
                                        	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                        
                                        .. attribute:: revert_schedule
                                        
                                        	Revert Schedule
                                        	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                        
                                        .. attribute:: snc_mode
                                        
                                        	Sub\-network Connection Mode
                                        	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                        
                                        .. attribute:: tcm_id
                                        
                                        	Sub\-network Connection Monitoring Mode
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: wait_to_restore_time
                                        
                                        	Wait to restore time
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                            self.yang_name = "attribute-set-aps-pp"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                            self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                            self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                            self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                            self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                            self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                            self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                            self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                            self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                            self.revert_schedule.parent = self
                                            self._children_name_map["revert_schedule"] = "revert-schedule"
                                            self._children_yang_names.add("revert-schedule")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("hold_off_time",
                                                            "path_prot_profile_type",
                                                            "protection_mode",
                                                            "protection_type",
                                                            "restoration_style",
                                                            "snc_mode",
                                                            "tcm_id",
                                                            "wait_to_restore_time") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                                        class RevertSchedule(Entity):
                                            """
                                            Revert Schedule
                                            
                                            .. attribute:: duration
                                            
                                            	Duration for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: max_tries
                                            
                                            	Max tries for scheduled reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_date
                                            
                                            	Schedule time for reversion
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: schedule_frequency
                                            
                                            	Schedule frequency for reversion
                                            	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                            
                                            .. attribute:: schedulename
                                            
                                            	Schedule name identifier
                                            	**type**\:  str
                                            
                                            	**length:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                                self.yang_name = "revert-schedule"
                                                self.yang_parent_name = "attribute-set-aps-pp"

                                                self.duration = YLeaf(YType.uint32, "duration")

                                                self.max_tries = YLeaf(YType.uint32, "max-tries")

                                                self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                                self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                                self.schedulename = YLeaf(YType.str, "schedulename")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("duration",
                                                                "max_tries",
                                                                "schedule_date",
                                                                "schedule_frequency",
                                                                "schedulename") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.duration.is_set or
                                                    self.max_tries.is_set or
                                                    self.schedule_date.is_set or
                                                    self.schedule_frequency.is_set or
                                                    self.schedulename.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.duration.yfilter != YFilter.not_set or
                                                    self.max_tries.yfilter != YFilter.not_set or
                                                    self.schedule_date.yfilter != YFilter.not_set or
                                                    self.schedule_frequency.yfilter != YFilter.not_set or
                                                    self.schedulename.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "revert-schedule" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.duration.get_name_leafdata())
                                                if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.max_tries.get_name_leafdata())
                                                if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                                if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                                if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.schedulename.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "duration"):
                                                    self.duration = value
                                                    self.duration.value_namespace = name_space
                                                    self.duration.value_namespace_prefix = name_space_prefix
                                                if(value_path == "max-tries"):
                                                    self.max_tries = value
                                                    self.max_tries.value_namespace = name_space
                                                    self.max_tries.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-date"):
                                                    self.schedule_date = value
                                                    self.schedule_date.value_namespace = name_space
                                                    self.schedule_date.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedule-frequency"):
                                                    self.schedule_frequency = value
                                                    self.schedule_frequency.value_namespace = name_space
                                                    self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                                if(value_path == "schedulename"):
                                                    self.schedulename = value
                                                    self.schedulename.value_namespace = name_space
                                                    self.schedulename.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.hold_off_time.is_set or
                                                self.path_prot_profile_type.is_set or
                                                self.protection_mode.is_set or
                                                self.protection_type.is_set or
                                                self.restoration_style.is_set or
                                                self.snc_mode.is_set or
                                                self.tcm_id.is_set or
                                                self.wait_to_restore_time.is_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.hold_off_time.yfilter != YFilter.not_set or
                                                self.path_prot_profile_type.yfilter != YFilter.not_set or
                                                self.protection_mode.yfilter != YFilter.not_set or
                                                self.protection_type.yfilter != YFilter.not_set or
                                                self.restoration_style.yfilter != YFilter.not_set or
                                                self.snc_mode.yfilter != YFilter.not_set or
                                                self.tcm_id.yfilter != YFilter.not_set or
                                                self.wait_to_restore_time.yfilter != YFilter.not_set or
                                                (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-aps-pp" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                            if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                            if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                            if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protection_type.get_name_leafdata())
                                            if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                            if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                            if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                            if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "revert-schedule"):
                                                if (self.revert_schedule is None):
                                                    self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                                    self.revert_schedule.parent = self
                                                    self._children_name_map["revert_schedule"] = "revert-schedule"
                                                return self.revert_schedule

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "hold-off-time"):
                                                self.hold_off_time = value
                                                self.hold_off_time.value_namespace = name_space
                                                self.hold_off_time.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-prot-profile-type"):
                                                self.path_prot_profile_type = value
                                                self.path_prot_profile_type.value_namespace = name_space
                                                self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-mode"):
                                                self.protection_mode = value
                                                self.protection_mode.value_namespace = name_space
                                                self.protection_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protection-type"):
                                                self.protection_type = value
                                                self.protection_type.value_namespace = name_space
                                                self.protection_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "restoration-style"):
                                                self.restoration_style = value
                                                self.restoration_style.value_namespace = name_space
                                                self.restoration_style.value_namespace_prefix = name_space_prefix
                                            if(value_path == "snc-mode"):
                                                self.snc_mode = value
                                                self.snc_mode.value_namespace = name_space
                                                self.snc_mode.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tcm-id"):
                                                self.tcm_id = value
                                                self.tcm_id.value_namespace = name_space
                                                self.tcm_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "wait-to-restore-time"):
                                                self.wait_to_restore_time = value
                                                self.wait_to_restore_time.value_namespace = name_space
                                                self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                                    class AttributeSetP2PTe(Entity):
                                        """
                                        MPLS TE P2P\-TE Attribute Set
                                        
                                        .. attribute:: affinity
                                        
                                        	Affinity
                                        	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                                        
                                        .. attribute:: is_affinity_configured
                                        
                                        	Is affinity configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_action_configured
                                        
                                        	Is Path Invalidation action configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_invalidation_timeout_configured
                                        
                                        	Is Path Invalidation timeout configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_select_configured
                                        
                                        	Is any of the path selection parameters configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_metric_configured
                                        
                                        	Is path selection metric configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                        
                                        	Is path selection segment routing configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_configured
                                        
                                        	Is path selection margin configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_margin_relative
                                        
                                        	Path selection margin is\_relative
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_configured
                                        
                                        	Is PCE Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_group_id_configured
                                        
                                        	Is PCE Disjoint Path Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_source_configured
                                        
                                        	Is PCE Disjoint Path Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pce_disj_type_configured
                                        
                                        	Is PCE Disjoint Path Type Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pceb_dj_source_configured
                                        
                                        	Is PCE Bidirectional Source Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_pcebd_group_id_configured
                                        
                                        	Is PCE Bidirectional Group ID Configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: is_prepend_list_configured
                                        
                                        	Is SR prepend list configured
                                        	**type**\:  bool
                                        
                                        .. attribute:: logging
                                        
                                        	Logging attributes
                                        	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                                        
                                        .. attribute:: path_invalidation_timeout
                                        
                                        	Path invalidation timeout on the tunnel path
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_invalidation_action
                                        
                                        	Path invalidation action
                                        	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                        
                                        .. attribute:: path_selection_metric
                                        
                                        	Path selection metric type
                                        	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                        
                                        .. attribute:: path_selection_segment_routing_adjacency_protection
                                        
                                        	Path selection segment\-routing type
                                        	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                                        
                                        .. attribute:: path_selection_segment_routing_margin
                                        
                                        	Path selection margin
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_selection_segment_routing_segment_limit
                                        
                                        	Is path selection segment limit configured
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_group_id
                                        
                                        	PCE Bidirectional Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcebd_source_address
                                        
                                        	PCE Bidirectional Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_group_id
                                        
                                        	PCE Disjoint Path Group ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_source_address
                                        
                                        	PCE Disjoint Path Source Address
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: pcedp_type
                                        
                                        	PCE Disjoint Path Type
                                        	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                        
                                        .. attribute:: prepend_list
                                        
                                        	SR prepend list
                                        	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                                        
                                        .. attribute:: tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                            self.yang_name = "attribute-set-p2p-te"
                                            self.yang_parent_name = "attribute-set-union"

                                            self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                            self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                            self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                            self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                            self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                            self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                            self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                            self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                            self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                            self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                            self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                            self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                            self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                            self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                            self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                            self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                            self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                            self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                            self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                            self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                            self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                            self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                            self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                            self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                            self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                            self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                            self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                            self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                            self.affinity.parent = self
                                            self._children_name_map["affinity"] = "affinity"
                                            self._children_yang_names.add("affinity")

                                            self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                            self.logging.parent = self
                                            self._children_name_map["logging"] = "logging"
                                            self._children_yang_names.add("logging")

                                            self.prepend_list = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                            self.prepend_list.parent = self
                                            self._children_name_map["prepend_list"] = "prepend-list"
                                            self._children_yang_names.add("prepend-list")

                                            self.tunnel_id = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_affinity_configured",
                                                            "is_path_invalidation_action_configured",
                                                            "is_path_invalidation_timeout_configured",
                                                            "is_path_select_configured",
                                                            "is_path_selection_metric_configured",
                                                            "is_path_selection_segment_routing_adjacency_protection_configured",
                                                            "is_path_selection_segment_routing_margin_configured",
                                                            "is_path_selection_segment_routing_margin_relative",
                                                            "is_path_selection_segment_routing_segment_limit_configured",
                                                            "is_pce_configured",
                                                            "is_pce_disj_group_id_configured",
                                                            "is_pce_disj_source_configured",
                                                            "is_pce_disj_type_configured",
                                                            "is_pceb_dj_source_configured",
                                                            "is_pcebd_group_id_configured",
                                                            "is_prepend_list_configured",
                                                            "path_invalidation_timeout",
                                                            "path_selection_invalidation_action",
                                                            "path_selection_metric",
                                                            "path_selection_segment_routing_adjacency_protection",
                                                            "path_selection_segment_routing_margin",
                                                            "path_selection_segment_routing_segment_limit",
                                                            "pcebd_group_id",
                                                            "pcebd_source_address",
                                                            "pcedp_group_id",
                                                            "pcedp_source_address",
                                                            "pcedp_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                                        class Affinity(Entity):
                                            """
                                            Affinity
                                            
                                            .. attribute:: affinity_bits
                                            
                                            	The affinity bits (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: affinity_mask
                                            
                                            	The affinity mask (colors)
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: named_affinity
                                            
                                            	Array of name based constratints currently applied to the tunnel
                                            	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                                self.yang_name = "affinity"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                                self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                                self.named_affinity = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("affinity_bits",
                                                                "affinity_mask") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                            class NamedAffinity(Entity):
                                                """
                                                Array of name based constratints currently
                                                applied to the tunnel
                                                
                                                .. attribute:: constraint_extended_value
                                                
                                                	Constraint value
                                                	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                                
                                                .. attribute:: constraint_type
                                                
                                                	Constraint type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: constraint_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: extended_forward_ref_value
                                                
                                                	Reference bits for undefined affinity names
                                                	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                                
                                                .. attribute:: forward_ref_value
                                                
                                                	Deprecated
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                                    self.yang_name = "named-affinity"
                                                    self.yang_parent_name = "affinity"

                                                    self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                    self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                    self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                    self.constraint_extended_value = YList(self)
                                                    self.extended_forward_ref_value = YList(self)

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("constraint_type",
                                                                    "constraint_value",
                                                                    "forward_ref_value") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                                class ConstraintExtendedValue(Entity):
                                                    """
                                                    Constraint value
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                        self.yang_name = "constraint-extended-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "constraint-extended-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix


                                                class ExtendedForwardRefValue(Entity):
                                                    """
                                                    Reference bits for undefined affinity names
                                                    
                                                    .. attribute:: entry
                                                    
                                                    	
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                        self.yang_name = "extended-forward-ref-value"
                                                        self.yang_parent_name = "named-affinity"

                                                        self.entry = YLeaf(YType.uint32, "entry")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("entry") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                    def has_data(self):
                                                        return self.entry.is_set

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.entry.yfilter != YFilter.not_set)

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "extended-forward-ref-value" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "entry"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "entry"):
                                                            self.entry = value
                                                            self.entry.value_namespace = name_space
                                                            self.entry.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_data()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_data()):
                                                            return True
                                                    return (
                                                        self.constraint_type.is_set or
                                                        self.constraint_value.is_set or
                                                        self.forward_ref_value.is_set)

                                                def has_operation(self):
                                                    for c in self.constraint_extended_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    for c in self.extended_forward_ref_value:
                                                        if (c.has_operation()):
                                                            return True
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.constraint_type.yfilter != YFilter.not_set or
                                                        self.constraint_value.yfilter != YFilter.not_set or
                                                        self.forward_ref_value.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "named-affinity" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                    if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                    if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "constraint-extended-value"):
                                                        for c in self.constraint_extended_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.constraint_extended_value.append(c)
                                                        return c

                                                    if (child_yang_name == "extended-forward-ref-value"):
                                                        for c in self.extended_forward_ref_value:
                                                            segment = c.get_segment_path()
                                                            if (segment_path == segment):
                                                                return c
                                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                        c.parent = self
                                                        local_reference_key = "ydk::seg::%s" % segment_path
                                                        self._local_refs[local_reference_key] = c
                                                        self.extended_forward_ref_value.append(c)
                                                        return c

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "constraint-type"):
                                                        self.constraint_type = value
                                                        self.constraint_type.value_namespace = name_space
                                                        self.constraint_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "constraint-value"):
                                                        self.constraint_value = value
                                                        self.constraint_value.value_namespace = name_space
                                                        self.constraint_value.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "forward-ref-value"):
                                                        self.forward_ref_value = value
                                                        self.forward_ref_value.value_namespace = name_space
                                                        self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.named_affinity:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.affinity_bits.is_set or
                                                    self.affinity_mask.is_set)

                                            def has_operation(self):
                                                for c in self.named_affinity:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.affinity_bits.yfilter != YFilter.not_set or
                                                    self.affinity_mask.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                                if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "named-affinity"):
                                                    for c in self.named_affinity:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.named_affinity.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "affinity-bits"):
                                                    self.affinity_bits = value
                                                    self.affinity_bits.value_namespace = name_space
                                                    self.affinity_bits.value_namespace_prefix = name_space_prefix
                                                if(value_path == "affinity-mask"):
                                                    self.affinity_mask = value
                                                    self.affinity_mask.value_namespace = name_space
                                                    self.affinity_mask.value_namespace_prefix = name_space_prefix


                                        class Logging(Entity):
                                            """
                                            Logging attributes
                                            
                                            .. attribute:: all_logging_enabled
                                            
                                            	All logging option\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_bandwidth_change
                                            
                                            	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_insufficient_bw
                                            
                                            	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_pcalc_failure_logging_enabled
                                            
                                            	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_opt
                                            
                                            	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_re_route
                                            
                                            	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: lsp_state
                                            
                                            	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            .. attribute:: s2l_state
                                            
                                            	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                                self.yang_name = "logging"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                                self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                                self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                                self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                                self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                                self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                                self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                                self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("all_logging_enabled",
                                                                "lsp_bandwidth_change",
                                                                "lsp_insufficient_bw",
                                                                "lsp_pcalc_failure_logging_enabled",
                                                                "lsp_re_opt",
                                                                "lsp_re_route",
                                                                "lsp_state",
                                                                "s2l_state") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.all_logging_enabled.is_set or
                                                    self.lsp_bandwidth_change.is_set or
                                                    self.lsp_insufficient_bw.is_set or
                                                    self.lsp_pcalc_failure_logging_enabled.is_set or
                                                    self.lsp_re_opt.is_set or
                                                    self.lsp_re_route.is_set or
                                                    self.lsp_state.is_set or
                                                    self.s2l_state.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.all_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                    self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                    self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                    self.lsp_re_opt.yfilter != YFilter.not_set or
                                                    self.lsp_re_route.yfilter != YFilter.not_set or
                                                    self.lsp_state.yfilter != YFilter.not_set or
                                                    self.s2l_state.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "logging" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                                if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                                if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                                if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                                if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                                if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                                if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                                if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "all-logging-enabled"):
                                                    self.all_logging_enabled = value
                                                    self.all_logging_enabled.value_namespace = name_space
                                                    self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-bandwidth-change"):
                                                    self.lsp_bandwidth_change = value
                                                    self.lsp_bandwidth_change.value_namespace = name_space
                                                    self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-insufficient-bw"):
                                                    self.lsp_insufficient_bw = value
                                                    self.lsp_insufficient_bw.value_namespace = name_space
                                                    self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                    self.lsp_pcalc_failure_logging_enabled = value
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                    self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-opt"):
                                                    self.lsp_re_opt = value
                                                    self.lsp_re_opt.value_namespace = name_space
                                                    self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-re-route"):
                                                    self.lsp_re_route = value
                                                    self.lsp_re_route.value_namespace = name_space
                                                    self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                                if(value_path == "lsp-state"):
                                                    self.lsp_state = value
                                                    self.lsp_state.value_namespace = name_space
                                                    self.lsp_state.value_namespace_prefix = name_space_prefix
                                                if(value_path == "s2l-state"):
                                                    self.s2l_state = value
                                                    self.s2l_state.value_namespace = name_space
                                                    self.s2l_state.value_namespace_prefix = name_space_prefix


                                        class PrependList(Entity):
                                            """
                                            SR prepend list
                                            
                                            .. attribute:: prepend_entry
                                            
                                            	List of prepend entries
                                            	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                                self.yang_name = "prepend-list"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.prepend_entry = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in () and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                            class PrependEntry(Entity):
                                                """
                                                List of prepend entries
                                                
                                                .. attribute:: index
                                                
                                                	Prepend index
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: next_label
                                                
                                                	Prepend next label
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: type
                                                
                                                	Prepend Type
                                                	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                                    self.yang_name = "prepend-entry"
                                                    self.yang_parent_name = "prepend-list"

                                                    self.index = YLeaf(YType.uint32, "index")

                                                    self.next_label = YLeaf(YType.uint32, "next-label")

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("index",
                                                                    "next_label",
                                                                    "type") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.index.is_set or
                                                        self.next_label.is_set or
                                                        self.type.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.index.yfilter != YFilter.not_set or
                                                        self.next_label.yfilter != YFilter.not_set or
                                                        self.type.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "prepend-entry" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.index.get_name_leafdata())
                                                    if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.next_label.get_name_leafdata())
                                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.type.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "index" or name == "next-label" or name == "type"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "index"):
                                                        self.index = value
                                                        self.index.value_namespace = name_space
                                                        self.index.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "next-label"):
                                                        self.next_label = value
                                                        self.next_label.value_namespace = name_space
                                                        self.next_label.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "type"):
                                                        self.type = value
                                                        self.type.value_namespace = name_space
                                                        self.type.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_data()):
                                                        return True
                                                return False

                                            def has_operation(self):
                                                for c in self.prepend_entry:
                                                    if (c.has_operation()):
                                                        return True
                                                return self.yfilter != YFilter.not_set

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prepend-list" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "prepend-entry"):
                                                    for c in self.prepend_entry:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.prepend_entry.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "prepend-entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                pass


                                        class TunnelId(Entity):
                                            """
                                            Tunnel ID
                                            
                                            .. attribute:: entry
                                            
                                            	
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                                self.yang_name = "tunnel-id"
                                                self.yang_parent_name = "attribute-set-p2p-te"

                                                self.entry = YLeaf(YType.uint16, "entry")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("entry") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                            def has_data(self):
                                                return self.entry.is_set

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.entry.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "tunnel-id" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "entry"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "entry"):
                                                    self.entry = value
                                                    self.entry.value_namespace = name_space
                                                    self.entry.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.tunnel_id:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.is_affinity_configured.is_set or
                                                self.is_path_invalidation_action_configured.is_set or
                                                self.is_path_invalidation_timeout_configured.is_set or
                                                self.is_path_select_configured.is_set or
                                                self.is_path_selection_metric_configured.is_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_configured.is_set or
                                                self.is_path_selection_segment_routing_margin_relative.is_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                                self.is_pce_configured.is_set or
                                                self.is_pce_disj_group_id_configured.is_set or
                                                self.is_pce_disj_source_configured.is_set or
                                                self.is_pce_disj_type_configured.is_set or
                                                self.is_pceb_dj_source_configured.is_set or
                                                self.is_pcebd_group_id_configured.is_set or
                                                self.is_prepend_list_configured.is_set or
                                                self.path_invalidation_timeout.is_set or
                                                self.path_selection_invalidation_action.is_set or
                                                self.path_selection_metric.is_set or
                                                self.path_selection_segment_routing_adjacency_protection.is_set or
                                                self.path_selection_segment_routing_margin.is_set or
                                                self.path_selection_segment_routing_segment_limit.is_set or
                                                self.pcebd_group_id.is_set or
                                                self.pcebd_source_address.is_set or
                                                self.pcedp_group_id.is_set or
                                                self.pcedp_source_address.is_set or
                                                self.pcedp_type.is_set or
                                                (self.affinity is not None and self.affinity.has_data()) or
                                                (self.logging is not None and self.logging.has_data()) or
                                                (self.prepend_list is not None and self.prepend_list.has_data()))

                                        def has_operation(self):
                                            for c in self.tunnel_id:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_affinity_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                                self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                                self.is_path_select_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                                self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                                self.is_pce_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                                self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                                self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                                self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                                self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                                self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                                self.path_selection_metric.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                                self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                                self.pcebd_group_id.yfilter != YFilter.not_set or
                                                self.pcebd_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_group_id.yfilter != YFilter.not_set or
                                                self.pcedp_source_address.yfilter != YFilter.not_set or
                                                self.pcedp_type.yfilter != YFilter.not_set or
                                                (self.affinity is not None and self.affinity.has_operation()) or
                                                (self.logging is not None and self.logging.has_operation()) or
                                                (self.prepend_list is not None and self.prepend_list.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "attribute-set-p2p-te" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                            if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                            if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                            if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                            if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                            if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                            if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                            if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                            if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                            if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                            if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                            if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                            if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                            if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                            if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                            if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                            if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                            if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                            if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                            if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                            if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                            if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                            if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "affinity"):
                                                if (self.affinity is None):
                                                    self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                                    self.affinity.parent = self
                                                    self._children_name_map["affinity"] = "affinity"
                                                return self.affinity

                                            if (child_yang_name == "logging"):
                                                if (self.logging is None):
                                                    self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                                    self.logging.parent = self
                                                    self._children_name_map["logging"] = "logging"
                                                return self.logging

                                            if (child_yang_name == "prepend-list"):
                                                if (self.prepend_list is None):
                                                    self.prepend_list = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                                    self.prepend_list.parent = self
                                                    self._children_name_map["prepend_list"] = "prepend-list"
                                                return self.prepend_list

                                            if (child_yang_name == "tunnel-id"):
                                                for c in self.tunnel_id:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.tunnel_id.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-affinity-configured"):
                                                self.is_affinity_configured = value
                                                self.is_affinity_configured.value_namespace = name_space
                                                self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-action-configured"):
                                                self.is_path_invalidation_action_configured = value
                                                self.is_path_invalidation_action_configured.value_namespace = name_space
                                                self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-invalidation-timeout-configured"):
                                                self.is_path_invalidation_timeout_configured = value
                                                self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                                self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-select-configured"):
                                                self.is_path_select_configured = value
                                                self.is_path_select_configured.value_namespace = name_space
                                                self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-metric-configured"):
                                                self.is_path_selection_metric_configured = value
                                                self.is_path_selection_metric_configured.value_namespace = name_space
                                                self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                                self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                                self.is_path_selection_segment_routing_margin_configured = value
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                                self.is_path_selection_segment_routing_margin_relative = value
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                                self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                                self.is_path_selection_segment_routing_segment_limit_configured = value
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                                self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-configured"):
                                                self.is_pce_configured = value
                                                self.is_pce_configured.value_namespace = name_space
                                                self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-group-id-configured"):
                                                self.is_pce_disj_group_id_configured = value
                                                self.is_pce_disj_group_id_configured.value_namespace = name_space
                                                self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-source-configured"):
                                                self.is_pce_disj_source_configured = value
                                                self.is_pce_disj_source_configured.value_namespace = name_space
                                                self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pce-disj-type-configured"):
                                                self.is_pce_disj_type_configured = value
                                                self.is_pce_disj_type_configured.value_namespace = name_space
                                                self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pceb-dj-source-configured"):
                                                self.is_pceb_dj_source_configured = value
                                                self.is_pceb_dj_source_configured.value_namespace = name_space
                                                self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-pcebd-group-id-configured"):
                                                self.is_pcebd_group_id_configured = value
                                                self.is_pcebd_group_id_configured.value_namespace = name_space
                                                self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-prepend-list-configured"):
                                                self.is_prepend_list_configured = value
                                                self.is_prepend_list_configured.value_namespace = name_space
                                                self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-invalidation-timeout"):
                                                self.path_invalidation_timeout = value
                                                self.path_invalidation_timeout.value_namespace = name_space
                                                self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-invalidation-action"):
                                                self.path_selection_invalidation_action = value
                                                self.path_selection_invalidation_action.value_namespace = name_space
                                                self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-metric"):
                                                self.path_selection_metric = value
                                                self.path_selection_metric.value_namespace = name_space
                                                self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                                self.path_selection_segment_routing_adjacency_protection = value
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                                self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-margin"):
                                                self.path_selection_segment_routing_margin = value
                                                self.path_selection_segment_routing_margin.value_namespace = name_space
                                                self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-selection-segment-routing-segment-limit"):
                                                self.path_selection_segment_routing_segment_limit = value
                                                self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                                self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-group-id"):
                                                self.pcebd_group_id = value
                                                self.pcebd_group_id.value_namespace = name_space
                                                self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcebd-source-address"):
                                                self.pcebd_source_address = value
                                                self.pcebd_source_address.value_namespace = name_space
                                                self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-group-id"):
                                                self.pcedp_group_id = value
                                                self.pcedp_group_id.value_namespace = name_space
                                                self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-source-address"):
                                                self.pcedp_source_address = value
                                                self.pcedp_source_address.value_namespace = name_space
                                                self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "pcedp-type"):
                                                self.pcedp_type = value
                                                self.pcedp_type.value_namespace = name_space
                                                self.pcedp_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.tunnel_attribute_set_type.is_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                            (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                            (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                            (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                            (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                            (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                            (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                            (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-union" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "attribute-set-aps-pp"):
                                            if (self.attribute_set_aps_pp is None):
                                                self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                                self.attribute_set_aps_pp.parent = self
                                                self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                            return self.attribute_set_aps_pp

                                        if (child_yang_name == "attribute-set-autobackup"):
                                            if (self.attribute_set_autobackup is None):
                                                self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                                self.attribute_set_autobackup.parent = self
                                                self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                            return self.attribute_set_autobackup

                                        if (child_yang_name == "attribute-set-automesh"):
                                            if (self.attribute_set_automesh is None):
                                                self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                                self.attribute_set_automesh.parent = self
                                                self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                            return self.attribute_set_automesh

                                        if (child_yang_name == "attribute-set-p2mpte"):
                                            if (self.attribute_set_p2mpte is None):
                                                self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                                self.attribute_set_p2mpte.parent = self
                                                self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                            return self.attribute_set_p2mpte

                                        if (child_yang_name == "attribute-set-p2p-te"):
                                            if (self.attribute_set_p2p_te is None):
                                                self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                                self.attribute_set_p2p_te.parent = self
                                                self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                            return self.attribute_set_p2p_te

                                        if (child_yang_name == "attribute-set-path-option"):
                                            if (self.attribute_set_path_option is None):
                                                self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                                self.attribute_set_path_option.parent = self
                                                self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                            return self.attribute_set_path_option

                                        if (child_yang_name == "attribute-set-xro"):
                                            if (self.attribute_set_xro is None):
                                                self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                                self.attribute_set_xro.parent = self
                                                self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                            return self.attribute_set_xro

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "tunnel-attribute-set-type"):
                                            self.tunnel_attribute_set_type = value
                                            self.tunnel_attribute_set_type.value_namespace = name_space
                                            self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.tunnel_attribute_set_name.is_set or
                                        self.tunnel_attribute_set_name_crc32.is_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                                        (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-attribute-set" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                                    if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "attribute-set-union"):
                                        if (self.attribute_set_union is None):
                                            self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet.AttributeSetUnion()
                                            self.attribute_set_union.parent = self
                                            self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                        return self.attribute_set_union

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "tunnel-attribute-set-name"):
                                        self.tunnel_attribute_set_name = value
                                        self.tunnel_attribute_set_name.value_namespace = name_space
                                        self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-attribute-set-name-crc32"):
                                        self.tunnel_attribute_set_name_crc32 = value
                                        self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                                        self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                            class PathCalculationError(Entity):
                                """
                                Path computation information
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.PathCalculationError, self).__init__()

                                    self.yang_name = "path-calculation-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error_message",
                                                    "log_time",
                                                    "lsp_mode") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.PathCalculationError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.PathCalculationError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error_message.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-calculation-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix


                            class RemergeError(Entity):
                                """
                                Path computation remerge resolve info
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: log_time
                                
                                	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSP Mode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.RemergeError, self).__init__()

                                    self.yang_name = "remerge-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error_message",
                                                    "log_time",
                                                    "lsp_mode") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.RemergeError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.RemergeError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error_message.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "remerge-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix


                            class SignallingError(Entity):
                                """
                                Signalling information
                                
                                .. attribute:: error
                                
                                	Path Error code
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: error_message
                                
                                	Error message (for display purposes only)
                                	**type**\:  str
                                
                                .. attribute:: error_node
                                
                                	Source address of the error generating node
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: log_time
                                
                                	Time in seconds when the error message is logged
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                .. attribute:: lsp_mode
                                
                                	LSPMode
                                	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                                
                                .. attribute:: reverse_lsp
                                
                                	Indicates if error is on the reverse LSP
                                	**type**\:  bool
                                
                                .. attribute:: signalling_lsp_id
                                
                                	LSP\-id for which the error was received
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: sub_code
                                
                                	Path Error subcode
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.SignallingError, self).__init__()

                                    self.yang_name = "signalling-error"
                                    self.yang_parent_name = "active-path-option"

                                    self.error = YLeaf(YType.uint8, "error")

                                    self.error_message = YLeaf(YType.str, "error-message")

                                    self.error_node = YLeaf(YType.uint32, "error-node")

                                    self.log_time = YLeaf(YType.uint32, "log-time")

                                    self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                    self.reverse_lsp = YLeaf(YType.boolean, "reverse-lsp")

                                    self.signalling_lsp_id = YLeaf(YType.uint16, "signalling-lsp-id")

                                    self.sub_code = YLeaf(YType.uint16, "sub-code")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("error",
                                                    "error_message",
                                                    "error_node",
                                                    "log_time",
                                                    "lsp_mode",
                                                    "reverse_lsp",
                                                    "signalling_lsp_id",
                                                    "sub_code") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.SignallingError, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.SignallingError, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.error.is_set or
                                        self.error_message.is_set or
                                        self.error_node.is_set or
                                        self.log_time.is_set or
                                        self.lsp_mode.is_set or
                                        self.reverse_lsp.is_set or
                                        self.signalling_lsp_id.is_set or
                                        self.sub_code.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.error.yfilter != YFilter.not_set or
                                        self.error_message.yfilter != YFilter.not_set or
                                        self.error_node.yfilter != YFilter.not_set or
                                        self.log_time.yfilter != YFilter.not_set or
                                        self.lsp_mode.yfilter != YFilter.not_set or
                                        self.reverse_lsp.yfilter != YFilter.not_set or
                                        self.signalling_lsp_id.yfilter != YFilter.not_set or
                                        self.sub_code.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "signalling-error" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.error.is_set or self.error.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error.get_name_leafdata())
                                    if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_message.get_name_leafdata())
                                    if (self.error_node.is_set or self.error_node.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.error_node.get_name_leafdata())
                                    if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.log_time.get_name_leafdata())
                                    if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_mode.get_name_leafdata())
                                    if (self.reverse_lsp.is_set or self.reverse_lsp.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.reverse_lsp.get_name_leafdata())
                                    if (self.signalling_lsp_id.is_set or self.signalling_lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signalling_lsp_id.get_name_leafdata())
                                    if (self.sub_code.is_set or self.sub_code.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.sub_code.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "error" or name == "error-message" or name == "error-node" or name == "log-time" or name == "lsp-mode" or name == "reverse-lsp" or name == "signalling-lsp-id" or name == "sub-code"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "error"):
                                        self.error = value
                                        self.error.value_namespace = name_space
                                        self.error.value_namespace_prefix = name_space_prefix
                                    if(value_path == "error-message"):
                                        self.error_message = value
                                        self.error_message.value_namespace = name_space
                                        self.error_message.value_namespace_prefix = name_space_prefix
                                    if(value_path == "error-node"):
                                        self.error_node = value
                                        self.error_node.value_namespace = name_space
                                        self.error_node.value_namespace_prefix = name_space_prefix
                                    if(value_path == "log-time"):
                                        self.log_time = value
                                        self.log_time.value_namespace = name_space
                                        self.log_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-mode"):
                                        self.lsp_mode = value
                                        self.lsp_mode.value_namespace = name_space
                                        self.lsp_mode.value_namespace_prefix = name_space_prefix
                                    if(value_path == "reverse-lsp"):
                                        self.reverse_lsp = value
                                        self.reverse_lsp.value_namespace = name_space
                                        self.reverse_lsp.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signalling-lsp-id"):
                                        self.signalling_lsp_id = value
                                        self.signalling_lsp_id.value_namespace = name_space
                                        self.signalling_lsp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "sub-code"):
                                        self.sub_code = value
                                        self.sub_code.value_namespace = name_space
                                        self.sub_code.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.path_calculation_error:
                                    if (c.has_data()):
                                        return True
                                for c in self.remerge_error:
                                    if (c.has_data()):
                                        return True
                                for c in self.signalling_error:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.attribute_set_found.is_set or
                                    self.explicit_path_id.is_set or
                                    self.explicit_path_name.is_set or
                                    self.has_attribute_set.is_set or
                                    self.has_xro_attribute_set.is_set or
                                    self.holddown_duration.is_set or
                                    self.is_disabled.is_set or
                                    self.is_helddown.is_set or
                                    self.is_lockdown.is_set or
                                    self.is_segment_routing.is_set or
                                    self.is_strict_explicit_path.is_set or
                                    self.is_verbatim.is_set or
                                    self.option_index.is_set or
                                    self.option_index_is_valid.is_set or
                                    self.path_option_area_id.is_set or
                                    self.path_option_name.is_set or
                                    self.path_option_type.is_set or
                                    self.pce_address.is_set or
                                    self.protected_by_path_option_index.is_set or
                                    self.restored_from_path_option_index.is_set or
                                    self.xro_attribute_set_found.is_set or
                                    (self.attribute_set is not None and self.attribute_set.has_data()) or
                                    (self.xro_attribute_set is not None and self.xro_attribute_set.has_data()))

                            def has_operation(self):
                                for c in self.path_calculation_error:
                                    if (c.has_operation()):
                                        return True
                                for c in self.remerge_error:
                                    if (c.has_operation()):
                                        return True
                                for c in self.signalling_error:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.attribute_set_found.yfilter != YFilter.not_set or
                                    self.explicit_path_id.yfilter != YFilter.not_set or
                                    self.explicit_path_name.yfilter != YFilter.not_set or
                                    self.has_attribute_set.yfilter != YFilter.not_set or
                                    self.has_xro_attribute_set.yfilter != YFilter.not_set or
                                    self.holddown_duration.yfilter != YFilter.not_set or
                                    self.is_disabled.yfilter != YFilter.not_set or
                                    self.is_helddown.yfilter != YFilter.not_set or
                                    self.is_lockdown.yfilter != YFilter.not_set or
                                    self.is_segment_routing.yfilter != YFilter.not_set or
                                    self.is_strict_explicit_path.yfilter != YFilter.not_set or
                                    self.is_verbatim.yfilter != YFilter.not_set or
                                    self.option_index.yfilter != YFilter.not_set or
                                    self.option_index_is_valid.yfilter != YFilter.not_set or
                                    self.path_option_area_id.yfilter != YFilter.not_set or
                                    self.path_option_name.yfilter != YFilter.not_set or
                                    self.path_option_type.yfilter != YFilter.not_set or
                                    self.pce_address.yfilter != YFilter.not_set or
                                    self.protected_by_path_option_index.yfilter != YFilter.not_set or
                                    self.restored_from_path_option_index.yfilter != YFilter.not_set or
                                    self.xro_attribute_set_found.yfilter != YFilter.not_set or
                                    (self.attribute_set is not None and self.attribute_set.has_operation()) or
                                    (self.xro_attribute_set is not None and self.xro_attribute_set.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "active-path-option" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.attribute_set_found.is_set or self.attribute_set_found.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.attribute_set_found.get_name_leafdata())
                                if (self.explicit_path_id.is_set or self.explicit_path_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.explicit_path_id.get_name_leafdata())
                                if (self.explicit_path_name.is_set or self.explicit_path_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.explicit_path_name.get_name_leafdata())
                                if (self.has_attribute_set.is_set or self.has_attribute_set.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_attribute_set.get_name_leafdata())
                                if (self.has_xro_attribute_set.is_set or self.has_xro_attribute_set.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_xro_attribute_set.get_name_leafdata())
                                if (self.holddown_duration.is_set or self.holddown_duration.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.holddown_duration.get_name_leafdata())
                                if (self.is_disabled.is_set or self.is_disabled.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_disabled.get_name_leafdata())
                                if (self.is_helddown.is_set or self.is_helddown.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_helddown.get_name_leafdata())
                                if (self.is_lockdown.is_set or self.is_lockdown.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_lockdown.get_name_leafdata())
                                if (self.is_segment_routing.is_set or self.is_segment_routing.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_segment_routing.get_name_leafdata())
                                if (self.is_strict_explicit_path.is_set or self.is_strict_explicit_path.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_strict_explicit_path.get_name_leafdata())
                                if (self.is_verbatim.is_set or self.is_verbatim.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_verbatim.get_name_leafdata())
                                if (self.option_index.is_set or self.option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.option_index.get_name_leafdata())
                                if (self.option_index_is_valid.is_set or self.option_index_is_valid.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.option_index_is_valid.get_name_leafdata())
                                if (self.path_option_area_id.is_set or self.path_option_area_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_area_id.get_name_leafdata())
                                if (self.path_option_name.is_set or self.path_option_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_name.get_name_leafdata())
                                if (self.path_option_type.is_set or self.path_option_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_option_type.get_name_leafdata())
                                if (self.pce_address.is_set or self.pce_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pce_address.get_name_leafdata())
                                if (self.protected_by_path_option_index.is_set or self.protected_by_path_option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.protected_by_path_option_index.get_name_leafdata())
                                if (self.restored_from_path_option_index.is_set or self.restored_from_path_option_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.restored_from_path_option_index.get_name_leafdata())
                                if (self.xro_attribute_set_found.is_set or self.xro_attribute_set_found.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.xro_attribute_set_found.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "attribute-set"):
                                    if (self.attribute_set is None):
                                        self.attribute_set = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.AttributeSet()
                                        self.attribute_set.parent = self
                                        self._children_name_map["attribute_set"] = "attribute-set"
                                    return self.attribute_set

                                if (child_yang_name == "path-calculation-error"):
                                    for c in self.path_calculation_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.PathCalculationError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.path_calculation_error.append(c)
                                    return c

                                if (child_yang_name == "remerge-error"):
                                    for c in self.remerge_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.RemergeError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.remerge_error.append(c)
                                    return c

                                if (child_yang_name == "signalling-error"):
                                    for c in self.signalling_error:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.SignallingError()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.signalling_error.append(c)
                                    return c

                                if (child_yang_name == "xro-attribute-set"):
                                    if (self.xro_attribute_set is None):
                                        self.xro_attribute_set = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption.XroAttributeSet()
                                        self.xro_attribute_set.parent = self
                                        self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                                    return self.xro_attribute_set

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "attribute-set" or name == "path-calculation-error" or name == "remerge-error" or name == "signalling-error" or name == "xro-attribute-set" or name == "attribute-set-found" or name == "explicit-path-id" or name == "explicit-path-name" or name == "has-attribute-set" or name == "has-xro-attribute-set" or name == "holddown-duration" or name == "is-disabled" or name == "is-helddown" or name == "is-lockdown" or name == "is-segment-routing" or name == "is-strict-explicit-path" or name == "is-verbatim" or name == "option-index" or name == "option-index-is-valid" or name == "path-option-area-id" or name == "path-option-name" or name == "path-option-type" or name == "pce-address" or name == "protected-by-path-option-index" or name == "restored-from-path-option-index" or name == "xro-attribute-set-found"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "attribute-set-found"):
                                    self.attribute_set_found = value
                                    self.attribute_set_found.value_namespace = name_space
                                    self.attribute_set_found.value_namespace_prefix = name_space_prefix
                                if(value_path == "explicit-path-id"):
                                    self.explicit_path_id = value
                                    self.explicit_path_id.value_namespace = name_space
                                    self.explicit_path_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "explicit-path-name"):
                                    self.explicit_path_name = value
                                    self.explicit_path_name.value_namespace = name_space
                                    self.explicit_path_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-attribute-set"):
                                    self.has_attribute_set = value
                                    self.has_attribute_set.value_namespace = name_space
                                    self.has_attribute_set.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-xro-attribute-set"):
                                    self.has_xro_attribute_set = value
                                    self.has_xro_attribute_set.value_namespace = name_space
                                    self.has_xro_attribute_set.value_namespace_prefix = name_space_prefix
                                if(value_path == "holddown-duration"):
                                    self.holddown_duration = value
                                    self.holddown_duration.value_namespace = name_space
                                    self.holddown_duration.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-disabled"):
                                    self.is_disabled = value
                                    self.is_disabled.value_namespace = name_space
                                    self.is_disabled.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-helddown"):
                                    self.is_helddown = value
                                    self.is_helddown.value_namespace = name_space
                                    self.is_helddown.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-lockdown"):
                                    self.is_lockdown = value
                                    self.is_lockdown.value_namespace = name_space
                                    self.is_lockdown.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-segment-routing"):
                                    self.is_segment_routing = value
                                    self.is_segment_routing.value_namespace = name_space
                                    self.is_segment_routing.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-strict-explicit-path"):
                                    self.is_strict_explicit_path = value
                                    self.is_strict_explicit_path.value_namespace = name_space
                                    self.is_strict_explicit_path.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-verbatim"):
                                    self.is_verbatim = value
                                    self.is_verbatim.value_namespace = name_space
                                    self.is_verbatim.value_namespace_prefix = name_space_prefix
                                if(value_path == "option-index"):
                                    self.option_index = value
                                    self.option_index.value_namespace = name_space
                                    self.option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "option-index-is-valid"):
                                    self.option_index_is_valid = value
                                    self.option_index_is_valid.value_namespace = name_space
                                    self.option_index_is_valid.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-area-id"):
                                    self.path_option_area_id = value
                                    self.path_option_area_id.value_namespace = name_space
                                    self.path_option_area_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-name"):
                                    self.path_option_name = value
                                    self.path_option_name.value_namespace = name_space
                                    self.path_option_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-option-type"):
                                    self.path_option_type = value
                                    self.path_option_type.value_namespace = name_space
                                    self.path_option_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "pce-address"):
                                    self.pce_address = value
                                    self.pce_address.value_namespace = name_space
                                    self.pce_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "protected-by-path-option-index"):
                                    self.protected_by_path_option_index = value
                                    self.protected_by_path_option_index.value_namespace = name_space
                                    self.protected_by_path_option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "restored-from-path-option-index"):
                                    self.restored_from_path_option_index = value
                                    self.restored_from_path_option_index.value_namespace = name_space
                                    self.restored_from_path_option_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "xro-attribute-set-found"):
                                    self.xro_attribute_set_found = value
                                    self.xro_attribute_set_found.value_namespace = name_space
                                    self.xro_attribute_set_found.value_namespace_prefix = name_space_prefix


                        class OutXro(Entity):
                            """
                            Outgoing XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\:  bool
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro, self).__init__()

                                self.yang_name = "out-xro"
                                self.yang_parent_name = "s2l"

                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                self.xro_subobject = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro, self).__setattr__(name, value)


                            class XroSubobject(Entity):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.AsSubobject>`
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.Ipv4Subobject>`
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.Ipv6Subobject>`
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.LspSubobject>`
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.SrlgSubobject>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "out-xro"

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.as_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"
                                    self._children_yang_names.add("as-subobject")

                                    self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                    self._children_yang_names.add("ipv4-subobject")

                                    self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                    self._children_yang_names.add("ipv6-subobject")

                                    self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._children_yang_names.add("lsp-subobject")

                                    self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                    self._children_yang_names.add("srlg-subobject")

                                    self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                    self._children_yang_names.add("unnumbered-subobject")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject, self).__setattr__(name, value)


                                class Ipv4Subobject(Entity):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class Ipv6Subobject(Entity):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class UnnumberedSubobject(Entity):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("attribute",
                                                        "exclusion_type",
                                                        "interface_id",
                                                        "te_router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.interface_id.is_set or
                                            self.te_router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.interface_id.yfilter != YFilter.not_set or
                                            self.te_router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "unnumbered-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-id"):
                                            self.interface_id = value
                                            self.interface_id.value_namespace = name_space
                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "te-router-id"):
                                            self.te_router_id = value
                                            self.te_router_id.value_namespace = name_space
                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                class AsSubobject(Entity):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("as_number") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.as_number.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.as_number.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "as-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "as-number"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "as-number"):
                                            self.as_number = value
                                            self.as_number.value_namespace = name_space
                                            self.as_number.value_namespace_prefix = name_space_prefix


                                class SrlgSubobject(Entity):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("exclusion_type",
                                                        "srlg_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.exclusion_type.is_set or
                                            self.srlg_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.srlg_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srlg-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "exclusion-type" or name == "srlg-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "srlg-id"):
                                            self.srlg_id = value
                                            self.srlg_id.value_namespace = name_space
                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                class LspSubobject(Entity):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\:  bool
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                        self.fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._children_yang_names.add("fec")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("destination_node_exception",
                                                        "exclusion_type",
                                                        "ignore_lsp_id",
                                                        "penultimate_node_exception",
                                                        "processing_node_exception") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                    class Fec(Entity):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"

                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                            self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._children_yang_names.add("fec-destination-info")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("fec_extended_tunnel_id",
                                                            "fec_lsp_id",
                                                            "fec_source",
                                                            "fec_tunnel_id",
                                                            "fec_vrf") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                        class FecDestinationInfo(Entity):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"

                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("fec_ctype",
                                                                "fec_destination_p2mp_id",
                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.fec_ctype.is_set or
                                                    self.fec_destination_p2mp_id.is_set or
                                                    self.p2p_lsp_destination.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "fec-destination-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "fec-ctype"):
                                                    self.fec_ctype = value
                                                    self.fec_ctype.value_namespace = name_space
                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                if(value_path == "fec-destination-p2mp-id"):
                                                    self.fec_destination_p2mp_id = value
                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "p2p-lsp-destination"):
                                                    self.p2p_lsp_destination = value
                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.fec_extended_tunnel_id.is_set or
                                                self.fec_lsp_id.is_set or
                                                self.fec_source.is_set or
                                                self.fec_tunnel_id.is_set or
                                                self.fec_vrf.is_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                self.fec_source.yfilter != YFilter.not_set or
                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "fec" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "fec-destination-info"):
                                                if (self.fec_destination_info is None):
                                                    self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                    self.fec_destination_info.parent = self
                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                return self.fec_destination_info

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "fec-extended-tunnel-id"):
                                                self.fec_extended_tunnel_id = value
                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-lsp-id"):
                                                self.fec_lsp_id = value
                                                self.fec_lsp_id.value_namespace = name_space
                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-source"):
                                                self.fec_source = value
                                                self.fec_source.value_namespace = name_space
                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-tunnel-id"):
                                                self.fec_tunnel_id = value
                                                self.fec_tunnel_id.value_namespace = name_space
                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-vrf"):
                                                self.fec_vrf = value
                                                self.fec_vrf.value_namespace = name_space
                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.destination_node_exception.is_set or
                                            self.exclusion_type.is_set or
                                            self.ignore_lsp_id.is_set or
                                            self.penultimate_node_exception.is_set or
                                            self.processing_node_exception.is_set or
                                            (self.fec is not None and self.fec.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                            (self.fec is not None and self.fec.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "lsp-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "fec"):
                                            if (self.fec is None):
                                                self.fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.LspSubobject.Fec()
                                                self.fec.parent = self
                                                self._children_name_map["fec"] = "fec"
                                            return self.fec

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "destination-node-exception"):
                                            self.destination_node_exception = value
                                            self.destination_node_exception.value_namespace = name_space
                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ignore-lsp-id"):
                                            self.ignore_lsp_id = value
                                            self.ignore_lsp_id.value_namespace = name_space
                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "penultimate-node-exception"):
                                            self.penultimate_node_exception = value
                                            self.penultimate_node_exception.value_namespace = name_space
                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "processing-node-exception"):
                                            self.processing_node_exception = value
                                            self.processing_node_exception.value_namespace = name_space
                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.type.is_set or
                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "as-subobject"):
                                        if (self.as_subobject is None):
                                            self.as_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.AsSubobject()
                                            self.as_subobject.parent = self
                                            self._children_name_map["as_subobject"] = "as-subobject"
                                        return self.as_subobject

                                    if (child_yang_name == "ipv4-subobject"):
                                        if (self.ipv4_subobject is None):
                                            self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.Ipv4Subobject()
                                            self.ipv4_subobject.parent = self
                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                        return self.ipv4_subobject

                                    if (child_yang_name == "ipv6-subobject"):
                                        if (self.ipv6_subobject is None):
                                            self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.Ipv6Subobject()
                                            self.ipv6_subobject.parent = self
                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                        return self.ipv6_subobject

                                    if (child_yang_name == "lsp-subobject"):
                                        if (self.lsp_subobject is None):
                                            self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.LspSubobject()
                                            self.lsp_subobject.parent = self
                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                        return self.lsp_subobject

                                    if (child_yang_name == "srlg-subobject"):
                                        if (self.srlg_subobject is None):
                                            self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.SrlgSubobject()
                                            self.srlg_subobject.parent = self
                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                        return self.srlg_subobject

                                    if (child_yang_name == "unnumbered-subobject"):
                                        if (self.unnumbered_subobject is None):
                                            self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject.UnnumberedSubobject()
                                            self.unnumbered_subobject.parent = self
                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                        return self.unnumbered_subobject

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.xro_subobject:
                                    if (c.has_data()):
                                        return True
                                return self.mutual_diversity_flag.is_set

                            def has_operation(self):
                                for c in self.xro_subobject:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "out-xro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "xro-subobject"):
                                    for c in self.xro_subobject:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro.XroSubobject()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.xro_subobject.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "mutual-diversity-flag"):
                                    self.mutual_diversity_flag = value
                                    self.mutual_diversity_flag.value_namespace = name_space
                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix


                        class InXro(Entity):
                            """
                            Incoming XRO for this S2L
                            
                            .. attribute:: mutual_diversity_flag
                            
                            	Mutual Diversity Flag
                            	**type**\:  bool
                            
                            .. attribute:: xro_subobject
                            
                            	List of XRO sub\-objects
                            	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro, self).__init__()

                                self.yang_name = "in-xro"
                                self.yang_parent_name = "s2l"

                                self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                self.xro_subobject = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("mutual_diversity_flag") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro, self).__setattr__(name, value)


                            class XroSubobject(Entity):
                                """
                                List of XRO sub\-objects
                                
                                .. attribute:: as_subobject
                                
                                	AS sub\-object
                                	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.AsSubobject>`
                                
                                .. attribute:: ipv4_subobject
                                
                                	IPv4 sub\-object
                                	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.Ipv4Subobject>`
                                
                                .. attribute:: ipv6_subobject
                                
                                	IPv6 sub\-object
                                	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.Ipv6Subobject>`
                                
                                .. attribute:: lsp_subobject
                                
                                	P2P LSP sub\-object
                                	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.LspSubobject>`
                                
                                .. attribute:: srlg_subobject
                                
                                	SRLG sub\-object
                                	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.SrlgSubobject>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                
                                .. attribute:: unnumbered_subobject
                                
                                	Unnumbered sub\-object
                                	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.UnnumberedSubobject>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject, self).__init__()

                                    self.yang_name = "xro-subobject"
                                    self.yang_parent_name = "in-xro"

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.as_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.AsSubobject()
                                    self.as_subobject.parent = self
                                    self._children_name_map["as_subobject"] = "as-subobject"
                                    self._children_yang_names.add("as-subobject")

                                    self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.Ipv4Subobject()
                                    self.ipv4_subobject.parent = self
                                    self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                    self._children_yang_names.add("ipv4-subobject")

                                    self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.Ipv6Subobject()
                                    self.ipv6_subobject.parent = self
                                    self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                    self._children_yang_names.add("ipv6-subobject")

                                    self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.LspSubobject()
                                    self.lsp_subobject.parent = self
                                    self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    self._children_yang_names.add("lsp-subobject")

                                    self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.SrlgSubobject()
                                    self.srlg_subobject.parent = self
                                    self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                    self._children_yang_names.add("srlg-subobject")

                                    self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.UnnumberedSubobject()
                                    self.unnumbered_subobject.parent = self
                                    self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                    self._children_yang_names.add("unnumbered-subobject")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject, self).__setattr__(name, value)


                                class Ipv4Subobject(Entity):
                                    """
                                    IPv4 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv4 address
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__init__()

                                        self.yang_name = "ipv4-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class Ipv6Subobject(Entity):
                                    """
                                    IPv6 sub\-object
                                    
                                    .. attribute:: address
                                    
                                    	IPv6 address
                                    	**type**\:  str
                                    
                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: prefix_len
                                    
                                    	Prefix length
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__init__()

                                        self.yang_name = "ipv6-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.address = YLeaf(YType.str, "address")

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("address",
                                                        "attribute",
                                                        "exclusion_type",
                                                        "prefix_len") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.address.is_set or
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.prefix_len.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.address.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.prefix_len.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv6-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.address.get_name_leafdata())
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "address"):
                                            self.address = value
                                            self.address.value_namespace = name_space
                                            self.address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "prefix-len"):
                                            self.prefix_len = value
                                            self.prefix_len.value_namespace = name_space
                                            self.prefix_len.value_namespace_prefix = name_space_prefix


                                class UnnumberedSubobject(Entity):
                                    """
                                    Unnumbered sub\-object
                                    
                                    .. attribute:: attribute
                                    
                                    	Attribute
                                    	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: interface_id
                                    
                                    	Interface ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: te_router_id
                                    
                                    	TE router\-id
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__init__()

                                        self.yang_name = "unnumbered-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.attribute = YLeaf(YType.enumeration, "attribute")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.interface_id = YLeaf(YType.uint32, "interface-id")

                                        self.te_router_id = YLeaf(YType.str, "te-router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("attribute",
                                                        "exclusion_type",
                                                        "interface_id",
                                                        "te_router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.attribute.is_set or
                                            self.exclusion_type.is_set or
                                            self.interface_id.is_set or
                                            self.te_router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.attribute.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.interface_id.yfilter != YFilter.not_set or
                                            self.te_router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "unnumbered-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.attribute.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_id.get_name_leafdata())
                                        if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "attribute"):
                                            self.attribute = value
                                            self.attribute.value_namespace = name_space
                                            self.attribute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "interface-id"):
                                            self.interface_id = value
                                            self.interface_id.value_namespace = name_space
                                            self.interface_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "te-router-id"):
                                            self.te_router_id = value
                                            self.te_router_id.value_namespace = name_space
                                            self.te_router_id.value_namespace_prefix = name_space_prefix


                                class AsSubobject(Entity):
                                    """
                                    AS sub\-object
                                    
                                    .. attribute:: as_number
                                    
                                    	Autonomous System number
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.AsSubobject, self).__init__()

                                        self.yang_name = "as-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.as_number = YLeaf(YType.uint16, "as-number")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("as_number") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.as_number.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.as_number.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "as-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.as_number.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "as-number"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "as-number"):
                                            self.as_number = value
                                            self.as_number.value_namespace = name_space
                                            self.as_number.value_namespace_prefix = name_space_prefix


                                class SrlgSubobject(Entity):
                                    """
                                    SRLG sub\-object
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: srlg_id
                                    
                                    	SRLG ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__init__()

                                        self.yang_name = "srlg-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("exclusion_type",
                                                        "srlg_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.exclusion_type.is_set or
                                            self.srlg_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.srlg_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srlg-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "exclusion-type" or name == "srlg-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "srlg-id"):
                                            self.srlg_id = value
                                            self.srlg_id.value_namespace = name_space
                                            self.srlg_id.value_namespace_prefix = name_space_prefix


                                class LspSubobject(Entity):
                                    """
                                    P2P LSP sub\-object
                                    
                                    .. attribute:: destination_node_exception
                                    
                                    	Destination\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: exclusion_type
                                    
                                    	Exclusion Type
                                    	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                    
                                    .. attribute:: fec
                                    
                                    	LSP FEC
                                    	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.LspSubobject.Fec>`
                                    
                                    .. attribute:: ignore_lsp_id
                                    
                                    	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                    	**type**\:  bool
                                    
                                    .. attribute:: penultimate_node_exception
                                    
                                    	Penultimate\-node exception flag
                                    	**type**\:  bool
                                    
                                    .. attribute:: processing_node_exception
                                    
                                    	Processing\-node exception flag
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.LspSubobject, self).__init__()

                                        self.yang_name = "lsp-subobject"
                                        self.yang_parent_name = "xro-subobject"

                                        self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                        self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                        self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                        self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                        self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                        self.fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.LspSubobject.Fec()
                                        self.fec.parent = self
                                        self._children_name_map["fec"] = "fec"
                                        self._children_yang_names.add("fec")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("destination_node_exception",
                                                        "exclusion_type",
                                                        "ignore_lsp_id",
                                                        "penultimate_node_exception",
                                                        "processing_node_exception") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                    class Fec(Entity):
                                        """
                                        LSP FEC
                                        
                                        .. attribute:: fec_destination_info
                                        
                                        	Destination or P2MP ID
                                        	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                        
                                        .. attribute:: fec_extended_tunnel_id
                                        
                                        	Extended tunnel ID
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_lsp_id
                                        
                                        	LSP ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_source
                                        
                                        	Tunnel source address
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: fec_tunnel_id
                                        
                                        	Tunnel ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: fec_vrf
                                        
                                        	VRF; currently only for GMPLS tunnels
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__init__()

                                            self.yang_name = "fec"
                                            self.yang_parent_name = "lsp-subobject"

                                            self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                            self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                            self.fec_source = YLeaf(YType.str, "fec-source")

                                            self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                            self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                            self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                            self.fec_destination_info.parent = self
                                            self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            self._children_yang_names.add("fec-destination-info")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("fec_extended_tunnel_id",
                                                            "fec_lsp_id",
                                                            "fec_source",
                                                            "fec_tunnel_id",
                                                            "fec_vrf") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                        class FecDestinationInfo(Entity):
                                            """
                                            Destination or P2MP ID
                                            
                                            .. attribute:: fec_ctype
                                            
                                            	FEC CType
                                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                            
                                            .. attribute:: fec_destination_p2mp_id
                                            
                                            	P2MP ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: p2p_lsp_destination
                                            
                                            	P2P LSP destination
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                self.yang_name = "fec-destination-info"
                                                self.yang_parent_name = "fec"

                                                self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("fec_ctype",
                                                                "fec_destination_p2mp_id",
                                                                "p2p_lsp_destination") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.fec_ctype.is_set or
                                                    self.fec_destination_p2mp_id.is_set or
                                                    self.p2p_lsp_destination.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.fec_ctype.yfilter != YFilter.not_set or
                                                    self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                    self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "fec-destination-info" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "fec-ctype"):
                                                    self.fec_ctype = value
                                                    self.fec_ctype.value_namespace = name_space
                                                    self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                if(value_path == "fec-destination-p2mp-id"):
                                                    self.fec_destination_p2mp_id = value
                                                    self.fec_destination_p2mp_id.value_namespace = name_space
                                                    self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "p2p-lsp-destination"):
                                                    self.p2p_lsp_destination = value
                                                    self.p2p_lsp_destination.value_namespace = name_space
                                                    self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.fec_extended_tunnel_id.is_set or
                                                self.fec_lsp_id.is_set or
                                                self.fec_source.is_set or
                                                self.fec_tunnel_id.is_set or
                                                self.fec_vrf.is_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_lsp_id.yfilter != YFilter.not_set or
                                                self.fec_source.yfilter != YFilter.not_set or
                                                self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                self.fec_vrf.yfilter != YFilter.not_set or
                                                (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "fec" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                            if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                            if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_source.get_name_leafdata())
                                            if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                            if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "fec-destination-info"):
                                                if (self.fec_destination_info is None):
                                                    self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                    self.fec_destination_info.parent = self
                                                    self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                return self.fec_destination_info

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "fec-extended-tunnel-id"):
                                                self.fec_extended_tunnel_id = value
                                                self.fec_extended_tunnel_id.value_namespace = name_space
                                                self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-lsp-id"):
                                                self.fec_lsp_id = value
                                                self.fec_lsp_id.value_namespace = name_space
                                                self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-source"):
                                                self.fec_source = value
                                                self.fec_source.value_namespace = name_space
                                                self.fec_source.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-tunnel-id"):
                                                self.fec_tunnel_id = value
                                                self.fec_tunnel_id.value_namespace = name_space
                                                self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-vrf"):
                                                self.fec_vrf = value
                                                self.fec_vrf.value_namespace = name_space
                                                self.fec_vrf.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.destination_node_exception.is_set or
                                            self.exclusion_type.is_set or
                                            self.ignore_lsp_id.is_set or
                                            self.penultimate_node_exception.is_set or
                                            self.processing_node_exception.is_set or
                                            (self.fec is not None and self.fec.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.destination_node_exception.yfilter != YFilter.not_set or
                                            self.exclusion_type.yfilter != YFilter.not_set or
                                            self.ignore_lsp_id.yfilter != YFilter.not_set or
                                            self.penultimate_node_exception.yfilter != YFilter.not_set or
                                            self.processing_node_exception.yfilter != YFilter.not_set or
                                            (self.fec is not None and self.fec.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "lsp-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                        if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                        if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                        if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                        if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "fec"):
                                            if (self.fec is None):
                                                self.fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.LspSubobject.Fec()
                                                self.fec.parent = self
                                                self._children_name_map["fec"] = "fec"
                                            return self.fec

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "destination-node-exception"):
                                            self.destination_node_exception = value
                                            self.destination_node_exception.value_namespace = name_space
                                            self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclusion-type"):
                                            self.exclusion_type = value
                                            self.exclusion_type.value_namespace = name_space
                                            self.exclusion_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "ignore-lsp-id"):
                                            self.ignore_lsp_id = value
                                            self.ignore_lsp_id.value_namespace = name_space
                                            self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "penultimate-node-exception"):
                                            self.penultimate_node_exception = value
                                            self.penultimate_node_exception.value_namespace = name_space
                                            self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                        if(value_path == "processing-node-exception"):
                                            self.processing_node_exception = value
                                            self.processing_node_exception.value_namespace = name_space
                                            self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.type.is_set or
                                        (self.as_subobject is not None and self.as_subobject.has_data()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                        (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                        (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                        (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                        (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                        (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "as-subobject"):
                                        if (self.as_subobject is None):
                                            self.as_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.AsSubobject()
                                            self.as_subobject.parent = self
                                            self._children_name_map["as_subobject"] = "as-subobject"
                                        return self.as_subobject

                                    if (child_yang_name == "ipv4-subobject"):
                                        if (self.ipv4_subobject is None):
                                            self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.Ipv4Subobject()
                                            self.ipv4_subobject.parent = self
                                            self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                        return self.ipv4_subobject

                                    if (child_yang_name == "ipv6-subobject"):
                                        if (self.ipv6_subobject is None):
                                            self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.Ipv6Subobject()
                                            self.ipv6_subobject.parent = self
                                            self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                        return self.ipv6_subobject

                                    if (child_yang_name == "lsp-subobject"):
                                        if (self.lsp_subobject is None):
                                            self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.LspSubobject()
                                            self.lsp_subobject.parent = self
                                            self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                        return self.lsp_subobject

                                    if (child_yang_name == "srlg-subobject"):
                                        if (self.srlg_subobject is None):
                                            self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.SrlgSubobject()
                                            self.srlg_subobject.parent = self
                                            self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                        return self.srlg_subobject

                                    if (child_yang_name == "unnumbered-subobject"):
                                        if (self.unnumbered_subobject is None):
                                            self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject.UnnumberedSubobject()
                                            self.unnumbered_subobject.parent = self
                                            self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                        return self.unnumbered_subobject

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.xro_subobject:
                                    if (c.has_data()):
                                        return True
                                return self.mutual_diversity_flag.is_set

                            def has_operation(self):
                                for c in self.xro_subobject:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.mutual_diversity_flag.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "in-xro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "xro-subobject"):
                                    for c in self.xro_subobject:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro.XroSubobject()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.xro_subobject.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "mutual-diversity-flag"):
                                    self.mutual_diversity_flag = value
                                    self.mutual_diversity_flag.value_namespace = name_space
                                    self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix


                        class Tspec(Entity):
                            """
                            The T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.Tspec, self).__init__()

                                self.yang_name = "tspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.Tspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.Tspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class GenericTspec(Entity):
                            """
                            Generic TSpec
                            
                            .. attribute:: otntspec
                            
                            	TE TSpec for G709 OTN
                            	**type**\:   :py:class:`Otntspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GenericTspec.Otntspec>`
                            
                            .. attribute:: tspec_type
                            
                            	TSpecType
                            	**type**\:   :py:class:`TeMgmtGenericTspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericTspec>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GenericTspec, self).__init__()

                                self.yang_name = "generic-tspec"
                                self.yang_parent_name = "s2l"

                                self.tspec_type = YLeaf(YType.enumeration, "tspec-type")

                                self.otntspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GenericTspec.Otntspec()
                                self.otntspec.parent = self
                                self._children_name_map["otntspec"] = "otntspec"
                                self._children_yang_names.add("otntspec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("tspec_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GenericTspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GenericTspec, self).__setattr__(name, value)


                            class Otntspec(Entity):
                                """
                                TE TSpec for G709 OTN
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GenericTspec.Otntspec, self).__init__()

                                    self.yang_name = "otntspec"
                                    self.yang_parent_name = "generic-tspec"

                                    self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                    self.multiplier = YLeaf(YType.uint16, "multiplier")

                                    self.nmc_or_tolerance = YLeaf(YType.uint16, "nmc-or-tolerance")

                                    self.nvc = YLeaf(YType.uint16, "nvc")

                                    self.signal_type = YLeaf(YType.uint8, "signal-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bit_rate",
                                                    "multiplier",
                                                    "nmc_or_tolerance",
                                                    "nvc",
                                                    "signal_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GenericTspec.Otntspec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GenericTspec.Otntspec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.bit_rate.is_set or
                                        self.multiplier.is_set or
                                        self.nmc_or_tolerance.is_set or
                                        self.nvc.is_set or
                                        self.signal_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bit_rate.yfilter != YFilter.not_set or
                                        self.multiplier.yfilter != YFilter.not_set or
                                        self.nmc_or_tolerance.yfilter != YFilter.not_set or
                                        self.nvc.yfilter != YFilter.not_set or
                                        self.signal_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otntspec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                    if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.multiplier.get_name_leafdata())
                                    if (self.nmc_or_tolerance.is_set or self.nmc_or_tolerance.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nmc_or_tolerance.get_name_leafdata())
                                    if (self.nvc.is_set or self.nvc.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nvc.get_name_leafdata())
                                    if (self.signal_type.is_set or self.signal_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signal_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bit-rate" or name == "multiplier" or name == "nmc-or-tolerance" or name == "nvc" or name == "signal-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bit-rate"):
                                        self.bit_rate = value
                                        self.bit_rate.value_namespace = name_space
                                        self.bit_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "multiplier"):
                                        self.multiplier = value
                                        self.multiplier.value_namespace = name_space
                                        self.multiplier.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nmc-or-tolerance"):
                                        self.nmc_or_tolerance = value
                                        self.nmc_or_tolerance.value_namespace = name_space
                                        self.nmc_or_tolerance.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nvc"):
                                        self.nvc = value
                                        self.nvc.value_namespace = name_space
                                        self.nvc.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signal-type"):
                                        self.signal_type = value
                                        self.signal_type.value_namespace = name_space
                                        self.signal_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.tspec_type.is_set or
                                    (self.otntspec is not None and self.otntspec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.tspec_type.yfilter != YFilter.not_set or
                                    (self.otntspec is not None and self.otntspec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "generic-tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.tspec_type.is_set or self.tspec_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tspec_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "otntspec"):
                                    if (self.otntspec is None):
                                        self.otntspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GenericTspec.Otntspec()
                                        self.otntspec.parent = self
                                        self._children_name_map["otntspec"] = "otntspec"
                                    return self.otntspec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "otntspec" or name == "tspec-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "tspec-type"):
                                    self.tspec_type = value
                                    self.tspec_type.value_namespace = name_space
                                    self.tspec_type.value_namespace_prefix = name_space_prefix


                        class Fspec(Entity):
                            """
                            The F spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.Fspec, self).__init__()

                                self.yang_name = "fspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.Fspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.Fspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "fspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class GenericFspec(Entity):
                            """
                            Generic FSpec
                            
                            .. attribute:: fspec_type
                            
                            	FSpecType
                            	**type**\:   :py:class:`TeMgmtGenericFspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMgmtGenericFspec>`
                            
                            .. attribute:: otnfspec
                            
                            	TE FSpec for G709 OTN
                            	**type**\:   :py:class:`Otnfspec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GenericFspec.Otnfspec>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GenericFspec, self).__init__()

                                self.yang_name = "generic-fspec"
                                self.yang_parent_name = "s2l"

                                self.fspec_type = YLeaf(YType.enumeration, "fspec-type")

                                self.otnfspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GenericFspec.Otnfspec()
                                self.otnfspec.parent = self
                                self._children_name_map["otnfspec"] = "otnfspec"
                                self._children_yang_names.add("otnfspec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fspec_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GenericFspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GenericFspec, self).__setattr__(name, value)


                            class Otnfspec(Entity):
                                """
                                TE FSpec for G709 OTN
                                
                                .. attribute:: bit_rate
                                
                                	Bit Rate in kbps
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: multiplier
                                
                                	Multiplier
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nmc_or_tolerance
                                
                                	NMC or Tolerance
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: nvc
                                
                                	Number of Virtual Components
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: signal_type
                                
                                	Signal Type
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GenericFspec.Otnfspec, self).__init__()

                                    self.yang_name = "otnfspec"
                                    self.yang_parent_name = "generic-fspec"

                                    self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                    self.multiplier = YLeaf(YType.uint16, "multiplier")

                                    self.nmc_or_tolerance = YLeaf(YType.uint16, "nmc-or-tolerance")

                                    self.nvc = YLeaf(YType.uint16, "nvc")

                                    self.signal_type = YLeaf(YType.uint8, "signal-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bit_rate",
                                                    "multiplier",
                                                    "nmc_or_tolerance",
                                                    "nvc",
                                                    "signal_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GenericFspec.Otnfspec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GenericFspec.Otnfspec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.bit_rate.is_set or
                                        self.multiplier.is_set or
                                        self.nmc_or_tolerance.is_set or
                                        self.nvc.is_set or
                                        self.signal_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bit_rate.yfilter != YFilter.not_set or
                                        self.multiplier.yfilter != YFilter.not_set or
                                        self.nmc_or_tolerance.yfilter != YFilter.not_set or
                                        self.nvc.yfilter != YFilter.not_set or
                                        self.signal_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otnfspec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                    if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.multiplier.get_name_leafdata())
                                    if (self.nmc_or_tolerance.is_set or self.nmc_or_tolerance.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nmc_or_tolerance.get_name_leafdata())
                                    if (self.nvc.is_set or self.nvc.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.nvc.get_name_leafdata())
                                    if (self.signal_type.is_set or self.signal_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.signal_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bit-rate" or name == "multiplier" or name == "nmc-or-tolerance" or name == "nvc" or name == "signal-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bit-rate"):
                                        self.bit_rate = value
                                        self.bit_rate.value_namespace = name_space
                                        self.bit_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "multiplier"):
                                        self.multiplier = value
                                        self.multiplier.value_namespace = name_space
                                        self.multiplier.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nmc-or-tolerance"):
                                        self.nmc_or_tolerance = value
                                        self.nmc_or_tolerance.value_namespace = name_space
                                        self.nmc_or_tolerance.value_namespace_prefix = name_space_prefix
                                    if(value_path == "nvc"):
                                        self.nvc = value
                                        self.nvc.value_namespace = name_space
                                        self.nvc.value_namespace_prefix = name_space_prefix
                                    if(value_path == "signal-type"):
                                        self.signal_type = value
                                        self.signal_type.value_namespace = name_space
                                        self.signal_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.fspec_type.is_set or
                                    (self.otnfspec is not None and self.otnfspec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fspec_type.yfilter != YFilter.not_set or
                                    (self.otnfspec is not None and self.otnfspec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "generic-fspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fspec_type.is_set or self.fspec_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fspec_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "otnfspec"):
                                    if (self.otnfspec is None):
                                        self.otnfspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GenericFspec.Otnfspec()
                                        self.otnfspec.parent = self
                                        self._children_name_map["otnfspec"] = "otnfspec"
                                    return self.otnfspec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "otnfspec" or name == "fspec-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fspec-type"):
                                    self.fspec_type = value
                                    self.fspec_type.value_namespace = name_space
                                    self.fspec_type.value_namespace_prefix = name_space_prefix


                        class NextHopAddressGeneric(Entity):
                            """
                            Next hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.NextHopAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.NextHopAddressGeneric, self).__init__()

                                self.yang_name = "next-hop-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.NextHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.NextHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "next-hop-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.NextHopAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.NextHopAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.NextHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "next-hop-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.NextHopAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class PreviousHopAddressGeneric(Entity):
                            """
                            Previous hop address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PreviousHopAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PreviousHopAddressGeneric, self).__init__()

                                self.yang_name = "previous-hop-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PreviousHopAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "previous-hop-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PreviousHopAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PreviousHopAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "previous-hop-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PreviousHopAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class IncomingAddressGeneric(Entity):
                            """
                            Incoming interface address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.IncomingAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.IncomingAddressGeneric, self).__init__()

                                self.yang_name = "incoming-address-generic"
                                self.yang_parent_name = "s2l"

                                self.te_addr = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.IncomingAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.IncomingAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "incoming-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.IncomingAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.IncomingAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.IncomingAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "incoming-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.IncomingAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class S2LConvergence(Entity):
                            """
                            TE LSP convergence related information
                            
                            .. attribute:: creation_time
                            
                            	Tunnel creation timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: label_rewrite
                            
                            	LSP Label rewrite timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_in
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: path_out
                            
                            	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_in
                            
                            	LSP RSVP Resv\-in timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: resv_out
                            
                            	LSP RSVP Resv\-out timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            .. attribute:: tunnel_rewrite
                            
                            	Tunnel rewrite timestamp (clocktime in nsecs)
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: nanosecond
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.S2LConvergence, self).__init__()

                                self.yang_name = "s2l-convergence"
                                self.yang_parent_name = "s2l"

                                self.creation_time = YLeaf(YType.uint64, "creation-time")

                                self.label_rewrite = YLeaf(YType.uint64, "label-rewrite")

                                self.path_in = YLeaf(YType.uint64, "path-in")

                                self.path_out = YLeaf(YType.uint64, "path-out")

                                self.resv_in = YLeaf(YType.uint64, "resv-in")

                                self.resv_out = YLeaf(YType.uint64, "resv-out")

                                self.tunnel_rewrite = YLeaf(YType.uint64, "tunnel-rewrite")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("creation_time",
                                                "label_rewrite",
                                                "path_in",
                                                "path_out",
                                                "resv_in",
                                                "resv_out",
                                                "tunnel_rewrite") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.S2LConvergence, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.S2LConvergence, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.creation_time.is_set or
                                    self.label_rewrite.is_set or
                                    self.path_in.is_set or
                                    self.path_out.is_set or
                                    self.resv_in.is_set or
                                    self.resv_out.is_set or
                                    self.tunnel_rewrite.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.creation_time.yfilter != YFilter.not_set or
                                    self.label_rewrite.yfilter != YFilter.not_set or
                                    self.path_in.yfilter != YFilter.not_set or
                                    self.path_out.yfilter != YFilter.not_set or
                                    self.resv_in.yfilter != YFilter.not_set or
                                    self.resv_out.yfilter != YFilter.not_set or
                                    self.tunnel_rewrite.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-convergence" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.creation_time.is_set or self.creation_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.creation_time.get_name_leafdata())
                                if (self.label_rewrite.is_set or self.label_rewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.label_rewrite.get_name_leafdata())
                                if (self.path_in.is_set or self.path_in.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_in.get_name_leafdata())
                                if (self.path_out.is_set or self.path_out.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_out.get_name_leafdata())
                                if (self.resv_in.is_set or self.resv_in.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.resv_in.get_name_leafdata())
                                if (self.resv_out.is_set or self.resv_out.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.resv_out.get_name_leafdata())
                                if (self.tunnel_rewrite.is_set or self.tunnel_rewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_rewrite.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "creation-time" or name == "label-rewrite" or name == "path-in" or name == "path-out" or name == "resv-in" or name == "resv-out" or name == "tunnel-rewrite"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "creation-time"):
                                    self.creation_time = value
                                    self.creation_time.value_namespace = name_space
                                    self.creation_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "label-rewrite"):
                                    self.label_rewrite = value
                                    self.label_rewrite.value_namespace = name_space
                                    self.label_rewrite.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-in"):
                                    self.path_in = value
                                    self.path_in.value_namespace = name_space
                                    self.path_in.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-out"):
                                    self.path_out = value
                                    self.path_out.value_namespace = name_space
                                    self.path_out.value_namespace_prefix = name_space_prefix
                                if(value_path == "resv-in"):
                                    self.resv_in = value
                                    self.resv_in.value_namespace = name_space
                                    self.resv_in.value_namespace_prefix = name_space_prefix
                                if(value_path == "resv-out"):
                                    self.resv_out = value
                                    self.resv_out.value_namespace = name_space
                                    self.resv_out.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-rewrite"):
                                    self.tunnel_rewrite = value
                                    self.tunnel_rewrite.value_namespace = name_space
                                    self.tunnel_rewrite.value_namespace_prefix = name_space_prefix


                        class SoftPreemption(Entity):
                            """
                            The soft preemption info for this LSP.
                            
                            .. attribute:: fr_rrewrite
                            
                            	FRR\-rewrite during soft preemption
                            	**type**\:  bool
                            
                            .. attribute:: fr_rrewrite_tunnel_name
                            
                            	The tunnel name of the backup
                            	**type**\:  str
                            
                            .. attribute:: preempting_link_address
                            
                            	The address of the link where the preemption happened
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: soft_preemption_link
                            
                            	Name of the link where the soft preemption occurred
                            	**type**\:  str
                            
                            .. attribute:: soft_preemption_timestamp
                            
                            	The POSIX timestamp when the soft preemption occurred
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: status
                            
                            	The current state of the soft preemption operation
                            	**type**\:   :py:class:`MplsTeSoftPreemptionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeSoftPreemptionState>`
                            
                            .. attribute:: time_to_hard_preemption
                            
                            	The number of seconds until hard preemption is triggered
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.SoftPreemption, self).__init__()

                                self.yang_name = "soft-preemption"
                                self.yang_parent_name = "s2l"

                                self.fr_rrewrite = YLeaf(YType.boolean, "fr-rrewrite")

                                self.fr_rrewrite_tunnel_name = YLeaf(YType.str, "fr-rrewrite-tunnel-name")

                                self.preempting_link_address = YLeaf(YType.str, "preempting-link-address")

                                self.soft_preemption_link = YLeaf(YType.str, "soft-preemption-link")

                                self.soft_preemption_timestamp = YLeaf(YType.uint32, "soft-preemption-timestamp")

                                self.status = YLeaf(YType.enumeration, "status")

                                self.time_to_hard_preemption = YLeaf(YType.uint16, "time-to-hard-preemption")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fr_rrewrite",
                                                "fr_rrewrite_tunnel_name",
                                                "preempting_link_address",
                                                "soft_preemption_link",
                                                "soft_preemption_timestamp",
                                                "status",
                                                "time_to_hard_preemption") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.SoftPreemption, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.SoftPreemption, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.fr_rrewrite.is_set or
                                    self.fr_rrewrite_tunnel_name.is_set or
                                    self.preempting_link_address.is_set or
                                    self.soft_preemption_link.is_set or
                                    self.soft_preemption_timestamp.is_set or
                                    self.status.is_set or
                                    self.time_to_hard_preemption.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fr_rrewrite.yfilter != YFilter.not_set or
                                    self.fr_rrewrite_tunnel_name.yfilter != YFilter.not_set or
                                    self.preempting_link_address.yfilter != YFilter.not_set or
                                    self.soft_preemption_link.yfilter != YFilter.not_set or
                                    self.soft_preemption_timestamp.yfilter != YFilter.not_set or
                                    self.status.yfilter != YFilter.not_set or
                                    self.time_to_hard_preemption.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "soft-preemption" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fr_rrewrite.is_set or self.fr_rrewrite.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fr_rrewrite.get_name_leafdata())
                                if (self.fr_rrewrite_tunnel_name.is_set or self.fr_rrewrite_tunnel_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fr_rrewrite_tunnel_name.get_name_leafdata())
                                if (self.preempting_link_address.is_set or self.preempting_link_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.preempting_link_address.get_name_leafdata())
                                if (self.soft_preemption_link.is_set or self.soft_preemption_link.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.soft_preemption_link.get_name_leafdata())
                                if (self.soft_preemption_timestamp.is_set or self.soft_preemption_timestamp.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.soft_preemption_timestamp.get_name_leafdata())
                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.status.get_name_leafdata())
                                if (self.time_to_hard_preemption.is_set or self.time_to_hard_preemption.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.time_to_hard_preemption.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fr-rrewrite" or name == "fr-rrewrite-tunnel-name" or name == "preempting-link-address" or name == "soft-preemption-link" or name == "soft-preemption-timestamp" or name == "status" or name == "time-to-hard-preemption"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fr-rrewrite"):
                                    self.fr_rrewrite = value
                                    self.fr_rrewrite.value_namespace = name_space
                                    self.fr_rrewrite.value_namespace_prefix = name_space_prefix
                                if(value_path == "fr-rrewrite-tunnel-name"):
                                    self.fr_rrewrite_tunnel_name = value
                                    self.fr_rrewrite_tunnel_name.value_namespace = name_space
                                    self.fr_rrewrite_tunnel_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "preempting-link-address"):
                                    self.preempting_link_address = value
                                    self.preempting_link_address.value_namespace = name_space
                                    self.preempting_link_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "soft-preemption-link"):
                                    self.soft_preemption_link = value
                                    self.soft_preemption_link.value_namespace = name_space
                                    self.soft_preemption_link.value_namespace_prefix = name_space_prefix
                                if(value_path == "soft-preemption-timestamp"):
                                    self.soft_preemption_timestamp = value
                                    self.soft_preemption_timestamp.value_namespace = name_space
                                    self.soft_preemption_timestamp.value_namespace_prefix = name_space_prefix
                                if(value_path == "status"):
                                    self.status = value
                                    self.status.value_namespace = name_space
                                    self.status.value_namespace_prefix = name_space_prefix
                                if(value_path == "time-to-hard-preemption"):
                                    self.time_to_hard_preemption = value
                                    self.time_to_hard_preemption.value_namespace = name_space
                                    self.time_to_hard_preemption.value_namespace_prefix = name_space_prefix


                        class GmplsLabels(Entity):
                            """
                            GMPLS labels
                            
                            .. attribute:: path_egress_label
                            
                            	Path message (upstream) egress label
                            	**type**\:   :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathEgressLabel>`
                            
                            .. attribute:: path_ingress_label
                            
                            	Path message (upstream) ingress label
                            	**type**\:   :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathIngressLabel>`
                            
                            .. attribute:: resv_egress_label
                            
                            	Resv message (downstream) egress label
                            	**type**\:   :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel>`
                            
                            .. attribute:: resv_ingress_label
                            
                            	Resv message (downstream) ingress label
                            	**type**\:   :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels, self).__init__()

                                self.yang_name = "gmpls-labels"
                                self.yang_parent_name = "s2l"

                                self.path_egress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathEgressLabel()
                                self.path_egress_label.parent = self
                                self._children_name_map["path_egress_label"] = "path-egress-label"
                                self._children_yang_names.add("path-egress-label")

                                self.path_ingress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathIngressLabel()
                                self.path_ingress_label.parent = self
                                self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                self._children_yang_names.add("path-ingress-label")

                                self.resv_egress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel()
                                self.resv_egress_label.parent = self
                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                self._children_yang_names.add("resv-egress-label")

                                self.resv_ingress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel()
                                self.resv_ingress_label.parent = self
                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                self._children_yang_names.add("resv-ingress-label")


                            class PathIngressLabel(Entity):
                                """
                                Path message (upstream) ingress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathIngressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathIngressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathIngressLabel, self).__init__()

                                    self.yang_name = "path-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathIngressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathIngressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-ingress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathIngressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-ingress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathIngressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathIngressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-ingress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class PathEgressLabel(Entity):
                                """
                                Path message (upstream) egress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathEgressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathEgressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathEgressLabel, self).__init__()

                                    self.yang_name = "path-egress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathEgressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathEgressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "path-egress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathEgressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "path-egress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathEgressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathEgressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "path-egress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class ResvIngressLabel(Entity):
                                """
                                Resv message (downstream) ingress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel, self).__init__()

                                    self.yang_name = "resv-ingress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-ingress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-ingress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "resv-ingress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix


                            class ResvEgressLabel(Entity):
                                """
                                Resv message (downstream) egress label
                                
                                .. attribute:: label_type
                                
                                	LabelType
                                	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                
                                .. attribute:: otn
                                
                                	Fixed\-size G09 OTN label
                                	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel.Otn>`
                                
                                .. attribute:: wdm
                                
                                	Fixed\-grid WDM label
                                	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel, self).__init__()

                                    self.yang_name = "resv-egress-label"
                                    self.yang_parent_name = "gmpls-labels"

                                    self.label_type = YLeaf(YType.enumeration, "label-type")

                                    self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel.Otn()
                                    self.otn.parent = self
                                    self._children_name_map["otn"] = "otn"
                                    self._children_yang_names.add("otn")

                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm()
                                    self.wdm.parent = self
                                    self._children_name_map["wdm"] = "wdm"
                                    self._children_yang_names.add("wdm")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("label_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel, self).__setattr__(name, value)


                                class Wdm(Entity):
                                    """
                                    Fixed\-grid WDM label
                                    
                                    .. attribute:: channel
                                    
                                    	Channel Number
                                    	**type**\:  int
                                    
                                    	**range:** \-32768..32767
                                    
                                    .. attribute:: channel_spacing
                                    
                                    	Channel spacing
                                    	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                    
                                    .. attribute:: grid
                                    
                                    	Grid
                                    	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                    
                                    .. attribute:: identifier
                                    
                                    	Identifier
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: label_set
                                    
                                    	Flag to indicate whether label is set
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__init__()

                                        self.yang_name = "wdm"
                                        self.yang_parent_name = "resv-egress-label"

                                        self.channel = YLeaf(YType.int16, "channel")

                                        self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                        self.grid = YLeaf(YType.enumeration, "grid")

                                        self.identifier = YLeaf(YType.uint16, "identifier")

                                        self.label_set = YLeaf(YType.boolean, "label-set")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("channel",
                                                        "channel_spacing",
                                                        "grid",
                                                        "identifier",
                                                        "label_set") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.channel.is_set or
                                            self.channel_spacing.is_set or
                                            self.grid.is_set or
                                            self.identifier.is_set or
                                            self.label_set.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.channel.yfilter != YFilter.not_set or
                                            self.channel_spacing.yfilter != YFilter.not_set or
                                            self.grid.yfilter != YFilter.not_set or
                                            self.identifier.yfilter != YFilter.not_set or
                                            self.label_set.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "wdm" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel.get_name_leafdata())
                                        if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                        if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.grid.get_name_leafdata())
                                        if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.identifier.get_name_leafdata())
                                        if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.label_set.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "channel"):
                                            self.channel = value
                                            self.channel.value_namespace = name_space
                                            self.channel.value_namespace_prefix = name_space_prefix
                                        if(value_path == "channel-spacing"):
                                            self.channel_spacing = value
                                            self.channel_spacing.value_namespace = name_space
                                            self.channel_spacing.value_namespace_prefix = name_space_prefix
                                        if(value_path == "grid"):
                                            self.grid = value
                                            self.grid.value_namespace = name_space
                                            self.grid.value_namespace_prefix = name_space_prefix
                                        if(value_path == "identifier"):
                                            self.identifier = value
                                            self.identifier.value_namespace = name_space
                                            self.identifier.value_namespace_prefix = name_space_prefix
                                        if(value_path == "label-set"):
                                            self.label_set = value
                                            self.label_set.value_namespace = name_space
                                            self.label_set.value_namespace_prefix = name_space_prefix


                                class Otn(Entity):
                                    """
                                    Fixed\-size G09 OTN label
                                    
                                    .. attribute:: bit_map
                                    
                                    	Bit Map
                                    	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap>`
                                    
                                    .. attribute:: bit_map_length
                                    
                                    	Bit map length
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: tpn
                                    
                                    	Tributary time slot
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__init__()

                                        self.yang_name = "otn"
                                        self.yang_parent_name = "resv-egress-label"

                                        self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                        self.tpn = YLeaf(YType.uint16, "tpn")

                                        self.bit_map = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bit_map_length",
                                                        "tpn") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel.Otn, self).__setattr__(name, value)


                                    class BitMap(Entity):
                                        """
                                        Bit Map
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                            self.yang_name = "bit-map"
                                            self.yang_parent_name = "otn"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bit-map" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.bit_map:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bit_map_length.is_set or
                                            self.tpn.is_set)

                                    def has_operation(self):
                                        for c in self.bit_map:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bit_map_length.yfilter != YFilter.not_set or
                                            self.tpn.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "otn" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                        if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tpn.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "bit-map"):
                                            for c in self.bit_map:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel.Otn.BitMap()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.bit_map.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bit-map-length"):
                                            self.bit_map_length = value
                                            self.bit_map_length.value_namespace = name_space
                                            self.bit_map_length.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tpn"):
                                            self.tpn = value
                                            self.tpn.value_namespace = name_space
                                            self.tpn.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.label_type.is_set or
                                        (self.otn is not None and self.otn.has_data()) or
                                        (self.wdm is not None and self.wdm.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.label_type.yfilter != YFilter.not_set or
                                        (self.otn is not None and self.otn.has_operation()) or
                                        (self.wdm is not None and self.wdm.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "resv-egress-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "otn"):
                                        if (self.otn is None):
                                            self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                        return self.otn

                                    if (child_yang_name == "wdm"):
                                        if (self.wdm is None):
                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                        return self.wdm

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "otn" or name == "wdm" or name == "label-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "label-type"):
                                        self.label_type = value
                                        self.label_type.value_namespace = name_space
                                        self.label_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    (self.path_egress_label is not None and self.path_egress_label.has_data()) or
                                    (self.path_ingress_label is not None and self.path_ingress_label.has_data()) or
                                    (self.resv_egress_label is not None and self.resv_egress_label.has_data()) or
                                    (self.resv_ingress_label is not None and self.resv_ingress_label.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.path_egress_label is not None and self.path_egress_label.has_operation()) or
                                    (self.path_ingress_label is not None and self.path_ingress_label.has_operation()) or
                                    (self.resv_egress_label is not None and self.resv_egress_label.has_operation()) or
                                    (self.resv_ingress_label is not None and self.resv_ingress_label.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "gmpls-labels" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "path-egress-label"):
                                    if (self.path_egress_label is None):
                                        self.path_egress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"
                                    return self.path_egress_label

                                if (child_yang_name == "path-ingress-label"):
                                    if (self.path_ingress_label is None):
                                        self.path_ingress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                    return self.path_ingress_label

                                if (child_yang_name == "resv-egress-label"):
                                    if (self.resv_egress_label is None):
                                        self.resv_egress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                    return self.resv_egress_label

                                if (child_yang_name == "resv-ingress-label"):
                                    if (self.resv_ingress_label is None):
                                        self.resv_ingress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                    return self.resv_ingress_label

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "path-egress-label" or name == "path-ingress-label" or name == "resv-egress-label" or name == "resv-ingress-label"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class OtnS2L(Entity):
                            """
                            Otn S2L Information
                            
                            .. attribute:: aps
                            
                            	APS Info for OTN S2L
                            	**type**\:   :py:class:`Aps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Aps>`
                            
                            .. attribute:: otn
                            
                            	Info Related to OTN technology in S2L
                            	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L, self).__init__()

                                self.yang_name = "otn-s2l"
                                self.yang_parent_name = "s2l"

                                self.aps = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Aps()
                                self.aps.parent = self
                                self._children_name_map["aps"] = "aps"
                                self._children_yang_names.add("aps")

                                self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn()
                                self.otn.parent = self
                                self._children_name_map["otn"] = "otn"
                                self._children_yang_names.add("otn")


                            class Otn(Entity):
                                """
                                Info Related to OTN technology in S2L
                                
                                .. attribute:: bandwidth
                                
                                	OTN Bandwidth for s2l
                                	**type**\:   :py:class:`Bandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth>`
                                
                                .. attribute:: cross_connect_id
                                
                                	Cross connect id
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: gpid
                                
                                	Gpid Payload
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: incoming_controller
                                
                                	Incoming Controller
                                	**type**\:  str
                                
                                .. attribute:: incoming_controller_ifhandle
                                
                                	Incoming Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: incoming_controller_state
                                
                                	State of Incoming Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: incoming_sub_controller
                                
                                	Incoming Sub Controller
                                	**type**\:  str
                                
                                .. attribute:: incoming_sub_controller_ifhandle
                                
                                	Incoming Sub Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: incoming_sub_controller_state
                                
                                	State of Incoming Sub Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: is_connected
                                
                                	True if subcontrollers are connected
                                	**type**\:  bool
                                
                                .. attribute:: labels
                                
                                	Labels
                                	**type**\:   :py:class:`Labels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels>`
                                
                                .. attribute:: outgoing_controller
                                
                                	Outgoing Controller
                                	**type**\:  str
                                
                                .. attribute:: outgoing_controller_ifhandle
                                
                                	Outgoing Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: outgoing_controller_state
                                
                                	State of Outgoing Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: outgoing_sub_controller
                                
                                	Outgoing Sub Controller
                                	**type**\:  str
                                
                                .. attribute:: outgoing_sub_controller_ifhandle
                                
                                	Outgoing Sub Controller Ifhandle
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: outgoing_sub_controller_state
                                
                                	State of Outgoing Sub Controller
                                	**type**\:   :py:class:`TeControllerState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeControllerState>`
                                
                                .. attribute:: uptime
                                
                                	XC Uptime
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn, self).__init__()

                                    self.yang_name = "otn"
                                    self.yang_parent_name = "otn-s2l"

                                    self.cross_connect_id = YLeaf(YType.uint32, "cross-connect-id")

                                    self.gpid = YLeaf(YType.uint16, "gpid")

                                    self.incoming_controller = YLeaf(YType.str, "incoming-controller")

                                    self.incoming_controller_ifhandle = YLeaf(YType.str, "incoming-controller-ifhandle")

                                    self.incoming_controller_state = YLeaf(YType.enumeration, "incoming-controller-state")

                                    self.incoming_sub_controller = YLeaf(YType.str, "incoming-sub-controller")

                                    self.incoming_sub_controller_ifhandle = YLeaf(YType.str, "incoming-sub-controller-ifhandle")

                                    self.incoming_sub_controller_state = YLeaf(YType.enumeration, "incoming-sub-controller-state")

                                    self.is_connected = YLeaf(YType.boolean, "is-connected")

                                    self.outgoing_controller = YLeaf(YType.str, "outgoing-controller")

                                    self.outgoing_controller_ifhandle = YLeaf(YType.str, "outgoing-controller-ifhandle")

                                    self.outgoing_controller_state = YLeaf(YType.enumeration, "outgoing-controller-state")

                                    self.outgoing_sub_controller = YLeaf(YType.str, "outgoing-sub-controller")

                                    self.outgoing_sub_controller_ifhandle = YLeaf(YType.str, "outgoing-sub-controller-ifhandle")

                                    self.outgoing_sub_controller_state = YLeaf(YType.enumeration, "outgoing-sub-controller-state")

                                    self.uptime = YLeaf(YType.uint32, "uptime")

                                    self.bandwidth = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth()
                                    self.bandwidth.parent = self
                                    self._children_name_map["bandwidth"] = "bandwidth"
                                    self._children_yang_names.add("bandwidth")

                                    self.labels = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels()
                                    self.labels.parent = self
                                    self._children_name_map["labels"] = "labels"
                                    self._children_yang_names.add("labels")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("cross_connect_id",
                                                    "gpid",
                                                    "incoming_controller",
                                                    "incoming_controller_ifhandle",
                                                    "incoming_controller_state",
                                                    "incoming_sub_controller",
                                                    "incoming_sub_controller_ifhandle",
                                                    "incoming_sub_controller_state",
                                                    "is_connected",
                                                    "outgoing_controller",
                                                    "outgoing_controller_ifhandle",
                                                    "outgoing_controller_state",
                                                    "outgoing_sub_controller",
                                                    "outgoing_sub_controller_ifhandle",
                                                    "outgoing_sub_controller_state",
                                                    "uptime") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn, self).__setattr__(name, value)


                                class Bandwidth(Entity):
                                    """
                                    OTN Bandwidth for s2l
                                    
                                    .. attribute:: odu_flex_cbr
                                    
                                    	Odu flex CBR info
                                    	**type**\:   :py:class:`OduFlexCbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr>`
                                    
                                    .. attribute:: odu_flex_gfp_f_non_res
                                    
                                    	Odu flex GFP\-F non\-resizable info
                                    	**type**\:   :py:class:`OduFlexGfpFNonRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes>`
                                    
                                    .. attribute:: odu_flex_gfp_f_res
                                    
                                    	Odu flex GFP\-F resizable info
                                    	**type**\:   :py:class:`OduFlexGfpFRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes>`
                                    
                                    .. attribute:: odu_level
                                    
                                    	ODULevel
                                    	**type**\:   :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth, self).__init__()

                                        self.yang_name = "bandwidth"
                                        self.yang_parent_name = "otn"

                                        self.odu_level = YLeaf(YType.enumeration, "odu-level")

                                        self.odu_flex_cbr = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr()
                                        self.odu_flex_cbr.parent = self
                                        self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"
                                        self._children_yang_names.add("odu-flex-cbr")

                                        self.odu_flex_gfp_f_non_res = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes()
                                        self.odu_flex_gfp_f_non_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                        self._children_yang_names.add("odu-flex-gfp-f-non-res")

                                        self.odu_flex_gfp_f_res = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes()
                                        self.odu_flex_gfp_f_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"
                                        self._children_yang_names.add("odu-flex-gfp-f-res")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("odu_level") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth, self).__setattr__(name, value)


                                    class OduFlexCbr(Entity):
                                        """
                                        Odu flex CBR info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: tolerance
                                        
                                        	Tolerance
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__init__()

                                            self.yang_name = "odu-flex-cbr"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                            self.tolerance = YLeaf(YType.uint16, "tolerance")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate",
                                                            "tolerance") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.bit_rate.is_set or
                                                self.tolerance.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set or
                                                self.tolerance.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-cbr" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                            if (self.tolerance.is_set or self.tolerance.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.tolerance.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate" or name == "tolerance"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix
                                            if(value_path == "tolerance"):
                                                self.tolerance = value
                                                self.tolerance.value_namespace = name_space
                                                self.tolerance.value_namespace_prefix = name_space_prefix


                                    class OduFlexGfpFRes(Entity):
                                        """
                                        Odu flex GFP\-F resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-res"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.bit_rate.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-gfp-f-res" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix


                                    class OduFlexGfpFNonRes(Entity):
                                        """
                                        Odu flex GFP\-F non\-resizable info
                                        
                                        .. attribute:: bit_rate
                                        
                                        	Bit rate in kbit/s
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__init__()

                                            self.yang_name = "odu-flex-gfp-f-non-res"
                                            self.yang_parent_name = "bandwidth"

                                            self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("bit_rate") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.bit_rate.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.bit_rate.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "odu-flex-gfp-f-non-res" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.bit_rate.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "bit-rate"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "bit-rate"):
                                                self.bit_rate = value
                                                self.bit_rate.value_namespace = name_space
                                                self.bit_rate.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.odu_level.is_set or
                                            (self.odu_flex_cbr is not None and self.odu_flex_cbr.has_data()) or
                                            (self.odu_flex_gfp_f_non_res is not None and self.odu_flex_gfp_f_non_res.has_data()) or
                                            (self.odu_flex_gfp_f_res is not None and self.odu_flex_gfp_f_res.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.odu_level.yfilter != YFilter.not_set or
                                            (self.odu_flex_cbr is not None and self.odu_flex_cbr.has_operation()) or
                                            (self.odu_flex_gfp_f_non_res is not None and self.odu_flex_gfp_f_non_res.has_operation()) or
                                            (self.odu_flex_gfp_f_res is not None and self.odu_flex_gfp_f_res.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "bandwidth" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.odu_level.is_set or self.odu_level.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.odu_level.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "odu-flex-cbr"):
                                            if (self.odu_flex_cbr is None):
                                                self.odu_flex_cbr = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexCbr()
                                                self.odu_flex_cbr.parent = self
                                                self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"
                                            return self.odu_flex_cbr

                                        if (child_yang_name == "odu-flex-gfp-f-non-res"):
                                            if (self.odu_flex_gfp_f_non_res is None):
                                                self.odu_flex_gfp_f_non_res = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFNonRes()
                                                self.odu_flex_gfp_f_non_res.parent = self
                                                self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                            return self.odu_flex_gfp_f_non_res

                                        if (child_yang_name == "odu-flex-gfp-f-res"):
                                            if (self.odu_flex_gfp_f_res is None):
                                                self.odu_flex_gfp_f_res = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth.OduFlexGfpFRes()
                                                self.odu_flex_gfp_f_res.parent = self
                                                self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"
                                            return self.odu_flex_gfp_f_res

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "odu-flex-cbr" or name == "odu-flex-gfp-f-non-res" or name == "odu-flex-gfp-f-res" or name == "odu-level"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "odu-level"):
                                            self.odu_level = value
                                            self.odu_level.value_namespace = name_space
                                            self.odu_level.value_namespace_prefix = name_space_prefix


                                class Labels(Entity):
                                    """
                                    Labels
                                    
                                    .. attribute:: path_egress_label
                                    
                                    	Path message (upstream) egress label
                                    	**type**\:   :py:class:`PathEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel>`
                                    
                                    .. attribute:: path_ingress_label
                                    
                                    	Path message (upstream) ingress label
                                    	**type**\:   :py:class:`PathIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel>`
                                    
                                    .. attribute:: resv_egress_label
                                    
                                    	Resv message (downstream) egress label
                                    	**type**\:   :py:class:`ResvEgressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel>`
                                    
                                    .. attribute:: resv_ingress_label
                                    
                                    	Resv message (downstream) ingress label
                                    	**type**\:   :py:class:`ResvIngressLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels, self).__init__()

                                        self.yang_name = "labels"
                                        self.yang_parent_name = "otn"

                                        self.path_egress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel()
                                        self.path_egress_label.parent = self
                                        self._children_name_map["path_egress_label"] = "path-egress-label"
                                        self._children_yang_names.add("path-egress-label")

                                        self.path_ingress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel()
                                        self.path_ingress_label.parent = self
                                        self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                        self._children_yang_names.add("path-ingress-label")

                                        self.resv_egress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel()
                                        self.resv_egress_label.parent = self
                                        self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                        self._children_yang_names.add("resv-egress-label")

                                        self.resv_ingress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel()
                                        self.resv_ingress_label.parent = self
                                        self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                        self._children_yang_names.add("resv-ingress-label")


                                    class PathIngressLabel(Entity):
                                        """
                                        Path message (upstream) ingress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__init__()

                                            self.yang_name = "path-ingress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-ingress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-ingress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "path-ingress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class PathEgressLabel(Entity):
                                        """
                                        Path message (upstream) egress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__init__()

                                            self.yang_name = "path-egress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "path-egress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "path-egress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "path-egress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class ResvIngressLabel(Entity):
                                        """
                                        Resv message (downstream) ingress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__init__()

                                            self.yang_name = "resv-ingress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-ingress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-ingress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "resv-ingress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix


                                    class ResvEgressLabel(Entity):
                                        """
                                        Resv message (downstream) egress label
                                        
                                        .. attribute:: label_type
                                        
                                        	LabelType
                                        	**type**\:   :py:class:`MplsTeMgmtGmplsLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabel>`
                                        
                                        .. attribute:: otn
                                        
                                        	Fixed\-size G09 OTN label
                                        	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn>`
                                        
                                        .. attribute:: wdm
                                        
                                        	Fixed\-grid WDM label
                                        	**type**\:   :py:class:`Wdm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__init__()

                                            self.yang_name = "resv-egress-label"
                                            self.yang_parent_name = "labels"

                                            self.label_type = YLeaf(YType.enumeration, "label-type")

                                            self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn()
                                            self.otn.parent = self
                                            self._children_name_map["otn"] = "otn"
                                            self._children_yang_names.add("otn")

                                            self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm()
                                            self.wdm.parent = self
                                            self._children_name_map["wdm"] = "wdm"
                                            self._children_yang_names.add("wdm")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("label_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel, self).__setattr__(name, value)


                                        class Wdm(Entity):
                                            """
                                            Fixed\-grid WDM label
                                            
                                            .. attribute:: channel
                                            
                                            	Channel Number
                                            	**type**\:  int
                                            
                                            	**range:** \-32768..32767
                                            
                                            .. attribute:: channel_spacing
                                            
                                            	Channel spacing
                                            	**type**\:   :py:class:`GmplsUniMgmtDwdmCs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtDwdmCs>`
                                            
                                            .. attribute:: grid
                                            
                                            	Grid
                                            	**type**\:   :py:class:`GmplsUniMgmtWdmGrid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.GmplsUniMgmtWdmGrid>`
                                            
                                            .. attribute:: identifier
                                            
                                            	Identifier
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: label_set
                                            
                                            	Flag to indicate whether label is set
                                            	**type**\:  bool
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__init__()

                                                self.yang_name = "wdm"
                                                self.yang_parent_name = "resv-egress-label"

                                                self.channel = YLeaf(YType.int16, "channel")

                                                self.channel_spacing = YLeaf(YType.enumeration, "channel-spacing")

                                                self.grid = YLeaf(YType.enumeration, "grid")

                                                self.identifier = YLeaf(YType.uint16, "identifier")

                                                self.label_set = YLeaf(YType.boolean, "label-set")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("channel",
                                                                "channel_spacing",
                                                                "grid",
                                                                "identifier",
                                                                "label_set") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.channel.is_set or
                                                    self.channel_spacing.is_set or
                                                    self.grid.is_set or
                                                    self.identifier.is_set or
                                                    self.label_set.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.channel.yfilter != YFilter.not_set or
                                                    self.channel_spacing.yfilter != YFilter.not_set or
                                                    self.grid.yfilter != YFilter.not_set or
                                                    self.identifier.yfilter != YFilter.not_set or
                                                    self.label_set.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "wdm" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.channel.is_set or self.channel.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel.get_name_leafdata())
                                                if (self.channel_spacing.is_set or self.channel_spacing.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.channel_spacing.get_name_leafdata())
                                                if (self.grid.is_set or self.grid.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.grid.get_name_leafdata())
                                                if (self.identifier.is_set or self.identifier.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.identifier.get_name_leafdata())
                                                if (self.label_set.is_set or self.label_set.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.label_set.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "channel" or name == "channel-spacing" or name == "grid" or name == "identifier" or name == "label-set"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "channel"):
                                                    self.channel = value
                                                    self.channel.value_namespace = name_space
                                                    self.channel.value_namespace_prefix = name_space_prefix
                                                if(value_path == "channel-spacing"):
                                                    self.channel_spacing = value
                                                    self.channel_spacing.value_namespace = name_space
                                                    self.channel_spacing.value_namespace_prefix = name_space_prefix
                                                if(value_path == "grid"):
                                                    self.grid = value
                                                    self.grid.value_namespace = name_space
                                                    self.grid.value_namespace_prefix = name_space_prefix
                                                if(value_path == "identifier"):
                                                    self.identifier = value
                                                    self.identifier.value_namespace = name_space
                                                    self.identifier.value_namespace_prefix = name_space_prefix
                                                if(value_path == "label-set"):
                                                    self.label_set = value
                                                    self.label_set.value_namespace = name_space
                                                    self.label_set.value_namespace_prefix = name_space_prefix


                                        class Otn(Entity):
                                            """
                                            Fixed\-size G09 OTN label
                                            
                                            .. attribute:: bit_map
                                            
                                            	Bit Map
                                            	**type**\: list of    :py:class:`BitMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap>`
                                            
                                            .. attribute:: bit_map_length
                                            
                                            	Bit map length
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: tpn
                                            
                                            	Tributary time slot
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__init__()

                                                self.yang_name = "otn"
                                                self.yang_parent_name = "resv-egress-label"

                                                self.bit_map_length = YLeaf(YType.uint16, "bit-map-length")

                                                self.tpn = YLeaf(YType.uint16, "tpn")

                                                self.bit_map = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("bit_map_length",
                                                                "tpn") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn, self).__setattr__(name, value)


                                            class BitMap(Entity):
                                                """
                                                Bit Map
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__init__()

                                                    self.yang_name = "bit-map"
                                                    self.yang_parent_name = "otn"

                                                    self.entry = YLeaf(YType.uint8, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "bit-map" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.bit_map:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.bit_map_length.is_set or
                                                    self.tpn.is_set)

                                            def has_operation(self):
                                                for c in self.bit_map:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.bit_map_length.yfilter != YFilter.not_set or
                                                    self.tpn.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "otn" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.bit_map_length.is_set or self.bit_map_length.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.bit_map_length.get_name_leafdata())
                                                if (self.tpn.is_set or self.tpn.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.tpn.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "bit-map"):
                                                    for c in self.bit_map:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn.BitMap()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.bit_map.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "bit-map" or name == "bit-map-length" or name == "tpn"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "bit-map-length"):
                                                    self.bit_map_length = value
                                                    self.bit_map_length.value_namespace = name_space
                                                    self.bit_map_length.value_namespace_prefix = name_space_prefix
                                                if(value_path == "tpn"):
                                                    self.tpn = value
                                                    self.tpn.value_namespace = name_space
                                                    self.tpn.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.label_type.is_set or
                                                (self.otn is not None and self.otn.has_data()) or
                                                (self.wdm is not None and self.wdm.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.label_type.yfilter != YFilter.not_set or
                                                (self.otn is not None and self.otn.has_operation()) or
                                                (self.wdm is not None and self.wdm.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "resv-egress-label" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.label_type.is_set or self.label_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.label_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "otn"):
                                                if (self.otn is None):
                                                    self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Otn()
                                                    self.otn.parent = self
                                                    self._children_name_map["otn"] = "otn"
                                                return self.otn

                                            if (child_yang_name == "wdm"):
                                                if (self.wdm is None):
                                                    self.wdm = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel.Wdm()
                                                    self.wdm.parent = self
                                                    self._children_name_map["wdm"] = "wdm"
                                                return self.wdm

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "otn" or name == "wdm" or name == "label-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "label-type"):
                                                self.label_type = value
                                                self.label_type.value_namespace = name_space
                                                self.label_type.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            (self.path_egress_label is not None and self.path_egress_label.has_data()) or
                                            (self.path_ingress_label is not None and self.path_ingress_label.has_data()) or
                                            (self.resv_egress_label is not None and self.resv_egress_label.has_data()) or
                                            (self.resv_ingress_label is not None and self.resv_ingress_label.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.path_egress_label is not None and self.path_egress_label.has_operation()) or
                                            (self.path_ingress_label is not None and self.path_ingress_label.has_operation()) or
                                            (self.resv_egress_label is not None and self.resv_egress_label.has_operation()) or
                                            (self.resv_ingress_label is not None and self.resv_ingress_label.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "labels" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "path-egress-label"):
                                            if (self.path_egress_label is None):
                                                self.path_egress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathEgressLabel()
                                                self.path_egress_label.parent = self
                                                self._children_name_map["path_egress_label"] = "path-egress-label"
                                            return self.path_egress_label

                                        if (child_yang_name == "path-ingress-label"):
                                            if (self.path_ingress_label is None):
                                                self.path_ingress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.PathIngressLabel()
                                                self.path_ingress_label.parent = self
                                                self._children_name_map["path_ingress_label"] = "path-ingress-label"
                                            return self.path_ingress_label

                                        if (child_yang_name == "resv-egress-label"):
                                            if (self.resv_egress_label is None):
                                                self.resv_egress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvEgressLabel()
                                                self.resv_egress_label.parent = self
                                                self._children_name_map["resv_egress_label"] = "resv-egress-label"
                                            return self.resv_egress_label

                                        if (child_yang_name == "resv-ingress-label"):
                                            if (self.resv_ingress_label is None):
                                                self.resv_ingress_label = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels.ResvIngressLabel()
                                                self.resv_ingress_label.parent = self
                                                self._children_name_map["resv_ingress_label"] = "resv-ingress-label"
                                            return self.resv_ingress_label

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "path-egress-label" or name == "path-ingress-label" or name == "resv-egress-label" or name == "resv-ingress-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass

                                def has_data(self):
                                    return (
                                        self.cross_connect_id.is_set or
                                        self.gpid.is_set or
                                        self.incoming_controller.is_set or
                                        self.incoming_controller_ifhandle.is_set or
                                        self.incoming_controller_state.is_set or
                                        self.incoming_sub_controller.is_set or
                                        self.incoming_sub_controller_ifhandle.is_set or
                                        self.incoming_sub_controller_state.is_set or
                                        self.is_connected.is_set or
                                        self.outgoing_controller.is_set or
                                        self.outgoing_controller_ifhandle.is_set or
                                        self.outgoing_controller_state.is_set or
                                        self.outgoing_sub_controller.is_set or
                                        self.outgoing_sub_controller_ifhandle.is_set or
                                        self.outgoing_sub_controller_state.is_set or
                                        self.uptime.is_set or
                                        (self.bandwidth is not None and self.bandwidth.has_data()) or
                                        (self.labels is not None and self.labels.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.cross_connect_id.yfilter != YFilter.not_set or
                                        self.gpid.yfilter != YFilter.not_set or
                                        self.incoming_controller.yfilter != YFilter.not_set or
                                        self.incoming_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.incoming_controller_state.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.incoming_sub_controller_state.yfilter != YFilter.not_set or
                                        self.is_connected.yfilter != YFilter.not_set or
                                        self.outgoing_controller.yfilter != YFilter.not_set or
                                        self.outgoing_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.outgoing_controller_state.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller_ifhandle.yfilter != YFilter.not_set or
                                        self.outgoing_sub_controller_state.yfilter != YFilter.not_set or
                                        self.uptime.yfilter != YFilter.not_set or
                                        (self.bandwidth is not None and self.bandwidth.has_operation()) or
                                        (self.labels is not None and self.labels.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "otn" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.cross_connect_id.is_set or self.cross_connect_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.cross_connect_id.get_name_leafdata())
                                    if (self.gpid.is_set or self.gpid.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.gpid.get_name_leafdata())
                                    if (self.incoming_controller.is_set or self.incoming_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller.get_name_leafdata())
                                    if (self.incoming_controller_ifhandle.is_set or self.incoming_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller_ifhandle.get_name_leafdata())
                                    if (self.incoming_controller_state.is_set or self.incoming_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_controller_state.get_name_leafdata())
                                    if (self.incoming_sub_controller.is_set or self.incoming_sub_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller.get_name_leafdata())
                                    if (self.incoming_sub_controller_ifhandle.is_set or self.incoming_sub_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller_ifhandle.get_name_leafdata())
                                    if (self.incoming_sub_controller_state.is_set or self.incoming_sub_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.incoming_sub_controller_state.get_name_leafdata())
                                    if (self.is_connected.is_set or self.is_connected.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_connected.get_name_leafdata())
                                    if (self.outgoing_controller.is_set or self.outgoing_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller.get_name_leafdata())
                                    if (self.outgoing_controller_ifhandle.is_set or self.outgoing_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller_ifhandle.get_name_leafdata())
                                    if (self.outgoing_controller_state.is_set or self.outgoing_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_controller_state.get_name_leafdata())
                                    if (self.outgoing_sub_controller.is_set or self.outgoing_sub_controller.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller.get_name_leafdata())
                                    if (self.outgoing_sub_controller_ifhandle.is_set or self.outgoing_sub_controller_ifhandle.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller_ifhandle.get_name_leafdata())
                                    if (self.outgoing_sub_controller_state.is_set or self.outgoing_sub_controller_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.outgoing_sub_controller_state.get_name_leafdata())
                                    if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.uptime.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "bandwidth"):
                                        if (self.bandwidth is None):
                                            self.bandwidth = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Bandwidth()
                                            self.bandwidth.parent = self
                                            self._children_name_map["bandwidth"] = "bandwidth"
                                        return self.bandwidth

                                    if (child_yang_name == "labels"):
                                        if (self.labels is None):
                                            self.labels = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn.Labels()
                                            self.labels.parent = self
                                            self._children_name_map["labels"] = "labels"
                                        return self.labels

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bandwidth" or name == "labels" or name == "cross-connect-id" or name == "gpid" or name == "incoming-controller" or name == "incoming-controller-ifhandle" or name == "incoming-controller-state" or name == "incoming-sub-controller" or name == "incoming-sub-controller-ifhandle" or name == "incoming-sub-controller-state" or name == "is-connected" or name == "outgoing-controller" or name == "outgoing-controller-ifhandle" or name == "outgoing-controller-state" or name == "outgoing-sub-controller" or name == "outgoing-sub-controller-ifhandle" or name == "outgoing-sub-controller-state" or name == "uptime"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "cross-connect-id"):
                                        self.cross_connect_id = value
                                        self.cross_connect_id.value_namespace = name_space
                                        self.cross_connect_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "gpid"):
                                        self.gpid = value
                                        self.gpid.value_namespace = name_space
                                        self.gpid.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller"):
                                        self.incoming_controller = value
                                        self.incoming_controller.value_namespace = name_space
                                        self.incoming_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller-ifhandle"):
                                        self.incoming_controller_ifhandle = value
                                        self.incoming_controller_ifhandle.value_namespace = name_space
                                        self.incoming_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-controller-state"):
                                        self.incoming_controller_state = value
                                        self.incoming_controller_state.value_namespace = name_space
                                        self.incoming_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller"):
                                        self.incoming_sub_controller = value
                                        self.incoming_sub_controller.value_namespace = name_space
                                        self.incoming_sub_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller-ifhandle"):
                                        self.incoming_sub_controller_ifhandle = value
                                        self.incoming_sub_controller_ifhandle.value_namespace = name_space
                                        self.incoming_sub_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "incoming-sub-controller-state"):
                                        self.incoming_sub_controller_state = value
                                        self.incoming_sub_controller_state.value_namespace = name_space
                                        self.incoming_sub_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-connected"):
                                        self.is_connected = value
                                        self.is_connected.value_namespace = name_space
                                        self.is_connected.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller"):
                                        self.outgoing_controller = value
                                        self.outgoing_controller.value_namespace = name_space
                                        self.outgoing_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller-ifhandle"):
                                        self.outgoing_controller_ifhandle = value
                                        self.outgoing_controller_ifhandle.value_namespace = name_space
                                        self.outgoing_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-controller-state"):
                                        self.outgoing_controller_state = value
                                        self.outgoing_controller_state.value_namespace = name_space
                                        self.outgoing_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller"):
                                        self.outgoing_sub_controller = value
                                        self.outgoing_sub_controller.value_namespace = name_space
                                        self.outgoing_sub_controller.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller-ifhandle"):
                                        self.outgoing_sub_controller_ifhandle = value
                                        self.outgoing_sub_controller_ifhandle.value_namespace = name_space
                                        self.outgoing_sub_controller_ifhandle.value_namespace_prefix = name_space_prefix
                                    if(value_path == "outgoing-sub-controller-state"):
                                        self.outgoing_sub_controller_state = value
                                        self.outgoing_sub_controller_state.value_namespace = name_space
                                        self.outgoing_sub_controller_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "uptime"):
                                        self.uptime = value
                                        self.uptime.value_namespace = name_space
                                        self.uptime.value_namespace_prefix = name_space_prefix


                            class Aps(Entity):
                                """
                                APS Info for OTN S2L
                                
                                .. attribute:: protection_info
                                
                                	Protection Info
                                	**type**\:   :py:class:`ProtectionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Aps.ProtectionInfo>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Aps, self).__init__()

                                    self.yang_name = "aps"
                                    self.yang_parent_name = "otn-s2l"

                                    self.protection_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Aps.ProtectionInfo()
                                    self.protection_info.parent = self
                                    self._children_name_map["protection_info"] = "protection-info"
                                    self._children_yang_names.add("protection-info")


                                class ProtectionInfo(Entity):
                                    """
                                    Protection Info
                                    
                                    .. attribute:: ho_timeout
                                    
                                    	Hold\-Off timeout
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: is_hopresent
                                    
                                    	Is Hold\-Off timeout present
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_snc_mode_present
                                    
                                    	Is SNC mode present
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_wtr_present
                                    
                                    	Is Wait\-to\-Restore timeout present
                                    	**type**\:  bool
                                    
                                    .. attribute:: nbit
                                    
                                    	Notification bit 
                                    	**type**\:  bool
                                    
                                    .. attribute:: obit
                                    
                                    	Operational bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path protection profile type
                                    	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    .. attribute:: pbit
                                    
                                    	Protecting bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: protect_type
                                    
                                    	LSP Protect Type
                                    	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    .. attribute:: sbit
                                    
                                    	Secondary bit
                                    	**type**\:  bool
                                    
                                    .. attribute:: snc_mode
                                    
                                    	SNC mode
                                    	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    .. attribute:: tcm_id
                                    
                                    	TCM ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: wtr_timeout
                                    
                                    	Wait\-to\-Restore timeout
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__init__()

                                        self.yang_name = "protection-info"
                                        self.yang_parent_name = "aps"

                                        self.ho_timeout = YLeaf(YType.uint32, "ho-timeout")

                                        self.is_hopresent = YLeaf(YType.boolean, "is-hopresent")

                                        self.is_snc_mode_present = YLeaf(YType.boolean, "is-snc-mode-present")

                                        self.is_wtr_present = YLeaf(YType.boolean, "is-wtr-present")

                                        self.nbit = YLeaf(YType.boolean, "nbit")

                                        self.obit = YLeaf(YType.boolean, "obit")

                                        self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                        self.pbit = YLeaf(YType.boolean, "pbit")

                                        self.protect_type = YLeaf(YType.enumeration, "protect-type")

                                        self.sbit = YLeaf(YType.boolean, "sbit")

                                        self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                        self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                        self.wtr_timeout = YLeaf(YType.uint32, "wtr-timeout")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("ho_timeout",
                                                        "is_hopresent",
                                                        "is_snc_mode_present",
                                                        "is_wtr_present",
                                                        "nbit",
                                                        "obit",
                                                        "path_prot_profile_type",
                                                        "pbit",
                                                        "protect_type",
                                                        "sbit",
                                                        "snc_mode",
                                                        "tcm_id",
                                                        "wtr_timeout") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Aps.ProtectionInfo, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.ho_timeout.is_set or
                                            self.is_hopresent.is_set or
                                            self.is_snc_mode_present.is_set or
                                            self.is_wtr_present.is_set or
                                            self.nbit.is_set or
                                            self.obit.is_set or
                                            self.path_prot_profile_type.is_set or
                                            self.pbit.is_set or
                                            self.protect_type.is_set or
                                            self.sbit.is_set or
                                            self.snc_mode.is_set or
                                            self.tcm_id.is_set or
                                            self.wtr_timeout.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.ho_timeout.yfilter != YFilter.not_set or
                                            self.is_hopresent.yfilter != YFilter.not_set or
                                            self.is_snc_mode_present.yfilter != YFilter.not_set or
                                            self.is_wtr_present.yfilter != YFilter.not_set or
                                            self.nbit.yfilter != YFilter.not_set or
                                            self.obit.yfilter != YFilter.not_set or
                                            self.path_prot_profile_type.yfilter != YFilter.not_set or
                                            self.pbit.yfilter != YFilter.not_set or
                                            self.protect_type.yfilter != YFilter.not_set or
                                            self.sbit.yfilter != YFilter.not_set or
                                            self.snc_mode.yfilter != YFilter.not_set or
                                            self.tcm_id.yfilter != YFilter.not_set or
                                            self.wtr_timeout.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "protection-info" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.ho_timeout.is_set or self.ho_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.ho_timeout.get_name_leafdata())
                                        if (self.is_hopresent.is_set or self.is_hopresent.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_hopresent.get_name_leafdata())
                                        if (self.is_snc_mode_present.is_set or self.is_snc_mode_present.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_snc_mode_present.get_name_leafdata())
                                        if (self.is_wtr_present.is_set or self.is_wtr_present.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_wtr_present.get_name_leafdata())
                                        if (self.nbit.is_set or self.nbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.nbit.get_name_leafdata())
                                        if (self.obit.is_set or self.obit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.obit.get_name_leafdata())
                                        if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                        if (self.pbit.is_set or self.pbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pbit.get_name_leafdata())
                                        if (self.protect_type.is_set or self.protect_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.protect_type.get_name_leafdata())
                                        if (self.sbit.is_set or self.sbit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.sbit.get_name_leafdata())
                                        if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                        if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                        if (self.wtr_timeout.is_set or self.wtr_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.wtr_timeout.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "ho-timeout" or name == "is-hopresent" or name == "is-snc-mode-present" or name == "is-wtr-present" or name == "nbit" or name == "obit" or name == "path-prot-profile-type" or name == "pbit" or name == "protect-type" or name == "sbit" or name == "snc-mode" or name == "tcm-id" or name == "wtr-timeout"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "ho-timeout"):
                                            self.ho_timeout = value
                                            self.ho_timeout.value_namespace = name_space
                                            self.ho_timeout.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-hopresent"):
                                            self.is_hopresent = value
                                            self.is_hopresent.value_namespace = name_space
                                            self.is_hopresent.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-snc-mode-present"):
                                            self.is_snc_mode_present = value
                                            self.is_snc_mode_present.value_namespace = name_space
                                            self.is_snc_mode_present.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-wtr-present"):
                                            self.is_wtr_present = value
                                            self.is_wtr_present.value_namespace = name_space
                                            self.is_wtr_present.value_namespace_prefix = name_space_prefix
                                        if(value_path == "nbit"):
                                            self.nbit = value
                                            self.nbit.value_namespace = name_space
                                            self.nbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "obit"):
                                            self.obit = value
                                            self.obit.value_namespace = name_space
                                            self.obit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-prot-profile-type"):
                                            self.path_prot_profile_type = value
                                            self.path_prot_profile_type.value_namespace = name_space
                                            self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pbit"):
                                            self.pbit = value
                                            self.pbit.value_namespace = name_space
                                            self.pbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "protect-type"):
                                            self.protect_type = value
                                            self.protect_type.value_namespace = name_space
                                            self.protect_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "sbit"):
                                            self.sbit = value
                                            self.sbit.value_namespace = name_space
                                            self.sbit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "snc-mode"):
                                            self.snc_mode = value
                                            self.snc_mode.value_namespace = name_space
                                            self.snc_mode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcm-id"):
                                            self.tcm_id = value
                                            self.tcm_id.value_namespace = name_space
                                            self.tcm_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "wtr-timeout"):
                                            self.wtr_timeout = value
                                            self.wtr_timeout.value_namespace = name_space
                                            self.wtr_timeout.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (self.protection_info is not None and self.protection_info.has_data())

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        (self.protection_info is not None and self.protection_info.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "aps" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "protection-info"):
                                        if (self.protection_info is None):
                                            self.protection_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Aps.ProtectionInfo()
                                            self.protection_info.parent = self
                                            self._children_name_map["protection_info"] = "protection-info"
                                        return self.protection_info

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "protection-info"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    (self.aps is not None and self.aps.has_data()) or
                                    (self.otn is not None and self.otn.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.aps is not None and self.aps.has_operation()) or
                                    (self.otn is not None and self.otn.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "otn-s2l" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "aps"):
                                    if (self.aps is None):
                                        self.aps = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Aps()
                                        self.aps.parent = self
                                        self._children_name_map["aps"] = "aps"
                                    return self.aps

                                if (child_yang_name == "otn"):
                                    if (self.otn is None):
                                        self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L.Otn()
                                        self.otn.parent = self
                                        self._children_name_map["otn"] = "otn"
                                    return self.otn

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "aps" or name == "otn"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class HeadEndBfdInfo(Entity):
                            """
                            The Head\-end BFD info
                            
                            .. attribute:: bfd_reverse_path_label
                            
                            	BFD reverse path labels
                            	**type**\: list of    :py:class:`BfdReversePathLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel>`
                            
                            .. attribute:: bfd_reverse_path_stale
                            
                            	The BFD reverse path is stale compared to configuration
                            	**type**\:  bool
                            
                            .. attribute:: creation_time
                            
                            	Time in seconds since the BFD session created
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: deletion_history
                            
                            	BFD Session Deletion History
                            	**type**\:   :py:class:`DeletionHistory <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.HeadEndBfdInfo.DeletionHistory>`
                            
                            .. attribute:: is_redundant
                            
                            	sBFD session is redundant
                            	**type**\:  bool
                            
                            .. attribute:: lspbfd_type
                            
                            	LSP BFD type
                            	**type**\:   :py:class:`TeVifBfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfd>`
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:   :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.HeadEndBfdInfo.SessionInfo>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.HeadEndBfdInfo, self).__init__()

                                self.yang_name = "head-end-bfd-info"
                                self.yang_parent_name = "s2l"

                                self.bfd_reverse_path_stale = YLeaf(YType.boolean, "bfd-reverse-path-stale")

                                self.creation_time = YLeaf(YType.uint32, "creation-time")

                                self.is_redundant = YLeaf(YType.boolean, "is-redundant")

                                self.lspbfd_type = YLeaf(YType.enumeration, "lspbfd-type")

                                self.deletion_history = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.HeadEndBfdInfo.DeletionHistory()
                                self.deletion_history.parent = self
                                self._children_name_map["deletion_history"] = "deletion-history"
                                self._children_yang_names.add("deletion-history")

                                self.session_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.HeadEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._children_yang_names.add("session-info")

                                self.bfd_reverse_path_label = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("bfd_reverse_path_stale",
                                                "creation_time",
                                                "is_redundant",
                                                "lspbfd_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.HeadEndBfdInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.HeadEndBfdInfo, self).__setattr__(name, value)


                            class SessionInfo(Entity):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:   :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.state = YLeaf(YType.enumeration, "state")

                                    self.state_change_time = YLeaf(YType.uint32, "state-change-time")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("state",
                                                    "state_change_time") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.HeadEndBfdInfo.SessionInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.state.is_set or
                                        self.state_change_time.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.state.yfilter != YFilter.not_set or
                                        self.state_change_time.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "session-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state.get_name_leafdata())
                                    if (self.state_change_time.is_set or self.state_change_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state_change_time.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "state" or name == "state-change-time"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "state"):
                                        self.state = value
                                        self.state.value_namespace = name_space
                                        self.state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "state-change-time"):
                                        self.state_change_time = value
                                        self.state_change_time.value_namespace = name_space
                                        self.state_change_time.value_namespace_prefix = name_space_prefix


                            class DeletionHistory(Entity):
                                """
                                BFD Session Deletion History
                                
                                .. attribute:: deletion_diagnostic_code
                                
                                	Diagnostic Code for the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: deletion_reason
                                
                                	Reason for the BFD session get deleted
                                	**type**\:  str
                                
                                .. attribute:: deletion_time
                                
                                	Time stamp of the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: lsp_id
                                
                                	LSP ID of the BFD session get deleted
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__init__()

                                    self.yang_name = "deletion-history"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.deletion_diagnostic_code = YLeaf(YType.uint32, "deletion-diagnostic-code")

                                    self.deletion_reason = YLeaf(YType.str, "deletion-reason")

                                    self.deletion_time = YLeaf(YType.uint32, "deletion-time")

                                    self.lsp_id = YLeaf(YType.uint16, "lsp-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("deletion_diagnostic_code",
                                                    "deletion_reason",
                                                    "deletion_time",
                                                    "lsp_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.HeadEndBfdInfo.DeletionHistory, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.deletion_diagnostic_code.is_set or
                                        self.deletion_reason.is_set or
                                        self.deletion_time.is_set or
                                        self.lsp_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.deletion_diagnostic_code.yfilter != YFilter.not_set or
                                        self.deletion_reason.yfilter != YFilter.not_set or
                                        self.deletion_time.yfilter != YFilter.not_set or
                                        self.lsp_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "deletion-history" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.deletion_diagnostic_code.is_set or self.deletion_diagnostic_code.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_diagnostic_code.get_name_leafdata())
                                    if (self.deletion_reason.is_set or self.deletion_reason.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_reason.get_name_leafdata())
                                    if (self.deletion_time.is_set or self.deletion_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.deletion_time.get_name_leafdata())
                                    if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "deletion-diagnostic-code" or name == "deletion-reason" or name == "deletion-time" or name == "lsp-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "deletion-diagnostic-code"):
                                        self.deletion_diagnostic_code = value
                                        self.deletion_diagnostic_code.value_namespace = name_space
                                        self.deletion_diagnostic_code.value_namespace_prefix = name_space_prefix
                                    if(value_path == "deletion-reason"):
                                        self.deletion_reason = value
                                        self.deletion_reason.value_namespace = name_space
                                        self.deletion_reason.value_namespace_prefix = name_space_prefix
                                    if(value_path == "deletion-time"):
                                        self.deletion_time = value
                                        self.deletion_time.value_namespace = name_space
                                        self.deletion_time.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-id"):
                                        self.lsp_id = value
                                        self.lsp_id.value_namespace = name_space
                                        self.lsp_id.value_namespace_prefix = name_space_prefix


                            class BfdReversePathLabel(Entity):
                                """
                                BFD reverse path labels
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__init__()

                                    self.yang_name = "bfd-reverse-path-label"
                                    self.yang_parent_name = "head-end-bfd-info"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "bfd-reverse-path-label" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.bfd_reverse_path_label:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.bfd_reverse_path_stale.is_set or
                                    self.creation_time.is_set or
                                    self.is_redundant.is_set or
                                    self.lspbfd_type.is_set or
                                    (self.deletion_history is not None and self.deletion_history.has_data()) or
                                    (self.session_info is not None and self.session_info.has_data()))

                            def has_operation(self):
                                for c in self.bfd_reverse_path_label:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.bfd_reverse_path_stale.yfilter != YFilter.not_set or
                                    self.creation_time.yfilter != YFilter.not_set or
                                    self.is_redundant.yfilter != YFilter.not_set or
                                    self.lspbfd_type.yfilter != YFilter.not_set or
                                    (self.deletion_history is not None and self.deletion_history.has_operation()) or
                                    (self.session_info is not None and self.session_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "head-end-bfd-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.bfd_reverse_path_stale.is_set or self.bfd_reverse_path_stale.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_reverse_path_stale.get_name_leafdata())
                                if (self.creation_time.is_set or self.creation_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.creation_time.get_name_leafdata())
                                if (self.is_redundant.is_set or self.is_redundant.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_redundant.get_name_leafdata())
                                if (self.lspbfd_type.is_set or self.lspbfd_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lspbfd_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "bfd-reverse-path-label"):
                                    for c in self.bfd_reverse_path_label:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.HeadEndBfdInfo.BfdReversePathLabel()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.bfd_reverse_path_label.append(c)
                                    return c

                                if (child_yang_name == "deletion-history"):
                                    if (self.deletion_history is None):
                                        self.deletion_history = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.HeadEndBfdInfo.DeletionHistory()
                                        self.deletion_history.parent = self
                                        self._children_name_map["deletion_history"] = "deletion-history"
                                    return self.deletion_history

                                if (child_yang_name == "session-info"):
                                    if (self.session_info is None):
                                        self.session_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.HeadEndBfdInfo.SessionInfo()
                                        self.session_info.parent = self
                                        self._children_name_map["session_info"] = "session-info"
                                    return self.session_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "bfd-reverse-path-label" or name == "deletion-history" or name == "session-info" or name == "bfd-reverse-path-stale" or name == "creation-time" or name == "is-redundant" or name == "lspbfd-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "bfd-reverse-path-stale"):
                                    self.bfd_reverse_path_stale = value
                                    self.bfd_reverse_path_stale.value_namespace = name_space
                                    self.bfd_reverse_path_stale.value_namespace_prefix = name_space_prefix
                                if(value_path == "creation-time"):
                                    self.creation_time = value
                                    self.creation_time.value_namespace = name_space
                                    self.creation_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-redundant"):
                                    self.is_redundant = value
                                    self.is_redundant.value_namespace = name_space
                                    self.is_redundant.value_namespace_prefix = name_space_prefix
                                if(value_path == "lspbfd-type"):
                                    self.lspbfd_type = value
                                    self.lspbfd_type.value_namespace = name_space
                                    self.lspbfd_type.value_namespace_prefix = name_space_prefix


                        class TailEndBfdInfo(Entity):
                            """
                            The Tail\-end BFD info
                            
                            .. attribute:: failure_diagnostic_code
                            
                            	BFD session failure diagnostic code
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: failure_reason
                            
                            	BFD session failure reason
                            	**type**\:  str
                            
                            .. attribute:: local_discriminator
                            
                            	BFD Local Discriminator
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: min_interval
                            
                            	Hello interval in mini second
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: min_interval_default
                            
                            	Is default hello interval
                            	**type**\:  bool
                            
                            .. attribute:: multiplier
                            
                            	Multiplier
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: multiplier_default
                            
                            	Is default multiplier
                            	**type**\:  bool
                            
                            .. attribute:: remote_discriminator
                            
                            	BFD Remote Discrminator
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: session_info
                            
                            	BFD Session Info
                            	**type**\:   :py:class:`SessionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.TailEndBfdInfo.SessionInfo>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.TailEndBfdInfo, self).__init__()

                                self.yang_name = "tail-end-bfd-info"
                                self.yang_parent_name = "s2l"

                                self.failure_diagnostic_code = YLeaf(YType.uint32, "failure-diagnostic-code")

                                self.failure_reason = YLeaf(YType.str, "failure-reason")

                                self.local_discriminator = YLeaf(YType.uint32, "local-discriminator")

                                self.min_interval = YLeaf(YType.uint32, "min-interval")

                                self.min_interval_default = YLeaf(YType.boolean, "min-interval-default")

                                self.multiplier = YLeaf(YType.uint8, "multiplier")

                                self.multiplier_default = YLeaf(YType.boolean, "multiplier-default")

                                self.remote_discriminator = YLeaf(YType.uint32, "remote-discriminator")

                                self.session_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.TailEndBfdInfo.SessionInfo()
                                self.session_info.parent = self
                                self._children_name_map["session_info"] = "session-info"
                                self._children_yang_names.add("session-info")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("failure_diagnostic_code",
                                                "failure_reason",
                                                "local_discriminator",
                                                "min_interval",
                                                "min_interval_default",
                                                "multiplier",
                                                "multiplier_default",
                                                "remote_discriminator") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.TailEndBfdInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.TailEndBfdInfo, self).__setattr__(name, value)


                            class SessionInfo(Entity):
                                """
                                BFD Session Info
                                
                                .. attribute:: state
                                
                                	BFD session state
                                	**type**\:   :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                                
                                .. attribute:: state_change_time
                                
                                	Time in seconds since the last session state change
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: second
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.TailEndBfdInfo.SessionInfo, self).__init__()

                                    self.yang_name = "session-info"
                                    self.yang_parent_name = "tail-end-bfd-info"

                                    self.state = YLeaf(YType.enumeration, "state")

                                    self.state_change_time = YLeaf(YType.uint32, "state-change-time")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("state",
                                                    "state_change_time") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.TailEndBfdInfo.SessionInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.TailEndBfdInfo.SessionInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.state.is_set or
                                        self.state_change_time.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.state.yfilter != YFilter.not_set or
                                        self.state_change_time.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "session-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.state.is_set or self.state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state.get_name_leafdata())
                                    if (self.state_change_time.is_set or self.state_change_time.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.state_change_time.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "state" or name == "state-change-time"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "state"):
                                        self.state = value
                                        self.state.value_namespace = name_space
                                        self.state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "state-change-time"):
                                        self.state_change_time = value
                                        self.state_change_time.value_namespace = name_space
                                        self.state_change_time.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.failure_diagnostic_code.is_set or
                                    self.failure_reason.is_set or
                                    self.local_discriminator.is_set or
                                    self.min_interval.is_set or
                                    self.min_interval_default.is_set or
                                    self.multiplier.is_set or
                                    self.multiplier_default.is_set or
                                    self.remote_discriminator.is_set or
                                    (self.session_info is not None and self.session_info.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.failure_diagnostic_code.yfilter != YFilter.not_set or
                                    self.failure_reason.yfilter != YFilter.not_set or
                                    self.local_discriminator.yfilter != YFilter.not_set or
                                    self.min_interval.yfilter != YFilter.not_set or
                                    self.min_interval_default.yfilter != YFilter.not_set or
                                    self.multiplier.yfilter != YFilter.not_set or
                                    self.multiplier_default.yfilter != YFilter.not_set or
                                    self.remote_discriminator.yfilter != YFilter.not_set or
                                    (self.session_info is not None and self.session_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "tail-end-bfd-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.failure_diagnostic_code.is_set or self.failure_diagnostic_code.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.failure_diagnostic_code.get_name_leafdata())
                                if (self.failure_reason.is_set or self.failure_reason.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.failure_reason.get_name_leafdata())
                                if (self.local_discriminator.is_set or self.local_discriminator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_discriminator.get_name_leafdata())
                                if (self.min_interval.is_set or self.min_interval.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.min_interval.get_name_leafdata())
                                if (self.min_interval_default.is_set or self.min_interval_default.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.min_interval_default.get_name_leafdata())
                                if (self.multiplier.is_set or self.multiplier.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.multiplier.get_name_leafdata())
                                if (self.multiplier_default.is_set or self.multiplier_default.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.multiplier_default.get_name_leafdata())
                                if (self.remote_discriminator.is_set or self.remote_discriminator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.remote_discriminator.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "session-info"):
                                    if (self.session_info is None):
                                        self.session_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.TailEndBfdInfo.SessionInfo()
                                        self.session_info.parent = self
                                        self._children_name_map["session_info"] = "session-info"
                                    return self.session_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "session-info" or name == "failure-diagnostic-code" or name == "failure-reason" or name == "local-discriminator" or name == "min-interval" or name == "min-interval-default" or name == "multiplier" or name == "multiplier-default" or name == "remote-discriminator"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "failure-diagnostic-code"):
                                    self.failure_diagnostic_code = value
                                    self.failure_diagnostic_code.value_namespace = name_space
                                    self.failure_diagnostic_code.value_namespace_prefix = name_space_prefix
                                if(value_path == "failure-reason"):
                                    self.failure_reason = value
                                    self.failure_reason.value_namespace = name_space
                                    self.failure_reason.value_namespace_prefix = name_space_prefix
                                if(value_path == "local-discriminator"):
                                    self.local_discriminator = value
                                    self.local_discriminator.value_namespace = name_space
                                    self.local_discriminator.value_namespace_prefix = name_space_prefix
                                if(value_path == "min-interval"):
                                    self.min_interval = value
                                    self.min_interval.value_namespace = name_space
                                    self.min_interval.value_namespace_prefix = name_space_prefix
                                if(value_path == "min-interval-default"):
                                    self.min_interval_default = value
                                    self.min_interval_default.value_namespace = name_space
                                    self.min_interval_default.value_namespace_prefix = name_space_prefix
                                if(value_path == "multiplier"):
                                    self.multiplier = value
                                    self.multiplier.value_namespace = name_space
                                    self.multiplier.value_namespace_prefix = name_space_prefix
                                if(value_path == "multiplier-default"):
                                    self.multiplier_default = value
                                    self.multiplier_default.value_namespace = name_space
                                    self.multiplier_default.value_namespace_prefix = name_space_prefix
                                if(value_path == "remote-discriminator"):
                                    self.remote_discriminator = value
                                    self.remote_discriminator.value_namespace = name_space
                                    self.remote_discriminator.value_namespace_prefix = name_space_prefix


                        class SrlgCollection(Entity):
                            """
                            SRLG\-collection data
                            
                            .. attribute:: discovered_srlg
                            
                            	Discovered SRLGs
                            	**type**\: list of    :py:class:`DiscoveredSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.SrlgCollection.DiscoveredSrlg>`
                            
                            .. attribute:: srlg_collect_type
                            
                            	SRLG\-collection mechanism
                            	**type**\:   :py:class:`TeSrlgCollectRequest <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrlgCollectRequest>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.SrlgCollection, self).__init__()

                                self.yang_name = "srlg-collection"
                                self.yang_parent_name = "s2l"

                                self.srlg_collect_type = YLeaf(YType.enumeration, "srlg-collect-type")

                                self.discovered_srlg = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("srlg_collect_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.SrlgCollection, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.SrlgCollection, self).__setattr__(name, value)


                            class DiscoveredSrlg(Entity):
                                """
                                Discovered SRLGs
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__init__()

                                    self.yang_name = "discovered-srlg"
                                    self.yang_parent_name = "srlg-collection"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.SrlgCollection.DiscoveredSrlg, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "discovered-srlg" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.discovered_srlg:
                                    if (c.has_data()):
                                        return True
                                return self.srlg_collect_type.is_set

                            def has_operation(self):
                                for c in self.discovered_srlg:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.srlg_collect_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "srlg-collection" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.srlg_collect_type.is_set or self.srlg_collect_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.srlg_collect_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "discovered-srlg"):
                                    for c in self.discovered_srlg:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.SrlgCollection.DiscoveredSrlg()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.discovered_srlg.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "discovered-srlg" or name == "srlg-collect-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "srlg-collect-type"):
                                    self.srlg_collect_type = value
                                    self.srlg_collect_type.value_namespace = name_space
                                    self.srlg_collect_type.value_namespace_prefix = name_space_prefix


                        class Association(Entity):
                            """
                            Association Object
                            
                            .. attribute:: s2l_association_id
                            
                            	S2L Association ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_association_source
                            
                            	S2L Association Source
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_association_tie_role
                            
                            	S2L Association Tie Role
                            	**type**\:   :py:class:`TeAssociationTieRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAssociationTieRole>`
                            
                            .. attribute:: s2l_association_type
                            
                            	S2L Association Type                          (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_extended_id
                            
                            	S2L Extended ID Array
                            	**type**\: list of    :py:class:`S2LExtendedId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.Association.S2LExtendedId>`
                            
                            .. attribute:: s2l_global_source
                            
                            	S2L Global Source
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.Association, self).__init__()

                                self.yang_name = "association"
                                self.yang_parent_name = "s2l"

                                self.s2l_association_id = YLeaf(YType.uint16, "s2l-association-id")

                                self.s2l_association_source = YLeaf(YType.str, "s2l-association-source")

                                self.s2l_association_tie_role = YLeaf(YType.enumeration, "s2l-association-tie-role")

                                self.s2l_association_type = YLeaf(YType.uint16, "s2l-association-type")

                                self.s2l_global_source = YLeaf(YType.uint32, "s2l-global-source")

                                self.s2l_extended_id = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("s2l_association_id",
                                                "s2l_association_source",
                                                "s2l_association_tie_role",
                                                "s2l_association_type",
                                                "s2l_global_source") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.Association, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.Association, self).__setattr__(name, value)


                            class S2LExtendedId(Entity):
                                """
                                S2L Extended ID Array
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.Association.S2LExtendedId, self).__init__()

                                    self.yang_name = "s2l-extended-id"
                                    self.yang_parent_name = "association"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.Association.S2LExtendedId, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.Association.S2LExtendedId, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "s2l-extended-id" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.s2l_extended_id:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.s2l_association_id.is_set or
                                    self.s2l_association_source.is_set or
                                    self.s2l_association_tie_role.is_set or
                                    self.s2l_association_type.is_set or
                                    self.s2l_global_source.is_set)

                            def has_operation(self):
                                for c in self.s2l_extended_id:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.s2l_association_id.yfilter != YFilter.not_set or
                                    self.s2l_association_source.yfilter != YFilter.not_set or
                                    self.s2l_association_tie_role.yfilter != YFilter.not_set or
                                    self.s2l_association_type.yfilter != YFilter.not_set or
                                    self.s2l_global_source.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "association" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.s2l_association_id.is_set or self.s2l_association_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_id.get_name_leafdata())
                                if (self.s2l_association_source.is_set or self.s2l_association_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_source.get_name_leafdata())
                                if (self.s2l_association_tie_role.is_set or self.s2l_association_tie_role.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_tie_role.get_name_leafdata())
                                if (self.s2l_association_type.is_set or self.s2l_association_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_type.get_name_leafdata())
                                if (self.s2l_global_source.is_set or self.s2l_global_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_global_source.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "s2l-extended-id"):
                                    for c in self.s2l_extended_id:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.Association.S2LExtendedId()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.s2l_extended_id.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "s2l-extended-id" or name == "s2l-association-id" or name == "s2l-association-source" or name == "s2l-association-tie-role" or name == "s2l-association-type" or name == "s2l-global-source"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "s2l-association-id"):
                                    self.s2l_association_id = value
                                    self.s2l_association_id.value_namespace = name_space
                                    self.s2l_association_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-source"):
                                    self.s2l_association_source = value
                                    self.s2l_association_source.value_namespace = name_space
                                    self.s2l_association_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-tie-role"):
                                    self.s2l_association_tie_role = value
                                    self.s2l_association_tie_role.value_namespace = name_space
                                    self.s2l_association_tie_role.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-type"):
                                    self.s2l_association_type = value
                                    self.s2l_association_type.value_namespace = name_space
                                    self.s2l_association_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-global-source"):
                                    self.s2l_global_source = value
                                    self.s2l_global_source.value_namespace = name_space
                                    self.s2l_global_source.value_namespace_prefix = name_space_prefix


                        class Protection(Entity):
                            """
                            Protection Object
                            
                            .. attribute:: any
                            
                            	Any
                            	**type**\:  bool
                            
                            .. attribute:: ded1_plus1
                            
                            	Dedicated 1+1 Protection
                            	**type**\:  bool
                            
                            .. attribute:: ded1_to1
                            
                            	Dedicated 1\:1 Protection
                            	**type**\:  bool
                            
                            .. attribute:: enhanced
                            
                            	Indicates Enhanced Protection Scheme
                            	**type**\:  bool
                            
                            .. attribute:: extra_traffic
                            
                            	LSP should use Links that are protecting other (primary) traffic
                            	**type**\:  bool
                            
                            .. attribute:: link_unprotected
                            
                            	LSP should not use any Link Layer Protection
                            	**type**\:  bool
                            
                            .. attribute:: lsp_unprotected
                            
                            	LSP Flags Unprotected
                            	**type**\:  bool
                            
                            .. attribute:: one_plus_one_bi
                            
                            	1+1 Bidirectional Protection
                            	**type**\:  bool
                            
                            .. attribute:: one_plus_one_uni
                            
                            	1+1 Unidirectional Protection
                            	**type**\:  bool
                            
                            .. attribute:: one_to_n_protection_et
                            
                            	1\:N Protection with Extra\-Traffic
                            	**type**\:  bool
                            
                            .. attribute:: rerouting
                            
                            	Full Rerouting
                            	**type**\:  bool
                            
                            .. attribute:: rerouting_no_et
                            
                            	Rerouting Without Extra\-Traffic
                            	**type**\:  bool
                            
                            .. attribute:: s2l_notification
                            
                            	 S2L Protection Notification Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_operational
                            
                            	 S2L Protection Operational Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_protecting
                            
                            	 S2L Protection Protecting Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_secondary
                            
                            	 S2L Protection Secondary Bit
                            	**type**\:  bool
                            
                            .. attribute:: shared
                            
                            	Shared Link Layer Protection
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.Protection, self).__init__()

                                self.yang_name = "protection"
                                self.yang_parent_name = "s2l"

                                self.any = YLeaf(YType.boolean, "any")

                                self.ded1_plus1 = YLeaf(YType.boolean, "ded1-plus1")

                                self.ded1_to1 = YLeaf(YType.boolean, "ded1-to1")

                                self.enhanced = YLeaf(YType.boolean, "enhanced")

                                self.extra_traffic = YLeaf(YType.boolean, "extra-traffic")

                                self.link_unprotected = YLeaf(YType.boolean, "link-unprotected")

                                self.lsp_unprotected = YLeaf(YType.boolean, "lsp-unprotected")

                                self.one_plus_one_bi = YLeaf(YType.boolean, "one-plus-one-bi")

                                self.one_plus_one_uni = YLeaf(YType.boolean, "one-plus-one-uni")

                                self.one_to_n_protection_et = YLeaf(YType.boolean, "one-to-n-protection-et")

                                self.rerouting = YLeaf(YType.boolean, "rerouting")

                                self.rerouting_no_et = YLeaf(YType.boolean, "rerouting-no-et")

                                self.s2l_notification = YLeaf(YType.boolean, "s2l-notification")

                                self.s2l_operational = YLeaf(YType.boolean, "s2l-operational")

                                self.s2l_protecting = YLeaf(YType.boolean, "s2l-protecting")

                                self.s2l_secondary = YLeaf(YType.boolean, "s2l-secondary")

                                self.shared = YLeaf(YType.boolean, "shared")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("any",
                                                "ded1_plus1",
                                                "ded1_to1",
                                                "enhanced",
                                                "extra_traffic",
                                                "link_unprotected",
                                                "lsp_unprotected",
                                                "one_plus_one_bi",
                                                "one_plus_one_uni",
                                                "one_to_n_protection_et",
                                                "rerouting",
                                                "rerouting_no_et",
                                                "s2l_notification",
                                                "s2l_operational",
                                                "s2l_protecting",
                                                "s2l_secondary",
                                                "shared") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.Protection, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.Protection, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.any.is_set or
                                    self.ded1_plus1.is_set or
                                    self.ded1_to1.is_set or
                                    self.enhanced.is_set or
                                    self.extra_traffic.is_set or
                                    self.link_unprotected.is_set or
                                    self.lsp_unprotected.is_set or
                                    self.one_plus_one_bi.is_set or
                                    self.one_plus_one_uni.is_set or
                                    self.one_to_n_protection_et.is_set or
                                    self.rerouting.is_set or
                                    self.rerouting_no_et.is_set or
                                    self.s2l_notification.is_set or
                                    self.s2l_operational.is_set or
                                    self.s2l_protecting.is_set or
                                    self.s2l_secondary.is_set or
                                    self.shared.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.any.yfilter != YFilter.not_set or
                                    self.ded1_plus1.yfilter != YFilter.not_set or
                                    self.ded1_to1.yfilter != YFilter.not_set or
                                    self.enhanced.yfilter != YFilter.not_set or
                                    self.extra_traffic.yfilter != YFilter.not_set or
                                    self.link_unprotected.yfilter != YFilter.not_set or
                                    self.lsp_unprotected.yfilter != YFilter.not_set or
                                    self.one_plus_one_bi.yfilter != YFilter.not_set or
                                    self.one_plus_one_uni.yfilter != YFilter.not_set or
                                    self.one_to_n_protection_et.yfilter != YFilter.not_set or
                                    self.rerouting.yfilter != YFilter.not_set or
                                    self.rerouting_no_et.yfilter != YFilter.not_set or
                                    self.s2l_notification.yfilter != YFilter.not_set or
                                    self.s2l_operational.yfilter != YFilter.not_set or
                                    self.s2l_protecting.yfilter != YFilter.not_set or
                                    self.s2l_secondary.yfilter != YFilter.not_set or
                                    self.shared.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "protection" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.any.is_set or self.any.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.any.get_name_leafdata())
                                if (self.ded1_plus1.is_set or self.ded1_plus1.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ded1_plus1.get_name_leafdata())
                                if (self.ded1_to1.is_set or self.ded1_to1.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ded1_to1.get_name_leafdata())
                                if (self.enhanced.is_set or self.enhanced.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.enhanced.get_name_leafdata())
                                if (self.extra_traffic.is_set or self.extra_traffic.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.extra_traffic.get_name_leafdata())
                                if (self.link_unprotected.is_set or self.link_unprotected.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.link_unprotected.get_name_leafdata())
                                if (self.lsp_unprotected.is_set or self.lsp_unprotected.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_unprotected.get_name_leafdata())
                                if (self.one_plus_one_bi.is_set or self.one_plus_one_bi.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_plus_one_bi.get_name_leafdata())
                                if (self.one_plus_one_uni.is_set or self.one_plus_one_uni.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_plus_one_uni.get_name_leafdata())
                                if (self.one_to_n_protection_et.is_set or self.one_to_n_protection_et.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_to_n_protection_et.get_name_leafdata())
                                if (self.rerouting.is_set or self.rerouting.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rerouting.get_name_leafdata())
                                if (self.rerouting_no_et.is_set or self.rerouting_no_et.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rerouting_no_et.get_name_leafdata())
                                if (self.s2l_notification.is_set or self.s2l_notification.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_notification.get_name_leafdata())
                                if (self.s2l_operational.is_set or self.s2l_operational.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_operational.get_name_leafdata())
                                if (self.s2l_protecting.is_set or self.s2l_protecting.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_protecting.get_name_leafdata())
                                if (self.s2l_secondary.is_set or self.s2l_secondary.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_secondary.get_name_leafdata())
                                if (self.shared.is_set or self.shared.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.shared.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "any" or name == "ded1-plus1" or name == "ded1-to1" or name == "enhanced" or name == "extra-traffic" or name == "link-unprotected" or name == "lsp-unprotected" or name == "one-plus-one-bi" or name == "one-plus-one-uni" or name == "one-to-n-protection-et" or name == "rerouting" or name == "rerouting-no-et" or name == "s2l-notification" or name == "s2l-operational" or name == "s2l-protecting" or name == "s2l-secondary" or name == "shared"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "any"):
                                    self.any = value
                                    self.any.value_namespace = name_space
                                    self.any.value_namespace_prefix = name_space_prefix
                                if(value_path == "ded1-plus1"):
                                    self.ded1_plus1 = value
                                    self.ded1_plus1.value_namespace = name_space
                                    self.ded1_plus1.value_namespace_prefix = name_space_prefix
                                if(value_path == "ded1-to1"):
                                    self.ded1_to1 = value
                                    self.ded1_to1.value_namespace = name_space
                                    self.ded1_to1.value_namespace_prefix = name_space_prefix
                                if(value_path == "enhanced"):
                                    self.enhanced = value
                                    self.enhanced.value_namespace = name_space
                                    self.enhanced.value_namespace_prefix = name_space_prefix
                                if(value_path == "extra-traffic"):
                                    self.extra_traffic = value
                                    self.extra_traffic.value_namespace = name_space
                                    self.extra_traffic.value_namespace_prefix = name_space_prefix
                                if(value_path == "link-unprotected"):
                                    self.link_unprotected = value
                                    self.link_unprotected.value_namespace = name_space
                                    self.link_unprotected.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-unprotected"):
                                    self.lsp_unprotected = value
                                    self.lsp_unprotected.value_namespace = name_space
                                    self.lsp_unprotected.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-plus-one-bi"):
                                    self.one_plus_one_bi = value
                                    self.one_plus_one_bi.value_namespace = name_space
                                    self.one_plus_one_bi.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-plus-one-uni"):
                                    self.one_plus_one_uni = value
                                    self.one_plus_one_uni.value_namespace = name_space
                                    self.one_plus_one_uni.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-to-n-protection-et"):
                                    self.one_to_n_protection_et = value
                                    self.one_to_n_protection_et.value_namespace = name_space
                                    self.one_to_n_protection_et.value_namespace_prefix = name_space_prefix
                                if(value_path == "rerouting"):
                                    self.rerouting = value
                                    self.rerouting.value_namespace = name_space
                                    self.rerouting.value_namespace_prefix = name_space_prefix
                                if(value_path == "rerouting-no-et"):
                                    self.rerouting_no_et = value
                                    self.rerouting_no_et.value_namespace = name_space
                                    self.rerouting_no_et.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-notification"):
                                    self.s2l_notification = value
                                    self.s2l_notification.value_namespace = name_space
                                    self.s2l_notification.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-operational"):
                                    self.s2l_operational = value
                                    self.s2l_operational.value_namespace = name_space
                                    self.s2l_operational.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-protecting"):
                                    self.s2l_protecting = value
                                    self.s2l_protecting.value_namespace = name_space
                                    self.s2l_protecting.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-secondary"):
                                    self.s2l_secondary = value
                                    self.s2l_secondary.value_namespace = name_space
                                    self.s2l_secondary.value_namespace_prefix = name_space_prefix
                                if(value_path == "shared"):
                                    self.shared = value
                                    self.shared.value_namespace = name_space
                                    self.shared.value_namespace_prefix = name_space_prefix


                        class ReverseLspFec(Entity):
                            """
                            Reverse Associated Bidir LSP FEC
                            
                            .. attribute:: fec_destination_info
                            
                            	Destination or P2MP ID
                            	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ReverseLspFec.FecDestinationInfo>`
                            
                            .. attribute:: fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: fec_lsp_id
                            
                            	LSP ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: fec_source
                            
                            	Tunnel source address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ReverseLspFec, self).__init__()

                                self.yang_name = "reverse-lsp-fec"
                                self.yang_parent_name = "s2l"

                                self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                self.fec_source = YLeaf(YType.str, "fec-source")

                                self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ReverseLspFec.FecDestinationInfo()
                                self.fec_destination_info.parent = self
                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                self._children_yang_names.add("fec-destination-info")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fec_extended_tunnel_id",
                                                "fec_lsp_id",
                                                "fec_source",
                                                "fec_tunnel_id",
                                                "fec_vrf") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ReverseLspFec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ReverseLspFec, self).__setattr__(name, value)


                            class FecDestinationInfo(Entity):
                                """
                                Destination or P2MP ID
                                
                                .. attribute:: fec_ctype
                                
                                	FEC CType
                                	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                .. attribute:: fec_destination_p2mp_id
                                
                                	P2MP ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: p2p_lsp_destination
                                
                                	P2P LSP destination
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__init__()

                                    self.yang_name = "fec-destination-info"
                                    self.yang_parent_name = "reverse-lsp-fec"

                                    self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                    self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                    self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("fec_ctype",
                                                    "fec_destination_p2mp_id",
                                                    "p2p_lsp_destination") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ReverseLspFec.FecDestinationInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.fec_ctype.is_set or
                                        self.fec_destination_p2mp_id.is_set or
                                        self.p2p_lsp_destination.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.fec_ctype.yfilter != YFilter.not_set or
                                        self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                        self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "fec-destination-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                    if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                    if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "fec-ctype"):
                                        self.fec_ctype = value
                                        self.fec_ctype.value_namespace = name_space
                                        self.fec_ctype.value_namespace_prefix = name_space_prefix
                                    if(value_path == "fec-destination-p2mp-id"):
                                        self.fec_destination_p2mp_id = value
                                        self.fec_destination_p2mp_id.value_namespace = name_space
                                        self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "p2p-lsp-destination"):
                                        self.p2p_lsp_destination = value
                                        self.p2p_lsp_destination.value_namespace = name_space
                                        self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.fec_extended_tunnel_id.is_set or
                                    self.fec_lsp_id.is_set or
                                    self.fec_source.is_set or
                                    self.fec_tunnel_id.is_set or
                                    self.fec_vrf.is_set or
                                    (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                    self.fec_lsp_id.yfilter != YFilter.not_set or
                                    self.fec_source.yfilter != YFilter.not_set or
                                    self.fec_tunnel_id.yfilter != YFilter.not_set or
                                    self.fec_vrf.yfilter != YFilter.not_set or
                                    (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-lsp-fec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_source.get_name_leafdata())
                                if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "fec-destination-info"):
                                    if (self.fec_destination_info is None):
                                        self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ReverseLspFec.FecDestinationInfo()
                                        self.fec_destination_info.parent = self
                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                    return self.fec_destination_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fec-extended-tunnel-id"):
                                    self.fec_extended_tunnel_id = value
                                    self.fec_extended_tunnel_id.value_namespace = name_space
                                    self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-lsp-id"):
                                    self.fec_lsp_id = value
                                    self.fec_lsp_id.value_namespace = name_space
                                    self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-source"):
                                    self.fec_source = value
                                    self.fec_source.value_namespace = name_space
                                    self.fec_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-tunnel-id"):
                                    self.fec_tunnel_id = value
                                    self.fec_tunnel_id.value_namespace = name_space
                                    self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-vrf"):
                                    self.fec_vrf = value
                                    self.fec_vrf.value_namespace = name_space
                                    self.fec_vrf.value_namespace_prefix = name_space_prefix


                        class ReverseTspec(Entity):
                            """
                            The Reverse T spec info
                            
                            .. attribute:: average_rate
                            
                            	Average bandwidth in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: maximum_burst
                            
                            	Maximum burst of data in bytes
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: byte
                            
                            .. attribute:: peak_rate
                            
                            	Peak rate in  kbps
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            	**units**\: kbit/s
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ReverseTspec, self).__init__()

                                self.yang_name = "reverse-tspec"
                                self.yang_parent_name = "s2l"

                                self.average_rate = YLeaf(YType.uint64, "average-rate")

                                self.maximum_burst = YLeaf(YType.uint64, "maximum-burst")

                                self.peak_rate = YLeaf(YType.uint64, "peak-rate")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("average_rate",
                                                "maximum_burst",
                                                "peak_rate") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ReverseTspec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ReverseTspec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.average_rate.is_set or
                                    self.maximum_burst.is_set or
                                    self.peak_rate.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.average_rate.yfilter != YFilter.not_set or
                                    self.maximum_burst.yfilter != YFilter.not_set or
                                    self.peak_rate.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-tspec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.average_rate.is_set or self.average_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.average_rate.get_name_leafdata())
                                if (self.maximum_burst.is_set or self.maximum_burst.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.maximum_burst.get_name_leafdata())
                                if (self.peak_rate.is_set or self.peak_rate.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.peak_rate.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "average-rate" or name == "maximum-burst" or name == "peak-rate"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "average-rate"):
                                    self.average_rate = value
                                    self.average_rate.value_namespace = name_space
                                    self.average_rate.value_namespace_prefix = name_space_prefix
                                if(value_path == "maximum-burst"):
                                    self.maximum_burst = value
                                    self.maximum_burst.value_namespace = name_space
                                    self.maximum_burst.value_namespace_prefix = name_space_prefix
                                if(value_path == "peak-rate"):
                                    self.peak_rate = value
                                    self.peak_rate.value_namespace = name_space
                                    self.peak_rate.value_namespace_prefix = name_space_prefix


                        class FlexInfo(Entity):
                            """
                            FlexLSP S2L Information
                            
                            .. attribute:: bfd_created
                            
                            	GAL BFD Session Created
                            	**type**\:  bool
                            
                            .. attribute:: bfd_egress_label
                            
                            	BFD Egress Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: bfd_int_label
                            
                            	BFD Internal Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: bfd_next_hop
                            
                            	BFD Next Hop
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: bfd_out_ifh
                            
                            	BFD Out Interface Handle
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: bfd_tun_ifh
                            
                            	BFD Tunnel Interface Handle
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: bfd_up
                            
                            	GAL BFD Session Up
                            	**type**\:  bool
                            
                            .. attribute:: entry_exists
                            
                            	FlexLSP Entry Exists
                            	**type**\:  bool
                            
                            .. attribute:: fault_ais
                            
                            	Fault AIS
                            	**type**\:  bool
                            
                            .. attribute:: fault_ldi
                            
                            	Fault LDI
                            	**type**\:  bool
                            
                            .. attribute:: fault_ldi_lockout
                            
                            	Fault LDI Lockout
                            	**type**\:  bool
                            
                            .. attribute:: fault_lkr
                            
                            	Fault LKR
                            	**type**\:  bool
                            
                            .. attribute:: fault_time
                            
                            	Fault Time
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: flex_fec
                            
                            	FEC for the FlexLSP Entry
                            	**type**\:   :py:class:`FlexFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.FlexInfo.FlexFec>`
                            
                            .. attribute:: in_label
                            
                            	In Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: oam_created
                            
                            	OAM Entry Created
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.FlexInfo, self).__init__()

                                self.yang_name = "flex-info"
                                self.yang_parent_name = "s2l"

                                self.bfd_created = YLeaf(YType.boolean, "bfd-created")

                                self.bfd_egress_label = YLeaf(YType.uint32, "bfd-egress-label")

                                self.bfd_int_label = YLeaf(YType.uint32, "bfd-int-label")

                                self.bfd_next_hop = YLeaf(YType.str, "bfd-next-hop")

                                self.bfd_out_ifh = YLeaf(YType.str, "bfd-out-ifh")

                                self.bfd_tun_ifh = YLeaf(YType.str, "bfd-tun-ifh")

                                self.bfd_up = YLeaf(YType.boolean, "bfd-up")

                                self.entry_exists = YLeaf(YType.boolean, "entry-exists")

                                self.fault_ais = YLeaf(YType.boolean, "fault-ais")

                                self.fault_ldi = YLeaf(YType.boolean, "fault-ldi")

                                self.fault_ldi_lockout = YLeaf(YType.boolean, "fault-ldi-lockout")

                                self.fault_lkr = YLeaf(YType.boolean, "fault-lkr")

                                self.fault_time = YLeaf(YType.uint32, "fault-time")

                                self.in_label = YLeaf(YType.uint32, "in-label")

                                self.oam_created = YLeaf(YType.boolean, "oam-created")

                                self.flex_fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.FlexInfo.FlexFec()
                                self.flex_fec.parent = self
                                self._children_name_map["flex_fec"] = "flex-fec"
                                self._children_yang_names.add("flex-fec")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("bfd_created",
                                                "bfd_egress_label",
                                                "bfd_int_label",
                                                "bfd_next_hop",
                                                "bfd_out_ifh",
                                                "bfd_tun_ifh",
                                                "bfd_up",
                                                "entry_exists",
                                                "fault_ais",
                                                "fault_ldi",
                                                "fault_ldi_lockout",
                                                "fault_lkr",
                                                "fault_time",
                                                "in_label",
                                                "oam_created") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.FlexInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.FlexInfo, self).__setattr__(name, value)


                            class FlexFec(Entity):
                                """
                                FEC for the FlexLSP Entry
                                
                                .. attribute:: s2l_fec_ctype
                                
                                	Session identifier (ctype)
                                	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                .. attribute:: s2l_fec_dest
                                
                                	sub\-LSP destination address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_extended_tunnel_id
                                
                                	Extended tunnel ID
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_lsp_id
                                
                                	LSP ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_p2mp_id
                                
                                	P2MP ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: s2l_fec_source
                                
                                	LSP source address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_subgroup_id
                                
                                	sub\-LSP subgroup ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_subgroup_originator
                                
                                	Subgroup Originator
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: s2l_fec_tunnel_id
                                
                                	Tunnel ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: s2l_fec_vrf
                                
                                	VRF; currently only for GMPLS tunnels
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.FlexInfo.FlexFec, self).__init__()

                                    self.yang_name = "flex-fec"
                                    self.yang_parent_name = "flex-info"

                                    self.s2l_fec_ctype = YLeaf(YType.enumeration, "s2l-fec-ctype")

                                    self.s2l_fec_dest = YLeaf(YType.str, "s2l-fec-dest")

                                    self.s2l_fec_extended_tunnel_id = YLeaf(YType.str, "s2l-fec-extended-tunnel-id")

                                    self.s2l_fec_lsp_id = YLeaf(YType.uint16, "s2l-fec-lsp-id")

                                    self.s2l_fec_p2mp_id = YLeaf(YType.uint32, "s2l-fec-p2mp-id")

                                    self.s2l_fec_source = YLeaf(YType.str, "s2l-fec-source")

                                    self.s2l_fec_subgroup_id = YLeaf(YType.uint16, "s2l-fec-subgroup-id")

                                    self.s2l_fec_subgroup_originator = YLeaf(YType.str, "s2l-fec-subgroup-originator")

                                    self.s2l_fec_tunnel_id = YLeaf(YType.uint16, "s2l-fec-tunnel-id")

                                    self.s2l_fec_vrf = YLeaf(YType.str, "s2l-fec-vrf")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("s2l_fec_ctype",
                                                    "s2l_fec_dest",
                                                    "s2l_fec_extended_tunnel_id",
                                                    "s2l_fec_lsp_id",
                                                    "s2l_fec_p2mp_id",
                                                    "s2l_fec_source",
                                                    "s2l_fec_subgroup_id",
                                                    "s2l_fec_subgroup_originator",
                                                    "s2l_fec_tunnel_id",
                                                    "s2l_fec_vrf") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.FlexInfo.FlexFec, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.FlexInfo.FlexFec, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.s2l_fec_ctype.is_set or
                                        self.s2l_fec_dest.is_set or
                                        self.s2l_fec_extended_tunnel_id.is_set or
                                        self.s2l_fec_lsp_id.is_set or
                                        self.s2l_fec_p2mp_id.is_set or
                                        self.s2l_fec_source.is_set or
                                        self.s2l_fec_subgroup_id.is_set or
                                        self.s2l_fec_subgroup_originator.is_set or
                                        self.s2l_fec_tunnel_id.is_set or
                                        self.s2l_fec_vrf.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.s2l_fec_ctype.yfilter != YFilter.not_set or
                                        self.s2l_fec_dest.yfilter != YFilter.not_set or
                                        self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_lsp_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_p2mp_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_source.yfilter != YFilter.not_set or
                                        self.s2l_fec_subgroup_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set or
                                        self.s2l_fec_tunnel_id.yfilter != YFilter.not_set or
                                        self.s2l_fec_vrf.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "flex-fec" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.s2l_fec_ctype.is_set or self.s2l_fec_ctype.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_ctype.get_name_leafdata())
                                    if (self.s2l_fec_dest.is_set or self.s2l_fec_dest.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_dest.get_name_leafdata())
                                    if (self.s2l_fec_extended_tunnel_id.is_set or self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_extended_tunnel_id.get_name_leafdata())
                                    if (self.s2l_fec_lsp_id.is_set or self.s2l_fec_lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_lsp_id.get_name_leafdata())
                                    if (self.s2l_fec_p2mp_id.is_set or self.s2l_fec_p2mp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_p2mp_id.get_name_leafdata())
                                    if (self.s2l_fec_source.is_set or self.s2l_fec_source.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_source.get_name_leafdata())
                                    if (self.s2l_fec_subgroup_id.is_set or self.s2l_fec_subgroup_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_subgroup_id.get_name_leafdata())
                                    if (self.s2l_fec_subgroup_originator.is_set or self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_subgroup_originator.get_name_leafdata())
                                    if (self.s2l_fec_tunnel_id.is_set or self.s2l_fec_tunnel_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_tunnel_id.get_name_leafdata())
                                    if (self.s2l_fec_vrf.is_set or self.s2l_fec_vrf.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_fec_vrf.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "s2l-fec-ctype" or name == "s2l-fec-dest" or name == "s2l-fec-extended-tunnel-id" or name == "s2l-fec-lsp-id" or name == "s2l-fec-p2mp-id" or name == "s2l-fec-source" or name == "s2l-fec-subgroup-id" or name == "s2l-fec-subgroup-originator" or name == "s2l-fec-tunnel-id" or name == "s2l-fec-vrf"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "s2l-fec-ctype"):
                                        self.s2l_fec_ctype = value
                                        self.s2l_fec_ctype.value_namespace = name_space
                                        self.s2l_fec_ctype.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-dest"):
                                        self.s2l_fec_dest = value
                                        self.s2l_fec_dest.value_namespace = name_space
                                        self.s2l_fec_dest.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-extended-tunnel-id"):
                                        self.s2l_fec_extended_tunnel_id = value
                                        self.s2l_fec_extended_tunnel_id.value_namespace = name_space
                                        self.s2l_fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-lsp-id"):
                                        self.s2l_fec_lsp_id = value
                                        self.s2l_fec_lsp_id.value_namespace = name_space
                                        self.s2l_fec_lsp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-p2mp-id"):
                                        self.s2l_fec_p2mp_id = value
                                        self.s2l_fec_p2mp_id.value_namespace = name_space
                                        self.s2l_fec_p2mp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-source"):
                                        self.s2l_fec_source = value
                                        self.s2l_fec_source.value_namespace = name_space
                                        self.s2l_fec_source.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-subgroup-id"):
                                        self.s2l_fec_subgroup_id = value
                                        self.s2l_fec_subgroup_id.value_namespace = name_space
                                        self.s2l_fec_subgroup_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-subgroup-originator"):
                                        self.s2l_fec_subgroup_originator = value
                                        self.s2l_fec_subgroup_originator.value_namespace = name_space
                                        self.s2l_fec_subgroup_originator.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-tunnel-id"):
                                        self.s2l_fec_tunnel_id = value
                                        self.s2l_fec_tunnel_id.value_namespace = name_space
                                        self.s2l_fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-fec-vrf"):
                                        self.s2l_fec_vrf = value
                                        self.s2l_fec_vrf.value_namespace = name_space
                                        self.s2l_fec_vrf.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.bfd_created.is_set or
                                    self.bfd_egress_label.is_set or
                                    self.bfd_int_label.is_set or
                                    self.bfd_next_hop.is_set or
                                    self.bfd_out_ifh.is_set or
                                    self.bfd_tun_ifh.is_set or
                                    self.bfd_up.is_set or
                                    self.entry_exists.is_set or
                                    self.fault_ais.is_set or
                                    self.fault_ldi.is_set or
                                    self.fault_ldi_lockout.is_set or
                                    self.fault_lkr.is_set or
                                    self.fault_time.is_set or
                                    self.in_label.is_set or
                                    self.oam_created.is_set or
                                    (self.flex_fec is not None and self.flex_fec.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.bfd_created.yfilter != YFilter.not_set or
                                    self.bfd_egress_label.yfilter != YFilter.not_set or
                                    self.bfd_int_label.yfilter != YFilter.not_set or
                                    self.bfd_next_hop.yfilter != YFilter.not_set or
                                    self.bfd_out_ifh.yfilter != YFilter.not_set or
                                    self.bfd_tun_ifh.yfilter != YFilter.not_set or
                                    self.bfd_up.yfilter != YFilter.not_set or
                                    self.entry_exists.yfilter != YFilter.not_set or
                                    self.fault_ais.yfilter != YFilter.not_set or
                                    self.fault_ldi.yfilter != YFilter.not_set or
                                    self.fault_ldi_lockout.yfilter != YFilter.not_set or
                                    self.fault_lkr.yfilter != YFilter.not_set or
                                    self.fault_time.yfilter != YFilter.not_set or
                                    self.in_label.yfilter != YFilter.not_set or
                                    self.oam_created.yfilter != YFilter.not_set or
                                    (self.flex_fec is not None and self.flex_fec.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "flex-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.bfd_created.is_set or self.bfd_created.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_created.get_name_leafdata())
                                if (self.bfd_egress_label.is_set or self.bfd_egress_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_egress_label.get_name_leafdata())
                                if (self.bfd_int_label.is_set or self.bfd_int_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_int_label.get_name_leafdata())
                                if (self.bfd_next_hop.is_set or self.bfd_next_hop.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_next_hop.get_name_leafdata())
                                if (self.bfd_out_ifh.is_set or self.bfd_out_ifh.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_out_ifh.get_name_leafdata())
                                if (self.bfd_tun_ifh.is_set or self.bfd_tun_ifh.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_tun_ifh.get_name_leafdata())
                                if (self.bfd_up.is_set or self.bfd_up.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bfd_up.get_name_leafdata())
                                if (self.entry_exists.is_set or self.entry_exists.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry_exists.get_name_leafdata())
                                if (self.fault_ais.is_set or self.fault_ais.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ais.get_name_leafdata())
                                if (self.fault_ldi.is_set or self.fault_ldi.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ldi.get_name_leafdata())
                                if (self.fault_ldi_lockout.is_set or self.fault_ldi_lockout.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_ldi_lockout.get_name_leafdata())
                                if (self.fault_lkr.is_set or self.fault_lkr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_lkr.get_name_leafdata())
                                if (self.fault_time.is_set or self.fault_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fault_time.get_name_leafdata())
                                if (self.in_label.is_set or self.in_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.in_label.get_name_leafdata())
                                if (self.oam_created.is_set or self.oam_created.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.oam_created.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "flex-fec"):
                                    if (self.flex_fec is None):
                                        self.flex_fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.FlexInfo.FlexFec()
                                        self.flex_fec.parent = self
                                        self._children_name_map["flex_fec"] = "flex-fec"
                                    return self.flex_fec

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "flex-fec" or name == "bfd-created" or name == "bfd-egress-label" or name == "bfd-int-label" or name == "bfd-next-hop" or name == "bfd-out-ifh" or name == "bfd-tun-ifh" or name == "bfd-up" or name == "entry-exists" or name == "fault-ais" or name == "fault-ldi" or name == "fault-ldi-lockout" or name == "fault-lkr" or name == "fault-time" or name == "in-label" or name == "oam-created"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "bfd-created"):
                                    self.bfd_created = value
                                    self.bfd_created.value_namespace = name_space
                                    self.bfd_created.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-egress-label"):
                                    self.bfd_egress_label = value
                                    self.bfd_egress_label.value_namespace = name_space
                                    self.bfd_egress_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-int-label"):
                                    self.bfd_int_label = value
                                    self.bfd_int_label.value_namespace = name_space
                                    self.bfd_int_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-next-hop"):
                                    self.bfd_next_hop = value
                                    self.bfd_next_hop.value_namespace = name_space
                                    self.bfd_next_hop.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-out-ifh"):
                                    self.bfd_out_ifh = value
                                    self.bfd_out_ifh.value_namespace = name_space
                                    self.bfd_out_ifh.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-tun-ifh"):
                                    self.bfd_tun_ifh = value
                                    self.bfd_tun_ifh.value_namespace = name_space
                                    self.bfd_tun_ifh.value_namespace_prefix = name_space_prefix
                                if(value_path == "bfd-up"):
                                    self.bfd_up = value
                                    self.bfd_up.value_namespace = name_space
                                    self.bfd_up.value_namespace_prefix = name_space_prefix
                                if(value_path == "entry-exists"):
                                    self.entry_exists = value
                                    self.entry_exists.value_namespace = name_space
                                    self.entry_exists.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ais"):
                                    self.fault_ais = value
                                    self.fault_ais.value_namespace = name_space
                                    self.fault_ais.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ldi"):
                                    self.fault_ldi = value
                                    self.fault_ldi.value_namespace = name_space
                                    self.fault_ldi.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-ldi-lockout"):
                                    self.fault_ldi_lockout = value
                                    self.fault_ldi_lockout.value_namespace = name_space
                                    self.fault_ldi_lockout.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-lkr"):
                                    self.fault_lkr = value
                                    self.fault_lkr.value_namespace = name_space
                                    self.fault_lkr.value_namespace_prefix = name_space_prefix
                                if(value_path == "fault-time"):
                                    self.fault_time = value
                                    self.fault_time.value_namespace = name_space
                                    self.fault_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "in-label"):
                                    self.in_label = value
                                    self.in_label.value_namespace = name_space
                                    self.in_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "oam-created"):
                                    self.oam_created = value
                                    self.oam_created.value_namespace = name_space
                                    self.oam_created.value_namespace_prefix = name_space_prefix


                        class LspWrapInfo(Entity):
                            """
                            Lsp Wrap  Related information
                            
                            .. attribute:: lsp_wrap_protection_enable
                            
                            	LSP Wrap protection enabled
                            	**type**\:  bool
                            
                            .. attribute:: lsp_wrap_protection_label
                            
                            	LSP Wrap Merge Point Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: lsp_wrap_protection_state
                            
                            	LSP wrap protection state
                            	**type**\:   :py:class:`MplsTeLspWrapState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspWrapState>`
                            
                            .. attribute:: reverse_egress_interface
                            
                            	Reverse Egress Interface
                            	**type**\:  str
                            
                            .. attribute:: reverse_lsp_label
                            
                            	Reverse LSP label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.LspWrapInfo, self).__init__()

                                self.yang_name = "lsp-wrap-info"
                                self.yang_parent_name = "s2l"

                                self.lsp_wrap_protection_enable = YLeaf(YType.boolean, "lsp-wrap-protection-enable")

                                self.lsp_wrap_protection_label = YLeaf(YType.uint32, "lsp-wrap-protection-label")

                                self.lsp_wrap_protection_state = YLeaf(YType.enumeration, "lsp-wrap-protection-state")

                                self.reverse_egress_interface = YLeaf(YType.str, "reverse-egress-interface")

                                self.reverse_lsp_label = YLeaf(YType.uint32, "reverse-lsp-label")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("lsp_wrap_protection_enable",
                                                "lsp_wrap_protection_label",
                                                "lsp_wrap_protection_state",
                                                "reverse_egress_interface",
                                                "reverse_lsp_label") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.LspWrapInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.LspWrapInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.lsp_wrap_protection_enable.is_set or
                                    self.lsp_wrap_protection_label.is_set or
                                    self.lsp_wrap_protection_state.is_set or
                                    self.reverse_egress_interface.is_set or
                                    self.reverse_lsp_label.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_enable.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_label.yfilter != YFilter.not_set or
                                    self.lsp_wrap_protection_state.yfilter != YFilter.not_set or
                                    self.reverse_egress_interface.yfilter != YFilter.not_set or
                                    self.reverse_lsp_label.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "lsp-wrap-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.lsp_wrap_protection_enable.is_set or self.lsp_wrap_protection_enable.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_enable.get_name_leafdata())
                                if (self.lsp_wrap_protection_label.is_set or self.lsp_wrap_protection_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_label.get_name_leafdata())
                                if (self.lsp_wrap_protection_state.is_set or self.lsp_wrap_protection_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_wrap_protection_state.get_name_leafdata())
                                if (self.reverse_egress_interface.is_set or self.reverse_egress_interface.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reverse_egress_interface.get_name_leafdata())
                                if (self.reverse_lsp_label.is_set or self.reverse_lsp_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reverse_lsp_label.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "lsp-wrap-protection-enable" or name == "lsp-wrap-protection-label" or name == "lsp-wrap-protection-state" or name == "reverse-egress-interface" or name == "reverse-lsp-label"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "lsp-wrap-protection-enable"):
                                    self.lsp_wrap_protection_enable = value
                                    self.lsp_wrap_protection_enable.value_namespace = name_space
                                    self.lsp_wrap_protection_enable.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-wrap-protection-label"):
                                    self.lsp_wrap_protection_label = value
                                    self.lsp_wrap_protection_label.value_namespace = name_space
                                    self.lsp_wrap_protection_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-wrap-protection-state"):
                                    self.lsp_wrap_protection_state = value
                                    self.lsp_wrap_protection_state.value_namespace = name_space
                                    self.lsp_wrap_protection_state.value_namespace_prefix = name_space_prefix
                                if(value_path == "reverse-egress-interface"):
                                    self.reverse_egress_interface = value
                                    self.reverse_egress_interface.value_namespace = name_space
                                    self.reverse_egress_interface.value_namespace_prefix = name_space_prefix
                                if(value_path == "reverse-lsp-label"):
                                    self.reverse_lsp_label = value
                                    self.reverse_lsp_label.value_namespace = name_space
                                    self.reverse_lsp_label.value_namespace_prefix = name_space_prefix


                        class DiversityInfo(Entity):
                            """
                            S2L Diversity Information
                            
                            .. attribute:: diversity_type
                            
                            	S2L path diversity type
                            	**type**\:   :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.DiversityInfo, self).__init__()

                                self.yang_name = "diversity-info"
                                self.yang_parent_name = "s2l"

                                self.diversity_type = YLeaf(YType.enumeration, "diversity-type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("diversity_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.DiversityInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.DiversityInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return self.diversity_type.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.diversity_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "diversity-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.diversity_type.is_set or self.diversity_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.diversity_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "diversity-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "diversity-type"):
                                    self.diversity_type = value
                                    self.diversity_type.value_namespace = name_space
                                    self.diversity_type.value_namespace_prefix = name_space_prefix


                        class S2LReverseLspSubObj(Entity):
                            """
                            Reverse LSP Sub Objects
                            
                            .. attribute:: entry
                            
                            	
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.S2LReverseLspSubObj, self).__init__()

                                self.yang_name = "s2l-reverse-lsp-sub-obj"
                                self.yang_parent_name = "s2l"

                                self.entry = YLeaf(YType.uint8, "entry")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("entry") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.S2LReverseLspSubObj, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.S2LReverseLspSubObj, self).__setattr__(name, value)

                            def has_data(self):
                                return self.entry.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.entry.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-reverse-lsp-sub-obj" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "entry"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "entry"):
                                    self.entry = value
                                    self.entry.value_namespace = name_space
                                    self.entry.value_namespace_prefix = name_space_prefix


                        class SharedRiskLinkGroup(Entity):
                            """
                            The S2L's excluded srlg groups
                            
                            .. attribute:: shared_risk_group
                            
                            	SRLG number
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: srlg_name
                            
                            	SRLG name
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.SharedRiskLinkGroup, self).__init__()

                                self.yang_name = "shared-risk-link-group"
                                self.yang_parent_name = "s2l"

                                self.shared_risk_group = YLeaf(YType.uint32, "shared-risk-group")

                                self.srlg_name = YLeaf(YType.str, "srlg-name")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("shared_risk_group",
                                                "srlg_name") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.SharedRiskLinkGroup, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.SharedRiskLinkGroup, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.shared_risk_group.is_set or
                                    self.srlg_name.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.shared_risk_group.yfilter != YFilter.not_set or
                                    self.srlg_name.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "shared-risk-link-group" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.shared_risk_group.is_set or self.shared_risk_group.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.shared_risk_group.get_name_leafdata())
                                if (self.srlg_name.is_set or self.srlg_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.srlg_name.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "shared-risk-group" or name == "srlg-name"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "shared-risk-group"):
                                    self.shared_risk_group = value
                                    self.shared_risk_group.value_namespace = name_space
                                    self.shared_risk_group.value_namespace_prefix = name_space_prefix
                                if(value_path == "srlg-name"):
                                    self.srlg_name = value
                                    self.srlg_name.value_namespace = name_space
                                    self.srlg_name.value_namespace_prefix = name_space_prefix


                        class OutEro(Entity):
                            """
                            Outgoing ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutEro.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutEro.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutEro, self).__init__()

                                self.yang_name = "out-ero"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutEro.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutEro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutEro, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutEro.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "out-ero"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutEro.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutEro.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "out-ero"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutEro.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutEro.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "out-ero" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutEro.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutEro.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class InEro(Entity):
                            """
                            Incoming ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InEro.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InEro.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InEro, self).__init__()

                                self.yang_name = "in-ero"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InEro.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InEro.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InEro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InEro, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InEro.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "in-ero"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InEro.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InEro.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InEro.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "in-ero"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InEro.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InEro.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "in-ero" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InEro.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InEro.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class PathRro(Entity):
                            """
                            Path RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:   :py:class:`Ipv4RroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.Ipv4RroSubObject>`
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:   :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.LabelRroSubObject>`
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:   :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:   :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.SrlgRroSubObject>`
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:   :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.UnnumberedRroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro, self).__init__()

                                self.yang_name = "path-rro"
                                self.yang_parent_name = "s2l"

                                self.rro_type = YLeaf(YType.enumeration, "rro-type")

                                self.ipv4rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.Ipv4RroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                self._children_yang_names.add("ipv4rro-sub-object")

                                self.label_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                self._children_yang_names.add("label-rro-sub-object")

                                self.srlg_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._children_yang_names.add("srlg-rro-sub-object")

                                self.unnumbered_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                self._children_yang_names.add("unnumbered-rro-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("rro_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro, self).__setattr__(name, value)


                            class Ipv4RroSubObject(Entity):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.Ipv4RroSubObject.Flags>`
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.Ipv4RroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.rro_address = YLeaf(YType.str, "rro-address")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.Ipv4RroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("rro_address") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.Ipv4RroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.Ipv4RroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.rro_address.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.rro_address.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.rro_address.is_set or self.rro_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rro_address.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.Ipv4RroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "rro-address"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "rro-address"):
                                        self.rro_address = value
                                        self.rro_address.value_namespace = name_space
                                        self.rro_address.value_namespace_prefix = name_space_prefix


                            class LabelRroSubObject(Entity):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.LabelRroSubObject.Flags>`
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\:  bool
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of    :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.is_label_variable_length = YLeaf(YType.boolean, "is-label-variable-length")

                                    self.label = YLeaf(YType.uint32, "label")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                    self.variable_length_label = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_label_variable_length",
                                                    "label") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.LabelRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.LabelRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.is_global_label = YLeaf(YType.boolean, "is-global-label")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_global_label") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.LabelRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.is_global_label.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_global_label.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_global_label.is_set or self.is_global_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_global_label.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-global-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-global-label"):
                                            self.is_global_label = value
                                            self.is_global_label.value_namespace = name_space
                                            self.is_global_label.value_namespace_prefix = name_space_prefix


                                class VariableLengthLabel(Entity):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "variable-length-label" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.variable_length_label:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.is_label_variable_length.is_set or
                                        self.label.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    for c in self.variable_length_label:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_label_variable_length.yfilter != YFilter.not_set or
                                        self.label.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "label-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_label_variable_length.is_set or self.is_label_variable_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_label_variable_length.get_name_leafdata())
                                    if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.LabelRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    if (child_yang_name == "variable-length-label"):
                                        for c in self.variable_length_label:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.LabelRroSubObject.VariableLengthLabel()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.variable_length_label.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "variable-length-label" or name == "is-label-variable-length" or name == "label"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-label-variable-length"):
                                        self.is_label_variable_length = value
                                        self.is_label_variable_length.value_namespace = name_space
                                        self.is_label_variable_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label"):
                                        self.label = value
                                        self.label.value_namespace = name_space
                                        self.label.value_namespace_prefix = name_space_prefix


                            class UnnumberedRroSubObject(Entity):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.UnnumberedRroSubObject.Flags>`
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.interface_address = YLeaf(YType.str, "interface-address")

                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_address",
                                                    "interface_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.UnnumberedRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.UnnumberedRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.interface_address.is_set or
                                        self.interface_id.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_address.yfilter != YFilter.not_set or
                                        self.interface_id.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_address.is_set or self.interface_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_address.get_name_leafdata())
                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.UnnumberedRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "interface-address" or name == "interface-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-address"):
                                        self.interface_address = value
                                        self.interface_address.value_namespace = name_space
                                        self.interface_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-id"):
                                        self.interface_id = value
                                        self.interface_id.value_namespace = name_space
                                        self.interface_id.value_namespace_prefix = name_space_prefix


                            class SrlgRroSubObject(Entity):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of    :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.SrlgRroSubObject.SrlGs>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "path-rro"

                                    self.srl_gs = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.SrlgRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.SrlgRroSubObject, self).__setattr__(name, value)


                                class SrlGs(Entity):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srl-gs" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.srl_gs:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.srl_gs:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "srlg-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "srl-gs"):
                                        for c in self.srl_gs:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.SrlgRroSubObject.SrlGs()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.srl_gs.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "srl-gs"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    self.rro_type.is_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_data()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_data()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_data()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.rro_type.yfilter != YFilter.not_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_operation()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_operation()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_operation()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-rro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.rro_type.is_set or self.rro_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rro_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4rro-sub-object"):
                                    if (self.ipv4rro_sub_object is None):
                                        self.ipv4rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.Ipv4RroSubObject()
                                        self.ipv4rro_sub_object.parent = self
                                        self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                    return self.ipv4rro_sub_object

                                if (child_yang_name == "label-rro-sub-object"):
                                    if (self.label_rro_sub_object is None):
                                        self.label_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.LabelRroSubObject()
                                        self.label_rro_sub_object.parent = self
                                        self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                    return self.label_rro_sub_object

                                if (child_yang_name == "srlg-rro-sub-object"):
                                    if (self.srlg_rro_sub_object is None):
                                        self.srlg_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.SrlgRroSubObject()
                                        self.srlg_rro_sub_object.parent = self
                                        self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                    return self.srlg_rro_sub_object

                                if (child_yang_name == "unnumbered-rro-sub-object"):
                                    if (self.unnumbered_rro_sub_object is None):
                                        self.unnumbered_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro.UnnumberedRroSubObject()
                                        self.unnumbered_rro_sub_object.parent = self
                                        self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                    return self.unnumbered_rro_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4rro-sub-object" or name == "label-rro-sub-object" or name == "srlg-rro-sub-object" or name == "unnumbered-rro-sub-object" or name == "rro-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "rro-type"):
                                    self.rro_type = value
                                    self.rro_type.value_namespace = name_space
                                    self.rro_type.value_namespace_prefix = name_space_prefix


                        class ResvRro(Entity):
                            """
                            Resv RRO for this S2L
                            
                            .. attribute:: ipv4rro_sub_object
                            
                            	IPV4 RRO Sub Object
                            	**type**\:   :py:class:`Ipv4RroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.Ipv4RroSubObject>`
                            
                            .. attribute:: label_rro_sub_object
                            
                            	Label RRO Sub Object
                            	**type**\:   :py:class:`LabelRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.LabelRroSubObject>`
                            
                            .. attribute:: rro_type
                            
                            	RROType
                            	**type**\:   :py:class:`RsvpMgmtRroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtRroSubobj>`
                            
                            .. attribute:: srlg_rro_sub_object
                            
                            	SRLG RRO Sub Object
                            	**type**\:   :py:class:`SrlgRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.SrlgRroSubObject>`
                            
                            .. attribute:: unnumbered_rro_sub_object
                            
                            	Unnumbered RRO Sub Object
                            	**type**\:   :py:class:`UnnumberedRroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.UnnumberedRroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro, self).__init__()

                                self.yang_name = "resv-rro"
                                self.yang_parent_name = "s2l"

                                self.rro_type = YLeaf(YType.enumeration, "rro-type")

                                self.ipv4rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.Ipv4RroSubObject()
                                self.ipv4rro_sub_object.parent = self
                                self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                self._children_yang_names.add("ipv4rro-sub-object")

                                self.label_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.LabelRroSubObject()
                                self.label_rro_sub_object.parent = self
                                self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                self._children_yang_names.add("label-rro-sub-object")

                                self.srlg_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.SrlgRroSubObject()
                                self.srlg_rro_sub_object.parent = self
                                self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                self._children_yang_names.add("srlg-rro-sub-object")

                                self.unnumbered_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.UnnumberedRroSubObject()
                                self.unnumbered_rro_sub_object.parent = self
                                self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                self._children_yang_names.add("unnumbered-rro-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("rro_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro, self).__setattr__(name, value)


                            class Ipv4RroSubObject(Entity):
                                """
                                IPV4 RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO IPV4 Subobject Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.Ipv4RroSubObject.Flags>`
                                
                                .. attribute:: rro_address
                                
                                	The RRO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.Ipv4RroSubObject, self).__init__()

                                    self.yang_name = "ipv4rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.rro_address = YLeaf(YType.str, "rro-address")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.Ipv4RroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("rro_address") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.Ipv4RroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.Ipv4RroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO IPV4 Subobject Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "ipv4rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.Ipv4RroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.rro_address.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.rro_address.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.rro_address.is_set or self.rro_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rro_address.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.Ipv4RroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "rro-address"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "rro-address"):
                                        self.rro_address = value
                                        self.rro_address.value_namespace = name_space
                                        self.rro_address.value_namespace_prefix = name_space_prefix


                            class LabelRroSubObject(Entity):
                                """
                                Label RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Label Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.LabelRroSubObject.Flags>`
                                
                                .. attribute:: is_label_variable_length
                                
                                	Is the RRO Subobject Label Variable Length
                                	**type**\:  bool
                                
                                .. attribute:: label
                                
                                	The RRO Subobject Label Value
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: variable_length_label
                                
                                	The RRO Subobject Variable Length Label
                                	**type**\: list of    :py:class:`VariableLengthLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.LabelRroSubObject, self).__init__()

                                    self.yang_name = "label-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.is_label_variable_length = YLeaf(YType.boolean, "is-label-variable-length")

                                    self.label = YLeaf(YType.uint32, "label")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.LabelRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                    self.variable_length_label = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_label_variable_length",
                                                    "label") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.LabelRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.LabelRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Label Flags
                                    
                                    .. attribute:: is_global_label
                                    
                                    	Label is Global across all interfaces
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.is_global_label = YLeaf(YType.boolean, "is-global-label")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_global_label") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.LabelRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.is_global_label.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_global_label.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_global_label.is_set or self.is_global_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_global_label.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-global-label"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-global-label"):
                                            self.is_global_label = value
                                            self.is_global_label.value_namespace = name_space
                                            self.is_global_label.value_namespace_prefix = name_space_prefix


                                class VariableLengthLabel(Entity):
                                    """
                                    The RRO Subobject Variable Length Label
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__init__()

                                        self.yang_name = "variable-length-label"
                                        self.yang_parent_name = "label-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "variable-length-label" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.variable_length_label:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.is_label_variable_length.is_set or
                                        self.label.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    for c in self.variable_length_label:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_label_variable_length.yfilter != YFilter.not_set or
                                        self.label.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "label-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_label_variable_length.is_set or self.is_label_variable_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_label_variable_length.get_name_leafdata())
                                    if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.label.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.LabelRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    if (child_yang_name == "variable-length-label"):
                                        for c in self.variable_length_label:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.LabelRroSubObject.VariableLengthLabel()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.variable_length_label.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "variable-length-label" or name == "is-label-variable-length" or name == "label"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-label-variable-length"):
                                        self.is_label_variable_length = value
                                        self.is_label_variable_length.value_namespace = name_space
                                        self.is_label_variable_length.value_namespace_prefix = name_space_prefix
                                    if(value_path == "label"):
                                        self.label = value
                                        self.label.value_namespace = name_space
                                        self.label.value_namespace_prefix = name_space_prefix


                            class UnnumberedRroSubObject(Entity):
                                """
                                Unnumbered RRO Sub Object
                                
                                .. attribute:: flags
                                
                                	The RRO Subobject Unnumbered Flags
                                	**type**\:   :py:class:`Flags <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags>`
                                
                                .. attribute:: interface_address
                                
                                	The RRO Interface Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: interface_id
                                
                                	The RRO Interface ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.interface_address = YLeaf(YType.str, "interface-address")

                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                    self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags()
                                    self.flags.parent = self
                                    self._children_name_map["flags"] = "flags"
                                    self._children_yang_names.add("flags")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("interface_address",
                                                    "interface_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.UnnumberedRroSubObject, self).__setattr__(name, value)


                                class Flags(Entity):
                                    """
                                    The RRO Subobject Unnumbered Flags
                                    
                                    .. attribute:: is_bandwidth_protected
                                    
                                    	Bandwidth Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_id
                                    
                                    	Node ID In Use
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_node_protection_available
                                    
                                    	Node Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_available
                                    
                                    	Local Protection Available
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_protection_in_use
                                    
                                    	Local Protection In Use
                                    	**type**\:  bool
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__init__()

                                        self.yang_name = "flags"
                                        self.yang_parent_name = "unnumbered-rro-sub-object"

                                        self.is_bandwidth_protected = YLeaf(YType.boolean, "is-bandwidth-protected")

                                        self.is_node_id = YLeaf(YType.boolean, "is-node-id")

                                        self.is_node_protection_available = YLeaf(YType.boolean, "is-node-protection-available")

                                        self.is_protection_available = YLeaf(YType.boolean, "is-protection-available")

                                        self.is_protection_in_use = YLeaf(YType.boolean, "is-protection-in-use")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_bandwidth_protected",
                                                        "is_node_id",
                                                        "is_node_protection_available",
                                                        "is_protection_available",
                                                        "is_protection_in_use") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.is_bandwidth_protected.is_set or
                                            self.is_node_id.is_set or
                                            self.is_node_protection_available.is_set or
                                            self.is_protection_available.is_set or
                                            self.is_protection_in_use.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_bandwidth_protected.yfilter != YFilter.not_set or
                                            self.is_node_id.yfilter != YFilter.not_set or
                                            self.is_node_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_available.yfilter != YFilter.not_set or
                                            self.is_protection_in_use.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "flags" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_bandwidth_protected.is_set or self.is_bandwidth_protected.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_protected.get_name_leafdata())
                                        if (self.is_node_id.is_set or self.is_node_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_id.get_name_leafdata())
                                        if (self.is_node_protection_available.is_set or self.is_node_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_node_protection_available.get_name_leafdata())
                                        if (self.is_protection_available.is_set or self.is_protection_available.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_available.get_name_leafdata())
                                        if (self.is_protection_in_use.is_set or self.is_protection_in_use.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_protection_in_use.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "is-bandwidth-protected" or name == "is-node-id" or name == "is-node-protection-available" or name == "is-protection-available" or name == "is-protection-in-use"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-bandwidth-protected"):
                                            self.is_bandwidth_protected = value
                                            self.is_bandwidth_protected.value_namespace = name_space
                                            self.is_bandwidth_protected.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-id"):
                                            self.is_node_id = value
                                            self.is_node_id.value_namespace = name_space
                                            self.is_node_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-node-protection-available"):
                                            self.is_node_protection_available = value
                                            self.is_node_protection_available.value_namespace = name_space
                                            self.is_node_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-available"):
                                            self.is_protection_available = value
                                            self.is_protection_available.value_namespace = name_space
                                            self.is_protection_available.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-protection-in-use"):
                                            self.is_protection_in_use = value
                                            self.is_protection_in_use.value_namespace = name_space
                                            self.is_protection_in_use.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.interface_address.is_set or
                                        self.interface_id.is_set or
                                        (self.flags is not None and self.flags.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.interface_address.yfilter != YFilter.not_set or
                                        self.interface_id.yfilter != YFilter.not_set or
                                        (self.flags is not None and self.flags.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.interface_address.is_set or self.interface_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_address.get_name_leafdata())
                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "flags"):
                                        if (self.flags is None):
                                            self.flags = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.UnnumberedRroSubObject.Flags()
                                            self.flags.parent = self
                                            self._children_name_map["flags"] = "flags"
                                        return self.flags

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "flags" or name == "interface-address" or name == "interface-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "interface-address"):
                                        self.interface_address = value
                                        self.interface_address.value_namespace = name_space
                                        self.interface_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-id"):
                                        self.interface_id = value
                                        self.interface_id.value_namespace = name_space
                                        self.interface_id.value_namespace_prefix = name_space_prefix


                            class SrlgRroSubObject(Entity):
                                """
                                SRLG RRO Sub Object
                                
                                .. attribute:: srl_gs
                                
                                	The RRO Subobject SRLGs
                                	**type**\: list of    :py:class:`SrlGs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.SrlgRroSubObject, self).__init__()

                                    self.yang_name = "srlg-rro-sub-object"
                                    self.yang_parent_name = "resv-rro"

                                    self.srl_gs = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.SrlgRroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.SrlgRroSubObject, self).__setattr__(name, value)


                                class SrlGs(Entity):
                                    """
                                    The RRO Subobject SRLGs
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__init__()

                                        self.yang_name = "srl-gs"
                                        self.yang_parent_name = "srlg-rro-sub-object"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "srl-gs" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.srl_gs:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.srl_gs:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "srlg-rro-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "srl-gs"):
                                        for c in self.srl_gs:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.SrlgRroSubObject.SrlGs()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.srl_gs.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "srl-gs"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass

                            def has_data(self):
                                return (
                                    self.rro_type.is_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_data()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_data()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_data()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.rro_type.yfilter != YFilter.not_set or
                                    (self.ipv4rro_sub_object is not None and self.ipv4rro_sub_object.has_operation()) or
                                    (self.label_rro_sub_object is not None and self.label_rro_sub_object.has_operation()) or
                                    (self.srlg_rro_sub_object is not None and self.srlg_rro_sub_object.has_operation()) or
                                    (self.unnumbered_rro_sub_object is not None and self.unnumbered_rro_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "resv-rro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.rro_type.is_set or self.rro_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rro_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4rro-sub-object"):
                                    if (self.ipv4rro_sub_object is None):
                                        self.ipv4rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.Ipv4RroSubObject()
                                        self.ipv4rro_sub_object.parent = self
                                        self._children_name_map["ipv4rro_sub_object"] = "ipv4rro-sub-object"
                                    return self.ipv4rro_sub_object

                                if (child_yang_name == "label-rro-sub-object"):
                                    if (self.label_rro_sub_object is None):
                                        self.label_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.LabelRroSubObject()
                                        self.label_rro_sub_object.parent = self
                                        self._children_name_map["label_rro_sub_object"] = "label-rro-sub-object"
                                    return self.label_rro_sub_object

                                if (child_yang_name == "srlg-rro-sub-object"):
                                    if (self.srlg_rro_sub_object is None):
                                        self.srlg_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.SrlgRroSubObject()
                                        self.srlg_rro_sub_object.parent = self
                                        self._children_name_map["srlg_rro_sub_object"] = "srlg-rro-sub-object"
                                    return self.srlg_rro_sub_object

                                if (child_yang_name == "unnumbered-rro-sub-object"):
                                    if (self.unnumbered_rro_sub_object is None):
                                        self.unnumbered_rro_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro.UnnumberedRroSubObject()
                                        self.unnumbered_rro_sub_object.parent = self
                                        self._children_name_map["unnumbered_rro_sub_object"] = "unnumbered-rro-sub-object"
                                    return self.unnumbered_rro_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4rro-sub-object" or name == "label-rro-sub-object" or name == "srlg-rro-sub-object" or name == "unnumbered-rro-sub-object" or name == "rro-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "rro-type"):
                                    self.rro_type = value
                                    self.rro_type.value_namespace = name_space
                                    self.rro_type.value_namespace_prefix = name_space_prefix


                        class PathAffinityArray(Entity):
                            """
                            Tunnel's Path hops with affinity
                            
                            .. attribute:: hop_address
                            
                            	Hop address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: hop_affinity
                            
                            	Deprecated
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: hop_extended_affinity
                            
                            	Hop affinity
                            	**type**\: list of    :py:class:`HopExtendedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathAffinityArray.HopExtendedAffinity>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathAffinityArray, self).__init__()

                                self.yang_name = "path-affinity-array"
                                self.yang_parent_name = "s2l"

                                self.hop_address = YLeaf(YType.str, "hop-address")

                                self.hop_affinity = YLeaf(YType.uint32, "hop-affinity")

                                self.hop_extended_affinity = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("hop_address",
                                                "hop_affinity") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathAffinityArray, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathAffinityArray, self).__setattr__(name, value)


                            class HopExtendedAffinity(Entity):
                                """
                                Hop affinity
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__init__()

                                    self.yang_name = "hop-extended-affinity"
                                    self.yang_parent_name = "path-affinity-array"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathAffinityArray.HopExtendedAffinity, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "hop-extended-affinity" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.hop_extended_affinity:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.hop_address.is_set or
                                    self.hop_affinity.is_set)

                            def has_operation(self):
                                for c in self.hop_extended_affinity:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.hop_address.yfilter != YFilter.not_set or
                                    self.hop_affinity.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-affinity-array" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.hop_address.is_set or self.hop_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hop_address.get_name_leafdata())
                                if (self.hop_affinity.is_set or self.hop_affinity.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hop_affinity.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "hop-extended-affinity"):
                                    for c in self.hop_extended_affinity:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathAffinityArray.HopExtendedAffinity()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.hop_extended_affinity.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "hop-extended-affinity" or name == "hop-address" or name == "hop-affinity"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "hop-address"):
                                    self.hop_address = value
                                    self.hop_address.value_namespace = name_space
                                    self.hop_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "hop-affinity"):
                                    self.hop_affinity = value
                                    self.hop_affinity.value_namespace = name_space
                                    self.hop_affinity.value_namespace_prefix = name_space_prefix


                        class ReverseEroIn(Entity):
                            """
                             Reverse Incoming ERO for this S2L
                            
                            .. attribute:: ero_type
                            
                            	EROType
                            	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                            
                            .. attribute:: ipv4ero_sub_object
                            
                            	IPV4 ERO Sub Object
                            	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ReverseEroIn.Ipv4EroSubObject>`
                            
                            .. attribute:: unnumbered_ero_sub_object
                            
                            	Unnumbered ERO Sub Object
                            	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ReverseEroIn.UnnumberedEroSubObject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ReverseEroIn, self).__init__()

                                self.yang_name = "reverse-ero-in"
                                self.yang_parent_name = "s2l"

                                self.ero_type = YLeaf(YType.enumeration, "ero-type")

                                self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ReverseEroIn.Ipv4EroSubObject()
                                self.ipv4ero_sub_object.parent = self
                                self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                self._children_yang_names.add("ipv4ero-sub-object")

                                self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ReverseEroIn.UnnumberedEroSubObject()
                                self.unnumbered_ero_sub_object.parent = self
                                self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                self._children_yang_names.add("unnumbered-ero-sub-object")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ReverseEroIn, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ReverseEroIn, self).__setattr__(name, value)


                            class Ipv4EroSubObject(Entity):
                                """
                                IPV4 ERO Sub Object
                                
                                .. attribute:: ero_address
                                
                                	The ERO IPV4 Address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: prefix_length
                                
                                	ERO Prefix Length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__init__()

                                    self.yang_name = "ipv4ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"

                                    self.ero_address = YLeaf(YType.str, "ero-address")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_address",
                                                    "is_strict_route",
                                                    "prefix_length") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ReverseEroIn.Ipv4EroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_address.is_set or
                                        self.is_strict_route.is_set or
                                        self.prefix_length.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_address.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.prefix_length.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_address.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-address"):
                                        self.ero_address = value
                                        self.ero_address.value_namespace = name_space
                                        self.ero_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-length"):
                                        self.prefix_length = value
                                        self.prefix_length.value_namespace = name_space
                                        self.prefix_length.value_namespace_prefix = name_space_prefix


                            class UnnumberedEroSubObject(Entity):
                                """
                                Unnumbered ERO Sub Object
                                
                                .. attribute:: ero_interface_id
                                
                                	The Interface ID in ERO
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: ero_router_id
                                
                                	The Router ID in ERO
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: is_strict_route
                                
                                	ERO Entry Is Strict
                                	**type**\:  bool
                                
                                .. attribute:: status
                                
                                	Status of ERO
                                	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__init__()

                                    self.yang_name = "unnumbered-ero-sub-object"
                                    self.yang_parent_name = "reverse-ero-in"

                                    self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                    self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                    self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                    self.status = YLeaf(YType.enumeration, "status")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ero_interface_id",
                                                    "ero_router_id",
                                                    "is_strict_route",
                                                    "status") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ReverseEroIn.UnnumberedEroSubObject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.ero_interface_id.is_set or
                                        self.ero_router_id.is_set or
                                        self.is_strict_route.is_set or
                                        self.status.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ero_interface_id.yfilter != YFilter.not_set or
                                        self.ero_router_id.yfilter != YFilter.not_set or
                                        self.is_strict_route.yfilter != YFilter.not_set or
                                        self.status.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                    if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                    if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                    if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.status.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ero-interface-id"):
                                        self.ero_interface_id = value
                                        self.ero_interface_id.value_namespace = name_space
                                        self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ero-router-id"):
                                        self.ero_router_id = value
                                        self.ero_router_id.value_namespace = name_space
                                        self.ero_router_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-strict-route"):
                                        self.is_strict_route = value
                                        self.is_strict_route.value_namespace = name_space
                                        self.is_strict_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "status"):
                                        self.status = value
                                        self.status.value_namespace = name_space
                                        self.status.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.ero_type.is_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_type.yfilter != YFilter.not_set or
                                    (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                    (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-ero-in" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "ipv4ero-sub-object"):
                                    if (self.ipv4ero_sub_object is None):
                                        self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ReverseEroIn.Ipv4EroSubObject()
                                        self.ipv4ero_sub_object.parent = self
                                        self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                    return self.ipv4ero_sub_object

                                if (child_yang_name == "unnumbered-ero-sub-object"):
                                    if (self.unnumbered_ero_sub_object is None):
                                        self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ReverseEroIn.UnnumberedEroSubObject()
                                        self.unnumbered_ero_sub_object.parent = self
                                        self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                    return self.unnumbered_ero_sub_object

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-type"):
                                    self.ero_type = value
                                    self.ero_type.value_namespace = name_space
                                    self.ero_type.value_namespace_prefix = name_space_prefix


                        class S2LSegmentRoutingPath(Entity):
                            """
                            Segment\-Routing S2L path info
                            
                            .. attribute:: has_entropy_label
                            
                            	Hop has EL specified
                            	**type**\:  bool
                            
                            .. attribute:: has_ip_addresses
                            
                            	Node has IP addresses specified
                            	**type**\:  bool
                            
                            .. attribute:: has_mpls_label
                            
                            	Hop has MPLS label specified
                            	**type**\:  bool
                            
                            .. attribute:: local_addr
                            
                            	Local IP address of adjacency or Node ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: mpls_label_value
                            
                            	The MPLS label value
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: remote_addr
                            
                            	Remote IP address of adjacency
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: sid_type
                            
                            	Type of the SID
                            	**type**\:   :py:class:`TeSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrSid>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.S2LSegmentRoutingPath, self).__init__()

                                self.yang_name = "s2l-segment-routing-path"
                                self.yang_parent_name = "s2l"

                                self.has_entropy_label = YLeaf(YType.boolean, "has-entropy-label")

                                self.has_ip_addresses = YLeaf(YType.boolean, "has-ip-addresses")

                                self.has_mpls_label = YLeaf(YType.boolean, "has-mpls-label")

                                self.local_addr = YLeaf(YType.str, "local-addr")

                                self.mpls_label_value = YLeaf(YType.uint32, "mpls-label-value")

                                self.remote_addr = YLeaf(YType.str, "remote-addr")

                                self.sid_type = YLeaf(YType.enumeration, "sid-type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("has_entropy_label",
                                                "has_ip_addresses",
                                                "has_mpls_label",
                                                "local_addr",
                                                "mpls_label_value",
                                                "remote_addr",
                                                "sid_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.S2LSegmentRoutingPath, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.S2LSegmentRoutingPath, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.has_entropy_label.is_set or
                                    self.has_ip_addresses.is_set or
                                    self.has_mpls_label.is_set or
                                    self.local_addr.is_set or
                                    self.mpls_label_value.is_set or
                                    self.remote_addr.is_set or
                                    self.sid_type.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.has_entropy_label.yfilter != YFilter.not_set or
                                    self.has_ip_addresses.yfilter != YFilter.not_set or
                                    self.has_mpls_label.yfilter != YFilter.not_set or
                                    self.local_addr.yfilter != YFilter.not_set or
                                    self.mpls_label_value.yfilter != YFilter.not_set or
                                    self.remote_addr.yfilter != YFilter.not_set or
                                    self.sid_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-segment-routing-path" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.has_entropy_label.is_set or self.has_entropy_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_entropy_label.get_name_leafdata())
                                if (self.has_ip_addresses.is_set or self.has_ip_addresses.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_ip_addresses.get_name_leafdata())
                                if (self.has_mpls_label.is_set or self.has_mpls_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.has_mpls_label.get_name_leafdata())
                                if (self.local_addr.is_set or self.local_addr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_addr.get_name_leafdata())
                                if (self.mpls_label_value.is_set or self.mpls_label_value.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mpls_label_value.get_name_leafdata())
                                if (self.remote_addr.is_set or self.remote_addr.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.remote_addr.get_name_leafdata())
                                if (self.sid_type.is_set or self.sid_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.sid_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "has-entropy-label" or name == "has-ip-addresses" or name == "has-mpls-label" or name == "local-addr" or name == "mpls-label-value" or name == "remote-addr" or name == "sid-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "has-entropy-label"):
                                    self.has_entropy_label = value
                                    self.has_entropy_label.value_namespace = name_space
                                    self.has_entropy_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-ip-addresses"):
                                    self.has_ip_addresses = value
                                    self.has_ip_addresses.value_namespace = name_space
                                    self.has_ip_addresses.value_namespace_prefix = name_space_prefix
                                if(value_path == "has-mpls-label"):
                                    self.has_mpls_label = value
                                    self.has_mpls_label.value_namespace = name_space
                                    self.has_mpls_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "local-addr"):
                                    self.local_addr = value
                                    self.local_addr.value_namespace = name_space
                                    self.local_addr.value_namespace_prefix = name_space_prefix
                                if(value_path == "mpls-label-value"):
                                    self.mpls_label_value = value
                                    self.mpls_label_value.value_namespace = name_space
                                    self.mpls_label_value.value_namespace_prefix = name_space_prefix
                                if(value_path == "remote-addr"):
                                    self.remote_addr = value
                                    self.remote_addr.value_namespace = name_space
                                    self.remote_addr.value_namespace_prefix = name_space_prefix
                                if(value_path == "sid-type"):
                                    self.sid_type = value
                                    self.sid_type.value_namespace = name_space
                                    self.sid_type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.in_ero:
                                if (c.has_data()):
                                    return True
                            for c in self.out_ero:
                                if (c.has_data()):
                                    return True
                            for c in self.path_affinity_array:
                                if (c.has_data()):
                                    return True
                            for c in self.path_rro:
                                if (c.has_data()):
                                    return True
                            for c in self.resv_rro:
                                if (c.has_data()):
                                    return True
                            for c in self.reverse_ero_in:
                                if (c.has_data()):
                                    return True
                            for c in self.s2l_reverse_lsp_sub_obj:
                                if (c.has_data()):
                                    return True
                            for c in self.s2l_segment_routing_path:
                                if (c.has_data()):
                                    return True
                            for c in self.shared_risk_link_group:
                                if (c.has_data()):
                                    return True
                            return (
                                self.abr_auto_discovered.is_set or
                                self.backup_tunnel_interface.is_set or
                                self.downstream_router_id.is_set or
                                self.egress_interface.is_set or
                                self.egress_interface_brief.is_set or
                                self.egress_interface_state.is_set or
                                self.expanded_ero_affinity_bits.is_set or
                                self.expanded_ero_affinity_mask.is_set or
                                self.expanded_ero_area_id.is_set or
                                self.expanded_ero_metric.is_set or
                                self.expanded_ero_metric_type.is_set or
                                self.frr_out_tunnel_interface.is_set or
                                self.incoming_address.is_set or
                                self.ingress_interface.is_set or
                                self.ingress_interface_brief.is_set or
                                self.ingress_interface_state.is_set or
                                self.is_bandwidth_protect.is_set or
                                self.is_expanded_ero.is_set or
                                self.is_frr_enabled.is_set or
                                self.is_node_protected.is_set or
                                self.is_optical.is_set or
                                self.local_router_id.is_set or
                                self.next_hop_address.is_set or
                                self.node_hop_count.is_set or
                                self.outbound_frr_state.is_set or
                                self.path_reeval_query_mid.is_set or
                                self.path_rro_enabled.is_set or
                                self.path_using_strict_spf.is_set or
                                self.pcalc_area.is_set or
                                self.previous_hop_address.is_set or
                                self.reverse_lsp_connected.is_set or
                                self.reverse_lsp_name.is_set or
                                self.reverse_lsp_present.is_set or
                                self.reverse_weight.is_set or
                                self.role.is_set or
                                self.s2l_local_label.is_set or
                                self.s2l_out_label.is_set or
                                self.s2l_reverse_ero_obj_present.is_set or
                                self.s2l_reverse_tspec_obj_present.is_set or
                                self.signalling_status.is_set or
                                self.time_since_last_preferred_path_exists_send_mid.is_set or
                                self.time_since_last_preferred_tree_exists_send_mid.is_set or
                                self.time_since_last_query_received_mid.is_set or
                                self.upstream_router_id.is_set or
                                self.uptime.is_set or
                                self.weight.is_set or
                                (self.active_path_option is not None and self.active_path_option.has_data()) or
                                (self.association is not None and self.association.has_data()) or
                                (self.diversity_info is not None and self.diversity_info.has_data()) or
                                (self.flex_info is not None and self.flex_info.has_data()) or
                                (self.fspec is not None and self.fspec.has_data()) or
                                (self.generic_fspec is not None and self.generic_fspec.has_data()) or
                                (self.generic_tspec is not None and self.generic_tspec.has_data()) or
                                (self.gmpls_labels is not None and self.gmpls_labels.has_data()) or
                                (self.head_end_bfd_info is not None and self.head_end_bfd_info.has_data()) or
                                (self.in_xro is not None and self.in_xro.has_data()) or
                                (self.incoming_address_generic is not None and self.incoming_address_generic.has_data()) or
                                (self.lsp_wrap_info is not None and self.lsp_wrap_info.has_data()) or
                                (self.next_hop_address_generic is not None and self.next_hop_address_generic.has_data()) or
                                (self.otn_s2l is not None and self.otn_s2l.has_data()) or
                                (self.out_xro is not None and self.out_xro.has_data()) or
                                (self.previous_hop_address_generic is not None and self.previous_hop_address_generic.has_data()) or
                                (self.protection is not None and self.protection.has_data()) or
                                (self.reverse_lsp_fec is not None and self.reverse_lsp_fec.has_data()) or
                                (self.reverse_tspec is not None and self.reverse_tspec.has_data()) or
                                (self.s2l_convergence is not None and self.s2l_convergence.has_data()) or
                                (self.s2l_fec is not None and self.s2l_fec.has_data()) or
                                (self.soft_preemption is not None and self.soft_preemption.has_data()) or
                                (self.srlg_collection is not None and self.srlg_collection.has_data()) or
                                (self.tail_end_bfd_info is not None and self.tail_end_bfd_info.has_data()) or
                                (self.tspec is not None and self.tspec.has_data()))

                        def has_operation(self):
                            for c in self.in_ero:
                                if (c.has_operation()):
                                    return True
                            for c in self.out_ero:
                                if (c.has_operation()):
                                    return True
                            for c in self.path_affinity_array:
                                if (c.has_operation()):
                                    return True
                            for c in self.path_rro:
                                if (c.has_operation()):
                                    return True
                            for c in self.resv_rro:
                                if (c.has_operation()):
                                    return True
                            for c in self.reverse_ero_in:
                                if (c.has_operation()):
                                    return True
                            for c in self.s2l_reverse_lsp_sub_obj:
                                if (c.has_operation()):
                                    return True
                            for c in self.s2l_segment_routing_path:
                                if (c.has_operation()):
                                    return True
                            for c in self.shared_risk_link_group:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.abr_auto_discovered.yfilter != YFilter.not_set or
                                self.backup_tunnel_interface.yfilter != YFilter.not_set or
                                self.downstream_router_id.yfilter != YFilter.not_set or
                                self.egress_interface.yfilter != YFilter.not_set or
                                self.egress_interface_brief.yfilter != YFilter.not_set or
                                self.egress_interface_state.yfilter != YFilter.not_set or
                                self.expanded_ero_affinity_bits.yfilter != YFilter.not_set or
                                self.expanded_ero_affinity_mask.yfilter != YFilter.not_set or
                                self.expanded_ero_area_id.yfilter != YFilter.not_set or
                                self.expanded_ero_metric.yfilter != YFilter.not_set or
                                self.expanded_ero_metric_type.yfilter != YFilter.not_set or
                                self.frr_out_tunnel_interface.yfilter != YFilter.not_set or
                                self.incoming_address.yfilter != YFilter.not_set or
                                self.ingress_interface.yfilter != YFilter.not_set or
                                self.ingress_interface_brief.yfilter != YFilter.not_set or
                                self.ingress_interface_state.yfilter != YFilter.not_set or
                                self.is_bandwidth_protect.yfilter != YFilter.not_set or
                                self.is_expanded_ero.yfilter != YFilter.not_set or
                                self.is_frr_enabled.yfilter != YFilter.not_set or
                                self.is_node_protected.yfilter != YFilter.not_set or
                                self.is_optical.yfilter != YFilter.not_set or
                                self.local_router_id.yfilter != YFilter.not_set or
                                self.next_hop_address.yfilter != YFilter.not_set or
                                self.node_hop_count.yfilter != YFilter.not_set or
                                self.outbound_frr_state.yfilter != YFilter.not_set or
                                self.path_reeval_query_mid.yfilter != YFilter.not_set or
                                self.path_rro_enabled.yfilter != YFilter.not_set or
                                self.path_using_strict_spf.yfilter != YFilter.not_set or
                                self.pcalc_area.yfilter != YFilter.not_set or
                                self.previous_hop_address.yfilter != YFilter.not_set or
                                self.reverse_lsp_connected.yfilter != YFilter.not_set or
                                self.reverse_lsp_name.yfilter != YFilter.not_set or
                                self.reverse_lsp_present.yfilter != YFilter.not_set or
                                self.reverse_weight.yfilter != YFilter.not_set or
                                self.role.yfilter != YFilter.not_set or
                                self.s2l_local_label.yfilter != YFilter.not_set or
                                self.s2l_out_label.yfilter != YFilter.not_set or
                                self.s2l_reverse_ero_obj_present.yfilter != YFilter.not_set or
                                self.s2l_reverse_tspec_obj_present.yfilter != YFilter.not_set or
                                self.signalling_status.yfilter != YFilter.not_set or
                                self.time_since_last_preferred_path_exists_send_mid.yfilter != YFilter.not_set or
                                self.time_since_last_preferred_tree_exists_send_mid.yfilter != YFilter.not_set or
                                self.time_since_last_query_received_mid.yfilter != YFilter.not_set or
                                self.upstream_router_id.yfilter != YFilter.not_set or
                                self.uptime.yfilter != YFilter.not_set or
                                self.weight.yfilter != YFilter.not_set or
                                (self.active_path_option is not None and self.active_path_option.has_operation()) or
                                (self.association is not None and self.association.has_operation()) or
                                (self.diversity_info is not None and self.diversity_info.has_operation()) or
                                (self.flex_info is not None and self.flex_info.has_operation()) or
                                (self.fspec is not None and self.fspec.has_operation()) or
                                (self.generic_fspec is not None and self.generic_fspec.has_operation()) or
                                (self.generic_tspec is not None and self.generic_tspec.has_operation()) or
                                (self.gmpls_labels is not None and self.gmpls_labels.has_operation()) or
                                (self.head_end_bfd_info is not None and self.head_end_bfd_info.has_operation()) or
                                (self.in_xro is not None and self.in_xro.has_operation()) or
                                (self.incoming_address_generic is not None and self.incoming_address_generic.has_operation()) or
                                (self.lsp_wrap_info is not None and self.lsp_wrap_info.has_operation()) or
                                (self.next_hop_address_generic is not None and self.next_hop_address_generic.has_operation()) or
                                (self.otn_s2l is not None and self.otn_s2l.has_operation()) or
                                (self.out_xro is not None and self.out_xro.has_operation()) or
                                (self.previous_hop_address_generic is not None and self.previous_hop_address_generic.has_operation()) or
                                (self.protection is not None and self.protection.has_operation()) or
                                (self.reverse_lsp_fec is not None and self.reverse_lsp_fec.has_operation()) or
                                (self.reverse_tspec is not None and self.reverse_tspec.has_operation()) or
                                (self.s2l_convergence is not None and self.s2l_convergence.has_operation()) or
                                (self.s2l_fec is not None and self.s2l_fec.has_operation()) or
                                (self.soft_preemption is not None and self.soft_preemption.has_operation()) or
                                (self.srlg_collection is not None and self.srlg_collection.has_operation()) or
                                (self.tail_end_bfd_info is not None and self.tail_end_bfd_info.has_operation()) or
                                (self.tspec is not None and self.tspec.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "s2l" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.abr_auto_discovered.is_set or self.abr_auto_discovered.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.abr_auto_discovered.get_name_leafdata())
                            if (self.backup_tunnel_interface.is_set or self.backup_tunnel_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.backup_tunnel_interface.get_name_leafdata())
                            if (self.downstream_router_id.is_set or self.downstream_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.downstream_router_id.get_name_leafdata())
                            if (self.egress_interface.is_set or self.egress_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface.get_name_leafdata())
                            if (self.egress_interface_brief.is_set or self.egress_interface_brief.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface_brief.get_name_leafdata())
                            if (self.egress_interface_state.is_set or self.egress_interface_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.egress_interface_state.get_name_leafdata())
                            if (self.expanded_ero_affinity_bits.is_set or self.expanded_ero_affinity_bits.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_affinity_bits.get_name_leafdata())
                            if (self.expanded_ero_affinity_mask.is_set or self.expanded_ero_affinity_mask.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_affinity_mask.get_name_leafdata())
                            if (self.expanded_ero_area_id.is_set or self.expanded_ero_area_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_area_id.get_name_leafdata())
                            if (self.expanded_ero_metric.is_set or self.expanded_ero_metric.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_metric.get_name_leafdata())
                            if (self.expanded_ero_metric_type.is_set or self.expanded_ero_metric_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.expanded_ero_metric_type.get_name_leafdata())
                            if (self.frr_out_tunnel_interface.is_set or self.frr_out_tunnel_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.frr_out_tunnel_interface.get_name_leafdata())
                            if (self.incoming_address.is_set or self.incoming_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.incoming_address.get_name_leafdata())
                            if (self.ingress_interface.is_set or self.ingress_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface.get_name_leafdata())
                            if (self.ingress_interface_brief.is_set or self.ingress_interface_brief.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface_brief.get_name_leafdata())
                            if (self.ingress_interface_state.is_set or self.ingress_interface_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ingress_interface_state.get_name_leafdata())
                            if (self.is_bandwidth_protect.is_set or self.is_bandwidth_protect.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_bandwidth_protect.get_name_leafdata())
                            if (self.is_expanded_ero.is_set or self.is_expanded_ero.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_expanded_ero.get_name_leafdata())
                            if (self.is_frr_enabled.is_set or self.is_frr_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_frr_enabled.get_name_leafdata())
                            if (self.is_node_protected.is_set or self.is_node_protected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_node_protected.get_name_leafdata())
                            if (self.is_optical.is_set or self.is_optical.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_optical.get_name_leafdata())
                            if (self.local_router_id.is_set or self.local_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.local_router_id.get_name_leafdata())
                            if (self.next_hop_address.is_set or self.next_hop_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.next_hop_address.get_name_leafdata())
                            if (self.node_hop_count.is_set or self.node_hop_count.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.node_hop_count.get_name_leafdata())
                            if (self.outbound_frr_state.is_set or self.outbound_frr_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.outbound_frr_state.get_name_leafdata())
                            if (self.path_reeval_query_mid.is_set or self.path_reeval_query_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reeval_query_mid.get_name_leafdata())
                            if (self.path_rro_enabled.is_set or self.path_rro_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_rro_enabled.get_name_leafdata())
                            if (self.path_using_strict_spf.is_set or self.path_using_strict_spf.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_using_strict_spf.get_name_leafdata())
                            if (self.pcalc_area.is_set or self.pcalc_area.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.pcalc_area.get_name_leafdata())
                            if (self.previous_hop_address.is_set or self.previous_hop_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.previous_hop_address.get_name_leafdata())
                            if (self.reverse_lsp_connected.is_set or self.reverse_lsp_connected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_connected.get_name_leafdata())
                            if (self.reverse_lsp_name.is_set or self.reverse_lsp_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_name.get_name_leafdata())
                            if (self.reverse_lsp_present.is_set or self.reverse_lsp_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_present.get_name_leafdata())
                            if (self.reverse_weight.is_set or self.reverse_weight.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_weight.get_name_leafdata())
                            if (self.role.is_set or self.role.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.role.get_name_leafdata())
                            if (self.s2l_local_label.is_set or self.s2l_local_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_local_label.get_name_leafdata())
                            if (self.s2l_out_label.is_set or self.s2l_out_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_out_label.get_name_leafdata())
                            if (self.s2l_reverse_ero_obj_present.is_set or self.s2l_reverse_ero_obj_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_reverse_ero_obj_present.get_name_leafdata())
                            if (self.s2l_reverse_tspec_obj_present.is_set or self.s2l_reverse_tspec_obj_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_reverse_tspec_obj_present.get_name_leafdata())
                            if (self.signalling_status.is_set or self.signalling_status.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.signalling_status.get_name_leafdata())
                            if (self.time_since_last_preferred_path_exists_send_mid.is_set or self.time_since_last_preferred_path_exists_send_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_preferred_path_exists_send_mid.get_name_leafdata())
                            if (self.time_since_last_preferred_tree_exists_send_mid.is_set or self.time_since_last_preferred_tree_exists_send_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_preferred_tree_exists_send_mid.get_name_leafdata())
                            if (self.time_since_last_query_received_mid.is_set or self.time_since_last_query_received_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_query_received_mid.get_name_leafdata())
                            if (self.upstream_router_id.is_set or self.upstream_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.upstream_router_id.get_name_leafdata())
                            if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.uptime.get_name_leafdata())
                            if (self.weight.is_set or self.weight.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.weight.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "active-path-option"):
                                if (self.active_path_option is None):
                                    self.active_path_option = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ActivePathOption()
                                    self.active_path_option.parent = self
                                    self._children_name_map["active_path_option"] = "active-path-option"
                                return self.active_path_option

                            if (child_yang_name == "association"):
                                if (self.association is None):
                                    self.association = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.Association()
                                    self.association.parent = self
                                    self._children_name_map["association"] = "association"
                                return self.association

                            if (child_yang_name == "diversity-info"):
                                if (self.diversity_info is None):
                                    self.diversity_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.DiversityInfo()
                                    self.diversity_info.parent = self
                                    self._children_name_map["diversity_info"] = "diversity-info"
                                return self.diversity_info

                            if (child_yang_name == "flex-info"):
                                if (self.flex_info is None):
                                    self.flex_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.FlexInfo()
                                    self.flex_info.parent = self
                                    self._children_name_map["flex_info"] = "flex-info"
                                return self.flex_info

                            if (child_yang_name == "fspec"):
                                if (self.fspec is None):
                                    self.fspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.Fspec()
                                    self.fspec.parent = self
                                    self._children_name_map["fspec"] = "fspec"
                                return self.fspec

                            if (child_yang_name == "generic-fspec"):
                                if (self.generic_fspec is None):
                                    self.generic_fspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GenericFspec()
                                    self.generic_fspec.parent = self
                                    self._children_name_map["generic_fspec"] = "generic-fspec"
                                return self.generic_fspec

                            if (child_yang_name == "generic-tspec"):
                                if (self.generic_tspec is None):
                                    self.generic_tspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GenericTspec()
                                    self.generic_tspec.parent = self
                                    self._children_name_map["generic_tspec"] = "generic-tspec"
                                return self.generic_tspec

                            if (child_yang_name == "gmpls-labels"):
                                if (self.gmpls_labels is None):
                                    self.gmpls_labels = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.GmplsLabels()
                                    self.gmpls_labels.parent = self
                                    self._children_name_map["gmpls_labels"] = "gmpls-labels"
                                return self.gmpls_labels

                            if (child_yang_name == "head-end-bfd-info"):
                                if (self.head_end_bfd_info is None):
                                    self.head_end_bfd_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.HeadEndBfdInfo()
                                    self.head_end_bfd_info.parent = self
                                    self._children_name_map["head_end_bfd_info"] = "head-end-bfd-info"
                                return self.head_end_bfd_info

                            if (child_yang_name == "in-ero"):
                                for c in self.in_ero:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InEro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.in_ero.append(c)
                                return c

                            if (child_yang_name == "in-xro"):
                                if (self.in_xro is None):
                                    self.in_xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.InXro()
                                    self.in_xro.parent = self
                                    self._children_name_map["in_xro"] = "in-xro"
                                return self.in_xro

                            if (child_yang_name == "incoming-address-generic"):
                                if (self.incoming_address_generic is None):
                                    self.incoming_address_generic = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.IncomingAddressGeneric()
                                    self.incoming_address_generic.parent = self
                                    self._children_name_map["incoming_address_generic"] = "incoming-address-generic"
                                return self.incoming_address_generic

                            if (child_yang_name == "lsp-wrap-info"):
                                if (self.lsp_wrap_info is None):
                                    self.lsp_wrap_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.LspWrapInfo()
                                    self.lsp_wrap_info.parent = self
                                    self._children_name_map["lsp_wrap_info"] = "lsp-wrap-info"
                                return self.lsp_wrap_info

                            if (child_yang_name == "next-hop-address-generic"):
                                if (self.next_hop_address_generic is None):
                                    self.next_hop_address_generic = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.NextHopAddressGeneric()
                                    self.next_hop_address_generic.parent = self
                                    self._children_name_map["next_hop_address_generic"] = "next-hop-address-generic"
                                return self.next_hop_address_generic

                            if (child_yang_name == "otn-s2l"):
                                if (self.otn_s2l is None):
                                    self.otn_s2l = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OtnS2L()
                                    self.otn_s2l.parent = self
                                    self._children_name_map["otn_s2l"] = "otn-s2l"
                                return self.otn_s2l

                            if (child_yang_name == "out-ero"):
                                for c in self.out_ero:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutEro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.out_ero.append(c)
                                return c

                            if (child_yang_name == "out-xro"):
                                if (self.out_xro is None):
                                    self.out_xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.OutXro()
                                    self.out_xro.parent = self
                                    self._children_name_map["out_xro"] = "out-xro"
                                return self.out_xro

                            if (child_yang_name == "path-affinity-array"):
                                for c in self.path_affinity_array:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathAffinityArray()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_affinity_array.append(c)
                                return c

                            if (child_yang_name == "path-rro"):
                                for c in self.path_rro:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PathRro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_rro.append(c)
                                return c

                            if (child_yang_name == "previous-hop-address-generic"):
                                if (self.previous_hop_address_generic is None):
                                    self.previous_hop_address_generic = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.PreviousHopAddressGeneric()
                                    self.previous_hop_address_generic.parent = self
                                    self._children_name_map["previous_hop_address_generic"] = "previous-hop-address-generic"
                                return self.previous_hop_address_generic

                            if (child_yang_name == "protection"):
                                if (self.protection is None):
                                    self.protection = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.Protection()
                                    self.protection.parent = self
                                    self._children_name_map["protection"] = "protection"
                                return self.protection

                            if (child_yang_name == "resv-rro"):
                                for c in self.resv_rro:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ResvRro()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.resv_rro.append(c)
                                return c

                            if (child_yang_name == "reverse-ero-in"):
                                for c in self.reverse_ero_in:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ReverseEroIn()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.reverse_ero_in.append(c)
                                return c

                            if (child_yang_name == "reverse-lsp-fec"):
                                if (self.reverse_lsp_fec is None):
                                    self.reverse_lsp_fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ReverseLspFec()
                                    self.reverse_lsp_fec.parent = self
                                    self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"
                                return self.reverse_lsp_fec

                            if (child_yang_name == "reverse-tspec"):
                                if (self.reverse_tspec is None):
                                    self.reverse_tspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.ReverseTspec()
                                    self.reverse_tspec.parent = self
                                    self._children_name_map["reverse_tspec"] = "reverse-tspec"
                                return self.reverse_tspec

                            if (child_yang_name == "s2l-convergence"):
                                if (self.s2l_convergence is None):
                                    self.s2l_convergence = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.S2LConvergence()
                                    self.s2l_convergence.parent = self
                                    self._children_name_map["s2l_convergence"] = "s2l-convergence"
                                return self.s2l_convergence

                            if (child_yang_name == "s2l-fec"):
                                if (self.s2l_fec is None):
                                    self.s2l_fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.S2LFec()
                                    self.s2l_fec.parent = self
                                    self._children_name_map["s2l_fec"] = "s2l-fec"
                                return self.s2l_fec

                            if (child_yang_name == "s2l-reverse-lsp-sub-obj"):
                                for c in self.s2l_reverse_lsp_sub_obj:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.S2LReverseLspSubObj()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.s2l_reverse_lsp_sub_obj.append(c)
                                return c

                            if (child_yang_name == "s2l-segment-routing-path"):
                                for c in self.s2l_segment_routing_path:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.S2LSegmentRoutingPath()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.s2l_segment_routing_path.append(c)
                                return c

                            if (child_yang_name == "shared-risk-link-group"):
                                for c in self.shared_risk_link_group:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.SharedRiskLinkGroup()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.shared_risk_link_group.append(c)
                                return c

                            if (child_yang_name == "soft-preemption"):
                                if (self.soft_preemption is None):
                                    self.soft_preemption = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.SoftPreemption()
                                    self.soft_preemption.parent = self
                                    self._children_name_map["soft_preemption"] = "soft-preemption"
                                return self.soft_preemption

                            if (child_yang_name == "srlg-collection"):
                                if (self.srlg_collection is None):
                                    self.srlg_collection = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.SrlgCollection()
                                    self.srlg_collection.parent = self
                                    self._children_name_map["srlg_collection"] = "srlg-collection"
                                return self.srlg_collection

                            if (child_yang_name == "tail-end-bfd-info"):
                                if (self.tail_end_bfd_info is None):
                                    self.tail_end_bfd_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.TailEndBfdInfo()
                                    self.tail_end_bfd_info.parent = self
                                    self._children_name_map["tail_end_bfd_info"] = "tail-end-bfd-info"
                                return self.tail_end_bfd_info

                            if (child_yang_name == "tspec"):
                                if (self.tspec is None):
                                    self.tspec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L.Tspec()
                                    self.tspec.parent = self
                                    self._children_name_map["tspec"] = "tspec"
                                return self.tspec

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "active-path-option" or name == "association" or name == "diversity-info" or name == "flex-info" or name == "fspec" or name == "generic-fspec" or name == "generic-tspec" or name == "gmpls-labels" or name == "head-end-bfd-info" or name == "in-ero" or name == "in-xro" or name == "incoming-address-generic" or name == "lsp-wrap-info" or name == "next-hop-address-generic" or name == "otn-s2l" or name == "out-ero" or name == "out-xro" or name == "path-affinity-array" or name == "path-rro" or name == "previous-hop-address-generic" or name == "protection" or name == "resv-rro" or name == "reverse-ero-in" or name == "reverse-lsp-fec" or name == "reverse-tspec" or name == "s2l-convergence" or name == "s2l-fec" or name == "s2l-reverse-lsp-sub-obj" or name == "s2l-segment-routing-path" or name == "shared-risk-link-group" or name == "soft-preemption" or name == "srlg-collection" or name == "tail-end-bfd-info" or name == "tspec" or name == "abr-auto-discovered" or name == "backup-tunnel-interface" or name == "downstream-router-id" or name == "egress-interface" or name == "egress-interface-brief" or name == "egress-interface-state" or name == "expanded-ero-affinity-bits" or name == "expanded-ero-affinity-mask" or name == "expanded-ero-area-id" or name == "expanded-ero-metric" or name == "expanded-ero-metric-type" or name == "frr-out-tunnel-interface" or name == "incoming-address" or name == "ingress-interface" or name == "ingress-interface-brief" or name == "ingress-interface-state" or name == "is-bandwidth-protect" or name == "is-expanded-ero" or name == "is-frr-enabled" or name == "is-node-protected" or name == "is-optical" or name == "local-router-id" or name == "next-hop-address" or name == "node-hop-count" or name == "outbound-frr-state" or name == "path-reeval-query-mid" or name == "path-rro-enabled" or name == "path-using-strict-spf" or name == "pcalc-area" or name == "previous-hop-address" or name == "reverse-lsp-connected" or name == "reverse-lsp-name" or name == "reverse-lsp-present" or name == "reverse-weight" or name == "role" or name == "s2l-local-label" or name == "s2l-out-label" or name == "s2l-reverse-ero-obj-present" or name == "s2l-reverse-tspec-obj-present" or name == "signalling-status" or name == "time-since-last-preferred-path-exists-send-mid" or name == "time-since-last-preferred-tree-exists-send-mid" or name == "time-since-last-query-received-mid" or name == "upstream-router-id" or name == "uptime" or name == "weight"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "abr-auto-discovered"):
                                self.abr_auto_discovered = value
                                self.abr_auto_discovered.value_namespace = name_space
                                self.abr_auto_discovered.value_namespace_prefix = name_space_prefix
                            if(value_path == "backup-tunnel-interface"):
                                self.backup_tunnel_interface = value
                                self.backup_tunnel_interface.value_namespace = name_space
                                self.backup_tunnel_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "downstream-router-id"):
                                self.downstream_router_id = value
                                self.downstream_router_id.value_namespace = name_space
                                self.downstream_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface"):
                                self.egress_interface = value
                                self.egress_interface.value_namespace = name_space
                                self.egress_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface-brief"):
                                self.egress_interface_brief = value
                                self.egress_interface_brief.value_namespace = name_space
                                self.egress_interface_brief.value_namespace_prefix = name_space_prefix
                            if(value_path == "egress-interface-state"):
                                self.egress_interface_state = value
                                self.egress_interface_state.value_namespace = name_space
                                self.egress_interface_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-affinity-bits"):
                                self.expanded_ero_affinity_bits = value
                                self.expanded_ero_affinity_bits.value_namespace = name_space
                                self.expanded_ero_affinity_bits.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-affinity-mask"):
                                self.expanded_ero_affinity_mask = value
                                self.expanded_ero_affinity_mask.value_namespace = name_space
                                self.expanded_ero_affinity_mask.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-area-id"):
                                self.expanded_ero_area_id = value
                                self.expanded_ero_area_id.value_namespace = name_space
                                self.expanded_ero_area_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-metric"):
                                self.expanded_ero_metric = value
                                self.expanded_ero_metric.value_namespace = name_space
                                self.expanded_ero_metric.value_namespace_prefix = name_space_prefix
                            if(value_path == "expanded-ero-metric-type"):
                                self.expanded_ero_metric_type = value
                                self.expanded_ero_metric_type.value_namespace = name_space
                                self.expanded_ero_metric_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "frr-out-tunnel-interface"):
                                self.frr_out_tunnel_interface = value
                                self.frr_out_tunnel_interface.value_namespace = name_space
                                self.frr_out_tunnel_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "incoming-address"):
                                self.incoming_address = value
                                self.incoming_address.value_namespace = name_space
                                self.incoming_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface"):
                                self.ingress_interface = value
                                self.ingress_interface.value_namespace = name_space
                                self.ingress_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface-brief"):
                                self.ingress_interface_brief = value
                                self.ingress_interface_brief.value_namespace = name_space
                                self.ingress_interface_brief.value_namespace_prefix = name_space_prefix
                            if(value_path == "ingress-interface-state"):
                                self.ingress_interface_state = value
                                self.ingress_interface_state.value_namespace = name_space
                                self.ingress_interface_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-bandwidth-protect"):
                                self.is_bandwidth_protect = value
                                self.is_bandwidth_protect.value_namespace = name_space
                                self.is_bandwidth_protect.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-expanded-ero"):
                                self.is_expanded_ero = value
                                self.is_expanded_ero.value_namespace = name_space
                                self.is_expanded_ero.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-frr-enabled"):
                                self.is_frr_enabled = value
                                self.is_frr_enabled.value_namespace = name_space
                                self.is_frr_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-node-protected"):
                                self.is_node_protected = value
                                self.is_node_protected.value_namespace = name_space
                                self.is_node_protected.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-optical"):
                                self.is_optical = value
                                self.is_optical.value_namespace = name_space
                                self.is_optical.value_namespace_prefix = name_space_prefix
                            if(value_path == "local-router-id"):
                                self.local_router_id = value
                                self.local_router_id.value_namespace = name_space
                                self.local_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "next-hop-address"):
                                self.next_hop_address = value
                                self.next_hop_address.value_namespace = name_space
                                self.next_hop_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "node-hop-count"):
                                self.node_hop_count = value
                                self.node_hop_count.value_namespace = name_space
                                self.node_hop_count.value_namespace_prefix = name_space_prefix
                            if(value_path == "outbound-frr-state"):
                                self.outbound_frr_state = value
                                self.outbound_frr_state.value_namespace = name_space
                                self.outbound_frr_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reeval-query-mid"):
                                self.path_reeval_query_mid = value
                                self.path_reeval_query_mid.value_namespace = name_space
                                self.path_reeval_query_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-rro-enabled"):
                                self.path_rro_enabled = value
                                self.path_rro_enabled.value_namespace = name_space
                                self.path_rro_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-using-strict-spf"):
                                self.path_using_strict_spf = value
                                self.path_using_strict_spf.value_namespace = name_space
                                self.path_using_strict_spf.value_namespace_prefix = name_space_prefix
                            if(value_path == "pcalc-area"):
                                self.pcalc_area = value
                                self.pcalc_area.value_namespace = name_space
                                self.pcalc_area.value_namespace_prefix = name_space_prefix
                            if(value_path == "previous-hop-address"):
                                self.previous_hop_address = value
                                self.previous_hop_address.value_namespace = name_space
                                self.previous_hop_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-connected"):
                                self.reverse_lsp_connected = value
                                self.reverse_lsp_connected.value_namespace = name_space
                                self.reverse_lsp_connected.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-name"):
                                self.reverse_lsp_name = value
                                self.reverse_lsp_name.value_namespace = name_space
                                self.reverse_lsp_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-present"):
                                self.reverse_lsp_present = value
                                self.reverse_lsp_present.value_namespace = name_space
                                self.reverse_lsp_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-weight"):
                                self.reverse_weight = value
                                self.reverse_weight.value_namespace = name_space
                                self.reverse_weight.value_namespace_prefix = name_space_prefix
                            if(value_path == "role"):
                                self.role = value
                                self.role.value_namespace = name_space
                                self.role.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-local-label"):
                                self.s2l_local_label = value
                                self.s2l_local_label.value_namespace = name_space
                                self.s2l_local_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-out-label"):
                                self.s2l_out_label = value
                                self.s2l_out_label.value_namespace = name_space
                                self.s2l_out_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-reverse-ero-obj-present"):
                                self.s2l_reverse_ero_obj_present = value
                                self.s2l_reverse_ero_obj_present.value_namespace = name_space
                                self.s2l_reverse_ero_obj_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-reverse-tspec-obj-present"):
                                self.s2l_reverse_tspec_obj_present = value
                                self.s2l_reverse_tspec_obj_present.value_namespace = name_space
                                self.s2l_reverse_tspec_obj_present.value_namespace_prefix = name_space_prefix
                            if(value_path == "signalling-status"):
                                self.signalling_status = value
                                self.signalling_status.value_namespace = name_space
                                self.signalling_status.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-preferred-path-exists-send-mid"):
                                self.time_since_last_preferred_path_exists_send_mid = value
                                self.time_since_last_preferred_path_exists_send_mid.value_namespace = name_space
                                self.time_since_last_preferred_path_exists_send_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-preferred-tree-exists-send-mid"):
                                self.time_since_last_preferred_tree_exists_send_mid = value
                                self.time_since_last_preferred_tree_exists_send_mid.value_namespace = name_space
                                self.time_since_last_preferred_tree_exists_send_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-query-received-mid"):
                                self.time_since_last_query_received_mid = value
                                self.time_since_last_query_received_mid.value_namespace = name_space
                                self.time_since_last_query_received_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "upstream-router-id"):
                                self.upstream_router_id = value
                                self.upstream_router_id.value_namespace = name_space
                                self.upstream_router_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "uptime"):
                                self.uptime = value
                                self.uptime.value_namespace = name_space
                                self.uptime.value_namespace_prefix = name_space_prefix
                            if(value_path == "weight"):
                                self.weight = value
                                self.weight.value_namespace = name_space
                                self.weight.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.s2l:
                            if (c.has_data()):
                                return True
                        return (
                            self.dste_class_index.is_set or
                            self.dste_class_match.is_set or
                            self.frr_active_reason.is_set or
                            self.is_frr_failed.is_set or
                            self.is_interface.is_set or
                            self.is_passive.is_set or
                            self.last_path_change.is_set or
                            self.lsp_bandwidth.is_set or
                            self.lsp_bandwidth_type.is_set or
                            self.lsp_hold_priority.is_set or
                            self.lsp_setup_priority.is_set or
                            self.persistent_bytes.is_set or
                            self.persistent_packets.is_set or
                            self.reoptimize_reason.is_set or
                            self.reoptimize_trigger.is_set or
                            self.s2_ls_down.is_set or
                            self.s2_ls_proceeding.is_set or
                            self.s2_ls_up.is_set or
                            self.signaled_name.is_set or
                            self.timer_left.is_set or
                            self.type.is_set or
                            self.uptime.is_set or
                            (self.lsp_fec is not None and self.lsp_fec.has_data()))

                    def has_operation(self):
                        for c in self.s2l:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.dste_class_index.yfilter != YFilter.not_set or
                            self.dste_class_match.yfilter != YFilter.not_set or
                            self.frr_active_reason.yfilter != YFilter.not_set or
                            self.is_frr_failed.yfilter != YFilter.not_set or
                            self.is_interface.yfilter != YFilter.not_set or
                            self.is_passive.yfilter != YFilter.not_set or
                            self.last_path_change.yfilter != YFilter.not_set or
                            self.lsp_bandwidth.yfilter != YFilter.not_set or
                            self.lsp_bandwidth_type.yfilter != YFilter.not_set or
                            self.lsp_hold_priority.yfilter != YFilter.not_set or
                            self.lsp_setup_priority.yfilter != YFilter.not_set or
                            self.persistent_bytes.yfilter != YFilter.not_set or
                            self.persistent_packets.yfilter != YFilter.not_set or
                            self.reoptimize_reason.yfilter != YFilter.not_set or
                            self.reoptimize_trigger.yfilter != YFilter.not_set or
                            self.s2_ls_down.yfilter != YFilter.not_set or
                            self.s2_ls_proceeding.yfilter != YFilter.not_set or
                            self.s2_ls_up.yfilter != YFilter.not_set or
                            self.signaled_name.yfilter != YFilter.not_set or
                            self.timer_left.yfilter != YFilter.not_set or
                            self.type.yfilter != YFilter.not_set or
                            self.uptime.yfilter != YFilter.not_set or
                            (self.lsp_fec is not None and self.lsp_fec.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "cleaned-lsp" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.dste_class_index.is_set or self.dste_class_index.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.dste_class_index.get_name_leafdata())
                        if (self.dste_class_match.is_set or self.dste_class_match.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.dste_class_match.get_name_leafdata())
                        if (self.frr_active_reason.is_set or self.frr_active_reason.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.frr_active_reason.get_name_leafdata())
                        if (self.is_frr_failed.is_set or self.is_frr_failed.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_frr_failed.get_name_leafdata())
                        if (self.is_interface.is_set or self.is_interface.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_interface.get_name_leafdata())
                        if (self.is_passive.is_set or self.is_passive.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_passive.get_name_leafdata())
                        if (self.last_path_change.is_set or self.last_path_change.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.last_path_change.get_name_leafdata())
                        if (self.lsp_bandwidth.is_set or self.lsp_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_bandwidth.get_name_leafdata())
                        if (self.lsp_bandwidth_type.is_set or self.lsp_bandwidth_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_bandwidth_type.get_name_leafdata())
                        if (self.lsp_hold_priority.is_set or self.lsp_hold_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_hold_priority.get_name_leafdata())
                        if (self.lsp_setup_priority.is_set or self.lsp_setup_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_setup_priority.get_name_leafdata())
                        if (self.persistent_bytes.is_set or self.persistent_bytes.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.persistent_bytes.get_name_leafdata())
                        if (self.persistent_packets.is_set or self.persistent_packets.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.persistent_packets.get_name_leafdata())
                        if (self.reoptimize_reason.is_set or self.reoptimize_reason.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reoptimize_reason.get_name_leafdata())
                        if (self.reoptimize_trigger.is_set or self.reoptimize_trigger.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reoptimize_trigger.get_name_leafdata())
                        if (self.s2_ls_down.is_set or self.s2_ls_down.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_down.get_name_leafdata())
                        if (self.s2_ls_proceeding.is_set or self.s2_ls_proceeding.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_proceeding.get_name_leafdata())
                        if (self.s2_ls_up.is_set or self.s2_ls_up.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2_ls_up.get_name_leafdata())
                        if (self.signaled_name.is_set or self.signaled_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.signaled_name.get_name_leafdata())
                        if (self.timer_left.is_set or self.timer_left.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.timer_left.get_name_leafdata())
                        if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.type.get_name_leafdata())
                        if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.uptime.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "lsp-fec"):
                            if (self.lsp_fec is None):
                                self.lsp_fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.LspFec()
                                self.lsp_fec.parent = self
                                self._children_name_map["lsp_fec"] = "lsp-fec"
                            return self.lsp_fec

                        if (child_yang_name == "s2l"):
                            for c in self.s2l:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp.S2L()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.s2l.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "lsp-fec" or name == "s2l" or name == "dste-class-index" or name == "dste-class-match" or name == "frr-active-reason" or name == "is-frr-failed" or name == "is-interface" or name == "is-passive" or name == "last-path-change" or name == "lsp-bandwidth" or name == "lsp-bandwidth-type" or name == "lsp-hold-priority" or name == "lsp-setup-priority" or name == "persistent-bytes" or name == "persistent-packets" or name == "reoptimize-reason" or name == "reoptimize-trigger" or name == "s2-ls-down" or name == "s2-ls-proceeding" or name == "s2-ls-up" or name == "signaled-name" or name == "timer-left" or name == "type" or name == "uptime"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "dste-class-index"):
                            self.dste_class_index = value
                            self.dste_class_index.value_namespace = name_space
                            self.dste_class_index.value_namespace_prefix = name_space_prefix
                        if(value_path == "dste-class-match"):
                            self.dste_class_match = value
                            self.dste_class_match.value_namespace = name_space
                            self.dste_class_match.value_namespace_prefix = name_space_prefix
                        if(value_path == "frr-active-reason"):
                            self.frr_active_reason = value
                            self.frr_active_reason.value_namespace = name_space
                            self.frr_active_reason.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-frr-failed"):
                            self.is_frr_failed = value
                            self.is_frr_failed.value_namespace = name_space
                            self.is_frr_failed.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-interface"):
                            self.is_interface = value
                            self.is_interface.value_namespace = name_space
                            self.is_interface.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-passive"):
                            self.is_passive = value
                            self.is_passive.value_namespace = name_space
                            self.is_passive.value_namespace_prefix = name_space_prefix
                        if(value_path == "last-path-change"):
                            self.last_path_change = value
                            self.last_path_change.value_namespace = name_space
                            self.last_path_change.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-bandwidth"):
                            self.lsp_bandwidth = value
                            self.lsp_bandwidth.value_namespace = name_space
                            self.lsp_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-bandwidth-type"):
                            self.lsp_bandwidth_type = value
                            self.lsp_bandwidth_type.value_namespace = name_space
                            self.lsp_bandwidth_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-hold-priority"):
                            self.lsp_hold_priority = value
                            self.lsp_hold_priority.value_namespace = name_space
                            self.lsp_hold_priority.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-setup-priority"):
                            self.lsp_setup_priority = value
                            self.lsp_setup_priority.value_namespace = name_space
                            self.lsp_setup_priority.value_namespace_prefix = name_space_prefix
                        if(value_path == "persistent-bytes"):
                            self.persistent_bytes = value
                            self.persistent_bytes.value_namespace = name_space
                            self.persistent_bytes.value_namespace_prefix = name_space_prefix
                        if(value_path == "persistent-packets"):
                            self.persistent_packets = value
                            self.persistent_packets.value_namespace = name_space
                            self.persistent_packets.value_namespace_prefix = name_space_prefix
                        if(value_path == "reoptimize-reason"):
                            self.reoptimize_reason = value
                            self.reoptimize_reason.value_namespace = name_space
                            self.reoptimize_reason.value_namespace_prefix = name_space_prefix
                        if(value_path == "reoptimize-trigger"):
                            self.reoptimize_trigger = value
                            self.reoptimize_trigger.value_namespace = name_space
                            self.reoptimize_trigger.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-down"):
                            self.s2_ls_down = value
                            self.s2_ls_down.value_namespace = name_space
                            self.s2_ls_down.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-proceeding"):
                            self.s2_ls_proceeding = value
                            self.s2_ls_proceeding.value_namespace = name_space
                            self.s2_ls_proceeding.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2-ls-up"):
                            self.s2_ls_up = value
                            self.s2_ls_up.value_namespace = name_space
                            self.s2_ls_up.value_namespace_prefix = name_space_prefix
                        if(value_path == "signaled-name"):
                            self.signaled_name = value
                            self.signaled_name.value_namespace = name_space
                            self.signaled_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "timer-left"):
                            self.timer_left = value
                            self.timer_left.value_namespace = name_space
                            self.timer_left.value_namespace_prefix = name_space_prefix
                        if(value_path == "type"):
                            self.type = value
                            self.type.value_namespace = name_space
                            self.type.value_namespace_prefix = name_space_prefix
                        if(value_path == "uptime"):
                            self.uptime = value
                            self.uptime.value_namespace = name_space
                            self.uptime.value_namespace_prefix = name_space_prefix


                class P2PInfo(Entity):
                    """
                    P2P specific info
                    
                    .. attribute:: auto_bandwidth_config
                    
                    	Tunnels's AutoBandwidth Configuration information
                    	**type**\:   :py:class:`AutoBandwidthConfig <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.P2PInfo.AutoBandwidthConfig>`
                    
                    .. attribute:: auto_bandwidth_oper
                    
                    	Tunnels's AutoBandwidth Operational information
                    	**type**\:   :py:class:`AutoBandwidthOper <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.P2PInfo.AutoBandwidthOper>`
                    
                    .. attribute:: auto_bandwidth_status
                    
                    	Tunnels's AutoBandwidth Status information
                    	**type**\:   :py:class:`AutoBandwidthStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.P2PInfo.AutoBandwidthStatus>`
                    
                    .. attribute:: is_bidirectional
                    
                    	TRUE if the tunnel is bidirectional
                    	**type**\:  bool
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.P2PInfo, self).__init__()

                        self.yang_name = "p2p-info"
                        self.yang_parent_name = "tunnel-head"

                        self.is_bidirectional = YLeaf(YType.boolean, "is-bidirectional")

                        self.auto_bandwidth_config = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.P2PInfo.AutoBandwidthConfig()
                        self.auto_bandwidth_config.parent = self
                        self._children_name_map["auto_bandwidth_config"] = "auto-bandwidth-config"
                        self._children_yang_names.add("auto-bandwidth-config")

                        self.auto_bandwidth_oper = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.P2PInfo.AutoBandwidthOper()
                        self.auto_bandwidth_oper.parent = self
                        self._children_name_map["auto_bandwidth_oper"] = "auto-bandwidth-oper"
                        self._children_yang_names.add("auto-bandwidth-oper")

                        self.auto_bandwidth_status = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.P2PInfo.AutoBandwidthStatus()
                        self.auto_bandwidth_status.parent = self
                        self._children_name_map["auto_bandwidth_status"] = "auto-bandwidth-status"
                        self._children_yang_names.add("auto-bandwidth-status")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("is_bidirectional") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.P2PInfo, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.P2PInfo, self).__setattr__(name, value)


                    class AutoBandwidthStatus(Entity):
                        """
                        Tunnels's AutoBandwidth Status information
                        
                        .. attribute:: is_auto_bandwidth_enabled
                        
                        	TRUE if auto\-bw is enabled for the tunnel
                        	**type**\:  bool
                        
                        .. attribute:: reactivation_time
                        
                        	Time until auto\-bw gets activated if activation has been delayed due to failover
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.P2PInfo.AutoBandwidthStatus, self).__init__()

                            self.yang_name = "auto-bandwidth-status"
                            self.yang_parent_name = "p2p-info"

                            self.is_auto_bandwidth_enabled = YLeaf(YType.boolean, "is-auto-bandwidth-enabled")

                            self.reactivation_time = YLeaf(YType.uint32, "reactivation-time")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("is_auto_bandwidth_enabled",
                                            "reactivation_time") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.P2PInfo.AutoBandwidthStatus, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.P2PInfo.AutoBandwidthStatus, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.is_auto_bandwidth_enabled.is_set or
                                self.reactivation_time.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.is_auto_bandwidth_enabled.yfilter != YFilter.not_set or
                                self.reactivation_time.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "auto-bandwidth-status" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.is_auto_bandwidth_enabled.is_set or self.is_auto_bandwidth_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_auto_bandwidth_enabled.get_name_leafdata())
                            if (self.reactivation_time.is_set or self.reactivation_time.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reactivation_time.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "is-auto-bandwidth-enabled" or name == "reactivation-time"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "is-auto-bandwidth-enabled"):
                                self.is_auto_bandwidth_enabled = value
                                self.is_auto_bandwidth_enabled.value_namespace = name_space
                                self.is_auto_bandwidth_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "reactivation-time"):
                                self.reactivation_time = value
                                self.reactivation_time.value_namespace = name_space
                                self.reactivation_time.value_namespace_prefix = name_space_prefix


                    class AutoBandwidthConfig(Entity):
                        """
                        Tunnels's AutoBandwidth Configuration
                        information
                        
                        .. attribute:: adjustment_threshold_percent
                        
                        	Bandwidth change threshold needed to trigger bandwidth adjustment
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: adjustment_threshold_value
                        
                        	Bandwidth change value (kbps) needed to trigger bandwidth adjustment
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: kbit/s
                        
                        .. attribute:: application_frequency
                        
                        	Auto\-bw application frequency for the tunnel (mins)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: minute
                        
                        .. attribute:: collection_frequency
                        
                        	Global auto\-bw collection frequency
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: is_auto_bandwidth_collect_only
                        
                        	TRUE if auto\-bw collection\-only is enabled
                        	**type**\:  bool
                        
                        .. attribute:: maximum_bandwidth
                        
                        	Maximum bandwidth auto\-bw can apply
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: minimum_bandwidth
                        
                        	Minimum bandwidth auto\-bw can apply
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: overflow_threshold_limit
                        
                        	Limit of consecutive collections exceeding threshold to trigger an immediate overflow bandwidth adjustment
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: overflow_threshold_percent
                        
                        	Bandwidth change threshold needed to count a collection towards overflow limit allowed
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: overflow_threshold_value
                        
                        	Bandwidth change value needed to count a collection towards overflow limit allowed
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: underflow_threshold_limit
                        
                        	Limit of consecutive collections exceeding threshold to trigger an immediate underflow bandwidth adjustment
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: underflow_threshold_percent
                        
                        	Bandwidth change threshold needed to count a collection towards underflow limit allowed
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: underflow_threshold_value
                        
                        	Bandwidth change value needed to count a collection towards underflow limit allowed
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.P2PInfo.AutoBandwidthConfig, self).__init__()

                            self.yang_name = "auto-bandwidth-config"
                            self.yang_parent_name = "p2p-info"

                            self.adjustment_threshold_percent = YLeaf(YType.uint32, "adjustment-threshold-percent")

                            self.adjustment_threshold_value = YLeaf(YType.uint32, "adjustment-threshold-value")

                            self.application_frequency = YLeaf(YType.uint32, "application-frequency")

                            self.collection_frequency = YLeaf(YType.uint32, "collection-frequency")

                            self.is_auto_bandwidth_collect_only = YLeaf(YType.boolean, "is-auto-bandwidth-collect-only")

                            self.maximum_bandwidth = YLeaf(YType.uint32, "maximum-bandwidth")

                            self.minimum_bandwidth = YLeaf(YType.uint32, "minimum-bandwidth")

                            self.overflow_threshold_limit = YLeaf(YType.uint32, "overflow-threshold-limit")

                            self.overflow_threshold_percent = YLeaf(YType.uint32, "overflow-threshold-percent")

                            self.overflow_threshold_value = YLeaf(YType.uint32, "overflow-threshold-value")

                            self.underflow_threshold_limit = YLeaf(YType.uint32, "underflow-threshold-limit")

                            self.underflow_threshold_percent = YLeaf(YType.uint32, "underflow-threshold-percent")

                            self.underflow_threshold_value = YLeaf(YType.uint32, "underflow-threshold-value")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("adjustment_threshold_percent",
                                            "adjustment_threshold_value",
                                            "application_frequency",
                                            "collection_frequency",
                                            "is_auto_bandwidth_collect_only",
                                            "maximum_bandwidth",
                                            "minimum_bandwidth",
                                            "overflow_threshold_limit",
                                            "overflow_threshold_percent",
                                            "overflow_threshold_value",
                                            "underflow_threshold_limit",
                                            "underflow_threshold_percent",
                                            "underflow_threshold_value") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.P2PInfo.AutoBandwidthConfig, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.P2PInfo.AutoBandwidthConfig, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.adjustment_threshold_percent.is_set or
                                self.adjustment_threshold_value.is_set or
                                self.application_frequency.is_set or
                                self.collection_frequency.is_set or
                                self.is_auto_bandwidth_collect_only.is_set or
                                self.maximum_bandwidth.is_set or
                                self.minimum_bandwidth.is_set or
                                self.overflow_threshold_limit.is_set or
                                self.overflow_threshold_percent.is_set or
                                self.overflow_threshold_value.is_set or
                                self.underflow_threshold_limit.is_set or
                                self.underflow_threshold_percent.is_set or
                                self.underflow_threshold_value.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.adjustment_threshold_percent.yfilter != YFilter.not_set or
                                self.adjustment_threshold_value.yfilter != YFilter.not_set or
                                self.application_frequency.yfilter != YFilter.not_set or
                                self.collection_frequency.yfilter != YFilter.not_set or
                                self.is_auto_bandwidth_collect_only.yfilter != YFilter.not_set or
                                self.maximum_bandwidth.yfilter != YFilter.not_set or
                                self.minimum_bandwidth.yfilter != YFilter.not_set or
                                self.overflow_threshold_limit.yfilter != YFilter.not_set or
                                self.overflow_threshold_percent.yfilter != YFilter.not_set or
                                self.overflow_threshold_value.yfilter != YFilter.not_set or
                                self.underflow_threshold_limit.yfilter != YFilter.not_set or
                                self.underflow_threshold_percent.yfilter != YFilter.not_set or
                                self.underflow_threshold_value.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "auto-bandwidth-config" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.adjustment_threshold_percent.is_set or self.adjustment_threshold_percent.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.adjustment_threshold_percent.get_name_leafdata())
                            if (self.adjustment_threshold_value.is_set or self.adjustment_threshold_value.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.adjustment_threshold_value.get_name_leafdata())
                            if (self.application_frequency.is_set or self.application_frequency.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.application_frequency.get_name_leafdata())
                            if (self.collection_frequency.is_set or self.collection_frequency.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.collection_frequency.get_name_leafdata())
                            if (self.is_auto_bandwidth_collect_only.is_set or self.is_auto_bandwidth_collect_only.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_auto_bandwidth_collect_only.get_name_leafdata())
                            if (self.maximum_bandwidth.is_set or self.maximum_bandwidth.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.maximum_bandwidth.get_name_leafdata())
                            if (self.minimum_bandwidth.is_set or self.minimum_bandwidth.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.minimum_bandwidth.get_name_leafdata())
                            if (self.overflow_threshold_limit.is_set or self.overflow_threshold_limit.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.overflow_threshold_limit.get_name_leafdata())
                            if (self.overflow_threshold_percent.is_set or self.overflow_threshold_percent.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.overflow_threshold_percent.get_name_leafdata())
                            if (self.overflow_threshold_value.is_set or self.overflow_threshold_value.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.overflow_threshold_value.get_name_leafdata())
                            if (self.underflow_threshold_limit.is_set or self.underflow_threshold_limit.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.underflow_threshold_limit.get_name_leafdata())
                            if (self.underflow_threshold_percent.is_set or self.underflow_threshold_percent.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.underflow_threshold_percent.get_name_leafdata())
                            if (self.underflow_threshold_value.is_set or self.underflow_threshold_value.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.underflow_threshold_value.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "adjustment-threshold-percent" or name == "adjustment-threshold-value" or name == "application-frequency" or name == "collection-frequency" or name == "is-auto-bandwidth-collect-only" or name == "maximum-bandwidth" or name == "minimum-bandwidth" or name == "overflow-threshold-limit" or name == "overflow-threshold-percent" or name == "overflow-threshold-value" or name == "underflow-threshold-limit" or name == "underflow-threshold-percent" or name == "underflow-threshold-value"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "adjustment-threshold-percent"):
                                self.adjustment_threshold_percent = value
                                self.adjustment_threshold_percent.value_namespace = name_space
                                self.adjustment_threshold_percent.value_namespace_prefix = name_space_prefix
                            if(value_path == "adjustment-threshold-value"):
                                self.adjustment_threshold_value = value
                                self.adjustment_threshold_value.value_namespace = name_space
                                self.adjustment_threshold_value.value_namespace_prefix = name_space_prefix
                            if(value_path == "application-frequency"):
                                self.application_frequency = value
                                self.application_frequency.value_namespace = name_space
                                self.application_frequency.value_namespace_prefix = name_space_prefix
                            if(value_path == "collection-frequency"):
                                self.collection_frequency = value
                                self.collection_frequency.value_namespace = name_space
                                self.collection_frequency.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-auto-bandwidth-collect-only"):
                                self.is_auto_bandwidth_collect_only = value
                                self.is_auto_bandwidth_collect_only.value_namespace = name_space
                                self.is_auto_bandwidth_collect_only.value_namespace_prefix = name_space_prefix
                            if(value_path == "maximum-bandwidth"):
                                self.maximum_bandwidth = value
                                self.maximum_bandwidth.value_namespace = name_space
                                self.maximum_bandwidth.value_namespace_prefix = name_space_prefix
                            if(value_path == "minimum-bandwidth"):
                                self.minimum_bandwidth = value
                                self.minimum_bandwidth.value_namespace = name_space
                                self.minimum_bandwidth.value_namespace_prefix = name_space_prefix
                            if(value_path == "overflow-threshold-limit"):
                                self.overflow_threshold_limit = value
                                self.overflow_threshold_limit.value_namespace = name_space
                                self.overflow_threshold_limit.value_namespace_prefix = name_space_prefix
                            if(value_path == "overflow-threshold-percent"):
                                self.overflow_threshold_percent = value
                                self.overflow_threshold_percent.value_namespace = name_space
                                self.overflow_threshold_percent.value_namespace_prefix = name_space_prefix
                            if(value_path == "overflow-threshold-value"):
                                self.overflow_threshold_value = value
                                self.overflow_threshold_value.value_namespace = name_space
                                self.overflow_threshold_value.value_namespace_prefix = name_space_prefix
                            if(value_path == "underflow-threshold-limit"):
                                self.underflow_threshold_limit = value
                                self.underflow_threshold_limit.value_namespace = name_space
                                self.underflow_threshold_limit.value_namespace_prefix = name_space_prefix
                            if(value_path == "underflow-threshold-percent"):
                                self.underflow_threshold_percent = value
                                self.underflow_threshold_percent.value_namespace = name_space
                                self.underflow_threshold_percent.value_namespace_prefix = name_space_prefix
                            if(value_path == "underflow-threshold-value"):
                                self.underflow_threshold_value = value
                                self.underflow_threshold_value.value_namespace = name_space
                                self.underflow_threshold_value.value_namespace_prefix = name_space_prefix


                    class AutoBandwidthOper(Entity):
                        """
                        Tunnels's AutoBandwidth Operational information
                        
                        .. attribute:: application_jitter
                        
                        	Amount of time introduced to delay first application so that not all tunnels may signal BW at the same time
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: application_reject_reason
                        
                        	Current application reject reason
                        	**type**\:   :py:class:`TeAutobwAppRej <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAutobwAppRej>`
                        
                        .. attribute:: bandwidth_applications
                        
                        	Total number of bandwidth applications requested by auto\-bw
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: bandwidth_pool_type
                        
                        	Bandwidth pool type
                        	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                        
                        .. attribute:: collect_only_requested_bandwidth
                        
                        	Collect\-only Requested Bandwidth for the tunnel
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: highest_bandwidth
                        
                        	Highest bandwidth registered within current application period
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: last_application_trigger
                        
                        	The reason causing the last BW application
                        	**type**\:   :py:class:`TeAutobwAppTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAutobwAppTrigger>`
                        
                        .. attribute:: last_bandwidth_applied
                        
                        	Last bandwidth requested by auto\-bw for the tunnel
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: overflow_early_bw_applications
                        
                        	tunnel counter for number of bandwidth applications due to overflow
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: samples_collected
                        
                        	Number of samples collected within current application period
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: threshold_overflows
                        
                        	counter for current consecutive collections exceeding threshold
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: threshold_underflows
                        
                        	counter for current consecutive collections exceeding threshold
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: time_left_application
                        
                        	Time left until next auto\-bw application algorithm is performed
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: time_left_collection
                        
                        	Time left until next auto\-bw data collection is performed
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: underflow_early_bw_applications
                        
                        	tunnel counter for number of bandwidth applications due to underflow
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: underflow_highest_bandwidth
                        
                        	Highest sample collected during an underflow sequence
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.P2PInfo.AutoBandwidthOper, self).__init__()

                            self.yang_name = "auto-bandwidth-oper"
                            self.yang_parent_name = "p2p-info"

                            self.application_jitter = YLeaf(YType.uint32, "application-jitter")

                            self.application_reject_reason = YLeaf(YType.enumeration, "application-reject-reason")

                            self.bandwidth_applications = YLeaf(YType.uint32, "bandwidth-applications")

                            self.bandwidth_pool_type = YLeaf(YType.enumeration, "bandwidth-pool-type")

                            self.collect_only_requested_bandwidth = YLeaf(YType.uint32, "collect-only-requested-bandwidth")

                            self.highest_bandwidth = YLeaf(YType.uint32, "highest-bandwidth")

                            self.last_application_trigger = YLeaf(YType.enumeration, "last-application-trigger")

                            self.last_bandwidth_applied = YLeaf(YType.uint32, "last-bandwidth-applied")

                            self.overflow_early_bw_applications = YLeaf(YType.uint32, "overflow-early-bw-applications")

                            self.samples_collected = YLeaf(YType.uint32, "samples-collected")

                            self.threshold_overflows = YLeaf(YType.uint32, "threshold-overflows")

                            self.threshold_underflows = YLeaf(YType.uint32, "threshold-underflows")

                            self.time_left_application = YLeaf(YType.uint32, "time-left-application")

                            self.time_left_collection = YLeaf(YType.uint32, "time-left-collection")

                            self.underflow_early_bw_applications = YLeaf(YType.uint32, "underflow-early-bw-applications")

                            self.underflow_highest_bandwidth = YLeaf(YType.uint32, "underflow-highest-bandwidth")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("application_jitter",
                                            "application_reject_reason",
                                            "bandwidth_applications",
                                            "bandwidth_pool_type",
                                            "collect_only_requested_bandwidth",
                                            "highest_bandwidth",
                                            "last_application_trigger",
                                            "last_bandwidth_applied",
                                            "overflow_early_bw_applications",
                                            "samples_collected",
                                            "threshold_overflows",
                                            "threshold_underflows",
                                            "time_left_application",
                                            "time_left_collection",
                                            "underflow_early_bw_applications",
                                            "underflow_highest_bandwidth") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.P2PInfo.AutoBandwidthOper, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.P2PInfo.AutoBandwidthOper, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.application_jitter.is_set or
                                self.application_reject_reason.is_set or
                                self.bandwidth_applications.is_set or
                                self.bandwidth_pool_type.is_set or
                                self.collect_only_requested_bandwidth.is_set or
                                self.highest_bandwidth.is_set or
                                self.last_application_trigger.is_set or
                                self.last_bandwidth_applied.is_set or
                                self.overflow_early_bw_applications.is_set or
                                self.samples_collected.is_set or
                                self.threshold_overflows.is_set or
                                self.threshold_underflows.is_set or
                                self.time_left_application.is_set or
                                self.time_left_collection.is_set or
                                self.underflow_early_bw_applications.is_set or
                                self.underflow_highest_bandwidth.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.application_jitter.yfilter != YFilter.not_set or
                                self.application_reject_reason.yfilter != YFilter.not_set or
                                self.bandwidth_applications.yfilter != YFilter.not_set or
                                self.bandwidth_pool_type.yfilter != YFilter.not_set or
                                self.collect_only_requested_bandwidth.yfilter != YFilter.not_set or
                                self.highest_bandwidth.yfilter != YFilter.not_set or
                                self.last_application_trigger.yfilter != YFilter.not_set or
                                self.last_bandwidth_applied.yfilter != YFilter.not_set or
                                self.overflow_early_bw_applications.yfilter != YFilter.not_set or
                                self.samples_collected.yfilter != YFilter.not_set or
                                self.threshold_overflows.yfilter != YFilter.not_set or
                                self.threshold_underflows.yfilter != YFilter.not_set or
                                self.time_left_application.yfilter != YFilter.not_set or
                                self.time_left_collection.yfilter != YFilter.not_set or
                                self.underflow_early_bw_applications.yfilter != YFilter.not_set or
                                self.underflow_highest_bandwidth.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "auto-bandwidth-oper" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.application_jitter.is_set or self.application_jitter.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.application_jitter.get_name_leafdata())
                            if (self.application_reject_reason.is_set or self.application_reject_reason.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.application_reject_reason.get_name_leafdata())
                            if (self.bandwidth_applications.is_set or self.bandwidth_applications.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bandwidth_applications.get_name_leafdata())
                            if (self.bandwidth_pool_type.is_set or self.bandwidth_pool_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bandwidth_pool_type.get_name_leafdata())
                            if (self.collect_only_requested_bandwidth.is_set or self.collect_only_requested_bandwidth.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.collect_only_requested_bandwidth.get_name_leafdata())
                            if (self.highest_bandwidth.is_set or self.highest_bandwidth.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.highest_bandwidth.get_name_leafdata())
                            if (self.last_application_trigger.is_set or self.last_application_trigger.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.last_application_trigger.get_name_leafdata())
                            if (self.last_bandwidth_applied.is_set or self.last_bandwidth_applied.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.last_bandwidth_applied.get_name_leafdata())
                            if (self.overflow_early_bw_applications.is_set or self.overflow_early_bw_applications.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.overflow_early_bw_applications.get_name_leafdata())
                            if (self.samples_collected.is_set or self.samples_collected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.samples_collected.get_name_leafdata())
                            if (self.threshold_overflows.is_set or self.threshold_overflows.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.threshold_overflows.get_name_leafdata())
                            if (self.threshold_underflows.is_set or self.threshold_underflows.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.threshold_underflows.get_name_leafdata())
                            if (self.time_left_application.is_set or self.time_left_application.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_left_application.get_name_leafdata())
                            if (self.time_left_collection.is_set or self.time_left_collection.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_left_collection.get_name_leafdata())
                            if (self.underflow_early_bw_applications.is_set or self.underflow_early_bw_applications.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.underflow_early_bw_applications.get_name_leafdata())
                            if (self.underflow_highest_bandwidth.is_set or self.underflow_highest_bandwidth.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.underflow_highest_bandwidth.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "application-jitter" or name == "application-reject-reason" or name == "bandwidth-applications" or name == "bandwidth-pool-type" or name == "collect-only-requested-bandwidth" or name == "highest-bandwidth" or name == "last-application-trigger" or name == "last-bandwidth-applied" or name == "overflow-early-bw-applications" or name == "samples-collected" or name == "threshold-overflows" or name == "threshold-underflows" or name == "time-left-application" or name == "time-left-collection" or name == "underflow-early-bw-applications" or name == "underflow-highest-bandwidth"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "application-jitter"):
                                self.application_jitter = value
                                self.application_jitter.value_namespace = name_space
                                self.application_jitter.value_namespace_prefix = name_space_prefix
                            if(value_path == "application-reject-reason"):
                                self.application_reject_reason = value
                                self.application_reject_reason.value_namespace = name_space
                                self.application_reject_reason.value_namespace_prefix = name_space_prefix
                            if(value_path == "bandwidth-applications"):
                                self.bandwidth_applications = value
                                self.bandwidth_applications.value_namespace = name_space
                                self.bandwidth_applications.value_namespace_prefix = name_space_prefix
                            if(value_path == "bandwidth-pool-type"):
                                self.bandwidth_pool_type = value
                                self.bandwidth_pool_type.value_namespace = name_space
                                self.bandwidth_pool_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "collect-only-requested-bandwidth"):
                                self.collect_only_requested_bandwidth = value
                                self.collect_only_requested_bandwidth.value_namespace = name_space
                                self.collect_only_requested_bandwidth.value_namespace_prefix = name_space_prefix
                            if(value_path == "highest-bandwidth"):
                                self.highest_bandwidth = value
                                self.highest_bandwidth.value_namespace = name_space
                                self.highest_bandwidth.value_namespace_prefix = name_space_prefix
                            if(value_path == "last-application-trigger"):
                                self.last_application_trigger = value
                                self.last_application_trigger.value_namespace = name_space
                                self.last_application_trigger.value_namespace_prefix = name_space_prefix
                            if(value_path == "last-bandwidth-applied"):
                                self.last_bandwidth_applied = value
                                self.last_bandwidth_applied.value_namespace = name_space
                                self.last_bandwidth_applied.value_namespace_prefix = name_space_prefix
                            if(value_path == "overflow-early-bw-applications"):
                                self.overflow_early_bw_applications = value
                                self.overflow_early_bw_applications.value_namespace = name_space
                                self.overflow_early_bw_applications.value_namespace_prefix = name_space_prefix
                            if(value_path == "samples-collected"):
                                self.samples_collected = value
                                self.samples_collected.value_namespace = name_space
                                self.samples_collected.value_namespace_prefix = name_space_prefix
                            if(value_path == "threshold-overflows"):
                                self.threshold_overflows = value
                                self.threshold_overflows.value_namespace = name_space
                                self.threshold_overflows.value_namespace_prefix = name_space_prefix
                            if(value_path == "threshold-underflows"):
                                self.threshold_underflows = value
                                self.threshold_underflows.value_namespace = name_space
                                self.threshold_underflows.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-left-application"):
                                self.time_left_application = value
                                self.time_left_application.value_namespace = name_space
                                self.time_left_application.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-left-collection"):
                                self.time_left_collection = value
                                self.time_left_collection.value_namespace = name_space
                                self.time_left_collection.value_namespace_prefix = name_space_prefix
                            if(value_path == "underflow-early-bw-applications"):
                                self.underflow_early_bw_applications = value
                                self.underflow_early_bw_applications.value_namespace = name_space
                                self.underflow_early_bw_applications.value_namespace_prefix = name_space_prefix
                            if(value_path == "underflow-highest-bandwidth"):
                                self.underflow_highest_bandwidth = value
                                self.underflow_highest_bandwidth.value_namespace = name_space
                                self.underflow_highest_bandwidth.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.is_bidirectional.is_set or
                            (self.auto_bandwidth_config is not None and self.auto_bandwidth_config.has_data()) or
                            (self.auto_bandwidth_oper is not None and self.auto_bandwidth_oper.has_data()) or
                            (self.auto_bandwidth_status is not None and self.auto_bandwidth_status.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.is_bidirectional.yfilter != YFilter.not_set or
                            (self.auto_bandwidth_config is not None and self.auto_bandwidth_config.has_operation()) or
                            (self.auto_bandwidth_oper is not None and self.auto_bandwidth_oper.has_operation()) or
                            (self.auto_bandwidth_status is not None and self.auto_bandwidth_status.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "p2p-info" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.is_bidirectional.is_set or self.is_bidirectional.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_bidirectional.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "auto-bandwidth-config"):
                            if (self.auto_bandwidth_config is None):
                                self.auto_bandwidth_config = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.P2PInfo.AutoBandwidthConfig()
                                self.auto_bandwidth_config.parent = self
                                self._children_name_map["auto_bandwidth_config"] = "auto-bandwidth-config"
                            return self.auto_bandwidth_config

                        if (child_yang_name == "auto-bandwidth-oper"):
                            if (self.auto_bandwidth_oper is None):
                                self.auto_bandwidth_oper = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.P2PInfo.AutoBandwidthOper()
                                self.auto_bandwidth_oper.parent = self
                                self._children_name_map["auto_bandwidth_oper"] = "auto-bandwidth-oper"
                            return self.auto_bandwidth_oper

                        if (child_yang_name == "auto-bandwidth-status"):
                            if (self.auto_bandwidth_status is None):
                                self.auto_bandwidth_status = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.P2PInfo.AutoBandwidthStatus()
                                self.auto_bandwidth_status.parent = self
                                self._children_name_map["auto_bandwidth_status"] = "auto-bandwidth-status"
                            return self.auto_bandwidth_status

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "auto-bandwidth-config" or name == "auto-bandwidth-oper" or name == "auto-bandwidth-status" or name == "is-bidirectional"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "is-bidirectional"):
                            self.is_bidirectional = value
                            self.is_bidirectional.value_namespace = name_space
                            self.is_bidirectional.value_namespace_prefix = name_space_prefix


                class History(Entity):
                    """
                    Tunnel history
                    
                    .. attribute:: current_setup
                    
                    	Current setup data
                    	**type**\:   :py:class:`CurrentSetup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.CurrentSetup>`
                    
                    .. attribute:: gmpls_other_protect_setup
                    
                    	GMPLS additional protecting setup data
                    	**type**\:   :py:class:`GmplsOtherProtectSetup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.GmplsOtherProtectSetup>`
                    
                    .. attribute:: gmpls_other_setup
                    
                    	GMPLS additional setup data
                    	**type**\:   :py:class:`GmplsOtherSetup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.GmplsOtherSetup>`
                    
                    .. attribute:: gmpls_path_protect_setup
                    
                    	GMPLS protecting setup data
                    	**type**\:   :py:class:`GmplsPathProtectSetup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.GmplsPathProtectSetup>`
                    
                    .. attribute:: last_re_opt_fail
                    
                    	Last re\-opt attempt failure information
                    	**type**\:   :py:class:`LastReOptFail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.LastReOptFail>`
                    
                    .. attribute:: last_stdby_re_opt_fail
                    
                    	Last standby re\-opt attempt failure information
                    	**type**\:   :py:class:`LastStdbyReOptFail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.LastStdbyReOptFail>`
                    
                    .. attribute:: previous_gmpls_path_protect_setup
                    
                    	Previous GMPLS protecting setup data
                    	**type**\:   :py:class:`PreviousGmplsPathProtectSetup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.PreviousGmplsPathProtectSetup>`
                    
                    .. attribute:: previous_setup
                    
                    	Previous setup data
                    	**type**\:   :py:class:`PreviousSetup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.PreviousSetup>`
                    
                    .. attribute:: reopt_setup
                    
                    	Reoptimized setup data
                    	**type**\:   :py:class:`ReoptSetup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.ReoptSetup>`
                    
                    .. attribute:: standby_reopt_setup
                    
                    	Standby Reopt setup data
                    	**type**\:   :py:class:`StandbyReoptSetup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.StandbyReoptSetup>`
                    
                    .. attribute:: standby_setup
                    
                    	Standby setup data
                    	**type**\:   :py:class:`StandbySetup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.StandbySetup>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.History, self).__init__()

                        self.yang_name = "history"
                        self.yang_parent_name = "tunnel-head"

                        self.current_setup = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.CurrentSetup()
                        self.current_setup.parent = self
                        self._children_name_map["current_setup"] = "current-setup"
                        self._children_yang_names.add("current-setup")

                        self.gmpls_other_protect_setup = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.GmplsOtherProtectSetup()
                        self.gmpls_other_protect_setup.parent = self
                        self._children_name_map["gmpls_other_protect_setup"] = "gmpls-other-protect-setup"
                        self._children_yang_names.add("gmpls-other-protect-setup")

                        self.gmpls_other_setup = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.GmplsOtherSetup()
                        self.gmpls_other_setup.parent = self
                        self._children_name_map["gmpls_other_setup"] = "gmpls-other-setup"
                        self._children_yang_names.add("gmpls-other-setup")

                        self.gmpls_path_protect_setup = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.GmplsPathProtectSetup()
                        self.gmpls_path_protect_setup.parent = self
                        self._children_name_map["gmpls_path_protect_setup"] = "gmpls-path-protect-setup"
                        self._children_yang_names.add("gmpls-path-protect-setup")

                        self.last_re_opt_fail = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.LastReOptFail()
                        self.last_re_opt_fail.parent = self
                        self._children_name_map["last_re_opt_fail"] = "last-re-opt-fail"
                        self._children_yang_names.add("last-re-opt-fail")

                        self.last_stdby_re_opt_fail = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.LastStdbyReOptFail()
                        self.last_stdby_re_opt_fail.parent = self
                        self._children_name_map["last_stdby_re_opt_fail"] = "last-stdby-re-opt-fail"
                        self._children_yang_names.add("last-stdby-re-opt-fail")

                        self.previous_gmpls_path_protect_setup = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.PreviousGmplsPathProtectSetup()
                        self.previous_gmpls_path_protect_setup.parent = self
                        self._children_name_map["previous_gmpls_path_protect_setup"] = "previous-gmpls-path-protect-setup"
                        self._children_yang_names.add("previous-gmpls-path-protect-setup")

                        self.previous_setup = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.PreviousSetup()
                        self.previous_setup.parent = self
                        self._children_name_map["previous_setup"] = "previous-setup"
                        self._children_yang_names.add("previous-setup")

                        self.reopt_setup = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.ReoptSetup()
                        self.reopt_setup.parent = self
                        self._children_name_map["reopt_setup"] = "reopt-setup"
                        self._children_yang_names.add("reopt-setup")

                        self.standby_reopt_setup = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.StandbyReoptSetup()
                        self.standby_reopt_setup.parent = self
                        self._children_name_map["standby_reopt_setup"] = "standby-reopt-setup"
                        self._children_yang_names.add("standby-reopt-setup")

                        self.standby_setup = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.StandbySetup()
                        self.standby_setup.parent = self
                        self._children_name_map["standby_setup"] = "standby-setup"
                        self._children_yang_names.add("standby-setup")


                    class CurrentSetup(Entity):
                        """
                        Current setup data
                        
                        .. attribute:: connected_uptimes
                        
                        	Uptimes for connected setup
                        	**type**\:   :py:class:`ConnectedUptimes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.CurrentSetup.ConnectedUptimes>`
                        
                        .. attribute:: current_setup_last_error
                        
                        	The last error for the current setup
                        	**type**\:  str
                        
                        .. attribute:: current_setup_timer
                        
                        	Time in seconds until the next attempt to connect this setup
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: selection_reason
                        
                        	The reason why this setup is selected. For display purposes only
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.CurrentSetup, self).__init__()

                            self.yang_name = "current-setup"
                            self.yang_parent_name = "history"

                            self.current_setup_last_error = YLeaf(YType.str, "current-setup-last-error")

                            self.current_setup_timer = YLeaf(YType.uint32, "current-setup-timer")

                            self.selection_reason = YLeaf(YType.str, "selection-reason")

                            self.connected_uptimes = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.CurrentSetup.ConnectedUptimes()
                            self.connected_uptimes.parent = self
                            self._children_name_map["connected_uptimes"] = "connected-uptimes"
                            self._children_yang_names.add("connected-uptimes")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("current_setup_last_error",
                                            "current_setup_timer",
                                            "selection_reason") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.CurrentSetup, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.CurrentSetup, self).__setattr__(name, value)


                        class ConnectedUptimes(Entity):
                            """
                            Uptimes for connected setup
                            
                            .. attribute:: current_lsp_uptime
                            
                            	Time in seconds since the current LSP was up
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: current_uptime
                            
                            	Time in seconds since the tunnel was up
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.CurrentSetup.ConnectedUptimes, self).__init__()

                                self.yang_name = "connected-uptimes"
                                self.yang_parent_name = "current-setup"

                                self.current_lsp_uptime = YLeaf(YType.uint32, "current-lsp-uptime")

                                self.current_uptime = YLeaf(YType.uint32, "current-uptime")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("current_lsp_uptime",
                                                "current_uptime") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.CurrentSetup.ConnectedUptimes, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.CurrentSetup.ConnectedUptimes, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.current_lsp_uptime.is_set or
                                    self.current_uptime.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.current_lsp_uptime.yfilter != YFilter.not_set or
                                    self.current_uptime.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "connected-uptimes" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.current_lsp_uptime.is_set or self.current_lsp_uptime.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.current_lsp_uptime.get_name_leafdata())
                                if (self.current_uptime.is_set or self.current_uptime.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.current_uptime.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "current-lsp-uptime" or name == "current-uptime"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "current-lsp-uptime"):
                                    self.current_lsp_uptime = value
                                    self.current_lsp_uptime.value_namespace = name_space
                                    self.current_lsp_uptime.value_namespace_prefix = name_space_prefix
                                if(value_path == "current-uptime"):
                                    self.current_uptime = value
                                    self.current_uptime.value_namespace = name_space
                                    self.current_uptime.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.current_setup_last_error.is_set or
                                self.current_setup_timer.is_set or
                                self.selection_reason.is_set or
                                (self.connected_uptimes is not None and self.connected_uptimes.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.current_setup_last_error.yfilter != YFilter.not_set or
                                self.current_setup_timer.yfilter != YFilter.not_set or
                                self.selection_reason.yfilter != YFilter.not_set or
                                (self.connected_uptimes is not None and self.connected_uptimes.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "current-setup" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.current_setup_last_error.is_set or self.current_setup_last_error.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.current_setup_last_error.get_name_leafdata())
                            if (self.current_setup_timer.is_set or self.current_setup_timer.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.current_setup_timer.get_name_leafdata())
                            if (self.selection_reason.is_set or self.selection_reason.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.selection_reason.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "connected-uptimes"):
                                if (self.connected_uptimes is None):
                                    self.connected_uptimes = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.CurrentSetup.ConnectedUptimes()
                                    self.connected_uptimes.parent = self
                                    self._children_name_map["connected_uptimes"] = "connected-uptimes"
                                return self.connected_uptimes

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "connected-uptimes" or name == "current-setup-last-error" or name == "current-setup-timer" or name == "selection-reason"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "current-setup-last-error"):
                                self.current_setup_last_error = value
                                self.current_setup_last_error.value_namespace = name_space
                                self.current_setup_last_error.value_namespace_prefix = name_space_prefix
                            if(value_path == "current-setup-timer"):
                                self.current_setup_timer = value
                                self.current_setup_timer.value_namespace = name_space
                                self.current_setup_timer.value_namespace_prefix = name_space_prefix
                            if(value_path == "selection-reason"):
                                self.selection_reason = value
                                self.selection_reason.value_namespace = name_space
                                self.selection_reason.value_namespace_prefix = name_space_prefix


                    class ReoptSetup(Entity):
                        """
                        Reoptimized setup data
                        
                        .. attribute:: reoptimized_setup_last_error
                        
                        	The last error for the reopt setup
                        	**type**\:  str
                        
                        .. attribute:: reoptimized_setup_timer
                        
                        	Time in seconds until the next attempt to connect the reopt setup
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: reoptimized_setup_uptime
                        
                        	Time in seconds since the reopt setup came up
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.ReoptSetup, self).__init__()

                            self.yang_name = "reopt-setup"
                            self.yang_parent_name = "history"

                            self.reoptimized_setup_last_error = YLeaf(YType.str, "reoptimized-setup-last-error")

                            self.reoptimized_setup_timer = YLeaf(YType.uint32, "reoptimized-setup-timer")

                            self.reoptimized_setup_uptime = YLeaf(YType.uint32, "reoptimized-setup-uptime")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("reoptimized_setup_last_error",
                                            "reoptimized_setup_timer",
                                            "reoptimized_setup_uptime") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.ReoptSetup, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.ReoptSetup, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.reoptimized_setup_last_error.is_set or
                                self.reoptimized_setup_timer.is_set or
                                self.reoptimized_setup_uptime.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.reoptimized_setup_last_error.yfilter != YFilter.not_set or
                                self.reoptimized_setup_timer.yfilter != YFilter.not_set or
                                self.reoptimized_setup_uptime.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "reopt-setup" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.reoptimized_setup_last_error.is_set or self.reoptimized_setup_last_error.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reoptimized_setup_last_error.get_name_leafdata())
                            if (self.reoptimized_setup_timer.is_set or self.reoptimized_setup_timer.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reoptimized_setup_timer.get_name_leafdata())
                            if (self.reoptimized_setup_uptime.is_set or self.reoptimized_setup_uptime.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reoptimized_setup_uptime.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "reoptimized-setup-last-error" or name == "reoptimized-setup-timer" or name == "reoptimized-setup-uptime"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "reoptimized-setup-last-error"):
                                self.reoptimized_setup_last_error = value
                                self.reoptimized_setup_last_error.value_namespace = name_space
                                self.reoptimized_setup_last_error.value_namespace_prefix = name_space_prefix
                            if(value_path == "reoptimized-setup-timer"):
                                self.reoptimized_setup_timer = value
                                self.reoptimized_setup_timer.value_namespace = name_space
                                self.reoptimized_setup_timer.value_namespace_prefix = name_space_prefix
                            if(value_path == "reoptimized-setup-uptime"):
                                self.reoptimized_setup_uptime = value
                                self.reoptimized_setup_uptime.value_namespace = name_space
                                self.reoptimized_setup_uptime.value_namespace_prefix = name_space_prefix


                    class GmplsPathProtectSetup(Entity):
                        """
                        GMPLS protecting setup data
                        
                        .. attribute:: protecting_setup_last_error
                        
                        	The last error for the protecting setup (for display purposes only)
                        	**type**\:  str
                        
                        .. attribute:: protecting_setup_timer
                        
                        	Time in seconds until the next attempt to connect the protecting setup
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: protecting_setup_uptime
                        
                        	Time in seconds since the protecting setup came up
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.GmplsPathProtectSetup, self).__init__()

                            self.yang_name = "gmpls-path-protect-setup"
                            self.yang_parent_name = "history"

                            self.protecting_setup_last_error = YLeaf(YType.str, "protecting-setup-last-error")

                            self.protecting_setup_timer = YLeaf(YType.uint32, "protecting-setup-timer")

                            self.protecting_setup_uptime = YLeaf(YType.uint32, "protecting-setup-uptime")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("protecting_setup_last_error",
                                            "protecting_setup_timer",
                                            "protecting_setup_uptime") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.GmplsPathProtectSetup, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.GmplsPathProtectSetup, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.protecting_setup_last_error.is_set or
                                self.protecting_setup_timer.is_set or
                                self.protecting_setup_uptime.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.protecting_setup_last_error.yfilter != YFilter.not_set or
                                self.protecting_setup_timer.yfilter != YFilter.not_set or
                                self.protecting_setup_uptime.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "gmpls-path-protect-setup" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.protecting_setup_last_error.is_set or self.protecting_setup_last_error.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.protecting_setup_last_error.get_name_leafdata())
                            if (self.protecting_setup_timer.is_set or self.protecting_setup_timer.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.protecting_setup_timer.get_name_leafdata())
                            if (self.protecting_setup_uptime.is_set or self.protecting_setup_uptime.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.protecting_setup_uptime.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "protecting-setup-last-error" or name == "protecting-setup-timer" or name == "protecting-setup-uptime"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "protecting-setup-last-error"):
                                self.protecting_setup_last_error = value
                                self.protecting_setup_last_error.value_namespace = name_space
                                self.protecting_setup_last_error.value_namespace_prefix = name_space_prefix
                            if(value_path == "protecting-setup-timer"):
                                self.protecting_setup_timer = value
                                self.protecting_setup_timer.value_namespace = name_space
                                self.protecting_setup_timer.value_namespace_prefix = name_space_prefix
                            if(value_path == "protecting-setup-uptime"):
                                self.protecting_setup_uptime = value
                                self.protecting_setup_uptime.value_namespace = name_space
                                self.protecting_setup_uptime.value_namespace_prefix = name_space_prefix


                    class PreviousSetup(Entity):
                        """
                        Previous setup data
                        
                        .. attribute:: previous_fail_reason
                        
                        	Reason for the previous setup's failure
                        	**type**\:  str
                        
                        .. attribute:: previous_path_option
                        
                        	The previous setup path option
                        	**type**\:  str
                        
                        .. attribute:: previous_setup_last_error
                        
                        	The last error for the previous setup
                        	**type**\:  str
                        
                        .. attribute:: previous_tunnel_instance
                        
                        	The previous setup's instance
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.PreviousSetup, self).__init__()

                            self.yang_name = "previous-setup"
                            self.yang_parent_name = "history"

                            self.previous_fail_reason = YLeaf(YType.str, "previous-fail-reason")

                            self.previous_path_option = YLeaf(YType.str, "previous-path-option")

                            self.previous_setup_last_error = YLeaf(YType.str, "previous-setup-last-error")

                            self.previous_tunnel_instance = YLeaf(YType.uint32, "previous-tunnel-instance")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("previous_fail_reason",
                                            "previous_path_option",
                                            "previous_setup_last_error",
                                            "previous_tunnel_instance") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.PreviousSetup, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.PreviousSetup, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.previous_fail_reason.is_set or
                                self.previous_path_option.is_set or
                                self.previous_setup_last_error.is_set or
                                self.previous_tunnel_instance.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.previous_fail_reason.yfilter != YFilter.not_set or
                                self.previous_path_option.yfilter != YFilter.not_set or
                                self.previous_setup_last_error.yfilter != YFilter.not_set or
                                self.previous_tunnel_instance.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "previous-setup" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.previous_fail_reason.is_set or self.previous_fail_reason.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.previous_fail_reason.get_name_leafdata())
                            if (self.previous_path_option.is_set or self.previous_path_option.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.previous_path_option.get_name_leafdata())
                            if (self.previous_setup_last_error.is_set or self.previous_setup_last_error.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.previous_setup_last_error.get_name_leafdata())
                            if (self.previous_tunnel_instance.is_set or self.previous_tunnel_instance.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.previous_tunnel_instance.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "previous-fail-reason" or name == "previous-path-option" or name == "previous-setup-last-error" or name == "previous-tunnel-instance"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "previous-fail-reason"):
                                self.previous_fail_reason = value
                                self.previous_fail_reason.value_namespace = name_space
                                self.previous_fail_reason.value_namespace_prefix = name_space_prefix
                            if(value_path == "previous-path-option"):
                                self.previous_path_option = value
                                self.previous_path_option.value_namespace = name_space
                                self.previous_path_option.value_namespace_prefix = name_space_prefix
                            if(value_path == "previous-setup-last-error"):
                                self.previous_setup_last_error = value
                                self.previous_setup_last_error.value_namespace = name_space
                                self.previous_setup_last_error.value_namespace_prefix = name_space_prefix
                            if(value_path == "previous-tunnel-instance"):
                                self.previous_tunnel_instance = value
                                self.previous_tunnel_instance.value_namespace = name_space
                                self.previous_tunnel_instance.value_namespace_prefix = name_space_prefix


                    class PreviousGmplsPathProtectSetup(Entity):
                        """
                        Previous GMPLS protecting setup data
                        
                        .. attribute:: previous_protect_fail_reason
                        
                        	Reason for the previous protect setup's failure
                        	**type**\:  str
                        
                        .. attribute:: previous_protect_path_option
                        
                        	The previous protect setup path option
                        	**type**\:  str
                        
                        .. attribute:: previous_protect_setup_last_error
                        
                        	The last error for the previous setup
                        	**type**\:  str
                        
                        .. attribute:: previous_protect_tunnel_instance
                        
                        	The previous protect setup's instance
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.PreviousGmplsPathProtectSetup, self).__init__()

                            self.yang_name = "previous-gmpls-path-protect-setup"
                            self.yang_parent_name = "history"

                            self.previous_protect_fail_reason = YLeaf(YType.str, "previous-protect-fail-reason")

                            self.previous_protect_path_option = YLeaf(YType.str, "previous-protect-path-option")

                            self.previous_protect_setup_last_error = YLeaf(YType.str, "previous-protect-setup-last-error")

                            self.previous_protect_tunnel_instance = YLeaf(YType.uint32, "previous-protect-tunnel-instance")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("previous_protect_fail_reason",
                                            "previous_protect_path_option",
                                            "previous_protect_setup_last_error",
                                            "previous_protect_tunnel_instance") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.PreviousGmplsPathProtectSetup, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.PreviousGmplsPathProtectSetup, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.previous_protect_fail_reason.is_set or
                                self.previous_protect_path_option.is_set or
                                self.previous_protect_setup_last_error.is_set or
                                self.previous_protect_tunnel_instance.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.previous_protect_fail_reason.yfilter != YFilter.not_set or
                                self.previous_protect_path_option.yfilter != YFilter.not_set or
                                self.previous_protect_setup_last_error.yfilter != YFilter.not_set or
                                self.previous_protect_tunnel_instance.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "previous-gmpls-path-protect-setup" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.previous_protect_fail_reason.is_set or self.previous_protect_fail_reason.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.previous_protect_fail_reason.get_name_leafdata())
                            if (self.previous_protect_path_option.is_set or self.previous_protect_path_option.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.previous_protect_path_option.get_name_leafdata())
                            if (self.previous_protect_setup_last_error.is_set or self.previous_protect_setup_last_error.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.previous_protect_setup_last_error.get_name_leafdata())
                            if (self.previous_protect_tunnel_instance.is_set or self.previous_protect_tunnel_instance.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.previous_protect_tunnel_instance.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "previous-protect-fail-reason" or name == "previous-protect-path-option" or name == "previous-protect-setup-last-error" or name == "previous-protect-tunnel-instance"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "previous-protect-fail-reason"):
                                self.previous_protect_fail_reason = value
                                self.previous_protect_fail_reason.value_namespace = name_space
                                self.previous_protect_fail_reason.value_namespace_prefix = name_space_prefix
                            if(value_path == "previous-protect-path-option"):
                                self.previous_protect_path_option = value
                                self.previous_protect_path_option.value_namespace = name_space
                                self.previous_protect_path_option.value_namespace_prefix = name_space_prefix
                            if(value_path == "previous-protect-setup-last-error"):
                                self.previous_protect_setup_last_error = value
                                self.previous_protect_setup_last_error.value_namespace = name_space
                                self.previous_protect_setup_last_error.value_namespace_prefix = name_space_prefix
                            if(value_path == "previous-protect-tunnel-instance"):
                                self.previous_protect_tunnel_instance = value
                                self.previous_protect_tunnel_instance.value_namespace = name_space
                                self.previous_protect_tunnel_instance.value_namespace_prefix = name_space_prefix


                    class GmplsOtherSetup(Entity):
                        """
                        GMPLS additional setup data
                        
                        .. attribute:: other_setup_error
                        
                        	The last error for the additional setup
                        	**type**\:  str
                        
                        .. attribute:: path_option_index
                        
                        	Path option index for the additional setup
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.GmplsOtherSetup, self).__init__()

                            self.yang_name = "gmpls-other-setup"
                            self.yang_parent_name = "history"

                            self.other_setup_error = YLeaf(YType.str, "other-setup-error")

                            self.path_option_index = YLeaf(YType.uint32, "path-option-index")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("other_setup_error",
                                            "path_option_index") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.GmplsOtherSetup, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.GmplsOtherSetup, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.other_setup_error.is_set or
                                self.path_option_index.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.other_setup_error.yfilter != YFilter.not_set or
                                self.path_option_index.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "gmpls-other-setup" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.other_setup_error.is_set or self.other_setup_error.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.other_setup_error.get_name_leafdata())
                            if (self.path_option_index.is_set or self.path_option_index.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_option_index.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "other-setup-error" or name == "path-option-index"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "other-setup-error"):
                                self.other_setup_error = value
                                self.other_setup_error.value_namespace = name_space
                                self.other_setup_error.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-option-index"):
                                self.path_option_index = value
                                self.path_option_index.value_namespace = name_space
                                self.path_option_index.value_namespace_prefix = name_space_prefix


                    class GmplsOtherProtectSetup(Entity):
                        """
                        GMPLS additional protecting setup data
                        
                        .. attribute:: other_setup_error
                        
                        	The last error for the additional setup
                        	**type**\:  str
                        
                        .. attribute:: path_option_index
                        
                        	Path option index for the additional setup
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.GmplsOtherProtectSetup, self).__init__()

                            self.yang_name = "gmpls-other-protect-setup"
                            self.yang_parent_name = "history"

                            self.other_setup_error = YLeaf(YType.str, "other-setup-error")

                            self.path_option_index = YLeaf(YType.uint32, "path-option-index")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("other_setup_error",
                                            "path_option_index") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.GmplsOtherProtectSetup, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.GmplsOtherProtectSetup, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.other_setup_error.is_set or
                                self.path_option_index.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.other_setup_error.yfilter != YFilter.not_set or
                                self.path_option_index.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "gmpls-other-protect-setup" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.other_setup_error.is_set or self.other_setup_error.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.other_setup_error.get_name_leafdata())
                            if (self.path_option_index.is_set or self.path_option_index.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_option_index.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "other-setup-error" or name == "path-option-index"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "other-setup-error"):
                                self.other_setup_error = value
                                self.other_setup_error.value_namespace = name_space
                                self.other_setup_error.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-option-index"):
                                self.path_option_index = value
                                self.path_option_index.value_namespace = name_space
                                self.path_option_index.value_namespace_prefix = name_space_prefix


                    class StandbySetup(Entity):
                        """
                        Standby setup data
                        
                        .. attribute:: standby_lsp_uptime
                        
                        	Time in seconds since the standby LSP was up
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: standby_setup_timer
                        
                        	Time in seconds until the next attempt to connect this setup
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.StandbySetup, self).__init__()

                            self.yang_name = "standby-setup"
                            self.yang_parent_name = "history"

                            self.standby_lsp_uptime = YLeaf(YType.uint32, "standby-lsp-uptime")

                            self.standby_setup_timer = YLeaf(YType.uint32, "standby-setup-timer")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("standby_lsp_uptime",
                                            "standby_setup_timer") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.StandbySetup, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.StandbySetup, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.standby_lsp_uptime.is_set or
                                self.standby_setup_timer.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.standby_lsp_uptime.yfilter != YFilter.not_set or
                                self.standby_setup_timer.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "standby-setup" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.standby_lsp_uptime.is_set or self.standby_lsp_uptime.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.standby_lsp_uptime.get_name_leafdata())
                            if (self.standby_setup_timer.is_set or self.standby_setup_timer.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.standby_setup_timer.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "standby-lsp-uptime" or name == "standby-setup-timer"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "standby-lsp-uptime"):
                                self.standby_lsp_uptime = value
                                self.standby_lsp_uptime.value_namespace = name_space
                                self.standby_lsp_uptime.value_namespace_prefix = name_space_prefix
                            if(value_path == "standby-setup-timer"):
                                self.standby_setup_timer = value
                                self.standby_setup_timer.value_namespace = name_space
                                self.standby_setup_timer.value_namespace_prefix = name_space_prefix


                    class StandbyReoptSetup(Entity):
                        """
                        Standby Reopt setup data
                        
                        .. attribute:: reoptimized_setup_last_error
                        
                        	The last error for the reopt setup
                        	**type**\:  str
                        
                        .. attribute:: reoptimized_setup_timer
                        
                        	Time in seconds until the next attempt to connect the reopt setup
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: reoptimized_setup_uptime
                        
                        	Time in seconds since the reopt setup came up
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.StandbyReoptSetup, self).__init__()

                            self.yang_name = "standby-reopt-setup"
                            self.yang_parent_name = "history"

                            self.reoptimized_setup_last_error = YLeaf(YType.str, "reoptimized-setup-last-error")

                            self.reoptimized_setup_timer = YLeaf(YType.uint32, "reoptimized-setup-timer")

                            self.reoptimized_setup_uptime = YLeaf(YType.uint32, "reoptimized-setup-uptime")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("reoptimized_setup_last_error",
                                            "reoptimized_setup_timer",
                                            "reoptimized_setup_uptime") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.StandbyReoptSetup, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.StandbyReoptSetup, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.reoptimized_setup_last_error.is_set or
                                self.reoptimized_setup_timer.is_set or
                                self.reoptimized_setup_uptime.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.reoptimized_setup_last_error.yfilter != YFilter.not_set or
                                self.reoptimized_setup_timer.yfilter != YFilter.not_set or
                                self.reoptimized_setup_uptime.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "standby-reopt-setup" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.reoptimized_setup_last_error.is_set or self.reoptimized_setup_last_error.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reoptimized_setup_last_error.get_name_leafdata())
                            if (self.reoptimized_setup_timer.is_set or self.reoptimized_setup_timer.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reoptimized_setup_timer.get_name_leafdata())
                            if (self.reoptimized_setup_uptime.is_set or self.reoptimized_setup_uptime.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reoptimized_setup_uptime.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "reoptimized-setup-last-error" or name == "reoptimized-setup-timer" or name == "reoptimized-setup-uptime"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "reoptimized-setup-last-error"):
                                self.reoptimized_setup_last_error = value
                                self.reoptimized_setup_last_error.value_namespace = name_space
                                self.reoptimized_setup_last_error.value_namespace_prefix = name_space_prefix
                            if(value_path == "reoptimized-setup-timer"):
                                self.reoptimized_setup_timer = value
                                self.reoptimized_setup_timer.value_namespace = name_space
                                self.reoptimized_setup_timer.value_namespace_prefix = name_space_prefix
                            if(value_path == "reoptimized-setup-uptime"):
                                self.reoptimized_setup_uptime = value
                                self.reoptimized_setup_uptime.value_namespace = name_space
                                self.reoptimized_setup_uptime.value_namespace_prefix = name_space_prefix


                    class LastReOptFail(Entity):
                        """
                        Last re\-opt attempt failure information
                        
                        .. attribute:: re_opt_failed_destination
                        
                        	First tunnel destination (if any) in re\-opt LSP that failed to come up
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: re_opt_failed_timestamp
                        
                        	Time stamp of the last re\-opt failure. (seconds since Jan. 1, 1970)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: re_opt_last_fail_reason
                        
                        	Reason (if any) for the last re\-opt attempt failure
                        	**type**\:   :py:class:`MplsTeReoptDecisionReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReoptDecisionReason>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.LastReOptFail, self).__init__()

                            self.yang_name = "last-re-opt-fail"
                            self.yang_parent_name = "history"

                            self.re_opt_failed_destination = YLeaf(YType.str, "re-opt-failed-destination")

                            self.re_opt_failed_timestamp = YLeaf(YType.uint32, "re-opt-failed-timestamp")

                            self.re_opt_last_fail_reason = YLeaf(YType.enumeration, "re-opt-last-fail-reason")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("re_opt_failed_destination",
                                            "re_opt_failed_timestamp",
                                            "re_opt_last_fail_reason") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.LastReOptFail, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.LastReOptFail, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.re_opt_failed_destination.is_set or
                                self.re_opt_failed_timestamp.is_set or
                                self.re_opt_last_fail_reason.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.re_opt_failed_destination.yfilter != YFilter.not_set or
                                self.re_opt_failed_timestamp.yfilter != YFilter.not_set or
                                self.re_opt_last_fail_reason.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "last-re-opt-fail" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.re_opt_failed_destination.is_set or self.re_opt_failed_destination.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.re_opt_failed_destination.get_name_leafdata())
                            if (self.re_opt_failed_timestamp.is_set or self.re_opt_failed_timestamp.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.re_opt_failed_timestamp.get_name_leafdata())
                            if (self.re_opt_last_fail_reason.is_set or self.re_opt_last_fail_reason.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.re_opt_last_fail_reason.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "re-opt-failed-destination" or name == "re-opt-failed-timestamp" or name == "re-opt-last-fail-reason"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "re-opt-failed-destination"):
                                self.re_opt_failed_destination = value
                                self.re_opt_failed_destination.value_namespace = name_space
                                self.re_opt_failed_destination.value_namespace_prefix = name_space_prefix
                            if(value_path == "re-opt-failed-timestamp"):
                                self.re_opt_failed_timestamp = value
                                self.re_opt_failed_timestamp.value_namespace = name_space
                                self.re_opt_failed_timestamp.value_namespace_prefix = name_space_prefix
                            if(value_path == "re-opt-last-fail-reason"):
                                self.re_opt_last_fail_reason = value
                                self.re_opt_last_fail_reason.value_namespace = name_space
                                self.re_opt_last_fail_reason.value_namespace_prefix = name_space_prefix


                    class LastStdbyReOptFail(Entity):
                        """
                        Last standby re\-opt attempt failure information
                        
                        .. attribute:: re_opt_failed_destination
                        
                        	First tunnel destination (if any) in re\-opt LSP that failed to come up
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: re_opt_failed_timestamp
                        
                        	Time stamp of the last re\-opt failure. (seconds since Jan. 1, 1970)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: re_opt_last_fail_reason
                        
                        	Reason (if any) for the last re\-opt attempt failure
                        	**type**\:   :py:class:`MplsTeReoptDecisionReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeReoptDecisionReason>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.LastStdbyReOptFail, self).__init__()

                            self.yang_name = "last-stdby-re-opt-fail"
                            self.yang_parent_name = "history"

                            self.re_opt_failed_destination = YLeaf(YType.str, "re-opt-failed-destination")

                            self.re_opt_failed_timestamp = YLeaf(YType.uint32, "re-opt-failed-timestamp")

                            self.re_opt_last_fail_reason = YLeaf(YType.enumeration, "re-opt-last-fail-reason")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("re_opt_failed_destination",
                                            "re_opt_failed_timestamp",
                                            "re_opt_last_fail_reason") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.LastStdbyReOptFail, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.LastStdbyReOptFail, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.re_opt_failed_destination.is_set or
                                self.re_opt_failed_timestamp.is_set or
                                self.re_opt_last_fail_reason.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.re_opt_failed_destination.yfilter != YFilter.not_set or
                                self.re_opt_failed_timestamp.yfilter != YFilter.not_set or
                                self.re_opt_last_fail_reason.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "last-stdby-re-opt-fail" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.re_opt_failed_destination.is_set or self.re_opt_failed_destination.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.re_opt_failed_destination.get_name_leafdata())
                            if (self.re_opt_failed_timestamp.is_set or self.re_opt_failed_timestamp.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.re_opt_failed_timestamp.get_name_leafdata())
                            if (self.re_opt_last_fail_reason.is_set or self.re_opt_last_fail_reason.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.re_opt_last_fail_reason.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "re-opt-failed-destination" or name == "re-opt-failed-timestamp" or name == "re-opt-last-fail-reason"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "re-opt-failed-destination"):
                                self.re_opt_failed_destination = value
                                self.re_opt_failed_destination.value_namespace = name_space
                                self.re_opt_failed_destination.value_namespace_prefix = name_space_prefix
                            if(value_path == "re-opt-failed-timestamp"):
                                self.re_opt_failed_timestamp = value
                                self.re_opt_failed_timestamp.value_namespace = name_space
                                self.re_opt_failed_timestamp.value_namespace_prefix = name_space_prefix
                            if(value_path == "re-opt-last-fail-reason"):
                                self.re_opt_last_fail_reason = value
                                self.re_opt_last_fail_reason.value_namespace = name_space
                                self.re_opt_last_fail_reason.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            (self.current_setup is not None and self.current_setup.has_data()) or
                            (self.gmpls_other_protect_setup is not None and self.gmpls_other_protect_setup.has_data()) or
                            (self.gmpls_other_setup is not None and self.gmpls_other_setup.has_data()) or
                            (self.gmpls_path_protect_setup is not None and self.gmpls_path_protect_setup.has_data()) or
                            (self.last_re_opt_fail is not None and self.last_re_opt_fail.has_data()) or
                            (self.last_stdby_re_opt_fail is not None and self.last_stdby_re_opt_fail.has_data()) or
                            (self.previous_gmpls_path_protect_setup is not None and self.previous_gmpls_path_protect_setup.has_data()) or
                            (self.previous_setup is not None and self.previous_setup.has_data()) or
                            (self.reopt_setup is not None and self.reopt_setup.has_data()) or
                            (self.standby_reopt_setup is not None and self.standby_reopt_setup.has_data()) or
                            (self.standby_setup is not None and self.standby_setup.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            (self.current_setup is not None and self.current_setup.has_operation()) or
                            (self.gmpls_other_protect_setup is not None and self.gmpls_other_protect_setup.has_operation()) or
                            (self.gmpls_other_setup is not None and self.gmpls_other_setup.has_operation()) or
                            (self.gmpls_path_protect_setup is not None and self.gmpls_path_protect_setup.has_operation()) or
                            (self.last_re_opt_fail is not None and self.last_re_opt_fail.has_operation()) or
                            (self.last_stdby_re_opt_fail is not None and self.last_stdby_re_opt_fail.has_operation()) or
                            (self.previous_gmpls_path_protect_setup is not None and self.previous_gmpls_path_protect_setup.has_operation()) or
                            (self.previous_setup is not None and self.previous_setup.has_operation()) or
                            (self.reopt_setup is not None and self.reopt_setup.has_operation()) or
                            (self.standby_reopt_setup is not None and self.standby_reopt_setup.has_operation()) or
                            (self.standby_setup is not None and self.standby_setup.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "history" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "current-setup"):
                            if (self.current_setup is None):
                                self.current_setup = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.CurrentSetup()
                                self.current_setup.parent = self
                                self._children_name_map["current_setup"] = "current-setup"
                            return self.current_setup

                        if (child_yang_name == "gmpls-other-protect-setup"):
                            if (self.gmpls_other_protect_setup is None):
                                self.gmpls_other_protect_setup = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.GmplsOtherProtectSetup()
                                self.gmpls_other_protect_setup.parent = self
                                self._children_name_map["gmpls_other_protect_setup"] = "gmpls-other-protect-setup"
                            return self.gmpls_other_protect_setup

                        if (child_yang_name == "gmpls-other-setup"):
                            if (self.gmpls_other_setup is None):
                                self.gmpls_other_setup = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.GmplsOtherSetup()
                                self.gmpls_other_setup.parent = self
                                self._children_name_map["gmpls_other_setup"] = "gmpls-other-setup"
                            return self.gmpls_other_setup

                        if (child_yang_name == "gmpls-path-protect-setup"):
                            if (self.gmpls_path_protect_setup is None):
                                self.gmpls_path_protect_setup = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.GmplsPathProtectSetup()
                                self.gmpls_path_protect_setup.parent = self
                                self._children_name_map["gmpls_path_protect_setup"] = "gmpls-path-protect-setup"
                            return self.gmpls_path_protect_setup

                        if (child_yang_name == "last-re-opt-fail"):
                            if (self.last_re_opt_fail is None):
                                self.last_re_opt_fail = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.LastReOptFail()
                                self.last_re_opt_fail.parent = self
                                self._children_name_map["last_re_opt_fail"] = "last-re-opt-fail"
                            return self.last_re_opt_fail

                        if (child_yang_name == "last-stdby-re-opt-fail"):
                            if (self.last_stdby_re_opt_fail is None):
                                self.last_stdby_re_opt_fail = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.LastStdbyReOptFail()
                                self.last_stdby_re_opt_fail.parent = self
                                self._children_name_map["last_stdby_re_opt_fail"] = "last-stdby-re-opt-fail"
                            return self.last_stdby_re_opt_fail

                        if (child_yang_name == "previous-gmpls-path-protect-setup"):
                            if (self.previous_gmpls_path_protect_setup is None):
                                self.previous_gmpls_path_protect_setup = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.PreviousGmplsPathProtectSetup()
                                self.previous_gmpls_path_protect_setup.parent = self
                                self._children_name_map["previous_gmpls_path_protect_setup"] = "previous-gmpls-path-protect-setup"
                            return self.previous_gmpls_path_protect_setup

                        if (child_yang_name == "previous-setup"):
                            if (self.previous_setup is None):
                                self.previous_setup = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.PreviousSetup()
                                self.previous_setup.parent = self
                                self._children_name_map["previous_setup"] = "previous-setup"
                            return self.previous_setup

                        if (child_yang_name == "reopt-setup"):
                            if (self.reopt_setup is None):
                                self.reopt_setup = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.ReoptSetup()
                                self.reopt_setup.parent = self
                                self._children_name_map["reopt_setup"] = "reopt-setup"
                            return self.reopt_setup

                        if (child_yang_name == "standby-reopt-setup"):
                            if (self.standby_reopt_setup is None):
                                self.standby_reopt_setup = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.StandbyReoptSetup()
                                self.standby_reopt_setup.parent = self
                                self._children_name_map["standby_reopt_setup"] = "standby-reopt-setup"
                            return self.standby_reopt_setup

                        if (child_yang_name == "standby-setup"):
                            if (self.standby_setup is None):
                                self.standby_setup = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.History.StandbySetup()
                                self.standby_setup.parent = self
                                self._children_name_map["standby_setup"] = "standby-setup"
                            return self.standby_setup

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "current-setup" or name == "gmpls-other-protect-setup" or name == "gmpls-other-setup" or name == "gmpls-path-protect-setup" or name == "last-re-opt-fail" or name == "last-stdby-re-opt-fail" or name == "previous-gmpls-path-protect-setup" or name == "previous-setup" or name == "reopt-setup" or name == "standby-reopt-setup" or name == "standby-setup"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class PathProtection(Entity):
                    """
                    Path Protect Info
                    
                    .. attribute:: diversity_type
                    
                    	Standby path diversity type
                    	**type**\:   :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                    
                    .. attribute:: is_path_protect_configured
                    
                    	Is Path Protection Configured
                    	**type**\:  bool
                    
                    .. attribute:: is_path_protect_switch_over_underway
                    
                    	Is Switchover Underway
                    	**type**\:  bool
                    
                    .. attribute:: path_protection_protected_by_id
                    
                    	The path option ID (level/index) of the configured explicit protecting path
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: reoptimization_time_remaining
                    
                    	Remaining time until path protection reoptimization (seconds)
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: standby_reoptimized_number
                    
                    	Number of times the standby LSP was reoptimized
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: switchover
                    
                    	Path Protected Switchover Information
                    	**type**\:   :py:class:`Switchover <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.PathProtection.Switchover>`
                    
                    .. attribute:: switchover_ready
                    
                    	Total times, Standby LSP ready for use
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: switchover_reason
                    
                    	Reason for last switchover
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: switchover_total
                    
                    	Number of times switchover occurred
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: time_of_switchover_sec
                    
                    	The date when the switchover was completed. This date is the number of seconds since Jan 1st 1970
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: valid_path_protection_path_option_exists
                    
                    	Flag to indicate whether tunnel has a path\-option which is valid for path\-protection
                    	**type**\:  bool
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.PathProtection, self).__init__()

                        self.yang_name = "path-protection"
                        self.yang_parent_name = "tunnel-head"

                        self.diversity_type = YLeaf(YType.enumeration, "diversity-type")

                        self.is_path_protect_configured = YLeaf(YType.boolean, "is-path-protect-configured")

                        self.is_path_protect_switch_over_underway = YLeaf(YType.boolean, "is-path-protect-switch-over-underway")

                        self.path_protection_protected_by_id = YLeaf(YType.uint32, "path-protection-protected-by-id")

                        self.reoptimization_time_remaining = YLeaf(YType.uint32, "reoptimization-time-remaining")

                        self.standby_reoptimized_number = YLeaf(YType.uint16, "standby-reoptimized-number")

                        self.switchover_ready = YLeaf(YType.uint16, "switchover-ready")

                        self.switchover_reason = YLeaf(YType.uint16, "switchover-reason")

                        self.switchover_total = YLeaf(YType.uint16, "switchover-total")

                        self.time_of_switchover_sec = YLeaf(YType.uint32, "time-of-switchover-sec")

                        self.valid_path_protection_path_option_exists = YLeaf(YType.boolean, "valid-path-protection-path-option-exists")

                        self.switchover = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.PathProtection.Switchover()
                        self.switchover.parent = self
                        self._children_name_map["switchover"] = "switchover"
                        self._children_yang_names.add("switchover")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("diversity_type",
                                        "is_path_protect_configured",
                                        "is_path_protect_switch_over_underway",
                                        "path_protection_protected_by_id",
                                        "reoptimization_time_remaining",
                                        "standby_reoptimized_number",
                                        "switchover_ready",
                                        "switchover_reason",
                                        "switchover_total",
                                        "time_of_switchover_sec",
                                        "valid_path_protection_path_option_exists") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.PathProtection, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.PathProtection, self).__setattr__(name, value)


                    class Switchover(Entity):
                        """
                        Path Protected Switchover Information
                        
                        .. attribute:: date_of_error_detection
                        
                        	The date when the error that caused the switchover was detected. This date is the number of seconds since Jan 1st 1970
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: date_of_error_detection_millisec
                        
                        	The milliseconds offset of the date when the error that caused  the switchover was detected
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: millisecond
                        
                        .. attribute:: from_lsp_id
                        
                        	The LSP ID from which the traffic was switched over
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: path_protection_switchover_event_index
                        
                        	The index number of the path protection switch over event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: path_protection_switchover_reason
                        
                        	The reason that caused the path protection switchover
                        	**type**\:   :py:class:`TeP2MpS2LDeletionSubcause <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeP2MpS2LDeletionSubcause>`
                        
                        .. attribute:: path_protection_tunnel_id
                        
                        	The ID of the tunnel that experienced switchover
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: switchover_duration_millisec
                        
                        	The time in milliseconds between the detection of the error and switching the traffic
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: millisecond
                        
                        .. attribute:: to_lsp_id
                        
                        	The LSP ID to which the traffic was switched over
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.PathProtection.Switchover, self).__init__()

                            self.yang_name = "switchover"
                            self.yang_parent_name = "path-protection"

                            self.date_of_error_detection = YLeaf(YType.uint32, "date-of-error-detection")

                            self.date_of_error_detection_millisec = YLeaf(YType.uint32, "date-of-error-detection-millisec")

                            self.from_lsp_id = YLeaf(YType.uint16, "from-lsp-id")

                            self.path_protection_switchover_event_index = YLeaf(YType.uint32, "path-protection-switchover-event-index")

                            self.path_protection_switchover_reason = YLeaf(YType.enumeration, "path-protection-switchover-reason")

                            self.path_protection_tunnel_id = YLeaf(YType.uint16, "path-protection-tunnel-id")

                            self.switchover_duration_millisec = YLeaf(YType.uint32, "switchover-duration-millisec")

                            self.to_lsp_id = YLeaf(YType.uint16, "to-lsp-id")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("date_of_error_detection",
                                            "date_of_error_detection_millisec",
                                            "from_lsp_id",
                                            "path_protection_switchover_event_index",
                                            "path_protection_switchover_reason",
                                            "path_protection_tunnel_id",
                                            "switchover_duration_millisec",
                                            "to_lsp_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.PathProtection.Switchover, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.PathProtection.Switchover, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.date_of_error_detection.is_set or
                                self.date_of_error_detection_millisec.is_set or
                                self.from_lsp_id.is_set or
                                self.path_protection_switchover_event_index.is_set or
                                self.path_protection_switchover_reason.is_set or
                                self.path_protection_tunnel_id.is_set or
                                self.switchover_duration_millisec.is_set or
                                self.to_lsp_id.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.date_of_error_detection.yfilter != YFilter.not_set or
                                self.date_of_error_detection_millisec.yfilter != YFilter.not_set or
                                self.from_lsp_id.yfilter != YFilter.not_set or
                                self.path_protection_switchover_event_index.yfilter != YFilter.not_set or
                                self.path_protection_switchover_reason.yfilter != YFilter.not_set or
                                self.path_protection_tunnel_id.yfilter != YFilter.not_set or
                                self.switchover_duration_millisec.yfilter != YFilter.not_set or
                                self.to_lsp_id.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "switchover" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.date_of_error_detection.is_set or self.date_of_error_detection.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.date_of_error_detection.get_name_leafdata())
                            if (self.date_of_error_detection_millisec.is_set or self.date_of_error_detection_millisec.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.date_of_error_detection_millisec.get_name_leafdata())
                            if (self.from_lsp_id.is_set or self.from_lsp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.from_lsp_id.get_name_leafdata())
                            if (self.path_protection_switchover_event_index.is_set or self.path_protection_switchover_event_index.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_protection_switchover_event_index.get_name_leafdata())
                            if (self.path_protection_switchover_reason.is_set or self.path_protection_switchover_reason.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_protection_switchover_reason.get_name_leafdata())
                            if (self.path_protection_tunnel_id.is_set or self.path_protection_tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_protection_tunnel_id.get_name_leafdata())
                            if (self.switchover_duration_millisec.is_set or self.switchover_duration_millisec.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.switchover_duration_millisec.get_name_leafdata())
                            if (self.to_lsp_id.is_set or self.to_lsp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.to_lsp_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "date-of-error-detection" or name == "date-of-error-detection-millisec" or name == "from-lsp-id" or name == "path-protection-switchover-event-index" or name == "path-protection-switchover-reason" or name == "path-protection-tunnel-id" or name == "switchover-duration-millisec" or name == "to-lsp-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "date-of-error-detection"):
                                self.date_of_error_detection = value
                                self.date_of_error_detection.value_namespace = name_space
                                self.date_of_error_detection.value_namespace_prefix = name_space_prefix
                            if(value_path == "date-of-error-detection-millisec"):
                                self.date_of_error_detection_millisec = value
                                self.date_of_error_detection_millisec.value_namespace = name_space
                                self.date_of_error_detection_millisec.value_namespace_prefix = name_space_prefix
                            if(value_path == "from-lsp-id"):
                                self.from_lsp_id = value
                                self.from_lsp_id.value_namespace = name_space
                                self.from_lsp_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-protection-switchover-event-index"):
                                self.path_protection_switchover_event_index = value
                                self.path_protection_switchover_event_index.value_namespace = name_space
                                self.path_protection_switchover_event_index.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-protection-switchover-reason"):
                                self.path_protection_switchover_reason = value
                                self.path_protection_switchover_reason.value_namespace = name_space
                                self.path_protection_switchover_reason.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-protection-tunnel-id"):
                                self.path_protection_tunnel_id = value
                                self.path_protection_tunnel_id.value_namespace = name_space
                                self.path_protection_tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "switchover-duration-millisec"):
                                self.switchover_duration_millisec = value
                                self.switchover_duration_millisec.value_namespace = name_space
                                self.switchover_duration_millisec.value_namespace_prefix = name_space_prefix
                            if(value_path == "to-lsp-id"):
                                self.to_lsp_id = value
                                self.to_lsp_id.value_namespace = name_space
                                self.to_lsp_id.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.diversity_type.is_set or
                            self.is_path_protect_configured.is_set or
                            self.is_path_protect_switch_over_underway.is_set or
                            self.path_protection_protected_by_id.is_set or
                            self.reoptimization_time_remaining.is_set or
                            self.standby_reoptimized_number.is_set or
                            self.switchover_ready.is_set or
                            self.switchover_reason.is_set or
                            self.switchover_total.is_set or
                            self.time_of_switchover_sec.is_set or
                            self.valid_path_protection_path_option_exists.is_set or
                            (self.switchover is not None and self.switchover.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.diversity_type.yfilter != YFilter.not_set or
                            self.is_path_protect_configured.yfilter != YFilter.not_set or
                            self.is_path_protect_switch_over_underway.yfilter != YFilter.not_set or
                            self.path_protection_protected_by_id.yfilter != YFilter.not_set or
                            self.reoptimization_time_remaining.yfilter != YFilter.not_set or
                            self.standby_reoptimized_number.yfilter != YFilter.not_set or
                            self.switchover_ready.yfilter != YFilter.not_set or
                            self.switchover_reason.yfilter != YFilter.not_set or
                            self.switchover_total.yfilter != YFilter.not_set or
                            self.time_of_switchover_sec.yfilter != YFilter.not_set or
                            self.valid_path_protection_path_option_exists.yfilter != YFilter.not_set or
                            (self.switchover is not None and self.switchover.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "path-protection" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.diversity_type.is_set or self.diversity_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.diversity_type.get_name_leafdata())
                        if (self.is_path_protect_configured.is_set or self.is_path_protect_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_path_protect_configured.get_name_leafdata())
                        if (self.is_path_protect_switch_over_underway.is_set or self.is_path_protect_switch_over_underway.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_path_protect_switch_over_underway.get_name_leafdata())
                        if (self.path_protection_protected_by_id.is_set or self.path_protection_protected_by_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.path_protection_protected_by_id.get_name_leafdata())
                        if (self.reoptimization_time_remaining.is_set or self.reoptimization_time_remaining.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reoptimization_time_remaining.get_name_leafdata())
                        if (self.standby_reoptimized_number.is_set or self.standby_reoptimized_number.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.standby_reoptimized_number.get_name_leafdata())
                        if (self.switchover_ready.is_set or self.switchover_ready.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.switchover_ready.get_name_leafdata())
                        if (self.switchover_reason.is_set or self.switchover_reason.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.switchover_reason.get_name_leafdata())
                        if (self.switchover_total.is_set or self.switchover_total.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.switchover_total.get_name_leafdata())
                        if (self.time_of_switchover_sec.is_set or self.time_of_switchover_sec.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.time_of_switchover_sec.get_name_leafdata())
                        if (self.valid_path_protection_path_option_exists.is_set or self.valid_path_protection_path_option_exists.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.valid_path_protection_path_option_exists.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "switchover"):
                            if (self.switchover is None):
                                self.switchover = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.PathProtection.Switchover()
                                self.switchover.parent = self
                                self._children_name_map["switchover"] = "switchover"
                            return self.switchover

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "switchover" or name == "diversity-type" or name == "is-path-protect-configured" or name == "is-path-protect-switch-over-underway" or name == "path-protection-protected-by-id" or name == "reoptimization-time-remaining" or name == "standby-reoptimized-number" or name == "switchover-ready" or name == "switchover-reason" or name == "switchover-total" or name == "time-of-switchover-sec" or name == "valid-path-protection-path-option-exists"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "diversity-type"):
                            self.diversity_type = value
                            self.diversity_type.value_namespace = name_space
                            self.diversity_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-path-protect-configured"):
                            self.is_path_protect_configured = value
                            self.is_path_protect_configured.value_namespace = name_space
                            self.is_path_protect_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-path-protect-switch-over-underway"):
                            self.is_path_protect_switch_over_underway = value
                            self.is_path_protect_switch_over_underway.value_namespace = name_space
                            self.is_path_protect_switch_over_underway.value_namespace_prefix = name_space_prefix
                        if(value_path == "path-protection-protected-by-id"):
                            self.path_protection_protected_by_id = value
                            self.path_protection_protected_by_id.value_namespace = name_space
                            self.path_protection_protected_by_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "reoptimization-time-remaining"):
                            self.reoptimization_time_remaining = value
                            self.reoptimization_time_remaining.value_namespace = name_space
                            self.reoptimization_time_remaining.value_namespace_prefix = name_space_prefix
                        if(value_path == "standby-reoptimized-number"):
                            self.standby_reoptimized_number = value
                            self.standby_reoptimized_number.value_namespace = name_space
                            self.standby_reoptimized_number.value_namespace_prefix = name_space_prefix
                        if(value_path == "switchover-ready"):
                            self.switchover_ready = value
                            self.switchover_ready.value_namespace = name_space
                            self.switchover_ready.value_namespace_prefix = name_space_prefix
                        if(value_path == "switchover-reason"):
                            self.switchover_reason = value
                            self.switchover_reason.value_namespace = name_space
                            self.switchover_reason.value_namespace_prefix = name_space_prefix
                        if(value_path == "switchover-total"):
                            self.switchover_total = value
                            self.switchover_total.value_namespace = name_space
                            self.switchover_total.value_namespace_prefix = name_space_prefix
                        if(value_path == "time-of-switchover-sec"):
                            self.time_of_switchover_sec = value
                            self.time_of_switchover_sec.value_namespace = name_space
                            self.time_of_switchover_sec.value_namespace_prefix = name_space_prefix
                        if(value_path == "valid-path-protection-path-option-exists"):
                            self.valid_path_protection_path_option_exists = value
                            self.valid_path_protection_path_option_exists.value_namespace = name_space
                            self.valid_path_protection_path_option_exists.value_namespace_prefix = name_space_prefix


                class AutoBackup(Entity):
                    """
                    Autobackup Information
                    
                    .. attribute:: ab_protected_interface
                    
                    	Protected Interface
                    	**type**\:  str
                    
                    .. attribute:: ab_protection_type
                    
                    	Protection type
                    	**type**\:   :py:class:`AutoBackupProtection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.AutoBackupProtection>`
                    
                    .. attribute:: iep
                    
                    	List of IEPs for the path options on this tunnel
                    	**type**\: list of    :py:class:`Iep <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoBackup.Iep>`
                    
                    .. attribute:: is_unused_removal_timer_running
                    
                    	Indicates if the unused removal timer is running
                    	**type**\:  bool
                    
                    .. attribute:: is_using_srlg
                    
                    	Indicates whether SRLG Path Option is in use
                    	**type**\:  bool
                    
                    .. attribute:: protected_address
                    
                    	Protected Address
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: protected_ls_ps
                    
                    	Number Of Protected LSPs
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: protected_s2_ls
                    
                    	Number of Protected S2Ls
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: sharing_families
                    
                    	Number of S2L Sharing Families
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: srlg_prot_type
                    
                    	SRLG Protection Type
                    	**type**\:   :py:class:`AutoBackupSrlgMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.AutoBackupSrlgMode>`
                    
                    .. attribute:: tunnel_attribute_set_name
                    
                    	AttributeSet name
                    	**type**\:  str
                    
                    .. attribute:: unused_removal_remaining_time
                    
                    	Time Remaining in Unused Removal Time in seconds
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: weighted_srlg_info
                    
                    	Weighted SRLG info for the autobackup tunnel
                    	**type**\:   :py:class:`WeightedSrlgInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoBackup, self).__init__()

                        self.yang_name = "auto-backup"
                        self.yang_parent_name = "tunnel-head"

                        self.ab_protected_interface = YLeaf(YType.str, "ab-protected-interface")

                        self.ab_protection_type = YLeaf(YType.enumeration, "ab-protection-type")

                        self.is_unused_removal_timer_running = YLeaf(YType.boolean, "is-unused-removal-timer-running")

                        self.is_using_srlg = YLeaf(YType.boolean, "is-using-srlg")

                        self.protected_address = YLeaf(YType.str, "protected-address")

                        self.protected_ls_ps = YLeaf(YType.uint32, "protected-ls-ps")

                        self.protected_s2_ls = YLeaf(YType.uint32, "protected-s2-ls")

                        self.sharing_families = YLeaf(YType.uint32, "sharing-families")

                        self.srlg_prot_type = YLeaf(YType.enumeration, "srlg-prot-type")

                        self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                        self.unused_removal_remaining_time = YLeaf(YType.uint32, "unused-removal-remaining-time")

                        self.weighted_srlg_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo()
                        self.weighted_srlg_info.parent = self
                        self._children_name_map["weighted_srlg_info"] = "weighted-srlg-info"
                        self._children_yang_names.add("weighted-srlg-info")

                        self.iep = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("ab_protected_interface",
                                        "ab_protection_type",
                                        "is_unused_removal_timer_running",
                                        "is_using_srlg",
                                        "protected_address",
                                        "protected_ls_ps",
                                        "protected_s2_ls",
                                        "sharing_families",
                                        "srlg_prot_type",
                                        "tunnel_attribute_set_name",
                                        "unused_removal_remaining_time") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoBackup, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoBackup, self).__setattr__(name, value)


                    class WeightedSrlgInfo(Entity):
                        """
                        Weighted SRLG info for the autobackup tunnel
                        
                        .. attribute:: protected_interface_srlg
                        
                        	SRLG values and admin weight penalties of the protected interface
                        	**type**\: list of    :py:class:`ProtectedInterfaceSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo.ProtectedInterfaceSrlg>`
                        
                        .. attribute:: weighted_srlg_hop
                        
                        	Autobackup hops and the common SRLG with the protected interface
                        	**type**\: list of    :py:class:`WeightedSrlgHop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo, self).__init__()

                            self.yang_name = "weighted-srlg-info"
                            self.yang_parent_name = "auto-backup"

                            self.protected_interface_srlg = YList(self)
                            self.weighted_srlg_hop = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in () and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo, self).__setattr__(name, value)


                        class ProtectedInterfaceSrlg(Entity):
                            """
                            SRLG values and admin weight penalties of the
                            protected interface
                            
                            .. attribute:: admin_weight
                            
                            	Admin weight
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: srlg
                            
                            	SRLG number
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: srlg_name
                            
                            	SRLG name
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo.ProtectedInterfaceSrlg, self).__init__()

                                self.yang_name = "protected-interface-srlg"
                                self.yang_parent_name = "weighted-srlg-info"

                                self.admin_weight = YLeaf(YType.uint32, "admin-weight")

                                self.srlg = YLeaf(YType.uint32, "srlg")

                                self.srlg_name = YLeaf(YType.str, "srlg-name")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("admin_weight",
                                                "srlg",
                                                "srlg_name") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo.ProtectedInterfaceSrlg, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo.ProtectedInterfaceSrlg, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.admin_weight.is_set or
                                    self.srlg.is_set or
                                    self.srlg_name.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.admin_weight.yfilter != YFilter.not_set or
                                    self.srlg.yfilter != YFilter.not_set or
                                    self.srlg_name.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "protected-interface-srlg" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.admin_weight.is_set or self.admin_weight.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.admin_weight.get_name_leafdata())
                                if (self.srlg.is_set or self.srlg.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.srlg.get_name_leafdata())
                                if (self.srlg_name.is_set or self.srlg_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.srlg_name.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "admin-weight" or name == "srlg" or name == "srlg-name"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "admin-weight"):
                                    self.admin_weight = value
                                    self.admin_weight.value_namespace = name_space
                                    self.admin_weight.value_namespace_prefix = name_space_prefix
                                if(value_path == "srlg"):
                                    self.srlg = value
                                    self.srlg.value_namespace = name_space
                                    self.srlg.value_namespace_prefix = name_space_prefix
                                if(value_path == "srlg-name"):
                                    self.srlg_name = value
                                    self.srlg_name.value_namespace = name_space
                                    self.srlg_name.value_namespace_prefix = name_space_prefix


                        class WeightedSrlgHop(Entity):
                            """
                            Autobackup hops and the common SRLG with the
                            protected interface
                            
                            .. attribute:: aggregate_admin_weight
                            
                            	Sum of the admin weights for all the common SRLG values
                            	**type**\:  int
                            
                            	**range:** 0..18446744073709551615
                            
                            .. attribute:: common_srlg
                            
                            	Common SRLG between this hop and the protected  interface
                            	**type**\: list of    :py:class:`CommonSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop.CommonSrlg>`
                            
                            .. attribute:: from_address
                            
                            	Local IP address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: to_address
                            
                            	Remote IP address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop, self).__init__()

                                self.yang_name = "weighted-srlg-hop"
                                self.yang_parent_name = "weighted-srlg-info"

                                self.aggregate_admin_weight = YLeaf(YType.uint64, "aggregate-admin-weight")

                                self.from_address = YLeaf(YType.str, "from-address")

                                self.to_address = YLeaf(YType.str, "to-address")

                                self.common_srlg = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("aggregate_admin_weight",
                                                "from_address",
                                                "to_address") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop, self).__setattr__(name, value)


                            class CommonSrlg(Entity):
                                """
                                Common SRLG between this hop and the protected
                                
                                interface
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop.CommonSrlg, self).__init__()

                                    self.yang_name = "common-srlg"
                                    self.yang_parent_name = "weighted-srlg-hop"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop.CommonSrlg, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop.CommonSrlg, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "common-srlg" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.common_srlg:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.aggregate_admin_weight.is_set or
                                    self.from_address.is_set or
                                    self.to_address.is_set)

                            def has_operation(self):
                                for c in self.common_srlg:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.aggregate_admin_weight.yfilter != YFilter.not_set or
                                    self.from_address.yfilter != YFilter.not_set or
                                    self.to_address.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "weighted-srlg-hop" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.aggregate_admin_weight.is_set or self.aggregate_admin_weight.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.aggregate_admin_weight.get_name_leafdata())
                                if (self.from_address.is_set or self.from_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.from_address.get_name_leafdata())
                                if (self.to_address.is_set or self.to_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.to_address.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "common-srlg"):
                                    for c in self.common_srlg:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop.CommonSrlg()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.common_srlg.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "common-srlg" or name == "aggregate-admin-weight" or name == "from-address" or name == "to-address"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "aggregate-admin-weight"):
                                    self.aggregate_admin_weight = value
                                    self.aggregate_admin_weight.value_namespace = name_space
                                    self.aggregate_admin_weight.value_namespace_prefix = name_space_prefix
                                if(value_path == "from-address"):
                                    self.from_address = value
                                    self.from_address.value_namespace = name_space
                                    self.from_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "to-address"):
                                    self.to_address = value
                                    self.to_address.value_namespace = name_space
                                    self.to_address.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.protected_interface_srlg:
                                if (c.has_data()):
                                    return True
                            for c in self.weighted_srlg_hop:
                                if (c.has_data()):
                                    return True
                            return False

                        def has_operation(self):
                            for c in self.protected_interface_srlg:
                                if (c.has_operation()):
                                    return True
                            for c in self.weighted_srlg_hop:
                                if (c.has_operation()):
                                    return True
                            return self.yfilter != YFilter.not_set

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "weighted-srlg-info" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "protected-interface-srlg"):
                                for c in self.protected_interface_srlg:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo.ProtectedInterfaceSrlg()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.protected_interface_srlg.append(c)
                                return c

                            if (child_yang_name == "weighted-srlg-hop"):
                                for c in self.weighted_srlg_hop:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo.WeightedSrlgHop()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.weighted_srlg_hop.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "protected-interface-srlg" or name == "weighted-srlg-hop"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class Iep(Entity):
                        """
                        List of IEPs for the path options on this tunnel
                        
                        .. attribute:: iep_hop
                        
                        	IEP Hop List
                        	**type**\: list of    :py:class:`IepHop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoBackup.Iep.IepHop>`
                        
                        .. attribute:: path_option_id
                        
                        	Path option ID this IEP is associated with
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoBackup.Iep, self).__init__()

                            self.yang_name = "iep"
                            self.yang_parent_name = "auto-backup"

                            self.path_option_id = YLeaf(YType.uint32, "path-option-id")

                            self.iep_hop = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("path_option_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoBackup.Iep, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoBackup.Iep, self).__setattr__(name, value)


                        class IepHop(Entity):
                            """
                            IEP Hop List
                            
                            .. attribute:: hop_index
                            
                            	Hop Index
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: iep_hop_address
                            
                            	IEP Hop Address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: iep_hop_type
                            
                            	IEP type
                            	**type**\:   :py:class:`MplsTeIepHop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeIepHop>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoBackup.Iep.IepHop, self).__init__()

                                self.yang_name = "iep-hop"
                                self.yang_parent_name = "iep"

                                self.hop_index = YLeaf(YType.uint32, "hop-index")

                                self.iep_hop_address = YLeaf(YType.str, "iep-hop-address")

                                self.iep_hop_type = YLeaf(YType.enumeration, "iep-hop-type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("hop_index",
                                                "iep_hop_address",
                                                "iep_hop_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoBackup.Iep.IepHop, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoBackup.Iep.IepHop, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.hop_index.is_set or
                                    self.iep_hop_address.is_set or
                                    self.iep_hop_type.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.hop_index.yfilter != YFilter.not_set or
                                    self.iep_hop_address.yfilter != YFilter.not_set or
                                    self.iep_hop_type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "iep-hop" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.hop_index.is_set or self.hop_index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hop_index.get_name_leafdata())
                                if (self.iep_hop_address.is_set or self.iep_hop_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.iep_hop_address.get_name_leafdata())
                                if (self.iep_hop_type.is_set or self.iep_hop_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.iep_hop_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "hop-index" or name == "iep-hop-address" or name == "iep-hop-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "hop-index"):
                                    self.hop_index = value
                                    self.hop_index.value_namespace = name_space
                                    self.hop_index.value_namespace_prefix = name_space_prefix
                                if(value_path == "iep-hop-address"):
                                    self.iep_hop_address = value
                                    self.iep_hop_address.value_namespace = name_space
                                    self.iep_hop_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "iep-hop-type"):
                                    self.iep_hop_type = value
                                    self.iep_hop_type.value_namespace = name_space
                                    self.iep_hop_type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.iep_hop:
                                if (c.has_data()):
                                    return True
                            return self.path_option_id.is_set

                        def has_operation(self):
                            for c in self.iep_hop:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.path_option_id.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "iep" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.path_option_id.is_set or self.path_option_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_option_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "iep-hop"):
                                for c in self.iep_hop:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoBackup.Iep.IepHop()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.iep_hop.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "iep-hop" or name == "path-option-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "path-option-id"):
                                self.path_option_id = value
                                self.path_option_id.value_namespace = name_space
                                self.path_option_id.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.iep:
                            if (c.has_data()):
                                return True
                        return (
                            self.ab_protected_interface.is_set or
                            self.ab_protection_type.is_set or
                            self.is_unused_removal_timer_running.is_set or
                            self.is_using_srlg.is_set or
                            self.protected_address.is_set or
                            self.protected_ls_ps.is_set or
                            self.protected_s2_ls.is_set or
                            self.sharing_families.is_set or
                            self.srlg_prot_type.is_set or
                            self.tunnel_attribute_set_name.is_set or
                            self.unused_removal_remaining_time.is_set or
                            (self.weighted_srlg_info is not None and self.weighted_srlg_info.has_data()))

                    def has_operation(self):
                        for c in self.iep:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.ab_protected_interface.yfilter != YFilter.not_set or
                            self.ab_protection_type.yfilter != YFilter.not_set or
                            self.is_unused_removal_timer_running.yfilter != YFilter.not_set or
                            self.is_using_srlg.yfilter != YFilter.not_set or
                            self.protected_address.yfilter != YFilter.not_set or
                            self.protected_ls_ps.yfilter != YFilter.not_set or
                            self.protected_s2_ls.yfilter != YFilter.not_set or
                            self.sharing_families.yfilter != YFilter.not_set or
                            self.srlg_prot_type.yfilter != YFilter.not_set or
                            self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                            self.unused_removal_remaining_time.yfilter != YFilter.not_set or
                            (self.weighted_srlg_info is not None and self.weighted_srlg_info.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "auto-backup" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.ab_protected_interface.is_set or self.ab_protected_interface.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.ab_protected_interface.get_name_leafdata())
                        if (self.ab_protection_type.is_set or self.ab_protection_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.ab_protection_type.get_name_leafdata())
                        if (self.is_unused_removal_timer_running.is_set or self.is_unused_removal_timer_running.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_unused_removal_timer_running.get_name_leafdata())
                        if (self.is_using_srlg.is_set or self.is_using_srlg.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_using_srlg.get_name_leafdata())
                        if (self.protected_address.is_set or self.protected_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.protected_address.get_name_leafdata())
                        if (self.protected_ls_ps.is_set or self.protected_ls_ps.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.protected_ls_ps.get_name_leafdata())
                        if (self.protected_s2_ls.is_set or self.protected_s2_ls.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.protected_s2_ls.get_name_leafdata())
                        if (self.sharing_families.is_set or self.sharing_families.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.sharing_families.get_name_leafdata())
                        if (self.srlg_prot_type.is_set or self.srlg_prot_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.srlg_prot_type.get_name_leafdata())
                        if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                        if (self.unused_removal_remaining_time.is_set or self.unused_removal_remaining_time.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.unused_removal_remaining_time.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "iep"):
                            for c in self.iep:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoBackup.Iep()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.iep.append(c)
                            return c

                        if (child_yang_name == "weighted-srlg-info"):
                            if (self.weighted_srlg_info is None):
                                self.weighted_srlg_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoBackup.WeightedSrlgInfo()
                                self.weighted_srlg_info.parent = self
                                self._children_name_map["weighted_srlg_info"] = "weighted-srlg-info"
                            return self.weighted_srlg_info

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "iep" or name == "weighted-srlg-info" or name == "ab-protected-interface" or name == "ab-protection-type" or name == "is-unused-removal-timer-running" or name == "is-using-srlg" or name == "protected-address" or name == "protected-ls-ps" or name == "protected-s2-ls" or name == "sharing-families" or name == "srlg-prot-type" or name == "tunnel-attribute-set-name" or name == "unused-removal-remaining-time"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "ab-protected-interface"):
                            self.ab_protected_interface = value
                            self.ab_protected_interface.value_namespace = name_space
                            self.ab_protected_interface.value_namespace_prefix = name_space_prefix
                        if(value_path == "ab-protection-type"):
                            self.ab_protection_type = value
                            self.ab_protection_type.value_namespace = name_space
                            self.ab_protection_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-unused-removal-timer-running"):
                            self.is_unused_removal_timer_running = value
                            self.is_unused_removal_timer_running.value_namespace = name_space
                            self.is_unused_removal_timer_running.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-using-srlg"):
                            self.is_using_srlg = value
                            self.is_using_srlg.value_namespace = name_space
                            self.is_using_srlg.value_namespace_prefix = name_space_prefix
                        if(value_path == "protected-address"):
                            self.protected_address = value
                            self.protected_address.value_namespace = name_space
                            self.protected_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "protected-ls-ps"):
                            self.protected_ls_ps = value
                            self.protected_ls_ps.value_namespace = name_space
                            self.protected_ls_ps.value_namespace_prefix = name_space_prefix
                        if(value_path == "protected-s2-ls"):
                            self.protected_s2_ls = value
                            self.protected_s2_ls.value_namespace = name_space
                            self.protected_s2_ls.value_namespace_prefix = name_space_prefix
                        if(value_path == "sharing-families"):
                            self.sharing_families = value
                            self.sharing_families.value_namespace = name_space
                            self.sharing_families.value_namespace_prefix = name_space_prefix
                        if(value_path == "srlg-prot-type"):
                            self.srlg_prot_type = value
                            self.srlg_prot_type.value_namespace = name_space
                            self.srlg_prot_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "tunnel-attribute-set-name"):
                            self.tunnel_attribute_set_name = value
                            self.tunnel_attribute_set_name.value_namespace = name_space
                            self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "unused-removal-remaining-time"):
                            self.unused_removal_remaining_time = value
                            self.unused_removal_remaining_time.value_namespace = name_space
                            self.unused_removal_remaining_time.value_namespace_prefix = name_space_prefix


                class AutoMesh(Entity):
                    """
                    Automesh Information
                    
                    .. attribute:: is_tunnel_unused_timer_running
                    
                    	Flag to indicate whether unused timer running
                    	**type**\:  bool
                    
                    .. attribute:: mesh_group_id
                    
                    	Auto\-mesh tunnel Mesh Group ID
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: mesh_group_type
                    
                    	Auto\-tunnel mesh group type
                    	**type**\:   :py:class:`TeMeshgroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMeshgroup>`
                    
                    .. attribute:: remaining_unused_time
                    
                    	Remaining time for unused timer in seconds
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: tunnel_destination_list_name
                    
                    	Destination List name
                    	**type**\:  str
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoMesh, self).__init__()

                        self.yang_name = "auto-mesh"
                        self.yang_parent_name = "tunnel-head"

                        self.is_tunnel_unused_timer_running = YLeaf(YType.boolean, "is-tunnel-unused-timer-running")

                        self.mesh_group_id = YLeaf(YType.uint32, "mesh-group-id")

                        self.mesh_group_type = YLeaf(YType.enumeration, "mesh-group-type")

                        self.remaining_unused_time = YLeaf(YType.uint32, "remaining-unused-time")

                        self.tunnel_destination_list_name = YLeaf(YType.str, "tunnel-destination-list-name")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("is_tunnel_unused_timer_running",
                                        "mesh_group_id",
                                        "mesh_group_type",
                                        "remaining_unused_time",
                                        "tunnel_destination_list_name") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoMesh, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoMesh, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.is_tunnel_unused_timer_running.is_set or
                            self.mesh_group_id.is_set or
                            self.mesh_group_type.is_set or
                            self.remaining_unused_time.is_set or
                            self.tunnel_destination_list_name.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.is_tunnel_unused_timer_running.yfilter != YFilter.not_set or
                            self.mesh_group_id.yfilter != YFilter.not_set or
                            self.mesh_group_type.yfilter != YFilter.not_set or
                            self.remaining_unused_time.yfilter != YFilter.not_set or
                            self.tunnel_destination_list_name.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "auto-mesh" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.is_tunnel_unused_timer_running.is_set or self.is_tunnel_unused_timer_running.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_tunnel_unused_timer_running.get_name_leafdata())
                        if (self.mesh_group_id.is_set or self.mesh_group_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.mesh_group_id.get_name_leafdata())
                        if (self.mesh_group_type.is_set or self.mesh_group_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.mesh_group_type.get_name_leafdata())
                        if (self.remaining_unused_time.is_set or self.remaining_unused_time.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.remaining_unused_time.get_name_leafdata())
                        if (self.tunnel_destination_list_name.is_set or self.tunnel_destination_list_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tunnel_destination_list_name.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "is-tunnel-unused-timer-running" or name == "mesh-group-id" or name == "mesh-group-type" or name == "remaining-unused-time" or name == "tunnel-destination-list-name"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "is-tunnel-unused-timer-running"):
                            self.is_tunnel_unused_timer_running = value
                            self.is_tunnel_unused_timer_running.value_namespace = name_space
                            self.is_tunnel_unused_timer_running.value_namespace_prefix = name_space_prefix
                        if(value_path == "mesh-group-id"):
                            self.mesh_group_id = value
                            self.mesh_group_id.value_namespace = name_space
                            self.mesh_group_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "mesh-group-type"):
                            self.mesh_group_type = value
                            self.mesh_group_type.value_namespace = name_space
                            self.mesh_group_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "remaining-unused-time"):
                            self.remaining_unused_time = value
                            self.remaining_unused_time.value_namespace = name_space
                            self.remaining_unused_time.value_namespace_prefix = name_space_prefix
                        if(value_path == "tunnel-destination-list-name"):
                            self.tunnel_destination_list_name = value
                            self.tunnel_destination_list_name.value_namespace = name_space
                            self.tunnel_destination_list_name.value_namespace_prefix = name_space_prefix


                class AutoPcc(Entity):
                    """
                    Auto\-PCC Information
                    
                    .. attribute:: creator_address
                    
                    	Address of creating node
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: creator_id
                    
                    	ID of creating node
                    	**type**\:  str
                    
                    .. attribute:: has_creator_id
                    
                    	Indicates if the ID of the creating node is set
                    	**type**\:  bool
                    
                    .. attribute:: operationally_up
                    
                    	Operationally up
                    	**type**\:  bool
                    
                    .. attribute:: owner_address
                    
                    	Address of owner node
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: plspid
                    
                    	PLSP ID
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: symbolic_name
                    
                    	Symbolic name
                    	**type**\:  str
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoPcc, self).__init__()

                        self.yang_name = "auto-pcc"
                        self.yang_parent_name = "tunnel-head"

                        self.creator_address = YLeaf(YType.str, "creator-address")

                        self.creator_id = YLeaf(YType.str, "creator-id")

                        self.has_creator_id = YLeaf(YType.boolean, "has-creator-id")

                        self.operationally_up = YLeaf(YType.boolean, "operationally-up")

                        self.owner_address = YLeaf(YType.str, "owner-address")

                        self.plspid = YLeaf(YType.uint32, "plspid")

                        self.symbolic_name = YLeaf(YType.str, "symbolic-name")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("creator_address",
                                        "creator_id",
                                        "has_creator_id",
                                        "operationally_up",
                                        "owner_address",
                                        "plspid",
                                        "symbolic_name") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoPcc, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoPcc, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.creator_address.is_set or
                            self.creator_id.is_set or
                            self.has_creator_id.is_set or
                            self.operationally_up.is_set or
                            self.owner_address.is_set or
                            self.plspid.is_set or
                            self.symbolic_name.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.creator_address.yfilter != YFilter.not_set or
                            self.creator_id.yfilter != YFilter.not_set or
                            self.has_creator_id.yfilter != YFilter.not_set or
                            self.operationally_up.yfilter != YFilter.not_set or
                            self.owner_address.yfilter != YFilter.not_set or
                            self.plspid.yfilter != YFilter.not_set or
                            self.symbolic_name.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "auto-pcc" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.creator_address.is_set or self.creator_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.creator_address.get_name_leafdata())
                        if (self.creator_id.is_set or self.creator_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.creator_id.get_name_leafdata())
                        if (self.has_creator_id.is_set or self.has_creator_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.has_creator_id.get_name_leafdata())
                        if (self.operationally_up.is_set or self.operationally_up.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.operationally_up.get_name_leafdata())
                        if (self.owner_address.is_set or self.owner_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.owner_address.get_name_leafdata())
                        if (self.plspid.is_set or self.plspid.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.plspid.get_name_leafdata())
                        if (self.symbolic_name.is_set or self.symbolic_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.symbolic_name.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "creator-address" or name == "creator-id" or name == "has-creator-id" or name == "operationally-up" or name == "owner-address" or name == "plspid" or name == "symbolic-name"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "creator-address"):
                            self.creator_address = value
                            self.creator_address.value_namespace = name_space
                            self.creator_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "creator-id"):
                            self.creator_id = value
                            self.creator_id.value_namespace = name_space
                            self.creator_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "has-creator-id"):
                            self.has_creator_id = value
                            self.has_creator_id.value_namespace = name_space
                            self.has_creator_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "operationally-up"):
                            self.operationally_up = value
                            self.operationally_up.value_namespace = name_space
                            self.operationally_up.value_namespace_prefix = name_space_prefix
                        if(value_path == "owner-address"):
                            self.owner_address = value
                            self.owner_address.value_namespace = name_space
                            self.owner_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "plspid"):
                            self.plspid = value
                            self.plspid.value_namespace = name_space
                            self.plspid.value_namespace_prefix = name_space_prefix
                        if(value_path == "symbolic-name"):
                            self.symbolic_name = value
                            self.symbolic_name.value_namespace = name_space
                            self.symbolic_name.value_namespace_prefix = name_space_prefix


                class PceDelegation(Entity):
                    """
                    PCE Delegation information
                    
                    .. attribute:: operationally_up
                    
                    	Operationally up
                    	**type**\:  bool
                    
                    .. attribute:: owner_address
                    
                    	Address of owner node
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: plsp_id
                    
                    	PLSP ID
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: symbolic_name
                    
                    	Symbolic name
                    	**type**\:  str
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.PceDelegation, self).__init__()

                        self.yang_name = "pce-delegation"
                        self.yang_parent_name = "tunnel-head"

                        self.operationally_up = YLeaf(YType.boolean, "operationally-up")

                        self.owner_address = YLeaf(YType.str, "owner-address")

                        self.plsp_id = YLeaf(YType.uint32, "plsp-id")

                        self.symbolic_name = YLeaf(YType.str, "symbolic-name")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("operationally_up",
                                        "owner_address",
                                        "plsp_id",
                                        "symbolic_name") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.PceDelegation, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.PceDelegation, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.operationally_up.is_set or
                            self.owner_address.is_set or
                            self.plsp_id.is_set or
                            self.symbolic_name.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.operationally_up.yfilter != YFilter.not_set or
                            self.owner_address.yfilter != YFilter.not_set or
                            self.plsp_id.yfilter != YFilter.not_set or
                            self.symbolic_name.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "pce-delegation" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.operationally_up.is_set or self.operationally_up.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.operationally_up.get_name_leafdata())
                        if (self.owner_address.is_set or self.owner_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.owner_address.get_name_leafdata())
                        if (self.plsp_id.is_set or self.plsp_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.plsp_id.get_name_leafdata())
                        if (self.symbolic_name.is_set or self.symbolic_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.symbolic_name.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "operationally-up" or name == "owner-address" or name == "plsp-id" or name == "symbolic-name"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "operationally-up"):
                            self.operationally_up = value
                            self.operationally_up.value_namespace = name_space
                            self.operationally_up.value_namespace_prefix = name_space_prefix
                        if(value_path == "owner-address"):
                            self.owner_address = value
                            self.owner_address.value_namespace = name_space
                            self.owner_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "plsp-id"):
                            self.plsp_id = value
                            self.plsp_id.value_namespace = name_space
                            self.plsp_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "symbolic-name"):
                            self.symbolic_name = value
                            self.symbolic_name.value_namespace = name_space
                            self.symbolic_name.value_namespace_prefix = name_space_prefix


                class SoftPreemption(Entity):
                    """
                    Tunnel head soft preemption info. This is NULL
                    if soft preemption is not configured
                    
                    .. attribute:: preemption_pending_resolution
                    
                    	Indicates how the soft preemption operation ended
                    	**type**\:   :py:class:`MplsTeSoftPreemptionResolution <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeSoftPreemptionResolution>`
                    
                    .. attribute:: soft_preemption_counters
                    
                    	The soft preemption counters for this tunnel head
                    	**type**\:   :py:class:`SoftPreemptionCounters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.SoftPreemption.SoftPreemptionCounters>`
                    
                    .. attribute:: soft_preemption_path_error
                    
                    	The array of soft preemption path errors info received for the LSP that is being soft preempted
                    	**type**\: list of    :py:class:`SoftPreemptionPathError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.SoftPreemption.SoftPreemptionPathError>`
                    
                    .. attribute:: status
                    
                    	The preemption state
                    	**type**\:   :py:class:`MplsTeSoftPreemptionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeSoftPreemptionState>`
                    
                    .. attribute:: time_in_preemption_pending
                    
                    	The number of seconds that were spent in the preemption\-pending state
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    	**units**\: second
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.SoftPreemption, self).__init__()

                        self.yang_name = "soft-preemption"
                        self.yang_parent_name = "tunnel-head"

                        self.preemption_pending_resolution = YLeaf(YType.enumeration, "preemption-pending-resolution")

                        self.status = YLeaf(YType.enumeration, "status")

                        self.time_in_preemption_pending = YLeaf(YType.uint16, "time-in-preemption-pending")

                        self.soft_preemption_counters = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.SoftPreemption.SoftPreemptionCounters()
                        self.soft_preemption_counters.parent = self
                        self._children_name_map["soft_preemption_counters"] = "soft-preemption-counters"
                        self._children_yang_names.add("soft-preemption-counters")

                        self.soft_preemption_path_error = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("preemption_pending_resolution",
                                        "status",
                                        "time_in_preemption_pending") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.SoftPreemption, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.SoftPreemption, self).__setattr__(name, value)


                    class SoftPreemptionCounters(Entity):
                        """
                        The soft preemption counters for this tunnel
                        head
                        
                        .. attribute:: frr_triggered_ls_ps
                        
                        	The number of soft preempted LSPs that were fast rerouted at the             headend or any remote node before the reoptimization is done
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: path_protection_switchover_ls_ps
                        
                        	The number of soft preempted LSPs that were switched over to a             standby LSP
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: reopt_completed_ls_ps
                        
                        	The number of soft preempted LSPs that were torn down by the ingress router after the reopt LSP was successfully setup
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: soft_preemption_events
                        
                        	The number of soft preemption events
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: time_in_preemption_pending_avg
                        
                        	The average time in seconds that an LSP was in preemption pending state
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        	**units**\: second
                        
                        .. attribute:: time_in_preemption_pending_max
                        
                        	The maximum time in seconds that an LSP was in preemption pending state
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        	**units**\: second
                        
                        .. attribute:: time_in_preemption_pending_min
                        
                        	The minimum time in seconds that an LSP was in preemption pending state
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        	**units**\: second
                        
                        .. attribute:: torn_down_ls_ps
                        
                        	The number of soft preempted LSPs that were torn down by the              headend or any remote node before the reoptimization is done
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.SoftPreemption.SoftPreemptionCounters, self).__init__()

                            self.yang_name = "soft-preemption-counters"
                            self.yang_parent_name = "soft-preemption"

                            self.frr_triggered_ls_ps = YLeaf(YType.uint32, "frr-triggered-ls-ps")

                            self.path_protection_switchover_ls_ps = YLeaf(YType.uint32, "path-protection-switchover-ls-ps")

                            self.reopt_completed_ls_ps = YLeaf(YType.uint32, "reopt-completed-ls-ps")

                            self.soft_preemption_events = YLeaf(YType.uint32, "soft-preemption-events")

                            self.time_in_preemption_pending_avg = YLeaf(YType.uint16, "time-in-preemption-pending-avg")

                            self.time_in_preemption_pending_max = YLeaf(YType.uint16, "time-in-preemption-pending-max")

                            self.time_in_preemption_pending_min = YLeaf(YType.uint16, "time-in-preemption-pending-min")

                            self.torn_down_ls_ps = YLeaf(YType.uint32, "torn-down-ls-ps")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("frr_triggered_ls_ps",
                                            "path_protection_switchover_ls_ps",
                                            "reopt_completed_ls_ps",
                                            "soft_preemption_events",
                                            "time_in_preemption_pending_avg",
                                            "time_in_preemption_pending_max",
                                            "time_in_preemption_pending_min",
                                            "torn_down_ls_ps") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.SoftPreemption.SoftPreemptionCounters, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.SoftPreemption.SoftPreemptionCounters, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.frr_triggered_ls_ps.is_set or
                                self.path_protection_switchover_ls_ps.is_set or
                                self.reopt_completed_ls_ps.is_set or
                                self.soft_preemption_events.is_set or
                                self.time_in_preemption_pending_avg.is_set or
                                self.time_in_preemption_pending_max.is_set or
                                self.time_in_preemption_pending_min.is_set or
                                self.torn_down_ls_ps.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.frr_triggered_ls_ps.yfilter != YFilter.not_set or
                                self.path_protection_switchover_ls_ps.yfilter != YFilter.not_set or
                                self.reopt_completed_ls_ps.yfilter != YFilter.not_set or
                                self.soft_preemption_events.yfilter != YFilter.not_set or
                                self.time_in_preemption_pending_avg.yfilter != YFilter.not_set or
                                self.time_in_preemption_pending_max.yfilter != YFilter.not_set or
                                self.time_in_preemption_pending_min.yfilter != YFilter.not_set or
                                self.torn_down_ls_ps.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "soft-preemption-counters" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.frr_triggered_ls_ps.is_set or self.frr_triggered_ls_ps.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.frr_triggered_ls_ps.get_name_leafdata())
                            if (self.path_protection_switchover_ls_ps.is_set or self.path_protection_switchover_ls_ps.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_protection_switchover_ls_ps.get_name_leafdata())
                            if (self.reopt_completed_ls_ps.is_set or self.reopt_completed_ls_ps.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reopt_completed_ls_ps.get_name_leafdata())
                            if (self.soft_preemption_events.is_set or self.soft_preemption_events.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.soft_preemption_events.get_name_leafdata())
                            if (self.time_in_preemption_pending_avg.is_set or self.time_in_preemption_pending_avg.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_in_preemption_pending_avg.get_name_leafdata())
                            if (self.time_in_preemption_pending_max.is_set or self.time_in_preemption_pending_max.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_in_preemption_pending_max.get_name_leafdata())
                            if (self.time_in_preemption_pending_min.is_set or self.time_in_preemption_pending_min.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_in_preemption_pending_min.get_name_leafdata())
                            if (self.torn_down_ls_ps.is_set or self.torn_down_ls_ps.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.torn_down_ls_ps.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "frr-triggered-ls-ps" or name == "path-protection-switchover-ls-ps" or name == "reopt-completed-ls-ps" or name == "soft-preemption-events" or name == "time-in-preemption-pending-avg" or name == "time-in-preemption-pending-max" or name == "time-in-preemption-pending-min" or name == "torn-down-ls-ps"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "frr-triggered-ls-ps"):
                                self.frr_triggered_ls_ps = value
                                self.frr_triggered_ls_ps.value_namespace = name_space
                                self.frr_triggered_ls_ps.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-protection-switchover-ls-ps"):
                                self.path_protection_switchover_ls_ps = value
                                self.path_protection_switchover_ls_ps.value_namespace = name_space
                                self.path_protection_switchover_ls_ps.value_namespace_prefix = name_space_prefix
                            if(value_path == "reopt-completed-ls-ps"):
                                self.reopt_completed_ls_ps = value
                                self.reopt_completed_ls_ps.value_namespace = name_space
                                self.reopt_completed_ls_ps.value_namespace_prefix = name_space_prefix
                            if(value_path == "soft-preemption-events"):
                                self.soft_preemption_events = value
                                self.soft_preemption_events.value_namespace = name_space
                                self.soft_preemption_events.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-in-preemption-pending-avg"):
                                self.time_in_preemption_pending_avg = value
                                self.time_in_preemption_pending_avg.value_namespace = name_space
                                self.time_in_preemption_pending_avg.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-in-preemption-pending-max"):
                                self.time_in_preemption_pending_max = value
                                self.time_in_preemption_pending_max.value_namespace = name_space
                                self.time_in_preemption_pending_max.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-in-preemption-pending-min"):
                                self.time_in_preemption_pending_min = value
                                self.time_in_preemption_pending_min.value_namespace = name_space
                                self.time_in_preemption_pending_min.value_namespace_prefix = name_space_prefix
                            if(value_path == "torn-down-ls-ps"):
                                self.torn_down_ls_ps = value
                                self.torn_down_ls_ps.value_namespace = name_space
                                self.torn_down_ls_ps.value_namespace_prefix = name_space_prefix


                    class SoftPreemptionPathError(Entity):
                        """
                        The array of soft preemption path errors info
                        received for the LSP that is being soft
                        preempted
                        
                        .. attribute:: preempting_link_address
                        
                        	The address of the link where the preemption happened
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: timestamp
                        
                        	The POSIX timestamp when the soft preemption error is received
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.SoftPreemption.SoftPreemptionPathError, self).__init__()

                            self.yang_name = "soft-preemption-path-error"
                            self.yang_parent_name = "soft-preemption"

                            self.preempting_link_address = YLeaf(YType.str, "preempting-link-address")

                            self.timestamp = YLeaf(YType.uint32, "timestamp")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("preempting_link_address",
                                            "timestamp") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.SoftPreemption.SoftPreemptionPathError, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.SoftPreemption.SoftPreemptionPathError, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.preempting_link_address.is_set or
                                self.timestamp.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.preempting_link_address.yfilter != YFilter.not_set or
                                self.timestamp.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "soft-preemption-path-error" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.preempting_link_address.is_set or self.preempting_link_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.preempting_link_address.get_name_leafdata())
                            if (self.timestamp.is_set or self.timestamp.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.timestamp.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "preempting-link-address" or name == "timestamp"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "preempting-link-address"):
                                self.preempting_link_address = value
                                self.preempting_link_address.value_namespace = name_space
                                self.preempting_link_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "timestamp"):
                                self.timestamp = value
                                self.timestamp.value_namespace = name_space
                                self.timestamp.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.soft_preemption_path_error:
                            if (c.has_data()):
                                return True
                        return (
                            self.preemption_pending_resolution.is_set or
                            self.status.is_set or
                            self.time_in_preemption_pending.is_set or
                            (self.soft_preemption_counters is not None and self.soft_preemption_counters.has_data()))

                    def has_operation(self):
                        for c in self.soft_preemption_path_error:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.preemption_pending_resolution.yfilter != YFilter.not_set or
                            self.status.yfilter != YFilter.not_set or
                            self.time_in_preemption_pending.yfilter != YFilter.not_set or
                            (self.soft_preemption_counters is not None and self.soft_preemption_counters.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "soft-preemption" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.preemption_pending_resolution.is_set or self.preemption_pending_resolution.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.preemption_pending_resolution.get_name_leafdata())
                        if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.status.get_name_leafdata())
                        if (self.time_in_preemption_pending.is_set or self.time_in_preemption_pending.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.time_in_preemption_pending.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "soft-preemption-counters"):
                            if (self.soft_preemption_counters is None):
                                self.soft_preemption_counters = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.SoftPreemption.SoftPreemptionCounters()
                                self.soft_preemption_counters.parent = self
                                self._children_name_map["soft_preemption_counters"] = "soft-preemption-counters"
                            return self.soft_preemption_counters

                        if (child_yang_name == "soft-preemption-path-error"):
                            for c in self.soft_preemption_path_error:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.SoftPreemption.SoftPreemptionPathError()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.soft_preemption_path_error.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "soft-preemption-counters" or name == "soft-preemption-path-error" or name == "preemption-pending-resolution" or name == "status" or name == "time-in-preemption-pending"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "preemption-pending-resolution"):
                            self.preemption_pending_resolution = value
                            self.preemption_pending_resolution.value_namespace = name_space
                            self.preemption_pending_resolution.value_namespace_prefix = name_space_prefix
                        if(value_path == "status"):
                            self.status = value
                            self.status.value_namespace = name_space
                            self.status.value_namespace_prefix = name_space_prefix
                        if(value_path == "time-in-preemption-pending"):
                            self.time_in_preemption_pending = value
                            self.time_in_preemption_pending.value_namespace = name_space
                            self.time_in_preemption_pending.value_namespace_prefix = name_space_prefix


                class WdmUnitunnel(Entity):
                    """
                    WDM\-UNI tunnel data. Only exists for WDM\-UNI
                    tunnels
                    
                    .. attribute:: controlled_interface
                    
                    	Interface being controlled
                    	**type**\:  str
                    
                    .. attribute:: destination_address
                    
                    	Destination address
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: extended_tunnel_id
                    
                    	Extended tunnel\-id
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: label_origin
                    
                    	Label origin
                    	**type**\:   :py:class:`MplsTeMgmtGmplsLabelOrigin <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMgmtGmplsLabelOrigin>`
                    
                    .. attribute:: local_optical_router_id
                    
                    	Local optical router id
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: lsp_id
                    
                    	LSP ID
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: remote_optical_router_id
                    
                    	Remote optical router id
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: source_address
                    
                    	Source address
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: srlg_discovery
                    
                    	SRLG\-discovery enabled
                    	**type**\:  bool
                    
                    .. attribute:: tunnel_id
                    
                    	Tunnel ID
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: tunnel_role
                    
                    	Tunnel Role
                    	**type**\:   :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                    
                    .. attribute:: tunnel_state
                    
                    	Tunnel state
                    	**type**\:   :py:class:`MplsTeTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelState>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.WdmUnitunnel, self).__init__()

                        self.yang_name = "wdm-unitunnel"
                        self.yang_parent_name = "tunnel-head"

                        self.controlled_interface = YLeaf(YType.str, "controlled-interface")

                        self.destination_address = YLeaf(YType.str, "destination-address")

                        self.extended_tunnel_id = YLeaf(YType.str, "extended-tunnel-id")

                        self.label_origin = YLeaf(YType.enumeration, "label-origin")

                        self.local_optical_router_id = YLeaf(YType.str, "local-optical-router-id")

                        self.lsp_id = YLeaf(YType.uint16, "lsp-id")

                        self.remote_optical_router_id = YLeaf(YType.str, "remote-optical-router-id")

                        self.source_address = YLeaf(YType.str, "source-address")

                        self.srlg_discovery = YLeaf(YType.boolean, "srlg-discovery")

                        self.tunnel_id = YLeaf(YType.uint16, "tunnel-id")

                        self.tunnel_role = YLeaf(YType.enumeration, "tunnel-role")

                        self.tunnel_state = YLeaf(YType.enumeration, "tunnel-state")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("controlled_interface",
                                        "destination_address",
                                        "extended_tunnel_id",
                                        "label_origin",
                                        "local_optical_router_id",
                                        "lsp_id",
                                        "remote_optical_router_id",
                                        "source_address",
                                        "srlg_discovery",
                                        "tunnel_id",
                                        "tunnel_role",
                                        "tunnel_state") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.WdmUnitunnel, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.WdmUnitunnel, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.controlled_interface.is_set or
                            self.destination_address.is_set or
                            self.extended_tunnel_id.is_set or
                            self.label_origin.is_set or
                            self.local_optical_router_id.is_set or
                            self.lsp_id.is_set or
                            self.remote_optical_router_id.is_set or
                            self.source_address.is_set or
                            self.srlg_discovery.is_set or
                            self.tunnel_id.is_set or
                            self.tunnel_role.is_set or
                            self.tunnel_state.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.controlled_interface.yfilter != YFilter.not_set or
                            self.destination_address.yfilter != YFilter.not_set or
                            self.extended_tunnel_id.yfilter != YFilter.not_set or
                            self.label_origin.yfilter != YFilter.not_set or
                            self.local_optical_router_id.yfilter != YFilter.not_set or
                            self.lsp_id.yfilter != YFilter.not_set or
                            self.remote_optical_router_id.yfilter != YFilter.not_set or
                            self.source_address.yfilter != YFilter.not_set or
                            self.srlg_discovery.yfilter != YFilter.not_set or
                            self.tunnel_id.yfilter != YFilter.not_set or
                            self.tunnel_role.yfilter != YFilter.not_set or
                            self.tunnel_state.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "wdm-unitunnel" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.controlled_interface.is_set or self.controlled_interface.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.controlled_interface.get_name_leafdata())
                        if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.destination_address.get_name_leafdata())
                        if (self.extended_tunnel_id.is_set or self.extended_tunnel_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.extended_tunnel_id.get_name_leafdata())
                        if (self.label_origin.is_set or self.label_origin.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.label_origin.get_name_leafdata())
                        if (self.local_optical_router_id.is_set or self.local_optical_router_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.local_optical_router_id.get_name_leafdata())
                        if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_id.get_name_leafdata())
                        if (self.remote_optical_router_id.is_set or self.remote_optical_router_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.remote_optical_router_id.get_name_leafdata())
                        if (self.source_address.is_set or self.source_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.source_address.get_name_leafdata())
                        if (self.srlg_discovery.is_set or self.srlg_discovery.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.srlg_discovery.get_name_leafdata())
                        if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tunnel_id.get_name_leafdata())
                        if (self.tunnel_role.is_set or self.tunnel_role.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tunnel_role.get_name_leafdata())
                        if (self.tunnel_state.is_set or self.tunnel_state.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tunnel_state.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "controlled-interface" or name == "destination-address" or name == "extended-tunnel-id" or name == "label-origin" or name == "local-optical-router-id" or name == "lsp-id" or name == "remote-optical-router-id" or name == "source-address" or name == "srlg-discovery" or name == "tunnel-id" or name == "tunnel-role" or name == "tunnel-state"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "controlled-interface"):
                            self.controlled_interface = value
                            self.controlled_interface.value_namespace = name_space
                            self.controlled_interface.value_namespace_prefix = name_space_prefix
                        if(value_path == "destination-address"):
                            self.destination_address = value
                            self.destination_address.value_namespace = name_space
                            self.destination_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "extended-tunnel-id"):
                            self.extended_tunnel_id = value
                            self.extended_tunnel_id.value_namespace = name_space
                            self.extended_tunnel_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "label-origin"):
                            self.label_origin = value
                            self.label_origin.value_namespace = name_space
                            self.label_origin.value_namespace_prefix = name_space_prefix
                        if(value_path == "local-optical-router-id"):
                            self.local_optical_router_id = value
                            self.local_optical_router_id.value_namespace = name_space
                            self.local_optical_router_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-id"):
                            self.lsp_id = value
                            self.lsp_id.value_namespace = name_space
                            self.lsp_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "remote-optical-router-id"):
                            self.remote_optical_router_id = value
                            self.remote_optical_router_id.value_namespace = name_space
                            self.remote_optical_router_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "source-address"):
                            self.source_address = value
                            self.source_address.value_namespace = name_space
                            self.source_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "srlg-discovery"):
                            self.srlg_discovery = value
                            self.srlg_discovery.value_namespace = name_space
                            self.srlg_discovery.value_namespace_prefix = name_space_prefix
                        if(value_path == "tunnel-id"):
                            self.tunnel_id = value
                            self.tunnel_id.value_namespace = name_space
                            self.tunnel_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "tunnel-role"):
                            self.tunnel_role = value
                            self.tunnel_role.value_namespace = name_space
                            self.tunnel_role.value_namespace_prefix = name_space_prefix
                        if(value_path == "tunnel-state"):
                            self.tunnel_state = value
                            self.tunnel_state.value_namespace = name_space
                            self.tunnel_state.value_namespace_prefix = name_space_prefix


                class TransportTunnelInfo(Entity):
                    """
                    Transport tunnel data. Only exists for Transport
                    tunnels
                    
                    .. attribute:: diversity_info
                    
                    	Diversity Info
                    	**type**\: list of    :py:class:`DiversityInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.DiversityInfo>`
                    
                    .. attribute:: egress_static_uni
                    
                    	Tunnel EgressStatic UNI Info
                    	**type**\:   :py:class:`EgressStaticUni <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni>`
                    
                    .. attribute:: homepath_ero
                    
                    	Homepath ero for working lsp
                    	**type**\: list of    :py:class:`HomepathEro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.HomepathEro>`
                    
                    .. attribute:: otn
                    
                    	Info Related to OTN technology in S2L
                    	**type**\:   :py:class:`Otn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn>`
                    
                    .. attribute:: static_uni
                    
                    	Tunnel Static UNI Info
                    	**type**\:   :py:class:`StaticUni <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.StaticUni>`
                    
                    .. attribute:: status_homepath_working
                    
                    	Status of working homepath
                    	**type**\:  bool
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo, self).__init__()

                        self.yang_name = "transport-tunnel-info"
                        self.yang_parent_name = "tunnel-head"

                        self.status_homepath_working = YLeaf(YType.boolean, "status-homepath-working")

                        self.egress_static_uni = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni()
                        self.egress_static_uni.parent = self
                        self._children_name_map["egress_static_uni"] = "egress-static-uni"
                        self._children_yang_names.add("egress-static-uni")

                        self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn()
                        self.otn.parent = self
                        self._children_name_map["otn"] = "otn"
                        self._children_yang_names.add("otn")

                        self.static_uni = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.StaticUni()
                        self.static_uni.parent = self
                        self._children_name_map["static_uni"] = "static-uni"
                        self._children_yang_names.add("static-uni")

                        self.diversity_info = YList(self)
                        self.homepath_ero = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("status_homepath_working") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo, self).__setattr__(name, value)


                    class Otn(Entity):
                        """
                        Info Related to OTN technology in S2L
                        
                        .. attribute:: bandwidth_cfg
                        
                        	Configured OTN Bandwidth for tunnel
                        	**type**\:   :py:class:`BandwidthCfg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn, self).__init__()

                            self.yang_name = "otn"
                            self.yang_parent_name = "transport-tunnel-info"

                            self.bandwidth_cfg = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg()
                            self.bandwidth_cfg.parent = self
                            self._children_name_map["bandwidth_cfg"] = "bandwidth-cfg"
                            self._children_yang_names.add("bandwidth-cfg")


                        class BandwidthCfg(Entity):
                            """
                            Configured OTN Bandwidth for tunnel
                            
                            .. attribute:: odu_flex_cbr
                            
                            	Odu flex CBR info
                            	**type**\:   :py:class:`OduFlexCbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexCbr>`
                            
                            .. attribute:: odu_flex_gfp_f_non_res
                            
                            	Odu flex GFP\-F non\-resizable info
                            	**type**\:   :py:class:`OduFlexGfpFNonRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFNonRes>`
                            
                            .. attribute:: odu_flex_gfp_f_res
                            
                            	Odu flex GFP\-F resizable info
                            	**type**\:   :py:class:`OduFlexGfpFRes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFRes>`
                            
                            .. attribute:: odu_level
                            
                            	ODULevel
                            	**type**\:   :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg, self).__init__()

                                self.yang_name = "bandwidth-cfg"
                                self.yang_parent_name = "otn"

                                self.odu_level = YLeaf(YType.enumeration, "odu-level")

                                self.odu_flex_cbr = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexCbr()
                                self.odu_flex_cbr.parent = self
                                self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"
                                self._children_yang_names.add("odu-flex-cbr")

                                self.odu_flex_gfp_f_non_res = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFNonRes()
                                self.odu_flex_gfp_f_non_res.parent = self
                                self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                self._children_yang_names.add("odu-flex-gfp-f-non-res")

                                self.odu_flex_gfp_f_res = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFRes()
                                self.odu_flex_gfp_f_res.parent = self
                                self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"
                                self._children_yang_names.add("odu-flex-gfp-f-res")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("odu_level") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg, self).__setattr__(name, value)


                            class OduFlexCbr(Entity):
                                """
                                Odu flex CBR info
                                
                                .. attribute:: bit_rate
                                
                                	Bit rate in kbit/s
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tolerance
                                
                                	Tolerance
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexCbr, self).__init__()

                                    self.yang_name = "odu-flex-cbr"
                                    self.yang_parent_name = "bandwidth-cfg"

                                    self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                    self.tolerance = YLeaf(YType.uint16, "tolerance")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bit_rate",
                                                    "tolerance") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexCbr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexCbr, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.bit_rate.is_set or
                                        self.tolerance.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bit_rate.yfilter != YFilter.not_set or
                                        self.tolerance.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "odu-flex-cbr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bit_rate.get_name_leafdata())
                                    if (self.tolerance.is_set or self.tolerance.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tolerance.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bit-rate" or name == "tolerance"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bit-rate"):
                                        self.bit_rate = value
                                        self.bit_rate.value_namespace = name_space
                                        self.bit_rate.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tolerance"):
                                        self.tolerance = value
                                        self.tolerance.value_namespace = name_space
                                        self.tolerance.value_namespace_prefix = name_space_prefix


                            class OduFlexGfpFRes(Entity):
                                """
                                Odu flex GFP\-F resizable info
                                
                                .. attribute:: bit_rate
                                
                                	Bit rate in kbit/s
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFRes, self).__init__()

                                    self.yang_name = "odu-flex-gfp-f-res"
                                    self.yang_parent_name = "bandwidth-cfg"

                                    self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bit_rate") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFRes, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFRes, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.bit_rate.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bit_rate.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "odu-flex-gfp-f-res" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bit_rate.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bit-rate"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bit-rate"):
                                        self.bit_rate = value
                                        self.bit_rate.value_namespace = name_space
                                        self.bit_rate.value_namespace_prefix = name_space_prefix


                            class OduFlexGfpFNonRes(Entity):
                                """
                                Odu flex GFP\-F non\-resizable info
                                
                                .. attribute:: bit_rate
                                
                                	Bit rate in kbit/s
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFNonRes, self).__init__()

                                    self.yang_name = "odu-flex-gfp-f-non-res"
                                    self.yang_parent_name = "bandwidth-cfg"

                                    self.bit_rate = YLeaf(YType.uint32, "bit-rate")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("bit_rate") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFNonRes, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFNonRes, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.bit_rate.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.bit_rate.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "odu-flex-gfp-f-non-res" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.bit_rate.is_set or self.bit_rate.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.bit_rate.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "bit-rate"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "bit-rate"):
                                        self.bit_rate = value
                                        self.bit_rate.value_namespace = name_space
                                        self.bit_rate.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.odu_level.is_set or
                                    (self.odu_flex_cbr is not None and self.odu_flex_cbr.has_data()) or
                                    (self.odu_flex_gfp_f_non_res is not None and self.odu_flex_gfp_f_non_res.has_data()) or
                                    (self.odu_flex_gfp_f_res is not None and self.odu_flex_gfp_f_res.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.odu_level.yfilter != YFilter.not_set or
                                    (self.odu_flex_cbr is not None and self.odu_flex_cbr.has_operation()) or
                                    (self.odu_flex_gfp_f_non_res is not None and self.odu_flex_gfp_f_non_res.has_operation()) or
                                    (self.odu_flex_gfp_f_res is not None and self.odu_flex_gfp_f_res.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "bandwidth-cfg" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.odu_level.is_set or self.odu_level.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.odu_level.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "odu-flex-cbr"):
                                    if (self.odu_flex_cbr is None):
                                        self.odu_flex_cbr = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexCbr()
                                        self.odu_flex_cbr.parent = self
                                        self._children_name_map["odu_flex_cbr"] = "odu-flex-cbr"
                                    return self.odu_flex_cbr

                                if (child_yang_name == "odu-flex-gfp-f-non-res"):
                                    if (self.odu_flex_gfp_f_non_res is None):
                                        self.odu_flex_gfp_f_non_res = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFNonRes()
                                        self.odu_flex_gfp_f_non_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_non_res"] = "odu-flex-gfp-f-non-res"
                                    return self.odu_flex_gfp_f_non_res

                                if (child_yang_name == "odu-flex-gfp-f-res"):
                                    if (self.odu_flex_gfp_f_res is None):
                                        self.odu_flex_gfp_f_res = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg.OduFlexGfpFRes()
                                        self.odu_flex_gfp_f_res.parent = self
                                        self._children_name_map["odu_flex_gfp_f_res"] = "odu-flex-gfp-f-res"
                                    return self.odu_flex_gfp_f_res

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "odu-flex-cbr" or name == "odu-flex-gfp-f-non-res" or name == "odu-flex-gfp-f-res" or name == "odu-level"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "odu-level"):
                                    self.odu_level = value
                                    self.odu_level.value_namespace = name_space
                                    self.odu_level.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (self.bandwidth_cfg is not None and self.bandwidth_cfg.has_data())

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.bandwidth_cfg is not None and self.bandwidth_cfg.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "otn" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "bandwidth-cfg"):
                                if (self.bandwidth_cfg is None):
                                    self.bandwidth_cfg = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn.BandwidthCfg()
                                    self.bandwidth_cfg.parent = self
                                    self._children_name_map["bandwidth_cfg"] = "bandwidth-cfg"
                                return self.bandwidth_cfg

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "bandwidth-cfg"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class StaticUni(Entity):
                        """
                        Tunnel Static UNI Info
                        
                        .. attribute:: client_if_handle
                        
                        	Ingress Client Port Ifhandle
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        .. attribute:: client_odu_if_handle
                        
                        	Client Odu Interface
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        .. attribute:: client_odu_name
                        
                        	Client Odu Name
                        	**type**\:  str
                        
                        .. attribute:: client_port
                        
                        	Ingress Client Port
                        	**type**\:  str
                        
                        .. attribute:: cross_connect_id
                        
                        	Cross connect id
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: is_connected
                        
                        	True if client port is connected
                        	**type**\:  bool
                        
                        .. attribute:: local_termination
                        
                        	Local Termination Type
                        	**type**\:   :py:class:`MplsTeTermination <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTermination>`
                        
                        .. attribute:: static_uni_type
                        
                        	Static uni type
                        	**type**\:   :py:class:`MplsTeUni <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeUni>`
                        
                        .. attribute:: term_client_if_handle
                        
                        	Termination Ingress Client Port Ifhandle
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        .. attribute:: term_client_port
                        
                        	Termination Ingress Client Port
                        	**type**\:  str
                        
                        .. attribute:: uptime
                        
                        	Client Port Uptime
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.StaticUni, self).__init__()

                            self.yang_name = "static-uni"
                            self.yang_parent_name = "transport-tunnel-info"

                            self.client_if_handle = YLeaf(YType.str, "client-if-handle")

                            self.client_odu_if_handle = YLeaf(YType.str, "client-odu-if-handle")

                            self.client_odu_name = YLeaf(YType.str, "client-odu-name")

                            self.client_port = YLeaf(YType.str, "client-port")

                            self.cross_connect_id = YLeaf(YType.uint32, "cross-connect-id")

                            self.is_connected = YLeaf(YType.boolean, "is-connected")

                            self.local_termination = YLeaf(YType.enumeration, "local-termination")

                            self.static_uni_type = YLeaf(YType.enumeration, "static-uni-type")

                            self.term_client_if_handle = YLeaf(YType.str, "term-client-if-handle")

                            self.term_client_port = YLeaf(YType.str, "term-client-port")

                            self.uptime = YLeaf(YType.uint32, "uptime")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("client_if_handle",
                                            "client_odu_if_handle",
                                            "client_odu_name",
                                            "client_port",
                                            "cross_connect_id",
                                            "is_connected",
                                            "local_termination",
                                            "static_uni_type",
                                            "term_client_if_handle",
                                            "term_client_port",
                                            "uptime") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.StaticUni, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.StaticUni, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.client_if_handle.is_set or
                                self.client_odu_if_handle.is_set or
                                self.client_odu_name.is_set or
                                self.client_port.is_set or
                                self.cross_connect_id.is_set or
                                self.is_connected.is_set or
                                self.local_termination.is_set or
                                self.static_uni_type.is_set or
                                self.term_client_if_handle.is_set or
                                self.term_client_port.is_set or
                                self.uptime.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.client_if_handle.yfilter != YFilter.not_set or
                                self.client_odu_if_handle.yfilter != YFilter.not_set or
                                self.client_odu_name.yfilter != YFilter.not_set or
                                self.client_port.yfilter != YFilter.not_set or
                                self.cross_connect_id.yfilter != YFilter.not_set or
                                self.is_connected.yfilter != YFilter.not_set or
                                self.local_termination.yfilter != YFilter.not_set or
                                self.static_uni_type.yfilter != YFilter.not_set or
                                self.term_client_if_handle.yfilter != YFilter.not_set or
                                self.term_client_port.yfilter != YFilter.not_set or
                                self.uptime.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "static-uni" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.client_if_handle.is_set or self.client_if_handle.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.client_if_handle.get_name_leafdata())
                            if (self.client_odu_if_handle.is_set or self.client_odu_if_handle.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.client_odu_if_handle.get_name_leafdata())
                            if (self.client_odu_name.is_set or self.client_odu_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.client_odu_name.get_name_leafdata())
                            if (self.client_port.is_set or self.client_port.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.client_port.get_name_leafdata())
                            if (self.cross_connect_id.is_set or self.cross_connect_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.cross_connect_id.get_name_leafdata())
                            if (self.is_connected.is_set or self.is_connected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_connected.get_name_leafdata())
                            if (self.local_termination.is_set or self.local_termination.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.local_termination.get_name_leafdata())
                            if (self.static_uni_type.is_set or self.static_uni_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.static_uni_type.get_name_leafdata())
                            if (self.term_client_if_handle.is_set or self.term_client_if_handle.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.term_client_if_handle.get_name_leafdata())
                            if (self.term_client_port.is_set or self.term_client_port.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.term_client_port.get_name_leafdata())
                            if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.uptime.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "client-if-handle" or name == "client-odu-if-handle" or name == "client-odu-name" or name == "client-port" or name == "cross-connect-id" or name == "is-connected" or name == "local-termination" or name == "static-uni-type" or name == "term-client-if-handle" or name == "term-client-port" or name == "uptime"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "client-if-handle"):
                                self.client_if_handle = value
                                self.client_if_handle.value_namespace = name_space
                                self.client_if_handle.value_namespace_prefix = name_space_prefix
                            if(value_path == "client-odu-if-handle"):
                                self.client_odu_if_handle = value
                                self.client_odu_if_handle.value_namespace = name_space
                                self.client_odu_if_handle.value_namespace_prefix = name_space_prefix
                            if(value_path == "client-odu-name"):
                                self.client_odu_name = value
                                self.client_odu_name.value_namespace = name_space
                                self.client_odu_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "client-port"):
                                self.client_port = value
                                self.client_port.value_namespace = name_space
                                self.client_port.value_namespace_prefix = name_space_prefix
                            if(value_path == "cross-connect-id"):
                                self.cross_connect_id = value
                                self.cross_connect_id.value_namespace = name_space
                                self.cross_connect_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-connected"):
                                self.is_connected = value
                                self.is_connected.value_namespace = name_space
                                self.is_connected.value_namespace_prefix = name_space_prefix
                            if(value_path == "local-termination"):
                                self.local_termination = value
                                self.local_termination.value_namespace = name_space
                                self.local_termination.value_namespace_prefix = name_space_prefix
                            if(value_path == "static-uni-type"):
                                self.static_uni_type = value
                                self.static_uni_type.value_namespace = name_space
                                self.static_uni_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "term-client-if-handle"):
                                self.term_client_if_handle = value
                                self.term_client_if_handle.value_namespace = name_space
                                self.term_client_if_handle.value_namespace_prefix = name_space_prefix
                            if(value_path == "term-client-port"):
                                self.term_client_port = value
                                self.term_client_port.value_namespace = name_space
                                self.term_client_port.value_namespace_prefix = name_space_prefix
                            if(value_path == "uptime"):
                                self.uptime = value
                                self.uptime.value_namespace = name_space
                                self.uptime.value_namespace_prefix = name_space_prefix


                    class EgressStaticUni(Entity):
                        """
                        Tunnel EgressStatic UNI Info
                        
                        .. attribute:: egress_port
                        
                        	Egress Client Port of Tunnel
                        	**type**\:   :py:class:`EgressPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.EgressPort>`
                        
                        .. attribute:: local_termination
                        
                        	Local Termination Type
                        	**type**\:   :py:class:`MplsTeTermination <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTermination>`
                        
                        .. attribute:: remote_uni_type
                        
                        	Remote uni type
                        	**type**\:   :py:class:`MplsTeUni <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeUni>`
                        
                        .. attribute:: term_egress_port
                        
                        	Termination Egress Client Port of Tunnel
                        	**type**\:   :py:class:`TermEgressPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.TermEgressPort>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni, self).__init__()

                            self.yang_name = "egress-static-uni"
                            self.yang_parent_name = "transport-tunnel-info"

                            self.local_termination = YLeaf(YType.enumeration, "local-termination")

                            self.remote_uni_type = YLeaf(YType.enumeration, "remote-uni-type")

                            self.egress_port = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.EgressPort()
                            self.egress_port.parent = self
                            self._children_name_map["egress_port"] = "egress-port"
                            self._children_yang_names.add("egress-port")

                            self.term_egress_port = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.TermEgressPort()
                            self.term_egress_port.parent = self
                            self._children_name_map["term_egress_port"] = "term-egress-port"
                            self._children_yang_names.add("term-egress-port")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("local_termination",
                                            "remote_uni_type") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni, self).__setattr__(name, value)


                        class EgressPort(Entity):
                            """
                            Egress Client Port of Tunnel
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.EgressPort, self).__init__()

                                self.yang_name = "egress-port"
                                self.yang_parent_name = "egress-static-uni"

                                self.te_addr = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "egress-port"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "egress-port" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.EgressPort.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class TermEgressPort(Entity):
                            """
                            Termination Egress Client Port of Tunnel
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.TermEgressPort, self).__init__()

                                self.yang_name = "term-egress-port"
                                self.yang_parent_name = "egress-static-uni"

                                self.te_addr = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "term-egress-port"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "term-egress-port" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.TermEgressPort.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass

                        def has_data(self):
                            return (
                                self.local_termination.is_set or
                                self.remote_uni_type.is_set or
                                (self.egress_port is not None and self.egress_port.has_data()) or
                                (self.term_egress_port is not None and self.term_egress_port.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.local_termination.yfilter != YFilter.not_set or
                                self.remote_uni_type.yfilter != YFilter.not_set or
                                (self.egress_port is not None and self.egress_port.has_operation()) or
                                (self.term_egress_port is not None and self.term_egress_port.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "egress-static-uni" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.local_termination.is_set or self.local_termination.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.local_termination.get_name_leafdata())
                            if (self.remote_uni_type.is_set or self.remote_uni_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.remote_uni_type.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "egress-port"):
                                if (self.egress_port is None):
                                    self.egress_port = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.EgressPort()
                                    self.egress_port.parent = self
                                    self._children_name_map["egress_port"] = "egress-port"
                                return self.egress_port

                            if (child_yang_name == "term-egress-port"):
                                if (self.term_egress_port is None):
                                    self.term_egress_port = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni.TermEgressPort()
                                    self.term_egress_port.parent = self
                                    self._children_name_map["term_egress_port"] = "term-egress-port"
                                return self.term_egress_port

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "egress-port" or name == "term-egress-port" or name == "local-termination" or name == "remote-uni-type"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "local-termination"):
                                self.local_termination = value
                                self.local_termination.value_namespace = name_space
                                self.local_termination.value_namespace_prefix = name_space_prefix
                            if(value_path == "remote-uni-type"):
                                self.remote_uni_type = value
                                self.remote_uni_type.value_namespace = name_space
                                self.remote_uni_type.value_namespace_prefix = name_space_prefix


                    class HomepathEro(Entity):
                        """
                        Homepath ero for working lsp
                        
                        .. attribute:: ero_type
                        
                        	EROType
                        	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                        
                        .. attribute:: ipv4ero_sub_object
                        
                        	IPV4 ERO Sub Object
                        	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.HomepathEro.Ipv4EroSubObject>`
                        
                        .. attribute:: unnumbered_ero_sub_object
                        
                        	Unnumbered ERO Sub Object
                        	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.HomepathEro.UnnumberedEroSubObject>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.HomepathEro, self).__init__()

                            self.yang_name = "homepath-ero"
                            self.yang_parent_name = "transport-tunnel-info"

                            self.ero_type = YLeaf(YType.enumeration, "ero-type")

                            self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.HomepathEro.Ipv4EroSubObject()
                            self.ipv4ero_sub_object.parent = self
                            self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                            self._children_yang_names.add("ipv4ero-sub-object")

                            self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.HomepathEro.UnnumberedEroSubObject()
                            self.unnumbered_ero_sub_object.parent = self
                            self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                            self._children_yang_names.add("unnumbered-ero-sub-object")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("ero_type") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.HomepathEro, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.HomepathEro, self).__setattr__(name, value)


                        class Ipv4EroSubObject(Entity):
                            """
                            IPV4 ERO Sub Object
                            
                            .. attribute:: ero_address
                            
                            	The ERO IPV4 Address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: is_strict_route
                            
                            	ERO Entry Is Strict
                            	**type**\:  bool
                            
                            .. attribute:: prefix_length
                            
                            	ERO Prefix Length
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.HomepathEro.Ipv4EroSubObject, self).__init__()

                                self.yang_name = "ipv4ero-sub-object"
                                self.yang_parent_name = "homepath-ero"

                                self.ero_address = YLeaf(YType.str, "ero-address")

                                self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_address",
                                                "is_strict_route",
                                                "prefix_length") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.HomepathEro.Ipv4EroSubObject, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.HomepathEro.Ipv4EroSubObject, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.ero_address.is_set or
                                    self.is_strict_route.is_set or
                                    self.prefix_length.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_address.yfilter != YFilter.not_set or
                                    self.is_strict_route.yfilter != YFilter.not_set or
                                    self.prefix_length.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ipv4ero-sub-object" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_address.get_name_leafdata())
                                if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-address"):
                                    self.ero_address = value
                                    self.ero_address.value_namespace = name_space
                                    self.ero_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-strict-route"):
                                    self.is_strict_route = value
                                    self.is_strict_route.value_namespace = name_space
                                    self.is_strict_route.value_namespace_prefix = name_space_prefix
                                if(value_path == "prefix-length"):
                                    self.prefix_length = value
                                    self.prefix_length.value_namespace = name_space
                                    self.prefix_length.value_namespace_prefix = name_space_prefix


                        class UnnumberedEroSubObject(Entity):
                            """
                            Unnumbered ERO Sub Object
                            
                            .. attribute:: ero_interface_id
                            
                            	The Interface ID in ERO
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: ero_router_id
                            
                            	The Router ID in ERO
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: is_strict_route
                            
                            	ERO Entry Is Strict
                            	**type**\:  bool
                            
                            .. attribute:: status
                            
                            	Status of ERO
                            	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.HomepathEro.UnnumberedEroSubObject, self).__init__()

                                self.yang_name = "unnumbered-ero-sub-object"
                                self.yang_parent_name = "homepath-ero"

                                self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                self.status = YLeaf(YType.enumeration, "status")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_interface_id",
                                                "ero_router_id",
                                                "is_strict_route",
                                                "status") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.HomepathEro.UnnumberedEroSubObject, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.HomepathEro.UnnumberedEroSubObject, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.ero_interface_id.is_set or
                                    self.ero_router_id.is_set or
                                    self.is_strict_route.is_set or
                                    self.status.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_interface_id.yfilter != YFilter.not_set or
                                    self.ero_router_id.yfilter != YFilter.not_set or
                                    self.is_strict_route.yfilter != YFilter.not_set or
                                    self.status.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.status.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-interface-id"):
                                    self.ero_interface_id = value
                                    self.ero_interface_id.value_namespace = name_space
                                    self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "ero-router-id"):
                                    self.ero_router_id = value
                                    self.ero_router_id.value_namespace = name_space
                                    self.ero_router_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-strict-route"):
                                    self.is_strict_route = value
                                    self.is_strict_route.value_namespace = name_space
                                    self.is_strict_route.value_namespace_prefix = name_space_prefix
                                if(value_path == "status"):
                                    self.status = value
                                    self.status.value_namespace = name_space
                                    self.status.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.ero_type.is_set or
                                (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.ero_type.yfilter != YFilter.not_set or
                                (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "homepath-ero" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ero_type.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "ipv4ero-sub-object"):
                                if (self.ipv4ero_sub_object is None):
                                    self.ipv4ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.HomepathEro.Ipv4EroSubObject()
                                    self.ipv4ero_sub_object.parent = self
                                    self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                return self.ipv4ero_sub_object

                            if (child_yang_name == "unnumbered-ero-sub-object"):
                                if (self.unnumbered_ero_sub_object is None):
                                    self.unnumbered_ero_sub_object = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.HomepathEro.UnnumberedEroSubObject()
                                    self.unnumbered_ero_sub_object.parent = self
                                    self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                return self.unnumbered_ero_sub_object

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "ero-type"):
                                self.ero_type = value
                                self.ero_type.value_namespace = name_space
                                self.ero_type.value_namespace_prefix = name_space_prefix


                    class DiversityInfo(Entity):
                        """
                        Diversity Info
                        
                        .. attribute:: tunnel_id
                        
                        	Dependent Tunnel ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.DiversityInfo, self).__init__()

                            self.yang_name = "diversity-info"
                            self.yang_parent_name = "transport-tunnel-info"

                            self.tunnel_id = YLeaf(YType.uint16, "tunnel-id")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("tunnel_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.DiversityInfo, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.DiversityInfo, self).__setattr__(name, value)

                        def has_data(self):
                            return self.tunnel_id.is_set

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.tunnel_id.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "diversity-info" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tunnel_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "tunnel-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "tunnel-id"):
                                self.tunnel_id = value
                                self.tunnel_id.value_namespace = name_space
                                self.tunnel_id.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.diversity_info:
                            if (c.has_data()):
                                return True
                        for c in self.homepath_ero:
                            if (c.has_data()):
                                return True
                        return (
                            self.status_homepath_working.is_set or
                            (self.egress_static_uni is not None and self.egress_static_uni.has_data()) or
                            (self.otn is not None and self.otn.has_data()) or
                            (self.static_uni is not None and self.static_uni.has_data()))

                    def has_operation(self):
                        for c in self.diversity_info:
                            if (c.has_operation()):
                                return True
                        for c in self.homepath_ero:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.status_homepath_working.yfilter != YFilter.not_set or
                            (self.egress_static_uni is not None and self.egress_static_uni.has_operation()) or
                            (self.otn is not None and self.otn.has_operation()) or
                            (self.static_uni is not None and self.static_uni.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "transport-tunnel-info" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.status_homepath_working.is_set or self.status_homepath_working.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.status_homepath_working.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "diversity-info"):
                            for c in self.diversity_info:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.DiversityInfo()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.diversity_info.append(c)
                            return c

                        if (child_yang_name == "egress-static-uni"):
                            if (self.egress_static_uni is None):
                                self.egress_static_uni = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.EgressStaticUni()
                                self.egress_static_uni.parent = self
                                self._children_name_map["egress_static_uni"] = "egress-static-uni"
                            return self.egress_static_uni

                        if (child_yang_name == "homepath-ero"):
                            for c in self.homepath_ero:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.HomepathEro()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.homepath_ero.append(c)
                            return c

                        if (child_yang_name == "otn"):
                            if (self.otn is None):
                                self.otn = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.Otn()
                                self.otn.parent = self
                                self._children_name_map["otn"] = "otn"
                            return self.otn

                        if (child_yang_name == "static-uni"):
                            if (self.static_uni is None):
                                self.static_uni = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo.StaticUni()
                                self.static_uni.parent = self
                                self._children_name_map["static_uni"] = "static-uni"
                            return self.static_uni

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "diversity-info" or name == "egress-static-uni" or name == "homepath-ero" or name == "otn" or name == "static-uni" or name == "status-homepath-working"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "status-homepath-working"):
                            self.status_homepath_working = value
                            self.status_homepath_working.value_namespace = name_space
                            self.status_homepath_working.value_namespace_prefix = name_space_prefix


                class BfdInfo(Entity):
                    """
                    BFD session info. This is NULL if BFD is not
                    configured
                    
                    .. attribute:: bfd_session_up
                    
                    	Tunnel BFD session state up or down
                    	**type**\:  bool
                    
                    .. attribute:: dampening_info
                    
                    	Path option dampening info
                    	**type**\: list of    :py:class:`DampeningInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.BfdInfo.DampeningInfo>`
                    
                    .. attribute:: event_counters
                    
                    	Per tunnel BFD session event counters
                    	**type**\:   :py:class:`EventCounters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.BfdInfo.EventCounters>`
                    
                    .. attribute:: failure_diagnostic_code
                    
                    	BFD session failure diagnostic code
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: failure_reason
                    
                    	BFD session failure reason
                    	**type**\:  str
                    
                    .. attribute:: maximum_session_up_interval
                    
                    	Maximum time in mini second for session to come up
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: minimum_session_up_interval
                    
                    	Minimum time in mini second for session to come up
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: session_up_time
                    
                    	Time in seconds since the last session state up
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.BfdInfo, self).__init__()

                        self.yang_name = "bfd-info"
                        self.yang_parent_name = "tunnel-head"

                        self.bfd_session_up = YLeaf(YType.boolean, "bfd-session-up")

                        self.failure_diagnostic_code = YLeaf(YType.uint32, "failure-diagnostic-code")

                        self.failure_reason = YLeaf(YType.str, "failure-reason")

                        self.maximum_session_up_interval = YLeaf(YType.uint32, "maximum-session-up-interval")

                        self.minimum_session_up_interval = YLeaf(YType.uint32, "minimum-session-up-interval")

                        self.session_up_time = YLeaf(YType.uint32, "session-up-time")

                        self.event_counters = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.BfdInfo.EventCounters()
                        self.event_counters.parent = self
                        self._children_name_map["event_counters"] = "event-counters"
                        self._children_yang_names.add("event-counters")

                        self.dampening_info = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("bfd_session_up",
                                        "failure_diagnostic_code",
                                        "failure_reason",
                                        "maximum_session_up_interval",
                                        "minimum_session_up_interval",
                                        "session_up_time") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.BfdInfo, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.BfdInfo, self).__setattr__(name, value)


                    class EventCounters(Entity):
                        """
                        Per tunnel BFD session event counters
                        
                        .. attribute:: session_admin_down_events
                        
                        	The number of BFDOverLSP session admin down events
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: session_create_events
                        
                        	The number of BFDOverLSP session create events
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: session_create_timeout_events
                        
                        	The number of BFDOverLSP session create timeout events
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: session_creation_failed_events
                        
                        	The number of BFDOverLSP session creation failed events
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: session_down_events
                        
                        	The number of BFDOverLSP session down events
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: session_gracefully_delete_events
                        
                        	The number of BFDOverLSP session gracefully delete events
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: session_non_gracefully_delete_events
                        
                        	The number of BFDOverLSP session non gracefully delete events
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: session_replay_events
                        
                        	The number of BFDOverLSP session replay events
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: session_up_events
                        
                        	The number of BFDOverLSP session up events
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.BfdInfo.EventCounters, self).__init__()

                            self.yang_name = "event-counters"
                            self.yang_parent_name = "bfd-info"

                            self.session_admin_down_events = YLeaf(YType.uint32, "session-admin-down-events")

                            self.session_create_events = YLeaf(YType.uint32, "session-create-events")

                            self.session_create_timeout_events = YLeaf(YType.uint32, "session-create-timeout-events")

                            self.session_creation_failed_events = YLeaf(YType.uint32, "session-creation-failed-events")

                            self.session_down_events = YLeaf(YType.uint32, "session-down-events")

                            self.session_gracefully_delete_events = YLeaf(YType.uint32, "session-gracefully-delete-events")

                            self.session_non_gracefully_delete_events = YLeaf(YType.uint32, "session-non-gracefully-delete-events")

                            self.session_replay_events = YLeaf(YType.uint32, "session-replay-events")

                            self.session_up_events = YLeaf(YType.uint32, "session-up-events")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("session_admin_down_events",
                                            "session_create_events",
                                            "session_create_timeout_events",
                                            "session_creation_failed_events",
                                            "session_down_events",
                                            "session_gracefully_delete_events",
                                            "session_non_gracefully_delete_events",
                                            "session_replay_events",
                                            "session_up_events") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.BfdInfo.EventCounters, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.BfdInfo.EventCounters, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.session_admin_down_events.is_set or
                                self.session_create_events.is_set or
                                self.session_create_timeout_events.is_set or
                                self.session_creation_failed_events.is_set or
                                self.session_down_events.is_set or
                                self.session_gracefully_delete_events.is_set or
                                self.session_non_gracefully_delete_events.is_set or
                                self.session_replay_events.is_set or
                                self.session_up_events.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.session_admin_down_events.yfilter != YFilter.not_set or
                                self.session_create_events.yfilter != YFilter.not_set or
                                self.session_create_timeout_events.yfilter != YFilter.not_set or
                                self.session_creation_failed_events.yfilter != YFilter.not_set or
                                self.session_down_events.yfilter != YFilter.not_set or
                                self.session_gracefully_delete_events.yfilter != YFilter.not_set or
                                self.session_non_gracefully_delete_events.yfilter != YFilter.not_set or
                                self.session_replay_events.yfilter != YFilter.not_set or
                                self.session_up_events.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "event-counters" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.session_admin_down_events.is_set or self.session_admin_down_events.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.session_admin_down_events.get_name_leafdata())
                            if (self.session_create_events.is_set or self.session_create_events.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.session_create_events.get_name_leafdata())
                            if (self.session_create_timeout_events.is_set or self.session_create_timeout_events.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.session_create_timeout_events.get_name_leafdata())
                            if (self.session_creation_failed_events.is_set or self.session_creation_failed_events.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.session_creation_failed_events.get_name_leafdata())
                            if (self.session_down_events.is_set or self.session_down_events.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.session_down_events.get_name_leafdata())
                            if (self.session_gracefully_delete_events.is_set or self.session_gracefully_delete_events.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.session_gracefully_delete_events.get_name_leafdata())
                            if (self.session_non_gracefully_delete_events.is_set or self.session_non_gracefully_delete_events.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.session_non_gracefully_delete_events.get_name_leafdata())
                            if (self.session_replay_events.is_set or self.session_replay_events.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.session_replay_events.get_name_leafdata())
                            if (self.session_up_events.is_set or self.session_up_events.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.session_up_events.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "session-admin-down-events" or name == "session-create-events" or name == "session-create-timeout-events" or name == "session-creation-failed-events" or name == "session-down-events" or name == "session-gracefully-delete-events" or name == "session-non-gracefully-delete-events" or name == "session-replay-events" or name == "session-up-events"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "session-admin-down-events"):
                                self.session_admin_down_events = value
                                self.session_admin_down_events.value_namespace = name_space
                                self.session_admin_down_events.value_namespace_prefix = name_space_prefix
                            if(value_path == "session-create-events"):
                                self.session_create_events = value
                                self.session_create_events.value_namespace = name_space
                                self.session_create_events.value_namespace_prefix = name_space_prefix
                            if(value_path == "session-create-timeout-events"):
                                self.session_create_timeout_events = value
                                self.session_create_timeout_events.value_namespace = name_space
                                self.session_create_timeout_events.value_namespace_prefix = name_space_prefix
                            if(value_path == "session-creation-failed-events"):
                                self.session_creation_failed_events = value
                                self.session_creation_failed_events.value_namespace = name_space
                                self.session_creation_failed_events.value_namespace_prefix = name_space_prefix
                            if(value_path == "session-down-events"):
                                self.session_down_events = value
                                self.session_down_events.value_namespace = name_space
                                self.session_down_events.value_namespace_prefix = name_space_prefix
                            if(value_path == "session-gracefully-delete-events"):
                                self.session_gracefully_delete_events = value
                                self.session_gracefully_delete_events.value_namespace = name_space
                                self.session_gracefully_delete_events.value_namespace_prefix = name_space_prefix
                            if(value_path == "session-non-gracefully-delete-events"):
                                self.session_non_gracefully_delete_events = value
                                self.session_non_gracefully_delete_events.value_namespace = name_space
                                self.session_non_gracefully_delete_events.value_namespace_prefix = name_space_prefix
                            if(value_path == "session-replay-events"):
                                self.session_replay_events = value
                                self.session_replay_events.value_namespace = name_space
                                self.session_replay_events.value_namespace_prefix = name_space_prefix
                            if(value_path == "session-up-events"):
                                self.session_up_events = value
                                self.session_up_events.value_namespace = name_space
                                self.session_up_events.value_namespace_prefix = name_space_prefix


                    class DampeningInfo(Entity):
                        """
                        Path option dampening info
                        
                        .. attribute:: backoff_count
                        
                        	Backoff count
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: hold_down_time
                        
                        	Hold down time in second
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: option_index
                        
                        	Path option index
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: remained_time
                        
                        	Remained time to resignal in second
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.BfdInfo.DampeningInfo, self).__init__()

                            self.yang_name = "dampening-info"
                            self.yang_parent_name = "bfd-info"

                            self.backoff_count = YLeaf(YType.uint32, "backoff-count")

                            self.hold_down_time = YLeaf(YType.uint32, "hold-down-time")

                            self.option_index = YLeaf(YType.uint32, "option-index")

                            self.remained_time = YLeaf(YType.uint32, "remained-time")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("backoff_count",
                                            "hold_down_time",
                                            "option_index",
                                            "remained_time") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.BfdInfo.DampeningInfo, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.BfdInfo.DampeningInfo, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.backoff_count.is_set or
                                self.hold_down_time.is_set or
                                self.option_index.is_set or
                                self.remained_time.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.backoff_count.yfilter != YFilter.not_set or
                                self.hold_down_time.yfilter != YFilter.not_set or
                                self.option_index.yfilter != YFilter.not_set or
                                self.remained_time.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "dampening-info" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.backoff_count.is_set or self.backoff_count.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.backoff_count.get_name_leafdata())
                            if (self.hold_down_time.is_set or self.hold_down_time.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.hold_down_time.get_name_leafdata())
                            if (self.option_index.is_set or self.option_index.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.option_index.get_name_leafdata())
                            if (self.remained_time.is_set or self.remained_time.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.remained_time.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "backoff-count" or name == "hold-down-time" or name == "option-index" or name == "remained-time"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "backoff-count"):
                                self.backoff_count = value
                                self.backoff_count.value_namespace = name_space
                                self.backoff_count.value_namespace_prefix = name_space_prefix
                            if(value_path == "hold-down-time"):
                                self.hold_down_time = value
                                self.hold_down_time.value_namespace = name_space
                                self.hold_down_time.value_namespace_prefix = name_space_prefix
                            if(value_path == "option-index"):
                                self.option_index = value
                                self.option_index.value_namespace = name_space
                                self.option_index.value_namespace_prefix = name_space_prefix
                            if(value_path == "remained-time"):
                                self.remained_time = value
                                self.remained_time.value_namespace = name_space
                                self.remained_time.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.dampening_info:
                            if (c.has_data()):
                                return True
                        return (
                            self.bfd_session_up.is_set or
                            self.failure_diagnostic_code.is_set or
                            self.failure_reason.is_set or
                            self.maximum_session_up_interval.is_set or
                            self.minimum_session_up_interval.is_set or
                            self.session_up_time.is_set or
                            (self.event_counters is not None and self.event_counters.has_data()))

                    def has_operation(self):
                        for c in self.dampening_info:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.bfd_session_up.yfilter != YFilter.not_set or
                            self.failure_diagnostic_code.yfilter != YFilter.not_set or
                            self.failure_reason.yfilter != YFilter.not_set or
                            self.maximum_session_up_interval.yfilter != YFilter.not_set or
                            self.minimum_session_up_interval.yfilter != YFilter.not_set or
                            self.session_up_time.yfilter != YFilter.not_set or
                            (self.event_counters is not None and self.event_counters.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "bfd-info" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.bfd_session_up.is_set or self.bfd_session_up.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.bfd_session_up.get_name_leafdata())
                        if (self.failure_diagnostic_code.is_set or self.failure_diagnostic_code.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.failure_diagnostic_code.get_name_leafdata())
                        if (self.failure_reason.is_set or self.failure_reason.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.failure_reason.get_name_leafdata())
                        if (self.maximum_session_up_interval.is_set or self.maximum_session_up_interval.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.maximum_session_up_interval.get_name_leafdata())
                        if (self.minimum_session_up_interval.is_set or self.minimum_session_up_interval.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.minimum_session_up_interval.get_name_leafdata())
                        if (self.session_up_time.is_set or self.session_up_time.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.session_up_time.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "dampening-info"):
                            for c in self.dampening_info:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.BfdInfo.DampeningInfo()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.dampening_info.append(c)
                            return c

                        if (child_yang_name == "event-counters"):
                            if (self.event_counters is None):
                                self.event_counters = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.BfdInfo.EventCounters()
                                self.event_counters.parent = self
                                self._children_name_map["event_counters"] = "event-counters"
                            return self.event_counters

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "dampening-info" or name == "event-counters" or name == "bfd-session-up" or name == "failure-diagnostic-code" or name == "failure-reason" or name == "maximum-session-up-interval" or name == "minimum-session-up-interval" or name == "session-up-time"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "bfd-session-up"):
                            self.bfd_session_up = value
                            self.bfd_session_up.value_namespace = name_space
                            self.bfd_session_up.value_namespace_prefix = name_space_prefix
                        if(value_path == "failure-diagnostic-code"):
                            self.failure_diagnostic_code = value
                            self.failure_diagnostic_code.value_namespace = name_space
                            self.failure_diagnostic_code.value_namespace_prefix = name_space_prefix
                        if(value_path == "failure-reason"):
                            self.failure_reason = value
                            self.failure_reason.value_namespace = name_space
                            self.failure_reason.value_namespace_prefix = name_space_prefix
                        if(value_path == "maximum-session-up-interval"):
                            self.maximum_session_up_interval = value
                            self.maximum_session_up_interval.value_namespace = name_space
                            self.maximum_session_up_interval.value_namespace_prefix = name_space_prefix
                        if(value_path == "minimum-session-up-interval"):
                            self.minimum_session_up_interval = value
                            self.minimum_session_up_interval.value_namespace = name_space
                            self.minimum_session_up_interval.value_namespace_prefix = name_space_prefix
                        if(value_path == "session-up-time"):
                            self.session_up_time = value
                            self.session_up_time.value_namespace = name_space
                            self.session_up_time.value_namespace_prefix = name_space_prefix


                class OtnBidir(Entity):
                    """
                    OTN bidir info
                    
                    .. attribute:: aps
                    
                    	APS Protection Info
                    	**type**\:   :py:class:`Aps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.OtnBidir.Aps>`
                    
                    .. attribute:: restoration
                    
                    	Restoration Info
                    	**type**\:   :py:class:`Restoration <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.OtnBidir.Restoration>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.OtnBidir, self).__init__()

                        self.yang_name = "otn-bidir"
                        self.yang_parent_name = "tunnel-head"

                        self.aps = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.OtnBidir.Aps()
                        self.aps.parent = self
                        self._children_name_map["aps"] = "aps"
                        self._children_yang_names.add("aps")

                        self.restoration = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.OtnBidir.Restoration()
                        self.restoration.parent = self
                        self._children_name_map["restoration"] = "restoration"
                        self._children_yang_names.add("restoration")


                    class Aps(Entity):
                        """
                        APS Protection Info
                        
                        .. attribute:: active_lsp
                        
                        	Active LSP for Incoming Data
                        	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                        
                        .. attribute:: diversity_type
                        
                        	Standby path diversity type
                        	**type**\:   :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                        
                        .. attribute:: protection_profile
                        
                        	Protection Profile Information of tunnel
                        	**type**\:   :py:class:`ProtectionProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.OtnBidir.Aps.ProtectionProfile>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.OtnBidir.Aps, self).__init__()

                            self.yang_name = "aps"
                            self.yang_parent_name = "otn-bidir"

                            self.active_lsp = YLeaf(YType.enumeration, "active-lsp")

                            self.diversity_type = YLeaf(YType.enumeration, "diversity-type")

                            self.protection_profile = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.OtnBidir.Aps.ProtectionProfile()
                            self.protection_profile.parent = self
                            self._children_name_map["protection_profile"] = "protection-profile"
                            self._children_yang_names.add("protection-profile")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("active_lsp",
                                            "diversity_type") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.OtnBidir.Aps, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.OtnBidir.Aps, self).__setattr__(name, value)


                        class ProtectionProfile(Entity):
                            """
                            Protection Profile Information of tunnel
                            
                            .. attribute:: hold_off_time
                            
                            	Hold\-off time
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: path_prot_profile_type
                            
                            	Path Protection Profile Type
                            	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                            
                            .. attribute:: protection_mode
                            
                            	Protection Restoration Mode
                            	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                            
                            .. attribute:: protection_type
                            
                            	Protection Type
                            	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                            
                            .. attribute:: restoration_style
                            
                            	Restoration Style
                            	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                            
                            .. attribute:: revert_schedule
                            
                            	Revert Schedule
                            	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.OtnBidir.Aps.ProtectionProfile.RevertSchedule>`
                            
                            .. attribute:: snc_mode
                            
                            	Sub\-network Connection Mode
                            	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                            
                            .. attribute:: tcm_id
                            
                            	Sub\-network Connection Monitoring Mode
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: wait_to_restore_time
                            
                            	Wait to restore time
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.OtnBidir.Aps.ProtectionProfile, self).__init__()

                                self.yang_name = "protection-profile"
                                self.yang_parent_name = "aps"

                                self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.OtnBidir.Aps.ProtectionProfile.RevertSchedule()
                                self.revert_schedule.parent = self
                                self._children_name_map["revert_schedule"] = "revert-schedule"
                                self._children_yang_names.add("revert-schedule")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("hold_off_time",
                                                "path_prot_profile_type",
                                                "protection_mode",
                                                "protection_type",
                                                "restoration_style",
                                                "snc_mode",
                                                "tcm_id",
                                                "wait_to_restore_time") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.OtnBidir.Aps.ProtectionProfile, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.OtnBidir.Aps.ProtectionProfile, self).__setattr__(name, value)


                            class RevertSchedule(Entity):
                                """
                                Revert Schedule
                                
                                .. attribute:: duration
                                
                                	Duration for scheduled reversion
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: max_tries
                                
                                	Max tries for scheduled reversion
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: schedule_date
                                
                                	Schedule time for reversion
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: schedule_frequency
                                
                                	Schedule frequency for reversion
                                	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                
                                .. attribute:: schedulename
                                
                                	Schedule name identifier
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.OtnBidir.Aps.ProtectionProfile.RevertSchedule, self).__init__()

                                    self.yang_name = "revert-schedule"
                                    self.yang_parent_name = "protection-profile"

                                    self.duration = YLeaf(YType.uint32, "duration")

                                    self.max_tries = YLeaf(YType.uint32, "max-tries")

                                    self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                    self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                    self.schedulename = YLeaf(YType.str, "schedulename")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("duration",
                                                    "max_tries",
                                                    "schedule_date",
                                                    "schedule_frequency",
                                                    "schedulename") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.OtnBidir.Aps.ProtectionProfile.RevertSchedule, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.OtnBidir.Aps.ProtectionProfile.RevertSchedule, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.duration.is_set or
                                        self.max_tries.is_set or
                                        self.schedule_date.is_set or
                                        self.schedule_frequency.is_set or
                                        self.schedulename.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.duration.yfilter != YFilter.not_set or
                                        self.max_tries.yfilter != YFilter.not_set or
                                        self.schedule_date.yfilter != YFilter.not_set or
                                        self.schedule_frequency.yfilter != YFilter.not_set or
                                        self.schedulename.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "revert-schedule" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.duration.get_name_leafdata())
                                    if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.max_tries.get_name_leafdata())
                                    if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                    if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                    if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.schedulename.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "duration"):
                                        self.duration = value
                                        self.duration.value_namespace = name_space
                                        self.duration.value_namespace_prefix = name_space_prefix
                                    if(value_path == "max-tries"):
                                        self.max_tries = value
                                        self.max_tries.value_namespace = name_space
                                        self.max_tries.value_namespace_prefix = name_space_prefix
                                    if(value_path == "schedule-date"):
                                        self.schedule_date = value
                                        self.schedule_date.value_namespace = name_space
                                        self.schedule_date.value_namespace_prefix = name_space_prefix
                                    if(value_path == "schedule-frequency"):
                                        self.schedule_frequency = value
                                        self.schedule_frequency.value_namespace = name_space
                                        self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                    if(value_path == "schedulename"):
                                        self.schedulename = value
                                        self.schedulename.value_namespace = name_space
                                        self.schedulename.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.hold_off_time.is_set or
                                    self.path_prot_profile_type.is_set or
                                    self.protection_mode.is_set or
                                    self.protection_type.is_set or
                                    self.restoration_style.is_set or
                                    self.snc_mode.is_set or
                                    self.tcm_id.is_set or
                                    self.wait_to_restore_time.is_set or
                                    (self.revert_schedule is not None and self.revert_schedule.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.hold_off_time.yfilter != YFilter.not_set or
                                    self.path_prot_profile_type.yfilter != YFilter.not_set or
                                    self.protection_mode.yfilter != YFilter.not_set or
                                    self.protection_type.yfilter != YFilter.not_set or
                                    self.restoration_style.yfilter != YFilter.not_set or
                                    self.snc_mode.yfilter != YFilter.not_set or
                                    self.tcm_id.yfilter != YFilter.not_set or
                                    self.wait_to_restore_time.yfilter != YFilter.not_set or
                                    (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "protection-profile" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.protection_type.get_name_leafdata())
                                if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "revert-schedule"):
                                    if (self.revert_schedule is None):
                                        self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.OtnBidir.Aps.ProtectionProfile.RevertSchedule()
                                        self.revert_schedule.parent = self
                                        self._children_name_map["revert_schedule"] = "revert-schedule"
                                    return self.revert_schedule

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "hold-off-time"):
                                    self.hold_off_time = value
                                    self.hold_off_time.value_namespace = name_space
                                    self.hold_off_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-prot-profile-type"):
                                    self.path_prot_profile_type = value
                                    self.path_prot_profile_type.value_namespace = name_space
                                    self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "protection-mode"):
                                    self.protection_mode = value
                                    self.protection_mode.value_namespace = name_space
                                    self.protection_mode.value_namespace_prefix = name_space_prefix
                                if(value_path == "protection-type"):
                                    self.protection_type = value
                                    self.protection_type.value_namespace = name_space
                                    self.protection_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "restoration-style"):
                                    self.restoration_style = value
                                    self.restoration_style.value_namespace = name_space
                                    self.restoration_style.value_namespace_prefix = name_space_prefix
                                if(value_path == "snc-mode"):
                                    self.snc_mode = value
                                    self.snc_mode.value_namespace = name_space
                                    self.snc_mode.value_namespace_prefix = name_space_prefix
                                if(value_path == "tcm-id"):
                                    self.tcm_id = value
                                    self.tcm_id.value_namespace = name_space
                                    self.tcm_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "wait-to-restore-time"):
                                    self.wait_to_restore_time = value
                                    self.wait_to_restore_time.value_namespace = name_space
                                    self.wait_to_restore_time.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.active_lsp.is_set or
                                self.diversity_type.is_set or
                                (self.protection_profile is not None and self.protection_profile.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.active_lsp.yfilter != YFilter.not_set or
                                self.diversity_type.yfilter != YFilter.not_set or
                                (self.protection_profile is not None and self.protection_profile.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "aps" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.active_lsp.is_set or self.active_lsp.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.active_lsp.get_name_leafdata())
                            if (self.diversity_type.is_set or self.diversity_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.diversity_type.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "protection-profile"):
                                if (self.protection_profile is None):
                                    self.protection_profile = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.OtnBidir.Aps.ProtectionProfile()
                                    self.protection_profile.parent = self
                                    self._children_name_map["protection_profile"] = "protection-profile"
                                return self.protection_profile

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "protection-profile" or name == "active-lsp" or name == "diversity-type"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "active-lsp"):
                                self.active_lsp = value
                                self.active_lsp.value_namespace = name_space
                                self.active_lsp.value_namespace_prefix = name_space_prefix
                            if(value_path == "diversity-type"):
                                self.diversity_type = value
                                self.diversity_type.value_namespace = name_space
                                self.diversity_type.value_namespace_prefix = name_space_prefix


                    class Restoration(Entity):
                        """
                        Restoration Info
                        
                        .. attribute:: diverse_lsp
                        
                        	LSP from which restoration LSP is DIVERSED
                        	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                        
                        .. attribute:: diversity_type
                        
                        	Restoration path diversity type
                        	**type**\:   :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                        
                        .. attribute:: revert_option
                        
                        	Revertive or non\-revertive
                        	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.OtnBidir.Restoration, self).__init__()

                            self.yang_name = "restoration"
                            self.yang_parent_name = "otn-bidir"

                            self.diverse_lsp = YLeaf(YType.enumeration, "diverse-lsp")

                            self.diversity_type = YLeaf(YType.enumeration, "diversity-type")

                            self.revert_option = YLeaf(YType.enumeration, "revert-option")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("diverse_lsp",
                                            "diversity_type",
                                            "revert_option") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.OtnBidir.Restoration, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.OtnBidir.Restoration, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.diverse_lsp.is_set or
                                self.diversity_type.is_set or
                                self.revert_option.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.diverse_lsp.yfilter != YFilter.not_set or
                                self.diversity_type.yfilter != YFilter.not_set or
                                self.revert_option.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "restoration" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.diverse_lsp.is_set or self.diverse_lsp.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.diverse_lsp.get_name_leafdata())
                            if (self.diversity_type.is_set or self.diversity_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.diversity_type.get_name_leafdata())
                            if (self.revert_option.is_set or self.revert_option.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.revert_option.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "diverse-lsp" or name == "diversity-type" or name == "revert-option"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "diverse-lsp"):
                                self.diverse_lsp = value
                                self.diverse_lsp.value_namespace = name_space
                                self.diverse_lsp.value_namespace_prefix = name_space_prefix
                            if(value_path == "diversity-type"):
                                self.diversity_type = value
                                self.diversity_type.value_namespace = name_space
                                self.diversity_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "revert-option"):
                                self.revert_option = value
                                self.revert_option.value_namespace = name_space
                                self.revert_option.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            (self.aps is not None and self.aps.has_data()) or
                            (self.restoration is not None and self.restoration.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            (self.aps is not None and self.aps.has_operation()) or
                            (self.restoration is not None and self.restoration.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "otn-bidir" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "aps"):
                            if (self.aps is None):
                                self.aps = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.OtnBidir.Aps()
                                self.aps.parent = self
                                self._children_name_map["aps"] = "aps"
                            return self.aps

                        if (child_yang_name == "restoration"):
                            if (self.restoration is None):
                                self.restoration = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.OtnBidir.Restoration()
                                self.restoration.parent = self
                                self._children_name_map["restoration"] = "restoration"
                            return self.restoration

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "aps" or name == "restoration"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class Bidir(Entity):
                    """
                    Bidir info
                    
                    .. attribute:: reverse_bandwidth
                    
                    	Reverse Bandwidth value in kbps
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: kbit/s
                    
                    .. attribute:: reverse_bandwidth_standby
                    
                    	Reverse Bandwidth value for standby in kbps
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: kbit/s
                    
                    .. attribute:: reverse_ero_error_current
                    
                    	Reverse ERO Error Current LSP
                    	**type**\:   :py:class:`ReverseEroErrorCurrent <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorCurrent>`
                    
                    .. attribute:: reverse_ero_error_reopt
                    
                    	Reverse ERO Error Reopt LSP
                    	**type**\:   :py:class:`ReverseEroErrorReopt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorReopt>`
                    
                    .. attribute:: reverse_ero_error_standby
                    
                    	Reverse ERO Error Standby LSP
                    	**type**\:   :py:class:`ReverseEroErrorStandby <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandby>`
                    
                    .. attribute:: reverse_ero_error_standby_reopt
                    
                    	Reverse ERO Error Standby Reopt LSP
                    	**type**\:   :py:class:`ReverseEroErrorStandbyReopt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandbyReopt>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir, self).__init__()

                        self.yang_name = "bidir"
                        self.yang_parent_name = "tunnel-head"

                        self.reverse_bandwidth = YLeaf(YType.uint32, "reverse-bandwidth")

                        self.reverse_bandwidth_standby = YLeaf(YType.uint32, "reverse-bandwidth-standby")

                        self.reverse_ero_error_current = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorCurrent()
                        self.reverse_ero_error_current.parent = self
                        self._children_name_map["reverse_ero_error_current"] = "reverse-ero-error-current"
                        self._children_yang_names.add("reverse-ero-error-current")

                        self.reverse_ero_error_reopt = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorReopt()
                        self.reverse_ero_error_reopt.parent = self
                        self._children_name_map["reverse_ero_error_reopt"] = "reverse-ero-error-reopt"
                        self._children_yang_names.add("reverse-ero-error-reopt")

                        self.reverse_ero_error_standby = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandby()
                        self.reverse_ero_error_standby.parent = self
                        self._children_name_map["reverse_ero_error_standby"] = "reverse-ero-error-standby"
                        self._children_yang_names.add("reverse-ero-error-standby")

                        self.reverse_ero_error_standby_reopt = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandbyReopt()
                        self.reverse_ero_error_standby_reopt.parent = self
                        self._children_name_map["reverse_ero_error_standby_reopt"] = "reverse-ero-error-standby-reopt"
                        self._children_yang_names.add("reverse-ero-error-standby-reopt")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("reverse_bandwidth",
                                        "reverse_bandwidth_standby") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir, self).__setattr__(name, value)


                    class ReverseEroErrorCurrent(Entity):
                        """
                        Reverse ERO Error Current LSP
                        
                        .. attribute:: ero_reject_reason
                        
                        	Reverse ERO Reject Reason
                        	**type**\:   :py:class:`TeRevEroRejectReasons <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRevEroRejectReasons>`
                        
                        .. attribute:: path_calculation_error
                        
                        	Path Computation Information
                        	**type**\: list of    :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorCurrent.PathCalculationError>`
                        
                        .. attribute:: path_option_index
                        
                        	Path Option Index
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: path_option_type
                        
                        	Path Option Type
                        	**type**\:   :py:class:`MtePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MtePathOption>`
                        
                        .. attribute:: path_reject_reason_affinity
                        
                        	Path Reject due to affinity
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_bw
                        
                        	Path Reject due to bw
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_exclude_link
                        
                        	Path Reject due to exclude link
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_exclude_node
                        
                        	Path Reject due to exclude node
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_exclude_srlg
                        
                        	Path Reject due to exclude SRLG
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_holddown
                        
                        	Path Reject due to holddown
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_hop_limit
                        
                        	Path Reject due to hop limit
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_ip_addr
                        
                        	Path Reject due to IP address
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_ixcd
                        
                        	Path Reject due to IXCD
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_ol_head
                        
                        	Path Reject due to head node overload
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_ol_mid
                        
                        	Path Reject due to mid node overload
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_ol_tail
                        
                        	Path Reject due to head node overload
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_ol_unknown
                        
                        	Path Reject due to unknown node overload
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_unreachable
                        
                        	Path Reject due to unreachable node
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_reverse_bw
                        
                        	Path Reject due to reverse bw
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_reverse_link
                        
                        	Path Reject due to reverse link
                        	**type**\:  bool
                        
                        .. attribute:: reverse_lsp_id
                        
                        	Reverse LSP ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorCurrent, self).__init__()

                            self.yang_name = "reverse-ero-error-current"
                            self.yang_parent_name = "bidir"

                            self.ero_reject_reason = YLeaf(YType.enumeration, "ero-reject-reason")

                            self.path_option_index = YLeaf(YType.uint16, "path-option-index")

                            self.path_option_type = YLeaf(YType.enumeration, "path-option-type")

                            self.path_reject_reason_affinity = YLeaf(YType.boolean, "path-reject-reason-affinity")

                            self.path_reject_reason_bw = YLeaf(YType.boolean, "path-reject-reason-bw")

                            self.path_reject_reason_exclude_link = YLeaf(YType.boolean, "path-reject-reason-exclude-link")

                            self.path_reject_reason_exclude_node = YLeaf(YType.boolean, "path-reject-reason-exclude-node")

                            self.path_reject_reason_exclude_srlg = YLeaf(YType.boolean, "path-reject-reason-exclude-srlg")

                            self.path_reject_reason_holddown = YLeaf(YType.boolean, "path-reject-reason-holddown")

                            self.path_reject_reason_hop_limit = YLeaf(YType.boolean, "path-reject-reason-hop-limit")

                            self.path_reject_reason_ip_addr = YLeaf(YType.boolean, "path-reject-reason-ip-addr")

                            self.path_reject_reason_ixcd = YLeaf(YType.boolean, "path-reject-reason-ixcd")

                            self.path_reject_reason_node_ol_head = YLeaf(YType.boolean, "path-reject-reason-node-ol-head")

                            self.path_reject_reason_node_ol_mid = YLeaf(YType.boolean, "path-reject-reason-node-ol-mid")

                            self.path_reject_reason_node_ol_tail = YLeaf(YType.boolean, "path-reject-reason-node-ol-tail")

                            self.path_reject_reason_node_ol_unknown = YLeaf(YType.boolean, "path-reject-reason-node-ol-unknown")

                            self.path_reject_reason_node_unreachable = YLeaf(YType.boolean, "path-reject-reason-node-unreachable")

                            self.path_reject_reason_reverse_bw = YLeaf(YType.boolean, "path-reject-reason-reverse-bw")

                            self.path_reject_reason_reverse_link = YLeaf(YType.boolean, "path-reject-reason-reverse-link")

                            self.reverse_lsp_id = YLeaf(YType.uint16, "reverse-lsp-id")

                            self.path_calculation_error = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("ero_reject_reason",
                                            "path_option_index",
                                            "path_option_type",
                                            "path_reject_reason_affinity",
                                            "path_reject_reason_bw",
                                            "path_reject_reason_exclude_link",
                                            "path_reject_reason_exclude_node",
                                            "path_reject_reason_exclude_srlg",
                                            "path_reject_reason_holddown",
                                            "path_reject_reason_hop_limit",
                                            "path_reject_reason_ip_addr",
                                            "path_reject_reason_ixcd",
                                            "path_reject_reason_node_ol_head",
                                            "path_reject_reason_node_ol_mid",
                                            "path_reject_reason_node_ol_tail",
                                            "path_reject_reason_node_ol_unknown",
                                            "path_reject_reason_node_unreachable",
                                            "path_reject_reason_reverse_bw",
                                            "path_reject_reason_reverse_link",
                                            "reverse_lsp_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorCurrent, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorCurrent, self).__setattr__(name, value)


                        class PathCalculationError(Entity):
                            """
                            Path Computation Information
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\:  str
                            
                            .. attribute:: log_time
                            
                            	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: lsp_mode
                            
                            	LSP Mode
                            	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorCurrent.PathCalculationError, self).__init__()

                                self.yang_name = "path-calculation-error"
                                self.yang_parent_name = "reverse-ero-error-current"

                                self.error_message = YLeaf(YType.str, "error-message")

                                self.log_time = YLeaf(YType.uint32, "log-time")

                                self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("error_message",
                                                "log_time",
                                                "lsp_mode") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorCurrent.PathCalculationError, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorCurrent.PathCalculationError, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.error_message.is_set or
                                    self.log_time.is_set or
                                    self.lsp_mode.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.error_message.yfilter != YFilter.not_set or
                                    self.log_time.yfilter != YFilter.not_set or
                                    self.lsp_mode.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-calculation-error" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.error_message.get_name_leafdata())
                                if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.log_time.get_name_leafdata())
                                if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "error-message"):
                                    self.error_message = value
                                    self.error_message.value_namespace = name_space
                                    self.error_message.value_namespace_prefix = name_space_prefix
                                if(value_path == "log-time"):
                                    self.log_time = value
                                    self.log_time.value_namespace = name_space
                                    self.log_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-mode"):
                                    self.lsp_mode = value
                                    self.lsp_mode.value_namespace = name_space
                                    self.lsp_mode.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.path_calculation_error:
                                if (c.has_data()):
                                    return True
                            return (
                                self.ero_reject_reason.is_set or
                                self.path_option_index.is_set or
                                self.path_option_type.is_set or
                                self.path_reject_reason_affinity.is_set or
                                self.path_reject_reason_bw.is_set or
                                self.path_reject_reason_exclude_link.is_set or
                                self.path_reject_reason_exclude_node.is_set or
                                self.path_reject_reason_exclude_srlg.is_set or
                                self.path_reject_reason_holddown.is_set or
                                self.path_reject_reason_hop_limit.is_set or
                                self.path_reject_reason_ip_addr.is_set or
                                self.path_reject_reason_ixcd.is_set or
                                self.path_reject_reason_node_ol_head.is_set or
                                self.path_reject_reason_node_ol_mid.is_set or
                                self.path_reject_reason_node_ol_tail.is_set or
                                self.path_reject_reason_node_ol_unknown.is_set or
                                self.path_reject_reason_node_unreachable.is_set or
                                self.path_reject_reason_reverse_bw.is_set or
                                self.path_reject_reason_reverse_link.is_set or
                                self.reverse_lsp_id.is_set)

                        def has_operation(self):
                            for c in self.path_calculation_error:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.ero_reject_reason.yfilter != YFilter.not_set or
                                self.path_option_index.yfilter != YFilter.not_set or
                                self.path_option_type.yfilter != YFilter.not_set or
                                self.path_reject_reason_affinity.yfilter != YFilter.not_set or
                                self.path_reject_reason_bw.yfilter != YFilter.not_set or
                                self.path_reject_reason_exclude_link.yfilter != YFilter.not_set or
                                self.path_reject_reason_exclude_node.yfilter != YFilter.not_set or
                                self.path_reject_reason_exclude_srlg.yfilter != YFilter.not_set or
                                self.path_reject_reason_holddown.yfilter != YFilter.not_set or
                                self.path_reject_reason_hop_limit.yfilter != YFilter.not_set or
                                self.path_reject_reason_ip_addr.yfilter != YFilter.not_set or
                                self.path_reject_reason_ixcd.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_ol_head.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_ol_mid.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_ol_tail.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_ol_unknown.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_unreachable.yfilter != YFilter.not_set or
                                self.path_reject_reason_reverse_bw.yfilter != YFilter.not_set or
                                self.path_reject_reason_reverse_link.yfilter != YFilter.not_set or
                                self.reverse_lsp_id.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "reverse-ero-error-current" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.ero_reject_reason.is_set or self.ero_reject_reason.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ero_reject_reason.get_name_leafdata())
                            if (self.path_option_index.is_set or self.path_option_index.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_option_index.get_name_leafdata())
                            if (self.path_option_type.is_set or self.path_option_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_option_type.get_name_leafdata())
                            if (self.path_reject_reason_affinity.is_set or self.path_reject_reason_affinity.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_affinity.get_name_leafdata())
                            if (self.path_reject_reason_bw.is_set or self.path_reject_reason_bw.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_bw.get_name_leafdata())
                            if (self.path_reject_reason_exclude_link.is_set or self.path_reject_reason_exclude_link.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_exclude_link.get_name_leafdata())
                            if (self.path_reject_reason_exclude_node.is_set or self.path_reject_reason_exclude_node.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_exclude_node.get_name_leafdata())
                            if (self.path_reject_reason_exclude_srlg.is_set or self.path_reject_reason_exclude_srlg.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_exclude_srlg.get_name_leafdata())
                            if (self.path_reject_reason_holddown.is_set or self.path_reject_reason_holddown.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_holddown.get_name_leafdata())
                            if (self.path_reject_reason_hop_limit.is_set or self.path_reject_reason_hop_limit.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_hop_limit.get_name_leafdata())
                            if (self.path_reject_reason_ip_addr.is_set or self.path_reject_reason_ip_addr.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_ip_addr.get_name_leafdata())
                            if (self.path_reject_reason_ixcd.is_set or self.path_reject_reason_ixcd.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_ixcd.get_name_leafdata())
                            if (self.path_reject_reason_node_ol_head.is_set or self.path_reject_reason_node_ol_head.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_ol_head.get_name_leafdata())
                            if (self.path_reject_reason_node_ol_mid.is_set or self.path_reject_reason_node_ol_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_ol_mid.get_name_leafdata())
                            if (self.path_reject_reason_node_ol_tail.is_set or self.path_reject_reason_node_ol_tail.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_ol_tail.get_name_leafdata())
                            if (self.path_reject_reason_node_ol_unknown.is_set or self.path_reject_reason_node_ol_unknown.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_ol_unknown.get_name_leafdata())
                            if (self.path_reject_reason_node_unreachable.is_set or self.path_reject_reason_node_unreachable.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_unreachable.get_name_leafdata())
                            if (self.path_reject_reason_reverse_bw.is_set or self.path_reject_reason_reverse_bw.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_reverse_bw.get_name_leafdata())
                            if (self.path_reject_reason_reverse_link.is_set or self.path_reject_reason_reverse_link.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_reverse_link.get_name_leafdata())
                            if (self.reverse_lsp_id.is_set or self.reverse_lsp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "path-calculation-error"):
                                for c in self.path_calculation_error:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorCurrent.PathCalculationError()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_calculation_error.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "path-calculation-error" or name == "ero-reject-reason" or name == "path-option-index" or name == "path-option-type" or name == "path-reject-reason-affinity" or name == "path-reject-reason-bw" or name == "path-reject-reason-exclude-link" or name == "path-reject-reason-exclude-node" or name == "path-reject-reason-exclude-srlg" or name == "path-reject-reason-holddown" or name == "path-reject-reason-hop-limit" or name == "path-reject-reason-ip-addr" or name == "path-reject-reason-ixcd" or name == "path-reject-reason-node-ol-head" or name == "path-reject-reason-node-ol-mid" or name == "path-reject-reason-node-ol-tail" or name == "path-reject-reason-node-ol-unknown" or name == "path-reject-reason-node-unreachable" or name == "path-reject-reason-reverse-bw" or name == "path-reject-reason-reverse-link" or name == "reverse-lsp-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "ero-reject-reason"):
                                self.ero_reject_reason = value
                                self.ero_reject_reason.value_namespace = name_space
                                self.ero_reject_reason.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-option-index"):
                                self.path_option_index = value
                                self.path_option_index.value_namespace = name_space
                                self.path_option_index.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-option-type"):
                                self.path_option_type = value
                                self.path_option_type.value_namespace = name_space
                                self.path_option_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-affinity"):
                                self.path_reject_reason_affinity = value
                                self.path_reject_reason_affinity.value_namespace = name_space
                                self.path_reject_reason_affinity.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-bw"):
                                self.path_reject_reason_bw = value
                                self.path_reject_reason_bw.value_namespace = name_space
                                self.path_reject_reason_bw.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-exclude-link"):
                                self.path_reject_reason_exclude_link = value
                                self.path_reject_reason_exclude_link.value_namespace = name_space
                                self.path_reject_reason_exclude_link.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-exclude-node"):
                                self.path_reject_reason_exclude_node = value
                                self.path_reject_reason_exclude_node.value_namespace = name_space
                                self.path_reject_reason_exclude_node.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-exclude-srlg"):
                                self.path_reject_reason_exclude_srlg = value
                                self.path_reject_reason_exclude_srlg.value_namespace = name_space
                                self.path_reject_reason_exclude_srlg.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-holddown"):
                                self.path_reject_reason_holddown = value
                                self.path_reject_reason_holddown.value_namespace = name_space
                                self.path_reject_reason_holddown.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-hop-limit"):
                                self.path_reject_reason_hop_limit = value
                                self.path_reject_reason_hop_limit.value_namespace = name_space
                                self.path_reject_reason_hop_limit.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-ip-addr"):
                                self.path_reject_reason_ip_addr = value
                                self.path_reject_reason_ip_addr.value_namespace = name_space
                                self.path_reject_reason_ip_addr.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-ixcd"):
                                self.path_reject_reason_ixcd = value
                                self.path_reject_reason_ixcd.value_namespace = name_space
                                self.path_reject_reason_ixcd.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-ol-head"):
                                self.path_reject_reason_node_ol_head = value
                                self.path_reject_reason_node_ol_head.value_namespace = name_space
                                self.path_reject_reason_node_ol_head.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-ol-mid"):
                                self.path_reject_reason_node_ol_mid = value
                                self.path_reject_reason_node_ol_mid.value_namespace = name_space
                                self.path_reject_reason_node_ol_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-ol-tail"):
                                self.path_reject_reason_node_ol_tail = value
                                self.path_reject_reason_node_ol_tail.value_namespace = name_space
                                self.path_reject_reason_node_ol_tail.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-ol-unknown"):
                                self.path_reject_reason_node_ol_unknown = value
                                self.path_reject_reason_node_ol_unknown.value_namespace = name_space
                                self.path_reject_reason_node_ol_unknown.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-unreachable"):
                                self.path_reject_reason_node_unreachable = value
                                self.path_reject_reason_node_unreachable.value_namespace = name_space
                                self.path_reject_reason_node_unreachable.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-reverse-bw"):
                                self.path_reject_reason_reverse_bw = value
                                self.path_reject_reason_reverse_bw.value_namespace = name_space
                                self.path_reject_reason_reverse_bw.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-reverse-link"):
                                self.path_reject_reason_reverse_link = value
                                self.path_reject_reason_reverse_link.value_namespace = name_space
                                self.path_reject_reason_reverse_link.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-id"):
                                self.reverse_lsp_id = value
                                self.reverse_lsp_id.value_namespace = name_space
                                self.reverse_lsp_id.value_namespace_prefix = name_space_prefix


                    class ReverseEroErrorReopt(Entity):
                        """
                        Reverse ERO Error Reopt LSP
                        
                        .. attribute:: ero_reject_reason
                        
                        	Reverse ERO Reject Reason
                        	**type**\:   :py:class:`TeRevEroRejectReasons <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRevEroRejectReasons>`
                        
                        .. attribute:: path_calculation_error
                        
                        	Path Computation Information
                        	**type**\: list of    :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorReopt.PathCalculationError>`
                        
                        .. attribute:: path_option_index
                        
                        	Path Option Index
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: path_option_type
                        
                        	Path Option Type
                        	**type**\:   :py:class:`MtePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MtePathOption>`
                        
                        .. attribute:: path_reject_reason_affinity
                        
                        	Path Reject due to affinity
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_bw
                        
                        	Path Reject due to bw
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_exclude_link
                        
                        	Path Reject due to exclude link
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_exclude_node
                        
                        	Path Reject due to exclude node
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_exclude_srlg
                        
                        	Path Reject due to exclude SRLG
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_holddown
                        
                        	Path Reject due to holddown
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_hop_limit
                        
                        	Path Reject due to hop limit
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_ip_addr
                        
                        	Path Reject due to IP address
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_ixcd
                        
                        	Path Reject due to IXCD
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_ol_head
                        
                        	Path Reject due to head node overload
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_ol_mid
                        
                        	Path Reject due to mid node overload
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_ol_tail
                        
                        	Path Reject due to head node overload
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_ol_unknown
                        
                        	Path Reject due to unknown node overload
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_unreachable
                        
                        	Path Reject due to unreachable node
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_reverse_bw
                        
                        	Path Reject due to reverse bw
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_reverse_link
                        
                        	Path Reject due to reverse link
                        	**type**\:  bool
                        
                        .. attribute:: reverse_lsp_id
                        
                        	Reverse LSP ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorReopt, self).__init__()

                            self.yang_name = "reverse-ero-error-reopt"
                            self.yang_parent_name = "bidir"

                            self.ero_reject_reason = YLeaf(YType.enumeration, "ero-reject-reason")

                            self.path_option_index = YLeaf(YType.uint16, "path-option-index")

                            self.path_option_type = YLeaf(YType.enumeration, "path-option-type")

                            self.path_reject_reason_affinity = YLeaf(YType.boolean, "path-reject-reason-affinity")

                            self.path_reject_reason_bw = YLeaf(YType.boolean, "path-reject-reason-bw")

                            self.path_reject_reason_exclude_link = YLeaf(YType.boolean, "path-reject-reason-exclude-link")

                            self.path_reject_reason_exclude_node = YLeaf(YType.boolean, "path-reject-reason-exclude-node")

                            self.path_reject_reason_exclude_srlg = YLeaf(YType.boolean, "path-reject-reason-exclude-srlg")

                            self.path_reject_reason_holddown = YLeaf(YType.boolean, "path-reject-reason-holddown")

                            self.path_reject_reason_hop_limit = YLeaf(YType.boolean, "path-reject-reason-hop-limit")

                            self.path_reject_reason_ip_addr = YLeaf(YType.boolean, "path-reject-reason-ip-addr")

                            self.path_reject_reason_ixcd = YLeaf(YType.boolean, "path-reject-reason-ixcd")

                            self.path_reject_reason_node_ol_head = YLeaf(YType.boolean, "path-reject-reason-node-ol-head")

                            self.path_reject_reason_node_ol_mid = YLeaf(YType.boolean, "path-reject-reason-node-ol-mid")

                            self.path_reject_reason_node_ol_tail = YLeaf(YType.boolean, "path-reject-reason-node-ol-tail")

                            self.path_reject_reason_node_ol_unknown = YLeaf(YType.boolean, "path-reject-reason-node-ol-unknown")

                            self.path_reject_reason_node_unreachable = YLeaf(YType.boolean, "path-reject-reason-node-unreachable")

                            self.path_reject_reason_reverse_bw = YLeaf(YType.boolean, "path-reject-reason-reverse-bw")

                            self.path_reject_reason_reverse_link = YLeaf(YType.boolean, "path-reject-reason-reverse-link")

                            self.reverse_lsp_id = YLeaf(YType.uint16, "reverse-lsp-id")

                            self.path_calculation_error = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("ero_reject_reason",
                                            "path_option_index",
                                            "path_option_type",
                                            "path_reject_reason_affinity",
                                            "path_reject_reason_bw",
                                            "path_reject_reason_exclude_link",
                                            "path_reject_reason_exclude_node",
                                            "path_reject_reason_exclude_srlg",
                                            "path_reject_reason_holddown",
                                            "path_reject_reason_hop_limit",
                                            "path_reject_reason_ip_addr",
                                            "path_reject_reason_ixcd",
                                            "path_reject_reason_node_ol_head",
                                            "path_reject_reason_node_ol_mid",
                                            "path_reject_reason_node_ol_tail",
                                            "path_reject_reason_node_ol_unknown",
                                            "path_reject_reason_node_unreachable",
                                            "path_reject_reason_reverse_bw",
                                            "path_reject_reason_reverse_link",
                                            "reverse_lsp_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorReopt, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorReopt, self).__setattr__(name, value)


                        class PathCalculationError(Entity):
                            """
                            Path Computation Information
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\:  str
                            
                            .. attribute:: log_time
                            
                            	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: lsp_mode
                            
                            	LSP Mode
                            	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorReopt.PathCalculationError, self).__init__()

                                self.yang_name = "path-calculation-error"
                                self.yang_parent_name = "reverse-ero-error-reopt"

                                self.error_message = YLeaf(YType.str, "error-message")

                                self.log_time = YLeaf(YType.uint32, "log-time")

                                self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("error_message",
                                                "log_time",
                                                "lsp_mode") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorReopt.PathCalculationError, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorReopt.PathCalculationError, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.error_message.is_set or
                                    self.log_time.is_set or
                                    self.lsp_mode.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.error_message.yfilter != YFilter.not_set or
                                    self.log_time.yfilter != YFilter.not_set or
                                    self.lsp_mode.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-calculation-error" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.error_message.get_name_leafdata())
                                if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.log_time.get_name_leafdata())
                                if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "error-message"):
                                    self.error_message = value
                                    self.error_message.value_namespace = name_space
                                    self.error_message.value_namespace_prefix = name_space_prefix
                                if(value_path == "log-time"):
                                    self.log_time = value
                                    self.log_time.value_namespace = name_space
                                    self.log_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-mode"):
                                    self.lsp_mode = value
                                    self.lsp_mode.value_namespace = name_space
                                    self.lsp_mode.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.path_calculation_error:
                                if (c.has_data()):
                                    return True
                            return (
                                self.ero_reject_reason.is_set or
                                self.path_option_index.is_set or
                                self.path_option_type.is_set or
                                self.path_reject_reason_affinity.is_set or
                                self.path_reject_reason_bw.is_set or
                                self.path_reject_reason_exclude_link.is_set or
                                self.path_reject_reason_exclude_node.is_set or
                                self.path_reject_reason_exclude_srlg.is_set or
                                self.path_reject_reason_holddown.is_set or
                                self.path_reject_reason_hop_limit.is_set or
                                self.path_reject_reason_ip_addr.is_set or
                                self.path_reject_reason_ixcd.is_set or
                                self.path_reject_reason_node_ol_head.is_set or
                                self.path_reject_reason_node_ol_mid.is_set or
                                self.path_reject_reason_node_ol_tail.is_set or
                                self.path_reject_reason_node_ol_unknown.is_set or
                                self.path_reject_reason_node_unreachable.is_set or
                                self.path_reject_reason_reverse_bw.is_set or
                                self.path_reject_reason_reverse_link.is_set or
                                self.reverse_lsp_id.is_set)

                        def has_operation(self):
                            for c in self.path_calculation_error:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.ero_reject_reason.yfilter != YFilter.not_set or
                                self.path_option_index.yfilter != YFilter.not_set or
                                self.path_option_type.yfilter != YFilter.not_set or
                                self.path_reject_reason_affinity.yfilter != YFilter.not_set or
                                self.path_reject_reason_bw.yfilter != YFilter.not_set or
                                self.path_reject_reason_exclude_link.yfilter != YFilter.not_set or
                                self.path_reject_reason_exclude_node.yfilter != YFilter.not_set or
                                self.path_reject_reason_exclude_srlg.yfilter != YFilter.not_set or
                                self.path_reject_reason_holddown.yfilter != YFilter.not_set or
                                self.path_reject_reason_hop_limit.yfilter != YFilter.not_set or
                                self.path_reject_reason_ip_addr.yfilter != YFilter.not_set or
                                self.path_reject_reason_ixcd.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_ol_head.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_ol_mid.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_ol_tail.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_ol_unknown.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_unreachable.yfilter != YFilter.not_set or
                                self.path_reject_reason_reverse_bw.yfilter != YFilter.not_set or
                                self.path_reject_reason_reverse_link.yfilter != YFilter.not_set or
                                self.reverse_lsp_id.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "reverse-ero-error-reopt" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.ero_reject_reason.is_set or self.ero_reject_reason.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ero_reject_reason.get_name_leafdata())
                            if (self.path_option_index.is_set or self.path_option_index.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_option_index.get_name_leafdata())
                            if (self.path_option_type.is_set or self.path_option_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_option_type.get_name_leafdata())
                            if (self.path_reject_reason_affinity.is_set or self.path_reject_reason_affinity.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_affinity.get_name_leafdata())
                            if (self.path_reject_reason_bw.is_set or self.path_reject_reason_bw.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_bw.get_name_leafdata())
                            if (self.path_reject_reason_exclude_link.is_set or self.path_reject_reason_exclude_link.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_exclude_link.get_name_leafdata())
                            if (self.path_reject_reason_exclude_node.is_set or self.path_reject_reason_exclude_node.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_exclude_node.get_name_leafdata())
                            if (self.path_reject_reason_exclude_srlg.is_set or self.path_reject_reason_exclude_srlg.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_exclude_srlg.get_name_leafdata())
                            if (self.path_reject_reason_holddown.is_set or self.path_reject_reason_holddown.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_holddown.get_name_leafdata())
                            if (self.path_reject_reason_hop_limit.is_set or self.path_reject_reason_hop_limit.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_hop_limit.get_name_leafdata())
                            if (self.path_reject_reason_ip_addr.is_set or self.path_reject_reason_ip_addr.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_ip_addr.get_name_leafdata())
                            if (self.path_reject_reason_ixcd.is_set or self.path_reject_reason_ixcd.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_ixcd.get_name_leafdata())
                            if (self.path_reject_reason_node_ol_head.is_set or self.path_reject_reason_node_ol_head.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_ol_head.get_name_leafdata())
                            if (self.path_reject_reason_node_ol_mid.is_set or self.path_reject_reason_node_ol_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_ol_mid.get_name_leafdata())
                            if (self.path_reject_reason_node_ol_tail.is_set or self.path_reject_reason_node_ol_tail.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_ol_tail.get_name_leafdata())
                            if (self.path_reject_reason_node_ol_unknown.is_set or self.path_reject_reason_node_ol_unknown.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_ol_unknown.get_name_leafdata())
                            if (self.path_reject_reason_node_unreachable.is_set or self.path_reject_reason_node_unreachable.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_unreachable.get_name_leafdata())
                            if (self.path_reject_reason_reverse_bw.is_set or self.path_reject_reason_reverse_bw.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_reverse_bw.get_name_leafdata())
                            if (self.path_reject_reason_reverse_link.is_set or self.path_reject_reason_reverse_link.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_reverse_link.get_name_leafdata())
                            if (self.reverse_lsp_id.is_set or self.reverse_lsp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "path-calculation-error"):
                                for c in self.path_calculation_error:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorReopt.PathCalculationError()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_calculation_error.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "path-calculation-error" or name == "ero-reject-reason" or name == "path-option-index" or name == "path-option-type" or name == "path-reject-reason-affinity" or name == "path-reject-reason-bw" or name == "path-reject-reason-exclude-link" or name == "path-reject-reason-exclude-node" or name == "path-reject-reason-exclude-srlg" or name == "path-reject-reason-holddown" or name == "path-reject-reason-hop-limit" or name == "path-reject-reason-ip-addr" or name == "path-reject-reason-ixcd" or name == "path-reject-reason-node-ol-head" or name == "path-reject-reason-node-ol-mid" or name == "path-reject-reason-node-ol-tail" or name == "path-reject-reason-node-ol-unknown" or name == "path-reject-reason-node-unreachable" or name == "path-reject-reason-reverse-bw" or name == "path-reject-reason-reverse-link" or name == "reverse-lsp-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "ero-reject-reason"):
                                self.ero_reject_reason = value
                                self.ero_reject_reason.value_namespace = name_space
                                self.ero_reject_reason.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-option-index"):
                                self.path_option_index = value
                                self.path_option_index.value_namespace = name_space
                                self.path_option_index.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-option-type"):
                                self.path_option_type = value
                                self.path_option_type.value_namespace = name_space
                                self.path_option_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-affinity"):
                                self.path_reject_reason_affinity = value
                                self.path_reject_reason_affinity.value_namespace = name_space
                                self.path_reject_reason_affinity.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-bw"):
                                self.path_reject_reason_bw = value
                                self.path_reject_reason_bw.value_namespace = name_space
                                self.path_reject_reason_bw.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-exclude-link"):
                                self.path_reject_reason_exclude_link = value
                                self.path_reject_reason_exclude_link.value_namespace = name_space
                                self.path_reject_reason_exclude_link.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-exclude-node"):
                                self.path_reject_reason_exclude_node = value
                                self.path_reject_reason_exclude_node.value_namespace = name_space
                                self.path_reject_reason_exclude_node.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-exclude-srlg"):
                                self.path_reject_reason_exclude_srlg = value
                                self.path_reject_reason_exclude_srlg.value_namespace = name_space
                                self.path_reject_reason_exclude_srlg.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-holddown"):
                                self.path_reject_reason_holddown = value
                                self.path_reject_reason_holddown.value_namespace = name_space
                                self.path_reject_reason_holddown.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-hop-limit"):
                                self.path_reject_reason_hop_limit = value
                                self.path_reject_reason_hop_limit.value_namespace = name_space
                                self.path_reject_reason_hop_limit.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-ip-addr"):
                                self.path_reject_reason_ip_addr = value
                                self.path_reject_reason_ip_addr.value_namespace = name_space
                                self.path_reject_reason_ip_addr.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-ixcd"):
                                self.path_reject_reason_ixcd = value
                                self.path_reject_reason_ixcd.value_namespace = name_space
                                self.path_reject_reason_ixcd.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-ol-head"):
                                self.path_reject_reason_node_ol_head = value
                                self.path_reject_reason_node_ol_head.value_namespace = name_space
                                self.path_reject_reason_node_ol_head.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-ol-mid"):
                                self.path_reject_reason_node_ol_mid = value
                                self.path_reject_reason_node_ol_mid.value_namespace = name_space
                                self.path_reject_reason_node_ol_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-ol-tail"):
                                self.path_reject_reason_node_ol_tail = value
                                self.path_reject_reason_node_ol_tail.value_namespace = name_space
                                self.path_reject_reason_node_ol_tail.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-ol-unknown"):
                                self.path_reject_reason_node_ol_unknown = value
                                self.path_reject_reason_node_ol_unknown.value_namespace = name_space
                                self.path_reject_reason_node_ol_unknown.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-unreachable"):
                                self.path_reject_reason_node_unreachable = value
                                self.path_reject_reason_node_unreachable.value_namespace = name_space
                                self.path_reject_reason_node_unreachable.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-reverse-bw"):
                                self.path_reject_reason_reverse_bw = value
                                self.path_reject_reason_reverse_bw.value_namespace = name_space
                                self.path_reject_reason_reverse_bw.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-reverse-link"):
                                self.path_reject_reason_reverse_link = value
                                self.path_reject_reason_reverse_link.value_namespace = name_space
                                self.path_reject_reason_reverse_link.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-id"):
                                self.reverse_lsp_id = value
                                self.reverse_lsp_id.value_namespace = name_space
                                self.reverse_lsp_id.value_namespace_prefix = name_space_prefix


                    class ReverseEroErrorStandby(Entity):
                        """
                        Reverse ERO Error Standby LSP
                        
                        .. attribute:: ero_reject_reason
                        
                        	Reverse ERO Reject Reason
                        	**type**\:   :py:class:`TeRevEroRejectReasons <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRevEroRejectReasons>`
                        
                        .. attribute:: path_calculation_error
                        
                        	Path Computation Information
                        	**type**\: list of    :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandby.PathCalculationError>`
                        
                        .. attribute:: path_option_index
                        
                        	Path Option Index
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: path_option_type
                        
                        	Path Option Type
                        	**type**\:   :py:class:`MtePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MtePathOption>`
                        
                        .. attribute:: path_reject_reason_affinity
                        
                        	Path Reject due to affinity
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_bw
                        
                        	Path Reject due to bw
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_exclude_link
                        
                        	Path Reject due to exclude link
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_exclude_node
                        
                        	Path Reject due to exclude node
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_exclude_srlg
                        
                        	Path Reject due to exclude SRLG
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_holddown
                        
                        	Path Reject due to holddown
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_hop_limit
                        
                        	Path Reject due to hop limit
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_ip_addr
                        
                        	Path Reject due to IP address
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_ixcd
                        
                        	Path Reject due to IXCD
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_ol_head
                        
                        	Path Reject due to head node overload
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_ol_mid
                        
                        	Path Reject due to mid node overload
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_ol_tail
                        
                        	Path Reject due to head node overload
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_ol_unknown
                        
                        	Path Reject due to unknown node overload
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_unreachable
                        
                        	Path Reject due to unreachable node
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_reverse_bw
                        
                        	Path Reject due to reverse bw
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_reverse_link
                        
                        	Path Reject due to reverse link
                        	**type**\:  bool
                        
                        .. attribute:: reverse_lsp_id
                        
                        	Reverse LSP ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandby, self).__init__()

                            self.yang_name = "reverse-ero-error-standby"
                            self.yang_parent_name = "bidir"

                            self.ero_reject_reason = YLeaf(YType.enumeration, "ero-reject-reason")

                            self.path_option_index = YLeaf(YType.uint16, "path-option-index")

                            self.path_option_type = YLeaf(YType.enumeration, "path-option-type")

                            self.path_reject_reason_affinity = YLeaf(YType.boolean, "path-reject-reason-affinity")

                            self.path_reject_reason_bw = YLeaf(YType.boolean, "path-reject-reason-bw")

                            self.path_reject_reason_exclude_link = YLeaf(YType.boolean, "path-reject-reason-exclude-link")

                            self.path_reject_reason_exclude_node = YLeaf(YType.boolean, "path-reject-reason-exclude-node")

                            self.path_reject_reason_exclude_srlg = YLeaf(YType.boolean, "path-reject-reason-exclude-srlg")

                            self.path_reject_reason_holddown = YLeaf(YType.boolean, "path-reject-reason-holddown")

                            self.path_reject_reason_hop_limit = YLeaf(YType.boolean, "path-reject-reason-hop-limit")

                            self.path_reject_reason_ip_addr = YLeaf(YType.boolean, "path-reject-reason-ip-addr")

                            self.path_reject_reason_ixcd = YLeaf(YType.boolean, "path-reject-reason-ixcd")

                            self.path_reject_reason_node_ol_head = YLeaf(YType.boolean, "path-reject-reason-node-ol-head")

                            self.path_reject_reason_node_ol_mid = YLeaf(YType.boolean, "path-reject-reason-node-ol-mid")

                            self.path_reject_reason_node_ol_tail = YLeaf(YType.boolean, "path-reject-reason-node-ol-tail")

                            self.path_reject_reason_node_ol_unknown = YLeaf(YType.boolean, "path-reject-reason-node-ol-unknown")

                            self.path_reject_reason_node_unreachable = YLeaf(YType.boolean, "path-reject-reason-node-unreachable")

                            self.path_reject_reason_reverse_bw = YLeaf(YType.boolean, "path-reject-reason-reverse-bw")

                            self.path_reject_reason_reverse_link = YLeaf(YType.boolean, "path-reject-reason-reverse-link")

                            self.reverse_lsp_id = YLeaf(YType.uint16, "reverse-lsp-id")

                            self.path_calculation_error = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("ero_reject_reason",
                                            "path_option_index",
                                            "path_option_type",
                                            "path_reject_reason_affinity",
                                            "path_reject_reason_bw",
                                            "path_reject_reason_exclude_link",
                                            "path_reject_reason_exclude_node",
                                            "path_reject_reason_exclude_srlg",
                                            "path_reject_reason_holddown",
                                            "path_reject_reason_hop_limit",
                                            "path_reject_reason_ip_addr",
                                            "path_reject_reason_ixcd",
                                            "path_reject_reason_node_ol_head",
                                            "path_reject_reason_node_ol_mid",
                                            "path_reject_reason_node_ol_tail",
                                            "path_reject_reason_node_ol_unknown",
                                            "path_reject_reason_node_unreachable",
                                            "path_reject_reason_reverse_bw",
                                            "path_reject_reason_reverse_link",
                                            "reverse_lsp_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandby, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandby, self).__setattr__(name, value)


                        class PathCalculationError(Entity):
                            """
                            Path Computation Information
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\:  str
                            
                            .. attribute:: log_time
                            
                            	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: lsp_mode
                            
                            	LSP Mode
                            	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandby.PathCalculationError, self).__init__()

                                self.yang_name = "path-calculation-error"
                                self.yang_parent_name = "reverse-ero-error-standby"

                                self.error_message = YLeaf(YType.str, "error-message")

                                self.log_time = YLeaf(YType.uint32, "log-time")

                                self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("error_message",
                                                "log_time",
                                                "lsp_mode") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandby.PathCalculationError, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandby.PathCalculationError, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.error_message.is_set or
                                    self.log_time.is_set or
                                    self.lsp_mode.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.error_message.yfilter != YFilter.not_set or
                                    self.log_time.yfilter != YFilter.not_set or
                                    self.lsp_mode.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-calculation-error" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.error_message.get_name_leafdata())
                                if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.log_time.get_name_leafdata())
                                if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "error-message"):
                                    self.error_message = value
                                    self.error_message.value_namespace = name_space
                                    self.error_message.value_namespace_prefix = name_space_prefix
                                if(value_path == "log-time"):
                                    self.log_time = value
                                    self.log_time.value_namespace = name_space
                                    self.log_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-mode"):
                                    self.lsp_mode = value
                                    self.lsp_mode.value_namespace = name_space
                                    self.lsp_mode.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.path_calculation_error:
                                if (c.has_data()):
                                    return True
                            return (
                                self.ero_reject_reason.is_set or
                                self.path_option_index.is_set or
                                self.path_option_type.is_set or
                                self.path_reject_reason_affinity.is_set or
                                self.path_reject_reason_bw.is_set or
                                self.path_reject_reason_exclude_link.is_set or
                                self.path_reject_reason_exclude_node.is_set or
                                self.path_reject_reason_exclude_srlg.is_set or
                                self.path_reject_reason_holddown.is_set or
                                self.path_reject_reason_hop_limit.is_set or
                                self.path_reject_reason_ip_addr.is_set or
                                self.path_reject_reason_ixcd.is_set or
                                self.path_reject_reason_node_ol_head.is_set or
                                self.path_reject_reason_node_ol_mid.is_set or
                                self.path_reject_reason_node_ol_tail.is_set or
                                self.path_reject_reason_node_ol_unknown.is_set or
                                self.path_reject_reason_node_unreachable.is_set or
                                self.path_reject_reason_reverse_bw.is_set or
                                self.path_reject_reason_reverse_link.is_set or
                                self.reverse_lsp_id.is_set)

                        def has_operation(self):
                            for c in self.path_calculation_error:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.ero_reject_reason.yfilter != YFilter.not_set or
                                self.path_option_index.yfilter != YFilter.not_set or
                                self.path_option_type.yfilter != YFilter.not_set or
                                self.path_reject_reason_affinity.yfilter != YFilter.not_set or
                                self.path_reject_reason_bw.yfilter != YFilter.not_set or
                                self.path_reject_reason_exclude_link.yfilter != YFilter.not_set or
                                self.path_reject_reason_exclude_node.yfilter != YFilter.not_set or
                                self.path_reject_reason_exclude_srlg.yfilter != YFilter.not_set or
                                self.path_reject_reason_holddown.yfilter != YFilter.not_set or
                                self.path_reject_reason_hop_limit.yfilter != YFilter.not_set or
                                self.path_reject_reason_ip_addr.yfilter != YFilter.not_set or
                                self.path_reject_reason_ixcd.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_ol_head.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_ol_mid.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_ol_tail.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_ol_unknown.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_unreachable.yfilter != YFilter.not_set or
                                self.path_reject_reason_reverse_bw.yfilter != YFilter.not_set or
                                self.path_reject_reason_reverse_link.yfilter != YFilter.not_set or
                                self.reverse_lsp_id.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "reverse-ero-error-standby" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.ero_reject_reason.is_set or self.ero_reject_reason.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ero_reject_reason.get_name_leafdata())
                            if (self.path_option_index.is_set or self.path_option_index.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_option_index.get_name_leafdata())
                            if (self.path_option_type.is_set or self.path_option_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_option_type.get_name_leafdata())
                            if (self.path_reject_reason_affinity.is_set or self.path_reject_reason_affinity.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_affinity.get_name_leafdata())
                            if (self.path_reject_reason_bw.is_set or self.path_reject_reason_bw.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_bw.get_name_leafdata())
                            if (self.path_reject_reason_exclude_link.is_set or self.path_reject_reason_exclude_link.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_exclude_link.get_name_leafdata())
                            if (self.path_reject_reason_exclude_node.is_set or self.path_reject_reason_exclude_node.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_exclude_node.get_name_leafdata())
                            if (self.path_reject_reason_exclude_srlg.is_set or self.path_reject_reason_exclude_srlg.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_exclude_srlg.get_name_leafdata())
                            if (self.path_reject_reason_holddown.is_set or self.path_reject_reason_holddown.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_holddown.get_name_leafdata())
                            if (self.path_reject_reason_hop_limit.is_set or self.path_reject_reason_hop_limit.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_hop_limit.get_name_leafdata())
                            if (self.path_reject_reason_ip_addr.is_set or self.path_reject_reason_ip_addr.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_ip_addr.get_name_leafdata())
                            if (self.path_reject_reason_ixcd.is_set or self.path_reject_reason_ixcd.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_ixcd.get_name_leafdata())
                            if (self.path_reject_reason_node_ol_head.is_set or self.path_reject_reason_node_ol_head.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_ol_head.get_name_leafdata())
                            if (self.path_reject_reason_node_ol_mid.is_set or self.path_reject_reason_node_ol_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_ol_mid.get_name_leafdata())
                            if (self.path_reject_reason_node_ol_tail.is_set or self.path_reject_reason_node_ol_tail.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_ol_tail.get_name_leafdata())
                            if (self.path_reject_reason_node_ol_unknown.is_set or self.path_reject_reason_node_ol_unknown.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_ol_unknown.get_name_leafdata())
                            if (self.path_reject_reason_node_unreachable.is_set or self.path_reject_reason_node_unreachable.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_unreachable.get_name_leafdata())
                            if (self.path_reject_reason_reverse_bw.is_set or self.path_reject_reason_reverse_bw.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_reverse_bw.get_name_leafdata())
                            if (self.path_reject_reason_reverse_link.is_set or self.path_reject_reason_reverse_link.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_reverse_link.get_name_leafdata())
                            if (self.reverse_lsp_id.is_set or self.reverse_lsp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "path-calculation-error"):
                                for c in self.path_calculation_error:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandby.PathCalculationError()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_calculation_error.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "path-calculation-error" or name == "ero-reject-reason" or name == "path-option-index" or name == "path-option-type" or name == "path-reject-reason-affinity" or name == "path-reject-reason-bw" or name == "path-reject-reason-exclude-link" or name == "path-reject-reason-exclude-node" or name == "path-reject-reason-exclude-srlg" or name == "path-reject-reason-holddown" or name == "path-reject-reason-hop-limit" or name == "path-reject-reason-ip-addr" or name == "path-reject-reason-ixcd" or name == "path-reject-reason-node-ol-head" or name == "path-reject-reason-node-ol-mid" or name == "path-reject-reason-node-ol-tail" or name == "path-reject-reason-node-ol-unknown" or name == "path-reject-reason-node-unreachable" or name == "path-reject-reason-reverse-bw" or name == "path-reject-reason-reverse-link" or name == "reverse-lsp-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "ero-reject-reason"):
                                self.ero_reject_reason = value
                                self.ero_reject_reason.value_namespace = name_space
                                self.ero_reject_reason.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-option-index"):
                                self.path_option_index = value
                                self.path_option_index.value_namespace = name_space
                                self.path_option_index.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-option-type"):
                                self.path_option_type = value
                                self.path_option_type.value_namespace = name_space
                                self.path_option_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-affinity"):
                                self.path_reject_reason_affinity = value
                                self.path_reject_reason_affinity.value_namespace = name_space
                                self.path_reject_reason_affinity.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-bw"):
                                self.path_reject_reason_bw = value
                                self.path_reject_reason_bw.value_namespace = name_space
                                self.path_reject_reason_bw.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-exclude-link"):
                                self.path_reject_reason_exclude_link = value
                                self.path_reject_reason_exclude_link.value_namespace = name_space
                                self.path_reject_reason_exclude_link.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-exclude-node"):
                                self.path_reject_reason_exclude_node = value
                                self.path_reject_reason_exclude_node.value_namespace = name_space
                                self.path_reject_reason_exclude_node.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-exclude-srlg"):
                                self.path_reject_reason_exclude_srlg = value
                                self.path_reject_reason_exclude_srlg.value_namespace = name_space
                                self.path_reject_reason_exclude_srlg.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-holddown"):
                                self.path_reject_reason_holddown = value
                                self.path_reject_reason_holddown.value_namespace = name_space
                                self.path_reject_reason_holddown.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-hop-limit"):
                                self.path_reject_reason_hop_limit = value
                                self.path_reject_reason_hop_limit.value_namespace = name_space
                                self.path_reject_reason_hop_limit.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-ip-addr"):
                                self.path_reject_reason_ip_addr = value
                                self.path_reject_reason_ip_addr.value_namespace = name_space
                                self.path_reject_reason_ip_addr.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-ixcd"):
                                self.path_reject_reason_ixcd = value
                                self.path_reject_reason_ixcd.value_namespace = name_space
                                self.path_reject_reason_ixcd.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-ol-head"):
                                self.path_reject_reason_node_ol_head = value
                                self.path_reject_reason_node_ol_head.value_namespace = name_space
                                self.path_reject_reason_node_ol_head.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-ol-mid"):
                                self.path_reject_reason_node_ol_mid = value
                                self.path_reject_reason_node_ol_mid.value_namespace = name_space
                                self.path_reject_reason_node_ol_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-ol-tail"):
                                self.path_reject_reason_node_ol_tail = value
                                self.path_reject_reason_node_ol_tail.value_namespace = name_space
                                self.path_reject_reason_node_ol_tail.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-ol-unknown"):
                                self.path_reject_reason_node_ol_unknown = value
                                self.path_reject_reason_node_ol_unknown.value_namespace = name_space
                                self.path_reject_reason_node_ol_unknown.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-unreachable"):
                                self.path_reject_reason_node_unreachable = value
                                self.path_reject_reason_node_unreachable.value_namespace = name_space
                                self.path_reject_reason_node_unreachable.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-reverse-bw"):
                                self.path_reject_reason_reverse_bw = value
                                self.path_reject_reason_reverse_bw.value_namespace = name_space
                                self.path_reject_reason_reverse_bw.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-reverse-link"):
                                self.path_reject_reason_reverse_link = value
                                self.path_reject_reason_reverse_link.value_namespace = name_space
                                self.path_reject_reason_reverse_link.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-id"):
                                self.reverse_lsp_id = value
                                self.reverse_lsp_id.value_namespace = name_space
                                self.reverse_lsp_id.value_namespace_prefix = name_space_prefix


                    class ReverseEroErrorStandbyReopt(Entity):
                        """
                        Reverse ERO Error Standby Reopt LSP
                        
                        .. attribute:: ero_reject_reason
                        
                        	Reverse ERO Reject Reason
                        	**type**\:   :py:class:`TeRevEroRejectReasons <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRevEroRejectReasons>`
                        
                        .. attribute:: path_calculation_error
                        
                        	Path Computation Information
                        	**type**\: list of    :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandbyReopt.PathCalculationError>`
                        
                        .. attribute:: path_option_index
                        
                        	Path Option Index
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: path_option_type
                        
                        	Path Option Type
                        	**type**\:   :py:class:`MtePathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MtePathOption>`
                        
                        .. attribute:: path_reject_reason_affinity
                        
                        	Path Reject due to affinity
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_bw
                        
                        	Path Reject due to bw
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_exclude_link
                        
                        	Path Reject due to exclude link
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_exclude_node
                        
                        	Path Reject due to exclude node
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_exclude_srlg
                        
                        	Path Reject due to exclude SRLG
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_holddown
                        
                        	Path Reject due to holddown
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_hop_limit
                        
                        	Path Reject due to hop limit
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_ip_addr
                        
                        	Path Reject due to IP address
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_ixcd
                        
                        	Path Reject due to IXCD
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_ol_head
                        
                        	Path Reject due to head node overload
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_ol_mid
                        
                        	Path Reject due to mid node overload
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_ol_tail
                        
                        	Path Reject due to head node overload
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_ol_unknown
                        
                        	Path Reject due to unknown node overload
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_node_unreachable
                        
                        	Path Reject due to unreachable node
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_reverse_bw
                        
                        	Path Reject due to reverse bw
                        	**type**\:  bool
                        
                        .. attribute:: path_reject_reason_reverse_link
                        
                        	Path Reject due to reverse link
                        	**type**\:  bool
                        
                        .. attribute:: reverse_lsp_id
                        
                        	Reverse LSP ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandbyReopt, self).__init__()

                            self.yang_name = "reverse-ero-error-standby-reopt"
                            self.yang_parent_name = "bidir"

                            self.ero_reject_reason = YLeaf(YType.enumeration, "ero-reject-reason")

                            self.path_option_index = YLeaf(YType.uint16, "path-option-index")

                            self.path_option_type = YLeaf(YType.enumeration, "path-option-type")

                            self.path_reject_reason_affinity = YLeaf(YType.boolean, "path-reject-reason-affinity")

                            self.path_reject_reason_bw = YLeaf(YType.boolean, "path-reject-reason-bw")

                            self.path_reject_reason_exclude_link = YLeaf(YType.boolean, "path-reject-reason-exclude-link")

                            self.path_reject_reason_exclude_node = YLeaf(YType.boolean, "path-reject-reason-exclude-node")

                            self.path_reject_reason_exclude_srlg = YLeaf(YType.boolean, "path-reject-reason-exclude-srlg")

                            self.path_reject_reason_holddown = YLeaf(YType.boolean, "path-reject-reason-holddown")

                            self.path_reject_reason_hop_limit = YLeaf(YType.boolean, "path-reject-reason-hop-limit")

                            self.path_reject_reason_ip_addr = YLeaf(YType.boolean, "path-reject-reason-ip-addr")

                            self.path_reject_reason_ixcd = YLeaf(YType.boolean, "path-reject-reason-ixcd")

                            self.path_reject_reason_node_ol_head = YLeaf(YType.boolean, "path-reject-reason-node-ol-head")

                            self.path_reject_reason_node_ol_mid = YLeaf(YType.boolean, "path-reject-reason-node-ol-mid")

                            self.path_reject_reason_node_ol_tail = YLeaf(YType.boolean, "path-reject-reason-node-ol-tail")

                            self.path_reject_reason_node_ol_unknown = YLeaf(YType.boolean, "path-reject-reason-node-ol-unknown")

                            self.path_reject_reason_node_unreachable = YLeaf(YType.boolean, "path-reject-reason-node-unreachable")

                            self.path_reject_reason_reverse_bw = YLeaf(YType.boolean, "path-reject-reason-reverse-bw")

                            self.path_reject_reason_reverse_link = YLeaf(YType.boolean, "path-reject-reason-reverse-link")

                            self.reverse_lsp_id = YLeaf(YType.uint16, "reverse-lsp-id")

                            self.path_calculation_error = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("ero_reject_reason",
                                            "path_option_index",
                                            "path_option_type",
                                            "path_reject_reason_affinity",
                                            "path_reject_reason_bw",
                                            "path_reject_reason_exclude_link",
                                            "path_reject_reason_exclude_node",
                                            "path_reject_reason_exclude_srlg",
                                            "path_reject_reason_holddown",
                                            "path_reject_reason_hop_limit",
                                            "path_reject_reason_ip_addr",
                                            "path_reject_reason_ixcd",
                                            "path_reject_reason_node_ol_head",
                                            "path_reject_reason_node_ol_mid",
                                            "path_reject_reason_node_ol_tail",
                                            "path_reject_reason_node_ol_unknown",
                                            "path_reject_reason_node_unreachable",
                                            "path_reject_reason_reverse_bw",
                                            "path_reject_reason_reverse_link",
                                            "reverse_lsp_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandbyReopt, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandbyReopt, self).__setattr__(name, value)


                        class PathCalculationError(Entity):
                            """
                            Path Computation Information
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\:  str
                            
                            .. attribute:: log_time
                            
                            	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: lsp_mode
                            
                            	LSP Mode
                            	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandbyReopt.PathCalculationError, self).__init__()

                                self.yang_name = "path-calculation-error"
                                self.yang_parent_name = "reverse-ero-error-standby-reopt"

                                self.error_message = YLeaf(YType.str, "error-message")

                                self.log_time = YLeaf(YType.uint32, "log-time")

                                self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("error_message",
                                                "log_time",
                                                "lsp_mode") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandbyReopt.PathCalculationError, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandbyReopt.PathCalculationError, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.error_message.is_set or
                                    self.log_time.is_set or
                                    self.lsp_mode.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.error_message.yfilter != YFilter.not_set or
                                    self.log_time.yfilter != YFilter.not_set or
                                    self.lsp_mode.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-calculation-error" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.error_message.get_name_leafdata())
                                if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.log_time.get_name_leafdata())
                                if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "error-message"):
                                    self.error_message = value
                                    self.error_message.value_namespace = name_space
                                    self.error_message.value_namespace_prefix = name_space_prefix
                                if(value_path == "log-time"):
                                    self.log_time = value
                                    self.log_time.value_namespace = name_space
                                    self.log_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-mode"):
                                    self.lsp_mode = value
                                    self.lsp_mode.value_namespace = name_space
                                    self.lsp_mode.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.path_calculation_error:
                                if (c.has_data()):
                                    return True
                            return (
                                self.ero_reject_reason.is_set or
                                self.path_option_index.is_set or
                                self.path_option_type.is_set or
                                self.path_reject_reason_affinity.is_set or
                                self.path_reject_reason_bw.is_set or
                                self.path_reject_reason_exclude_link.is_set or
                                self.path_reject_reason_exclude_node.is_set or
                                self.path_reject_reason_exclude_srlg.is_set or
                                self.path_reject_reason_holddown.is_set or
                                self.path_reject_reason_hop_limit.is_set or
                                self.path_reject_reason_ip_addr.is_set or
                                self.path_reject_reason_ixcd.is_set or
                                self.path_reject_reason_node_ol_head.is_set or
                                self.path_reject_reason_node_ol_mid.is_set or
                                self.path_reject_reason_node_ol_tail.is_set or
                                self.path_reject_reason_node_ol_unknown.is_set or
                                self.path_reject_reason_node_unreachable.is_set or
                                self.path_reject_reason_reverse_bw.is_set or
                                self.path_reject_reason_reverse_link.is_set or
                                self.reverse_lsp_id.is_set)

                        def has_operation(self):
                            for c in self.path_calculation_error:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.ero_reject_reason.yfilter != YFilter.not_set or
                                self.path_option_index.yfilter != YFilter.not_set or
                                self.path_option_type.yfilter != YFilter.not_set or
                                self.path_reject_reason_affinity.yfilter != YFilter.not_set or
                                self.path_reject_reason_bw.yfilter != YFilter.not_set or
                                self.path_reject_reason_exclude_link.yfilter != YFilter.not_set or
                                self.path_reject_reason_exclude_node.yfilter != YFilter.not_set or
                                self.path_reject_reason_exclude_srlg.yfilter != YFilter.not_set or
                                self.path_reject_reason_holddown.yfilter != YFilter.not_set or
                                self.path_reject_reason_hop_limit.yfilter != YFilter.not_set or
                                self.path_reject_reason_ip_addr.yfilter != YFilter.not_set or
                                self.path_reject_reason_ixcd.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_ol_head.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_ol_mid.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_ol_tail.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_ol_unknown.yfilter != YFilter.not_set or
                                self.path_reject_reason_node_unreachable.yfilter != YFilter.not_set or
                                self.path_reject_reason_reverse_bw.yfilter != YFilter.not_set or
                                self.path_reject_reason_reverse_link.yfilter != YFilter.not_set or
                                self.reverse_lsp_id.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "reverse-ero-error-standby-reopt" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.ero_reject_reason.is_set or self.ero_reject_reason.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ero_reject_reason.get_name_leafdata())
                            if (self.path_option_index.is_set or self.path_option_index.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_option_index.get_name_leafdata())
                            if (self.path_option_type.is_set or self.path_option_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_option_type.get_name_leafdata())
                            if (self.path_reject_reason_affinity.is_set or self.path_reject_reason_affinity.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_affinity.get_name_leafdata())
                            if (self.path_reject_reason_bw.is_set or self.path_reject_reason_bw.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_bw.get_name_leafdata())
                            if (self.path_reject_reason_exclude_link.is_set or self.path_reject_reason_exclude_link.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_exclude_link.get_name_leafdata())
                            if (self.path_reject_reason_exclude_node.is_set or self.path_reject_reason_exclude_node.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_exclude_node.get_name_leafdata())
                            if (self.path_reject_reason_exclude_srlg.is_set or self.path_reject_reason_exclude_srlg.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_exclude_srlg.get_name_leafdata())
                            if (self.path_reject_reason_holddown.is_set or self.path_reject_reason_holddown.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_holddown.get_name_leafdata())
                            if (self.path_reject_reason_hop_limit.is_set or self.path_reject_reason_hop_limit.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_hop_limit.get_name_leafdata())
                            if (self.path_reject_reason_ip_addr.is_set or self.path_reject_reason_ip_addr.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_ip_addr.get_name_leafdata())
                            if (self.path_reject_reason_ixcd.is_set or self.path_reject_reason_ixcd.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_ixcd.get_name_leafdata())
                            if (self.path_reject_reason_node_ol_head.is_set or self.path_reject_reason_node_ol_head.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_ol_head.get_name_leafdata())
                            if (self.path_reject_reason_node_ol_mid.is_set or self.path_reject_reason_node_ol_mid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_ol_mid.get_name_leafdata())
                            if (self.path_reject_reason_node_ol_tail.is_set or self.path_reject_reason_node_ol_tail.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_ol_tail.get_name_leafdata())
                            if (self.path_reject_reason_node_ol_unknown.is_set or self.path_reject_reason_node_ol_unknown.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_ol_unknown.get_name_leafdata())
                            if (self.path_reject_reason_node_unreachable.is_set or self.path_reject_reason_node_unreachable.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_node_unreachable.get_name_leafdata())
                            if (self.path_reject_reason_reverse_bw.is_set or self.path_reject_reason_reverse_bw.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_reverse_bw.get_name_leafdata())
                            if (self.path_reject_reason_reverse_link.is_set or self.path_reject_reason_reverse_link.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_reject_reason_reverse_link.get_name_leafdata())
                            if (self.reverse_lsp_id.is_set or self.reverse_lsp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "path-calculation-error"):
                                for c in self.path_calculation_error:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandbyReopt.PathCalculationError()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_calculation_error.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "path-calculation-error" or name == "ero-reject-reason" or name == "path-option-index" or name == "path-option-type" or name == "path-reject-reason-affinity" or name == "path-reject-reason-bw" or name == "path-reject-reason-exclude-link" or name == "path-reject-reason-exclude-node" or name == "path-reject-reason-exclude-srlg" or name == "path-reject-reason-holddown" or name == "path-reject-reason-hop-limit" or name == "path-reject-reason-ip-addr" or name == "path-reject-reason-ixcd" or name == "path-reject-reason-node-ol-head" or name == "path-reject-reason-node-ol-mid" or name == "path-reject-reason-node-ol-tail" or name == "path-reject-reason-node-ol-unknown" or name == "path-reject-reason-node-unreachable" or name == "path-reject-reason-reverse-bw" or name == "path-reject-reason-reverse-link" or name == "reverse-lsp-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "ero-reject-reason"):
                                self.ero_reject_reason = value
                                self.ero_reject_reason.value_namespace = name_space
                                self.ero_reject_reason.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-option-index"):
                                self.path_option_index = value
                                self.path_option_index.value_namespace = name_space
                                self.path_option_index.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-option-type"):
                                self.path_option_type = value
                                self.path_option_type.value_namespace = name_space
                                self.path_option_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-affinity"):
                                self.path_reject_reason_affinity = value
                                self.path_reject_reason_affinity.value_namespace = name_space
                                self.path_reject_reason_affinity.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-bw"):
                                self.path_reject_reason_bw = value
                                self.path_reject_reason_bw.value_namespace = name_space
                                self.path_reject_reason_bw.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-exclude-link"):
                                self.path_reject_reason_exclude_link = value
                                self.path_reject_reason_exclude_link.value_namespace = name_space
                                self.path_reject_reason_exclude_link.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-exclude-node"):
                                self.path_reject_reason_exclude_node = value
                                self.path_reject_reason_exclude_node.value_namespace = name_space
                                self.path_reject_reason_exclude_node.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-exclude-srlg"):
                                self.path_reject_reason_exclude_srlg = value
                                self.path_reject_reason_exclude_srlg.value_namespace = name_space
                                self.path_reject_reason_exclude_srlg.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-holddown"):
                                self.path_reject_reason_holddown = value
                                self.path_reject_reason_holddown.value_namespace = name_space
                                self.path_reject_reason_holddown.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-hop-limit"):
                                self.path_reject_reason_hop_limit = value
                                self.path_reject_reason_hop_limit.value_namespace = name_space
                                self.path_reject_reason_hop_limit.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-ip-addr"):
                                self.path_reject_reason_ip_addr = value
                                self.path_reject_reason_ip_addr.value_namespace = name_space
                                self.path_reject_reason_ip_addr.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-ixcd"):
                                self.path_reject_reason_ixcd = value
                                self.path_reject_reason_ixcd.value_namespace = name_space
                                self.path_reject_reason_ixcd.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-ol-head"):
                                self.path_reject_reason_node_ol_head = value
                                self.path_reject_reason_node_ol_head.value_namespace = name_space
                                self.path_reject_reason_node_ol_head.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-ol-mid"):
                                self.path_reject_reason_node_ol_mid = value
                                self.path_reject_reason_node_ol_mid.value_namespace = name_space
                                self.path_reject_reason_node_ol_mid.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-ol-tail"):
                                self.path_reject_reason_node_ol_tail = value
                                self.path_reject_reason_node_ol_tail.value_namespace = name_space
                                self.path_reject_reason_node_ol_tail.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-ol-unknown"):
                                self.path_reject_reason_node_ol_unknown = value
                                self.path_reject_reason_node_ol_unknown.value_namespace = name_space
                                self.path_reject_reason_node_ol_unknown.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-node-unreachable"):
                                self.path_reject_reason_node_unreachable = value
                                self.path_reject_reason_node_unreachable.value_namespace = name_space
                                self.path_reject_reason_node_unreachable.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-reverse-bw"):
                                self.path_reject_reason_reverse_bw = value
                                self.path_reject_reason_reverse_bw.value_namespace = name_space
                                self.path_reject_reason_reverse_bw.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-reject-reason-reverse-link"):
                                self.path_reject_reason_reverse_link = value
                                self.path_reject_reason_reverse_link.value_namespace = name_space
                                self.path_reject_reason_reverse_link.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-id"):
                                self.reverse_lsp_id = value
                                self.reverse_lsp_id.value_namespace = name_space
                                self.reverse_lsp_id.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.reverse_bandwidth.is_set or
                            self.reverse_bandwidth_standby.is_set or
                            (self.reverse_ero_error_current is not None and self.reverse_ero_error_current.has_data()) or
                            (self.reverse_ero_error_reopt is not None and self.reverse_ero_error_reopt.has_data()) or
                            (self.reverse_ero_error_standby is not None and self.reverse_ero_error_standby.has_data()) or
                            (self.reverse_ero_error_standby_reopt is not None and self.reverse_ero_error_standby_reopt.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.reverse_bandwidth.yfilter != YFilter.not_set or
                            self.reverse_bandwidth_standby.yfilter != YFilter.not_set or
                            (self.reverse_ero_error_current is not None and self.reverse_ero_error_current.has_operation()) or
                            (self.reverse_ero_error_reopt is not None and self.reverse_ero_error_reopt.has_operation()) or
                            (self.reverse_ero_error_standby is not None and self.reverse_ero_error_standby.has_operation()) or
                            (self.reverse_ero_error_standby_reopt is not None and self.reverse_ero_error_standby_reopt.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "bidir" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.reverse_bandwidth.is_set or self.reverse_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reverse_bandwidth.get_name_leafdata())
                        if (self.reverse_bandwidth_standby.is_set or self.reverse_bandwidth_standby.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reverse_bandwidth_standby.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "reverse-ero-error-current"):
                            if (self.reverse_ero_error_current is None):
                                self.reverse_ero_error_current = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorCurrent()
                                self.reverse_ero_error_current.parent = self
                                self._children_name_map["reverse_ero_error_current"] = "reverse-ero-error-current"
                            return self.reverse_ero_error_current

                        if (child_yang_name == "reverse-ero-error-reopt"):
                            if (self.reverse_ero_error_reopt is None):
                                self.reverse_ero_error_reopt = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorReopt()
                                self.reverse_ero_error_reopt.parent = self
                                self._children_name_map["reverse_ero_error_reopt"] = "reverse-ero-error-reopt"
                            return self.reverse_ero_error_reopt

                        if (child_yang_name == "reverse-ero-error-standby"):
                            if (self.reverse_ero_error_standby is None):
                                self.reverse_ero_error_standby = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandby()
                                self.reverse_ero_error_standby.parent = self
                                self._children_name_map["reverse_ero_error_standby"] = "reverse-ero-error-standby"
                            return self.reverse_ero_error_standby

                        if (child_yang_name == "reverse-ero-error-standby-reopt"):
                            if (self.reverse_ero_error_standby_reopt is None):
                                self.reverse_ero_error_standby_reopt = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir.ReverseEroErrorStandbyReopt()
                                self.reverse_ero_error_standby_reopt.parent = self
                                self._children_name_map["reverse_ero_error_standby_reopt"] = "reverse-ero-error-standby-reopt"
                            return self.reverse_ero_error_standby_reopt

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "reverse-ero-error-current" or name == "reverse-ero-error-reopt" or name == "reverse-ero-error-standby" or name == "reverse-ero-error-standby-reopt" or name == "reverse-bandwidth" or name == "reverse-bandwidth-standby"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "reverse-bandwidth"):
                            self.reverse_bandwidth = value
                            self.reverse_bandwidth.value_namespace = name_space
                            self.reverse_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "reverse-bandwidth-standby"):
                            self.reverse_bandwidth_standby = value
                            self.reverse_bandwidth_standby.value_namespace = name_space
                            self.reverse_bandwidth_standby.value_namespace_prefix = name_space_prefix


                class XroAttributeSet(Entity):
                    """
                    XRO attribute\-set
                    
                    .. attribute:: attribute_set_union
                    
                    	Union of Attribute Sets
                    	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion>`
                    
                    .. attribute:: tunnel_attribute_set_name
                    
                    	Attribute Set Name
                    	**type**\:  str
                    
                    .. attribute:: tunnel_attribute_set_name_crc32
                    
                    	Attribute Set name CRC32 value
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet, self).__init__()

                        self.yang_name = "xro-attribute-set"
                        self.yang_parent_name = "tunnel-head"

                        self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                        self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                        self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion()
                        self.attribute_set_union.parent = self
                        self._children_name_map["attribute_set_union"] = "attribute-set-union"
                        self._children_yang_names.add("attribute-set-union")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("tunnel_attribute_set_name",
                                        "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet, self).__setattr__(name, value)


                    class AttributeSetUnion(Entity):
                        """
                        Union of Attribute Sets
                        
                        .. attribute:: attribute_set_aps_pp
                        
                        	Attribute Set OTN APS Path Protection
                        	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                        
                        .. attribute:: attribute_set_autobackup
                        
                        	MPLS TE Auto\-backup Attribute Set
                        	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                        
                        .. attribute:: attribute_set_automesh
                        
                        	MPLS TE Auto\-mesh Attribute Set
                        	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                        
                        .. attribute:: attribute_set_p2mpte
                        
                        	MPLS TE P2MP\-TE Attribute Set
                        	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                        
                        .. attribute:: attribute_set_p2p_te
                        
                        	MPLS TE P2P\-TE Attribute Set
                        	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                        
                        .. attribute:: attribute_set_path_option
                        
                        	MPLS TE Path Option Attribute Set
                        	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                        
                        .. attribute:: attribute_set_xro
                        
                        	Attribute Set XRO
                        	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                        
                        .. attribute:: tunnel_attribute_set_type
                        
                        	TunnelAttributeSetType
                        	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion, self).__init__()

                            self.yang_name = "attribute-set-union"
                            self.yang_parent_name = "xro-attribute-set"

                            self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                            self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                            self.attribute_set_aps_pp.parent = self
                            self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                            self._children_yang_names.add("attribute-set-aps-pp")

                            self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                            self.attribute_set_autobackup.parent = self
                            self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                            self._children_yang_names.add("attribute-set-autobackup")

                            self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                            self.attribute_set_automesh.parent = self
                            self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                            self._children_yang_names.add("attribute-set-automesh")

                            self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                            self.attribute_set_p2mpte.parent = self
                            self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                            self._children_yang_names.add("attribute-set-p2mpte")

                            self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                            self.attribute_set_p2p_te.parent = self
                            self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                            self._children_yang_names.add("attribute-set-p2p-te")

                            self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                            self.attribute_set_path_option.parent = self
                            self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                            self._children_yang_names.add("attribute-set-path-option")

                            self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                            self.attribute_set_xro.parent = self
                            self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                            self._children_yang_names.add("attribute-set-xro")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                        class AttributeSetPathOption(Entity):
                            """
                            MPLS TE Path Option Attribute Set
                            
                            .. attribute:: affinity
                            
                            	Affinity
                            	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                            
                            .. attribute:: bandwidth_type
                            
                            	The bandwidth type
                            	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                            
                            .. attribute:: bfd_reverse_path
                            
                            	BFD reverse path
                            	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                            
                            .. attribute:: configured_bandwidth
                            
                            	Bandwidth value in kbps
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: cost_limit
                            
                            	Cost limit on the tunnel path
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: dste_class_type
                            
                            	DSTE Class
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: exclude_list_name
                            
                            	Exclude list name
                            	**type**\:  str
                            
                            .. attribute:: generation
                            
                            	Generation
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: is_affinity_configured
                            
                            	Is affinity configured
                            	**type**\:  bool
                            
                            .. attribute:: is_bandwidth_configured
                            
                            	Is bandwidth configured
                            	**type**\:  bool
                            
                            .. attribute:: is_bfd_reverse_pat_configured
                            
                            	Is BFD reverse path configured
                            	**type**\:  bool
                            
                            .. attribute:: is_cost_limit_configured
                            
                            	Is Cost Limit configured
                            	**type**\:  bool
                            
                            .. attribute:: is_exclude_list_name_configured
                            
                            	Is exclude list name configured
                            	**type**\:  bool
                            
                            .. attribute:: is_path_invalidation_action_configured
                            
                            	Is path invalidation action configured
                            	**type**\:  bool
                            
                            .. attribute:: is_path_invalidation_timeout_configured
                            
                            	Is path invalidation timeout configured
                            	**type**\:  bool
                            
                            .. attribute:: is_pce_configured
                            
                            	Is PCE Configured
                            	**type**\:  bool
                            
                            .. attribute:: is_pce_disj_group_id_configured
                            
                            	Is PCE Disjoint Path Group ID Configured
                            	**type**\:  bool
                            
                            .. attribute:: is_pce_disj_source_configured
                            
                            	Is PCE Disjoint Path Source Configured
                            	**type**\:  bool
                            
                            .. attribute:: is_pce_disj_type_configured
                            
                            	Is PCE Disjoint Path Type Configured
                            	**type**\:  bool
                            
                            .. attribute:: is_pceb_dj_source_configured
                            
                            	Is PCE Bidirectional Source Configured
                            	**type**\:  bool
                            
                            .. attribute:: is_pcebd_group_id_configured
                            
                            	Is PCE Bidirectional Group ID Configured
                            	**type**\:  bool
                            
                            .. attribute:: path_invalidation_action
                            
                            	Path invalidation action
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: path_invalidation_timeout
                            
                            	Path invalidation interval on the tunnel path
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: pcebd_group_id
                            
                            	PCE Bidirectional Group ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: pcebd_source_address
                            
                            	PCE Bidirectional Source Address
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: pcedp_group_id
                            
                            	PCE Disjoint Path Group ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: pcedp_source_address
                            
                            	PCE Disjoint Path Source Address
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: pcedp_type
                            
                            	PCE Disjoint Path Type
                            	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                            
                            .. attribute:: tunnel_id
                            
                            	Tunnel ID
                            	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                            
                            .. attribute:: version_info
                            
                            	Version Info
                            	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                self.yang_name = "attribute-set-path-option"
                                self.yang_parent_name = "attribute-set-union"

                                self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                self.generation = YLeaf(YType.uint32, "generation")

                                self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                self.affinity.parent = self
                                self._children_name_map["affinity"] = "affinity"
                                self._children_yang_names.add("affinity")

                                self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                self.bfd_reverse_path.parent = self
                                self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                self._children_yang_names.add("bfd-reverse-path")

                                self.tunnel_id = YList(self)
                                self.version_info = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("bandwidth_type",
                                                "configured_bandwidth",
                                                "cost_limit",
                                                "dste_class_type",
                                                "exclude_list_name",
                                                "generation",
                                                "is_affinity_configured",
                                                "is_bandwidth_configured",
                                                "is_bfd_reverse_pat_configured",
                                                "is_cost_limit_configured",
                                                "is_exclude_list_name_configured",
                                                "is_path_invalidation_action_configured",
                                                "is_path_invalidation_timeout_configured",
                                                "is_pce_configured",
                                                "is_pce_disj_group_id_configured",
                                                "is_pce_disj_source_configured",
                                                "is_pce_disj_type_configured",
                                                "is_pceb_dj_source_configured",
                                                "is_pcebd_group_id_configured",
                                                "path_invalidation_action",
                                                "path_invalidation_timeout",
                                                "pcebd_group_id",
                                                "pcebd_source_address",
                                                "pcedp_group_id",
                                                "pcedp_source_address",
                                                "pcedp_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                            class Affinity(Entity):
                                """
                                Affinity
                                
                                .. attribute:: affinity_bits
                                
                                	The affinity bits (colors)
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: affinity_mask
                                
                                	The affinity mask (colors)
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: named_affinity
                                
                                	Array of name based constratints currently applied to the tunnel
                                	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                    self.yang_name = "affinity"
                                    self.yang_parent_name = "attribute-set-path-option"

                                    self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                    self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                    self.named_affinity = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("affinity_bits",
                                                    "affinity_mask") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                class NamedAffinity(Entity):
                                    """
                                    Array of name based constratints currently
                                    applied to the tunnel
                                    
                                    .. attribute:: constraint_extended_value
                                    
                                    	Constraint value
                                    	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                    
                                    .. attribute:: constraint_type
                                    
                                    	Constraint type
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: constraint_value
                                    
                                    	Deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: extended_forward_ref_value
                                    
                                    	Reference bits for undefined affinity names
                                    	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                    
                                    .. attribute:: forward_ref_value
                                    
                                    	Deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                        self.yang_name = "named-affinity"
                                        self.yang_parent_name = "affinity"

                                        self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                        self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                        self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                        self.constraint_extended_value = YList(self)
                                        self.extended_forward_ref_value = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("constraint_type",
                                                        "constraint_value",
                                                        "forward_ref_value") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                    class ConstraintExtendedValue(Entity):
                                        """
                                        Constraint value
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                            self.yang_name = "constraint-extended-value"
                                            self.yang_parent_name = "named-affinity"

                                            self.entry = YLeaf(YType.uint32, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "constraint-extended-value" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class ExtendedForwardRefValue(Entity):
                                        """
                                        Reference bits for undefined affinity names
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                            self.yang_name = "extended-forward-ref-value"
                                            self.yang_parent_name = "named-affinity"

                                            self.entry = YLeaf(YType.uint32, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "extended-forward-ref-value" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.constraint_extended_value:
                                            if (c.has_data()):
                                                return True
                                        for c in self.extended_forward_ref_value:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.constraint_type.is_set or
                                            self.constraint_value.is_set or
                                            self.forward_ref_value.is_set)

                                    def has_operation(self):
                                        for c in self.constraint_extended_value:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.extended_forward_ref_value:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.constraint_type.yfilter != YFilter.not_set or
                                            self.constraint_value.yfilter != YFilter.not_set or
                                            self.forward_ref_value.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "named-affinity" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                        if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                        if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "constraint-extended-value"):
                                            for c in self.constraint_extended_value:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.constraint_extended_value.append(c)
                                            return c

                                        if (child_yang_name == "extended-forward-ref-value"):
                                            for c in self.extended_forward_ref_value:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.extended_forward_ref_value.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "constraint-type"):
                                            self.constraint_type = value
                                            self.constraint_type.value_namespace = name_space
                                            self.constraint_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "constraint-value"):
                                            self.constraint_value = value
                                            self.constraint_value.value_namespace = name_space
                                            self.constraint_value.value_namespace_prefix = name_space_prefix
                                        if(value_path == "forward-ref-value"):
                                            self.forward_ref_value = value
                                            self.forward_ref_value.value_namespace = name_space
                                            self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.named_affinity:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.affinity_bits.is_set or
                                        self.affinity_mask.is_set)

                                def has_operation(self):
                                    for c in self.named_affinity:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.affinity_bits.yfilter != YFilter.not_set or
                                        self.affinity_mask.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "affinity" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                    if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "named-affinity"):
                                        for c in self.named_affinity:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.named_affinity.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "affinity-bits"):
                                        self.affinity_bits = value
                                        self.affinity_bits.value_namespace = name_space
                                        self.affinity_bits.value_namespace_prefix = name_space_prefix
                                    if(value_path == "affinity-mask"):
                                        self.affinity_mask = value
                                        self.affinity_mask.value_namespace = name_space
                                        self.affinity_mask.value_namespace_prefix = name_space_prefix


                            class BfdReversePath(Entity):
                                """
                                BFD reverse path
                                
                                .. attribute:: binding_label
                                
                                	BFD reverse path binding label
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: path_type
                                
                                	BFD reverse path type
                                	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                    self.yang_name = "bfd-reverse-path"
                                    self.yang_parent_name = "attribute-set-path-option"

                                    self.binding_label = YLeaf(YType.uint32, "binding-label")

                                    self.path_type = YLeaf(YType.enumeration, "path-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("binding_label",
                                                    "path_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.binding_label.is_set or
                                        self.path_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.binding_label.yfilter != YFilter.not_set or
                                        self.path_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "bfd-reverse-path" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.binding_label.get_name_leafdata())
                                    if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.path_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "binding-label" or name == "path-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "binding-label"):
                                        self.binding_label = value
                                        self.binding_label.value_namespace = name_space
                                        self.binding_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "path-type"):
                                        self.path_type = value
                                        self.path_type.value_namespace = name_space
                                        self.path_type.value_namespace_prefix = name_space_prefix


                            class TunnelId(Entity):
                                """
                                Tunnel ID
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                    self.yang_name = "tunnel-id"
                                    self.yang_parent_name = "attribute-set-path-option"

                                    self.entry = YLeaf(YType.uint16, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "tunnel-id" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix


                            class VersionInfo(Entity):
                                """
                                Version Info
                                
                                .. attribute:: attribute_type
                                
                                	Attribute Type
                                	**type**\:  str
                                
                                .. attribute:: generation
                                
                                	Generation
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: is_default
                                
                                	Is default
                                	**type**\:  bool
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                    self.yang_name = "version-info"
                                    self.yang_parent_name = "attribute-set-path-option"

                                    self.attribute_type = YLeaf(YType.str, "attribute-type")

                                    self.generation = YLeaf(YType.uint32, "generation")

                                    self.is_default = YLeaf(YType.boolean, "is-default")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("attribute_type",
                                                    "generation",
                                                    "is_default") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.attribute_type.is_set or
                                        self.generation.is_set or
                                        self.is_default.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.attribute_type.yfilter != YFilter.not_set or
                                        self.generation.yfilter != YFilter.not_set or
                                        self.is_default.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "version-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                    if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.generation.get_name_leafdata())
                                    if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_default.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "attribute-type"):
                                        self.attribute_type = value
                                        self.attribute_type.value_namespace = name_space
                                        self.attribute_type.value_namespace_prefix = name_space_prefix
                                    if(value_path == "generation"):
                                        self.generation = value
                                        self.generation.value_namespace = name_space
                                        self.generation.value_namespace_prefix = name_space_prefix
                                    if(value_path == "is-default"):
                                        self.is_default = value
                                        self.is_default.value_namespace = name_space
                                        self.is_default.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.tunnel_id:
                                    if (c.has_data()):
                                        return True
                                for c in self.version_info:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.bandwidth_type.is_set or
                                    self.configured_bandwidth.is_set or
                                    self.cost_limit.is_set or
                                    self.dste_class_type.is_set or
                                    self.exclude_list_name.is_set or
                                    self.generation.is_set or
                                    self.is_affinity_configured.is_set or
                                    self.is_bandwidth_configured.is_set or
                                    self.is_bfd_reverse_pat_configured.is_set or
                                    self.is_cost_limit_configured.is_set or
                                    self.is_exclude_list_name_configured.is_set or
                                    self.is_path_invalidation_action_configured.is_set or
                                    self.is_path_invalidation_timeout_configured.is_set or
                                    self.is_pce_configured.is_set or
                                    self.is_pce_disj_group_id_configured.is_set or
                                    self.is_pce_disj_source_configured.is_set or
                                    self.is_pce_disj_type_configured.is_set or
                                    self.is_pceb_dj_source_configured.is_set or
                                    self.is_pcebd_group_id_configured.is_set or
                                    self.path_invalidation_action.is_set or
                                    self.path_invalidation_timeout.is_set or
                                    self.pcebd_group_id.is_set or
                                    self.pcebd_source_address.is_set or
                                    self.pcedp_group_id.is_set or
                                    self.pcedp_source_address.is_set or
                                    self.pcedp_type.is_set or
                                    (self.affinity is not None and self.affinity.has_data()) or
                                    (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                            def has_operation(self):
                                for c in self.tunnel_id:
                                    if (c.has_operation()):
                                        return True
                                for c in self.version_info:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.bandwidth_type.yfilter != YFilter.not_set or
                                    self.configured_bandwidth.yfilter != YFilter.not_set or
                                    self.cost_limit.yfilter != YFilter.not_set or
                                    self.dste_class_type.yfilter != YFilter.not_set or
                                    self.exclude_list_name.yfilter != YFilter.not_set or
                                    self.generation.yfilter != YFilter.not_set or
                                    self.is_affinity_configured.yfilter != YFilter.not_set or
                                    self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                    self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                    self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                    self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                    self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                    self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                    self.is_pce_configured.yfilter != YFilter.not_set or
                                    self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                    self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                    self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                    self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                    self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                    self.path_invalidation_action.yfilter != YFilter.not_set or
                                    self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                    self.pcebd_group_id.yfilter != YFilter.not_set or
                                    self.pcebd_source_address.yfilter != YFilter.not_set or
                                    self.pcedp_group_id.yfilter != YFilter.not_set or
                                    self.pcedp_source_address.yfilter != YFilter.not_set or
                                    self.pcedp_type.yfilter != YFilter.not_set or
                                    (self.affinity is not None and self.affinity.has_operation()) or
                                    (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "attribute-set-path-option" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.generation.get_name_leafdata())
                                if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "affinity"):
                                    if (self.affinity is None):
                                        self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                    return self.affinity

                                if (child_yang_name == "bfd-reverse-path"):
                                    if (self.bfd_reverse_path is None):
                                        self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                        self.bfd_reverse_path.parent = self
                                        self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                    return self.bfd_reverse_path

                                if (child_yang_name == "tunnel-id"):
                                    for c in self.tunnel_id:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.tunnel_id.append(c)
                                    return c

                                if (child_yang_name == "version-info"):
                                    for c in self.version_info:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.version_info.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "bandwidth-type"):
                                    self.bandwidth_type = value
                                    self.bandwidth_type.value_namespace = name_space
                                    self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "configured-bandwidth"):
                                    self.configured_bandwidth = value
                                    self.configured_bandwidth.value_namespace = name_space
                                    self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                if(value_path == "cost-limit"):
                                    self.cost_limit = value
                                    self.cost_limit.value_namespace = name_space
                                    self.cost_limit.value_namespace_prefix = name_space_prefix
                                if(value_path == "dste-class-type"):
                                    self.dste_class_type = value
                                    self.dste_class_type.value_namespace = name_space
                                    self.dste_class_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "exclude-list-name"):
                                    self.exclude_list_name = value
                                    self.exclude_list_name.value_namespace = name_space
                                    self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "generation"):
                                    self.generation = value
                                    self.generation.value_namespace = name_space
                                    self.generation.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-affinity-configured"):
                                    self.is_affinity_configured = value
                                    self.is_affinity_configured.value_namespace = name_space
                                    self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-bandwidth-configured"):
                                    self.is_bandwidth_configured = value
                                    self.is_bandwidth_configured.value_namespace = name_space
                                    self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-bfd-reverse-pat-configured"):
                                    self.is_bfd_reverse_pat_configured = value
                                    self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                    self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-cost-limit-configured"):
                                    self.is_cost_limit_configured = value
                                    self.is_cost_limit_configured.value_namespace = name_space
                                    self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-exclude-list-name-configured"):
                                    self.is_exclude_list_name_configured = value
                                    self.is_exclude_list_name_configured.value_namespace = name_space
                                    self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-path-invalidation-action-configured"):
                                    self.is_path_invalidation_action_configured = value
                                    self.is_path_invalidation_action_configured.value_namespace = name_space
                                    self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-path-invalidation-timeout-configured"):
                                    self.is_path_invalidation_timeout_configured = value
                                    self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                    self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-pce-configured"):
                                    self.is_pce_configured = value
                                    self.is_pce_configured.value_namespace = name_space
                                    self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-pce-disj-group-id-configured"):
                                    self.is_pce_disj_group_id_configured = value
                                    self.is_pce_disj_group_id_configured.value_namespace = name_space
                                    self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-pce-disj-source-configured"):
                                    self.is_pce_disj_source_configured = value
                                    self.is_pce_disj_source_configured.value_namespace = name_space
                                    self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-pce-disj-type-configured"):
                                    self.is_pce_disj_type_configured = value
                                    self.is_pce_disj_type_configured.value_namespace = name_space
                                    self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-pceb-dj-source-configured"):
                                    self.is_pceb_dj_source_configured = value
                                    self.is_pceb_dj_source_configured.value_namespace = name_space
                                    self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-pcebd-group-id-configured"):
                                    self.is_pcebd_group_id_configured = value
                                    self.is_pcebd_group_id_configured.value_namespace = name_space
                                    self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-invalidation-action"):
                                    self.path_invalidation_action = value
                                    self.path_invalidation_action.value_namespace = name_space
                                    self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-invalidation-timeout"):
                                    self.path_invalidation_timeout = value
                                    self.path_invalidation_timeout.value_namespace = name_space
                                    self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                if(value_path == "pcebd-group-id"):
                                    self.pcebd_group_id = value
                                    self.pcebd_group_id.value_namespace = name_space
                                    self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "pcebd-source-address"):
                                    self.pcebd_source_address = value
                                    self.pcebd_source_address.value_namespace = name_space
                                    self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "pcedp-group-id"):
                                    self.pcedp_group_id = value
                                    self.pcedp_group_id.value_namespace = name_space
                                    self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "pcedp-source-address"):
                                    self.pcedp_source_address = value
                                    self.pcedp_source_address.value_namespace = name_space
                                    self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "pcedp-type"):
                                    self.pcedp_type = value
                                    self.pcedp_type.value_namespace = name_space
                                    self.pcedp_type.value_namespace_prefix = name_space_prefix


                        class AttributeSetAutobackup(Entity):
                            """
                            MPLS TE Auto\-backup Attribute Set
                            
                            .. attribute:: affinity
                            
                            	Affinity
                            	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                            
                            .. attribute:: hold_priority
                            
                            	Hold priority
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: is_affinity_configured
                            
                            	Is affinity configured
                            	**type**\:  bool
                            
                            .. attribute:: is_policyclass_configured
                            
                            	Is policy class configured
                            	**type**\:  bool
                            
                            .. attribute:: is_priority_configured
                            
                            	Is priority configured
                            	**type**\:  bool
                            
                            .. attribute:: is_signalled_name_configured
                            
                            	Is signalled name configured
                            	**type**\:  bool
                            
                            .. attribute:: logging
                            
                            	Logging attributes
                            	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                            
                            .. attribute:: policy_class
                            
                            	deprecated
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: policy_class_entry
                            
                            	PBTS policy classes
                            	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                            
                            .. attribute:: protected_interface
                            
                            	Array of Protected Interface Names
                            	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                            
                            .. attribute:: record_route
                            
                            	Record route
                            	**type**\:  bool
                            
                            .. attribute:: setup_priority
                            
                            	Setup priority
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: signalled_name
                            
                            	Signalled name
                            	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                            
                            .. attribute:: tunnel_id
                            
                            	Tunnel ID
                            	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                self.yang_name = "attribute-set-autobackup"
                                self.yang_parent_name = "attribute-set-union"

                                self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                self.policy_class = YLeaf(YType.uint8, "policy-class")

                                self.record_route = YLeaf(YType.boolean, "record-route")

                                self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                self.affinity.parent = self
                                self._children_name_map["affinity"] = "affinity"
                                self._children_yang_names.add("affinity")

                                self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                self.logging.parent = self
                                self._children_name_map["logging"] = "logging"
                                self._children_yang_names.add("logging")

                                self.signalled_name = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                self.signalled_name.parent = self
                                self._children_name_map["signalled_name"] = "signalled-name"
                                self._children_yang_names.add("signalled-name")

                                self.policy_class_entry = YList(self)
                                self.protected_interface = YList(self)
                                self.tunnel_id = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("hold_priority",
                                                "is_affinity_configured",
                                                "is_policyclass_configured",
                                                "is_priority_configured",
                                                "is_signalled_name_configured",
                                                "policy_class",
                                                "record_route",
                                                "setup_priority") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                            class SignalledName(Entity):
                                """
                                Signalled name
                                
                                .. attribute:: is_mp_addresses
                                
                                	MP address appended
                                	**type**\:  bool
                                
                                .. attribute:: name
                                
                                	Signalled name
                                	**type**\:  str
                                
                                .. attribute:: protected_interface_type
                                
                                	Protected interface address or name
                                	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                
                                .. attribute:: source_type
                                
                                	Source address or name
                                	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                    self.yang_name = "signalled-name"
                                    self.yang_parent_name = "attribute-set-autobackup"

                                    self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                    self.name = YLeaf(YType.str, "name")

                                    self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                    self.source_type = YLeaf(YType.enumeration, "source-type")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("is_mp_addresses",
                                                    "name",
                                                    "protected_interface_type",
                                                    "source_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.is_mp_addresses.is_set or
                                        self.name.is_set or
                                        self.protected_interface_type.is_set or
                                        self.source_type.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.is_mp_addresses.yfilter != YFilter.not_set or
                                        self.name.yfilter != YFilter.not_set or
                                        self.protected_interface_type.yfilter != YFilter.not_set or
                                        self.source_type.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "signalled-name" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                    if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.name.get_name_leafdata())
                                    if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                    if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.source_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "is-mp-addresses"):
                                        self.is_mp_addresses = value
                                        self.is_mp_addresses.value_namespace = name_space
                                        self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                    if(value_path == "name"):
                                        self.name = value
                                        self.name.value_namespace = name_space
                                        self.name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "protected-interface-type"):
                                        self.protected_interface_type = value
                                        self.protected_interface_type.value_namespace = name_space
                                        self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                    if(value_path == "source-type"):
                                        self.source_type = value
                                        self.source_type.value_namespace = name_space
                                        self.source_type.value_namespace_prefix = name_space_prefix


                            class Affinity(Entity):
                                """
                                Affinity
                                
                                .. attribute:: affinity_bits
                                
                                	The affinity bits (colors)
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: affinity_mask
                                
                                	The affinity mask (colors)
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: named_affinity
                                
                                	Array of name based constratints currently applied to the tunnel
                                	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                    self.yang_name = "affinity"
                                    self.yang_parent_name = "attribute-set-autobackup"

                                    self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                    self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                    self.named_affinity = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("affinity_bits",
                                                    "affinity_mask") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                class NamedAffinity(Entity):
                                    """
                                    Array of name based constratints currently
                                    applied to the tunnel
                                    
                                    .. attribute:: constraint_extended_value
                                    
                                    	Constraint value
                                    	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                    
                                    .. attribute:: constraint_type
                                    
                                    	Constraint type
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: constraint_value
                                    
                                    	Deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: extended_forward_ref_value
                                    
                                    	Reference bits for undefined affinity names
                                    	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                    
                                    .. attribute:: forward_ref_value
                                    
                                    	Deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                        self.yang_name = "named-affinity"
                                        self.yang_parent_name = "affinity"

                                        self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                        self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                        self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                        self.constraint_extended_value = YList(self)
                                        self.extended_forward_ref_value = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("constraint_type",
                                                        "constraint_value",
                                                        "forward_ref_value") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                    class ConstraintExtendedValue(Entity):
                                        """
                                        Constraint value
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                            self.yang_name = "constraint-extended-value"
                                            self.yang_parent_name = "named-affinity"

                                            self.entry = YLeaf(YType.uint32, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "constraint-extended-value" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class ExtendedForwardRefValue(Entity):
                                        """
                                        Reference bits for undefined affinity names
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                            self.yang_name = "extended-forward-ref-value"
                                            self.yang_parent_name = "named-affinity"

                                            self.entry = YLeaf(YType.uint32, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "extended-forward-ref-value" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.constraint_extended_value:
                                            if (c.has_data()):
                                                return True
                                        for c in self.extended_forward_ref_value:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.constraint_type.is_set or
                                            self.constraint_value.is_set or
                                            self.forward_ref_value.is_set)

                                    def has_operation(self):
                                        for c in self.constraint_extended_value:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.extended_forward_ref_value:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.constraint_type.yfilter != YFilter.not_set or
                                            self.constraint_value.yfilter != YFilter.not_set or
                                            self.forward_ref_value.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "named-affinity" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                        if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                        if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "constraint-extended-value"):
                                            for c in self.constraint_extended_value:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.constraint_extended_value.append(c)
                                            return c

                                        if (child_yang_name == "extended-forward-ref-value"):
                                            for c in self.extended_forward_ref_value:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.extended_forward_ref_value.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "constraint-type"):
                                            self.constraint_type = value
                                            self.constraint_type.value_namespace = name_space
                                            self.constraint_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "constraint-value"):
                                            self.constraint_value = value
                                            self.constraint_value.value_namespace = name_space
                                            self.constraint_value.value_namespace_prefix = name_space_prefix
                                        if(value_path == "forward-ref-value"):
                                            self.forward_ref_value = value
                                            self.forward_ref_value.value_namespace = name_space
                                            self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.named_affinity:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.affinity_bits.is_set or
                                        self.affinity_mask.is_set)

                                def has_operation(self):
                                    for c in self.named_affinity:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.affinity_bits.yfilter != YFilter.not_set or
                                        self.affinity_mask.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "affinity" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                    if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "named-affinity"):
                                        for c in self.named_affinity:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.named_affinity.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "affinity-bits"):
                                        self.affinity_bits = value
                                        self.affinity_bits.value_namespace = name_space
                                        self.affinity_bits.value_namespace_prefix = name_space_prefix
                                    if(value_path == "affinity-mask"):
                                        self.affinity_mask = value
                                        self.affinity_mask.value_namespace = name_space
                                        self.affinity_mask.value_namespace_prefix = name_space_prefix


                            class Logging(Entity):
                                """
                                Logging attributes
                                
                                .. attribute:: all_logging_enabled
                                
                                	All logging option\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: lsp_bandwidth_change
                                
                                	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: lsp_insufficient_bw
                                
                                	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: lsp_pcalc_failure_logging_enabled
                                
                                	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: lsp_re_opt
                                
                                	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: lsp_re_route
                                
                                	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: lsp_state
                                
                                	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: s2l_state
                                
                                	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                    self.yang_name = "logging"
                                    self.yang_parent_name = "attribute-set-autobackup"

                                    self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                    self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                    self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                    self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                    self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                    self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                    self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                    self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("all_logging_enabled",
                                                    "lsp_bandwidth_change",
                                                    "lsp_insufficient_bw",
                                                    "lsp_pcalc_failure_logging_enabled",
                                                    "lsp_re_opt",
                                                    "lsp_re_route",
                                                    "lsp_state",
                                                    "s2l_state") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.all_logging_enabled.is_set or
                                        self.lsp_bandwidth_change.is_set or
                                        self.lsp_insufficient_bw.is_set or
                                        self.lsp_pcalc_failure_logging_enabled.is_set or
                                        self.lsp_re_opt.is_set or
                                        self.lsp_re_route.is_set or
                                        self.lsp_state.is_set or
                                        self.s2l_state.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.all_logging_enabled.yfilter != YFilter.not_set or
                                        self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                        self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                        self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                        self.lsp_re_opt.yfilter != YFilter.not_set or
                                        self.lsp_re_route.yfilter != YFilter.not_set or
                                        self.lsp_state.yfilter != YFilter.not_set or
                                        self.s2l_state.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "logging" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                    if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                    if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                    if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                    if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                    if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                    if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                    if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "all-logging-enabled"):
                                        self.all_logging_enabled = value
                                        self.all_logging_enabled.value_namespace = name_space
                                        self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-bandwidth-change"):
                                        self.lsp_bandwidth_change = value
                                        self.lsp_bandwidth_change.value_namespace = name_space
                                        self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-insufficient-bw"):
                                        self.lsp_insufficient_bw = value
                                        self.lsp_insufficient_bw.value_namespace = name_space
                                        self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                        self.lsp_pcalc_failure_logging_enabled = value
                                        self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                        self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-re-opt"):
                                        self.lsp_re_opt = value
                                        self.lsp_re_opt.value_namespace = name_space
                                        self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-re-route"):
                                        self.lsp_re_route = value
                                        self.lsp_re_route.value_namespace = name_space
                                        self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-state"):
                                        self.lsp_state = value
                                        self.lsp_state.value_namespace = name_space
                                        self.lsp_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-state"):
                                        self.s2l_state = value
                                        self.s2l_state.value_namespace = name_space
                                        self.s2l_state.value_namespace_prefix = name_space_prefix


                            class PolicyClassEntry(Entity):
                                """
                                PBTS policy classes
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                    self.yang_name = "policy-class-entry"
                                    self.yang_parent_name = "attribute-set-autobackup"

                                    self.entry = YLeaf(YType.uint8, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "policy-class-entry" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix


                            class TunnelId(Entity):
                                """
                                Tunnel ID
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                    self.yang_name = "tunnel-id"
                                    self.yang_parent_name = "attribute-set-autobackup"

                                    self.entry = YLeaf(YType.uint16, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "tunnel-id" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix


                            class ProtectedInterface(Entity):
                                """
                                Array of Protected Interface Names
                                
                                .. attribute:: protected_interface
                                
                                	Protected Interface Name
                                	**type**\:  str
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                    self.yang_name = "protected-interface"
                                    self.yang_parent_name = "attribute-set-autobackup"

                                    self.protected_interface = YLeaf(YType.str, "protected-interface")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("protected_interface") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.protected_interface.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.protected_interface.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "protected-interface" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "protected-interface"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "protected-interface"):
                                        self.protected_interface = value
                                        self.protected_interface.value_namespace = name_space
                                        self.protected_interface.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.policy_class_entry:
                                    if (c.has_data()):
                                        return True
                                for c in self.protected_interface:
                                    if (c.has_data()):
                                        return True
                                for c in self.tunnel_id:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.hold_priority.is_set or
                                    self.is_affinity_configured.is_set or
                                    self.is_policyclass_configured.is_set or
                                    self.is_priority_configured.is_set or
                                    self.is_signalled_name_configured.is_set or
                                    self.policy_class.is_set or
                                    self.record_route.is_set or
                                    self.setup_priority.is_set or
                                    (self.affinity is not None and self.affinity.has_data()) or
                                    (self.logging is not None and self.logging.has_data()) or
                                    (self.signalled_name is not None and self.signalled_name.has_data()))

                            def has_operation(self):
                                for c in self.policy_class_entry:
                                    if (c.has_operation()):
                                        return True
                                for c in self.protected_interface:
                                    if (c.has_operation()):
                                        return True
                                for c in self.tunnel_id:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.hold_priority.yfilter != YFilter.not_set or
                                    self.is_affinity_configured.yfilter != YFilter.not_set or
                                    self.is_policyclass_configured.yfilter != YFilter.not_set or
                                    self.is_priority_configured.yfilter != YFilter.not_set or
                                    self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                    self.policy_class.yfilter != YFilter.not_set or
                                    self.record_route.yfilter != YFilter.not_set or
                                    self.setup_priority.yfilter != YFilter.not_set or
                                    (self.affinity is not None and self.affinity.has_operation()) or
                                    (self.logging is not None and self.logging.has_operation()) or
                                    (self.signalled_name is not None and self.signalled_name.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "attribute-set-autobackup" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.policy_class.get_name_leafdata())
                                if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.record_route.get_name_leafdata())
                                if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "affinity"):
                                    if (self.affinity is None):
                                        self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                    return self.affinity

                                if (child_yang_name == "logging"):
                                    if (self.logging is None):
                                        self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"
                                    return self.logging

                                if (child_yang_name == "policy-class-entry"):
                                    for c in self.policy_class_entry:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.policy_class_entry.append(c)
                                    return c

                                if (child_yang_name == "protected-interface"):
                                    for c in self.protected_interface:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.protected_interface.append(c)
                                    return c

                                if (child_yang_name == "signalled-name"):
                                    if (self.signalled_name is None):
                                        self.signalled_name = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                        self.signalled_name.parent = self
                                        self._children_name_map["signalled_name"] = "signalled-name"
                                    return self.signalled_name

                                if (child_yang_name == "tunnel-id"):
                                    for c in self.tunnel_id:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.tunnel_id.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "hold-priority"):
                                    self.hold_priority = value
                                    self.hold_priority.value_namespace = name_space
                                    self.hold_priority.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-affinity-configured"):
                                    self.is_affinity_configured = value
                                    self.is_affinity_configured.value_namespace = name_space
                                    self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-policyclass-configured"):
                                    self.is_policyclass_configured = value
                                    self.is_policyclass_configured.value_namespace = name_space
                                    self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-priority-configured"):
                                    self.is_priority_configured = value
                                    self.is_priority_configured.value_namespace = name_space
                                    self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-signalled-name-configured"):
                                    self.is_signalled_name_configured = value
                                    self.is_signalled_name_configured.value_namespace = name_space
                                    self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "policy-class"):
                                    self.policy_class = value
                                    self.policy_class.value_namespace = name_space
                                    self.policy_class.value_namespace_prefix = name_space_prefix
                                if(value_path == "record-route"):
                                    self.record_route = value
                                    self.record_route.value_namespace = name_space
                                    self.record_route.value_namespace_prefix = name_space_prefix
                                if(value_path == "setup-priority"):
                                    self.setup_priority = value
                                    self.setup_priority.value_namespace = name_space
                                    self.setup_priority.value_namespace_prefix = name_space_prefix


                        class AttributeSetAutomesh(Entity):
                            """
                            MPLS TE Auto\-mesh Attribute Set
                            
                            .. attribute:: affinity
                            
                            	Affinity
                            	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                            
                            .. attribute:: auto_bandwidth_collect
                            
                            	Auto bandwidth collect only
                            	**type**\:  bool
                            
                            .. attribute:: auto_route_announce
                            
                            	Announce auto route to IGP
                            	**type**\:  bool
                            
                            .. attribute:: bandwidth
                            
                            	IM bandwidth
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: configured_bandwidth
                            
                            	Bandwidth value in kbps
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: dste_class_type
                            
                            	DSTE Class
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: fast_reroute
                            
                            	Fast reroute
                            	**type**\:  bool
                            
                            .. attribute:: forward_class
                            
                            	Forward class
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: frr_bandwidth_protection
                            
                            	FRR bandwidth protection
                            	**type**\:  bool
                            
                            .. attribute:: frr_node_protection
                            
                            	FRR Node protection
                            	**type**\:  bool
                            
                            .. attribute:: hold_priority
                            
                            	Hold priority
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: is_affinity_configured
                            
                            	Is affinity configured
                            	**type**\:  bool
                            
                            .. attribute:: is_bandwidth_configured
                            
                            	Is bandwidth configured
                            	**type**\:  bool
                            
                            .. attribute:: is_interface_bw_configured
                            
                            	Is Interface BW configured
                            	**type**\:  bool
                            
                            .. attribute:: is_policyclass_configured
                            
                            	Is policy class configured
                            	**type**\:  bool
                            
                            .. attribute:: is_priority_configured
                            
                            	Is priority configured
                            	**type**\:  bool
                            
                            .. attribute:: load_share
                            
                            	Load Share
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: logging
                            
                            	Logging attributes
                            	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                            
                            .. attribute:: mesh_group_id
                            
                            	Meshgroup ID
                            	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                            
                            .. attribute:: policy_class
                            
                            	deprecated
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: policy_class_entry
                            
                            	PBTS policy classes
                            	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                            
                            .. attribute:: record_route
                            
                            	Record route
                            	**type**\:  bool
                            
                            .. attribute:: setup_priority
                            
                            	Setup priority
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: soft_preemption_configured
                            
                            	Soft preemption is configured
                            	**type**\:  bool
                            
                            .. attribute:: tunnel_id
                            
                            	Tunnel ID
                            	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                self.yang_name = "attribute-set-automesh"
                                self.yang_parent_name = "attribute-set-union"

                                self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                self.forward_class = YLeaf(YType.uint32, "forward-class")

                                self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                self.load_share = YLeaf(YType.uint32, "load-share")

                                self.policy_class = YLeaf(YType.uint8, "policy-class")

                                self.record_route = YLeaf(YType.boolean, "record-route")

                                self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                self.affinity.parent = self
                                self._children_name_map["affinity"] = "affinity"
                                self._children_yang_names.add("affinity")

                                self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                self.logging.parent = self
                                self._children_name_map["logging"] = "logging"
                                self._children_yang_names.add("logging")

                                self.mesh_group_id = YList(self)
                                self.policy_class_entry = YList(self)
                                self.tunnel_id = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("auto_bandwidth_collect",
                                                "auto_route_announce",
                                                "bandwidth",
                                                "configured_bandwidth",
                                                "dste_class_type",
                                                "fast_reroute",
                                                "forward_class",
                                                "frr_bandwidth_protection",
                                                "frr_node_protection",
                                                "hold_priority",
                                                "is_affinity_configured",
                                                "is_bandwidth_configured",
                                                "is_interface_bw_configured",
                                                "is_policyclass_configured",
                                                "is_priority_configured",
                                                "load_share",
                                                "policy_class",
                                                "record_route",
                                                "setup_priority",
                                                "soft_preemption_configured") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                            class Affinity(Entity):
                                """
                                Affinity
                                
                                .. attribute:: affinity_bits
                                
                                	The affinity bits (colors)
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: affinity_mask
                                
                                	The affinity mask (colors)
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: named_affinity
                                
                                	Array of name based constratints currently applied to the tunnel
                                	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                    self.yang_name = "affinity"
                                    self.yang_parent_name = "attribute-set-automesh"

                                    self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                    self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                    self.named_affinity = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("affinity_bits",
                                                    "affinity_mask") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                class NamedAffinity(Entity):
                                    """
                                    Array of name based constratints currently
                                    applied to the tunnel
                                    
                                    .. attribute:: constraint_extended_value
                                    
                                    	Constraint value
                                    	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                    
                                    .. attribute:: constraint_type
                                    
                                    	Constraint type
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: constraint_value
                                    
                                    	Deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: extended_forward_ref_value
                                    
                                    	Reference bits for undefined affinity names
                                    	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                    
                                    .. attribute:: forward_ref_value
                                    
                                    	Deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                        self.yang_name = "named-affinity"
                                        self.yang_parent_name = "affinity"

                                        self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                        self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                        self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                        self.constraint_extended_value = YList(self)
                                        self.extended_forward_ref_value = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("constraint_type",
                                                        "constraint_value",
                                                        "forward_ref_value") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                    class ConstraintExtendedValue(Entity):
                                        """
                                        Constraint value
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                            self.yang_name = "constraint-extended-value"
                                            self.yang_parent_name = "named-affinity"

                                            self.entry = YLeaf(YType.uint32, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "constraint-extended-value" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class ExtendedForwardRefValue(Entity):
                                        """
                                        Reference bits for undefined affinity names
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                            self.yang_name = "extended-forward-ref-value"
                                            self.yang_parent_name = "named-affinity"

                                            self.entry = YLeaf(YType.uint32, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "extended-forward-ref-value" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.constraint_extended_value:
                                            if (c.has_data()):
                                                return True
                                        for c in self.extended_forward_ref_value:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.constraint_type.is_set or
                                            self.constraint_value.is_set or
                                            self.forward_ref_value.is_set)

                                    def has_operation(self):
                                        for c in self.constraint_extended_value:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.extended_forward_ref_value:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.constraint_type.yfilter != YFilter.not_set or
                                            self.constraint_value.yfilter != YFilter.not_set or
                                            self.forward_ref_value.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "named-affinity" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                        if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                        if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "constraint-extended-value"):
                                            for c in self.constraint_extended_value:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.constraint_extended_value.append(c)
                                            return c

                                        if (child_yang_name == "extended-forward-ref-value"):
                                            for c in self.extended_forward_ref_value:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.extended_forward_ref_value.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "constraint-type"):
                                            self.constraint_type = value
                                            self.constraint_type.value_namespace = name_space
                                            self.constraint_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "constraint-value"):
                                            self.constraint_value = value
                                            self.constraint_value.value_namespace = name_space
                                            self.constraint_value.value_namespace_prefix = name_space_prefix
                                        if(value_path == "forward-ref-value"):
                                            self.forward_ref_value = value
                                            self.forward_ref_value.value_namespace = name_space
                                            self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.named_affinity:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.affinity_bits.is_set or
                                        self.affinity_mask.is_set)

                                def has_operation(self):
                                    for c in self.named_affinity:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.affinity_bits.yfilter != YFilter.not_set or
                                        self.affinity_mask.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "affinity" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                    if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "named-affinity"):
                                        for c in self.named_affinity:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.named_affinity.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "affinity-bits"):
                                        self.affinity_bits = value
                                        self.affinity_bits.value_namespace = name_space
                                        self.affinity_bits.value_namespace_prefix = name_space_prefix
                                    if(value_path == "affinity-mask"):
                                        self.affinity_mask = value
                                        self.affinity_mask.value_namespace = name_space
                                        self.affinity_mask.value_namespace_prefix = name_space_prefix


                            class Logging(Entity):
                                """
                                Logging attributes
                                
                                .. attribute:: all_logging_enabled
                                
                                	All logging option\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: lsp_bandwidth_change
                                
                                	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: lsp_insufficient_bw
                                
                                	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: lsp_pcalc_failure_logging_enabled
                                
                                	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: lsp_re_opt
                                
                                	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: lsp_re_route
                                
                                	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: lsp_state
                                
                                	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: s2l_state
                                
                                	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                    self.yang_name = "logging"
                                    self.yang_parent_name = "attribute-set-automesh"

                                    self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                    self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                    self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                    self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                    self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                    self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                    self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                    self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("all_logging_enabled",
                                                    "lsp_bandwidth_change",
                                                    "lsp_insufficient_bw",
                                                    "lsp_pcalc_failure_logging_enabled",
                                                    "lsp_re_opt",
                                                    "lsp_re_route",
                                                    "lsp_state",
                                                    "s2l_state") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.all_logging_enabled.is_set or
                                        self.lsp_bandwidth_change.is_set or
                                        self.lsp_insufficient_bw.is_set or
                                        self.lsp_pcalc_failure_logging_enabled.is_set or
                                        self.lsp_re_opt.is_set or
                                        self.lsp_re_route.is_set or
                                        self.lsp_state.is_set or
                                        self.s2l_state.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.all_logging_enabled.yfilter != YFilter.not_set or
                                        self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                        self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                        self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                        self.lsp_re_opt.yfilter != YFilter.not_set or
                                        self.lsp_re_route.yfilter != YFilter.not_set or
                                        self.lsp_state.yfilter != YFilter.not_set or
                                        self.s2l_state.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "logging" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                    if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                    if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                    if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                    if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                    if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                    if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                    if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "all-logging-enabled"):
                                        self.all_logging_enabled = value
                                        self.all_logging_enabled.value_namespace = name_space
                                        self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-bandwidth-change"):
                                        self.lsp_bandwidth_change = value
                                        self.lsp_bandwidth_change.value_namespace = name_space
                                        self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-insufficient-bw"):
                                        self.lsp_insufficient_bw = value
                                        self.lsp_insufficient_bw.value_namespace = name_space
                                        self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                        self.lsp_pcalc_failure_logging_enabled = value
                                        self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                        self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-re-opt"):
                                        self.lsp_re_opt = value
                                        self.lsp_re_opt.value_namespace = name_space
                                        self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-re-route"):
                                        self.lsp_re_route = value
                                        self.lsp_re_route.value_namespace = name_space
                                        self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-state"):
                                        self.lsp_state = value
                                        self.lsp_state.value_namespace = name_space
                                        self.lsp_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-state"):
                                        self.s2l_state = value
                                        self.s2l_state.value_namespace = name_space
                                        self.s2l_state.value_namespace_prefix = name_space_prefix


                            class PolicyClassEntry(Entity):
                                """
                                PBTS policy classes
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                    self.yang_name = "policy-class-entry"
                                    self.yang_parent_name = "attribute-set-automesh"

                                    self.entry = YLeaf(YType.uint8, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "policy-class-entry" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix


                            class MeshGroupId(Entity):
                                """
                                Meshgroup ID
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                    self.yang_name = "mesh-group-id"
                                    self.yang_parent_name = "attribute-set-automesh"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "mesh-group-id" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix


                            class TunnelId(Entity):
                                """
                                Tunnel ID
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                    self.yang_name = "tunnel-id"
                                    self.yang_parent_name = "attribute-set-automesh"

                                    self.entry = YLeaf(YType.uint16, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "tunnel-id" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.mesh_group_id:
                                    if (c.has_data()):
                                        return True
                                for c in self.policy_class_entry:
                                    if (c.has_data()):
                                        return True
                                for c in self.tunnel_id:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.auto_bandwidth_collect.is_set or
                                    self.auto_route_announce.is_set or
                                    self.bandwidth.is_set or
                                    self.configured_bandwidth.is_set or
                                    self.dste_class_type.is_set or
                                    self.fast_reroute.is_set or
                                    self.forward_class.is_set or
                                    self.frr_bandwidth_protection.is_set or
                                    self.frr_node_protection.is_set or
                                    self.hold_priority.is_set or
                                    self.is_affinity_configured.is_set or
                                    self.is_bandwidth_configured.is_set or
                                    self.is_interface_bw_configured.is_set or
                                    self.is_policyclass_configured.is_set or
                                    self.is_priority_configured.is_set or
                                    self.load_share.is_set or
                                    self.policy_class.is_set or
                                    self.record_route.is_set or
                                    self.setup_priority.is_set or
                                    self.soft_preemption_configured.is_set or
                                    (self.affinity is not None and self.affinity.has_data()) or
                                    (self.logging is not None and self.logging.has_data()))

                            def has_operation(self):
                                for c in self.mesh_group_id:
                                    if (c.has_operation()):
                                        return True
                                for c in self.policy_class_entry:
                                    if (c.has_operation()):
                                        return True
                                for c in self.tunnel_id:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                    self.auto_route_announce.yfilter != YFilter.not_set or
                                    self.bandwidth.yfilter != YFilter.not_set or
                                    self.configured_bandwidth.yfilter != YFilter.not_set or
                                    self.dste_class_type.yfilter != YFilter.not_set or
                                    self.fast_reroute.yfilter != YFilter.not_set or
                                    self.forward_class.yfilter != YFilter.not_set or
                                    self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                    self.frr_node_protection.yfilter != YFilter.not_set or
                                    self.hold_priority.yfilter != YFilter.not_set or
                                    self.is_affinity_configured.yfilter != YFilter.not_set or
                                    self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                    self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                    self.is_policyclass_configured.yfilter != YFilter.not_set or
                                    self.is_priority_configured.yfilter != YFilter.not_set or
                                    self.load_share.yfilter != YFilter.not_set or
                                    self.policy_class.yfilter != YFilter.not_set or
                                    self.record_route.yfilter != YFilter.not_set or
                                    self.setup_priority.yfilter != YFilter.not_set or
                                    self.soft_preemption_configured.yfilter != YFilter.not_set or
                                    (self.affinity is not None and self.affinity.has_operation()) or
                                    (self.logging is not None and self.logging.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "attribute-set-automesh" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.forward_class.get_name_leafdata())
                                if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.load_share.get_name_leafdata())
                                if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.policy_class.get_name_leafdata())
                                if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.record_route.get_name_leafdata())
                                if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "affinity"):
                                    if (self.affinity is None):
                                        self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                    return self.affinity

                                if (child_yang_name == "logging"):
                                    if (self.logging is None):
                                        self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"
                                    return self.logging

                                if (child_yang_name == "mesh-group-id"):
                                    for c in self.mesh_group_id:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.mesh_group_id.append(c)
                                    return c

                                if (child_yang_name == "policy-class-entry"):
                                    for c in self.policy_class_entry:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.policy_class_entry.append(c)
                                    return c

                                if (child_yang_name == "tunnel-id"):
                                    for c in self.tunnel_id:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.tunnel_id.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "auto-bandwidth-collect"):
                                    self.auto_bandwidth_collect = value
                                    self.auto_bandwidth_collect.value_namespace = name_space
                                    self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                if(value_path == "auto-route-announce"):
                                    self.auto_route_announce = value
                                    self.auto_route_announce.value_namespace = name_space
                                    self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                if(value_path == "bandwidth"):
                                    self.bandwidth = value
                                    self.bandwidth.value_namespace = name_space
                                    self.bandwidth.value_namespace_prefix = name_space_prefix
                                if(value_path == "configured-bandwidth"):
                                    self.configured_bandwidth = value
                                    self.configured_bandwidth.value_namespace = name_space
                                    self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                if(value_path == "dste-class-type"):
                                    self.dste_class_type = value
                                    self.dste_class_type.value_namespace = name_space
                                    self.dste_class_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "fast-reroute"):
                                    self.fast_reroute = value
                                    self.fast_reroute.value_namespace = name_space
                                    self.fast_reroute.value_namespace_prefix = name_space_prefix
                                if(value_path == "forward-class"):
                                    self.forward_class = value
                                    self.forward_class.value_namespace = name_space
                                    self.forward_class.value_namespace_prefix = name_space_prefix
                                if(value_path == "frr-bandwidth-protection"):
                                    self.frr_bandwidth_protection = value
                                    self.frr_bandwidth_protection.value_namespace = name_space
                                    self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                if(value_path == "frr-node-protection"):
                                    self.frr_node_protection = value
                                    self.frr_node_protection.value_namespace = name_space
                                    self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                if(value_path == "hold-priority"):
                                    self.hold_priority = value
                                    self.hold_priority.value_namespace = name_space
                                    self.hold_priority.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-affinity-configured"):
                                    self.is_affinity_configured = value
                                    self.is_affinity_configured.value_namespace = name_space
                                    self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-bandwidth-configured"):
                                    self.is_bandwidth_configured = value
                                    self.is_bandwidth_configured.value_namespace = name_space
                                    self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-interface-bw-configured"):
                                    self.is_interface_bw_configured = value
                                    self.is_interface_bw_configured.value_namespace = name_space
                                    self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-policyclass-configured"):
                                    self.is_policyclass_configured = value
                                    self.is_policyclass_configured.value_namespace = name_space
                                    self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-priority-configured"):
                                    self.is_priority_configured = value
                                    self.is_priority_configured.value_namespace = name_space
                                    self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "load-share"):
                                    self.load_share = value
                                    self.load_share.value_namespace = name_space
                                    self.load_share.value_namespace_prefix = name_space_prefix
                                if(value_path == "policy-class"):
                                    self.policy_class = value
                                    self.policy_class.value_namespace = name_space
                                    self.policy_class.value_namespace_prefix = name_space_prefix
                                if(value_path == "record-route"):
                                    self.record_route = value
                                    self.record_route.value_namespace = name_space
                                    self.record_route.value_namespace_prefix = name_space_prefix
                                if(value_path == "setup-priority"):
                                    self.setup_priority = value
                                    self.setup_priority.value_namespace = name_space
                                    self.setup_priority.value_namespace_prefix = name_space_prefix
                                if(value_path == "soft-preemption-configured"):
                                    self.soft_preemption_configured = value
                                    self.soft_preemption_configured.value_namespace = name_space
                                    self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                        class AttributeSetXro(Entity):
                            """
                            Attribute Set XRO
                            
                            .. attribute:: xro
                            
                            	The XRO specified by this attribute\-set
                            	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                self.yang_name = "attribute-set-xro"
                                self.yang_parent_name = "attribute-set-union"

                                self.xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                self.xro.parent = self
                                self._children_name_map["xro"] = "xro"
                                self._children_yang_names.add("xro")


                            class Xro(Entity):
                                """
                                The XRO specified by this attribute\-set
                                
                                .. attribute:: mutual_diversity_flag
                                
                                	Mutual Diversity Flag
                                	**type**\:  bool
                                
                                .. attribute:: xro_subobject
                                
                                	List of XRO sub\-objects
                                	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                    self.yang_name = "xro"
                                    self.yang_parent_name = "attribute-set-xro"

                                    self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                    self.xro_subobject = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("mutual_diversity_flag") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                class XroSubobject(Entity):
                                    """
                                    List of XRO sub\-objects
                                    
                                    .. attribute:: as_subobject
                                    
                                    	AS sub\-object
                                    	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                    
                                    .. attribute:: ipv4_subobject
                                    
                                    	IPv4 sub\-object
                                    	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                    
                                    .. attribute:: ipv6_subobject
                                    
                                    	IPv6 sub\-object
                                    	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                    
                                    .. attribute:: lsp_subobject
                                    
                                    	P2P LSP sub\-object
                                    	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                    
                                    .. attribute:: srlg_subobject
                                    
                                    	SRLG sub\-object
                                    	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                    
                                    .. attribute:: type
                                    
                                    	Type
                                    	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                    
                                    .. attribute:: unnumbered_subobject
                                    
                                    	Unnumbered sub\-object
                                    	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                        self.yang_name = "xro-subobject"
                                        self.yang_parent_name = "xro"

                                        self.type = YLeaf(YType.enumeration, "type")

                                        self.as_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                        self.as_subobject.parent = self
                                        self._children_name_map["as_subobject"] = "as-subobject"
                                        self._children_yang_names.add("as-subobject")

                                        self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                        self.ipv4_subobject.parent = self
                                        self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                        self._children_yang_names.add("ipv4-subobject")

                                        self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                        self.ipv6_subobject.parent = self
                                        self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                        self._children_yang_names.add("ipv6-subobject")

                                        self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                        self.lsp_subobject.parent = self
                                        self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                        self._children_yang_names.add("lsp-subobject")

                                        self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                        self.srlg_subobject.parent = self
                                        self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                        self._children_yang_names.add("srlg-subobject")

                                        self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                        self.unnumbered_subobject.parent = self
                                        self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                        self._children_yang_names.add("unnumbered-subobject")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                    class Ipv4Subobject(Entity):
                                        """
                                        IPv4 sub\-object
                                        
                                        .. attribute:: address
                                        
                                        	IPv4 address
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: attribute
                                        
                                        	Attribute
                                        	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                        
                                        .. attribute:: exclusion_type
                                        
                                        	Exclusion Type
                                        	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                        
                                        .. attribute:: prefix_len
                                        
                                        	Prefix length
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                            self.yang_name = "ipv4-subobject"
                                            self.yang_parent_name = "xro-subobject"

                                            self.address = YLeaf(YType.str, "address")

                                            self.attribute = YLeaf(YType.enumeration, "attribute")

                                            self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                            self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("address",
                                                            "attribute",
                                                            "exclusion_type",
                                                            "prefix_len") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.address.is_set or
                                                self.attribute.is_set or
                                                self.exclusion_type.is_set or
                                                self.prefix_len.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.address.yfilter != YFilter.not_set or
                                                self.attribute.yfilter != YFilter.not_set or
                                                self.exclusion_type.yfilter != YFilter.not_set or
                                                self.prefix_len.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "ipv4-subobject" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.address.get_name_leafdata())
                                            if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.attribute.get_name_leafdata())
                                            if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                            if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "address"):
                                                self.address = value
                                                self.address.value_namespace = name_space
                                                self.address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "attribute"):
                                                self.attribute = value
                                                self.attribute.value_namespace = name_space
                                                self.attribute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exclusion-type"):
                                                self.exclusion_type = value
                                                self.exclusion_type.value_namespace = name_space
                                                self.exclusion_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "prefix-len"):
                                                self.prefix_len = value
                                                self.prefix_len.value_namespace = name_space
                                                self.prefix_len.value_namespace_prefix = name_space_prefix


                                    class Ipv6Subobject(Entity):
                                        """
                                        IPv6 sub\-object
                                        
                                        .. attribute:: address
                                        
                                        	IPv6 address
                                        	**type**\:  str
                                        
                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                        
                                        .. attribute:: attribute
                                        
                                        	Attribute
                                        	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                        
                                        .. attribute:: exclusion_type
                                        
                                        	Exclusion Type
                                        	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                        
                                        .. attribute:: prefix_len
                                        
                                        	Prefix length
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                            self.yang_name = "ipv6-subobject"
                                            self.yang_parent_name = "xro-subobject"

                                            self.address = YLeaf(YType.str, "address")

                                            self.attribute = YLeaf(YType.enumeration, "attribute")

                                            self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                            self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("address",
                                                            "attribute",
                                                            "exclusion_type",
                                                            "prefix_len") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.address.is_set or
                                                self.attribute.is_set or
                                                self.exclusion_type.is_set or
                                                self.prefix_len.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.address.yfilter != YFilter.not_set or
                                                self.attribute.yfilter != YFilter.not_set or
                                                self.exclusion_type.yfilter != YFilter.not_set or
                                                self.prefix_len.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "ipv6-subobject" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.address.get_name_leafdata())
                                            if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.attribute.get_name_leafdata())
                                            if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                            if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "address"):
                                                self.address = value
                                                self.address.value_namespace = name_space
                                                self.address.value_namespace_prefix = name_space_prefix
                                            if(value_path == "attribute"):
                                                self.attribute = value
                                                self.attribute.value_namespace = name_space
                                                self.attribute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exclusion-type"):
                                                self.exclusion_type = value
                                                self.exclusion_type.value_namespace = name_space
                                                self.exclusion_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "prefix-len"):
                                                self.prefix_len = value
                                                self.prefix_len.value_namespace = name_space
                                                self.prefix_len.value_namespace_prefix = name_space_prefix


                                    class UnnumberedSubobject(Entity):
                                        """
                                        Unnumbered sub\-object
                                        
                                        .. attribute:: attribute
                                        
                                        	Attribute
                                        	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                        
                                        .. attribute:: exclusion_type
                                        
                                        	Exclusion Type
                                        	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                        
                                        .. attribute:: interface_id
                                        
                                        	Interface ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: te_router_id
                                        
                                        	TE router\-id
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                            self.yang_name = "unnumbered-subobject"
                                            self.yang_parent_name = "xro-subobject"

                                            self.attribute = YLeaf(YType.enumeration, "attribute")

                                            self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                            self.interface_id = YLeaf(YType.uint32, "interface-id")

                                            self.te_router_id = YLeaf(YType.str, "te-router-id")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("attribute",
                                                            "exclusion_type",
                                                            "interface_id",
                                                            "te_router_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.attribute.is_set or
                                                self.exclusion_type.is_set or
                                                self.interface_id.is_set or
                                                self.te_router_id.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.attribute.yfilter != YFilter.not_set or
                                                self.exclusion_type.yfilter != YFilter.not_set or
                                                self.interface_id.yfilter != YFilter.not_set or
                                                self.te_router_id.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "unnumbered-subobject" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.attribute.get_name_leafdata())
                                            if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                            if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.interface_id.get_name_leafdata())
                                            if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "attribute"):
                                                self.attribute = value
                                                self.attribute.value_namespace = name_space
                                                self.attribute.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exclusion-type"):
                                                self.exclusion_type = value
                                                self.exclusion_type.value_namespace = name_space
                                                self.exclusion_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "interface-id"):
                                                self.interface_id = value
                                                self.interface_id.value_namespace = name_space
                                                self.interface_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "te-router-id"):
                                                self.te_router_id = value
                                                self.te_router_id.value_namespace = name_space
                                                self.te_router_id.value_namespace_prefix = name_space_prefix


                                    class AsSubobject(Entity):
                                        """
                                        AS sub\-object
                                        
                                        .. attribute:: as_number
                                        
                                        	Autonomous System number
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                            self.yang_name = "as-subobject"
                                            self.yang_parent_name = "xro-subobject"

                                            self.as_number = YLeaf(YType.uint16, "as-number")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("as_number") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.as_number.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.as_number.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "as-subobject" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.as_number.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "as-number"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "as-number"):
                                                self.as_number = value
                                                self.as_number.value_namespace = name_space
                                                self.as_number.value_namespace_prefix = name_space_prefix


                                    class SrlgSubobject(Entity):
                                        """
                                        SRLG sub\-object
                                        
                                        .. attribute:: exclusion_type
                                        
                                        	Exclusion Type
                                        	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                        
                                        .. attribute:: srlg_id
                                        
                                        	SRLG ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                            self.yang_name = "srlg-subobject"
                                            self.yang_parent_name = "xro-subobject"

                                            self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                            self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("exclusion_type",
                                                            "srlg_id") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.exclusion_type.is_set or
                                                self.srlg_id.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.exclusion_type.yfilter != YFilter.not_set or
                                                self.srlg_id.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "srlg-subobject" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                            if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "exclusion-type" or name == "srlg-id"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "exclusion-type"):
                                                self.exclusion_type = value
                                                self.exclusion_type.value_namespace = name_space
                                                self.exclusion_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "srlg-id"):
                                                self.srlg_id = value
                                                self.srlg_id.value_namespace = name_space
                                                self.srlg_id.value_namespace_prefix = name_space_prefix


                                    class LspSubobject(Entity):
                                        """
                                        P2P LSP sub\-object
                                        
                                        .. attribute:: destination_node_exception
                                        
                                        	Destination\-node exception flag
                                        	**type**\:  bool
                                        
                                        .. attribute:: exclusion_type
                                        
                                        	Exclusion Type
                                        	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                        
                                        .. attribute:: fec
                                        
                                        	LSP FEC
                                        	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                        
                                        .. attribute:: ignore_lsp_id
                                        
                                        	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                        	**type**\:  bool
                                        
                                        .. attribute:: penultimate_node_exception
                                        
                                        	Penultimate\-node exception flag
                                        	**type**\:  bool
                                        
                                        .. attribute:: processing_node_exception
                                        
                                        	Processing\-node exception flag
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                            self.yang_name = "lsp-subobject"
                                            self.yang_parent_name = "xro-subobject"

                                            self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                            self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                            self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                            self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                            self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                            self.fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                            self.fec.parent = self
                                            self._children_name_map["fec"] = "fec"
                                            self._children_yang_names.add("fec")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("destination_node_exception",
                                                            "exclusion_type",
                                                            "ignore_lsp_id",
                                                            "penultimate_node_exception",
                                                            "processing_node_exception") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                        class Fec(Entity):
                                            """
                                            LSP FEC
                                            
                                            .. attribute:: fec_destination_info
                                            
                                            	Destination or P2MP ID
                                            	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                            
                                            .. attribute:: fec_extended_tunnel_id
                                            
                                            	Extended tunnel ID
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: fec_lsp_id
                                            
                                            	LSP ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: fec_source
                                            
                                            	Tunnel source address
                                            	**type**\:  str
                                            
                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                            
                                            .. attribute:: fec_tunnel_id
                                            
                                            	Tunnel ID
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: fec_vrf
                                            
                                            	VRF; currently only for GMPLS tunnels
                                            	**type**\:  str
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                self.yang_name = "fec"
                                                self.yang_parent_name = "lsp-subobject"

                                                self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                self.fec_source = YLeaf(YType.str, "fec-source")

                                                self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                self.fec_destination_info.parent = self
                                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                self._children_yang_names.add("fec-destination-info")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("fec_extended_tunnel_id",
                                                                "fec_lsp_id",
                                                                "fec_source",
                                                                "fec_tunnel_id",
                                                                "fec_vrf") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                            class FecDestinationInfo(Entity):
                                                """
                                                Destination or P2MP ID
                                                
                                                .. attribute:: fec_ctype
                                                
                                                	FEC CType
                                                	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                
                                                .. attribute:: fec_destination_p2mp_id
                                                
                                                	P2MP ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: p2p_lsp_destination
                                                
                                                	P2P LSP destination
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                    self.yang_name = "fec-destination-info"
                                                    self.yang_parent_name = "fec"

                                                    self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                    self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                    self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("fec_ctype",
                                                                    "fec_destination_p2mp_id",
                                                                    "p2p_lsp_destination") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.fec_ctype.is_set or
                                                        self.fec_destination_p2mp_id.is_set or
                                                        self.p2p_lsp_destination.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.fec_ctype.yfilter != YFilter.not_set or
                                                        self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                        self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "fec-destination-info" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                    if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                    if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "fec-ctype"):
                                                        self.fec_ctype = value
                                                        self.fec_ctype.value_namespace = name_space
                                                        self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "fec-destination-p2mp-id"):
                                                        self.fec_destination_p2mp_id = value
                                                        self.fec_destination_p2mp_id.value_namespace = name_space
                                                        self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "p2p-lsp-destination"):
                                                        self.p2p_lsp_destination = value
                                                        self.p2p_lsp_destination.value_namespace = name_space
                                                        self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.fec_extended_tunnel_id.is_set or
                                                    self.fec_lsp_id.is_set or
                                                    self.fec_source.is_set or
                                                    self.fec_tunnel_id.is_set or
                                                    self.fec_vrf.is_set or
                                                    (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                    self.fec_lsp_id.yfilter != YFilter.not_set or
                                                    self.fec_source.yfilter != YFilter.not_set or
                                                    self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                    self.fec_vrf.yfilter != YFilter.not_set or
                                                    (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "fec" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "fec-destination-info"):
                                                    if (self.fec_destination_info is None):
                                                        self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                        self.fec_destination_info.parent = self
                                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                    return self.fec_destination_info

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "fec-extended-tunnel-id"):
                                                    self.fec_extended_tunnel_id = value
                                                    self.fec_extended_tunnel_id.value_namespace = name_space
                                                    self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "fec-lsp-id"):
                                                    self.fec_lsp_id = value
                                                    self.fec_lsp_id.value_namespace = name_space
                                                    self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "fec-source"):
                                                    self.fec_source = value
                                                    self.fec_source.value_namespace = name_space
                                                    self.fec_source.value_namespace_prefix = name_space_prefix
                                                if(value_path == "fec-tunnel-id"):
                                                    self.fec_tunnel_id = value
                                                    self.fec_tunnel_id.value_namespace = name_space
                                                    self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                if(value_path == "fec-vrf"):
                                                    self.fec_vrf = value
                                                    self.fec_vrf.value_namespace = name_space
                                                    self.fec_vrf.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            return (
                                                self.destination_node_exception.is_set or
                                                self.exclusion_type.is_set or
                                                self.ignore_lsp_id.is_set or
                                                self.penultimate_node_exception.is_set or
                                                self.processing_node_exception.is_set or
                                                (self.fec is not None and self.fec.has_data()))

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.destination_node_exception.yfilter != YFilter.not_set or
                                                self.exclusion_type.yfilter != YFilter.not_set or
                                                self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                self.processing_node_exception.yfilter != YFilter.not_set or
                                                (self.fec is not None and self.fec.has_operation()))

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "lsp-subobject" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                            if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                            if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                            if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                            if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "fec"):
                                                if (self.fec is None):
                                                    self.fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                    self.fec.parent = self
                                                    self._children_name_map["fec"] = "fec"
                                                return self.fec

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "destination-node-exception"):
                                                self.destination_node_exception = value
                                                self.destination_node_exception.value_namespace = name_space
                                                self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                            if(value_path == "exclusion-type"):
                                                self.exclusion_type = value
                                                self.exclusion_type.value_namespace = name_space
                                                self.exclusion_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "ignore-lsp-id"):
                                                self.ignore_lsp_id = value
                                                self.ignore_lsp_id.value_namespace = name_space
                                                self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "penultimate-node-exception"):
                                                self.penultimate_node_exception = value
                                                self.penultimate_node_exception.value_namespace = name_space
                                                self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                            if(value_path == "processing-node-exception"):
                                                self.processing_node_exception = value
                                                self.processing_node_exception.value_namespace = name_space
                                                self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.type.is_set or
                                            (self.as_subobject is not None and self.as_subobject.has_data()) or
                                            (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                            (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                            (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                            (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                            (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.type.yfilter != YFilter.not_set or
                                            (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                            (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                            (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                            (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                            (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                            (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "xro-subobject" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "as-subobject"):
                                            if (self.as_subobject is None):
                                                self.as_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                self.as_subobject.parent = self
                                                self._children_name_map["as_subobject"] = "as-subobject"
                                            return self.as_subobject

                                        if (child_yang_name == "ipv4-subobject"):
                                            if (self.ipv4_subobject is None):
                                                self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                self.ipv4_subobject.parent = self
                                                self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                            return self.ipv4_subobject

                                        if (child_yang_name == "ipv6-subobject"):
                                            if (self.ipv6_subobject is None):
                                                self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                self.ipv6_subobject.parent = self
                                                self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                            return self.ipv6_subobject

                                        if (child_yang_name == "lsp-subobject"):
                                            if (self.lsp_subobject is None):
                                                self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                self.lsp_subobject.parent = self
                                                self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                            return self.lsp_subobject

                                        if (child_yang_name == "srlg-subobject"):
                                            if (self.srlg_subobject is None):
                                                self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                self.srlg_subobject.parent = self
                                                self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                            return self.srlg_subobject

                                        if (child_yang_name == "unnumbered-subobject"):
                                            if (self.unnumbered_subobject is None):
                                                self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                self.unnumbered_subobject.parent = self
                                                self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                            return self.unnumbered_subobject

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "type"):
                                            self.type = value
                                            self.type.value_namespace = name_space
                                            self.type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.xro_subobject:
                                        if (c.has_data()):
                                            return True
                                    return self.mutual_diversity_flag.is_set

                                def has_operation(self):
                                    for c in self.xro_subobject:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "xro" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "xro-subobject"):
                                        for c in self.xro_subobject:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.xro_subobject.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "mutual-diversity-flag"):
                                        self.mutual_diversity_flag = value
                                        self.mutual_diversity_flag.value_namespace = name_space
                                        self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.xro is not None and self.xro.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.xro is not None and self.xro.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "attribute-set-xro" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "xro"):
                                    if (self.xro is None):
                                        self.xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                        self.xro.parent = self
                                        self._children_name_map["xro"] = "xro"
                                    return self.xro

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "xro"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass


                        class AttributeSetP2Mpte(Entity):
                            """
                            MPLS TE P2MP\-TE Attribute Set
                            
                            .. attribute:: affinity
                            
                            	Affinity
                            	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                            
                            .. attribute:: configured_bandwidth
                            
                            	Bandwidth value in kbps
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: kbit/s
                            
                            .. attribute:: dste_class_type
                            
                            	DSTE Class
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: fast_reroute
                            
                            	Fast reroute
                            	**type**\:  bool
                            
                            .. attribute:: frr_bandwidth_protection
                            
                            	FRR bandwidth protection
                            	**type**\:  bool
                            
                            .. attribute:: hold_priority
                            
                            	Hold priority
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: is_affinity_configured
                            
                            	Is affinity configured
                            	**type**\:  bool
                            
                            .. attribute:: is_bandwidth_configured
                            
                            	Is bandwidth configured
                            	**type**\:  bool
                            
                            .. attribute:: is_priority_configured
                            
                            	Is priority configured
                            	**type**\:  bool
                            
                            .. attribute:: setup_priority
                            
                            	Setup priority
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: tunnel_id
                            
                            	Tunnel ID
                            	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                self.yang_name = "attribute-set-p2mpte"
                                self.yang_parent_name = "attribute-set-union"

                                self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                self.affinity.parent = self
                                self._children_name_map["affinity"] = "affinity"
                                self._children_yang_names.add("affinity")

                                self.tunnel_id = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("configured_bandwidth",
                                                "dste_class_type",
                                                "fast_reroute",
                                                "frr_bandwidth_protection",
                                                "hold_priority",
                                                "is_affinity_configured",
                                                "is_bandwidth_configured",
                                                "is_priority_configured",
                                                "setup_priority") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                            class Affinity(Entity):
                                """
                                Affinity
                                
                                .. attribute:: affinity_bits
                                
                                	The affinity bits (colors)
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: affinity_mask
                                
                                	The affinity mask (colors)
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: named_affinity
                                
                                	Array of name based constratints currently applied to the tunnel
                                	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                    self.yang_name = "affinity"
                                    self.yang_parent_name = "attribute-set-p2mpte"

                                    self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                    self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                    self.named_affinity = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("affinity_bits",
                                                    "affinity_mask") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                class NamedAffinity(Entity):
                                    """
                                    Array of name based constratints currently
                                    applied to the tunnel
                                    
                                    .. attribute:: constraint_extended_value
                                    
                                    	Constraint value
                                    	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                    
                                    .. attribute:: constraint_type
                                    
                                    	Constraint type
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: constraint_value
                                    
                                    	Deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: extended_forward_ref_value
                                    
                                    	Reference bits for undefined affinity names
                                    	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                    
                                    .. attribute:: forward_ref_value
                                    
                                    	Deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                        self.yang_name = "named-affinity"
                                        self.yang_parent_name = "affinity"

                                        self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                        self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                        self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                        self.constraint_extended_value = YList(self)
                                        self.extended_forward_ref_value = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("constraint_type",
                                                        "constraint_value",
                                                        "forward_ref_value") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                    class ConstraintExtendedValue(Entity):
                                        """
                                        Constraint value
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                            self.yang_name = "constraint-extended-value"
                                            self.yang_parent_name = "named-affinity"

                                            self.entry = YLeaf(YType.uint32, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "constraint-extended-value" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class ExtendedForwardRefValue(Entity):
                                        """
                                        Reference bits for undefined affinity names
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                            self.yang_name = "extended-forward-ref-value"
                                            self.yang_parent_name = "named-affinity"

                                            self.entry = YLeaf(YType.uint32, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "extended-forward-ref-value" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.constraint_extended_value:
                                            if (c.has_data()):
                                                return True
                                        for c in self.extended_forward_ref_value:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.constraint_type.is_set or
                                            self.constraint_value.is_set or
                                            self.forward_ref_value.is_set)

                                    def has_operation(self):
                                        for c in self.constraint_extended_value:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.extended_forward_ref_value:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.constraint_type.yfilter != YFilter.not_set or
                                            self.constraint_value.yfilter != YFilter.not_set or
                                            self.forward_ref_value.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "named-affinity" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                        if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                        if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "constraint-extended-value"):
                                            for c in self.constraint_extended_value:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.constraint_extended_value.append(c)
                                            return c

                                        if (child_yang_name == "extended-forward-ref-value"):
                                            for c in self.extended_forward_ref_value:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.extended_forward_ref_value.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "constraint-type"):
                                            self.constraint_type = value
                                            self.constraint_type.value_namespace = name_space
                                            self.constraint_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "constraint-value"):
                                            self.constraint_value = value
                                            self.constraint_value.value_namespace = name_space
                                            self.constraint_value.value_namespace_prefix = name_space_prefix
                                        if(value_path == "forward-ref-value"):
                                            self.forward_ref_value = value
                                            self.forward_ref_value.value_namespace = name_space
                                            self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.named_affinity:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.affinity_bits.is_set or
                                        self.affinity_mask.is_set)

                                def has_operation(self):
                                    for c in self.named_affinity:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.affinity_bits.yfilter != YFilter.not_set or
                                        self.affinity_mask.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "affinity" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                    if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "named-affinity"):
                                        for c in self.named_affinity:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.named_affinity.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "affinity-bits"):
                                        self.affinity_bits = value
                                        self.affinity_bits.value_namespace = name_space
                                        self.affinity_bits.value_namespace_prefix = name_space_prefix
                                    if(value_path == "affinity-mask"):
                                        self.affinity_mask = value
                                        self.affinity_mask.value_namespace = name_space
                                        self.affinity_mask.value_namespace_prefix = name_space_prefix


                            class TunnelId(Entity):
                                """
                                Tunnel ID
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                    self.yang_name = "tunnel-id"
                                    self.yang_parent_name = "attribute-set-p2mpte"

                                    self.entry = YLeaf(YType.uint16, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "tunnel-id" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.tunnel_id:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.configured_bandwidth.is_set or
                                    self.dste_class_type.is_set or
                                    self.fast_reroute.is_set or
                                    self.frr_bandwidth_protection.is_set or
                                    self.hold_priority.is_set or
                                    self.is_affinity_configured.is_set or
                                    self.is_bandwidth_configured.is_set or
                                    self.is_priority_configured.is_set or
                                    self.setup_priority.is_set or
                                    (self.affinity is not None and self.affinity.has_data()))

                            def has_operation(self):
                                for c in self.tunnel_id:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.configured_bandwidth.yfilter != YFilter.not_set or
                                    self.dste_class_type.yfilter != YFilter.not_set or
                                    self.fast_reroute.yfilter != YFilter.not_set or
                                    self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                    self.hold_priority.yfilter != YFilter.not_set or
                                    self.is_affinity_configured.yfilter != YFilter.not_set or
                                    self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                    self.is_priority_configured.yfilter != YFilter.not_set or
                                    self.setup_priority.yfilter != YFilter.not_set or
                                    (self.affinity is not None and self.affinity.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "attribute-set-p2mpte" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "affinity"):
                                    if (self.affinity is None):
                                        self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                    return self.affinity

                                if (child_yang_name == "tunnel-id"):
                                    for c in self.tunnel_id:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.tunnel_id.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "configured-bandwidth"):
                                    self.configured_bandwidth = value
                                    self.configured_bandwidth.value_namespace = name_space
                                    self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                if(value_path == "dste-class-type"):
                                    self.dste_class_type = value
                                    self.dste_class_type.value_namespace = name_space
                                    self.dste_class_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "fast-reroute"):
                                    self.fast_reroute = value
                                    self.fast_reroute.value_namespace = name_space
                                    self.fast_reroute.value_namespace_prefix = name_space_prefix
                                if(value_path == "frr-bandwidth-protection"):
                                    self.frr_bandwidth_protection = value
                                    self.frr_bandwidth_protection.value_namespace = name_space
                                    self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                if(value_path == "hold-priority"):
                                    self.hold_priority = value
                                    self.hold_priority.value_namespace = name_space
                                    self.hold_priority.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-affinity-configured"):
                                    self.is_affinity_configured = value
                                    self.is_affinity_configured.value_namespace = name_space
                                    self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-bandwidth-configured"):
                                    self.is_bandwidth_configured = value
                                    self.is_bandwidth_configured.value_namespace = name_space
                                    self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-priority-configured"):
                                    self.is_priority_configured = value
                                    self.is_priority_configured.value_namespace = name_space
                                    self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "setup-priority"):
                                    self.setup_priority = value
                                    self.setup_priority.value_namespace = name_space
                                    self.setup_priority.value_namespace_prefix = name_space_prefix


                        class AttributeSetApsPp(Entity):
                            """
                            Attribute Set OTN APS Path Protection
                            
                            .. attribute:: hold_off_time
                            
                            	Hold\-off time
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: path_prot_profile_type
                            
                            	Path Protection Profile Type
                            	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                            
                            .. attribute:: protection_mode
                            
                            	Protection Restoration Mode
                            	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                            
                            .. attribute:: protection_type
                            
                            	Protection Type
                            	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                            
                            .. attribute:: restoration_style
                            
                            	Restoration Style
                            	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                            
                            .. attribute:: revert_schedule
                            
                            	Revert Schedule
                            	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                            
                            .. attribute:: snc_mode
                            
                            	Sub\-network Connection Mode
                            	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                            
                            .. attribute:: tcm_id
                            
                            	Sub\-network Connection Monitoring Mode
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: wait_to_restore_time
                            
                            	Wait to restore time
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                self.yang_name = "attribute-set-aps-pp"
                                self.yang_parent_name = "attribute-set-union"

                                self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                self.revert_schedule.parent = self
                                self._children_name_map["revert_schedule"] = "revert-schedule"
                                self._children_yang_names.add("revert-schedule")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("hold_off_time",
                                                "path_prot_profile_type",
                                                "protection_mode",
                                                "protection_type",
                                                "restoration_style",
                                                "snc_mode",
                                                "tcm_id",
                                                "wait_to_restore_time") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                            class RevertSchedule(Entity):
                                """
                                Revert Schedule
                                
                                .. attribute:: duration
                                
                                	Duration for scheduled reversion
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: max_tries
                                
                                	Max tries for scheduled reversion
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: schedule_date
                                
                                	Schedule time for reversion
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: schedule_frequency
                                
                                	Schedule frequency for reversion
                                	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                
                                .. attribute:: schedulename
                                
                                	Schedule name identifier
                                	**type**\:  str
                                
                                	**length:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                    self.yang_name = "revert-schedule"
                                    self.yang_parent_name = "attribute-set-aps-pp"

                                    self.duration = YLeaf(YType.uint32, "duration")

                                    self.max_tries = YLeaf(YType.uint32, "max-tries")

                                    self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                    self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                    self.schedulename = YLeaf(YType.str, "schedulename")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("duration",
                                                    "max_tries",
                                                    "schedule_date",
                                                    "schedule_frequency",
                                                    "schedulename") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.duration.is_set or
                                        self.max_tries.is_set or
                                        self.schedule_date.is_set or
                                        self.schedule_frequency.is_set or
                                        self.schedulename.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.duration.yfilter != YFilter.not_set or
                                        self.max_tries.yfilter != YFilter.not_set or
                                        self.schedule_date.yfilter != YFilter.not_set or
                                        self.schedule_frequency.yfilter != YFilter.not_set or
                                        self.schedulename.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "revert-schedule" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.duration.get_name_leafdata())
                                    if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.max_tries.get_name_leafdata())
                                    if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                    if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                    if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.schedulename.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "duration"):
                                        self.duration = value
                                        self.duration.value_namespace = name_space
                                        self.duration.value_namespace_prefix = name_space_prefix
                                    if(value_path == "max-tries"):
                                        self.max_tries = value
                                        self.max_tries.value_namespace = name_space
                                        self.max_tries.value_namespace_prefix = name_space_prefix
                                    if(value_path == "schedule-date"):
                                        self.schedule_date = value
                                        self.schedule_date.value_namespace = name_space
                                        self.schedule_date.value_namespace_prefix = name_space_prefix
                                    if(value_path == "schedule-frequency"):
                                        self.schedule_frequency = value
                                        self.schedule_frequency.value_namespace = name_space
                                        self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                    if(value_path == "schedulename"):
                                        self.schedulename = value
                                        self.schedulename.value_namespace = name_space
                                        self.schedulename.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.hold_off_time.is_set or
                                    self.path_prot_profile_type.is_set or
                                    self.protection_mode.is_set or
                                    self.protection_type.is_set or
                                    self.restoration_style.is_set or
                                    self.snc_mode.is_set or
                                    self.tcm_id.is_set or
                                    self.wait_to_restore_time.is_set or
                                    (self.revert_schedule is not None and self.revert_schedule.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.hold_off_time.yfilter != YFilter.not_set or
                                    self.path_prot_profile_type.yfilter != YFilter.not_set or
                                    self.protection_mode.yfilter != YFilter.not_set or
                                    self.protection_type.yfilter != YFilter.not_set or
                                    self.restoration_style.yfilter != YFilter.not_set or
                                    self.snc_mode.yfilter != YFilter.not_set or
                                    self.tcm_id.yfilter != YFilter.not_set or
                                    self.wait_to_restore_time.yfilter != YFilter.not_set or
                                    (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "attribute-set-aps-pp" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.protection_type.get_name_leafdata())
                                if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "revert-schedule"):
                                    if (self.revert_schedule is None):
                                        self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                        self.revert_schedule.parent = self
                                        self._children_name_map["revert_schedule"] = "revert-schedule"
                                    return self.revert_schedule

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "hold-off-time"):
                                    self.hold_off_time = value
                                    self.hold_off_time.value_namespace = name_space
                                    self.hold_off_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-prot-profile-type"):
                                    self.path_prot_profile_type = value
                                    self.path_prot_profile_type.value_namespace = name_space
                                    self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "protection-mode"):
                                    self.protection_mode = value
                                    self.protection_mode.value_namespace = name_space
                                    self.protection_mode.value_namespace_prefix = name_space_prefix
                                if(value_path == "protection-type"):
                                    self.protection_type = value
                                    self.protection_type.value_namespace = name_space
                                    self.protection_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "restoration-style"):
                                    self.restoration_style = value
                                    self.restoration_style.value_namespace = name_space
                                    self.restoration_style.value_namespace_prefix = name_space_prefix
                                if(value_path == "snc-mode"):
                                    self.snc_mode = value
                                    self.snc_mode.value_namespace = name_space
                                    self.snc_mode.value_namespace_prefix = name_space_prefix
                                if(value_path == "tcm-id"):
                                    self.tcm_id = value
                                    self.tcm_id.value_namespace = name_space
                                    self.tcm_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "wait-to-restore-time"):
                                    self.wait_to_restore_time = value
                                    self.wait_to_restore_time.value_namespace = name_space
                                    self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                        class AttributeSetP2PTe(Entity):
                            """
                            MPLS TE P2P\-TE Attribute Set
                            
                            .. attribute:: affinity
                            
                            	Affinity
                            	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                            
                            .. attribute:: is_affinity_configured
                            
                            	Is affinity configured
                            	**type**\:  bool
                            
                            .. attribute:: is_path_invalidation_action_configured
                            
                            	Is Path Invalidation action configured
                            	**type**\:  bool
                            
                            .. attribute:: is_path_invalidation_timeout_configured
                            
                            	Is Path Invalidation timeout configured
                            	**type**\:  bool
                            
                            .. attribute:: is_path_select_configured
                            
                            	Is any of the path selection parameters configured
                            	**type**\:  bool
                            
                            .. attribute:: is_path_selection_metric_configured
                            
                            	Is path selection metric configured
                            	**type**\:  bool
                            
                            .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                            
                            	Is path selection segment routing configured
                            	**type**\:  bool
                            
                            .. attribute:: is_path_selection_segment_routing_margin_configured
                            
                            	Is path selection margin configured
                            	**type**\:  bool
                            
                            .. attribute:: is_path_selection_segment_routing_margin_relative
                            
                            	Path selection margin is\_relative
                            	**type**\:  bool
                            
                            .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                            
                            	Is path selection segment limit configured
                            	**type**\:  bool
                            
                            .. attribute:: is_pce_configured
                            
                            	Is PCE Configured
                            	**type**\:  bool
                            
                            .. attribute:: is_pce_disj_group_id_configured
                            
                            	Is PCE Disjoint Path Group ID Configured
                            	**type**\:  bool
                            
                            .. attribute:: is_pce_disj_source_configured
                            
                            	Is PCE Disjoint Path Source Configured
                            	**type**\:  bool
                            
                            .. attribute:: is_pce_disj_type_configured
                            
                            	Is PCE Disjoint Path Type Configured
                            	**type**\:  bool
                            
                            .. attribute:: is_pceb_dj_source_configured
                            
                            	Is PCE Bidirectional Source Configured
                            	**type**\:  bool
                            
                            .. attribute:: is_pcebd_group_id_configured
                            
                            	Is PCE Bidirectional Group ID Configured
                            	**type**\:  bool
                            
                            .. attribute:: is_prepend_list_configured
                            
                            	Is SR prepend list configured
                            	**type**\:  bool
                            
                            .. attribute:: logging
                            
                            	Logging attributes
                            	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                            
                            .. attribute:: path_invalidation_timeout
                            
                            	Path invalidation timeout on the tunnel path
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: path_selection_invalidation_action
                            
                            	Path invalidation action
                            	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                            
                            .. attribute:: path_selection_metric
                            
                            	Path selection metric type
                            	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                            
                            .. attribute:: path_selection_segment_routing_adjacency_protection
                            
                            	Path selection segment\-routing type
                            	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                            
                            .. attribute:: path_selection_segment_routing_margin
                            
                            	Path selection margin
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: path_selection_segment_routing_segment_limit
                            
                            	Is path selection segment limit configured
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: pcebd_group_id
                            
                            	PCE Bidirectional Group ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: pcebd_source_address
                            
                            	PCE Bidirectional Source Address
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: pcedp_group_id
                            
                            	PCE Disjoint Path Group ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: pcedp_source_address
                            
                            	PCE Disjoint Path Source Address
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: pcedp_type
                            
                            	PCE Disjoint Path Type
                            	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                            
                            .. attribute:: prepend_list
                            
                            	SR prepend list
                            	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                            
                            .. attribute:: tunnel_id
                            
                            	Tunnel ID
                            	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                self.yang_name = "attribute-set-p2p-te"
                                self.yang_parent_name = "attribute-set-union"

                                self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                self.affinity.parent = self
                                self._children_name_map["affinity"] = "affinity"
                                self._children_yang_names.add("affinity")

                                self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                self.logging.parent = self
                                self._children_name_map["logging"] = "logging"
                                self._children_yang_names.add("logging")

                                self.prepend_list = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                self.prepend_list.parent = self
                                self._children_name_map["prepend_list"] = "prepend-list"
                                self._children_yang_names.add("prepend-list")

                                self.tunnel_id = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("is_affinity_configured",
                                                "is_path_invalidation_action_configured",
                                                "is_path_invalidation_timeout_configured",
                                                "is_path_select_configured",
                                                "is_path_selection_metric_configured",
                                                "is_path_selection_segment_routing_adjacency_protection_configured",
                                                "is_path_selection_segment_routing_margin_configured",
                                                "is_path_selection_segment_routing_margin_relative",
                                                "is_path_selection_segment_routing_segment_limit_configured",
                                                "is_pce_configured",
                                                "is_pce_disj_group_id_configured",
                                                "is_pce_disj_source_configured",
                                                "is_pce_disj_type_configured",
                                                "is_pceb_dj_source_configured",
                                                "is_pcebd_group_id_configured",
                                                "is_prepend_list_configured",
                                                "path_invalidation_timeout",
                                                "path_selection_invalidation_action",
                                                "path_selection_metric",
                                                "path_selection_segment_routing_adjacency_protection",
                                                "path_selection_segment_routing_margin",
                                                "path_selection_segment_routing_segment_limit",
                                                "pcebd_group_id",
                                                "pcebd_source_address",
                                                "pcedp_group_id",
                                                "pcedp_source_address",
                                                "pcedp_type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                            class Affinity(Entity):
                                """
                                Affinity
                                
                                .. attribute:: affinity_bits
                                
                                	The affinity bits (colors)
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: affinity_mask
                                
                                	The affinity mask (colors)
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: named_affinity
                                
                                	Array of name based constratints currently applied to the tunnel
                                	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                    self.yang_name = "affinity"
                                    self.yang_parent_name = "attribute-set-p2p-te"

                                    self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                    self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                    self.named_affinity = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("affinity_bits",
                                                    "affinity_mask") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                class NamedAffinity(Entity):
                                    """
                                    Array of name based constratints currently
                                    applied to the tunnel
                                    
                                    .. attribute:: constraint_extended_value
                                    
                                    	Constraint value
                                    	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                    
                                    .. attribute:: constraint_type
                                    
                                    	Constraint type
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: constraint_value
                                    
                                    	Deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: extended_forward_ref_value
                                    
                                    	Reference bits for undefined affinity names
                                    	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                    
                                    .. attribute:: forward_ref_value
                                    
                                    	Deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                        self.yang_name = "named-affinity"
                                        self.yang_parent_name = "affinity"

                                        self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                        self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                        self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                        self.constraint_extended_value = YList(self)
                                        self.extended_forward_ref_value = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("constraint_type",
                                                        "constraint_value",
                                                        "forward_ref_value") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                    class ConstraintExtendedValue(Entity):
                                        """
                                        Constraint value
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                            self.yang_name = "constraint-extended-value"
                                            self.yang_parent_name = "named-affinity"

                                            self.entry = YLeaf(YType.uint32, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "constraint-extended-value" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class ExtendedForwardRefValue(Entity):
                                        """
                                        Reference bits for undefined affinity names
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                            self.yang_name = "extended-forward-ref-value"
                                            self.yang_parent_name = "named-affinity"

                                            self.entry = YLeaf(YType.uint32, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "extended-forward-ref-value" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.constraint_extended_value:
                                            if (c.has_data()):
                                                return True
                                        for c in self.extended_forward_ref_value:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.constraint_type.is_set or
                                            self.constraint_value.is_set or
                                            self.forward_ref_value.is_set)

                                    def has_operation(self):
                                        for c in self.constraint_extended_value:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.extended_forward_ref_value:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.constraint_type.yfilter != YFilter.not_set or
                                            self.constraint_value.yfilter != YFilter.not_set or
                                            self.forward_ref_value.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "named-affinity" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                        if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                        if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "constraint-extended-value"):
                                            for c in self.constraint_extended_value:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.constraint_extended_value.append(c)
                                            return c

                                        if (child_yang_name == "extended-forward-ref-value"):
                                            for c in self.extended_forward_ref_value:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.extended_forward_ref_value.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "constraint-type"):
                                            self.constraint_type = value
                                            self.constraint_type.value_namespace = name_space
                                            self.constraint_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "constraint-value"):
                                            self.constraint_value = value
                                            self.constraint_value.value_namespace = name_space
                                            self.constraint_value.value_namespace_prefix = name_space_prefix
                                        if(value_path == "forward-ref-value"):
                                            self.forward_ref_value = value
                                            self.forward_ref_value.value_namespace = name_space
                                            self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.named_affinity:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.affinity_bits.is_set or
                                        self.affinity_mask.is_set)

                                def has_operation(self):
                                    for c in self.named_affinity:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.affinity_bits.yfilter != YFilter.not_set or
                                        self.affinity_mask.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "affinity" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                    if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "named-affinity"):
                                        for c in self.named_affinity:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.named_affinity.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "affinity-bits"):
                                        self.affinity_bits = value
                                        self.affinity_bits.value_namespace = name_space
                                        self.affinity_bits.value_namespace_prefix = name_space_prefix
                                    if(value_path == "affinity-mask"):
                                        self.affinity_mask = value
                                        self.affinity_mask.value_namespace = name_space
                                        self.affinity_mask.value_namespace_prefix = name_space_prefix


                            class Logging(Entity):
                                """
                                Logging attributes
                                
                                .. attribute:: all_logging_enabled
                                
                                	All logging option\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: lsp_bandwidth_change
                                
                                	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: lsp_insufficient_bw
                                
                                	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: lsp_pcalc_failure_logging_enabled
                                
                                	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: lsp_re_opt
                                
                                	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: lsp_re_route
                                
                                	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: lsp_state
                                
                                	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                .. attribute:: s2l_state
                                
                                	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                	**type**\:  bool
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                    self.yang_name = "logging"
                                    self.yang_parent_name = "attribute-set-p2p-te"

                                    self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                    self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                    self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                    self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                    self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                    self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                    self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                    self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("all_logging_enabled",
                                                    "lsp_bandwidth_change",
                                                    "lsp_insufficient_bw",
                                                    "lsp_pcalc_failure_logging_enabled",
                                                    "lsp_re_opt",
                                                    "lsp_re_route",
                                                    "lsp_state",
                                                    "s2l_state") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.all_logging_enabled.is_set or
                                        self.lsp_bandwidth_change.is_set or
                                        self.lsp_insufficient_bw.is_set or
                                        self.lsp_pcalc_failure_logging_enabled.is_set or
                                        self.lsp_re_opt.is_set or
                                        self.lsp_re_route.is_set or
                                        self.lsp_state.is_set or
                                        self.s2l_state.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.all_logging_enabled.yfilter != YFilter.not_set or
                                        self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                        self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                        self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                        self.lsp_re_opt.yfilter != YFilter.not_set or
                                        self.lsp_re_route.yfilter != YFilter.not_set or
                                        self.lsp_state.yfilter != YFilter.not_set or
                                        self.s2l_state.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "logging" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                    if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                    if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                    if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                    if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                    if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                    if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                    if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "all-logging-enabled"):
                                        self.all_logging_enabled = value
                                        self.all_logging_enabled.value_namespace = name_space
                                        self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-bandwidth-change"):
                                        self.lsp_bandwidth_change = value
                                        self.lsp_bandwidth_change.value_namespace = name_space
                                        self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-insufficient-bw"):
                                        self.lsp_insufficient_bw = value
                                        self.lsp_insufficient_bw.value_namespace = name_space
                                        self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                        self.lsp_pcalc_failure_logging_enabled = value
                                        self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                        self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-re-opt"):
                                        self.lsp_re_opt = value
                                        self.lsp_re_opt.value_namespace = name_space
                                        self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-re-route"):
                                        self.lsp_re_route = value
                                        self.lsp_re_route.value_namespace = name_space
                                        self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                    if(value_path == "lsp-state"):
                                        self.lsp_state = value
                                        self.lsp_state.value_namespace = name_space
                                        self.lsp_state.value_namespace_prefix = name_space_prefix
                                    if(value_path == "s2l-state"):
                                        self.s2l_state = value
                                        self.s2l_state.value_namespace = name_space
                                        self.s2l_state.value_namespace_prefix = name_space_prefix


                            class PrependList(Entity):
                                """
                                SR prepend list
                                
                                .. attribute:: prepend_entry
                                
                                	List of prepend entries
                                	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                    self.yang_name = "prepend-list"
                                    self.yang_parent_name = "attribute-set-p2p-te"

                                    self.prepend_entry = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in () and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                class PrependEntry(Entity):
                                    """
                                    List of prepend entries
                                    
                                    .. attribute:: index
                                    
                                    	Prepend index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: next_label
                                    
                                    	Prepend next label
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: type
                                    
                                    	Prepend Type
                                    	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                        self.yang_name = "prepend-entry"
                                        self.yang_parent_name = "prepend-list"

                                        self.index = YLeaf(YType.uint32, "index")

                                        self.next_label = YLeaf(YType.uint32, "next-label")

                                        self.type = YLeaf(YType.enumeration, "type")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("index",
                                                        "next_label",
                                                        "type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.index.is_set or
                                            self.next_label.is_set or
                                            self.type.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.index.yfilter != YFilter.not_set or
                                            self.next_label.yfilter != YFilter.not_set or
                                            self.type.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "prepend-entry" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.index.get_name_leafdata())
                                        if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.next_label.get_name_leafdata())
                                        if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "index" or name == "next-label" or name == "type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "index"):
                                            self.index = value
                                            self.index.value_namespace = name_space
                                            self.index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "next-label"):
                                            self.next_label = value
                                            self.next_label.value_namespace = name_space
                                            self.next_label.value_namespace_prefix = name_space_prefix
                                        if(value_path == "type"):
                                            self.type = value
                                            self.type.value_namespace = name_space
                                            self.type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.prepend_entry:
                                        if (c.has_data()):
                                            return True
                                    return False

                                def has_operation(self):
                                    for c in self.prepend_entry:
                                        if (c.has_operation()):
                                            return True
                                    return self.yfilter != YFilter.not_set

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "prepend-list" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "prepend-entry"):
                                        for c in self.prepend_entry:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.prepend_entry.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "prepend-entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    pass


                            class TunnelId(Entity):
                                """
                                Tunnel ID
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                    self.yang_name = "tunnel-id"
                                    self.yang_parent_name = "attribute-set-p2p-te"

                                    self.entry = YLeaf(YType.uint16, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "tunnel-id" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.tunnel_id:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.is_affinity_configured.is_set or
                                    self.is_path_invalidation_action_configured.is_set or
                                    self.is_path_invalidation_timeout_configured.is_set or
                                    self.is_path_select_configured.is_set or
                                    self.is_path_selection_metric_configured.is_set or
                                    self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                    self.is_path_selection_segment_routing_margin_configured.is_set or
                                    self.is_path_selection_segment_routing_margin_relative.is_set or
                                    self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                    self.is_pce_configured.is_set or
                                    self.is_pce_disj_group_id_configured.is_set or
                                    self.is_pce_disj_source_configured.is_set or
                                    self.is_pce_disj_type_configured.is_set or
                                    self.is_pceb_dj_source_configured.is_set or
                                    self.is_pcebd_group_id_configured.is_set or
                                    self.is_prepend_list_configured.is_set or
                                    self.path_invalidation_timeout.is_set or
                                    self.path_selection_invalidation_action.is_set or
                                    self.path_selection_metric.is_set or
                                    self.path_selection_segment_routing_adjacency_protection.is_set or
                                    self.path_selection_segment_routing_margin.is_set or
                                    self.path_selection_segment_routing_segment_limit.is_set or
                                    self.pcebd_group_id.is_set or
                                    self.pcebd_source_address.is_set or
                                    self.pcedp_group_id.is_set or
                                    self.pcedp_source_address.is_set or
                                    self.pcedp_type.is_set or
                                    (self.affinity is not None and self.affinity.has_data()) or
                                    (self.logging is not None and self.logging.has_data()) or
                                    (self.prepend_list is not None and self.prepend_list.has_data()))

                            def has_operation(self):
                                for c in self.tunnel_id:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.is_affinity_configured.yfilter != YFilter.not_set or
                                    self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                    self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                    self.is_path_select_configured.yfilter != YFilter.not_set or
                                    self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                    self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                    self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                    self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                    self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                    self.is_pce_configured.yfilter != YFilter.not_set or
                                    self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                    self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                    self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                    self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                    self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                    self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                    self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                    self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                    self.path_selection_metric.yfilter != YFilter.not_set or
                                    self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                    self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                    self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                    self.pcebd_group_id.yfilter != YFilter.not_set or
                                    self.pcebd_source_address.yfilter != YFilter.not_set or
                                    self.pcedp_group_id.yfilter != YFilter.not_set or
                                    self.pcedp_source_address.yfilter != YFilter.not_set or
                                    self.pcedp_type.yfilter != YFilter.not_set or
                                    (self.affinity is not None and self.affinity.has_operation()) or
                                    (self.logging is not None and self.logging.has_operation()) or
                                    (self.prepend_list is not None and self.prepend_list.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "attribute-set-p2p-te" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "affinity"):
                                    if (self.affinity is None):
                                        self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                    return self.affinity

                                if (child_yang_name == "logging"):
                                    if (self.logging is None):
                                        self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"
                                    return self.logging

                                if (child_yang_name == "prepend-list"):
                                    if (self.prepend_list is None):
                                        self.prepend_list = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                        self.prepend_list.parent = self
                                        self._children_name_map["prepend_list"] = "prepend-list"
                                    return self.prepend_list

                                if (child_yang_name == "tunnel-id"):
                                    for c in self.tunnel_id:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.tunnel_id.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "is-affinity-configured"):
                                    self.is_affinity_configured = value
                                    self.is_affinity_configured.value_namespace = name_space
                                    self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-path-invalidation-action-configured"):
                                    self.is_path_invalidation_action_configured = value
                                    self.is_path_invalidation_action_configured.value_namespace = name_space
                                    self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-path-invalidation-timeout-configured"):
                                    self.is_path_invalidation_timeout_configured = value
                                    self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                    self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-path-select-configured"):
                                    self.is_path_select_configured = value
                                    self.is_path_select_configured.value_namespace = name_space
                                    self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-path-selection-metric-configured"):
                                    self.is_path_selection_metric_configured = value
                                    self.is_path_selection_metric_configured.value_namespace = name_space
                                    self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                    self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                    self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                    self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                    self.is_path_selection_segment_routing_margin_configured = value
                                    self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                    self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                    self.is_path_selection_segment_routing_margin_relative = value
                                    self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                    self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                    self.is_path_selection_segment_routing_segment_limit_configured = value
                                    self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                    self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-pce-configured"):
                                    self.is_pce_configured = value
                                    self.is_pce_configured.value_namespace = name_space
                                    self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-pce-disj-group-id-configured"):
                                    self.is_pce_disj_group_id_configured = value
                                    self.is_pce_disj_group_id_configured.value_namespace = name_space
                                    self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-pce-disj-source-configured"):
                                    self.is_pce_disj_source_configured = value
                                    self.is_pce_disj_source_configured.value_namespace = name_space
                                    self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-pce-disj-type-configured"):
                                    self.is_pce_disj_type_configured = value
                                    self.is_pce_disj_type_configured.value_namespace = name_space
                                    self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-pceb-dj-source-configured"):
                                    self.is_pceb_dj_source_configured = value
                                    self.is_pceb_dj_source_configured.value_namespace = name_space
                                    self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-pcebd-group-id-configured"):
                                    self.is_pcebd_group_id_configured = value
                                    self.is_pcebd_group_id_configured.value_namespace = name_space
                                    self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-prepend-list-configured"):
                                    self.is_prepend_list_configured = value
                                    self.is_prepend_list_configured.value_namespace = name_space
                                    self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-invalidation-timeout"):
                                    self.path_invalidation_timeout = value
                                    self.path_invalidation_timeout.value_namespace = name_space
                                    self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-selection-invalidation-action"):
                                    self.path_selection_invalidation_action = value
                                    self.path_selection_invalidation_action.value_namespace = name_space
                                    self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-selection-metric"):
                                    self.path_selection_metric = value
                                    self.path_selection_metric.value_namespace = name_space
                                    self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                    self.path_selection_segment_routing_adjacency_protection = value
                                    self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                    self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-selection-segment-routing-margin"):
                                    self.path_selection_segment_routing_margin = value
                                    self.path_selection_segment_routing_margin.value_namespace = name_space
                                    self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                if(value_path == "path-selection-segment-routing-segment-limit"):
                                    self.path_selection_segment_routing_segment_limit = value
                                    self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                    self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                if(value_path == "pcebd-group-id"):
                                    self.pcebd_group_id = value
                                    self.pcebd_group_id.value_namespace = name_space
                                    self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "pcebd-source-address"):
                                    self.pcebd_source_address = value
                                    self.pcebd_source_address.value_namespace = name_space
                                    self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "pcedp-group-id"):
                                    self.pcedp_group_id = value
                                    self.pcedp_group_id.value_namespace = name_space
                                    self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "pcedp-source-address"):
                                    self.pcedp_source_address = value
                                    self.pcedp_source_address.value_namespace = name_space
                                    self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "pcedp-type"):
                                    self.pcedp_type = value
                                    self.pcedp_type.value_namespace = name_space
                                    self.pcedp_type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.tunnel_attribute_set_type.is_set or
                                (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "attribute-set-union" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "attribute-set-aps-pp"):
                                if (self.attribute_set_aps_pp is None):
                                    self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                    self.attribute_set_aps_pp.parent = self
                                    self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                return self.attribute_set_aps_pp

                            if (child_yang_name == "attribute-set-autobackup"):
                                if (self.attribute_set_autobackup is None):
                                    self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                    self.attribute_set_autobackup.parent = self
                                    self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                return self.attribute_set_autobackup

                            if (child_yang_name == "attribute-set-automesh"):
                                if (self.attribute_set_automesh is None):
                                    self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                    self.attribute_set_automesh.parent = self
                                    self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                return self.attribute_set_automesh

                            if (child_yang_name == "attribute-set-p2mpte"):
                                if (self.attribute_set_p2mpte is None):
                                    self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                    self.attribute_set_p2mpte.parent = self
                                    self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                return self.attribute_set_p2mpte

                            if (child_yang_name == "attribute-set-p2p-te"):
                                if (self.attribute_set_p2p_te is None):
                                    self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                    self.attribute_set_p2p_te.parent = self
                                    self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                return self.attribute_set_p2p_te

                            if (child_yang_name == "attribute-set-path-option"):
                                if (self.attribute_set_path_option is None):
                                    self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                    self.attribute_set_path_option.parent = self
                                    self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                return self.attribute_set_path_option

                            if (child_yang_name == "attribute-set-xro"):
                                if (self.attribute_set_xro is None):
                                    self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                    self.attribute_set_xro.parent = self
                                    self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                return self.attribute_set_xro

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "tunnel-attribute-set-type"):
                                self.tunnel_attribute_set_type = value
                                self.tunnel_attribute_set_type.value_namespace = name_space
                                self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.tunnel_attribute_set_name.is_set or
                            self.tunnel_attribute_set_name_crc32.is_set or
                            (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                            self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                            (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "xro-attribute-set" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                        if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "attribute-set-union"):
                            if (self.attribute_set_union is None):
                                self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet.AttributeSetUnion()
                                self.attribute_set_union.parent = self
                                self._children_name_map["attribute_set_union"] = "attribute-set-union"
                            return self.attribute_set_union

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "tunnel-attribute-set-name"):
                            self.tunnel_attribute_set_name = value
                            self.tunnel_attribute_set_name.value_namespace = name_space
                            self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "tunnel-attribute-set-name-crc32"):
                            self.tunnel_attribute_set_name_crc32 = value
                            self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                            self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                class TeTunnelConvergence(Entity):
                    """
                    TE tunnel convergence related information
                    
                    .. attribute:: binding_label_rewrite_time
                    
                    	Binding label timestamp (clocktime in nsecs)
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**units**\: nanosecond
                    
                    .. attribute:: convergence_complete_time
                    
                    	TE convergence completion time
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: convergence_lsp
                    
                    	TE LSP convergence related information
                    	**type**\:   :py:class:`ConvergenceLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TeTunnelConvergence.ConvergenceLsp>`
                    
                    .. attribute:: frr_trigger_time
                    
                    	FRR trigger time
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    .. attribute:: is_convergence_in_progress
                    
                    	TE convergence in progress
                    	**type**\:  bool
                    
                    .. attribute:: pcalc_complete_time
                    
                    	Path computation completion timestamp (clocktime in nsecs)
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**units**\: nanosecond
                    
                    .. attribute:: vif_creation_time
                    
                    	Vif creation timestamp (clocktime in nsecs)
                    	**type**\:  int
                    
                    	**range:** 0..18446744073709551615
                    
                    	**units**\: nanosecond
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TeTunnelConvergence, self).__init__()

                        self.yang_name = "te-tunnel-convergence"
                        self.yang_parent_name = "tunnel-head"

                        self.binding_label_rewrite_time = YLeaf(YType.uint64, "binding-label-rewrite-time")

                        self.convergence_complete_time = YLeaf(YType.uint64, "convergence-complete-time")

                        self.frr_trigger_time = YLeaf(YType.uint64, "frr-trigger-time")

                        self.is_convergence_in_progress = YLeaf(YType.boolean, "is-convergence-in-progress")

                        self.pcalc_complete_time = YLeaf(YType.uint64, "pcalc-complete-time")

                        self.vif_creation_time = YLeaf(YType.uint64, "vif-creation-time")

                        self.convergence_lsp = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TeTunnelConvergence.ConvergenceLsp()
                        self.convergence_lsp.parent = self
                        self._children_name_map["convergence_lsp"] = "convergence-lsp"
                        self._children_yang_names.add("convergence-lsp")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("binding_label_rewrite_time",
                                        "convergence_complete_time",
                                        "frr_trigger_time",
                                        "is_convergence_in_progress",
                                        "pcalc_complete_time",
                                        "vif_creation_time") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TeTunnelConvergence, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TeTunnelConvergence, self).__setattr__(name, value)


                    class ConvergenceLsp(Entity):
                        """
                        TE LSP convergence related information
                        
                        .. attribute:: creation_time
                        
                        	Tunnel creation timestamp (clocktime in nsecs)
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: label_rewrite
                        
                        	LSP Label rewrite timestamp (clocktime in nsecs)
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: path_in
                        
                        	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: path_out
                        
                        	LSP RSVP Path\-in timestamp (clocktime in nsecs)
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: resv_in
                        
                        	LSP RSVP Resv\-in timestamp (clocktime in nsecs)
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: resv_out
                        
                        	LSP RSVP Resv\-out timestamp (clocktime in nsecs)
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: nanosecond
                        
                        .. attribute:: tunnel_rewrite
                        
                        	Tunnel rewrite timestamp (clocktime in nsecs)
                        	**type**\:  int
                        
                        	**range:** 0..18446744073709551615
                        
                        	**units**\: nanosecond
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TeTunnelConvergence.ConvergenceLsp, self).__init__()

                            self.yang_name = "convergence-lsp"
                            self.yang_parent_name = "te-tunnel-convergence"

                            self.creation_time = YLeaf(YType.uint64, "creation-time")

                            self.label_rewrite = YLeaf(YType.uint64, "label-rewrite")

                            self.path_in = YLeaf(YType.uint64, "path-in")

                            self.path_out = YLeaf(YType.uint64, "path-out")

                            self.resv_in = YLeaf(YType.uint64, "resv-in")

                            self.resv_out = YLeaf(YType.uint64, "resv-out")

                            self.tunnel_rewrite = YLeaf(YType.uint64, "tunnel-rewrite")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("creation_time",
                                            "label_rewrite",
                                            "path_in",
                                            "path_out",
                                            "resv_in",
                                            "resv_out",
                                            "tunnel_rewrite") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TeTunnelConvergence.ConvergenceLsp, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TeTunnelConvergence.ConvergenceLsp, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.creation_time.is_set or
                                self.label_rewrite.is_set or
                                self.path_in.is_set or
                                self.path_out.is_set or
                                self.resv_in.is_set or
                                self.resv_out.is_set or
                                self.tunnel_rewrite.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.creation_time.yfilter != YFilter.not_set or
                                self.label_rewrite.yfilter != YFilter.not_set or
                                self.path_in.yfilter != YFilter.not_set or
                                self.path_out.yfilter != YFilter.not_set or
                                self.resv_in.yfilter != YFilter.not_set or
                                self.resv_out.yfilter != YFilter.not_set or
                                self.tunnel_rewrite.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "convergence-lsp" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.creation_time.is_set or self.creation_time.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.creation_time.get_name_leafdata())
                            if (self.label_rewrite.is_set or self.label_rewrite.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.label_rewrite.get_name_leafdata())
                            if (self.path_in.is_set or self.path_in.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_in.get_name_leafdata())
                            if (self.path_out.is_set or self.path_out.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_out.get_name_leafdata())
                            if (self.resv_in.is_set or self.resv_in.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.resv_in.get_name_leafdata())
                            if (self.resv_out.is_set or self.resv_out.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.resv_out.get_name_leafdata())
                            if (self.tunnel_rewrite.is_set or self.tunnel_rewrite.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tunnel_rewrite.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "creation-time" or name == "label-rewrite" or name == "path-in" or name == "path-out" or name == "resv-in" or name == "resv-out" or name == "tunnel-rewrite"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "creation-time"):
                                self.creation_time = value
                                self.creation_time.value_namespace = name_space
                                self.creation_time.value_namespace_prefix = name_space_prefix
                            if(value_path == "label-rewrite"):
                                self.label_rewrite = value
                                self.label_rewrite.value_namespace = name_space
                                self.label_rewrite.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-in"):
                                self.path_in = value
                                self.path_in.value_namespace = name_space
                                self.path_in.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-out"):
                                self.path_out = value
                                self.path_out.value_namespace = name_space
                                self.path_out.value_namespace_prefix = name_space_prefix
                            if(value_path == "resv-in"):
                                self.resv_in = value
                                self.resv_in.value_namespace = name_space
                                self.resv_in.value_namespace_prefix = name_space_prefix
                            if(value_path == "resv-out"):
                                self.resv_out = value
                                self.resv_out.value_namespace = name_space
                                self.resv_out.value_namespace_prefix = name_space_prefix
                            if(value_path == "tunnel-rewrite"):
                                self.tunnel_rewrite = value
                                self.tunnel_rewrite.value_namespace = name_space
                                self.tunnel_rewrite.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.binding_label_rewrite_time.is_set or
                            self.convergence_complete_time.is_set or
                            self.frr_trigger_time.is_set or
                            self.is_convergence_in_progress.is_set or
                            self.pcalc_complete_time.is_set or
                            self.vif_creation_time.is_set or
                            (self.convergence_lsp is not None and self.convergence_lsp.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.binding_label_rewrite_time.yfilter != YFilter.not_set or
                            self.convergence_complete_time.yfilter != YFilter.not_set or
                            self.frr_trigger_time.yfilter != YFilter.not_set or
                            self.is_convergence_in_progress.yfilter != YFilter.not_set or
                            self.pcalc_complete_time.yfilter != YFilter.not_set or
                            self.vif_creation_time.yfilter != YFilter.not_set or
                            (self.convergence_lsp is not None and self.convergence_lsp.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "te-tunnel-convergence" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.binding_label_rewrite_time.is_set or self.binding_label_rewrite_time.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.binding_label_rewrite_time.get_name_leafdata())
                        if (self.convergence_complete_time.is_set or self.convergence_complete_time.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.convergence_complete_time.get_name_leafdata())
                        if (self.frr_trigger_time.is_set or self.frr_trigger_time.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.frr_trigger_time.get_name_leafdata())
                        if (self.is_convergence_in_progress.is_set or self.is_convergence_in_progress.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_convergence_in_progress.get_name_leafdata())
                        if (self.pcalc_complete_time.is_set or self.pcalc_complete_time.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.pcalc_complete_time.get_name_leafdata())
                        if (self.vif_creation_time.is_set or self.vif_creation_time.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.vif_creation_time.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "convergence-lsp"):
                            if (self.convergence_lsp is None):
                                self.convergence_lsp = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TeTunnelConvergence.ConvergenceLsp()
                                self.convergence_lsp.parent = self
                                self._children_name_map["convergence_lsp"] = "convergence-lsp"
                            return self.convergence_lsp

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "convergence-lsp" or name == "binding-label-rewrite-time" or name == "convergence-complete-time" or name == "frr-trigger-time" or name == "is-convergence-in-progress" or name == "pcalc-complete-time" or name == "vif-creation-time"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "binding-label-rewrite-time"):
                            self.binding_label_rewrite_time = value
                            self.binding_label_rewrite_time.value_namespace = name_space
                            self.binding_label_rewrite_time.value_namespace_prefix = name_space_prefix
                        if(value_path == "convergence-complete-time"):
                            self.convergence_complete_time = value
                            self.convergence_complete_time.value_namespace = name_space
                            self.convergence_complete_time.value_namespace_prefix = name_space_prefix
                        if(value_path == "frr-trigger-time"):
                            self.frr_trigger_time = value
                            self.frr_trigger_time.value_namespace = name_space
                            self.frr_trigger_time.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-convergence-in-progress"):
                            self.is_convergence_in_progress = value
                            self.is_convergence_in_progress.value_namespace = name_space
                            self.is_convergence_in_progress.value_namespace_prefix = name_space_prefix
                        if(value_path == "pcalc-complete-time"):
                            self.pcalc_complete_time = value
                            self.pcalc_complete_time.value_namespace = name_space
                            self.pcalc_complete_time.value_namespace_prefix = name_space_prefix
                        if(value_path == "vif-creation-time"):
                            self.vif_creation_time = value
                            self.vif_creation_time.value_namespace = name_space
                            self.vif_creation_time.value_namespace_prefix = name_space_prefix


                class FlexInfo(Entity):
                    """
                    Flex Info
                    
                    .. attribute:: fault_ais
                    
                    	Fault AIS
                    	**type**\:  bool
                    
                    .. attribute:: fault_in_label
                    
                    	Fault In Label
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: fault_ldi
                    
                    	Fault LDI
                    	**type**\:  bool
                    
                    .. attribute:: fault_ldi_lockout
                    
                    	Fault LDI Lockout
                    	**type**\:  bool
                    
                    .. attribute:: fault_lkr
                    
                    	Fault LKR
                    	**type**\:  bool
                    
                    .. attribute:: fault_time
                    
                    	Fault Time
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: is_lockout
                    
                    	Lockout Status
                    	**type**\:  bool
                    
                    .. attribute:: lockout_lsp_id
                    
                    	The LSP ID of the locked out LSP
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: lockout_timestamp
                    
                    	The timestamp when the lockout is set
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: origination
                    
                    	Flex LSP Lockout Origination Source
                    	**type**\:   :py:class:`FlexLspLockoutOrigination <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.FlexLspLockoutOrigination>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.FlexInfo, self).__init__()

                        self.yang_name = "flex-info"
                        self.yang_parent_name = "tunnel-head"

                        self.fault_ais = YLeaf(YType.boolean, "fault-ais")

                        self.fault_in_label = YLeaf(YType.uint32, "fault-in-label")

                        self.fault_ldi = YLeaf(YType.boolean, "fault-ldi")

                        self.fault_ldi_lockout = YLeaf(YType.boolean, "fault-ldi-lockout")

                        self.fault_lkr = YLeaf(YType.boolean, "fault-lkr")

                        self.fault_time = YLeaf(YType.uint32, "fault-time")

                        self.is_lockout = YLeaf(YType.boolean, "is-lockout")

                        self.lockout_lsp_id = YLeaf(YType.uint16, "lockout-lsp-id")

                        self.lockout_timestamp = YLeaf(YType.uint32, "lockout-timestamp")

                        self.origination = YLeaf(YType.enumeration, "origination")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("fault_ais",
                                        "fault_in_label",
                                        "fault_ldi",
                                        "fault_ldi_lockout",
                                        "fault_lkr",
                                        "fault_time",
                                        "is_lockout",
                                        "lockout_lsp_id",
                                        "lockout_timestamp",
                                        "origination") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.FlexInfo, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.FlexInfo, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.fault_ais.is_set or
                            self.fault_in_label.is_set or
                            self.fault_ldi.is_set or
                            self.fault_ldi_lockout.is_set or
                            self.fault_lkr.is_set or
                            self.fault_time.is_set or
                            self.is_lockout.is_set or
                            self.lockout_lsp_id.is_set or
                            self.lockout_timestamp.is_set or
                            self.origination.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.fault_ais.yfilter != YFilter.not_set or
                            self.fault_in_label.yfilter != YFilter.not_set or
                            self.fault_ldi.yfilter != YFilter.not_set or
                            self.fault_ldi_lockout.yfilter != YFilter.not_set or
                            self.fault_lkr.yfilter != YFilter.not_set or
                            self.fault_time.yfilter != YFilter.not_set or
                            self.is_lockout.yfilter != YFilter.not_set or
                            self.lockout_lsp_id.yfilter != YFilter.not_set or
                            self.lockout_timestamp.yfilter != YFilter.not_set or
                            self.origination.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "flex-info" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.fault_ais.is_set or self.fault_ais.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.fault_ais.get_name_leafdata())
                        if (self.fault_in_label.is_set or self.fault_in_label.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.fault_in_label.get_name_leafdata())
                        if (self.fault_ldi.is_set or self.fault_ldi.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.fault_ldi.get_name_leafdata())
                        if (self.fault_ldi_lockout.is_set or self.fault_ldi_lockout.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.fault_ldi_lockout.get_name_leafdata())
                        if (self.fault_lkr.is_set or self.fault_lkr.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.fault_lkr.get_name_leafdata())
                        if (self.fault_time.is_set or self.fault_time.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.fault_time.get_name_leafdata())
                        if (self.is_lockout.is_set or self.is_lockout.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_lockout.get_name_leafdata())
                        if (self.lockout_lsp_id.is_set or self.lockout_lsp_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lockout_lsp_id.get_name_leafdata())
                        if (self.lockout_timestamp.is_set or self.lockout_timestamp.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lockout_timestamp.get_name_leafdata())
                        if (self.origination.is_set or self.origination.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.origination.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "fault-ais" or name == "fault-in-label" or name == "fault-ldi" or name == "fault-ldi-lockout" or name == "fault-lkr" or name == "fault-time" or name == "is-lockout" or name == "lockout-lsp-id" or name == "lockout-timestamp" or name == "origination"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "fault-ais"):
                            self.fault_ais = value
                            self.fault_ais.value_namespace = name_space
                            self.fault_ais.value_namespace_prefix = name_space_prefix
                        if(value_path == "fault-in-label"):
                            self.fault_in_label = value
                            self.fault_in_label.value_namespace = name_space
                            self.fault_in_label.value_namespace_prefix = name_space_prefix
                        if(value_path == "fault-ldi"):
                            self.fault_ldi = value
                            self.fault_ldi.value_namespace = name_space
                            self.fault_ldi.value_namespace_prefix = name_space_prefix
                        if(value_path == "fault-ldi-lockout"):
                            self.fault_ldi_lockout = value
                            self.fault_ldi_lockout.value_namespace = name_space
                            self.fault_ldi_lockout.value_namespace_prefix = name_space_prefix
                        if(value_path == "fault-lkr"):
                            self.fault_lkr = value
                            self.fault_lkr.value_namespace = name_space
                            self.fault_lkr.value_namespace_prefix = name_space_prefix
                        if(value_path == "fault-time"):
                            self.fault_time = value
                            self.fault_time.value_namespace = name_space
                            self.fault_time.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-lockout"):
                            self.is_lockout = value
                            self.is_lockout.value_namespace = name_space
                            self.is_lockout.value_namespace_prefix = name_space_prefix
                        if(value_path == "lockout-lsp-id"):
                            self.lockout_lsp_id = value
                            self.lockout_lsp_id.value_namespace = name_space
                            self.lockout_lsp_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "lockout-timestamp"):
                            self.lockout_timestamp = value
                            self.lockout_timestamp.value_namespace = name_space
                            self.lockout_timestamp.value_namespace_prefix = name_space_prefix
                        if(value_path == "origination"):
                            self.origination = value
                            self.origination.value_namespace = name_space
                            self.origination.value_namespace_prefix = name_space_prefix


                class Destination(Entity):
                    """
                    Destinations array
                    
                    .. attribute:: active_path_option_index
                    
                    	Index of active path option
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: destination_address
                    
                    	Destination address
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: destination_deletion_cause
                    
                    	Destination deletion cause
                    	**type**\:   :py:class:`TeP2MpS2LDeletionCause <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeP2MpS2LDeletionCause>`
                    
                    .. attribute:: destination_deletion_sub_cause
                    
                    	Destination deletion subcause
                    	**type**\:   :py:class:`TeP2MpS2LDeletionSubcause <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeP2MpS2LDeletionSubcause>`
                    
                    .. attribute:: destination_deletion_timestamp
                    
                    	Destination deletion timestamp in seconds
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: destination_state
                    
                    	The state of the destination
                    	**type**\:   :py:class:`TeDestinationState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeDestinationState>`
                    
                    .. attribute:: inter_area_reoptimization
                    
                    	The timing and count information of interarea reoptimization
                    	**type**\:   :py:class:`InterAreaReoptimization <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.InterAreaReoptimization>`
                    
                    .. attribute:: is_inter_area
                    
                    	Indicates whether this destination is in different area
                    	**type**\:  bool
                    
                    .. attribute:: path_change_time
                    
                    	Last path change time
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: path_option
                    
                    	Destination's list of path options
                    	**type**\: list of    :py:class:`PathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption>`
                    
                    .. attribute:: path_option_entry
                    
                    	Deprecated; replaced by PathOption
                    	**type**\: list of    :py:class:`PathOptionEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry>`
                    
                    .. attribute:: path_option_exhausted
                    
                    	Path options are exhausted
                    	**type**\:  bool
                    
                    .. attribute:: s2l_exist
                    
                    	Dest state may not be up but S2L may exist
                    	**type**\:  bool
                    
                    .. attribute:: total_uptime
                    
                    	Unused
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: uptime
                    
                    	Time in seconds since the destination was up
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination, self).__init__()

                        self.yang_name = "destination"
                        self.yang_parent_name = "tunnel-head"

                        self.active_path_option_index = YLeaf(YType.uint32, "active-path-option-index")

                        self.destination_address = YLeaf(YType.str, "destination-address")

                        self.destination_deletion_cause = YLeaf(YType.enumeration, "destination-deletion-cause")

                        self.destination_deletion_sub_cause = YLeaf(YType.enumeration, "destination-deletion-sub-cause")

                        self.destination_deletion_timestamp = YLeaf(YType.uint32, "destination-deletion-timestamp")

                        self.destination_state = YLeaf(YType.enumeration, "destination-state")

                        self.is_inter_area = YLeaf(YType.boolean, "is-inter-area")

                        self.path_change_time = YLeaf(YType.uint32, "path-change-time")

                        self.path_option_exhausted = YLeaf(YType.boolean, "path-option-exhausted")

                        self.s2l_exist = YLeaf(YType.boolean, "s2l-exist")

                        self.total_uptime = YLeaf(YType.uint32, "total-uptime")

                        self.uptime = YLeaf(YType.uint32, "uptime")

                        self.inter_area_reoptimization = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.InterAreaReoptimization()
                        self.inter_area_reoptimization.parent = self
                        self._children_name_map["inter_area_reoptimization"] = "inter-area-reoptimization"
                        self._children_yang_names.add("inter-area-reoptimization")

                        self.path_option = YList(self)
                        self.path_option_entry = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("active_path_option_index",
                                        "destination_address",
                                        "destination_deletion_cause",
                                        "destination_deletion_sub_cause",
                                        "destination_deletion_timestamp",
                                        "destination_state",
                                        "is_inter_area",
                                        "path_change_time",
                                        "path_option_exhausted",
                                        "s2l_exist",
                                        "total_uptime",
                                        "uptime") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination, self).__setattr__(name, value)


                    class InterAreaReoptimization(Entity):
                        """
                        The timing and count information of interarea
                        reoptimization.
                        
                        .. attribute:: preferred_path_error_node
                        
                        	Address of the preferred path error generating node
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: preferred_tree_error_node
                        
                        	Address of the preferred tree error generating node
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: received_preferred_path_errors
                        
                        	Number of received Preferred Path Exists Error
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: received_preferred_tree_errors
                        
                        	Number of received Preferred Tree Exists Error
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: sent_path_queries
                        
                        	Number of better path queries sent
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: time_since_last_preferred_path_error
                        
                        	Time since last Preferred Path Exists error received (seconds)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: time_since_last_preferred_tree_error
                        
                        	Time since last Preferred Tree Exists error received (seconds)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: time_since_last_query_sent
                        
                        	Time since the last better path query was sent (seconds)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.InterAreaReoptimization, self).__init__()

                            self.yang_name = "inter-area-reoptimization"
                            self.yang_parent_name = "destination"

                            self.preferred_path_error_node = YLeaf(YType.str, "preferred-path-error-node")

                            self.preferred_tree_error_node = YLeaf(YType.str, "preferred-tree-error-node")

                            self.received_preferred_path_errors = YLeaf(YType.uint16, "received-preferred-path-errors")

                            self.received_preferred_tree_errors = YLeaf(YType.uint16, "received-preferred-tree-errors")

                            self.sent_path_queries = YLeaf(YType.uint16, "sent-path-queries")

                            self.time_since_last_preferred_path_error = YLeaf(YType.uint32, "time-since-last-preferred-path-error")

                            self.time_since_last_preferred_tree_error = YLeaf(YType.uint32, "time-since-last-preferred-tree-error")

                            self.time_since_last_query_sent = YLeaf(YType.uint32, "time-since-last-query-sent")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("preferred_path_error_node",
                                            "preferred_tree_error_node",
                                            "received_preferred_path_errors",
                                            "received_preferred_tree_errors",
                                            "sent_path_queries",
                                            "time_since_last_preferred_path_error",
                                            "time_since_last_preferred_tree_error",
                                            "time_since_last_query_sent") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.InterAreaReoptimization, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.InterAreaReoptimization, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.preferred_path_error_node.is_set or
                                self.preferred_tree_error_node.is_set or
                                self.received_preferred_path_errors.is_set or
                                self.received_preferred_tree_errors.is_set or
                                self.sent_path_queries.is_set or
                                self.time_since_last_preferred_path_error.is_set or
                                self.time_since_last_preferred_tree_error.is_set or
                                self.time_since_last_query_sent.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.preferred_path_error_node.yfilter != YFilter.not_set or
                                self.preferred_tree_error_node.yfilter != YFilter.not_set or
                                self.received_preferred_path_errors.yfilter != YFilter.not_set or
                                self.received_preferred_tree_errors.yfilter != YFilter.not_set or
                                self.sent_path_queries.yfilter != YFilter.not_set or
                                self.time_since_last_preferred_path_error.yfilter != YFilter.not_set or
                                self.time_since_last_preferred_tree_error.yfilter != YFilter.not_set or
                                self.time_since_last_query_sent.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "inter-area-reoptimization" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.preferred_path_error_node.is_set or self.preferred_path_error_node.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.preferred_path_error_node.get_name_leafdata())
                            if (self.preferred_tree_error_node.is_set or self.preferred_tree_error_node.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.preferred_tree_error_node.get_name_leafdata())
                            if (self.received_preferred_path_errors.is_set or self.received_preferred_path_errors.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.received_preferred_path_errors.get_name_leafdata())
                            if (self.received_preferred_tree_errors.is_set or self.received_preferred_tree_errors.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.received_preferred_tree_errors.get_name_leafdata())
                            if (self.sent_path_queries.is_set or self.sent_path_queries.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.sent_path_queries.get_name_leafdata())
                            if (self.time_since_last_preferred_path_error.is_set or self.time_since_last_preferred_path_error.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_preferred_path_error.get_name_leafdata())
                            if (self.time_since_last_preferred_tree_error.is_set or self.time_since_last_preferred_tree_error.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_preferred_tree_error.get_name_leafdata())
                            if (self.time_since_last_query_sent.is_set or self.time_since_last_query_sent.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.time_since_last_query_sent.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "preferred-path-error-node" or name == "preferred-tree-error-node" or name == "received-preferred-path-errors" or name == "received-preferred-tree-errors" or name == "sent-path-queries" or name == "time-since-last-preferred-path-error" or name == "time-since-last-preferred-tree-error" or name == "time-since-last-query-sent"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "preferred-path-error-node"):
                                self.preferred_path_error_node = value
                                self.preferred_path_error_node.value_namespace = name_space
                                self.preferred_path_error_node.value_namespace_prefix = name_space_prefix
                            if(value_path == "preferred-tree-error-node"):
                                self.preferred_tree_error_node = value
                                self.preferred_tree_error_node.value_namespace = name_space
                                self.preferred_tree_error_node.value_namespace_prefix = name_space_prefix
                            if(value_path == "received-preferred-path-errors"):
                                self.received_preferred_path_errors = value
                                self.received_preferred_path_errors.value_namespace = name_space
                                self.received_preferred_path_errors.value_namespace_prefix = name_space_prefix
                            if(value_path == "received-preferred-tree-errors"):
                                self.received_preferred_tree_errors = value
                                self.received_preferred_tree_errors.value_namespace = name_space
                                self.received_preferred_tree_errors.value_namespace_prefix = name_space_prefix
                            if(value_path == "sent-path-queries"):
                                self.sent_path_queries = value
                                self.sent_path_queries.value_namespace = name_space
                                self.sent_path_queries.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-preferred-path-error"):
                                self.time_since_last_preferred_path_error = value
                                self.time_since_last_preferred_path_error.value_namespace = name_space
                                self.time_since_last_preferred_path_error.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-preferred-tree-error"):
                                self.time_since_last_preferred_tree_error = value
                                self.time_since_last_preferred_tree_error.value_namespace = name_space
                                self.time_since_last_preferred_tree_error.value_namespace_prefix = name_space_prefix
                            if(value_path == "time-since-last-query-sent"):
                                self.time_since_last_query_sent = value
                                self.time_since_last_query_sent.value_namespace = name_space
                                self.time_since_last_query_sent.value_namespace_prefix = name_space_prefix


                    class PathOptionEntry(Entity):
                        """
                        Deprecated; replaced by PathOption
                        
                        .. attribute:: attribute_set
                        
                        	The path option attribute set used by this path
                        	**type**\:   :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet>`
                        
                        .. attribute:: attribute_set_found
                        
                        	TRUE if the path has found the defined attribute set
                        	**type**\:  bool
                        
                        .. attribute:: explicit_path_id
                        
                        	Explicit Path ID, this is the key to table ExplicitPaths.IdentifierTable
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: explicit_path_name
                        
                        	Explicit Path Name, this is the key to table ExplicitPaths.NameTable
                        	**type**\:  str
                        
                        .. attribute:: has_attribute_set
                        
                        	TRUE if the path has an attribute set defined
                        	**type**\:  bool
                        
                        .. attribute:: has_xro_attribute_set
                        
                        	TRUE if the path has an XRO attribute set configured
                        	**type**\:  bool
                        
                        .. attribute:: holddown_duration
                        
                        	Holddown Duration (seconds)
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        	**units**\: second
                        
                        .. attribute:: is_disabled
                        
                        	TRUE if the path option is disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_helddown
                        
                        	TRUE if path is helddown
                        	**type**\:  bool
                        
                        .. attribute:: is_lockdown
                        
                        	TRUE if the path is locked down
                        	**type**\:  bool
                        
                        .. attribute:: is_segment_routing
                        
                        	TRUE if the path is Segment\-Routing
                        	**type**\:  bool
                        
                        .. attribute:: is_strict_explicit_path
                        
                        	TRUE if explicit path is strict
                        	**type**\:  bool
                        
                        .. attribute:: is_verbatim
                        
                        	TRUE if the path is verbatim
                        	**type**\:  bool
                        
                        .. attribute:: option_index
                        
                        	Path option index
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: option_index_is_valid
                        
                        	The path option index is valid
                        	**type**\:  bool
                        
                        .. attribute:: path_calculation_error
                        
                        	Path computation information
                        	**type**\: list of    :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.PathCalculationError>`
                        
                        .. attribute:: path_option_area_id
                        
                        	The path\-option area constraint
                        	**type**\:  str
                        
                        .. attribute:: path_option_name
                        
                        	Path option name
                        	**type**\:  str
                        
                        .. attribute:: path_option_type
                        
                        	Path option type
                        	**type**\:   :py:class:`MplsTePathoption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathoption>`
                        
                        .. attribute:: pce_address
                        
                        	PCE server address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: protected_by_path_option_index
                        
                        	Path option index for Protect path options
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: remerge_error
                        
                        	Path computation remerge resolve info
                        	**type**\: list of    :py:class:`RemergeError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.RemergeError>`
                        
                        .. attribute:: restored_from_path_option_index
                        
                        	Path option index for Restore path options
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: signalling_error
                        
                        	Signalling information
                        	**type**\: list of    :py:class:`SignallingError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.SignallingError>`
                        
                        .. attribute:: xro_attribute_set
                        
                        	The XRO attribute set used by this path\-option
                        	**type**\:   :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet>`
                        
                        .. attribute:: xro_attribute_set_found
                        
                        	TRUE if the path's XRO attribute set is known
                        	**type**\:  bool
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry, self).__init__()

                            self.yang_name = "path-option-entry"
                            self.yang_parent_name = "destination"

                            self.attribute_set_found = YLeaf(YType.boolean, "attribute-set-found")

                            self.explicit_path_id = YLeaf(YType.uint16, "explicit-path-id")

                            self.explicit_path_name = YLeaf(YType.str, "explicit-path-name")

                            self.has_attribute_set = YLeaf(YType.boolean, "has-attribute-set")

                            self.has_xro_attribute_set = YLeaf(YType.boolean, "has-xro-attribute-set")

                            self.holddown_duration = YLeaf(YType.uint16, "holddown-duration")

                            self.is_disabled = YLeaf(YType.boolean, "is-disabled")

                            self.is_helddown = YLeaf(YType.boolean, "is-helddown")

                            self.is_lockdown = YLeaf(YType.boolean, "is-lockdown")

                            self.is_segment_routing = YLeaf(YType.boolean, "is-segment-routing")

                            self.is_strict_explicit_path = YLeaf(YType.boolean, "is-strict-explicit-path")

                            self.is_verbatim = YLeaf(YType.boolean, "is-verbatim")

                            self.option_index = YLeaf(YType.uint32, "option-index")

                            self.option_index_is_valid = YLeaf(YType.boolean, "option-index-is-valid")

                            self.path_option_area_id = YLeaf(YType.str, "path-option-area-id")

                            self.path_option_name = YLeaf(YType.str, "path-option-name")

                            self.path_option_type = YLeaf(YType.enumeration, "path-option-type")

                            self.pce_address = YLeaf(YType.str, "pce-address")

                            self.protected_by_path_option_index = YLeaf(YType.uint32, "protected-by-path-option-index")

                            self.restored_from_path_option_index = YLeaf(YType.uint32, "restored-from-path-option-index")

                            self.xro_attribute_set_found = YLeaf(YType.boolean, "xro-attribute-set-found")

                            self.attribute_set = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet()
                            self.attribute_set.parent = self
                            self._children_name_map["attribute_set"] = "attribute-set"
                            self._children_yang_names.add("attribute-set")

                            self.xro_attribute_set = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet()
                            self.xro_attribute_set.parent = self
                            self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                            self._children_yang_names.add("xro-attribute-set")

                            self.path_calculation_error = YList(self)
                            self.remerge_error = YList(self)
                            self.signalling_error = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("attribute_set_found",
                                            "explicit_path_id",
                                            "explicit_path_name",
                                            "has_attribute_set",
                                            "has_xro_attribute_set",
                                            "holddown_duration",
                                            "is_disabled",
                                            "is_helddown",
                                            "is_lockdown",
                                            "is_segment_routing",
                                            "is_strict_explicit_path",
                                            "is_verbatim",
                                            "option_index",
                                            "option_index_is_valid",
                                            "path_option_area_id",
                                            "path_option_name",
                                            "path_option_type",
                                            "pce_address",
                                            "protected_by_path_option_index",
                                            "restored_from_path_option_index",
                                            "xro_attribute_set_found") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry, self).__setattr__(name, value)


                        class AttributeSet(Entity):
                            """
                            The path option attribute set used by this path
                            
                            .. attribute:: attribute_set_union
                            
                            	Union of Attribute Sets
                            	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion>`
                            
                            .. attribute:: tunnel_attribute_set_name
                            
                            	Attribute Set Name
                            	**type**\:  str
                            
                            .. attribute:: tunnel_attribute_set_name_crc32
                            
                            	Attribute Set name CRC32 value
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet, self).__init__()

                                self.yang_name = "attribute-set"
                                self.yang_parent_name = "path-option-entry"

                                self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                                self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                                self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion()
                                self.attribute_set_union.parent = self
                                self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                self._children_yang_names.add("attribute-set-union")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("tunnel_attribute_set_name",
                                                "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet, self).__setattr__(name, value)


                            class AttributeSetUnion(Entity):
                                """
                                Union of Attribute Sets
                                
                                .. attribute:: attribute_set_aps_pp
                                
                                	Attribute Set OTN APS Path Protection
                                	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                
                                .. attribute:: attribute_set_autobackup
                                
                                	MPLS TE Auto\-backup Attribute Set
                                	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                
                                .. attribute:: attribute_set_automesh
                                
                                	MPLS TE Auto\-mesh Attribute Set
                                	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                
                                .. attribute:: attribute_set_p2mpte
                                
                                	MPLS TE P2MP\-TE Attribute Set
                                	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                                
                                .. attribute:: attribute_set_p2p_te
                                
                                	MPLS TE P2P\-TE Attribute Set
                                	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                                
                                .. attribute:: attribute_set_path_option
                                
                                	MPLS TE Path Option Attribute Set
                                	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                
                                .. attribute:: attribute_set_xro
                                
                                	Attribute Set XRO
                                	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                                
                                .. attribute:: tunnel_attribute_set_type
                                
                                	TunnelAttributeSetType
                                	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion, self).__init__()

                                    self.yang_name = "attribute-set-union"
                                    self.yang_parent_name = "attribute-set"

                                    self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                                    self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                    self.attribute_set_aps_pp.parent = self
                                    self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                    self._children_yang_names.add("attribute-set-aps-pp")

                                    self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                    self.attribute_set_autobackup.parent = self
                                    self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                    self._children_yang_names.add("attribute-set-autobackup")

                                    self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                    self.attribute_set_automesh.parent = self
                                    self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                    self._children_yang_names.add("attribute-set-automesh")

                                    self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                    self.attribute_set_p2mpte.parent = self
                                    self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                    self._children_yang_names.add("attribute-set-p2mpte")

                                    self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                    self.attribute_set_p2p_te.parent = self
                                    self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                    self._children_yang_names.add("attribute-set-p2p-te")

                                    self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                    self.attribute_set_path_option.parent = self
                                    self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                    self._children_yang_names.add("attribute-set-path-option")

                                    self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                    self.attribute_set_xro.parent = self
                                    self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                    self._children_yang_names.add("attribute-set-xro")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                                class AttributeSetPathOption(Entity):
                                    """
                                    MPLS TE Path Option Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                    
                                    .. attribute:: bandwidth_type
                                    
                                    	The bandwidth type
                                    	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                    
                                    .. attribute:: bfd_reverse_path
                                    
                                    	BFD reverse path
                                    	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: cost_limit
                                    
                                    	Cost limit on the tunnel path
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: exclude_list_name
                                    
                                    	Exclude list name
                                    	**type**\:  str
                                    
                                    .. attribute:: generation
                                    
                                    	Generation
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bfd_reverse_pat_configured
                                    
                                    	Is BFD reverse path configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_cost_limit_configured
                                    
                                    	Is Cost Limit configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_exclude_list_name_configured
                                    
                                    	Is exclude list name configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is path invalidation action configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is path invalidation timeout configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: path_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation interval on the tunnel path
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                    
                                    .. attribute:: version_info
                                    
                                    	Version Info
                                    	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                        self.yang_name = "attribute-set-path-option"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                        self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                        self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                        self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                        self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                        self.generation = YLeaf(YType.uint32, "generation")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                        self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                        self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                        self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                        self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                        self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                        self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                        self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                        self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                        self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                        self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                        self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                        self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                        self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                        self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                        self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                        self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                        self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                        self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                        self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                        self.bfd_reverse_path.parent = self
                                        self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                        self._children_yang_names.add("bfd-reverse-path")

                                        self.tunnel_id = YList(self)
                                        self.version_info = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bandwidth_type",
                                                        "configured_bandwidth",
                                                        "cost_limit",
                                                        "dste_class_type",
                                                        "exclude_list_name",
                                                        "generation",
                                                        "is_affinity_configured",
                                                        "is_bandwidth_configured",
                                                        "is_bfd_reverse_pat_configured",
                                                        "is_cost_limit_configured",
                                                        "is_exclude_list_name_configured",
                                                        "is_path_invalidation_action_configured",
                                                        "is_path_invalidation_timeout_configured",
                                                        "is_pce_configured",
                                                        "is_pce_disj_group_id_configured",
                                                        "is_pce_disj_source_configured",
                                                        "is_pce_disj_type_configured",
                                                        "is_pceb_dj_source_configured",
                                                        "is_pcebd_group_id_configured",
                                                        "path_invalidation_action",
                                                        "path_invalidation_timeout",
                                                        "pcebd_group_id",
                                                        "pcebd_source_address",
                                                        "pcedp_group_id",
                                                        "pcedp_source_address",
                                                        "pcedp_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class BfdReversePath(Entity):
                                        """
                                        BFD reverse path
                                        
                                        .. attribute:: binding_label
                                        
                                        	BFD reverse path binding label
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_type
                                        
                                        	BFD reverse path type
                                        	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                            self.yang_name = "bfd-reverse-path"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.binding_label = YLeaf(YType.uint32, "binding-label")

                                            self.path_type = YLeaf(YType.enumeration, "path-type")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("binding_label",
                                                            "path_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.binding_label.is_set or
                                                self.path_type.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.binding_label.yfilter != YFilter.not_set or
                                                self.path_type.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bfd-reverse-path" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.binding_label.get_name_leafdata())
                                            if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "binding-label" or name == "path-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "binding-label"):
                                                self.binding_label = value
                                                self.binding_label.value_namespace = name_space
                                                self.binding_label.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-type"):
                                                self.path_type = value
                                                self.path_type.value_namespace = name_space
                                                self.path_type.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class VersionInfo(Entity):
                                        """
                                        Version Info
                                        
                                        .. attribute:: attribute_type
                                        
                                        	Attribute Type
                                        	**type**\:  str
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_default
                                        
                                        	Is default
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                            self.yang_name = "version-info"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.attribute_type = YLeaf(YType.str, "attribute-type")

                                            self.generation = YLeaf(YType.uint32, "generation")

                                            self.is_default = YLeaf(YType.boolean, "is-default")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("attribute_type",
                                                            "generation",
                                                            "is_default") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.attribute_type.is_set or
                                                self.generation.is_set or
                                                self.is_default.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.attribute_type.yfilter != YFilter.not_set or
                                                self.generation.yfilter != YFilter.not_set or
                                                self.is_default.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "version-info" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.generation.get_name_leafdata())
                                            if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_default.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "attribute-type"):
                                                self.attribute_type = value
                                                self.attribute_type.value_namespace = name_space
                                                self.attribute_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "generation"):
                                                self.generation = value
                                                self.generation.value_namespace = name_space
                                                self.generation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-default"):
                                                self.is_default = value
                                                self.is_default.value_namespace = name_space
                                                self.is_default.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        for c in self.version_info:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bandwidth_type.is_set or
                                            self.configured_bandwidth.is_set or
                                            self.cost_limit.is_set or
                                            self.dste_class_type.is_set or
                                            self.exclude_list_name.is_set or
                                            self.generation.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_bandwidth_configured.is_set or
                                            self.is_bfd_reverse_pat_configured.is_set or
                                            self.is_cost_limit_configured.is_set or
                                            self.is_exclude_list_name_configured.is_set or
                                            self.is_path_invalidation_action_configured.is_set or
                                            self.is_path_invalidation_timeout_configured.is_set or
                                            self.is_pce_configured.is_set or
                                            self.is_pce_disj_group_id_configured.is_set or
                                            self.is_pce_disj_source_configured.is_set or
                                            self.is_pce_disj_type_configured.is_set or
                                            self.is_pceb_dj_source_configured.is_set or
                                            self.is_pcebd_group_id_configured.is_set or
                                            self.path_invalidation_action.is_set or
                                            self.path_invalidation_timeout.is_set or
                                            self.pcebd_group_id.is_set or
                                            self.pcebd_source_address.is_set or
                                            self.pcedp_group_id.is_set or
                                            self.pcedp_source_address.is_set or
                                            self.pcedp_type.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                                    def has_operation(self):
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.version_info:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bandwidth_type.yfilter != YFilter.not_set or
                                            self.configured_bandwidth.yfilter != YFilter.not_set or
                                            self.cost_limit.yfilter != YFilter.not_set or
                                            self.dste_class_type.yfilter != YFilter.not_set or
                                            self.exclude_list_name.yfilter != YFilter.not_set or
                                            self.generation.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                            self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                            self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                            self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                            self.is_pce_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                            self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                            self.path_invalidation_action.yfilter != YFilter.not_set or
                                            self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                            self.pcebd_group_id.yfilter != YFilter.not_set or
                                            self.pcebd_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_group_id.yfilter != YFilter.not_set or
                                            self.pcedp_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_type.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-path-option" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                        if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                        if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                        if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                        if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                        if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.generation.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                        if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                        if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                        if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                        if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                        if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                        if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                        if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                        if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                        if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                        if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                        if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                        if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                        if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                        if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                        if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                        if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "bfd-reverse-path"):
                                            if (self.bfd_reverse_path is None):
                                                self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                                self.bfd_reverse_path.parent = self
                                                self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                            return self.bfd_reverse_path

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        if (child_yang_name == "version-info"):
                                            for c in self.version_info:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.version_info.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bandwidth-type"):
                                            self.bandwidth_type = value
                                            self.bandwidth_type.value_namespace = name_space
                                            self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "configured-bandwidth"):
                                            self.configured_bandwidth = value
                                            self.configured_bandwidth.value_namespace = name_space
                                            self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "cost-limit"):
                                            self.cost_limit = value
                                            self.cost_limit.value_namespace = name_space
                                            self.cost_limit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dste-class-type"):
                                            self.dste_class_type = value
                                            self.dste_class_type.value_namespace = name_space
                                            self.dste_class_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclude-list-name"):
                                            self.exclude_list_name = value
                                            self.exclude_list_name.value_namespace = name_space
                                            self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "generation"):
                                            self.generation = value
                                            self.generation.value_namespace = name_space
                                            self.generation.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bandwidth-configured"):
                                            self.is_bandwidth_configured = value
                                            self.is_bandwidth_configured.value_namespace = name_space
                                            self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bfd-reverse-pat-configured"):
                                            self.is_bfd_reverse_pat_configured = value
                                            self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                            self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-cost-limit-configured"):
                                            self.is_cost_limit_configured = value
                                            self.is_cost_limit_configured.value_namespace = name_space
                                            self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-exclude-list-name-configured"):
                                            self.is_exclude_list_name_configured = value
                                            self.is_exclude_list_name_configured.value_namespace = name_space
                                            self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-action-configured"):
                                            self.is_path_invalidation_action_configured = value
                                            self.is_path_invalidation_action_configured.value_namespace = name_space
                                            self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-timeout-configured"):
                                            self.is_path_invalidation_timeout_configured = value
                                            self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                            self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-configured"):
                                            self.is_pce_configured = value
                                            self.is_pce_configured.value_namespace = name_space
                                            self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-group-id-configured"):
                                            self.is_pce_disj_group_id_configured = value
                                            self.is_pce_disj_group_id_configured.value_namespace = name_space
                                            self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-source-configured"):
                                            self.is_pce_disj_source_configured = value
                                            self.is_pce_disj_source_configured.value_namespace = name_space
                                            self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-type-configured"):
                                            self.is_pce_disj_type_configured = value
                                            self.is_pce_disj_type_configured.value_namespace = name_space
                                            self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pceb-dj-source-configured"):
                                            self.is_pceb_dj_source_configured = value
                                            self.is_pceb_dj_source_configured.value_namespace = name_space
                                            self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pcebd-group-id-configured"):
                                            self.is_pcebd_group_id_configured = value
                                            self.is_pcebd_group_id_configured.value_namespace = name_space
                                            self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-invalidation-action"):
                                            self.path_invalidation_action = value
                                            self.path_invalidation_action.value_namespace = name_space
                                            self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-invalidation-timeout"):
                                            self.path_invalidation_timeout = value
                                            self.path_invalidation_timeout.value_namespace = name_space
                                            self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-group-id"):
                                            self.pcebd_group_id = value
                                            self.pcebd_group_id.value_namespace = name_space
                                            self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-source-address"):
                                            self.pcebd_source_address = value
                                            self.pcebd_source_address.value_namespace = name_space
                                            self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-group-id"):
                                            self.pcedp_group_id = value
                                            self.pcedp_group_id.value_namespace = name_space
                                            self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-source-address"):
                                            self.pcedp_source_address = value
                                            self.pcedp_source_address.value_namespace = name_space
                                            self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-type"):
                                            self.pcedp_type = value
                                            self.pcedp_type.value_namespace = name_space
                                            self.pcedp_type.value_namespace_prefix = name_space_prefix


                                class AttributeSetAutobackup(Entity):
                                    """
                                    MPLS TE Auto\-backup Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_signalled_name_configured
                                    
                                    	Is signalled name configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                    
                                    .. attribute:: protected_interface
                                    
                                    	Array of Protected Interface Names
                                    	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\:  bool
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: signalled_name
                                    
                                    	Signalled name
                                    	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                        self.yang_name = "attribute-set-autobackup"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                        self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                        self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                        self.policy_class = YLeaf(YType.uint8, "policy-class")

                                        self.record_route = YLeaf(YType.boolean, "record-route")

                                        self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                        self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"
                                        self._children_yang_names.add("logging")

                                        self.signalled_name = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                        self.signalled_name.parent = self
                                        self._children_name_map["signalled_name"] = "signalled-name"
                                        self._children_yang_names.add("signalled-name")

                                        self.policy_class_entry = YList(self)
                                        self.protected_interface = YList(self)
                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("hold_priority",
                                                        "is_affinity_configured",
                                                        "is_policyclass_configured",
                                                        "is_priority_configured",
                                                        "is_signalled_name_configured",
                                                        "policy_class",
                                                        "record_route",
                                                        "setup_priority") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                                    class SignalledName(Entity):
                                        """
                                        Signalled name
                                        
                                        .. attribute:: is_mp_addresses
                                        
                                        	MP address appended
                                        	**type**\:  bool
                                        
                                        .. attribute:: name
                                        
                                        	Signalled name
                                        	**type**\:  str
                                        
                                        .. attribute:: protected_interface_type
                                        
                                        	Protected interface address or name
                                        	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        .. attribute:: source_type
                                        
                                        	Source address or name
                                        	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                            self.yang_name = "signalled-name"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                            self.name = YLeaf(YType.str, "name")

                                            self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                            self.source_type = YLeaf(YType.enumeration, "source-type")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_mp_addresses",
                                                            "name",
                                                            "protected_interface_type",
                                                            "source_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.is_mp_addresses.is_set or
                                                self.name.is_set or
                                                self.protected_interface_type.is_set or
                                                self.source_type.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_mp_addresses.yfilter != YFilter.not_set or
                                                self.name.yfilter != YFilter.not_set or
                                                self.protected_interface_type.yfilter != YFilter.not_set or
                                                self.source_type.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "signalled-name" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                            if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.name.get_name_leafdata())
                                            if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                            if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.source_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-mp-addresses"):
                                                self.is_mp_addresses = value
                                                self.is_mp_addresses.value_namespace = name_space
                                                self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                            if(value_path == "name"):
                                                self.name = value
                                                self.name.value_namespace = name_space
                                                self.name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protected-interface-type"):
                                                self.protected_interface_type = value
                                                self.protected_interface_type.value_namespace = name_space
                                                self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "source-type"):
                                                self.source_type = value
                                                self.source_type.value_namespace = name_space
                                                self.source_type.value_namespace_prefix = name_space_prefix


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class Logging(Entity):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                            self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                            self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                            self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                            self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                            self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                            self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                            self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("all_logging_enabled",
                                                            "lsp_bandwidth_change",
                                                            "lsp_insufficient_bw",
                                                            "lsp_pcalc_failure_logging_enabled",
                                                            "lsp_re_opt",
                                                            "lsp_re_route",
                                                            "lsp_state",
                                                            "s2l_state") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.all_logging_enabled.is_set or
                                                self.lsp_bandwidth_change.is_set or
                                                self.lsp_insufficient_bw.is_set or
                                                self.lsp_pcalc_failure_logging_enabled.is_set or
                                                self.lsp_re_opt.is_set or
                                                self.lsp_re_route.is_set or
                                                self.lsp_state.is_set or
                                                self.s2l_state.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.all_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_re_opt.yfilter != YFilter.not_set or
                                                self.lsp_re_route.yfilter != YFilter.not_set or
                                                self.lsp_state.yfilter != YFilter.not_set or
                                                self.s2l_state.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "logging" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                            if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                            if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                            if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                            if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                            if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                            if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                            if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "all-logging-enabled"):
                                                self.all_logging_enabled = value
                                                self.all_logging_enabled.value_namespace = name_space
                                                self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-bandwidth-change"):
                                                self.lsp_bandwidth_change = value
                                                self.lsp_bandwidth_change.value_namespace = name_space
                                                self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-insufficient-bw"):
                                                self.lsp_insufficient_bw = value
                                                self.lsp_insufficient_bw.value_namespace = name_space
                                                self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                self.lsp_pcalc_failure_logging_enabled = value
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-opt"):
                                                self.lsp_re_opt = value
                                                self.lsp_re_opt.value_namespace = name_space
                                                self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-route"):
                                                self.lsp_re_route = value
                                                self.lsp_re_route.value_namespace = name_space
                                                self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-state"):
                                                self.lsp_state = value
                                                self.lsp_state.value_namespace = name_space
                                                self.lsp_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "s2l-state"):
                                                self.s2l_state = value
                                                self.s2l_state.value_namespace = name_space
                                                self.s2l_state.value_namespace_prefix = name_space_prefix


                                    class PolicyClassEntry(Entity):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "policy-class-entry" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class ProtectedInterface(Entity):
                                        """
                                        Array of Protected Interface Names
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Protected Interface Name
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                            self.yang_name = "protected-interface"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.protected_interface = YLeaf(YType.str, "protected-interface")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("protected_interface") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.protected_interface.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.protected_interface.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "protected-interface" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "protected-interface"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "protected-interface"):
                                                self.protected_interface = value
                                                self.protected_interface.value_namespace = name_space
                                                self.protected_interface.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.policy_class_entry:
                                            if (c.has_data()):
                                                return True
                                        for c in self.protected_interface:
                                            if (c.has_data()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.hold_priority.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_policyclass_configured.is_set or
                                            self.is_priority_configured.is_set or
                                            self.is_signalled_name_configured.is_set or
                                            self.policy_class.is_set or
                                            self.record_route.is_set or
                                            self.setup_priority.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.logging is not None and self.logging.has_data()) or
                                            (self.signalled_name is not None and self.signalled_name.has_data()))

                                    def has_operation(self):
                                        for c in self.policy_class_entry:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.protected_interface:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.hold_priority.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_policyclass_configured.yfilter != YFilter.not_set or
                                            self.is_priority_configured.yfilter != YFilter.not_set or
                                            self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                            self.policy_class.yfilter != YFilter.not_set or
                                            self.record_route.yfilter != YFilter.not_set or
                                            self.setup_priority.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.logging is not None and self.logging.has_operation()) or
                                            (self.signalled_name is not None and self.signalled_name.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-autobackup" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                        if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                        if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                        if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.policy_class.get_name_leafdata())
                                        if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.record_route.get_name_leafdata())
                                        if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "logging"):
                                            if (self.logging is None):
                                                self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                                self.logging.parent = self
                                                self._children_name_map["logging"] = "logging"
                                            return self.logging

                                        if (child_yang_name == "policy-class-entry"):
                                            for c in self.policy_class_entry:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.policy_class_entry.append(c)
                                            return c

                                        if (child_yang_name == "protected-interface"):
                                            for c in self.protected_interface:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.protected_interface.append(c)
                                            return c

                                        if (child_yang_name == "signalled-name"):
                                            if (self.signalled_name is None):
                                                self.signalled_name = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                                self.signalled_name.parent = self
                                                self._children_name_map["signalled_name"] = "signalled-name"
                                            return self.signalled_name

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "hold-priority"):
                                            self.hold_priority = value
                                            self.hold_priority.value_namespace = name_space
                                            self.hold_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-policyclass-configured"):
                                            self.is_policyclass_configured = value
                                            self.is_policyclass_configured.value_namespace = name_space
                                            self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-priority-configured"):
                                            self.is_priority_configured = value
                                            self.is_priority_configured.value_namespace = name_space
                                            self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-signalled-name-configured"):
                                            self.is_signalled_name_configured = value
                                            self.is_signalled_name_configured.value_namespace = name_space
                                            self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "policy-class"):
                                            self.policy_class = value
                                            self.policy_class.value_namespace = name_space
                                            self.policy_class.value_namespace_prefix = name_space_prefix
                                        if(value_path == "record-route"):
                                            self.record_route = value
                                            self.record_route.value_namespace = name_space
                                            self.record_route.value_namespace_prefix = name_space_prefix
                                        if(value_path == "setup-priority"):
                                            self.setup_priority = value
                                            self.setup_priority.value_namespace = name_space
                                            self.setup_priority.value_namespace_prefix = name_space_prefix


                                class AttributeSetAutomesh(Entity):
                                    """
                                    MPLS TE Auto\-mesh Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                    
                                    .. attribute:: auto_bandwidth_collect
                                    
                                    	Auto bandwidth collect only
                                    	**type**\:  bool
                                    
                                    .. attribute:: auto_route_announce
                                    
                                    	Announce auto route to IGP
                                    	**type**\:  bool
                                    
                                    .. attribute:: bandwidth
                                    
                                    	IM bandwidth
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\:  bool
                                    
                                    .. attribute:: forward_class
                                    
                                    	Forward class
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\:  bool
                                    
                                    .. attribute:: frr_node_protection
                                    
                                    	FRR Node protection
                                    	**type**\:  bool
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_interface_bw_configured
                                    
                                    	Is Interface BW configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: load_share
                                    
                                    	Load Share
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                    
                                    .. attribute:: mesh_group_id
                                    
                                    	Meshgroup ID
                                    	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\:  bool
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: soft_preemption_configured
                                    
                                    	Soft preemption is configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                        self.yang_name = "attribute-set-automesh"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                        self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                        self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                        self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                        self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                        self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                        self.forward_class = YLeaf(YType.uint32, "forward-class")

                                        self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                        self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                        self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                        self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                        self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                        self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                        self.load_share = YLeaf(YType.uint32, "load-share")

                                        self.policy_class = YLeaf(YType.uint8, "policy-class")

                                        self.record_route = YLeaf(YType.boolean, "record-route")

                                        self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                        self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                        self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"
                                        self._children_yang_names.add("logging")

                                        self.mesh_group_id = YList(self)
                                        self.policy_class_entry = YList(self)
                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("auto_bandwidth_collect",
                                                        "auto_route_announce",
                                                        "bandwidth",
                                                        "configured_bandwidth",
                                                        "dste_class_type",
                                                        "fast_reroute",
                                                        "forward_class",
                                                        "frr_bandwidth_protection",
                                                        "frr_node_protection",
                                                        "hold_priority",
                                                        "is_affinity_configured",
                                                        "is_bandwidth_configured",
                                                        "is_interface_bw_configured",
                                                        "is_policyclass_configured",
                                                        "is_priority_configured",
                                                        "load_share",
                                                        "policy_class",
                                                        "record_route",
                                                        "setup_priority",
                                                        "soft_preemption_configured") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class Logging(Entity):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                            self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                            self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                            self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                            self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                            self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                            self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                            self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("all_logging_enabled",
                                                            "lsp_bandwidth_change",
                                                            "lsp_insufficient_bw",
                                                            "lsp_pcalc_failure_logging_enabled",
                                                            "lsp_re_opt",
                                                            "lsp_re_route",
                                                            "lsp_state",
                                                            "s2l_state") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.all_logging_enabled.is_set or
                                                self.lsp_bandwidth_change.is_set or
                                                self.lsp_insufficient_bw.is_set or
                                                self.lsp_pcalc_failure_logging_enabled.is_set or
                                                self.lsp_re_opt.is_set or
                                                self.lsp_re_route.is_set or
                                                self.lsp_state.is_set or
                                                self.s2l_state.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.all_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_re_opt.yfilter != YFilter.not_set or
                                                self.lsp_re_route.yfilter != YFilter.not_set or
                                                self.lsp_state.yfilter != YFilter.not_set or
                                                self.s2l_state.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "logging" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                            if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                            if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                            if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                            if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                            if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                            if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                            if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "all-logging-enabled"):
                                                self.all_logging_enabled = value
                                                self.all_logging_enabled.value_namespace = name_space
                                                self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-bandwidth-change"):
                                                self.lsp_bandwidth_change = value
                                                self.lsp_bandwidth_change.value_namespace = name_space
                                                self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-insufficient-bw"):
                                                self.lsp_insufficient_bw = value
                                                self.lsp_insufficient_bw.value_namespace = name_space
                                                self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                self.lsp_pcalc_failure_logging_enabled = value
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-opt"):
                                                self.lsp_re_opt = value
                                                self.lsp_re_opt.value_namespace = name_space
                                                self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-route"):
                                                self.lsp_re_route = value
                                                self.lsp_re_route.value_namespace = name_space
                                                self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-state"):
                                                self.lsp_state = value
                                                self.lsp_state.value_namespace = name_space
                                                self.lsp_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "s2l-state"):
                                                self.s2l_state = value
                                                self.s2l_state.value_namespace = name_space
                                                self.s2l_state.value_namespace_prefix = name_space_prefix


                                    class PolicyClassEntry(Entity):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "policy-class-entry" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class MeshGroupId(Entity):
                                        """
                                        Meshgroup ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                            self.yang_name = "mesh-group-id"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.entry = YLeaf(YType.uint32, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "mesh-group-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.mesh_group_id:
                                            if (c.has_data()):
                                                return True
                                        for c in self.policy_class_entry:
                                            if (c.has_data()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.auto_bandwidth_collect.is_set or
                                            self.auto_route_announce.is_set or
                                            self.bandwidth.is_set or
                                            self.configured_bandwidth.is_set or
                                            self.dste_class_type.is_set or
                                            self.fast_reroute.is_set or
                                            self.forward_class.is_set or
                                            self.frr_bandwidth_protection.is_set or
                                            self.frr_node_protection.is_set or
                                            self.hold_priority.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_bandwidth_configured.is_set or
                                            self.is_interface_bw_configured.is_set or
                                            self.is_policyclass_configured.is_set or
                                            self.is_priority_configured.is_set or
                                            self.load_share.is_set or
                                            self.policy_class.is_set or
                                            self.record_route.is_set or
                                            self.setup_priority.is_set or
                                            self.soft_preemption_configured.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.logging is not None and self.logging.has_data()))

                                    def has_operation(self):
                                        for c in self.mesh_group_id:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.policy_class_entry:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                            self.auto_route_announce.yfilter != YFilter.not_set or
                                            self.bandwidth.yfilter != YFilter.not_set or
                                            self.configured_bandwidth.yfilter != YFilter.not_set or
                                            self.dste_class_type.yfilter != YFilter.not_set or
                                            self.fast_reroute.yfilter != YFilter.not_set or
                                            self.forward_class.yfilter != YFilter.not_set or
                                            self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                            self.frr_node_protection.yfilter != YFilter.not_set or
                                            self.hold_priority.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                            self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                            self.is_policyclass_configured.yfilter != YFilter.not_set or
                                            self.is_priority_configured.yfilter != YFilter.not_set or
                                            self.load_share.yfilter != YFilter.not_set or
                                            self.policy_class.yfilter != YFilter.not_set or
                                            self.record_route.yfilter != YFilter.not_set or
                                            self.setup_priority.yfilter != YFilter.not_set or
                                            self.soft_preemption_configured.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.logging is not None and self.logging.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-automesh" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                        if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                        if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                        if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                        if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                        if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                        if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.forward_class.get_name_leafdata())
                                        if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                        if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                        if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                        if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                        if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                        if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                        if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.load_share.get_name_leafdata())
                                        if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.policy_class.get_name_leafdata())
                                        if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.record_route.get_name_leafdata())
                                        if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                        if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "logging"):
                                            if (self.logging is None):
                                                self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                                self.logging.parent = self
                                                self._children_name_map["logging"] = "logging"
                                            return self.logging

                                        if (child_yang_name == "mesh-group-id"):
                                            for c in self.mesh_group_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.mesh_group_id.append(c)
                                            return c

                                        if (child_yang_name == "policy-class-entry"):
                                            for c in self.policy_class_entry:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.policy_class_entry.append(c)
                                            return c

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "auto-bandwidth-collect"):
                                            self.auto_bandwidth_collect = value
                                            self.auto_bandwidth_collect.value_namespace = name_space
                                            self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                        if(value_path == "auto-route-announce"):
                                            self.auto_route_announce = value
                                            self.auto_route_announce.value_namespace = name_space
                                            self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                        if(value_path == "bandwidth"):
                                            self.bandwidth = value
                                            self.bandwidth.value_namespace = name_space
                                            self.bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "configured-bandwidth"):
                                            self.configured_bandwidth = value
                                            self.configured_bandwidth.value_namespace = name_space
                                            self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dste-class-type"):
                                            self.dste_class_type = value
                                            self.dste_class_type.value_namespace = name_space
                                            self.dste_class_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "fast-reroute"):
                                            self.fast_reroute = value
                                            self.fast_reroute.value_namespace = name_space
                                            self.fast_reroute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "forward-class"):
                                            self.forward_class = value
                                            self.forward_class.value_namespace = name_space
                                            self.forward_class.value_namespace_prefix = name_space_prefix
                                        if(value_path == "frr-bandwidth-protection"):
                                            self.frr_bandwidth_protection = value
                                            self.frr_bandwidth_protection.value_namespace = name_space
                                            self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "frr-node-protection"):
                                            self.frr_node_protection = value
                                            self.frr_node_protection.value_namespace = name_space
                                            self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "hold-priority"):
                                            self.hold_priority = value
                                            self.hold_priority.value_namespace = name_space
                                            self.hold_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bandwidth-configured"):
                                            self.is_bandwidth_configured = value
                                            self.is_bandwidth_configured.value_namespace = name_space
                                            self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-interface-bw-configured"):
                                            self.is_interface_bw_configured = value
                                            self.is_interface_bw_configured.value_namespace = name_space
                                            self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-policyclass-configured"):
                                            self.is_policyclass_configured = value
                                            self.is_policyclass_configured.value_namespace = name_space
                                            self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-priority-configured"):
                                            self.is_priority_configured = value
                                            self.is_priority_configured.value_namespace = name_space
                                            self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "load-share"):
                                            self.load_share = value
                                            self.load_share.value_namespace = name_space
                                            self.load_share.value_namespace_prefix = name_space_prefix
                                        if(value_path == "policy-class"):
                                            self.policy_class = value
                                            self.policy_class.value_namespace = name_space
                                            self.policy_class.value_namespace_prefix = name_space_prefix
                                        if(value_path == "record-route"):
                                            self.record_route = value
                                            self.record_route.value_namespace = name_space
                                            self.record_route.value_namespace_prefix = name_space_prefix
                                        if(value_path == "setup-priority"):
                                            self.setup_priority = value
                                            self.setup_priority.value_namespace = name_space
                                            self.setup_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "soft-preemption-configured"):
                                            self.soft_preemption_configured = value
                                            self.soft_preemption_configured.value_namespace = name_space
                                            self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                                class AttributeSetXro(Entity):
                                    """
                                    Attribute Set XRO
                                    
                                    .. attribute:: xro
                                    
                                    	The XRO specified by this attribute\-set
                                    	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                        self.yang_name = "attribute-set-xro"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                        self.xro.parent = self
                                        self._children_name_map["xro"] = "xro"
                                        self._children_yang_names.add("xro")


                                    class Xro(Entity):
                                        """
                                        The XRO specified by this attribute\-set
                                        
                                        .. attribute:: mutual_diversity_flag
                                        
                                        	Mutual Diversity Flag
                                        	**type**\:  bool
                                        
                                        .. attribute:: xro_subobject
                                        
                                        	List of XRO sub\-objects
                                        	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                            self.yang_name = "xro"
                                            self.yang_parent_name = "attribute-set-xro"

                                            self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                            self.xro_subobject = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("mutual_diversity_flag") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                        class XroSubobject(Entity):
                                            """
                                            List of XRO sub\-objects
                                            
                                            .. attribute:: as_subobject
                                            
                                            	AS sub\-object
                                            	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                            
                                            .. attribute:: ipv4_subobject
                                            
                                            	IPv4 sub\-object
                                            	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                            
                                            .. attribute:: ipv6_subobject
                                            
                                            	IPv6 sub\-object
                                            	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                            
                                            .. attribute:: lsp_subobject
                                            
                                            	P2P LSP sub\-object
                                            	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                            
                                            .. attribute:: srlg_subobject
                                            
                                            	SRLG sub\-object
                                            	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                            
                                            .. attribute:: type
                                            
                                            	Type
                                            	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                            
                                            .. attribute:: unnumbered_subobject
                                            
                                            	Unnumbered sub\-object
                                            	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                self.yang_name = "xro-subobject"
                                                self.yang_parent_name = "xro"

                                                self.type = YLeaf(YType.enumeration, "type")

                                                self.as_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                self.as_subobject.parent = self
                                                self._children_name_map["as_subobject"] = "as-subobject"
                                                self._children_yang_names.add("as-subobject")

                                                self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                self.ipv4_subobject.parent = self
                                                self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                self._children_yang_names.add("ipv4-subobject")

                                                self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                self.ipv6_subobject.parent = self
                                                self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                self._children_yang_names.add("ipv6-subobject")

                                                self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                self.lsp_subobject.parent = self
                                                self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                self._children_yang_names.add("lsp-subobject")

                                                self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                self.srlg_subobject.parent = self
                                                self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                self._children_yang_names.add("srlg-subobject")

                                                self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                self.unnumbered_subobject.parent = self
                                                self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                self._children_yang_names.add("unnumbered-subobject")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                            class Ipv4Subobject(Entity):
                                                """
                                                IPv4 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv4 address
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                    self.yang_name = "ipv4-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.address = YLeaf(YType.str, "address")

                                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("address",
                                                                    "attribute",
                                                                    "exclusion_type",
                                                                    "prefix_len") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.address.is_set or
                                                        self.attribute.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.prefix_len.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.address.yfilter != YFilter.not_set or
                                                        self.attribute.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.prefix_len.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "ipv4-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.address.get_name_leafdata())
                                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "address"):
                                                        self.address = value
                                                        self.address.value_namespace = name_space
                                                        self.address.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "attribute"):
                                                        self.attribute = value
                                                        self.attribute.value_namespace = name_space
                                                        self.attribute.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "prefix-len"):
                                                        self.prefix_len = value
                                                        self.prefix_len.value_namespace = name_space
                                                        self.prefix_len.value_namespace_prefix = name_space_prefix


                                            class Ipv6Subobject(Entity):
                                                """
                                                IPv6 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv6 address
                                                	**type**\:  str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                    self.yang_name = "ipv6-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.address = YLeaf(YType.str, "address")

                                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("address",
                                                                    "attribute",
                                                                    "exclusion_type",
                                                                    "prefix_len") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.address.is_set or
                                                        self.attribute.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.prefix_len.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.address.yfilter != YFilter.not_set or
                                                        self.attribute.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.prefix_len.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "ipv6-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.address.get_name_leafdata())
                                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "address"):
                                                        self.address = value
                                                        self.address.value_namespace = name_space
                                                        self.address.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "attribute"):
                                                        self.attribute = value
                                                        self.attribute.value_namespace = name_space
                                                        self.attribute.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "prefix-len"):
                                                        self.prefix_len = value
                                                        self.prefix_len.value_namespace = name_space
                                                        self.prefix_len.value_namespace_prefix = name_space_prefix


                                            class UnnumberedSubobject(Entity):
                                                """
                                                Unnumbered sub\-object
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: interface_id
                                                
                                                	Interface ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: te_router_id
                                                
                                                	TE router\-id
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                    self.yang_name = "unnumbered-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                                    self.te_router_id = YLeaf(YType.str, "te-router-id")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("attribute",
                                                                    "exclusion_type",
                                                                    "interface_id",
                                                                    "te_router_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.attribute.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.interface_id.is_set or
                                                        self.te_router_id.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.attribute.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.interface_id.yfilter != YFilter.not_set or
                                                        self.te_router_id.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "unnumbered-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.interface_id.get_name_leafdata())
                                                    if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "attribute"):
                                                        self.attribute = value
                                                        self.attribute.value_namespace = name_space
                                                        self.attribute.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "interface-id"):
                                                        self.interface_id = value
                                                        self.interface_id.value_namespace = name_space
                                                        self.interface_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "te-router-id"):
                                                        self.te_router_id = value
                                                        self.te_router_id.value_namespace = name_space
                                                        self.te_router_id.value_namespace_prefix = name_space_prefix


                                            class AsSubobject(Entity):
                                                """
                                                AS sub\-object
                                                
                                                .. attribute:: as_number
                                                
                                                	Autonomous System number
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                    self.yang_name = "as-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.as_number = YLeaf(YType.uint16, "as-number")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("as_number") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.as_number.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.as_number.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "as-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.as_number.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "as-number"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "as-number"):
                                                        self.as_number = value
                                                        self.as_number.value_namespace = name_space
                                                        self.as_number.value_namespace_prefix = name_space_prefix


                                            class SrlgSubobject(Entity):
                                                """
                                                SRLG sub\-object
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: srlg_id
                                                
                                                	SRLG ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                    self.yang_name = "srlg-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("exclusion_type",
                                                                    "srlg_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.exclusion_type.is_set or
                                                        self.srlg_id.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.srlg_id.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "srlg-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "exclusion-type" or name == "srlg-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "srlg-id"):
                                                        self.srlg_id = value
                                                        self.srlg_id.value_namespace = name_space
                                                        self.srlg_id.value_namespace_prefix = name_space_prefix


                                            class LspSubobject(Entity):
                                                """
                                                P2P LSP sub\-object
                                                
                                                .. attribute:: destination_node_exception
                                                
                                                	Destination\-node exception flag
                                                	**type**\:  bool
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: fec
                                                
                                                	LSP FEC
                                                	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                
                                                .. attribute:: ignore_lsp_id
                                                
                                                	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                	**type**\:  bool
                                                
                                                .. attribute:: penultimate_node_exception
                                                
                                                	Penultimate\-node exception flag
                                                	**type**\:  bool
                                                
                                                .. attribute:: processing_node_exception
                                                
                                                	Processing\-node exception flag
                                                	**type**\:  bool
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                    self.yang_name = "lsp-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                                    self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                                    self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                                    self.fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                    self.fec.parent = self
                                                    self._children_name_map["fec"] = "fec"
                                                    self._children_yang_names.add("fec")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("destination_node_exception",
                                                                    "exclusion_type",
                                                                    "ignore_lsp_id",
                                                                    "penultimate_node_exception",
                                                                    "processing_node_exception") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                                class Fec(Entity):
                                                    """
                                                    LSP FEC
                                                    
                                                    .. attribute:: fec_destination_info
                                                    
                                                    	Destination or P2MP ID
                                                    	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                    
                                                    .. attribute:: fec_extended_tunnel_id
                                                    
                                                    	Extended tunnel ID
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: fec_lsp_id
                                                    
                                                    	LSP ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: fec_source
                                                    
                                                    	Tunnel source address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: fec_tunnel_id
                                                    
                                                    	Tunnel ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: fec_vrf
                                                    
                                                    	VRF; currently only for GMPLS tunnels
                                                    	**type**\:  str
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                        self.yang_name = "fec"
                                                        self.yang_parent_name = "lsp-subobject"

                                                        self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                        self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                        self.fec_source = YLeaf(YType.str, "fec-source")

                                                        self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                        self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                        self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                        self.fec_destination_info.parent = self
                                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                        self._children_yang_names.add("fec-destination-info")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("fec_extended_tunnel_id",
                                                                        "fec_lsp_id",
                                                                        "fec_source",
                                                                        "fec_tunnel_id",
                                                                        "fec_vrf") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                                    class FecDestinationInfo(Entity):
                                                        """
                                                        Destination or P2MP ID
                                                        
                                                        .. attribute:: fec_ctype
                                                        
                                                        	FEC CType
                                                        	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                        
                                                        .. attribute:: fec_destination_p2mp_id
                                                        
                                                        	P2MP ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: p2p_lsp_destination
                                                        
                                                        	P2P LSP destination
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                            self.yang_name = "fec-destination-info"
                                                            self.yang_parent_name = "fec"

                                                            self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                            self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                            self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("fec_ctype",
                                                                            "fec_destination_p2mp_id",
                                                                            "p2p_lsp_destination") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.fec_ctype.is_set or
                                                                self.fec_destination_p2mp_id.is_set or
                                                                self.p2p_lsp_destination.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.fec_ctype.yfilter != YFilter.not_set or
                                                                self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                                self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "fec-destination-info" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                            if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                            if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "fec-ctype"):
                                                                self.fec_ctype = value
                                                                self.fec_ctype.value_namespace = name_space
                                                                self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-destination-p2mp-id"):
                                                                self.fec_destination_p2mp_id = value
                                                                self.fec_destination_p2mp_id.value_namespace = name_space
                                                                self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "p2p-lsp-destination"):
                                                                self.p2p_lsp_destination = value
                                                                self.p2p_lsp_destination.value_namespace = name_space
                                                                self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.fec_extended_tunnel_id.is_set or
                                                            self.fec_lsp_id.is_set or
                                                            self.fec_source.is_set or
                                                            self.fec_tunnel_id.is_set or
                                                            self.fec_vrf.is_set or
                                                            (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                            self.fec_lsp_id.yfilter != YFilter.not_set or
                                                            self.fec_source.yfilter != YFilter.not_set or
                                                            self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                            self.fec_vrf.yfilter != YFilter.not_set or
                                                            (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "fec" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                        if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                        if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                        if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                        if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "fec-destination-info"):
                                                            if (self.fec_destination_info is None):
                                                                self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                                self.fec_destination_info.parent = self
                                                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            return self.fec_destination_info

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "fec-extended-tunnel-id"):
                                                            self.fec_extended_tunnel_id = value
                                                            self.fec_extended_tunnel_id.value_namespace = name_space
                                                            self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-lsp-id"):
                                                            self.fec_lsp_id = value
                                                            self.fec_lsp_id.value_namespace = name_space
                                                            self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-source"):
                                                            self.fec_source = value
                                                            self.fec_source.value_namespace = name_space
                                                            self.fec_source.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-tunnel-id"):
                                                            self.fec_tunnel_id = value
                                                            self.fec_tunnel_id.value_namespace = name_space
                                                            self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-vrf"):
                                                            self.fec_vrf = value
                                                            self.fec_vrf.value_namespace = name_space
                                                            self.fec_vrf.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.destination_node_exception.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.ignore_lsp_id.is_set or
                                                        self.penultimate_node_exception.is_set or
                                                        self.processing_node_exception.is_set or
                                                        (self.fec is not None and self.fec.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.destination_node_exception.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                        self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                        self.processing_node_exception.yfilter != YFilter.not_set or
                                                        (self.fec is not None and self.fec.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsp-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                                    if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                                    if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "fec"):
                                                        if (self.fec is None):
                                                            self.fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                            self.fec.parent = self
                                                            self._children_name_map["fec"] = "fec"
                                                        return self.fec

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "destination-node-exception"):
                                                        self.destination_node_exception = value
                                                        self.destination_node_exception.value_namespace = name_space
                                                        self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ignore-lsp-id"):
                                                        self.ignore_lsp_id = value
                                                        self.ignore_lsp_id.value_namespace = name_space
                                                        self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "penultimate-node-exception"):
                                                        self.penultimate_node_exception = value
                                                        self.penultimate_node_exception.value_namespace = name_space
                                                        self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "processing-node-exception"):
                                                        self.processing_node_exception = value
                                                        self.processing_node_exception.value_namespace = name_space
                                                        self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.type.is_set or
                                                    (self.as_subobject is not None and self.as_subobject.has_data()) or
                                                    (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                                    (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                                    (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                                    (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                                    (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.type.yfilter != YFilter.not_set or
                                                    (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                                    (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                                    (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                                    (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                                    (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                                    (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "xro-subobject" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "as-subobject"):
                                                    if (self.as_subobject is None):
                                                        self.as_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                        self.as_subobject.parent = self
                                                        self._children_name_map["as_subobject"] = "as-subobject"
                                                    return self.as_subobject

                                                if (child_yang_name == "ipv4-subobject"):
                                                    if (self.ipv4_subobject is None):
                                                        self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                        self.ipv4_subobject.parent = self
                                                        self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                    return self.ipv4_subobject

                                                if (child_yang_name == "ipv6-subobject"):
                                                    if (self.ipv6_subobject is None):
                                                        self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                        self.ipv6_subobject.parent = self
                                                        self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                    return self.ipv6_subobject

                                                if (child_yang_name == "lsp-subobject"):
                                                    if (self.lsp_subobject is None):
                                                        self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                        self.lsp_subobject.parent = self
                                                        self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    return self.lsp_subobject

                                                if (child_yang_name == "srlg-subobject"):
                                                    if (self.srlg_subobject is None):
                                                        self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                        self.srlg_subobject.parent = self
                                                        self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                    return self.srlg_subobject

                                                if (child_yang_name == "unnumbered-subobject"):
                                                    if (self.unnumbered_subobject is None):
                                                        self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                        self.unnumbered_subobject.parent = self
                                                        self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                    return self.unnumbered_subobject

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "type"):
                                                    self.type = value
                                                    self.type.value_namespace = name_space
                                                    self.type.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.xro_subobject:
                                                if (c.has_data()):
                                                    return True
                                            return self.mutual_diversity_flag.is_set

                                        def has_operation(self):
                                            for c in self.xro_subobject:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "xro" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "xro-subobject"):
                                                for c in self.xro_subobject:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.xro_subobject.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "mutual-diversity-flag"):
                                                self.mutual_diversity_flag = value
                                                self.mutual_diversity_flag.value_namespace = name_space
                                                self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (self.xro is not None and self.xro.has_data())

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.xro is not None and self.xro.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-xro" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "xro"):
                                            if (self.xro is None):
                                                self.xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                                self.xro.parent = self
                                                self._children_name_map["xro"] = "xro"
                                            return self.xro

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "xro"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass


                                class AttributeSetP2Mpte(Entity):
                                    """
                                    MPLS TE P2MP\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\:  bool
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\:  bool
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                        self.yang_name = "attribute-set-p2mpte"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                        self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                        self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                        self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                        self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                        self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                        self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                        self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("configured_bandwidth",
                                                        "dste_class_type",
                                                        "fast_reroute",
                                                        "frr_bandwidth_protection",
                                                        "hold_priority",
                                                        "is_affinity_configured",
                                                        "is_bandwidth_configured",
                                                        "is_priority_configured",
                                                        "setup_priority") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2mpte"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2mpte"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.configured_bandwidth.is_set or
                                            self.dste_class_type.is_set or
                                            self.fast_reroute.is_set or
                                            self.frr_bandwidth_protection.is_set or
                                            self.hold_priority.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_bandwidth_configured.is_set or
                                            self.is_priority_configured.is_set or
                                            self.setup_priority.is_set or
                                            (self.affinity is not None and self.affinity.has_data()))

                                    def has_operation(self):
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.configured_bandwidth.yfilter != YFilter.not_set or
                                            self.dste_class_type.yfilter != YFilter.not_set or
                                            self.fast_reroute.yfilter != YFilter.not_set or
                                            self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                            self.hold_priority.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                            self.is_priority_configured.yfilter != YFilter.not_set or
                                            self.setup_priority.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-p2mpte" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                        if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                        if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                        if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                        if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                        if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                        if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "configured-bandwidth"):
                                            self.configured_bandwidth = value
                                            self.configured_bandwidth.value_namespace = name_space
                                            self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dste-class-type"):
                                            self.dste_class_type = value
                                            self.dste_class_type.value_namespace = name_space
                                            self.dste_class_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "fast-reroute"):
                                            self.fast_reroute = value
                                            self.fast_reroute.value_namespace = name_space
                                            self.fast_reroute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "frr-bandwidth-protection"):
                                            self.frr_bandwidth_protection = value
                                            self.frr_bandwidth_protection.value_namespace = name_space
                                            self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "hold-priority"):
                                            self.hold_priority = value
                                            self.hold_priority.value_namespace = name_space
                                            self.hold_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bandwidth-configured"):
                                            self.is_bandwidth_configured = value
                                            self.is_bandwidth_configured.value_namespace = name_space
                                            self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-priority-configured"):
                                            self.is_priority_configured = value
                                            self.is_priority_configured.value_namespace = name_space
                                            self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "setup-priority"):
                                            self.setup_priority = value
                                            self.setup_priority.value_namespace = name_space
                                            self.setup_priority.value_namespace_prefix = name_space_prefix


                                class AttributeSetApsPp(Entity):
                                    """
                                    Attribute Set OTN APS Path Protection
                                    
                                    .. attribute:: hold_off_time
                                    
                                    	Hold\-off time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path Protection Profile Type
                                    	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    .. attribute:: protection_mode
                                    
                                    	Protection Restoration Mode
                                    	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                    
                                    .. attribute:: protection_type
                                    
                                    	Protection Type
                                    	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    .. attribute:: restoration_style
                                    
                                    	Restoration Style
                                    	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                    
                                    .. attribute:: revert_schedule
                                    
                                    	Revert Schedule
                                    	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                    
                                    .. attribute:: snc_mode
                                    
                                    	Sub\-network Connection Mode
                                    	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    .. attribute:: tcm_id
                                    
                                    	Sub\-network Connection Monitoring Mode
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: wait_to_restore_time
                                    
                                    	Wait to restore time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                        self.yang_name = "attribute-set-aps-pp"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                        self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                        self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                        self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                        self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                        self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                        self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                        self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                        self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                        self.revert_schedule.parent = self
                                        self._children_name_map["revert_schedule"] = "revert-schedule"
                                        self._children_yang_names.add("revert-schedule")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("hold_off_time",
                                                        "path_prot_profile_type",
                                                        "protection_mode",
                                                        "protection_type",
                                                        "restoration_style",
                                                        "snc_mode",
                                                        "tcm_id",
                                                        "wait_to_restore_time") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                                    class RevertSchedule(Entity):
                                        """
                                        Revert Schedule
                                        
                                        .. attribute:: duration
                                        
                                        	Duration for scheduled reversion
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: max_tries
                                        
                                        	Max tries for scheduled reversion
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: schedule_date
                                        
                                        	Schedule time for reversion
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: schedule_frequency
                                        
                                        	Schedule frequency for reversion
                                        	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                        
                                        .. attribute:: schedulename
                                        
                                        	Schedule name identifier
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                            self.yang_name = "revert-schedule"
                                            self.yang_parent_name = "attribute-set-aps-pp"

                                            self.duration = YLeaf(YType.uint32, "duration")

                                            self.max_tries = YLeaf(YType.uint32, "max-tries")

                                            self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                            self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                            self.schedulename = YLeaf(YType.str, "schedulename")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("duration",
                                                            "max_tries",
                                                            "schedule_date",
                                                            "schedule_frequency",
                                                            "schedulename") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.duration.is_set or
                                                self.max_tries.is_set or
                                                self.schedule_date.is_set or
                                                self.schedule_frequency.is_set or
                                                self.schedulename.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.duration.yfilter != YFilter.not_set or
                                                self.max_tries.yfilter != YFilter.not_set or
                                                self.schedule_date.yfilter != YFilter.not_set or
                                                self.schedule_frequency.yfilter != YFilter.not_set or
                                                self.schedulename.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "revert-schedule" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.duration.get_name_leafdata())
                                            if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.max_tries.get_name_leafdata())
                                            if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                            if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                            if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.schedulename.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "duration"):
                                                self.duration = value
                                                self.duration.value_namespace = name_space
                                                self.duration.value_namespace_prefix = name_space_prefix
                                            if(value_path == "max-tries"):
                                                self.max_tries = value
                                                self.max_tries.value_namespace = name_space
                                                self.max_tries.value_namespace_prefix = name_space_prefix
                                            if(value_path == "schedule-date"):
                                                self.schedule_date = value
                                                self.schedule_date.value_namespace = name_space
                                                self.schedule_date.value_namespace_prefix = name_space_prefix
                                            if(value_path == "schedule-frequency"):
                                                self.schedule_frequency = value
                                                self.schedule_frequency.value_namespace = name_space
                                                self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                            if(value_path == "schedulename"):
                                                self.schedulename = value
                                                self.schedulename.value_namespace = name_space
                                                self.schedulename.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.hold_off_time.is_set or
                                            self.path_prot_profile_type.is_set or
                                            self.protection_mode.is_set or
                                            self.protection_type.is_set or
                                            self.restoration_style.is_set or
                                            self.snc_mode.is_set or
                                            self.tcm_id.is_set or
                                            self.wait_to_restore_time.is_set or
                                            (self.revert_schedule is not None and self.revert_schedule.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.hold_off_time.yfilter != YFilter.not_set or
                                            self.path_prot_profile_type.yfilter != YFilter.not_set or
                                            self.protection_mode.yfilter != YFilter.not_set or
                                            self.protection_type.yfilter != YFilter.not_set or
                                            self.restoration_style.yfilter != YFilter.not_set or
                                            self.snc_mode.yfilter != YFilter.not_set or
                                            self.tcm_id.yfilter != YFilter.not_set or
                                            self.wait_to_restore_time.yfilter != YFilter.not_set or
                                            (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-aps-pp" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                        if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                        if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                        if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.protection_type.get_name_leafdata())
                                        if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                        if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                        if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                        if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "revert-schedule"):
                                            if (self.revert_schedule is None):
                                                self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                                self.revert_schedule.parent = self
                                                self._children_name_map["revert_schedule"] = "revert-schedule"
                                            return self.revert_schedule

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "hold-off-time"):
                                            self.hold_off_time = value
                                            self.hold_off_time.value_namespace = name_space
                                            self.hold_off_time.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-prot-profile-type"):
                                            self.path_prot_profile_type = value
                                            self.path_prot_profile_type.value_namespace = name_space
                                            self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "protection-mode"):
                                            self.protection_mode = value
                                            self.protection_mode.value_namespace = name_space
                                            self.protection_mode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "protection-type"):
                                            self.protection_type = value
                                            self.protection_type.value_namespace = name_space
                                            self.protection_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "restoration-style"):
                                            self.restoration_style = value
                                            self.restoration_style.value_namespace = name_space
                                            self.restoration_style.value_namespace_prefix = name_space_prefix
                                        if(value_path == "snc-mode"):
                                            self.snc_mode = value
                                            self.snc_mode.value_namespace = name_space
                                            self.snc_mode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcm-id"):
                                            self.tcm_id = value
                                            self.tcm_id.value_namespace = name_space
                                            self.tcm_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "wait-to-restore-time"):
                                            self.wait_to_restore_time = value
                                            self.wait_to_restore_time.value_namespace = name_space
                                            self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                                class AttributeSetP2PTe(Entity):
                                    """
                                    MPLS TE P2P\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is Path Invalidation action configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is Path Invalidation timeout configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_select_configured
                                    
                                    	Is any of the path selection parameters configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_metric_configured
                                    
                                    	Is path selection metric configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                    
                                    	Is path selection segment routing configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_configured
                                    
                                    	Is path selection margin configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_relative
                                    
                                    	Path selection margin is\_relative
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                    
                                    	Is path selection segment limit configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_prepend_list_configured
                                    
                                    	Is SR prepend list configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation timeout on the tunnel path
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_selection_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                    
                                    .. attribute:: path_selection_metric
                                    
                                    	Path selection metric type
                                    	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                    
                                    .. attribute:: path_selection_segment_routing_adjacency_protection
                                    
                                    	Path selection segment\-routing type
                                    	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                                    
                                    .. attribute:: path_selection_segment_routing_margin
                                    
                                    	Path selection margin
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_selection_segment_routing_segment_limit
                                    
                                    	Is path selection segment limit configured
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    .. attribute:: prepend_list
                                    
                                    	SR prepend list
                                    	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                        self.yang_name = "attribute-set-p2p-te"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                        self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                        self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                        self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                        self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                        self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                        self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                        self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                        self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                        self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                        self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                        self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                        self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                        self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                        self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                        self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                        self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                        self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                        self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                        self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                        self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                        self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                        self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                        self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                        self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                        self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                        self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"
                                        self._children_yang_names.add("logging")

                                        self.prepend_list = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                        self.prepend_list.parent = self
                                        self._children_name_map["prepend_list"] = "prepend-list"
                                        self._children_yang_names.add("prepend-list")

                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_affinity_configured",
                                                        "is_path_invalidation_action_configured",
                                                        "is_path_invalidation_timeout_configured",
                                                        "is_path_select_configured",
                                                        "is_path_selection_metric_configured",
                                                        "is_path_selection_segment_routing_adjacency_protection_configured",
                                                        "is_path_selection_segment_routing_margin_configured",
                                                        "is_path_selection_segment_routing_margin_relative",
                                                        "is_path_selection_segment_routing_segment_limit_configured",
                                                        "is_pce_configured",
                                                        "is_pce_disj_group_id_configured",
                                                        "is_pce_disj_source_configured",
                                                        "is_pce_disj_type_configured",
                                                        "is_pceb_dj_source_configured",
                                                        "is_pcebd_group_id_configured",
                                                        "is_prepend_list_configured",
                                                        "path_invalidation_timeout",
                                                        "path_selection_invalidation_action",
                                                        "path_selection_metric",
                                                        "path_selection_segment_routing_adjacency_protection",
                                                        "path_selection_segment_routing_margin",
                                                        "path_selection_segment_routing_segment_limit",
                                                        "pcebd_group_id",
                                                        "pcebd_source_address",
                                                        "pcedp_group_id",
                                                        "pcedp_source_address",
                                                        "pcedp_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class Logging(Entity):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                            self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                            self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                            self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                            self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                            self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                            self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                            self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("all_logging_enabled",
                                                            "lsp_bandwidth_change",
                                                            "lsp_insufficient_bw",
                                                            "lsp_pcalc_failure_logging_enabled",
                                                            "lsp_re_opt",
                                                            "lsp_re_route",
                                                            "lsp_state",
                                                            "s2l_state") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.all_logging_enabled.is_set or
                                                self.lsp_bandwidth_change.is_set or
                                                self.lsp_insufficient_bw.is_set or
                                                self.lsp_pcalc_failure_logging_enabled.is_set or
                                                self.lsp_re_opt.is_set or
                                                self.lsp_re_route.is_set or
                                                self.lsp_state.is_set or
                                                self.s2l_state.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.all_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_re_opt.yfilter != YFilter.not_set or
                                                self.lsp_re_route.yfilter != YFilter.not_set or
                                                self.lsp_state.yfilter != YFilter.not_set or
                                                self.s2l_state.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "logging" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                            if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                            if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                            if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                            if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                            if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                            if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                            if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "all-logging-enabled"):
                                                self.all_logging_enabled = value
                                                self.all_logging_enabled.value_namespace = name_space
                                                self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-bandwidth-change"):
                                                self.lsp_bandwidth_change = value
                                                self.lsp_bandwidth_change.value_namespace = name_space
                                                self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-insufficient-bw"):
                                                self.lsp_insufficient_bw = value
                                                self.lsp_insufficient_bw.value_namespace = name_space
                                                self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                self.lsp_pcalc_failure_logging_enabled = value
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-opt"):
                                                self.lsp_re_opt = value
                                                self.lsp_re_opt.value_namespace = name_space
                                                self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-route"):
                                                self.lsp_re_route = value
                                                self.lsp_re_route.value_namespace = name_space
                                                self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-state"):
                                                self.lsp_state = value
                                                self.lsp_state.value_namespace = name_space
                                                self.lsp_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "s2l-state"):
                                                self.s2l_state = value
                                                self.s2l_state.value_namespace = name_space
                                                self.s2l_state.value_namespace_prefix = name_space_prefix


                                    class PrependList(Entity):
                                        """
                                        SR prepend list
                                        
                                        .. attribute:: prepend_entry
                                        
                                        	List of prepend entries
                                        	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                            self.yang_name = "prepend-list"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.prepend_entry = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in () and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                        class PrependEntry(Entity):
                                            """
                                            List of prepend entries
                                            
                                            .. attribute:: index
                                            
                                            	Prepend index
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: next_label
                                            
                                            	Prepend next label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: type
                                            
                                            	Prepend Type
                                            	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                                self.yang_name = "prepend-entry"
                                                self.yang_parent_name = "prepend-list"

                                                self.index = YLeaf(YType.uint32, "index")

                                                self.next_label = YLeaf(YType.uint32, "next-label")

                                                self.type = YLeaf(YType.enumeration, "type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("index",
                                                                "next_label",
                                                                "type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.index.is_set or
                                                    self.next_label.is_set or
                                                    self.type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.index.yfilter != YFilter.not_set or
                                                    self.next_label.yfilter != YFilter.not_set or
                                                    self.type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prepend-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.index.get_name_leafdata())
                                                if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.next_label.get_name_leafdata())
                                                if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "index" or name == "next-label" or name == "type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "index"):
                                                    self.index = value
                                                    self.index.value_namespace = name_space
                                                    self.index.value_namespace_prefix = name_space_prefix
                                                if(value_path == "next-label"):
                                                    self.next_label = value
                                                    self.next_label.value_namespace = name_space
                                                    self.next_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "type"):
                                                    self.type = value
                                                    self.type.value_namespace = name_space
                                                    self.type.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.prepend_entry:
                                                if (c.has_data()):
                                                    return True
                                            return False

                                        def has_operation(self):
                                            for c in self.prepend_entry:
                                                if (c.has_operation()):
                                                    return True
                                            return self.yfilter != YFilter.not_set

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "prepend-list" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "prepend-entry"):
                                                for c in self.prepend_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.prepend_entry.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "prepend-entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.is_affinity_configured.is_set or
                                            self.is_path_invalidation_action_configured.is_set or
                                            self.is_path_invalidation_timeout_configured.is_set or
                                            self.is_path_select_configured.is_set or
                                            self.is_path_selection_metric_configured.is_set or
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                            self.is_path_selection_segment_routing_margin_configured.is_set or
                                            self.is_path_selection_segment_routing_margin_relative.is_set or
                                            self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                            self.is_pce_configured.is_set or
                                            self.is_pce_disj_group_id_configured.is_set or
                                            self.is_pce_disj_source_configured.is_set or
                                            self.is_pce_disj_type_configured.is_set or
                                            self.is_pceb_dj_source_configured.is_set or
                                            self.is_pcebd_group_id_configured.is_set or
                                            self.is_prepend_list_configured.is_set or
                                            self.path_invalidation_timeout.is_set or
                                            self.path_selection_invalidation_action.is_set or
                                            self.path_selection_metric.is_set or
                                            self.path_selection_segment_routing_adjacency_protection.is_set or
                                            self.path_selection_segment_routing_margin.is_set or
                                            self.path_selection_segment_routing_segment_limit.is_set or
                                            self.pcebd_group_id.is_set or
                                            self.pcebd_source_address.is_set or
                                            self.pcedp_group_id.is_set or
                                            self.pcedp_source_address.is_set or
                                            self.pcedp_type.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.logging is not None and self.logging.has_data()) or
                                            (self.prepend_list is not None and self.prepend_list.has_data()))

                                    def has_operation(self):
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                            self.is_path_select_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                            self.is_pce_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                            self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                            self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                            self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                            self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                            self.path_selection_metric.yfilter != YFilter.not_set or
                                            self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                            self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                            self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                            self.pcebd_group_id.yfilter != YFilter.not_set or
                                            self.pcebd_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_group_id.yfilter != YFilter.not_set or
                                            self.pcedp_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_type.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.logging is not None and self.logging.has_operation()) or
                                            (self.prepend_list is not None and self.prepend_list.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-p2p-te" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                        if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                        if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                        if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                        if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                        if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                        if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                        if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                        if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                        if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                        if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                        if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                        if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                        if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                        if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                        if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                        if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                        if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                        if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                        if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                        if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "logging"):
                                            if (self.logging is None):
                                                self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                                self.logging.parent = self
                                                self._children_name_map["logging"] = "logging"
                                            return self.logging

                                        if (child_yang_name == "prepend-list"):
                                            if (self.prepend_list is None):
                                                self.prepend_list = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                                self.prepend_list.parent = self
                                                self._children_name_map["prepend_list"] = "prepend-list"
                                            return self.prepend_list

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-action-configured"):
                                            self.is_path_invalidation_action_configured = value
                                            self.is_path_invalidation_action_configured.value_namespace = name_space
                                            self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-timeout-configured"):
                                            self.is_path_invalidation_timeout_configured = value
                                            self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                            self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-select-configured"):
                                            self.is_path_select_configured = value
                                            self.is_path_select_configured.value_namespace = name_space
                                            self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-metric-configured"):
                                            self.is_path_selection_metric_configured = value
                                            self.is_path_selection_metric_configured.value_namespace = name_space
                                            self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                            self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                            self.is_path_selection_segment_routing_margin_configured = value
                                            self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                            self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                            self.is_path_selection_segment_routing_margin_relative = value
                                            self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                            self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                            self.is_path_selection_segment_routing_segment_limit_configured = value
                                            self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                            self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-configured"):
                                            self.is_pce_configured = value
                                            self.is_pce_configured.value_namespace = name_space
                                            self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-group-id-configured"):
                                            self.is_pce_disj_group_id_configured = value
                                            self.is_pce_disj_group_id_configured.value_namespace = name_space
                                            self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-source-configured"):
                                            self.is_pce_disj_source_configured = value
                                            self.is_pce_disj_source_configured.value_namespace = name_space
                                            self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-type-configured"):
                                            self.is_pce_disj_type_configured = value
                                            self.is_pce_disj_type_configured.value_namespace = name_space
                                            self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pceb-dj-source-configured"):
                                            self.is_pceb_dj_source_configured = value
                                            self.is_pceb_dj_source_configured.value_namespace = name_space
                                            self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pcebd-group-id-configured"):
                                            self.is_pcebd_group_id_configured = value
                                            self.is_pcebd_group_id_configured.value_namespace = name_space
                                            self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-prepend-list-configured"):
                                            self.is_prepend_list_configured = value
                                            self.is_prepend_list_configured.value_namespace = name_space
                                            self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-invalidation-timeout"):
                                            self.path_invalidation_timeout = value
                                            self.path_invalidation_timeout.value_namespace = name_space
                                            self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-invalidation-action"):
                                            self.path_selection_invalidation_action = value
                                            self.path_selection_invalidation_action.value_namespace = name_space
                                            self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-metric"):
                                            self.path_selection_metric = value
                                            self.path_selection_metric.value_namespace = name_space
                                            self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                            self.path_selection_segment_routing_adjacency_protection = value
                                            self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                            self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-segment-routing-margin"):
                                            self.path_selection_segment_routing_margin = value
                                            self.path_selection_segment_routing_margin.value_namespace = name_space
                                            self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-segment-routing-segment-limit"):
                                            self.path_selection_segment_routing_segment_limit = value
                                            self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                            self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-group-id"):
                                            self.pcebd_group_id = value
                                            self.pcebd_group_id.value_namespace = name_space
                                            self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-source-address"):
                                            self.pcebd_source_address = value
                                            self.pcebd_source_address.value_namespace = name_space
                                            self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-group-id"):
                                            self.pcedp_group_id = value
                                            self.pcedp_group_id.value_namespace = name_space
                                            self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-source-address"):
                                            self.pcedp_source_address = value
                                            self.pcedp_source_address.value_namespace = name_space
                                            self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-type"):
                                            self.pcedp_type = value
                                            self.pcedp_type.value_namespace = name_space
                                            self.pcedp_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.tunnel_attribute_set_type.is_set or
                                        (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                        (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                        (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                        (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                        (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                        (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                        (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                        (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                        (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                        (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                        (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                        (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                        (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                        (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "attribute-set-union" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "attribute-set-aps-pp"):
                                        if (self.attribute_set_aps_pp is None):
                                            self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                            self.attribute_set_aps_pp.parent = self
                                            self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                        return self.attribute_set_aps_pp

                                    if (child_yang_name == "attribute-set-autobackup"):
                                        if (self.attribute_set_autobackup is None):
                                            self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                            self.attribute_set_autobackup.parent = self
                                            self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                        return self.attribute_set_autobackup

                                    if (child_yang_name == "attribute-set-automesh"):
                                        if (self.attribute_set_automesh is None):
                                            self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                            self.attribute_set_automesh.parent = self
                                            self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                        return self.attribute_set_automesh

                                    if (child_yang_name == "attribute-set-p2mpte"):
                                        if (self.attribute_set_p2mpte is None):
                                            self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                            self.attribute_set_p2mpte.parent = self
                                            self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                        return self.attribute_set_p2mpte

                                    if (child_yang_name == "attribute-set-p2p-te"):
                                        if (self.attribute_set_p2p_te is None):
                                            self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                            self.attribute_set_p2p_te.parent = self
                                            self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        return self.attribute_set_p2p_te

                                    if (child_yang_name == "attribute-set-path-option"):
                                        if (self.attribute_set_path_option is None):
                                            self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                            self.attribute_set_path_option.parent = self
                                            self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                        return self.attribute_set_path_option

                                    if (child_yang_name == "attribute-set-xro"):
                                        if (self.attribute_set_xro is None):
                                            self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                            self.attribute_set_xro.parent = self
                                            self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                        return self.attribute_set_xro

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "tunnel-attribute-set-type"):
                                        self.tunnel_attribute_set_type = value
                                        self.tunnel_attribute_set_type.value_namespace = name_space
                                        self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.tunnel_attribute_set_name.is_set or
                                    self.tunnel_attribute_set_name_crc32.is_set or
                                    (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                                    self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                                    (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "attribute-set" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                                if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "attribute-set-union"):
                                    if (self.attribute_set_union is None):
                                        self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet.AttributeSetUnion()
                                        self.attribute_set_union.parent = self
                                        self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    return self.attribute_set_union

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "tunnel-attribute-set-name"):
                                    self.tunnel_attribute_set_name = value
                                    self.tunnel_attribute_set_name.value_namespace = name_space
                                    self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-attribute-set-name-crc32"):
                                    self.tunnel_attribute_set_name_crc32 = value
                                    self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                                    self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                        class XroAttributeSet(Entity):
                            """
                            The XRO attribute set used by this path\-option
                            
                            .. attribute:: attribute_set_union
                            
                            	Union of Attribute Sets
                            	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion>`
                            
                            .. attribute:: tunnel_attribute_set_name
                            
                            	Attribute Set Name
                            	**type**\:  str
                            
                            .. attribute:: tunnel_attribute_set_name_crc32
                            
                            	Attribute Set name CRC32 value
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet, self).__init__()

                                self.yang_name = "xro-attribute-set"
                                self.yang_parent_name = "path-option-entry"

                                self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                                self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                                self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion()
                                self.attribute_set_union.parent = self
                                self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                self._children_yang_names.add("attribute-set-union")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("tunnel_attribute_set_name",
                                                "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet, self).__setattr__(name, value)


                            class AttributeSetUnion(Entity):
                                """
                                Union of Attribute Sets
                                
                                .. attribute:: attribute_set_aps_pp
                                
                                	Attribute Set OTN APS Path Protection
                                	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                
                                .. attribute:: attribute_set_autobackup
                                
                                	MPLS TE Auto\-backup Attribute Set
                                	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                
                                .. attribute:: attribute_set_automesh
                                
                                	MPLS TE Auto\-mesh Attribute Set
                                	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                
                                .. attribute:: attribute_set_p2mpte
                                
                                	MPLS TE P2MP\-TE Attribute Set
                                	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                                
                                .. attribute:: attribute_set_p2p_te
                                
                                	MPLS TE P2P\-TE Attribute Set
                                	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                                
                                .. attribute:: attribute_set_path_option
                                
                                	MPLS TE Path Option Attribute Set
                                	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                
                                .. attribute:: attribute_set_xro
                                
                                	Attribute Set XRO
                                	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                                
                                .. attribute:: tunnel_attribute_set_type
                                
                                	TunnelAttributeSetType
                                	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion, self).__init__()

                                    self.yang_name = "attribute-set-union"
                                    self.yang_parent_name = "xro-attribute-set"

                                    self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                                    self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                    self.attribute_set_aps_pp.parent = self
                                    self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                    self._children_yang_names.add("attribute-set-aps-pp")

                                    self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                    self.attribute_set_autobackup.parent = self
                                    self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                    self._children_yang_names.add("attribute-set-autobackup")

                                    self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                    self.attribute_set_automesh.parent = self
                                    self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                    self._children_yang_names.add("attribute-set-automesh")

                                    self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                    self.attribute_set_p2mpte.parent = self
                                    self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                    self._children_yang_names.add("attribute-set-p2mpte")

                                    self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                    self.attribute_set_p2p_te.parent = self
                                    self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                    self._children_yang_names.add("attribute-set-p2p-te")

                                    self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                    self.attribute_set_path_option.parent = self
                                    self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                    self._children_yang_names.add("attribute-set-path-option")

                                    self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                    self.attribute_set_xro.parent = self
                                    self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                    self._children_yang_names.add("attribute-set-xro")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                                class AttributeSetPathOption(Entity):
                                    """
                                    MPLS TE Path Option Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                    
                                    .. attribute:: bandwidth_type
                                    
                                    	The bandwidth type
                                    	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                    
                                    .. attribute:: bfd_reverse_path
                                    
                                    	BFD reverse path
                                    	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: cost_limit
                                    
                                    	Cost limit on the tunnel path
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: exclude_list_name
                                    
                                    	Exclude list name
                                    	**type**\:  str
                                    
                                    .. attribute:: generation
                                    
                                    	Generation
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bfd_reverse_pat_configured
                                    
                                    	Is BFD reverse path configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_cost_limit_configured
                                    
                                    	Is Cost Limit configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_exclude_list_name_configured
                                    
                                    	Is exclude list name configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is path invalidation action configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is path invalidation timeout configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: path_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation interval on the tunnel path
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                    
                                    .. attribute:: version_info
                                    
                                    	Version Info
                                    	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                        self.yang_name = "attribute-set-path-option"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                        self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                        self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                        self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                        self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                        self.generation = YLeaf(YType.uint32, "generation")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                        self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                        self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                        self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                        self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                        self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                        self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                        self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                        self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                        self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                        self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                        self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                        self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                        self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                        self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                        self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                        self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                        self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                        self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                        self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                        self.bfd_reverse_path.parent = self
                                        self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                        self._children_yang_names.add("bfd-reverse-path")

                                        self.tunnel_id = YList(self)
                                        self.version_info = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bandwidth_type",
                                                        "configured_bandwidth",
                                                        "cost_limit",
                                                        "dste_class_type",
                                                        "exclude_list_name",
                                                        "generation",
                                                        "is_affinity_configured",
                                                        "is_bandwidth_configured",
                                                        "is_bfd_reverse_pat_configured",
                                                        "is_cost_limit_configured",
                                                        "is_exclude_list_name_configured",
                                                        "is_path_invalidation_action_configured",
                                                        "is_path_invalidation_timeout_configured",
                                                        "is_pce_configured",
                                                        "is_pce_disj_group_id_configured",
                                                        "is_pce_disj_source_configured",
                                                        "is_pce_disj_type_configured",
                                                        "is_pceb_dj_source_configured",
                                                        "is_pcebd_group_id_configured",
                                                        "path_invalidation_action",
                                                        "path_invalidation_timeout",
                                                        "pcebd_group_id",
                                                        "pcebd_source_address",
                                                        "pcedp_group_id",
                                                        "pcedp_source_address",
                                                        "pcedp_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class BfdReversePath(Entity):
                                        """
                                        BFD reverse path
                                        
                                        .. attribute:: binding_label
                                        
                                        	BFD reverse path binding label
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_type
                                        
                                        	BFD reverse path type
                                        	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                            self.yang_name = "bfd-reverse-path"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.binding_label = YLeaf(YType.uint32, "binding-label")

                                            self.path_type = YLeaf(YType.enumeration, "path-type")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("binding_label",
                                                            "path_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.binding_label.is_set or
                                                self.path_type.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.binding_label.yfilter != YFilter.not_set or
                                                self.path_type.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bfd-reverse-path" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.binding_label.get_name_leafdata())
                                            if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "binding-label" or name == "path-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "binding-label"):
                                                self.binding_label = value
                                                self.binding_label.value_namespace = name_space
                                                self.binding_label.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-type"):
                                                self.path_type = value
                                                self.path_type.value_namespace = name_space
                                                self.path_type.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class VersionInfo(Entity):
                                        """
                                        Version Info
                                        
                                        .. attribute:: attribute_type
                                        
                                        	Attribute Type
                                        	**type**\:  str
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_default
                                        
                                        	Is default
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                            self.yang_name = "version-info"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.attribute_type = YLeaf(YType.str, "attribute-type")

                                            self.generation = YLeaf(YType.uint32, "generation")

                                            self.is_default = YLeaf(YType.boolean, "is-default")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("attribute_type",
                                                            "generation",
                                                            "is_default") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.attribute_type.is_set or
                                                self.generation.is_set or
                                                self.is_default.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.attribute_type.yfilter != YFilter.not_set or
                                                self.generation.yfilter != YFilter.not_set or
                                                self.is_default.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "version-info" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.generation.get_name_leafdata())
                                            if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_default.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "attribute-type"):
                                                self.attribute_type = value
                                                self.attribute_type.value_namespace = name_space
                                                self.attribute_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "generation"):
                                                self.generation = value
                                                self.generation.value_namespace = name_space
                                                self.generation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-default"):
                                                self.is_default = value
                                                self.is_default.value_namespace = name_space
                                                self.is_default.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        for c in self.version_info:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bandwidth_type.is_set or
                                            self.configured_bandwidth.is_set or
                                            self.cost_limit.is_set or
                                            self.dste_class_type.is_set or
                                            self.exclude_list_name.is_set or
                                            self.generation.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_bandwidth_configured.is_set or
                                            self.is_bfd_reverse_pat_configured.is_set or
                                            self.is_cost_limit_configured.is_set or
                                            self.is_exclude_list_name_configured.is_set or
                                            self.is_path_invalidation_action_configured.is_set or
                                            self.is_path_invalidation_timeout_configured.is_set or
                                            self.is_pce_configured.is_set or
                                            self.is_pce_disj_group_id_configured.is_set or
                                            self.is_pce_disj_source_configured.is_set or
                                            self.is_pce_disj_type_configured.is_set or
                                            self.is_pceb_dj_source_configured.is_set or
                                            self.is_pcebd_group_id_configured.is_set or
                                            self.path_invalidation_action.is_set or
                                            self.path_invalidation_timeout.is_set or
                                            self.pcebd_group_id.is_set or
                                            self.pcebd_source_address.is_set or
                                            self.pcedp_group_id.is_set or
                                            self.pcedp_source_address.is_set or
                                            self.pcedp_type.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                                    def has_operation(self):
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.version_info:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bandwidth_type.yfilter != YFilter.not_set or
                                            self.configured_bandwidth.yfilter != YFilter.not_set or
                                            self.cost_limit.yfilter != YFilter.not_set or
                                            self.dste_class_type.yfilter != YFilter.not_set or
                                            self.exclude_list_name.yfilter != YFilter.not_set or
                                            self.generation.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                            self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                            self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                            self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                            self.is_pce_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                            self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                            self.path_invalidation_action.yfilter != YFilter.not_set or
                                            self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                            self.pcebd_group_id.yfilter != YFilter.not_set or
                                            self.pcebd_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_group_id.yfilter != YFilter.not_set or
                                            self.pcedp_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_type.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-path-option" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                        if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                        if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                        if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                        if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                        if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.generation.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                        if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                        if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                        if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                        if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                        if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                        if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                        if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                        if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                        if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                        if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                        if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                        if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                        if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                        if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                        if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                        if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "bfd-reverse-path"):
                                            if (self.bfd_reverse_path is None):
                                                self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                                self.bfd_reverse_path.parent = self
                                                self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                            return self.bfd_reverse_path

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        if (child_yang_name == "version-info"):
                                            for c in self.version_info:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.version_info.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bandwidth-type"):
                                            self.bandwidth_type = value
                                            self.bandwidth_type.value_namespace = name_space
                                            self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "configured-bandwidth"):
                                            self.configured_bandwidth = value
                                            self.configured_bandwidth.value_namespace = name_space
                                            self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "cost-limit"):
                                            self.cost_limit = value
                                            self.cost_limit.value_namespace = name_space
                                            self.cost_limit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dste-class-type"):
                                            self.dste_class_type = value
                                            self.dste_class_type.value_namespace = name_space
                                            self.dste_class_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclude-list-name"):
                                            self.exclude_list_name = value
                                            self.exclude_list_name.value_namespace = name_space
                                            self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "generation"):
                                            self.generation = value
                                            self.generation.value_namespace = name_space
                                            self.generation.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bandwidth-configured"):
                                            self.is_bandwidth_configured = value
                                            self.is_bandwidth_configured.value_namespace = name_space
                                            self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bfd-reverse-pat-configured"):
                                            self.is_bfd_reverse_pat_configured = value
                                            self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                            self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-cost-limit-configured"):
                                            self.is_cost_limit_configured = value
                                            self.is_cost_limit_configured.value_namespace = name_space
                                            self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-exclude-list-name-configured"):
                                            self.is_exclude_list_name_configured = value
                                            self.is_exclude_list_name_configured.value_namespace = name_space
                                            self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-action-configured"):
                                            self.is_path_invalidation_action_configured = value
                                            self.is_path_invalidation_action_configured.value_namespace = name_space
                                            self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-timeout-configured"):
                                            self.is_path_invalidation_timeout_configured = value
                                            self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                            self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-configured"):
                                            self.is_pce_configured = value
                                            self.is_pce_configured.value_namespace = name_space
                                            self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-group-id-configured"):
                                            self.is_pce_disj_group_id_configured = value
                                            self.is_pce_disj_group_id_configured.value_namespace = name_space
                                            self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-source-configured"):
                                            self.is_pce_disj_source_configured = value
                                            self.is_pce_disj_source_configured.value_namespace = name_space
                                            self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-type-configured"):
                                            self.is_pce_disj_type_configured = value
                                            self.is_pce_disj_type_configured.value_namespace = name_space
                                            self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pceb-dj-source-configured"):
                                            self.is_pceb_dj_source_configured = value
                                            self.is_pceb_dj_source_configured.value_namespace = name_space
                                            self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pcebd-group-id-configured"):
                                            self.is_pcebd_group_id_configured = value
                                            self.is_pcebd_group_id_configured.value_namespace = name_space
                                            self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-invalidation-action"):
                                            self.path_invalidation_action = value
                                            self.path_invalidation_action.value_namespace = name_space
                                            self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-invalidation-timeout"):
                                            self.path_invalidation_timeout = value
                                            self.path_invalidation_timeout.value_namespace = name_space
                                            self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-group-id"):
                                            self.pcebd_group_id = value
                                            self.pcebd_group_id.value_namespace = name_space
                                            self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-source-address"):
                                            self.pcebd_source_address = value
                                            self.pcebd_source_address.value_namespace = name_space
                                            self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-group-id"):
                                            self.pcedp_group_id = value
                                            self.pcedp_group_id.value_namespace = name_space
                                            self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-source-address"):
                                            self.pcedp_source_address = value
                                            self.pcedp_source_address.value_namespace = name_space
                                            self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-type"):
                                            self.pcedp_type = value
                                            self.pcedp_type.value_namespace = name_space
                                            self.pcedp_type.value_namespace_prefix = name_space_prefix


                                class AttributeSetAutobackup(Entity):
                                    """
                                    MPLS TE Auto\-backup Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_signalled_name_configured
                                    
                                    	Is signalled name configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                    
                                    .. attribute:: protected_interface
                                    
                                    	Array of Protected Interface Names
                                    	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\:  bool
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: signalled_name
                                    
                                    	Signalled name
                                    	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                        self.yang_name = "attribute-set-autobackup"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                        self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                        self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                        self.policy_class = YLeaf(YType.uint8, "policy-class")

                                        self.record_route = YLeaf(YType.boolean, "record-route")

                                        self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                        self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"
                                        self._children_yang_names.add("logging")

                                        self.signalled_name = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                        self.signalled_name.parent = self
                                        self._children_name_map["signalled_name"] = "signalled-name"
                                        self._children_yang_names.add("signalled-name")

                                        self.policy_class_entry = YList(self)
                                        self.protected_interface = YList(self)
                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("hold_priority",
                                                        "is_affinity_configured",
                                                        "is_policyclass_configured",
                                                        "is_priority_configured",
                                                        "is_signalled_name_configured",
                                                        "policy_class",
                                                        "record_route",
                                                        "setup_priority") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                                    class SignalledName(Entity):
                                        """
                                        Signalled name
                                        
                                        .. attribute:: is_mp_addresses
                                        
                                        	MP address appended
                                        	**type**\:  bool
                                        
                                        .. attribute:: name
                                        
                                        	Signalled name
                                        	**type**\:  str
                                        
                                        .. attribute:: protected_interface_type
                                        
                                        	Protected interface address or name
                                        	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        .. attribute:: source_type
                                        
                                        	Source address or name
                                        	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                            self.yang_name = "signalled-name"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                            self.name = YLeaf(YType.str, "name")

                                            self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                            self.source_type = YLeaf(YType.enumeration, "source-type")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_mp_addresses",
                                                            "name",
                                                            "protected_interface_type",
                                                            "source_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.is_mp_addresses.is_set or
                                                self.name.is_set or
                                                self.protected_interface_type.is_set or
                                                self.source_type.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_mp_addresses.yfilter != YFilter.not_set or
                                                self.name.yfilter != YFilter.not_set or
                                                self.protected_interface_type.yfilter != YFilter.not_set or
                                                self.source_type.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "signalled-name" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                            if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.name.get_name_leafdata())
                                            if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                            if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.source_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-mp-addresses"):
                                                self.is_mp_addresses = value
                                                self.is_mp_addresses.value_namespace = name_space
                                                self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                            if(value_path == "name"):
                                                self.name = value
                                                self.name.value_namespace = name_space
                                                self.name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protected-interface-type"):
                                                self.protected_interface_type = value
                                                self.protected_interface_type.value_namespace = name_space
                                                self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "source-type"):
                                                self.source_type = value
                                                self.source_type.value_namespace = name_space
                                                self.source_type.value_namespace_prefix = name_space_prefix


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class Logging(Entity):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                            self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                            self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                            self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                            self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                            self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                            self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                            self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("all_logging_enabled",
                                                            "lsp_bandwidth_change",
                                                            "lsp_insufficient_bw",
                                                            "lsp_pcalc_failure_logging_enabled",
                                                            "lsp_re_opt",
                                                            "lsp_re_route",
                                                            "lsp_state",
                                                            "s2l_state") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.all_logging_enabled.is_set or
                                                self.lsp_bandwidth_change.is_set or
                                                self.lsp_insufficient_bw.is_set or
                                                self.lsp_pcalc_failure_logging_enabled.is_set or
                                                self.lsp_re_opt.is_set or
                                                self.lsp_re_route.is_set or
                                                self.lsp_state.is_set or
                                                self.s2l_state.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.all_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_re_opt.yfilter != YFilter.not_set or
                                                self.lsp_re_route.yfilter != YFilter.not_set or
                                                self.lsp_state.yfilter != YFilter.not_set or
                                                self.s2l_state.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "logging" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                            if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                            if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                            if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                            if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                            if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                            if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                            if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "all-logging-enabled"):
                                                self.all_logging_enabled = value
                                                self.all_logging_enabled.value_namespace = name_space
                                                self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-bandwidth-change"):
                                                self.lsp_bandwidth_change = value
                                                self.lsp_bandwidth_change.value_namespace = name_space
                                                self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-insufficient-bw"):
                                                self.lsp_insufficient_bw = value
                                                self.lsp_insufficient_bw.value_namespace = name_space
                                                self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                self.lsp_pcalc_failure_logging_enabled = value
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-opt"):
                                                self.lsp_re_opt = value
                                                self.lsp_re_opt.value_namespace = name_space
                                                self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-route"):
                                                self.lsp_re_route = value
                                                self.lsp_re_route.value_namespace = name_space
                                                self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-state"):
                                                self.lsp_state = value
                                                self.lsp_state.value_namespace = name_space
                                                self.lsp_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "s2l-state"):
                                                self.s2l_state = value
                                                self.s2l_state.value_namespace = name_space
                                                self.s2l_state.value_namespace_prefix = name_space_prefix


                                    class PolicyClassEntry(Entity):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "policy-class-entry" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class ProtectedInterface(Entity):
                                        """
                                        Array of Protected Interface Names
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Protected Interface Name
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                            self.yang_name = "protected-interface"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.protected_interface = YLeaf(YType.str, "protected-interface")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("protected_interface") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.protected_interface.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.protected_interface.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "protected-interface" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "protected-interface"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "protected-interface"):
                                                self.protected_interface = value
                                                self.protected_interface.value_namespace = name_space
                                                self.protected_interface.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.policy_class_entry:
                                            if (c.has_data()):
                                                return True
                                        for c in self.protected_interface:
                                            if (c.has_data()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.hold_priority.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_policyclass_configured.is_set or
                                            self.is_priority_configured.is_set or
                                            self.is_signalled_name_configured.is_set or
                                            self.policy_class.is_set or
                                            self.record_route.is_set or
                                            self.setup_priority.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.logging is not None and self.logging.has_data()) or
                                            (self.signalled_name is not None and self.signalled_name.has_data()))

                                    def has_operation(self):
                                        for c in self.policy_class_entry:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.protected_interface:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.hold_priority.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_policyclass_configured.yfilter != YFilter.not_set or
                                            self.is_priority_configured.yfilter != YFilter.not_set or
                                            self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                            self.policy_class.yfilter != YFilter.not_set or
                                            self.record_route.yfilter != YFilter.not_set or
                                            self.setup_priority.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.logging is not None and self.logging.has_operation()) or
                                            (self.signalled_name is not None and self.signalled_name.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-autobackup" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                        if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                        if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                        if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.policy_class.get_name_leafdata())
                                        if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.record_route.get_name_leafdata())
                                        if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "logging"):
                                            if (self.logging is None):
                                                self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                                self.logging.parent = self
                                                self._children_name_map["logging"] = "logging"
                                            return self.logging

                                        if (child_yang_name == "policy-class-entry"):
                                            for c in self.policy_class_entry:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.policy_class_entry.append(c)
                                            return c

                                        if (child_yang_name == "protected-interface"):
                                            for c in self.protected_interface:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.protected_interface.append(c)
                                            return c

                                        if (child_yang_name == "signalled-name"):
                                            if (self.signalled_name is None):
                                                self.signalled_name = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                                self.signalled_name.parent = self
                                                self._children_name_map["signalled_name"] = "signalled-name"
                                            return self.signalled_name

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "hold-priority"):
                                            self.hold_priority = value
                                            self.hold_priority.value_namespace = name_space
                                            self.hold_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-policyclass-configured"):
                                            self.is_policyclass_configured = value
                                            self.is_policyclass_configured.value_namespace = name_space
                                            self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-priority-configured"):
                                            self.is_priority_configured = value
                                            self.is_priority_configured.value_namespace = name_space
                                            self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-signalled-name-configured"):
                                            self.is_signalled_name_configured = value
                                            self.is_signalled_name_configured.value_namespace = name_space
                                            self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "policy-class"):
                                            self.policy_class = value
                                            self.policy_class.value_namespace = name_space
                                            self.policy_class.value_namespace_prefix = name_space_prefix
                                        if(value_path == "record-route"):
                                            self.record_route = value
                                            self.record_route.value_namespace = name_space
                                            self.record_route.value_namespace_prefix = name_space_prefix
                                        if(value_path == "setup-priority"):
                                            self.setup_priority = value
                                            self.setup_priority.value_namespace = name_space
                                            self.setup_priority.value_namespace_prefix = name_space_prefix


                                class AttributeSetAutomesh(Entity):
                                    """
                                    MPLS TE Auto\-mesh Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                    
                                    .. attribute:: auto_bandwidth_collect
                                    
                                    	Auto bandwidth collect only
                                    	**type**\:  bool
                                    
                                    .. attribute:: auto_route_announce
                                    
                                    	Announce auto route to IGP
                                    	**type**\:  bool
                                    
                                    .. attribute:: bandwidth
                                    
                                    	IM bandwidth
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\:  bool
                                    
                                    .. attribute:: forward_class
                                    
                                    	Forward class
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\:  bool
                                    
                                    .. attribute:: frr_node_protection
                                    
                                    	FRR Node protection
                                    	**type**\:  bool
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_interface_bw_configured
                                    
                                    	Is Interface BW configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: load_share
                                    
                                    	Load Share
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                    
                                    .. attribute:: mesh_group_id
                                    
                                    	Meshgroup ID
                                    	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\:  bool
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: soft_preemption_configured
                                    
                                    	Soft preemption is configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                        self.yang_name = "attribute-set-automesh"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                        self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                        self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                        self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                        self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                        self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                        self.forward_class = YLeaf(YType.uint32, "forward-class")

                                        self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                        self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                        self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                        self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                        self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                        self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                        self.load_share = YLeaf(YType.uint32, "load-share")

                                        self.policy_class = YLeaf(YType.uint8, "policy-class")

                                        self.record_route = YLeaf(YType.boolean, "record-route")

                                        self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                        self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                        self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"
                                        self._children_yang_names.add("logging")

                                        self.mesh_group_id = YList(self)
                                        self.policy_class_entry = YList(self)
                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("auto_bandwidth_collect",
                                                        "auto_route_announce",
                                                        "bandwidth",
                                                        "configured_bandwidth",
                                                        "dste_class_type",
                                                        "fast_reroute",
                                                        "forward_class",
                                                        "frr_bandwidth_protection",
                                                        "frr_node_protection",
                                                        "hold_priority",
                                                        "is_affinity_configured",
                                                        "is_bandwidth_configured",
                                                        "is_interface_bw_configured",
                                                        "is_policyclass_configured",
                                                        "is_priority_configured",
                                                        "load_share",
                                                        "policy_class",
                                                        "record_route",
                                                        "setup_priority",
                                                        "soft_preemption_configured") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class Logging(Entity):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                            self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                            self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                            self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                            self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                            self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                            self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                            self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("all_logging_enabled",
                                                            "lsp_bandwidth_change",
                                                            "lsp_insufficient_bw",
                                                            "lsp_pcalc_failure_logging_enabled",
                                                            "lsp_re_opt",
                                                            "lsp_re_route",
                                                            "lsp_state",
                                                            "s2l_state") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.all_logging_enabled.is_set or
                                                self.lsp_bandwidth_change.is_set or
                                                self.lsp_insufficient_bw.is_set or
                                                self.lsp_pcalc_failure_logging_enabled.is_set or
                                                self.lsp_re_opt.is_set or
                                                self.lsp_re_route.is_set or
                                                self.lsp_state.is_set or
                                                self.s2l_state.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.all_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_re_opt.yfilter != YFilter.not_set or
                                                self.lsp_re_route.yfilter != YFilter.not_set or
                                                self.lsp_state.yfilter != YFilter.not_set or
                                                self.s2l_state.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "logging" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                            if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                            if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                            if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                            if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                            if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                            if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                            if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "all-logging-enabled"):
                                                self.all_logging_enabled = value
                                                self.all_logging_enabled.value_namespace = name_space
                                                self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-bandwidth-change"):
                                                self.lsp_bandwidth_change = value
                                                self.lsp_bandwidth_change.value_namespace = name_space
                                                self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-insufficient-bw"):
                                                self.lsp_insufficient_bw = value
                                                self.lsp_insufficient_bw.value_namespace = name_space
                                                self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                self.lsp_pcalc_failure_logging_enabled = value
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-opt"):
                                                self.lsp_re_opt = value
                                                self.lsp_re_opt.value_namespace = name_space
                                                self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-route"):
                                                self.lsp_re_route = value
                                                self.lsp_re_route.value_namespace = name_space
                                                self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-state"):
                                                self.lsp_state = value
                                                self.lsp_state.value_namespace = name_space
                                                self.lsp_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "s2l-state"):
                                                self.s2l_state = value
                                                self.s2l_state.value_namespace = name_space
                                                self.s2l_state.value_namespace_prefix = name_space_prefix


                                    class PolicyClassEntry(Entity):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "policy-class-entry" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class MeshGroupId(Entity):
                                        """
                                        Meshgroup ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                            self.yang_name = "mesh-group-id"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.entry = YLeaf(YType.uint32, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "mesh-group-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.mesh_group_id:
                                            if (c.has_data()):
                                                return True
                                        for c in self.policy_class_entry:
                                            if (c.has_data()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.auto_bandwidth_collect.is_set or
                                            self.auto_route_announce.is_set or
                                            self.bandwidth.is_set or
                                            self.configured_bandwidth.is_set or
                                            self.dste_class_type.is_set or
                                            self.fast_reroute.is_set or
                                            self.forward_class.is_set or
                                            self.frr_bandwidth_protection.is_set or
                                            self.frr_node_protection.is_set or
                                            self.hold_priority.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_bandwidth_configured.is_set or
                                            self.is_interface_bw_configured.is_set or
                                            self.is_policyclass_configured.is_set or
                                            self.is_priority_configured.is_set or
                                            self.load_share.is_set or
                                            self.policy_class.is_set or
                                            self.record_route.is_set or
                                            self.setup_priority.is_set or
                                            self.soft_preemption_configured.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.logging is not None and self.logging.has_data()))

                                    def has_operation(self):
                                        for c in self.mesh_group_id:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.policy_class_entry:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                            self.auto_route_announce.yfilter != YFilter.not_set or
                                            self.bandwidth.yfilter != YFilter.not_set or
                                            self.configured_bandwidth.yfilter != YFilter.not_set or
                                            self.dste_class_type.yfilter != YFilter.not_set or
                                            self.fast_reroute.yfilter != YFilter.not_set or
                                            self.forward_class.yfilter != YFilter.not_set or
                                            self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                            self.frr_node_protection.yfilter != YFilter.not_set or
                                            self.hold_priority.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                            self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                            self.is_policyclass_configured.yfilter != YFilter.not_set or
                                            self.is_priority_configured.yfilter != YFilter.not_set or
                                            self.load_share.yfilter != YFilter.not_set or
                                            self.policy_class.yfilter != YFilter.not_set or
                                            self.record_route.yfilter != YFilter.not_set or
                                            self.setup_priority.yfilter != YFilter.not_set or
                                            self.soft_preemption_configured.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.logging is not None and self.logging.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-automesh" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                        if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                        if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                        if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                        if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                        if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                        if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.forward_class.get_name_leafdata())
                                        if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                        if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                        if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                        if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                        if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                        if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                        if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.load_share.get_name_leafdata())
                                        if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.policy_class.get_name_leafdata())
                                        if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.record_route.get_name_leafdata())
                                        if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                        if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "logging"):
                                            if (self.logging is None):
                                                self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                                self.logging.parent = self
                                                self._children_name_map["logging"] = "logging"
                                            return self.logging

                                        if (child_yang_name == "mesh-group-id"):
                                            for c in self.mesh_group_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.mesh_group_id.append(c)
                                            return c

                                        if (child_yang_name == "policy-class-entry"):
                                            for c in self.policy_class_entry:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.policy_class_entry.append(c)
                                            return c

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "auto-bandwidth-collect"):
                                            self.auto_bandwidth_collect = value
                                            self.auto_bandwidth_collect.value_namespace = name_space
                                            self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                        if(value_path == "auto-route-announce"):
                                            self.auto_route_announce = value
                                            self.auto_route_announce.value_namespace = name_space
                                            self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                        if(value_path == "bandwidth"):
                                            self.bandwidth = value
                                            self.bandwidth.value_namespace = name_space
                                            self.bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "configured-bandwidth"):
                                            self.configured_bandwidth = value
                                            self.configured_bandwidth.value_namespace = name_space
                                            self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dste-class-type"):
                                            self.dste_class_type = value
                                            self.dste_class_type.value_namespace = name_space
                                            self.dste_class_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "fast-reroute"):
                                            self.fast_reroute = value
                                            self.fast_reroute.value_namespace = name_space
                                            self.fast_reroute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "forward-class"):
                                            self.forward_class = value
                                            self.forward_class.value_namespace = name_space
                                            self.forward_class.value_namespace_prefix = name_space_prefix
                                        if(value_path == "frr-bandwidth-protection"):
                                            self.frr_bandwidth_protection = value
                                            self.frr_bandwidth_protection.value_namespace = name_space
                                            self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "frr-node-protection"):
                                            self.frr_node_protection = value
                                            self.frr_node_protection.value_namespace = name_space
                                            self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "hold-priority"):
                                            self.hold_priority = value
                                            self.hold_priority.value_namespace = name_space
                                            self.hold_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bandwidth-configured"):
                                            self.is_bandwidth_configured = value
                                            self.is_bandwidth_configured.value_namespace = name_space
                                            self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-interface-bw-configured"):
                                            self.is_interface_bw_configured = value
                                            self.is_interface_bw_configured.value_namespace = name_space
                                            self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-policyclass-configured"):
                                            self.is_policyclass_configured = value
                                            self.is_policyclass_configured.value_namespace = name_space
                                            self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-priority-configured"):
                                            self.is_priority_configured = value
                                            self.is_priority_configured.value_namespace = name_space
                                            self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "load-share"):
                                            self.load_share = value
                                            self.load_share.value_namespace = name_space
                                            self.load_share.value_namespace_prefix = name_space_prefix
                                        if(value_path == "policy-class"):
                                            self.policy_class = value
                                            self.policy_class.value_namespace = name_space
                                            self.policy_class.value_namespace_prefix = name_space_prefix
                                        if(value_path == "record-route"):
                                            self.record_route = value
                                            self.record_route.value_namespace = name_space
                                            self.record_route.value_namespace_prefix = name_space_prefix
                                        if(value_path == "setup-priority"):
                                            self.setup_priority = value
                                            self.setup_priority.value_namespace = name_space
                                            self.setup_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "soft-preemption-configured"):
                                            self.soft_preemption_configured = value
                                            self.soft_preemption_configured.value_namespace = name_space
                                            self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                                class AttributeSetXro(Entity):
                                    """
                                    Attribute Set XRO
                                    
                                    .. attribute:: xro
                                    
                                    	The XRO specified by this attribute\-set
                                    	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                        self.yang_name = "attribute-set-xro"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                        self.xro.parent = self
                                        self._children_name_map["xro"] = "xro"
                                        self._children_yang_names.add("xro")


                                    class Xro(Entity):
                                        """
                                        The XRO specified by this attribute\-set
                                        
                                        .. attribute:: mutual_diversity_flag
                                        
                                        	Mutual Diversity Flag
                                        	**type**\:  bool
                                        
                                        .. attribute:: xro_subobject
                                        
                                        	List of XRO sub\-objects
                                        	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                            self.yang_name = "xro"
                                            self.yang_parent_name = "attribute-set-xro"

                                            self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                            self.xro_subobject = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("mutual_diversity_flag") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                        class XroSubobject(Entity):
                                            """
                                            List of XRO sub\-objects
                                            
                                            .. attribute:: as_subobject
                                            
                                            	AS sub\-object
                                            	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                            
                                            .. attribute:: ipv4_subobject
                                            
                                            	IPv4 sub\-object
                                            	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                            
                                            .. attribute:: ipv6_subobject
                                            
                                            	IPv6 sub\-object
                                            	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                            
                                            .. attribute:: lsp_subobject
                                            
                                            	P2P LSP sub\-object
                                            	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                            
                                            .. attribute:: srlg_subobject
                                            
                                            	SRLG sub\-object
                                            	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                            
                                            .. attribute:: type
                                            
                                            	Type
                                            	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                            
                                            .. attribute:: unnumbered_subobject
                                            
                                            	Unnumbered sub\-object
                                            	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                self.yang_name = "xro-subobject"
                                                self.yang_parent_name = "xro"

                                                self.type = YLeaf(YType.enumeration, "type")

                                                self.as_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                self.as_subobject.parent = self
                                                self._children_name_map["as_subobject"] = "as-subobject"
                                                self._children_yang_names.add("as-subobject")

                                                self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                self.ipv4_subobject.parent = self
                                                self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                self._children_yang_names.add("ipv4-subobject")

                                                self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                self.ipv6_subobject.parent = self
                                                self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                self._children_yang_names.add("ipv6-subobject")

                                                self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                self.lsp_subobject.parent = self
                                                self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                self._children_yang_names.add("lsp-subobject")

                                                self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                self.srlg_subobject.parent = self
                                                self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                self._children_yang_names.add("srlg-subobject")

                                                self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                self.unnumbered_subobject.parent = self
                                                self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                self._children_yang_names.add("unnumbered-subobject")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                            class Ipv4Subobject(Entity):
                                                """
                                                IPv4 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv4 address
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                    self.yang_name = "ipv4-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.address = YLeaf(YType.str, "address")

                                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("address",
                                                                    "attribute",
                                                                    "exclusion_type",
                                                                    "prefix_len") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.address.is_set or
                                                        self.attribute.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.prefix_len.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.address.yfilter != YFilter.not_set or
                                                        self.attribute.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.prefix_len.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "ipv4-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.address.get_name_leafdata())
                                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "address"):
                                                        self.address = value
                                                        self.address.value_namespace = name_space
                                                        self.address.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "attribute"):
                                                        self.attribute = value
                                                        self.attribute.value_namespace = name_space
                                                        self.attribute.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "prefix-len"):
                                                        self.prefix_len = value
                                                        self.prefix_len.value_namespace = name_space
                                                        self.prefix_len.value_namespace_prefix = name_space_prefix


                                            class Ipv6Subobject(Entity):
                                                """
                                                IPv6 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv6 address
                                                	**type**\:  str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                    self.yang_name = "ipv6-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.address = YLeaf(YType.str, "address")

                                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("address",
                                                                    "attribute",
                                                                    "exclusion_type",
                                                                    "prefix_len") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.address.is_set or
                                                        self.attribute.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.prefix_len.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.address.yfilter != YFilter.not_set or
                                                        self.attribute.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.prefix_len.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "ipv6-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.address.get_name_leafdata())
                                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "address"):
                                                        self.address = value
                                                        self.address.value_namespace = name_space
                                                        self.address.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "attribute"):
                                                        self.attribute = value
                                                        self.attribute.value_namespace = name_space
                                                        self.attribute.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "prefix-len"):
                                                        self.prefix_len = value
                                                        self.prefix_len.value_namespace = name_space
                                                        self.prefix_len.value_namespace_prefix = name_space_prefix


                                            class UnnumberedSubobject(Entity):
                                                """
                                                Unnumbered sub\-object
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: interface_id
                                                
                                                	Interface ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: te_router_id
                                                
                                                	TE router\-id
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                    self.yang_name = "unnumbered-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                                    self.te_router_id = YLeaf(YType.str, "te-router-id")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("attribute",
                                                                    "exclusion_type",
                                                                    "interface_id",
                                                                    "te_router_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.attribute.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.interface_id.is_set or
                                                        self.te_router_id.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.attribute.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.interface_id.yfilter != YFilter.not_set or
                                                        self.te_router_id.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "unnumbered-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.interface_id.get_name_leafdata())
                                                    if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "attribute"):
                                                        self.attribute = value
                                                        self.attribute.value_namespace = name_space
                                                        self.attribute.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "interface-id"):
                                                        self.interface_id = value
                                                        self.interface_id.value_namespace = name_space
                                                        self.interface_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "te-router-id"):
                                                        self.te_router_id = value
                                                        self.te_router_id.value_namespace = name_space
                                                        self.te_router_id.value_namespace_prefix = name_space_prefix


                                            class AsSubobject(Entity):
                                                """
                                                AS sub\-object
                                                
                                                .. attribute:: as_number
                                                
                                                	Autonomous System number
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                    self.yang_name = "as-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.as_number = YLeaf(YType.uint16, "as-number")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("as_number") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.as_number.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.as_number.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "as-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.as_number.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "as-number"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "as-number"):
                                                        self.as_number = value
                                                        self.as_number.value_namespace = name_space
                                                        self.as_number.value_namespace_prefix = name_space_prefix


                                            class SrlgSubobject(Entity):
                                                """
                                                SRLG sub\-object
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: srlg_id
                                                
                                                	SRLG ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                    self.yang_name = "srlg-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("exclusion_type",
                                                                    "srlg_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.exclusion_type.is_set or
                                                        self.srlg_id.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.srlg_id.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "srlg-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "exclusion-type" or name == "srlg-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "srlg-id"):
                                                        self.srlg_id = value
                                                        self.srlg_id.value_namespace = name_space
                                                        self.srlg_id.value_namespace_prefix = name_space_prefix


                                            class LspSubobject(Entity):
                                                """
                                                P2P LSP sub\-object
                                                
                                                .. attribute:: destination_node_exception
                                                
                                                	Destination\-node exception flag
                                                	**type**\:  bool
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: fec
                                                
                                                	LSP FEC
                                                	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                
                                                .. attribute:: ignore_lsp_id
                                                
                                                	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                	**type**\:  bool
                                                
                                                .. attribute:: penultimate_node_exception
                                                
                                                	Penultimate\-node exception flag
                                                	**type**\:  bool
                                                
                                                .. attribute:: processing_node_exception
                                                
                                                	Processing\-node exception flag
                                                	**type**\:  bool
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                    self.yang_name = "lsp-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                                    self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                                    self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                                    self.fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                    self.fec.parent = self
                                                    self._children_name_map["fec"] = "fec"
                                                    self._children_yang_names.add("fec")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("destination_node_exception",
                                                                    "exclusion_type",
                                                                    "ignore_lsp_id",
                                                                    "penultimate_node_exception",
                                                                    "processing_node_exception") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                                class Fec(Entity):
                                                    """
                                                    LSP FEC
                                                    
                                                    .. attribute:: fec_destination_info
                                                    
                                                    	Destination or P2MP ID
                                                    	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                    
                                                    .. attribute:: fec_extended_tunnel_id
                                                    
                                                    	Extended tunnel ID
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: fec_lsp_id
                                                    
                                                    	LSP ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: fec_source
                                                    
                                                    	Tunnel source address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: fec_tunnel_id
                                                    
                                                    	Tunnel ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: fec_vrf
                                                    
                                                    	VRF; currently only for GMPLS tunnels
                                                    	**type**\:  str
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                        self.yang_name = "fec"
                                                        self.yang_parent_name = "lsp-subobject"

                                                        self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                        self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                        self.fec_source = YLeaf(YType.str, "fec-source")

                                                        self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                        self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                        self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                        self.fec_destination_info.parent = self
                                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                        self._children_yang_names.add("fec-destination-info")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("fec_extended_tunnel_id",
                                                                        "fec_lsp_id",
                                                                        "fec_source",
                                                                        "fec_tunnel_id",
                                                                        "fec_vrf") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                                    class FecDestinationInfo(Entity):
                                                        """
                                                        Destination or P2MP ID
                                                        
                                                        .. attribute:: fec_ctype
                                                        
                                                        	FEC CType
                                                        	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                        
                                                        .. attribute:: fec_destination_p2mp_id
                                                        
                                                        	P2MP ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: p2p_lsp_destination
                                                        
                                                        	P2P LSP destination
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                            self.yang_name = "fec-destination-info"
                                                            self.yang_parent_name = "fec"

                                                            self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                            self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                            self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("fec_ctype",
                                                                            "fec_destination_p2mp_id",
                                                                            "p2p_lsp_destination") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.fec_ctype.is_set or
                                                                self.fec_destination_p2mp_id.is_set or
                                                                self.p2p_lsp_destination.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.fec_ctype.yfilter != YFilter.not_set or
                                                                self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                                self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "fec-destination-info" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                            if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                            if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "fec-ctype"):
                                                                self.fec_ctype = value
                                                                self.fec_ctype.value_namespace = name_space
                                                                self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-destination-p2mp-id"):
                                                                self.fec_destination_p2mp_id = value
                                                                self.fec_destination_p2mp_id.value_namespace = name_space
                                                                self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "p2p-lsp-destination"):
                                                                self.p2p_lsp_destination = value
                                                                self.p2p_lsp_destination.value_namespace = name_space
                                                                self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.fec_extended_tunnel_id.is_set or
                                                            self.fec_lsp_id.is_set or
                                                            self.fec_source.is_set or
                                                            self.fec_tunnel_id.is_set or
                                                            self.fec_vrf.is_set or
                                                            (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                            self.fec_lsp_id.yfilter != YFilter.not_set or
                                                            self.fec_source.yfilter != YFilter.not_set or
                                                            self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                            self.fec_vrf.yfilter != YFilter.not_set or
                                                            (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "fec" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                        if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                        if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                        if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                        if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "fec-destination-info"):
                                                            if (self.fec_destination_info is None):
                                                                self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                                self.fec_destination_info.parent = self
                                                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            return self.fec_destination_info

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "fec-extended-tunnel-id"):
                                                            self.fec_extended_tunnel_id = value
                                                            self.fec_extended_tunnel_id.value_namespace = name_space
                                                            self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-lsp-id"):
                                                            self.fec_lsp_id = value
                                                            self.fec_lsp_id.value_namespace = name_space
                                                            self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-source"):
                                                            self.fec_source = value
                                                            self.fec_source.value_namespace = name_space
                                                            self.fec_source.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-tunnel-id"):
                                                            self.fec_tunnel_id = value
                                                            self.fec_tunnel_id.value_namespace = name_space
                                                            self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-vrf"):
                                                            self.fec_vrf = value
                                                            self.fec_vrf.value_namespace = name_space
                                                            self.fec_vrf.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.destination_node_exception.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.ignore_lsp_id.is_set or
                                                        self.penultimate_node_exception.is_set or
                                                        self.processing_node_exception.is_set or
                                                        (self.fec is not None and self.fec.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.destination_node_exception.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                        self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                        self.processing_node_exception.yfilter != YFilter.not_set or
                                                        (self.fec is not None and self.fec.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsp-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                                    if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                                    if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "fec"):
                                                        if (self.fec is None):
                                                            self.fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                            self.fec.parent = self
                                                            self._children_name_map["fec"] = "fec"
                                                        return self.fec

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "destination-node-exception"):
                                                        self.destination_node_exception = value
                                                        self.destination_node_exception.value_namespace = name_space
                                                        self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ignore-lsp-id"):
                                                        self.ignore_lsp_id = value
                                                        self.ignore_lsp_id.value_namespace = name_space
                                                        self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "penultimate-node-exception"):
                                                        self.penultimate_node_exception = value
                                                        self.penultimate_node_exception.value_namespace = name_space
                                                        self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "processing-node-exception"):
                                                        self.processing_node_exception = value
                                                        self.processing_node_exception.value_namespace = name_space
                                                        self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.type.is_set or
                                                    (self.as_subobject is not None and self.as_subobject.has_data()) or
                                                    (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                                    (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                                    (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                                    (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                                    (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.type.yfilter != YFilter.not_set or
                                                    (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                                    (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                                    (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                                    (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                                    (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                                    (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "xro-subobject" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "as-subobject"):
                                                    if (self.as_subobject is None):
                                                        self.as_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                        self.as_subobject.parent = self
                                                        self._children_name_map["as_subobject"] = "as-subobject"
                                                    return self.as_subobject

                                                if (child_yang_name == "ipv4-subobject"):
                                                    if (self.ipv4_subobject is None):
                                                        self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                        self.ipv4_subobject.parent = self
                                                        self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                    return self.ipv4_subobject

                                                if (child_yang_name == "ipv6-subobject"):
                                                    if (self.ipv6_subobject is None):
                                                        self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                        self.ipv6_subobject.parent = self
                                                        self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                    return self.ipv6_subobject

                                                if (child_yang_name == "lsp-subobject"):
                                                    if (self.lsp_subobject is None):
                                                        self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                        self.lsp_subobject.parent = self
                                                        self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    return self.lsp_subobject

                                                if (child_yang_name == "srlg-subobject"):
                                                    if (self.srlg_subobject is None):
                                                        self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                        self.srlg_subobject.parent = self
                                                        self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                    return self.srlg_subobject

                                                if (child_yang_name == "unnumbered-subobject"):
                                                    if (self.unnumbered_subobject is None):
                                                        self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                        self.unnumbered_subobject.parent = self
                                                        self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                    return self.unnumbered_subobject

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "type"):
                                                    self.type = value
                                                    self.type.value_namespace = name_space
                                                    self.type.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.xro_subobject:
                                                if (c.has_data()):
                                                    return True
                                            return self.mutual_diversity_flag.is_set

                                        def has_operation(self):
                                            for c in self.xro_subobject:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "xro" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "xro-subobject"):
                                                for c in self.xro_subobject:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.xro_subobject.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "mutual-diversity-flag"):
                                                self.mutual_diversity_flag = value
                                                self.mutual_diversity_flag.value_namespace = name_space
                                                self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (self.xro is not None and self.xro.has_data())

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.xro is not None and self.xro.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-xro" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "xro"):
                                            if (self.xro is None):
                                                self.xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                                self.xro.parent = self
                                                self._children_name_map["xro"] = "xro"
                                            return self.xro

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "xro"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass


                                class AttributeSetP2Mpte(Entity):
                                    """
                                    MPLS TE P2MP\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\:  bool
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\:  bool
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                        self.yang_name = "attribute-set-p2mpte"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                        self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                        self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                        self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                        self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                        self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                        self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                        self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("configured_bandwidth",
                                                        "dste_class_type",
                                                        "fast_reroute",
                                                        "frr_bandwidth_protection",
                                                        "hold_priority",
                                                        "is_affinity_configured",
                                                        "is_bandwidth_configured",
                                                        "is_priority_configured",
                                                        "setup_priority") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2mpte"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2mpte"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.configured_bandwidth.is_set or
                                            self.dste_class_type.is_set or
                                            self.fast_reroute.is_set or
                                            self.frr_bandwidth_protection.is_set or
                                            self.hold_priority.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_bandwidth_configured.is_set or
                                            self.is_priority_configured.is_set or
                                            self.setup_priority.is_set or
                                            (self.affinity is not None and self.affinity.has_data()))

                                    def has_operation(self):
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.configured_bandwidth.yfilter != YFilter.not_set or
                                            self.dste_class_type.yfilter != YFilter.not_set or
                                            self.fast_reroute.yfilter != YFilter.not_set or
                                            self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                            self.hold_priority.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                            self.is_priority_configured.yfilter != YFilter.not_set or
                                            self.setup_priority.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-p2mpte" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                        if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                        if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                        if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                        if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                        if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                        if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "configured-bandwidth"):
                                            self.configured_bandwidth = value
                                            self.configured_bandwidth.value_namespace = name_space
                                            self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dste-class-type"):
                                            self.dste_class_type = value
                                            self.dste_class_type.value_namespace = name_space
                                            self.dste_class_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "fast-reroute"):
                                            self.fast_reroute = value
                                            self.fast_reroute.value_namespace = name_space
                                            self.fast_reroute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "frr-bandwidth-protection"):
                                            self.frr_bandwidth_protection = value
                                            self.frr_bandwidth_protection.value_namespace = name_space
                                            self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "hold-priority"):
                                            self.hold_priority = value
                                            self.hold_priority.value_namespace = name_space
                                            self.hold_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bandwidth-configured"):
                                            self.is_bandwidth_configured = value
                                            self.is_bandwidth_configured.value_namespace = name_space
                                            self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-priority-configured"):
                                            self.is_priority_configured = value
                                            self.is_priority_configured.value_namespace = name_space
                                            self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "setup-priority"):
                                            self.setup_priority = value
                                            self.setup_priority.value_namespace = name_space
                                            self.setup_priority.value_namespace_prefix = name_space_prefix


                                class AttributeSetApsPp(Entity):
                                    """
                                    Attribute Set OTN APS Path Protection
                                    
                                    .. attribute:: hold_off_time
                                    
                                    	Hold\-off time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path Protection Profile Type
                                    	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    .. attribute:: protection_mode
                                    
                                    	Protection Restoration Mode
                                    	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                    
                                    .. attribute:: protection_type
                                    
                                    	Protection Type
                                    	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    .. attribute:: restoration_style
                                    
                                    	Restoration Style
                                    	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                    
                                    .. attribute:: revert_schedule
                                    
                                    	Revert Schedule
                                    	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                    
                                    .. attribute:: snc_mode
                                    
                                    	Sub\-network Connection Mode
                                    	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    .. attribute:: tcm_id
                                    
                                    	Sub\-network Connection Monitoring Mode
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: wait_to_restore_time
                                    
                                    	Wait to restore time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                        self.yang_name = "attribute-set-aps-pp"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                        self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                        self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                        self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                        self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                        self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                        self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                        self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                        self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                        self.revert_schedule.parent = self
                                        self._children_name_map["revert_schedule"] = "revert-schedule"
                                        self._children_yang_names.add("revert-schedule")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("hold_off_time",
                                                        "path_prot_profile_type",
                                                        "protection_mode",
                                                        "protection_type",
                                                        "restoration_style",
                                                        "snc_mode",
                                                        "tcm_id",
                                                        "wait_to_restore_time") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                                    class RevertSchedule(Entity):
                                        """
                                        Revert Schedule
                                        
                                        .. attribute:: duration
                                        
                                        	Duration for scheduled reversion
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: max_tries
                                        
                                        	Max tries for scheduled reversion
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: schedule_date
                                        
                                        	Schedule time for reversion
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: schedule_frequency
                                        
                                        	Schedule frequency for reversion
                                        	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                        
                                        .. attribute:: schedulename
                                        
                                        	Schedule name identifier
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                            self.yang_name = "revert-schedule"
                                            self.yang_parent_name = "attribute-set-aps-pp"

                                            self.duration = YLeaf(YType.uint32, "duration")

                                            self.max_tries = YLeaf(YType.uint32, "max-tries")

                                            self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                            self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                            self.schedulename = YLeaf(YType.str, "schedulename")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("duration",
                                                            "max_tries",
                                                            "schedule_date",
                                                            "schedule_frequency",
                                                            "schedulename") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.duration.is_set or
                                                self.max_tries.is_set or
                                                self.schedule_date.is_set or
                                                self.schedule_frequency.is_set or
                                                self.schedulename.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.duration.yfilter != YFilter.not_set or
                                                self.max_tries.yfilter != YFilter.not_set or
                                                self.schedule_date.yfilter != YFilter.not_set or
                                                self.schedule_frequency.yfilter != YFilter.not_set or
                                                self.schedulename.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "revert-schedule" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.duration.get_name_leafdata())
                                            if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.max_tries.get_name_leafdata())
                                            if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                            if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                            if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.schedulename.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "duration"):
                                                self.duration = value
                                                self.duration.value_namespace = name_space
                                                self.duration.value_namespace_prefix = name_space_prefix
                                            if(value_path == "max-tries"):
                                                self.max_tries = value
                                                self.max_tries.value_namespace = name_space
                                                self.max_tries.value_namespace_prefix = name_space_prefix
                                            if(value_path == "schedule-date"):
                                                self.schedule_date = value
                                                self.schedule_date.value_namespace = name_space
                                                self.schedule_date.value_namespace_prefix = name_space_prefix
                                            if(value_path == "schedule-frequency"):
                                                self.schedule_frequency = value
                                                self.schedule_frequency.value_namespace = name_space
                                                self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                            if(value_path == "schedulename"):
                                                self.schedulename = value
                                                self.schedulename.value_namespace = name_space
                                                self.schedulename.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.hold_off_time.is_set or
                                            self.path_prot_profile_type.is_set or
                                            self.protection_mode.is_set or
                                            self.protection_type.is_set or
                                            self.restoration_style.is_set or
                                            self.snc_mode.is_set or
                                            self.tcm_id.is_set or
                                            self.wait_to_restore_time.is_set or
                                            (self.revert_schedule is not None and self.revert_schedule.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.hold_off_time.yfilter != YFilter.not_set or
                                            self.path_prot_profile_type.yfilter != YFilter.not_set or
                                            self.protection_mode.yfilter != YFilter.not_set or
                                            self.protection_type.yfilter != YFilter.not_set or
                                            self.restoration_style.yfilter != YFilter.not_set or
                                            self.snc_mode.yfilter != YFilter.not_set or
                                            self.tcm_id.yfilter != YFilter.not_set or
                                            self.wait_to_restore_time.yfilter != YFilter.not_set or
                                            (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-aps-pp" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                        if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                        if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                        if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.protection_type.get_name_leafdata())
                                        if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                        if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                        if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                        if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "revert-schedule"):
                                            if (self.revert_schedule is None):
                                                self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                                self.revert_schedule.parent = self
                                                self._children_name_map["revert_schedule"] = "revert-schedule"
                                            return self.revert_schedule

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "hold-off-time"):
                                            self.hold_off_time = value
                                            self.hold_off_time.value_namespace = name_space
                                            self.hold_off_time.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-prot-profile-type"):
                                            self.path_prot_profile_type = value
                                            self.path_prot_profile_type.value_namespace = name_space
                                            self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "protection-mode"):
                                            self.protection_mode = value
                                            self.protection_mode.value_namespace = name_space
                                            self.protection_mode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "protection-type"):
                                            self.protection_type = value
                                            self.protection_type.value_namespace = name_space
                                            self.protection_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "restoration-style"):
                                            self.restoration_style = value
                                            self.restoration_style.value_namespace = name_space
                                            self.restoration_style.value_namespace_prefix = name_space_prefix
                                        if(value_path == "snc-mode"):
                                            self.snc_mode = value
                                            self.snc_mode.value_namespace = name_space
                                            self.snc_mode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcm-id"):
                                            self.tcm_id = value
                                            self.tcm_id.value_namespace = name_space
                                            self.tcm_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "wait-to-restore-time"):
                                            self.wait_to_restore_time = value
                                            self.wait_to_restore_time.value_namespace = name_space
                                            self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                                class AttributeSetP2PTe(Entity):
                                    """
                                    MPLS TE P2P\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is Path Invalidation action configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is Path Invalidation timeout configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_select_configured
                                    
                                    	Is any of the path selection parameters configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_metric_configured
                                    
                                    	Is path selection metric configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                    
                                    	Is path selection segment routing configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_configured
                                    
                                    	Is path selection margin configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_relative
                                    
                                    	Path selection margin is\_relative
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                    
                                    	Is path selection segment limit configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_prepend_list_configured
                                    
                                    	Is SR prepend list configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation timeout on the tunnel path
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_selection_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                    
                                    .. attribute:: path_selection_metric
                                    
                                    	Path selection metric type
                                    	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                    
                                    .. attribute:: path_selection_segment_routing_adjacency_protection
                                    
                                    	Path selection segment\-routing type
                                    	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                                    
                                    .. attribute:: path_selection_segment_routing_margin
                                    
                                    	Path selection margin
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_selection_segment_routing_segment_limit
                                    
                                    	Is path selection segment limit configured
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    .. attribute:: prepend_list
                                    
                                    	SR prepend list
                                    	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                        self.yang_name = "attribute-set-p2p-te"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                        self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                        self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                        self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                        self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                        self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                        self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                        self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                        self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                        self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                        self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                        self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                        self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                        self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                        self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                        self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                        self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                        self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                        self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                        self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                        self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                        self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                        self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                        self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                        self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                        self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                        self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"
                                        self._children_yang_names.add("logging")

                                        self.prepend_list = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                        self.prepend_list.parent = self
                                        self._children_name_map["prepend_list"] = "prepend-list"
                                        self._children_yang_names.add("prepend-list")

                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_affinity_configured",
                                                        "is_path_invalidation_action_configured",
                                                        "is_path_invalidation_timeout_configured",
                                                        "is_path_select_configured",
                                                        "is_path_selection_metric_configured",
                                                        "is_path_selection_segment_routing_adjacency_protection_configured",
                                                        "is_path_selection_segment_routing_margin_configured",
                                                        "is_path_selection_segment_routing_margin_relative",
                                                        "is_path_selection_segment_routing_segment_limit_configured",
                                                        "is_pce_configured",
                                                        "is_pce_disj_group_id_configured",
                                                        "is_pce_disj_source_configured",
                                                        "is_pce_disj_type_configured",
                                                        "is_pceb_dj_source_configured",
                                                        "is_pcebd_group_id_configured",
                                                        "is_prepend_list_configured",
                                                        "path_invalidation_timeout",
                                                        "path_selection_invalidation_action",
                                                        "path_selection_metric",
                                                        "path_selection_segment_routing_adjacency_protection",
                                                        "path_selection_segment_routing_margin",
                                                        "path_selection_segment_routing_segment_limit",
                                                        "pcebd_group_id",
                                                        "pcebd_source_address",
                                                        "pcedp_group_id",
                                                        "pcedp_source_address",
                                                        "pcedp_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class Logging(Entity):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                            self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                            self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                            self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                            self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                            self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                            self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                            self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("all_logging_enabled",
                                                            "lsp_bandwidth_change",
                                                            "lsp_insufficient_bw",
                                                            "lsp_pcalc_failure_logging_enabled",
                                                            "lsp_re_opt",
                                                            "lsp_re_route",
                                                            "lsp_state",
                                                            "s2l_state") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.all_logging_enabled.is_set or
                                                self.lsp_bandwidth_change.is_set or
                                                self.lsp_insufficient_bw.is_set or
                                                self.lsp_pcalc_failure_logging_enabled.is_set or
                                                self.lsp_re_opt.is_set or
                                                self.lsp_re_route.is_set or
                                                self.lsp_state.is_set or
                                                self.s2l_state.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.all_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_re_opt.yfilter != YFilter.not_set or
                                                self.lsp_re_route.yfilter != YFilter.not_set or
                                                self.lsp_state.yfilter != YFilter.not_set or
                                                self.s2l_state.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "logging" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                            if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                            if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                            if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                            if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                            if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                            if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                            if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "all-logging-enabled"):
                                                self.all_logging_enabled = value
                                                self.all_logging_enabled.value_namespace = name_space
                                                self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-bandwidth-change"):
                                                self.lsp_bandwidth_change = value
                                                self.lsp_bandwidth_change.value_namespace = name_space
                                                self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-insufficient-bw"):
                                                self.lsp_insufficient_bw = value
                                                self.lsp_insufficient_bw.value_namespace = name_space
                                                self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                self.lsp_pcalc_failure_logging_enabled = value
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-opt"):
                                                self.lsp_re_opt = value
                                                self.lsp_re_opt.value_namespace = name_space
                                                self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-route"):
                                                self.lsp_re_route = value
                                                self.lsp_re_route.value_namespace = name_space
                                                self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-state"):
                                                self.lsp_state = value
                                                self.lsp_state.value_namespace = name_space
                                                self.lsp_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "s2l-state"):
                                                self.s2l_state = value
                                                self.s2l_state.value_namespace = name_space
                                                self.s2l_state.value_namespace_prefix = name_space_prefix


                                    class PrependList(Entity):
                                        """
                                        SR prepend list
                                        
                                        .. attribute:: prepend_entry
                                        
                                        	List of prepend entries
                                        	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                            self.yang_name = "prepend-list"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.prepend_entry = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in () and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                        class PrependEntry(Entity):
                                            """
                                            List of prepend entries
                                            
                                            .. attribute:: index
                                            
                                            	Prepend index
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: next_label
                                            
                                            	Prepend next label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: type
                                            
                                            	Prepend Type
                                            	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                                self.yang_name = "prepend-entry"
                                                self.yang_parent_name = "prepend-list"

                                                self.index = YLeaf(YType.uint32, "index")

                                                self.next_label = YLeaf(YType.uint32, "next-label")

                                                self.type = YLeaf(YType.enumeration, "type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("index",
                                                                "next_label",
                                                                "type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.index.is_set or
                                                    self.next_label.is_set or
                                                    self.type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.index.yfilter != YFilter.not_set or
                                                    self.next_label.yfilter != YFilter.not_set or
                                                    self.type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prepend-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.index.get_name_leafdata())
                                                if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.next_label.get_name_leafdata())
                                                if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "index" or name == "next-label" or name == "type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "index"):
                                                    self.index = value
                                                    self.index.value_namespace = name_space
                                                    self.index.value_namespace_prefix = name_space_prefix
                                                if(value_path == "next-label"):
                                                    self.next_label = value
                                                    self.next_label.value_namespace = name_space
                                                    self.next_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "type"):
                                                    self.type = value
                                                    self.type.value_namespace = name_space
                                                    self.type.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.prepend_entry:
                                                if (c.has_data()):
                                                    return True
                                            return False

                                        def has_operation(self):
                                            for c in self.prepend_entry:
                                                if (c.has_operation()):
                                                    return True
                                            return self.yfilter != YFilter.not_set

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "prepend-list" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "prepend-entry"):
                                                for c in self.prepend_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.prepend_entry.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "prepend-entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.is_affinity_configured.is_set or
                                            self.is_path_invalidation_action_configured.is_set or
                                            self.is_path_invalidation_timeout_configured.is_set or
                                            self.is_path_select_configured.is_set or
                                            self.is_path_selection_metric_configured.is_set or
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                            self.is_path_selection_segment_routing_margin_configured.is_set or
                                            self.is_path_selection_segment_routing_margin_relative.is_set or
                                            self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                            self.is_pce_configured.is_set or
                                            self.is_pce_disj_group_id_configured.is_set or
                                            self.is_pce_disj_source_configured.is_set or
                                            self.is_pce_disj_type_configured.is_set or
                                            self.is_pceb_dj_source_configured.is_set or
                                            self.is_pcebd_group_id_configured.is_set or
                                            self.is_prepend_list_configured.is_set or
                                            self.path_invalidation_timeout.is_set or
                                            self.path_selection_invalidation_action.is_set or
                                            self.path_selection_metric.is_set or
                                            self.path_selection_segment_routing_adjacency_protection.is_set or
                                            self.path_selection_segment_routing_margin.is_set or
                                            self.path_selection_segment_routing_segment_limit.is_set or
                                            self.pcebd_group_id.is_set or
                                            self.pcebd_source_address.is_set or
                                            self.pcedp_group_id.is_set or
                                            self.pcedp_source_address.is_set or
                                            self.pcedp_type.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.logging is not None and self.logging.has_data()) or
                                            (self.prepend_list is not None and self.prepend_list.has_data()))

                                    def has_operation(self):
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                            self.is_path_select_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                            self.is_pce_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                            self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                            self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                            self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                            self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                            self.path_selection_metric.yfilter != YFilter.not_set or
                                            self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                            self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                            self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                            self.pcebd_group_id.yfilter != YFilter.not_set or
                                            self.pcebd_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_group_id.yfilter != YFilter.not_set or
                                            self.pcedp_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_type.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.logging is not None and self.logging.has_operation()) or
                                            (self.prepend_list is not None and self.prepend_list.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-p2p-te" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                        if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                        if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                        if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                        if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                        if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                        if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                        if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                        if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                        if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                        if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                        if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                        if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                        if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                        if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                        if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                        if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                        if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                        if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                        if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                        if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "logging"):
                                            if (self.logging is None):
                                                self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                                self.logging.parent = self
                                                self._children_name_map["logging"] = "logging"
                                            return self.logging

                                        if (child_yang_name == "prepend-list"):
                                            if (self.prepend_list is None):
                                                self.prepend_list = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                                self.prepend_list.parent = self
                                                self._children_name_map["prepend_list"] = "prepend-list"
                                            return self.prepend_list

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-action-configured"):
                                            self.is_path_invalidation_action_configured = value
                                            self.is_path_invalidation_action_configured.value_namespace = name_space
                                            self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-timeout-configured"):
                                            self.is_path_invalidation_timeout_configured = value
                                            self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                            self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-select-configured"):
                                            self.is_path_select_configured = value
                                            self.is_path_select_configured.value_namespace = name_space
                                            self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-metric-configured"):
                                            self.is_path_selection_metric_configured = value
                                            self.is_path_selection_metric_configured.value_namespace = name_space
                                            self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                            self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                            self.is_path_selection_segment_routing_margin_configured = value
                                            self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                            self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                            self.is_path_selection_segment_routing_margin_relative = value
                                            self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                            self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                            self.is_path_selection_segment_routing_segment_limit_configured = value
                                            self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                            self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-configured"):
                                            self.is_pce_configured = value
                                            self.is_pce_configured.value_namespace = name_space
                                            self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-group-id-configured"):
                                            self.is_pce_disj_group_id_configured = value
                                            self.is_pce_disj_group_id_configured.value_namespace = name_space
                                            self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-source-configured"):
                                            self.is_pce_disj_source_configured = value
                                            self.is_pce_disj_source_configured.value_namespace = name_space
                                            self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-type-configured"):
                                            self.is_pce_disj_type_configured = value
                                            self.is_pce_disj_type_configured.value_namespace = name_space
                                            self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pceb-dj-source-configured"):
                                            self.is_pceb_dj_source_configured = value
                                            self.is_pceb_dj_source_configured.value_namespace = name_space
                                            self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pcebd-group-id-configured"):
                                            self.is_pcebd_group_id_configured = value
                                            self.is_pcebd_group_id_configured.value_namespace = name_space
                                            self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-prepend-list-configured"):
                                            self.is_prepend_list_configured = value
                                            self.is_prepend_list_configured.value_namespace = name_space
                                            self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-invalidation-timeout"):
                                            self.path_invalidation_timeout = value
                                            self.path_invalidation_timeout.value_namespace = name_space
                                            self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-invalidation-action"):
                                            self.path_selection_invalidation_action = value
                                            self.path_selection_invalidation_action.value_namespace = name_space
                                            self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-metric"):
                                            self.path_selection_metric = value
                                            self.path_selection_metric.value_namespace = name_space
                                            self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                            self.path_selection_segment_routing_adjacency_protection = value
                                            self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                            self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-segment-routing-margin"):
                                            self.path_selection_segment_routing_margin = value
                                            self.path_selection_segment_routing_margin.value_namespace = name_space
                                            self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-segment-routing-segment-limit"):
                                            self.path_selection_segment_routing_segment_limit = value
                                            self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                            self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-group-id"):
                                            self.pcebd_group_id = value
                                            self.pcebd_group_id.value_namespace = name_space
                                            self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-source-address"):
                                            self.pcebd_source_address = value
                                            self.pcebd_source_address.value_namespace = name_space
                                            self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-group-id"):
                                            self.pcedp_group_id = value
                                            self.pcedp_group_id.value_namespace = name_space
                                            self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-source-address"):
                                            self.pcedp_source_address = value
                                            self.pcedp_source_address.value_namespace = name_space
                                            self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-type"):
                                            self.pcedp_type = value
                                            self.pcedp_type.value_namespace = name_space
                                            self.pcedp_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.tunnel_attribute_set_type.is_set or
                                        (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                        (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                        (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                        (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                        (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                        (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                        (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                        (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                        (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                        (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                        (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                        (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                        (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                        (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "attribute-set-union" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "attribute-set-aps-pp"):
                                        if (self.attribute_set_aps_pp is None):
                                            self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                            self.attribute_set_aps_pp.parent = self
                                            self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                        return self.attribute_set_aps_pp

                                    if (child_yang_name == "attribute-set-autobackup"):
                                        if (self.attribute_set_autobackup is None):
                                            self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                            self.attribute_set_autobackup.parent = self
                                            self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                        return self.attribute_set_autobackup

                                    if (child_yang_name == "attribute-set-automesh"):
                                        if (self.attribute_set_automesh is None):
                                            self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                            self.attribute_set_automesh.parent = self
                                            self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                        return self.attribute_set_automesh

                                    if (child_yang_name == "attribute-set-p2mpte"):
                                        if (self.attribute_set_p2mpte is None):
                                            self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                            self.attribute_set_p2mpte.parent = self
                                            self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                        return self.attribute_set_p2mpte

                                    if (child_yang_name == "attribute-set-p2p-te"):
                                        if (self.attribute_set_p2p_te is None):
                                            self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                            self.attribute_set_p2p_te.parent = self
                                            self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        return self.attribute_set_p2p_te

                                    if (child_yang_name == "attribute-set-path-option"):
                                        if (self.attribute_set_path_option is None):
                                            self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                            self.attribute_set_path_option.parent = self
                                            self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                        return self.attribute_set_path_option

                                    if (child_yang_name == "attribute-set-xro"):
                                        if (self.attribute_set_xro is None):
                                            self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                            self.attribute_set_xro.parent = self
                                            self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                        return self.attribute_set_xro

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "tunnel-attribute-set-type"):
                                        self.tunnel_attribute_set_type = value
                                        self.tunnel_attribute_set_type.value_namespace = name_space
                                        self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.tunnel_attribute_set_name.is_set or
                                    self.tunnel_attribute_set_name_crc32.is_set or
                                    (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                                    self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                                    (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "xro-attribute-set" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                                if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "attribute-set-union"):
                                    if (self.attribute_set_union is None):
                                        self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet.AttributeSetUnion()
                                        self.attribute_set_union.parent = self
                                        self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    return self.attribute_set_union

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "tunnel-attribute-set-name"):
                                    self.tunnel_attribute_set_name = value
                                    self.tunnel_attribute_set_name.value_namespace = name_space
                                    self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-attribute-set-name-crc32"):
                                    self.tunnel_attribute_set_name_crc32 = value
                                    self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                                    self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                        class PathCalculationError(Entity):
                            """
                            Path computation information
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\:  str
                            
                            .. attribute:: log_time
                            
                            	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: lsp_mode
                            
                            	LSP Mode
                            	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.PathCalculationError, self).__init__()

                                self.yang_name = "path-calculation-error"
                                self.yang_parent_name = "path-option-entry"

                                self.error_message = YLeaf(YType.str, "error-message")

                                self.log_time = YLeaf(YType.uint32, "log-time")

                                self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("error_message",
                                                "log_time",
                                                "lsp_mode") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.PathCalculationError, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.PathCalculationError, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.error_message.is_set or
                                    self.log_time.is_set or
                                    self.lsp_mode.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.error_message.yfilter != YFilter.not_set or
                                    self.log_time.yfilter != YFilter.not_set or
                                    self.lsp_mode.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-calculation-error" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.error_message.get_name_leafdata())
                                if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.log_time.get_name_leafdata())
                                if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "error-message"):
                                    self.error_message = value
                                    self.error_message.value_namespace = name_space
                                    self.error_message.value_namespace_prefix = name_space_prefix
                                if(value_path == "log-time"):
                                    self.log_time = value
                                    self.log_time.value_namespace = name_space
                                    self.log_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-mode"):
                                    self.lsp_mode = value
                                    self.lsp_mode.value_namespace = name_space
                                    self.lsp_mode.value_namespace_prefix = name_space_prefix


                        class RemergeError(Entity):
                            """
                            Path computation remerge resolve info
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\:  str
                            
                            .. attribute:: log_time
                            
                            	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: lsp_mode
                            
                            	LSP Mode
                            	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.RemergeError, self).__init__()

                                self.yang_name = "remerge-error"
                                self.yang_parent_name = "path-option-entry"

                                self.error_message = YLeaf(YType.str, "error-message")

                                self.log_time = YLeaf(YType.uint32, "log-time")

                                self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("error_message",
                                                "log_time",
                                                "lsp_mode") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.RemergeError, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.RemergeError, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.error_message.is_set or
                                    self.log_time.is_set or
                                    self.lsp_mode.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.error_message.yfilter != YFilter.not_set or
                                    self.log_time.yfilter != YFilter.not_set or
                                    self.lsp_mode.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "remerge-error" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.error_message.get_name_leafdata())
                                if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.log_time.get_name_leafdata())
                                if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "error-message"):
                                    self.error_message = value
                                    self.error_message.value_namespace = name_space
                                    self.error_message.value_namespace_prefix = name_space_prefix
                                if(value_path == "log-time"):
                                    self.log_time = value
                                    self.log_time.value_namespace = name_space
                                    self.log_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-mode"):
                                    self.lsp_mode = value
                                    self.lsp_mode.value_namespace = name_space
                                    self.lsp_mode.value_namespace_prefix = name_space_prefix


                        class SignallingError(Entity):
                            """
                            Signalling information
                            
                            .. attribute:: error
                            
                            	Path Error code
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\:  str
                            
                            .. attribute:: error_node
                            
                            	Source address of the error generating node
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: log_time
                            
                            	Time in seconds when the error message is logged
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: lsp_mode
                            
                            	LSPMode
                            	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            .. attribute:: reverse_lsp
                            
                            	Indicates if error is on the reverse LSP
                            	**type**\:  bool
                            
                            .. attribute:: signalling_lsp_id
                            
                            	LSP\-id for which the error was received
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: sub_code
                            
                            	Path Error subcode
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.SignallingError, self).__init__()

                                self.yang_name = "signalling-error"
                                self.yang_parent_name = "path-option-entry"

                                self.error = YLeaf(YType.uint8, "error")

                                self.error_message = YLeaf(YType.str, "error-message")

                                self.error_node = YLeaf(YType.uint32, "error-node")

                                self.log_time = YLeaf(YType.uint32, "log-time")

                                self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                self.reverse_lsp = YLeaf(YType.boolean, "reverse-lsp")

                                self.signalling_lsp_id = YLeaf(YType.uint16, "signalling-lsp-id")

                                self.sub_code = YLeaf(YType.uint16, "sub-code")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("error",
                                                "error_message",
                                                "error_node",
                                                "log_time",
                                                "lsp_mode",
                                                "reverse_lsp",
                                                "signalling_lsp_id",
                                                "sub_code") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.SignallingError, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.SignallingError, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.error.is_set or
                                    self.error_message.is_set or
                                    self.error_node.is_set or
                                    self.log_time.is_set or
                                    self.lsp_mode.is_set or
                                    self.reverse_lsp.is_set or
                                    self.signalling_lsp_id.is_set or
                                    self.sub_code.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.error.yfilter != YFilter.not_set or
                                    self.error_message.yfilter != YFilter.not_set or
                                    self.error_node.yfilter != YFilter.not_set or
                                    self.log_time.yfilter != YFilter.not_set or
                                    self.lsp_mode.yfilter != YFilter.not_set or
                                    self.reverse_lsp.yfilter != YFilter.not_set or
                                    self.signalling_lsp_id.yfilter != YFilter.not_set or
                                    self.sub_code.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "signalling-error" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.error.is_set or self.error.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.error.get_name_leafdata())
                                if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.error_message.get_name_leafdata())
                                if (self.error_node.is_set or self.error_node.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.error_node.get_name_leafdata())
                                if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.log_time.get_name_leafdata())
                                if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_mode.get_name_leafdata())
                                if (self.reverse_lsp.is_set or self.reverse_lsp.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reverse_lsp.get_name_leafdata())
                                if (self.signalling_lsp_id.is_set or self.signalling_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.signalling_lsp_id.get_name_leafdata())
                                if (self.sub_code.is_set or self.sub_code.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.sub_code.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "error" or name == "error-message" or name == "error-node" or name == "log-time" or name == "lsp-mode" or name == "reverse-lsp" or name == "signalling-lsp-id" or name == "sub-code"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "error"):
                                    self.error = value
                                    self.error.value_namespace = name_space
                                    self.error.value_namespace_prefix = name_space_prefix
                                if(value_path == "error-message"):
                                    self.error_message = value
                                    self.error_message.value_namespace = name_space
                                    self.error_message.value_namespace_prefix = name_space_prefix
                                if(value_path == "error-node"):
                                    self.error_node = value
                                    self.error_node.value_namespace = name_space
                                    self.error_node.value_namespace_prefix = name_space_prefix
                                if(value_path == "log-time"):
                                    self.log_time = value
                                    self.log_time.value_namespace = name_space
                                    self.log_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-mode"):
                                    self.lsp_mode = value
                                    self.lsp_mode.value_namespace = name_space
                                    self.lsp_mode.value_namespace_prefix = name_space_prefix
                                if(value_path == "reverse-lsp"):
                                    self.reverse_lsp = value
                                    self.reverse_lsp.value_namespace = name_space
                                    self.reverse_lsp.value_namespace_prefix = name_space_prefix
                                if(value_path == "signalling-lsp-id"):
                                    self.signalling_lsp_id = value
                                    self.signalling_lsp_id.value_namespace = name_space
                                    self.signalling_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "sub-code"):
                                    self.sub_code = value
                                    self.sub_code.value_namespace = name_space
                                    self.sub_code.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.path_calculation_error:
                                if (c.has_data()):
                                    return True
                            for c in self.remerge_error:
                                if (c.has_data()):
                                    return True
                            for c in self.signalling_error:
                                if (c.has_data()):
                                    return True
                            return (
                                self.attribute_set_found.is_set or
                                self.explicit_path_id.is_set or
                                self.explicit_path_name.is_set or
                                self.has_attribute_set.is_set or
                                self.has_xro_attribute_set.is_set or
                                self.holddown_duration.is_set or
                                self.is_disabled.is_set or
                                self.is_helddown.is_set or
                                self.is_lockdown.is_set or
                                self.is_segment_routing.is_set or
                                self.is_strict_explicit_path.is_set or
                                self.is_verbatim.is_set or
                                self.option_index.is_set or
                                self.option_index_is_valid.is_set or
                                self.path_option_area_id.is_set or
                                self.path_option_name.is_set or
                                self.path_option_type.is_set or
                                self.pce_address.is_set or
                                self.protected_by_path_option_index.is_set or
                                self.restored_from_path_option_index.is_set or
                                self.xro_attribute_set_found.is_set or
                                (self.attribute_set is not None and self.attribute_set.has_data()) or
                                (self.xro_attribute_set is not None and self.xro_attribute_set.has_data()))

                        def has_operation(self):
                            for c in self.path_calculation_error:
                                if (c.has_operation()):
                                    return True
                            for c in self.remerge_error:
                                if (c.has_operation()):
                                    return True
                            for c in self.signalling_error:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.attribute_set_found.yfilter != YFilter.not_set or
                                self.explicit_path_id.yfilter != YFilter.not_set or
                                self.explicit_path_name.yfilter != YFilter.not_set or
                                self.has_attribute_set.yfilter != YFilter.not_set or
                                self.has_xro_attribute_set.yfilter != YFilter.not_set or
                                self.holddown_duration.yfilter != YFilter.not_set or
                                self.is_disabled.yfilter != YFilter.not_set or
                                self.is_helddown.yfilter != YFilter.not_set or
                                self.is_lockdown.yfilter != YFilter.not_set or
                                self.is_segment_routing.yfilter != YFilter.not_set or
                                self.is_strict_explicit_path.yfilter != YFilter.not_set or
                                self.is_verbatim.yfilter != YFilter.not_set or
                                self.option_index.yfilter != YFilter.not_set or
                                self.option_index_is_valid.yfilter != YFilter.not_set or
                                self.path_option_area_id.yfilter != YFilter.not_set or
                                self.path_option_name.yfilter != YFilter.not_set or
                                self.path_option_type.yfilter != YFilter.not_set or
                                self.pce_address.yfilter != YFilter.not_set or
                                self.protected_by_path_option_index.yfilter != YFilter.not_set or
                                self.restored_from_path_option_index.yfilter != YFilter.not_set or
                                self.xro_attribute_set_found.yfilter != YFilter.not_set or
                                (self.attribute_set is not None and self.attribute_set.has_operation()) or
                                (self.xro_attribute_set is not None and self.xro_attribute_set.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "path-option-entry" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.attribute_set_found.is_set or self.attribute_set_found.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.attribute_set_found.get_name_leafdata())
                            if (self.explicit_path_id.is_set or self.explicit_path_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.explicit_path_id.get_name_leafdata())
                            if (self.explicit_path_name.is_set or self.explicit_path_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.explicit_path_name.get_name_leafdata())
                            if (self.has_attribute_set.is_set or self.has_attribute_set.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.has_attribute_set.get_name_leafdata())
                            if (self.has_xro_attribute_set.is_set or self.has_xro_attribute_set.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.has_xro_attribute_set.get_name_leafdata())
                            if (self.holddown_duration.is_set or self.holddown_duration.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.holddown_duration.get_name_leafdata())
                            if (self.is_disabled.is_set or self.is_disabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_disabled.get_name_leafdata())
                            if (self.is_helddown.is_set or self.is_helddown.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_helddown.get_name_leafdata())
                            if (self.is_lockdown.is_set or self.is_lockdown.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_lockdown.get_name_leafdata())
                            if (self.is_segment_routing.is_set or self.is_segment_routing.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_segment_routing.get_name_leafdata())
                            if (self.is_strict_explicit_path.is_set or self.is_strict_explicit_path.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_strict_explicit_path.get_name_leafdata())
                            if (self.is_verbatim.is_set or self.is_verbatim.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_verbatim.get_name_leafdata())
                            if (self.option_index.is_set or self.option_index.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.option_index.get_name_leafdata())
                            if (self.option_index_is_valid.is_set or self.option_index_is_valid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.option_index_is_valid.get_name_leafdata())
                            if (self.path_option_area_id.is_set or self.path_option_area_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_option_area_id.get_name_leafdata())
                            if (self.path_option_name.is_set or self.path_option_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_option_name.get_name_leafdata())
                            if (self.path_option_type.is_set or self.path_option_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_option_type.get_name_leafdata())
                            if (self.pce_address.is_set or self.pce_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.pce_address.get_name_leafdata())
                            if (self.protected_by_path_option_index.is_set or self.protected_by_path_option_index.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.protected_by_path_option_index.get_name_leafdata())
                            if (self.restored_from_path_option_index.is_set or self.restored_from_path_option_index.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.restored_from_path_option_index.get_name_leafdata())
                            if (self.xro_attribute_set_found.is_set or self.xro_attribute_set_found.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.xro_attribute_set_found.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "attribute-set"):
                                if (self.attribute_set is None):
                                    self.attribute_set = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.AttributeSet()
                                    self.attribute_set.parent = self
                                    self._children_name_map["attribute_set"] = "attribute-set"
                                return self.attribute_set

                            if (child_yang_name == "path-calculation-error"):
                                for c in self.path_calculation_error:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.PathCalculationError()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_calculation_error.append(c)
                                return c

                            if (child_yang_name == "remerge-error"):
                                for c in self.remerge_error:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.RemergeError()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.remerge_error.append(c)
                                return c

                            if (child_yang_name == "signalling-error"):
                                for c in self.signalling_error:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.SignallingError()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.signalling_error.append(c)
                                return c

                            if (child_yang_name == "xro-attribute-set"):
                                if (self.xro_attribute_set is None):
                                    self.xro_attribute_set = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry.XroAttributeSet()
                                    self.xro_attribute_set.parent = self
                                    self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                                return self.xro_attribute_set

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "attribute-set" or name == "path-calculation-error" or name == "remerge-error" or name == "signalling-error" or name == "xro-attribute-set" or name == "attribute-set-found" or name == "explicit-path-id" or name == "explicit-path-name" or name == "has-attribute-set" or name == "has-xro-attribute-set" or name == "holddown-duration" or name == "is-disabled" or name == "is-helddown" or name == "is-lockdown" or name == "is-segment-routing" or name == "is-strict-explicit-path" or name == "is-verbatim" or name == "option-index" or name == "option-index-is-valid" or name == "path-option-area-id" or name == "path-option-name" or name == "path-option-type" or name == "pce-address" or name == "protected-by-path-option-index" or name == "restored-from-path-option-index" or name == "xro-attribute-set-found"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "attribute-set-found"):
                                self.attribute_set_found = value
                                self.attribute_set_found.value_namespace = name_space
                                self.attribute_set_found.value_namespace_prefix = name_space_prefix
                            if(value_path == "explicit-path-id"):
                                self.explicit_path_id = value
                                self.explicit_path_id.value_namespace = name_space
                                self.explicit_path_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "explicit-path-name"):
                                self.explicit_path_name = value
                                self.explicit_path_name.value_namespace = name_space
                                self.explicit_path_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "has-attribute-set"):
                                self.has_attribute_set = value
                                self.has_attribute_set.value_namespace = name_space
                                self.has_attribute_set.value_namespace_prefix = name_space_prefix
                            if(value_path == "has-xro-attribute-set"):
                                self.has_xro_attribute_set = value
                                self.has_xro_attribute_set.value_namespace = name_space
                                self.has_xro_attribute_set.value_namespace_prefix = name_space_prefix
                            if(value_path == "holddown-duration"):
                                self.holddown_duration = value
                                self.holddown_duration.value_namespace = name_space
                                self.holddown_duration.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-disabled"):
                                self.is_disabled = value
                                self.is_disabled.value_namespace = name_space
                                self.is_disabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-helddown"):
                                self.is_helddown = value
                                self.is_helddown.value_namespace = name_space
                                self.is_helddown.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-lockdown"):
                                self.is_lockdown = value
                                self.is_lockdown.value_namespace = name_space
                                self.is_lockdown.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-segment-routing"):
                                self.is_segment_routing = value
                                self.is_segment_routing.value_namespace = name_space
                                self.is_segment_routing.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-strict-explicit-path"):
                                self.is_strict_explicit_path = value
                                self.is_strict_explicit_path.value_namespace = name_space
                                self.is_strict_explicit_path.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-verbatim"):
                                self.is_verbatim = value
                                self.is_verbatim.value_namespace = name_space
                                self.is_verbatim.value_namespace_prefix = name_space_prefix
                            if(value_path == "option-index"):
                                self.option_index = value
                                self.option_index.value_namespace = name_space
                                self.option_index.value_namespace_prefix = name_space_prefix
                            if(value_path == "option-index-is-valid"):
                                self.option_index_is_valid = value
                                self.option_index_is_valid.value_namespace = name_space
                                self.option_index_is_valid.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-option-area-id"):
                                self.path_option_area_id = value
                                self.path_option_area_id.value_namespace = name_space
                                self.path_option_area_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-option-name"):
                                self.path_option_name = value
                                self.path_option_name.value_namespace = name_space
                                self.path_option_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-option-type"):
                                self.path_option_type = value
                                self.path_option_type.value_namespace = name_space
                                self.path_option_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "pce-address"):
                                self.pce_address = value
                                self.pce_address.value_namespace = name_space
                                self.pce_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "protected-by-path-option-index"):
                                self.protected_by_path_option_index = value
                                self.protected_by_path_option_index.value_namespace = name_space
                                self.protected_by_path_option_index.value_namespace_prefix = name_space_prefix
                            if(value_path == "restored-from-path-option-index"):
                                self.restored_from_path_option_index = value
                                self.restored_from_path_option_index.value_namespace = name_space
                                self.restored_from_path_option_index.value_namespace_prefix = name_space_prefix
                            if(value_path == "xro-attribute-set-found"):
                                self.xro_attribute_set_found = value
                                self.xro_attribute_set_found.value_namespace = name_space
                                self.xro_attribute_set_found.value_namespace_prefix = name_space_prefix


                    class PathOption(Entity):
                        """
                        Destination's list of path options
                        
                        .. attribute:: attribute_set
                        
                        	The path option attribute set used by this path
                        	**type**\:   :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet>`
                        
                        .. attribute:: attribute_set_found
                        
                        	TRUE if the path has found the defined attribute set
                        	**type**\:  bool
                        
                        .. attribute:: explicit_path_id
                        
                        	Explicit Path ID, this is the key to table ExplicitPaths.IdentifierTable
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: explicit_path_name
                        
                        	Explicit Path Name, this is the key to table ExplicitPaths.NameTable
                        	**type**\:  str
                        
                        .. attribute:: has_attribute_set
                        
                        	TRUE if the path has an attribute set defined
                        	**type**\:  bool
                        
                        .. attribute:: has_xro_attribute_set
                        
                        	TRUE if the path has an XRO attribute set configured
                        	**type**\:  bool
                        
                        .. attribute:: holddown_duration
                        
                        	Holddown Duration (seconds)
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        	**units**\: second
                        
                        .. attribute:: is_disabled
                        
                        	TRUE if the path option is disabled
                        	**type**\:  bool
                        
                        .. attribute:: is_helddown
                        
                        	TRUE if path is helddown
                        	**type**\:  bool
                        
                        .. attribute:: is_lockdown
                        
                        	TRUE if the path is locked down
                        	**type**\:  bool
                        
                        .. attribute:: is_segment_routing
                        
                        	TRUE if the path is Segment\-Routing
                        	**type**\:  bool
                        
                        .. attribute:: is_strict_explicit_path
                        
                        	TRUE if explicit path is strict
                        	**type**\:  bool
                        
                        .. attribute:: is_verbatim
                        
                        	TRUE if the path is verbatim
                        	**type**\:  bool
                        
                        .. attribute:: option_index
                        
                        	Path option index
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: option_index_is_valid
                        
                        	The path option index is valid
                        	**type**\:  bool
                        
                        .. attribute:: path_calculation_error
                        
                        	Path computation information
                        	**type**\: list of    :py:class:`PathCalculationError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.PathCalculationError>`
                        
                        .. attribute:: path_option_area_id
                        
                        	The path\-option area constraint
                        	**type**\:  str
                        
                        .. attribute:: path_option_name
                        
                        	Path option name
                        	**type**\:  str
                        
                        .. attribute:: path_option_type
                        
                        	Path option type
                        	**type**\:   :py:class:`MplsTePathoption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePathoption>`
                        
                        .. attribute:: pce_address
                        
                        	PCE server address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: protected_by_path_option_index
                        
                        	Path option index for Protect path options
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: remerge_error
                        
                        	Path computation remerge resolve info
                        	**type**\: list of    :py:class:`RemergeError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.RemergeError>`
                        
                        .. attribute:: restored_from_path_option_index
                        
                        	Path option index for Restore path options
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: signalling_error
                        
                        	Signalling information
                        	**type**\: list of    :py:class:`SignallingError <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.SignallingError>`
                        
                        .. attribute:: xro_attribute_set
                        
                        	The XRO attribute set used by this path\-option
                        	**type**\:   :py:class:`XroAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet>`
                        
                        .. attribute:: xro_attribute_set_found
                        
                        	TRUE if the path's XRO attribute set is known
                        	**type**\:  bool
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption, self).__init__()

                            self.yang_name = "path-option"
                            self.yang_parent_name = "destination"

                            self.attribute_set_found = YLeaf(YType.boolean, "attribute-set-found")

                            self.explicit_path_id = YLeaf(YType.uint16, "explicit-path-id")

                            self.explicit_path_name = YLeaf(YType.str, "explicit-path-name")

                            self.has_attribute_set = YLeaf(YType.boolean, "has-attribute-set")

                            self.has_xro_attribute_set = YLeaf(YType.boolean, "has-xro-attribute-set")

                            self.holddown_duration = YLeaf(YType.uint16, "holddown-duration")

                            self.is_disabled = YLeaf(YType.boolean, "is-disabled")

                            self.is_helddown = YLeaf(YType.boolean, "is-helddown")

                            self.is_lockdown = YLeaf(YType.boolean, "is-lockdown")

                            self.is_segment_routing = YLeaf(YType.boolean, "is-segment-routing")

                            self.is_strict_explicit_path = YLeaf(YType.boolean, "is-strict-explicit-path")

                            self.is_verbatim = YLeaf(YType.boolean, "is-verbatim")

                            self.option_index = YLeaf(YType.uint32, "option-index")

                            self.option_index_is_valid = YLeaf(YType.boolean, "option-index-is-valid")

                            self.path_option_area_id = YLeaf(YType.str, "path-option-area-id")

                            self.path_option_name = YLeaf(YType.str, "path-option-name")

                            self.path_option_type = YLeaf(YType.enumeration, "path-option-type")

                            self.pce_address = YLeaf(YType.str, "pce-address")

                            self.protected_by_path_option_index = YLeaf(YType.uint32, "protected-by-path-option-index")

                            self.restored_from_path_option_index = YLeaf(YType.uint32, "restored-from-path-option-index")

                            self.xro_attribute_set_found = YLeaf(YType.boolean, "xro-attribute-set-found")

                            self.attribute_set = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet()
                            self.attribute_set.parent = self
                            self._children_name_map["attribute_set"] = "attribute-set"
                            self._children_yang_names.add("attribute-set")

                            self.xro_attribute_set = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet()
                            self.xro_attribute_set.parent = self
                            self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                            self._children_yang_names.add("xro-attribute-set")

                            self.path_calculation_error = YList(self)
                            self.remerge_error = YList(self)
                            self.signalling_error = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("attribute_set_found",
                                            "explicit_path_id",
                                            "explicit_path_name",
                                            "has_attribute_set",
                                            "has_xro_attribute_set",
                                            "holddown_duration",
                                            "is_disabled",
                                            "is_helddown",
                                            "is_lockdown",
                                            "is_segment_routing",
                                            "is_strict_explicit_path",
                                            "is_verbatim",
                                            "option_index",
                                            "option_index_is_valid",
                                            "path_option_area_id",
                                            "path_option_name",
                                            "path_option_type",
                                            "pce_address",
                                            "protected_by_path_option_index",
                                            "restored_from_path_option_index",
                                            "xro_attribute_set_found") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption, self).__setattr__(name, value)


                        class AttributeSet(Entity):
                            """
                            The path option attribute set used by this path
                            
                            .. attribute:: attribute_set_union
                            
                            	Union of Attribute Sets
                            	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion>`
                            
                            .. attribute:: tunnel_attribute_set_name
                            
                            	Attribute Set Name
                            	**type**\:  str
                            
                            .. attribute:: tunnel_attribute_set_name_crc32
                            
                            	Attribute Set name CRC32 value
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet, self).__init__()

                                self.yang_name = "attribute-set"
                                self.yang_parent_name = "path-option"

                                self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                                self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                                self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion()
                                self.attribute_set_union.parent = self
                                self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                self._children_yang_names.add("attribute-set-union")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("tunnel_attribute_set_name",
                                                "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet, self).__setattr__(name, value)


                            class AttributeSetUnion(Entity):
                                """
                                Union of Attribute Sets
                                
                                .. attribute:: attribute_set_aps_pp
                                
                                	Attribute Set OTN APS Path Protection
                                	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                
                                .. attribute:: attribute_set_autobackup
                                
                                	MPLS TE Auto\-backup Attribute Set
                                	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                
                                .. attribute:: attribute_set_automesh
                                
                                	MPLS TE Auto\-mesh Attribute Set
                                	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                
                                .. attribute:: attribute_set_p2mpte
                                
                                	MPLS TE P2MP\-TE Attribute Set
                                	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                                
                                .. attribute:: attribute_set_p2p_te
                                
                                	MPLS TE P2P\-TE Attribute Set
                                	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                                
                                .. attribute:: attribute_set_path_option
                                
                                	MPLS TE Path Option Attribute Set
                                	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                
                                .. attribute:: attribute_set_xro
                                
                                	Attribute Set XRO
                                	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                                
                                .. attribute:: tunnel_attribute_set_type
                                
                                	TunnelAttributeSetType
                                	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion, self).__init__()

                                    self.yang_name = "attribute-set-union"
                                    self.yang_parent_name = "attribute-set"

                                    self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                                    self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                    self.attribute_set_aps_pp.parent = self
                                    self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                    self._children_yang_names.add("attribute-set-aps-pp")

                                    self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                    self.attribute_set_autobackup.parent = self
                                    self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                    self._children_yang_names.add("attribute-set-autobackup")

                                    self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                    self.attribute_set_automesh.parent = self
                                    self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                    self._children_yang_names.add("attribute-set-automesh")

                                    self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                    self.attribute_set_p2mpte.parent = self
                                    self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                    self._children_yang_names.add("attribute-set-p2mpte")

                                    self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                    self.attribute_set_p2p_te.parent = self
                                    self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                    self._children_yang_names.add("attribute-set-p2p-te")

                                    self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                    self.attribute_set_path_option.parent = self
                                    self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                    self._children_yang_names.add("attribute-set-path-option")

                                    self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                    self.attribute_set_xro.parent = self
                                    self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                    self._children_yang_names.add("attribute-set-xro")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                                class AttributeSetPathOption(Entity):
                                    """
                                    MPLS TE Path Option Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                    
                                    .. attribute:: bandwidth_type
                                    
                                    	The bandwidth type
                                    	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                    
                                    .. attribute:: bfd_reverse_path
                                    
                                    	BFD reverse path
                                    	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: cost_limit
                                    
                                    	Cost limit on the tunnel path
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: exclude_list_name
                                    
                                    	Exclude list name
                                    	**type**\:  str
                                    
                                    .. attribute:: generation
                                    
                                    	Generation
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bfd_reverse_pat_configured
                                    
                                    	Is BFD reverse path configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_cost_limit_configured
                                    
                                    	Is Cost Limit configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_exclude_list_name_configured
                                    
                                    	Is exclude list name configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is path invalidation action configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is path invalidation timeout configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: path_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation interval on the tunnel path
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                    
                                    .. attribute:: version_info
                                    
                                    	Version Info
                                    	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                        self.yang_name = "attribute-set-path-option"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                        self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                        self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                        self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                        self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                        self.generation = YLeaf(YType.uint32, "generation")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                        self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                        self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                        self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                        self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                        self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                        self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                        self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                        self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                        self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                        self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                        self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                        self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                        self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                        self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                        self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                        self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                        self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                        self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                        self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                        self.bfd_reverse_path.parent = self
                                        self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                        self._children_yang_names.add("bfd-reverse-path")

                                        self.tunnel_id = YList(self)
                                        self.version_info = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bandwidth_type",
                                                        "configured_bandwidth",
                                                        "cost_limit",
                                                        "dste_class_type",
                                                        "exclude_list_name",
                                                        "generation",
                                                        "is_affinity_configured",
                                                        "is_bandwidth_configured",
                                                        "is_bfd_reverse_pat_configured",
                                                        "is_cost_limit_configured",
                                                        "is_exclude_list_name_configured",
                                                        "is_path_invalidation_action_configured",
                                                        "is_path_invalidation_timeout_configured",
                                                        "is_pce_configured",
                                                        "is_pce_disj_group_id_configured",
                                                        "is_pce_disj_source_configured",
                                                        "is_pce_disj_type_configured",
                                                        "is_pceb_dj_source_configured",
                                                        "is_pcebd_group_id_configured",
                                                        "path_invalidation_action",
                                                        "path_invalidation_timeout",
                                                        "pcebd_group_id",
                                                        "pcebd_source_address",
                                                        "pcedp_group_id",
                                                        "pcedp_source_address",
                                                        "pcedp_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class BfdReversePath(Entity):
                                        """
                                        BFD reverse path
                                        
                                        .. attribute:: binding_label
                                        
                                        	BFD reverse path binding label
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_type
                                        
                                        	BFD reverse path type
                                        	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                            self.yang_name = "bfd-reverse-path"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.binding_label = YLeaf(YType.uint32, "binding-label")

                                            self.path_type = YLeaf(YType.enumeration, "path-type")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("binding_label",
                                                            "path_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.binding_label.is_set or
                                                self.path_type.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.binding_label.yfilter != YFilter.not_set or
                                                self.path_type.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bfd-reverse-path" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.binding_label.get_name_leafdata())
                                            if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "binding-label" or name == "path-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "binding-label"):
                                                self.binding_label = value
                                                self.binding_label.value_namespace = name_space
                                                self.binding_label.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-type"):
                                                self.path_type = value
                                                self.path_type.value_namespace = name_space
                                                self.path_type.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class VersionInfo(Entity):
                                        """
                                        Version Info
                                        
                                        .. attribute:: attribute_type
                                        
                                        	Attribute Type
                                        	**type**\:  str
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_default
                                        
                                        	Is default
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                            self.yang_name = "version-info"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.attribute_type = YLeaf(YType.str, "attribute-type")

                                            self.generation = YLeaf(YType.uint32, "generation")

                                            self.is_default = YLeaf(YType.boolean, "is-default")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("attribute_type",
                                                            "generation",
                                                            "is_default") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.attribute_type.is_set or
                                                self.generation.is_set or
                                                self.is_default.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.attribute_type.yfilter != YFilter.not_set or
                                                self.generation.yfilter != YFilter.not_set or
                                                self.is_default.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "version-info" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.generation.get_name_leafdata())
                                            if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_default.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "attribute-type"):
                                                self.attribute_type = value
                                                self.attribute_type.value_namespace = name_space
                                                self.attribute_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "generation"):
                                                self.generation = value
                                                self.generation.value_namespace = name_space
                                                self.generation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-default"):
                                                self.is_default = value
                                                self.is_default.value_namespace = name_space
                                                self.is_default.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        for c in self.version_info:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bandwidth_type.is_set or
                                            self.configured_bandwidth.is_set or
                                            self.cost_limit.is_set or
                                            self.dste_class_type.is_set or
                                            self.exclude_list_name.is_set or
                                            self.generation.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_bandwidth_configured.is_set or
                                            self.is_bfd_reverse_pat_configured.is_set or
                                            self.is_cost_limit_configured.is_set or
                                            self.is_exclude_list_name_configured.is_set or
                                            self.is_path_invalidation_action_configured.is_set or
                                            self.is_path_invalidation_timeout_configured.is_set or
                                            self.is_pce_configured.is_set or
                                            self.is_pce_disj_group_id_configured.is_set or
                                            self.is_pce_disj_source_configured.is_set or
                                            self.is_pce_disj_type_configured.is_set or
                                            self.is_pceb_dj_source_configured.is_set or
                                            self.is_pcebd_group_id_configured.is_set or
                                            self.path_invalidation_action.is_set or
                                            self.path_invalidation_timeout.is_set or
                                            self.pcebd_group_id.is_set or
                                            self.pcebd_source_address.is_set or
                                            self.pcedp_group_id.is_set or
                                            self.pcedp_source_address.is_set or
                                            self.pcedp_type.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                                    def has_operation(self):
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.version_info:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bandwidth_type.yfilter != YFilter.not_set or
                                            self.configured_bandwidth.yfilter != YFilter.not_set or
                                            self.cost_limit.yfilter != YFilter.not_set or
                                            self.dste_class_type.yfilter != YFilter.not_set or
                                            self.exclude_list_name.yfilter != YFilter.not_set or
                                            self.generation.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                            self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                            self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                            self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                            self.is_pce_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                            self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                            self.path_invalidation_action.yfilter != YFilter.not_set or
                                            self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                            self.pcebd_group_id.yfilter != YFilter.not_set or
                                            self.pcebd_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_group_id.yfilter != YFilter.not_set or
                                            self.pcedp_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_type.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-path-option" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                        if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                        if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                        if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                        if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                        if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.generation.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                        if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                        if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                        if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                        if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                        if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                        if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                        if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                        if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                        if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                        if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                        if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                        if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                        if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                        if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                        if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                        if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "bfd-reverse-path"):
                                            if (self.bfd_reverse_path is None):
                                                self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                                self.bfd_reverse_path.parent = self
                                                self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                            return self.bfd_reverse_path

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        if (child_yang_name == "version-info"):
                                            for c in self.version_info:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.version_info.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bandwidth-type"):
                                            self.bandwidth_type = value
                                            self.bandwidth_type.value_namespace = name_space
                                            self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "configured-bandwidth"):
                                            self.configured_bandwidth = value
                                            self.configured_bandwidth.value_namespace = name_space
                                            self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "cost-limit"):
                                            self.cost_limit = value
                                            self.cost_limit.value_namespace = name_space
                                            self.cost_limit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dste-class-type"):
                                            self.dste_class_type = value
                                            self.dste_class_type.value_namespace = name_space
                                            self.dste_class_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclude-list-name"):
                                            self.exclude_list_name = value
                                            self.exclude_list_name.value_namespace = name_space
                                            self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "generation"):
                                            self.generation = value
                                            self.generation.value_namespace = name_space
                                            self.generation.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bandwidth-configured"):
                                            self.is_bandwidth_configured = value
                                            self.is_bandwidth_configured.value_namespace = name_space
                                            self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bfd-reverse-pat-configured"):
                                            self.is_bfd_reverse_pat_configured = value
                                            self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                            self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-cost-limit-configured"):
                                            self.is_cost_limit_configured = value
                                            self.is_cost_limit_configured.value_namespace = name_space
                                            self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-exclude-list-name-configured"):
                                            self.is_exclude_list_name_configured = value
                                            self.is_exclude_list_name_configured.value_namespace = name_space
                                            self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-action-configured"):
                                            self.is_path_invalidation_action_configured = value
                                            self.is_path_invalidation_action_configured.value_namespace = name_space
                                            self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-timeout-configured"):
                                            self.is_path_invalidation_timeout_configured = value
                                            self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                            self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-configured"):
                                            self.is_pce_configured = value
                                            self.is_pce_configured.value_namespace = name_space
                                            self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-group-id-configured"):
                                            self.is_pce_disj_group_id_configured = value
                                            self.is_pce_disj_group_id_configured.value_namespace = name_space
                                            self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-source-configured"):
                                            self.is_pce_disj_source_configured = value
                                            self.is_pce_disj_source_configured.value_namespace = name_space
                                            self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-type-configured"):
                                            self.is_pce_disj_type_configured = value
                                            self.is_pce_disj_type_configured.value_namespace = name_space
                                            self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pceb-dj-source-configured"):
                                            self.is_pceb_dj_source_configured = value
                                            self.is_pceb_dj_source_configured.value_namespace = name_space
                                            self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pcebd-group-id-configured"):
                                            self.is_pcebd_group_id_configured = value
                                            self.is_pcebd_group_id_configured.value_namespace = name_space
                                            self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-invalidation-action"):
                                            self.path_invalidation_action = value
                                            self.path_invalidation_action.value_namespace = name_space
                                            self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-invalidation-timeout"):
                                            self.path_invalidation_timeout = value
                                            self.path_invalidation_timeout.value_namespace = name_space
                                            self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-group-id"):
                                            self.pcebd_group_id = value
                                            self.pcebd_group_id.value_namespace = name_space
                                            self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-source-address"):
                                            self.pcebd_source_address = value
                                            self.pcebd_source_address.value_namespace = name_space
                                            self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-group-id"):
                                            self.pcedp_group_id = value
                                            self.pcedp_group_id.value_namespace = name_space
                                            self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-source-address"):
                                            self.pcedp_source_address = value
                                            self.pcedp_source_address.value_namespace = name_space
                                            self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-type"):
                                            self.pcedp_type = value
                                            self.pcedp_type.value_namespace = name_space
                                            self.pcedp_type.value_namespace_prefix = name_space_prefix


                                class AttributeSetAutobackup(Entity):
                                    """
                                    MPLS TE Auto\-backup Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_signalled_name_configured
                                    
                                    	Is signalled name configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                    
                                    .. attribute:: protected_interface
                                    
                                    	Array of Protected Interface Names
                                    	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\:  bool
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: signalled_name
                                    
                                    	Signalled name
                                    	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                        self.yang_name = "attribute-set-autobackup"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                        self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                        self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                        self.policy_class = YLeaf(YType.uint8, "policy-class")

                                        self.record_route = YLeaf(YType.boolean, "record-route")

                                        self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                        self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"
                                        self._children_yang_names.add("logging")

                                        self.signalled_name = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                        self.signalled_name.parent = self
                                        self._children_name_map["signalled_name"] = "signalled-name"
                                        self._children_yang_names.add("signalled-name")

                                        self.policy_class_entry = YList(self)
                                        self.protected_interface = YList(self)
                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("hold_priority",
                                                        "is_affinity_configured",
                                                        "is_policyclass_configured",
                                                        "is_priority_configured",
                                                        "is_signalled_name_configured",
                                                        "policy_class",
                                                        "record_route",
                                                        "setup_priority") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                                    class SignalledName(Entity):
                                        """
                                        Signalled name
                                        
                                        .. attribute:: is_mp_addresses
                                        
                                        	MP address appended
                                        	**type**\:  bool
                                        
                                        .. attribute:: name
                                        
                                        	Signalled name
                                        	**type**\:  str
                                        
                                        .. attribute:: protected_interface_type
                                        
                                        	Protected interface address or name
                                        	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        .. attribute:: source_type
                                        
                                        	Source address or name
                                        	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                            self.yang_name = "signalled-name"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                            self.name = YLeaf(YType.str, "name")

                                            self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                            self.source_type = YLeaf(YType.enumeration, "source-type")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_mp_addresses",
                                                            "name",
                                                            "protected_interface_type",
                                                            "source_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.is_mp_addresses.is_set or
                                                self.name.is_set or
                                                self.protected_interface_type.is_set or
                                                self.source_type.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_mp_addresses.yfilter != YFilter.not_set or
                                                self.name.yfilter != YFilter.not_set or
                                                self.protected_interface_type.yfilter != YFilter.not_set or
                                                self.source_type.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "signalled-name" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                            if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.name.get_name_leafdata())
                                            if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                            if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.source_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-mp-addresses"):
                                                self.is_mp_addresses = value
                                                self.is_mp_addresses.value_namespace = name_space
                                                self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                            if(value_path == "name"):
                                                self.name = value
                                                self.name.value_namespace = name_space
                                                self.name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protected-interface-type"):
                                                self.protected_interface_type = value
                                                self.protected_interface_type.value_namespace = name_space
                                                self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "source-type"):
                                                self.source_type = value
                                                self.source_type.value_namespace = name_space
                                                self.source_type.value_namespace_prefix = name_space_prefix


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class Logging(Entity):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                            self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                            self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                            self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                            self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                            self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                            self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                            self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("all_logging_enabled",
                                                            "lsp_bandwidth_change",
                                                            "lsp_insufficient_bw",
                                                            "lsp_pcalc_failure_logging_enabled",
                                                            "lsp_re_opt",
                                                            "lsp_re_route",
                                                            "lsp_state",
                                                            "s2l_state") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.all_logging_enabled.is_set or
                                                self.lsp_bandwidth_change.is_set or
                                                self.lsp_insufficient_bw.is_set or
                                                self.lsp_pcalc_failure_logging_enabled.is_set or
                                                self.lsp_re_opt.is_set or
                                                self.lsp_re_route.is_set or
                                                self.lsp_state.is_set or
                                                self.s2l_state.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.all_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_re_opt.yfilter != YFilter.not_set or
                                                self.lsp_re_route.yfilter != YFilter.not_set or
                                                self.lsp_state.yfilter != YFilter.not_set or
                                                self.s2l_state.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "logging" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                            if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                            if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                            if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                            if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                            if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                            if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                            if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "all-logging-enabled"):
                                                self.all_logging_enabled = value
                                                self.all_logging_enabled.value_namespace = name_space
                                                self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-bandwidth-change"):
                                                self.lsp_bandwidth_change = value
                                                self.lsp_bandwidth_change.value_namespace = name_space
                                                self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-insufficient-bw"):
                                                self.lsp_insufficient_bw = value
                                                self.lsp_insufficient_bw.value_namespace = name_space
                                                self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                self.lsp_pcalc_failure_logging_enabled = value
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-opt"):
                                                self.lsp_re_opt = value
                                                self.lsp_re_opt.value_namespace = name_space
                                                self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-route"):
                                                self.lsp_re_route = value
                                                self.lsp_re_route.value_namespace = name_space
                                                self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-state"):
                                                self.lsp_state = value
                                                self.lsp_state.value_namespace = name_space
                                                self.lsp_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "s2l-state"):
                                                self.s2l_state = value
                                                self.s2l_state.value_namespace = name_space
                                                self.s2l_state.value_namespace_prefix = name_space_prefix


                                    class PolicyClassEntry(Entity):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "policy-class-entry" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class ProtectedInterface(Entity):
                                        """
                                        Array of Protected Interface Names
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Protected Interface Name
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                            self.yang_name = "protected-interface"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.protected_interface = YLeaf(YType.str, "protected-interface")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("protected_interface") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.protected_interface.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.protected_interface.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "protected-interface" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "protected-interface"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "protected-interface"):
                                                self.protected_interface = value
                                                self.protected_interface.value_namespace = name_space
                                                self.protected_interface.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.policy_class_entry:
                                            if (c.has_data()):
                                                return True
                                        for c in self.protected_interface:
                                            if (c.has_data()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.hold_priority.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_policyclass_configured.is_set or
                                            self.is_priority_configured.is_set or
                                            self.is_signalled_name_configured.is_set or
                                            self.policy_class.is_set or
                                            self.record_route.is_set or
                                            self.setup_priority.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.logging is not None and self.logging.has_data()) or
                                            (self.signalled_name is not None and self.signalled_name.has_data()))

                                    def has_operation(self):
                                        for c in self.policy_class_entry:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.protected_interface:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.hold_priority.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_policyclass_configured.yfilter != YFilter.not_set or
                                            self.is_priority_configured.yfilter != YFilter.not_set or
                                            self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                            self.policy_class.yfilter != YFilter.not_set or
                                            self.record_route.yfilter != YFilter.not_set or
                                            self.setup_priority.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.logging is not None and self.logging.has_operation()) or
                                            (self.signalled_name is not None and self.signalled_name.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-autobackup" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                        if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                        if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                        if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.policy_class.get_name_leafdata())
                                        if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.record_route.get_name_leafdata())
                                        if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "logging"):
                                            if (self.logging is None):
                                                self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                                self.logging.parent = self
                                                self._children_name_map["logging"] = "logging"
                                            return self.logging

                                        if (child_yang_name == "policy-class-entry"):
                                            for c in self.policy_class_entry:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.policy_class_entry.append(c)
                                            return c

                                        if (child_yang_name == "protected-interface"):
                                            for c in self.protected_interface:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.protected_interface.append(c)
                                            return c

                                        if (child_yang_name == "signalled-name"):
                                            if (self.signalled_name is None):
                                                self.signalled_name = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                                self.signalled_name.parent = self
                                                self._children_name_map["signalled_name"] = "signalled-name"
                                            return self.signalled_name

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "hold-priority"):
                                            self.hold_priority = value
                                            self.hold_priority.value_namespace = name_space
                                            self.hold_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-policyclass-configured"):
                                            self.is_policyclass_configured = value
                                            self.is_policyclass_configured.value_namespace = name_space
                                            self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-priority-configured"):
                                            self.is_priority_configured = value
                                            self.is_priority_configured.value_namespace = name_space
                                            self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-signalled-name-configured"):
                                            self.is_signalled_name_configured = value
                                            self.is_signalled_name_configured.value_namespace = name_space
                                            self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "policy-class"):
                                            self.policy_class = value
                                            self.policy_class.value_namespace = name_space
                                            self.policy_class.value_namespace_prefix = name_space_prefix
                                        if(value_path == "record-route"):
                                            self.record_route = value
                                            self.record_route.value_namespace = name_space
                                            self.record_route.value_namespace_prefix = name_space_prefix
                                        if(value_path == "setup-priority"):
                                            self.setup_priority = value
                                            self.setup_priority.value_namespace = name_space
                                            self.setup_priority.value_namespace_prefix = name_space_prefix


                                class AttributeSetAutomesh(Entity):
                                    """
                                    MPLS TE Auto\-mesh Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                    
                                    .. attribute:: auto_bandwidth_collect
                                    
                                    	Auto bandwidth collect only
                                    	**type**\:  bool
                                    
                                    .. attribute:: auto_route_announce
                                    
                                    	Announce auto route to IGP
                                    	**type**\:  bool
                                    
                                    .. attribute:: bandwidth
                                    
                                    	IM bandwidth
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\:  bool
                                    
                                    .. attribute:: forward_class
                                    
                                    	Forward class
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\:  bool
                                    
                                    .. attribute:: frr_node_protection
                                    
                                    	FRR Node protection
                                    	**type**\:  bool
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_interface_bw_configured
                                    
                                    	Is Interface BW configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: load_share
                                    
                                    	Load Share
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                    
                                    .. attribute:: mesh_group_id
                                    
                                    	Meshgroup ID
                                    	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\:  bool
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: soft_preemption_configured
                                    
                                    	Soft preemption is configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                        self.yang_name = "attribute-set-automesh"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                        self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                        self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                        self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                        self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                        self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                        self.forward_class = YLeaf(YType.uint32, "forward-class")

                                        self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                        self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                        self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                        self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                        self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                        self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                        self.load_share = YLeaf(YType.uint32, "load-share")

                                        self.policy_class = YLeaf(YType.uint8, "policy-class")

                                        self.record_route = YLeaf(YType.boolean, "record-route")

                                        self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                        self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                        self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"
                                        self._children_yang_names.add("logging")

                                        self.mesh_group_id = YList(self)
                                        self.policy_class_entry = YList(self)
                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("auto_bandwidth_collect",
                                                        "auto_route_announce",
                                                        "bandwidth",
                                                        "configured_bandwidth",
                                                        "dste_class_type",
                                                        "fast_reroute",
                                                        "forward_class",
                                                        "frr_bandwidth_protection",
                                                        "frr_node_protection",
                                                        "hold_priority",
                                                        "is_affinity_configured",
                                                        "is_bandwidth_configured",
                                                        "is_interface_bw_configured",
                                                        "is_policyclass_configured",
                                                        "is_priority_configured",
                                                        "load_share",
                                                        "policy_class",
                                                        "record_route",
                                                        "setup_priority",
                                                        "soft_preemption_configured") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class Logging(Entity):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                            self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                            self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                            self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                            self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                            self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                            self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                            self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("all_logging_enabled",
                                                            "lsp_bandwidth_change",
                                                            "lsp_insufficient_bw",
                                                            "lsp_pcalc_failure_logging_enabled",
                                                            "lsp_re_opt",
                                                            "lsp_re_route",
                                                            "lsp_state",
                                                            "s2l_state") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.all_logging_enabled.is_set or
                                                self.lsp_bandwidth_change.is_set or
                                                self.lsp_insufficient_bw.is_set or
                                                self.lsp_pcalc_failure_logging_enabled.is_set or
                                                self.lsp_re_opt.is_set or
                                                self.lsp_re_route.is_set or
                                                self.lsp_state.is_set or
                                                self.s2l_state.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.all_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_re_opt.yfilter != YFilter.not_set or
                                                self.lsp_re_route.yfilter != YFilter.not_set or
                                                self.lsp_state.yfilter != YFilter.not_set or
                                                self.s2l_state.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "logging" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                            if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                            if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                            if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                            if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                            if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                            if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                            if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "all-logging-enabled"):
                                                self.all_logging_enabled = value
                                                self.all_logging_enabled.value_namespace = name_space
                                                self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-bandwidth-change"):
                                                self.lsp_bandwidth_change = value
                                                self.lsp_bandwidth_change.value_namespace = name_space
                                                self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-insufficient-bw"):
                                                self.lsp_insufficient_bw = value
                                                self.lsp_insufficient_bw.value_namespace = name_space
                                                self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                self.lsp_pcalc_failure_logging_enabled = value
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-opt"):
                                                self.lsp_re_opt = value
                                                self.lsp_re_opt.value_namespace = name_space
                                                self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-route"):
                                                self.lsp_re_route = value
                                                self.lsp_re_route.value_namespace = name_space
                                                self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-state"):
                                                self.lsp_state = value
                                                self.lsp_state.value_namespace = name_space
                                                self.lsp_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "s2l-state"):
                                                self.s2l_state = value
                                                self.s2l_state.value_namespace = name_space
                                                self.s2l_state.value_namespace_prefix = name_space_prefix


                                    class PolicyClassEntry(Entity):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "policy-class-entry" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class MeshGroupId(Entity):
                                        """
                                        Meshgroup ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                            self.yang_name = "mesh-group-id"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.entry = YLeaf(YType.uint32, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "mesh-group-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.mesh_group_id:
                                            if (c.has_data()):
                                                return True
                                        for c in self.policy_class_entry:
                                            if (c.has_data()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.auto_bandwidth_collect.is_set or
                                            self.auto_route_announce.is_set or
                                            self.bandwidth.is_set or
                                            self.configured_bandwidth.is_set or
                                            self.dste_class_type.is_set or
                                            self.fast_reroute.is_set or
                                            self.forward_class.is_set or
                                            self.frr_bandwidth_protection.is_set or
                                            self.frr_node_protection.is_set or
                                            self.hold_priority.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_bandwidth_configured.is_set or
                                            self.is_interface_bw_configured.is_set or
                                            self.is_policyclass_configured.is_set or
                                            self.is_priority_configured.is_set or
                                            self.load_share.is_set or
                                            self.policy_class.is_set or
                                            self.record_route.is_set or
                                            self.setup_priority.is_set or
                                            self.soft_preemption_configured.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.logging is not None and self.logging.has_data()))

                                    def has_operation(self):
                                        for c in self.mesh_group_id:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.policy_class_entry:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                            self.auto_route_announce.yfilter != YFilter.not_set or
                                            self.bandwidth.yfilter != YFilter.not_set or
                                            self.configured_bandwidth.yfilter != YFilter.not_set or
                                            self.dste_class_type.yfilter != YFilter.not_set or
                                            self.fast_reroute.yfilter != YFilter.not_set or
                                            self.forward_class.yfilter != YFilter.not_set or
                                            self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                            self.frr_node_protection.yfilter != YFilter.not_set or
                                            self.hold_priority.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                            self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                            self.is_policyclass_configured.yfilter != YFilter.not_set or
                                            self.is_priority_configured.yfilter != YFilter.not_set or
                                            self.load_share.yfilter != YFilter.not_set or
                                            self.policy_class.yfilter != YFilter.not_set or
                                            self.record_route.yfilter != YFilter.not_set or
                                            self.setup_priority.yfilter != YFilter.not_set or
                                            self.soft_preemption_configured.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.logging is not None and self.logging.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-automesh" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                        if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                        if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                        if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                        if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                        if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                        if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.forward_class.get_name_leafdata())
                                        if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                        if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                        if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                        if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                        if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                        if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                        if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.load_share.get_name_leafdata())
                                        if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.policy_class.get_name_leafdata())
                                        if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.record_route.get_name_leafdata())
                                        if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                        if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "logging"):
                                            if (self.logging is None):
                                                self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                                self.logging.parent = self
                                                self._children_name_map["logging"] = "logging"
                                            return self.logging

                                        if (child_yang_name == "mesh-group-id"):
                                            for c in self.mesh_group_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.mesh_group_id.append(c)
                                            return c

                                        if (child_yang_name == "policy-class-entry"):
                                            for c in self.policy_class_entry:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.policy_class_entry.append(c)
                                            return c

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "auto-bandwidth-collect"):
                                            self.auto_bandwidth_collect = value
                                            self.auto_bandwidth_collect.value_namespace = name_space
                                            self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                        if(value_path == "auto-route-announce"):
                                            self.auto_route_announce = value
                                            self.auto_route_announce.value_namespace = name_space
                                            self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                        if(value_path == "bandwidth"):
                                            self.bandwidth = value
                                            self.bandwidth.value_namespace = name_space
                                            self.bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "configured-bandwidth"):
                                            self.configured_bandwidth = value
                                            self.configured_bandwidth.value_namespace = name_space
                                            self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dste-class-type"):
                                            self.dste_class_type = value
                                            self.dste_class_type.value_namespace = name_space
                                            self.dste_class_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "fast-reroute"):
                                            self.fast_reroute = value
                                            self.fast_reroute.value_namespace = name_space
                                            self.fast_reroute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "forward-class"):
                                            self.forward_class = value
                                            self.forward_class.value_namespace = name_space
                                            self.forward_class.value_namespace_prefix = name_space_prefix
                                        if(value_path == "frr-bandwidth-protection"):
                                            self.frr_bandwidth_protection = value
                                            self.frr_bandwidth_protection.value_namespace = name_space
                                            self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "frr-node-protection"):
                                            self.frr_node_protection = value
                                            self.frr_node_protection.value_namespace = name_space
                                            self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "hold-priority"):
                                            self.hold_priority = value
                                            self.hold_priority.value_namespace = name_space
                                            self.hold_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bandwidth-configured"):
                                            self.is_bandwidth_configured = value
                                            self.is_bandwidth_configured.value_namespace = name_space
                                            self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-interface-bw-configured"):
                                            self.is_interface_bw_configured = value
                                            self.is_interface_bw_configured.value_namespace = name_space
                                            self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-policyclass-configured"):
                                            self.is_policyclass_configured = value
                                            self.is_policyclass_configured.value_namespace = name_space
                                            self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-priority-configured"):
                                            self.is_priority_configured = value
                                            self.is_priority_configured.value_namespace = name_space
                                            self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "load-share"):
                                            self.load_share = value
                                            self.load_share.value_namespace = name_space
                                            self.load_share.value_namespace_prefix = name_space_prefix
                                        if(value_path == "policy-class"):
                                            self.policy_class = value
                                            self.policy_class.value_namespace = name_space
                                            self.policy_class.value_namespace_prefix = name_space_prefix
                                        if(value_path == "record-route"):
                                            self.record_route = value
                                            self.record_route.value_namespace = name_space
                                            self.record_route.value_namespace_prefix = name_space_prefix
                                        if(value_path == "setup-priority"):
                                            self.setup_priority = value
                                            self.setup_priority.value_namespace = name_space
                                            self.setup_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "soft-preemption-configured"):
                                            self.soft_preemption_configured = value
                                            self.soft_preemption_configured.value_namespace = name_space
                                            self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                                class AttributeSetXro(Entity):
                                    """
                                    Attribute Set XRO
                                    
                                    .. attribute:: xro
                                    
                                    	The XRO specified by this attribute\-set
                                    	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                        self.yang_name = "attribute-set-xro"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                        self.xro.parent = self
                                        self._children_name_map["xro"] = "xro"
                                        self._children_yang_names.add("xro")


                                    class Xro(Entity):
                                        """
                                        The XRO specified by this attribute\-set
                                        
                                        .. attribute:: mutual_diversity_flag
                                        
                                        	Mutual Diversity Flag
                                        	**type**\:  bool
                                        
                                        .. attribute:: xro_subobject
                                        
                                        	List of XRO sub\-objects
                                        	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                            self.yang_name = "xro"
                                            self.yang_parent_name = "attribute-set-xro"

                                            self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                            self.xro_subobject = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("mutual_diversity_flag") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                        class XroSubobject(Entity):
                                            """
                                            List of XRO sub\-objects
                                            
                                            .. attribute:: as_subobject
                                            
                                            	AS sub\-object
                                            	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                            
                                            .. attribute:: ipv4_subobject
                                            
                                            	IPv4 sub\-object
                                            	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                            
                                            .. attribute:: ipv6_subobject
                                            
                                            	IPv6 sub\-object
                                            	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                            
                                            .. attribute:: lsp_subobject
                                            
                                            	P2P LSP sub\-object
                                            	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                            
                                            .. attribute:: srlg_subobject
                                            
                                            	SRLG sub\-object
                                            	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                            
                                            .. attribute:: type
                                            
                                            	Type
                                            	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                            
                                            .. attribute:: unnumbered_subobject
                                            
                                            	Unnumbered sub\-object
                                            	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                self.yang_name = "xro-subobject"
                                                self.yang_parent_name = "xro"

                                                self.type = YLeaf(YType.enumeration, "type")

                                                self.as_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                self.as_subobject.parent = self
                                                self._children_name_map["as_subobject"] = "as-subobject"
                                                self._children_yang_names.add("as-subobject")

                                                self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                self.ipv4_subobject.parent = self
                                                self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                self._children_yang_names.add("ipv4-subobject")

                                                self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                self.ipv6_subobject.parent = self
                                                self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                self._children_yang_names.add("ipv6-subobject")

                                                self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                self.lsp_subobject.parent = self
                                                self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                self._children_yang_names.add("lsp-subobject")

                                                self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                self.srlg_subobject.parent = self
                                                self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                self._children_yang_names.add("srlg-subobject")

                                                self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                self.unnumbered_subobject.parent = self
                                                self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                self._children_yang_names.add("unnumbered-subobject")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                            class Ipv4Subobject(Entity):
                                                """
                                                IPv4 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv4 address
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                    self.yang_name = "ipv4-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.address = YLeaf(YType.str, "address")

                                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("address",
                                                                    "attribute",
                                                                    "exclusion_type",
                                                                    "prefix_len") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.address.is_set or
                                                        self.attribute.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.prefix_len.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.address.yfilter != YFilter.not_set or
                                                        self.attribute.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.prefix_len.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "ipv4-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.address.get_name_leafdata())
                                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "address"):
                                                        self.address = value
                                                        self.address.value_namespace = name_space
                                                        self.address.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "attribute"):
                                                        self.attribute = value
                                                        self.attribute.value_namespace = name_space
                                                        self.attribute.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "prefix-len"):
                                                        self.prefix_len = value
                                                        self.prefix_len.value_namespace = name_space
                                                        self.prefix_len.value_namespace_prefix = name_space_prefix


                                            class Ipv6Subobject(Entity):
                                                """
                                                IPv6 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv6 address
                                                	**type**\:  str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                    self.yang_name = "ipv6-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.address = YLeaf(YType.str, "address")

                                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("address",
                                                                    "attribute",
                                                                    "exclusion_type",
                                                                    "prefix_len") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.address.is_set or
                                                        self.attribute.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.prefix_len.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.address.yfilter != YFilter.not_set or
                                                        self.attribute.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.prefix_len.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "ipv6-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.address.get_name_leafdata())
                                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "address"):
                                                        self.address = value
                                                        self.address.value_namespace = name_space
                                                        self.address.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "attribute"):
                                                        self.attribute = value
                                                        self.attribute.value_namespace = name_space
                                                        self.attribute.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "prefix-len"):
                                                        self.prefix_len = value
                                                        self.prefix_len.value_namespace = name_space
                                                        self.prefix_len.value_namespace_prefix = name_space_prefix


                                            class UnnumberedSubobject(Entity):
                                                """
                                                Unnumbered sub\-object
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: interface_id
                                                
                                                	Interface ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: te_router_id
                                                
                                                	TE router\-id
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                    self.yang_name = "unnumbered-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                                    self.te_router_id = YLeaf(YType.str, "te-router-id")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("attribute",
                                                                    "exclusion_type",
                                                                    "interface_id",
                                                                    "te_router_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.attribute.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.interface_id.is_set or
                                                        self.te_router_id.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.attribute.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.interface_id.yfilter != YFilter.not_set or
                                                        self.te_router_id.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "unnumbered-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.interface_id.get_name_leafdata())
                                                    if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "attribute"):
                                                        self.attribute = value
                                                        self.attribute.value_namespace = name_space
                                                        self.attribute.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "interface-id"):
                                                        self.interface_id = value
                                                        self.interface_id.value_namespace = name_space
                                                        self.interface_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "te-router-id"):
                                                        self.te_router_id = value
                                                        self.te_router_id.value_namespace = name_space
                                                        self.te_router_id.value_namespace_prefix = name_space_prefix


                                            class AsSubobject(Entity):
                                                """
                                                AS sub\-object
                                                
                                                .. attribute:: as_number
                                                
                                                	Autonomous System number
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                    self.yang_name = "as-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.as_number = YLeaf(YType.uint16, "as-number")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("as_number") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.as_number.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.as_number.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "as-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.as_number.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "as-number"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "as-number"):
                                                        self.as_number = value
                                                        self.as_number.value_namespace = name_space
                                                        self.as_number.value_namespace_prefix = name_space_prefix


                                            class SrlgSubobject(Entity):
                                                """
                                                SRLG sub\-object
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: srlg_id
                                                
                                                	SRLG ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                    self.yang_name = "srlg-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("exclusion_type",
                                                                    "srlg_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.exclusion_type.is_set or
                                                        self.srlg_id.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.srlg_id.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "srlg-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "exclusion-type" or name == "srlg-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "srlg-id"):
                                                        self.srlg_id = value
                                                        self.srlg_id.value_namespace = name_space
                                                        self.srlg_id.value_namespace_prefix = name_space_prefix


                                            class LspSubobject(Entity):
                                                """
                                                P2P LSP sub\-object
                                                
                                                .. attribute:: destination_node_exception
                                                
                                                	Destination\-node exception flag
                                                	**type**\:  bool
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: fec
                                                
                                                	LSP FEC
                                                	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                
                                                .. attribute:: ignore_lsp_id
                                                
                                                	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                	**type**\:  bool
                                                
                                                .. attribute:: penultimate_node_exception
                                                
                                                	Penultimate\-node exception flag
                                                	**type**\:  bool
                                                
                                                .. attribute:: processing_node_exception
                                                
                                                	Processing\-node exception flag
                                                	**type**\:  bool
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                    self.yang_name = "lsp-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                                    self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                                    self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                                    self.fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                    self.fec.parent = self
                                                    self._children_name_map["fec"] = "fec"
                                                    self._children_yang_names.add("fec")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("destination_node_exception",
                                                                    "exclusion_type",
                                                                    "ignore_lsp_id",
                                                                    "penultimate_node_exception",
                                                                    "processing_node_exception") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                                class Fec(Entity):
                                                    """
                                                    LSP FEC
                                                    
                                                    .. attribute:: fec_destination_info
                                                    
                                                    	Destination or P2MP ID
                                                    	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                    
                                                    .. attribute:: fec_extended_tunnel_id
                                                    
                                                    	Extended tunnel ID
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: fec_lsp_id
                                                    
                                                    	LSP ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: fec_source
                                                    
                                                    	Tunnel source address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: fec_tunnel_id
                                                    
                                                    	Tunnel ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: fec_vrf
                                                    
                                                    	VRF; currently only for GMPLS tunnels
                                                    	**type**\:  str
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                        self.yang_name = "fec"
                                                        self.yang_parent_name = "lsp-subobject"

                                                        self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                        self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                        self.fec_source = YLeaf(YType.str, "fec-source")

                                                        self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                        self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                        self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                        self.fec_destination_info.parent = self
                                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                        self._children_yang_names.add("fec-destination-info")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("fec_extended_tunnel_id",
                                                                        "fec_lsp_id",
                                                                        "fec_source",
                                                                        "fec_tunnel_id",
                                                                        "fec_vrf") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                                    class FecDestinationInfo(Entity):
                                                        """
                                                        Destination or P2MP ID
                                                        
                                                        .. attribute:: fec_ctype
                                                        
                                                        	FEC CType
                                                        	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                        
                                                        .. attribute:: fec_destination_p2mp_id
                                                        
                                                        	P2MP ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: p2p_lsp_destination
                                                        
                                                        	P2P LSP destination
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                            self.yang_name = "fec-destination-info"
                                                            self.yang_parent_name = "fec"

                                                            self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                            self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                            self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("fec_ctype",
                                                                            "fec_destination_p2mp_id",
                                                                            "p2p_lsp_destination") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.fec_ctype.is_set or
                                                                self.fec_destination_p2mp_id.is_set or
                                                                self.p2p_lsp_destination.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.fec_ctype.yfilter != YFilter.not_set or
                                                                self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                                self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "fec-destination-info" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                            if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                            if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "fec-ctype"):
                                                                self.fec_ctype = value
                                                                self.fec_ctype.value_namespace = name_space
                                                                self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-destination-p2mp-id"):
                                                                self.fec_destination_p2mp_id = value
                                                                self.fec_destination_p2mp_id.value_namespace = name_space
                                                                self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "p2p-lsp-destination"):
                                                                self.p2p_lsp_destination = value
                                                                self.p2p_lsp_destination.value_namespace = name_space
                                                                self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.fec_extended_tunnel_id.is_set or
                                                            self.fec_lsp_id.is_set or
                                                            self.fec_source.is_set or
                                                            self.fec_tunnel_id.is_set or
                                                            self.fec_vrf.is_set or
                                                            (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                            self.fec_lsp_id.yfilter != YFilter.not_set or
                                                            self.fec_source.yfilter != YFilter.not_set or
                                                            self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                            self.fec_vrf.yfilter != YFilter.not_set or
                                                            (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "fec" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                        if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                        if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                        if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                        if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "fec-destination-info"):
                                                            if (self.fec_destination_info is None):
                                                                self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                                self.fec_destination_info.parent = self
                                                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            return self.fec_destination_info

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "fec-extended-tunnel-id"):
                                                            self.fec_extended_tunnel_id = value
                                                            self.fec_extended_tunnel_id.value_namespace = name_space
                                                            self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-lsp-id"):
                                                            self.fec_lsp_id = value
                                                            self.fec_lsp_id.value_namespace = name_space
                                                            self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-source"):
                                                            self.fec_source = value
                                                            self.fec_source.value_namespace = name_space
                                                            self.fec_source.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-tunnel-id"):
                                                            self.fec_tunnel_id = value
                                                            self.fec_tunnel_id.value_namespace = name_space
                                                            self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-vrf"):
                                                            self.fec_vrf = value
                                                            self.fec_vrf.value_namespace = name_space
                                                            self.fec_vrf.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.destination_node_exception.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.ignore_lsp_id.is_set or
                                                        self.penultimate_node_exception.is_set or
                                                        self.processing_node_exception.is_set or
                                                        (self.fec is not None and self.fec.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.destination_node_exception.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                        self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                        self.processing_node_exception.yfilter != YFilter.not_set or
                                                        (self.fec is not None and self.fec.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsp-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                                    if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                                    if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "fec"):
                                                        if (self.fec is None):
                                                            self.fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                            self.fec.parent = self
                                                            self._children_name_map["fec"] = "fec"
                                                        return self.fec

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "destination-node-exception"):
                                                        self.destination_node_exception = value
                                                        self.destination_node_exception.value_namespace = name_space
                                                        self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ignore-lsp-id"):
                                                        self.ignore_lsp_id = value
                                                        self.ignore_lsp_id.value_namespace = name_space
                                                        self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "penultimate-node-exception"):
                                                        self.penultimate_node_exception = value
                                                        self.penultimate_node_exception.value_namespace = name_space
                                                        self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "processing-node-exception"):
                                                        self.processing_node_exception = value
                                                        self.processing_node_exception.value_namespace = name_space
                                                        self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.type.is_set or
                                                    (self.as_subobject is not None and self.as_subobject.has_data()) or
                                                    (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                                    (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                                    (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                                    (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                                    (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.type.yfilter != YFilter.not_set or
                                                    (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                                    (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                                    (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                                    (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                                    (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                                    (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "xro-subobject" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "as-subobject"):
                                                    if (self.as_subobject is None):
                                                        self.as_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                        self.as_subobject.parent = self
                                                        self._children_name_map["as_subobject"] = "as-subobject"
                                                    return self.as_subobject

                                                if (child_yang_name == "ipv4-subobject"):
                                                    if (self.ipv4_subobject is None):
                                                        self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                        self.ipv4_subobject.parent = self
                                                        self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                    return self.ipv4_subobject

                                                if (child_yang_name == "ipv6-subobject"):
                                                    if (self.ipv6_subobject is None):
                                                        self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                        self.ipv6_subobject.parent = self
                                                        self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                    return self.ipv6_subobject

                                                if (child_yang_name == "lsp-subobject"):
                                                    if (self.lsp_subobject is None):
                                                        self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                        self.lsp_subobject.parent = self
                                                        self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    return self.lsp_subobject

                                                if (child_yang_name == "srlg-subobject"):
                                                    if (self.srlg_subobject is None):
                                                        self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                        self.srlg_subobject.parent = self
                                                        self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                    return self.srlg_subobject

                                                if (child_yang_name == "unnumbered-subobject"):
                                                    if (self.unnumbered_subobject is None):
                                                        self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                        self.unnumbered_subobject.parent = self
                                                        self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                    return self.unnumbered_subobject

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "type"):
                                                    self.type = value
                                                    self.type.value_namespace = name_space
                                                    self.type.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.xro_subobject:
                                                if (c.has_data()):
                                                    return True
                                            return self.mutual_diversity_flag.is_set

                                        def has_operation(self):
                                            for c in self.xro_subobject:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "xro" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "xro-subobject"):
                                                for c in self.xro_subobject:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.xro_subobject.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "mutual-diversity-flag"):
                                                self.mutual_diversity_flag = value
                                                self.mutual_diversity_flag.value_namespace = name_space
                                                self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (self.xro is not None and self.xro.has_data())

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.xro is not None and self.xro.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-xro" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "xro"):
                                            if (self.xro is None):
                                                self.xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                                self.xro.parent = self
                                                self._children_name_map["xro"] = "xro"
                                            return self.xro

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "xro"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass


                                class AttributeSetP2Mpte(Entity):
                                    """
                                    MPLS TE P2MP\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\:  bool
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\:  bool
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                        self.yang_name = "attribute-set-p2mpte"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                        self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                        self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                        self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                        self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                        self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                        self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                        self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("configured_bandwidth",
                                                        "dste_class_type",
                                                        "fast_reroute",
                                                        "frr_bandwidth_protection",
                                                        "hold_priority",
                                                        "is_affinity_configured",
                                                        "is_bandwidth_configured",
                                                        "is_priority_configured",
                                                        "setup_priority") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2mpte"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2mpte"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.configured_bandwidth.is_set or
                                            self.dste_class_type.is_set or
                                            self.fast_reroute.is_set or
                                            self.frr_bandwidth_protection.is_set or
                                            self.hold_priority.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_bandwidth_configured.is_set or
                                            self.is_priority_configured.is_set or
                                            self.setup_priority.is_set or
                                            (self.affinity is not None and self.affinity.has_data()))

                                    def has_operation(self):
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.configured_bandwidth.yfilter != YFilter.not_set or
                                            self.dste_class_type.yfilter != YFilter.not_set or
                                            self.fast_reroute.yfilter != YFilter.not_set or
                                            self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                            self.hold_priority.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                            self.is_priority_configured.yfilter != YFilter.not_set or
                                            self.setup_priority.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-p2mpte" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                        if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                        if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                        if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                        if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                        if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                        if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "configured-bandwidth"):
                                            self.configured_bandwidth = value
                                            self.configured_bandwidth.value_namespace = name_space
                                            self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dste-class-type"):
                                            self.dste_class_type = value
                                            self.dste_class_type.value_namespace = name_space
                                            self.dste_class_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "fast-reroute"):
                                            self.fast_reroute = value
                                            self.fast_reroute.value_namespace = name_space
                                            self.fast_reroute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "frr-bandwidth-protection"):
                                            self.frr_bandwidth_protection = value
                                            self.frr_bandwidth_protection.value_namespace = name_space
                                            self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "hold-priority"):
                                            self.hold_priority = value
                                            self.hold_priority.value_namespace = name_space
                                            self.hold_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bandwidth-configured"):
                                            self.is_bandwidth_configured = value
                                            self.is_bandwidth_configured.value_namespace = name_space
                                            self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-priority-configured"):
                                            self.is_priority_configured = value
                                            self.is_priority_configured.value_namespace = name_space
                                            self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "setup-priority"):
                                            self.setup_priority = value
                                            self.setup_priority.value_namespace = name_space
                                            self.setup_priority.value_namespace_prefix = name_space_prefix


                                class AttributeSetApsPp(Entity):
                                    """
                                    Attribute Set OTN APS Path Protection
                                    
                                    .. attribute:: hold_off_time
                                    
                                    	Hold\-off time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path Protection Profile Type
                                    	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    .. attribute:: protection_mode
                                    
                                    	Protection Restoration Mode
                                    	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                    
                                    .. attribute:: protection_type
                                    
                                    	Protection Type
                                    	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    .. attribute:: restoration_style
                                    
                                    	Restoration Style
                                    	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                    
                                    .. attribute:: revert_schedule
                                    
                                    	Revert Schedule
                                    	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                    
                                    .. attribute:: snc_mode
                                    
                                    	Sub\-network Connection Mode
                                    	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    .. attribute:: tcm_id
                                    
                                    	Sub\-network Connection Monitoring Mode
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: wait_to_restore_time
                                    
                                    	Wait to restore time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                        self.yang_name = "attribute-set-aps-pp"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                        self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                        self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                        self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                        self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                        self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                        self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                        self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                        self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                        self.revert_schedule.parent = self
                                        self._children_name_map["revert_schedule"] = "revert-schedule"
                                        self._children_yang_names.add("revert-schedule")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("hold_off_time",
                                                        "path_prot_profile_type",
                                                        "protection_mode",
                                                        "protection_type",
                                                        "restoration_style",
                                                        "snc_mode",
                                                        "tcm_id",
                                                        "wait_to_restore_time") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                                    class RevertSchedule(Entity):
                                        """
                                        Revert Schedule
                                        
                                        .. attribute:: duration
                                        
                                        	Duration for scheduled reversion
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: max_tries
                                        
                                        	Max tries for scheduled reversion
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: schedule_date
                                        
                                        	Schedule time for reversion
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: schedule_frequency
                                        
                                        	Schedule frequency for reversion
                                        	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                        
                                        .. attribute:: schedulename
                                        
                                        	Schedule name identifier
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                            self.yang_name = "revert-schedule"
                                            self.yang_parent_name = "attribute-set-aps-pp"

                                            self.duration = YLeaf(YType.uint32, "duration")

                                            self.max_tries = YLeaf(YType.uint32, "max-tries")

                                            self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                            self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                            self.schedulename = YLeaf(YType.str, "schedulename")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("duration",
                                                            "max_tries",
                                                            "schedule_date",
                                                            "schedule_frequency",
                                                            "schedulename") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.duration.is_set or
                                                self.max_tries.is_set or
                                                self.schedule_date.is_set or
                                                self.schedule_frequency.is_set or
                                                self.schedulename.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.duration.yfilter != YFilter.not_set or
                                                self.max_tries.yfilter != YFilter.not_set or
                                                self.schedule_date.yfilter != YFilter.not_set or
                                                self.schedule_frequency.yfilter != YFilter.not_set or
                                                self.schedulename.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "revert-schedule" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.duration.get_name_leafdata())
                                            if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.max_tries.get_name_leafdata())
                                            if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                            if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                            if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.schedulename.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "duration"):
                                                self.duration = value
                                                self.duration.value_namespace = name_space
                                                self.duration.value_namespace_prefix = name_space_prefix
                                            if(value_path == "max-tries"):
                                                self.max_tries = value
                                                self.max_tries.value_namespace = name_space
                                                self.max_tries.value_namespace_prefix = name_space_prefix
                                            if(value_path == "schedule-date"):
                                                self.schedule_date = value
                                                self.schedule_date.value_namespace = name_space
                                                self.schedule_date.value_namespace_prefix = name_space_prefix
                                            if(value_path == "schedule-frequency"):
                                                self.schedule_frequency = value
                                                self.schedule_frequency.value_namespace = name_space
                                                self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                            if(value_path == "schedulename"):
                                                self.schedulename = value
                                                self.schedulename.value_namespace = name_space
                                                self.schedulename.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.hold_off_time.is_set or
                                            self.path_prot_profile_type.is_set or
                                            self.protection_mode.is_set or
                                            self.protection_type.is_set or
                                            self.restoration_style.is_set or
                                            self.snc_mode.is_set or
                                            self.tcm_id.is_set or
                                            self.wait_to_restore_time.is_set or
                                            (self.revert_schedule is not None and self.revert_schedule.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.hold_off_time.yfilter != YFilter.not_set or
                                            self.path_prot_profile_type.yfilter != YFilter.not_set or
                                            self.protection_mode.yfilter != YFilter.not_set or
                                            self.protection_type.yfilter != YFilter.not_set or
                                            self.restoration_style.yfilter != YFilter.not_set or
                                            self.snc_mode.yfilter != YFilter.not_set or
                                            self.tcm_id.yfilter != YFilter.not_set or
                                            self.wait_to_restore_time.yfilter != YFilter.not_set or
                                            (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-aps-pp" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                        if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                        if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                        if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.protection_type.get_name_leafdata())
                                        if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                        if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                        if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                        if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "revert-schedule"):
                                            if (self.revert_schedule is None):
                                                self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                                self.revert_schedule.parent = self
                                                self._children_name_map["revert_schedule"] = "revert-schedule"
                                            return self.revert_schedule

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "hold-off-time"):
                                            self.hold_off_time = value
                                            self.hold_off_time.value_namespace = name_space
                                            self.hold_off_time.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-prot-profile-type"):
                                            self.path_prot_profile_type = value
                                            self.path_prot_profile_type.value_namespace = name_space
                                            self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "protection-mode"):
                                            self.protection_mode = value
                                            self.protection_mode.value_namespace = name_space
                                            self.protection_mode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "protection-type"):
                                            self.protection_type = value
                                            self.protection_type.value_namespace = name_space
                                            self.protection_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "restoration-style"):
                                            self.restoration_style = value
                                            self.restoration_style.value_namespace = name_space
                                            self.restoration_style.value_namespace_prefix = name_space_prefix
                                        if(value_path == "snc-mode"):
                                            self.snc_mode = value
                                            self.snc_mode.value_namespace = name_space
                                            self.snc_mode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcm-id"):
                                            self.tcm_id = value
                                            self.tcm_id.value_namespace = name_space
                                            self.tcm_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "wait-to-restore-time"):
                                            self.wait_to_restore_time = value
                                            self.wait_to_restore_time.value_namespace = name_space
                                            self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                                class AttributeSetP2PTe(Entity):
                                    """
                                    MPLS TE P2P\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is Path Invalidation action configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is Path Invalidation timeout configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_select_configured
                                    
                                    	Is any of the path selection parameters configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_metric_configured
                                    
                                    	Is path selection metric configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                    
                                    	Is path selection segment routing configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_configured
                                    
                                    	Is path selection margin configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_relative
                                    
                                    	Path selection margin is\_relative
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                    
                                    	Is path selection segment limit configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_prepend_list_configured
                                    
                                    	Is SR prepend list configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation timeout on the tunnel path
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_selection_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                    
                                    .. attribute:: path_selection_metric
                                    
                                    	Path selection metric type
                                    	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                    
                                    .. attribute:: path_selection_segment_routing_adjacency_protection
                                    
                                    	Path selection segment\-routing type
                                    	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                                    
                                    .. attribute:: path_selection_segment_routing_margin
                                    
                                    	Path selection margin
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_selection_segment_routing_segment_limit
                                    
                                    	Is path selection segment limit configured
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    .. attribute:: prepend_list
                                    
                                    	SR prepend list
                                    	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                        self.yang_name = "attribute-set-p2p-te"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                        self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                        self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                        self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                        self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                        self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                        self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                        self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                        self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                        self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                        self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                        self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                        self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                        self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                        self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                        self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                        self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                        self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                        self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                        self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                        self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                        self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                        self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                        self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                        self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                        self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                        self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"
                                        self._children_yang_names.add("logging")

                                        self.prepend_list = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                        self.prepend_list.parent = self
                                        self._children_name_map["prepend_list"] = "prepend-list"
                                        self._children_yang_names.add("prepend-list")

                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_affinity_configured",
                                                        "is_path_invalidation_action_configured",
                                                        "is_path_invalidation_timeout_configured",
                                                        "is_path_select_configured",
                                                        "is_path_selection_metric_configured",
                                                        "is_path_selection_segment_routing_adjacency_protection_configured",
                                                        "is_path_selection_segment_routing_margin_configured",
                                                        "is_path_selection_segment_routing_margin_relative",
                                                        "is_path_selection_segment_routing_segment_limit_configured",
                                                        "is_pce_configured",
                                                        "is_pce_disj_group_id_configured",
                                                        "is_pce_disj_source_configured",
                                                        "is_pce_disj_type_configured",
                                                        "is_pceb_dj_source_configured",
                                                        "is_pcebd_group_id_configured",
                                                        "is_prepend_list_configured",
                                                        "path_invalidation_timeout",
                                                        "path_selection_invalidation_action",
                                                        "path_selection_metric",
                                                        "path_selection_segment_routing_adjacency_protection",
                                                        "path_selection_segment_routing_margin",
                                                        "path_selection_segment_routing_segment_limit",
                                                        "pcebd_group_id",
                                                        "pcebd_source_address",
                                                        "pcedp_group_id",
                                                        "pcedp_source_address",
                                                        "pcedp_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class Logging(Entity):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                            self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                            self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                            self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                            self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                            self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                            self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                            self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("all_logging_enabled",
                                                            "lsp_bandwidth_change",
                                                            "lsp_insufficient_bw",
                                                            "lsp_pcalc_failure_logging_enabled",
                                                            "lsp_re_opt",
                                                            "lsp_re_route",
                                                            "lsp_state",
                                                            "s2l_state") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.all_logging_enabled.is_set or
                                                self.lsp_bandwidth_change.is_set or
                                                self.lsp_insufficient_bw.is_set or
                                                self.lsp_pcalc_failure_logging_enabled.is_set or
                                                self.lsp_re_opt.is_set or
                                                self.lsp_re_route.is_set or
                                                self.lsp_state.is_set or
                                                self.s2l_state.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.all_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_re_opt.yfilter != YFilter.not_set or
                                                self.lsp_re_route.yfilter != YFilter.not_set or
                                                self.lsp_state.yfilter != YFilter.not_set or
                                                self.s2l_state.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "logging" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                            if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                            if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                            if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                            if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                            if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                            if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                            if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "all-logging-enabled"):
                                                self.all_logging_enabled = value
                                                self.all_logging_enabled.value_namespace = name_space
                                                self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-bandwidth-change"):
                                                self.lsp_bandwidth_change = value
                                                self.lsp_bandwidth_change.value_namespace = name_space
                                                self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-insufficient-bw"):
                                                self.lsp_insufficient_bw = value
                                                self.lsp_insufficient_bw.value_namespace = name_space
                                                self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                self.lsp_pcalc_failure_logging_enabled = value
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-opt"):
                                                self.lsp_re_opt = value
                                                self.lsp_re_opt.value_namespace = name_space
                                                self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-route"):
                                                self.lsp_re_route = value
                                                self.lsp_re_route.value_namespace = name_space
                                                self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-state"):
                                                self.lsp_state = value
                                                self.lsp_state.value_namespace = name_space
                                                self.lsp_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "s2l-state"):
                                                self.s2l_state = value
                                                self.s2l_state.value_namespace = name_space
                                                self.s2l_state.value_namespace_prefix = name_space_prefix


                                    class PrependList(Entity):
                                        """
                                        SR prepend list
                                        
                                        .. attribute:: prepend_entry
                                        
                                        	List of prepend entries
                                        	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                            self.yang_name = "prepend-list"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.prepend_entry = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in () and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                        class PrependEntry(Entity):
                                            """
                                            List of prepend entries
                                            
                                            .. attribute:: index
                                            
                                            	Prepend index
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: next_label
                                            
                                            	Prepend next label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: type
                                            
                                            	Prepend Type
                                            	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                                self.yang_name = "prepend-entry"
                                                self.yang_parent_name = "prepend-list"

                                                self.index = YLeaf(YType.uint32, "index")

                                                self.next_label = YLeaf(YType.uint32, "next-label")

                                                self.type = YLeaf(YType.enumeration, "type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("index",
                                                                "next_label",
                                                                "type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.index.is_set or
                                                    self.next_label.is_set or
                                                    self.type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.index.yfilter != YFilter.not_set or
                                                    self.next_label.yfilter != YFilter.not_set or
                                                    self.type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prepend-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.index.get_name_leafdata())
                                                if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.next_label.get_name_leafdata())
                                                if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "index" or name == "next-label" or name == "type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "index"):
                                                    self.index = value
                                                    self.index.value_namespace = name_space
                                                    self.index.value_namespace_prefix = name_space_prefix
                                                if(value_path == "next-label"):
                                                    self.next_label = value
                                                    self.next_label.value_namespace = name_space
                                                    self.next_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "type"):
                                                    self.type = value
                                                    self.type.value_namespace = name_space
                                                    self.type.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.prepend_entry:
                                                if (c.has_data()):
                                                    return True
                                            return False

                                        def has_operation(self):
                                            for c in self.prepend_entry:
                                                if (c.has_operation()):
                                                    return True
                                            return self.yfilter != YFilter.not_set

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "prepend-list" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "prepend-entry"):
                                                for c in self.prepend_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.prepend_entry.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "prepend-entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.is_affinity_configured.is_set or
                                            self.is_path_invalidation_action_configured.is_set or
                                            self.is_path_invalidation_timeout_configured.is_set or
                                            self.is_path_select_configured.is_set or
                                            self.is_path_selection_metric_configured.is_set or
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                            self.is_path_selection_segment_routing_margin_configured.is_set or
                                            self.is_path_selection_segment_routing_margin_relative.is_set or
                                            self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                            self.is_pce_configured.is_set or
                                            self.is_pce_disj_group_id_configured.is_set or
                                            self.is_pce_disj_source_configured.is_set or
                                            self.is_pce_disj_type_configured.is_set or
                                            self.is_pceb_dj_source_configured.is_set or
                                            self.is_pcebd_group_id_configured.is_set or
                                            self.is_prepend_list_configured.is_set or
                                            self.path_invalidation_timeout.is_set or
                                            self.path_selection_invalidation_action.is_set or
                                            self.path_selection_metric.is_set or
                                            self.path_selection_segment_routing_adjacency_protection.is_set or
                                            self.path_selection_segment_routing_margin.is_set or
                                            self.path_selection_segment_routing_segment_limit.is_set or
                                            self.pcebd_group_id.is_set or
                                            self.pcebd_source_address.is_set or
                                            self.pcedp_group_id.is_set or
                                            self.pcedp_source_address.is_set or
                                            self.pcedp_type.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.logging is not None and self.logging.has_data()) or
                                            (self.prepend_list is not None and self.prepend_list.has_data()))

                                    def has_operation(self):
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                            self.is_path_select_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                            self.is_pce_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                            self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                            self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                            self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                            self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                            self.path_selection_metric.yfilter != YFilter.not_set or
                                            self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                            self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                            self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                            self.pcebd_group_id.yfilter != YFilter.not_set or
                                            self.pcebd_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_group_id.yfilter != YFilter.not_set or
                                            self.pcedp_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_type.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.logging is not None and self.logging.has_operation()) or
                                            (self.prepend_list is not None and self.prepend_list.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-p2p-te" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                        if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                        if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                        if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                        if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                        if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                        if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                        if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                        if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                        if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                        if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                        if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                        if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                        if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                        if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                        if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                        if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                        if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                        if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                        if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                        if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "logging"):
                                            if (self.logging is None):
                                                self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                                self.logging.parent = self
                                                self._children_name_map["logging"] = "logging"
                                            return self.logging

                                        if (child_yang_name == "prepend-list"):
                                            if (self.prepend_list is None):
                                                self.prepend_list = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                                self.prepend_list.parent = self
                                                self._children_name_map["prepend_list"] = "prepend-list"
                                            return self.prepend_list

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-action-configured"):
                                            self.is_path_invalidation_action_configured = value
                                            self.is_path_invalidation_action_configured.value_namespace = name_space
                                            self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-timeout-configured"):
                                            self.is_path_invalidation_timeout_configured = value
                                            self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                            self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-select-configured"):
                                            self.is_path_select_configured = value
                                            self.is_path_select_configured.value_namespace = name_space
                                            self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-metric-configured"):
                                            self.is_path_selection_metric_configured = value
                                            self.is_path_selection_metric_configured.value_namespace = name_space
                                            self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                            self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                            self.is_path_selection_segment_routing_margin_configured = value
                                            self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                            self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                            self.is_path_selection_segment_routing_margin_relative = value
                                            self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                            self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                            self.is_path_selection_segment_routing_segment_limit_configured = value
                                            self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                            self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-configured"):
                                            self.is_pce_configured = value
                                            self.is_pce_configured.value_namespace = name_space
                                            self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-group-id-configured"):
                                            self.is_pce_disj_group_id_configured = value
                                            self.is_pce_disj_group_id_configured.value_namespace = name_space
                                            self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-source-configured"):
                                            self.is_pce_disj_source_configured = value
                                            self.is_pce_disj_source_configured.value_namespace = name_space
                                            self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-type-configured"):
                                            self.is_pce_disj_type_configured = value
                                            self.is_pce_disj_type_configured.value_namespace = name_space
                                            self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pceb-dj-source-configured"):
                                            self.is_pceb_dj_source_configured = value
                                            self.is_pceb_dj_source_configured.value_namespace = name_space
                                            self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pcebd-group-id-configured"):
                                            self.is_pcebd_group_id_configured = value
                                            self.is_pcebd_group_id_configured.value_namespace = name_space
                                            self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-prepend-list-configured"):
                                            self.is_prepend_list_configured = value
                                            self.is_prepend_list_configured.value_namespace = name_space
                                            self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-invalidation-timeout"):
                                            self.path_invalidation_timeout = value
                                            self.path_invalidation_timeout.value_namespace = name_space
                                            self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-invalidation-action"):
                                            self.path_selection_invalidation_action = value
                                            self.path_selection_invalidation_action.value_namespace = name_space
                                            self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-metric"):
                                            self.path_selection_metric = value
                                            self.path_selection_metric.value_namespace = name_space
                                            self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                            self.path_selection_segment_routing_adjacency_protection = value
                                            self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                            self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-segment-routing-margin"):
                                            self.path_selection_segment_routing_margin = value
                                            self.path_selection_segment_routing_margin.value_namespace = name_space
                                            self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-segment-routing-segment-limit"):
                                            self.path_selection_segment_routing_segment_limit = value
                                            self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                            self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-group-id"):
                                            self.pcebd_group_id = value
                                            self.pcebd_group_id.value_namespace = name_space
                                            self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-source-address"):
                                            self.pcebd_source_address = value
                                            self.pcebd_source_address.value_namespace = name_space
                                            self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-group-id"):
                                            self.pcedp_group_id = value
                                            self.pcedp_group_id.value_namespace = name_space
                                            self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-source-address"):
                                            self.pcedp_source_address = value
                                            self.pcedp_source_address.value_namespace = name_space
                                            self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-type"):
                                            self.pcedp_type = value
                                            self.pcedp_type.value_namespace = name_space
                                            self.pcedp_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.tunnel_attribute_set_type.is_set or
                                        (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                        (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                        (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                        (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                        (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                        (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                        (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                        (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                        (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                        (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                        (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                        (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                        (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                        (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "attribute-set-union" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "attribute-set-aps-pp"):
                                        if (self.attribute_set_aps_pp is None):
                                            self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                            self.attribute_set_aps_pp.parent = self
                                            self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                        return self.attribute_set_aps_pp

                                    if (child_yang_name == "attribute-set-autobackup"):
                                        if (self.attribute_set_autobackup is None):
                                            self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                            self.attribute_set_autobackup.parent = self
                                            self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                        return self.attribute_set_autobackup

                                    if (child_yang_name == "attribute-set-automesh"):
                                        if (self.attribute_set_automesh is None):
                                            self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                            self.attribute_set_automesh.parent = self
                                            self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                        return self.attribute_set_automesh

                                    if (child_yang_name == "attribute-set-p2mpte"):
                                        if (self.attribute_set_p2mpte is None):
                                            self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                            self.attribute_set_p2mpte.parent = self
                                            self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                        return self.attribute_set_p2mpte

                                    if (child_yang_name == "attribute-set-p2p-te"):
                                        if (self.attribute_set_p2p_te is None):
                                            self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                            self.attribute_set_p2p_te.parent = self
                                            self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        return self.attribute_set_p2p_te

                                    if (child_yang_name == "attribute-set-path-option"):
                                        if (self.attribute_set_path_option is None):
                                            self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                            self.attribute_set_path_option.parent = self
                                            self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                        return self.attribute_set_path_option

                                    if (child_yang_name == "attribute-set-xro"):
                                        if (self.attribute_set_xro is None):
                                            self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion.AttributeSetXro()
                                            self.attribute_set_xro.parent = self
                                            self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                        return self.attribute_set_xro

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "tunnel-attribute-set-type"):
                                        self.tunnel_attribute_set_type = value
                                        self.tunnel_attribute_set_type.value_namespace = name_space
                                        self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.tunnel_attribute_set_name.is_set or
                                    self.tunnel_attribute_set_name_crc32.is_set or
                                    (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                                    self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                                    (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "attribute-set" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                                if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "attribute-set-union"):
                                    if (self.attribute_set_union is None):
                                        self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet.AttributeSetUnion()
                                        self.attribute_set_union.parent = self
                                        self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    return self.attribute_set_union

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "tunnel-attribute-set-name"):
                                    self.tunnel_attribute_set_name = value
                                    self.tunnel_attribute_set_name.value_namespace = name_space
                                    self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-attribute-set-name-crc32"):
                                    self.tunnel_attribute_set_name_crc32 = value
                                    self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                                    self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                        class XroAttributeSet(Entity):
                            """
                            The XRO attribute set used by this path\-option
                            
                            .. attribute:: attribute_set_union
                            
                            	Union of Attribute Sets
                            	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion>`
                            
                            .. attribute:: tunnel_attribute_set_name
                            
                            	Attribute Set Name
                            	**type**\:  str
                            
                            .. attribute:: tunnel_attribute_set_name_crc32
                            
                            	Attribute Set name CRC32 value
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet, self).__init__()

                                self.yang_name = "xro-attribute-set"
                                self.yang_parent_name = "path-option"

                                self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                                self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                                self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion()
                                self.attribute_set_union.parent = self
                                self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                self._children_yang_names.add("attribute-set-union")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("tunnel_attribute_set_name",
                                                "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet, self).__setattr__(name, value)


                            class AttributeSetUnion(Entity):
                                """
                                Union of Attribute Sets
                                
                                .. attribute:: attribute_set_aps_pp
                                
                                	Attribute Set OTN APS Path Protection
                                	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                                
                                .. attribute:: attribute_set_autobackup
                                
                                	MPLS TE Auto\-backup Attribute Set
                                	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                                
                                .. attribute:: attribute_set_automesh
                                
                                	MPLS TE Auto\-mesh Attribute Set
                                	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                                
                                .. attribute:: attribute_set_p2mpte
                                
                                	MPLS TE P2MP\-TE Attribute Set
                                	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                                
                                .. attribute:: attribute_set_p2p_te
                                
                                	MPLS TE P2P\-TE Attribute Set
                                	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                                
                                .. attribute:: attribute_set_path_option
                                
                                	MPLS TE Path Option Attribute Set
                                	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                                
                                .. attribute:: attribute_set_xro
                                
                                	Attribute Set XRO
                                	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro>`
                                
                                .. attribute:: tunnel_attribute_set_type
                                
                                	TunnelAttributeSetType
                                	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion, self).__init__()

                                    self.yang_name = "attribute-set-union"
                                    self.yang_parent_name = "xro-attribute-set"

                                    self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                                    self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                    self.attribute_set_aps_pp.parent = self
                                    self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                    self._children_yang_names.add("attribute-set-aps-pp")

                                    self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                    self.attribute_set_autobackup.parent = self
                                    self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                    self._children_yang_names.add("attribute-set-autobackup")

                                    self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                    self.attribute_set_automesh.parent = self
                                    self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                    self._children_yang_names.add("attribute-set-automesh")

                                    self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                    self.attribute_set_p2mpte.parent = self
                                    self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                    self._children_yang_names.add("attribute-set-p2mpte")

                                    self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                    self.attribute_set_p2p_te.parent = self
                                    self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                    self._children_yang_names.add("attribute-set-p2p-te")

                                    self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                    self.attribute_set_path_option.parent = self
                                    self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                    self._children_yang_names.add("attribute-set-path-option")

                                    self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                    self.attribute_set_xro.parent = self
                                    self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                    self._children_yang_names.add("attribute-set-xro")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                                class AttributeSetPathOption(Entity):
                                    """
                                    MPLS TE Path Option Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                                    
                                    .. attribute:: bandwidth_type
                                    
                                    	The bandwidth type
                                    	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                                    
                                    .. attribute:: bfd_reverse_path
                                    
                                    	BFD reverse path
                                    	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: cost_limit
                                    
                                    	Cost limit on the tunnel path
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: exclude_list_name
                                    
                                    	Exclude list name
                                    	**type**\:  str
                                    
                                    .. attribute:: generation
                                    
                                    	Generation
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bfd_reverse_pat_configured
                                    
                                    	Is BFD reverse path configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_cost_limit_configured
                                    
                                    	Is Cost Limit configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_exclude_list_name_configured
                                    
                                    	Is exclude list name configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is path invalidation action configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is path invalidation timeout configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: path_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation interval on the tunnel path
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                                    
                                    .. attribute:: version_info
                                    
                                    	Version Info
                                    	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                                        self.yang_name = "attribute-set-path-option"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                                        self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                        self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                                        self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                        self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                                        self.generation = YLeaf(YType.uint32, "generation")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                        self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                                        self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                                        self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                                        self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                        self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                        self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                        self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                        self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                        self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                        self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                        self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                        self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                                        self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                        self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                        self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                        self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                        self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                        self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                        self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                        self.bfd_reverse_path.parent = self
                                        self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                        self._children_yang_names.add("bfd-reverse-path")

                                        self.tunnel_id = YList(self)
                                        self.version_info = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("bandwidth_type",
                                                        "configured_bandwidth",
                                                        "cost_limit",
                                                        "dste_class_type",
                                                        "exclude_list_name",
                                                        "generation",
                                                        "is_affinity_configured",
                                                        "is_bandwidth_configured",
                                                        "is_bfd_reverse_pat_configured",
                                                        "is_cost_limit_configured",
                                                        "is_exclude_list_name_configured",
                                                        "is_path_invalidation_action_configured",
                                                        "is_path_invalidation_timeout_configured",
                                                        "is_pce_configured",
                                                        "is_pce_disj_group_id_configured",
                                                        "is_pce_disj_source_configured",
                                                        "is_pce_disj_type_configured",
                                                        "is_pceb_dj_source_configured",
                                                        "is_pcebd_group_id_configured",
                                                        "path_invalidation_action",
                                                        "path_invalidation_timeout",
                                                        "pcebd_group_id",
                                                        "pcebd_source_address",
                                                        "pcedp_group_id",
                                                        "pcedp_source_address",
                                                        "pcedp_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class BfdReversePath(Entity):
                                        """
                                        BFD reverse path
                                        
                                        .. attribute:: binding_label
                                        
                                        	BFD reverse path binding label
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: path_type
                                        
                                        	BFD reverse path type
                                        	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                                            self.yang_name = "bfd-reverse-path"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.binding_label = YLeaf(YType.uint32, "binding-label")

                                            self.path_type = YLeaf(YType.enumeration, "path-type")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("binding_label",
                                                            "path_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.binding_label.is_set or
                                                self.path_type.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.binding_label.yfilter != YFilter.not_set or
                                                self.path_type.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "bfd-reverse-path" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.binding_label.get_name_leafdata())
                                            if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.path_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "binding-label" or name == "path-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "binding-label"):
                                                self.binding_label = value
                                                self.binding_label.value_namespace = name_space
                                                self.binding_label.value_namespace_prefix = name_space_prefix
                                            if(value_path == "path-type"):
                                                self.path_type = value
                                                self.path_type.value_namespace = name_space
                                                self.path_type.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class VersionInfo(Entity):
                                        """
                                        Version Info
                                        
                                        .. attribute:: attribute_type
                                        
                                        	Attribute Type
                                        	**type**\:  str
                                        
                                        .. attribute:: generation
                                        
                                        	Generation
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: is_default
                                        
                                        	Is default
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                                            self.yang_name = "version-info"
                                            self.yang_parent_name = "attribute-set-path-option"

                                            self.attribute_type = YLeaf(YType.str, "attribute-type")

                                            self.generation = YLeaf(YType.uint32, "generation")

                                            self.is_default = YLeaf(YType.boolean, "is-default")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("attribute_type",
                                                            "generation",
                                                            "is_default") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.attribute_type.is_set or
                                                self.generation.is_set or
                                                self.is_default.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.attribute_type.yfilter != YFilter.not_set or
                                                self.generation.yfilter != YFilter.not_set or
                                                self.is_default.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "version-info" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.attribute_type.get_name_leafdata())
                                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.generation.get_name_leafdata())
                                            if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_default.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "attribute-type"):
                                                self.attribute_type = value
                                                self.attribute_type.value_namespace = name_space
                                                self.attribute_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "generation"):
                                                self.generation = value
                                                self.generation.value_namespace = name_space
                                                self.generation.value_namespace_prefix = name_space_prefix
                                            if(value_path == "is-default"):
                                                self.is_default = value
                                                self.is_default.value_namespace = name_space
                                                self.is_default.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        for c in self.version_info:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.bandwidth_type.is_set or
                                            self.configured_bandwidth.is_set or
                                            self.cost_limit.is_set or
                                            self.dste_class_type.is_set or
                                            self.exclude_list_name.is_set or
                                            self.generation.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_bandwidth_configured.is_set or
                                            self.is_bfd_reverse_pat_configured.is_set or
                                            self.is_cost_limit_configured.is_set or
                                            self.is_exclude_list_name_configured.is_set or
                                            self.is_path_invalidation_action_configured.is_set or
                                            self.is_path_invalidation_timeout_configured.is_set or
                                            self.is_pce_configured.is_set or
                                            self.is_pce_disj_group_id_configured.is_set or
                                            self.is_pce_disj_source_configured.is_set or
                                            self.is_pce_disj_type_configured.is_set or
                                            self.is_pceb_dj_source_configured.is_set or
                                            self.is_pcebd_group_id_configured.is_set or
                                            self.path_invalidation_action.is_set or
                                            self.path_invalidation_timeout.is_set or
                                            self.pcebd_group_id.is_set or
                                            self.pcebd_source_address.is_set or
                                            self.pcedp_group_id.is_set or
                                            self.pcedp_source_address.is_set or
                                            self.pcedp_type.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                                    def has_operation(self):
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.version_info:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.bandwidth_type.yfilter != YFilter.not_set or
                                            self.configured_bandwidth.yfilter != YFilter.not_set or
                                            self.cost_limit.yfilter != YFilter.not_set or
                                            self.dste_class_type.yfilter != YFilter.not_set or
                                            self.exclude_list_name.yfilter != YFilter.not_set or
                                            self.generation.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                            self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                                            self.is_cost_limit_configured.yfilter != YFilter.not_set or
                                            self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                            self.is_pce_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                            self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                            self.path_invalidation_action.yfilter != YFilter.not_set or
                                            self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                            self.pcebd_group_id.yfilter != YFilter.not_set or
                                            self.pcebd_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_group_id.yfilter != YFilter.not_set or
                                            self.pcedp_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_type.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-path-option" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                                        if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                        if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.cost_limit.get_name_leafdata())
                                        if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                        if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                                        if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.generation.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                        if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                                        if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                                        if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                        if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                        if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                        if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                        if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                        if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                        if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                        if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                                        if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                        if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                        if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                        if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                        if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                        if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "bfd-reverse-path"):
                                            if (self.bfd_reverse_path is None):
                                                self.bfd_reverse_path = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                                self.bfd_reverse_path.parent = self
                                                self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                                            return self.bfd_reverse_path

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        if (child_yang_name == "version-info"):
                                            for c in self.version_info:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.version_info.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "bandwidth-type"):
                                            self.bandwidth_type = value
                                            self.bandwidth_type.value_namespace = name_space
                                            self.bandwidth_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "configured-bandwidth"):
                                            self.configured_bandwidth = value
                                            self.configured_bandwidth.value_namespace = name_space
                                            self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "cost-limit"):
                                            self.cost_limit = value
                                            self.cost_limit.value_namespace = name_space
                                            self.cost_limit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dste-class-type"):
                                            self.dste_class_type = value
                                            self.dste_class_type.value_namespace = name_space
                                            self.dste_class_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "exclude-list-name"):
                                            self.exclude_list_name = value
                                            self.exclude_list_name.value_namespace = name_space
                                            self.exclude_list_name.value_namespace_prefix = name_space_prefix
                                        if(value_path == "generation"):
                                            self.generation = value
                                            self.generation.value_namespace = name_space
                                            self.generation.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bandwidth-configured"):
                                            self.is_bandwidth_configured = value
                                            self.is_bandwidth_configured.value_namespace = name_space
                                            self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bfd-reverse-pat-configured"):
                                            self.is_bfd_reverse_pat_configured = value
                                            self.is_bfd_reverse_pat_configured.value_namespace = name_space
                                            self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-cost-limit-configured"):
                                            self.is_cost_limit_configured = value
                                            self.is_cost_limit_configured.value_namespace = name_space
                                            self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-exclude-list-name-configured"):
                                            self.is_exclude_list_name_configured = value
                                            self.is_exclude_list_name_configured.value_namespace = name_space
                                            self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-action-configured"):
                                            self.is_path_invalidation_action_configured = value
                                            self.is_path_invalidation_action_configured.value_namespace = name_space
                                            self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-timeout-configured"):
                                            self.is_path_invalidation_timeout_configured = value
                                            self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                            self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-configured"):
                                            self.is_pce_configured = value
                                            self.is_pce_configured.value_namespace = name_space
                                            self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-group-id-configured"):
                                            self.is_pce_disj_group_id_configured = value
                                            self.is_pce_disj_group_id_configured.value_namespace = name_space
                                            self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-source-configured"):
                                            self.is_pce_disj_source_configured = value
                                            self.is_pce_disj_source_configured.value_namespace = name_space
                                            self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-type-configured"):
                                            self.is_pce_disj_type_configured = value
                                            self.is_pce_disj_type_configured.value_namespace = name_space
                                            self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pceb-dj-source-configured"):
                                            self.is_pceb_dj_source_configured = value
                                            self.is_pceb_dj_source_configured.value_namespace = name_space
                                            self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pcebd-group-id-configured"):
                                            self.is_pcebd_group_id_configured = value
                                            self.is_pcebd_group_id_configured.value_namespace = name_space
                                            self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-invalidation-action"):
                                            self.path_invalidation_action = value
                                            self.path_invalidation_action.value_namespace = name_space
                                            self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-invalidation-timeout"):
                                            self.path_invalidation_timeout = value
                                            self.path_invalidation_timeout.value_namespace = name_space
                                            self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-group-id"):
                                            self.pcebd_group_id = value
                                            self.pcebd_group_id.value_namespace = name_space
                                            self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-source-address"):
                                            self.pcebd_source_address = value
                                            self.pcebd_source_address.value_namespace = name_space
                                            self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-group-id"):
                                            self.pcedp_group_id = value
                                            self.pcedp_group_id.value_namespace = name_space
                                            self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-source-address"):
                                            self.pcedp_source_address = value
                                            self.pcedp_source_address.value_namespace = name_space
                                            self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-type"):
                                            self.pcedp_type = value
                                            self.pcedp_type.value_namespace = name_space
                                            self.pcedp_type.value_namespace_prefix = name_space_prefix


                                class AttributeSetAutobackup(Entity):
                                    """
                                    MPLS TE Auto\-backup Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_signalled_name_configured
                                    
                                    	Is signalled name configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                                    
                                    .. attribute:: protected_interface
                                    
                                    	Array of Protected Interface Names
                                    	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\:  bool
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: signalled_name
                                    
                                    	Signalled name
                                    	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                                        self.yang_name = "attribute-set-autobackup"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                        self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                        self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                                        self.policy_class = YLeaf(YType.uint8, "policy-class")

                                        self.record_route = YLeaf(YType.boolean, "record-route")

                                        self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                        self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"
                                        self._children_yang_names.add("logging")

                                        self.signalled_name = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                        self.signalled_name.parent = self
                                        self._children_name_map["signalled_name"] = "signalled-name"
                                        self._children_yang_names.add("signalled-name")

                                        self.policy_class_entry = YList(self)
                                        self.protected_interface = YList(self)
                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("hold_priority",
                                                        "is_affinity_configured",
                                                        "is_policyclass_configured",
                                                        "is_priority_configured",
                                                        "is_signalled_name_configured",
                                                        "policy_class",
                                                        "record_route",
                                                        "setup_priority") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                                    class SignalledName(Entity):
                                        """
                                        Signalled name
                                        
                                        .. attribute:: is_mp_addresses
                                        
                                        	MP address appended
                                        	**type**\:  bool
                                        
                                        .. attribute:: name
                                        
                                        	Signalled name
                                        	**type**\:  str
                                        
                                        .. attribute:: protected_interface_type
                                        
                                        	Protected interface address or name
                                        	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        .. attribute:: source_type
                                        
                                        	Source address or name
                                        	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                                            self.yang_name = "signalled-name"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                                            self.name = YLeaf(YType.str, "name")

                                            self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                                            self.source_type = YLeaf(YType.enumeration, "source-type")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("is_mp_addresses",
                                                            "name",
                                                            "protected_interface_type",
                                                            "source_type") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.is_mp_addresses.is_set or
                                                self.name.is_set or
                                                self.protected_interface_type.is_set or
                                                self.source_type.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.is_mp_addresses.yfilter != YFilter.not_set or
                                                self.name.yfilter != YFilter.not_set or
                                                self.protected_interface_type.yfilter != YFilter.not_set or
                                                self.source_type.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "signalled-name" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                                            if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.name.get_name_leafdata())
                                            if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                                            if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.source_type.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "is-mp-addresses"):
                                                self.is_mp_addresses = value
                                                self.is_mp_addresses.value_namespace = name_space
                                                self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                                            if(value_path == "name"):
                                                self.name = value
                                                self.name.value_namespace = name_space
                                                self.name.value_namespace_prefix = name_space_prefix
                                            if(value_path == "protected-interface-type"):
                                                self.protected_interface_type = value
                                                self.protected_interface_type.value_namespace = name_space
                                                self.protected_interface_type.value_namespace_prefix = name_space_prefix
                                            if(value_path == "source-type"):
                                                self.source_type = value
                                                self.source_type.value_namespace = name_space
                                                self.source_type.value_namespace_prefix = name_space_prefix


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class Logging(Entity):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                            self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                            self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                            self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                            self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                            self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                            self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                            self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("all_logging_enabled",
                                                            "lsp_bandwidth_change",
                                                            "lsp_insufficient_bw",
                                                            "lsp_pcalc_failure_logging_enabled",
                                                            "lsp_re_opt",
                                                            "lsp_re_route",
                                                            "lsp_state",
                                                            "s2l_state") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.all_logging_enabled.is_set or
                                                self.lsp_bandwidth_change.is_set or
                                                self.lsp_insufficient_bw.is_set or
                                                self.lsp_pcalc_failure_logging_enabled.is_set or
                                                self.lsp_re_opt.is_set or
                                                self.lsp_re_route.is_set or
                                                self.lsp_state.is_set or
                                                self.s2l_state.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.all_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_re_opt.yfilter != YFilter.not_set or
                                                self.lsp_re_route.yfilter != YFilter.not_set or
                                                self.lsp_state.yfilter != YFilter.not_set or
                                                self.s2l_state.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "logging" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                            if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                            if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                            if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                            if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                            if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                            if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                            if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "all-logging-enabled"):
                                                self.all_logging_enabled = value
                                                self.all_logging_enabled.value_namespace = name_space
                                                self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-bandwidth-change"):
                                                self.lsp_bandwidth_change = value
                                                self.lsp_bandwidth_change.value_namespace = name_space
                                                self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-insufficient-bw"):
                                                self.lsp_insufficient_bw = value
                                                self.lsp_insufficient_bw.value_namespace = name_space
                                                self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                self.lsp_pcalc_failure_logging_enabled = value
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-opt"):
                                                self.lsp_re_opt = value
                                                self.lsp_re_opt.value_namespace = name_space
                                                self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-route"):
                                                self.lsp_re_route = value
                                                self.lsp_re_route.value_namespace = name_space
                                                self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-state"):
                                                self.lsp_state = value
                                                self.lsp_state.value_namespace = name_space
                                                self.lsp_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "s2l-state"):
                                                self.s2l_state = value
                                                self.s2l_state.value_namespace = name_space
                                                self.s2l_state.value_namespace_prefix = name_space_prefix


                                    class PolicyClassEntry(Entity):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "policy-class-entry" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class ProtectedInterface(Entity):
                                        """
                                        Array of Protected Interface Names
                                        
                                        .. attribute:: protected_interface
                                        
                                        	Protected Interface Name
                                        	**type**\:  str
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                                            self.yang_name = "protected-interface"
                                            self.yang_parent_name = "attribute-set-autobackup"

                                            self.protected_interface = YLeaf(YType.str, "protected-interface")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("protected_interface") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.protected_interface.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.protected_interface.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "protected-interface" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.protected_interface.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "protected-interface"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "protected-interface"):
                                                self.protected_interface = value
                                                self.protected_interface.value_namespace = name_space
                                                self.protected_interface.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.policy_class_entry:
                                            if (c.has_data()):
                                                return True
                                        for c in self.protected_interface:
                                            if (c.has_data()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.hold_priority.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_policyclass_configured.is_set or
                                            self.is_priority_configured.is_set or
                                            self.is_signalled_name_configured.is_set or
                                            self.policy_class.is_set or
                                            self.record_route.is_set or
                                            self.setup_priority.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.logging is not None and self.logging.has_data()) or
                                            (self.signalled_name is not None and self.signalled_name.has_data()))

                                    def has_operation(self):
                                        for c in self.policy_class_entry:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.protected_interface:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.hold_priority.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_policyclass_configured.yfilter != YFilter.not_set or
                                            self.is_priority_configured.yfilter != YFilter.not_set or
                                            self.is_signalled_name_configured.yfilter != YFilter.not_set or
                                            self.policy_class.yfilter != YFilter.not_set or
                                            self.record_route.yfilter != YFilter.not_set or
                                            self.setup_priority.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.logging is not None and self.logging.has_operation()) or
                                            (self.signalled_name is not None and self.signalled_name.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-autobackup" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                        if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                        if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                                        if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.policy_class.get_name_leafdata())
                                        if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.record_route.get_name_leafdata())
                                        if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "logging"):
                                            if (self.logging is None):
                                                self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                                self.logging.parent = self
                                                self._children_name_map["logging"] = "logging"
                                            return self.logging

                                        if (child_yang_name == "policy-class-entry"):
                                            for c in self.policy_class_entry:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.policy_class_entry.append(c)
                                            return c

                                        if (child_yang_name == "protected-interface"):
                                            for c in self.protected_interface:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.protected_interface.append(c)
                                            return c

                                        if (child_yang_name == "signalled-name"):
                                            if (self.signalled_name is None):
                                                self.signalled_name = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                                self.signalled_name.parent = self
                                                self._children_name_map["signalled_name"] = "signalled-name"
                                            return self.signalled_name

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "hold-priority"):
                                            self.hold_priority = value
                                            self.hold_priority.value_namespace = name_space
                                            self.hold_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-policyclass-configured"):
                                            self.is_policyclass_configured = value
                                            self.is_policyclass_configured.value_namespace = name_space
                                            self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-priority-configured"):
                                            self.is_priority_configured = value
                                            self.is_priority_configured.value_namespace = name_space
                                            self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-signalled-name-configured"):
                                            self.is_signalled_name_configured = value
                                            self.is_signalled_name_configured.value_namespace = name_space
                                            self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "policy-class"):
                                            self.policy_class = value
                                            self.policy_class.value_namespace = name_space
                                            self.policy_class.value_namespace_prefix = name_space_prefix
                                        if(value_path == "record-route"):
                                            self.record_route = value
                                            self.record_route.value_namespace = name_space
                                            self.record_route.value_namespace_prefix = name_space_prefix
                                        if(value_path == "setup-priority"):
                                            self.setup_priority = value
                                            self.setup_priority.value_namespace = name_space
                                            self.setup_priority.value_namespace_prefix = name_space_prefix


                                class AttributeSetAutomesh(Entity):
                                    """
                                    MPLS TE Auto\-mesh Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                                    
                                    .. attribute:: auto_bandwidth_collect
                                    
                                    	Auto bandwidth collect only
                                    	**type**\:  bool
                                    
                                    .. attribute:: auto_route_announce
                                    
                                    	Announce auto route to IGP
                                    	**type**\:  bool
                                    
                                    .. attribute:: bandwidth
                                    
                                    	IM bandwidth
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\:  bool
                                    
                                    .. attribute:: forward_class
                                    
                                    	Forward class
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\:  bool
                                    
                                    .. attribute:: frr_node_protection
                                    
                                    	FRR Node protection
                                    	**type**\:  bool
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_interface_bw_configured
                                    
                                    	Is Interface BW configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_policyclass_configured
                                    
                                    	Is policy class configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: load_share
                                    
                                    	Load Share
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                                    
                                    .. attribute:: mesh_group_id
                                    
                                    	Meshgroup ID
                                    	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                                    
                                    .. attribute:: policy_class
                                    
                                    	deprecated
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: policy_class_entry
                                    
                                    	PBTS policy classes
                                    	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                                    
                                    .. attribute:: record_route
                                    
                                    	Record route
                                    	**type**\:  bool
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: soft_preemption_configured
                                    
                                    	Soft preemption is configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                                        self.yang_name = "attribute-set-automesh"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                                        self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                                        self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                                        self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                        self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                        self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                        self.forward_class = YLeaf(YType.uint32, "forward-class")

                                        self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                        self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                                        self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                        self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                                        self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                                        self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                        self.load_share = YLeaf(YType.uint32, "load-share")

                                        self.policy_class = YLeaf(YType.uint8, "policy-class")

                                        self.record_route = YLeaf(YType.boolean, "record-route")

                                        self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                        self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                                        self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"
                                        self._children_yang_names.add("logging")

                                        self.mesh_group_id = YList(self)
                                        self.policy_class_entry = YList(self)
                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("auto_bandwidth_collect",
                                                        "auto_route_announce",
                                                        "bandwidth",
                                                        "configured_bandwidth",
                                                        "dste_class_type",
                                                        "fast_reroute",
                                                        "forward_class",
                                                        "frr_bandwidth_protection",
                                                        "frr_node_protection",
                                                        "hold_priority",
                                                        "is_affinity_configured",
                                                        "is_bandwidth_configured",
                                                        "is_interface_bw_configured",
                                                        "is_policyclass_configured",
                                                        "is_priority_configured",
                                                        "load_share",
                                                        "policy_class",
                                                        "record_route",
                                                        "setup_priority",
                                                        "soft_preemption_configured") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class Logging(Entity):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                            self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                            self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                            self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                            self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                            self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                            self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                            self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("all_logging_enabled",
                                                            "lsp_bandwidth_change",
                                                            "lsp_insufficient_bw",
                                                            "lsp_pcalc_failure_logging_enabled",
                                                            "lsp_re_opt",
                                                            "lsp_re_route",
                                                            "lsp_state",
                                                            "s2l_state") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.all_logging_enabled.is_set or
                                                self.lsp_bandwidth_change.is_set or
                                                self.lsp_insufficient_bw.is_set or
                                                self.lsp_pcalc_failure_logging_enabled.is_set or
                                                self.lsp_re_opt.is_set or
                                                self.lsp_re_route.is_set or
                                                self.lsp_state.is_set or
                                                self.s2l_state.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.all_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_re_opt.yfilter != YFilter.not_set or
                                                self.lsp_re_route.yfilter != YFilter.not_set or
                                                self.lsp_state.yfilter != YFilter.not_set or
                                                self.s2l_state.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "logging" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                            if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                            if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                            if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                            if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                            if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                            if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                            if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "all-logging-enabled"):
                                                self.all_logging_enabled = value
                                                self.all_logging_enabled.value_namespace = name_space
                                                self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-bandwidth-change"):
                                                self.lsp_bandwidth_change = value
                                                self.lsp_bandwidth_change.value_namespace = name_space
                                                self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-insufficient-bw"):
                                                self.lsp_insufficient_bw = value
                                                self.lsp_insufficient_bw.value_namespace = name_space
                                                self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                self.lsp_pcalc_failure_logging_enabled = value
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-opt"):
                                                self.lsp_re_opt = value
                                                self.lsp_re_opt.value_namespace = name_space
                                                self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-route"):
                                                self.lsp_re_route = value
                                                self.lsp_re_route.value_namespace = name_space
                                                self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-state"):
                                                self.lsp_state = value
                                                self.lsp_state.value_namespace = name_space
                                                self.lsp_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "s2l-state"):
                                                self.s2l_state = value
                                                self.s2l_state.value_namespace = name_space
                                                self.s2l_state.value_namespace_prefix = name_space_prefix


                                    class PolicyClassEntry(Entity):
                                        """
                                        PBTS policy classes
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                                            self.yang_name = "policy-class-entry"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.entry = YLeaf(YType.uint8, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "policy-class-entry" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class MeshGroupId(Entity):
                                        """
                                        Meshgroup ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                                            self.yang_name = "mesh-group-id"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.entry = YLeaf(YType.uint32, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "mesh-group-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-automesh"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.mesh_group_id:
                                            if (c.has_data()):
                                                return True
                                        for c in self.policy_class_entry:
                                            if (c.has_data()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.auto_bandwidth_collect.is_set or
                                            self.auto_route_announce.is_set or
                                            self.bandwidth.is_set or
                                            self.configured_bandwidth.is_set or
                                            self.dste_class_type.is_set or
                                            self.fast_reroute.is_set or
                                            self.forward_class.is_set or
                                            self.frr_bandwidth_protection.is_set or
                                            self.frr_node_protection.is_set or
                                            self.hold_priority.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_bandwidth_configured.is_set or
                                            self.is_interface_bw_configured.is_set or
                                            self.is_policyclass_configured.is_set or
                                            self.is_priority_configured.is_set or
                                            self.load_share.is_set or
                                            self.policy_class.is_set or
                                            self.record_route.is_set or
                                            self.setup_priority.is_set or
                                            self.soft_preemption_configured.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.logging is not None and self.logging.has_data()))

                                    def has_operation(self):
                                        for c in self.mesh_group_id:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.policy_class_entry:
                                            if (c.has_operation()):
                                                return True
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                                            self.auto_route_announce.yfilter != YFilter.not_set or
                                            self.bandwidth.yfilter != YFilter.not_set or
                                            self.configured_bandwidth.yfilter != YFilter.not_set or
                                            self.dste_class_type.yfilter != YFilter.not_set or
                                            self.fast_reroute.yfilter != YFilter.not_set or
                                            self.forward_class.yfilter != YFilter.not_set or
                                            self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                            self.frr_node_protection.yfilter != YFilter.not_set or
                                            self.hold_priority.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                            self.is_interface_bw_configured.yfilter != YFilter.not_set or
                                            self.is_policyclass_configured.yfilter != YFilter.not_set or
                                            self.is_priority_configured.yfilter != YFilter.not_set or
                                            self.load_share.yfilter != YFilter.not_set or
                                            self.policy_class.yfilter != YFilter.not_set or
                                            self.record_route.yfilter != YFilter.not_set or
                                            self.setup_priority.yfilter != YFilter.not_set or
                                            self.soft_preemption_configured.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.logging is not None and self.logging.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-automesh" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                                        if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                                        if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.bandwidth.get_name_leafdata())
                                        if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                        if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                        if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                        if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.forward_class.get_name_leafdata())
                                        if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                        if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                                        if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                        if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                                        if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                                        if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                        if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.load_share.get_name_leafdata())
                                        if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.policy_class.get_name_leafdata())
                                        if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.record_route.get_name_leafdata())
                                        if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.setup_priority.get_name_leafdata())
                                        if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "logging"):
                                            if (self.logging is None):
                                                self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                                self.logging.parent = self
                                                self._children_name_map["logging"] = "logging"
                                            return self.logging

                                        if (child_yang_name == "mesh-group-id"):
                                            for c in self.mesh_group_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.mesh_group_id.append(c)
                                            return c

                                        if (child_yang_name == "policy-class-entry"):
                                            for c in self.policy_class_entry:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.policy_class_entry.append(c)
                                            return c

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "auto-bandwidth-collect"):
                                            self.auto_bandwidth_collect = value
                                            self.auto_bandwidth_collect.value_namespace = name_space
                                            self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                                        if(value_path == "auto-route-announce"):
                                            self.auto_route_announce = value
                                            self.auto_route_announce.value_namespace = name_space
                                            self.auto_route_announce.value_namespace_prefix = name_space_prefix
                                        if(value_path == "bandwidth"):
                                            self.bandwidth = value
                                            self.bandwidth.value_namespace = name_space
                                            self.bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "configured-bandwidth"):
                                            self.configured_bandwidth = value
                                            self.configured_bandwidth.value_namespace = name_space
                                            self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dste-class-type"):
                                            self.dste_class_type = value
                                            self.dste_class_type.value_namespace = name_space
                                            self.dste_class_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "fast-reroute"):
                                            self.fast_reroute = value
                                            self.fast_reroute.value_namespace = name_space
                                            self.fast_reroute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "forward-class"):
                                            self.forward_class = value
                                            self.forward_class.value_namespace = name_space
                                            self.forward_class.value_namespace_prefix = name_space_prefix
                                        if(value_path == "frr-bandwidth-protection"):
                                            self.frr_bandwidth_protection = value
                                            self.frr_bandwidth_protection.value_namespace = name_space
                                            self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "frr-node-protection"):
                                            self.frr_node_protection = value
                                            self.frr_node_protection.value_namespace = name_space
                                            self.frr_node_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "hold-priority"):
                                            self.hold_priority = value
                                            self.hold_priority.value_namespace = name_space
                                            self.hold_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bandwidth-configured"):
                                            self.is_bandwidth_configured = value
                                            self.is_bandwidth_configured.value_namespace = name_space
                                            self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-interface-bw-configured"):
                                            self.is_interface_bw_configured = value
                                            self.is_interface_bw_configured.value_namespace = name_space
                                            self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-policyclass-configured"):
                                            self.is_policyclass_configured = value
                                            self.is_policyclass_configured.value_namespace = name_space
                                            self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-priority-configured"):
                                            self.is_priority_configured = value
                                            self.is_priority_configured.value_namespace = name_space
                                            self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "load-share"):
                                            self.load_share = value
                                            self.load_share.value_namespace = name_space
                                            self.load_share.value_namespace_prefix = name_space_prefix
                                        if(value_path == "policy-class"):
                                            self.policy_class = value
                                            self.policy_class.value_namespace = name_space
                                            self.policy_class.value_namespace_prefix = name_space_prefix
                                        if(value_path == "record-route"):
                                            self.record_route = value
                                            self.record_route.value_namespace = name_space
                                            self.record_route.value_namespace_prefix = name_space_prefix
                                        if(value_path == "setup-priority"):
                                            self.setup_priority = value
                                            self.setup_priority.value_namespace = name_space
                                            self.setup_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "soft-preemption-configured"):
                                            self.soft_preemption_configured = value
                                            self.soft_preemption_configured.value_namespace = name_space
                                            self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                                class AttributeSetXro(Entity):
                                    """
                                    Attribute Set XRO
                                    
                                    .. attribute:: xro
                                    
                                    	The XRO specified by this attribute\-set
                                    	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                                        self.yang_name = "attribute-set-xro"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                        self.xro.parent = self
                                        self._children_name_map["xro"] = "xro"
                                        self._children_yang_names.add("xro")


                                    class Xro(Entity):
                                        """
                                        The XRO specified by this attribute\-set
                                        
                                        .. attribute:: mutual_diversity_flag
                                        
                                        	Mutual Diversity Flag
                                        	**type**\:  bool
                                        
                                        .. attribute:: xro_subobject
                                        
                                        	List of XRO sub\-objects
                                        	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                                            self.yang_name = "xro"
                                            self.yang_parent_name = "attribute-set-xro"

                                            self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                                            self.xro_subobject = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("mutual_diversity_flag") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                                        class XroSubobject(Entity):
                                            """
                                            List of XRO sub\-objects
                                            
                                            .. attribute:: as_subobject
                                            
                                            	AS sub\-object
                                            	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                                            
                                            .. attribute:: ipv4_subobject
                                            
                                            	IPv4 sub\-object
                                            	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                                            
                                            .. attribute:: ipv6_subobject
                                            
                                            	IPv6 sub\-object
                                            	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                                            
                                            .. attribute:: lsp_subobject
                                            
                                            	P2P LSP sub\-object
                                            	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                                            
                                            .. attribute:: srlg_subobject
                                            
                                            	SRLG sub\-object
                                            	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                                            
                                            .. attribute:: type
                                            
                                            	Type
                                            	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                                            
                                            .. attribute:: unnumbered_subobject
                                            
                                            	Unnumbered sub\-object
                                            	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                                self.yang_name = "xro-subobject"
                                                self.yang_parent_name = "xro"

                                                self.type = YLeaf(YType.enumeration, "type")

                                                self.as_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                self.as_subobject.parent = self
                                                self._children_name_map["as_subobject"] = "as-subobject"
                                                self._children_yang_names.add("as-subobject")

                                                self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                self.ipv4_subobject.parent = self
                                                self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                self._children_yang_names.add("ipv4-subobject")

                                                self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                self.ipv6_subobject.parent = self
                                                self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                self._children_yang_names.add("ipv6-subobject")

                                                self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                self.lsp_subobject.parent = self
                                                self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                self._children_yang_names.add("lsp-subobject")

                                                self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                self.srlg_subobject.parent = self
                                                self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                self._children_yang_names.add("srlg-subobject")

                                                self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                self.unnumbered_subobject.parent = self
                                                self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                self._children_yang_names.add("unnumbered-subobject")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                                            class Ipv4Subobject(Entity):
                                                """
                                                IPv4 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv4 address
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                                    self.yang_name = "ipv4-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.address = YLeaf(YType.str, "address")

                                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("address",
                                                                    "attribute",
                                                                    "exclusion_type",
                                                                    "prefix_len") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.address.is_set or
                                                        self.attribute.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.prefix_len.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.address.yfilter != YFilter.not_set or
                                                        self.attribute.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.prefix_len.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "ipv4-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.address.get_name_leafdata())
                                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "address"):
                                                        self.address = value
                                                        self.address.value_namespace = name_space
                                                        self.address.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "attribute"):
                                                        self.attribute = value
                                                        self.attribute.value_namespace = name_space
                                                        self.attribute.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "prefix-len"):
                                                        self.prefix_len = value
                                                        self.prefix_len.value_namespace = name_space
                                                        self.prefix_len.value_namespace_prefix = name_space_prefix


                                            class Ipv6Subobject(Entity):
                                                """
                                                IPv6 sub\-object
                                                
                                                .. attribute:: address
                                                
                                                	IPv6 address
                                                	**type**\:  str
                                                
                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: prefix_len
                                                
                                                	Prefix length
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                                    self.yang_name = "ipv6-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.address = YLeaf(YType.str, "address")

                                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("address",
                                                                    "attribute",
                                                                    "exclusion_type",
                                                                    "prefix_len") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.address.is_set or
                                                        self.attribute.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.prefix_len.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.address.yfilter != YFilter.not_set or
                                                        self.attribute.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.prefix_len.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "ipv6-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.address.get_name_leafdata())
                                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "address"):
                                                        self.address = value
                                                        self.address.value_namespace = name_space
                                                        self.address.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "attribute"):
                                                        self.attribute = value
                                                        self.attribute.value_namespace = name_space
                                                        self.attribute.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "prefix-len"):
                                                        self.prefix_len = value
                                                        self.prefix_len.value_namespace = name_space
                                                        self.prefix_len.value_namespace_prefix = name_space_prefix


                                            class UnnumberedSubobject(Entity):
                                                """
                                                Unnumbered sub\-object
                                                
                                                .. attribute:: attribute
                                                
                                                	Attribute
                                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: interface_id
                                                
                                                	Interface ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: te_router_id
                                                
                                                	TE router\-id
                                                	**type**\:  str
                                                
                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                                    self.yang_name = "unnumbered-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                                    self.te_router_id = YLeaf(YType.str, "te-router-id")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("attribute",
                                                                    "exclusion_type",
                                                                    "interface_id",
                                                                    "te_router_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.attribute.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.interface_id.is_set or
                                                        self.te_router_id.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.attribute.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.interface_id.yfilter != YFilter.not_set or
                                                        self.te_router_id.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "unnumbered-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.interface_id.get_name_leafdata())
                                                    if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "attribute"):
                                                        self.attribute = value
                                                        self.attribute.value_namespace = name_space
                                                        self.attribute.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "interface-id"):
                                                        self.interface_id = value
                                                        self.interface_id.value_namespace = name_space
                                                        self.interface_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "te-router-id"):
                                                        self.te_router_id = value
                                                        self.te_router_id.value_namespace = name_space
                                                        self.te_router_id.value_namespace_prefix = name_space_prefix


                                            class AsSubobject(Entity):
                                                """
                                                AS sub\-object
                                                
                                                .. attribute:: as_number
                                                
                                                	Autonomous System number
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                                    self.yang_name = "as-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.as_number = YLeaf(YType.uint16, "as-number")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("as_number") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.as_number.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.as_number.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "as-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.as_number.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "as-number"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "as-number"):
                                                        self.as_number = value
                                                        self.as_number.value_namespace = name_space
                                                        self.as_number.value_namespace_prefix = name_space_prefix


                                            class SrlgSubobject(Entity):
                                                """
                                                SRLG sub\-object
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: srlg_id
                                                
                                                	SRLG ID
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                                    self.yang_name = "srlg-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("exclusion_type",
                                                                    "srlg_id") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return (
                                                        self.exclusion_type.is_set or
                                                        self.srlg_id.is_set)

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.srlg_id.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "srlg-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "exclusion-type" or name == "srlg-id"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "srlg-id"):
                                                        self.srlg_id = value
                                                        self.srlg_id.value_namespace = name_space
                                                        self.srlg_id.value_namespace_prefix = name_space_prefix


                                            class LspSubobject(Entity):
                                                """
                                                P2P LSP sub\-object
                                                
                                                .. attribute:: destination_node_exception
                                                
                                                	Destination\-node exception flag
                                                	**type**\:  bool
                                                
                                                .. attribute:: exclusion_type
                                                
                                                	Exclusion Type
                                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                                
                                                .. attribute:: fec
                                                
                                                	LSP FEC
                                                	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                                
                                                .. attribute:: ignore_lsp_id
                                                
                                                	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                                	**type**\:  bool
                                                
                                                .. attribute:: penultimate_node_exception
                                                
                                                	Penultimate\-node exception flag
                                                	**type**\:  bool
                                                
                                                .. attribute:: processing_node_exception
                                                
                                                	Processing\-node exception flag
                                                	**type**\:  bool
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                                    self.yang_name = "lsp-subobject"
                                                    self.yang_parent_name = "xro-subobject"

                                                    self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                                    self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                                    self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                                    self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                                    self.fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                    self.fec.parent = self
                                                    self._children_name_map["fec"] = "fec"
                                                    self._children_yang_names.add("fec")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("destination_node_exception",
                                                                    "exclusion_type",
                                                                    "ignore_lsp_id",
                                                                    "penultimate_node_exception",
                                                                    "processing_node_exception") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                                class Fec(Entity):
                                                    """
                                                    LSP FEC
                                                    
                                                    .. attribute:: fec_destination_info
                                                    
                                                    	Destination or P2MP ID
                                                    	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                                    
                                                    .. attribute:: fec_extended_tunnel_id
                                                    
                                                    	Extended tunnel ID
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: fec_lsp_id
                                                    
                                                    	LSP ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: fec_source
                                                    
                                                    	Tunnel source address
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: fec_tunnel_id
                                                    
                                                    	Tunnel ID
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: fec_vrf
                                                    
                                                    	VRF; currently only for GMPLS tunnels
                                                    	**type**\:  str
                                                    
                                                    

                                                    """

                                                    _prefix = 'mpls-te-oper'
                                                    _revision = '2015-11-09'

                                                    def __init__(self):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                                        self.yang_name = "fec"
                                                        self.yang_parent_name = "lsp-subobject"

                                                        self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                                        self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                                        self.fec_source = YLeaf(YType.str, "fec-source")

                                                        self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                                        self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                                        self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                        self.fec_destination_info.parent = self
                                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                        self._children_yang_names.add("fec-destination-info")

                                                    def __setattr__(self, name, value):
                                                        self._check_monkey_patching_error(name, value)
                                                        with _handle_type_error():
                                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                    "Please use list append or extend method."
                                                                                    .format(value))
                                                            if isinstance(value, Enum.YLeaf):
                                                                value = value.name
                                                            if name in ("fec_extended_tunnel_id",
                                                                        "fec_lsp_id",
                                                                        "fec_source",
                                                                        "fec_tunnel_id",
                                                                        "fec_vrf") and name in self.__dict__:
                                                                if isinstance(value, YLeaf):
                                                                    self.__dict__[name].set(value.get())
                                                                elif isinstance(value, YLeafList):
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                                else:
                                                                    self.__dict__[name].set(value)
                                                            else:
                                                                if hasattr(value, "parent") and name != "parent":
                                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                        value.parent = self
                                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                        value.parent = self
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                                    class FecDestinationInfo(Entity):
                                                        """
                                                        Destination or P2MP ID
                                                        
                                                        .. attribute:: fec_ctype
                                                        
                                                        	FEC CType
                                                        	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                                        
                                                        .. attribute:: fec_destination_p2mp_id
                                                        
                                                        	P2MP ID
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: p2p_lsp_destination
                                                        
                                                        	P2P LSP destination
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        

                                                        """

                                                        _prefix = 'mpls-te-oper'
                                                        _revision = '2015-11-09'

                                                        def __init__(self):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                                            self.yang_name = "fec-destination-info"
                                                            self.yang_parent_name = "fec"

                                                            self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                                            self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                                            self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                                        def __setattr__(self, name, value):
                                                            self._check_monkey_patching_error(name, value)
                                                            with _handle_type_error():
                                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                        "Please use list append or extend method."
                                                                                        .format(value))
                                                                if isinstance(value, Enum.YLeaf):
                                                                    value = value.name
                                                                if name in ("fec_ctype",
                                                                            "fec_destination_p2mp_id",
                                                                            "p2p_lsp_destination") and name in self.__dict__:
                                                                    if isinstance(value, YLeaf):
                                                                        self.__dict__[name].set(value.get())
                                                                    elif isinstance(value, YLeafList):
                                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                                    else:
                                                                        self.__dict__[name].set(value)
                                                                else:
                                                                    if hasattr(value, "parent") and name != "parent":
                                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                            value.parent = self
                                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                            value.parent = self
                                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                                        def has_data(self):
                                                            return (
                                                                self.fec_ctype.is_set or
                                                                self.fec_destination_p2mp_id.is_set or
                                                                self.p2p_lsp_destination.is_set)

                                                        def has_operation(self):
                                                            return (
                                                                self.yfilter != YFilter.not_set or
                                                                self.fec_ctype.yfilter != YFilter.not_set or
                                                                self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                                self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                                        def get_segment_path(self):
                                                            path_buffer = ""
                                                            path_buffer = "fec-destination-info" + path_buffer

                                                            return path_buffer

                                                        def get_entity_path(self, ancestor):
                                                            path_buffer = ""
                                                            if (ancestor is None):
                                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                            else:
                                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                            leaf_name_data = LeafDataList()
                                                            if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                                            if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                                            if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                                leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                                            return entity_path

                                                        def get_child_by_name(self, child_yang_name, segment_path):
                                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                            if child is not None:
                                                                return child

                                                            return None

                                                        def has_leaf_or_child_of_name(self, name):
                                                            if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                                return True
                                                            return False

                                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                                            if(value_path == "fec-ctype"):
                                                                self.fec_ctype = value
                                                                self.fec_ctype.value_namespace = name_space
                                                                self.fec_ctype.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "fec-destination-p2mp-id"):
                                                                self.fec_destination_p2mp_id = value
                                                                self.fec_destination_p2mp_id.value_namespace = name_space
                                                                self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                                            if(value_path == "p2p-lsp-destination"):
                                                                self.p2p_lsp_destination = value
                                                                self.p2p_lsp_destination.value_namespace = name_space
                                                                self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                                    def has_data(self):
                                                        return (
                                                            self.fec_extended_tunnel_id.is_set or
                                                            self.fec_lsp_id.is_set or
                                                            self.fec_source.is_set or
                                                            self.fec_tunnel_id.is_set or
                                                            self.fec_vrf.is_set or
                                                            (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                                    def has_operation(self):
                                                        return (
                                                            self.yfilter != YFilter.not_set or
                                                            self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                                            self.fec_lsp_id.yfilter != YFilter.not_set or
                                                            self.fec_source.yfilter != YFilter.not_set or
                                                            self.fec_tunnel_id.yfilter != YFilter.not_set or
                                                            self.fec_vrf.yfilter != YFilter.not_set or
                                                            (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                                    def get_segment_path(self):
                                                        path_buffer = ""
                                                        path_buffer = "fec" + path_buffer

                                                        return path_buffer

                                                    def get_entity_path(self, ancestor):
                                                        path_buffer = ""
                                                        if (ancestor is None):
                                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                        else:
                                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                        leaf_name_data = LeafDataList()
                                                        if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                                        if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                                        if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_source.get_name_leafdata())
                                                        if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                                        if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                                            leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                                        return entity_path

                                                    def get_child_by_name(self, child_yang_name, segment_path):
                                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                        if child is not None:
                                                            return child

                                                        if (child_yang_name == "fec-destination-info"):
                                                            if (self.fec_destination_info is None):
                                                                self.fec_destination_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                                self.fec_destination_info.parent = self
                                                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                                            return self.fec_destination_info

                                                        return None

                                                    def has_leaf_or_child_of_name(self, name):
                                                        if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                                            return True
                                                        return False

                                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                                        if(value_path == "fec-extended-tunnel-id"):
                                                            self.fec_extended_tunnel_id = value
                                                            self.fec_extended_tunnel_id.value_namespace = name_space
                                                            self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-lsp-id"):
                                                            self.fec_lsp_id = value
                                                            self.fec_lsp_id.value_namespace = name_space
                                                            self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-source"):
                                                            self.fec_source = value
                                                            self.fec_source.value_namespace = name_space
                                                            self.fec_source.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-tunnel-id"):
                                                            self.fec_tunnel_id = value
                                                            self.fec_tunnel_id.value_namespace = name_space
                                                            self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                                        if(value_path == "fec-vrf"):
                                                            self.fec_vrf = value
                                                            self.fec_vrf.value_namespace = name_space
                                                            self.fec_vrf.value_namespace_prefix = name_space_prefix

                                                def has_data(self):
                                                    return (
                                                        self.destination_node_exception.is_set or
                                                        self.exclusion_type.is_set or
                                                        self.ignore_lsp_id.is_set or
                                                        self.penultimate_node_exception.is_set or
                                                        self.processing_node_exception.is_set or
                                                        (self.fec is not None and self.fec.has_data()))

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.destination_node_exception.yfilter != YFilter.not_set or
                                                        self.exclusion_type.yfilter != YFilter.not_set or
                                                        self.ignore_lsp_id.yfilter != YFilter.not_set or
                                                        self.penultimate_node_exception.yfilter != YFilter.not_set or
                                                        self.processing_node_exception.yfilter != YFilter.not_set or
                                                        (self.fec is not None and self.fec.has_operation()))

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "lsp-subobject" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                                    if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                                    if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                                    if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    if (child_yang_name == "fec"):
                                                        if (self.fec is None):
                                                            self.fec = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                                            self.fec.parent = self
                                                            self._children_name_map["fec"] = "fec"
                                                        return self.fec

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "destination-node-exception"):
                                                        self.destination_node_exception = value
                                                        self.destination_node_exception.value_namespace = name_space
                                                        self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "exclusion-type"):
                                                        self.exclusion_type = value
                                                        self.exclusion_type.value_namespace = name_space
                                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "ignore-lsp-id"):
                                                        self.ignore_lsp_id = value
                                                        self.ignore_lsp_id.value_namespace = name_space
                                                        self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "penultimate-node-exception"):
                                                        self.penultimate_node_exception = value
                                                        self.penultimate_node_exception.value_namespace = name_space
                                                        self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                                    if(value_path == "processing-node-exception"):
                                                        self.processing_node_exception = value
                                                        self.processing_node_exception.value_namespace = name_space
                                                        self.processing_node_exception.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                return (
                                                    self.type.is_set or
                                                    (self.as_subobject is not None and self.as_subobject.has_data()) or
                                                    (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                                    (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                                    (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                                    (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                                    (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.type.yfilter != YFilter.not_set or
                                                    (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                                    (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                                    (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                                    (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                                    (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                                    (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "xro-subobject" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "as-subobject"):
                                                    if (self.as_subobject is None):
                                                        self.as_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                                        self.as_subobject.parent = self
                                                        self._children_name_map["as_subobject"] = "as-subobject"
                                                    return self.as_subobject

                                                if (child_yang_name == "ipv4-subobject"):
                                                    if (self.ipv4_subobject is None):
                                                        self.ipv4_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                                        self.ipv4_subobject.parent = self
                                                        self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                                    return self.ipv4_subobject

                                                if (child_yang_name == "ipv6-subobject"):
                                                    if (self.ipv6_subobject is None):
                                                        self.ipv6_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                                        self.ipv6_subobject.parent = self
                                                        self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                                    return self.ipv6_subobject

                                                if (child_yang_name == "lsp-subobject"):
                                                    if (self.lsp_subobject is None):
                                                        self.lsp_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                                        self.lsp_subobject.parent = self
                                                        self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                                    return self.lsp_subobject

                                                if (child_yang_name == "srlg-subobject"):
                                                    if (self.srlg_subobject is None):
                                                        self.srlg_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                                        self.srlg_subobject.parent = self
                                                        self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                                    return self.srlg_subobject

                                                if (child_yang_name == "unnumbered-subobject"):
                                                    if (self.unnumbered_subobject is None):
                                                        self.unnumbered_subobject = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                                        self.unnumbered_subobject.parent = self
                                                        self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                                    return self.unnumbered_subobject

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "type"):
                                                    self.type = value
                                                    self.type.value_namespace = name_space
                                                    self.type.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.xro_subobject:
                                                if (c.has_data()):
                                                    return True
                                            return self.mutual_diversity_flag.is_set

                                        def has_operation(self):
                                            for c in self.xro_subobject:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.mutual_diversity_flag.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "xro" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "xro-subobject"):
                                                for c in self.xro_subobject:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.xro_subobject.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "mutual-diversity-flag"):
                                                self.mutual_diversity_flag = value
                                                self.mutual_diversity_flag.value_namespace = name_space
                                                self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (self.xro is not None and self.xro.has_data())

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            (self.xro is not None and self.xro.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-xro" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "xro"):
                                            if (self.xro is None):
                                                self.xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                                self.xro.parent = self
                                                self._children_name_map["xro"] = "xro"
                                            return self.xro

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "xro"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        pass


                                class AttributeSetP2Mpte(Entity):
                                    """
                                    MPLS TE P2MP\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                                    
                                    .. attribute:: configured_bandwidth
                                    
                                    	Bandwidth value in kbps
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    	**units**\: kbit/s
                                    
                                    .. attribute:: dste_class_type
                                    
                                    	DSTE Class
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: fast_reroute
                                    
                                    	Fast reroute
                                    	**type**\:  bool
                                    
                                    .. attribute:: frr_bandwidth_protection
                                    
                                    	FRR bandwidth protection
                                    	**type**\:  bool
                                    
                                    .. attribute:: hold_priority
                                    
                                    	Hold priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_bandwidth_configured
                                    
                                    	Is bandwidth configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_priority_configured
                                    
                                    	Is priority configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: setup_priority
                                    
                                    	Setup priority
                                    	**type**\:  int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                                        self.yang_name = "attribute-set-p2mpte"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                                        self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                                        self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                                        self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                                        self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                                        self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                                        self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                                        self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("configured_bandwidth",
                                                        "dste_class_type",
                                                        "fast_reroute",
                                                        "frr_bandwidth_protection",
                                                        "hold_priority",
                                                        "is_affinity_configured",
                                                        "is_bandwidth_configured",
                                                        "is_priority_configured",
                                                        "setup_priority") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2mpte"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2mpte"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.configured_bandwidth.is_set or
                                            self.dste_class_type.is_set or
                                            self.fast_reroute.is_set or
                                            self.frr_bandwidth_protection.is_set or
                                            self.hold_priority.is_set or
                                            self.is_affinity_configured.is_set or
                                            self.is_bandwidth_configured.is_set or
                                            self.is_priority_configured.is_set or
                                            self.setup_priority.is_set or
                                            (self.affinity is not None and self.affinity.has_data()))

                                    def has_operation(self):
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.configured_bandwidth.yfilter != YFilter.not_set or
                                            self.dste_class_type.yfilter != YFilter.not_set or
                                            self.fast_reroute.yfilter != YFilter.not_set or
                                            self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                                            self.hold_priority.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_bandwidth_configured.yfilter != YFilter.not_set or
                                            self.is_priority_configured.yfilter != YFilter.not_set or
                                            self.setup_priority.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-p2mpte" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                                        if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                                        if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                                        if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                                        if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_priority.get_name_leafdata())
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                                        if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                                        if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.setup_priority.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "configured-bandwidth"):
                                            self.configured_bandwidth = value
                                            self.configured_bandwidth.value_namespace = name_space
                                            self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                                        if(value_path == "dste-class-type"):
                                            self.dste_class_type = value
                                            self.dste_class_type.value_namespace = name_space
                                            self.dste_class_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "fast-reroute"):
                                            self.fast_reroute = value
                                            self.fast_reroute.value_namespace = name_space
                                            self.fast_reroute.value_namespace_prefix = name_space_prefix
                                        if(value_path == "frr-bandwidth-protection"):
                                            self.frr_bandwidth_protection = value
                                            self.frr_bandwidth_protection.value_namespace = name_space
                                            self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "hold-priority"):
                                            self.hold_priority = value
                                            self.hold_priority.value_namespace = name_space
                                            self.hold_priority.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-bandwidth-configured"):
                                            self.is_bandwidth_configured = value
                                            self.is_bandwidth_configured.value_namespace = name_space
                                            self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-priority-configured"):
                                            self.is_priority_configured = value
                                            self.is_priority_configured.value_namespace = name_space
                                            self.is_priority_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "setup-priority"):
                                            self.setup_priority = value
                                            self.setup_priority.value_namespace = name_space
                                            self.setup_priority.value_namespace_prefix = name_space_prefix


                                class AttributeSetApsPp(Entity):
                                    """
                                    Attribute Set OTN APS Path Protection
                                    
                                    .. attribute:: hold_off_time
                                    
                                    	Hold\-off time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_prot_profile_type
                                    
                                    	Path Protection Profile Type
                                    	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                                    
                                    .. attribute:: protection_mode
                                    
                                    	Protection Restoration Mode
                                    	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                                    
                                    .. attribute:: protection_type
                                    
                                    	Protection Type
                                    	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                                    
                                    .. attribute:: restoration_style
                                    
                                    	Restoration Style
                                    	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                                    
                                    .. attribute:: revert_schedule
                                    
                                    	Revert Schedule
                                    	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                                    
                                    .. attribute:: snc_mode
                                    
                                    	Sub\-network Connection Mode
                                    	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                                    
                                    .. attribute:: tcm_id
                                    
                                    	Sub\-network Connection Monitoring Mode
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: wait_to_restore_time
                                    
                                    	Wait to restore time
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                                        self.yang_name = "attribute-set-aps-pp"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                                        self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                                        self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                                        self.protection_type = YLeaf(YType.enumeration, "protection-type")

                                        self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                                        self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                                        self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                                        self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                                        self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                        self.revert_schedule.parent = self
                                        self._children_name_map["revert_schedule"] = "revert-schedule"
                                        self._children_yang_names.add("revert-schedule")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("hold_off_time",
                                                        "path_prot_profile_type",
                                                        "protection_mode",
                                                        "protection_type",
                                                        "restoration_style",
                                                        "snc_mode",
                                                        "tcm_id",
                                                        "wait_to_restore_time") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                                    class RevertSchedule(Entity):
                                        """
                                        Revert Schedule
                                        
                                        .. attribute:: duration
                                        
                                        	Duration for scheduled reversion
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: max_tries
                                        
                                        	Max tries for scheduled reversion
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: schedule_date
                                        
                                        	Schedule time for reversion
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: schedule_frequency
                                        
                                        	Schedule frequency for reversion
                                        	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                                        
                                        .. attribute:: schedulename
                                        
                                        	Schedule name identifier
                                        	**type**\:  str
                                        
                                        	**length:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                                            self.yang_name = "revert-schedule"
                                            self.yang_parent_name = "attribute-set-aps-pp"

                                            self.duration = YLeaf(YType.uint32, "duration")

                                            self.max_tries = YLeaf(YType.uint32, "max-tries")

                                            self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                                            self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                                            self.schedulename = YLeaf(YType.str, "schedulename")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("duration",
                                                            "max_tries",
                                                            "schedule_date",
                                                            "schedule_frequency",
                                                            "schedulename") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.duration.is_set or
                                                self.max_tries.is_set or
                                                self.schedule_date.is_set or
                                                self.schedule_frequency.is_set or
                                                self.schedulename.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.duration.yfilter != YFilter.not_set or
                                                self.max_tries.yfilter != YFilter.not_set or
                                                self.schedule_date.yfilter != YFilter.not_set or
                                                self.schedule_frequency.yfilter != YFilter.not_set or
                                                self.schedulename.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "revert-schedule" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.duration.get_name_leafdata())
                                            if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.max_tries.get_name_leafdata())
                                            if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.schedule_date.get_name_leafdata())
                                            if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                                            if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.schedulename.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "duration"):
                                                self.duration = value
                                                self.duration.value_namespace = name_space
                                                self.duration.value_namespace_prefix = name_space_prefix
                                            if(value_path == "max-tries"):
                                                self.max_tries = value
                                                self.max_tries.value_namespace = name_space
                                                self.max_tries.value_namespace_prefix = name_space_prefix
                                            if(value_path == "schedule-date"):
                                                self.schedule_date = value
                                                self.schedule_date.value_namespace = name_space
                                                self.schedule_date.value_namespace_prefix = name_space_prefix
                                            if(value_path == "schedule-frequency"):
                                                self.schedule_frequency = value
                                                self.schedule_frequency.value_namespace = name_space
                                                self.schedule_frequency.value_namespace_prefix = name_space_prefix
                                            if(value_path == "schedulename"):
                                                self.schedulename = value
                                                self.schedulename.value_namespace = name_space
                                                self.schedulename.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.hold_off_time.is_set or
                                            self.path_prot_profile_type.is_set or
                                            self.protection_mode.is_set or
                                            self.protection_type.is_set or
                                            self.restoration_style.is_set or
                                            self.snc_mode.is_set or
                                            self.tcm_id.is_set or
                                            self.wait_to_restore_time.is_set or
                                            (self.revert_schedule is not None and self.revert_schedule.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.hold_off_time.yfilter != YFilter.not_set or
                                            self.path_prot_profile_type.yfilter != YFilter.not_set or
                                            self.protection_mode.yfilter != YFilter.not_set or
                                            self.protection_type.yfilter != YFilter.not_set or
                                            self.restoration_style.yfilter != YFilter.not_set or
                                            self.snc_mode.yfilter != YFilter.not_set or
                                            self.tcm_id.yfilter != YFilter.not_set or
                                            self.wait_to_restore_time.yfilter != YFilter.not_set or
                                            (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-aps-pp" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                                        if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                                        if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.protection_mode.get_name_leafdata())
                                        if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.protection_type.get_name_leafdata())
                                        if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.restoration_style.get_name_leafdata())
                                        if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.snc_mode.get_name_leafdata())
                                        if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tcm_id.get_name_leafdata())
                                        if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "revert-schedule"):
                                            if (self.revert_schedule is None):
                                                self.revert_schedule = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                                self.revert_schedule.parent = self
                                                self._children_name_map["revert_schedule"] = "revert-schedule"
                                            return self.revert_schedule

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "hold-off-time"):
                                            self.hold_off_time = value
                                            self.hold_off_time.value_namespace = name_space
                                            self.hold_off_time.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-prot-profile-type"):
                                            self.path_prot_profile_type = value
                                            self.path_prot_profile_type.value_namespace = name_space
                                            self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "protection-mode"):
                                            self.protection_mode = value
                                            self.protection_mode.value_namespace = name_space
                                            self.protection_mode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "protection-type"):
                                            self.protection_type = value
                                            self.protection_type.value_namespace = name_space
                                            self.protection_type.value_namespace_prefix = name_space_prefix
                                        if(value_path == "restoration-style"):
                                            self.restoration_style = value
                                            self.restoration_style.value_namespace = name_space
                                            self.restoration_style.value_namespace_prefix = name_space_prefix
                                        if(value_path == "snc-mode"):
                                            self.snc_mode = value
                                            self.snc_mode.value_namespace = name_space
                                            self.snc_mode.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tcm-id"):
                                            self.tcm_id = value
                                            self.tcm_id.value_namespace = name_space
                                            self.tcm_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "wait-to-restore-time"):
                                            self.wait_to_restore_time = value
                                            self.wait_to_restore_time.value_namespace = name_space
                                            self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                                class AttributeSetP2PTe(Entity):
                                    """
                                    MPLS TE P2P\-TE Attribute Set
                                    
                                    .. attribute:: affinity
                                    
                                    	Affinity
                                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                                    
                                    .. attribute:: is_affinity_configured
                                    
                                    	Is affinity configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_action_configured
                                    
                                    	Is Path Invalidation action configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_invalidation_timeout_configured
                                    
                                    	Is Path Invalidation timeout configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_select_configured
                                    
                                    	Is any of the path selection parameters configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_metric_configured
                                    
                                    	Is path selection metric configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                                    
                                    	Is path selection segment routing configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_configured
                                    
                                    	Is path selection margin configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_margin_relative
                                    
                                    	Path selection margin is\_relative
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                                    
                                    	Is path selection segment limit configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_configured
                                    
                                    	Is PCE Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_group_id_configured
                                    
                                    	Is PCE Disjoint Path Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_source_configured
                                    
                                    	Is PCE Disjoint Path Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pce_disj_type_configured
                                    
                                    	Is PCE Disjoint Path Type Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pceb_dj_source_configured
                                    
                                    	Is PCE Bidirectional Source Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_pcebd_group_id_configured
                                    
                                    	Is PCE Bidirectional Group ID Configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: is_prepend_list_configured
                                    
                                    	Is SR prepend list configured
                                    	**type**\:  bool
                                    
                                    .. attribute:: logging
                                    
                                    	Logging attributes
                                    	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                                    
                                    .. attribute:: path_invalidation_timeout
                                    
                                    	Path invalidation timeout on the tunnel path
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_selection_invalidation_action
                                    
                                    	Path invalidation action
                                    	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                                    
                                    .. attribute:: path_selection_metric
                                    
                                    	Path selection metric type
                                    	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                                    
                                    .. attribute:: path_selection_segment_routing_adjacency_protection
                                    
                                    	Path selection segment\-routing type
                                    	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                                    
                                    .. attribute:: path_selection_segment_routing_margin
                                    
                                    	Path selection margin
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: path_selection_segment_routing_segment_limit
                                    
                                    	Is path selection segment limit configured
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_group_id
                                    
                                    	PCE Bidirectional Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcebd_source_address
                                    
                                    	PCE Bidirectional Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_group_id
                                    
                                    	PCE Disjoint Path Group ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_source_address
                                    
                                    	PCE Disjoint Path Source Address
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: pcedp_type
                                    
                                    	PCE Disjoint Path Type
                                    	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                                    
                                    .. attribute:: prepend_list
                                    
                                    	SR prepend list
                                    	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                                    
                                    .. attribute:: tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                                        self.yang_name = "attribute-set-p2p-te"
                                        self.yang_parent_name = "attribute-set-union"

                                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                                        self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                                        self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                                        self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                                        self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                                        self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                                        self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                                        self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                                        self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                                        self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                                        self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                                        self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                                        self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                                        self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                                        self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                                        self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                                        self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                                        self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                                        self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                                        self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                                        self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                                        self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                                        self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                                        self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                                        self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                                        self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                                        self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                                        self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                        self.affinity.parent = self
                                        self._children_name_map["affinity"] = "affinity"
                                        self._children_yang_names.add("affinity")

                                        self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                        self.logging.parent = self
                                        self._children_name_map["logging"] = "logging"
                                        self._children_yang_names.add("logging")

                                        self.prepend_list = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                        self.prepend_list.parent = self
                                        self._children_name_map["prepend_list"] = "prepend-list"
                                        self._children_yang_names.add("prepend-list")

                                        self.tunnel_id = YList(self)

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("is_affinity_configured",
                                                        "is_path_invalidation_action_configured",
                                                        "is_path_invalidation_timeout_configured",
                                                        "is_path_select_configured",
                                                        "is_path_selection_metric_configured",
                                                        "is_path_selection_segment_routing_adjacency_protection_configured",
                                                        "is_path_selection_segment_routing_margin_configured",
                                                        "is_path_selection_segment_routing_margin_relative",
                                                        "is_path_selection_segment_routing_segment_limit_configured",
                                                        "is_pce_configured",
                                                        "is_pce_disj_group_id_configured",
                                                        "is_pce_disj_source_configured",
                                                        "is_pce_disj_type_configured",
                                                        "is_pceb_dj_source_configured",
                                                        "is_pcebd_group_id_configured",
                                                        "is_prepend_list_configured",
                                                        "path_invalidation_timeout",
                                                        "path_selection_invalidation_action",
                                                        "path_selection_metric",
                                                        "path_selection_segment_routing_adjacency_protection",
                                                        "path_selection_segment_routing_margin",
                                                        "path_selection_segment_routing_segment_limit",
                                                        "pcebd_group_id",
                                                        "pcebd_source_address",
                                                        "pcedp_group_id",
                                                        "pcedp_source_address",
                                                        "pcedp_type") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                                    class Affinity(Entity):
                                        """
                                        Affinity
                                        
                                        .. attribute:: affinity_bits
                                        
                                        	The affinity bits (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: affinity_mask
                                        
                                        	The affinity mask (colors)
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: named_affinity
                                        
                                        	Array of name based constratints currently applied to the tunnel
                                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                                            self.yang_name = "affinity"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                                            self.named_affinity = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("affinity_bits",
                                                            "affinity_mask") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                                        class NamedAffinity(Entity):
                                            """
                                            Array of name based constratints currently
                                            applied to the tunnel
                                            
                                            .. attribute:: constraint_extended_value
                                            
                                            	Constraint value
                                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                                            
                                            .. attribute:: constraint_type
                                            
                                            	Constraint type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: constraint_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: extended_forward_ref_value
                                            
                                            	Reference bits for undefined affinity names
                                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                                            
                                            .. attribute:: forward_ref_value
                                            
                                            	Deprecated
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                                self.yang_name = "named-affinity"
                                                self.yang_parent_name = "affinity"

                                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                                self.constraint_extended_value = YList(self)
                                                self.extended_forward_ref_value = YList(self)

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("constraint_type",
                                                                "constraint_value",
                                                                "forward_ref_value") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                                            class ConstraintExtendedValue(Entity):
                                                """
                                                Constraint value
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                                    self.yang_name = "constraint-extended-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "constraint-extended-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix


                                            class ExtendedForwardRefValue(Entity):
                                                """
                                                Reference bits for undefined affinity names
                                                
                                                .. attribute:: entry
                                                
                                                	
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'mpls-te-oper'
                                                _revision = '2015-11-09'

                                                def __init__(self):
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                                    self.yang_name = "extended-forward-ref-value"
                                                    self.yang_parent_name = "named-affinity"

                                                    self.entry = YLeaf(YType.uint32, "entry")

                                                def __setattr__(self, name, value):
                                                    self._check_monkey_patching_error(name, value)
                                                    with _handle_type_error():
                                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                                "Please use list append or extend method."
                                                                                .format(value))
                                                        if isinstance(value, Enum.YLeaf):
                                                            value = value.name
                                                        if name in ("entry") and name in self.__dict__:
                                                            if isinstance(value, YLeaf):
                                                                self.__dict__[name].set(value.get())
                                                            elif isinstance(value, YLeafList):
                                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                                            else:
                                                                self.__dict__[name].set(value)
                                                        else:
                                                            if hasattr(value, "parent") and name != "parent":
                                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                    value.parent = self
                                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                    value.parent = self
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                                def has_data(self):
                                                    return self.entry.is_set

                                                def has_operation(self):
                                                    return (
                                                        self.yfilter != YFilter.not_set or
                                                        self.entry.yfilter != YFilter.not_set)

                                                def get_segment_path(self):
                                                    path_buffer = ""
                                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                                    return path_buffer

                                                def get_entity_path(self, ancestor):
                                                    path_buffer = ""
                                                    if (ancestor is None):
                                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                    else:
                                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                    leaf_name_data = LeafDataList()
                                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                                    return entity_path

                                                def get_child_by_name(self, child_yang_name, segment_path):
                                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                    if child is not None:
                                                        return child

                                                    return None

                                                def has_leaf_or_child_of_name(self, name):
                                                    if(name == "entry"):
                                                        return True
                                                    return False

                                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                                    if(value_path == "entry"):
                                                        self.entry = value
                                                        self.entry.value_namespace = name_space
                                                        self.entry.value_namespace_prefix = name_space_prefix

                                            def has_data(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_data()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_data()):
                                                        return True
                                                return (
                                                    self.constraint_type.is_set or
                                                    self.constraint_value.is_set or
                                                    self.forward_ref_value.is_set)

                                            def has_operation(self):
                                                for c in self.constraint_extended_value:
                                                    if (c.has_operation()):
                                                        return True
                                                for c in self.extended_forward_ref_value:
                                                    if (c.has_operation()):
                                                        return True
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.constraint_type.yfilter != YFilter.not_set or
                                                    self.constraint_value.yfilter != YFilter.not_set or
                                                    self.forward_ref_value.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "named-affinity" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                if (child_yang_name == "constraint-extended-value"):
                                                    for c in self.constraint_extended_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.constraint_extended_value.append(c)
                                                    return c

                                                if (child_yang_name == "extended-forward-ref-value"):
                                                    for c in self.extended_forward_ref_value:
                                                        segment = c.get_segment_path()
                                                        if (segment_path == segment):
                                                            return c
                                                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                                    c.parent = self
                                                    local_reference_key = "ydk::seg::%s" % segment_path
                                                    self._local_refs[local_reference_key] = c
                                                    self.extended_forward_ref_value.append(c)
                                                    return c

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "constraint-type"):
                                                    self.constraint_type = value
                                                    self.constraint_type.value_namespace = name_space
                                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                                if(value_path == "constraint-value"):
                                                    self.constraint_value = value
                                                    self.constraint_value.value_namespace = name_space
                                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                                if(value_path == "forward-ref-value"):
                                                    self.forward_ref_value = value
                                                    self.forward_ref_value.value_namespace = name_space
                                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.named_affinity:
                                                if (c.has_data()):
                                                    return True
                                            return (
                                                self.affinity_bits.is_set or
                                                self.affinity_mask.is_set)

                                        def has_operation(self):
                                            for c in self.named_affinity:
                                                if (c.has_operation()):
                                                    return True
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.affinity_bits.yfilter != YFilter.not_set or
                                                self.affinity_mask.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "affinity" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "named-affinity"):
                                                for c in self.named_affinity:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.named_affinity.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "affinity-bits"):
                                                self.affinity_bits = value
                                                self.affinity_bits.value_namespace = name_space
                                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                                            if(value_path == "affinity-mask"):
                                                self.affinity_mask = value
                                                self.affinity_mask.value_namespace = name_space
                                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                                    class Logging(Entity):
                                        """
                                        Logging attributes
                                        
                                        .. attribute:: all_logging_enabled
                                        
                                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_bandwidth_change
                                        
                                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_insufficient_bw
                                        
                                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_pcalc_failure_logging_enabled
                                        
                                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_opt
                                        
                                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_re_route
                                        
                                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: lsp_state
                                        
                                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        .. attribute:: s2l_state
                                        
                                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                                        	**type**\:  bool
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                                            self.yang_name = "logging"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                                            self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                                            self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                                            self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                                            self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                                            self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                                            self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                                            self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("all_logging_enabled",
                                                            "lsp_bandwidth_change",
                                                            "lsp_insufficient_bw",
                                                            "lsp_pcalc_failure_logging_enabled",
                                                            "lsp_re_opt",
                                                            "lsp_re_route",
                                                            "lsp_state",
                                                            "s2l_state") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.all_logging_enabled.is_set or
                                                self.lsp_bandwidth_change.is_set or
                                                self.lsp_insufficient_bw.is_set or
                                                self.lsp_pcalc_failure_logging_enabled.is_set or
                                                self.lsp_re_opt.is_set or
                                                self.lsp_re_route.is_set or
                                                self.lsp_state.is_set or
                                                self.s2l_state.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.all_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                                self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                                self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                                self.lsp_re_opt.yfilter != YFilter.not_set or
                                                self.lsp_re_route.yfilter != YFilter.not_set or
                                                self.lsp_state.yfilter != YFilter.not_set or
                                                self.s2l_state.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "logging" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                                            if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                                            if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                                            if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                                            if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                                            if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                                            if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.lsp_state.get_name_leafdata())
                                            if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.s2l_state.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "all-logging-enabled"):
                                                self.all_logging_enabled = value
                                                self.all_logging_enabled.value_namespace = name_space
                                                self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-bandwidth-change"):
                                                self.lsp_bandwidth_change = value
                                                self.lsp_bandwidth_change.value_namespace = name_space
                                                self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-insufficient-bw"):
                                                self.lsp_insufficient_bw = value
                                                self.lsp_insufficient_bw.value_namespace = name_space
                                                self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                                self.lsp_pcalc_failure_logging_enabled = value
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                                self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-opt"):
                                                self.lsp_re_opt = value
                                                self.lsp_re_opt.value_namespace = name_space
                                                self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-re-route"):
                                                self.lsp_re_route = value
                                                self.lsp_re_route.value_namespace = name_space
                                                self.lsp_re_route.value_namespace_prefix = name_space_prefix
                                            if(value_path == "lsp-state"):
                                                self.lsp_state = value
                                                self.lsp_state.value_namespace = name_space
                                                self.lsp_state.value_namespace_prefix = name_space_prefix
                                            if(value_path == "s2l-state"):
                                                self.s2l_state = value
                                                self.s2l_state.value_namespace = name_space
                                                self.s2l_state.value_namespace_prefix = name_space_prefix


                                    class PrependList(Entity):
                                        """
                                        SR prepend list
                                        
                                        .. attribute:: prepend_entry
                                        
                                        	List of prepend entries
                                        	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                                            self.yang_name = "prepend-list"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.prepend_entry = YList(self)

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in () and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                                        class PrependEntry(Entity):
                                            """
                                            List of prepend entries
                                            
                                            .. attribute:: index
                                            
                                            	Prepend index
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: next_label
                                            
                                            	Prepend next label
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: type
                                            
                                            	Prepend Type
                                            	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                                            
                                            

                                            """

                                            _prefix = 'mpls-te-oper'
                                            _revision = '2015-11-09'

                                            def __init__(self):
                                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                                self.yang_name = "prepend-entry"
                                                self.yang_parent_name = "prepend-list"

                                                self.index = YLeaf(YType.uint32, "index")

                                                self.next_label = YLeaf(YType.uint32, "next-label")

                                                self.type = YLeaf(YType.enumeration, "type")

                                            def __setattr__(self, name, value):
                                                self._check_monkey_patching_error(name, value)
                                                with _handle_type_error():
                                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                            "Please use list append or extend method."
                                                                            .format(value))
                                                    if isinstance(value, Enum.YLeaf):
                                                        value = value.name
                                                    if name in ("index",
                                                                "next_label",
                                                                "type") and name in self.__dict__:
                                                        if isinstance(value, YLeaf):
                                                            self.__dict__[name].set(value.get())
                                                        elif isinstance(value, YLeafList):
                                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                                        else:
                                                            self.__dict__[name].set(value)
                                                    else:
                                                        if hasattr(value, "parent") and name != "parent":
                                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                                value.parent = self
                                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                                value.parent = self
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                                            def has_data(self):
                                                return (
                                                    self.index.is_set or
                                                    self.next_label.is_set or
                                                    self.type.is_set)

                                            def has_operation(self):
                                                return (
                                                    self.yfilter != YFilter.not_set or
                                                    self.index.yfilter != YFilter.not_set or
                                                    self.next_label.yfilter != YFilter.not_set or
                                                    self.type.yfilter != YFilter.not_set)

                                            def get_segment_path(self):
                                                path_buffer = ""
                                                path_buffer = "prepend-entry" + path_buffer

                                                return path_buffer

                                            def get_entity_path(self, ancestor):
                                                path_buffer = ""
                                                if (ancestor is None):
                                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                                else:
                                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                                leaf_name_data = LeafDataList()
                                                if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.index.get_name_leafdata())
                                                if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.next_label.get_name_leafdata())
                                                if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                                    leaf_name_data.append(self.type.get_name_leafdata())

                                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                                return entity_path

                                            def get_child_by_name(self, child_yang_name, segment_path):
                                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                                if child is not None:
                                                    return child

                                                return None

                                            def has_leaf_or_child_of_name(self, name):
                                                if(name == "index" or name == "next-label" or name == "type"):
                                                    return True
                                                return False

                                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                                if(value_path == "index"):
                                                    self.index = value
                                                    self.index.value_namespace = name_space
                                                    self.index.value_namespace_prefix = name_space_prefix
                                                if(value_path == "next-label"):
                                                    self.next_label = value
                                                    self.next_label.value_namespace = name_space
                                                    self.next_label.value_namespace_prefix = name_space_prefix
                                                if(value_path == "type"):
                                                    self.type = value
                                                    self.type.value_namespace = name_space
                                                    self.type.value_namespace_prefix = name_space_prefix

                                        def has_data(self):
                                            for c in self.prepend_entry:
                                                if (c.has_data()):
                                                    return True
                                            return False

                                        def has_operation(self):
                                            for c in self.prepend_entry:
                                                if (c.has_operation()):
                                                    return True
                                            return self.yfilter != YFilter.not_set

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "prepend-list" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            if (child_yang_name == "prepend-entry"):
                                                for c in self.prepend_entry:
                                                    segment = c.get_segment_path()
                                                    if (segment_path == segment):
                                                        return c
                                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                                c.parent = self
                                                local_reference_key = "ydk::seg::%s" % segment_path
                                                self._local_refs[local_reference_key] = c
                                                self.prepend_entry.append(c)
                                                return c

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "prepend-entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            pass


                                    class TunnelId(Entity):
                                        """
                                        Tunnel ID
                                        
                                        .. attribute:: entry
                                        
                                        	
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                                            self.yang_name = "tunnel-id"
                                            self.yang_parent_name = "attribute-set-p2p-te"

                                            self.entry = YLeaf(YType.uint16, "entry")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("entry") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                                        def has_data(self):
                                            return self.entry.is_set

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.entry.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "tunnel-id" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.entry.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "entry"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "entry"):
                                                self.entry = value
                                                self.entry.value_namespace = name_space
                                                self.entry.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        for c in self.tunnel_id:
                                            if (c.has_data()):
                                                return True
                                        return (
                                            self.is_affinity_configured.is_set or
                                            self.is_path_invalidation_action_configured.is_set or
                                            self.is_path_invalidation_timeout_configured.is_set or
                                            self.is_path_select_configured.is_set or
                                            self.is_path_selection_metric_configured.is_set or
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                                            self.is_path_selection_segment_routing_margin_configured.is_set or
                                            self.is_path_selection_segment_routing_margin_relative.is_set or
                                            self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                                            self.is_pce_configured.is_set or
                                            self.is_pce_disj_group_id_configured.is_set or
                                            self.is_pce_disj_source_configured.is_set or
                                            self.is_pce_disj_type_configured.is_set or
                                            self.is_pceb_dj_source_configured.is_set or
                                            self.is_pcebd_group_id_configured.is_set or
                                            self.is_prepend_list_configured.is_set or
                                            self.path_invalidation_timeout.is_set or
                                            self.path_selection_invalidation_action.is_set or
                                            self.path_selection_metric.is_set or
                                            self.path_selection_segment_routing_adjacency_protection.is_set or
                                            self.path_selection_segment_routing_margin.is_set or
                                            self.path_selection_segment_routing_segment_limit.is_set or
                                            self.pcebd_group_id.is_set or
                                            self.pcebd_source_address.is_set or
                                            self.pcedp_group_id.is_set or
                                            self.pcedp_source_address.is_set or
                                            self.pcedp_type.is_set or
                                            (self.affinity is not None and self.affinity.has_data()) or
                                            (self.logging is not None and self.logging.has_data()) or
                                            (self.prepend_list is not None and self.prepend_list.has_data()))

                                    def has_operation(self):
                                        for c in self.tunnel_id:
                                            if (c.has_operation()):
                                                return True
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.is_affinity_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                                            self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                                            self.is_path_select_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                                            self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                                            self.is_pce_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                                            self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                                            self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                                            self.is_prepend_list_configured.yfilter != YFilter.not_set or
                                            self.path_invalidation_timeout.yfilter != YFilter.not_set or
                                            self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                                            self.path_selection_metric.yfilter != YFilter.not_set or
                                            self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                                            self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                                            self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                                            self.pcebd_group_id.yfilter != YFilter.not_set or
                                            self.pcebd_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_group_id.yfilter != YFilter.not_set or
                                            self.pcedp_source_address.yfilter != YFilter.not_set or
                                            self.pcedp_type.yfilter != YFilter.not_set or
                                            (self.affinity is not None and self.affinity.has_operation()) or
                                            (self.logging is not None and self.logging.has_operation()) or
                                            (self.prepend_list is not None and self.prepend_list.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "attribute-set-p2p-te" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                                        if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                                        if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                                        if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                                        if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                                        if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                                        if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                                        if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                                        if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                                        if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                                        if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                                        if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                                        if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                                        if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                                        if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                                        if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                                        if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                                        if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                                        if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                                        if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                                        if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                                        if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                                        if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "affinity"):
                                            if (self.affinity is None):
                                                self.affinity = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                                self.affinity.parent = self
                                                self._children_name_map["affinity"] = "affinity"
                                            return self.affinity

                                        if (child_yang_name == "logging"):
                                            if (self.logging is None):
                                                self.logging = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                                self.logging.parent = self
                                                self._children_name_map["logging"] = "logging"
                                            return self.logging

                                        if (child_yang_name == "prepend-list"):
                                            if (self.prepend_list is None):
                                                self.prepend_list = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                                self.prepend_list.parent = self
                                                self._children_name_map["prepend_list"] = "prepend-list"
                                            return self.prepend_list

                                        if (child_yang_name == "tunnel-id"):
                                            for c in self.tunnel_id:
                                                segment = c.get_segment_path()
                                                if (segment_path == segment):
                                                    return c
                                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                                            c.parent = self
                                            local_reference_key = "ydk::seg::%s" % segment_path
                                            self._local_refs[local_reference_key] = c
                                            self.tunnel_id.append(c)
                                            return c

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "is-affinity-configured"):
                                            self.is_affinity_configured = value
                                            self.is_affinity_configured.value_namespace = name_space
                                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-action-configured"):
                                            self.is_path_invalidation_action_configured = value
                                            self.is_path_invalidation_action_configured.value_namespace = name_space
                                            self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-invalidation-timeout-configured"):
                                            self.is_path_invalidation_timeout_configured = value
                                            self.is_path_invalidation_timeout_configured.value_namespace = name_space
                                            self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-select-configured"):
                                            self.is_path_select_configured = value
                                            self.is_path_select_configured.value_namespace = name_space
                                            self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-metric-configured"):
                                            self.is_path_selection_metric_configured = value
                                            self.is_path_selection_metric_configured.value_namespace = name_space
                                            self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                                            self.is_path_selection_segment_routing_adjacency_protection_configured = value
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                                            self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-margin-configured"):
                                            self.is_path_selection_segment_routing_margin_configured = value
                                            self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                                            self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-margin-relative"):
                                            self.is_path_selection_segment_routing_margin_relative = value
                                            self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                                            self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                                            self.is_path_selection_segment_routing_segment_limit_configured = value
                                            self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                                            self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-configured"):
                                            self.is_pce_configured = value
                                            self.is_pce_configured.value_namespace = name_space
                                            self.is_pce_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-group-id-configured"):
                                            self.is_pce_disj_group_id_configured = value
                                            self.is_pce_disj_group_id_configured.value_namespace = name_space
                                            self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-source-configured"):
                                            self.is_pce_disj_source_configured = value
                                            self.is_pce_disj_source_configured.value_namespace = name_space
                                            self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pce-disj-type-configured"):
                                            self.is_pce_disj_type_configured = value
                                            self.is_pce_disj_type_configured.value_namespace = name_space
                                            self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pceb-dj-source-configured"):
                                            self.is_pceb_dj_source_configured = value
                                            self.is_pceb_dj_source_configured.value_namespace = name_space
                                            self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-pcebd-group-id-configured"):
                                            self.is_pcebd_group_id_configured = value
                                            self.is_pcebd_group_id_configured.value_namespace = name_space
                                            self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "is-prepend-list-configured"):
                                            self.is_prepend_list_configured = value
                                            self.is_prepend_list_configured.value_namespace = name_space
                                            self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-invalidation-timeout"):
                                            self.path_invalidation_timeout = value
                                            self.path_invalidation_timeout.value_namespace = name_space
                                            self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-invalidation-action"):
                                            self.path_selection_invalidation_action = value
                                            self.path_selection_invalidation_action.value_namespace = name_space
                                            self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-metric"):
                                            self.path_selection_metric = value
                                            self.path_selection_metric.value_namespace = name_space
                                            self.path_selection_metric.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-segment-routing-adjacency-protection"):
                                            self.path_selection_segment_routing_adjacency_protection = value
                                            self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                                            self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-segment-routing-margin"):
                                            self.path_selection_segment_routing_margin = value
                                            self.path_selection_segment_routing_margin.value_namespace = name_space
                                            self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                                        if(value_path == "path-selection-segment-routing-segment-limit"):
                                            self.path_selection_segment_routing_segment_limit = value
                                            self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                                            self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-group-id"):
                                            self.pcebd_group_id = value
                                            self.pcebd_group_id.value_namespace = name_space
                                            self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcebd-source-address"):
                                            self.pcebd_source_address = value
                                            self.pcebd_source_address.value_namespace = name_space
                                            self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-group-id"):
                                            self.pcedp_group_id = value
                                            self.pcedp_group_id.value_namespace = name_space
                                            self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-source-address"):
                                            self.pcedp_source_address = value
                                            self.pcedp_source_address.value_namespace = name_space
                                            self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                                        if(value_path == "pcedp-type"):
                                            self.pcedp_type = value
                                            self.pcedp_type.value_namespace = name_space
                                            self.pcedp_type.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.tunnel_attribute_set_type.is_set or
                                        (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                                        (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                                        (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                                        (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                                        (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                                        (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                                        (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                                        (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                                        (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                                        (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                                        (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                                        (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                                        (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                                        (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "attribute-set-union" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "attribute-set-aps-pp"):
                                        if (self.attribute_set_aps_pp is None):
                                            self.attribute_set_aps_pp = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetApsPp()
                                            self.attribute_set_aps_pp.parent = self
                                            self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                                        return self.attribute_set_aps_pp

                                    if (child_yang_name == "attribute-set-autobackup"):
                                        if (self.attribute_set_autobackup is None):
                                            self.attribute_set_autobackup = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                                            self.attribute_set_autobackup.parent = self
                                            self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                                        return self.attribute_set_autobackup

                                    if (child_yang_name == "attribute-set-automesh"):
                                        if (self.attribute_set_automesh is None):
                                            self.attribute_set_automesh = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                                            self.attribute_set_automesh.parent = self
                                            self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                                        return self.attribute_set_automesh

                                    if (child_yang_name == "attribute-set-p2mpte"):
                                        if (self.attribute_set_p2mpte is None):
                                            self.attribute_set_p2mpte = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                                            self.attribute_set_p2mpte.parent = self
                                            self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                                        return self.attribute_set_p2mpte

                                    if (child_yang_name == "attribute-set-p2p-te"):
                                        if (self.attribute_set_p2p_te is None):
                                            self.attribute_set_p2p_te = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                                            self.attribute_set_p2p_te.parent = self
                                            self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                                        return self.attribute_set_p2p_te

                                    if (child_yang_name == "attribute-set-path-option"):
                                        if (self.attribute_set_path_option is None):
                                            self.attribute_set_path_option = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetPathOption()
                                            self.attribute_set_path_option.parent = self
                                            self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                                        return self.attribute_set_path_option

                                    if (child_yang_name == "attribute-set-xro"):
                                        if (self.attribute_set_xro is None):
                                            self.attribute_set_xro = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion.AttributeSetXro()
                                            self.attribute_set_xro.parent = self
                                            self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                                        return self.attribute_set_xro

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "tunnel-attribute-set-type"):
                                        self.tunnel_attribute_set_type = value
                                        self.tunnel_attribute_set_type.value_namespace = name_space
                                        self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.tunnel_attribute_set_name.is_set or
                                    self.tunnel_attribute_set_name_crc32.is_set or
                                    (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                                    self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                                    (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "xro-attribute-set" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                                if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "attribute-set-union"):
                                    if (self.attribute_set_union is None):
                                        self.attribute_set_union = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet.AttributeSetUnion()
                                        self.attribute_set_union.parent = self
                                        self._children_name_map["attribute_set_union"] = "attribute-set-union"
                                    return self.attribute_set_union

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "attribute-set-union" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "tunnel-attribute-set-name"):
                                    self.tunnel_attribute_set_name = value
                                    self.tunnel_attribute_set_name.value_namespace = name_space
                                    self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-attribute-set-name-crc32"):
                                    self.tunnel_attribute_set_name_crc32 = value
                                    self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                                    self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix


                        class PathCalculationError(Entity):
                            """
                            Path computation information
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\:  str
                            
                            .. attribute:: log_time
                            
                            	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: lsp_mode
                            
                            	LSP Mode
                            	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.PathCalculationError, self).__init__()

                                self.yang_name = "path-calculation-error"
                                self.yang_parent_name = "path-option"

                                self.error_message = YLeaf(YType.str, "error-message")

                                self.log_time = YLeaf(YType.uint32, "log-time")

                                self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("error_message",
                                                "log_time",
                                                "lsp_mode") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.PathCalculationError, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.PathCalculationError, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.error_message.is_set or
                                    self.log_time.is_set or
                                    self.lsp_mode.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.error_message.yfilter != YFilter.not_set or
                                    self.log_time.yfilter != YFilter.not_set or
                                    self.lsp_mode.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "path-calculation-error" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.error_message.get_name_leafdata())
                                if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.log_time.get_name_leafdata())
                                if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "error-message"):
                                    self.error_message = value
                                    self.error_message.value_namespace = name_space
                                    self.error_message.value_namespace_prefix = name_space_prefix
                                if(value_path == "log-time"):
                                    self.log_time = value
                                    self.log_time.value_namespace = name_space
                                    self.log_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-mode"):
                                    self.lsp_mode = value
                                    self.lsp_mode.value_namespace = name_space
                                    self.lsp_mode.value_namespace_prefix = name_space_prefix


                        class RemergeError(Entity):
                            """
                            Path computation remerge resolve info
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\:  str
                            
                            .. attribute:: log_time
                            
                            	Time in seconds seconds (since Jan. 1, 1970) when the error message is logged
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: lsp_mode
                            
                            	LSP Mode
                            	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.RemergeError, self).__init__()

                                self.yang_name = "remerge-error"
                                self.yang_parent_name = "path-option"

                                self.error_message = YLeaf(YType.str, "error-message")

                                self.log_time = YLeaf(YType.uint32, "log-time")

                                self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("error_message",
                                                "log_time",
                                                "lsp_mode") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.RemergeError, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.RemergeError, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.error_message.is_set or
                                    self.log_time.is_set or
                                    self.lsp_mode.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.error_message.yfilter != YFilter.not_set or
                                    self.log_time.yfilter != YFilter.not_set or
                                    self.lsp_mode.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "remerge-error" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.error_message.get_name_leafdata())
                                if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.log_time.get_name_leafdata())
                                if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_mode.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "error-message" or name == "log-time" or name == "lsp-mode"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "error-message"):
                                    self.error_message = value
                                    self.error_message.value_namespace = name_space
                                    self.error_message.value_namespace_prefix = name_space_prefix
                                if(value_path == "log-time"):
                                    self.log_time = value
                                    self.log_time.value_namespace = name_space
                                    self.log_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-mode"):
                                    self.lsp_mode = value
                                    self.lsp_mode.value_namespace = name_space
                                    self.lsp_mode.value_namespace_prefix = name_space_prefix


                        class SignallingError(Entity):
                            """
                            Signalling information
                            
                            .. attribute:: error
                            
                            	Path Error code
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: error_message
                            
                            	Error message (for display purposes only)
                            	**type**\:  str
                            
                            .. attribute:: error_node
                            
                            	Source address of the error generating node
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: log_time
                            
                            	Time in seconds when the error message is logged
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: lsp_mode
                            
                            	LSPMode
                            	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                            
                            .. attribute:: reverse_lsp
                            
                            	Indicates if error is on the reverse LSP
                            	**type**\:  bool
                            
                            .. attribute:: signalling_lsp_id
                            
                            	LSP\-id for which the error was received
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: sub_code
                            
                            	Path Error subcode
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.SignallingError, self).__init__()

                                self.yang_name = "signalling-error"
                                self.yang_parent_name = "path-option"

                                self.error = YLeaf(YType.uint8, "error")

                                self.error_message = YLeaf(YType.str, "error-message")

                                self.error_node = YLeaf(YType.uint32, "error-node")

                                self.log_time = YLeaf(YType.uint32, "log-time")

                                self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                                self.reverse_lsp = YLeaf(YType.boolean, "reverse-lsp")

                                self.signalling_lsp_id = YLeaf(YType.uint16, "signalling-lsp-id")

                                self.sub_code = YLeaf(YType.uint16, "sub-code")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("error",
                                                "error_message",
                                                "error_node",
                                                "log_time",
                                                "lsp_mode",
                                                "reverse_lsp",
                                                "signalling_lsp_id",
                                                "sub_code") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.SignallingError, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.SignallingError, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.error.is_set or
                                    self.error_message.is_set or
                                    self.error_node.is_set or
                                    self.log_time.is_set or
                                    self.lsp_mode.is_set or
                                    self.reverse_lsp.is_set or
                                    self.signalling_lsp_id.is_set or
                                    self.sub_code.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.error.yfilter != YFilter.not_set or
                                    self.error_message.yfilter != YFilter.not_set or
                                    self.error_node.yfilter != YFilter.not_set or
                                    self.log_time.yfilter != YFilter.not_set or
                                    self.lsp_mode.yfilter != YFilter.not_set or
                                    self.reverse_lsp.yfilter != YFilter.not_set or
                                    self.signalling_lsp_id.yfilter != YFilter.not_set or
                                    self.sub_code.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "signalling-error" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.error.is_set or self.error.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.error.get_name_leafdata())
                                if (self.error_message.is_set or self.error_message.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.error_message.get_name_leafdata())
                                if (self.error_node.is_set or self.error_node.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.error_node.get_name_leafdata())
                                if (self.log_time.is_set or self.log_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.log_time.get_name_leafdata())
                                if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_mode.get_name_leafdata())
                                if (self.reverse_lsp.is_set or self.reverse_lsp.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reverse_lsp.get_name_leafdata())
                                if (self.signalling_lsp_id.is_set or self.signalling_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.signalling_lsp_id.get_name_leafdata())
                                if (self.sub_code.is_set or self.sub_code.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.sub_code.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "error" or name == "error-message" or name == "error-node" or name == "log-time" or name == "lsp-mode" or name == "reverse-lsp" or name == "signalling-lsp-id" or name == "sub-code"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "error"):
                                    self.error = value
                                    self.error.value_namespace = name_space
                                    self.error.value_namespace_prefix = name_space_prefix
                                if(value_path == "error-message"):
                                    self.error_message = value
                                    self.error_message.value_namespace = name_space
                                    self.error_message.value_namespace_prefix = name_space_prefix
                                if(value_path == "error-node"):
                                    self.error_node = value
                                    self.error_node.value_namespace = name_space
                                    self.error_node.value_namespace_prefix = name_space_prefix
                                if(value_path == "log-time"):
                                    self.log_time = value
                                    self.log_time.value_namespace = name_space
                                    self.log_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-mode"):
                                    self.lsp_mode = value
                                    self.lsp_mode.value_namespace = name_space
                                    self.lsp_mode.value_namespace_prefix = name_space_prefix
                                if(value_path == "reverse-lsp"):
                                    self.reverse_lsp = value
                                    self.reverse_lsp.value_namespace = name_space
                                    self.reverse_lsp.value_namespace_prefix = name_space_prefix
                                if(value_path == "signalling-lsp-id"):
                                    self.signalling_lsp_id = value
                                    self.signalling_lsp_id.value_namespace = name_space
                                    self.signalling_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "sub-code"):
                                    self.sub_code = value
                                    self.sub_code.value_namespace = name_space
                                    self.sub_code.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.path_calculation_error:
                                if (c.has_data()):
                                    return True
                            for c in self.remerge_error:
                                if (c.has_data()):
                                    return True
                            for c in self.signalling_error:
                                if (c.has_data()):
                                    return True
                            return (
                                self.attribute_set_found.is_set or
                                self.explicit_path_id.is_set or
                                self.explicit_path_name.is_set or
                                self.has_attribute_set.is_set or
                                self.has_xro_attribute_set.is_set or
                                self.holddown_duration.is_set or
                                self.is_disabled.is_set or
                                self.is_helddown.is_set or
                                self.is_lockdown.is_set or
                                self.is_segment_routing.is_set or
                                self.is_strict_explicit_path.is_set or
                                self.is_verbatim.is_set or
                                self.option_index.is_set or
                                self.option_index_is_valid.is_set or
                                self.path_option_area_id.is_set or
                                self.path_option_name.is_set or
                                self.path_option_type.is_set or
                                self.pce_address.is_set or
                                self.protected_by_path_option_index.is_set or
                                self.restored_from_path_option_index.is_set or
                                self.xro_attribute_set_found.is_set or
                                (self.attribute_set is not None and self.attribute_set.has_data()) or
                                (self.xro_attribute_set is not None and self.xro_attribute_set.has_data()))

                        def has_operation(self):
                            for c in self.path_calculation_error:
                                if (c.has_operation()):
                                    return True
                            for c in self.remerge_error:
                                if (c.has_operation()):
                                    return True
                            for c in self.signalling_error:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.attribute_set_found.yfilter != YFilter.not_set or
                                self.explicit_path_id.yfilter != YFilter.not_set or
                                self.explicit_path_name.yfilter != YFilter.not_set or
                                self.has_attribute_set.yfilter != YFilter.not_set or
                                self.has_xro_attribute_set.yfilter != YFilter.not_set or
                                self.holddown_duration.yfilter != YFilter.not_set or
                                self.is_disabled.yfilter != YFilter.not_set or
                                self.is_helddown.yfilter != YFilter.not_set or
                                self.is_lockdown.yfilter != YFilter.not_set or
                                self.is_segment_routing.yfilter != YFilter.not_set or
                                self.is_strict_explicit_path.yfilter != YFilter.not_set or
                                self.is_verbatim.yfilter != YFilter.not_set or
                                self.option_index.yfilter != YFilter.not_set or
                                self.option_index_is_valid.yfilter != YFilter.not_set or
                                self.path_option_area_id.yfilter != YFilter.not_set or
                                self.path_option_name.yfilter != YFilter.not_set or
                                self.path_option_type.yfilter != YFilter.not_set or
                                self.pce_address.yfilter != YFilter.not_set or
                                self.protected_by_path_option_index.yfilter != YFilter.not_set or
                                self.restored_from_path_option_index.yfilter != YFilter.not_set or
                                self.xro_attribute_set_found.yfilter != YFilter.not_set or
                                (self.attribute_set is not None and self.attribute_set.has_operation()) or
                                (self.xro_attribute_set is not None and self.xro_attribute_set.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "path-option" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.attribute_set_found.is_set or self.attribute_set_found.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.attribute_set_found.get_name_leafdata())
                            if (self.explicit_path_id.is_set or self.explicit_path_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.explicit_path_id.get_name_leafdata())
                            if (self.explicit_path_name.is_set or self.explicit_path_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.explicit_path_name.get_name_leafdata())
                            if (self.has_attribute_set.is_set or self.has_attribute_set.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.has_attribute_set.get_name_leafdata())
                            if (self.has_xro_attribute_set.is_set or self.has_xro_attribute_set.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.has_xro_attribute_set.get_name_leafdata())
                            if (self.holddown_duration.is_set or self.holddown_duration.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.holddown_duration.get_name_leafdata())
                            if (self.is_disabled.is_set or self.is_disabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_disabled.get_name_leafdata())
                            if (self.is_helddown.is_set or self.is_helddown.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_helddown.get_name_leafdata())
                            if (self.is_lockdown.is_set or self.is_lockdown.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_lockdown.get_name_leafdata())
                            if (self.is_segment_routing.is_set or self.is_segment_routing.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_segment_routing.get_name_leafdata())
                            if (self.is_strict_explicit_path.is_set or self.is_strict_explicit_path.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_strict_explicit_path.get_name_leafdata())
                            if (self.is_verbatim.is_set or self.is_verbatim.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_verbatim.get_name_leafdata())
                            if (self.option_index.is_set or self.option_index.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.option_index.get_name_leafdata())
                            if (self.option_index_is_valid.is_set or self.option_index_is_valid.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.option_index_is_valid.get_name_leafdata())
                            if (self.path_option_area_id.is_set or self.path_option_area_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_option_area_id.get_name_leafdata())
                            if (self.path_option_name.is_set or self.path_option_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_option_name.get_name_leafdata())
                            if (self.path_option_type.is_set or self.path_option_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_option_type.get_name_leafdata())
                            if (self.pce_address.is_set or self.pce_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.pce_address.get_name_leafdata())
                            if (self.protected_by_path_option_index.is_set or self.protected_by_path_option_index.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.protected_by_path_option_index.get_name_leafdata())
                            if (self.restored_from_path_option_index.is_set or self.restored_from_path_option_index.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.restored_from_path_option_index.get_name_leafdata())
                            if (self.xro_attribute_set_found.is_set or self.xro_attribute_set_found.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.xro_attribute_set_found.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "attribute-set"):
                                if (self.attribute_set is None):
                                    self.attribute_set = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.AttributeSet()
                                    self.attribute_set.parent = self
                                    self._children_name_map["attribute_set"] = "attribute-set"
                                return self.attribute_set

                            if (child_yang_name == "path-calculation-error"):
                                for c in self.path_calculation_error:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.PathCalculationError()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.path_calculation_error.append(c)
                                return c

                            if (child_yang_name == "remerge-error"):
                                for c in self.remerge_error:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.RemergeError()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.remerge_error.append(c)
                                return c

                            if (child_yang_name == "signalling-error"):
                                for c in self.signalling_error:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.SignallingError()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.signalling_error.append(c)
                                return c

                            if (child_yang_name == "xro-attribute-set"):
                                if (self.xro_attribute_set is None):
                                    self.xro_attribute_set = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption.XroAttributeSet()
                                    self.xro_attribute_set.parent = self
                                    self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                                return self.xro_attribute_set

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "attribute-set" or name == "path-calculation-error" or name == "remerge-error" or name == "signalling-error" or name == "xro-attribute-set" or name == "attribute-set-found" or name == "explicit-path-id" or name == "explicit-path-name" or name == "has-attribute-set" or name == "has-xro-attribute-set" or name == "holddown-duration" or name == "is-disabled" or name == "is-helddown" or name == "is-lockdown" or name == "is-segment-routing" or name == "is-strict-explicit-path" or name == "is-verbatim" or name == "option-index" or name == "option-index-is-valid" or name == "path-option-area-id" or name == "path-option-name" or name == "path-option-type" or name == "pce-address" or name == "protected-by-path-option-index" or name == "restored-from-path-option-index" or name == "xro-attribute-set-found"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "attribute-set-found"):
                                self.attribute_set_found = value
                                self.attribute_set_found.value_namespace = name_space
                                self.attribute_set_found.value_namespace_prefix = name_space_prefix
                            if(value_path == "explicit-path-id"):
                                self.explicit_path_id = value
                                self.explicit_path_id.value_namespace = name_space
                                self.explicit_path_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "explicit-path-name"):
                                self.explicit_path_name = value
                                self.explicit_path_name.value_namespace = name_space
                                self.explicit_path_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "has-attribute-set"):
                                self.has_attribute_set = value
                                self.has_attribute_set.value_namespace = name_space
                                self.has_attribute_set.value_namespace_prefix = name_space_prefix
                            if(value_path == "has-xro-attribute-set"):
                                self.has_xro_attribute_set = value
                                self.has_xro_attribute_set.value_namespace = name_space
                                self.has_xro_attribute_set.value_namespace_prefix = name_space_prefix
                            if(value_path == "holddown-duration"):
                                self.holddown_duration = value
                                self.holddown_duration.value_namespace = name_space
                                self.holddown_duration.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-disabled"):
                                self.is_disabled = value
                                self.is_disabled.value_namespace = name_space
                                self.is_disabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-helddown"):
                                self.is_helddown = value
                                self.is_helddown.value_namespace = name_space
                                self.is_helddown.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-lockdown"):
                                self.is_lockdown = value
                                self.is_lockdown.value_namespace = name_space
                                self.is_lockdown.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-segment-routing"):
                                self.is_segment_routing = value
                                self.is_segment_routing.value_namespace = name_space
                                self.is_segment_routing.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-strict-explicit-path"):
                                self.is_strict_explicit_path = value
                                self.is_strict_explicit_path.value_namespace = name_space
                                self.is_strict_explicit_path.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-verbatim"):
                                self.is_verbatim = value
                                self.is_verbatim.value_namespace = name_space
                                self.is_verbatim.value_namespace_prefix = name_space_prefix
                            if(value_path == "option-index"):
                                self.option_index = value
                                self.option_index.value_namespace = name_space
                                self.option_index.value_namespace_prefix = name_space_prefix
                            if(value_path == "option-index-is-valid"):
                                self.option_index_is_valid = value
                                self.option_index_is_valid.value_namespace = name_space
                                self.option_index_is_valid.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-option-area-id"):
                                self.path_option_area_id = value
                                self.path_option_area_id.value_namespace = name_space
                                self.path_option_area_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-option-name"):
                                self.path_option_name = value
                                self.path_option_name.value_namespace = name_space
                                self.path_option_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-option-type"):
                                self.path_option_type = value
                                self.path_option_type.value_namespace = name_space
                                self.path_option_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "pce-address"):
                                self.pce_address = value
                                self.pce_address.value_namespace = name_space
                                self.pce_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "protected-by-path-option-index"):
                                self.protected_by_path_option_index = value
                                self.protected_by_path_option_index.value_namespace = name_space
                                self.protected_by_path_option_index.value_namespace_prefix = name_space_prefix
                            if(value_path == "restored-from-path-option-index"):
                                self.restored_from_path_option_index = value
                                self.restored_from_path_option_index.value_namespace = name_space
                                self.restored_from_path_option_index.value_namespace_prefix = name_space_prefix
                            if(value_path == "xro-attribute-set-found"):
                                self.xro_attribute_set_found = value
                                self.xro_attribute_set_found.value_namespace = name_space
                                self.xro_attribute_set_found.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.path_option:
                            if (c.has_data()):
                                return True
                        for c in self.path_option_entry:
                            if (c.has_data()):
                                return True
                        return (
                            self.active_path_option_index.is_set or
                            self.destination_address.is_set or
                            self.destination_deletion_cause.is_set or
                            self.destination_deletion_sub_cause.is_set or
                            self.destination_deletion_timestamp.is_set or
                            self.destination_state.is_set or
                            self.is_inter_area.is_set or
                            self.path_change_time.is_set or
                            self.path_option_exhausted.is_set or
                            self.s2l_exist.is_set or
                            self.total_uptime.is_set or
                            self.uptime.is_set or
                            (self.inter_area_reoptimization is not None and self.inter_area_reoptimization.has_data()))

                    def has_operation(self):
                        for c in self.path_option:
                            if (c.has_operation()):
                                return True
                        for c in self.path_option_entry:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.active_path_option_index.yfilter != YFilter.not_set or
                            self.destination_address.yfilter != YFilter.not_set or
                            self.destination_deletion_cause.yfilter != YFilter.not_set or
                            self.destination_deletion_sub_cause.yfilter != YFilter.not_set or
                            self.destination_deletion_timestamp.yfilter != YFilter.not_set or
                            self.destination_state.yfilter != YFilter.not_set or
                            self.is_inter_area.yfilter != YFilter.not_set or
                            self.path_change_time.yfilter != YFilter.not_set or
                            self.path_option_exhausted.yfilter != YFilter.not_set or
                            self.s2l_exist.yfilter != YFilter.not_set or
                            self.total_uptime.yfilter != YFilter.not_set or
                            self.uptime.yfilter != YFilter.not_set or
                            (self.inter_area_reoptimization is not None and self.inter_area_reoptimization.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "destination" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.active_path_option_index.is_set or self.active_path_option_index.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.active_path_option_index.get_name_leafdata())
                        if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.destination_address.get_name_leafdata())
                        if (self.destination_deletion_cause.is_set or self.destination_deletion_cause.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.destination_deletion_cause.get_name_leafdata())
                        if (self.destination_deletion_sub_cause.is_set or self.destination_deletion_sub_cause.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.destination_deletion_sub_cause.get_name_leafdata())
                        if (self.destination_deletion_timestamp.is_set or self.destination_deletion_timestamp.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.destination_deletion_timestamp.get_name_leafdata())
                        if (self.destination_state.is_set or self.destination_state.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.destination_state.get_name_leafdata())
                        if (self.is_inter_area.is_set or self.is_inter_area.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_inter_area.get_name_leafdata())
                        if (self.path_change_time.is_set or self.path_change_time.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.path_change_time.get_name_leafdata())
                        if (self.path_option_exhausted.is_set or self.path_option_exhausted.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.path_option_exhausted.get_name_leafdata())
                        if (self.s2l_exist.is_set or self.s2l_exist.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.s2l_exist.get_name_leafdata())
                        if (self.total_uptime.is_set or self.total_uptime.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.total_uptime.get_name_leafdata())
                        if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.uptime.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "inter-area-reoptimization"):
                            if (self.inter_area_reoptimization is None):
                                self.inter_area_reoptimization = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.InterAreaReoptimization()
                                self.inter_area_reoptimization.parent = self
                                self._children_name_map["inter_area_reoptimization"] = "inter-area-reoptimization"
                            return self.inter_area_reoptimization

                        if (child_yang_name == "path-option"):
                            for c in self.path_option:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOption()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.path_option.append(c)
                            return c

                        if (child_yang_name == "path-option-entry"):
                            for c in self.path_option_entry:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination.PathOptionEntry()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.path_option_entry.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "inter-area-reoptimization" or name == "path-option" or name == "path-option-entry" or name == "active-path-option-index" or name == "destination-address" or name == "destination-deletion-cause" or name == "destination-deletion-sub-cause" or name == "destination-deletion-timestamp" or name == "destination-state" or name == "is-inter-area" or name == "path-change-time" or name == "path-option-exhausted" or name == "s2l-exist" or name == "total-uptime" or name == "uptime"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "active-path-option-index"):
                            self.active_path_option_index = value
                            self.active_path_option_index.value_namespace = name_space
                            self.active_path_option_index.value_namespace_prefix = name_space_prefix
                        if(value_path == "destination-address"):
                            self.destination_address = value
                            self.destination_address.value_namespace = name_space
                            self.destination_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "destination-deletion-cause"):
                            self.destination_deletion_cause = value
                            self.destination_deletion_cause.value_namespace = name_space
                            self.destination_deletion_cause.value_namespace_prefix = name_space_prefix
                        if(value_path == "destination-deletion-sub-cause"):
                            self.destination_deletion_sub_cause = value
                            self.destination_deletion_sub_cause.value_namespace = name_space
                            self.destination_deletion_sub_cause.value_namespace_prefix = name_space_prefix
                        if(value_path == "destination-deletion-timestamp"):
                            self.destination_deletion_timestamp = value
                            self.destination_deletion_timestamp.value_namespace = name_space
                            self.destination_deletion_timestamp.value_namespace_prefix = name_space_prefix
                        if(value_path == "destination-state"):
                            self.destination_state = value
                            self.destination_state.value_namespace = name_space
                            self.destination_state.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-inter-area"):
                            self.is_inter_area = value
                            self.is_inter_area.value_namespace = name_space
                            self.is_inter_area.value_namespace_prefix = name_space_prefix
                        if(value_path == "path-change-time"):
                            self.path_change_time = value
                            self.path_change_time.value_namespace = name_space
                            self.path_change_time.value_namespace_prefix = name_space_prefix
                        if(value_path == "path-option-exhausted"):
                            self.path_option_exhausted = value
                            self.path_option_exhausted.value_namespace = name_space
                            self.path_option_exhausted.value_namespace_prefix = name_space_prefix
                        if(value_path == "s2l-exist"):
                            self.s2l_exist = value
                            self.s2l_exist.value_namespace = name_space
                            self.s2l_exist.value_namespace_prefix = name_space_prefix
                        if(value_path == "total-uptime"):
                            self.total_uptime = value
                            self.total_uptime.value_namespace = name_space
                            self.total_uptime.value_namespace_prefix = name_space_prefix
                        if(value_path == "uptime"):
                            self.uptime = value
                            self.uptime.value_namespace = name_space
                            self.uptime.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.destination:
                        if (c.has_data()):
                            return True
                    return (
                        self.tunnel_name.is_set or
                        self.admin_state.is_set or
                        self.affinity_failure_delayed_tear_time_remained.is_set or
                        self.affinity_failure_reopt_disabled.is_set or
                        self.affinity_failure_reopt_time_remained.is_set or
                        self.area_id.is_set or
                        self.auto_route.is_set or
                        self.autoroute_announce_exclude_segment_routing.is_set or
                        self.bandwidth_requested.is_set or
                        self.bandwidth_type.is_set or
                        self.binding_label.is_set or
                        self.binding_label_exists.is_set or
                        self.create_time.is_set or
                        self.destination_disabled_count.is_set or
                        self.destination_down_count.is_set or
                        self.destination_up_count.is_set or
                        self.drop_mode.is_set or
                        self.explicit_path_change.is_set or
                        self.fail_reason.is_set or
                        self.forwarding_adjacency.is_set or
                        self.hop_limit_ignored_reason.is_set or
                        self.invalidation_time_remained.is_set or
                        self.is_auto_backup.is_set or
                        self.is_auto_pcc.is_set or
                        self.is_bandwidth_protect.is_set or
                        self.is_hop_limit_ignore.is_set or
                        self.is_inter_area_tunnel.is_set or
                        self.is_interface.is_set or
                        self.is_named.is_set or
                        self.is_node_protected.is_set or
                        self.is_passive.is_set or
                        self.is_pce_delegated.is_set or
                        self.last_hop_ifindex.is_set or
                        self.last_path_change.is_set or
                        self.load_share_factor.is_set or
                        self.load_share_type.is_set or
                        self.lsp_wrap_label.is_set or
                        self.lsp_wrap_protection_enabled.is_set or
                        self.metric_qualifier.is_set or
                        self.metric_type.is_set or
                        self.operational_state.is_set or
                        self.operational_state_changes.is_set or
                        self.outbound_frr_state.is_set or
                        self.passive_tunnel_name.is_set or
                        self.path_option_change.is_set or
                        self.pce_fail_reason.is_set or
                        self.persistent_bytes.is_set or
                        self.persistent_packets.is_set or
                        self.re_opt_hold_down_timer_remaining.is_set or
                        self.reroute_pending.is_set or
                        self.role_standby.is_set or
                        self.signaled_name.is_set or
                        self.snmp_index.is_set or
                        self.tie_breaker.is_set or
                        self.tiebreaker_qualifier.is_set or
                        self.tiebreaker_type.is_set or
                        self.tunnel_attribute_set_name.is_set or
                        self.tunnel_attribute_set_type.is_set or
                        self.tunnel_interface_name.is_set or
                        self.tunnel_recovering.is_set or
                        self.uptime.is_set or
                        self.xro_attribute_set_name.is_set or
                        (self.auto_backup is not None and self.auto_backup.has_data()) or
                        (self.auto_mesh is not None and self.auto_mesh.has_data()) or
                        (self.auto_pcc is not None and self.auto_pcc.has_data()) or
                        (self.bfd_info is not None and self.bfd_info.has_data()) or
                        (self.bidir is not None and self.bidir.has_data()) or
                        (self.cleaned_lsp is not None and self.cleaned_lsp.has_data()) or
                        (self.config is not None and self.config.has_data()) or
                        (self.delay_clean_pp_lsp is not None and self.delay_clean_pp_lsp.has_data()) or
                        (self.flex_info is not None and self.flex_info.has_data()) or
                        (self.history is not None and self.history.has_data()) or
                        (self.otn_bidir is not None and self.otn_bidir.has_data()) or
                        (self.p2p_info is not None and self.p2p_info.has_data()) or
                        (self.path_protection is not None and self.path_protection.has_data()) or
                        (self.pce_delegation is not None and self.pce_delegation.has_data()) or
                        (self.reoptimized_p2mp_lsp is not None and self.reoptimized_p2mp_lsp.has_data()) or
                        (self.reoptimized_standby_p2mp_lsp is not None and self.reoptimized_standby_p2mp_lsp.has_data()) or
                        (self.soft_preemption is not None and self.soft_preemption.has_data()) or
                        (self.te_tunnel_convergence is not None and self.te_tunnel_convergence.has_data()) or
                        (self.transport_tunnel_info is not None and self.transport_tunnel_info.has_data()) or
                        (self.tunnel_current_lsp is not None and self.tunnel_current_lsp.has_data()) or
                        (self.tunnel_restoration_lsp is not None and self.tunnel_restoration_lsp.has_data()) or
                        (self.tunnel_standby_lsp is not None and self.tunnel_standby_lsp.has_data()) or
                        (self.wdm_unitunnel is not None and self.wdm_unitunnel.has_data()) or
                        (self.xro_attribute_set is not None and self.xro_attribute_set.has_data()))

                def has_operation(self):
                    for c in self.destination:
                        if (c.has_operation()):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        self.tunnel_name.yfilter != YFilter.not_set or
                        self.admin_state.yfilter != YFilter.not_set or
                        self.affinity_failure_delayed_tear_time_remained.yfilter != YFilter.not_set or
                        self.affinity_failure_reopt_disabled.yfilter != YFilter.not_set or
                        self.affinity_failure_reopt_time_remained.yfilter != YFilter.not_set or
                        self.area_id.yfilter != YFilter.not_set or
                        self.auto_route.yfilter != YFilter.not_set or
                        self.autoroute_announce_exclude_segment_routing.yfilter != YFilter.not_set or
                        self.bandwidth_requested.yfilter != YFilter.not_set or
                        self.bandwidth_type.yfilter != YFilter.not_set or
                        self.binding_label.yfilter != YFilter.not_set or
                        self.binding_label_exists.yfilter != YFilter.not_set or
                        self.create_time.yfilter != YFilter.not_set or
                        self.destination_disabled_count.yfilter != YFilter.not_set or
                        self.destination_down_count.yfilter != YFilter.not_set or
                        self.destination_up_count.yfilter != YFilter.not_set or
                        self.drop_mode.yfilter != YFilter.not_set or
                        self.explicit_path_change.yfilter != YFilter.not_set or
                        self.fail_reason.yfilter != YFilter.not_set or
                        self.forwarding_adjacency.yfilter != YFilter.not_set or
                        self.hop_limit_ignored_reason.yfilter != YFilter.not_set or
                        self.invalidation_time_remained.yfilter != YFilter.not_set or
                        self.is_auto_backup.yfilter != YFilter.not_set or
                        self.is_auto_pcc.yfilter != YFilter.not_set or
                        self.is_bandwidth_protect.yfilter != YFilter.not_set or
                        self.is_hop_limit_ignore.yfilter != YFilter.not_set or
                        self.is_inter_area_tunnel.yfilter != YFilter.not_set or
                        self.is_interface.yfilter != YFilter.not_set or
                        self.is_named.yfilter != YFilter.not_set or
                        self.is_node_protected.yfilter != YFilter.not_set or
                        self.is_passive.yfilter != YFilter.not_set or
                        self.is_pce_delegated.yfilter != YFilter.not_set or
                        self.last_hop_ifindex.yfilter != YFilter.not_set or
                        self.last_path_change.yfilter != YFilter.not_set or
                        self.load_share_factor.yfilter != YFilter.not_set or
                        self.load_share_type.yfilter != YFilter.not_set or
                        self.lsp_wrap_label.yfilter != YFilter.not_set or
                        self.lsp_wrap_protection_enabled.yfilter != YFilter.not_set or
                        self.metric_qualifier.yfilter != YFilter.not_set or
                        self.metric_type.yfilter != YFilter.not_set or
                        self.operational_state.yfilter != YFilter.not_set or
                        self.operational_state_changes.yfilter != YFilter.not_set or
                        self.outbound_frr_state.yfilter != YFilter.not_set or
                        self.passive_tunnel_name.yfilter != YFilter.not_set or
                        self.path_option_change.yfilter != YFilter.not_set or
                        self.pce_fail_reason.yfilter != YFilter.not_set or
                        self.persistent_bytes.yfilter != YFilter.not_set or
                        self.persistent_packets.yfilter != YFilter.not_set or
                        self.re_opt_hold_down_timer_remaining.yfilter != YFilter.not_set or
                        self.reroute_pending.yfilter != YFilter.not_set or
                        self.role_standby.yfilter != YFilter.not_set or
                        self.signaled_name.yfilter != YFilter.not_set or
                        self.snmp_index.yfilter != YFilter.not_set or
                        self.tie_breaker.yfilter != YFilter.not_set or
                        self.tiebreaker_qualifier.yfilter != YFilter.not_set or
                        self.tiebreaker_type.yfilter != YFilter.not_set or
                        self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                        self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                        self.tunnel_interface_name.yfilter != YFilter.not_set or
                        self.tunnel_recovering.yfilter != YFilter.not_set or
                        self.uptime.yfilter != YFilter.not_set or
                        self.xro_attribute_set_name.yfilter != YFilter.not_set or
                        (self.auto_backup is not None and self.auto_backup.has_operation()) or
                        (self.auto_mesh is not None and self.auto_mesh.has_operation()) or
                        (self.auto_pcc is not None and self.auto_pcc.has_operation()) or
                        (self.bfd_info is not None and self.bfd_info.has_operation()) or
                        (self.bidir is not None and self.bidir.has_operation()) or
                        (self.cleaned_lsp is not None and self.cleaned_lsp.has_operation()) or
                        (self.config is not None and self.config.has_operation()) or
                        (self.delay_clean_pp_lsp is not None and self.delay_clean_pp_lsp.has_operation()) or
                        (self.flex_info is not None and self.flex_info.has_operation()) or
                        (self.history is not None and self.history.has_operation()) or
                        (self.otn_bidir is not None and self.otn_bidir.has_operation()) or
                        (self.p2p_info is not None and self.p2p_info.has_operation()) or
                        (self.path_protection is not None and self.path_protection.has_operation()) or
                        (self.pce_delegation is not None and self.pce_delegation.has_operation()) or
                        (self.reoptimized_p2mp_lsp is not None and self.reoptimized_p2mp_lsp.has_operation()) or
                        (self.reoptimized_standby_p2mp_lsp is not None and self.reoptimized_standby_p2mp_lsp.has_operation()) or
                        (self.soft_preemption is not None and self.soft_preemption.has_operation()) or
                        (self.te_tunnel_convergence is not None and self.te_tunnel_convergence.has_operation()) or
                        (self.transport_tunnel_info is not None and self.transport_tunnel_info.has_operation()) or
                        (self.tunnel_current_lsp is not None and self.tunnel_current_lsp.has_operation()) or
                        (self.tunnel_restoration_lsp is not None and self.tunnel_restoration_lsp.has_operation()) or
                        (self.tunnel_standby_lsp is not None and self.tunnel_standby_lsp.has_operation()) or
                        (self.wdm_unitunnel is not None and self.wdm_unitunnel.has_operation()) or
                        (self.xro_attribute_set is not None and self.xro_attribute_set.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "tunnel-head" + "[tunnel-name='" + self.tunnel_name.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/p2p-p2mp-tunnel/tunnel-heads/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.tunnel_name.is_set or self.tunnel_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_name.get_name_leafdata())
                    if (self.admin_state.is_set or self.admin_state.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.admin_state.get_name_leafdata())
                    if (self.affinity_failure_delayed_tear_time_remained.is_set or self.affinity_failure_delayed_tear_time_remained.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.affinity_failure_delayed_tear_time_remained.get_name_leafdata())
                    if (self.affinity_failure_reopt_disabled.is_set or self.affinity_failure_reopt_disabled.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.affinity_failure_reopt_disabled.get_name_leafdata())
                    if (self.affinity_failure_reopt_time_remained.is_set or self.affinity_failure_reopt_time_remained.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.affinity_failure_reopt_time_remained.get_name_leafdata())
                    if (self.area_id.is_set or self.area_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.area_id.get_name_leafdata())
                    if (self.auto_route.is_set or self.auto_route.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.auto_route.get_name_leafdata())
                    if (self.autoroute_announce_exclude_segment_routing.is_set or self.autoroute_announce_exclude_segment_routing.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.autoroute_announce_exclude_segment_routing.get_name_leafdata())
                    if (self.bandwidth_requested.is_set or self.bandwidth_requested.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.bandwidth_requested.get_name_leafdata())
                    if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                    if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.binding_label.get_name_leafdata())
                    if (self.binding_label_exists.is_set or self.binding_label_exists.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.binding_label_exists.get_name_leafdata())
                    if (self.create_time.is_set or self.create_time.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.create_time.get_name_leafdata())
                    if (self.destination_disabled_count.is_set or self.destination_disabled_count.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.destination_disabled_count.get_name_leafdata())
                    if (self.destination_down_count.is_set or self.destination_down_count.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.destination_down_count.get_name_leafdata())
                    if (self.destination_up_count.is_set or self.destination_up_count.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.destination_up_count.get_name_leafdata())
                    if (self.drop_mode.is_set or self.drop_mode.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.drop_mode.get_name_leafdata())
                    if (self.explicit_path_change.is_set or self.explicit_path_change.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.explicit_path_change.get_name_leafdata())
                    if (self.fail_reason.is_set or self.fail_reason.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.fail_reason.get_name_leafdata())
                    if (self.forwarding_adjacency.is_set or self.forwarding_adjacency.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.forwarding_adjacency.get_name_leafdata())
                    if (self.hop_limit_ignored_reason.is_set or self.hop_limit_ignored_reason.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.hop_limit_ignored_reason.get_name_leafdata())
                    if (self.invalidation_time_remained.is_set or self.invalidation_time_remained.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.invalidation_time_remained.get_name_leafdata())
                    if (self.is_auto_backup.is_set or self.is_auto_backup.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_auto_backup.get_name_leafdata())
                    if (self.is_auto_pcc.is_set or self.is_auto_pcc.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_auto_pcc.get_name_leafdata())
                    if (self.is_bandwidth_protect.is_set or self.is_bandwidth_protect.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_bandwidth_protect.get_name_leafdata())
                    if (self.is_hop_limit_ignore.is_set or self.is_hop_limit_ignore.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_hop_limit_ignore.get_name_leafdata())
                    if (self.is_inter_area_tunnel.is_set or self.is_inter_area_tunnel.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_inter_area_tunnel.get_name_leafdata())
                    if (self.is_interface.is_set or self.is_interface.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_interface.get_name_leafdata())
                    if (self.is_named.is_set or self.is_named.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_named.get_name_leafdata())
                    if (self.is_node_protected.is_set or self.is_node_protected.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_node_protected.get_name_leafdata())
                    if (self.is_passive.is_set or self.is_passive.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_passive.get_name_leafdata())
                    if (self.is_pce_delegated.is_set or self.is_pce_delegated.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_pce_delegated.get_name_leafdata())
                    if (self.last_hop_ifindex.is_set or self.last_hop_ifindex.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.last_hop_ifindex.get_name_leafdata())
                    if (self.last_path_change.is_set or self.last_path_change.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.last_path_change.get_name_leafdata())
                    if (self.load_share_factor.is_set or self.load_share_factor.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.load_share_factor.get_name_leafdata())
                    if (self.load_share_type.is_set or self.load_share_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.load_share_type.get_name_leafdata())
                    if (self.lsp_wrap_label.is_set or self.lsp_wrap_label.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.lsp_wrap_label.get_name_leafdata())
                    if (self.lsp_wrap_protection_enabled.is_set or self.lsp_wrap_protection_enabled.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.lsp_wrap_protection_enabled.get_name_leafdata())
                    if (self.metric_qualifier.is_set or self.metric_qualifier.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.metric_qualifier.get_name_leafdata())
                    if (self.metric_type.is_set or self.metric_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.metric_type.get_name_leafdata())
                    if (self.operational_state.is_set or self.operational_state.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.operational_state.get_name_leafdata())
                    if (self.operational_state_changes.is_set or self.operational_state_changes.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.operational_state_changes.get_name_leafdata())
                    if (self.outbound_frr_state.is_set or self.outbound_frr_state.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.outbound_frr_state.get_name_leafdata())
                    if (self.passive_tunnel_name.is_set or self.passive_tunnel_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.passive_tunnel_name.get_name_leafdata())
                    if (self.path_option_change.is_set or self.path_option_change.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.path_option_change.get_name_leafdata())
                    if (self.pce_fail_reason.is_set or self.pce_fail_reason.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.pce_fail_reason.get_name_leafdata())
                    if (self.persistent_bytes.is_set or self.persistent_bytes.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.persistent_bytes.get_name_leafdata())
                    if (self.persistent_packets.is_set or self.persistent_packets.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.persistent_packets.get_name_leafdata())
                    if (self.re_opt_hold_down_timer_remaining.is_set or self.re_opt_hold_down_timer_remaining.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.re_opt_hold_down_timer_remaining.get_name_leafdata())
                    if (self.reroute_pending.is_set or self.reroute_pending.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.reroute_pending.get_name_leafdata())
                    if (self.role_standby.is_set or self.role_standby.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.role_standby.get_name_leafdata())
                    if (self.signaled_name.is_set or self.signaled_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.signaled_name.get_name_leafdata())
                    if (self.snmp_index.is_set or self.snmp_index.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.snmp_index.get_name_leafdata())
                    if (self.tie_breaker.is_set or self.tie_breaker.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tie_breaker.get_name_leafdata())
                    if (self.tiebreaker_qualifier.is_set or self.tiebreaker_qualifier.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tiebreaker_qualifier.get_name_leafdata())
                    if (self.tiebreaker_type.is_set or self.tiebreaker_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tiebreaker_type.get_name_leafdata())
                    if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                    if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())
                    if (self.tunnel_interface_name.is_set or self.tunnel_interface_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_interface_name.get_name_leafdata())
                    if (self.tunnel_recovering.is_set or self.tunnel_recovering.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_recovering.get_name_leafdata())
                    if (self.uptime.is_set or self.uptime.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.uptime.get_name_leafdata())
                    if (self.xro_attribute_set_name.is_set or self.xro_attribute_set_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.xro_attribute_set_name.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "auto-backup"):
                        if (self.auto_backup is None):
                            self.auto_backup = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoBackup()
                            self.auto_backup.parent = self
                            self._children_name_map["auto_backup"] = "auto-backup"
                        return self.auto_backup

                    if (child_yang_name == "auto-mesh"):
                        if (self.auto_mesh is None):
                            self.auto_mesh = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoMesh()
                            self.auto_mesh.parent = self
                            self._children_name_map["auto_mesh"] = "auto-mesh"
                        return self.auto_mesh

                    if (child_yang_name == "auto-pcc"):
                        if (self.auto_pcc is None):
                            self.auto_pcc = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.AutoPcc()
                            self.auto_pcc.parent = self
                            self._children_name_map["auto_pcc"] = "auto-pcc"
                        return self.auto_pcc

                    if (child_yang_name == "bfd-info"):
                        if (self.bfd_info is None):
                            self.bfd_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.BfdInfo()
                            self.bfd_info.parent = self
                            self._children_name_map["bfd_info"] = "bfd-info"
                        return self.bfd_info

                    if (child_yang_name == "bidir"):
                        if (self.bidir is None):
                            self.bidir = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Bidir()
                            self.bidir.parent = self
                            self._children_name_map["bidir"] = "bidir"
                        return self.bidir

                    if (child_yang_name == "cleaned-lsp"):
                        if (self.cleaned_lsp is None):
                            self.cleaned_lsp = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.CleanedLsp()
                            self.cleaned_lsp.parent = self
                            self._children_name_map["cleaned_lsp"] = "cleaned-lsp"
                        return self.cleaned_lsp

                    if (child_yang_name == "config"):
                        if (self.config is None):
                            self.config = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Config()
                            self.config.parent = self
                            self._children_name_map["config"] = "config"
                        return self.config

                    if (child_yang_name == "delay-clean-pp-lsp"):
                        if (self.delay_clean_pp_lsp is None):
                            self.delay_clean_pp_lsp = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.DelayCleanPpLsp()
                            self.delay_clean_pp_lsp.parent = self
                            self._children_name_map["delay_clean_pp_lsp"] = "delay-clean-pp-lsp"
                        return self.delay_clean_pp_lsp

                    if (child_yang_name == "destination"):
                        for c in self.destination:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.Destination()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.destination.append(c)
                        return c

                    if (child_yang_name == "flex-info"):
                        if (self.flex_info is None):
                            self.flex_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.FlexInfo()
                            self.flex_info.parent = self
                            self._children_name_map["flex_info"] = "flex-info"
                        return self.flex_info

                    if (child_yang_name == "history"):
                        if (self.history is None):
                            self.history = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.History()
                            self.history.parent = self
                            self._children_name_map["history"] = "history"
                        return self.history

                    if (child_yang_name == "otn-bidir"):
                        if (self.otn_bidir is None):
                            self.otn_bidir = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.OtnBidir()
                            self.otn_bidir.parent = self
                            self._children_name_map["otn_bidir"] = "otn-bidir"
                        return self.otn_bidir

                    if (child_yang_name == "p2p-info"):
                        if (self.p2p_info is None):
                            self.p2p_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.P2PInfo()
                            self.p2p_info.parent = self
                            self._children_name_map["p2p_info"] = "p2p-info"
                        return self.p2p_info

                    if (child_yang_name == "path-protection"):
                        if (self.path_protection is None):
                            self.path_protection = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.PathProtection()
                            self.path_protection.parent = self
                            self._children_name_map["path_protection"] = "path-protection"
                        return self.path_protection

                    if (child_yang_name == "pce-delegation"):
                        if (self.pce_delegation is None):
                            self.pce_delegation = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.PceDelegation()
                            self.pce_delegation.parent = self
                            self._children_name_map["pce_delegation"] = "pce-delegation"
                        return self.pce_delegation

                    if (child_yang_name == "reoptimized-p2mp-lsp"):
                        if (self.reoptimized_p2mp_lsp is None):
                            self.reoptimized_p2mp_lsp = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedP2MpLsp()
                            self.reoptimized_p2mp_lsp.parent = self
                            self._children_name_map["reoptimized_p2mp_lsp"] = "reoptimized-p2mp-lsp"
                        return self.reoptimized_p2mp_lsp

                    if (child_yang_name == "reoptimized-standby-p2mp-lsp"):
                        if (self.reoptimized_standby_p2mp_lsp is None):
                            self.reoptimized_standby_p2mp_lsp = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.ReoptimizedStandbyP2MpLsp()
                            self.reoptimized_standby_p2mp_lsp.parent = self
                            self._children_name_map["reoptimized_standby_p2mp_lsp"] = "reoptimized-standby-p2mp-lsp"
                        return self.reoptimized_standby_p2mp_lsp

                    if (child_yang_name == "soft-preemption"):
                        if (self.soft_preemption is None):
                            self.soft_preemption = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.SoftPreemption()
                            self.soft_preemption.parent = self
                            self._children_name_map["soft_preemption"] = "soft-preemption"
                        return self.soft_preemption

                    if (child_yang_name == "te-tunnel-convergence"):
                        if (self.te_tunnel_convergence is None):
                            self.te_tunnel_convergence = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TeTunnelConvergence()
                            self.te_tunnel_convergence.parent = self
                            self._children_name_map["te_tunnel_convergence"] = "te-tunnel-convergence"
                        return self.te_tunnel_convergence

                    if (child_yang_name == "transport-tunnel-info"):
                        if (self.transport_tunnel_info is None):
                            self.transport_tunnel_info = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TransportTunnelInfo()
                            self.transport_tunnel_info.parent = self
                            self._children_name_map["transport_tunnel_info"] = "transport-tunnel-info"
                        return self.transport_tunnel_info

                    if (child_yang_name == "tunnel-current-lsp"):
                        if (self.tunnel_current_lsp is None):
                            self.tunnel_current_lsp = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelCurrentLsp()
                            self.tunnel_current_lsp.parent = self
                            self._children_name_map["tunnel_current_lsp"] = "tunnel-current-lsp"
                        return self.tunnel_current_lsp

                    if (child_yang_name == "tunnel-restoration-lsp"):
                        if (self.tunnel_restoration_lsp is None):
                            self.tunnel_restoration_lsp = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelRestorationLsp()
                            self.tunnel_restoration_lsp.parent = self
                            self._children_name_map["tunnel_restoration_lsp"] = "tunnel-restoration-lsp"
                        return self.tunnel_restoration_lsp

                    if (child_yang_name == "tunnel-standby-lsp"):
                        if (self.tunnel_standby_lsp is None):
                            self.tunnel_standby_lsp = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.TunnelStandbyLsp()
                            self.tunnel_standby_lsp.parent = self
                            self._children_name_map["tunnel_standby_lsp"] = "tunnel-standby-lsp"
                        return self.tunnel_standby_lsp

                    if (child_yang_name == "wdm-unitunnel"):
                        if (self.wdm_unitunnel is None):
                            self.wdm_unitunnel = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.WdmUnitunnel()
                            self.wdm_unitunnel.parent = self
                            self._children_name_map["wdm_unitunnel"] = "wdm-unitunnel"
                        return self.wdm_unitunnel

                    if (child_yang_name == "xro-attribute-set"):
                        if (self.xro_attribute_set is None):
                            self.xro_attribute_set = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead.XroAttributeSet()
                            self.xro_attribute_set.parent = self
                            self._children_name_map["xro_attribute_set"] = "xro-attribute-set"
                        return self.xro_attribute_set

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "auto-backup" or name == "auto-mesh" or name == "auto-pcc" or name == "bfd-info" or name == "bidir" or name == "cleaned-lsp" or name == "config" or name == "delay-clean-pp-lsp" or name == "destination" or name == "flex-info" or name == "history" or name == "otn-bidir" or name == "p2p-info" or name == "path-protection" or name == "pce-delegation" or name == "reoptimized-p2mp-lsp" or name == "reoptimized-standby-p2mp-lsp" or name == "soft-preemption" or name == "te-tunnel-convergence" or name == "transport-tunnel-info" or name == "tunnel-current-lsp" or name == "tunnel-restoration-lsp" or name == "tunnel-standby-lsp" or name == "wdm-unitunnel" or name == "xro-attribute-set" or name == "tunnel-name" or name == "admin-state" or name == "affinity-failure-delayed-tear-time-remained" or name == "affinity-failure-reopt-disabled" or name == "affinity-failure-reopt-time-remained" or name == "area-id" or name == "auto-route" or name == "autoroute-announce-exclude-segment-routing" or name == "bandwidth-requested" or name == "bandwidth-type" or name == "binding-label" or name == "binding-label-exists" or name == "create-time" or name == "destination-disabled-count" or name == "destination-down-count" or name == "destination-up-count" or name == "drop-mode" or name == "explicit-path-change" or name == "fail-reason" or name == "forwarding-adjacency" or name == "hop-limit-ignored-reason" or name == "invalidation-time-remained" or name == "is-auto-backup" or name == "is-auto-pcc" or name == "is-bandwidth-protect" or name == "is-hop-limit-ignore" or name == "is-inter-area-tunnel" or name == "is-interface" or name == "is-named" or name == "is-node-protected" or name == "is-passive" or name == "is-pce-delegated" or name == "last-hop-ifindex" or name == "last-path-change" or name == "load-share-factor" or name == "load-share-type" or name == "lsp-wrap-label" or name == "lsp-wrap-protection-enabled" or name == "metric-qualifier" or name == "metric-type" or name == "operational-state" or name == "operational-state-changes" or name == "outbound-frr-state" or name == "passive-tunnel-name" or name == "path-option-change" or name == "pce-fail-reason" or name == "persistent-bytes" or name == "persistent-packets" or name == "re-opt-hold-down-timer-remaining" or name == "reroute-pending" or name == "role-standby" or name == "signaled-name" or name == "snmp-index" or name == "tie-breaker" or name == "tiebreaker-qualifier" or name == "tiebreaker-type" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-type" or name == "tunnel-interface-name" or name == "tunnel-recovering" or name == "uptime" or name == "xro-attribute-set-name"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "tunnel-name"):
                        self.tunnel_name = value
                        self.tunnel_name.value_namespace = name_space
                        self.tunnel_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "admin-state"):
                        self.admin_state = value
                        self.admin_state.value_namespace = name_space
                        self.admin_state.value_namespace_prefix = name_space_prefix
                    if(value_path == "affinity-failure-delayed-tear-time-remained"):
                        self.affinity_failure_delayed_tear_time_remained = value
                        self.affinity_failure_delayed_tear_time_remained.value_namespace = name_space
                        self.affinity_failure_delayed_tear_time_remained.value_namespace_prefix = name_space_prefix
                    if(value_path == "affinity-failure-reopt-disabled"):
                        self.affinity_failure_reopt_disabled = value
                        self.affinity_failure_reopt_disabled.value_namespace = name_space
                        self.affinity_failure_reopt_disabled.value_namespace_prefix = name_space_prefix
                    if(value_path == "affinity-failure-reopt-time-remained"):
                        self.affinity_failure_reopt_time_remained = value
                        self.affinity_failure_reopt_time_remained.value_namespace = name_space
                        self.affinity_failure_reopt_time_remained.value_namespace_prefix = name_space_prefix
                    if(value_path == "area-id"):
                        self.area_id = value
                        self.area_id.value_namespace = name_space
                        self.area_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "auto-route"):
                        self.auto_route = value
                        self.auto_route.value_namespace = name_space
                        self.auto_route.value_namespace_prefix = name_space_prefix
                    if(value_path == "autoroute-announce-exclude-segment-routing"):
                        self.autoroute_announce_exclude_segment_routing = value
                        self.autoroute_announce_exclude_segment_routing.value_namespace = name_space
                        self.autoroute_announce_exclude_segment_routing.value_namespace_prefix = name_space_prefix
                    if(value_path == "bandwidth-requested"):
                        self.bandwidth_requested = value
                        self.bandwidth_requested.value_namespace = name_space
                        self.bandwidth_requested.value_namespace_prefix = name_space_prefix
                    if(value_path == "bandwidth-type"):
                        self.bandwidth_type = value
                        self.bandwidth_type.value_namespace = name_space
                        self.bandwidth_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "binding-label"):
                        self.binding_label = value
                        self.binding_label.value_namespace = name_space
                        self.binding_label.value_namespace_prefix = name_space_prefix
                    if(value_path == "binding-label-exists"):
                        self.binding_label_exists = value
                        self.binding_label_exists.value_namespace = name_space
                        self.binding_label_exists.value_namespace_prefix = name_space_prefix
                    if(value_path == "create-time"):
                        self.create_time = value
                        self.create_time.value_namespace = name_space
                        self.create_time.value_namespace_prefix = name_space_prefix
                    if(value_path == "destination-disabled-count"):
                        self.destination_disabled_count = value
                        self.destination_disabled_count.value_namespace = name_space
                        self.destination_disabled_count.value_namespace_prefix = name_space_prefix
                    if(value_path == "destination-down-count"):
                        self.destination_down_count = value
                        self.destination_down_count.value_namespace = name_space
                        self.destination_down_count.value_namespace_prefix = name_space_prefix
                    if(value_path == "destination-up-count"):
                        self.destination_up_count = value
                        self.destination_up_count.value_namespace = name_space
                        self.destination_up_count.value_namespace_prefix = name_space_prefix
                    if(value_path == "drop-mode"):
                        self.drop_mode = value
                        self.drop_mode.value_namespace = name_space
                        self.drop_mode.value_namespace_prefix = name_space_prefix
                    if(value_path == "explicit-path-change"):
                        self.explicit_path_change = value
                        self.explicit_path_change.value_namespace = name_space
                        self.explicit_path_change.value_namespace_prefix = name_space_prefix
                    if(value_path == "fail-reason"):
                        self.fail_reason = value
                        self.fail_reason.value_namespace = name_space
                        self.fail_reason.value_namespace_prefix = name_space_prefix
                    if(value_path == "forwarding-adjacency"):
                        self.forwarding_adjacency = value
                        self.forwarding_adjacency.value_namespace = name_space
                        self.forwarding_adjacency.value_namespace_prefix = name_space_prefix
                    if(value_path == "hop-limit-ignored-reason"):
                        self.hop_limit_ignored_reason = value
                        self.hop_limit_ignored_reason.value_namespace = name_space
                        self.hop_limit_ignored_reason.value_namespace_prefix = name_space_prefix
                    if(value_path == "invalidation-time-remained"):
                        self.invalidation_time_remained = value
                        self.invalidation_time_remained.value_namespace = name_space
                        self.invalidation_time_remained.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-auto-backup"):
                        self.is_auto_backup = value
                        self.is_auto_backup.value_namespace = name_space
                        self.is_auto_backup.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-auto-pcc"):
                        self.is_auto_pcc = value
                        self.is_auto_pcc.value_namespace = name_space
                        self.is_auto_pcc.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-bandwidth-protect"):
                        self.is_bandwidth_protect = value
                        self.is_bandwidth_protect.value_namespace = name_space
                        self.is_bandwidth_protect.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-hop-limit-ignore"):
                        self.is_hop_limit_ignore = value
                        self.is_hop_limit_ignore.value_namespace = name_space
                        self.is_hop_limit_ignore.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-inter-area-tunnel"):
                        self.is_inter_area_tunnel = value
                        self.is_inter_area_tunnel.value_namespace = name_space
                        self.is_inter_area_tunnel.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-interface"):
                        self.is_interface = value
                        self.is_interface.value_namespace = name_space
                        self.is_interface.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-named"):
                        self.is_named = value
                        self.is_named.value_namespace = name_space
                        self.is_named.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-node-protected"):
                        self.is_node_protected = value
                        self.is_node_protected.value_namespace = name_space
                        self.is_node_protected.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-passive"):
                        self.is_passive = value
                        self.is_passive.value_namespace = name_space
                        self.is_passive.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-pce-delegated"):
                        self.is_pce_delegated = value
                        self.is_pce_delegated.value_namespace = name_space
                        self.is_pce_delegated.value_namespace_prefix = name_space_prefix
                    if(value_path == "last-hop-ifindex"):
                        self.last_hop_ifindex = value
                        self.last_hop_ifindex.value_namespace = name_space
                        self.last_hop_ifindex.value_namespace_prefix = name_space_prefix
                    if(value_path == "last-path-change"):
                        self.last_path_change = value
                        self.last_path_change.value_namespace = name_space
                        self.last_path_change.value_namespace_prefix = name_space_prefix
                    if(value_path == "load-share-factor"):
                        self.load_share_factor = value
                        self.load_share_factor.value_namespace = name_space
                        self.load_share_factor.value_namespace_prefix = name_space_prefix
                    if(value_path == "load-share-type"):
                        self.load_share_type = value
                        self.load_share_type.value_namespace = name_space
                        self.load_share_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "lsp-wrap-label"):
                        self.lsp_wrap_label = value
                        self.lsp_wrap_label.value_namespace = name_space
                        self.lsp_wrap_label.value_namespace_prefix = name_space_prefix
                    if(value_path == "lsp-wrap-protection-enabled"):
                        self.lsp_wrap_protection_enabled = value
                        self.lsp_wrap_protection_enabled.value_namespace = name_space
                        self.lsp_wrap_protection_enabled.value_namespace_prefix = name_space_prefix
                    if(value_path == "metric-qualifier"):
                        self.metric_qualifier = value
                        self.metric_qualifier.value_namespace = name_space
                        self.metric_qualifier.value_namespace_prefix = name_space_prefix
                    if(value_path == "metric-type"):
                        self.metric_type = value
                        self.metric_type.value_namespace = name_space
                        self.metric_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "operational-state"):
                        self.operational_state = value
                        self.operational_state.value_namespace = name_space
                        self.operational_state.value_namespace_prefix = name_space_prefix
                    if(value_path == "operational-state-changes"):
                        self.operational_state_changes = value
                        self.operational_state_changes.value_namespace = name_space
                        self.operational_state_changes.value_namespace_prefix = name_space_prefix
                    if(value_path == "outbound-frr-state"):
                        self.outbound_frr_state = value
                        self.outbound_frr_state.value_namespace = name_space
                        self.outbound_frr_state.value_namespace_prefix = name_space_prefix
                    if(value_path == "passive-tunnel-name"):
                        self.passive_tunnel_name = value
                        self.passive_tunnel_name.value_namespace = name_space
                        self.passive_tunnel_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "path-option-change"):
                        self.path_option_change = value
                        self.path_option_change.value_namespace = name_space
                        self.path_option_change.value_namespace_prefix = name_space_prefix
                    if(value_path == "pce-fail-reason"):
                        self.pce_fail_reason = value
                        self.pce_fail_reason.value_namespace = name_space
                        self.pce_fail_reason.value_namespace_prefix = name_space_prefix
                    if(value_path == "persistent-bytes"):
                        self.persistent_bytes = value
                        self.persistent_bytes.value_namespace = name_space
                        self.persistent_bytes.value_namespace_prefix = name_space_prefix
                    if(value_path == "persistent-packets"):
                        self.persistent_packets = value
                        self.persistent_packets.value_namespace = name_space
                        self.persistent_packets.value_namespace_prefix = name_space_prefix
                    if(value_path == "re-opt-hold-down-timer-remaining"):
                        self.re_opt_hold_down_timer_remaining = value
                        self.re_opt_hold_down_timer_remaining.value_namespace = name_space
                        self.re_opt_hold_down_timer_remaining.value_namespace_prefix = name_space_prefix
                    if(value_path == "reroute-pending"):
                        self.reroute_pending = value
                        self.reroute_pending.value_namespace = name_space
                        self.reroute_pending.value_namespace_prefix = name_space_prefix
                    if(value_path == "role-standby"):
                        self.role_standby = value
                        self.role_standby.value_namespace = name_space
                        self.role_standby.value_namespace_prefix = name_space_prefix
                    if(value_path == "signaled-name"):
                        self.signaled_name = value
                        self.signaled_name.value_namespace = name_space
                        self.signaled_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "snmp-index"):
                        self.snmp_index = value
                        self.snmp_index.value_namespace = name_space
                        self.snmp_index.value_namespace_prefix = name_space_prefix
                    if(value_path == "tie-breaker"):
                        self.tie_breaker = value
                        self.tie_breaker.value_namespace = name_space
                        self.tie_breaker.value_namespace_prefix = name_space_prefix
                    if(value_path == "tiebreaker-qualifier"):
                        self.tiebreaker_qualifier = value
                        self.tiebreaker_qualifier.value_namespace = name_space
                        self.tiebreaker_qualifier.value_namespace_prefix = name_space_prefix
                    if(value_path == "tiebreaker-type"):
                        self.tiebreaker_type = value
                        self.tiebreaker_type.value_namespace = name_space
                        self.tiebreaker_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-attribute-set-name"):
                        self.tunnel_attribute_set_name = value
                        self.tunnel_attribute_set_name.value_namespace = name_space
                        self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-attribute-set-type"):
                        self.tunnel_attribute_set_type = value
                        self.tunnel_attribute_set_type.value_namespace = name_space
                        self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-interface-name"):
                        self.tunnel_interface_name = value
                        self.tunnel_interface_name.value_namespace = name_space
                        self.tunnel_interface_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-recovering"):
                        self.tunnel_recovering = value
                        self.tunnel_recovering.value_namespace = name_space
                        self.tunnel_recovering.value_namespace_prefix = name_space_prefix
                    if(value_path == "uptime"):
                        self.uptime = value
                        self.uptime.value_namespace = name_space
                        self.uptime.value_namespace_prefix = name_space_prefix
                    if(value_path == "xro-attribute-set-name"):
                        self.xro_attribute_set_name = value
                        self.xro_attribute_set_name.value_namespace = name_space
                        self.xro_attribute_set_name.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.tunnel_head:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.tunnel_head:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "tunnel-heads" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/p2p-p2mp-tunnel/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "tunnel-head"):
                    for c in self.tunnel_head:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTeStandby.P2PP2MpTunnel.TunnelHeads.TunnelHead()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.tunnel_head.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "tunnel-head"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass

        def has_data(self):
            return (
                (self.nni_tunnels is not None and self.nni_tunnels.has_data()) or
                (self.tunnel_heads is not None and self.tunnel_heads.has_data()) or
                (self.tunnel_remote_briefs is not None and self.tunnel_remote_briefs.has_data()) or
                (self.tunnel_remotes is not None and self.tunnel_remotes.has_data()))

        def has_operation(self):
            return (
                self.yfilter != YFilter.not_set or
                (self.nni_tunnels is not None and self.nni_tunnels.has_operation()) or
                (self.tunnel_heads is not None and self.tunnel_heads.has_operation()) or
                (self.tunnel_remote_briefs is not None and self.tunnel_remote_briefs.has_operation()) or
                (self.tunnel_remotes is not None and self.tunnel_remotes.has_operation()))

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "p2p-p2mp-tunnel" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "nni-tunnels"):
                if (self.nni_tunnels is None):
                    self.nni_tunnels = MplsTeStandby.P2PP2MpTunnel.NniTunnels()
                    self.nni_tunnels.parent = self
                    self._children_name_map["nni_tunnels"] = "nni-tunnels"
                return self.nni_tunnels

            if (child_yang_name == "tunnel-heads"):
                if (self.tunnel_heads is None):
                    self.tunnel_heads = MplsTeStandby.P2PP2MpTunnel.TunnelHeads()
                    self.tunnel_heads.parent = self
                    self._children_name_map["tunnel_heads"] = "tunnel-heads"
                return self.tunnel_heads

            if (child_yang_name == "tunnel-remote-briefs"):
                if (self.tunnel_remote_briefs is None):
                    self.tunnel_remote_briefs = MplsTeStandby.P2PP2MpTunnel.TunnelRemoteBriefs()
                    self.tunnel_remote_briefs.parent = self
                    self._children_name_map["tunnel_remote_briefs"] = "tunnel-remote-briefs"
                return self.tunnel_remote_briefs

            if (child_yang_name == "tunnel-remotes"):
                if (self.tunnel_remotes is None):
                    self.tunnel_remotes = MplsTeStandby.P2PP2MpTunnel.TunnelRemotes()
                    self.tunnel_remotes.parent = self
                    self._children_name_map["tunnel_remotes"] = "tunnel-remotes"
                return self.tunnel_remotes

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "nni-tunnels" or name == "tunnel-heads" or name == "tunnel-remote-briefs" or name == "tunnel-remotes"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class TopologyNodes(Entity):
        """
        A node in the MPLS\-TE topology
        
        .. attribute:: topology_node
        
        	A node in the MPLS\-TE topology
        	**type**\: list of    :py:class:`TopologyNode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyNodes.TopologyNode>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsTeStandby.TopologyNodes, self).__init__()

            self.yang_name = "topology-nodes"
            self.yang_parent_name = "mpls-te-standby"

            self.topology_node = YList(self)

        def __setattr__(self, name, value):
            self._check_monkey_patching_error(name, value)
            with _handle_type_error():
                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                        "Please use list append or extend method."
                                        .format(value))
                if isinstance(value, Enum.YLeaf):
                    value = value.name
                if name in () and name in self.__dict__:
                    if isinstance(value, YLeaf):
                        self.__dict__[name].set(value.get())
                    elif isinstance(value, YLeafList):
                        super(MplsTeStandby.TopologyNodes, self).__setattr__(name, value)
                    else:
                        self.__dict__[name].set(value)
                else:
                    if hasattr(value, "parent") and name != "parent":
                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                            value.parent = self
                        elif value.parent is None and value.yang_name in self._children_yang_names:
                            value.parent = self
                    super(MplsTeStandby.TopologyNodes, self).__setattr__(name, value)


        class TopologyNode(Entity):
            """
            A node in the MPLS\-TE topology
            
            .. attribute:: protocol  <key>
            
            	IGP protocol type
            	**type**\:   :py:class:`MplsTeIgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeIgpProtocol>`
            
            .. attribute:: igp_id  <key>
            
            	IGP instance
            	**type**\:  str
            
            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
            
            .. attribute:: area  <key>
            
            	IGP area
            	**type**\:  int
            
            	**range:** \-2147483648..2147483647
            
            .. attribute:: topology_node_type  <key>
            
            	Node type
            	**type**\:   :py:class:`MplsTeNode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeNode>`
            
            .. attribute:: igp_node_id  <key>
            
            	IGP Node ID
            	**type**\:  str
            
            .. attribute:: topology_node_link
            
            	This node's link information
            	**type**\: list of    :py:class:`TopologyNodeLink <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink>`
            
            .. attribute:: topology_node_overloaded
            
            	Flag to indicate whether this node is overloaded
            	**type**\:  bool
            
            .. attribute:: topology_node_sid_and_srbg
            
            	This node's SID and SRBG information
            	**type**\:   :py:class:`TopologyNodeSidAndSrbg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeSidAndSrbg>`
            
            .. attribute:: topology_node_te_router_id
            
            	The node's TE router\-id. Not set for network nodes
            	**type**\:  str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTeStandby.TopologyNodes.TopologyNode, self).__init__()

                self.yang_name = "topology-node"
                self.yang_parent_name = "topology-nodes"

                self.protocol = YLeaf(YType.enumeration, "protocol")

                self.igp_id = YLeaf(YType.str, "igp-id")

                self.area = YLeaf(YType.int32, "area")

                self.topology_node_type = YLeaf(YType.enumeration, "topology-node-type")

                self.igp_node_id = YLeaf(YType.str, "igp-node-id")

                self.topology_node_overloaded = YLeaf(YType.boolean, "topology-node-overloaded")

                self.topology_node_te_router_id = YLeaf(YType.str, "topology-node-te-router-id")

                self.topology_node_sid_and_srbg = MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeSidAndSrbg()
                self.topology_node_sid_and_srbg.parent = self
                self._children_name_map["topology_node_sid_and_srbg"] = "topology-node-sid-and-srbg"
                self._children_yang_names.add("topology-node-sid-and-srbg")

                self.topology_node_link = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("protocol",
                                "igp_id",
                                "area",
                                "topology_node_type",
                                "igp_node_id",
                                "topology_node_overloaded",
                                "topology_node_te_router_id") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTeStandby.TopologyNodes.TopologyNode, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTeStandby.TopologyNodes.TopologyNode, self).__setattr__(name, value)


            class TopologyNodeSidAndSrbg(Entity):
                """
                This node's SID and SRBG information
                
                .. attribute:: segment_id
                
                	Segment\-Routing Node\-SID
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: segment_id_local_absolute_value
                
                	Node\-SID local absolute value
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: srgb_size
                
                	Segment\-Routing global block size
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: srgb_start
                
                	Segment\-Routring global block start value
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeSidAndSrbg, self).__init__()

                    self.yang_name = "topology-node-sid-and-srbg"
                    self.yang_parent_name = "topology-node"

                    self.segment_id = YLeaf(YType.uint32, "segment-id")

                    self.segment_id_local_absolute_value = YLeaf(YType.uint32, "segment-id-local-absolute-value")

                    self.srgb_size = YLeaf(YType.uint32, "srgb-size")

                    self.srgb_start = YLeaf(YType.uint32, "srgb-start")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("segment_id",
                                    "segment_id_local_absolute_value",
                                    "srgb_size",
                                    "srgb_start") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeSidAndSrbg, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeSidAndSrbg, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.segment_id.is_set or
                        self.segment_id_local_absolute_value.is_set or
                        self.srgb_size.is_set or
                        self.srgb_start.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.segment_id.yfilter != YFilter.not_set or
                        self.segment_id_local_absolute_value.yfilter != YFilter.not_set or
                        self.srgb_size.yfilter != YFilter.not_set or
                        self.srgb_start.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "topology-node-sid-and-srbg" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.segment_id.is_set or self.segment_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.segment_id.get_name_leafdata())
                    if (self.segment_id_local_absolute_value.is_set or self.segment_id_local_absolute_value.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.segment_id_local_absolute_value.get_name_leafdata())
                    if (self.srgb_size.is_set or self.srgb_size.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.srgb_size.get_name_leafdata())
                    if (self.srgb_start.is_set or self.srgb_start.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.srgb_start.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "segment-id" or name == "segment-id-local-absolute-value" or name == "srgb-size" or name == "srgb-start"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "segment-id"):
                        self.segment_id = value
                        self.segment_id.value_namespace = name_space
                        self.segment_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "segment-id-local-absolute-value"):
                        self.segment_id_local_absolute_value = value
                        self.segment_id_local_absolute_value.value_namespace = name_space
                        self.segment_id_local_absolute_value.value_namespace_prefix = name_space_prefix
                    if(value_path == "srgb-size"):
                        self.srgb_size = value
                        self.srgb_size.value_namespace = name_space
                        self.srgb_size.value_namespace_prefix = name_space_prefix
                    if(value_path == "srgb-start"):
                        self.srgb_start = value
                        self.srgb_start.value_namespace = name_space
                        self.srgb_start.value_namespace_prefix = name_space_prefix


            class TopologyNodeLink(Entity):
                """
                This node's link information
                
                .. attribute:: adjacency_sid
                
                	Adjacency SIDs assigned for adjacency nodes
                	**type**\: list of    :py:class:`AdjacencySid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.AdjacencySid>`
                
                .. attribute:: odu_link_capabilities
                
                	ODU Link Capabilities
                	**type**\:   :py:class:`OduLinkCapabilities <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities>`
                
                .. attribute:: shared_risk_link_group
                
                	The link's shared risk link groups
                	**type**\: list of    :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.SharedRiskLinkGroup>`
                
                .. attribute:: topology_link_affinity_bits
                
                	Deprecated
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: topology_link_bandwidth
                
                	Bandwidth information for this link
                	**type**\:   :py:class:`TopologyLinkBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth>`
                
                .. attribute:: topology_link_bandwidth_model
                
                	The link's topology bandwidth model
                	**type**\:   :py:class:`IgpteLibBwModel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpteLibBwModel>`
                
                .. attribute:: topology_link_encoding
                
                	The link's encoding
                	**type**\:  int
                
                	**range:** 0..255
                
                .. attribute:: topology_link_extended_affinity_bit
                
                	The link's affinity bits (colors)
                	**type**\: list of    :py:class:`TopologyLinkExtendedAffinityBit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkExtendedAffinityBit>`
                
                .. attribute:: topology_link_fragment_id
                
                	Neighbor's link version counter
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: topology_link_igp_metric
                
                	The link's IGP metric
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: topology_link_interface_address
                
                	Link's local interface address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: topology_link_interface_id
                
                	Link's local interface ID
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: topology_link_neighbor_address
                
                	Link's neighbor interface address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: topology_link_neighbor_generation
                
                	Neighbor's link version counter
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: topology_link_neighbor_id
                
                	Link's neighbor interface ID
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: topology_link_neighbor_node_id
                
                	Node id of neighbor
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: topology_link_neighbor_system_id
                
                	System id of neighbor
                	**type**\:  str
                
                .. attribute:: topology_link_switching_capability
                
                	The link's switching capability
                	**type**\:  int
                
                	**range:** 0..255
                
                .. attribute:: topology_link_te_metric
                
                	The link's TE metric
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: topology_link_type
                
                	Link type
                	**type**\:   :py:class:`IgpSubnet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpSubnet>`
                
                .. attribute:: topology_link_uni_delay
                
                	Unidirectional Link Delay in micro\-sec
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink, self).__init__()

                    self.yang_name = "topology-node-link"
                    self.yang_parent_name = "topology-node"

                    self.topology_link_affinity_bits = YLeaf(YType.uint32, "topology-link-affinity-bits")

                    self.topology_link_bandwidth_model = YLeaf(YType.enumeration, "topology-link-bandwidth-model")

                    self.topology_link_encoding = YLeaf(YType.uint8, "topology-link-encoding")

                    self.topology_link_fragment_id = YLeaf(YType.uint32, "topology-link-fragment-id")

                    self.topology_link_igp_metric = YLeaf(YType.uint32, "topology-link-igp-metric")

                    self.topology_link_interface_address = YLeaf(YType.str, "topology-link-interface-address")

                    self.topology_link_interface_id = YLeaf(YType.uint32, "topology-link-interface-id")

                    self.topology_link_neighbor_address = YLeaf(YType.str, "topology-link-neighbor-address")

                    self.topology_link_neighbor_generation = YLeaf(YType.uint32, "topology-link-neighbor-generation")

                    self.topology_link_neighbor_id = YLeaf(YType.uint32, "topology-link-neighbor-id")

                    self.topology_link_neighbor_node_id = YLeaf(YType.uint32, "topology-link-neighbor-node-id")

                    self.topology_link_neighbor_system_id = YLeaf(YType.str, "topology-link-neighbor-system-id")

                    self.topology_link_switching_capability = YLeaf(YType.uint8, "topology-link-switching-capability")

                    self.topology_link_te_metric = YLeaf(YType.uint32, "topology-link-te-metric")

                    self.topology_link_type = YLeaf(YType.enumeration, "topology-link-type")

                    self.topology_link_uni_delay = YLeaf(YType.uint32, "topology-link-uni-delay")

                    self.odu_link_capabilities = MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities()
                    self.odu_link_capabilities.parent = self
                    self._children_name_map["odu_link_capabilities"] = "odu-link-capabilities"
                    self._children_yang_names.add("odu-link-capabilities")

                    self.topology_link_bandwidth = MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth()
                    self.topology_link_bandwidth.parent = self
                    self._children_name_map["topology_link_bandwidth"] = "topology-link-bandwidth"
                    self._children_yang_names.add("topology-link-bandwidth")

                    self.adjacency_sid = YList(self)
                    self.shared_risk_link_group = YList(self)
                    self.topology_link_extended_affinity_bit = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("topology_link_affinity_bits",
                                    "topology_link_bandwidth_model",
                                    "topology_link_encoding",
                                    "topology_link_fragment_id",
                                    "topology_link_igp_metric",
                                    "topology_link_interface_address",
                                    "topology_link_interface_id",
                                    "topology_link_neighbor_address",
                                    "topology_link_neighbor_generation",
                                    "topology_link_neighbor_id",
                                    "topology_link_neighbor_node_id",
                                    "topology_link_neighbor_system_id",
                                    "topology_link_switching_capability",
                                    "topology_link_te_metric",
                                    "topology_link_type",
                                    "topology_link_uni_delay") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink, self).__setattr__(name, value)


                class TopologyLinkBandwidth(Entity):
                    """
                    Bandwidth information for this link
                    
                    .. attribute:: bandwidth_migration_mode
                    
                    	BandwidthMigrationMode
                    	**type**\:   :py:class:`RrrDsteMigrationMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RrrDsteMigrationMode>`
                    
                    .. attribute:: topology_link_bandwidth_prestandard
                    
                    	Pre\-standard bandwidth information for this link
                    	**type**\:   :py:class:`TopologyLinkBandwidthPrestandard <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard>`
                    
                    .. attribute:: topology_link_bandwidth_standard
                    
                    	IETF\-standard bandwidth information for this link
                    	**type**\:   :py:class:`TopologyLinkBandwidthStandard <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth, self).__init__()

                        self.yang_name = "topology-link-bandwidth"
                        self.yang_parent_name = "topology-node-link"

                        self.bandwidth_migration_mode = YLeaf(YType.enumeration, "bandwidth-migration-mode")

                        self.topology_link_bandwidth_prestandard = MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard()
                        self.topology_link_bandwidth_prestandard.parent = self
                        self._children_name_map["topology_link_bandwidth_prestandard"] = "topology-link-bandwidth-prestandard"
                        self._children_yang_names.add("topology-link-bandwidth-prestandard")

                        self.topology_link_bandwidth_standard = MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard()
                        self.topology_link_bandwidth_standard.parent = self
                        self._children_name_map["topology_link_bandwidth_standard"] = "topology-link-bandwidth-standard"
                        self._children_yang_names.add("topology-link-bandwidth-standard")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("bandwidth_migration_mode") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth, self).__setattr__(name, value)


                    class TopologyLinkBandwidthPrestandard(Entity):
                        """
                        Pre\-standard bandwidth information for this link
                        
                        .. attribute:: topology_link_prestandard_bandwidth_detail
                        
                        	Detailed bandwidth information for this link
                        	**type**\:   :py:class:`TopologyLinkPrestandardBandwidthDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail>`
                        
                        .. attribute:: topology_link_prestandard_bandwidth_physical
                        
                        	The link's physical bandwidth
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: topology_link_prestandard_bandwidth_reservation_global
                        
                        	The link's reservable global bandwidth
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: topology_link_prestandard_bandwidth_reservation_subpool
                        
                        	The link's reservable subpool bandwidth
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard, self).__init__()

                            self.yang_name = "topology-link-bandwidth-prestandard"
                            self.yang_parent_name = "topology-link-bandwidth"

                            self.topology_link_prestandard_bandwidth_physical = YLeaf(YType.uint32, "topology-link-prestandard-bandwidth-physical")

                            self.topology_link_prestandard_bandwidth_reservation_global = YLeaf(YType.uint32, "topology-link-prestandard-bandwidth-reservation-global")

                            self.topology_link_prestandard_bandwidth_reservation_subpool = YLeaf(YType.uint32, "topology-link-prestandard-bandwidth-reservation-subpool")

                            self.topology_link_prestandard_bandwidth_detail = MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail()
                            self.topology_link_prestandard_bandwidth_detail.parent = self
                            self._children_name_map["topology_link_prestandard_bandwidth_detail"] = "topology-link-prestandard-bandwidth-detail"
                            self._children_yang_names.add("topology-link-prestandard-bandwidth-detail")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("topology_link_prestandard_bandwidth_physical",
                                            "topology_link_prestandard_bandwidth_reservation_global",
                                            "topology_link_prestandard_bandwidth_reservation_subpool") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard, self).__setattr__(name, value)


                        class TopologyLinkPrestandardBandwidthDetail(Entity):
                            """
                            Detailed bandwidth information for this link
                            
                            .. attribute:: topology_link_prestandard_bandwidth_allocated
                            
                            	Link's allocated bandwidth at priority levels  (priority 0 to priority 7)
                            	**type**\: list of    :py:class:`TopologyLinkPrestandardBandwidthAllocated <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAllocated>`
                            
                            .. attribute:: topology_link_prestandard_bandwidth_available_global
                            
                            	Link's available global\-pool bandwidth at  priority levels (priority 0 to priority 7)
                            	**type**\: list of    :py:class:`TopologyLinkPrestandardBandwidthAvailableGlobal <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableGlobal>`
                            
                            .. attribute:: topology_link_prestandard_bandwidth_available_subpool
                            
                            	Link's available sub\-pool bandwidth at priority  levels (priority 0 to priority 7)
                            	**type**\: list of    :py:class:`TopologyLinkPrestandardBandwidthAvailableSubpool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableSubpool>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail, self).__init__()

                                self.yang_name = "topology-link-prestandard-bandwidth-detail"
                                self.yang_parent_name = "topology-link-bandwidth-prestandard"

                                self.topology_link_prestandard_bandwidth_allocated = YList(self)
                                self.topology_link_prestandard_bandwidth_available_global = YList(self)
                                self.topology_link_prestandard_bandwidth_available_subpool = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in () and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail, self).__setattr__(name, value)


                            class TopologyLinkPrestandardBandwidthAllocated(Entity):
                                """
                                Link's allocated bandwidth at priority levels
                                
                                (priority 0 to priority 7)
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAllocated, self).__init__()

                                    self.yang_name = "topology-link-prestandard-bandwidth-allocated"
                                    self.yang_parent_name = "topology-link-prestandard-bandwidth-detail"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAllocated, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAllocated, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "topology-link-prestandard-bandwidth-allocated" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix


                            class TopologyLinkPrestandardBandwidthAvailableGlobal(Entity):
                                """
                                Link's available global\-pool bandwidth at
                                
                                priority levels (priority 0 to priority 7)
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableGlobal, self).__init__()

                                    self.yang_name = "topology-link-prestandard-bandwidth-available-global"
                                    self.yang_parent_name = "topology-link-prestandard-bandwidth-detail"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableGlobal, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableGlobal, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "topology-link-prestandard-bandwidth-available-global" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix


                            class TopologyLinkPrestandardBandwidthAvailableSubpool(Entity):
                                """
                                Link's available sub\-pool bandwidth at priority
                                
                                levels (priority 0 to priority 7)
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableSubpool, self).__init__()

                                    self.yang_name = "topology-link-prestandard-bandwidth-available-subpool"
                                    self.yang_parent_name = "topology-link-prestandard-bandwidth-detail"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableSubpool, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableSubpool, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "topology-link-prestandard-bandwidth-available-subpool" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.topology_link_prestandard_bandwidth_allocated:
                                    if (c.has_data()):
                                        return True
                                for c in self.topology_link_prestandard_bandwidth_available_global:
                                    if (c.has_data()):
                                        return True
                                for c in self.topology_link_prestandard_bandwidth_available_subpool:
                                    if (c.has_data()):
                                        return True
                                return False

                            def has_operation(self):
                                for c in self.topology_link_prestandard_bandwidth_allocated:
                                    if (c.has_operation()):
                                        return True
                                for c in self.topology_link_prestandard_bandwidth_available_global:
                                    if (c.has_operation()):
                                        return True
                                for c in self.topology_link_prestandard_bandwidth_available_subpool:
                                    if (c.has_operation()):
                                        return True
                                return self.yfilter != YFilter.not_set

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "topology-link-prestandard-bandwidth-detail" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "topology-link-prestandard-bandwidth-allocated"):
                                    for c in self.topology_link_prestandard_bandwidth_allocated:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAllocated()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.topology_link_prestandard_bandwidth_allocated.append(c)
                                    return c

                                if (child_yang_name == "topology-link-prestandard-bandwidth-available-global"):
                                    for c in self.topology_link_prestandard_bandwidth_available_global:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableGlobal()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.topology_link_prestandard_bandwidth_available_global.append(c)
                                    return c

                                if (child_yang_name == "topology-link-prestandard-bandwidth-available-subpool"):
                                    for c in self.topology_link_prestandard_bandwidth_available_subpool:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableSubpool()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.topology_link_prestandard_bandwidth_available_subpool.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "topology-link-prestandard-bandwidth-allocated" or name == "topology-link-prestandard-bandwidth-available-global" or name == "topology-link-prestandard-bandwidth-available-subpool"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass

                        def has_data(self):
                            return (
                                self.topology_link_prestandard_bandwidth_physical.is_set or
                                self.topology_link_prestandard_bandwidth_reservation_global.is_set or
                                self.topology_link_prestandard_bandwidth_reservation_subpool.is_set or
                                (self.topology_link_prestandard_bandwidth_detail is not None and self.topology_link_prestandard_bandwidth_detail.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.topology_link_prestandard_bandwidth_physical.yfilter != YFilter.not_set or
                                self.topology_link_prestandard_bandwidth_reservation_global.yfilter != YFilter.not_set or
                                self.topology_link_prestandard_bandwidth_reservation_subpool.yfilter != YFilter.not_set or
                                (self.topology_link_prestandard_bandwidth_detail is not None and self.topology_link_prestandard_bandwidth_detail.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "topology-link-bandwidth-prestandard" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.topology_link_prestandard_bandwidth_physical.is_set or self.topology_link_prestandard_bandwidth_physical.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.topology_link_prestandard_bandwidth_physical.get_name_leafdata())
                            if (self.topology_link_prestandard_bandwidth_reservation_global.is_set or self.topology_link_prestandard_bandwidth_reservation_global.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.topology_link_prestandard_bandwidth_reservation_global.get_name_leafdata())
                            if (self.topology_link_prestandard_bandwidth_reservation_subpool.is_set or self.topology_link_prestandard_bandwidth_reservation_subpool.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.topology_link_prestandard_bandwidth_reservation_subpool.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "topology-link-prestandard-bandwidth-detail"):
                                if (self.topology_link_prestandard_bandwidth_detail is None):
                                    self.topology_link_prestandard_bandwidth_detail = MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail()
                                    self.topology_link_prestandard_bandwidth_detail.parent = self
                                    self._children_name_map["topology_link_prestandard_bandwidth_detail"] = "topology-link-prestandard-bandwidth-detail"
                                return self.topology_link_prestandard_bandwidth_detail

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "topology-link-prestandard-bandwidth-detail" or name == "topology-link-prestandard-bandwidth-physical" or name == "topology-link-prestandard-bandwidth-reservation-global" or name == "topology-link-prestandard-bandwidth-reservation-subpool"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "topology-link-prestandard-bandwidth-physical"):
                                self.topology_link_prestandard_bandwidth_physical = value
                                self.topology_link_prestandard_bandwidth_physical.value_namespace = name_space
                                self.topology_link_prestandard_bandwidth_physical.value_namespace_prefix = name_space_prefix
                            if(value_path == "topology-link-prestandard-bandwidth-reservation-global"):
                                self.topology_link_prestandard_bandwidth_reservation_global = value
                                self.topology_link_prestandard_bandwidth_reservation_global.value_namespace = name_space
                                self.topology_link_prestandard_bandwidth_reservation_global.value_namespace_prefix = name_space_prefix
                            if(value_path == "topology-link-prestandard-bandwidth-reservation-subpool"):
                                self.topology_link_prestandard_bandwidth_reservation_subpool = value
                                self.topology_link_prestandard_bandwidth_reservation_subpool.value_namespace = name_space
                                self.topology_link_prestandard_bandwidth_reservation_subpool.value_namespace_prefix = name_space_prefix


                    class TopologyLinkBandwidthStandard(Entity):
                        """
                        IETF\-standard bandwidth information for this
                        link
                        
                        .. attribute:: topo_link_std_bw_detail
                        
                        	Detailed bandwidth information for this link
                        	**type**\:   :py:class:`TopoLinkStdBwDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail>`
                        
                        .. attribute:: topo_link_std_bw_physical
                        
                        	The link's physical bandwidth
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: topo_link_std_bw_res_max
                        
                        	The link's maximum reservable bandwidth
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: topo_link_std_bw_res_pool0
                        
                        	The link's reservable BC0 bandwidth
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: topo_link_std_bw_res_pool1
                        
                        	The link's reservable BC1 bandwidth
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard, self).__init__()

                            self.yang_name = "topology-link-bandwidth-standard"
                            self.yang_parent_name = "topology-link-bandwidth"

                            self.topo_link_std_bw_physical = YLeaf(YType.uint32, "topo-link-std-bw-physical")

                            self.topo_link_std_bw_res_max = YLeaf(YType.uint32, "topo-link-std-bw-res-max")

                            self.topo_link_std_bw_res_pool0 = YLeaf(YType.uint32, "topo-link-std-bw-res-pool0")

                            self.topo_link_std_bw_res_pool1 = YLeaf(YType.uint32, "topo-link-std-bw-res-pool1")

                            self.topo_link_std_bw_detail = MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail()
                            self.topo_link_std_bw_detail.parent = self
                            self._children_name_map["topo_link_std_bw_detail"] = "topo-link-std-bw-detail"
                            self._children_yang_names.add("topo-link-std-bw-detail")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("topo_link_std_bw_physical",
                                            "topo_link_std_bw_res_max",
                                            "topo_link_std_bw_res_pool0",
                                            "topo_link_std_bw_res_pool1") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard, self).__setattr__(name, value)


                        class TopoLinkStdBwDetail(Entity):
                            """
                            Detailed bandwidth information for this link
                            
                            .. attribute:: topo_link_std_bw_allocated
                            
                            	Link's allocated bandwidth per class
                            	**type**\: list of    :py:class:`TopoLinkStdBwAllocated <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAllocated>`
                            
                            .. attribute:: topo_link_std_bw_available
                            
                            	Link's available bandwidth per class
                            	**type**\: list of    :py:class:`TopoLinkStdBwAvailable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAvailable>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail, self).__init__()

                                self.yang_name = "topo-link-std-bw-detail"
                                self.yang_parent_name = "topology-link-bandwidth-standard"

                                self.topo_link_std_bw_allocated = YList(self)
                                self.topo_link_std_bw_available = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in () and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail, self).__setattr__(name, value)


                            class TopoLinkStdBwAllocated(Entity):
                                """
                                Link's allocated bandwidth per class
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAllocated, self).__init__()

                                    self.yang_name = "topo-link-std-bw-allocated"
                                    self.yang_parent_name = "topo-link-std-bw-detail"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAllocated, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAllocated, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "topo-link-std-bw-allocated" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix


                            class TopoLinkStdBwAvailable(Entity):
                                """
                                Link's available bandwidth per class
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAvailable, self).__init__()

                                    self.yang_name = "topo-link-std-bw-available"
                                    self.yang_parent_name = "topo-link-std-bw-detail"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAvailable, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAvailable, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "topo-link-std-bw-available" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.topo_link_std_bw_allocated:
                                    if (c.has_data()):
                                        return True
                                for c in self.topo_link_std_bw_available:
                                    if (c.has_data()):
                                        return True
                                return False

                            def has_operation(self):
                                for c in self.topo_link_std_bw_allocated:
                                    if (c.has_operation()):
                                        return True
                                for c in self.topo_link_std_bw_available:
                                    if (c.has_operation()):
                                        return True
                                return self.yfilter != YFilter.not_set

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "topo-link-std-bw-detail" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "topo-link-std-bw-allocated"):
                                    for c in self.topo_link_std_bw_allocated:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAllocated()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.topo_link_std_bw_allocated.append(c)
                                    return c

                                if (child_yang_name == "topo-link-std-bw-available"):
                                    for c in self.topo_link_std_bw_available:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAvailable()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.topo_link_std_bw_available.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "topo-link-std-bw-allocated" or name == "topo-link-std-bw-available"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass

                        def has_data(self):
                            return (
                                self.topo_link_std_bw_physical.is_set or
                                self.topo_link_std_bw_res_max.is_set or
                                self.topo_link_std_bw_res_pool0.is_set or
                                self.topo_link_std_bw_res_pool1.is_set or
                                (self.topo_link_std_bw_detail is not None and self.topo_link_std_bw_detail.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.topo_link_std_bw_physical.yfilter != YFilter.not_set or
                                self.topo_link_std_bw_res_max.yfilter != YFilter.not_set or
                                self.topo_link_std_bw_res_pool0.yfilter != YFilter.not_set or
                                self.topo_link_std_bw_res_pool1.yfilter != YFilter.not_set or
                                (self.topo_link_std_bw_detail is not None and self.topo_link_std_bw_detail.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "topology-link-bandwidth-standard" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.topo_link_std_bw_physical.is_set or self.topo_link_std_bw_physical.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.topo_link_std_bw_physical.get_name_leafdata())
                            if (self.topo_link_std_bw_res_max.is_set or self.topo_link_std_bw_res_max.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.topo_link_std_bw_res_max.get_name_leafdata())
                            if (self.topo_link_std_bw_res_pool0.is_set or self.topo_link_std_bw_res_pool0.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.topo_link_std_bw_res_pool0.get_name_leafdata())
                            if (self.topo_link_std_bw_res_pool1.is_set or self.topo_link_std_bw_res_pool1.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.topo_link_std_bw_res_pool1.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "topo-link-std-bw-detail"):
                                if (self.topo_link_std_bw_detail is None):
                                    self.topo_link_std_bw_detail = MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail()
                                    self.topo_link_std_bw_detail.parent = self
                                    self._children_name_map["topo_link_std_bw_detail"] = "topo-link-std-bw-detail"
                                return self.topo_link_std_bw_detail

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "topo-link-std-bw-detail" or name == "topo-link-std-bw-physical" or name == "topo-link-std-bw-res-max" or name == "topo-link-std-bw-res-pool0" or name == "topo-link-std-bw-res-pool1"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "topo-link-std-bw-physical"):
                                self.topo_link_std_bw_physical = value
                                self.topo_link_std_bw_physical.value_namespace = name_space
                                self.topo_link_std_bw_physical.value_namespace_prefix = name_space_prefix
                            if(value_path == "topo-link-std-bw-res-max"):
                                self.topo_link_std_bw_res_max = value
                                self.topo_link_std_bw_res_max.value_namespace = name_space
                                self.topo_link_std_bw_res_max.value_namespace_prefix = name_space_prefix
                            if(value_path == "topo-link-std-bw-res-pool0"):
                                self.topo_link_std_bw_res_pool0 = value
                                self.topo_link_std_bw_res_pool0.value_namespace = name_space
                                self.topo_link_std_bw_res_pool0.value_namespace_prefix = name_space_prefix
                            if(value_path == "topo-link-std-bw-res-pool1"):
                                self.topo_link_std_bw_res_pool1 = value
                                self.topo_link_std_bw_res_pool1.value_namespace = name_space
                                self.topo_link_std_bw_res_pool1.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.bandwidth_migration_mode.is_set or
                            (self.topology_link_bandwidth_prestandard is not None and self.topology_link_bandwidth_prestandard.has_data()) or
                            (self.topology_link_bandwidth_standard is not None and self.topology_link_bandwidth_standard.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.bandwidth_migration_mode.yfilter != YFilter.not_set or
                            (self.topology_link_bandwidth_prestandard is not None and self.topology_link_bandwidth_prestandard.has_operation()) or
                            (self.topology_link_bandwidth_standard is not None and self.topology_link_bandwidth_standard.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "topology-link-bandwidth" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.bandwidth_migration_mode.is_set or self.bandwidth_migration_mode.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.bandwidth_migration_mode.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "topology-link-bandwidth-prestandard"):
                            if (self.topology_link_bandwidth_prestandard is None):
                                self.topology_link_bandwidth_prestandard = MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard()
                                self.topology_link_bandwidth_prestandard.parent = self
                                self._children_name_map["topology_link_bandwidth_prestandard"] = "topology-link-bandwidth-prestandard"
                            return self.topology_link_bandwidth_prestandard

                        if (child_yang_name == "topology-link-bandwidth-standard"):
                            if (self.topology_link_bandwidth_standard is None):
                                self.topology_link_bandwidth_standard = MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard()
                                self.topology_link_bandwidth_standard.parent = self
                                self._children_name_map["topology_link_bandwidth_standard"] = "topology-link-bandwidth-standard"
                            return self.topology_link_bandwidth_standard

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "topology-link-bandwidth-prestandard" or name == "topology-link-bandwidth-standard" or name == "bandwidth-migration-mode"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "bandwidth-migration-mode"):
                            self.bandwidth_migration_mode = value
                            self.bandwidth_migration_mode.value_namespace = name_space
                            self.bandwidth_migration_mode.value_namespace_prefix = name_space_prefix


                class OduLinkCapabilities(Entity):
                    """
                    ODU Link Capabilities
                    
                    .. attribute:: max_lsp_bandwidth
                    
                    	Max LSP Bandwidth per priority in kbit/s
                    	**type**\: list of    :py:class:`MaxLspBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.MaxLspBandwidth>`
                    
                    .. attribute:: odu_capability
                    
                    	ODU Capabilities of Link
                    	**type**\: list of    :py:class:`OduCapability <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities, self).__init__()

                        self.yang_name = "odu-link-capabilities"
                        self.yang_parent_name = "topology-node-link"

                        self.max_lsp_bandwidth = YList(self)
                        self.odu_capability = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in () and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities, self).__setattr__(name, value)


                    class MaxLspBandwidth(Entity):
                        """
                        Max LSP Bandwidth per priority in kbit/s
                        
                        .. attribute:: entry
                        
                        	
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.MaxLspBandwidth, self).__init__()

                            self.yang_name = "max-lsp-bandwidth"
                            self.yang_parent_name = "odu-link-capabilities"

                            self.entry = YLeaf(YType.uint32, "entry")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("entry") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.MaxLspBandwidth, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.MaxLspBandwidth, self).__setattr__(name, value)

                        def has_data(self):
                            return self.entry.is_set

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.entry.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "max-lsp-bandwidth" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.entry.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "entry"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "entry"):
                                self.entry = value
                                self.entry.value_namespace = name_space
                                self.entry.value_namespace_prefix = name_space_prefix


                    class OduCapability(Entity):
                        """
                        ODU Capabilities of Link
                        
                        .. attribute:: bandwidth_info
                        
                        	Bandwidth related info for this ODU level
                        	**type**\:   :py:class:`BandwidthInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo>`
                        
                        .. attribute:: lcas_capable
                        
                        	True if link LCAS capable for this ODU level
                        	**type**\:  bool
                        
                        .. attribute:: signal_type
                        
                        	Signal Type
                        	**type**\:   :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                        
                        .. attribute:: stage1
                        
                        	ODU Type at stage 1, Not Set for HO ODU
                        	**type**\:   :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                        
                        .. attribute:: stage2
                        
                        	ODU Type at stage 2, Not Set for single stage mulitplexing
                        	**type**\:   :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                        
                        .. attribute:: stage3
                        
                        	ODU Type at stage 3, Not set up to two levels of multiplexing
                        	**type**\:   :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                        
                        .. attribute:: stage4
                        
                        	ODU Type at stage 4, Not set up to three levels of multiplexing
                        	**type**\:   :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                        
                        .. attribute:: switchable
                        
                        	True if link is switchable for this ODU level
                        	**type**\:  bool
                        
                        .. attribute:: terminable
                        
                        	True if link is terminable for this ODU level
                        	**type**\:  bool
                        
                        .. attribute:: tsg1p25
                        
                        	True if link supports 1.25G TSG for this ODU level
                        	**type**\:  bool
                        
                        .. attribute:: tsg2p5
                        
                        	True if link supports 2.5G TSG for this ODU level
                        	**type**\:  bool
                        
                        .. attribute:: vcat_capable
                        
                        	True if link VCAT capable for this ODU level
                        	**type**\:  bool
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability, self).__init__()

                            self.yang_name = "odu-capability"
                            self.yang_parent_name = "odu-link-capabilities"

                            self.lcas_capable = YLeaf(YType.boolean, "lcas-capable")

                            self.signal_type = YLeaf(YType.enumeration, "signal-type")

                            self.stage1 = YLeaf(YType.enumeration, "stage1")

                            self.stage2 = YLeaf(YType.enumeration, "stage2")

                            self.stage3 = YLeaf(YType.enumeration, "stage3")

                            self.stage4 = YLeaf(YType.enumeration, "stage4")

                            self.switchable = YLeaf(YType.boolean, "switchable")

                            self.terminable = YLeaf(YType.boolean, "terminable")

                            self.tsg1p25 = YLeaf(YType.boolean, "tsg1p25")

                            self.tsg2p5 = YLeaf(YType.boolean, "tsg2p5")

                            self.vcat_capable = YLeaf(YType.boolean, "vcat-capable")

                            self.bandwidth_info = MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo()
                            self.bandwidth_info.parent = self
                            self._children_name_map["bandwidth_info"] = "bandwidth-info"
                            self._children_yang_names.add("bandwidth-info")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("lcas_capable",
                                            "signal_type",
                                            "stage1",
                                            "stage2",
                                            "stage3",
                                            "stage4",
                                            "switchable",
                                            "terminable",
                                            "tsg1p25",
                                            "tsg2p5",
                                            "vcat_capable") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability, self).__setattr__(name, value)


                        class BandwidthInfo(Entity):
                            """
                            Bandwidth related info for this ODU level
                            
                            .. attribute:: fixed
                            
                            	ODU capability for Fixed ODUs
                            	**type**\:   :py:class:`Fixed <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed>`
                            
                            .. attribute:: flex
                            
                            	ODU capability for Flex ODUs
                            	**type**\:   :py:class:`Flex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex>`
                            
                            .. attribute:: type
                            
                            	type
                            	**type**\:   :py:class:`TeOduCapability <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduCapability>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo, self).__init__()

                                self.yang_name = "bandwidth-info"
                                self.yang_parent_name = "odu-capability"

                                self.type = YLeaf(YType.enumeration, "type")

                                self.fixed = MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed()
                                self.fixed.parent = self
                                self._children_name_map["fixed"] = "fixed"
                                self._children_yang_names.add("fixed")

                                self.flex = MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex()
                                self.flex.parent = self
                                self._children_name_map["flex"] = "flex"
                                self._children_yang_names.add("flex")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo, self).__setattr__(name, value)


                            class Fixed(Entity):
                                """
                                ODU capability for Fixed ODUs
                                
                                .. attribute:: maximum_od_us
                                
                                	Maximum Number of ODUs of this level possible on this link
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: unreserved_od_us
                                
                                	Maximum Number of ODUs of this level possible on this link
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed, self).__init__()

                                    self.yang_name = "fixed"
                                    self.yang_parent_name = "bandwidth-info"

                                    self.maximum_od_us = YLeaf(YType.uint8, "maximum-od-us")

                                    self.unreserved_od_us = YLeaf(YType.uint8, "unreserved-od-us")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("maximum_od_us",
                                                    "unreserved_od_us") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.maximum_od_us.is_set or
                                        self.unreserved_od_us.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.maximum_od_us.yfilter != YFilter.not_set or
                                        self.unreserved_od_us.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "fixed" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.maximum_od_us.is_set or self.maximum_od_us.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.maximum_od_us.get_name_leafdata())
                                    if (self.unreserved_od_us.is_set or self.unreserved_od_us.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.unreserved_od_us.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "maximum-od-us" or name == "unreserved-od-us"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "maximum-od-us"):
                                        self.maximum_od_us = value
                                        self.maximum_od_us.value_namespace = name_space
                                        self.maximum_od_us.value_namespace_prefix = name_space_prefix
                                    if(value_path == "unreserved-od-us"):
                                        self.unreserved_od_us = value
                                        self.unreserved_od_us.value_namespace = name_space
                                        self.unreserved_od_us.value_namespace_prefix = name_space_prefix


                            class Flex(Entity):
                                """
                                ODU capability for Flex ODUs
                                
                                .. attribute:: max_bandwidth
                                
                                	Max kbps Bandwidth of this level possible on this link
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: max_lsp_bandwidth
                                
                                	Per LSP Max kbps Bandwidth of this level possible on this link
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: unreserved_bandwidth
                                
                                	Unreserved kbps Bandwidth of this level possible on this link
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex, self).__init__()

                                    self.yang_name = "flex"
                                    self.yang_parent_name = "bandwidth-info"

                                    self.max_bandwidth = YLeaf(YType.uint32, "max-bandwidth")

                                    self.max_lsp_bandwidth = YLeaf(YType.uint32, "max-lsp-bandwidth")

                                    self.unreserved_bandwidth = YLeaf(YType.uint32, "unreserved-bandwidth")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("max_bandwidth",
                                                    "max_lsp_bandwidth",
                                                    "unreserved_bandwidth") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.max_bandwidth.is_set or
                                        self.max_lsp_bandwidth.is_set or
                                        self.unreserved_bandwidth.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.max_bandwidth.yfilter != YFilter.not_set or
                                        self.max_lsp_bandwidth.yfilter != YFilter.not_set or
                                        self.unreserved_bandwidth.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "flex" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.max_bandwidth.is_set or self.max_bandwidth.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.max_bandwidth.get_name_leafdata())
                                    if (self.max_lsp_bandwidth.is_set or self.max_lsp_bandwidth.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.max_lsp_bandwidth.get_name_leafdata())
                                    if (self.unreserved_bandwidth.is_set or self.unreserved_bandwidth.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.unreserved_bandwidth.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "max-bandwidth" or name == "max-lsp-bandwidth" or name == "unreserved-bandwidth"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "max-bandwidth"):
                                        self.max_bandwidth = value
                                        self.max_bandwidth.value_namespace = name_space
                                        self.max_bandwidth.value_namespace_prefix = name_space_prefix
                                    if(value_path == "max-lsp-bandwidth"):
                                        self.max_lsp_bandwidth = value
                                        self.max_lsp_bandwidth.value_namespace = name_space
                                        self.max_lsp_bandwidth.value_namespace_prefix = name_space_prefix
                                    if(value_path == "unreserved-bandwidth"):
                                        self.unreserved_bandwidth = value
                                        self.unreserved_bandwidth.value_namespace = name_space
                                        self.unreserved_bandwidth.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.type.is_set or
                                    (self.fixed is not None and self.fixed.has_data()) or
                                    (self.flex is not None and self.flex.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.type.yfilter != YFilter.not_set or
                                    (self.fixed is not None and self.fixed.has_operation()) or
                                    (self.flex is not None and self.flex.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "bandwidth-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "fixed"):
                                    if (self.fixed is None):
                                        self.fixed = MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed()
                                        self.fixed.parent = self
                                        self._children_name_map["fixed"] = "fixed"
                                    return self.fixed

                                if (child_yang_name == "flex"):
                                    if (self.flex is None):
                                        self.flex = MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex()
                                        self.flex.parent = self
                                        self._children_name_map["flex"] = "flex"
                                    return self.flex

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fixed" or name == "flex" or name == "type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "type"):
                                    self.type = value
                                    self.type.value_namespace = name_space
                                    self.type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.lcas_capable.is_set or
                                self.signal_type.is_set or
                                self.stage1.is_set or
                                self.stage2.is_set or
                                self.stage3.is_set or
                                self.stage4.is_set or
                                self.switchable.is_set or
                                self.terminable.is_set or
                                self.tsg1p25.is_set or
                                self.tsg2p5.is_set or
                                self.vcat_capable.is_set or
                                (self.bandwidth_info is not None and self.bandwidth_info.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.lcas_capable.yfilter != YFilter.not_set or
                                self.signal_type.yfilter != YFilter.not_set or
                                self.stage1.yfilter != YFilter.not_set or
                                self.stage2.yfilter != YFilter.not_set or
                                self.stage3.yfilter != YFilter.not_set or
                                self.stage4.yfilter != YFilter.not_set or
                                self.switchable.yfilter != YFilter.not_set or
                                self.terminable.yfilter != YFilter.not_set or
                                self.tsg1p25.yfilter != YFilter.not_set or
                                self.tsg2p5.yfilter != YFilter.not_set or
                                self.vcat_capable.yfilter != YFilter.not_set or
                                (self.bandwidth_info is not None and self.bandwidth_info.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "odu-capability" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.lcas_capable.is_set or self.lcas_capable.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lcas_capable.get_name_leafdata())
                            if (self.signal_type.is_set or self.signal_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.signal_type.get_name_leafdata())
                            if (self.stage1.is_set or self.stage1.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.stage1.get_name_leafdata())
                            if (self.stage2.is_set or self.stage2.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.stage2.get_name_leafdata())
                            if (self.stage3.is_set or self.stage3.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.stage3.get_name_leafdata())
                            if (self.stage4.is_set or self.stage4.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.stage4.get_name_leafdata())
                            if (self.switchable.is_set or self.switchable.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.switchable.get_name_leafdata())
                            if (self.terminable.is_set or self.terminable.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.terminable.get_name_leafdata())
                            if (self.tsg1p25.is_set or self.tsg1p25.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tsg1p25.get_name_leafdata())
                            if (self.tsg2p5.is_set or self.tsg2p5.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tsg2p5.get_name_leafdata())
                            if (self.vcat_capable.is_set or self.vcat_capable.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.vcat_capable.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "bandwidth-info"):
                                if (self.bandwidth_info is None):
                                    self.bandwidth_info = MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo()
                                    self.bandwidth_info.parent = self
                                    self._children_name_map["bandwidth_info"] = "bandwidth-info"
                                return self.bandwidth_info

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "bandwidth-info" or name == "lcas-capable" or name == "signal-type" or name == "stage1" or name == "stage2" or name == "stage3" or name == "stage4" or name == "switchable" or name == "terminable" or name == "tsg1p25" or name == "tsg2p5" or name == "vcat-capable"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "lcas-capable"):
                                self.lcas_capable = value
                                self.lcas_capable.value_namespace = name_space
                                self.lcas_capable.value_namespace_prefix = name_space_prefix
                            if(value_path == "signal-type"):
                                self.signal_type = value
                                self.signal_type.value_namespace = name_space
                                self.signal_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "stage1"):
                                self.stage1 = value
                                self.stage1.value_namespace = name_space
                                self.stage1.value_namespace_prefix = name_space_prefix
                            if(value_path == "stage2"):
                                self.stage2 = value
                                self.stage2.value_namespace = name_space
                                self.stage2.value_namespace_prefix = name_space_prefix
                            if(value_path == "stage3"):
                                self.stage3 = value
                                self.stage3.value_namespace = name_space
                                self.stage3.value_namespace_prefix = name_space_prefix
                            if(value_path == "stage4"):
                                self.stage4 = value
                                self.stage4.value_namespace = name_space
                                self.stage4.value_namespace_prefix = name_space_prefix
                            if(value_path == "switchable"):
                                self.switchable = value
                                self.switchable.value_namespace = name_space
                                self.switchable.value_namespace_prefix = name_space_prefix
                            if(value_path == "terminable"):
                                self.terminable = value
                                self.terminable.value_namespace = name_space
                                self.terminable.value_namespace_prefix = name_space_prefix
                            if(value_path == "tsg1p25"):
                                self.tsg1p25 = value
                                self.tsg1p25.value_namespace = name_space
                                self.tsg1p25.value_namespace_prefix = name_space_prefix
                            if(value_path == "tsg2p5"):
                                self.tsg2p5 = value
                                self.tsg2p5.value_namespace = name_space
                                self.tsg2p5.value_namespace_prefix = name_space_prefix
                            if(value_path == "vcat-capable"):
                                self.vcat_capable = value
                                self.vcat_capable.value_namespace = name_space
                                self.vcat_capable.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.max_lsp_bandwidth:
                            if (c.has_data()):
                                return True
                        for c in self.odu_capability:
                            if (c.has_data()):
                                return True
                        return False

                    def has_operation(self):
                        for c in self.max_lsp_bandwidth:
                            if (c.has_operation()):
                                return True
                        for c in self.odu_capability:
                            if (c.has_operation()):
                                return True
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "odu-link-capabilities" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "max-lsp-bandwidth"):
                            for c in self.max_lsp_bandwidth:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.MaxLspBandwidth()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.max_lsp_bandwidth.append(c)
                            return c

                        if (child_yang_name == "odu-capability"):
                            for c in self.odu_capability:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities.OduCapability()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.odu_capability.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "max-lsp-bandwidth" or name == "odu-capability"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class TopologyLinkExtendedAffinityBit(Entity):
                    """
                    The link's affinity bits (colors)
                    
                    .. attribute:: entry
                    
                    	
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkExtendedAffinityBit, self).__init__()

                        self.yang_name = "topology-link-extended-affinity-bit"
                        self.yang_parent_name = "topology-node-link"

                        self.entry = YLeaf(YType.uint32, "entry")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("entry") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkExtendedAffinityBit, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkExtendedAffinityBit, self).__setattr__(name, value)

                    def has_data(self):
                        return self.entry.is_set

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.entry.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "topology-link-extended-affinity-bit" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.entry.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "entry"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "entry"):
                            self.entry = value
                            self.entry.value_namespace = name_space
                            self.entry.value_namespace_prefix = name_space_prefix


                class SharedRiskLinkGroup(Entity):
                    """
                    The link's shared risk link groups
                    
                    .. attribute:: shared_risk_group
                    
                    	SRLG number
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: srlg_name
                    
                    	SRLG name
                    	**type**\:  str
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.SharedRiskLinkGroup, self).__init__()

                        self.yang_name = "shared-risk-link-group"
                        self.yang_parent_name = "topology-node-link"

                        self.shared_risk_group = YLeaf(YType.uint32, "shared-risk-group")

                        self.srlg_name = YLeaf(YType.str, "srlg-name")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("shared_risk_group",
                                        "srlg_name") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.SharedRiskLinkGroup, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.SharedRiskLinkGroup, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.shared_risk_group.is_set or
                            self.srlg_name.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.shared_risk_group.yfilter != YFilter.not_set or
                            self.srlg_name.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "shared-risk-link-group" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.shared_risk_group.is_set or self.shared_risk_group.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.shared_risk_group.get_name_leafdata())
                        if (self.srlg_name.is_set or self.srlg_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.srlg_name.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "shared-risk-group" or name == "srlg-name"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "shared-risk-group"):
                            self.shared_risk_group = value
                            self.shared_risk_group.value_namespace = name_space
                            self.shared_risk_group.value_namespace_prefix = name_space_prefix
                        if(value_path == "srlg-name"):
                            self.srlg_name = value
                            self.srlg_name.value_namespace = name_space
                            self.srlg_name.value_namespace_prefix = name_space_prefix


                class AdjacencySid(Entity):
                    """
                    Adjacency SIDs assigned for adjacency nodes
                    
                    .. attribute:: adjacency_sid
                    
                    	The adjacency SID assigned for the topology node
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: flag_b
                    
                    	IGP Flag B
                    	**type**\:  bool
                    
                    .. attribute:: flag_f
                    
                    	IGP Flag F
                    	**type**\:  bool
                    
                    .. attribute:: flag_l
                    
                    	IGP Flag L
                    	**type**\:  bool
                    
                    .. attribute:: flag_s
                    
                    	IGP Flag S
                    	**type**\:  bool
                    
                    .. attribute:: flag_v
                    
                    	IGP Flag V
                    	**type**\:  bool
                    
                    .. attribute:: link_type
                    
                    	Link Type
                    	**type**\:   :py:class:`IgpSubnet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpSubnet>`
                    
                    .. attribute:: local_addr
                    
                    	Local Address
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: nbr_node_igpid
                    
                    	The neighbor node's IGP ID
                    	**type**\:  str
                    
                    .. attribute:: nbr_node_te_router_id
                    
                    	The neigbor node's TE router\-id
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: remote_addr
                    
                    	Remote Address
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.AdjacencySid, self).__init__()

                        self.yang_name = "adjacency-sid"
                        self.yang_parent_name = "topology-node-link"

                        self.adjacency_sid = YLeaf(YType.uint32, "adjacency-sid")

                        self.flag_b = YLeaf(YType.boolean, "flag-b")

                        self.flag_f = YLeaf(YType.boolean, "flag-f")

                        self.flag_l = YLeaf(YType.boolean, "flag-l")

                        self.flag_s = YLeaf(YType.boolean, "flag-s")

                        self.flag_v = YLeaf(YType.boolean, "flag-v")

                        self.link_type = YLeaf(YType.enumeration, "link-type")

                        self.local_addr = YLeaf(YType.str, "local-addr")

                        self.nbr_node_igpid = YLeaf(YType.str, "nbr-node-igpid")

                        self.nbr_node_te_router_id = YLeaf(YType.str, "nbr-node-te-router-id")

                        self.remote_addr = YLeaf(YType.str, "remote-addr")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("adjacency_sid",
                                        "flag_b",
                                        "flag_f",
                                        "flag_l",
                                        "flag_s",
                                        "flag_v",
                                        "link_type",
                                        "local_addr",
                                        "nbr_node_igpid",
                                        "nbr_node_te_router_id",
                                        "remote_addr") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.AdjacencySid, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.AdjacencySid, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.adjacency_sid.is_set or
                            self.flag_b.is_set or
                            self.flag_f.is_set or
                            self.flag_l.is_set or
                            self.flag_s.is_set or
                            self.flag_v.is_set or
                            self.link_type.is_set or
                            self.local_addr.is_set or
                            self.nbr_node_igpid.is_set or
                            self.nbr_node_te_router_id.is_set or
                            self.remote_addr.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.adjacency_sid.yfilter != YFilter.not_set or
                            self.flag_b.yfilter != YFilter.not_set or
                            self.flag_f.yfilter != YFilter.not_set or
                            self.flag_l.yfilter != YFilter.not_set or
                            self.flag_s.yfilter != YFilter.not_set or
                            self.flag_v.yfilter != YFilter.not_set or
                            self.link_type.yfilter != YFilter.not_set or
                            self.local_addr.yfilter != YFilter.not_set or
                            self.nbr_node_igpid.yfilter != YFilter.not_set or
                            self.nbr_node_te_router_id.yfilter != YFilter.not_set or
                            self.remote_addr.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "adjacency-sid" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.adjacency_sid.is_set or self.adjacency_sid.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.adjacency_sid.get_name_leafdata())
                        if (self.flag_b.is_set or self.flag_b.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.flag_b.get_name_leafdata())
                        if (self.flag_f.is_set or self.flag_f.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.flag_f.get_name_leafdata())
                        if (self.flag_l.is_set or self.flag_l.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.flag_l.get_name_leafdata())
                        if (self.flag_s.is_set or self.flag_s.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.flag_s.get_name_leafdata())
                        if (self.flag_v.is_set or self.flag_v.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.flag_v.get_name_leafdata())
                        if (self.link_type.is_set or self.link_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.link_type.get_name_leafdata())
                        if (self.local_addr.is_set or self.local_addr.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.local_addr.get_name_leafdata())
                        if (self.nbr_node_igpid.is_set or self.nbr_node_igpid.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nbr_node_igpid.get_name_leafdata())
                        if (self.nbr_node_te_router_id.is_set or self.nbr_node_te_router_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nbr_node_te_router_id.get_name_leafdata())
                        if (self.remote_addr.is_set or self.remote_addr.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.remote_addr.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "adjacency-sid" or name == "flag-b" or name == "flag-f" or name == "flag-l" or name == "flag-s" or name == "flag-v" or name == "link-type" or name == "local-addr" or name == "nbr-node-igpid" or name == "nbr-node-te-router-id" or name == "remote-addr"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "adjacency-sid"):
                            self.adjacency_sid = value
                            self.adjacency_sid.value_namespace = name_space
                            self.adjacency_sid.value_namespace_prefix = name_space_prefix
                        if(value_path == "flag-b"):
                            self.flag_b = value
                            self.flag_b.value_namespace = name_space
                            self.flag_b.value_namespace_prefix = name_space_prefix
                        if(value_path == "flag-f"):
                            self.flag_f = value
                            self.flag_f.value_namespace = name_space
                            self.flag_f.value_namespace_prefix = name_space_prefix
                        if(value_path == "flag-l"):
                            self.flag_l = value
                            self.flag_l.value_namespace = name_space
                            self.flag_l.value_namespace_prefix = name_space_prefix
                        if(value_path == "flag-s"):
                            self.flag_s = value
                            self.flag_s.value_namespace = name_space
                            self.flag_s.value_namespace_prefix = name_space_prefix
                        if(value_path == "flag-v"):
                            self.flag_v = value
                            self.flag_v.value_namespace = name_space
                            self.flag_v.value_namespace_prefix = name_space_prefix
                        if(value_path == "link-type"):
                            self.link_type = value
                            self.link_type.value_namespace = name_space
                            self.link_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "local-addr"):
                            self.local_addr = value
                            self.local_addr.value_namespace = name_space
                            self.local_addr.value_namespace_prefix = name_space_prefix
                        if(value_path == "nbr-node-igpid"):
                            self.nbr_node_igpid = value
                            self.nbr_node_igpid.value_namespace = name_space
                            self.nbr_node_igpid.value_namespace_prefix = name_space_prefix
                        if(value_path == "nbr-node-te-router-id"):
                            self.nbr_node_te_router_id = value
                            self.nbr_node_te_router_id.value_namespace = name_space
                            self.nbr_node_te_router_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "remote-addr"):
                            self.remote_addr = value
                            self.remote_addr.value_namespace = name_space
                            self.remote_addr.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.adjacency_sid:
                        if (c.has_data()):
                            return True
                    for c in self.shared_risk_link_group:
                        if (c.has_data()):
                            return True
                    for c in self.topology_link_extended_affinity_bit:
                        if (c.has_data()):
                            return True
                    return (
                        self.topology_link_affinity_bits.is_set or
                        self.topology_link_bandwidth_model.is_set or
                        self.topology_link_encoding.is_set or
                        self.topology_link_fragment_id.is_set or
                        self.topology_link_igp_metric.is_set or
                        self.topology_link_interface_address.is_set or
                        self.topology_link_interface_id.is_set or
                        self.topology_link_neighbor_address.is_set or
                        self.topology_link_neighbor_generation.is_set or
                        self.topology_link_neighbor_id.is_set or
                        self.topology_link_neighbor_node_id.is_set or
                        self.topology_link_neighbor_system_id.is_set or
                        self.topology_link_switching_capability.is_set or
                        self.topology_link_te_metric.is_set or
                        self.topology_link_type.is_set or
                        self.topology_link_uni_delay.is_set or
                        (self.odu_link_capabilities is not None and self.odu_link_capabilities.has_data()) or
                        (self.topology_link_bandwidth is not None and self.topology_link_bandwidth.has_data()))

                def has_operation(self):
                    for c in self.adjacency_sid:
                        if (c.has_operation()):
                            return True
                    for c in self.shared_risk_link_group:
                        if (c.has_operation()):
                            return True
                    for c in self.topology_link_extended_affinity_bit:
                        if (c.has_operation()):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        self.topology_link_affinity_bits.yfilter != YFilter.not_set or
                        self.topology_link_bandwidth_model.yfilter != YFilter.not_set or
                        self.topology_link_encoding.yfilter != YFilter.not_set or
                        self.topology_link_fragment_id.yfilter != YFilter.not_set or
                        self.topology_link_igp_metric.yfilter != YFilter.not_set or
                        self.topology_link_interface_address.yfilter != YFilter.not_set or
                        self.topology_link_interface_id.yfilter != YFilter.not_set or
                        self.topology_link_neighbor_address.yfilter != YFilter.not_set or
                        self.topology_link_neighbor_generation.yfilter != YFilter.not_set or
                        self.topology_link_neighbor_id.yfilter != YFilter.not_set or
                        self.topology_link_neighbor_node_id.yfilter != YFilter.not_set or
                        self.topology_link_neighbor_system_id.yfilter != YFilter.not_set or
                        self.topology_link_switching_capability.yfilter != YFilter.not_set or
                        self.topology_link_te_metric.yfilter != YFilter.not_set or
                        self.topology_link_type.yfilter != YFilter.not_set or
                        self.topology_link_uni_delay.yfilter != YFilter.not_set or
                        (self.odu_link_capabilities is not None and self.odu_link_capabilities.has_operation()) or
                        (self.topology_link_bandwidth is not None and self.topology_link_bandwidth.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "topology-node-link" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.topology_link_affinity_bits.is_set or self.topology_link_affinity_bits.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.topology_link_affinity_bits.get_name_leafdata())
                    if (self.topology_link_bandwidth_model.is_set or self.topology_link_bandwidth_model.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.topology_link_bandwidth_model.get_name_leafdata())
                    if (self.topology_link_encoding.is_set or self.topology_link_encoding.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.topology_link_encoding.get_name_leafdata())
                    if (self.topology_link_fragment_id.is_set or self.topology_link_fragment_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.topology_link_fragment_id.get_name_leafdata())
                    if (self.topology_link_igp_metric.is_set or self.topology_link_igp_metric.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.topology_link_igp_metric.get_name_leafdata())
                    if (self.topology_link_interface_address.is_set or self.topology_link_interface_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.topology_link_interface_address.get_name_leafdata())
                    if (self.topology_link_interface_id.is_set or self.topology_link_interface_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.topology_link_interface_id.get_name_leafdata())
                    if (self.topology_link_neighbor_address.is_set or self.topology_link_neighbor_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.topology_link_neighbor_address.get_name_leafdata())
                    if (self.topology_link_neighbor_generation.is_set or self.topology_link_neighbor_generation.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.topology_link_neighbor_generation.get_name_leafdata())
                    if (self.topology_link_neighbor_id.is_set or self.topology_link_neighbor_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.topology_link_neighbor_id.get_name_leafdata())
                    if (self.topology_link_neighbor_node_id.is_set or self.topology_link_neighbor_node_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.topology_link_neighbor_node_id.get_name_leafdata())
                    if (self.topology_link_neighbor_system_id.is_set or self.topology_link_neighbor_system_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.topology_link_neighbor_system_id.get_name_leafdata())
                    if (self.topology_link_switching_capability.is_set or self.topology_link_switching_capability.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.topology_link_switching_capability.get_name_leafdata())
                    if (self.topology_link_te_metric.is_set or self.topology_link_te_metric.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.topology_link_te_metric.get_name_leafdata())
                    if (self.topology_link_type.is_set or self.topology_link_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.topology_link_type.get_name_leafdata())
                    if (self.topology_link_uni_delay.is_set or self.topology_link_uni_delay.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.topology_link_uni_delay.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "adjacency-sid"):
                        for c in self.adjacency_sid:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.AdjacencySid()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.adjacency_sid.append(c)
                        return c

                    if (child_yang_name == "odu-link-capabilities"):
                        if (self.odu_link_capabilities is None):
                            self.odu_link_capabilities = MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.OduLinkCapabilities()
                            self.odu_link_capabilities.parent = self
                            self._children_name_map["odu_link_capabilities"] = "odu-link-capabilities"
                        return self.odu_link_capabilities

                    if (child_yang_name == "shared-risk-link-group"):
                        for c in self.shared_risk_link_group:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.SharedRiskLinkGroup()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.shared_risk_link_group.append(c)
                        return c

                    if (child_yang_name == "topology-link-bandwidth"):
                        if (self.topology_link_bandwidth is None):
                            self.topology_link_bandwidth = MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkBandwidth()
                            self.topology_link_bandwidth.parent = self
                            self._children_name_map["topology_link_bandwidth"] = "topology-link-bandwidth"
                        return self.topology_link_bandwidth

                    if (child_yang_name == "topology-link-extended-affinity-bit"):
                        for c in self.topology_link_extended_affinity_bit:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink.TopologyLinkExtendedAffinityBit()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.topology_link_extended_affinity_bit.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "adjacency-sid" or name == "odu-link-capabilities" or name == "shared-risk-link-group" or name == "topology-link-bandwidth" or name == "topology-link-extended-affinity-bit" or name == "topology-link-affinity-bits" or name == "topology-link-bandwidth-model" or name == "topology-link-encoding" or name == "topology-link-fragment-id" or name == "topology-link-igp-metric" or name == "topology-link-interface-address" or name == "topology-link-interface-id" or name == "topology-link-neighbor-address" or name == "topology-link-neighbor-generation" or name == "topology-link-neighbor-id" or name == "topology-link-neighbor-node-id" or name == "topology-link-neighbor-system-id" or name == "topology-link-switching-capability" or name == "topology-link-te-metric" or name == "topology-link-type" or name == "topology-link-uni-delay"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "topology-link-affinity-bits"):
                        self.topology_link_affinity_bits = value
                        self.topology_link_affinity_bits.value_namespace = name_space
                        self.topology_link_affinity_bits.value_namespace_prefix = name_space_prefix
                    if(value_path == "topology-link-bandwidth-model"):
                        self.topology_link_bandwidth_model = value
                        self.topology_link_bandwidth_model.value_namespace = name_space
                        self.topology_link_bandwidth_model.value_namespace_prefix = name_space_prefix
                    if(value_path == "topology-link-encoding"):
                        self.topology_link_encoding = value
                        self.topology_link_encoding.value_namespace = name_space
                        self.topology_link_encoding.value_namespace_prefix = name_space_prefix
                    if(value_path == "topology-link-fragment-id"):
                        self.topology_link_fragment_id = value
                        self.topology_link_fragment_id.value_namespace = name_space
                        self.topology_link_fragment_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "topology-link-igp-metric"):
                        self.topology_link_igp_metric = value
                        self.topology_link_igp_metric.value_namespace = name_space
                        self.topology_link_igp_metric.value_namespace_prefix = name_space_prefix
                    if(value_path == "topology-link-interface-address"):
                        self.topology_link_interface_address = value
                        self.topology_link_interface_address.value_namespace = name_space
                        self.topology_link_interface_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "topology-link-interface-id"):
                        self.topology_link_interface_id = value
                        self.topology_link_interface_id.value_namespace = name_space
                        self.topology_link_interface_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "topology-link-neighbor-address"):
                        self.topology_link_neighbor_address = value
                        self.topology_link_neighbor_address.value_namespace = name_space
                        self.topology_link_neighbor_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "topology-link-neighbor-generation"):
                        self.topology_link_neighbor_generation = value
                        self.topology_link_neighbor_generation.value_namespace = name_space
                        self.topology_link_neighbor_generation.value_namespace_prefix = name_space_prefix
                    if(value_path == "topology-link-neighbor-id"):
                        self.topology_link_neighbor_id = value
                        self.topology_link_neighbor_id.value_namespace = name_space
                        self.topology_link_neighbor_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "topology-link-neighbor-node-id"):
                        self.topology_link_neighbor_node_id = value
                        self.topology_link_neighbor_node_id.value_namespace = name_space
                        self.topology_link_neighbor_node_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "topology-link-neighbor-system-id"):
                        self.topology_link_neighbor_system_id = value
                        self.topology_link_neighbor_system_id.value_namespace = name_space
                        self.topology_link_neighbor_system_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "topology-link-switching-capability"):
                        self.topology_link_switching_capability = value
                        self.topology_link_switching_capability.value_namespace = name_space
                        self.topology_link_switching_capability.value_namespace_prefix = name_space_prefix
                    if(value_path == "topology-link-te-metric"):
                        self.topology_link_te_metric = value
                        self.topology_link_te_metric.value_namespace = name_space
                        self.topology_link_te_metric.value_namespace_prefix = name_space_prefix
                    if(value_path == "topology-link-type"):
                        self.topology_link_type = value
                        self.topology_link_type.value_namespace = name_space
                        self.topology_link_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "topology-link-uni-delay"):
                        self.topology_link_uni_delay = value
                        self.topology_link_uni_delay.value_namespace = name_space
                        self.topology_link_uni_delay.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.topology_node_link:
                    if (c.has_data()):
                        return True
                return (
                    self.protocol.is_set or
                    self.igp_id.is_set or
                    self.area.is_set or
                    self.topology_node_type.is_set or
                    self.igp_node_id.is_set or
                    self.topology_node_overloaded.is_set or
                    self.topology_node_te_router_id.is_set or
                    (self.topology_node_sid_and_srbg is not None and self.topology_node_sid_and_srbg.has_data()))

            def has_operation(self):
                for c in self.topology_node_link:
                    if (c.has_operation()):
                        return True
                return (
                    self.yfilter != YFilter.not_set or
                    self.protocol.yfilter != YFilter.not_set or
                    self.igp_id.yfilter != YFilter.not_set or
                    self.area.yfilter != YFilter.not_set or
                    self.topology_node_type.yfilter != YFilter.not_set or
                    self.igp_node_id.yfilter != YFilter.not_set or
                    self.topology_node_overloaded.yfilter != YFilter.not_set or
                    self.topology_node_te_router_id.yfilter != YFilter.not_set or
                    (self.topology_node_sid_and_srbg is not None and self.topology_node_sid_and_srbg.has_operation()))

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "topology-node" + "[protocol='" + self.protocol.get() + "']" + "[igp-id='" + self.igp_id.get() + "']" + "[area='" + self.area.get() + "']" + "[topology-node-type='" + self.topology_node_type.get() + "']" + "[igp-node-id='" + self.igp_node_id.get() + "']" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/topology-nodes/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.protocol.is_set or self.protocol.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.protocol.get_name_leafdata())
                if (self.igp_id.is_set or self.igp_id.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.igp_id.get_name_leafdata())
                if (self.area.is_set or self.area.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.area.get_name_leafdata())
                if (self.topology_node_type.is_set or self.topology_node_type.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.topology_node_type.get_name_leafdata())
                if (self.igp_node_id.is_set or self.igp_node_id.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.igp_node_id.get_name_leafdata())
                if (self.topology_node_overloaded.is_set or self.topology_node_overloaded.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.topology_node_overloaded.get_name_leafdata())
                if (self.topology_node_te_router_id.is_set or self.topology_node_te_router_id.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.topology_node_te_router_id.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "topology-node-link"):
                    for c in self.topology_node_link:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeLink()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.topology_node_link.append(c)
                    return c

                if (child_yang_name == "topology-node-sid-and-srbg"):
                    if (self.topology_node_sid_and_srbg is None):
                        self.topology_node_sid_and_srbg = MplsTeStandby.TopologyNodes.TopologyNode.TopologyNodeSidAndSrbg()
                        self.topology_node_sid_and_srbg.parent = self
                        self._children_name_map["topology_node_sid_and_srbg"] = "topology-node-sid-and-srbg"
                    return self.topology_node_sid_and_srbg

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "topology-node-link" or name == "topology-node-sid-and-srbg" or name == "protocol" or name == "igp-id" or name == "area" or name == "topology-node-type" or name == "igp-node-id" or name == "topology-node-overloaded" or name == "topology-node-te-router-id"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "protocol"):
                    self.protocol = value
                    self.protocol.value_namespace = name_space
                    self.protocol.value_namespace_prefix = name_space_prefix
                if(value_path == "igp-id"):
                    self.igp_id = value
                    self.igp_id.value_namespace = name_space
                    self.igp_id.value_namespace_prefix = name_space_prefix
                if(value_path == "area"):
                    self.area = value
                    self.area.value_namespace = name_space
                    self.area.value_namespace_prefix = name_space_prefix
                if(value_path == "topology-node-type"):
                    self.topology_node_type = value
                    self.topology_node_type.value_namespace = name_space
                    self.topology_node_type.value_namespace_prefix = name_space_prefix
                if(value_path == "igp-node-id"):
                    self.igp_node_id = value
                    self.igp_node_id.value_namespace = name_space
                    self.igp_node_id.value_namespace_prefix = name_space_prefix
                if(value_path == "topology-node-overloaded"):
                    self.topology_node_overloaded = value
                    self.topology_node_overloaded.value_namespace = name_space
                    self.topology_node_overloaded.value_namespace_prefix = name_space_prefix
                if(value_path == "topology-node-te-router-id"):
                    self.topology_node_te_router_id = value
                    self.topology_node_te_router_id.value_namespace = name_space
                    self.topology_node_te_router_id.value_namespace_prefix = name_space_prefix

        def has_data(self):
            for c in self.topology_node:
                if (c.has_data()):
                    return True
            return False

        def has_operation(self):
            for c in self.topology_node:
                if (c.has_operation()):
                    return True
            return self.yfilter != YFilter.not_set

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "topology-nodes" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "topology-node"):
                for c in self.topology_node:
                    segment = c.get_segment_path()
                    if (segment_path == segment):
                        return c
                c = MplsTeStandby.TopologyNodes.TopologyNode()
                c.parent = self
                local_reference_key = "ydk::seg::%s" % segment_path
                self._local_refs[local_reference_key] = c
                self.topology_node.append(c)
                return c

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "topology-node"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class AnnounceTunnelsInfo(Entity):
        """
        Announced tunnels (forwarding adjacency and
        autoroute annonce)
        
        .. attribute:: all_autoroute_table
        
        	Autoroute announce and forwarding adjacency table
        	**type**\:   :py:class:`AllAutorouteTable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AnnounceTunnelsInfo.AllAutorouteTable>`
        
        .. attribute:: autoroute_announce_table
        
        	Autoroute announce and forwarding adjacency table
        	**type**\:   :py:class:`AutorouteAnnounceTable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AnnounceTunnelsInfo.AutorouteAnnounceTable>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsTeStandby.AnnounceTunnelsInfo, self).__init__()

            self.yang_name = "announce-tunnels-info"
            self.yang_parent_name = "mpls-te-standby"

            self.all_autoroute_table = MplsTeStandby.AnnounceTunnelsInfo.AllAutorouteTable()
            self.all_autoroute_table.parent = self
            self._children_name_map["all_autoroute_table"] = "all-autoroute-table"
            self._children_yang_names.add("all-autoroute-table")

            self.autoroute_announce_table = MplsTeStandby.AnnounceTunnelsInfo.AutorouteAnnounceTable()
            self.autoroute_announce_table.parent = self
            self._children_name_map["autoroute_announce_table"] = "autoroute-announce-table"
            self._children_yang_names.add("autoroute-announce-table")


        class AutorouteAnnounceTable(Entity):
            """
            Autoroute announce and forwarding adjacency
            table
            
            .. attribute:: announce_dest
            
            	Autoroute tunnels per destination information
            	**type**\: list of    :py:class:`AnnounceDest <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AnnounceTunnelsInfo.AutorouteAnnounceTable.AnnounceDest>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTeStandby.AnnounceTunnelsInfo.AutorouteAnnounceTable, self).__init__()

                self.yang_name = "autoroute-announce-table"
                self.yang_parent_name = "announce-tunnels-info"

                self.announce_dest = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTeStandby.AnnounceTunnelsInfo.AutorouteAnnounceTable, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTeStandby.AnnounceTunnelsInfo.AutorouteAnnounceTable, self).__setattr__(name, value)


            class AnnounceDest(Entity):
                """
                Autoroute tunnels per destination information
                
                .. attribute:: destination_address  <key>
                
                	Destination Address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: protocol  <key>
                
                	The IGP protocol used by the tunnel
                	**type**\:   :py:class:`MplsTeIgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeIgpProtocol>`
                
                .. attribute:: area  <key>
                
                	Area
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: igp_id  <key>
                
                	IGP Instance ID
                	**type**\:  str
                
                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                
                .. attribute:: announced_tunnels_count
                
                	The number of announced tunnels
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: area_format
                
                	The format for the area\: IPv4 address or a positive integer
                	**type**\:   :py:class:`IgpOspfAreaFormat <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpOspfAreaFormat>`
                
                .. attribute:: autorouted_tunnels_count
                
                	The number of tunnels that are announced as shortcuts
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: destination
                
                	Destination
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: forwarding_adjacency_tunnels_count
                
                	The number of tunnels that are announced as forwarding adjacencies
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: igp_area
                
                	IGP Area ID
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: igp_instance
                
                	IGP Instance name
                	**type**\:  str
                
                .. attribute:: igp_type
                
                	IGP type
                	**type**\:   :py:class:`IgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpProtocol>`
                
                .. attribute:: total_tunnel
                
                	Announced tunnels for this destination
                	**type**\: list of    :py:class:`TotalTunnel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AnnounceTunnelsInfo.AutorouteAnnounceTable.AnnounceDest.TotalTunnel>`
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTeStandby.AnnounceTunnelsInfo.AutorouteAnnounceTable.AnnounceDest, self).__init__()

                    self.yang_name = "announce-dest"
                    self.yang_parent_name = "autoroute-announce-table"

                    self.destination_address = YLeaf(YType.str, "destination-address")

                    self.protocol = YLeaf(YType.enumeration, "protocol")

                    self.area = YLeaf(YType.int32, "area")

                    self.igp_id = YLeaf(YType.str, "igp-id")

                    self.announced_tunnels_count = YLeaf(YType.uint16, "announced-tunnels-count")

                    self.area_format = YLeaf(YType.enumeration, "area-format")

                    self.autorouted_tunnels_count = YLeaf(YType.uint16, "autorouted-tunnels-count")

                    self.destination = YLeaf(YType.str, "destination")

                    self.forwarding_adjacency_tunnels_count = YLeaf(YType.uint16, "forwarding-adjacency-tunnels-count")

                    self.igp_area = YLeaf(YType.uint32, "igp-area")

                    self.igp_instance = YLeaf(YType.str, "igp-instance")

                    self.igp_type = YLeaf(YType.enumeration, "igp-type")

                    self.total_tunnel = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("destination_address",
                                    "protocol",
                                    "area",
                                    "igp_id",
                                    "announced_tunnels_count",
                                    "area_format",
                                    "autorouted_tunnels_count",
                                    "destination",
                                    "forwarding_adjacency_tunnels_count",
                                    "igp_area",
                                    "igp_instance",
                                    "igp_type") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTeStandby.AnnounceTunnelsInfo.AutorouteAnnounceTable.AnnounceDest, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTeStandby.AnnounceTunnelsInfo.AutorouteAnnounceTable.AnnounceDest, self).__setattr__(name, value)


                class TotalTunnel(Entity):
                    """
                    Announced tunnels for this destination
                    
                    .. attribute:: announce_type
                    
                    	Announcement type
                    	**type**\:   :py:class:`MplsTeTunnelAnnounce <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelAnnounce>`
                    
                    .. attribute:: area_format
                    
                    	IGP Area Format
                    	**type**\:   :py:class:`IgpOspfAreaFormat <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpOspfAreaFormat>`
                    
                    .. attribute:: hold_time
                    
                    	Hold time in seconds
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: ig_ps
                    
                    	List of IGPs to which it is announced
                    	**type**\: list of    :py:class:`IgPs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AnnounceTunnelsInfo.AutorouteAnnounceTable.AnnounceDest.TotalTunnel.IgPs>`
                    
                    .. attribute:: igp_metric
                    
                    	IGP metric
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: is_auto_mesh_aa
                    
                    	True if this is auto\-tunnel mesh AA
                    	**type**\:  bool
                    
                    .. attribute:: is_exclude_segment_routing
                    
                    	True if autoroute\-announce has exclude segment\-routing option
                    	**type**\:  bool
                    
                    .. attribute:: is_sr
                    
                    	True if this is a segment routing tunnel
                    	**type**\:  bool
                    
                    .. attribute:: is_sr_strict
                    
                    	True if this is a strict SID SR tunnel
                    	**type**\:  bool
                    
                    .. attribute:: mesh_group_idaa
                    
                    	MeshGroup ID for AA
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: mode
                    
                    	Autoroute mode
                    	**type**\:   :py:class:`IgpteAaMetricMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpteAaMetricMode>`
                    
                    .. attribute:: next_hop_address
                    
                    	The tunnel destination
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: tunnel_loadshare
                    
                    	Tunnel loadshare
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tunnel_name
                    
                    	The tunnel name
                    	**type**\:  str
                    
                    .. attribute:: tunnel_sig_name
                    
                    	The tunnel signaled\-name
                    	**type**\:  str
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.AnnounceTunnelsInfo.AutorouteAnnounceTable.AnnounceDest.TotalTunnel, self).__init__()

                        self.yang_name = "total-tunnel"
                        self.yang_parent_name = "announce-dest"

                        self.announce_type = YLeaf(YType.enumeration, "announce-type")

                        self.area_format = YLeaf(YType.enumeration, "area-format")

                        self.hold_time = YLeaf(YType.uint32, "hold-time")

                        self.igp_metric = YLeaf(YType.int32, "igp-metric")

                        self.is_auto_mesh_aa = YLeaf(YType.boolean, "is-auto-mesh-aa")

                        self.is_exclude_segment_routing = YLeaf(YType.boolean, "is-exclude-segment-routing")

                        self.is_sr = YLeaf(YType.boolean, "is-sr")

                        self.is_sr_strict = YLeaf(YType.boolean, "is-sr-strict")

                        self.mesh_group_idaa = YLeaf(YType.uint32, "mesh-group-idaa")

                        self.mode = YLeaf(YType.enumeration, "mode")

                        self.next_hop_address = YLeaf(YType.str, "next-hop-address")

                        self.tunnel_loadshare = YLeaf(YType.uint32, "tunnel-loadshare")

                        self.tunnel_name = YLeaf(YType.str, "tunnel-name")

                        self.tunnel_sig_name = YLeaf(YType.str, "tunnel-sig-name")

                        self.ig_ps = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("announce_type",
                                        "area_format",
                                        "hold_time",
                                        "igp_metric",
                                        "is_auto_mesh_aa",
                                        "is_exclude_segment_routing",
                                        "is_sr",
                                        "is_sr_strict",
                                        "mesh_group_idaa",
                                        "mode",
                                        "next_hop_address",
                                        "tunnel_loadshare",
                                        "tunnel_name",
                                        "tunnel_sig_name") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.AnnounceTunnelsInfo.AutorouteAnnounceTable.AnnounceDest.TotalTunnel, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.AnnounceTunnelsInfo.AutorouteAnnounceTable.AnnounceDest.TotalTunnel, self).__setattr__(name, value)


                    class IgPs(Entity):
                        """
                        List of IGPs to which it is announced
                        
                        .. attribute:: afi
                        
                        	AFI
                        	**type**\:   :py:class:`MplsTeAfi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeAfi>`
                        
                        .. attribute:: igp_area_id
                        
                        	The IGP Instance and Area ID
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.AnnounceTunnelsInfo.AutorouteAnnounceTable.AnnounceDest.TotalTunnel.IgPs, self).__init__()

                            self.yang_name = "ig-ps"
                            self.yang_parent_name = "total-tunnel"

                            self.afi = YLeaf(YType.enumeration, "afi")

                            self.igp_area_id = YLeaf(YType.str, "igp-area-id")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("afi",
                                            "igp_area_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.AnnounceTunnelsInfo.AutorouteAnnounceTable.AnnounceDest.TotalTunnel.IgPs, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.AnnounceTunnelsInfo.AutorouteAnnounceTable.AnnounceDest.TotalTunnel.IgPs, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.afi.is_set or
                                self.igp_area_id.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.afi.yfilter != YFilter.not_set or
                                self.igp_area_id.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "ig-ps" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.afi.get_name_leafdata())
                            if (self.igp_area_id.is_set or self.igp_area_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.igp_area_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "afi" or name == "igp-area-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "afi"):
                                self.afi = value
                                self.afi.value_namespace = name_space
                                self.afi.value_namespace_prefix = name_space_prefix
                            if(value_path == "igp-area-id"):
                                self.igp_area_id = value
                                self.igp_area_id.value_namespace = name_space
                                self.igp_area_id.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.ig_ps:
                            if (c.has_data()):
                                return True
                        return (
                            self.announce_type.is_set or
                            self.area_format.is_set or
                            self.hold_time.is_set or
                            self.igp_metric.is_set or
                            self.is_auto_mesh_aa.is_set or
                            self.is_exclude_segment_routing.is_set or
                            self.is_sr.is_set or
                            self.is_sr_strict.is_set or
                            self.mesh_group_idaa.is_set or
                            self.mode.is_set or
                            self.next_hop_address.is_set or
                            self.tunnel_loadshare.is_set or
                            self.tunnel_name.is_set or
                            self.tunnel_sig_name.is_set)

                    def has_operation(self):
                        for c in self.ig_ps:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.announce_type.yfilter != YFilter.not_set or
                            self.area_format.yfilter != YFilter.not_set or
                            self.hold_time.yfilter != YFilter.not_set or
                            self.igp_metric.yfilter != YFilter.not_set or
                            self.is_auto_mesh_aa.yfilter != YFilter.not_set or
                            self.is_exclude_segment_routing.yfilter != YFilter.not_set or
                            self.is_sr.yfilter != YFilter.not_set or
                            self.is_sr_strict.yfilter != YFilter.not_set or
                            self.mesh_group_idaa.yfilter != YFilter.not_set or
                            self.mode.yfilter != YFilter.not_set or
                            self.next_hop_address.yfilter != YFilter.not_set or
                            self.tunnel_loadshare.yfilter != YFilter.not_set or
                            self.tunnel_name.yfilter != YFilter.not_set or
                            self.tunnel_sig_name.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "total-tunnel" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.announce_type.is_set or self.announce_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.announce_type.get_name_leafdata())
                        if (self.area_format.is_set or self.area_format.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.area_format.get_name_leafdata())
                        if (self.hold_time.is_set or self.hold_time.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.hold_time.get_name_leafdata())
                        if (self.igp_metric.is_set or self.igp_metric.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.igp_metric.get_name_leafdata())
                        if (self.is_auto_mesh_aa.is_set or self.is_auto_mesh_aa.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_auto_mesh_aa.get_name_leafdata())
                        if (self.is_exclude_segment_routing.is_set or self.is_exclude_segment_routing.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_exclude_segment_routing.get_name_leafdata())
                        if (self.is_sr.is_set or self.is_sr.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_sr.get_name_leafdata())
                        if (self.is_sr_strict.is_set or self.is_sr_strict.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_sr_strict.get_name_leafdata())
                        if (self.mesh_group_idaa.is_set or self.mesh_group_idaa.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.mesh_group_idaa.get_name_leafdata())
                        if (self.mode.is_set or self.mode.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.mode.get_name_leafdata())
                        if (self.next_hop_address.is_set or self.next_hop_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.next_hop_address.get_name_leafdata())
                        if (self.tunnel_loadshare.is_set or self.tunnel_loadshare.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tunnel_loadshare.get_name_leafdata())
                        if (self.tunnel_name.is_set or self.tunnel_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tunnel_name.get_name_leafdata())
                        if (self.tunnel_sig_name.is_set or self.tunnel_sig_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tunnel_sig_name.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "ig-ps"):
                            for c in self.ig_ps:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.AnnounceTunnelsInfo.AutorouteAnnounceTable.AnnounceDest.TotalTunnel.IgPs()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.ig_ps.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "ig-ps" or name == "announce-type" or name == "area-format" or name == "hold-time" or name == "igp-metric" or name == "is-auto-mesh-aa" or name == "is-exclude-segment-routing" or name == "is-sr" or name == "is-sr-strict" or name == "mesh-group-idaa" or name == "mode" or name == "next-hop-address" or name == "tunnel-loadshare" or name == "tunnel-name" or name == "tunnel-sig-name"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "announce-type"):
                            self.announce_type = value
                            self.announce_type.value_namespace = name_space
                            self.announce_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "area-format"):
                            self.area_format = value
                            self.area_format.value_namespace = name_space
                            self.area_format.value_namespace_prefix = name_space_prefix
                        if(value_path == "hold-time"):
                            self.hold_time = value
                            self.hold_time.value_namespace = name_space
                            self.hold_time.value_namespace_prefix = name_space_prefix
                        if(value_path == "igp-metric"):
                            self.igp_metric = value
                            self.igp_metric.value_namespace = name_space
                            self.igp_metric.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-auto-mesh-aa"):
                            self.is_auto_mesh_aa = value
                            self.is_auto_mesh_aa.value_namespace = name_space
                            self.is_auto_mesh_aa.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-exclude-segment-routing"):
                            self.is_exclude_segment_routing = value
                            self.is_exclude_segment_routing.value_namespace = name_space
                            self.is_exclude_segment_routing.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-sr"):
                            self.is_sr = value
                            self.is_sr.value_namespace = name_space
                            self.is_sr.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-sr-strict"):
                            self.is_sr_strict = value
                            self.is_sr_strict.value_namespace = name_space
                            self.is_sr_strict.value_namespace_prefix = name_space_prefix
                        if(value_path == "mesh-group-idaa"):
                            self.mesh_group_idaa = value
                            self.mesh_group_idaa.value_namespace = name_space
                            self.mesh_group_idaa.value_namespace_prefix = name_space_prefix
                        if(value_path == "mode"):
                            self.mode = value
                            self.mode.value_namespace = name_space
                            self.mode.value_namespace_prefix = name_space_prefix
                        if(value_path == "next-hop-address"):
                            self.next_hop_address = value
                            self.next_hop_address.value_namespace = name_space
                            self.next_hop_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "tunnel-loadshare"):
                            self.tunnel_loadshare = value
                            self.tunnel_loadshare.value_namespace = name_space
                            self.tunnel_loadshare.value_namespace_prefix = name_space_prefix
                        if(value_path == "tunnel-name"):
                            self.tunnel_name = value
                            self.tunnel_name.value_namespace = name_space
                            self.tunnel_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "tunnel-sig-name"):
                            self.tunnel_sig_name = value
                            self.tunnel_sig_name.value_namespace = name_space
                            self.tunnel_sig_name.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.total_tunnel:
                        if (c.has_data()):
                            return True
                    return (
                        self.destination_address.is_set or
                        self.protocol.is_set or
                        self.area.is_set or
                        self.igp_id.is_set or
                        self.announced_tunnels_count.is_set or
                        self.area_format.is_set or
                        self.autorouted_tunnels_count.is_set or
                        self.destination.is_set or
                        self.forwarding_adjacency_tunnels_count.is_set or
                        self.igp_area.is_set or
                        self.igp_instance.is_set or
                        self.igp_type.is_set)

                def has_operation(self):
                    for c in self.total_tunnel:
                        if (c.has_operation()):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        self.destination_address.yfilter != YFilter.not_set or
                        self.protocol.yfilter != YFilter.not_set or
                        self.area.yfilter != YFilter.not_set or
                        self.igp_id.yfilter != YFilter.not_set or
                        self.announced_tunnels_count.yfilter != YFilter.not_set or
                        self.area_format.yfilter != YFilter.not_set or
                        self.autorouted_tunnels_count.yfilter != YFilter.not_set or
                        self.destination.yfilter != YFilter.not_set or
                        self.forwarding_adjacency_tunnels_count.yfilter != YFilter.not_set or
                        self.igp_area.yfilter != YFilter.not_set or
                        self.igp_instance.yfilter != YFilter.not_set or
                        self.igp_type.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "announce-dest" + "[destination-address='" + self.destination_address.get() + "']" + "[protocol='" + self.protocol.get() + "']" + "[area='" + self.area.get() + "']" + "[igp-id='" + self.igp_id.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/announce-tunnels-info/autoroute-announce-table/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.destination_address.get_name_leafdata())
                    if (self.protocol.is_set or self.protocol.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.protocol.get_name_leafdata())
                    if (self.area.is_set or self.area.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.area.get_name_leafdata())
                    if (self.igp_id.is_set or self.igp_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.igp_id.get_name_leafdata())
                    if (self.announced_tunnels_count.is_set or self.announced_tunnels_count.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.announced_tunnels_count.get_name_leafdata())
                    if (self.area_format.is_set or self.area_format.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.area_format.get_name_leafdata())
                    if (self.autorouted_tunnels_count.is_set or self.autorouted_tunnels_count.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.autorouted_tunnels_count.get_name_leafdata())
                    if (self.destination.is_set or self.destination.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.destination.get_name_leafdata())
                    if (self.forwarding_adjacency_tunnels_count.is_set or self.forwarding_adjacency_tunnels_count.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.forwarding_adjacency_tunnels_count.get_name_leafdata())
                    if (self.igp_area.is_set or self.igp_area.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.igp_area.get_name_leafdata())
                    if (self.igp_instance.is_set or self.igp_instance.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.igp_instance.get_name_leafdata())
                    if (self.igp_type.is_set or self.igp_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.igp_type.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "total-tunnel"):
                        for c in self.total_tunnel:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsTeStandby.AnnounceTunnelsInfo.AutorouteAnnounceTable.AnnounceDest.TotalTunnel()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.total_tunnel.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "total-tunnel" or name == "destination-address" or name == "protocol" or name == "area" or name == "igp-id" or name == "announced-tunnels-count" or name == "area-format" or name == "autorouted-tunnels-count" or name == "destination" or name == "forwarding-adjacency-tunnels-count" or name == "igp-area" or name == "igp-instance" or name == "igp-type"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "destination-address"):
                        self.destination_address = value
                        self.destination_address.value_namespace = name_space
                        self.destination_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "protocol"):
                        self.protocol = value
                        self.protocol.value_namespace = name_space
                        self.protocol.value_namespace_prefix = name_space_prefix
                    if(value_path == "area"):
                        self.area = value
                        self.area.value_namespace = name_space
                        self.area.value_namespace_prefix = name_space_prefix
                    if(value_path == "igp-id"):
                        self.igp_id = value
                        self.igp_id.value_namespace = name_space
                        self.igp_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "announced-tunnels-count"):
                        self.announced_tunnels_count = value
                        self.announced_tunnels_count.value_namespace = name_space
                        self.announced_tunnels_count.value_namespace_prefix = name_space_prefix
                    if(value_path == "area-format"):
                        self.area_format = value
                        self.area_format.value_namespace = name_space
                        self.area_format.value_namespace_prefix = name_space_prefix
                    if(value_path == "autorouted-tunnels-count"):
                        self.autorouted_tunnels_count = value
                        self.autorouted_tunnels_count.value_namespace = name_space
                        self.autorouted_tunnels_count.value_namespace_prefix = name_space_prefix
                    if(value_path == "destination"):
                        self.destination = value
                        self.destination.value_namespace = name_space
                        self.destination.value_namespace_prefix = name_space_prefix
                    if(value_path == "forwarding-adjacency-tunnels-count"):
                        self.forwarding_adjacency_tunnels_count = value
                        self.forwarding_adjacency_tunnels_count.value_namespace = name_space
                        self.forwarding_adjacency_tunnels_count.value_namespace_prefix = name_space_prefix
                    if(value_path == "igp-area"):
                        self.igp_area = value
                        self.igp_area.value_namespace = name_space
                        self.igp_area.value_namespace_prefix = name_space_prefix
                    if(value_path == "igp-instance"):
                        self.igp_instance = value
                        self.igp_instance.value_namespace = name_space
                        self.igp_instance.value_namespace_prefix = name_space_prefix
                    if(value_path == "igp-type"):
                        self.igp_type = value
                        self.igp_type.value_namespace = name_space
                        self.igp_type.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.announce_dest:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.announce_dest:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "autoroute-announce-table" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/announce-tunnels-info/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "announce-dest"):
                    for c in self.announce_dest:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTeStandby.AnnounceTunnelsInfo.AutorouteAnnounceTable.AnnounceDest()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.announce_dest.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "announce-dest"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass


        class AllAutorouteTable(Entity):
            """
            Autoroute announce and forwarding adjacency
            table
            
            .. attribute:: announce_dest
            
            	Autoroute tunnels per destination information
            	**type**\: list of    :py:class:`AnnounceDest <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AnnounceTunnelsInfo.AllAutorouteTable.AnnounceDest>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTeStandby.AnnounceTunnelsInfo.AllAutorouteTable, self).__init__()

                self.yang_name = "all-autoroute-table"
                self.yang_parent_name = "announce-tunnels-info"

                self.announce_dest = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTeStandby.AnnounceTunnelsInfo.AllAutorouteTable, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTeStandby.AnnounceTunnelsInfo.AllAutorouteTable, self).__setattr__(name, value)


            class AnnounceDest(Entity):
                """
                Autoroute tunnels per destination information
                
                .. attribute:: destination_address  <key>
                
                	Destination Address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: protocol  <key>
                
                	The IGP protocol used by the tunnel
                	**type**\:   :py:class:`MplsTeIgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeIgpProtocol>`
                
                .. attribute:: area  <key>
                
                	Area
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: igp_id  <key>
                
                	IGP Instance ID
                	**type**\:  str
                
                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                
                .. attribute:: announced_tunnels_count
                
                	The number of announced tunnels
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: area_format
                
                	The format for the area\: IPv4 address or a positive integer
                	**type**\:   :py:class:`IgpOspfAreaFormat <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpOspfAreaFormat>`
                
                .. attribute:: autorouted_tunnels_count
                
                	The number of tunnels that are announced as shortcuts
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: destination
                
                	Destination
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: forwarding_adjacency_tunnels_count
                
                	The number of tunnels that are announced as forwarding adjacencies
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: igp_area
                
                	IGP Area ID
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: igp_instance
                
                	IGP Instance name
                	**type**\:  str
                
                .. attribute:: igp_type
                
                	IGP type
                	**type**\:   :py:class:`IgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpProtocol>`
                
                .. attribute:: total_tunnel
                
                	Announced tunnels for this destination
                	**type**\: list of    :py:class:`TotalTunnel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AnnounceTunnelsInfo.AllAutorouteTable.AnnounceDest.TotalTunnel>`
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTeStandby.AnnounceTunnelsInfo.AllAutorouteTable.AnnounceDest, self).__init__()

                    self.yang_name = "announce-dest"
                    self.yang_parent_name = "all-autoroute-table"

                    self.destination_address = YLeaf(YType.str, "destination-address")

                    self.protocol = YLeaf(YType.enumeration, "protocol")

                    self.area = YLeaf(YType.int32, "area")

                    self.igp_id = YLeaf(YType.str, "igp-id")

                    self.announced_tunnels_count = YLeaf(YType.uint16, "announced-tunnels-count")

                    self.area_format = YLeaf(YType.enumeration, "area-format")

                    self.autorouted_tunnels_count = YLeaf(YType.uint16, "autorouted-tunnels-count")

                    self.destination = YLeaf(YType.str, "destination")

                    self.forwarding_adjacency_tunnels_count = YLeaf(YType.uint16, "forwarding-adjacency-tunnels-count")

                    self.igp_area = YLeaf(YType.uint32, "igp-area")

                    self.igp_instance = YLeaf(YType.str, "igp-instance")

                    self.igp_type = YLeaf(YType.enumeration, "igp-type")

                    self.total_tunnel = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("destination_address",
                                    "protocol",
                                    "area",
                                    "igp_id",
                                    "announced_tunnels_count",
                                    "area_format",
                                    "autorouted_tunnels_count",
                                    "destination",
                                    "forwarding_adjacency_tunnels_count",
                                    "igp_area",
                                    "igp_instance",
                                    "igp_type") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTeStandby.AnnounceTunnelsInfo.AllAutorouteTable.AnnounceDest, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTeStandby.AnnounceTunnelsInfo.AllAutorouteTable.AnnounceDest, self).__setattr__(name, value)


                class TotalTunnel(Entity):
                    """
                    Announced tunnels for this destination
                    
                    .. attribute:: announce_type
                    
                    	Announcement type
                    	**type**\:   :py:class:`MplsTeTunnelAnnounce <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelAnnounce>`
                    
                    .. attribute:: area_format
                    
                    	IGP Area Format
                    	**type**\:   :py:class:`IgpOspfAreaFormat <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpOspfAreaFormat>`
                    
                    .. attribute:: hold_time
                    
                    	Hold time in seconds
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: ig_ps
                    
                    	List of IGPs to which it is announced
                    	**type**\: list of    :py:class:`IgPs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AnnounceTunnelsInfo.AllAutorouteTable.AnnounceDest.TotalTunnel.IgPs>`
                    
                    .. attribute:: igp_metric
                    
                    	IGP metric
                    	**type**\:  int
                    
                    	**range:** \-2147483648..2147483647
                    
                    .. attribute:: is_auto_mesh_aa
                    
                    	True if this is auto\-tunnel mesh AA
                    	**type**\:  bool
                    
                    .. attribute:: is_exclude_segment_routing
                    
                    	True if autoroute\-announce has exclude segment\-routing option
                    	**type**\:  bool
                    
                    .. attribute:: is_sr
                    
                    	True if this is a segment routing tunnel
                    	**type**\:  bool
                    
                    .. attribute:: is_sr_strict
                    
                    	True if this is a strict SID SR tunnel
                    	**type**\:  bool
                    
                    .. attribute:: mesh_group_idaa
                    
                    	MeshGroup ID for AA
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: mode
                    
                    	Autoroute mode
                    	**type**\:   :py:class:`IgpteAaMetricMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpteAaMetricMode>`
                    
                    .. attribute:: next_hop_address
                    
                    	The tunnel destination
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: tunnel_loadshare
                    
                    	Tunnel loadshare
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tunnel_name
                    
                    	The tunnel name
                    	**type**\:  str
                    
                    .. attribute:: tunnel_sig_name
                    
                    	The tunnel signaled\-name
                    	**type**\:  str
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.AnnounceTunnelsInfo.AllAutorouteTable.AnnounceDest.TotalTunnel, self).__init__()

                        self.yang_name = "total-tunnel"
                        self.yang_parent_name = "announce-dest"

                        self.announce_type = YLeaf(YType.enumeration, "announce-type")

                        self.area_format = YLeaf(YType.enumeration, "area-format")

                        self.hold_time = YLeaf(YType.uint32, "hold-time")

                        self.igp_metric = YLeaf(YType.int32, "igp-metric")

                        self.is_auto_mesh_aa = YLeaf(YType.boolean, "is-auto-mesh-aa")

                        self.is_exclude_segment_routing = YLeaf(YType.boolean, "is-exclude-segment-routing")

                        self.is_sr = YLeaf(YType.boolean, "is-sr")

                        self.is_sr_strict = YLeaf(YType.boolean, "is-sr-strict")

                        self.mesh_group_idaa = YLeaf(YType.uint32, "mesh-group-idaa")

                        self.mode = YLeaf(YType.enumeration, "mode")

                        self.next_hop_address = YLeaf(YType.str, "next-hop-address")

                        self.tunnel_loadshare = YLeaf(YType.uint32, "tunnel-loadshare")

                        self.tunnel_name = YLeaf(YType.str, "tunnel-name")

                        self.tunnel_sig_name = YLeaf(YType.str, "tunnel-sig-name")

                        self.ig_ps = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("announce_type",
                                        "area_format",
                                        "hold_time",
                                        "igp_metric",
                                        "is_auto_mesh_aa",
                                        "is_exclude_segment_routing",
                                        "is_sr",
                                        "is_sr_strict",
                                        "mesh_group_idaa",
                                        "mode",
                                        "next_hop_address",
                                        "tunnel_loadshare",
                                        "tunnel_name",
                                        "tunnel_sig_name") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.AnnounceTunnelsInfo.AllAutorouteTable.AnnounceDest.TotalTunnel, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.AnnounceTunnelsInfo.AllAutorouteTable.AnnounceDest.TotalTunnel, self).__setattr__(name, value)


                    class IgPs(Entity):
                        """
                        List of IGPs to which it is announced
                        
                        .. attribute:: afi
                        
                        	AFI
                        	**type**\:   :py:class:`MplsTeAfi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeAfi>`
                        
                        .. attribute:: igp_area_id
                        
                        	The IGP Instance and Area ID
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.AnnounceTunnelsInfo.AllAutorouteTable.AnnounceDest.TotalTunnel.IgPs, self).__init__()

                            self.yang_name = "ig-ps"
                            self.yang_parent_name = "total-tunnel"

                            self.afi = YLeaf(YType.enumeration, "afi")

                            self.igp_area_id = YLeaf(YType.str, "igp-area-id")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("afi",
                                            "igp_area_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.AnnounceTunnelsInfo.AllAutorouteTable.AnnounceDest.TotalTunnel.IgPs, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.AnnounceTunnelsInfo.AllAutorouteTable.AnnounceDest.TotalTunnel.IgPs, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.afi.is_set or
                                self.igp_area_id.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.afi.yfilter != YFilter.not_set or
                                self.igp_area_id.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "ig-ps" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.afi.get_name_leafdata())
                            if (self.igp_area_id.is_set or self.igp_area_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.igp_area_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "afi" or name == "igp-area-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "afi"):
                                self.afi = value
                                self.afi.value_namespace = name_space
                                self.afi.value_namespace_prefix = name_space_prefix
                            if(value_path == "igp-area-id"):
                                self.igp_area_id = value
                                self.igp_area_id.value_namespace = name_space
                                self.igp_area_id.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.ig_ps:
                            if (c.has_data()):
                                return True
                        return (
                            self.announce_type.is_set or
                            self.area_format.is_set or
                            self.hold_time.is_set or
                            self.igp_metric.is_set or
                            self.is_auto_mesh_aa.is_set or
                            self.is_exclude_segment_routing.is_set or
                            self.is_sr.is_set or
                            self.is_sr_strict.is_set or
                            self.mesh_group_idaa.is_set or
                            self.mode.is_set or
                            self.next_hop_address.is_set or
                            self.tunnel_loadshare.is_set or
                            self.tunnel_name.is_set or
                            self.tunnel_sig_name.is_set)

                    def has_operation(self):
                        for c in self.ig_ps:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.announce_type.yfilter != YFilter.not_set or
                            self.area_format.yfilter != YFilter.not_set or
                            self.hold_time.yfilter != YFilter.not_set or
                            self.igp_metric.yfilter != YFilter.not_set or
                            self.is_auto_mesh_aa.yfilter != YFilter.not_set or
                            self.is_exclude_segment_routing.yfilter != YFilter.not_set or
                            self.is_sr.yfilter != YFilter.not_set or
                            self.is_sr_strict.yfilter != YFilter.not_set or
                            self.mesh_group_idaa.yfilter != YFilter.not_set or
                            self.mode.yfilter != YFilter.not_set or
                            self.next_hop_address.yfilter != YFilter.not_set or
                            self.tunnel_loadshare.yfilter != YFilter.not_set or
                            self.tunnel_name.yfilter != YFilter.not_set or
                            self.tunnel_sig_name.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "total-tunnel" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.announce_type.is_set or self.announce_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.announce_type.get_name_leafdata())
                        if (self.area_format.is_set or self.area_format.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.area_format.get_name_leafdata())
                        if (self.hold_time.is_set or self.hold_time.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.hold_time.get_name_leafdata())
                        if (self.igp_metric.is_set or self.igp_metric.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.igp_metric.get_name_leafdata())
                        if (self.is_auto_mesh_aa.is_set or self.is_auto_mesh_aa.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_auto_mesh_aa.get_name_leafdata())
                        if (self.is_exclude_segment_routing.is_set or self.is_exclude_segment_routing.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_exclude_segment_routing.get_name_leafdata())
                        if (self.is_sr.is_set or self.is_sr.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_sr.get_name_leafdata())
                        if (self.is_sr_strict.is_set or self.is_sr_strict.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_sr_strict.get_name_leafdata())
                        if (self.mesh_group_idaa.is_set or self.mesh_group_idaa.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.mesh_group_idaa.get_name_leafdata())
                        if (self.mode.is_set or self.mode.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.mode.get_name_leafdata())
                        if (self.next_hop_address.is_set or self.next_hop_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.next_hop_address.get_name_leafdata())
                        if (self.tunnel_loadshare.is_set or self.tunnel_loadshare.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tunnel_loadshare.get_name_leafdata())
                        if (self.tunnel_name.is_set or self.tunnel_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tunnel_name.get_name_leafdata())
                        if (self.tunnel_sig_name.is_set or self.tunnel_sig_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tunnel_sig_name.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "ig-ps"):
                            for c in self.ig_ps:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.AnnounceTunnelsInfo.AllAutorouteTable.AnnounceDest.TotalTunnel.IgPs()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.ig_ps.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "ig-ps" or name == "announce-type" or name == "area-format" or name == "hold-time" or name == "igp-metric" or name == "is-auto-mesh-aa" or name == "is-exclude-segment-routing" or name == "is-sr" or name == "is-sr-strict" or name == "mesh-group-idaa" or name == "mode" or name == "next-hop-address" or name == "tunnel-loadshare" or name == "tunnel-name" or name == "tunnel-sig-name"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "announce-type"):
                            self.announce_type = value
                            self.announce_type.value_namespace = name_space
                            self.announce_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "area-format"):
                            self.area_format = value
                            self.area_format.value_namespace = name_space
                            self.area_format.value_namespace_prefix = name_space_prefix
                        if(value_path == "hold-time"):
                            self.hold_time = value
                            self.hold_time.value_namespace = name_space
                            self.hold_time.value_namespace_prefix = name_space_prefix
                        if(value_path == "igp-metric"):
                            self.igp_metric = value
                            self.igp_metric.value_namespace = name_space
                            self.igp_metric.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-auto-mesh-aa"):
                            self.is_auto_mesh_aa = value
                            self.is_auto_mesh_aa.value_namespace = name_space
                            self.is_auto_mesh_aa.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-exclude-segment-routing"):
                            self.is_exclude_segment_routing = value
                            self.is_exclude_segment_routing.value_namespace = name_space
                            self.is_exclude_segment_routing.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-sr"):
                            self.is_sr = value
                            self.is_sr.value_namespace = name_space
                            self.is_sr.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-sr-strict"):
                            self.is_sr_strict = value
                            self.is_sr_strict.value_namespace = name_space
                            self.is_sr_strict.value_namespace_prefix = name_space_prefix
                        if(value_path == "mesh-group-idaa"):
                            self.mesh_group_idaa = value
                            self.mesh_group_idaa.value_namespace = name_space
                            self.mesh_group_idaa.value_namespace_prefix = name_space_prefix
                        if(value_path == "mode"):
                            self.mode = value
                            self.mode.value_namespace = name_space
                            self.mode.value_namespace_prefix = name_space_prefix
                        if(value_path == "next-hop-address"):
                            self.next_hop_address = value
                            self.next_hop_address.value_namespace = name_space
                            self.next_hop_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "tunnel-loadshare"):
                            self.tunnel_loadshare = value
                            self.tunnel_loadshare.value_namespace = name_space
                            self.tunnel_loadshare.value_namespace_prefix = name_space_prefix
                        if(value_path == "tunnel-name"):
                            self.tunnel_name = value
                            self.tunnel_name.value_namespace = name_space
                            self.tunnel_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "tunnel-sig-name"):
                            self.tunnel_sig_name = value
                            self.tunnel_sig_name.value_namespace = name_space
                            self.tunnel_sig_name.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.total_tunnel:
                        if (c.has_data()):
                            return True
                    return (
                        self.destination_address.is_set or
                        self.protocol.is_set or
                        self.area.is_set or
                        self.igp_id.is_set or
                        self.announced_tunnels_count.is_set or
                        self.area_format.is_set or
                        self.autorouted_tunnels_count.is_set or
                        self.destination.is_set or
                        self.forwarding_adjacency_tunnels_count.is_set or
                        self.igp_area.is_set or
                        self.igp_instance.is_set or
                        self.igp_type.is_set)

                def has_operation(self):
                    for c in self.total_tunnel:
                        if (c.has_operation()):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        self.destination_address.yfilter != YFilter.not_set or
                        self.protocol.yfilter != YFilter.not_set or
                        self.area.yfilter != YFilter.not_set or
                        self.igp_id.yfilter != YFilter.not_set or
                        self.announced_tunnels_count.yfilter != YFilter.not_set or
                        self.area_format.yfilter != YFilter.not_set or
                        self.autorouted_tunnels_count.yfilter != YFilter.not_set or
                        self.destination.yfilter != YFilter.not_set or
                        self.forwarding_adjacency_tunnels_count.yfilter != YFilter.not_set or
                        self.igp_area.yfilter != YFilter.not_set or
                        self.igp_instance.yfilter != YFilter.not_set or
                        self.igp_type.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "announce-dest" + "[destination-address='" + self.destination_address.get() + "']" + "[protocol='" + self.protocol.get() + "']" + "[area='" + self.area.get() + "']" + "[igp-id='" + self.igp_id.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/announce-tunnels-info/all-autoroute-table/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.destination_address.get_name_leafdata())
                    if (self.protocol.is_set or self.protocol.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.protocol.get_name_leafdata())
                    if (self.area.is_set or self.area.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.area.get_name_leafdata())
                    if (self.igp_id.is_set or self.igp_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.igp_id.get_name_leafdata())
                    if (self.announced_tunnels_count.is_set or self.announced_tunnels_count.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.announced_tunnels_count.get_name_leafdata())
                    if (self.area_format.is_set or self.area_format.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.area_format.get_name_leafdata())
                    if (self.autorouted_tunnels_count.is_set or self.autorouted_tunnels_count.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.autorouted_tunnels_count.get_name_leafdata())
                    if (self.destination.is_set or self.destination.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.destination.get_name_leafdata())
                    if (self.forwarding_adjacency_tunnels_count.is_set or self.forwarding_adjacency_tunnels_count.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.forwarding_adjacency_tunnels_count.get_name_leafdata())
                    if (self.igp_area.is_set or self.igp_area.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.igp_area.get_name_leafdata())
                    if (self.igp_instance.is_set or self.igp_instance.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.igp_instance.get_name_leafdata())
                    if (self.igp_type.is_set or self.igp_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.igp_type.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "total-tunnel"):
                        for c in self.total_tunnel:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsTeStandby.AnnounceTunnelsInfo.AllAutorouteTable.AnnounceDest.TotalTunnel()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.total_tunnel.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "total-tunnel" or name == "destination-address" or name == "protocol" or name == "area" or name == "igp-id" or name == "announced-tunnels-count" or name == "area-format" or name == "autorouted-tunnels-count" or name == "destination" or name == "forwarding-adjacency-tunnels-count" or name == "igp-area" or name == "igp-instance" or name == "igp-type"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "destination-address"):
                        self.destination_address = value
                        self.destination_address.value_namespace = name_space
                        self.destination_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "protocol"):
                        self.protocol = value
                        self.protocol.value_namespace = name_space
                        self.protocol.value_namespace_prefix = name_space_prefix
                    if(value_path == "area"):
                        self.area = value
                        self.area.value_namespace = name_space
                        self.area.value_namespace_prefix = name_space_prefix
                    if(value_path == "igp-id"):
                        self.igp_id = value
                        self.igp_id.value_namespace = name_space
                        self.igp_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "announced-tunnels-count"):
                        self.announced_tunnels_count = value
                        self.announced_tunnels_count.value_namespace = name_space
                        self.announced_tunnels_count.value_namespace_prefix = name_space_prefix
                    if(value_path == "area-format"):
                        self.area_format = value
                        self.area_format.value_namespace = name_space
                        self.area_format.value_namespace_prefix = name_space_prefix
                    if(value_path == "autorouted-tunnels-count"):
                        self.autorouted_tunnels_count = value
                        self.autorouted_tunnels_count.value_namespace = name_space
                        self.autorouted_tunnels_count.value_namespace_prefix = name_space_prefix
                    if(value_path == "destination"):
                        self.destination = value
                        self.destination.value_namespace = name_space
                        self.destination.value_namespace_prefix = name_space_prefix
                    if(value_path == "forwarding-adjacency-tunnels-count"):
                        self.forwarding_adjacency_tunnels_count = value
                        self.forwarding_adjacency_tunnels_count.value_namespace = name_space
                        self.forwarding_adjacency_tunnels_count.value_namespace_prefix = name_space_prefix
                    if(value_path == "igp-area"):
                        self.igp_area = value
                        self.igp_area.value_namespace = name_space
                        self.igp_area.value_namespace_prefix = name_space_prefix
                    if(value_path == "igp-instance"):
                        self.igp_instance = value
                        self.igp_instance.value_namespace = name_space
                        self.igp_instance.value_namespace_prefix = name_space_prefix
                    if(value_path == "igp-type"):
                        self.igp_type = value
                        self.igp_type.value_namespace = name_space
                        self.igp_type.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.announce_dest:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.announce_dest:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "all-autoroute-table" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/announce-tunnels-info/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "announce-dest"):
                    for c in self.announce_dest:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTeStandby.AnnounceTunnelsInfo.AllAutorouteTable.AnnounceDest()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.announce_dest.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "announce-dest"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass

        def has_data(self):
            return (
                (self.all_autoroute_table is not None and self.all_autoroute_table.has_data()) or
                (self.autoroute_announce_table is not None and self.autoroute_announce_table.has_data()))

        def has_operation(self):
            return (
                self.yfilter != YFilter.not_set or
                (self.all_autoroute_table is not None and self.all_autoroute_table.has_operation()) or
                (self.autoroute_announce_table is not None and self.autoroute_announce_table.has_operation()))

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "announce-tunnels-info" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "all-autoroute-table"):
                if (self.all_autoroute_table is None):
                    self.all_autoroute_table = MplsTeStandby.AnnounceTunnelsInfo.AllAutorouteTable()
                    self.all_autoroute_table.parent = self
                    self._children_name_map["all_autoroute_table"] = "all-autoroute-table"
                return self.all_autoroute_table

            if (child_yang_name == "autoroute-announce-table"):
                if (self.autoroute_announce_table is None):
                    self.autoroute_announce_table = MplsTeStandby.AnnounceTunnelsInfo.AutorouteAnnounceTable()
                    self.autoroute_announce_table.parent = self
                    self._children_name_map["autoroute_announce_table"] = "autoroute-announce-table"
                return self.autoroute_announce_table

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "all-autoroute-table" or name == "autoroute-announce-table"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class CollaboratorTimers(Entity):
        """
        TE Collaborator timer status
        
        .. attribute:: p2mp_timer
        
        	Description of all P2MP timers
        	**type**\: list of    :py:class:`P2MpTimer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.CollaboratorTimers.P2MpTimer>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsTeStandby.CollaboratorTimers, self).__init__()

            self.yang_name = "collaborator-timers"
            self.yang_parent_name = "mpls-te-standby"

            self.p2mp_timer = YList(self)

        def __setattr__(self, name, value):
            self._check_monkey_patching_error(name, value)
            with _handle_type_error():
                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                        "Please use list append or extend method."
                                        .format(value))
                if isinstance(value, Enum.YLeaf):
                    value = value.name
                if name in () and name in self.__dict__:
                    if isinstance(value, YLeaf):
                        self.__dict__[name].set(value.get())
                    elif isinstance(value, YLeafList):
                        super(MplsTeStandby.CollaboratorTimers, self).__setattr__(name, value)
                    else:
                        self.__dict__[name].set(value)
                else:
                    if hasattr(value, "parent") and name != "parent":
                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                            value.parent = self
                        elif value.parent is None and value.yang_name in self._children_yang_names:
                            value.parent = self
                    super(MplsTeStandby.CollaboratorTimers, self).__setattr__(name, value)


        class P2MpTimer(Entity):
            """
            Description of all P2MP timers
            
            .. attribute:: duration
            
            	The expiry delay in seconds
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            	**units**\: second
            
            .. attribute:: expiry_time
            
            	Date when the timer last expired in seconds
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            	**units**\: second
            
            .. attribute:: is_running
            
            	True if the timer is running
            	**type**\:  bool
            
            .. attribute:: start_time
            
            	Date when timer was last started in seconds
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            	**units**\: second
            
            .. attribute:: stop_time
            
            	Date when the timer was last stopped in seconds
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            	**units**\: second
            
            .. attribute:: timer_name
            
            	Timer Name
            	**type**\:  str
            
            .. attribute:: timer_type
            
            	Timer Type
            	**type**\:   :py:class:`MplsTeP2MpTimer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeP2MpTimer>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTeStandby.CollaboratorTimers.P2MpTimer, self).__init__()

                self.yang_name = "p2mp-timer"
                self.yang_parent_name = "collaborator-timers"

                self.duration = YLeaf(YType.uint32, "duration")

                self.expiry_time = YLeaf(YType.uint32, "expiry-time")

                self.is_running = YLeaf(YType.boolean, "is-running")

                self.start_time = YLeaf(YType.uint32, "start-time")

                self.stop_time = YLeaf(YType.uint32, "stop-time")

                self.timer_name = YLeaf(YType.str, "timer-name")

                self.timer_type = YLeaf(YType.enumeration, "timer-type")

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("duration",
                                "expiry_time",
                                "is_running",
                                "start_time",
                                "stop_time",
                                "timer_name",
                                "timer_type") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTeStandby.CollaboratorTimers.P2MpTimer, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTeStandby.CollaboratorTimers.P2MpTimer, self).__setattr__(name, value)

            def has_data(self):
                return (
                    self.duration.is_set or
                    self.expiry_time.is_set or
                    self.is_running.is_set or
                    self.start_time.is_set or
                    self.stop_time.is_set or
                    self.timer_name.is_set or
                    self.timer_type.is_set)

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    self.duration.yfilter != YFilter.not_set or
                    self.expiry_time.yfilter != YFilter.not_set or
                    self.is_running.yfilter != YFilter.not_set or
                    self.start_time.yfilter != YFilter.not_set or
                    self.stop_time.yfilter != YFilter.not_set or
                    self.timer_name.yfilter != YFilter.not_set or
                    self.timer_type.yfilter != YFilter.not_set)

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "p2mp-timer" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/collaborator-timers/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.duration.get_name_leafdata())
                if (self.expiry_time.is_set or self.expiry_time.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.expiry_time.get_name_leafdata())
                if (self.is_running.is_set or self.is_running.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.is_running.get_name_leafdata())
                if (self.start_time.is_set or self.start_time.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.start_time.get_name_leafdata())
                if (self.stop_time.is_set or self.stop_time.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.stop_time.get_name_leafdata())
                if (self.timer_name.is_set or self.timer_name.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.timer_name.get_name_leafdata())
                if (self.timer_type.is_set or self.timer_type.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.timer_type.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "duration" or name == "expiry-time" or name == "is-running" or name == "start-time" or name == "stop-time" or name == "timer-name" or name == "timer-type"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "duration"):
                    self.duration = value
                    self.duration.value_namespace = name_space
                    self.duration.value_namespace_prefix = name_space_prefix
                if(value_path == "expiry-time"):
                    self.expiry_time = value
                    self.expiry_time.value_namespace = name_space
                    self.expiry_time.value_namespace_prefix = name_space_prefix
                if(value_path == "is-running"):
                    self.is_running = value
                    self.is_running.value_namespace = name_space
                    self.is_running.value_namespace_prefix = name_space_prefix
                if(value_path == "start-time"):
                    self.start_time = value
                    self.start_time.value_namespace = name_space
                    self.start_time.value_namespace_prefix = name_space_prefix
                if(value_path == "stop-time"):
                    self.stop_time = value
                    self.stop_time.value_namespace = name_space
                    self.stop_time.value_namespace_prefix = name_space_prefix
                if(value_path == "timer-name"):
                    self.timer_name = value
                    self.timer_name.value_namespace = name_space
                    self.timer_name.value_namespace_prefix = name_space_prefix
                if(value_path == "timer-type"):
                    self.timer_type = value
                    self.timer_type.value_namespace = name_space
                    self.timer_type.value_namespace_prefix = name_space_prefix

        def has_data(self):
            for c in self.p2mp_timer:
                if (c.has_data()):
                    return True
            return False

        def has_operation(self):
            for c in self.p2mp_timer:
                if (c.has_operation()):
                    return True
            return self.yfilter != YFilter.not_set

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "collaborator-timers" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "p2mp-timer"):
                for c in self.p2mp_timer:
                    segment = c.get_segment_path()
                    if (segment_path == segment):
                        return c
                c = MplsTeStandby.CollaboratorTimers.P2MpTimer()
                c.parent = self
                local_reference_key = "ydk::seg::%s" % segment_path
                self._local_refs[local_reference_key] = c
                self.p2mp_timer.append(c)
                return c

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "p2mp-timer"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class AutoTunnel(Entity):
        """
        Auto tunnel information.
        
        .. attribute:: backup
        
        	Auto tunnel backup information
        	**type**\:   :py:class:`Backup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AutoTunnel.Backup>`
        
        .. attribute:: mesh
        
        	Auto tunnel mesh information
        	**type**\:   :py:class:`Mesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AutoTunnel.Mesh>`
        
        .. attribute:: pcc
        
        	Auto tunnel PCC (Path Computation Client) information
        	**type**\:   :py:class:`Pcc <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AutoTunnel.Pcc>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsTeStandby.AutoTunnel, self).__init__()

            self.yang_name = "auto-tunnel"
            self.yang_parent_name = "mpls-te-standby"

            self.backup = MplsTeStandby.AutoTunnel.Backup()
            self.backup.parent = self
            self._children_name_map["backup"] = "backup"
            self._children_yang_names.add("backup")

            self.mesh = MplsTeStandby.AutoTunnel.Mesh()
            self.mesh.parent = self
            self._children_name_map["mesh"] = "mesh"
            self._children_yang_names.add("mesh")

            self.pcc = MplsTeStandby.AutoTunnel.Pcc()
            self.pcc.parent = self
            self._children_name_map["pcc"] = "pcc"
            self._children_yang_names.add("pcc")


        class Pcc(Entity):
            """
            Auto tunnel PCC (Path Computation Client)
            information.
            
            .. attribute:: summary
            
            	MPLS TE auto\-tunnel pcc summary information
            	**type**\:   :py:class:`Summary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AutoTunnel.Pcc.Summary>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTeStandby.AutoTunnel.Pcc, self).__init__()

                self.yang_name = "pcc"
                self.yang_parent_name = "auto-tunnel"

                self.summary = MplsTeStandby.AutoTunnel.Pcc.Summary()
                self.summary.parent = self
                self._children_name_map["summary"] = "summary"
                self._children_yang_names.add("summary")


            class Summary(Entity):
                """
                MPLS TE auto\-tunnel pcc summary information
                
                .. attribute:: down_pcc_auto_tunnels
                
                	Total number of stateful PCE client auto\-tunnels that are down
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: pcc_auto_tunnel
                
                	Total number of stateful PCE client auto\-tunnels
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: up_pcc_auto_tunnels
                
                	Total number of stateful PCE client auto\-tunnels that are up
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTeStandby.AutoTunnel.Pcc.Summary, self).__init__()

                    self.yang_name = "summary"
                    self.yang_parent_name = "pcc"

                    self.down_pcc_auto_tunnels = YLeaf(YType.uint32, "down-pcc-auto-tunnels")

                    self.pcc_auto_tunnel = YLeaf(YType.uint32, "pcc-auto-tunnel")

                    self.up_pcc_auto_tunnels = YLeaf(YType.uint32, "up-pcc-auto-tunnels")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("down_pcc_auto_tunnels",
                                    "pcc_auto_tunnel",
                                    "up_pcc_auto_tunnels") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTeStandby.AutoTunnel.Pcc.Summary, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTeStandby.AutoTunnel.Pcc.Summary, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.down_pcc_auto_tunnels.is_set or
                        self.pcc_auto_tunnel.is_set or
                        self.up_pcc_auto_tunnels.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.down_pcc_auto_tunnels.yfilter != YFilter.not_set or
                        self.pcc_auto_tunnel.yfilter != YFilter.not_set or
                        self.up_pcc_auto_tunnels.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "summary" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/auto-tunnel/pcc/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.down_pcc_auto_tunnels.is_set or self.down_pcc_auto_tunnels.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.down_pcc_auto_tunnels.get_name_leafdata())
                    if (self.pcc_auto_tunnel.is_set or self.pcc_auto_tunnel.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.pcc_auto_tunnel.get_name_leafdata())
                    if (self.up_pcc_auto_tunnels.is_set or self.up_pcc_auto_tunnels.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.up_pcc_auto_tunnels.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "down-pcc-auto-tunnels" or name == "pcc-auto-tunnel" or name == "up-pcc-auto-tunnels"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "down-pcc-auto-tunnels"):
                        self.down_pcc_auto_tunnels = value
                        self.down_pcc_auto_tunnels.value_namespace = name_space
                        self.down_pcc_auto_tunnels.value_namespace_prefix = name_space_prefix
                    if(value_path == "pcc-auto-tunnel"):
                        self.pcc_auto_tunnel = value
                        self.pcc_auto_tunnel.value_namespace = name_space
                        self.pcc_auto_tunnel.value_namespace_prefix = name_space_prefix
                    if(value_path == "up-pcc-auto-tunnels"):
                        self.up_pcc_auto_tunnels = value
                        self.up_pcc_auto_tunnels.value_namespace = name_space
                        self.up_pcc_auto_tunnels.value_namespace_prefix = name_space_prefix

            def has_data(self):
                return (self.summary is not None and self.summary.has_data())

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    (self.summary is not None and self.summary.has_operation()))

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "pcc" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/auto-tunnel/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "summary"):
                    if (self.summary is None):
                        self.summary = MplsTeStandby.AutoTunnel.Pcc.Summary()
                        self.summary.parent = self
                        self._children_name_map["summary"] = "summary"
                    return self.summary

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "summary"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass


        class Mesh(Entity):
            """
            Auto tunnel mesh information.
            
            .. attribute:: config
            
            	MPLS TE auto\-tunnel mesh configuration information
            	**type**\:   :py:class:`Config <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AutoTunnel.Mesh.Config>`
            
            .. attribute:: mesh_groups
            
            	Display auto\-tunnel mesh group
            	**type**\:   :py:class:`MeshGroups <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AutoTunnel.Mesh.MeshGroups>`
            
            .. attribute:: one_hop
            
            	MPLS TE auto\-tunnel mesh onehop information
            	**type**\:   :py:class:`OneHop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AutoTunnel.Mesh.OneHop>`
            
            .. attribute:: statistics
            
            	MPLS TE auto\-tunnel mesh counters (stats) information
            	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AutoTunnel.Mesh.Statistics>`
            
            .. attribute:: summary
            
            	MPLS TE auto\-tunnel mesh summary information
            	**type**\:   :py:class:`Summary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AutoTunnel.Mesh.Summary>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTeStandby.AutoTunnel.Mesh, self).__init__()

                self.yang_name = "mesh"
                self.yang_parent_name = "auto-tunnel"

                self.config = MplsTeStandby.AutoTunnel.Mesh.Config()
                self.config.parent = self
                self._children_name_map["config"] = "config"
                self._children_yang_names.add("config")

                self.mesh_groups = MplsTeStandby.AutoTunnel.Mesh.MeshGroups()
                self.mesh_groups.parent = self
                self._children_name_map["mesh_groups"] = "mesh-groups"
                self._children_yang_names.add("mesh-groups")

                self.one_hop = MplsTeStandby.AutoTunnel.Mesh.OneHop()
                self.one_hop.parent = self
                self._children_name_map["one_hop"] = "one-hop"
                self._children_yang_names.add("one-hop")

                self.statistics = MplsTeStandby.AutoTunnel.Mesh.Statistics()
                self.statistics.parent = self
                self._children_name_map["statistics"] = "statistics"
                self._children_yang_names.add("statistics")

                self.summary = MplsTeStandby.AutoTunnel.Mesh.Summary()
                self.summary.parent = self
                self._children_name_map["summary"] = "summary"
                self._children_yang_names.add("summary")


            class MeshGroups(Entity):
                """
                Display auto\-tunnel mesh group
                
                .. attribute:: mesh_group
                
                	Display auto\-tunnel mesh group information
                	**type**\: list of    :py:class:`MeshGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AutoTunnel.Mesh.MeshGroups.MeshGroup>`
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTeStandby.AutoTunnel.Mesh.MeshGroups, self).__init__()

                    self.yang_name = "mesh-groups"
                    self.yang_parent_name = "mesh"

                    self.mesh_group = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in () and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTeStandby.AutoTunnel.Mesh.MeshGroups, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTeStandby.AutoTunnel.Mesh.MeshGroups, self).__setattr__(name, value)


                class MeshGroup(Entity):
                    """
                    Display auto\-tunnel mesh group information
                    
                    .. attribute:: mesh_group_id  <key>
                    
                    	Mesh group ID
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: attribute_set_name
                    
                    	Attribute set name
                    	**type**\:  str
                    
                    .. attribute:: auto_mesh_group_type
                    
                    	Meshgroup Type
                    	**type**\:   :py:class:`TeMeshgroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeMeshgroup>`
                    
                    .. attribute:: auto_mesh_total_destinations
                    
                    	Total number of destinations
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: auto_mesh_tunnels
                    
                    	Total number of automesh tunnels
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: destination
                    
                    	List of destinations for this meshgroup
                    	**type**\: list of    :py:class:`Destination <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AutoTunnel.Mesh.MeshGroups.MeshGroup.Destination>`
                    
                    .. attribute:: destination_list_name
                    
                    	Destination List name
                    	**type**\:  str
                    
                    .. attribute:: destination_list_type
                    
                    	Type of the  destlist
                    	**type**\:   :py:class:`TeAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAcl>`
                    
                    .. attribute:: down_auto_mesh_tunnels
                    
                    	Total number of automesh tunnels that are down
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: frr_auto_mesh_tunnels
                    
                    	Total number of automesh tunnels that are FRR enabled
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: is_attribute_set_configured
                    
                    	Is any attribute\-set associated to this meshgroup
                    	**type**\:  bool
                    
                    .. attribute:: is_attribute_set_in_db
                    
                    	Flag to indicate the existence of attribute set found in database
                    	**type**\:  bool
                    
                    .. attribute:: is_destination_list_configured
                    
                    	Is any destiantion\-list associated to this meshgroup
                    	**type**\:  bool
                    
                    .. attribute:: is_meshgroup_disabled
                    
                    	Is the meshgroup disabled
                    	**type**\:  bool
                    
                    .. attribute:: mesh_group_id_xr
                    
                    	Meshgroup ID
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: remaining_time
                    
                    	Remaining time for recreate timer in seconds
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: up_auto_mesh_tunnels
                    
                    	Total number of automesh tunnels that are up
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.AutoTunnel.Mesh.MeshGroups.MeshGroup, self).__init__()

                        self.yang_name = "mesh-group"
                        self.yang_parent_name = "mesh-groups"

                        self.mesh_group_id = YLeaf(YType.uint32, "mesh-group-id")

                        self.attribute_set_name = YLeaf(YType.str, "attribute-set-name")

                        self.auto_mesh_group_type = YLeaf(YType.enumeration, "auto-mesh-group-type")

                        self.auto_mesh_total_destinations = YLeaf(YType.uint32, "auto-mesh-total-destinations")

                        self.auto_mesh_tunnels = YLeaf(YType.uint32, "auto-mesh-tunnels")

                        self.destination_list_name = YLeaf(YType.str, "destination-list-name")

                        self.destination_list_type = YLeaf(YType.enumeration, "destination-list-type")

                        self.down_auto_mesh_tunnels = YLeaf(YType.uint32, "down-auto-mesh-tunnels")

                        self.frr_auto_mesh_tunnels = YLeaf(YType.uint32, "frr-auto-mesh-tunnels")

                        self.is_attribute_set_configured = YLeaf(YType.boolean, "is-attribute-set-configured")

                        self.is_attribute_set_in_db = YLeaf(YType.boolean, "is-attribute-set-in-db")

                        self.is_destination_list_configured = YLeaf(YType.boolean, "is-destination-list-configured")

                        self.is_meshgroup_disabled = YLeaf(YType.boolean, "is-meshgroup-disabled")

                        self.mesh_group_id_xr = YLeaf(YType.uint32, "mesh-group-id-xr")

                        self.remaining_time = YLeaf(YType.uint32, "remaining-time")

                        self.up_auto_mesh_tunnels = YLeaf(YType.uint32, "up-auto-mesh-tunnels")

                        self.destination = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("mesh_group_id",
                                        "attribute_set_name",
                                        "auto_mesh_group_type",
                                        "auto_mesh_total_destinations",
                                        "auto_mesh_tunnels",
                                        "destination_list_name",
                                        "destination_list_type",
                                        "down_auto_mesh_tunnels",
                                        "frr_auto_mesh_tunnels",
                                        "is_attribute_set_configured",
                                        "is_attribute_set_in_db",
                                        "is_destination_list_configured",
                                        "is_meshgroup_disabled",
                                        "mesh_group_id_xr",
                                        "remaining_time",
                                        "up_auto_mesh_tunnels") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.AutoTunnel.Mesh.MeshGroups.MeshGroup, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.AutoTunnel.Mesh.MeshGroups.MeshGroup, self).__setattr__(name, value)


                    class Destination(Entity):
                        """
                        List of destinations for this meshgroup
                        
                        .. attribute:: destination_address
                        
                        	Destination address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: operational_status
                        
                        	Tunnel operational status
                        	**type**\:   :py:class:`MplsTeTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelState>`
                        
                        .. attribute:: remaining_time
                        
                        	Remaining time for unused timer in seconds
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: tunnel_id
                        
                        	Tunnel ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.AutoTunnel.Mesh.MeshGroups.MeshGroup.Destination, self).__init__()

                            self.yang_name = "destination"
                            self.yang_parent_name = "mesh-group"

                            self.destination_address = YLeaf(YType.str, "destination-address")

                            self.operational_status = YLeaf(YType.enumeration, "operational-status")

                            self.remaining_time = YLeaf(YType.uint32, "remaining-time")

                            self.tunnel_id = YLeaf(YType.uint16, "tunnel-id")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("destination_address",
                                            "operational_status",
                                            "remaining_time",
                                            "tunnel_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.AutoTunnel.Mesh.MeshGroups.MeshGroup.Destination, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.AutoTunnel.Mesh.MeshGroups.MeshGroup.Destination, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.destination_address.is_set or
                                self.operational_status.is_set or
                                self.remaining_time.is_set or
                                self.tunnel_id.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.destination_address.yfilter != YFilter.not_set or
                                self.operational_status.yfilter != YFilter.not_set or
                                self.remaining_time.yfilter != YFilter.not_set or
                                self.tunnel_id.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "destination" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.destination_address.get_name_leafdata())
                            if (self.operational_status.is_set or self.operational_status.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.operational_status.get_name_leafdata())
                            if (self.remaining_time.is_set or self.remaining_time.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.remaining_time.get_name_leafdata())
                            if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tunnel_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "destination-address" or name == "operational-status" or name == "remaining-time" or name == "tunnel-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "destination-address"):
                                self.destination_address = value
                                self.destination_address.value_namespace = name_space
                                self.destination_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "operational-status"):
                                self.operational_status = value
                                self.operational_status.value_namespace = name_space
                                self.operational_status.value_namespace_prefix = name_space_prefix
                            if(value_path == "remaining-time"):
                                self.remaining_time = value
                                self.remaining_time.value_namespace = name_space
                                self.remaining_time.value_namespace_prefix = name_space_prefix
                            if(value_path == "tunnel-id"):
                                self.tunnel_id = value
                                self.tunnel_id.value_namespace = name_space
                                self.tunnel_id.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.destination:
                            if (c.has_data()):
                                return True
                        return (
                            self.mesh_group_id.is_set or
                            self.attribute_set_name.is_set or
                            self.auto_mesh_group_type.is_set or
                            self.auto_mesh_total_destinations.is_set or
                            self.auto_mesh_tunnels.is_set or
                            self.destination_list_name.is_set or
                            self.destination_list_type.is_set or
                            self.down_auto_mesh_tunnels.is_set or
                            self.frr_auto_mesh_tunnels.is_set or
                            self.is_attribute_set_configured.is_set or
                            self.is_attribute_set_in_db.is_set or
                            self.is_destination_list_configured.is_set or
                            self.is_meshgroup_disabled.is_set or
                            self.mesh_group_id_xr.is_set or
                            self.remaining_time.is_set or
                            self.up_auto_mesh_tunnels.is_set)

                    def has_operation(self):
                        for c in self.destination:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.mesh_group_id.yfilter != YFilter.not_set or
                            self.attribute_set_name.yfilter != YFilter.not_set or
                            self.auto_mesh_group_type.yfilter != YFilter.not_set or
                            self.auto_mesh_total_destinations.yfilter != YFilter.not_set or
                            self.auto_mesh_tunnels.yfilter != YFilter.not_set or
                            self.destination_list_name.yfilter != YFilter.not_set or
                            self.destination_list_type.yfilter != YFilter.not_set or
                            self.down_auto_mesh_tunnels.yfilter != YFilter.not_set or
                            self.frr_auto_mesh_tunnels.yfilter != YFilter.not_set or
                            self.is_attribute_set_configured.yfilter != YFilter.not_set or
                            self.is_attribute_set_in_db.yfilter != YFilter.not_set or
                            self.is_destination_list_configured.yfilter != YFilter.not_set or
                            self.is_meshgroup_disabled.yfilter != YFilter.not_set or
                            self.mesh_group_id_xr.yfilter != YFilter.not_set or
                            self.remaining_time.yfilter != YFilter.not_set or
                            self.up_auto_mesh_tunnels.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "mesh-group" + "[mesh-group-id='" + self.mesh_group_id.get() + "']" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/auto-tunnel/mesh/mesh-groups/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.mesh_group_id.is_set or self.mesh_group_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.mesh_group_id.get_name_leafdata())
                        if (self.attribute_set_name.is_set or self.attribute_set_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.attribute_set_name.get_name_leafdata())
                        if (self.auto_mesh_group_type.is_set or self.auto_mesh_group_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.auto_mesh_group_type.get_name_leafdata())
                        if (self.auto_mesh_total_destinations.is_set or self.auto_mesh_total_destinations.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.auto_mesh_total_destinations.get_name_leafdata())
                        if (self.auto_mesh_tunnels.is_set or self.auto_mesh_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.auto_mesh_tunnels.get_name_leafdata())
                        if (self.destination_list_name.is_set or self.destination_list_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.destination_list_name.get_name_leafdata())
                        if (self.destination_list_type.is_set or self.destination_list_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.destination_list_type.get_name_leafdata())
                        if (self.down_auto_mesh_tunnels.is_set or self.down_auto_mesh_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.down_auto_mesh_tunnels.get_name_leafdata())
                        if (self.frr_auto_mesh_tunnels.is_set or self.frr_auto_mesh_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.frr_auto_mesh_tunnels.get_name_leafdata())
                        if (self.is_attribute_set_configured.is_set or self.is_attribute_set_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_attribute_set_configured.get_name_leafdata())
                        if (self.is_attribute_set_in_db.is_set or self.is_attribute_set_in_db.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_attribute_set_in_db.get_name_leafdata())
                        if (self.is_destination_list_configured.is_set or self.is_destination_list_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_destination_list_configured.get_name_leafdata())
                        if (self.is_meshgroup_disabled.is_set or self.is_meshgroup_disabled.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_meshgroup_disabled.get_name_leafdata())
                        if (self.mesh_group_id_xr.is_set or self.mesh_group_id_xr.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.mesh_group_id_xr.get_name_leafdata())
                        if (self.remaining_time.is_set or self.remaining_time.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.remaining_time.get_name_leafdata())
                        if (self.up_auto_mesh_tunnels.is_set or self.up_auto_mesh_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.up_auto_mesh_tunnels.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "destination"):
                            for c in self.destination:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.AutoTunnel.Mesh.MeshGroups.MeshGroup.Destination()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.destination.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "destination" or name == "mesh-group-id" or name == "attribute-set-name" or name == "auto-mesh-group-type" or name == "auto-mesh-total-destinations" or name == "auto-mesh-tunnels" or name == "destination-list-name" or name == "destination-list-type" or name == "down-auto-mesh-tunnels" or name == "frr-auto-mesh-tunnels" or name == "is-attribute-set-configured" or name == "is-attribute-set-in-db" or name == "is-destination-list-configured" or name == "is-meshgroup-disabled" or name == "mesh-group-id-xr" or name == "remaining-time" or name == "up-auto-mesh-tunnels"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "mesh-group-id"):
                            self.mesh_group_id = value
                            self.mesh_group_id.value_namespace = name_space
                            self.mesh_group_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "attribute-set-name"):
                            self.attribute_set_name = value
                            self.attribute_set_name.value_namespace = name_space
                            self.attribute_set_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "auto-mesh-group-type"):
                            self.auto_mesh_group_type = value
                            self.auto_mesh_group_type.value_namespace = name_space
                            self.auto_mesh_group_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "auto-mesh-total-destinations"):
                            self.auto_mesh_total_destinations = value
                            self.auto_mesh_total_destinations.value_namespace = name_space
                            self.auto_mesh_total_destinations.value_namespace_prefix = name_space_prefix
                        if(value_path == "auto-mesh-tunnels"):
                            self.auto_mesh_tunnels = value
                            self.auto_mesh_tunnels.value_namespace = name_space
                            self.auto_mesh_tunnels.value_namespace_prefix = name_space_prefix
                        if(value_path == "destination-list-name"):
                            self.destination_list_name = value
                            self.destination_list_name.value_namespace = name_space
                            self.destination_list_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "destination-list-type"):
                            self.destination_list_type = value
                            self.destination_list_type.value_namespace = name_space
                            self.destination_list_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "down-auto-mesh-tunnels"):
                            self.down_auto_mesh_tunnels = value
                            self.down_auto_mesh_tunnels.value_namespace = name_space
                            self.down_auto_mesh_tunnels.value_namespace_prefix = name_space_prefix
                        if(value_path == "frr-auto-mesh-tunnels"):
                            self.frr_auto_mesh_tunnels = value
                            self.frr_auto_mesh_tunnels.value_namespace = name_space
                            self.frr_auto_mesh_tunnels.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-attribute-set-configured"):
                            self.is_attribute_set_configured = value
                            self.is_attribute_set_configured.value_namespace = name_space
                            self.is_attribute_set_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-attribute-set-in-db"):
                            self.is_attribute_set_in_db = value
                            self.is_attribute_set_in_db.value_namespace = name_space
                            self.is_attribute_set_in_db.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-destination-list-configured"):
                            self.is_destination_list_configured = value
                            self.is_destination_list_configured.value_namespace = name_space
                            self.is_destination_list_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-meshgroup-disabled"):
                            self.is_meshgroup_disabled = value
                            self.is_meshgroup_disabled.value_namespace = name_space
                            self.is_meshgroup_disabled.value_namespace_prefix = name_space_prefix
                        if(value_path == "mesh-group-id-xr"):
                            self.mesh_group_id_xr = value
                            self.mesh_group_id_xr.value_namespace = name_space
                            self.mesh_group_id_xr.value_namespace_prefix = name_space_prefix
                        if(value_path == "remaining-time"):
                            self.remaining_time = value
                            self.remaining_time.value_namespace = name_space
                            self.remaining_time.value_namespace_prefix = name_space_prefix
                        if(value_path == "up-auto-mesh-tunnels"):
                            self.up_auto_mesh_tunnels = value
                            self.up_auto_mesh_tunnels.value_namespace = name_space
                            self.up_auto_mesh_tunnels.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.mesh_group:
                        if (c.has_data()):
                            return True
                    return False

                def has_operation(self):
                    for c in self.mesh_group:
                        if (c.has_operation()):
                            return True
                    return self.yfilter != YFilter.not_set

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "mesh-groups" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/auto-tunnel/mesh/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "mesh-group"):
                        for c in self.mesh_group:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsTeStandby.AutoTunnel.Mesh.MeshGroups.MeshGroup()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.mesh_group.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "mesh-group"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    pass


            class Statistics(Entity):
                """
                MPLS TE auto\-tunnel mesh counters (stats)
                information
                
                .. attribute:: connected
                
                	Number of connected automesh tunnels
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: created
                
                	Number of connected automesh tunnels
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: last_cleared_time
                
                	Time at which these were last cleared in seconds since (in seconds since 1st Jan 1970 00\:00\:00)'
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: second
                
                .. attribute:: removed_in_use
                
                	Number of automesh tunnels removed while up and in use
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: removed_range_exceeded
                
                	Number of automesh tunnel attempts rejected because the total number exceeds the range
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: removed_unused
                
                	Number of automesh tunnels removed while unused
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTeStandby.AutoTunnel.Mesh.Statistics, self).__init__()

                    self.yang_name = "statistics"
                    self.yang_parent_name = "mesh"

                    self.connected = YLeaf(YType.uint32, "connected")

                    self.created = YLeaf(YType.uint32, "created")

                    self.last_cleared_time = YLeaf(YType.uint32, "last-cleared-time")

                    self.removed_in_use = YLeaf(YType.uint32, "removed-in-use")

                    self.removed_range_exceeded = YLeaf(YType.uint32, "removed-range-exceeded")

                    self.removed_unused = YLeaf(YType.uint32, "removed-unused")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("connected",
                                    "created",
                                    "last_cleared_time",
                                    "removed_in_use",
                                    "removed_range_exceeded",
                                    "removed_unused") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTeStandby.AutoTunnel.Mesh.Statistics, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTeStandby.AutoTunnel.Mesh.Statistics, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.connected.is_set or
                        self.created.is_set or
                        self.last_cleared_time.is_set or
                        self.removed_in_use.is_set or
                        self.removed_range_exceeded.is_set or
                        self.removed_unused.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.connected.yfilter != YFilter.not_set or
                        self.created.yfilter != YFilter.not_set or
                        self.last_cleared_time.yfilter != YFilter.not_set or
                        self.removed_in_use.yfilter != YFilter.not_set or
                        self.removed_range_exceeded.yfilter != YFilter.not_set or
                        self.removed_unused.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "statistics" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/auto-tunnel/mesh/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.connected.is_set or self.connected.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.connected.get_name_leafdata())
                    if (self.created.is_set or self.created.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.created.get_name_leafdata())
                    if (self.last_cleared_time.is_set or self.last_cleared_time.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.last_cleared_time.get_name_leafdata())
                    if (self.removed_in_use.is_set or self.removed_in_use.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.removed_in_use.get_name_leafdata())
                    if (self.removed_range_exceeded.is_set or self.removed_range_exceeded.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.removed_range_exceeded.get_name_leafdata())
                    if (self.removed_unused.is_set or self.removed_unused.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.removed_unused.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "connected" or name == "created" or name == "last-cleared-time" or name == "removed-in-use" or name == "removed-range-exceeded" or name == "removed-unused"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "connected"):
                        self.connected = value
                        self.connected.value_namespace = name_space
                        self.connected.value_namespace_prefix = name_space_prefix
                    if(value_path == "created"):
                        self.created = value
                        self.created.value_namespace = name_space
                        self.created.value_namespace_prefix = name_space_prefix
                    if(value_path == "last-cleared-time"):
                        self.last_cleared_time = value
                        self.last_cleared_time.value_namespace = name_space
                        self.last_cleared_time.value_namespace_prefix = name_space_prefix
                    if(value_path == "removed-in-use"):
                        self.removed_in_use = value
                        self.removed_in_use.value_namespace = name_space
                        self.removed_in_use.value_namespace_prefix = name_space_prefix
                    if(value_path == "removed-range-exceeded"):
                        self.removed_range_exceeded = value
                        self.removed_range_exceeded.value_namespace = name_space
                        self.removed_range_exceeded.value_namespace_prefix = name_space_prefix
                    if(value_path == "removed-unused"):
                        self.removed_unused = value
                        self.removed_unused.value_namespace = name_space
                        self.removed_unused.value_namespace_prefix = name_space_prefix


            class Summary(Entity):
                """
                MPLS TE auto\-tunnel mesh summary information
                
                .. attribute:: auto_mesh_destinations
                
                	Total number of automesh destinations
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: auto_mesh_groups
                
                	Total number of automesh mesh\-groups
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: auto_mesh_tunnels
                
                	Total number of automesh tunnels
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: down_auto_mesh_tunnels
                
                	Total number of automesh tunnels that are down
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: frr_auto_mesh_tunnels
                
                	Total number of automesh tunnels that are FRR enabled
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: up_auto_mesh_tunnels
                
                	Total number of automesh tunnels that are up
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTeStandby.AutoTunnel.Mesh.Summary, self).__init__()

                    self.yang_name = "summary"
                    self.yang_parent_name = "mesh"

                    self.auto_mesh_destinations = YLeaf(YType.uint32, "auto-mesh-destinations")

                    self.auto_mesh_groups = YLeaf(YType.uint32, "auto-mesh-groups")

                    self.auto_mesh_tunnels = YLeaf(YType.uint32, "auto-mesh-tunnels")

                    self.down_auto_mesh_tunnels = YLeaf(YType.uint32, "down-auto-mesh-tunnels")

                    self.frr_auto_mesh_tunnels = YLeaf(YType.uint32, "frr-auto-mesh-tunnels")

                    self.up_auto_mesh_tunnels = YLeaf(YType.uint32, "up-auto-mesh-tunnels")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("auto_mesh_destinations",
                                    "auto_mesh_groups",
                                    "auto_mesh_tunnels",
                                    "down_auto_mesh_tunnels",
                                    "frr_auto_mesh_tunnels",
                                    "up_auto_mesh_tunnels") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTeStandby.AutoTunnel.Mesh.Summary, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTeStandby.AutoTunnel.Mesh.Summary, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.auto_mesh_destinations.is_set or
                        self.auto_mesh_groups.is_set or
                        self.auto_mesh_tunnels.is_set or
                        self.down_auto_mesh_tunnels.is_set or
                        self.frr_auto_mesh_tunnels.is_set or
                        self.up_auto_mesh_tunnels.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.auto_mesh_destinations.yfilter != YFilter.not_set or
                        self.auto_mesh_groups.yfilter != YFilter.not_set or
                        self.auto_mesh_tunnels.yfilter != YFilter.not_set or
                        self.down_auto_mesh_tunnels.yfilter != YFilter.not_set or
                        self.frr_auto_mesh_tunnels.yfilter != YFilter.not_set or
                        self.up_auto_mesh_tunnels.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "summary" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/auto-tunnel/mesh/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.auto_mesh_destinations.is_set or self.auto_mesh_destinations.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.auto_mesh_destinations.get_name_leafdata())
                    if (self.auto_mesh_groups.is_set or self.auto_mesh_groups.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.auto_mesh_groups.get_name_leafdata())
                    if (self.auto_mesh_tunnels.is_set or self.auto_mesh_tunnels.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.auto_mesh_tunnels.get_name_leafdata())
                    if (self.down_auto_mesh_tunnels.is_set or self.down_auto_mesh_tunnels.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.down_auto_mesh_tunnels.get_name_leafdata())
                    if (self.frr_auto_mesh_tunnels.is_set or self.frr_auto_mesh_tunnels.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.frr_auto_mesh_tunnels.get_name_leafdata())
                    if (self.up_auto_mesh_tunnels.is_set or self.up_auto_mesh_tunnels.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.up_auto_mesh_tunnels.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "auto-mesh-destinations" or name == "auto-mesh-groups" or name == "auto-mesh-tunnels" or name == "down-auto-mesh-tunnels" or name == "frr-auto-mesh-tunnels" or name == "up-auto-mesh-tunnels"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "auto-mesh-destinations"):
                        self.auto_mesh_destinations = value
                        self.auto_mesh_destinations.value_namespace = name_space
                        self.auto_mesh_destinations.value_namespace_prefix = name_space_prefix
                    if(value_path == "auto-mesh-groups"):
                        self.auto_mesh_groups = value
                        self.auto_mesh_groups.value_namespace = name_space
                        self.auto_mesh_groups.value_namespace_prefix = name_space_prefix
                    if(value_path == "auto-mesh-tunnels"):
                        self.auto_mesh_tunnels = value
                        self.auto_mesh_tunnels.value_namespace = name_space
                        self.auto_mesh_tunnels.value_namespace_prefix = name_space_prefix
                    if(value_path == "down-auto-mesh-tunnels"):
                        self.down_auto_mesh_tunnels = value
                        self.down_auto_mesh_tunnels.value_namespace = name_space
                        self.down_auto_mesh_tunnels.value_namespace_prefix = name_space_prefix
                    if(value_path == "frr-auto-mesh-tunnels"):
                        self.frr_auto_mesh_tunnels = value
                        self.frr_auto_mesh_tunnels.value_namespace = name_space
                        self.frr_auto_mesh_tunnels.value_namespace_prefix = name_space_prefix
                    if(value_path == "up-auto-mesh-tunnels"):
                        self.up_auto_mesh_tunnels = value
                        self.up_auto_mesh_tunnels.value_namespace = name_space
                        self.up_auto_mesh_tunnels.value_namespace_prefix = name_space_prefix


            class Config(Entity):
                """
                MPLS TE auto\-tunnel mesh configuration
                information
                
                .. attribute:: is_configured
                
                	Indicate if auto\-tunnel mesh feature is configured 
                	**type**\:  bool
                
                .. attribute:: max_tunnel_id
                
                	Upper bound of configured tunnel ID range
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: min_tunnel_id
                
                	Lower bound of configured tunnel ID range
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: unused_removal_timeout_configured
                
                	Configured value of unused removal timer in seconds
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: second
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTeStandby.AutoTunnel.Mesh.Config, self).__init__()

                    self.yang_name = "config"
                    self.yang_parent_name = "mesh"

                    self.is_configured = YLeaf(YType.boolean, "is-configured")

                    self.max_tunnel_id = YLeaf(YType.uint16, "max-tunnel-id")

                    self.min_tunnel_id = YLeaf(YType.uint16, "min-tunnel-id")

                    self.unused_removal_timeout_configured = YLeaf(YType.uint32, "unused-removal-timeout-configured")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("is_configured",
                                    "max_tunnel_id",
                                    "min_tunnel_id",
                                    "unused_removal_timeout_configured") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTeStandby.AutoTunnel.Mesh.Config, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTeStandby.AutoTunnel.Mesh.Config, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.is_configured.is_set or
                        self.max_tunnel_id.is_set or
                        self.min_tunnel_id.is_set or
                        self.unused_removal_timeout_configured.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.is_configured.yfilter != YFilter.not_set or
                        self.max_tunnel_id.yfilter != YFilter.not_set or
                        self.min_tunnel_id.yfilter != YFilter.not_set or
                        self.unused_removal_timeout_configured.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "config" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/auto-tunnel/mesh/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.is_configured.is_set or self.is_configured.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_configured.get_name_leafdata())
                    if (self.max_tunnel_id.is_set or self.max_tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.max_tunnel_id.get_name_leafdata())
                    if (self.min_tunnel_id.is_set or self.min_tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.min_tunnel_id.get_name_leafdata())
                    if (self.unused_removal_timeout_configured.is_set or self.unused_removal_timeout_configured.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.unused_removal_timeout_configured.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "is-configured" or name == "max-tunnel-id" or name == "min-tunnel-id" or name == "unused-removal-timeout-configured"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "is-configured"):
                        self.is_configured = value
                        self.is_configured.value_namespace = name_space
                        self.is_configured.value_namespace_prefix = name_space_prefix
                    if(value_path == "max-tunnel-id"):
                        self.max_tunnel_id = value
                        self.max_tunnel_id.value_namespace = name_space
                        self.max_tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "min-tunnel-id"):
                        self.min_tunnel_id = value
                        self.min_tunnel_id.value_namespace = name_space
                        self.min_tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "unused-removal-timeout-configured"):
                        self.unused_removal_timeout_configured = value
                        self.unused_removal_timeout_configured.value_namespace = name_space
                        self.unused_removal_timeout_configured.value_namespace_prefix = name_space_prefix


            class OneHop(Entity):
                """
                MPLS TE auto\-tunnel mesh onehop information
                
                .. attribute:: interfaces
                
                	Display auto\-tunnel onehop interfaces
                	**type**\:   :py:class:`Interfaces <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AutoTunnel.Mesh.OneHop.Interfaces>`
                
                .. attribute:: statistics
                
                	MPLS TE auto\-tunnel mesh onehop counters (stats) information
                	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AutoTunnel.Mesh.OneHop.Statistics>`
                
                .. attribute:: summary
                
                	MPLS TE auto\-tunnel mesh onehop summary information
                	**type**\:   :py:class:`Summary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AutoTunnel.Mesh.OneHop.Summary>`
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTeStandby.AutoTunnel.Mesh.OneHop, self).__init__()

                    self.yang_name = "one-hop"
                    self.yang_parent_name = "mesh"

                    self.interfaces = MplsTeStandby.AutoTunnel.Mesh.OneHop.Interfaces()
                    self.interfaces.parent = self
                    self._children_name_map["interfaces"] = "interfaces"
                    self._children_yang_names.add("interfaces")

                    self.statistics = MplsTeStandby.AutoTunnel.Mesh.OneHop.Statistics()
                    self.statistics.parent = self
                    self._children_name_map["statistics"] = "statistics"
                    self._children_yang_names.add("statistics")

                    self.summary = MplsTeStandby.AutoTunnel.Mesh.OneHop.Summary()
                    self.summary.parent = self
                    self._children_name_map["summary"] = "summary"
                    self._children_yang_names.add("summary")


                class Interfaces(Entity):
                    """
                    Display auto\-tunnel onehop interfaces
                    
                    .. attribute:: interface
                    
                    	Display auto\-tunnel mesh onehop interface information
                    	**type**\: list of    :py:class:`Interface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AutoTunnel.Mesh.OneHop.Interfaces.Interface>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.AutoTunnel.Mesh.OneHop.Interfaces, self).__init__()

                        self.yang_name = "interfaces"
                        self.yang_parent_name = "one-hop"

                        self.interface = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in () and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.AutoTunnel.Mesh.OneHop.Interfaces, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.AutoTunnel.Mesh.OneHop.Interfaces, self).__setattr__(name, value)


                    class Interface(Entity):
                        """
                        Display auto\-tunnel mesh onehop interface
                        information
                        
                        .. attribute:: interface_name  <key>
                        
                        	Interface Name
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        .. attribute:: interface_name_xr
                        
                        	Interface name
                        	**type**\:  str
                        
                        .. attribute:: tunnel
                        
                        	Onehop tunnels created for this interface
                        	**type**\: list of    :py:class:`Tunnel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AutoTunnel.Mesh.OneHop.Interfaces.Interface.Tunnel>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.AutoTunnel.Mesh.OneHop.Interfaces.Interface, self).__init__()

                            self.yang_name = "interface"
                            self.yang_parent_name = "interfaces"

                            self.interface_name = YLeaf(YType.str, "interface-name")

                            self.interface_name_xr = YLeaf(YType.str, "interface-name-xr")

                            self.tunnel = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("interface_name",
                                            "interface_name_xr") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.AutoTunnel.Mesh.OneHop.Interfaces.Interface, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.AutoTunnel.Mesh.OneHop.Interfaces.Interface, self).__setattr__(name, value)


                        class Tunnel(Entity):
                            """
                            Onehop tunnels created for this interface
                            
                            .. attribute:: destination_address
                            
                            	Destination Address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: mesh_group_id
                            
                            	Meshgroup ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tunnel_id
                            
                            	Tunnel ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: tunnel_lspid
                            
                            	LSP ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: tunnel_state
                            
                            	Tunnel state
                            	**type**\:   :py:class:`MplsTeTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelState>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.AutoTunnel.Mesh.OneHop.Interfaces.Interface.Tunnel, self).__init__()

                                self.yang_name = "tunnel"
                                self.yang_parent_name = "interface"

                                self.destination_address = YLeaf(YType.str, "destination-address")

                                self.mesh_group_id = YLeaf(YType.uint32, "mesh-group-id")

                                self.tunnel_id = YLeaf(YType.uint16, "tunnel-id")

                                self.tunnel_lspid = YLeaf(YType.uint16, "tunnel-lspid")

                                self.tunnel_state = YLeaf(YType.enumeration, "tunnel-state")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("destination_address",
                                                "mesh_group_id",
                                                "tunnel_id",
                                                "tunnel_lspid",
                                                "tunnel_state") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.AutoTunnel.Mesh.OneHop.Interfaces.Interface.Tunnel, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.AutoTunnel.Mesh.OneHop.Interfaces.Interface.Tunnel, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.destination_address.is_set or
                                    self.mesh_group_id.is_set or
                                    self.tunnel_id.is_set or
                                    self.tunnel_lspid.is_set or
                                    self.tunnel_state.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.destination_address.yfilter != YFilter.not_set or
                                    self.mesh_group_id.yfilter != YFilter.not_set or
                                    self.tunnel_id.yfilter != YFilter.not_set or
                                    self.tunnel_lspid.yfilter != YFilter.not_set or
                                    self.tunnel_state.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "tunnel" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.destination_address.get_name_leafdata())
                                if (self.mesh_group_id.is_set or self.mesh_group_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.mesh_group_id.get_name_leafdata())
                                if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_id.get_name_leafdata())
                                if (self.tunnel_lspid.is_set or self.tunnel_lspid.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_lspid.get_name_leafdata())
                                if (self.tunnel_state.is_set or self.tunnel_state.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_state.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "destination-address" or name == "mesh-group-id" or name == "tunnel-id" or name == "tunnel-lspid" or name == "tunnel-state"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "destination-address"):
                                    self.destination_address = value
                                    self.destination_address.value_namespace = name_space
                                    self.destination_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "mesh-group-id"):
                                    self.mesh_group_id = value
                                    self.mesh_group_id.value_namespace = name_space
                                    self.mesh_group_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-id"):
                                    self.tunnel_id = value
                                    self.tunnel_id.value_namespace = name_space
                                    self.tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-lspid"):
                                    self.tunnel_lspid = value
                                    self.tunnel_lspid.value_namespace = name_space
                                    self.tunnel_lspid.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-state"):
                                    self.tunnel_state = value
                                    self.tunnel_state.value_namespace = name_space
                                    self.tunnel_state.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.tunnel:
                                if (c.has_data()):
                                    return True
                            return (
                                self.interface_name.is_set or
                                self.interface_name_xr.is_set)

                        def has_operation(self):
                            for c in self.tunnel:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.interface_name.yfilter != YFilter.not_set or
                                self.interface_name_xr.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "interface" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/auto-tunnel/mesh/one-hop/interfaces/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.interface_name.get_name_leafdata())
                            if (self.interface_name_xr.is_set or self.interface_name_xr.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.interface_name_xr.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "tunnel"):
                                for c in self.tunnel:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.AutoTunnel.Mesh.OneHop.Interfaces.Interface.Tunnel()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.tunnel.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "tunnel" or name == "interface-name" or name == "interface-name-xr"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "interface-name"):
                                self.interface_name = value
                                self.interface_name.value_namespace = name_space
                                self.interface_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "interface-name-xr"):
                                self.interface_name_xr = value
                                self.interface_name_xr.value_namespace = name_space
                                self.interface_name_xr.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.interface:
                            if (c.has_data()):
                                return True
                        return False

                    def has_operation(self):
                        for c in self.interface:
                            if (c.has_operation()):
                                return True
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "interfaces" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/auto-tunnel/mesh/one-hop/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "interface"):
                            for c in self.interface:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.AutoTunnel.Mesh.OneHop.Interfaces.Interface()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.interface.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "interface"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class Statistics(Entity):
                    """
                    MPLS TE auto\-tunnel mesh onehop counters
                    (stats) information
                    
                    .. attribute:: connected
                    
                    	Number of connected automesh tunnels
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: created
                    
                    	Number of connected automesh tunnels
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: last_cleared_time
                    
                    	Time at which these were last cleared in seconds since (in seconds since 1st Jan 1970 00\:00\:00)'
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: removed_in_use
                    
                    	Number of automesh tunnels removed while up and in use
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: removed_range_exceeded
                    
                    	Number of automesh tunnel attempts rejected because the total number exceeds the range
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: removed_unused
                    
                    	Number of automesh tunnels removed while unused
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.AutoTunnel.Mesh.OneHop.Statistics, self).__init__()

                        self.yang_name = "statistics"
                        self.yang_parent_name = "one-hop"

                        self.connected = YLeaf(YType.uint32, "connected")

                        self.created = YLeaf(YType.uint32, "created")

                        self.last_cleared_time = YLeaf(YType.uint32, "last-cleared-time")

                        self.removed_in_use = YLeaf(YType.uint32, "removed-in-use")

                        self.removed_range_exceeded = YLeaf(YType.uint32, "removed-range-exceeded")

                        self.removed_unused = YLeaf(YType.uint32, "removed-unused")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("connected",
                                        "created",
                                        "last_cleared_time",
                                        "removed_in_use",
                                        "removed_range_exceeded",
                                        "removed_unused") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.AutoTunnel.Mesh.OneHop.Statistics, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.AutoTunnel.Mesh.OneHop.Statistics, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.connected.is_set or
                            self.created.is_set or
                            self.last_cleared_time.is_set or
                            self.removed_in_use.is_set or
                            self.removed_range_exceeded.is_set or
                            self.removed_unused.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.connected.yfilter != YFilter.not_set or
                            self.created.yfilter != YFilter.not_set or
                            self.last_cleared_time.yfilter != YFilter.not_set or
                            self.removed_in_use.yfilter != YFilter.not_set or
                            self.removed_range_exceeded.yfilter != YFilter.not_set or
                            self.removed_unused.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "statistics" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/auto-tunnel/mesh/one-hop/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.connected.is_set or self.connected.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.connected.get_name_leafdata())
                        if (self.created.is_set or self.created.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.created.get_name_leafdata())
                        if (self.last_cleared_time.is_set or self.last_cleared_time.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.last_cleared_time.get_name_leafdata())
                        if (self.removed_in_use.is_set or self.removed_in_use.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.removed_in_use.get_name_leafdata())
                        if (self.removed_range_exceeded.is_set or self.removed_range_exceeded.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.removed_range_exceeded.get_name_leafdata())
                        if (self.removed_unused.is_set or self.removed_unused.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.removed_unused.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "connected" or name == "created" or name == "last-cleared-time" or name == "removed-in-use" or name == "removed-range-exceeded" or name == "removed-unused"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "connected"):
                            self.connected = value
                            self.connected.value_namespace = name_space
                            self.connected.value_namespace_prefix = name_space_prefix
                        if(value_path == "created"):
                            self.created = value
                            self.created.value_namespace = name_space
                            self.created.value_namespace_prefix = name_space_prefix
                        if(value_path == "last-cleared-time"):
                            self.last_cleared_time = value
                            self.last_cleared_time.value_namespace = name_space
                            self.last_cleared_time.value_namespace_prefix = name_space_prefix
                        if(value_path == "removed-in-use"):
                            self.removed_in_use = value
                            self.removed_in_use.value_namespace = name_space
                            self.removed_in_use.value_namespace_prefix = name_space_prefix
                        if(value_path == "removed-range-exceeded"):
                            self.removed_range_exceeded = value
                            self.removed_range_exceeded.value_namespace = name_space
                            self.removed_range_exceeded.value_namespace_prefix = name_space_prefix
                        if(value_path == "removed-unused"):
                            self.removed_unused = value
                            self.removed_unused.value_namespace = name_space
                            self.removed_unused.value_namespace_prefix = name_space_prefix


                class Summary(Entity):
                    """
                    MPLS TE auto\-tunnel mesh onehop summary
                    information
                    
                    .. attribute:: auto_mesh_one_hop_destinations
                    
                    	Total number of automesh onehop destinations
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: auto_mesh_one_hop_groups
                    
                    	Total number of automesh onehop mesh\-groups
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: auto_mesh_one_hop_tunnels
                    
                    	Total number of automesh onehop tunnels
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: down_auto_mesh_one_hop_tunnels
                    
                    	Total number of automesh onehop tunnels that are down
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: frr_auto_mesh_tunnels
                    
                    	Total number of automesh onehop tunnels that are FRR enabled
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: up_auto_mesh_one_hop_tunnels
                    
                    	Total number of automesh onehop tunnels that are up
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.AutoTunnel.Mesh.OneHop.Summary, self).__init__()

                        self.yang_name = "summary"
                        self.yang_parent_name = "one-hop"

                        self.auto_mesh_one_hop_destinations = YLeaf(YType.uint32, "auto-mesh-one-hop-destinations")

                        self.auto_mesh_one_hop_groups = YLeaf(YType.uint32, "auto-mesh-one-hop-groups")

                        self.auto_mesh_one_hop_tunnels = YLeaf(YType.uint32, "auto-mesh-one-hop-tunnels")

                        self.down_auto_mesh_one_hop_tunnels = YLeaf(YType.uint32, "down-auto-mesh-one-hop-tunnels")

                        self.frr_auto_mesh_tunnels = YLeaf(YType.uint32, "frr-auto-mesh-tunnels")

                        self.up_auto_mesh_one_hop_tunnels = YLeaf(YType.uint32, "up-auto-mesh-one-hop-tunnels")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("auto_mesh_one_hop_destinations",
                                        "auto_mesh_one_hop_groups",
                                        "auto_mesh_one_hop_tunnels",
                                        "down_auto_mesh_one_hop_tunnels",
                                        "frr_auto_mesh_tunnels",
                                        "up_auto_mesh_one_hop_tunnels") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.AutoTunnel.Mesh.OneHop.Summary, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.AutoTunnel.Mesh.OneHop.Summary, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.auto_mesh_one_hop_destinations.is_set or
                            self.auto_mesh_one_hop_groups.is_set or
                            self.auto_mesh_one_hop_tunnels.is_set or
                            self.down_auto_mesh_one_hop_tunnels.is_set or
                            self.frr_auto_mesh_tunnels.is_set or
                            self.up_auto_mesh_one_hop_tunnels.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.auto_mesh_one_hop_destinations.yfilter != YFilter.not_set or
                            self.auto_mesh_one_hop_groups.yfilter != YFilter.not_set or
                            self.auto_mesh_one_hop_tunnels.yfilter != YFilter.not_set or
                            self.down_auto_mesh_one_hop_tunnels.yfilter != YFilter.not_set or
                            self.frr_auto_mesh_tunnels.yfilter != YFilter.not_set or
                            self.up_auto_mesh_one_hop_tunnels.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "summary" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/auto-tunnel/mesh/one-hop/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.auto_mesh_one_hop_destinations.is_set or self.auto_mesh_one_hop_destinations.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.auto_mesh_one_hop_destinations.get_name_leafdata())
                        if (self.auto_mesh_one_hop_groups.is_set or self.auto_mesh_one_hop_groups.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.auto_mesh_one_hop_groups.get_name_leafdata())
                        if (self.auto_mesh_one_hop_tunnels.is_set or self.auto_mesh_one_hop_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.auto_mesh_one_hop_tunnels.get_name_leafdata())
                        if (self.down_auto_mesh_one_hop_tunnels.is_set or self.down_auto_mesh_one_hop_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.down_auto_mesh_one_hop_tunnels.get_name_leafdata())
                        if (self.frr_auto_mesh_tunnels.is_set or self.frr_auto_mesh_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.frr_auto_mesh_tunnels.get_name_leafdata())
                        if (self.up_auto_mesh_one_hop_tunnels.is_set or self.up_auto_mesh_one_hop_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.up_auto_mesh_one_hop_tunnels.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "auto-mesh-one-hop-destinations" or name == "auto-mesh-one-hop-groups" or name == "auto-mesh-one-hop-tunnels" or name == "down-auto-mesh-one-hop-tunnels" or name == "frr-auto-mesh-tunnels" or name == "up-auto-mesh-one-hop-tunnels"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "auto-mesh-one-hop-destinations"):
                            self.auto_mesh_one_hop_destinations = value
                            self.auto_mesh_one_hop_destinations.value_namespace = name_space
                            self.auto_mesh_one_hop_destinations.value_namespace_prefix = name_space_prefix
                        if(value_path == "auto-mesh-one-hop-groups"):
                            self.auto_mesh_one_hop_groups = value
                            self.auto_mesh_one_hop_groups.value_namespace = name_space
                            self.auto_mesh_one_hop_groups.value_namespace_prefix = name_space_prefix
                        if(value_path == "auto-mesh-one-hop-tunnels"):
                            self.auto_mesh_one_hop_tunnels = value
                            self.auto_mesh_one_hop_tunnels.value_namespace = name_space
                            self.auto_mesh_one_hop_tunnels.value_namespace_prefix = name_space_prefix
                        if(value_path == "down-auto-mesh-one-hop-tunnels"):
                            self.down_auto_mesh_one_hop_tunnels = value
                            self.down_auto_mesh_one_hop_tunnels.value_namespace = name_space
                            self.down_auto_mesh_one_hop_tunnels.value_namespace_prefix = name_space_prefix
                        if(value_path == "frr-auto-mesh-tunnels"):
                            self.frr_auto_mesh_tunnels = value
                            self.frr_auto_mesh_tunnels.value_namespace = name_space
                            self.frr_auto_mesh_tunnels.value_namespace_prefix = name_space_prefix
                        if(value_path == "up-auto-mesh-one-hop-tunnels"):
                            self.up_auto_mesh_one_hop_tunnels = value
                            self.up_auto_mesh_one_hop_tunnels.value_namespace = name_space
                            self.up_auto_mesh_one_hop_tunnels.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    return (
                        (self.interfaces is not None and self.interfaces.has_data()) or
                        (self.statistics is not None and self.statistics.has_data()) or
                        (self.summary is not None and self.summary.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        (self.interfaces is not None and self.interfaces.has_operation()) or
                        (self.statistics is not None and self.statistics.has_operation()) or
                        (self.summary is not None and self.summary.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "one-hop" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/auto-tunnel/mesh/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "interfaces"):
                        if (self.interfaces is None):
                            self.interfaces = MplsTeStandby.AutoTunnel.Mesh.OneHop.Interfaces()
                            self.interfaces.parent = self
                            self._children_name_map["interfaces"] = "interfaces"
                        return self.interfaces

                    if (child_yang_name == "statistics"):
                        if (self.statistics is None):
                            self.statistics = MplsTeStandby.AutoTunnel.Mesh.OneHop.Statistics()
                            self.statistics.parent = self
                            self._children_name_map["statistics"] = "statistics"
                        return self.statistics

                    if (child_yang_name == "summary"):
                        if (self.summary is None):
                            self.summary = MplsTeStandby.AutoTunnel.Mesh.OneHop.Summary()
                            self.summary.parent = self
                            self._children_name_map["summary"] = "summary"
                        return self.summary

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "interfaces" or name == "statistics" or name == "summary"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    pass

            def has_data(self):
                return (
                    (self.config is not None and self.config.has_data()) or
                    (self.mesh_groups is not None and self.mesh_groups.has_data()) or
                    (self.one_hop is not None and self.one_hop.has_data()) or
                    (self.statistics is not None and self.statistics.has_data()) or
                    (self.summary is not None and self.summary.has_data()))

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    (self.config is not None and self.config.has_operation()) or
                    (self.mesh_groups is not None and self.mesh_groups.has_operation()) or
                    (self.one_hop is not None and self.one_hop.has_operation()) or
                    (self.statistics is not None and self.statistics.has_operation()) or
                    (self.summary is not None and self.summary.has_operation()))

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "mesh" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/auto-tunnel/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "config"):
                    if (self.config is None):
                        self.config = MplsTeStandby.AutoTunnel.Mesh.Config()
                        self.config.parent = self
                        self._children_name_map["config"] = "config"
                    return self.config

                if (child_yang_name == "mesh-groups"):
                    if (self.mesh_groups is None):
                        self.mesh_groups = MplsTeStandby.AutoTunnel.Mesh.MeshGroups()
                        self.mesh_groups.parent = self
                        self._children_name_map["mesh_groups"] = "mesh-groups"
                    return self.mesh_groups

                if (child_yang_name == "one-hop"):
                    if (self.one_hop is None):
                        self.one_hop = MplsTeStandby.AutoTunnel.Mesh.OneHop()
                        self.one_hop.parent = self
                        self._children_name_map["one_hop"] = "one-hop"
                    return self.one_hop

                if (child_yang_name == "statistics"):
                    if (self.statistics is None):
                        self.statistics = MplsTeStandby.AutoTunnel.Mesh.Statistics()
                        self.statistics.parent = self
                        self._children_name_map["statistics"] = "statistics"
                    return self.statistics

                if (child_yang_name == "summary"):
                    if (self.summary is None):
                        self.summary = MplsTeStandby.AutoTunnel.Mesh.Summary()
                        self.summary.parent = self
                        self._children_name_map["summary"] = "summary"
                    return self.summary

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "config" or name == "mesh-groups" or name == "one-hop" or name == "statistics" or name == "summary"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass


        class Backup(Entity):
            """
            Auto tunnel backup information.
            
            .. attribute:: config
            
            	MPLS TE auto\-tunnel backup configuration information
            	**type**\:   :py:class:`Config <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AutoTunnel.Backup.Config>`
            
            .. attribute:: statistics
            
            	MPLS TE auto\-tunnel backup counters (stats) information
            	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AutoTunnel.Backup.Statistics>`
            
            .. attribute:: summary
            
            	MPLS TE auto\-tunnel backup summary information
            	**type**\:   :py:class:`Summary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AutoTunnel.Backup.Summary>`
            
            .. attribute:: tunnels
            
            	auto\-tunnel backup information
            	**type**\:   :py:class:`Tunnels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AutoTunnel.Backup.Tunnels>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTeStandby.AutoTunnel.Backup, self).__init__()

                self.yang_name = "backup"
                self.yang_parent_name = "auto-tunnel"

                self.config = MplsTeStandby.AutoTunnel.Backup.Config()
                self.config.parent = self
                self._children_name_map["config"] = "config"
                self._children_yang_names.add("config")

                self.statistics = MplsTeStandby.AutoTunnel.Backup.Statistics()
                self.statistics.parent = self
                self._children_name_map["statistics"] = "statistics"
                self._children_yang_names.add("statistics")

                self.summary = MplsTeStandby.AutoTunnel.Backup.Summary()
                self.summary.parent = self
                self._children_name_map["summary"] = "summary"
                self._children_yang_names.add("summary")

                self.tunnels = MplsTeStandby.AutoTunnel.Backup.Tunnels()
                self.tunnels.parent = self
                self._children_name_map["tunnels"] = "tunnels"
                self._children_yang_names.add("tunnels")


            class Tunnels(Entity):
                """
                auto\-tunnel backup information
                
                .. attribute:: tunnel
                
                	Display auto tunnel backup tunnel information
                	**type**\: list of    :py:class:`Tunnel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AutoTunnel.Backup.Tunnels.Tunnel>`
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTeStandby.AutoTunnel.Backup.Tunnels, self).__init__()

                    self.yang_name = "tunnels"
                    self.yang_parent_name = "backup"

                    self.tunnel = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in () and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTeStandby.AutoTunnel.Backup.Tunnels, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTeStandby.AutoTunnel.Backup.Tunnels, self).__setattr__(name, value)


                class Tunnel(Entity):
                    """
                    Display auto tunnel backup tunnel information
                    
                    .. attribute:: backup_tunnel_name  <key>
                    
                    	Backup tunnel name
                    	**type**\:  str
                    
                    	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                    
                    .. attribute:: atb_protection_type
                    
                    	Type of protection offered by this auto\-tunnel backup
                    	**type**\:   :py:class:`AutoBackupProtection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.AutoBackupProtection>`
                    
                    .. attribute:: operational_status
                    
                    	Tunnel operational status
                    	**type**\:   :py:class:`MplsTeTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelState>`
                    
                    .. attribute:: protected_flows
                    
                    	Number of protected flows
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: protected_interface_name
                    
                    	Interface protected by this auto\-tunnel backup
                    	**type**\:  str
                    
                    .. attribute:: protected_router_id
                    
                    	Router ID of node protected by this auto\-tunnel backup
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: srlg_mode
                    
                    	SRLG exclude mode for this auto\-tunnel backup
                    	**type**\:   :py:class:`AutoBackupSrlgMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.AutoBackupSrlgMode>`
                    
                    .. attribute:: tunnel_name
                    
                    	Tunnel Name
                    	**type**\:  str
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.AutoTunnel.Backup.Tunnels.Tunnel, self).__init__()

                        self.yang_name = "tunnel"
                        self.yang_parent_name = "tunnels"

                        self.backup_tunnel_name = YLeaf(YType.str, "backup-tunnel-name")

                        self.atb_protection_type = YLeaf(YType.enumeration, "atb-protection-type")

                        self.operational_status = YLeaf(YType.enumeration, "operational-status")

                        self.protected_flows = YLeaf(YType.uint32, "protected-flows")

                        self.protected_interface_name = YLeaf(YType.str, "protected-interface-name")

                        self.protected_router_id = YLeaf(YType.str, "protected-router-id")

                        self.srlg_mode = YLeaf(YType.enumeration, "srlg-mode")

                        self.tunnel_name = YLeaf(YType.str, "tunnel-name")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("backup_tunnel_name",
                                        "atb_protection_type",
                                        "operational_status",
                                        "protected_flows",
                                        "protected_interface_name",
                                        "protected_router_id",
                                        "srlg_mode",
                                        "tunnel_name") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.AutoTunnel.Backup.Tunnels.Tunnel, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.AutoTunnel.Backup.Tunnels.Tunnel, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.backup_tunnel_name.is_set or
                            self.atb_protection_type.is_set or
                            self.operational_status.is_set or
                            self.protected_flows.is_set or
                            self.protected_interface_name.is_set or
                            self.protected_router_id.is_set or
                            self.srlg_mode.is_set or
                            self.tunnel_name.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.backup_tunnel_name.yfilter != YFilter.not_set or
                            self.atb_protection_type.yfilter != YFilter.not_set or
                            self.operational_status.yfilter != YFilter.not_set or
                            self.protected_flows.yfilter != YFilter.not_set or
                            self.protected_interface_name.yfilter != YFilter.not_set or
                            self.protected_router_id.yfilter != YFilter.not_set or
                            self.srlg_mode.yfilter != YFilter.not_set or
                            self.tunnel_name.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "tunnel" + "[backup-tunnel-name='" + self.backup_tunnel_name.get() + "']" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/auto-tunnel/backup/tunnels/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.backup_tunnel_name.is_set or self.backup_tunnel_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.backup_tunnel_name.get_name_leafdata())
                        if (self.atb_protection_type.is_set or self.atb_protection_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.atb_protection_type.get_name_leafdata())
                        if (self.operational_status.is_set or self.operational_status.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.operational_status.get_name_leafdata())
                        if (self.protected_flows.is_set or self.protected_flows.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.protected_flows.get_name_leafdata())
                        if (self.protected_interface_name.is_set or self.protected_interface_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.protected_interface_name.get_name_leafdata())
                        if (self.protected_router_id.is_set or self.protected_router_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.protected_router_id.get_name_leafdata())
                        if (self.srlg_mode.is_set or self.srlg_mode.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.srlg_mode.get_name_leafdata())
                        if (self.tunnel_name.is_set or self.tunnel_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tunnel_name.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "backup-tunnel-name" or name == "atb-protection-type" or name == "operational-status" or name == "protected-flows" or name == "protected-interface-name" or name == "protected-router-id" or name == "srlg-mode" or name == "tunnel-name"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "backup-tunnel-name"):
                            self.backup_tunnel_name = value
                            self.backup_tunnel_name.value_namespace = name_space
                            self.backup_tunnel_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "atb-protection-type"):
                            self.atb_protection_type = value
                            self.atb_protection_type.value_namespace = name_space
                            self.atb_protection_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "operational-status"):
                            self.operational_status = value
                            self.operational_status.value_namespace = name_space
                            self.operational_status.value_namespace_prefix = name_space_prefix
                        if(value_path == "protected-flows"):
                            self.protected_flows = value
                            self.protected_flows.value_namespace = name_space
                            self.protected_flows.value_namespace_prefix = name_space_prefix
                        if(value_path == "protected-interface-name"):
                            self.protected_interface_name = value
                            self.protected_interface_name.value_namespace = name_space
                            self.protected_interface_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "protected-router-id"):
                            self.protected_router_id = value
                            self.protected_router_id.value_namespace = name_space
                            self.protected_router_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "srlg-mode"):
                            self.srlg_mode = value
                            self.srlg_mode.value_namespace = name_space
                            self.srlg_mode.value_namespace_prefix = name_space_prefix
                        if(value_path == "tunnel-name"):
                            self.tunnel_name = value
                            self.tunnel_name.value_namespace = name_space
                            self.tunnel_name.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.tunnel:
                        if (c.has_data()):
                            return True
                    return False

                def has_operation(self):
                    for c in self.tunnel:
                        if (c.has_operation()):
                            return True
                    return self.yfilter != YFilter.not_set

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "tunnels" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/auto-tunnel/backup/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "tunnel"):
                        for c in self.tunnel:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsTeStandby.AutoTunnel.Backup.Tunnels.Tunnel()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.tunnel.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "tunnel"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    pass


            class Statistics(Entity):
                """
                MPLS TE auto\-tunnel backup counters (stats)
                information
                
                .. attribute:: connected
                
                	Number of connected auto backup tunnels
                	**type**\:   :py:class:`Connected <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AutoTunnel.Backup.Statistics.Connected>`
                
                .. attribute:: created
                
                	Number of connected auto backup tunnels
                	**type**\:   :py:class:`Created <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AutoTunnel.Backup.Statistics.Created>`
                
                .. attribute:: last_cleared_time
                
                	Timestamp when the stat has been cleared
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: removed_down
                
                	Number of NNHOP auto backup tunnels removed while down
                	**type**\:   :py:class:`RemovedDown <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AutoTunnel.Backup.Statistics.RemovedDown>`
                
                .. attribute:: removed_in_use
                
                	Number of auto backup tunnels removed while up and in use
                	**type**\:   :py:class:`RemovedInUse <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AutoTunnel.Backup.Statistics.RemovedInUse>`
                
                .. attribute:: removed_range_exceeded
                
                	Number of auto backup tunnel attempts rejected because the total number exceeds the range
                	**type**\:   :py:class:`RemovedRangeExceeded <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AutoTunnel.Backup.Statistics.RemovedRangeExceeded>`
                
                .. attribute:: removed_unused
                
                	Number of auto backup tunnels removed while unused
                	**type**\:   :py:class:`RemovedUnused <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AutoTunnel.Backup.Statistics.RemovedUnused>`
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTeStandby.AutoTunnel.Backup.Statistics, self).__init__()

                    self.yang_name = "statistics"
                    self.yang_parent_name = "backup"

                    self.last_cleared_time = YLeaf(YType.uint32, "last-cleared-time")

                    self.connected = MplsTeStandby.AutoTunnel.Backup.Statistics.Connected()
                    self.connected.parent = self
                    self._children_name_map["connected"] = "connected"
                    self._children_yang_names.add("connected")

                    self.created = MplsTeStandby.AutoTunnel.Backup.Statistics.Created()
                    self.created.parent = self
                    self._children_name_map["created"] = "created"
                    self._children_yang_names.add("created")

                    self.removed_down = MplsTeStandby.AutoTunnel.Backup.Statistics.RemovedDown()
                    self.removed_down.parent = self
                    self._children_name_map["removed_down"] = "removed-down"
                    self._children_yang_names.add("removed-down")

                    self.removed_in_use = MplsTeStandby.AutoTunnel.Backup.Statistics.RemovedInUse()
                    self.removed_in_use.parent = self
                    self._children_name_map["removed_in_use"] = "removed-in-use"
                    self._children_yang_names.add("removed-in-use")

                    self.removed_range_exceeded = MplsTeStandby.AutoTunnel.Backup.Statistics.RemovedRangeExceeded()
                    self.removed_range_exceeded.parent = self
                    self._children_name_map["removed_range_exceeded"] = "removed-range-exceeded"
                    self._children_yang_names.add("removed-range-exceeded")

                    self.removed_unused = MplsTeStandby.AutoTunnel.Backup.Statistics.RemovedUnused()
                    self.removed_unused.parent = self
                    self._children_name_map["removed_unused"] = "removed-unused"
                    self._children_yang_names.add("removed-unused")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("last_cleared_time") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTeStandby.AutoTunnel.Backup.Statistics, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTeStandby.AutoTunnel.Backup.Statistics, self).__setattr__(name, value)


                class Created(Entity):
                    """
                    Number of connected auto backup tunnels
                    
                    .. attribute:: next_hop_tunnels
                    
                    	Next hop auto backup tunnels only
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: next_next_hop_tunnels
                    
                    	Next next hop auto backup tunnels only
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: total_tunnels
                    
                    	Total auto backup tunnels
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.AutoTunnel.Backup.Statistics.Created, self).__init__()

                        self.yang_name = "created"
                        self.yang_parent_name = "statistics"

                        self.next_hop_tunnels = YLeaf(YType.uint32, "next-hop-tunnels")

                        self.next_next_hop_tunnels = YLeaf(YType.uint32, "next-next-hop-tunnels")

                        self.total_tunnels = YLeaf(YType.uint32, "total-tunnels")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("next_hop_tunnels",
                                        "next_next_hop_tunnels",
                                        "total_tunnels") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.AutoTunnel.Backup.Statistics.Created, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.AutoTunnel.Backup.Statistics.Created, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.next_hop_tunnels.is_set or
                            self.next_next_hop_tunnels.is_set or
                            self.total_tunnels.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.next_hop_tunnels.yfilter != YFilter.not_set or
                            self.next_next_hop_tunnels.yfilter != YFilter.not_set or
                            self.total_tunnels.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "created" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/auto-tunnel/backup/statistics/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.next_hop_tunnels.is_set or self.next_hop_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.next_hop_tunnels.get_name_leafdata())
                        if (self.next_next_hop_tunnels.is_set or self.next_next_hop_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.next_next_hop_tunnels.get_name_leafdata())
                        if (self.total_tunnels.is_set or self.total_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.total_tunnels.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "next-hop-tunnels" or name == "next-next-hop-tunnels" or name == "total-tunnels"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "next-hop-tunnels"):
                            self.next_hop_tunnels = value
                            self.next_hop_tunnels.value_namespace = name_space
                            self.next_hop_tunnels.value_namespace_prefix = name_space_prefix
                        if(value_path == "next-next-hop-tunnels"):
                            self.next_next_hop_tunnels = value
                            self.next_next_hop_tunnels.value_namespace = name_space
                            self.next_next_hop_tunnels.value_namespace_prefix = name_space_prefix
                        if(value_path == "total-tunnels"):
                            self.total_tunnels = value
                            self.total_tunnels.value_namespace = name_space
                            self.total_tunnels.value_namespace_prefix = name_space_prefix


                class Connected(Entity):
                    """
                    Number of connected auto backup tunnels
                    
                    .. attribute:: next_hop_tunnels
                    
                    	Next hop auto backup tunnels only
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: next_next_hop_tunnels
                    
                    	Next next hop auto backup tunnels only
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: total_tunnels
                    
                    	Total auto backup tunnels
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.AutoTunnel.Backup.Statistics.Connected, self).__init__()

                        self.yang_name = "connected"
                        self.yang_parent_name = "statistics"

                        self.next_hop_tunnels = YLeaf(YType.uint32, "next-hop-tunnels")

                        self.next_next_hop_tunnels = YLeaf(YType.uint32, "next-next-hop-tunnels")

                        self.total_tunnels = YLeaf(YType.uint32, "total-tunnels")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("next_hop_tunnels",
                                        "next_next_hop_tunnels",
                                        "total_tunnels") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.AutoTunnel.Backup.Statistics.Connected, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.AutoTunnel.Backup.Statistics.Connected, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.next_hop_tunnels.is_set or
                            self.next_next_hop_tunnels.is_set or
                            self.total_tunnels.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.next_hop_tunnels.yfilter != YFilter.not_set or
                            self.next_next_hop_tunnels.yfilter != YFilter.not_set or
                            self.total_tunnels.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "connected" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/auto-tunnel/backup/statistics/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.next_hop_tunnels.is_set or self.next_hop_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.next_hop_tunnels.get_name_leafdata())
                        if (self.next_next_hop_tunnels.is_set or self.next_next_hop_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.next_next_hop_tunnels.get_name_leafdata())
                        if (self.total_tunnels.is_set or self.total_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.total_tunnels.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "next-hop-tunnels" or name == "next-next-hop-tunnels" or name == "total-tunnels"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "next-hop-tunnels"):
                            self.next_hop_tunnels = value
                            self.next_hop_tunnels.value_namespace = name_space
                            self.next_hop_tunnels.value_namespace_prefix = name_space_prefix
                        if(value_path == "next-next-hop-tunnels"):
                            self.next_next_hop_tunnels = value
                            self.next_next_hop_tunnels.value_namespace = name_space
                            self.next_next_hop_tunnels.value_namespace_prefix = name_space_prefix
                        if(value_path == "total-tunnels"):
                            self.total_tunnels = value
                            self.total_tunnels.value_namespace = name_space
                            self.total_tunnels.value_namespace_prefix = name_space_prefix


                class RemovedDown(Entity):
                    """
                    Number of NNHOP auto backup tunnels removed
                    while down
                    
                    .. attribute:: next_hop_tunnels
                    
                    	Next hop auto backup tunnels only
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: next_next_hop_tunnels
                    
                    	Next next hop auto backup tunnels only
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: total_tunnels
                    
                    	Total auto backup tunnels
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.AutoTunnel.Backup.Statistics.RemovedDown, self).__init__()

                        self.yang_name = "removed-down"
                        self.yang_parent_name = "statistics"

                        self.next_hop_tunnels = YLeaf(YType.uint32, "next-hop-tunnels")

                        self.next_next_hop_tunnels = YLeaf(YType.uint32, "next-next-hop-tunnels")

                        self.total_tunnels = YLeaf(YType.uint32, "total-tunnels")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("next_hop_tunnels",
                                        "next_next_hop_tunnels",
                                        "total_tunnels") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.AutoTunnel.Backup.Statistics.RemovedDown, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.AutoTunnel.Backup.Statistics.RemovedDown, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.next_hop_tunnels.is_set or
                            self.next_next_hop_tunnels.is_set or
                            self.total_tunnels.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.next_hop_tunnels.yfilter != YFilter.not_set or
                            self.next_next_hop_tunnels.yfilter != YFilter.not_set or
                            self.total_tunnels.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "removed-down" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/auto-tunnel/backup/statistics/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.next_hop_tunnels.is_set or self.next_hop_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.next_hop_tunnels.get_name_leafdata())
                        if (self.next_next_hop_tunnels.is_set or self.next_next_hop_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.next_next_hop_tunnels.get_name_leafdata())
                        if (self.total_tunnels.is_set or self.total_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.total_tunnels.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "next-hop-tunnels" or name == "next-next-hop-tunnels" or name == "total-tunnels"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "next-hop-tunnels"):
                            self.next_hop_tunnels = value
                            self.next_hop_tunnels.value_namespace = name_space
                            self.next_hop_tunnels.value_namespace_prefix = name_space_prefix
                        if(value_path == "next-next-hop-tunnels"):
                            self.next_next_hop_tunnels = value
                            self.next_next_hop_tunnels.value_namespace = name_space
                            self.next_next_hop_tunnels.value_namespace_prefix = name_space_prefix
                        if(value_path == "total-tunnels"):
                            self.total_tunnels = value
                            self.total_tunnels.value_namespace = name_space
                            self.total_tunnels.value_namespace_prefix = name_space_prefix


                class RemovedUnused(Entity):
                    """
                    Number of auto backup tunnels removed while
                    unused
                    
                    .. attribute:: next_hop_tunnels
                    
                    	Next hop auto backup tunnels only
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: next_next_hop_tunnels
                    
                    	Next next hop auto backup tunnels only
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: total_tunnels
                    
                    	Total auto backup tunnels
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.AutoTunnel.Backup.Statistics.RemovedUnused, self).__init__()

                        self.yang_name = "removed-unused"
                        self.yang_parent_name = "statistics"

                        self.next_hop_tunnels = YLeaf(YType.uint32, "next-hop-tunnels")

                        self.next_next_hop_tunnels = YLeaf(YType.uint32, "next-next-hop-tunnels")

                        self.total_tunnels = YLeaf(YType.uint32, "total-tunnels")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("next_hop_tunnels",
                                        "next_next_hop_tunnels",
                                        "total_tunnels") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.AutoTunnel.Backup.Statistics.RemovedUnused, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.AutoTunnel.Backup.Statistics.RemovedUnused, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.next_hop_tunnels.is_set or
                            self.next_next_hop_tunnels.is_set or
                            self.total_tunnels.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.next_hop_tunnels.yfilter != YFilter.not_set or
                            self.next_next_hop_tunnels.yfilter != YFilter.not_set or
                            self.total_tunnels.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "removed-unused" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/auto-tunnel/backup/statistics/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.next_hop_tunnels.is_set or self.next_hop_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.next_hop_tunnels.get_name_leafdata())
                        if (self.next_next_hop_tunnels.is_set or self.next_next_hop_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.next_next_hop_tunnels.get_name_leafdata())
                        if (self.total_tunnels.is_set or self.total_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.total_tunnels.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "next-hop-tunnels" or name == "next-next-hop-tunnels" or name == "total-tunnels"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "next-hop-tunnels"):
                            self.next_hop_tunnels = value
                            self.next_hop_tunnels.value_namespace = name_space
                            self.next_hop_tunnels.value_namespace_prefix = name_space_prefix
                        if(value_path == "next-next-hop-tunnels"):
                            self.next_next_hop_tunnels = value
                            self.next_next_hop_tunnels.value_namespace = name_space
                            self.next_next_hop_tunnels.value_namespace_prefix = name_space_prefix
                        if(value_path == "total-tunnels"):
                            self.total_tunnels = value
                            self.total_tunnels.value_namespace = name_space
                            self.total_tunnels.value_namespace_prefix = name_space_prefix


                class RemovedInUse(Entity):
                    """
                    Number of auto backup tunnels removed while up
                    and in use
                    
                    .. attribute:: next_hop_tunnels
                    
                    	Next hop auto backup tunnels only
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: next_next_hop_tunnels
                    
                    	Next next hop auto backup tunnels only
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: total_tunnels
                    
                    	Total auto backup tunnels
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.AutoTunnel.Backup.Statistics.RemovedInUse, self).__init__()

                        self.yang_name = "removed-in-use"
                        self.yang_parent_name = "statistics"

                        self.next_hop_tunnels = YLeaf(YType.uint32, "next-hop-tunnels")

                        self.next_next_hop_tunnels = YLeaf(YType.uint32, "next-next-hop-tunnels")

                        self.total_tunnels = YLeaf(YType.uint32, "total-tunnels")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("next_hop_tunnels",
                                        "next_next_hop_tunnels",
                                        "total_tunnels") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.AutoTunnel.Backup.Statistics.RemovedInUse, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.AutoTunnel.Backup.Statistics.RemovedInUse, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.next_hop_tunnels.is_set or
                            self.next_next_hop_tunnels.is_set or
                            self.total_tunnels.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.next_hop_tunnels.yfilter != YFilter.not_set or
                            self.next_next_hop_tunnels.yfilter != YFilter.not_set or
                            self.total_tunnels.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "removed-in-use" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/auto-tunnel/backup/statistics/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.next_hop_tunnels.is_set or self.next_hop_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.next_hop_tunnels.get_name_leafdata())
                        if (self.next_next_hop_tunnels.is_set or self.next_next_hop_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.next_next_hop_tunnels.get_name_leafdata())
                        if (self.total_tunnels.is_set or self.total_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.total_tunnels.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "next-hop-tunnels" or name == "next-next-hop-tunnels" or name == "total-tunnels"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "next-hop-tunnels"):
                            self.next_hop_tunnels = value
                            self.next_hop_tunnels.value_namespace = name_space
                            self.next_hop_tunnels.value_namespace_prefix = name_space_prefix
                        if(value_path == "next-next-hop-tunnels"):
                            self.next_next_hop_tunnels = value
                            self.next_next_hop_tunnels.value_namespace = name_space
                            self.next_next_hop_tunnels.value_namespace_prefix = name_space_prefix
                        if(value_path == "total-tunnels"):
                            self.total_tunnels = value
                            self.total_tunnels.value_namespace = name_space
                            self.total_tunnels.value_namespace_prefix = name_space_prefix


                class RemovedRangeExceeded(Entity):
                    """
                    Number of auto backup tunnel attempts rejected
                    because the total number exceeds the range
                    
                    .. attribute:: next_hop_tunnels
                    
                    	Next hop auto backup tunnels only
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: next_next_hop_tunnels
                    
                    	Next next hop auto backup tunnels only
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: total_tunnels
                    
                    	Total auto backup tunnels
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.AutoTunnel.Backup.Statistics.RemovedRangeExceeded, self).__init__()

                        self.yang_name = "removed-range-exceeded"
                        self.yang_parent_name = "statistics"

                        self.next_hop_tunnels = YLeaf(YType.uint32, "next-hop-tunnels")

                        self.next_next_hop_tunnels = YLeaf(YType.uint32, "next-next-hop-tunnels")

                        self.total_tunnels = YLeaf(YType.uint32, "total-tunnels")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("next_hop_tunnels",
                                        "next_next_hop_tunnels",
                                        "total_tunnels") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.AutoTunnel.Backup.Statistics.RemovedRangeExceeded, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.AutoTunnel.Backup.Statistics.RemovedRangeExceeded, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.next_hop_tunnels.is_set or
                            self.next_next_hop_tunnels.is_set or
                            self.total_tunnels.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.next_hop_tunnels.yfilter != YFilter.not_set or
                            self.next_next_hop_tunnels.yfilter != YFilter.not_set or
                            self.total_tunnels.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "removed-range-exceeded" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/auto-tunnel/backup/statistics/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.next_hop_tunnels.is_set or self.next_hop_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.next_hop_tunnels.get_name_leafdata())
                        if (self.next_next_hop_tunnels.is_set or self.next_next_hop_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.next_next_hop_tunnels.get_name_leafdata())
                        if (self.total_tunnels.is_set or self.total_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.total_tunnels.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "next-hop-tunnels" or name == "next-next-hop-tunnels" or name == "total-tunnels"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "next-hop-tunnels"):
                            self.next_hop_tunnels = value
                            self.next_hop_tunnels.value_namespace = name_space
                            self.next_hop_tunnels.value_namespace_prefix = name_space_prefix
                        if(value_path == "next-next-hop-tunnels"):
                            self.next_next_hop_tunnels = value
                            self.next_next_hop_tunnels.value_namespace = name_space
                            self.next_next_hop_tunnels.value_namespace_prefix = name_space_prefix
                        if(value_path == "total-tunnels"):
                            self.total_tunnels = value
                            self.total_tunnels.value_namespace = name_space
                            self.total_tunnels.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    return (
                        self.last_cleared_time.is_set or
                        (self.connected is not None and self.connected.has_data()) or
                        (self.created is not None and self.created.has_data()) or
                        (self.removed_down is not None and self.removed_down.has_data()) or
                        (self.removed_in_use is not None and self.removed_in_use.has_data()) or
                        (self.removed_range_exceeded is not None and self.removed_range_exceeded.has_data()) or
                        (self.removed_unused is not None and self.removed_unused.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.last_cleared_time.yfilter != YFilter.not_set or
                        (self.connected is not None and self.connected.has_operation()) or
                        (self.created is not None and self.created.has_operation()) or
                        (self.removed_down is not None and self.removed_down.has_operation()) or
                        (self.removed_in_use is not None and self.removed_in_use.has_operation()) or
                        (self.removed_range_exceeded is not None and self.removed_range_exceeded.has_operation()) or
                        (self.removed_unused is not None and self.removed_unused.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "statistics" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/auto-tunnel/backup/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.last_cleared_time.is_set or self.last_cleared_time.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.last_cleared_time.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "connected"):
                        if (self.connected is None):
                            self.connected = MplsTeStandby.AutoTunnel.Backup.Statistics.Connected()
                            self.connected.parent = self
                            self._children_name_map["connected"] = "connected"
                        return self.connected

                    if (child_yang_name == "created"):
                        if (self.created is None):
                            self.created = MplsTeStandby.AutoTunnel.Backup.Statistics.Created()
                            self.created.parent = self
                            self._children_name_map["created"] = "created"
                        return self.created

                    if (child_yang_name == "removed-down"):
                        if (self.removed_down is None):
                            self.removed_down = MplsTeStandby.AutoTunnel.Backup.Statistics.RemovedDown()
                            self.removed_down.parent = self
                            self._children_name_map["removed_down"] = "removed-down"
                        return self.removed_down

                    if (child_yang_name == "removed-in-use"):
                        if (self.removed_in_use is None):
                            self.removed_in_use = MplsTeStandby.AutoTunnel.Backup.Statistics.RemovedInUse()
                            self.removed_in_use.parent = self
                            self._children_name_map["removed_in_use"] = "removed-in-use"
                        return self.removed_in_use

                    if (child_yang_name == "removed-range-exceeded"):
                        if (self.removed_range_exceeded is None):
                            self.removed_range_exceeded = MplsTeStandby.AutoTunnel.Backup.Statistics.RemovedRangeExceeded()
                            self.removed_range_exceeded.parent = self
                            self._children_name_map["removed_range_exceeded"] = "removed-range-exceeded"
                        return self.removed_range_exceeded

                    if (child_yang_name == "removed-unused"):
                        if (self.removed_unused is None):
                            self.removed_unused = MplsTeStandby.AutoTunnel.Backup.Statistics.RemovedUnused()
                            self.removed_unused.parent = self
                            self._children_name_map["removed_unused"] = "removed-unused"
                        return self.removed_unused

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "connected" or name == "created" or name == "removed-down" or name == "removed-in-use" or name == "removed-range-exceeded" or name == "removed-unused" or name == "last-cleared-time"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "last-cleared-time"):
                        self.last_cleared_time = value
                        self.last_cleared_time.value_namespace = name_space
                        self.last_cleared_time.value_namespace_prefix = name_space_prefix


            class Summary(Entity):
                """
                MPLS TE auto\-tunnel backup summary information
                
                .. attribute:: autobackups
                
                	Total number of autobackup tunnels
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: down_autobackups
                
                	Total number of autobackup tunnels that are down
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: next_hop_autobackup_protected_ls_ps
                
                	Total number of autobackup protected LSPs with NHOP and no SRLG
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: next_hop_autobackup_protected_s2_ls
                
                	Total number of autobackup protected S2Ls with NHOP and no SRLG
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: next_hop_autobackup_protected_s2l_families
                
                	Total number of autobackup protected S2L Families with NHOP and no SRLG
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: next_hop_autobackups
                
                	Total number of autobackup tunnels that are NHOP
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: next_hop_srlg_autobackup_protected_ls_ps
                
                	Total number of autobackup protected LSPs with NHOP and SRLG
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: next_hop_srlg_autobackup_protected_s2_ls
                
                	Total number of autobackup protected S2Ls with NHOP and SRLG
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: next_hop_srlg_autobackup_protected_s2l_families
                
                	Total number of autobackup protected S2L Families with NHOP and SRLG
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: next_next_hop_autobackup_protected_ls_ps
                
                	Total number of autobackup protected LSPs with NNHOP and no SRLG
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: next_next_hop_autobackup_protected_s2_ls
                
                	Total number of autobackup protected S2Ls with NNHOP and no SRLG
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: next_next_hop_autobackup_protected_s2l_families
                
                	Total number of autobackup protected S2L Families with NNHOP and no SRLG
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: next_next_hop_autobackups
                
                	Total number of autobackup tunnels that are NNHOP
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: next_next_hop_srlg_autobackup_protected_ls_ps
                
                	Total number of autobackup protected LSPs with NNHOP and SRLG
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: next_next_hop_srlg_autobackup_protected_s2_ls
                
                	Total number of autobackup protected S2Ls with NNHOP and SRLG
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: next_next_hop_srlg_autobackup_protected_s2l_families
                
                	Total number of autobackup protected S2L Families with NNHOP and SRLG
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: srlg_preferred_autobackups
                
                	Total number of autobackup tunnels that are using SRLG preferred
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: srlg_strict_autobackups
                
                	Total number of autobackup tunnels that are using SRLG strict
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: srlg_weighted_autobackups
                
                	Total number of autobackup tunnels that are using weighted SRLG
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: unused_autobackups
                
                	Total number of autobackup tunnels that are unused
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: up_autobackups
                
                	Total number of autobackup tunnels that are up
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTeStandby.AutoTunnel.Backup.Summary, self).__init__()

                    self.yang_name = "summary"
                    self.yang_parent_name = "backup"

                    self.autobackups = YLeaf(YType.uint32, "autobackups")

                    self.down_autobackups = YLeaf(YType.uint32, "down-autobackups")

                    self.next_hop_autobackup_protected_ls_ps = YLeaf(YType.uint32, "next-hop-autobackup-protected-ls-ps")

                    self.next_hop_autobackup_protected_s2_ls = YLeaf(YType.uint32, "next-hop-autobackup-protected-s2-ls")

                    self.next_hop_autobackup_protected_s2l_families = YLeaf(YType.uint32, "next-hop-autobackup-protected-s2l-families")

                    self.next_hop_autobackups = YLeaf(YType.uint32, "next-hop-autobackups")

                    self.next_hop_srlg_autobackup_protected_ls_ps = YLeaf(YType.uint32, "next-hop-srlg-autobackup-protected-ls-ps")

                    self.next_hop_srlg_autobackup_protected_s2_ls = YLeaf(YType.uint32, "next-hop-srlg-autobackup-protected-s2-ls")

                    self.next_hop_srlg_autobackup_protected_s2l_families = YLeaf(YType.uint32, "next-hop-srlg-autobackup-protected-s2l-families")

                    self.next_next_hop_autobackup_protected_ls_ps = YLeaf(YType.uint32, "next-next-hop-autobackup-protected-ls-ps")

                    self.next_next_hop_autobackup_protected_s2_ls = YLeaf(YType.uint32, "next-next-hop-autobackup-protected-s2-ls")

                    self.next_next_hop_autobackup_protected_s2l_families = YLeaf(YType.uint32, "next-next-hop-autobackup-protected-s2l-families")

                    self.next_next_hop_autobackups = YLeaf(YType.uint32, "next-next-hop-autobackups")

                    self.next_next_hop_srlg_autobackup_protected_ls_ps = YLeaf(YType.uint32, "next-next-hop-srlg-autobackup-protected-ls-ps")

                    self.next_next_hop_srlg_autobackup_protected_s2_ls = YLeaf(YType.uint32, "next-next-hop-srlg-autobackup-protected-s2-ls")

                    self.next_next_hop_srlg_autobackup_protected_s2l_families = YLeaf(YType.uint32, "next-next-hop-srlg-autobackup-protected-s2l-families")

                    self.srlg_preferred_autobackups = YLeaf(YType.uint32, "srlg-preferred-autobackups")

                    self.srlg_strict_autobackups = YLeaf(YType.uint32, "srlg-strict-autobackups")

                    self.srlg_weighted_autobackups = YLeaf(YType.uint32, "srlg-weighted-autobackups")

                    self.unused_autobackups = YLeaf(YType.uint32, "unused-autobackups")

                    self.up_autobackups = YLeaf(YType.uint32, "up-autobackups")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("autobackups",
                                    "down_autobackups",
                                    "next_hop_autobackup_protected_ls_ps",
                                    "next_hop_autobackup_protected_s2_ls",
                                    "next_hop_autobackup_protected_s2l_families",
                                    "next_hop_autobackups",
                                    "next_hop_srlg_autobackup_protected_ls_ps",
                                    "next_hop_srlg_autobackup_protected_s2_ls",
                                    "next_hop_srlg_autobackup_protected_s2l_families",
                                    "next_next_hop_autobackup_protected_ls_ps",
                                    "next_next_hop_autobackup_protected_s2_ls",
                                    "next_next_hop_autobackup_protected_s2l_families",
                                    "next_next_hop_autobackups",
                                    "next_next_hop_srlg_autobackup_protected_ls_ps",
                                    "next_next_hop_srlg_autobackup_protected_s2_ls",
                                    "next_next_hop_srlg_autobackup_protected_s2l_families",
                                    "srlg_preferred_autobackups",
                                    "srlg_strict_autobackups",
                                    "srlg_weighted_autobackups",
                                    "unused_autobackups",
                                    "up_autobackups") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTeStandby.AutoTunnel.Backup.Summary, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTeStandby.AutoTunnel.Backup.Summary, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.autobackups.is_set or
                        self.down_autobackups.is_set or
                        self.next_hop_autobackup_protected_ls_ps.is_set or
                        self.next_hop_autobackup_protected_s2_ls.is_set or
                        self.next_hop_autobackup_protected_s2l_families.is_set or
                        self.next_hop_autobackups.is_set or
                        self.next_hop_srlg_autobackup_protected_ls_ps.is_set or
                        self.next_hop_srlg_autobackup_protected_s2_ls.is_set or
                        self.next_hop_srlg_autobackup_protected_s2l_families.is_set or
                        self.next_next_hop_autobackup_protected_ls_ps.is_set or
                        self.next_next_hop_autobackup_protected_s2_ls.is_set or
                        self.next_next_hop_autobackup_protected_s2l_families.is_set or
                        self.next_next_hop_autobackups.is_set or
                        self.next_next_hop_srlg_autobackup_protected_ls_ps.is_set or
                        self.next_next_hop_srlg_autobackup_protected_s2_ls.is_set or
                        self.next_next_hop_srlg_autobackup_protected_s2l_families.is_set or
                        self.srlg_preferred_autobackups.is_set or
                        self.srlg_strict_autobackups.is_set or
                        self.srlg_weighted_autobackups.is_set or
                        self.unused_autobackups.is_set or
                        self.up_autobackups.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.autobackups.yfilter != YFilter.not_set or
                        self.down_autobackups.yfilter != YFilter.not_set or
                        self.next_hop_autobackup_protected_ls_ps.yfilter != YFilter.not_set or
                        self.next_hop_autobackup_protected_s2_ls.yfilter != YFilter.not_set or
                        self.next_hop_autobackup_protected_s2l_families.yfilter != YFilter.not_set or
                        self.next_hop_autobackups.yfilter != YFilter.not_set or
                        self.next_hop_srlg_autobackup_protected_ls_ps.yfilter != YFilter.not_set or
                        self.next_hop_srlg_autobackup_protected_s2_ls.yfilter != YFilter.not_set or
                        self.next_hop_srlg_autobackup_protected_s2l_families.yfilter != YFilter.not_set or
                        self.next_next_hop_autobackup_protected_ls_ps.yfilter != YFilter.not_set or
                        self.next_next_hop_autobackup_protected_s2_ls.yfilter != YFilter.not_set or
                        self.next_next_hop_autobackup_protected_s2l_families.yfilter != YFilter.not_set or
                        self.next_next_hop_autobackups.yfilter != YFilter.not_set or
                        self.next_next_hop_srlg_autobackup_protected_ls_ps.yfilter != YFilter.not_set or
                        self.next_next_hop_srlg_autobackup_protected_s2_ls.yfilter != YFilter.not_set or
                        self.next_next_hop_srlg_autobackup_protected_s2l_families.yfilter != YFilter.not_set or
                        self.srlg_preferred_autobackups.yfilter != YFilter.not_set or
                        self.srlg_strict_autobackups.yfilter != YFilter.not_set or
                        self.srlg_weighted_autobackups.yfilter != YFilter.not_set or
                        self.unused_autobackups.yfilter != YFilter.not_set or
                        self.up_autobackups.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "summary" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/auto-tunnel/backup/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.autobackups.is_set or self.autobackups.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.autobackups.get_name_leafdata())
                    if (self.down_autobackups.is_set or self.down_autobackups.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.down_autobackups.get_name_leafdata())
                    if (self.next_hop_autobackup_protected_ls_ps.is_set or self.next_hop_autobackup_protected_ls_ps.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.next_hop_autobackup_protected_ls_ps.get_name_leafdata())
                    if (self.next_hop_autobackup_protected_s2_ls.is_set or self.next_hop_autobackup_protected_s2_ls.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.next_hop_autobackup_protected_s2_ls.get_name_leafdata())
                    if (self.next_hop_autobackup_protected_s2l_families.is_set or self.next_hop_autobackup_protected_s2l_families.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.next_hop_autobackup_protected_s2l_families.get_name_leafdata())
                    if (self.next_hop_autobackups.is_set or self.next_hop_autobackups.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.next_hop_autobackups.get_name_leafdata())
                    if (self.next_hop_srlg_autobackup_protected_ls_ps.is_set or self.next_hop_srlg_autobackup_protected_ls_ps.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.next_hop_srlg_autobackup_protected_ls_ps.get_name_leafdata())
                    if (self.next_hop_srlg_autobackup_protected_s2_ls.is_set or self.next_hop_srlg_autobackup_protected_s2_ls.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.next_hop_srlg_autobackup_protected_s2_ls.get_name_leafdata())
                    if (self.next_hop_srlg_autobackup_protected_s2l_families.is_set or self.next_hop_srlg_autobackup_protected_s2l_families.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.next_hop_srlg_autobackup_protected_s2l_families.get_name_leafdata())
                    if (self.next_next_hop_autobackup_protected_ls_ps.is_set or self.next_next_hop_autobackup_protected_ls_ps.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.next_next_hop_autobackup_protected_ls_ps.get_name_leafdata())
                    if (self.next_next_hop_autobackup_protected_s2_ls.is_set or self.next_next_hop_autobackup_protected_s2_ls.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.next_next_hop_autobackup_protected_s2_ls.get_name_leafdata())
                    if (self.next_next_hop_autobackup_protected_s2l_families.is_set or self.next_next_hop_autobackup_protected_s2l_families.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.next_next_hop_autobackup_protected_s2l_families.get_name_leafdata())
                    if (self.next_next_hop_autobackups.is_set or self.next_next_hop_autobackups.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.next_next_hop_autobackups.get_name_leafdata())
                    if (self.next_next_hop_srlg_autobackup_protected_ls_ps.is_set or self.next_next_hop_srlg_autobackup_protected_ls_ps.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.next_next_hop_srlg_autobackup_protected_ls_ps.get_name_leafdata())
                    if (self.next_next_hop_srlg_autobackup_protected_s2_ls.is_set or self.next_next_hop_srlg_autobackup_protected_s2_ls.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.next_next_hop_srlg_autobackup_protected_s2_ls.get_name_leafdata())
                    if (self.next_next_hop_srlg_autobackup_protected_s2l_families.is_set or self.next_next_hop_srlg_autobackup_protected_s2l_families.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.next_next_hop_srlg_autobackup_protected_s2l_families.get_name_leafdata())
                    if (self.srlg_preferred_autobackups.is_set or self.srlg_preferred_autobackups.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.srlg_preferred_autobackups.get_name_leafdata())
                    if (self.srlg_strict_autobackups.is_set or self.srlg_strict_autobackups.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.srlg_strict_autobackups.get_name_leafdata())
                    if (self.srlg_weighted_autobackups.is_set or self.srlg_weighted_autobackups.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.srlg_weighted_autobackups.get_name_leafdata())
                    if (self.unused_autobackups.is_set or self.unused_autobackups.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.unused_autobackups.get_name_leafdata())
                    if (self.up_autobackups.is_set or self.up_autobackups.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.up_autobackups.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "autobackups" or name == "down-autobackups" or name == "next-hop-autobackup-protected-ls-ps" or name == "next-hop-autobackup-protected-s2-ls" or name == "next-hop-autobackup-protected-s2l-families" or name == "next-hop-autobackups" or name == "next-hop-srlg-autobackup-protected-ls-ps" or name == "next-hop-srlg-autobackup-protected-s2-ls" or name == "next-hop-srlg-autobackup-protected-s2l-families" or name == "next-next-hop-autobackup-protected-ls-ps" or name == "next-next-hop-autobackup-protected-s2-ls" or name == "next-next-hop-autobackup-protected-s2l-families" or name == "next-next-hop-autobackups" or name == "next-next-hop-srlg-autobackup-protected-ls-ps" or name == "next-next-hop-srlg-autobackup-protected-s2-ls" or name == "next-next-hop-srlg-autobackup-protected-s2l-families" or name == "srlg-preferred-autobackups" or name == "srlg-strict-autobackups" or name == "srlg-weighted-autobackups" or name == "unused-autobackups" or name == "up-autobackups"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "autobackups"):
                        self.autobackups = value
                        self.autobackups.value_namespace = name_space
                        self.autobackups.value_namespace_prefix = name_space_prefix
                    if(value_path == "down-autobackups"):
                        self.down_autobackups = value
                        self.down_autobackups.value_namespace = name_space
                        self.down_autobackups.value_namespace_prefix = name_space_prefix
                    if(value_path == "next-hop-autobackup-protected-ls-ps"):
                        self.next_hop_autobackup_protected_ls_ps = value
                        self.next_hop_autobackup_protected_ls_ps.value_namespace = name_space
                        self.next_hop_autobackup_protected_ls_ps.value_namespace_prefix = name_space_prefix
                    if(value_path == "next-hop-autobackup-protected-s2-ls"):
                        self.next_hop_autobackup_protected_s2_ls = value
                        self.next_hop_autobackup_protected_s2_ls.value_namespace = name_space
                        self.next_hop_autobackup_protected_s2_ls.value_namespace_prefix = name_space_prefix
                    if(value_path == "next-hop-autobackup-protected-s2l-families"):
                        self.next_hop_autobackup_protected_s2l_families = value
                        self.next_hop_autobackup_protected_s2l_families.value_namespace = name_space
                        self.next_hop_autobackup_protected_s2l_families.value_namespace_prefix = name_space_prefix
                    if(value_path == "next-hop-autobackups"):
                        self.next_hop_autobackups = value
                        self.next_hop_autobackups.value_namespace = name_space
                        self.next_hop_autobackups.value_namespace_prefix = name_space_prefix
                    if(value_path == "next-hop-srlg-autobackup-protected-ls-ps"):
                        self.next_hop_srlg_autobackup_protected_ls_ps = value
                        self.next_hop_srlg_autobackup_protected_ls_ps.value_namespace = name_space
                        self.next_hop_srlg_autobackup_protected_ls_ps.value_namespace_prefix = name_space_prefix
                    if(value_path == "next-hop-srlg-autobackup-protected-s2-ls"):
                        self.next_hop_srlg_autobackup_protected_s2_ls = value
                        self.next_hop_srlg_autobackup_protected_s2_ls.value_namespace = name_space
                        self.next_hop_srlg_autobackup_protected_s2_ls.value_namespace_prefix = name_space_prefix
                    if(value_path == "next-hop-srlg-autobackup-protected-s2l-families"):
                        self.next_hop_srlg_autobackup_protected_s2l_families = value
                        self.next_hop_srlg_autobackup_protected_s2l_families.value_namespace = name_space
                        self.next_hop_srlg_autobackup_protected_s2l_families.value_namespace_prefix = name_space_prefix
                    if(value_path == "next-next-hop-autobackup-protected-ls-ps"):
                        self.next_next_hop_autobackup_protected_ls_ps = value
                        self.next_next_hop_autobackup_protected_ls_ps.value_namespace = name_space
                        self.next_next_hop_autobackup_protected_ls_ps.value_namespace_prefix = name_space_prefix
                    if(value_path == "next-next-hop-autobackup-protected-s2-ls"):
                        self.next_next_hop_autobackup_protected_s2_ls = value
                        self.next_next_hop_autobackup_protected_s2_ls.value_namespace = name_space
                        self.next_next_hop_autobackup_protected_s2_ls.value_namespace_prefix = name_space_prefix
                    if(value_path == "next-next-hop-autobackup-protected-s2l-families"):
                        self.next_next_hop_autobackup_protected_s2l_families = value
                        self.next_next_hop_autobackup_protected_s2l_families.value_namespace = name_space
                        self.next_next_hop_autobackup_protected_s2l_families.value_namespace_prefix = name_space_prefix
                    if(value_path == "next-next-hop-autobackups"):
                        self.next_next_hop_autobackups = value
                        self.next_next_hop_autobackups.value_namespace = name_space
                        self.next_next_hop_autobackups.value_namespace_prefix = name_space_prefix
                    if(value_path == "next-next-hop-srlg-autobackup-protected-ls-ps"):
                        self.next_next_hop_srlg_autobackup_protected_ls_ps = value
                        self.next_next_hop_srlg_autobackup_protected_ls_ps.value_namespace = name_space
                        self.next_next_hop_srlg_autobackup_protected_ls_ps.value_namespace_prefix = name_space_prefix
                    if(value_path == "next-next-hop-srlg-autobackup-protected-s2-ls"):
                        self.next_next_hop_srlg_autobackup_protected_s2_ls = value
                        self.next_next_hop_srlg_autobackup_protected_s2_ls.value_namespace = name_space
                        self.next_next_hop_srlg_autobackup_protected_s2_ls.value_namespace_prefix = name_space_prefix
                    if(value_path == "next-next-hop-srlg-autobackup-protected-s2l-families"):
                        self.next_next_hop_srlg_autobackup_protected_s2l_families = value
                        self.next_next_hop_srlg_autobackup_protected_s2l_families.value_namespace = name_space
                        self.next_next_hop_srlg_autobackup_protected_s2l_families.value_namespace_prefix = name_space_prefix
                    if(value_path == "srlg-preferred-autobackups"):
                        self.srlg_preferred_autobackups = value
                        self.srlg_preferred_autobackups.value_namespace = name_space
                        self.srlg_preferred_autobackups.value_namespace_prefix = name_space_prefix
                    if(value_path == "srlg-strict-autobackups"):
                        self.srlg_strict_autobackups = value
                        self.srlg_strict_autobackups.value_namespace = name_space
                        self.srlg_strict_autobackups.value_namespace_prefix = name_space_prefix
                    if(value_path == "srlg-weighted-autobackups"):
                        self.srlg_weighted_autobackups = value
                        self.srlg_weighted_autobackups.value_namespace = name_space
                        self.srlg_weighted_autobackups.value_namespace_prefix = name_space_prefix
                    if(value_path == "unused-autobackups"):
                        self.unused_autobackups = value
                        self.unused_autobackups.value_namespace = name_space
                        self.unused_autobackups.value_namespace_prefix = name_space_prefix
                    if(value_path == "up-autobackups"):
                        self.up_autobackups = value
                        self.up_autobackups.value_namespace = name_space
                        self.up_autobackups.value_namespace_prefix = name_space_prefix


            class Config(Entity):
                """
                MPLS TE auto\-tunnel backup configuration
                information
                
                .. attribute:: interface_count
                
                	Number of TE link interfaces with auto\-tunnel backup configured
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: is_configured
                
                	Indicate if auto\-tunnel bacukp feature is configured 
                	**type**\:  bool
                
                .. attribute:: max_tunnel_id
                
                	Upper bound of configured tunnel ID range
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: min_tunnel_id
                
                	Lower bound of configured tunnel ID range
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: unused_removal_timeout_configured
                
                	Configured value of unused removal timer in seconds
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: second
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTeStandby.AutoTunnel.Backup.Config, self).__init__()

                    self.yang_name = "config"
                    self.yang_parent_name = "backup"

                    self.interface_count = YLeaf(YType.uint32, "interface-count")

                    self.is_configured = YLeaf(YType.boolean, "is-configured")

                    self.max_tunnel_id = YLeaf(YType.uint16, "max-tunnel-id")

                    self.min_tunnel_id = YLeaf(YType.uint16, "min-tunnel-id")

                    self.unused_removal_timeout_configured = YLeaf(YType.uint32, "unused-removal-timeout-configured")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("interface_count",
                                    "is_configured",
                                    "max_tunnel_id",
                                    "min_tunnel_id",
                                    "unused_removal_timeout_configured") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTeStandby.AutoTunnel.Backup.Config, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTeStandby.AutoTunnel.Backup.Config, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.interface_count.is_set or
                        self.is_configured.is_set or
                        self.max_tunnel_id.is_set or
                        self.min_tunnel_id.is_set or
                        self.unused_removal_timeout_configured.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.interface_count.yfilter != YFilter.not_set or
                        self.is_configured.yfilter != YFilter.not_set or
                        self.max_tunnel_id.yfilter != YFilter.not_set or
                        self.min_tunnel_id.yfilter != YFilter.not_set or
                        self.unused_removal_timeout_configured.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "config" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/auto-tunnel/backup/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.interface_count.is_set or self.interface_count.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.interface_count.get_name_leafdata())
                    if (self.is_configured.is_set or self.is_configured.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_configured.get_name_leafdata())
                    if (self.max_tunnel_id.is_set or self.max_tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.max_tunnel_id.get_name_leafdata())
                    if (self.min_tunnel_id.is_set or self.min_tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.min_tunnel_id.get_name_leafdata())
                    if (self.unused_removal_timeout_configured.is_set or self.unused_removal_timeout_configured.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.unused_removal_timeout_configured.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "interface-count" or name == "is-configured" or name == "max-tunnel-id" or name == "min-tunnel-id" or name == "unused-removal-timeout-configured"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "interface-count"):
                        self.interface_count = value
                        self.interface_count.value_namespace = name_space
                        self.interface_count.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-configured"):
                        self.is_configured = value
                        self.is_configured.value_namespace = name_space
                        self.is_configured.value_namespace_prefix = name_space_prefix
                    if(value_path == "max-tunnel-id"):
                        self.max_tunnel_id = value
                        self.max_tunnel_id.value_namespace = name_space
                        self.max_tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "min-tunnel-id"):
                        self.min_tunnel_id = value
                        self.min_tunnel_id.value_namespace = name_space
                        self.min_tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "unused-removal-timeout-configured"):
                        self.unused_removal_timeout_configured = value
                        self.unused_removal_timeout_configured.value_namespace = name_space
                        self.unused_removal_timeout_configured.value_namespace_prefix = name_space_prefix

            def has_data(self):
                return (
                    (self.config is not None and self.config.has_data()) or
                    (self.statistics is not None and self.statistics.has_data()) or
                    (self.summary is not None and self.summary.has_data()) or
                    (self.tunnels is not None and self.tunnels.has_data()))

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    (self.config is not None and self.config.has_operation()) or
                    (self.statistics is not None and self.statistics.has_operation()) or
                    (self.summary is not None and self.summary.has_operation()) or
                    (self.tunnels is not None and self.tunnels.has_operation()))

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "backup" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/auto-tunnel/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "config"):
                    if (self.config is None):
                        self.config = MplsTeStandby.AutoTunnel.Backup.Config()
                        self.config.parent = self
                        self._children_name_map["config"] = "config"
                    return self.config

                if (child_yang_name == "statistics"):
                    if (self.statistics is None):
                        self.statistics = MplsTeStandby.AutoTunnel.Backup.Statistics()
                        self.statistics.parent = self
                        self._children_name_map["statistics"] = "statistics"
                    return self.statistics

                if (child_yang_name == "summary"):
                    if (self.summary is None):
                        self.summary = MplsTeStandby.AutoTunnel.Backup.Summary()
                        self.summary.parent = self
                        self._children_name_map["summary"] = "summary"
                    return self.summary

                if (child_yang_name == "tunnels"):
                    if (self.tunnels is None):
                        self.tunnels = MplsTeStandby.AutoTunnel.Backup.Tunnels()
                        self.tunnels.parent = self
                        self._children_name_map["tunnels"] = "tunnels"
                    return self.tunnels

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "config" or name == "statistics" or name == "summary" or name == "tunnels"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass

        def has_data(self):
            return (
                (self.backup is not None and self.backup.has_data()) or
                (self.mesh is not None and self.mesh.has_data()) or
                (self.pcc is not None and self.pcc.has_data()))

        def has_operation(self):
            return (
                self.yfilter != YFilter.not_set or
                (self.backup is not None and self.backup.has_operation()) or
                (self.mesh is not None and self.mesh.has_operation()) or
                (self.pcc is not None and self.pcc.has_operation()))

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "auto-tunnel" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "backup"):
                if (self.backup is None):
                    self.backup = MplsTeStandby.AutoTunnel.Backup()
                    self.backup.parent = self
                    self._children_name_map["backup"] = "backup"
                return self.backup

            if (child_yang_name == "mesh"):
                if (self.mesh is None):
                    self.mesh = MplsTeStandby.AutoTunnel.Mesh()
                    self.mesh.parent = self
                    self._children_name_map["mesh"] = "mesh"
                return self.mesh

            if (child_yang_name == "pcc"):
                if (self.pcc is None):
                    self.pcc = MplsTeStandby.AutoTunnel.Pcc()
                    self.pcc.parent = self
                    self._children_name_map["pcc"] = "pcc"
                return self.pcc

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "backup" or name == "mesh" or name == "pcc"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class SoftPreemption(Entity):
        """
        Soft Preemption information.
        
        .. attribute:: statistics
        
        	MPLS TE soft preemption stats information
        	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SoftPreemption.Statistics>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsTeStandby.SoftPreemption, self).__init__()

            self.yang_name = "soft-preemption"
            self.yang_parent_name = "mpls-te-standby"

            self.statistics = MplsTeStandby.SoftPreemption.Statistics()
            self.statistics.parent = self
            self._children_name_map["statistics"] = "statistics"
            self._children_yang_names.add("statistics")


        class Statistics(Entity):
            """
            MPLS TE soft preemption stats information
            
            .. attribute:: frr_triggered_soft_preempted_lsp_ss
            
            	The number of LSPs that have been soft preempted and then fast rerouted at this node
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: last_cleared_timestamp
            
            	The timestamp when these stats are cleared relative to Jan 1, 1970
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: minimum_time_in_soft_preempted_state
            
            	The minimum number of seconds an LSP remained in the soft preempted state
            	**type**\:  int
            
            	**range:** 0..65535
            
            	**units**\: second
            
            .. attribute:: path_protected_switchover_soft_preempted_ls_ps
            
            	Number of soft preemption LSPs that are replaced with the path protection LSP. This is relevant to the headend
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: reoptimized_soft_preempted_ls_ps
            
            	Number of soft preemption LSPs that are reoptimized. This is relevant to the headend
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: soft_preempted_head_ls_ps
            
            	Number of soft preempted LSPs at the headend. This is relevant to the headend
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: soft_preempted_ls_ps
            
            	The number of LSPs that have been soft preempted at this node
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: soft_preemption_events
            
            	The number of soft preemption events triggered
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: time_in_soft_preempted_state_avg
            
            	The average number of seconds an LSP remained in the soft preempted state. This excludes the timed out LSPs
            	**type**\:  int
            
            	**range:** 0..65535
            
            	**units**\: second
            
            .. attribute:: time_in_soft_preempted_state_max
            
            	The maximum number of seconds an LSP remained in the soft preempted state without being hard preempted
            	**type**\:  int
            
            	**range:** 0..65535
            
            	**units**\: second
            
            .. attribute:: timed_out_soft_preempted_lsp_ss
            
            	The number of LSPs that have been soft preempted and timed out at this node
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: torn_down_soft_preempted_ls_ps
            
            	The number of LSPs that have been soft preempted at this node and torn down before timing out
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: torndown_soft_preempted_ls_ps
            
            	Number of soft preemption LSPs that are torn down instead of being reoptimized. This is relevant to the headend
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTeStandby.SoftPreemption.Statistics, self).__init__()

                self.yang_name = "statistics"
                self.yang_parent_name = "soft-preemption"

                self.frr_triggered_soft_preempted_lsp_ss = YLeaf(YType.uint32, "frr-triggered-soft-preempted-lsp-ss")

                self.last_cleared_timestamp = YLeaf(YType.uint32, "last-cleared-timestamp")

                self.minimum_time_in_soft_preempted_state = YLeaf(YType.uint16, "minimum-time-in-soft-preempted-state")

                self.path_protected_switchover_soft_preempted_ls_ps = YLeaf(YType.uint32, "path-protected-switchover-soft-preempted-ls-ps")

                self.reoptimized_soft_preempted_ls_ps = YLeaf(YType.uint32, "reoptimized-soft-preempted-ls-ps")

                self.soft_preempted_head_ls_ps = YLeaf(YType.uint32, "soft-preempted-head-ls-ps")

                self.soft_preempted_ls_ps = YLeaf(YType.uint32, "soft-preempted-ls-ps")

                self.soft_preemption_events = YLeaf(YType.uint32, "soft-preemption-events")

                self.time_in_soft_preempted_state_avg = YLeaf(YType.uint16, "time-in-soft-preempted-state-avg")

                self.time_in_soft_preempted_state_max = YLeaf(YType.uint16, "time-in-soft-preempted-state-max")

                self.timed_out_soft_preempted_lsp_ss = YLeaf(YType.uint32, "timed-out-soft-preempted-lsp-ss")

                self.torn_down_soft_preempted_ls_ps = YLeaf(YType.uint32, "torn-down-soft-preempted-ls-ps")

                self.torndown_soft_preempted_ls_ps = YLeaf(YType.uint32, "torndown-soft-preempted-ls-ps")

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("frr_triggered_soft_preempted_lsp_ss",
                                "last_cleared_timestamp",
                                "minimum_time_in_soft_preempted_state",
                                "path_protected_switchover_soft_preempted_ls_ps",
                                "reoptimized_soft_preempted_ls_ps",
                                "soft_preempted_head_ls_ps",
                                "soft_preempted_ls_ps",
                                "soft_preemption_events",
                                "time_in_soft_preempted_state_avg",
                                "time_in_soft_preempted_state_max",
                                "timed_out_soft_preempted_lsp_ss",
                                "torn_down_soft_preempted_ls_ps",
                                "torndown_soft_preempted_ls_ps") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTeStandby.SoftPreemption.Statistics, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTeStandby.SoftPreemption.Statistics, self).__setattr__(name, value)

            def has_data(self):
                return (
                    self.frr_triggered_soft_preempted_lsp_ss.is_set or
                    self.last_cleared_timestamp.is_set or
                    self.minimum_time_in_soft_preempted_state.is_set or
                    self.path_protected_switchover_soft_preempted_ls_ps.is_set or
                    self.reoptimized_soft_preempted_ls_ps.is_set or
                    self.soft_preempted_head_ls_ps.is_set or
                    self.soft_preempted_ls_ps.is_set or
                    self.soft_preemption_events.is_set or
                    self.time_in_soft_preempted_state_avg.is_set or
                    self.time_in_soft_preempted_state_max.is_set or
                    self.timed_out_soft_preempted_lsp_ss.is_set or
                    self.torn_down_soft_preempted_ls_ps.is_set or
                    self.torndown_soft_preempted_ls_ps.is_set)

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    self.frr_triggered_soft_preempted_lsp_ss.yfilter != YFilter.not_set or
                    self.last_cleared_timestamp.yfilter != YFilter.not_set or
                    self.minimum_time_in_soft_preempted_state.yfilter != YFilter.not_set or
                    self.path_protected_switchover_soft_preempted_ls_ps.yfilter != YFilter.not_set or
                    self.reoptimized_soft_preempted_ls_ps.yfilter != YFilter.not_set or
                    self.soft_preempted_head_ls_ps.yfilter != YFilter.not_set or
                    self.soft_preempted_ls_ps.yfilter != YFilter.not_set or
                    self.soft_preemption_events.yfilter != YFilter.not_set or
                    self.time_in_soft_preempted_state_avg.yfilter != YFilter.not_set or
                    self.time_in_soft_preempted_state_max.yfilter != YFilter.not_set or
                    self.timed_out_soft_preempted_lsp_ss.yfilter != YFilter.not_set or
                    self.torn_down_soft_preempted_ls_ps.yfilter != YFilter.not_set or
                    self.torndown_soft_preempted_ls_ps.yfilter != YFilter.not_set)

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "statistics" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/soft-preemption/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.frr_triggered_soft_preempted_lsp_ss.is_set or self.frr_triggered_soft_preempted_lsp_ss.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.frr_triggered_soft_preempted_lsp_ss.get_name_leafdata())
                if (self.last_cleared_timestamp.is_set or self.last_cleared_timestamp.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.last_cleared_timestamp.get_name_leafdata())
                if (self.minimum_time_in_soft_preempted_state.is_set or self.minimum_time_in_soft_preempted_state.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.minimum_time_in_soft_preempted_state.get_name_leafdata())
                if (self.path_protected_switchover_soft_preempted_ls_ps.is_set or self.path_protected_switchover_soft_preempted_ls_ps.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.path_protected_switchover_soft_preempted_ls_ps.get_name_leafdata())
                if (self.reoptimized_soft_preempted_ls_ps.is_set or self.reoptimized_soft_preempted_ls_ps.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.reoptimized_soft_preempted_ls_ps.get_name_leafdata())
                if (self.soft_preempted_head_ls_ps.is_set or self.soft_preempted_head_ls_ps.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.soft_preempted_head_ls_ps.get_name_leafdata())
                if (self.soft_preempted_ls_ps.is_set or self.soft_preempted_ls_ps.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.soft_preempted_ls_ps.get_name_leafdata())
                if (self.soft_preemption_events.is_set or self.soft_preemption_events.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.soft_preemption_events.get_name_leafdata())
                if (self.time_in_soft_preempted_state_avg.is_set or self.time_in_soft_preempted_state_avg.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.time_in_soft_preempted_state_avg.get_name_leafdata())
                if (self.time_in_soft_preempted_state_max.is_set or self.time_in_soft_preempted_state_max.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.time_in_soft_preempted_state_max.get_name_leafdata())
                if (self.timed_out_soft_preempted_lsp_ss.is_set or self.timed_out_soft_preempted_lsp_ss.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.timed_out_soft_preempted_lsp_ss.get_name_leafdata())
                if (self.torn_down_soft_preempted_ls_ps.is_set or self.torn_down_soft_preempted_ls_ps.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.torn_down_soft_preempted_ls_ps.get_name_leafdata())
                if (self.torndown_soft_preempted_ls_ps.is_set or self.torndown_soft_preempted_ls_ps.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.torndown_soft_preempted_ls_ps.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "frr-triggered-soft-preempted-lsp-ss" or name == "last-cleared-timestamp" or name == "minimum-time-in-soft-preempted-state" or name == "path-protected-switchover-soft-preempted-ls-ps" or name == "reoptimized-soft-preempted-ls-ps" or name == "soft-preempted-head-ls-ps" or name == "soft-preempted-ls-ps" or name == "soft-preemption-events" or name == "time-in-soft-preempted-state-avg" or name == "time-in-soft-preempted-state-max" or name == "timed-out-soft-preempted-lsp-ss" or name == "torn-down-soft-preempted-ls-ps" or name == "torndown-soft-preempted-ls-ps"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "frr-triggered-soft-preempted-lsp-ss"):
                    self.frr_triggered_soft_preempted_lsp_ss = value
                    self.frr_triggered_soft_preempted_lsp_ss.value_namespace = name_space
                    self.frr_triggered_soft_preempted_lsp_ss.value_namespace_prefix = name_space_prefix
                if(value_path == "last-cleared-timestamp"):
                    self.last_cleared_timestamp = value
                    self.last_cleared_timestamp.value_namespace = name_space
                    self.last_cleared_timestamp.value_namespace_prefix = name_space_prefix
                if(value_path == "minimum-time-in-soft-preempted-state"):
                    self.minimum_time_in_soft_preempted_state = value
                    self.minimum_time_in_soft_preempted_state.value_namespace = name_space
                    self.minimum_time_in_soft_preempted_state.value_namespace_prefix = name_space_prefix
                if(value_path == "path-protected-switchover-soft-preempted-ls-ps"):
                    self.path_protected_switchover_soft_preempted_ls_ps = value
                    self.path_protected_switchover_soft_preempted_ls_ps.value_namespace = name_space
                    self.path_protected_switchover_soft_preempted_ls_ps.value_namespace_prefix = name_space_prefix
                if(value_path == "reoptimized-soft-preempted-ls-ps"):
                    self.reoptimized_soft_preempted_ls_ps = value
                    self.reoptimized_soft_preempted_ls_ps.value_namespace = name_space
                    self.reoptimized_soft_preempted_ls_ps.value_namespace_prefix = name_space_prefix
                if(value_path == "soft-preempted-head-ls-ps"):
                    self.soft_preempted_head_ls_ps = value
                    self.soft_preempted_head_ls_ps.value_namespace = name_space
                    self.soft_preempted_head_ls_ps.value_namespace_prefix = name_space_prefix
                if(value_path == "soft-preempted-ls-ps"):
                    self.soft_preempted_ls_ps = value
                    self.soft_preempted_ls_ps.value_namespace = name_space
                    self.soft_preempted_ls_ps.value_namespace_prefix = name_space_prefix
                if(value_path == "soft-preemption-events"):
                    self.soft_preemption_events = value
                    self.soft_preemption_events.value_namespace = name_space
                    self.soft_preemption_events.value_namespace_prefix = name_space_prefix
                if(value_path == "time-in-soft-preempted-state-avg"):
                    self.time_in_soft_preempted_state_avg = value
                    self.time_in_soft_preempted_state_avg.value_namespace = name_space
                    self.time_in_soft_preempted_state_avg.value_namespace_prefix = name_space_prefix
                if(value_path == "time-in-soft-preempted-state-max"):
                    self.time_in_soft_preempted_state_max = value
                    self.time_in_soft_preempted_state_max.value_namespace = name_space
                    self.time_in_soft_preempted_state_max.value_namespace_prefix = name_space_prefix
                if(value_path == "timed-out-soft-preempted-lsp-ss"):
                    self.timed_out_soft_preempted_lsp_ss = value
                    self.timed_out_soft_preempted_lsp_ss.value_namespace = name_space
                    self.timed_out_soft_preempted_lsp_ss.value_namespace_prefix = name_space_prefix
                if(value_path == "torn-down-soft-preempted-ls-ps"):
                    self.torn_down_soft_preempted_ls_ps = value
                    self.torn_down_soft_preempted_ls_ps.value_namespace = name_space
                    self.torn_down_soft_preempted_ls_ps.value_namespace_prefix = name_space_prefix
                if(value_path == "torndown-soft-preempted-ls-ps"):
                    self.torndown_soft_preempted_ls_ps = value
                    self.torndown_soft_preempted_ls_ps.value_namespace = name_space
                    self.torndown_soft_preempted_ls_ps.value_namespace_prefix = name_space_prefix

        def has_data(self):
            return (self.statistics is not None and self.statistics.has_data())

        def has_operation(self):
            return (
                self.yfilter != YFilter.not_set or
                (self.statistics is not None and self.statistics.has_operation()))

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "soft-preemption" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "statistics"):
                if (self.statistics is None):
                    self.statistics = MplsTeStandby.SoftPreemption.Statistics()
                    self.statistics.parent = self
                    self._children_name_map["statistics"] = "statistics"
                return self.statistics

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "statistics"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class ForwardingAdjacencyDestinations(Entity):
        """
        Announced Destination tunnel
        
        .. attribute:: forwarding_adjacency_destination
        
        	Forwarding Adjacencies for a destination
        	**type**\: list of    :py:class:`ForwardingAdjacencyDestination <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.ForwardingAdjacencyDestinations.ForwardingAdjacencyDestination>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsTeStandby.ForwardingAdjacencyDestinations, self).__init__()

            self.yang_name = "forwarding-adjacency-destinations"
            self.yang_parent_name = "mpls-te-standby"

            self.forwarding_adjacency_destination = YList(self)

        def __setattr__(self, name, value):
            self._check_monkey_patching_error(name, value)
            with _handle_type_error():
                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                        "Please use list append or extend method."
                                        .format(value))
                if isinstance(value, Enum.YLeaf):
                    value = value.name
                if name in () and name in self.__dict__:
                    if isinstance(value, YLeaf):
                        self.__dict__[name].set(value.get())
                    elif isinstance(value, YLeafList):
                        super(MplsTeStandby.ForwardingAdjacencyDestinations, self).__setattr__(name, value)
                    else:
                        self.__dict__[name].set(value)
                else:
                    if hasattr(value, "parent") and name != "parent":
                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                            value.parent = self
                        elif value.parent is None and value.yang_name in self._children_yang_names:
                            value.parent = self
                    super(MplsTeStandby.ForwardingAdjacencyDestinations, self).__setattr__(name, value)


        class ForwardingAdjacencyDestination(Entity):
            """
            Forwarding Adjacencies for a destination
            
            .. attribute:: destination_address  <key>
            
            	Destination address
            	**type**\:  str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            .. attribute:: adjacencies
            
            	Number of Forwarding Adjacencies
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: destination_address_xr
            
            	The tunnel destination
            	**type**\:  str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            .. attribute:: forward_adjacency
            
            	Forwarding\-adjacency list
            	**type**\: list of    :py:class:`ForwardAdjacency <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.ForwardingAdjacencyDestinations.ForwardingAdjacencyDestination.ForwardAdjacency>`
            
            .. attribute:: ipv6_adjacencies
            
            	Number of IPv6 Forwarding Adjacencies
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTeStandby.ForwardingAdjacencyDestinations.ForwardingAdjacencyDestination, self).__init__()

                self.yang_name = "forwarding-adjacency-destination"
                self.yang_parent_name = "forwarding-adjacency-destinations"

                self.destination_address = YLeaf(YType.str, "destination-address")

                self.adjacencies = YLeaf(YType.uint32, "adjacencies")

                self.destination_address_xr = YLeaf(YType.str, "destination-address-xr")

                self.ipv6_adjacencies = YLeaf(YType.uint32, "ipv6-adjacencies")

                self.forward_adjacency = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("destination_address",
                                "adjacencies",
                                "destination_address_xr",
                                "ipv6_adjacencies") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTeStandby.ForwardingAdjacencyDestinations.ForwardingAdjacencyDestination, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTeStandby.ForwardingAdjacencyDestinations.ForwardingAdjacencyDestination, self).__setattr__(name, value)


            class ForwardAdjacency(Entity):
                """
                Forwarding\-adjacency list
                
                .. attribute:: hold_time
                
                	Hold time in seconds
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: second
                
                .. attribute:: ig_ps
                
                	List of IGPs to which it is announced
                	**type**\: list of    :py:class:`IgPs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.ForwardingAdjacencyDestinations.ForwardingAdjacencyDestination.ForwardAdjacency.IgPs>`
                
                .. attribute:: is_adjacency_up
                
                	True if adj is up
                	**type**\:  bool
                
                .. attribute:: traffic_share
                
                	Traffic Share
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: tunnel_name
                
                	The tunnel name
                	**type**\:  str
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTeStandby.ForwardingAdjacencyDestinations.ForwardingAdjacencyDestination.ForwardAdjacency, self).__init__()

                    self.yang_name = "forward-adjacency"
                    self.yang_parent_name = "forwarding-adjacency-destination"

                    self.hold_time = YLeaf(YType.uint32, "hold-time")

                    self.is_adjacency_up = YLeaf(YType.boolean, "is-adjacency-up")

                    self.traffic_share = YLeaf(YType.uint32, "traffic-share")

                    self.tunnel_name = YLeaf(YType.str, "tunnel-name")

                    self.ig_ps = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("hold_time",
                                    "is_adjacency_up",
                                    "traffic_share",
                                    "tunnel_name") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTeStandby.ForwardingAdjacencyDestinations.ForwardingAdjacencyDestination.ForwardAdjacency, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTeStandby.ForwardingAdjacencyDestinations.ForwardingAdjacencyDestination.ForwardAdjacency, self).__setattr__(name, value)


                class IgPs(Entity):
                    """
                    List of IGPs to which it is announced
                    
                    .. attribute:: afi
                    
                    	AFI
                    	**type**\:   :py:class:`MplsTeAfi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeAfi>`
                    
                    .. attribute:: igp_area_id
                    
                    	The IGP Instance and Area ID
                    	**type**\:  str
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.ForwardingAdjacencyDestinations.ForwardingAdjacencyDestination.ForwardAdjacency.IgPs, self).__init__()

                        self.yang_name = "ig-ps"
                        self.yang_parent_name = "forward-adjacency"

                        self.afi = YLeaf(YType.enumeration, "afi")

                        self.igp_area_id = YLeaf(YType.str, "igp-area-id")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("afi",
                                        "igp_area_id") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.ForwardingAdjacencyDestinations.ForwardingAdjacencyDestination.ForwardAdjacency.IgPs, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.ForwardingAdjacencyDestinations.ForwardingAdjacencyDestination.ForwardAdjacency.IgPs, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.afi.is_set or
                            self.igp_area_id.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.afi.yfilter != YFilter.not_set or
                            self.igp_area_id.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "ig-ps" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.afi.is_set or self.afi.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.afi.get_name_leafdata())
                        if (self.igp_area_id.is_set or self.igp_area_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.igp_area_id.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "afi" or name == "igp-area-id"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "afi"):
                            self.afi = value
                            self.afi.value_namespace = name_space
                            self.afi.value_namespace_prefix = name_space_prefix
                        if(value_path == "igp-area-id"):
                            self.igp_area_id = value
                            self.igp_area_id.value_namespace = name_space
                            self.igp_area_id.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.ig_ps:
                        if (c.has_data()):
                            return True
                    return (
                        self.hold_time.is_set or
                        self.is_adjacency_up.is_set or
                        self.traffic_share.is_set or
                        self.tunnel_name.is_set)

                def has_operation(self):
                    for c in self.ig_ps:
                        if (c.has_operation()):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        self.hold_time.yfilter != YFilter.not_set or
                        self.is_adjacency_up.yfilter != YFilter.not_set or
                        self.traffic_share.yfilter != YFilter.not_set or
                        self.tunnel_name.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "forward-adjacency" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.hold_time.is_set or self.hold_time.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.hold_time.get_name_leafdata())
                    if (self.is_adjacency_up.is_set or self.is_adjacency_up.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_adjacency_up.get_name_leafdata())
                    if (self.traffic_share.is_set or self.traffic_share.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.traffic_share.get_name_leafdata())
                    if (self.tunnel_name.is_set or self.tunnel_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_name.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "ig-ps"):
                        for c in self.ig_ps:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsTeStandby.ForwardingAdjacencyDestinations.ForwardingAdjacencyDestination.ForwardAdjacency.IgPs()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.ig_ps.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "ig-ps" or name == "hold-time" or name == "is-adjacency-up" or name == "traffic-share" or name == "tunnel-name"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "hold-time"):
                        self.hold_time = value
                        self.hold_time.value_namespace = name_space
                        self.hold_time.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-adjacency-up"):
                        self.is_adjacency_up = value
                        self.is_adjacency_up.value_namespace = name_space
                        self.is_adjacency_up.value_namespace_prefix = name_space_prefix
                    if(value_path == "traffic-share"):
                        self.traffic_share = value
                        self.traffic_share.value_namespace = name_space
                        self.traffic_share.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-name"):
                        self.tunnel_name = value
                        self.tunnel_name.value_namespace = name_space
                        self.tunnel_name.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.forward_adjacency:
                    if (c.has_data()):
                        return True
                return (
                    self.destination_address.is_set or
                    self.adjacencies.is_set or
                    self.destination_address_xr.is_set or
                    self.ipv6_adjacencies.is_set)

            def has_operation(self):
                for c in self.forward_adjacency:
                    if (c.has_operation()):
                        return True
                return (
                    self.yfilter != YFilter.not_set or
                    self.destination_address.yfilter != YFilter.not_set or
                    self.adjacencies.yfilter != YFilter.not_set or
                    self.destination_address_xr.yfilter != YFilter.not_set or
                    self.ipv6_adjacencies.yfilter != YFilter.not_set)

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "forwarding-adjacency-destination" + "[destination-address='" + self.destination_address.get() + "']" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/forwarding-adjacency-destinations/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.destination_address.get_name_leafdata())
                if (self.adjacencies.is_set or self.adjacencies.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.adjacencies.get_name_leafdata())
                if (self.destination_address_xr.is_set or self.destination_address_xr.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.destination_address_xr.get_name_leafdata())
                if (self.ipv6_adjacencies.is_set or self.ipv6_adjacencies.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.ipv6_adjacencies.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "forward-adjacency"):
                    for c in self.forward_adjacency:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTeStandby.ForwardingAdjacencyDestinations.ForwardingAdjacencyDestination.ForwardAdjacency()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.forward_adjacency.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "forward-adjacency" or name == "destination-address" or name == "adjacencies" or name == "destination-address-xr" or name == "ipv6-adjacencies"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "destination-address"):
                    self.destination_address = value
                    self.destination_address.value_namespace = name_space
                    self.destination_address.value_namespace_prefix = name_space_prefix
                if(value_path == "adjacencies"):
                    self.adjacencies = value
                    self.adjacencies.value_namespace = name_space
                    self.adjacencies.value_namespace_prefix = name_space_prefix
                if(value_path == "destination-address-xr"):
                    self.destination_address_xr = value
                    self.destination_address_xr.value_namespace = name_space
                    self.destination_address_xr.value_namespace_prefix = name_space_prefix
                if(value_path == "ipv6-adjacencies"):
                    self.ipv6_adjacencies = value
                    self.ipv6_adjacencies.value_namespace = name_space
                    self.ipv6_adjacencies.value_namespace_prefix = name_space_prefix

        def has_data(self):
            for c in self.forwarding_adjacency_destination:
                if (c.has_data()):
                    return True
            return False

        def has_operation(self):
            for c in self.forwarding_adjacency_destination:
                if (c.has_operation()):
                    return True
            return self.yfilter != YFilter.not_set

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "forwarding-adjacency-destinations" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "forwarding-adjacency-destination"):
                for c in self.forwarding_adjacency_destination:
                    segment = c.get_segment_path()
                    if (segment_path == segment):
                        return c
                c = MplsTeStandby.ForwardingAdjacencyDestinations.ForwardingAdjacencyDestination()
                c.parent = self
                local_reference_key = "ydk::seg::%s" % segment_path
                self._local_refs[local_reference_key] = c
                self.forwarding_adjacency_destination.append(c)
                return c

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "forwarding-adjacency-destination"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class IgpAreas(Entity):
        """
        The set of IGP\-areas known to MPLS\-TE
        
        .. attribute:: igp_area
        
        	An IGP instance
        	**type**\: list of    :py:class:`IgpArea <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.IgpAreas.IgpArea>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsTeStandby.IgpAreas, self).__init__()

            self.yang_name = "igp-areas"
            self.yang_parent_name = "mpls-te-standby"

            self.igp_area = YList(self)

        def __setattr__(self, name, value):
            self._check_monkey_patching_error(name, value)
            with _handle_type_error():
                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                        "Please use list append or extend method."
                                        .format(value))
                if isinstance(value, Enum.YLeaf):
                    value = value.name
                if name in () and name in self.__dict__:
                    if isinstance(value, YLeaf):
                        self.__dict__[name].set(value.get())
                    elif isinstance(value, YLeafList):
                        super(MplsTeStandby.IgpAreas, self).__setattr__(name, value)
                    else:
                        self.__dict__[name].set(value)
                else:
                    if hasattr(value, "parent") and name != "parent":
                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                            value.parent = self
                        elif value.parent is None and value.yang_name in self._children_yang_names:
                            value.parent = self
                    super(MplsTeStandby.IgpAreas, self).__setattr__(name, value)


        class IgpArea(Entity):
            """
            An IGP instance
            
            .. attribute:: protocol  <key>
            
            	The IGP protocol
            	**type**\:   :py:class:`MplsTeIgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeIgpProtocol>`
            
            .. attribute:: process_tag  <key>
            
            	IGP Process Tag
            	**type**\:  str
            
            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
            
            .. attribute:: area
            
            	IGP area information
            	**type**\: list of    :py:class:`Area <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.IgpAreas.IgpArea.Area>`
            
            .. attribute:: configured_te_router_id
            
            	Configured TE router\-id
            	**type**\:  str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            .. attribute:: connection_down_count
            
            	Number of times IGP connection has gone down
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: connection_up_count
            
            	Number of times IGP connection has gone up
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: global_router_id
            
            	Global router\-id
            	**type**\:  str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            .. attribute:: globall_router_id_optical
            
            	Global router\-id for GMPLS (optical TE)
            	**type**\:  str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            .. attribute:: igp_system_id
            
            	 The IGP instance's system/router\-id; interpret appropriately depending on IGP type
            	**type**\:  str
            
            .. attribute:: igp_type
            
            	IGP type
            	**type**\:   :py:class:`IgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpProtocol>`
            
            .. attribute:: in_use_te_router_id
            
            	TE router\-id in use
            	**type**\:  str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            .. attribute:: instance_name
            
            	 The IGP instance name
            	**type**\:  str
            
            .. attribute:: is_connection_up
            
            	Flag to indicate whether the IGP connection is open or not
            	**type**\:  bool
            
            .. attribute:: secondary_router_id
            
            	Secondary router\-ids
            	**type**\: list of    :py:class:`SecondaryRouterId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.IgpAreas.IgpArea.SecondaryRouterId>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTeStandby.IgpAreas.IgpArea, self).__init__()

                self.yang_name = "igp-area"
                self.yang_parent_name = "igp-areas"

                self.protocol = YLeaf(YType.enumeration, "protocol")

                self.process_tag = YLeaf(YType.str, "process-tag")

                self.configured_te_router_id = YLeaf(YType.str, "configured-te-router-id")

                self.connection_down_count = YLeaf(YType.uint32, "connection-down-count")

                self.connection_up_count = YLeaf(YType.uint32, "connection-up-count")

                self.global_router_id = YLeaf(YType.str, "global-router-id")

                self.globall_router_id_optical = YLeaf(YType.str, "globall-router-id-optical")

                self.igp_system_id = YLeaf(YType.str, "igp-system-id")

                self.igp_type = YLeaf(YType.enumeration, "igp-type")

                self.in_use_te_router_id = YLeaf(YType.str, "in-use-te-router-id")

                self.instance_name = YLeaf(YType.str, "instance-name")

                self.is_connection_up = YLeaf(YType.boolean, "is-connection-up")

                self.area = YList(self)
                self.secondary_router_id = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("protocol",
                                "process_tag",
                                "configured_te_router_id",
                                "connection_down_count",
                                "connection_up_count",
                                "global_router_id",
                                "globall_router_id_optical",
                                "igp_system_id",
                                "igp_type",
                                "in_use_te_router_id",
                                "instance_name",
                                "is_connection_up") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTeStandby.IgpAreas.IgpArea, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTeStandby.IgpAreas.IgpArea, self).__setattr__(name, value)


            class SecondaryRouterId(Entity):
                """
                Secondary router\-ids
                
                .. attribute:: entry
                
                	
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTeStandby.IgpAreas.IgpArea.SecondaryRouterId, self).__init__()

                    self.yang_name = "secondary-router-id"
                    self.yang_parent_name = "igp-area"

                    self.entry = YLeaf(YType.str, "entry")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("entry") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTeStandby.IgpAreas.IgpArea.SecondaryRouterId, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTeStandby.IgpAreas.IgpArea.SecondaryRouterId, self).__setattr__(name, value)

                def has_data(self):
                    return self.entry.is_set

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.entry.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "secondary-router-id" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.entry.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "entry"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "entry"):
                        self.entry = value
                        self.entry.value_namespace = name_space
                        self.entry.value_namespace_prefix = name_space_prefix


            class Area(Entity):
                """
                IGP area information
                
                .. attribute:: active_data
                
                	Data which applies only to an active area
                	**type**\:   :py:class:`ActiveData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.IgpAreas.IgpArea.Area.ActiveData>`
                
                .. attribute:: area_format
                
                	IGP Area Format
                	**type**\:   :py:class:`IgpOspfAreaFormat <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpOspfAreaFormat>`
                
                .. attribute:: area_index
                
                	Internal area index
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: area_number
                
                	Area number
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: is_config_ready
                
                	Indicates whether or not the area is correctly configured under the IGP submode to run TE
                	**type**\:  bool
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTeStandby.IgpAreas.IgpArea.Area, self).__init__()

                    self.yang_name = "area"
                    self.yang_parent_name = "igp-area"

                    self.area_format = YLeaf(YType.enumeration, "area-format")

                    self.area_index = YLeaf(YType.uint32, "area-index")

                    self.area_number = YLeaf(YType.uint32, "area-number")

                    self.is_config_ready = YLeaf(YType.boolean, "is-config-ready")

                    self.active_data = MplsTeStandby.IgpAreas.IgpArea.Area.ActiveData()
                    self.active_data.parent = self
                    self._children_name_map["active_data"] = "active-data"
                    self._children_yang_names.add("active-data")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("area_format",
                                    "area_index",
                                    "area_number",
                                    "is_config_ready") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTeStandby.IgpAreas.IgpArea.Area, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTeStandby.IgpAreas.IgpArea.Area, self).__setattr__(name, value)


                class ActiveData(Entity):
                    """
                    Data which applies only to an active area
                    
                    .. attribute:: area_statistics
                    
                    	Area communication statistics
                    	**type**\:   :py:class:`AreaStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.IgpAreas.IgpArea.Area.ActiveData.AreaStatistics>`
                    
                    .. attribute:: interfaces_count
                    
                    	Number of interfaces running over this area
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: link_idt_received
                    
                    	Flag to indicate IDT for link adjacencies was received
                    	**type**\:  bool
                    
                    .. attribute:: p2mp_destination_count
                    
                    	Number of P2MP destinations whose path was calculated over this area
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: p2p_autoroute_announced_count
                    
                    	Number of p2p tunnel heads which have been autoroute\-announced into this area
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: p2p_forwarding_adjacency_count
                    
                    	Number of p2p tunnel heads which have been announced as forwarding adjacencies in this area
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: p2p_heads_count
                    
                    	Number of p2p tunnel heads whose path was calculated over this area
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: sr_strict
                    
                    	Flag to indicate if the area is SR strict
                    	**type**\:  bool
                    
                    .. attribute:: topology_idt_received
                    
                    	Flag to indicate IDT topology was received
                    	**type**\:  bool
                    
                    .. attribute:: tunnel_loose_hops
                    
                    	Number of tunnels with a loose hop ERO expanded in this area
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.IgpAreas.IgpArea.Area.ActiveData, self).__init__()

                        self.yang_name = "active-data"
                        self.yang_parent_name = "area"

                        self.interfaces_count = YLeaf(YType.uint32, "interfaces-count")

                        self.link_idt_received = YLeaf(YType.boolean, "link-idt-received")

                        self.p2mp_destination_count = YLeaf(YType.uint32, "p2mp-destination-count")

                        self.p2p_autoroute_announced_count = YLeaf(YType.uint32, "p2p-autoroute-announced-count")

                        self.p2p_forwarding_adjacency_count = YLeaf(YType.uint32, "p2p-forwarding-adjacency-count")

                        self.p2p_heads_count = YLeaf(YType.uint32, "p2p-heads-count")

                        self.sr_strict = YLeaf(YType.boolean, "sr-strict")

                        self.topology_idt_received = YLeaf(YType.boolean, "topology-idt-received")

                        self.tunnel_loose_hops = YLeaf(YType.uint32, "tunnel-loose-hops")

                        self.area_statistics = MplsTeStandby.IgpAreas.IgpArea.Area.ActiveData.AreaStatistics()
                        self.area_statistics.parent = self
                        self._children_name_map["area_statistics"] = "area-statistics"
                        self._children_yang_names.add("area-statistics")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("interfaces_count",
                                        "link_idt_received",
                                        "p2mp_destination_count",
                                        "p2p_autoroute_announced_count",
                                        "p2p_forwarding_adjacency_count",
                                        "p2p_heads_count",
                                        "sr_strict",
                                        "topology_idt_received",
                                        "tunnel_loose_hops") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.IgpAreas.IgpArea.Area.ActiveData, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.IgpAreas.IgpArea.Area.ActiveData, self).__setattr__(name, value)


                    class AreaStatistics(Entity):
                        """
                        Area communication statistics
                        
                        .. attribute:: area_adjacency_announce_messages
                        
                        	Number of adjacency announcement messages received
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: area_adjacency_request_messages
                        
                        	Number of adjacency request messages sent
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: area_flood_messages
                        
                        	Number of local LSA floods sent
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: area_lsa_announce_messages
                        
                        	Number of LSA announcement messages received
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: area_lsa_delete_messages
                        
                        	Number of LSA delete messages received
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: area_lsa_fragment_announce_messages
                        
                        	Number of LSA fragment announcement messages received
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: area_lsa_fragment_delete_messages
                        
                        	Number of LSA fragment delete messages received
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: area_tunnel_announce_messages
                        
                        	Number of tunnel announcement messages sent
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.IgpAreas.IgpArea.Area.ActiveData.AreaStatistics, self).__init__()

                            self.yang_name = "area-statistics"
                            self.yang_parent_name = "active-data"

                            self.area_adjacency_announce_messages = YLeaf(YType.uint32, "area-adjacency-announce-messages")

                            self.area_adjacency_request_messages = YLeaf(YType.uint32, "area-adjacency-request-messages")

                            self.area_flood_messages = YLeaf(YType.uint32, "area-flood-messages")

                            self.area_lsa_announce_messages = YLeaf(YType.uint32, "area-lsa-announce-messages")

                            self.area_lsa_delete_messages = YLeaf(YType.uint32, "area-lsa-delete-messages")

                            self.area_lsa_fragment_announce_messages = YLeaf(YType.uint32, "area-lsa-fragment-announce-messages")

                            self.area_lsa_fragment_delete_messages = YLeaf(YType.uint32, "area-lsa-fragment-delete-messages")

                            self.area_tunnel_announce_messages = YLeaf(YType.uint32, "area-tunnel-announce-messages")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("area_adjacency_announce_messages",
                                            "area_adjacency_request_messages",
                                            "area_flood_messages",
                                            "area_lsa_announce_messages",
                                            "area_lsa_delete_messages",
                                            "area_lsa_fragment_announce_messages",
                                            "area_lsa_fragment_delete_messages",
                                            "area_tunnel_announce_messages") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.IgpAreas.IgpArea.Area.ActiveData.AreaStatistics, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.IgpAreas.IgpArea.Area.ActiveData.AreaStatistics, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.area_adjacency_announce_messages.is_set or
                                self.area_adjacency_request_messages.is_set or
                                self.area_flood_messages.is_set or
                                self.area_lsa_announce_messages.is_set or
                                self.area_lsa_delete_messages.is_set or
                                self.area_lsa_fragment_announce_messages.is_set or
                                self.area_lsa_fragment_delete_messages.is_set or
                                self.area_tunnel_announce_messages.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.area_adjacency_announce_messages.yfilter != YFilter.not_set or
                                self.area_adjacency_request_messages.yfilter != YFilter.not_set or
                                self.area_flood_messages.yfilter != YFilter.not_set or
                                self.area_lsa_announce_messages.yfilter != YFilter.not_set or
                                self.area_lsa_delete_messages.yfilter != YFilter.not_set or
                                self.area_lsa_fragment_announce_messages.yfilter != YFilter.not_set or
                                self.area_lsa_fragment_delete_messages.yfilter != YFilter.not_set or
                                self.area_tunnel_announce_messages.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "area-statistics" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.area_adjacency_announce_messages.is_set or self.area_adjacency_announce_messages.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.area_adjacency_announce_messages.get_name_leafdata())
                            if (self.area_adjacency_request_messages.is_set or self.area_adjacency_request_messages.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.area_adjacency_request_messages.get_name_leafdata())
                            if (self.area_flood_messages.is_set or self.area_flood_messages.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.area_flood_messages.get_name_leafdata())
                            if (self.area_lsa_announce_messages.is_set or self.area_lsa_announce_messages.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.area_lsa_announce_messages.get_name_leafdata())
                            if (self.area_lsa_delete_messages.is_set or self.area_lsa_delete_messages.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.area_lsa_delete_messages.get_name_leafdata())
                            if (self.area_lsa_fragment_announce_messages.is_set or self.area_lsa_fragment_announce_messages.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.area_lsa_fragment_announce_messages.get_name_leafdata())
                            if (self.area_lsa_fragment_delete_messages.is_set or self.area_lsa_fragment_delete_messages.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.area_lsa_fragment_delete_messages.get_name_leafdata())
                            if (self.area_tunnel_announce_messages.is_set or self.area_tunnel_announce_messages.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.area_tunnel_announce_messages.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "area-adjacency-announce-messages" or name == "area-adjacency-request-messages" or name == "area-flood-messages" or name == "area-lsa-announce-messages" or name == "area-lsa-delete-messages" or name == "area-lsa-fragment-announce-messages" or name == "area-lsa-fragment-delete-messages" or name == "area-tunnel-announce-messages"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "area-adjacency-announce-messages"):
                                self.area_adjacency_announce_messages = value
                                self.area_adjacency_announce_messages.value_namespace = name_space
                                self.area_adjacency_announce_messages.value_namespace_prefix = name_space_prefix
                            if(value_path == "area-adjacency-request-messages"):
                                self.area_adjacency_request_messages = value
                                self.area_adjacency_request_messages.value_namespace = name_space
                                self.area_adjacency_request_messages.value_namespace_prefix = name_space_prefix
                            if(value_path == "area-flood-messages"):
                                self.area_flood_messages = value
                                self.area_flood_messages.value_namespace = name_space
                                self.area_flood_messages.value_namespace_prefix = name_space_prefix
                            if(value_path == "area-lsa-announce-messages"):
                                self.area_lsa_announce_messages = value
                                self.area_lsa_announce_messages.value_namespace = name_space
                                self.area_lsa_announce_messages.value_namespace_prefix = name_space_prefix
                            if(value_path == "area-lsa-delete-messages"):
                                self.area_lsa_delete_messages = value
                                self.area_lsa_delete_messages.value_namespace = name_space
                                self.area_lsa_delete_messages.value_namespace_prefix = name_space_prefix
                            if(value_path == "area-lsa-fragment-announce-messages"):
                                self.area_lsa_fragment_announce_messages = value
                                self.area_lsa_fragment_announce_messages.value_namespace = name_space
                                self.area_lsa_fragment_announce_messages.value_namespace_prefix = name_space_prefix
                            if(value_path == "area-lsa-fragment-delete-messages"):
                                self.area_lsa_fragment_delete_messages = value
                                self.area_lsa_fragment_delete_messages.value_namespace = name_space
                                self.area_lsa_fragment_delete_messages.value_namespace_prefix = name_space_prefix
                            if(value_path == "area-tunnel-announce-messages"):
                                self.area_tunnel_announce_messages = value
                                self.area_tunnel_announce_messages.value_namespace = name_space
                                self.area_tunnel_announce_messages.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.interfaces_count.is_set or
                            self.link_idt_received.is_set or
                            self.p2mp_destination_count.is_set or
                            self.p2p_autoroute_announced_count.is_set or
                            self.p2p_forwarding_adjacency_count.is_set or
                            self.p2p_heads_count.is_set or
                            self.sr_strict.is_set or
                            self.topology_idt_received.is_set or
                            self.tunnel_loose_hops.is_set or
                            (self.area_statistics is not None and self.area_statistics.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.interfaces_count.yfilter != YFilter.not_set or
                            self.link_idt_received.yfilter != YFilter.not_set or
                            self.p2mp_destination_count.yfilter != YFilter.not_set or
                            self.p2p_autoroute_announced_count.yfilter != YFilter.not_set or
                            self.p2p_forwarding_adjacency_count.yfilter != YFilter.not_set or
                            self.p2p_heads_count.yfilter != YFilter.not_set or
                            self.sr_strict.yfilter != YFilter.not_set or
                            self.topology_idt_received.yfilter != YFilter.not_set or
                            self.tunnel_loose_hops.yfilter != YFilter.not_set or
                            (self.area_statistics is not None and self.area_statistics.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "active-data" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.interfaces_count.is_set or self.interfaces_count.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.interfaces_count.get_name_leafdata())
                        if (self.link_idt_received.is_set or self.link_idt_received.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.link_idt_received.get_name_leafdata())
                        if (self.p2mp_destination_count.is_set or self.p2mp_destination_count.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.p2mp_destination_count.get_name_leafdata())
                        if (self.p2p_autoroute_announced_count.is_set or self.p2p_autoroute_announced_count.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.p2p_autoroute_announced_count.get_name_leafdata())
                        if (self.p2p_forwarding_adjacency_count.is_set or self.p2p_forwarding_adjacency_count.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.p2p_forwarding_adjacency_count.get_name_leafdata())
                        if (self.p2p_heads_count.is_set or self.p2p_heads_count.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.p2p_heads_count.get_name_leafdata())
                        if (self.sr_strict.is_set or self.sr_strict.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.sr_strict.get_name_leafdata())
                        if (self.topology_idt_received.is_set or self.topology_idt_received.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.topology_idt_received.get_name_leafdata())
                        if (self.tunnel_loose_hops.is_set or self.tunnel_loose_hops.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tunnel_loose_hops.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "area-statistics"):
                            if (self.area_statistics is None):
                                self.area_statistics = MplsTeStandby.IgpAreas.IgpArea.Area.ActiveData.AreaStatistics()
                                self.area_statistics.parent = self
                                self._children_name_map["area_statistics"] = "area-statistics"
                            return self.area_statistics

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "area-statistics" or name == "interfaces-count" or name == "link-idt-received" or name == "p2mp-destination-count" or name == "p2p-autoroute-announced-count" or name == "p2p-forwarding-adjacency-count" or name == "p2p-heads-count" or name == "sr-strict" or name == "topology-idt-received" or name == "tunnel-loose-hops"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "interfaces-count"):
                            self.interfaces_count = value
                            self.interfaces_count.value_namespace = name_space
                            self.interfaces_count.value_namespace_prefix = name_space_prefix
                        if(value_path == "link-idt-received"):
                            self.link_idt_received = value
                            self.link_idt_received.value_namespace = name_space
                            self.link_idt_received.value_namespace_prefix = name_space_prefix
                        if(value_path == "p2mp-destination-count"):
                            self.p2mp_destination_count = value
                            self.p2mp_destination_count.value_namespace = name_space
                            self.p2mp_destination_count.value_namespace_prefix = name_space_prefix
                        if(value_path == "p2p-autoroute-announced-count"):
                            self.p2p_autoroute_announced_count = value
                            self.p2p_autoroute_announced_count.value_namespace = name_space
                            self.p2p_autoroute_announced_count.value_namespace_prefix = name_space_prefix
                        if(value_path == "p2p-forwarding-adjacency-count"):
                            self.p2p_forwarding_adjacency_count = value
                            self.p2p_forwarding_adjacency_count.value_namespace = name_space
                            self.p2p_forwarding_adjacency_count.value_namespace_prefix = name_space_prefix
                        if(value_path == "p2p-heads-count"):
                            self.p2p_heads_count = value
                            self.p2p_heads_count.value_namespace = name_space
                            self.p2p_heads_count.value_namespace_prefix = name_space_prefix
                        if(value_path == "sr-strict"):
                            self.sr_strict = value
                            self.sr_strict.value_namespace = name_space
                            self.sr_strict.value_namespace_prefix = name_space_prefix
                        if(value_path == "topology-idt-received"):
                            self.topology_idt_received = value
                            self.topology_idt_received.value_namespace = name_space
                            self.topology_idt_received.value_namespace_prefix = name_space_prefix
                        if(value_path == "tunnel-loose-hops"):
                            self.tunnel_loose_hops = value
                            self.tunnel_loose_hops.value_namespace = name_space
                            self.tunnel_loose_hops.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    return (
                        self.area_format.is_set or
                        self.area_index.is_set or
                        self.area_number.is_set or
                        self.is_config_ready.is_set or
                        (self.active_data is not None and self.active_data.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.area_format.yfilter != YFilter.not_set or
                        self.area_index.yfilter != YFilter.not_set or
                        self.area_number.yfilter != YFilter.not_set or
                        self.is_config_ready.yfilter != YFilter.not_set or
                        (self.active_data is not None and self.active_data.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "area" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.area_format.is_set or self.area_format.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.area_format.get_name_leafdata())
                    if (self.area_index.is_set or self.area_index.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.area_index.get_name_leafdata())
                    if (self.area_number.is_set or self.area_number.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.area_number.get_name_leafdata())
                    if (self.is_config_ready.is_set or self.is_config_ready.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_config_ready.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "active-data"):
                        if (self.active_data is None):
                            self.active_data = MplsTeStandby.IgpAreas.IgpArea.Area.ActiveData()
                            self.active_data.parent = self
                            self._children_name_map["active_data"] = "active-data"
                        return self.active_data

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "active-data" or name == "area-format" or name == "area-index" or name == "area-number" or name == "is-config-ready"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "area-format"):
                        self.area_format = value
                        self.area_format.value_namespace = name_space
                        self.area_format.value_namespace_prefix = name_space_prefix
                    if(value_path == "area-index"):
                        self.area_index = value
                        self.area_index.value_namespace = name_space
                        self.area_index.value_namespace_prefix = name_space_prefix
                    if(value_path == "area-number"):
                        self.area_number = value
                        self.area_number.value_namespace = name_space
                        self.area_number.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-config-ready"):
                        self.is_config_ready = value
                        self.is_config_ready.value_namespace = name_space
                        self.is_config_ready.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.area:
                    if (c.has_data()):
                        return True
                for c in self.secondary_router_id:
                    if (c.has_data()):
                        return True
                return (
                    self.protocol.is_set or
                    self.process_tag.is_set or
                    self.configured_te_router_id.is_set or
                    self.connection_down_count.is_set or
                    self.connection_up_count.is_set or
                    self.global_router_id.is_set or
                    self.globall_router_id_optical.is_set or
                    self.igp_system_id.is_set or
                    self.igp_type.is_set or
                    self.in_use_te_router_id.is_set or
                    self.instance_name.is_set or
                    self.is_connection_up.is_set)

            def has_operation(self):
                for c in self.area:
                    if (c.has_operation()):
                        return True
                for c in self.secondary_router_id:
                    if (c.has_operation()):
                        return True
                return (
                    self.yfilter != YFilter.not_set or
                    self.protocol.yfilter != YFilter.not_set or
                    self.process_tag.yfilter != YFilter.not_set or
                    self.configured_te_router_id.yfilter != YFilter.not_set or
                    self.connection_down_count.yfilter != YFilter.not_set or
                    self.connection_up_count.yfilter != YFilter.not_set or
                    self.global_router_id.yfilter != YFilter.not_set or
                    self.globall_router_id_optical.yfilter != YFilter.not_set or
                    self.igp_system_id.yfilter != YFilter.not_set or
                    self.igp_type.yfilter != YFilter.not_set or
                    self.in_use_te_router_id.yfilter != YFilter.not_set or
                    self.instance_name.yfilter != YFilter.not_set or
                    self.is_connection_up.yfilter != YFilter.not_set)

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "igp-area" + "[protocol='" + self.protocol.get() + "']" + "[process-tag='" + self.process_tag.get() + "']" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/igp-areas/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.protocol.is_set or self.protocol.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.protocol.get_name_leafdata())
                if (self.process_tag.is_set or self.process_tag.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.process_tag.get_name_leafdata())
                if (self.configured_te_router_id.is_set or self.configured_te_router_id.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.configured_te_router_id.get_name_leafdata())
                if (self.connection_down_count.is_set or self.connection_down_count.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.connection_down_count.get_name_leafdata())
                if (self.connection_up_count.is_set or self.connection_up_count.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.connection_up_count.get_name_leafdata())
                if (self.global_router_id.is_set or self.global_router_id.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.global_router_id.get_name_leafdata())
                if (self.globall_router_id_optical.is_set or self.globall_router_id_optical.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.globall_router_id_optical.get_name_leafdata())
                if (self.igp_system_id.is_set or self.igp_system_id.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.igp_system_id.get_name_leafdata())
                if (self.igp_type.is_set or self.igp_type.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.igp_type.get_name_leafdata())
                if (self.in_use_te_router_id.is_set or self.in_use_te_router_id.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.in_use_te_router_id.get_name_leafdata())
                if (self.instance_name.is_set or self.instance_name.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.instance_name.get_name_leafdata())
                if (self.is_connection_up.is_set or self.is_connection_up.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.is_connection_up.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "area"):
                    for c in self.area:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTeStandby.IgpAreas.IgpArea.Area()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.area.append(c)
                    return c

                if (child_yang_name == "secondary-router-id"):
                    for c in self.secondary_router_id:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTeStandby.IgpAreas.IgpArea.SecondaryRouterId()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.secondary_router_id.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "area" or name == "secondary-router-id" or name == "protocol" or name == "process-tag" or name == "configured-te-router-id" or name == "connection-down-count" or name == "connection-up-count" or name == "global-router-id" or name == "globall-router-id-optical" or name == "igp-system-id" or name == "igp-type" or name == "in-use-te-router-id" or name == "instance-name" or name == "is-connection-up"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "protocol"):
                    self.protocol = value
                    self.protocol.value_namespace = name_space
                    self.protocol.value_namespace_prefix = name_space_prefix
                if(value_path == "process-tag"):
                    self.process_tag = value
                    self.process_tag.value_namespace = name_space
                    self.process_tag.value_namespace_prefix = name_space_prefix
                if(value_path == "configured-te-router-id"):
                    self.configured_te_router_id = value
                    self.configured_te_router_id.value_namespace = name_space
                    self.configured_te_router_id.value_namespace_prefix = name_space_prefix
                if(value_path == "connection-down-count"):
                    self.connection_down_count = value
                    self.connection_down_count.value_namespace = name_space
                    self.connection_down_count.value_namespace_prefix = name_space_prefix
                if(value_path == "connection-up-count"):
                    self.connection_up_count = value
                    self.connection_up_count.value_namespace = name_space
                    self.connection_up_count.value_namespace_prefix = name_space_prefix
                if(value_path == "global-router-id"):
                    self.global_router_id = value
                    self.global_router_id.value_namespace = name_space
                    self.global_router_id.value_namespace_prefix = name_space_prefix
                if(value_path == "globall-router-id-optical"):
                    self.globall_router_id_optical = value
                    self.globall_router_id_optical.value_namespace = name_space
                    self.globall_router_id_optical.value_namespace_prefix = name_space_prefix
                if(value_path == "igp-system-id"):
                    self.igp_system_id = value
                    self.igp_system_id.value_namespace = name_space
                    self.igp_system_id.value_namespace_prefix = name_space_prefix
                if(value_path == "igp-type"):
                    self.igp_type = value
                    self.igp_type.value_namespace = name_space
                    self.igp_type.value_namespace_prefix = name_space_prefix
                if(value_path == "in-use-te-router-id"):
                    self.in_use_te_router_id = value
                    self.in_use_te_router_id.value_namespace = name_space
                    self.in_use_te_router_id.value_namespace_prefix = name_space_prefix
                if(value_path == "instance-name"):
                    self.instance_name = value
                    self.instance_name.value_namespace = name_space
                    self.instance_name.value_namespace_prefix = name_space_prefix
                if(value_path == "is-connection-up"):
                    self.is_connection_up = value
                    self.is_connection_up.value_namespace = name_space
                    self.is_connection_up.value_namespace_prefix = name_space_prefix

        def has_data(self):
            for c in self.igp_area:
                if (c.has_data()):
                    return True
            return False

        def has_operation(self):
            for c in self.igp_area:
                if (c.has_operation()):
                    return True
            return self.yfilter != YFilter.not_set

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "igp-areas" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "igp-area"):
                for c in self.igp_area:
                    segment = c.get_segment_path()
                    if (segment_path == segment):
                        return c
                c = MplsTeStandby.IgpAreas.IgpArea()
                c.parent = self
                local_reference_key = "ydk::seg::%s" % segment_path
                self._local_refs[local_reference_key] = c
                self.igp_area.append(c)
                return c

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "igp-area"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class WrapProtection(Entity):
        """
        Represent all the LSP Wrap Protection info in
        MPLS\-TE
        
        .. attribute:: protected_lsps
        
        	The set of wrap protected LSPs available in MPLS\-TE
        	**type**\:   :py:class:`ProtectedLsps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.WrapProtection.ProtectedLsps>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsTeStandby.WrapProtection, self).__init__()

            self.yang_name = "wrap-protection"
            self.yang_parent_name = "mpls-te-standby"

            self.protected_lsps = MplsTeStandby.WrapProtection.ProtectedLsps()
            self.protected_lsps.parent = self
            self._children_name_map["protected_lsps"] = "protected-lsps"
            self._children_yang_names.add("protected-lsps")


        class ProtectedLsps(Entity):
            """
            The set of wrap protected LSPs available in
            MPLS\-TE
            
            .. attribute:: protected_lsp
            
            	Wrap protection info for a given protected LSP
            	**type**\: list of    :py:class:`ProtectedLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.WrapProtection.ProtectedLsps.ProtectedLsp>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTeStandby.WrapProtection.ProtectedLsps, self).__init__()

                self.yang_name = "protected-lsps"
                self.yang_parent_name = "wrap-protection"

                self.protected_lsp = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTeStandby.WrapProtection.ProtectedLsps, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTeStandby.WrapProtection.ProtectedLsps, self).__setattr__(name, value)


            class ProtectedLsp(Entity):
                """
                Wrap protection info for a given protected LSP
                
                .. attribute:: source_address  <key>
                
                	Source Address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: destination_address  <key>
                
                	Destination Address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: tunnel_id  <key>
                
                	Tunnel ID
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: extended_tunnel_id  <key>
                
                	Extended Tunnel ID
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: lsp_id  <key>
                
                	LSP ID
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: sub_group_id  <key>
                
                	Subgroup ID
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: sub_group_originator  <key>
                
                	Subgroup Orig ID
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: p2mp_id  <key>
                
                	P2MP ID
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: session_type  <key>
                
                	Session Type
                	**type**\:   :py:class:`Ctype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.Ctype>`
                
                .. attribute:: destination_address_xr
                
                	Destination
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: extended_tunnel_id_xr
                
                	Extended Tunnel ID
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: lsp_wrap_protection_enable
                
                	LSP Wrap protection enabled
                	**type**\:  bool
                
                .. attribute:: lsp_wrap_protection_label
                
                	LSP Wrap Merge Point Label
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: lsp_wrap_protection_state
                
                	LSP wrap protection state
                	**type**\:   :py:class:`MplsTeLspWrapState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspWrapState>`
                
                .. attribute:: p2mp_id_xr
                
                	S2L P2MP ID
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: reverse_egress_interface
                
                	Reverse Egress Interface
                	**type**\:  str
                
                .. attribute:: reverse_lsp_label
                
                	Reverse LSP label
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: source_address_xr
                
                	Source
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: sub_group_id_xr
                
                	S2L Sub\-Group ID
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: sub_group_original_id
                
                	S2L Sub\-Group Originator ID
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: tunnel_id_xr
                
                	Tunnel ID
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: tunnel_instance
                
                	Tunnel instance
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: tunnel_name
                
                	Tunnel Name
                	**type**\:  str
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTeStandby.WrapProtection.ProtectedLsps.ProtectedLsp, self).__init__()

                    self.yang_name = "protected-lsp"
                    self.yang_parent_name = "protected-lsps"

                    self.source_address = YLeaf(YType.str, "source-address")

                    self.destination_address = YLeaf(YType.str, "destination-address")

                    self.tunnel_id = YLeaf(YType.int32, "tunnel-id")

                    self.extended_tunnel_id = YLeaf(YType.str, "extended-tunnel-id")

                    self.lsp_id = YLeaf(YType.int32, "lsp-id")

                    self.sub_group_id = YLeaf(YType.int32, "sub-group-id")

                    self.sub_group_originator = YLeaf(YType.str, "sub-group-originator")

                    self.p2mp_id = YLeaf(YType.int32, "p2mp-id")

                    self.session_type = YLeaf(YType.enumeration, "session-type")

                    self.destination_address_xr = YLeaf(YType.str, "destination-address-xr")

                    self.extended_tunnel_id_xr = YLeaf(YType.str, "extended-tunnel-id-xr")

                    self.lsp_wrap_protection_enable = YLeaf(YType.boolean, "lsp-wrap-protection-enable")

                    self.lsp_wrap_protection_label = YLeaf(YType.uint32, "lsp-wrap-protection-label")

                    self.lsp_wrap_protection_state = YLeaf(YType.enumeration, "lsp-wrap-protection-state")

                    self.p2mp_id_xr = YLeaf(YType.uint32, "p2mp-id-xr")

                    self.reverse_egress_interface = YLeaf(YType.str, "reverse-egress-interface")

                    self.reverse_lsp_label = YLeaf(YType.uint32, "reverse-lsp-label")

                    self.source_address_xr = YLeaf(YType.str, "source-address-xr")

                    self.sub_group_id_xr = YLeaf(YType.uint16, "sub-group-id-xr")

                    self.sub_group_original_id = YLeaf(YType.str, "sub-group-original-id")

                    self.tunnel_id_xr = YLeaf(YType.uint16, "tunnel-id-xr")

                    self.tunnel_instance = YLeaf(YType.uint32, "tunnel-instance")

                    self.tunnel_name = YLeaf(YType.str, "tunnel-name")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("source_address",
                                    "destination_address",
                                    "tunnel_id",
                                    "extended_tunnel_id",
                                    "lsp_id",
                                    "sub_group_id",
                                    "sub_group_originator",
                                    "p2mp_id",
                                    "session_type",
                                    "destination_address_xr",
                                    "extended_tunnel_id_xr",
                                    "lsp_wrap_protection_enable",
                                    "lsp_wrap_protection_label",
                                    "lsp_wrap_protection_state",
                                    "p2mp_id_xr",
                                    "reverse_egress_interface",
                                    "reverse_lsp_label",
                                    "source_address_xr",
                                    "sub_group_id_xr",
                                    "sub_group_original_id",
                                    "tunnel_id_xr",
                                    "tunnel_instance",
                                    "tunnel_name") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTeStandby.WrapProtection.ProtectedLsps.ProtectedLsp, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTeStandby.WrapProtection.ProtectedLsps.ProtectedLsp, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.source_address.is_set or
                        self.destination_address.is_set or
                        self.tunnel_id.is_set or
                        self.extended_tunnel_id.is_set or
                        self.lsp_id.is_set or
                        self.sub_group_id.is_set or
                        self.sub_group_originator.is_set or
                        self.p2mp_id.is_set or
                        self.session_type.is_set or
                        self.destination_address_xr.is_set or
                        self.extended_tunnel_id_xr.is_set or
                        self.lsp_wrap_protection_enable.is_set or
                        self.lsp_wrap_protection_label.is_set or
                        self.lsp_wrap_protection_state.is_set or
                        self.p2mp_id_xr.is_set or
                        self.reverse_egress_interface.is_set or
                        self.reverse_lsp_label.is_set or
                        self.source_address_xr.is_set or
                        self.sub_group_id_xr.is_set or
                        self.sub_group_original_id.is_set or
                        self.tunnel_id_xr.is_set or
                        self.tunnel_instance.is_set or
                        self.tunnel_name.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.source_address.yfilter != YFilter.not_set or
                        self.destination_address.yfilter != YFilter.not_set or
                        self.tunnel_id.yfilter != YFilter.not_set or
                        self.extended_tunnel_id.yfilter != YFilter.not_set or
                        self.lsp_id.yfilter != YFilter.not_set or
                        self.sub_group_id.yfilter != YFilter.not_set or
                        self.sub_group_originator.yfilter != YFilter.not_set or
                        self.p2mp_id.yfilter != YFilter.not_set or
                        self.session_type.yfilter != YFilter.not_set or
                        self.destination_address_xr.yfilter != YFilter.not_set or
                        self.extended_tunnel_id_xr.yfilter != YFilter.not_set or
                        self.lsp_wrap_protection_enable.yfilter != YFilter.not_set or
                        self.lsp_wrap_protection_label.yfilter != YFilter.not_set or
                        self.lsp_wrap_protection_state.yfilter != YFilter.not_set or
                        self.p2mp_id_xr.yfilter != YFilter.not_set or
                        self.reverse_egress_interface.yfilter != YFilter.not_set or
                        self.reverse_lsp_label.yfilter != YFilter.not_set or
                        self.source_address_xr.yfilter != YFilter.not_set or
                        self.sub_group_id_xr.yfilter != YFilter.not_set or
                        self.sub_group_original_id.yfilter != YFilter.not_set or
                        self.tunnel_id_xr.yfilter != YFilter.not_set or
                        self.tunnel_instance.yfilter != YFilter.not_set or
                        self.tunnel_name.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "protected-lsp" + "[source-address='" + self.source_address.get() + "']" + "[destination-address='" + self.destination_address.get() + "']" + "[tunnel-id='" + self.tunnel_id.get() + "']" + "[extended-tunnel-id='" + self.extended_tunnel_id.get() + "']" + "[lsp-id='" + self.lsp_id.get() + "']" + "[sub-group-id='" + self.sub_group_id.get() + "']" + "[sub-group-originator='" + self.sub_group_originator.get() + "']" + "[p2mp-id='" + self.p2mp_id.get() + "']" + "[session-type='" + self.session_type.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/wrap-protection/protected-lsps/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.source_address.is_set or self.source_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.source_address.get_name_leafdata())
                    if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.destination_address.get_name_leafdata())
                    if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_id.get_name_leafdata())
                    if (self.extended_tunnel_id.is_set or self.extended_tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.extended_tunnel_id.get_name_leafdata())
                    if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.lsp_id.get_name_leafdata())
                    if (self.sub_group_id.is_set or self.sub_group_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.sub_group_id.get_name_leafdata())
                    if (self.sub_group_originator.is_set or self.sub_group_originator.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.sub_group_originator.get_name_leafdata())
                    if (self.p2mp_id.is_set or self.p2mp_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.p2mp_id.get_name_leafdata())
                    if (self.session_type.is_set or self.session_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.session_type.get_name_leafdata())
                    if (self.destination_address_xr.is_set or self.destination_address_xr.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.destination_address_xr.get_name_leafdata())
                    if (self.extended_tunnel_id_xr.is_set or self.extended_tunnel_id_xr.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.extended_tunnel_id_xr.get_name_leafdata())
                    if (self.lsp_wrap_protection_enable.is_set or self.lsp_wrap_protection_enable.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.lsp_wrap_protection_enable.get_name_leafdata())
                    if (self.lsp_wrap_protection_label.is_set or self.lsp_wrap_protection_label.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.lsp_wrap_protection_label.get_name_leafdata())
                    if (self.lsp_wrap_protection_state.is_set or self.lsp_wrap_protection_state.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.lsp_wrap_protection_state.get_name_leafdata())
                    if (self.p2mp_id_xr.is_set or self.p2mp_id_xr.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.p2mp_id_xr.get_name_leafdata())
                    if (self.reverse_egress_interface.is_set or self.reverse_egress_interface.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.reverse_egress_interface.get_name_leafdata())
                    if (self.reverse_lsp_label.is_set or self.reverse_lsp_label.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.reverse_lsp_label.get_name_leafdata())
                    if (self.source_address_xr.is_set or self.source_address_xr.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.source_address_xr.get_name_leafdata())
                    if (self.sub_group_id_xr.is_set or self.sub_group_id_xr.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.sub_group_id_xr.get_name_leafdata())
                    if (self.sub_group_original_id.is_set or self.sub_group_original_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.sub_group_original_id.get_name_leafdata())
                    if (self.tunnel_id_xr.is_set or self.tunnel_id_xr.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_id_xr.get_name_leafdata())
                    if (self.tunnel_instance.is_set or self.tunnel_instance.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_instance.get_name_leafdata())
                    if (self.tunnel_name.is_set or self.tunnel_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_name.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "source-address" or name == "destination-address" or name == "tunnel-id" or name == "extended-tunnel-id" or name == "lsp-id" or name == "sub-group-id" or name == "sub-group-originator" or name == "p2mp-id" or name == "session-type" or name == "destination-address-xr" or name == "extended-tunnel-id-xr" or name == "lsp-wrap-protection-enable" or name == "lsp-wrap-protection-label" or name == "lsp-wrap-protection-state" or name == "p2mp-id-xr" or name == "reverse-egress-interface" or name == "reverse-lsp-label" or name == "source-address-xr" or name == "sub-group-id-xr" or name == "sub-group-original-id" or name == "tunnel-id-xr" or name == "tunnel-instance" or name == "tunnel-name"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "source-address"):
                        self.source_address = value
                        self.source_address.value_namespace = name_space
                        self.source_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "destination-address"):
                        self.destination_address = value
                        self.destination_address.value_namespace = name_space
                        self.destination_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-id"):
                        self.tunnel_id = value
                        self.tunnel_id.value_namespace = name_space
                        self.tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "extended-tunnel-id"):
                        self.extended_tunnel_id = value
                        self.extended_tunnel_id.value_namespace = name_space
                        self.extended_tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "lsp-id"):
                        self.lsp_id = value
                        self.lsp_id.value_namespace = name_space
                        self.lsp_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "sub-group-id"):
                        self.sub_group_id = value
                        self.sub_group_id.value_namespace = name_space
                        self.sub_group_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "sub-group-originator"):
                        self.sub_group_originator = value
                        self.sub_group_originator.value_namespace = name_space
                        self.sub_group_originator.value_namespace_prefix = name_space_prefix
                    if(value_path == "p2mp-id"):
                        self.p2mp_id = value
                        self.p2mp_id.value_namespace = name_space
                        self.p2mp_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "session-type"):
                        self.session_type = value
                        self.session_type.value_namespace = name_space
                        self.session_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "destination-address-xr"):
                        self.destination_address_xr = value
                        self.destination_address_xr.value_namespace = name_space
                        self.destination_address_xr.value_namespace_prefix = name_space_prefix
                    if(value_path == "extended-tunnel-id-xr"):
                        self.extended_tunnel_id_xr = value
                        self.extended_tunnel_id_xr.value_namespace = name_space
                        self.extended_tunnel_id_xr.value_namespace_prefix = name_space_prefix
                    if(value_path == "lsp-wrap-protection-enable"):
                        self.lsp_wrap_protection_enable = value
                        self.lsp_wrap_protection_enable.value_namespace = name_space
                        self.lsp_wrap_protection_enable.value_namespace_prefix = name_space_prefix
                    if(value_path == "lsp-wrap-protection-label"):
                        self.lsp_wrap_protection_label = value
                        self.lsp_wrap_protection_label.value_namespace = name_space
                        self.lsp_wrap_protection_label.value_namespace_prefix = name_space_prefix
                    if(value_path == "lsp-wrap-protection-state"):
                        self.lsp_wrap_protection_state = value
                        self.lsp_wrap_protection_state.value_namespace = name_space
                        self.lsp_wrap_protection_state.value_namespace_prefix = name_space_prefix
                    if(value_path == "p2mp-id-xr"):
                        self.p2mp_id_xr = value
                        self.p2mp_id_xr.value_namespace = name_space
                        self.p2mp_id_xr.value_namespace_prefix = name_space_prefix
                    if(value_path == "reverse-egress-interface"):
                        self.reverse_egress_interface = value
                        self.reverse_egress_interface.value_namespace = name_space
                        self.reverse_egress_interface.value_namespace_prefix = name_space_prefix
                    if(value_path == "reverse-lsp-label"):
                        self.reverse_lsp_label = value
                        self.reverse_lsp_label.value_namespace = name_space
                        self.reverse_lsp_label.value_namespace_prefix = name_space_prefix
                    if(value_path == "source-address-xr"):
                        self.source_address_xr = value
                        self.source_address_xr.value_namespace = name_space
                        self.source_address_xr.value_namespace_prefix = name_space_prefix
                    if(value_path == "sub-group-id-xr"):
                        self.sub_group_id_xr = value
                        self.sub_group_id_xr.value_namespace = name_space
                        self.sub_group_id_xr.value_namespace_prefix = name_space_prefix
                    if(value_path == "sub-group-original-id"):
                        self.sub_group_original_id = value
                        self.sub_group_original_id.value_namespace = name_space
                        self.sub_group_original_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-id-xr"):
                        self.tunnel_id_xr = value
                        self.tunnel_id_xr.value_namespace = name_space
                        self.tunnel_id_xr.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-instance"):
                        self.tunnel_instance = value
                        self.tunnel_instance.value_namespace = name_space
                        self.tunnel_instance.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-name"):
                        self.tunnel_name = value
                        self.tunnel_name.value_namespace = name_space
                        self.tunnel_name.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.protected_lsp:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.protected_lsp:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "protected-lsps" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/wrap-protection/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "protected-lsp"):
                    for c in self.protected_lsp:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTeStandby.WrapProtection.ProtectedLsps.ProtectedLsp()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.protected_lsp.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "protected-lsp"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass

        def has_data(self):
            return (self.protected_lsps is not None and self.protected_lsps.has_data())

        def has_operation(self):
            return (
                self.yfilter != YFilter.not_set or
                (self.protected_lsps is not None and self.protected_lsps.has_operation()))

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "wrap-protection" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "protected-lsps"):
                if (self.protected_lsps is None):
                    self.protected_lsps = MplsTeStandby.WrapProtection.ProtectedLsps()
                    self.protected_lsps.parent = self
                    self._children_name_map["protected_lsps"] = "protected-lsps"
                return self.protected_lsps

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "protected-lsps"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class Topology(Entity):
        """
        The topology information in MPLS\-TE
        
        .. attribute:: configured_srlgs
        
        	Set of configured SRLG
        	**type**\:   :py:class:`ConfiguredSrlgs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Topology.ConfiguredSrlgs>`
        
        .. attribute:: destination_paths
        
        	This table models the path calculation capabilities in MPLS\-TE.A GET operation for the complete table will return no entries.See the class DestinationPath for more details
        	**type**\:   :py:class:`DestinationPaths <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Topology.DestinationPaths>`
        
        .. attribute:: global_
        
        	Global information about the overall MPLS\-TE topology
        	**type**\:   :py:class:`Global_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Topology.Global_>`
        
        .. attribute:: path_tunnels
        
        	MPLS\-Te topology path info
        	**type**\:   :py:class:`PathTunnels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Topology.PathTunnels>`
        
        .. attribute:: srlgs
        
        	Set of SRLG operational value for the overall MPLS\-TE topology
        	**type**\:   :py:class:`Srlgs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Topology.Srlgs>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsTeStandby.Topology, self).__init__()

            self.yang_name = "topology"
            self.yang_parent_name = "mpls-te-standby"

            self.configured_srlgs = MplsTeStandby.Topology.ConfiguredSrlgs()
            self.configured_srlgs.parent = self
            self._children_name_map["configured_srlgs"] = "configured-srlgs"
            self._children_yang_names.add("configured-srlgs")

            self.destination_paths = MplsTeStandby.Topology.DestinationPaths()
            self.destination_paths.parent = self
            self._children_name_map["destination_paths"] = "destination-paths"
            self._children_yang_names.add("destination-paths")

            self.global_ = MplsTeStandby.Topology.Global_()
            self.global_.parent = self
            self._children_name_map["global_"] = "global"
            self._children_yang_names.add("global")

            self.path_tunnels = MplsTeStandby.Topology.PathTunnels()
            self.path_tunnels.parent = self
            self._children_name_map["path_tunnels"] = "path-tunnels"
            self._children_yang_names.add("path-tunnels")

            self.srlgs = MplsTeStandby.Topology.Srlgs()
            self.srlgs.parent = self
            self._children_name_map["srlgs"] = "srlgs"
            self._children_yang_names.add("srlgs")


        class Global_(Entity):
            """
            Global information about the overall MPLS\-TE
            topology
            
            .. attribute:: areas
            
            	Information for areas
            	**type**\: list of    :py:class:`Areas <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Topology.Global_.Areas>`
            
            .. attribute:: hold_down_interval
            
            	Interval in seconds to hold down a neighbor after a signalling error
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            	**units**\: second
            
            .. attribute:: link_add_remove_count
            
            	Link add/remove counter
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: local_model_id
            
            	Local BC Model ID
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTeStandby.Topology.Global_, self).__init__()

                self.yang_name = "global"
                self.yang_parent_name = "topology"

                self.hold_down_interval = YLeaf(YType.uint32, "hold-down-interval")

                self.link_add_remove_count = YLeaf(YType.uint32, "link-add-remove-count")

                self.local_model_id = YLeaf(YType.uint32, "local-model-id")

                self.areas = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("hold_down_interval",
                                "link_add_remove_count",
                                "local_model_id") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTeStandby.Topology.Global_, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTeStandby.Topology.Global_, self).__setattr__(name, value)


            class Areas(Entity):
                """
                Information for areas
                
                .. attribute:: area_id
                
                	The area's id
                	**type**\:  str
                
                .. attribute:: local_sid_and_srbg
                
                	Local SID and SRBG
                	**type**\:   :py:class:`LocalSidAndSrbg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Topology.Global_.Areas.LocalSidAndSrbg>`
                
                .. attribute:: node_id
                
                	The node's IGP id
                	**type**\:  str
                
                .. attribute:: protocol
                
                	Protocol used
                	**type**\:   :py:class:`IgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpProtocol>`
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTeStandby.Topology.Global_.Areas, self).__init__()

                    self.yang_name = "areas"
                    self.yang_parent_name = "global"

                    self.area_id = YLeaf(YType.str, "area-id")

                    self.node_id = YLeaf(YType.str, "node-id")

                    self.protocol = YLeaf(YType.enumeration, "protocol")

                    self.local_sid_and_srbg = MplsTeStandby.Topology.Global_.Areas.LocalSidAndSrbg()
                    self.local_sid_and_srbg.parent = self
                    self._children_name_map["local_sid_and_srbg"] = "local-sid-and-srbg"
                    self._children_yang_names.add("local-sid-and-srbg")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("area_id",
                                    "node_id",
                                    "protocol") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTeStandby.Topology.Global_.Areas, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTeStandby.Topology.Global_.Areas, self).__setattr__(name, value)


                class LocalSidAndSrbg(Entity):
                    """
                    Local SID and SRBG
                    
                    .. attribute:: segment_id
                    
                    	Segment\-Routing Node\-SID
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: segment_id_local_absolute_value
                    
                    	Node\-SID local absolute value
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: srgb_size
                    
                    	Segment\-Routing global block size
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: srgb_start
                    
                    	Segment\-Routring global block start value
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.Topology.Global_.Areas.LocalSidAndSrbg, self).__init__()

                        self.yang_name = "local-sid-and-srbg"
                        self.yang_parent_name = "areas"

                        self.segment_id = YLeaf(YType.uint32, "segment-id")

                        self.segment_id_local_absolute_value = YLeaf(YType.uint32, "segment-id-local-absolute-value")

                        self.srgb_size = YLeaf(YType.uint32, "srgb-size")

                        self.srgb_start = YLeaf(YType.uint32, "srgb-start")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("segment_id",
                                        "segment_id_local_absolute_value",
                                        "srgb_size",
                                        "srgb_start") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.Topology.Global_.Areas.LocalSidAndSrbg, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.Topology.Global_.Areas.LocalSidAndSrbg, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.segment_id.is_set or
                            self.segment_id_local_absolute_value.is_set or
                            self.srgb_size.is_set or
                            self.srgb_start.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.segment_id.yfilter != YFilter.not_set or
                            self.segment_id_local_absolute_value.yfilter != YFilter.not_set or
                            self.srgb_size.yfilter != YFilter.not_set or
                            self.srgb_start.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "local-sid-and-srbg" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/topology/global/areas/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.segment_id.is_set or self.segment_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.segment_id.get_name_leafdata())
                        if (self.segment_id_local_absolute_value.is_set or self.segment_id_local_absolute_value.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.segment_id_local_absolute_value.get_name_leafdata())
                        if (self.srgb_size.is_set or self.srgb_size.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.srgb_size.get_name_leafdata())
                        if (self.srgb_start.is_set or self.srgb_start.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.srgb_start.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "segment-id" or name == "segment-id-local-absolute-value" or name == "srgb-size" or name == "srgb-start"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "segment-id"):
                            self.segment_id = value
                            self.segment_id.value_namespace = name_space
                            self.segment_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "segment-id-local-absolute-value"):
                            self.segment_id_local_absolute_value = value
                            self.segment_id_local_absolute_value.value_namespace = name_space
                            self.segment_id_local_absolute_value.value_namespace_prefix = name_space_prefix
                        if(value_path == "srgb-size"):
                            self.srgb_size = value
                            self.srgb_size.value_namespace = name_space
                            self.srgb_size.value_namespace_prefix = name_space_prefix
                        if(value_path == "srgb-start"):
                            self.srgb_start = value
                            self.srgb_start.value_namespace = name_space
                            self.srgb_start.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    return (
                        self.area_id.is_set or
                        self.node_id.is_set or
                        self.protocol.is_set or
                        (self.local_sid_and_srbg is not None and self.local_sid_and_srbg.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.area_id.yfilter != YFilter.not_set or
                        self.node_id.yfilter != YFilter.not_set or
                        self.protocol.yfilter != YFilter.not_set or
                        (self.local_sid_and_srbg is not None and self.local_sid_and_srbg.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "areas" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/topology/global/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.area_id.is_set or self.area_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.area_id.get_name_leafdata())
                    if (self.node_id.is_set or self.node_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.node_id.get_name_leafdata())
                    if (self.protocol.is_set or self.protocol.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.protocol.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "local-sid-and-srbg"):
                        if (self.local_sid_and_srbg is None):
                            self.local_sid_and_srbg = MplsTeStandby.Topology.Global_.Areas.LocalSidAndSrbg()
                            self.local_sid_and_srbg.parent = self
                            self._children_name_map["local_sid_and_srbg"] = "local-sid-and-srbg"
                        return self.local_sid_and_srbg

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "local-sid-and-srbg" or name == "area-id" or name == "node-id" or name == "protocol"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "area-id"):
                        self.area_id = value
                        self.area_id.value_namespace = name_space
                        self.area_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "node-id"):
                        self.node_id = value
                        self.node_id.value_namespace = name_space
                        self.node_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "protocol"):
                        self.protocol = value
                        self.protocol.value_namespace = name_space
                        self.protocol.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.areas:
                    if (c.has_data()):
                        return True
                return (
                    self.hold_down_interval.is_set or
                    self.link_add_remove_count.is_set or
                    self.local_model_id.is_set)

            def has_operation(self):
                for c in self.areas:
                    if (c.has_operation()):
                        return True
                return (
                    self.yfilter != YFilter.not_set or
                    self.hold_down_interval.yfilter != YFilter.not_set or
                    self.link_add_remove_count.yfilter != YFilter.not_set or
                    self.local_model_id.yfilter != YFilter.not_set)

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "global" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/topology/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.hold_down_interval.is_set or self.hold_down_interval.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.hold_down_interval.get_name_leafdata())
                if (self.link_add_remove_count.is_set or self.link_add_remove_count.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.link_add_remove_count.get_name_leafdata())
                if (self.local_model_id.is_set or self.local_model_id.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.local_model_id.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "areas"):
                    for c in self.areas:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTeStandby.Topology.Global_.Areas()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.areas.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "areas" or name == "hold-down-interval" or name == "link-add-remove-count" or name == "local-model-id"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "hold-down-interval"):
                    self.hold_down_interval = value
                    self.hold_down_interval.value_namespace = name_space
                    self.hold_down_interval.value_namespace_prefix = name_space_prefix
                if(value_path == "link-add-remove-count"):
                    self.link_add_remove_count = value
                    self.link_add_remove_count.value_namespace = name_space
                    self.link_add_remove_count.value_namespace_prefix = name_space_prefix
                if(value_path == "local-model-id"):
                    self.local_model_id = value
                    self.local_model_id.value_namespace = name_space
                    self.local_model_id.value_namespace_prefix = name_space_prefix


        class DestinationPaths(Entity):
            """
            This table models the path calculation
            capabilities in MPLS\-TE.A GET operation for the
            complete table will return no entries.See the
            class DestinationPath for more details.
            
            .. attribute:: destination_path
            
            	A GET operation on this class returns the best available path in the TE topology to reach the specified destination while satisfying the specified constraints
            	**type**\: list of    :py:class:`DestinationPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Topology.DestinationPaths.DestinationPath>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTeStandby.Topology.DestinationPaths, self).__init__()

                self.yang_name = "destination-paths"
                self.yang_parent_name = "topology"

                self.destination_path = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTeStandby.Topology.DestinationPaths, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTeStandby.Topology.DestinationPaths, self).__setattr__(name, value)


            class DestinationPath(Entity):
                """
                A GET operation on this class returns the best
                available path in the TE topology to reach the
                specified destination while satisfying the
                specified constraints.
                
                .. attribute:: accumulated_admin_weight
                
                	The path's accumulated admin weight
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                .. attribute:: affinity
                
                	Affinity
                	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Topology.DestinationPaths.DestinationPath.Affinity>`
                
                .. attribute:: affinity_bits
                
                	Affinity Bits
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: affinity_mask
                
                	Affinity Mask
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: bandwidth
                
                	Bandwidth in kbps
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                	**units**\: kbit/s
                
                .. attribute:: bandwidth_type
                
                	The path's bandwidth type
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                .. attribute:: cost_limit
                
                	Cost Limit
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: destination_address
                
                	Destination Address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: destination_address_xr
                
                	The path's destination
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: exclude_srlg_address
                
                	The Exclude SRLG IP Addr
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: exclude_srlg_ip_address
                
                	Exclude SRLG IP Address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: hold_priority
                
                	Hold Priority
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: hold_priority_xr
                
                	The path's hold priority
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: hop
                
                	The path's array of hops
                	**type**\: list of    :py:class:`Hop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Topology.DestinationPaths.DestinationPath.Hop>`
                
                .. attribute:: hop_limit
                
                	Hop Limit
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: igp_area
                
                	IGP Area
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: igp_instance
                
                	IGP Instance
                	**type**\:  str
                
                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                
                .. attribute:: igp_type
                
                	IGP Type
                	**type**\:   :py:class:`MplsTeIgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeIgpProtocol>`
                
                .. attribute:: is_full_path
                
                	TRUE if path is full
                	**type**\:  bool
                
                .. attribute:: is_partial_path
                
                	TRUE if path is partial
                	**type**\:  bool
                
                .. attribute:: is_segment_routing_db_checked
                
                	TRUE if checking the Segment\-Routing DB is enabled
                	**type**\:  bool
                
                .. attribute:: is_topology_checked
                
                	TRUE if checking the topology is enabled
                	**type**\:  bool
                
                .. attribute:: mininum_bandwidth
                
                	The path's minimum bandwidth
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                .. attribute:: node_hop_count
                
                	Path hop count
                	**type**\:  int
                
                	**range:** 0..255
                
                .. attribute:: path_id
                
                	This is the ID of the explicit path to be used for this path calculation query
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: path_name
                
                	This is the name of the explicit path to be used for this path calculation query
                	**type**\:  str
                
                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                
                .. attribute:: path_type
                
                	Path Type
                	**type**\:   :py:class:`MplsTePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTePath>`
                
                .. attribute:: requested_bandwidth
                
                	The path's requested bandwidth
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                .. attribute:: setup_priority
                
                	Setup Priority
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: setup_priority_xr
                
                	The path's setup priority
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: shared_risk_link_group
                
                	The path's excluded srlg groups
                	**type**\: list of    :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Topology.DestinationPaths.DestinationPath.SharedRiskLinkGroup>`
                
                .. attribute:: sr_segment
                
                	The path's array of Segment\-Routing segments
                	**type**\: list of    :py:class:`SrSegment <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Topology.DestinationPaths.DestinationPath.SrSegment>`
                
                .. attribute:: tunnel_id_xr
                
                	The tunnel ID to which this path belong
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTeStandby.Topology.DestinationPaths.DestinationPath, self).__init__()

                    self.yang_name = "destination-path"
                    self.yang_parent_name = "destination-paths"

                    self.accumulated_admin_weight = YLeaf(YType.uint64, "accumulated-admin-weight")

                    self.affinity_bits = YLeaf(YType.int32, "affinity-bits")

                    self.affinity_mask = YLeaf(YType.int32, "affinity-mask")

                    self.bandwidth = YLeaf(YType.int32, "bandwidth")

                    self.bandwidth_type = YLeaf(YType.uint64, "bandwidth-type")

                    self.cost_limit = YLeaf(YType.int32, "cost-limit")

                    self.destination_address = YLeaf(YType.str, "destination-address")

                    self.destination_address_xr = YLeaf(YType.str, "destination-address-xr")

                    self.exclude_srlg_address = YLeaf(YType.str, "exclude-srlg-address")

                    self.exclude_srlg_ip_address = YLeaf(YType.str, "exclude-srlg-ip-address")

                    self.hold_priority = YLeaf(YType.int32, "hold-priority")

                    self.hold_priority_xr = YLeaf(YType.uint32, "hold-priority-xr")

                    self.hop_limit = YLeaf(YType.int32, "hop-limit")

                    self.igp_area = YLeaf(YType.int32, "igp-area")

                    self.igp_instance = YLeaf(YType.str, "igp-instance")

                    self.igp_type = YLeaf(YType.enumeration, "igp-type")

                    self.is_full_path = YLeaf(YType.boolean, "is-full-path")

                    self.is_partial_path = YLeaf(YType.boolean, "is-partial-path")

                    self.is_segment_routing_db_checked = YLeaf(YType.boolean, "is-segment-routing-db-checked")

                    self.is_topology_checked = YLeaf(YType.boolean, "is-topology-checked")

                    self.mininum_bandwidth = YLeaf(YType.uint64, "mininum-bandwidth")

                    self.node_hop_count = YLeaf(YType.uint8, "node-hop-count")

                    self.path_id = YLeaf(YType.int32, "path-id")

                    self.path_name = YLeaf(YType.str, "path-name")

                    self.path_type = YLeaf(YType.enumeration, "path-type")

                    self.requested_bandwidth = YLeaf(YType.uint64, "requested-bandwidth")

                    self.setup_priority = YLeaf(YType.int32, "setup-priority")

                    self.setup_priority_xr = YLeaf(YType.uint32, "setup-priority-xr")

                    self.tunnel_id_xr = YLeaf(YType.uint32, "tunnel-id-xr")

                    self.affinity = MplsTeStandby.Topology.DestinationPaths.DestinationPath.Affinity()
                    self.affinity.parent = self
                    self._children_name_map["affinity"] = "affinity"
                    self._children_yang_names.add("affinity")

                    self.hop = YList(self)
                    self.shared_risk_link_group = YList(self)
                    self.sr_segment = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("accumulated_admin_weight",
                                    "affinity_bits",
                                    "affinity_mask",
                                    "bandwidth",
                                    "bandwidth_type",
                                    "cost_limit",
                                    "destination_address",
                                    "destination_address_xr",
                                    "exclude_srlg_address",
                                    "exclude_srlg_ip_address",
                                    "hold_priority",
                                    "hold_priority_xr",
                                    "hop_limit",
                                    "igp_area",
                                    "igp_instance",
                                    "igp_type",
                                    "is_full_path",
                                    "is_partial_path",
                                    "is_segment_routing_db_checked",
                                    "is_topology_checked",
                                    "mininum_bandwidth",
                                    "node_hop_count",
                                    "path_id",
                                    "path_name",
                                    "path_type",
                                    "requested_bandwidth",
                                    "setup_priority",
                                    "setup_priority_xr",
                                    "tunnel_id_xr") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTeStandby.Topology.DestinationPaths.DestinationPath, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTeStandby.Topology.DestinationPaths.DestinationPath, self).__setattr__(name, value)


                class Affinity(Entity):
                    """
                    Affinity
                    
                    .. attribute:: affinity_bits
                    
                    	The affinity bits (colors)
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: affinity_mask
                    
                    	The affinity mask (colors)
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: named_affinity
                    
                    	Array of name based constratints currently applied to the tunnel
                    	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Topology.DestinationPaths.DestinationPath.Affinity.NamedAffinity>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.Topology.DestinationPaths.DestinationPath.Affinity, self).__init__()

                        self.yang_name = "affinity"
                        self.yang_parent_name = "destination-path"

                        self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                        self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                        self.named_affinity = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("affinity_bits",
                                        "affinity_mask") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.Topology.DestinationPaths.DestinationPath.Affinity, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.Topology.DestinationPaths.DestinationPath.Affinity, self).__setattr__(name, value)


                    class NamedAffinity(Entity):
                        """
                        Array of name based constratints currently
                        applied to the tunnel
                        
                        .. attribute:: constraint_extended_value
                        
                        	Constraint value
                        	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Topology.DestinationPaths.DestinationPath.Affinity.NamedAffinity.ConstraintExtendedValue>`
                        
                        .. attribute:: constraint_type
                        
                        	Constraint type
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        .. attribute:: constraint_value
                        
                        	Deprecated
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: extended_forward_ref_value
                        
                        	Reference bits for undefined affinity names
                        	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Topology.DestinationPaths.DestinationPath.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                        
                        .. attribute:: forward_ref_value
                        
                        	Deprecated
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.Topology.DestinationPaths.DestinationPath.Affinity.NamedAffinity, self).__init__()

                            self.yang_name = "named-affinity"
                            self.yang_parent_name = "affinity"

                            self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                            self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                            self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                            self.constraint_extended_value = YList(self)
                            self.extended_forward_ref_value = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("constraint_type",
                                            "constraint_value",
                                            "forward_ref_value") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.Topology.DestinationPaths.DestinationPath.Affinity.NamedAffinity, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.Topology.DestinationPaths.DestinationPath.Affinity.NamedAffinity, self).__setattr__(name, value)


                        class ConstraintExtendedValue(Entity):
                            """
                            Constraint value
                            
                            .. attribute:: entry
                            
                            	
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.Topology.DestinationPaths.DestinationPath.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                self.yang_name = "constraint-extended-value"
                                self.yang_parent_name = "named-affinity"

                                self.entry = YLeaf(YType.uint32, "entry")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("entry") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.Topology.DestinationPaths.DestinationPath.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.Topology.DestinationPaths.DestinationPath.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                            def has_data(self):
                                return self.entry.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.entry.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "constraint-extended-value" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/topology/destination-paths/destination-path/affinity/named-affinity/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "entry"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "entry"):
                                    self.entry = value
                                    self.entry.value_namespace = name_space
                                    self.entry.value_namespace_prefix = name_space_prefix


                        class ExtendedForwardRefValue(Entity):
                            """
                            Reference bits for undefined affinity names
                            
                            .. attribute:: entry
                            
                            	
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.Topology.DestinationPaths.DestinationPath.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                self.yang_name = "extended-forward-ref-value"
                                self.yang_parent_name = "named-affinity"

                                self.entry = YLeaf(YType.uint32, "entry")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("entry") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.Topology.DestinationPaths.DestinationPath.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.Topology.DestinationPaths.DestinationPath.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                            def has_data(self):
                                return self.entry.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.entry.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "extended-forward-ref-value" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/topology/destination-paths/destination-path/affinity/named-affinity/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "entry"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "entry"):
                                    self.entry = value
                                    self.entry.value_namespace = name_space
                                    self.entry.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.constraint_extended_value:
                                if (c.has_data()):
                                    return True
                            for c in self.extended_forward_ref_value:
                                if (c.has_data()):
                                    return True
                            return (
                                self.constraint_type.is_set or
                                self.constraint_value.is_set or
                                self.forward_ref_value.is_set)

                        def has_operation(self):
                            for c in self.constraint_extended_value:
                                if (c.has_operation()):
                                    return True
                            for c in self.extended_forward_ref_value:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.constraint_type.yfilter != YFilter.not_set or
                                self.constraint_value.yfilter != YFilter.not_set or
                                self.forward_ref_value.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "named-affinity" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/topology/destination-paths/destination-path/affinity/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.constraint_type.get_name_leafdata())
                            if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.constraint_value.get_name_leafdata())
                            if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "constraint-extended-value"):
                                for c in self.constraint_extended_value:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.Topology.DestinationPaths.DestinationPath.Affinity.NamedAffinity.ConstraintExtendedValue()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.constraint_extended_value.append(c)
                                return c

                            if (child_yang_name == "extended-forward-ref-value"):
                                for c in self.extended_forward_ref_value:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.Topology.DestinationPaths.DestinationPath.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.extended_forward_ref_value.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "constraint-type"):
                                self.constraint_type = value
                                self.constraint_type.value_namespace = name_space
                                self.constraint_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "constraint-value"):
                                self.constraint_value = value
                                self.constraint_value.value_namespace = name_space
                                self.constraint_value.value_namespace_prefix = name_space_prefix
                            if(value_path == "forward-ref-value"):
                                self.forward_ref_value = value
                                self.forward_ref_value.value_namespace = name_space
                                self.forward_ref_value.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.named_affinity:
                            if (c.has_data()):
                                return True
                        return (
                            self.affinity_bits.is_set or
                            self.affinity_mask.is_set)

                    def has_operation(self):
                        for c in self.named_affinity:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.affinity_bits.yfilter != YFilter.not_set or
                            self.affinity_mask.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "affinity" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/topology/destination-paths/destination-path/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                        if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "named-affinity"):
                            for c in self.named_affinity:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.Topology.DestinationPaths.DestinationPath.Affinity.NamedAffinity()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.named_affinity.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "affinity-bits"):
                            self.affinity_bits = value
                            self.affinity_bits.value_namespace = name_space
                            self.affinity_bits.value_namespace_prefix = name_space_prefix
                        if(value_path == "affinity-mask"):
                            self.affinity_mask = value
                            self.affinity_mask.value_namespace = name_space
                            self.affinity_mask.value_namespace_prefix = name_space_prefix


                class Hop(Entity):
                    """
                    The path's array of hops
                    
                    .. attribute:: entry
                    
                    	
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.Topology.DestinationPaths.DestinationPath.Hop, self).__init__()

                        self.yang_name = "hop"
                        self.yang_parent_name = "destination-path"

                        self.entry = YLeaf(YType.str, "entry")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("entry") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.Topology.DestinationPaths.DestinationPath.Hop, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.Topology.DestinationPaths.DestinationPath.Hop, self).__setattr__(name, value)

                    def has_data(self):
                        return self.entry.is_set

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.entry.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "hop" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/topology/destination-paths/destination-path/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.entry.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "entry"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "entry"):
                            self.entry = value
                            self.entry.value_namespace = name_space
                            self.entry.value_namespace_prefix = name_space_prefix


                class SharedRiskLinkGroup(Entity):
                    """
                    The path's excluded srlg groups
                    
                    .. attribute:: shared_risk_group
                    
                    	SRLG number
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: srlg_name
                    
                    	SRLG name
                    	**type**\:  str
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.Topology.DestinationPaths.DestinationPath.SharedRiskLinkGroup, self).__init__()

                        self.yang_name = "shared-risk-link-group"
                        self.yang_parent_name = "destination-path"

                        self.shared_risk_group = YLeaf(YType.uint32, "shared-risk-group")

                        self.srlg_name = YLeaf(YType.str, "srlg-name")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("shared_risk_group",
                                        "srlg_name") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.Topology.DestinationPaths.DestinationPath.SharedRiskLinkGroup, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.Topology.DestinationPaths.DestinationPath.SharedRiskLinkGroup, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.shared_risk_group.is_set or
                            self.srlg_name.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.shared_risk_group.yfilter != YFilter.not_set or
                            self.srlg_name.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "shared-risk-link-group" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/topology/destination-paths/destination-path/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.shared_risk_group.is_set or self.shared_risk_group.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.shared_risk_group.get_name_leafdata())
                        if (self.srlg_name.is_set or self.srlg_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.srlg_name.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "shared-risk-group" or name == "srlg-name"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "shared-risk-group"):
                            self.shared_risk_group = value
                            self.shared_risk_group.value_namespace = name_space
                            self.shared_risk_group.value_namespace_prefix = name_space_prefix
                        if(value_path == "srlg-name"):
                            self.srlg_name = value
                            self.srlg_name.value_namespace = name_space
                            self.srlg_name.value_namespace_prefix = name_space_prefix


                class SrSegment(Entity):
                    """
                    The path's array of Segment\-Routing segments
                    
                    .. attribute:: has_entropy_label
                    
                    	Hop has EL specified
                    	**type**\:  bool
                    
                    .. attribute:: has_ip_addresses
                    
                    	Node has IP addresses specified
                    	**type**\:  bool
                    
                    .. attribute:: has_mpls_label
                    
                    	Hop has MPLS label specified
                    	**type**\:  bool
                    
                    .. attribute:: local_addr
                    
                    	Local IP address of adjacency or Node ID
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: mpls_label_value
                    
                    	The MPLS label value
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: remote_addr
                    
                    	Remote IP address of adjacency
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: sid_type
                    
                    	Type of the SID
                    	**type**\:   :py:class:`TeSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrSid>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.Topology.DestinationPaths.DestinationPath.SrSegment, self).__init__()

                        self.yang_name = "sr-segment"
                        self.yang_parent_name = "destination-path"

                        self.has_entropy_label = YLeaf(YType.boolean, "has-entropy-label")

                        self.has_ip_addresses = YLeaf(YType.boolean, "has-ip-addresses")

                        self.has_mpls_label = YLeaf(YType.boolean, "has-mpls-label")

                        self.local_addr = YLeaf(YType.str, "local-addr")

                        self.mpls_label_value = YLeaf(YType.uint32, "mpls-label-value")

                        self.remote_addr = YLeaf(YType.str, "remote-addr")

                        self.sid_type = YLeaf(YType.enumeration, "sid-type")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("has_entropy_label",
                                        "has_ip_addresses",
                                        "has_mpls_label",
                                        "local_addr",
                                        "mpls_label_value",
                                        "remote_addr",
                                        "sid_type") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.Topology.DestinationPaths.DestinationPath.SrSegment, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.Topology.DestinationPaths.DestinationPath.SrSegment, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.has_entropy_label.is_set or
                            self.has_ip_addresses.is_set or
                            self.has_mpls_label.is_set or
                            self.local_addr.is_set or
                            self.mpls_label_value.is_set or
                            self.remote_addr.is_set or
                            self.sid_type.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.has_entropy_label.yfilter != YFilter.not_set or
                            self.has_ip_addresses.yfilter != YFilter.not_set or
                            self.has_mpls_label.yfilter != YFilter.not_set or
                            self.local_addr.yfilter != YFilter.not_set or
                            self.mpls_label_value.yfilter != YFilter.not_set or
                            self.remote_addr.yfilter != YFilter.not_set or
                            self.sid_type.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "sr-segment" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/topology/destination-paths/destination-path/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.has_entropy_label.is_set or self.has_entropy_label.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.has_entropy_label.get_name_leafdata())
                        if (self.has_ip_addresses.is_set or self.has_ip_addresses.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.has_ip_addresses.get_name_leafdata())
                        if (self.has_mpls_label.is_set or self.has_mpls_label.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.has_mpls_label.get_name_leafdata())
                        if (self.local_addr.is_set or self.local_addr.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.local_addr.get_name_leafdata())
                        if (self.mpls_label_value.is_set or self.mpls_label_value.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.mpls_label_value.get_name_leafdata())
                        if (self.remote_addr.is_set or self.remote_addr.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.remote_addr.get_name_leafdata())
                        if (self.sid_type.is_set or self.sid_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.sid_type.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "has-entropy-label" or name == "has-ip-addresses" or name == "has-mpls-label" or name == "local-addr" or name == "mpls-label-value" or name == "remote-addr" or name == "sid-type"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "has-entropy-label"):
                            self.has_entropy_label = value
                            self.has_entropy_label.value_namespace = name_space
                            self.has_entropy_label.value_namespace_prefix = name_space_prefix
                        if(value_path == "has-ip-addresses"):
                            self.has_ip_addresses = value
                            self.has_ip_addresses.value_namespace = name_space
                            self.has_ip_addresses.value_namespace_prefix = name_space_prefix
                        if(value_path == "has-mpls-label"):
                            self.has_mpls_label = value
                            self.has_mpls_label.value_namespace = name_space
                            self.has_mpls_label.value_namespace_prefix = name_space_prefix
                        if(value_path == "local-addr"):
                            self.local_addr = value
                            self.local_addr.value_namespace = name_space
                            self.local_addr.value_namespace_prefix = name_space_prefix
                        if(value_path == "mpls-label-value"):
                            self.mpls_label_value = value
                            self.mpls_label_value.value_namespace = name_space
                            self.mpls_label_value.value_namespace_prefix = name_space_prefix
                        if(value_path == "remote-addr"):
                            self.remote_addr = value
                            self.remote_addr.value_namespace = name_space
                            self.remote_addr.value_namespace_prefix = name_space_prefix
                        if(value_path == "sid-type"):
                            self.sid_type = value
                            self.sid_type.value_namespace = name_space
                            self.sid_type.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.hop:
                        if (c.has_data()):
                            return True
                    for c in self.shared_risk_link_group:
                        if (c.has_data()):
                            return True
                    for c in self.sr_segment:
                        if (c.has_data()):
                            return True
                    return (
                        self.accumulated_admin_weight.is_set or
                        self.affinity_bits.is_set or
                        self.affinity_mask.is_set or
                        self.bandwidth.is_set or
                        self.bandwidth_type.is_set or
                        self.cost_limit.is_set or
                        self.destination_address.is_set or
                        self.destination_address_xr.is_set or
                        self.exclude_srlg_address.is_set or
                        self.exclude_srlg_ip_address.is_set or
                        self.hold_priority.is_set or
                        self.hold_priority_xr.is_set or
                        self.hop_limit.is_set or
                        self.igp_area.is_set or
                        self.igp_instance.is_set or
                        self.igp_type.is_set or
                        self.is_full_path.is_set or
                        self.is_partial_path.is_set or
                        self.is_segment_routing_db_checked.is_set or
                        self.is_topology_checked.is_set or
                        self.mininum_bandwidth.is_set or
                        self.node_hop_count.is_set or
                        self.path_id.is_set or
                        self.path_name.is_set or
                        self.path_type.is_set or
                        self.requested_bandwidth.is_set or
                        self.setup_priority.is_set or
                        self.setup_priority_xr.is_set or
                        self.tunnel_id_xr.is_set or
                        (self.affinity is not None and self.affinity.has_data()))

                def has_operation(self):
                    for c in self.hop:
                        if (c.has_operation()):
                            return True
                    for c in self.shared_risk_link_group:
                        if (c.has_operation()):
                            return True
                    for c in self.sr_segment:
                        if (c.has_operation()):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        self.accumulated_admin_weight.yfilter != YFilter.not_set or
                        self.affinity_bits.yfilter != YFilter.not_set or
                        self.affinity_mask.yfilter != YFilter.not_set or
                        self.bandwidth.yfilter != YFilter.not_set or
                        self.bandwidth_type.yfilter != YFilter.not_set or
                        self.cost_limit.yfilter != YFilter.not_set or
                        self.destination_address.yfilter != YFilter.not_set or
                        self.destination_address_xr.yfilter != YFilter.not_set or
                        self.exclude_srlg_address.yfilter != YFilter.not_set or
                        self.exclude_srlg_ip_address.yfilter != YFilter.not_set or
                        self.hold_priority.yfilter != YFilter.not_set or
                        self.hold_priority_xr.yfilter != YFilter.not_set or
                        self.hop_limit.yfilter != YFilter.not_set or
                        self.igp_area.yfilter != YFilter.not_set or
                        self.igp_instance.yfilter != YFilter.not_set or
                        self.igp_type.yfilter != YFilter.not_set or
                        self.is_full_path.yfilter != YFilter.not_set or
                        self.is_partial_path.yfilter != YFilter.not_set or
                        self.is_segment_routing_db_checked.yfilter != YFilter.not_set or
                        self.is_topology_checked.yfilter != YFilter.not_set or
                        self.mininum_bandwidth.yfilter != YFilter.not_set or
                        self.node_hop_count.yfilter != YFilter.not_set or
                        self.path_id.yfilter != YFilter.not_set or
                        self.path_name.yfilter != YFilter.not_set or
                        self.path_type.yfilter != YFilter.not_set or
                        self.requested_bandwidth.yfilter != YFilter.not_set or
                        self.setup_priority.yfilter != YFilter.not_set or
                        self.setup_priority_xr.yfilter != YFilter.not_set or
                        self.tunnel_id_xr.yfilter != YFilter.not_set or
                        (self.affinity is not None and self.affinity.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "destination-path" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/topology/destination-paths/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.accumulated_admin_weight.is_set or self.accumulated_admin_weight.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.accumulated_admin_weight.get_name_leafdata())
                    if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                    if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.affinity_mask.get_name_leafdata())
                    if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.bandwidth.get_name_leafdata())
                    if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                    if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.cost_limit.get_name_leafdata())
                    if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.destination_address.get_name_leafdata())
                    if (self.destination_address_xr.is_set or self.destination_address_xr.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.destination_address_xr.get_name_leafdata())
                    if (self.exclude_srlg_address.is_set or self.exclude_srlg_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.exclude_srlg_address.get_name_leafdata())
                    if (self.exclude_srlg_ip_address.is_set or self.exclude_srlg_ip_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.exclude_srlg_ip_address.get_name_leafdata())
                    if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.hold_priority.get_name_leafdata())
                    if (self.hold_priority_xr.is_set or self.hold_priority_xr.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.hold_priority_xr.get_name_leafdata())
                    if (self.hop_limit.is_set or self.hop_limit.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.hop_limit.get_name_leafdata())
                    if (self.igp_area.is_set or self.igp_area.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.igp_area.get_name_leafdata())
                    if (self.igp_instance.is_set or self.igp_instance.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.igp_instance.get_name_leafdata())
                    if (self.igp_type.is_set or self.igp_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.igp_type.get_name_leafdata())
                    if (self.is_full_path.is_set or self.is_full_path.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_full_path.get_name_leafdata())
                    if (self.is_partial_path.is_set or self.is_partial_path.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_partial_path.get_name_leafdata())
                    if (self.is_segment_routing_db_checked.is_set or self.is_segment_routing_db_checked.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_segment_routing_db_checked.get_name_leafdata())
                    if (self.is_topology_checked.is_set or self.is_topology_checked.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_topology_checked.get_name_leafdata())
                    if (self.mininum_bandwidth.is_set or self.mininum_bandwidth.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.mininum_bandwidth.get_name_leafdata())
                    if (self.node_hop_count.is_set or self.node_hop_count.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.node_hop_count.get_name_leafdata())
                    if (self.path_id.is_set or self.path_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.path_id.get_name_leafdata())
                    if (self.path_name.is_set or self.path_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.path_name.get_name_leafdata())
                    if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.path_type.get_name_leafdata())
                    if (self.requested_bandwidth.is_set or self.requested_bandwidth.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.requested_bandwidth.get_name_leafdata())
                    if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.setup_priority.get_name_leafdata())
                    if (self.setup_priority_xr.is_set or self.setup_priority_xr.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.setup_priority_xr.get_name_leafdata())
                    if (self.tunnel_id_xr.is_set or self.tunnel_id_xr.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_id_xr.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "affinity"):
                        if (self.affinity is None):
                            self.affinity = MplsTeStandby.Topology.DestinationPaths.DestinationPath.Affinity()
                            self.affinity.parent = self
                            self._children_name_map["affinity"] = "affinity"
                        return self.affinity

                    if (child_yang_name == "hop"):
                        for c in self.hop:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsTeStandby.Topology.DestinationPaths.DestinationPath.Hop()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.hop.append(c)
                        return c

                    if (child_yang_name == "shared-risk-link-group"):
                        for c in self.shared_risk_link_group:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsTeStandby.Topology.DestinationPaths.DestinationPath.SharedRiskLinkGroup()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.shared_risk_link_group.append(c)
                        return c

                    if (child_yang_name == "sr-segment"):
                        for c in self.sr_segment:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsTeStandby.Topology.DestinationPaths.DestinationPath.SrSegment()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.sr_segment.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "affinity" or name == "hop" or name == "shared-risk-link-group" or name == "sr-segment" or name == "accumulated-admin-weight" or name == "affinity-bits" or name == "affinity-mask" or name == "bandwidth" or name == "bandwidth-type" or name == "cost-limit" or name == "destination-address" or name == "destination-address-xr" or name == "exclude-srlg-address" or name == "exclude-srlg-ip-address" or name == "hold-priority" or name == "hold-priority-xr" or name == "hop-limit" or name == "igp-area" or name == "igp-instance" or name == "igp-type" or name == "is-full-path" or name == "is-partial-path" or name == "is-segment-routing-db-checked" or name == "is-topology-checked" or name == "mininum-bandwidth" or name == "node-hop-count" or name == "path-id" or name == "path-name" or name == "path-type" or name == "requested-bandwidth" or name == "setup-priority" or name == "setup-priority-xr" or name == "tunnel-id-xr"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "accumulated-admin-weight"):
                        self.accumulated_admin_weight = value
                        self.accumulated_admin_weight.value_namespace = name_space
                        self.accumulated_admin_weight.value_namespace_prefix = name_space_prefix
                    if(value_path == "affinity-bits"):
                        self.affinity_bits = value
                        self.affinity_bits.value_namespace = name_space
                        self.affinity_bits.value_namespace_prefix = name_space_prefix
                    if(value_path == "affinity-mask"):
                        self.affinity_mask = value
                        self.affinity_mask.value_namespace = name_space
                        self.affinity_mask.value_namespace_prefix = name_space_prefix
                    if(value_path == "bandwidth"):
                        self.bandwidth = value
                        self.bandwidth.value_namespace = name_space
                        self.bandwidth.value_namespace_prefix = name_space_prefix
                    if(value_path == "bandwidth-type"):
                        self.bandwidth_type = value
                        self.bandwidth_type.value_namespace = name_space
                        self.bandwidth_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "cost-limit"):
                        self.cost_limit = value
                        self.cost_limit.value_namespace = name_space
                        self.cost_limit.value_namespace_prefix = name_space_prefix
                    if(value_path == "destination-address"):
                        self.destination_address = value
                        self.destination_address.value_namespace = name_space
                        self.destination_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "destination-address-xr"):
                        self.destination_address_xr = value
                        self.destination_address_xr.value_namespace = name_space
                        self.destination_address_xr.value_namespace_prefix = name_space_prefix
                    if(value_path == "exclude-srlg-address"):
                        self.exclude_srlg_address = value
                        self.exclude_srlg_address.value_namespace = name_space
                        self.exclude_srlg_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "exclude-srlg-ip-address"):
                        self.exclude_srlg_ip_address = value
                        self.exclude_srlg_ip_address.value_namespace = name_space
                        self.exclude_srlg_ip_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "hold-priority"):
                        self.hold_priority = value
                        self.hold_priority.value_namespace = name_space
                        self.hold_priority.value_namespace_prefix = name_space_prefix
                    if(value_path == "hold-priority-xr"):
                        self.hold_priority_xr = value
                        self.hold_priority_xr.value_namespace = name_space
                        self.hold_priority_xr.value_namespace_prefix = name_space_prefix
                    if(value_path == "hop-limit"):
                        self.hop_limit = value
                        self.hop_limit.value_namespace = name_space
                        self.hop_limit.value_namespace_prefix = name_space_prefix
                    if(value_path == "igp-area"):
                        self.igp_area = value
                        self.igp_area.value_namespace = name_space
                        self.igp_area.value_namespace_prefix = name_space_prefix
                    if(value_path == "igp-instance"):
                        self.igp_instance = value
                        self.igp_instance.value_namespace = name_space
                        self.igp_instance.value_namespace_prefix = name_space_prefix
                    if(value_path == "igp-type"):
                        self.igp_type = value
                        self.igp_type.value_namespace = name_space
                        self.igp_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-full-path"):
                        self.is_full_path = value
                        self.is_full_path.value_namespace = name_space
                        self.is_full_path.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-partial-path"):
                        self.is_partial_path = value
                        self.is_partial_path.value_namespace = name_space
                        self.is_partial_path.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-segment-routing-db-checked"):
                        self.is_segment_routing_db_checked = value
                        self.is_segment_routing_db_checked.value_namespace = name_space
                        self.is_segment_routing_db_checked.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-topology-checked"):
                        self.is_topology_checked = value
                        self.is_topology_checked.value_namespace = name_space
                        self.is_topology_checked.value_namespace_prefix = name_space_prefix
                    if(value_path == "mininum-bandwidth"):
                        self.mininum_bandwidth = value
                        self.mininum_bandwidth.value_namespace = name_space
                        self.mininum_bandwidth.value_namespace_prefix = name_space_prefix
                    if(value_path == "node-hop-count"):
                        self.node_hop_count = value
                        self.node_hop_count.value_namespace = name_space
                        self.node_hop_count.value_namespace_prefix = name_space_prefix
                    if(value_path == "path-id"):
                        self.path_id = value
                        self.path_id.value_namespace = name_space
                        self.path_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "path-name"):
                        self.path_name = value
                        self.path_name.value_namespace = name_space
                        self.path_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "path-type"):
                        self.path_type = value
                        self.path_type.value_namespace = name_space
                        self.path_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "requested-bandwidth"):
                        self.requested_bandwidth = value
                        self.requested_bandwidth.value_namespace = name_space
                        self.requested_bandwidth.value_namespace_prefix = name_space_prefix
                    if(value_path == "setup-priority"):
                        self.setup_priority = value
                        self.setup_priority.value_namespace = name_space
                        self.setup_priority.value_namespace_prefix = name_space_prefix
                    if(value_path == "setup-priority-xr"):
                        self.setup_priority_xr = value
                        self.setup_priority_xr.value_namespace = name_space
                        self.setup_priority_xr.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-id-xr"):
                        self.tunnel_id_xr = value
                        self.tunnel_id_xr.value_namespace = name_space
                        self.tunnel_id_xr.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.destination_path:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.destination_path:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "destination-paths" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/topology/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "destination-path"):
                    for c in self.destination_path:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTeStandby.Topology.DestinationPaths.DestinationPath()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.destination_path.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "destination-path"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass


        class ConfiguredSrlgs(Entity):
            """
            Set of configured SRLG
            
            .. attribute:: configured_srlg
            
            	Configured SRLG value and the addresses using it
            	**type**\: list of    :py:class:`ConfiguredSrlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Topology.ConfiguredSrlgs.ConfiguredSrlg>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTeStandby.Topology.ConfiguredSrlgs, self).__init__()

                self.yang_name = "configured-srlgs"
                self.yang_parent_name = "topology"

                self.configured_srlg = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTeStandby.Topology.ConfiguredSrlgs, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTeStandby.Topology.ConfiguredSrlgs, self).__setattr__(name, value)


            class ConfiguredSrlg(Entity):
                """
                Configured SRLG value and the addresses using
                it
                
                .. attribute:: srlg_number  <key>
                
                	SRLG Number
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: admin_weight
                
                	The admin weight that is added to the link if the SRLG is shared with the protected link
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: is_admin_weight_configured
                
                	Set to TRUE if the admin weight is explicitely configured
                	**type**\:  bool
                
                .. attribute:: srlg_link
                
                	Link associated with the SRLG
                	**type**\: list of    :py:class:`SrlgLink <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Topology.ConfiguredSrlgs.ConfiguredSrlg.SrlgLink>`
                
                .. attribute:: srlg_name
                
                	SRLG name
                	**type**\:  str
                
                .. attribute:: srlg_number_xr
                
                	SRLG number
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTeStandby.Topology.ConfiguredSrlgs.ConfiguredSrlg, self).__init__()

                    self.yang_name = "configured-srlg"
                    self.yang_parent_name = "configured-srlgs"

                    self.srlg_number = YLeaf(YType.int32, "srlg-number")

                    self.admin_weight = YLeaf(YType.uint32, "admin-weight")

                    self.is_admin_weight_configured = YLeaf(YType.boolean, "is-admin-weight-configured")

                    self.srlg_name = YLeaf(YType.str, "srlg-name")

                    self.srlg_number_xr = YLeaf(YType.uint32, "srlg-number-xr")

                    self.srlg_link = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("srlg_number",
                                    "admin_weight",
                                    "is_admin_weight_configured",
                                    "srlg_name",
                                    "srlg_number_xr") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTeStandby.Topology.ConfiguredSrlgs.ConfiguredSrlg, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTeStandby.Topology.ConfiguredSrlgs.ConfiguredSrlg, self).__setattr__(name, value)


                class SrlgLink(Entity):
                    """
                    Link associated with the SRLG
                    
                    .. attribute:: local_address
                    
                    	Local address
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: remote_address
                    
                    	Remote address
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.Topology.ConfiguredSrlgs.ConfiguredSrlg.SrlgLink, self).__init__()

                        self.yang_name = "srlg-link"
                        self.yang_parent_name = "configured-srlg"

                        self.local_address = YLeaf(YType.str, "local-address")

                        self.remote_address = YLeaf(YType.str, "remote-address")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("local_address",
                                        "remote_address") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.Topology.ConfiguredSrlgs.ConfiguredSrlg.SrlgLink, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.Topology.ConfiguredSrlgs.ConfiguredSrlg.SrlgLink, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.local_address.is_set or
                            self.remote_address.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.local_address.yfilter != YFilter.not_set or
                            self.remote_address.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "srlg-link" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.local_address.is_set or self.local_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.local_address.get_name_leafdata())
                        if (self.remote_address.is_set or self.remote_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.remote_address.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "local-address" or name == "remote-address"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "local-address"):
                            self.local_address = value
                            self.local_address.value_namespace = name_space
                            self.local_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "remote-address"):
                            self.remote_address = value
                            self.remote_address.value_namespace = name_space
                            self.remote_address.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.srlg_link:
                        if (c.has_data()):
                            return True
                    return (
                        self.srlg_number.is_set or
                        self.admin_weight.is_set or
                        self.is_admin_weight_configured.is_set or
                        self.srlg_name.is_set or
                        self.srlg_number_xr.is_set)

                def has_operation(self):
                    for c in self.srlg_link:
                        if (c.has_operation()):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        self.srlg_number.yfilter != YFilter.not_set or
                        self.admin_weight.yfilter != YFilter.not_set or
                        self.is_admin_weight_configured.yfilter != YFilter.not_set or
                        self.srlg_name.yfilter != YFilter.not_set or
                        self.srlg_number_xr.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "configured-srlg" + "[srlg-number='" + self.srlg_number.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/topology/configured-srlgs/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.srlg_number.is_set or self.srlg_number.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.srlg_number.get_name_leafdata())
                    if (self.admin_weight.is_set or self.admin_weight.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.admin_weight.get_name_leafdata())
                    if (self.is_admin_weight_configured.is_set or self.is_admin_weight_configured.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_admin_weight_configured.get_name_leafdata())
                    if (self.srlg_name.is_set or self.srlg_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.srlg_name.get_name_leafdata())
                    if (self.srlg_number_xr.is_set or self.srlg_number_xr.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.srlg_number_xr.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "srlg-link"):
                        for c in self.srlg_link:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsTeStandby.Topology.ConfiguredSrlgs.ConfiguredSrlg.SrlgLink()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.srlg_link.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "srlg-link" or name == "srlg-number" or name == "admin-weight" or name == "is-admin-weight-configured" or name == "srlg-name" or name == "srlg-number-xr"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "srlg-number"):
                        self.srlg_number = value
                        self.srlg_number.value_namespace = name_space
                        self.srlg_number.value_namespace_prefix = name_space_prefix
                    if(value_path == "admin-weight"):
                        self.admin_weight = value
                        self.admin_weight.value_namespace = name_space
                        self.admin_weight.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-admin-weight-configured"):
                        self.is_admin_weight_configured = value
                        self.is_admin_weight_configured.value_namespace = name_space
                        self.is_admin_weight_configured.value_namespace_prefix = name_space_prefix
                    if(value_path == "srlg-name"):
                        self.srlg_name = value
                        self.srlg_name.value_namespace = name_space
                        self.srlg_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "srlg-number-xr"):
                        self.srlg_number_xr = value
                        self.srlg_number_xr.value_namespace = name_space
                        self.srlg_number_xr.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.configured_srlg:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.configured_srlg:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "configured-srlgs" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/topology/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "configured-srlg"):
                    for c in self.configured_srlg:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTeStandby.Topology.ConfiguredSrlgs.ConfiguredSrlg()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.configured_srlg.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "configured-srlg"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass


        class Srlgs(Entity):
            """
            Set of SRLG operational value for the overall
            MPLS\-TE topology
            
            .. attribute:: srlg
            
            	SRLG operational value for the overall MPLS\-TE topology
            	**type**\: list of    :py:class:`Srlg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Topology.Srlgs.Srlg>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTeStandby.Topology.Srlgs, self).__init__()

                self.yang_name = "srlgs"
                self.yang_parent_name = "topology"

                self.srlg = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTeStandby.Topology.Srlgs, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTeStandby.Topology.Srlgs, self).__setattr__(name, value)


            class Srlg(Entity):
                """
                SRLG operational value for the overall MPLS\-TE
                topology
                
                .. attribute:: srlg_number  <key>
                
                	SRLG Number
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: admin_weight
                
                	The admin weight that is added to the link if the SRLG is shared with the protected link
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: srlg_areas
                
                	Topology areas in this SRLG
                	**type**\: list of    :py:class:`SrlgAreas <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Topology.Srlgs.Srlg.SrlgAreas>`
                
                .. attribute:: srlg_name
                
                	SRLG name
                	**type**\:  str
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTeStandby.Topology.Srlgs.Srlg, self).__init__()

                    self.yang_name = "srlg"
                    self.yang_parent_name = "srlgs"

                    self.srlg_number = YLeaf(YType.int32, "srlg-number")

                    self.admin_weight = YLeaf(YType.uint32, "admin-weight")

                    self.srlg_name = YLeaf(YType.str, "srlg-name")

                    self.srlg_areas = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("srlg_number",
                                    "admin_weight",
                                    "srlg_name") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTeStandby.Topology.Srlgs.Srlg, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTeStandby.Topology.Srlgs.Srlg, self).__setattr__(name, value)


                class SrlgAreas(Entity):
                    """
                    Topology areas in this SRLG
                    
                    .. attribute:: igp_area
                    
                    	IGP Area ID
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: igp_area_format
                    
                    	IGP\-area format
                    	**type**\:   :py:class:`IgpOspfAreaFormat <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpOspfAreaFormat>`
                    
                    .. attribute:: igp_instance
                    
                    	IGP Instance name
                    	**type**\:  str
                    
                    .. attribute:: igp_type
                    
                    	IGP type
                    	**type**\:   :py:class:`IgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpProtocol>`
                    
                    .. attribute:: srlg_link
                    
                    	Links in this SRLG/area
                    	**type**\: list of    :py:class:`SrlgLink <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.Topology.Srlgs.Srlg.SrlgAreas, self).__init__()

                        self.yang_name = "srlg-areas"
                        self.yang_parent_name = "srlg"

                        self.igp_area = YLeaf(YType.uint32, "igp-area")

                        self.igp_area_format = YLeaf(YType.enumeration, "igp-area-format")

                        self.igp_instance = YLeaf(YType.str, "igp-instance")

                        self.igp_type = YLeaf(YType.enumeration, "igp-type")

                        self.srlg_link = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("igp_area",
                                        "igp_area_format",
                                        "igp_instance",
                                        "igp_type") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.Topology.Srlgs.Srlg.SrlgAreas, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.Topology.Srlgs.Srlg.SrlgAreas, self).__setattr__(name, value)


                    class SrlgLink(Entity):
                        """
                        Links in this SRLG/area
                        
                        .. attribute:: link_address
                        
                        	Link address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: link_address_generic
                        
                        	Link address
                        	**type**\:   :py:class:`LinkAddressGeneric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink.LinkAddressGeneric>`
                        
                        .. attribute:: te_router_id
                        
                        	Link TE router\-id
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink, self).__init__()

                            self.yang_name = "srlg-link"
                            self.yang_parent_name = "srlg-areas"

                            self.link_address = YLeaf(YType.str, "link-address")

                            self.te_router_id = YLeaf(YType.str, "te-router-id")

                            self.link_address_generic = MplsTeStandby.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink.LinkAddressGeneric()
                            self.link_address_generic.parent = self
                            self._children_name_map["link_address_generic"] = "link-address-generic"
                            self._children_yang_names.add("link-address-generic")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("link_address",
                                            "te_router_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink, self).__setattr__(name, value)


                        class LinkAddressGeneric(Entity):
                            """
                            Link address
                            
                            .. attribute:: te_addr
                            
                            	TE Address
                            	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink.LinkAddressGeneric.TeAddr>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink.LinkAddressGeneric, self).__init__()

                                self.yang_name = "link-address-generic"
                                self.yang_parent_name = "srlg-link"

                                self.te_addr = MplsTeStandby.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink.LinkAddressGeneric.TeAddr()
                                self.te_addr.parent = self
                                self._children_name_map["te_addr"] = "te-addr"
                                self._children_yang_names.add("te-addr")


                            class TeAddr(Entity):
                                """
                                TE Address
                                
                                .. attribute:: ipv4_address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: ipv4_unnumbered_address
                                
                                	IPv4 unnumbered address
                                	**type**\:   :py:class:`Ipv4UnnumberedAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink.LinkAddressGeneric.TeAddr.Ipv4UnnumberedAddress>`
                                
                                .. attribute:: type
                                
                                	Type
                                	**type**\:   :py:class:`TeAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAddr>`
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink.LinkAddressGeneric.TeAddr, self).__init__()

                                    self.yang_name = "te-addr"
                                    self.yang_parent_name = "link-address-generic"

                                    self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.ipv4_unnumbered_address = MplsTeStandby.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink.LinkAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                    self.ipv4_unnumbered_address.parent = self
                                    self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                    self._children_yang_names.add("ipv4-unnumbered-address")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("ipv4_address",
                                                    "type") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink.LinkAddressGeneric.TeAddr, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink.LinkAddressGeneric.TeAddr, self).__setattr__(name, value)


                                class Ipv4UnnumberedAddress(Entity):
                                    """
                                    IPv4 unnumbered address
                                    
                                    .. attribute:: interface_index
                                    
                                    	Interface index
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: router_id
                                    
                                    	IPv4 router ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink.LinkAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__init__()

                                        self.yang_name = "ipv4-unnumbered-address"
                                        self.yang_parent_name = "te-addr"

                                        self.interface_index = YLeaf(YType.uint32, "interface-index")

                                        self.router_id = YLeaf(YType.str, "router-id")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("interface_index",
                                                        "router_id") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink.LinkAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink.LinkAddressGeneric.TeAddr.Ipv4UnnumberedAddress, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.interface_index.is_set or
                                            self.router_id.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.interface_index.yfilter != YFilter.not_set or
                                            self.router_id.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "ipv4-unnumbered-address" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.interface_index.is_set or self.interface_index.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.interface_index.get_name_leafdata())
                                        if (self.router_id.is_set or self.router_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.router_id.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "interface-index" or name == "router-id"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "interface-index"):
                                            self.interface_index = value
                                            self.interface_index.value_namespace = name_space
                                            self.interface_index.value_namespace_prefix = name_space_prefix
                                        if(value_path == "router-id"):
                                            self.router_id = value
                                            self.router_id.value_namespace = name_space
                                            self.router_id.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.ipv4_address.is_set or
                                        self.type.is_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.ipv4_address.yfilter != YFilter.not_set or
                                        self.type.yfilter != YFilter.not_set or
                                        (self.ipv4_unnumbered_address is not None and self.ipv4_unnumbered_address.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "te-addr" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.type.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "ipv4-unnumbered-address"):
                                        if (self.ipv4_unnumbered_address is None):
                                            self.ipv4_unnumbered_address = MplsTeStandby.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink.LinkAddressGeneric.TeAddr.Ipv4UnnumberedAddress()
                                            self.ipv4_unnumbered_address.parent = self
                                            self._children_name_map["ipv4_unnumbered_address"] = "ipv4-unnumbered-address"
                                        return self.ipv4_unnumbered_address

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "ipv4-unnumbered-address" or name == "ipv4-address" or name == "type"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "ipv4-address"):
                                        self.ipv4_address = value
                                        self.ipv4_address.value_namespace = name_space
                                        self.ipv4_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "type"):
                                        self.type = value
                                        self.type.value_namespace = name_space
                                        self.type.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (self.te_addr is not None and self.te_addr.has_data())

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    (self.te_addr is not None and self.te_addr.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "link-address-generic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "te-addr"):
                                    if (self.te_addr is None):
                                        self.te_addr = MplsTeStandby.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink.LinkAddressGeneric.TeAddr()
                                        self.te_addr.parent = self
                                        self._children_name_map["te_addr"] = "te-addr"
                                    return self.te_addr

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "te-addr"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass

                        def has_data(self):
                            return (
                                self.link_address.is_set or
                                self.te_router_id.is_set or
                                (self.link_address_generic is not None and self.link_address_generic.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.link_address.yfilter != YFilter.not_set or
                                self.te_router_id.yfilter != YFilter.not_set or
                                (self.link_address_generic is not None and self.link_address_generic.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "srlg-link" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.link_address.is_set or self.link_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.link_address.get_name_leafdata())
                            if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.te_router_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "link-address-generic"):
                                if (self.link_address_generic is None):
                                    self.link_address_generic = MplsTeStandby.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink.LinkAddressGeneric()
                                    self.link_address_generic.parent = self
                                    self._children_name_map["link_address_generic"] = "link-address-generic"
                                return self.link_address_generic

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "link-address-generic" or name == "link-address" or name == "te-router-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "link-address"):
                                self.link_address = value
                                self.link_address.value_namespace = name_space
                                self.link_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "te-router-id"):
                                self.te_router_id = value
                                self.te_router_id.value_namespace = name_space
                                self.te_router_id.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.srlg_link:
                            if (c.has_data()):
                                return True
                        return (
                            self.igp_area.is_set or
                            self.igp_area_format.is_set or
                            self.igp_instance.is_set or
                            self.igp_type.is_set)

                    def has_operation(self):
                        for c in self.srlg_link:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.igp_area.yfilter != YFilter.not_set or
                            self.igp_area_format.yfilter != YFilter.not_set or
                            self.igp_instance.yfilter != YFilter.not_set or
                            self.igp_type.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "srlg-areas" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.igp_area.is_set or self.igp_area.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.igp_area.get_name_leafdata())
                        if (self.igp_area_format.is_set or self.igp_area_format.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.igp_area_format.get_name_leafdata())
                        if (self.igp_instance.is_set or self.igp_instance.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.igp_instance.get_name_leafdata())
                        if (self.igp_type.is_set or self.igp_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.igp_type.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "srlg-link"):
                            for c in self.srlg_link:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.Topology.Srlgs.Srlg.SrlgAreas.SrlgLink()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.srlg_link.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "srlg-link" or name == "igp-area" or name == "igp-area-format" or name == "igp-instance" or name == "igp-type"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "igp-area"):
                            self.igp_area = value
                            self.igp_area.value_namespace = name_space
                            self.igp_area.value_namespace_prefix = name_space_prefix
                        if(value_path == "igp-area-format"):
                            self.igp_area_format = value
                            self.igp_area_format.value_namespace = name_space
                            self.igp_area_format.value_namespace_prefix = name_space_prefix
                        if(value_path == "igp-instance"):
                            self.igp_instance = value
                            self.igp_instance.value_namespace = name_space
                            self.igp_instance.value_namespace_prefix = name_space_prefix
                        if(value_path == "igp-type"):
                            self.igp_type = value
                            self.igp_type.value_namespace = name_space
                            self.igp_type.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.srlg_areas:
                        if (c.has_data()):
                            return True
                    return (
                        self.srlg_number.is_set or
                        self.admin_weight.is_set or
                        self.srlg_name.is_set)

                def has_operation(self):
                    for c in self.srlg_areas:
                        if (c.has_operation()):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        self.srlg_number.yfilter != YFilter.not_set or
                        self.admin_weight.yfilter != YFilter.not_set or
                        self.srlg_name.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "srlg" + "[srlg-number='" + self.srlg_number.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/topology/srlgs/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.srlg_number.is_set or self.srlg_number.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.srlg_number.get_name_leafdata())
                    if (self.admin_weight.is_set or self.admin_weight.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.admin_weight.get_name_leafdata())
                    if (self.srlg_name.is_set or self.srlg_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.srlg_name.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "srlg-areas"):
                        for c in self.srlg_areas:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsTeStandby.Topology.Srlgs.Srlg.SrlgAreas()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.srlg_areas.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "srlg-areas" or name == "srlg-number" or name == "admin-weight" or name == "srlg-name"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "srlg-number"):
                        self.srlg_number = value
                        self.srlg_number.value_namespace = name_space
                        self.srlg_number.value_namespace_prefix = name_space_prefix
                    if(value_path == "admin-weight"):
                        self.admin_weight = value
                        self.admin_weight.value_namespace = name_space
                        self.admin_weight.value_namespace_prefix = name_space_prefix
                    if(value_path == "srlg-name"):
                        self.srlg_name = value
                        self.srlg_name.value_namespace = name_space
                        self.srlg_name.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.srlg:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.srlg:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "srlgs" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/topology/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "srlg"):
                    for c in self.srlg:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTeStandby.Topology.Srlgs.Srlg()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.srlg.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "srlg"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass


        class PathTunnels(Entity):
            """
            MPLS\-Te topology path info
            
            .. attribute:: path_tunnel
            
            	MPLS\-TE topology path taken by the specified tunnel
            	**type**\: list of    :py:class:`PathTunnel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Topology.PathTunnels.PathTunnel>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTeStandby.Topology.PathTunnels, self).__init__()

                self.yang_name = "path-tunnels"
                self.yang_parent_name = "topology"

                self.path_tunnel = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTeStandby.Topology.PathTunnels, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTeStandby.Topology.PathTunnels, self).__setattr__(name, value)


            class PathTunnel(Entity):
                """
                MPLS\-TE topology path taken by the specified
                tunnel
                
                .. attribute:: accumulated_admin_weight
                
                	The path's accumulated admin weight
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                .. attribute:: affinity
                
                	Affinity
                	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Topology.PathTunnels.PathTunnel.Affinity>`
                
                .. attribute:: bandwidth_type
                
                	The path's bandwidth type
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                .. attribute:: destination_address_xr
                
                	The path's destination
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: exclude_srlg_address
                
                	The Exclude SRLG IP Addr
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: hold_priority_xr
                
                	The path's hold priority
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: hop
                
                	The path's array of hops
                	**type**\: list of    :py:class:`Hop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Topology.PathTunnels.PathTunnel.Hop>`
                
                .. attribute:: is_full_path
                
                	TRUE if path is full
                	**type**\:  bool
                
                .. attribute:: is_partial_path
                
                	TRUE if path is partial
                	**type**\:  bool
                
                .. attribute:: is_segment_routing_db_checked
                
                	TRUE if checking the Segment\-Routing DB is enabled
                	**type**\:  bool
                
                .. attribute:: is_topology_checked
                
                	TRUE if checking the topology is enabled
                	**type**\:  bool
                
                .. attribute:: mininum_bandwidth
                
                	The path's minimum bandwidth
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                .. attribute:: node_hop_count
                
                	Path hop count
                	**type**\:  int
                
                	**range:** 0..255
                
                .. attribute:: requested_bandwidth
                
                	The path's requested bandwidth
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                .. attribute:: setup_priority_xr
                
                	The path's setup priority
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: shared_risk_link_group
                
                	The path's excluded srlg groups
                	**type**\: list of    :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Topology.PathTunnels.PathTunnel.SharedRiskLinkGroup>`
                
                .. attribute:: sr_segment
                
                	The path's array of Segment\-Routing segments
                	**type**\: list of    :py:class:`SrSegment <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Topology.PathTunnels.PathTunnel.SrSegment>`
                
                .. attribute:: tunnel_id
                
                	Tunnel ID
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: tunnel_id_xr
                
                	The tunnel ID to which this path belong
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: tunnel_name
                
                	Tunnel name
                	**type**\:  str
                
                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTeStandby.Topology.PathTunnels.PathTunnel, self).__init__()

                    self.yang_name = "path-tunnel"
                    self.yang_parent_name = "path-tunnels"

                    self.accumulated_admin_weight = YLeaf(YType.uint64, "accumulated-admin-weight")

                    self.bandwidth_type = YLeaf(YType.uint64, "bandwidth-type")

                    self.destination_address_xr = YLeaf(YType.str, "destination-address-xr")

                    self.exclude_srlg_address = YLeaf(YType.str, "exclude-srlg-address")

                    self.hold_priority_xr = YLeaf(YType.uint32, "hold-priority-xr")

                    self.is_full_path = YLeaf(YType.boolean, "is-full-path")

                    self.is_partial_path = YLeaf(YType.boolean, "is-partial-path")

                    self.is_segment_routing_db_checked = YLeaf(YType.boolean, "is-segment-routing-db-checked")

                    self.is_topology_checked = YLeaf(YType.boolean, "is-topology-checked")

                    self.mininum_bandwidth = YLeaf(YType.uint64, "mininum-bandwidth")

                    self.node_hop_count = YLeaf(YType.uint8, "node-hop-count")

                    self.requested_bandwidth = YLeaf(YType.uint64, "requested-bandwidth")

                    self.setup_priority_xr = YLeaf(YType.uint32, "setup-priority-xr")

                    self.tunnel_id = YLeaf(YType.int32, "tunnel-id")

                    self.tunnel_id_xr = YLeaf(YType.uint32, "tunnel-id-xr")

                    self.tunnel_name = YLeaf(YType.str, "tunnel-name")

                    self.affinity = MplsTeStandby.Topology.PathTunnels.PathTunnel.Affinity()
                    self.affinity.parent = self
                    self._children_name_map["affinity"] = "affinity"
                    self._children_yang_names.add("affinity")

                    self.hop = YList(self)
                    self.shared_risk_link_group = YList(self)
                    self.sr_segment = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("accumulated_admin_weight",
                                    "bandwidth_type",
                                    "destination_address_xr",
                                    "exclude_srlg_address",
                                    "hold_priority_xr",
                                    "is_full_path",
                                    "is_partial_path",
                                    "is_segment_routing_db_checked",
                                    "is_topology_checked",
                                    "mininum_bandwidth",
                                    "node_hop_count",
                                    "requested_bandwidth",
                                    "setup_priority_xr",
                                    "tunnel_id",
                                    "tunnel_id_xr",
                                    "tunnel_name") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTeStandby.Topology.PathTunnels.PathTunnel, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTeStandby.Topology.PathTunnels.PathTunnel, self).__setattr__(name, value)


                class Affinity(Entity):
                    """
                    Affinity
                    
                    .. attribute:: affinity_bits
                    
                    	The affinity bits (colors)
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: affinity_mask
                    
                    	The affinity mask (colors)
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: named_affinity
                    
                    	Array of name based constratints currently applied to the tunnel
                    	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Topology.PathTunnels.PathTunnel.Affinity.NamedAffinity>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.Topology.PathTunnels.PathTunnel.Affinity, self).__init__()

                        self.yang_name = "affinity"
                        self.yang_parent_name = "path-tunnel"

                        self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                        self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                        self.named_affinity = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("affinity_bits",
                                        "affinity_mask") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.Topology.PathTunnels.PathTunnel.Affinity, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.Topology.PathTunnels.PathTunnel.Affinity, self).__setattr__(name, value)


                    class NamedAffinity(Entity):
                        """
                        Array of name based constratints currently
                        applied to the tunnel
                        
                        .. attribute:: constraint_extended_value
                        
                        	Constraint value
                        	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Topology.PathTunnels.PathTunnel.Affinity.NamedAffinity.ConstraintExtendedValue>`
                        
                        .. attribute:: constraint_type
                        
                        	Constraint type
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        .. attribute:: constraint_value
                        
                        	Deprecated
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: extended_forward_ref_value
                        
                        	Reference bits for undefined affinity names
                        	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Topology.PathTunnels.PathTunnel.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                        
                        .. attribute:: forward_ref_value
                        
                        	Deprecated
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.Topology.PathTunnels.PathTunnel.Affinity.NamedAffinity, self).__init__()

                            self.yang_name = "named-affinity"
                            self.yang_parent_name = "affinity"

                            self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                            self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                            self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                            self.constraint_extended_value = YList(self)
                            self.extended_forward_ref_value = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("constraint_type",
                                            "constraint_value",
                                            "forward_ref_value") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.Topology.PathTunnels.PathTunnel.Affinity.NamedAffinity, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.Topology.PathTunnels.PathTunnel.Affinity.NamedAffinity, self).__setattr__(name, value)


                        class ConstraintExtendedValue(Entity):
                            """
                            Constraint value
                            
                            .. attribute:: entry
                            
                            	
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.Topology.PathTunnels.PathTunnel.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                self.yang_name = "constraint-extended-value"
                                self.yang_parent_name = "named-affinity"

                                self.entry = YLeaf(YType.uint32, "entry")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("entry") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.Topology.PathTunnels.PathTunnel.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.Topology.PathTunnels.PathTunnel.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                            def has_data(self):
                                return self.entry.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.entry.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "constraint-extended-value" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/topology/path-tunnels/path-tunnel/affinity/named-affinity/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "entry"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "entry"):
                                    self.entry = value
                                    self.entry.value_namespace = name_space
                                    self.entry.value_namespace_prefix = name_space_prefix


                        class ExtendedForwardRefValue(Entity):
                            """
                            Reference bits for undefined affinity names
                            
                            .. attribute:: entry
                            
                            	
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.Topology.PathTunnels.PathTunnel.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                self.yang_name = "extended-forward-ref-value"
                                self.yang_parent_name = "named-affinity"

                                self.entry = YLeaf(YType.uint32, "entry")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("entry") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.Topology.PathTunnels.PathTunnel.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.Topology.PathTunnels.PathTunnel.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                            def has_data(self):
                                return self.entry.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.entry.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "extended-forward-ref-value" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/topology/path-tunnels/path-tunnel/affinity/named-affinity/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "entry"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "entry"):
                                    self.entry = value
                                    self.entry.value_namespace = name_space
                                    self.entry.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.constraint_extended_value:
                                if (c.has_data()):
                                    return True
                            for c in self.extended_forward_ref_value:
                                if (c.has_data()):
                                    return True
                            return (
                                self.constraint_type.is_set or
                                self.constraint_value.is_set or
                                self.forward_ref_value.is_set)

                        def has_operation(self):
                            for c in self.constraint_extended_value:
                                if (c.has_operation()):
                                    return True
                            for c in self.extended_forward_ref_value:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.constraint_type.yfilter != YFilter.not_set or
                                self.constraint_value.yfilter != YFilter.not_set or
                                self.forward_ref_value.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "named-affinity" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/topology/path-tunnels/path-tunnel/affinity/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.constraint_type.get_name_leafdata())
                            if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.constraint_value.get_name_leafdata())
                            if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "constraint-extended-value"):
                                for c in self.constraint_extended_value:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.Topology.PathTunnels.PathTunnel.Affinity.NamedAffinity.ConstraintExtendedValue()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.constraint_extended_value.append(c)
                                return c

                            if (child_yang_name == "extended-forward-ref-value"):
                                for c in self.extended_forward_ref_value:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.Topology.PathTunnels.PathTunnel.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.extended_forward_ref_value.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "constraint-type"):
                                self.constraint_type = value
                                self.constraint_type.value_namespace = name_space
                                self.constraint_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "constraint-value"):
                                self.constraint_value = value
                                self.constraint_value.value_namespace = name_space
                                self.constraint_value.value_namespace_prefix = name_space_prefix
                            if(value_path == "forward-ref-value"):
                                self.forward_ref_value = value
                                self.forward_ref_value.value_namespace = name_space
                                self.forward_ref_value.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.named_affinity:
                            if (c.has_data()):
                                return True
                        return (
                            self.affinity_bits.is_set or
                            self.affinity_mask.is_set)

                    def has_operation(self):
                        for c in self.named_affinity:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.affinity_bits.yfilter != YFilter.not_set or
                            self.affinity_mask.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "affinity" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/topology/path-tunnels/path-tunnel/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                        if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "named-affinity"):
                            for c in self.named_affinity:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.Topology.PathTunnels.PathTunnel.Affinity.NamedAffinity()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.named_affinity.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "affinity-bits"):
                            self.affinity_bits = value
                            self.affinity_bits.value_namespace = name_space
                            self.affinity_bits.value_namespace_prefix = name_space_prefix
                        if(value_path == "affinity-mask"):
                            self.affinity_mask = value
                            self.affinity_mask.value_namespace = name_space
                            self.affinity_mask.value_namespace_prefix = name_space_prefix


                class Hop(Entity):
                    """
                    The path's array of hops
                    
                    .. attribute:: entry
                    
                    	
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.Topology.PathTunnels.PathTunnel.Hop, self).__init__()

                        self.yang_name = "hop"
                        self.yang_parent_name = "path-tunnel"

                        self.entry = YLeaf(YType.str, "entry")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("entry") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.Topology.PathTunnels.PathTunnel.Hop, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.Topology.PathTunnels.PathTunnel.Hop, self).__setattr__(name, value)

                    def has_data(self):
                        return self.entry.is_set

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.entry.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "hop" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/topology/path-tunnels/path-tunnel/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.entry.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "entry"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "entry"):
                            self.entry = value
                            self.entry.value_namespace = name_space
                            self.entry.value_namespace_prefix = name_space_prefix


                class SharedRiskLinkGroup(Entity):
                    """
                    The path's excluded srlg groups
                    
                    .. attribute:: shared_risk_group
                    
                    	SRLG number
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: srlg_name
                    
                    	SRLG name
                    	**type**\:  str
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.Topology.PathTunnels.PathTunnel.SharedRiskLinkGroup, self).__init__()

                        self.yang_name = "shared-risk-link-group"
                        self.yang_parent_name = "path-tunnel"

                        self.shared_risk_group = YLeaf(YType.uint32, "shared-risk-group")

                        self.srlg_name = YLeaf(YType.str, "srlg-name")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("shared_risk_group",
                                        "srlg_name") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.Topology.PathTunnels.PathTunnel.SharedRiskLinkGroup, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.Topology.PathTunnels.PathTunnel.SharedRiskLinkGroup, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.shared_risk_group.is_set or
                            self.srlg_name.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.shared_risk_group.yfilter != YFilter.not_set or
                            self.srlg_name.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "shared-risk-link-group" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/topology/path-tunnels/path-tunnel/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.shared_risk_group.is_set or self.shared_risk_group.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.shared_risk_group.get_name_leafdata())
                        if (self.srlg_name.is_set or self.srlg_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.srlg_name.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "shared-risk-group" or name == "srlg-name"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "shared-risk-group"):
                            self.shared_risk_group = value
                            self.shared_risk_group.value_namespace = name_space
                            self.shared_risk_group.value_namespace_prefix = name_space_prefix
                        if(value_path == "srlg-name"):
                            self.srlg_name = value
                            self.srlg_name.value_namespace = name_space
                            self.srlg_name.value_namespace_prefix = name_space_prefix


                class SrSegment(Entity):
                    """
                    The path's array of Segment\-Routing segments
                    
                    .. attribute:: has_entropy_label
                    
                    	Hop has EL specified
                    	**type**\:  bool
                    
                    .. attribute:: has_ip_addresses
                    
                    	Node has IP addresses specified
                    	**type**\:  bool
                    
                    .. attribute:: has_mpls_label
                    
                    	Hop has MPLS label specified
                    	**type**\:  bool
                    
                    .. attribute:: local_addr
                    
                    	Local IP address of adjacency or Node ID
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: mpls_label_value
                    
                    	The MPLS label value
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: remote_addr
                    
                    	Remote IP address of adjacency
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: sid_type
                    
                    	Type of the SID
                    	**type**\:   :py:class:`TeSrSid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSrSid>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.Topology.PathTunnels.PathTunnel.SrSegment, self).__init__()

                        self.yang_name = "sr-segment"
                        self.yang_parent_name = "path-tunnel"

                        self.has_entropy_label = YLeaf(YType.boolean, "has-entropy-label")

                        self.has_ip_addresses = YLeaf(YType.boolean, "has-ip-addresses")

                        self.has_mpls_label = YLeaf(YType.boolean, "has-mpls-label")

                        self.local_addr = YLeaf(YType.str, "local-addr")

                        self.mpls_label_value = YLeaf(YType.uint32, "mpls-label-value")

                        self.remote_addr = YLeaf(YType.str, "remote-addr")

                        self.sid_type = YLeaf(YType.enumeration, "sid-type")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("has_entropy_label",
                                        "has_ip_addresses",
                                        "has_mpls_label",
                                        "local_addr",
                                        "mpls_label_value",
                                        "remote_addr",
                                        "sid_type") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.Topology.PathTunnels.PathTunnel.SrSegment, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.Topology.PathTunnels.PathTunnel.SrSegment, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.has_entropy_label.is_set or
                            self.has_ip_addresses.is_set or
                            self.has_mpls_label.is_set or
                            self.local_addr.is_set or
                            self.mpls_label_value.is_set or
                            self.remote_addr.is_set or
                            self.sid_type.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.has_entropy_label.yfilter != YFilter.not_set or
                            self.has_ip_addresses.yfilter != YFilter.not_set or
                            self.has_mpls_label.yfilter != YFilter.not_set or
                            self.local_addr.yfilter != YFilter.not_set or
                            self.mpls_label_value.yfilter != YFilter.not_set or
                            self.remote_addr.yfilter != YFilter.not_set or
                            self.sid_type.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "sr-segment" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/topology/path-tunnels/path-tunnel/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.has_entropy_label.is_set or self.has_entropy_label.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.has_entropy_label.get_name_leafdata())
                        if (self.has_ip_addresses.is_set or self.has_ip_addresses.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.has_ip_addresses.get_name_leafdata())
                        if (self.has_mpls_label.is_set or self.has_mpls_label.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.has_mpls_label.get_name_leafdata())
                        if (self.local_addr.is_set or self.local_addr.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.local_addr.get_name_leafdata())
                        if (self.mpls_label_value.is_set or self.mpls_label_value.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.mpls_label_value.get_name_leafdata())
                        if (self.remote_addr.is_set or self.remote_addr.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.remote_addr.get_name_leafdata())
                        if (self.sid_type.is_set or self.sid_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.sid_type.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "has-entropy-label" or name == "has-ip-addresses" or name == "has-mpls-label" or name == "local-addr" or name == "mpls-label-value" or name == "remote-addr" or name == "sid-type"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "has-entropy-label"):
                            self.has_entropy_label = value
                            self.has_entropy_label.value_namespace = name_space
                            self.has_entropy_label.value_namespace_prefix = name_space_prefix
                        if(value_path == "has-ip-addresses"):
                            self.has_ip_addresses = value
                            self.has_ip_addresses.value_namespace = name_space
                            self.has_ip_addresses.value_namespace_prefix = name_space_prefix
                        if(value_path == "has-mpls-label"):
                            self.has_mpls_label = value
                            self.has_mpls_label.value_namespace = name_space
                            self.has_mpls_label.value_namespace_prefix = name_space_prefix
                        if(value_path == "local-addr"):
                            self.local_addr = value
                            self.local_addr.value_namespace = name_space
                            self.local_addr.value_namespace_prefix = name_space_prefix
                        if(value_path == "mpls-label-value"):
                            self.mpls_label_value = value
                            self.mpls_label_value.value_namespace = name_space
                            self.mpls_label_value.value_namespace_prefix = name_space_prefix
                        if(value_path == "remote-addr"):
                            self.remote_addr = value
                            self.remote_addr.value_namespace = name_space
                            self.remote_addr.value_namespace_prefix = name_space_prefix
                        if(value_path == "sid-type"):
                            self.sid_type = value
                            self.sid_type.value_namespace = name_space
                            self.sid_type.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.hop:
                        if (c.has_data()):
                            return True
                    for c in self.shared_risk_link_group:
                        if (c.has_data()):
                            return True
                    for c in self.sr_segment:
                        if (c.has_data()):
                            return True
                    return (
                        self.accumulated_admin_weight.is_set or
                        self.bandwidth_type.is_set or
                        self.destination_address_xr.is_set or
                        self.exclude_srlg_address.is_set or
                        self.hold_priority_xr.is_set or
                        self.is_full_path.is_set or
                        self.is_partial_path.is_set or
                        self.is_segment_routing_db_checked.is_set or
                        self.is_topology_checked.is_set or
                        self.mininum_bandwidth.is_set or
                        self.node_hop_count.is_set or
                        self.requested_bandwidth.is_set or
                        self.setup_priority_xr.is_set or
                        self.tunnel_id.is_set or
                        self.tunnel_id_xr.is_set or
                        self.tunnel_name.is_set or
                        (self.affinity is not None and self.affinity.has_data()))

                def has_operation(self):
                    for c in self.hop:
                        if (c.has_operation()):
                            return True
                    for c in self.shared_risk_link_group:
                        if (c.has_operation()):
                            return True
                    for c in self.sr_segment:
                        if (c.has_operation()):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        self.accumulated_admin_weight.yfilter != YFilter.not_set or
                        self.bandwidth_type.yfilter != YFilter.not_set or
                        self.destination_address_xr.yfilter != YFilter.not_set or
                        self.exclude_srlg_address.yfilter != YFilter.not_set or
                        self.hold_priority_xr.yfilter != YFilter.not_set or
                        self.is_full_path.yfilter != YFilter.not_set or
                        self.is_partial_path.yfilter != YFilter.not_set or
                        self.is_segment_routing_db_checked.yfilter != YFilter.not_set or
                        self.is_topology_checked.yfilter != YFilter.not_set or
                        self.mininum_bandwidth.yfilter != YFilter.not_set or
                        self.node_hop_count.yfilter != YFilter.not_set or
                        self.requested_bandwidth.yfilter != YFilter.not_set or
                        self.setup_priority_xr.yfilter != YFilter.not_set or
                        self.tunnel_id.yfilter != YFilter.not_set or
                        self.tunnel_id_xr.yfilter != YFilter.not_set or
                        self.tunnel_name.yfilter != YFilter.not_set or
                        (self.affinity is not None and self.affinity.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "path-tunnel" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/topology/path-tunnels/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.accumulated_admin_weight.is_set or self.accumulated_admin_weight.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.accumulated_admin_weight.get_name_leafdata())
                    if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                    if (self.destination_address_xr.is_set or self.destination_address_xr.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.destination_address_xr.get_name_leafdata())
                    if (self.exclude_srlg_address.is_set or self.exclude_srlg_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.exclude_srlg_address.get_name_leafdata())
                    if (self.hold_priority_xr.is_set or self.hold_priority_xr.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.hold_priority_xr.get_name_leafdata())
                    if (self.is_full_path.is_set or self.is_full_path.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_full_path.get_name_leafdata())
                    if (self.is_partial_path.is_set or self.is_partial_path.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_partial_path.get_name_leafdata())
                    if (self.is_segment_routing_db_checked.is_set or self.is_segment_routing_db_checked.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_segment_routing_db_checked.get_name_leafdata())
                    if (self.is_topology_checked.is_set or self.is_topology_checked.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_topology_checked.get_name_leafdata())
                    if (self.mininum_bandwidth.is_set or self.mininum_bandwidth.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.mininum_bandwidth.get_name_leafdata())
                    if (self.node_hop_count.is_set or self.node_hop_count.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.node_hop_count.get_name_leafdata())
                    if (self.requested_bandwidth.is_set or self.requested_bandwidth.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.requested_bandwidth.get_name_leafdata())
                    if (self.setup_priority_xr.is_set or self.setup_priority_xr.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.setup_priority_xr.get_name_leafdata())
                    if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_id.get_name_leafdata())
                    if (self.tunnel_id_xr.is_set or self.tunnel_id_xr.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_id_xr.get_name_leafdata())
                    if (self.tunnel_name.is_set or self.tunnel_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_name.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "affinity"):
                        if (self.affinity is None):
                            self.affinity = MplsTeStandby.Topology.PathTunnels.PathTunnel.Affinity()
                            self.affinity.parent = self
                            self._children_name_map["affinity"] = "affinity"
                        return self.affinity

                    if (child_yang_name == "hop"):
                        for c in self.hop:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsTeStandby.Topology.PathTunnels.PathTunnel.Hop()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.hop.append(c)
                        return c

                    if (child_yang_name == "shared-risk-link-group"):
                        for c in self.shared_risk_link_group:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsTeStandby.Topology.PathTunnels.PathTunnel.SharedRiskLinkGroup()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.shared_risk_link_group.append(c)
                        return c

                    if (child_yang_name == "sr-segment"):
                        for c in self.sr_segment:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsTeStandby.Topology.PathTunnels.PathTunnel.SrSegment()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.sr_segment.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "affinity" or name == "hop" or name == "shared-risk-link-group" or name == "sr-segment" or name == "accumulated-admin-weight" or name == "bandwidth-type" or name == "destination-address-xr" or name == "exclude-srlg-address" or name == "hold-priority-xr" or name == "is-full-path" or name == "is-partial-path" or name == "is-segment-routing-db-checked" or name == "is-topology-checked" or name == "mininum-bandwidth" or name == "node-hop-count" or name == "requested-bandwidth" or name == "setup-priority-xr" or name == "tunnel-id" or name == "tunnel-id-xr" or name == "tunnel-name"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "accumulated-admin-weight"):
                        self.accumulated_admin_weight = value
                        self.accumulated_admin_weight.value_namespace = name_space
                        self.accumulated_admin_weight.value_namespace_prefix = name_space_prefix
                    if(value_path == "bandwidth-type"):
                        self.bandwidth_type = value
                        self.bandwidth_type.value_namespace = name_space
                        self.bandwidth_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "destination-address-xr"):
                        self.destination_address_xr = value
                        self.destination_address_xr.value_namespace = name_space
                        self.destination_address_xr.value_namespace_prefix = name_space_prefix
                    if(value_path == "exclude-srlg-address"):
                        self.exclude_srlg_address = value
                        self.exclude_srlg_address.value_namespace = name_space
                        self.exclude_srlg_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "hold-priority-xr"):
                        self.hold_priority_xr = value
                        self.hold_priority_xr.value_namespace = name_space
                        self.hold_priority_xr.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-full-path"):
                        self.is_full_path = value
                        self.is_full_path.value_namespace = name_space
                        self.is_full_path.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-partial-path"):
                        self.is_partial_path = value
                        self.is_partial_path.value_namespace = name_space
                        self.is_partial_path.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-segment-routing-db-checked"):
                        self.is_segment_routing_db_checked = value
                        self.is_segment_routing_db_checked.value_namespace = name_space
                        self.is_segment_routing_db_checked.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-topology-checked"):
                        self.is_topology_checked = value
                        self.is_topology_checked.value_namespace = name_space
                        self.is_topology_checked.value_namespace_prefix = name_space_prefix
                    if(value_path == "mininum-bandwidth"):
                        self.mininum_bandwidth = value
                        self.mininum_bandwidth.value_namespace = name_space
                        self.mininum_bandwidth.value_namespace_prefix = name_space_prefix
                    if(value_path == "node-hop-count"):
                        self.node_hop_count = value
                        self.node_hop_count.value_namespace = name_space
                        self.node_hop_count.value_namespace_prefix = name_space_prefix
                    if(value_path == "requested-bandwidth"):
                        self.requested_bandwidth = value
                        self.requested_bandwidth.value_namespace = name_space
                        self.requested_bandwidth.value_namespace_prefix = name_space_prefix
                    if(value_path == "setup-priority-xr"):
                        self.setup_priority_xr = value
                        self.setup_priority_xr.value_namespace = name_space
                        self.setup_priority_xr.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-id"):
                        self.tunnel_id = value
                        self.tunnel_id.value_namespace = name_space
                        self.tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-id-xr"):
                        self.tunnel_id_xr = value
                        self.tunnel_id_xr.value_namespace = name_space
                        self.tunnel_id_xr.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-name"):
                        self.tunnel_name = value
                        self.tunnel_name.value_namespace = name_space
                        self.tunnel_name.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.path_tunnel:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.path_tunnel:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "path-tunnels" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/topology/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "path-tunnel"):
                    for c in self.path_tunnel:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTeStandby.Topology.PathTunnels.PathTunnel()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.path_tunnel.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "path-tunnel"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass

        def has_data(self):
            return (
                (self.configured_srlgs is not None and self.configured_srlgs.has_data()) or
                (self.destination_paths is not None and self.destination_paths.has_data()) or
                (self.global_ is not None and self.global_.has_data()) or
                (self.path_tunnels is not None and self.path_tunnels.has_data()) or
                (self.srlgs is not None and self.srlgs.has_data()))

        def has_operation(self):
            return (
                self.yfilter != YFilter.not_set or
                (self.configured_srlgs is not None and self.configured_srlgs.has_operation()) or
                (self.destination_paths is not None and self.destination_paths.has_operation()) or
                (self.global_ is not None and self.global_.has_operation()) or
                (self.path_tunnels is not None and self.path_tunnels.has_operation()) or
                (self.srlgs is not None and self.srlgs.has_operation()))

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "topology" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "configured-srlgs"):
                if (self.configured_srlgs is None):
                    self.configured_srlgs = MplsTeStandby.Topology.ConfiguredSrlgs()
                    self.configured_srlgs.parent = self
                    self._children_name_map["configured_srlgs"] = "configured-srlgs"
                return self.configured_srlgs

            if (child_yang_name == "destination-paths"):
                if (self.destination_paths is None):
                    self.destination_paths = MplsTeStandby.Topology.DestinationPaths()
                    self.destination_paths.parent = self
                    self._children_name_map["destination_paths"] = "destination-paths"
                return self.destination_paths

            if (child_yang_name == "global"):
                if (self.global_ is None):
                    self.global_ = MplsTeStandby.Topology.Global_()
                    self.global_.parent = self
                    self._children_name_map["global_"] = "global"
                return self.global_

            if (child_yang_name == "path-tunnels"):
                if (self.path_tunnels is None):
                    self.path_tunnels = MplsTeStandby.Topology.PathTunnels()
                    self.path_tunnels.parent = self
                    self._children_name_map["path_tunnels"] = "path-tunnels"
                return self.path_tunnels

            if (child_yang_name == "srlgs"):
                if (self.srlgs is None):
                    self.srlgs = MplsTeStandby.Topology.Srlgs()
                    self.srlgs.parent = self
                    self._children_name_map["srlgs"] = "srlgs"
                return self.srlgs

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "configured-srlgs" or name == "destination-paths" or name == "global" or name == "path-tunnels" or name == "srlgs"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class SignallingCounters(Entity):
        """
        TE counters
        
        .. attribute:: head_signalling_counters
        
        	Sig Head Table TE counters
        	**type**\:   :py:class:`HeadSignallingCounters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.HeadSignallingCounters>`
        
        .. attribute:: heads_counters
        
        	MPLS TE counters signalling heads table
        	**type**\:   :py:class:`HeadsCounters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.HeadsCounters>`
        
        .. attribute:: issu
        
        	MPLS TE ISSU counters
        	**type**\:   :py:class:`Issu <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.Issu>`
        
        .. attribute:: mids_counters
        
        	MPLS TE counters signalling heads table
        	**type**\:   :py:class:`MidsCounters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.MidsCounters>`
        
        .. attribute:: remote_signalling_counters
        
        	Sig mid tail Table TE counters
        	**type**\:   :py:class:`RemoteSignallingCounters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.RemoteSignallingCounters>`
        
        .. attribute:: signalling_summary
        
        	Send\-Recv count summary for TE Signaling
        	**type**\:   :py:class:`SignallingSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.SignallingSummary>`
        
        .. attribute:: signallings
        
        	TE counters
        	**type**\:   :py:class:`Signallings <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.Signallings>`
        
        .. attribute:: tails_counters
        
        	MPLS TE counters signalling heads table
        	**type**\:   :py:class:`TailsCounters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.TailsCounters>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsTeStandby.SignallingCounters, self).__init__()

            self.yang_name = "signalling-counters"
            self.yang_parent_name = "mpls-te-standby"

            self.head_signalling_counters = MplsTeStandby.SignallingCounters.HeadSignallingCounters()
            self.head_signalling_counters.parent = self
            self._children_name_map["head_signalling_counters"] = "head-signalling-counters"
            self._children_yang_names.add("head-signalling-counters")

            self.heads_counters = MplsTeStandby.SignallingCounters.HeadsCounters()
            self.heads_counters.parent = self
            self._children_name_map["heads_counters"] = "heads-counters"
            self._children_yang_names.add("heads-counters")

            self.issu = MplsTeStandby.SignallingCounters.Issu()
            self.issu.parent = self
            self._children_name_map["issu"] = "issu"
            self._children_yang_names.add("issu")

            self.mids_counters = MplsTeStandby.SignallingCounters.MidsCounters()
            self.mids_counters.parent = self
            self._children_name_map["mids_counters"] = "mids-counters"
            self._children_yang_names.add("mids-counters")

            self.remote_signalling_counters = MplsTeStandby.SignallingCounters.RemoteSignallingCounters()
            self.remote_signalling_counters.parent = self
            self._children_name_map["remote_signalling_counters"] = "remote-signalling-counters"
            self._children_yang_names.add("remote-signalling-counters")

            self.signalling_summary = MplsTeStandby.SignallingCounters.SignallingSummary()
            self.signalling_summary.parent = self
            self._children_name_map["signalling_summary"] = "signalling-summary"
            self._children_yang_names.add("signalling-summary")

            self.signallings = MplsTeStandby.SignallingCounters.Signallings()
            self.signallings.parent = self
            self._children_name_map["signallings"] = "signallings"
            self._children_yang_names.add("signallings")

            self.tails_counters = MplsTeStandby.SignallingCounters.TailsCounters()
            self.tails_counters.parent = self
            self._children_name_map["tails_counters"] = "tails-counters"
            self._children_yang_names.add("tails-counters")


        class Issu(Entity):
            """
            MPLS TE ISSU counters
            
            .. attribute:: last_cleared_timestamp
            
            	The timestamp, in seconds, when these statistics are cleared              since 00\:00\:00 UTC, January 1, 1970
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            	**units**\: second
            
            .. attribute:: last_idt_states
            
            	Last IDT States
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: role
            
            	Process role
            	**type**\:   :py:class:`TeProcRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProcRole>`
            
            .. attribute:: total_deletions
            
            	Total deletions
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: total_id_ts
            
            	Total IDTs
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: total_nac_ks
            
            	Total NACKs
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            .. attribute:: total_states
            
            	Total states
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTeStandby.SignallingCounters.Issu, self).__init__()

                self.yang_name = "issu"
                self.yang_parent_name = "signalling-counters"

                self.last_cleared_timestamp = YLeaf(YType.uint32, "last-cleared-timestamp")

                self.last_idt_states = YLeaf(YType.uint32, "last-idt-states")

                self.role = YLeaf(YType.enumeration, "role")

                self.total_deletions = YLeaf(YType.uint32, "total-deletions")

                self.total_id_ts = YLeaf(YType.uint32, "total-id-ts")

                self.total_nac_ks = YLeaf(YType.uint64, "total-nac-ks")

                self.total_states = YLeaf(YType.uint32, "total-states")

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("last_cleared_timestamp",
                                "last_idt_states",
                                "role",
                                "total_deletions",
                                "total_id_ts",
                                "total_nac_ks",
                                "total_states") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTeStandby.SignallingCounters.Issu, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTeStandby.SignallingCounters.Issu, self).__setattr__(name, value)

            def has_data(self):
                return (
                    self.last_cleared_timestamp.is_set or
                    self.last_idt_states.is_set or
                    self.role.is_set or
                    self.total_deletions.is_set or
                    self.total_id_ts.is_set or
                    self.total_nac_ks.is_set or
                    self.total_states.is_set)

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    self.last_cleared_timestamp.yfilter != YFilter.not_set or
                    self.last_idt_states.yfilter != YFilter.not_set or
                    self.role.yfilter != YFilter.not_set or
                    self.total_deletions.yfilter != YFilter.not_set or
                    self.total_id_ts.yfilter != YFilter.not_set or
                    self.total_nac_ks.yfilter != YFilter.not_set or
                    self.total_states.yfilter != YFilter.not_set)

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "issu" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/signalling-counters/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.last_cleared_timestamp.is_set or self.last_cleared_timestamp.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.last_cleared_timestamp.get_name_leafdata())
                if (self.last_idt_states.is_set or self.last_idt_states.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.last_idt_states.get_name_leafdata())
                if (self.role.is_set or self.role.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.role.get_name_leafdata())
                if (self.total_deletions.is_set or self.total_deletions.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.total_deletions.get_name_leafdata())
                if (self.total_id_ts.is_set or self.total_id_ts.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.total_id_ts.get_name_leafdata())
                if (self.total_nac_ks.is_set or self.total_nac_ks.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.total_nac_ks.get_name_leafdata())
                if (self.total_states.is_set or self.total_states.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.total_states.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "last-cleared-timestamp" or name == "last-idt-states" or name == "role" or name == "total-deletions" or name == "total-id-ts" or name == "total-nac-ks" or name == "total-states"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "last-cleared-timestamp"):
                    self.last_cleared_timestamp = value
                    self.last_cleared_timestamp.value_namespace = name_space
                    self.last_cleared_timestamp.value_namespace_prefix = name_space_prefix
                if(value_path == "last-idt-states"):
                    self.last_idt_states = value
                    self.last_idt_states.value_namespace = name_space
                    self.last_idt_states.value_namespace_prefix = name_space_prefix
                if(value_path == "role"):
                    self.role = value
                    self.role.value_namespace = name_space
                    self.role.value_namespace_prefix = name_space_prefix
                if(value_path == "total-deletions"):
                    self.total_deletions = value
                    self.total_deletions.value_namespace = name_space
                    self.total_deletions.value_namespace_prefix = name_space_prefix
                if(value_path == "total-id-ts"):
                    self.total_id_ts = value
                    self.total_id_ts.value_namespace = name_space
                    self.total_id_ts.value_namespace_prefix = name_space_prefix
                if(value_path == "total-nac-ks"):
                    self.total_nac_ks = value
                    self.total_nac_ks.value_namespace = name_space
                    self.total_nac_ks.value_namespace_prefix = name_space_prefix
                if(value_path == "total-states"):
                    self.total_states = value
                    self.total_states.value_namespace = name_space
                    self.total_states.value_namespace_prefix = name_space_prefix


        class HeadsCounters(Entity):
            """
            MPLS TE counters signalling heads table
            
            .. attribute:: heads_counter
            
            	MPLS TE counters signalling head
            	**type**\: list of    :py:class:`HeadsCounter <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.HeadsCounters.HeadsCounter>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTeStandby.SignallingCounters.HeadsCounters, self).__init__()

                self.yang_name = "heads-counters"
                self.yang_parent_name = "signalling-counters"

                self.heads_counter = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTeStandby.SignallingCounters.HeadsCounters, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTeStandby.SignallingCounters.HeadsCounters, self).__setattr__(name, value)


            class HeadsCounter(Entity):
                """
                MPLS TE counters signalling head
                
                .. attribute:: tunnel_id  <key>
                
                	tunnel id of last obtained tunnel
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: destination_statistic
                
                	List of Destination Stats
                	**type**\: list of    :py:class:`DestinationStatistic <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.HeadsCounters.HeadsCounter.DestinationStatistic>`
                
                .. attribute:: lsp_id
                
                	LSP ID
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: statistics
                
                	VIF stats
                	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.HeadsCounters.HeadsCounter.Statistics>`
                
                .. attribute:: tunnel_name
                
                	Tunnel Name
                	**type**\:  str
                
                .. attribute:: tunnel_sig_name
                
                	Tunnel Signalled\-Name
                	**type**\:  str
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTeStandby.SignallingCounters.HeadsCounters.HeadsCounter, self).__init__()

                    self.yang_name = "heads-counter"
                    self.yang_parent_name = "heads-counters"

                    self.tunnel_id = YLeaf(YType.int32, "tunnel-id")

                    self.lsp_id = YLeaf(YType.uint16, "lsp-id")

                    self.tunnel_name = YLeaf(YType.str, "tunnel-name")

                    self.tunnel_sig_name = YLeaf(YType.str, "tunnel-sig-name")

                    self.statistics = MplsTeStandby.SignallingCounters.HeadsCounters.HeadsCounter.Statistics()
                    self.statistics.parent = self
                    self._children_name_map["statistics"] = "statistics"
                    self._children_yang_names.add("statistics")

                    self.destination_statistic = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("tunnel_id",
                                    "lsp_id",
                                    "tunnel_name",
                                    "tunnel_sig_name") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTeStandby.SignallingCounters.HeadsCounters.HeadsCounter, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTeStandby.SignallingCounters.HeadsCounters.HeadsCounter, self).__setattr__(name, value)


                class Statistics(Entity):
                    """
                    VIF stats
                    
                    .. attribute:: events_count
                    
                    	TE Signaling event count
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: events_total_count
                    
                    	Total TE Signalling event count
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_backup_assign_err_event
                    
                    	Error on Backup Assign event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_event_unknown
                    
                    	RX Unknown events
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_path_change_event
                    
                    	RX Path Change event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_path_create_event
                    
                    	RX Path Create event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_path_delete_event
                    
                    	RX Path Delete event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_path_error_event
                    
                    	RX Path Error event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_path_reeval_query_event
                    
                    	RX Path Reeval Query event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_resv_change_event
                    
                    	RX Resv Change event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_resv_create_event
                    
                    	RX Resv Create event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_resv_delete_event
                    
                    	RX Resv Delete event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_resv_error_event
                    
                    	RX Resv Error event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_backup_assign_event
                    
                    	Backup Assign event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_event_unknown
                    
                    	Unknown TX events
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_path_change_event
                    
                    	TX Path Change event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_path_create_event
                    
                    	TX Path Create event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_path_delete_event
                    
                    	TX Path Delete event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_path_error_event
                    
                    	TX Path Error event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_path_reeval_query_event
                    
                    	TX Path Reeval Query event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_resv_change_event
                    
                    	TX Resv Change event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_resv_create_event
                    
                    	TX Resv Create event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_resv_delete_event
                    
                    	TX Resv Delete event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_resv_error_event
                    
                    	TX Resv Error event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.SignallingCounters.HeadsCounters.HeadsCounter.Statistics, self).__init__()

                        self.yang_name = "statistics"
                        self.yang_parent_name = "heads-counter"

                        self.events_count = YLeaf(YType.uint32, "events-count")

                        self.events_total_count = YLeaf(YType.uint32, "events-total-count")

                        self.rx_backup_assign_err_event = YLeaf(YType.uint32, "rx-backup-assign-err-event")

                        self.rx_event_unknown = YLeaf(YType.uint32, "rx-event-unknown")

                        self.rx_path_change_event = YLeaf(YType.uint32, "rx-path-change-event")

                        self.rx_path_create_event = YLeaf(YType.uint32, "rx-path-create-event")

                        self.rx_path_delete_event = YLeaf(YType.uint32, "rx-path-delete-event")

                        self.rx_path_error_event = YLeaf(YType.uint32, "rx-path-error-event")

                        self.rx_path_reeval_query_event = YLeaf(YType.uint32, "rx-path-reeval-query-event")

                        self.rx_resv_change_event = YLeaf(YType.uint32, "rx-resv-change-event")

                        self.rx_resv_create_event = YLeaf(YType.uint32, "rx-resv-create-event")

                        self.rx_resv_delete_event = YLeaf(YType.uint32, "rx-resv-delete-event")

                        self.rx_resv_error_event = YLeaf(YType.uint32, "rx-resv-error-event")

                        self.tx_backup_assign_event = YLeaf(YType.uint32, "tx-backup-assign-event")

                        self.tx_event_unknown = YLeaf(YType.uint32, "tx-event-unknown")

                        self.tx_path_change_event = YLeaf(YType.uint32, "tx-path-change-event")

                        self.tx_path_create_event = YLeaf(YType.uint32, "tx-path-create-event")

                        self.tx_path_delete_event = YLeaf(YType.uint32, "tx-path-delete-event")

                        self.tx_path_error_event = YLeaf(YType.uint32, "tx-path-error-event")

                        self.tx_path_reeval_query_event = YLeaf(YType.uint32, "tx-path-reeval-query-event")

                        self.tx_resv_change_event = YLeaf(YType.uint32, "tx-resv-change-event")

                        self.tx_resv_create_event = YLeaf(YType.uint32, "tx-resv-create-event")

                        self.tx_resv_delete_event = YLeaf(YType.uint32, "tx-resv-delete-event")

                        self.tx_resv_error_event = YLeaf(YType.uint32, "tx-resv-error-event")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("events_count",
                                        "events_total_count",
                                        "rx_backup_assign_err_event",
                                        "rx_event_unknown",
                                        "rx_path_change_event",
                                        "rx_path_create_event",
                                        "rx_path_delete_event",
                                        "rx_path_error_event",
                                        "rx_path_reeval_query_event",
                                        "rx_resv_change_event",
                                        "rx_resv_create_event",
                                        "rx_resv_delete_event",
                                        "rx_resv_error_event",
                                        "tx_backup_assign_event",
                                        "tx_event_unknown",
                                        "tx_path_change_event",
                                        "tx_path_create_event",
                                        "tx_path_delete_event",
                                        "tx_path_error_event",
                                        "tx_path_reeval_query_event",
                                        "tx_resv_change_event",
                                        "tx_resv_create_event",
                                        "tx_resv_delete_event",
                                        "tx_resv_error_event") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.SignallingCounters.HeadsCounters.HeadsCounter.Statistics, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.SignallingCounters.HeadsCounters.HeadsCounter.Statistics, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.events_count.is_set or
                            self.events_total_count.is_set or
                            self.rx_backup_assign_err_event.is_set or
                            self.rx_event_unknown.is_set or
                            self.rx_path_change_event.is_set or
                            self.rx_path_create_event.is_set or
                            self.rx_path_delete_event.is_set or
                            self.rx_path_error_event.is_set or
                            self.rx_path_reeval_query_event.is_set or
                            self.rx_resv_change_event.is_set or
                            self.rx_resv_create_event.is_set or
                            self.rx_resv_delete_event.is_set or
                            self.rx_resv_error_event.is_set or
                            self.tx_backup_assign_event.is_set or
                            self.tx_event_unknown.is_set or
                            self.tx_path_change_event.is_set or
                            self.tx_path_create_event.is_set or
                            self.tx_path_delete_event.is_set or
                            self.tx_path_error_event.is_set or
                            self.tx_path_reeval_query_event.is_set or
                            self.tx_resv_change_event.is_set or
                            self.tx_resv_create_event.is_set or
                            self.tx_resv_delete_event.is_set or
                            self.tx_resv_error_event.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.events_count.yfilter != YFilter.not_set or
                            self.events_total_count.yfilter != YFilter.not_set or
                            self.rx_backup_assign_err_event.yfilter != YFilter.not_set or
                            self.rx_event_unknown.yfilter != YFilter.not_set or
                            self.rx_path_change_event.yfilter != YFilter.not_set or
                            self.rx_path_create_event.yfilter != YFilter.not_set or
                            self.rx_path_delete_event.yfilter != YFilter.not_set or
                            self.rx_path_error_event.yfilter != YFilter.not_set or
                            self.rx_path_reeval_query_event.yfilter != YFilter.not_set or
                            self.rx_resv_change_event.yfilter != YFilter.not_set or
                            self.rx_resv_create_event.yfilter != YFilter.not_set or
                            self.rx_resv_delete_event.yfilter != YFilter.not_set or
                            self.rx_resv_error_event.yfilter != YFilter.not_set or
                            self.tx_backup_assign_event.yfilter != YFilter.not_set or
                            self.tx_event_unknown.yfilter != YFilter.not_set or
                            self.tx_path_change_event.yfilter != YFilter.not_set or
                            self.tx_path_create_event.yfilter != YFilter.not_set or
                            self.tx_path_delete_event.yfilter != YFilter.not_set or
                            self.tx_path_error_event.yfilter != YFilter.not_set or
                            self.tx_path_reeval_query_event.yfilter != YFilter.not_set or
                            self.tx_resv_change_event.yfilter != YFilter.not_set or
                            self.tx_resv_create_event.yfilter != YFilter.not_set or
                            self.tx_resv_delete_event.yfilter != YFilter.not_set or
                            self.tx_resv_error_event.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "statistics" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.events_count.is_set or self.events_count.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.events_count.get_name_leafdata())
                        if (self.events_total_count.is_set or self.events_total_count.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.events_total_count.get_name_leafdata())
                        if (self.rx_backup_assign_err_event.is_set or self.rx_backup_assign_err_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_backup_assign_err_event.get_name_leafdata())
                        if (self.rx_event_unknown.is_set or self.rx_event_unknown.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_event_unknown.get_name_leafdata())
                        if (self.rx_path_change_event.is_set or self.rx_path_change_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_path_change_event.get_name_leafdata())
                        if (self.rx_path_create_event.is_set or self.rx_path_create_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_path_create_event.get_name_leafdata())
                        if (self.rx_path_delete_event.is_set or self.rx_path_delete_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_path_delete_event.get_name_leafdata())
                        if (self.rx_path_error_event.is_set or self.rx_path_error_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_path_error_event.get_name_leafdata())
                        if (self.rx_path_reeval_query_event.is_set or self.rx_path_reeval_query_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_path_reeval_query_event.get_name_leafdata())
                        if (self.rx_resv_change_event.is_set or self.rx_resv_change_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_resv_change_event.get_name_leafdata())
                        if (self.rx_resv_create_event.is_set or self.rx_resv_create_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_resv_create_event.get_name_leafdata())
                        if (self.rx_resv_delete_event.is_set or self.rx_resv_delete_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_resv_delete_event.get_name_leafdata())
                        if (self.rx_resv_error_event.is_set or self.rx_resv_error_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_resv_error_event.get_name_leafdata())
                        if (self.tx_backup_assign_event.is_set or self.tx_backup_assign_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_backup_assign_event.get_name_leafdata())
                        if (self.tx_event_unknown.is_set or self.tx_event_unknown.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_event_unknown.get_name_leafdata())
                        if (self.tx_path_change_event.is_set or self.tx_path_change_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_path_change_event.get_name_leafdata())
                        if (self.tx_path_create_event.is_set or self.tx_path_create_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_path_create_event.get_name_leafdata())
                        if (self.tx_path_delete_event.is_set or self.tx_path_delete_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_path_delete_event.get_name_leafdata())
                        if (self.tx_path_error_event.is_set or self.tx_path_error_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_path_error_event.get_name_leafdata())
                        if (self.tx_path_reeval_query_event.is_set or self.tx_path_reeval_query_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_path_reeval_query_event.get_name_leafdata())
                        if (self.tx_resv_change_event.is_set or self.tx_resv_change_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_resv_change_event.get_name_leafdata())
                        if (self.tx_resv_create_event.is_set or self.tx_resv_create_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_resv_create_event.get_name_leafdata())
                        if (self.tx_resv_delete_event.is_set or self.tx_resv_delete_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_resv_delete_event.get_name_leafdata())
                        if (self.tx_resv_error_event.is_set or self.tx_resv_error_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_resv_error_event.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "events-count" or name == "events-total-count" or name == "rx-backup-assign-err-event" or name == "rx-event-unknown" or name == "rx-path-change-event" or name == "rx-path-create-event" or name == "rx-path-delete-event" or name == "rx-path-error-event" or name == "rx-path-reeval-query-event" or name == "rx-resv-change-event" or name == "rx-resv-create-event" or name == "rx-resv-delete-event" or name == "rx-resv-error-event" or name == "tx-backup-assign-event" or name == "tx-event-unknown" or name == "tx-path-change-event" or name == "tx-path-create-event" or name == "tx-path-delete-event" or name == "tx-path-error-event" or name == "tx-path-reeval-query-event" or name == "tx-resv-change-event" or name == "tx-resv-create-event" or name == "tx-resv-delete-event" or name == "tx-resv-error-event"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "events-count"):
                            self.events_count = value
                            self.events_count.value_namespace = name_space
                            self.events_count.value_namespace_prefix = name_space_prefix
                        if(value_path == "events-total-count"):
                            self.events_total_count = value
                            self.events_total_count.value_namespace = name_space
                            self.events_total_count.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-backup-assign-err-event"):
                            self.rx_backup_assign_err_event = value
                            self.rx_backup_assign_err_event.value_namespace = name_space
                            self.rx_backup_assign_err_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-event-unknown"):
                            self.rx_event_unknown = value
                            self.rx_event_unknown.value_namespace = name_space
                            self.rx_event_unknown.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-path-change-event"):
                            self.rx_path_change_event = value
                            self.rx_path_change_event.value_namespace = name_space
                            self.rx_path_change_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-path-create-event"):
                            self.rx_path_create_event = value
                            self.rx_path_create_event.value_namespace = name_space
                            self.rx_path_create_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-path-delete-event"):
                            self.rx_path_delete_event = value
                            self.rx_path_delete_event.value_namespace = name_space
                            self.rx_path_delete_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-path-error-event"):
                            self.rx_path_error_event = value
                            self.rx_path_error_event.value_namespace = name_space
                            self.rx_path_error_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-path-reeval-query-event"):
                            self.rx_path_reeval_query_event = value
                            self.rx_path_reeval_query_event.value_namespace = name_space
                            self.rx_path_reeval_query_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-resv-change-event"):
                            self.rx_resv_change_event = value
                            self.rx_resv_change_event.value_namespace = name_space
                            self.rx_resv_change_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-resv-create-event"):
                            self.rx_resv_create_event = value
                            self.rx_resv_create_event.value_namespace = name_space
                            self.rx_resv_create_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-resv-delete-event"):
                            self.rx_resv_delete_event = value
                            self.rx_resv_delete_event.value_namespace = name_space
                            self.rx_resv_delete_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-resv-error-event"):
                            self.rx_resv_error_event = value
                            self.rx_resv_error_event.value_namespace = name_space
                            self.rx_resv_error_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-backup-assign-event"):
                            self.tx_backup_assign_event = value
                            self.tx_backup_assign_event.value_namespace = name_space
                            self.tx_backup_assign_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-event-unknown"):
                            self.tx_event_unknown = value
                            self.tx_event_unknown.value_namespace = name_space
                            self.tx_event_unknown.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-path-change-event"):
                            self.tx_path_change_event = value
                            self.tx_path_change_event.value_namespace = name_space
                            self.tx_path_change_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-path-create-event"):
                            self.tx_path_create_event = value
                            self.tx_path_create_event.value_namespace = name_space
                            self.tx_path_create_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-path-delete-event"):
                            self.tx_path_delete_event = value
                            self.tx_path_delete_event.value_namespace = name_space
                            self.tx_path_delete_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-path-error-event"):
                            self.tx_path_error_event = value
                            self.tx_path_error_event.value_namespace = name_space
                            self.tx_path_error_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-path-reeval-query-event"):
                            self.tx_path_reeval_query_event = value
                            self.tx_path_reeval_query_event.value_namespace = name_space
                            self.tx_path_reeval_query_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-resv-change-event"):
                            self.tx_resv_change_event = value
                            self.tx_resv_change_event.value_namespace = name_space
                            self.tx_resv_change_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-resv-create-event"):
                            self.tx_resv_create_event = value
                            self.tx_resv_create_event.value_namespace = name_space
                            self.tx_resv_create_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-resv-delete-event"):
                            self.tx_resv_delete_event = value
                            self.tx_resv_delete_event.value_namespace = name_space
                            self.tx_resv_delete_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-resv-error-event"):
                            self.tx_resv_error_event = value
                            self.tx_resv_error_event.value_namespace = name_space
                            self.tx_resv_error_event.value_namespace_prefix = name_space_prefix


                class DestinationStatistic(Entity):
                    """
                    List of Destination Stats
                    
                    .. attribute:: destination_address
                    
                    	Destination address
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: s2l_statistic
                    
                    	List of S2L Stats
                    	**type**\: list of    :py:class:`S2LStatistic <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.HeadsCounters.HeadsCounter.DestinationStatistic.S2LStatistic>`
                    
                    .. attribute:: statistics
                    
                    	Destination stats
                    	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.HeadsCounters.HeadsCounter.DestinationStatistic.Statistics>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.SignallingCounters.HeadsCounters.HeadsCounter.DestinationStatistic, self).__init__()

                        self.yang_name = "destination-statistic"
                        self.yang_parent_name = "heads-counter"

                        self.destination_address = YLeaf(YType.str, "destination-address")

                        self.statistics = MplsTeStandby.SignallingCounters.HeadsCounters.HeadsCounter.DestinationStatistic.Statistics()
                        self.statistics.parent = self
                        self._children_name_map["statistics"] = "statistics"
                        self._children_yang_names.add("statistics")

                        self.s2l_statistic = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("destination_address") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.SignallingCounters.HeadsCounters.HeadsCounter.DestinationStatistic, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.SignallingCounters.HeadsCounters.HeadsCounter.DestinationStatistic, self).__setattr__(name, value)


                    class Statistics(Entity):
                        """
                        Destination stats
                        
                        .. attribute:: events_count
                        
                        	TE Signaling event count
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: events_total_count
                        
                        	Total TE Signalling event count
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_backup_assign_err_event
                        
                        	Error on Backup Assign event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_event_unknown
                        
                        	RX Unknown events
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_path_change_event
                        
                        	RX Path Change event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_path_create_event
                        
                        	RX Path Create event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_path_delete_event
                        
                        	RX Path Delete event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_path_error_event
                        
                        	RX Path Error event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_path_reeval_query_event
                        
                        	RX Path Reeval Query event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_resv_change_event
                        
                        	RX Resv Change event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_resv_create_event
                        
                        	RX Resv Create event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_resv_delete_event
                        
                        	RX Resv Delete event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_resv_error_event
                        
                        	RX Resv Error event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_backup_assign_event
                        
                        	Backup Assign event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_event_unknown
                        
                        	Unknown TX events
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_path_change_event
                        
                        	TX Path Change event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_path_create_event
                        
                        	TX Path Create event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_path_delete_event
                        
                        	TX Path Delete event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_path_error_event
                        
                        	TX Path Error event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_path_reeval_query_event
                        
                        	TX Path Reeval Query event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_resv_change_event
                        
                        	TX Resv Change event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_resv_create_event
                        
                        	TX Resv Create event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_resv_delete_event
                        
                        	TX Resv Delete event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_resv_error_event
                        
                        	TX Resv Error event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.SignallingCounters.HeadsCounters.HeadsCounter.DestinationStatistic.Statistics, self).__init__()

                            self.yang_name = "statistics"
                            self.yang_parent_name = "destination-statistic"

                            self.events_count = YLeaf(YType.uint32, "events-count")

                            self.events_total_count = YLeaf(YType.uint32, "events-total-count")

                            self.rx_backup_assign_err_event = YLeaf(YType.uint32, "rx-backup-assign-err-event")

                            self.rx_event_unknown = YLeaf(YType.uint32, "rx-event-unknown")

                            self.rx_path_change_event = YLeaf(YType.uint32, "rx-path-change-event")

                            self.rx_path_create_event = YLeaf(YType.uint32, "rx-path-create-event")

                            self.rx_path_delete_event = YLeaf(YType.uint32, "rx-path-delete-event")

                            self.rx_path_error_event = YLeaf(YType.uint32, "rx-path-error-event")

                            self.rx_path_reeval_query_event = YLeaf(YType.uint32, "rx-path-reeval-query-event")

                            self.rx_resv_change_event = YLeaf(YType.uint32, "rx-resv-change-event")

                            self.rx_resv_create_event = YLeaf(YType.uint32, "rx-resv-create-event")

                            self.rx_resv_delete_event = YLeaf(YType.uint32, "rx-resv-delete-event")

                            self.rx_resv_error_event = YLeaf(YType.uint32, "rx-resv-error-event")

                            self.tx_backup_assign_event = YLeaf(YType.uint32, "tx-backup-assign-event")

                            self.tx_event_unknown = YLeaf(YType.uint32, "tx-event-unknown")

                            self.tx_path_change_event = YLeaf(YType.uint32, "tx-path-change-event")

                            self.tx_path_create_event = YLeaf(YType.uint32, "tx-path-create-event")

                            self.tx_path_delete_event = YLeaf(YType.uint32, "tx-path-delete-event")

                            self.tx_path_error_event = YLeaf(YType.uint32, "tx-path-error-event")

                            self.tx_path_reeval_query_event = YLeaf(YType.uint32, "tx-path-reeval-query-event")

                            self.tx_resv_change_event = YLeaf(YType.uint32, "tx-resv-change-event")

                            self.tx_resv_create_event = YLeaf(YType.uint32, "tx-resv-create-event")

                            self.tx_resv_delete_event = YLeaf(YType.uint32, "tx-resv-delete-event")

                            self.tx_resv_error_event = YLeaf(YType.uint32, "tx-resv-error-event")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("events_count",
                                            "events_total_count",
                                            "rx_backup_assign_err_event",
                                            "rx_event_unknown",
                                            "rx_path_change_event",
                                            "rx_path_create_event",
                                            "rx_path_delete_event",
                                            "rx_path_error_event",
                                            "rx_path_reeval_query_event",
                                            "rx_resv_change_event",
                                            "rx_resv_create_event",
                                            "rx_resv_delete_event",
                                            "rx_resv_error_event",
                                            "tx_backup_assign_event",
                                            "tx_event_unknown",
                                            "tx_path_change_event",
                                            "tx_path_create_event",
                                            "tx_path_delete_event",
                                            "tx_path_error_event",
                                            "tx_path_reeval_query_event",
                                            "tx_resv_change_event",
                                            "tx_resv_create_event",
                                            "tx_resv_delete_event",
                                            "tx_resv_error_event") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.SignallingCounters.HeadsCounters.HeadsCounter.DestinationStatistic.Statistics, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.SignallingCounters.HeadsCounters.HeadsCounter.DestinationStatistic.Statistics, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.events_count.is_set or
                                self.events_total_count.is_set or
                                self.rx_backup_assign_err_event.is_set or
                                self.rx_event_unknown.is_set or
                                self.rx_path_change_event.is_set or
                                self.rx_path_create_event.is_set or
                                self.rx_path_delete_event.is_set or
                                self.rx_path_error_event.is_set or
                                self.rx_path_reeval_query_event.is_set or
                                self.rx_resv_change_event.is_set or
                                self.rx_resv_create_event.is_set or
                                self.rx_resv_delete_event.is_set or
                                self.rx_resv_error_event.is_set or
                                self.tx_backup_assign_event.is_set or
                                self.tx_event_unknown.is_set or
                                self.tx_path_change_event.is_set or
                                self.tx_path_create_event.is_set or
                                self.tx_path_delete_event.is_set or
                                self.tx_path_error_event.is_set or
                                self.tx_path_reeval_query_event.is_set or
                                self.tx_resv_change_event.is_set or
                                self.tx_resv_create_event.is_set or
                                self.tx_resv_delete_event.is_set or
                                self.tx_resv_error_event.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.events_count.yfilter != YFilter.not_set or
                                self.events_total_count.yfilter != YFilter.not_set or
                                self.rx_backup_assign_err_event.yfilter != YFilter.not_set or
                                self.rx_event_unknown.yfilter != YFilter.not_set or
                                self.rx_path_change_event.yfilter != YFilter.not_set or
                                self.rx_path_create_event.yfilter != YFilter.not_set or
                                self.rx_path_delete_event.yfilter != YFilter.not_set or
                                self.rx_path_error_event.yfilter != YFilter.not_set or
                                self.rx_path_reeval_query_event.yfilter != YFilter.not_set or
                                self.rx_resv_change_event.yfilter != YFilter.not_set or
                                self.rx_resv_create_event.yfilter != YFilter.not_set or
                                self.rx_resv_delete_event.yfilter != YFilter.not_set or
                                self.rx_resv_error_event.yfilter != YFilter.not_set or
                                self.tx_backup_assign_event.yfilter != YFilter.not_set or
                                self.tx_event_unknown.yfilter != YFilter.not_set or
                                self.tx_path_change_event.yfilter != YFilter.not_set or
                                self.tx_path_create_event.yfilter != YFilter.not_set or
                                self.tx_path_delete_event.yfilter != YFilter.not_set or
                                self.tx_path_error_event.yfilter != YFilter.not_set or
                                self.tx_path_reeval_query_event.yfilter != YFilter.not_set or
                                self.tx_resv_change_event.yfilter != YFilter.not_set or
                                self.tx_resv_create_event.yfilter != YFilter.not_set or
                                self.tx_resv_delete_event.yfilter != YFilter.not_set or
                                self.tx_resv_error_event.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "statistics" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.events_count.is_set or self.events_count.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.events_count.get_name_leafdata())
                            if (self.events_total_count.is_set or self.events_total_count.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.events_total_count.get_name_leafdata())
                            if (self.rx_backup_assign_err_event.is_set or self.rx_backup_assign_err_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_backup_assign_err_event.get_name_leafdata())
                            if (self.rx_event_unknown.is_set or self.rx_event_unknown.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_event_unknown.get_name_leafdata())
                            if (self.rx_path_change_event.is_set or self.rx_path_change_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_path_change_event.get_name_leafdata())
                            if (self.rx_path_create_event.is_set or self.rx_path_create_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_path_create_event.get_name_leafdata())
                            if (self.rx_path_delete_event.is_set or self.rx_path_delete_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_path_delete_event.get_name_leafdata())
                            if (self.rx_path_error_event.is_set or self.rx_path_error_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_path_error_event.get_name_leafdata())
                            if (self.rx_path_reeval_query_event.is_set or self.rx_path_reeval_query_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_path_reeval_query_event.get_name_leafdata())
                            if (self.rx_resv_change_event.is_set or self.rx_resv_change_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_resv_change_event.get_name_leafdata())
                            if (self.rx_resv_create_event.is_set or self.rx_resv_create_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_resv_create_event.get_name_leafdata())
                            if (self.rx_resv_delete_event.is_set or self.rx_resv_delete_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_resv_delete_event.get_name_leafdata())
                            if (self.rx_resv_error_event.is_set or self.rx_resv_error_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_resv_error_event.get_name_leafdata())
                            if (self.tx_backup_assign_event.is_set or self.tx_backup_assign_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_backup_assign_event.get_name_leafdata())
                            if (self.tx_event_unknown.is_set or self.tx_event_unknown.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_event_unknown.get_name_leafdata())
                            if (self.tx_path_change_event.is_set or self.tx_path_change_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_path_change_event.get_name_leafdata())
                            if (self.tx_path_create_event.is_set or self.tx_path_create_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_path_create_event.get_name_leafdata())
                            if (self.tx_path_delete_event.is_set or self.tx_path_delete_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_path_delete_event.get_name_leafdata())
                            if (self.tx_path_error_event.is_set or self.tx_path_error_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_path_error_event.get_name_leafdata())
                            if (self.tx_path_reeval_query_event.is_set or self.tx_path_reeval_query_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_path_reeval_query_event.get_name_leafdata())
                            if (self.tx_resv_change_event.is_set or self.tx_resv_change_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_resv_change_event.get_name_leafdata())
                            if (self.tx_resv_create_event.is_set or self.tx_resv_create_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_resv_create_event.get_name_leafdata())
                            if (self.tx_resv_delete_event.is_set or self.tx_resv_delete_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_resv_delete_event.get_name_leafdata())
                            if (self.tx_resv_error_event.is_set or self.tx_resv_error_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_resv_error_event.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "events-count" or name == "events-total-count" or name == "rx-backup-assign-err-event" or name == "rx-event-unknown" or name == "rx-path-change-event" or name == "rx-path-create-event" or name == "rx-path-delete-event" or name == "rx-path-error-event" or name == "rx-path-reeval-query-event" or name == "rx-resv-change-event" or name == "rx-resv-create-event" or name == "rx-resv-delete-event" or name == "rx-resv-error-event" or name == "tx-backup-assign-event" or name == "tx-event-unknown" or name == "tx-path-change-event" or name == "tx-path-create-event" or name == "tx-path-delete-event" or name == "tx-path-error-event" or name == "tx-path-reeval-query-event" or name == "tx-resv-change-event" or name == "tx-resv-create-event" or name == "tx-resv-delete-event" or name == "tx-resv-error-event"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "events-count"):
                                self.events_count = value
                                self.events_count.value_namespace = name_space
                                self.events_count.value_namespace_prefix = name_space_prefix
                            if(value_path == "events-total-count"):
                                self.events_total_count = value
                                self.events_total_count.value_namespace = name_space
                                self.events_total_count.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-backup-assign-err-event"):
                                self.rx_backup_assign_err_event = value
                                self.rx_backup_assign_err_event.value_namespace = name_space
                                self.rx_backup_assign_err_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-event-unknown"):
                                self.rx_event_unknown = value
                                self.rx_event_unknown.value_namespace = name_space
                                self.rx_event_unknown.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-path-change-event"):
                                self.rx_path_change_event = value
                                self.rx_path_change_event.value_namespace = name_space
                                self.rx_path_change_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-path-create-event"):
                                self.rx_path_create_event = value
                                self.rx_path_create_event.value_namespace = name_space
                                self.rx_path_create_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-path-delete-event"):
                                self.rx_path_delete_event = value
                                self.rx_path_delete_event.value_namespace = name_space
                                self.rx_path_delete_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-path-error-event"):
                                self.rx_path_error_event = value
                                self.rx_path_error_event.value_namespace = name_space
                                self.rx_path_error_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-path-reeval-query-event"):
                                self.rx_path_reeval_query_event = value
                                self.rx_path_reeval_query_event.value_namespace = name_space
                                self.rx_path_reeval_query_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-resv-change-event"):
                                self.rx_resv_change_event = value
                                self.rx_resv_change_event.value_namespace = name_space
                                self.rx_resv_change_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-resv-create-event"):
                                self.rx_resv_create_event = value
                                self.rx_resv_create_event.value_namespace = name_space
                                self.rx_resv_create_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-resv-delete-event"):
                                self.rx_resv_delete_event = value
                                self.rx_resv_delete_event.value_namespace = name_space
                                self.rx_resv_delete_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-resv-error-event"):
                                self.rx_resv_error_event = value
                                self.rx_resv_error_event.value_namespace = name_space
                                self.rx_resv_error_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-backup-assign-event"):
                                self.tx_backup_assign_event = value
                                self.tx_backup_assign_event.value_namespace = name_space
                                self.tx_backup_assign_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-event-unknown"):
                                self.tx_event_unknown = value
                                self.tx_event_unknown.value_namespace = name_space
                                self.tx_event_unknown.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-path-change-event"):
                                self.tx_path_change_event = value
                                self.tx_path_change_event.value_namespace = name_space
                                self.tx_path_change_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-path-create-event"):
                                self.tx_path_create_event = value
                                self.tx_path_create_event.value_namespace = name_space
                                self.tx_path_create_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-path-delete-event"):
                                self.tx_path_delete_event = value
                                self.tx_path_delete_event.value_namespace = name_space
                                self.tx_path_delete_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-path-error-event"):
                                self.tx_path_error_event = value
                                self.tx_path_error_event.value_namespace = name_space
                                self.tx_path_error_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-path-reeval-query-event"):
                                self.tx_path_reeval_query_event = value
                                self.tx_path_reeval_query_event.value_namespace = name_space
                                self.tx_path_reeval_query_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-resv-change-event"):
                                self.tx_resv_change_event = value
                                self.tx_resv_change_event.value_namespace = name_space
                                self.tx_resv_change_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-resv-create-event"):
                                self.tx_resv_create_event = value
                                self.tx_resv_create_event.value_namespace = name_space
                                self.tx_resv_create_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-resv-delete-event"):
                                self.tx_resv_delete_event = value
                                self.tx_resv_delete_event.value_namespace = name_space
                                self.tx_resv_delete_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-resv-error-event"):
                                self.tx_resv_error_event = value
                                self.tx_resv_error_event.value_namespace = name_space
                                self.tx_resv_error_event.value_namespace_prefix = name_space_prefix


                    class S2LStatistic(Entity):
                        """
                        List of S2L Stats
                        
                        .. attribute:: destination_address
                        
                        	Destination address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: statistics
                        
                        	S2L stats
                        	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.HeadsCounters.HeadsCounter.DestinationStatistic.S2LStatistic.Statistics>`
                        
                        .. attribute:: sub_group_id
                        
                        	subgroup ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: sub_group_originator
                        
                        	Subgroup Originator
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.SignallingCounters.HeadsCounters.HeadsCounter.DestinationStatistic.S2LStatistic, self).__init__()

                            self.yang_name = "s2l-statistic"
                            self.yang_parent_name = "destination-statistic"

                            self.destination_address = YLeaf(YType.str, "destination-address")

                            self.sub_group_id = YLeaf(YType.uint16, "sub-group-id")

                            self.sub_group_originator = YLeaf(YType.str, "sub-group-originator")

                            self.statistics = MplsTeStandby.SignallingCounters.HeadsCounters.HeadsCounter.DestinationStatistic.S2LStatistic.Statistics()
                            self.statistics.parent = self
                            self._children_name_map["statistics"] = "statistics"
                            self._children_yang_names.add("statistics")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("destination_address",
                                            "sub_group_id",
                                            "sub_group_originator") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.SignallingCounters.HeadsCounters.HeadsCounter.DestinationStatistic.S2LStatistic, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.SignallingCounters.HeadsCounters.HeadsCounter.DestinationStatistic.S2LStatistic, self).__setattr__(name, value)


                        class Statistics(Entity):
                            """
                            S2L stats
                            
                            .. attribute:: events_count
                            
                            	TE Signaling event count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: events_total_count
                            
                            	Total TE Signalling event count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_backup_assign_err_event
                            
                            	Error on Backup Assign event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_event_unknown
                            
                            	RX Unknown events
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_path_change_event
                            
                            	RX Path Change event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_path_create_event
                            
                            	RX Path Create event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_path_delete_event
                            
                            	RX Path Delete event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_path_error_event
                            
                            	RX Path Error event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_path_reeval_query_event
                            
                            	RX Path Reeval Query event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_resv_change_event
                            
                            	RX Resv Change event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_resv_create_event
                            
                            	RX Resv Create event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_resv_delete_event
                            
                            	RX Resv Delete event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_resv_error_event
                            
                            	RX Resv Error event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_backup_assign_event
                            
                            	Backup Assign event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_event_unknown
                            
                            	Unknown TX events
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_path_change_event
                            
                            	TX Path Change event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_path_create_event
                            
                            	TX Path Create event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_path_delete_event
                            
                            	TX Path Delete event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_path_error_event
                            
                            	TX Path Error event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_path_reeval_query_event
                            
                            	TX Path Reeval Query event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_resv_change_event
                            
                            	TX Resv Change event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_resv_create_event
                            
                            	TX Resv Create event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_resv_delete_event
                            
                            	TX Resv Delete event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_resv_error_event
                            
                            	TX Resv Error event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.SignallingCounters.HeadsCounters.HeadsCounter.DestinationStatistic.S2LStatistic.Statistics, self).__init__()

                                self.yang_name = "statistics"
                                self.yang_parent_name = "s2l-statistic"

                                self.events_count = YLeaf(YType.uint32, "events-count")

                                self.events_total_count = YLeaf(YType.uint32, "events-total-count")

                                self.rx_backup_assign_err_event = YLeaf(YType.uint32, "rx-backup-assign-err-event")

                                self.rx_event_unknown = YLeaf(YType.uint32, "rx-event-unknown")

                                self.rx_path_change_event = YLeaf(YType.uint32, "rx-path-change-event")

                                self.rx_path_create_event = YLeaf(YType.uint32, "rx-path-create-event")

                                self.rx_path_delete_event = YLeaf(YType.uint32, "rx-path-delete-event")

                                self.rx_path_error_event = YLeaf(YType.uint32, "rx-path-error-event")

                                self.rx_path_reeval_query_event = YLeaf(YType.uint32, "rx-path-reeval-query-event")

                                self.rx_resv_change_event = YLeaf(YType.uint32, "rx-resv-change-event")

                                self.rx_resv_create_event = YLeaf(YType.uint32, "rx-resv-create-event")

                                self.rx_resv_delete_event = YLeaf(YType.uint32, "rx-resv-delete-event")

                                self.rx_resv_error_event = YLeaf(YType.uint32, "rx-resv-error-event")

                                self.tx_backup_assign_event = YLeaf(YType.uint32, "tx-backup-assign-event")

                                self.tx_event_unknown = YLeaf(YType.uint32, "tx-event-unknown")

                                self.tx_path_change_event = YLeaf(YType.uint32, "tx-path-change-event")

                                self.tx_path_create_event = YLeaf(YType.uint32, "tx-path-create-event")

                                self.tx_path_delete_event = YLeaf(YType.uint32, "tx-path-delete-event")

                                self.tx_path_error_event = YLeaf(YType.uint32, "tx-path-error-event")

                                self.tx_path_reeval_query_event = YLeaf(YType.uint32, "tx-path-reeval-query-event")

                                self.tx_resv_change_event = YLeaf(YType.uint32, "tx-resv-change-event")

                                self.tx_resv_create_event = YLeaf(YType.uint32, "tx-resv-create-event")

                                self.tx_resv_delete_event = YLeaf(YType.uint32, "tx-resv-delete-event")

                                self.tx_resv_error_event = YLeaf(YType.uint32, "tx-resv-error-event")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("events_count",
                                                "events_total_count",
                                                "rx_backup_assign_err_event",
                                                "rx_event_unknown",
                                                "rx_path_change_event",
                                                "rx_path_create_event",
                                                "rx_path_delete_event",
                                                "rx_path_error_event",
                                                "rx_path_reeval_query_event",
                                                "rx_resv_change_event",
                                                "rx_resv_create_event",
                                                "rx_resv_delete_event",
                                                "rx_resv_error_event",
                                                "tx_backup_assign_event",
                                                "tx_event_unknown",
                                                "tx_path_change_event",
                                                "tx_path_create_event",
                                                "tx_path_delete_event",
                                                "tx_path_error_event",
                                                "tx_path_reeval_query_event",
                                                "tx_resv_change_event",
                                                "tx_resv_create_event",
                                                "tx_resv_delete_event",
                                                "tx_resv_error_event") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.SignallingCounters.HeadsCounters.HeadsCounter.DestinationStatistic.S2LStatistic.Statistics, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.SignallingCounters.HeadsCounters.HeadsCounter.DestinationStatistic.S2LStatistic.Statistics, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.events_count.is_set or
                                    self.events_total_count.is_set or
                                    self.rx_backup_assign_err_event.is_set or
                                    self.rx_event_unknown.is_set or
                                    self.rx_path_change_event.is_set or
                                    self.rx_path_create_event.is_set or
                                    self.rx_path_delete_event.is_set or
                                    self.rx_path_error_event.is_set or
                                    self.rx_path_reeval_query_event.is_set or
                                    self.rx_resv_change_event.is_set or
                                    self.rx_resv_create_event.is_set or
                                    self.rx_resv_delete_event.is_set or
                                    self.rx_resv_error_event.is_set or
                                    self.tx_backup_assign_event.is_set or
                                    self.tx_event_unknown.is_set or
                                    self.tx_path_change_event.is_set or
                                    self.tx_path_create_event.is_set or
                                    self.tx_path_delete_event.is_set or
                                    self.tx_path_error_event.is_set or
                                    self.tx_path_reeval_query_event.is_set or
                                    self.tx_resv_change_event.is_set or
                                    self.tx_resv_create_event.is_set or
                                    self.tx_resv_delete_event.is_set or
                                    self.tx_resv_error_event.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.events_count.yfilter != YFilter.not_set or
                                    self.events_total_count.yfilter != YFilter.not_set or
                                    self.rx_backup_assign_err_event.yfilter != YFilter.not_set or
                                    self.rx_event_unknown.yfilter != YFilter.not_set or
                                    self.rx_path_change_event.yfilter != YFilter.not_set or
                                    self.rx_path_create_event.yfilter != YFilter.not_set or
                                    self.rx_path_delete_event.yfilter != YFilter.not_set or
                                    self.rx_path_error_event.yfilter != YFilter.not_set or
                                    self.rx_path_reeval_query_event.yfilter != YFilter.not_set or
                                    self.rx_resv_change_event.yfilter != YFilter.not_set or
                                    self.rx_resv_create_event.yfilter != YFilter.not_set or
                                    self.rx_resv_delete_event.yfilter != YFilter.not_set or
                                    self.rx_resv_error_event.yfilter != YFilter.not_set or
                                    self.tx_backup_assign_event.yfilter != YFilter.not_set or
                                    self.tx_event_unknown.yfilter != YFilter.not_set or
                                    self.tx_path_change_event.yfilter != YFilter.not_set or
                                    self.tx_path_create_event.yfilter != YFilter.not_set or
                                    self.tx_path_delete_event.yfilter != YFilter.not_set or
                                    self.tx_path_error_event.yfilter != YFilter.not_set or
                                    self.tx_path_reeval_query_event.yfilter != YFilter.not_set or
                                    self.tx_resv_change_event.yfilter != YFilter.not_set or
                                    self.tx_resv_create_event.yfilter != YFilter.not_set or
                                    self.tx_resv_delete_event.yfilter != YFilter.not_set or
                                    self.tx_resv_error_event.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "statistics" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.events_count.is_set or self.events_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.events_count.get_name_leafdata())
                                if (self.events_total_count.is_set or self.events_total_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.events_total_count.get_name_leafdata())
                                if (self.rx_backup_assign_err_event.is_set or self.rx_backup_assign_err_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_backup_assign_err_event.get_name_leafdata())
                                if (self.rx_event_unknown.is_set or self.rx_event_unknown.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_event_unknown.get_name_leafdata())
                                if (self.rx_path_change_event.is_set or self.rx_path_change_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_path_change_event.get_name_leafdata())
                                if (self.rx_path_create_event.is_set or self.rx_path_create_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_path_create_event.get_name_leafdata())
                                if (self.rx_path_delete_event.is_set or self.rx_path_delete_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_path_delete_event.get_name_leafdata())
                                if (self.rx_path_error_event.is_set or self.rx_path_error_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_path_error_event.get_name_leafdata())
                                if (self.rx_path_reeval_query_event.is_set or self.rx_path_reeval_query_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_path_reeval_query_event.get_name_leafdata())
                                if (self.rx_resv_change_event.is_set or self.rx_resv_change_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_resv_change_event.get_name_leafdata())
                                if (self.rx_resv_create_event.is_set or self.rx_resv_create_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_resv_create_event.get_name_leafdata())
                                if (self.rx_resv_delete_event.is_set or self.rx_resv_delete_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_resv_delete_event.get_name_leafdata())
                                if (self.rx_resv_error_event.is_set or self.rx_resv_error_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_resv_error_event.get_name_leafdata())
                                if (self.tx_backup_assign_event.is_set or self.tx_backup_assign_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_backup_assign_event.get_name_leafdata())
                                if (self.tx_event_unknown.is_set or self.tx_event_unknown.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_event_unknown.get_name_leafdata())
                                if (self.tx_path_change_event.is_set or self.tx_path_change_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_path_change_event.get_name_leafdata())
                                if (self.tx_path_create_event.is_set or self.tx_path_create_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_path_create_event.get_name_leafdata())
                                if (self.tx_path_delete_event.is_set or self.tx_path_delete_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_path_delete_event.get_name_leafdata())
                                if (self.tx_path_error_event.is_set or self.tx_path_error_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_path_error_event.get_name_leafdata())
                                if (self.tx_path_reeval_query_event.is_set or self.tx_path_reeval_query_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_path_reeval_query_event.get_name_leafdata())
                                if (self.tx_resv_change_event.is_set or self.tx_resv_change_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_resv_change_event.get_name_leafdata())
                                if (self.tx_resv_create_event.is_set or self.tx_resv_create_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_resv_create_event.get_name_leafdata())
                                if (self.tx_resv_delete_event.is_set or self.tx_resv_delete_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_resv_delete_event.get_name_leafdata())
                                if (self.tx_resv_error_event.is_set or self.tx_resv_error_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_resv_error_event.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "events-count" or name == "events-total-count" or name == "rx-backup-assign-err-event" or name == "rx-event-unknown" or name == "rx-path-change-event" or name == "rx-path-create-event" or name == "rx-path-delete-event" or name == "rx-path-error-event" or name == "rx-path-reeval-query-event" or name == "rx-resv-change-event" or name == "rx-resv-create-event" or name == "rx-resv-delete-event" or name == "rx-resv-error-event" or name == "tx-backup-assign-event" or name == "tx-event-unknown" or name == "tx-path-change-event" or name == "tx-path-create-event" or name == "tx-path-delete-event" or name == "tx-path-error-event" or name == "tx-path-reeval-query-event" or name == "tx-resv-change-event" or name == "tx-resv-create-event" or name == "tx-resv-delete-event" or name == "tx-resv-error-event"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "events-count"):
                                    self.events_count = value
                                    self.events_count.value_namespace = name_space
                                    self.events_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "events-total-count"):
                                    self.events_total_count = value
                                    self.events_total_count.value_namespace = name_space
                                    self.events_total_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-backup-assign-err-event"):
                                    self.rx_backup_assign_err_event = value
                                    self.rx_backup_assign_err_event.value_namespace = name_space
                                    self.rx_backup_assign_err_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-event-unknown"):
                                    self.rx_event_unknown = value
                                    self.rx_event_unknown.value_namespace = name_space
                                    self.rx_event_unknown.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-path-change-event"):
                                    self.rx_path_change_event = value
                                    self.rx_path_change_event.value_namespace = name_space
                                    self.rx_path_change_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-path-create-event"):
                                    self.rx_path_create_event = value
                                    self.rx_path_create_event.value_namespace = name_space
                                    self.rx_path_create_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-path-delete-event"):
                                    self.rx_path_delete_event = value
                                    self.rx_path_delete_event.value_namespace = name_space
                                    self.rx_path_delete_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-path-error-event"):
                                    self.rx_path_error_event = value
                                    self.rx_path_error_event.value_namespace = name_space
                                    self.rx_path_error_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-path-reeval-query-event"):
                                    self.rx_path_reeval_query_event = value
                                    self.rx_path_reeval_query_event.value_namespace = name_space
                                    self.rx_path_reeval_query_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-resv-change-event"):
                                    self.rx_resv_change_event = value
                                    self.rx_resv_change_event.value_namespace = name_space
                                    self.rx_resv_change_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-resv-create-event"):
                                    self.rx_resv_create_event = value
                                    self.rx_resv_create_event.value_namespace = name_space
                                    self.rx_resv_create_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-resv-delete-event"):
                                    self.rx_resv_delete_event = value
                                    self.rx_resv_delete_event.value_namespace = name_space
                                    self.rx_resv_delete_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-resv-error-event"):
                                    self.rx_resv_error_event = value
                                    self.rx_resv_error_event.value_namespace = name_space
                                    self.rx_resv_error_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-backup-assign-event"):
                                    self.tx_backup_assign_event = value
                                    self.tx_backup_assign_event.value_namespace = name_space
                                    self.tx_backup_assign_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-event-unknown"):
                                    self.tx_event_unknown = value
                                    self.tx_event_unknown.value_namespace = name_space
                                    self.tx_event_unknown.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-path-change-event"):
                                    self.tx_path_change_event = value
                                    self.tx_path_change_event.value_namespace = name_space
                                    self.tx_path_change_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-path-create-event"):
                                    self.tx_path_create_event = value
                                    self.tx_path_create_event.value_namespace = name_space
                                    self.tx_path_create_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-path-delete-event"):
                                    self.tx_path_delete_event = value
                                    self.tx_path_delete_event.value_namespace = name_space
                                    self.tx_path_delete_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-path-error-event"):
                                    self.tx_path_error_event = value
                                    self.tx_path_error_event.value_namespace = name_space
                                    self.tx_path_error_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-path-reeval-query-event"):
                                    self.tx_path_reeval_query_event = value
                                    self.tx_path_reeval_query_event.value_namespace = name_space
                                    self.tx_path_reeval_query_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-resv-change-event"):
                                    self.tx_resv_change_event = value
                                    self.tx_resv_change_event.value_namespace = name_space
                                    self.tx_resv_change_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-resv-create-event"):
                                    self.tx_resv_create_event = value
                                    self.tx_resv_create_event.value_namespace = name_space
                                    self.tx_resv_create_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-resv-delete-event"):
                                    self.tx_resv_delete_event = value
                                    self.tx_resv_delete_event.value_namespace = name_space
                                    self.tx_resv_delete_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-resv-error-event"):
                                    self.tx_resv_error_event = value
                                    self.tx_resv_error_event.value_namespace = name_space
                                    self.tx_resv_error_event.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.destination_address.is_set or
                                self.sub_group_id.is_set or
                                self.sub_group_originator.is_set or
                                (self.statistics is not None and self.statistics.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.destination_address.yfilter != YFilter.not_set or
                                self.sub_group_id.yfilter != YFilter.not_set or
                                self.sub_group_originator.yfilter != YFilter.not_set or
                                (self.statistics is not None and self.statistics.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "s2l-statistic" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.destination_address.get_name_leafdata())
                            if (self.sub_group_id.is_set or self.sub_group_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.sub_group_id.get_name_leafdata())
                            if (self.sub_group_originator.is_set or self.sub_group_originator.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.sub_group_originator.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "statistics"):
                                if (self.statistics is None):
                                    self.statistics = MplsTeStandby.SignallingCounters.HeadsCounters.HeadsCounter.DestinationStatistic.S2LStatistic.Statistics()
                                    self.statistics.parent = self
                                    self._children_name_map["statistics"] = "statistics"
                                return self.statistics

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "statistics" or name == "destination-address" or name == "sub-group-id" or name == "sub-group-originator"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "destination-address"):
                                self.destination_address = value
                                self.destination_address.value_namespace = name_space
                                self.destination_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "sub-group-id"):
                                self.sub_group_id = value
                                self.sub_group_id.value_namespace = name_space
                                self.sub_group_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "sub-group-originator"):
                                self.sub_group_originator = value
                                self.sub_group_originator.value_namespace = name_space
                                self.sub_group_originator.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.s2l_statistic:
                            if (c.has_data()):
                                return True
                        return (
                            self.destination_address.is_set or
                            (self.statistics is not None and self.statistics.has_data()))

                    def has_operation(self):
                        for c in self.s2l_statistic:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.destination_address.yfilter != YFilter.not_set or
                            (self.statistics is not None and self.statistics.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "destination-statistic" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.destination_address.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "s2l-statistic"):
                            for c in self.s2l_statistic:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.SignallingCounters.HeadsCounters.HeadsCounter.DestinationStatistic.S2LStatistic()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.s2l_statistic.append(c)
                            return c

                        if (child_yang_name == "statistics"):
                            if (self.statistics is None):
                                self.statistics = MplsTeStandby.SignallingCounters.HeadsCounters.HeadsCounter.DestinationStatistic.Statistics()
                                self.statistics.parent = self
                                self._children_name_map["statistics"] = "statistics"
                            return self.statistics

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "s2l-statistic" or name == "statistics" or name == "destination-address"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "destination-address"):
                            self.destination_address = value
                            self.destination_address.value_namespace = name_space
                            self.destination_address.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.destination_statistic:
                        if (c.has_data()):
                            return True
                    return (
                        self.tunnel_id.is_set or
                        self.lsp_id.is_set or
                        self.tunnel_name.is_set or
                        self.tunnel_sig_name.is_set or
                        (self.statistics is not None and self.statistics.has_data()))

                def has_operation(self):
                    for c in self.destination_statistic:
                        if (c.has_operation()):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        self.tunnel_id.yfilter != YFilter.not_set or
                        self.lsp_id.yfilter != YFilter.not_set or
                        self.tunnel_name.yfilter != YFilter.not_set or
                        self.tunnel_sig_name.yfilter != YFilter.not_set or
                        (self.statistics is not None and self.statistics.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "heads-counter" + "[tunnel-id='" + self.tunnel_id.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/signalling-counters/heads-counters/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_id.get_name_leafdata())
                    if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.lsp_id.get_name_leafdata())
                    if (self.tunnel_name.is_set or self.tunnel_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_name.get_name_leafdata())
                    if (self.tunnel_sig_name.is_set or self.tunnel_sig_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_sig_name.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "destination-statistic"):
                        for c in self.destination_statistic:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsTeStandby.SignallingCounters.HeadsCounters.HeadsCounter.DestinationStatistic()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.destination_statistic.append(c)
                        return c

                    if (child_yang_name == "statistics"):
                        if (self.statistics is None):
                            self.statistics = MplsTeStandby.SignallingCounters.HeadsCounters.HeadsCounter.Statistics()
                            self.statistics.parent = self
                            self._children_name_map["statistics"] = "statistics"
                        return self.statistics

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "destination-statistic" or name == "statistics" or name == "tunnel-id" or name == "lsp-id" or name == "tunnel-name" or name == "tunnel-sig-name"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "tunnel-id"):
                        self.tunnel_id = value
                        self.tunnel_id.value_namespace = name_space
                        self.tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "lsp-id"):
                        self.lsp_id = value
                        self.lsp_id.value_namespace = name_space
                        self.lsp_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-name"):
                        self.tunnel_name = value
                        self.tunnel_name.value_namespace = name_space
                        self.tunnel_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-sig-name"):
                        self.tunnel_sig_name = value
                        self.tunnel_sig_name.value_namespace = name_space
                        self.tunnel_sig_name.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.heads_counter:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.heads_counter:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "heads-counters" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/signalling-counters/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "heads-counter"):
                    for c in self.heads_counter:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTeStandby.SignallingCounters.HeadsCounters.HeadsCounter()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.heads_counter.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "heads-counter"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass


        class MidsCounters(Entity):
            """
            MPLS TE counters signalling heads table
            
            .. attribute:: mids_counter
            
            	MPLS TE counters signalling mid
            	**type**\: list of    :py:class:`MidsCounter <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.MidsCounters.MidsCounter>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTeStandby.SignallingCounters.MidsCounters, self).__init__()

                self.yang_name = "mids-counters"
                self.yang_parent_name = "signalling-counters"

                self.mids_counter = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTeStandby.SignallingCounters.MidsCounters, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTeStandby.SignallingCounters.MidsCounters, self).__setattr__(name, value)


            class MidsCounter(Entity):
                """
                MPLS TE counters signalling mid
                
                .. attribute:: source_address  <key>
                
                	Source Address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: destination_address  <key>
                
                	Destination Address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: tunnel_id  <key>
                
                	tunnel id of last obtained tunnel
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: extended_tunnel_id  <key>
                
                	Extended Tunnel ID
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: lsp_id  <key>
                
                	LSP ID
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: s2l_statistic
                
                	List of S2L Statistics
                	**type**\: list of    :py:class:`S2LStatistic <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.MidsCounters.MidsCounter.S2LStatistic>`
                
                .. attribute:: statistics
                
                	LSP statistics
                	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.MidsCounters.MidsCounter.Statistics>`
                
                .. attribute:: tunnel_name
                
                	Tunnel Name
                	**type**\:  str
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTeStandby.SignallingCounters.MidsCounters.MidsCounter, self).__init__()

                    self.yang_name = "mids-counter"
                    self.yang_parent_name = "mids-counters"

                    self.source_address = YLeaf(YType.str, "source-address")

                    self.destination_address = YLeaf(YType.str, "destination-address")

                    self.tunnel_id = YLeaf(YType.int32, "tunnel-id")

                    self.extended_tunnel_id = YLeaf(YType.str, "extended-tunnel-id")

                    self.lsp_id = YLeaf(YType.int32, "lsp-id")

                    self.tunnel_name = YLeaf(YType.str, "tunnel-name")

                    self.statistics = MplsTeStandby.SignallingCounters.MidsCounters.MidsCounter.Statistics()
                    self.statistics.parent = self
                    self._children_name_map["statistics"] = "statistics"
                    self._children_yang_names.add("statistics")

                    self.s2l_statistic = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("source_address",
                                    "destination_address",
                                    "tunnel_id",
                                    "extended_tunnel_id",
                                    "lsp_id",
                                    "tunnel_name") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTeStandby.SignallingCounters.MidsCounters.MidsCounter, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTeStandby.SignallingCounters.MidsCounters.MidsCounter, self).__setattr__(name, value)


                class Statistics(Entity):
                    """
                    LSP statistics
                    
                    .. attribute:: events_count
                    
                    	TE Signaling event count
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: events_total_count
                    
                    	Total TE Signalling event count
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_backup_assign_err_event
                    
                    	Error on Backup Assign event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_event_unknown
                    
                    	RX Unknown events
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_path_change_event
                    
                    	RX Path Change event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_path_create_event
                    
                    	RX Path Create event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_path_delete_event
                    
                    	RX Path Delete event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_path_error_event
                    
                    	RX Path Error event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_path_reeval_query_event
                    
                    	RX Path Reeval Query event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_resv_change_event
                    
                    	RX Resv Change event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_resv_create_event
                    
                    	RX Resv Create event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_resv_delete_event
                    
                    	RX Resv Delete event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_resv_error_event
                    
                    	RX Resv Error event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_backup_assign_event
                    
                    	Backup Assign event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_event_unknown
                    
                    	Unknown TX events
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_path_change_event
                    
                    	TX Path Change event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_path_create_event
                    
                    	TX Path Create event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_path_delete_event
                    
                    	TX Path Delete event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_path_error_event
                    
                    	TX Path Error event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_path_reeval_query_event
                    
                    	TX Path Reeval Query event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_resv_change_event
                    
                    	TX Resv Change event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_resv_create_event
                    
                    	TX Resv Create event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_resv_delete_event
                    
                    	TX Resv Delete event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_resv_error_event
                    
                    	TX Resv Error event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.SignallingCounters.MidsCounters.MidsCounter.Statistics, self).__init__()

                        self.yang_name = "statistics"
                        self.yang_parent_name = "mids-counter"

                        self.events_count = YLeaf(YType.uint32, "events-count")

                        self.events_total_count = YLeaf(YType.uint32, "events-total-count")

                        self.rx_backup_assign_err_event = YLeaf(YType.uint32, "rx-backup-assign-err-event")

                        self.rx_event_unknown = YLeaf(YType.uint32, "rx-event-unknown")

                        self.rx_path_change_event = YLeaf(YType.uint32, "rx-path-change-event")

                        self.rx_path_create_event = YLeaf(YType.uint32, "rx-path-create-event")

                        self.rx_path_delete_event = YLeaf(YType.uint32, "rx-path-delete-event")

                        self.rx_path_error_event = YLeaf(YType.uint32, "rx-path-error-event")

                        self.rx_path_reeval_query_event = YLeaf(YType.uint32, "rx-path-reeval-query-event")

                        self.rx_resv_change_event = YLeaf(YType.uint32, "rx-resv-change-event")

                        self.rx_resv_create_event = YLeaf(YType.uint32, "rx-resv-create-event")

                        self.rx_resv_delete_event = YLeaf(YType.uint32, "rx-resv-delete-event")

                        self.rx_resv_error_event = YLeaf(YType.uint32, "rx-resv-error-event")

                        self.tx_backup_assign_event = YLeaf(YType.uint32, "tx-backup-assign-event")

                        self.tx_event_unknown = YLeaf(YType.uint32, "tx-event-unknown")

                        self.tx_path_change_event = YLeaf(YType.uint32, "tx-path-change-event")

                        self.tx_path_create_event = YLeaf(YType.uint32, "tx-path-create-event")

                        self.tx_path_delete_event = YLeaf(YType.uint32, "tx-path-delete-event")

                        self.tx_path_error_event = YLeaf(YType.uint32, "tx-path-error-event")

                        self.tx_path_reeval_query_event = YLeaf(YType.uint32, "tx-path-reeval-query-event")

                        self.tx_resv_change_event = YLeaf(YType.uint32, "tx-resv-change-event")

                        self.tx_resv_create_event = YLeaf(YType.uint32, "tx-resv-create-event")

                        self.tx_resv_delete_event = YLeaf(YType.uint32, "tx-resv-delete-event")

                        self.tx_resv_error_event = YLeaf(YType.uint32, "tx-resv-error-event")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("events_count",
                                        "events_total_count",
                                        "rx_backup_assign_err_event",
                                        "rx_event_unknown",
                                        "rx_path_change_event",
                                        "rx_path_create_event",
                                        "rx_path_delete_event",
                                        "rx_path_error_event",
                                        "rx_path_reeval_query_event",
                                        "rx_resv_change_event",
                                        "rx_resv_create_event",
                                        "rx_resv_delete_event",
                                        "rx_resv_error_event",
                                        "tx_backup_assign_event",
                                        "tx_event_unknown",
                                        "tx_path_change_event",
                                        "tx_path_create_event",
                                        "tx_path_delete_event",
                                        "tx_path_error_event",
                                        "tx_path_reeval_query_event",
                                        "tx_resv_change_event",
                                        "tx_resv_create_event",
                                        "tx_resv_delete_event",
                                        "tx_resv_error_event") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.SignallingCounters.MidsCounters.MidsCounter.Statistics, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.SignallingCounters.MidsCounters.MidsCounter.Statistics, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.events_count.is_set or
                            self.events_total_count.is_set or
                            self.rx_backup_assign_err_event.is_set or
                            self.rx_event_unknown.is_set or
                            self.rx_path_change_event.is_set or
                            self.rx_path_create_event.is_set or
                            self.rx_path_delete_event.is_set or
                            self.rx_path_error_event.is_set or
                            self.rx_path_reeval_query_event.is_set or
                            self.rx_resv_change_event.is_set or
                            self.rx_resv_create_event.is_set or
                            self.rx_resv_delete_event.is_set or
                            self.rx_resv_error_event.is_set or
                            self.tx_backup_assign_event.is_set or
                            self.tx_event_unknown.is_set or
                            self.tx_path_change_event.is_set or
                            self.tx_path_create_event.is_set or
                            self.tx_path_delete_event.is_set or
                            self.tx_path_error_event.is_set or
                            self.tx_path_reeval_query_event.is_set or
                            self.tx_resv_change_event.is_set or
                            self.tx_resv_create_event.is_set or
                            self.tx_resv_delete_event.is_set or
                            self.tx_resv_error_event.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.events_count.yfilter != YFilter.not_set or
                            self.events_total_count.yfilter != YFilter.not_set or
                            self.rx_backup_assign_err_event.yfilter != YFilter.not_set or
                            self.rx_event_unknown.yfilter != YFilter.not_set or
                            self.rx_path_change_event.yfilter != YFilter.not_set or
                            self.rx_path_create_event.yfilter != YFilter.not_set or
                            self.rx_path_delete_event.yfilter != YFilter.not_set or
                            self.rx_path_error_event.yfilter != YFilter.not_set or
                            self.rx_path_reeval_query_event.yfilter != YFilter.not_set or
                            self.rx_resv_change_event.yfilter != YFilter.not_set or
                            self.rx_resv_create_event.yfilter != YFilter.not_set or
                            self.rx_resv_delete_event.yfilter != YFilter.not_set or
                            self.rx_resv_error_event.yfilter != YFilter.not_set or
                            self.tx_backup_assign_event.yfilter != YFilter.not_set or
                            self.tx_event_unknown.yfilter != YFilter.not_set or
                            self.tx_path_change_event.yfilter != YFilter.not_set or
                            self.tx_path_create_event.yfilter != YFilter.not_set or
                            self.tx_path_delete_event.yfilter != YFilter.not_set or
                            self.tx_path_error_event.yfilter != YFilter.not_set or
                            self.tx_path_reeval_query_event.yfilter != YFilter.not_set or
                            self.tx_resv_change_event.yfilter != YFilter.not_set or
                            self.tx_resv_create_event.yfilter != YFilter.not_set or
                            self.tx_resv_delete_event.yfilter != YFilter.not_set or
                            self.tx_resv_error_event.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "statistics" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.events_count.is_set or self.events_count.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.events_count.get_name_leafdata())
                        if (self.events_total_count.is_set or self.events_total_count.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.events_total_count.get_name_leafdata())
                        if (self.rx_backup_assign_err_event.is_set or self.rx_backup_assign_err_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_backup_assign_err_event.get_name_leafdata())
                        if (self.rx_event_unknown.is_set or self.rx_event_unknown.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_event_unknown.get_name_leafdata())
                        if (self.rx_path_change_event.is_set or self.rx_path_change_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_path_change_event.get_name_leafdata())
                        if (self.rx_path_create_event.is_set or self.rx_path_create_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_path_create_event.get_name_leafdata())
                        if (self.rx_path_delete_event.is_set or self.rx_path_delete_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_path_delete_event.get_name_leafdata())
                        if (self.rx_path_error_event.is_set or self.rx_path_error_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_path_error_event.get_name_leafdata())
                        if (self.rx_path_reeval_query_event.is_set or self.rx_path_reeval_query_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_path_reeval_query_event.get_name_leafdata())
                        if (self.rx_resv_change_event.is_set or self.rx_resv_change_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_resv_change_event.get_name_leafdata())
                        if (self.rx_resv_create_event.is_set or self.rx_resv_create_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_resv_create_event.get_name_leafdata())
                        if (self.rx_resv_delete_event.is_set or self.rx_resv_delete_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_resv_delete_event.get_name_leafdata())
                        if (self.rx_resv_error_event.is_set or self.rx_resv_error_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_resv_error_event.get_name_leafdata())
                        if (self.tx_backup_assign_event.is_set or self.tx_backup_assign_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_backup_assign_event.get_name_leafdata())
                        if (self.tx_event_unknown.is_set or self.tx_event_unknown.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_event_unknown.get_name_leafdata())
                        if (self.tx_path_change_event.is_set or self.tx_path_change_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_path_change_event.get_name_leafdata())
                        if (self.tx_path_create_event.is_set or self.tx_path_create_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_path_create_event.get_name_leafdata())
                        if (self.tx_path_delete_event.is_set or self.tx_path_delete_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_path_delete_event.get_name_leafdata())
                        if (self.tx_path_error_event.is_set or self.tx_path_error_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_path_error_event.get_name_leafdata())
                        if (self.tx_path_reeval_query_event.is_set or self.tx_path_reeval_query_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_path_reeval_query_event.get_name_leafdata())
                        if (self.tx_resv_change_event.is_set or self.tx_resv_change_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_resv_change_event.get_name_leafdata())
                        if (self.tx_resv_create_event.is_set or self.tx_resv_create_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_resv_create_event.get_name_leafdata())
                        if (self.tx_resv_delete_event.is_set or self.tx_resv_delete_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_resv_delete_event.get_name_leafdata())
                        if (self.tx_resv_error_event.is_set or self.tx_resv_error_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_resv_error_event.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "events-count" or name == "events-total-count" or name == "rx-backup-assign-err-event" or name == "rx-event-unknown" or name == "rx-path-change-event" or name == "rx-path-create-event" or name == "rx-path-delete-event" or name == "rx-path-error-event" or name == "rx-path-reeval-query-event" or name == "rx-resv-change-event" or name == "rx-resv-create-event" or name == "rx-resv-delete-event" or name == "rx-resv-error-event" or name == "tx-backup-assign-event" or name == "tx-event-unknown" or name == "tx-path-change-event" or name == "tx-path-create-event" or name == "tx-path-delete-event" or name == "tx-path-error-event" or name == "tx-path-reeval-query-event" or name == "tx-resv-change-event" or name == "tx-resv-create-event" or name == "tx-resv-delete-event" or name == "tx-resv-error-event"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "events-count"):
                            self.events_count = value
                            self.events_count.value_namespace = name_space
                            self.events_count.value_namespace_prefix = name_space_prefix
                        if(value_path == "events-total-count"):
                            self.events_total_count = value
                            self.events_total_count.value_namespace = name_space
                            self.events_total_count.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-backup-assign-err-event"):
                            self.rx_backup_assign_err_event = value
                            self.rx_backup_assign_err_event.value_namespace = name_space
                            self.rx_backup_assign_err_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-event-unknown"):
                            self.rx_event_unknown = value
                            self.rx_event_unknown.value_namespace = name_space
                            self.rx_event_unknown.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-path-change-event"):
                            self.rx_path_change_event = value
                            self.rx_path_change_event.value_namespace = name_space
                            self.rx_path_change_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-path-create-event"):
                            self.rx_path_create_event = value
                            self.rx_path_create_event.value_namespace = name_space
                            self.rx_path_create_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-path-delete-event"):
                            self.rx_path_delete_event = value
                            self.rx_path_delete_event.value_namespace = name_space
                            self.rx_path_delete_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-path-error-event"):
                            self.rx_path_error_event = value
                            self.rx_path_error_event.value_namespace = name_space
                            self.rx_path_error_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-path-reeval-query-event"):
                            self.rx_path_reeval_query_event = value
                            self.rx_path_reeval_query_event.value_namespace = name_space
                            self.rx_path_reeval_query_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-resv-change-event"):
                            self.rx_resv_change_event = value
                            self.rx_resv_change_event.value_namespace = name_space
                            self.rx_resv_change_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-resv-create-event"):
                            self.rx_resv_create_event = value
                            self.rx_resv_create_event.value_namespace = name_space
                            self.rx_resv_create_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-resv-delete-event"):
                            self.rx_resv_delete_event = value
                            self.rx_resv_delete_event.value_namespace = name_space
                            self.rx_resv_delete_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-resv-error-event"):
                            self.rx_resv_error_event = value
                            self.rx_resv_error_event.value_namespace = name_space
                            self.rx_resv_error_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-backup-assign-event"):
                            self.tx_backup_assign_event = value
                            self.tx_backup_assign_event.value_namespace = name_space
                            self.tx_backup_assign_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-event-unknown"):
                            self.tx_event_unknown = value
                            self.tx_event_unknown.value_namespace = name_space
                            self.tx_event_unknown.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-path-change-event"):
                            self.tx_path_change_event = value
                            self.tx_path_change_event.value_namespace = name_space
                            self.tx_path_change_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-path-create-event"):
                            self.tx_path_create_event = value
                            self.tx_path_create_event.value_namespace = name_space
                            self.tx_path_create_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-path-delete-event"):
                            self.tx_path_delete_event = value
                            self.tx_path_delete_event.value_namespace = name_space
                            self.tx_path_delete_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-path-error-event"):
                            self.tx_path_error_event = value
                            self.tx_path_error_event.value_namespace = name_space
                            self.tx_path_error_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-path-reeval-query-event"):
                            self.tx_path_reeval_query_event = value
                            self.tx_path_reeval_query_event.value_namespace = name_space
                            self.tx_path_reeval_query_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-resv-change-event"):
                            self.tx_resv_change_event = value
                            self.tx_resv_change_event.value_namespace = name_space
                            self.tx_resv_change_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-resv-create-event"):
                            self.tx_resv_create_event = value
                            self.tx_resv_create_event.value_namespace = name_space
                            self.tx_resv_create_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-resv-delete-event"):
                            self.tx_resv_delete_event = value
                            self.tx_resv_delete_event.value_namespace = name_space
                            self.tx_resv_delete_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-resv-error-event"):
                            self.tx_resv_error_event = value
                            self.tx_resv_error_event.value_namespace = name_space
                            self.tx_resv_error_event.value_namespace_prefix = name_space_prefix


                class S2LStatistic(Entity):
                    """
                    List of S2L Statistics
                    
                    .. attribute:: destination_address
                    
                    	Destination address
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: statistics
                    
                    	S2L stats
                    	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.MidsCounters.MidsCounter.S2LStatistic.Statistics>`
                    
                    .. attribute:: sub_group_id
                    
                    	subgroup ID
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: sub_group_originator
                    
                    	Subgroup Originator
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.SignallingCounters.MidsCounters.MidsCounter.S2LStatistic, self).__init__()

                        self.yang_name = "s2l-statistic"
                        self.yang_parent_name = "mids-counter"

                        self.destination_address = YLeaf(YType.str, "destination-address")

                        self.sub_group_id = YLeaf(YType.uint16, "sub-group-id")

                        self.sub_group_originator = YLeaf(YType.str, "sub-group-originator")

                        self.statistics = MplsTeStandby.SignallingCounters.MidsCounters.MidsCounter.S2LStatistic.Statistics()
                        self.statistics.parent = self
                        self._children_name_map["statistics"] = "statistics"
                        self._children_yang_names.add("statistics")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("destination_address",
                                        "sub_group_id",
                                        "sub_group_originator") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.SignallingCounters.MidsCounters.MidsCounter.S2LStatistic, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.SignallingCounters.MidsCounters.MidsCounter.S2LStatistic, self).__setattr__(name, value)


                    class Statistics(Entity):
                        """
                        S2L stats
                        
                        .. attribute:: events_count
                        
                        	TE Signaling event count
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: events_total_count
                        
                        	Total TE Signalling event count
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_backup_assign_err_event
                        
                        	Error on Backup Assign event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_event_unknown
                        
                        	RX Unknown events
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_path_change_event
                        
                        	RX Path Change event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_path_create_event
                        
                        	RX Path Create event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_path_delete_event
                        
                        	RX Path Delete event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_path_error_event
                        
                        	RX Path Error event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_path_reeval_query_event
                        
                        	RX Path Reeval Query event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_resv_change_event
                        
                        	RX Resv Change event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_resv_create_event
                        
                        	RX Resv Create event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_resv_delete_event
                        
                        	RX Resv Delete event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_resv_error_event
                        
                        	RX Resv Error event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_backup_assign_event
                        
                        	Backup Assign event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_event_unknown
                        
                        	Unknown TX events
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_path_change_event
                        
                        	TX Path Change event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_path_create_event
                        
                        	TX Path Create event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_path_delete_event
                        
                        	TX Path Delete event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_path_error_event
                        
                        	TX Path Error event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_path_reeval_query_event
                        
                        	TX Path Reeval Query event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_resv_change_event
                        
                        	TX Resv Change event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_resv_create_event
                        
                        	TX Resv Create event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_resv_delete_event
                        
                        	TX Resv Delete event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_resv_error_event
                        
                        	TX Resv Error event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.SignallingCounters.MidsCounters.MidsCounter.S2LStatistic.Statistics, self).__init__()

                            self.yang_name = "statistics"
                            self.yang_parent_name = "s2l-statistic"

                            self.events_count = YLeaf(YType.uint32, "events-count")

                            self.events_total_count = YLeaf(YType.uint32, "events-total-count")

                            self.rx_backup_assign_err_event = YLeaf(YType.uint32, "rx-backup-assign-err-event")

                            self.rx_event_unknown = YLeaf(YType.uint32, "rx-event-unknown")

                            self.rx_path_change_event = YLeaf(YType.uint32, "rx-path-change-event")

                            self.rx_path_create_event = YLeaf(YType.uint32, "rx-path-create-event")

                            self.rx_path_delete_event = YLeaf(YType.uint32, "rx-path-delete-event")

                            self.rx_path_error_event = YLeaf(YType.uint32, "rx-path-error-event")

                            self.rx_path_reeval_query_event = YLeaf(YType.uint32, "rx-path-reeval-query-event")

                            self.rx_resv_change_event = YLeaf(YType.uint32, "rx-resv-change-event")

                            self.rx_resv_create_event = YLeaf(YType.uint32, "rx-resv-create-event")

                            self.rx_resv_delete_event = YLeaf(YType.uint32, "rx-resv-delete-event")

                            self.rx_resv_error_event = YLeaf(YType.uint32, "rx-resv-error-event")

                            self.tx_backup_assign_event = YLeaf(YType.uint32, "tx-backup-assign-event")

                            self.tx_event_unknown = YLeaf(YType.uint32, "tx-event-unknown")

                            self.tx_path_change_event = YLeaf(YType.uint32, "tx-path-change-event")

                            self.tx_path_create_event = YLeaf(YType.uint32, "tx-path-create-event")

                            self.tx_path_delete_event = YLeaf(YType.uint32, "tx-path-delete-event")

                            self.tx_path_error_event = YLeaf(YType.uint32, "tx-path-error-event")

                            self.tx_path_reeval_query_event = YLeaf(YType.uint32, "tx-path-reeval-query-event")

                            self.tx_resv_change_event = YLeaf(YType.uint32, "tx-resv-change-event")

                            self.tx_resv_create_event = YLeaf(YType.uint32, "tx-resv-create-event")

                            self.tx_resv_delete_event = YLeaf(YType.uint32, "tx-resv-delete-event")

                            self.tx_resv_error_event = YLeaf(YType.uint32, "tx-resv-error-event")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("events_count",
                                            "events_total_count",
                                            "rx_backup_assign_err_event",
                                            "rx_event_unknown",
                                            "rx_path_change_event",
                                            "rx_path_create_event",
                                            "rx_path_delete_event",
                                            "rx_path_error_event",
                                            "rx_path_reeval_query_event",
                                            "rx_resv_change_event",
                                            "rx_resv_create_event",
                                            "rx_resv_delete_event",
                                            "rx_resv_error_event",
                                            "tx_backup_assign_event",
                                            "tx_event_unknown",
                                            "tx_path_change_event",
                                            "tx_path_create_event",
                                            "tx_path_delete_event",
                                            "tx_path_error_event",
                                            "tx_path_reeval_query_event",
                                            "tx_resv_change_event",
                                            "tx_resv_create_event",
                                            "tx_resv_delete_event",
                                            "tx_resv_error_event") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.SignallingCounters.MidsCounters.MidsCounter.S2LStatistic.Statistics, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.SignallingCounters.MidsCounters.MidsCounter.S2LStatistic.Statistics, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.events_count.is_set or
                                self.events_total_count.is_set or
                                self.rx_backup_assign_err_event.is_set or
                                self.rx_event_unknown.is_set or
                                self.rx_path_change_event.is_set or
                                self.rx_path_create_event.is_set or
                                self.rx_path_delete_event.is_set or
                                self.rx_path_error_event.is_set or
                                self.rx_path_reeval_query_event.is_set or
                                self.rx_resv_change_event.is_set or
                                self.rx_resv_create_event.is_set or
                                self.rx_resv_delete_event.is_set or
                                self.rx_resv_error_event.is_set or
                                self.tx_backup_assign_event.is_set or
                                self.tx_event_unknown.is_set or
                                self.tx_path_change_event.is_set or
                                self.tx_path_create_event.is_set or
                                self.tx_path_delete_event.is_set or
                                self.tx_path_error_event.is_set or
                                self.tx_path_reeval_query_event.is_set or
                                self.tx_resv_change_event.is_set or
                                self.tx_resv_create_event.is_set or
                                self.tx_resv_delete_event.is_set or
                                self.tx_resv_error_event.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.events_count.yfilter != YFilter.not_set or
                                self.events_total_count.yfilter != YFilter.not_set or
                                self.rx_backup_assign_err_event.yfilter != YFilter.not_set or
                                self.rx_event_unknown.yfilter != YFilter.not_set or
                                self.rx_path_change_event.yfilter != YFilter.not_set or
                                self.rx_path_create_event.yfilter != YFilter.not_set or
                                self.rx_path_delete_event.yfilter != YFilter.not_set or
                                self.rx_path_error_event.yfilter != YFilter.not_set or
                                self.rx_path_reeval_query_event.yfilter != YFilter.not_set or
                                self.rx_resv_change_event.yfilter != YFilter.not_set or
                                self.rx_resv_create_event.yfilter != YFilter.not_set or
                                self.rx_resv_delete_event.yfilter != YFilter.not_set or
                                self.rx_resv_error_event.yfilter != YFilter.not_set or
                                self.tx_backup_assign_event.yfilter != YFilter.not_set or
                                self.tx_event_unknown.yfilter != YFilter.not_set or
                                self.tx_path_change_event.yfilter != YFilter.not_set or
                                self.tx_path_create_event.yfilter != YFilter.not_set or
                                self.tx_path_delete_event.yfilter != YFilter.not_set or
                                self.tx_path_error_event.yfilter != YFilter.not_set or
                                self.tx_path_reeval_query_event.yfilter != YFilter.not_set or
                                self.tx_resv_change_event.yfilter != YFilter.not_set or
                                self.tx_resv_create_event.yfilter != YFilter.not_set or
                                self.tx_resv_delete_event.yfilter != YFilter.not_set or
                                self.tx_resv_error_event.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "statistics" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.events_count.is_set or self.events_count.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.events_count.get_name_leafdata())
                            if (self.events_total_count.is_set or self.events_total_count.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.events_total_count.get_name_leafdata())
                            if (self.rx_backup_assign_err_event.is_set or self.rx_backup_assign_err_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_backup_assign_err_event.get_name_leafdata())
                            if (self.rx_event_unknown.is_set or self.rx_event_unknown.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_event_unknown.get_name_leafdata())
                            if (self.rx_path_change_event.is_set or self.rx_path_change_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_path_change_event.get_name_leafdata())
                            if (self.rx_path_create_event.is_set or self.rx_path_create_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_path_create_event.get_name_leafdata())
                            if (self.rx_path_delete_event.is_set or self.rx_path_delete_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_path_delete_event.get_name_leafdata())
                            if (self.rx_path_error_event.is_set or self.rx_path_error_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_path_error_event.get_name_leafdata())
                            if (self.rx_path_reeval_query_event.is_set or self.rx_path_reeval_query_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_path_reeval_query_event.get_name_leafdata())
                            if (self.rx_resv_change_event.is_set or self.rx_resv_change_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_resv_change_event.get_name_leafdata())
                            if (self.rx_resv_create_event.is_set or self.rx_resv_create_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_resv_create_event.get_name_leafdata())
                            if (self.rx_resv_delete_event.is_set or self.rx_resv_delete_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_resv_delete_event.get_name_leafdata())
                            if (self.rx_resv_error_event.is_set or self.rx_resv_error_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_resv_error_event.get_name_leafdata())
                            if (self.tx_backup_assign_event.is_set or self.tx_backup_assign_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_backup_assign_event.get_name_leafdata())
                            if (self.tx_event_unknown.is_set or self.tx_event_unknown.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_event_unknown.get_name_leafdata())
                            if (self.tx_path_change_event.is_set or self.tx_path_change_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_path_change_event.get_name_leafdata())
                            if (self.tx_path_create_event.is_set or self.tx_path_create_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_path_create_event.get_name_leafdata())
                            if (self.tx_path_delete_event.is_set or self.tx_path_delete_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_path_delete_event.get_name_leafdata())
                            if (self.tx_path_error_event.is_set or self.tx_path_error_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_path_error_event.get_name_leafdata())
                            if (self.tx_path_reeval_query_event.is_set or self.tx_path_reeval_query_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_path_reeval_query_event.get_name_leafdata())
                            if (self.tx_resv_change_event.is_set or self.tx_resv_change_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_resv_change_event.get_name_leafdata())
                            if (self.tx_resv_create_event.is_set or self.tx_resv_create_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_resv_create_event.get_name_leafdata())
                            if (self.tx_resv_delete_event.is_set or self.tx_resv_delete_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_resv_delete_event.get_name_leafdata())
                            if (self.tx_resv_error_event.is_set or self.tx_resv_error_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_resv_error_event.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "events-count" or name == "events-total-count" or name == "rx-backup-assign-err-event" or name == "rx-event-unknown" or name == "rx-path-change-event" or name == "rx-path-create-event" or name == "rx-path-delete-event" or name == "rx-path-error-event" or name == "rx-path-reeval-query-event" or name == "rx-resv-change-event" or name == "rx-resv-create-event" or name == "rx-resv-delete-event" or name == "rx-resv-error-event" or name == "tx-backup-assign-event" or name == "tx-event-unknown" or name == "tx-path-change-event" or name == "tx-path-create-event" or name == "tx-path-delete-event" or name == "tx-path-error-event" or name == "tx-path-reeval-query-event" or name == "tx-resv-change-event" or name == "tx-resv-create-event" or name == "tx-resv-delete-event" or name == "tx-resv-error-event"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "events-count"):
                                self.events_count = value
                                self.events_count.value_namespace = name_space
                                self.events_count.value_namespace_prefix = name_space_prefix
                            if(value_path == "events-total-count"):
                                self.events_total_count = value
                                self.events_total_count.value_namespace = name_space
                                self.events_total_count.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-backup-assign-err-event"):
                                self.rx_backup_assign_err_event = value
                                self.rx_backup_assign_err_event.value_namespace = name_space
                                self.rx_backup_assign_err_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-event-unknown"):
                                self.rx_event_unknown = value
                                self.rx_event_unknown.value_namespace = name_space
                                self.rx_event_unknown.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-path-change-event"):
                                self.rx_path_change_event = value
                                self.rx_path_change_event.value_namespace = name_space
                                self.rx_path_change_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-path-create-event"):
                                self.rx_path_create_event = value
                                self.rx_path_create_event.value_namespace = name_space
                                self.rx_path_create_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-path-delete-event"):
                                self.rx_path_delete_event = value
                                self.rx_path_delete_event.value_namespace = name_space
                                self.rx_path_delete_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-path-error-event"):
                                self.rx_path_error_event = value
                                self.rx_path_error_event.value_namespace = name_space
                                self.rx_path_error_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-path-reeval-query-event"):
                                self.rx_path_reeval_query_event = value
                                self.rx_path_reeval_query_event.value_namespace = name_space
                                self.rx_path_reeval_query_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-resv-change-event"):
                                self.rx_resv_change_event = value
                                self.rx_resv_change_event.value_namespace = name_space
                                self.rx_resv_change_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-resv-create-event"):
                                self.rx_resv_create_event = value
                                self.rx_resv_create_event.value_namespace = name_space
                                self.rx_resv_create_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-resv-delete-event"):
                                self.rx_resv_delete_event = value
                                self.rx_resv_delete_event.value_namespace = name_space
                                self.rx_resv_delete_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-resv-error-event"):
                                self.rx_resv_error_event = value
                                self.rx_resv_error_event.value_namespace = name_space
                                self.rx_resv_error_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-backup-assign-event"):
                                self.tx_backup_assign_event = value
                                self.tx_backup_assign_event.value_namespace = name_space
                                self.tx_backup_assign_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-event-unknown"):
                                self.tx_event_unknown = value
                                self.tx_event_unknown.value_namespace = name_space
                                self.tx_event_unknown.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-path-change-event"):
                                self.tx_path_change_event = value
                                self.tx_path_change_event.value_namespace = name_space
                                self.tx_path_change_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-path-create-event"):
                                self.tx_path_create_event = value
                                self.tx_path_create_event.value_namespace = name_space
                                self.tx_path_create_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-path-delete-event"):
                                self.tx_path_delete_event = value
                                self.tx_path_delete_event.value_namespace = name_space
                                self.tx_path_delete_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-path-error-event"):
                                self.tx_path_error_event = value
                                self.tx_path_error_event.value_namespace = name_space
                                self.tx_path_error_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-path-reeval-query-event"):
                                self.tx_path_reeval_query_event = value
                                self.tx_path_reeval_query_event.value_namespace = name_space
                                self.tx_path_reeval_query_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-resv-change-event"):
                                self.tx_resv_change_event = value
                                self.tx_resv_change_event.value_namespace = name_space
                                self.tx_resv_change_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-resv-create-event"):
                                self.tx_resv_create_event = value
                                self.tx_resv_create_event.value_namespace = name_space
                                self.tx_resv_create_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-resv-delete-event"):
                                self.tx_resv_delete_event = value
                                self.tx_resv_delete_event.value_namespace = name_space
                                self.tx_resv_delete_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-resv-error-event"):
                                self.tx_resv_error_event = value
                                self.tx_resv_error_event.value_namespace = name_space
                                self.tx_resv_error_event.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.destination_address.is_set or
                            self.sub_group_id.is_set or
                            self.sub_group_originator.is_set or
                            (self.statistics is not None and self.statistics.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.destination_address.yfilter != YFilter.not_set or
                            self.sub_group_id.yfilter != YFilter.not_set or
                            self.sub_group_originator.yfilter != YFilter.not_set or
                            (self.statistics is not None and self.statistics.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "s2l-statistic" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.destination_address.get_name_leafdata())
                        if (self.sub_group_id.is_set or self.sub_group_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.sub_group_id.get_name_leafdata())
                        if (self.sub_group_originator.is_set or self.sub_group_originator.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.sub_group_originator.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "statistics"):
                            if (self.statistics is None):
                                self.statistics = MplsTeStandby.SignallingCounters.MidsCounters.MidsCounter.S2LStatistic.Statistics()
                                self.statistics.parent = self
                                self._children_name_map["statistics"] = "statistics"
                            return self.statistics

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "statistics" or name == "destination-address" or name == "sub-group-id" or name == "sub-group-originator"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "destination-address"):
                            self.destination_address = value
                            self.destination_address.value_namespace = name_space
                            self.destination_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "sub-group-id"):
                            self.sub_group_id = value
                            self.sub_group_id.value_namespace = name_space
                            self.sub_group_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "sub-group-originator"):
                            self.sub_group_originator = value
                            self.sub_group_originator.value_namespace = name_space
                            self.sub_group_originator.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.s2l_statistic:
                        if (c.has_data()):
                            return True
                    return (
                        self.source_address.is_set or
                        self.destination_address.is_set or
                        self.tunnel_id.is_set or
                        self.extended_tunnel_id.is_set or
                        self.lsp_id.is_set or
                        self.tunnel_name.is_set or
                        (self.statistics is not None and self.statistics.has_data()))

                def has_operation(self):
                    for c in self.s2l_statistic:
                        if (c.has_operation()):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        self.source_address.yfilter != YFilter.not_set or
                        self.destination_address.yfilter != YFilter.not_set or
                        self.tunnel_id.yfilter != YFilter.not_set or
                        self.extended_tunnel_id.yfilter != YFilter.not_set or
                        self.lsp_id.yfilter != YFilter.not_set or
                        self.tunnel_name.yfilter != YFilter.not_set or
                        (self.statistics is not None and self.statistics.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "mids-counter" + "[source-address='" + self.source_address.get() + "']" + "[destination-address='" + self.destination_address.get() + "']" + "[tunnel-id='" + self.tunnel_id.get() + "']" + "[extended-tunnel-id='" + self.extended_tunnel_id.get() + "']" + "[lsp-id='" + self.lsp_id.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/signalling-counters/mids-counters/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.source_address.is_set or self.source_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.source_address.get_name_leafdata())
                    if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.destination_address.get_name_leafdata())
                    if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_id.get_name_leafdata())
                    if (self.extended_tunnel_id.is_set or self.extended_tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.extended_tunnel_id.get_name_leafdata())
                    if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.lsp_id.get_name_leafdata())
                    if (self.tunnel_name.is_set or self.tunnel_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_name.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "s2l-statistic"):
                        for c in self.s2l_statistic:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsTeStandby.SignallingCounters.MidsCounters.MidsCounter.S2LStatistic()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.s2l_statistic.append(c)
                        return c

                    if (child_yang_name == "statistics"):
                        if (self.statistics is None):
                            self.statistics = MplsTeStandby.SignallingCounters.MidsCounters.MidsCounter.Statistics()
                            self.statistics.parent = self
                            self._children_name_map["statistics"] = "statistics"
                        return self.statistics

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "s2l-statistic" or name == "statistics" or name == "source-address" or name == "destination-address" or name == "tunnel-id" or name == "extended-tunnel-id" or name == "lsp-id" or name == "tunnel-name"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "source-address"):
                        self.source_address = value
                        self.source_address.value_namespace = name_space
                        self.source_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "destination-address"):
                        self.destination_address = value
                        self.destination_address.value_namespace = name_space
                        self.destination_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-id"):
                        self.tunnel_id = value
                        self.tunnel_id.value_namespace = name_space
                        self.tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "extended-tunnel-id"):
                        self.extended_tunnel_id = value
                        self.extended_tunnel_id.value_namespace = name_space
                        self.extended_tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "lsp-id"):
                        self.lsp_id = value
                        self.lsp_id.value_namespace = name_space
                        self.lsp_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-name"):
                        self.tunnel_name = value
                        self.tunnel_name.value_namespace = name_space
                        self.tunnel_name.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.mids_counter:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.mids_counter:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "mids-counters" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/signalling-counters/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "mids-counter"):
                    for c in self.mids_counter:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTeStandby.SignallingCounters.MidsCounters.MidsCounter()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.mids_counter.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "mids-counter"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass


        class HeadSignallingCounters(Entity):
            """
            Sig Head Table TE counters
            
            .. attribute:: head_signalling_counter
            
            	TE stats
            	**type**\: list of    :py:class:`HeadSignallingCounter <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTeStandby.SignallingCounters.HeadSignallingCounters, self).__init__()

                self.yang_name = "head-signalling-counters"
                self.yang_parent_name = "signalling-counters"

                self.head_signalling_counter = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTeStandby.SignallingCounters.HeadSignallingCounters, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTeStandby.SignallingCounters.HeadSignallingCounters, self).__setattr__(name, value)


            class HeadSignallingCounter(Entity):
                """
                TE stats
                
                .. attribute:: ctype  <key>
                
                	Ctype
                	**type**\:   :py:class:`Ctype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.Ctype>`
                
                .. attribute:: tunnel_id  <key>
                
                	Tunnel ID
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: destination_statistic
                
                	List of Destination Stats
                	**type**\: list of    :py:class:`DestinationStatistic <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic>`
                
                .. attribute:: lsp_id
                
                	LSP ID
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: statistics
                
                	VIF stats
                	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.Statistics>`
                
                .. attribute:: tunnel_name
                
                	Tunnel Name
                	**type**\:  str
                
                .. attribute:: tunnel_sig_name
                
                	Tunnel Signalled\-Name
                	**type**\:  str
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTeStandby.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter, self).__init__()

                    self.yang_name = "head-signalling-counter"
                    self.yang_parent_name = "head-signalling-counters"

                    self.ctype = YLeaf(YType.enumeration, "ctype")

                    self.tunnel_id = YLeaf(YType.int32, "tunnel-id")

                    self.lsp_id = YLeaf(YType.uint16, "lsp-id")

                    self.tunnel_name = YLeaf(YType.str, "tunnel-name")

                    self.tunnel_sig_name = YLeaf(YType.str, "tunnel-sig-name")

                    self.statistics = MplsTeStandby.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.Statistics()
                    self.statistics.parent = self
                    self._children_name_map["statistics"] = "statistics"
                    self._children_yang_names.add("statistics")

                    self.destination_statistic = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("ctype",
                                    "tunnel_id",
                                    "lsp_id",
                                    "tunnel_name",
                                    "tunnel_sig_name") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTeStandby.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTeStandby.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter, self).__setattr__(name, value)


                class Statistics(Entity):
                    """
                    VIF stats
                    
                    .. attribute:: events_count
                    
                    	TE Signaling event count
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: events_total_count
                    
                    	Total TE Signalling event count
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_backup_assign_err_event
                    
                    	Error on Backup Assign event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_event_unknown
                    
                    	RX Unknown events
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_path_change_event
                    
                    	RX Path Change event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_path_create_event
                    
                    	RX Path Create event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_path_delete_event
                    
                    	RX Path Delete event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_path_error_event
                    
                    	RX Path Error event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_path_reeval_query_event
                    
                    	RX Path Reeval Query event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_resv_change_event
                    
                    	RX Resv Change event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_resv_create_event
                    
                    	RX Resv Create event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_resv_delete_event
                    
                    	RX Resv Delete event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_resv_error_event
                    
                    	RX Resv Error event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_backup_assign_event
                    
                    	Backup Assign event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_event_unknown
                    
                    	Unknown TX events
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_path_change_event
                    
                    	TX Path Change event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_path_create_event
                    
                    	TX Path Create event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_path_delete_event
                    
                    	TX Path Delete event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_path_error_event
                    
                    	TX Path Error event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_path_reeval_query_event
                    
                    	TX Path Reeval Query event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_resv_change_event
                    
                    	TX Resv Change event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_resv_create_event
                    
                    	TX Resv Create event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_resv_delete_event
                    
                    	TX Resv Delete event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_resv_error_event
                    
                    	TX Resv Error event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.Statistics, self).__init__()

                        self.yang_name = "statistics"
                        self.yang_parent_name = "head-signalling-counter"

                        self.events_count = YLeaf(YType.uint32, "events-count")

                        self.events_total_count = YLeaf(YType.uint32, "events-total-count")

                        self.rx_backup_assign_err_event = YLeaf(YType.uint32, "rx-backup-assign-err-event")

                        self.rx_event_unknown = YLeaf(YType.uint32, "rx-event-unknown")

                        self.rx_path_change_event = YLeaf(YType.uint32, "rx-path-change-event")

                        self.rx_path_create_event = YLeaf(YType.uint32, "rx-path-create-event")

                        self.rx_path_delete_event = YLeaf(YType.uint32, "rx-path-delete-event")

                        self.rx_path_error_event = YLeaf(YType.uint32, "rx-path-error-event")

                        self.rx_path_reeval_query_event = YLeaf(YType.uint32, "rx-path-reeval-query-event")

                        self.rx_resv_change_event = YLeaf(YType.uint32, "rx-resv-change-event")

                        self.rx_resv_create_event = YLeaf(YType.uint32, "rx-resv-create-event")

                        self.rx_resv_delete_event = YLeaf(YType.uint32, "rx-resv-delete-event")

                        self.rx_resv_error_event = YLeaf(YType.uint32, "rx-resv-error-event")

                        self.tx_backup_assign_event = YLeaf(YType.uint32, "tx-backup-assign-event")

                        self.tx_event_unknown = YLeaf(YType.uint32, "tx-event-unknown")

                        self.tx_path_change_event = YLeaf(YType.uint32, "tx-path-change-event")

                        self.tx_path_create_event = YLeaf(YType.uint32, "tx-path-create-event")

                        self.tx_path_delete_event = YLeaf(YType.uint32, "tx-path-delete-event")

                        self.tx_path_error_event = YLeaf(YType.uint32, "tx-path-error-event")

                        self.tx_path_reeval_query_event = YLeaf(YType.uint32, "tx-path-reeval-query-event")

                        self.tx_resv_change_event = YLeaf(YType.uint32, "tx-resv-change-event")

                        self.tx_resv_create_event = YLeaf(YType.uint32, "tx-resv-create-event")

                        self.tx_resv_delete_event = YLeaf(YType.uint32, "tx-resv-delete-event")

                        self.tx_resv_error_event = YLeaf(YType.uint32, "tx-resv-error-event")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("events_count",
                                        "events_total_count",
                                        "rx_backup_assign_err_event",
                                        "rx_event_unknown",
                                        "rx_path_change_event",
                                        "rx_path_create_event",
                                        "rx_path_delete_event",
                                        "rx_path_error_event",
                                        "rx_path_reeval_query_event",
                                        "rx_resv_change_event",
                                        "rx_resv_create_event",
                                        "rx_resv_delete_event",
                                        "rx_resv_error_event",
                                        "tx_backup_assign_event",
                                        "tx_event_unknown",
                                        "tx_path_change_event",
                                        "tx_path_create_event",
                                        "tx_path_delete_event",
                                        "tx_path_error_event",
                                        "tx_path_reeval_query_event",
                                        "tx_resv_change_event",
                                        "tx_resv_create_event",
                                        "tx_resv_delete_event",
                                        "tx_resv_error_event") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.Statistics, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.Statistics, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.events_count.is_set or
                            self.events_total_count.is_set or
                            self.rx_backup_assign_err_event.is_set or
                            self.rx_event_unknown.is_set or
                            self.rx_path_change_event.is_set or
                            self.rx_path_create_event.is_set or
                            self.rx_path_delete_event.is_set or
                            self.rx_path_error_event.is_set or
                            self.rx_path_reeval_query_event.is_set or
                            self.rx_resv_change_event.is_set or
                            self.rx_resv_create_event.is_set or
                            self.rx_resv_delete_event.is_set or
                            self.rx_resv_error_event.is_set or
                            self.tx_backup_assign_event.is_set or
                            self.tx_event_unknown.is_set or
                            self.tx_path_change_event.is_set or
                            self.tx_path_create_event.is_set or
                            self.tx_path_delete_event.is_set or
                            self.tx_path_error_event.is_set or
                            self.tx_path_reeval_query_event.is_set or
                            self.tx_resv_change_event.is_set or
                            self.tx_resv_create_event.is_set or
                            self.tx_resv_delete_event.is_set or
                            self.tx_resv_error_event.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.events_count.yfilter != YFilter.not_set or
                            self.events_total_count.yfilter != YFilter.not_set or
                            self.rx_backup_assign_err_event.yfilter != YFilter.not_set or
                            self.rx_event_unknown.yfilter != YFilter.not_set or
                            self.rx_path_change_event.yfilter != YFilter.not_set or
                            self.rx_path_create_event.yfilter != YFilter.not_set or
                            self.rx_path_delete_event.yfilter != YFilter.not_set or
                            self.rx_path_error_event.yfilter != YFilter.not_set or
                            self.rx_path_reeval_query_event.yfilter != YFilter.not_set or
                            self.rx_resv_change_event.yfilter != YFilter.not_set or
                            self.rx_resv_create_event.yfilter != YFilter.not_set or
                            self.rx_resv_delete_event.yfilter != YFilter.not_set or
                            self.rx_resv_error_event.yfilter != YFilter.not_set or
                            self.tx_backup_assign_event.yfilter != YFilter.not_set or
                            self.tx_event_unknown.yfilter != YFilter.not_set or
                            self.tx_path_change_event.yfilter != YFilter.not_set or
                            self.tx_path_create_event.yfilter != YFilter.not_set or
                            self.tx_path_delete_event.yfilter != YFilter.not_set or
                            self.tx_path_error_event.yfilter != YFilter.not_set or
                            self.tx_path_reeval_query_event.yfilter != YFilter.not_set or
                            self.tx_resv_change_event.yfilter != YFilter.not_set or
                            self.tx_resv_create_event.yfilter != YFilter.not_set or
                            self.tx_resv_delete_event.yfilter != YFilter.not_set or
                            self.tx_resv_error_event.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "statistics" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.events_count.is_set or self.events_count.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.events_count.get_name_leafdata())
                        if (self.events_total_count.is_set or self.events_total_count.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.events_total_count.get_name_leafdata())
                        if (self.rx_backup_assign_err_event.is_set or self.rx_backup_assign_err_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_backup_assign_err_event.get_name_leafdata())
                        if (self.rx_event_unknown.is_set or self.rx_event_unknown.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_event_unknown.get_name_leafdata())
                        if (self.rx_path_change_event.is_set or self.rx_path_change_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_path_change_event.get_name_leafdata())
                        if (self.rx_path_create_event.is_set or self.rx_path_create_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_path_create_event.get_name_leafdata())
                        if (self.rx_path_delete_event.is_set or self.rx_path_delete_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_path_delete_event.get_name_leafdata())
                        if (self.rx_path_error_event.is_set or self.rx_path_error_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_path_error_event.get_name_leafdata())
                        if (self.rx_path_reeval_query_event.is_set or self.rx_path_reeval_query_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_path_reeval_query_event.get_name_leafdata())
                        if (self.rx_resv_change_event.is_set or self.rx_resv_change_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_resv_change_event.get_name_leafdata())
                        if (self.rx_resv_create_event.is_set or self.rx_resv_create_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_resv_create_event.get_name_leafdata())
                        if (self.rx_resv_delete_event.is_set or self.rx_resv_delete_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_resv_delete_event.get_name_leafdata())
                        if (self.rx_resv_error_event.is_set or self.rx_resv_error_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_resv_error_event.get_name_leafdata())
                        if (self.tx_backup_assign_event.is_set or self.tx_backup_assign_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_backup_assign_event.get_name_leafdata())
                        if (self.tx_event_unknown.is_set or self.tx_event_unknown.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_event_unknown.get_name_leafdata())
                        if (self.tx_path_change_event.is_set or self.tx_path_change_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_path_change_event.get_name_leafdata())
                        if (self.tx_path_create_event.is_set or self.tx_path_create_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_path_create_event.get_name_leafdata())
                        if (self.tx_path_delete_event.is_set or self.tx_path_delete_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_path_delete_event.get_name_leafdata())
                        if (self.tx_path_error_event.is_set or self.tx_path_error_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_path_error_event.get_name_leafdata())
                        if (self.tx_path_reeval_query_event.is_set or self.tx_path_reeval_query_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_path_reeval_query_event.get_name_leafdata())
                        if (self.tx_resv_change_event.is_set or self.tx_resv_change_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_resv_change_event.get_name_leafdata())
                        if (self.tx_resv_create_event.is_set or self.tx_resv_create_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_resv_create_event.get_name_leafdata())
                        if (self.tx_resv_delete_event.is_set or self.tx_resv_delete_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_resv_delete_event.get_name_leafdata())
                        if (self.tx_resv_error_event.is_set or self.tx_resv_error_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_resv_error_event.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "events-count" or name == "events-total-count" or name == "rx-backup-assign-err-event" or name == "rx-event-unknown" or name == "rx-path-change-event" or name == "rx-path-create-event" or name == "rx-path-delete-event" or name == "rx-path-error-event" or name == "rx-path-reeval-query-event" or name == "rx-resv-change-event" or name == "rx-resv-create-event" or name == "rx-resv-delete-event" or name == "rx-resv-error-event" or name == "tx-backup-assign-event" or name == "tx-event-unknown" or name == "tx-path-change-event" or name == "tx-path-create-event" or name == "tx-path-delete-event" or name == "tx-path-error-event" or name == "tx-path-reeval-query-event" or name == "tx-resv-change-event" or name == "tx-resv-create-event" or name == "tx-resv-delete-event" or name == "tx-resv-error-event"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "events-count"):
                            self.events_count = value
                            self.events_count.value_namespace = name_space
                            self.events_count.value_namespace_prefix = name_space_prefix
                        if(value_path == "events-total-count"):
                            self.events_total_count = value
                            self.events_total_count.value_namespace = name_space
                            self.events_total_count.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-backup-assign-err-event"):
                            self.rx_backup_assign_err_event = value
                            self.rx_backup_assign_err_event.value_namespace = name_space
                            self.rx_backup_assign_err_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-event-unknown"):
                            self.rx_event_unknown = value
                            self.rx_event_unknown.value_namespace = name_space
                            self.rx_event_unknown.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-path-change-event"):
                            self.rx_path_change_event = value
                            self.rx_path_change_event.value_namespace = name_space
                            self.rx_path_change_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-path-create-event"):
                            self.rx_path_create_event = value
                            self.rx_path_create_event.value_namespace = name_space
                            self.rx_path_create_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-path-delete-event"):
                            self.rx_path_delete_event = value
                            self.rx_path_delete_event.value_namespace = name_space
                            self.rx_path_delete_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-path-error-event"):
                            self.rx_path_error_event = value
                            self.rx_path_error_event.value_namespace = name_space
                            self.rx_path_error_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-path-reeval-query-event"):
                            self.rx_path_reeval_query_event = value
                            self.rx_path_reeval_query_event.value_namespace = name_space
                            self.rx_path_reeval_query_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-resv-change-event"):
                            self.rx_resv_change_event = value
                            self.rx_resv_change_event.value_namespace = name_space
                            self.rx_resv_change_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-resv-create-event"):
                            self.rx_resv_create_event = value
                            self.rx_resv_create_event.value_namespace = name_space
                            self.rx_resv_create_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-resv-delete-event"):
                            self.rx_resv_delete_event = value
                            self.rx_resv_delete_event.value_namespace = name_space
                            self.rx_resv_delete_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-resv-error-event"):
                            self.rx_resv_error_event = value
                            self.rx_resv_error_event.value_namespace = name_space
                            self.rx_resv_error_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-backup-assign-event"):
                            self.tx_backup_assign_event = value
                            self.tx_backup_assign_event.value_namespace = name_space
                            self.tx_backup_assign_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-event-unknown"):
                            self.tx_event_unknown = value
                            self.tx_event_unknown.value_namespace = name_space
                            self.tx_event_unknown.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-path-change-event"):
                            self.tx_path_change_event = value
                            self.tx_path_change_event.value_namespace = name_space
                            self.tx_path_change_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-path-create-event"):
                            self.tx_path_create_event = value
                            self.tx_path_create_event.value_namespace = name_space
                            self.tx_path_create_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-path-delete-event"):
                            self.tx_path_delete_event = value
                            self.tx_path_delete_event.value_namespace = name_space
                            self.tx_path_delete_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-path-error-event"):
                            self.tx_path_error_event = value
                            self.tx_path_error_event.value_namespace = name_space
                            self.tx_path_error_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-path-reeval-query-event"):
                            self.tx_path_reeval_query_event = value
                            self.tx_path_reeval_query_event.value_namespace = name_space
                            self.tx_path_reeval_query_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-resv-change-event"):
                            self.tx_resv_change_event = value
                            self.tx_resv_change_event.value_namespace = name_space
                            self.tx_resv_change_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-resv-create-event"):
                            self.tx_resv_create_event = value
                            self.tx_resv_create_event.value_namespace = name_space
                            self.tx_resv_create_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-resv-delete-event"):
                            self.tx_resv_delete_event = value
                            self.tx_resv_delete_event.value_namespace = name_space
                            self.tx_resv_delete_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-resv-error-event"):
                            self.tx_resv_error_event = value
                            self.tx_resv_error_event.value_namespace = name_space
                            self.tx_resv_error_event.value_namespace_prefix = name_space_prefix


                class DestinationStatistic(Entity):
                    """
                    List of Destination Stats
                    
                    .. attribute:: destination_address
                    
                    	Destination address
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: s2l_statistic
                    
                    	List of S2L Stats
                    	**type**\: list of    :py:class:`S2LStatistic <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic.S2LStatistic>`
                    
                    .. attribute:: statistics
                    
                    	Destination stats
                    	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic.Statistics>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic, self).__init__()

                        self.yang_name = "destination-statistic"
                        self.yang_parent_name = "head-signalling-counter"

                        self.destination_address = YLeaf(YType.str, "destination-address")

                        self.statistics = MplsTeStandby.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic.Statistics()
                        self.statistics.parent = self
                        self._children_name_map["statistics"] = "statistics"
                        self._children_yang_names.add("statistics")

                        self.s2l_statistic = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("destination_address") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic, self).__setattr__(name, value)


                    class Statistics(Entity):
                        """
                        Destination stats
                        
                        .. attribute:: events_count
                        
                        	TE Signaling event count
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: events_total_count
                        
                        	Total TE Signalling event count
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_backup_assign_err_event
                        
                        	Error on Backup Assign event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_event_unknown
                        
                        	RX Unknown events
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_path_change_event
                        
                        	RX Path Change event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_path_create_event
                        
                        	RX Path Create event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_path_delete_event
                        
                        	RX Path Delete event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_path_error_event
                        
                        	RX Path Error event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_path_reeval_query_event
                        
                        	RX Path Reeval Query event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_resv_change_event
                        
                        	RX Resv Change event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_resv_create_event
                        
                        	RX Resv Create event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_resv_delete_event
                        
                        	RX Resv Delete event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_resv_error_event
                        
                        	RX Resv Error event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_backup_assign_event
                        
                        	Backup Assign event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_event_unknown
                        
                        	Unknown TX events
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_path_change_event
                        
                        	TX Path Change event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_path_create_event
                        
                        	TX Path Create event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_path_delete_event
                        
                        	TX Path Delete event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_path_error_event
                        
                        	TX Path Error event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_path_reeval_query_event
                        
                        	TX Path Reeval Query event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_resv_change_event
                        
                        	TX Resv Change event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_resv_create_event
                        
                        	TX Resv Create event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_resv_delete_event
                        
                        	TX Resv Delete event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_resv_error_event
                        
                        	TX Resv Error event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic.Statistics, self).__init__()

                            self.yang_name = "statistics"
                            self.yang_parent_name = "destination-statistic"

                            self.events_count = YLeaf(YType.uint32, "events-count")

                            self.events_total_count = YLeaf(YType.uint32, "events-total-count")

                            self.rx_backup_assign_err_event = YLeaf(YType.uint32, "rx-backup-assign-err-event")

                            self.rx_event_unknown = YLeaf(YType.uint32, "rx-event-unknown")

                            self.rx_path_change_event = YLeaf(YType.uint32, "rx-path-change-event")

                            self.rx_path_create_event = YLeaf(YType.uint32, "rx-path-create-event")

                            self.rx_path_delete_event = YLeaf(YType.uint32, "rx-path-delete-event")

                            self.rx_path_error_event = YLeaf(YType.uint32, "rx-path-error-event")

                            self.rx_path_reeval_query_event = YLeaf(YType.uint32, "rx-path-reeval-query-event")

                            self.rx_resv_change_event = YLeaf(YType.uint32, "rx-resv-change-event")

                            self.rx_resv_create_event = YLeaf(YType.uint32, "rx-resv-create-event")

                            self.rx_resv_delete_event = YLeaf(YType.uint32, "rx-resv-delete-event")

                            self.rx_resv_error_event = YLeaf(YType.uint32, "rx-resv-error-event")

                            self.tx_backup_assign_event = YLeaf(YType.uint32, "tx-backup-assign-event")

                            self.tx_event_unknown = YLeaf(YType.uint32, "tx-event-unknown")

                            self.tx_path_change_event = YLeaf(YType.uint32, "tx-path-change-event")

                            self.tx_path_create_event = YLeaf(YType.uint32, "tx-path-create-event")

                            self.tx_path_delete_event = YLeaf(YType.uint32, "tx-path-delete-event")

                            self.tx_path_error_event = YLeaf(YType.uint32, "tx-path-error-event")

                            self.tx_path_reeval_query_event = YLeaf(YType.uint32, "tx-path-reeval-query-event")

                            self.tx_resv_change_event = YLeaf(YType.uint32, "tx-resv-change-event")

                            self.tx_resv_create_event = YLeaf(YType.uint32, "tx-resv-create-event")

                            self.tx_resv_delete_event = YLeaf(YType.uint32, "tx-resv-delete-event")

                            self.tx_resv_error_event = YLeaf(YType.uint32, "tx-resv-error-event")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("events_count",
                                            "events_total_count",
                                            "rx_backup_assign_err_event",
                                            "rx_event_unknown",
                                            "rx_path_change_event",
                                            "rx_path_create_event",
                                            "rx_path_delete_event",
                                            "rx_path_error_event",
                                            "rx_path_reeval_query_event",
                                            "rx_resv_change_event",
                                            "rx_resv_create_event",
                                            "rx_resv_delete_event",
                                            "rx_resv_error_event",
                                            "tx_backup_assign_event",
                                            "tx_event_unknown",
                                            "tx_path_change_event",
                                            "tx_path_create_event",
                                            "tx_path_delete_event",
                                            "tx_path_error_event",
                                            "tx_path_reeval_query_event",
                                            "tx_resv_change_event",
                                            "tx_resv_create_event",
                                            "tx_resv_delete_event",
                                            "tx_resv_error_event") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic.Statistics, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic.Statistics, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.events_count.is_set or
                                self.events_total_count.is_set or
                                self.rx_backup_assign_err_event.is_set or
                                self.rx_event_unknown.is_set or
                                self.rx_path_change_event.is_set or
                                self.rx_path_create_event.is_set or
                                self.rx_path_delete_event.is_set or
                                self.rx_path_error_event.is_set or
                                self.rx_path_reeval_query_event.is_set or
                                self.rx_resv_change_event.is_set or
                                self.rx_resv_create_event.is_set or
                                self.rx_resv_delete_event.is_set or
                                self.rx_resv_error_event.is_set or
                                self.tx_backup_assign_event.is_set or
                                self.tx_event_unknown.is_set or
                                self.tx_path_change_event.is_set or
                                self.tx_path_create_event.is_set or
                                self.tx_path_delete_event.is_set or
                                self.tx_path_error_event.is_set or
                                self.tx_path_reeval_query_event.is_set or
                                self.tx_resv_change_event.is_set or
                                self.tx_resv_create_event.is_set or
                                self.tx_resv_delete_event.is_set or
                                self.tx_resv_error_event.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.events_count.yfilter != YFilter.not_set or
                                self.events_total_count.yfilter != YFilter.not_set or
                                self.rx_backup_assign_err_event.yfilter != YFilter.not_set or
                                self.rx_event_unknown.yfilter != YFilter.not_set or
                                self.rx_path_change_event.yfilter != YFilter.not_set or
                                self.rx_path_create_event.yfilter != YFilter.not_set or
                                self.rx_path_delete_event.yfilter != YFilter.not_set or
                                self.rx_path_error_event.yfilter != YFilter.not_set or
                                self.rx_path_reeval_query_event.yfilter != YFilter.not_set or
                                self.rx_resv_change_event.yfilter != YFilter.not_set or
                                self.rx_resv_create_event.yfilter != YFilter.not_set or
                                self.rx_resv_delete_event.yfilter != YFilter.not_set or
                                self.rx_resv_error_event.yfilter != YFilter.not_set or
                                self.tx_backup_assign_event.yfilter != YFilter.not_set or
                                self.tx_event_unknown.yfilter != YFilter.not_set or
                                self.tx_path_change_event.yfilter != YFilter.not_set or
                                self.tx_path_create_event.yfilter != YFilter.not_set or
                                self.tx_path_delete_event.yfilter != YFilter.not_set or
                                self.tx_path_error_event.yfilter != YFilter.not_set or
                                self.tx_path_reeval_query_event.yfilter != YFilter.not_set or
                                self.tx_resv_change_event.yfilter != YFilter.not_set or
                                self.tx_resv_create_event.yfilter != YFilter.not_set or
                                self.tx_resv_delete_event.yfilter != YFilter.not_set or
                                self.tx_resv_error_event.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "statistics" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.events_count.is_set or self.events_count.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.events_count.get_name_leafdata())
                            if (self.events_total_count.is_set or self.events_total_count.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.events_total_count.get_name_leafdata())
                            if (self.rx_backup_assign_err_event.is_set or self.rx_backup_assign_err_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_backup_assign_err_event.get_name_leafdata())
                            if (self.rx_event_unknown.is_set or self.rx_event_unknown.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_event_unknown.get_name_leafdata())
                            if (self.rx_path_change_event.is_set or self.rx_path_change_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_path_change_event.get_name_leafdata())
                            if (self.rx_path_create_event.is_set or self.rx_path_create_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_path_create_event.get_name_leafdata())
                            if (self.rx_path_delete_event.is_set or self.rx_path_delete_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_path_delete_event.get_name_leafdata())
                            if (self.rx_path_error_event.is_set or self.rx_path_error_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_path_error_event.get_name_leafdata())
                            if (self.rx_path_reeval_query_event.is_set or self.rx_path_reeval_query_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_path_reeval_query_event.get_name_leafdata())
                            if (self.rx_resv_change_event.is_set or self.rx_resv_change_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_resv_change_event.get_name_leafdata())
                            if (self.rx_resv_create_event.is_set or self.rx_resv_create_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_resv_create_event.get_name_leafdata())
                            if (self.rx_resv_delete_event.is_set or self.rx_resv_delete_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_resv_delete_event.get_name_leafdata())
                            if (self.rx_resv_error_event.is_set or self.rx_resv_error_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_resv_error_event.get_name_leafdata())
                            if (self.tx_backup_assign_event.is_set or self.tx_backup_assign_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_backup_assign_event.get_name_leafdata())
                            if (self.tx_event_unknown.is_set or self.tx_event_unknown.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_event_unknown.get_name_leafdata())
                            if (self.tx_path_change_event.is_set or self.tx_path_change_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_path_change_event.get_name_leafdata())
                            if (self.tx_path_create_event.is_set or self.tx_path_create_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_path_create_event.get_name_leafdata())
                            if (self.tx_path_delete_event.is_set or self.tx_path_delete_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_path_delete_event.get_name_leafdata())
                            if (self.tx_path_error_event.is_set or self.tx_path_error_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_path_error_event.get_name_leafdata())
                            if (self.tx_path_reeval_query_event.is_set or self.tx_path_reeval_query_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_path_reeval_query_event.get_name_leafdata())
                            if (self.tx_resv_change_event.is_set or self.tx_resv_change_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_resv_change_event.get_name_leafdata())
                            if (self.tx_resv_create_event.is_set or self.tx_resv_create_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_resv_create_event.get_name_leafdata())
                            if (self.tx_resv_delete_event.is_set or self.tx_resv_delete_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_resv_delete_event.get_name_leafdata())
                            if (self.tx_resv_error_event.is_set or self.tx_resv_error_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_resv_error_event.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "events-count" or name == "events-total-count" or name == "rx-backup-assign-err-event" or name == "rx-event-unknown" or name == "rx-path-change-event" or name == "rx-path-create-event" or name == "rx-path-delete-event" or name == "rx-path-error-event" or name == "rx-path-reeval-query-event" or name == "rx-resv-change-event" or name == "rx-resv-create-event" or name == "rx-resv-delete-event" or name == "rx-resv-error-event" or name == "tx-backup-assign-event" or name == "tx-event-unknown" or name == "tx-path-change-event" or name == "tx-path-create-event" or name == "tx-path-delete-event" or name == "tx-path-error-event" or name == "tx-path-reeval-query-event" or name == "tx-resv-change-event" or name == "tx-resv-create-event" or name == "tx-resv-delete-event" or name == "tx-resv-error-event"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "events-count"):
                                self.events_count = value
                                self.events_count.value_namespace = name_space
                                self.events_count.value_namespace_prefix = name_space_prefix
                            if(value_path == "events-total-count"):
                                self.events_total_count = value
                                self.events_total_count.value_namespace = name_space
                                self.events_total_count.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-backup-assign-err-event"):
                                self.rx_backup_assign_err_event = value
                                self.rx_backup_assign_err_event.value_namespace = name_space
                                self.rx_backup_assign_err_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-event-unknown"):
                                self.rx_event_unknown = value
                                self.rx_event_unknown.value_namespace = name_space
                                self.rx_event_unknown.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-path-change-event"):
                                self.rx_path_change_event = value
                                self.rx_path_change_event.value_namespace = name_space
                                self.rx_path_change_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-path-create-event"):
                                self.rx_path_create_event = value
                                self.rx_path_create_event.value_namespace = name_space
                                self.rx_path_create_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-path-delete-event"):
                                self.rx_path_delete_event = value
                                self.rx_path_delete_event.value_namespace = name_space
                                self.rx_path_delete_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-path-error-event"):
                                self.rx_path_error_event = value
                                self.rx_path_error_event.value_namespace = name_space
                                self.rx_path_error_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-path-reeval-query-event"):
                                self.rx_path_reeval_query_event = value
                                self.rx_path_reeval_query_event.value_namespace = name_space
                                self.rx_path_reeval_query_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-resv-change-event"):
                                self.rx_resv_change_event = value
                                self.rx_resv_change_event.value_namespace = name_space
                                self.rx_resv_change_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-resv-create-event"):
                                self.rx_resv_create_event = value
                                self.rx_resv_create_event.value_namespace = name_space
                                self.rx_resv_create_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-resv-delete-event"):
                                self.rx_resv_delete_event = value
                                self.rx_resv_delete_event.value_namespace = name_space
                                self.rx_resv_delete_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-resv-error-event"):
                                self.rx_resv_error_event = value
                                self.rx_resv_error_event.value_namespace = name_space
                                self.rx_resv_error_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-backup-assign-event"):
                                self.tx_backup_assign_event = value
                                self.tx_backup_assign_event.value_namespace = name_space
                                self.tx_backup_assign_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-event-unknown"):
                                self.tx_event_unknown = value
                                self.tx_event_unknown.value_namespace = name_space
                                self.tx_event_unknown.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-path-change-event"):
                                self.tx_path_change_event = value
                                self.tx_path_change_event.value_namespace = name_space
                                self.tx_path_change_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-path-create-event"):
                                self.tx_path_create_event = value
                                self.tx_path_create_event.value_namespace = name_space
                                self.tx_path_create_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-path-delete-event"):
                                self.tx_path_delete_event = value
                                self.tx_path_delete_event.value_namespace = name_space
                                self.tx_path_delete_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-path-error-event"):
                                self.tx_path_error_event = value
                                self.tx_path_error_event.value_namespace = name_space
                                self.tx_path_error_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-path-reeval-query-event"):
                                self.tx_path_reeval_query_event = value
                                self.tx_path_reeval_query_event.value_namespace = name_space
                                self.tx_path_reeval_query_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-resv-change-event"):
                                self.tx_resv_change_event = value
                                self.tx_resv_change_event.value_namespace = name_space
                                self.tx_resv_change_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-resv-create-event"):
                                self.tx_resv_create_event = value
                                self.tx_resv_create_event.value_namespace = name_space
                                self.tx_resv_create_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-resv-delete-event"):
                                self.tx_resv_delete_event = value
                                self.tx_resv_delete_event.value_namespace = name_space
                                self.tx_resv_delete_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-resv-error-event"):
                                self.tx_resv_error_event = value
                                self.tx_resv_error_event.value_namespace = name_space
                                self.tx_resv_error_event.value_namespace_prefix = name_space_prefix


                    class S2LStatistic(Entity):
                        """
                        List of S2L Stats
                        
                        .. attribute:: destination_address
                        
                        	Destination address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: statistics
                        
                        	S2L stats
                        	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic.S2LStatistic.Statistics>`
                        
                        .. attribute:: sub_group_id
                        
                        	subgroup ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: sub_group_originator
                        
                        	Subgroup Originator
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic.S2LStatistic, self).__init__()

                            self.yang_name = "s2l-statistic"
                            self.yang_parent_name = "destination-statistic"

                            self.destination_address = YLeaf(YType.str, "destination-address")

                            self.sub_group_id = YLeaf(YType.uint16, "sub-group-id")

                            self.sub_group_originator = YLeaf(YType.str, "sub-group-originator")

                            self.statistics = MplsTeStandby.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic.S2LStatistic.Statistics()
                            self.statistics.parent = self
                            self._children_name_map["statistics"] = "statistics"
                            self._children_yang_names.add("statistics")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("destination_address",
                                            "sub_group_id",
                                            "sub_group_originator") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic.S2LStatistic, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic.S2LStatistic, self).__setattr__(name, value)


                        class Statistics(Entity):
                            """
                            S2L stats
                            
                            .. attribute:: events_count
                            
                            	TE Signaling event count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: events_total_count
                            
                            	Total TE Signalling event count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_backup_assign_err_event
                            
                            	Error on Backup Assign event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_event_unknown
                            
                            	RX Unknown events
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_path_change_event
                            
                            	RX Path Change event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_path_create_event
                            
                            	RX Path Create event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_path_delete_event
                            
                            	RX Path Delete event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_path_error_event
                            
                            	RX Path Error event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_path_reeval_query_event
                            
                            	RX Path Reeval Query event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_resv_change_event
                            
                            	RX Resv Change event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_resv_create_event
                            
                            	RX Resv Create event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_resv_delete_event
                            
                            	RX Resv Delete event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_resv_error_event
                            
                            	RX Resv Error event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_backup_assign_event
                            
                            	Backup Assign event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_event_unknown
                            
                            	Unknown TX events
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_path_change_event
                            
                            	TX Path Change event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_path_create_event
                            
                            	TX Path Create event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_path_delete_event
                            
                            	TX Path Delete event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_path_error_event
                            
                            	TX Path Error event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_path_reeval_query_event
                            
                            	TX Path Reeval Query event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_resv_change_event
                            
                            	TX Resv Change event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_resv_create_event
                            
                            	TX Resv Create event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_resv_delete_event
                            
                            	TX Resv Delete event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_resv_error_event
                            
                            	TX Resv Error event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic.S2LStatistic.Statistics, self).__init__()

                                self.yang_name = "statistics"
                                self.yang_parent_name = "s2l-statistic"

                                self.events_count = YLeaf(YType.uint32, "events-count")

                                self.events_total_count = YLeaf(YType.uint32, "events-total-count")

                                self.rx_backup_assign_err_event = YLeaf(YType.uint32, "rx-backup-assign-err-event")

                                self.rx_event_unknown = YLeaf(YType.uint32, "rx-event-unknown")

                                self.rx_path_change_event = YLeaf(YType.uint32, "rx-path-change-event")

                                self.rx_path_create_event = YLeaf(YType.uint32, "rx-path-create-event")

                                self.rx_path_delete_event = YLeaf(YType.uint32, "rx-path-delete-event")

                                self.rx_path_error_event = YLeaf(YType.uint32, "rx-path-error-event")

                                self.rx_path_reeval_query_event = YLeaf(YType.uint32, "rx-path-reeval-query-event")

                                self.rx_resv_change_event = YLeaf(YType.uint32, "rx-resv-change-event")

                                self.rx_resv_create_event = YLeaf(YType.uint32, "rx-resv-create-event")

                                self.rx_resv_delete_event = YLeaf(YType.uint32, "rx-resv-delete-event")

                                self.rx_resv_error_event = YLeaf(YType.uint32, "rx-resv-error-event")

                                self.tx_backup_assign_event = YLeaf(YType.uint32, "tx-backup-assign-event")

                                self.tx_event_unknown = YLeaf(YType.uint32, "tx-event-unknown")

                                self.tx_path_change_event = YLeaf(YType.uint32, "tx-path-change-event")

                                self.tx_path_create_event = YLeaf(YType.uint32, "tx-path-create-event")

                                self.tx_path_delete_event = YLeaf(YType.uint32, "tx-path-delete-event")

                                self.tx_path_error_event = YLeaf(YType.uint32, "tx-path-error-event")

                                self.tx_path_reeval_query_event = YLeaf(YType.uint32, "tx-path-reeval-query-event")

                                self.tx_resv_change_event = YLeaf(YType.uint32, "tx-resv-change-event")

                                self.tx_resv_create_event = YLeaf(YType.uint32, "tx-resv-create-event")

                                self.tx_resv_delete_event = YLeaf(YType.uint32, "tx-resv-delete-event")

                                self.tx_resv_error_event = YLeaf(YType.uint32, "tx-resv-error-event")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("events_count",
                                                "events_total_count",
                                                "rx_backup_assign_err_event",
                                                "rx_event_unknown",
                                                "rx_path_change_event",
                                                "rx_path_create_event",
                                                "rx_path_delete_event",
                                                "rx_path_error_event",
                                                "rx_path_reeval_query_event",
                                                "rx_resv_change_event",
                                                "rx_resv_create_event",
                                                "rx_resv_delete_event",
                                                "rx_resv_error_event",
                                                "tx_backup_assign_event",
                                                "tx_event_unknown",
                                                "tx_path_change_event",
                                                "tx_path_create_event",
                                                "tx_path_delete_event",
                                                "tx_path_error_event",
                                                "tx_path_reeval_query_event",
                                                "tx_resv_change_event",
                                                "tx_resv_create_event",
                                                "tx_resv_delete_event",
                                                "tx_resv_error_event") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic.S2LStatistic.Statistics, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic.S2LStatistic.Statistics, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.events_count.is_set or
                                    self.events_total_count.is_set or
                                    self.rx_backup_assign_err_event.is_set or
                                    self.rx_event_unknown.is_set or
                                    self.rx_path_change_event.is_set or
                                    self.rx_path_create_event.is_set or
                                    self.rx_path_delete_event.is_set or
                                    self.rx_path_error_event.is_set or
                                    self.rx_path_reeval_query_event.is_set or
                                    self.rx_resv_change_event.is_set or
                                    self.rx_resv_create_event.is_set or
                                    self.rx_resv_delete_event.is_set or
                                    self.rx_resv_error_event.is_set or
                                    self.tx_backup_assign_event.is_set or
                                    self.tx_event_unknown.is_set or
                                    self.tx_path_change_event.is_set or
                                    self.tx_path_create_event.is_set or
                                    self.tx_path_delete_event.is_set or
                                    self.tx_path_error_event.is_set or
                                    self.tx_path_reeval_query_event.is_set or
                                    self.tx_resv_change_event.is_set or
                                    self.tx_resv_create_event.is_set or
                                    self.tx_resv_delete_event.is_set or
                                    self.tx_resv_error_event.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.events_count.yfilter != YFilter.not_set or
                                    self.events_total_count.yfilter != YFilter.not_set or
                                    self.rx_backup_assign_err_event.yfilter != YFilter.not_set or
                                    self.rx_event_unknown.yfilter != YFilter.not_set or
                                    self.rx_path_change_event.yfilter != YFilter.not_set or
                                    self.rx_path_create_event.yfilter != YFilter.not_set or
                                    self.rx_path_delete_event.yfilter != YFilter.not_set or
                                    self.rx_path_error_event.yfilter != YFilter.not_set or
                                    self.rx_path_reeval_query_event.yfilter != YFilter.not_set or
                                    self.rx_resv_change_event.yfilter != YFilter.not_set or
                                    self.rx_resv_create_event.yfilter != YFilter.not_set or
                                    self.rx_resv_delete_event.yfilter != YFilter.not_set or
                                    self.rx_resv_error_event.yfilter != YFilter.not_set or
                                    self.tx_backup_assign_event.yfilter != YFilter.not_set or
                                    self.tx_event_unknown.yfilter != YFilter.not_set or
                                    self.tx_path_change_event.yfilter != YFilter.not_set or
                                    self.tx_path_create_event.yfilter != YFilter.not_set or
                                    self.tx_path_delete_event.yfilter != YFilter.not_set or
                                    self.tx_path_error_event.yfilter != YFilter.not_set or
                                    self.tx_path_reeval_query_event.yfilter != YFilter.not_set or
                                    self.tx_resv_change_event.yfilter != YFilter.not_set or
                                    self.tx_resv_create_event.yfilter != YFilter.not_set or
                                    self.tx_resv_delete_event.yfilter != YFilter.not_set or
                                    self.tx_resv_error_event.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "statistics" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.events_count.is_set or self.events_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.events_count.get_name_leafdata())
                                if (self.events_total_count.is_set or self.events_total_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.events_total_count.get_name_leafdata())
                                if (self.rx_backup_assign_err_event.is_set or self.rx_backup_assign_err_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_backup_assign_err_event.get_name_leafdata())
                                if (self.rx_event_unknown.is_set or self.rx_event_unknown.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_event_unknown.get_name_leafdata())
                                if (self.rx_path_change_event.is_set or self.rx_path_change_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_path_change_event.get_name_leafdata())
                                if (self.rx_path_create_event.is_set or self.rx_path_create_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_path_create_event.get_name_leafdata())
                                if (self.rx_path_delete_event.is_set or self.rx_path_delete_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_path_delete_event.get_name_leafdata())
                                if (self.rx_path_error_event.is_set or self.rx_path_error_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_path_error_event.get_name_leafdata())
                                if (self.rx_path_reeval_query_event.is_set or self.rx_path_reeval_query_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_path_reeval_query_event.get_name_leafdata())
                                if (self.rx_resv_change_event.is_set or self.rx_resv_change_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_resv_change_event.get_name_leafdata())
                                if (self.rx_resv_create_event.is_set or self.rx_resv_create_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_resv_create_event.get_name_leafdata())
                                if (self.rx_resv_delete_event.is_set or self.rx_resv_delete_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_resv_delete_event.get_name_leafdata())
                                if (self.rx_resv_error_event.is_set or self.rx_resv_error_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_resv_error_event.get_name_leafdata())
                                if (self.tx_backup_assign_event.is_set or self.tx_backup_assign_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_backup_assign_event.get_name_leafdata())
                                if (self.tx_event_unknown.is_set or self.tx_event_unknown.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_event_unknown.get_name_leafdata())
                                if (self.tx_path_change_event.is_set or self.tx_path_change_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_path_change_event.get_name_leafdata())
                                if (self.tx_path_create_event.is_set or self.tx_path_create_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_path_create_event.get_name_leafdata())
                                if (self.tx_path_delete_event.is_set or self.tx_path_delete_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_path_delete_event.get_name_leafdata())
                                if (self.tx_path_error_event.is_set or self.tx_path_error_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_path_error_event.get_name_leafdata())
                                if (self.tx_path_reeval_query_event.is_set or self.tx_path_reeval_query_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_path_reeval_query_event.get_name_leafdata())
                                if (self.tx_resv_change_event.is_set or self.tx_resv_change_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_resv_change_event.get_name_leafdata())
                                if (self.tx_resv_create_event.is_set or self.tx_resv_create_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_resv_create_event.get_name_leafdata())
                                if (self.tx_resv_delete_event.is_set or self.tx_resv_delete_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_resv_delete_event.get_name_leafdata())
                                if (self.tx_resv_error_event.is_set or self.tx_resv_error_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_resv_error_event.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "events-count" or name == "events-total-count" or name == "rx-backup-assign-err-event" or name == "rx-event-unknown" or name == "rx-path-change-event" or name == "rx-path-create-event" or name == "rx-path-delete-event" or name == "rx-path-error-event" or name == "rx-path-reeval-query-event" or name == "rx-resv-change-event" or name == "rx-resv-create-event" or name == "rx-resv-delete-event" or name == "rx-resv-error-event" or name == "tx-backup-assign-event" or name == "tx-event-unknown" or name == "tx-path-change-event" or name == "tx-path-create-event" or name == "tx-path-delete-event" or name == "tx-path-error-event" or name == "tx-path-reeval-query-event" or name == "tx-resv-change-event" or name == "tx-resv-create-event" or name == "tx-resv-delete-event" or name == "tx-resv-error-event"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "events-count"):
                                    self.events_count = value
                                    self.events_count.value_namespace = name_space
                                    self.events_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "events-total-count"):
                                    self.events_total_count = value
                                    self.events_total_count.value_namespace = name_space
                                    self.events_total_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-backup-assign-err-event"):
                                    self.rx_backup_assign_err_event = value
                                    self.rx_backup_assign_err_event.value_namespace = name_space
                                    self.rx_backup_assign_err_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-event-unknown"):
                                    self.rx_event_unknown = value
                                    self.rx_event_unknown.value_namespace = name_space
                                    self.rx_event_unknown.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-path-change-event"):
                                    self.rx_path_change_event = value
                                    self.rx_path_change_event.value_namespace = name_space
                                    self.rx_path_change_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-path-create-event"):
                                    self.rx_path_create_event = value
                                    self.rx_path_create_event.value_namespace = name_space
                                    self.rx_path_create_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-path-delete-event"):
                                    self.rx_path_delete_event = value
                                    self.rx_path_delete_event.value_namespace = name_space
                                    self.rx_path_delete_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-path-error-event"):
                                    self.rx_path_error_event = value
                                    self.rx_path_error_event.value_namespace = name_space
                                    self.rx_path_error_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-path-reeval-query-event"):
                                    self.rx_path_reeval_query_event = value
                                    self.rx_path_reeval_query_event.value_namespace = name_space
                                    self.rx_path_reeval_query_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-resv-change-event"):
                                    self.rx_resv_change_event = value
                                    self.rx_resv_change_event.value_namespace = name_space
                                    self.rx_resv_change_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-resv-create-event"):
                                    self.rx_resv_create_event = value
                                    self.rx_resv_create_event.value_namespace = name_space
                                    self.rx_resv_create_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-resv-delete-event"):
                                    self.rx_resv_delete_event = value
                                    self.rx_resv_delete_event.value_namespace = name_space
                                    self.rx_resv_delete_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-resv-error-event"):
                                    self.rx_resv_error_event = value
                                    self.rx_resv_error_event.value_namespace = name_space
                                    self.rx_resv_error_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-backup-assign-event"):
                                    self.tx_backup_assign_event = value
                                    self.tx_backup_assign_event.value_namespace = name_space
                                    self.tx_backup_assign_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-event-unknown"):
                                    self.tx_event_unknown = value
                                    self.tx_event_unknown.value_namespace = name_space
                                    self.tx_event_unknown.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-path-change-event"):
                                    self.tx_path_change_event = value
                                    self.tx_path_change_event.value_namespace = name_space
                                    self.tx_path_change_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-path-create-event"):
                                    self.tx_path_create_event = value
                                    self.tx_path_create_event.value_namespace = name_space
                                    self.tx_path_create_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-path-delete-event"):
                                    self.tx_path_delete_event = value
                                    self.tx_path_delete_event.value_namespace = name_space
                                    self.tx_path_delete_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-path-error-event"):
                                    self.tx_path_error_event = value
                                    self.tx_path_error_event.value_namespace = name_space
                                    self.tx_path_error_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-path-reeval-query-event"):
                                    self.tx_path_reeval_query_event = value
                                    self.tx_path_reeval_query_event.value_namespace = name_space
                                    self.tx_path_reeval_query_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-resv-change-event"):
                                    self.tx_resv_change_event = value
                                    self.tx_resv_change_event.value_namespace = name_space
                                    self.tx_resv_change_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-resv-create-event"):
                                    self.tx_resv_create_event = value
                                    self.tx_resv_create_event.value_namespace = name_space
                                    self.tx_resv_create_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-resv-delete-event"):
                                    self.tx_resv_delete_event = value
                                    self.tx_resv_delete_event.value_namespace = name_space
                                    self.tx_resv_delete_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-resv-error-event"):
                                    self.tx_resv_error_event = value
                                    self.tx_resv_error_event.value_namespace = name_space
                                    self.tx_resv_error_event.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.destination_address.is_set or
                                self.sub_group_id.is_set or
                                self.sub_group_originator.is_set or
                                (self.statistics is not None and self.statistics.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.destination_address.yfilter != YFilter.not_set or
                                self.sub_group_id.yfilter != YFilter.not_set or
                                self.sub_group_originator.yfilter != YFilter.not_set or
                                (self.statistics is not None and self.statistics.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "s2l-statistic" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.destination_address.get_name_leafdata())
                            if (self.sub_group_id.is_set or self.sub_group_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.sub_group_id.get_name_leafdata())
                            if (self.sub_group_originator.is_set or self.sub_group_originator.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.sub_group_originator.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "statistics"):
                                if (self.statistics is None):
                                    self.statistics = MplsTeStandby.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic.S2LStatistic.Statistics()
                                    self.statistics.parent = self
                                    self._children_name_map["statistics"] = "statistics"
                                return self.statistics

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "statistics" or name == "destination-address" or name == "sub-group-id" or name == "sub-group-originator"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "destination-address"):
                                self.destination_address = value
                                self.destination_address.value_namespace = name_space
                                self.destination_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "sub-group-id"):
                                self.sub_group_id = value
                                self.sub_group_id.value_namespace = name_space
                                self.sub_group_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "sub-group-originator"):
                                self.sub_group_originator = value
                                self.sub_group_originator.value_namespace = name_space
                                self.sub_group_originator.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.s2l_statistic:
                            if (c.has_data()):
                                return True
                        return (
                            self.destination_address.is_set or
                            (self.statistics is not None and self.statistics.has_data()))

                    def has_operation(self):
                        for c in self.s2l_statistic:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.destination_address.yfilter != YFilter.not_set or
                            (self.statistics is not None and self.statistics.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "destination-statistic" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.destination_address.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "s2l-statistic"):
                            for c in self.s2l_statistic:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic.S2LStatistic()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.s2l_statistic.append(c)
                            return c

                        if (child_yang_name == "statistics"):
                            if (self.statistics is None):
                                self.statistics = MplsTeStandby.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic.Statistics()
                                self.statistics.parent = self
                                self._children_name_map["statistics"] = "statistics"
                            return self.statistics

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "s2l-statistic" or name == "statistics" or name == "destination-address"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "destination-address"):
                            self.destination_address = value
                            self.destination_address.value_namespace = name_space
                            self.destination_address.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.destination_statistic:
                        if (c.has_data()):
                            return True
                    return (
                        self.ctype.is_set or
                        self.tunnel_id.is_set or
                        self.lsp_id.is_set or
                        self.tunnel_name.is_set or
                        self.tunnel_sig_name.is_set or
                        (self.statistics is not None and self.statistics.has_data()))

                def has_operation(self):
                    for c in self.destination_statistic:
                        if (c.has_operation()):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        self.ctype.yfilter != YFilter.not_set or
                        self.tunnel_id.yfilter != YFilter.not_set or
                        self.lsp_id.yfilter != YFilter.not_set or
                        self.tunnel_name.yfilter != YFilter.not_set or
                        self.tunnel_sig_name.yfilter != YFilter.not_set or
                        (self.statistics is not None and self.statistics.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "head-signalling-counter" + "[ctype='" + self.ctype.get() + "']" + "[tunnel-id='" + self.tunnel_id.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/signalling-counters/head-signalling-counters/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.ctype.is_set or self.ctype.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.ctype.get_name_leafdata())
                    if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_id.get_name_leafdata())
                    if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.lsp_id.get_name_leafdata())
                    if (self.tunnel_name.is_set or self.tunnel_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_name.get_name_leafdata())
                    if (self.tunnel_sig_name.is_set or self.tunnel_sig_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_sig_name.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "destination-statistic"):
                        for c in self.destination_statistic:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsTeStandby.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.DestinationStatistic()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.destination_statistic.append(c)
                        return c

                    if (child_yang_name == "statistics"):
                        if (self.statistics is None):
                            self.statistics = MplsTeStandby.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter.Statistics()
                            self.statistics.parent = self
                            self._children_name_map["statistics"] = "statistics"
                        return self.statistics

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "destination-statistic" or name == "statistics" or name == "ctype" or name == "tunnel-id" or name == "lsp-id" or name == "tunnel-name" or name == "tunnel-sig-name"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "ctype"):
                        self.ctype = value
                        self.ctype.value_namespace = name_space
                        self.ctype.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-id"):
                        self.tunnel_id = value
                        self.tunnel_id.value_namespace = name_space
                        self.tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "lsp-id"):
                        self.lsp_id = value
                        self.lsp_id.value_namespace = name_space
                        self.lsp_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-name"):
                        self.tunnel_name = value
                        self.tunnel_name.value_namespace = name_space
                        self.tunnel_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-sig-name"):
                        self.tunnel_sig_name = value
                        self.tunnel_sig_name.value_namespace = name_space
                        self.tunnel_sig_name.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.head_signalling_counter:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.head_signalling_counter:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "head-signalling-counters" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/signalling-counters/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "head-signalling-counter"):
                    for c in self.head_signalling_counter:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTeStandby.SignallingCounters.HeadSignallingCounters.HeadSignallingCounter()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.head_signalling_counter.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "head-signalling-counter"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass


        class RemoteSignallingCounters(Entity):
            """
            Sig mid tail Table TE counters
            
            .. attribute:: remote_signalling_counter
            
            	TE stats
            	**type**\: list of    :py:class:`RemoteSignallingCounter <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTeStandby.SignallingCounters.RemoteSignallingCounters, self).__init__()

                self.yang_name = "remote-signalling-counters"
                self.yang_parent_name = "signalling-counters"

                self.remote_signalling_counter = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTeStandby.SignallingCounters.RemoteSignallingCounters, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTeStandby.SignallingCounters.RemoteSignallingCounters, self).__setattr__(name, value)


            class RemoteSignallingCounter(Entity):
                """
                TE stats
                
                .. attribute:: ctype  <key>
                
                	Ctype
                	**type**\:   :py:class:`Ctype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.Ctype>`
                
                .. attribute:: tunnel_id  <key>
                
                	Tunnel ID
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: extended_tunnel_id  <key>
                
                	Extended Tunnel ID
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: p2mp_id  <key>
                
                	P2MP ID
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: lsp_id  <key>
                
                	LSP ID
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: source_address  <key>
                
                	Source Address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: destination_address  <key>
                
                	Destination Address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: sub_group_originator  <key>
                
                	Subgroup originator
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: sub_group_id  <key>
                
                	Subgroup ID
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: s2l_statistic
                
                	List of S2L Statistics
                	**type**\: list of    :py:class:`S2LStatistic <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter.S2LStatistic>`
                
                .. attribute:: statistics
                
                	LSP statistics
                	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter.Statistics>`
                
                .. attribute:: tunnel_name
                
                	Tunnel Name
                	**type**\:  str
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTeStandby.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter, self).__init__()

                    self.yang_name = "remote-signalling-counter"
                    self.yang_parent_name = "remote-signalling-counters"

                    self.ctype = YLeaf(YType.enumeration, "ctype")

                    self.tunnel_id = YLeaf(YType.int32, "tunnel-id")

                    self.extended_tunnel_id = YLeaf(YType.str, "extended-tunnel-id")

                    self.p2mp_id = YLeaf(YType.int32, "p2mp-id")

                    self.lsp_id = YLeaf(YType.int32, "lsp-id")

                    self.source_address = YLeaf(YType.str, "source-address")

                    self.destination_address = YLeaf(YType.str, "destination-address")

                    self.sub_group_originator = YLeaf(YType.str, "sub-group-originator")

                    self.sub_group_id = YLeaf(YType.int32, "sub-group-id")

                    self.tunnel_name = YLeaf(YType.str, "tunnel-name")

                    self.statistics = MplsTeStandby.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter.Statistics()
                    self.statistics.parent = self
                    self._children_name_map["statistics"] = "statistics"
                    self._children_yang_names.add("statistics")

                    self.s2l_statistic = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("ctype",
                                    "tunnel_id",
                                    "extended_tunnel_id",
                                    "p2mp_id",
                                    "lsp_id",
                                    "source_address",
                                    "destination_address",
                                    "sub_group_originator",
                                    "sub_group_id",
                                    "tunnel_name") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTeStandby.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTeStandby.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter, self).__setattr__(name, value)


                class Statistics(Entity):
                    """
                    LSP statistics
                    
                    .. attribute:: events_count
                    
                    	TE Signaling event count
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: events_total_count
                    
                    	Total TE Signalling event count
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_backup_assign_err_event
                    
                    	Error on Backup Assign event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_event_unknown
                    
                    	RX Unknown events
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_path_change_event
                    
                    	RX Path Change event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_path_create_event
                    
                    	RX Path Create event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_path_delete_event
                    
                    	RX Path Delete event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_path_error_event
                    
                    	RX Path Error event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_path_reeval_query_event
                    
                    	RX Path Reeval Query event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_resv_change_event
                    
                    	RX Resv Change event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_resv_create_event
                    
                    	RX Resv Create event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_resv_delete_event
                    
                    	RX Resv Delete event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_resv_error_event
                    
                    	RX Resv Error event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_backup_assign_event
                    
                    	Backup Assign event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_event_unknown
                    
                    	Unknown TX events
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_path_change_event
                    
                    	TX Path Change event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_path_create_event
                    
                    	TX Path Create event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_path_delete_event
                    
                    	TX Path Delete event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_path_error_event
                    
                    	TX Path Error event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_path_reeval_query_event
                    
                    	TX Path Reeval Query event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_resv_change_event
                    
                    	TX Resv Change event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_resv_create_event
                    
                    	TX Resv Create event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_resv_delete_event
                    
                    	TX Resv Delete event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_resv_error_event
                    
                    	TX Resv Error event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter.Statistics, self).__init__()

                        self.yang_name = "statistics"
                        self.yang_parent_name = "remote-signalling-counter"

                        self.events_count = YLeaf(YType.uint32, "events-count")

                        self.events_total_count = YLeaf(YType.uint32, "events-total-count")

                        self.rx_backup_assign_err_event = YLeaf(YType.uint32, "rx-backup-assign-err-event")

                        self.rx_event_unknown = YLeaf(YType.uint32, "rx-event-unknown")

                        self.rx_path_change_event = YLeaf(YType.uint32, "rx-path-change-event")

                        self.rx_path_create_event = YLeaf(YType.uint32, "rx-path-create-event")

                        self.rx_path_delete_event = YLeaf(YType.uint32, "rx-path-delete-event")

                        self.rx_path_error_event = YLeaf(YType.uint32, "rx-path-error-event")

                        self.rx_path_reeval_query_event = YLeaf(YType.uint32, "rx-path-reeval-query-event")

                        self.rx_resv_change_event = YLeaf(YType.uint32, "rx-resv-change-event")

                        self.rx_resv_create_event = YLeaf(YType.uint32, "rx-resv-create-event")

                        self.rx_resv_delete_event = YLeaf(YType.uint32, "rx-resv-delete-event")

                        self.rx_resv_error_event = YLeaf(YType.uint32, "rx-resv-error-event")

                        self.tx_backup_assign_event = YLeaf(YType.uint32, "tx-backup-assign-event")

                        self.tx_event_unknown = YLeaf(YType.uint32, "tx-event-unknown")

                        self.tx_path_change_event = YLeaf(YType.uint32, "tx-path-change-event")

                        self.tx_path_create_event = YLeaf(YType.uint32, "tx-path-create-event")

                        self.tx_path_delete_event = YLeaf(YType.uint32, "tx-path-delete-event")

                        self.tx_path_error_event = YLeaf(YType.uint32, "tx-path-error-event")

                        self.tx_path_reeval_query_event = YLeaf(YType.uint32, "tx-path-reeval-query-event")

                        self.tx_resv_change_event = YLeaf(YType.uint32, "tx-resv-change-event")

                        self.tx_resv_create_event = YLeaf(YType.uint32, "tx-resv-create-event")

                        self.tx_resv_delete_event = YLeaf(YType.uint32, "tx-resv-delete-event")

                        self.tx_resv_error_event = YLeaf(YType.uint32, "tx-resv-error-event")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("events_count",
                                        "events_total_count",
                                        "rx_backup_assign_err_event",
                                        "rx_event_unknown",
                                        "rx_path_change_event",
                                        "rx_path_create_event",
                                        "rx_path_delete_event",
                                        "rx_path_error_event",
                                        "rx_path_reeval_query_event",
                                        "rx_resv_change_event",
                                        "rx_resv_create_event",
                                        "rx_resv_delete_event",
                                        "rx_resv_error_event",
                                        "tx_backup_assign_event",
                                        "tx_event_unknown",
                                        "tx_path_change_event",
                                        "tx_path_create_event",
                                        "tx_path_delete_event",
                                        "tx_path_error_event",
                                        "tx_path_reeval_query_event",
                                        "tx_resv_change_event",
                                        "tx_resv_create_event",
                                        "tx_resv_delete_event",
                                        "tx_resv_error_event") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter.Statistics, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter.Statistics, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.events_count.is_set or
                            self.events_total_count.is_set or
                            self.rx_backup_assign_err_event.is_set or
                            self.rx_event_unknown.is_set or
                            self.rx_path_change_event.is_set or
                            self.rx_path_create_event.is_set or
                            self.rx_path_delete_event.is_set or
                            self.rx_path_error_event.is_set or
                            self.rx_path_reeval_query_event.is_set or
                            self.rx_resv_change_event.is_set or
                            self.rx_resv_create_event.is_set or
                            self.rx_resv_delete_event.is_set or
                            self.rx_resv_error_event.is_set or
                            self.tx_backup_assign_event.is_set or
                            self.tx_event_unknown.is_set or
                            self.tx_path_change_event.is_set or
                            self.tx_path_create_event.is_set or
                            self.tx_path_delete_event.is_set or
                            self.tx_path_error_event.is_set or
                            self.tx_path_reeval_query_event.is_set or
                            self.tx_resv_change_event.is_set or
                            self.tx_resv_create_event.is_set or
                            self.tx_resv_delete_event.is_set or
                            self.tx_resv_error_event.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.events_count.yfilter != YFilter.not_set or
                            self.events_total_count.yfilter != YFilter.not_set or
                            self.rx_backup_assign_err_event.yfilter != YFilter.not_set or
                            self.rx_event_unknown.yfilter != YFilter.not_set or
                            self.rx_path_change_event.yfilter != YFilter.not_set or
                            self.rx_path_create_event.yfilter != YFilter.not_set or
                            self.rx_path_delete_event.yfilter != YFilter.not_set or
                            self.rx_path_error_event.yfilter != YFilter.not_set or
                            self.rx_path_reeval_query_event.yfilter != YFilter.not_set or
                            self.rx_resv_change_event.yfilter != YFilter.not_set or
                            self.rx_resv_create_event.yfilter != YFilter.not_set or
                            self.rx_resv_delete_event.yfilter != YFilter.not_set or
                            self.rx_resv_error_event.yfilter != YFilter.not_set or
                            self.tx_backup_assign_event.yfilter != YFilter.not_set or
                            self.tx_event_unknown.yfilter != YFilter.not_set or
                            self.tx_path_change_event.yfilter != YFilter.not_set or
                            self.tx_path_create_event.yfilter != YFilter.not_set or
                            self.tx_path_delete_event.yfilter != YFilter.not_set or
                            self.tx_path_error_event.yfilter != YFilter.not_set or
                            self.tx_path_reeval_query_event.yfilter != YFilter.not_set or
                            self.tx_resv_change_event.yfilter != YFilter.not_set or
                            self.tx_resv_create_event.yfilter != YFilter.not_set or
                            self.tx_resv_delete_event.yfilter != YFilter.not_set or
                            self.tx_resv_error_event.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "statistics" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.events_count.is_set or self.events_count.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.events_count.get_name_leafdata())
                        if (self.events_total_count.is_set or self.events_total_count.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.events_total_count.get_name_leafdata())
                        if (self.rx_backup_assign_err_event.is_set or self.rx_backup_assign_err_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_backup_assign_err_event.get_name_leafdata())
                        if (self.rx_event_unknown.is_set or self.rx_event_unknown.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_event_unknown.get_name_leafdata())
                        if (self.rx_path_change_event.is_set or self.rx_path_change_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_path_change_event.get_name_leafdata())
                        if (self.rx_path_create_event.is_set or self.rx_path_create_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_path_create_event.get_name_leafdata())
                        if (self.rx_path_delete_event.is_set or self.rx_path_delete_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_path_delete_event.get_name_leafdata())
                        if (self.rx_path_error_event.is_set or self.rx_path_error_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_path_error_event.get_name_leafdata())
                        if (self.rx_path_reeval_query_event.is_set or self.rx_path_reeval_query_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_path_reeval_query_event.get_name_leafdata())
                        if (self.rx_resv_change_event.is_set or self.rx_resv_change_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_resv_change_event.get_name_leafdata())
                        if (self.rx_resv_create_event.is_set or self.rx_resv_create_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_resv_create_event.get_name_leafdata())
                        if (self.rx_resv_delete_event.is_set or self.rx_resv_delete_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_resv_delete_event.get_name_leafdata())
                        if (self.rx_resv_error_event.is_set or self.rx_resv_error_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_resv_error_event.get_name_leafdata())
                        if (self.tx_backup_assign_event.is_set or self.tx_backup_assign_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_backup_assign_event.get_name_leafdata())
                        if (self.tx_event_unknown.is_set or self.tx_event_unknown.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_event_unknown.get_name_leafdata())
                        if (self.tx_path_change_event.is_set or self.tx_path_change_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_path_change_event.get_name_leafdata())
                        if (self.tx_path_create_event.is_set or self.tx_path_create_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_path_create_event.get_name_leafdata())
                        if (self.tx_path_delete_event.is_set or self.tx_path_delete_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_path_delete_event.get_name_leafdata())
                        if (self.tx_path_error_event.is_set or self.tx_path_error_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_path_error_event.get_name_leafdata())
                        if (self.tx_path_reeval_query_event.is_set or self.tx_path_reeval_query_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_path_reeval_query_event.get_name_leafdata())
                        if (self.tx_resv_change_event.is_set or self.tx_resv_change_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_resv_change_event.get_name_leafdata())
                        if (self.tx_resv_create_event.is_set or self.tx_resv_create_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_resv_create_event.get_name_leafdata())
                        if (self.tx_resv_delete_event.is_set or self.tx_resv_delete_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_resv_delete_event.get_name_leafdata())
                        if (self.tx_resv_error_event.is_set or self.tx_resv_error_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_resv_error_event.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "events-count" or name == "events-total-count" or name == "rx-backup-assign-err-event" or name == "rx-event-unknown" or name == "rx-path-change-event" or name == "rx-path-create-event" or name == "rx-path-delete-event" or name == "rx-path-error-event" or name == "rx-path-reeval-query-event" or name == "rx-resv-change-event" or name == "rx-resv-create-event" or name == "rx-resv-delete-event" or name == "rx-resv-error-event" or name == "tx-backup-assign-event" or name == "tx-event-unknown" or name == "tx-path-change-event" or name == "tx-path-create-event" or name == "tx-path-delete-event" or name == "tx-path-error-event" or name == "tx-path-reeval-query-event" or name == "tx-resv-change-event" or name == "tx-resv-create-event" or name == "tx-resv-delete-event" or name == "tx-resv-error-event"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "events-count"):
                            self.events_count = value
                            self.events_count.value_namespace = name_space
                            self.events_count.value_namespace_prefix = name_space_prefix
                        if(value_path == "events-total-count"):
                            self.events_total_count = value
                            self.events_total_count.value_namespace = name_space
                            self.events_total_count.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-backup-assign-err-event"):
                            self.rx_backup_assign_err_event = value
                            self.rx_backup_assign_err_event.value_namespace = name_space
                            self.rx_backup_assign_err_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-event-unknown"):
                            self.rx_event_unknown = value
                            self.rx_event_unknown.value_namespace = name_space
                            self.rx_event_unknown.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-path-change-event"):
                            self.rx_path_change_event = value
                            self.rx_path_change_event.value_namespace = name_space
                            self.rx_path_change_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-path-create-event"):
                            self.rx_path_create_event = value
                            self.rx_path_create_event.value_namespace = name_space
                            self.rx_path_create_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-path-delete-event"):
                            self.rx_path_delete_event = value
                            self.rx_path_delete_event.value_namespace = name_space
                            self.rx_path_delete_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-path-error-event"):
                            self.rx_path_error_event = value
                            self.rx_path_error_event.value_namespace = name_space
                            self.rx_path_error_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-path-reeval-query-event"):
                            self.rx_path_reeval_query_event = value
                            self.rx_path_reeval_query_event.value_namespace = name_space
                            self.rx_path_reeval_query_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-resv-change-event"):
                            self.rx_resv_change_event = value
                            self.rx_resv_change_event.value_namespace = name_space
                            self.rx_resv_change_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-resv-create-event"):
                            self.rx_resv_create_event = value
                            self.rx_resv_create_event.value_namespace = name_space
                            self.rx_resv_create_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-resv-delete-event"):
                            self.rx_resv_delete_event = value
                            self.rx_resv_delete_event.value_namespace = name_space
                            self.rx_resv_delete_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-resv-error-event"):
                            self.rx_resv_error_event = value
                            self.rx_resv_error_event.value_namespace = name_space
                            self.rx_resv_error_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-backup-assign-event"):
                            self.tx_backup_assign_event = value
                            self.tx_backup_assign_event.value_namespace = name_space
                            self.tx_backup_assign_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-event-unknown"):
                            self.tx_event_unknown = value
                            self.tx_event_unknown.value_namespace = name_space
                            self.tx_event_unknown.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-path-change-event"):
                            self.tx_path_change_event = value
                            self.tx_path_change_event.value_namespace = name_space
                            self.tx_path_change_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-path-create-event"):
                            self.tx_path_create_event = value
                            self.tx_path_create_event.value_namespace = name_space
                            self.tx_path_create_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-path-delete-event"):
                            self.tx_path_delete_event = value
                            self.tx_path_delete_event.value_namespace = name_space
                            self.tx_path_delete_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-path-error-event"):
                            self.tx_path_error_event = value
                            self.tx_path_error_event.value_namespace = name_space
                            self.tx_path_error_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-path-reeval-query-event"):
                            self.tx_path_reeval_query_event = value
                            self.tx_path_reeval_query_event.value_namespace = name_space
                            self.tx_path_reeval_query_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-resv-change-event"):
                            self.tx_resv_change_event = value
                            self.tx_resv_change_event.value_namespace = name_space
                            self.tx_resv_change_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-resv-create-event"):
                            self.tx_resv_create_event = value
                            self.tx_resv_create_event.value_namespace = name_space
                            self.tx_resv_create_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-resv-delete-event"):
                            self.tx_resv_delete_event = value
                            self.tx_resv_delete_event.value_namespace = name_space
                            self.tx_resv_delete_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-resv-error-event"):
                            self.tx_resv_error_event = value
                            self.tx_resv_error_event.value_namespace = name_space
                            self.tx_resv_error_event.value_namespace_prefix = name_space_prefix


                class S2LStatistic(Entity):
                    """
                    List of S2L Statistics
                    
                    .. attribute:: destination_address
                    
                    	Destination address
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: statistics
                    
                    	S2L stats
                    	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter.S2LStatistic.Statistics>`
                    
                    .. attribute:: sub_group_id
                    
                    	subgroup ID
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: sub_group_originator
                    
                    	Subgroup Originator
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter.S2LStatistic, self).__init__()

                        self.yang_name = "s2l-statistic"
                        self.yang_parent_name = "remote-signalling-counter"

                        self.destination_address = YLeaf(YType.str, "destination-address")

                        self.sub_group_id = YLeaf(YType.uint16, "sub-group-id")

                        self.sub_group_originator = YLeaf(YType.str, "sub-group-originator")

                        self.statistics = MplsTeStandby.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter.S2LStatistic.Statistics()
                        self.statistics.parent = self
                        self._children_name_map["statistics"] = "statistics"
                        self._children_yang_names.add("statistics")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("destination_address",
                                        "sub_group_id",
                                        "sub_group_originator") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter.S2LStatistic, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter.S2LStatistic, self).__setattr__(name, value)


                    class Statistics(Entity):
                        """
                        S2L stats
                        
                        .. attribute:: events_count
                        
                        	TE Signaling event count
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: events_total_count
                        
                        	Total TE Signalling event count
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_backup_assign_err_event
                        
                        	Error on Backup Assign event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_event_unknown
                        
                        	RX Unknown events
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_path_change_event
                        
                        	RX Path Change event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_path_create_event
                        
                        	RX Path Create event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_path_delete_event
                        
                        	RX Path Delete event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_path_error_event
                        
                        	RX Path Error event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_path_reeval_query_event
                        
                        	RX Path Reeval Query event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_resv_change_event
                        
                        	RX Resv Change event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_resv_create_event
                        
                        	RX Resv Create event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_resv_delete_event
                        
                        	RX Resv Delete event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_resv_error_event
                        
                        	RX Resv Error event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_backup_assign_event
                        
                        	Backup Assign event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_event_unknown
                        
                        	Unknown TX events
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_path_change_event
                        
                        	TX Path Change event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_path_create_event
                        
                        	TX Path Create event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_path_delete_event
                        
                        	TX Path Delete event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_path_error_event
                        
                        	TX Path Error event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_path_reeval_query_event
                        
                        	TX Path Reeval Query event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_resv_change_event
                        
                        	TX Resv Change event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_resv_create_event
                        
                        	TX Resv Create event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_resv_delete_event
                        
                        	TX Resv Delete event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_resv_error_event
                        
                        	TX Resv Error event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter.S2LStatistic.Statistics, self).__init__()

                            self.yang_name = "statistics"
                            self.yang_parent_name = "s2l-statistic"

                            self.events_count = YLeaf(YType.uint32, "events-count")

                            self.events_total_count = YLeaf(YType.uint32, "events-total-count")

                            self.rx_backup_assign_err_event = YLeaf(YType.uint32, "rx-backup-assign-err-event")

                            self.rx_event_unknown = YLeaf(YType.uint32, "rx-event-unknown")

                            self.rx_path_change_event = YLeaf(YType.uint32, "rx-path-change-event")

                            self.rx_path_create_event = YLeaf(YType.uint32, "rx-path-create-event")

                            self.rx_path_delete_event = YLeaf(YType.uint32, "rx-path-delete-event")

                            self.rx_path_error_event = YLeaf(YType.uint32, "rx-path-error-event")

                            self.rx_path_reeval_query_event = YLeaf(YType.uint32, "rx-path-reeval-query-event")

                            self.rx_resv_change_event = YLeaf(YType.uint32, "rx-resv-change-event")

                            self.rx_resv_create_event = YLeaf(YType.uint32, "rx-resv-create-event")

                            self.rx_resv_delete_event = YLeaf(YType.uint32, "rx-resv-delete-event")

                            self.rx_resv_error_event = YLeaf(YType.uint32, "rx-resv-error-event")

                            self.tx_backup_assign_event = YLeaf(YType.uint32, "tx-backup-assign-event")

                            self.tx_event_unknown = YLeaf(YType.uint32, "tx-event-unknown")

                            self.tx_path_change_event = YLeaf(YType.uint32, "tx-path-change-event")

                            self.tx_path_create_event = YLeaf(YType.uint32, "tx-path-create-event")

                            self.tx_path_delete_event = YLeaf(YType.uint32, "tx-path-delete-event")

                            self.tx_path_error_event = YLeaf(YType.uint32, "tx-path-error-event")

                            self.tx_path_reeval_query_event = YLeaf(YType.uint32, "tx-path-reeval-query-event")

                            self.tx_resv_change_event = YLeaf(YType.uint32, "tx-resv-change-event")

                            self.tx_resv_create_event = YLeaf(YType.uint32, "tx-resv-create-event")

                            self.tx_resv_delete_event = YLeaf(YType.uint32, "tx-resv-delete-event")

                            self.tx_resv_error_event = YLeaf(YType.uint32, "tx-resv-error-event")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("events_count",
                                            "events_total_count",
                                            "rx_backup_assign_err_event",
                                            "rx_event_unknown",
                                            "rx_path_change_event",
                                            "rx_path_create_event",
                                            "rx_path_delete_event",
                                            "rx_path_error_event",
                                            "rx_path_reeval_query_event",
                                            "rx_resv_change_event",
                                            "rx_resv_create_event",
                                            "rx_resv_delete_event",
                                            "rx_resv_error_event",
                                            "tx_backup_assign_event",
                                            "tx_event_unknown",
                                            "tx_path_change_event",
                                            "tx_path_create_event",
                                            "tx_path_delete_event",
                                            "tx_path_error_event",
                                            "tx_path_reeval_query_event",
                                            "tx_resv_change_event",
                                            "tx_resv_create_event",
                                            "tx_resv_delete_event",
                                            "tx_resv_error_event") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter.S2LStatistic.Statistics, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter.S2LStatistic.Statistics, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.events_count.is_set or
                                self.events_total_count.is_set or
                                self.rx_backup_assign_err_event.is_set or
                                self.rx_event_unknown.is_set or
                                self.rx_path_change_event.is_set or
                                self.rx_path_create_event.is_set or
                                self.rx_path_delete_event.is_set or
                                self.rx_path_error_event.is_set or
                                self.rx_path_reeval_query_event.is_set or
                                self.rx_resv_change_event.is_set or
                                self.rx_resv_create_event.is_set or
                                self.rx_resv_delete_event.is_set or
                                self.rx_resv_error_event.is_set or
                                self.tx_backup_assign_event.is_set or
                                self.tx_event_unknown.is_set or
                                self.tx_path_change_event.is_set or
                                self.tx_path_create_event.is_set or
                                self.tx_path_delete_event.is_set or
                                self.tx_path_error_event.is_set or
                                self.tx_path_reeval_query_event.is_set or
                                self.tx_resv_change_event.is_set or
                                self.tx_resv_create_event.is_set or
                                self.tx_resv_delete_event.is_set or
                                self.tx_resv_error_event.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.events_count.yfilter != YFilter.not_set or
                                self.events_total_count.yfilter != YFilter.not_set or
                                self.rx_backup_assign_err_event.yfilter != YFilter.not_set or
                                self.rx_event_unknown.yfilter != YFilter.not_set or
                                self.rx_path_change_event.yfilter != YFilter.not_set or
                                self.rx_path_create_event.yfilter != YFilter.not_set or
                                self.rx_path_delete_event.yfilter != YFilter.not_set or
                                self.rx_path_error_event.yfilter != YFilter.not_set or
                                self.rx_path_reeval_query_event.yfilter != YFilter.not_set or
                                self.rx_resv_change_event.yfilter != YFilter.not_set or
                                self.rx_resv_create_event.yfilter != YFilter.not_set or
                                self.rx_resv_delete_event.yfilter != YFilter.not_set or
                                self.rx_resv_error_event.yfilter != YFilter.not_set or
                                self.tx_backup_assign_event.yfilter != YFilter.not_set or
                                self.tx_event_unknown.yfilter != YFilter.not_set or
                                self.tx_path_change_event.yfilter != YFilter.not_set or
                                self.tx_path_create_event.yfilter != YFilter.not_set or
                                self.tx_path_delete_event.yfilter != YFilter.not_set or
                                self.tx_path_error_event.yfilter != YFilter.not_set or
                                self.tx_path_reeval_query_event.yfilter != YFilter.not_set or
                                self.tx_resv_change_event.yfilter != YFilter.not_set or
                                self.tx_resv_create_event.yfilter != YFilter.not_set or
                                self.tx_resv_delete_event.yfilter != YFilter.not_set or
                                self.tx_resv_error_event.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "statistics" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.events_count.is_set or self.events_count.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.events_count.get_name_leafdata())
                            if (self.events_total_count.is_set or self.events_total_count.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.events_total_count.get_name_leafdata())
                            if (self.rx_backup_assign_err_event.is_set or self.rx_backup_assign_err_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_backup_assign_err_event.get_name_leafdata())
                            if (self.rx_event_unknown.is_set or self.rx_event_unknown.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_event_unknown.get_name_leafdata())
                            if (self.rx_path_change_event.is_set or self.rx_path_change_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_path_change_event.get_name_leafdata())
                            if (self.rx_path_create_event.is_set or self.rx_path_create_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_path_create_event.get_name_leafdata())
                            if (self.rx_path_delete_event.is_set or self.rx_path_delete_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_path_delete_event.get_name_leafdata())
                            if (self.rx_path_error_event.is_set or self.rx_path_error_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_path_error_event.get_name_leafdata())
                            if (self.rx_path_reeval_query_event.is_set or self.rx_path_reeval_query_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_path_reeval_query_event.get_name_leafdata())
                            if (self.rx_resv_change_event.is_set or self.rx_resv_change_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_resv_change_event.get_name_leafdata())
                            if (self.rx_resv_create_event.is_set or self.rx_resv_create_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_resv_create_event.get_name_leafdata())
                            if (self.rx_resv_delete_event.is_set or self.rx_resv_delete_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_resv_delete_event.get_name_leafdata())
                            if (self.rx_resv_error_event.is_set or self.rx_resv_error_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_resv_error_event.get_name_leafdata())
                            if (self.tx_backup_assign_event.is_set or self.tx_backup_assign_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_backup_assign_event.get_name_leafdata())
                            if (self.tx_event_unknown.is_set or self.tx_event_unknown.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_event_unknown.get_name_leafdata())
                            if (self.tx_path_change_event.is_set or self.tx_path_change_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_path_change_event.get_name_leafdata())
                            if (self.tx_path_create_event.is_set or self.tx_path_create_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_path_create_event.get_name_leafdata())
                            if (self.tx_path_delete_event.is_set or self.tx_path_delete_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_path_delete_event.get_name_leafdata())
                            if (self.tx_path_error_event.is_set or self.tx_path_error_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_path_error_event.get_name_leafdata())
                            if (self.tx_path_reeval_query_event.is_set or self.tx_path_reeval_query_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_path_reeval_query_event.get_name_leafdata())
                            if (self.tx_resv_change_event.is_set or self.tx_resv_change_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_resv_change_event.get_name_leafdata())
                            if (self.tx_resv_create_event.is_set or self.tx_resv_create_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_resv_create_event.get_name_leafdata())
                            if (self.tx_resv_delete_event.is_set or self.tx_resv_delete_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_resv_delete_event.get_name_leafdata())
                            if (self.tx_resv_error_event.is_set or self.tx_resv_error_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_resv_error_event.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "events-count" or name == "events-total-count" or name == "rx-backup-assign-err-event" or name == "rx-event-unknown" or name == "rx-path-change-event" or name == "rx-path-create-event" or name == "rx-path-delete-event" or name == "rx-path-error-event" or name == "rx-path-reeval-query-event" or name == "rx-resv-change-event" or name == "rx-resv-create-event" or name == "rx-resv-delete-event" or name == "rx-resv-error-event" or name == "tx-backup-assign-event" or name == "tx-event-unknown" or name == "tx-path-change-event" or name == "tx-path-create-event" or name == "tx-path-delete-event" or name == "tx-path-error-event" or name == "tx-path-reeval-query-event" or name == "tx-resv-change-event" or name == "tx-resv-create-event" or name == "tx-resv-delete-event" or name == "tx-resv-error-event"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "events-count"):
                                self.events_count = value
                                self.events_count.value_namespace = name_space
                                self.events_count.value_namespace_prefix = name_space_prefix
                            if(value_path == "events-total-count"):
                                self.events_total_count = value
                                self.events_total_count.value_namespace = name_space
                                self.events_total_count.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-backup-assign-err-event"):
                                self.rx_backup_assign_err_event = value
                                self.rx_backup_assign_err_event.value_namespace = name_space
                                self.rx_backup_assign_err_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-event-unknown"):
                                self.rx_event_unknown = value
                                self.rx_event_unknown.value_namespace = name_space
                                self.rx_event_unknown.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-path-change-event"):
                                self.rx_path_change_event = value
                                self.rx_path_change_event.value_namespace = name_space
                                self.rx_path_change_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-path-create-event"):
                                self.rx_path_create_event = value
                                self.rx_path_create_event.value_namespace = name_space
                                self.rx_path_create_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-path-delete-event"):
                                self.rx_path_delete_event = value
                                self.rx_path_delete_event.value_namespace = name_space
                                self.rx_path_delete_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-path-error-event"):
                                self.rx_path_error_event = value
                                self.rx_path_error_event.value_namespace = name_space
                                self.rx_path_error_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-path-reeval-query-event"):
                                self.rx_path_reeval_query_event = value
                                self.rx_path_reeval_query_event.value_namespace = name_space
                                self.rx_path_reeval_query_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-resv-change-event"):
                                self.rx_resv_change_event = value
                                self.rx_resv_change_event.value_namespace = name_space
                                self.rx_resv_change_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-resv-create-event"):
                                self.rx_resv_create_event = value
                                self.rx_resv_create_event.value_namespace = name_space
                                self.rx_resv_create_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-resv-delete-event"):
                                self.rx_resv_delete_event = value
                                self.rx_resv_delete_event.value_namespace = name_space
                                self.rx_resv_delete_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-resv-error-event"):
                                self.rx_resv_error_event = value
                                self.rx_resv_error_event.value_namespace = name_space
                                self.rx_resv_error_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-backup-assign-event"):
                                self.tx_backup_assign_event = value
                                self.tx_backup_assign_event.value_namespace = name_space
                                self.tx_backup_assign_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-event-unknown"):
                                self.tx_event_unknown = value
                                self.tx_event_unknown.value_namespace = name_space
                                self.tx_event_unknown.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-path-change-event"):
                                self.tx_path_change_event = value
                                self.tx_path_change_event.value_namespace = name_space
                                self.tx_path_change_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-path-create-event"):
                                self.tx_path_create_event = value
                                self.tx_path_create_event.value_namespace = name_space
                                self.tx_path_create_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-path-delete-event"):
                                self.tx_path_delete_event = value
                                self.tx_path_delete_event.value_namespace = name_space
                                self.tx_path_delete_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-path-error-event"):
                                self.tx_path_error_event = value
                                self.tx_path_error_event.value_namespace = name_space
                                self.tx_path_error_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-path-reeval-query-event"):
                                self.tx_path_reeval_query_event = value
                                self.tx_path_reeval_query_event.value_namespace = name_space
                                self.tx_path_reeval_query_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-resv-change-event"):
                                self.tx_resv_change_event = value
                                self.tx_resv_change_event.value_namespace = name_space
                                self.tx_resv_change_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-resv-create-event"):
                                self.tx_resv_create_event = value
                                self.tx_resv_create_event.value_namespace = name_space
                                self.tx_resv_create_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-resv-delete-event"):
                                self.tx_resv_delete_event = value
                                self.tx_resv_delete_event.value_namespace = name_space
                                self.tx_resv_delete_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-resv-error-event"):
                                self.tx_resv_error_event = value
                                self.tx_resv_error_event.value_namespace = name_space
                                self.tx_resv_error_event.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.destination_address.is_set or
                            self.sub_group_id.is_set or
                            self.sub_group_originator.is_set or
                            (self.statistics is not None and self.statistics.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.destination_address.yfilter != YFilter.not_set or
                            self.sub_group_id.yfilter != YFilter.not_set or
                            self.sub_group_originator.yfilter != YFilter.not_set or
                            (self.statistics is not None and self.statistics.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "s2l-statistic" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.destination_address.get_name_leafdata())
                        if (self.sub_group_id.is_set or self.sub_group_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.sub_group_id.get_name_leafdata())
                        if (self.sub_group_originator.is_set or self.sub_group_originator.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.sub_group_originator.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "statistics"):
                            if (self.statistics is None):
                                self.statistics = MplsTeStandby.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter.S2LStatistic.Statistics()
                                self.statistics.parent = self
                                self._children_name_map["statistics"] = "statistics"
                            return self.statistics

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "statistics" or name == "destination-address" or name == "sub-group-id" or name == "sub-group-originator"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "destination-address"):
                            self.destination_address = value
                            self.destination_address.value_namespace = name_space
                            self.destination_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "sub-group-id"):
                            self.sub_group_id = value
                            self.sub_group_id.value_namespace = name_space
                            self.sub_group_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "sub-group-originator"):
                            self.sub_group_originator = value
                            self.sub_group_originator.value_namespace = name_space
                            self.sub_group_originator.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.s2l_statistic:
                        if (c.has_data()):
                            return True
                    return (
                        self.ctype.is_set or
                        self.tunnel_id.is_set or
                        self.extended_tunnel_id.is_set or
                        self.p2mp_id.is_set or
                        self.lsp_id.is_set or
                        self.source_address.is_set or
                        self.destination_address.is_set or
                        self.sub_group_originator.is_set or
                        self.sub_group_id.is_set or
                        self.tunnel_name.is_set or
                        (self.statistics is not None and self.statistics.has_data()))

                def has_operation(self):
                    for c in self.s2l_statistic:
                        if (c.has_operation()):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        self.ctype.yfilter != YFilter.not_set or
                        self.tunnel_id.yfilter != YFilter.not_set or
                        self.extended_tunnel_id.yfilter != YFilter.not_set or
                        self.p2mp_id.yfilter != YFilter.not_set or
                        self.lsp_id.yfilter != YFilter.not_set or
                        self.source_address.yfilter != YFilter.not_set or
                        self.destination_address.yfilter != YFilter.not_set or
                        self.sub_group_originator.yfilter != YFilter.not_set or
                        self.sub_group_id.yfilter != YFilter.not_set or
                        self.tunnel_name.yfilter != YFilter.not_set or
                        (self.statistics is not None and self.statistics.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "remote-signalling-counter" + "[ctype='" + self.ctype.get() + "']" + "[tunnel-id='" + self.tunnel_id.get() + "']" + "[extended-tunnel-id='" + self.extended_tunnel_id.get() + "']" + "[p2mp-id='" + self.p2mp_id.get() + "']" + "[lsp-id='" + self.lsp_id.get() + "']" + "[source-address='" + self.source_address.get() + "']" + "[destination-address='" + self.destination_address.get() + "']" + "[sub-group-originator='" + self.sub_group_originator.get() + "']" + "[sub-group-id='" + self.sub_group_id.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/signalling-counters/remote-signalling-counters/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.ctype.is_set or self.ctype.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.ctype.get_name_leafdata())
                    if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_id.get_name_leafdata())
                    if (self.extended_tunnel_id.is_set or self.extended_tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.extended_tunnel_id.get_name_leafdata())
                    if (self.p2mp_id.is_set or self.p2mp_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.p2mp_id.get_name_leafdata())
                    if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.lsp_id.get_name_leafdata())
                    if (self.source_address.is_set or self.source_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.source_address.get_name_leafdata())
                    if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.destination_address.get_name_leafdata())
                    if (self.sub_group_originator.is_set or self.sub_group_originator.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.sub_group_originator.get_name_leafdata())
                    if (self.sub_group_id.is_set or self.sub_group_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.sub_group_id.get_name_leafdata())
                    if (self.tunnel_name.is_set or self.tunnel_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_name.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "s2l-statistic"):
                        for c in self.s2l_statistic:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsTeStandby.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter.S2LStatistic()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.s2l_statistic.append(c)
                        return c

                    if (child_yang_name == "statistics"):
                        if (self.statistics is None):
                            self.statistics = MplsTeStandby.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter.Statistics()
                            self.statistics.parent = self
                            self._children_name_map["statistics"] = "statistics"
                        return self.statistics

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "s2l-statistic" or name == "statistics" or name == "ctype" or name == "tunnel-id" or name == "extended-tunnel-id" or name == "p2mp-id" or name == "lsp-id" or name == "source-address" or name == "destination-address" or name == "sub-group-originator" or name == "sub-group-id" or name == "tunnel-name"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "ctype"):
                        self.ctype = value
                        self.ctype.value_namespace = name_space
                        self.ctype.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-id"):
                        self.tunnel_id = value
                        self.tunnel_id.value_namespace = name_space
                        self.tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "extended-tunnel-id"):
                        self.extended_tunnel_id = value
                        self.extended_tunnel_id.value_namespace = name_space
                        self.extended_tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "p2mp-id"):
                        self.p2mp_id = value
                        self.p2mp_id.value_namespace = name_space
                        self.p2mp_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "lsp-id"):
                        self.lsp_id = value
                        self.lsp_id.value_namespace = name_space
                        self.lsp_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "source-address"):
                        self.source_address = value
                        self.source_address.value_namespace = name_space
                        self.source_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "destination-address"):
                        self.destination_address = value
                        self.destination_address.value_namespace = name_space
                        self.destination_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "sub-group-originator"):
                        self.sub_group_originator = value
                        self.sub_group_originator.value_namespace = name_space
                        self.sub_group_originator.value_namespace_prefix = name_space_prefix
                    if(value_path == "sub-group-id"):
                        self.sub_group_id = value
                        self.sub_group_id.value_namespace = name_space
                        self.sub_group_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-name"):
                        self.tunnel_name = value
                        self.tunnel_name.value_namespace = name_space
                        self.tunnel_name.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.remote_signalling_counter:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.remote_signalling_counter:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "remote-signalling-counters" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/signalling-counters/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "remote-signalling-counter"):
                    for c in self.remote_signalling_counter:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTeStandby.SignallingCounters.RemoteSignallingCounters.RemoteSignallingCounter()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.remote_signalling_counter.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "remote-signalling-counter"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass


        class TailsCounters(Entity):
            """
            MPLS TE counters signalling heads table
            
            .. attribute:: tails_counter
            
            	MPLS TE counters signalling mid
            	**type**\: list of    :py:class:`TailsCounter <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.TailsCounters.TailsCounter>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTeStandby.SignallingCounters.TailsCounters, self).__init__()

                self.yang_name = "tails-counters"
                self.yang_parent_name = "signalling-counters"

                self.tails_counter = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTeStandby.SignallingCounters.TailsCounters, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTeStandby.SignallingCounters.TailsCounters, self).__setattr__(name, value)


            class TailsCounter(Entity):
                """
                MPLS TE counters signalling mid
                
                .. attribute:: source_address  <key>
                
                	Source Address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: destination_address  <key>
                
                	Destination Address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: tunnel_id  <key>
                
                	tunnel id of last obtained tunnel
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: extended_tunnel_id  <key>
                
                	Extended Tunnel ID
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: lsp_id  <key>
                
                	LSP ID
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: s2l_statistic
                
                	List of S2L Statistics
                	**type**\: list of    :py:class:`S2LStatistic <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.TailsCounters.TailsCounter.S2LStatistic>`
                
                .. attribute:: statistics
                
                	LSP statistics
                	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.TailsCounters.TailsCounter.Statistics>`
                
                .. attribute:: tunnel_name
                
                	Tunnel Name
                	**type**\:  str
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTeStandby.SignallingCounters.TailsCounters.TailsCounter, self).__init__()

                    self.yang_name = "tails-counter"
                    self.yang_parent_name = "tails-counters"

                    self.source_address = YLeaf(YType.str, "source-address")

                    self.destination_address = YLeaf(YType.str, "destination-address")

                    self.tunnel_id = YLeaf(YType.int32, "tunnel-id")

                    self.extended_tunnel_id = YLeaf(YType.str, "extended-tunnel-id")

                    self.lsp_id = YLeaf(YType.int32, "lsp-id")

                    self.tunnel_name = YLeaf(YType.str, "tunnel-name")

                    self.statistics = MplsTeStandby.SignallingCounters.TailsCounters.TailsCounter.Statistics()
                    self.statistics.parent = self
                    self._children_name_map["statistics"] = "statistics"
                    self._children_yang_names.add("statistics")

                    self.s2l_statistic = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("source_address",
                                    "destination_address",
                                    "tunnel_id",
                                    "extended_tunnel_id",
                                    "lsp_id",
                                    "tunnel_name") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTeStandby.SignallingCounters.TailsCounters.TailsCounter, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTeStandby.SignallingCounters.TailsCounters.TailsCounter, self).__setattr__(name, value)


                class Statistics(Entity):
                    """
                    LSP statistics
                    
                    .. attribute:: events_count
                    
                    	TE Signaling event count
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: events_total_count
                    
                    	Total TE Signalling event count
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_backup_assign_err_event
                    
                    	Error on Backup Assign event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_event_unknown
                    
                    	RX Unknown events
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_path_change_event
                    
                    	RX Path Change event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_path_create_event
                    
                    	RX Path Create event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_path_delete_event
                    
                    	RX Path Delete event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_path_error_event
                    
                    	RX Path Error event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_path_reeval_query_event
                    
                    	RX Path Reeval Query event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_resv_change_event
                    
                    	RX Resv Change event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_resv_create_event
                    
                    	RX Resv Create event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_resv_delete_event
                    
                    	RX Resv Delete event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rx_resv_error_event
                    
                    	RX Resv Error event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_backup_assign_event
                    
                    	Backup Assign event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_event_unknown
                    
                    	Unknown TX events
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_path_change_event
                    
                    	TX Path Change event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_path_create_event
                    
                    	TX Path Create event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_path_delete_event
                    
                    	TX Path Delete event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_path_error_event
                    
                    	TX Path Error event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_path_reeval_query_event
                    
                    	TX Path Reeval Query event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_resv_change_event
                    
                    	TX Resv Change event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_resv_create_event
                    
                    	TX Resv Create event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_resv_delete_event
                    
                    	TX Resv Delete event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tx_resv_error_event
                    
                    	TX Resv Error event
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.SignallingCounters.TailsCounters.TailsCounter.Statistics, self).__init__()

                        self.yang_name = "statistics"
                        self.yang_parent_name = "tails-counter"

                        self.events_count = YLeaf(YType.uint32, "events-count")

                        self.events_total_count = YLeaf(YType.uint32, "events-total-count")

                        self.rx_backup_assign_err_event = YLeaf(YType.uint32, "rx-backup-assign-err-event")

                        self.rx_event_unknown = YLeaf(YType.uint32, "rx-event-unknown")

                        self.rx_path_change_event = YLeaf(YType.uint32, "rx-path-change-event")

                        self.rx_path_create_event = YLeaf(YType.uint32, "rx-path-create-event")

                        self.rx_path_delete_event = YLeaf(YType.uint32, "rx-path-delete-event")

                        self.rx_path_error_event = YLeaf(YType.uint32, "rx-path-error-event")

                        self.rx_path_reeval_query_event = YLeaf(YType.uint32, "rx-path-reeval-query-event")

                        self.rx_resv_change_event = YLeaf(YType.uint32, "rx-resv-change-event")

                        self.rx_resv_create_event = YLeaf(YType.uint32, "rx-resv-create-event")

                        self.rx_resv_delete_event = YLeaf(YType.uint32, "rx-resv-delete-event")

                        self.rx_resv_error_event = YLeaf(YType.uint32, "rx-resv-error-event")

                        self.tx_backup_assign_event = YLeaf(YType.uint32, "tx-backup-assign-event")

                        self.tx_event_unknown = YLeaf(YType.uint32, "tx-event-unknown")

                        self.tx_path_change_event = YLeaf(YType.uint32, "tx-path-change-event")

                        self.tx_path_create_event = YLeaf(YType.uint32, "tx-path-create-event")

                        self.tx_path_delete_event = YLeaf(YType.uint32, "tx-path-delete-event")

                        self.tx_path_error_event = YLeaf(YType.uint32, "tx-path-error-event")

                        self.tx_path_reeval_query_event = YLeaf(YType.uint32, "tx-path-reeval-query-event")

                        self.tx_resv_change_event = YLeaf(YType.uint32, "tx-resv-change-event")

                        self.tx_resv_create_event = YLeaf(YType.uint32, "tx-resv-create-event")

                        self.tx_resv_delete_event = YLeaf(YType.uint32, "tx-resv-delete-event")

                        self.tx_resv_error_event = YLeaf(YType.uint32, "tx-resv-error-event")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("events_count",
                                        "events_total_count",
                                        "rx_backup_assign_err_event",
                                        "rx_event_unknown",
                                        "rx_path_change_event",
                                        "rx_path_create_event",
                                        "rx_path_delete_event",
                                        "rx_path_error_event",
                                        "rx_path_reeval_query_event",
                                        "rx_resv_change_event",
                                        "rx_resv_create_event",
                                        "rx_resv_delete_event",
                                        "rx_resv_error_event",
                                        "tx_backup_assign_event",
                                        "tx_event_unknown",
                                        "tx_path_change_event",
                                        "tx_path_create_event",
                                        "tx_path_delete_event",
                                        "tx_path_error_event",
                                        "tx_path_reeval_query_event",
                                        "tx_resv_change_event",
                                        "tx_resv_create_event",
                                        "tx_resv_delete_event",
                                        "tx_resv_error_event") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.SignallingCounters.TailsCounters.TailsCounter.Statistics, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.SignallingCounters.TailsCounters.TailsCounter.Statistics, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.events_count.is_set or
                            self.events_total_count.is_set or
                            self.rx_backup_assign_err_event.is_set or
                            self.rx_event_unknown.is_set or
                            self.rx_path_change_event.is_set or
                            self.rx_path_create_event.is_set or
                            self.rx_path_delete_event.is_set or
                            self.rx_path_error_event.is_set or
                            self.rx_path_reeval_query_event.is_set or
                            self.rx_resv_change_event.is_set or
                            self.rx_resv_create_event.is_set or
                            self.rx_resv_delete_event.is_set or
                            self.rx_resv_error_event.is_set or
                            self.tx_backup_assign_event.is_set or
                            self.tx_event_unknown.is_set or
                            self.tx_path_change_event.is_set or
                            self.tx_path_create_event.is_set or
                            self.tx_path_delete_event.is_set or
                            self.tx_path_error_event.is_set or
                            self.tx_path_reeval_query_event.is_set or
                            self.tx_resv_change_event.is_set or
                            self.tx_resv_create_event.is_set or
                            self.tx_resv_delete_event.is_set or
                            self.tx_resv_error_event.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.events_count.yfilter != YFilter.not_set or
                            self.events_total_count.yfilter != YFilter.not_set or
                            self.rx_backup_assign_err_event.yfilter != YFilter.not_set or
                            self.rx_event_unknown.yfilter != YFilter.not_set or
                            self.rx_path_change_event.yfilter != YFilter.not_set or
                            self.rx_path_create_event.yfilter != YFilter.not_set or
                            self.rx_path_delete_event.yfilter != YFilter.not_set or
                            self.rx_path_error_event.yfilter != YFilter.not_set or
                            self.rx_path_reeval_query_event.yfilter != YFilter.not_set or
                            self.rx_resv_change_event.yfilter != YFilter.not_set or
                            self.rx_resv_create_event.yfilter != YFilter.not_set or
                            self.rx_resv_delete_event.yfilter != YFilter.not_set or
                            self.rx_resv_error_event.yfilter != YFilter.not_set or
                            self.tx_backup_assign_event.yfilter != YFilter.not_set or
                            self.tx_event_unknown.yfilter != YFilter.not_set or
                            self.tx_path_change_event.yfilter != YFilter.not_set or
                            self.tx_path_create_event.yfilter != YFilter.not_set or
                            self.tx_path_delete_event.yfilter != YFilter.not_set or
                            self.tx_path_error_event.yfilter != YFilter.not_set or
                            self.tx_path_reeval_query_event.yfilter != YFilter.not_set or
                            self.tx_resv_change_event.yfilter != YFilter.not_set or
                            self.tx_resv_create_event.yfilter != YFilter.not_set or
                            self.tx_resv_delete_event.yfilter != YFilter.not_set or
                            self.tx_resv_error_event.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "statistics" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.events_count.is_set or self.events_count.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.events_count.get_name_leafdata())
                        if (self.events_total_count.is_set or self.events_total_count.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.events_total_count.get_name_leafdata())
                        if (self.rx_backup_assign_err_event.is_set or self.rx_backup_assign_err_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_backup_assign_err_event.get_name_leafdata())
                        if (self.rx_event_unknown.is_set or self.rx_event_unknown.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_event_unknown.get_name_leafdata())
                        if (self.rx_path_change_event.is_set or self.rx_path_change_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_path_change_event.get_name_leafdata())
                        if (self.rx_path_create_event.is_set or self.rx_path_create_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_path_create_event.get_name_leafdata())
                        if (self.rx_path_delete_event.is_set or self.rx_path_delete_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_path_delete_event.get_name_leafdata())
                        if (self.rx_path_error_event.is_set or self.rx_path_error_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_path_error_event.get_name_leafdata())
                        if (self.rx_path_reeval_query_event.is_set or self.rx_path_reeval_query_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_path_reeval_query_event.get_name_leafdata())
                        if (self.rx_resv_change_event.is_set or self.rx_resv_change_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_resv_change_event.get_name_leafdata())
                        if (self.rx_resv_create_event.is_set or self.rx_resv_create_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_resv_create_event.get_name_leafdata())
                        if (self.rx_resv_delete_event.is_set or self.rx_resv_delete_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_resv_delete_event.get_name_leafdata())
                        if (self.rx_resv_error_event.is_set or self.rx_resv_error_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rx_resv_error_event.get_name_leafdata())
                        if (self.tx_backup_assign_event.is_set or self.tx_backup_assign_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_backup_assign_event.get_name_leafdata())
                        if (self.tx_event_unknown.is_set or self.tx_event_unknown.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_event_unknown.get_name_leafdata())
                        if (self.tx_path_change_event.is_set or self.tx_path_change_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_path_change_event.get_name_leafdata())
                        if (self.tx_path_create_event.is_set or self.tx_path_create_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_path_create_event.get_name_leafdata())
                        if (self.tx_path_delete_event.is_set or self.tx_path_delete_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_path_delete_event.get_name_leafdata())
                        if (self.tx_path_error_event.is_set or self.tx_path_error_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_path_error_event.get_name_leafdata())
                        if (self.tx_path_reeval_query_event.is_set or self.tx_path_reeval_query_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_path_reeval_query_event.get_name_leafdata())
                        if (self.tx_resv_change_event.is_set or self.tx_resv_change_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_resv_change_event.get_name_leafdata())
                        if (self.tx_resv_create_event.is_set or self.tx_resv_create_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_resv_create_event.get_name_leafdata())
                        if (self.tx_resv_delete_event.is_set or self.tx_resv_delete_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_resv_delete_event.get_name_leafdata())
                        if (self.tx_resv_error_event.is_set or self.tx_resv_error_event.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tx_resv_error_event.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "events-count" or name == "events-total-count" or name == "rx-backup-assign-err-event" or name == "rx-event-unknown" or name == "rx-path-change-event" or name == "rx-path-create-event" or name == "rx-path-delete-event" or name == "rx-path-error-event" or name == "rx-path-reeval-query-event" or name == "rx-resv-change-event" or name == "rx-resv-create-event" or name == "rx-resv-delete-event" or name == "rx-resv-error-event" or name == "tx-backup-assign-event" or name == "tx-event-unknown" or name == "tx-path-change-event" or name == "tx-path-create-event" or name == "tx-path-delete-event" or name == "tx-path-error-event" or name == "tx-path-reeval-query-event" or name == "tx-resv-change-event" or name == "tx-resv-create-event" or name == "tx-resv-delete-event" or name == "tx-resv-error-event"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "events-count"):
                            self.events_count = value
                            self.events_count.value_namespace = name_space
                            self.events_count.value_namespace_prefix = name_space_prefix
                        if(value_path == "events-total-count"):
                            self.events_total_count = value
                            self.events_total_count.value_namespace = name_space
                            self.events_total_count.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-backup-assign-err-event"):
                            self.rx_backup_assign_err_event = value
                            self.rx_backup_assign_err_event.value_namespace = name_space
                            self.rx_backup_assign_err_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-event-unknown"):
                            self.rx_event_unknown = value
                            self.rx_event_unknown.value_namespace = name_space
                            self.rx_event_unknown.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-path-change-event"):
                            self.rx_path_change_event = value
                            self.rx_path_change_event.value_namespace = name_space
                            self.rx_path_change_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-path-create-event"):
                            self.rx_path_create_event = value
                            self.rx_path_create_event.value_namespace = name_space
                            self.rx_path_create_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-path-delete-event"):
                            self.rx_path_delete_event = value
                            self.rx_path_delete_event.value_namespace = name_space
                            self.rx_path_delete_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-path-error-event"):
                            self.rx_path_error_event = value
                            self.rx_path_error_event.value_namespace = name_space
                            self.rx_path_error_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-path-reeval-query-event"):
                            self.rx_path_reeval_query_event = value
                            self.rx_path_reeval_query_event.value_namespace = name_space
                            self.rx_path_reeval_query_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-resv-change-event"):
                            self.rx_resv_change_event = value
                            self.rx_resv_change_event.value_namespace = name_space
                            self.rx_resv_change_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-resv-create-event"):
                            self.rx_resv_create_event = value
                            self.rx_resv_create_event.value_namespace = name_space
                            self.rx_resv_create_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-resv-delete-event"):
                            self.rx_resv_delete_event = value
                            self.rx_resv_delete_event.value_namespace = name_space
                            self.rx_resv_delete_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "rx-resv-error-event"):
                            self.rx_resv_error_event = value
                            self.rx_resv_error_event.value_namespace = name_space
                            self.rx_resv_error_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-backup-assign-event"):
                            self.tx_backup_assign_event = value
                            self.tx_backup_assign_event.value_namespace = name_space
                            self.tx_backup_assign_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-event-unknown"):
                            self.tx_event_unknown = value
                            self.tx_event_unknown.value_namespace = name_space
                            self.tx_event_unknown.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-path-change-event"):
                            self.tx_path_change_event = value
                            self.tx_path_change_event.value_namespace = name_space
                            self.tx_path_change_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-path-create-event"):
                            self.tx_path_create_event = value
                            self.tx_path_create_event.value_namespace = name_space
                            self.tx_path_create_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-path-delete-event"):
                            self.tx_path_delete_event = value
                            self.tx_path_delete_event.value_namespace = name_space
                            self.tx_path_delete_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-path-error-event"):
                            self.tx_path_error_event = value
                            self.tx_path_error_event.value_namespace = name_space
                            self.tx_path_error_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-path-reeval-query-event"):
                            self.tx_path_reeval_query_event = value
                            self.tx_path_reeval_query_event.value_namespace = name_space
                            self.tx_path_reeval_query_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-resv-change-event"):
                            self.tx_resv_change_event = value
                            self.tx_resv_change_event.value_namespace = name_space
                            self.tx_resv_change_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-resv-create-event"):
                            self.tx_resv_create_event = value
                            self.tx_resv_create_event.value_namespace = name_space
                            self.tx_resv_create_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-resv-delete-event"):
                            self.tx_resv_delete_event = value
                            self.tx_resv_delete_event.value_namespace = name_space
                            self.tx_resv_delete_event.value_namespace_prefix = name_space_prefix
                        if(value_path == "tx-resv-error-event"):
                            self.tx_resv_error_event = value
                            self.tx_resv_error_event.value_namespace = name_space
                            self.tx_resv_error_event.value_namespace_prefix = name_space_prefix


                class S2LStatistic(Entity):
                    """
                    List of S2L Statistics
                    
                    .. attribute:: destination_address
                    
                    	Destination address
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: statistics
                    
                    	S2L stats
                    	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.TailsCounters.TailsCounter.S2LStatistic.Statistics>`
                    
                    .. attribute:: sub_group_id
                    
                    	subgroup ID
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: sub_group_originator
                    
                    	Subgroup Originator
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.SignallingCounters.TailsCounters.TailsCounter.S2LStatistic, self).__init__()

                        self.yang_name = "s2l-statistic"
                        self.yang_parent_name = "tails-counter"

                        self.destination_address = YLeaf(YType.str, "destination-address")

                        self.sub_group_id = YLeaf(YType.uint16, "sub-group-id")

                        self.sub_group_originator = YLeaf(YType.str, "sub-group-originator")

                        self.statistics = MplsTeStandby.SignallingCounters.TailsCounters.TailsCounter.S2LStatistic.Statistics()
                        self.statistics.parent = self
                        self._children_name_map["statistics"] = "statistics"
                        self._children_yang_names.add("statistics")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("destination_address",
                                        "sub_group_id",
                                        "sub_group_originator") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.SignallingCounters.TailsCounters.TailsCounter.S2LStatistic, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.SignallingCounters.TailsCounters.TailsCounter.S2LStatistic, self).__setattr__(name, value)


                    class Statistics(Entity):
                        """
                        S2L stats
                        
                        .. attribute:: events_count
                        
                        	TE Signaling event count
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: events_total_count
                        
                        	Total TE Signalling event count
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_backup_assign_err_event
                        
                        	Error on Backup Assign event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_event_unknown
                        
                        	RX Unknown events
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_path_change_event
                        
                        	RX Path Change event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_path_create_event
                        
                        	RX Path Create event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_path_delete_event
                        
                        	RX Path Delete event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_path_error_event
                        
                        	RX Path Error event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_path_reeval_query_event
                        
                        	RX Path Reeval Query event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_resv_change_event
                        
                        	RX Resv Change event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_resv_create_event
                        
                        	RX Resv Create event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_resv_delete_event
                        
                        	RX Resv Delete event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: rx_resv_error_event
                        
                        	RX Resv Error event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_backup_assign_event
                        
                        	Backup Assign event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_event_unknown
                        
                        	Unknown TX events
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_path_change_event
                        
                        	TX Path Change event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_path_create_event
                        
                        	TX Path Create event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_path_delete_event
                        
                        	TX Path Delete event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_path_error_event
                        
                        	TX Path Error event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_path_reeval_query_event
                        
                        	TX Path Reeval Query event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_resv_change_event
                        
                        	TX Resv Change event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_resv_create_event
                        
                        	TX Resv Create event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_resv_delete_event
                        
                        	TX Resv Delete event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tx_resv_error_event
                        
                        	TX Resv Error event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.SignallingCounters.TailsCounters.TailsCounter.S2LStatistic.Statistics, self).__init__()

                            self.yang_name = "statistics"
                            self.yang_parent_name = "s2l-statistic"

                            self.events_count = YLeaf(YType.uint32, "events-count")

                            self.events_total_count = YLeaf(YType.uint32, "events-total-count")

                            self.rx_backup_assign_err_event = YLeaf(YType.uint32, "rx-backup-assign-err-event")

                            self.rx_event_unknown = YLeaf(YType.uint32, "rx-event-unknown")

                            self.rx_path_change_event = YLeaf(YType.uint32, "rx-path-change-event")

                            self.rx_path_create_event = YLeaf(YType.uint32, "rx-path-create-event")

                            self.rx_path_delete_event = YLeaf(YType.uint32, "rx-path-delete-event")

                            self.rx_path_error_event = YLeaf(YType.uint32, "rx-path-error-event")

                            self.rx_path_reeval_query_event = YLeaf(YType.uint32, "rx-path-reeval-query-event")

                            self.rx_resv_change_event = YLeaf(YType.uint32, "rx-resv-change-event")

                            self.rx_resv_create_event = YLeaf(YType.uint32, "rx-resv-create-event")

                            self.rx_resv_delete_event = YLeaf(YType.uint32, "rx-resv-delete-event")

                            self.rx_resv_error_event = YLeaf(YType.uint32, "rx-resv-error-event")

                            self.tx_backup_assign_event = YLeaf(YType.uint32, "tx-backup-assign-event")

                            self.tx_event_unknown = YLeaf(YType.uint32, "tx-event-unknown")

                            self.tx_path_change_event = YLeaf(YType.uint32, "tx-path-change-event")

                            self.tx_path_create_event = YLeaf(YType.uint32, "tx-path-create-event")

                            self.tx_path_delete_event = YLeaf(YType.uint32, "tx-path-delete-event")

                            self.tx_path_error_event = YLeaf(YType.uint32, "tx-path-error-event")

                            self.tx_path_reeval_query_event = YLeaf(YType.uint32, "tx-path-reeval-query-event")

                            self.tx_resv_change_event = YLeaf(YType.uint32, "tx-resv-change-event")

                            self.tx_resv_create_event = YLeaf(YType.uint32, "tx-resv-create-event")

                            self.tx_resv_delete_event = YLeaf(YType.uint32, "tx-resv-delete-event")

                            self.tx_resv_error_event = YLeaf(YType.uint32, "tx-resv-error-event")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("events_count",
                                            "events_total_count",
                                            "rx_backup_assign_err_event",
                                            "rx_event_unknown",
                                            "rx_path_change_event",
                                            "rx_path_create_event",
                                            "rx_path_delete_event",
                                            "rx_path_error_event",
                                            "rx_path_reeval_query_event",
                                            "rx_resv_change_event",
                                            "rx_resv_create_event",
                                            "rx_resv_delete_event",
                                            "rx_resv_error_event",
                                            "tx_backup_assign_event",
                                            "tx_event_unknown",
                                            "tx_path_change_event",
                                            "tx_path_create_event",
                                            "tx_path_delete_event",
                                            "tx_path_error_event",
                                            "tx_path_reeval_query_event",
                                            "tx_resv_change_event",
                                            "tx_resv_create_event",
                                            "tx_resv_delete_event",
                                            "tx_resv_error_event") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.SignallingCounters.TailsCounters.TailsCounter.S2LStatistic.Statistics, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.SignallingCounters.TailsCounters.TailsCounter.S2LStatistic.Statistics, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.events_count.is_set or
                                self.events_total_count.is_set or
                                self.rx_backup_assign_err_event.is_set or
                                self.rx_event_unknown.is_set or
                                self.rx_path_change_event.is_set or
                                self.rx_path_create_event.is_set or
                                self.rx_path_delete_event.is_set or
                                self.rx_path_error_event.is_set or
                                self.rx_path_reeval_query_event.is_set or
                                self.rx_resv_change_event.is_set or
                                self.rx_resv_create_event.is_set or
                                self.rx_resv_delete_event.is_set or
                                self.rx_resv_error_event.is_set or
                                self.tx_backup_assign_event.is_set or
                                self.tx_event_unknown.is_set or
                                self.tx_path_change_event.is_set or
                                self.tx_path_create_event.is_set or
                                self.tx_path_delete_event.is_set or
                                self.tx_path_error_event.is_set or
                                self.tx_path_reeval_query_event.is_set or
                                self.tx_resv_change_event.is_set or
                                self.tx_resv_create_event.is_set or
                                self.tx_resv_delete_event.is_set or
                                self.tx_resv_error_event.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.events_count.yfilter != YFilter.not_set or
                                self.events_total_count.yfilter != YFilter.not_set or
                                self.rx_backup_assign_err_event.yfilter != YFilter.not_set or
                                self.rx_event_unknown.yfilter != YFilter.not_set or
                                self.rx_path_change_event.yfilter != YFilter.not_set or
                                self.rx_path_create_event.yfilter != YFilter.not_set or
                                self.rx_path_delete_event.yfilter != YFilter.not_set or
                                self.rx_path_error_event.yfilter != YFilter.not_set or
                                self.rx_path_reeval_query_event.yfilter != YFilter.not_set or
                                self.rx_resv_change_event.yfilter != YFilter.not_set or
                                self.rx_resv_create_event.yfilter != YFilter.not_set or
                                self.rx_resv_delete_event.yfilter != YFilter.not_set or
                                self.rx_resv_error_event.yfilter != YFilter.not_set or
                                self.tx_backup_assign_event.yfilter != YFilter.not_set or
                                self.tx_event_unknown.yfilter != YFilter.not_set or
                                self.tx_path_change_event.yfilter != YFilter.not_set or
                                self.tx_path_create_event.yfilter != YFilter.not_set or
                                self.tx_path_delete_event.yfilter != YFilter.not_set or
                                self.tx_path_error_event.yfilter != YFilter.not_set or
                                self.tx_path_reeval_query_event.yfilter != YFilter.not_set or
                                self.tx_resv_change_event.yfilter != YFilter.not_set or
                                self.tx_resv_create_event.yfilter != YFilter.not_set or
                                self.tx_resv_delete_event.yfilter != YFilter.not_set or
                                self.tx_resv_error_event.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "statistics" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.events_count.is_set or self.events_count.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.events_count.get_name_leafdata())
                            if (self.events_total_count.is_set or self.events_total_count.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.events_total_count.get_name_leafdata())
                            if (self.rx_backup_assign_err_event.is_set or self.rx_backup_assign_err_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_backup_assign_err_event.get_name_leafdata())
                            if (self.rx_event_unknown.is_set or self.rx_event_unknown.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_event_unknown.get_name_leafdata())
                            if (self.rx_path_change_event.is_set or self.rx_path_change_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_path_change_event.get_name_leafdata())
                            if (self.rx_path_create_event.is_set or self.rx_path_create_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_path_create_event.get_name_leafdata())
                            if (self.rx_path_delete_event.is_set or self.rx_path_delete_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_path_delete_event.get_name_leafdata())
                            if (self.rx_path_error_event.is_set or self.rx_path_error_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_path_error_event.get_name_leafdata())
                            if (self.rx_path_reeval_query_event.is_set or self.rx_path_reeval_query_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_path_reeval_query_event.get_name_leafdata())
                            if (self.rx_resv_change_event.is_set or self.rx_resv_change_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_resv_change_event.get_name_leafdata())
                            if (self.rx_resv_create_event.is_set or self.rx_resv_create_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_resv_create_event.get_name_leafdata())
                            if (self.rx_resv_delete_event.is_set or self.rx_resv_delete_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_resv_delete_event.get_name_leafdata())
                            if (self.rx_resv_error_event.is_set or self.rx_resv_error_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rx_resv_error_event.get_name_leafdata())
                            if (self.tx_backup_assign_event.is_set or self.tx_backup_assign_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_backup_assign_event.get_name_leafdata())
                            if (self.tx_event_unknown.is_set or self.tx_event_unknown.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_event_unknown.get_name_leafdata())
                            if (self.tx_path_change_event.is_set or self.tx_path_change_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_path_change_event.get_name_leafdata())
                            if (self.tx_path_create_event.is_set or self.tx_path_create_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_path_create_event.get_name_leafdata())
                            if (self.tx_path_delete_event.is_set or self.tx_path_delete_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_path_delete_event.get_name_leafdata())
                            if (self.tx_path_error_event.is_set or self.tx_path_error_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_path_error_event.get_name_leafdata())
                            if (self.tx_path_reeval_query_event.is_set or self.tx_path_reeval_query_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_path_reeval_query_event.get_name_leafdata())
                            if (self.tx_resv_change_event.is_set or self.tx_resv_change_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_resv_change_event.get_name_leafdata())
                            if (self.tx_resv_create_event.is_set or self.tx_resv_create_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_resv_create_event.get_name_leafdata())
                            if (self.tx_resv_delete_event.is_set or self.tx_resv_delete_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_resv_delete_event.get_name_leafdata())
                            if (self.tx_resv_error_event.is_set or self.tx_resv_error_event.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tx_resv_error_event.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "events-count" or name == "events-total-count" or name == "rx-backup-assign-err-event" or name == "rx-event-unknown" or name == "rx-path-change-event" or name == "rx-path-create-event" or name == "rx-path-delete-event" or name == "rx-path-error-event" or name == "rx-path-reeval-query-event" or name == "rx-resv-change-event" or name == "rx-resv-create-event" or name == "rx-resv-delete-event" or name == "rx-resv-error-event" or name == "tx-backup-assign-event" or name == "tx-event-unknown" or name == "tx-path-change-event" or name == "tx-path-create-event" or name == "tx-path-delete-event" or name == "tx-path-error-event" or name == "tx-path-reeval-query-event" or name == "tx-resv-change-event" or name == "tx-resv-create-event" or name == "tx-resv-delete-event" or name == "tx-resv-error-event"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "events-count"):
                                self.events_count = value
                                self.events_count.value_namespace = name_space
                                self.events_count.value_namespace_prefix = name_space_prefix
                            if(value_path == "events-total-count"):
                                self.events_total_count = value
                                self.events_total_count.value_namespace = name_space
                                self.events_total_count.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-backup-assign-err-event"):
                                self.rx_backup_assign_err_event = value
                                self.rx_backup_assign_err_event.value_namespace = name_space
                                self.rx_backup_assign_err_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-event-unknown"):
                                self.rx_event_unknown = value
                                self.rx_event_unknown.value_namespace = name_space
                                self.rx_event_unknown.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-path-change-event"):
                                self.rx_path_change_event = value
                                self.rx_path_change_event.value_namespace = name_space
                                self.rx_path_change_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-path-create-event"):
                                self.rx_path_create_event = value
                                self.rx_path_create_event.value_namespace = name_space
                                self.rx_path_create_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-path-delete-event"):
                                self.rx_path_delete_event = value
                                self.rx_path_delete_event.value_namespace = name_space
                                self.rx_path_delete_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-path-error-event"):
                                self.rx_path_error_event = value
                                self.rx_path_error_event.value_namespace = name_space
                                self.rx_path_error_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-path-reeval-query-event"):
                                self.rx_path_reeval_query_event = value
                                self.rx_path_reeval_query_event.value_namespace = name_space
                                self.rx_path_reeval_query_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-resv-change-event"):
                                self.rx_resv_change_event = value
                                self.rx_resv_change_event.value_namespace = name_space
                                self.rx_resv_change_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-resv-create-event"):
                                self.rx_resv_create_event = value
                                self.rx_resv_create_event.value_namespace = name_space
                                self.rx_resv_create_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-resv-delete-event"):
                                self.rx_resv_delete_event = value
                                self.rx_resv_delete_event.value_namespace = name_space
                                self.rx_resv_delete_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "rx-resv-error-event"):
                                self.rx_resv_error_event = value
                                self.rx_resv_error_event.value_namespace = name_space
                                self.rx_resv_error_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-backup-assign-event"):
                                self.tx_backup_assign_event = value
                                self.tx_backup_assign_event.value_namespace = name_space
                                self.tx_backup_assign_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-event-unknown"):
                                self.tx_event_unknown = value
                                self.tx_event_unknown.value_namespace = name_space
                                self.tx_event_unknown.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-path-change-event"):
                                self.tx_path_change_event = value
                                self.tx_path_change_event.value_namespace = name_space
                                self.tx_path_change_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-path-create-event"):
                                self.tx_path_create_event = value
                                self.tx_path_create_event.value_namespace = name_space
                                self.tx_path_create_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-path-delete-event"):
                                self.tx_path_delete_event = value
                                self.tx_path_delete_event.value_namespace = name_space
                                self.tx_path_delete_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-path-error-event"):
                                self.tx_path_error_event = value
                                self.tx_path_error_event.value_namespace = name_space
                                self.tx_path_error_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-path-reeval-query-event"):
                                self.tx_path_reeval_query_event = value
                                self.tx_path_reeval_query_event.value_namespace = name_space
                                self.tx_path_reeval_query_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-resv-change-event"):
                                self.tx_resv_change_event = value
                                self.tx_resv_change_event.value_namespace = name_space
                                self.tx_resv_change_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-resv-create-event"):
                                self.tx_resv_create_event = value
                                self.tx_resv_create_event.value_namespace = name_space
                                self.tx_resv_create_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-resv-delete-event"):
                                self.tx_resv_delete_event = value
                                self.tx_resv_delete_event.value_namespace = name_space
                                self.tx_resv_delete_event.value_namespace_prefix = name_space_prefix
                            if(value_path == "tx-resv-error-event"):
                                self.tx_resv_error_event = value
                                self.tx_resv_error_event.value_namespace = name_space
                                self.tx_resv_error_event.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.destination_address.is_set or
                            self.sub_group_id.is_set or
                            self.sub_group_originator.is_set or
                            (self.statistics is not None and self.statistics.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.destination_address.yfilter != YFilter.not_set or
                            self.sub_group_id.yfilter != YFilter.not_set or
                            self.sub_group_originator.yfilter != YFilter.not_set or
                            (self.statistics is not None and self.statistics.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "s2l-statistic" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.destination_address.get_name_leafdata())
                        if (self.sub_group_id.is_set or self.sub_group_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.sub_group_id.get_name_leafdata())
                        if (self.sub_group_originator.is_set or self.sub_group_originator.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.sub_group_originator.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "statistics"):
                            if (self.statistics is None):
                                self.statistics = MplsTeStandby.SignallingCounters.TailsCounters.TailsCounter.S2LStatistic.Statistics()
                                self.statistics.parent = self
                                self._children_name_map["statistics"] = "statistics"
                            return self.statistics

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "statistics" or name == "destination-address" or name == "sub-group-id" or name == "sub-group-originator"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "destination-address"):
                            self.destination_address = value
                            self.destination_address.value_namespace = name_space
                            self.destination_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "sub-group-id"):
                            self.sub_group_id = value
                            self.sub_group_id.value_namespace = name_space
                            self.sub_group_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "sub-group-originator"):
                            self.sub_group_originator = value
                            self.sub_group_originator.value_namespace = name_space
                            self.sub_group_originator.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.s2l_statistic:
                        if (c.has_data()):
                            return True
                    return (
                        self.source_address.is_set or
                        self.destination_address.is_set or
                        self.tunnel_id.is_set or
                        self.extended_tunnel_id.is_set or
                        self.lsp_id.is_set or
                        self.tunnel_name.is_set or
                        (self.statistics is not None and self.statistics.has_data()))

                def has_operation(self):
                    for c in self.s2l_statistic:
                        if (c.has_operation()):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        self.source_address.yfilter != YFilter.not_set or
                        self.destination_address.yfilter != YFilter.not_set or
                        self.tunnel_id.yfilter != YFilter.not_set or
                        self.extended_tunnel_id.yfilter != YFilter.not_set or
                        self.lsp_id.yfilter != YFilter.not_set or
                        self.tunnel_name.yfilter != YFilter.not_set or
                        (self.statistics is not None and self.statistics.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "tails-counter" + "[source-address='" + self.source_address.get() + "']" + "[destination-address='" + self.destination_address.get() + "']" + "[tunnel-id='" + self.tunnel_id.get() + "']" + "[extended-tunnel-id='" + self.extended_tunnel_id.get() + "']" + "[lsp-id='" + self.lsp_id.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/signalling-counters/tails-counters/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.source_address.is_set or self.source_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.source_address.get_name_leafdata())
                    if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.destination_address.get_name_leafdata())
                    if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_id.get_name_leafdata())
                    if (self.extended_tunnel_id.is_set or self.extended_tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.extended_tunnel_id.get_name_leafdata())
                    if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.lsp_id.get_name_leafdata())
                    if (self.tunnel_name.is_set or self.tunnel_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_name.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "s2l-statistic"):
                        for c in self.s2l_statistic:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsTeStandby.SignallingCounters.TailsCounters.TailsCounter.S2LStatistic()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.s2l_statistic.append(c)
                        return c

                    if (child_yang_name == "statistics"):
                        if (self.statistics is None):
                            self.statistics = MplsTeStandby.SignallingCounters.TailsCounters.TailsCounter.Statistics()
                            self.statistics.parent = self
                            self._children_name_map["statistics"] = "statistics"
                        return self.statistics

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "s2l-statistic" or name == "statistics" or name == "source-address" or name == "destination-address" or name == "tunnel-id" or name == "extended-tunnel-id" or name == "lsp-id" or name == "tunnel-name"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "source-address"):
                        self.source_address = value
                        self.source_address.value_namespace = name_space
                        self.source_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "destination-address"):
                        self.destination_address = value
                        self.destination_address.value_namespace = name_space
                        self.destination_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-id"):
                        self.tunnel_id = value
                        self.tunnel_id.value_namespace = name_space
                        self.tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "extended-tunnel-id"):
                        self.extended_tunnel_id = value
                        self.extended_tunnel_id.value_namespace = name_space
                        self.extended_tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "lsp-id"):
                        self.lsp_id = value
                        self.lsp_id.value_namespace = name_space
                        self.lsp_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-name"):
                        self.tunnel_name = value
                        self.tunnel_name.value_namespace = name_space
                        self.tunnel_name.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.tails_counter:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.tails_counter:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "tails-counters" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/signalling-counters/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "tails-counter"):
                    for c in self.tails_counter:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTeStandby.SignallingCounters.TailsCounters.TailsCounter()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.tails_counter.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "tails-counter"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass


        class Signallings(Entity):
            """
            TE counters
            
            .. attribute:: signalling
            
            	TE Sig
            	**type**\: list of    :py:class:`Signalling <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.Signallings.Signalling>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTeStandby.SignallingCounters.Signallings, self).__init__()

                self.yang_name = "signallings"
                self.yang_parent_name = "signalling-counters"

                self.signalling = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTeStandby.SignallingCounters.Signallings, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTeStandby.SignallingCounters.Signallings, self).__setattr__(name, value)


            class Signalling(Entity):
                """
                TE Sig
                
                .. attribute:: ctype  <key>
                
                	Ctype
                	**type**\:   :py:class:`Ctype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.Ctype>`
                
                .. attribute:: tunnel_id  <key>
                
                	Tunnel ID
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: extended_tunnel_id  <key>
                
                	Extended Tunnel ID
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: p2mp_id  <key>
                
                	P2MP ID
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: lsp_id  <key>
                
                	LSP ID
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: source_address  <key>
                
                	Source Address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: destination_address  <key>
                
                	Destination Address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: sub_group_originator  <key>
                
                	Subgroup originator
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: sub_group_id  <key>
                
                	Subgroup ID
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: te_signalling_filter_data
                
                	TE Signaling Filter data
                	**type**\:   :py:class:`TeSignallingFilterData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData>`
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTeStandby.SignallingCounters.Signallings.Signalling, self).__init__()

                    self.yang_name = "signalling"
                    self.yang_parent_name = "signallings"

                    self.ctype = YLeaf(YType.enumeration, "ctype")

                    self.tunnel_id = YLeaf(YType.int32, "tunnel-id")

                    self.extended_tunnel_id = YLeaf(YType.str, "extended-tunnel-id")

                    self.p2mp_id = YLeaf(YType.int32, "p2mp-id")

                    self.lsp_id = YLeaf(YType.int32, "lsp-id")

                    self.source_address = YLeaf(YType.str, "source-address")

                    self.destination_address = YLeaf(YType.str, "destination-address")

                    self.sub_group_originator = YLeaf(YType.str, "sub-group-originator")

                    self.sub_group_id = YLeaf(YType.int32, "sub-group-id")

                    self.te_signalling_filter_data = MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData()
                    self.te_signalling_filter_data.parent = self
                    self._children_name_map["te_signalling_filter_data"] = "te-signalling-filter-data"
                    self._children_yang_names.add("te-signalling-filter-data")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("ctype",
                                    "tunnel_id",
                                    "extended_tunnel_id",
                                    "p2mp_id",
                                    "lsp_id",
                                    "source_address",
                                    "destination_address",
                                    "sub_group_originator",
                                    "sub_group_id") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTeStandby.SignallingCounters.Signallings.Signalling, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTeStandby.SignallingCounters.Signallings.Signalling, self).__setattr__(name, value)


                class TeSignallingFilterData(Entity):
                    """
                    TE Signaling Filter data
                    
                    .. attribute:: statistics_filter
                    
                    	StatisticsFilter
                    	**type**\:   :py:class:`TeStatsSigFilter <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeStatsSigFilter>`
                    
                    .. attribute:: te_signalling_filter_lsp
                    
                    	LSP data
                    	**type**\:   :py:class:`TeSignallingFilterLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp>`
                    
                    .. attribute:: te_signalling_filter_vif
                    
                    	VIF data
                    	**type**\:   :py:class:`TeSignallingFilterVif <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData, self).__init__()

                        self.yang_name = "te-signalling-filter-data"
                        self.yang_parent_name = "signalling"

                        self.statistics_filter = YLeaf(YType.enumeration, "statistics-filter")

                        self.te_signalling_filter_lsp = MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp()
                        self.te_signalling_filter_lsp.parent = self
                        self._children_name_map["te_signalling_filter_lsp"] = "te-signalling-filter-lsp"
                        self._children_yang_names.add("te-signalling-filter-lsp")

                        self.te_signalling_filter_vif = MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif()
                        self.te_signalling_filter_vif.parent = self
                        self._children_name_map["te_signalling_filter_vif"] = "te-signalling-filter-vif"
                        self._children_yang_names.add("te-signalling-filter-vif")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("statistics_filter") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData, self).__setattr__(name, value)


                    class TeSignallingFilterVif(Entity):
                        """
                        VIF data
                        
                        .. attribute:: destination_statistic
                        
                        	List of Destination Stats
                        	**type**\: list of    :py:class:`DestinationStatistic <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic>`
                        
                        .. attribute:: lsp_id
                        
                        	LSP ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: statistics
                        
                        	VIF stats
                        	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.Statistics>`
                        
                        .. attribute:: tunnel_name
                        
                        	Tunnel Name
                        	**type**\:  str
                        
                        .. attribute:: tunnel_sig_name
                        
                        	Tunnel Signalled\-Name
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif, self).__init__()

                            self.yang_name = "te-signalling-filter-vif"
                            self.yang_parent_name = "te-signalling-filter-data"

                            self.lsp_id = YLeaf(YType.uint16, "lsp-id")

                            self.tunnel_name = YLeaf(YType.str, "tunnel-name")

                            self.tunnel_sig_name = YLeaf(YType.str, "tunnel-sig-name")

                            self.statistics = MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.Statistics()
                            self.statistics.parent = self
                            self._children_name_map["statistics"] = "statistics"
                            self._children_yang_names.add("statistics")

                            self.destination_statistic = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("lsp_id",
                                            "tunnel_name",
                                            "tunnel_sig_name") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif, self).__setattr__(name, value)


                        class Statistics(Entity):
                            """
                            VIF stats
                            
                            .. attribute:: events_count
                            
                            	TE Signaling event count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: events_total_count
                            
                            	Total TE Signalling event count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_backup_assign_err_event
                            
                            	Error on Backup Assign event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_event_unknown
                            
                            	RX Unknown events
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_path_change_event
                            
                            	RX Path Change event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_path_create_event
                            
                            	RX Path Create event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_path_delete_event
                            
                            	RX Path Delete event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_path_error_event
                            
                            	RX Path Error event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_path_reeval_query_event
                            
                            	RX Path Reeval Query event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_resv_change_event
                            
                            	RX Resv Change event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_resv_create_event
                            
                            	RX Resv Create event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_resv_delete_event
                            
                            	RX Resv Delete event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_resv_error_event
                            
                            	RX Resv Error event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_backup_assign_event
                            
                            	Backup Assign event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_event_unknown
                            
                            	Unknown TX events
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_path_change_event
                            
                            	TX Path Change event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_path_create_event
                            
                            	TX Path Create event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_path_delete_event
                            
                            	TX Path Delete event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_path_error_event
                            
                            	TX Path Error event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_path_reeval_query_event
                            
                            	TX Path Reeval Query event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_resv_change_event
                            
                            	TX Resv Change event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_resv_create_event
                            
                            	TX Resv Create event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_resv_delete_event
                            
                            	TX Resv Delete event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_resv_error_event
                            
                            	TX Resv Error event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.Statistics, self).__init__()

                                self.yang_name = "statistics"
                                self.yang_parent_name = "te-signalling-filter-vif"

                                self.events_count = YLeaf(YType.uint32, "events-count")

                                self.events_total_count = YLeaf(YType.uint32, "events-total-count")

                                self.rx_backup_assign_err_event = YLeaf(YType.uint32, "rx-backup-assign-err-event")

                                self.rx_event_unknown = YLeaf(YType.uint32, "rx-event-unknown")

                                self.rx_path_change_event = YLeaf(YType.uint32, "rx-path-change-event")

                                self.rx_path_create_event = YLeaf(YType.uint32, "rx-path-create-event")

                                self.rx_path_delete_event = YLeaf(YType.uint32, "rx-path-delete-event")

                                self.rx_path_error_event = YLeaf(YType.uint32, "rx-path-error-event")

                                self.rx_path_reeval_query_event = YLeaf(YType.uint32, "rx-path-reeval-query-event")

                                self.rx_resv_change_event = YLeaf(YType.uint32, "rx-resv-change-event")

                                self.rx_resv_create_event = YLeaf(YType.uint32, "rx-resv-create-event")

                                self.rx_resv_delete_event = YLeaf(YType.uint32, "rx-resv-delete-event")

                                self.rx_resv_error_event = YLeaf(YType.uint32, "rx-resv-error-event")

                                self.tx_backup_assign_event = YLeaf(YType.uint32, "tx-backup-assign-event")

                                self.tx_event_unknown = YLeaf(YType.uint32, "tx-event-unknown")

                                self.tx_path_change_event = YLeaf(YType.uint32, "tx-path-change-event")

                                self.tx_path_create_event = YLeaf(YType.uint32, "tx-path-create-event")

                                self.tx_path_delete_event = YLeaf(YType.uint32, "tx-path-delete-event")

                                self.tx_path_error_event = YLeaf(YType.uint32, "tx-path-error-event")

                                self.tx_path_reeval_query_event = YLeaf(YType.uint32, "tx-path-reeval-query-event")

                                self.tx_resv_change_event = YLeaf(YType.uint32, "tx-resv-change-event")

                                self.tx_resv_create_event = YLeaf(YType.uint32, "tx-resv-create-event")

                                self.tx_resv_delete_event = YLeaf(YType.uint32, "tx-resv-delete-event")

                                self.tx_resv_error_event = YLeaf(YType.uint32, "tx-resv-error-event")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("events_count",
                                                "events_total_count",
                                                "rx_backup_assign_err_event",
                                                "rx_event_unknown",
                                                "rx_path_change_event",
                                                "rx_path_create_event",
                                                "rx_path_delete_event",
                                                "rx_path_error_event",
                                                "rx_path_reeval_query_event",
                                                "rx_resv_change_event",
                                                "rx_resv_create_event",
                                                "rx_resv_delete_event",
                                                "rx_resv_error_event",
                                                "tx_backup_assign_event",
                                                "tx_event_unknown",
                                                "tx_path_change_event",
                                                "tx_path_create_event",
                                                "tx_path_delete_event",
                                                "tx_path_error_event",
                                                "tx_path_reeval_query_event",
                                                "tx_resv_change_event",
                                                "tx_resv_create_event",
                                                "tx_resv_delete_event",
                                                "tx_resv_error_event") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.Statistics, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.Statistics, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.events_count.is_set or
                                    self.events_total_count.is_set or
                                    self.rx_backup_assign_err_event.is_set or
                                    self.rx_event_unknown.is_set or
                                    self.rx_path_change_event.is_set or
                                    self.rx_path_create_event.is_set or
                                    self.rx_path_delete_event.is_set or
                                    self.rx_path_error_event.is_set or
                                    self.rx_path_reeval_query_event.is_set or
                                    self.rx_resv_change_event.is_set or
                                    self.rx_resv_create_event.is_set or
                                    self.rx_resv_delete_event.is_set or
                                    self.rx_resv_error_event.is_set or
                                    self.tx_backup_assign_event.is_set or
                                    self.tx_event_unknown.is_set or
                                    self.tx_path_change_event.is_set or
                                    self.tx_path_create_event.is_set or
                                    self.tx_path_delete_event.is_set or
                                    self.tx_path_error_event.is_set or
                                    self.tx_path_reeval_query_event.is_set or
                                    self.tx_resv_change_event.is_set or
                                    self.tx_resv_create_event.is_set or
                                    self.tx_resv_delete_event.is_set or
                                    self.tx_resv_error_event.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.events_count.yfilter != YFilter.not_set or
                                    self.events_total_count.yfilter != YFilter.not_set or
                                    self.rx_backup_assign_err_event.yfilter != YFilter.not_set or
                                    self.rx_event_unknown.yfilter != YFilter.not_set or
                                    self.rx_path_change_event.yfilter != YFilter.not_set or
                                    self.rx_path_create_event.yfilter != YFilter.not_set or
                                    self.rx_path_delete_event.yfilter != YFilter.not_set or
                                    self.rx_path_error_event.yfilter != YFilter.not_set or
                                    self.rx_path_reeval_query_event.yfilter != YFilter.not_set or
                                    self.rx_resv_change_event.yfilter != YFilter.not_set or
                                    self.rx_resv_create_event.yfilter != YFilter.not_set or
                                    self.rx_resv_delete_event.yfilter != YFilter.not_set or
                                    self.rx_resv_error_event.yfilter != YFilter.not_set or
                                    self.tx_backup_assign_event.yfilter != YFilter.not_set or
                                    self.tx_event_unknown.yfilter != YFilter.not_set or
                                    self.tx_path_change_event.yfilter != YFilter.not_set or
                                    self.tx_path_create_event.yfilter != YFilter.not_set or
                                    self.tx_path_delete_event.yfilter != YFilter.not_set or
                                    self.tx_path_error_event.yfilter != YFilter.not_set or
                                    self.tx_path_reeval_query_event.yfilter != YFilter.not_set or
                                    self.tx_resv_change_event.yfilter != YFilter.not_set or
                                    self.tx_resv_create_event.yfilter != YFilter.not_set or
                                    self.tx_resv_delete_event.yfilter != YFilter.not_set or
                                    self.tx_resv_error_event.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "statistics" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.events_count.is_set or self.events_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.events_count.get_name_leafdata())
                                if (self.events_total_count.is_set or self.events_total_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.events_total_count.get_name_leafdata())
                                if (self.rx_backup_assign_err_event.is_set or self.rx_backup_assign_err_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_backup_assign_err_event.get_name_leafdata())
                                if (self.rx_event_unknown.is_set or self.rx_event_unknown.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_event_unknown.get_name_leafdata())
                                if (self.rx_path_change_event.is_set or self.rx_path_change_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_path_change_event.get_name_leafdata())
                                if (self.rx_path_create_event.is_set or self.rx_path_create_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_path_create_event.get_name_leafdata())
                                if (self.rx_path_delete_event.is_set or self.rx_path_delete_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_path_delete_event.get_name_leafdata())
                                if (self.rx_path_error_event.is_set or self.rx_path_error_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_path_error_event.get_name_leafdata())
                                if (self.rx_path_reeval_query_event.is_set or self.rx_path_reeval_query_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_path_reeval_query_event.get_name_leafdata())
                                if (self.rx_resv_change_event.is_set or self.rx_resv_change_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_resv_change_event.get_name_leafdata())
                                if (self.rx_resv_create_event.is_set or self.rx_resv_create_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_resv_create_event.get_name_leafdata())
                                if (self.rx_resv_delete_event.is_set or self.rx_resv_delete_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_resv_delete_event.get_name_leafdata())
                                if (self.rx_resv_error_event.is_set or self.rx_resv_error_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_resv_error_event.get_name_leafdata())
                                if (self.tx_backup_assign_event.is_set or self.tx_backup_assign_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_backup_assign_event.get_name_leafdata())
                                if (self.tx_event_unknown.is_set or self.tx_event_unknown.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_event_unknown.get_name_leafdata())
                                if (self.tx_path_change_event.is_set or self.tx_path_change_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_path_change_event.get_name_leafdata())
                                if (self.tx_path_create_event.is_set or self.tx_path_create_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_path_create_event.get_name_leafdata())
                                if (self.tx_path_delete_event.is_set or self.tx_path_delete_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_path_delete_event.get_name_leafdata())
                                if (self.tx_path_error_event.is_set or self.tx_path_error_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_path_error_event.get_name_leafdata())
                                if (self.tx_path_reeval_query_event.is_set or self.tx_path_reeval_query_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_path_reeval_query_event.get_name_leafdata())
                                if (self.tx_resv_change_event.is_set or self.tx_resv_change_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_resv_change_event.get_name_leafdata())
                                if (self.tx_resv_create_event.is_set or self.tx_resv_create_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_resv_create_event.get_name_leafdata())
                                if (self.tx_resv_delete_event.is_set or self.tx_resv_delete_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_resv_delete_event.get_name_leafdata())
                                if (self.tx_resv_error_event.is_set or self.tx_resv_error_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_resv_error_event.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "events-count" or name == "events-total-count" or name == "rx-backup-assign-err-event" or name == "rx-event-unknown" or name == "rx-path-change-event" or name == "rx-path-create-event" or name == "rx-path-delete-event" or name == "rx-path-error-event" or name == "rx-path-reeval-query-event" or name == "rx-resv-change-event" or name == "rx-resv-create-event" or name == "rx-resv-delete-event" or name == "rx-resv-error-event" or name == "tx-backup-assign-event" or name == "tx-event-unknown" or name == "tx-path-change-event" or name == "tx-path-create-event" or name == "tx-path-delete-event" or name == "tx-path-error-event" or name == "tx-path-reeval-query-event" or name == "tx-resv-change-event" or name == "tx-resv-create-event" or name == "tx-resv-delete-event" or name == "tx-resv-error-event"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "events-count"):
                                    self.events_count = value
                                    self.events_count.value_namespace = name_space
                                    self.events_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "events-total-count"):
                                    self.events_total_count = value
                                    self.events_total_count.value_namespace = name_space
                                    self.events_total_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-backup-assign-err-event"):
                                    self.rx_backup_assign_err_event = value
                                    self.rx_backup_assign_err_event.value_namespace = name_space
                                    self.rx_backup_assign_err_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-event-unknown"):
                                    self.rx_event_unknown = value
                                    self.rx_event_unknown.value_namespace = name_space
                                    self.rx_event_unknown.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-path-change-event"):
                                    self.rx_path_change_event = value
                                    self.rx_path_change_event.value_namespace = name_space
                                    self.rx_path_change_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-path-create-event"):
                                    self.rx_path_create_event = value
                                    self.rx_path_create_event.value_namespace = name_space
                                    self.rx_path_create_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-path-delete-event"):
                                    self.rx_path_delete_event = value
                                    self.rx_path_delete_event.value_namespace = name_space
                                    self.rx_path_delete_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-path-error-event"):
                                    self.rx_path_error_event = value
                                    self.rx_path_error_event.value_namespace = name_space
                                    self.rx_path_error_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-path-reeval-query-event"):
                                    self.rx_path_reeval_query_event = value
                                    self.rx_path_reeval_query_event.value_namespace = name_space
                                    self.rx_path_reeval_query_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-resv-change-event"):
                                    self.rx_resv_change_event = value
                                    self.rx_resv_change_event.value_namespace = name_space
                                    self.rx_resv_change_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-resv-create-event"):
                                    self.rx_resv_create_event = value
                                    self.rx_resv_create_event.value_namespace = name_space
                                    self.rx_resv_create_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-resv-delete-event"):
                                    self.rx_resv_delete_event = value
                                    self.rx_resv_delete_event.value_namespace = name_space
                                    self.rx_resv_delete_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-resv-error-event"):
                                    self.rx_resv_error_event = value
                                    self.rx_resv_error_event.value_namespace = name_space
                                    self.rx_resv_error_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-backup-assign-event"):
                                    self.tx_backup_assign_event = value
                                    self.tx_backup_assign_event.value_namespace = name_space
                                    self.tx_backup_assign_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-event-unknown"):
                                    self.tx_event_unknown = value
                                    self.tx_event_unknown.value_namespace = name_space
                                    self.tx_event_unknown.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-path-change-event"):
                                    self.tx_path_change_event = value
                                    self.tx_path_change_event.value_namespace = name_space
                                    self.tx_path_change_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-path-create-event"):
                                    self.tx_path_create_event = value
                                    self.tx_path_create_event.value_namespace = name_space
                                    self.tx_path_create_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-path-delete-event"):
                                    self.tx_path_delete_event = value
                                    self.tx_path_delete_event.value_namespace = name_space
                                    self.tx_path_delete_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-path-error-event"):
                                    self.tx_path_error_event = value
                                    self.tx_path_error_event.value_namespace = name_space
                                    self.tx_path_error_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-path-reeval-query-event"):
                                    self.tx_path_reeval_query_event = value
                                    self.tx_path_reeval_query_event.value_namespace = name_space
                                    self.tx_path_reeval_query_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-resv-change-event"):
                                    self.tx_resv_change_event = value
                                    self.tx_resv_change_event.value_namespace = name_space
                                    self.tx_resv_change_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-resv-create-event"):
                                    self.tx_resv_create_event = value
                                    self.tx_resv_create_event.value_namespace = name_space
                                    self.tx_resv_create_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-resv-delete-event"):
                                    self.tx_resv_delete_event = value
                                    self.tx_resv_delete_event.value_namespace = name_space
                                    self.tx_resv_delete_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-resv-error-event"):
                                    self.tx_resv_error_event = value
                                    self.tx_resv_error_event.value_namespace = name_space
                                    self.tx_resv_error_event.value_namespace_prefix = name_space_prefix


                        class DestinationStatistic(Entity):
                            """
                            List of Destination Stats
                            
                            .. attribute:: destination_address
                            
                            	Destination address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_statistic
                            
                            	List of S2L Stats
                            	**type**\: list of    :py:class:`S2LStatistic <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic.S2LStatistic>`
                            
                            .. attribute:: statistics
                            
                            	Destination stats
                            	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic.Statistics>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic, self).__init__()

                                self.yang_name = "destination-statistic"
                                self.yang_parent_name = "te-signalling-filter-vif"

                                self.destination_address = YLeaf(YType.str, "destination-address")

                                self.statistics = MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic.Statistics()
                                self.statistics.parent = self
                                self._children_name_map["statistics"] = "statistics"
                                self._children_yang_names.add("statistics")

                                self.s2l_statistic = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("destination_address") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic, self).__setattr__(name, value)


                            class Statistics(Entity):
                                """
                                Destination stats
                                
                                .. attribute:: events_count
                                
                                	TE Signaling event count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: events_total_count
                                
                                	Total TE Signalling event count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: rx_backup_assign_err_event
                                
                                	Error on Backup Assign event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: rx_event_unknown
                                
                                	RX Unknown events
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: rx_path_change_event
                                
                                	RX Path Change event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: rx_path_create_event
                                
                                	RX Path Create event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: rx_path_delete_event
                                
                                	RX Path Delete event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: rx_path_error_event
                                
                                	RX Path Error event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: rx_path_reeval_query_event
                                
                                	RX Path Reeval Query event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: rx_resv_change_event
                                
                                	RX Resv Change event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: rx_resv_create_event
                                
                                	RX Resv Create event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: rx_resv_delete_event
                                
                                	RX Resv Delete event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: rx_resv_error_event
                                
                                	RX Resv Error event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tx_backup_assign_event
                                
                                	Backup Assign event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tx_event_unknown
                                
                                	Unknown TX events
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tx_path_change_event
                                
                                	TX Path Change event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tx_path_create_event
                                
                                	TX Path Create event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tx_path_delete_event
                                
                                	TX Path Delete event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tx_path_error_event
                                
                                	TX Path Error event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tx_path_reeval_query_event
                                
                                	TX Path Reeval Query event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tx_resv_change_event
                                
                                	TX Resv Change event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tx_resv_create_event
                                
                                	TX Resv Create event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tx_resv_delete_event
                                
                                	TX Resv Delete event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tx_resv_error_event
                                
                                	TX Resv Error event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic.Statistics, self).__init__()

                                    self.yang_name = "statistics"
                                    self.yang_parent_name = "destination-statistic"

                                    self.events_count = YLeaf(YType.uint32, "events-count")

                                    self.events_total_count = YLeaf(YType.uint32, "events-total-count")

                                    self.rx_backup_assign_err_event = YLeaf(YType.uint32, "rx-backup-assign-err-event")

                                    self.rx_event_unknown = YLeaf(YType.uint32, "rx-event-unknown")

                                    self.rx_path_change_event = YLeaf(YType.uint32, "rx-path-change-event")

                                    self.rx_path_create_event = YLeaf(YType.uint32, "rx-path-create-event")

                                    self.rx_path_delete_event = YLeaf(YType.uint32, "rx-path-delete-event")

                                    self.rx_path_error_event = YLeaf(YType.uint32, "rx-path-error-event")

                                    self.rx_path_reeval_query_event = YLeaf(YType.uint32, "rx-path-reeval-query-event")

                                    self.rx_resv_change_event = YLeaf(YType.uint32, "rx-resv-change-event")

                                    self.rx_resv_create_event = YLeaf(YType.uint32, "rx-resv-create-event")

                                    self.rx_resv_delete_event = YLeaf(YType.uint32, "rx-resv-delete-event")

                                    self.rx_resv_error_event = YLeaf(YType.uint32, "rx-resv-error-event")

                                    self.tx_backup_assign_event = YLeaf(YType.uint32, "tx-backup-assign-event")

                                    self.tx_event_unknown = YLeaf(YType.uint32, "tx-event-unknown")

                                    self.tx_path_change_event = YLeaf(YType.uint32, "tx-path-change-event")

                                    self.tx_path_create_event = YLeaf(YType.uint32, "tx-path-create-event")

                                    self.tx_path_delete_event = YLeaf(YType.uint32, "tx-path-delete-event")

                                    self.tx_path_error_event = YLeaf(YType.uint32, "tx-path-error-event")

                                    self.tx_path_reeval_query_event = YLeaf(YType.uint32, "tx-path-reeval-query-event")

                                    self.tx_resv_change_event = YLeaf(YType.uint32, "tx-resv-change-event")

                                    self.tx_resv_create_event = YLeaf(YType.uint32, "tx-resv-create-event")

                                    self.tx_resv_delete_event = YLeaf(YType.uint32, "tx-resv-delete-event")

                                    self.tx_resv_error_event = YLeaf(YType.uint32, "tx-resv-error-event")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("events_count",
                                                    "events_total_count",
                                                    "rx_backup_assign_err_event",
                                                    "rx_event_unknown",
                                                    "rx_path_change_event",
                                                    "rx_path_create_event",
                                                    "rx_path_delete_event",
                                                    "rx_path_error_event",
                                                    "rx_path_reeval_query_event",
                                                    "rx_resv_change_event",
                                                    "rx_resv_create_event",
                                                    "rx_resv_delete_event",
                                                    "rx_resv_error_event",
                                                    "tx_backup_assign_event",
                                                    "tx_event_unknown",
                                                    "tx_path_change_event",
                                                    "tx_path_create_event",
                                                    "tx_path_delete_event",
                                                    "tx_path_error_event",
                                                    "tx_path_reeval_query_event",
                                                    "tx_resv_change_event",
                                                    "tx_resv_create_event",
                                                    "tx_resv_delete_event",
                                                    "tx_resv_error_event") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic.Statistics, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic.Statistics, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.events_count.is_set or
                                        self.events_total_count.is_set or
                                        self.rx_backup_assign_err_event.is_set or
                                        self.rx_event_unknown.is_set or
                                        self.rx_path_change_event.is_set or
                                        self.rx_path_create_event.is_set or
                                        self.rx_path_delete_event.is_set or
                                        self.rx_path_error_event.is_set or
                                        self.rx_path_reeval_query_event.is_set or
                                        self.rx_resv_change_event.is_set or
                                        self.rx_resv_create_event.is_set or
                                        self.rx_resv_delete_event.is_set or
                                        self.rx_resv_error_event.is_set or
                                        self.tx_backup_assign_event.is_set or
                                        self.tx_event_unknown.is_set or
                                        self.tx_path_change_event.is_set or
                                        self.tx_path_create_event.is_set or
                                        self.tx_path_delete_event.is_set or
                                        self.tx_path_error_event.is_set or
                                        self.tx_path_reeval_query_event.is_set or
                                        self.tx_resv_change_event.is_set or
                                        self.tx_resv_create_event.is_set or
                                        self.tx_resv_delete_event.is_set or
                                        self.tx_resv_error_event.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.events_count.yfilter != YFilter.not_set or
                                        self.events_total_count.yfilter != YFilter.not_set or
                                        self.rx_backup_assign_err_event.yfilter != YFilter.not_set or
                                        self.rx_event_unknown.yfilter != YFilter.not_set or
                                        self.rx_path_change_event.yfilter != YFilter.not_set or
                                        self.rx_path_create_event.yfilter != YFilter.not_set or
                                        self.rx_path_delete_event.yfilter != YFilter.not_set or
                                        self.rx_path_error_event.yfilter != YFilter.not_set or
                                        self.rx_path_reeval_query_event.yfilter != YFilter.not_set or
                                        self.rx_resv_change_event.yfilter != YFilter.not_set or
                                        self.rx_resv_create_event.yfilter != YFilter.not_set or
                                        self.rx_resv_delete_event.yfilter != YFilter.not_set or
                                        self.rx_resv_error_event.yfilter != YFilter.not_set or
                                        self.tx_backup_assign_event.yfilter != YFilter.not_set or
                                        self.tx_event_unknown.yfilter != YFilter.not_set or
                                        self.tx_path_change_event.yfilter != YFilter.not_set or
                                        self.tx_path_create_event.yfilter != YFilter.not_set or
                                        self.tx_path_delete_event.yfilter != YFilter.not_set or
                                        self.tx_path_error_event.yfilter != YFilter.not_set or
                                        self.tx_path_reeval_query_event.yfilter != YFilter.not_set or
                                        self.tx_resv_change_event.yfilter != YFilter.not_set or
                                        self.tx_resv_create_event.yfilter != YFilter.not_set or
                                        self.tx_resv_delete_event.yfilter != YFilter.not_set or
                                        self.tx_resv_error_event.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "statistics" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.events_count.is_set or self.events_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.events_count.get_name_leafdata())
                                    if (self.events_total_count.is_set or self.events_total_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.events_total_count.get_name_leafdata())
                                    if (self.rx_backup_assign_err_event.is_set or self.rx_backup_assign_err_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rx_backup_assign_err_event.get_name_leafdata())
                                    if (self.rx_event_unknown.is_set or self.rx_event_unknown.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rx_event_unknown.get_name_leafdata())
                                    if (self.rx_path_change_event.is_set or self.rx_path_change_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rx_path_change_event.get_name_leafdata())
                                    if (self.rx_path_create_event.is_set or self.rx_path_create_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rx_path_create_event.get_name_leafdata())
                                    if (self.rx_path_delete_event.is_set or self.rx_path_delete_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rx_path_delete_event.get_name_leafdata())
                                    if (self.rx_path_error_event.is_set or self.rx_path_error_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rx_path_error_event.get_name_leafdata())
                                    if (self.rx_path_reeval_query_event.is_set or self.rx_path_reeval_query_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rx_path_reeval_query_event.get_name_leafdata())
                                    if (self.rx_resv_change_event.is_set or self.rx_resv_change_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rx_resv_change_event.get_name_leafdata())
                                    if (self.rx_resv_create_event.is_set or self.rx_resv_create_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rx_resv_create_event.get_name_leafdata())
                                    if (self.rx_resv_delete_event.is_set or self.rx_resv_delete_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rx_resv_delete_event.get_name_leafdata())
                                    if (self.rx_resv_error_event.is_set or self.rx_resv_error_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rx_resv_error_event.get_name_leafdata())
                                    if (self.tx_backup_assign_event.is_set or self.tx_backup_assign_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tx_backup_assign_event.get_name_leafdata())
                                    if (self.tx_event_unknown.is_set or self.tx_event_unknown.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tx_event_unknown.get_name_leafdata())
                                    if (self.tx_path_change_event.is_set or self.tx_path_change_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tx_path_change_event.get_name_leafdata())
                                    if (self.tx_path_create_event.is_set or self.tx_path_create_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tx_path_create_event.get_name_leafdata())
                                    if (self.tx_path_delete_event.is_set or self.tx_path_delete_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tx_path_delete_event.get_name_leafdata())
                                    if (self.tx_path_error_event.is_set or self.tx_path_error_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tx_path_error_event.get_name_leafdata())
                                    if (self.tx_path_reeval_query_event.is_set or self.tx_path_reeval_query_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tx_path_reeval_query_event.get_name_leafdata())
                                    if (self.tx_resv_change_event.is_set or self.tx_resv_change_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tx_resv_change_event.get_name_leafdata())
                                    if (self.tx_resv_create_event.is_set or self.tx_resv_create_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tx_resv_create_event.get_name_leafdata())
                                    if (self.tx_resv_delete_event.is_set or self.tx_resv_delete_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tx_resv_delete_event.get_name_leafdata())
                                    if (self.tx_resv_error_event.is_set or self.tx_resv_error_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tx_resv_error_event.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "events-count" or name == "events-total-count" or name == "rx-backup-assign-err-event" or name == "rx-event-unknown" or name == "rx-path-change-event" or name == "rx-path-create-event" or name == "rx-path-delete-event" or name == "rx-path-error-event" or name == "rx-path-reeval-query-event" or name == "rx-resv-change-event" or name == "rx-resv-create-event" or name == "rx-resv-delete-event" or name == "rx-resv-error-event" or name == "tx-backup-assign-event" or name == "tx-event-unknown" or name == "tx-path-change-event" or name == "tx-path-create-event" or name == "tx-path-delete-event" or name == "tx-path-error-event" or name == "tx-path-reeval-query-event" or name == "tx-resv-change-event" or name == "tx-resv-create-event" or name == "tx-resv-delete-event" or name == "tx-resv-error-event"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "events-count"):
                                        self.events_count = value
                                        self.events_count.value_namespace = name_space
                                        self.events_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "events-total-count"):
                                        self.events_total_count = value
                                        self.events_total_count.value_namespace = name_space
                                        self.events_total_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "rx-backup-assign-err-event"):
                                        self.rx_backup_assign_err_event = value
                                        self.rx_backup_assign_err_event.value_namespace = name_space
                                        self.rx_backup_assign_err_event.value_namespace_prefix = name_space_prefix
                                    if(value_path == "rx-event-unknown"):
                                        self.rx_event_unknown = value
                                        self.rx_event_unknown.value_namespace = name_space
                                        self.rx_event_unknown.value_namespace_prefix = name_space_prefix
                                    if(value_path == "rx-path-change-event"):
                                        self.rx_path_change_event = value
                                        self.rx_path_change_event.value_namespace = name_space
                                        self.rx_path_change_event.value_namespace_prefix = name_space_prefix
                                    if(value_path == "rx-path-create-event"):
                                        self.rx_path_create_event = value
                                        self.rx_path_create_event.value_namespace = name_space
                                        self.rx_path_create_event.value_namespace_prefix = name_space_prefix
                                    if(value_path == "rx-path-delete-event"):
                                        self.rx_path_delete_event = value
                                        self.rx_path_delete_event.value_namespace = name_space
                                        self.rx_path_delete_event.value_namespace_prefix = name_space_prefix
                                    if(value_path == "rx-path-error-event"):
                                        self.rx_path_error_event = value
                                        self.rx_path_error_event.value_namespace = name_space
                                        self.rx_path_error_event.value_namespace_prefix = name_space_prefix
                                    if(value_path == "rx-path-reeval-query-event"):
                                        self.rx_path_reeval_query_event = value
                                        self.rx_path_reeval_query_event.value_namespace = name_space
                                        self.rx_path_reeval_query_event.value_namespace_prefix = name_space_prefix
                                    if(value_path == "rx-resv-change-event"):
                                        self.rx_resv_change_event = value
                                        self.rx_resv_change_event.value_namespace = name_space
                                        self.rx_resv_change_event.value_namespace_prefix = name_space_prefix
                                    if(value_path == "rx-resv-create-event"):
                                        self.rx_resv_create_event = value
                                        self.rx_resv_create_event.value_namespace = name_space
                                        self.rx_resv_create_event.value_namespace_prefix = name_space_prefix
                                    if(value_path == "rx-resv-delete-event"):
                                        self.rx_resv_delete_event = value
                                        self.rx_resv_delete_event.value_namespace = name_space
                                        self.rx_resv_delete_event.value_namespace_prefix = name_space_prefix
                                    if(value_path == "rx-resv-error-event"):
                                        self.rx_resv_error_event = value
                                        self.rx_resv_error_event.value_namespace = name_space
                                        self.rx_resv_error_event.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tx-backup-assign-event"):
                                        self.tx_backup_assign_event = value
                                        self.tx_backup_assign_event.value_namespace = name_space
                                        self.tx_backup_assign_event.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tx-event-unknown"):
                                        self.tx_event_unknown = value
                                        self.tx_event_unknown.value_namespace = name_space
                                        self.tx_event_unknown.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tx-path-change-event"):
                                        self.tx_path_change_event = value
                                        self.tx_path_change_event.value_namespace = name_space
                                        self.tx_path_change_event.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tx-path-create-event"):
                                        self.tx_path_create_event = value
                                        self.tx_path_create_event.value_namespace = name_space
                                        self.tx_path_create_event.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tx-path-delete-event"):
                                        self.tx_path_delete_event = value
                                        self.tx_path_delete_event.value_namespace = name_space
                                        self.tx_path_delete_event.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tx-path-error-event"):
                                        self.tx_path_error_event = value
                                        self.tx_path_error_event.value_namespace = name_space
                                        self.tx_path_error_event.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tx-path-reeval-query-event"):
                                        self.tx_path_reeval_query_event = value
                                        self.tx_path_reeval_query_event.value_namespace = name_space
                                        self.tx_path_reeval_query_event.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tx-resv-change-event"):
                                        self.tx_resv_change_event = value
                                        self.tx_resv_change_event.value_namespace = name_space
                                        self.tx_resv_change_event.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tx-resv-create-event"):
                                        self.tx_resv_create_event = value
                                        self.tx_resv_create_event.value_namespace = name_space
                                        self.tx_resv_create_event.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tx-resv-delete-event"):
                                        self.tx_resv_delete_event = value
                                        self.tx_resv_delete_event.value_namespace = name_space
                                        self.tx_resv_delete_event.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tx-resv-error-event"):
                                        self.tx_resv_error_event = value
                                        self.tx_resv_error_event.value_namespace = name_space
                                        self.tx_resv_error_event.value_namespace_prefix = name_space_prefix


                            class S2LStatistic(Entity):
                                """
                                List of S2L Stats
                                
                                .. attribute:: destination_address
                                
                                	Destination address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: statistics
                                
                                	S2L stats
                                	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic.S2LStatistic.Statistics>`
                                
                                .. attribute:: sub_group_id
                                
                                	subgroup ID
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                .. attribute:: sub_group_originator
                                
                                	Subgroup Originator
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic.S2LStatistic, self).__init__()

                                    self.yang_name = "s2l-statistic"
                                    self.yang_parent_name = "destination-statistic"

                                    self.destination_address = YLeaf(YType.str, "destination-address")

                                    self.sub_group_id = YLeaf(YType.uint16, "sub-group-id")

                                    self.sub_group_originator = YLeaf(YType.str, "sub-group-originator")

                                    self.statistics = MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic.S2LStatistic.Statistics()
                                    self.statistics.parent = self
                                    self._children_name_map["statistics"] = "statistics"
                                    self._children_yang_names.add("statistics")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("destination_address",
                                                    "sub_group_id",
                                                    "sub_group_originator") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic.S2LStatistic, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic.S2LStatistic, self).__setattr__(name, value)


                                class Statistics(Entity):
                                    """
                                    S2L stats
                                    
                                    .. attribute:: events_count
                                    
                                    	TE Signaling event count
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: events_total_count
                                    
                                    	Total TE Signalling event count
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: rx_backup_assign_err_event
                                    
                                    	Error on Backup Assign event
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: rx_event_unknown
                                    
                                    	RX Unknown events
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: rx_path_change_event
                                    
                                    	RX Path Change event
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: rx_path_create_event
                                    
                                    	RX Path Create event
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: rx_path_delete_event
                                    
                                    	RX Path Delete event
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: rx_path_error_event
                                    
                                    	RX Path Error event
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: rx_path_reeval_query_event
                                    
                                    	RX Path Reeval Query event
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: rx_resv_change_event
                                    
                                    	RX Resv Change event
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: rx_resv_create_event
                                    
                                    	RX Resv Create event
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: rx_resv_delete_event
                                    
                                    	RX Resv Delete event
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: rx_resv_error_event
                                    
                                    	RX Resv Error event
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tx_backup_assign_event
                                    
                                    	Backup Assign event
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tx_event_unknown
                                    
                                    	Unknown TX events
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tx_path_change_event
                                    
                                    	TX Path Change event
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tx_path_create_event
                                    
                                    	TX Path Create event
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tx_path_delete_event
                                    
                                    	TX Path Delete event
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tx_path_error_event
                                    
                                    	TX Path Error event
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tx_path_reeval_query_event
                                    
                                    	TX Path Reeval Query event
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tx_resv_change_event
                                    
                                    	TX Resv Change event
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tx_resv_create_event
                                    
                                    	TX Resv Create event
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tx_resv_delete_event
                                    
                                    	TX Resv Delete event
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: tx_resv_error_event
                                    
                                    	TX Resv Error event
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic.S2LStatistic.Statistics, self).__init__()

                                        self.yang_name = "statistics"
                                        self.yang_parent_name = "s2l-statistic"

                                        self.events_count = YLeaf(YType.uint32, "events-count")

                                        self.events_total_count = YLeaf(YType.uint32, "events-total-count")

                                        self.rx_backup_assign_err_event = YLeaf(YType.uint32, "rx-backup-assign-err-event")

                                        self.rx_event_unknown = YLeaf(YType.uint32, "rx-event-unknown")

                                        self.rx_path_change_event = YLeaf(YType.uint32, "rx-path-change-event")

                                        self.rx_path_create_event = YLeaf(YType.uint32, "rx-path-create-event")

                                        self.rx_path_delete_event = YLeaf(YType.uint32, "rx-path-delete-event")

                                        self.rx_path_error_event = YLeaf(YType.uint32, "rx-path-error-event")

                                        self.rx_path_reeval_query_event = YLeaf(YType.uint32, "rx-path-reeval-query-event")

                                        self.rx_resv_change_event = YLeaf(YType.uint32, "rx-resv-change-event")

                                        self.rx_resv_create_event = YLeaf(YType.uint32, "rx-resv-create-event")

                                        self.rx_resv_delete_event = YLeaf(YType.uint32, "rx-resv-delete-event")

                                        self.rx_resv_error_event = YLeaf(YType.uint32, "rx-resv-error-event")

                                        self.tx_backup_assign_event = YLeaf(YType.uint32, "tx-backup-assign-event")

                                        self.tx_event_unknown = YLeaf(YType.uint32, "tx-event-unknown")

                                        self.tx_path_change_event = YLeaf(YType.uint32, "tx-path-change-event")

                                        self.tx_path_create_event = YLeaf(YType.uint32, "tx-path-create-event")

                                        self.tx_path_delete_event = YLeaf(YType.uint32, "tx-path-delete-event")

                                        self.tx_path_error_event = YLeaf(YType.uint32, "tx-path-error-event")

                                        self.tx_path_reeval_query_event = YLeaf(YType.uint32, "tx-path-reeval-query-event")

                                        self.tx_resv_change_event = YLeaf(YType.uint32, "tx-resv-change-event")

                                        self.tx_resv_create_event = YLeaf(YType.uint32, "tx-resv-create-event")

                                        self.tx_resv_delete_event = YLeaf(YType.uint32, "tx-resv-delete-event")

                                        self.tx_resv_error_event = YLeaf(YType.uint32, "tx-resv-error-event")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("events_count",
                                                        "events_total_count",
                                                        "rx_backup_assign_err_event",
                                                        "rx_event_unknown",
                                                        "rx_path_change_event",
                                                        "rx_path_create_event",
                                                        "rx_path_delete_event",
                                                        "rx_path_error_event",
                                                        "rx_path_reeval_query_event",
                                                        "rx_resv_change_event",
                                                        "rx_resv_create_event",
                                                        "rx_resv_delete_event",
                                                        "rx_resv_error_event",
                                                        "tx_backup_assign_event",
                                                        "tx_event_unknown",
                                                        "tx_path_change_event",
                                                        "tx_path_create_event",
                                                        "tx_path_delete_event",
                                                        "tx_path_error_event",
                                                        "tx_path_reeval_query_event",
                                                        "tx_resv_change_event",
                                                        "tx_resv_create_event",
                                                        "tx_resv_delete_event",
                                                        "tx_resv_error_event") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic.S2LStatistic.Statistics, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic.S2LStatistic.Statistics, self).__setattr__(name, value)

                                    def has_data(self):
                                        return (
                                            self.events_count.is_set or
                                            self.events_total_count.is_set or
                                            self.rx_backup_assign_err_event.is_set or
                                            self.rx_event_unknown.is_set or
                                            self.rx_path_change_event.is_set or
                                            self.rx_path_create_event.is_set or
                                            self.rx_path_delete_event.is_set or
                                            self.rx_path_error_event.is_set or
                                            self.rx_path_reeval_query_event.is_set or
                                            self.rx_resv_change_event.is_set or
                                            self.rx_resv_create_event.is_set or
                                            self.rx_resv_delete_event.is_set or
                                            self.rx_resv_error_event.is_set or
                                            self.tx_backup_assign_event.is_set or
                                            self.tx_event_unknown.is_set or
                                            self.tx_path_change_event.is_set or
                                            self.tx_path_create_event.is_set or
                                            self.tx_path_delete_event.is_set or
                                            self.tx_path_error_event.is_set or
                                            self.tx_path_reeval_query_event.is_set or
                                            self.tx_resv_change_event.is_set or
                                            self.tx_resv_create_event.is_set or
                                            self.tx_resv_delete_event.is_set or
                                            self.tx_resv_error_event.is_set)

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.events_count.yfilter != YFilter.not_set or
                                            self.events_total_count.yfilter != YFilter.not_set or
                                            self.rx_backup_assign_err_event.yfilter != YFilter.not_set or
                                            self.rx_event_unknown.yfilter != YFilter.not_set or
                                            self.rx_path_change_event.yfilter != YFilter.not_set or
                                            self.rx_path_create_event.yfilter != YFilter.not_set or
                                            self.rx_path_delete_event.yfilter != YFilter.not_set or
                                            self.rx_path_error_event.yfilter != YFilter.not_set or
                                            self.rx_path_reeval_query_event.yfilter != YFilter.not_set or
                                            self.rx_resv_change_event.yfilter != YFilter.not_set or
                                            self.rx_resv_create_event.yfilter != YFilter.not_set or
                                            self.rx_resv_delete_event.yfilter != YFilter.not_set or
                                            self.rx_resv_error_event.yfilter != YFilter.not_set or
                                            self.tx_backup_assign_event.yfilter != YFilter.not_set or
                                            self.tx_event_unknown.yfilter != YFilter.not_set or
                                            self.tx_path_change_event.yfilter != YFilter.not_set or
                                            self.tx_path_create_event.yfilter != YFilter.not_set or
                                            self.tx_path_delete_event.yfilter != YFilter.not_set or
                                            self.tx_path_error_event.yfilter != YFilter.not_set or
                                            self.tx_path_reeval_query_event.yfilter != YFilter.not_set or
                                            self.tx_resv_change_event.yfilter != YFilter.not_set or
                                            self.tx_resv_create_event.yfilter != YFilter.not_set or
                                            self.tx_resv_delete_event.yfilter != YFilter.not_set or
                                            self.tx_resv_error_event.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "statistics" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.events_count.is_set or self.events_count.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.events_count.get_name_leafdata())
                                        if (self.events_total_count.is_set or self.events_total_count.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.events_total_count.get_name_leafdata())
                                        if (self.rx_backup_assign_err_event.is_set or self.rx_backup_assign_err_event.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.rx_backup_assign_err_event.get_name_leafdata())
                                        if (self.rx_event_unknown.is_set or self.rx_event_unknown.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.rx_event_unknown.get_name_leafdata())
                                        if (self.rx_path_change_event.is_set or self.rx_path_change_event.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.rx_path_change_event.get_name_leafdata())
                                        if (self.rx_path_create_event.is_set or self.rx_path_create_event.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.rx_path_create_event.get_name_leafdata())
                                        if (self.rx_path_delete_event.is_set or self.rx_path_delete_event.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.rx_path_delete_event.get_name_leafdata())
                                        if (self.rx_path_error_event.is_set or self.rx_path_error_event.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.rx_path_error_event.get_name_leafdata())
                                        if (self.rx_path_reeval_query_event.is_set or self.rx_path_reeval_query_event.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.rx_path_reeval_query_event.get_name_leafdata())
                                        if (self.rx_resv_change_event.is_set or self.rx_resv_change_event.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.rx_resv_change_event.get_name_leafdata())
                                        if (self.rx_resv_create_event.is_set or self.rx_resv_create_event.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.rx_resv_create_event.get_name_leafdata())
                                        if (self.rx_resv_delete_event.is_set or self.rx_resv_delete_event.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.rx_resv_delete_event.get_name_leafdata())
                                        if (self.rx_resv_error_event.is_set or self.rx_resv_error_event.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.rx_resv_error_event.get_name_leafdata())
                                        if (self.tx_backup_assign_event.is_set or self.tx_backup_assign_event.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tx_backup_assign_event.get_name_leafdata())
                                        if (self.tx_event_unknown.is_set or self.tx_event_unknown.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tx_event_unknown.get_name_leafdata())
                                        if (self.tx_path_change_event.is_set or self.tx_path_change_event.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tx_path_change_event.get_name_leafdata())
                                        if (self.tx_path_create_event.is_set or self.tx_path_create_event.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tx_path_create_event.get_name_leafdata())
                                        if (self.tx_path_delete_event.is_set or self.tx_path_delete_event.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tx_path_delete_event.get_name_leafdata())
                                        if (self.tx_path_error_event.is_set or self.tx_path_error_event.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tx_path_error_event.get_name_leafdata())
                                        if (self.tx_path_reeval_query_event.is_set or self.tx_path_reeval_query_event.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tx_path_reeval_query_event.get_name_leafdata())
                                        if (self.tx_resv_change_event.is_set or self.tx_resv_change_event.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tx_resv_change_event.get_name_leafdata())
                                        if (self.tx_resv_create_event.is_set or self.tx_resv_create_event.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tx_resv_create_event.get_name_leafdata())
                                        if (self.tx_resv_delete_event.is_set or self.tx_resv_delete_event.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tx_resv_delete_event.get_name_leafdata())
                                        if (self.tx_resv_error_event.is_set or self.tx_resv_error_event.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.tx_resv_error_event.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "events-count" or name == "events-total-count" or name == "rx-backup-assign-err-event" or name == "rx-event-unknown" or name == "rx-path-change-event" or name == "rx-path-create-event" or name == "rx-path-delete-event" or name == "rx-path-error-event" or name == "rx-path-reeval-query-event" or name == "rx-resv-change-event" or name == "rx-resv-create-event" or name == "rx-resv-delete-event" or name == "rx-resv-error-event" or name == "tx-backup-assign-event" or name == "tx-event-unknown" or name == "tx-path-change-event" or name == "tx-path-create-event" or name == "tx-path-delete-event" or name == "tx-path-error-event" or name == "tx-path-reeval-query-event" or name == "tx-resv-change-event" or name == "tx-resv-create-event" or name == "tx-resv-delete-event" or name == "tx-resv-error-event"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "events-count"):
                                            self.events_count = value
                                            self.events_count.value_namespace = name_space
                                            self.events_count.value_namespace_prefix = name_space_prefix
                                        if(value_path == "events-total-count"):
                                            self.events_total_count = value
                                            self.events_total_count.value_namespace = name_space
                                            self.events_total_count.value_namespace_prefix = name_space_prefix
                                        if(value_path == "rx-backup-assign-err-event"):
                                            self.rx_backup_assign_err_event = value
                                            self.rx_backup_assign_err_event.value_namespace = name_space
                                            self.rx_backup_assign_err_event.value_namespace_prefix = name_space_prefix
                                        if(value_path == "rx-event-unknown"):
                                            self.rx_event_unknown = value
                                            self.rx_event_unknown.value_namespace = name_space
                                            self.rx_event_unknown.value_namespace_prefix = name_space_prefix
                                        if(value_path == "rx-path-change-event"):
                                            self.rx_path_change_event = value
                                            self.rx_path_change_event.value_namespace = name_space
                                            self.rx_path_change_event.value_namespace_prefix = name_space_prefix
                                        if(value_path == "rx-path-create-event"):
                                            self.rx_path_create_event = value
                                            self.rx_path_create_event.value_namespace = name_space
                                            self.rx_path_create_event.value_namespace_prefix = name_space_prefix
                                        if(value_path == "rx-path-delete-event"):
                                            self.rx_path_delete_event = value
                                            self.rx_path_delete_event.value_namespace = name_space
                                            self.rx_path_delete_event.value_namespace_prefix = name_space_prefix
                                        if(value_path == "rx-path-error-event"):
                                            self.rx_path_error_event = value
                                            self.rx_path_error_event.value_namespace = name_space
                                            self.rx_path_error_event.value_namespace_prefix = name_space_prefix
                                        if(value_path == "rx-path-reeval-query-event"):
                                            self.rx_path_reeval_query_event = value
                                            self.rx_path_reeval_query_event.value_namespace = name_space
                                            self.rx_path_reeval_query_event.value_namespace_prefix = name_space_prefix
                                        if(value_path == "rx-resv-change-event"):
                                            self.rx_resv_change_event = value
                                            self.rx_resv_change_event.value_namespace = name_space
                                            self.rx_resv_change_event.value_namespace_prefix = name_space_prefix
                                        if(value_path == "rx-resv-create-event"):
                                            self.rx_resv_create_event = value
                                            self.rx_resv_create_event.value_namespace = name_space
                                            self.rx_resv_create_event.value_namespace_prefix = name_space_prefix
                                        if(value_path == "rx-resv-delete-event"):
                                            self.rx_resv_delete_event = value
                                            self.rx_resv_delete_event.value_namespace = name_space
                                            self.rx_resv_delete_event.value_namespace_prefix = name_space_prefix
                                        if(value_path == "rx-resv-error-event"):
                                            self.rx_resv_error_event = value
                                            self.rx_resv_error_event.value_namespace = name_space
                                            self.rx_resv_error_event.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tx-backup-assign-event"):
                                            self.tx_backup_assign_event = value
                                            self.tx_backup_assign_event.value_namespace = name_space
                                            self.tx_backup_assign_event.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tx-event-unknown"):
                                            self.tx_event_unknown = value
                                            self.tx_event_unknown.value_namespace = name_space
                                            self.tx_event_unknown.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tx-path-change-event"):
                                            self.tx_path_change_event = value
                                            self.tx_path_change_event.value_namespace = name_space
                                            self.tx_path_change_event.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tx-path-create-event"):
                                            self.tx_path_create_event = value
                                            self.tx_path_create_event.value_namespace = name_space
                                            self.tx_path_create_event.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tx-path-delete-event"):
                                            self.tx_path_delete_event = value
                                            self.tx_path_delete_event.value_namespace = name_space
                                            self.tx_path_delete_event.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tx-path-error-event"):
                                            self.tx_path_error_event = value
                                            self.tx_path_error_event.value_namespace = name_space
                                            self.tx_path_error_event.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tx-path-reeval-query-event"):
                                            self.tx_path_reeval_query_event = value
                                            self.tx_path_reeval_query_event.value_namespace = name_space
                                            self.tx_path_reeval_query_event.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tx-resv-change-event"):
                                            self.tx_resv_change_event = value
                                            self.tx_resv_change_event.value_namespace = name_space
                                            self.tx_resv_change_event.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tx-resv-create-event"):
                                            self.tx_resv_create_event = value
                                            self.tx_resv_create_event.value_namespace = name_space
                                            self.tx_resv_create_event.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tx-resv-delete-event"):
                                            self.tx_resv_delete_event = value
                                            self.tx_resv_delete_event.value_namespace = name_space
                                            self.tx_resv_delete_event.value_namespace_prefix = name_space_prefix
                                        if(value_path == "tx-resv-error-event"):
                                            self.tx_resv_error_event = value
                                            self.tx_resv_error_event.value_namespace = name_space
                                            self.tx_resv_error_event.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.destination_address.is_set or
                                        self.sub_group_id.is_set or
                                        self.sub_group_originator.is_set or
                                        (self.statistics is not None and self.statistics.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.destination_address.yfilter != YFilter.not_set or
                                        self.sub_group_id.yfilter != YFilter.not_set or
                                        self.sub_group_originator.yfilter != YFilter.not_set or
                                        (self.statistics is not None and self.statistics.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "s2l-statistic" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.destination_address.get_name_leafdata())
                                    if (self.sub_group_id.is_set or self.sub_group_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.sub_group_id.get_name_leafdata())
                                    if (self.sub_group_originator.is_set or self.sub_group_originator.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.sub_group_originator.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "statistics"):
                                        if (self.statistics is None):
                                            self.statistics = MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic.S2LStatistic.Statistics()
                                            self.statistics.parent = self
                                            self._children_name_map["statistics"] = "statistics"
                                        return self.statistics

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "statistics" or name == "destination-address" or name == "sub-group-id" or name == "sub-group-originator"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "destination-address"):
                                        self.destination_address = value
                                        self.destination_address.value_namespace = name_space
                                        self.destination_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "sub-group-id"):
                                        self.sub_group_id = value
                                        self.sub_group_id.value_namespace = name_space
                                        self.sub_group_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "sub-group-originator"):
                                        self.sub_group_originator = value
                                        self.sub_group_originator.value_namespace = name_space
                                        self.sub_group_originator.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.s2l_statistic:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.destination_address.is_set or
                                    (self.statistics is not None and self.statistics.has_data()))

                            def has_operation(self):
                                for c in self.s2l_statistic:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.destination_address.yfilter != YFilter.not_set or
                                    (self.statistics is not None and self.statistics.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "destination-statistic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.destination_address.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "s2l-statistic"):
                                    for c in self.s2l_statistic:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic.S2LStatistic()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.s2l_statistic.append(c)
                                    return c

                                if (child_yang_name == "statistics"):
                                    if (self.statistics is None):
                                        self.statistics = MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic.Statistics()
                                        self.statistics.parent = self
                                        self._children_name_map["statistics"] = "statistics"
                                    return self.statistics

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "s2l-statistic" or name == "statistics" or name == "destination-address"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "destination-address"):
                                    self.destination_address = value
                                    self.destination_address.value_namespace = name_space
                                    self.destination_address.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.destination_statistic:
                                if (c.has_data()):
                                    return True
                            return (
                                self.lsp_id.is_set or
                                self.tunnel_name.is_set or
                                self.tunnel_sig_name.is_set or
                                (self.statistics is not None and self.statistics.has_data()))

                        def has_operation(self):
                            for c in self.destination_statistic:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.lsp_id.yfilter != YFilter.not_set or
                                self.tunnel_name.yfilter != YFilter.not_set or
                                self.tunnel_sig_name.yfilter != YFilter.not_set or
                                (self.statistics is not None and self.statistics.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "te-signalling-filter-vif" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsp_id.get_name_leafdata())
                            if (self.tunnel_name.is_set or self.tunnel_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tunnel_name.get_name_leafdata())
                            if (self.tunnel_sig_name.is_set or self.tunnel_sig_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tunnel_sig_name.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "destination-statistic"):
                                for c in self.destination_statistic:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.DestinationStatistic()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.destination_statistic.append(c)
                                return c

                            if (child_yang_name == "statistics"):
                                if (self.statistics is None):
                                    self.statistics = MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif.Statistics()
                                    self.statistics.parent = self
                                    self._children_name_map["statistics"] = "statistics"
                                return self.statistics

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "destination-statistic" or name == "statistics" or name == "lsp-id" or name == "tunnel-name" or name == "tunnel-sig-name"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "lsp-id"):
                                self.lsp_id = value
                                self.lsp_id.value_namespace = name_space
                                self.lsp_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "tunnel-name"):
                                self.tunnel_name = value
                                self.tunnel_name.value_namespace = name_space
                                self.tunnel_name.value_namespace_prefix = name_space_prefix
                            if(value_path == "tunnel-sig-name"):
                                self.tunnel_sig_name = value
                                self.tunnel_sig_name.value_namespace = name_space
                                self.tunnel_sig_name.value_namespace_prefix = name_space_prefix


                    class TeSignallingFilterLsp(Entity):
                        """
                        LSP data
                        
                        .. attribute:: s2l_statistic
                        
                        	List of S2L Statistics
                        	**type**\: list of    :py:class:`S2LStatistic <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp.S2LStatistic>`
                        
                        .. attribute:: statistics
                        
                        	LSP statistics
                        	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp.Statistics>`
                        
                        .. attribute:: tunnel_name
                        
                        	Tunnel Name
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp, self).__init__()

                            self.yang_name = "te-signalling-filter-lsp"
                            self.yang_parent_name = "te-signalling-filter-data"

                            self.tunnel_name = YLeaf(YType.str, "tunnel-name")

                            self.statistics = MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp.Statistics()
                            self.statistics.parent = self
                            self._children_name_map["statistics"] = "statistics"
                            self._children_yang_names.add("statistics")

                            self.s2l_statistic = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("tunnel_name") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp, self).__setattr__(name, value)


                        class Statistics(Entity):
                            """
                            LSP statistics
                            
                            .. attribute:: events_count
                            
                            	TE Signaling event count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: events_total_count
                            
                            	Total TE Signalling event count
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_backup_assign_err_event
                            
                            	Error on Backup Assign event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_event_unknown
                            
                            	RX Unknown events
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_path_change_event
                            
                            	RX Path Change event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_path_create_event
                            
                            	RX Path Create event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_path_delete_event
                            
                            	RX Path Delete event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_path_error_event
                            
                            	RX Path Error event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_path_reeval_query_event
                            
                            	RX Path Reeval Query event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_resv_change_event
                            
                            	RX Resv Change event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_resv_create_event
                            
                            	RX Resv Create event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_resv_delete_event
                            
                            	RX Resv Delete event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: rx_resv_error_event
                            
                            	RX Resv Error event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_backup_assign_event
                            
                            	Backup Assign event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_event_unknown
                            
                            	Unknown TX events
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_path_change_event
                            
                            	TX Path Change event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_path_create_event
                            
                            	TX Path Create event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_path_delete_event
                            
                            	TX Path Delete event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_path_error_event
                            
                            	TX Path Error event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_path_reeval_query_event
                            
                            	TX Path Reeval Query event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_resv_change_event
                            
                            	TX Resv Change event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_resv_create_event
                            
                            	TX Resv Create event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_resv_delete_event
                            
                            	TX Resv Delete event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: tx_resv_error_event
                            
                            	TX Resv Error event
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp.Statistics, self).__init__()

                                self.yang_name = "statistics"
                                self.yang_parent_name = "te-signalling-filter-lsp"

                                self.events_count = YLeaf(YType.uint32, "events-count")

                                self.events_total_count = YLeaf(YType.uint32, "events-total-count")

                                self.rx_backup_assign_err_event = YLeaf(YType.uint32, "rx-backup-assign-err-event")

                                self.rx_event_unknown = YLeaf(YType.uint32, "rx-event-unknown")

                                self.rx_path_change_event = YLeaf(YType.uint32, "rx-path-change-event")

                                self.rx_path_create_event = YLeaf(YType.uint32, "rx-path-create-event")

                                self.rx_path_delete_event = YLeaf(YType.uint32, "rx-path-delete-event")

                                self.rx_path_error_event = YLeaf(YType.uint32, "rx-path-error-event")

                                self.rx_path_reeval_query_event = YLeaf(YType.uint32, "rx-path-reeval-query-event")

                                self.rx_resv_change_event = YLeaf(YType.uint32, "rx-resv-change-event")

                                self.rx_resv_create_event = YLeaf(YType.uint32, "rx-resv-create-event")

                                self.rx_resv_delete_event = YLeaf(YType.uint32, "rx-resv-delete-event")

                                self.rx_resv_error_event = YLeaf(YType.uint32, "rx-resv-error-event")

                                self.tx_backup_assign_event = YLeaf(YType.uint32, "tx-backup-assign-event")

                                self.tx_event_unknown = YLeaf(YType.uint32, "tx-event-unknown")

                                self.tx_path_change_event = YLeaf(YType.uint32, "tx-path-change-event")

                                self.tx_path_create_event = YLeaf(YType.uint32, "tx-path-create-event")

                                self.tx_path_delete_event = YLeaf(YType.uint32, "tx-path-delete-event")

                                self.tx_path_error_event = YLeaf(YType.uint32, "tx-path-error-event")

                                self.tx_path_reeval_query_event = YLeaf(YType.uint32, "tx-path-reeval-query-event")

                                self.tx_resv_change_event = YLeaf(YType.uint32, "tx-resv-change-event")

                                self.tx_resv_create_event = YLeaf(YType.uint32, "tx-resv-create-event")

                                self.tx_resv_delete_event = YLeaf(YType.uint32, "tx-resv-delete-event")

                                self.tx_resv_error_event = YLeaf(YType.uint32, "tx-resv-error-event")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("events_count",
                                                "events_total_count",
                                                "rx_backup_assign_err_event",
                                                "rx_event_unknown",
                                                "rx_path_change_event",
                                                "rx_path_create_event",
                                                "rx_path_delete_event",
                                                "rx_path_error_event",
                                                "rx_path_reeval_query_event",
                                                "rx_resv_change_event",
                                                "rx_resv_create_event",
                                                "rx_resv_delete_event",
                                                "rx_resv_error_event",
                                                "tx_backup_assign_event",
                                                "tx_event_unknown",
                                                "tx_path_change_event",
                                                "tx_path_create_event",
                                                "tx_path_delete_event",
                                                "tx_path_error_event",
                                                "tx_path_reeval_query_event",
                                                "tx_resv_change_event",
                                                "tx_resv_create_event",
                                                "tx_resv_delete_event",
                                                "tx_resv_error_event") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp.Statistics, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp.Statistics, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.events_count.is_set or
                                    self.events_total_count.is_set or
                                    self.rx_backup_assign_err_event.is_set or
                                    self.rx_event_unknown.is_set or
                                    self.rx_path_change_event.is_set or
                                    self.rx_path_create_event.is_set or
                                    self.rx_path_delete_event.is_set or
                                    self.rx_path_error_event.is_set or
                                    self.rx_path_reeval_query_event.is_set or
                                    self.rx_resv_change_event.is_set or
                                    self.rx_resv_create_event.is_set or
                                    self.rx_resv_delete_event.is_set or
                                    self.rx_resv_error_event.is_set or
                                    self.tx_backup_assign_event.is_set or
                                    self.tx_event_unknown.is_set or
                                    self.tx_path_change_event.is_set or
                                    self.tx_path_create_event.is_set or
                                    self.tx_path_delete_event.is_set or
                                    self.tx_path_error_event.is_set or
                                    self.tx_path_reeval_query_event.is_set or
                                    self.tx_resv_change_event.is_set or
                                    self.tx_resv_create_event.is_set or
                                    self.tx_resv_delete_event.is_set or
                                    self.tx_resv_error_event.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.events_count.yfilter != YFilter.not_set or
                                    self.events_total_count.yfilter != YFilter.not_set or
                                    self.rx_backup_assign_err_event.yfilter != YFilter.not_set or
                                    self.rx_event_unknown.yfilter != YFilter.not_set or
                                    self.rx_path_change_event.yfilter != YFilter.not_set or
                                    self.rx_path_create_event.yfilter != YFilter.not_set or
                                    self.rx_path_delete_event.yfilter != YFilter.not_set or
                                    self.rx_path_error_event.yfilter != YFilter.not_set or
                                    self.rx_path_reeval_query_event.yfilter != YFilter.not_set or
                                    self.rx_resv_change_event.yfilter != YFilter.not_set or
                                    self.rx_resv_create_event.yfilter != YFilter.not_set or
                                    self.rx_resv_delete_event.yfilter != YFilter.not_set or
                                    self.rx_resv_error_event.yfilter != YFilter.not_set or
                                    self.tx_backup_assign_event.yfilter != YFilter.not_set or
                                    self.tx_event_unknown.yfilter != YFilter.not_set or
                                    self.tx_path_change_event.yfilter != YFilter.not_set or
                                    self.tx_path_create_event.yfilter != YFilter.not_set or
                                    self.tx_path_delete_event.yfilter != YFilter.not_set or
                                    self.tx_path_error_event.yfilter != YFilter.not_set or
                                    self.tx_path_reeval_query_event.yfilter != YFilter.not_set or
                                    self.tx_resv_change_event.yfilter != YFilter.not_set or
                                    self.tx_resv_create_event.yfilter != YFilter.not_set or
                                    self.tx_resv_delete_event.yfilter != YFilter.not_set or
                                    self.tx_resv_error_event.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "statistics" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.events_count.is_set or self.events_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.events_count.get_name_leafdata())
                                if (self.events_total_count.is_set or self.events_total_count.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.events_total_count.get_name_leafdata())
                                if (self.rx_backup_assign_err_event.is_set or self.rx_backup_assign_err_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_backup_assign_err_event.get_name_leafdata())
                                if (self.rx_event_unknown.is_set or self.rx_event_unknown.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_event_unknown.get_name_leafdata())
                                if (self.rx_path_change_event.is_set or self.rx_path_change_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_path_change_event.get_name_leafdata())
                                if (self.rx_path_create_event.is_set or self.rx_path_create_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_path_create_event.get_name_leafdata())
                                if (self.rx_path_delete_event.is_set or self.rx_path_delete_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_path_delete_event.get_name_leafdata())
                                if (self.rx_path_error_event.is_set or self.rx_path_error_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_path_error_event.get_name_leafdata())
                                if (self.rx_path_reeval_query_event.is_set or self.rx_path_reeval_query_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_path_reeval_query_event.get_name_leafdata())
                                if (self.rx_resv_change_event.is_set or self.rx_resv_change_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_resv_change_event.get_name_leafdata())
                                if (self.rx_resv_create_event.is_set or self.rx_resv_create_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_resv_create_event.get_name_leafdata())
                                if (self.rx_resv_delete_event.is_set or self.rx_resv_delete_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_resv_delete_event.get_name_leafdata())
                                if (self.rx_resv_error_event.is_set or self.rx_resv_error_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rx_resv_error_event.get_name_leafdata())
                                if (self.tx_backup_assign_event.is_set or self.tx_backup_assign_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_backup_assign_event.get_name_leafdata())
                                if (self.tx_event_unknown.is_set or self.tx_event_unknown.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_event_unknown.get_name_leafdata())
                                if (self.tx_path_change_event.is_set or self.tx_path_change_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_path_change_event.get_name_leafdata())
                                if (self.tx_path_create_event.is_set or self.tx_path_create_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_path_create_event.get_name_leafdata())
                                if (self.tx_path_delete_event.is_set or self.tx_path_delete_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_path_delete_event.get_name_leafdata())
                                if (self.tx_path_error_event.is_set or self.tx_path_error_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_path_error_event.get_name_leafdata())
                                if (self.tx_path_reeval_query_event.is_set or self.tx_path_reeval_query_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_path_reeval_query_event.get_name_leafdata())
                                if (self.tx_resv_change_event.is_set or self.tx_resv_change_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_resv_change_event.get_name_leafdata())
                                if (self.tx_resv_create_event.is_set or self.tx_resv_create_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_resv_create_event.get_name_leafdata())
                                if (self.tx_resv_delete_event.is_set or self.tx_resv_delete_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_resv_delete_event.get_name_leafdata())
                                if (self.tx_resv_error_event.is_set or self.tx_resv_error_event.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tx_resv_error_event.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "events-count" or name == "events-total-count" or name == "rx-backup-assign-err-event" or name == "rx-event-unknown" or name == "rx-path-change-event" or name == "rx-path-create-event" or name == "rx-path-delete-event" or name == "rx-path-error-event" or name == "rx-path-reeval-query-event" or name == "rx-resv-change-event" or name == "rx-resv-create-event" or name == "rx-resv-delete-event" or name == "rx-resv-error-event" or name == "tx-backup-assign-event" or name == "tx-event-unknown" or name == "tx-path-change-event" or name == "tx-path-create-event" or name == "tx-path-delete-event" or name == "tx-path-error-event" or name == "tx-path-reeval-query-event" or name == "tx-resv-change-event" or name == "tx-resv-create-event" or name == "tx-resv-delete-event" or name == "tx-resv-error-event"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "events-count"):
                                    self.events_count = value
                                    self.events_count.value_namespace = name_space
                                    self.events_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "events-total-count"):
                                    self.events_total_count = value
                                    self.events_total_count.value_namespace = name_space
                                    self.events_total_count.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-backup-assign-err-event"):
                                    self.rx_backup_assign_err_event = value
                                    self.rx_backup_assign_err_event.value_namespace = name_space
                                    self.rx_backup_assign_err_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-event-unknown"):
                                    self.rx_event_unknown = value
                                    self.rx_event_unknown.value_namespace = name_space
                                    self.rx_event_unknown.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-path-change-event"):
                                    self.rx_path_change_event = value
                                    self.rx_path_change_event.value_namespace = name_space
                                    self.rx_path_change_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-path-create-event"):
                                    self.rx_path_create_event = value
                                    self.rx_path_create_event.value_namespace = name_space
                                    self.rx_path_create_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-path-delete-event"):
                                    self.rx_path_delete_event = value
                                    self.rx_path_delete_event.value_namespace = name_space
                                    self.rx_path_delete_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-path-error-event"):
                                    self.rx_path_error_event = value
                                    self.rx_path_error_event.value_namespace = name_space
                                    self.rx_path_error_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-path-reeval-query-event"):
                                    self.rx_path_reeval_query_event = value
                                    self.rx_path_reeval_query_event.value_namespace = name_space
                                    self.rx_path_reeval_query_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-resv-change-event"):
                                    self.rx_resv_change_event = value
                                    self.rx_resv_change_event.value_namespace = name_space
                                    self.rx_resv_change_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-resv-create-event"):
                                    self.rx_resv_create_event = value
                                    self.rx_resv_create_event.value_namespace = name_space
                                    self.rx_resv_create_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-resv-delete-event"):
                                    self.rx_resv_delete_event = value
                                    self.rx_resv_delete_event.value_namespace = name_space
                                    self.rx_resv_delete_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "rx-resv-error-event"):
                                    self.rx_resv_error_event = value
                                    self.rx_resv_error_event.value_namespace = name_space
                                    self.rx_resv_error_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-backup-assign-event"):
                                    self.tx_backup_assign_event = value
                                    self.tx_backup_assign_event.value_namespace = name_space
                                    self.tx_backup_assign_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-event-unknown"):
                                    self.tx_event_unknown = value
                                    self.tx_event_unknown.value_namespace = name_space
                                    self.tx_event_unknown.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-path-change-event"):
                                    self.tx_path_change_event = value
                                    self.tx_path_change_event.value_namespace = name_space
                                    self.tx_path_change_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-path-create-event"):
                                    self.tx_path_create_event = value
                                    self.tx_path_create_event.value_namespace = name_space
                                    self.tx_path_create_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-path-delete-event"):
                                    self.tx_path_delete_event = value
                                    self.tx_path_delete_event.value_namespace = name_space
                                    self.tx_path_delete_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-path-error-event"):
                                    self.tx_path_error_event = value
                                    self.tx_path_error_event.value_namespace = name_space
                                    self.tx_path_error_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-path-reeval-query-event"):
                                    self.tx_path_reeval_query_event = value
                                    self.tx_path_reeval_query_event.value_namespace = name_space
                                    self.tx_path_reeval_query_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-resv-change-event"):
                                    self.tx_resv_change_event = value
                                    self.tx_resv_change_event.value_namespace = name_space
                                    self.tx_resv_change_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-resv-create-event"):
                                    self.tx_resv_create_event = value
                                    self.tx_resv_create_event.value_namespace = name_space
                                    self.tx_resv_create_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-resv-delete-event"):
                                    self.tx_resv_delete_event = value
                                    self.tx_resv_delete_event.value_namespace = name_space
                                    self.tx_resv_delete_event.value_namespace_prefix = name_space_prefix
                                if(value_path == "tx-resv-error-event"):
                                    self.tx_resv_error_event = value
                                    self.tx_resv_error_event.value_namespace = name_space
                                    self.tx_resv_error_event.value_namespace_prefix = name_space_prefix


                        class S2LStatistic(Entity):
                            """
                            List of S2L Statistics
                            
                            .. attribute:: destination_address
                            
                            	Destination address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: statistics
                            
                            	S2L stats
                            	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp.S2LStatistic.Statistics>`
                            
                            .. attribute:: sub_group_id
                            
                            	subgroup ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: sub_group_originator
                            
                            	Subgroup Originator
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp.S2LStatistic, self).__init__()

                                self.yang_name = "s2l-statistic"
                                self.yang_parent_name = "te-signalling-filter-lsp"

                                self.destination_address = YLeaf(YType.str, "destination-address")

                                self.sub_group_id = YLeaf(YType.uint16, "sub-group-id")

                                self.sub_group_originator = YLeaf(YType.str, "sub-group-originator")

                                self.statistics = MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp.S2LStatistic.Statistics()
                                self.statistics.parent = self
                                self._children_name_map["statistics"] = "statistics"
                                self._children_yang_names.add("statistics")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("destination_address",
                                                "sub_group_id",
                                                "sub_group_originator") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp.S2LStatistic, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp.S2LStatistic, self).__setattr__(name, value)


                            class Statistics(Entity):
                                """
                                S2L stats
                                
                                .. attribute:: events_count
                                
                                	TE Signaling event count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: events_total_count
                                
                                	Total TE Signalling event count
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: rx_backup_assign_err_event
                                
                                	Error on Backup Assign event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: rx_event_unknown
                                
                                	RX Unknown events
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: rx_path_change_event
                                
                                	RX Path Change event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: rx_path_create_event
                                
                                	RX Path Create event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: rx_path_delete_event
                                
                                	RX Path Delete event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: rx_path_error_event
                                
                                	RX Path Error event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: rx_path_reeval_query_event
                                
                                	RX Path Reeval Query event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: rx_resv_change_event
                                
                                	RX Resv Change event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: rx_resv_create_event
                                
                                	RX Resv Create event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: rx_resv_delete_event
                                
                                	RX Resv Delete event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: rx_resv_error_event
                                
                                	RX Resv Error event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tx_backup_assign_event
                                
                                	Backup Assign event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tx_event_unknown
                                
                                	Unknown TX events
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tx_path_change_event
                                
                                	TX Path Change event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tx_path_create_event
                                
                                	TX Path Create event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tx_path_delete_event
                                
                                	TX Path Delete event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tx_path_error_event
                                
                                	TX Path Error event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tx_path_reeval_query_event
                                
                                	TX Path Reeval Query event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tx_resv_change_event
                                
                                	TX Resv Change event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tx_resv_create_event
                                
                                	TX Resv Create event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tx_resv_delete_event
                                
                                	TX Resv Delete event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: tx_resv_error_event
                                
                                	TX Resv Error event
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp.S2LStatistic.Statistics, self).__init__()

                                    self.yang_name = "statistics"
                                    self.yang_parent_name = "s2l-statistic"

                                    self.events_count = YLeaf(YType.uint32, "events-count")

                                    self.events_total_count = YLeaf(YType.uint32, "events-total-count")

                                    self.rx_backup_assign_err_event = YLeaf(YType.uint32, "rx-backup-assign-err-event")

                                    self.rx_event_unknown = YLeaf(YType.uint32, "rx-event-unknown")

                                    self.rx_path_change_event = YLeaf(YType.uint32, "rx-path-change-event")

                                    self.rx_path_create_event = YLeaf(YType.uint32, "rx-path-create-event")

                                    self.rx_path_delete_event = YLeaf(YType.uint32, "rx-path-delete-event")

                                    self.rx_path_error_event = YLeaf(YType.uint32, "rx-path-error-event")

                                    self.rx_path_reeval_query_event = YLeaf(YType.uint32, "rx-path-reeval-query-event")

                                    self.rx_resv_change_event = YLeaf(YType.uint32, "rx-resv-change-event")

                                    self.rx_resv_create_event = YLeaf(YType.uint32, "rx-resv-create-event")

                                    self.rx_resv_delete_event = YLeaf(YType.uint32, "rx-resv-delete-event")

                                    self.rx_resv_error_event = YLeaf(YType.uint32, "rx-resv-error-event")

                                    self.tx_backup_assign_event = YLeaf(YType.uint32, "tx-backup-assign-event")

                                    self.tx_event_unknown = YLeaf(YType.uint32, "tx-event-unknown")

                                    self.tx_path_change_event = YLeaf(YType.uint32, "tx-path-change-event")

                                    self.tx_path_create_event = YLeaf(YType.uint32, "tx-path-create-event")

                                    self.tx_path_delete_event = YLeaf(YType.uint32, "tx-path-delete-event")

                                    self.tx_path_error_event = YLeaf(YType.uint32, "tx-path-error-event")

                                    self.tx_path_reeval_query_event = YLeaf(YType.uint32, "tx-path-reeval-query-event")

                                    self.tx_resv_change_event = YLeaf(YType.uint32, "tx-resv-change-event")

                                    self.tx_resv_create_event = YLeaf(YType.uint32, "tx-resv-create-event")

                                    self.tx_resv_delete_event = YLeaf(YType.uint32, "tx-resv-delete-event")

                                    self.tx_resv_error_event = YLeaf(YType.uint32, "tx-resv-error-event")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("events_count",
                                                    "events_total_count",
                                                    "rx_backup_assign_err_event",
                                                    "rx_event_unknown",
                                                    "rx_path_change_event",
                                                    "rx_path_create_event",
                                                    "rx_path_delete_event",
                                                    "rx_path_error_event",
                                                    "rx_path_reeval_query_event",
                                                    "rx_resv_change_event",
                                                    "rx_resv_create_event",
                                                    "rx_resv_delete_event",
                                                    "rx_resv_error_event",
                                                    "tx_backup_assign_event",
                                                    "tx_event_unknown",
                                                    "tx_path_change_event",
                                                    "tx_path_create_event",
                                                    "tx_path_delete_event",
                                                    "tx_path_error_event",
                                                    "tx_path_reeval_query_event",
                                                    "tx_resv_change_event",
                                                    "tx_resv_create_event",
                                                    "tx_resv_delete_event",
                                                    "tx_resv_error_event") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp.S2LStatistic.Statistics, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp.S2LStatistic.Statistics, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.events_count.is_set or
                                        self.events_total_count.is_set or
                                        self.rx_backup_assign_err_event.is_set or
                                        self.rx_event_unknown.is_set or
                                        self.rx_path_change_event.is_set or
                                        self.rx_path_create_event.is_set or
                                        self.rx_path_delete_event.is_set or
                                        self.rx_path_error_event.is_set or
                                        self.rx_path_reeval_query_event.is_set or
                                        self.rx_resv_change_event.is_set or
                                        self.rx_resv_create_event.is_set or
                                        self.rx_resv_delete_event.is_set or
                                        self.rx_resv_error_event.is_set or
                                        self.tx_backup_assign_event.is_set or
                                        self.tx_event_unknown.is_set or
                                        self.tx_path_change_event.is_set or
                                        self.tx_path_create_event.is_set or
                                        self.tx_path_delete_event.is_set or
                                        self.tx_path_error_event.is_set or
                                        self.tx_path_reeval_query_event.is_set or
                                        self.tx_resv_change_event.is_set or
                                        self.tx_resv_create_event.is_set or
                                        self.tx_resv_delete_event.is_set or
                                        self.tx_resv_error_event.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.events_count.yfilter != YFilter.not_set or
                                        self.events_total_count.yfilter != YFilter.not_set or
                                        self.rx_backup_assign_err_event.yfilter != YFilter.not_set or
                                        self.rx_event_unknown.yfilter != YFilter.not_set or
                                        self.rx_path_change_event.yfilter != YFilter.not_set or
                                        self.rx_path_create_event.yfilter != YFilter.not_set or
                                        self.rx_path_delete_event.yfilter != YFilter.not_set or
                                        self.rx_path_error_event.yfilter != YFilter.not_set or
                                        self.rx_path_reeval_query_event.yfilter != YFilter.not_set or
                                        self.rx_resv_change_event.yfilter != YFilter.not_set or
                                        self.rx_resv_create_event.yfilter != YFilter.not_set or
                                        self.rx_resv_delete_event.yfilter != YFilter.not_set or
                                        self.rx_resv_error_event.yfilter != YFilter.not_set or
                                        self.tx_backup_assign_event.yfilter != YFilter.not_set or
                                        self.tx_event_unknown.yfilter != YFilter.not_set or
                                        self.tx_path_change_event.yfilter != YFilter.not_set or
                                        self.tx_path_create_event.yfilter != YFilter.not_set or
                                        self.tx_path_delete_event.yfilter != YFilter.not_set or
                                        self.tx_path_error_event.yfilter != YFilter.not_set or
                                        self.tx_path_reeval_query_event.yfilter != YFilter.not_set or
                                        self.tx_resv_change_event.yfilter != YFilter.not_set or
                                        self.tx_resv_create_event.yfilter != YFilter.not_set or
                                        self.tx_resv_delete_event.yfilter != YFilter.not_set or
                                        self.tx_resv_error_event.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "statistics" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.events_count.is_set or self.events_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.events_count.get_name_leafdata())
                                    if (self.events_total_count.is_set or self.events_total_count.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.events_total_count.get_name_leafdata())
                                    if (self.rx_backup_assign_err_event.is_set or self.rx_backup_assign_err_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rx_backup_assign_err_event.get_name_leafdata())
                                    if (self.rx_event_unknown.is_set or self.rx_event_unknown.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rx_event_unknown.get_name_leafdata())
                                    if (self.rx_path_change_event.is_set or self.rx_path_change_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rx_path_change_event.get_name_leafdata())
                                    if (self.rx_path_create_event.is_set or self.rx_path_create_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rx_path_create_event.get_name_leafdata())
                                    if (self.rx_path_delete_event.is_set or self.rx_path_delete_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rx_path_delete_event.get_name_leafdata())
                                    if (self.rx_path_error_event.is_set or self.rx_path_error_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rx_path_error_event.get_name_leafdata())
                                    if (self.rx_path_reeval_query_event.is_set or self.rx_path_reeval_query_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rx_path_reeval_query_event.get_name_leafdata())
                                    if (self.rx_resv_change_event.is_set or self.rx_resv_change_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rx_resv_change_event.get_name_leafdata())
                                    if (self.rx_resv_create_event.is_set or self.rx_resv_create_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rx_resv_create_event.get_name_leafdata())
                                    if (self.rx_resv_delete_event.is_set or self.rx_resv_delete_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rx_resv_delete_event.get_name_leafdata())
                                    if (self.rx_resv_error_event.is_set or self.rx_resv_error_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.rx_resv_error_event.get_name_leafdata())
                                    if (self.tx_backup_assign_event.is_set or self.tx_backup_assign_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tx_backup_assign_event.get_name_leafdata())
                                    if (self.tx_event_unknown.is_set or self.tx_event_unknown.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tx_event_unknown.get_name_leafdata())
                                    if (self.tx_path_change_event.is_set or self.tx_path_change_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tx_path_change_event.get_name_leafdata())
                                    if (self.tx_path_create_event.is_set or self.tx_path_create_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tx_path_create_event.get_name_leafdata())
                                    if (self.tx_path_delete_event.is_set or self.tx_path_delete_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tx_path_delete_event.get_name_leafdata())
                                    if (self.tx_path_error_event.is_set or self.tx_path_error_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tx_path_error_event.get_name_leafdata())
                                    if (self.tx_path_reeval_query_event.is_set or self.tx_path_reeval_query_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tx_path_reeval_query_event.get_name_leafdata())
                                    if (self.tx_resv_change_event.is_set or self.tx_resv_change_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tx_resv_change_event.get_name_leafdata())
                                    if (self.tx_resv_create_event.is_set or self.tx_resv_create_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tx_resv_create_event.get_name_leafdata())
                                    if (self.tx_resv_delete_event.is_set or self.tx_resv_delete_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tx_resv_delete_event.get_name_leafdata())
                                    if (self.tx_resv_error_event.is_set or self.tx_resv_error_event.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tx_resv_error_event.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "events-count" or name == "events-total-count" or name == "rx-backup-assign-err-event" or name == "rx-event-unknown" or name == "rx-path-change-event" or name == "rx-path-create-event" or name == "rx-path-delete-event" or name == "rx-path-error-event" or name == "rx-path-reeval-query-event" or name == "rx-resv-change-event" or name == "rx-resv-create-event" or name == "rx-resv-delete-event" or name == "rx-resv-error-event" or name == "tx-backup-assign-event" or name == "tx-event-unknown" or name == "tx-path-change-event" or name == "tx-path-create-event" or name == "tx-path-delete-event" or name == "tx-path-error-event" or name == "tx-path-reeval-query-event" or name == "tx-resv-change-event" or name == "tx-resv-create-event" or name == "tx-resv-delete-event" or name == "tx-resv-error-event"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "events-count"):
                                        self.events_count = value
                                        self.events_count.value_namespace = name_space
                                        self.events_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "events-total-count"):
                                        self.events_total_count = value
                                        self.events_total_count.value_namespace = name_space
                                        self.events_total_count.value_namespace_prefix = name_space_prefix
                                    if(value_path == "rx-backup-assign-err-event"):
                                        self.rx_backup_assign_err_event = value
                                        self.rx_backup_assign_err_event.value_namespace = name_space
                                        self.rx_backup_assign_err_event.value_namespace_prefix = name_space_prefix
                                    if(value_path == "rx-event-unknown"):
                                        self.rx_event_unknown = value
                                        self.rx_event_unknown.value_namespace = name_space
                                        self.rx_event_unknown.value_namespace_prefix = name_space_prefix
                                    if(value_path == "rx-path-change-event"):
                                        self.rx_path_change_event = value
                                        self.rx_path_change_event.value_namespace = name_space
                                        self.rx_path_change_event.value_namespace_prefix = name_space_prefix
                                    if(value_path == "rx-path-create-event"):
                                        self.rx_path_create_event = value
                                        self.rx_path_create_event.value_namespace = name_space
                                        self.rx_path_create_event.value_namespace_prefix = name_space_prefix
                                    if(value_path == "rx-path-delete-event"):
                                        self.rx_path_delete_event = value
                                        self.rx_path_delete_event.value_namespace = name_space
                                        self.rx_path_delete_event.value_namespace_prefix = name_space_prefix
                                    if(value_path == "rx-path-error-event"):
                                        self.rx_path_error_event = value
                                        self.rx_path_error_event.value_namespace = name_space
                                        self.rx_path_error_event.value_namespace_prefix = name_space_prefix
                                    if(value_path == "rx-path-reeval-query-event"):
                                        self.rx_path_reeval_query_event = value
                                        self.rx_path_reeval_query_event.value_namespace = name_space
                                        self.rx_path_reeval_query_event.value_namespace_prefix = name_space_prefix
                                    if(value_path == "rx-resv-change-event"):
                                        self.rx_resv_change_event = value
                                        self.rx_resv_change_event.value_namespace = name_space
                                        self.rx_resv_change_event.value_namespace_prefix = name_space_prefix
                                    if(value_path == "rx-resv-create-event"):
                                        self.rx_resv_create_event = value
                                        self.rx_resv_create_event.value_namespace = name_space
                                        self.rx_resv_create_event.value_namespace_prefix = name_space_prefix
                                    if(value_path == "rx-resv-delete-event"):
                                        self.rx_resv_delete_event = value
                                        self.rx_resv_delete_event.value_namespace = name_space
                                        self.rx_resv_delete_event.value_namespace_prefix = name_space_prefix
                                    if(value_path == "rx-resv-error-event"):
                                        self.rx_resv_error_event = value
                                        self.rx_resv_error_event.value_namespace = name_space
                                        self.rx_resv_error_event.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tx-backup-assign-event"):
                                        self.tx_backup_assign_event = value
                                        self.tx_backup_assign_event.value_namespace = name_space
                                        self.tx_backup_assign_event.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tx-event-unknown"):
                                        self.tx_event_unknown = value
                                        self.tx_event_unknown.value_namespace = name_space
                                        self.tx_event_unknown.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tx-path-change-event"):
                                        self.tx_path_change_event = value
                                        self.tx_path_change_event.value_namespace = name_space
                                        self.tx_path_change_event.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tx-path-create-event"):
                                        self.tx_path_create_event = value
                                        self.tx_path_create_event.value_namespace = name_space
                                        self.tx_path_create_event.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tx-path-delete-event"):
                                        self.tx_path_delete_event = value
                                        self.tx_path_delete_event.value_namespace = name_space
                                        self.tx_path_delete_event.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tx-path-error-event"):
                                        self.tx_path_error_event = value
                                        self.tx_path_error_event.value_namespace = name_space
                                        self.tx_path_error_event.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tx-path-reeval-query-event"):
                                        self.tx_path_reeval_query_event = value
                                        self.tx_path_reeval_query_event.value_namespace = name_space
                                        self.tx_path_reeval_query_event.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tx-resv-change-event"):
                                        self.tx_resv_change_event = value
                                        self.tx_resv_change_event.value_namespace = name_space
                                        self.tx_resv_change_event.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tx-resv-create-event"):
                                        self.tx_resv_create_event = value
                                        self.tx_resv_create_event.value_namespace = name_space
                                        self.tx_resv_create_event.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tx-resv-delete-event"):
                                        self.tx_resv_delete_event = value
                                        self.tx_resv_delete_event.value_namespace = name_space
                                        self.tx_resv_delete_event.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tx-resv-error-event"):
                                        self.tx_resv_error_event = value
                                        self.tx_resv_error_event.value_namespace = name_space
                                        self.tx_resv_error_event.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.destination_address.is_set or
                                    self.sub_group_id.is_set or
                                    self.sub_group_originator.is_set or
                                    (self.statistics is not None and self.statistics.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.destination_address.yfilter != YFilter.not_set or
                                    self.sub_group_id.yfilter != YFilter.not_set or
                                    self.sub_group_originator.yfilter != YFilter.not_set or
                                    (self.statistics is not None and self.statistics.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-statistic" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.destination_address.get_name_leafdata())
                                if (self.sub_group_id.is_set or self.sub_group_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.sub_group_id.get_name_leafdata())
                                if (self.sub_group_originator.is_set or self.sub_group_originator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.sub_group_originator.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "statistics"):
                                    if (self.statistics is None):
                                        self.statistics = MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp.S2LStatistic.Statistics()
                                        self.statistics.parent = self
                                        self._children_name_map["statistics"] = "statistics"
                                    return self.statistics

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "statistics" or name == "destination-address" or name == "sub-group-id" or name == "sub-group-originator"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "destination-address"):
                                    self.destination_address = value
                                    self.destination_address.value_namespace = name_space
                                    self.destination_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "sub-group-id"):
                                    self.sub_group_id = value
                                    self.sub_group_id.value_namespace = name_space
                                    self.sub_group_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "sub-group-originator"):
                                    self.sub_group_originator = value
                                    self.sub_group_originator.value_namespace = name_space
                                    self.sub_group_originator.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.s2l_statistic:
                                if (c.has_data()):
                                    return True
                            return (
                                self.tunnel_name.is_set or
                                (self.statistics is not None and self.statistics.has_data()))

                        def has_operation(self):
                            for c in self.s2l_statistic:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.tunnel_name.yfilter != YFilter.not_set or
                                (self.statistics is not None and self.statistics.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "te-signalling-filter-lsp" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.tunnel_name.is_set or self.tunnel_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tunnel_name.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "s2l-statistic"):
                                for c in self.s2l_statistic:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp.S2LStatistic()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.s2l_statistic.append(c)
                                return c

                            if (child_yang_name == "statistics"):
                                if (self.statistics is None):
                                    self.statistics = MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp.Statistics()
                                    self.statistics.parent = self
                                    self._children_name_map["statistics"] = "statistics"
                                return self.statistics

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "s2l-statistic" or name == "statistics" or name == "tunnel-name"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "tunnel-name"):
                                self.tunnel_name = value
                                self.tunnel_name.value_namespace = name_space
                                self.tunnel_name.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.statistics_filter.is_set or
                            (self.te_signalling_filter_lsp is not None and self.te_signalling_filter_lsp.has_data()) or
                            (self.te_signalling_filter_vif is not None and self.te_signalling_filter_vif.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.statistics_filter.yfilter != YFilter.not_set or
                            (self.te_signalling_filter_lsp is not None and self.te_signalling_filter_lsp.has_operation()) or
                            (self.te_signalling_filter_vif is not None and self.te_signalling_filter_vif.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "te-signalling-filter-data" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.statistics_filter.is_set or self.statistics_filter.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.statistics_filter.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "te-signalling-filter-lsp"):
                            if (self.te_signalling_filter_lsp is None):
                                self.te_signalling_filter_lsp = MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterLsp()
                                self.te_signalling_filter_lsp.parent = self
                                self._children_name_map["te_signalling_filter_lsp"] = "te-signalling-filter-lsp"
                            return self.te_signalling_filter_lsp

                        if (child_yang_name == "te-signalling-filter-vif"):
                            if (self.te_signalling_filter_vif is None):
                                self.te_signalling_filter_vif = MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData.TeSignallingFilterVif()
                                self.te_signalling_filter_vif.parent = self
                                self._children_name_map["te_signalling_filter_vif"] = "te-signalling-filter-vif"
                            return self.te_signalling_filter_vif

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "te-signalling-filter-lsp" or name == "te-signalling-filter-vif" or name == "statistics-filter"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "statistics-filter"):
                            self.statistics_filter = value
                            self.statistics_filter.value_namespace = name_space
                            self.statistics_filter.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    return (
                        self.ctype.is_set or
                        self.tunnel_id.is_set or
                        self.extended_tunnel_id.is_set or
                        self.p2mp_id.is_set or
                        self.lsp_id.is_set or
                        self.source_address.is_set or
                        self.destination_address.is_set or
                        self.sub_group_originator.is_set or
                        self.sub_group_id.is_set or
                        (self.te_signalling_filter_data is not None and self.te_signalling_filter_data.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.ctype.yfilter != YFilter.not_set or
                        self.tunnel_id.yfilter != YFilter.not_set or
                        self.extended_tunnel_id.yfilter != YFilter.not_set or
                        self.p2mp_id.yfilter != YFilter.not_set or
                        self.lsp_id.yfilter != YFilter.not_set or
                        self.source_address.yfilter != YFilter.not_set or
                        self.destination_address.yfilter != YFilter.not_set or
                        self.sub_group_originator.yfilter != YFilter.not_set or
                        self.sub_group_id.yfilter != YFilter.not_set or
                        (self.te_signalling_filter_data is not None and self.te_signalling_filter_data.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "signalling" + "[ctype='" + self.ctype.get() + "']" + "[tunnel-id='" + self.tunnel_id.get() + "']" + "[extended-tunnel-id='" + self.extended_tunnel_id.get() + "']" + "[p2mp-id='" + self.p2mp_id.get() + "']" + "[lsp-id='" + self.lsp_id.get() + "']" + "[source-address='" + self.source_address.get() + "']" + "[destination-address='" + self.destination_address.get() + "']" + "[sub-group-originator='" + self.sub_group_originator.get() + "']" + "[sub-group-id='" + self.sub_group_id.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/signalling-counters/signallings/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.ctype.is_set or self.ctype.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.ctype.get_name_leafdata())
                    if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_id.get_name_leafdata())
                    if (self.extended_tunnel_id.is_set or self.extended_tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.extended_tunnel_id.get_name_leafdata())
                    if (self.p2mp_id.is_set or self.p2mp_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.p2mp_id.get_name_leafdata())
                    if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.lsp_id.get_name_leafdata())
                    if (self.source_address.is_set or self.source_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.source_address.get_name_leafdata())
                    if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.destination_address.get_name_leafdata())
                    if (self.sub_group_originator.is_set or self.sub_group_originator.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.sub_group_originator.get_name_leafdata())
                    if (self.sub_group_id.is_set or self.sub_group_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.sub_group_id.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "te-signalling-filter-data"):
                        if (self.te_signalling_filter_data is None):
                            self.te_signalling_filter_data = MplsTeStandby.SignallingCounters.Signallings.Signalling.TeSignallingFilterData()
                            self.te_signalling_filter_data.parent = self
                            self._children_name_map["te_signalling_filter_data"] = "te-signalling-filter-data"
                        return self.te_signalling_filter_data

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "te-signalling-filter-data" or name == "ctype" or name == "tunnel-id" or name == "extended-tunnel-id" or name == "p2mp-id" or name == "lsp-id" or name == "source-address" or name == "destination-address" or name == "sub-group-originator" or name == "sub-group-id"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "ctype"):
                        self.ctype = value
                        self.ctype.value_namespace = name_space
                        self.ctype.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-id"):
                        self.tunnel_id = value
                        self.tunnel_id.value_namespace = name_space
                        self.tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "extended-tunnel-id"):
                        self.extended_tunnel_id = value
                        self.extended_tunnel_id.value_namespace = name_space
                        self.extended_tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "p2mp-id"):
                        self.p2mp_id = value
                        self.p2mp_id.value_namespace = name_space
                        self.p2mp_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "lsp-id"):
                        self.lsp_id = value
                        self.lsp_id.value_namespace = name_space
                        self.lsp_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "source-address"):
                        self.source_address = value
                        self.source_address.value_namespace = name_space
                        self.source_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "destination-address"):
                        self.destination_address = value
                        self.destination_address.value_namespace = name_space
                        self.destination_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "sub-group-originator"):
                        self.sub_group_originator = value
                        self.sub_group_originator.value_namespace = name_space
                        self.sub_group_originator.value_namespace_prefix = name_space_prefix
                    if(value_path == "sub-group-id"):
                        self.sub_group_id = value
                        self.sub_group_id.value_namespace = name_space
                        self.sub_group_id.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.signalling:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.signalling:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "signallings" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/signalling-counters/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "signalling"):
                    for c in self.signalling:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTeStandby.SignallingCounters.Signallings.Signalling()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.signalling.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "signalling"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass


        class SignallingSummary(Entity):
            """
            Send\-Recv count summary for TE Signaling
            
            .. attribute:: events_count
            
            	TE Signaling event count
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: events_total_count
            
            	Total TE Signalling event count
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: rx_backup_assign_err_event
            
            	Error on Backup Assign event
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: rx_event_unknown
            
            	RX Unknown events
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: rx_path_change_event
            
            	RX Path Change event
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: rx_path_create_event
            
            	RX Path Create event
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: rx_path_delete_event
            
            	RX Path Delete event
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: rx_path_error_event
            
            	RX Path Error event
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: rx_path_reeval_query_event
            
            	RX Path Reeval Query event
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: rx_resv_change_event
            
            	RX Resv Change event
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: rx_resv_create_event
            
            	RX Resv Create event
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: rx_resv_delete_event
            
            	RX Resv Delete event
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: rx_resv_error_event
            
            	RX Resv Error event
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: tx_backup_assign_event
            
            	Backup Assign event
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: tx_event_unknown
            
            	Unknown TX events
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: tx_path_change_event
            
            	TX Path Change event
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: tx_path_create_event
            
            	TX Path Create event
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: tx_path_delete_event
            
            	TX Path Delete event
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: tx_path_error_event
            
            	TX Path Error event
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: tx_path_reeval_query_event
            
            	TX Path Reeval Query event
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: tx_resv_change_event
            
            	TX Resv Change event
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: tx_resv_create_event
            
            	TX Resv Create event
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: tx_resv_delete_event
            
            	TX Resv Delete event
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: tx_resv_error_event
            
            	TX Resv Error event
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTeStandby.SignallingCounters.SignallingSummary, self).__init__()

                self.yang_name = "signalling-summary"
                self.yang_parent_name = "signalling-counters"

                self.events_count = YLeaf(YType.uint32, "events-count")

                self.events_total_count = YLeaf(YType.uint32, "events-total-count")

                self.rx_backup_assign_err_event = YLeaf(YType.uint32, "rx-backup-assign-err-event")

                self.rx_event_unknown = YLeaf(YType.uint32, "rx-event-unknown")

                self.rx_path_change_event = YLeaf(YType.uint32, "rx-path-change-event")

                self.rx_path_create_event = YLeaf(YType.uint32, "rx-path-create-event")

                self.rx_path_delete_event = YLeaf(YType.uint32, "rx-path-delete-event")

                self.rx_path_error_event = YLeaf(YType.uint32, "rx-path-error-event")

                self.rx_path_reeval_query_event = YLeaf(YType.uint32, "rx-path-reeval-query-event")

                self.rx_resv_change_event = YLeaf(YType.uint32, "rx-resv-change-event")

                self.rx_resv_create_event = YLeaf(YType.uint32, "rx-resv-create-event")

                self.rx_resv_delete_event = YLeaf(YType.uint32, "rx-resv-delete-event")

                self.rx_resv_error_event = YLeaf(YType.uint32, "rx-resv-error-event")

                self.tx_backup_assign_event = YLeaf(YType.uint32, "tx-backup-assign-event")

                self.tx_event_unknown = YLeaf(YType.uint32, "tx-event-unknown")

                self.tx_path_change_event = YLeaf(YType.uint32, "tx-path-change-event")

                self.tx_path_create_event = YLeaf(YType.uint32, "tx-path-create-event")

                self.tx_path_delete_event = YLeaf(YType.uint32, "tx-path-delete-event")

                self.tx_path_error_event = YLeaf(YType.uint32, "tx-path-error-event")

                self.tx_path_reeval_query_event = YLeaf(YType.uint32, "tx-path-reeval-query-event")

                self.tx_resv_change_event = YLeaf(YType.uint32, "tx-resv-change-event")

                self.tx_resv_create_event = YLeaf(YType.uint32, "tx-resv-create-event")

                self.tx_resv_delete_event = YLeaf(YType.uint32, "tx-resv-delete-event")

                self.tx_resv_error_event = YLeaf(YType.uint32, "tx-resv-error-event")

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("events_count",
                                "events_total_count",
                                "rx_backup_assign_err_event",
                                "rx_event_unknown",
                                "rx_path_change_event",
                                "rx_path_create_event",
                                "rx_path_delete_event",
                                "rx_path_error_event",
                                "rx_path_reeval_query_event",
                                "rx_resv_change_event",
                                "rx_resv_create_event",
                                "rx_resv_delete_event",
                                "rx_resv_error_event",
                                "tx_backup_assign_event",
                                "tx_event_unknown",
                                "tx_path_change_event",
                                "tx_path_create_event",
                                "tx_path_delete_event",
                                "tx_path_error_event",
                                "tx_path_reeval_query_event",
                                "tx_resv_change_event",
                                "tx_resv_create_event",
                                "tx_resv_delete_event",
                                "tx_resv_error_event") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTeStandby.SignallingCounters.SignallingSummary, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTeStandby.SignallingCounters.SignallingSummary, self).__setattr__(name, value)

            def has_data(self):
                return (
                    self.events_count.is_set or
                    self.events_total_count.is_set or
                    self.rx_backup_assign_err_event.is_set or
                    self.rx_event_unknown.is_set or
                    self.rx_path_change_event.is_set or
                    self.rx_path_create_event.is_set or
                    self.rx_path_delete_event.is_set or
                    self.rx_path_error_event.is_set or
                    self.rx_path_reeval_query_event.is_set or
                    self.rx_resv_change_event.is_set or
                    self.rx_resv_create_event.is_set or
                    self.rx_resv_delete_event.is_set or
                    self.rx_resv_error_event.is_set or
                    self.tx_backup_assign_event.is_set or
                    self.tx_event_unknown.is_set or
                    self.tx_path_change_event.is_set or
                    self.tx_path_create_event.is_set or
                    self.tx_path_delete_event.is_set or
                    self.tx_path_error_event.is_set or
                    self.tx_path_reeval_query_event.is_set or
                    self.tx_resv_change_event.is_set or
                    self.tx_resv_create_event.is_set or
                    self.tx_resv_delete_event.is_set or
                    self.tx_resv_error_event.is_set)

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    self.events_count.yfilter != YFilter.not_set or
                    self.events_total_count.yfilter != YFilter.not_set or
                    self.rx_backup_assign_err_event.yfilter != YFilter.not_set or
                    self.rx_event_unknown.yfilter != YFilter.not_set or
                    self.rx_path_change_event.yfilter != YFilter.not_set or
                    self.rx_path_create_event.yfilter != YFilter.not_set or
                    self.rx_path_delete_event.yfilter != YFilter.not_set or
                    self.rx_path_error_event.yfilter != YFilter.not_set or
                    self.rx_path_reeval_query_event.yfilter != YFilter.not_set or
                    self.rx_resv_change_event.yfilter != YFilter.not_set or
                    self.rx_resv_create_event.yfilter != YFilter.not_set or
                    self.rx_resv_delete_event.yfilter != YFilter.not_set or
                    self.rx_resv_error_event.yfilter != YFilter.not_set or
                    self.tx_backup_assign_event.yfilter != YFilter.not_set or
                    self.tx_event_unknown.yfilter != YFilter.not_set or
                    self.tx_path_change_event.yfilter != YFilter.not_set or
                    self.tx_path_create_event.yfilter != YFilter.not_set or
                    self.tx_path_delete_event.yfilter != YFilter.not_set or
                    self.tx_path_error_event.yfilter != YFilter.not_set or
                    self.tx_path_reeval_query_event.yfilter != YFilter.not_set or
                    self.tx_resv_change_event.yfilter != YFilter.not_set or
                    self.tx_resv_create_event.yfilter != YFilter.not_set or
                    self.tx_resv_delete_event.yfilter != YFilter.not_set or
                    self.tx_resv_error_event.yfilter != YFilter.not_set)

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "signalling-summary" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/signalling-counters/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.events_count.is_set or self.events_count.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.events_count.get_name_leafdata())
                if (self.events_total_count.is_set or self.events_total_count.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.events_total_count.get_name_leafdata())
                if (self.rx_backup_assign_err_event.is_set or self.rx_backup_assign_err_event.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.rx_backup_assign_err_event.get_name_leafdata())
                if (self.rx_event_unknown.is_set or self.rx_event_unknown.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.rx_event_unknown.get_name_leafdata())
                if (self.rx_path_change_event.is_set or self.rx_path_change_event.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.rx_path_change_event.get_name_leafdata())
                if (self.rx_path_create_event.is_set or self.rx_path_create_event.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.rx_path_create_event.get_name_leafdata())
                if (self.rx_path_delete_event.is_set or self.rx_path_delete_event.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.rx_path_delete_event.get_name_leafdata())
                if (self.rx_path_error_event.is_set or self.rx_path_error_event.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.rx_path_error_event.get_name_leafdata())
                if (self.rx_path_reeval_query_event.is_set or self.rx_path_reeval_query_event.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.rx_path_reeval_query_event.get_name_leafdata())
                if (self.rx_resv_change_event.is_set or self.rx_resv_change_event.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.rx_resv_change_event.get_name_leafdata())
                if (self.rx_resv_create_event.is_set or self.rx_resv_create_event.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.rx_resv_create_event.get_name_leafdata())
                if (self.rx_resv_delete_event.is_set or self.rx_resv_delete_event.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.rx_resv_delete_event.get_name_leafdata())
                if (self.rx_resv_error_event.is_set or self.rx_resv_error_event.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.rx_resv_error_event.get_name_leafdata())
                if (self.tx_backup_assign_event.is_set or self.tx_backup_assign_event.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.tx_backup_assign_event.get_name_leafdata())
                if (self.tx_event_unknown.is_set or self.tx_event_unknown.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.tx_event_unknown.get_name_leafdata())
                if (self.tx_path_change_event.is_set or self.tx_path_change_event.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.tx_path_change_event.get_name_leafdata())
                if (self.tx_path_create_event.is_set or self.tx_path_create_event.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.tx_path_create_event.get_name_leafdata())
                if (self.tx_path_delete_event.is_set or self.tx_path_delete_event.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.tx_path_delete_event.get_name_leafdata())
                if (self.tx_path_error_event.is_set or self.tx_path_error_event.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.tx_path_error_event.get_name_leafdata())
                if (self.tx_path_reeval_query_event.is_set or self.tx_path_reeval_query_event.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.tx_path_reeval_query_event.get_name_leafdata())
                if (self.tx_resv_change_event.is_set or self.tx_resv_change_event.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.tx_resv_change_event.get_name_leafdata())
                if (self.tx_resv_create_event.is_set or self.tx_resv_create_event.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.tx_resv_create_event.get_name_leafdata())
                if (self.tx_resv_delete_event.is_set or self.tx_resv_delete_event.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.tx_resv_delete_event.get_name_leafdata())
                if (self.tx_resv_error_event.is_set or self.tx_resv_error_event.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.tx_resv_error_event.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "events-count" or name == "events-total-count" or name == "rx-backup-assign-err-event" or name == "rx-event-unknown" or name == "rx-path-change-event" or name == "rx-path-create-event" or name == "rx-path-delete-event" or name == "rx-path-error-event" or name == "rx-path-reeval-query-event" or name == "rx-resv-change-event" or name == "rx-resv-create-event" or name == "rx-resv-delete-event" or name == "rx-resv-error-event" or name == "tx-backup-assign-event" or name == "tx-event-unknown" or name == "tx-path-change-event" or name == "tx-path-create-event" or name == "tx-path-delete-event" or name == "tx-path-error-event" or name == "tx-path-reeval-query-event" or name == "tx-resv-change-event" or name == "tx-resv-create-event" or name == "tx-resv-delete-event" or name == "tx-resv-error-event"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "events-count"):
                    self.events_count = value
                    self.events_count.value_namespace = name_space
                    self.events_count.value_namespace_prefix = name_space_prefix
                if(value_path == "events-total-count"):
                    self.events_total_count = value
                    self.events_total_count.value_namespace = name_space
                    self.events_total_count.value_namespace_prefix = name_space_prefix
                if(value_path == "rx-backup-assign-err-event"):
                    self.rx_backup_assign_err_event = value
                    self.rx_backup_assign_err_event.value_namespace = name_space
                    self.rx_backup_assign_err_event.value_namespace_prefix = name_space_prefix
                if(value_path == "rx-event-unknown"):
                    self.rx_event_unknown = value
                    self.rx_event_unknown.value_namespace = name_space
                    self.rx_event_unknown.value_namespace_prefix = name_space_prefix
                if(value_path == "rx-path-change-event"):
                    self.rx_path_change_event = value
                    self.rx_path_change_event.value_namespace = name_space
                    self.rx_path_change_event.value_namespace_prefix = name_space_prefix
                if(value_path == "rx-path-create-event"):
                    self.rx_path_create_event = value
                    self.rx_path_create_event.value_namespace = name_space
                    self.rx_path_create_event.value_namespace_prefix = name_space_prefix
                if(value_path == "rx-path-delete-event"):
                    self.rx_path_delete_event = value
                    self.rx_path_delete_event.value_namespace = name_space
                    self.rx_path_delete_event.value_namespace_prefix = name_space_prefix
                if(value_path == "rx-path-error-event"):
                    self.rx_path_error_event = value
                    self.rx_path_error_event.value_namespace = name_space
                    self.rx_path_error_event.value_namespace_prefix = name_space_prefix
                if(value_path == "rx-path-reeval-query-event"):
                    self.rx_path_reeval_query_event = value
                    self.rx_path_reeval_query_event.value_namespace = name_space
                    self.rx_path_reeval_query_event.value_namespace_prefix = name_space_prefix
                if(value_path == "rx-resv-change-event"):
                    self.rx_resv_change_event = value
                    self.rx_resv_change_event.value_namespace = name_space
                    self.rx_resv_change_event.value_namespace_prefix = name_space_prefix
                if(value_path == "rx-resv-create-event"):
                    self.rx_resv_create_event = value
                    self.rx_resv_create_event.value_namespace = name_space
                    self.rx_resv_create_event.value_namespace_prefix = name_space_prefix
                if(value_path == "rx-resv-delete-event"):
                    self.rx_resv_delete_event = value
                    self.rx_resv_delete_event.value_namespace = name_space
                    self.rx_resv_delete_event.value_namespace_prefix = name_space_prefix
                if(value_path == "rx-resv-error-event"):
                    self.rx_resv_error_event = value
                    self.rx_resv_error_event.value_namespace = name_space
                    self.rx_resv_error_event.value_namespace_prefix = name_space_prefix
                if(value_path == "tx-backup-assign-event"):
                    self.tx_backup_assign_event = value
                    self.tx_backup_assign_event.value_namespace = name_space
                    self.tx_backup_assign_event.value_namespace_prefix = name_space_prefix
                if(value_path == "tx-event-unknown"):
                    self.tx_event_unknown = value
                    self.tx_event_unknown.value_namespace = name_space
                    self.tx_event_unknown.value_namespace_prefix = name_space_prefix
                if(value_path == "tx-path-change-event"):
                    self.tx_path_change_event = value
                    self.tx_path_change_event.value_namespace = name_space
                    self.tx_path_change_event.value_namespace_prefix = name_space_prefix
                if(value_path == "tx-path-create-event"):
                    self.tx_path_create_event = value
                    self.tx_path_create_event.value_namespace = name_space
                    self.tx_path_create_event.value_namespace_prefix = name_space_prefix
                if(value_path == "tx-path-delete-event"):
                    self.tx_path_delete_event = value
                    self.tx_path_delete_event.value_namespace = name_space
                    self.tx_path_delete_event.value_namespace_prefix = name_space_prefix
                if(value_path == "tx-path-error-event"):
                    self.tx_path_error_event = value
                    self.tx_path_error_event.value_namespace = name_space
                    self.tx_path_error_event.value_namespace_prefix = name_space_prefix
                if(value_path == "tx-path-reeval-query-event"):
                    self.tx_path_reeval_query_event = value
                    self.tx_path_reeval_query_event.value_namespace = name_space
                    self.tx_path_reeval_query_event.value_namespace_prefix = name_space_prefix
                if(value_path == "tx-resv-change-event"):
                    self.tx_resv_change_event = value
                    self.tx_resv_change_event.value_namespace = name_space
                    self.tx_resv_change_event.value_namespace_prefix = name_space_prefix
                if(value_path == "tx-resv-create-event"):
                    self.tx_resv_create_event = value
                    self.tx_resv_create_event.value_namespace = name_space
                    self.tx_resv_create_event.value_namespace_prefix = name_space_prefix
                if(value_path == "tx-resv-delete-event"):
                    self.tx_resv_delete_event = value
                    self.tx_resv_delete_event.value_namespace = name_space
                    self.tx_resv_delete_event.value_namespace_prefix = name_space_prefix
                if(value_path == "tx-resv-error-event"):
                    self.tx_resv_error_event = value
                    self.tx_resv_error_event.value_namespace = name_space
                    self.tx_resv_error_event.value_namespace_prefix = name_space_prefix

        def has_data(self):
            return (
                (self.head_signalling_counters is not None and self.head_signalling_counters.has_data()) or
                (self.heads_counters is not None and self.heads_counters.has_data()) or
                (self.issu is not None and self.issu.has_data()) or
                (self.mids_counters is not None and self.mids_counters.has_data()) or
                (self.remote_signalling_counters is not None and self.remote_signalling_counters.has_data()) or
                (self.signalling_summary is not None and self.signalling_summary.has_data()) or
                (self.signallings is not None and self.signallings.has_data()) or
                (self.tails_counters is not None and self.tails_counters.has_data()))

        def has_operation(self):
            return (
                self.yfilter != YFilter.not_set or
                (self.head_signalling_counters is not None and self.head_signalling_counters.has_operation()) or
                (self.heads_counters is not None and self.heads_counters.has_operation()) or
                (self.issu is not None and self.issu.has_operation()) or
                (self.mids_counters is not None and self.mids_counters.has_operation()) or
                (self.remote_signalling_counters is not None and self.remote_signalling_counters.has_operation()) or
                (self.signalling_summary is not None and self.signalling_summary.has_operation()) or
                (self.signallings is not None and self.signallings.has_operation()) or
                (self.tails_counters is not None and self.tails_counters.has_operation()))

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "signalling-counters" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "head-signalling-counters"):
                if (self.head_signalling_counters is None):
                    self.head_signalling_counters = MplsTeStandby.SignallingCounters.HeadSignallingCounters()
                    self.head_signalling_counters.parent = self
                    self._children_name_map["head_signalling_counters"] = "head-signalling-counters"
                return self.head_signalling_counters

            if (child_yang_name == "heads-counters"):
                if (self.heads_counters is None):
                    self.heads_counters = MplsTeStandby.SignallingCounters.HeadsCounters()
                    self.heads_counters.parent = self
                    self._children_name_map["heads_counters"] = "heads-counters"
                return self.heads_counters

            if (child_yang_name == "issu"):
                if (self.issu is None):
                    self.issu = MplsTeStandby.SignallingCounters.Issu()
                    self.issu.parent = self
                    self._children_name_map["issu"] = "issu"
                return self.issu

            if (child_yang_name == "mids-counters"):
                if (self.mids_counters is None):
                    self.mids_counters = MplsTeStandby.SignallingCounters.MidsCounters()
                    self.mids_counters.parent = self
                    self._children_name_map["mids_counters"] = "mids-counters"
                return self.mids_counters

            if (child_yang_name == "remote-signalling-counters"):
                if (self.remote_signalling_counters is None):
                    self.remote_signalling_counters = MplsTeStandby.SignallingCounters.RemoteSignallingCounters()
                    self.remote_signalling_counters.parent = self
                    self._children_name_map["remote_signalling_counters"] = "remote-signalling-counters"
                return self.remote_signalling_counters

            if (child_yang_name == "signalling-summary"):
                if (self.signalling_summary is None):
                    self.signalling_summary = MplsTeStandby.SignallingCounters.SignallingSummary()
                    self.signalling_summary.parent = self
                    self._children_name_map["signalling_summary"] = "signalling-summary"
                return self.signalling_summary

            if (child_yang_name == "signallings"):
                if (self.signallings is None):
                    self.signallings = MplsTeStandby.SignallingCounters.Signallings()
                    self.signallings.parent = self
                    self._children_name_map["signallings"] = "signallings"
                return self.signallings

            if (child_yang_name == "tails-counters"):
                if (self.tails_counters is None):
                    self.tails_counters = MplsTeStandby.SignallingCounters.TailsCounters()
                    self.tails_counters.parent = self
                    self._children_name_map["tails_counters"] = "tails-counters"
                return self.tails_counters

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "head-signalling-counters" or name == "heads-counters" or name == "issu" or name == "mids-counters" or name == "remote-signalling-counters" or name == "signalling-summary" or name == "signallings" or name == "tails-counters"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class DiffServTeClasses(Entity):
        """
        The configured Diff Serv TE classes
        
        .. attribute:: te_class
        
        	te class
        	**type**\: list of    :py:class:`TeClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.DiffServTeClasses.TeClass>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsTeStandby.DiffServTeClasses, self).__init__()

            self.yang_name = "diff-serv-te-classes"
            self.yang_parent_name = "mpls-te-standby"

            self.te_class = YList(self)

        def __setattr__(self, name, value):
            self._check_monkey_patching_error(name, value)
            with _handle_type_error():
                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                        "Please use list append or extend method."
                                        .format(value))
                if isinstance(value, Enum.YLeaf):
                    value = value.name
                if name in () and name in self.__dict__:
                    if isinstance(value, YLeaf):
                        self.__dict__[name].set(value.get())
                    elif isinstance(value, YLeafList):
                        super(MplsTeStandby.DiffServTeClasses, self).__setattr__(name, value)
                    else:
                        self.__dict__[name].set(value)
                else:
                    if hasattr(value, "parent") and name != "parent":
                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                            value.parent = self
                        elif value.parent is None and value.yang_name in self._children_yang_names:
                            value.parent = self
                    super(MplsTeStandby.DiffServTeClasses, self).__setattr__(name, value)


        class TeClass(Entity):
            """
            te class
            
            .. attribute:: class_number
            
            	The DS\-TE class number from 0 to 7
            	**type**\:  int
            
            	**range:** 0..255
            
            .. attribute:: class_status
            
            	The status of the TE class
            	**type**\:   :py:class:`MplsTeDsteClassStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeDsteClassStatus>`
            
            .. attribute:: class_type
            
            	The class type of the TE class
            	**type**\:  int
            
            	**range:** 0..255
            
            .. attribute:: priority
            
            	The priority of the TE class
            	**type**\:  int
            
            	**range:** 0..255
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTeStandby.DiffServTeClasses.TeClass, self).__init__()

                self.yang_name = "te-class"
                self.yang_parent_name = "diff-serv-te-classes"

                self.class_number = YLeaf(YType.uint8, "class-number")

                self.class_status = YLeaf(YType.enumeration, "class-status")

                self.class_type = YLeaf(YType.uint8, "class-type")

                self.priority = YLeaf(YType.uint8, "priority")

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("class_number",
                                "class_status",
                                "class_type",
                                "priority") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTeStandby.DiffServTeClasses.TeClass, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTeStandby.DiffServTeClasses.TeClass, self).__setattr__(name, value)

            def has_data(self):
                return (
                    self.class_number.is_set or
                    self.class_status.is_set or
                    self.class_type.is_set or
                    self.priority.is_set)

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    self.class_number.yfilter != YFilter.not_set or
                    self.class_status.yfilter != YFilter.not_set or
                    self.class_type.yfilter != YFilter.not_set or
                    self.priority.yfilter != YFilter.not_set)

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "te-class" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/diff-serv-te-classes/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.class_number.is_set or self.class_number.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.class_number.get_name_leafdata())
                if (self.class_status.is_set or self.class_status.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.class_status.get_name_leafdata())
                if (self.class_type.is_set or self.class_type.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.class_type.get_name_leafdata())
                if (self.priority.is_set or self.priority.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.priority.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "class-number" or name == "class-status" or name == "class-type" or name == "priority"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "class-number"):
                    self.class_number = value
                    self.class_number.value_namespace = name_space
                    self.class_number.value_namespace_prefix = name_space_prefix
                if(value_path == "class-status"):
                    self.class_status = value
                    self.class_status.value_namespace = name_space
                    self.class_status.value_namespace_prefix = name_space_prefix
                if(value_path == "class-type"):
                    self.class_type = value
                    self.class_type.value_namespace = name_space
                    self.class_type.value_namespace_prefix = name_space_prefix
                if(value_path == "priority"):
                    self.priority = value
                    self.priority.value_namespace = name_space
                    self.priority.value_namespace_prefix = name_space_prefix

        def has_data(self):
            for c in self.te_class:
                if (c.has_data()):
                    return True
            return False

        def has_operation(self):
            for c in self.te_class:
                if (c.has_operation()):
                    return True
            return self.yfilter != YFilter.not_set

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "diff-serv-te-classes" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "te-class"):
                for c in self.te_class:
                    segment = c.get_segment_path()
                    if (segment_path == segment):
                        return c
                c = MplsTeStandby.DiffServTeClasses.TeClass()
                c.parent = self
                local_reference_key = "ydk::seg::%s" % segment_path
                self._local_refs[local_reference_key] = c
                self.te_class.append(c)
                return c

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "te-class"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class Issu(Entity):
        """
        MPLS TE ISSU information
        
        .. attribute:: detail
        
        	MPLS TE ISSU Status information
        	**type**\:   :py:class:`Detail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Issu.Detail>`
        
        .. attribute:: status
        
        	MPLS TE ISSU Status information
        	**type**\:   :py:class:`Status <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Issu.Status>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsTeStandby.Issu, self).__init__()

            self.yang_name = "issu"
            self.yang_parent_name = "mpls-te-standby"

            self.detail = MplsTeStandby.Issu.Detail()
            self.detail.parent = self
            self._children_name_map["detail"] = "detail"
            self._children_yang_names.add("detail")

            self.status = MplsTeStandby.Issu.Status()
            self.status.parent = self
            self._children_name_map["status"] = "status"
            self._children_yang_names.add("status")


        class Status(Entity):
            """
            MPLS TE ISSU Status information
            
            .. attribute:: role
            
            	Process role
            	**type**\:   :py:class:`TeProcRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProcRole>`
            
            .. attribute:: sync_status_information
            
            	Sync information for the NSR and ISSU
            	**type**\:   :py:class:`SyncStatusInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Issu.Status.SyncStatusInformation>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTeStandby.Issu.Status, self).__init__()

                self.yang_name = "status"
                self.yang_parent_name = "issu"

                self.role = YLeaf(YType.enumeration, "role")

                self.sync_status_information = MplsTeStandby.Issu.Status.SyncStatusInformation()
                self.sync_status_information.parent = self
                self._children_name_map["sync_status_information"] = "sync-status-information"
                self._children_yang_names.add("sync-status-information")

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("role") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTeStandby.Issu.Status, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTeStandby.Issu.Status, self).__setattr__(name, value)


            class SyncStatusInformation(Entity):
                """
                Sync information for the NSR and ISSU
                
                .. attribute:: master_sync_information
                
                	Master sync information
                	**type**\:   :py:class:`MasterSyncInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Issu.Status.SyncStatusInformation.MasterSyncInformation>`
                
                .. attribute:: slave_sync_information
                
                	Slave sync information
                	**type**\:   :py:class:`SlaveSyncInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Issu.Status.SyncStatusInformation.SlaveSyncInformation>`
                
                .. attribute:: sync_show_type
                
                	SyncShowType
                	**type**\:   :py:class:`TeSyncStatusShow <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncStatusShow>`
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTeStandby.Issu.Status.SyncStatusInformation, self).__init__()

                    self.yang_name = "sync-status-information"
                    self.yang_parent_name = "status"

                    self.sync_show_type = YLeaf(YType.enumeration, "sync-show-type")

                    self.master_sync_information = MplsTeStandby.Issu.Status.SyncStatusInformation.MasterSyncInformation()
                    self.master_sync_information.parent = self
                    self._children_name_map["master_sync_information"] = "master-sync-information"
                    self._children_yang_names.add("master-sync-information")

                    self.slave_sync_information = MplsTeStandby.Issu.Status.SyncStatusInformation.SlaveSyncInformation()
                    self.slave_sync_information.parent = self
                    self._children_name_map["slave_sync_information"] = "slave-sync-information"
                    self._children_yang_names.add("slave-sync-information")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("sync_show_type") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTeStandby.Issu.Status.SyncStatusInformation, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTeStandby.Issu.Status.SyncStatusInformation, self).__setattr__(name, value)


                class SlaveSyncInformation(Entity):
                    """
                    Slave sync information
                    
                    .. attribute:: idt
                    
                    	Sync status IDT information
                    	**type**\:   :py:class:`Idt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Issu.Status.SyncStatusInformation.SlaveSyncInformation.Idt>`
                    
                    .. attribute:: insync_sub_ls_ps
                    
                    	Sub\-LSPs in sync
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: insync_tunnels
                    
                    	Tunnels in sync
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: pending_sub_ls_ps
                    
                    	Sub\-LSPs in sync pending
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: pending_tunnels
                    
                    	Tunnels in sync pending
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2l_pending
                    
                    	Pending sub\-LSPs details
                    	**type**\: list of    :py:class:`S2LPending <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Issu.Status.SyncStatusInformation.SlaveSyncInformation.S2LPending>`
                    
                    .. attribute:: vif_pending
                    
                    	Pending tunnels details
                    	**type**\: list of    :py:class:`VifPending <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Issu.Status.SyncStatusInformation.SlaveSyncInformation.VifPending>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.Issu.Status.SyncStatusInformation.SlaveSyncInformation, self).__init__()

                        self.yang_name = "slave-sync-information"
                        self.yang_parent_name = "sync-status-information"

                        self.insync_sub_ls_ps = YLeaf(YType.uint32, "insync-sub-ls-ps")

                        self.insync_tunnels = YLeaf(YType.uint32, "insync-tunnels")

                        self.pending_sub_ls_ps = YLeaf(YType.uint32, "pending-sub-ls-ps")

                        self.pending_tunnels = YLeaf(YType.uint32, "pending-tunnels")

                        self.idt = MplsTeStandby.Issu.Status.SyncStatusInformation.SlaveSyncInformation.Idt()
                        self.idt.parent = self
                        self._children_name_map["idt"] = "idt"
                        self._children_yang_names.add("idt")

                        self.s2l_pending = YList(self)
                        self.vif_pending = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("insync_sub_ls_ps",
                                        "insync_tunnels",
                                        "pending_sub_ls_ps",
                                        "pending_tunnels") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.Issu.Status.SyncStatusInformation.SlaveSyncInformation, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.Issu.Status.SyncStatusInformation.SlaveSyncInformation, self).__setattr__(name, value)


                    class Idt(Entity):
                        """
                        Sync status IDT information
                        
                        .. attribute:: current_idt_info
                        
                        	Current IDT information
                        	**type**\:   :py:class:`CurrentIdtInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Issu.Status.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo>`
                        
                        .. attribute:: previous_idt_status
                        
                        	Previous IDT information
                        	**type**\:   :py:class:`PreviousIdtStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Issu.Status.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.Issu.Status.SyncStatusInformation.SlaveSyncInformation.Idt, self).__init__()

                            self.yang_name = "idt"
                            self.yang_parent_name = "slave-sync-information"

                            self.current_idt_info = MplsTeStandby.Issu.Status.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo()
                            self.current_idt_info.parent = self
                            self._children_name_map["current_idt_info"] = "current-idt-info"
                            self._children_yang_names.add("current-idt-info")

                            self.previous_idt_status = MplsTeStandby.Issu.Status.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus()
                            self.previous_idt_status.parent = self
                            self._children_name_map["previous_idt_status"] = "previous-idt-status"
                            self._children_yang_names.add("previous-idt-status")


                        class CurrentIdtInfo(Entity):
                            """
                            Current IDT information
                            
                            .. attribute:: declare_time
                            
                            	Declare ready timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: idt_end_time
                            
                            	IDT end timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: idt_start_time
                            
                            	IDT start timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: is_ready_status
                            
                            	Ready status
                            	**type**\:  bool
                            
                            .. attribute:: reason
                            
                            	Not ready reason
                            	**type**\:   :py:class:`TeSyncNotReadyReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncNotReadyReason>`
                            
                            .. attribute:: withdraw_time
                            
                            	Withdraw ready timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.Issu.Status.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo, self).__init__()

                                self.yang_name = "current-idt-info"
                                self.yang_parent_name = "idt"

                                self.declare_time = YLeaf(YType.uint32, "declare-time")

                                self.idt_end_time = YLeaf(YType.uint32, "idt-end-time")

                                self.idt_start_time = YLeaf(YType.uint32, "idt-start-time")

                                self.is_ready_status = YLeaf(YType.boolean, "is-ready-status")

                                self.reason = YLeaf(YType.enumeration, "reason")

                                self.withdraw_time = YLeaf(YType.uint32, "withdraw-time")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("declare_time",
                                                "idt_end_time",
                                                "idt_start_time",
                                                "is_ready_status",
                                                "reason",
                                                "withdraw_time") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.Issu.Status.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.Issu.Status.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.declare_time.is_set or
                                    self.idt_end_time.is_set or
                                    self.idt_start_time.is_set or
                                    self.is_ready_status.is_set or
                                    self.reason.is_set or
                                    self.withdraw_time.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.declare_time.yfilter != YFilter.not_set or
                                    self.idt_end_time.yfilter != YFilter.not_set or
                                    self.idt_start_time.yfilter != YFilter.not_set or
                                    self.is_ready_status.yfilter != YFilter.not_set or
                                    self.reason.yfilter != YFilter.not_set or
                                    self.withdraw_time.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "current-idt-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/issu/status/sync-status-information/slave-sync-information/idt/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.declare_time.is_set or self.declare_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.declare_time.get_name_leafdata())
                                if (self.idt_end_time.is_set or self.idt_end_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.idt_end_time.get_name_leafdata())
                                if (self.idt_start_time.is_set or self.idt_start_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.idt_start_time.get_name_leafdata())
                                if (self.is_ready_status.is_set or self.is_ready_status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_ready_status.get_name_leafdata())
                                if (self.reason.is_set or self.reason.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reason.get_name_leafdata())
                                if (self.withdraw_time.is_set or self.withdraw_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.withdraw_time.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "declare-time" or name == "idt-end-time" or name == "idt-start-time" or name == "is-ready-status" or name == "reason" or name == "withdraw-time"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "declare-time"):
                                    self.declare_time = value
                                    self.declare_time.value_namespace = name_space
                                    self.declare_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "idt-end-time"):
                                    self.idt_end_time = value
                                    self.idt_end_time.value_namespace = name_space
                                    self.idt_end_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "idt-start-time"):
                                    self.idt_start_time = value
                                    self.idt_start_time.value_namespace = name_space
                                    self.idt_start_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-ready-status"):
                                    self.is_ready_status = value
                                    self.is_ready_status.value_namespace = name_space
                                    self.is_ready_status.value_namespace_prefix = name_space_prefix
                                if(value_path == "reason"):
                                    self.reason = value
                                    self.reason.value_namespace = name_space
                                    self.reason.value_namespace_prefix = name_space_prefix
                                if(value_path == "withdraw-time"):
                                    self.withdraw_time = value
                                    self.withdraw_time.value_namespace = name_space
                                    self.withdraw_time.value_namespace_prefix = name_space_prefix


                        class PreviousIdtStatus(Entity):
                            """
                            Previous IDT information
                            
                            .. attribute:: declare_time
                            
                            	Declare ready timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: idt_end_time
                            
                            	IDT end timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: idt_start_time
                            
                            	IDT start timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: is_ready_status
                            
                            	Ready status
                            	**type**\:  bool
                            
                            .. attribute:: reason
                            
                            	Not ready reason
                            	**type**\:   :py:class:`TeSyncNotReadyReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncNotReadyReason>`
                            
                            .. attribute:: withdraw_time
                            
                            	Withdraw ready timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.Issu.Status.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus, self).__init__()

                                self.yang_name = "previous-idt-status"
                                self.yang_parent_name = "idt"

                                self.declare_time = YLeaf(YType.uint32, "declare-time")

                                self.idt_end_time = YLeaf(YType.uint32, "idt-end-time")

                                self.idt_start_time = YLeaf(YType.uint32, "idt-start-time")

                                self.is_ready_status = YLeaf(YType.boolean, "is-ready-status")

                                self.reason = YLeaf(YType.enumeration, "reason")

                                self.withdraw_time = YLeaf(YType.uint32, "withdraw-time")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("declare_time",
                                                "idt_end_time",
                                                "idt_start_time",
                                                "is_ready_status",
                                                "reason",
                                                "withdraw_time") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.Issu.Status.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.Issu.Status.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.declare_time.is_set or
                                    self.idt_end_time.is_set or
                                    self.idt_start_time.is_set or
                                    self.is_ready_status.is_set or
                                    self.reason.is_set or
                                    self.withdraw_time.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.declare_time.yfilter != YFilter.not_set or
                                    self.idt_end_time.yfilter != YFilter.not_set or
                                    self.idt_start_time.yfilter != YFilter.not_set or
                                    self.is_ready_status.yfilter != YFilter.not_set or
                                    self.reason.yfilter != YFilter.not_set or
                                    self.withdraw_time.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "previous-idt-status" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/issu/status/sync-status-information/slave-sync-information/idt/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.declare_time.is_set or self.declare_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.declare_time.get_name_leafdata())
                                if (self.idt_end_time.is_set or self.idt_end_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.idt_end_time.get_name_leafdata())
                                if (self.idt_start_time.is_set or self.idt_start_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.idt_start_time.get_name_leafdata())
                                if (self.is_ready_status.is_set or self.is_ready_status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_ready_status.get_name_leafdata())
                                if (self.reason.is_set or self.reason.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reason.get_name_leafdata())
                                if (self.withdraw_time.is_set or self.withdraw_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.withdraw_time.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "declare-time" or name == "idt-end-time" or name == "idt-start-time" or name == "is-ready-status" or name == "reason" or name == "withdraw-time"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "declare-time"):
                                    self.declare_time = value
                                    self.declare_time.value_namespace = name_space
                                    self.declare_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "idt-end-time"):
                                    self.idt_end_time = value
                                    self.idt_end_time.value_namespace = name_space
                                    self.idt_end_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "idt-start-time"):
                                    self.idt_start_time = value
                                    self.idt_start_time.value_namespace = name_space
                                    self.idt_start_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-ready-status"):
                                    self.is_ready_status = value
                                    self.is_ready_status.value_namespace = name_space
                                    self.is_ready_status.value_namespace_prefix = name_space_prefix
                                if(value_path == "reason"):
                                    self.reason = value
                                    self.reason.value_namespace = name_space
                                    self.reason.value_namespace_prefix = name_space_prefix
                                if(value_path == "withdraw-time"):
                                    self.withdraw_time = value
                                    self.withdraw_time.value_namespace = name_space
                                    self.withdraw_time.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                (self.current_idt_info is not None and self.current_idt_info.has_data()) or
                                (self.previous_idt_status is not None and self.previous_idt_status.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.current_idt_info is not None and self.current_idt_info.has_operation()) or
                                (self.previous_idt_status is not None and self.previous_idt_status.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "idt" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/issu/status/sync-status-information/slave-sync-information/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "current-idt-info"):
                                if (self.current_idt_info is None):
                                    self.current_idt_info = MplsTeStandby.Issu.Status.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo()
                                    self.current_idt_info.parent = self
                                    self._children_name_map["current_idt_info"] = "current-idt-info"
                                return self.current_idt_info

                            if (child_yang_name == "previous-idt-status"):
                                if (self.previous_idt_status is None):
                                    self.previous_idt_status = MplsTeStandby.Issu.Status.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus()
                                    self.previous_idt_status.parent = self
                                    self._children_name_map["previous_idt_status"] = "previous-idt-status"
                                return self.previous_idt_status

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "current-idt-info" or name == "previous-idt-status"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class VifPending(Entity):
                        """
                        Pending tunnels details
                        
                        .. attribute:: pending_reason
                        
                        	Pending reason
                        	**type**\:   :py:class:`TeSyncPendingReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncPendingReason>`
                        
                        .. attribute:: tunnel_name
                        
                        	Tunnel name
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.Issu.Status.SyncStatusInformation.SlaveSyncInformation.VifPending, self).__init__()

                            self.yang_name = "vif-pending"
                            self.yang_parent_name = "slave-sync-information"

                            self.pending_reason = YLeaf(YType.enumeration, "pending-reason")

                            self.tunnel_name = YLeaf(YType.str, "tunnel-name")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("pending_reason",
                                            "tunnel_name") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.Issu.Status.SyncStatusInformation.SlaveSyncInformation.VifPending, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.Issu.Status.SyncStatusInformation.SlaveSyncInformation.VifPending, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.pending_reason.is_set or
                                self.tunnel_name.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.pending_reason.yfilter != YFilter.not_set or
                                self.tunnel_name.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "vif-pending" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/issu/status/sync-status-information/slave-sync-information/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.pending_reason.is_set or self.pending_reason.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.pending_reason.get_name_leafdata())
                            if (self.tunnel_name.is_set or self.tunnel_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tunnel_name.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "pending-reason" or name == "tunnel-name"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "pending-reason"):
                                self.pending_reason = value
                                self.pending_reason.value_namespace = name_space
                                self.pending_reason.value_namespace_prefix = name_space_prefix
                            if(value_path == "tunnel-name"):
                                self.tunnel_name = value
                                self.tunnel_name.value_namespace = name_space
                                self.tunnel_name.value_namespace_prefix = name_space_prefix


                    class S2LPending(Entity):
                        """
                        Pending sub\-LSPs details
                        
                        .. attribute:: pending_reason
                        
                        	Pending reason
                        	**type**\:   :py:class:`TeSyncPendingReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncPendingReason>`
                        
                        .. attribute:: s2l_role
                        
                        	S2L role
                        	**type**\:   :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        .. attribute:: signaled_name
                        
                        	Signaled name
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.Issu.Status.SyncStatusInformation.SlaveSyncInformation.S2LPending, self).__init__()

                            self.yang_name = "s2l-pending"
                            self.yang_parent_name = "slave-sync-information"

                            self.pending_reason = YLeaf(YType.enumeration, "pending-reason")

                            self.s2l_role = YLeaf(YType.enumeration, "s2l-role")

                            self.signaled_name = YLeaf(YType.str, "signaled-name")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("pending_reason",
                                            "s2l_role",
                                            "signaled_name") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.Issu.Status.SyncStatusInformation.SlaveSyncInformation.S2LPending, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.Issu.Status.SyncStatusInformation.SlaveSyncInformation.S2LPending, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.pending_reason.is_set or
                                self.s2l_role.is_set or
                                self.signaled_name.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.pending_reason.yfilter != YFilter.not_set or
                                self.s2l_role.yfilter != YFilter.not_set or
                                self.signaled_name.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "s2l-pending" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/issu/status/sync-status-information/slave-sync-information/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.pending_reason.is_set or self.pending_reason.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.pending_reason.get_name_leafdata())
                            if (self.s2l_role.is_set or self.s2l_role.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_role.get_name_leafdata())
                            if (self.signaled_name.is_set or self.signaled_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.signaled_name.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "pending-reason" or name == "s2l-role" or name == "signaled-name"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "pending-reason"):
                                self.pending_reason = value
                                self.pending_reason.value_namespace = name_space
                                self.pending_reason.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-role"):
                                self.s2l_role = value
                                self.s2l_role.value_namespace = name_space
                                self.s2l_role.value_namespace_prefix = name_space_prefix
                            if(value_path == "signaled-name"):
                                self.signaled_name = value
                                self.signaled_name.value_namespace = name_space
                                self.signaled_name.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.s2l_pending:
                            if (c.has_data()):
                                return True
                        for c in self.vif_pending:
                            if (c.has_data()):
                                return True
                        return (
                            self.insync_sub_ls_ps.is_set or
                            self.insync_tunnels.is_set or
                            self.pending_sub_ls_ps.is_set or
                            self.pending_tunnels.is_set or
                            (self.idt is not None and self.idt.has_data()))

                    def has_operation(self):
                        for c in self.s2l_pending:
                            if (c.has_operation()):
                                return True
                        for c in self.vif_pending:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.insync_sub_ls_ps.yfilter != YFilter.not_set or
                            self.insync_tunnels.yfilter != YFilter.not_set or
                            self.pending_sub_ls_ps.yfilter != YFilter.not_set or
                            self.pending_tunnels.yfilter != YFilter.not_set or
                            (self.idt is not None and self.idt.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "slave-sync-information" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/issu/status/sync-status-information/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.insync_sub_ls_ps.is_set or self.insync_sub_ls_ps.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.insync_sub_ls_ps.get_name_leafdata())
                        if (self.insync_tunnels.is_set or self.insync_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.insync_tunnels.get_name_leafdata())
                        if (self.pending_sub_ls_ps.is_set or self.pending_sub_ls_ps.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.pending_sub_ls_ps.get_name_leafdata())
                        if (self.pending_tunnels.is_set or self.pending_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.pending_tunnels.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "idt"):
                            if (self.idt is None):
                                self.idt = MplsTeStandby.Issu.Status.SyncStatusInformation.SlaveSyncInformation.Idt()
                                self.idt.parent = self
                                self._children_name_map["idt"] = "idt"
                            return self.idt

                        if (child_yang_name == "s2l-pending"):
                            for c in self.s2l_pending:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.Issu.Status.SyncStatusInformation.SlaveSyncInformation.S2LPending()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.s2l_pending.append(c)
                            return c

                        if (child_yang_name == "vif-pending"):
                            for c in self.vif_pending:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.Issu.Status.SyncStatusInformation.SlaveSyncInformation.VifPending()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.vif_pending.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "idt" or name == "s2l-pending" or name == "vif-pending" or name == "insync-sub-ls-ps" or name == "insync-tunnels" or name == "pending-sub-ls-ps" or name == "pending-tunnels"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "insync-sub-ls-ps"):
                            self.insync_sub_ls_ps = value
                            self.insync_sub_ls_ps.value_namespace = name_space
                            self.insync_sub_ls_ps.value_namespace_prefix = name_space_prefix
                        if(value_path == "insync-tunnels"):
                            self.insync_tunnels = value
                            self.insync_tunnels.value_namespace = name_space
                            self.insync_tunnels.value_namespace_prefix = name_space_prefix
                        if(value_path == "pending-sub-ls-ps"):
                            self.pending_sub_ls_ps = value
                            self.pending_sub_ls_ps.value_namespace = name_space
                            self.pending_sub_ls_ps.value_namespace_prefix = name_space_prefix
                        if(value_path == "pending-tunnels"):
                            self.pending_tunnels = value
                            self.pending_tunnels.value_namespace = name_space
                            self.pending_tunnels.value_namespace_prefix = name_space_prefix


                class MasterSyncInformation(Entity):
                    """
                    Master sync information
                    
                    .. attribute:: idt
                    
                    	Sync status IDT information
                    	**type**\:   :py:class:`Idt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Issu.Status.SyncStatusInformation.MasterSyncInformation.Idt>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.Issu.Status.SyncStatusInformation.MasterSyncInformation, self).__init__()

                        self.yang_name = "master-sync-information"
                        self.yang_parent_name = "sync-status-information"

                        self.idt = MplsTeStandby.Issu.Status.SyncStatusInformation.MasterSyncInformation.Idt()
                        self.idt.parent = self
                        self._children_name_map["idt"] = "idt"
                        self._children_yang_names.add("idt")


                    class Idt(Entity):
                        """
                        Sync status IDT information
                        
                        .. attribute:: current_idt_info
                        
                        	Current IDT information
                        	**type**\:   :py:class:`CurrentIdtInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Issu.Status.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo>`
                        
                        .. attribute:: previous_idt_status
                        
                        	Previous IDT information
                        	**type**\:   :py:class:`PreviousIdtStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Issu.Status.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.Issu.Status.SyncStatusInformation.MasterSyncInformation.Idt, self).__init__()

                            self.yang_name = "idt"
                            self.yang_parent_name = "master-sync-information"

                            self.current_idt_info = MplsTeStandby.Issu.Status.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo()
                            self.current_idt_info.parent = self
                            self._children_name_map["current_idt_info"] = "current-idt-info"
                            self._children_yang_names.add("current-idt-info")

                            self.previous_idt_status = MplsTeStandby.Issu.Status.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus()
                            self.previous_idt_status.parent = self
                            self._children_name_map["previous_idt_status"] = "previous-idt-status"
                            self._children_yang_names.add("previous-idt-status")


                        class CurrentIdtInfo(Entity):
                            """
                            Current IDT information
                            
                            .. attribute:: declare_time
                            
                            	Declare ready timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: idt_end_time
                            
                            	IDT end timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: idt_start_time
                            
                            	IDT start timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: is_ready_status
                            
                            	Ready status
                            	**type**\:  bool
                            
                            .. attribute:: reason
                            
                            	Not ready reason
                            	**type**\:   :py:class:`TeSyncNotReadyReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncNotReadyReason>`
                            
                            .. attribute:: withdraw_time
                            
                            	Withdraw ready timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.Issu.Status.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo, self).__init__()

                                self.yang_name = "current-idt-info"
                                self.yang_parent_name = "idt"

                                self.declare_time = YLeaf(YType.uint32, "declare-time")

                                self.idt_end_time = YLeaf(YType.uint32, "idt-end-time")

                                self.idt_start_time = YLeaf(YType.uint32, "idt-start-time")

                                self.is_ready_status = YLeaf(YType.boolean, "is-ready-status")

                                self.reason = YLeaf(YType.enumeration, "reason")

                                self.withdraw_time = YLeaf(YType.uint32, "withdraw-time")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("declare_time",
                                                "idt_end_time",
                                                "idt_start_time",
                                                "is_ready_status",
                                                "reason",
                                                "withdraw_time") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.Issu.Status.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.Issu.Status.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.declare_time.is_set or
                                    self.idt_end_time.is_set or
                                    self.idt_start_time.is_set or
                                    self.is_ready_status.is_set or
                                    self.reason.is_set or
                                    self.withdraw_time.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.declare_time.yfilter != YFilter.not_set or
                                    self.idt_end_time.yfilter != YFilter.not_set or
                                    self.idt_start_time.yfilter != YFilter.not_set or
                                    self.is_ready_status.yfilter != YFilter.not_set or
                                    self.reason.yfilter != YFilter.not_set or
                                    self.withdraw_time.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "current-idt-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/issu/status/sync-status-information/master-sync-information/idt/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.declare_time.is_set or self.declare_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.declare_time.get_name_leafdata())
                                if (self.idt_end_time.is_set or self.idt_end_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.idt_end_time.get_name_leafdata())
                                if (self.idt_start_time.is_set or self.idt_start_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.idt_start_time.get_name_leafdata())
                                if (self.is_ready_status.is_set or self.is_ready_status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_ready_status.get_name_leafdata())
                                if (self.reason.is_set or self.reason.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reason.get_name_leafdata())
                                if (self.withdraw_time.is_set or self.withdraw_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.withdraw_time.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "declare-time" or name == "idt-end-time" or name == "idt-start-time" or name == "is-ready-status" or name == "reason" or name == "withdraw-time"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "declare-time"):
                                    self.declare_time = value
                                    self.declare_time.value_namespace = name_space
                                    self.declare_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "idt-end-time"):
                                    self.idt_end_time = value
                                    self.idt_end_time.value_namespace = name_space
                                    self.idt_end_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "idt-start-time"):
                                    self.idt_start_time = value
                                    self.idt_start_time.value_namespace = name_space
                                    self.idt_start_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-ready-status"):
                                    self.is_ready_status = value
                                    self.is_ready_status.value_namespace = name_space
                                    self.is_ready_status.value_namespace_prefix = name_space_prefix
                                if(value_path == "reason"):
                                    self.reason = value
                                    self.reason.value_namespace = name_space
                                    self.reason.value_namespace_prefix = name_space_prefix
                                if(value_path == "withdraw-time"):
                                    self.withdraw_time = value
                                    self.withdraw_time.value_namespace = name_space
                                    self.withdraw_time.value_namespace_prefix = name_space_prefix


                        class PreviousIdtStatus(Entity):
                            """
                            Previous IDT information
                            
                            .. attribute:: declare_time
                            
                            	Declare ready timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: idt_end_time
                            
                            	IDT end timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: idt_start_time
                            
                            	IDT start timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: is_ready_status
                            
                            	Ready status
                            	**type**\:  bool
                            
                            .. attribute:: reason
                            
                            	Not ready reason
                            	**type**\:   :py:class:`TeSyncNotReadyReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncNotReadyReason>`
                            
                            .. attribute:: withdraw_time
                            
                            	Withdraw ready timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.Issu.Status.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus, self).__init__()

                                self.yang_name = "previous-idt-status"
                                self.yang_parent_name = "idt"

                                self.declare_time = YLeaf(YType.uint32, "declare-time")

                                self.idt_end_time = YLeaf(YType.uint32, "idt-end-time")

                                self.idt_start_time = YLeaf(YType.uint32, "idt-start-time")

                                self.is_ready_status = YLeaf(YType.boolean, "is-ready-status")

                                self.reason = YLeaf(YType.enumeration, "reason")

                                self.withdraw_time = YLeaf(YType.uint32, "withdraw-time")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("declare_time",
                                                "idt_end_time",
                                                "idt_start_time",
                                                "is_ready_status",
                                                "reason",
                                                "withdraw_time") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.Issu.Status.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.Issu.Status.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.declare_time.is_set or
                                    self.idt_end_time.is_set or
                                    self.idt_start_time.is_set or
                                    self.is_ready_status.is_set or
                                    self.reason.is_set or
                                    self.withdraw_time.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.declare_time.yfilter != YFilter.not_set or
                                    self.idt_end_time.yfilter != YFilter.not_set or
                                    self.idt_start_time.yfilter != YFilter.not_set or
                                    self.is_ready_status.yfilter != YFilter.not_set or
                                    self.reason.yfilter != YFilter.not_set or
                                    self.withdraw_time.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "previous-idt-status" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/issu/status/sync-status-information/master-sync-information/idt/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.declare_time.is_set or self.declare_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.declare_time.get_name_leafdata())
                                if (self.idt_end_time.is_set or self.idt_end_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.idt_end_time.get_name_leafdata())
                                if (self.idt_start_time.is_set or self.idt_start_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.idt_start_time.get_name_leafdata())
                                if (self.is_ready_status.is_set or self.is_ready_status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_ready_status.get_name_leafdata())
                                if (self.reason.is_set or self.reason.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reason.get_name_leafdata())
                                if (self.withdraw_time.is_set or self.withdraw_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.withdraw_time.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "declare-time" or name == "idt-end-time" or name == "idt-start-time" or name == "is-ready-status" or name == "reason" or name == "withdraw-time"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "declare-time"):
                                    self.declare_time = value
                                    self.declare_time.value_namespace = name_space
                                    self.declare_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "idt-end-time"):
                                    self.idt_end_time = value
                                    self.idt_end_time.value_namespace = name_space
                                    self.idt_end_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "idt-start-time"):
                                    self.idt_start_time = value
                                    self.idt_start_time.value_namespace = name_space
                                    self.idt_start_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-ready-status"):
                                    self.is_ready_status = value
                                    self.is_ready_status.value_namespace = name_space
                                    self.is_ready_status.value_namespace_prefix = name_space_prefix
                                if(value_path == "reason"):
                                    self.reason = value
                                    self.reason.value_namespace = name_space
                                    self.reason.value_namespace_prefix = name_space_prefix
                                if(value_path == "withdraw-time"):
                                    self.withdraw_time = value
                                    self.withdraw_time.value_namespace = name_space
                                    self.withdraw_time.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                (self.current_idt_info is not None and self.current_idt_info.has_data()) or
                                (self.previous_idt_status is not None and self.previous_idt_status.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.current_idt_info is not None and self.current_idt_info.has_operation()) or
                                (self.previous_idt_status is not None and self.previous_idt_status.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "idt" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/issu/status/sync-status-information/master-sync-information/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "current-idt-info"):
                                if (self.current_idt_info is None):
                                    self.current_idt_info = MplsTeStandby.Issu.Status.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo()
                                    self.current_idt_info.parent = self
                                    self._children_name_map["current_idt_info"] = "current-idt-info"
                                return self.current_idt_info

                            if (child_yang_name == "previous-idt-status"):
                                if (self.previous_idt_status is None):
                                    self.previous_idt_status = MplsTeStandby.Issu.Status.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus()
                                    self.previous_idt_status.parent = self
                                    self._children_name_map["previous_idt_status"] = "previous-idt-status"
                                return self.previous_idt_status

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "current-idt-info" or name == "previous-idt-status"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass

                    def has_data(self):
                        return (self.idt is not None and self.idt.has_data())

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            (self.idt is not None and self.idt.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "master-sync-information" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/issu/status/sync-status-information/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "idt"):
                            if (self.idt is None):
                                self.idt = MplsTeStandby.Issu.Status.SyncStatusInformation.MasterSyncInformation.Idt()
                                self.idt.parent = self
                                self._children_name_map["idt"] = "idt"
                            return self.idt

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "idt"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass

                def has_data(self):
                    return (
                        self.sync_show_type.is_set or
                        (self.master_sync_information is not None and self.master_sync_information.has_data()) or
                        (self.slave_sync_information is not None and self.slave_sync_information.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.sync_show_type.yfilter != YFilter.not_set or
                        (self.master_sync_information is not None and self.master_sync_information.has_operation()) or
                        (self.slave_sync_information is not None and self.slave_sync_information.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "sync-status-information" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/issu/status/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.sync_show_type.is_set or self.sync_show_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.sync_show_type.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "master-sync-information"):
                        if (self.master_sync_information is None):
                            self.master_sync_information = MplsTeStandby.Issu.Status.SyncStatusInformation.MasterSyncInformation()
                            self.master_sync_information.parent = self
                            self._children_name_map["master_sync_information"] = "master-sync-information"
                        return self.master_sync_information

                    if (child_yang_name == "slave-sync-information"):
                        if (self.slave_sync_information is None):
                            self.slave_sync_information = MplsTeStandby.Issu.Status.SyncStatusInformation.SlaveSyncInformation()
                            self.slave_sync_information.parent = self
                            self._children_name_map["slave_sync_information"] = "slave-sync-information"
                        return self.slave_sync_information

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "master-sync-information" or name == "slave-sync-information" or name == "sync-show-type"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "sync-show-type"):
                        self.sync_show_type = value
                        self.sync_show_type.value_namespace = name_space
                        self.sync_show_type.value_namespace_prefix = name_space_prefix

            def has_data(self):
                return (
                    self.role.is_set or
                    (self.sync_status_information is not None and self.sync_status_information.has_data()))

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    self.role.yfilter != YFilter.not_set or
                    (self.sync_status_information is not None and self.sync_status_information.has_operation()))

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "status" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/issu/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.role.is_set or self.role.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.role.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "sync-status-information"):
                    if (self.sync_status_information is None):
                        self.sync_status_information = MplsTeStandby.Issu.Status.SyncStatusInformation()
                        self.sync_status_information.parent = self
                        self._children_name_map["sync_status_information"] = "sync-status-information"
                    return self.sync_status_information

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "sync-status-information" or name == "role"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "role"):
                    self.role = value
                    self.role.value_namespace = name_space
                    self.role.value_namespace_prefix = name_space_prefix


        class Detail(Entity):
            """
            MPLS TE ISSU Status information
            
            .. attribute:: role
            
            	Process role
            	**type**\:   :py:class:`TeProcRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProcRole>`
            
            .. attribute:: sync_status_information
            
            	Sync information for the NSR and ISSU
            	**type**\:   :py:class:`SyncStatusInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Issu.Detail.SyncStatusInformation>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTeStandby.Issu.Detail, self).__init__()

                self.yang_name = "detail"
                self.yang_parent_name = "issu"

                self.role = YLeaf(YType.enumeration, "role")

                self.sync_status_information = MplsTeStandby.Issu.Detail.SyncStatusInformation()
                self.sync_status_information.parent = self
                self._children_name_map["sync_status_information"] = "sync-status-information"
                self._children_yang_names.add("sync-status-information")

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("role") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTeStandby.Issu.Detail, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTeStandby.Issu.Detail, self).__setattr__(name, value)


            class SyncStatusInformation(Entity):
                """
                Sync information for the NSR and ISSU
                
                .. attribute:: master_sync_information
                
                	Master sync information
                	**type**\:   :py:class:`MasterSyncInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Issu.Detail.SyncStatusInformation.MasterSyncInformation>`
                
                .. attribute:: slave_sync_information
                
                	Slave sync information
                	**type**\:   :py:class:`SlaveSyncInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Issu.Detail.SyncStatusInformation.SlaveSyncInformation>`
                
                .. attribute:: sync_show_type
                
                	SyncShowType
                	**type**\:   :py:class:`TeSyncStatusShow <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncStatusShow>`
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTeStandby.Issu.Detail.SyncStatusInformation, self).__init__()

                    self.yang_name = "sync-status-information"
                    self.yang_parent_name = "detail"

                    self.sync_show_type = YLeaf(YType.enumeration, "sync-show-type")

                    self.master_sync_information = MplsTeStandby.Issu.Detail.SyncStatusInformation.MasterSyncInformation()
                    self.master_sync_information.parent = self
                    self._children_name_map["master_sync_information"] = "master-sync-information"
                    self._children_yang_names.add("master-sync-information")

                    self.slave_sync_information = MplsTeStandby.Issu.Detail.SyncStatusInformation.SlaveSyncInformation()
                    self.slave_sync_information.parent = self
                    self._children_name_map["slave_sync_information"] = "slave-sync-information"
                    self._children_yang_names.add("slave-sync-information")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("sync_show_type") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTeStandby.Issu.Detail.SyncStatusInformation, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTeStandby.Issu.Detail.SyncStatusInformation, self).__setattr__(name, value)


                class SlaveSyncInformation(Entity):
                    """
                    Slave sync information
                    
                    .. attribute:: idt
                    
                    	Sync status IDT information
                    	**type**\:   :py:class:`Idt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.Idt>`
                    
                    .. attribute:: insync_sub_ls_ps
                    
                    	Sub\-LSPs in sync
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: insync_tunnels
                    
                    	Tunnels in sync
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: pending_sub_ls_ps
                    
                    	Sub\-LSPs in sync pending
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: pending_tunnels
                    
                    	Tunnels in sync pending
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2l_pending
                    
                    	Pending sub\-LSPs details
                    	**type**\: list of    :py:class:`S2LPending <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.S2LPending>`
                    
                    .. attribute:: vif_pending
                    
                    	Pending tunnels details
                    	**type**\: list of    :py:class:`VifPending <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.VifPending>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.Issu.Detail.SyncStatusInformation.SlaveSyncInformation, self).__init__()

                        self.yang_name = "slave-sync-information"
                        self.yang_parent_name = "sync-status-information"

                        self.insync_sub_ls_ps = YLeaf(YType.uint32, "insync-sub-ls-ps")

                        self.insync_tunnels = YLeaf(YType.uint32, "insync-tunnels")

                        self.pending_sub_ls_ps = YLeaf(YType.uint32, "pending-sub-ls-ps")

                        self.pending_tunnels = YLeaf(YType.uint32, "pending-tunnels")

                        self.idt = MplsTeStandby.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.Idt()
                        self.idt.parent = self
                        self._children_name_map["idt"] = "idt"
                        self._children_yang_names.add("idt")

                        self.s2l_pending = YList(self)
                        self.vif_pending = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("insync_sub_ls_ps",
                                        "insync_tunnels",
                                        "pending_sub_ls_ps",
                                        "pending_tunnels") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.Issu.Detail.SyncStatusInformation.SlaveSyncInformation, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.Issu.Detail.SyncStatusInformation.SlaveSyncInformation, self).__setattr__(name, value)


                    class Idt(Entity):
                        """
                        Sync status IDT information
                        
                        .. attribute:: current_idt_info
                        
                        	Current IDT information
                        	**type**\:   :py:class:`CurrentIdtInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo>`
                        
                        .. attribute:: previous_idt_status
                        
                        	Previous IDT information
                        	**type**\:   :py:class:`PreviousIdtStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.Idt, self).__init__()

                            self.yang_name = "idt"
                            self.yang_parent_name = "slave-sync-information"

                            self.current_idt_info = MplsTeStandby.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo()
                            self.current_idt_info.parent = self
                            self._children_name_map["current_idt_info"] = "current-idt-info"
                            self._children_yang_names.add("current-idt-info")

                            self.previous_idt_status = MplsTeStandby.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus()
                            self.previous_idt_status.parent = self
                            self._children_name_map["previous_idt_status"] = "previous-idt-status"
                            self._children_yang_names.add("previous-idt-status")


                        class CurrentIdtInfo(Entity):
                            """
                            Current IDT information
                            
                            .. attribute:: declare_time
                            
                            	Declare ready timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: idt_end_time
                            
                            	IDT end timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: idt_start_time
                            
                            	IDT start timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: is_ready_status
                            
                            	Ready status
                            	**type**\:  bool
                            
                            .. attribute:: reason
                            
                            	Not ready reason
                            	**type**\:   :py:class:`TeSyncNotReadyReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncNotReadyReason>`
                            
                            .. attribute:: withdraw_time
                            
                            	Withdraw ready timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo, self).__init__()

                                self.yang_name = "current-idt-info"
                                self.yang_parent_name = "idt"

                                self.declare_time = YLeaf(YType.uint32, "declare-time")

                                self.idt_end_time = YLeaf(YType.uint32, "idt-end-time")

                                self.idt_start_time = YLeaf(YType.uint32, "idt-start-time")

                                self.is_ready_status = YLeaf(YType.boolean, "is-ready-status")

                                self.reason = YLeaf(YType.enumeration, "reason")

                                self.withdraw_time = YLeaf(YType.uint32, "withdraw-time")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("declare_time",
                                                "idt_end_time",
                                                "idt_start_time",
                                                "is_ready_status",
                                                "reason",
                                                "withdraw_time") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.declare_time.is_set or
                                    self.idt_end_time.is_set or
                                    self.idt_start_time.is_set or
                                    self.is_ready_status.is_set or
                                    self.reason.is_set or
                                    self.withdraw_time.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.declare_time.yfilter != YFilter.not_set or
                                    self.idt_end_time.yfilter != YFilter.not_set or
                                    self.idt_start_time.yfilter != YFilter.not_set or
                                    self.is_ready_status.yfilter != YFilter.not_set or
                                    self.reason.yfilter != YFilter.not_set or
                                    self.withdraw_time.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "current-idt-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/issu/detail/sync-status-information/slave-sync-information/idt/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.declare_time.is_set or self.declare_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.declare_time.get_name_leafdata())
                                if (self.idt_end_time.is_set or self.idt_end_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.idt_end_time.get_name_leafdata())
                                if (self.idt_start_time.is_set or self.idt_start_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.idt_start_time.get_name_leafdata())
                                if (self.is_ready_status.is_set or self.is_ready_status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_ready_status.get_name_leafdata())
                                if (self.reason.is_set or self.reason.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reason.get_name_leafdata())
                                if (self.withdraw_time.is_set or self.withdraw_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.withdraw_time.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "declare-time" or name == "idt-end-time" or name == "idt-start-time" or name == "is-ready-status" or name == "reason" or name == "withdraw-time"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "declare-time"):
                                    self.declare_time = value
                                    self.declare_time.value_namespace = name_space
                                    self.declare_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "idt-end-time"):
                                    self.idt_end_time = value
                                    self.idt_end_time.value_namespace = name_space
                                    self.idt_end_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "idt-start-time"):
                                    self.idt_start_time = value
                                    self.idt_start_time.value_namespace = name_space
                                    self.idt_start_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-ready-status"):
                                    self.is_ready_status = value
                                    self.is_ready_status.value_namespace = name_space
                                    self.is_ready_status.value_namespace_prefix = name_space_prefix
                                if(value_path == "reason"):
                                    self.reason = value
                                    self.reason.value_namespace = name_space
                                    self.reason.value_namespace_prefix = name_space_prefix
                                if(value_path == "withdraw-time"):
                                    self.withdraw_time = value
                                    self.withdraw_time.value_namespace = name_space
                                    self.withdraw_time.value_namespace_prefix = name_space_prefix


                        class PreviousIdtStatus(Entity):
                            """
                            Previous IDT information
                            
                            .. attribute:: declare_time
                            
                            	Declare ready timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: idt_end_time
                            
                            	IDT end timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: idt_start_time
                            
                            	IDT start timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: is_ready_status
                            
                            	Ready status
                            	**type**\:  bool
                            
                            .. attribute:: reason
                            
                            	Not ready reason
                            	**type**\:   :py:class:`TeSyncNotReadyReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncNotReadyReason>`
                            
                            .. attribute:: withdraw_time
                            
                            	Withdraw ready timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus, self).__init__()

                                self.yang_name = "previous-idt-status"
                                self.yang_parent_name = "idt"

                                self.declare_time = YLeaf(YType.uint32, "declare-time")

                                self.idt_end_time = YLeaf(YType.uint32, "idt-end-time")

                                self.idt_start_time = YLeaf(YType.uint32, "idt-start-time")

                                self.is_ready_status = YLeaf(YType.boolean, "is-ready-status")

                                self.reason = YLeaf(YType.enumeration, "reason")

                                self.withdraw_time = YLeaf(YType.uint32, "withdraw-time")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("declare_time",
                                                "idt_end_time",
                                                "idt_start_time",
                                                "is_ready_status",
                                                "reason",
                                                "withdraw_time") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.declare_time.is_set or
                                    self.idt_end_time.is_set or
                                    self.idt_start_time.is_set or
                                    self.is_ready_status.is_set or
                                    self.reason.is_set or
                                    self.withdraw_time.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.declare_time.yfilter != YFilter.not_set or
                                    self.idt_end_time.yfilter != YFilter.not_set or
                                    self.idt_start_time.yfilter != YFilter.not_set or
                                    self.is_ready_status.yfilter != YFilter.not_set or
                                    self.reason.yfilter != YFilter.not_set or
                                    self.withdraw_time.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "previous-idt-status" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/issu/detail/sync-status-information/slave-sync-information/idt/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.declare_time.is_set or self.declare_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.declare_time.get_name_leafdata())
                                if (self.idt_end_time.is_set or self.idt_end_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.idt_end_time.get_name_leafdata())
                                if (self.idt_start_time.is_set or self.idt_start_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.idt_start_time.get_name_leafdata())
                                if (self.is_ready_status.is_set or self.is_ready_status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_ready_status.get_name_leafdata())
                                if (self.reason.is_set or self.reason.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reason.get_name_leafdata())
                                if (self.withdraw_time.is_set or self.withdraw_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.withdraw_time.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "declare-time" or name == "idt-end-time" or name == "idt-start-time" or name == "is-ready-status" or name == "reason" or name == "withdraw-time"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "declare-time"):
                                    self.declare_time = value
                                    self.declare_time.value_namespace = name_space
                                    self.declare_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "idt-end-time"):
                                    self.idt_end_time = value
                                    self.idt_end_time.value_namespace = name_space
                                    self.idt_end_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "idt-start-time"):
                                    self.idt_start_time = value
                                    self.idt_start_time.value_namespace = name_space
                                    self.idt_start_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-ready-status"):
                                    self.is_ready_status = value
                                    self.is_ready_status.value_namespace = name_space
                                    self.is_ready_status.value_namespace_prefix = name_space_prefix
                                if(value_path == "reason"):
                                    self.reason = value
                                    self.reason.value_namespace = name_space
                                    self.reason.value_namespace_prefix = name_space_prefix
                                if(value_path == "withdraw-time"):
                                    self.withdraw_time = value
                                    self.withdraw_time.value_namespace = name_space
                                    self.withdraw_time.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                (self.current_idt_info is not None and self.current_idt_info.has_data()) or
                                (self.previous_idt_status is not None and self.previous_idt_status.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.current_idt_info is not None and self.current_idt_info.has_operation()) or
                                (self.previous_idt_status is not None and self.previous_idt_status.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "idt" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/issu/detail/sync-status-information/slave-sync-information/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "current-idt-info"):
                                if (self.current_idt_info is None):
                                    self.current_idt_info = MplsTeStandby.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo()
                                    self.current_idt_info.parent = self
                                    self._children_name_map["current_idt_info"] = "current-idt-info"
                                return self.current_idt_info

                            if (child_yang_name == "previous-idt-status"):
                                if (self.previous_idt_status is None):
                                    self.previous_idt_status = MplsTeStandby.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus()
                                    self.previous_idt_status.parent = self
                                    self._children_name_map["previous_idt_status"] = "previous-idt-status"
                                return self.previous_idt_status

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "current-idt-info" or name == "previous-idt-status"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class VifPending(Entity):
                        """
                        Pending tunnels details
                        
                        .. attribute:: pending_reason
                        
                        	Pending reason
                        	**type**\:   :py:class:`TeSyncPendingReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncPendingReason>`
                        
                        .. attribute:: tunnel_name
                        
                        	Tunnel name
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.VifPending, self).__init__()

                            self.yang_name = "vif-pending"
                            self.yang_parent_name = "slave-sync-information"

                            self.pending_reason = YLeaf(YType.enumeration, "pending-reason")

                            self.tunnel_name = YLeaf(YType.str, "tunnel-name")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("pending_reason",
                                            "tunnel_name") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.VifPending, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.VifPending, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.pending_reason.is_set or
                                self.tunnel_name.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.pending_reason.yfilter != YFilter.not_set or
                                self.tunnel_name.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "vif-pending" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/issu/detail/sync-status-information/slave-sync-information/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.pending_reason.is_set or self.pending_reason.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.pending_reason.get_name_leafdata())
                            if (self.tunnel_name.is_set or self.tunnel_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tunnel_name.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "pending-reason" or name == "tunnel-name"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "pending-reason"):
                                self.pending_reason = value
                                self.pending_reason.value_namespace = name_space
                                self.pending_reason.value_namespace_prefix = name_space_prefix
                            if(value_path == "tunnel-name"):
                                self.tunnel_name = value
                                self.tunnel_name.value_namespace = name_space
                                self.tunnel_name.value_namespace_prefix = name_space_prefix


                    class S2LPending(Entity):
                        """
                        Pending sub\-LSPs details
                        
                        .. attribute:: pending_reason
                        
                        	Pending reason
                        	**type**\:   :py:class:`TeSyncPendingReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncPendingReason>`
                        
                        .. attribute:: s2l_role
                        
                        	S2L role
                        	**type**\:   :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        .. attribute:: signaled_name
                        
                        	Signaled name
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.S2LPending, self).__init__()

                            self.yang_name = "s2l-pending"
                            self.yang_parent_name = "slave-sync-information"

                            self.pending_reason = YLeaf(YType.enumeration, "pending-reason")

                            self.s2l_role = YLeaf(YType.enumeration, "s2l-role")

                            self.signaled_name = YLeaf(YType.str, "signaled-name")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("pending_reason",
                                            "s2l_role",
                                            "signaled_name") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.S2LPending, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.S2LPending, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.pending_reason.is_set or
                                self.s2l_role.is_set or
                                self.signaled_name.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.pending_reason.yfilter != YFilter.not_set or
                                self.s2l_role.yfilter != YFilter.not_set or
                                self.signaled_name.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "s2l-pending" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/issu/detail/sync-status-information/slave-sync-information/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.pending_reason.is_set or self.pending_reason.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.pending_reason.get_name_leafdata())
                            if (self.s2l_role.is_set or self.s2l_role.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_role.get_name_leafdata())
                            if (self.signaled_name.is_set or self.signaled_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.signaled_name.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "pending-reason" or name == "s2l-role" or name == "signaled-name"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "pending-reason"):
                                self.pending_reason = value
                                self.pending_reason.value_namespace = name_space
                                self.pending_reason.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-role"):
                                self.s2l_role = value
                                self.s2l_role.value_namespace = name_space
                                self.s2l_role.value_namespace_prefix = name_space_prefix
                            if(value_path == "signaled-name"):
                                self.signaled_name = value
                                self.signaled_name.value_namespace = name_space
                                self.signaled_name.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.s2l_pending:
                            if (c.has_data()):
                                return True
                        for c in self.vif_pending:
                            if (c.has_data()):
                                return True
                        return (
                            self.insync_sub_ls_ps.is_set or
                            self.insync_tunnels.is_set or
                            self.pending_sub_ls_ps.is_set or
                            self.pending_tunnels.is_set or
                            (self.idt is not None and self.idt.has_data()))

                    def has_operation(self):
                        for c in self.s2l_pending:
                            if (c.has_operation()):
                                return True
                        for c in self.vif_pending:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.insync_sub_ls_ps.yfilter != YFilter.not_set or
                            self.insync_tunnels.yfilter != YFilter.not_set or
                            self.pending_sub_ls_ps.yfilter != YFilter.not_set or
                            self.pending_tunnels.yfilter != YFilter.not_set or
                            (self.idt is not None and self.idt.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "slave-sync-information" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/issu/detail/sync-status-information/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.insync_sub_ls_ps.is_set or self.insync_sub_ls_ps.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.insync_sub_ls_ps.get_name_leafdata())
                        if (self.insync_tunnels.is_set or self.insync_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.insync_tunnels.get_name_leafdata())
                        if (self.pending_sub_ls_ps.is_set or self.pending_sub_ls_ps.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.pending_sub_ls_ps.get_name_leafdata())
                        if (self.pending_tunnels.is_set or self.pending_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.pending_tunnels.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "idt"):
                            if (self.idt is None):
                                self.idt = MplsTeStandby.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.Idt()
                                self.idt.parent = self
                                self._children_name_map["idt"] = "idt"
                            return self.idt

                        if (child_yang_name == "s2l-pending"):
                            for c in self.s2l_pending:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.S2LPending()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.s2l_pending.append(c)
                            return c

                        if (child_yang_name == "vif-pending"):
                            for c in self.vif_pending:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.Issu.Detail.SyncStatusInformation.SlaveSyncInformation.VifPending()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.vif_pending.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "idt" or name == "s2l-pending" or name == "vif-pending" or name == "insync-sub-ls-ps" or name == "insync-tunnels" or name == "pending-sub-ls-ps" or name == "pending-tunnels"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "insync-sub-ls-ps"):
                            self.insync_sub_ls_ps = value
                            self.insync_sub_ls_ps.value_namespace = name_space
                            self.insync_sub_ls_ps.value_namespace_prefix = name_space_prefix
                        if(value_path == "insync-tunnels"):
                            self.insync_tunnels = value
                            self.insync_tunnels.value_namespace = name_space
                            self.insync_tunnels.value_namespace_prefix = name_space_prefix
                        if(value_path == "pending-sub-ls-ps"):
                            self.pending_sub_ls_ps = value
                            self.pending_sub_ls_ps.value_namespace = name_space
                            self.pending_sub_ls_ps.value_namespace_prefix = name_space_prefix
                        if(value_path == "pending-tunnels"):
                            self.pending_tunnels = value
                            self.pending_tunnels.value_namespace = name_space
                            self.pending_tunnels.value_namespace_prefix = name_space_prefix


                class MasterSyncInformation(Entity):
                    """
                    Master sync information
                    
                    .. attribute:: idt
                    
                    	Sync status IDT information
                    	**type**\:   :py:class:`Idt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Issu.Detail.SyncStatusInformation.MasterSyncInformation.Idt>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.Issu.Detail.SyncStatusInformation.MasterSyncInformation, self).__init__()

                        self.yang_name = "master-sync-information"
                        self.yang_parent_name = "sync-status-information"

                        self.idt = MplsTeStandby.Issu.Detail.SyncStatusInformation.MasterSyncInformation.Idt()
                        self.idt.parent = self
                        self._children_name_map["idt"] = "idt"
                        self._children_yang_names.add("idt")


                    class Idt(Entity):
                        """
                        Sync status IDT information
                        
                        .. attribute:: current_idt_info
                        
                        	Current IDT information
                        	**type**\:   :py:class:`CurrentIdtInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Issu.Detail.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo>`
                        
                        .. attribute:: previous_idt_status
                        
                        	Previous IDT information
                        	**type**\:   :py:class:`PreviousIdtStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Issu.Detail.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.Issu.Detail.SyncStatusInformation.MasterSyncInformation.Idt, self).__init__()

                            self.yang_name = "idt"
                            self.yang_parent_name = "master-sync-information"

                            self.current_idt_info = MplsTeStandby.Issu.Detail.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo()
                            self.current_idt_info.parent = self
                            self._children_name_map["current_idt_info"] = "current-idt-info"
                            self._children_yang_names.add("current-idt-info")

                            self.previous_idt_status = MplsTeStandby.Issu.Detail.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus()
                            self.previous_idt_status.parent = self
                            self._children_name_map["previous_idt_status"] = "previous-idt-status"
                            self._children_yang_names.add("previous-idt-status")


                        class CurrentIdtInfo(Entity):
                            """
                            Current IDT information
                            
                            .. attribute:: declare_time
                            
                            	Declare ready timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: idt_end_time
                            
                            	IDT end timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: idt_start_time
                            
                            	IDT start timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: is_ready_status
                            
                            	Ready status
                            	**type**\:  bool
                            
                            .. attribute:: reason
                            
                            	Not ready reason
                            	**type**\:   :py:class:`TeSyncNotReadyReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncNotReadyReason>`
                            
                            .. attribute:: withdraw_time
                            
                            	Withdraw ready timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.Issu.Detail.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo, self).__init__()

                                self.yang_name = "current-idt-info"
                                self.yang_parent_name = "idt"

                                self.declare_time = YLeaf(YType.uint32, "declare-time")

                                self.idt_end_time = YLeaf(YType.uint32, "idt-end-time")

                                self.idt_start_time = YLeaf(YType.uint32, "idt-start-time")

                                self.is_ready_status = YLeaf(YType.boolean, "is-ready-status")

                                self.reason = YLeaf(YType.enumeration, "reason")

                                self.withdraw_time = YLeaf(YType.uint32, "withdraw-time")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("declare_time",
                                                "idt_end_time",
                                                "idt_start_time",
                                                "is_ready_status",
                                                "reason",
                                                "withdraw_time") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.Issu.Detail.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.Issu.Detail.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.declare_time.is_set or
                                    self.idt_end_time.is_set or
                                    self.idt_start_time.is_set or
                                    self.is_ready_status.is_set or
                                    self.reason.is_set or
                                    self.withdraw_time.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.declare_time.yfilter != YFilter.not_set or
                                    self.idt_end_time.yfilter != YFilter.not_set or
                                    self.idt_start_time.yfilter != YFilter.not_set or
                                    self.is_ready_status.yfilter != YFilter.not_set or
                                    self.reason.yfilter != YFilter.not_set or
                                    self.withdraw_time.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "current-idt-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/issu/detail/sync-status-information/master-sync-information/idt/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.declare_time.is_set or self.declare_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.declare_time.get_name_leafdata())
                                if (self.idt_end_time.is_set or self.idt_end_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.idt_end_time.get_name_leafdata())
                                if (self.idt_start_time.is_set or self.idt_start_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.idt_start_time.get_name_leafdata())
                                if (self.is_ready_status.is_set or self.is_ready_status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_ready_status.get_name_leafdata())
                                if (self.reason.is_set or self.reason.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reason.get_name_leafdata())
                                if (self.withdraw_time.is_set or self.withdraw_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.withdraw_time.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "declare-time" or name == "idt-end-time" or name == "idt-start-time" or name == "is-ready-status" or name == "reason" or name == "withdraw-time"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "declare-time"):
                                    self.declare_time = value
                                    self.declare_time.value_namespace = name_space
                                    self.declare_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "idt-end-time"):
                                    self.idt_end_time = value
                                    self.idt_end_time.value_namespace = name_space
                                    self.idt_end_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "idt-start-time"):
                                    self.idt_start_time = value
                                    self.idt_start_time.value_namespace = name_space
                                    self.idt_start_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-ready-status"):
                                    self.is_ready_status = value
                                    self.is_ready_status.value_namespace = name_space
                                    self.is_ready_status.value_namespace_prefix = name_space_prefix
                                if(value_path == "reason"):
                                    self.reason = value
                                    self.reason.value_namespace = name_space
                                    self.reason.value_namespace_prefix = name_space_prefix
                                if(value_path == "withdraw-time"):
                                    self.withdraw_time = value
                                    self.withdraw_time.value_namespace = name_space
                                    self.withdraw_time.value_namespace_prefix = name_space_prefix


                        class PreviousIdtStatus(Entity):
                            """
                            Previous IDT information
                            
                            .. attribute:: declare_time
                            
                            	Declare ready timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: idt_end_time
                            
                            	IDT end timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: idt_start_time
                            
                            	IDT start timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: is_ready_status
                            
                            	Ready status
                            	**type**\:  bool
                            
                            .. attribute:: reason
                            
                            	Not ready reason
                            	**type**\:   :py:class:`TeSyncNotReadyReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncNotReadyReason>`
                            
                            .. attribute:: withdraw_time
                            
                            	Withdraw ready timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.Issu.Detail.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus, self).__init__()

                                self.yang_name = "previous-idt-status"
                                self.yang_parent_name = "idt"

                                self.declare_time = YLeaf(YType.uint32, "declare-time")

                                self.idt_end_time = YLeaf(YType.uint32, "idt-end-time")

                                self.idt_start_time = YLeaf(YType.uint32, "idt-start-time")

                                self.is_ready_status = YLeaf(YType.boolean, "is-ready-status")

                                self.reason = YLeaf(YType.enumeration, "reason")

                                self.withdraw_time = YLeaf(YType.uint32, "withdraw-time")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("declare_time",
                                                "idt_end_time",
                                                "idt_start_time",
                                                "is_ready_status",
                                                "reason",
                                                "withdraw_time") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.Issu.Detail.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.Issu.Detail.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.declare_time.is_set or
                                    self.idt_end_time.is_set or
                                    self.idt_start_time.is_set or
                                    self.is_ready_status.is_set or
                                    self.reason.is_set or
                                    self.withdraw_time.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.declare_time.yfilter != YFilter.not_set or
                                    self.idt_end_time.yfilter != YFilter.not_set or
                                    self.idt_start_time.yfilter != YFilter.not_set or
                                    self.is_ready_status.yfilter != YFilter.not_set or
                                    self.reason.yfilter != YFilter.not_set or
                                    self.withdraw_time.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "previous-idt-status" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/issu/detail/sync-status-information/master-sync-information/idt/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.declare_time.is_set or self.declare_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.declare_time.get_name_leafdata())
                                if (self.idt_end_time.is_set or self.idt_end_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.idt_end_time.get_name_leafdata())
                                if (self.idt_start_time.is_set or self.idt_start_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.idt_start_time.get_name_leafdata())
                                if (self.is_ready_status.is_set or self.is_ready_status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_ready_status.get_name_leafdata())
                                if (self.reason.is_set or self.reason.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reason.get_name_leafdata())
                                if (self.withdraw_time.is_set or self.withdraw_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.withdraw_time.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "declare-time" or name == "idt-end-time" or name == "idt-start-time" or name == "is-ready-status" or name == "reason" or name == "withdraw-time"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "declare-time"):
                                    self.declare_time = value
                                    self.declare_time.value_namespace = name_space
                                    self.declare_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "idt-end-time"):
                                    self.idt_end_time = value
                                    self.idt_end_time.value_namespace = name_space
                                    self.idt_end_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "idt-start-time"):
                                    self.idt_start_time = value
                                    self.idt_start_time.value_namespace = name_space
                                    self.idt_start_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-ready-status"):
                                    self.is_ready_status = value
                                    self.is_ready_status.value_namespace = name_space
                                    self.is_ready_status.value_namespace_prefix = name_space_prefix
                                if(value_path == "reason"):
                                    self.reason = value
                                    self.reason.value_namespace = name_space
                                    self.reason.value_namespace_prefix = name_space_prefix
                                if(value_path == "withdraw-time"):
                                    self.withdraw_time = value
                                    self.withdraw_time.value_namespace = name_space
                                    self.withdraw_time.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                (self.current_idt_info is not None and self.current_idt_info.has_data()) or
                                (self.previous_idt_status is not None and self.previous_idt_status.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.current_idt_info is not None and self.current_idt_info.has_operation()) or
                                (self.previous_idt_status is not None and self.previous_idt_status.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "idt" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/issu/detail/sync-status-information/master-sync-information/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "current-idt-info"):
                                if (self.current_idt_info is None):
                                    self.current_idt_info = MplsTeStandby.Issu.Detail.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo()
                                    self.current_idt_info.parent = self
                                    self._children_name_map["current_idt_info"] = "current-idt-info"
                                return self.current_idt_info

                            if (child_yang_name == "previous-idt-status"):
                                if (self.previous_idt_status is None):
                                    self.previous_idt_status = MplsTeStandby.Issu.Detail.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus()
                                    self.previous_idt_status.parent = self
                                    self._children_name_map["previous_idt_status"] = "previous-idt-status"
                                return self.previous_idt_status

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "current-idt-info" or name == "previous-idt-status"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass

                    def has_data(self):
                        return (self.idt is not None and self.idt.has_data())

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            (self.idt is not None and self.idt.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "master-sync-information" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/issu/detail/sync-status-information/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "idt"):
                            if (self.idt is None):
                                self.idt = MplsTeStandby.Issu.Detail.SyncStatusInformation.MasterSyncInformation.Idt()
                                self.idt.parent = self
                                self._children_name_map["idt"] = "idt"
                            return self.idt

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "idt"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass

                def has_data(self):
                    return (
                        self.sync_show_type.is_set or
                        (self.master_sync_information is not None and self.master_sync_information.has_data()) or
                        (self.slave_sync_information is not None and self.slave_sync_information.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.sync_show_type.yfilter != YFilter.not_set or
                        (self.master_sync_information is not None and self.master_sync_information.has_operation()) or
                        (self.slave_sync_information is not None and self.slave_sync_information.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "sync-status-information" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/issu/detail/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.sync_show_type.is_set or self.sync_show_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.sync_show_type.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "master-sync-information"):
                        if (self.master_sync_information is None):
                            self.master_sync_information = MplsTeStandby.Issu.Detail.SyncStatusInformation.MasterSyncInformation()
                            self.master_sync_information.parent = self
                            self._children_name_map["master_sync_information"] = "master-sync-information"
                        return self.master_sync_information

                    if (child_yang_name == "slave-sync-information"):
                        if (self.slave_sync_information is None):
                            self.slave_sync_information = MplsTeStandby.Issu.Detail.SyncStatusInformation.SlaveSyncInformation()
                            self.slave_sync_information.parent = self
                            self._children_name_map["slave_sync_information"] = "slave-sync-information"
                        return self.slave_sync_information

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "master-sync-information" or name == "slave-sync-information" or name == "sync-show-type"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "sync-show-type"):
                        self.sync_show_type = value
                        self.sync_show_type.value_namespace = name_space
                        self.sync_show_type.value_namespace_prefix = name_space_prefix

            def has_data(self):
                return (
                    self.role.is_set or
                    (self.sync_status_information is not None and self.sync_status_information.has_data()))

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    self.role.yfilter != YFilter.not_set or
                    (self.sync_status_information is not None and self.sync_status_information.has_operation()))

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "detail" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/issu/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.role.is_set or self.role.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.role.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "sync-status-information"):
                    if (self.sync_status_information is None):
                        self.sync_status_information = MplsTeStandby.Issu.Detail.SyncStatusInformation()
                        self.sync_status_information.parent = self
                        self._children_name_map["sync_status_information"] = "sync-status-information"
                    return self.sync_status_information

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "sync-status-information" or name == "role"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "role"):
                    self.role = value
                    self.role.value_namespace = name_space
                    self.role.value_namespace_prefix = name_space_prefix

        def has_data(self):
            return (
                (self.detail is not None and self.detail.has_data()) or
                (self.status is not None and self.status.has_data()))

        def has_operation(self):
            return (
                self.yfilter != YFilter.not_set or
                (self.detail is not None and self.detail.has_operation()) or
                (self.status is not None and self.status.has_operation()))

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "issu" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "detail"):
                if (self.detail is None):
                    self.detail = MplsTeStandby.Issu.Detail()
                    self.detail.parent = self
                    self._children_name_map["detail"] = "detail"
                return self.detail

            if (child_yang_name == "status"):
                if (self.status is None):
                    self.status = MplsTeStandby.Issu.Status()
                    self.status.parent = self
                    self._children_name_map["status"] = "status"
                return self.status

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "detail" or name == "status"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class FastReroute(Entity):
        """
        Represent all the fastreroute info in MPLS\-TE
        
        .. attribute:: backup_tunnels
        
        	The set of fastreroute backup tunnels available in MPLS\-TE
        	**type**\:   :py:class:`BackupTunnels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.FastReroute.BackupTunnels>`
        
        .. attribute:: promotion
        
        	The info about the promotion timer of backup tunnels
        	**type**\:   :py:class:`Promotion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.FastReroute.Promotion>`
        
        .. attribute:: protected_interfaces
        
        	The set of fastreroute protected interfaces available in MPLS\-TE
        	**type**\:   :py:class:`ProtectedInterfaces <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.FastReroute.ProtectedInterfaces>`
        
        .. attribute:: protections
        
        	The set of fastreroute protected interfaces available in MPLS\-TE
        	**type**\:   :py:class:`Protections <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.FastReroute.Protections>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsTeStandby.FastReroute, self).__init__()

            self.yang_name = "fast-reroute"
            self.yang_parent_name = "mpls-te-standby"

            self.backup_tunnels = MplsTeStandby.FastReroute.BackupTunnels()
            self.backup_tunnels.parent = self
            self._children_name_map["backup_tunnels"] = "backup-tunnels"
            self._children_yang_names.add("backup-tunnels")

            self.promotion = MplsTeStandby.FastReroute.Promotion()
            self.promotion.parent = self
            self._children_name_map["promotion"] = "promotion"
            self._children_yang_names.add("promotion")

            self.protected_interfaces = MplsTeStandby.FastReroute.ProtectedInterfaces()
            self.protected_interfaces.parent = self
            self._children_name_map["protected_interfaces"] = "protected-interfaces"
            self._children_yang_names.add("protected-interfaces")

            self.protections = MplsTeStandby.FastReroute.Protections()
            self.protections.parent = self
            self._children_name_map["protections"] = "protections"
            self._children_yang_names.add("protections")


        class BackupTunnels(Entity):
            """
            The set of fastreroute backup tunnels available
            in MPLS\-TE
            
            .. attribute:: backup_tunnel
            
            	Fastreroute info for a given backup tunnel
            	**type**\: list of    :py:class:`BackupTunnel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.FastReroute.BackupTunnels.BackupTunnel>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTeStandby.FastReroute.BackupTunnels, self).__init__()

                self.yang_name = "backup-tunnels"
                self.yang_parent_name = "fast-reroute"

                self.backup_tunnel = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTeStandby.FastReroute.BackupTunnels, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTeStandby.FastReroute.BackupTunnels, self).__setattr__(name, value)


            class BackupTunnel(Entity):
                """
                Fastreroute info for a given backup tunnel
                
                .. attribute:: tunnel_name  <key>
                
                	Backup tunnel name
                	**type**\:  str
                
                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                
                .. attribute:: interface_name  <key>
                
                	Protected interface name
                	**type**\:  str
                
                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                
                .. attribute:: backup_status
                
                	Backup state
                	**type**\:   :py:class:`MplsTeBackupStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBackupStatus>`
                
                .. attribute:: backup_tunnel_id
                
                	Backup tunnel ID
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: backup_tunnel_name_xr
                
                	Backup tunnel name
                	**type**\:  str
                
                .. attribute:: backup_type
                
                	Backup type
                	**type**\:   :py:class:`MplsTeBackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBackup>`
                
                .. attribute:: backup_usage
                
                	Backup usage
                	**type**\:   :py:class:`MplsTeBackupUsage <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBackupUsage>`
                
                .. attribute:: bandwidth
                
                	Bandwidth (kbps)
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: kbit/s
                
                .. attribute:: bandwidth_limit_type
                
                	Bandwidth limit type
                	**type**\:   :py:class:`MplsTeBwLimit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwLimit>`
                
                .. attribute:: bandwidth_pool_type
                
                	Bandwidth pool type
                	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                
                .. attribute:: connection_status
                
                	Backup's connection's status
                	**type**\:   :py:class:`MplsTeTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelState>`
                
                .. attribute:: destination_address
                
                	Backup's destination
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: frr_active_ls_ps
                
                	Number of LSPs in FRR active state
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: frr_active_soft_preempted_ls_ps
                
                	Number of soft preempted LSPs routed over backup
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: general_status
                
                	Backup's general status
                	**type**\:   :py:class:`MplsTeTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelState>`
                
                .. attribute:: has_attribute_set
                
                	TRUE if the auto\-backup has an attribute set defined
                	**type**\:  bool
                
                .. attribute:: in_use_bandwidth
                
                	Bandwidth currently in use (kbps)
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: kbit/s
                
                .. attribute:: is_attribute_set_in_db
                
                	Flag to indicate the existence of attribute set found in database
                	**type**\:  bool
                
                .. attribute:: ls_ps
                
                	Number of LSPs
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: output_interface_name
                
                	The output intf of the tunnel
                	**type**\:  str
                
                .. attribute:: prot_interface_autobackup_config
                
                	Protected interface Autobackup config
                	**type**\:   :py:class:`AutoBackupProtection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.AutoBackupProtection>`
                
                .. attribute:: prot_interface_srlg_config
                
                	Protected interface SRLG config
                	**type**\:   :py:class:`AutoBackupSrlgMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.AutoBackupSrlgMode>`
                
                .. attribute:: recreate_remaining_time
                
                	Time Remaining in Recreate Timer (seconds)
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: second
                
                .. attribute:: recreate_timer_is_running
                
                	Indicates if the recreate timer is running
                	**type**\:  bool
                
                .. attribute:: s2_ls
                
                	Number of P2MP S2Ls
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: s2l_families
                
                	Number of S2L Families
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: soft_preempted_in_use_bandwidth
                
                	Bandwidth soft preempted and rerouted over the backup(kbps)
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: kbit/s
                
                .. attribute:: source_address
                
                	Backup's source
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: tunnel_attribute_set_name
                
                	Attribute Set Name
                	**type**\:  str
                
                .. attribute:: tunnel_instance
                
                	Tunnel instance
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTeStandby.FastReroute.BackupTunnels.BackupTunnel, self).__init__()

                    self.yang_name = "backup-tunnel"
                    self.yang_parent_name = "backup-tunnels"

                    self.tunnel_name = YLeaf(YType.str, "tunnel-name")

                    self.interface_name = YLeaf(YType.str, "interface-name")

                    self.backup_status = YLeaf(YType.enumeration, "backup-status")

                    self.backup_tunnel_id = YLeaf(YType.uint32, "backup-tunnel-id")

                    self.backup_tunnel_name_xr = YLeaf(YType.str, "backup-tunnel-name-xr")

                    self.backup_type = YLeaf(YType.enumeration, "backup-type")

                    self.backup_usage = YLeaf(YType.enumeration, "backup-usage")

                    self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                    self.bandwidth_limit_type = YLeaf(YType.enumeration, "bandwidth-limit-type")

                    self.bandwidth_pool_type = YLeaf(YType.enumeration, "bandwidth-pool-type")

                    self.connection_status = YLeaf(YType.enumeration, "connection-status")

                    self.destination_address = YLeaf(YType.str, "destination-address")

                    self.frr_active_ls_ps = YLeaf(YType.uint32, "frr-active-ls-ps")

                    self.frr_active_soft_preempted_ls_ps = YLeaf(YType.uint32, "frr-active-soft-preempted-ls-ps")

                    self.general_status = YLeaf(YType.enumeration, "general-status")

                    self.has_attribute_set = YLeaf(YType.boolean, "has-attribute-set")

                    self.in_use_bandwidth = YLeaf(YType.uint32, "in-use-bandwidth")

                    self.is_attribute_set_in_db = YLeaf(YType.boolean, "is-attribute-set-in-db")

                    self.ls_ps = YLeaf(YType.uint32, "ls-ps")

                    self.output_interface_name = YLeaf(YType.str, "output-interface-name")

                    self.prot_interface_autobackup_config = YLeaf(YType.enumeration, "prot-interface-autobackup-config")

                    self.prot_interface_srlg_config = YLeaf(YType.enumeration, "prot-interface-srlg-config")

                    self.recreate_remaining_time = YLeaf(YType.uint32, "recreate-remaining-time")

                    self.recreate_timer_is_running = YLeaf(YType.boolean, "recreate-timer-is-running")

                    self.s2_ls = YLeaf(YType.uint32, "s2-ls")

                    self.s2l_families = YLeaf(YType.uint32, "s2l-families")

                    self.soft_preempted_in_use_bandwidth = YLeaf(YType.uint32, "soft-preempted-in-use-bandwidth")

                    self.source_address = YLeaf(YType.str, "source-address")

                    self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                    self.tunnel_instance = YLeaf(YType.uint32, "tunnel-instance")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("tunnel_name",
                                    "interface_name",
                                    "backup_status",
                                    "backup_tunnel_id",
                                    "backup_tunnel_name_xr",
                                    "backup_type",
                                    "backup_usage",
                                    "bandwidth",
                                    "bandwidth_limit_type",
                                    "bandwidth_pool_type",
                                    "connection_status",
                                    "destination_address",
                                    "frr_active_ls_ps",
                                    "frr_active_soft_preempted_ls_ps",
                                    "general_status",
                                    "has_attribute_set",
                                    "in_use_bandwidth",
                                    "is_attribute_set_in_db",
                                    "ls_ps",
                                    "output_interface_name",
                                    "prot_interface_autobackup_config",
                                    "prot_interface_srlg_config",
                                    "recreate_remaining_time",
                                    "recreate_timer_is_running",
                                    "s2_ls",
                                    "s2l_families",
                                    "soft_preempted_in_use_bandwidth",
                                    "source_address",
                                    "tunnel_attribute_set_name",
                                    "tunnel_instance") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTeStandby.FastReroute.BackupTunnels.BackupTunnel, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTeStandby.FastReroute.BackupTunnels.BackupTunnel, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.tunnel_name.is_set or
                        self.interface_name.is_set or
                        self.backup_status.is_set or
                        self.backup_tunnel_id.is_set or
                        self.backup_tunnel_name_xr.is_set or
                        self.backup_type.is_set or
                        self.backup_usage.is_set or
                        self.bandwidth.is_set or
                        self.bandwidth_limit_type.is_set or
                        self.bandwidth_pool_type.is_set or
                        self.connection_status.is_set or
                        self.destination_address.is_set or
                        self.frr_active_ls_ps.is_set or
                        self.frr_active_soft_preempted_ls_ps.is_set or
                        self.general_status.is_set or
                        self.has_attribute_set.is_set or
                        self.in_use_bandwidth.is_set or
                        self.is_attribute_set_in_db.is_set or
                        self.ls_ps.is_set or
                        self.output_interface_name.is_set or
                        self.prot_interface_autobackup_config.is_set or
                        self.prot_interface_srlg_config.is_set or
                        self.recreate_remaining_time.is_set or
                        self.recreate_timer_is_running.is_set or
                        self.s2_ls.is_set or
                        self.s2l_families.is_set or
                        self.soft_preempted_in_use_bandwidth.is_set or
                        self.source_address.is_set or
                        self.tunnel_attribute_set_name.is_set or
                        self.tunnel_instance.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.tunnel_name.yfilter != YFilter.not_set or
                        self.interface_name.yfilter != YFilter.not_set or
                        self.backup_status.yfilter != YFilter.not_set or
                        self.backup_tunnel_id.yfilter != YFilter.not_set or
                        self.backup_tunnel_name_xr.yfilter != YFilter.not_set or
                        self.backup_type.yfilter != YFilter.not_set or
                        self.backup_usage.yfilter != YFilter.not_set or
                        self.bandwidth.yfilter != YFilter.not_set or
                        self.bandwidth_limit_type.yfilter != YFilter.not_set or
                        self.bandwidth_pool_type.yfilter != YFilter.not_set or
                        self.connection_status.yfilter != YFilter.not_set or
                        self.destination_address.yfilter != YFilter.not_set or
                        self.frr_active_ls_ps.yfilter != YFilter.not_set or
                        self.frr_active_soft_preempted_ls_ps.yfilter != YFilter.not_set or
                        self.general_status.yfilter != YFilter.not_set or
                        self.has_attribute_set.yfilter != YFilter.not_set or
                        self.in_use_bandwidth.yfilter != YFilter.not_set or
                        self.is_attribute_set_in_db.yfilter != YFilter.not_set or
                        self.ls_ps.yfilter != YFilter.not_set or
                        self.output_interface_name.yfilter != YFilter.not_set or
                        self.prot_interface_autobackup_config.yfilter != YFilter.not_set or
                        self.prot_interface_srlg_config.yfilter != YFilter.not_set or
                        self.recreate_remaining_time.yfilter != YFilter.not_set or
                        self.recreate_timer_is_running.yfilter != YFilter.not_set or
                        self.s2_ls.yfilter != YFilter.not_set or
                        self.s2l_families.yfilter != YFilter.not_set or
                        self.soft_preempted_in_use_bandwidth.yfilter != YFilter.not_set or
                        self.source_address.yfilter != YFilter.not_set or
                        self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                        self.tunnel_instance.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "backup-tunnel" + "[tunnel-name='" + self.tunnel_name.get() + "']" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/fast-reroute/backup-tunnels/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.tunnel_name.is_set or self.tunnel_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_name.get_name_leafdata())
                    if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.interface_name.get_name_leafdata())
                    if (self.backup_status.is_set or self.backup_status.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.backup_status.get_name_leafdata())
                    if (self.backup_tunnel_id.is_set or self.backup_tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.backup_tunnel_id.get_name_leafdata())
                    if (self.backup_tunnel_name_xr.is_set or self.backup_tunnel_name_xr.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.backup_tunnel_name_xr.get_name_leafdata())
                    if (self.backup_type.is_set or self.backup_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.backup_type.get_name_leafdata())
                    if (self.backup_usage.is_set or self.backup_usage.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.backup_usage.get_name_leafdata())
                    if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.bandwidth.get_name_leafdata())
                    if (self.bandwidth_limit_type.is_set or self.bandwidth_limit_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.bandwidth_limit_type.get_name_leafdata())
                    if (self.bandwidth_pool_type.is_set or self.bandwidth_pool_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.bandwidth_pool_type.get_name_leafdata())
                    if (self.connection_status.is_set or self.connection_status.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.connection_status.get_name_leafdata())
                    if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.destination_address.get_name_leafdata())
                    if (self.frr_active_ls_ps.is_set or self.frr_active_ls_ps.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.frr_active_ls_ps.get_name_leafdata())
                    if (self.frr_active_soft_preempted_ls_ps.is_set or self.frr_active_soft_preempted_ls_ps.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.frr_active_soft_preempted_ls_ps.get_name_leafdata())
                    if (self.general_status.is_set or self.general_status.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.general_status.get_name_leafdata())
                    if (self.has_attribute_set.is_set or self.has_attribute_set.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.has_attribute_set.get_name_leafdata())
                    if (self.in_use_bandwidth.is_set or self.in_use_bandwidth.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.in_use_bandwidth.get_name_leafdata())
                    if (self.is_attribute_set_in_db.is_set or self.is_attribute_set_in_db.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_attribute_set_in_db.get_name_leafdata())
                    if (self.ls_ps.is_set or self.ls_ps.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.ls_ps.get_name_leafdata())
                    if (self.output_interface_name.is_set or self.output_interface_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.output_interface_name.get_name_leafdata())
                    if (self.prot_interface_autobackup_config.is_set or self.prot_interface_autobackup_config.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.prot_interface_autobackup_config.get_name_leafdata())
                    if (self.prot_interface_srlg_config.is_set or self.prot_interface_srlg_config.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.prot_interface_srlg_config.get_name_leafdata())
                    if (self.recreate_remaining_time.is_set or self.recreate_remaining_time.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.recreate_remaining_time.get_name_leafdata())
                    if (self.recreate_timer_is_running.is_set or self.recreate_timer_is_running.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.recreate_timer_is_running.get_name_leafdata())
                    if (self.s2_ls.is_set or self.s2_ls.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.s2_ls.get_name_leafdata())
                    if (self.s2l_families.is_set or self.s2l_families.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.s2l_families.get_name_leafdata())
                    if (self.soft_preempted_in_use_bandwidth.is_set or self.soft_preempted_in_use_bandwidth.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.soft_preempted_in_use_bandwidth.get_name_leafdata())
                    if (self.source_address.is_set or self.source_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.source_address.get_name_leafdata())
                    if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                    if (self.tunnel_instance.is_set or self.tunnel_instance.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_instance.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "tunnel-name" or name == "interface-name" or name == "backup-status" or name == "backup-tunnel-id" or name == "backup-tunnel-name-xr" or name == "backup-type" or name == "backup-usage" or name == "bandwidth" or name == "bandwidth-limit-type" or name == "bandwidth-pool-type" or name == "connection-status" or name == "destination-address" or name == "frr-active-ls-ps" or name == "frr-active-soft-preempted-ls-ps" or name == "general-status" or name == "has-attribute-set" or name == "in-use-bandwidth" or name == "is-attribute-set-in-db" or name == "ls-ps" or name == "output-interface-name" or name == "prot-interface-autobackup-config" or name == "prot-interface-srlg-config" or name == "recreate-remaining-time" or name == "recreate-timer-is-running" or name == "s2-ls" or name == "s2l-families" or name == "soft-preempted-in-use-bandwidth" or name == "source-address" or name == "tunnel-attribute-set-name" or name == "tunnel-instance"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "tunnel-name"):
                        self.tunnel_name = value
                        self.tunnel_name.value_namespace = name_space
                        self.tunnel_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "interface-name"):
                        self.interface_name = value
                        self.interface_name.value_namespace = name_space
                        self.interface_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "backup-status"):
                        self.backup_status = value
                        self.backup_status.value_namespace = name_space
                        self.backup_status.value_namespace_prefix = name_space_prefix
                    if(value_path == "backup-tunnel-id"):
                        self.backup_tunnel_id = value
                        self.backup_tunnel_id.value_namespace = name_space
                        self.backup_tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "backup-tunnel-name-xr"):
                        self.backup_tunnel_name_xr = value
                        self.backup_tunnel_name_xr.value_namespace = name_space
                        self.backup_tunnel_name_xr.value_namespace_prefix = name_space_prefix
                    if(value_path == "backup-type"):
                        self.backup_type = value
                        self.backup_type.value_namespace = name_space
                        self.backup_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "backup-usage"):
                        self.backup_usage = value
                        self.backup_usage.value_namespace = name_space
                        self.backup_usage.value_namespace_prefix = name_space_prefix
                    if(value_path == "bandwidth"):
                        self.bandwidth = value
                        self.bandwidth.value_namespace = name_space
                        self.bandwidth.value_namespace_prefix = name_space_prefix
                    if(value_path == "bandwidth-limit-type"):
                        self.bandwidth_limit_type = value
                        self.bandwidth_limit_type.value_namespace = name_space
                        self.bandwidth_limit_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "bandwidth-pool-type"):
                        self.bandwidth_pool_type = value
                        self.bandwidth_pool_type.value_namespace = name_space
                        self.bandwidth_pool_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "connection-status"):
                        self.connection_status = value
                        self.connection_status.value_namespace = name_space
                        self.connection_status.value_namespace_prefix = name_space_prefix
                    if(value_path == "destination-address"):
                        self.destination_address = value
                        self.destination_address.value_namespace = name_space
                        self.destination_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "frr-active-ls-ps"):
                        self.frr_active_ls_ps = value
                        self.frr_active_ls_ps.value_namespace = name_space
                        self.frr_active_ls_ps.value_namespace_prefix = name_space_prefix
                    if(value_path == "frr-active-soft-preempted-ls-ps"):
                        self.frr_active_soft_preempted_ls_ps = value
                        self.frr_active_soft_preempted_ls_ps.value_namespace = name_space
                        self.frr_active_soft_preempted_ls_ps.value_namespace_prefix = name_space_prefix
                    if(value_path == "general-status"):
                        self.general_status = value
                        self.general_status.value_namespace = name_space
                        self.general_status.value_namespace_prefix = name_space_prefix
                    if(value_path == "has-attribute-set"):
                        self.has_attribute_set = value
                        self.has_attribute_set.value_namespace = name_space
                        self.has_attribute_set.value_namespace_prefix = name_space_prefix
                    if(value_path == "in-use-bandwidth"):
                        self.in_use_bandwidth = value
                        self.in_use_bandwidth.value_namespace = name_space
                        self.in_use_bandwidth.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-attribute-set-in-db"):
                        self.is_attribute_set_in_db = value
                        self.is_attribute_set_in_db.value_namespace = name_space
                        self.is_attribute_set_in_db.value_namespace_prefix = name_space_prefix
                    if(value_path == "ls-ps"):
                        self.ls_ps = value
                        self.ls_ps.value_namespace = name_space
                        self.ls_ps.value_namespace_prefix = name_space_prefix
                    if(value_path == "output-interface-name"):
                        self.output_interface_name = value
                        self.output_interface_name.value_namespace = name_space
                        self.output_interface_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "prot-interface-autobackup-config"):
                        self.prot_interface_autobackup_config = value
                        self.prot_interface_autobackup_config.value_namespace = name_space
                        self.prot_interface_autobackup_config.value_namespace_prefix = name_space_prefix
                    if(value_path == "prot-interface-srlg-config"):
                        self.prot_interface_srlg_config = value
                        self.prot_interface_srlg_config.value_namespace = name_space
                        self.prot_interface_srlg_config.value_namespace_prefix = name_space_prefix
                    if(value_path == "recreate-remaining-time"):
                        self.recreate_remaining_time = value
                        self.recreate_remaining_time.value_namespace = name_space
                        self.recreate_remaining_time.value_namespace_prefix = name_space_prefix
                    if(value_path == "recreate-timer-is-running"):
                        self.recreate_timer_is_running = value
                        self.recreate_timer_is_running.value_namespace = name_space
                        self.recreate_timer_is_running.value_namespace_prefix = name_space_prefix
                    if(value_path == "s2-ls"):
                        self.s2_ls = value
                        self.s2_ls.value_namespace = name_space
                        self.s2_ls.value_namespace_prefix = name_space_prefix
                    if(value_path == "s2l-families"):
                        self.s2l_families = value
                        self.s2l_families.value_namespace = name_space
                        self.s2l_families.value_namespace_prefix = name_space_prefix
                    if(value_path == "soft-preempted-in-use-bandwidth"):
                        self.soft_preempted_in_use_bandwidth = value
                        self.soft_preempted_in_use_bandwidth.value_namespace = name_space
                        self.soft_preempted_in_use_bandwidth.value_namespace_prefix = name_space_prefix
                    if(value_path == "source-address"):
                        self.source_address = value
                        self.source_address.value_namespace = name_space
                        self.source_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-attribute-set-name"):
                        self.tunnel_attribute_set_name = value
                        self.tunnel_attribute_set_name.value_namespace = name_space
                        self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-instance"):
                        self.tunnel_instance = value
                        self.tunnel_instance.value_namespace = name_space
                        self.tunnel_instance.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.backup_tunnel:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.backup_tunnel:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "backup-tunnels" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/fast-reroute/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "backup-tunnel"):
                    for c in self.backup_tunnel:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTeStandby.FastReroute.BackupTunnels.BackupTunnel()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.backup_tunnel.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "backup-tunnel"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass


        class ProtectedInterfaces(Entity):
            """
            The set of fastreroute protected interfaces
            available in MPLS\-TE
            
            .. attribute:: protected_interface
            
            	Fastreroute info for a given protected interface
            	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.FastReroute.ProtectedInterfaces.ProtectedInterface>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTeStandby.FastReroute.ProtectedInterfaces, self).__init__()

                self.yang_name = "protected-interfaces"
                self.yang_parent_name = "fast-reroute"

                self.protected_interface = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTeStandby.FastReroute.ProtectedInterfaces, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTeStandby.FastReroute.ProtectedInterfaces, self).__setattr__(name, value)


            class ProtectedInterface(Entity):
                """
                Fastreroute info for a given protected
                interface
                
                .. attribute:: interface_name  <key>
                
                	Protected interface name
                	**type**\:  str
                
                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                
                .. attribute:: backup_tunnel_name  <key>
                
                	Backup tunnel name
                	**type**\:  str
                
                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                
                .. attribute:: backup_status
                
                	Backup state
                	**type**\:   :py:class:`MplsTeBackupStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBackupStatus>`
                
                .. attribute:: backup_tunnel_id
                
                	Backup tunnel ID
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: backup_tunnel_name_xr
                
                	Backup tunnel name
                	**type**\:  str
                
                .. attribute:: backup_type
                
                	Backup type
                	**type**\:   :py:class:`MplsTeBackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBackup>`
                
                .. attribute:: backup_usage
                
                	Backup usage
                	**type**\:   :py:class:`MplsTeBackupUsage <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBackupUsage>`
                
                .. attribute:: bandwidth
                
                	Bandwidth (kbps)
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: kbit/s
                
                .. attribute:: bandwidth_limit_type
                
                	Bandwidth limit type
                	**type**\:   :py:class:`MplsTeBwLimit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwLimit>`
                
                .. attribute:: bandwidth_pool_type
                
                	Bandwidth pool type
                	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                
                .. attribute:: connection_status
                
                	Backup's connection's status
                	**type**\:   :py:class:`MplsTeTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelState>`
                
                .. attribute:: destination_address
                
                	Backup's destination
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: frr_active_ls_ps
                
                	Number of LSPs in FRR active state
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: frr_active_soft_preempted_ls_ps
                
                	Number of soft preempted LSPs routed over backup
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: general_status
                
                	Backup's general status
                	**type**\:   :py:class:`MplsTeTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelState>`
                
                .. attribute:: has_attribute_set
                
                	TRUE if the auto\-backup has an attribute set defined
                	**type**\:  bool
                
                .. attribute:: in_use_bandwidth
                
                	Bandwidth currently in use (kbps)
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: kbit/s
                
                .. attribute:: is_attribute_set_in_db
                
                	Flag to indicate the existence of attribute set found in database
                	**type**\:  bool
                
                .. attribute:: ls_ps
                
                	Number of LSPs
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: output_interface_name
                
                	The output intf of the tunnel
                	**type**\:  str
                
                .. attribute:: prot_interface_autobackup_config
                
                	Protected interface Autobackup config
                	**type**\:   :py:class:`AutoBackupProtection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.AutoBackupProtection>`
                
                .. attribute:: prot_interface_srlg_config
                
                	Protected interface SRLG config
                	**type**\:   :py:class:`AutoBackupSrlgMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.AutoBackupSrlgMode>`
                
                .. attribute:: recreate_remaining_time
                
                	Time Remaining in Recreate Timer (seconds)
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: second
                
                .. attribute:: recreate_timer_is_running
                
                	Indicates if the recreate timer is running
                	**type**\:  bool
                
                .. attribute:: s2_ls
                
                	Number of P2MP S2Ls
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: s2l_families
                
                	Number of S2L Families
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: soft_preempted_in_use_bandwidth
                
                	Bandwidth soft preempted and rerouted over the backup(kbps)
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: kbit/s
                
                .. attribute:: source_address
                
                	Backup's source
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: tunnel_attribute_set_name
                
                	Attribute Set Name
                	**type**\:  str
                
                .. attribute:: tunnel_instance
                
                	Tunnel instance
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTeStandby.FastReroute.ProtectedInterfaces.ProtectedInterface, self).__init__()

                    self.yang_name = "protected-interface"
                    self.yang_parent_name = "protected-interfaces"

                    self.interface_name = YLeaf(YType.str, "interface-name")

                    self.backup_tunnel_name = YLeaf(YType.str, "backup-tunnel-name")

                    self.backup_status = YLeaf(YType.enumeration, "backup-status")

                    self.backup_tunnel_id = YLeaf(YType.uint32, "backup-tunnel-id")

                    self.backup_tunnel_name_xr = YLeaf(YType.str, "backup-tunnel-name-xr")

                    self.backup_type = YLeaf(YType.enumeration, "backup-type")

                    self.backup_usage = YLeaf(YType.enumeration, "backup-usage")

                    self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                    self.bandwidth_limit_type = YLeaf(YType.enumeration, "bandwidth-limit-type")

                    self.bandwidth_pool_type = YLeaf(YType.enumeration, "bandwidth-pool-type")

                    self.connection_status = YLeaf(YType.enumeration, "connection-status")

                    self.destination_address = YLeaf(YType.str, "destination-address")

                    self.frr_active_ls_ps = YLeaf(YType.uint32, "frr-active-ls-ps")

                    self.frr_active_soft_preempted_ls_ps = YLeaf(YType.uint32, "frr-active-soft-preempted-ls-ps")

                    self.general_status = YLeaf(YType.enumeration, "general-status")

                    self.has_attribute_set = YLeaf(YType.boolean, "has-attribute-set")

                    self.in_use_bandwidth = YLeaf(YType.uint32, "in-use-bandwidth")

                    self.is_attribute_set_in_db = YLeaf(YType.boolean, "is-attribute-set-in-db")

                    self.ls_ps = YLeaf(YType.uint32, "ls-ps")

                    self.output_interface_name = YLeaf(YType.str, "output-interface-name")

                    self.prot_interface_autobackup_config = YLeaf(YType.enumeration, "prot-interface-autobackup-config")

                    self.prot_interface_srlg_config = YLeaf(YType.enumeration, "prot-interface-srlg-config")

                    self.recreate_remaining_time = YLeaf(YType.uint32, "recreate-remaining-time")

                    self.recreate_timer_is_running = YLeaf(YType.boolean, "recreate-timer-is-running")

                    self.s2_ls = YLeaf(YType.uint32, "s2-ls")

                    self.s2l_families = YLeaf(YType.uint32, "s2l-families")

                    self.soft_preempted_in_use_bandwidth = YLeaf(YType.uint32, "soft-preempted-in-use-bandwidth")

                    self.source_address = YLeaf(YType.str, "source-address")

                    self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                    self.tunnel_instance = YLeaf(YType.uint32, "tunnel-instance")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("interface_name",
                                    "backup_tunnel_name",
                                    "backup_status",
                                    "backup_tunnel_id",
                                    "backup_tunnel_name_xr",
                                    "backup_type",
                                    "backup_usage",
                                    "bandwidth",
                                    "bandwidth_limit_type",
                                    "bandwidth_pool_type",
                                    "connection_status",
                                    "destination_address",
                                    "frr_active_ls_ps",
                                    "frr_active_soft_preempted_ls_ps",
                                    "general_status",
                                    "has_attribute_set",
                                    "in_use_bandwidth",
                                    "is_attribute_set_in_db",
                                    "ls_ps",
                                    "output_interface_name",
                                    "prot_interface_autobackup_config",
                                    "prot_interface_srlg_config",
                                    "recreate_remaining_time",
                                    "recreate_timer_is_running",
                                    "s2_ls",
                                    "s2l_families",
                                    "soft_preempted_in_use_bandwidth",
                                    "source_address",
                                    "tunnel_attribute_set_name",
                                    "tunnel_instance") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTeStandby.FastReroute.ProtectedInterfaces.ProtectedInterface, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTeStandby.FastReroute.ProtectedInterfaces.ProtectedInterface, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.interface_name.is_set or
                        self.backup_tunnel_name.is_set or
                        self.backup_status.is_set or
                        self.backup_tunnel_id.is_set or
                        self.backup_tunnel_name_xr.is_set or
                        self.backup_type.is_set or
                        self.backup_usage.is_set or
                        self.bandwidth.is_set or
                        self.bandwidth_limit_type.is_set or
                        self.bandwidth_pool_type.is_set or
                        self.connection_status.is_set or
                        self.destination_address.is_set or
                        self.frr_active_ls_ps.is_set or
                        self.frr_active_soft_preempted_ls_ps.is_set or
                        self.general_status.is_set or
                        self.has_attribute_set.is_set or
                        self.in_use_bandwidth.is_set or
                        self.is_attribute_set_in_db.is_set or
                        self.ls_ps.is_set or
                        self.output_interface_name.is_set or
                        self.prot_interface_autobackup_config.is_set or
                        self.prot_interface_srlg_config.is_set or
                        self.recreate_remaining_time.is_set or
                        self.recreate_timer_is_running.is_set or
                        self.s2_ls.is_set or
                        self.s2l_families.is_set or
                        self.soft_preempted_in_use_bandwidth.is_set or
                        self.source_address.is_set or
                        self.tunnel_attribute_set_name.is_set or
                        self.tunnel_instance.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.interface_name.yfilter != YFilter.not_set or
                        self.backup_tunnel_name.yfilter != YFilter.not_set or
                        self.backup_status.yfilter != YFilter.not_set or
                        self.backup_tunnel_id.yfilter != YFilter.not_set or
                        self.backup_tunnel_name_xr.yfilter != YFilter.not_set or
                        self.backup_type.yfilter != YFilter.not_set or
                        self.backup_usage.yfilter != YFilter.not_set or
                        self.bandwidth.yfilter != YFilter.not_set or
                        self.bandwidth_limit_type.yfilter != YFilter.not_set or
                        self.bandwidth_pool_type.yfilter != YFilter.not_set or
                        self.connection_status.yfilter != YFilter.not_set or
                        self.destination_address.yfilter != YFilter.not_set or
                        self.frr_active_ls_ps.yfilter != YFilter.not_set or
                        self.frr_active_soft_preempted_ls_ps.yfilter != YFilter.not_set or
                        self.general_status.yfilter != YFilter.not_set or
                        self.has_attribute_set.yfilter != YFilter.not_set or
                        self.in_use_bandwidth.yfilter != YFilter.not_set or
                        self.is_attribute_set_in_db.yfilter != YFilter.not_set or
                        self.ls_ps.yfilter != YFilter.not_set or
                        self.output_interface_name.yfilter != YFilter.not_set or
                        self.prot_interface_autobackup_config.yfilter != YFilter.not_set or
                        self.prot_interface_srlg_config.yfilter != YFilter.not_set or
                        self.recreate_remaining_time.yfilter != YFilter.not_set or
                        self.recreate_timer_is_running.yfilter != YFilter.not_set or
                        self.s2_ls.yfilter != YFilter.not_set or
                        self.s2l_families.yfilter != YFilter.not_set or
                        self.soft_preempted_in_use_bandwidth.yfilter != YFilter.not_set or
                        self.source_address.yfilter != YFilter.not_set or
                        self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                        self.tunnel_instance.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "protected-interface" + "[interface-name='" + self.interface_name.get() + "']" + "[backup-tunnel-name='" + self.backup_tunnel_name.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/fast-reroute/protected-interfaces/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.interface_name.get_name_leafdata())
                    if (self.backup_tunnel_name.is_set or self.backup_tunnel_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.backup_tunnel_name.get_name_leafdata())
                    if (self.backup_status.is_set or self.backup_status.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.backup_status.get_name_leafdata())
                    if (self.backup_tunnel_id.is_set or self.backup_tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.backup_tunnel_id.get_name_leafdata())
                    if (self.backup_tunnel_name_xr.is_set or self.backup_tunnel_name_xr.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.backup_tunnel_name_xr.get_name_leafdata())
                    if (self.backup_type.is_set or self.backup_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.backup_type.get_name_leafdata())
                    if (self.backup_usage.is_set or self.backup_usage.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.backup_usage.get_name_leafdata())
                    if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.bandwidth.get_name_leafdata())
                    if (self.bandwidth_limit_type.is_set or self.bandwidth_limit_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.bandwidth_limit_type.get_name_leafdata())
                    if (self.bandwidth_pool_type.is_set or self.bandwidth_pool_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.bandwidth_pool_type.get_name_leafdata())
                    if (self.connection_status.is_set or self.connection_status.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.connection_status.get_name_leafdata())
                    if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.destination_address.get_name_leafdata())
                    if (self.frr_active_ls_ps.is_set or self.frr_active_ls_ps.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.frr_active_ls_ps.get_name_leafdata())
                    if (self.frr_active_soft_preempted_ls_ps.is_set or self.frr_active_soft_preempted_ls_ps.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.frr_active_soft_preempted_ls_ps.get_name_leafdata())
                    if (self.general_status.is_set or self.general_status.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.general_status.get_name_leafdata())
                    if (self.has_attribute_set.is_set or self.has_attribute_set.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.has_attribute_set.get_name_leafdata())
                    if (self.in_use_bandwidth.is_set or self.in_use_bandwidth.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.in_use_bandwidth.get_name_leafdata())
                    if (self.is_attribute_set_in_db.is_set or self.is_attribute_set_in_db.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_attribute_set_in_db.get_name_leafdata())
                    if (self.ls_ps.is_set or self.ls_ps.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.ls_ps.get_name_leafdata())
                    if (self.output_interface_name.is_set or self.output_interface_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.output_interface_name.get_name_leafdata())
                    if (self.prot_interface_autobackup_config.is_set or self.prot_interface_autobackup_config.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.prot_interface_autobackup_config.get_name_leafdata())
                    if (self.prot_interface_srlg_config.is_set or self.prot_interface_srlg_config.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.prot_interface_srlg_config.get_name_leafdata())
                    if (self.recreate_remaining_time.is_set or self.recreate_remaining_time.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.recreate_remaining_time.get_name_leafdata())
                    if (self.recreate_timer_is_running.is_set or self.recreate_timer_is_running.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.recreate_timer_is_running.get_name_leafdata())
                    if (self.s2_ls.is_set or self.s2_ls.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.s2_ls.get_name_leafdata())
                    if (self.s2l_families.is_set or self.s2l_families.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.s2l_families.get_name_leafdata())
                    if (self.soft_preempted_in_use_bandwidth.is_set or self.soft_preempted_in_use_bandwidth.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.soft_preempted_in_use_bandwidth.get_name_leafdata())
                    if (self.source_address.is_set or self.source_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.source_address.get_name_leafdata())
                    if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                    if (self.tunnel_instance.is_set or self.tunnel_instance.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_instance.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "interface-name" or name == "backup-tunnel-name" or name == "backup-status" or name == "backup-tunnel-id" or name == "backup-tunnel-name-xr" or name == "backup-type" or name == "backup-usage" or name == "bandwidth" or name == "bandwidth-limit-type" or name == "bandwidth-pool-type" or name == "connection-status" or name == "destination-address" or name == "frr-active-ls-ps" or name == "frr-active-soft-preempted-ls-ps" or name == "general-status" or name == "has-attribute-set" or name == "in-use-bandwidth" or name == "is-attribute-set-in-db" or name == "ls-ps" or name == "output-interface-name" or name == "prot-interface-autobackup-config" or name == "prot-interface-srlg-config" or name == "recreate-remaining-time" or name == "recreate-timer-is-running" or name == "s2-ls" or name == "s2l-families" or name == "soft-preempted-in-use-bandwidth" or name == "source-address" or name == "tunnel-attribute-set-name" or name == "tunnel-instance"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "interface-name"):
                        self.interface_name = value
                        self.interface_name.value_namespace = name_space
                        self.interface_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "backup-tunnel-name"):
                        self.backup_tunnel_name = value
                        self.backup_tunnel_name.value_namespace = name_space
                        self.backup_tunnel_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "backup-status"):
                        self.backup_status = value
                        self.backup_status.value_namespace = name_space
                        self.backup_status.value_namespace_prefix = name_space_prefix
                    if(value_path == "backup-tunnel-id"):
                        self.backup_tunnel_id = value
                        self.backup_tunnel_id.value_namespace = name_space
                        self.backup_tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "backup-tunnel-name-xr"):
                        self.backup_tunnel_name_xr = value
                        self.backup_tunnel_name_xr.value_namespace = name_space
                        self.backup_tunnel_name_xr.value_namespace_prefix = name_space_prefix
                    if(value_path == "backup-type"):
                        self.backup_type = value
                        self.backup_type.value_namespace = name_space
                        self.backup_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "backup-usage"):
                        self.backup_usage = value
                        self.backup_usage.value_namespace = name_space
                        self.backup_usage.value_namespace_prefix = name_space_prefix
                    if(value_path == "bandwidth"):
                        self.bandwidth = value
                        self.bandwidth.value_namespace = name_space
                        self.bandwidth.value_namespace_prefix = name_space_prefix
                    if(value_path == "bandwidth-limit-type"):
                        self.bandwidth_limit_type = value
                        self.bandwidth_limit_type.value_namespace = name_space
                        self.bandwidth_limit_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "bandwidth-pool-type"):
                        self.bandwidth_pool_type = value
                        self.bandwidth_pool_type.value_namespace = name_space
                        self.bandwidth_pool_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "connection-status"):
                        self.connection_status = value
                        self.connection_status.value_namespace = name_space
                        self.connection_status.value_namespace_prefix = name_space_prefix
                    if(value_path == "destination-address"):
                        self.destination_address = value
                        self.destination_address.value_namespace = name_space
                        self.destination_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "frr-active-ls-ps"):
                        self.frr_active_ls_ps = value
                        self.frr_active_ls_ps.value_namespace = name_space
                        self.frr_active_ls_ps.value_namespace_prefix = name_space_prefix
                    if(value_path == "frr-active-soft-preempted-ls-ps"):
                        self.frr_active_soft_preempted_ls_ps = value
                        self.frr_active_soft_preempted_ls_ps.value_namespace = name_space
                        self.frr_active_soft_preempted_ls_ps.value_namespace_prefix = name_space_prefix
                    if(value_path == "general-status"):
                        self.general_status = value
                        self.general_status.value_namespace = name_space
                        self.general_status.value_namespace_prefix = name_space_prefix
                    if(value_path == "has-attribute-set"):
                        self.has_attribute_set = value
                        self.has_attribute_set.value_namespace = name_space
                        self.has_attribute_set.value_namespace_prefix = name_space_prefix
                    if(value_path == "in-use-bandwidth"):
                        self.in_use_bandwidth = value
                        self.in_use_bandwidth.value_namespace = name_space
                        self.in_use_bandwidth.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-attribute-set-in-db"):
                        self.is_attribute_set_in_db = value
                        self.is_attribute_set_in_db.value_namespace = name_space
                        self.is_attribute_set_in_db.value_namespace_prefix = name_space_prefix
                    if(value_path == "ls-ps"):
                        self.ls_ps = value
                        self.ls_ps.value_namespace = name_space
                        self.ls_ps.value_namespace_prefix = name_space_prefix
                    if(value_path == "output-interface-name"):
                        self.output_interface_name = value
                        self.output_interface_name.value_namespace = name_space
                        self.output_interface_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "prot-interface-autobackup-config"):
                        self.prot_interface_autobackup_config = value
                        self.prot_interface_autobackup_config.value_namespace = name_space
                        self.prot_interface_autobackup_config.value_namespace_prefix = name_space_prefix
                    if(value_path == "prot-interface-srlg-config"):
                        self.prot_interface_srlg_config = value
                        self.prot_interface_srlg_config.value_namespace = name_space
                        self.prot_interface_srlg_config.value_namespace_prefix = name_space_prefix
                    if(value_path == "recreate-remaining-time"):
                        self.recreate_remaining_time = value
                        self.recreate_remaining_time.value_namespace = name_space
                        self.recreate_remaining_time.value_namespace_prefix = name_space_prefix
                    if(value_path == "recreate-timer-is-running"):
                        self.recreate_timer_is_running = value
                        self.recreate_timer_is_running.value_namespace = name_space
                        self.recreate_timer_is_running.value_namespace_prefix = name_space_prefix
                    if(value_path == "s2-ls"):
                        self.s2_ls = value
                        self.s2_ls.value_namespace = name_space
                        self.s2_ls.value_namespace_prefix = name_space_prefix
                    if(value_path == "s2l-families"):
                        self.s2l_families = value
                        self.s2l_families.value_namespace = name_space
                        self.s2l_families.value_namespace_prefix = name_space_prefix
                    if(value_path == "soft-preempted-in-use-bandwidth"):
                        self.soft_preempted_in_use_bandwidth = value
                        self.soft_preempted_in_use_bandwidth.value_namespace = name_space
                        self.soft_preempted_in_use_bandwidth.value_namespace_prefix = name_space_prefix
                    if(value_path == "source-address"):
                        self.source_address = value
                        self.source_address.value_namespace = name_space
                        self.source_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-attribute-set-name"):
                        self.tunnel_attribute_set_name = value
                        self.tunnel_attribute_set_name.value_namespace = name_space
                        self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-instance"):
                        self.tunnel_instance = value
                        self.tunnel_instance.value_namespace = name_space
                        self.tunnel_instance.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.protected_interface:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.protected_interface:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "protected-interfaces" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/fast-reroute/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "protected-interface"):
                    for c in self.protected_interface:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTeStandby.FastReroute.ProtectedInterfaces.ProtectedInterface()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.protected_interface.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "protected-interface"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass


        class Protections(Entity):
            """
            The set of fastreroute protected interfaces
            available in MPLS\-TE
            
            .. attribute:: protection
            
            	Fastreroute info for a given protection interface
            	**type**\: list of    :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.FastReroute.Protections.Protection>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTeStandby.FastReroute.Protections, self).__init__()

                self.yang_name = "protections"
                self.yang_parent_name = "fast-reroute"

                self.protection = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTeStandby.FastReroute.Protections, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTeStandby.FastReroute.Protections, self).__setattr__(name, value)


            class Protection(Entity):
                """
                Fastreroute info for a given protection
                interface
                
                .. attribute:: source_address  <key>
                
                	Source Address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: destination_address  <key>
                
                	Destination Address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: tunnel_id  <key>
                
                	Tunnel ID
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: extended_tunnel_id  <key>
                
                	Extended Tunnel ID
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: lsp_id  <key>
                
                	LSP ID
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: sub_group_id  <key>
                
                	Subgroup ID
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: sub_group_originator  <key>
                
                	Subgroup Orig ID
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: p2mp_id  <key>
                
                	P2MP ID
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: session_type  <key>
                
                	Session Type
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: admin_status
                
                	Tunnel Admin status
                	**type**\:   :py:class:`MplsTeTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelState>`
                
                .. attribute:: backup_bandwidth
                
                	Backup bandwidth
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: backup_next_hop_address
                
                	S2L Nexthop of the backup tunnel
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: backup_status
                
                	Backup status
                	**type**\:   :py:class:`MplsTeBackupStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBackupStatus>`
                
                .. attribute:: bandwidth_limit_type
                
                	Bandwidth limit type
                	**type**\:   :py:class:`MplsTeBwLimit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwLimit>`
                
                .. attribute:: bandwidth_pool_type
                
                	Bandwidth pool type
                	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                
                .. attribute:: destination_address_xr
                
                	Destination
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: extended_tunnel_id_xr
                
                	Extended Tunnel ID
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: frr_output_interface
                
                	Output interface of bkup tunnel
                	**type**\:  str
                
                .. attribute:: frr_output_label
                
                	FRR output label
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: frr_output_tunnel_interface
                
                	FRR output tunnel intface
                	**type**\:  str
                
                .. attribute:: inbound_frr_state
                
                	Indicates inbound FRR state
                	**type**\:   :py:class:`MplsTeFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrState>`
                
                .. attribute:: input_label
                
                	Input label
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: is_frr_requested
                
                	TRUE if frr protection is on
                	**type**\:  bool
                
                .. attribute:: is_p2mp_tunnel
                
                	Is P2P or P2MP Tunnel
                	**type**\:  bool
                
                .. attribute:: is_signalled
                
                	Indicates whether signalled
                	**type**\:  bool
                
                .. attribute:: lsp_bandwidth_type
                
                	LSP bandwidth type
                	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                
                .. attribute:: next_hop_address
                
                	Next hop
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: operation_status
                
                	Tunnel operational status
                	**type**\:   :py:class:`MplsTeTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelState>`
                
                .. attribute:: original_input_interface
                
                	Input intface of the LSP
                	**type**\:  str
                
                .. attribute:: outbound_frr_state
                
                	Indicates outbound FRR state
                	**type**\:   :py:class:`MplsTeFrrState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrState>`
                
                .. attribute:: output_interface_lsp
                
                	Output intface of the LSP
                	**type**\:  str
                
                .. attribute:: output_label
                
                	Output label
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: p2mp_id_xr
                
                	S2L P2MP ID
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: previous_hop_address
                
                	Previous hop
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: role
                
                	Role of LSP
                	**type**\:   :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                
                .. attribute:: sharing_type
                
                	Outgoing i/f Sharing type
                	**type**\:   :py:class:`MplsTeFrrSharing <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeFrrSharing>`
                
                .. attribute:: source_address_xr
                
                	Source
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: sub_group_id_xr
                
                	S2L Sub\-Group ID
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: sub_group_original_id
                
                	S2L Sub\-Group Originator ID
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: tunnel_id_xr
                
                	Tunnel ID
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: tunnel_instance
                
                	Tunnel instance
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: tunnel_name
                
                	Tunnel Name
                	**type**\:  str
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTeStandby.FastReroute.Protections.Protection, self).__init__()

                    self.yang_name = "protection"
                    self.yang_parent_name = "protections"

                    self.source_address = YLeaf(YType.str, "source-address")

                    self.destination_address = YLeaf(YType.str, "destination-address")

                    self.tunnel_id = YLeaf(YType.int32, "tunnel-id")

                    self.extended_tunnel_id = YLeaf(YType.str, "extended-tunnel-id")

                    self.lsp_id = YLeaf(YType.int32, "lsp-id")

                    self.sub_group_id = YLeaf(YType.int32, "sub-group-id")

                    self.sub_group_originator = YLeaf(YType.str, "sub-group-originator")

                    self.p2mp_id = YLeaf(YType.int32, "p2mp-id")

                    self.session_type = YLeaf(YType.int32, "session-type")

                    self.admin_status = YLeaf(YType.enumeration, "admin-status")

                    self.backup_bandwidth = YLeaf(YType.uint32, "backup-bandwidth")

                    self.backup_next_hop_address = YLeaf(YType.str, "backup-next-hop-address")

                    self.backup_status = YLeaf(YType.enumeration, "backup-status")

                    self.bandwidth_limit_type = YLeaf(YType.enumeration, "bandwidth-limit-type")

                    self.bandwidth_pool_type = YLeaf(YType.enumeration, "bandwidth-pool-type")

                    self.destination_address_xr = YLeaf(YType.str, "destination-address-xr")

                    self.extended_tunnel_id_xr = YLeaf(YType.str, "extended-tunnel-id-xr")

                    self.frr_output_interface = YLeaf(YType.str, "frr-output-interface")

                    self.frr_output_label = YLeaf(YType.uint32, "frr-output-label")

                    self.frr_output_tunnel_interface = YLeaf(YType.str, "frr-output-tunnel-interface")

                    self.inbound_frr_state = YLeaf(YType.enumeration, "inbound-frr-state")

                    self.input_label = YLeaf(YType.uint32, "input-label")

                    self.is_frr_requested = YLeaf(YType.boolean, "is-frr-requested")

                    self.is_p2mp_tunnel = YLeaf(YType.boolean, "is-p2mp-tunnel")

                    self.is_signalled = YLeaf(YType.boolean, "is-signalled")

                    self.lsp_bandwidth_type = YLeaf(YType.enumeration, "lsp-bandwidth-type")

                    self.next_hop_address = YLeaf(YType.str, "next-hop-address")

                    self.operation_status = YLeaf(YType.enumeration, "operation-status")

                    self.original_input_interface = YLeaf(YType.str, "original-input-interface")

                    self.outbound_frr_state = YLeaf(YType.enumeration, "outbound-frr-state")

                    self.output_interface_lsp = YLeaf(YType.str, "output-interface-lsp")

                    self.output_label = YLeaf(YType.uint32, "output-label")

                    self.p2mp_id_xr = YLeaf(YType.uint32, "p2mp-id-xr")

                    self.previous_hop_address = YLeaf(YType.str, "previous-hop-address")

                    self.role = YLeaf(YType.enumeration, "role")

                    self.sharing_type = YLeaf(YType.enumeration, "sharing-type")

                    self.source_address_xr = YLeaf(YType.str, "source-address-xr")

                    self.sub_group_id_xr = YLeaf(YType.uint16, "sub-group-id-xr")

                    self.sub_group_original_id = YLeaf(YType.str, "sub-group-original-id")

                    self.tunnel_id_xr = YLeaf(YType.uint32, "tunnel-id-xr")

                    self.tunnel_instance = YLeaf(YType.uint32, "tunnel-instance")

                    self.tunnel_name = YLeaf(YType.str, "tunnel-name")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("source_address",
                                    "destination_address",
                                    "tunnel_id",
                                    "extended_tunnel_id",
                                    "lsp_id",
                                    "sub_group_id",
                                    "sub_group_originator",
                                    "p2mp_id",
                                    "session_type",
                                    "admin_status",
                                    "backup_bandwidth",
                                    "backup_next_hop_address",
                                    "backup_status",
                                    "bandwidth_limit_type",
                                    "bandwidth_pool_type",
                                    "destination_address_xr",
                                    "extended_tunnel_id_xr",
                                    "frr_output_interface",
                                    "frr_output_label",
                                    "frr_output_tunnel_interface",
                                    "inbound_frr_state",
                                    "input_label",
                                    "is_frr_requested",
                                    "is_p2mp_tunnel",
                                    "is_signalled",
                                    "lsp_bandwidth_type",
                                    "next_hop_address",
                                    "operation_status",
                                    "original_input_interface",
                                    "outbound_frr_state",
                                    "output_interface_lsp",
                                    "output_label",
                                    "p2mp_id_xr",
                                    "previous_hop_address",
                                    "role",
                                    "sharing_type",
                                    "source_address_xr",
                                    "sub_group_id_xr",
                                    "sub_group_original_id",
                                    "tunnel_id_xr",
                                    "tunnel_instance",
                                    "tunnel_name") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTeStandby.FastReroute.Protections.Protection, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTeStandby.FastReroute.Protections.Protection, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.source_address.is_set or
                        self.destination_address.is_set or
                        self.tunnel_id.is_set or
                        self.extended_tunnel_id.is_set or
                        self.lsp_id.is_set or
                        self.sub_group_id.is_set or
                        self.sub_group_originator.is_set or
                        self.p2mp_id.is_set or
                        self.session_type.is_set or
                        self.admin_status.is_set or
                        self.backup_bandwidth.is_set or
                        self.backup_next_hop_address.is_set or
                        self.backup_status.is_set or
                        self.bandwidth_limit_type.is_set or
                        self.bandwidth_pool_type.is_set or
                        self.destination_address_xr.is_set or
                        self.extended_tunnel_id_xr.is_set or
                        self.frr_output_interface.is_set or
                        self.frr_output_label.is_set or
                        self.frr_output_tunnel_interface.is_set or
                        self.inbound_frr_state.is_set or
                        self.input_label.is_set or
                        self.is_frr_requested.is_set or
                        self.is_p2mp_tunnel.is_set or
                        self.is_signalled.is_set or
                        self.lsp_bandwidth_type.is_set or
                        self.next_hop_address.is_set or
                        self.operation_status.is_set or
                        self.original_input_interface.is_set or
                        self.outbound_frr_state.is_set or
                        self.output_interface_lsp.is_set or
                        self.output_label.is_set or
                        self.p2mp_id_xr.is_set or
                        self.previous_hop_address.is_set or
                        self.role.is_set or
                        self.sharing_type.is_set or
                        self.source_address_xr.is_set or
                        self.sub_group_id_xr.is_set or
                        self.sub_group_original_id.is_set or
                        self.tunnel_id_xr.is_set or
                        self.tunnel_instance.is_set or
                        self.tunnel_name.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.source_address.yfilter != YFilter.not_set or
                        self.destination_address.yfilter != YFilter.not_set or
                        self.tunnel_id.yfilter != YFilter.not_set or
                        self.extended_tunnel_id.yfilter != YFilter.not_set or
                        self.lsp_id.yfilter != YFilter.not_set or
                        self.sub_group_id.yfilter != YFilter.not_set or
                        self.sub_group_originator.yfilter != YFilter.not_set or
                        self.p2mp_id.yfilter != YFilter.not_set or
                        self.session_type.yfilter != YFilter.not_set or
                        self.admin_status.yfilter != YFilter.not_set or
                        self.backup_bandwidth.yfilter != YFilter.not_set or
                        self.backup_next_hop_address.yfilter != YFilter.not_set or
                        self.backup_status.yfilter != YFilter.not_set or
                        self.bandwidth_limit_type.yfilter != YFilter.not_set or
                        self.bandwidth_pool_type.yfilter != YFilter.not_set or
                        self.destination_address_xr.yfilter != YFilter.not_set or
                        self.extended_tunnel_id_xr.yfilter != YFilter.not_set or
                        self.frr_output_interface.yfilter != YFilter.not_set or
                        self.frr_output_label.yfilter != YFilter.not_set or
                        self.frr_output_tunnel_interface.yfilter != YFilter.not_set or
                        self.inbound_frr_state.yfilter != YFilter.not_set or
                        self.input_label.yfilter != YFilter.not_set or
                        self.is_frr_requested.yfilter != YFilter.not_set or
                        self.is_p2mp_tunnel.yfilter != YFilter.not_set or
                        self.is_signalled.yfilter != YFilter.not_set or
                        self.lsp_bandwidth_type.yfilter != YFilter.not_set or
                        self.next_hop_address.yfilter != YFilter.not_set or
                        self.operation_status.yfilter != YFilter.not_set or
                        self.original_input_interface.yfilter != YFilter.not_set or
                        self.outbound_frr_state.yfilter != YFilter.not_set or
                        self.output_interface_lsp.yfilter != YFilter.not_set or
                        self.output_label.yfilter != YFilter.not_set or
                        self.p2mp_id_xr.yfilter != YFilter.not_set or
                        self.previous_hop_address.yfilter != YFilter.not_set or
                        self.role.yfilter != YFilter.not_set or
                        self.sharing_type.yfilter != YFilter.not_set or
                        self.source_address_xr.yfilter != YFilter.not_set or
                        self.sub_group_id_xr.yfilter != YFilter.not_set or
                        self.sub_group_original_id.yfilter != YFilter.not_set or
                        self.tunnel_id_xr.yfilter != YFilter.not_set or
                        self.tunnel_instance.yfilter != YFilter.not_set or
                        self.tunnel_name.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "protection" + "[source-address='" + self.source_address.get() + "']" + "[destination-address='" + self.destination_address.get() + "']" + "[tunnel-id='" + self.tunnel_id.get() + "']" + "[extended-tunnel-id='" + self.extended_tunnel_id.get() + "']" + "[lsp-id='" + self.lsp_id.get() + "']" + "[sub-group-id='" + self.sub_group_id.get() + "']" + "[sub-group-originator='" + self.sub_group_originator.get() + "']" + "[p2mp-id='" + self.p2mp_id.get() + "']" + "[session-type='" + self.session_type.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/fast-reroute/protections/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.source_address.is_set or self.source_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.source_address.get_name_leafdata())
                    if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.destination_address.get_name_leafdata())
                    if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_id.get_name_leafdata())
                    if (self.extended_tunnel_id.is_set or self.extended_tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.extended_tunnel_id.get_name_leafdata())
                    if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.lsp_id.get_name_leafdata())
                    if (self.sub_group_id.is_set or self.sub_group_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.sub_group_id.get_name_leafdata())
                    if (self.sub_group_originator.is_set or self.sub_group_originator.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.sub_group_originator.get_name_leafdata())
                    if (self.p2mp_id.is_set or self.p2mp_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.p2mp_id.get_name_leafdata())
                    if (self.session_type.is_set or self.session_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.session_type.get_name_leafdata())
                    if (self.admin_status.is_set or self.admin_status.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.admin_status.get_name_leafdata())
                    if (self.backup_bandwidth.is_set or self.backup_bandwidth.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.backup_bandwidth.get_name_leafdata())
                    if (self.backup_next_hop_address.is_set or self.backup_next_hop_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.backup_next_hop_address.get_name_leafdata())
                    if (self.backup_status.is_set or self.backup_status.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.backup_status.get_name_leafdata())
                    if (self.bandwidth_limit_type.is_set or self.bandwidth_limit_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.bandwidth_limit_type.get_name_leafdata())
                    if (self.bandwidth_pool_type.is_set or self.bandwidth_pool_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.bandwidth_pool_type.get_name_leafdata())
                    if (self.destination_address_xr.is_set or self.destination_address_xr.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.destination_address_xr.get_name_leafdata())
                    if (self.extended_tunnel_id_xr.is_set or self.extended_tunnel_id_xr.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.extended_tunnel_id_xr.get_name_leafdata())
                    if (self.frr_output_interface.is_set or self.frr_output_interface.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.frr_output_interface.get_name_leafdata())
                    if (self.frr_output_label.is_set or self.frr_output_label.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.frr_output_label.get_name_leafdata())
                    if (self.frr_output_tunnel_interface.is_set or self.frr_output_tunnel_interface.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.frr_output_tunnel_interface.get_name_leafdata())
                    if (self.inbound_frr_state.is_set or self.inbound_frr_state.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.inbound_frr_state.get_name_leafdata())
                    if (self.input_label.is_set or self.input_label.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.input_label.get_name_leafdata())
                    if (self.is_frr_requested.is_set or self.is_frr_requested.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_frr_requested.get_name_leafdata())
                    if (self.is_p2mp_tunnel.is_set or self.is_p2mp_tunnel.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_p2mp_tunnel.get_name_leafdata())
                    if (self.is_signalled.is_set or self.is_signalled.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_signalled.get_name_leafdata())
                    if (self.lsp_bandwidth_type.is_set or self.lsp_bandwidth_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.lsp_bandwidth_type.get_name_leafdata())
                    if (self.next_hop_address.is_set or self.next_hop_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.next_hop_address.get_name_leafdata())
                    if (self.operation_status.is_set or self.operation_status.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.operation_status.get_name_leafdata())
                    if (self.original_input_interface.is_set or self.original_input_interface.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.original_input_interface.get_name_leafdata())
                    if (self.outbound_frr_state.is_set or self.outbound_frr_state.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.outbound_frr_state.get_name_leafdata())
                    if (self.output_interface_lsp.is_set or self.output_interface_lsp.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.output_interface_lsp.get_name_leafdata())
                    if (self.output_label.is_set or self.output_label.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.output_label.get_name_leafdata())
                    if (self.p2mp_id_xr.is_set or self.p2mp_id_xr.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.p2mp_id_xr.get_name_leafdata())
                    if (self.previous_hop_address.is_set or self.previous_hop_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.previous_hop_address.get_name_leafdata())
                    if (self.role.is_set or self.role.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.role.get_name_leafdata())
                    if (self.sharing_type.is_set or self.sharing_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.sharing_type.get_name_leafdata())
                    if (self.source_address_xr.is_set or self.source_address_xr.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.source_address_xr.get_name_leafdata())
                    if (self.sub_group_id_xr.is_set or self.sub_group_id_xr.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.sub_group_id_xr.get_name_leafdata())
                    if (self.sub_group_original_id.is_set or self.sub_group_original_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.sub_group_original_id.get_name_leafdata())
                    if (self.tunnel_id_xr.is_set or self.tunnel_id_xr.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_id_xr.get_name_leafdata())
                    if (self.tunnel_instance.is_set or self.tunnel_instance.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_instance.get_name_leafdata())
                    if (self.tunnel_name.is_set or self.tunnel_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_name.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "source-address" or name == "destination-address" or name == "tunnel-id" or name == "extended-tunnel-id" or name == "lsp-id" or name == "sub-group-id" or name == "sub-group-originator" or name == "p2mp-id" or name == "session-type" or name == "admin-status" or name == "backup-bandwidth" or name == "backup-next-hop-address" or name == "backup-status" or name == "bandwidth-limit-type" or name == "bandwidth-pool-type" or name == "destination-address-xr" or name == "extended-tunnel-id-xr" or name == "frr-output-interface" or name == "frr-output-label" or name == "frr-output-tunnel-interface" or name == "inbound-frr-state" or name == "input-label" or name == "is-frr-requested" or name == "is-p2mp-tunnel" or name == "is-signalled" or name == "lsp-bandwidth-type" or name == "next-hop-address" or name == "operation-status" or name == "original-input-interface" or name == "outbound-frr-state" or name == "output-interface-lsp" or name == "output-label" or name == "p2mp-id-xr" or name == "previous-hop-address" or name == "role" or name == "sharing-type" or name == "source-address-xr" or name == "sub-group-id-xr" or name == "sub-group-original-id" or name == "tunnel-id-xr" or name == "tunnel-instance" or name == "tunnel-name"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "source-address"):
                        self.source_address = value
                        self.source_address.value_namespace = name_space
                        self.source_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "destination-address"):
                        self.destination_address = value
                        self.destination_address.value_namespace = name_space
                        self.destination_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-id"):
                        self.tunnel_id = value
                        self.tunnel_id.value_namespace = name_space
                        self.tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "extended-tunnel-id"):
                        self.extended_tunnel_id = value
                        self.extended_tunnel_id.value_namespace = name_space
                        self.extended_tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "lsp-id"):
                        self.lsp_id = value
                        self.lsp_id.value_namespace = name_space
                        self.lsp_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "sub-group-id"):
                        self.sub_group_id = value
                        self.sub_group_id.value_namespace = name_space
                        self.sub_group_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "sub-group-originator"):
                        self.sub_group_originator = value
                        self.sub_group_originator.value_namespace = name_space
                        self.sub_group_originator.value_namespace_prefix = name_space_prefix
                    if(value_path == "p2mp-id"):
                        self.p2mp_id = value
                        self.p2mp_id.value_namespace = name_space
                        self.p2mp_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "session-type"):
                        self.session_type = value
                        self.session_type.value_namespace = name_space
                        self.session_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "admin-status"):
                        self.admin_status = value
                        self.admin_status.value_namespace = name_space
                        self.admin_status.value_namespace_prefix = name_space_prefix
                    if(value_path == "backup-bandwidth"):
                        self.backup_bandwidth = value
                        self.backup_bandwidth.value_namespace = name_space
                        self.backup_bandwidth.value_namespace_prefix = name_space_prefix
                    if(value_path == "backup-next-hop-address"):
                        self.backup_next_hop_address = value
                        self.backup_next_hop_address.value_namespace = name_space
                        self.backup_next_hop_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "backup-status"):
                        self.backup_status = value
                        self.backup_status.value_namespace = name_space
                        self.backup_status.value_namespace_prefix = name_space_prefix
                    if(value_path == "bandwidth-limit-type"):
                        self.bandwidth_limit_type = value
                        self.bandwidth_limit_type.value_namespace = name_space
                        self.bandwidth_limit_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "bandwidth-pool-type"):
                        self.bandwidth_pool_type = value
                        self.bandwidth_pool_type.value_namespace = name_space
                        self.bandwidth_pool_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "destination-address-xr"):
                        self.destination_address_xr = value
                        self.destination_address_xr.value_namespace = name_space
                        self.destination_address_xr.value_namespace_prefix = name_space_prefix
                    if(value_path == "extended-tunnel-id-xr"):
                        self.extended_tunnel_id_xr = value
                        self.extended_tunnel_id_xr.value_namespace = name_space
                        self.extended_tunnel_id_xr.value_namespace_prefix = name_space_prefix
                    if(value_path == "frr-output-interface"):
                        self.frr_output_interface = value
                        self.frr_output_interface.value_namespace = name_space
                        self.frr_output_interface.value_namespace_prefix = name_space_prefix
                    if(value_path == "frr-output-label"):
                        self.frr_output_label = value
                        self.frr_output_label.value_namespace = name_space
                        self.frr_output_label.value_namespace_prefix = name_space_prefix
                    if(value_path == "frr-output-tunnel-interface"):
                        self.frr_output_tunnel_interface = value
                        self.frr_output_tunnel_interface.value_namespace = name_space
                        self.frr_output_tunnel_interface.value_namespace_prefix = name_space_prefix
                    if(value_path == "inbound-frr-state"):
                        self.inbound_frr_state = value
                        self.inbound_frr_state.value_namespace = name_space
                        self.inbound_frr_state.value_namespace_prefix = name_space_prefix
                    if(value_path == "input-label"):
                        self.input_label = value
                        self.input_label.value_namespace = name_space
                        self.input_label.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-frr-requested"):
                        self.is_frr_requested = value
                        self.is_frr_requested.value_namespace = name_space
                        self.is_frr_requested.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-p2mp-tunnel"):
                        self.is_p2mp_tunnel = value
                        self.is_p2mp_tunnel.value_namespace = name_space
                        self.is_p2mp_tunnel.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-signalled"):
                        self.is_signalled = value
                        self.is_signalled.value_namespace = name_space
                        self.is_signalled.value_namespace_prefix = name_space_prefix
                    if(value_path == "lsp-bandwidth-type"):
                        self.lsp_bandwidth_type = value
                        self.lsp_bandwidth_type.value_namespace = name_space
                        self.lsp_bandwidth_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "next-hop-address"):
                        self.next_hop_address = value
                        self.next_hop_address.value_namespace = name_space
                        self.next_hop_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "operation-status"):
                        self.operation_status = value
                        self.operation_status.value_namespace = name_space
                        self.operation_status.value_namespace_prefix = name_space_prefix
                    if(value_path == "original-input-interface"):
                        self.original_input_interface = value
                        self.original_input_interface.value_namespace = name_space
                        self.original_input_interface.value_namespace_prefix = name_space_prefix
                    if(value_path == "outbound-frr-state"):
                        self.outbound_frr_state = value
                        self.outbound_frr_state.value_namespace = name_space
                        self.outbound_frr_state.value_namespace_prefix = name_space_prefix
                    if(value_path == "output-interface-lsp"):
                        self.output_interface_lsp = value
                        self.output_interface_lsp.value_namespace = name_space
                        self.output_interface_lsp.value_namespace_prefix = name_space_prefix
                    if(value_path == "output-label"):
                        self.output_label = value
                        self.output_label.value_namespace = name_space
                        self.output_label.value_namespace_prefix = name_space_prefix
                    if(value_path == "p2mp-id-xr"):
                        self.p2mp_id_xr = value
                        self.p2mp_id_xr.value_namespace = name_space
                        self.p2mp_id_xr.value_namespace_prefix = name_space_prefix
                    if(value_path == "previous-hop-address"):
                        self.previous_hop_address = value
                        self.previous_hop_address.value_namespace = name_space
                        self.previous_hop_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "role"):
                        self.role = value
                        self.role.value_namespace = name_space
                        self.role.value_namespace_prefix = name_space_prefix
                    if(value_path == "sharing-type"):
                        self.sharing_type = value
                        self.sharing_type.value_namespace = name_space
                        self.sharing_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "source-address-xr"):
                        self.source_address_xr = value
                        self.source_address_xr.value_namespace = name_space
                        self.source_address_xr.value_namespace_prefix = name_space_prefix
                    if(value_path == "sub-group-id-xr"):
                        self.sub_group_id_xr = value
                        self.sub_group_id_xr.value_namespace = name_space
                        self.sub_group_id_xr.value_namespace_prefix = name_space_prefix
                    if(value_path == "sub-group-original-id"):
                        self.sub_group_original_id = value
                        self.sub_group_original_id.value_namespace = name_space
                        self.sub_group_original_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-id-xr"):
                        self.tunnel_id_xr = value
                        self.tunnel_id_xr.value_namespace = name_space
                        self.tunnel_id_xr.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-instance"):
                        self.tunnel_instance = value
                        self.tunnel_instance.value_namespace = name_space
                        self.tunnel_instance.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-name"):
                        self.tunnel_name = value
                        self.tunnel_name.value_namespace = name_space
                        self.tunnel_name.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.protection:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.protection:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "protections" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/fast-reroute/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "protection"):
                    for c in self.protection:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTeStandby.FastReroute.Protections.Protection()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.protection.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "protection"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass


        class Promotion(Entity):
            """
            The info about the promotion timer of backup
            tunnels
            
            .. attribute:: is_configured
            
            	Indicate if periodic promotion is configured 
            	**type**\:  bool
            
            .. attribute:: promotion_period
            
            	Promotion period in seconds
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            	**units**\: second
            
            .. attribute:: remaining_time
            
            	Remaining time for next promotion in seconds
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            	**units**\: second
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTeStandby.FastReroute.Promotion, self).__init__()

                self.yang_name = "promotion"
                self.yang_parent_name = "fast-reroute"

                self.is_configured = YLeaf(YType.boolean, "is-configured")

                self.promotion_period = YLeaf(YType.uint32, "promotion-period")

                self.remaining_time = YLeaf(YType.uint32, "remaining-time")

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("is_configured",
                                "promotion_period",
                                "remaining_time") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTeStandby.FastReroute.Promotion, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTeStandby.FastReroute.Promotion, self).__setattr__(name, value)

            def has_data(self):
                return (
                    self.is_configured.is_set or
                    self.promotion_period.is_set or
                    self.remaining_time.is_set)

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    self.is_configured.yfilter != YFilter.not_set or
                    self.promotion_period.yfilter != YFilter.not_set or
                    self.remaining_time.yfilter != YFilter.not_set)

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "promotion" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/fast-reroute/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.is_configured.is_set or self.is_configured.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.is_configured.get_name_leafdata())
                if (self.promotion_period.is_set or self.promotion_period.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.promotion_period.get_name_leafdata())
                if (self.remaining_time.is_set or self.remaining_time.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.remaining_time.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "is-configured" or name == "promotion-period" or name == "remaining-time"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "is-configured"):
                    self.is_configured = value
                    self.is_configured.value_namespace = name_space
                    self.is_configured.value_namespace_prefix = name_space_prefix
                if(value_path == "promotion-period"):
                    self.promotion_period = value
                    self.promotion_period.value_namespace = name_space
                    self.promotion_period.value_namespace_prefix = name_space_prefix
                if(value_path == "remaining-time"):
                    self.remaining_time = value
                    self.remaining_time.value_namespace = name_space
                    self.remaining_time.value_namespace_prefix = name_space_prefix

        def has_data(self):
            return (
                (self.backup_tunnels is not None and self.backup_tunnels.has_data()) or
                (self.promotion is not None and self.promotion.has_data()) or
                (self.protected_interfaces is not None and self.protected_interfaces.has_data()) or
                (self.protections is not None and self.protections.has_data()))

        def has_operation(self):
            return (
                self.yfilter != YFilter.not_set or
                (self.backup_tunnels is not None and self.backup_tunnels.has_operation()) or
                (self.promotion is not None and self.promotion.has_operation()) or
                (self.protected_interfaces is not None and self.protected_interfaces.has_operation()) or
                (self.protections is not None and self.protections.has_operation()))

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "fast-reroute" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "backup-tunnels"):
                if (self.backup_tunnels is None):
                    self.backup_tunnels = MplsTeStandby.FastReroute.BackupTunnels()
                    self.backup_tunnels.parent = self
                    self._children_name_map["backup_tunnels"] = "backup-tunnels"
                return self.backup_tunnels

            if (child_yang_name == "promotion"):
                if (self.promotion is None):
                    self.promotion = MplsTeStandby.FastReroute.Promotion()
                    self.promotion.parent = self
                    self._children_name_map["promotion"] = "promotion"
                return self.promotion

            if (child_yang_name == "protected-interfaces"):
                if (self.protected_interfaces is None):
                    self.protected_interfaces = MplsTeStandby.FastReroute.ProtectedInterfaces()
                    self.protected_interfaces.parent = self
                    self._children_name_map["protected_interfaces"] = "protected-interfaces"
                return self.protected_interfaces

            if (child_yang_name == "protections"):
                if (self.protections is None):
                    self.protections = MplsTeStandby.FastReroute.Protections()
                    self.protections.parent = self
                    self._children_name_map["protections"] = "protections"
                return self.protections

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "backup-tunnels" or name == "promotion" or name == "protected-interfaces" or name == "protections"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class AttributeSets(Entity):
        """
        AttributeSet information.
        
        .. attribute:: attribute_set
        
        	MPLS TE attribute\-set information
        	**type**\: list of    :py:class:`AttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsTeStandby.AttributeSets, self).__init__()

            self.yang_name = "attribute-sets"
            self.yang_parent_name = "mpls-te-standby"

            self.attribute_set = YList(self)

        def __setattr__(self, name, value):
            self._check_monkey_patching_error(name, value)
            with _handle_type_error():
                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                        "Please use list append or extend method."
                                        .format(value))
                if isinstance(value, Enum.YLeaf):
                    value = value.name
                if name in () and name in self.__dict__:
                    if isinstance(value, YLeaf):
                        self.__dict__[name].set(value.get())
                    elif isinstance(value, YLeafList):
                        super(MplsTeStandby.AttributeSets, self).__setattr__(name, value)
                    else:
                        self.__dict__[name].set(value)
                else:
                    if hasattr(value, "parent") and name != "parent":
                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                            value.parent = self
                        elif value.parent is None and value.yang_name in self._children_yang_names:
                            value.parent = self
                    super(MplsTeStandby.AttributeSets, self).__setattr__(name, value)


        class AttributeSet(Entity):
            """
            MPLS TE attribute\-set information
            
            .. attribute:: attribute_set_type  <key>
            
            	Attribute Set Type
            	**type**\:   :py:class:`MplsTeAttrSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeAttrSet>`
            
            .. attribute:: attribute_set_name  <key>
            
            	Attribute Set Name
            	**type**\:  str
            
            	**length:** 1..64
            
            .. attribute:: attribute_set_union
            
            	Union of Attribute Sets
            	**type**\:   :py:class:`AttributeSetUnion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion>`
            
            .. attribute:: tunnel_attribute_set_name
            
            	Attribute Set Name
            	**type**\:  str
            
            .. attribute:: tunnel_attribute_set_name_crc32
            
            	Attribute Set name CRC32 value
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTeStandby.AttributeSets.AttributeSet, self).__init__()

                self.yang_name = "attribute-set"
                self.yang_parent_name = "attribute-sets"

                self.attribute_set_type = YLeaf(YType.enumeration, "attribute-set-type")

                self.attribute_set_name = YLeaf(YType.str, "attribute-set-name")

                self.tunnel_attribute_set_name = YLeaf(YType.str, "tunnel-attribute-set-name")

                self.tunnel_attribute_set_name_crc32 = YLeaf(YType.uint32, "tunnel-attribute-set-name-crc32")

                self.attribute_set_union = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion()
                self.attribute_set_union.parent = self
                self._children_name_map["attribute_set_union"] = "attribute-set-union"
                self._children_yang_names.add("attribute-set-union")

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("attribute_set_type",
                                "attribute_set_name",
                                "tunnel_attribute_set_name",
                                "tunnel_attribute_set_name_crc32") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTeStandby.AttributeSets.AttributeSet, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTeStandby.AttributeSets.AttributeSet, self).__setattr__(name, value)


            class AttributeSetUnion(Entity):
                """
                Union of Attribute Sets
                
                .. attribute:: attribute_set_aps_pp
                
                	Attribute Set OTN APS Path Protection
                	**type**\:   :py:class:`AttributeSetApsPp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetApsPp>`
                
                .. attribute:: attribute_set_autobackup
                
                	MPLS TE Auto\-backup Attribute Set
                	**type**\:   :py:class:`AttributeSetAutobackup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup>`
                
                .. attribute:: attribute_set_automesh
                
                	MPLS TE Auto\-mesh Attribute Set
                	**type**\:   :py:class:`AttributeSetAutomesh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh>`
                
                .. attribute:: attribute_set_p2mpte
                
                	MPLS TE P2MP\-TE Attribute Set
                	**type**\:   :py:class:`AttributeSetP2Mpte <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte>`
                
                .. attribute:: attribute_set_p2p_te
                
                	MPLS TE P2P\-TE Attribute Set
                	**type**\:   :py:class:`AttributeSetP2PTe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe>`
                
                .. attribute:: attribute_set_path_option
                
                	MPLS TE Path Option Attribute Set
                	**type**\:   :py:class:`AttributeSetPathOption <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption>`
                
                .. attribute:: attribute_set_xro
                
                	Attribute Set XRO
                	**type**\:   :py:class:`AttributeSetXro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro>`
                
                .. attribute:: tunnel_attribute_set_type
                
                	TunnelAttributeSetType
                	**type**\:   :py:class:`TunnelAttributeSet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TunnelAttributeSet>`
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion, self).__init__()

                    self.yang_name = "attribute-set-union"
                    self.yang_parent_name = "attribute-set"

                    self.tunnel_attribute_set_type = YLeaf(YType.enumeration, "tunnel-attribute-set-type")

                    self.attribute_set_aps_pp = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                    self.attribute_set_aps_pp.parent = self
                    self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                    self._children_yang_names.add("attribute-set-aps-pp")

                    self.attribute_set_autobackup = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                    self.attribute_set_autobackup.parent = self
                    self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                    self._children_yang_names.add("attribute-set-autobackup")

                    self.attribute_set_automesh = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                    self.attribute_set_automesh.parent = self
                    self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                    self._children_yang_names.add("attribute-set-automesh")

                    self.attribute_set_p2mpte = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                    self.attribute_set_p2mpte.parent = self
                    self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                    self._children_yang_names.add("attribute-set-p2mpte")

                    self.attribute_set_p2p_te = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                    self.attribute_set_p2p_te.parent = self
                    self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                    self._children_yang_names.add("attribute-set-p2p-te")

                    self.attribute_set_path_option = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                    self.attribute_set_path_option.parent = self
                    self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                    self._children_yang_names.add("attribute-set-path-option")

                    self.attribute_set_xro = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro()
                    self.attribute_set_xro.parent = self
                    self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                    self._children_yang_names.add("attribute-set-xro")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("tunnel_attribute_set_type") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion, self).__setattr__(name, value)


                class AttributeSetPathOption(Entity):
                    """
                    MPLS TE Path Option Attribute Set
                    
                    .. attribute:: affinity
                    
                    	Affinity
                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity>`
                    
                    .. attribute:: bandwidth_type
                    
                    	The bandwidth type
                    	**type**\:   :py:class:`MplsTeBwPool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeBwPool>`
                    
                    .. attribute:: bfd_reverse_path
                    
                    	BFD reverse path
                    	**type**\:   :py:class:`BfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath>`
                    
                    .. attribute:: configured_bandwidth
                    
                    	Bandwidth value in kbps
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: kbit/s
                    
                    .. attribute:: cost_limit
                    
                    	Cost limit on the tunnel path
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: dste_class_type
                    
                    	DSTE Class
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: exclude_list_name
                    
                    	Exclude list name
                    	**type**\:  str
                    
                    .. attribute:: generation
                    
                    	Generation
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: is_affinity_configured
                    
                    	Is affinity configured
                    	**type**\:  bool
                    
                    .. attribute:: is_bandwidth_configured
                    
                    	Is bandwidth configured
                    	**type**\:  bool
                    
                    .. attribute:: is_bfd_reverse_pat_configured
                    
                    	Is BFD reverse path configured
                    	**type**\:  bool
                    
                    .. attribute:: is_cost_limit_configured
                    
                    	Is Cost Limit configured
                    	**type**\:  bool
                    
                    .. attribute:: is_exclude_list_name_configured
                    
                    	Is exclude list name configured
                    	**type**\:  bool
                    
                    .. attribute:: is_path_invalidation_action_configured
                    
                    	Is path invalidation action configured
                    	**type**\:  bool
                    
                    .. attribute:: is_path_invalidation_timeout_configured
                    
                    	Is path invalidation timeout configured
                    	**type**\:  bool
                    
                    .. attribute:: is_pce_configured
                    
                    	Is PCE Configured
                    	**type**\:  bool
                    
                    .. attribute:: is_pce_disj_group_id_configured
                    
                    	Is PCE Disjoint Path Group ID Configured
                    	**type**\:  bool
                    
                    .. attribute:: is_pce_disj_source_configured
                    
                    	Is PCE Disjoint Path Source Configured
                    	**type**\:  bool
                    
                    .. attribute:: is_pce_disj_type_configured
                    
                    	Is PCE Disjoint Path Type Configured
                    	**type**\:  bool
                    
                    .. attribute:: is_pceb_dj_source_configured
                    
                    	Is PCE Bidirectional Source Configured
                    	**type**\:  bool
                    
                    .. attribute:: is_pcebd_group_id_configured
                    
                    	Is PCE Bidirectional Group ID Configured
                    	**type**\:  bool
                    
                    .. attribute:: path_invalidation_action
                    
                    	Path invalidation action
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: path_invalidation_timeout
                    
                    	Path invalidation interval on the tunnel path
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: pcebd_group_id
                    
                    	PCE Bidirectional Group ID
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: pcebd_source_address
                    
                    	PCE Bidirectional Source Address
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: pcedp_group_id
                    
                    	PCE Disjoint Path Group ID
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: pcedp_source_address
                    
                    	PCE Disjoint Path Source Address
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: pcedp_type
                    
                    	PCE Disjoint Path Type
                    	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                    
                    .. attribute:: tunnel_id
                    
                    	Tunnel ID
                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId>`
                    
                    .. attribute:: version_info
                    
                    	Version Info
                    	**type**\: list of    :py:class:`VersionInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__init__()

                        self.yang_name = "attribute-set-path-option"
                        self.yang_parent_name = "attribute-set-union"

                        self.bandwidth_type = YLeaf(YType.enumeration, "bandwidth-type")

                        self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                        self.cost_limit = YLeaf(YType.uint32, "cost-limit")

                        self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                        self.exclude_list_name = YLeaf(YType.str, "exclude-list-name")

                        self.generation = YLeaf(YType.uint32, "generation")

                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                        self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                        self.is_bfd_reverse_pat_configured = YLeaf(YType.boolean, "is-bfd-reverse-pat-configured")

                        self.is_cost_limit_configured = YLeaf(YType.boolean, "is-cost-limit-configured")

                        self.is_exclude_list_name_configured = YLeaf(YType.boolean, "is-exclude-list-name-configured")

                        self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                        self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                        self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                        self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                        self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                        self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                        self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                        self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                        self.path_invalidation_action = YLeaf(YType.uint32, "path-invalidation-action")

                        self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                        self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                        self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                        self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                        self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                        self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                        self.affinity = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                        self.affinity.parent = self
                        self._children_name_map["affinity"] = "affinity"
                        self._children_yang_names.add("affinity")

                        self.bfd_reverse_path = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                        self.bfd_reverse_path.parent = self
                        self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                        self._children_yang_names.add("bfd-reverse-path")

                        self.tunnel_id = YList(self)
                        self.version_info = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("bandwidth_type",
                                        "configured_bandwidth",
                                        "cost_limit",
                                        "dste_class_type",
                                        "exclude_list_name",
                                        "generation",
                                        "is_affinity_configured",
                                        "is_bandwidth_configured",
                                        "is_bfd_reverse_pat_configured",
                                        "is_cost_limit_configured",
                                        "is_exclude_list_name_configured",
                                        "is_path_invalidation_action_configured",
                                        "is_path_invalidation_timeout_configured",
                                        "is_pce_configured",
                                        "is_pce_disj_group_id_configured",
                                        "is_pce_disj_source_configured",
                                        "is_pce_disj_type_configured",
                                        "is_pceb_dj_source_configured",
                                        "is_pcebd_group_id_configured",
                                        "path_invalidation_action",
                                        "path_invalidation_timeout",
                                        "pcebd_group_id",
                                        "pcebd_source_address",
                                        "pcedp_group_id",
                                        "pcedp_source_address",
                                        "pcedp_type") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption, self).__setattr__(name, value)


                    class Affinity(Entity):
                        """
                        Affinity
                        
                        .. attribute:: affinity_bits
                        
                        	The affinity bits (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: affinity_mask
                        
                        	The affinity mask (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: named_affinity
                        
                        	Array of name based constratints currently applied to the tunnel
                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__init__()

                            self.yang_name = "affinity"
                            self.yang_parent_name = "attribute-set-path-option"

                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                            self.named_affinity = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("affinity_bits",
                                            "affinity_mask") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity, self).__setattr__(name, value)


                        class NamedAffinity(Entity):
                            """
                            Array of name based constratints currently
                            applied to the tunnel
                            
                            .. attribute:: constraint_extended_value
                            
                            	Constraint value
                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue>`
                            
                            .. attribute:: constraint_type
                            
                            	Constraint type
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: constraint_value
                            
                            	Deprecated
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: extended_forward_ref_value
                            
                            	Reference bits for undefined affinity names
                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                            
                            .. attribute:: forward_ref_value
                            
                            	Deprecated
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__init__()

                                self.yang_name = "named-affinity"
                                self.yang_parent_name = "affinity"

                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                self.constraint_extended_value = YList(self)
                                self.extended_forward_ref_value = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("constraint_type",
                                                "constraint_value",
                                                "forward_ref_value") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity, self).__setattr__(name, value)


                            class ConstraintExtendedValue(Entity):
                                """
                                Constraint value
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                    self.yang_name = "constraint-extended-value"
                                    self.yang_parent_name = "named-affinity"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "constraint-extended-value" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix


                            class ExtendedForwardRefValue(Entity):
                                """
                                Reference bits for undefined affinity names
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                    self.yang_name = "extended-forward-ref-value"
                                    self.yang_parent_name = "named-affinity"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.constraint_extended_value:
                                    if (c.has_data()):
                                        return True
                                for c in self.extended_forward_ref_value:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.constraint_type.is_set or
                                    self.constraint_value.is_set or
                                    self.forward_ref_value.is_set)

                            def has_operation(self):
                                for c in self.constraint_extended_value:
                                    if (c.has_operation()):
                                        return True
                                for c in self.extended_forward_ref_value:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.constraint_type.yfilter != YFilter.not_set or
                                    self.constraint_value.yfilter != YFilter.not_set or
                                    self.forward_ref_value.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "named-affinity" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "constraint-extended-value"):
                                    for c in self.constraint_extended_value:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ConstraintExtendedValue()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.constraint_extended_value.append(c)
                                    return c

                                if (child_yang_name == "extended-forward-ref-value"):
                                    for c in self.extended_forward_ref_value:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.extended_forward_ref_value.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "constraint-type"):
                                    self.constraint_type = value
                                    self.constraint_type.value_namespace = name_space
                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "constraint-value"):
                                    self.constraint_value = value
                                    self.constraint_value.value_namespace = name_space
                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                if(value_path == "forward-ref-value"):
                                    self.forward_ref_value = value
                                    self.forward_ref_value.value_namespace = name_space
                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.named_affinity:
                                if (c.has_data()):
                                    return True
                            return (
                                self.affinity_bits.is_set or
                                self.affinity_mask.is_set)

                        def has_operation(self):
                            for c in self.named_affinity:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.affinity_bits.yfilter != YFilter.not_set or
                                self.affinity_mask.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "affinity" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "named-affinity"):
                                for c in self.named_affinity:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity.NamedAffinity()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.named_affinity.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "affinity-bits"):
                                self.affinity_bits = value
                                self.affinity_bits.value_namespace = name_space
                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                            if(value_path == "affinity-mask"):
                                self.affinity_mask = value
                                self.affinity_mask.value_namespace = name_space
                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                    class BfdReversePath(Entity):
                        """
                        BFD reverse path
                        
                        .. attribute:: binding_label
                        
                        	BFD reverse path binding label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: path_type
                        
                        	BFD reverse path type
                        	**type**\:   :py:class:`TeBfdReversePath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdReversePath>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__init__()

                            self.yang_name = "bfd-reverse-path"
                            self.yang_parent_name = "attribute-set-path-option"

                            self.binding_label = YLeaf(YType.uint32, "binding-label")

                            self.path_type = YLeaf(YType.enumeration, "path-type")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("binding_label",
                                            "path_type") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.binding_label.is_set or
                                self.path_type.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.binding_label.yfilter != YFilter.not_set or
                                self.path_type.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "bfd-reverse-path" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.binding_label.is_set or self.binding_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.binding_label.get_name_leafdata())
                            if (self.path_type.is_set or self.path_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_type.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "binding-label" or name == "path-type"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "binding-label"):
                                self.binding_label = value
                                self.binding_label.value_namespace = name_space
                                self.binding_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-type"):
                                self.path_type = value
                                self.path_type.value_namespace = name_space
                                self.path_type.value_namespace_prefix = name_space_prefix


                    class TunnelId(Entity):
                        """
                        Tunnel ID
                        
                        .. attribute:: entry
                        
                        	
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__init__()

                            self.yang_name = "tunnel-id"
                            self.yang_parent_name = "attribute-set-path-option"

                            self.entry = YLeaf(YType.uint16, "entry")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("entry") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId, self).__setattr__(name, value)

                        def has_data(self):
                            return self.entry.is_set

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.entry.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "tunnel-id" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.entry.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "entry"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "entry"):
                                self.entry = value
                                self.entry.value_namespace = name_space
                                self.entry.value_namespace_prefix = name_space_prefix


                    class VersionInfo(Entity):
                        """
                        Version Info
                        
                        .. attribute:: attribute_type
                        
                        	Attribute Type
                        	**type**\:  str
                        
                        .. attribute:: generation
                        
                        	Generation
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: is_default
                        
                        	Is default
                        	**type**\:  bool
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__init__()

                            self.yang_name = "version-info"
                            self.yang_parent_name = "attribute-set-path-option"

                            self.attribute_type = YLeaf(YType.str, "attribute-type")

                            self.generation = YLeaf(YType.uint32, "generation")

                            self.is_default = YLeaf(YType.boolean, "is-default")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("attribute_type",
                                            "generation",
                                            "is_default") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.attribute_type.is_set or
                                self.generation.is_set or
                                self.is_default.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.attribute_type.yfilter != YFilter.not_set or
                                self.generation.yfilter != YFilter.not_set or
                                self.is_default.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "version-info" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.attribute_type.is_set or self.attribute_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.attribute_type.get_name_leafdata())
                            if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.generation.get_name_leafdata())
                            if (self.is_default.is_set or self.is_default.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_default.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "attribute-type" or name == "generation" or name == "is-default"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "attribute-type"):
                                self.attribute_type = value
                                self.attribute_type.value_namespace = name_space
                                self.attribute_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "generation"):
                                self.generation = value
                                self.generation.value_namespace = name_space
                                self.generation.value_namespace_prefix = name_space_prefix
                            if(value_path == "is-default"):
                                self.is_default = value
                                self.is_default.value_namespace = name_space
                                self.is_default.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.tunnel_id:
                            if (c.has_data()):
                                return True
                        for c in self.version_info:
                            if (c.has_data()):
                                return True
                        return (
                            self.bandwidth_type.is_set or
                            self.configured_bandwidth.is_set or
                            self.cost_limit.is_set or
                            self.dste_class_type.is_set or
                            self.exclude_list_name.is_set or
                            self.generation.is_set or
                            self.is_affinity_configured.is_set or
                            self.is_bandwidth_configured.is_set or
                            self.is_bfd_reverse_pat_configured.is_set or
                            self.is_cost_limit_configured.is_set or
                            self.is_exclude_list_name_configured.is_set or
                            self.is_path_invalidation_action_configured.is_set or
                            self.is_path_invalidation_timeout_configured.is_set or
                            self.is_pce_configured.is_set or
                            self.is_pce_disj_group_id_configured.is_set or
                            self.is_pce_disj_source_configured.is_set or
                            self.is_pce_disj_type_configured.is_set or
                            self.is_pceb_dj_source_configured.is_set or
                            self.is_pcebd_group_id_configured.is_set or
                            self.path_invalidation_action.is_set or
                            self.path_invalidation_timeout.is_set or
                            self.pcebd_group_id.is_set or
                            self.pcebd_source_address.is_set or
                            self.pcedp_group_id.is_set or
                            self.pcedp_source_address.is_set or
                            self.pcedp_type.is_set or
                            (self.affinity is not None and self.affinity.has_data()) or
                            (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_data()))

                    def has_operation(self):
                        for c in self.tunnel_id:
                            if (c.has_operation()):
                                return True
                        for c in self.version_info:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.bandwidth_type.yfilter != YFilter.not_set or
                            self.configured_bandwidth.yfilter != YFilter.not_set or
                            self.cost_limit.yfilter != YFilter.not_set or
                            self.dste_class_type.yfilter != YFilter.not_set or
                            self.exclude_list_name.yfilter != YFilter.not_set or
                            self.generation.yfilter != YFilter.not_set or
                            self.is_affinity_configured.yfilter != YFilter.not_set or
                            self.is_bandwidth_configured.yfilter != YFilter.not_set or
                            self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set or
                            self.is_cost_limit_configured.yfilter != YFilter.not_set or
                            self.is_exclude_list_name_configured.yfilter != YFilter.not_set or
                            self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                            self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                            self.is_pce_configured.yfilter != YFilter.not_set or
                            self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                            self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                            self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                            self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                            self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                            self.path_invalidation_action.yfilter != YFilter.not_set or
                            self.path_invalidation_timeout.yfilter != YFilter.not_set or
                            self.pcebd_group_id.yfilter != YFilter.not_set or
                            self.pcebd_source_address.yfilter != YFilter.not_set or
                            self.pcedp_group_id.yfilter != YFilter.not_set or
                            self.pcedp_source_address.yfilter != YFilter.not_set or
                            self.pcedp_type.yfilter != YFilter.not_set or
                            (self.affinity is not None and self.affinity.has_operation()) or
                            (self.bfd_reverse_path is not None and self.bfd_reverse_path.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "attribute-set-path-option" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.bandwidth_type.is_set or self.bandwidth_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.bandwidth_type.get_name_leafdata())
                        if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                        if (self.cost_limit.is_set or self.cost_limit.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.cost_limit.get_name_leafdata())
                        if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                        if (self.exclude_list_name.is_set or self.exclude_list_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.exclude_list_name.get_name_leafdata())
                        if (self.generation.is_set or self.generation.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.generation.get_name_leafdata())
                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                        if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                        if (self.is_bfd_reverse_pat_configured.is_set or self.is_bfd_reverse_pat_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_bfd_reverse_pat_configured.get_name_leafdata())
                        if (self.is_cost_limit_configured.is_set or self.is_cost_limit_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_cost_limit_configured.get_name_leafdata())
                        if (self.is_exclude_list_name_configured.is_set or self.is_exclude_list_name_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_exclude_list_name_configured.get_name_leafdata())
                        if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                        if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                        if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                        if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                        if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                        if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                        if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                        if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                        if (self.path_invalidation_action.is_set or self.path_invalidation_action.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.path_invalidation_action.get_name_leafdata())
                        if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                        if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                        if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                        if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                        if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                        if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "affinity"):
                            if (self.affinity is None):
                                self.affinity = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.Affinity()
                                self.affinity.parent = self
                                self._children_name_map["affinity"] = "affinity"
                            return self.affinity

                        if (child_yang_name == "bfd-reverse-path"):
                            if (self.bfd_reverse_path is None):
                                self.bfd_reverse_path = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.BfdReversePath()
                                self.bfd_reverse_path.parent = self
                                self._children_name_map["bfd_reverse_path"] = "bfd-reverse-path"
                            return self.bfd_reverse_path

                        if (child_yang_name == "tunnel-id"):
                            for c in self.tunnel_id:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.TunnelId()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.tunnel_id.append(c)
                            return c

                        if (child_yang_name == "version-info"):
                            for c in self.version_info:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption.VersionInfo()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.version_info.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "affinity" or name == "bfd-reverse-path" or name == "tunnel-id" or name == "version-info" or name == "bandwidth-type" or name == "configured-bandwidth" or name == "cost-limit" or name == "dste-class-type" or name == "exclude-list-name" or name == "generation" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-bfd-reverse-pat-configured" or name == "is-cost-limit-configured" or name == "is-exclude-list-name-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "path-invalidation-action" or name == "path-invalidation-timeout" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "bandwidth-type"):
                            self.bandwidth_type = value
                            self.bandwidth_type.value_namespace = name_space
                            self.bandwidth_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "configured-bandwidth"):
                            self.configured_bandwidth = value
                            self.configured_bandwidth.value_namespace = name_space
                            self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "cost-limit"):
                            self.cost_limit = value
                            self.cost_limit.value_namespace = name_space
                            self.cost_limit.value_namespace_prefix = name_space_prefix
                        if(value_path == "dste-class-type"):
                            self.dste_class_type = value
                            self.dste_class_type.value_namespace = name_space
                            self.dste_class_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "exclude-list-name"):
                            self.exclude_list_name = value
                            self.exclude_list_name.value_namespace = name_space
                            self.exclude_list_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "generation"):
                            self.generation = value
                            self.generation.value_namespace = name_space
                            self.generation.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-affinity-configured"):
                            self.is_affinity_configured = value
                            self.is_affinity_configured.value_namespace = name_space
                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-bandwidth-configured"):
                            self.is_bandwidth_configured = value
                            self.is_bandwidth_configured.value_namespace = name_space
                            self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-bfd-reverse-pat-configured"):
                            self.is_bfd_reverse_pat_configured = value
                            self.is_bfd_reverse_pat_configured.value_namespace = name_space
                            self.is_bfd_reverse_pat_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-cost-limit-configured"):
                            self.is_cost_limit_configured = value
                            self.is_cost_limit_configured.value_namespace = name_space
                            self.is_cost_limit_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-exclude-list-name-configured"):
                            self.is_exclude_list_name_configured = value
                            self.is_exclude_list_name_configured.value_namespace = name_space
                            self.is_exclude_list_name_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-path-invalidation-action-configured"):
                            self.is_path_invalidation_action_configured = value
                            self.is_path_invalidation_action_configured.value_namespace = name_space
                            self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-path-invalidation-timeout-configured"):
                            self.is_path_invalidation_timeout_configured = value
                            self.is_path_invalidation_timeout_configured.value_namespace = name_space
                            self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-pce-configured"):
                            self.is_pce_configured = value
                            self.is_pce_configured.value_namespace = name_space
                            self.is_pce_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-pce-disj-group-id-configured"):
                            self.is_pce_disj_group_id_configured = value
                            self.is_pce_disj_group_id_configured.value_namespace = name_space
                            self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-pce-disj-source-configured"):
                            self.is_pce_disj_source_configured = value
                            self.is_pce_disj_source_configured.value_namespace = name_space
                            self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-pce-disj-type-configured"):
                            self.is_pce_disj_type_configured = value
                            self.is_pce_disj_type_configured.value_namespace = name_space
                            self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-pceb-dj-source-configured"):
                            self.is_pceb_dj_source_configured = value
                            self.is_pceb_dj_source_configured.value_namespace = name_space
                            self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-pcebd-group-id-configured"):
                            self.is_pcebd_group_id_configured = value
                            self.is_pcebd_group_id_configured.value_namespace = name_space
                            self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "path-invalidation-action"):
                            self.path_invalidation_action = value
                            self.path_invalidation_action.value_namespace = name_space
                            self.path_invalidation_action.value_namespace_prefix = name_space_prefix
                        if(value_path == "path-invalidation-timeout"):
                            self.path_invalidation_timeout = value
                            self.path_invalidation_timeout.value_namespace = name_space
                            self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                        if(value_path == "pcebd-group-id"):
                            self.pcebd_group_id = value
                            self.pcebd_group_id.value_namespace = name_space
                            self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "pcebd-source-address"):
                            self.pcebd_source_address = value
                            self.pcebd_source_address.value_namespace = name_space
                            self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "pcedp-group-id"):
                            self.pcedp_group_id = value
                            self.pcedp_group_id.value_namespace = name_space
                            self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "pcedp-source-address"):
                            self.pcedp_source_address = value
                            self.pcedp_source_address.value_namespace = name_space
                            self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "pcedp-type"):
                            self.pcedp_type = value
                            self.pcedp_type.value_namespace = name_space
                            self.pcedp_type.value_namespace_prefix = name_space_prefix


                class AttributeSetAutobackup(Entity):
                    """
                    MPLS TE Auto\-backup Attribute Set
                    
                    .. attribute:: affinity
                    
                    	Affinity
                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity>`
                    
                    .. attribute:: hold_priority
                    
                    	Hold priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: is_affinity_configured
                    
                    	Is affinity configured
                    	**type**\:  bool
                    
                    .. attribute:: is_policyclass_configured
                    
                    	Is policy class configured
                    	**type**\:  bool
                    
                    .. attribute:: is_priority_configured
                    
                    	Is priority configured
                    	**type**\:  bool
                    
                    .. attribute:: is_signalled_name_configured
                    
                    	Is signalled name configured
                    	**type**\:  bool
                    
                    .. attribute:: logging
                    
                    	Logging attributes
                    	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging>`
                    
                    .. attribute:: policy_class
                    
                    	deprecated
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: policy_class_entry
                    
                    	PBTS policy classes
                    	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry>`
                    
                    .. attribute:: protected_interface
                    
                    	Array of Protected Interface Names
                    	**type**\: list of    :py:class:`ProtectedInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface>`
                    
                    .. attribute:: record_route
                    
                    	Record route
                    	**type**\:  bool
                    
                    .. attribute:: setup_priority
                    
                    	Setup priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: signalled_name
                    
                    	Signalled name
                    	**type**\:   :py:class:`SignalledName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName>`
                    
                    .. attribute:: tunnel_id
                    
                    	Tunnel ID
                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__init__()

                        self.yang_name = "attribute-set-autobackup"
                        self.yang_parent_name = "attribute-set-union"

                        self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                        self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                        self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                        self.is_signalled_name_configured = YLeaf(YType.boolean, "is-signalled-name-configured")

                        self.policy_class = YLeaf(YType.uint8, "policy-class")

                        self.record_route = YLeaf(YType.boolean, "record-route")

                        self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                        self.affinity = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                        self.affinity.parent = self
                        self._children_name_map["affinity"] = "affinity"
                        self._children_yang_names.add("affinity")

                        self.logging = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                        self.logging.parent = self
                        self._children_name_map["logging"] = "logging"
                        self._children_yang_names.add("logging")

                        self.signalled_name = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                        self.signalled_name.parent = self
                        self._children_name_map["signalled_name"] = "signalled-name"
                        self._children_yang_names.add("signalled-name")

                        self.policy_class_entry = YList(self)
                        self.protected_interface = YList(self)
                        self.tunnel_id = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("hold_priority",
                                        "is_affinity_configured",
                                        "is_policyclass_configured",
                                        "is_priority_configured",
                                        "is_signalled_name_configured",
                                        "policy_class",
                                        "record_route",
                                        "setup_priority") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup, self).__setattr__(name, value)


                    class SignalledName(Entity):
                        """
                        Signalled name
                        
                        .. attribute:: is_mp_addresses
                        
                        	MP address appended
                        	**type**\:  bool
                        
                        .. attribute:: name
                        
                        	Signalled name
                        	**type**\:  str
                        
                        .. attribute:: protected_interface_type
                        
                        	Protected interface address or name
                        	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                        
                        .. attribute:: source_type
                        
                        	Source address or name
                        	**type**\:   :py:class:`TeSigNameAppend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSigNameAppend>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__init__()

                            self.yang_name = "signalled-name"
                            self.yang_parent_name = "attribute-set-autobackup"

                            self.is_mp_addresses = YLeaf(YType.boolean, "is-mp-addresses")

                            self.name = YLeaf(YType.str, "name")

                            self.protected_interface_type = YLeaf(YType.enumeration, "protected-interface-type")

                            self.source_type = YLeaf(YType.enumeration, "source-type")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("is_mp_addresses",
                                            "name",
                                            "protected_interface_type",
                                            "source_type") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.is_mp_addresses.is_set or
                                self.name.is_set or
                                self.protected_interface_type.is_set or
                                self.source_type.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.is_mp_addresses.yfilter != YFilter.not_set or
                                self.name.yfilter != YFilter.not_set or
                                self.protected_interface_type.yfilter != YFilter.not_set or
                                self.source_type.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "signalled-name" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.is_mp_addresses.is_set or self.is_mp_addresses.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.is_mp_addresses.get_name_leafdata())
                            if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.name.get_name_leafdata())
                            if (self.protected_interface_type.is_set or self.protected_interface_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.protected_interface_type.get_name_leafdata())
                            if (self.source_type.is_set or self.source_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.source_type.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "is-mp-addresses" or name == "name" or name == "protected-interface-type" or name == "source-type"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "is-mp-addresses"):
                                self.is_mp_addresses = value
                                self.is_mp_addresses.value_namespace = name_space
                                self.is_mp_addresses.value_namespace_prefix = name_space_prefix
                            if(value_path == "name"):
                                self.name = value
                                self.name.value_namespace = name_space
                                self.name.value_namespace_prefix = name_space_prefix
                            if(value_path == "protected-interface-type"):
                                self.protected_interface_type = value
                                self.protected_interface_type.value_namespace = name_space
                                self.protected_interface_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "source-type"):
                                self.source_type = value
                                self.source_type.value_namespace = name_space
                                self.source_type.value_namespace_prefix = name_space_prefix


                    class Affinity(Entity):
                        """
                        Affinity
                        
                        .. attribute:: affinity_bits
                        
                        	The affinity bits (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: affinity_mask
                        
                        	The affinity mask (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: named_affinity
                        
                        	Array of name based constratints currently applied to the tunnel
                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__init__()

                            self.yang_name = "affinity"
                            self.yang_parent_name = "attribute-set-autobackup"

                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                            self.named_affinity = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("affinity_bits",
                                            "affinity_mask") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity, self).__setattr__(name, value)


                        class NamedAffinity(Entity):
                            """
                            Array of name based constratints currently
                            applied to the tunnel
                            
                            .. attribute:: constraint_extended_value
                            
                            	Constraint value
                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue>`
                            
                            .. attribute:: constraint_type
                            
                            	Constraint type
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: constraint_value
                            
                            	Deprecated
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: extended_forward_ref_value
                            
                            	Reference bits for undefined affinity names
                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                            
                            .. attribute:: forward_ref_value
                            
                            	Deprecated
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__init__()

                                self.yang_name = "named-affinity"
                                self.yang_parent_name = "affinity"

                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                self.constraint_extended_value = YList(self)
                                self.extended_forward_ref_value = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("constraint_type",
                                                "constraint_value",
                                                "forward_ref_value") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity, self).__setattr__(name, value)


                            class ConstraintExtendedValue(Entity):
                                """
                                Constraint value
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                    self.yang_name = "constraint-extended-value"
                                    self.yang_parent_name = "named-affinity"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "constraint-extended-value" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix


                            class ExtendedForwardRefValue(Entity):
                                """
                                Reference bits for undefined affinity names
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                    self.yang_name = "extended-forward-ref-value"
                                    self.yang_parent_name = "named-affinity"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.constraint_extended_value:
                                    if (c.has_data()):
                                        return True
                                for c in self.extended_forward_ref_value:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.constraint_type.is_set or
                                    self.constraint_value.is_set or
                                    self.forward_ref_value.is_set)

                            def has_operation(self):
                                for c in self.constraint_extended_value:
                                    if (c.has_operation()):
                                        return True
                                for c in self.extended_forward_ref_value:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.constraint_type.yfilter != YFilter.not_set or
                                    self.constraint_value.yfilter != YFilter.not_set or
                                    self.forward_ref_value.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "named-affinity" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "constraint-extended-value"):
                                    for c in self.constraint_extended_value:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ConstraintExtendedValue()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.constraint_extended_value.append(c)
                                    return c

                                if (child_yang_name == "extended-forward-ref-value"):
                                    for c in self.extended_forward_ref_value:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.extended_forward_ref_value.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "constraint-type"):
                                    self.constraint_type = value
                                    self.constraint_type.value_namespace = name_space
                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "constraint-value"):
                                    self.constraint_value = value
                                    self.constraint_value.value_namespace = name_space
                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                if(value_path == "forward-ref-value"):
                                    self.forward_ref_value = value
                                    self.forward_ref_value.value_namespace = name_space
                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.named_affinity:
                                if (c.has_data()):
                                    return True
                            return (
                                self.affinity_bits.is_set or
                                self.affinity_mask.is_set)

                        def has_operation(self):
                            for c in self.named_affinity:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.affinity_bits.yfilter != YFilter.not_set or
                                self.affinity_mask.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "affinity" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "named-affinity"):
                                for c in self.named_affinity:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity.NamedAffinity()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.named_affinity.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "affinity-bits"):
                                self.affinity_bits = value
                                self.affinity_bits.value_namespace = name_space
                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                            if(value_path == "affinity-mask"):
                                self.affinity_mask = value
                                self.affinity_mask.value_namespace = name_space
                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                    class Logging(Entity):
                        """
                        Logging attributes
                        
                        .. attribute:: all_logging_enabled
                        
                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                        	**type**\:  bool
                        
                        .. attribute:: lsp_bandwidth_change
                        
                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\:  bool
                        
                        .. attribute:: lsp_insufficient_bw
                        
                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\:  bool
                        
                        .. attribute:: lsp_pcalc_failure_logging_enabled
                        
                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\:  bool
                        
                        .. attribute:: lsp_re_opt
                        
                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\:  bool
                        
                        .. attribute:: lsp_re_route
                        
                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\:  bool
                        
                        .. attribute:: lsp_state
                        
                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\:  bool
                        
                        .. attribute:: s2l_state
                        
                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\:  bool
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__init__()

                            self.yang_name = "logging"
                            self.yang_parent_name = "attribute-set-autobackup"

                            self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                            self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                            self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                            self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                            self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                            self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                            self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                            self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("all_logging_enabled",
                                            "lsp_bandwidth_change",
                                            "lsp_insufficient_bw",
                                            "lsp_pcalc_failure_logging_enabled",
                                            "lsp_re_opt",
                                            "lsp_re_route",
                                            "lsp_state",
                                            "s2l_state") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.all_logging_enabled.is_set or
                                self.lsp_bandwidth_change.is_set or
                                self.lsp_insufficient_bw.is_set or
                                self.lsp_pcalc_failure_logging_enabled.is_set or
                                self.lsp_re_opt.is_set or
                                self.lsp_re_route.is_set or
                                self.lsp_state.is_set or
                                self.s2l_state.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.all_logging_enabled.yfilter != YFilter.not_set or
                                self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                self.lsp_re_opt.yfilter != YFilter.not_set or
                                self.lsp_re_route.yfilter != YFilter.not_set or
                                self.lsp_state.yfilter != YFilter.not_set or
                                self.s2l_state.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "logging" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                            if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                            if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                            if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                            if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                            if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                            if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsp_state.get_name_leafdata())
                            if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_state.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "all-logging-enabled"):
                                self.all_logging_enabled = value
                                self.all_logging_enabled.value_namespace = name_space
                                self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsp-bandwidth-change"):
                                self.lsp_bandwidth_change = value
                                self.lsp_bandwidth_change.value_namespace = name_space
                                self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsp-insufficient-bw"):
                                self.lsp_insufficient_bw = value
                                self.lsp_insufficient_bw.value_namespace = name_space
                                self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                self.lsp_pcalc_failure_logging_enabled = value
                                self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsp-re-opt"):
                                self.lsp_re_opt = value
                                self.lsp_re_opt.value_namespace = name_space
                                self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsp-re-route"):
                                self.lsp_re_route = value
                                self.lsp_re_route.value_namespace = name_space
                                self.lsp_re_route.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsp-state"):
                                self.lsp_state = value
                                self.lsp_state.value_namespace = name_space
                                self.lsp_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-state"):
                                self.s2l_state = value
                                self.s2l_state.value_namespace = name_space
                                self.s2l_state.value_namespace_prefix = name_space_prefix


                    class PolicyClassEntry(Entity):
                        """
                        PBTS policy classes
                        
                        .. attribute:: entry
                        
                        	
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__init__()

                            self.yang_name = "policy-class-entry"
                            self.yang_parent_name = "attribute-set-autobackup"

                            self.entry = YLeaf(YType.uint8, "entry")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("entry") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry, self).__setattr__(name, value)

                        def has_data(self):
                            return self.entry.is_set

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.entry.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "policy-class-entry" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.entry.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "entry"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "entry"):
                                self.entry = value
                                self.entry.value_namespace = name_space
                                self.entry.value_namespace_prefix = name_space_prefix


                    class TunnelId(Entity):
                        """
                        Tunnel ID
                        
                        .. attribute:: entry
                        
                        	
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__init__()

                            self.yang_name = "tunnel-id"
                            self.yang_parent_name = "attribute-set-autobackup"

                            self.entry = YLeaf(YType.uint16, "entry")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("entry") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId, self).__setattr__(name, value)

                        def has_data(self):
                            return self.entry.is_set

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.entry.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "tunnel-id" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.entry.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "entry"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "entry"):
                                self.entry = value
                                self.entry.value_namespace = name_space
                                self.entry.value_namespace_prefix = name_space_prefix


                    class ProtectedInterface(Entity):
                        """
                        Array of Protected Interface Names
                        
                        .. attribute:: protected_interface
                        
                        	Protected Interface Name
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__init__()

                            self.yang_name = "protected-interface"
                            self.yang_parent_name = "attribute-set-autobackup"

                            self.protected_interface = YLeaf(YType.str, "protected-interface")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("protected_interface") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface, self).__setattr__(name, value)

                        def has_data(self):
                            return self.protected_interface.is_set

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.protected_interface.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "protected-interface" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.protected_interface.is_set or self.protected_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.protected_interface.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "protected-interface"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "protected-interface"):
                                self.protected_interface = value
                                self.protected_interface.value_namespace = name_space
                                self.protected_interface.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.policy_class_entry:
                            if (c.has_data()):
                                return True
                        for c in self.protected_interface:
                            if (c.has_data()):
                                return True
                        for c in self.tunnel_id:
                            if (c.has_data()):
                                return True
                        return (
                            self.hold_priority.is_set or
                            self.is_affinity_configured.is_set or
                            self.is_policyclass_configured.is_set or
                            self.is_priority_configured.is_set or
                            self.is_signalled_name_configured.is_set or
                            self.policy_class.is_set or
                            self.record_route.is_set or
                            self.setup_priority.is_set or
                            (self.affinity is not None and self.affinity.has_data()) or
                            (self.logging is not None and self.logging.has_data()) or
                            (self.signalled_name is not None and self.signalled_name.has_data()))

                    def has_operation(self):
                        for c in self.policy_class_entry:
                            if (c.has_operation()):
                                return True
                        for c in self.protected_interface:
                            if (c.has_operation()):
                                return True
                        for c in self.tunnel_id:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.hold_priority.yfilter != YFilter.not_set or
                            self.is_affinity_configured.yfilter != YFilter.not_set or
                            self.is_policyclass_configured.yfilter != YFilter.not_set or
                            self.is_priority_configured.yfilter != YFilter.not_set or
                            self.is_signalled_name_configured.yfilter != YFilter.not_set or
                            self.policy_class.yfilter != YFilter.not_set or
                            self.record_route.yfilter != YFilter.not_set or
                            self.setup_priority.yfilter != YFilter.not_set or
                            (self.affinity is not None and self.affinity.has_operation()) or
                            (self.logging is not None and self.logging.has_operation()) or
                            (self.signalled_name is not None and self.signalled_name.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "attribute-set-autobackup" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.hold_priority.get_name_leafdata())
                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                        if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                        if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                        if (self.is_signalled_name_configured.is_set or self.is_signalled_name_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_signalled_name_configured.get_name_leafdata())
                        if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.policy_class.get_name_leafdata())
                        if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.record_route.get_name_leafdata())
                        if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.setup_priority.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "affinity"):
                            if (self.affinity is None):
                                self.affinity = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Affinity()
                                self.affinity.parent = self
                                self._children_name_map["affinity"] = "affinity"
                            return self.affinity

                        if (child_yang_name == "logging"):
                            if (self.logging is None):
                                self.logging = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.Logging()
                                self.logging.parent = self
                                self._children_name_map["logging"] = "logging"
                            return self.logging

                        if (child_yang_name == "policy-class-entry"):
                            for c in self.policy_class_entry:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.PolicyClassEntry()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.policy_class_entry.append(c)
                            return c

                        if (child_yang_name == "protected-interface"):
                            for c in self.protected_interface:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.ProtectedInterface()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.protected_interface.append(c)
                            return c

                        if (child_yang_name == "signalled-name"):
                            if (self.signalled_name is None):
                                self.signalled_name = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.SignalledName()
                                self.signalled_name.parent = self
                                self._children_name_map["signalled_name"] = "signalled-name"
                            return self.signalled_name

                        if (child_yang_name == "tunnel-id"):
                            for c in self.tunnel_id:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup.TunnelId()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.tunnel_id.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "affinity" or name == "logging" or name == "policy-class-entry" or name == "protected-interface" or name == "signalled-name" or name == "tunnel-id" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "is-signalled-name-configured" or name == "policy-class" or name == "record-route" or name == "setup-priority"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "hold-priority"):
                            self.hold_priority = value
                            self.hold_priority.value_namespace = name_space
                            self.hold_priority.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-affinity-configured"):
                            self.is_affinity_configured = value
                            self.is_affinity_configured.value_namespace = name_space
                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-policyclass-configured"):
                            self.is_policyclass_configured = value
                            self.is_policyclass_configured.value_namespace = name_space
                            self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-priority-configured"):
                            self.is_priority_configured = value
                            self.is_priority_configured.value_namespace = name_space
                            self.is_priority_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-signalled-name-configured"):
                            self.is_signalled_name_configured = value
                            self.is_signalled_name_configured.value_namespace = name_space
                            self.is_signalled_name_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "policy-class"):
                            self.policy_class = value
                            self.policy_class.value_namespace = name_space
                            self.policy_class.value_namespace_prefix = name_space_prefix
                        if(value_path == "record-route"):
                            self.record_route = value
                            self.record_route.value_namespace = name_space
                            self.record_route.value_namespace_prefix = name_space_prefix
                        if(value_path == "setup-priority"):
                            self.setup_priority = value
                            self.setup_priority.value_namespace = name_space
                            self.setup_priority.value_namespace_prefix = name_space_prefix


                class AttributeSetAutomesh(Entity):
                    """
                    MPLS TE Auto\-mesh Attribute Set
                    
                    .. attribute:: affinity
                    
                    	Affinity
                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity>`
                    
                    .. attribute:: auto_bandwidth_collect
                    
                    	Auto bandwidth collect only
                    	**type**\:  bool
                    
                    .. attribute:: auto_route_announce
                    
                    	Announce auto route to IGP
                    	**type**\:  bool
                    
                    .. attribute:: bandwidth
                    
                    	IM bandwidth
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: configured_bandwidth
                    
                    	Bandwidth value in kbps
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: kbit/s
                    
                    .. attribute:: dste_class_type
                    
                    	DSTE Class
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: fast_reroute
                    
                    	Fast reroute
                    	**type**\:  bool
                    
                    .. attribute:: forward_class
                    
                    	Forward class
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: frr_bandwidth_protection
                    
                    	FRR bandwidth protection
                    	**type**\:  bool
                    
                    .. attribute:: frr_node_protection
                    
                    	FRR Node protection
                    	**type**\:  bool
                    
                    .. attribute:: hold_priority
                    
                    	Hold priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: is_affinity_configured
                    
                    	Is affinity configured
                    	**type**\:  bool
                    
                    .. attribute:: is_bandwidth_configured
                    
                    	Is bandwidth configured
                    	**type**\:  bool
                    
                    .. attribute:: is_interface_bw_configured
                    
                    	Is Interface BW configured
                    	**type**\:  bool
                    
                    .. attribute:: is_policyclass_configured
                    
                    	Is policy class configured
                    	**type**\:  bool
                    
                    .. attribute:: is_priority_configured
                    
                    	Is priority configured
                    	**type**\:  bool
                    
                    .. attribute:: load_share
                    
                    	Load Share
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: logging
                    
                    	Logging attributes
                    	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging>`
                    
                    .. attribute:: mesh_group_id
                    
                    	Meshgroup ID
                    	**type**\: list of    :py:class:`MeshGroupId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId>`
                    
                    .. attribute:: policy_class
                    
                    	deprecated
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: policy_class_entry
                    
                    	PBTS policy classes
                    	**type**\: list of    :py:class:`PolicyClassEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry>`
                    
                    .. attribute:: record_route
                    
                    	Record route
                    	**type**\:  bool
                    
                    .. attribute:: setup_priority
                    
                    	Setup priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: soft_preemption_configured
                    
                    	Soft preemption is configured
                    	**type**\:  bool
                    
                    .. attribute:: tunnel_id
                    
                    	Tunnel ID
                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__init__()

                        self.yang_name = "attribute-set-automesh"
                        self.yang_parent_name = "attribute-set-union"

                        self.auto_bandwidth_collect = YLeaf(YType.boolean, "auto-bandwidth-collect")

                        self.auto_route_announce = YLeaf(YType.boolean, "auto-route-announce")

                        self.bandwidth = YLeaf(YType.uint32, "bandwidth")

                        self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                        self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                        self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                        self.forward_class = YLeaf(YType.uint32, "forward-class")

                        self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                        self.frr_node_protection = YLeaf(YType.boolean, "frr-node-protection")

                        self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                        self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                        self.is_interface_bw_configured = YLeaf(YType.boolean, "is-interface-bw-configured")

                        self.is_policyclass_configured = YLeaf(YType.boolean, "is-policyclass-configured")

                        self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                        self.load_share = YLeaf(YType.uint32, "load-share")

                        self.policy_class = YLeaf(YType.uint8, "policy-class")

                        self.record_route = YLeaf(YType.boolean, "record-route")

                        self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                        self.soft_preemption_configured = YLeaf(YType.boolean, "soft-preemption-configured")

                        self.affinity = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                        self.affinity.parent = self
                        self._children_name_map["affinity"] = "affinity"
                        self._children_yang_names.add("affinity")

                        self.logging = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                        self.logging.parent = self
                        self._children_name_map["logging"] = "logging"
                        self._children_yang_names.add("logging")

                        self.mesh_group_id = YList(self)
                        self.policy_class_entry = YList(self)
                        self.tunnel_id = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("auto_bandwidth_collect",
                                        "auto_route_announce",
                                        "bandwidth",
                                        "configured_bandwidth",
                                        "dste_class_type",
                                        "fast_reroute",
                                        "forward_class",
                                        "frr_bandwidth_protection",
                                        "frr_node_protection",
                                        "hold_priority",
                                        "is_affinity_configured",
                                        "is_bandwidth_configured",
                                        "is_interface_bw_configured",
                                        "is_policyclass_configured",
                                        "is_priority_configured",
                                        "load_share",
                                        "policy_class",
                                        "record_route",
                                        "setup_priority",
                                        "soft_preemption_configured") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh, self).__setattr__(name, value)


                    class Affinity(Entity):
                        """
                        Affinity
                        
                        .. attribute:: affinity_bits
                        
                        	The affinity bits (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: affinity_mask
                        
                        	The affinity mask (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: named_affinity
                        
                        	Array of name based constratints currently applied to the tunnel
                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__init__()

                            self.yang_name = "affinity"
                            self.yang_parent_name = "attribute-set-automesh"

                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                            self.named_affinity = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("affinity_bits",
                                            "affinity_mask") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity, self).__setattr__(name, value)


                        class NamedAffinity(Entity):
                            """
                            Array of name based constratints currently
                            applied to the tunnel
                            
                            .. attribute:: constraint_extended_value
                            
                            	Constraint value
                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue>`
                            
                            .. attribute:: constraint_type
                            
                            	Constraint type
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: constraint_value
                            
                            	Deprecated
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: extended_forward_ref_value
                            
                            	Reference bits for undefined affinity names
                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                            
                            .. attribute:: forward_ref_value
                            
                            	Deprecated
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__init__()

                                self.yang_name = "named-affinity"
                                self.yang_parent_name = "affinity"

                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                self.constraint_extended_value = YList(self)
                                self.extended_forward_ref_value = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("constraint_type",
                                                "constraint_value",
                                                "forward_ref_value") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity, self).__setattr__(name, value)


                            class ConstraintExtendedValue(Entity):
                                """
                                Constraint value
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                    self.yang_name = "constraint-extended-value"
                                    self.yang_parent_name = "named-affinity"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "constraint-extended-value" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix


                            class ExtendedForwardRefValue(Entity):
                                """
                                Reference bits for undefined affinity names
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                    self.yang_name = "extended-forward-ref-value"
                                    self.yang_parent_name = "named-affinity"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.constraint_extended_value:
                                    if (c.has_data()):
                                        return True
                                for c in self.extended_forward_ref_value:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.constraint_type.is_set or
                                    self.constraint_value.is_set or
                                    self.forward_ref_value.is_set)

                            def has_operation(self):
                                for c in self.constraint_extended_value:
                                    if (c.has_operation()):
                                        return True
                                for c in self.extended_forward_ref_value:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.constraint_type.yfilter != YFilter.not_set or
                                    self.constraint_value.yfilter != YFilter.not_set or
                                    self.forward_ref_value.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "named-affinity" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "constraint-extended-value"):
                                    for c in self.constraint_extended_value:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ConstraintExtendedValue()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.constraint_extended_value.append(c)
                                    return c

                                if (child_yang_name == "extended-forward-ref-value"):
                                    for c in self.extended_forward_ref_value:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.extended_forward_ref_value.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "constraint-type"):
                                    self.constraint_type = value
                                    self.constraint_type.value_namespace = name_space
                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "constraint-value"):
                                    self.constraint_value = value
                                    self.constraint_value.value_namespace = name_space
                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                if(value_path == "forward-ref-value"):
                                    self.forward_ref_value = value
                                    self.forward_ref_value.value_namespace = name_space
                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.named_affinity:
                                if (c.has_data()):
                                    return True
                            return (
                                self.affinity_bits.is_set or
                                self.affinity_mask.is_set)

                        def has_operation(self):
                            for c in self.named_affinity:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.affinity_bits.yfilter != YFilter.not_set or
                                self.affinity_mask.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "affinity" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "named-affinity"):
                                for c in self.named_affinity:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity.NamedAffinity()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.named_affinity.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "affinity-bits"):
                                self.affinity_bits = value
                                self.affinity_bits.value_namespace = name_space
                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                            if(value_path == "affinity-mask"):
                                self.affinity_mask = value
                                self.affinity_mask.value_namespace = name_space
                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                    class Logging(Entity):
                        """
                        Logging attributes
                        
                        .. attribute:: all_logging_enabled
                        
                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                        	**type**\:  bool
                        
                        .. attribute:: lsp_bandwidth_change
                        
                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\:  bool
                        
                        .. attribute:: lsp_insufficient_bw
                        
                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\:  bool
                        
                        .. attribute:: lsp_pcalc_failure_logging_enabled
                        
                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\:  bool
                        
                        .. attribute:: lsp_re_opt
                        
                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\:  bool
                        
                        .. attribute:: lsp_re_route
                        
                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\:  bool
                        
                        .. attribute:: lsp_state
                        
                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\:  bool
                        
                        .. attribute:: s2l_state
                        
                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\:  bool
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__init__()

                            self.yang_name = "logging"
                            self.yang_parent_name = "attribute-set-automesh"

                            self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                            self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                            self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                            self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                            self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                            self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                            self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                            self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("all_logging_enabled",
                                            "lsp_bandwidth_change",
                                            "lsp_insufficient_bw",
                                            "lsp_pcalc_failure_logging_enabled",
                                            "lsp_re_opt",
                                            "lsp_re_route",
                                            "lsp_state",
                                            "s2l_state") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.all_logging_enabled.is_set or
                                self.lsp_bandwidth_change.is_set or
                                self.lsp_insufficient_bw.is_set or
                                self.lsp_pcalc_failure_logging_enabled.is_set or
                                self.lsp_re_opt.is_set or
                                self.lsp_re_route.is_set or
                                self.lsp_state.is_set or
                                self.s2l_state.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.all_logging_enabled.yfilter != YFilter.not_set or
                                self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                self.lsp_re_opt.yfilter != YFilter.not_set or
                                self.lsp_re_route.yfilter != YFilter.not_set or
                                self.lsp_state.yfilter != YFilter.not_set or
                                self.s2l_state.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "logging" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                            if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                            if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                            if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                            if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                            if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                            if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsp_state.get_name_leafdata())
                            if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_state.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "all-logging-enabled"):
                                self.all_logging_enabled = value
                                self.all_logging_enabled.value_namespace = name_space
                                self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsp-bandwidth-change"):
                                self.lsp_bandwidth_change = value
                                self.lsp_bandwidth_change.value_namespace = name_space
                                self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsp-insufficient-bw"):
                                self.lsp_insufficient_bw = value
                                self.lsp_insufficient_bw.value_namespace = name_space
                                self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                self.lsp_pcalc_failure_logging_enabled = value
                                self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsp-re-opt"):
                                self.lsp_re_opt = value
                                self.lsp_re_opt.value_namespace = name_space
                                self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsp-re-route"):
                                self.lsp_re_route = value
                                self.lsp_re_route.value_namespace = name_space
                                self.lsp_re_route.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsp-state"):
                                self.lsp_state = value
                                self.lsp_state.value_namespace = name_space
                                self.lsp_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-state"):
                                self.s2l_state = value
                                self.s2l_state.value_namespace = name_space
                                self.s2l_state.value_namespace_prefix = name_space_prefix


                    class PolicyClassEntry(Entity):
                        """
                        PBTS policy classes
                        
                        .. attribute:: entry
                        
                        	
                        	**type**\:  int
                        
                        	**range:** 0..255
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__init__()

                            self.yang_name = "policy-class-entry"
                            self.yang_parent_name = "attribute-set-automesh"

                            self.entry = YLeaf(YType.uint8, "entry")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("entry") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry, self).__setattr__(name, value)

                        def has_data(self):
                            return self.entry.is_set

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.entry.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "policy-class-entry" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.entry.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "entry"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "entry"):
                                self.entry = value
                                self.entry.value_namespace = name_space
                                self.entry.value_namespace_prefix = name_space_prefix


                    class MeshGroupId(Entity):
                        """
                        Meshgroup ID
                        
                        .. attribute:: entry
                        
                        	
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__init__()

                            self.yang_name = "mesh-group-id"
                            self.yang_parent_name = "attribute-set-automesh"

                            self.entry = YLeaf(YType.uint32, "entry")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("entry") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId, self).__setattr__(name, value)

                        def has_data(self):
                            return self.entry.is_set

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.entry.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "mesh-group-id" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.entry.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "entry"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "entry"):
                                self.entry = value
                                self.entry.value_namespace = name_space
                                self.entry.value_namespace_prefix = name_space_prefix


                    class TunnelId(Entity):
                        """
                        Tunnel ID
                        
                        .. attribute:: entry
                        
                        	
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__init__()

                            self.yang_name = "tunnel-id"
                            self.yang_parent_name = "attribute-set-automesh"

                            self.entry = YLeaf(YType.uint16, "entry")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("entry") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId, self).__setattr__(name, value)

                        def has_data(self):
                            return self.entry.is_set

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.entry.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "tunnel-id" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.entry.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "entry"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "entry"):
                                self.entry = value
                                self.entry.value_namespace = name_space
                                self.entry.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.mesh_group_id:
                            if (c.has_data()):
                                return True
                        for c in self.policy_class_entry:
                            if (c.has_data()):
                                return True
                        for c in self.tunnel_id:
                            if (c.has_data()):
                                return True
                        return (
                            self.auto_bandwidth_collect.is_set or
                            self.auto_route_announce.is_set or
                            self.bandwidth.is_set or
                            self.configured_bandwidth.is_set or
                            self.dste_class_type.is_set or
                            self.fast_reroute.is_set or
                            self.forward_class.is_set or
                            self.frr_bandwidth_protection.is_set or
                            self.frr_node_protection.is_set or
                            self.hold_priority.is_set or
                            self.is_affinity_configured.is_set or
                            self.is_bandwidth_configured.is_set or
                            self.is_interface_bw_configured.is_set or
                            self.is_policyclass_configured.is_set or
                            self.is_priority_configured.is_set or
                            self.load_share.is_set or
                            self.policy_class.is_set or
                            self.record_route.is_set or
                            self.setup_priority.is_set or
                            self.soft_preemption_configured.is_set or
                            (self.affinity is not None and self.affinity.has_data()) or
                            (self.logging is not None and self.logging.has_data()))

                    def has_operation(self):
                        for c in self.mesh_group_id:
                            if (c.has_operation()):
                                return True
                        for c in self.policy_class_entry:
                            if (c.has_operation()):
                                return True
                        for c in self.tunnel_id:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.auto_bandwidth_collect.yfilter != YFilter.not_set or
                            self.auto_route_announce.yfilter != YFilter.not_set or
                            self.bandwidth.yfilter != YFilter.not_set or
                            self.configured_bandwidth.yfilter != YFilter.not_set or
                            self.dste_class_type.yfilter != YFilter.not_set or
                            self.fast_reroute.yfilter != YFilter.not_set or
                            self.forward_class.yfilter != YFilter.not_set or
                            self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                            self.frr_node_protection.yfilter != YFilter.not_set or
                            self.hold_priority.yfilter != YFilter.not_set or
                            self.is_affinity_configured.yfilter != YFilter.not_set or
                            self.is_bandwidth_configured.yfilter != YFilter.not_set or
                            self.is_interface_bw_configured.yfilter != YFilter.not_set or
                            self.is_policyclass_configured.yfilter != YFilter.not_set or
                            self.is_priority_configured.yfilter != YFilter.not_set or
                            self.load_share.yfilter != YFilter.not_set or
                            self.policy_class.yfilter != YFilter.not_set or
                            self.record_route.yfilter != YFilter.not_set or
                            self.setup_priority.yfilter != YFilter.not_set or
                            self.soft_preemption_configured.yfilter != YFilter.not_set or
                            (self.affinity is not None and self.affinity.has_operation()) or
                            (self.logging is not None and self.logging.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "attribute-set-automesh" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.auto_bandwidth_collect.is_set or self.auto_bandwidth_collect.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.auto_bandwidth_collect.get_name_leafdata())
                        if (self.auto_route_announce.is_set or self.auto_route_announce.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.auto_route_announce.get_name_leafdata())
                        if (self.bandwidth.is_set or self.bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.bandwidth.get_name_leafdata())
                        if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                        if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                        if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                        if (self.forward_class.is_set or self.forward_class.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.forward_class.get_name_leafdata())
                        if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                        if (self.frr_node_protection.is_set or self.frr_node_protection.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.frr_node_protection.get_name_leafdata())
                        if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.hold_priority.get_name_leafdata())
                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                        if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                        if (self.is_interface_bw_configured.is_set or self.is_interface_bw_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_interface_bw_configured.get_name_leafdata())
                        if (self.is_policyclass_configured.is_set or self.is_policyclass_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_policyclass_configured.get_name_leafdata())
                        if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                        if (self.load_share.is_set or self.load_share.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.load_share.get_name_leafdata())
                        if (self.policy_class.is_set or self.policy_class.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.policy_class.get_name_leafdata())
                        if (self.record_route.is_set or self.record_route.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.record_route.get_name_leafdata())
                        if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.setup_priority.get_name_leafdata())
                        if (self.soft_preemption_configured.is_set or self.soft_preemption_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.soft_preemption_configured.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "affinity"):
                            if (self.affinity is None):
                                self.affinity = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Affinity()
                                self.affinity.parent = self
                                self._children_name_map["affinity"] = "affinity"
                            return self.affinity

                        if (child_yang_name == "logging"):
                            if (self.logging is None):
                                self.logging = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.Logging()
                                self.logging.parent = self
                                self._children_name_map["logging"] = "logging"
                            return self.logging

                        if (child_yang_name == "mesh-group-id"):
                            for c in self.mesh_group_id:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.MeshGroupId()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.mesh_group_id.append(c)
                            return c

                        if (child_yang_name == "policy-class-entry"):
                            for c in self.policy_class_entry:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.PolicyClassEntry()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.policy_class_entry.append(c)
                            return c

                        if (child_yang_name == "tunnel-id"):
                            for c in self.tunnel_id:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh.TunnelId()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.tunnel_id.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "affinity" or name == "logging" or name == "mesh-group-id" or name == "policy-class-entry" or name == "tunnel-id" or name == "auto-bandwidth-collect" or name == "auto-route-announce" or name == "bandwidth" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "forward-class" or name == "frr-bandwidth-protection" or name == "frr-node-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-interface-bw-configured" or name == "is-policyclass-configured" or name == "is-priority-configured" or name == "load-share" or name == "policy-class" or name == "record-route" or name == "setup-priority" or name == "soft-preemption-configured"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "auto-bandwidth-collect"):
                            self.auto_bandwidth_collect = value
                            self.auto_bandwidth_collect.value_namespace = name_space
                            self.auto_bandwidth_collect.value_namespace_prefix = name_space_prefix
                        if(value_path == "auto-route-announce"):
                            self.auto_route_announce = value
                            self.auto_route_announce.value_namespace = name_space
                            self.auto_route_announce.value_namespace_prefix = name_space_prefix
                        if(value_path == "bandwidth"):
                            self.bandwidth = value
                            self.bandwidth.value_namespace = name_space
                            self.bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "configured-bandwidth"):
                            self.configured_bandwidth = value
                            self.configured_bandwidth.value_namespace = name_space
                            self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "dste-class-type"):
                            self.dste_class_type = value
                            self.dste_class_type.value_namespace = name_space
                            self.dste_class_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "fast-reroute"):
                            self.fast_reroute = value
                            self.fast_reroute.value_namespace = name_space
                            self.fast_reroute.value_namespace_prefix = name_space_prefix
                        if(value_path == "forward-class"):
                            self.forward_class = value
                            self.forward_class.value_namespace = name_space
                            self.forward_class.value_namespace_prefix = name_space_prefix
                        if(value_path == "frr-bandwidth-protection"):
                            self.frr_bandwidth_protection = value
                            self.frr_bandwidth_protection.value_namespace = name_space
                            self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                        if(value_path == "frr-node-protection"):
                            self.frr_node_protection = value
                            self.frr_node_protection.value_namespace = name_space
                            self.frr_node_protection.value_namespace_prefix = name_space_prefix
                        if(value_path == "hold-priority"):
                            self.hold_priority = value
                            self.hold_priority.value_namespace = name_space
                            self.hold_priority.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-affinity-configured"):
                            self.is_affinity_configured = value
                            self.is_affinity_configured.value_namespace = name_space
                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-bandwidth-configured"):
                            self.is_bandwidth_configured = value
                            self.is_bandwidth_configured.value_namespace = name_space
                            self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-interface-bw-configured"):
                            self.is_interface_bw_configured = value
                            self.is_interface_bw_configured.value_namespace = name_space
                            self.is_interface_bw_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-policyclass-configured"):
                            self.is_policyclass_configured = value
                            self.is_policyclass_configured.value_namespace = name_space
                            self.is_policyclass_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-priority-configured"):
                            self.is_priority_configured = value
                            self.is_priority_configured.value_namespace = name_space
                            self.is_priority_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "load-share"):
                            self.load_share = value
                            self.load_share.value_namespace = name_space
                            self.load_share.value_namespace_prefix = name_space_prefix
                        if(value_path == "policy-class"):
                            self.policy_class = value
                            self.policy_class.value_namespace = name_space
                            self.policy_class.value_namespace_prefix = name_space_prefix
                        if(value_path == "record-route"):
                            self.record_route = value
                            self.record_route.value_namespace = name_space
                            self.record_route.value_namespace_prefix = name_space_prefix
                        if(value_path == "setup-priority"):
                            self.setup_priority = value
                            self.setup_priority.value_namespace = name_space
                            self.setup_priority.value_namespace_prefix = name_space_prefix
                        if(value_path == "soft-preemption-configured"):
                            self.soft_preemption_configured = value
                            self.soft_preemption_configured.value_namespace = name_space
                            self.soft_preemption_configured.value_namespace_prefix = name_space_prefix


                class AttributeSetXro(Entity):
                    """
                    Attribute Set XRO
                    
                    .. attribute:: xro
                    
                    	The XRO specified by this attribute\-set
                    	**type**\:   :py:class:`Xro <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro, self).__init__()

                        self.yang_name = "attribute-set-xro"
                        self.yang_parent_name = "attribute-set-union"

                        self.xro = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                        self.xro.parent = self
                        self._children_name_map["xro"] = "xro"
                        self._children_yang_names.add("xro")


                    class Xro(Entity):
                        """
                        The XRO specified by this attribute\-set
                        
                        .. attribute:: mutual_diversity_flag
                        
                        	Mutual Diversity Flag
                        	**type**\:  bool
                        
                        .. attribute:: xro_subobject
                        
                        	List of XRO sub\-objects
                        	**type**\: list of    :py:class:`XroSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__init__()

                            self.yang_name = "xro"
                            self.yang_parent_name = "attribute-set-xro"

                            self.mutual_diversity_flag = YLeaf(YType.boolean, "mutual-diversity-flag")

                            self.xro_subobject = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("mutual_diversity_flag") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro, self).__setattr__(name, value)


                        class XroSubobject(Entity):
                            """
                            List of XRO sub\-objects
                            
                            .. attribute:: as_subobject
                            
                            	AS sub\-object
                            	**type**\:   :py:class:`AsSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject>`
                            
                            .. attribute:: ipv4_subobject
                            
                            	IPv4 sub\-object
                            	**type**\:   :py:class:`Ipv4Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject>`
                            
                            .. attribute:: ipv6_subobject
                            
                            	IPv6 sub\-object
                            	**type**\:   :py:class:`Ipv6Subobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject>`
                            
                            .. attribute:: lsp_subobject
                            
                            	P2P LSP sub\-object
                            	**type**\:   :py:class:`LspSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject>`
                            
                            .. attribute:: srlg_subobject
                            
                            	SRLG sub\-object
                            	**type**\:   :py:class:`SrlgSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject>`
                            
                            .. attribute:: type
                            
                            	Type
                            	**type**\:   :py:class:`TeXroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroSubobj>`
                            
                            .. attribute:: unnumbered_subobject
                            
                            	Unnumbered sub\-object
                            	**type**\:   :py:class:`UnnumberedSubobject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__init__()

                                self.yang_name = "xro-subobject"
                                self.yang_parent_name = "xro"

                                self.type = YLeaf(YType.enumeration, "type")

                                self.as_subobject = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                self.as_subobject.parent = self
                                self._children_name_map["as_subobject"] = "as-subobject"
                                self._children_yang_names.add("as-subobject")

                                self.ipv4_subobject = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                self.ipv4_subobject.parent = self
                                self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                self._children_yang_names.add("ipv4-subobject")

                                self.ipv6_subobject = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                self.ipv6_subobject.parent = self
                                self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                self._children_yang_names.add("ipv6-subobject")

                                self.lsp_subobject = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                self.lsp_subobject.parent = self
                                self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                self._children_yang_names.add("lsp-subobject")

                                self.srlg_subobject = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                self.srlg_subobject.parent = self
                                self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                self._children_yang_names.add("srlg-subobject")

                                self.unnumbered_subobject = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                self.unnumbered_subobject.parent = self
                                self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                self._children_yang_names.add("unnumbered-subobject")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject, self).__setattr__(name, value)


                            class Ipv4Subobject(Entity):
                                """
                                IPv4 sub\-object
                                
                                .. attribute:: address
                                
                                	IPv4 address
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: attribute
                                
                                	Attribute
                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                
                                .. attribute:: exclusion_type
                                
                                	Exclusion Type
                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                
                                .. attribute:: prefix_len
                                
                                	Prefix length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__init__()

                                    self.yang_name = "ipv4-subobject"
                                    self.yang_parent_name = "xro-subobject"

                                    self.address = YLeaf(YType.str, "address")

                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                    self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("address",
                                                    "attribute",
                                                    "exclusion_type",
                                                    "prefix_len") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.address.is_set or
                                        self.attribute.is_set or
                                        self.exclusion_type.is_set or
                                        self.prefix_len.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.address.yfilter != YFilter.not_set or
                                        self.attribute.yfilter != YFilter.not_set or
                                        self.exclusion_type.yfilter != YFilter.not_set or
                                        self.prefix_len.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv4-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.address.get_name_leafdata())
                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                    if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "address"):
                                        self.address = value
                                        self.address.value_namespace = name_space
                                        self.address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "attribute"):
                                        self.attribute = value
                                        self.attribute.value_namespace = name_space
                                        self.attribute.value_namespace_prefix = name_space_prefix
                                    if(value_path == "exclusion-type"):
                                        self.exclusion_type = value
                                        self.exclusion_type.value_namespace = name_space
                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-len"):
                                        self.prefix_len = value
                                        self.prefix_len.value_namespace = name_space
                                        self.prefix_len.value_namespace_prefix = name_space_prefix


                            class Ipv6Subobject(Entity):
                                """
                                IPv6 sub\-object
                                
                                .. attribute:: address
                                
                                	IPv6 address
                                	**type**\:  str
                                
                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: attribute
                                
                                	Attribute
                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                
                                .. attribute:: exclusion_type
                                
                                	Exclusion Type
                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                
                                .. attribute:: prefix_len
                                
                                	Prefix length
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__init__()

                                    self.yang_name = "ipv6-subobject"
                                    self.yang_parent_name = "xro-subobject"

                                    self.address = YLeaf(YType.str, "address")

                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                    self.prefix_len = YLeaf(YType.uint8, "prefix-len")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("address",
                                                    "attribute",
                                                    "exclusion_type",
                                                    "prefix_len") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.address.is_set or
                                        self.attribute.is_set or
                                        self.exclusion_type.is_set or
                                        self.prefix_len.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.address.yfilter != YFilter.not_set or
                                        self.attribute.yfilter != YFilter.not_set or
                                        self.exclusion_type.yfilter != YFilter.not_set or
                                        self.prefix_len.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "ipv6-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.address.is_set or self.address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.address.get_name_leafdata())
                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                    if (self.prefix_len.is_set or self.prefix_len.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.prefix_len.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "address" or name == "attribute" or name == "exclusion-type" or name == "prefix-len"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "address"):
                                        self.address = value
                                        self.address.value_namespace = name_space
                                        self.address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "attribute"):
                                        self.attribute = value
                                        self.attribute.value_namespace = name_space
                                        self.attribute.value_namespace_prefix = name_space_prefix
                                    if(value_path == "exclusion-type"):
                                        self.exclusion_type = value
                                        self.exclusion_type.value_namespace = name_space
                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                    if(value_path == "prefix-len"):
                                        self.prefix_len = value
                                        self.prefix_len.value_namespace = name_space
                                        self.prefix_len.value_namespace_prefix = name_space_prefix


                            class UnnumberedSubobject(Entity):
                                """
                                Unnumbered sub\-object
                                
                                .. attribute:: attribute
                                
                                	Attribute
                                	**type**\:   :py:class:`TeXroAttribute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroAttribute>`
                                
                                .. attribute:: exclusion_type
                                
                                	Exclusion Type
                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                
                                .. attribute:: interface_id
                                
                                	Interface ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: te_router_id
                                
                                	TE router\-id
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__init__()

                                    self.yang_name = "unnumbered-subobject"
                                    self.yang_parent_name = "xro-subobject"

                                    self.attribute = YLeaf(YType.enumeration, "attribute")

                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                    self.interface_id = YLeaf(YType.uint32, "interface-id")

                                    self.te_router_id = YLeaf(YType.str, "te-router-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("attribute",
                                                    "exclusion_type",
                                                    "interface_id",
                                                    "te_router_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.attribute.is_set or
                                        self.exclusion_type.is_set or
                                        self.interface_id.is_set or
                                        self.te_router_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.attribute.yfilter != YFilter.not_set or
                                        self.exclusion_type.yfilter != YFilter.not_set or
                                        self.interface_id.yfilter != YFilter.not_set or
                                        self.te_router_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "unnumbered-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.attribute.is_set or self.attribute.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.attribute.get_name_leafdata())
                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                    if (self.interface_id.is_set or self.interface_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.interface_id.get_name_leafdata())
                                    if (self.te_router_id.is_set or self.te_router_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.te_router_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "attribute" or name == "exclusion-type" or name == "interface-id" or name == "te-router-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "attribute"):
                                        self.attribute = value
                                        self.attribute.value_namespace = name_space
                                        self.attribute.value_namespace_prefix = name_space_prefix
                                    if(value_path == "exclusion-type"):
                                        self.exclusion_type = value
                                        self.exclusion_type.value_namespace = name_space
                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                    if(value_path == "interface-id"):
                                        self.interface_id = value
                                        self.interface_id.value_namespace = name_space
                                        self.interface_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "te-router-id"):
                                        self.te_router_id = value
                                        self.te_router_id.value_namespace = name_space
                                        self.te_router_id.value_namespace_prefix = name_space_prefix


                            class AsSubobject(Entity):
                                """
                                AS sub\-object
                                
                                .. attribute:: as_number
                                
                                	Autonomous System number
                                	**type**\:  int
                                
                                	**range:** 0..65535
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__init__()

                                    self.yang_name = "as-subobject"
                                    self.yang_parent_name = "xro-subobject"

                                    self.as_number = YLeaf(YType.uint16, "as-number")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("as_number") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.as_number.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.as_number.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "as-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.as_number.is_set or self.as_number.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.as_number.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "as-number"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "as-number"):
                                        self.as_number = value
                                        self.as_number.value_namespace = name_space
                                        self.as_number.value_namespace_prefix = name_space_prefix


                            class SrlgSubobject(Entity):
                                """
                                SRLG sub\-object
                                
                                .. attribute:: exclusion_type
                                
                                	Exclusion Type
                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                
                                .. attribute:: srlg_id
                                
                                	SRLG ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__init__()

                                    self.yang_name = "srlg-subobject"
                                    self.yang_parent_name = "xro-subobject"

                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                    self.srlg_id = YLeaf(YType.uint32, "srlg-id")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("exclusion_type",
                                                    "srlg_id") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.exclusion_type.is_set or
                                        self.srlg_id.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.exclusion_type.yfilter != YFilter.not_set or
                                        self.srlg_id.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "srlg-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                    if (self.srlg_id.is_set or self.srlg_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.srlg_id.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "exclusion-type" or name == "srlg-id"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "exclusion-type"):
                                        self.exclusion_type = value
                                        self.exclusion_type.value_namespace = name_space
                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                    if(value_path == "srlg-id"):
                                        self.srlg_id = value
                                        self.srlg_id.value_namespace = name_space
                                        self.srlg_id.value_namespace_prefix = name_space_prefix


                            class LspSubobject(Entity):
                                """
                                P2P LSP sub\-object
                                
                                .. attribute:: destination_node_exception
                                
                                	Destination\-node exception flag
                                	**type**\:  bool
                                
                                .. attribute:: exclusion_type
                                
                                	Exclusion Type
                                	**type**\:   :py:class:`TeXroExclusion <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeXroExclusion>`
                                
                                .. attribute:: fec
                                
                                	LSP FEC
                                	**type**\:   :py:class:`Fec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec>`
                                
                                .. attribute:: ignore_lsp_id
                                
                                	Flag to indicate whether or not the lsp\-id in the FEC is to be ignored
                                	**type**\:  bool
                                
                                .. attribute:: penultimate_node_exception
                                
                                	Penultimate\-node exception flag
                                	**type**\:  bool
                                
                                .. attribute:: processing_node_exception
                                
                                	Processing\-node exception flag
                                	**type**\:  bool
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__init__()

                                    self.yang_name = "lsp-subobject"
                                    self.yang_parent_name = "xro-subobject"

                                    self.destination_node_exception = YLeaf(YType.boolean, "destination-node-exception")

                                    self.exclusion_type = YLeaf(YType.enumeration, "exclusion-type")

                                    self.ignore_lsp_id = YLeaf(YType.boolean, "ignore-lsp-id")

                                    self.penultimate_node_exception = YLeaf(YType.boolean, "penultimate-node-exception")

                                    self.processing_node_exception = YLeaf(YType.boolean, "processing-node-exception")

                                    self.fec = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                    self.fec.parent = self
                                    self._children_name_map["fec"] = "fec"
                                    self._children_yang_names.add("fec")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("destination_node_exception",
                                                    "exclusion_type",
                                                    "ignore_lsp_id",
                                                    "penultimate_node_exception",
                                                    "processing_node_exception") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject, self).__setattr__(name, value)


                                class Fec(Entity):
                                    """
                                    LSP FEC
                                    
                                    .. attribute:: fec_destination_info
                                    
                                    	Destination or P2MP ID
                                    	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo>`
                                    
                                    .. attribute:: fec_extended_tunnel_id
                                    
                                    	Extended tunnel ID
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: fec_lsp_id
                                    
                                    	LSP ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: fec_source
                                    
                                    	Tunnel source address
                                    	**type**\:  str
                                    
                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                    
                                    .. attribute:: fec_tunnel_id
                                    
                                    	Tunnel ID
                                    	**type**\:  int
                                    
                                    	**range:** 0..65535
                                    
                                    .. attribute:: fec_vrf
                                    
                                    	VRF; currently only for GMPLS tunnels
                                    	**type**\:  str
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__init__()

                                        self.yang_name = "fec"
                                        self.yang_parent_name = "lsp-subobject"

                                        self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                        self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                        self.fec_source = YLeaf(YType.str, "fec-source")

                                        self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                        self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                        self.fec_destination_info = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                        self.fec_destination_info.parent = self
                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                        self._children_yang_names.add("fec-destination-info")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("fec_extended_tunnel_id",
                                                        "fec_lsp_id",
                                                        "fec_source",
                                                        "fec_tunnel_id",
                                                        "fec_vrf") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec, self).__setattr__(name, value)


                                    class FecDestinationInfo(Entity):
                                        """
                                        Destination or P2MP ID
                                        
                                        .. attribute:: fec_ctype
                                        
                                        	FEC CType
                                        	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                        
                                        .. attribute:: fec_destination_p2mp_id
                                        
                                        	P2MP ID
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: p2p_lsp_destination
                                        
                                        	P2P LSP destination
                                        	**type**\:  str
                                        
                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                        
                                        

                                        """

                                        _prefix = 'mpls-te-oper'
                                        _revision = '2015-11-09'

                                        def __init__(self):
                                            super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__init__()

                                            self.yang_name = "fec-destination-info"
                                            self.yang_parent_name = "fec"

                                            self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                            self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                            self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                        def __setattr__(self, name, value):
                                            self._check_monkey_patching_error(name, value)
                                            with _handle_type_error():
                                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                        "Please use list append or extend method."
                                                                        .format(value))
                                                if isinstance(value, Enum.YLeaf):
                                                    value = value.name
                                                if name in ("fec_ctype",
                                                            "fec_destination_p2mp_id",
                                                            "p2p_lsp_destination") and name in self.__dict__:
                                                    if isinstance(value, YLeaf):
                                                        self.__dict__[name].set(value.get())
                                                    elif isinstance(value, YLeafList):
                                                        super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)
                                                    else:
                                                        self.__dict__[name].set(value)
                                                else:
                                                    if hasattr(value, "parent") and name != "parent":
                                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                            value.parent = self
                                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                                            value.parent = self
                                                    super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo, self).__setattr__(name, value)

                                        def has_data(self):
                                            return (
                                                self.fec_ctype.is_set or
                                                self.fec_destination_p2mp_id.is_set or
                                                self.p2p_lsp_destination.is_set)

                                        def has_operation(self):
                                            return (
                                                self.yfilter != YFilter.not_set or
                                                self.fec_ctype.yfilter != YFilter.not_set or
                                                self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                                self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                        def get_segment_path(self):
                                            path_buffer = ""
                                            path_buffer = "fec-destination-info" + path_buffer

                                            return path_buffer

                                        def get_entity_path(self, ancestor):
                                            path_buffer = ""
                                            if (ancestor is None):
                                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                            else:
                                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                            leaf_name_data = LeafDataList()
                                            if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                            if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                            if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                                leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                            entity_path = EntityPath(path_buffer, leaf_name_data)
                                            return entity_path

                                        def get_child_by_name(self, child_yang_name, segment_path):
                                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                            if child is not None:
                                                return child

                                            return None

                                        def has_leaf_or_child_of_name(self, name):
                                            if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                                return True
                                            return False

                                        def set_value(self, value_path, value, name_space, name_space_prefix):
                                            if(value_path == "fec-ctype"):
                                                self.fec_ctype = value
                                                self.fec_ctype.value_namespace = name_space
                                                self.fec_ctype.value_namespace_prefix = name_space_prefix
                                            if(value_path == "fec-destination-p2mp-id"):
                                                self.fec_destination_p2mp_id = value
                                                self.fec_destination_p2mp_id.value_namespace = name_space
                                                self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                            if(value_path == "p2p-lsp-destination"):
                                                self.p2p_lsp_destination = value
                                                self.p2p_lsp_destination.value_namespace = name_space
                                                self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                                    def has_data(self):
                                        return (
                                            self.fec_extended_tunnel_id.is_set or
                                            self.fec_lsp_id.is_set or
                                            self.fec_source.is_set or
                                            self.fec_tunnel_id.is_set or
                                            self.fec_vrf.is_set or
                                            (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                            self.fec_lsp_id.yfilter != YFilter.not_set or
                                            self.fec_source.yfilter != YFilter.not_set or
                                            self.fec_tunnel_id.yfilter != YFilter.not_set or
                                            self.fec_vrf.yfilter != YFilter.not_set or
                                            (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "fec" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                        if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                        if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.fec_source.get_name_leafdata())
                                        if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                        if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        if (child_yang_name == "fec-destination-info"):
                                            if (self.fec_destination_info is None):
                                                self.fec_destination_info = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec.FecDestinationInfo()
                                                self.fec_destination_info.parent = self
                                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                            return self.fec_destination_info

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "fec-extended-tunnel-id"):
                                            self.fec_extended_tunnel_id = value
                                            self.fec_extended_tunnel_id.value_namespace = name_space
                                            self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "fec-lsp-id"):
                                            self.fec_lsp_id = value
                                            self.fec_lsp_id.value_namespace = name_space
                                            self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "fec-source"):
                                            self.fec_source = value
                                            self.fec_source.value_namespace = name_space
                                            self.fec_source.value_namespace_prefix = name_space_prefix
                                        if(value_path == "fec-tunnel-id"):
                                            self.fec_tunnel_id = value
                                            self.fec_tunnel_id.value_namespace = name_space
                                            self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                        if(value_path == "fec-vrf"):
                                            self.fec_vrf = value
                                            self.fec_vrf.value_namespace = name_space
                                            self.fec_vrf.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    return (
                                        self.destination_node_exception.is_set or
                                        self.exclusion_type.is_set or
                                        self.ignore_lsp_id.is_set or
                                        self.penultimate_node_exception.is_set or
                                        self.processing_node_exception.is_set or
                                        (self.fec is not None and self.fec.has_data()))

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.destination_node_exception.yfilter != YFilter.not_set or
                                        self.exclusion_type.yfilter != YFilter.not_set or
                                        self.ignore_lsp_id.yfilter != YFilter.not_set or
                                        self.penultimate_node_exception.yfilter != YFilter.not_set or
                                        self.processing_node_exception.yfilter != YFilter.not_set or
                                        (self.fec is not None and self.fec.has_operation()))

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "lsp-subobject" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.destination_node_exception.is_set or self.destination_node_exception.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.destination_node_exception.get_name_leafdata())
                                    if (self.exclusion_type.is_set or self.exclusion_type.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.exclusion_type.get_name_leafdata())
                                    if (self.ignore_lsp_id.is_set or self.ignore_lsp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.ignore_lsp_id.get_name_leafdata())
                                    if (self.penultimate_node_exception.is_set or self.penultimate_node_exception.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.penultimate_node_exception.get_name_leafdata())
                                    if (self.processing_node_exception.is_set or self.processing_node_exception.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.processing_node_exception.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "fec"):
                                        if (self.fec is None):
                                            self.fec = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject.Fec()
                                            self.fec.parent = self
                                            self._children_name_map["fec"] = "fec"
                                        return self.fec

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "fec" or name == "destination-node-exception" or name == "exclusion-type" or name == "ignore-lsp-id" or name == "penultimate-node-exception" or name == "processing-node-exception"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "destination-node-exception"):
                                        self.destination_node_exception = value
                                        self.destination_node_exception.value_namespace = name_space
                                        self.destination_node_exception.value_namespace_prefix = name_space_prefix
                                    if(value_path == "exclusion-type"):
                                        self.exclusion_type = value
                                        self.exclusion_type.value_namespace = name_space
                                        self.exclusion_type.value_namespace_prefix = name_space_prefix
                                    if(value_path == "ignore-lsp-id"):
                                        self.ignore_lsp_id = value
                                        self.ignore_lsp_id.value_namespace = name_space
                                        self.ignore_lsp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "penultimate-node-exception"):
                                        self.penultimate_node_exception = value
                                        self.penultimate_node_exception.value_namespace = name_space
                                        self.penultimate_node_exception.value_namespace_prefix = name_space_prefix
                                    if(value_path == "processing-node-exception"):
                                        self.processing_node_exception = value
                                        self.processing_node_exception.value_namespace = name_space
                                        self.processing_node_exception.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.type.is_set or
                                    (self.as_subobject is not None and self.as_subobject.has_data()) or
                                    (self.ipv4_subobject is not None and self.ipv4_subobject.has_data()) or
                                    (self.ipv6_subobject is not None and self.ipv6_subobject.has_data()) or
                                    (self.lsp_subobject is not None and self.lsp_subobject.has_data()) or
                                    (self.srlg_subobject is not None and self.srlg_subobject.has_data()) or
                                    (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.type.yfilter != YFilter.not_set or
                                    (self.as_subobject is not None and self.as_subobject.has_operation()) or
                                    (self.ipv4_subobject is not None and self.ipv4_subobject.has_operation()) or
                                    (self.ipv6_subobject is not None and self.ipv6_subobject.has_operation()) or
                                    (self.lsp_subobject is not None and self.lsp_subobject.has_operation()) or
                                    (self.srlg_subobject is not None and self.srlg_subobject.has_operation()) or
                                    (self.unnumbered_subobject is not None and self.unnumbered_subobject.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "xro-subobject" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "as-subobject"):
                                    if (self.as_subobject is None):
                                        self.as_subobject = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.AsSubobject()
                                        self.as_subobject.parent = self
                                        self._children_name_map["as_subobject"] = "as-subobject"
                                    return self.as_subobject

                                if (child_yang_name == "ipv4-subobject"):
                                    if (self.ipv4_subobject is None):
                                        self.ipv4_subobject = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv4Subobject()
                                        self.ipv4_subobject.parent = self
                                        self._children_name_map["ipv4_subobject"] = "ipv4-subobject"
                                    return self.ipv4_subobject

                                if (child_yang_name == "ipv6-subobject"):
                                    if (self.ipv6_subobject is None):
                                        self.ipv6_subobject = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.Ipv6Subobject()
                                        self.ipv6_subobject.parent = self
                                        self._children_name_map["ipv6_subobject"] = "ipv6-subobject"
                                    return self.ipv6_subobject

                                if (child_yang_name == "lsp-subobject"):
                                    if (self.lsp_subobject is None):
                                        self.lsp_subobject = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.LspSubobject()
                                        self.lsp_subobject.parent = self
                                        self._children_name_map["lsp_subobject"] = "lsp-subobject"
                                    return self.lsp_subobject

                                if (child_yang_name == "srlg-subobject"):
                                    if (self.srlg_subobject is None):
                                        self.srlg_subobject = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.SrlgSubobject()
                                        self.srlg_subobject.parent = self
                                        self._children_name_map["srlg_subobject"] = "srlg-subobject"
                                    return self.srlg_subobject

                                if (child_yang_name == "unnumbered-subobject"):
                                    if (self.unnumbered_subobject is None):
                                        self.unnumbered_subobject = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject.UnnumberedSubobject()
                                        self.unnumbered_subobject.parent = self
                                        self._children_name_map["unnumbered_subobject"] = "unnumbered-subobject"
                                    return self.unnumbered_subobject

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "as-subobject" or name == "ipv4-subobject" or name == "ipv6-subobject" or name == "lsp-subobject" or name == "srlg-subobject" or name == "unnumbered-subobject" or name == "type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "type"):
                                    self.type = value
                                    self.type.value_namespace = name_space
                                    self.type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.xro_subobject:
                                if (c.has_data()):
                                    return True
                            return self.mutual_diversity_flag.is_set

                        def has_operation(self):
                            for c in self.xro_subobject:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.mutual_diversity_flag.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "xro" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.mutual_diversity_flag.is_set or self.mutual_diversity_flag.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.mutual_diversity_flag.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "xro-subobject"):
                                for c in self.xro_subobject:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro.XroSubobject()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.xro_subobject.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "xro-subobject" or name == "mutual-diversity-flag"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "mutual-diversity-flag"):
                                self.mutual_diversity_flag = value
                                self.mutual_diversity_flag.value_namespace = name_space
                                self.mutual_diversity_flag.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (self.xro is not None and self.xro.has_data())

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            (self.xro is not None and self.xro.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "attribute-set-xro" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "xro"):
                            if (self.xro is None):
                                self.xro = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro.Xro()
                                self.xro.parent = self
                                self._children_name_map["xro"] = "xro"
                            return self.xro

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "xro"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class AttributeSetP2Mpte(Entity):
                    """
                    MPLS TE P2MP\-TE Attribute Set
                    
                    .. attribute:: affinity
                    
                    	Affinity
                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity>`
                    
                    .. attribute:: configured_bandwidth
                    
                    	Bandwidth value in kbps
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: kbit/s
                    
                    .. attribute:: dste_class_type
                    
                    	DSTE Class
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: fast_reroute
                    
                    	Fast reroute
                    	**type**\:  bool
                    
                    .. attribute:: frr_bandwidth_protection
                    
                    	FRR bandwidth protection
                    	**type**\:  bool
                    
                    .. attribute:: hold_priority
                    
                    	Hold priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: is_affinity_configured
                    
                    	Is affinity configured
                    	**type**\:  bool
                    
                    .. attribute:: is_bandwidth_configured
                    
                    	Is bandwidth configured
                    	**type**\:  bool
                    
                    .. attribute:: is_priority_configured
                    
                    	Is priority configured
                    	**type**\:  bool
                    
                    .. attribute:: setup_priority
                    
                    	Setup priority
                    	**type**\:  int
                    
                    	**range:** 0..255
                    
                    .. attribute:: tunnel_id
                    
                    	Tunnel ID
                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__init__()

                        self.yang_name = "attribute-set-p2mpte"
                        self.yang_parent_name = "attribute-set-union"

                        self.configured_bandwidth = YLeaf(YType.uint32, "configured-bandwidth")

                        self.dste_class_type = YLeaf(YType.uint8, "dste-class-type")

                        self.fast_reroute = YLeaf(YType.boolean, "fast-reroute")

                        self.frr_bandwidth_protection = YLeaf(YType.boolean, "frr-bandwidth-protection")

                        self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                        self.is_bandwidth_configured = YLeaf(YType.boolean, "is-bandwidth-configured")

                        self.is_priority_configured = YLeaf(YType.boolean, "is-priority-configured")

                        self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                        self.affinity = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                        self.affinity.parent = self
                        self._children_name_map["affinity"] = "affinity"
                        self._children_yang_names.add("affinity")

                        self.tunnel_id = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("configured_bandwidth",
                                        "dste_class_type",
                                        "fast_reroute",
                                        "frr_bandwidth_protection",
                                        "hold_priority",
                                        "is_affinity_configured",
                                        "is_bandwidth_configured",
                                        "is_priority_configured",
                                        "setup_priority") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte, self).__setattr__(name, value)


                    class Affinity(Entity):
                        """
                        Affinity
                        
                        .. attribute:: affinity_bits
                        
                        	The affinity bits (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: affinity_mask
                        
                        	The affinity mask (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: named_affinity
                        
                        	Array of name based constratints currently applied to the tunnel
                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__init__()

                            self.yang_name = "affinity"
                            self.yang_parent_name = "attribute-set-p2mpte"

                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                            self.named_affinity = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("affinity_bits",
                                            "affinity_mask") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity, self).__setattr__(name, value)


                        class NamedAffinity(Entity):
                            """
                            Array of name based constratints currently
                            applied to the tunnel
                            
                            .. attribute:: constraint_extended_value
                            
                            	Constraint value
                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue>`
                            
                            .. attribute:: constraint_type
                            
                            	Constraint type
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: constraint_value
                            
                            	Deprecated
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: extended_forward_ref_value
                            
                            	Reference bits for undefined affinity names
                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                            
                            .. attribute:: forward_ref_value
                            
                            	Deprecated
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__init__()

                                self.yang_name = "named-affinity"
                                self.yang_parent_name = "affinity"

                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                self.constraint_extended_value = YList(self)
                                self.extended_forward_ref_value = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("constraint_type",
                                                "constraint_value",
                                                "forward_ref_value") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity, self).__setattr__(name, value)


                            class ConstraintExtendedValue(Entity):
                                """
                                Constraint value
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                    self.yang_name = "constraint-extended-value"
                                    self.yang_parent_name = "named-affinity"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "constraint-extended-value" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix


                            class ExtendedForwardRefValue(Entity):
                                """
                                Reference bits for undefined affinity names
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                    self.yang_name = "extended-forward-ref-value"
                                    self.yang_parent_name = "named-affinity"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.constraint_extended_value:
                                    if (c.has_data()):
                                        return True
                                for c in self.extended_forward_ref_value:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.constraint_type.is_set or
                                    self.constraint_value.is_set or
                                    self.forward_ref_value.is_set)

                            def has_operation(self):
                                for c in self.constraint_extended_value:
                                    if (c.has_operation()):
                                        return True
                                for c in self.extended_forward_ref_value:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.constraint_type.yfilter != YFilter.not_set or
                                    self.constraint_value.yfilter != YFilter.not_set or
                                    self.forward_ref_value.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "named-affinity" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "constraint-extended-value"):
                                    for c in self.constraint_extended_value:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ConstraintExtendedValue()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.constraint_extended_value.append(c)
                                    return c

                                if (child_yang_name == "extended-forward-ref-value"):
                                    for c in self.extended_forward_ref_value:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.extended_forward_ref_value.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "constraint-type"):
                                    self.constraint_type = value
                                    self.constraint_type.value_namespace = name_space
                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "constraint-value"):
                                    self.constraint_value = value
                                    self.constraint_value.value_namespace = name_space
                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                if(value_path == "forward-ref-value"):
                                    self.forward_ref_value = value
                                    self.forward_ref_value.value_namespace = name_space
                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.named_affinity:
                                if (c.has_data()):
                                    return True
                            return (
                                self.affinity_bits.is_set or
                                self.affinity_mask.is_set)

                        def has_operation(self):
                            for c in self.named_affinity:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.affinity_bits.yfilter != YFilter.not_set or
                                self.affinity_mask.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "affinity" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "named-affinity"):
                                for c in self.named_affinity:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity.NamedAffinity()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.named_affinity.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "affinity-bits"):
                                self.affinity_bits = value
                                self.affinity_bits.value_namespace = name_space
                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                            if(value_path == "affinity-mask"):
                                self.affinity_mask = value
                                self.affinity_mask.value_namespace = name_space
                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                    class TunnelId(Entity):
                        """
                        Tunnel ID
                        
                        .. attribute:: entry
                        
                        	
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__init__()

                            self.yang_name = "tunnel-id"
                            self.yang_parent_name = "attribute-set-p2mpte"

                            self.entry = YLeaf(YType.uint16, "entry")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("entry") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId, self).__setattr__(name, value)

                        def has_data(self):
                            return self.entry.is_set

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.entry.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "tunnel-id" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.entry.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "entry"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "entry"):
                                self.entry = value
                                self.entry.value_namespace = name_space
                                self.entry.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.tunnel_id:
                            if (c.has_data()):
                                return True
                        return (
                            self.configured_bandwidth.is_set or
                            self.dste_class_type.is_set or
                            self.fast_reroute.is_set or
                            self.frr_bandwidth_protection.is_set or
                            self.hold_priority.is_set or
                            self.is_affinity_configured.is_set or
                            self.is_bandwidth_configured.is_set or
                            self.is_priority_configured.is_set or
                            self.setup_priority.is_set or
                            (self.affinity is not None and self.affinity.has_data()))

                    def has_operation(self):
                        for c in self.tunnel_id:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.configured_bandwidth.yfilter != YFilter.not_set or
                            self.dste_class_type.yfilter != YFilter.not_set or
                            self.fast_reroute.yfilter != YFilter.not_set or
                            self.frr_bandwidth_protection.yfilter != YFilter.not_set or
                            self.hold_priority.yfilter != YFilter.not_set or
                            self.is_affinity_configured.yfilter != YFilter.not_set or
                            self.is_bandwidth_configured.yfilter != YFilter.not_set or
                            self.is_priority_configured.yfilter != YFilter.not_set or
                            self.setup_priority.yfilter != YFilter.not_set or
                            (self.affinity is not None and self.affinity.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "attribute-set-p2mpte" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.configured_bandwidth.is_set or self.configured_bandwidth.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.configured_bandwidth.get_name_leafdata())
                        if (self.dste_class_type.is_set or self.dste_class_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.dste_class_type.get_name_leafdata())
                        if (self.fast_reroute.is_set or self.fast_reroute.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.fast_reroute.get_name_leafdata())
                        if (self.frr_bandwidth_protection.is_set or self.frr_bandwidth_protection.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.frr_bandwidth_protection.get_name_leafdata())
                        if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.hold_priority.get_name_leafdata())
                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                        if (self.is_bandwidth_configured.is_set or self.is_bandwidth_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_bandwidth_configured.get_name_leafdata())
                        if (self.is_priority_configured.is_set or self.is_priority_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_priority_configured.get_name_leafdata())
                        if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.setup_priority.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "affinity"):
                            if (self.affinity is None):
                                self.affinity = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.Affinity()
                                self.affinity.parent = self
                                self._children_name_map["affinity"] = "affinity"
                            return self.affinity

                        if (child_yang_name == "tunnel-id"):
                            for c in self.tunnel_id:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte.TunnelId()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.tunnel_id.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "affinity" or name == "tunnel-id" or name == "configured-bandwidth" or name == "dste-class-type" or name == "fast-reroute" or name == "frr-bandwidth-protection" or name == "hold-priority" or name == "is-affinity-configured" or name == "is-bandwidth-configured" or name == "is-priority-configured" or name == "setup-priority"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "configured-bandwidth"):
                            self.configured_bandwidth = value
                            self.configured_bandwidth.value_namespace = name_space
                            self.configured_bandwidth.value_namespace_prefix = name_space_prefix
                        if(value_path == "dste-class-type"):
                            self.dste_class_type = value
                            self.dste_class_type.value_namespace = name_space
                            self.dste_class_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "fast-reroute"):
                            self.fast_reroute = value
                            self.fast_reroute.value_namespace = name_space
                            self.fast_reroute.value_namespace_prefix = name_space_prefix
                        if(value_path == "frr-bandwidth-protection"):
                            self.frr_bandwidth_protection = value
                            self.frr_bandwidth_protection.value_namespace = name_space
                            self.frr_bandwidth_protection.value_namespace_prefix = name_space_prefix
                        if(value_path == "hold-priority"):
                            self.hold_priority = value
                            self.hold_priority.value_namespace = name_space
                            self.hold_priority.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-affinity-configured"):
                            self.is_affinity_configured = value
                            self.is_affinity_configured.value_namespace = name_space
                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-bandwidth-configured"):
                            self.is_bandwidth_configured = value
                            self.is_bandwidth_configured.value_namespace = name_space
                            self.is_bandwidth_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-priority-configured"):
                            self.is_priority_configured = value
                            self.is_priority_configured.value_namespace = name_space
                            self.is_priority_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "setup-priority"):
                            self.setup_priority = value
                            self.setup_priority.value_namespace = name_space
                            self.setup_priority.value_namespace_prefix = name_space_prefix


                class AttributeSetApsPp(Entity):
                    """
                    Attribute Set OTN APS Path Protection
                    
                    .. attribute:: hold_off_time
                    
                    	Hold\-off time
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: path_prot_profile_type
                    
                    	Path Protection Profile Type
                    	**type**\:   :py:class:`TePathProtProfile <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathProtProfile>`
                    
                    .. attribute:: protection_mode
                    
                    	Protection Restoration Mode
                    	**type**\:   :py:class:`TePnrRevertOptions <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePnrRevertOptions>`
                    
                    .. attribute:: protection_type
                    
                    	Protection Type
                    	**type**\:   :py:class:`TeProtect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProtect>`
                    
                    .. attribute:: restoration_style
                    
                    	Restoration Style
                    	**type**\:   :py:class:`TeRestorationStyle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeRestorationStyle>`
                    
                    .. attribute:: revert_schedule
                    
                    	Revert Schedule
                    	**type**\:   :py:class:`RevertSchedule <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule>`
                    
                    .. attribute:: snc_mode
                    
                    	Sub\-network Connection Mode
                    	**type**\:   :py:class:`TeApsSncMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeApsSncMode>`
                    
                    .. attribute:: tcm_id
                    
                    	Sub\-network Connection Monitoring Mode
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: wait_to_restore_time
                    
                    	Wait to restore time
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__init__()

                        self.yang_name = "attribute-set-aps-pp"
                        self.yang_parent_name = "attribute-set-union"

                        self.hold_off_time = YLeaf(YType.uint32, "hold-off-time")

                        self.path_prot_profile_type = YLeaf(YType.enumeration, "path-prot-profile-type")

                        self.protection_mode = YLeaf(YType.enumeration, "protection-mode")

                        self.protection_type = YLeaf(YType.enumeration, "protection-type")

                        self.restoration_style = YLeaf(YType.enumeration, "restoration-style")

                        self.snc_mode = YLeaf(YType.enumeration, "snc-mode")

                        self.tcm_id = YLeaf(YType.uint32, "tcm-id")

                        self.wait_to_restore_time = YLeaf(YType.uint32, "wait-to-restore-time")

                        self.revert_schedule = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                        self.revert_schedule.parent = self
                        self._children_name_map["revert_schedule"] = "revert-schedule"
                        self._children_yang_names.add("revert-schedule")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("hold_off_time",
                                        "path_prot_profile_type",
                                        "protection_mode",
                                        "protection_type",
                                        "restoration_style",
                                        "snc_mode",
                                        "tcm_id",
                                        "wait_to_restore_time") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetApsPp, self).__setattr__(name, value)


                    class RevertSchedule(Entity):
                        """
                        Revert Schedule
                        
                        .. attribute:: duration
                        
                        	Duration for scheduled reversion
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: max_tries
                        
                        	Max tries for scheduled reversion
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: schedule_date
                        
                        	Schedule time for reversion
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: schedule_frequency
                        
                        	Schedule frequency for reversion
                        	**type**\:   :py:class:`TeSchFreq <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSchFreq>`
                        
                        .. attribute:: schedulename
                        
                        	Schedule name identifier
                        	**type**\:  str
                        
                        	**length:** 0..255
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__init__()

                            self.yang_name = "revert-schedule"
                            self.yang_parent_name = "attribute-set-aps-pp"

                            self.duration = YLeaf(YType.uint32, "duration")

                            self.max_tries = YLeaf(YType.uint32, "max-tries")

                            self.schedule_date = YLeaf(YType.uint32, "schedule-date")

                            self.schedule_frequency = YLeaf(YType.enumeration, "schedule-frequency")

                            self.schedulename = YLeaf(YType.str, "schedulename")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("duration",
                                            "max_tries",
                                            "schedule_date",
                                            "schedule_frequency",
                                            "schedulename") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.duration.is_set or
                                self.max_tries.is_set or
                                self.schedule_date.is_set or
                                self.schedule_frequency.is_set or
                                self.schedulename.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.duration.yfilter != YFilter.not_set or
                                self.max_tries.yfilter != YFilter.not_set or
                                self.schedule_date.yfilter != YFilter.not_set or
                                self.schedule_frequency.yfilter != YFilter.not_set or
                                self.schedulename.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "revert-schedule" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.duration.get_name_leafdata())
                            if (self.max_tries.is_set or self.max_tries.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.max_tries.get_name_leafdata())
                            if (self.schedule_date.is_set or self.schedule_date.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.schedule_date.get_name_leafdata())
                            if (self.schedule_frequency.is_set or self.schedule_frequency.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.schedule_frequency.get_name_leafdata())
                            if (self.schedulename.is_set or self.schedulename.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.schedulename.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "duration" or name == "max-tries" or name == "schedule-date" or name == "schedule-frequency" or name == "schedulename"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "duration"):
                                self.duration = value
                                self.duration.value_namespace = name_space
                                self.duration.value_namespace_prefix = name_space_prefix
                            if(value_path == "max-tries"):
                                self.max_tries = value
                                self.max_tries.value_namespace = name_space
                                self.max_tries.value_namespace_prefix = name_space_prefix
                            if(value_path == "schedule-date"):
                                self.schedule_date = value
                                self.schedule_date.value_namespace = name_space
                                self.schedule_date.value_namespace_prefix = name_space_prefix
                            if(value_path == "schedule-frequency"):
                                self.schedule_frequency = value
                                self.schedule_frequency.value_namespace = name_space
                                self.schedule_frequency.value_namespace_prefix = name_space_prefix
                            if(value_path == "schedulename"):
                                self.schedulename = value
                                self.schedulename.value_namespace = name_space
                                self.schedulename.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.hold_off_time.is_set or
                            self.path_prot_profile_type.is_set or
                            self.protection_mode.is_set or
                            self.protection_type.is_set or
                            self.restoration_style.is_set or
                            self.snc_mode.is_set or
                            self.tcm_id.is_set or
                            self.wait_to_restore_time.is_set or
                            (self.revert_schedule is not None and self.revert_schedule.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.hold_off_time.yfilter != YFilter.not_set or
                            self.path_prot_profile_type.yfilter != YFilter.not_set or
                            self.protection_mode.yfilter != YFilter.not_set or
                            self.protection_type.yfilter != YFilter.not_set or
                            self.restoration_style.yfilter != YFilter.not_set or
                            self.snc_mode.yfilter != YFilter.not_set or
                            self.tcm_id.yfilter != YFilter.not_set or
                            self.wait_to_restore_time.yfilter != YFilter.not_set or
                            (self.revert_schedule is not None and self.revert_schedule.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "attribute-set-aps-pp" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.hold_off_time.is_set or self.hold_off_time.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.hold_off_time.get_name_leafdata())
                        if (self.path_prot_profile_type.is_set or self.path_prot_profile_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.path_prot_profile_type.get_name_leafdata())
                        if (self.protection_mode.is_set or self.protection_mode.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.protection_mode.get_name_leafdata())
                        if (self.protection_type.is_set or self.protection_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.protection_type.get_name_leafdata())
                        if (self.restoration_style.is_set or self.restoration_style.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.restoration_style.get_name_leafdata())
                        if (self.snc_mode.is_set or self.snc_mode.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.snc_mode.get_name_leafdata())
                        if (self.tcm_id.is_set or self.tcm_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tcm_id.get_name_leafdata())
                        if (self.wait_to_restore_time.is_set or self.wait_to_restore_time.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.wait_to_restore_time.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "revert-schedule"):
                            if (self.revert_schedule is None):
                                self.revert_schedule = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetApsPp.RevertSchedule()
                                self.revert_schedule.parent = self
                                self._children_name_map["revert_schedule"] = "revert-schedule"
                            return self.revert_schedule

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "revert-schedule" or name == "hold-off-time" or name == "path-prot-profile-type" or name == "protection-mode" or name == "protection-type" or name == "restoration-style" or name == "snc-mode" or name == "tcm-id" or name == "wait-to-restore-time"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "hold-off-time"):
                            self.hold_off_time = value
                            self.hold_off_time.value_namespace = name_space
                            self.hold_off_time.value_namespace_prefix = name_space_prefix
                        if(value_path == "path-prot-profile-type"):
                            self.path_prot_profile_type = value
                            self.path_prot_profile_type.value_namespace = name_space
                            self.path_prot_profile_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "protection-mode"):
                            self.protection_mode = value
                            self.protection_mode.value_namespace = name_space
                            self.protection_mode.value_namespace_prefix = name_space_prefix
                        if(value_path == "protection-type"):
                            self.protection_type = value
                            self.protection_type.value_namespace = name_space
                            self.protection_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "restoration-style"):
                            self.restoration_style = value
                            self.restoration_style.value_namespace = name_space
                            self.restoration_style.value_namespace_prefix = name_space_prefix
                        if(value_path == "snc-mode"):
                            self.snc_mode = value
                            self.snc_mode.value_namespace = name_space
                            self.snc_mode.value_namespace_prefix = name_space_prefix
                        if(value_path == "tcm-id"):
                            self.tcm_id = value
                            self.tcm_id.value_namespace = name_space
                            self.tcm_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "wait-to-restore-time"):
                            self.wait_to_restore_time = value
                            self.wait_to_restore_time.value_namespace = name_space
                            self.wait_to_restore_time.value_namespace_prefix = name_space_prefix


                class AttributeSetP2PTe(Entity):
                    """
                    MPLS TE P2P\-TE Attribute Set
                    
                    .. attribute:: affinity
                    
                    	Affinity
                    	**type**\:   :py:class:`Affinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity>`
                    
                    .. attribute:: is_affinity_configured
                    
                    	Is affinity configured
                    	**type**\:  bool
                    
                    .. attribute:: is_path_invalidation_action_configured
                    
                    	Is Path Invalidation action configured
                    	**type**\:  bool
                    
                    .. attribute:: is_path_invalidation_timeout_configured
                    
                    	Is Path Invalidation timeout configured
                    	**type**\:  bool
                    
                    .. attribute:: is_path_select_configured
                    
                    	Is any of the path selection parameters configured
                    	**type**\:  bool
                    
                    .. attribute:: is_path_selection_metric_configured
                    
                    	Is path selection metric configured
                    	**type**\:  bool
                    
                    .. attribute:: is_path_selection_segment_routing_adjacency_protection_configured
                    
                    	Is path selection segment routing configured
                    	**type**\:  bool
                    
                    .. attribute:: is_path_selection_segment_routing_margin_configured
                    
                    	Is path selection margin configured
                    	**type**\:  bool
                    
                    .. attribute:: is_path_selection_segment_routing_margin_relative
                    
                    	Path selection margin is\_relative
                    	**type**\:  bool
                    
                    .. attribute:: is_path_selection_segment_routing_segment_limit_configured
                    
                    	Is path selection segment limit configured
                    	**type**\:  bool
                    
                    .. attribute:: is_pce_configured
                    
                    	Is PCE Configured
                    	**type**\:  bool
                    
                    .. attribute:: is_pce_disj_group_id_configured
                    
                    	Is PCE Disjoint Path Group ID Configured
                    	**type**\:  bool
                    
                    .. attribute:: is_pce_disj_source_configured
                    
                    	Is PCE Disjoint Path Source Configured
                    	**type**\:  bool
                    
                    .. attribute:: is_pce_disj_type_configured
                    
                    	Is PCE Disjoint Path Type Configured
                    	**type**\:  bool
                    
                    .. attribute:: is_pceb_dj_source_configured
                    
                    	Is PCE Bidirectional Source Configured
                    	**type**\:  bool
                    
                    .. attribute:: is_pcebd_group_id_configured
                    
                    	Is PCE Bidirectional Group ID Configured
                    	**type**\:  bool
                    
                    .. attribute:: is_prepend_list_configured
                    
                    	Is SR prepend list configured
                    	**type**\:  bool
                    
                    .. attribute:: logging
                    
                    	Logging attributes
                    	**type**\:   :py:class:`Logging <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging>`
                    
                    .. attribute:: path_invalidation_timeout
                    
                    	Path invalidation timeout on the tunnel path
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: path_selection_invalidation_action
                    
                    	Path invalidation action
                    	**type**\:   :py:class:`TePathInvalAction <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathInvalAction>`
                    
                    .. attribute:: path_selection_metric
                    
                    	Path selection metric type
                    	**type**\:   :py:class:`MplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetric>`
                    
                    .. attribute:: path_selection_segment_routing_adjacency_protection
                    
                    	Path selection segment\-routing type
                    	**type**\:   :py:class:`TeS2LSrPathSelection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LSrPathSelection>`
                    
                    .. attribute:: path_selection_segment_routing_margin
                    
                    	Path selection margin
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: path_selection_segment_routing_segment_limit
                    
                    	Is path selection segment limit configured
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: pcebd_group_id
                    
                    	PCE Bidirectional Group ID
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: pcebd_source_address
                    
                    	PCE Bidirectional Source Address
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: pcedp_group_id
                    
                    	PCE Disjoint Path Group ID
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: pcedp_source_address
                    
                    	PCE Disjoint Path Source Address
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: pcedp_type
                    
                    	PCE Disjoint Path Type
                    	**type**\:   :py:class:`TePceDisjoint <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePceDisjoint>`
                    
                    .. attribute:: prepend_list
                    
                    	SR prepend list
                    	**type**\:   :py:class:`PrependList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList>`
                    
                    .. attribute:: tunnel_id
                    
                    	Tunnel ID
                    	**type**\: list of    :py:class:`TunnelId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__init__()

                        self.yang_name = "attribute-set-p2p-te"
                        self.yang_parent_name = "attribute-set-union"

                        self.is_affinity_configured = YLeaf(YType.boolean, "is-affinity-configured")

                        self.is_path_invalidation_action_configured = YLeaf(YType.boolean, "is-path-invalidation-action-configured")

                        self.is_path_invalidation_timeout_configured = YLeaf(YType.boolean, "is-path-invalidation-timeout-configured")

                        self.is_path_select_configured = YLeaf(YType.boolean, "is-path-select-configured")

                        self.is_path_selection_metric_configured = YLeaf(YType.boolean, "is-path-selection-metric-configured")

                        self.is_path_selection_segment_routing_adjacency_protection_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-adjacency-protection-configured")

                        self.is_path_selection_segment_routing_margin_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-configured")

                        self.is_path_selection_segment_routing_margin_relative = YLeaf(YType.boolean, "is-path-selection-segment-routing-margin-relative")

                        self.is_path_selection_segment_routing_segment_limit_configured = YLeaf(YType.boolean, "is-path-selection-segment-routing-segment-limit-configured")

                        self.is_pce_configured = YLeaf(YType.boolean, "is-pce-configured")

                        self.is_pce_disj_group_id_configured = YLeaf(YType.boolean, "is-pce-disj-group-id-configured")

                        self.is_pce_disj_source_configured = YLeaf(YType.boolean, "is-pce-disj-source-configured")

                        self.is_pce_disj_type_configured = YLeaf(YType.boolean, "is-pce-disj-type-configured")

                        self.is_pceb_dj_source_configured = YLeaf(YType.boolean, "is-pceb-dj-source-configured")

                        self.is_pcebd_group_id_configured = YLeaf(YType.boolean, "is-pcebd-group-id-configured")

                        self.is_prepend_list_configured = YLeaf(YType.boolean, "is-prepend-list-configured")

                        self.path_invalidation_timeout = YLeaf(YType.uint32, "path-invalidation-timeout")

                        self.path_selection_invalidation_action = YLeaf(YType.enumeration, "path-selection-invalidation-action")

                        self.path_selection_metric = YLeaf(YType.enumeration, "path-selection-metric")

                        self.path_selection_segment_routing_adjacency_protection = YLeaf(YType.enumeration, "path-selection-segment-routing-adjacency-protection")

                        self.path_selection_segment_routing_margin = YLeaf(YType.uint32, "path-selection-segment-routing-margin")

                        self.path_selection_segment_routing_segment_limit = YLeaf(YType.uint32, "path-selection-segment-routing-segment-limit")

                        self.pcebd_group_id = YLeaf(YType.uint32, "pcebd-group-id")

                        self.pcebd_source_address = YLeaf(YType.uint32, "pcebd-source-address")

                        self.pcedp_group_id = YLeaf(YType.uint32, "pcedp-group-id")

                        self.pcedp_source_address = YLeaf(YType.uint32, "pcedp-source-address")

                        self.pcedp_type = YLeaf(YType.enumeration, "pcedp-type")

                        self.affinity = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                        self.affinity.parent = self
                        self._children_name_map["affinity"] = "affinity"
                        self._children_yang_names.add("affinity")

                        self.logging = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                        self.logging.parent = self
                        self._children_name_map["logging"] = "logging"
                        self._children_yang_names.add("logging")

                        self.prepend_list = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                        self.prepend_list.parent = self
                        self._children_name_map["prepend_list"] = "prepend-list"
                        self._children_yang_names.add("prepend-list")

                        self.tunnel_id = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("is_affinity_configured",
                                        "is_path_invalidation_action_configured",
                                        "is_path_invalidation_timeout_configured",
                                        "is_path_select_configured",
                                        "is_path_selection_metric_configured",
                                        "is_path_selection_segment_routing_adjacency_protection_configured",
                                        "is_path_selection_segment_routing_margin_configured",
                                        "is_path_selection_segment_routing_margin_relative",
                                        "is_path_selection_segment_routing_segment_limit_configured",
                                        "is_pce_configured",
                                        "is_pce_disj_group_id_configured",
                                        "is_pce_disj_source_configured",
                                        "is_pce_disj_type_configured",
                                        "is_pceb_dj_source_configured",
                                        "is_pcebd_group_id_configured",
                                        "is_prepend_list_configured",
                                        "path_invalidation_timeout",
                                        "path_selection_invalidation_action",
                                        "path_selection_metric",
                                        "path_selection_segment_routing_adjacency_protection",
                                        "path_selection_segment_routing_margin",
                                        "path_selection_segment_routing_segment_limit",
                                        "pcebd_group_id",
                                        "pcebd_source_address",
                                        "pcedp_group_id",
                                        "pcedp_source_address",
                                        "pcedp_type") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe, self).__setattr__(name, value)


                    class Affinity(Entity):
                        """
                        Affinity
                        
                        .. attribute:: affinity_bits
                        
                        	The affinity bits (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: affinity_mask
                        
                        	The affinity mask (colors)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: named_affinity
                        
                        	Array of name based constratints currently applied to the tunnel
                        	**type**\: list of    :py:class:`NamedAffinity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__init__()

                            self.yang_name = "affinity"
                            self.yang_parent_name = "attribute-set-p2p-te"

                            self.affinity_bits = YLeaf(YType.uint32, "affinity-bits")

                            self.affinity_mask = YLeaf(YType.uint32, "affinity-mask")

                            self.named_affinity = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("affinity_bits",
                                            "affinity_mask") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity, self).__setattr__(name, value)


                        class NamedAffinity(Entity):
                            """
                            Array of name based constratints currently
                            applied to the tunnel
                            
                            .. attribute:: constraint_extended_value
                            
                            	Constraint value
                            	**type**\: list of    :py:class:`ConstraintExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue>`
                            
                            .. attribute:: constraint_type
                            
                            	Constraint type
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            .. attribute:: constraint_value
                            
                            	Deprecated
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: extended_forward_ref_value
                            
                            	Reference bits for undefined affinity names
                            	**type**\: list of    :py:class:`ExtendedForwardRefValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue>`
                            
                            .. attribute:: forward_ref_value
                            
                            	Deprecated
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__init__()

                                self.yang_name = "named-affinity"
                                self.yang_parent_name = "affinity"

                                self.constraint_type = YLeaf(YType.uint8, "constraint-type")

                                self.constraint_value = YLeaf(YType.uint32, "constraint-value")

                                self.forward_ref_value = YLeaf(YType.uint32, "forward-ref-value")

                                self.constraint_extended_value = YList(self)
                                self.extended_forward_ref_value = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("constraint_type",
                                                "constraint_value",
                                                "forward_ref_value") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity, self).__setattr__(name, value)


                            class ConstraintExtendedValue(Entity):
                                """
                                Constraint value
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__init__()

                                    self.yang_name = "constraint-extended-value"
                                    self.yang_parent_name = "named-affinity"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "constraint-extended-value" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix


                            class ExtendedForwardRefValue(Entity):
                                """
                                Reference bits for undefined affinity names
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__init__()

                                    self.yang_name = "extended-forward-ref-value"
                                    self.yang_parent_name = "named-affinity"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "extended-forward-ref-value" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.constraint_extended_value:
                                    if (c.has_data()):
                                        return True
                                for c in self.extended_forward_ref_value:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.constraint_type.is_set or
                                    self.constraint_value.is_set or
                                    self.forward_ref_value.is_set)

                            def has_operation(self):
                                for c in self.constraint_extended_value:
                                    if (c.has_operation()):
                                        return True
                                for c in self.extended_forward_ref_value:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.constraint_type.yfilter != YFilter.not_set or
                                    self.constraint_value.yfilter != YFilter.not_set or
                                    self.forward_ref_value.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "named-affinity" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.constraint_type.is_set or self.constraint_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.constraint_type.get_name_leafdata())
                                if (self.constraint_value.is_set or self.constraint_value.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.constraint_value.get_name_leafdata())
                                if (self.forward_ref_value.is_set or self.forward_ref_value.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.forward_ref_value.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "constraint-extended-value"):
                                    for c in self.constraint_extended_value:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ConstraintExtendedValue()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.constraint_extended_value.append(c)
                                    return c

                                if (child_yang_name == "extended-forward-ref-value"):
                                    for c in self.extended_forward_ref_value:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity.ExtendedForwardRefValue()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.extended_forward_ref_value.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "constraint-extended-value" or name == "extended-forward-ref-value" or name == "constraint-type" or name == "constraint-value" or name == "forward-ref-value"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "constraint-type"):
                                    self.constraint_type = value
                                    self.constraint_type.value_namespace = name_space
                                    self.constraint_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "constraint-value"):
                                    self.constraint_value = value
                                    self.constraint_value.value_namespace = name_space
                                    self.constraint_value.value_namespace_prefix = name_space_prefix
                                if(value_path == "forward-ref-value"):
                                    self.forward_ref_value = value
                                    self.forward_ref_value.value_namespace = name_space
                                    self.forward_ref_value.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.named_affinity:
                                if (c.has_data()):
                                    return True
                            return (
                                self.affinity_bits.is_set or
                                self.affinity_mask.is_set)

                        def has_operation(self):
                            for c in self.named_affinity:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.affinity_bits.yfilter != YFilter.not_set or
                                self.affinity_mask.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "affinity" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.affinity_bits.is_set or self.affinity_bits.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.affinity_bits.get_name_leafdata())
                            if (self.affinity_mask.is_set or self.affinity_mask.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.affinity_mask.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "named-affinity"):
                                for c in self.named_affinity:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity.NamedAffinity()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.named_affinity.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "named-affinity" or name == "affinity-bits" or name == "affinity-mask"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "affinity-bits"):
                                self.affinity_bits = value
                                self.affinity_bits.value_namespace = name_space
                                self.affinity_bits.value_namespace_prefix = name_space_prefix
                            if(value_path == "affinity-mask"):
                                self.affinity_mask = value
                                self.affinity_mask.value_namespace = name_space
                                self.affinity_mask.value_namespace_prefix = name_space_prefix


                    class Logging(Entity):
                        """
                        Logging attributes
                        
                        .. attribute:: all_logging_enabled
                        
                        	All logging option\: TRUE \- enabled, FALSE \- disabled
                        	**type**\:  bool
                        
                        .. attribute:: lsp_bandwidth_change
                        
                        	LSP bandwidth change logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\:  bool
                        
                        .. attribute:: lsp_insufficient_bw
                        
                        	LSP insufficient bandwidth logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\:  bool
                        
                        .. attribute:: lsp_pcalc_failure_logging_enabled
                        
                        	LSP pcalc failure logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\:  bool
                        
                        .. attribute:: lsp_re_opt
                        
                        	LSP re\-optimization logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\:  bool
                        
                        .. attribute:: lsp_re_route
                        
                        	LSP re\-route logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\:  bool
                        
                        .. attribute:: lsp_state
                        
                        	LSP State logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\:  bool
                        
                        .. attribute:: s2l_state
                        
                        	S2L State logging\: TRUE \- enabled, FALSE \- disabled
                        	**type**\:  bool
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__init__()

                            self.yang_name = "logging"
                            self.yang_parent_name = "attribute-set-p2p-te"

                            self.all_logging_enabled = YLeaf(YType.boolean, "all-logging-enabled")

                            self.lsp_bandwidth_change = YLeaf(YType.boolean, "lsp-bandwidth-change")

                            self.lsp_insufficient_bw = YLeaf(YType.boolean, "lsp-insufficient-bw")

                            self.lsp_pcalc_failure_logging_enabled = YLeaf(YType.boolean, "lsp-pcalc-failure-logging-enabled")

                            self.lsp_re_opt = YLeaf(YType.boolean, "lsp-re-opt")

                            self.lsp_re_route = YLeaf(YType.boolean, "lsp-re-route")

                            self.lsp_state = YLeaf(YType.boolean, "lsp-state")

                            self.s2l_state = YLeaf(YType.boolean, "s2l-state")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("all_logging_enabled",
                                            "lsp_bandwidth_change",
                                            "lsp_insufficient_bw",
                                            "lsp_pcalc_failure_logging_enabled",
                                            "lsp_re_opt",
                                            "lsp_re_route",
                                            "lsp_state",
                                            "s2l_state") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.all_logging_enabled.is_set or
                                self.lsp_bandwidth_change.is_set or
                                self.lsp_insufficient_bw.is_set or
                                self.lsp_pcalc_failure_logging_enabled.is_set or
                                self.lsp_re_opt.is_set or
                                self.lsp_re_route.is_set or
                                self.lsp_state.is_set or
                                self.s2l_state.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.all_logging_enabled.yfilter != YFilter.not_set or
                                self.lsp_bandwidth_change.yfilter != YFilter.not_set or
                                self.lsp_insufficient_bw.yfilter != YFilter.not_set or
                                self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set or
                                self.lsp_re_opt.yfilter != YFilter.not_set or
                                self.lsp_re_route.yfilter != YFilter.not_set or
                                self.lsp_state.yfilter != YFilter.not_set or
                                self.s2l_state.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "logging" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.all_logging_enabled.is_set or self.all_logging_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.all_logging_enabled.get_name_leafdata())
                            if (self.lsp_bandwidth_change.is_set or self.lsp_bandwidth_change.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsp_bandwidth_change.get_name_leafdata())
                            if (self.lsp_insufficient_bw.is_set or self.lsp_insufficient_bw.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsp_insufficient_bw.get_name_leafdata())
                            if (self.lsp_pcalc_failure_logging_enabled.is_set or self.lsp_pcalc_failure_logging_enabled.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsp_pcalc_failure_logging_enabled.get_name_leafdata())
                            if (self.lsp_re_opt.is_set or self.lsp_re_opt.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsp_re_opt.get_name_leafdata())
                            if (self.lsp_re_route.is_set or self.lsp_re_route.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsp_re_route.get_name_leafdata())
                            if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsp_state.get_name_leafdata())
                            if (self.s2l_state.is_set or self.s2l_state.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_state.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "all-logging-enabled" or name == "lsp-bandwidth-change" or name == "lsp-insufficient-bw" or name == "lsp-pcalc-failure-logging-enabled" or name == "lsp-re-opt" or name == "lsp-re-route" or name == "lsp-state" or name == "s2l-state"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "all-logging-enabled"):
                                self.all_logging_enabled = value
                                self.all_logging_enabled.value_namespace = name_space
                                self.all_logging_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsp-bandwidth-change"):
                                self.lsp_bandwidth_change = value
                                self.lsp_bandwidth_change.value_namespace = name_space
                                self.lsp_bandwidth_change.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsp-insufficient-bw"):
                                self.lsp_insufficient_bw = value
                                self.lsp_insufficient_bw.value_namespace = name_space
                                self.lsp_insufficient_bw.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsp-pcalc-failure-logging-enabled"):
                                self.lsp_pcalc_failure_logging_enabled = value
                                self.lsp_pcalc_failure_logging_enabled.value_namespace = name_space
                                self.lsp_pcalc_failure_logging_enabled.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsp-re-opt"):
                                self.lsp_re_opt = value
                                self.lsp_re_opt.value_namespace = name_space
                                self.lsp_re_opt.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsp-re-route"):
                                self.lsp_re_route = value
                                self.lsp_re_route.value_namespace = name_space
                                self.lsp_re_route.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsp-state"):
                                self.lsp_state = value
                                self.lsp_state.value_namespace = name_space
                                self.lsp_state.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-state"):
                                self.s2l_state = value
                                self.s2l_state.value_namespace = name_space
                                self.s2l_state.value_namespace_prefix = name_space_prefix


                    class PrependList(Entity):
                        """
                        SR prepend list
                        
                        .. attribute:: prepend_entry
                        
                        	List of prepend entries
                        	**type**\: list of    :py:class:`PrependEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__init__()

                            self.yang_name = "prepend-list"
                            self.yang_parent_name = "attribute-set-p2p-te"

                            self.prepend_entry = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in () and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList, self).__setattr__(name, value)


                        class PrependEntry(Entity):
                            """
                            List of prepend entries
                            
                            .. attribute:: index
                            
                            	Prepend index
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: next_label
                            
                            	Prepend next label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: type
                            
                            	Prepend Type
                            	**type**\:   :py:class:`TeAttributeSetSrPrepend <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAttributeSetSrPrepend>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__init__()

                                self.yang_name = "prepend-entry"
                                self.yang_parent_name = "prepend-list"

                                self.index = YLeaf(YType.uint32, "index")

                                self.next_label = YLeaf(YType.uint32, "next-label")

                                self.type = YLeaf(YType.enumeration, "type")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("index",
                                                "next_label",
                                                "type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.index.is_set or
                                    self.next_label.is_set or
                                    self.type.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.index.yfilter != YFilter.not_set or
                                    self.next_label.yfilter != YFilter.not_set or
                                    self.type.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "prepend-entry" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.index.is_set or self.index.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.index.get_name_leafdata())
                                if (self.next_label.is_set or self.next_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.next_label.get_name_leafdata())
                                if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "index" or name == "next-label" or name == "type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "index"):
                                    self.index = value
                                    self.index.value_namespace = name_space
                                    self.index.value_namespace_prefix = name_space_prefix
                                if(value_path == "next-label"):
                                    self.next_label = value
                                    self.next_label.value_namespace = name_space
                                    self.next_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "type"):
                                    self.type = value
                                    self.type.value_namespace = name_space
                                    self.type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.prepend_entry:
                                if (c.has_data()):
                                    return True
                            return False

                        def has_operation(self):
                            for c in self.prepend_entry:
                                if (c.has_operation()):
                                    return True
                            return self.yfilter != YFilter.not_set

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "prepend-list" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "prepend-entry"):
                                for c in self.prepend_entry:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList.PrependEntry()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.prepend_entry.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "prepend-entry"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class TunnelId(Entity):
                        """
                        Tunnel ID
                        
                        .. attribute:: entry
                        
                        	
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__init__()

                            self.yang_name = "tunnel-id"
                            self.yang_parent_name = "attribute-set-p2p-te"

                            self.entry = YLeaf(YType.uint16, "entry")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("entry") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId, self).__setattr__(name, value)

                        def has_data(self):
                            return self.entry.is_set

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.entry.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "tunnel-id" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.entry.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "entry"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "entry"):
                                self.entry = value
                                self.entry.value_namespace = name_space
                                self.entry.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.tunnel_id:
                            if (c.has_data()):
                                return True
                        return (
                            self.is_affinity_configured.is_set or
                            self.is_path_invalidation_action_configured.is_set or
                            self.is_path_invalidation_timeout_configured.is_set or
                            self.is_path_select_configured.is_set or
                            self.is_path_selection_metric_configured.is_set or
                            self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or
                            self.is_path_selection_segment_routing_margin_configured.is_set or
                            self.is_path_selection_segment_routing_margin_relative.is_set or
                            self.is_path_selection_segment_routing_segment_limit_configured.is_set or
                            self.is_pce_configured.is_set or
                            self.is_pce_disj_group_id_configured.is_set or
                            self.is_pce_disj_source_configured.is_set or
                            self.is_pce_disj_type_configured.is_set or
                            self.is_pceb_dj_source_configured.is_set or
                            self.is_pcebd_group_id_configured.is_set or
                            self.is_prepend_list_configured.is_set or
                            self.path_invalidation_timeout.is_set or
                            self.path_selection_invalidation_action.is_set or
                            self.path_selection_metric.is_set or
                            self.path_selection_segment_routing_adjacency_protection.is_set or
                            self.path_selection_segment_routing_margin.is_set or
                            self.path_selection_segment_routing_segment_limit.is_set or
                            self.pcebd_group_id.is_set or
                            self.pcebd_source_address.is_set or
                            self.pcedp_group_id.is_set or
                            self.pcedp_source_address.is_set or
                            self.pcedp_type.is_set or
                            (self.affinity is not None and self.affinity.has_data()) or
                            (self.logging is not None and self.logging.has_data()) or
                            (self.prepend_list is not None and self.prepend_list.has_data()))

                    def has_operation(self):
                        for c in self.tunnel_id:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.is_affinity_configured.yfilter != YFilter.not_set or
                            self.is_path_invalidation_action_configured.yfilter != YFilter.not_set or
                            self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set or
                            self.is_path_select_configured.yfilter != YFilter.not_set or
                            self.is_path_selection_metric_configured.yfilter != YFilter.not_set or
                            self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set or
                            self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set or
                            self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set or
                            self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set or
                            self.is_pce_configured.yfilter != YFilter.not_set or
                            self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set or
                            self.is_pce_disj_source_configured.yfilter != YFilter.not_set or
                            self.is_pce_disj_type_configured.yfilter != YFilter.not_set or
                            self.is_pceb_dj_source_configured.yfilter != YFilter.not_set or
                            self.is_pcebd_group_id_configured.yfilter != YFilter.not_set or
                            self.is_prepend_list_configured.yfilter != YFilter.not_set or
                            self.path_invalidation_timeout.yfilter != YFilter.not_set or
                            self.path_selection_invalidation_action.yfilter != YFilter.not_set or
                            self.path_selection_metric.yfilter != YFilter.not_set or
                            self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set or
                            self.path_selection_segment_routing_margin.yfilter != YFilter.not_set or
                            self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set or
                            self.pcebd_group_id.yfilter != YFilter.not_set or
                            self.pcebd_source_address.yfilter != YFilter.not_set or
                            self.pcedp_group_id.yfilter != YFilter.not_set or
                            self.pcedp_source_address.yfilter != YFilter.not_set or
                            self.pcedp_type.yfilter != YFilter.not_set or
                            (self.affinity is not None and self.affinity.has_operation()) or
                            (self.logging is not None and self.logging.has_operation()) or
                            (self.prepend_list is not None and self.prepend_list.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "attribute-set-p2p-te" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.is_affinity_configured.is_set or self.is_affinity_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_affinity_configured.get_name_leafdata())
                        if (self.is_path_invalidation_action_configured.is_set or self.is_path_invalidation_action_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_path_invalidation_action_configured.get_name_leafdata())
                        if (self.is_path_invalidation_timeout_configured.is_set or self.is_path_invalidation_timeout_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_path_invalidation_timeout_configured.get_name_leafdata())
                        if (self.is_path_select_configured.is_set or self.is_path_select_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_path_select_configured.get_name_leafdata())
                        if (self.is_path_selection_metric_configured.is_set or self.is_path_selection_metric_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_path_selection_metric_configured.get_name_leafdata())
                        if (self.is_path_selection_segment_routing_adjacency_protection_configured.is_set or self.is_path_selection_segment_routing_adjacency_protection_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_path_selection_segment_routing_adjacency_protection_configured.get_name_leafdata())
                        if (self.is_path_selection_segment_routing_margin_configured.is_set or self.is_path_selection_segment_routing_margin_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_path_selection_segment_routing_margin_configured.get_name_leafdata())
                        if (self.is_path_selection_segment_routing_margin_relative.is_set or self.is_path_selection_segment_routing_margin_relative.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_path_selection_segment_routing_margin_relative.get_name_leafdata())
                        if (self.is_path_selection_segment_routing_segment_limit_configured.is_set or self.is_path_selection_segment_routing_segment_limit_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_path_selection_segment_routing_segment_limit_configured.get_name_leafdata())
                        if (self.is_pce_configured.is_set or self.is_pce_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_pce_configured.get_name_leafdata())
                        if (self.is_pce_disj_group_id_configured.is_set or self.is_pce_disj_group_id_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_pce_disj_group_id_configured.get_name_leafdata())
                        if (self.is_pce_disj_source_configured.is_set or self.is_pce_disj_source_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_pce_disj_source_configured.get_name_leafdata())
                        if (self.is_pce_disj_type_configured.is_set or self.is_pce_disj_type_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_pce_disj_type_configured.get_name_leafdata())
                        if (self.is_pceb_dj_source_configured.is_set or self.is_pceb_dj_source_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_pceb_dj_source_configured.get_name_leafdata())
                        if (self.is_pcebd_group_id_configured.is_set or self.is_pcebd_group_id_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_pcebd_group_id_configured.get_name_leafdata())
                        if (self.is_prepend_list_configured.is_set or self.is_prepend_list_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_prepend_list_configured.get_name_leafdata())
                        if (self.path_invalidation_timeout.is_set or self.path_invalidation_timeout.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.path_invalidation_timeout.get_name_leafdata())
                        if (self.path_selection_invalidation_action.is_set or self.path_selection_invalidation_action.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.path_selection_invalidation_action.get_name_leafdata())
                        if (self.path_selection_metric.is_set or self.path_selection_metric.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.path_selection_metric.get_name_leafdata())
                        if (self.path_selection_segment_routing_adjacency_protection.is_set or self.path_selection_segment_routing_adjacency_protection.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.path_selection_segment_routing_adjacency_protection.get_name_leafdata())
                        if (self.path_selection_segment_routing_margin.is_set or self.path_selection_segment_routing_margin.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.path_selection_segment_routing_margin.get_name_leafdata())
                        if (self.path_selection_segment_routing_segment_limit.is_set or self.path_selection_segment_routing_segment_limit.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.path_selection_segment_routing_segment_limit.get_name_leafdata())
                        if (self.pcebd_group_id.is_set or self.pcebd_group_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.pcebd_group_id.get_name_leafdata())
                        if (self.pcebd_source_address.is_set or self.pcebd_source_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.pcebd_source_address.get_name_leafdata())
                        if (self.pcedp_group_id.is_set or self.pcedp_group_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.pcedp_group_id.get_name_leafdata())
                        if (self.pcedp_source_address.is_set or self.pcedp_source_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.pcedp_source_address.get_name_leafdata())
                        if (self.pcedp_type.is_set or self.pcedp_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.pcedp_type.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "affinity"):
                            if (self.affinity is None):
                                self.affinity = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Affinity()
                                self.affinity.parent = self
                                self._children_name_map["affinity"] = "affinity"
                            return self.affinity

                        if (child_yang_name == "logging"):
                            if (self.logging is None):
                                self.logging = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.Logging()
                                self.logging.parent = self
                                self._children_name_map["logging"] = "logging"
                            return self.logging

                        if (child_yang_name == "prepend-list"):
                            if (self.prepend_list is None):
                                self.prepend_list = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.PrependList()
                                self.prepend_list.parent = self
                                self._children_name_map["prepend_list"] = "prepend-list"
                            return self.prepend_list

                        if (child_yang_name == "tunnel-id"):
                            for c in self.tunnel_id:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe.TunnelId()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.tunnel_id.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "affinity" or name == "logging" or name == "prepend-list" or name == "tunnel-id" or name == "is-affinity-configured" or name == "is-path-invalidation-action-configured" or name == "is-path-invalidation-timeout-configured" or name == "is-path-select-configured" or name == "is-path-selection-metric-configured" or name == "is-path-selection-segment-routing-adjacency-protection-configured" or name == "is-path-selection-segment-routing-margin-configured" or name == "is-path-selection-segment-routing-margin-relative" or name == "is-path-selection-segment-routing-segment-limit-configured" or name == "is-pce-configured" or name == "is-pce-disj-group-id-configured" or name == "is-pce-disj-source-configured" or name == "is-pce-disj-type-configured" or name == "is-pceb-dj-source-configured" or name == "is-pcebd-group-id-configured" or name == "is-prepend-list-configured" or name == "path-invalidation-timeout" or name == "path-selection-invalidation-action" or name == "path-selection-metric" or name == "path-selection-segment-routing-adjacency-protection" or name == "path-selection-segment-routing-margin" or name == "path-selection-segment-routing-segment-limit" or name == "pcebd-group-id" or name == "pcebd-source-address" or name == "pcedp-group-id" or name == "pcedp-source-address" or name == "pcedp-type"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "is-affinity-configured"):
                            self.is_affinity_configured = value
                            self.is_affinity_configured.value_namespace = name_space
                            self.is_affinity_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-path-invalidation-action-configured"):
                            self.is_path_invalidation_action_configured = value
                            self.is_path_invalidation_action_configured.value_namespace = name_space
                            self.is_path_invalidation_action_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-path-invalidation-timeout-configured"):
                            self.is_path_invalidation_timeout_configured = value
                            self.is_path_invalidation_timeout_configured.value_namespace = name_space
                            self.is_path_invalidation_timeout_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-path-select-configured"):
                            self.is_path_select_configured = value
                            self.is_path_select_configured.value_namespace = name_space
                            self.is_path_select_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-path-selection-metric-configured"):
                            self.is_path_selection_metric_configured = value
                            self.is_path_selection_metric_configured.value_namespace = name_space
                            self.is_path_selection_metric_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-path-selection-segment-routing-adjacency-protection-configured"):
                            self.is_path_selection_segment_routing_adjacency_protection_configured = value
                            self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace = name_space
                            self.is_path_selection_segment_routing_adjacency_protection_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-path-selection-segment-routing-margin-configured"):
                            self.is_path_selection_segment_routing_margin_configured = value
                            self.is_path_selection_segment_routing_margin_configured.value_namespace = name_space
                            self.is_path_selection_segment_routing_margin_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-path-selection-segment-routing-margin-relative"):
                            self.is_path_selection_segment_routing_margin_relative = value
                            self.is_path_selection_segment_routing_margin_relative.value_namespace = name_space
                            self.is_path_selection_segment_routing_margin_relative.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-path-selection-segment-routing-segment-limit-configured"):
                            self.is_path_selection_segment_routing_segment_limit_configured = value
                            self.is_path_selection_segment_routing_segment_limit_configured.value_namespace = name_space
                            self.is_path_selection_segment_routing_segment_limit_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-pce-configured"):
                            self.is_pce_configured = value
                            self.is_pce_configured.value_namespace = name_space
                            self.is_pce_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-pce-disj-group-id-configured"):
                            self.is_pce_disj_group_id_configured = value
                            self.is_pce_disj_group_id_configured.value_namespace = name_space
                            self.is_pce_disj_group_id_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-pce-disj-source-configured"):
                            self.is_pce_disj_source_configured = value
                            self.is_pce_disj_source_configured.value_namespace = name_space
                            self.is_pce_disj_source_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-pce-disj-type-configured"):
                            self.is_pce_disj_type_configured = value
                            self.is_pce_disj_type_configured.value_namespace = name_space
                            self.is_pce_disj_type_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-pceb-dj-source-configured"):
                            self.is_pceb_dj_source_configured = value
                            self.is_pceb_dj_source_configured.value_namespace = name_space
                            self.is_pceb_dj_source_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-pcebd-group-id-configured"):
                            self.is_pcebd_group_id_configured = value
                            self.is_pcebd_group_id_configured.value_namespace = name_space
                            self.is_pcebd_group_id_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-prepend-list-configured"):
                            self.is_prepend_list_configured = value
                            self.is_prepend_list_configured.value_namespace = name_space
                            self.is_prepend_list_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "path-invalidation-timeout"):
                            self.path_invalidation_timeout = value
                            self.path_invalidation_timeout.value_namespace = name_space
                            self.path_invalidation_timeout.value_namespace_prefix = name_space_prefix
                        if(value_path == "path-selection-invalidation-action"):
                            self.path_selection_invalidation_action = value
                            self.path_selection_invalidation_action.value_namespace = name_space
                            self.path_selection_invalidation_action.value_namespace_prefix = name_space_prefix
                        if(value_path == "path-selection-metric"):
                            self.path_selection_metric = value
                            self.path_selection_metric.value_namespace = name_space
                            self.path_selection_metric.value_namespace_prefix = name_space_prefix
                        if(value_path == "path-selection-segment-routing-adjacency-protection"):
                            self.path_selection_segment_routing_adjacency_protection = value
                            self.path_selection_segment_routing_adjacency_protection.value_namespace = name_space
                            self.path_selection_segment_routing_adjacency_protection.value_namespace_prefix = name_space_prefix
                        if(value_path == "path-selection-segment-routing-margin"):
                            self.path_selection_segment_routing_margin = value
                            self.path_selection_segment_routing_margin.value_namespace = name_space
                            self.path_selection_segment_routing_margin.value_namespace_prefix = name_space_prefix
                        if(value_path == "path-selection-segment-routing-segment-limit"):
                            self.path_selection_segment_routing_segment_limit = value
                            self.path_selection_segment_routing_segment_limit.value_namespace = name_space
                            self.path_selection_segment_routing_segment_limit.value_namespace_prefix = name_space_prefix
                        if(value_path == "pcebd-group-id"):
                            self.pcebd_group_id = value
                            self.pcebd_group_id.value_namespace = name_space
                            self.pcebd_group_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "pcebd-source-address"):
                            self.pcebd_source_address = value
                            self.pcebd_source_address.value_namespace = name_space
                            self.pcebd_source_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "pcedp-group-id"):
                            self.pcedp_group_id = value
                            self.pcedp_group_id.value_namespace = name_space
                            self.pcedp_group_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "pcedp-source-address"):
                            self.pcedp_source_address = value
                            self.pcedp_source_address.value_namespace = name_space
                            self.pcedp_source_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "pcedp-type"):
                            self.pcedp_type = value
                            self.pcedp_type.value_namespace = name_space
                            self.pcedp_type.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    return (
                        self.tunnel_attribute_set_type.is_set or
                        (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_data()) or
                        (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_data()) or
                        (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_data()) or
                        (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_data()) or
                        (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_data()) or
                        (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_data()) or
                        (self.attribute_set_xro is not None and self.attribute_set_xro.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.tunnel_attribute_set_type.yfilter != YFilter.not_set or
                        (self.attribute_set_aps_pp is not None and self.attribute_set_aps_pp.has_operation()) or
                        (self.attribute_set_autobackup is not None and self.attribute_set_autobackup.has_operation()) or
                        (self.attribute_set_automesh is not None and self.attribute_set_automesh.has_operation()) or
                        (self.attribute_set_p2mpte is not None and self.attribute_set_p2mpte.has_operation()) or
                        (self.attribute_set_p2p_te is not None and self.attribute_set_p2p_te.has_operation()) or
                        (self.attribute_set_path_option is not None and self.attribute_set_path_option.has_operation()) or
                        (self.attribute_set_xro is not None and self.attribute_set_xro.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "attribute-set-union" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.tunnel_attribute_set_type.is_set or self.tunnel_attribute_set_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_attribute_set_type.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "attribute-set-aps-pp"):
                        if (self.attribute_set_aps_pp is None):
                            self.attribute_set_aps_pp = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetApsPp()
                            self.attribute_set_aps_pp.parent = self
                            self._children_name_map["attribute_set_aps_pp"] = "attribute-set-aps-pp"
                        return self.attribute_set_aps_pp

                    if (child_yang_name == "attribute-set-autobackup"):
                        if (self.attribute_set_autobackup is None):
                            self.attribute_set_autobackup = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutobackup()
                            self.attribute_set_autobackup.parent = self
                            self._children_name_map["attribute_set_autobackup"] = "attribute-set-autobackup"
                        return self.attribute_set_autobackup

                    if (child_yang_name == "attribute-set-automesh"):
                        if (self.attribute_set_automesh is None):
                            self.attribute_set_automesh = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetAutomesh()
                            self.attribute_set_automesh.parent = self
                            self._children_name_map["attribute_set_automesh"] = "attribute-set-automesh"
                        return self.attribute_set_automesh

                    if (child_yang_name == "attribute-set-p2mpte"):
                        if (self.attribute_set_p2mpte is None):
                            self.attribute_set_p2mpte = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2Mpte()
                            self.attribute_set_p2mpte.parent = self
                            self._children_name_map["attribute_set_p2mpte"] = "attribute-set-p2mpte"
                        return self.attribute_set_p2mpte

                    if (child_yang_name == "attribute-set-p2p-te"):
                        if (self.attribute_set_p2p_te is None):
                            self.attribute_set_p2p_te = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetP2PTe()
                            self.attribute_set_p2p_te.parent = self
                            self._children_name_map["attribute_set_p2p_te"] = "attribute-set-p2p-te"
                        return self.attribute_set_p2p_te

                    if (child_yang_name == "attribute-set-path-option"):
                        if (self.attribute_set_path_option is None):
                            self.attribute_set_path_option = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetPathOption()
                            self.attribute_set_path_option.parent = self
                            self._children_name_map["attribute_set_path_option"] = "attribute-set-path-option"
                        return self.attribute_set_path_option

                    if (child_yang_name == "attribute-set-xro"):
                        if (self.attribute_set_xro is None):
                            self.attribute_set_xro = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion.AttributeSetXro()
                            self.attribute_set_xro.parent = self
                            self._children_name_map["attribute_set_xro"] = "attribute-set-xro"
                        return self.attribute_set_xro

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "attribute-set-aps-pp" or name == "attribute-set-autobackup" or name == "attribute-set-automesh" or name == "attribute-set-p2mpte" or name == "attribute-set-p2p-te" or name == "attribute-set-path-option" or name == "attribute-set-xro" or name == "tunnel-attribute-set-type"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "tunnel-attribute-set-type"):
                        self.tunnel_attribute_set_type = value
                        self.tunnel_attribute_set_type.value_namespace = name_space
                        self.tunnel_attribute_set_type.value_namespace_prefix = name_space_prefix

            def has_data(self):
                return (
                    self.attribute_set_type.is_set or
                    self.attribute_set_name.is_set or
                    self.tunnel_attribute_set_name.is_set or
                    self.tunnel_attribute_set_name_crc32.is_set or
                    (self.attribute_set_union is not None and self.attribute_set_union.has_data()))

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    self.attribute_set_type.yfilter != YFilter.not_set or
                    self.attribute_set_name.yfilter != YFilter.not_set or
                    self.tunnel_attribute_set_name.yfilter != YFilter.not_set or
                    self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set or
                    (self.attribute_set_union is not None and self.attribute_set_union.has_operation()))

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "attribute-set" + "[attribute-set-type='" + self.attribute_set_type.get() + "']" + "[attribute-set-name='" + self.attribute_set_name.get() + "']" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/attribute-sets/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.attribute_set_type.is_set or self.attribute_set_type.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.attribute_set_type.get_name_leafdata())
                if (self.attribute_set_name.is_set or self.attribute_set_name.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.attribute_set_name.get_name_leafdata())
                if (self.tunnel_attribute_set_name.is_set or self.tunnel_attribute_set_name.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.tunnel_attribute_set_name.get_name_leafdata())
                if (self.tunnel_attribute_set_name_crc32.is_set or self.tunnel_attribute_set_name_crc32.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.tunnel_attribute_set_name_crc32.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "attribute-set-union"):
                    if (self.attribute_set_union is None):
                        self.attribute_set_union = MplsTeStandby.AttributeSets.AttributeSet.AttributeSetUnion()
                        self.attribute_set_union.parent = self
                        self._children_name_map["attribute_set_union"] = "attribute-set-union"
                    return self.attribute_set_union

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "attribute-set-union" or name == "attribute-set-type" or name == "attribute-set-name" or name == "tunnel-attribute-set-name" or name == "tunnel-attribute-set-name-crc32"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "attribute-set-type"):
                    self.attribute_set_type = value
                    self.attribute_set_type.value_namespace = name_space
                    self.attribute_set_type.value_namespace_prefix = name_space_prefix
                if(value_path == "attribute-set-name"):
                    self.attribute_set_name = value
                    self.attribute_set_name.value_namespace = name_space
                    self.attribute_set_name.value_namespace_prefix = name_space_prefix
                if(value_path == "tunnel-attribute-set-name"):
                    self.tunnel_attribute_set_name = value
                    self.tunnel_attribute_set_name.value_namespace = name_space
                    self.tunnel_attribute_set_name.value_namespace_prefix = name_space_prefix
                if(value_path == "tunnel-attribute-set-name-crc32"):
                    self.tunnel_attribute_set_name_crc32 = value
                    self.tunnel_attribute_set_name_crc32.value_namespace = name_space
                    self.tunnel_attribute_set_name_crc32.value_namespace_prefix = name_space_prefix

        def has_data(self):
            for c in self.attribute_set:
                if (c.has_data()):
                    return True
            return False

        def has_operation(self):
            for c in self.attribute_set:
                if (c.has_operation()):
                    return True
            return self.yfilter != YFilter.not_set

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "attribute-sets" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "attribute-set"):
                for c in self.attribute_set:
                    segment = c.get_segment_path()
                    if (segment_path == segment):
                        return c
                c = MplsTeStandby.AttributeSets.AttributeSet()
                c.parent = self
                local_reference_key = "ydk::seg::%s" % segment_path
                self._local_refs[local_reference_key] = c
                self.attribute_set.append(c)
                return c

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "attribute-set"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class IgpAreaBriefs(Entity):
        """
        The set of IGP\-areas known to MPLS\-TE
        
        .. attribute:: igp_area_brief
        
        	An IGP instance Brief info
        	**type**\: list of    :py:class:`IgpAreaBrief <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.IgpAreaBriefs.IgpAreaBrief>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsTeStandby.IgpAreaBriefs, self).__init__()

            self.yang_name = "igp-area-briefs"
            self.yang_parent_name = "mpls-te-standby"

            self.igp_area_brief = YList(self)

        def __setattr__(self, name, value):
            self._check_monkey_patching_error(name, value)
            with _handle_type_error():
                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                        "Please use list append or extend method."
                                        .format(value))
                if isinstance(value, Enum.YLeaf):
                    value = value.name
                if name in () and name in self.__dict__:
                    if isinstance(value, YLeaf):
                        self.__dict__[name].set(value.get())
                    elif isinstance(value, YLeafList):
                        super(MplsTeStandby.IgpAreaBriefs, self).__setattr__(name, value)
                    else:
                        self.__dict__[name].set(value)
                else:
                    if hasattr(value, "parent") and name != "parent":
                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                            value.parent = self
                        elif value.parent is None and value.yang_name in self._children_yang_names:
                            value.parent = self
                    super(MplsTeStandby.IgpAreaBriefs, self).__setattr__(name, value)


        class IgpAreaBrief(Entity):
            """
            An IGP instance Brief info
            
            .. attribute:: protocol  <key>
            
            	The IGP protocol
            	**type**\:   :py:class:`MplsTeIgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeIgpProtocol>`
            
            .. attribute:: process_tag  <key>
            
            	IGP Process Tag
            	**type**\:  str
            
            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
            
            .. attribute:: area
            
            	IGP area information
            	**type**\: list of    :py:class:`Area <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.IgpAreaBriefs.IgpAreaBrief.Area>`
            
            .. attribute:: configured_te_router_id
            
            	Configured TE router\-id
            	**type**\:  str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            .. attribute:: connection_down_count
            
            	Number of times IGP connection has gone down
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: connection_up_count
            
            	Number of times IGP connection has gone up
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: global_router_id
            
            	Global router\-id
            	**type**\:  str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            .. attribute:: globall_router_id_optical
            
            	Global router\-id for GMPLS (optical TE)
            	**type**\:  str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            .. attribute:: igp_system_id
            
            	 The IGP instance's system/router\-id; interpret appropriately depending on IGP type
            	**type**\:  str
            
            .. attribute:: igp_type
            
            	IGP type
            	**type**\:   :py:class:`IgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpProtocol>`
            
            .. attribute:: in_use_te_router_id
            
            	TE router\-id in use
            	**type**\:  str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            .. attribute:: instance_name
            
            	 The IGP instance name
            	**type**\:  str
            
            .. attribute:: is_connection_up
            
            	Flag to indicate whether the IGP connection is open or not
            	**type**\:  bool
            
            .. attribute:: secondary_router_id
            
            	Secondary router\-ids
            	**type**\: list of    :py:class:`SecondaryRouterId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.IgpAreaBriefs.IgpAreaBrief.SecondaryRouterId>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTeStandby.IgpAreaBriefs.IgpAreaBrief, self).__init__()

                self.yang_name = "igp-area-brief"
                self.yang_parent_name = "igp-area-briefs"

                self.protocol = YLeaf(YType.enumeration, "protocol")

                self.process_tag = YLeaf(YType.str, "process-tag")

                self.configured_te_router_id = YLeaf(YType.str, "configured-te-router-id")

                self.connection_down_count = YLeaf(YType.uint32, "connection-down-count")

                self.connection_up_count = YLeaf(YType.uint32, "connection-up-count")

                self.global_router_id = YLeaf(YType.str, "global-router-id")

                self.globall_router_id_optical = YLeaf(YType.str, "globall-router-id-optical")

                self.igp_system_id = YLeaf(YType.str, "igp-system-id")

                self.igp_type = YLeaf(YType.enumeration, "igp-type")

                self.in_use_te_router_id = YLeaf(YType.str, "in-use-te-router-id")

                self.instance_name = YLeaf(YType.str, "instance-name")

                self.is_connection_up = YLeaf(YType.boolean, "is-connection-up")

                self.area = YList(self)
                self.secondary_router_id = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("protocol",
                                "process_tag",
                                "configured_te_router_id",
                                "connection_down_count",
                                "connection_up_count",
                                "global_router_id",
                                "globall_router_id_optical",
                                "igp_system_id",
                                "igp_type",
                                "in_use_te_router_id",
                                "instance_name",
                                "is_connection_up") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTeStandby.IgpAreaBriefs.IgpAreaBrief, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTeStandby.IgpAreaBriefs.IgpAreaBrief, self).__setattr__(name, value)


            class SecondaryRouterId(Entity):
                """
                Secondary router\-ids
                
                .. attribute:: entry
                
                	
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTeStandby.IgpAreaBriefs.IgpAreaBrief.SecondaryRouterId, self).__init__()

                    self.yang_name = "secondary-router-id"
                    self.yang_parent_name = "igp-area-brief"

                    self.entry = YLeaf(YType.str, "entry")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("entry") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTeStandby.IgpAreaBriefs.IgpAreaBrief.SecondaryRouterId, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTeStandby.IgpAreaBriefs.IgpAreaBrief.SecondaryRouterId, self).__setattr__(name, value)

                def has_data(self):
                    return self.entry.is_set

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.entry.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "secondary-router-id" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.entry.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "entry"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "entry"):
                        self.entry = value
                        self.entry.value_namespace = name_space
                        self.entry.value_namespace_prefix = name_space_prefix


            class Area(Entity):
                """
                IGP area information
                
                .. attribute:: active_data
                
                	Data which applies only to an active area
                	**type**\:   :py:class:`ActiveData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.IgpAreaBriefs.IgpAreaBrief.Area.ActiveData>`
                
                .. attribute:: area_format
                
                	IGP Area Format
                	**type**\:   :py:class:`IgpOspfAreaFormat <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpOspfAreaFormat>`
                
                .. attribute:: area_index
                
                	Internal area index
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: area_number
                
                	Area number
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: is_config_ready
                
                	Indicates whether or not the area is correctly configured under the IGP submode to run TE
                	**type**\:  bool
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTeStandby.IgpAreaBriefs.IgpAreaBrief.Area, self).__init__()

                    self.yang_name = "area"
                    self.yang_parent_name = "igp-area-brief"

                    self.area_format = YLeaf(YType.enumeration, "area-format")

                    self.area_index = YLeaf(YType.uint32, "area-index")

                    self.area_number = YLeaf(YType.uint32, "area-number")

                    self.is_config_ready = YLeaf(YType.boolean, "is-config-ready")

                    self.active_data = MplsTeStandby.IgpAreaBriefs.IgpAreaBrief.Area.ActiveData()
                    self.active_data.parent = self
                    self._children_name_map["active_data"] = "active-data"
                    self._children_yang_names.add("active-data")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("area_format",
                                    "area_index",
                                    "area_number",
                                    "is_config_ready") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTeStandby.IgpAreaBriefs.IgpAreaBrief.Area, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTeStandby.IgpAreaBriefs.IgpAreaBrief.Area, self).__setattr__(name, value)


                class ActiveData(Entity):
                    """
                    Data which applies only to an active area
                    
                    .. attribute:: area_statistics
                    
                    	Area communication statistics
                    	**type**\:   :py:class:`AreaStatistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.IgpAreaBriefs.IgpAreaBrief.Area.ActiveData.AreaStatistics>`
                    
                    .. attribute:: interfaces_count
                    
                    	Number of interfaces running over this area
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: link_idt_received
                    
                    	Flag to indicate IDT for link adjacencies was received
                    	**type**\:  bool
                    
                    .. attribute:: p2mp_destination_count
                    
                    	Number of P2MP destinations whose path was calculated over this area
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: p2p_autoroute_announced_count
                    
                    	Number of p2p tunnel heads which have been autoroute\-announced into this area
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: p2p_forwarding_adjacency_count
                    
                    	Number of p2p tunnel heads which have been announced as forwarding adjacencies in this area
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: p2p_heads_count
                    
                    	Number of p2p tunnel heads whose path was calculated over this area
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: sr_strict
                    
                    	Flag to indicate if the area is SR strict
                    	**type**\:  bool
                    
                    .. attribute:: topology_idt_received
                    
                    	Flag to indicate IDT topology was received
                    	**type**\:  bool
                    
                    .. attribute:: tunnel_loose_hops
                    
                    	Number of tunnels with a loose hop ERO expanded in this area
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.IgpAreaBriefs.IgpAreaBrief.Area.ActiveData, self).__init__()

                        self.yang_name = "active-data"
                        self.yang_parent_name = "area"

                        self.interfaces_count = YLeaf(YType.uint32, "interfaces-count")

                        self.link_idt_received = YLeaf(YType.boolean, "link-idt-received")

                        self.p2mp_destination_count = YLeaf(YType.uint32, "p2mp-destination-count")

                        self.p2p_autoroute_announced_count = YLeaf(YType.uint32, "p2p-autoroute-announced-count")

                        self.p2p_forwarding_adjacency_count = YLeaf(YType.uint32, "p2p-forwarding-adjacency-count")

                        self.p2p_heads_count = YLeaf(YType.uint32, "p2p-heads-count")

                        self.sr_strict = YLeaf(YType.boolean, "sr-strict")

                        self.topology_idt_received = YLeaf(YType.boolean, "topology-idt-received")

                        self.tunnel_loose_hops = YLeaf(YType.uint32, "tunnel-loose-hops")

                        self.area_statistics = MplsTeStandby.IgpAreaBriefs.IgpAreaBrief.Area.ActiveData.AreaStatistics()
                        self.area_statistics.parent = self
                        self._children_name_map["area_statistics"] = "area-statistics"
                        self._children_yang_names.add("area-statistics")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("interfaces_count",
                                        "link_idt_received",
                                        "p2mp_destination_count",
                                        "p2p_autoroute_announced_count",
                                        "p2p_forwarding_adjacency_count",
                                        "p2p_heads_count",
                                        "sr_strict",
                                        "topology_idt_received",
                                        "tunnel_loose_hops") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.IgpAreaBriefs.IgpAreaBrief.Area.ActiveData, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.IgpAreaBriefs.IgpAreaBrief.Area.ActiveData, self).__setattr__(name, value)


                    class AreaStatistics(Entity):
                        """
                        Area communication statistics
                        
                        .. attribute:: area_adjacency_announce_messages
                        
                        	Number of adjacency announcement messages received
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: area_adjacency_request_messages
                        
                        	Number of adjacency request messages sent
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: area_flood_messages
                        
                        	Number of local LSA floods sent
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: area_lsa_announce_messages
                        
                        	Number of LSA announcement messages received
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: area_lsa_delete_messages
                        
                        	Number of LSA delete messages received
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: area_lsa_fragment_announce_messages
                        
                        	Number of LSA fragment announcement messages received
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: area_lsa_fragment_delete_messages
                        
                        	Number of LSA fragment delete messages received
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: area_tunnel_announce_messages
                        
                        	Number of tunnel announcement messages sent
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.IgpAreaBriefs.IgpAreaBrief.Area.ActiveData.AreaStatistics, self).__init__()

                            self.yang_name = "area-statistics"
                            self.yang_parent_name = "active-data"

                            self.area_adjacency_announce_messages = YLeaf(YType.uint32, "area-adjacency-announce-messages")

                            self.area_adjacency_request_messages = YLeaf(YType.uint32, "area-adjacency-request-messages")

                            self.area_flood_messages = YLeaf(YType.uint32, "area-flood-messages")

                            self.area_lsa_announce_messages = YLeaf(YType.uint32, "area-lsa-announce-messages")

                            self.area_lsa_delete_messages = YLeaf(YType.uint32, "area-lsa-delete-messages")

                            self.area_lsa_fragment_announce_messages = YLeaf(YType.uint32, "area-lsa-fragment-announce-messages")

                            self.area_lsa_fragment_delete_messages = YLeaf(YType.uint32, "area-lsa-fragment-delete-messages")

                            self.area_tunnel_announce_messages = YLeaf(YType.uint32, "area-tunnel-announce-messages")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("area_adjacency_announce_messages",
                                            "area_adjacency_request_messages",
                                            "area_flood_messages",
                                            "area_lsa_announce_messages",
                                            "area_lsa_delete_messages",
                                            "area_lsa_fragment_announce_messages",
                                            "area_lsa_fragment_delete_messages",
                                            "area_tunnel_announce_messages") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.IgpAreaBriefs.IgpAreaBrief.Area.ActiveData.AreaStatistics, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.IgpAreaBriefs.IgpAreaBrief.Area.ActiveData.AreaStatistics, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.area_adjacency_announce_messages.is_set or
                                self.area_adjacency_request_messages.is_set or
                                self.area_flood_messages.is_set or
                                self.area_lsa_announce_messages.is_set or
                                self.area_lsa_delete_messages.is_set or
                                self.area_lsa_fragment_announce_messages.is_set or
                                self.area_lsa_fragment_delete_messages.is_set or
                                self.area_tunnel_announce_messages.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.area_adjacency_announce_messages.yfilter != YFilter.not_set or
                                self.area_adjacency_request_messages.yfilter != YFilter.not_set or
                                self.area_flood_messages.yfilter != YFilter.not_set or
                                self.area_lsa_announce_messages.yfilter != YFilter.not_set or
                                self.area_lsa_delete_messages.yfilter != YFilter.not_set or
                                self.area_lsa_fragment_announce_messages.yfilter != YFilter.not_set or
                                self.area_lsa_fragment_delete_messages.yfilter != YFilter.not_set or
                                self.area_tunnel_announce_messages.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "area-statistics" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.area_adjacency_announce_messages.is_set or self.area_adjacency_announce_messages.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.area_adjacency_announce_messages.get_name_leafdata())
                            if (self.area_adjacency_request_messages.is_set or self.area_adjacency_request_messages.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.area_adjacency_request_messages.get_name_leafdata())
                            if (self.area_flood_messages.is_set or self.area_flood_messages.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.area_flood_messages.get_name_leafdata())
                            if (self.area_lsa_announce_messages.is_set or self.area_lsa_announce_messages.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.area_lsa_announce_messages.get_name_leafdata())
                            if (self.area_lsa_delete_messages.is_set or self.area_lsa_delete_messages.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.area_lsa_delete_messages.get_name_leafdata())
                            if (self.area_lsa_fragment_announce_messages.is_set or self.area_lsa_fragment_announce_messages.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.area_lsa_fragment_announce_messages.get_name_leafdata())
                            if (self.area_lsa_fragment_delete_messages.is_set or self.area_lsa_fragment_delete_messages.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.area_lsa_fragment_delete_messages.get_name_leafdata())
                            if (self.area_tunnel_announce_messages.is_set or self.area_tunnel_announce_messages.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.area_tunnel_announce_messages.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "area-adjacency-announce-messages" or name == "area-adjacency-request-messages" or name == "area-flood-messages" or name == "area-lsa-announce-messages" or name == "area-lsa-delete-messages" or name == "area-lsa-fragment-announce-messages" or name == "area-lsa-fragment-delete-messages" or name == "area-tunnel-announce-messages"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "area-adjacency-announce-messages"):
                                self.area_adjacency_announce_messages = value
                                self.area_adjacency_announce_messages.value_namespace = name_space
                                self.area_adjacency_announce_messages.value_namespace_prefix = name_space_prefix
                            if(value_path == "area-adjacency-request-messages"):
                                self.area_adjacency_request_messages = value
                                self.area_adjacency_request_messages.value_namespace = name_space
                                self.area_adjacency_request_messages.value_namespace_prefix = name_space_prefix
                            if(value_path == "area-flood-messages"):
                                self.area_flood_messages = value
                                self.area_flood_messages.value_namespace = name_space
                                self.area_flood_messages.value_namespace_prefix = name_space_prefix
                            if(value_path == "area-lsa-announce-messages"):
                                self.area_lsa_announce_messages = value
                                self.area_lsa_announce_messages.value_namespace = name_space
                                self.area_lsa_announce_messages.value_namespace_prefix = name_space_prefix
                            if(value_path == "area-lsa-delete-messages"):
                                self.area_lsa_delete_messages = value
                                self.area_lsa_delete_messages.value_namespace = name_space
                                self.area_lsa_delete_messages.value_namespace_prefix = name_space_prefix
                            if(value_path == "area-lsa-fragment-announce-messages"):
                                self.area_lsa_fragment_announce_messages = value
                                self.area_lsa_fragment_announce_messages.value_namespace = name_space
                                self.area_lsa_fragment_announce_messages.value_namespace_prefix = name_space_prefix
                            if(value_path == "area-lsa-fragment-delete-messages"):
                                self.area_lsa_fragment_delete_messages = value
                                self.area_lsa_fragment_delete_messages.value_namespace = name_space
                                self.area_lsa_fragment_delete_messages.value_namespace_prefix = name_space_prefix
                            if(value_path == "area-tunnel-announce-messages"):
                                self.area_tunnel_announce_messages = value
                                self.area_tunnel_announce_messages.value_namespace = name_space
                                self.area_tunnel_announce_messages.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.interfaces_count.is_set or
                            self.link_idt_received.is_set or
                            self.p2mp_destination_count.is_set or
                            self.p2p_autoroute_announced_count.is_set or
                            self.p2p_forwarding_adjacency_count.is_set or
                            self.p2p_heads_count.is_set or
                            self.sr_strict.is_set or
                            self.topology_idt_received.is_set or
                            self.tunnel_loose_hops.is_set or
                            (self.area_statistics is not None and self.area_statistics.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.interfaces_count.yfilter != YFilter.not_set or
                            self.link_idt_received.yfilter != YFilter.not_set or
                            self.p2mp_destination_count.yfilter != YFilter.not_set or
                            self.p2p_autoroute_announced_count.yfilter != YFilter.not_set or
                            self.p2p_forwarding_adjacency_count.yfilter != YFilter.not_set or
                            self.p2p_heads_count.yfilter != YFilter.not_set or
                            self.sr_strict.yfilter != YFilter.not_set or
                            self.topology_idt_received.yfilter != YFilter.not_set or
                            self.tunnel_loose_hops.yfilter != YFilter.not_set or
                            (self.area_statistics is not None and self.area_statistics.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "active-data" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.interfaces_count.is_set or self.interfaces_count.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.interfaces_count.get_name_leafdata())
                        if (self.link_idt_received.is_set or self.link_idt_received.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.link_idt_received.get_name_leafdata())
                        if (self.p2mp_destination_count.is_set or self.p2mp_destination_count.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.p2mp_destination_count.get_name_leafdata())
                        if (self.p2p_autoroute_announced_count.is_set or self.p2p_autoroute_announced_count.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.p2p_autoroute_announced_count.get_name_leafdata())
                        if (self.p2p_forwarding_adjacency_count.is_set or self.p2p_forwarding_adjacency_count.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.p2p_forwarding_adjacency_count.get_name_leafdata())
                        if (self.p2p_heads_count.is_set or self.p2p_heads_count.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.p2p_heads_count.get_name_leafdata())
                        if (self.sr_strict.is_set or self.sr_strict.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.sr_strict.get_name_leafdata())
                        if (self.topology_idt_received.is_set or self.topology_idt_received.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.topology_idt_received.get_name_leafdata())
                        if (self.tunnel_loose_hops.is_set or self.tunnel_loose_hops.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.tunnel_loose_hops.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "area-statistics"):
                            if (self.area_statistics is None):
                                self.area_statistics = MplsTeStandby.IgpAreaBriefs.IgpAreaBrief.Area.ActiveData.AreaStatistics()
                                self.area_statistics.parent = self
                                self._children_name_map["area_statistics"] = "area-statistics"
                            return self.area_statistics

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "area-statistics" or name == "interfaces-count" or name == "link-idt-received" or name == "p2mp-destination-count" or name == "p2p-autoroute-announced-count" or name == "p2p-forwarding-adjacency-count" or name == "p2p-heads-count" or name == "sr-strict" or name == "topology-idt-received" or name == "tunnel-loose-hops"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "interfaces-count"):
                            self.interfaces_count = value
                            self.interfaces_count.value_namespace = name_space
                            self.interfaces_count.value_namespace_prefix = name_space_prefix
                        if(value_path == "link-idt-received"):
                            self.link_idt_received = value
                            self.link_idt_received.value_namespace = name_space
                            self.link_idt_received.value_namespace_prefix = name_space_prefix
                        if(value_path == "p2mp-destination-count"):
                            self.p2mp_destination_count = value
                            self.p2mp_destination_count.value_namespace = name_space
                            self.p2mp_destination_count.value_namespace_prefix = name_space_prefix
                        if(value_path == "p2p-autoroute-announced-count"):
                            self.p2p_autoroute_announced_count = value
                            self.p2p_autoroute_announced_count.value_namespace = name_space
                            self.p2p_autoroute_announced_count.value_namespace_prefix = name_space_prefix
                        if(value_path == "p2p-forwarding-adjacency-count"):
                            self.p2p_forwarding_adjacency_count = value
                            self.p2p_forwarding_adjacency_count.value_namespace = name_space
                            self.p2p_forwarding_adjacency_count.value_namespace_prefix = name_space_prefix
                        if(value_path == "p2p-heads-count"):
                            self.p2p_heads_count = value
                            self.p2p_heads_count.value_namespace = name_space
                            self.p2p_heads_count.value_namespace_prefix = name_space_prefix
                        if(value_path == "sr-strict"):
                            self.sr_strict = value
                            self.sr_strict.value_namespace = name_space
                            self.sr_strict.value_namespace_prefix = name_space_prefix
                        if(value_path == "topology-idt-received"):
                            self.topology_idt_received = value
                            self.topology_idt_received.value_namespace = name_space
                            self.topology_idt_received.value_namespace_prefix = name_space_prefix
                        if(value_path == "tunnel-loose-hops"):
                            self.tunnel_loose_hops = value
                            self.tunnel_loose_hops.value_namespace = name_space
                            self.tunnel_loose_hops.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    return (
                        self.area_format.is_set or
                        self.area_index.is_set or
                        self.area_number.is_set or
                        self.is_config_ready.is_set or
                        (self.active_data is not None and self.active_data.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.area_format.yfilter != YFilter.not_set or
                        self.area_index.yfilter != YFilter.not_set or
                        self.area_number.yfilter != YFilter.not_set or
                        self.is_config_ready.yfilter != YFilter.not_set or
                        (self.active_data is not None and self.active_data.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "area" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.area_format.is_set or self.area_format.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.area_format.get_name_leafdata())
                    if (self.area_index.is_set or self.area_index.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.area_index.get_name_leafdata())
                    if (self.area_number.is_set or self.area_number.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.area_number.get_name_leafdata())
                    if (self.is_config_ready.is_set or self.is_config_ready.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_config_ready.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "active-data"):
                        if (self.active_data is None):
                            self.active_data = MplsTeStandby.IgpAreaBriefs.IgpAreaBrief.Area.ActiveData()
                            self.active_data.parent = self
                            self._children_name_map["active_data"] = "active-data"
                        return self.active_data

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "active-data" or name == "area-format" or name == "area-index" or name == "area-number" or name == "is-config-ready"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "area-format"):
                        self.area_format = value
                        self.area_format.value_namespace = name_space
                        self.area_format.value_namespace_prefix = name_space_prefix
                    if(value_path == "area-index"):
                        self.area_index = value
                        self.area_index.value_namespace = name_space
                        self.area_index.value_namespace_prefix = name_space_prefix
                    if(value_path == "area-number"):
                        self.area_number = value
                        self.area_number.value_namespace = name_space
                        self.area_number.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-config-ready"):
                        self.is_config_ready = value
                        self.is_config_ready.value_namespace = name_space
                        self.is_config_ready.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.area:
                    if (c.has_data()):
                        return True
                for c in self.secondary_router_id:
                    if (c.has_data()):
                        return True
                return (
                    self.protocol.is_set or
                    self.process_tag.is_set or
                    self.configured_te_router_id.is_set or
                    self.connection_down_count.is_set or
                    self.connection_up_count.is_set or
                    self.global_router_id.is_set or
                    self.globall_router_id_optical.is_set or
                    self.igp_system_id.is_set or
                    self.igp_type.is_set or
                    self.in_use_te_router_id.is_set or
                    self.instance_name.is_set or
                    self.is_connection_up.is_set)

            def has_operation(self):
                for c in self.area:
                    if (c.has_operation()):
                        return True
                for c in self.secondary_router_id:
                    if (c.has_operation()):
                        return True
                return (
                    self.yfilter != YFilter.not_set or
                    self.protocol.yfilter != YFilter.not_set or
                    self.process_tag.yfilter != YFilter.not_set or
                    self.configured_te_router_id.yfilter != YFilter.not_set or
                    self.connection_down_count.yfilter != YFilter.not_set or
                    self.connection_up_count.yfilter != YFilter.not_set or
                    self.global_router_id.yfilter != YFilter.not_set or
                    self.globall_router_id_optical.yfilter != YFilter.not_set or
                    self.igp_system_id.yfilter != YFilter.not_set or
                    self.igp_type.yfilter != YFilter.not_set or
                    self.in_use_te_router_id.yfilter != YFilter.not_set or
                    self.instance_name.yfilter != YFilter.not_set or
                    self.is_connection_up.yfilter != YFilter.not_set)

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "igp-area-brief" + "[protocol='" + self.protocol.get() + "']" + "[process-tag='" + self.process_tag.get() + "']" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/igp-area-briefs/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.protocol.is_set or self.protocol.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.protocol.get_name_leafdata())
                if (self.process_tag.is_set or self.process_tag.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.process_tag.get_name_leafdata())
                if (self.configured_te_router_id.is_set or self.configured_te_router_id.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.configured_te_router_id.get_name_leafdata())
                if (self.connection_down_count.is_set or self.connection_down_count.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.connection_down_count.get_name_leafdata())
                if (self.connection_up_count.is_set or self.connection_up_count.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.connection_up_count.get_name_leafdata())
                if (self.global_router_id.is_set or self.global_router_id.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.global_router_id.get_name_leafdata())
                if (self.globall_router_id_optical.is_set or self.globall_router_id_optical.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.globall_router_id_optical.get_name_leafdata())
                if (self.igp_system_id.is_set or self.igp_system_id.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.igp_system_id.get_name_leafdata())
                if (self.igp_type.is_set or self.igp_type.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.igp_type.get_name_leafdata())
                if (self.in_use_te_router_id.is_set or self.in_use_te_router_id.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.in_use_te_router_id.get_name_leafdata())
                if (self.instance_name.is_set or self.instance_name.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.instance_name.get_name_leafdata())
                if (self.is_connection_up.is_set or self.is_connection_up.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.is_connection_up.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "area"):
                    for c in self.area:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTeStandby.IgpAreaBriefs.IgpAreaBrief.Area()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.area.append(c)
                    return c

                if (child_yang_name == "secondary-router-id"):
                    for c in self.secondary_router_id:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTeStandby.IgpAreaBriefs.IgpAreaBrief.SecondaryRouterId()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.secondary_router_id.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "area" or name == "secondary-router-id" or name == "protocol" or name == "process-tag" or name == "configured-te-router-id" or name == "connection-down-count" or name == "connection-up-count" or name == "global-router-id" or name == "globall-router-id-optical" or name == "igp-system-id" or name == "igp-type" or name == "in-use-te-router-id" or name == "instance-name" or name == "is-connection-up"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "protocol"):
                    self.protocol = value
                    self.protocol.value_namespace = name_space
                    self.protocol.value_namespace_prefix = name_space_prefix
                if(value_path == "process-tag"):
                    self.process_tag = value
                    self.process_tag.value_namespace = name_space
                    self.process_tag.value_namespace_prefix = name_space_prefix
                if(value_path == "configured-te-router-id"):
                    self.configured_te_router_id = value
                    self.configured_te_router_id.value_namespace = name_space
                    self.configured_te_router_id.value_namespace_prefix = name_space_prefix
                if(value_path == "connection-down-count"):
                    self.connection_down_count = value
                    self.connection_down_count.value_namespace = name_space
                    self.connection_down_count.value_namespace_prefix = name_space_prefix
                if(value_path == "connection-up-count"):
                    self.connection_up_count = value
                    self.connection_up_count.value_namespace = name_space
                    self.connection_up_count.value_namespace_prefix = name_space_prefix
                if(value_path == "global-router-id"):
                    self.global_router_id = value
                    self.global_router_id.value_namespace = name_space
                    self.global_router_id.value_namespace_prefix = name_space_prefix
                if(value_path == "globall-router-id-optical"):
                    self.globall_router_id_optical = value
                    self.globall_router_id_optical.value_namespace = name_space
                    self.globall_router_id_optical.value_namespace_prefix = name_space_prefix
                if(value_path == "igp-system-id"):
                    self.igp_system_id = value
                    self.igp_system_id.value_namespace = name_space
                    self.igp_system_id.value_namespace_prefix = name_space_prefix
                if(value_path == "igp-type"):
                    self.igp_type = value
                    self.igp_type.value_namespace = name_space
                    self.igp_type.value_namespace_prefix = name_space_prefix
                if(value_path == "in-use-te-router-id"):
                    self.in_use_te_router_id = value
                    self.in_use_te_router_id.value_namespace = name_space
                    self.in_use_te_router_id.value_namespace_prefix = name_space_prefix
                if(value_path == "instance-name"):
                    self.instance_name = value
                    self.instance_name.value_namespace = name_space
                    self.instance_name.value_namespace_prefix = name_space_prefix
                if(value_path == "is-connection-up"):
                    self.is_connection_up = value
                    self.is_connection_up.value_namespace = name_space
                    self.is_connection_up.value_namespace_prefix = name_space_prefix

        def has_data(self):
            for c in self.igp_area_brief:
                if (c.has_data()):
                    return True
            return False

        def has_operation(self):
            for c in self.igp_area_brief:
                if (c.has_operation()):
                    return True
            return self.yfilter != YFilter.not_set

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "igp-area-briefs" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "igp-area-brief"):
                for c in self.igp_area_brief:
                    segment = c.get_segment_path()
                    if (segment_path == segment):
                        return c
                c = MplsTeStandby.IgpAreaBriefs.IgpAreaBrief()
                c.parent = self
                local_reference_key = "ydk::seg::%s" % segment_path
                self._local_refs[local_reference_key] = c
                self.igp_area_brief.append(c)
                return c

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "igp-area-brief"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class Tunnels(Entity):
        """
        Failure protection provided for tunnels
        
        .. attribute:: summary
        
        	Summary of tunnel info
        	**type**\:   :py:class:`Summary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.Summary>`
        
        .. attribute:: tunnel_auto_bandwidths
        
        	Auto Bandwidth Brief Table
        	**type**\:   :py:class:`TunnelAutoBandwidths <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelAutoBandwidths>`
        
        .. attribute:: tunnel_flex_lsps
        
        	Flex LSP
        	**type**\:   :py:class:`TunnelFlexLsps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelFlexLsps>`
        
        .. attribute:: tunnel_path_protections
        
        	Path protection
        	**type**\:   :py:class:`TunnelPathProtections <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelPathProtections>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsTeStandby.Tunnels, self).__init__()

            self.yang_name = "tunnels"
            self.yang_parent_name = "mpls-te-standby"

            self.summary = MplsTeStandby.Tunnels.Summary()
            self.summary.parent = self
            self._children_name_map["summary"] = "summary"
            self._children_yang_names.add("summary")

            self.tunnel_auto_bandwidths = MplsTeStandby.Tunnels.TunnelAutoBandwidths()
            self.tunnel_auto_bandwidths.parent = self
            self._children_name_map["tunnel_auto_bandwidths"] = "tunnel-auto-bandwidths"
            self._children_yang_names.add("tunnel-auto-bandwidths")

            self.tunnel_flex_lsps = MplsTeStandby.Tunnels.TunnelFlexLsps()
            self.tunnel_flex_lsps.parent = self
            self._children_name_map["tunnel_flex_lsps"] = "tunnel-flex-lsps"
            self._children_yang_names.add("tunnel-flex-lsps")

            self.tunnel_path_protections = MplsTeStandby.Tunnels.TunnelPathProtections()
            self.tunnel_path_protections.parent = self
            self._children_name_map["tunnel_path_protections"] = "tunnel-path-protections"
            self._children_yang_names.add("tunnel-path-protections")


        class TunnelFlexLsps(Entity):
            """
            Flex LSP
            
            .. attribute:: tunnel_flex_lsp
            
            	Flex LSP
            	**type**\: list of    :py:class:`TunnelFlexLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTeStandby.Tunnels.TunnelFlexLsps, self).__init__()

                self.yang_name = "tunnel-flex-lsps"
                self.yang_parent_name = "tunnels"

                self.tunnel_flex_lsp = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTeStandby.Tunnels.TunnelFlexLsps, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTeStandby.Tunnels.TunnelFlexLsps, self).__setattr__(name, value)


            class TunnelFlexLsp(Entity):
                """
                Flex LSP
                
                .. attribute:: ctype
                
                	Ctype
                	**type**\:   :py:class:`Ctype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.Ctype>`
                
                .. attribute:: destination_address
                
                	Destination
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: extended_tunnel_id
                
                	Extended Tunnel ID
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: is_tunnel_up
                
                	Tunnel UP
                	**type**\:  bool
                
                .. attribute:: protect_lsp
                
                	 Protect LSP info
                	**type**\:   :py:class:`ProtectLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp>`
                
                .. attribute:: source_address
                
                	Source
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: tun_id
                
                	Tunnel ID
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: tunnel_id
                
                	Tunnel ID
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: tunnel_name
                
                	Tunnel Name
                	**type**\:  str
                
                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                
                .. attribute:: working_lsp
                
                	 Working LSP info
                	**type**\:   :py:class:`WorkingLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp>`
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp, self).__init__()

                    self.yang_name = "tunnel-flex-lsp"
                    self.yang_parent_name = "tunnel-flex-lsps"

                    self.ctype = YLeaf(YType.enumeration, "ctype")

                    self.destination_address = YLeaf(YType.str, "destination-address")

                    self.extended_tunnel_id = YLeaf(YType.str, "extended-tunnel-id")

                    self.is_tunnel_up = YLeaf(YType.boolean, "is-tunnel-up")

                    self.source_address = YLeaf(YType.str, "source-address")

                    self.tun_id = YLeaf(YType.uint16, "tun-id")

                    self.tunnel_id = YLeaf(YType.int32, "tunnel-id")

                    self.tunnel_name = YLeaf(YType.str, "tunnel-name")

                    self.protect_lsp = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp()
                    self.protect_lsp.parent = self
                    self._children_name_map["protect_lsp"] = "protect-lsp"
                    self._children_yang_names.add("protect-lsp")

                    self.working_lsp = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp()
                    self.working_lsp.parent = self
                    self._children_name_map["working_lsp"] = "working-lsp"
                    self._children_yang_names.add("working-lsp")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("ctype",
                                    "destination_address",
                                    "extended_tunnel_id",
                                    "is_tunnel_up",
                                    "source_address",
                                    "tun_id",
                                    "tunnel_id",
                                    "tunnel_name") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp, self).__setattr__(name, value)


                class WorkingLsp(Entity):
                    """
                     Working LSP info
                    
                    .. attribute:: association
                    
                    	Association Object
                    	**type**\:   :py:class:`Association <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.Association>`
                    
                    .. attribute:: flex_info
                    
                    	Flex Info
                    	**type**\:   :py:class:`FlexInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.FlexInfo>`
                    
                    .. attribute:: is_operational
                    
                    	Operational
                    	**type**\:  bool
                    
                    .. attribute:: lsp_hop
                    
                    	Path used by LSP
                    	**type**\: list of    :py:class:`LspHop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.LspHop>`
                    
                    .. attribute:: lsp_local_label
                    
                    	Local label 
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: lsp_mode
                    
                    	LSP mode
                    	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                    
                    .. attribute:: lsp_output_interface
                    
                    	Output interface of LSP
                    	**type**\:  str
                    
                    .. attribute:: lsp_output_label
                    
                    	Output label of the LSP
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: lsp_state
                    
                    	LSP State
                    	**type**\:   :py:class:`MplsTeTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelState>`
                    
                    .. attribute:: lsp_uptime
                    
                    	LSP Uptime
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: path_protection_lsp_id
                    
                    	LSP ID 
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: protection
                    
                    	Protection Object
                    	**type**\:   :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.Protection>`
                    
                    .. attribute:: reverse_lsp
                    
                    	Reverse LSP information
                    	**type**\:   :py:class:`ReverseLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp, self).__init__()

                        self.yang_name = "working-lsp"
                        self.yang_parent_name = "tunnel-flex-lsp"

                        self.is_operational = YLeaf(YType.boolean, "is-operational")

                        self.lsp_local_label = YLeaf(YType.uint32, "lsp-local-label")

                        self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                        self.lsp_output_interface = YLeaf(YType.str, "lsp-output-interface")

                        self.lsp_output_label = YLeaf(YType.uint32, "lsp-output-label")

                        self.lsp_state = YLeaf(YType.enumeration, "lsp-state")

                        self.lsp_uptime = YLeaf(YType.uint32, "lsp-uptime")

                        self.path_protection_lsp_id = YLeaf(YType.uint32, "path-protection-lsp-id")

                        self.association = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.Association()
                        self.association.parent = self
                        self._children_name_map["association"] = "association"
                        self._children_yang_names.add("association")

                        self.flex_info = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.FlexInfo()
                        self.flex_info.parent = self
                        self._children_name_map["flex_info"] = "flex-info"
                        self._children_yang_names.add("flex-info")

                        self.protection = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.Protection()
                        self.protection.parent = self
                        self._children_name_map["protection"] = "protection"
                        self._children_yang_names.add("protection")

                        self.reverse_lsp = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp()
                        self.reverse_lsp.parent = self
                        self._children_name_map["reverse_lsp"] = "reverse-lsp"
                        self._children_yang_names.add("reverse-lsp")

                        self.lsp_hop = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("is_operational",
                                        "lsp_local_label",
                                        "lsp_mode",
                                        "lsp_output_interface",
                                        "lsp_output_label",
                                        "lsp_state",
                                        "lsp_uptime",
                                        "path_protection_lsp_id") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp, self).__setattr__(name, value)


                    class FlexInfo(Entity):
                        """
                        Flex Info
                        
                        .. attribute:: bfd_created
                        
                        	GAL BFD Session Created
                        	**type**\:  bool
                        
                        .. attribute:: bfd_egress_label
                        
                        	BFD Egress Label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: bfd_int_label
                        
                        	BFD Internal Label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: bfd_next_hop
                        
                        	BFD Next Hop
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: bfd_out_ifh
                        
                        	BFD Out Interface Handle
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        .. attribute:: bfd_tun_ifh
                        
                        	BFD Tunnel Interface Handle
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        .. attribute:: bfd_up
                        
                        	GAL BFD Session Up
                        	**type**\:  bool
                        
                        .. attribute:: entry_exists
                        
                        	FlexLSP Entry Exists
                        	**type**\:  bool
                        
                        .. attribute:: fault_ais
                        
                        	Fault AIS
                        	**type**\:  bool
                        
                        .. attribute:: fault_ldi
                        
                        	Fault LDI
                        	**type**\:  bool
                        
                        .. attribute:: fault_ldi_lockout
                        
                        	Fault LDI Lockout
                        	**type**\:  bool
                        
                        .. attribute:: fault_lkr
                        
                        	Fault LKR
                        	**type**\:  bool
                        
                        .. attribute:: fault_time
                        
                        	Fault Time
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: flex_fec
                        
                        	FEC for the FlexLSP Entry
                        	**type**\:   :py:class:`FlexFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.FlexInfo.FlexFec>`
                        
                        .. attribute:: in_label
                        
                        	In Label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: oam_created
                        
                        	OAM Entry Created
                        	**type**\:  bool
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.FlexInfo, self).__init__()

                            self.yang_name = "flex-info"
                            self.yang_parent_name = "working-lsp"

                            self.bfd_created = YLeaf(YType.boolean, "bfd-created")

                            self.bfd_egress_label = YLeaf(YType.uint32, "bfd-egress-label")

                            self.bfd_int_label = YLeaf(YType.uint32, "bfd-int-label")

                            self.bfd_next_hop = YLeaf(YType.str, "bfd-next-hop")

                            self.bfd_out_ifh = YLeaf(YType.str, "bfd-out-ifh")

                            self.bfd_tun_ifh = YLeaf(YType.str, "bfd-tun-ifh")

                            self.bfd_up = YLeaf(YType.boolean, "bfd-up")

                            self.entry_exists = YLeaf(YType.boolean, "entry-exists")

                            self.fault_ais = YLeaf(YType.boolean, "fault-ais")

                            self.fault_ldi = YLeaf(YType.boolean, "fault-ldi")

                            self.fault_ldi_lockout = YLeaf(YType.boolean, "fault-ldi-lockout")

                            self.fault_lkr = YLeaf(YType.boolean, "fault-lkr")

                            self.fault_time = YLeaf(YType.uint32, "fault-time")

                            self.in_label = YLeaf(YType.uint32, "in-label")

                            self.oam_created = YLeaf(YType.boolean, "oam-created")

                            self.flex_fec = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.FlexInfo.FlexFec()
                            self.flex_fec.parent = self
                            self._children_name_map["flex_fec"] = "flex-fec"
                            self._children_yang_names.add("flex-fec")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("bfd_created",
                                            "bfd_egress_label",
                                            "bfd_int_label",
                                            "bfd_next_hop",
                                            "bfd_out_ifh",
                                            "bfd_tun_ifh",
                                            "bfd_up",
                                            "entry_exists",
                                            "fault_ais",
                                            "fault_ldi",
                                            "fault_ldi_lockout",
                                            "fault_lkr",
                                            "fault_time",
                                            "in_label",
                                            "oam_created") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.FlexInfo, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.FlexInfo, self).__setattr__(name, value)


                        class FlexFec(Entity):
                            """
                            FEC for the FlexLSP Entry
                            
                            .. attribute:: s2l_fec_ctype
                            
                            	Session identifier (ctype)
                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            .. attribute:: s2l_fec_dest
                            
                            	sub\-LSP destination address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_lsp_id
                            
                            	LSP ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_p2mp_id
                            
                            	P2MP ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: s2l_fec_source
                            
                            	LSP source address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_subgroup_id
                            
                            	sub\-LSP subgroup ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_subgroup_originator
                            
                            	Subgroup Originator
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.FlexInfo.FlexFec, self).__init__()

                                self.yang_name = "flex-fec"
                                self.yang_parent_name = "flex-info"

                                self.s2l_fec_ctype = YLeaf(YType.enumeration, "s2l-fec-ctype")

                                self.s2l_fec_dest = YLeaf(YType.str, "s2l-fec-dest")

                                self.s2l_fec_extended_tunnel_id = YLeaf(YType.str, "s2l-fec-extended-tunnel-id")

                                self.s2l_fec_lsp_id = YLeaf(YType.uint16, "s2l-fec-lsp-id")

                                self.s2l_fec_p2mp_id = YLeaf(YType.uint32, "s2l-fec-p2mp-id")

                                self.s2l_fec_source = YLeaf(YType.str, "s2l-fec-source")

                                self.s2l_fec_subgroup_id = YLeaf(YType.uint16, "s2l-fec-subgroup-id")

                                self.s2l_fec_subgroup_originator = YLeaf(YType.str, "s2l-fec-subgroup-originator")

                                self.s2l_fec_tunnel_id = YLeaf(YType.uint16, "s2l-fec-tunnel-id")

                                self.s2l_fec_vrf = YLeaf(YType.str, "s2l-fec-vrf")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("s2l_fec_ctype",
                                                "s2l_fec_dest",
                                                "s2l_fec_extended_tunnel_id",
                                                "s2l_fec_lsp_id",
                                                "s2l_fec_p2mp_id",
                                                "s2l_fec_source",
                                                "s2l_fec_subgroup_id",
                                                "s2l_fec_subgroup_originator",
                                                "s2l_fec_tunnel_id",
                                                "s2l_fec_vrf") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.FlexInfo.FlexFec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.FlexInfo.FlexFec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.s2l_fec_ctype.is_set or
                                    self.s2l_fec_dest.is_set or
                                    self.s2l_fec_extended_tunnel_id.is_set or
                                    self.s2l_fec_lsp_id.is_set or
                                    self.s2l_fec_p2mp_id.is_set or
                                    self.s2l_fec_source.is_set or
                                    self.s2l_fec_subgroup_id.is_set or
                                    self.s2l_fec_subgroup_originator.is_set or
                                    self.s2l_fec_tunnel_id.is_set or
                                    self.s2l_fec_vrf.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.s2l_fec_ctype.yfilter != YFilter.not_set or
                                    self.s2l_fec_dest.yfilter != YFilter.not_set or
                                    self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_lsp_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_p2mp_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_source.yfilter != YFilter.not_set or
                                    self.s2l_fec_subgroup_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set or
                                    self.s2l_fec_tunnel_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_vrf.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "flex-fec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/working-lsp/flex-info/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.s2l_fec_ctype.is_set or self.s2l_fec_ctype.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_ctype.get_name_leafdata())
                                if (self.s2l_fec_dest.is_set or self.s2l_fec_dest.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_dest.get_name_leafdata())
                                if (self.s2l_fec_extended_tunnel_id.is_set or self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_extended_tunnel_id.get_name_leafdata())
                                if (self.s2l_fec_lsp_id.is_set or self.s2l_fec_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_lsp_id.get_name_leafdata())
                                if (self.s2l_fec_p2mp_id.is_set or self.s2l_fec_p2mp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_p2mp_id.get_name_leafdata())
                                if (self.s2l_fec_source.is_set or self.s2l_fec_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_source.get_name_leafdata())
                                if (self.s2l_fec_subgroup_id.is_set or self.s2l_fec_subgroup_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_subgroup_id.get_name_leafdata())
                                if (self.s2l_fec_subgroup_originator.is_set or self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_subgroup_originator.get_name_leafdata())
                                if (self.s2l_fec_tunnel_id.is_set or self.s2l_fec_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_tunnel_id.get_name_leafdata())
                                if (self.s2l_fec_vrf.is_set or self.s2l_fec_vrf.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_vrf.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "s2l-fec-ctype" or name == "s2l-fec-dest" or name == "s2l-fec-extended-tunnel-id" or name == "s2l-fec-lsp-id" or name == "s2l-fec-p2mp-id" or name == "s2l-fec-source" or name == "s2l-fec-subgroup-id" or name == "s2l-fec-subgroup-originator" or name == "s2l-fec-tunnel-id" or name == "s2l-fec-vrf"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "s2l-fec-ctype"):
                                    self.s2l_fec_ctype = value
                                    self.s2l_fec_ctype.value_namespace = name_space
                                    self.s2l_fec_ctype.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-dest"):
                                    self.s2l_fec_dest = value
                                    self.s2l_fec_dest.value_namespace = name_space
                                    self.s2l_fec_dest.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-extended-tunnel-id"):
                                    self.s2l_fec_extended_tunnel_id = value
                                    self.s2l_fec_extended_tunnel_id.value_namespace = name_space
                                    self.s2l_fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-lsp-id"):
                                    self.s2l_fec_lsp_id = value
                                    self.s2l_fec_lsp_id.value_namespace = name_space
                                    self.s2l_fec_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-p2mp-id"):
                                    self.s2l_fec_p2mp_id = value
                                    self.s2l_fec_p2mp_id.value_namespace = name_space
                                    self.s2l_fec_p2mp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-source"):
                                    self.s2l_fec_source = value
                                    self.s2l_fec_source.value_namespace = name_space
                                    self.s2l_fec_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-subgroup-id"):
                                    self.s2l_fec_subgroup_id = value
                                    self.s2l_fec_subgroup_id.value_namespace = name_space
                                    self.s2l_fec_subgroup_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-subgroup-originator"):
                                    self.s2l_fec_subgroup_originator = value
                                    self.s2l_fec_subgroup_originator.value_namespace = name_space
                                    self.s2l_fec_subgroup_originator.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-tunnel-id"):
                                    self.s2l_fec_tunnel_id = value
                                    self.s2l_fec_tunnel_id.value_namespace = name_space
                                    self.s2l_fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-vrf"):
                                    self.s2l_fec_vrf = value
                                    self.s2l_fec_vrf.value_namespace = name_space
                                    self.s2l_fec_vrf.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.bfd_created.is_set or
                                self.bfd_egress_label.is_set or
                                self.bfd_int_label.is_set or
                                self.bfd_next_hop.is_set or
                                self.bfd_out_ifh.is_set or
                                self.bfd_tun_ifh.is_set or
                                self.bfd_up.is_set or
                                self.entry_exists.is_set or
                                self.fault_ais.is_set or
                                self.fault_ldi.is_set or
                                self.fault_ldi_lockout.is_set or
                                self.fault_lkr.is_set or
                                self.fault_time.is_set or
                                self.in_label.is_set or
                                self.oam_created.is_set or
                                (self.flex_fec is not None and self.flex_fec.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.bfd_created.yfilter != YFilter.not_set or
                                self.bfd_egress_label.yfilter != YFilter.not_set or
                                self.bfd_int_label.yfilter != YFilter.not_set or
                                self.bfd_next_hop.yfilter != YFilter.not_set or
                                self.bfd_out_ifh.yfilter != YFilter.not_set or
                                self.bfd_tun_ifh.yfilter != YFilter.not_set or
                                self.bfd_up.yfilter != YFilter.not_set or
                                self.entry_exists.yfilter != YFilter.not_set or
                                self.fault_ais.yfilter != YFilter.not_set or
                                self.fault_ldi.yfilter != YFilter.not_set or
                                self.fault_ldi_lockout.yfilter != YFilter.not_set or
                                self.fault_lkr.yfilter != YFilter.not_set or
                                self.fault_time.yfilter != YFilter.not_set or
                                self.in_label.yfilter != YFilter.not_set or
                                self.oam_created.yfilter != YFilter.not_set or
                                (self.flex_fec is not None and self.flex_fec.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "flex-info" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/working-lsp/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.bfd_created.is_set or self.bfd_created.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bfd_created.get_name_leafdata())
                            if (self.bfd_egress_label.is_set or self.bfd_egress_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bfd_egress_label.get_name_leafdata())
                            if (self.bfd_int_label.is_set or self.bfd_int_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bfd_int_label.get_name_leafdata())
                            if (self.bfd_next_hop.is_set or self.bfd_next_hop.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bfd_next_hop.get_name_leafdata())
                            if (self.bfd_out_ifh.is_set or self.bfd_out_ifh.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bfd_out_ifh.get_name_leafdata())
                            if (self.bfd_tun_ifh.is_set or self.bfd_tun_ifh.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bfd_tun_ifh.get_name_leafdata())
                            if (self.bfd_up.is_set or self.bfd_up.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bfd_up.get_name_leafdata())
                            if (self.entry_exists.is_set or self.entry_exists.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.entry_exists.get_name_leafdata())
                            if (self.fault_ais.is_set or self.fault_ais.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fault_ais.get_name_leafdata())
                            if (self.fault_ldi.is_set or self.fault_ldi.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fault_ldi.get_name_leafdata())
                            if (self.fault_ldi_lockout.is_set or self.fault_ldi_lockout.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fault_ldi_lockout.get_name_leafdata())
                            if (self.fault_lkr.is_set or self.fault_lkr.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fault_lkr.get_name_leafdata())
                            if (self.fault_time.is_set or self.fault_time.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fault_time.get_name_leafdata())
                            if (self.in_label.is_set or self.in_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.in_label.get_name_leafdata())
                            if (self.oam_created.is_set or self.oam_created.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.oam_created.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "flex-fec"):
                                if (self.flex_fec is None):
                                    self.flex_fec = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.FlexInfo.FlexFec()
                                    self.flex_fec.parent = self
                                    self._children_name_map["flex_fec"] = "flex-fec"
                                return self.flex_fec

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "flex-fec" or name == "bfd-created" or name == "bfd-egress-label" or name == "bfd-int-label" or name == "bfd-next-hop" or name == "bfd-out-ifh" or name == "bfd-tun-ifh" or name == "bfd-up" or name == "entry-exists" or name == "fault-ais" or name == "fault-ldi" or name == "fault-ldi-lockout" or name == "fault-lkr" or name == "fault-time" or name == "in-label" or name == "oam-created"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "bfd-created"):
                                self.bfd_created = value
                                self.bfd_created.value_namespace = name_space
                                self.bfd_created.value_namespace_prefix = name_space_prefix
                            if(value_path == "bfd-egress-label"):
                                self.bfd_egress_label = value
                                self.bfd_egress_label.value_namespace = name_space
                                self.bfd_egress_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "bfd-int-label"):
                                self.bfd_int_label = value
                                self.bfd_int_label.value_namespace = name_space
                                self.bfd_int_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "bfd-next-hop"):
                                self.bfd_next_hop = value
                                self.bfd_next_hop.value_namespace = name_space
                                self.bfd_next_hop.value_namespace_prefix = name_space_prefix
                            if(value_path == "bfd-out-ifh"):
                                self.bfd_out_ifh = value
                                self.bfd_out_ifh.value_namespace = name_space
                                self.bfd_out_ifh.value_namespace_prefix = name_space_prefix
                            if(value_path == "bfd-tun-ifh"):
                                self.bfd_tun_ifh = value
                                self.bfd_tun_ifh.value_namespace = name_space
                                self.bfd_tun_ifh.value_namespace_prefix = name_space_prefix
                            if(value_path == "bfd-up"):
                                self.bfd_up = value
                                self.bfd_up.value_namespace = name_space
                                self.bfd_up.value_namespace_prefix = name_space_prefix
                            if(value_path == "entry-exists"):
                                self.entry_exists = value
                                self.entry_exists.value_namespace = name_space
                                self.entry_exists.value_namespace_prefix = name_space_prefix
                            if(value_path == "fault-ais"):
                                self.fault_ais = value
                                self.fault_ais.value_namespace = name_space
                                self.fault_ais.value_namespace_prefix = name_space_prefix
                            if(value_path == "fault-ldi"):
                                self.fault_ldi = value
                                self.fault_ldi.value_namespace = name_space
                                self.fault_ldi.value_namespace_prefix = name_space_prefix
                            if(value_path == "fault-ldi-lockout"):
                                self.fault_ldi_lockout = value
                                self.fault_ldi_lockout.value_namespace = name_space
                                self.fault_ldi_lockout.value_namespace_prefix = name_space_prefix
                            if(value_path == "fault-lkr"):
                                self.fault_lkr = value
                                self.fault_lkr.value_namespace = name_space
                                self.fault_lkr.value_namespace_prefix = name_space_prefix
                            if(value_path == "fault-time"):
                                self.fault_time = value
                                self.fault_time.value_namespace = name_space
                                self.fault_time.value_namespace_prefix = name_space_prefix
                            if(value_path == "in-label"):
                                self.in_label = value
                                self.in_label.value_namespace = name_space
                                self.in_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "oam-created"):
                                self.oam_created = value
                                self.oam_created.value_namespace = name_space
                                self.oam_created.value_namespace_prefix = name_space_prefix


                    class Association(Entity):
                        """
                        Association Object
                        
                        .. attribute:: s2l_association_id
                        
                        	S2L Association ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: s2l_association_source
                        
                        	S2L Association Source
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: s2l_association_tie_role
                        
                        	S2L Association Tie Role
                        	**type**\:   :py:class:`TeAssociationTieRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAssociationTieRole>`
                        
                        .. attribute:: s2l_association_type
                        
                        	S2L Association Type                          (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: s2l_extended_id
                        
                        	S2L Extended ID Array
                        	**type**\: list of    :py:class:`S2LExtendedId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.Association.S2LExtendedId>`
                        
                        .. attribute:: s2l_global_source
                        
                        	S2L Global Source
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.Association, self).__init__()

                            self.yang_name = "association"
                            self.yang_parent_name = "working-lsp"

                            self.s2l_association_id = YLeaf(YType.uint16, "s2l-association-id")

                            self.s2l_association_source = YLeaf(YType.str, "s2l-association-source")

                            self.s2l_association_tie_role = YLeaf(YType.enumeration, "s2l-association-tie-role")

                            self.s2l_association_type = YLeaf(YType.uint16, "s2l-association-type")

                            self.s2l_global_source = YLeaf(YType.uint32, "s2l-global-source")

                            self.s2l_extended_id = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("s2l_association_id",
                                            "s2l_association_source",
                                            "s2l_association_tie_role",
                                            "s2l_association_type",
                                            "s2l_global_source") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.Association, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.Association, self).__setattr__(name, value)


                        class S2LExtendedId(Entity):
                            """
                            S2L Extended ID Array
                            
                            .. attribute:: entry
                            
                            	
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.Association.S2LExtendedId, self).__init__()

                                self.yang_name = "s2l-extended-id"
                                self.yang_parent_name = "association"

                                self.entry = YLeaf(YType.uint32, "entry")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("entry") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.Association.S2LExtendedId, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.Association.S2LExtendedId, self).__setattr__(name, value)

                            def has_data(self):
                                return self.entry.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.entry.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-extended-id" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/working-lsp/association/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "entry"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "entry"):
                                    self.entry = value
                                    self.entry.value_namespace = name_space
                                    self.entry.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.s2l_extended_id:
                                if (c.has_data()):
                                    return True
                            return (
                                self.s2l_association_id.is_set or
                                self.s2l_association_source.is_set or
                                self.s2l_association_tie_role.is_set or
                                self.s2l_association_type.is_set or
                                self.s2l_global_source.is_set)

                        def has_operation(self):
                            for c in self.s2l_extended_id:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.s2l_association_id.yfilter != YFilter.not_set or
                                self.s2l_association_source.yfilter != YFilter.not_set or
                                self.s2l_association_tie_role.yfilter != YFilter.not_set or
                                self.s2l_association_type.yfilter != YFilter.not_set or
                                self.s2l_global_source.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "association" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/working-lsp/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.s2l_association_id.is_set or self.s2l_association_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_association_id.get_name_leafdata())
                            if (self.s2l_association_source.is_set or self.s2l_association_source.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_association_source.get_name_leafdata())
                            if (self.s2l_association_tie_role.is_set or self.s2l_association_tie_role.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_association_tie_role.get_name_leafdata())
                            if (self.s2l_association_type.is_set or self.s2l_association_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_association_type.get_name_leafdata())
                            if (self.s2l_global_source.is_set or self.s2l_global_source.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_global_source.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "s2l-extended-id"):
                                for c in self.s2l_extended_id:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.Association.S2LExtendedId()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.s2l_extended_id.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "s2l-extended-id" or name == "s2l-association-id" or name == "s2l-association-source" or name == "s2l-association-tie-role" or name == "s2l-association-type" or name == "s2l-global-source"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "s2l-association-id"):
                                self.s2l_association_id = value
                                self.s2l_association_id.value_namespace = name_space
                                self.s2l_association_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-association-source"):
                                self.s2l_association_source = value
                                self.s2l_association_source.value_namespace = name_space
                                self.s2l_association_source.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-association-tie-role"):
                                self.s2l_association_tie_role = value
                                self.s2l_association_tie_role.value_namespace = name_space
                                self.s2l_association_tie_role.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-association-type"):
                                self.s2l_association_type = value
                                self.s2l_association_type.value_namespace = name_space
                                self.s2l_association_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-global-source"):
                                self.s2l_global_source = value
                                self.s2l_global_source.value_namespace = name_space
                                self.s2l_global_source.value_namespace_prefix = name_space_prefix


                    class Protection(Entity):
                        """
                        Protection Object
                        
                        .. attribute:: any
                        
                        	Any
                        	**type**\:  bool
                        
                        .. attribute:: ded1_plus1
                        
                        	Dedicated 1+1 Protection
                        	**type**\:  bool
                        
                        .. attribute:: ded1_to1
                        
                        	Dedicated 1\:1 Protection
                        	**type**\:  bool
                        
                        .. attribute:: enhanced
                        
                        	Indicates Enhanced Protection Scheme
                        	**type**\:  bool
                        
                        .. attribute:: extra_traffic
                        
                        	LSP should use Links that are protecting other (primary) traffic
                        	**type**\:  bool
                        
                        .. attribute:: link_unprotected
                        
                        	LSP should not use any Link Layer Protection
                        	**type**\:  bool
                        
                        .. attribute:: lsp_unprotected
                        
                        	LSP Flags Unprotected
                        	**type**\:  bool
                        
                        .. attribute:: one_plus_one_bi
                        
                        	1+1 Bidirectional Protection
                        	**type**\:  bool
                        
                        .. attribute:: one_plus_one_uni
                        
                        	1+1 Unidirectional Protection
                        	**type**\:  bool
                        
                        .. attribute:: one_to_n_protection_et
                        
                        	1\:N Protection with Extra\-Traffic
                        	**type**\:  bool
                        
                        .. attribute:: rerouting
                        
                        	Full Rerouting
                        	**type**\:  bool
                        
                        .. attribute:: rerouting_no_et
                        
                        	Rerouting Without Extra\-Traffic
                        	**type**\:  bool
                        
                        .. attribute:: s2l_notification
                        
                        	 S2L Protection Notification Bit
                        	**type**\:  bool
                        
                        .. attribute:: s2l_operational
                        
                        	 S2L Protection Operational Bit
                        	**type**\:  bool
                        
                        .. attribute:: s2l_protecting
                        
                        	 S2L Protection Protecting Bit
                        	**type**\:  bool
                        
                        .. attribute:: s2l_secondary
                        
                        	 S2L Protection Secondary Bit
                        	**type**\:  bool
                        
                        .. attribute:: shared
                        
                        	Shared Link Layer Protection
                        	**type**\:  bool
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.Protection, self).__init__()

                            self.yang_name = "protection"
                            self.yang_parent_name = "working-lsp"

                            self.any = YLeaf(YType.boolean, "any")

                            self.ded1_plus1 = YLeaf(YType.boolean, "ded1-plus1")

                            self.ded1_to1 = YLeaf(YType.boolean, "ded1-to1")

                            self.enhanced = YLeaf(YType.boolean, "enhanced")

                            self.extra_traffic = YLeaf(YType.boolean, "extra-traffic")

                            self.link_unprotected = YLeaf(YType.boolean, "link-unprotected")

                            self.lsp_unprotected = YLeaf(YType.boolean, "lsp-unprotected")

                            self.one_plus_one_bi = YLeaf(YType.boolean, "one-plus-one-bi")

                            self.one_plus_one_uni = YLeaf(YType.boolean, "one-plus-one-uni")

                            self.one_to_n_protection_et = YLeaf(YType.boolean, "one-to-n-protection-et")

                            self.rerouting = YLeaf(YType.boolean, "rerouting")

                            self.rerouting_no_et = YLeaf(YType.boolean, "rerouting-no-et")

                            self.s2l_notification = YLeaf(YType.boolean, "s2l-notification")

                            self.s2l_operational = YLeaf(YType.boolean, "s2l-operational")

                            self.s2l_protecting = YLeaf(YType.boolean, "s2l-protecting")

                            self.s2l_secondary = YLeaf(YType.boolean, "s2l-secondary")

                            self.shared = YLeaf(YType.boolean, "shared")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("any",
                                            "ded1_plus1",
                                            "ded1_to1",
                                            "enhanced",
                                            "extra_traffic",
                                            "link_unprotected",
                                            "lsp_unprotected",
                                            "one_plus_one_bi",
                                            "one_plus_one_uni",
                                            "one_to_n_protection_et",
                                            "rerouting",
                                            "rerouting_no_et",
                                            "s2l_notification",
                                            "s2l_operational",
                                            "s2l_protecting",
                                            "s2l_secondary",
                                            "shared") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.Protection, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.Protection, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.any.is_set or
                                self.ded1_plus1.is_set or
                                self.ded1_to1.is_set or
                                self.enhanced.is_set or
                                self.extra_traffic.is_set or
                                self.link_unprotected.is_set or
                                self.lsp_unprotected.is_set or
                                self.one_plus_one_bi.is_set or
                                self.one_plus_one_uni.is_set or
                                self.one_to_n_protection_et.is_set or
                                self.rerouting.is_set or
                                self.rerouting_no_et.is_set or
                                self.s2l_notification.is_set or
                                self.s2l_operational.is_set or
                                self.s2l_protecting.is_set or
                                self.s2l_secondary.is_set or
                                self.shared.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.any.yfilter != YFilter.not_set or
                                self.ded1_plus1.yfilter != YFilter.not_set or
                                self.ded1_to1.yfilter != YFilter.not_set or
                                self.enhanced.yfilter != YFilter.not_set or
                                self.extra_traffic.yfilter != YFilter.not_set or
                                self.link_unprotected.yfilter != YFilter.not_set or
                                self.lsp_unprotected.yfilter != YFilter.not_set or
                                self.one_plus_one_bi.yfilter != YFilter.not_set or
                                self.one_plus_one_uni.yfilter != YFilter.not_set or
                                self.one_to_n_protection_et.yfilter != YFilter.not_set or
                                self.rerouting.yfilter != YFilter.not_set or
                                self.rerouting_no_et.yfilter != YFilter.not_set or
                                self.s2l_notification.yfilter != YFilter.not_set or
                                self.s2l_operational.yfilter != YFilter.not_set or
                                self.s2l_protecting.yfilter != YFilter.not_set or
                                self.s2l_secondary.yfilter != YFilter.not_set or
                                self.shared.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "protection" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/working-lsp/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.any.is_set or self.any.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.any.get_name_leafdata())
                            if (self.ded1_plus1.is_set or self.ded1_plus1.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ded1_plus1.get_name_leafdata())
                            if (self.ded1_to1.is_set or self.ded1_to1.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ded1_to1.get_name_leafdata())
                            if (self.enhanced.is_set or self.enhanced.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.enhanced.get_name_leafdata())
                            if (self.extra_traffic.is_set or self.extra_traffic.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.extra_traffic.get_name_leafdata())
                            if (self.link_unprotected.is_set or self.link_unprotected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.link_unprotected.get_name_leafdata())
                            if (self.lsp_unprotected.is_set or self.lsp_unprotected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsp_unprotected.get_name_leafdata())
                            if (self.one_plus_one_bi.is_set or self.one_plus_one_bi.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.one_plus_one_bi.get_name_leafdata())
                            if (self.one_plus_one_uni.is_set or self.one_plus_one_uni.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.one_plus_one_uni.get_name_leafdata())
                            if (self.one_to_n_protection_et.is_set or self.one_to_n_protection_et.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.one_to_n_protection_et.get_name_leafdata())
                            if (self.rerouting.is_set or self.rerouting.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rerouting.get_name_leafdata())
                            if (self.rerouting_no_et.is_set or self.rerouting_no_et.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rerouting_no_et.get_name_leafdata())
                            if (self.s2l_notification.is_set or self.s2l_notification.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_notification.get_name_leafdata())
                            if (self.s2l_operational.is_set or self.s2l_operational.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_operational.get_name_leafdata())
                            if (self.s2l_protecting.is_set or self.s2l_protecting.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_protecting.get_name_leafdata())
                            if (self.s2l_secondary.is_set or self.s2l_secondary.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_secondary.get_name_leafdata())
                            if (self.shared.is_set or self.shared.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.shared.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "any" or name == "ded1-plus1" or name == "ded1-to1" or name == "enhanced" or name == "extra-traffic" or name == "link-unprotected" or name == "lsp-unprotected" or name == "one-plus-one-bi" or name == "one-plus-one-uni" or name == "one-to-n-protection-et" or name == "rerouting" or name == "rerouting-no-et" or name == "s2l-notification" or name == "s2l-operational" or name == "s2l-protecting" or name == "s2l-secondary" or name == "shared"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "any"):
                                self.any = value
                                self.any.value_namespace = name_space
                                self.any.value_namespace_prefix = name_space_prefix
                            if(value_path == "ded1-plus1"):
                                self.ded1_plus1 = value
                                self.ded1_plus1.value_namespace = name_space
                                self.ded1_plus1.value_namespace_prefix = name_space_prefix
                            if(value_path == "ded1-to1"):
                                self.ded1_to1 = value
                                self.ded1_to1.value_namespace = name_space
                                self.ded1_to1.value_namespace_prefix = name_space_prefix
                            if(value_path == "enhanced"):
                                self.enhanced = value
                                self.enhanced.value_namespace = name_space
                                self.enhanced.value_namespace_prefix = name_space_prefix
                            if(value_path == "extra-traffic"):
                                self.extra_traffic = value
                                self.extra_traffic.value_namespace = name_space
                                self.extra_traffic.value_namespace_prefix = name_space_prefix
                            if(value_path == "link-unprotected"):
                                self.link_unprotected = value
                                self.link_unprotected.value_namespace = name_space
                                self.link_unprotected.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsp-unprotected"):
                                self.lsp_unprotected = value
                                self.lsp_unprotected.value_namespace = name_space
                                self.lsp_unprotected.value_namespace_prefix = name_space_prefix
                            if(value_path == "one-plus-one-bi"):
                                self.one_plus_one_bi = value
                                self.one_plus_one_bi.value_namespace = name_space
                                self.one_plus_one_bi.value_namespace_prefix = name_space_prefix
                            if(value_path == "one-plus-one-uni"):
                                self.one_plus_one_uni = value
                                self.one_plus_one_uni.value_namespace = name_space
                                self.one_plus_one_uni.value_namespace_prefix = name_space_prefix
                            if(value_path == "one-to-n-protection-et"):
                                self.one_to_n_protection_et = value
                                self.one_to_n_protection_et.value_namespace = name_space
                                self.one_to_n_protection_et.value_namespace_prefix = name_space_prefix
                            if(value_path == "rerouting"):
                                self.rerouting = value
                                self.rerouting.value_namespace = name_space
                                self.rerouting.value_namespace_prefix = name_space_prefix
                            if(value_path == "rerouting-no-et"):
                                self.rerouting_no_et = value
                                self.rerouting_no_et.value_namespace = name_space
                                self.rerouting_no_et.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-notification"):
                                self.s2l_notification = value
                                self.s2l_notification.value_namespace = name_space
                                self.s2l_notification.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-operational"):
                                self.s2l_operational = value
                                self.s2l_operational.value_namespace = name_space
                                self.s2l_operational.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-protecting"):
                                self.s2l_protecting = value
                                self.s2l_protecting.value_namespace = name_space
                                self.s2l_protecting.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-secondary"):
                                self.s2l_secondary = value
                                self.s2l_secondary.value_namespace = name_space
                                self.s2l_secondary.value_namespace_prefix = name_space_prefix
                            if(value_path == "shared"):
                                self.shared = value
                                self.shared.value_namespace = name_space
                                self.shared.value_namespace_prefix = name_space_prefix


                    class ReverseLsp(Entity):
                        """
                        Reverse LSP information
                        
                        .. attribute:: association
                        
                        	Association Object
                        	**type**\:   :py:class:`Association <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.Association>`
                        
                        .. attribute:: protection
                        
                        	Protection Object
                        	**type**\:   :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.Protection>`
                        
                        .. attribute:: reverse_lsp_connected
                        
                        	Reverse Associated Bidir LSP Connected
                        	**type**\:  bool
                        
                        .. attribute:: reverse_lsp_fec
                        
                        	Reverse Associated Bidir LSP FEC
                        	**type**\:   :py:class:`ReverseLspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.ReverseLspFec>`
                        
                        .. attribute:: reverse_lsp_present
                        
                        	Reverse Associated Bidir LSP Present
                        	**type**\:  bool
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp, self).__init__()

                            self.yang_name = "reverse-lsp"
                            self.yang_parent_name = "working-lsp"

                            self.reverse_lsp_connected = YLeaf(YType.boolean, "reverse-lsp-connected")

                            self.reverse_lsp_present = YLeaf(YType.boolean, "reverse-lsp-present")

                            self.association = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.Association()
                            self.association.parent = self
                            self._children_name_map["association"] = "association"
                            self._children_yang_names.add("association")

                            self.protection = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.Protection()
                            self.protection.parent = self
                            self._children_name_map["protection"] = "protection"
                            self._children_yang_names.add("protection")

                            self.reverse_lsp_fec = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.ReverseLspFec()
                            self.reverse_lsp_fec.parent = self
                            self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"
                            self._children_yang_names.add("reverse-lsp-fec")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("reverse_lsp_connected",
                                            "reverse_lsp_present") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp, self).__setattr__(name, value)


                        class ReverseLspFec(Entity):
                            """
                            Reverse Associated Bidir LSP FEC
                            
                            .. attribute:: fec_destination_info
                            
                            	Destination or P2MP ID
                            	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.ReverseLspFec.FecDestinationInfo>`
                            
                            .. attribute:: fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: fec_lsp_id
                            
                            	LSP ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: fec_source
                            
                            	Tunnel source address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.ReverseLspFec, self).__init__()

                                self.yang_name = "reverse-lsp-fec"
                                self.yang_parent_name = "reverse-lsp"

                                self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                self.fec_source = YLeaf(YType.str, "fec-source")

                                self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                self.fec_destination_info = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.ReverseLspFec.FecDestinationInfo()
                                self.fec_destination_info.parent = self
                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                self._children_yang_names.add("fec-destination-info")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fec_extended_tunnel_id",
                                                "fec_lsp_id",
                                                "fec_source",
                                                "fec_tunnel_id",
                                                "fec_vrf") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.ReverseLspFec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.ReverseLspFec, self).__setattr__(name, value)


                            class FecDestinationInfo(Entity):
                                """
                                Destination or P2MP ID
                                
                                .. attribute:: fec_ctype
                                
                                	FEC CType
                                	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                .. attribute:: fec_destination_p2mp_id
                                
                                	P2MP ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: p2p_lsp_destination
                                
                                	P2P LSP destination
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.ReverseLspFec.FecDestinationInfo, self).__init__()

                                    self.yang_name = "fec-destination-info"
                                    self.yang_parent_name = "reverse-lsp-fec"

                                    self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                    self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                    self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("fec_ctype",
                                                    "fec_destination_p2mp_id",
                                                    "p2p_lsp_destination") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.ReverseLspFec.FecDestinationInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.ReverseLspFec.FecDestinationInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.fec_ctype.is_set or
                                        self.fec_destination_p2mp_id.is_set or
                                        self.p2p_lsp_destination.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.fec_ctype.yfilter != YFilter.not_set or
                                        self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                        self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "fec-destination-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/working-lsp/reverse-lsp/reverse-lsp-fec/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                    if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                    if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "fec-ctype"):
                                        self.fec_ctype = value
                                        self.fec_ctype.value_namespace = name_space
                                        self.fec_ctype.value_namespace_prefix = name_space_prefix
                                    if(value_path == "fec-destination-p2mp-id"):
                                        self.fec_destination_p2mp_id = value
                                        self.fec_destination_p2mp_id.value_namespace = name_space
                                        self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "p2p-lsp-destination"):
                                        self.p2p_lsp_destination = value
                                        self.p2p_lsp_destination.value_namespace = name_space
                                        self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.fec_extended_tunnel_id.is_set or
                                    self.fec_lsp_id.is_set or
                                    self.fec_source.is_set or
                                    self.fec_tunnel_id.is_set or
                                    self.fec_vrf.is_set or
                                    (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                    self.fec_lsp_id.yfilter != YFilter.not_set or
                                    self.fec_source.yfilter != YFilter.not_set or
                                    self.fec_tunnel_id.yfilter != YFilter.not_set or
                                    self.fec_vrf.yfilter != YFilter.not_set or
                                    (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-lsp-fec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/working-lsp/reverse-lsp/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_source.get_name_leafdata())
                                if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "fec-destination-info"):
                                    if (self.fec_destination_info is None):
                                        self.fec_destination_info = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.ReverseLspFec.FecDestinationInfo()
                                        self.fec_destination_info.parent = self
                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                    return self.fec_destination_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fec-extended-tunnel-id"):
                                    self.fec_extended_tunnel_id = value
                                    self.fec_extended_tunnel_id.value_namespace = name_space
                                    self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-lsp-id"):
                                    self.fec_lsp_id = value
                                    self.fec_lsp_id.value_namespace = name_space
                                    self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-source"):
                                    self.fec_source = value
                                    self.fec_source.value_namespace = name_space
                                    self.fec_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-tunnel-id"):
                                    self.fec_tunnel_id = value
                                    self.fec_tunnel_id.value_namespace = name_space
                                    self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-vrf"):
                                    self.fec_vrf = value
                                    self.fec_vrf.value_namespace = name_space
                                    self.fec_vrf.value_namespace_prefix = name_space_prefix


                        class Association(Entity):
                            """
                            Association Object
                            
                            .. attribute:: s2l_association_id
                            
                            	S2L Association ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_association_source
                            
                            	S2L Association Source
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_association_tie_role
                            
                            	S2L Association Tie Role
                            	**type**\:   :py:class:`TeAssociationTieRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAssociationTieRole>`
                            
                            .. attribute:: s2l_association_type
                            
                            	S2L Association Type                          (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_extended_id
                            
                            	S2L Extended ID Array
                            	**type**\: list of    :py:class:`S2LExtendedId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.Association.S2LExtendedId>`
                            
                            .. attribute:: s2l_global_source
                            
                            	S2L Global Source
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.Association, self).__init__()

                                self.yang_name = "association"
                                self.yang_parent_name = "reverse-lsp"

                                self.s2l_association_id = YLeaf(YType.uint16, "s2l-association-id")

                                self.s2l_association_source = YLeaf(YType.str, "s2l-association-source")

                                self.s2l_association_tie_role = YLeaf(YType.enumeration, "s2l-association-tie-role")

                                self.s2l_association_type = YLeaf(YType.uint16, "s2l-association-type")

                                self.s2l_global_source = YLeaf(YType.uint32, "s2l-global-source")

                                self.s2l_extended_id = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("s2l_association_id",
                                                "s2l_association_source",
                                                "s2l_association_tie_role",
                                                "s2l_association_type",
                                                "s2l_global_source") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.Association, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.Association, self).__setattr__(name, value)


                            class S2LExtendedId(Entity):
                                """
                                S2L Extended ID Array
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.Association.S2LExtendedId, self).__init__()

                                    self.yang_name = "s2l-extended-id"
                                    self.yang_parent_name = "association"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.Association.S2LExtendedId, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.Association.S2LExtendedId, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "s2l-extended-id" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/working-lsp/reverse-lsp/association/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.s2l_extended_id:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.s2l_association_id.is_set or
                                    self.s2l_association_source.is_set or
                                    self.s2l_association_tie_role.is_set or
                                    self.s2l_association_type.is_set or
                                    self.s2l_global_source.is_set)

                            def has_operation(self):
                                for c in self.s2l_extended_id:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.s2l_association_id.yfilter != YFilter.not_set or
                                    self.s2l_association_source.yfilter != YFilter.not_set or
                                    self.s2l_association_tie_role.yfilter != YFilter.not_set or
                                    self.s2l_association_type.yfilter != YFilter.not_set or
                                    self.s2l_global_source.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "association" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/working-lsp/reverse-lsp/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.s2l_association_id.is_set or self.s2l_association_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_id.get_name_leafdata())
                                if (self.s2l_association_source.is_set or self.s2l_association_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_source.get_name_leafdata())
                                if (self.s2l_association_tie_role.is_set or self.s2l_association_tie_role.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_tie_role.get_name_leafdata())
                                if (self.s2l_association_type.is_set or self.s2l_association_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_type.get_name_leafdata())
                                if (self.s2l_global_source.is_set or self.s2l_global_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_global_source.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "s2l-extended-id"):
                                    for c in self.s2l_extended_id:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.Association.S2LExtendedId()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.s2l_extended_id.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "s2l-extended-id" or name == "s2l-association-id" or name == "s2l-association-source" or name == "s2l-association-tie-role" or name == "s2l-association-type" or name == "s2l-global-source"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "s2l-association-id"):
                                    self.s2l_association_id = value
                                    self.s2l_association_id.value_namespace = name_space
                                    self.s2l_association_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-source"):
                                    self.s2l_association_source = value
                                    self.s2l_association_source.value_namespace = name_space
                                    self.s2l_association_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-tie-role"):
                                    self.s2l_association_tie_role = value
                                    self.s2l_association_tie_role.value_namespace = name_space
                                    self.s2l_association_tie_role.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-type"):
                                    self.s2l_association_type = value
                                    self.s2l_association_type.value_namespace = name_space
                                    self.s2l_association_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-global-source"):
                                    self.s2l_global_source = value
                                    self.s2l_global_source.value_namespace = name_space
                                    self.s2l_global_source.value_namespace_prefix = name_space_prefix


                        class Protection(Entity):
                            """
                            Protection Object
                            
                            .. attribute:: any
                            
                            	Any
                            	**type**\:  bool
                            
                            .. attribute:: ded1_plus1
                            
                            	Dedicated 1+1 Protection
                            	**type**\:  bool
                            
                            .. attribute:: ded1_to1
                            
                            	Dedicated 1\:1 Protection
                            	**type**\:  bool
                            
                            .. attribute:: enhanced
                            
                            	Indicates Enhanced Protection Scheme
                            	**type**\:  bool
                            
                            .. attribute:: extra_traffic
                            
                            	LSP should use Links that are protecting other (primary) traffic
                            	**type**\:  bool
                            
                            .. attribute:: link_unprotected
                            
                            	LSP should not use any Link Layer Protection
                            	**type**\:  bool
                            
                            .. attribute:: lsp_unprotected
                            
                            	LSP Flags Unprotected
                            	**type**\:  bool
                            
                            .. attribute:: one_plus_one_bi
                            
                            	1+1 Bidirectional Protection
                            	**type**\:  bool
                            
                            .. attribute:: one_plus_one_uni
                            
                            	1+1 Unidirectional Protection
                            	**type**\:  bool
                            
                            .. attribute:: one_to_n_protection_et
                            
                            	1\:N Protection with Extra\-Traffic
                            	**type**\:  bool
                            
                            .. attribute:: rerouting
                            
                            	Full Rerouting
                            	**type**\:  bool
                            
                            .. attribute:: rerouting_no_et
                            
                            	Rerouting Without Extra\-Traffic
                            	**type**\:  bool
                            
                            .. attribute:: s2l_notification
                            
                            	 S2L Protection Notification Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_operational
                            
                            	 S2L Protection Operational Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_protecting
                            
                            	 S2L Protection Protecting Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_secondary
                            
                            	 S2L Protection Secondary Bit
                            	**type**\:  bool
                            
                            .. attribute:: shared
                            
                            	Shared Link Layer Protection
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.Protection, self).__init__()

                                self.yang_name = "protection"
                                self.yang_parent_name = "reverse-lsp"

                                self.any = YLeaf(YType.boolean, "any")

                                self.ded1_plus1 = YLeaf(YType.boolean, "ded1-plus1")

                                self.ded1_to1 = YLeaf(YType.boolean, "ded1-to1")

                                self.enhanced = YLeaf(YType.boolean, "enhanced")

                                self.extra_traffic = YLeaf(YType.boolean, "extra-traffic")

                                self.link_unprotected = YLeaf(YType.boolean, "link-unprotected")

                                self.lsp_unprotected = YLeaf(YType.boolean, "lsp-unprotected")

                                self.one_plus_one_bi = YLeaf(YType.boolean, "one-plus-one-bi")

                                self.one_plus_one_uni = YLeaf(YType.boolean, "one-plus-one-uni")

                                self.one_to_n_protection_et = YLeaf(YType.boolean, "one-to-n-protection-et")

                                self.rerouting = YLeaf(YType.boolean, "rerouting")

                                self.rerouting_no_et = YLeaf(YType.boolean, "rerouting-no-et")

                                self.s2l_notification = YLeaf(YType.boolean, "s2l-notification")

                                self.s2l_operational = YLeaf(YType.boolean, "s2l-operational")

                                self.s2l_protecting = YLeaf(YType.boolean, "s2l-protecting")

                                self.s2l_secondary = YLeaf(YType.boolean, "s2l-secondary")

                                self.shared = YLeaf(YType.boolean, "shared")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("any",
                                                "ded1_plus1",
                                                "ded1_to1",
                                                "enhanced",
                                                "extra_traffic",
                                                "link_unprotected",
                                                "lsp_unprotected",
                                                "one_plus_one_bi",
                                                "one_plus_one_uni",
                                                "one_to_n_protection_et",
                                                "rerouting",
                                                "rerouting_no_et",
                                                "s2l_notification",
                                                "s2l_operational",
                                                "s2l_protecting",
                                                "s2l_secondary",
                                                "shared") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.Protection, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.Protection, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.any.is_set or
                                    self.ded1_plus1.is_set or
                                    self.ded1_to1.is_set or
                                    self.enhanced.is_set or
                                    self.extra_traffic.is_set or
                                    self.link_unprotected.is_set or
                                    self.lsp_unprotected.is_set or
                                    self.one_plus_one_bi.is_set or
                                    self.one_plus_one_uni.is_set or
                                    self.one_to_n_protection_et.is_set or
                                    self.rerouting.is_set or
                                    self.rerouting_no_et.is_set or
                                    self.s2l_notification.is_set or
                                    self.s2l_operational.is_set or
                                    self.s2l_protecting.is_set or
                                    self.s2l_secondary.is_set or
                                    self.shared.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.any.yfilter != YFilter.not_set or
                                    self.ded1_plus1.yfilter != YFilter.not_set or
                                    self.ded1_to1.yfilter != YFilter.not_set or
                                    self.enhanced.yfilter != YFilter.not_set or
                                    self.extra_traffic.yfilter != YFilter.not_set or
                                    self.link_unprotected.yfilter != YFilter.not_set or
                                    self.lsp_unprotected.yfilter != YFilter.not_set or
                                    self.one_plus_one_bi.yfilter != YFilter.not_set or
                                    self.one_plus_one_uni.yfilter != YFilter.not_set or
                                    self.one_to_n_protection_et.yfilter != YFilter.not_set or
                                    self.rerouting.yfilter != YFilter.not_set or
                                    self.rerouting_no_et.yfilter != YFilter.not_set or
                                    self.s2l_notification.yfilter != YFilter.not_set or
                                    self.s2l_operational.yfilter != YFilter.not_set or
                                    self.s2l_protecting.yfilter != YFilter.not_set or
                                    self.s2l_secondary.yfilter != YFilter.not_set or
                                    self.shared.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "protection" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/working-lsp/reverse-lsp/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.any.is_set or self.any.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.any.get_name_leafdata())
                                if (self.ded1_plus1.is_set or self.ded1_plus1.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ded1_plus1.get_name_leafdata())
                                if (self.ded1_to1.is_set or self.ded1_to1.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ded1_to1.get_name_leafdata())
                                if (self.enhanced.is_set or self.enhanced.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.enhanced.get_name_leafdata())
                                if (self.extra_traffic.is_set or self.extra_traffic.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.extra_traffic.get_name_leafdata())
                                if (self.link_unprotected.is_set or self.link_unprotected.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.link_unprotected.get_name_leafdata())
                                if (self.lsp_unprotected.is_set or self.lsp_unprotected.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_unprotected.get_name_leafdata())
                                if (self.one_plus_one_bi.is_set or self.one_plus_one_bi.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_plus_one_bi.get_name_leafdata())
                                if (self.one_plus_one_uni.is_set or self.one_plus_one_uni.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_plus_one_uni.get_name_leafdata())
                                if (self.one_to_n_protection_et.is_set or self.one_to_n_protection_et.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_to_n_protection_et.get_name_leafdata())
                                if (self.rerouting.is_set or self.rerouting.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rerouting.get_name_leafdata())
                                if (self.rerouting_no_et.is_set or self.rerouting_no_et.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rerouting_no_et.get_name_leafdata())
                                if (self.s2l_notification.is_set or self.s2l_notification.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_notification.get_name_leafdata())
                                if (self.s2l_operational.is_set or self.s2l_operational.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_operational.get_name_leafdata())
                                if (self.s2l_protecting.is_set or self.s2l_protecting.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_protecting.get_name_leafdata())
                                if (self.s2l_secondary.is_set or self.s2l_secondary.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_secondary.get_name_leafdata())
                                if (self.shared.is_set or self.shared.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.shared.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "any" or name == "ded1-plus1" or name == "ded1-to1" or name == "enhanced" or name == "extra-traffic" or name == "link-unprotected" or name == "lsp-unprotected" or name == "one-plus-one-bi" or name == "one-plus-one-uni" or name == "one-to-n-protection-et" or name == "rerouting" or name == "rerouting-no-et" or name == "s2l-notification" or name == "s2l-operational" or name == "s2l-protecting" or name == "s2l-secondary" or name == "shared"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "any"):
                                    self.any = value
                                    self.any.value_namespace = name_space
                                    self.any.value_namespace_prefix = name_space_prefix
                                if(value_path == "ded1-plus1"):
                                    self.ded1_plus1 = value
                                    self.ded1_plus1.value_namespace = name_space
                                    self.ded1_plus1.value_namespace_prefix = name_space_prefix
                                if(value_path == "ded1-to1"):
                                    self.ded1_to1 = value
                                    self.ded1_to1.value_namespace = name_space
                                    self.ded1_to1.value_namespace_prefix = name_space_prefix
                                if(value_path == "enhanced"):
                                    self.enhanced = value
                                    self.enhanced.value_namespace = name_space
                                    self.enhanced.value_namespace_prefix = name_space_prefix
                                if(value_path == "extra-traffic"):
                                    self.extra_traffic = value
                                    self.extra_traffic.value_namespace = name_space
                                    self.extra_traffic.value_namespace_prefix = name_space_prefix
                                if(value_path == "link-unprotected"):
                                    self.link_unprotected = value
                                    self.link_unprotected.value_namespace = name_space
                                    self.link_unprotected.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-unprotected"):
                                    self.lsp_unprotected = value
                                    self.lsp_unprotected.value_namespace = name_space
                                    self.lsp_unprotected.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-plus-one-bi"):
                                    self.one_plus_one_bi = value
                                    self.one_plus_one_bi.value_namespace = name_space
                                    self.one_plus_one_bi.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-plus-one-uni"):
                                    self.one_plus_one_uni = value
                                    self.one_plus_one_uni.value_namespace = name_space
                                    self.one_plus_one_uni.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-to-n-protection-et"):
                                    self.one_to_n_protection_et = value
                                    self.one_to_n_protection_et.value_namespace = name_space
                                    self.one_to_n_protection_et.value_namespace_prefix = name_space_prefix
                                if(value_path == "rerouting"):
                                    self.rerouting = value
                                    self.rerouting.value_namespace = name_space
                                    self.rerouting.value_namespace_prefix = name_space_prefix
                                if(value_path == "rerouting-no-et"):
                                    self.rerouting_no_et = value
                                    self.rerouting_no_et.value_namespace = name_space
                                    self.rerouting_no_et.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-notification"):
                                    self.s2l_notification = value
                                    self.s2l_notification.value_namespace = name_space
                                    self.s2l_notification.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-operational"):
                                    self.s2l_operational = value
                                    self.s2l_operational.value_namespace = name_space
                                    self.s2l_operational.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-protecting"):
                                    self.s2l_protecting = value
                                    self.s2l_protecting.value_namespace = name_space
                                    self.s2l_protecting.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-secondary"):
                                    self.s2l_secondary = value
                                    self.s2l_secondary.value_namespace = name_space
                                    self.s2l_secondary.value_namespace_prefix = name_space_prefix
                                if(value_path == "shared"):
                                    self.shared = value
                                    self.shared.value_namespace = name_space
                                    self.shared.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.reverse_lsp_connected.is_set or
                                self.reverse_lsp_present.is_set or
                                (self.association is not None and self.association.has_data()) or
                                (self.protection is not None and self.protection.has_data()) or
                                (self.reverse_lsp_fec is not None and self.reverse_lsp_fec.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.reverse_lsp_connected.yfilter != YFilter.not_set or
                                self.reverse_lsp_present.yfilter != YFilter.not_set or
                                (self.association is not None and self.association.has_operation()) or
                                (self.protection is not None and self.protection.has_operation()) or
                                (self.reverse_lsp_fec is not None and self.reverse_lsp_fec.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "reverse-lsp" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/working-lsp/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.reverse_lsp_connected.is_set or self.reverse_lsp_connected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_connected.get_name_leafdata())
                            if (self.reverse_lsp_present.is_set or self.reverse_lsp_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_present.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "association"):
                                if (self.association is None):
                                    self.association = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.Association()
                                    self.association.parent = self
                                    self._children_name_map["association"] = "association"
                                return self.association

                            if (child_yang_name == "protection"):
                                if (self.protection is None):
                                    self.protection = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.Protection()
                                    self.protection.parent = self
                                    self._children_name_map["protection"] = "protection"
                                return self.protection

                            if (child_yang_name == "reverse-lsp-fec"):
                                if (self.reverse_lsp_fec is None):
                                    self.reverse_lsp_fec = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp.ReverseLspFec()
                                    self.reverse_lsp_fec.parent = self
                                    self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"
                                return self.reverse_lsp_fec

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "association" or name == "protection" or name == "reverse-lsp-fec" or name == "reverse-lsp-connected" or name == "reverse-lsp-present"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "reverse-lsp-connected"):
                                self.reverse_lsp_connected = value
                                self.reverse_lsp_connected.value_namespace = name_space
                                self.reverse_lsp_connected.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-present"):
                                self.reverse_lsp_present = value
                                self.reverse_lsp_present.value_namespace = name_space
                                self.reverse_lsp_present.value_namespace_prefix = name_space_prefix


                    class LspHop(Entity):
                        """
                        Path used by LSP
                        
                        .. attribute:: ero_type
                        
                        	EROType
                        	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                        
                        .. attribute:: ipv4ero_sub_object
                        
                        	IPV4 ERO Sub Object
                        	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.LspHop.Ipv4EroSubObject>`
                        
                        .. attribute:: unnumbered_ero_sub_object
                        
                        	Unnumbered ERO Sub Object
                        	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.LspHop.UnnumberedEroSubObject>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.LspHop, self).__init__()

                            self.yang_name = "lsp-hop"
                            self.yang_parent_name = "working-lsp"

                            self.ero_type = YLeaf(YType.enumeration, "ero-type")

                            self.ipv4ero_sub_object = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.LspHop.Ipv4EroSubObject()
                            self.ipv4ero_sub_object.parent = self
                            self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                            self._children_yang_names.add("ipv4ero-sub-object")

                            self.unnumbered_ero_sub_object = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.LspHop.UnnumberedEroSubObject()
                            self.unnumbered_ero_sub_object.parent = self
                            self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                            self._children_yang_names.add("unnumbered-ero-sub-object")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("ero_type") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.LspHop, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.LspHop, self).__setattr__(name, value)


                        class Ipv4EroSubObject(Entity):
                            """
                            IPV4 ERO Sub Object
                            
                            .. attribute:: ero_address
                            
                            	The ERO IPV4 Address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: is_strict_route
                            
                            	ERO Entry Is Strict
                            	**type**\:  bool
                            
                            .. attribute:: prefix_length
                            
                            	ERO Prefix Length
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.LspHop.Ipv4EroSubObject, self).__init__()

                                self.yang_name = "ipv4ero-sub-object"
                                self.yang_parent_name = "lsp-hop"

                                self.ero_address = YLeaf(YType.str, "ero-address")

                                self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_address",
                                                "is_strict_route",
                                                "prefix_length") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.LspHop.Ipv4EroSubObject, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.LspHop.Ipv4EroSubObject, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.ero_address.is_set or
                                    self.is_strict_route.is_set or
                                    self.prefix_length.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_address.yfilter != YFilter.not_set or
                                    self.is_strict_route.yfilter != YFilter.not_set or
                                    self.prefix_length.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ipv4ero-sub-object" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/working-lsp/lsp-hop/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_address.get_name_leafdata())
                                if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-address"):
                                    self.ero_address = value
                                    self.ero_address.value_namespace = name_space
                                    self.ero_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-strict-route"):
                                    self.is_strict_route = value
                                    self.is_strict_route.value_namespace = name_space
                                    self.is_strict_route.value_namespace_prefix = name_space_prefix
                                if(value_path == "prefix-length"):
                                    self.prefix_length = value
                                    self.prefix_length.value_namespace = name_space
                                    self.prefix_length.value_namespace_prefix = name_space_prefix


                        class UnnumberedEroSubObject(Entity):
                            """
                            Unnumbered ERO Sub Object
                            
                            .. attribute:: ero_interface_id
                            
                            	The Interface ID in ERO
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: ero_router_id
                            
                            	The Router ID in ERO
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: is_strict_route
                            
                            	ERO Entry Is Strict
                            	**type**\:  bool
                            
                            .. attribute:: status
                            
                            	Status of ERO
                            	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.LspHop.UnnumberedEroSubObject, self).__init__()

                                self.yang_name = "unnumbered-ero-sub-object"
                                self.yang_parent_name = "lsp-hop"

                                self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                self.status = YLeaf(YType.enumeration, "status")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_interface_id",
                                                "ero_router_id",
                                                "is_strict_route",
                                                "status") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.LspHop.UnnumberedEroSubObject, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.LspHop.UnnumberedEroSubObject, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.ero_interface_id.is_set or
                                    self.ero_router_id.is_set or
                                    self.is_strict_route.is_set or
                                    self.status.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_interface_id.yfilter != YFilter.not_set or
                                    self.ero_router_id.yfilter != YFilter.not_set or
                                    self.is_strict_route.yfilter != YFilter.not_set or
                                    self.status.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/working-lsp/lsp-hop/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.status.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-interface-id"):
                                    self.ero_interface_id = value
                                    self.ero_interface_id.value_namespace = name_space
                                    self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "ero-router-id"):
                                    self.ero_router_id = value
                                    self.ero_router_id.value_namespace = name_space
                                    self.ero_router_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-strict-route"):
                                    self.is_strict_route = value
                                    self.is_strict_route.value_namespace = name_space
                                    self.is_strict_route.value_namespace_prefix = name_space_prefix
                                if(value_path == "status"):
                                    self.status = value
                                    self.status.value_namespace = name_space
                                    self.status.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.ero_type.is_set or
                                (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.ero_type.yfilter != YFilter.not_set or
                                (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "lsp-hop" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/working-lsp/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ero_type.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "ipv4ero-sub-object"):
                                if (self.ipv4ero_sub_object is None):
                                    self.ipv4ero_sub_object = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.LspHop.Ipv4EroSubObject()
                                    self.ipv4ero_sub_object.parent = self
                                    self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                return self.ipv4ero_sub_object

                            if (child_yang_name == "unnumbered-ero-sub-object"):
                                if (self.unnumbered_ero_sub_object is None):
                                    self.unnumbered_ero_sub_object = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.LspHop.UnnumberedEroSubObject()
                                    self.unnumbered_ero_sub_object.parent = self
                                    self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                return self.unnumbered_ero_sub_object

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "ero-type"):
                                self.ero_type = value
                                self.ero_type.value_namespace = name_space
                                self.ero_type.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.lsp_hop:
                            if (c.has_data()):
                                return True
                        return (
                            self.is_operational.is_set or
                            self.lsp_local_label.is_set or
                            self.lsp_mode.is_set or
                            self.lsp_output_interface.is_set or
                            self.lsp_output_label.is_set or
                            self.lsp_state.is_set or
                            self.lsp_uptime.is_set or
                            self.path_protection_lsp_id.is_set or
                            (self.association is not None and self.association.has_data()) or
                            (self.flex_info is not None and self.flex_info.has_data()) or
                            (self.protection is not None and self.protection.has_data()) or
                            (self.reverse_lsp is not None and self.reverse_lsp.has_data()))

                    def has_operation(self):
                        for c in self.lsp_hop:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.is_operational.yfilter != YFilter.not_set or
                            self.lsp_local_label.yfilter != YFilter.not_set or
                            self.lsp_mode.yfilter != YFilter.not_set or
                            self.lsp_output_interface.yfilter != YFilter.not_set or
                            self.lsp_output_label.yfilter != YFilter.not_set or
                            self.lsp_state.yfilter != YFilter.not_set or
                            self.lsp_uptime.yfilter != YFilter.not_set or
                            self.path_protection_lsp_id.yfilter != YFilter.not_set or
                            (self.association is not None and self.association.has_operation()) or
                            (self.flex_info is not None and self.flex_info.has_operation()) or
                            (self.protection is not None and self.protection.has_operation()) or
                            (self.reverse_lsp is not None and self.reverse_lsp.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "working-lsp" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.is_operational.is_set or self.is_operational.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_operational.get_name_leafdata())
                        if (self.lsp_local_label.is_set or self.lsp_local_label.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_local_label.get_name_leafdata())
                        if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_mode.get_name_leafdata())
                        if (self.lsp_output_interface.is_set or self.lsp_output_interface.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_output_interface.get_name_leafdata())
                        if (self.lsp_output_label.is_set or self.lsp_output_label.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_output_label.get_name_leafdata())
                        if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_state.get_name_leafdata())
                        if (self.lsp_uptime.is_set or self.lsp_uptime.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_uptime.get_name_leafdata())
                        if (self.path_protection_lsp_id.is_set or self.path_protection_lsp_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.path_protection_lsp_id.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "association"):
                            if (self.association is None):
                                self.association = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.Association()
                                self.association.parent = self
                                self._children_name_map["association"] = "association"
                            return self.association

                        if (child_yang_name == "flex-info"):
                            if (self.flex_info is None):
                                self.flex_info = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.FlexInfo()
                                self.flex_info.parent = self
                                self._children_name_map["flex_info"] = "flex-info"
                            return self.flex_info

                        if (child_yang_name == "lsp-hop"):
                            for c in self.lsp_hop:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.LspHop()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.lsp_hop.append(c)
                            return c

                        if (child_yang_name == "protection"):
                            if (self.protection is None):
                                self.protection = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.Protection()
                                self.protection.parent = self
                                self._children_name_map["protection"] = "protection"
                            return self.protection

                        if (child_yang_name == "reverse-lsp"):
                            if (self.reverse_lsp is None):
                                self.reverse_lsp = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp.ReverseLsp()
                                self.reverse_lsp.parent = self
                                self._children_name_map["reverse_lsp"] = "reverse-lsp"
                            return self.reverse_lsp

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "association" or name == "flex-info" or name == "lsp-hop" or name == "protection" or name == "reverse-lsp" or name == "is-operational" or name == "lsp-local-label" or name == "lsp-mode" or name == "lsp-output-interface" or name == "lsp-output-label" or name == "lsp-state" or name == "lsp-uptime" or name == "path-protection-lsp-id"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "is-operational"):
                            self.is_operational = value
                            self.is_operational.value_namespace = name_space
                            self.is_operational.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-local-label"):
                            self.lsp_local_label = value
                            self.lsp_local_label.value_namespace = name_space
                            self.lsp_local_label.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-mode"):
                            self.lsp_mode = value
                            self.lsp_mode.value_namespace = name_space
                            self.lsp_mode.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-output-interface"):
                            self.lsp_output_interface = value
                            self.lsp_output_interface.value_namespace = name_space
                            self.lsp_output_interface.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-output-label"):
                            self.lsp_output_label = value
                            self.lsp_output_label.value_namespace = name_space
                            self.lsp_output_label.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-state"):
                            self.lsp_state = value
                            self.lsp_state.value_namespace = name_space
                            self.lsp_state.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-uptime"):
                            self.lsp_uptime = value
                            self.lsp_uptime.value_namespace = name_space
                            self.lsp_uptime.value_namespace_prefix = name_space_prefix
                        if(value_path == "path-protection-lsp-id"):
                            self.path_protection_lsp_id = value
                            self.path_protection_lsp_id.value_namespace = name_space
                            self.path_protection_lsp_id.value_namespace_prefix = name_space_prefix


                class ProtectLsp(Entity):
                    """
                     Protect LSP info
                    
                    .. attribute:: association
                    
                    	Association Object
                    	**type**\:   :py:class:`Association <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.Association>`
                    
                    .. attribute:: flex_info
                    
                    	Flex Info
                    	**type**\:   :py:class:`FlexInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.FlexInfo>`
                    
                    .. attribute:: is_operational
                    
                    	Operational
                    	**type**\:  bool
                    
                    .. attribute:: lsp_hop
                    
                    	Path used by LSP
                    	**type**\: list of    :py:class:`LspHop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.LspHop>`
                    
                    .. attribute:: lsp_local_label
                    
                    	Local label 
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: lsp_mode
                    
                    	LSP mode
                    	**type**\:   :py:class:`MplsTeLspMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspMode>`
                    
                    .. attribute:: lsp_output_interface
                    
                    	Output interface of LSP
                    	**type**\:  str
                    
                    .. attribute:: lsp_output_label
                    
                    	Output label of the LSP
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: lsp_state
                    
                    	LSP State
                    	**type**\:   :py:class:`MplsTeTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelState>`
                    
                    .. attribute:: lsp_uptime
                    
                    	LSP Uptime
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: path_protection_lsp_id
                    
                    	LSP ID 
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: protection
                    
                    	Protection Object
                    	**type**\:   :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.Protection>`
                    
                    .. attribute:: reverse_lsp
                    
                    	Reverse LSP information
                    	**type**\:   :py:class:`ReverseLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp, self).__init__()

                        self.yang_name = "protect-lsp"
                        self.yang_parent_name = "tunnel-flex-lsp"

                        self.is_operational = YLeaf(YType.boolean, "is-operational")

                        self.lsp_local_label = YLeaf(YType.uint32, "lsp-local-label")

                        self.lsp_mode = YLeaf(YType.enumeration, "lsp-mode")

                        self.lsp_output_interface = YLeaf(YType.str, "lsp-output-interface")

                        self.lsp_output_label = YLeaf(YType.uint32, "lsp-output-label")

                        self.lsp_state = YLeaf(YType.enumeration, "lsp-state")

                        self.lsp_uptime = YLeaf(YType.uint32, "lsp-uptime")

                        self.path_protection_lsp_id = YLeaf(YType.uint32, "path-protection-lsp-id")

                        self.association = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.Association()
                        self.association.parent = self
                        self._children_name_map["association"] = "association"
                        self._children_yang_names.add("association")

                        self.flex_info = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.FlexInfo()
                        self.flex_info.parent = self
                        self._children_name_map["flex_info"] = "flex-info"
                        self._children_yang_names.add("flex-info")

                        self.protection = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.Protection()
                        self.protection.parent = self
                        self._children_name_map["protection"] = "protection"
                        self._children_yang_names.add("protection")

                        self.reverse_lsp = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp()
                        self.reverse_lsp.parent = self
                        self._children_name_map["reverse_lsp"] = "reverse-lsp"
                        self._children_yang_names.add("reverse-lsp")

                        self.lsp_hop = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("is_operational",
                                        "lsp_local_label",
                                        "lsp_mode",
                                        "lsp_output_interface",
                                        "lsp_output_label",
                                        "lsp_state",
                                        "lsp_uptime",
                                        "path_protection_lsp_id") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp, self).__setattr__(name, value)


                    class FlexInfo(Entity):
                        """
                        Flex Info
                        
                        .. attribute:: bfd_created
                        
                        	GAL BFD Session Created
                        	**type**\:  bool
                        
                        .. attribute:: bfd_egress_label
                        
                        	BFD Egress Label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: bfd_int_label
                        
                        	BFD Internal Label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: bfd_next_hop
                        
                        	BFD Next Hop
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: bfd_out_ifh
                        
                        	BFD Out Interface Handle
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        .. attribute:: bfd_tun_ifh
                        
                        	BFD Tunnel Interface Handle
                        	**type**\:  str
                        
                        	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                        
                        .. attribute:: bfd_up
                        
                        	GAL BFD Session Up
                        	**type**\:  bool
                        
                        .. attribute:: entry_exists
                        
                        	FlexLSP Entry Exists
                        	**type**\:  bool
                        
                        .. attribute:: fault_ais
                        
                        	Fault AIS
                        	**type**\:  bool
                        
                        .. attribute:: fault_ldi
                        
                        	Fault LDI
                        	**type**\:  bool
                        
                        .. attribute:: fault_ldi_lockout
                        
                        	Fault LDI Lockout
                        	**type**\:  bool
                        
                        .. attribute:: fault_lkr
                        
                        	Fault LKR
                        	**type**\:  bool
                        
                        .. attribute:: fault_time
                        
                        	Fault Time
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: flex_fec
                        
                        	FEC for the FlexLSP Entry
                        	**type**\:   :py:class:`FlexFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.FlexInfo.FlexFec>`
                        
                        .. attribute:: in_label
                        
                        	In Label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: oam_created
                        
                        	OAM Entry Created
                        	**type**\:  bool
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.FlexInfo, self).__init__()

                            self.yang_name = "flex-info"
                            self.yang_parent_name = "protect-lsp"

                            self.bfd_created = YLeaf(YType.boolean, "bfd-created")

                            self.bfd_egress_label = YLeaf(YType.uint32, "bfd-egress-label")

                            self.bfd_int_label = YLeaf(YType.uint32, "bfd-int-label")

                            self.bfd_next_hop = YLeaf(YType.str, "bfd-next-hop")

                            self.bfd_out_ifh = YLeaf(YType.str, "bfd-out-ifh")

                            self.bfd_tun_ifh = YLeaf(YType.str, "bfd-tun-ifh")

                            self.bfd_up = YLeaf(YType.boolean, "bfd-up")

                            self.entry_exists = YLeaf(YType.boolean, "entry-exists")

                            self.fault_ais = YLeaf(YType.boolean, "fault-ais")

                            self.fault_ldi = YLeaf(YType.boolean, "fault-ldi")

                            self.fault_ldi_lockout = YLeaf(YType.boolean, "fault-ldi-lockout")

                            self.fault_lkr = YLeaf(YType.boolean, "fault-lkr")

                            self.fault_time = YLeaf(YType.uint32, "fault-time")

                            self.in_label = YLeaf(YType.uint32, "in-label")

                            self.oam_created = YLeaf(YType.boolean, "oam-created")

                            self.flex_fec = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.FlexInfo.FlexFec()
                            self.flex_fec.parent = self
                            self._children_name_map["flex_fec"] = "flex-fec"
                            self._children_yang_names.add("flex-fec")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("bfd_created",
                                            "bfd_egress_label",
                                            "bfd_int_label",
                                            "bfd_next_hop",
                                            "bfd_out_ifh",
                                            "bfd_tun_ifh",
                                            "bfd_up",
                                            "entry_exists",
                                            "fault_ais",
                                            "fault_ldi",
                                            "fault_ldi_lockout",
                                            "fault_lkr",
                                            "fault_time",
                                            "in_label",
                                            "oam_created") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.FlexInfo, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.FlexInfo, self).__setattr__(name, value)


                        class FlexFec(Entity):
                            """
                            FEC for the FlexLSP Entry
                            
                            .. attribute:: s2l_fec_ctype
                            
                            	Session identifier (ctype)
                            	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                            
                            .. attribute:: s2l_fec_dest
                            
                            	sub\-LSP destination address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_lsp_id
                            
                            	LSP ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_p2mp_id
                            
                            	P2MP ID
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: s2l_fec_source
                            
                            	LSP source address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_subgroup_id
                            
                            	sub\-LSP subgroup ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_subgroup_originator
                            
                            	Subgroup Originator
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.FlexInfo.FlexFec, self).__init__()

                                self.yang_name = "flex-fec"
                                self.yang_parent_name = "flex-info"

                                self.s2l_fec_ctype = YLeaf(YType.enumeration, "s2l-fec-ctype")

                                self.s2l_fec_dest = YLeaf(YType.str, "s2l-fec-dest")

                                self.s2l_fec_extended_tunnel_id = YLeaf(YType.str, "s2l-fec-extended-tunnel-id")

                                self.s2l_fec_lsp_id = YLeaf(YType.uint16, "s2l-fec-lsp-id")

                                self.s2l_fec_p2mp_id = YLeaf(YType.uint32, "s2l-fec-p2mp-id")

                                self.s2l_fec_source = YLeaf(YType.str, "s2l-fec-source")

                                self.s2l_fec_subgroup_id = YLeaf(YType.uint16, "s2l-fec-subgroup-id")

                                self.s2l_fec_subgroup_originator = YLeaf(YType.str, "s2l-fec-subgroup-originator")

                                self.s2l_fec_tunnel_id = YLeaf(YType.uint16, "s2l-fec-tunnel-id")

                                self.s2l_fec_vrf = YLeaf(YType.str, "s2l-fec-vrf")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("s2l_fec_ctype",
                                                "s2l_fec_dest",
                                                "s2l_fec_extended_tunnel_id",
                                                "s2l_fec_lsp_id",
                                                "s2l_fec_p2mp_id",
                                                "s2l_fec_source",
                                                "s2l_fec_subgroup_id",
                                                "s2l_fec_subgroup_originator",
                                                "s2l_fec_tunnel_id",
                                                "s2l_fec_vrf") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.FlexInfo.FlexFec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.FlexInfo.FlexFec, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.s2l_fec_ctype.is_set or
                                    self.s2l_fec_dest.is_set or
                                    self.s2l_fec_extended_tunnel_id.is_set or
                                    self.s2l_fec_lsp_id.is_set or
                                    self.s2l_fec_p2mp_id.is_set or
                                    self.s2l_fec_source.is_set or
                                    self.s2l_fec_subgroup_id.is_set or
                                    self.s2l_fec_subgroup_originator.is_set or
                                    self.s2l_fec_tunnel_id.is_set or
                                    self.s2l_fec_vrf.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.s2l_fec_ctype.yfilter != YFilter.not_set or
                                    self.s2l_fec_dest.yfilter != YFilter.not_set or
                                    self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_lsp_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_p2mp_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_source.yfilter != YFilter.not_set or
                                    self.s2l_fec_subgroup_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set or
                                    self.s2l_fec_tunnel_id.yfilter != YFilter.not_set or
                                    self.s2l_fec_vrf.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "flex-fec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/protect-lsp/flex-info/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.s2l_fec_ctype.is_set or self.s2l_fec_ctype.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_ctype.get_name_leafdata())
                                if (self.s2l_fec_dest.is_set or self.s2l_fec_dest.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_dest.get_name_leafdata())
                                if (self.s2l_fec_extended_tunnel_id.is_set or self.s2l_fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_extended_tunnel_id.get_name_leafdata())
                                if (self.s2l_fec_lsp_id.is_set or self.s2l_fec_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_lsp_id.get_name_leafdata())
                                if (self.s2l_fec_p2mp_id.is_set or self.s2l_fec_p2mp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_p2mp_id.get_name_leafdata())
                                if (self.s2l_fec_source.is_set or self.s2l_fec_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_source.get_name_leafdata())
                                if (self.s2l_fec_subgroup_id.is_set or self.s2l_fec_subgroup_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_subgroup_id.get_name_leafdata())
                                if (self.s2l_fec_subgroup_originator.is_set or self.s2l_fec_subgroup_originator.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_subgroup_originator.get_name_leafdata())
                                if (self.s2l_fec_tunnel_id.is_set or self.s2l_fec_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_tunnel_id.get_name_leafdata())
                                if (self.s2l_fec_vrf.is_set or self.s2l_fec_vrf.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_fec_vrf.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "s2l-fec-ctype" or name == "s2l-fec-dest" or name == "s2l-fec-extended-tunnel-id" or name == "s2l-fec-lsp-id" or name == "s2l-fec-p2mp-id" or name == "s2l-fec-source" or name == "s2l-fec-subgroup-id" or name == "s2l-fec-subgroup-originator" or name == "s2l-fec-tunnel-id" or name == "s2l-fec-vrf"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "s2l-fec-ctype"):
                                    self.s2l_fec_ctype = value
                                    self.s2l_fec_ctype.value_namespace = name_space
                                    self.s2l_fec_ctype.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-dest"):
                                    self.s2l_fec_dest = value
                                    self.s2l_fec_dest.value_namespace = name_space
                                    self.s2l_fec_dest.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-extended-tunnel-id"):
                                    self.s2l_fec_extended_tunnel_id = value
                                    self.s2l_fec_extended_tunnel_id.value_namespace = name_space
                                    self.s2l_fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-lsp-id"):
                                    self.s2l_fec_lsp_id = value
                                    self.s2l_fec_lsp_id.value_namespace = name_space
                                    self.s2l_fec_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-p2mp-id"):
                                    self.s2l_fec_p2mp_id = value
                                    self.s2l_fec_p2mp_id.value_namespace = name_space
                                    self.s2l_fec_p2mp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-source"):
                                    self.s2l_fec_source = value
                                    self.s2l_fec_source.value_namespace = name_space
                                    self.s2l_fec_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-subgroup-id"):
                                    self.s2l_fec_subgroup_id = value
                                    self.s2l_fec_subgroup_id.value_namespace = name_space
                                    self.s2l_fec_subgroup_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-subgroup-originator"):
                                    self.s2l_fec_subgroup_originator = value
                                    self.s2l_fec_subgroup_originator.value_namespace = name_space
                                    self.s2l_fec_subgroup_originator.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-tunnel-id"):
                                    self.s2l_fec_tunnel_id = value
                                    self.s2l_fec_tunnel_id.value_namespace = name_space
                                    self.s2l_fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-fec-vrf"):
                                    self.s2l_fec_vrf = value
                                    self.s2l_fec_vrf.value_namespace = name_space
                                    self.s2l_fec_vrf.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.bfd_created.is_set or
                                self.bfd_egress_label.is_set or
                                self.bfd_int_label.is_set or
                                self.bfd_next_hop.is_set or
                                self.bfd_out_ifh.is_set or
                                self.bfd_tun_ifh.is_set or
                                self.bfd_up.is_set or
                                self.entry_exists.is_set or
                                self.fault_ais.is_set or
                                self.fault_ldi.is_set or
                                self.fault_ldi_lockout.is_set or
                                self.fault_lkr.is_set or
                                self.fault_time.is_set or
                                self.in_label.is_set or
                                self.oam_created.is_set or
                                (self.flex_fec is not None and self.flex_fec.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.bfd_created.yfilter != YFilter.not_set or
                                self.bfd_egress_label.yfilter != YFilter.not_set or
                                self.bfd_int_label.yfilter != YFilter.not_set or
                                self.bfd_next_hop.yfilter != YFilter.not_set or
                                self.bfd_out_ifh.yfilter != YFilter.not_set or
                                self.bfd_tun_ifh.yfilter != YFilter.not_set or
                                self.bfd_up.yfilter != YFilter.not_set or
                                self.entry_exists.yfilter != YFilter.not_set or
                                self.fault_ais.yfilter != YFilter.not_set or
                                self.fault_ldi.yfilter != YFilter.not_set or
                                self.fault_ldi_lockout.yfilter != YFilter.not_set or
                                self.fault_lkr.yfilter != YFilter.not_set or
                                self.fault_time.yfilter != YFilter.not_set or
                                self.in_label.yfilter != YFilter.not_set or
                                self.oam_created.yfilter != YFilter.not_set or
                                (self.flex_fec is not None and self.flex_fec.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "flex-info" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/protect-lsp/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.bfd_created.is_set or self.bfd_created.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bfd_created.get_name_leafdata())
                            if (self.bfd_egress_label.is_set or self.bfd_egress_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bfd_egress_label.get_name_leafdata())
                            if (self.bfd_int_label.is_set or self.bfd_int_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bfd_int_label.get_name_leafdata())
                            if (self.bfd_next_hop.is_set or self.bfd_next_hop.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bfd_next_hop.get_name_leafdata())
                            if (self.bfd_out_ifh.is_set or self.bfd_out_ifh.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bfd_out_ifh.get_name_leafdata())
                            if (self.bfd_tun_ifh.is_set or self.bfd_tun_ifh.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bfd_tun_ifh.get_name_leafdata())
                            if (self.bfd_up.is_set or self.bfd_up.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.bfd_up.get_name_leafdata())
                            if (self.entry_exists.is_set or self.entry_exists.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.entry_exists.get_name_leafdata())
                            if (self.fault_ais.is_set or self.fault_ais.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fault_ais.get_name_leafdata())
                            if (self.fault_ldi.is_set or self.fault_ldi.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fault_ldi.get_name_leafdata())
                            if (self.fault_ldi_lockout.is_set or self.fault_ldi_lockout.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fault_ldi_lockout.get_name_leafdata())
                            if (self.fault_lkr.is_set or self.fault_lkr.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fault_lkr.get_name_leafdata())
                            if (self.fault_time.is_set or self.fault_time.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fault_time.get_name_leafdata())
                            if (self.in_label.is_set or self.in_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.in_label.get_name_leafdata())
                            if (self.oam_created.is_set or self.oam_created.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.oam_created.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "flex-fec"):
                                if (self.flex_fec is None):
                                    self.flex_fec = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.FlexInfo.FlexFec()
                                    self.flex_fec.parent = self
                                    self._children_name_map["flex_fec"] = "flex-fec"
                                return self.flex_fec

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "flex-fec" or name == "bfd-created" or name == "bfd-egress-label" or name == "bfd-int-label" or name == "bfd-next-hop" or name == "bfd-out-ifh" or name == "bfd-tun-ifh" or name == "bfd-up" or name == "entry-exists" or name == "fault-ais" or name == "fault-ldi" or name == "fault-ldi-lockout" or name == "fault-lkr" or name == "fault-time" or name == "in-label" or name == "oam-created"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "bfd-created"):
                                self.bfd_created = value
                                self.bfd_created.value_namespace = name_space
                                self.bfd_created.value_namespace_prefix = name_space_prefix
                            if(value_path == "bfd-egress-label"):
                                self.bfd_egress_label = value
                                self.bfd_egress_label.value_namespace = name_space
                                self.bfd_egress_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "bfd-int-label"):
                                self.bfd_int_label = value
                                self.bfd_int_label.value_namespace = name_space
                                self.bfd_int_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "bfd-next-hop"):
                                self.bfd_next_hop = value
                                self.bfd_next_hop.value_namespace = name_space
                                self.bfd_next_hop.value_namespace_prefix = name_space_prefix
                            if(value_path == "bfd-out-ifh"):
                                self.bfd_out_ifh = value
                                self.bfd_out_ifh.value_namespace = name_space
                                self.bfd_out_ifh.value_namespace_prefix = name_space_prefix
                            if(value_path == "bfd-tun-ifh"):
                                self.bfd_tun_ifh = value
                                self.bfd_tun_ifh.value_namespace = name_space
                                self.bfd_tun_ifh.value_namespace_prefix = name_space_prefix
                            if(value_path == "bfd-up"):
                                self.bfd_up = value
                                self.bfd_up.value_namespace = name_space
                                self.bfd_up.value_namespace_prefix = name_space_prefix
                            if(value_path == "entry-exists"):
                                self.entry_exists = value
                                self.entry_exists.value_namespace = name_space
                                self.entry_exists.value_namespace_prefix = name_space_prefix
                            if(value_path == "fault-ais"):
                                self.fault_ais = value
                                self.fault_ais.value_namespace = name_space
                                self.fault_ais.value_namespace_prefix = name_space_prefix
                            if(value_path == "fault-ldi"):
                                self.fault_ldi = value
                                self.fault_ldi.value_namespace = name_space
                                self.fault_ldi.value_namespace_prefix = name_space_prefix
                            if(value_path == "fault-ldi-lockout"):
                                self.fault_ldi_lockout = value
                                self.fault_ldi_lockout.value_namespace = name_space
                                self.fault_ldi_lockout.value_namespace_prefix = name_space_prefix
                            if(value_path == "fault-lkr"):
                                self.fault_lkr = value
                                self.fault_lkr.value_namespace = name_space
                                self.fault_lkr.value_namespace_prefix = name_space_prefix
                            if(value_path == "fault-time"):
                                self.fault_time = value
                                self.fault_time.value_namespace = name_space
                                self.fault_time.value_namespace_prefix = name_space_prefix
                            if(value_path == "in-label"):
                                self.in_label = value
                                self.in_label.value_namespace = name_space
                                self.in_label.value_namespace_prefix = name_space_prefix
                            if(value_path == "oam-created"):
                                self.oam_created = value
                                self.oam_created.value_namespace = name_space
                                self.oam_created.value_namespace_prefix = name_space_prefix


                    class Association(Entity):
                        """
                        Association Object
                        
                        .. attribute:: s2l_association_id
                        
                        	S2L Association ID
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: s2l_association_source
                        
                        	S2L Association Source
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: s2l_association_tie_role
                        
                        	S2L Association Tie Role
                        	**type**\:   :py:class:`TeAssociationTieRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAssociationTieRole>`
                        
                        .. attribute:: s2l_association_type
                        
                        	S2L Association Type                          (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: s2l_extended_id
                        
                        	S2L Extended ID Array
                        	**type**\: list of    :py:class:`S2LExtendedId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.Association.S2LExtendedId>`
                        
                        .. attribute:: s2l_global_source
                        
                        	S2L Global Source
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.Association, self).__init__()

                            self.yang_name = "association"
                            self.yang_parent_name = "protect-lsp"

                            self.s2l_association_id = YLeaf(YType.uint16, "s2l-association-id")

                            self.s2l_association_source = YLeaf(YType.str, "s2l-association-source")

                            self.s2l_association_tie_role = YLeaf(YType.enumeration, "s2l-association-tie-role")

                            self.s2l_association_type = YLeaf(YType.uint16, "s2l-association-type")

                            self.s2l_global_source = YLeaf(YType.uint32, "s2l-global-source")

                            self.s2l_extended_id = YList(self)

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("s2l_association_id",
                                            "s2l_association_source",
                                            "s2l_association_tie_role",
                                            "s2l_association_type",
                                            "s2l_global_source") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.Association, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.Association, self).__setattr__(name, value)


                        class S2LExtendedId(Entity):
                            """
                            S2L Extended ID Array
                            
                            .. attribute:: entry
                            
                            	
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.Association.S2LExtendedId, self).__init__()

                                self.yang_name = "s2l-extended-id"
                                self.yang_parent_name = "association"

                                self.entry = YLeaf(YType.uint32, "entry")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("entry") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.Association.S2LExtendedId, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.Association.S2LExtendedId, self).__setattr__(name, value)

                            def has_data(self):
                                return self.entry.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.entry.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "s2l-extended-id" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/protect-lsp/association/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.entry.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "entry"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "entry"):
                                    self.entry = value
                                    self.entry.value_namespace = name_space
                                    self.entry.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            for c in self.s2l_extended_id:
                                if (c.has_data()):
                                    return True
                            return (
                                self.s2l_association_id.is_set or
                                self.s2l_association_source.is_set or
                                self.s2l_association_tie_role.is_set or
                                self.s2l_association_type.is_set or
                                self.s2l_global_source.is_set)

                        def has_operation(self):
                            for c in self.s2l_extended_id:
                                if (c.has_operation()):
                                    return True
                            return (
                                self.yfilter != YFilter.not_set or
                                self.s2l_association_id.yfilter != YFilter.not_set or
                                self.s2l_association_source.yfilter != YFilter.not_set or
                                self.s2l_association_tie_role.yfilter != YFilter.not_set or
                                self.s2l_association_type.yfilter != YFilter.not_set or
                                self.s2l_global_source.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "association" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/protect-lsp/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.s2l_association_id.is_set or self.s2l_association_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_association_id.get_name_leafdata())
                            if (self.s2l_association_source.is_set or self.s2l_association_source.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_association_source.get_name_leafdata())
                            if (self.s2l_association_tie_role.is_set or self.s2l_association_tie_role.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_association_tie_role.get_name_leafdata())
                            if (self.s2l_association_type.is_set or self.s2l_association_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_association_type.get_name_leafdata())
                            if (self.s2l_global_source.is_set or self.s2l_global_source.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_global_source.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "s2l-extended-id"):
                                for c in self.s2l_extended_id:
                                    segment = c.get_segment_path()
                                    if (segment_path == segment):
                                        return c
                                c = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.Association.S2LExtendedId()
                                c.parent = self
                                local_reference_key = "ydk::seg::%s" % segment_path
                                self._local_refs[local_reference_key] = c
                                self.s2l_extended_id.append(c)
                                return c

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "s2l-extended-id" or name == "s2l-association-id" or name == "s2l-association-source" or name == "s2l-association-tie-role" or name == "s2l-association-type" or name == "s2l-global-source"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "s2l-association-id"):
                                self.s2l_association_id = value
                                self.s2l_association_id.value_namespace = name_space
                                self.s2l_association_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-association-source"):
                                self.s2l_association_source = value
                                self.s2l_association_source.value_namespace = name_space
                                self.s2l_association_source.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-association-tie-role"):
                                self.s2l_association_tie_role = value
                                self.s2l_association_tie_role.value_namespace = name_space
                                self.s2l_association_tie_role.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-association-type"):
                                self.s2l_association_type = value
                                self.s2l_association_type.value_namespace = name_space
                                self.s2l_association_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-global-source"):
                                self.s2l_global_source = value
                                self.s2l_global_source.value_namespace = name_space
                                self.s2l_global_source.value_namespace_prefix = name_space_prefix


                    class Protection(Entity):
                        """
                        Protection Object
                        
                        .. attribute:: any
                        
                        	Any
                        	**type**\:  bool
                        
                        .. attribute:: ded1_plus1
                        
                        	Dedicated 1+1 Protection
                        	**type**\:  bool
                        
                        .. attribute:: ded1_to1
                        
                        	Dedicated 1\:1 Protection
                        	**type**\:  bool
                        
                        .. attribute:: enhanced
                        
                        	Indicates Enhanced Protection Scheme
                        	**type**\:  bool
                        
                        .. attribute:: extra_traffic
                        
                        	LSP should use Links that are protecting other (primary) traffic
                        	**type**\:  bool
                        
                        .. attribute:: link_unprotected
                        
                        	LSP should not use any Link Layer Protection
                        	**type**\:  bool
                        
                        .. attribute:: lsp_unprotected
                        
                        	LSP Flags Unprotected
                        	**type**\:  bool
                        
                        .. attribute:: one_plus_one_bi
                        
                        	1+1 Bidirectional Protection
                        	**type**\:  bool
                        
                        .. attribute:: one_plus_one_uni
                        
                        	1+1 Unidirectional Protection
                        	**type**\:  bool
                        
                        .. attribute:: one_to_n_protection_et
                        
                        	1\:N Protection with Extra\-Traffic
                        	**type**\:  bool
                        
                        .. attribute:: rerouting
                        
                        	Full Rerouting
                        	**type**\:  bool
                        
                        .. attribute:: rerouting_no_et
                        
                        	Rerouting Without Extra\-Traffic
                        	**type**\:  bool
                        
                        .. attribute:: s2l_notification
                        
                        	 S2L Protection Notification Bit
                        	**type**\:  bool
                        
                        .. attribute:: s2l_operational
                        
                        	 S2L Protection Operational Bit
                        	**type**\:  bool
                        
                        .. attribute:: s2l_protecting
                        
                        	 S2L Protection Protecting Bit
                        	**type**\:  bool
                        
                        .. attribute:: s2l_secondary
                        
                        	 S2L Protection Secondary Bit
                        	**type**\:  bool
                        
                        .. attribute:: shared
                        
                        	Shared Link Layer Protection
                        	**type**\:  bool
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.Protection, self).__init__()

                            self.yang_name = "protection"
                            self.yang_parent_name = "protect-lsp"

                            self.any = YLeaf(YType.boolean, "any")

                            self.ded1_plus1 = YLeaf(YType.boolean, "ded1-plus1")

                            self.ded1_to1 = YLeaf(YType.boolean, "ded1-to1")

                            self.enhanced = YLeaf(YType.boolean, "enhanced")

                            self.extra_traffic = YLeaf(YType.boolean, "extra-traffic")

                            self.link_unprotected = YLeaf(YType.boolean, "link-unprotected")

                            self.lsp_unprotected = YLeaf(YType.boolean, "lsp-unprotected")

                            self.one_plus_one_bi = YLeaf(YType.boolean, "one-plus-one-bi")

                            self.one_plus_one_uni = YLeaf(YType.boolean, "one-plus-one-uni")

                            self.one_to_n_protection_et = YLeaf(YType.boolean, "one-to-n-protection-et")

                            self.rerouting = YLeaf(YType.boolean, "rerouting")

                            self.rerouting_no_et = YLeaf(YType.boolean, "rerouting-no-et")

                            self.s2l_notification = YLeaf(YType.boolean, "s2l-notification")

                            self.s2l_operational = YLeaf(YType.boolean, "s2l-operational")

                            self.s2l_protecting = YLeaf(YType.boolean, "s2l-protecting")

                            self.s2l_secondary = YLeaf(YType.boolean, "s2l-secondary")

                            self.shared = YLeaf(YType.boolean, "shared")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("any",
                                            "ded1_plus1",
                                            "ded1_to1",
                                            "enhanced",
                                            "extra_traffic",
                                            "link_unprotected",
                                            "lsp_unprotected",
                                            "one_plus_one_bi",
                                            "one_plus_one_uni",
                                            "one_to_n_protection_et",
                                            "rerouting",
                                            "rerouting_no_et",
                                            "s2l_notification",
                                            "s2l_operational",
                                            "s2l_protecting",
                                            "s2l_secondary",
                                            "shared") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.Protection, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.Protection, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.any.is_set or
                                self.ded1_plus1.is_set or
                                self.ded1_to1.is_set or
                                self.enhanced.is_set or
                                self.extra_traffic.is_set or
                                self.link_unprotected.is_set or
                                self.lsp_unprotected.is_set or
                                self.one_plus_one_bi.is_set or
                                self.one_plus_one_uni.is_set or
                                self.one_to_n_protection_et.is_set or
                                self.rerouting.is_set or
                                self.rerouting_no_et.is_set or
                                self.s2l_notification.is_set or
                                self.s2l_operational.is_set or
                                self.s2l_protecting.is_set or
                                self.s2l_secondary.is_set or
                                self.shared.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.any.yfilter != YFilter.not_set or
                                self.ded1_plus1.yfilter != YFilter.not_set or
                                self.ded1_to1.yfilter != YFilter.not_set or
                                self.enhanced.yfilter != YFilter.not_set or
                                self.extra_traffic.yfilter != YFilter.not_set or
                                self.link_unprotected.yfilter != YFilter.not_set or
                                self.lsp_unprotected.yfilter != YFilter.not_set or
                                self.one_plus_one_bi.yfilter != YFilter.not_set or
                                self.one_plus_one_uni.yfilter != YFilter.not_set or
                                self.one_to_n_protection_et.yfilter != YFilter.not_set or
                                self.rerouting.yfilter != YFilter.not_set or
                                self.rerouting_no_et.yfilter != YFilter.not_set or
                                self.s2l_notification.yfilter != YFilter.not_set or
                                self.s2l_operational.yfilter != YFilter.not_set or
                                self.s2l_protecting.yfilter != YFilter.not_set or
                                self.s2l_secondary.yfilter != YFilter.not_set or
                                self.shared.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "protection" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/protect-lsp/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.any.is_set or self.any.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.any.get_name_leafdata())
                            if (self.ded1_plus1.is_set or self.ded1_plus1.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ded1_plus1.get_name_leafdata())
                            if (self.ded1_to1.is_set or self.ded1_to1.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ded1_to1.get_name_leafdata())
                            if (self.enhanced.is_set or self.enhanced.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.enhanced.get_name_leafdata())
                            if (self.extra_traffic.is_set or self.extra_traffic.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.extra_traffic.get_name_leafdata())
                            if (self.link_unprotected.is_set or self.link_unprotected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.link_unprotected.get_name_leafdata())
                            if (self.lsp_unprotected.is_set or self.lsp_unprotected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsp_unprotected.get_name_leafdata())
                            if (self.one_plus_one_bi.is_set or self.one_plus_one_bi.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.one_plus_one_bi.get_name_leafdata())
                            if (self.one_plus_one_uni.is_set or self.one_plus_one_uni.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.one_plus_one_uni.get_name_leafdata())
                            if (self.one_to_n_protection_et.is_set or self.one_to_n_protection_et.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.one_to_n_protection_et.get_name_leafdata())
                            if (self.rerouting.is_set or self.rerouting.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rerouting.get_name_leafdata())
                            if (self.rerouting_no_et.is_set or self.rerouting_no_et.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.rerouting_no_et.get_name_leafdata())
                            if (self.s2l_notification.is_set or self.s2l_notification.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_notification.get_name_leafdata())
                            if (self.s2l_operational.is_set or self.s2l_operational.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_operational.get_name_leafdata())
                            if (self.s2l_protecting.is_set or self.s2l_protecting.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_protecting.get_name_leafdata())
                            if (self.s2l_secondary.is_set or self.s2l_secondary.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_secondary.get_name_leafdata())
                            if (self.shared.is_set or self.shared.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.shared.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "any" or name == "ded1-plus1" or name == "ded1-to1" or name == "enhanced" or name == "extra-traffic" or name == "link-unprotected" or name == "lsp-unprotected" or name == "one-plus-one-bi" or name == "one-plus-one-uni" or name == "one-to-n-protection-et" or name == "rerouting" or name == "rerouting-no-et" or name == "s2l-notification" or name == "s2l-operational" or name == "s2l-protecting" or name == "s2l-secondary" or name == "shared"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "any"):
                                self.any = value
                                self.any.value_namespace = name_space
                                self.any.value_namespace_prefix = name_space_prefix
                            if(value_path == "ded1-plus1"):
                                self.ded1_plus1 = value
                                self.ded1_plus1.value_namespace = name_space
                                self.ded1_plus1.value_namespace_prefix = name_space_prefix
                            if(value_path == "ded1-to1"):
                                self.ded1_to1 = value
                                self.ded1_to1.value_namespace = name_space
                                self.ded1_to1.value_namespace_prefix = name_space_prefix
                            if(value_path == "enhanced"):
                                self.enhanced = value
                                self.enhanced.value_namespace = name_space
                                self.enhanced.value_namespace_prefix = name_space_prefix
                            if(value_path == "extra-traffic"):
                                self.extra_traffic = value
                                self.extra_traffic.value_namespace = name_space
                                self.extra_traffic.value_namespace_prefix = name_space_prefix
                            if(value_path == "link-unprotected"):
                                self.link_unprotected = value
                                self.link_unprotected.value_namespace = name_space
                                self.link_unprotected.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsp-unprotected"):
                                self.lsp_unprotected = value
                                self.lsp_unprotected.value_namespace = name_space
                                self.lsp_unprotected.value_namespace_prefix = name_space_prefix
                            if(value_path == "one-plus-one-bi"):
                                self.one_plus_one_bi = value
                                self.one_plus_one_bi.value_namespace = name_space
                                self.one_plus_one_bi.value_namespace_prefix = name_space_prefix
                            if(value_path == "one-plus-one-uni"):
                                self.one_plus_one_uni = value
                                self.one_plus_one_uni.value_namespace = name_space
                                self.one_plus_one_uni.value_namespace_prefix = name_space_prefix
                            if(value_path == "one-to-n-protection-et"):
                                self.one_to_n_protection_et = value
                                self.one_to_n_protection_et.value_namespace = name_space
                                self.one_to_n_protection_et.value_namespace_prefix = name_space_prefix
                            if(value_path == "rerouting"):
                                self.rerouting = value
                                self.rerouting.value_namespace = name_space
                                self.rerouting.value_namespace_prefix = name_space_prefix
                            if(value_path == "rerouting-no-et"):
                                self.rerouting_no_et = value
                                self.rerouting_no_et.value_namespace = name_space
                                self.rerouting_no_et.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-notification"):
                                self.s2l_notification = value
                                self.s2l_notification.value_namespace = name_space
                                self.s2l_notification.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-operational"):
                                self.s2l_operational = value
                                self.s2l_operational.value_namespace = name_space
                                self.s2l_operational.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-protecting"):
                                self.s2l_protecting = value
                                self.s2l_protecting.value_namespace = name_space
                                self.s2l_protecting.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-secondary"):
                                self.s2l_secondary = value
                                self.s2l_secondary.value_namespace = name_space
                                self.s2l_secondary.value_namespace_prefix = name_space_prefix
                            if(value_path == "shared"):
                                self.shared = value
                                self.shared.value_namespace = name_space
                                self.shared.value_namespace_prefix = name_space_prefix


                    class ReverseLsp(Entity):
                        """
                        Reverse LSP information
                        
                        .. attribute:: association
                        
                        	Association Object
                        	**type**\:   :py:class:`Association <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.Association>`
                        
                        .. attribute:: protection
                        
                        	Protection Object
                        	**type**\:   :py:class:`Protection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.Protection>`
                        
                        .. attribute:: reverse_lsp_connected
                        
                        	Reverse Associated Bidir LSP Connected
                        	**type**\:  bool
                        
                        .. attribute:: reverse_lsp_fec
                        
                        	Reverse Associated Bidir LSP FEC
                        	**type**\:   :py:class:`ReverseLspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.ReverseLspFec>`
                        
                        .. attribute:: reverse_lsp_present
                        
                        	Reverse Associated Bidir LSP Present
                        	**type**\:  bool
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp, self).__init__()

                            self.yang_name = "reverse-lsp"
                            self.yang_parent_name = "protect-lsp"

                            self.reverse_lsp_connected = YLeaf(YType.boolean, "reverse-lsp-connected")

                            self.reverse_lsp_present = YLeaf(YType.boolean, "reverse-lsp-present")

                            self.association = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.Association()
                            self.association.parent = self
                            self._children_name_map["association"] = "association"
                            self._children_yang_names.add("association")

                            self.protection = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.Protection()
                            self.protection.parent = self
                            self._children_name_map["protection"] = "protection"
                            self._children_yang_names.add("protection")

                            self.reverse_lsp_fec = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.ReverseLspFec()
                            self.reverse_lsp_fec.parent = self
                            self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"
                            self._children_yang_names.add("reverse-lsp-fec")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("reverse_lsp_connected",
                                            "reverse_lsp_present") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp, self).__setattr__(name, value)


                        class ReverseLspFec(Entity):
                            """
                            Reverse Associated Bidir LSP FEC
                            
                            .. attribute:: fec_destination_info
                            
                            	Destination or P2MP ID
                            	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.ReverseLspFec.FecDestinationInfo>`
                            
                            .. attribute:: fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: fec_lsp_id
                            
                            	LSP ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: fec_source
                            
                            	Tunnel source address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.ReverseLspFec, self).__init__()

                                self.yang_name = "reverse-lsp-fec"
                                self.yang_parent_name = "reverse-lsp"

                                self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                self.fec_source = YLeaf(YType.str, "fec-source")

                                self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                self.fec_destination_info = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.ReverseLspFec.FecDestinationInfo()
                                self.fec_destination_info.parent = self
                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                self._children_yang_names.add("fec-destination-info")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fec_extended_tunnel_id",
                                                "fec_lsp_id",
                                                "fec_source",
                                                "fec_tunnel_id",
                                                "fec_vrf") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.ReverseLspFec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.ReverseLspFec, self).__setattr__(name, value)


                            class FecDestinationInfo(Entity):
                                """
                                Destination or P2MP ID
                                
                                .. attribute:: fec_ctype
                                
                                	FEC CType
                                	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                .. attribute:: fec_destination_p2mp_id
                                
                                	P2MP ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: p2p_lsp_destination
                                
                                	P2P LSP destination
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.ReverseLspFec.FecDestinationInfo, self).__init__()

                                    self.yang_name = "fec-destination-info"
                                    self.yang_parent_name = "reverse-lsp-fec"

                                    self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                    self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                    self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("fec_ctype",
                                                    "fec_destination_p2mp_id",
                                                    "p2p_lsp_destination") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.ReverseLspFec.FecDestinationInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.ReverseLspFec.FecDestinationInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.fec_ctype.is_set or
                                        self.fec_destination_p2mp_id.is_set or
                                        self.p2p_lsp_destination.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.fec_ctype.yfilter != YFilter.not_set or
                                        self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                        self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "fec-destination-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/protect-lsp/reverse-lsp/reverse-lsp-fec/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                    if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                    if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "fec-ctype"):
                                        self.fec_ctype = value
                                        self.fec_ctype.value_namespace = name_space
                                        self.fec_ctype.value_namespace_prefix = name_space_prefix
                                    if(value_path == "fec-destination-p2mp-id"):
                                        self.fec_destination_p2mp_id = value
                                        self.fec_destination_p2mp_id.value_namespace = name_space
                                        self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "p2p-lsp-destination"):
                                        self.p2p_lsp_destination = value
                                        self.p2p_lsp_destination.value_namespace = name_space
                                        self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.fec_extended_tunnel_id.is_set or
                                    self.fec_lsp_id.is_set or
                                    self.fec_source.is_set or
                                    self.fec_tunnel_id.is_set or
                                    self.fec_vrf.is_set or
                                    (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                    self.fec_lsp_id.yfilter != YFilter.not_set or
                                    self.fec_source.yfilter != YFilter.not_set or
                                    self.fec_tunnel_id.yfilter != YFilter.not_set or
                                    self.fec_vrf.yfilter != YFilter.not_set or
                                    (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "reverse-lsp-fec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/protect-lsp/reverse-lsp/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_source.get_name_leafdata())
                                if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "fec-destination-info"):
                                    if (self.fec_destination_info is None):
                                        self.fec_destination_info = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.ReverseLspFec.FecDestinationInfo()
                                        self.fec_destination_info.parent = self
                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                    return self.fec_destination_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fec-extended-tunnel-id"):
                                    self.fec_extended_tunnel_id = value
                                    self.fec_extended_tunnel_id.value_namespace = name_space
                                    self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-lsp-id"):
                                    self.fec_lsp_id = value
                                    self.fec_lsp_id.value_namespace = name_space
                                    self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-source"):
                                    self.fec_source = value
                                    self.fec_source.value_namespace = name_space
                                    self.fec_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-tunnel-id"):
                                    self.fec_tunnel_id = value
                                    self.fec_tunnel_id.value_namespace = name_space
                                    self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-vrf"):
                                    self.fec_vrf = value
                                    self.fec_vrf.value_namespace = name_space
                                    self.fec_vrf.value_namespace_prefix = name_space_prefix


                        class Association(Entity):
                            """
                            Association Object
                            
                            .. attribute:: s2l_association_id
                            
                            	S2L Association ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_association_source
                            
                            	S2L Association Source
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: s2l_association_tie_role
                            
                            	S2L Association Tie Role
                            	**type**\:   :py:class:`TeAssociationTieRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAssociationTieRole>`
                            
                            .. attribute:: s2l_association_type
                            
                            	S2L Association Type                          (draft\-ietf\-ccamp\-mpls\-tp\-rsvpte\-ext\-associated\-lsp)
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: s2l_extended_id
                            
                            	S2L Extended ID Array
                            	**type**\: list of    :py:class:`S2LExtendedId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.Association.S2LExtendedId>`
                            
                            .. attribute:: s2l_global_source
                            
                            	S2L Global Source
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.Association, self).__init__()

                                self.yang_name = "association"
                                self.yang_parent_name = "reverse-lsp"

                                self.s2l_association_id = YLeaf(YType.uint16, "s2l-association-id")

                                self.s2l_association_source = YLeaf(YType.str, "s2l-association-source")

                                self.s2l_association_tie_role = YLeaf(YType.enumeration, "s2l-association-tie-role")

                                self.s2l_association_type = YLeaf(YType.uint16, "s2l-association-type")

                                self.s2l_global_source = YLeaf(YType.uint32, "s2l-global-source")

                                self.s2l_extended_id = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("s2l_association_id",
                                                "s2l_association_source",
                                                "s2l_association_tie_role",
                                                "s2l_association_type",
                                                "s2l_global_source") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.Association, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.Association, self).__setattr__(name, value)


                            class S2LExtendedId(Entity):
                                """
                                S2L Extended ID Array
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.Association.S2LExtendedId, self).__init__()

                                    self.yang_name = "s2l-extended-id"
                                    self.yang_parent_name = "association"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.Association.S2LExtendedId, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.Association.S2LExtendedId, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "s2l-extended-id" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/protect-lsp/reverse-lsp/association/%s" % self.get_segment_path()
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.s2l_extended_id:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.s2l_association_id.is_set or
                                    self.s2l_association_source.is_set or
                                    self.s2l_association_tie_role.is_set or
                                    self.s2l_association_type.is_set or
                                    self.s2l_global_source.is_set)

                            def has_operation(self):
                                for c in self.s2l_extended_id:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.s2l_association_id.yfilter != YFilter.not_set or
                                    self.s2l_association_source.yfilter != YFilter.not_set or
                                    self.s2l_association_tie_role.yfilter != YFilter.not_set or
                                    self.s2l_association_type.yfilter != YFilter.not_set or
                                    self.s2l_global_source.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "association" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/protect-lsp/reverse-lsp/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.s2l_association_id.is_set or self.s2l_association_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_id.get_name_leafdata())
                                if (self.s2l_association_source.is_set or self.s2l_association_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_source.get_name_leafdata())
                                if (self.s2l_association_tie_role.is_set or self.s2l_association_tie_role.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_tie_role.get_name_leafdata())
                                if (self.s2l_association_type.is_set or self.s2l_association_type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_association_type.get_name_leafdata())
                                if (self.s2l_global_source.is_set or self.s2l_global_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_global_source.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "s2l-extended-id"):
                                    for c in self.s2l_extended_id:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.Association.S2LExtendedId()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.s2l_extended_id.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "s2l-extended-id" or name == "s2l-association-id" or name == "s2l-association-source" or name == "s2l-association-tie-role" or name == "s2l-association-type" or name == "s2l-global-source"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "s2l-association-id"):
                                    self.s2l_association_id = value
                                    self.s2l_association_id.value_namespace = name_space
                                    self.s2l_association_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-source"):
                                    self.s2l_association_source = value
                                    self.s2l_association_source.value_namespace = name_space
                                    self.s2l_association_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-tie-role"):
                                    self.s2l_association_tie_role = value
                                    self.s2l_association_tie_role.value_namespace = name_space
                                    self.s2l_association_tie_role.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-association-type"):
                                    self.s2l_association_type = value
                                    self.s2l_association_type.value_namespace = name_space
                                    self.s2l_association_type.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-global-source"):
                                    self.s2l_global_source = value
                                    self.s2l_global_source.value_namespace = name_space
                                    self.s2l_global_source.value_namespace_prefix = name_space_prefix


                        class Protection(Entity):
                            """
                            Protection Object
                            
                            .. attribute:: any
                            
                            	Any
                            	**type**\:  bool
                            
                            .. attribute:: ded1_plus1
                            
                            	Dedicated 1+1 Protection
                            	**type**\:  bool
                            
                            .. attribute:: ded1_to1
                            
                            	Dedicated 1\:1 Protection
                            	**type**\:  bool
                            
                            .. attribute:: enhanced
                            
                            	Indicates Enhanced Protection Scheme
                            	**type**\:  bool
                            
                            .. attribute:: extra_traffic
                            
                            	LSP should use Links that are protecting other (primary) traffic
                            	**type**\:  bool
                            
                            .. attribute:: link_unprotected
                            
                            	LSP should not use any Link Layer Protection
                            	**type**\:  bool
                            
                            .. attribute:: lsp_unprotected
                            
                            	LSP Flags Unprotected
                            	**type**\:  bool
                            
                            .. attribute:: one_plus_one_bi
                            
                            	1+1 Bidirectional Protection
                            	**type**\:  bool
                            
                            .. attribute:: one_plus_one_uni
                            
                            	1+1 Unidirectional Protection
                            	**type**\:  bool
                            
                            .. attribute:: one_to_n_protection_et
                            
                            	1\:N Protection with Extra\-Traffic
                            	**type**\:  bool
                            
                            .. attribute:: rerouting
                            
                            	Full Rerouting
                            	**type**\:  bool
                            
                            .. attribute:: rerouting_no_et
                            
                            	Rerouting Without Extra\-Traffic
                            	**type**\:  bool
                            
                            .. attribute:: s2l_notification
                            
                            	 S2L Protection Notification Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_operational
                            
                            	 S2L Protection Operational Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_protecting
                            
                            	 S2L Protection Protecting Bit
                            	**type**\:  bool
                            
                            .. attribute:: s2l_secondary
                            
                            	 S2L Protection Secondary Bit
                            	**type**\:  bool
                            
                            .. attribute:: shared
                            
                            	Shared Link Layer Protection
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.Protection, self).__init__()

                                self.yang_name = "protection"
                                self.yang_parent_name = "reverse-lsp"

                                self.any = YLeaf(YType.boolean, "any")

                                self.ded1_plus1 = YLeaf(YType.boolean, "ded1-plus1")

                                self.ded1_to1 = YLeaf(YType.boolean, "ded1-to1")

                                self.enhanced = YLeaf(YType.boolean, "enhanced")

                                self.extra_traffic = YLeaf(YType.boolean, "extra-traffic")

                                self.link_unprotected = YLeaf(YType.boolean, "link-unprotected")

                                self.lsp_unprotected = YLeaf(YType.boolean, "lsp-unprotected")

                                self.one_plus_one_bi = YLeaf(YType.boolean, "one-plus-one-bi")

                                self.one_plus_one_uni = YLeaf(YType.boolean, "one-plus-one-uni")

                                self.one_to_n_protection_et = YLeaf(YType.boolean, "one-to-n-protection-et")

                                self.rerouting = YLeaf(YType.boolean, "rerouting")

                                self.rerouting_no_et = YLeaf(YType.boolean, "rerouting-no-et")

                                self.s2l_notification = YLeaf(YType.boolean, "s2l-notification")

                                self.s2l_operational = YLeaf(YType.boolean, "s2l-operational")

                                self.s2l_protecting = YLeaf(YType.boolean, "s2l-protecting")

                                self.s2l_secondary = YLeaf(YType.boolean, "s2l-secondary")

                                self.shared = YLeaf(YType.boolean, "shared")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("any",
                                                "ded1_plus1",
                                                "ded1_to1",
                                                "enhanced",
                                                "extra_traffic",
                                                "link_unprotected",
                                                "lsp_unprotected",
                                                "one_plus_one_bi",
                                                "one_plus_one_uni",
                                                "one_to_n_protection_et",
                                                "rerouting",
                                                "rerouting_no_et",
                                                "s2l_notification",
                                                "s2l_operational",
                                                "s2l_protecting",
                                                "s2l_secondary",
                                                "shared") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.Protection, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.Protection, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.any.is_set or
                                    self.ded1_plus1.is_set or
                                    self.ded1_to1.is_set or
                                    self.enhanced.is_set or
                                    self.extra_traffic.is_set or
                                    self.link_unprotected.is_set or
                                    self.lsp_unprotected.is_set or
                                    self.one_plus_one_bi.is_set or
                                    self.one_plus_one_uni.is_set or
                                    self.one_to_n_protection_et.is_set or
                                    self.rerouting.is_set or
                                    self.rerouting_no_et.is_set or
                                    self.s2l_notification.is_set or
                                    self.s2l_operational.is_set or
                                    self.s2l_protecting.is_set or
                                    self.s2l_secondary.is_set or
                                    self.shared.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.any.yfilter != YFilter.not_set or
                                    self.ded1_plus1.yfilter != YFilter.not_set or
                                    self.ded1_to1.yfilter != YFilter.not_set or
                                    self.enhanced.yfilter != YFilter.not_set or
                                    self.extra_traffic.yfilter != YFilter.not_set or
                                    self.link_unprotected.yfilter != YFilter.not_set or
                                    self.lsp_unprotected.yfilter != YFilter.not_set or
                                    self.one_plus_one_bi.yfilter != YFilter.not_set or
                                    self.one_plus_one_uni.yfilter != YFilter.not_set or
                                    self.one_to_n_protection_et.yfilter != YFilter.not_set or
                                    self.rerouting.yfilter != YFilter.not_set or
                                    self.rerouting_no_et.yfilter != YFilter.not_set or
                                    self.s2l_notification.yfilter != YFilter.not_set or
                                    self.s2l_operational.yfilter != YFilter.not_set or
                                    self.s2l_protecting.yfilter != YFilter.not_set or
                                    self.s2l_secondary.yfilter != YFilter.not_set or
                                    self.shared.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "protection" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/protect-lsp/reverse-lsp/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.any.is_set or self.any.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.any.get_name_leafdata())
                                if (self.ded1_plus1.is_set or self.ded1_plus1.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ded1_plus1.get_name_leafdata())
                                if (self.ded1_to1.is_set or self.ded1_to1.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ded1_to1.get_name_leafdata())
                                if (self.enhanced.is_set or self.enhanced.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.enhanced.get_name_leafdata())
                                if (self.extra_traffic.is_set or self.extra_traffic.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.extra_traffic.get_name_leafdata())
                                if (self.link_unprotected.is_set or self.link_unprotected.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.link_unprotected.get_name_leafdata())
                                if (self.lsp_unprotected.is_set or self.lsp_unprotected.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.lsp_unprotected.get_name_leafdata())
                                if (self.one_plus_one_bi.is_set or self.one_plus_one_bi.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_plus_one_bi.get_name_leafdata())
                                if (self.one_plus_one_uni.is_set or self.one_plus_one_uni.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_plus_one_uni.get_name_leafdata())
                                if (self.one_to_n_protection_et.is_set or self.one_to_n_protection_et.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.one_to_n_protection_et.get_name_leafdata())
                                if (self.rerouting.is_set or self.rerouting.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rerouting.get_name_leafdata())
                                if (self.rerouting_no_et.is_set or self.rerouting_no_et.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.rerouting_no_et.get_name_leafdata())
                                if (self.s2l_notification.is_set or self.s2l_notification.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_notification.get_name_leafdata())
                                if (self.s2l_operational.is_set or self.s2l_operational.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_operational.get_name_leafdata())
                                if (self.s2l_protecting.is_set or self.s2l_protecting.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_protecting.get_name_leafdata())
                                if (self.s2l_secondary.is_set or self.s2l_secondary.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.s2l_secondary.get_name_leafdata())
                                if (self.shared.is_set or self.shared.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.shared.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "any" or name == "ded1-plus1" or name == "ded1-to1" or name == "enhanced" or name == "extra-traffic" or name == "link-unprotected" or name == "lsp-unprotected" or name == "one-plus-one-bi" or name == "one-plus-one-uni" or name == "one-to-n-protection-et" or name == "rerouting" or name == "rerouting-no-et" or name == "s2l-notification" or name == "s2l-operational" or name == "s2l-protecting" or name == "s2l-secondary" or name == "shared"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "any"):
                                    self.any = value
                                    self.any.value_namespace = name_space
                                    self.any.value_namespace_prefix = name_space_prefix
                                if(value_path == "ded1-plus1"):
                                    self.ded1_plus1 = value
                                    self.ded1_plus1.value_namespace = name_space
                                    self.ded1_plus1.value_namespace_prefix = name_space_prefix
                                if(value_path == "ded1-to1"):
                                    self.ded1_to1 = value
                                    self.ded1_to1.value_namespace = name_space
                                    self.ded1_to1.value_namespace_prefix = name_space_prefix
                                if(value_path == "enhanced"):
                                    self.enhanced = value
                                    self.enhanced.value_namespace = name_space
                                    self.enhanced.value_namespace_prefix = name_space_prefix
                                if(value_path == "extra-traffic"):
                                    self.extra_traffic = value
                                    self.extra_traffic.value_namespace = name_space
                                    self.extra_traffic.value_namespace_prefix = name_space_prefix
                                if(value_path == "link-unprotected"):
                                    self.link_unprotected = value
                                    self.link_unprotected.value_namespace = name_space
                                    self.link_unprotected.value_namespace_prefix = name_space_prefix
                                if(value_path == "lsp-unprotected"):
                                    self.lsp_unprotected = value
                                    self.lsp_unprotected.value_namespace = name_space
                                    self.lsp_unprotected.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-plus-one-bi"):
                                    self.one_plus_one_bi = value
                                    self.one_plus_one_bi.value_namespace = name_space
                                    self.one_plus_one_bi.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-plus-one-uni"):
                                    self.one_plus_one_uni = value
                                    self.one_plus_one_uni.value_namespace = name_space
                                    self.one_plus_one_uni.value_namespace_prefix = name_space_prefix
                                if(value_path == "one-to-n-protection-et"):
                                    self.one_to_n_protection_et = value
                                    self.one_to_n_protection_et.value_namespace = name_space
                                    self.one_to_n_protection_et.value_namespace_prefix = name_space_prefix
                                if(value_path == "rerouting"):
                                    self.rerouting = value
                                    self.rerouting.value_namespace = name_space
                                    self.rerouting.value_namespace_prefix = name_space_prefix
                                if(value_path == "rerouting-no-et"):
                                    self.rerouting_no_et = value
                                    self.rerouting_no_et.value_namespace = name_space
                                    self.rerouting_no_et.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-notification"):
                                    self.s2l_notification = value
                                    self.s2l_notification.value_namespace = name_space
                                    self.s2l_notification.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-operational"):
                                    self.s2l_operational = value
                                    self.s2l_operational.value_namespace = name_space
                                    self.s2l_operational.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-protecting"):
                                    self.s2l_protecting = value
                                    self.s2l_protecting.value_namespace = name_space
                                    self.s2l_protecting.value_namespace_prefix = name_space_prefix
                                if(value_path == "s2l-secondary"):
                                    self.s2l_secondary = value
                                    self.s2l_secondary.value_namespace = name_space
                                    self.s2l_secondary.value_namespace_prefix = name_space_prefix
                                if(value_path == "shared"):
                                    self.shared = value
                                    self.shared.value_namespace = name_space
                                    self.shared.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.reverse_lsp_connected.is_set or
                                self.reverse_lsp_present.is_set or
                                (self.association is not None and self.association.has_data()) or
                                (self.protection is not None and self.protection.has_data()) or
                                (self.reverse_lsp_fec is not None and self.reverse_lsp_fec.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.reverse_lsp_connected.yfilter != YFilter.not_set or
                                self.reverse_lsp_present.yfilter != YFilter.not_set or
                                (self.association is not None and self.association.has_operation()) or
                                (self.protection is not None and self.protection.has_operation()) or
                                (self.reverse_lsp_fec is not None and self.reverse_lsp_fec.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "reverse-lsp" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/protect-lsp/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.reverse_lsp_connected.is_set or self.reverse_lsp_connected.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_connected.get_name_leafdata())
                            if (self.reverse_lsp_present.is_set or self.reverse_lsp_present.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.reverse_lsp_present.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "association"):
                                if (self.association is None):
                                    self.association = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.Association()
                                    self.association.parent = self
                                    self._children_name_map["association"] = "association"
                                return self.association

                            if (child_yang_name == "protection"):
                                if (self.protection is None):
                                    self.protection = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.Protection()
                                    self.protection.parent = self
                                    self._children_name_map["protection"] = "protection"
                                return self.protection

                            if (child_yang_name == "reverse-lsp-fec"):
                                if (self.reverse_lsp_fec is None):
                                    self.reverse_lsp_fec = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp.ReverseLspFec()
                                    self.reverse_lsp_fec.parent = self
                                    self._children_name_map["reverse_lsp_fec"] = "reverse-lsp-fec"
                                return self.reverse_lsp_fec

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "association" or name == "protection" or name == "reverse-lsp-fec" or name == "reverse-lsp-connected" or name == "reverse-lsp-present"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "reverse-lsp-connected"):
                                self.reverse_lsp_connected = value
                                self.reverse_lsp_connected.value_namespace = name_space
                                self.reverse_lsp_connected.value_namespace_prefix = name_space_prefix
                            if(value_path == "reverse-lsp-present"):
                                self.reverse_lsp_present = value
                                self.reverse_lsp_present.value_namespace = name_space
                                self.reverse_lsp_present.value_namespace_prefix = name_space_prefix


                    class LspHop(Entity):
                        """
                        Path used by LSP
                        
                        .. attribute:: ero_type
                        
                        	EROType
                        	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                        
                        .. attribute:: ipv4ero_sub_object
                        
                        	IPV4 ERO Sub Object
                        	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.LspHop.Ipv4EroSubObject>`
                        
                        .. attribute:: unnumbered_ero_sub_object
                        
                        	Unnumbered ERO Sub Object
                        	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.LspHop.UnnumberedEroSubObject>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.LspHop, self).__init__()

                            self.yang_name = "lsp-hop"
                            self.yang_parent_name = "protect-lsp"

                            self.ero_type = YLeaf(YType.enumeration, "ero-type")

                            self.ipv4ero_sub_object = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.LspHop.Ipv4EroSubObject()
                            self.ipv4ero_sub_object.parent = self
                            self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                            self._children_yang_names.add("ipv4ero-sub-object")

                            self.unnumbered_ero_sub_object = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.LspHop.UnnumberedEroSubObject()
                            self.unnumbered_ero_sub_object.parent = self
                            self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                            self._children_yang_names.add("unnumbered-ero-sub-object")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("ero_type") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.LspHop, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.LspHop, self).__setattr__(name, value)


                        class Ipv4EroSubObject(Entity):
                            """
                            IPV4 ERO Sub Object
                            
                            .. attribute:: ero_address
                            
                            	The ERO IPV4 Address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: is_strict_route
                            
                            	ERO Entry Is Strict
                            	**type**\:  bool
                            
                            .. attribute:: prefix_length
                            
                            	ERO Prefix Length
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.LspHop.Ipv4EroSubObject, self).__init__()

                                self.yang_name = "ipv4ero-sub-object"
                                self.yang_parent_name = "lsp-hop"

                                self.ero_address = YLeaf(YType.str, "ero-address")

                                self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_address",
                                                "is_strict_route",
                                                "prefix_length") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.LspHop.Ipv4EroSubObject, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.LspHop.Ipv4EroSubObject, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.ero_address.is_set or
                                    self.is_strict_route.is_set or
                                    self.prefix_length.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_address.yfilter != YFilter.not_set or
                                    self.is_strict_route.yfilter != YFilter.not_set or
                                    self.prefix_length.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ipv4ero-sub-object" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/protect-lsp/lsp-hop/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_address.get_name_leafdata())
                                if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-address"):
                                    self.ero_address = value
                                    self.ero_address.value_namespace = name_space
                                    self.ero_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-strict-route"):
                                    self.is_strict_route = value
                                    self.is_strict_route.value_namespace = name_space
                                    self.is_strict_route.value_namespace_prefix = name_space_prefix
                                if(value_path == "prefix-length"):
                                    self.prefix_length = value
                                    self.prefix_length.value_namespace = name_space
                                    self.prefix_length.value_namespace_prefix = name_space_prefix


                        class UnnumberedEroSubObject(Entity):
                            """
                            Unnumbered ERO Sub Object
                            
                            .. attribute:: ero_interface_id
                            
                            	The Interface ID in ERO
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: ero_router_id
                            
                            	The Router ID in ERO
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: is_strict_route
                            
                            	ERO Entry Is Strict
                            	**type**\:  bool
                            
                            .. attribute:: status
                            
                            	Status of ERO
                            	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.LspHop.UnnumberedEroSubObject, self).__init__()

                                self.yang_name = "unnumbered-ero-sub-object"
                                self.yang_parent_name = "lsp-hop"

                                self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                self.status = YLeaf(YType.enumeration, "status")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_interface_id",
                                                "ero_router_id",
                                                "is_strict_route",
                                                "status") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.LspHop.UnnumberedEroSubObject, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.LspHop.UnnumberedEroSubObject, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.ero_interface_id.is_set or
                                    self.ero_router_id.is_set or
                                    self.is_strict_route.is_set or
                                    self.status.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_interface_id.yfilter != YFilter.not_set or
                                    self.ero_router_id.yfilter != YFilter.not_set or
                                    self.is_strict_route.yfilter != YFilter.not_set or
                                    self.status.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/protect-lsp/lsp-hop/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.status.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-interface-id"):
                                    self.ero_interface_id = value
                                    self.ero_interface_id.value_namespace = name_space
                                    self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "ero-router-id"):
                                    self.ero_router_id = value
                                    self.ero_router_id.value_namespace = name_space
                                    self.ero_router_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-strict-route"):
                                    self.is_strict_route = value
                                    self.is_strict_route.value_namespace = name_space
                                    self.is_strict_route.value_namespace_prefix = name_space_prefix
                                if(value_path == "status"):
                                    self.status = value
                                    self.status.value_namespace = name_space
                                    self.status.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.ero_type.is_set or
                                (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.ero_type.yfilter != YFilter.not_set or
                                (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "lsp-hop" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/protect-lsp/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ero_type.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "ipv4ero-sub-object"):
                                if (self.ipv4ero_sub_object is None):
                                    self.ipv4ero_sub_object = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.LspHop.Ipv4EroSubObject()
                                    self.ipv4ero_sub_object.parent = self
                                    self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                return self.ipv4ero_sub_object

                            if (child_yang_name == "unnumbered-ero-sub-object"):
                                if (self.unnumbered_ero_sub_object is None):
                                    self.unnumbered_ero_sub_object = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.LspHop.UnnumberedEroSubObject()
                                    self.unnumbered_ero_sub_object.parent = self
                                    self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                return self.unnumbered_ero_sub_object

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "ero-type"):
                                self.ero_type = value
                                self.ero_type.value_namespace = name_space
                                self.ero_type.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.lsp_hop:
                            if (c.has_data()):
                                return True
                        return (
                            self.is_operational.is_set or
                            self.lsp_local_label.is_set or
                            self.lsp_mode.is_set or
                            self.lsp_output_interface.is_set or
                            self.lsp_output_label.is_set or
                            self.lsp_state.is_set or
                            self.lsp_uptime.is_set or
                            self.path_protection_lsp_id.is_set or
                            (self.association is not None and self.association.has_data()) or
                            (self.flex_info is not None and self.flex_info.has_data()) or
                            (self.protection is not None and self.protection.has_data()) or
                            (self.reverse_lsp is not None and self.reverse_lsp.has_data()))

                    def has_operation(self):
                        for c in self.lsp_hop:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.is_operational.yfilter != YFilter.not_set or
                            self.lsp_local_label.yfilter != YFilter.not_set or
                            self.lsp_mode.yfilter != YFilter.not_set or
                            self.lsp_output_interface.yfilter != YFilter.not_set or
                            self.lsp_output_label.yfilter != YFilter.not_set or
                            self.lsp_state.yfilter != YFilter.not_set or
                            self.lsp_uptime.yfilter != YFilter.not_set or
                            self.path_protection_lsp_id.yfilter != YFilter.not_set or
                            (self.association is not None and self.association.has_operation()) or
                            (self.flex_info is not None and self.flex_info.has_operation()) or
                            (self.protection is not None and self.protection.has_operation()) or
                            (self.reverse_lsp is not None and self.reverse_lsp.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "protect-lsp" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-flex-lsps/tunnel-flex-lsp/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.is_operational.is_set or self.is_operational.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_operational.get_name_leafdata())
                        if (self.lsp_local_label.is_set or self.lsp_local_label.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_local_label.get_name_leafdata())
                        if (self.lsp_mode.is_set or self.lsp_mode.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_mode.get_name_leafdata())
                        if (self.lsp_output_interface.is_set or self.lsp_output_interface.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_output_interface.get_name_leafdata())
                        if (self.lsp_output_label.is_set or self.lsp_output_label.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_output_label.get_name_leafdata())
                        if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_state.get_name_leafdata())
                        if (self.lsp_uptime.is_set or self.lsp_uptime.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_uptime.get_name_leafdata())
                        if (self.path_protection_lsp_id.is_set or self.path_protection_lsp_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.path_protection_lsp_id.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "association"):
                            if (self.association is None):
                                self.association = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.Association()
                                self.association.parent = self
                                self._children_name_map["association"] = "association"
                            return self.association

                        if (child_yang_name == "flex-info"):
                            if (self.flex_info is None):
                                self.flex_info = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.FlexInfo()
                                self.flex_info.parent = self
                                self._children_name_map["flex_info"] = "flex-info"
                            return self.flex_info

                        if (child_yang_name == "lsp-hop"):
                            for c in self.lsp_hop:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.LspHop()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.lsp_hop.append(c)
                            return c

                        if (child_yang_name == "protection"):
                            if (self.protection is None):
                                self.protection = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.Protection()
                                self.protection.parent = self
                                self._children_name_map["protection"] = "protection"
                            return self.protection

                        if (child_yang_name == "reverse-lsp"):
                            if (self.reverse_lsp is None):
                                self.reverse_lsp = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp.ReverseLsp()
                                self.reverse_lsp.parent = self
                                self._children_name_map["reverse_lsp"] = "reverse-lsp"
                            return self.reverse_lsp

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "association" or name == "flex-info" or name == "lsp-hop" or name == "protection" or name == "reverse-lsp" or name == "is-operational" or name == "lsp-local-label" or name == "lsp-mode" or name == "lsp-output-interface" or name == "lsp-output-label" or name == "lsp-state" or name == "lsp-uptime" or name == "path-protection-lsp-id"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "is-operational"):
                            self.is_operational = value
                            self.is_operational.value_namespace = name_space
                            self.is_operational.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-local-label"):
                            self.lsp_local_label = value
                            self.lsp_local_label.value_namespace = name_space
                            self.lsp_local_label.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-mode"):
                            self.lsp_mode = value
                            self.lsp_mode.value_namespace = name_space
                            self.lsp_mode.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-output-interface"):
                            self.lsp_output_interface = value
                            self.lsp_output_interface.value_namespace = name_space
                            self.lsp_output_interface.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-output-label"):
                            self.lsp_output_label = value
                            self.lsp_output_label.value_namespace = name_space
                            self.lsp_output_label.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-state"):
                            self.lsp_state = value
                            self.lsp_state.value_namespace = name_space
                            self.lsp_state.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-uptime"):
                            self.lsp_uptime = value
                            self.lsp_uptime.value_namespace = name_space
                            self.lsp_uptime.value_namespace_prefix = name_space_prefix
                        if(value_path == "path-protection-lsp-id"):
                            self.path_protection_lsp_id = value
                            self.path_protection_lsp_id.value_namespace = name_space
                            self.path_protection_lsp_id.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    return (
                        self.ctype.is_set or
                        self.destination_address.is_set or
                        self.extended_tunnel_id.is_set or
                        self.is_tunnel_up.is_set or
                        self.source_address.is_set or
                        self.tun_id.is_set or
                        self.tunnel_id.is_set or
                        self.tunnel_name.is_set or
                        (self.protect_lsp is not None and self.protect_lsp.has_data()) or
                        (self.working_lsp is not None and self.working_lsp.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.ctype.yfilter != YFilter.not_set or
                        self.destination_address.yfilter != YFilter.not_set or
                        self.extended_tunnel_id.yfilter != YFilter.not_set or
                        self.is_tunnel_up.yfilter != YFilter.not_set or
                        self.source_address.yfilter != YFilter.not_set or
                        self.tun_id.yfilter != YFilter.not_set or
                        self.tunnel_id.yfilter != YFilter.not_set or
                        self.tunnel_name.yfilter != YFilter.not_set or
                        (self.protect_lsp is not None and self.protect_lsp.has_operation()) or
                        (self.working_lsp is not None and self.working_lsp.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "tunnel-flex-lsp" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-flex-lsps/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.ctype.is_set or self.ctype.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.ctype.get_name_leafdata())
                    if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.destination_address.get_name_leafdata())
                    if (self.extended_tunnel_id.is_set or self.extended_tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.extended_tunnel_id.get_name_leafdata())
                    if (self.is_tunnel_up.is_set or self.is_tunnel_up.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_tunnel_up.get_name_leafdata())
                    if (self.source_address.is_set or self.source_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.source_address.get_name_leafdata())
                    if (self.tun_id.is_set or self.tun_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tun_id.get_name_leafdata())
                    if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_id.get_name_leafdata())
                    if (self.tunnel_name.is_set or self.tunnel_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_name.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "protect-lsp"):
                        if (self.protect_lsp is None):
                            self.protect_lsp = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.ProtectLsp()
                            self.protect_lsp.parent = self
                            self._children_name_map["protect_lsp"] = "protect-lsp"
                        return self.protect_lsp

                    if (child_yang_name == "working-lsp"):
                        if (self.working_lsp is None):
                            self.working_lsp = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp.WorkingLsp()
                            self.working_lsp.parent = self
                            self._children_name_map["working_lsp"] = "working-lsp"
                        return self.working_lsp

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "protect-lsp" or name == "working-lsp" or name == "ctype" or name == "destination-address" or name == "extended-tunnel-id" or name == "is-tunnel-up" or name == "source-address" or name == "tun-id" or name == "tunnel-id" or name == "tunnel-name"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "ctype"):
                        self.ctype = value
                        self.ctype.value_namespace = name_space
                        self.ctype.value_namespace_prefix = name_space_prefix
                    if(value_path == "destination-address"):
                        self.destination_address = value
                        self.destination_address.value_namespace = name_space
                        self.destination_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "extended-tunnel-id"):
                        self.extended_tunnel_id = value
                        self.extended_tunnel_id.value_namespace = name_space
                        self.extended_tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-tunnel-up"):
                        self.is_tunnel_up = value
                        self.is_tunnel_up.value_namespace = name_space
                        self.is_tunnel_up.value_namespace_prefix = name_space_prefix
                    if(value_path == "source-address"):
                        self.source_address = value
                        self.source_address.value_namespace = name_space
                        self.source_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "tun-id"):
                        self.tun_id = value
                        self.tun_id.value_namespace = name_space
                        self.tun_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-id"):
                        self.tunnel_id = value
                        self.tunnel_id.value_namespace = name_space
                        self.tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-name"):
                        self.tunnel_name = value
                        self.tunnel_name.value_namespace = name_space
                        self.tunnel_name.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.tunnel_flex_lsp:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.tunnel_flex_lsp:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "tunnel-flex-lsps" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "tunnel-flex-lsp"):
                    for c in self.tunnel_flex_lsp:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTeStandby.Tunnels.TunnelFlexLsps.TunnelFlexLsp()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.tunnel_flex_lsp.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "tunnel-flex-lsp"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass


        class TunnelAutoBandwidths(Entity):
            """
            Auto Bandwidth Brief Table
            
            .. attribute:: tunnel_auto_bandwidth
            
            	Auto Bandwidth info bag
            	**type**\: list of    :py:class:`TunnelAutoBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelAutoBandwidths.TunnelAutoBandwidth>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTeStandby.Tunnels.TunnelAutoBandwidths, self).__init__()

                self.yang_name = "tunnel-auto-bandwidths"
                self.yang_parent_name = "tunnels"

                self.tunnel_auto_bandwidth = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTeStandby.Tunnels.TunnelAutoBandwidths, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTeStandby.Tunnels.TunnelAutoBandwidths, self).__setattr__(name, value)


            class TunnelAutoBandwidth(Entity):
                """
                Auto Bandwidth info bag
                
                .. attribute:: tunnel_name  <key>
                
                	Tunnel Name
                	**type**\:  str
                
                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                
                .. attribute:: auto_bandwidth_status
                
                	Tunnels's AutoBandwidth Status information
                	**type**\:   :py:class:`AutoBandwidthStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelAutoBandwidths.TunnelAutoBandwidth.AutoBandwidthStatus>`
                
                .. attribute:: bandwidth_applications
                
                	Total number of bandwidth applications requested by auto\-bw
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: highest_bandwidth
                
                	Highest bandwidth registered within current application period
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: last_bandwidth_applied
                
                	Last bandwidth requested by auto\-bw for the tunnel
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: last_sample_bandwidth
                
                	Last sample bandwidth collected
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: samples_collected
                
                	Number of samples collected within current application period
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: signaled_name
                
                	Tunnel signaled name
                	**type**\:  str
                
                .. attribute:: signalled_bandwidth
                
                	Signalled bandwidth for the tunnel
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: time_left_application
                
                	Time left until next auto\-bw application algorithm is performed
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: tunnel_lsp_id
                
                	Tunnel Lsp Id
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: tunnel_name_xr
                
                	Tunnel name
                	**type**\:  str
                
                .. attribute:: tunnel_requested_bandwidth
                
                	Requested Bandwidth for the tunnel
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTeStandby.Tunnels.TunnelAutoBandwidths.TunnelAutoBandwidth, self).__init__()

                    self.yang_name = "tunnel-auto-bandwidth"
                    self.yang_parent_name = "tunnel-auto-bandwidths"

                    self.tunnel_name = YLeaf(YType.str, "tunnel-name")

                    self.bandwidth_applications = YLeaf(YType.uint32, "bandwidth-applications")

                    self.highest_bandwidth = YLeaf(YType.uint32, "highest-bandwidth")

                    self.last_bandwidth_applied = YLeaf(YType.uint32, "last-bandwidth-applied")

                    self.last_sample_bandwidth = YLeaf(YType.uint32, "last-sample-bandwidth")

                    self.samples_collected = YLeaf(YType.uint32, "samples-collected")

                    self.signaled_name = YLeaf(YType.str, "signaled-name")

                    self.signalled_bandwidth = YLeaf(YType.uint32, "signalled-bandwidth")

                    self.time_left_application = YLeaf(YType.uint32, "time-left-application")

                    self.tunnel_lsp_id = YLeaf(YType.uint32, "tunnel-lsp-id")

                    self.tunnel_name_xr = YLeaf(YType.str, "tunnel-name-xr")

                    self.tunnel_requested_bandwidth = YLeaf(YType.uint32, "tunnel-requested-bandwidth")

                    self.auto_bandwidth_status = MplsTeStandby.Tunnels.TunnelAutoBandwidths.TunnelAutoBandwidth.AutoBandwidthStatus()
                    self.auto_bandwidth_status.parent = self
                    self._children_name_map["auto_bandwidth_status"] = "auto-bandwidth-status"
                    self._children_yang_names.add("auto-bandwidth-status")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("tunnel_name",
                                    "bandwidth_applications",
                                    "highest_bandwidth",
                                    "last_bandwidth_applied",
                                    "last_sample_bandwidth",
                                    "samples_collected",
                                    "signaled_name",
                                    "signalled_bandwidth",
                                    "time_left_application",
                                    "tunnel_lsp_id",
                                    "tunnel_name_xr",
                                    "tunnel_requested_bandwidth") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTeStandby.Tunnels.TunnelAutoBandwidths.TunnelAutoBandwidth, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTeStandby.Tunnels.TunnelAutoBandwidths.TunnelAutoBandwidth, self).__setattr__(name, value)


                class AutoBandwidthStatus(Entity):
                    """
                    Tunnels's AutoBandwidth Status information
                    
                    .. attribute:: is_auto_bandwidth_enabled
                    
                    	TRUE if auto\-bw is enabled for the tunnel
                    	**type**\:  bool
                    
                    .. attribute:: reactivation_time
                    
                    	Time until auto\-bw gets activated if activation has been delayed due to failover
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.Tunnels.TunnelAutoBandwidths.TunnelAutoBandwidth.AutoBandwidthStatus, self).__init__()

                        self.yang_name = "auto-bandwidth-status"
                        self.yang_parent_name = "tunnel-auto-bandwidth"

                        self.is_auto_bandwidth_enabled = YLeaf(YType.boolean, "is-auto-bandwidth-enabled")

                        self.reactivation_time = YLeaf(YType.uint32, "reactivation-time")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("is_auto_bandwidth_enabled",
                                        "reactivation_time") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.Tunnels.TunnelAutoBandwidths.TunnelAutoBandwidth.AutoBandwidthStatus, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.Tunnels.TunnelAutoBandwidths.TunnelAutoBandwidth.AutoBandwidthStatus, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.is_auto_bandwidth_enabled.is_set or
                            self.reactivation_time.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.is_auto_bandwidth_enabled.yfilter != YFilter.not_set or
                            self.reactivation_time.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "auto-bandwidth-status" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.is_auto_bandwidth_enabled.is_set or self.is_auto_bandwidth_enabled.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_auto_bandwidth_enabled.get_name_leafdata())
                        if (self.reactivation_time.is_set or self.reactivation_time.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reactivation_time.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "is-auto-bandwidth-enabled" or name == "reactivation-time"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "is-auto-bandwidth-enabled"):
                            self.is_auto_bandwidth_enabled = value
                            self.is_auto_bandwidth_enabled.value_namespace = name_space
                            self.is_auto_bandwidth_enabled.value_namespace_prefix = name_space_prefix
                        if(value_path == "reactivation-time"):
                            self.reactivation_time = value
                            self.reactivation_time.value_namespace = name_space
                            self.reactivation_time.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    return (
                        self.tunnel_name.is_set or
                        self.bandwidth_applications.is_set or
                        self.highest_bandwidth.is_set or
                        self.last_bandwidth_applied.is_set or
                        self.last_sample_bandwidth.is_set or
                        self.samples_collected.is_set or
                        self.signaled_name.is_set or
                        self.signalled_bandwidth.is_set or
                        self.time_left_application.is_set or
                        self.tunnel_lsp_id.is_set or
                        self.tunnel_name_xr.is_set or
                        self.tunnel_requested_bandwidth.is_set or
                        (self.auto_bandwidth_status is not None and self.auto_bandwidth_status.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.tunnel_name.yfilter != YFilter.not_set or
                        self.bandwidth_applications.yfilter != YFilter.not_set or
                        self.highest_bandwidth.yfilter != YFilter.not_set or
                        self.last_bandwidth_applied.yfilter != YFilter.not_set or
                        self.last_sample_bandwidth.yfilter != YFilter.not_set or
                        self.samples_collected.yfilter != YFilter.not_set or
                        self.signaled_name.yfilter != YFilter.not_set or
                        self.signalled_bandwidth.yfilter != YFilter.not_set or
                        self.time_left_application.yfilter != YFilter.not_set or
                        self.tunnel_lsp_id.yfilter != YFilter.not_set or
                        self.tunnel_name_xr.yfilter != YFilter.not_set or
                        self.tunnel_requested_bandwidth.yfilter != YFilter.not_set or
                        (self.auto_bandwidth_status is not None and self.auto_bandwidth_status.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "tunnel-auto-bandwidth" + "[tunnel-name='" + self.tunnel_name.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-auto-bandwidths/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.tunnel_name.is_set or self.tunnel_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_name.get_name_leafdata())
                    if (self.bandwidth_applications.is_set or self.bandwidth_applications.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.bandwidth_applications.get_name_leafdata())
                    if (self.highest_bandwidth.is_set or self.highest_bandwidth.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.highest_bandwidth.get_name_leafdata())
                    if (self.last_bandwidth_applied.is_set or self.last_bandwidth_applied.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.last_bandwidth_applied.get_name_leafdata())
                    if (self.last_sample_bandwidth.is_set or self.last_sample_bandwidth.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.last_sample_bandwidth.get_name_leafdata())
                    if (self.samples_collected.is_set or self.samples_collected.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.samples_collected.get_name_leafdata())
                    if (self.signaled_name.is_set or self.signaled_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.signaled_name.get_name_leafdata())
                    if (self.signalled_bandwidth.is_set or self.signalled_bandwidth.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.signalled_bandwidth.get_name_leafdata())
                    if (self.time_left_application.is_set or self.time_left_application.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.time_left_application.get_name_leafdata())
                    if (self.tunnel_lsp_id.is_set or self.tunnel_lsp_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_lsp_id.get_name_leafdata())
                    if (self.tunnel_name_xr.is_set or self.tunnel_name_xr.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_name_xr.get_name_leafdata())
                    if (self.tunnel_requested_bandwidth.is_set or self.tunnel_requested_bandwidth.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_requested_bandwidth.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "auto-bandwidth-status"):
                        if (self.auto_bandwidth_status is None):
                            self.auto_bandwidth_status = MplsTeStandby.Tunnels.TunnelAutoBandwidths.TunnelAutoBandwidth.AutoBandwidthStatus()
                            self.auto_bandwidth_status.parent = self
                            self._children_name_map["auto_bandwidth_status"] = "auto-bandwidth-status"
                        return self.auto_bandwidth_status

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "auto-bandwidth-status" or name == "tunnel-name" or name == "bandwidth-applications" or name == "highest-bandwidth" or name == "last-bandwidth-applied" or name == "last-sample-bandwidth" or name == "samples-collected" or name == "signaled-name" or name == "signalled-bandwidth" or name == "time-left-application" or name == "tunnel-lsp-id" or name == "tunnel-name-xr" or name == "tunnel-requested-bandwidth"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "tunnel-name"):
                        self.tunnel_name = value
                        self.tunnel_name.value_namespace = name_space
                        self.tunnel_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "bandwidth-applications"):
                        self.bandwidth_applications = value
                        self.bandwidth_applications.value_namespace = name_space
                        self.bandwidth_applications.value_namespace_prefix = name_space_prefix
                    if(value_path == "highest-bandwidth"):
                        self.highest_bandwidth = value
                        self.highest_bandwidth.value_namespace = name_space
                        self.highest_bandwidth.value_namespace_prefix = name_space_prefix
                    if(value_path == "last-bandwidth-applied"):
                        self.last_bandwidth_applied = value
                        self.last_bandwidth_applied.value_namespace = name_space
                        self.last_bandwidth_applied.value_namespace_prefix = name_space_prefix
                    if(value_path == "last-sample-bandwidth"):
                        self.last_sample_bandwidth = value
                        self.last_sample_bandwidth.value_namespace = name_space
                        self.last_sample_bandwidth.value_namespace_prefix = name_space_prefix
                    if(value_path == "samples-collected"):
                        self.samples_collected = value
                        self.samples_collected.value_namespace = name_space
                        self.samples_collected.value_namespace_prefix = name_space_prefix
                    if(value_path == "signaled-name"):
                        self.signaled_name = value
                        self.signaled_name.value_namespace = name_space
                        self.signaled_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "signalled-bandwidth"):
                        self.signalled_bandwidth = value
                        self.signalled_bandwidth.value_namespace = name_space
                        self.signalled_bandwidth.value_namespace_prefix = name_space_prefix
                    if(value_path == "time-left-application"):
                        self.time_left_application = value
                        self.time_left_application.value_namespace = name_space
                        self.time_left_application.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-lsp-id"):
                        self.tunnel_lsp_id = value
                        self.tunnel_lsp_id.value_namespace = name_space
                        self.tunnel_lsp_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-name-xr"):
                        self.tunnel_name_xr = value
                        self.tunnel_name_xr.value_namespace = name_space
                        self.tunnel_name_xr.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-requested-bandwidth"):
                        self.tunnel_requested_bandwidth = value
                        self.tunnel_requested_bandwidth.value_namespace = name_space
                        self.tunnel_requested_bandwidth.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.tunnel_auto_bandwidth:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.tunnel_auto_bandwidth:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "tunnel-auto-bandwidths" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "tunnel-auto-bandwidth"):
                    for c in self.tunnel_auto_bandwidth:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTeStandby.Tunnels.TunnelAutoBandwidths.TunnelAutoBandwidth()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.tunnel_auto_bandwidth.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "tunnel-auto-bandwidth"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass


        class Summary(Entity):
            """
            Summary of tunnel info
            
            .. attribute:: activated_heads
            
            	Total tunnel heads activated
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: auto_bandwidth_collection_period
            
            	Collection period in minutes
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            	**units**\: minute
            
            .. attribute:: auto_bandwidth_tunnels
            
            	Counter with number of auto\-bw enabled tunnels
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: auto_mesh_one_hop_summary
            
            	Automesh Onehop summary
            	**type**\:   :py:class:`AutoMeshOneHopSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.Summary.AutoMeshOneHopSummary>`
            
            .. attribute:: auto_mesh_summary
            
            	Automesh summary
            	**type**\:   :py:class:`AutoMeshSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.Summary.AutoMeshSummary>`
            
            .. attribute:: auto_tun_server_summary
            
            	Auto\-tunnel server tunnel summary
            	**type**\:   :py:class:`AutoTunServerSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.Summary.AutoTunServerSummary>`
            
            .. attribute:: autobackup_summary
            
            	Autobackup summary
            	**type**\:   :py:class:`AutobackupSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.Summary.AutobackupSummary>`
            
            .. attribute:: backup_tunnels
            
            	FRR backup tunnels in Up state
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: backups_assigned
            
            	FRR backup tunnels assigned
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: bidir_head_ls_ps_associated
            
            	Associated Bidirectional Head LSPs
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: bidir_head_ls_ps_proceeding
            
            	Proceeding Bidirectional Head LSPs
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: bidir_head_ls_ps_standby
            
            	Standby Bidirectional Head LSPs
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: bidir_head_ls_ps_up
            
            	Connected Bidirectional Head Tunnel interfaces
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: bidir_head_tunnels
            
            	Bidirectional Head Tunnel interfaces
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: bidir_head_tunnels_associated
            
            	Associated Bidirectional Head Tunnels
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: bidir_head_tunnels_corouted
            
            	Corouted Bidirectional Head Tunnels
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: bidir_head_tunnels_up
            
            	Connected Bidirectional Head Tunnel interfaces
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: bidir_mid_ls_ps_associated
            
            	Associated Bidirectional Mid LSPs
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: bidir_mid_ls_ps_proceeding
            
            	Proceeding Bidirectional Mid LSPs
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: bidir_mid_ls_ps_standby
            
            	Standby Bidirectional Mid LSPs
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: bidir_mid_tunnels
            
            	Bidirectional Mid Tunnel interfaces
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: bidir_mid_tunnels_up
            
            	Connected Bidirectional Mid Tunnel interfaces
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: bidir_tail_ls_ps
            
            	Bidirectional Tail LSPs
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: bidir_tail_ls_ps_associated
            
            	Associated Bidirectional Tail LSPs
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: bidir_tail_ls_ps_corouted
            
            	Corouted Bidirectional Tail LSPs
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: bidir_tail_ls_ps_proceeding
            
            	Proceeding Bidirectional Tail LSPs
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: bidir_tail_ls_ps_standby
            
            	Standby Bidirectional Tail LSPs
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: bidir_tail_ls_ps_up
            
            	Connected Bidirectional Tail LSPs
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: bw_protected_p2mp_s2_ls
            
            	P2MP S2Ls BW Protected
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: bw_protected_p2p_s2_ls
            
            	p2p S2Ls BW Protected
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: bw_protected_p2p_tunnels
            
            	P2P FRR BW protected tunnels
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: bw_protected_tunnels
            
            	FRR BW protected tunnels
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: current_tunnel_convergence_summary
            
            	Current Tunnel convergemce summary information
            	**type**\:   :py:class:`CurrentTunnelConvergenceSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.Summary.CurrentTunnelConvergenceSummary>`
            
            .. attribute:: deactivated_heads
            
            	Total tunnel heads deactivated
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: dynamic_up_p2p_head_tunnels
            
            	p2p Tunnel up via a dynamic path
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: frr_config_p2mp_head_tunnels
            
            	P2MP Tunnel interfaces with FRR configuration
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: frr_config_p2p_head_tunnels
            
            	p2p Tunnel interfaces with FRR configuration
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: frr_head_tunnels
            
            	FRR tunnels in Up state at head end
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: frr_mid_point_tunnels
            
            	FRR tunnels at mid point
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: frr_p2mp_head_s2_ls
            
            	P2MP S2Ls with FRR requested at Head
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: frr_p2mp_mid_point_s2_ls
            
            	P2MP S2Ls with FRR requested at Mid
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: frr_p2p_head_s2_ls
            
            	p2p S2Ls with FRR requested at Head
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: frr_p2p_head_tunnels
            
            	P2P FRR tunnels in Up state at head end
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: frr_p2p_mid_point_s2_ls
            
            	p2p S2Ls with FRR requested at Mid
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: frr_p2p_mid_point_tunnels
            
            	P2P FRR tunnels at mid point
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: frr_protected_interfaces
            
            	FRR Protected Interfaces
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: gmpls_nni_summary
            
            	GMPLS\-NNI summary
            	**type**\:   :py:class:`GmplsNniSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.Summary.GmplsNniSummary>`
            
            .. attribute:: gmpls_uni_summary
            
            	GMPLS\-UNI summary
            	**type**\:   :py:class:`GmplsUniSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.Summary.GmplsUniSummary>`
            
            .. attribute:: is_forwarding_enabled
            
            	TRUE if forwarding is enabled
            	**type**\:  bool
            
            .. attribute:: is_periodic_reoptimization_on
            
            	TRUE if periodic reoptimization is on
            	**type**\:  bool
            
            .. attribute:: is_promotion_on
            
            	TRUE if periodic frr promotion is on
            	**type**\:  bool
            
            .. attribute:: is_rsvp_process_enabled
            
            	Status of rsvp
            	**type**\:  bool
            
            .. attribute:: last_tunnel_convergence_summary
            
            	Last Tunnel convergemce summary information
            	**type**\:   :py:class:`LastTunnelConvergenceSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.Summary.LastTunnelConvergenceSummary>`
            
            .. attribute:: link_and_node_diverse_paths
            
            	Link and Node diverse paths
            	**type**\:  int
            
            	**range:** 0..65535
            
            .. attribute:: link_diverse_paths
            
            	Link diverse paths
            	**type**\:  int
            
            	**range:** 0..65535
            
            .. attribute:: link_protected_p2mp_s2_ls
            
            	P2MP S2Ls Link Protected
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: link_protected_p2p_s2_ls
            
            	p2p S2Ls Link Protected
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: link_protected_p2p_tunnels
            
            	P2P FRR link protected tunnels
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: link_protected_tunnels
            
            	FRR link protected tunnels
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: next_check_time
            
            	Time left till next FRR promotion (seconds)
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            	**units**\: second
            
            .. attribute:: next_promotion_timer
            
            	Time left till next FRR promotion (seconds)
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            	**units**\: second
            
            .. attribute:: next_reoptimization_timer
            
            	Time left till next reoptimization (seconds)
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            	**units**\: second
            
            .. attribute:: next_verify_timer
            
            	Time left till next FRR promotion (seconds)
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            	**units**\: second
            
            .. attribute:: node_diverse_paths
            
            	Node diverse paths
            	**type**\:  int
            
            	**range:** 0..65535
            
            .. attribute:: node_protected_p2p_tunnels
            
            	P2P FRR node protected tunnels
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: node_protected_tunnels
            
            	FRR node protected tunnels
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: p2mp_head_destinations
            
            	P2MP Destinations at Head
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: p2mp_head_tunnels
            
            	P2MP Tunnel interfaces
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: p2mp_mid_point_s2_ls
            
            	P2MP S2Ls at Mid
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: p2mp_tail_s2_ls
            
            	P2MP S2Ls at Tail
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: p2p_head_destinations
            
            	p2p Destinations at Head
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: p2p_head_destinations_up
            
            	p2p Destinations in Up state at Head
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: p2p_head_tunnels
            
            	p2p Tunnel interfaces
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: p2p_mid_point_s2_ls
            
            	p2p S2Ls at Mid
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: p2p_tail_s2_ls
            
            	p2p S2Ls at Tail
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: p2p_tail_tunnels
            
            	p2p Tunnel tail interfaces
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: path_protect_configured_tunnels
            
            	Tunnels configured with Path Protect
            	**type**\:  int
            
            	**range:** 0..65535
            
            .. attribute:: path_protect_configured_tunnels_standby_up
            
            	Tunnels with standby LSP up
            	**type**\:  int
            
            	**range:** 0..65535
            
            .. attribute:: path_protect_configured_tunnels_up
            
            	Path Protect configured tunnels connected/up
            	**type**\:  int
            
            	**range:** 0..65535
            
            .. attribute:: pcalc_tie_breaker_type
            
            	PCALC tiebreaker type
            	**type**\:   :py:class:`TePathSelectionTiebreaker <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePathSelectionTiebreaker>`
            
            .. attribute:: pcalc_tiebreaker
            
            	Deprecated \- replaced by PCALCTiebreakerType
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: proceeding_p2mp_head_s2_ls
            
            	P2MP S2Ls in signalling\-proceeding state at Head
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: proceeding_p2mp_mid_point_s2_ls
            
            	P2MP S2Ls in signalling=proceeding state at Mid
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: proceeding_p2p_head_s2_ls
            
            	p2p S2Ls in signalling\-proceeding state at Head
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: proceeding_p2p_mid_point_s2_ls
            
            	p2p S2Ls in signalling=proceeding state at Mid
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: promotion_period
            
            	FRR promotion period in seconds
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            	**units**\: second
            
            .. attribute:: protected_head_tunnels
            
            	FRR protected tunnels in Up state at head end
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: protected_mid_point_tunnels
            
            	FRR protected tunnels at mid point
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: protected_p2mp_head_s2_ls
            
            	P2MP S2Ls FRR Protected at Head
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: protected_p2mp_mid_point_s2_ls
            
            	P2MP S2Ls FRR Protected at Mid
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: protected_p2p_head_s2_ls
            
            	p2p S2Ls FRR Protected at Head
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: protected_p2p_head_tunnels
            
            	P2P FRR protected tunnels in Up state at head end
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: protected_p2p_mid_point_s2_ls
            
            	p2p S2Ls FRR Protected at Mid
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: protected_p2p_mid_point_tunnels
            
            	P2P FRR protected tunnels at mid point
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: recovered_heads
            
            	Number of heads recovered
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: recovering_p2p_head_s2_ls
            
            	p2p S2Ls recovering at Head
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: reoptimization_period
            
            	Reoptimization period in seconds
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            	**units**\: second
            
            .. attribute:: rerouted_head_tunnels
            
            	FRR rerouted tunnels in Up state at head end
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: rerouted_interfaces
            
            	FRR Rerouted Interfaces
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: rerouted_mid_point_tunnels
            
            	FRR rerouted tunnels at mid point
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: rerouted_p2mp_head_s2_ls
            
            	P2MP S2Ls FRR Rerouted at Head
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: rerouted_p2mp_mid_point_s2_ls
            
            	P2MP S2Ls FRR Rerouted at Mid
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: rerouted_p2p_head_s2_ls
            
            	p2p S2Ls FRR Rerouted at Head
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: rerouted_p2p_head_tunnels
            
            	P2P FRR rerouted tunnels in Up state at head end
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: rerouted_p2p_mid_point_s2_ls
            
            	p2p S2Ls FRR Rerouted at Mid
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: rerouted_p2p_mid_point_tunnels
            
            	P2P FRR rerouted tunnels at mid point
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: te_process_status
            
            	Status of te\_control
            	**type**\:   :py:class:`MplsTeTunnelsProcessStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelsProcessStatus>`
            
            .. attribute:: tiebreaker_qualifier
            
            	Describes how the path selection tiebreaker was specified\:default, or globally set
            	**type**\:   :py:class:`MplsTeMetricQualifier <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeMetricQualifier>`
            
            .. attribute:: tunnel_check_period
            
            	Tunnel head check period (seconds)
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            	**units**\: second
            
            .. attribute:: tunnel_verify_period
            
            	Tunnel head verify period (seconds)
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            	**units**\: second
            
            .. attribute:: up_p2mp_head_destinations
            
            	P2MP Destinations in Up state at Head
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: up_p2mp_head_s2_ls
            
            	P2MP S2Ls in Up state at Head
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: up_p2mp_head_tunnels
            
            	P2MP Tunnel interfaces in Up state
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: up_p2mp_mid_point_s2_ls
            
            	P2MP S2Ls in Up state at Mid
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: up_p2mp_tail_s2_ls
            
            	P2MP S2Ls in Up state at Tail
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: up_p2p_head_s2_ls
            
            	p2p S2Ls in Up state at Head
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: up_p2p_head_tunnels
            
            	p2p Tunnel interfaces in Up state
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: up_p2p_mid_point_s2_ls
            
            	p2p S2Ls in Up state at Mid
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: up_p2p_tail_s2_ls
            
            	p2p S2Ls in Up state at Tail
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: user_defined_paths
            
            	User defined paths
            	**type**\:  int
            
            	**range:** 0..65535
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTeStandby.Tunnels.Summary, self).__init__()

                self.yang_name = "summary"
                self.yang_parent_name = "tunnels"

                self.activated_heads = YLeaf(YType.uint32, "activated-heads")

                self.auto_bandwidth_collection_period = YLeaf(YType.uint32, "auto-bandwidth-collection-period")

                self.auto_bandwidth_tunnels = YLeaf(YType.uint32, "auto-bandwidth-tunnels")

                self.backup_tunnels = YLeaf(YType.uint32, "backup-tunnels")

                self.backups_assigned = YLeaf(YType.uint32, "backups-assigned")

                self.bidir_head_ls_ps_associated = YLeaf(YType.uint32, "bidir-head-ls-ps-associated")

                self.bidir_head_ls_ps_proceeding = YLeaf(YType.uint32, "bidir-head-ls-ps-proceeding")

                self.bidir_head_ls_ps_standby = YLeaf(YType.uint32, "bidir-head-ls-ps-standby")

                self.bidir_head_ls_ps_up = YLeaf(YType.uint32, "bidir-head-ls-ps-up")

                self.bidir_head_tunnels = YLeaf(YType.uint32, "bidir-head-tunnels")

                self.bidir_head_tunnels_associated = YLeaf(YType.uint32, "bidir-head-tunnels-associated")

                self.bidir_head_tunnels_corouted = YLeaf(YType.uint32, "bidir-head-tunnels-corouted")

                self.bidir_head_tunnels_up = YLeaf(YType.uint32, "bidir-head-tunnels-up")

                self.bidir_mid_ls_ps_associated = YLeaf(YType.uint32, "bidir-mid-ls-ps-associated")

                self.bidir_mid_ls_ps_proceeding = YLeaf(YType.uint32, "bidir-mid-ls-ps-proceeding")

                self.bidir_mid_ls_ps_standby = YLeaf(YType.uint32, "bidir-mid-ls-ps-standby")

                self.bidir_mid_tunnels = YLeaf(YType.uint32, "bidir-mid-tunnels")

                self.bidir_mid_tunnels_up = YLeaf(YType.uint32, "bidir-mid-tunnels-up")

                self.bidir_tail_ls_ps = YLeaf(YType.uint32, "bidir-tail-ls-ps")

                self.bidir_tail_ls_ps_associated = YLeaf(YType.uint32, "bidir-tail-ls-ps-associated")

                self.bidir_tail_ls_ps_corouted = YLeaf(YType.uint32, "bidir-tail-ls-ps-corouted")

                self.bidir_tail_ls_ps_proceeding = YLeaf(YType.uint32, "bidir-tail-ls-ps-proceeding")

                self.bidir_tail_ls_ps_standby = YLeaf(YType.uint32, "bidir-tail-ls-ps-standby")

                self.bidir_tail_ls_ps_up = YLeaf(YType.uint32, "bidir-tail-ls-ps-up")

                self.bw_protected_p2mp_s2_ls = YLeaf(YType.uint32, "bw-protected-p2mp-s2-ls")

                self.bw_protected_p2p_s2_ls = YLeaf(YType.uint32, "bw-protected-p2p-s2-ls")

                self.bw_protected_p2p_tunnels = YLeaf(YType.uint32, "bw-protected-p2p-tunnels")

                self.bw_protected_tunnels = YLeaf(YType.uint32, "bw-protected-tunnels")

                self.deactivated_heads = YLeaf(YType.uint32, "deactivated-heads")

                self.dynamic_up_p2p_head_tunnels = YLeaf(YType.uint32, "dynamic-up-p2p-head-tunnels")

                self.frr_config_p2mp_head_tunnels = YLeaf(YType.uint32, "frr-config-p2mp-head-tunnels")

                self.frr_config_p2p_head_tunnels = YLeaf(YType.uint32, "frr-config-p2p-head-tunnels")

                self.frr_head_tunnels = YLeaf(YType.uint32, "frr-head-tunnels")

                self.frr_mid_point_tunnels = YLeaf(YType.uint32, "frr-mid-point-tunnels")

                self.frr_p2mp_head_s2_ls = YLeaf(YType.uint32, "frr-p2mp-head-s2-ls")

                self.frr_p2mp_mid_point_s2_ls = YLeaf(YType.uint32, "frr-p2mp-mid-point-s2-ls")

                self.frr_p2p_head_s2_ls = YLeaf(YType.uint32, "frr-p2p-head-s2-ls")

                self.frr_p2p_head_tunnels = YLeaf(YType.uint32, "frr-p2p-head-tunnels")

                self.frr_p2p_mid_point_s2_ls = YLeaf(YType.uint32, "frr-p2p-mid-point-s2-ls")

                self.frr_p2p_mid_point_tunnels = YLeaf(YType.uint32, "frr-p2p-mid-point-tunnels")

                self.frr_protected_interfaces = YLeaf(YType.uint32, "frr-protected-interfaces")

                self.is_forwarding_enabled = YLeaf(YType.boolean, "is-forwarding-enabled")

                self.is_periodic_reoptimization_on = YLeaf(YType.boolean, "is-periodic-reoptimization-on")

                self.is_promotion_on = YLeaf(YType.boolean, "is-promotion-on")

                self.is_rsvp_process_enabled = YLeaf(YType.boolean, "is-rsvp-process-enabled")

                self.link_and_node_diverse_paths = YLeaf(YType.uint16, "link-and-node-diverse-paths")

                self.link_diverse_paths = YLeaf(YType.uint16, "link-diverse-paths")

                self.link_protected_p2mp_s2_ls = YLeaf(YType.uint32, "link-protected-p2mp-s2-ls")

                self.link_protected_p2p_s2_ls = YLeaf(YType.uint32, "link-protected-p2p-s2-ls")

                self.link_protected_p2p_tunnels = YLeaf(YType.uint32, "link-protected-p2p-tunnels")

                self.link_protected_tunnels = YLeaf(YType.uint32, "link-protected-tunnels")

                self.next_check_time = YLeaf(YType.uint32, "next-check-time")

                self.next_promotion_timer = YLeaf(YType.uint32, "next-promotion-timer")

                self.next_reoptimization_timer = YLeaf(YType.uint32, "next-reoptimization-timer")

                self.next_verify_timer = YLeaf(YType.uint32, "next-verify-timer")

                self.node_diverse_paths = YLeaf(YType.uint16, "node-diverse-paths")

                self.node_protected_p2p_tunnels = YLeaf(YType.uint32, "node-protected-p2p-tunnels")

                self.node_protected_tunnels = YLeaf(YType.uint32, "node-protected-tunnels")

                self.p2mp_head_destinations = YLeaf(YType.uint32, "p2mp-head-destinations")

                self.p2mp_head_tunnels = YLeaf(YType.uint32, "p2mp-head-tunnels")

                self.p2mp_mid_point_s2_ls = YLeaf(YType.uint32, "p2mp-mid-point-s2-ls")

                self.p2mp_tail_s2_ls = YLeaf(YType.uint32, "p2mp-tail-s2-ls")

                self.p2p_head_destinations = YLeaf(YType.uint32, "p2p-head-destinations")

                self.p2p_head_destinations_up = YLeaf(YType.uint32, "p2p-head-destinations-up")

                self.p2p_head_tunnels = YLeaf(YType.uint32, "p2p-head-tunnels")

                self.p2p_mid_point_s2_ls = YLeaf(YType.uint32, "p2p-mid-point-s2-ls")

                self.p2p_tail_s2_ls = YLeaf(YType.uint32, "p2p-tail-s2-ls")

                self.p2p_tail_tunnels = YLeaf(YType.uint32, "p2p-tail-tunnels")

                self.path_protect_configured_tunnels = YLeaf(YType.uint16, "path-protect-configured-tunnels")

                self.path_protect_configured_tunnels_standby_up = YLeaf(YType.uint16, "path-protect-configured-tunnels-standby-up")

                self.path_protect_configured_tunnels_up = YLeaf(YType.uint16, "path-protect-configured-tunnels-up")

                self.pcalc_tie_breaker_type = YLeaf(YType.enumeration, "pcalc-tie-breaker-type")

                self.pcalc_tiebreaker = YLeaf(YType.uint32, "pcalc-tiebreaker")

                self.proceeding_p2mp_head_s2_ls = YLeaf(YType.uint32, "proceeding-p2mp-head-s2-ls")

                self.proceeding_p2mp_mid_point_s2_ls = YLeaf(YType.uint32, "proceeding-p2mp-mid-point-s2-ls")

                self.proceeding_p2p_head_s2_ls = YLeaf(YType.uint32, "proceeding-p2p-head-s2-ls")

                self.proceeding_p2p_mid_point_s2_ls = YLeaf(YType.uint32, "proceeding-p2p-mid-point-s2-ls")

                self.promotion_period = YLeaf(YType.uint32, "promotion-period")

                self.protected_head_tunnels = YLeaf(YType.uint32, "protected-head-tunnels")

                self.protected_mid_point_tunnels = YLeaf(YType.uint32, "protected-mid-point-tunnels")

                self.protected_p2mp_head_s2_ls = YLeaf(YType.uint32, "protected-p2mp-head-s2-ls")

                self.protected_p2mp_mid_point_s2_ls = YLeaf(YType.uint32, "protected-p2mp-mid-point-s2-ls")

                self.protected_p2p_head_s2_ls = YLeaf(YType.uint32, "protected-p2p-head-s2-ls")

                self.protected_p2p_head_tunnels = YLeaf(YType.uint32, "protected-p2p-head-tunnels")

                self.protected_p2p_mid_point_s2_ls = YLeaf(YType.uint32, "protected-p2p-mid-point-s2-ls")

                self.protected_p2p_mid_point_tunnels = YLeaf(YType.uint32, "protected-p2p-mid-point-tunnels")

                self.recovered_heads = YLeaf(YType.uint32, "recovered-heads")

                self.recovering_p2p_head_s2_ls = YLeaf(YType.uint32, "recovering-p2p-head-s2-ls")

                self.reoptimization_period = YLeaf(YType.uint32, "reoptimization-period")

                self.rerouted_head_tunnels = YLeaf(YType.uint32, "rerouted-head-tunnels")

                self.rerouted_interfaces = YLeaf(YType.uint32, "rerouted-interfaces")

                self.rerouted_mid_point_tunnels = YLeaf(YType.uint32, "rerouted-mid-point-tunnels")

                self.rerouted_p2mp_head_s2_ls = YLeaf(YType.uint32, "rerouted-p2mp-head-s2-ls")

                self.rerouted_p2mp_mid_point_s2_ls = YLeaf(YType.uint32, "rerouted-p2mp-mid-point-s2-ls")

                self.rerouted_p2p_head_s2_ls = YLeaf(YType.uint32, "rerouted-p2p-head-s2-ls")

                self.rerouted_p2p_head_tunnels = YLeaf(YType.uint32, "rerouted-p2p-head-tunnels")

                self.rerouted_p2p_mid_point_s2_ls = YLeaf(YType.uint32, "rerouted-p2p-mid-point-s2-ls")

                self.rerouted_p2p_mid_point_tunnels = YLeaf(YType.uint32, "rerouted-p2p-mid-point-tunnels")

                self.te_process_status = YLeaf(YType.enumeration, "te-process-status")

                self.tiebreaker_qualifier = YLeaf(YType.enumeration, "tiebreaker-qualifier")

                self.tunnel_check_period = YLeaf(YType.uint32, "tunnel-check-period")

                self.tunnel_verify_period = YLeaf(YType.uint32, "tunnel-verify-period")

                self.up_p2mp_head_destinations = YLeaf(YType.uint32, "up-p2mp-head-destinations")

                self.up_p2mp_head_s2_ls = YLeaf(YType.uint32, "up-p2mp-head-s2-ls")

                self.up_p2mp_head_tunnels = YLeaf(YType.uint32, "up-p2mp-head-tunnels")

                self.up_p2mp_mid_point_s2_ls = YLeaf(YType.uint32, "up-p2mp-mid-point-s2-ls")

                self.up_p2mp_tail_s2_ls = YLeaf(YType.uint32, "up-p2mp-tail-s2-ls")

                self.up_p2p_head_s2_ls = YLeaf(YType.uint32, "up-p2p-head-s2-ls")

                self.up_p2p_head_tunnels = YLeaf(YType.uint32, "up-p2p-head-tunnels")

                self.up_p2p_mid_point_s2_ls = YLeaf(YType.uint32, "up-p2p-mid-point-s2-ls")

                self.up_p2p_tail_s2_ls = YLeaf(YType.uint32, "up-p2p-tail-s2-ls")

                self.user_defined_paths = YLeaf(YType.uint16, "user-defined-paths")

                self.auto_mesh_one_hop_summary = MplsTeStandby.Tunnels.Summary.AutoMeshOneHopSummary()
                self.auto_mesh_one_hop_summary.parent = self
                self._children_name_map["auto_mesh_one_hop_summary"] = "auto-mesh-one-hop-summary"
                self._children_yang_names.add("auto-mesh-one-hop-summary")

                self.auto_mesh_summary = MplsTeStandby.Tunnels.Summary.AutoMeshSummary()
                self.auto_mesh_summary.parent = self
                self._children_name_map["auto_mesh_summary"] = "auto-mesh-summary"
                self._children_yang_names.add("auto-mesh-summary")

                self.auto_tun_server_summary = MplsTeStandby.Tunnels.Summary.AutoTunServerSummary()
                self.auto_tun_server_summary.parent = self
                self._children_name_map["auto_tun_server_summary"] = "auto-tun-server-summary"
                self._children_yang_names.add("auto-tun-server-summary")

                self.autobackup_summary = MplsTeStandby.Tunnels.Summary.AutobackupSummary()
                self.autobackup_summary.parent = self
                self._children_name_map["autobackup_summary"] = "autobackup-summary"
                self._children_yang_names.add("autobackup-summary")

                self.current_tunnel_convergence_summary = MplsTeStandby.Tunnels.Summary.CurrentTunnelConvergenceSummary()
                self.current_tunnel_convergence_summary.parent = self
                self._children_name_map["current_tunnel_convergence_summary"] = "current-tunnel-convergence-summary"
                self._children_yang_names.add("current-tunnel-convergence-summary")

                self.gmpls_nni_summary = MplsTeStandby.Tunnels.Summary.GmplsNniSummary()
                self.gmpls_nni_summary.parent = self
                self._children_name_map["gmpls_nni_summary"] = "gmpls-nni-summary"
                self._children_yang_names.add("gmpls-nni-summary")

                self.gmpls_uni_summary = MplsTeStandby.Tunnels.Summary.GmplsUniSummary()
                self.gmpls_uni_summary.parent = self
                self._children_name_map["gmpls_uni_summary"] = "gmpls-uni-summary"
                self._children_yang_names.add("gmpls-uni-summary")

                self.last_tunnel_convergence_summary = MplsTeStandby.Tunnels.Summary.LastTunnelConvergenceSummary()
                self.last_tunnel_convergence_summary.parent = self
                self._children_name_map["last_tunnel_convergence_summary"] = "last-tunnel-convergence-summary"
                self._children_yang_names.add("last-tunnel-convergence-summary")

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("activated_heads",
                                "auto_bandwidth_collection_period",
                                "auto_bandwidth_tunnels",
                                "backup_tunnels",
                                "backups_assigned",
                                "bidir_head_ls_ps_associated",
                                "bidir_head_ls_ps_proceeding",
                                "bidir_head_ls_ps_standby",
                                "bidir_head_ls_ps_up",
                                "bidir_head_tunnels",
                                "bidir_head_tunnels_associated",
                                "bidir_head_tunnels_corouted",
                                "bidir_head_tunnels_up",
                                "bidir_mid_ls_ps_associated",
                                "bidir_mid_ls_ps_proceeding",
                                "bidir_mid_ls_ps_standby",
                                "bidir_mid_tunnels",
                                "bidir_mid_tunnels_up",
                                "bidir_tail_ls_ps",
                                "bidir_tail_ls_ps_associated",
                                "bidir_tail_ls_ps_corouted",
                                "bidir_tail_ls_ps_proceeding",
                                "bidir_tail_ls_ps_standby",
                                "bidir_tail_ls_ps_up",
                                "bw_protected_p2mp_s2_ls",
                                "bw_protected_p2p_s2_ls",
                                "bw_protected_p2p_tunnels",
                                "bw_protected_tunnels",
                                "deactivated_heads",
                                "dynamic_up_p2p_head_tunnels",
                                "frr_config_p2mp_head_tunnels",
                                "frr_config_p2p_head_tunnels",
                                "frr_head_tunnels",
                                "frr_mid_point_tunnels",
                                "frr_p2mp_head_s2_ls",
                                "frr_p2mp_mid_point_s2_ls",
                                "frr_p2p_head_s2_ls",
                                "frr_p2p_head_tunnels",
                                "frr_p2p_mid_point_s2_ls",
                                "frr_p2p_mid_point_tunnels",
                                "frr_protected_interfaces",
                                "is_forwarding_enabled",
                                "is_periodic_reoptimization_on",
                                "is_promotion_on",
                                "is_rsvp_process_enabled",
                                "link_and_node_diverse_paths",
                                "link_diverse_paths",
                                "link_protected_p2mp_s2_ls",
                                "link_protected_p2p_s2_ls",
                                "link_protected_p2p_tunnels",
                                "link_protected_tunnels",
                                "next_check_time",
                                "next_promotion_timer",
                                "next_reoptimization_timer",
                                "next_verify_timer",
                                "node_diverse_paths",
                                "node_protected_p2p_tunnels",
                                "node_protected_tunnels",
                                "p2mp_head_destinations",
                                "p2mp_head_tunnels",
                                "p2mp_mid_point_s2_ls",
                                "p2mp_tail_s2_ls",
                                "p2p_head_destinations",
                                "p2p_head_destinations_up",
                                "p2p_head_tunnels",
                                "p2p_mid_point_s2_ls",
                                "p2p_tail_s2_ls",
                                "p2p_tail_tunnels",
                                "path_protect_configured_tunnels",
                                "path_protect_configured_tunnels_standby_up",
                                "path_protect_configured_tunnels_up",
                                "pcalc_tie_breaker_type",
                                "pcalc_tiebreaker",
                                "proceeding_p2mp_head_s2_ls",
                                "proceeding_p2mp_mid_point_s2_ls",
                                "proceeding_p2p_head_s2_ls",
                                "proceeding_p2p_mid_point_s2_ls",
                                "promotion_period",
                                "protected_head_tunnels",
                                "protected_mid_point_tunnels",
                                "protected_p2mp_head_s2_ls",
                                "protected_p2mp_mid_point_s2_ls",
                                "protected_p2p_head_s2_ls",
                                "protected_p2p_head_tunnels",
                                "protected_p2p_mid_point_s2_ls",
                                "protected_p2p_mid_point_tunnels",
                                "recovered_heads",
                                "recovering_p2p_head_s2_ls",
                                "reoptimization_period",
                                "rerouted_head_tunnels",
                                "rerouted_interfaces",
                                "rerouted_mid_point_tunnels",
                                "rerouted_p2mp_head_s2_ls",
                                "rerouted_p2mp_mid_point_s2_ls",
                                "rerouted_p2p_head_s2_ls",
                                "rerouted_p2p_head_tunnels",
                                "rerouted_p2p_mid_point_s2_ls",
                                "rerouted_p2p_mid_point_tunnels",
                                "te_process_status",
                                "tiebreaker_qualifier",
                                "tunnel_check_period",
                                "tunnel_verify_period",
                                "up_p2mp_head_destinations",
                                "up_p2mp_head_s2_ls",
                                "up_p2mp_head_tunnels",
                                "up_p2mp_mid_point_s2_ls",
                                "up_p2mp_tail_s2_ls",
                                "up_p2p_head_s2_ls",
                                "up_p2p_head_tunnels",
                                "up_p2p_mid_point_s2_ls",
                                "up_p2p_tail_s2_ls",
                                "user_defined_paths") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTeStandby.Tunnels.Summary, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTeStandby.Tunnels.Summary, self).__setattr__(name, value)


            class AutobackupSummary(Entity):
                """
                Autobackup summary
                
                .. attribute:: autobackups
                
                	Total number of autobackup tunnels
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: down_autobackups
                
                	Total number of autobackup tunnels that are down
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: next_hop_autobackup_protected_ls_ps
                
                	Total number of autobackup protected LSPs with NHOP and no SRLG
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: next_hop_autobackup_protected_s2_ls
                
                	Total number of autobackup protected S2Ls with NHOP and no SRLG
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: next_hop_autobackup_protected_s2l_families
                
                	Total number of autobackup protected S2L Families with NHOP and no SRLG
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: next_hop_autobackups
                
                	Total number of autobackup tunnels that are NHOP
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: next_hop_srlg_autobackup_protected_ls_ps
                
                	Total number of autobackup protected LSPs with NHOP and SRLG
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: next_hop_srlg_autobackup_protected_s2_ls
                
                	Total number of autobackup protected S2Ls with NHOP and SRLG
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: next_hop_srlg_autobackup_protected_s2l_families
                
                	Total number of autobackup protected S2L Families with NHOP and SRLG
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: next_next_hop_autobackup_protected_ls_ps
                
                	Total number of autobackup protected LSPs with NNHOP and no SRLG
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: next_next_hop_autobackup_protected_s2_ls
                
                	Total number of autobackup protected S2Ls with NNHOP and no SRLG
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: next_next_hop_autobackup_protected_s2l_families
                
                	Total number of autobackup protected S2L Families with NNHOP and no SRLG
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: next_next_hop_autobackups
                
                	Total number of autobackup tunnels that are NNHOP
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: next_next_hop_srlg_autobackup_protected_ls_ps
                
                	Total number of autobackup protected LSPs with NNHOP and SRLG
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: next_next_hop_srlg_autobackup_protected_s2_ls
                
                	Total number of autobackup protected S2Ls with NNHOP and SRLG
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: next_next_hop_srlg_autobackup_protected_s2l_families
                
                	Total number of autobackup protected S2L Families with NNHOP and SRLG
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: srlg_preferred_autobackups
                
                	Total number of autobackup tunnels that are using SRLG preferred
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: srlg_strict_autobackups
                
                	Total number of autobackup tunnels that are using SRLG strict
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: srlg_weighted_autobackups
                
                	Total number of autobackup tunnels that are using weighted SRLG
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: unused_autobackups
                
                	Total number of autobackup tunnels that are unused
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: up_autobackups
                
                	Total number of autobackup tunnels that are up
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTeStandby.Tunnels.Summary.AutobackupSummary, self).__init__()

                    self.yang_name = "autobackup-summary"
                    self.yang_parent_name = "summary"

                    self.autobackups = YLeaf(YType.uint32, "autobackups")

                    self.down_autobackups = YLeaf(YType.uint32, "down-autobackups")

                    self.next_hop_autobackup_protected_ls_ps = YLeaf(YType.uint32, "next-hop-autobackup-protected-ls-ps")

                    self.next_hop_autobackup_protected_s2_ls = YLeaf(YType.uint32, "next-hop-autobackup-protected-s2-ls")

                    self.next_hop_autobackup_protected_s2l_families = YLeaf(YType.uint32, "next-hop-autobackup-protected-s2l-families")

                    self.next_hop_autobackups = YLeaf(YType.uint32, "next-hop-autobackups")

                    self.next_hop_srlg_autobackup_protected_ls_ps = YLeaf(YType.uint32, "next-hop-srlg-autobackup-protected-ls-ps")

                    self.next_hop_srlg_autobackup_protected_s2_ls = YLeaf(YType.uint32, "next-hop-srlg-autobackup-protected-s2-ls")

                    self.next_hop_srlg_autobackup_protected_s2l_families = YLeaf(YType.uint32, "next-hop-srlg-autobackup-protected-s2l-families")

                    self.next_next_hop_autobackup_protected_ls_ps = YLeaf(YType.uint32, "next-next-hop-autobackup-protected-ls-ps")

                    self.next_next_hop_autobackup_protected_s2_ls = YLeaf(YType.uint32, "next-next-hop-autobackup-protected-s2-ls")

                    self.next_next_hop_autobackup_protected_s2l_families = YLeaf(YType.uint32, "next-next-hop-autobackup-protected-s2l-families")

                    self.next_next_hop_autobackups = YLeaf(YType.uint32, "next-next-hop-autobackups")

                    self.next_next_hop_srlg_autobackup_protected_ls_ps = YLeaf(YType.uint32, "next-next-hop-srlg-autobackup-protected-ls-ps")

                    self.next_next_hop_srlg_autobackup_protected_s2_ls = YLeaf(YType.uint32, "next-next-hop-srlg-autobackup-protected-s2-ls")

                    self.next_next_hop_srlg_autobackup_protected_s2l_families = YLeaf(YType.uint32, "next-next-hop-srlg-autobackup-protected-s2l-families")

                    self.srlg_preferred_autobackups = YLeaf(YType.uint32, "srlg-preferred-autobackups")

                    self.srlg_strict_autobackups = YLeaf(YType.uint32, "srlg-strict-autobackups")

                    self.srlg_weighted_autobackups = YLeaf(YType.uint32, "srlg-weighted-autobackups")

                    self.unused_autobackups = YLeaf(YType.uint32, "unused-autobackups")

                    self.up_autobackups = YLeaf(YType.uint32, "up-autobackups")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("autobackups",
                                    "down_autobackups",
                                    "next_hop_autobackup_protected_ls_ps",
                                    "next_hop_autobackup_protected_s2_ls",
                                    "next_hop_autobackup_protected_s2l_families",
                                    "next_hop_autobackups",
                                    "next_hop_srlg_autobackup_protected_ls_ps",
                                    "next_hop_srlg_autobackup_protected_s2_ls",
                                    "next_hop_srlg_autobackup_protected_s2l_families",
                                    "next_next_hop_autobackup_protected_ls_ps",
                                    "next_next_hop_autobackup_protected_s2_ls",
                                    "next_next_hop_autobackup_protected_s2l_families",
                                    "next_next_hop_autobackups",
                                    "next_next_hop_srlg_autobackup_protected_ls_ps",
                                    "next_next_hop_srlg_autobackup_protected_s2_ls",
                                    "next_next_hop_srlg_autobackup_protected_s2l_families",
                                    "srlg_preferred_autobackups",
                                    "srlg_strict_autobackups",
                                    "srlg_weighted_autobackups",
                                    "unused_autobackups",
                                    "up_autobackups") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTeStandby.Tunnels.Summary.AutobackupSummary, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTeStandby.Tunnels.Summary.AutobackupSummary, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.autobackups.is_set or
                        self.down_autobackups.is_set or
                        self.next_hop_autobackup_protected_ls_ps.is_set or
                        self.next_hop_autobackup_protected_s2_ls.is_set or
                        self.next_hop_autobackup_protected_s2l_families.is_set or
                        self.next_hop_autobackups.is_set or
                        self.next_hop_srlg_autobackup_protected_ls_ps.is_set or
                        self.next_hop_srlg_autobackup_protected_s2_ls.is_set or
                        self.next_hop_srlg_autobackup_protected_s2l_families.is_set or
                        self.next_next_hop_autobackup_protected_ls_ps.is_set or
                        self.next_next_hop_autobackup_protected_s2_ls.is_set or
                        self.next_next_hop_autobackup_protected_s2l_families.is_set or
                        self.next_next_hop_autobackups.is_set or
                        self.next_next_hop_srlg_autobackup_protected_ls_ps.is_set or
                        self.next_next_hop_srlg_autobackup_protected_s2_ls.is_set or
                        self.next_next_hop_srlg_autobackup_protected_s2l_families.is_set or
                        self.srlg_preferred_autobackups.is_set or
                        self.srlg_strict_autobackups.is_set or
                        self.srlg_weighted_autobackups.is_set or
                        self.unused_autobackups.is_set or
                        self.up_autobackups.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.autobackups.yfilter != YFilter.not_set or
                        self.down_autobackups.yfilter != YFilter.not_set or
                        self.next_hop_autobackup_protected_ls_ps.yfilter != YFilter.not_set or
                        self.next_hop_autobackup_protected_s2_ls.yfilter != YFilter.not_set or
                        self.next_hop_autobackup_protected_s2l_families.yfilter != YFilter.not_set or
                        self.next_hop_autobackups.yfilter != YFilter.not_set or
                        self.next_hop_srlg_autobackup_protected_ls_ps.yfilter != YFilter.not_set or
                        self.next_hop_srlg_autobackup_protected_s2_ls.yfilter != YFilter.not_set or
                        self.next_hop_srlg_autobackup_protected_s2l_families.yfilter != YFilter.not_set or
                        self.next_next_hop_autobackup_protected_ls_ps.yfilter != YFilter.not_set or
                        self.next_next_hop_autobackup_protected_s2_ls.yfilter != YFilter.not_set or
                        self.next_next_hop_autobackup_protected_s2l_families.yfilter != YFilter.not_set or
                        self.next_next_hop_autobackups.yfilter != YFilter.not_set or
                        self.next_next_hop_srlg_autobackup_protected_ls_ps.yfilter != YFilter.not_set or
                        self.next_next_hop_srlg_autobackup_protected_s2_ls.yfilter != YFilter.not_set or
                        self.next_next_hop_srlg_autobackup_protected_s2l_families.yfilter != YFilter.not_set or
                        self.srlg_preferred_autobackups.yfilter != YFilter.not_set or
                        self.srlg_strict_autobackups.yfilter != YFilter.not_set or
                        self.srlg_weighted_autobackups.yfilter != YFilter.not_set or
                        self.unused_autobackups.yfilter != YFilter.not_set or
                        self.up_autobackups.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "autobackup-summary" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/summary/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.autobackups.is_set or self.autobackups.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.autobackups.get_name_leafdata())
                    if (self.down_autobackups.is_set or self.down_autobackups.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.down_autobackups.get_name_leafdata())
                    if (self.next_hop_autobackup_protected_ls_ps.is_set or self.next_hop_autobackup_protected_ls_ps.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.next_hop_autobackup_protected_ls_ps.get_name_leafdata())
                    if (self.next_hop_autobackup_protected_s2_ls.is_set or self.next_hop_autobackup_protected_s2_ls.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.next_hop_autobackup_protected_s2_ls.get_name_leafdata())
                    if (self.next_hop_autobackup_protected_s2l_families.is_set or self.next_hop_autobackup_protected_s2l_families.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.next_hop_autobackup_protected_s2l_families.get_name_leafdata())
                    if (self.next_hop_autobackups.is_set or self.next_hop_autobackups.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.next_hop_autobackups.get_name_leafdata())
                    if (self.next_hop_srlg_autobackup_protected_ls_ps.is_set or self.next_hop_srlg_autobackup_protected_ls_ps.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.next_hop_srlg_autobackup_protected_ls_ps.get_name_leafdata())
                    if (self.next_hop_srlg_autobackup_protected_s2_ls.is_set or self.next_hop_srlg_autobackup_protected_s2_ls.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.next_hop_srlg_autobackup_protected_s2_ls.get_name_leafdata())
                    if (self.next_hop_srlg_autobackup_protected_s2l_families.is_set or self.next_hop_srlg_autobackup_protected_s2l_families.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.next_hop_srlg_autobackup_protected_s2l_families.get_name_leafdata())
                    if (self.next_next_hop_autobackup_protected_ls_ps.is_set or self.next_next_hop_autobackup_protected_ls_ps.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.next_next_hop_autobackup_protected_ls_ps.get_name_leafdata())
                    if (self.next_next_hop_autobackup_protected_s2_ls.is_set or self.next_next_hop_autobackup_protected_s2_ls.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.next_next_hop_autobackup_protected_s2_ls.get_name_leafdata())
                    if (self.next_next_hop_autobackup_protected_s2l_families.is_set or self.next_next_hop_autobackup_protected_s2l_families.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.next_next_hop_autobackup_protected_s2l_families.get_name_leafdata())
                    if (self.next_next_hop_autobackups.is_set or self.next_next_hop_autobackups.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.next_next_hop_autobackups.get_name_leafdata())
                    if (self.next_next_hop_srlg_autobackup_protected_ls_ps.is_set or self.next_next_hop_srlg_autobackup_protected_ls_ps.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.next_next_hop_srlg_autobackup_protected_ls_ps.get_name_leafdata())
                    if (self.next_next_hop_srlg_autobackup_protected_s2_ls.is_set or self.next_next_hop_srlg_autobackup_protected_s2_ls.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.next_next_hop_srlg_autobackup_protected_s2_ls.get_name_leafdata())
                    if (self.next_next_hop_srlg_autobackup_protected_s2l_families.is_set or self.next_next_hop_srlg_autobackup_protected_s2l_families.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.next_next_hop_srlg_autobackup_protected_s2l_families.get_name_leafdata())
                    if (self.srlg_preferred_autobackups.is_set or self.srlg_preferred_autobackups.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.srlg_preferred_autobackups.get_name_leafdata())
                    if (self.srlg_strict_autobackups.is_set or self.srlg_strict_autobackups.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.srlg_strict_autobackups.get_name_leafdata())
                    if (self.srlg_weighted_autobackups.is_set or self.srlg_weighted_autobackups.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.srlg_weighted_autobackups.get_name_leafdata())
                    if (self.unused_autobackups.is_set or self.unused_autobackups.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.unused_autobackups.get_name_leafdata())
                    if (self.up_autobackups.is_set or self.up_autobackups.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.up_autobackups.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "autobackups" or name == "down-autobackups" or name == "next-hop-autobackup-protected-ls-ps" or name == "next-hop-autobackup-protected-s2-ls" or name == "next-hop-autobackup-protected-s2l-families" or name == "next-hop-autobackups" or name == "next-hop-srlg-autobackup-protected-ls-ps" or name == "next-hop-srlg-autobackup-protected-s2-ls" or name == "next-hop-srlg-autobackup-protected-s2l-families" or name == "next-next-hop-autobackup-protected-ls-ps" or name == "next-next-hop-autobackup-protected-s2-ls" or name == "next-next-hop-autobackup-protected-s2l-families" or name == "next-next-hop-autobackups" or name == "next-next-hop-srlg-autobackup-protected-ls-ps" or name == "next-next-hop-srlg-autobackup-protected-s2-ls" or name == "next-next-hop-srlg-autobackup-protected-s2l-families" or name == "srlg-preferred-autobackups" or name == "srlg-strict-autobackups" or name == "srlg-weighted-autobackups" or name == "unused-autobackups" or name == "up-autobackups"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "autobackups"):
                        self.autobackups = value
                        self.autobackups.value_namespace = name_space
                        self.autobackups.value_namespace_prefix = name_space_prefix
                    if(value_path == "down-autobackups"):
                        self.down_autobackups = value
                        self.down_autobackups.value_namespace = name_space
                        self.down_autobackups.value_namespace_prefix = name_space_prefix
                    if(value_path == "next-hop-autobackup-protected-ls-ps"):
                        self.next_hop_autobackup_protected_ls_ps = value
                        self.next_hop_autobackup_protected_ls_ps.value_namespace = name_space
                        self.next_hop_autobackup_protected_ls_ps.value_namespace_prefix = name_space_prefix
                    if(value_path == "next-hop-autobackup-protected-s2-ls"):
                        self.next_hop_autobackup_protected_s2_ls = value
                        self.next_hop_autobackup_protected_s2_ls.value_namespace = name_space
                        self.next_hop_autobackup_protected_s2_ls.value_namespace_prefix = name_space_prefix
                    if(value_path == "next-hop-autobackup-protected-s2l-families"):
                        self.next_hop_autobackup_protected_s2l_families = value
                        self.next_hop_autobackup_protected_s2l_families.value_namespace = name_space
                        self.next_hop_autobackup_protected_s2l_families.value_namespace_prefix = name_space_prefix
                    if(value_path == "next-hop-autobackups"):
                        self.next_hop_autobackups = value
                        self.next_hop_autobackups.value_namespace = name_space
                        self.next_hop_autobackups.value_namespace_prefix = name_space_prefix
                    if(value_path == "next-hop-srlg-autobackup-protected-ls-ps"):
                        self.next_hop_srlg_autobackup_protected_ls_ps = value
                        self.next_hop_srlg_autobackup_protected_ls_ps.value_namespace = name_space
                        self.next_hop_srlg_autobackup_protected_ls_ps.value_namespace_prefix = name_space_prefix
                    if(value_path == "next-hop-srlg-autobackup-protected-s2-ls"):
                        self.next_hop_srlg_autobackup_protected_s2_ls = value
                        self.next_hop_srlg_autobackup_protected_s2_ls.value_namespace = name_space
                        self.next_hop_srlg_autobackup_protected_s2_ls.value_namespace_prefix = name_space_prefix
                    if(value_path == "next-hop-srlg-autobackup-protected-s2l-families"):
                        self.next_hop_srlg_autobackup_protected_s2l_families = value
                        self.next_hop_srlg_autobackup_protected_s2l_families.value_namespace = name_space
                        self.next_hop_srlg_autobackup_protected_s2l_families.value_namespace_prefix = name_space_prefix
                    if(value_path == "next-next-hop-autobackup-protected-ls-ps"):
                        self.next_next_hop_autobackup_protected_ls_ps = value
                        self.next_next_hop_autobackup_protected_ls_ps.value_namespace = name_space
                        self.next_next_hop_autobackup_protected_ls_ps.value_namespace_prefix = name_space_prefix
                    if(value_path == "next-next-hop-autobackup-protected-s2-ls"):
                        self.next_next_hop_autobackup_protected_s2_ls = value
                        self.next_next_hop_autobackup_protected_s2_ls.value_namespace = name_space
                        self.next_next_hop_autobackup_protected_s2_ls.value_namespace_prefix = name_space_prefix
                    if(value_path == "next-next-hop-autobackup-protected-s2l-families"):
                        self.next_next_hop_autobackup_protected_s2l_families = value
                        self.next_next_hop_autobackup_protected_s2l_families.value_namespace = name_space
                        self.next_next_hop_autobackup_protected_s2l_families.value_namespace_prefix = name_space_prefix
                    if(value_path == "next-next-hop-autobackups"):
                        self.next_next_hop_autobackups = value
                        self.next_next_hop_autobackups.value_namespace = name_space
                        self.next_next_hop_autobackups.value_namespace_prefix = name_space_prefix
                    if(value_path == "next-next-hop-srlg-autobackup-protected-ls-ps"):
                        self.next_next_hop_srlg_autobackup_protected_ls_ps = value
                        self.next_next_hop_srlg_autobackup_protected_ls_ps.value_namespace = name_space
                        self.next_next_hop_srlg_autobackup_protected_ls_ps.value_namespace_prefix = name_space_prefix
                    if(value_path == "next-next-hop-srlg-autobackup-protected-s2-ls"):
                        self.next_next_hop_srlg_autobackup_protected_s2_ls = value
                        self.next_next_hop_srlg_autobackup_protected_s2_ls.value_namespace = name_space
                        self.next_next_hop_srlg_autobackup_protected_s2_ls.value_namespace_prefix = name_space_prefix
                    if(value_path == "next-next-hop-srlg-autobackup-protected-s2l-families"):
                        self.next_next_hop_srlg_autobackup_protected_s2l_families = value
                        self.next_next_hop_srlg_autobackup_protected_s2l_families.value_namespace = name_space
                        self.next_next_hop_srlg_autobackup_protected_s2l_families.value_namespace_prefix = name_space_prefix
                    if(value_path == "srlg-preferred-autobackups"):
                        self.srlg_preferred_autobackups = value
                        self.srlg_preferred_autobackups.value_namespace = name_space
                        self.srlg_preferred_autobackups.value_namespace_prefix = name_space_prefix
                    if(value_path == "srlg-strict-autobackups"):
                        self.srlg_strict_autobackups = value
                        self.srlg_strict_autobackups.value_namespace = name_space
                        self.srlg_strict_autobackups.value_namespace_prefix = name_space_prefix
                    if(value_path == "srlg-weighted-autobackups"):
                        self.srlg_weighted_autobackups = value
                        self.srlg_weighted_autobackups.value_namespace = name_space
                        self.srlg_weighted_autobackups.value_namespace_prefix = name_space_prefix
                    if(value_path == "unused-autobackups"):
                        self.unused_autobackups = value
                        self.unused_autobackups.value_namespace = name_space
                        self.unused_autobackups.value_namespace_prefix = name_space_prefix
                    if(value_path == "up-autobackups"):
                        self.up_autobackups = value
                        self.up_autobackups.value_namespace = name_space
                        self.up_autobackups.value_namespace_prefix = name_space_prefix


            class AutoMeshSummary(Entity):
                """
                Automesh summary
                
                .. attribute:: auto_mesh_destinations
                
                	Total number of automesh destinations
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: auto_mesh_groups
                
                	Total number of automesh mesh\-groups
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: auto_mesh_tunnels
                
                	Total number of automesh tunnels
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: down_auto_mesh_tunnels
                
                	Total number of automesh tunnels that are down
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: frr_auto_mesh_tunnels
                
                	Total number of automesh tunnels that are FRR enabled
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: up_auto_mesh_tunnels
                
                	Total number of automesh tunnels that are up
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTeStandby.Tunnels.Summary.AutoMeshSummary, self).__init__()

                    self.yang_name = "auto-mesh-summary"
                    self.yang_parent_name = "summary"

                    self.auto_mesh_destinations = YLeaf(YType.uint32, "auto-mesh-destinations")

                    self.auto_mesh_groups = YLeaf(YType.uint32, "auto-mesh-groups")

                    self.auto_mesh_tunnels = YLeaf(YType.uint32, "auto-mesh-tunnels")

                    self.down_auto_mesh_tunnels = YLeaf(YType.uint32, "down-auto-mesh-tunnels")

                    self.frr_auto_mesh_tunnels = YLeaf(YType.uint32, "frr-auto-mesh-tunnels")

                    self.up_auto_mesh_tunnels = YLeaf(YType.uint32, "up-auto-mesh-tunnels")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("auto_mesh_destinations",
                                    "auto_mesh_groups",
                                    "auto_mesh_tunnels",
                                    "down_auto_mesh_tunnels",
                                    "frr_auto_mesh_tunnels",
                                    "up_auto_mesh_tunnels") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTeStandby.Tunnels.Summary.AutoMeshSummary, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTeStandby.Tunnels.Summary.AutoMeshSummary, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.auto_mesh_destinations.is_set or
                        self.auto_mesh_groups.is_set or
                        self.auto_mesh_tunnels.is_set or
                        self.down_auto_mesh_tunnels.is_set or
                        self.frr_auto_mesh_tunnels.is_set or
                        self.up_auto_mesh_tunnels.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.auto_mesh_destinations.yfilter != YFilter.not_set or
                        self.auto_mesh_groups.yfilter != YFilter.not_set or
                        self.auto_mesh_tunnels.yfilter != YFilter.not_set or
                        self.down_auto_mesh_tunnels.yfilter != YFilter.not_set or
                        self.frr_auto_mesh_tunnels.yfilter != YFilter.not_set or
                        self.up_auto_mesh_tunnels.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "auto-mesh-summary" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/summary/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.auto_mesh_destinations.is_set or self.auto_mesh_destinations.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.auto_mesh_destinations.get_name_leafdata())
                    if (self.auto_mesh_groups.is_set or self.auto_mesh_groups.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.auto_mesh_groups.get_name_leafdata())
                    if (self.auto_mesh_tunnels.is_set or self.auto_mesh_tunnels.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.auto_mesh_tunnels.get_name_leafdata())
                    if (self.down_auto_mesh_tunnels.is_set or self.down_auto_mesh_tunnels.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.down_auto_mesh_tunnels.get_name_leafdata())
                    if (self.frr_auto_mesh_tunnels.is_set or self.frr_auto_mesh_tunnels.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.frr_auto_mesh_tunnels.get_name_leafdata())
                    if (self.up_auto_mesh_tunnels.is_set or self.up_auto_mesh_tunnels.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.up_auto_mesh_tunnels.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "auto-mesh-destinations" or name == "auto-mesh-groups" or name == "auto-mesh-tunnels" or name == "down-auto-mesh-tunnels" or name == "frr-auto-mesh-tunnels" or name == "up-auto-mesh-tunnels"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "auto-mesh-destinations"):
                        self.auto_mesh_destinations = value
                        self.auto_mesh_destinations.value_namespace = name_space
                        self.auto_mesh_destinations.value_namespace_prefix = name_space_prefix
                    if(value_path == "auto-mesh-groups"):
                        self.auto_mesh_groups = value
                        self.auto_mesh_groups.value_namespace = name_space
                        self.auto_mesh_groups.value_namespace_prefix = name_space_prefix
                    if(value_path == "auto-mesh-tunnels"):
                        self.auto_mesh_tunnels = value
                        self.auto_mesh_tunnels.value_namespace = name_space
                        self.auto_mesh_tunnels.value_namespace_prefix = name_space_prefix
                    if(value_path == "down-auto-mesh-tunnels"):
                        self.down_auto_mesh_tunnels = value
                        self.down_auto_mesh_tunnels.value_namespace = name_space
                        self.down_auto_mesh_tunnels.value_namespace_prefix = name_space_prefix
                    if(value_path == "frr-auto-mesh-tunnels"):
                        self.frr_auto_mesh_tunnels = value
                        self.frr_auto_mesh_tunnels.value_namespace = name_space
                        self.frr_auto_mesh_tunnels.value_namespace_prefix = name_space_prefix
                    if(value_path == "up-auto-mesh-tunnels"):
                        self.up_auto_mesh_tunnels = value
                        self.up_auto_mesh_tunnels.value_namespace = name_space
                        self.up_auto_mesh_tunnels.value_namespace_prefix = name_space_prefix


            class AutoMeshOneHopSummary(Entity):
                """
                Automesh Onehop summary
                
                .. attribute:: auto_mesh_one_hop_destinations
                
                	Total number of automesh onehop destinations
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: auto_mesh_one_hop_groups
                
                	Total number of automesh onehop mesh\-groups
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: auto_mesh_one_hop_tunnels
                
                	Total number of automesh onehop tunnels
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: down_auto_mesh_one_hop_tunnels
                
                	Total number of automesh onehop tunnels that are down
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: frr_auto_mesh_tunnels
                
                	Total number of automesh onehop tunnels that are FRR enabled
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: up_auto_mesh_one_hop_tunnels
                
                	Total number of automesh onehop tunnels that are up
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTeStandby.Tunnels.Summary.AutoMeshOneHopSummary, self).__init__()

                    self.yang_name = "auto-mesh-one-hop-summary"
                    self.yang_parent_name = "summary"

                    self.auto_mesh_one_hop_destinations = YLeaf(YType.uint32, "auto-mesh-one-hop-destinations")

                    self.auto_mesh_one_hop_groups = YLeaf(YType.uint32, "auto-mesh-one-hop-groups")

                    self.auto_mesh_one_hop_tunnels = YLeaf(YType.uint32, "auto-mesh-one-hop-tunnels")

                    self.down_auto_mesh_one_hop_tunnels = YLeaf(YType.uint32, "down-auto-mesh-one-hop-tunnels")

                    self.frr_auto_mesh_tunnels = YLeaf(YType.uint32, "frr-auto-mesh-tunnels")

                    self.up_auto_mesh_one_hop_tunnels = YLeaf(YType.uint32, "up-auto-mesh-one-hop-tunnels")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("auto_mesh_one_hop_destinations",
                                    "auto_mesh_one_hop_groups",
                                    "auto_mesh_one_hop_tunnels",
                                    "down_auto_mesh_one_hop_tunnels",
                                    "frr_auto_mesh_tunnels",
                                    "up_auto_mesh_one_hop_tunnels") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTeStandby.Tunnels.Summary.AutoMeshOneHopSummary, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTeStandby.Tunnels.Summary.AutoMeshOneHopSummary, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.auto_mesh_one_hop_destinations.is_set or
                        self.auto_mesh_one_hop_groups.is_set or
                        self.auto_mesh_one_hop_tunnels.is_set or
                        self.down_auto_mesh_one_hop_tunnels.is_set or
                        self.frr_auto_mesh_tunnels.is_set or
                        self.up_auto_mesh_one_hop_tunnels.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.auto_mesh_one_hop_destinations.yfilter != YFilter.not_set or
                        self.auto_mesh_one_hop_groups.yfilter != YFilter.not_set or
                        self.auto_mesh_one_hop_tunnels.yfilter != YFilter.not_set or
                        self.down_auto_mesh_one_hop_tunnels.yfilter != YFilter.not_set or
                        self.frr_auto_mesh_tunnels.yfilter != YFilter.not_set or
                        self.up_auto_mesh_one_hop_tunnels.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "auto-mesh-one-hop-summary" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/summary/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.auto_mesh_one_hop_destinations.is_set or self.auto_mesh_one_hop_destinations.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.auto_mesh_one_hop_destinations.get_name_leafdata())
                    if (self.auto_mesh_one_hop_groups.is_set or self.auto_mesh_one_hop_groups.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.auto_mesh_one_hop_groups.get_name_leafdata())
                    if (self.auto_mesh_one_hop_tunnels.is_set or self.auto_mesh_one_hop_tunnels.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.auto_mesh_one_hop_tunnels.get_name_leafdata())
                    if (self.down_auto_mesh_one_hop_tunnels.is_set or self.down_auto_mesh_one_hop_tunnels.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.down_auto_mesh_one_hop_tunnels.get_name_leafdata())
                    if (self.frr_auto_mesh_tunnels.is_set or self.frr_auto_mesh_tunnels.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.frr_auto_mesh_tunnels.get_name_leafdata())
                    if (self.up_auto_mesh_one_hop_tunnels.is_set or self.up_auto_mesh_one_hop_tunnels.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.up_auto_mesh_one_hop_tunnels.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "auto-mesh-one-hop-destinations" or name == "auto-mesh-one-hop-groups" or name == "auto-mesh-one-hop-tunnels" or name == "down-auto-mesh-one-hop-tunnels" or name == "frr-auto-mesh-tunnels" or name == "up-auto-mesh-one-hop-tunnels"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "auto-mesh-one-hop-destinations"):
                        self.auto_mesh_one_hop_destinations = value
                        self.auto_mesh_one_hop_destinations.value_namespace = name_space
                        self.auto_mesh_one_hop_destinations.value_namespace_prefix = name_space_prefix
                    if(value_path == "auto-mesh-one-hop-groups"):
                        self.auto_mesh_one_hop_groups = value
                        self.auto_mesh_one_hop_groups.value_namespace = name_space
                        self.auto_mesh_one_hop_groups.value_namespace_prefix = name_space_prefix
                    if(value_path == "auto-mesh-one-hop-tunnels"):
                        self.auto_mesh_one_hop_tunnels = value
                        self.auto_mesh_one_hop_tunnels.value_namespace = name_space
                        self.auto_mesh_one_hop_tunnels.value_namespace_prefix = name_space_prefix
                    if(value_path == "down-auto-mesh-one-hop-tunnels"):
                        self.down_auto_mesh_one_hop_tunnels = value
                        self.down_auto_mesh_one_hop_tunnels.value_namespace = name_space
                        self.down_auto_mesh_one_hop_tunnels.value_namespace_prefix = name_space_prefix
                    if(value_path == "frr-auto-mesh-tunnels"):
                        self.frr_auto_mesh_tunnels = value
                        self.frr_auto_mesh_tunnels.value_namespace = name_space
                        self.frr_auto_mesh_tunnels.value_namespace_prefix = name_space_prefix
                    if(value_path == "up-auto-mesh-one-hop-tunnels"):
                        self.up_auto_mesh_one_hop_tunnels = value
                        self.up_auto_mesh_one_hop_tunnels.value_namespace = name_space
                        self.up_auto_mesh_one_hop_tunnels.value_namespace_prefix = name_space_prefix


            class GmplsUniSummary(Entity):
                """
                GMPLS\-UNI summary
                
                .. attribute:: heads_down
                
                	Tunnel heads in down state
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: heads_up
                
                	Tunnel heads in up state
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: tails_down
                
                	Tunnel tails in down state
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: tails_up
                
                	Tunnel tails in up state
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTeStandby.Tunnels.Summary.GmplsUniSummary, self).__init__()

                    self.yang_name = "gmpls-uni-summary"
                    self.yang_parent_name = "summary"

                    self.heads_down = YLeaf(YType.uint32, "heads-down")

                    self.heads_up = YLeaf(YType.uint32, "heads-up")

                    self.tails_down = YLeaf(YType.uint32, "tails-down")

                    self.tails_up = YLeaf(YType.uint32, "tails-up")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("heads_down",
                                    "heads_up",
                                    "tails_down",
                                    "tails_up") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTeStandby.Tunnels.Summary.GmplsUniSummary, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTeStandby.Tunnels.Summary.GmplsUniSummary, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.heads_down.is_set or
                        self.heads_up.is_set or
                        self.tails_down.is_set or
                        self.tails_up.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.heads_down.yfilter != YFilter.not_set or
                        self.heads_up.yfilter != YFilter.not_set or
                        self.tails_down.yfilter != YFilter.not_set or
                        self.tails_up.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "gmpls-uni-summary" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/summary/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.heads_down.is_set or self.heads_down.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.heads_down.get_name_leafdata())
                    if (self.heads_up.is_set or self.heads_up.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.heads_up.get_name_leafdata())
                    if (self.tails_down.is_set or self.tails_down.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tails_down.get_name_leafdata())
                    if (self.tails_up.is_set or self.tails_up.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tails_up.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "heads-down" or name == "heads-up" or name == "tails-down" or name == "tails-up"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "heads-down"):
                        self.heads_down = value
                        self.heads_down.value_namespace = name_space
                        self.heads_down.value_namespace_prefix = name_space_prefix
                    if(value_path == "heads-up"):
                        self.heads_up = value
                        self.heads_up.value_namespace = name_space
                        self.heads_up.value_namespace_prefix = name_space_prefix
                    if(value_path == "tails-down"):
                        self.tails_down = value
                        self.tails_down.value_namespace = name_space
                        self.tails_down.value_namespace_prefix = name_space_prefix
                    if(value_path == "tails-up"):
                        self.tails_up = value
                        self.tails_up.value_namespace = name_space
                        self.tails_up.value_namespace_prefix = name_space_prefix


            class GmplsNniSummary(Entity):
                """
                GMPLS\-NNI summary
                
                .. attribute:: heads_down
                
                	Tunnel heads in down state
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: heads_up
                
                	Tunnel heads in up state
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: mids_down
                
                	Tunnel mids in down state
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: mids_up
                
                	Tunnel mids in up state
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: tails_down
                
                	Tunnel tails in down state
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: tails_up
                
                	Tunnel tails in up state
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTeStandby.Tunnels.Summary.GmplsNniSummary, self).__init__()

                    self.yang_name = "gmpls-nni-summary"
                    self.yang_parent_name = "summary"

                    self.heads_down = YLeaf(YType.uint32, "heads-down")

                    self.heads_up = YLeaf(YType.uint32, "heads-up")

                    self.mids_down = YLeaf(YType.uint32, "mids-down")

                    self.mids_up = YLeaf(YType.uint32, "mids-up")

                    self.tails_down = YLeaf(YType.uint32, "tails-down")

                    self.tails_up = YLeaf(YType.uint32, "tails-up")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("heads_down",
                                    "heads_up",
                                    "mids_down",
                                    "mids_up",
                                    "tails_down",
                                    "tails_up") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTeStandby.Tunnels.Summary.GmplsNniSummary, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTeStandby.Tunnels.Summary.GmplsNniSummary, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.heads_down.is_set or
                        self.heads_up.is_set or
                        self.mids_down.is_set or
                        self.mids_up.is_set or
                        self.tails_down.is_set or
                        self.tails_up.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.heads_down.yfilter != YFilter.not_set or
                        self.heads_up.yfilter != YFilter.not_set or
                        self.mids_down.yfilter != YFilter.not_set or
                        self.mids_up.yfilter != YFilter.not_set or
                        self.tails_down.yfilter != YFilter.not_set or
                        self.tails_up.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "gmpls-nni-summary" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/summary/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.heads_down.is_set or self.heads_down.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.heads_down.get_name_leafdata())
                    if (self.heads_up.is_set or self.heads_up.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.heads_up.get_name_leafdata())
                    if (self.mids_down.is_set or self.mids_down.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.mids_down.get_name_leafdata())
                    if (self.mids_up.is_set or self.mids_up.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.mids_up.get_name_leafdata())
                    if (self.tails_down.is_set or self.tails_down.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tails_down.get_name_leafdata())
                    if (self.tails_up.is_set or self.tails_up.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tails_up.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "heads-down" or name == "heads-up" or name == "mids-down" or name == "mids-up" or name == "tails-down" or name == "tails-up"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "heads-down"):
                        self.heads_down = value
                        self.heads_down.value_namespace = name_space
                        self.heads_down.value_namespace_prefix = name_space_prefix
                    if(value_path == "heads-up"):
                        self.heads_up = value
                        self.heads_up.value_namespace = name_space
                        self.heads_up.value_namespace_prefix = name_space_prefix
                    if(value_path == "mids-down"):
                        self.mids_down = value
                        self.mids_down.value_namespace = name_space
                        self.mids_down.value_namespace_prefix = name_space_prefix
                    if(value_path == "mids-up"):
                        self.mids_up = value
                        self.mids_up.value_namespace = name_space
                        self.mids_up.value_namespace_prefix = name_space_prefix
                    if(value_path == "tails-down"):
                        self.tails_down = value
                        self.tails_down.value_namespace = name_space
                        self.tails_down.value_namespace_prefix = name_space_prefix
                    if(value_path == "tails-up"):
                        self.tails_up = value
                        self.tails_up.value_namespace = name_space
                        self.tails_up.value_namespace_prefix = name_space_prefix


            class CurrentTunnelConvergenceSummary(Entity):
                """
                Current Tunnel convergemce summary information
                
                .. attribute:: table_frr_trigger
                
                	Table FRR trigger entry
                	**type**\:   :py:class:`TableFrrTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.Summary.CurrentTunnelConvergenceSummary.TableFrrTrigger>`
                
                .. attribute:: table_label_rewrite
                
                	Table label rewrite entry
                	**type**\:   :py:class:`TableLabelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.Summary.CurrentTunnelConvergenceSummary.TableLabelRewrite>`
                
                .. attribute:: table_path_out
                
                	Table path\-out entry
                	**type**\:   :py:class:`TablePathOut <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.Summary.CurrentTunnelConvergenceSummary.TablePathOut>`
                
                .. attribute:: table_pcalc
                
                	Table PCALC entry
                	**type**\:   :py:class:`TablePcalc <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.Summary.CurrentTunnelConvergenceSummary.TablePcalc>`
                
                .. attribute:: table_resv_in
                
                	Table resv\-in entry
                	**type**\:   :py:class:`TableResvIn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.Summary.CurrentTunnelConvergenceSummary.TableResvIn>`
                
                .. attribute:: table_tunnel_rewrite
                
                	Table Tunnel rewrite entry
                	**type**\:   :py:class:`TableTunnelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.Summary.CurrentTunnelConvergenceSummary.TableTunnelRewrite>`
                
                .. attribute:: tunnel_converged_count
                
                	Tunnel converged count
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: tunnel_frr_active_count
                
                	FRR active Tunnel count
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: tunnel_frr_total_count
                
                	FRR triggered Tunnel count
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: tunnel_total_convergence_complete_time
                
                	Tunnel convergence complete timestamp (clocktime in nsecs)
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                	**units**\: nanosecond
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTeStandby.Tunnels.Summary.CurrentTunnelConvergenceSummary, self).__init__()

                    self.yang_name = "current-tunnel-convergence-summary"
                    self.yang_parent_name = "summary"

                    self.tunnel_converged_count = YLeaf(YType.uint32, "tunnel-converged-count")

                    self.tunnel_frr_active_count = YLeaf(YType.uint32, "tunnel-frr-active-count")

                    self.tunnel_frr_total_count = YLeaf(YType.uint32, "tunnel-frr-total-count")

                    self.tunnel_total_convergence_complete_time = YLeaf(YType.uint64, "tunnel-total-convergence-complete-time")

                    self.table_frr_trigger = MplsTeStandby.Tunnels.Summary.CurrentTunnelConvergenceSummary.TableFrrTrigger()
                    self.table_frr_trigger.parent = self
                    self._children_name_map["table_frr_trigger"] = "table-frr-trigger"
                    self._children_yang_names.add("table-frr-trigger")

                    self.table_label_rewrite = MplsTeStandby.Tunnels.Summary.CurrentTunnelConvergenceSummary.TableLabelRewrite()
                    self.table_label_rewrite.parent = self
                    self._children_name_map["table_label_rewrite"] = "table-label-rewrite"
                    self._children_yang_names.add("table-label-rewrite")

                    self.table_path_out = MplsTeStandby.Tunnels.Summary.CurrentTunnelConvergenceSummary.TablePathOut()
                    self.table_path_out.parent = self
                    self._children_name_map["table_path_out"] = "table-path-out"
                    self._children_yang_names.add("table-path-out")

                    self.table_pcalc = MplsTeStandby.Tunnels.Summary.CurrentTunnelConvergenceSummary.TablePcalc()
                    self.table_pcalc.parent = self
                    self._children_name_map["table_pcalc"] = "table-pcalc"
                    self._children_yang_names.add("table-pcalc")

                    self.table_resv_in = MplsTeStandby.Tunnels.Summary.CurrentTunnelConvergenceSummary.TableResvIn()
                    self.table_resv_in.parent = self
                    self._children_name_map["table_resv_in"] = "table-resv-in"
                    self._children_yang_names.add("table-resv-in")

                    self.table_tunnel_rewrite = MplsTeStandby.Tunnels.Summary.CurrentTunnelConvergenceSummary.TableTunnelRewrite()
                    self.table_tunnel_rewrite.parent = self
                    self._children_name_map["table_tunnel_rewrite"] = "table-tunnel-rewrite"
                    self._children_yang_names.add("table-tunnel-rewrite")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("tunnel_converged_count",
                                    "tunnel_frr_active_count",
                                    "tunnel_frr_total_count",
                                    "tunnel_total_convergence_complete_time") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTeStandby.Tunnels.Summary.CurrentTunnelConvergenceSummary, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTeStandby.Tunnels.Summary.CurrentTunnelConvergenceSummary, self).__setattr__(name, value)


                class TablePathOut(Entity):
                    """
                    Table path\-out entry
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.Tunnels.Summary.CurrentTunnelConvergenceSummary.TablePathOut, self).__init__()

                        self.yang_name = "table-path-out"
                        self.yang_parent_name = "current-tunnel-convergence-summary"

                    def has_data(self):
                        return False

                    def has_operation(self):
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "table-path-out" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/summary/current-tunnel-convergence-summary/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class TableResvIn(Entity):
                    """
                    Table resv\-in entry
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.Tunnels.Summary.CurrentTunnelConvergenceSummary.TableResvIn, self).__init__()

                        self.yang_name = "table-resv-in"
                        self.yang_parent_name = "current-tunnel-convergence-summary"

                    def has_data(self):
                        return False

                    def has_operation(self):
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "table-resv-in" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/summary/current-tunnel-convergence-summary/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class TableLabelRewrite(Entity):
                    """
                    Table label rewrite entry
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.Tunnels.Summary.CurrentTunnelConvergenceSummary.TableLabelRewrite, self).__init__()

                        self.yang_name = "table-label-rewrite"
                        self.yang_parent_name = "current-tunnel-convergence-summary"

                    def has_data(self):
                        return False

                    def has_operation(self):
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "table-label-rewrite" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/summary/current-tunnel-convergence-summary/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class TablePcalc(Entity):
                    """
                    Table PCALC entry
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.Tunnels.Summary.CurrentTunnelConvergenceSummary.TablePcalc, self).__init__()

                        self.yang_name = "table-pcalc"
                        self.yang_parent_name = "current-tunnel-convergence-summary"

                    def has_data(self):
                        return False

                    def has_operation(self):
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "table-pcalc" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/summary/current-tunnel-convergence-summary/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class TableTunnelRewrite(Entity):
                    """
                    Table Tunnel rewrite entry
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.Tunnels.Summary.CurrentTunnelConvergenceSummary.TableTunnelRewrite, self).__init__()

                        self.yang_name = "table-tunnel-rewrite"
                        self.yang_parent_name = "current-tunnel-convergence-summary"

                    def has_data(self):
                        return False

                    def has_operation(self):
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "table-tunnel-rewrite" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/summary/current-tunnel-convergence-summary/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class TableFrrTrigger(Entity):
                    """
                    Table FRR trigger entry
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.Tunnels.Summary.CurrentTunnelConvergenceSummary.TableFrrTrigger, self).__init__()

                        self.yang_name = "table-frr-trigger"
                        self.yang_parent_name = "current-tunnel-convergence-summary"

                    def has_data(self):
                        return False

                    def has_operation(self):
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "table-frr-trigger" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/summary/current-tunnel-convergence-summary/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass

                def has_data(self):
                    return (
                        self.tunnel_converged_count.is_set or
                        self.tunnel_frr_active_count.is_set or
                        self.tunnel_frr_total_count.is_set or
                        self.tunnel_total_convergence_complete_time.is_set or
                        (self.table_frr_trigger is not None and self.table_frr_trigger.has_data()) or
                        (self.table_label_rewrite is not None and self.table_label_rewrite.has_data()) or
                        (self.table_path_out is not None and self.table_path_out.has_data()) or
                        (self.table_pcalc is not None and self.table_pcalc.has_data()) or
                        (self.table_resv_in is not None and self.table_resv_in.has_data()) or
                        (self.table_tunnel_rewrite is not None and self.table_tunnel_rewrite.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.tunnel_converged_count.yfilter != YFilter.not_set or
                        self.tunnel_frr_active_count.yfilter != YFilter.not_set or
                        self.tunnel_frr_total_count.yfilter != YFilter.not_set or
                        self.tunnel_total_convergence_complete_time.yfilter != YFilter.not_set or
                        (self.table_frr_trigger is not None and self.table_frr_trigger.has_operation()) or
                        (self.table_label_rewrite is not None and self.table_label_rewrite.has_operation()) or
                        (self.table_path_out is not None and self.table_path_out.has_operation()) or
                        (self.table_pcalc is not None and self.table_pcalc.has_operation()) or
                        (self.table_resv_in is not None and self.table_resv_in.has_operation()) or
                        (self.table_tunnel_rewrite is not None and self.table_tunnel_rewrite.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "current-tunnel-convergence-summary" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/summary/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.tunnel_converged_count.is_set or self.tunnel_converged_count.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_converged_count.get_name_leafdata())
                    if (self.tunnel_frr_active_count.is_set or self.tunnel_frr_active_count.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_frr_active_count.get_name_leafdata())
                    if (self.tunnel_frr_total_count.is_set or self.tunnel_frr_total_count.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_frr_total_count.get_name_leafdata())
                    if (self.tunnel_total_convergence_complete_time.is_set or self.tunnel_total_convergence_complete_time.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_total_convergence_complete_time.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "table-frr-trigger"):
                        if (self.table_frr_trigger is None):
                            self.table_frr_trigger = MplsTeStandby.Tunnels.Summary.CurrentTunnelConvergenceSummary.TableFrrTrigger()
                            self.table_frr_trigger.parent = self
                            self._children_name_map["table_frr_trigger"] = "table-frr-trigger"
                        return self.table_frr_trigger

                    if (child_yang_name == "table-label-rewrite"):
                        if (self.table_label_rewrite is None):
                            self.table_label_rewrite = MplsTeStandby.Tunnels.Summary.CurrentTunnelConvergenceSummary.TableLabelRewrite()
                            self.table_label_rewrite.parent = self
                            self._children_name_map["table_label_rewrite"] = "table-label-rewrite"
                        return self.table_label_rewrite

                    if (child_yang_name == "table-path-out"):
                        if (self.table_path_out is None):
                            self.table_path_out = MplsTeStandby.Tunnels.Summary.CurrentTunnelConvergenceSummary.TablePathOut()
                            self.table_path_out.parent = self
                            self._children_name_map["table_path_out"] = "table-path-out"
                        return self.table_path_out

                    if (child_yang_name == "table-pcalc"):
                        if (self.table_pcalc is None):
                            self.table_pcalc = MplsTeStandby.Tunnels.Summary.CurrentTunnelConvergenceSummary.TablePcalc()
                            self.table_pcalc.parent = self
                            self._children_name_map["table_pcalc"] = "table-pcalc"
                        return self.table_pcalc

                    if (child_yang_name == "table-resv-in"):
                        if (self.table_resv_in is None):
                            self.table_resv_in = MplsTeStandby.Tunnels.Summary.CurrentTunnelConvergenceSummary.TableResvIn()
                            self.table_resv_in.parent = self
                            self._children_name_map["table_resv_in"] = "table-resv-in"
                        return self.table_resv_in

                    if (child_yang_name == "table-tunnel-rewrite"):
                        if (self.table_tunnel_rewrite is None):
                            self.table_tunnel_rewrite = MplsTeStandby.Tunnels.Summary.CurrentTunnelConvergenceSummary.TableTunnelRewrite()
                            self.table_tunnel_rewrite.parent = self
                            self._children_name_map["table_tunnel_rewrite"] = "table-tunnel-rewrite"
                        return self.table_tunnel_rewrite

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "table-frr-trigger" or name == "table-label-rewrite" or name == "table-path-out" or name == "table-pcalc" or name == "table-resv-in" or name == "table-tunnel-rewrite" or name == "tunnel-converged-count" or name == "tunnel-frr-active-count" or name == "tunnel-frr-total-count" or name == "tunnel-total-convergence-complete-time"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "tunnel-converged-count"):
                        self.tunnel_converged_count = value
                        self.tunnel_converged_count.value_namespace = name_space
                        self.tunnel_converged_count.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-frr-active-count"):
                        self.tunnel_frr_active_count = value
                        self.tunnel_frr_active_count.value_namespace = name_space
                        self.tunnel_frr_active_count.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-frr-total-count"):
                        self.tunnel_frr_total_count = value
                        self.tunnel_frr_total_count.value_namespace = name_space
                        self.tunnel_frr_total_count.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-total-convergence-complete-time"):
                        self.tunnel_total_convergence_complete_time = value
                        self.tunnel_total_convergence_complete_time.value_namespace = name_space
                        self.tunnel_total_convergence_complete_time.value_namespace_prefix = name_space_prefix


            class LastTunnelConvergenceSummary(Entity):
                """
                Last Tunnel convergemce summary information
                
                .. attribute:: table_frr_trigger
                
                	Table FRR trigger entry
                	**type**\:   :py:class:`TableFrrTrigger <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.Summary.LastTunnelConvergenceSummary.TableFrrTrigger>`
                
                .. attribute:: table_label_rewrite
                
                	Table label rewrite entry
                	**type**\:   :py:class:`TableLabelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.Summary.LastTunnelConvergenceSummary.TableLabelRewrite>`
                
                .. attribute:: table_path_out
                
                	Table path\-out entry
                	**type**\:   :py:class:`TablePathOut <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.Summary.LastTunnelConvergenceSummary.TablePathOut>`
                
                .. attribute:: table_pcalc
                
                	Table PCALC entry
                	**type**\:   :py:class:`TablePcalc <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.Summary.LastTunnelConvergenceSummary.TablePcalc>`
                
                .. attribute:: table_resv_in
                
                	Table resv\-in entry
                	**type**\:   :py:class:`TableResvIn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.Summary.LastTunnelConvergenceSummary.TableResvIn>`
                
                .. attribute:: table_tunnel_rewrite
                
                	Table Tunnel rewrite entry
                	**type**\:   :py:class:`TableTunnelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.Summary.LastTunnelConvergenceSummary.TableTunnelRewrite>`
                
                .. attribute:: tunnel_converged_count
                
                	Tunnel converged count
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: tunnel_frr_active_count
                
                	FRR active Tunnel count
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: tunnel_frr_total_count
                
                	FRR triggered Tunnel count
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: tunnel_total_convergence_complete_time
                
                	Tunnel convergence complete timestamp (clocktime in nsecs)
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                	**units**\: nanosecond
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTeStandby.Tunnels.Summary.LastTunnelConvergenceSummary, self).__init__()

                    self.yang_name = "last-tunnel-convergence-summary"
                    self.yang_parent_name = "summary"

                    self.tunnel_converged_count = YLeaf(YType.uint32, "tunnel-converged-count")

                    self.tunnel_frr_active_count = YLeaf(YType.uint32, "tunnel-frr-active-count")

                    self.tunnel_frr_total_count = YLeaf(YType.uint32, "tunnel-frr-total-count")

                    self.tunnel_total_convergence_complete_time = YLeaf(YType.uint64, "tunnel-total-convergence-complete-time")

                    self.table_frr_trigger = MplsTeStandby.Tunnels.Summary.LastTunnelConvergenceSummary.TableFrrTrigger()
                    self.table_frr_trigger.parent = self
                    self._children_name_map["table_frr_trigger"] = "table-frr-trigger"
                    self._children_yang_names.add("table-frr-trigger")

                    self.table_label_rewrite = MplsTeStandby.Tunnels.Summary.LastTunnelConvergenceSummary.TableLabelRewrite()
                    self.table_label_rewrite.parent = self
                    self._children_name_map["table_label_rewrite"] = "table-label-rewrite"
                    self._children_yang_names.add("table-label-rewrite")

                    self.table_path_out = MplsTeStandby.Tunnels.Summary.LastTunnelConvergenceSummary.TablePathOut()
                    self.table_path_out.parent = self
                    self._children_name_map["table_path_out"] = "table-path-out"
                    self._children_yang_names.add("table-path-out")

                    self.table_pcalc = MplsTeStandby.Tunnels.Summary.LastTunnelConvergenceSummary.TablePcalc()
                    self.table_pcalc.parent = self
                    self._children_name_map["table_pcalc"] = "table-pcalc"
                    self._children_yang_names.add("table-pcalc")

                    self.table_resv_in = MplsTeStandby.Tunnels.Summary.LastTunnelConvergenceSummary.TableResvIn()
                    self.table_resv_in.parent = self
                    self._children_name_map["table_resv_in"] = "table-resv-in"
                    self._children_yang_names.add("table-resv-in")

                    self.table_tunnel_rewrite = MplsTeStandby.Tunnels.Summary.LastTunnelConvergenceSummary.TableTunnelRewrite()
                    self.table_tunnel_rewrite.parent = self
                    self._children_name_map["table_tunnel_rewrite"] = "table-tunnel-rewrite"
                    self._children_yang_names.add("table-tunnel-rewrite")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("tunnel_converged_count",
                                    "tunnel_frr_active_count",
                                    "tunnel_frr_total_count",
                                    "tunnel_total_convergence_complete_time") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTeStandby.Tunnels.Summary.LastTunnelConvergenceSummary, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTeStandby.Tunnels.Summary.LastTunnelConvergenceSummary, self).__setattr__(name, value)


                class TablePathOut(Entity):
                    """
                    Table path\-out entry
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.Tunnels.Summary.LastTunnelConvergenceSummary.TablePathOut, self).__init__()

                        self.yang_name = "table-path-out"
                        self.yang_parent_name = "last-tunnel-convergence-summary"

                    def has_data(self):
                        return False

                    def has_operation(self):
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "table-path-out" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/summary/last-tunnel-convergence-summary/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class TableResvIn(Entity):
                    """
                    Table resv\-in entry
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.Tunnels.Summary.LastTunnelConvergenceSummary.TableResvIn, self).__init__()

                        self.yang_name = "table-resv-in"
                        self.yang_parent_name = "last-tunnel-convergence-summary"

                    def has_data(self):
                        return False

                    def has_operation(self):
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "table-resv-in" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/summary/last-tunnel-convergence-summary/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class TableLabelRewrite(Entity):
                    """
                    Table label rewrite entry
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.Tunnels.Summary.LastTunnelConvergenceSummary.TableLabelRewrite, self).__init__()

                        self.yang_name = "table-label-rewrite"
                        self.yang_parent_name = "last-tunnel-convergence-summary"

                    def has_data(self):
                        return False

                    def has_operation(self):
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "table-label-rewrite" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/summary/last-tunnel-convergence-summary/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class TablePcalc(Entity):
                    """
                    Table PCALC entry
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.Tunnels.Summary.LastTunnelConvergenceSummary.TablePcalc, self).__init__()

                        self.yang_name = "table-pcalc"
                        self.yang_parent_name = "last-tunnel-convergence-summary"

                    def has_data(self):
                        return False

                    def has_operation(self):
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "table-pcalc" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/summary/last-tunnel-convergence-summary/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class TableTunnelRewrite(Entity):
                    """
                    Table Tunnel rewrite entry
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.Tunnels.Summary.LastTunnelConvergenceSummary.TableTunnelRewrite, self).__init__()

                        self.yang_name = "table-tunnel-rewrite"
                        self.yang_parent_name = "last-tunnel-convergence-summary"

                    def has_data(self):
                        return False

                    def has_operation(self):
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "table-tunnel-rewrite" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/summary/last-tunnel-convergence-summary/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class TableFrrTrigger(Entity):
                    """
                    Table FRR trigger entry
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.Tunnels.Summary.LastTunnelConvergenceSummary.TableFrrTrigger, self).__init__()

                        self.yang_name = "table-frr-trigger"
                        self.yang_parent_name = "last-tunnel-convergence-summary"

                    def has_data(self):
                        return False

                    def has_operation(self):
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "table-frr-trigger" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/summary/last-tunnel-convergence-summary/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass

                def has_data(self):
                    return (
                        self.tunnel_converged_count.is_set or
                        self.tunnel_frr_active_count.is_set or
                        self.tunnel_frr_total_count.is_set or
                        self.tunnel_total_convergence_complete_time.is_set or
                        (self.table_frr_trigger is not None and self.table_frr_trigger.has_data()) or
                        (self.table_label_rewrite is not None and self.table_label_rewrite.has_data()) or
                        (self.table_path_out is not None and self.table_path_out.has_data()) or
                        (self.table_pcalc is not None and self.table_pcalc.has_data()) or
                        (self.table_resv_in is not None and self.table_resv_in.has_data()) or
                        (self.table_tunnel_rewrite is not None and self.table_tunnel_rewrite.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.tunnel_converged_count.yfilter != YFilter.not_set or
                        self.tunnel_frr_active_count.yfilter != YFilter.not_set or
                        self.tunnel_frr_total_count.yfilter != YFilter.not_set or
                        self.tunnel_total_convergence_complete_time.yfilter != YFilter.not_set or
                        (self.table_frr_trigger is not None and self.table_frr_trigger.has_operation()) or
                        (self.table_label_rewrite is not None and self.table_label_rewrite.has_operation()) or
                        (self.table_path_out is not None and self.table_path_out.has_operation()) or
                        (self.table_pcalc is not None and self.table_pcalc.has_operation()) or
                        (self.table_resv_in is not None and self.table_resv_in.has_operation()) or
                        (self.table_tunnel_rewrite is not None and self.table_tunnel_rewrite.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "last-tunnel-convergence-summary" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/summary/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.tunnel_converged_count.is_set or self.tunnel_converged_count.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_converged_count.get_name_leafdata())
                    if (self.tunnel_frr_active_count.is_set or self.tunnel_frr_active_count.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_frr_active_count.get_name_leafdata())
                    if (self.tunnel_frr_total_count.is_set or self.tunnel_frr_total_count.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_frr_total_count.get_name_leafdata())
                    if (self.tunnel_total_convergence_complete_time.is_set or self.tunnel_total_convergence_complete_time.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_total_convergence_complete_time.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "table-frr-trigger"):
                        if (self.table_frr_trigger is None):
                            self.table_frr_trigger = MplsTeStandby.Tunnels.Summary.LastTunnelConvergenceSummary.TableFrrTrigger()
                            self.table_frr_trigger.parent = self
                            self._children_name_map["table_frr_trigger"] = "table-frr-trigger"
                        return self.table_frr_trigger

                    if (child_yang_name == "table-label-rewrite"):
                        if (self.table_label_rewrite is None):
                            self.table_label_rewrite = MplsTeStandby.Tunnels.Summary.LastTunnelConvergenceSummary.TableLabelRewrite()
                            self.table_label_rewrite.parent = self
                            self._children_name_map["table_label_rewrite"] = "table-label-rewrite"
                        return self.table_label_rewrite

                    if (child_yang_name == "table-path-out"):
                        if (self.table_path_out is None):
                            self.table_path_out = MplsTeStandby.Tunnels.Summary.LastTunnelConvergenceSummary.TablePathOut()
                            self.table_path_out.parent = self
                            self._children_name_map["table_path_out"] = "table-path-out"
                        return self.table_path_out

                    if (child_yang_name == "table-pcalc"):
                        if (self.table_pcalc is None):
                            self.table_pcalc = MplsTeStandby.Tunnels.Summary.LastTunnelConvergenceSummary.TablePcalc()
                            self.table_pcalc.parent = self
                            self._children_name_map["table_pcalc"] = "table-pcalc"
                        return self.table_pcalc

                    if (child_yang_name == "table-resv-in"):
                        if (self.table_resv_in is None):
                            self.table_resv_in = MplsTeStandby.Tunnels.Summary.LastTunnelConvergenceSummary.TableResvIn()
                            self.table_resv_in.parent = self
                            self._children_name_map["table_resv_in"] = "table-resv-in"
                        return self.table_resv_in

                    if (child_yang_name == "table-tunnel-rewrite"):
                        if (self.table_tunnel_rewrite is None):
                            self.table_tunnel_rewrite = MplsTeStandby.Tunnels.Summary.LastTunnelConvergenceSummary.TableTunnelRewrite()
                            self.table_tunnel_rewrite.parent = self
                            self._children_name_map["table_tunnel_rewrite"] = "table-tunnel-rewrite"
                        return self.table_tunnel_rewrite

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "table-frr-trigger" or name == "table-label-rewrite" or name == "table-path-out" or name == "table-pcalc" or name == "table-resv-in" or name == "table-tunnel-rewrite" or name == "tunnel-converged-count" or name == "tunnel-frr-active-count" or name == "tunnel-frr-total-count" or name == "tunnel-total-convergence-complete-time"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "tunnel-converged-count"):
                        self.tunnel_converged_count = value
                        self.tunnel_converged_count.value_namespace = name_space
                        self.tunnel_converged_count.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-frr-active-count"):
                        self.tunnel_frr_active_count = value
                        self.tunnel_frr_active_count.value_namespace = name_space
                        self.tunnel_frr_active_count.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-frr-total-count"):
                        self.tunnel_frr_total_count = value
                        self.tunnel_frr_total_count.value_namespace = name_space
                        self.tunnel_frr_total_count.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-total-convergence-complete-time"):
                        self.tunnel_total_convergence_complete_time = value
                        self.tunnel_total_convergence_complete_time.value_namespace = name_space
                        self.tunnel_total_convergence_complete_time.value_namespace_prefix = name_space_prefix


            class AutoTunServerSummary(Entity):
                """
                Auto\-tunnel server tunnel summary
                
                .. attribute:: clients_summary
                
                	List of auto\-tunnel server clients
                	**type**\: list of    :py:class:`ClientsSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.Summary.AutoTunServerSummary.ClientsSummary>`
                
                .. attribute:: total_auto_p2mp_tunnels
                
                	Total number of P2MP auto\-tunnels
                	**type**\:   :py:class:`TotalAutoP2MpTunnels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.Summary.AutoTunServerSummary.TotalAutoP2MpTunnels>`
                
                .. attribute:: total_auto_p2p_tunnels
                
                	Total number of P2P auto\-tunnels
                	**type**\:   :py:class:`TotalAutoP2PTunnels <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.Summary.AutoTunServerSummary.TotalAutoP2PTunnels>`
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTeStandby.Tunnels.Summary.AutoTunServerSummary, self).__init__()

                    self.yang_name = "auto-tun-server-summary"
                    self.yang_parent_name = "summary"

                    self.total_auto_p2mp_tunnels = MplsTeStandby.Tunnels.Summary.AutoTunServerSummary.TotalAutoP2MpTunnels()
                    self.total_auto_p2mp_tunnels.parent = self
                    self._children_name_map["total_auto_p2mp_tunnels"] = "total-auto-p2mp-tunnels"
                    self._children_yang_names.add("total-auto-p2mp-tunnels")

                    self.total_auto_p2p_tunnels = MplsTeStandby.Tunnels.Summary.AutoTunServerSummary.TotalAutoP2PTunnels()
                    self.total_auto_p2p_tunnels.parent = self
                    self._children_name_map["total_auto_p2p_tunnels"] = "total-auto-p2p-tunnels"
                    self._children_yang_names.add("total-auto-p2p-tunnels")

                    self.clients_summary = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in () and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTeStandby.Tunnels.Summary.AutoTunServerSummary, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTeStandby.Tunnels.Summary.AutoTunServerSummary, self).__setattr__(name, value)


                class TotalAutoP2MpTunnels(Entity):
                    """
                    Total number of P2MP auto\-tunnels
                    
                    .. attribute:: auto_p2mp_destinations
                    
                    	Total number of client P2MP auto\-tunnel destinations
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: auto_p2mp_tunnel
                    
                    	Total number of client P2MP auto\-tunnels
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: down_auto_p2mp_destinations
                    
                    	Total number of client P2MP auto\-tunnel destinations that are down
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: down_auto_p2mp_tunnels
                    
                    	Total number of client P2MP auto\-tunnels that are down
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: frr_auto_p2mp_tunnels
                    
                    	Total number of client P2MP auto\-tunnels that are FRR enabled
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: up_auto_p2mp_destinations
                    
                    	Total number of client P2MP auto\-tunnel destinations that are up
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: up_auto_p2mp_tunnels
                    
                    	Total number of client P2MP auto\-tunnels that are up
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.Tunnels.Summary.AutoTunServerSummary.TotalAutoP2MpTunnels, self).__init__()

                        self.yang_name = "total-auto-p2mp-tunnels"
                        self.yang_parent_name = "auto-tun-server-summary"

                        self.auto_p2mp_destinations = YLeaf(YType.uint32, "auto-p2mp-destinations")

                        self.auto_p2mp_tunnel = YLeaf(YType.uint32, "auto-p2mp-tunnel")

                        self.down_auto_p2mp_destinations = YLeaf(YType.uint32, "down-auto-p2mp-destinations")

                        self.down_auto_p2mp_tunnels = YLeaf(YType.uint32, "down-auto-p2mp-tunnels")

                        self.frr_auto_p2mp_tunnels = YLeaf(YType.uint32, "frr-auto-p2mp-tunnels")

                        self.up_auto_p2mp_destinations = YLeaf(YType.uint32, "up-auto-p2mp-destinations")

                        self.up_auto_p2mp_tunnels = YLeaf(YType.uint32, "up-auto-p2mp-tunnels")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("auto_p2mp_destinations",
                                        "auto_p2mp_tunnel",
                                        "down_auto_p2mp_destinations",
                                        "down_auto_p2mp_tunnels",
                                        "frr_auto_p2mp_tunnels",
                                        "up_auto_p2mp_destinations",
                                        "up_auto_p2mp_tunnels") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.Tunnels.Summary.AutoTunServerSummary.TotalAutoP2MpTunnels, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.Tunnels.Summary.AutoTunServerSummary.TotalAutoP2MpTunnels, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.auto_p2mp_destinations.is_set or
                            self.auto_p2mp_tunnel.is_set or
                            self.down_auto_p2mp_destinations.is_set or
                            self.down_auto_p2mp_tunnels.is_set or
                            self.frr_auto_p2mp_tunnels.is_set or
                            self.up_auto_p2mp_destinations.is_set or
                            self.up_auto_p2mp_tunnels.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.auto_p2mp_destinations.yfilter != YFilter.not_set or
                            self.auto_p2mp_tunnel.yfilter != YFilter.not_set or
                            self.down_auto_p2mp_destinations.yfilter != YFilter.not_set or
                            self.down_auto_p2mp_tunnels.yfilter != YFilter.not_set or
                            self.frr_auto_p2mp_tunnels.yfilter != YFilter.not_set or
                            self.up_auto_p2mp_destinations.yfilter != YFilter.not_set or
                            self.up_auto_p2mp_tunnels.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "total-auto-p2mp-tunnels" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/summary/auto-tun-server-summary/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.auto_p2mp_destinations.is_set or self.auto_p2mp_destinations.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.auto_p2mp_destinations.get_name_leafdata())
                        if (self.auto_p2mp_tunnel.is_set or self.auto_p2mp_tunnel.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.auto_p2mp_tunnel.get_name_leafdata())
                        if (self.down_auto_p2mp_destinations.is_set or self.down_auto_p2mp_destinations.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.down_auto_p2mp_destinations.get_name_leafdata())
                        if (self.down_auto_p2mp_tunnels.is_set or self.down_auto_p2mp_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.down_auto_p2mp_tunnels.get_name_leafdata())
                        if (self.frr_auto_p2mp_tunnels.is_set or self.frr_auto_p2mp_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.frr_auto_p2mp_tunnels.get_name_leafdata())
                        if (self.up_auto_p2mp_destinations.is_set or self.up_auto_p2mp_destinations.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.up_auto_p2mp_destinations.get_name_leafdata())
                        if (self.up_auto_p2mp_tunnels.is_set or self.up_auto_p2mp_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.up_auto_p2mp_tunnels.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "auto-p2mp-destinations" or name == "auto-p2mp-tunnel" or name == "down-auto-p2mp-destinations" or name == "down-auto-p2mp-tunnels" or name == "frr-auto-p2mp-tunnels" or name == "up-auto-p2mp-destinations" or name == "up-auto-p2mp-tunnels"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "auto-p2mp-destinations"):
                            self.auto_p2mp_destinations = value
                            self.auto_p2mp_destinations.value_namespace = name_space
                            self.auto_p2mp_destinations.value_namespace_prefix = name_space_prefix
                        if(value_path == "auto-p2mp-tunnel"):
                            self.auto_p2mp_tunnel = value
                            self.auto_p2mp_tunnel.value_namespace = name_space
                            self.auto_p2mp_tunnel.value_namespace_prefix = name_space_prefix
                        if(value_path == "down-auto-p2mp-destinations"):
                            self.down_auto_p2mp_destinations = value
                            self.down_auto_p2mp_destinations.value_namespace = name_space
                            self.down_auto_p2mp_destinations.value_namespace_prefix = name_space_prefix
                        if(value_path == "down-auto-p2mp-tunnels"):
                            self.down_auto_p2mp_tunnels = value
                            self.down_auto_p2mp_tunnels.value_namespace = name_space
                            self.down_auto_p2mp_tunnels.value_namespace_prefix = name_space_prefix
                        if(value_path == "frr-auto-p2mp-tunnels"):
                            self.frr_auto_p2mp_tunnels = value
                            self.frr_auto_p2mp_tunnels.value_namespace = name_space
                            self.frr_auto_p2mp_tunnels.value_namespace_prefix = name_space_prefix
                        if(value_path == "up-auto-p2mp-destinations"):
                            self.up_auto_p2mp_destinations = value
                            self.up_auto_p2mp_destinations.value_namespace = name_space
                            self.up_auto_p2mp_destinations.value_namespace_prefix = name_space_prefix
                        if(value_path == "up-auto-p2mp-tunnels"):
                            self.up_auto_p2mp_tunnels = value
                            self.up_auto_p2mp_tunnels.value_namespace = name_space
                            self.up_auto_p2mp_tunnels.value_namespace_prefix = name_space_prefix


                class TotalAutoP2PTunnels(Entity):
                    """
                    Total number of P2P auto\-tunnels
                    
                    .. attribute:: auto_p2p_tunnel
                    
                    	Total number of client P2P auto\-tunnels
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: down_auto_p2p_tunnels
                    
                    	Total number of client P2P auto\-tunnels that are down
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: up_auto_p2p_tunnels
                    
                    	Total number of client P2P auto\-tunnels that are up
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.Tunnels.Summary.AutoTunServerSummary.TotalAutoP2PTunnels, self).__init__()

                        self.yang_name = "total-auto-p2p-tunnels"
                        self.yang_parent_name = "auto-tun-server-summary"

                        self.auto_p2p_tunnel = YLeaf(YType.uint32, "auto-p2p-tunnel")

                        self.down_auto_p2p_tunnels = YLeaf(YType.uint32, "down-auto-p2p-tunnels")

                        self.up_auto_p2p_tunnels = YLeaf(YType.uint32, "up-auto-p2p-tunnels")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("auto_p2p_tunnel",
                                        "down_auto_p2p_tunnels",
                                        "up_auto_p2p_tunnels") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.Tunnels.Summary.AutoTunServerSummary.TotalAutoP2PTunnels, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.Tunnels.Summary.AutoTunServerSummary.TotalAutoP2PTunnels, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.auto_p2p_tunnel.is_set or
                            self.down_auto_p2p_tunnels.is_set or
                            self.up_auto_p2p_tunnels.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.auto_p2p_tunnel.yfilter != YFilter.not_set or
                            self.down_auto_p2p_tunnels.yfilter != YFilter.not_set or
                            self.up_auto_p2p_tunnels.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "total-auto-p2p-tunnels" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/summary/auto-tun-server-summary/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.auto_p2p_tunnel.is_set or self.auto_p2p_tunnel.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.auto_p2p_tunnel.get_name_leafdata())
                        if (self.down_auto_p2p_tunnels.is_set or self.down_auto_p2p_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.down_auto_p2p_tunnels.get_name_leafdata())
                        if (self.up_auto_p2p_tunnels.is_set or self.up_auto_p2p_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.up_auto_p2p_tunnels.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "auto-p2p-tunnel" or name == "down-auto-p2p-tunnels" or name == "up-auto-p2p-tunnels"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "auto-p2p-tunnel"):
                            self.auto_p2p_tunnel = value
                            self.auto_p2p_tunnel.value_namespace = name_space
                            self.auto_p2p_tunnel.value_namespace_prefix = name_space_prefix
                        if(value_path == "down-auto-p2p-tunnels"):
                            self.down_auto_p2p_tunnels = value
                            self.down_auto_p2p_tunnels.value_namespace = name_space
                            self.down_auto_p2p_tunnels.value_namespace_prefix = name_space_prefix
                        if(value_path == "up-auto-p2p-tunnels"):
                            self.up_auto_p2p_tunnels = value
                            self.up_auto_p2p_tunnels.value_namespace = name_space
                            self.up_auto_p2p_tunnels.value_namespace_prefix = name_space_prefix


                class ClientsSummary(Entity):
                    """
                    List of auto\-tunnel server clients
                    
                    .. attribute:: client_id
                    
                    	Client ID
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: client_instance_name
                    
                    	Client Instance name
                    	**type**\:  str
                    
                    .. attribute:: p2mp_info
                    
                    	P2MP info for a client
                    	**type**\:   :py:class:`P2MpInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.Summary.AutoTunServerSummary.ClientsSummary.P2MpInfo>`
                    
                    .. attribute:: p2p_info
                    
                    	P2P info for a client
                    	**type**\:   :py:class:`P2PInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.Summary.AutoTunServerSummary.ClientsSummary.P2PInfo>`
                    
                    .. attribute:: protocol_type
                    
                    	Client's protocol type
                    	**type**\:   :py:class:`TeServTunClient <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeServTunClient>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.Tunnels.Summary.AutoTunServerSummary.ClientsSummary, self).__init__()

                        self.yang_name = "clients-summary"
                        self.yang_parent_name = "auto-tun-server-summary"

                        self.client_id = YLeaf(YType.uint32, "client-id")

                        self.client_instance_name = YLeaf(YType.str, "client-instance-name")

                        self.protocol_type = YLeaf(YType.enumeration, "protocol-type")

                        self.p2mp_info = MplsTeStandby.Tunnels.Summary.AutoTunServerSummary.ClientsSummary.P2MpInfo()
                        self.p2mp_info.parent = self
                        self._children_name_map["p2mp_info"] = "p2mp-info"
                        self._children_yang_names.add("p2mp-info")

                        self.p2p_info = MplsTeStandby.Tunnels.Summary.AutoTunServerSummary.ClientsSummary.P2PInfo()
                        self.p2p_info.parent = self
                        self._children_name_map["p2p_info"] = "p2p-info"
                        self._children_yang_names.add("p2p-info")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("client_id",
                                        "client_instance_name",
                                        "protocol_type") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.Tunnels.Summary.AutoTunServerSummary.ClientsSummary, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.Tunnels.Summary.AutoTunServerSummary.ClientsSummary, self).__setattr__(name, value)


                    class P2MpInfo(Entity):
                        """
                        P2MP info for a client
                        
                        .. attribute:: auto_p2mp_destinations
                        
                        	Total number of client P2MP auto\-tunnel destinations
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: auto_p2mp_tunnel
                        
                        	Total number of client P2MP auto\-tunnels
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: down_auto_p2mp_destinations
                        
                        	Total number of client P2MP auto\-tunnel destinations that are down
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: down_auto_p2mp_tunnels
                        
                        	Total number of client P2MP auto\-tunnels that are down
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: frr_auto_p2mp_tunnels
                        
                        	Total number of client P2MP auto\-tunnels that are FRR enabled
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: up_auto_p2mp_destinations
                        
                        	Total number of client P2MP auto\-tunnel destinations that are up
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: up_auto_p2mp_tunnels
                        
                        	Total number of client P2MP auto\-tunnels that are up
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.Tunnels.Summary.AutoTunServerSummary.ClientsSummary.P2MpInfo, self).__init__()

                            self.yang_name = "p2mp-info"
                            self.yang_parent_name = "clients-summary"

                            self.auto_p2mp_destinations = YLeaf(YType.uint32, "auto-p2mp-destinations")

                            self.auto_p2mp_tunnel = YLeaf(YType.uint32, "auto-p2mp-tunnel")

                            self.down_auto_p2mp_destinations = YLeaf(YType.uint32, "down-auto-p2mp-destinations")

                            self.down_auto_p2mp_tunnels = YLeaf(YType.uint32, "down-auto-p2mp-tunnels")

                            self.frr_auto_p2mp_tunnels = YLeaf(YType.uint32, "frr-auto-p2mp-tunnels")

                            self.up_auto_p2mp_destinations = YLeaf(YType.uint32, "up-auto-p2mp-destinations")

                            self.up_auto_p2mp_tunnels = YLeaf(YType.uint32, "up-auto-p2mp-tunnels")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("auto_p2mp_destinations",
                                            "auto_p2mp_tunnel",
                                            "down_auto_p2mp_destinations",
                                            "down_auto_p2mp_tunnels",
                                            "frr_auto_p2mp_tunnels",
                                            "up_auto_p2mp_destinations",
                                            "up_auto_p2mp_tunnels") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.Tunnels.Summary.AutoTunServerSummary.ClientsSummary.P2MpInfo, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.Tunnels.Summary.AutoTunServerSummary.ClientsSummary.P2MpInfo, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.auto_p2mp_destinations.is_set or
                                self.auto_p2mp_tunnel.is_set or
                                self.down_auto_p2mp_destinations.is_set or
                                self.down_auto_p2mp_tunnels.is_set or
                                self.frr_auto_p2mp_tunnels.is_set or
                                self.up_auto_p2mp_destinations.is_set or
                                self.up_auto_p2mp_tunnels.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.auto_p2mp_destinations.yfilter != YFilter.not_set or
                                self.auto_p2mp_tunnel.yfilter != YFilter.not_set or
                                self.down_auto_p2mp_destinations.yfilter != YFilter.not_set or
                                self.down_auto_p2mp_tunnels.yfilter != YFilter.not_set or
                                self.frr_auto_p2mp_tunnels.yfilter != YFilter.not_set or
                                self.up_auto_p2mp_destinations.yfilter != YFilter.not_set or
                                self.up_auto_p2mp_tunnels.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "p2mp-info" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/summary/auto-tun-server-summary/clients-summary/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.auto_p2mp_destinations.is_set or self.auto_p2mp_destinations.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.auto_p2mp_destinations.get_name_leafdata())
                            if (self.auto_p2mp_tunnel.is_set or self.auto_p2mp_tunnel.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.auto_p2mp_tunnel.get_name_leafdata())
                            if (self.down_auto_p2mp_destinations.is_set or self.down_auto_p2mp_destinations.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.down_auto_p2mp_destinations.get_name_leafdata())
                            if (self.down_auto_p2mp_tunnels.is_set or self.down_auto_p2mp_tunnels.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.down_auto_p2mp_tunnels.get_name_leafdata())
                            if (self.frr_auto_p2mp_tunnels.is_set or self.frr_auto_p2mp_tunnels.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.frr_auto_p2mp_tunnels.get_name_leafdata())
                            if (self.up_auto_p2mp_destinations.is_set or self.up_auto_p2mp_destinations.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.up_auto_p2mp_destinations.get_name_leafdata())
                            if (self.up_auto_p2mp_tunnels.is_set or self.up_auto_p2mp_tunnels.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.up_auto_p2mp_tunnels.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "auto-p2mp-destinations" or name == "auto-p2mp-tunnel" or name == "down-auto-p2mp-destinations" or name == "down-auto-p2mp-tunnels" or name == "frr-auto-p2mp-tunnels" or name == "up-auto-p2mp-destinations" or name == "up-auto-p2mp-tunnels"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "auto-p2mp-destinations"):
                                self.auto_p2mp_destinations = value
                                self.auto_p2mp_destinations.value_namespace = name_space
                                self.auto_p2mp_destinations.value_namespace_prefix = name_space_prefix
                            if(value_path == "auto-p2mp-tunnel"):
                                self.auto_p2mp_tunnel = value
                                self.auto_p2mp_tunnel.value_namespace = name_space
                                self.auto_p2mp_tunnel.value_namespace_prefix = name_space_prefix
                            if(value_path == "down-auto-p2mp-destinations"):
                                self.down_auto_p2mp_destinations = value
                                self.down_auto_p2mp_destinations.value_namespace = name_space
                                self.down_auto_p2mp_destinations.value_namespace_prefix = name_space_prefix
                            if(value_path == "down-auto-p2mp-tunnels"):
                                self.down_auto_p2mp_tunnels = value
                                self.down_auto_p2mp_tunnels.value_namespace = name_space
                                self.down_auto_p2mp_tunnels.value_namespace_prefix = name_space_prefix
                            if(value_path == "frr-auto-p2mp-tunnels"):
                                self.frr_auto_p2mp_tunnels = value
                                self.frr_auto_p2mp_tunnels.value_namespace = name_space
                                self.frr_auto_p2mp_tunnels.value_namespace_prefix = name_space_prefix
                            if(value_path == "up-auto-p2mp-destinations"):
                                self.up_auto_p2mp_destinations = value
                                self.up_auto_p2mp_destinations.value_namespace = name_space
                                self.up_auto_p2mp_destinations.value_namespace_prefix = name_space_prefix
                            if(value_path == "up-auto-p2mp-tunnels"):
                                self.up_auto_p2mp_tunnels = value
                                self.up_auto_p2mp_tunnels.value_namespace = name_space
                                self.up_auto_p2mp_tunnels.value_namespace_prefix = name_space_prefix


                    class P2PInfo(Entity):
                        """
                        P2P info for a client
                        
                        .. attribute:: auto_p2p_tunnel
                        
                        	Total number of client P2P auto\-tunnels
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: down_auto_p2p_tunnels
                        
                        	Total number of client P2P auto\-tunnels that are down
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: up_auto_p2p_tunnels
                        
                        	Total number of client P2P auto\-tunnels that are up
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.Tunnels.Summary.AutoTunServerSummary.ClientsSummary.P2PInfo, self).__init__()

                            self.yang_name = "p2p-info"
                            self.yang_parent_name = "clients-summary"

                            self.auto_p2p_tunnel = YLeaf(YType.uint32, "auto-p2p-tunnel")

                            self.down_auto_p2p_tunnels = YLeaf(YType.uint32, "down-auto-p2p-tunnels")

                            self.up_auto_p2p_tunnels = YLeaf(YType.uint32, "up-auto-p2p-tunnels")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("auto_p2p_tunnel",
                                            "down_auto_p2p_tunnels",
                                            "up_auto_p2p_tunnels") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.Tunnels.Summary.AutoTunServerSummary.ClientsSummary.P2PInfo, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.Tunnels.Summary.AutoTunServerSummary.ClientsSummary.P2PInfo, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.auto_p2p_tunnel.is_set or
                                self.down_auto_p2p_tunnels.is_set or
                                self.up_auto_p2p_tunnels.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.auto_p2p_tunnel.yfilter != YFilter.not_set or
                                self.down_auto_p2p_tunnels.yfilter != YFilter.not_set or
                                self.up_auto_p2p_tunnels.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "p2p-info" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/summary/auto-tun-server-summary/clients-summary/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.auto_p2p_tunnel.is_set or self.auto_p2p_tunnel.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.auto_p2p_tunnel.get_name_leafdata())
                            if (self.down_auto_p2p_tunnels.is_set or self.down_auto_p2p_tunnels.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.down_auto_p2p_tunnels.get_name_leafdata())
                            if (self.up_auto_p2p_tunnels.is_set or self.up_auto_p2p_tunnels.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.up_auto_p2p_tunnels.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "auto-p2p-tunnel" or name == "down-auto-p2p-tunnels" or name == "up-auto-p2p-tunnels"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "auto-p2p-tunnel"):
                                self.auto_p2p_tunnel = value
                                self.auto_p2p_tunnel.value_namespace = name_space
                                self.auto_p2p_tunnel.value_namespace_prefix = name_space_prefix
                            if(value_path == "down-auto-p2p-tunnels"):
                                self.down_auto_p2p_tunnels = value
                                self.down_auto_p2p_tunnels.value_namespace = name_space
                                self.down_auto_p2p_tunnels.value_namespace_prefix = name_space_prefix
                            if(value_path == "up-auto-p2p-tunnels"):
                                self.up_auto_p2p_tunnels = value
                                self.up_auto_p2p_tunnels.value_namespace = name_space
                                self.up_auto_p2p_tunnels.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.client_id.is_set or
                            self.client_instance_name.is_set or
                            self.protocol_type.is_set or
                            (self.p2mp_info is not None and self.p2mp_info.has_data()) or
                            (self.p2p_info is not None and self.p2p_info.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.client_id.yfilter != YFilter.not_set or
                            self.client_instance_name.yfilter != YFilter.not_set or
                            self.protocol_type.yfilter != YFilter.not_set or
                            (self.p2mp_info is not None and self.p2mp_info.has_operation()) or
                            (self.p2p_info is not None and self.p2p_info.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "clients-summary" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/summary/auto-tun-server-summary/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.client_id.is_set or self.client_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.client_id.get_name_leafdata())
                        if (self.client_instance_name.is_set or self.client_instance_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.client_instance_name.get_name_leafdata())
                        if (self.protocol_type.is_set or self.protocol_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.protocol_type.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "p2mp-info"):
                            if (self.p2mp_info is None):
                                self.p2mp_info = MplsTeStandby.Tunnels.Summary.AutoTunServerSummary.ClientsSummary.P2MpInfo()
                                self.p2mp_info.parent = self
                                self._children_name_map["p2mp_info"] = "p2mp-info"
                            return self.p2mp_info

                        if (child_yang_name == "p2p-info"):
                            if (self.p2p_info is None):
                                self.p2p_info = MplsTeStandby.Tunnels.Summary.AutoTunServerSummary.ClientsSummary.P2PInfo()
                                self.p2p_info.parent = self
                                self._children_name_map["p2p_info"] = "p2p-info"
                            return self.p2p_info

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "p2mp-info" or name == "p2p-info" or name == "client-id" or name == "client-instance-name" or name == "protocol-type"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "client-id"):
                            self.client_id = value
                            self.client_id.value_namespace = name_space
                            self.client_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "client-instance-name"):
                            self.client_instance_name = value
                            self.client_instance_name.value_namespace = name_space
                            self.client_instance_name.value_namespace_prefix = name_space_prefix
                        if(value_path == "protocol-type"):
                            self.protocol_type = value
                            self.protocol_type.value_namespace = name_space
                            self.protocol_type.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.clients_summary:
                        if (c.has_data()):
                            return True
                    return (
                        (self.total_auto_p2mp_tunnels is not None and self.total_auto_p2mp_tunnels.has_data()) or
                        (self.total_auto_p2p_tunnels is not None and self.total_auto_p2p_tunnels.has_data()))

                def has_operation(self):
                    for c in self.clients_summary:
                        if (c.has_operation()):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        (self.total_auto_p2mp_tunnels is not None and self.total_auto_p2mp_tunnels.has_operation()) or
                        (self.total_auto_p2p_tunnels is not None and self.total_auto_p2p_tunnels.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "auto-tun-server-summary" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/summary/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "clients-summary"):
                        for c in self.clients_summary:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsTeStandby.Tunnels.Summary.AutoTunServerSummary.ClientsSummary()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.clients_summary.append(c)
                        return c

                    if (child_yang_name == "total-auto-p2mp-tunnels"):
                        if (self.total_auto_p2mp_tunnels is None):
                            self.total_auto_p2mp_tunnels = MplsTeStandby.Tunnels.Summary.AutoTunServerSummary.TotalAutoP2MpTunnels()
                            self.total_auto_p2mp_tunnels.parent = self
                            self._children_name_map["total_auto_p2mp_tunnels"] = "total-auto-p2mp-tunnels"
                        return self.total_auto_p2mp_tunnels

                    if (child_yang_name == "total-auto-p2p-tunnels"):
                        if (self.total_auto_p2p_tunnels is None):
                            self.total_auto_p2p_tunnels = MplsTeStandby.Tunnels.Summary.AutoTunServerSummary.TotalAutoP2PTunnels()
                            self.total_auto_p2p_tunnels.parent = self
                            self._children_name_map["total_auto_p2p_tunnels"] = "total-auto-p2p-tunnels"
                        return self.total_auto_p2p_tunnels

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "clients-summary" or name == "total-auto-p2mp-tunnels" or name == "total-auto-p2p-tunnels"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    pass

            def has_data(self):
                return (
                    self.activated_heads.is_set or
                    self.auto_bandwidth_collection_period.is_set or
                    self.auto_bandwidth_tunnels.is_set or
                    self.backup_tunnels.is_set or
                    self.backups_assigned.is_set or
                    self.bidir_head_ls_ps_associated.is_set or
                    self.bidir_head_ls_ps_proceeding.is_set or
                    self.bidir_head_ls_ps_standby.is_set or
                    self.bidir_head_ls_ps_up.is_set or
                    self.bidir_head_tunnels.is_set or
                    self.bidir_head_tunnels_associated.is_set or
                    self.bidir_head_tunnels_corouted.is_set or
                    self.bidir_head_tunnels_up.is_set or
                    self.bidir_mid_ls_ps_associated.is_set or
                    self.bidir_mid_ls_ps_proceeding.is_set or
                    self.bidir_mid_ls_ps_standby.is_set or
                    self.bidir_mid_tunnels.is_set or
                    self.bidir_mid_tunnels_up.is_set or
                    self.bidir_tail_ls_ps.is_set or
                    self.bidir_tail_ls_ps_associated.is_set or
                    self.bidir_tail_ls_ps_corouted.is_set or
                    self.bidir_tail_ls_ps_proceeding.is_set or
                    self.bidir_tail_ls_ps_standby.is_set or
                    self.bidir_tail_ls_ps_up.is_set or
                    self.bw_protected_p2mp_s2_ls.is_set or
                    self.bw_protected_p2p_s2_ls.is_set or
                    self.bw_protected_p2p_tunnels.is_set or
                    self.bw_protected_tunnels.is_set or
                    self.deactivated_heads.is_set or
                    self.dynamic_up_p2p_head_tunnels.is_set or
                    self.frr_config_p2mp_head_tunnels.is_set or
                    self.frr_config_p2p_head_tunnels.is_set or
                    self.frr_head_tunnels.is_set or
                    self.frr_mid_point_tunnels.is_set or
                    self.frr_p2mp_head_s2_ls.is_set or
                    self.frr_p2mp_mid_point_s2_ls.is_set or
                    self.frr_p2p_head_s2_ls.is_set or
                    self.frr_p2p_head_tunnels.is_set or
                    self.frr_p2p_mid_point_s2_ls.is_set or
                    self.frr_p2p_mid_point_tunnels.is_set or
                    self.frr_protected_interfaces.is_set or
                    self.is_forwarding_enabled.is_set or
                    self.is_periodic_reoptimization_on.is_set or
                    self.is_promotion_on.is_set or
                    self.is_rsvp_process_enabled.is_set or
                    self.link_and_node_diverse_paths.is_set or
                    self.link_diverse_paths.is_set or
                    self.link_protected_p2mp_s2_ls.is_set or
                    self.link_protected_p2p_s2_ls.is_set or
                    self.link_protected_p2p_tunnels.is_set or
                    self.link_protected_tunnels.is_set or
                    self.next_check_time.is_set or
                    self.next_promotion_timer.is_set or
                    self.next_reoptimization_timer.is_set or
                    self.next_verify_timer.is_set or
                    self.node_diverse_paths.is_set or
                    self.node_protected_p2p_tunnels.is_set or
                    self.node_protected_tunnels.is_set or
                    self.p2mp_head_destinations.is_set or
                    self.p2mp_head_tunnels.is_set or
                    self.p2mp_mid_point_s2_ls.is_set or
                    self.p2mp_tail_s2_ls.is_set or
                    self.p2p_head_destinations.is_set or
                    self.p2p_head_destinations_up.is_set or
                    self.p2p_head_tunnels.is_set or
                    self.p2p_mid_point_s2_ls.is_set or
                    self.p2p_tail_s2_ls.is_set or
                    self.p2p_tail_tunnels.is_set or
                    self.path_protect_configured_tunnels.is_set or
                    self.path_protect_configured_tunnels_standby_up.is_set or
                    self.path_protect_configured_tunnels_up.is_set or
                    self.pcalc_tie_breaker_type.is_set or
                    self.pcalc_tiebreaker.is_set or
                    self.proceeding_p2mp_head_s2_ls.is_set or
                    self.proceeding_p2mp_mid_point_s2_ls.is_set or
                    self.proceeding_p2p_head_s2_ls.is_set or
                    self.proceeding_p2p_mid_point_s2_ls.is_set or
                    self.promotion_period.is_set or
                    self.protected_head_tunnels.is_set or
                    self.protected_mid_point_tunnels.is_set or
                    self.protected_p2mp_head_s2_ls.is_set or
                    self.protected_p2mp_mid_point_s2_ls.is_set or
                    self.protected_p2p_head_s2_ls.is_set or
                    self.protected_p2p_head_tunnels.is_set or
                    self.protected_p2p_mid_point_s2_ls.is_set or
                    self.protected_p2p_mid_point_tunnels.is_set or
                    self.recovered_heads.is_set or
                    self.recovering_p2p_head_s2_ls.is_set or
                    self.reoptimization_period.is_set or
                    self.rerouted_head_tunnels.is_set or
                    self.rerouted_interfaces.is_set or
                    self.rerouted_mid_point_tunnels.is_set or
                    self.rerouted_p2mp_head_s2_ls.is_set or
                    self.rerouted_p2mp_mid_point_s2_ls.is_set or
                    self.rerouted_p2p_head_s2_ls.is_set or
                    self.rerouted_p2p_head_tunnels.is_set or
                    self.rerouted_p2p_mid_point_s2_ls.is_set or
                    self.rerouted_p2p_mid_point_tunnels.is_set or
                    self.te_process_status.is_set or
                    self.tiebreaker_qualifier.is_set or
                    self.tunnel_check_period.is_set or
                    self.tunnel_verify_period.is_set or
                    self.up_p2mp_head_destinations.is_set or
                    self.up_p2mp_head_s2_ls.is_set or
                    self.up_p2mp_head_tunnels.is_set or
                    self.up_p2mp_mid_point_s2_ls.is_set or
                    self.up_p2mp_tail_s2_ls.is_set or
                    self.up_p2p_head_s2_ls.is_set or
                    self.up_p2p_head_tunnels.is_set or
                    self.up_p2p_mid_point_s2_ls.is_set or
                    self.up_p2p_tail_s2_ls.is_set or
                    self.user_defined_paths.is_set or
                    (self.auto_mesh_one_hop_summary is not None and self.auto_mesh_one_hop_summary.has_data()) or
                    (self.auto_mesh_summary is not None and self.auto_mesh_summary.has_data()) or
                    (self.auto_tun_server_summary is not None and self.auto_tun_server_summary.has_data()) or
                    (self.autobackup_summary is not None and self.autobackup_summary.has_data()) or
                    (self.current_tunnel_convergence_summary is not None and self.current_tunnel_convergence_summary.has_data()) or
                    (self.gmpls_nni_summary is not None and self.gmpls_nni_summary.has_data()) or
                    (self.gmpls_uni_summary is not None and self.gmpls_uni_summary.has_data()) or
                    (self.last_tunnel_convergence_summary is not None and self.last_tunnel_convergence_summary.has_data()))

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    self.activated_heads.yfilter != YFilter.not_set or
                    self.auto_bandwidth_collection_period.yfilter != YFilter.not_set or
                    self.auto_bandwidth_tunnels.yfilter != YFilter.not_set or
                    self.backup_tunnels.yfilter != YFilter.not_set or
                    self.backups_assigned.yfilter != YFilter.not_set or
                    self.bidir_head_ls_ps_associated.yfilter != YFilter.not_set or
                    self.bidir_head_ls_ps_proceeding.yfilter != YFilter.not_set or
                    self.bidir_head_ls_ps_standby.yfilter != YFilter.not_set or
                    self.bidir_head_ls_ps_up.yfilter != YFilter.not_set or
                    self.bidir_head_tunnels.yfilter != YFilter.not_set or
                    self.bidir_head_tunnels_associated.yfilter != YFilter.not_set or
                    self.bidir_head_tunnels_corouted.yfilter != YFilter.not_set or
                    self.bidir_head_tunnels_up.yfilter != YFilter.not_set or
                    self.bidir_mid_ls_ps_associated.yfilter != YFilter.not_set or
                    self.bidir_mid_ls_ps_proceeding.yfilter != YFilter.not_set or
                    self.bidir_mid_ls_ps_standby.yfilter != YFilter.not_set or
                    self.bidir_mid_tunnels.yfilter != YFilter.not_set or
                    self.bidir_mid_tunnels_up.yfilter != YFilter.not_set or
                    self.bidir_tail_ls_ps.yfilter != YFilter.not_set or
                    self.bidir_tail_ls_ps_associated.yfilter != YFilter.not_set or
                    self.bidir_tail_ls_ps_corouted.yfilter != YFilter.not_set or
                    self.bidir_tail_ls_ps_proceeding.yfilter != YFilter.not_set or
                    self.bidir_tail_ls_ps_standby.yfilter != YFilter.not_set or
                    self.bidir_tail_ls_ps_up.yfilter != YFilter.not_set or
                    self.bw_protected_p2mp_s2_ls.yfilter != YFilter.not_set or
                    self.bw_protected_p2p_s2_ls.yfilter != YFilter.not_set or
                    self.bw_protected_p2p_tunnels.yfilter != YFilter.not_set or
                    self.bw_protected_tunnels.yfilter != YFilter.not_set or
                    self.deactivated_heads.yfilter != YFilter.not_set or
                    self.dynamic_up_p2p_head_tunnels.yfilter != YFilter.not_set or
                    self.frr_config_p2mp_head_tunnels.yfilter != YFilter.not_set or
                    self.frr_config_p2p_head_tunnels.yfilter != YFilter.not_set or
                    self.frr_head_tunnels.yfilter != YFilter.not_set or
                    self.frr_mid_point_tunnels.yfilter != YFilter.not_set or
                    self.frr_p2mp_head_s2_ls.yfilter != YFilter.not_set or
                    self.frr_p2mp_mid_point_s2_ls.yfilter != YFilter.not_set or
                    self.frr_p2p_head_s2_ls.yfilter != YFilter.not_set or
                    self.frr_p2p_head_tunnels.yfilter != YFilter.not_set or
                    self.frr_p2p_mid_point_s2_ls.yfilter != YFilter.not_set or
                    self.frr_p2p_mid_point_tunnels.yfilter != YFilter.not_set or
                    self.frr_protected_interfaces.yfilter != YFilter.not_set or
                    self.is_forwarding_enabled.yfilter != YFilter.not_set or
                    self.is_periodic_reoptimization_on.yfilter != YFilter.not_set or
                    self.is_promotion_on.yfilter != YFilter.not_set or
                    self.is_rsvp_process_enabled.yfilter != YFilter.not_set or
                    self.link_and_node_diverse_paths.yfilter != YFilter.not_set or
                    self.link_diverse_paths.yfilter != YFilter.not_set or
                    self.link_protected_p2mp_s2_ls.yfilter != YFilter.not_set or
                    self.link_protected_p2p_s2_ls.yfilter != YFilter.not_set or
                    self.link_protected_p2p_tunnels.yfilter != YFilter.not_set or
                    self.link_protected_tunnels.yfilter != YFilter.not_set or
                    self.next_check_time.yfilter != YFilter.not_set or
                    self.next_promotion_timer.yfilter != YFilter.not_set or
                    self.next_reoptimization_timer.yfilter != YFilter.not_set or
                    self.next_verify_timer.yfilter != YFilter.not_set or
                    self.node_diverse_paths.yfilter != YFilter.not_set or
                    self.node_protected_p2p_tunnels.yfilter != YFilter.not_set or
                    self.node_protected_tunnels.yfilter != YFilter.not_set or
                    self.p2mp_head_destinations.yfilter != YFilter.not_set or
                    self.p2mp_head_tunnels.yfilter != YFilter.not_set or
                    self.p2mp_mid_point_s2_ls.yfilter != YFilter.not_set or
                    self.p2mp_tail_s2_ls.yfilter != YFilter.not_set or
                    self.p2p_head_destinations.yfilter != YFilter.not_set or
                    self.p2p_head_destinations_up.yfilter != YFilter.not_set or
                    self.p2p_head_tunnels.yfilter != YFilter.not_set or
                    self.p2p_mid_point_s2_ls.yfilter != YFilter.not_set or
                    self.p2p_tail_s2_ls.yfilter != YFilter.not_set or
                    self.p2p_tail_tunnels.yfilter != YFilter.not_set or
                    self.path_protect_configured_tunnels.yfilter != YFilter.not_set or
                    self.path_protect_configured_tunnels_standby_up.yfilter != YFilter.not_set or
                    self.path_protect_configured_tunnels_up.yfilter != YFilter.not_set or
                    self.pcalc_tie_breaker_type.yfilter != YFilter.not_set or
                    self.pcalc_tiebreaker.yfilter != YFilter.not_set or
                    self.proceeding_p2mp_head_s2_ls.yfilter != YFilter.not_set or
                    self.proceeding_p2mp_mid_point_s2_ls.yfilter != YFilter.not_set or
                    self.proceeding_p2p_head_s2_ls.yfilter != YFilter.not_set or
                    self.proceeding_p2p_mid_point_s2_ls.yfilter != YFilter.not_set or
                    self.promotion_period.yfilter != YFilter.not_set or
                    self.protected_head_tunnels.yfilter != YFilter.not_set or
                    self.protected_mid_point_tunnels.yfilter != YFilter.not_set or
                    self.protected_p2mp_head_s2_ls.yfilter != YFilter.not_set or
                    self.protected_p2mp_mid_point_s2_ls.yfilter != YFilter.not_set or
                    self.protected_p2p_head_s2_ls.yfilter != YFilter.not_set or
                    self.protected_p2p_head_tunnels.yfilter != YFilter.not_set or
                    self.protected_p2p_mid_point_s2_ls.yfilter != YFilter.not_set or
                    self.protected_p2p_mid_point_tunnels.yfilter != YFilter.not_set or
                    self.recovered_heads.yfilter != YFilter.not_set or
                    self.recovering_p2p_head_s2_ls.yfilter != YFilter.not_set or
                    self.reoptimization_period.yfilter != YFilter.not_set or
                    self.rerouted_head_tunnels.yfilter != YFilter.not_set or
                    self.rerouted_interfaces.yfilter != YFilter.not_set or
                    self.rerouted_mid_point_tunnels.yfilter != YFilter.not_set or
                    self.rerouted_p2mp_head_s2_ls.yfilter != YFilter.not_set or
                    self.rerouted_p2mp_mid_point_s2_ls.yfilter != YFilter.not_set or
                    self.rerouted_p2p_head_s2_ls.yfilter != YFilter.not_set or
                    self.rerouted_p2p_head_tunnels.yfilter != YFilter.not_set or
                    self.rerouted_p2p_mid_point_s2_ls.yfilter != YFilter.not_set or
                    self.rerouted_p2p_mid_point_tunnels.yfilter != YFilter.not_set or
                    self.te_process_status.yfilter != YFilter.not_set or
                    self.tiebreaker_qualifier.yfilter != YFilter.not_set or
                    self.tunnel_check_period.yfilter != YFilter.not_set or
                    self.tunnel_verify_period.yfilter != YFilter.not_set or
                    self.up_p2mp_head_destinations.yfilter != YFilter.not_set or
                    self.up_p2mp_head_s2_ls.yfilter != YFilter.not_set or
                    self.up_p2mp_head_tunnels.yfilter != YFilter.not_set or
                    self.up_p2mp_mid_point_s2_ls.yfilter != YFilter.not_set or
                    self.up_p2mp_tail_s2_ls.yfilter != YFilter.not_set or
                    self.up_p2p_head_s2_ls.yfilter != YFilter.not_set or
                    self.up_p2p_head_tunnels.yfilter != YFilter.not_set or
                    self.up_p2p_mid_point_s2_ls.yfilter != YFilter.not_set or
                    self.up_p2p_tail_s2_ls.yfilter != YFilter.not_set or
                    self.user_defined_paths.yfilter != YFilter.not_set or
                    (self.auto_mesh_one_hop_summary is not None and self.auto_mesh_one_hop_summary.has_operation()) or
                    (self.auto_mesh_summary is not None and self.auto_mesh_summary.has_operation()) or
                    (self.auto_tun_server_summary is not None and self.auto_tun_server_summary.has_operation()) or
                    (self.autobackup_summary is not None and self.autobackup_summary.has_operation()) or
                    (self.current_tunnel_convergence_summary is not None and self.current_tunnel_convergence_summary.has_operation()) or
                    (self.gmpls_nni_summary is not None and self.gmpls_nni_summary.has_operation()) or
                    (self.gmpls_uni_summary is not None and self.gmpls_uni_summary.has_operation()) or
                    (self.last_tunnel_convergence_summary is not None and self.last_tunnel_convergence_summary.has_operation()))

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "summary" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.activated_heads.is_set or self.activated_heads.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.activated_heads.get_name_leafdata())
                if (self.auto_bandwidth_collection_period.is_set or self.auto_bandwidth_collection_period.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.auto_bandwidth_collection_period.get_name_leafdata())
                if (self.auto_bandwidth_tunnels.is_set or self.auto_bandwidth_tunnels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.auto_bandwidth_tunnels.get_name_leafdata())
                if (self.backup_tunnels.is_set or self.backup_tunnels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.backup_tunnels.get_name_leafdata())
                if (self.backups_assigned.is_set or self.backups_assigned.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.backups_assigned.get_name_leafdata())
                if (self.bidir_head_ls_ps_associated.is_set or self.bidir_head_ls_ps_associated.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.bidir_head_ls_ps_associated.get_name_leafdata())
                if (self.bidir_head_ls_ps_proceeding.is_set or self.bidir_head_ls_ps_proceeding.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.bidir_head_ls_ps_proceeding.get_name_leafdata())
                if (self.bidir_head_ls_ps_standby.is_set or self.bidir_head_ls_ps_standby.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.bidir_head_ls_ps_standby.get_name_leafdata())
                if (self.bidir_head_ls_ps_up.is_set or self.bidir_head_ls_ps_up.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.bidir_head_ls_ps_up.get_name_leafdata())
                if (self.bidir_head_tunnels.is_set or self.bidir_head_tunnels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.bidir_head_tunnels.get_name_leafdata())
                if (self.bidir_head_tunnels_associated.is_set or self.bidir_head_tunnels_associated.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.bidir_head_tunnels_associated.get_name_leafdata())
                if (self.bidir_head_tunnels_corouted.is_set or self.bidir_head_tunnels_corouted.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.bidir_head_tunnels_corouted.get_name_leafdata())
                if (self.bidir_head_tunnels_up.is_set or self.bidir_head_tunnels_up.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.bidir_head_tunnels_up.get_name_leafdata())
                if (self.bidir_mid_ls_ps_associated.is_set or self.bidir_mid_ls_ps_associated.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.bidir_mid_ls_ps_associated.get_name_leafdata())
                if (self.bidir_mid_ls_ps_proceeding.is_set or self.bidir_mid_ls_ps_proceeding.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.bidir_mid_ls_ps_proceeding.get_name_leafdata())
                if (self.bidir_mid_ls_ps_standby.is_set or self.bidir_mid_ls_ps_standby.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.bidir_mid_ls_ps_standby.get_name_leafdata())
                if (self.bidir_mid_tunnels.is_set or self.bidir_mid_tunnels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.bidir_mid_tunnels.get_name_leafdata())
                if (self.bidir_mid_tunnels_up.is_set or self.bidir_mid_tunnels_up.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.bidir_mid_tunnels_up.get_name_leafdata())
                if (self.bidir_tail_ls_ps.is_set or self.bidir_tail_ls_ps.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.bidir_tail_ls_ps.get_name_leafdata())
                if (self.bidir_tail_ls_ps_associated.is_set or self.bidir_tail_ls_ps_associated.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.bidir_tail_ls_ps_associated.get_name_leafdata())
                if (self.bidir_tail_ls_ps_corouted.is_set or self.bidir_tail_ls_ps_corouted.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.bidir_tail_ls_ps_corouted.get_name_leafdata())
                if (self.bidir_tail_ls_ps_proceeding.is_set or self.bidir_tail_ls_ps_proceeding.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.bidir_tail_ls_ps_proceeding.get_name_leafdata())
                if (self.bidir_tail_ls_ps_standby.is_set or self.bidir_tail_ls_ps_standby.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.bidir_tail_ls_ps_standby.get_name_leafdata())
                if (self.bidir_tail_ls_ps_up.is_set or self.bidir_tail_ls_ps_up.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.bidir_tail_ls_ps_up.get_name_leafdata())
                if (self.bw_protected_p2mp_s2_ls.is_set or self.bw_protected_p2mp_s2_ls.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.bw_protected_p2mp_s2_ls.get_name_leafdata())
                if (self.bw_protected_p2p_s2_ls.is_set or self.bw_protected_p2p_s2_ls.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.bw_protected_p2p_s2_ls.get_name_leafdata())
                if (self.bw_protected_p2p_tunnels.is_set or self.bw_protected_p2p_tunnels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.bw_protected_p2p_tunnels.get_name_leafdata())
                if (self.bw_protected_tunnels.is_set or self.bw_protected_tunnels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.bw_protected_tunnels.get_name_leafdata())
                if (self.deactivated_heads.is_set or self.deactivated_heads.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.deactivated_heads.get_name_leafdata())
                if (self.dynamic_up_p2p_head_tunnels.is_set or self.dynamic_up_p2p_head_tunnels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.dynamic_up_p2p_head_tunnels.get_name_leafdata())
                if (self.frr_config_p2mp_head_tunnels.is_set or self.frr_config_p2mp_head_tunnels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.frr_config_p2mp_head_tunnels.get_name_leafdata())
                if (self.frr_config_p2p_head_tunnels.is_set or self.frr_config_p2p_head_tunnels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.frr_config_p2p_head_tunnels.get_name_leafdata())
                if (self.frr_head_tunnels.is_set or self.frr_head_tunnels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.frr_head_tunnels.get_name_leafdata())
                if (self.frr_mid_point_tunnels.is_set or self.frr_mid_point_tunnels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.frr_mid_point_tunnels.get_name_leafdata())
                if (self.frr_p2mp_head_s2_ls.is_set or self.frr_p2mp_head_s2_ls.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.frr_p2mp_head_s2_ls.get_name_leafdata())
                if (self.frr_p2mp_mid_point_s2_ls.is_set or self.frr_p2mp_mid_point_s2_ls.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.frr_p2mp_mid_point_s2_ls.get_name_leafdata())
                if (self.frr_p2p_head_s2_ls.is_set or self.frr_p2p_head_s2_ls.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.frr_p2p_head_s2_ls.get_name_leafdata())
                if (self.frr_p2p_head_tunnels.is_set or self.frr_p2p_head_tunnels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.frr_p2p_head_tunnels.get_name_leafdata())
                if (self.frr_p2p_mid_point_s2_ls.is_set or self.frr_p2p_mid_point_s2_ls.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.frr_p2p_mid_point_s2_ls.get_name_leafdata())
                if (self.frr_p2p_mid_point_tunnels.is_set or self.frr_p2p_mid_point_tunnels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.frr_p2p_mid_point_tunnels.get_name_leafdata())
                if (self.frr_protected_interfaces.is_set or self.frr_protected_interfaces.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.frr_protected_interfaces.get_name_leafdata())
                if (self.is_forwarding_enabled.is_set or self.is_forwarding_enabled.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.is_forwarding_enabled.get_name_leafdata())
                if (self.is_periodic_reoptimization_on.is_set or self.is_periodic_reoptimization_on.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.is_periodic_reoptimization_on.get_name_leafdata())
                if (self.is_promotion_on.is_set or self.is_promotion_on.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.is_promotion_on.get_name_leafdata())
                if (self.is_rsvp_process_enabled.is_set or self.is_rsvp_process_enabled.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.is_rsvp_process_enabled.get_name_leafdata())
                if (self.link_and_node_diverse_paths.is_set or self.link_and_node_diverse_paths.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.link_and_node_diverse_paths.get_name_leafdata())
                if (self.link_diverse_paths.is_set or self.link_diverse_paths.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.link_diverse_paths.get_name_leafdata())
                if (self.link_protected_p2mp_s2_ls.is_set or self.link_protected_p2mp_s2_ls.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.link_protected_p2mp_s2_ls.get_name_leafdata())
                if (self.link_protected_p2p_s2_ls.is_set or self.link_protected_p2p_s2_ls.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.link_protected_p2p_s2_ls.get_name_leafdata())
                if (self.link_protected_p2p_tunnels.is_set or self.link_protected_p2p_tunnels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.link_protected_p2p_tunnels.get_name_leafdata())
                if (self.link_protected_tunnels.is_set or self.link_protected_tunnels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.link_protected_tunnels.get_name_leafdata())
                if (self.next_check_time.is_set or self.next_check_time.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.next_check_time.get_name_leafdata())
                if (self.next_promotion_timer.is_set or self.next_promotion_timer.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.next_promotion_timer.get_name_leafdata())
                if (self.next_reoptimization_timer.is_set or self.next_reoptimization_timer.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.next_reoptimization_timer.get_name_leafdata())
                if (self.next_verify_timer.is_set or self.next_verify_timer.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.next_verify_timer.get_name_leafdata())
                if (self.node_diverse_paths.is_set or self.node_diverse_paths.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.node_diverse_paths.get_name_leafdata())
                if (self.node_protected_p2p_tunnels.is_set or self.node_protected_p2p_tunnels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.node_protected_p2p_tunnels.get_name_leafdata())
                if (self.node_protected_tunnels.is_set or self.node_protected_tunnels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.node_protected_tunnels.get_name_leafdata())
                if (self.p2mp_head_destinations.is_set or self.p2mp_head_destinations.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.p2mp_head_destinations.get_name_leafdata())
                if (self.p2mp_head_tunnels.is_set or self.p2mp_head_tunnels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.p2mp_head_tunnels.get_name_leafdata())
                if (self.p2mp_mid_point_s2_ls.is_set or self.p2mp_mid_point_s2_ls.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.p2mp_mid_point_s2_ls.get_name_leafdata())
                if (self.p2mp_tail_s2_ls.is_set or self.p2mp_tail_s2_ls.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.p2mp_tail_s2_ls.get_name_leafdata())
                if (self.p2p_head_destinations.is_set or self.p2p_head_destinations.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.p2p_head_destinations.get_name_leafdata())
                if (self.p2p_head_destinations_up.is_set or self.p2p_head_destinations_up.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.p2p_head_destinations_up.get_name_leafdata())
                if (self.p2p_head_tunnels.is_set or self.p2p_head_tunnels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.p2p_head_tunnels.get_name_leafdata())
                if (self.p2p_mid_point_s2_ls.is_set or self.p2p_mid_point_s2_ls.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.p2p_mid_point_s2_ls.get_name_leafdata())
                if (self.p2p_tail_s2_ls.is_set or self.p2p_tail_s2_ls.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.p2p_tail_s2_ls.get_name_leafdata())
                if (self.p2p_tail_tunnels.is_set or self.p2p_tail_tunnels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.p2p_tail_tunnels.get_name_leafdata())
                if (self.path_protect_configured_tunnels.is_set or self.path_protect_configured_tunnels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.path_protect_configured_tunnels.get_name_leafdata())
                if (self.path_protect_configured_tunnels_standby_up.is_set or self.path_protect_configured_tunnels_standby_up.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.path_protect_configured_tunnels_standby_up.get_name_leafdata())
                if (self.path_protect_configured_tunnels_up.is_set or self.path_protect_configured_tunnels_up.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.path_protect_configured_tunnels_up.get_name_leafdata())
                if (self.pcalc_tie_breaker_type.is_set or self.pcalc_tie_breaker_type.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.pcalc_tie_breaker_type.get_name_leafdata())
                if (self.pcalc_tiebreaker.is_set or self.pcalc_tiebreaker.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.pcalc_tiebreaker.get_name_leafdata())
                if (self.proceeding_p2mp_head_s2_ls.is_set or self.proceeding_p2mp_head_s2_ls.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.proceeding_p2mp_head_s2_ls.get_name_leafdata())
                if (self.proceeding_p2mp_mid_point_s2_ls.is_set or self.proceeding_p2mp_mid_point_s2_ls.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.proceeding_p2mp_mid_point_s2_ls.get_name_leafdata())
                if (self.proceeding_p2p_head_s2_ls.is_set or self.proceeding_p2p_head_s2_ls.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.proceeding_p2p_head_s2_ls.get_name_leafdata())
                if (self.proceeding_p2p_mid_point_s2_ls.is_set or self.proceeding_p2p_mid_point_s2_ls.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.proceeding_p2p_mid_point_s2_ls.get_name_leafdata())
                if (self.promotion_period.is_set or self.promotion_period.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.promotion_period.get_name_leafdata())
                if (self.protected_head_tunnels.is_set or self.protected_head_tunnels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.protected_head_tunnels.get_name_leafdata())
                if (self.protected_mid_point_tunnels.is_set or self.protected_mid_point_tunnels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.protected_mid_point_tunnels.get_name_leafdata())
                if (self.protected_p2mp_head_s2_ls.is_set or self.protected_p2mp_head_s2_ls.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.protected_p2mp_head_s2_ls.get_name_leafdata())
                if (self.protected_p2mp_mid_point_s2_ls.is_set or self.protected_p2mp_mid_point_s2_ls.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.protected_p2mp_mid_point_s2_ls.get_name_leafdata())
                if (self.protected_p2p_head_s2_ls.is_set or self.protected_p2p_head_s2_ls.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.protected_p2p_head_s2_ls.get_name_leafdata())
                if (self.protected_p2p_head_tunnels.is_set or self.protected_p2p_head_tunnels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.protected_p2p_head_tunnels.get_name_leafdata())
                if (self.protected_p2p_mid_point_s2_ls.is_set or self.protected_p2p_mid_point_s2_ls.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.protected_p2p_mid_point_s2_ls.get_name_leafdata())
                if (self.protected_p2p_mid_point_tunnels.is_set or self.protected_p2p_mid_point_tunnels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.protected_p2p_mid_point_tunnels.get_name_leafdata())
                if (self.recovered_heads.is_set or self.recovered_heads.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.recovered_heads.get_name_leafdata())
                if (self.recovering_p2p_head_s2_ls.is_set or self.recovering_p2p_head_s2_ls.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.recovering_p2p_head_s2_ls.get_name_leafdata())
                if (self.reoptimization_period.is_set or self.reoptimization_period.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.reoptimization_period.get_name_leafdata())
                if (self.rerouted_head_tunnels.is_set or self.rerouted_head_tunnels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.rerouted_head_tunnels.get_name_leafdata())
                if (self.rerouted_interfaces.is_set or self.rerouted_interfaces.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.rerouted_interfaces.get_name_leafdata())
                if (self.rerouted_mid_point_tunnels.is_set or self.rerouted_mid_point_tunnels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.rerouted_mid_point_tunnels.get_name_leafdata())
                if (self.rerouted_p2mp_head_s2_ls.is_set or self.rerouted_p2mp_head_s2_ls.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.rerouted_p2mp_head_s2_ls.get_name_leafdata())
                if (self.rerouted_p2mp_mid_point_s2_ls.is_set or self.rerouted_p2mp_mid_point_s2_ls.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.rerouted_p2mp_mid_point_s2_ls.get_name_leafdata())
                if (self.rerouted_p2p_head_s2_ls.is_set or self.rerouted_p2p_head_s2_ls.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.rerouted_p2p_head_s2_ls.get_name_leafdata())
                if (self.rerouted_p2p_head_tunnels.is_set or self.rerouted_p2p_head_tunnels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.rerouted_p2p_head_tunnels.get_name_leafdata())
                if (self.rerouted_p2p_mid_point_s2_ls.is_set or self.rerouted_p2p_mid_point_s2_ls.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.rerouted_p2p_mid_point_s2_ls.get_name_leafdata())
                if (self.rerouted_p2p_mid_point_tunnels.is_set or self.rerouted_p2p_mid_point_tunnels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.rerouted_p2p_mid_point_tunnels.get_name_leafdata())
                if (self.te_process_status.is_set or self.te_process_status.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.te_process_status.get_name_leafdata())
                if (self.tiebreaker_qualifier.is_set or self.tiebreaker_qualifier.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.tiebreaker_qualifier.get_name_leafdata())
                if (self.tunnel_check_period.is_set or self.tunnel_check_period.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.tunnel_check_period.get_name_leafdata())
                if (self.tunnel_verify_period.is_set or self.tunnel_verify_period.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.tunnel_verify_period.get_name_leafdata())
                if (self.up_p2mp_head_destinations.is_set or self.up_p2mp_head_destinations.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.up_p2mp_head_destinations.get_name_leafdata())
                if (self.up_p2mp_head_s2_ls.is_set or self.up_p2mp_head_s2_ls.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.up_p2mp_head_s2_ls.get_name_leafdata())
                if (self.up_p2mp_head_tunnels.is_set or self.up_p2mp_head_tunnels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.up_p2mp_head_tunnels.get_name_leafdata())
                if (self.up_p2mp_mid_point_s2_ls.is_set or self.up_p2mp_mid_point_s2_ls.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.up_p2mp_mid_point_s2_ls.get_name_leafdata())
                if (self.up_p2mp_tail_s2_ls.is_set or self.up_p2mp_tail_s2_ls.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.up_p2mp_tail_s2_ls.get_name_leafdata())
                if (self.up_p2p_head_s2_ls.is_set or self.up_p2p_head_s2_ls.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.up_p2p_head_s2_ls.get_name_leafdata())
                if (self.up_p2p_head_tunnels.is_set or self.up_p2p_head_tunnels.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.up_p2p_head_tunnels.get_name_leafdata())
                if (self.up_p2p_mid_point_s2_ls.is_set or self.up_p2p_mid_point_s2_ls.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.up_p2p_mid_point_s2_ls.get_name_leafdata())
                if (self.up_p2p_tail_s2_ls.is_set or self.up_p2p_tail_s2_ls.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.up_p2p_tail_s2_ls.get_name_leafdata())
                if (self.user_defined_paths.is_set or self.user_defined_paths.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.user_defined_paths.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "auto-mesh-one-hop-summary"):
                    if (self.auto_mesh_one_hop_summary is None):
                        self.auto_mesh_one_hop_summary = MplsTeStandby.Tunnels.Summary.AutoMeshOneHopSummary()
                        self.auto_mesh_one_hop_summary.parent = self
                        self._children_name_map["auto_mesh_one_hop_summary"] = "auto-mesh-one-hop-summary"
                    return self.auto_mesh_one_hop_summary

                if (child_yang_name == "auto-mesh-summary"):
                    if (self.auto_mesh_summary is None):
                        self.auto_mesh_summary = MplsTeStandby.Tunnels.Summary.AutoMeshSummary()
                        self.auto_mesh_summary.parent = self
                        self._children_name_map["auto_mesh_summary"] = "auto-mesh-summary"
                    return self.auto_mesh_summary

                if (child_yang_name == "auto-tun-server-summary"):
                    if (self.auto_tun_server_summary is None):
                        self.auto_tun_server_summary = MplsTeStandby.Tunnels.Summary.AutoTunServerSummary()
                        self.auto_tun_server_summary.parent = self
                        self._children_name_map["auto_tun_server_summary"] = "auto-tun-server-summary"
                    return self.auto_tun_server_summary

                if (child_yang_name == "autobackup-summary"):
                    if (self.autobackup_summary is None):
                        self.autobackup_summary = MplsTeStandby.Tunnels.Summary.AutobackupSummary()
                        self.autobackup_summary.parent = self
                        self._children_name_map["autobackup_summary"] = "autobackup-summary"
                    return self.autobackup_summary

                if (child_yang_name == "current-tunnel-convergence-summary"):
                    if (self.current_tunnel_convergence_summary is None):
                        self.current_tunnel_convergence_summary = MplsTeStandby.Tunnels.Summary.CurrentTunnelConvergenceSummary()
                        self.current_tunnel_convergence_summary.parent = self
                        self._children_name_map["current_tunnel_convergence_summary"] = "current-tunnel-convergence-summary"
                    return self.current_tunnel_convergence_summary

                if (child_yang_name == "gmpls-nni-summary"):
                    if (self.gmpls_nni_summary is None):
                        self.gmpls_nni_summary = MplsTeStandby.Tunnels.Summary.GmplsNniSummary()
                        self.gmpls_nni_summary.parent = self
                        self._children_name_map["gmpls_nni_summary"] = "gmpls-nni-summary"
                    return self.gmpls_nni_summary

                if (child_yang_name == "gmpls-uni-summary"):
                    if (self.gmpls_uni_summary is None):
                        self.gmpls_uni_summary = MplsTeStandby.Tunnels.Summary.GmplsUniSummary()
                        self.gmpls_uni_summary.parent = self
                        self._children_name_map["gmpls_uni_summary"] = "gmpls-uni-summary"
                    return self.gmpls_uni_summary

                if (child_yang_name == "last-tunnel-convergence-summary"):
                    if (self.last_tunnel_convergence_summary is None):
                        self.last_tunnel_convergence_summary = MplsTeStandby.Tunnels.Summary.LastTunnelConvergenceSummary()
                        self.last_tunnel_convergence_summary.parent = self
                        self._children_name_map["last_tunnel_convergence_summary"] = "last-tunnel-convergence-summary"
                    return self.last_tunnel_convergence_summary

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "auto-mesh-one-hop-summary" or name == "auto-mesh-summary" or name == "auto-tun-server-summary" or name == "autobackup-summary" or name == "current-tunnel-convergence-summary" or name == "gmpls-nni-summary" or name == "gmpls-uni-summary" or name == "last-tunnel-convergence-summary" or name == "activated-heads" or name == "auto-bandwidth-collection-period" or name == "auto-bandwidth-tunnels" or name == "backup-tunnels" or name == "backups-assigned" or name == "bidir-head-ls-ps-associated" or name == "bidir-head-ls-ps-proceeding" or name == "bidir-head-ls-ps-standby" or name == "bidir-head-ls-ps-up" or name == "bidir-head-tunnels" or name == "bidir-head-tunnels-associated" or name == "bidir-head-tunnels-corouted" or name == "bidir-head-tunnels-up" or name == "bidir-mid-ls-ps-associated" or name == "bidir-mid-ls-ps-proceeding" or name == "bidir-mid-ls-ps-standby" or name == "bidir-mid-tunnels" or name == "bidir-mid-tunnels-up" or name == "bidir-tail-ls-ps" or name == "bidir-tail-ls-ps-associated" or name == "bidir-tail-ls-ps-corouted" or name == "bidir-tail-ls-ps-proceeding" or name == "bidir-tail-ls-ps-standby" or name == "bidir-tail-ls-ps-up" or name == "bw-protected-p2mp-s2-ls" or name == "bw-protected-p2p-s2-ls" or name == "bw-protected-p2p-tunnels" or name == "bw-protected-tunnels" or name == "deactivated-heads" or name == "dynamic-up-p2p-head-tunnels" or name == "frr-config-p2mp-head-tunnels" or name == "frr-config-p2p-head-tunnels" or name == "frr-head-tunnels" or name == "frr-mid-point-tunnels" or name == "frr-p2mp-head-s2-ls" or name == "frr-p2mp-mid-point-s2-ls" or name == "frr-p2p-head-s2-ls" or name == "frr-p2p-head-tunnels" or name == "frr-p2p-mid-point-s2-ls" or name == "frr-p2p-mid-point-tunnels" or name == "frr-protected-interfaces" or name == "is-forwarding-enabled" or name == "is-periodic-reoptimization-on" or name == "is-promotion-on" or name == "is-rsvp-process-enabled" or name == "link-and-node-diverse-paths" or name == "link-diverse-paths" or name == "link-protected-p2mp-s2-ls" or name == "link-protected-p2p-s2-ls" or name == "link-protected-p2p-tunnels" or name == "link-protected-tunnels" or name == "next-check-time" or name == "next-promotion-timer" or name == "next-reoptimization-timer" or name == "next-verify-timer" or name == "node-diverse-paths" or name == "node-protected-p2p-tunnels" or name == "node-protected-tunnels" or name == "p2mp-head-destinations" or name == "p2mp-head-tunnels" or name == "p2mp-mid-point-s2-ls" or name == "p2mp-tail-s2-ls" or name == "p2p-head-destinations" or name == "p2p-head-destinations-up" or name == "p2p-head-tunnels" or name == "p2p-mid-point-s2-ls" or name == "p2p-tail-s2-ls" or name == "p2p-tail-tunnels" or name == "path-protect-configured-tunnels" or name == "path-protect-configured-tunnels-standby-up" or name == "path-protect-configured-tunnels-up" or name == "pcalc-tie-breaker-type" or name == "pcalc-tiebreaker" or name == "proceeding-p2mp-head-s2-ls" or name == "proceeding-p2mp-mid-point-s2-ls" or name == "proceeding-p2p-head-s2-ls" or name == "proceeding-p2p-mid-point-s2-ls" or name == "promotion-period" or name == "protected-head-tunnels" or name == "protected-mid-point-tunnels" or name == "protected-p2mp-head-s2-ls" or name == "protected-p2mp-mid-point-s2-ls" or name == "protected-p2p-head-s2-ls" or name == "protected-p2p-head-tunnels" or name == "protected-p2p-mid-point-s2-ls" or name == "protected-p2p-mid-point-tunnels" or name == "recovered-heads" or name == "recovering-p2p-head-s2-ls" or name == "reoptimization-period" or name == "rerouted-head-tunnels" or name == "rerouted-interfaces" or name == "rerouted-mid-point-tunnels" or name == "rerouted-p2mp-head-s2-ls" or name == "rerouted-p2mp-mid-point-s2-ls" or name == "rerouted-p2p-head-s2-ls" or name == "rerouted-p2p-head-tunnels" or name == "rerouted-p2p-mid-point-s2-ls" or name == "rerouted-p2p-mid-point-tunnels" or name == "te-process-status" or name == "tiebreaker-qualifier" or name == "tunnel-check-period" or name == "tunnel-verify-period" or name == "up-p2mp-head-destinations" or name == "up-p2mp-head-s2-ls" or name == "up-p2mp-head-tunnels" or name == "up-p2mp-mid-point-s2-ls" or name == "up-p2mp-tail-s2-ls" or name == "up-p2p-head-s2-ls" or name == "up-p2p-head-tunnels" or name == "up-p2p-mid-point-s2-ls" or name == "up-p2p-tail-s2-ls" or name == "user-defined-paths"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "activated-heads"):
                    self.activated_heads = value
                    self.activated_heads.value_namespace = name_space
                    self.activated_heads.value_namespace_prefix = name_space_prefix
                if(value_path == "auto-bandwidth-collection-period"):
                    self.auto_bandwidth_collection_period = value
                    self.auto_bandwidth_collection_period.value_namespace = name_space
                    self.auto_bandwidth_collection_period.value_namespace_prefix = name_space_prefix
                if(value_path == "auto-bandwidth-tunnels"):
                    self.auto_bandwidth_tunnels = value
                    self.auto_bandwidth_tunnels.value_namespace = name_space
                    self.auto_bandwidth_tunnels.value_namespace_prefix = name_space_prefix
                if(value_path == "backup-tunnels"):
                    self.backup_tunnels = value
                    self.backup_tunnels.value_namespace = name_space
                    self.backup_tunnels.value_namespace_prefix = name_space_prefix
                if(value_path == "backups-assigned"):
                    self.backups_assigned = value
                    self.backups_assigned.value_namespace = name_space
                    self.backups_assigned.value_namespace_prefix = name_space_prefix
                if(value_path == "bidir-head-ls-ps-associated"):
                    self.bidir_head_ls_ps_associated = value
                    self.bidir_head_ls_ps_associated.value_namespace = name_space
                    self.bidir_head_ls_ps_associated.value_namespace_prefix = name_space_prefix
                if(value_path == "bidir-head-ls-ps-proceeding"):
                    self.bidir_head_ls_ps_proceeding = value
                    self.bidir_head_ls_ps_proceeding.value_namespace = name_space
                    self.bidir_head_ls_ps_proceeding.value_namespace_prefix = name_space_prefix
                if(value_path == "bidir-head-ls-ps-standby"):
                    self.bidir_head_ls_ps_standby = value
                    self.bidir_head_ls_ps_standby.value_namespace = name_space
                    self.bidir_head_ls_ps_standby.value_namespace_prefix = name_space_prefix
                if(value_path == "bidir-head-ls-ps-up"):
                    self.bidir_head_ls_ps_up = value
                    self.bidir_head_ls_ps_up.value_namespace = name_space
                    self.bidir_head_ls_ps_up.value_namespace_prefix = name_space_prefix
                if(value_path == "bidir-head-tunnels"):
                    self.bidir_head_tunnels = value
                    self.bidir_head_tunnels.value_namespace = name_space
                    self.bidir_head_tunnels.value_namespace_prefix = name_space_prefix
                if(value_path == "bidir-head-tunnels-associated"):
                    self.bidir_head_tunnels_associated = value
                    self.bidir_head_tunnels_associated.value_namespace = name_space
                    self.bidir_head_tunnels_associated.value_namespace_prefix = name_space_prefix
                if(value_path == "bidir-head-tunnels-corouted"):
                    self.bidir_head_tunnels_corouted = value
                    self.bidir_head_tunnels_corouted.value_namespace = name_space
                    self.bidir_head_tunnels_corouted.value_namespace_prefix = name_space_prefix
                if(value_path == "bidir-head-tunnels-up"):
                    self.bidir_head_tunnels_up = value
                    self.bidir_head_tunnels_up.value_namespace = name_space
                    self.bidir_head_tunnels_up.value_namespace_prefix = name_space_prefix
                if(value_path == "bidir-mid-ls-ps-associated"):
                    self.bidir_mid_ls_ps_associated = value
                    self.bidir_mid_ls_ps_associated.value_namespace = name_space
                    self.bidir_mid_ls_ps_associated.value_namespace_prefix = name_space_prefix
                if(value_path == "bidir-mid-ls-ps-proceeding"):
                    self.bidir_mid_ls_ps_proceeding = value
                    self.bidir_mid_ls_ps_proceeding.value_namespace = name_space
                    self.bidir_mid_ls_ps_proceeding.value_namespace_prefix = name_space_prefix
                if(value_path == "bidir-mid-ls-ps-standby"):
                    self.bidir_mid_ls_ps_standby = value
                    self.bidir_mid_ls_ps_standby.value_namespace = name_space
                    self.bidir_mid_ls_ps_standby.value_namespace_prefix = name_space_prefix
                if(value_path == "bidir-mid-tunnels"):
                    self.bidir_mid_tunnels = value
                    self.bidir_mid_tunnels.value_namespace = name_space
                    self.bidir_mid_tunnels.value_namespace_prefix = name_space_prefix
                if(value_path == "bidir-mid-tunnels-up"):
                    self.bidir_mid_tunnels_up = value
                    self.bidir_mid_tunnels_up.value_namespace = name_space
                    self.bidir_mid_tunnels_up.value_namespace_prefix = name_space_prefix
                if(value_path == "bidir-tail-ls-ps"):
                    self.bidir_tail_ls_ps = value
                    self.bidir_tail_ls_ps.value_namespace = name_space
                    self.bidir_tail_ls_ps.value_namespace_prefix = name_space_prefix
                if(value_path == "bidir-tail-ls-ps-associated"):
                    self.bidir_tail_ls_ps_associated = value
                    self.bidir_tail_ls_ps_associated.value_namespace = name_space
                    self.bidir_tail_ls_ps_associated.value_namespace_prefix = name_space_prefix
                if(value_path == "bidir-tail-ls-ps-corouted"):
                    self.bidir_tail_ls_ps_corouted = value
                    self.bidir_tail_ls_ps_corouted.value_namespace = name_space
                    self.bidir_tail_ls_ps_corouted.value_namespace_prefix = name_space_prefix
                if(value_path == "bidir-tail-ls-ps-proceeding"):
                    self.bidir_tail_ls_ps_proceeding = value
                    self.bidir_tail_ls_ps_proceeding.value_namespace = name_space
                    self.bidir_tail_ls_ps_proceeding.value_namespace_prefix = name_space_prefix
                if(value_path == "bidir-tail-ls-ps-standby"):
                    self.bidir_tail_ls_ps_standby = value
                    self.bidir_tail_ls_ps_standby.value_namespace = name_space
                    self.bidir_tail_ls_ps_standby.value_namespace_prefix = name_space_prefix
                if(value_path == "bidir-tail-ls-ps-up"):
                    self.bidir_tail_ls_ps_up = value
                    self.bidir_tail_ls_ps_up.value_namespace = name_space
                    self.bidir_tail_ls_ps_up.value_namespace_prefix = name_space_prefix
                if(value_path == "bw-protected-p2mp-s2-ls"):
                    self.bw_protected_p2mp_s2_ls = value
                    self.bw_protected_p2mp_s2_ls.value_namespace = name_space
                    self.bw_protected_p2mp_s2_ls.value_namespace_prefix = name_space_prefix
                if(value_path == "bw-protected-p2p-s2-ls"):
                    self.bw_protected_p2p_s2_ls = value
                    self.bw_protected_p2p_s2_ls.value_namespace = name_space
                    self.bw_protected_p2p_s2_ls.value_namespace_prefix = name_space_prefix
                if(value_path == "bw-protected-p2p-tunnels"):
                    self.bw_protected_p2p_tunnels = value
                    self.bw_protected_p2p_tunnels.value_namespace = name_space
                    self.bw_protected_p2p_tunnels.value_namespace_prefix = name_space_prefix
                if(value_path == "bw-protected-tunnels"):
                    self.bw_protected_tunnels = value
                    self.bw_protected_tunnels.value_namespace = name_space
                    self.bw_protected_tunnels.value_namespace_prefix = name_space_prefix
                if(value_path == "deactivated-heads"):
                    self.deactivated_heads = value
                    self.deactivated_heads.value_namespace = name_space
                    self.deactivated_heads.value_namespace_prefix = name_space_prefix
                if(value_path == "dynamic-up-p2p-head-tunnels"):
                    self.dynamic_up_p2p_head_tunnels = value
                    self.dynamic_up_p2p_head_tunnels.value_namespace = name_space
                    self.dynamic_up_p2p_head_tunnels.value_namespace_prefix = name_space_prefix
                if(value_path == "frr-config-p2mp-head-tunnels"):
                    self.frr_config_p2mp_head_tunnels = value
                    self.frr_config_p2mp_head_tunnels.value_namespace = name_space
                    self.frr_config_p2mp_head_tunnels.value_namespace_prefix = name_space_prefix
                if(value_path == "frr-config-p2p-head-tunnels"):
                    self.frr_config_p2p_head_tunnels = value
                    self.frr_config_p2p_head_tunnels.value_namespace = name_space
                    self.frr_config_p2p_head_tunnels.value_namespace_prefix = name_space_prefix
                if(value_path == "frr-head-tunnels"):
                    self.frr_head_tunnels = value
                    self.frr_head_tunnels.value_namespace = name_space
                    self.frr_head_tunnels.value_namespace_prefix = name_space_prefix
                if(value_path == "frr-mid-point-tunnels"):
                    self.frr_mid_point_tunnels = value
                    self.frr_mid_point_tunnels.value_namespace = name_space
                    self.frr_mid_point_tunnels.value_namespace_prefix = name_space_prefix
                if(value_path == "frr-p2mp-head-s2-ls"):
                    self.frr_p2mp_head_s2_ls = value
                    self.frr_p2mp_head_s2_ls.value_namespace = name_space
                    self.frr_p2mp_head_s2_ls.value_namespace_prefix = name_space_prefix
                if(value_path == "frr-p2mp-mid-point-s2-ls"):
                    self.frr_p2mp_mid_point_s2_ls = value
                    self.frr_p2mp_mid_point_s2_ls.value_namespace = name_space
                    self.frr_p2mp_mid_point_s2_ls.value_namespace_prefix = name_space_prefix
                if(value_path == "frr-p2p-head-s2-ls"):
                    self.frr_p2p_head_s2_ls = value
                    self.frr_p2p_head_s2_ls.value_namespace = name_space
                    self.frr_p2p_head_s2_ls.value_namespace_prefix = name_space_prefix
                if(value_path == "frr-p2p-head-tunnels"):
                    self.frr_p2p_head_tunnels = value
                    self.frr_p2p_head_tunnels.value_namespace = name_space
                    self.frr_p2p_head_tunnels.value_namespace_prefix = name_space_prefix
                if(value_path == "frr-p2p-mid-point-s2-ls"):
                    self.frr_p2p_mid_point_s2_ls = value
                    self.frr_p2p_mid_point_s2_ls.value_namespace = name_space
                    self.frr_p2p_mid_point_s2_ls.value_namespace_prefix = name_space_prefix
                if(value_path == "frr-p2p-mid-point-tunnels"):
                    self.frr_p2p_mid_point_tunnels = value
                    self.frr_p2p_mid_point_tunnels.value_namespace = name_space
                    self.frr_p2p_mid_point_tunnels.value_namespace_prefix = name_space_prefix
                if(value_path == "frr-protected-interfaces"):
                    self.frr_protected_interfaces = value
                    self.frr_protected_interfaces.value_namespace = name_space
                    self.frr_protected_interfaces.value_namespace_prefix = name_space_prefix
                if(value_path == "is-forwarding-enabled"):
                    self.is_forwarding_enabled = value
                    self.is_forwarding_enabled.value_namespace = name_space
                    self.is_forwarding_enabled.value_namespace_prefix = name_space_prefix
                if(value_path == "is-periodic-reoptimization-on"):
                    self.is_periodic_reoptimization_on = value
                    self.is_periodic_reoptimization_on.value_namespace = name_space
                    self.is_periodic_reoptimization_on.value_namespace_prefix = name_space_prefix
                if(value_path == "is-promotion-on"):
                    self.is_promotion_on = value
                    self.is_promotion_on.value_namespace = name_space
                    self.is_promotion_on.value_namespace_prefix = name_space_prefix
                if(value_path == "is-rsvp-process-enabled"):
                    self.is_rsvp_process_enabled = value
                    self.is_rsvp_process_enabled.value_namespace = name_space
                    self.is_rsvp_process_enabled.value_namespace_prefix = name_space_prefix
                if(value_path == "link-and-node-diverse-paths"):
                    self.link_and_node_diverse_paths = value
                    self.link_and_node_diverse_paths.value_namespace = name_space
                    self.link_and_node_diverse_paths.value_namespace_prefix = name_space_prefix
                if(value_path == "link-diverse-paths"):
                    self.link_diverse_paths = value
                    self.link_diverse_paths.value_namespace = name_space
                    self.link_diverse_paths.value_namespace_prefix = name_space_prefix
                if(value_path == "link-protected-p2mp-s2-ls"):
                    self.link_protected_p2mp_s2_ls = value
                    self.link_protected_p2mp_s2_ls.value_namespace = name_space
                    self.link_protected_p2mp_s2_ls.value_namespace_prefix = name_space_prefix
                if(value_path == "link-protected-p2p-s2-ls"):
                    self.link_protected_p2p_s2_ls = value
                    self.link_protected_p2p_s2_ls.value_namespace = name_space
                    self.link_protected_p2p_s2_ls.value_namespace_prefix = name_space_prefix
                if(value_path == "link-protected-p2p-tunnels"):
                    self.link_protected_p2p_tunnels = value
                    self.link_protected_p2p_tunnels.value_namespace = name_space
                    self.link_protected_p2p_tunnels.value_namespace_prefix = name_space_prefix
                if(value_path == "link-protected-tunnels"):
                    self.link_protected_tunnels = value
                    self.link_protected_tunnels.value_namespace = name_space
                    self.link_protected_tunnels.value_namespace_prefix = name_space_prefix
                if(value_path == "next-check-time"):
                    self.next_check_time = value
                    self.next_check_time.value_namespace = name_space
                    self.next_check_time.value_namespace_prefix = name_space_prefix
                if(value_path == "next-promotion-timer"):
                    self.next_promotion_timer = value
                    self.next_promotion_timer.value_namespace = name_space
                    self.next_promotion_timer.value_namespace_prefix = name_space_prefix
                if(value_path == "next-reoptimization-timer"):
                    self.next_reoptimization_timer = value
                    self.next_reoptimization_timer.value_namespace = name_space
                    self.next_reoptimization_timer.value_namespace_prefix = name_space_prefix
                if(value_path == "next-verify-timer"):
                    self.next_verify_timer = value
                    self.next_verify_timer.value_namespace = name_space
                    self.next_verify_timer.value_namespace_prefix = name_space_prefix
                if(value_path == "node-diverse-paths"):
                    self.node_diverse_paths = value
                    self.node_diverse_paths.value_namespace = name_space
                    self.node_diverse_paths.value_namespace_prefix = name_space_prefix
                if(value_path == "node-protected-p2p-tunnels"):
                    self.node_protected_p2p_tunnels = value
                    self.node_protected_p2p_tunnels.value_namespace = name_space
                    self.node_protected_p2p_tunnels.value_namespace_prefix = name_space_prefix
                if(value_path == "node-protected-tunnels"):
                    self.node_protected_tunnels = value
                    self.node_protected_tunnels.value_namespace = name_space
                    self.node_protected_tunnels.value_namespace_prefix = name_space_prefix
                if(value_path == "p2mp-head-destinations"):
                    self.p2mp_head_destinations = value
                    self.p2mp_head_destinations.value_namespace = name_space
                    self.p2mp_head_destinations.value_namespace_prefix = name_space_prefix
                if(value_path == "p2mp-head-tunnels"):
                    self.p2mp_head_tunnels = value
                    self.p2mp_head_tunnels.value_namespace = name_space
                    self.p2mp_head_tunnels.value_namespace_prefix = name_space_prefix
                if(value_path == "p2mp-mid-point-s2-ls"):
                    self.p2mp_mid_point_s2_ls = value
                    self.p2mp_mid_point_s2_ls.value_namespace = name_space
                    self.p2mp_mid_point_s2_ls.value_namespace_prefix = name_space_prefix
                if(value_path == "p2mp-tail-s2-ls"):
                    self.p2mp_tail_s2_ls = value
                    self.p2mp_tail_s2_ls.value_namespace = name_space
                    self.p2mp_tail_s2_ls.value_namespace_prefix = name_space_prefix
                if(value_path == "p2p-head-destinations"):
                    self.p2p_head_destinations = value
                    self.p2p_head_destinations.value_namespace = name_space
                    self.p2p_head_destinations.value_namespace_prefix = name_space_prefix
                if(value_path == "p2p-head-destinations-up"):
                    self.p2p_head_destinations_up = value
                    self.p2p_head_destinations_up.value_namespace = name_space
                    self.p2p_head_destinations_up.value_namespace_prefix = name_space_prefix
                if(value_path == "p2p-head-tunnels"):
                    self.p2p_head_tunnels = value
                    self.p2p_head_tunnels.value_namespace = name_space
                    self.p2p_head_tunnels.value_namespace_prefix = name_space_prefix
                if(value_path == "p2p-mid-point-s2-ls"):
                    self.p2p_mid_point_s2_ls = value
                    self.p2p_mid_point_s2_ls.value_namespace = name_space
                    self.p2p_mid_point_s2_ls.value_namespace_prefix = name_space_prefix
                if(value_path == "p2p-tail-s2-ls"):
                    self.p2p_tail_s2_ls = value
                    self.p2p_tail_s2_ls.value_namespace = name_space
                    self.p2p_tail_s2_ls.value_namespace_prefix = name_space_prefix
                if(value_path == "p2p-tail-tunnels"):
                    self.p2p_tail_tunnels = value
                    self.p2p_tail_tunnels.value_namespace = name_space
                    self.p2p_tail_tunnels.value_namespace_prefix = name_space_prefix
                if(value_path == "path-protect-configured-tunnels"):
                    self.path_protect_configured_tunnels = value
                    self.path_protect_configured_tunnels.value_namespace = name_space
                    self.path_protect_configured_tunnels.value_namespace_prefix = name_space_prefix
                if(value_path == "path-protect-configured-tunnels-standby-up"):
                    self.path_protect_configured_tunnels_standby_up = value
                    self.path_protect_configured_tunnels_standby_up.value_namespace = name_space
                    self.path_protect_configured_tunnels_standby_up.value_namespace_prefix = name_space_prefix
                if(value_path == "path-protect-configured-tunnels-up"):
                    self.path_protect_configured_tunnels_up = value
                    self.path_protect_configured_tunnels_up.value_namespace = name_space
                    self.path_protect_configured_tunnels_up.value_namespace_prefix = name_space_prefix
                if(value_path == "pcalc-tie-breaker-type"):
                    self.pcalc_tie_breaker_type = value
                    self.pcalc_tie_breaker_type.value_namespace = name_space
                    self.pcalc_tie_breaker_type.value_namespace_prefix = name_space_prefix
                if(value_path == "pcalc-tiebreaker"):
                    self.pcalc_tiebreaker = value
                    self.pcalc_tiebreaker.value_namespace = name_space
                    self.pcalc_tiebreaker.value_namespace_prefix = name_space_prefix
                if(value_path == "proceeding-p2mp-head-s2-ls"):
                    self.proceeding_p2mp_head_s2_ls = value
                    self.proceeding_p2mp_head_s2_ls.value_namespace = name_space
                    self.proceeding_p2mp_head_s2_ls.value_namespace_prefix = name_space_prefix
                if(value_path == "proceeding-p2mp-mid-point-s2-ls"):
                    self.proceeding_p2mp_mid_point_s2_ls = value
                    self.proceeding_p2mp_mid_point_s2_ls.value_namespace = name_space
                    self.proceeding_p2mp_mid_point_s2_ls.value_namespace_prefix = name_space_prefix
                if(value_path == "proceeding-p2p-head-s2-ls"):
                    self.proceeding_p2p_head_s2_ls = value
                    self.proceeding_p2p_head_s2_ls.value_namespace = name_space
                    self.proceeding_p2p_head_s2_ls.value_namespace_prefix = name_space_prefix
                if(value_path == "proceeding-p2p-mid-point-s2-ls"):
                    self.proceeding_p2p_mid_point_s2_ls = value
                    self.proceeding_p2p_mid_point_s2_ls.value_namespace = name_space
                    self.proceeding_p2p_mid_point_s2_ls.value_namespace_prefix = name_space_prefix
                if(value_path == "promotion-period"):
                    self.promotion_period = value
                    self.promotion_period.value_namespace = name_space
                    self.promotion_period.value_namespace_prefix = name_space_prefix
                if(value_path == "protected-head-tunnels"):
                    self.protected_head_tunnels = value
                    self.protected_head_tunnels.value_namespace = name_space
                    self.protected_head_tunnels.value_namespace_prefix = name_space_prefix
                if(value_path == "protected-mid-point-tunnels"):
                    self.protected_mid_point_tunnels = value
                    self.protected_mid_point_tunnels.value_namespace = name_space
                    self.protected_mid_point_tunnels.value_namespace_prefix = name_space_prefix
                if(value_path == "protected-p2mp-head-s2-ls"):
                    self.protected_p2mp_head_s2_ls = value
                    self.protected_p2mp_head_s2_ls.value_namespace = name_space
                    self.protected_p2mp_head_s2_ls.value_namespace_prefix = name_space_prefix
                if(value_path == "protected-p2mp-mid-point-s2-ls"):
                    self.protected_p2mp_mid_point_s2_ls = value
                    self.protected_p2mp_mid_point_s2_ls.value_namespace = name_space
                    self.protected_p2mp_mid_point_s2_ls.value_namespace_prefix = name_space_prefix
                if(value_path == "protected-p2p-head-s2-ls"):
                    self.protected_p2p_head_s2_ls = value
                    self.protected_p2p_head_s2_ls.value_namespace = name_space
                    self.protected_p2p_head_s2_ls.value_namespace_prefix = name_space_prefix
                if(value_path == "protected-p2p-head-tunnels"):
                    self.protected_p2p_head_tunnels = value
                    self.protected_p2p_head_tunnels.value_namespace = name_space
                    self.protected_p2p_head_tunnels.value_namespace_prefix = name_space_prefix
                if(value_path == "protected-p2p-mid-point-s2-ls"):
                    self.protected_p2p_mid_point_s2_ls = value
                    self.protected_p2p_mid_point_s2_ls.value_namespace = name_space
                    self.protected_p2p_mid_point_s2_ls.value_namespace_prefix = name_space_prefix
                if(value_path == "protected-p2p-mid-point-tunnels"):
                    self.protected_p2p_mid_point_tunnels = value
                    self.protected_p2p_mid_point_tunnels.value_namespace = name_space
                    self.protected_p2p_mid_point_tunnels.value_namespace_prefix = name_space_prefix
                if(value_path == "recovered-heads"):
                    self.recovered_heads = value
                    self.recovered_heads.value_namespace = name_space
                    self.recovered_heads.value_namespace_prefix = name_space_prefix
                if(value_path == "recovering-p2p-head-s2-ls"):
                    self.recovering_p2p_head_s2_ls = value
                    self.recovering_p2p_head_s2_ls.value_namespace = name_space
                    self.recovering_p2p_head_s2_ls.value_namespace_prefix = name_space_prefix
                if(value_path == "reoptimization-period"):
                    self.reoptimization_period = value
                    self.reoptimization_period.value_namespace = name_space
                    self.reoptimization_period.value_namespace_prefix = name_space_prefix
                if(value_path == "rerouted-head-tunnels"):
                    self.rerouted_head_tunnels = value
                    self.rerouted_head_tunnels.value_namespace = name_space
                    self.rerouted_head_tunnels.value_namespace_prefix = name_space_prefix
                if(value_path == "rerouted-interfaces"):
                    self.rerouted_interfaces = value
                    self.rerouted_interfaces.value_namespace = name_space
                    self.rerouted_interfaces.value_namespace_prefix = name_space_prefix
                if(value_path == "rerouted-mid-point-tunnels"):
                    self.rerouted_mid_point_tunnels = value
                    self.rerouted_mid_point_tunnels.value_namespace = name_space
                    self.rerouted_mid_point_tunnels.value_namespace_prefix = name_space_prefix
                if(value_path == "rerouted-p2mp-head-s2-ls"):
                    self.rerouted_p2mp_head_s2_ls = value
                    self.rerouted_p2mp_head_s2_ls.value_namespace = name_space
                    self.rerouted_p2mp_head_s2_ls.value_namespace_prefix = name_space_prefix
                if(value_path == "rerouted-p2mp-mid-point-s2-ls"):
                    self.rerouted_p2mp_mid_point_s2_ls = value
                    self.rerouted_p2mp_mid_point_s2_ls.value_namespace = name_space
                    self.rerouted_p2mp_mid_point_s2_ls.value_namespace_prefix = name_space_prefix
                if(value_path == "rerouted-p2p-head-s2-ls"):
                    self.rerouted_p2p_head_s2_ls = value
                    self.rerouted_p2p_head_s2_ls.value_namespace = name_space
                    self.rerouted_p2p_head_s2_ls.value_namespace_prefix = name_space_prefix
                if(value_path == "rerouted-p2p-head-tunnels"):
                    self.rerouted_p2p_head_tunnels = value
                    self.rerouted_p2p_head_tunnels.value_namespace = name_space
                    self.rerouted_p2p_head_tunnels.value_namespace_prefix = name_space_prefix
                if(value_path == "rerouted-p2p-mid-point-s2-ls"):
                    self.rerouted_p2p_mid_point_s2_ls = value
                    self.rerouted_p2p_mid_point_s2_ls.value_namespace = name_space
                    self.rerouted_p2p_mid_point_s2_ls.value_namespace_prefix = name_space_prefix
                if(value_path == "rerouted-p2p-mid-point-tunnels"):
                    self.rerouted_p2p_mid_point_tunnels = value
                    self.rerouted_p2p_mid_point_tunnels.value_namespace = name_space
                    self.rerouted_p2p_mid_point_tunnels.value_namespace_prefix = name_space_prefix
                if(value_path == "te-process-status"):
                    self.te_process_status = value
                    self.te_process_status.value_namespace = name_space
                    self.te_process_status.value_namespace_prefix = name_space_prefix
                if(value_path == "tiebreaker-qualifier"):
                    self.tiebreaker_qualifier = value
                    self.tiebreaker_qualifier.value_namespace = name_space
                    self.tiebreaker_qualifier.value_namespace_prefix = name_space_prefix
                if(value_path == "tunnel-check-period"):
                    self.tunnel_check_period = value
                    self.tunnel_check_period.value_namespace = name_space
                    self.tunnel_check_period.value_namespace_prefix = name_space_prefix
                if(value_path == "tunnel-verify-period"):
                    self.tunnel_verify_period = value
                    self.tunnel_verify_period.value_namespace = name_space
                    self.tunnel_verify_period.value_namespace_prefix = name_space_prefix
                if(value_path == "up-p2mp-head-destinations"):
                    self.up_p2mp_head_destinations = value
                    self.up_p2mp_head_destinations.value_namespace = name_space
                    self.up_p2mp_head_destinations.value_namespace_prefix = name_space_prefix
                if(value_path == "up-p2mp-head-s2-ls"):
                    self.up_p2mp_head_s2_ls = value
                    self.up_p2mp_head_s2_ls.value_namespace = name_space
                    self.up_p2mp_head_s2_ls.value_namespace_prefix = name_space_prefix
                if(value_path == "up-p2mp-head-tunnels"):
                    self.up_p2mp_head_tunnels = value
                    self.up_p2mp_head_tunnels.value_namespace = name_space
                    self.up_p2mp_head_tunnels.value_namespace_prefix = name_space_prefix
                if(value_path == "up-p2mp-mid-point-s2-ls"):
                    self.up_p2mp_mid_point_s2_ls = value
                    self.up_p2mp_mid_point_s2_ls.value_namespace = name_space
                    self.up_p2mp_mid_point_s2_ls.value_namespace_prefix = name_space_prefix
                if(value_path == "up-p2mp-tail-s2-ls"):
                    self.up_p2mp_tail_s2_ls = value
                    self.up_p2mp_tail_s2_ls.value_namespace = name_space
                    self.up_p2mp_tail_s2_ls.value_namespace_prefix = name_space_prefix
                if(value_path == "up-p2p-head-s2-ls"):
                    self.up_p2p_head_s2_ls = value
                    self.up_p2p_head_s2_ls.value_namespace = name_space
                    self.up_p2p_head_s2_ls.value_namespace_prefix = name_space_prefix
                if(value_path == "up-p2p-head-tunnels"):
                    self.up_p2p_head_tunnels = value
                    self.up_p2p_head_tunnels.value_namespace = name_space
                    self.up_p2p_head_tunnels.value_namespace_prefix = name_space_prefix
                if(value_path == "up-p2p-mid-point-s2-ls"):
                    self.up_p2p_mid_point_s2_ls = value
                    self.up_p2p_mid_point_s2_ls.value_namespace = name_space
                    self.up_p2p_mid_point_s2_ls.value_namespace_prefix = name_space_prefix
                if(value_path == "up-p2p-tail-s2-ls"):
                    self.up_p2p_tail_s2_ls = value
                    self.up_p2p_tail_s2_ls.value_namespace = name_space
                    self.up_p2p_tail_s2_ls.value_namespace_prefix = name_space_prefix
                if(value_path == "user-defined-paths"):
                    self.user_defined_paths = value
                    self.user_defined_paths.value_namespace = name_space
                    self.user_defined_paths.value_namespace_prefix = name_space_prefix


        class TunnelPathProtections(Entity):
            """
            Path protection
            
            .. attribute:: tunnel_path_protection
            
            	Path Protection
            	**type**\: list of    :py:class:`TunnelPathProtection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTeStandby.Tunnels.TunnelPathProtections, self).__init__()

                self.yang_name = "tunnel-path-protections"
                self.yang_parent_name = "tunnels"

                self.tunnel_path_protection = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTeStandby.Tunnels.TunnelPathProtections, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTeStandby.Tunnels.TunnelPathProtections, self).__setattr__(name, value)


            class TunnelPathProtection(Entity):
                """
                Path Protection
                
                .. attribute:: ctype
                
                	Ctype
                	**type**\:   :py:class:`Ctype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.Ctype>`
                
                .. attribute:: current_lsp
                
                	 Current LSP info
                	**type**\:   :py:class:`CurrentLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp>`
                
                .. attribute:: destination_address
                
                	Destination
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: extended_tunnel_id
                
                	Extended Tunnel ID
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: is_tunnel_up
                
                	Tunnel UP
                	**type**\:  bool
                
                .. attribute:: path_protection
                
                	Path Protect Info
                	**type**\:   :py:class:`PathProtection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.PathProtection>`
                
                .. attribute:: source_address
                
                	Source
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: standby_lsp
                
                	 Standby LSP info
                	**type**\:   :py:class:`StandbyLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp>`
                
                .. attribute:: tunnel_id
                
                	Tunnel ID
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: tunnel_name
                
                	Tunnel Name
                	**type**\:  str
                
                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection, self).__init__()

                    self.yang_name = "tunnel-path-protection"
                    self.yang_parent_name = "tunnel-path-protections"

                    self.ctype = YLeaf(YType.enumeration, "ctype")

                    self.destination_address = YLeaf(YType.str, "destination-address")

                    self.extended_tunnel_id = YLeaf(YType.str, "extended-tunnel-id")

                    self.is_tunnel_up = YLeaf(YType.boolean, "is-tunnel-up")

                    self.source_address = YLeaf(YType.str, "source-address")

                    self.tunnel_id = YLeaf(YType.int32, "tunnel-id")

                    self.tunnel_name = YLeaf(YType.str, "tunnel-name")

                    self.current_lsp = MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp()
                    self.current_lsp.parent = self
                    self._children_name_map["current_lsp"] = "current-lsp"
                    self._children_yang_names.add("current-lsp")

                    self.path_protection = MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.PathProtection()
                    self.path_protection.parent = self
                    self._children_name_map["path_protection"] = "path-protection"
                    self._children_yang_names.add("path-protection")

                    self.standby_lsp = MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp()
                    self.standby_lsp.parent = self
                    self._children_name_map["standby_lsp"] = "standby-lsp"
                    self._children_yang_names.add("standby-lsp")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("ctype",
                                    "destination_address",
                                    "extended_tunnel_id",
                                    "is_tunnel_up",
                                    "source_address",
                                    "tunnel_id",
                                    "tunnel_name") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection, self).__setattr__(name, value)


                class PathProtection(Entity):
                    """
                    Path Protect Info
                    
                    .. attribute:: diversity_type
                    
                    	Standby path diversity type
                    	**type**\:   :py:class:`TePpDiversity <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TePpDiversity>`
                    
                    .. attribute:: is_path_protect_configured
                    
                    	Is Path Protection Configured
                    	**type**\:  bool
                    
                    .. attribute:: is_path_protect_switch_over_underway
                    
                    	Is Switchover Underway
                    	**type**\:  bool
                    
                    .. attribute:: path_protection_protected_by_id
                    
                    	The path option ID (level/index) of the configured explicit protecting path
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: reoptimization_time_remaining
                    
                    	Remaining time until path protection reoptimization (seconds)
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: standby_reoptimized_number
                    
                    	Number of times the standby LSP was reoptimized
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: switchover
                    
                    	Path Protected Switchover Information
                    	**type**\:   :py:class:`Switchover <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.PathProtection.Switchover>`
                    
                    .. attribute:: switchover_ready
                    
                    	Total times, Standby LSP ready for use
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: switchover_reason
                    
                    	Reason for last switchover
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: switchover_total
                    
                    	Number of times switchover occurred
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: time_of_switchover_sec
                    
                    	The date when the switchover was completed. This date is the number of seconds since Jan 1st 1970
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    	**units**\: second
                    
                    .. attribute:: valid_path_protection_path_option_exists
                    
                    	Flag to indicate whether tunnel has a path\-option which is valid for path\-protection
                    	**type**\:  bool
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.PathProtection, self).__init__()

                        self.yang_name = "path-protection"
                        self.yang_parent_name = "tunnel-path-protection"

                        self.diversity_type = YLeaf(YType.enumeration, "diversity-type")

                        self.is_path_protect_configured = YLeaf(YType.boolean, "is-path-protect-configured")

                        self.is_path_protect_switch_over_underway = YLeaf(YType.boolean, "is-path-protect-switch-over-underway")

                        self.path_protection_protected_by_id = YLeaf(YType.uint32, "path-protection-protected-by-id")

                        self.reoptimization_time_remaining = YLeaf(YType.uint32, "reoptimization-time-remaining")

                        self.standby_reoptimized_number = YLeaf(YType.uint16, "standby-reoptimized-number")

                        self.switchover_ready = YLeaf(YType.uint16, "switchover-ready")

                        self.switchover_reason = YLeaf(YType.uint16, "switchover-reason")

                        self.switchover_total = YLeaf(YType.uint16, "switchover-total")

                        self.time_of_switchover_sec = YLeaf(YType.uint32, "time-of-switchover-sec")

                        self.valid_path_protection_path_option_exists = YLeaf(YType.boolean, "valid-path-protection-path-option-exists")

                        self.switchover = MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.PathProtection.Switchover()
                        self.switchover.parent = self
                        self._children_name_map["switchover"] = "switchover"
                        self._children_yang_names.add("switchover")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("diversity_type",
                                        "is_path_protect_configured",
                                        "is_path_protect_switch_over_underway",
                                        "path_protection_protected_by_id",
                                        "reoptimization_time_remaining",
                                        "standby_reoptimized_number",
                                        "switchover_ready",
                                        "switchover_reason",
                                        "switchover_total",
                                        "time_of_switchover_sec",
                                        "valid_path_protection_path_option_exists") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.PathProtection, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.PathProtection, self).__setattr__(name, value)


                    class Switchover(Entity):
                        """
                        Path Protected Switchover Information
                        
                        .. attribute:: date_of_error_detection
                        
                        	The date when the error that caused the switchover was detected. This date is the number of seconds since Jan 1st 1970
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        .. attribute:: date_of_error_detection_millisec
                        
                        	The milliseconds offset of the date when the error that caused  the switchover was detected
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: millisecond
                        
                        .. attribute:: from_lsp_id
                        
                        	The LSP ID from which the traffic was switched over
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: path_protection_switchover_event_index
                        
                        	The index number of the path protection switch over event
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: path_protection_switchover_reason
                        
                        	The reason that caused the path protection switchover
                        	**type**\:   :py:class:`TeP2MpS2LDeletionSubcause <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeP2MpS2LDeletionSubcause>`
                        
                        .. attribute:: path_protection_tunnel_id
                        
                        	The ID of the tunnel that experienced switchover
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: switchover_duration_millisec
                        
                        	The time in milliseconds between the detection of the error and switching the traffic
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: millisecond
                        
                        .. attribute:: to_lsp_id
                        
                        	The LSP ID to which the traffic was switched over
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.PathProtection.Switchover, self).__init__()

                            self.yang_name = "switchover"
                            self.yang_parent_name = "path-protection"

                            self.date_of_error_detection = YLeaf(YType.uint32, "date-of-error-detection")

                            self.date_of_error_detection_millisec = YLeaf(YType.uint32, "date-of-error-detection-millisec")

                            self.from_lsp_id = YLeaf(YType.uint16, "from-lsp-id")

                            self.path_protection_switchover_event_index = YLeaf(YType.uint32, "path-protection-switchover-event-index")

                            self.path_protection_switchover_reason = YLeaf(YType.enumeration, "path-protection-switchover-reason")

                            self.path_protection_tunnel_id = YLeaf(YType.uint16, "path-protection-tunnel-id")

                            self.switchover_duration_millisec = YLeaf(YType.uint32, "switchover-duration-millisec")

                            self.to_lsp_id = YLeaf(YType.uint16, "to-lsp-id")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("date_of_error_detection",
                                            "date_of_error_detection_millisec",
                                            "from_lsp_id",
                                            "path_protection_switchover_event_index",
                                            "path_protection_switchover_reason",
                                            "path_protection_tunnel_id",
                                            "switchover_duration_millisec",
                                            "to_lsp_id") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.PathProtection.Switchover, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.PathProtection.Switchover, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.date_of_error_detection.is_set or
                                self.date_of_error_detection_millisec.is_set or
                                self.from_lsp_id.is_set or
                                self.path_protection_switchover_event_index.is_set or
                                self.path_protection_switchover_reason.is_set or
                                self.path_protection_tunnel_id.is_set or
                                self.switchover_duration_millisec.is_set or
                                self.to_lsp_id.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.date_of_error_detection.yfilter != YFilter.not_set or
                                self.date_of_error_detection_millisec.yfilter != YFilter.not_set or
                                self.from_lsp_id.yfilter != YFilter.not_set or
                                self.path_protection_switchover_event_index.yfilter != YFilter.not_set or
                                self.path_protection_switchover_reason.yfilter != YFilter.not_set or
                                self.path_protection_tunnel_id.yfilter != YFilter.not_set or
                                self.switchover_duration_millisec.yfilter != YFilter.not_set or
                                self.to_lsp_id.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "switchover" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-path-protections/tunnel-path-protection/path-protection/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.date_of_error_detection.is_set or self.date_of_error_detection.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.date_of_error_detection.get_name_leafdata())
                            if (self.date_of_error_detection_millisec.is_set or self.date_of_error_detection_millisec.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.date_of_error_detection_millisec.get_name_leafdata())
                            if (self.from_lsp_id.is_set or self.from_lsp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.from_lsp_id.get_name_leafdata())
                            if (self.path_protection_switchover_event_index.is_set or self.path_protection_switchover_event_index.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_protection_switchover_event_index.get_name_leafdata())
                            if (self.path_protection_switchover_reason.is_set or self.path_protection_switchover_reason.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_protection_switchover_reason.get_name_leafdata())
                            if (self.path_protection_tunnel_id.is_set or self.path_protection_tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.path_protection_tunnel_id.get_name_leafdata())
                            if (self.switchover_duration_millisec.is_set or self.switchover_duration_millisec.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.switchover_duration_millisec.get_name_leafdata())
                            if (self.to_lsp_id.is_set or self.to_lsp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.to_lsp_id.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "date-of-error-detection" or name == "date-of-error-detection-millisec" or name == "from-lsp-id" or name == "path-protection-switchover-event-index" or name == "path-protection-switchover-reason" or name == "path-protection-tunnel-id" or name == "switchover-duration-millisec" or name == "to-lsp-id"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "date-of-error-detection"):
                                self.date_of_error_detection = value
                                self.date_of_error_detection.value_namespace = name_space
                                self.date_of_error_detection.value_namespace_prefix = name_space_prefix
                            if(value_path == "date-of-error-detection-millisec"):
                                self.date_of_error_detection_millisec = value
                                self.date_of_error_detection_millisec.value_namespace = name_space
                                self.date_of_error_detection_millisec.value_namespace_prefix = name_space_prefix
                            if(value_path == "from-lsp-id"):
                                self.from_lsp_id = value
                                self.from_lsp_id.value_namespace = name_space
                                self.from_lsp_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-protection-switchover-event-index"):
                                self.path_protection_switchover_event_index = value
                                self.path_protection_switchover_event_index.value_namespace = name_space
                                self.path_protection_switchover_event_index.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-protection-switchover-reason"):
                                self.path_protection_switchover_reason = value
                                self.path_protection_switchover_reason.value_namespace = name_space
                                self.path_protection_switchover_reason.value_namespace_prefix = name_space_prefix
                            if(value_path == "path-protection-tunnel-id"):
                                self.path_protection_tunnel_id = value
                                self.path_protection_tunnel_id.value_namespace = name_space
                                self.path_protection_tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "switchover-duration-millisec"):
                                self.switchover_duration_millisec = value
                                self.switchover_duration_millisec.value_namespace = name_space
                                self.switchover_duration_millisec.value_namespace_prefix = name_space_prefix
                            if(value_path == "to-lsp-id"):
                                self.to_lsp_id = value
                                self.to_lsp_id.value_namespace = name_space
                                self.to_lsp_id.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.diversity_type.is_set or
                            self.is_path_protect_configured.is_set or
                            self.is_path_protect_switch_over_underway.is_set or
                            self.path_protection_protected_by_id.is_set or
                            self.reoptimization_time_remaining.is_set or
                            self.standby_reoptimized_number.is_set or
                            self.switchover_ready.is_set or
                            self.switchover_reason.is_set or
                            self.switchover_total.is_set or
                            self.time_of_switchover_sec.is_set or
                            self.valid_path_protection_path_option_exists.is_set or
                            (self.switchover is not None and self.switchover.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.diversity_type.yfilter != YFilter.not_set or
                            self.is_path_protect_configured.yfilter != YFilter.not_set or
                            self.is_path_protect_switch_over_underway.yfilter != YFilter.not_set or
                            self.path_protection_protected_by_id.yfilter != YFilter.not_set or
                            self.reoptimization_time_remaining.yfilter != YFilter.not_set or
                            self.standby_reoptimized_number.yfilter != YFilter.not_set or
                            self.switchover_ready.yfilter != YFilter.not_set or
                            self.switchover_reason.yfilter != YFilter.not_set or
                            self.switchover_total.yfilter != YFilter.not_set or
                            self.time_of_switchover_sec.yfilter != YFilter.not_set or
                            self.valid_path_protection_path_option_exists.yfilter != YFilter.not_set or
                            (self.switchover is not None and self.switchover.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "path-protection" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-path-protections/tunnel-path-protection/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.diversity_type.is_set or self.diversity_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.diversity_type.get_name_leafdata())
                        if (self.is_path_protect_configured.is_set or self.is_path_protect_configured.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_path_protect_configured.get_name_leafdata())
                        if (self.is_path_protect_switch_over_underway.is_set or self.is_path_protect_switch_over_underway.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_path_protect_switch_over_underway.get_name_leafdata())
                        if (self.path_protection_protected_by_id.is_set or self.path_protection_protected_by_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.path_protection_protected_by_id.get_name_leafdata())
                        if (self.reoptimization_time_remaining.is_set or self.reoptimization_time_remaining.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.reoptimization_time_remaining.get_name_leafdata())
                        if (self.standby_reoptimized_number.is_set or self.standby_reoptimized_number.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.standby_reoptimized_number.get_name_leafdata())
                        if (self.switchover_ready.is_set or self.switchover_ready.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.switchover_ready.get_name_leafdata())
                        if (self.switchover_reason.is_set or self.switchover_reason.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.switchover_reason.get_name_leafdata())
                        if (self.switchover_total.is_set or self.switchover_total.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.switchover_total.get_name_leafdata())
                        if (self.time_of_switchover_sec.is_set or self.time_of_switchover_sec.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.time_of_switchover_sec.get_name_leafdata())
                        if (self.valid_path_protection_path_option_exists.is_set or self.valid_path_protection_path_option_exists.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.valid_path_protection_path_option_exists.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "switchover"):
                            if (self.switchover is None):
                                self.switchover = MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.PathProtection.Switchover()
                                self.switchover.parent = self
                                self._children_name_map["switchover"] = "switchover"
                            return self.switchover

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "switchover" or name == "diversity-type" or name == "is-path-protect-configured" or name == "is-path-protect-switch-over-underway" or name == "path-protection-protected-by-id" or name == "reoptimization-time-remaining" or name == "standby-reoptimized-number" or name == "switchover-ready" or name == "switchover-reason" or name == "switchover-total" or name == "time-of-switchover-sec" or name == "valid-path-protection-path-option-exists"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "diversity-type"):
                            self.diversity_type = value
                            self.diversity_type.value_namespace = name_space
                            self.diversity_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-path-protect-configured"):
                            self.is_path_protect_configured = value
                            self.is_path_protect_configured.value_namespace = name_space
                            self.is_path_protect_configured.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-path-protect-switch-over-underway"):
                            self.is_path_protect_switch_over_underway = value
                            self.is_path_protect_switch_over_underway.value_namespace = name_space
                            self.is_path_protect_switch_over_underway.value_namespace_prefix = name_space_prefix
                        if(value_path == "path-protection-protected-by-id"):
                            self.path_protection_protected_by_id = value
                            self.path_protection_protected_by_id.value_namespace = name_space
                            self.path_protection_protected_by_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "reoptimization-time-remaining"):
                            self.reoptimization_time_remaining = value
                            self.reoptimization_time_remaining.value_namespace = name_space
                            self.reoptimization_time_remaining.value_namespace_prefix = name_space_prefix
                        if(value_path == "standby-reoptimized-number"):
                            self.standby_reoptimized_number = value
                            self.standby_reoptimized_number.value_namespace = name_space
                            self.standby_reoptimized_number.value_namespace_prefix = name_space_prefix
                        if(value_path == "switchover-ready"):
                            self.switchover_ready = value
                            self.switchover_ready.value_namespace = name_space
                            self.switchover_ready.value_namespace_prefix = name_space_prefix
                        if(value_path == "switchover-reason"):
                            self.switchover_reason = value
                            self.switchover_reason.value_namespace = name_space
                            self.switchover_reason.value_namespace_prefix = name_space_prefix
                        if(value_path == "switchover-total"):
                            self.switchover_total = value
                            self.switchover_total.value_namespace = name_space
                            self.switchover_total.value_namespace_prefix = name_space_prefix
                        if(value_path == "time-of-switchover-sec"):
                            self.time_of_switchover_sec = value
                            self.time_of_switchover_sec.value_namespace = name_space
                            self.time_of_switchover_sec.value_namespace_prefix = name_space_prefix
                        if(value_path == "valid-path-protection-path-option-exists"):
                            self.valid_path_protection_path_option_exists = value
                            self.valid_path_protection_path_option_exists.value_namespace = name_space
                            self.valid_path_protection_path_option_exists.value_namespace_prefix = name_space_prefix


                class CurrentLsp(Entity):
                    """
                     Current LSP info
                    
                    .. attribute:: lsp_hop
                    
                    	Path used by LSP
                    	**type**\: list of    :py:class:`LspHop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.LspHop>`
                    
                    .. attribute:: lsp_local_label
                    
                    	Local label 
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: lsp_output_interface
                    
                    	Output interface of LSP
                    	**type**\:  str
                    
                    .. attribute:: lsp_output_label
                    
                    	Output label of the LSP
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: lsp_state
                    
                    	LSP State
                    	**type**\:   :py:class:`MplsTeTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelState>`
                    
                    .. attribute:: lsp_uptime
                    
                    	LSP Uptime
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: path_protection_lsp_id
                    
                    	LSP ID 
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: srlsp_outgoing_info
                    
                    	Segment\-routing iutgoing info of LSP
                    	**type**\: list of    :py:class:`SrlspOutgoingInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.SrlspOutgoingInfo>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp, self).__init__()

                        self.yang_name = "current-lsp"
                        self.yang_parent_name = "tunnel-path-protection"

                        self.lsp_local_label = YLeaf(YType.uint32, "lsp-local-label")

                        self.lsp_output_interface = YLeaf(YType.str, "lsp-output-interface")

                        self.lsp_output_label = YLeaf(YType.uint32, "lsp-output-label")

                        self.lsp_state = YLeaf(YType.enumeration, "lsp-state")

                        self.lsp_uptime = YLeaf(YType.uint32, "lsp-uptime")

                        self.path_protection_lsp_id = YLeaf(YType.uint32, "path-protection-lsp-id")

                        self.lsp_hop = YList(self)
                        self.srlsp_outgoing_info = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("lsp_local_label",
                                        "lsp_output_interface",
                                        "lsp_output_label",
                                        "lsp_state",
                                        "lsp_uptime",
                                        "path_protection_lsp_id") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp, self).__setattr__(name, value)


                    class SrlspOutgoingInfo(Entity):
                        """
                        Segment\-routing iutgoing info of LSP
                        
                        .. attribute:: lsp_output_interface
                        
                        	Output interface of LSP
                        	**type**\:  str
                        
                        .. attribute:: lsp_output_label
                        
                        	Output label of the LSP
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.SrlspOutgoingInfo, self).__init__()

                            self.yang_name = "srlsp-outgoing-info"
                            self.yang_parent_name = "current-lsp"

                            self.lsp_output_interface = YLeaf(YType.str, "lsp-output-interface")

                            self.lsp_output_label = YLeaf(YType.uint32, "lsp-output-label")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("lsp_output_interface",
                                            "lsp_output_label") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.SrlspOutgoingInfo, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.SrlspOutgoingInfo, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.lsp_output_interface.is_set or
                                self.lsp_output_label.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.lsp_output_interface.yfilter != YFilter.not_set or
                                self.lsp_output_label.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "srlsp-outgoing-info" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-path-protections/tunnel-path-protection/current-lsp/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.lsp_output_interface.is_set or self.lsp_output_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsp_output_interface.get_name_leafdata())
                            if (self.lsp_output_label.is_set or self.lsp_output_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsp_output_label.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "lsp-output-interface" or name == "lsp-output-label"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "lsp-output-interface"):
                                self.lsp_output_interface = value
                                self.lsp_output_interface.value_namespace = name_space
                                self.lsp_output_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsp-output-label"):
                                self.lsp_output_label = value
                                self.lsp_output_label.value_namespace = name_space
                                self.lsp_output_label.value_namespace_prefix = name_space_prefix


                    class LspHop(Entity):
                        """
                        Path used by LSP
                        
                        .. attribute:: ero_type
                        
                        	EROType
                        	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                        
                        .. attribute:: ipv4ero_sub_object
                        
                        	IPV4 ERO Sub Object
                        	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.LspHop.Ipv4EroSubObject>`
                        
                        .. attribute:: unnumbered_ero_sub_object
                        
                        	Unnumbered ERO Sub Object
                        	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.LspHop.UnnumberedEroSubObject>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.LspHop, self).__init__()

                            self.yang_name = "lsp-hop"
                            self.yang_parent_name = "current-lsp"

                            self.ero_type = YLeaf(YType.enumeration, "ero-type")

                            self.ipv4ero_sub_object = MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.LspHop.Ipv4EroSubObject()
                            self.ipv4ero_sub_object.parent = self
                            self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                            self._children_yang_names.add("ipv4ero-sub-object")

                            self.unnumbered_ero_sub_object = MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.LspHop.UnnumberedEroSubObject()
                            self.unnumbered_ero_sub_object.parent = self
                            self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                            self._children_yang_names.add("unnumbered-ero-sub-object")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("ero_type") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.LspHop, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.LspHop, self).__setattr__(name, value)


                        class Ipv4EroSubObject(Entity):
                            """
                            IPV4 ERO Sub Object
                            
                            .. attribute:: ero_address
                            
                            	The ERO IPV4 Address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: is_strict_route
                            
                            	ERO Entry Is Strict
                            	**type**\:  bool
                            
                            .. attribute:: prefix_length
                            
                            	ERO Prefix Length
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.LspHop.Ipv4EroSubObject, self).__init__()

                                self.yang_name = "ipv4ero-sub-object"
                                self.yang_parent_name = "lsp-hop"

                                self.ero_address = YLeaf(YType.str, "ero-address")

                                self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_address",
                                                "is_strict_route",
                                                "prefix_length") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.LspHop.Ipv4EroSubObject, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.LspHop.Ipv4EroSubObject, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.ero_address.is_set or
                                    self.is_strict_route.is_set or
                                    self.prefix_length.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_address.yfilter != YFilter.not_set or
                                    self.is_strict_route.yfilter != YFilter.not_set or
                                    self.prefix_length.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ipv4ero-sub-object" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-path-protections/tunnel-path-protection/current-lsp/lsp-hop/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_address.get_name_leafdata())
                                if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-address"):
                                    self.ero_address = value
                                    self.ero_address.value_namespace = name_space
                                    self.ero_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-strict-route"):
                                    self.is_strict_route = value
                                    self.is_strict_route.value_namespace = name_space
                                    self.is_strict_route.value_namespace_prefix = name_space_prefix
                                if(value_path == "prefix-length"):
                                    self.prefix_length = value
                                    self.prefix_length.value_namespace = name_space
                                    self.prefix_length.value_namespace_prefix = name_space_prefix


                        class UnnumberedEroSubObject(Entity):
                            """
                            Unnumbered ERO Sub Object
                            
                            .. attribute:: ero_interface_id
                            
                            	The Interface ID in ERO
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: ero_router_id
                            
                            	The Router ID in ERO
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: is_strict_route
                            
                            	ERO Entry Is Strict
                            	**type**\:  bool
                            
                            .. attribute:: status
                            
                            	Status of ERO
                            	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.LspHop.UnnumberedEroSubObject, self).__init__()

                                self.yang_name = "unnumbered-ero-sub-object"
                                self.yang_parent_name = "lsp-hop"

                                self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                self.status = YLeaf(YType.enumeration, "status")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_interface_id",
                                                "ero_router_id",
                                                "is_strict_route",
                                                "status") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.LspHop.UnnumberedEroSubObject, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.LspHop.UnnumberedEroSubObject, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.ero_interface_id.is_set or
                                    self.ero_router_id.is_set or
                                    self.is_strict_route.is_set or
                                    self.status.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_interface_id.yfilter != YFilter.not_set or
                                    self.ero_router_id.yfilter != YFilter.not_set or
                                    self.is_strict_route.yfilter != YFilter.not_set or
                                    self.status.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-path-protections/tunnel-path-protection/current-lsp/lsp-hop/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.status.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-interface-id"):
                                    self.ero_interface_id = value
                                    self.ero_interface_id.value_namespace = name_space
                                    self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "ero-router-id"):
                                    self.ero_router_id = value
                                    self.ero_router_id.value_namespace = name_space
                                    self.ero_router_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-strict-route"):
                                    self.is_strict_route = value
                                    self.is_strict_route.value_namespace = name_space
                                    self.is_strict_route.value_namespace_prefix = name_space_prefix
                                if(value_path == "status"):
                                    self.status = value
                                    self.status.value_namespace = name_space
                                    self.status.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.ero_type.is_set or
                                (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.ero_type.yfilter != YFilter.not_set or
                                (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "lsp-hop" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-path-protections/tunnel-path-protection/current-lsp/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ero_type.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "ipv4ero-sub-object"):
                                if (self.ipv4ero_sub_object is None):
                                    self.ipv4ero_sub_object = MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.LspHop.Ipv4EroSubObject()
                                    self.ipv4ero_sub_object.parent = self
                                    self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                return self.ipv4ero_sub_object

                            if (child_yang_name == "unnumbered-ero-sub-object"):
                                if (self.unnumbered_ero_sub_object is None):
                                    self.unnumbered_ero_sub_object = MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.LspHop.UnnumberedEroSubObject()
                                    self.unnumbered_ero_sub_object.parent = self
                                    self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                return self.unnumbered_ero_sub_object

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "ero-type"):
                                self.ero_type = value
                                self.ero_type.value_namespace = name_space
                                self.ero_type.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.lsp_hop:
                            if (c.has_data()):
                                return True
                        for c in self.srlsp_outgoing_info:
                            if (c.has_data()):
                                return True
                        return (
                            self.lsp_local_label.is_set or
                            self.lsp_output_interface.is_set or
                            self.lsp_output_label.is_set or
                            self.lsp_state.is_set or
                            self.lsp_uptime.is_set or
                            self.path_protection_lsp_id.is_set)

                    def has_operation(self):
                        for c in self.lsp_hop:
                            if (c.has_operation()):
                                return True
                        for c in self.srlsp_outgoing_info:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.lsp_local_label.yfilter != YFilter.not_set or
                            self.lsp_output_interface.yfilter != YFilter.not_set or
                            self.lsp_output_label.yfilter != YFilter.not_set or
                            self.lsp_state.yfilter != YFilter.not_set or
                            self.lsp_uptime.yfilter != YFilter.not_set or
                            self.path_protection_lsp_id.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "current-lsp" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-path-protections/tunnel-path-protection/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.lsp_local_label.is_set or self.lsp_local_label.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_local_label.get_name_leafdata())
                        if (self.lsp_output_interface.is_set or self.lsp_output_interface.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_output_interface.get_name_leafdata())
                        if (self.lsp_output_label.is_set or self.lsp_output_label.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_output_label.get_name_leafdata())
                        if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_state.get_name_leafdata())
                        if (self.lsp_uptime.is_set or self.lsp_uptime.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_uptime.get_name_leafdata())
                        if (self.path_protection_lsp_id.is_set or self.path_protection_lsp_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.path_protection_lsp_id.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "lsp-hop"):
                            for c in self.lsp_hop:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.LspHop()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.lsp_hop.append(c)
                            return c

                        if (child_yang_name == "srlsp-outgoing-info"):
                            for c in self.srlsp_outgoing_info:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp.SrlspOutgoingInfo()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.srlsp_outgoing_info.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "lsp-hop" or name == "srlsp-outgoing-info" or name == "lsp-local-label" or name == "lsp-output-interface" or name == "lsp-output-label" or name == "lsp-state" or name == "lsp-uptime" or name == "path-protection-lsp-id"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "lsp-local-label"):
                            self.lsp_local_label = value
                            self.lsp_local_label.value_namespace = name_space
                            self.lsp_local_label.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-output-interface"):
                            self.lsp_output_interface = value
                            self.lsp_output_interface.value_namespace = name_space
                            self.lsp_output_interface.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-output-label"):
                            self.lsp_output_label = value
                            self.lsp_output_label.value_namespace = name_space
                            self.lsp_output_label.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-state"):
                            self.lsp_state = value
                            self.lsp_state.value_namespace = name_space
                            self.lsp_state.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-uptime"):
                            self.lsp_uptime = value
                            self.lsp_uptime.value_namespace = name_space
                            self.lsp_uptime.value_namespace_prefix = name_space_prefix
                        if(value_path == "path-protection-lsp-id"):
                            self.path_protection_lsp_id = value
                            self.path_protection_lsp_id.value_namespace = name_space
                            self.path_protection_lsp_id.value_namespace_prefix = name_space_prefix


                class StandbyLsp(Entity):
                    """
                     Standby LSP info
                    
                    .. attribute:: lsp_hop
                    
                    	Path used by LSP
                    	**type**\: list of    :py:class:`LspHop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.LspHop>`
                    
                    .. attribute:: lsp_local_label
                    
                    	Local label 
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: lsp_output_interface
                    
                    	Output interface of LSP
                    	**type**\:  str
                    
                    .. attribute:: lsp_output_label
                    
                    	Output label of the LSP
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: lsp_state
                    
                    	LSP State
                    	**type**\:   :py:class:`MplsTeTunnelState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelState>`
                    
                    .. attribute:: lsp_uptime
                    
                    	LSP Uptime
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: path_protection_lsp_id
                    
                    	LSP ID 
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: srlsp_outgoing_info
                    
                    	Segment\-routing iutgoing info of LSP
                    	**type**\: list of    :py:class:`SrlspOutgoingInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.SrlspOutgoingInfo>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp, self).__init__()

                        self.yang_name = "standby-lsp"
                        self.yang_parent_name = "tunnel-path-protection"

                        self.lsp_local_label = YLeaf(YType.uint32, "lsp-local-label")

                        self.lsp_output_interface = YLeaf(YType.str, "lsp-output-interface")

                        self.lsp_output_label = YLeaf(YType.uint32, "lsp-output-label")

                        self.lsp_state = YLeaf(YType.enumeration, "lsp-state")

                        self.lsp_uptime = YLeaf(YType.uint32, "lsp-uptime")

                        self.path_protection_lsp_id = YLeaf(YType.uint32, "path-protection-lsp-id")

                        self.lsp_hop = YList(self)
                        self.srlsp_outgoing_info = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("lsp_local_label",
                                        "lsp_output_interface",
                                        "lsp_output_label",
                                        "lsp_state",
                                        "lsp_uptime",
                                        "path_protection_lsp_id") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp, self).__setattr__(name, value)


                    class SrlspOutgoingInfo(Entity):
                        """
                        Segment\-routing iutgoing info of LSP
                        
                        .. attribute:: lsp_output_interface
                        
                        	Output interface of LSP
                        	**type**\:  str
                        
                        .. attribute:: lsp_output_label
                        
                        	Output label of the LSP
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.SrlspOutgoingInfo, self).__init__()

                            self.yang_name = "srlsp-outgoing-info"
                            self.yang_parent_name = "standby-lsp"

                            self.lsp_output_interface = YLeaf(YType.str, "lsp-output-interface")

                            self.lsp_output_label = YLeaf(YType.uint32, "lsp-output-label")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("lsp_output_interface",
                                            "lsp_output_label") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.SrlspOutgoingInfo, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.SrlspOutgoingInfo, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.lsp_output_interface.is_set or
                                self.lsp_output_label.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.lsp_output_interface.yfilter != YFilter.not_set or
                                self.lsp_output_label.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "srlsp-outgoing-info" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-path-protections/tunnel-path-protection/standby-lsp/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.lsp_output_interface.is_set or self.lsp_output_interface.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsp_output_interface.get_name_leafdata())
                            if (self.lsp_output_label.is_set or self.lsp_output_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lsp_output_label.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "lsp-output-interface" or name == "lsp-output-label"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "lsp-output-interface"):
                                self.lsp_output_interface = value
                                self.lsp_output_interface.value_namespace = name_space
                                self.lsp_output_interface.value_namespace_prefix = name_space_prefix
                            if(value_path == "lsp-output-label"):
                                self.lsp_output_label = value
                                self.lsp_output_label.value_namespace = name_space
                                self.lsp_output_label.value_namespace_prefix = name_space_prefix


                    class LspHop(Entity):
                        """
                        Path used by LSP
                        
                        .. attribute:: ero_type
                        
                        	EROType
                        	**type**\:   :py:class:`RsvpMgmtEroSubobj <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobj>`
                        
                        .. attribute:: ipv4ero_sub_object
                        
                        	IPV4 ERO Sub Object
                        	**type**\:   :py:class:`Ipv4EroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.LspHop.Ipv4EroSubObject>`
                        
                        .. attribute:: unnumbered_ero_sub_object
                        
                        	Unnumbered ERO Sub Object
                        	**type**\:   :py:class:`UnnumberedEroSubObject <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.LspHop.UnnumberedEroSubObject>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.LspHop, self).__init__()

                            self.yang_name = "lsp-hop"
                            self.yang_parent_name = "standby-lsp"

                            self.ero_type = YLeaf(YType.enumeration, "ero-type")

                            self.ipv4ero_sub_object = MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.LspHop.Ipv4EroSubObject()
                            self.ipv4ero_sub_object.parent = self
                            self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                            self._children_yang_names.add("ipv4ero-sub-object")

                            self.unnumbered_ero_sub_object = MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.LspHop.UnnumberedEroSubObject()
                            self.unnumbered_ero_sub_object.parent = self
                            self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                            self._children_yang_names.add("unnumbered-ero-sub-object")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("ero_type") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.LspHop, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.LspHop, self).__setattr__(name, value)


                        class Ipv4EroSubObject(Entity):
                            """
                            IPV4 ERO Sub Object
                            
                            .. attribute:: ero_address
                            
                            	The ERO IPV4 Address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: is_strict_route
                            
                            	ERO Entry Is Strict
                            	**type**\:  bool
                            
                            .. attribute:: prefix_length
                            
                            	ERO Prefix Length
                            	**type**\:  int
                            
                            	**range:** 0..255
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.LspHop.Ipv4EroSubObject, self).__init__()

                                self.yang_name = "ipv4ero-sub-object"
                                self.yang_parent_name = "lsp-hop"

                                self.ero_address = YLeaf(YType.str, "ero-address")

                                self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                self.prefix_length = YLeaf(YType.uint8, "prefix-length")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_address",
                                                "is_strict_route",
                                                "prefix_length") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.LspHop.Ipv4EroSubObject, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.LspHop.Ipv4EroSubObject, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.ero_address.is_set or
                                    self.is_strict_route.is_set or
                                    self.prefix_length.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_address.yfilter != YFilter.not_set or
                                    self.is_strict_route.yfilter != YFilter.not_set or
                                    self.prefix_length.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "ipv4ero-sub-object" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-path-protections/tunnel-path-protection/standby-lsp/lsp-hop/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_address.is_set or self.ero_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_address.get_name_leafdata())
                                if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                if (self.prefix_length.is_set or self.prefix_length.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.prefix_length.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ero-address" or name == "is-strict-route" or name == "prefix-length"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-address"):
                                    self.ero_address = value
                                    self.ero_address.value_namespace = name_space
                                    self.ero_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-strict-route"):
                                    self.is_strict_route = value
                                    self.is_strict_route.value_namespace = name_space
                                    self.is_strict_route.value_namespace_prefix = name_space_prefix
                                if(value_path == "prefix-length"):
                                    self.prefix_length = value
                                    self.prefix_length.value_namespace = name_space
                                    self.prefix_length.value_namespace_prefix = name_space_prefix


                        class UnnumberedEroSubObject(Entity):
                            """
                            Unnumbered ERO Sub Object
                            
                            .. attribute:: ero_interface_id
                            
                            	The Interface ID in ERO
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: ero_router_id
                            
                            	The Router ID in ERO
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: is_strict_route
                            
                            	ERO Entry Is Strict
                            	**type**\:  bool
                            
                            .. attribute:: status
                            
                            	Status of ERO
                            	**type**\:   :py:class:`RsvpMgmtEroSubobjStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RsvpMgmtEroSubobjStatus>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.LspHop.UnnumberedEroSubObject, self).__init__()

                                self.yang_name = "unnumbered-ero-sub-object"
                                self.yang_parent_name = "lsp-hop"

                                self.ero_interface_id = YLeaf(YType.uint32, "ero-interface-id")

                                self.ero_router_id = YLeaf(YType.str, "ero-router-id")

                                self.is_strict_route = YLeaf(YType.boolean, "is-strict-route")

                                self.status = YLeaf(YType.enumeration, "status")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("ero_interface_id",
                                                "ero_router_id",
                                                "is_strict_route",
                                                "status") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.LspHop.UnnumberedEroSubObject, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.LspHop.UnnumberedEroSubObject, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.ero_interface_id.is_set or
                                    self.ero_router_id.is_set or
                                    self.is_strict_route.is_set or
                                    self.status.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.ero_interface_id.yfilter != YFilter.not_set or
                                    self.ero_router_id.yfilter != YFilter.not_set or
                                    self.is_strict_route.yfilter != YFilter.not_set or
                                    self.status.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "unnumbered-ero-sub-object" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-path-protections/tunnel-path-protection/standby-lsp/lsp-hop/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.ero_interface_id.is_set or self.ero_interface_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_interface_id.get_name_leafdata())
                                if (self.ero_router_id.is_set or self.ero_router_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.ero_router_id.get_name_leafdata())
                                if (self.is_strict_route.is_set or self.is_strict_route.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_strict_route.get_name_leafdata())
                                if (self.status.is_set or self.status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.status.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "ero-interface-id" or name == "ero-router-id" or name == "is-strict-route" or name == "status"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "ero-interface-id"):
                                    self.ero_interface_id = value
                                    self.ero_interface_id.value_namespace = name_space
                                    self.ero_interface_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "ero-router-id"):
                                    self.ero_router_id = value
                                    self.ero_router_id.value_namespace = name_space
                                    self.ero_router_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-strict-route"):
                                    self.is_strict_route = value
                                    self.is_strict_route.value_namespace = name_space
                                    self.is_strict_route.value_namespace_prefix = name_space_prefix
                                if(value_path == "status"):
                                    self.status = value
                                    self.status.value_namespace = name_space
                                    self.status.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.ero_type.is_set or
                                (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_data()) or
                                (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.ero_type.yfilter != YFilter.not_set or
                                (self.ipv4ero_sub_object is not None and self.ipv4ero_sub_object.has_operation()) or
                                (self.unnumbered_ero_sub_object is not None and self.unnumbered_ero_sub_object.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "lsp-hop" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-path-protections/tunnel-path-protection/standby-lsp/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.ero_type.is_set or self.ero_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ero_type.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "ipv4ero-sub-object"):
                                if (self.ipv4ero_sub_object is None):
                                    self.ipv4ero_sub_object = MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.LspHop.Ipv4EroSubObject()
                                    self.ipv4ero_sub_object.parent = self
                                    self._children_name_map["ipv4ero_sub_object"] = "ipv4ero-sub-object"
                                return self.ipv4ero_sub_object

                            if (child_yang_name == "unnumbered-ero-sub-object"):
                                if (self.unnumbered_ero_sub_object is None):
                                    self.unnumbered_ero_sub_object = MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.LspHop.UnnumberedEroSubObject()
                                    self.unnumbered_ero_sub_object.parent = self
                                    self._children_name_map["unnumbered_ero_sub_object"] = "unnumbered-ero-sub-object"
                                return self.unnumbered_ero_sub_object

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "ipv4ero-sub-object" or name == "unnumbered-ero-sub-object" or name == "ero-type"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "ero-type"):
                                self.ero_type = value
                                self.ero_type.value_namespace = name_space
                                self.ero_type.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.lsp_hop:
                            if (c.has_data()):
                                return True
                        for c in self.srlsp_outgoing_info:
                            if (c.has_data()):
                                return True
                        return (
                            self.lsp_local_label.is_set or
                            self.lsp_output_interface.is_set or
                            self.lsp_output_label.is_set or
                            self.lsp_state.is_set or
                            self.lsp_uptime.is_set or
                            self.path_protection_lsp_id.is_set)

                    def has_operation(self):
                        for c in self.lsp_hop:
                            if (c.has_operation()):
                                return True
                        for c in self.srlsp_outgoing_info:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.lsp_local_label.yfilter != YFilter.not_set or
                            self.lsp_output_interface.yfilter != YFilter.not_set or
                            self.lsp_output_label.yfilter != YFilter.not_set or
                            self.lsp_state.yfilter != YFilter.not_set or
                            self.lsp_uptime.yfilter != YFilter.not_set or
                            self.path_protection_lsp_id.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "standby-lsp" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-path-protections/tunnel-path-protection/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.lsp_local_label.is_set or self.lsp_local_label.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_local_label.get_name_leafdata())
                        if (self.lsp_output_interface.is_set or self.lsp_output_interface.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_output_interface.get_name_leafdata())
                        if (self.lsp_output_label.is_set or self.lsp_output_label.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_output_label.get_name_leafdata())
                        if (self.lsp_state.is_set or self.lsp_state.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_state.get_name_leafdata())
                        if (self.lsp_uptime.is_set or self.lsp_uptime.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_uptime.get_name_leafdata())
                        if (self.path_protection_lsp_id.is_set or self.path_protection_lsp_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.path_protection_lsp_id.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "lsp-hop"):
                            for c in self.lsp_hop:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.LspHop()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.lsp_hop.append(c)
                            return c

                        if (child_yang_name == "srlsp-outgoing-info"):
                            for c in self.srlsp_outgoing_info:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp.SrlspOutgoingInfo()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.srlsp_outgoing_info.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "lsp-hop" or name == "srlsp-outgoing-info" or name == "lsp-local-label" or name == "lsp-output-interface" or name == "lsp-output-label" or name == "lsp-state" or name == "lsp-uptime" or name == "path-protection-lsp-id"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "lsp-local-label"):
                            self.lsp_local_label = value
                            self.lsp_local_label.value_namespace = name_space
                            self.lsp_local_label.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-output-interface"):
                            self.lsp_output_interface = value
                            self.lsp_output_interface.value_namespace = name_space
                            self.lsp_output_interface.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-output-label"):
                            self.lsp_output_label = value
                            self.lsp_output_label.value_namespace = name_space
                            self.lsp_output_label.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-state"):
                            self.lsp_state = value
                            self.lsp_state.value_namespace = name_space
                            self.lsp_state.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-uptime"):
                            self.lsp_uptime = value
                            self.lsp_uptime.value_namespace = name_space
                            self.lsp_uptime.value_namespace_prefix = name_space_prefix
                        if(value_path == "path-protection-lsp-id"):
                            self.path_protection_lsp_id = value
                            self.path_protection_lsp_id.value_namespace = name_space
                            self.path_protection_lsp_id.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    return (
                        self.ctype.is_set or
                        self.destination_address.is_set or
                        self.extended_tunnel_id.is_set or
                        self.is_tunnel_up.is_set or
                        self.source_address.is_set or
                        self.tunnel_id.is_set or
                        self.tunnel_name.is_set or
                        (self.current_lsp is not None and self.current_lsp.has_data()) or
                        (self.path_protection is not None and self.path_protection.has_data()) or
                        (self.standby_lsp is not None and self.standby_lsp.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.ctype.yfilter != YFilter.not_set or
                        self.destination_address.yfilter != YFilter.not_set or
                        self.extended_tunnel_id.yfilter != YFilter.not_set or
                        self.is_tunnel_up.yfilter != YFilter.not_set or
                        self.source_address.yfilter != YFilter.not_set or
                        self.tunnel_id.yfilter != YFilter.not_set or
                        self.tunnel_name.yfilter != YFilter.not_set or
                        (self.current_lsp is not None and self.current_lsp.has_operation()) or
                        (self.path_protection is not None and self.path_protection.has_operation()) or
                        (self.standby_lsp is not None and self.standby_lsp.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "tunnel-path-protection" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/tunnel-path-protections/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.ctype.is_set or self.ctype.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.ctype.get_name_leafdata())
                    if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.destination_address.get_name_leafdata())
                    if (self.extended_tunnel_id.is_set or self.extended_tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.extended_tunnel_id.get_name_leafdata())
                    if (self.is_tunnel_up.is_set or self.is_tunnel_up.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_tunnel_up.get_name_leafdata())
                    if (self.source_address.is_set or self.source_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.source_address.get_name_leafdata())
                    if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_id.get_name_leafdata())
                    if (self.tunnel_name.is_set or self.tunnel_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_name.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "current-lsp"):
                        if (self.current_lsp is None):
                            self.current_lsp = MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.CurrentLsp()
                            self.current_lsp.parent = self
                            self._children_name_map["current_lsp"] = "current-lsp"
                        return self.current_lsp

                    if (child_yang_name == "path-protection"):
                        if (self.path_protection is None):
                            self.path_protection = MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.PathProtection()
                            self.path_protection.parent = self
                            self._children_name_map["path_protection"] = "path-protection"
                        return self.path_protection

                    if (child_yang_name == "standby-lsp"):
                        if (self.standby_lsp is None):
                            self.standby_lsp = MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection.StandbyLsp()
                            self.standby_lsp.parent = self
                            self._children_name_map["standby_lsp"] = "standby-lsp"
                        return self.standby_lsp

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "current-lsp" or name == "path-protection" or name == "standby-lsp" or name == "ctype" or name == "destination-address" or name == "extended-tunnel-id" or name == "is-tunnel-up" or name == "source-address" or name == "tunnel-id" or name == "tunnel-name"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "ctype"):
                        self.ctype = value
                        self.ctype.value_namespace = name_space
                        self.ctype.value_namespace_prefix = name_space_prefix
                    if(value_path == "destination-address"):
                        self.destination_address = value
                        self.destination_address.value_namespace = name_space
                        self.destination_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "extended-tunnel-id"):
                        self.extended_tunnel_id = value
                        self.extended_tunnel_id.value_namespace = name_space
                        self.extended_tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-tunnel-up"):
                        self.is_tunnel_up = value
                        self.is_tunnel_up.value_namespace = name_space
                        self.is_tunnel_up.value_namespace_prefix = name_space_prefix
                    if(value_path == "source-address"):
                        self.source_address = value
                        self.source_address.value_namespace = name_space
                        self.source_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-id"):
                        self.tunnel_id = value
                        self.tunnel_id.value_namespace = name_space
                        self.tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-name"):
                        self.tunnel_name = value
                        self.tunnel_name.value_namespace = name_space
                        self.tunnel_name.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.tunnel_path_protection:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.tunnel_path_protection:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "tunnel-path-protections" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/tunnels/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "tunnel-path-protection"):
                    for c in self.tunnel_path_protection:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTeStandby.Tunnels.TunnelPathProtections.TunnelPathProtection()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.tunnel_path_protection.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "tunnel-path-protection"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass

        def has_data(self):
            return (
                (self.summary is not None and self.summary.has_data()) or
                (self.tunnel_auto_bandwidths is not None and self.tunnel_auto_bandwidths.has_data()) or
                (self.tunnel_flex_lsps is not None and self.tunnel_flex_lsps.has_data()) or
                (self.tunnel_path_protections is not None and self.tunnel_path_protections.has_data()))

        def has_operation(self):
            return (
                self.yfilter != YFilter.not_set or
                (self.summary is not None and self.summary.has_operation()) or
                (self.tunnel_auto_bandwidths is not None and self.tunnel_auto_bandwidths.has_operation()) or
                (self.tunnel_flex_lsps is not None and self.tunnel_flex_lsps.has_operation()) or
                (self.tunnel_path_protections is not None and self.tunnel_path_protections.has_operation()))

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "tunnels" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "summary"):
                if (self.summary is None):
                    self.summary = MplsTeStandby.Tunnels.Summary()
                    self.summary.parent = self
                    self._children_name_map["summary"] = "summary"
                return self.summary

            if (child_yang_name == "tunnel-auto-bandwidths"):
                if (self.tunnel_auto_bandwidths is None):
                    self.tunnel_auto_bandwidths = MplsTeStandby.Tunnels.TunnelAutoBandwidths()
                    self.tunnel_auto_bandwidths.parent = self
                    self._children_name_map["tunnel_auto_bandwidths"] = "tunnel-auto-bandwidths"
                return self.tunnel_auto_bandwidths

            if (child_yang_name == "tunnel-flex-lsps"):
                if (self.tunnel_flex_lsps is None):
                    self.tunnel_flex_lsps = MplsTeStandby.Tunnels.TunnelFlexLsps()
                    self.tunnel_flex_lsps.parent = self
                    self._children_name_map["tunnel_flex_lsps"] = "tunnel-flex-lsps"
                return self.tunnel_flex_lsps

            if (child_yang_name == "tunnel-path-protections"):
                if (self.tunnel_path_protections is None):
                    self.tunnel_path_protections = MplsTeStandby.Tunnels.TunnelPathProtections()
                    self.tunnel_path_protections.parent = self
                    self._children_name_map["tunnel_path_protections"] = "tunnel-path-protections"
                return self.tunnel_path_protections

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "summary" or name == "tunnel-auto-bandwidths" or name == "tunnel-flex-lsps" or name == "tunnel-path-protections"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class MaximumTunnels(Entity):
        """
        MPLS Traffic Engineering Tunnels
        
        .. attribute:: absolute_maximum
        
        	Absolute Maximum
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: current_auto_mesh
        
        	Current Autotunnel Mesh count
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: current_autobackups
        
        	Current Autotunnel Backup count
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: current_destination_count
        
        	Current Destination Count
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: current_gmpls_uni
        
        	Current GMPLS\-UNI tunnel count
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: current_maximum_auto_mesh
        
        	Current Maximum Autotunnel Mesh Allowed
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: current_maximum_autobackups
        
        	Current Maximum Autotunnel Backups Allowed
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: current_maximum_destinations
        
        	Current Maximum Destinations
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: current_maximum_gmpls_unitunnels
        
        	Current Maximum GMPLS\-UNI Tunnel Count
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: current_maximum_p2mp_destnation_per_tunnel
        
        	Current Maximum P2MP Destinations Per Tunnel Count
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: current_maximum_p2mp_tunnels
        
        	Current Maximum P2MP Tunnel Count
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: current_maximum_tunnels
        
        	Current Maximum Tunnels
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: current_p2mp_destnation_per_tunnel_count
        
        	Current P2MP Destination per tunnel count
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: current_p2mp_tunnel_count
        
        	Current P2MP tunnel count
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: current_tunnel_count
        
        	Current tunnel count
        	**type**\:  int
        
        	**range:** 0..4294967295
        
        .. attribute:: is_auto_mesh_range_configured
        
        	TRUE if the automesh range is configured
        	**type**\:  bool
        
        .. attribute:: is_autobackup_range_configured
        
        	TRUE if the autobackup range is configured
        	**type**\:  bool
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsTeStandby.MaximumTunnels, self).__init__()

            self.yang_name = "maximum-tunnels"
            self.yang_parent_name = "mpls-te-standby"

            self.absolute_maximum = YLeaf(YType.uint32, "absolute-maximum")

            self.current_auto_mesh = YLeaf(YType.uint32, "current-auto-mesh")

            self.current_autobackups = YLeaf(YType.uint32, "current-autobackups")

            self.current_destination_count = YLeaf(YType.uint32, "current-destination-count")

            self.current_gmpls_uni = YLeaf(YType.uint32, "current-gmpls-uni")

            self.current_maximum_auto_mesh = YLeaf(YType.uint32, "current-maximum-auto-mesh")

            self.current_maximum_autobackups = YLeaf(YType.uint32, "current-maximum-autobackups")

            self.current_maximum_destinations = YLeaf(YType.uint32, "current-maximum-destinations")

            self.current_maximum_gmpls_unitunnels = YLeaf(YType.uint32, "current-maximum-gmpls-unitunnels")

            self.current_maximum_p2mp_destnation_per_tunnel = YLeaf(YType.uint32, "current-maximum-p2mp-destnation-per-tunnel")

            self.current_maximum_p2mp_tunnels = YLeaf(YType.uint32, "current-maximum-p2mp-tunnels")

            self.current_maximum_tunnels = YLeaf(YType.uint32, "current-maximum-tunnels")

            self.current_p2mp_destnation_per_tunnel_count = YLeaf(YType.uint32, "current-p2mp-destnation-per-tunnel-count")

            self.current_p2mp_tunnel_count = YLeaf(YType.uint32, "current-p2mp-tunnel-count")

            self.current_tunnel_count = YLeaf(YType.uint32, "current-tunnel-count")

            self.is_auto_mesh_range_configured = YLeaf(YType.boolean, "is-auto-mesh-range-configured")

            self.is_autobackup_range_configured = YLeaf(YType.boolean, "is-autobackup-range-configured")

        def __setattr__(self, name, value):
            self._check_monkey_patching_error(name, value)
            with _handle_type_error():
                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                        "Please use list append or extend method."
                                        .format(value))
                if isinstance(value, Enum.YLeaf):
                    value = value.name
                if name in ("absolute_maximum",
                            "current_auto_mesh",
                            "current_autobackups",
                            "current_destination_count",
                            "current_gmpls_uni",
                            "current_maximum_auto_mesh",
                            "current_maximum_autobackups",
                            "current_maximum_destinations",
                            "current_maximum_gmpls_unitunnels",
                            "current_maximum_p2mp_destnation_per_tunnel",
                            "current_maximum_p2mp_tunnels",
                            "current_maximum_tunnels",
                            "current_p2mp_destnation_per_tunnel_count",
                            "current_p2mp_tunnel_count",
                            "current_tunnel_count",
                            "is_auto_mesh_range_configured",
                            "is_autobackup_range_configured") and name in self.__dict__:
                    if isinstance(value, YLeaf):
                        self.__dict__[name].set(value.get())
                    elif isinstance(value, YLeafList):
                        super(MplsTeStandby.MaximumTunnels, self).__setattr__(name, value)
                    else:
                        self.__dict__[name].set(value)
                else:
                    if hasattr(value, "parent") and name != "parent":
                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                            value.parent = self
                        elif value.parent is None and value.yang_name in self._children_yang_names:
                            value.parent = self
                    super(MplsTeStandby.MaximumTunnels, self).__setattr__(name, value)

        def has_data(self):
            return (
                self.absolute_maximum.is_set or
                self.current_auto_mesh.is_set or
                self.current_autobackups.is_set or
                self.current_destination_count.is_set or
                self.current_gmpls_uni.is_set or
                self.current_maximum_auto_mesh.is_set or
                self.current_maximum_autobackups.is_set or
                self.current_maximum_destinations.is_set or
                self.current_maximum_gmpls_unitunnels.is_set or
                self.current_maximum_p2mp_destnation_per_tunnel.is_set or
                self.current_maximum_p2mp_tunnels.is_set or
                self.current_maximum_tunnels.is_set or
                self.current_p2mp_destnation_per_tunnel_count.is_set or
                self.current_p2mp_tunnel_count.is_set or
                self.current_tunnel_count.is_set or
                self.is_auto_mesh_range_configured.is_set or
                self.is_autobackup_range_configured.is_set)

        def has_operation(self):
            return (
                self.yfilter != YFilter.not_set or
                self.absolute_maximum.yfilter != YFilter.not_set or
                self.current_auto_mesh.yfilter != YFilter.not_set or
                self.current_autobackups.yfilter != YFilter.not_set or
                self.current_destination_count.yfilter != YFilter.not_set or
                self.current_gmpls_uni.yfilter != YFilter.not_set or
                self.current_maximum_auto_mesh.yfilter != YFilter.not_set or
                self.current_maximum_autobackups.yfilter != YFilter.not_set or
                self.current_maximum_destinations.yfilter != YFilter.not_set or
                self.current_maximum_gmpls_unitunnels.yfilter != YFilter.not_set or
                self.current_maximum_p2mp_destnation_per_tunnel.yfilter != YFilter.not_set or
                self.current_maximum_p2mp_tunnels.yfilter != YFilter.not_set or
                self.current_maximum_tunnels.yfilter != YFilter.not_set or
                self.current_p2mp_destnation_per_tunnel_count.yfilter != YFilter.not_set or
                self.current_p2mp_tunnel_count.yfilter != YFilter.not_set or
                self.current_tunnel_count.yfilter != YFilter.not_set or
                self.is_auto_mesh_range_configured.yfilter != YFilter.not_set or
                self.is_autobackup_range_configured.yfilter != YFilter.not_set)

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "maximum-tunnels" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()
            if (self.absolute_maximum.is_set or self.absolute_maximum.yfilter != YFilter.not_set):
                leaf_name_data.append(self.absolute_maximum.get_name_leafdata())
            if (self.current_auto_mesh.is_set or self.current_auto_mesh.yfilter != YFilter.not_set):
                leaf_name_data.append(self.current_auto_mesh.get_name_leafdata())
            if (self.current_autobackups.is_set or self.current_autobackups.yfilter != YFilter.not_set):
                leaf_name_data.append(self.current_autobackups.get_name_leafdata())
            if (self.current_destination_count.is_set or self.current_destination_count.yfilter != YFilter.not_set):
                leaf_name_data.append(self.current_destination_count.get_name_leafdata())
            if (self.current_gmpls_uni.is_set or self.current_gmpls_uni.yfilter != YFilter.not_set):
                leaf_name_data.append(self.current_gmpls_uni.get_name_leafdata())
            if (self.current_maximum_auto_mesh.is_set or self.current_maximum_auto_mesh.yfilter != YFilter.not_set):
                leaf_name_data.append(self.current_maximum_auto_mesh.get_name_leafdata())
            if (self.current_maximum_autobackups.is_set or self.current_maximum_autobackups.yfilter != YFilter.not_set):
                leaf_name_data.append(self.current_maximum_autobackups.get_name_leafdata())
            if (self.current_maximum_destinations.is_set or self.current_maximum_destinations.yfilter != YFilter.not_set):
                leaf_name_data.append(self.current_maximum_destinations.get_name_leafdata())
            if (self.current_maximum_gmpls_unitunnels.is_set or self.current_maximum_gmpls_unitunnels.yfilter != YFilter.not_set):
                leaf_name_data.append(self.current_maximum_gmpls_unitunnels.get_name_leafdata())
            if (self.current_maximum_p2mp_destnation_per_tunnel.is_set or self.current_maximum_p2mp_destnation_per_tunnel.yfilter != YFilter.not_set):
                leaf_name_data.append(self.current_maximum_p2mp_destnation_per_tunnel.get_name_leafdata())
            if (self.current_maximum_p2mp_tunnels.is_set or self.current_maximum_p2mp_tunnels.yfilter != YFilter.not_set):
                leaf_name_data.append(self.current_maximum_p2mp_tunnels.get_name_leafdata())
            if (self.current_maximum_tunnels.is_set or self.current_maximum_tunnels.yfilter != YFilter.not_set):
                leaf_name_data.append(self.current_maximum_tunnels.get_name_leafdata())
            if (self.current_p2mp_destnation_per_tunnel_count.is_set or self.current_p2mp_destnation_per_tunnel_count.yfilter != YFilter.not_set):
                leaf_name_data.append(self.current_p2mp_destnation_per_tunnel_count.get_name_leafdata())
            if (self.current_p2mp_tunnel_count.is_set or self.current_p2mp_tunnel_count.yfilter != YFilter.not_set):
                leaf_name_data.append(self.current_p2mp_tunnel_count.get_name_leafdata())
            if (self.current_tunnel_count.is_set or self.current_tunnel_count.yfilter != YFilter.not_set):
                leaf_name_data.append(self.current_tunnel_count.get_name_leafdata())
            if (self.is_auto_mesh_range_configured.is_set or self.is_auto_mesh_range_configured.yfilter != YFilter.not_set):
                leaf_name_data.append(self.is_auto_mesh_range_configured.get_name_leafdata())
            if (self.is_autobackup_range_configured.is_set or self.is_autobackup_range_configured.yfilter != YFilter.not_set):
                leaf_name_data.append(self.is_autobackup_range_configured.get_name_leafdata())

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "absolute-maximum" or name == "current-auto-mesh" or name == "current-autobackups" or name == "current-destination-count" or name == "current-gmpls-uni" or name == "current-maximum-auto-mesh" or name == "current-maximum-autobackups" or name == "current-maximum-destinations" or name == "current-maximum-gmpls-unitunnels" or name == "current-maximum-p2mp-destnation-per-tunnel" or name == "current-maximum-p2mp-tunnels" or name == "current-maximum-tunnels" or name == "current-p2mp-destnation-per-tunnel-count" or name == "current-p2mp-tunnel-count" or name == "current-tunnel-count" or name == "is-auto-mesh-range-configured" or name == "is-autobackup-range-configured"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            if(value_path == "absolute-maximum"):
                self.absolute_maximum = value
                self.absolute_maximum.value_namespace = name_space
                self.absolute_maximum.value_namespace_prefix = name_space_prefix
            if(value_path == "current-auto-mesh"):
                self.current_auto_mesh = value
                self.current_auto_mesh.value_namespace = name_space
                self.current_auto_mesh.value_namespace_prefix = name_space_prefix
            if(value_path == "current-autobackups"):
                self.current_autobackups = value
                self.current_autobackups.value_namespace = name_space
                self.current_autobackups.value_namespace_prefix = name_space_prefix
            if(value_path == "current-destination-count"):
                self.current_destination_count = value
                self.current_destination_count.value_namespace = name_space
                self.current_destination_count.value_namespace_prefix = name_space_prefix
            if(value_path == "current-gmpls-uni"):
                self.current_gmpls_uni = value
                self.current_gmpls_uni.value_namespace = name_space
                self.current_gmpls_uni.value_namespace_prefix = name_space_prefix
            if(value_path == "current-maximum-auto-mesh"):
                self.current_maximum_auto_mesh = value
                self.current_maximum_auto_mesh.value_namespace = name_space
                self.current_maximum_auto_mesh.value_namespace_prefix = name_space_prefix
            if(value_path == "current-maximum-autobackups"):
                self.current_maximum_autobackups = value
                self.current_maximum_autobackups.value_namespace = name_space
                self.current_maximum_autobackups.value_namespace_prefix = name_space_prefix
            if(value_path == "current-maximum-destinations"):
                self.current_maximum_destinations = value
                self.current_maximum_destinations.value_namespace = name_space
                self.current_maximum_destinations.value_namespace_prefix = name_space_prefix
            if(value_path == "current-maximum-gmpls-unitunnels"):
                self.current_maximum_gmpls_unitunnels = value
                self.current_maximum_gmpls_unitunnels.value_namespace = name_space
                self.current_maximum_gmpls_unitunnels.value_namespace_prefix = name_space_prefix
            if(value_path == "current-maximum-p2mp-destnation-per-tunnel"):
                self.current_maximum_p2mp_destnation_per_tunnel = value
                self.current_maximum_p2mp_destnation_per_tunnel.value_namespace = name_space
                self.current_maximum_p2mp_destnation_per_tunnel.value_namespace_prefix = name_space_prefix
            if(value_path == "current-maximum-p2mp-tunnels"):
                self.current_maximum_p2mp_tunnels = value
                self.current_maximum_p2mp_tunnels.value_namespace = name_space
                self.current_maximum_p2mp_tunnels.value_namespace_prefix = name_space_prefix
            if(value_path == "current-maximum-tunnels"):
                self.current_maximum_tunnels = value
                self.current_maximum_tunnels.value_namespace = name_space
                self.current_maximum_tunnels.value_namespace_prefix = name_space_prefix
            if(value_path == "current-p2mp-destnation-per-tunnel-count"):
                self.current_p2mp_destnation_per_tunnel_count = value
                self.current_p2mp_destnation_per_tunnel_count.value_namespace = name_space
                self.current_p2mp_destnation_per_tunnel_count.value_namespace_prefix = name_space_prefix
            if(value_path == "current-p2mp-tunnel-count"):
                self.current_p2mp_tunnel_count = value
                self.current_p2mp_tunnel_count.value_namespace = name_space
                self.current_p2mp_tunnel_count.value_namespace_prefix = name_space_prefix
            if(value_path == "current-tunnel-count"):
                self.current_tunnel_count = value
                self.current_tunnel_count.value_namespace = name_space
                self.current_tunnel_count.value_namespace_prefix = name_space_prefix
            if(value_path == "is-auto-mesh-range-configured"):
                self.is_auto_mesh_range_configured = value
                self.is_auto_mesh_range_configured.value_namespace = name_space
                self.is_auto_mesh_range_configured.value_namespace_prefix = name_space_prefix
            if(value_path == "is-autobackup-range-configured"):
                self.is_autobackup_range_configured = value
                self.is_autobackup_range_configured.value_namespace = name_space
                self.is_autobackup_range_configured.value_namespace_prefix = name_space_prefix


    class PathProtection(Entity):
        """
        MPLS TE path protection info
        
        .. attribute:: switchover_log
        
        	MPLS TE path protection info
        	**type**\:   :py:class:`SwitchoverLog <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.PathProtection.SwitchoverLog>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsTeStandby.PathProtection, self).__init__()

            self.yang_name = "path-protection"
            self.yang_parent_name = "mpls-te-standby"

            self.switchover_log = MplsTeStandby.PathProtection.SwitchoverLog()
            self.switchover_log.parent = self
            self._children_name_map["switchover_log"] = "switchover-log"
            self._children_yang_names.add("switchover-log")


        class SwitchoverLog(Entity):
            """
            MPLS TE path protection info
            
            .. attribute:: average_switchover_millisec
            
            	The average delay for a switchover in milliseconds
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            	**units**\: millisecond
            
            .. attribute:: maximum_switchover_millisec
            
            	The maximum delay for a switchover in milliseconds
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            	**units**\: millisecond
            
            .. attribute:: path_protection_switchover_entry
            
            	The array of path protection switchover entries
            	**type**\: list of    :py:class:`PathProtectionSwitchoverEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.PathProtection.SwitchoverLog.PathProtectionSwitchoverEntry>`
            
            .. attribute:: path_protection_switchovers
            
            	Total number of path protection switchover events. This could be more than the entries in the array
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTeStandby.PathProtection.SwitchoverLog, self).__init__()

                self.yang_name = "switchover-log"
                self.yang_parent_name = "path-protection"

                self.average_switchover_millisec = YLeaf(YType.uint32, "average-switchover-millisec")

                self.maximum_switchover_millisec = YLeaf(YType.uint32, "maximum-switchover-millisec")

                self.path_protection_switchovers = YLeaf(YType.uint32, "path-protection-switchovers")

                self.path_protection_switchover_entry = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("average_switchover_millisec",
                                "maximum_switchover_millisec",
                                "path_protection_switchovers") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTeStandby.PathProtection.SwitchoverLog, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTeStandby.PathProtection.SwitchoverLog, self).__setattr__(name, value)


            class PathProtectionSwitchoverEntry(Entity):
                """
                The array of path protection switchover entries
                
                .. attribute:: date_of_error_detection
                
                	The date when the error that caused the switchover was detected. This date is the number of seconds since Jan 1st 1970
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: second
                
                .. attribute:: date_of_error_detection_millisec
                
                	The milliseconds offset of the date when the error that caused  the switchover was detected
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: millisecond
                
                .. attribute:: from_lsp_id
                
                	The LSP ID from which the traffic was switched over
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: path_protection_switchover_event_index
                
                	The index number of the path protection switch over event
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: path_protection_switchover_reason
                
                	The reason that caused the path protection switchover
                	**type**\:   :py:class:`TeP2MpS2LDeletionSubcause <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeP2MpS2LDeletionSubcause>`
                
                .. attribute:: path_protection_tunnel_id
                
                	The ID of the tunnel that experienced switchover
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: switchover_duration_millisec
                
                	The time in milliseconds between the detection of the error and switching the traffic
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: millisecond
                
                .. attribute:: to_lsp_id
                
                	The LSP ID to which the traffic was switched over
                	**type**\:  int
                
                	**range:** 0..65535
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTeStandby.PathProtection.SwitchoverLog.PathProtectionSwitchoverEntry, self).__init__()

                    self.yang_name = "path-protection-switchover-entry"
                    self.yang_parent_name = "switchover-log"

                    self.date_of_error_detection = YLeaf(YType.uint32, "date-of-error-detection")

                    self.date_of_error_detection_millisec = YLeaf(YType.uint32, "date-of-error-detection-millisec")

                    self.from_lsp_id = YLeaf(YType.uint16, "from-lsp-id")

                    self.path_protection_switchover_event_index = YLeaf(YType.uint32, "path-protection-switchover-event-index")

                    self.path_protection_switchover_reason = YLeaf(YType.enumeration, "path-protection-switchover-reason")

                    self.path_protection_tunnel_id = YLeaf(YType.uint16, "path-protection-tunnel-id")

                    self.switchover_duration_millisec = YLeaf(YType.uint32, "switchover-duration-millisec")

                    self.to_lsp_id = YLeaf(YType.uint16, "to-lsp-id")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("date_of_error_detection",
                                    "date_of_error_detection_millisec",
                                    "from_lsp_id",
                                    "path_protection_switchover_event_index",
                                    "path_protection_switchover_reason",
                                    "path_protection_tunnel_id",
                                    "switchover_duration_millisec",
                                    "to_lsp_id") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTeStandby.PathProtection.SwitchoverLog.PathProtectionSwitchoverEntry, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTeStandby.PathProtection.SwitchoverLog.PathProtectionSwitchoverEntry, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.date_of_error_detection.is_set or
                        self.date_of_error_detection_millisec.is_set or
                        self.from_lsp_id.is_set or
                        self.path_protection_switchover_event_index.is_set or
                        self.path_protection_switchover_reason.is_set or
                        self.path_protection_tunnel_id.is_set or
                        self.switchover_duration_millisec.is_set or
                        self.to_lsp_id.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.date_of_error_detection.yfilter != YFilter.not_set or
                        self.date_of_error_detection_millisec.yfilter != YFilter.not_set or
                        self.from_lsp_id.yfilter != YFilter.not_set or
                        self.path_protection_switchover_event_index.yfilter != YFilter.not_set or
                        self.path_protection_switchover_reason.yfilter != YFilter.not_set or
                        self.path_protection_tunnel_id.yfilter != YFilter.not_set or
                        self.switchover_duration_millisec.yfilter != YFilter.not_set or
                        self.to_lsp_id.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "path-protection-switchover-entry" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/path-protection/switchover-log/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.date_of_error_detection.is_set or self.date_of_error_detection.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.date_of_error_detection.get_name_leafdata())
                    if (self.date_of_error_detection_millisec.is_set or self.date_of_error_detection_millisec.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.date_of_error_detection_millisec.get_name_leafdata())
                    if (self.from_lsp_id.is_set or self.from_lsp_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.from_lsp_id.get_name_leafdata())
                    if (self.path_protection_switchover_event_index.is_set or self.path_protection_switchover_event_index.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.path_protection_switchover_event_index.get_name_leafdata())
                    if (self.path_protection_switchover_reason.is_set or self.path_protection_switchover_reason.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.path_protection_switchover_reason.get_name_leafdata())
                    if (self.path_protection_tunnel_id.is_set or self.path_protection_tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.path_protection_tunnel_id.get_name_leafdata())
                    if (self.switchover_duration_millisec.is_set or self.switchover_duration_millisec.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.switchover_duration_millisec.get_name_leafdata())
                    if (self.to_lsp_id.is_set or self.to_lsp_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.to_lsp_id.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "date-of-error-detection" or name == "date-of-error-detection-millisec" or name == "from-lsp-id" or name == "path-protection-switchover-event-index" or name == "path-protection-switchover-reason" or name == "path-protection-tunnel-id" or name == "switchover-duration-millisec" or name == "to-lsp-id"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "date-of-error-detection"):
                        self.date_of_error_detection = value
                        self.date_of_error_detection.value_namespace = name_space
                        self.date_of_error_detection.value_namespace_prefix = name_space_prefix
                    if(value_path == "date-of-error-detection-millisec"):
                        self.date_of_error_detection_millisec = value
                        self.date_of_error_detection_millisec.value_namespace = name_space
                        self.date_of_error_detection_millisec.value_namespace_prefix = name_space_prefix
                    if(value_path == "from-lsp-id"):
                        self.from_lsp_id = value
                        self.from_lsp_id.value_namespace = name_space
                        self.from_lsp_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "path-protection-switchover-event-index"):
                        self.path_protection_switchover_event_index = value
                        self.path_protection_switchover_event_index.value_namespace = name_space
                        self.path_protection_switchover_event_index.value_namespace_prefix = name_space_prefix
                    if(value_path == "path-protection-switchover-reason"):
                        self.path_protection_switchover_reason = value
                        self.path_protection_switchover_reason.value_namespace = name_space
                        self.path_protection_switchover_reason.value_namespace_prefix = name_space_prefix
                    if(value_path == "path-protection-tunnel-id"):
                        self.path_protection_tunnel_id = value
                        self.path_protection_tunnel_id.value_namespace = name_space
                        self.path_protection_tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "switchover-duration-millisec"):
                        self.switchover_duration_millisec = value
                        self.switchover_duration_millisec.value_namespace = name_space
                        self.switchover_duration_millisec.value_namespace_prefix = name_space_prefix
                    if(value_path == "to-lsp-id"):
                        self.to_lsp_id = value
                        self.to_lsp_id.value_namespace = name_space
                        self.to_lsp_id.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.path_protection_switchover_entry:
                    if (c.has_data()):
                        return True
                return (
                    self.average_switchover_millisec.is_set or
                    self.maximum_switchover_millisec.is_set or
                    self.path_protection_switchovers.is_set)

            def has_operation(self):
                for c in self.path_protection_switchover_entry:
                    if (c.has_operation()):
                        return True
                return (
                    self.yfilter != YFilter.not_set or
                    self.average_switchover_millisec.yfilter != YFilter.not_set or
                    self.maximum_switchover_millisec.yfilter != YFilter.not_set or
                    self.path_protection_switchovers.yfilter != YFilter.not_set)

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "switchover-log" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/path-protection/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.average_switchover_millisec.is_set or self.average_switchover_millisec.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.average_switchover_millisec.get_name_leafdata())
                if (self.maximum_switchover_millisec.is_set or self.maximum_switchover_millisec.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.maximum_switchover_millisec.get_name_leafdata())
                if (self.path_protection_switchovers.is_set or self.path_protection_switchovers.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.path_protection_switchovers.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "path-protection-switchover-entry"):
                    for c in self.path_protection_switchover_entry:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTeStandby.PathProtection.SwitchoverLog.PathProtectionSwitchoverEntry()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.path_protection_switchover_entry.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "path-protection-switchover-entry" or name == "average-switchover-millisec" or name == "maximum-switchover-millisec" or name == "path-protection-switchovers"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "average-switchover-millisec"):
                    self.average_switchover_millisec = value
                    self.average_switchover_millisec.value_namespace = name_space
                    self.average_switchover_millisec.value_namespace_prefix = name_space_prefix
                if(value_path == "maximum-switchover-millisec"):
                    self.maximum_switchover_millisec = value
                    self.maximum_switchover_millisec.value_namespace = name_space
                    self.maximum_switchover_millisec.value_namespace_prefix = name_space_prefix
                if(value_path == "path-protection-switchovers"):
                    self.path_protection_switchovers = value
                    self.path_protection_switchovers.value_namespace = name_space
                    self.path_protection_switchovers.value_namespace_prefix = name_space_prefix

        def has_data(self):
            return (self.switchover_log is not None and self.switchover_log.has_data())

        def has_operation(self):
            return (
                self.yfilter != YFilter.not_set or
                (self.switchover_log is not None and self.switchover_log.has_operation()))

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "path-protection" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "switchover-log"):
                if (self.switchover_log is None):
                    self.switchover_log = MplsTeStandby.PathProtection.SwitchoverLog()
                    self.switchover_log.parent = self
                    self._children_name_map["switchover_log"] = "switchover-log"
                return self.switchover_log

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "switchover-log"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class FibNextHopLabelRoutes(Entity):
        """
        MPLS TE FIB nexthop label route database
        
        .. attribute:: fib_next_hop_label_route
        
        	MPLS TE FIB nexthop label route
        	**type**\: list of    :py:class:`FibNextHopLabelRoute <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.FibNextHopLabelRoutes.FibNextHopLabelRoute>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsTeStandby.FibNextHopLabelRoutes, self).__init__()

            self.yang_name = "fib-next-hop-label-routes"
            self.yang_parent_name = "mpls-te-standby"

            self.fib_next_hop_label_route = YList(self)

        def __setattr__(self, name, value):
            self._check_monkey_patching_error(name, value)
            with _handle_type_error():
                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                        "Please use list append or extend method."
                                        .format(value))
                if isinstance(value, Enum.YLeaf):
                    value = value.name
                if name in () and name in self.__dict__:
                    if isinstance(value, YLeaf):
                        self.__dict__[name].set(value.get())
                    elif isinstance(value, YLeafList):
                        super(MplsTeStandby.FibNextHopLabelRoutes, self).__setattr__(name, value)
                    else:
                        self.__dict__[name].set(value)
                else:
                    if hasattr(value, "parent") and name != "parent":
                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                            value.parent = self
                        elif value.parent is None and value.yang_name in self._children_yang_names:
                            value.parent = self
                    super(MplsTeStandby.FibNextHopLabelRoutes, self).__setattr__(name, value)


        class FibNextHopLabelRoute(Entity):
            """
            MPLS TE FIB nexthop label route
            
            .. attribute:: label  <key>
            
            	MPLS Label
            	**type**\:  int
            
            	**range:** 0..1048575
            
            .. attribute:: create_time
            
            	Create Time
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: expire_time
            
            	Expire Time
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: is_notified
            
            	Is Notified
            	**type**\:  bool
            
            .. attribute:: is_registered
            
            	Is Registered
            	**type**\:  bool
            
            .. attribute:: is_stale
            
            	Is Stale
            	**type**\:  bool
            
            .. attribute:: last_update_time
            
            	Last Update Time
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: last_used_time
            
            	Last Used Time
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: next_hop_path
            
            	Next Hop Paths
            	**type**\: list of    :py:class:`NextHopPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.FibNextHopLabelRoutes.FibNextHopLabelRoute.NextHopPath>`
            
            .. attribute:: prefix_addr
            
            	Deprecated \- replaced by TargetAddress
            	**type**\:  str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            .. attribute:: route_version
            
            	Route version
            	**type**\:  int
            
            	**range:** 0..18446744073709551615
            
            .. attribute:: target_address
            
            	Next Hop Target Address
            	**type**\:   :py:class:`TargetAddress <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.FibNextHopLabelRoutes.FibNextHopLabelRoute.TargetAddress>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTeStandby.FibNextHopLabelRoutes.FibNextHopLabelRoute, self).__init__()

                self.yang_name = "fib-next-hop-label-route"
                self.yang_parent_name = "fib-next-hop-label-routes"

                self.label = YLeaf(YType.uint32, "label")

                self.create_time = YLeaf(YType.uint32, "create-time")

                self.expire_time = YLeaf(YType.uint32, "expire-time")

                self.is_notified = YLeaf(YType.boolean, "is-notified")

                self.is_registered = YLeaf(YType.boolean, "is-registered")

                self.is_stale = YLeaf(YType.boolean, "is-stale")

                self.last_update_time = YLeaf(YType.uint32, "last-update-time")

                self.last_used_time = YLeaf(YType.uint32, "last-used-time")

                self.prefix_addr = YLeaf(YType.str, "prefix-addr")

                self.route_version = YLeaf(YType.uint64, "route-version")

                self.target_address = MplsTeStandby.FibNextHopLabelRoutes.FibNextHopLabelRoute.TargetAddress()
                self.target_address.parent = self
                self._children_name_map["target_address"] = "target-address"
                self._children_yang_names.add("target-address")

                self.next_hop_path = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("label",
                                "create_time",
                                "expire_time",
                                "is_notified",
                                "is_registered",
                                "is_stale",
                                "last_update_time",
                                "last_used_time",
                                "prefix_addr",
                                "route_version") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTeStandby.FibNextHopLabelRoutes.FibNextHopLabelRoute, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTeStandby.FibNextHopLabelRoutes.FibNextHopLabelRoute, self).__setattr__(name, value)


            class TargetAddress(Entity):
                """
                Next Hop Target Address
                
                .. attribute:: ip_address
                
                	IPv4 Address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: label
                
                	MPLS Label
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: type
                
                	type
                	**type**\:   :py:class:`TeTargetAddr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeTargetAddr>`
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTeStandby.FibNextHopLabelRoutes.FibNextHopLabelRoute.TargetAddress, self).__init__()

                    self.yang_name = "target-address"
                    self.yang_parent_name = "fib-next-hop-label-route"

                    self.ip_address = YLeaf(YType.str, "ip-address")

                    self.label = YLeaf(YType.uint32, "label")

                    self.type = YLeaf(YType.enumeration, "type")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("ip_address",
                                    "label",
                                    "type") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTeStandby.FibNextHopLabelRoutes.FibNextHopLabelRoute.TargetAddress, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTeStandby.FibNextHopLabelRoutes.FibNextHopLabelRoute.TargetAddress, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.ip_address.is_set or
                        self.label.is_set or
                        self.type.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.ip_address.yfilter != YFilter.not_set or
                        self.label.yfilter != YFilter.not_set or
                        self.type.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "target-address" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.ip_address.is_set or self.ip_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.ip_address.get_name_leafdata())
                    if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.label.get_name_leafdata())
                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.type.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "ip-address" or name == "label" or name == "type"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "ip-address"):
                        self.ip_address = value
                        self.ip_address.value_namespace = name_space
                        self.ip_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "label"):
                        self.label = value
                        self.label.value_namespace = name_space
                        self.label.value_namespace_prefix = name_space_prefix
                    if(value_path == "type"):
                        self.type = value
                        self.type.value_namespace = name_space
                        self.type.value_namespace_prefix = name_space_prefix


            class NextHopPath(Entity):
                """
                Next Hop Paths
                
                .. attribute:: backup_path_id
                
                	Backup Path Identifier
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: interface
                
                	Outgoing Interface
                	**type**\:  str
                
                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                
                .. attribute:: label_stack
                
                	Outgoing Label Stack
                	**type**\: list of    :py:class:`LabelStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.FibNextHopLabelRoutes.FibNextHopLabelRoute.NextHopPath.LabelStack>`
                
                .. attribute:: next_hop_address
                
                	Next Hop Address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: path_id
                
                	Path ID
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: pure_backup
                
                	Pure Backup
                	**type**\:  bool
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTeStandby.FibNextHopLabelRoutes.FibNextHopLabelRoute.NextHopPath, self).__init__()

                    self.yang_name = "next-hop-path"
                    self.yang_parent_name = "fib-next-hop-label-route"

                    self.backup_path_id = YLeaf(YType.uint32, "backup-path-id")

                    self.interface = YLeaf(YType.str, "interface")

                    self.next_hop_address = YLeaf(YType.str, "next-hop-address")

                    self.path_id = YLeaf(YType.uint32, "path-id")

                    self.pure_backup = YLeaf(YType.boolean, "pure-backup")

                    self.label_stack = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("backup_path_id",
                                    "interface",
                                    "next_hop_address",
                                    "path_id",
                                    "pure_backup") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTeStandby.FibNextHopLabelRoutes.FibNextHopLabelRoute.NextHopPath, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTeStandby.FibNextHopLabelRoutes.FibNextHopLabelRoute.NextHopPath, self).__setattr__(name, value)


                class LabelStack(Entity):
                    """
                    Outgoing Label Stack
                    
                    .. attribute:: entry
                    
                    	
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.FibNextHopLabelRoutes.FibNextHopLabelRoute.NextHopPath.LabelStack, self).__init__()

                        self.yang_name = "label-stack"
                        self.yang_parent_name = "next-hop-path"

                        self.entry = YLeaf(YType.uint32, "entry")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("entry") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.FibNextHopLabelRoutes.FibNextHopLabelRoute.NextHopPath.LabelStack, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.FibNextHopLabelRoutes.FibNextHopLabelRoute.NextHopPath.LabelStack, self).__setattr__(name, value)

                    def has_data(self):
                        return self.entry.is_set

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.entry.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "label-stack" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.entry.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "entry"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "entry"):
                            self.entry = value
                            self.entry.value_namespace = name_space
                            self.entry.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.label_stack:
                        if (c.has_data()):
                            return True
                    return (
                        self.backup_path_id.is_set or
                        self.interface.is_set or
                        self.next_hop_address.is_set or
                        self.path_id.is_set or
                        self.pure_backup.is_set)

                def has_operation(self):
                    for c in self.label_stack:
                        if (c.has_operation()):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        self.backup_path_id.yfilter != YFilter.not_set or
                        self.interface.yfilter != YFilter.not_set or
                        self.next_hop_address.yfilter != YFilter.not_set or
                        self.path_id.yfilter != YFilter.not_set or
                        self.pure_backup.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "next-hop-path" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.backup_path_id.is_set or self.backup_path_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.backup_path_id.get_name_leafdata())
                    if (self.interface.is_set or self.interface.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.interface.get_name_leafdata())
                    if (self.next_hop_address.is_set or self.next_hop_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.next_hop_address.get_name_leafdata())
                    if (self.path_id.is_set or self.path_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.path_id.get_name_leafdata())
                    if (self.pure_backup.is_set or self.pure_backup.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.pure_backup.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "label-stack"):
                        for c in self.label_stack:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsTeStandby.FibNextHopLabelRoutes.FibNextHopLabelRoute.NextHopPath.LabelStack()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.label_stack.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "label-stack" or name == "backup-path-id" or name == "interface" or name == "next-hop-address" or name == "path-id" or name == "pure-backup"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "backup-path-id"):
                        self.backup_path_id = value
                        self.backup_path_id.value_namespace = name_space
                        self.backup_path_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "interface"):
                        self.interface = value
                        self.interface.value_namespace = name_space
                        self.interface.value_namespace_prefix = name_space_prefix
                    if(value_path == "next-hop-address"):
                        self.next_hop_address = value
                        self.next_hop_address.value_namespace = name_space
                        self.next_hop_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "path-id"):
                        self.path_id = value
                        self.path_id.value_namespace = name_space
                        self.path_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "pure-backup"):
                        self.pure_backup = value
                        self.pure_backup.value_namespace = name_space
                        self.pure_backup.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.next_hop_path:
                    if (c.has_data()):
                        return True
                return (
                    self.label.is_set or
                    self.create_time.is_set or
                    self.expire_time.is_set or
                    self.is_notified.is_set or
                    self.is_registered.is_set or
                    self.is_stale.is_set or
                    self.last_update_time.is_set or
                    self.last_used_time.is_set or
                    self.prefix_addr.is_set or
                    self.route_version.is_set or
                    (self.target_address is not None and self.target_address.has_data()))

            def has_operation(self):
                for c in self.next_hop_path:
                    if (c.has_operation()):
                        return True
                return (
                    self.yfilter != YFilter.not_set or
                    self.label.yfilter != YFilter.not_set or
                    self.create_time.yfilter != YFilter.not_set or
                    self.expire_time.yfilter != YFilter.not_set or
                    self.is_notified.yfilter != YFilter.not_set or
                    self.is_registered.yfilter != YFilter.not_set or
                    self.is_stale.yfilter != YFilter.not_set or
                    self.last_update_time.yfilter != YFilter.not_set or
                    self.last_used_time.yfilter != YFilter.not_set or
                    self.prefix_addr.yfilter != YFilter.not_set or
                    self.route_version.yfilter != YFilter.not_set or
                    (self.target_address is not None and self.target_address.has_operation()))

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "fib-next-hop-label-route" + "[label='" + self.label.get() + "']" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/fib-next-hop-label-routes/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.label.get_name_leafdata())
                if (self.create_time.is_set or self.create_time.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.create_time.get_name_leafdata())
                if (self.expire_time.is_set or self.expire_time.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.expire_time.get_name_leafdata())
                if (self.is_notified.is_set or self.is_notified.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.is_notified.get_name_leafdata())
                if (self.is_registered.is_set or self.is_registered.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.is_registered.get_name_leafdata())
                if (self.is_stale.is_set or self.is_stale.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.is_stale.get_name_leafdata())
                if (self.last_update_time.is_set or self.last_update_time.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.last_update_time.get_name_leafdata())
                if (self.last_used_time.is_set or self.last_used_time.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.last_used_time.get_name_leafdata())
                if (self.prefix_addr.is_set or self.prefix_addr.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.prefix_addr.get_name_leafdata())
                if (self.route_version.is_set or self.route_version.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.route_version.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "next-hop-path"):
                    for c in self.next_hop_path:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTeStandby.FibNextHopLabelRoutes.FibNextHopLabelRoute.NextHopPath()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.next_hop_path.append(c)
                    return c

                if (child_yang_name == "target-address"):
                    if (self.target_address is None):
                        self.target_address = MplsTeStandby.FibNextHopLabelRoutes.FibNextHopLabelRoute.TargetAddress()
                        self.target_address.parent = self
                        self._children_name_map["target_address"] = "target-address"
                    return self.target_address

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "next-hop-path" or name == "target-address" or name == "label" or name == "create-time" or name == "expire-time" or name == "is-notified" or name == "is-registered" or name == "is-stale" or name == "last-update-time" or name == "last-used-time" or name == "prefix-addr" or name == "route-version"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "label"):
                    self.label = value
                    self.label.value_namespace = name_space
                    self.label.value_namespace_prefix = name_space_prefix
                if(value_path == "create-time"):
                    self.create_time = value
                    self.create_time.value_namespace = name_space
                    self.create_time.value_namespace_prefix = name_space_prefix
                if(value_path == "expire-time"):
                    self.expire_time = value
                    self.expire_time.value_namespace = name_space
                    self.expire_time.value_namespace_prefix = name_space_prefix
                if(value_path == "is-notified"):
                    self.is_notified = value
                    self.is_notified.value_namespace = name_space
                    self.is_notified.value_namespace_prefix = name_space_prefix
                if(value_path == "is-registered"):
                    self.is_registered = value
                    self.is_registered.value_namespace = name_space
                    self.is_registered.value_namespace_prefix = name_space_prefix
                if(value_path == "is-stale"):
                    self.is_stale = value
                    self.is_stale.value_namespace = name_space
                    self.is_stale.value_namespace_prefix = name_space_prefix
                if(value_path == "last-update-time"):
                    self.last_update_time = value
                    self.last_update_time.value_namespace = name_space
                    self.last_update_time.value_namespace_prefix = name_space_prefix
                if(value_path == "last-used-time"):
                    self.last_used_time = value
                    self.last_used_time.value_namespace = name_space
                    self.last_used_time.value_namespace_prefix = name_space_prefix
                if(value_path == "prefix-addr"):
                    self.prefix_addr = value
                    self.prefix_addr.value_namespace = name_space
                    self.prefix_addr.value_namespace_prefix = name_space_prefix
                if(value_path == "route-version"):
                    self.route_version = value
                    self.route_version.value_namespace = name_space
                    self.route_version.value_namespace_prefix = name_space_prefix

        def has_data(self):
            for c in self.fib_next_hop_label_route:
                if (c.has_data()):
                    return True
            return False

        def has_operation(self):
            for c in self.fib_next_hop_label_route:
                if (c.has_operation()):
                    return True
            return self.yfilter != YFilter.not_set

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "fib-next-hop-label-routes" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "fib-next-hop-label-route"):
                for c in self.fib_next_hop_label_route:
                    segment = c.get_segment_path()
                    if (segment_path == segment):
                        return c
                c = MplsTeStandby.FibNextHopLabelRoutes.FibNextHopLabelRoute()
                c.parent = self
                local_reference_key = "ydk::seg::%s" % segment_path
                self._local_refs[local_reference_key] = c
                self.fib_next_hop_label_route.append(c)
                return c

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "fib-next-hop-label-route"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class P2Mp(Entity):
        """
        P2MP Information
        
        .. attribute:: collaborator_timers
        
        	TE Collaborator timer status
        	**type**\:   :py:class:`CollaboratorTimers <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2Mp.CollaboratorTimers>`
        
        .. attribute:: forwarding_output_label_rewrites
        
        	forwarding\-adjacency P2MP Information
        	**type**\:   :py:class:`ForwardingOutputLabelRewrites <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites>`
        
        .. attribute:: tunnel_rewrites
        
        	forwarding\-adjacency P2MP Tunnel RW
        	**type**\:   :py:class:`TunnelRewrites <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2Mp.TunnelRewrites>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsTeStandby.P2Mp, self).__init__()

            self.yang_name = "p2mp"
            self.yang_parent_name = "mpls-te-standby"

            self.collaborator_timers = MplsTeStandby.P2Mp.CollaboratorTimers()
            self.collaborator_timers.parent = self
            self._children_name_map["collaborator_timers"] = "collaborator-timers"
            self._children_yang_names.add("collaborator-timers")

            self.forwarding_output_label_rewrites = MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites()
            self.forwarding_output_label_rewrites.parent = self
            self._children_name_map["forwarding_output_label_rewrites"] = "forwarding-output-label-rewrites"
            self._children_yang_names.add("forwarding-output-label-rewrites")

            self.tunnel_rewrites = MplsTeStandby.P2Mp.TunnelRewrites()
            self.tunnel_rewrites.parent = self
            self._children_name_map["tunnel_rewrites"] = "tunnel-rewrites"
            self._children_yang_names.add("tunnel-rewrites")


        class TunnelRewrites(Entity):
            """
            forwarding\-adjacency P2MP Tunnel RW
            
            .. attribute:: tunnel_rewrite
            
            	Display only P2MP Information
            	**type**\: list of    :py:class:`TunnelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTeStandby.P2Mp.TunnelRewrites, self).__init__()

                self.yang_name = "tunnel-rewrites"
                self.yang_parent_name = "p2mp"

                self.tunnel_rewrite = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTeStandby.P2Mp.TunnelRewrites, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTeStandby.P2Mp.TunnelRewrites, self).__setattr__(name, value)


            class TunnelRewrite(Entity):
                """
                Display only P2MP Information
                
                .. attribute:: tunnel_id  <key>
                
                	Tunnel ID
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: lsp_id  <key>
                
                	LSP ID
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: ctype  <key>
                
                	Ctype
                	**type**\:   :py:class:`Ctype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.Ctype>`
                
                .. attribute:: failed_rewrite
                
                	Failed rewrite details
                	**type**\:   :py:class:`FailedRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite>`
                
                .. attribute:: is_segment_routing
                
                	TRUE if the s2l path is Segment\-Routing
                	**type**\:  bool
                
                .. attribute:: pending_rewrite
                
                	Pending rewrite details
                	**type**\:   :py:class:`PendingRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite>`
                
                .. attribute:: successful_rewrite
                
                	Successful rewrite details
                	**type**\:   :py:class:`SuccessfulRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite>`
                
                .. attribute:: tunnel_interface
                
                	Tunnel interface name
                	**type**\:  str
                
                .. attribute:: tunnel_signal_name
                
                	Tunnel signaled\-name
                	**type**\:  str
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite, self).__init__()

                    self.yang_name = "tunnel-rewrite"
                    self.yang_parent_name = "tunnel-rewrites"

                    self.tunnel_id = YLeaf(YType.int32, "tunnel-id")

                    self.lsp_id = YLeaf(YType.int32, "lsp-id")

                    self.ctype = YLeaf(YType.enumeration, "ctype")

                    self.is_segment_routing = YLeaf(YType.boolean, "is-segment-routing")

                    self.tunnel_interface = YLeaf(YType.str, "tunnel-interface")

                    self.tunnel_signal_name = YLeaf(YType.str, "tunnel-signal-name")

                    self.failed_rewrite = MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite()
                    self.failed_rewrite.parent = self
                    self._children_name_map["failed_rewrite"] = "failed-rewrite"
                    self._children_yang_names.add("failed-rewrite")

                    self.pending_rewrite = MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite()
                    self.pending_rewrite.parent = self
                    self._children_name_map["pending_rewrite"] = "pending-rewrite"
                    self._children_yang_names.add("pending-rewrite")

                    self.successful_rewrite = MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite()
                    self.successful_rewrite.parent = self
                    self._children_name_map["successful_rewrite"] = "successful-rewrite"
                    self._children_yang_names.add("successful-rewrite")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("tunnel_id",
                                    "lsp_id",
                                    "ctype",
                                    "is_segment_routing",
                                    "tunnel_interface",
                                    "tunnel_signal_name") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite, self).__setattr__(name, value)


                class SuccessfulRewrite(Entity):
                    """
                    Successful rewrite details
                    
                    .. attribute:: timestamp
                    
                    	Time stamp of the entry
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tunnel_rewrite
                    
                    	Union of p2p and p2mp tun rewrite data
                    	**type**\:   :py:class:`TunnelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite, self).__init__()

                        self.yang_name = "successful-rewrite"
                        self.yang_parent_name = "tunnel-rewrite"

                        self.timestamp = YLeaf(YType.uint32, "timestamp")

                        self.tunnel_rewrite = MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite()
                        self.tunnel_rewrite.parent = self
                        self._children_name_map["tunnel_rewrite"] = "tunnel-rewrite"
                        self._children_yang_names.add("tunnel-rewrite")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("timestamp") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite, self).__setattr__(name, value)


                    class TunnelRewrite(Entity):
                        """
                        Union of p2p and p2mp tun rewrite data
                        
                        .. attribute:: fec_ctype
                        
                        	FEC CType
                        	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                        
                        .. attribute:: p2mp_tunnel_rewrite
                        
                        	Tunnel rewrite data specific to P2MP
                        	**type**\:   :py:class:`P2MpTunnelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite.P2MpTunnelRewrite>`
                        
                        .. attribute:: p2p_tunnel_rewrite
                        
                        	Tunnel rewrite data specific to P2P
                        	**type**\:   :py:class:`P2PTunnelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite.P2PTunnelRewrite>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite, self).__init__()

                            self.yang_name = "tunnel-rewrite"
                            self.yang_parent_name = "successful-rewrite"

                            self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                            self.p2mp_tunnel_rewrite = MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite.P2MpTunnelRewrite()
                            self.p2mp_tunnel_rewrite.parent = self
                            self._children_name_map["p2mp_tunnel_rewrite"] = "p2mp-tunnel-rewrite"
                            self._children_yang_names.add("p2mp-tunnel-rewrite")

                            self.p2p_tunnel_rewrite = MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite.P2PTunnelRewrite()
                            self.p2p_tunnel_rewrite.parent = self
                            self._children_name_map["p2p_tunnel_rewrite"] = "p2p-tunnel-rewrite"
                            self._children_yang_names.add("p2p-tunnel-rewrite")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("fec_ctype") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite, self).__setattr__(name, value)


                        class P2PTunnelRewrite(Entity):
                            """
                            Tunnel rewrite data specific to P2P
                            
                            .. attribute:: backup_active
                            
                            	FRR is active on the backup tunnel
                            	**type**\:  bool
                            
                            .. attribute:: backup_tunnel_name
                            
                            	Backup tunnel name
                            	**type**\:  str
                            
                            .. attribute:: backup_tunnel_rewrite
                            
                            	Properties of the S2L's backup for tunnel rewrite
                            	**type**\:   :py:class:`BackupTunnelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite.P2PTunnelRewrite.BackupTunnelRewrite>`
                            
                            .. attribute:: destination_address
                            
                            	Destination
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: extended_tunnel_id
                            
                            	Extended Tunnel ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: local_label
                            
                            	Local label of the tunnel rewrite
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: original_input_interface
                            
                            	Input interface of the S2Ls
                            	**type**\:  str
                            
                            .. attribute:: output_interface_name
                            
                            	The output interface of the S2Ls
                            	**type**\:  str
                            
                            .. attribute:: previous_hop_address
                            
                            	Previous hop
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: primary_s2l
                            
                            	Properties of the primary S2L of tunnel rewrite
                            	**type**\:   :py:class:`PrimaryS2L <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite.P2PTunnelRewrite.PrimaryS2L>`
                            
                            .. attribute:: source_pe
                            
                            	source address of the tunnel
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: tunnel_id
                            
                            	Tunnel ID for this rewrite data
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite.P2PTunnelRewrite, self).__init__()

                                self.yang_name = "p2p-tunnel-rewrite"
                                self.yang_parent_name = "tunnel-rewrite"

                                self.backup_active = YLeaf(YType.boolean, "backup-active")

                                self.backup_tunnel_name = YLeaf(YType.str, "backup-tunnel-name")

                                self.destination_address = YLeaf(YType.str, "destination-address")

                                self.extended_tunnel_id = YLeaf(YType.str, "extended-tunnel-id")

                                self.local_label = YLeaf(YType.uint32, "local-label")

                                self.original_input_interface = YLeaf(YType.str, "original-input-interface")

                                self.output_interface_name = YLeaf(YType.str, "output-interface-name")

                                self.previous_hop_address = YLeaf(YType.str, "previous-hop-address")

                                self.source_pe = YLeaf(YType.str, "source-pe")

                                self.tunnel_id = YLeaf(YType.uint16, "tunnel-id")

                                self.backup_tunnel_rewrite = MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite.P2PTunnelRewrite.BackupTunnelRewrite()
                                self.backup_tunnel_rewrite.parent = self
                                self._children_name_map["backup_tunnel_rewrite"] = "backup-tunnel-rewrite"
                                self._children_yang_names.add("backup-tunnel-rewrite")

                                self.primary_s2l = MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite.P2PTunnelRewrite.PrimaryS2L()
                                self.primary_s2l.parent = self
                                self._children_name_map["primary_s2l"] = "primary-s2l"
                                self._children_yang_names.add("primary-s2l")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("backup_active",
                                                "backup_tunnel_name",
                                                "destination_address",
                                                "extended_tunnel_id",
                                                "local_label",
                                                "original_input_interface",
                                                "output_interface_name",
                                                "previous_hop_address",
                                                "source_pe",
                                                "tunnel_id") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite.P2PTunnelRewrite, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite.P2PTunnelRewrite, self).__setattr__(name, value)


                            class PrimaryS2L(Entity):
                                """
                                Properties of the primary S2L of tunnel rewrite
                                
                                .. attribute:: next_hop_address
                                
                                	Next hop address associated with the entry
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: out_label
                                
                                	Output label associated with the entry
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: parent_interface_name
                                
                                	Interface name of the parent intf
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: physica_interface_name
                                
                                	Physical interface associated with the entry
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: sr_label_stack
                                
                                	Segment\-Routing labels stack
                                	**type**\: list of    :py:class:`SrLabelStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite.P2PTunnelRewrite.PrimaryS2L.SrLabelStack>`
                                
                                .. attribute:: tunnel_interface_name
                                
                                	Interface handle of the associated tunnel
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite.P2PTunnelRewrite.PrimaryS2L, self).__init__()

                                    self.yang_name = "primary-s2l"
                                    self.yang_parent_name = "p2p-tunnel-rewrite"

                                    self.next_hop_address = YLeaf(YType.str, "next-hop-address")

                                    self.out_label = YLeaf(YType.uint32, "out-label")

                                    self.parent_interface_name = YLeaf(YType.str, "parent-interface-name")

                                    self.physica_interface_name = YLeaf(YType.str, "physica-interface-name")

                                    self.tunnel_interface_name = YLeaf(YType.str, "tunnel-interface-name")

                                    self.sr_label_stack = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("next_hop_address",
                                                    "out_label",
                                                    "parent_interface_name",
                                                    "physica_interface_name",
                                                    "tunnel_interface_name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite.P2PTunnelRewrite.PrimaryS2L, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite.P2PTunnelRewrite.PrimaryS2L, self).__setattr__(name, value)


                                class SrLabelStack(Entity):
                                    """
                                    Segment\-Routing labels stack
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite.P2PTunnelRewrite.PrimaryS2L.SrLabelStack, self).__init__()

                                        self.yang_name = "sr-label-stack"
                                        self.yang_parent_name = "primary-s2l"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite.P2PTunnelRewrite.PrimaryS2L.SrLabelStack, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite.P2PTunnelRewrite.PrimaryS2L.SrLabelStack, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "sr-label-stack" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.sr_label_stack:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.next_hop_address.is_set or
                                        self.out_label.is_set or
                                        self.parent_interface_name.is_set or
                                        self.physica_interface_name.is_set or
                                        self.tunnel_interface_name.is_set)

                                def has_operation(self):
                                    for c in self.sr_label_stack:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.next_hop_address.yfilter != YFilter.not_set or
                                        self.out_label.yfilter != YFilter.not_set or
                                        self.parent_interface_name.yfilter != YFilter.not_set or
                                        self.physica_interface_name.yfilter != YFilter.not_set or
                                        self.tunnel_interface_name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "primary-s2l" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.next_hop_address.is_set or self.next_hop_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.next_hop_address.get_name_leafdata())
                                    if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.out_label.get_name_leafdata())
                                    if (self.parent_interface_name.is_set or self.parent_interface_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.parent_interface_name.get_name_leafdata())
                                    if (self.physica_interface_name.is_set or self.physica_interface_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.physica_interface_name.get_name_leafdata())
                                    if (self.tunnel_interface_name.is_set or self.tunnel_interface_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_interface_name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "sr-label-stack"):
                                        for c in self.sr_label_stack:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite.P2PTunnelRewrite.PrimaryS2L.SrLabelStack()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.sr_label_stack.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "sr-label-stack" or name == "next-hop-address" or name == "out-label" or name == "parent-interface-name" or name == "physica-interface-name" or name == "tunnel-interface-name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "next-hop-address"):
                                        self.next_hop_address = value
                                        self.next_hop_address.value_namespace = name_space
                                        self.next_hop_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "out-label"):
                                        self.out_label = value
                                        self.out_label.value_namespace = name_space
                                        self.out_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "parent-interface-name"):
                                        self.parent_interface_name = value
                                        self.parent_interface_name.value_namespace = name_space
                                        self.parent_interface_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "physica-interface-name"):
                                        self.physica_interface_name = value
                                        self.physica_interface_name.value_namespace = name_space
                                        self.physica_interface_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-interface-name"):
                                        self.tunnel_interface_name = value
                                        self.tunnel_interface_name.value_namespace = name_space
                                        self.tunnel_interface_name.value_namespace_prefix = name_space_prefix


                            class BackupTunnelRewrite(Entity):
                                """
                                Properties of the S2L's backup for tunnel
                                rewrite
                                
                                .. attribute:: next_hop_address
                                
                                	Next hop address associated with the entry
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: out_label
                                
                                	Output label associated with the entry
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: parent_interface_name
                                
                                	Interface name of the parent intf
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: physica_interface_name
                                
                                	Physical interface associated with the entry
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: sr_label_stack
                                
                                	Segment\-Routing labels stack
                                	**type**\: list of    :py:class:`SrLabelStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite.P2PTunnelRewrite.BackupTunnelRewrite.SrLabelStack>`
                                
                                .. attribute:: tunnel_interface_name
                                
                                	Interface handle of the associated tunnel
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite.P2PTunnelRewrite.BackupTunnelRewrite, self).__init__()

                                    self.yang_name = "backup-tunnel-rewrite"
                                    self.yang_parent_name = "p2p-tunnel-rewrite"

                                    self.next_hop_address = YLeaf(YType.str, "next-hop-address")

                                    self.out_label = YLeaf(YType.uint32, "out-label")

                                    self.parent_interface_name = YLeaf(YType.str, "parent-interface-name")

                                    self.physica_interface_name = YLeaf(YType.str, "physica-interface-name")

                                    self.tunnel_interface_name = YLeaf(YType.str, "tunnel-interface-name")

                                    self.sr_label_stack = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("next_hop_address",
                                                    "out_label",
                                                    "parent_interface_name",
                                                    "physica_interface_name",
                                                    "tunnel_interface_name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite.P2PTunnelRewrite.BackupTunnelRewrite, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite.P2PTunnelRewrite.BackupTunnelRewrite, self).__setattr__(name, value)


                                class SrLabelStack(Entity):
                                    """
                                    Segment\-Routing labels stack
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite.P2PTunnelRewrite.BackupTunnelRewrite.SrLabelStack, self).__init__()

                                        self.yang_name = "sr-label-stack"
                                        self.yang_parent_name = "backup-tunnel-rewrite"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite.P2PTunnelRewrite.BackupTunnelRewrite.SrLabelStack, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite.P2PTunnelRewrite.BackupTunnelRewrite.SrLabelStack, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "sr-label-stack" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.sr_label_stack:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.next_hop_address.is_set or
                                        self.out_label.is_set or
                                        self.parent_interface_name.is_set or
                                        self.physica_interface_name.is_set or
                                        self.tunnel_interface_name.is_set)

                                def has_operation(self):
                                    for c in self.sr_label_stack:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.next_hop_address.yfilter != YFilter.not_set or
                                        self.out_label.yfilter != YFilter.not_set or
                                        self.parent_interface_name.yfilter != YFilter.not_set or
                                        self.physica_interface_name.yfilter != YFilter.not_set or
                                        self.tunnel_interface_name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "backup-tunnel-rewrite" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.next_hop_address.is_set or self.next_hop_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.next_hop_address.get_name_leafdata())
                                    if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.out_label.get_name_leafdata())
                                    if (self.parent_interface_name.is_set or self.parent_interface_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.parent_interface_name.get_name_leafdata())
                                    if (self.physica_interface_name.is_set or self.physica_interface_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.physica_interface_name.get_name_leafdata())
                                    if (self.tunnel_interface_name.is_set or self.tunnel_interface_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_interface_name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "sr-label-stack"):
                                        for c in self.sr_label_stack:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite.P2PTunnelRewrite.BackupTunnelRewrite.SrLabelStack()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.sr_label_stack.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "sr-label-stack" or name == "next-hop-address" or name == "out-label" or name == "parent-interface-name" or name == "physica-interface-name" or name == "tunnel-interface-name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "next-hop-address"):
                                        self.next_hop_address = value
                                        self.next_hop_address.value_namespace = name_space
                                        self.next_hop_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "out-label"):
                                        self.out_label = value
                                        self.out_label.value_namespace = name_space
                                        self.out_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "parent-interface-name"):
                                        self.parent_interface_name = value
                                        self.parent_interface_name.value_namespace = name_space
                                        self.parent_interface_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "physica-interface-name"):
                                        self.physica_interface_name = value
                                        self.physica_interface_name.value_namespace = name_space
                                        self.physica_interface_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-interface-name"):
                                        self.tunnel_interface_name = value
                                        self.tunnel_interface_name.value_namespace = name_space
                                        self.tunnel_interface_name.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.backup_active.is_set or
                                    self.backup_tunnel_name.is_set or
                                    self.destination_address.is_set or
                                    self.extended_tunnel_id.is_set or
                                    self.local_label.is_set or
                                    self.original_input_interface.is_set or
                                    self.output_interface_name.is_set or
                                    self.previous_hop_address.is_set or
                                    self.source_pe.is_set or
                                    self.tunnel_id.is_set or
                                    (self.backup_tunnel_rewrite is not None and self.backup_tunnel_rewrite.has_data()) or
                                    (self.primary_s2l is not None and self.primary_s2l.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.backup_active.yfilter != YFilter.not_set or
                                    self.backup_tunnel_name.yfilter != YFilter.not_set or
                                    self.destination_address.yfilter != YFilter.not_set or
                                    self.extended_tunnel_id.yfilter != YFilter.not_set or
                                    self.local_label.yfilter != YFilter.not_set or
                                    self.original_input_interface.yfilter != YFilter.not_set or
                                    self.output_interface_name.yfilter != YFilter.not_set or
                                    self.previous_hop_address.yfilter != YFilter.not_set or
                                    self.source_pe.yfilter != YFilter.not_set or
                                    self.tunnel_id.yfilter != YFilter.not_set or
                                    (self.backup_tunnel_rewrite is not None and self.backup_tunnel_rewrite.has_operation()) or
                                    (self.primary_s2l is not None and self.primary_s2l.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "p2p-tunnel-rewrite" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.backup_active.is_set or self.backup_active.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.backup_active.get_name_leafdata())
                                if (self.backup_tunnel_name.is_set or self.backup_tunnel_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.backup_tunnel_name.get_name_leafdata())
                                if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.destination_address.get_name_leafdata())
                                if (self.extended_tunnel_id.is_set or self.extended_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.extended_tunnel_id.get_name_leafdata())
                                if (self.local_label.is_set or self.local_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_label.get_name_leafdata())
                                if (self.original_input_interface.is_set or self.original_input_interface.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.original_input_interface.get_name_leafdata())
                                if (self.output_interface_name.is_set or self.output_interface_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.output_interface_name.get_name_leafdata())
                                if (self.previous_hop_address.is_set or self.previous_hop_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.previous_hop_address.get_name_leafdata())
                                if (self.source_pe.is_set or self.source_pe.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.source_pe.get_name_leafdata())
                                if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_id.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "backup-tunnel-rewrite"):
                                    if (self.backup_tunnel_rewrite is None):
                                        self.backup_tunnel_rewrite = MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite.P2PTunnelRewrite.BackupTunnelRewrite()
                                        self.backup_tunnel_rewrite.parent = self
                                        self._children_name_map["backup_tunnel_rewrite"] = "backup-tunnel-rewrite"
                                    return self.backup_tunnel_rewrite

                                if (child_yang_name == "primary-s2l"):
                                    if (self.primary_s2l is None):
                                        self.primary_s2l = MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite.P2PTunnelRewrite.PrimaryS2L()
                                        self.primary_s2l.parent = self
                                        self._children_name_map["primary_s2l"] = "primary-s2l"
                                    return self.primary_s2l

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "backup-tunnel-rewrite" or name == "primary-s2l" or name == "backup-active" or name == "backup-tunnel-name" or name == "destination-address" or name == "extended-tunnel-id" or name == "local-label" or name == "original-input-interface" or name == "output-interface-name" or name == "previous-hop-address" or name == "source-pe" or name == "tunnel-id"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "backup-active"):
                                    self.backup_active = value
                                    self.backup_active.value_namespace = name_space
                                    self.backup_active.value_namespace_prefix = name_space_prefix
                                if(value_path == "backup-tunnel-name"):
                                    self.backup_tunnel_name = value
                                    self.backup_tunnel_name.value_namespace = name_space
                                    self.backup_tunnel_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "destination-address"):
                                    self.destination_address = value
                                    self.destination_address.value_namespace = name_space
                                    self.destination_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "extended-tunnel-id"):
                                    self.extended_tunnel_id = value
                                    self.extended_tunnel_id.value_namespace = name_space
                                    self.extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "local-label"):
                                    self.local_label = value
                                    self.local_label.value_namespace = name_space
                                    self.local_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "original-input-interface"):
                                    self.original_input_interface = value
                                    self.original_input_interface.value_namespace = name_space
                                    self.original_input_interface.value_namespace_prefix = name_space_prefix
                                if(value_path == "output-interface-name"):
                                    self.output_interface_name = value
                                    self.output_interface_name.value_namespace = name_space
                                    self.output_interface_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "previous-hop-address"):
                                    self.previous_hop_address = value
                                    self.previous_hop_address.value_namespace = name_space
                                    self.previous_hop_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "source-pe"):
                                    self.source_pe = value
                                    self.source_pe.value_namespace = name_space
                                    self.source_pe.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-id"):
                                    self.tunnel_id = value
                                    self.tunnel_id.value_namespace = name_space
                                    self.tunnel_id.value_namespace_prefix = name_space_prefix


                        class P2MpTunnelRewrite(Entity):
                            """
                            Tunnel rewrite data specific to P2MP
                            
                            .. attribute:: local_label
                            
                            	Local Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite.P2MpTunnelRewrite, self).__init__()

                                self.yang_name = "p2mp-tunnel-rewrite"
                                self.yang_parent_name = "tunnel-rewrite"

                                self.local_label = YLeaf(YType.uint32, "local-label")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("local_label") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite.P2MpTunnelRewrite, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite.P2MpTunnelRewrite, self).__setattr__(name, value)

                            def has_data(self):
                                return self.local_label.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.local_label.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "p2mp-tunnel-rewrite" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.local_label.is_set or self.local_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_label.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "local-label"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "local-label"):
                                    self.local_label = value
                                    self.local_label.value_namespace = name_space
                                    self.local_label.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.fec_ctype.is_set or
                                (self.p2mp_tunnel_rewrite is not None and self.p2mp_tunnel_rewrite.has_data()) or
                                (self.p2p_tunnel_rewrite is not None and self.p2p_tunnel_rewrite.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.fec_ctype.yfilter != YFilter.not_set or
                                (self.p2mp_tunnel_rewrite is not None and self.p2mp_tunnel_rewrite.has_operation()) or
                                (self.p2p_tunnel_rewrite is not None and self.p2p_tunnel_rewrite.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "tunnel-rewrite" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_ctype.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "p2mp-tunnel-rewrite"):
                                if (self.p2mp_tunnel_rewrite is None):
                                    self.p2mp_tunnel_rewrite = MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite.P2MpTunnelRewrite()
                                    self.p2mp_tunnel_rewrite.parent = self
                                    self._children_name_map["p2mp_tunnel_rewrite"] = "p2mp-tunnel-rewrite"
                                return self.p2mp_tunnel_rewrite

                            if (child_yang_name == "p2p-tunnel-rewrite"):
                                if (self.p2p_tunnel_rewrite is None):
                                    self.p2p_tunnel_rewrite = MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite.P2PTunnelRewrite()
                                    self.p2p_tunnel_rewrite.parent = self
                                    self._children_name_map["p2p_tunnel_rewrite"] = "p2p-tunnel-rewrite"
                                return self.p2p_tunnel_rewrite

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "p2mp-tunnel-rewrite" or name == "p2p-tunnel-rewrite" or name == "fec-ctype"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "fec-ctype"):
                                self.fec_ctype = value
                                self.fec_ctype.value_namespace = name_space
                                self.fec_ctype.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.timestamp.is_set or
                            (self.tunnel_rewrite is not None and self.tunnel_rewrite.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.timestamp.yfilter != YFilter.not_set or
                            (self.tunnel_rewrite is not None and self.tunnel_rewrite.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "successful-rewrite" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.timestamp.is_set or self.timestamp.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.timestamp.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "tunnel-rewrite"):
                            if (self.tunnel_rewrite is None):
                                self.tunnel_rewrite = MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite.TunnelRewrite()
                                self.tunnel_rewrite.parent = self
                                self._children_name_map["tunnel_rewrite"] = "tunnel-rewrite"
                            return self.tunnel_rewrite

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "tunnel-rewrite" or name == "timestamp"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "timestamp"):
                            self.timestamp = value
                            self.timestamp.value_namespace = name_space
                            self.timestamp.value_namespace_prefix = name_space_prefix


                class FailedRewrite(Entity):
                    """
                    Failed rewrite details
                    
                    .. attribute:: timestamp
                    
                    	Time stamp of the entry
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tunnel_rewrite
                    
                    	Union of p2p and p2mp tun rewrite data
                    	**type**\:   :py:class:`TunnelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite, self).__init__()

                        self.yang_name = "failed-rewrite"
                        self.yang_parent_name = "tunnel-rewrite"

                        self.timestamp = YLeaf(YType.uint32, "timestamp")

                        self.tunnel_rewrite = MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite()
                        self.tunnel_rewrite.parent = self
                        self._children_name_map["tunnel_rewrite"] = "tunnel-rewrite"
                        self._children_yang_names.add("tunnel-rewrite")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("timestamp") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite, self).__setattr__(name, value)


                    class TunnelRewrite(Entity):
                        """
                        Union of p2p and p2mp tun rewrite data
                        
                        .. attribute:: fec_ctype
                        
                        	FEC CType
                        	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                        
                        .. attribute:: p2mp_tunnel_rewrite
                        
                        	Tunnel rewrite data specific to P2MP
                        	**type**\:   :py:class:`P2MpTunnelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite.P2MpTunnelRewrite>`
                        
                        .. attribute:: p2p_tunnel_rewrite
                        
                        	Tunnel rewrite data specific to P2P
                        	**type**\:   :py:class:`P2PTunnelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite.P2PTunnelRewrite>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite, self).__init__()

                            self.yang_name = "tunnel-rewrite"
                            self.yang_parent_name = "failed-rewrite"

                            self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                            self.p2mp_tunnel_rewrite = MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite.P2MpTunnelRewrite()
                            self.p2mp_tunnel_rewrite.parent = self
                            self._children_name_map["p2mp_tunnel_rewrite"] = "p2mp-tunnel-rewrite"
                            self._children_yang_names.add("p2mp-tunnel-rewrite")

                            self.p2p_tunnel_rewrite = MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite.P2PTunnelRewrite()
                            self.p2p_tunnel_rewrite.parent = self
                            self._children_name_map["p2p_tunnel_rewrite"] = "p2p-tunnel-rewrite"
                            self._children_yang_names.add("p2p-tunnel-rewrite")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("fec_ctype") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite, self).__setattr__(name, value)


                        class P2PTunnelRewrite(Entity):
                            """
                            Tunnel rewrite data specific to P2P
                            
                            .. attribute:: backup_active
                            
                            	FRR is active on the backup tunnel
                            	**type**\:  bool
                            
                            .. attribute:: backup_tunnel_name
                            
                            	Backup tunnel name
                            	**type**\:  str
                            
                            .. attribute:: backup_tunnel_rewrite
                            
                            	Properties of the S2L's backup for tunnel rewrite
                            	**type**\:   :py:class:`BackupTunnelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite.P2PTunnelRewrite.BackupTunnelRewrite>`
                            
                            .. attribute:: destination_address
                            
                            	Destination
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: extended_tunnel_id
                            
                            	Extended Tunnel ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: local_label
                            
                            	Local label of the tunnel rewrite
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: original_input_interface
                            
                            	Input interface of the S2Ls
                            	**type**\:  str
                            
                            .. attribute:: output_interface_name
                            
                            	The output interface of the S2Ls
                            	**type**\:  str
                            
                            .. attribute:: previous_hop_address
                            
                            	Previous hop
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: primary_s2l
                            
                            	Properties of the primary S2L of tunnel rewrite
                            	**type**\:   :py:class:`PrimaryS2L <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite.P2PTunnelRewrite.PrimaryS2L>`
                            
                            .. attribute:: source_pe
                            
                            	source address of the tunnel
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: tunnel_id
                            
                            	Tunnel ID for this rewrite data
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite.P2PTunnelRewrite, self).__init__()

                                self.yang_name = "p2p-tunnel-rewrite"
                                self.yang_parent_name = "tunnel-rewrite"

                                self.backup_active = YLeaf(YType.boolean, "backup-active")

                                self.backup_tunnel_name = YLeaf(YType.str, "backup-tunnel-name")

                                self.destination_address = YLeaf(YType.str, "destination-address")

                                self.extended_tunnel_id = YLeaf(YType.str, "extended-tunnel-id")

                                self.local_label = YLeaf(YType.uint32, "local-label")

                                self.original_input_interface = YLeaf(YType.str, "original-input-interface")

                                self.output_interface_name = YLeaf(YType.str, "output-interface-name")

                                self.previous_hop_address = YLeaf(YType.str, "previous-hop-address")

                                self.source_pe = YLeaf(YType.str, "source-pe")

                                self.tunnel_id = YLeaf(YType.uint16, "tunnel-id")

                                self.backup_tunnel_rewrite = MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite.P2PTunnelRewrite.BackupTunnelRewrite()
                                self.backup_tunnel_rewrite.parent = self
                                self._children_name_map["backup_tunnel_rewrite"] = "backup-tunnel-rewrite"
                                self._children_yang_names.add("backup-tunnel-rewrite")

                                self.primary_s2l = MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite.P2PTunnelRewrite.PrimaryS2L()
                                self.primary_s2l.parent = self
                                self._children_name_map["primary_s2l"] = "primary-s2l"
                                self._children_yang_names.add("primary-s2l")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("backup_active",
                                                "backup_tunnel_name",
                                                "destination_address",
                                                "extended_tunnel_id",
                                                "local_label",
                                                "original_input_interface",
                                                "output_interface_name",
                                                "previous_hop_address",
                                                "source_pe",
                                                "tunnel_id") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite.P2PTunnelRewrite, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite.P2PTunnelRewrite, self).__setattr__(name, value)


                            class PrimaryS2L(Entity):
                                """
                                Properties of the primary S2L of tunnel rewrite
                                
                                .. attribute:: next_hop_address
                                
                                	Next hop address associated with the entry
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: out_label
                                
                                	Output label associated with the entry
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: parent_interface_name
                                
                                	Interface name of the parent intf
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: physica_interface_name
                                
                                	Physical interface associated with the entry
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: sr_label_stack
                                
                                	Segment\-Routing labels stack
                                	**type**\: list of    :py:class:`SrLabelStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite.P2PTunnelRewrite.PrimaryS2L.SrLabelStack>`
                                
                                .. attribute:: tunnel_interface_name
                                
                                	Interface handle of the associated tunnel
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite.P2PTunnelRewrite.PrimaryS2L, self).__init__()

                                    self.yang_name = "primary-s2l"
                                    self.yang_parent_name = "p2p-tunnel-rewrite"

                                    self.next_hop_address = YLeaf(YType.str, "next-hop-address")

                                    self.out_label = YLeaf(YType.uint32, "out-label")

                                    self.parent_interface_name = YLeaf(YType.str, "parent-interface-name")

                                    self.physica_interface_name = YLeaf(YType.str, "physica-interface-name")

                                    self.tunnel_interface_name = YLeaf(YType.str, "tunnel-interface-name")

                                    self.sr_label_stack = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("next_hop_address",
                                                    "out_label",
                                                    "parent_interface_name",
                                                    "physica_interface_name",
                                                    "tunnel_interface_name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite.P2PTunnelRewrite.PrimaryS2L, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite.P2PTunnelRewrite.PrimaryS2L, self).__setattr__(name, value)


                                class SrLabelStack(Entity):
                                    """
                                    Segment\-Routing labels stack
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite.P2PTunnelRewrite.PrimaryS2L.SrLabelStack, self).__init__()

                                        self.yang_name = "sr-label-stack"
                                        self.yang_parent_name = "primary-s2l"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite.P2PTunnelRewrite.PrimaryS2L.SrLabelStack, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite.P2PTunnelRewrite.PrimaryS2L.SrLabelStack, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "sr-label-stack" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.sr_label_stack:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.next_hop_address.is_set or
                                        self.out_label.is_set or
                                        self.parent_interface_name.is_set or
                                        self.physica_interface_name.is_set or
                                        self.tunnel_interface_name.is_set)

                                def has_operation(self):
                                    for c in self.sr_label_stack:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.next_hop_address.yfilter != YFilter.not_set or
                                        self.out_label.yfilter != YFilter.not_set or
                                        self.parent_interface_name.yfilter != YFilter.not_set or
                                        self.physica_interface_name.yfilter != YFilter.not_set or
                                        self.tunnel_interface_name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "primary-s2l" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.next_hop_address.is_set or self.next_hop_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.next_hop_address.get_name_leafdata())
                                    if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.out_label.get_name_leafdata())
                                    if (self.parent_interface_name.is_set or self.parent_interface_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.parent_interface_name.get_name_leafdata())
                                    if (self.physica_interface_name.is_set or self.physica_interface_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.physica_interface_name.get_name_leafdata())
                                    if (self.tunnel_interface_name.is_set or self.tunnel_interface_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_interface_name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "sr-label-stack"):
                                        for c in self.sr_label_stack:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite.P2PTunnelRewrite.PrimaryS2L.SrLabelStack()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.sr_label_stack.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "sr-label-stack" or name == "next-hop-address" or name == "out-label" or name == "parent-interface-name" or name == "physica-interface-name" or name == "tunnel-interface-name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "next-hop-address"):
                                        self.next_hop_address = value
                                        self.next_hop_address.value_namespace = name_space
                                        self.next_hop_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "out-label"):
                                        self.out_label = value
                                        self.out_label.value_namespace = name_space
                                        self.out_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "parent-interface-name"):
                                        self.parent_interface_name = value
                                        self.parent_interface_name.value_namespace = name_space
                                        self.parent_interface_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "physica-interface-name"):
                                        self.physica_interface_name = value
                                        self.physica_interface_name.value_namespace = name_space
                                        self.physica_interface_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-interface-name"):
                                        self.tunnel_interface_name = value
                                        self.tunnel_interface_name.value_namespace = name_space
                                        self.tunnel_interface_name.value_namespace_prefix = name_space_prefix


                            class BackupTunnelRewrite(Entity):
                                """
                                Properties of the S2L's backup for tunnel
                                rewrite
                                
                                .. attribute:: next_hop_address
                                
                                	Next hop address associated with the entry
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: out_label
                                
                                	Output label associated with the entry
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: parent_interface_name
                                
                                	Interface name of the parent intf
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: physica_interface_name
                                
                                	Physical interface associated with the entry
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: sr_label_stack
                                
                                	Segment\-Routing labels stack
                                	**type**\: list of    :py:class:`SrLabelStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite.P2PTunnelRewrite.BackupTunnelRewrite.SrLabelStack>`
                                
                                .. attribute:: tunnel_interface_name
                                
                                	Interface handle of the associated tunnel
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite.P2PTunnelRewrite.BackupTunnelRewrite, self).__init__()

                                    self.yang_name = "backup-tunnel-rewrite"
                                    self.yang_parent_name = "p2p-tunnel-rewrite"

                                    self.next_hop_address = YLeaf(YType.str, "next-hop-address")

                                    self.out_label = YLeaf(YType.uint32, "out-label")

                                    self.parent_interface_name = YLeaf(YType.str, "parent-interface-name")

                                    self.physica_interface_name = YLeaf(YType.str, "physica-interface-name")

                                    self.tunnel_interface_name = YLeaf(YType.str, "tunnel-interface-name")

                                    self.sr_label_stack = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("next_hop_address",
                                                    "out_label",
                                                    "parent_interface_name",
                                                    "physica_interface_name",
                                                    "tunnel_interface_name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite.P2PTunnelRewrite.BackupTunnelRewrite, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite.P2PTunnelRewrite.BackupTunnelRewrite, self).__setattr__(name, value)


                                class SrLabelStack(Entity):
                                    """
                                    Segment\-Routing labels stack
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite.P2PTunnelRewrite.BackupTunnelRewrite.SrLabelStack, self).__init__()

                                        self.yang_name = "sr-label-stack"
                                        self.yang_parent_name = "backup-tunnel-rewrite"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite.P2PTunnelRewrite.BackupTunnelRewrite.SrLabelStack, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite.P2PTunnelRewrite.BackupTunnelRewrite.SrLabelStack, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "sr-label-stack" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.sr_label_stack:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.next_hop_address.is_set or
                                        self.out_label.is_set or
                                        self.parent_interface_name.is_set or
                                        self.physica_interface_name.is_set or
                                        self.tunnel_interface_name.is_set)

                                def has_operation(self):
                                    for c in self.sr_label_stack:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.next_hop_address.yfilter != YFilter.not_set or
                                        self.out_label.yfilter != YFilter.not_set or
                                        self.parent_interface_name.yfilter != YFilter.not_set or
                                        self.physica_interface_name.yfilter != YFilter.not_set or
                                        self.tunnel_interface_name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "backup-tunnel-rewrite" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.next_hop_address.is_set or self.next_hop_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.next_hop_address.get_name_leafdata())
                                    if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.out_label.get_name_leafdata())
                                    if (self.parent_interface_name.is_set or self.parent_interface_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.parent_interface_name.get_name_leafdata())
                                    if (self.physica_interface_name.is_set or self.physica_interface_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.physica_interface_name.get_name_leafdata())
                                    if (self.tunnel_interface_name.is_set or self.tunnel_interface_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_interface_name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "sr-label-stack"):
                                        for c in self.sr_label_stack:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite.P2PTunnelRewrite.BackupTunnelRewrite.SrLabelStack()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.sr_label_stack.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "sr-label-stack" or name == "next-hop-address" or name == "out-label" or name == "parent-interface-name" or name == "physica-interface-name" or name == "tunnel-interface-name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "next-hop-address"):
                                        self.next_hop_address = value
                                        self.next_hop_address.value_namespace = name_space
                                        self.next_hop_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "out-label"):
                                        self.out_label = value
                                        self.out_label.value_namespace = name_space
                                        self.out_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "parent-interface-name"):
                                        self.parent_interface_name = value
                                        self.parent_interface_name.value_namespace = name_space
                                        self.parent_interface_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "physica-interface-name"):
                                        self.physica_interface_name = value
                                        self.physica_interface_name.value_namespace = name_space
                                        self.physica_interface_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-interface-name"):
                                        self.tunnel_interface_name = value
                                        self.tunnel_interface_name.value_namespace = name_space
                                        self.tunnel_interface_name.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.backup_active.is_set or
                                    self.backup_tunnel_name.is_set or
                                    self.destination_address.is_set or
                                    self.extended_tunnel_id.is_set or
                                    self.local_label.is_set or
                                    self.original_input_interface.is_set or
                                    self.output_interface_name.is_set or
                                    self.previous_hop_address.is_set or
                                    self.source_pe.is_set or
                                    self.tunnel_id.is_set or
                                    (self.backup_tunnel_rewrite is not None and self.backup_tunnel_rewrite.has_data()) or
                                    (self.primary_s2l is not None and self.primary_s2l.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.backup_active.yfilter != YFilter.not_set or
                                    self.backup_tunnel_name.yfilter != YFilter.not_set or
                                    self.destination_address.yfilter != YFilter.not_set or
                                    self.extended_tunnel_id.yfilter != YFilter.not_set or
                                    self.local_label.yfilter != YFilter.not_set or
                                    self.original_input_interface.yfilter != YFilter.not_set or
                                    self.output_interface_name.yfilter != YFilter.not_set or
                                    self.previous_hop_address.yfilter != YFilter.not_set or
                                    self.source_pe.yfilter != YFilter.not_set or
                                    self.tunnel_id.yfilter != YFilter.not_set or
                                    (self.backup_tunnel_rewrite is not None and self.backup_tunnel_rewrite.has_operation()) or
                                    (self.primary_s2l is not None and self.primary_s2l.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "p2p-tunnel-rewrite" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.backup_active.is_set or self.backup_active.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.backup_active.get_name_leafdata())
                                if (self.backup_tunnel_name.is_set or self.backup_tunnel_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.backup_tunnel_name.get_name_leafdata())
                                if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.destination_address.get_name_leafdata())
                                if (self.extended_tunnel_id.is_set or self.extended_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.extended_tunnel_id.get_name_leafdata())
                                if (self.local_label.is_set or self.local_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_label.get_name_leafdata())
                                if (self.original_input_interface.is_set or self.original_input_interface.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.original_input_interface.get_name_leafdata())
                                if (self.output_interface_name.is_set or self.output_interface_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.output_interface_name.get_name_leafdata())
                                if (self.previous_hop_address.is_set or self.previous_hop_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.previous_hop_address.get_name_leafdata())
                                if (self.source_pe.is_set or self.source_pe.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.source_pe.get_name_leafdata())
                                if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_id.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "backup-tunnel-rewrite"):
                                    if (self.backup_tunnel_rewrite is None):
                                        self.backup_tunnel_rewrite = MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite.P2PTunnelRewrite.BackupTunnelRewrite()
                                        self.backup_tunnel_rewrite.parent = self
                                        self._children_name_map["backup_tunnel_rewrite"] = "backup-tunnel-rewrite"
                                    return self.backup_tunnel_rewrite

                                if (child_yang_name == "primary-s2l"):
                                    if (self.primary_s2l is None):
                                        self.primary_s2l = MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite.P2PTunnelRewrite.PrimaryS2L()
                                        self.primary_s2l.parent = self
                                        self._children_name_map["primary_s2l"] = "primary-s2l"
                                    return self.primary_s2l

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "backup-tunnel-rewrite" or name == "primary-s2l" or name == "backup-active" or name == "backup-tunnel-name" or name == "destination-address" or name == "extended-tunnel-id" or name == "local-label" or name == "original-input-interface" or name == "output-interface-name" or name == "previous-hop-address" or name == "source-pe" or name == "tunnel-id"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "backup-active"):
                                    self.backup_active = value
                                    self.backup_active.value_namespace = name_space
                                    self.backup_active.value_namespace_prefix = name_space_prefix
                                if(value_path == "backup-tunnel-name"):
                                    self.backup_tunnel_name = value
                                    self.backup_tunnel_name.value_namespace = name_space
                                    self.backup_tunnel_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "destination-address"):
                                    self.destination_address = value
                                    self.destination_address.value_namespace = name_space
                                    self.destination_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "extended-tunnel-id"):
                                    self.extended_tunnel_id = value
                                    self.extended_tunnel_id.value_namespace = name_space
                                    self.extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "local-label"):
                                    self.local_label = value
                                    self.local_label.value_namespace = name_space
                                    self.local_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "original-input-interface"):
                                    self.original_input_interface = value
                                    self.original_input_interface.value_namespace = name_space
                                    self.original_input_interface.value_namespace_prefix = name_space_prefix
                                if(value_path == "output-interface-name"):
                                    self.output_interface_name = value
                                    self.output_interface_name.value_namespace = name_space
                                    self.output_interface_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "previous-hop-address"):
                                    self.previous_hop_address = value
                                    self.previous_hop_address.value_namespace = name_space
                                    self.previous_hop_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "source-pe"):
                                    self.source_pe = value
                                    self.source_pe.value_namespace = name_space
                                    self.source_pe.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-id"):
                                    self.tunnel_id = value
                                    self.tunnel_id.value_namespace = name_space
                                    self.tunnel_id.value_namespace_prefix = name_space_prefix


                        class P2MpTunnelRewrite(Entity):
                            """
                            Tunnel rewrite data specific to P2MP
                            
                            .. attribute:: local_label
                            
                            	Local Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite.P2MpTunnelRewrite, self).__init__()

                                self.yang_name = "p2mp-tunnel-rewrite"
                                self.yang_parent_name = "tunnel-rewrite"

                                self.local_label = YLeaf(YType.uint32, "local-label")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("local_label") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite.P2MpTunnelRewrite, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite.P2MpTunnelRewrite, self).__setattr__(name, value)

                            def has_data(self):
                                return self.local_label.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.local_label.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "p2mp-tunnel-rewrite" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.local_label.is_set or self.local_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_label.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "local-label"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "local-label"):
                                    self.local_label = value
                                    self.local_label.value_namespace = name_space
                                    self.local_label.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.fec_ctype.is_set or
                                (self.p2mp_tunnel_rewrite is not None and self.p2mp_tunnel_rewrite.has_data()) or
                                (self.p2p_tunnel_rewrite is not None and self.p2p_tunnel_rewrite.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.fec_ctype.yfilter != YFilter.not_set or
                                (self.p2mp_tunnel_rewrite is not None and self.p2mp_tunnel_rewrite.has_operation()) or
                                (self.p2p_tunnel_rewrite is not None and self.p2p_tunnel_rewrite.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "tunnel-rewrite" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_ctype.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "p2mp-tunnel-rewrite"):
                                if (self.p2mp_tunnel_rewrite is None):
                                    self.p2mp_tunnel_rewrite = MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite.P2MpTunnelRewrite()
                                    self.p2mp_tunnel_rewrite.parent = self
                                    self._children_name_map["p2mp_tunnel_rewrite"] = "p2mp-tunnel-rewrite"
                                return self.p2mp_tunnel_rewrite

                            if (child_yang_name == "p2p-tunnel-rewrite"):
                                if (self.p2p_tunnel_rewrite is None):
                                    self.p2p_tunnel_rewrite = MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite.P2PTunnelRewrite()
                                    self.p2p_tunnel_rewrite.parent = self
                                    self._children_name_map["p2p_tunnel_rewrite"] = "p2p-tunnel-rewrite"
                                return self.p2p_tunnel_rewrite

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "p2mp-tunnel-rewrite" or name == "p2p-tunnel-rewrite" or name == "fec-ctype"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "fec-ctype"):
                                self.fec_ctype = value
                                self.fec_ctype.value_namespace = name_space
                                self.fec_ctype.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.timestamp.is_set or
                            (self.tunnel_rewrite is not None and self.tunnel_rewrite.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.timestamp.yfilter != YFilter.not_set or
                            (self.tunnel_rewrite is not None and self.tunnel_rewrite.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "failed-rewrite" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.timestamp.is_set or self.timestamp.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.timestamp.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "tunnel-rewrite"):
                            if (self.tunnel_rewrite is None):
                                self.tunnel_rewrite = MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite.TunnelRewrite()
                                self.tunnel_rewrite.parent = self
                                self._children_name_map["tunnel_rewrite"] = "tunnel-rewrite"
                            return self.tunnel_rewrite

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "tunnel-rewrite" or name == "timestamp"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "timestamp"):
                            self.timestamp = value
                            self.timestamp.value_namespace = name_space
                            self.timestamp.value_namespace_prefix = name_space_prefix


                class PendingRewrite(Entity):
                    """
                    Pending rewrite details
                    
                    .. attribute:: timestamp
                    
                    	Time stamp of the entry
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: tunnel_rewrite
                    
                    	Union of p2p and p2mp tun rewrite data
                    	**type**\:   :py:class:`TunnelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite, self).__init__()

                        self.yang_name = "pending-rewrite"
                        self.yang_parent_name = "tunnel-rewrite"

                        self.timestamp = YLeaf(YType.uint32, "timestamp")

                        self.tunnel_rewrite = MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite()
                        self.tunnel_rewrite.parent = self
                        self._children_name_map["tunnel_rewrite"] = "tunnel-rewrite"
                        self._children_yang_names.add("tunnel-rewrite")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("timestamp") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite, self).__setattr__(name, value)


                    class TunnelRewrite(Entity):
                        """
                        Union of p2p and p2mp tun rewrite data
                        
                        .. attribute:: fec_ctype
                        
                        	FEC CType
                        	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                        
                        .. attribute:: p2mp_tunnel_rewrite
                        
                        	Tunnel rewrite data specific to P2MP
                        	**type**\:   :py:class:`P2MpTunnelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite.P2MpTunnelRewrite>`
                        
                        .. attribute:: p2p_tunnel_rewrite
                        
                        	Tunnel rewrite data specific to P2P
                        	**type**\:   :py:class:`P2PTunnelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite.P2PTunnelRewrite>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite, self).__init__()

                            self.yang_name = "tunnel-rewrite"
                            self.yang_parent_name = "pending-rewrite"

                            self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                            self.p2mp_tunnel_rewrite = MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite.P2MpTunnelRewrite()
                            self.p2mp_tunnel_rewrite.parent = self
                            self._children_name_map["p2mp_tunnel_rewrite"] = "p2mp-tunnel-rewrite"
                            self._children_yang_names.add("p2mp-tunnel-rewrite")

                            self.p2p_tunnel_rewrite = MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite.P2PTunnelRewrite()
                            self.p2p_tunnel_rewrite.parent = self
                            self._children_name_map["p2p_tunnel_rewrite"] = "p2p-tunnel-rewrite"
                            self._children_yang_names.add("p2p-tunnel-rewrite")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("fec_ctype") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite, self).__setattr__(name, value)


                        class P2PTunnelRewrite(Entity):
                            """
                            Tunnel rewrite data specific to P2P
                            
                            .. attribute:: backup_active
                            
                            	FRR is active on the backup tunnel
                            	**type**\:  bool
                            
                            .. attribute:: backup_tunnel_name
                            
                            	Backup tunnel name
                            	**type**\:  str
                            
                            .. attribute:: backup_tunnel_rewrite
                            
                            	Properties of the S2L's backup for tunnel rewrite
                            	**type**\:   :py:class:`BackupTunnelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite.P2PTunnelRewrite.BackupTunnelRewrite>`
                            
                            .. attribute:: destination_address
                            
                            	Destination
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: extended_tunnel_id
                            
                            	Extended Tunnel ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: local_label
                            
                            	Local label of the tunnel rewrite
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: original_input_interface
                            
                            	Input interface of the S2Ls
                            	**type**\:  str
                            
                            .. attribute:: output_interface_name
                            
                            	The output interface of the S2Ls
                            	**type**\:  str
                            
                            .. attribute:: previous_hop_address
                            
                            	Previous hop
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: primary_s2l
                            
                            	Properties of the primary S2L of tunnel rewrite
                            	**type**\:   :py:class:`PrimaryS2L <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite.P2PTunnelRewrite.PrimaryS2L>`
                            
                            .. attribute:: source_pe
                            
                            	source address of the tunnel
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: tunnel_id
                            
                            	Tunnel ID for this rewrite data
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite.P2PTunnelRewrite, self).__init__()

                                self.yang_name = "p2p-tunnel-rewrite"
                                self.yang_parent_name = "tunnel-rewrite"

                                self.backup_active = YLeaf(YType.boolean, "backup-active")

                                self.backup_tunnel_name = YLeaf(YType.str, "backup-tunnel-name")

                                self.destination_address = YLeaf(YType.str, "destination-address")

                                self.extended_tunnel_id = YLeaf(YType.str, "extended-tunnel-id")

                                self.local_label = YLeaf(YType.uint32, "local-label")

                                self.original_input_interface = YLeaf(YType.str, "original-input-interface")

                                self.output_interface_name = YLeaf(YType.str, "output-interface-name")

                                self.previous_hop_address = YLeaf(YType.str, "previous-hop-address")

                                self.source_pe = YLeaf(YType.str, "source-pe")

                                self.tunnel_id = YLeaf(YType.uint16, "tunnel-id")

                                self.backup_tunnel_rewrite = MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite.P2PTunnelRewrite.BackupTunnelRewrite()
                                self.backup_tunnel_rewrite.parent = self
                                self._children_name_map["backup_tunnel_rewrite"] = "backup-tunnel-rewrite"
                                self._children_yang_names.add("backup-tunnel-rewrite")

                                self.primary_s2l = MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite.P2PTunnelRewrite.PrimaryS2L()
                                self.primary_s2l.parent = self
                                self._children_name_map["primary_s2l"] = "primary-s2l"
                                self._children_yang_names.add("primary-s2l")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("backup_active",
                                                "backup_tunnel_name",
                                                "destination_address",
                                                "extended_tunnel_id",
                                                "local_label",
                                                "original_input_interface",
                                                "output_interface_name",
                                                "previous_hop_address",
                                                "source_pe",
                                                "tunnel_id") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite.P2PTunnelRewrite, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite.P2PTunnelRewrite, self).__setattr__(name, value)


                            class PrimaryS2L(Entity):
                                """
                                Properties of the primary S2L of tunnel rewrite
                                
                                .. attribute:: next_hop_address
                                
                                	Next hop address associated with the entry
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: out_label
                                
                                	Output label associated with the entry
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: parent_interface_name
                                
                                	Interface name of the parent intf
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: physica_interface_name
                                
                                	Physical interface associated with the entry
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: sr_label_stack
                                
                                	Segment\-Routing labels stack
                                	**type**\: list of    :py:class:`SrLabelStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite.P2PTunnelRewrite.PrimaryS2L.SrLabelStack>`
                                
                                .. attribute:: tunnel_interface_name
                                
                                	Interface handle of the associated tunnel
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite.P2PTunnelRewrite.PrimaryS2L, self).__init__()

                                    self.yang_name = "primary-s2l"
                                    self.yang_parent_name = "p2p-tunnel-rewrite"

                                    self.next_hop_address = YLeaf(YType.str, "next-hop-address")

                                    self.out_label = YLeaf(YType.uint32, "out-label")

                                    self.parent_interface_name = YLeaf(YType.str, "parent-interface-name")

                                    self.physica_interface_name = YLeaf(YType.str, "physica-interface-name")

                                    self.tunnel_interface_name = YLeaf(YType.str, "tunnel-interface-name")

                                    self.sr_label_stack = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("next_hop_address",
                                                    "out_label",
                                                    "parent_interface_name",
                                                    "physica_interface_name",
                                                    "tunnel_interface_name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite.P2PTunnelRewrite.PrimaryS2L, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite.P2PTunnelRewrite.PrimaryS2L, self).__setattr__(name, value)


                                class SrLabelStack(Entity):
                                    """
                                    Segment\-Routing labels stack
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite.P2PTunnelRewrite.PrimaryS2L.SrLabelStack, self).__init__()

                                        self.yang_name = "sr-label-stack"
                                        self.yang_parent_name = "primary-s2l"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite.P2PTunnelRewrite.PrimaryS2L.SrLabelStack, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite.P2PTunnelRewrite.PrimaryS2L.SrLabelStack, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "sr-label-stack" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.sr_label_stack:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.next_hop_address.is_set or
                                        self.out_label.is_set or
                                        self.parent_interface_name.is_set or
                                        self.physica_interface_name.is_set or
                                        self.tunnel_interface_name.is_set)

                                def has_operation(self):
                                    for c in self.sr_label_stack:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.next_hop_address.yfilter != YFilter.not_set or
                                        self.out_label.yfilter != YFilter.not_set or
                                        self.parent_interface_name.yfilter != YFilter.not_set or
                                        self.physica_interface_name.yfilter != YFilter.not_set or
                                        self.tunnel_interface_name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "primary-s2l" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.next_hop_address.is_set or self.next_hop_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.next_hop_address.get_name_leafdata())
                                    if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.out_label.get_name_leafdata())
                                    if (self.parent_interface_name.is_set or self.parent_interface_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.parent_interface_name.get_name_leafdata())
                                    if (self.physica_interface_name.is_set or self.physica_interface_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.physica_interface_name.get_name_leafdata())
                                    if (self.tunnel_interface_name.is_set or self.tunnel_interface_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_interface_name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "sr-label-stack"):
                                        for c in self.sr_label_stack:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite.P2PTunnelRewrite.PrimaryS2L.SrLabelStack()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.sr_label_stack.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "sr-label-stack" or name == "next-hop-address" or name == "out-label" or name == "parent-interface-name" or name == "physica-interface-name" or name == "tunnel-interface-name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "next-hop-address"):
                                        self.next_hop_address = value
                                        self.next_hop_address.value_namespace = name_space
                                        self.next_hop_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "out-label"):
                                        self.out_label = value
                                        self.out_label.value_namespace = name_space
                                        self.out_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "parent-interface-name"):
                                        self.parent_interface_name = value
                                        self.parent_interface_name.value_namespace = name_space
                                        self.parent_interface_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "physica-interface-name"):
                                        self.physica_interface_name = value
                                        self.physica_interface_name.value_namespace = name_space
                                        self.physica_interface_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-interface-name"):
                                        self.tunnel_interface_name = value
                                        self.tunnel_interface_name.value_namespace = name_space
                                        self.tunnel_interface_name.value_namespace_prefix = name_space_prefix


                            class BackupTunnelRewrite(Entity):
                                """
                                Properties of the S2L's backup for tunnel
                                rewrite
                                
                                .. attribute:: next_hop_address
                                
                                	Next hop address associated with the entry
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                .. attribute:: out_label
                                
                                	Output label associated with the entry
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: parent_interface_name
                                
                                	Interface name of the parent intf
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: physica_interface_name
                                
                                	Physical interface associated with the entry
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                .. attribute:: sr_label_stack
                                
                                	Segment\-Routing labels stack
                                	**type**\: list of    :py:class:`SrLabelStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite.P2PTunnelRewrite.BackupTunnelRewrite.SrLabelStack>`
                                
                                .. attribute:: tunnel_interface_name
                                
                                	Interface handle of the associated tunnel
                                	**type**\:  str
                                
                                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite.P2PTunnelRewrite.BackupTunnelRewrite, self).__init__()

                                    self.yang_name = "backup-tunnel-rewrite"
                                    self.yang_parent_name = "p2p-tunnel-rewrite"

                                    self.next_hop_address = YLeaf(YType.str, "next-hop-address")

                                    self.out_label = YLeaf(YType.uint32, "out-label")

                                    self.parent_interface_name = YLeaf(YType.str, "parent-interface-name")

                                    self.physica_interface_name = YLeaf(YType.str, "physica-interface-name")

                                    self.tunnel_interface_name = YLeaf(YType.str, "tunnel-interface-name")

                                    self.sr_label_stack = YList(self)

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("next_hop_address",
                                                    "out_label",
                                                    "parent_interface_name",
                                                    "physica_interface_name",
                                                    "tunnel_interface_name") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite.P2PTunnelRewrite.BackupTunnelRewrite, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite.P2PTunnelRewrite.BackupTunnelRewrite, self).__setattr__(name, value)


                                class SrLabelStack(Entity):
                                    """
                                    Segment\-Routing labels stack
                                    
                                    .. attribute:: entry
                                    
                                    	
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'mpls-te-oper'
                                    _revision = '2015-11-09'

                                    def __init__(self):
                                        super(MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite.P2PTunnelRewrite.BackupTunnelRewrite.SrLabelStack, self).__init__()

                                        self.yang_name = "sr-label-stack"
                                        self.yang_parent_name = "backup-tunnel-rewrite"

                                        self.entry = YLeaf(YType.uint32, "entry")

                                    def __setattr__(self, name, value):
                                        self._check_monkey_patching_error(name, value)
                                        with _handle_type_error():
                                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                    "Please use list append or extend method."
                                                                    .format(value))
                                            if isinstance(value, Enum.YLeaf):
                                                value = value.name
                                            if name in ("entry") and name in self.__dict__:
                                                if isinstance(value, YLeaf):
                                                    self.__dict__[name].set(value.get())
                                                elif isinstance(value, YLeafList):
                                                    super(MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite.P2PTunnelRewrite.BackupTunnelRewrite.SrLabelStack, self).__setattr__(name, value)
                                                else:
                                                    self.__dict__[name].set(value)
                                            else:
                                                if hasattr(value, "parent") and name != "parent":
                                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                        value.parent = self
                                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                                        value.parent = self
                                                super(MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite.P2PTunnelRewrite.BackupTunnelRewrite.SrLabelStack, self).__setattr__(name, value)

                                    def has_data(self):
                                        return self.entry.is_set

                                    def has_operation(self):
                                        return (
                                            self.yfilter != YFilter.not_set or
                                            self.entry.yfilter != YFilter.not_set)

                                    def get_segment_path(self):
                                        path_buffer = ""
                                        path_buffer = "sr-label-stack" + path_buffer

                                        return path_buffer

                                    def get_entity_path(self, ancestor):
                                        path_buffer = ""
                                        if (ancestor is None):
                                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                        else:
                                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                        leaf_name_data = LeafDataList()
                                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                            leaf_name_data.append(self.entry.get_name_leafdata())

                                        entity_path = EntityPath(path_buffer, leaf_name_data)
                                        return entity_path

                                    def get_child_by_name(self, child_yang_name, segment_path):
                                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                        if child is not None:
                                            return child

                                        return None

                                    def has_leaf_or_child_of_name(self, name):
                                        if(name == "entry"):
                                            return True
                                        return False

                                    def set_value(self, value_path, value, name_space, name_space_prefix):
                                        if(value_path == "entry"):
                                            self.entry = value
                                            self.entry.value_namespace = name_space
                                            self.entry.value_namespace_prefix = name_space_prefix

                                def has_data(self):
                                    for c in self.sr_label_stack:
                                        if (c.has_data()):
                                            return True
                                    return (
                                        self.next_hop_address.is_set or
                                        self.out_label.is_set or
                                        self.parent_interface_name.is_set or
                                        self.physica_interface_name.is_set or
                                        self.tunnel_interface_name.is_set)

                                def has_operation(self):
                                    for c in self.sr_label_stack:
                                        if (c.has_operation()):
                                            return True
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.next_hop_address.yfilter != YFilter.not_set or
                                        self.out_label.yfilter != YFilter.not_set or
                                        self.parent_interface_name.yfilter != YFilter.not_set or
                                        self.physica_interface_name.yfilter != YFilter.not_set or
                                        self.tunnel_interface_name.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "backup-tunnel-rewrite" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.next_hop_address.is_set or self.next_hop_address.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.next_hop_address.get_name_leafdata())
                                    if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.out_label.get_name_leafdata())
                                    if (self.parent_interface_name.is_set or self.parent_interface_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.parent_interface_name.get_name_leafdata())
                                    if (self.physica_interface_name.is_set or self.physica_interface_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.physica_interface_name.get_name_leafdata())
                                    if (self.tunnel_interface_name.is_set or self.tunnel_interface_name.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.tunnel_interface_name.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    if (child_yang_name == "sr-label-stack"):
                                        for c in self.sr_label_stack:
                                            segment = c.get_segment_path()
                                            if (segment_path == segment):
                                                return c
                                        c = MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite.P2PTunnelRewrite.BackupTunnelRewrite.SrLabelStack()
                                        c.parent = self
                                        local_reference_key = "ydk::seg::%s" % segment_path
                                        self._local_refs[local_reference_key] = c
                                        self.sr_label_stack.append(c)
                                        return c

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "sr-label-stack" or name == "next-hop-address" or name == "out-label" or name == "parent-interface-name" or name == "physica-interface-name" or name == "tunnel-interface-name"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "next-hop-address"):
                                        self.next_hop_address = value
                                        self.next_hop_address.value_namespace = name_space
                                        self.next_hop_address.value_namespace_prefix = name_space_prefix
                                    if(value_path == "out-label"):
                                        self.out_label = value
                                        self.out_label.value_namespace = name_space
                                        self.out_label.value_namespace_prefix = name_space_prefix
                                    if(value_path == "parent-interface-name"):
                                        self.parent_interface_name = value
                                        self.parent_interface_name.value_namespace = name_space
                                        self.parent_interface_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "physica-interface-name"):
                                        self.physica_interface_name = value
                                        self.physica_interface_name.value_namespace = name_space
                                        self.physica_interface_name.value_namespace_prefix = name_space_prefix
                                    if(value_path == "tunnel-interface-name"):
                                        self.tunnel_interface_name = value
                                        self.tunnel_interface_name.value_namespace = name_space
                                        self.tunnel_interface_name.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.backup_active.is_set or
                                    self.backup_tunnel_name.is_set or
                                    self.destination_address.is_set or
                                    self.extended_tunnel_id.is_set or
                                    self.local_label.is_set or
                                    self.original_input_interface.is_set or
                                    self.output_interface_name.is_set or
                                    self.previous_hop_address.is_set or
                                    self.source_pe.is_set or
                                    self.tunnel_id.is_set or
                                    (self.backup_tunnel_rewrite is not None and self.backup_tunnel_rewrite.has_data()) or
                                    (self.primary_s2l is not None and self.primary_s2l.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.backup_active.yfilter != YFilter.not_set or
                                    self.backup_tunnel_name.yfilter != YFilter.not_set or
                                    self.destination_address.yfilter != YFilter.not_set or
                                    self.extended_tunnel_id.yfilter != YFilter.not_set or
                                    self.local_label.yfilter != YFilter.not_set or
                                    self.original_input_interface.yfilter != YFilter.not_set or
                                    self.output_interface_name.yfilter != YFilter.not_set or
                                    self.previous_hop_address.yfilter != YFilter.not_set or
                                    self.source_pe.yfilter != YFilter.not_set or
                                    self.tunnel_id.yfilter != YFilter.not_set or
                                    (self.backup_tunnel_rewrite is not None and self.backup_tunnel_rewrite.has_operation()) or
                                    (self.primary_s2l is not None and self.primary_s2l.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "p2p-tunnel-rewrite" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.backup_active.is_set or self.backup_active.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.backup_active.get_name_leafdata())
                                if (self.backup_tunnel_name.is_set or self.backup_tunnel_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.backup_tunnel_name.get_name_leafdata())
                                if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.destination_address.get_name_leafdata())
                                if (self.extended_tunnel_id.is_set or self.extended_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.extended_tunnel_id.get_name_leafdata())
                                if (self.local_label.is_set or self.local_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_label.get_name_leafdata())
                                if (self.original_input_interface.is_set or self.original_input_interface.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.original_input_interface.get_name_leafdata())
                                if (self.output_interface_name.is_set or self.output_interface_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.output_interface_name.get_name_leafdata())
                                if (self.previous_hop_address.is_set or self.previous_hop_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.previous_hop_address.get_name_leafdata())
                                if (self.source_pe.is_set or self.source_pe.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.source_pe.get_name_leafdata())
                                if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_id.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "backup-tunnel-rewrite"):
                                    if (self.backup_tunnel_rewrite is None):
                                        self.backup_tunnel_rewrite = MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite.P2PTunnelRewrite.BackupTunnelRewrite()
                                        self.backup_tunnel_rewrite.parent = self
                                        self._children_name_map["backup_tunnel_rewrite"] = "backup-tunnel-rewrite"
                                    return self.backup_tunnel_rewrite

                                if (child_yang_name == "primary-s2l"):
                                    if (self.primary_s2l is None):
                                        self.primary_s2l = MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite.P2PTunnelRewrite.PrimaryS2L()
                                        self.primary_s2l.parent = self
                                        self._children_name_map["primary_s2l"] = "primary-s2l"
                                    return self.primary_s2l

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "backup-tunnel-rewrite" or name == "primary-s2l" or name == "backup-active" or name == "backup-tunnel-name" or name == "destination-address" or name == "extended-tunnel-id" or name == "local-label" or name == "original-input-interface" or name == "output-interface-name" or name == "previous-hop-address" or name == "source-pe" or name == "tunnel-id"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "backup-active"):
                                    self.backup_active = value
                                    self.backup_active.value_namespace = name_space
                                    self.backup_active.value_namespace_prefix = name_space_prefix
                                if(value_path == "backup-tunnel-name"):
                                    self.backup_tunnel_name = value
                                    self.backup_tunnel_name.value_namespace = name_space
                                    self.backup_tunnel_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "destination-address"):
                                    self.destination_address = value
                                    self.destination_address.value_namespace = name_space
                                    self.destination_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "extended-tunnel-id"):
                                    self.extended_tunnel_id = value
                                    self.extended_tunnel_id.value_namespace = name_space
                                    self.extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "local-label"):
                                    self.local_label = value
                                    self.local_label.value_namespace = name_space
                                    self.local_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "original-input-interface"):
                                    self.original_input_interface = value
                                    self.original_input_interface.value_namespace = name_space
                                    self.original_input_interface.value_namespace_prefix = name_space_prefix
                                if(value_path == "output-interface-name"):
                                    self.output_interface_name = value
                                    self.output_interface_name.value_namespace = name_space
                                    self.output_interface_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "previous-hop-address"):
                                    self.previous_hop_address = value
                                    self.previous_hop_address.value_namespace = name_space
                                    self.previous_hop_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "source-pe"):
                                    self.source_pe = value
                                    self.source_pe.value_namespace = name_space
                                    self.source_pe.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-id"):
                                    self.tunnel_id = value
                                    self.tunnel_id.value_namespace = name_space
                                    self.tunnel_id.value_namespace_prefix = name_space_prefix


                        class P2MpTunnelRewrite(Entity):
                            """
                            Tunnel rewrite data specific to P2MP
                            
                            .. attribute:: local_label
                            
                            	Local Label
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite.P2MpTunnelRewrite, self).__init__()

                                self.yang_name = "p2mp-tunnel-rewrite"
                                self.yang_parent_name = "tunnel-rewrite"

                                self.local_label = YLeaf(YType.uint32, "local-label")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("local_label") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite.P2MpTunnelRewrite, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite.P2MpTunnelRewrite, self).__setattr__(name, value)

                            def has_data(self):
                                return self.local_label.is_set

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.local_label.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "p2mp-tunnel-rewrite" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.local_label.is_set or self.local_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.local_label.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "local-label"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "local-label"):
                                    self.local_label = value
                                    self.local_label.value_namespace = name_space
                                    self.local_label.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.fec_ctype.is_set or
                                (self.p2mp_tunnel_rewrite is not None and self.p2mp_tunnel_rewrite.has_data()) or
                                (self.p2p_tunnel_rewrite is not None and self.p2p_tunnel_rewrite.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.fec_ctype.yfilter != YFilter.not_set or
                                (self.p2mp_tunnel_rewrite is not None and self.p2mp_tunnel_rewrite.has_operation()) or
                                (self.p2p_tunnel_rewrite is not None and self.p2p_tunnel_rewrite.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "tunnel-rewrite" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_ctype.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "p2mp-tunnel-rewrite"):
                                if (self.p2mp_tunnel_rewrite is None):
                                    self.p2mp_tunnel_rewrite = MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite.P2MpTunnelRewrite()
                                    self.p2mp_tunnel_rewrite.parent = self
                                    self._children_name_map["p2mp_tunnel_rewrite"] = "p2mp-tunnel-rewrite"
                                return self.p2mp_tunnel_rewrite

                            if (child_yang_name == "p2p-tunnel-rewrite"):
                                if (self.p2p_tunnel_rewrite is None):
                                    self.p2p_tunnel_rewrite = MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite.P2PTunnelRewrite()
                                    self.p2p_tunnel_rewrite.parent = self
                                    self._children_name_map["p2p_tunnel_rewrite"] = "p2p-tunnel-rewrite"
                                return self.p2p_tunnel_rewrite

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "p2mp-tunnel-rewrite" or name == "p2p-tunnel-rewrite" or name == "fec-ctype"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "fec-ctype"):
                                self.fec_ctype = value
                                self.fec_ctype.value_namespace = name_space
                                self.fec_ctype.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.timestamp.is_set or
                            (self.tunnel_rewrite is not None and self.tunnel_rewrite.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.timestamp.yfilter != YFilter.not_set or
                            (self.tunnel_rewrite is not None and self.tunnel_rewrite.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "pending-rewrite" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.timestamp.is_set or self.timestamp.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.timestamp.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "tunnel-rewrite"):
                            if (self.tunnel_rewrite is None):
                                self.tunnel_rewrite = MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite.TunnelRewrite()
                                self.tunnel_rewrite.parent = self
                                self._children_name_map["tunnel_rewrite"] = "tunnel-rewrite"
                            return self.tunnel_rewrite

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "tunnel-rewrite" or name == "timestamp"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "timestamp"):
                            self.timestamp = value
                            self.timestamp.value_namespace = name_space
                            self.timestamp.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    return (
                        self.tunnel_id.is_set or
                        self.lsp_id.is_set or
                        self.ctype.is_set or
                        self.is_segment_routing.is_set or
                        self.tunnel_interface.is_set or
                        self.tunnel_signal_name.is_set or
                        (self.failed_rewrite is not None and self.failed_rewrite.has_data()) or
                        (self.pending_rewrite is not None and self.pending_rewrite.has_data()) or
                        (self.successful_rewrite is not None and self.successful_rewrite.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.tunnel_id.yfilter != YFilter.not_set or
                        self.lsp_id.yfilter != YFilter.not_set or
                        self.ctype.yfilter != YFilter.not_set or
                        self.is_segment_routing.yfilter != YFilter.not_set or
                        self.tunnel_interface.yfilter != YFilter.not_set or
                        self.tunnel_signal_name.yfilter != YFilter.not_set or
                        (self.failed_rewrite is not None and self.failed_rewrite.has_operation()) or
                        (self.pending_rewrite is not None and self.pending_rewrite.has_operation()) or
                        (self.successful_rewrite is not None and self.successful_rewrite.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "tunnel-rewrite" + "[tunnel-id='" + self.tunnel_id.get() + "']" + "[lsp-id='" + self.lsp_id.get() + "']" + "[ctype='" + self.ctype.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/p2mp/tunnel-rewrites/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_id.get_name_leafdata())
                    if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.lsp_id.get_name_leafdata())
                    if (self.ctype.is_set or self.ctype.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.ctype.get_name_leafdata())
                    if (self.is_segment_routing.is_set or self.is_segment_routing.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_segment_routing.get_name_leafdata())
                    if (self.tunnel_interface.is_set or self.tunnel_interface.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_interface.get_name_leafdata())
                    if (self.tunnel_signal_name.is_set or self.tunnel_signal_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_signal_name.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "failed-rewrite"):
                        if (self.failed_rewrite is None):
                            self.failed_rewrite = MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.FailedRewrite()
                            self.failed_rewrite.parent = self
                            self._children_name_map["failed_rewrite"] = "failed-rewrite"
                        return self.failed_rewrite

                    if (child_yang_name == "pending-rewrite"):
                        if (self.pending_rewrite is None):
                            self.pending_rewrite = MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.PendingRewrite()
                            self.pending_rewrite.parent = self
                            self._children_name_map["pending_rewrite"] = "pending-rewrite"
                        return self.pending_rewrite

                    if (child_yang_name == "successful-rewrite"):
                        if (self.successful_rewrite is None):
                            self.successful_rewrite = MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite.SuccessfulRewrite()
                            self.successful_rewrite.parent = self
                            self._children_name_map["successful_rewrite"] = "successful-rewrite"
                        return self.successful_rewrite

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "failed-rewrite" or name == "pending-rewrite" or name == "successful-rewrite" or name == "tunnel-id" or name == "lsp-id" or name == "ctype" or name == "is-segment-routing" or name == "tunnel-interface" or name == "tunnel-signal-name"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "tunnel-id"):
                        self.tunnel_id = value
                        self.tunnel_id.value_namespace = name_space
                        self.tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "lsp-id"):
                        self.lsp_id = value
                        self.lsp_id.value_namespace = name_space
                        self.lsp_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "ctype"):
                        self.ctype = value
                        self.ctype.value_namespace = name_space
                        self.ctype.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-segment-routing"):
                        self.is_segment_routing = value
                        self.is_segment_routing.value_namespace = name_space
                        self.is_segment_routing.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-interface"):
                        self.tunnel_interface = value
                        self.tunnel_interface.value_namespace = name_space
                        self.tunnel_interface.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-signal-name"):
                        self.tunnel_signal_name = value
                        self.tunnel_signal_name.value_namespace = name_space
                        self.tunnel_signal_name.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.tunnel_rewrite:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.tunnel_rewrite:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "tunnel-rewrites" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/p2mp/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "tunnel-rewrite"):
                    for c in self.tunnel_rewrite:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTeStandby.P2Mp.TunnelRewrites.TunnelRewrite()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.tunnel_rewrite.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "tunnel-rewrite"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass


        class CollaboratorTimers(Entity):
            """
            TE Collaborator timer status
            
            .. attribute:: p2mp_timer
            
            	Description of all P2MP timers
            	**type**\: list of    :py:class:`P2MpTimer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2Mp.CollaboratorTimers.P2MpTimer>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTeStandby.P2Mp.CollaboratorTimers, self).__init__()

                self.yang_name = "collaborator-timers"
                self.yang_parent_name = "p2mp"

                self.p2mp_timer = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTeStandby.P2Mp.CollaboratorTimers, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTeStandby.P2Mp.CollaboratorTimers, self).__setattr__(name, value)


            class P2MpTimer(Entity):
                """
                Description of all P2MP timers
                
                .. attribute:: duration
                
                	The expiry delay in seconds
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: second
                
                .. attribute:: expiry_time
                
                	Date when the timer last expired in seconds
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: second
                
                .. attribute:: is_running
                
                	True if the timer is running
                	**type**\:  bool
                
                .. attribute:: start_time
                
                	Date when timer was last started in seconds
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: second
                
                .. attribute:: stop_time
                
                	Date when the timer was last stopped in seconds
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: second
                
                .. attribute:: timer_name
                
                	Timer Name
                	**type**\:  str
                
                .. attribute:: timer_type
                
                	Timer Type
                	**type**\:   :py:class:`MplsTeP2MpTimer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeP2MpTimer>`
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTeStandby.P2Mp.CollaboratorTimers.P2MpTimer, self).__init__()

                    self.yang_name = "p2mp-timer"
                    self.yang_parent_name = "collaborator-timers"

                    self.duration = YLeaf(YType.uint32, "duration")

                    self.expiry_time = YLeaf(YType.uint32, "expiry-time")

                    self.is_running = YLeaf(YType.boolean, "is-running")

                    self.start_time = YLeaf(YType.uint32, "start-time")

                    self.stop_time = YLeaf(YType.uint32, "stop-time")

                    self.timer_name = YLeaf(YType.str, "timer-name")

                    self.timer_type = YLeaf(YType.enumeration, "timer-type")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("duration",
                                    "expiry_time",
                                    "is_running",
                                    "start_time",
                                    "stop_time",
                                    "timer_name",
                                    "timer_type") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTeStandby.P2Mp.CollaboratorTimers.P2MpTimer, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTeStandby.P2Mp.CollaboratorTimers.P2MpTimer, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.duration.is_set or
                        self.expiry_time.is_set or
                        self.is_running.is_set or
                        self.start_time.is_set or
                        self.stop_time.is_set or
                        self.timer_name.is_set or
                        self.timer_type.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.duration.yfilter != YFilter.not_set or
                        self.expiry_time.yfilter != YFilter.not_set or
                        self.is_running.yfilter != YFilter.not_set or
                        self.start_time.yfilter != YFilter.not_set or
                        self.stop_time.yfilter != YFilter.not_set or
                        self.timer_name.yfilter != YFilter.not_set or
                        self.timer_type.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "p2mp-timer" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/p2mp/collaborator-timers/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.duration.is_set or self.duration.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.duration.get_name_leafdata())
                    if (self.expiry_time.is_set or self.expiry_time.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.expiry_time.get_name_leafdata())
                    if (self.is_running.is_set or self.is_running.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_running.get_name_leafdata())
                    if (self.start_time.is_set or self.start_time.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.start_time.get_name_leafdata())
                    if (self.stop_time.is_set or self.stop_time.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.stop_time.get_name_leafdata())
                    if (self.timer_name.is_set or self.timer_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.timer_name.get_name_leafdata())
                    if (self.timer_type.is_set or self.timer_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.timer_type.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "duration" or name == "expiry-time" or name == "is-running" or name == "start-time" or name == "stop-time" or name == "timer-name" or name == "timer-type"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "duration"):
                        self.duration = value
                        self.duration.value_namespace = name_space
                        self.duration.value_namespace_prefix = name_space_prefix
                    if(value_path == "expiry-time"):
                        self.expiry_time = value
                        self.expiry_time.value_namespace = name_space
                        self.expiry_time.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-running"):
                        self.is_running = value
                        self.is_running.value_namespace = name_space
                        self.is_running.value_namespace_prefix = name_space_prefix
                    if(value_path == "start-time"):
                        self.start_time = value
                        self.start_time.value_namespace = name_space
                        self.start_time.value_namespace_prefix = name_space_prefix
                    if(value_path == "stop-time"):
                        self.stop_time = value
                        self.stop_time.value_namespace = name_space
                        self.stop_time.value_namespace_prefix = name_space_prefix
                    if(value_path == "timer-name"):
                        self.timer_name = value
                        self.timer_name.value_namespace = name_space
                        self.timer_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "timer-type"):
                        self.timer_type = value
                        self.timer_type.value_namespace = name_space
                        self.timer_type.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.p2mp_timer:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.p2mp_timer:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "collaborator-timers" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/p2mp/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "p2mp-timer"):
                    for c in self.p2mp_timer:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTeStandby.P2Mp.CollaboratorTimers.P2MpTimer()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.p2mp_timer.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "p2mp-timer"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass


        class ForwardingOutputLabelRewrites(Entity):
            """
            forwarding\-adjacency P2MP Information
            
            .. attribute:: forwarding_output_label_rewrite
            
            	Display only P2MP Information
            	**type**\: list of    :py:class:`ForwardingOutputLabelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites, self).__init__()

                self.yang_name = "forwarding-output-label-rewrites"
                self.yang_parent_name = "p2mp"

                self.forwarding_output_label_rewrite = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites, self).__setattr__(name, value)


            class ForwardingOutputLabelRewrite(Entity):
                """
                Display only P2MP Information
                
                .. attribute:: tunnel_id  <key>
                
                	Tunnel ID
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: lsp_id  <key>
                
                	LSP ID
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: extended_tunnel_id  <key>
                
                	extended tunnel ID
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: source_address  <key>
                
                	Source Address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: p2mp_id  <key>
                
                	P2MP ID
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: destination_address  <key>
                
                	Destination Address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: next_hop_address  <key>
                
                	Next Hop
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: previous_hop_address  <key>
                
                	Prev Hop
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: ctype  <key>
                
                	Ctype
                	**type**\:   :py:class:`Ctype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.Ctype>`
                
                .. attribute:: backup_tunnel_name
                
                	Backup tunnel name
                	**type**\:  str
                
                .. attribute:: is_segment_routing
                
                	TRUE if the s2l path is Segment\-Routing
                	**type**\:  bool
                
                .. attribute:: original_input_interface
                
                	Input interface of the S2Ls
                	**type**\:  str
                
                .. attribute:: output_interface_name
                
                	The output interface of the S2Ls
                	**type**\:  str
                
                .. attribute:: s2l
                
                	Unique identifiers for the S2L sharing the rewrite
                	**type**\: list of    :py:class:`S2L <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2L>`
                
                .. attribute:: s2l_output_rewrite
                
                	Output rewrite shared between S2Ls
                	**type**\:   :py:class:`S2LOutputRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite>`
                
                .. attribute:: s2lsr_path
                
                	Segment\-Routing Paths
                	**type**\: list of    :py:class:`S2LsrPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LsrPath>`
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite, self).__init__()

                    self.yang_name = "forwarding-output-label-rewrite"
                    self.yang_parent_name = "forwarding-output-label-rewrites"

                    self.tunnel_id = YLeaf(YType.int32, "tunnel-id")

                    self.lsp_id = YLeaf(YType.int32, "lsp-id")

                    self.extended_tunnel_id = YLeaf(YType.str, "extended-tunnel-id")

                    self.source_address = YLeaf(YType.str, "source-address")

                    self.p2mp_id = YLeaf(YType.int32, "p2mp-id")

                    self.destination_address = YLeaf(YType.str, "destination-address")

                    self.next_hop_address = YLeaf(YType.str, "next-hop-address")

                    self.previous_hop_address = YLeaf(YType.str, "previous-hop-address")

                    self.ctype = YLeaf(YType.enumeration, "ctype")

                    self.backup_tunnel_name = YLeaf(YType.str, "backup-tunnel-name")

                    self.is_segment_routing = YLeaf(YType.boolean, "is-segment-routing")

                    self.original_input_interface = YLeaf(YType.str, "original-input-interface")

                    self.output_interface_name = YLeaf(YType.str, "output-interface-name")

                    self.s2l_output_rewrite = MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite()
                    self.s2l_output_rewrite.parent = self
                    self._children_name_map["s2l_output_rewrite"] = "s2l-output-rewrite"
                    self._children_yang_names.add("s2l-output-rewrite")

                    self.s2l = YList(self)
                    self.s2lsr_path = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("tunnel_id",
                                    "lsp_id",
                                    "extended_tunnel_id",
                                    "source_address",
                                    "p2mp_id",
                                    "destination_address",
                                    "next_hop_address",
                                    "previous_hop_address",
                                    "ctype",
                                    "backup_tunnel_name",
                                    "is_segment_routing",
                                    "original_input_interface",
                                    "output_interface_name") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite, self).__setattr__(name, value)


                class S2LOutputRewrite(Entity):
                    """
                    Output rewrite shared between S2Ls
                    
                    .. attribute:: failed_rewrite
                    
                    	Failed rewrite details
                    	**type**\:   :py:class:`FailedRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.FailedRewrite>`
                    
                    .. attribute:: pending_rewrite
                    
                    	Pending rewrite details
                    	**type**\:   :py:class:`PendingRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.PendingRewrite>`
                    
                    .. attribute:: subfamily
                    
                    	Subfamily identifiers
                    	**type**\:   :py:class:`Subfamily <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.Subfamily>`
                    
                    .. attribute:: successful_rewrite
                    
                    	Successful rewrite details
                    	**type**\:   :py:class:`SuccessfulRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.SuccessfulRewrite>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite, self).__init__()

                        self.yang_name = "s2l-output-rewrite"
                        self.yang_parent_name = "forwarding-output-label-rewrite"

                        self.failed_rewrite = MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.FailedRewrite()
                        self.failed_rewrite.parent = self
                        self._children_name_map["failed_rewrite"] = "failed-rewrite"
                        self._children_yang_names.add("failed-rewrite")

                        self.pending_rewrite = MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.PendingRewrite()
                        self.pending_rewrite.parent = self
                        self._children_name_map["pending_rewrite"] = "pending-rewrite"
                        self._children_yang_names.add("pending-rewrite")

                        self.subfamily = MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.Subfamily()
                        self.subfamily.parent = self
                        self._children_name_map["subfamily"] = "subfamily"
                        self._children_yang_names.add("subfamily")

                        self.successful_rewrite = MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.SuccessfulRewrite()
                        self.successful_rewrite.parent = self
                        self._children_name_map["successful_rewrite"] = "successful-rewrite"
                        self._children_yang_names.add("successful-rewrite")


                    class Subfamily(Entity):
                        """
                        Subfamily identifiers
                        
                        .. attribute:: lsp_fec
                        
                        	LSP FEC
                        	**type**\:   :py:class:`LspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.Subfamily.LspFec>`
                        
                        .. attribute:: next_hop_address
                        
                        	Next hop address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: previous_hop_address
                        
                        	Previous hop address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.Subfamily, self).__init__()

                            self.yang_name = "subfamily"
                            self.yang_parent_name = "s2l-output-rewrite"

                            self.next_hop_address = YLeaf(YType.str, "next-hop-address")

                            self.previous_hop_address = YLeaf(YType.str, "previous-hop-address")

                            self.lsp_fec = MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.Subfamily.LspFec()
                            self.lsp_fec.parent = self
                            self._children_name_map["lsp_fec"] = "lsp-fec"
                            self._children_yang_names.add("lsp-fec")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("next_hop_address",
                                            "previous_hop_address") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.Subfamily, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.Subfamily, self).__setattr__(name, value)


                        class LspFec(Entity):
                            """
                            LSP FEC
                            
                            .. attribute:: fec_destination_info
                            
                            	Destination or P2MP ID
                            	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.Subfamily.LspFec.FecDestinationInfo>`
                            
                            .. attribute:: fec_extended_tunnel_id
                            
                            	Extended tunnel ID
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: fec_lsp_id
                            
                            	LSP ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: fec_source
                            
                            	Tunnel source address
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: fec_tunnel_id
                            
                            	Tunnel ID
                            	**type**\:  int
                            
                            	**range:** 0..65535
                            
                            .. attribute:: fec_vrf
                            
                            	VRF; currently only for GMPLS tunnels
                            	**type**\:  str
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.Subfamily.LspFec, self).__init__()

                                self.yang_name = "lsp-fec"
                                self.yang_parent_name = "subfamily"

                                self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                                self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                                self.fec_source = YLeaf(YType.str, "fec-source")

                                self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                                self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                                self.fec_destination_info = MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.Subfamily.LspFec.FecDestinationInfo()
                                self.fec_destination_info.parent = self
                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                self._children_yang_names.add("fec-destination-info")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("fec_extended_tunnel_id",
                                                "fec_lsp_id",
                                                "fec_source",
                                                "fec_tunnel_id",
                                                "fec_vrf") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.Subfamily.LspFec, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.Subfamily.LspFec, self).__setattr__(name, value)


                            class FecDestinationInfo(Entity):
                                """
                                Destination or P2MP ID
                                
                                .. attribute:: fec_ctype
                                
                                	FEC CType
                                	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                                
                                .. attribute:: fec_destination_p2mp_id
                                
                                	P2MP ID
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: p2p_lsp_destination
                                
                                	P2P LSP destination
                                	**type**\:  str
                                
                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.Subfamily.LspFec.FecDestinationInfo, self).__init__()

                                    self.yang_name = "fec-destination-info"
                                    self.yang_parent_name = "lsp-fec"

                                    self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                                    self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                                    self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("fec_ctype",
                                                    "fec_destination_p2mp_id",
                                                    "p2p_lsp_destination") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.Subfamily.LspFec.FecDestinationInfo, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.Subfamily.LspFec.FecDestinationInfo, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.fec_ctype.is_set or
                                        self.fec_destination_p2mp_id.is_set or
                                        self.p2p_lsp_destination.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.fec_ctype.yfilter != YFilter.not_set or
                                        self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                        self.p2p_lsp_destination.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "fec-destination-info" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                                    if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                                    if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "fec-ctype"):
                                        self.fec_ctype = value
                                        self.fec_ctype.value_namespace = name_space
                                        self.fec_ctype.value_namespace_prefix = name_space_prefix
                                    if(value_path == "fec-destination-p2mp-id"):
                                        self.fec_destination_p2mp_id = value
                                        self.fec_destination_p2mp_id.value_namespace = name_space
                                        self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                                    if(value_path == "p2p-lsp-destination"):
                                        self.p2p_lsp_destination = value
                                        self.p2p_lsp_destination.value_namespace = name_space
                                        self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.fec_extended_tunnel_id.is_set or
                                    self.fec_lsp_id.is_set or
                                    self.fec_source.is_set or
                                    self.fec_tunnel_id.is_set or
                                    self.fec_vrf.is_set or
                                    (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                                    self.fec_lsp_id.yfilter != YFilter.not_set or
                                    self.fec_source.yfilter != YFilter.not_set or
                                    self.fec_tunnel_id.yfilter != YFilter.not_set or
                                    self.fec_vrf.yfilter != YFilter.not_set or
                                    (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "lsp-fec" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                                if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                                if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_source.get_name_leafdata())
                                if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                                if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "fec-destination-info"):
                                    if (self.fec_destination_info is None):
                                        self.fec_destination_info = MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.Subfamily.LspFec.FecDestinationInfo()
                                        self.fec_destination_info.parent = self
                                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                                    return self.fec_destination_info

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "fec-extended-tunnel-id"):
                                    self.fec_extended_tunnel_id = value
                                    self.fec_extended_tunnel_id.value_namespace = name_space
                                    self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-lsp-id"):
                                    self.fec_lsp_id = value
                                    self.fec_lsp_id.value_namespace = name_space
                                    self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-source"):
                                    self.fec_source = value
                                    self.fec_source.value_namespace = name_space
                                    self.fec_source.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-tunnel-id"):
                                    self.fec_tunnel_id = value
                                    self.fec_tunnel_id.value_namespace = name_space
                                    self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                                if(value_path == "fec-vrf"):
                                    self.fec_vrf = value
                                    self.fec_vrf.value_namespace = name_space
                                    self.fec_vrf.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.next_hop_address.is_set or
                                self.previous_hop_address.is_set or
                                (self.lsp_fec is not None and self.lsp_fec.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.next_hop_address.yfilter != YFilter.not_set or
                                self.previous_hop_address.yfilter != YFilter.not_set or
                                (self.lsp_fec is not None and self.lsp_fec.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "subfamily" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.next_hop_address.is_set or self.next_hop_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.next_hop_address.get_name_leafdata())
                            if (self.previous_hop_address.is_set or self.previous_hop_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.previous_hop_address.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "lsp-fec"):
                                if (self.lsp_fec is None):
                                    self.lsp_fec = MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.Subfamily.LspFec()
                                    self.lsp_fec.parent = self
                                    self._children_name_map["lsp_fec"] = "lsp-fec"
                                return self.lsp_fec

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "lsp-fec" or name == "next-hop-address" or name == "previous-hop-address"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "next-hop-address"):
                                self.next_hop_address = value
                                self.next_hop_address.value_namespace = name_space
                                self.next_hop_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "previous-hop-address"):
                                self.previous_hop_address = value
                                self.previous_hop_address.value_namespace = name_space
                                self.previous_hop_address.value_namespace_prefix = name_space_prefix


                    class SuccessfulRewrite(Entity):
                        """
                        Successful rewrite details
                        
                        .. attribute:: backup_active
                        
                        	Backup is active
                        	**type**\:  bool
                        
                        .. attribute:: backup_tunnel_rewrite
                        
                        	Properties of the S2L's backup tunnel rewrite
                        	**type**\:   :py:class:`BackupTunnelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.SuccessfulRewrite.BackupTunnelRewrite>`
                        
                        .. attribute:: explicit_null
                        
                        	Imposition of explicit NULL
                        	**type**\:   :py:class:`TeS2LOutputRwExplicitNull <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LOutputRwExplicitNull>`
                        
                        .. attribute:: label
                        
                        	Local label of the rewrite
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: out_rewrite_role
                        
                        	Role of the associated S2L
                        	**type**\:   :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        .. attribute:: primary_s2l
                        
                        	Properties of the S2L rewrite
                        	**type**\:   :py:class:`PrimaryS2L <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.SuccessfulRewrite.PrimaryS2L>`
                        
                        .. attribute:: protocol_transported
                        
                        	Protocol transported in the S2L
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: s2l_source
                        
                        	Source of the S2L
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: timestamp
                        
                        	Time stamp of the entry (secs since 1/1/70)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.SuccessfulRewrite, self).__init__()

                            self.yang_name = "successful-rewrite"
                            self.yang_parent_name = "s2l-output-rewrite"

                            self.backup_active = YLeaf(YType.boolean, "backup-active")

                            self.explicit_null = YLeaf(YType.enumeration, "explicit-null")

                            self.label = YLeaf(YType.uint32, "label")

                            self.out_rewrite_role = YLeaf(YType.enumeration, "out-rewrite-role")

                            self.protocol_transported = YLeaf(YType.uint16, "protocol-transported")

                            self.s2l_source = YLeaf(YType.str, "s2l-source")

                            self.timestamp = YLeaf(YType.uint32, "timestamp")

                            self.backup_tunnel_rewrite = MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.SuccessfulRewrite.BackupTunnelRewrite()
                            self.backup_tunnel_rewrite.parent = self
                            self._children_name_map["backup_tunnel_rewrite"] = "backup-tunnel-rewrite"
                            self._children_yang_names.add("backup-tunnel-rewrite")

                            self.primary_s2l = MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.SuccessfulRewrite.PrimaryS2L()
                            self.primary_s2l.parent = self
                            self._children_name_map["primary_s2l"] = "primary-s2l"
                            self._children_yang_names.add("primary-s2l")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("backup_active",
                                            "explicit_null",
                                            "label",
                                            "out_rewrite_role",
                                            "protocol_transported",
                                            "s2l_source",
                                            "timestamp") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.SuccessfulRewrite, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.SuccessfulRewrite, self).__setattr__(name, value)


                        class PrimaryS2L(Entity):
                            """
                            Properties of the S2L rewrite
                            
                            .. attribute:: next_hop_address
                            
                            	Next hop address associated with the entry
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: out_label
                            
                            	Output label associated with the entry
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: parent_interface_name
                            
                            	Interface name of the parent intf
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: physica_interface_name
                            
                            	Physical interface associated with the entry
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: sr_label_stack
                            
                            	Segment\-Routing labels stack
                            	**type**\: list of    :py:class:`SrLabelStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.SuccessfulRewrite.PrimaryS2L.SrLabelStack>`
                            
                            .. attribute:: tunnel_interface_name
                            
                            	Interface handle of the associated tunnel
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.SuccessfulRewrite.PrimaryS2L, self).__init__()

                                self.yang_name = "primary-s2l"
                                self.yang_parent_name = "successful-rewrite"

                                self.next_hop_address = YLeaf(YType.str, "next-hop-address")

                                self.out_label = YLeaf(YType.uint32, "out-label")

                                self.parent_interface_name = YLeaf(YType.str, "parent-interface-name")

                                self.physica_interface_name = YLeaf(YType.str, "physica-interface-name")

                                self.tunnel_interface_name = YLeaf(YType.str, "tunnel-interface-name")

                                self.sr_label_stack = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("next_hop_address",
                                                "out_label",
                                                "parent_interface_name",
                                                "physica_interface_name",
                                                "tunnel_interface_name") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.SuccessfulRewrite.PrimaryS2L, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.SuccessfulRewrite.PrimaryS2L, self).__setattr__(name, value)


                            class SrLabelStack(Entity):
                                """
                                Segment\-Routing labels stack
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.SuccessfulRewrite.PrimaryS2L.SrLabelStack, self).__init__()

                                    self.yang_name = "sr-label-stack"
                                    self.yang_parent_name = "primary-s2l"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.SuccessfulRewrite.PrimaryS2L.SrLabelStack, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.SuccessfulRewrite.PrimaryS2L.SrLabelStack, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "sr-label-stack" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.sr_label_stack:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.next_hop_address.is_set or
                                    self.out_label.is_set or
                                    self.parent_interface_name.is_set or
                                    self.physica_interface_name.is_set or
                                    self.tunnel_interface_name.is_set)

                            def has_operation(self):
                                for c in self.sr_label_stack:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.next_hop_address.yfilter != YFilter.not_set or
                                    self.out_label.yfilter != YFilter.not_set or
                                    self.parent_interface_name.yfilter != YFilter.not_set or
                                    self.physica_interface_name.yfilter != YFilter.not_set or
                                    self.tunnel_interface_name.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "primary-s2l" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.next_hop_address.is_set or self.next_hop_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.next_hop_address.get_name_leafdata())
                                if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.out_label.get_name_leafdata())
                                if (self.parent_interface_name.is_set or self.parent_interface_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.parent_interface_name.get_name_leafdata())
                                if (self.physica_interface_name.is_set or self.physica_interface_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.physica_interface_name.get_name_leafdata())
                                if (self.tunnel_interface_name.is_set or self.tunnel_interface_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_interface_name.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "sr-label-stack"):
                                    for c in self.sr_label_stack:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.SuccessfulRewrite.PrimaryS2L.SrLabelStack()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.sr_label_stack.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "sr-label-stack" or name == "next-hop-address" or name == "out-label" or name == "parent-interface-name" or name == "physica-interface-name" or name == "tunnel-interface-name"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "next-hop-address"):
                                    self.next_hop_address = value
                                    self.next_hop_address.value_namespace = name_space
                                    self.next_hop_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "out-label"):
                                    self.out_label = value
                                    self.out_label.value_namespace = name_space
                                    self.out_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "parent-interface-name"):
                                    self.parent_interface_name = value
                                    self.parent_interface_name.value_namespace = name_space
                                    self.parent_interface_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "physica-interface-name"):
                                    self.physica_interface_name = value
                                    self.physica_interface_name.value_namespace = name_space
                                    self.physica_interface_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-interface-name"):
                                    self.tunnel_interface_name = value
                                    self.tunnel_interface_name.value_namespace = name_space
                                    self.tunnel_interface_name.value_namespace_prefix = name_space_prefix


                        class BackupTunnelRewrite(Entity):
                            """
                            Properties of the S2L's backup tunnel rewrite
                            
                            .. attribute:: next_hop_address
                            
                            	Next hop address associated with the entry
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: out_label
                            
                            	Output label associated with the entry
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: parent_interface_name
                            
                            	Interface name of the parent intf
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: physica_interface_name
                            
                            	Physical interface associated with the entry
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: sr_label_stack
                            
                            	Segment\-Routing labels stack
                            	**type**\: list of    :py:class:`SrLabelStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.SuccessfulRewrite.BackupTunnelRewrite.SrLabelStack>`
                            
                            .. attribute:: tunnel_interface_name
                            
                            	Interface handle of the associated tunnel
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.SuccessfulRewrite.BackupTunnelRewrite, self).__init__()

                                self.yang_name = "backup-tunnel-rewrite"
                                self.yang_parent_name = "successful-rewrite"

                                self.next_hop_address = YLeaf(YType.str, "next-hop-address")

                                self.out_label = YLeaf(YType.uint32, "out-label")

                                self.parent_interface_name = YLeaf(YType.str, "parent-interface-name")

                                self.physica_interface_name = YLeaf(YType.str, "physica-interface-name")

                                self.tunnel_interface_name = YLeaf(YType.str, "tunnel-interface-name")

                                self.sr_label_stack = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("next_hop_address",
                                                "out_label",
                                                "parent_interface_name",
                                                "physica_interface_name",
                                                "tunnel_interface_name") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.SuccessfulRewrite.BackupTunnelRewrite, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.SuccessfulRewrite.BackupTunnelRewrite, self).__setattr__(name, value)


                            class SrLabelStack(Entity):
                                """
                                Segment\-Routing labels stack
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.SuccessfulRewrite.BackupTunnelRewrite.SrLabelStack, self).__init__()

                                    self.yang_name = "sr-label-stack"
                                    self.yang_parent_name = "backup-tunnel-rewrite"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.SuccessfulRewrite.BackupTunnelRewrite.SrLabelStack, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.SuccessfulRewrite.BackupTunnelRewrite.SrLabelStack, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "sr-label-stack" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.sr_label_stack:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.next_hop_address.is_set or
                                    self.out_label.is_set or
                                    self.parent_interface_name.is_set or
                                    self.physica_interface_name.is_set or
                                    self.tunnel_interface_name.is_set)

                            def has_operation(self):
                                for c in self.sr_label_stack:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.next_hop_address.yfilter != YFilter.not_set or
                                    self.out_label.yfilter != YFilter.not_set or
                                    self.parent_interface_name.yfilter != YFilter.not_set or
                                    self.physica_interface_name.yfilter != YFilter.not_set or
                                    self.tunnel_interface_name.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "backup-tunnel-rewrite" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.next_hop_address.is_set or self.next_hop_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.next_hop_address.get_name_leafdata())
                                if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.out_label.get_name_leafdata())
                                if (self.parent_interface_name.is_set or self.parent_interface_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.parent_interface_name.get_name_leafdata())
                                if (self.physica_interface_name.is_set or self.physica_interface_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.physica_interface_name.get_name_leafdata())
                                if (self.tunnel_interface_name.is_set or self.tunnel_interface_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_interface_name.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "sr-label-stack"):
                                    for c in self.sr_label_stack:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.SuccessfulRewrite.BackupTunnelRewrite.SrLabelStack()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.sr_label_stack.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "sr-label-stack" or name == "next-hop-address" or name == "out-label" or name == "parent-interface-name" or name == "physica-interface-name" or name == "tunnel-interface-name"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "next-hop-address"):
                                    self.next_hop_address = value
                                    self.next_hop_address.value_namespace = name_space
                                    self.next_hop_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "out-label"):
                                    self.out_label = value
                                    self.out_label.value_namespace = name_space
                                    self.out_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "parent-interface-name"):
                                    self.parent_interface_name = value
                                    self.parent_interface_name.value_namespace = name_space
                                    self.parent_interface_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "physica-interface-name"):
                                    self.physica_interface_name = value
                                    self.physica_interface_name.value_namespace = name_space
                                    self.physica_interface_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-interface-name"):
                                    self.tunnel_interface_name = value
                                    self.tunnel_interface_name.value_namespace = name_space
                                    self.tunnel_interface_name.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.backup_active.is_set or
                                self.explicit_null.is_set or
                                self.label.is_set or
                                self.out_rewrite_role.is_set or
                                self.protocol_transported.is_set or
                                self.s2l_source.is_set or
                                self.timestamp.is_set or
                                (self.backup_tunnel_rewrite is not None and self.backup_tunnel_rewrite.has_data()) or
                                (self.primary_s2l is not None and self.primary_s2l.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.backup_active.yfilter != YFilter.not_set or
                                self.explicit_null.yfilter != YFilter.not_set or
                                self.label.yfilter != YFilter.not_set or
                                self.out_rewrite_role.yfilter != YFilter.not_set or
                                self.protocol_transported.yfilter != YFilter.not_set or
                                self.s2l_source.yfilter != YFilter.not_set or
                                self.timestamp.yfilter != YFilter.not_set or
                                (self.backup_tunnel_rewrite is not None and self.backup_tunnel_rewrite.has_operation()) or
                                (self.primary_s2l is not None and self.primary_s2l.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "successful-rewrite" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.backup_active.is_set or self.backup_active.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.backup_active.get_name_leafdata())
                            if (self.explicit_null.is_set or self.explicit_null.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.explicit_null.get_name_leafdata())
                            if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.label.get_name_leafdata())
                            if (self.out_rewrite_role.is_set or self.out_rewrite_role.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.out_rewrite_role.get_name_leafdata())
                            if (self.protocol_transported.is_set or self.protocol_transported.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.protocol_transported.get_name_leafdata())
                            if (self.s2l_source.is_set or self.s2l_source.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_source.get_name_leafdata())
                            if (self.timestamp.is_set or self.timestamp.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.timestamp.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "backup-tunnel-rewrite"):
                                if (self.backup_tunnel_rewrite is None):
                                    self.backup_tunnel_rewrite = MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.SuccessfulRewrite.BackupTunnelRewrite()
                                    self.backup_tunnel_rewrite.parent = self
                                    self._children_name_map["backup_tunnel_rewrite"] = "backup-tunnel-rewrite"
                                return self.backup_tunnel_rewrite

                            if (child_yang_name == "primary-s2l"):
                                if (self.primary_s2l is None):
                                    self.primary_s2l = MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.SuccessfulRewrite.PrimaryS2L()
                                    self.primary_s2l.parent = self
                                    self._children_name_map["primary_s2l"] = "primary-s2l"
                                return self.primary_s2l

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "backup-tunnel-rewrite" or name == "primary-s2l" or name == "backup-active" or name == "explicit-null" or name == "label" or name == "out-rewrite-role" or name == "protocol-transported" or name == "s2l-source" or name == "timestamp"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "backup-active"):
                                self.backup_active = value
                                self.backup_active.value_namespace = name_space
                                self.backup_active.value_namespace_prefix = name_space_prefix
                            if(value_path == "explicit-null"):
                                self.explicit_null = value
                                self.explicit_null.value_namespace = name_space
                                self.explicit_null.value_namespace_prefix = name_space_prefix
                            if(value_path == "label"):
                                self.label = value
                                self.label.value_namespace = name_space
                                self.label.value_namespace_prefix = name_space_prefix
                            if(value_path == "out-rewrite-role"):
                                self.out_rewrite_role = value
                                self.out_rewrite_role.value_namespace = name_space
                                self.out_rewrite_role.value_namespace_prefix = name_space_prefix
                            if(value_path == "protocol-transported"):
                                self.protocol_transported = value
                                self.protocol_transported.value_namespace = name_space
                                self.protocol_transported.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-source"):
                                self.s2l_source = value
                                self.s2l_source.value_namespace = name_space
                                self.s2l_source.value_namespace_prefix = name_space_prefix
                            if(value_path == "timestamp"):
                                self.timestamp = value
                                self.timestamp.value_namespace = name_space
                                self.timestamp.value_namespace_prefix = name_space_prefix


                    class FailedRewrite(Entity):
                        """
                        Failed rewrite details
                        
                        .. attribute:: backup_active
                        
                        	Backup is active
                        	**type**\:  bool
                        
                        .. attribute:: backup_tunnel_rewrite
                        
                        	Properties of the S2L's backup tunnel rewrite
                        	**type**\:   :py:class:`BackupTunnelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.FailedRewrite.BackupTunnelRewrite>`
                        
                        .. attribute:: explicit_null
                        
                        	Imposition of explicit NULL
                        	**type**\:   :py:class:`TeS2LOutputRwExplicitNull <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LOutputRwExplicitNull>`
                        
                        .. attribute:: label
                        
                        	Local label of the rewrite
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: out_rewrite_role
                        
                        	Role of the associated S2L
                        	**type**\:   :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        .. attribute:: primary_s2l
                        
                        	Properties of the S2L rewrite
                        	**type**\:   :py:class:`PrimaryS2L <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.FailedRewrite.PrimaryS2L>`
                        
                        .. attribute:: protocol_transported
                        
                        	Protocol transported in the S2L
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: s2l_source
                        
                        	Source of the S2L
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: timestamp
                        
                        	Time stamp of the entry (secs since 1/1/70)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.FailedRewrite, self).__init__()

                            self.yang_name = "failed-rewrite"
                            self.yang_parent_name = "s2l-output-rewrite"

                            self.backup_active = YLeaf(YType.boolean, "backup-active")

                            self.explicit_null = YLeaf(YType.enumeration, "explicit-null")

                            self.label = YLeaf(YType.uint32, "label")

                            self.out_rewrite_role = YLeaf(YType.enumeration, "out-rewrite-role")

                            self.protocol_transported = YLeaf(YType.uint16, "protocol-transported")

                            self.s2l_source = YLeaf(YType.str, "s2l-source")

                            self.timestamp = YLeaf(YType.uint32, "timestamp")

                            self.backup_tunnel_rewrite = MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.FailedRewrite.BackupTunnelRewrite()
                            self.backup_tunnel_rewrite.parent = self
                            self._children_name_map["backup_tunnel_rewrite"] = "backup-tunnel-rewrite"
                            self._children_yang_names.add("backup-tunnel-rewrite")

                            self.primary_s2l = MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.FailedRewrite.PrimaryS2L()
                            self.primary_s2l.parent = self
                            self._children_name_map["primary_s2l"] = "primary-s2l"
                            self._children_yang_names.add("primary-s2l")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("backup_active",
                                            "explicit_null",
                                            "label",
                                            "out_rewrite_role",
                                            "protocol_transported",
                                            "s2l_source",
                                            "timestamp") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.FailedRewrite, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.FailedRewrite, self).__setattr__(name, value)


                        class PrimaryS2L(Entity):
                            """
                            Properties of the S2L rewrite
                            
                            .. attribute:: next_hop_address
                            
                            	Next hop address associated with the entry
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: out_label
                            
                            	Output label associated with the entry
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: parent_interface_name
                            
                            	Interface name of the parent intf
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: physica_interface_name
                            
                            	Physical interface associated with the entry
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: sr_label_stack
                            
                            	Segment\-Routing labels stack
                            	**type**\: list of    :py:class:`SrLabelStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.FailedRewrite.PrimaryS2L.SrLabelStack>`
                            
                            .. attribute:: tunnel_interface_name
                            
                            	Interface handle of the associated tunnel
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.FailedRewrite.PrimaryS2L, self).__init__()

                                self.yang_name = "primary-s2l"
                                self.yang_parent_name = "failed-rewrite"

                                self.next_hop_address = YLeaf(YType.str, "next-hop-address")

                                self.out_label = YLeaf(YType.uint32, "out-label")

                                self.parent_interface_name = YLeaf(YType.str, "parent-interface-name")

                                self.physica_interface_name = YLeaf(YType.str, "physica-interface-name")

                                self.tunnel_interface_name = YLeaf(YType.str, "tunnel-interface-name")

                                self.sr_label_stack = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("next_hop_address",
                                                "out_label",
                                                "parent_interface_name",
                                                "physica_interface_name",
                                                "tunnel_interface_name") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.FailedRewrite.PrimaryS2L, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.FailedRewrite.PrimaryS2L, self).__setattr__(name, value)


                            class SrLabelStack(Entity):
                                """
                                Segment\-Routing labels stack
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.FailedRewrite.PrimaryS2L.SrLabelStack, self).__init__()

                                    self.yang_name = "sr-label-stack"
                                    self.yang_parent_name = "primary-s2l"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.FailedRewrite.PrimaryS2L.SrLabelStack, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.FailedRewrite.PrimaryS2L.SrLabelStack, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "sr-label-stack" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.sr_label_stack:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.next_hop_address.is_set or
                                    self.out_label.is_set or
                                    self.parent_interface_name.is_set or
                                    self.physica_interface_name.is_set or
                                    self.tunnel_interface_name.is_set)

                            def has_operation(self):
                                for c in self.sr_label_stack:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.next_hop_address.yfilter != YFilter.not_set or
                                    self.out_label.yfilter != YFilter.not_set or
                                    self.parent_interface_name.yfilter != YFilter.not_set or
                                    self.physica_interface_name.yfilter != YFilter.not_set or
                                    self.tunnel_interface_name.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "primary-s2l" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.next_hop_address.is_set or self.next_hop_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.next_hop_address.get_name_leafdata())
                                if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.out_label.get_name_leafdata())
                                if (self.parent_interface_name.is_set or self.parent_interface_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.parent_interface_name.get_name_leafdata())
                                if (self.physica_interface_name.is_set or self.physica_interface_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.physica_interface_name.get_name_leafdata())
                                if (self.tunnel_interface_name.is_set or self.tunnel_interface_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_interface_name.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "sr-label-stack"):
                                    for c in self.sr_label_stack:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.FailedRewrite.PrimaryS2L.SrLabelStack()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.sr_label_stack.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "sr-label-stack" or name == "next-hop-address" or name == "out-label" or name == "parent-interface-name" or name == "physica-interface-name" or name == "tunnel-interface-name"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "next-hop-address"):
                                    self.next_hop_address = value
                                    self.next_hop_address.value_namespace = name_space
                                    self.next_hop_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "out-label"):
                                    self.out_label = value
                                    self.out_label.value_namespace = name_space
                                    self.out_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "parent-interface-name"):
                                    self.parent_interface_name = value
                                    self.parent_interface_name.value_namespace = name_space
                                    self.parent_interface_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "physica-interface-name"):
                                    self.physica_interface_name = value
                                    self.physica_interface_name.value_namespace = name_space
                                    self.physica_interface_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-interface-name"):
                                    self.tunnel_interface_name = value
                                    self.tunnel_interface_name.value_namespace = name_space
                                    self.tunnel_interface_name.value_namespace_prefix = name_space_prefix


                        class BackupTunnelRewrite(Entity):
                            """
                            Properties of the S2L's backup tunnel rewrite
                            
                            .. attribute:: next_hop_address
                            
                            	Next hop address associated with the entry
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: out_label
                            
                            	Output label associated with the entry
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: parent_interface_name
                            
                            	Interface name of the parent intf
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: physica_interface_name
                            
                            	Physical interface associated with the entry
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: sr_label_stack
                            
                            	Segment\-Routing labels stack
                            	**type**\: list of    :py:class:`SrLabelStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.FailedRewrite.BackupTunnelRewrite.SrLabelStack>`
                            
                            .. attribute:: tunnel_interface_name
                            
                            	Interface handle of the associated tunnel
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.FailedRewrite.BackupTunnelRewrite, self).__init__()

                                self.yang_name = "backup-tunnel-rewrite"
                                self.yang_parent_name = "failed-rewrite"

                                self.next_hop_address = YLeaf(YType.str, "next-hop-address")

                                self.out_label = YLeaf(YType.uint32, "out-label")

                                self.parent_interface_name = YLeaf(YType.str, "parent-interface-name")

                                self.physica_interface_name = YLeaf(YType.str, "physica-interface-name")

                                self.tunnel_interface_name = YLeaf(YType.str, "tunnel-interface-name")

                                self.sr_label_stack = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("next_hop_address",
                                                "out_label",
                                                "parent_interface_name",
                                                "physica_interface_name",
                                                "tunnel_interface_name") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.FailedRewrite.BackupTunnelRewrite, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.FailedRewrite.BackupTunnelRewrite, self).__setattr__(name, value)


                            class SrLabelStack(Entity):
                                """
                                Segment\-Routing labels stack
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.FailedRewrite.BackupTunnelRewrite.SrLabelStack, self).__init__()

                                    self.yang_name = "sr-label-stack"
                                    self.yang_parent_name = "backup-tunnel-rewrite"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.FailedRewrite.BackupTunnelRewrite.SrLabelStack, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.FailedRewrite.BackupTunnelRewrite.SrLabelStack, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "sr-label-stack" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.sr_label_stack:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.next_hop_address.is_set or
                                    self.out_label.is_set or
                                    self.parent_interface_name.is_set or
                                    self.physica_interface_name.is_set or
                                    self.tunnel_interface_name.is_set)

                            def has_operation(self):
                                for c in self.sr_label_stack:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.next_hop_address.yfilter != YFilter.not_set or
                                    self.out_label.yfilter != YFilter.not_set or
                                    self.parent_interface_name.yfilter != YFilter.not_set or
                                    self.physica_interface_name.yfilter != YFilter.not_set or
                                    self.tunnel_interface_name.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "backup-tunnel-rewrite" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.next_hop_address.is_set or self.next_hop_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.next_hop_address.get_name_leafdata())
                                if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.out_label.get_name_leafdata())
                                if (self.parent_interface_name.is_set or self.parent_interface_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.parent_interface_name.get_name_leafdata())
                                if (self.physica_interface_name.is_set or self.physica_interface_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.physica_interface_name.get_name_leafdata())
                                if (self.tunnel_interface_name.is_set or self.tunnel_interface_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_interface_name.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "sr-label-stack"):
                                    for c in self.sr_label_stack:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.FailedRewrite.BackupTunnelRewrite.SrLabelStack()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.sr_label_stack.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "sr-label-stack" or name == "next-hop-address" or name == "out-label" or name == "parent-interface-name" or name == "physica-interface-name" or name == "tunnel-interface-name"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "next-hop-address"):
                                    self.next_hop_address = value
                                    self.next_hop_address.value_namespace = name_space
                                    self.next_hop_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "out-label"):
                                    self.out_label = value
                                    self.out_label.value_namespace = name_space
                                    self.out_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "parent-interface-name"):
                                    self.parent_interface_name = value
                                    self.parent_interface_name.value_namespace = name_space
                                    self.parent_interface_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "physica-interface-name"):
                                    self.physica_interface_name = value
                                    self.physica_interface_name.value_namespace = name_space
                                    self.physica_interface_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-interface-name"):
                                    self.tunnel_interface_name = value
                                    self.tunnel_interface_name.value_namespace = name_space
                                    self.tunnel_interface_name.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.backup_active.is_set or
                                self.explicit_null.is_set or
                                self.label.is_set or
                                self.out_rewrite_role.is_set or
                                self.protocol_transported.is_set or
                                self.s2l_source.is_set or
                                self.timestamp.is_set or
                                (self.backup_tunnel_rewrite is not None and self.backup_tunnel_rewrite.has_data()) or
                                (self.primary_s2l is not None and self.primary_s2l.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.backup_active.yfilter != YFilter.not_set or
                                self.explicit_null.yfilter != YFilter.not_set or
                                self.label.yfilter != YFilter.not_set or
                                self.out_rewrite_role.yfilter != YFilter.not_set or
                                self.protocol_transported.yfilter != YFilter.not_set or
                                self.s2l_source.yfilter != YFilter.not_set or
                                self.timestamp.yfilter != YFilter.not_set or
                                (self.backup_tunnel_rewrite is not None and self.backup_tunnel_rewrite.has_operation()) or
                                (self.primary_s2l is not None and self.primary_s2l.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "failed-rewrite" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.backup_active.is_set or self.backup_active.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.backup_active.get_name_leafdata())
                            if (self.explicit_null.is_set or self.explicit_null.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.explicit_null.get_name_leafdata())
                            if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.label.get_name_leafdata())
                            if (self.out_rewrite_role.is_set or self.out_rewrite_role.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.out_rewrite_role.get_name_leafdata())
                            if (self.protocol_transported.is_set or self.protocol_transported.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.protocol_transported.get_name_leafdata())
                            if (self.s2l_source.is_set or self.s2l_source.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_source.get_name_leafdata())
                            if (self.timestamp.is_set or self.timestamp.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.timestamp.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "backup-tunnel-rewrite"):
                                if (self.backup_tunnel_rewrite is None):
                                    self.backup_tunnel_rewrite = MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.FailedRewrite.BackupTunnelRewrite()
                                    self.backup_tunnel_rewrite.parent = self
                                    self._children_name_map["backup_tunnel_rewrite"] = "backup-tunnel-rewrite"
                                return self.backup_tunnel_rewrite

                            if (child_yang_name == "primary-s2l"):
                                if (self.primary_s2l is None):
                                    self.primary_s2l = MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.FailedRewrite.PrimaryS2L()
                                    self.primary_s2l.parent = self
                                    self._children_name_map["primary_s2l"] = "primary-s2l"
                                return self.primary_s2l

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "backup-tunnel-rewrite" or name == "primary-s2l" or name == "backup-active" or name == "explicit-null" or name == "label" or name == "out-rewrite-role" or name == "protocol-transported" or name == "s2l-source" or name == "timestamp"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "backup-active"):
                                self.backup_active = value
                                self.backup_active.value_namespace = name_space
                                self.backup_active.value_namespace_prefix = name_space_prefix
                            if(value_path == "explicit-null"):
                                self.explicit_null = value
                                self.explicit_null.value_namespace = name_space
                                self.explicit_null.value_namespace_prefix = name_space_prefix
                            if(value_path == "label"):
                                self.label = value
                                self.label.value_namespace = name_space
                                self.label.value_namespace_prefix = name_space_prefix
                            if(value_path == "out-rewrite-role"):
                                self.out_rewrite_role = value
                                self.out_rewrite_role.value_namespace = name_space
                                self.out_rewrite_role.value_namespace_prefix = name_space_prefix
                            if(value_path == "protocol-transported"):
                                self.protocol_transported = value
                                self.protocol_transported.value_namespace = name_space
                                self.protocol_transported.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-source"):
                                self.s2l_source = value
                                self.s2l_source.value_namespace = name_space
                                self.s2l_source.value_namespace_prefix = name_space_prefix
                            if(value_path == "timestamp"):
                                self.timestamp = value
                                self.timestamp.value_namespace = name_space
                                self.timestamp.value_namespace_prefix = name_space_prefix


                    class PendingRewrite(Entity):
                        """
                        Pending rewrite details
                        
                        .. attribute:: backup_active
                        
                        	Backup is active
                        	**type**\:  bool
                        
                        .. attribute:: backup_tunnel_rewrite
                        
                        	Properties of the S2L's backup tunnel rewrite
                        	**type**\:   :py:class:`BackupTunnelRewrite <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.PendingRewrite.BackupTunnelRewrite>`
                        
                        .. attribute:: explicit_null
                        
                        	Imposition of explicit NULL
                        	**type**\:   :py:class:`TeS2LOutputRwExplicitNull <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeS2LOutputRwExplicitNull>`
                        
                        .. attribute:: label
                        
                        	Local label of the rewrite
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: out_rewrite_role
                        
                        	Role of the associated S2L
                        	**type**\:   :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        .. attribute:: primary_s2l
                        
                        	Properties of the S2L rewrite
                        	**type**\:   :py:class:`PrimaryS2L <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.PendingRewrite.PrimaryS2L>`
                        
                        .. attribute:: protocol_transported
                        
                        	Protocol transported in the S2L
                        	**type**\:  int
                        
                        	**range:** 0..65535
                        
                        .. attribute:: s2l_source
                        
                        	Source of the S2L
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: timestamp
                        
                        	Time stamp of the entry (secs since 1/1/70)
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        	**units**\: second
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.PendingRewrite, self).__init__()

                            self.yang_name = "pending-rewrite"
                            self.yang_parent_name = "s2l-output-rewrite"

                            self.backup_active = YLeaf(YType.boolean, "backup-active")

                            self.explicit_null = YLeaf(YType.enumeration, "explicit-null")

                            self.label = YLeaf(YType.uint32, "label")

                            self.out_rewrite_role = YLeaf(YType.enumeration, "out-rewrite-role")

                            self.protocol_transported = YLeaf(YType.uint16, "protocol-transported")

                            self.s2l_source = YLeaf(YType.str, "s2l-source")

                            self.timestamp = YLeaf(YType.uint32, "timestamp")

                            self.backup_tunnel_rewrite = MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.PendingRewrite.BackupTunnelRewrite()
                            self.backup_tunnel_rewrite.parent = self
                            self._children_name_map["backup_tunnel_rewrite"] = "backup-tunnel-rewrite"
                            self._children_yang_names.add("backup-tunnel-rewrite")

                            self.primary_s2l = MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.PendingRewrite.PrimaryS2L()
                            self.primary_s2l.parent = self
                            self._children_name_map["primary_s2l"] = "primary-s2l"
                            self._children_yang_names.add("primary-s2l")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("backup_active",
                                            "explicit_null",
                                            "label",
                                            "out_rewrite_role",
                                            "protocol_transported",
                                            "s2l_source",
                                            "timestamp") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.PendingRewrite, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.PendingRewrite, self).__setattr__(name, value)


                        class PrimaryS2L(Entity):
                            """
                            Properties of the S2L rewrite
                            
                            .. attribute:: next_hop_address
                            
                            	Next hop address associated with the entry
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: out_label
                            
                            	Output label associated with the entry
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: parent_interface_name
                            
                            	Interface name of the parent intf
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: physica_interface_name
                            
                            	Physical interface associated with the entry
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: sr_label_stack
                            
                            	Segment\-Routing labels stack
                            	**type**\: list of    :py:class:`SrLabelStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.PendingRewrite.PrimaryS2L.SrLabelStack>`
                            
                            .. attribute:: tunnel_interface_name
                            
                            	Interface handle of the associated tunnel
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.PendingRewrite.PrimaryS2L, self).__init__()

                                self.yang_name = "primary-s2l"
                                self.yang_parent_name = "pending-rewrite"

                                self.next_hop_address = YLeaf(YType.str, "next-hop-address")

                                self.out_label = YLeaf(YType.uint32, "out-label")

                                self.parent_interface_name = YLeaf(YType.str, "parent-interface-name")

                                self.physica_interface_name = YLeaf(YType.str, "physica-interface-name")

                                self.tunnel_interface_name = YLeaf(YType.str, "tunnel-interface-name")

                                self.sr_label_stack = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("next_hop_address",
                                                "out_label",
                                                "parent_interface_name",
                                                "physica_interface_name",
                                                "tunnel_interface_name") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.PendingRewrite.PrimaryS2L, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.PendingRewrite.PrimaryS2L, self).__setattr__(name, value)


                            class SrLabelStack(Entity):
                                """
                                Segment\-Routing labels stack
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.PendingRewrite.PrimaryS2L.SrLabelStack, self).__init__()

                                    self.yang_name = "sr-label-stack"
                                    self.yang_parent_name = "primary-s2l"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.PendingRewrite.PrimaryS2L.SrLabelStack, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.PendingRewrite.PrimaryS2L.SrLabelStack, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "sr-label-stack" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.sr_label_stack:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.next_hop_address.is_set or
                                    self.out_label.is_set or
                                    self.parent_interface_name.is_set or
                                    self.physica_interface_name.is_set or
                                    self.tunnel_interface_name.is_set)

                            def has_operation(self):
                                for c in self.sr_label_stack:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.next_hop_address.yfilter != YFilter.not_set or
                                    self.out_label.yfilter != YFilter.not_set or
                                    self.parent_interface_name.yfilter != YFilter.not_set or
                                    self.physica_interface_name.yfilter != YFilter.not_set or
                                    self.tunnel_interface_name.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "primary-s2l" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.next_hop_address.is_set or self.next_hop_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.next_hop_address.get_name_leafdata())
                                if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.out_label.get_name_leafdata())
                                if (self.parent_interface_name.is_set or self.parent_interface_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.parent_interface_name.get_name_leafdata())
                                if (self.physica_interface_name.is_set or self.physica_interface_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.physica_interface_name.get_name_leafdata())
                                if (self.tunnel_interface_name.is_set or self.tunnel_interface_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_interface_name.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "sr-label-stack"):
                                    for c in self.sr_label_stack:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.PendingRewrite.PrimaryS2L.SrLabelStack()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.sr_label_stack.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "sr-label-stack" or name == "next-hop-address" or name == "out-label" or name == "parent-interface-name" or name == "physica-interface-name" or name == "tunnel-interface-name"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "next-hop-address"):
                                    self.next_hop_address = value
                                    self.next_hop_address.value_namespace = name_space
                                    self.next_hop_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "out-label"):
                                    self.out_label = value
                                    self.out_label.value_namespace = name_space
                                    self.out_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "parent-interface-name"):
                                    self.parent_interface_name = value
                                    self.parent_interface_name.value_namespace = name_space
                                    self.parent_interface_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "physica-interface-name"):
                                    self.physica_interface_name = value
                                    self.physica_interface_name.value_namespace = name_space
                                    self.physica_interface_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-interface-name"):
                                    self.tunnel_interface_name = value
                                    self.tunnel_interface_name.value_namespace = name_space
                                    self.tunnel_interface_name.value_namespace_prefix = name_space_prefix


                        class BackupTunnelRewrite(Entity):
                            """
                            Properties of the S2L's backup tunnel rewrite
                            
                            .. attribute:: next_hop_address
                            
                            	Next hop address associated with the entry
                            	**type**\:  str
                            
                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                            
                            .. attribute:: out_label
                            
                            	Output label associated with the entry
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: parent_interface_name
                            
                            	Interface name of the parent intf
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: physica_interface_name
                            
                            	Physical interface associated with the entry
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            .. attribute:: sr_label_stack
                            
                            	Segment\-Routing labels stack
                            	**type**\: list of    :py:class:`SrLabelStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.PendingRewrite.BackupTunnelRewrite.SrLabelStack>`
                            
                            .. attribute:: tunnel_interface_name
                            
                            	Interface handle of the associated tunnel
                            	**type**\:  str
                            
                            	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.PendingRewrite.BackupTunnelRewrite, self).__init__()

                                self.yang_name = "backup-tunnel-rewrite"
                                self.yang_parent_name = "pending-rewrite"

                                self.next_hop_address = YLeaf(YType.str, "next-hop-address")

                                self.out_label = YLeaf(YType.uint32, "out-label")

                                self.parent_interface_name = YLeaf(YType.str, "parent-interface-name")

                                self.physica_interface_name = YLeaf(YType.str, "physica-interface-name")

                                self.tunnel_interface_name = YLeaf(YType.str, "tunnel-interface-name")

                                self.sr_label_stack = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("next_hop_address",
                                                "out_label",
                                                "parent_interface_name",
                                                "physica_interface_name",
                                                "tunnel_interface_name") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.PendingRewrite.BackupTunnelRewrite, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.PendingRewrite.BackupTunnelRewrite, self).__setattr__(name, value)


                            class SrLabelStack(Entity):
                                """
                                Segment\-Routing labels stack
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.PendingRewrite.BackupTunnelRewrite.SrLabelStack, self).__init__()

                                    self.yang_name = "sr-label-stack"
                                    self.yang_parent_name = "backup-tunnel-rewrite"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.PendingRewrite.BackupTunnelRewrite.SrLabelStack, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.PendingRewrite.BackupTunnelRewrite.SrLabelStack, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "sr-label-stack" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.sr_label_stack:
                                    if (c.has_data()):
                                        return True
                                return (
                                    self.next_hop_address.is_set or
                                    self.out_label.is_set or
                                    self.parent_interface_name.is_set or
                                    self.physica_interface_name.is_set or
                                    self.tunnel_interface_name.is_set)

                            def has_operation(self):
                                for c in self.sr_label_stack:
                                    if (c.has_operation()):
                                        return True
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.next_hop_address.yfilter != YFilter.not_set or
                                    self.out_label.yfilter != YFilter.not_set or
                                    self.parent_interface_name.yfilter != YFilter.not_set or
                                    self.physica_interface_name.yfilter != YFilter.not_set or
                                    self.tunnel_interface_name.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "backup-tunnel-rewrite" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.next_hop_address.is_set or self.next_hop_address.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.next_hop_address.get_name_leafdata())
                                if (self.out_label.is_set or self.out_label.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.out_label.get_name_leafdata())
                                if (self.parent_interface_name.is_set or self.parent_interface_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.parent_interface_name.get_name_leafdata())
                                if (self.physica_interface_name.is_set or self.physica_interface_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.physica_interface_name.get_name_leafdata())
                                if (self.tunnel_interface_name.is_set or self.tunnel_interface_name.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.tunnel_interface_name.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "sr-label-stack"):
                                    for c in self.sr_label_stack:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.PendingRewrite.BackupTunnelRewrite.SrLabelStack()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.sr_label_stack.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "sr-label-stack" or name == "next-hop-address" or name == "out-label" or name == "parent-interface-name" or name == "physica-interface-name" or name == "tunnel-interface-name"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "next-hop-address"):
                                    self.next_hop_address = value
                                    self.next_hop_address.value_namespace = name_space
                                    self.next_hop_address.value_namespace_prefix = name_space_prefix
                                if(value_path == "out-label"):
                                    self.out_label = value
                                    self.out_label.value_namespace = name_space
                                    self.out_label.value_namespace_prefix = name_space_prefix
                                if(value_path == "parent-interface-name"):
                                    self.parent_interface_name = value
                                    self.parent_interface_name.value_namespace = name_space
                                    self.parent_interface_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "physica-interface-name"):
                                    self.physica_interface_name = value
                                    self.physica_interface_name.value_namespace = name_space
                                    self.physica_interface_name.value_namespace_prefix = name_space_prefix
                                if(value_path == "tunnel-interface-name"):
                                    self.tunnel_interface_name = value
                                    self.tunnel_interface_name.value_namespace = name_space
                                    self.tunnel_interface_name.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.backup_active.is_set or
                                self.explicit_null.is_set or
                                self.label.is_set or
                                self.out_rewrite_role.is_set or
                                self.protocol_transported.is_set or
                                self.s2l_source.is_set or
                                self.timestamp.is_set or
                                (self.backup_tunnel_rewrite is not None and self.backup_tunnel_rewrite.has_data()) or
                                (self.primary_s2l is not None and self.primary_s2l.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.backup_active.yfilter != YFilter.not_set or
                                self.explicit_null.yfilter != YFilter.not_set or
                                self.label.yfilter != YFilter.not_set or
                                self.out_rewrite_role.yfilter != YFilter.not_set or
                                self.protocol_transported.yfilter != YFilter.not_set or
                                self.s2l_source.yfilter != YFilter.not_set or
                                self.timestamp.yfilter != YFilter.not_set or
                                (self.backup_tunnel_rewrite is not None and self.backup_tunnel_rewrite.has_operation()) or
                                (self.primary_s2l is not None and self.primary_s2l.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "pending-rewrite" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.backup_active.is_set or self.backup_active.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.backup_active.get_name_leafdata())
                            if (self.explicit_null.is_set or self.explicit_null.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.explicit_null.get_name_leafdata())
                            if (self.label.is_set or self.label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.label.get_name_leafdata())
                            if (self.out_rewrite_role.is_set or self.out_rewrite_role.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.out_rewrite_role.get_name_leafdata())
                            if (self.protocol_transported.is_set or self.protocol_transported.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.protocol_transported.get_name_leafdata())
                            if (self.s2l_source.is_set or self.s2l_source.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_source.get_name_leafdata())
                            if (self.timestamp.is_set or self.timestamp.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.timestamp.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "backup-tunnel-rewrite"):
                                if (self.backup_tunnel_rewrite is None):
                                    self.backup_tunnel_rewrite = MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.PendingRewrite.BackupTunnelRewrite()
                                    self.backup_tunnel_rewrite.parent = self
                                    self._children_name_map["backup_tunnel_rewrite"] = "backup-tunnel-rewrite"
                                return self.backup_tunnel_rewrite

                            if (child_yang_name == "primary-s2l"):
                                if (self.primary_s2l is None):
                                    self.primary_s2l = MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.PendingRewrite.PrimaryS2L()
                                    self.primary_s2l.parent = self
                                    self._children_name_map["primary_s2l"] = "primary-s2l"
                                return self.primary_s2l

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "backup-tunnel-rewrite" or name == "primary-s2l" or name == "backup-active" or name == "explicit-null" or name == "label" or name == "out-rewrite-role" or name == "protocol-transported" or name == "s2l-source" or name == "timestamp"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "backup-active"):
                                self.backup_active = value
                                self.backup_active.value_namespace = name_space
                                self.backup_active.value_namespace_prefix = name_space_prefix
                            if(value_path == "explicit-null"):
                                self.explicit_null = value
                                self.explicit_null.value_namespace = name_space
                                self.explicit_null.value_namespace_prefix = name_space_prefix
                            if(value_path == "label"):
                                self.label = value
                                self.label.value_namespace = name_space
                                self.label.value_namespace_prefix = name_space_prefix
                            if(value_path == "out-rewrite-role"):
                                self.out_rewrite_role = value
                                self.out_rewrite_role.value_namespace = name_space
                                self.out_rewrite_role.value_namespace_prefix = name_space_prefix
                            if(value_path == "protocol-transported"):
                                self.protocol_transported = value
                                self.protocol_transported.value_namespace = name_space
                                self.protocol_transported.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-source"):
                                self.s2l_source = value
                                self.s2l_source.value_namespace = name_space
                                self.s2l_source.value_namespace_prefix = name_space_prefix
                            if(value_path == "timestamp"):
                                self.timestamp = value
                                self.timestamp.value_namespace = name_space
                                self.timestamp.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            (self.failed_rewrite is not None and self.failed_rewrite.has_data()) or
                            (self.pending_rewrite is not None and self.pending_rewrite.has_data()) or
                            (self.subfamily is not None and self.subfamily.has_data()) or
                            (self.successful_rewrite is not None and self.successful_rewrite.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            (self.failed_rewrite is not None and self.failed_rewrite.has_operation()) or
                            (self.pending_rewrite is not None and self.pending_rewrite.has_operation()) or
                            (self.subfamily is not None and self.subfamily.has_operation()) or
                            (self.successful_rewrite is not None and self.successful_rewrite.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "s2l-output-rewrite" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "failed-rewrite"):
                            if (self.failed_rewrite is None):
                                self.failed_rewrite = MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.FailedRewrite()
                                self.failed_rewrite.parent = self
                                self._children_name_map["failed_rewrite"] = "failed-rewrite"
                            return self.failed_rewrite

                        if (child_yang_name == "pending-rewrite"):
                            if (self.pending_rewrite is None):
                                self.pending_rewrite = MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.PendingRewrite()
                                self.pending_rewrite.parent = self
                                self._children_name_map["pending_rewrite"] = "pending-rewrite"
                            return self.pending_rewrite

                        if (child_yang_name == "subfamily"):
                            if (self.subfamily is None):
                                self.subfamily = MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.Subfamily()
                                self.subfamily.parent = self
                                self._children_name_map["subfamily"] = "subfamily"
                            return self.subfamily

                        if (child_yang_name == "successful-rewrite"):
                            if (self.successful_rewrite is None):
                                self.successful_rewrite = MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite.SuccessfulRewrite()
                                self.successful_rewrite.parent = self
                                self._children_name_map["successful_rewrite"] = "successful-rewrite"
                            return self.successful_rewrite

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "failed-rewrite" or name == "pending-rewrite" or name == "subfamily" or name == "successful-rewrite"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class S2L(Entity):
                    """
                    Unique identifiers for the S2L sharing the
                    rewrite
                    
                    .. attribute:: destination_address
                    
                    	Destination
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: sub_group_id
                    
                    	S2L Sub\-Group ID
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: sub_group_original_id
                    
                    	S2L Sub\-Group Originator ID
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2L, self).__init__()

                        self.yang_name = "s2l"
                        self.yang_parent_name = "forwarding-output-label-rewrite"

                        self.destination_address = YLeaf(YType.str, "destination-address")

                        self.sub_group_id = YLeaf(YType.uint16, "sub-group-id")

                        self.sub_group_original_id = YLeaf(YType.str, "sub-group-original-id")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("destination_address",
                                        "sub_group_id",
                                        "sub_group_original_id") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2L, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2L, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.destination_address.is_set or
                            self.sub_group_id.is_set or
                            self.sub_group_original_id.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.destination_address.yfilter != YFilter.not_set or
                            self.sub_group_id.yfilter != YFilter.not_set or
                            self.sub_group_original_id.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "s2l" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.destination_address.get_name_leafdata())
                        if (self.sub_group_id.is_set or self.sub_group_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.sub_group_id.get_name_leafdata())
                        if (self.sub_group_original_id.is_set or self.sub_group_original_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.sub_group_original_id.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "destination-address" or name == "sub-group-id" or name == "sub-group-original-id"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "destination-address"):
                            self.destination_address = value
                            self.destination_address.value_namespace = name_space
                            self.destination_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "sub-group-id"):
                            self.sub_group_id = value
                            self.sub_group_id.value_namespace = name_space
                            self.sub_group_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "sub-group-original-id"):
                            self.sub_group_original_id = value
                            self.sub_group_original_id.value_namespace = name_space
                            self.sub_group_original_id.value_namespace_prefix = name_space_prefix


                class S2LsrPath(Entity):
                    """
                    Segment\-Routing Paths
                    
                    .. attribute:: backup_path_id
                    
                    	Backup Path Identifier
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: is_backup
                    
                    	True if path is backup
                    	**type**\:  bool
                    
                    .. attribute:: is_primary
                    
                    	True if path is primary
                    	**type**\:  bool
                    
                    .. attribute:: next_hop
                    
                    	Next hop
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: outgoing_interface
                    
                    	Outgoing Interface Name
                    	**type**\:  str
                    
                    .. attribute:: outgoing_labels_stack
                    
                    	Outgoing Labels Stack
                    	**type**\: list of    :py:class:`OutgoingLabelsStack <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LsrPath.OutgoingLabelsStack>`
                    
                    .. attribute:: path_id
                    
                    	Path Identifier
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LsrPath, self).__init__()

                        self.yang_name = "s2lsr-path"
                        self.yang_parent_name = "forwarding-output-label-rewrite"

                        self.backup_path_id = YLeaf(YType.uint32, "backup-path-id")

                        self.is_backup = YLeaf(YType.boolean, "is-backup")

                        self.is_primary = YLeaf(YType.boolean, "is-primary")

                        self.next_hop = YLeaf(YType.str, "next-hop")

                        self.outgoing_interface = YLeaf(YType.str, "outgoing-interface")

                        self.path_id = YLeaf(YType.uint32, "path-id")

                        self.outgoing_labels_stack = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("backup_path_id",
                                        "is_backup",
                                        "is_primary",
                                        "next_hop",
                                        "outgoing_interface",
                                        "path_id") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LsrPath, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LsrPath, self).__setattr__(name, value)


                    class OutgoingLabelsStack(Entity):
                        """
                        Outgoing Labels Stack
                        
                        .. attribute:: entry
                        
                        	
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LsrPath.OutgoingLabelsStack, self).__init__()

                            self.yang_name = "outgoing-labels-stack"
                            self.yang_parent_name = "s2lsr-path"

                            self.entry = YLeaf(YType.uint32, "entry")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("entry") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LsrPath.OutgoingLabelsStack, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LsrPath.OutgoingLabelsStack, self).__setattr__(name, value)

                        def has_data(self):
                            return self.entry.is_set

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.entry.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "outgoing-labels-stack" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.entry.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "entry"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "entry"):
                                self.entry = value
                                self.entry.value_namespace = name_space
                                self.entry.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.outgoing_labels_stack:
                            if (c.has_data()):
                                return True
                        return (
                            self.backup_path_id.is_set or
                            self.is_backup.is_set or
                            self.is_primary.is_set or
                            self.next_hop.is_set or
                            self.outgoing_interface.is_set or
                            self.path_id.is_set)

                    def has_operation(self):
                        for c in self.outgoing_labels_stack:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.backup_path_id.yfilter != YFilter.not_set or
                            self.is_backup.yfilter != YFilter.not_set or
                            self.is_primary.yfilter != YFilter.not_set or
                            self.next_hop.yfilter != YFilter.not_set or
                            self.outgoing_interface.yfilter != YFilter.not_set or
                            self.path_id.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "s2lsr-path" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.backup_path_id.is_set or self.backup_path_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.backup_path_id.get_name_leafdata())
                        if (self.is_backup.is_set or self.is_backup.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_backup.get_name_leafdata())
                        if (self.is_primary.is_set or self.is_primary.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_primary.get_name_leafdata())
                        if (self.next_hop.is_set or self.next_hop.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.next_hop.get_name_leafdata())
                        if (self.outgoing_interface.is_set or self.outgoing_interface.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.outgoing_interface.get_name_leafdata())
                        if (self.path_id.is_set or self.path_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.path_id.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "outgoing-labels-stack"):
                            for c in self.outgoing_labels_stack:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LsrPath.OutgoingLabelsStack()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.outgoing_labels_stack.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "outgoing-labels-stack" or name == "backup-path-id" or name == "is-backup" or name == "is-primary" or name == "next-hop" or name == "outgoing-interface" or name == "path-id"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "backup-path-id"):
                            self.backup_path_id = value
                            self.backup_path_id.value_namespace = name_space
                            self.backup_path_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-backup"):
                            self.is_backup = value
                            self.is_backup.value_namespace = name_space
                            self.is_backup.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-primary"):
                            self.is_primary = value
                            self.is_primary.value_namespace = name_space
                            self.is_primary.value_namespace_prefix = name_space_prefix
                        if(value_path == "next-hop"):
                            self.next_hop = value
                            self.next_hop.value_namespace = name_space
                            self.next_hop.value_namespace_prefix = name_space_prefix
                        if(value_path == "outgoing-interface"):
                            self.outgoing_interface = value
                            self.outgoing_interface.value_namespace = name_space
                            self.outgoing_interface.value_namespace_prefix = name_space_prefix
                        if(value_path == "path-id"):
                            self.path_id = value
                            self.path_id.value_namespace = name_space
                            self.path_id.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.s2l:
                        if (c.has_data()):
                            return True
                    for c in self.s2lsr_path:
                        if (c.has_data()):
                            return True
                    return (
                        self.tunnel_id.is_set or
                        self.lsp_id.is_set or
                        self.extended_tunnel_id.is_set or
                        self.source_address.is_set or
                        self.p2mp_id.is_set or
                        self.destination_address.is_set or
                        self.next_hop_address.is_set or
                        self.previous_hop_address.is_set or
                        self.ctype.is_set or
                        self.backup_tunnel_name.is_set or
                        self.is_segment_routing.is_set or
                        self.original_input_interface.is_set or
                        self.output_interface_name.is_set or
                        (self.s2l_output_rewrite is not None and self.s2l_output_rewrite.has_data()))

                def has_operation(self):
                    for c in self.s2l:
                        if (c.has_operation()):
                            return True
                    for c in self.s2lsr_path:
                        if (c.has_operation()):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        self.tunnel_id.yfilter != YFilter.not_set or
                        self.lsp_id.yfilter != YFilter.not_set or
                        self.extended_tunnel_id.yfilter != YFilter.not_set or
                        self.source_address.yfilter != YFilter.not_set or
                        self.p2mp_id.yfilter != YFilter.not_set or
                        self.destination_address.yfilter != YFilter.not_set or
                        self.next_hop_address.yfilter != YFilter.not_set or
                        self.previous_hop_address.yfilter != YFilter.not_set or
                        self.ctype.yfilter != YFilter.not_set or
                        self.backup_tunnel_name.yfilter != YFilter.not_set or
                        self.is_segment_routing.yfilter != YFilter.not_set or
                        self.original_input_interface.yfilter != YFilter.not_set or
                        self.output_interface_name.yfilter != YFilter.not_set or
                        (self.s2l_output_rewrite is not None and self.s2l_output_rewrite.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "forwarding-output-label-rewrite" + "[tunnel-id='" + self.tunnel_id.get() + "']" + "[lsp-id='" + self.lsp_id.get() + "']" + "[extended-tunnel-id='" + self.extended_tunnel_id.get() + "']" + "[source-address='" + self.source_address.get() + "']" + "[p2mp-id='" + self.p2mp_id.get() + "']" + "[destination-address='" + self.destination_address.get() + "']" + "[next-hop-address='" + self.next_hop_address.get() + "']" + "[previous-hop-address='" + self.previous_hop_address.get() + "']" + "[ctype='" + self.ctype.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/p2mp/forwarding-output-label-rewrites/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_id.get_name_leafdata())
                    if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.lsp_id.get_name_leafdata())
                    if (self.extended_tunnel_id.is_set or self.extended_tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.extended_tunnel_id.get_name_leafdata())
                    if (self.source_address.is_set or self.source_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.source_address.get_name_leafdata())
                    if (self.p2mp_id.is_set or self.p2mp_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.p2mp_id.get_name_leafdata())
                    if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.destination_address.get_name_leafdata())
                    if (self.next_hop_address.is_set or self.next_hop_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.next_hop_address.get_name_leafdata())
                    if (self.previous_hop_address.is_set or self.previous_hop_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.previous_hop_address.get_name_leafdata())
                    if (self.ctype.is_set or self.ctype.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.ctype.get_name_leafdata())
                    if (self.backup_tunnel_name.is_set or self.backup_tunnel_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.backup_tunnel_name.get_name_leafdata())
                    if (self.is_segment_routing.is_set or self.is_segment_routing.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_segment_routing.get_name_leafdata())
                    if (self.original_input_interface.is_set or self.original_input_interface.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.original_input_interface.get_name_leafdata())
                    if (self.output_interface_name.is_set or self.output_interface_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.output_interface_name.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "s2l"):
                        for c in self.s2l:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2L()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.s2l.append(c)
                        return c

                    if (child_yang_name == "s2l-output-rewrite"):
                        if (self.s2l_output_rewrite is None):
                            self.s2l_output_rewrite = MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LOutputRewrite()
                            self.s2l_output_rewrite.parent = self
                            self._children_name_map["s2l_output_rewrite"] = "s2l-output-rewrite"
                        return self.s2l_output_rewrite

                    if (child_yang_name == "s2lsr-path"):
                        for c in self.s2lsr_path:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite.S2LsrPath()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.s2lsr_path.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "s2l" or name == "s2l-output-rewrite" or name == "s2lsr-path" or name == "tunnel-id" or name == "lsp-id" or name == "extended-tunnel-id" or name == "source-address" or name == "p2mp-id" or name == "destination-address" or name == "next-hop-address" or name == "previous-hop-address" or name == "ctype" or name == "backup-tunnel-name" or name == "is-segment-routing" or name == "original-input-interface" or name == "output-interface-name"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "tunnel-id"):
                        self.tunnel_id = value
                        self.tunnel_id.value_namespace = name_space
                        self.tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "lsp-id"):
                        self.lsp_id = value
                        self.lsp_id.value_namespace = name_space
                        self.lsp_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "extended-tunnel-id"):
                        self.extended_tunnel_id = value
                        self.extended_tunnel_id.value_namespace = name_space
                        self.extended_tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "source-address"):
                        self.source_address = value
                        self.source_address.value_namespace = name_space
                        self.source_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "p2mp-id"):
                        self.p2mp_id = value
                        self.p2mp_id.value_namespace = name_space
                        self.p2mp_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "destination-address"):
                        self.destination_address = value
                        self.destination_address.value_namespace = name_space
                        self.destination_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "next-hop-address"):
                        self.next_hop_address = value
                        self.next_hop_address.value_namespace = name_space
                        self.next_hop_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "previous-hop-address"):
                        self.previous_hop_address = value
                        self.previous_hop_address.value_namespace = name_space
                        self.previous_hop_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "ctype"):
                        self.ctype = value
                        self.ctype.value_namespace = name_space
                        self.ctype.value_namespace_prefix = name_space_prefix
                    if(value_path == "backup-tunnel-name"):
                        self.backup_tunnel_name = value
                        self.backup_tunnel_name.value_namespace = name_space
                        self.backup_tunnel_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-segment-routing"):
                        self.is_segment_routing = value
                        self.is_segment_routing.value_namespace = name_space
                        self.is_segment_routing.value_namespace_prefix = name_space_prefix
                    if(value_path == "original-input-interface"):
                        self.original_input_interface = value
                        self.original_input_interface.value_namespace = name_space
                        self.original_input_interface.value_namespace_prefix = name_space_prefix
                    if(value_path == "output-interface-name"):
                        self.output_interface_name = value
                        self.output_interface_name.value_namespace = name_space
                        self.output_interface_name.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.forwarding_output_label_rewrite:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.forwarding_output_label_rewrite:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "forwarding-output-label-rewrites" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/p2mp/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "forwarding-output-label-rewrite"):
                    for c in self.forwarding_output_label_rewrite:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites.ForwardingOutputLabelRewrite()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.forwarding_output_label_rewrite.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "forwarding-output-label-rewrite"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass

        def has_data(self):
            return (
                (self.collaborator_timers is not None and self.collaborator_timers.has_data()) or
                (self.forwarding_output_label_rewrites is not None and self.forwarding_output_label_rewrites.has_data()) or
                (self.tunnel_rewrites is not None and self.tunnel_rewrites.has_data()))

        def has_operation(self):
            return (
                self.yfilter != YFilter.not_set or
                (self.collaborator_timers is not None and self.collaborator_timers.has_operation()) or
                (self.forwarding_output_label_rewrites is not None and self.forwarding_output_label_rewrites.has_operation()) or
                (self.tunnel_rewrites is not None and self.tunnel_rewrites.has_operation()))

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "p2mp" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "collaborator-timers"):
                if (self.collaborator_timers is None):
                    self.collaborator_timers = MplsTeStandby.P2Mp.CollaboratorTimers()
                    self.collaborator_timers.parent = self
                    self._children_name_map["collaborator_timers"] = "collaborator-timers"
                return self.collaborator_timers

            if (child_yang_name == "forwarding-output-label-rewrites"):
                if (self.forwarding_output_label_rewrites is None):
                    self.forwarding_output_label_rewrites = MplsTeStandby.P2Mp.ForwardingOutputLabelRewrites()
                    self.forwarding_output_label_rewrites.parent = self
                    self._children_name_map["forwarding_output_label_rewrites"] = "forwarding-output-label-rewrites"
                return self.forwarding_output_label_rewrites

            if (child_yang_name == "tunnel-rewrites"):
                if (self.tunnel_rewrites is None):
                    self.tunnel_rewrites = MplsTeStandby.P2Mp.TunnelRewrites()
                    self.tunnel_rewrites.parent = self
                    self._children_name_map["tunnel_rewrites"] = "tunnel-rewrites"
                return self.tunnel_rewrites

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "collaborator-timers" or name == "forwarding-output-label-rewrites" or name == "tunnel-rewrites"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class OpenConfig(Entity):
        """
        OpenConfig MPLS TE operational data
        
        .. attribute:: lsp_counters
        
        	Table of LSP Counters
        	**type**\:   :py:class:`LspCounters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.OpenConfig.LspCounters>`
        
        .. attribute:: lsp_states
        
        	Table of LSP State Info
        	**type**\:   :py:class:`LspStates <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.OpenConfig.LspStates>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsTeStandby.OpenConfig, self).__init__()

            self.yang_name = "open-config"
            self.yang_parent_name = "mpls-te-standby"

            self.lsp_counters = MplsTeStandby.OpenConfig.LspCounters()
            self.lsp_counters.parent = self
            self._children_name_map["lsp_counters"] = "lsp-counters"
            self._children_yang_names.add("lsp-counters")

            self.lsp_states = MplsTeStandby.OpenConfig.LspStates()
            self.lsp_states.parent = self
            self._children_name_map["lsp_states"] = "lsp-states"
            self._children_yang_names.add("lsp-states")


        class LspStates(Entity):
            """
            Table of LSP State Info
            
            .. attribute:: lsp_state
            
            	MPLS TE LSP State Info
            	**type**\: list of    :py:class:`LspState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.OpenConfig.LspStates.LspState>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTeStandby.OpenConfig.LspStates, self).__init__()

                self.yang_name = "lsp-states"
                self.yang_parent_name = "open-config"

                self.lsp_state = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTeStandby.OpenConfig.LspStates, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTeStandby.OpenConfig.LspStates, self).__setattr__(name, value)


            class LspState(Entity):
                """
                MPLS TE LSP State Info
                
                .. attribute:: tunnel_name  <key>
                
                	Tunnel Name
                	**type**\:  str
                
                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                
                .. attribute:: tunnel_type  <key>
                
                	Tunnel Type
                	**type**\:   :py:class:`OcMplsTeTunnel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.OcMplsTeTunnel>`
                
                .. attribute:: admin_status
                
                	Admin Status
                	**type**\:   :py:class:`LspAdminStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.LspAdminStatus>`
                
                .. attribute:: description
                
                	Description
                	**type**\:  str
                
                .. attribute:: hold_priority
                
                	Hold priority
                	**type**\:  int
                
                	**range:** 0..255
                
                .. attribute:: local_id
                
                	Local ID \- TBD
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: metric
                
                	Metric type
                	**type**\:   :py:class:`OcMplsTeMetric <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.OcMplsTeMetric>`
                
                .. attribute:: name
                
                	LSP Name
                	**type**\:  str
                
                .. attribute:: oper_status
                
                	Operational Status
                	**type**\:   :py:class:`LspOperStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.LspOperStatus>`
                
                .. attribute:: protection_style_requested
                
                	Protection Style Requested
                	**type**\:   :py:class:`MplsProtection <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsProtection>`
                
                .. attribute:: reoptimize_timer
                
                	frequency of reoptimization
                	**type**\:  int
                
                	**range:** 0..65535
                
                .. attribute:: role
                
                	Role
                	**type**\:   :py:class:`MplsTeLspRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeLspRole>`
                
                .. attribute:: setup_priority
                
                	Setup priority
                	**type**\:  int
                
                	**range:** 0..255
                
                .. attribute:: signaling_protocol
                
                	Signaling Protocol
                	**type**\:   :py:class:`MplsTeProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeProtocol>`
                
                .. attribute:: soft_preemption
                
                	Soft Preemption
                	**type**\:  bool
                
                .. attribute:: source
                
                	Source Address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: type
                
                	LSP Type
                	**type**\:   :py:class:`OcMplsTeLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.OcMplsTeLsp>`
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTeStandby.OpenConfig.LspStates.LspState, self).__init__()

                    self.yang_name = "lsp-state"
                    self.yang_parent_name = "lsp-states"

                    self.tunnel_name = YLeaf(YType.str, "tunnel-name")

                    self.tunnel_type = YLeaf(YType.enumeration, "tunnel-type")

                    self.admin_status = YLeaf(YType.enumeration, "admin-status")

                    self.description = YLeaf(YType.str, "description")

                    self.hold_priority = YLeaf(YType.uint8, "hold-priority")

                    self.local_id = YLeaf(YType.uint32, "local-id")

                    self.metric = YLeaf(YType.enumeration, "metric")

                    self.name = YLeaf(YType.str, "name")

                    self.oper_status = YLeaf(YType.enumeration, "oper-status")

                    self.protection_style_requested = YLeaf(YType.enumeration, "protection-style-requested")

                    self.reoptimize_timer = YLeaf(YType.uint16, "reoptimize-timer")

                    self.role = YLeaf(YType.enumeration, "role")

                    self.setup_priority = YLeaf(YType.uint8, "setup-priority")

                    self.signaling_protocol = YLeaf(YType.enumeration, "signaling-protocol")

                    self.soft_preemption = YLeaf(YType.boolean, "soft-preemption")

                    self.source = YLeaf(YType.str, "source")

                    self.type = YLeaf(YType.enumeration, "type")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("tunnel_name",
                                    "tunnel_type",
                                    "admin_status",
                                    "description",
                                    "hold_priority",
                                    "local_id",
                                    "metric",
                                    "name",
                                    "oper_status",
                                    "protection_style_requested",
                                    "reoptimize_timer",
                                    "role",
                                    "setup_priority",
                                    "signaling_protocol",
                                    "soft_preemption",
                                    "source",
                                    "type") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTeStandby.OpenConfig.LspStates.LspState, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTeStandby.OpenConfig.LspStates.LspState, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.tunnel_name.is_set or
                        self.tunnel_type.is_set or
                        self.admin_status.is_set or
                        self.description.is_set or
                        self.hold_priority.is_set or
                        self.local_id.is_set or
                        self.metric.is_set or
                        self.name.is_set or
                        self.oper_status.is_set or
                        self.protection_style_requested.is_set or
                        self.reoptimize_timer.is_set or
                        self.role.is_set or
                        self.setup_priority.is_set or
                        self.signaling_protocol.is_set or
                        self.soft_preemption.is_set or
                        self.source.is_set or
                        self.type.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.tunnel_name.yfilter != YFilter.not_set or
                        self.tunnel_type.yfilter != YFilter.not_set or
                        self.admin_status.yfilter != YFilter.not_set or
                        self.description.yfilter != YFilter.not_set or
                        self.hold_priority.yfilter != YFilter.not_set or
                        self.local_id.yfilter != YFilter.not_set or
                        self.metric.yfilter != YFilter.not_set or
                        self.name.yfilter != YFilter.not_set or
                        self.oper_status.yfilter != YFilter.not_set or
                        self.protection_style_requested.yfilter != YFilter.not_set or
                        self.reoptimize_timer.yfilter != YFilter.not_set or
                        self.role.yfilter != YFilter.not_set or
                        self.setup_priority.yfilter != YFilter.not_set or
                        self.signaling_protocol.yfilter != YFilter.not_set or
                        self.soft_preemption.yfilter != YFilter.not_set or
                        self.source.yfilter != YFilter.not_set or
                        self.type.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "lsp-state" + "[tunnel-name='" + self.tunnel_name.get() + "']" + "[tunnel-type='" + self.tunnel_type.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/open-config/lsp-states/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.tunnel_name.is_set or self.tunnel_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_name.get_name_leafdata())
                    if (self.tunnel_type.is_set or self.tunnel_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_type.get_name_leafdata())
                    if (self.admin_status.is_set or self.admin_status.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.admin_status.get_name_leafdata())
                    if (self.description.is_set or self.description.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.description.get_name_leafdata())
                    if (self.hold_priority.is_set or self.hold_priority.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.hold_priority.get_name_leafdata())
                    if (self.local_id.is_set or self.local_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.local_id.get_name_leafdata())
                    if (self.metric.is_set or self.metric.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.metric.get_name_leafdata())
                    if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.name.get_name_leafdata())
                    if (self.oper_status.is_set or self.oper_status.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.oper_status.get_name_leafdata())
                    if (self.protection_style_requested.is_set or self.protection_style_requested.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.protection_style_requested.get_name_leafdata())
                    if (self.reoptimize_timer.is_set or self.reoptimize_timer.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.reoptimize_timer.get_name_leafdata())
                    if (self.role.is_set or self.role.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.role.get_name_leafdata())
                    if (self.setup_priority.is_set or self.setup_priority.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.setup_priority.get_name_leafdata())
                    if (self.signaling_protocol.is_set or self.signaling_protocol.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.signaling_protocol.get_name_leafdata())
                    if (self.soft_preemption.is_set or self.soft_preemption.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.soft_preemption.get_name_leafdata())
                    if (self.source.is_set or self.source.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.source.get_name_leafdata())
                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.type.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "tunnel-name" or name == "tunnel-type" or name == "admin-status" or name == "description" or name == "hold-priority" or name == "local-id" or name == "metric" or name == "name" or name == "oper-status" or name == "protection-style-requested" or name == "reoptimize-timer" or name == "role" or name == "setup-priority" or name == "signaling-protocol" or name == "soft-preemption" or name == "source" or name == "type"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "tunnel-name"):
                        self.tunnel_name = value
                        self.tunnel_name.value_namespace = name_space
                        self.tunnel_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-type"):
                        self.tunnel_type = value
                        self.tunnel_type.value_namespace = name_space
                        self.tunnel_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "admin-status"):
                        self.admin_status = value
                        self.admin_status.value_namespace = name_space
                        self.admin_status.value_namespace_prefix = name_space_prefix
                    if(value_path == "description"):
                        self.description = value
                        self.description.value_namespace = name_space
                        self.description.value_namespace_prefix = name_space_prefix
                    if(value_path == "hold-priority"):
                        self.hold_priority = value
                        self.hold_priority.value_namespace = name_space
                        self.hold_priority.value_namespace_prefix = name_space_prefix
                    if(value_path == "local-id"):
                        self.local_id = value
                        self.local_id.value_namespace = name_space
                        self.local_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "metric"):
                        self.metric = value
                        self.metric.value_namespace = name_space
                        self.metric.value_namespace_prefix = name_space_prefix
                    if(value_path == "name"):
                        self.name = value
                        self.name.value_namespace = name_space
                        self.name.value_namespace_prefix = name_space_prefix
                    if(value_path == "oper-status"):
                        self.oper_status = value
                        self.oper_status.value_namespace = name_space
                        self.oper_status.value_namespace_prefix = name_space_prefix
                    if(value_path == "protection-style-requested"):
                        self.protection_style_requested = value
                        self.protection_style_requested.value_namespace = name_space
                        self.protection_style_requested.value_namespace_prefix = name_space_prefix
                    if(value_path == "reoptimize-timer"):
                        self.reoptimize_timer = value
                        self.reoptimize_timer.value_namespace = name_space
                        self.reoptimize_timer.value_namespace_prefix = name_space_prefix
                    if(value_path == "role"):
                        self.role = value
                        self.role.value_namespace = name_space
                        self.role.value_namespace_prefix = name_space_prefix
                    if(value_path == "setup-priority"):
                        self.setup_priority = value
                        self.setup_priority.value_namespace = name_space
                        self.setup_priority.value_namespace_prefix = name_space_prefix
                    if(value_path == "signaling-protocol"):
                        self.signaling_protocol = value
                        self.signaling_protocol.value_namespace = name_space
                        self.signaling_protocol.value_namespace_prefix = name_space_prefix
                    if(value_path == "soft-preemption"):
                        self.soft_preemption = value
                        self.soft_preemption.value_namespace = name_space
                        self.soft_preemption.value_namespace_prefix = name_space_prefix
                    if(value_path == "source"):
                        self.source = value
                        self.source.value_namespace = name_space
                        self.source.value_namespace_prefix = name_space_prefix
                    if(value_path == "type"):
                        self.type = value
                        self.type.value_namespace = name_space
                        self.type.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.lsp_state:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.lsp_state:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "lsp-states" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/open-config/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "lsp-state"):
                    for c in self.lsp_state:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTeStandby.OpenConfig.LspStates.LspState()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.lsp_state.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "lsp-state"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass


        class LspCounters(Entity):
            """
            Table of LSP Counters
            
            .. attribute:: lsp_counter
            
            	MPLS TE LSP Counters
            	**type**\: list of    :py:class:`LspCounter <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.OpenConfig.LspCounters.LspCounter>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTeStandby.OpenConfig.LspCounters, self).__init__()

                self.yang_name = "lsp-counters"
                self.yang_parent_name = "open-config"

                self.lsp_counter = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTeStandby.OpenConfig.LspCounters, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTeStandby.OpenConfig.LspCounters, self).__setattr__(name, value)


            class LspCounter(Entity):
                """
                MPLS TE LSP Counters
                
                .. attribute:: tunnel_name  <key>
                
                	Tunnel Name
                	**type**\:  str
                
                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                
                .. attribute:: tunnel_type  <key>
                
                	Tunnel Type
                	**type**\:   :py:class:`OcMplsTeTunnel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.OcMplsTeTunnel>`
                
                .. attribute:: bytes
                
                	Number of bytes forwarded over the lsp
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                	**units**\: byte
                
                .. attribute:: current_path_time
                
                	Timestamp of LSP switched onto current path
                	**type**\:  str
                
                .. attribute:: name
                
                	LSP Name
                	**type**\:  str
                
                .. attribute:: next_reoptimization_time
                
                	Timestamp of next scheduled reoptmiziation
                	**type**\:  str
                
                .. attribute:: online_time
                
                	Timestamp of LSP oper state up
                	**type**\:  str
                
                .. attribute:: packets
                
                	Number of packets forwarded over the lsp
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                .. attribute:: path_changes
                
                	Number of path changes for the lsp
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                .. attribute:: state_changes
                
                	Number of state changes for the lsp
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                .. attribute:: type
                
                	LSP Type
                	**type**\:   :py:class:`OcMplsTeLsp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.OcMplsTeLsp>`
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTeStandby.OpenConfig.LspCounters.LspCounter, self).__init__()

                    self.yang_name = "lsp-counter"
                    self.yang_parent_name = "lsp-counters"

                    self.tunnel_name = YLeaf(YType.str, "tunnel-name")

                    self.tunnel_type = YLeaf(YType.enumeration, "tunnel-type")

                    self.bytes = YLeaf(YType.uint64, "bytes")

                    self.current_path_time = YLeaf(YType.str, "current-path-time")

                    self.name = YLeaf(YType.str, "name")

                    self.next_reoptimization_time = YLeaf(YType.str, "next-reoptimization-time")

                    self.online_time = YLeaf(YType.str, "online-time")

                    self.packets = YLeaf(YType.uint64, "packets")

                    self.path_changes = YLeaf(YType.uint64, "path-changes")

                    self.state_changes = YLeaf(YType.uint64, "state-changes")

                    self.type = YLeaf(YType.enumeration, "type")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("tunnel_name",
                                    "tunnel_type",
                                    "bytes",
                                    "current_path_time",
                                    "name",
                                    "next_reoptimization_time",
                                    "online_time",
                                    "packets",
                                    "path_changes",
                                    "state_changes",
                                    "type") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTeStandby.OpenConfig.LspCounters.LspCounter, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTeStandby.OpenConfig.LspCounters.LspCounter, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.tunnel_name.is_set or
                        self.tunnel_type.is_set or
                        self.bytes.is_set or
                        self.current_path_time.is_set or
                        self.name.is_set or
                        self.next_reoptimization_time.is_set or
                        self.online_time.is_set or
                        self.packets.is_set or
                        self.path_changes.is_set or
                        self.state_changes.is_set or
                        self.type.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.tunnel_name.yfilter != YFilter.not_set or
                        self.tunnel_type.yfilter != YFilter.not_set or
                        self.bytes.yfilter != YFilter.not_set or
                        self.current_path_time.yfilter != YFilter.not_set or
                        self.name.yfilter != YFilter.not_set or
                        self.next_reoptimization_time.yfilter != YFilter.not_set or
                        self.online_time.yfilter != YFilter.not_set or
                        self.packets.yfilter != YFilter.not_set or
                        self.path_changes.yfilter != YFilter.not_set or
                        self.state_changes.yfilter != YFilter.not_set or
                        self.type.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "lsp-counter" + "[tunnel-name='" + self.tunnel_name.get() + "']" + "[tunnel-type='" + self.tunnel_type.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/open-config/lsp-counters/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.tunnel_name.is_set or self.tunnel_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_name.get_name_leafdata())
                    if (self.tunnel_type.is_set or self.tunnel_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_type.get_name_leafdata())
                    if (self.bytes.is_set or self.bytes.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.bytes.get_name_leafdata())
                    if (self.current_path_time.is_set or self.current_path_time.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.current_path_time.get_name_leafdata())
                    if (self.name.is_set or self.name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.name.get_name_leafdata())
                    if (self.next_reoptimization_time.is_set or self.next_reoptimization_time.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.next_reoptimization_time.get_name_leafdata())
                    if (self.online_time.is_set or self.online_time.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.online_time.get_name_leafdata())
                    if (self.packets.is_set or self.packets.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.packets.get_name_leafdata())
                    if (self.path_changes.is_set or self.path_changes.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.path_changes.get_name_leafdata())
                    if (self.state_changes.is_set or self.state_changes.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.state_changes.get_name_leafdata())
                    if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.type.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "tunnel-name" or name == "tunnel-type" or name == "bytes" or name == "current-path-time" or name == "name" or name == "next-reoptimization-time" or name == "online-time" or name == "packets" or name == "path-changes" or name == "state-changes" or name == "type"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "tunnel-name"):
                        self.tunnel_name = value
                        self.tunnel_name.value_namespace = name_space
                        self.tunnel_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-type"):
                        self.tunnel_type = value
                        self.tunnel_type.value_namespace = name_space
                        self.tunnel_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "bytes"):
                        self.bytes = value
                        self.bytes.value_namespace = name_space
                        self.bytes.value_namespace_prefix = name_space_prefix
                    if(value_path == "current-path-time"):
                        self.current_path_time = value
                        self.current_path_time.value_namespace = name_space
                        self.current_path_time.value_namespace_prefix = name_space_prefix
                    if(value_path == "name"):
                        self.name = value
                        self.name.value_namespace = name_space
                        self.name.value_namespace_prefix = name_space_prefix
                    if(value_path == "next-reoptimization-time"):
                        self.next_reoptimization_time = value
                        self.next_reoptimization_time.value_namespace = name_space
                        self.next_reoptimization_time.value_namespace_prefix = name_space_prefix
                    if(value_path == "online-time"):
                        self.online_time = value
                        self.online_time.value_namespace = name_space
                        self.online_time.value_namespace_prefix = name_space_prefix
                    if(value_path == "packets"):
                        self.packets = value
                        self.packets.value_namespace = name_space
                        self.packets.value_namespace_prefix = name_space_prefix
                    if(value_path == "path-changes"):
                        self.path_changes = value
                        self.path_changes.value_namespace = name_space
                        self.path_changes.value_namespace_prefix = name_space_prefix
                    if(value_path == "state-changes"):
                        self.state_changes = value
                        self.state_changes.value_namespace = name_space
                        self.state_changes.value_namespace_prefix = name_space_prefix
                    if(value_path == "type"):
                        self.type = value
                        self.type.value_namespace = name_space
                        self.type.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.lsp_counter:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.lsp_counter:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "lsp-counters" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/open-config/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "lsp-counter"):
                    for c in self.lsp_counter:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTeStandby.OpenConfig.LspCounters.LspCounter()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.lsp_counter.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "lsp-counter"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass

        def has_data(self):
            return (
                (self.lsp_counters is not None and self.lsp_counters.has_data()) or
                (self.lsp_states is not None and self.lsp_states.has_data()))

        def has_operation(self):
            return (
                self.yfilter != YFilter.not_set or
                (self.lsp_counters is not None and self.lsp_counters.has_operation()) or
                (self.lsp_states is not None and self.lsp_states.has_operation()))

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "open-config" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "lsp-counters"):
                if (self.lsp_counters is None):
                    self.lsp_counters = MplsTeStandby.OpenConfig.LspCounters()
                    self.lsp_counters.parent = self
                    self._children_name_map["lsp_counters"] = "lsp-counters"
                return self.lsp_counters

            if (child_yang_name == "lsp-states"):
                if (self.lsp_states is None):
                    self.lsp_states = MplsTeStandby.OpenConfig.LspStates()
                    self.lsp_states.parent = self
                    self._children_name_map["lsp_states"] = "lsp-states"
                return self.lsp_states

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "lsp-counters" or name == "lsp-states"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class LspOutOfResources(Entity):
        """
        LSP OOR information
        
        .. attribute:: summary
        
        	LSP OOR Summary information
        	**type**\:   :py:class:`Summary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.LspOutOfResources.Summary>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsTeStandby.LspOutOfResources, self).__init__()

            self.yang_name = "lsp-out-of-resources"
            self.yang_parent_name = "mpls-te-standby"

            self.summary = MplsTeStandby.LspOutOfResources.Summary()
            self.summary.parent = self
            self._children_name_map["summary"] = "summary"
            self._children_yang_names.add("summary")


        class Summary(Entity):
            """
            LSP OOR Summary information
            
            .. attribute:: lsp_oor_green_recovery_time
            
            	Time Remaining in Green Recovery State (seconds)
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            	**units**\: second
            
            .. attribute:: lsp_oor_state
            
            	The current LSP OOR state
            	**type**\:   :py:class:`LspOorState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.LspOorState>`
            
            .. attribute:: lsp_oor_state_xr
            
            	Array of LSP OOR info per state
            	**type**\: list of    :py:class:`LspOorStateXr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.LspOutOfResources.Summary.LspOorStateXr>`
            
            .. attribute:: lsp_oor_timestamp
            
            	Timestamp when the OOR state last changed
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: transit_lsp_total_count
            
            	Number of all transit LSPs on the router
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: transit_lsp_unprotected_count
            
            	Number of unprotected transit LSPs on the router
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTeStandby.LspOutOfResources.Summary, self).__init__()

                self.yang_name = "summary"
                self.yang_parent_name = "lsp-out-of-resources"

                self.lsp_oor_green_recovery_time = YLeaf(YType.uint32, "lsp-oor-green-recovery-time")

                self.lsp_oor_state = YLeaf(YType.enumeration, "lsp-oor-state")

                self.lsp_oor_timestamp = YLeaf(YType.uint32, "lsp-oor-timestamp")

                self.transit_lsp_total_count = YLeaf(YType.uint32, "transit-lsp-total-count")

                self.transit_lsp_unprotected_count = YLeaf(YType.uint32, "transit-lsp-unprotected-count")

                self.lsp_oor_state_xr = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("lsp_oor_green_recovery_time",
                                "lsp_oor_state",
                                "lsp_oor_timestamp",
                                "transit_lsp_total_count",
                                "transit_lsp_unprotected_count") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTeStandby.LspOutOfResources.Summary, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTeStandby.LspOutOfResources.Summary, self).__setattr__(name, value)


            class LspOorStateXr(Entity):
                """
                Array of LSP OOR info per state
                
                .. attribute:: accept_reopt
                
                	Make\-before\-break is allowed for LSPs reoptimizing over the same link in the LSP OOR state
                	**type**\:  bool
                
                .. attribute:: available_bw_percentage
                
                	The flooded percentage of available bandwidth advertized when the link is in this LSP OOR state
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: percentage
                
                .. attribute:: lsp_oor_state
                
                	The LSP\-OOR state that this information belongs to
                	**type**\:   :py:class:`LspOorState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.LspOorState>`
                
                .. attribute:: minimum_lsp_bandwidth
                
                	Minimum LSP bandwidth so the LSP is admitted when the link is in this LSP OOR state
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: statistics
                
                	LSP OOR Statistics
                	**type**\:   :py:class:`Statistics <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.LspOutOfResources.Summary.LspOorStateXr.Statistics>`
                
                .. attribute:: te_metric_penalty
                
                	The TE metric penalty when the link is in this LSP OOR state
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: threshold_transit_all
                
                	The number of transit LSPs that triggers OOR state transition
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: threshold_transit_unprotected
                
                	The number of unprotected transit LSPs that triggers OOR state transition
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: transition_duration
                
                	Recovery in minutes after the green LSP OOR state is entered
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                	**units**\: minute
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTeStandby.LspOutOfResources.Summary.LspOorStateXr, self).__init__()

                    self.yang_name = "lsp-oor-state-xr"
                    self.yang_parent_name = "summary"

                    self.accept_reopt = YLeaf(YType.boolean, "accept-reopt")

                    self.available_bw_percentage = YLeaf(YType.uint32, "available-bw-percentage")

                    self.lsp_oor_state = YLeaf(YType.enumeration, "lsp-oor-state")

                    self.minimum_lsp_bandwidth = YLeaf(YType.uint32, "minimum-lsp-bandwidth")

                    self.te_metric_penalty = YLeaf(YType.uint32, "te-metric-penalty")

                    self.threshold_transit_all = YLeaf(YType.uint32, "threshold-transit-all")

                    self.threshold_transit_unprotected = YLeaf(YType.uint32, "threshold-transit-unprotected")

                    self.transition_duration = YLeaf(YType.uint32, "transition-duration")

                    self.statistics = MplsTeStandby.LspOutOfResources.Summary.LspOorStateXr.Statistics()
                    self.statistics.parent = self
                    self._children_name_map["statistics"] = "statistics"
                    self._children_yang_names.add("statistics")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("accept_reopt",
                                    "available_bw_percentage",
                                    "lsp_oor_state",
                                    "minimum_lsp_bandwidth",
                                    "te_metric_penalty",
                                    "threshold_transit_all",
                                    "threshold_transit_unprotected",
                                    "transition_duration") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTeStandby.LspOutOfResources.Summary.LspOorStateXr, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTeStandby.LspOutOfResources.Summary.LspOorStateXr, self).__setattr__(name, value)


                class Statistics(Entity):
                    """
                    LSP OOR Statistics
                    
                    .. attribute:: accepted_ls_ps_number
                    
                    	Number of LSPs that were accepted in this state
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: accepted_reopt_ls_ps_number
                    
                    	Number of Reoptimize LSPs that were accepted in this state
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rejected_ls_ps_number
                    
                    	Number of LSPs that were rejected in this state
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: rejected_reopt_ls_ps_number
                    
                    	Number of Reoptimize LSPs that were rejected in this state
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: transitions
                    
                    	Number of transitions to this state
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.LspOutOfResources.Summary.LspOorStateXr.Statistics, self).__init__()

                        self.yang_name = "statistics"
                        self.yang_parent_name = "lsp-oor-state-xr"

                        self.accepted_ls_ps_number = YLeaf(YType.uint32, "accepted-ls-ps-number")

                        self.accepted_reopt_ls_ps_number = YLeaf(YType.uint32, "accepted-reopt-ls-ps-number")

                        self.rejected_ls_ps_number = YLeaf(YType.uint32, "rejected-ls-ps-number")

                        self.rejected_reopt_ls_ps_number = YLeaf(YType.uint32, "rejected-reopt-ls-ps-number")

                        self.transitions = YLeaf(YType.uint32, "transitions")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("accepted_ls_ps_number",
                                        "accepted_reopt_ls_ps_number",
                                        "rejected_ls_ps_number",
                                        "rejected_reopt_ls_ps_number",
                                        "transitions") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.LspOutOfResources.Summary.LspOorStateXr.Statistics, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.LspOutOfResources.Summary.LspOorStateXr.Statistics, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.accepted_ls_ps_number.is_set or
                            self.accepted_reopt_ls_ps_number.is_set or
                            self.rejected_ls_ps_number.is_set or
                            self.rejected_reopt_ls_ps_number.is_set or
                            self.transitions.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.accepted_ls_ps_number.yfilter != YFilter.not_set or
                            self.accepted_reopt_ls_ps_number.yfilter != YFilter.not_set or
                            self.rejected_ls_ps_number.yfilter != YFilter.not_set or
                            self.rejected_reopt_ls_ps_number.yfilter != YFilter.not_set or
                            self.transitions.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "statistics" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/lsp-out-of-resources/summary/lsp-oor-state-xr/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.accepted_ls_ps_number.is_set or self.accepted_ls_ps_number.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.accepted_ls_ps_number.get_name_leafdata())
                        if (self.accepted_reopt_ls_ps_number.is_set or self.accepted_reopt_ls_ps_number.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.accepted_reopt_ls_ps_number.get_name_leafdata())
                        if (self.rejected_ls_ps_number.is_set or self.rejected_ls_ps_number.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rejected_ls_ps_number.get_name_leafdata())
                        if (self.rejected_reopt_ls_ps_number.is_set or self.rejected_reopt_ls_ps_number.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.rejected_reopt_ls_ps_number.get_name_leafdata())
                        if (self.transitions.is_set or self.transitions.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.transitions.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "accepted-ls-ps-number" or name == "accepted-reopt-ls-ps-number" or name == "rejected-ls-ps-number" or name == "rejected-reopt-ls-ps-number" or name == "transitions"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "accepted-ls-ps-number"):
                            self.accepted_ls_ps_number = value
                            self.accepted_ls_ps_number.value_namespace = name_space
                            self.accepted_ls_ps_number.value_namespace_prefix = name_space_prefix
                        if(value_path == "accepted-reopt-ls-ps-number"):
                            self.accepted_reopt_ls_ps_number = value
                            self.accepted_reopt_ls_ps_number.value_namespace = name_space
                            self.accepted_reopt_ls_ps_number.value_namespace_prefix = name_space_prefix
                        if(value_path == "rejected-ls-ps-number"):
                            self.rejected_ls_ps_number = value
                            self.rejected_ls_ps_number.value_namespace = name_space
                            self.rejected_ls_ps_number.value_namespace_prefix = name_space_prefix
                        if(value_path == "rejected-reopt-ls-ps-number"):
                            self.rejected_reopt_ls_ps_number = value
                            self.rejected_reopt_ls_ps_number.value_namespace = name_space
                            self.rejected_reopt_ls_ps_number.value_namespace_prefix = name_space_prefix
                        if(value_path == "transitions"):
                            self.transitions = value
                            self.transitions.value_namespace = name_space
                            self.transitions.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    return (
                        self.accept_reopt.is_set or
                        self.available_bw_percentage.is_set or
                        self.lsp_oor_state.is_set or
                        self.minimum_lsp_bandwidth.is_set or
                        self.te_metric_penalty.is_set or
                        self.threshold_transit_all.is_set or
                        self.threshold_transit_unprotected.is_set or
                        self.transition_duration.is_set or
                        (self.statistics is not None and self.statistics.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.accept_reopt.yfilter != YFilter.not_set or
                        self.available_bw_percentage.yfilter != YFilter.not_set or
                        self.lsp_oor_state.yfilter != YFilter.not_set or
                        self.minimum_lsp_bandwidth.yfilter != YFilter.not_set or
                        self.te_metric_penalty.yfilter != YFilter.not_set or
                        self.threshold_transit_all.yfilter != YFilter.not_set or
                        self.threshold_transit_unprotected.yfilter != YFilter.not_set or
                        self.transition_duration.yfilter != YFilter.not_set or
                        (self.statistics is not None and self.statistics.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "lsp-oor-state-xr" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/lsp-out-of-resources/summary/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.accept_reopt.is_set or self.accept_reopt.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.accept_reopt.get_name_leafdata())
                    if (self.available_bw_percentage.is_set or self.available_bw_percentage.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.available_bw_percentage.get_name_leafdata())
                    if (self.lsp_oor_state.is_set or self.lsp_oor_state.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.lsp_oor_state.get_name_leafdata())
                    if (self.minimum_lsp_bandwidth.is_set or self.minimum_lsp_bandwidth.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.minimum_lsp_bandwidth.get_name_leafdata())
                    if (self.te_metric_penalty.is_set or self.te_metric_penalty.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.te_metric_penalty.get_name_leafdata())
                    if (self.threshold_transit_all.is_set or self.threshold_transit_all.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.threshold_transit_all.get_name_leafdata())
                    if (self.threshold_transit_unprotected.is_set or self.threshold_transit_unprotected.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.threshold_transit_unprotected.get_name_leafdata())
                    if (self.transition_duration.is_set or self.transition_duration.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.transition_duration.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "statistics"):
                        if (self.statistics is None):
                            self.statistics = MplsTeStandby.LspOutOfResources.Summary.LspOorStateXr.Statistics()
                            self.statistics.parent = self
                            self._children_name_map["statistics"] = "statistics"
                        return self.statistics

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "statistics" or name == "accept-reopt" or name == "available-bw-percentage" or name == "lsp-oor-state" or name == "minimum-lsp-bandwidth" or name == "te-metric-penalty" or name == "threshold-transit-all" or name == "threshold-transit-unprotected" or name == "transition-duration"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "accept-reopt"):
                        self.accept_reopt = value
                        self.accept_reopt.value_namespace = name_space
                        self.accept_reopt.value_namespace_prefix = name_space_prefix
                    if(value_path == "available-bw-percentage"):
                        self.available_bw_percentage = value
                        self.available_bw_percentage.value_namespace = name_space
                        self.available_bw_percentage.value_namespace_prefix = name_space_prefix
                    if(value_path == "lsp-oor-state"):
                        self.lsp_oor_state = value
                        self.lsp_oor_state.value_namespace = name_space
                        self.lsp_oor_state.value_namespace_prefix = name_space_prefix
                    if(value_path == "minimum-lsp-bandwidth"):
                        self.minimum_lsp_bandwidth = value
                        self.minimum_lsp_bandwidth.value_namespace = name_space
                        self.minimum_lsp_bandwidth.value_namespace_prefix = name_space_prefix
                    if(value_path == "te-metric-penalty"):
                        self.te_metric_penalty = value
                        self.te_metric_penalty.value_namespace = name_space
                        self.te_metric_penalty.value_namespace_prefix = name_space_prefix
                    if(value_path == "threshold-transit-all"):
                        self.threshold_transit_all = value
                        self.threshold_transit_all.value_namespace = name_space
                        self.threshold_transit_all.value_namespace_prefix = name_space_prefix
                    if(value_path == "threshold-transit-unprotected"):
                        self.threshold_transit_unprotected = value
                        self.threshold_transit_unprotected.value_namespace = name_space
                        self.threshold_transit_unprotected.value_namespace_prefix = name_space_prefix
                    if(value_path == "transition-duration"):
                        self.transition_duration = value
                        self.transition_duration.value_namespace = name_space
                        self.transition_duration.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.lsp_oor_state_xr:
                    if (c.has_data()):
                        return True
                return (
                    self.lsp_oor_green_recovery_time.is_set or
                    self.lsp_oor_state.is_set or
                    self.lsp_oor_timestamp.is_set or
                    self.transit_lsp_total_count.is_set or
                    self.transit_lsp_unprotected_count.is_set)

            def has_operation(self):
                for c in self.lsp_oor_state_xr:
                    if (c.has_operation()):
                        return True
                return (
                    self.yfilter != YFilter.not_set or
                    self.lsp_oor_green_recovery_time.yfilter != YFilter.not_set or
                    self.lsp_oor_state.yfilter != YFilter.not_set or
                    self.lsp_oor_timestamp.yfilter != YFilter.not_set or
                    self.transit_lsp_total_count.yfilter != YFilter.not_set or
                    self.transit_lsp_unprotected_count.yfilter != YFilter.not_set)

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "summary" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/lsp-out-of-resources/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.lsp_oor_green_recovery_time.is_set or self.lsp_oor_green_recovery_time.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.lsp_oor_green_recovery_time.get_name_leafdata())
                if (self.lsp_oor_state.is_set or self.lsp_oor_state.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.lsp_oor_state.get_name_leafdata())
                if (self.lsp_oor_timestamp.is_set or self.lsp_oor_timestamp.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.lsp_oor_timestamp.get_name_leafdata())
                if (self.transit_lsp_total_count.is_set or self.transit_lsp_total_count.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.transit_lsp_total_count.get_name_leafdata())
                if (self.transit_lsp_unprotected_count.is_set or self.transit_lsp_unprotected_count.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.transit_lsp_unprotected_count.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "lsp-oor-state-xr"):
                    for c in self.lsp_oor_state_xr:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTeStandby.LspOutOfResources.Summary.LspOorStateXr()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.lsp_oor_state_xr.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "lsp-oor-state-xr" or name == "lsp-oor-green-recovery-time" or name == "lsp-oor-state" or name == "lsp-oor-timestamp" or name == "transit-lsp-total-count" or name == "transit-lsp-unprotected-count"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "lsp-oor-green-recovery-time"):
                    self.lsp_oor_green_recovery_time = value
                    self.lsp_oor_green_recovery_time.value_namespace = name_space
                    self.lsp_oor_green_recovery_time.value_namespace_prefix = name_space_prefix
                if(value_path == "lsp-oor-state"):
                    self.lsp_oor_state = value
                    self.lsp_oor_state.value_namespace = name_space
                    self.lsp_oor_state.value_namespace_prefix = name_space_prefix
                if(value_path == "lsp-oor-timestamp"):
                    self.lsp_oor_timestamp = value
                    self.lsp_oor_timestamp.value_namespace = name_space
                    self.lsp_oor_timestamp.value_namespace_prefix = name_space_prefix
                if(value_path == "transit-lsp-total-count"):
                    self.transit_lsp_total_count = value
                    self.transit_lsp_total_count.value_namespace = name_space
                    self.transit_lsp_total_count.value_namespace_prefix = name_space_prefix
                if(value_path == "transit-lsp-unprotected-count"):
                    self.transit_lsp_unprotected_count = value
                    self.transit_lsp_unprotected_count.value_namespace = name_space
                    self.transit_lsp_unprotected_count.value_namespace_prefix = name_space_prefix

        def has_data(self):
            return (self.summary is not None and self.summary.has_data())

        def has_operation(self):
            return (
                self.yfilter != YFilter.not_set or
                (self.summary is not None and self.summary.has_operation()))

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "lsp-out-of-resources" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "summary"):
                if (self.summary is None):
                    self.summary = MplsTeStandby.LspOutOfResources.Summary()
                    self.summary.parent = self
                    self._children_name_map["summary"] = "summary"
                return self.summary

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "summary"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class Bfd(Entity):
        """
        MPLS TE BFD Oper Info
        
        .. attribute:: counters
        
        	MPLS TE BFD Counters
        	**type**\:   :py:class:`Counters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Bfd.Counters>`
        
        .. attribute:: head_infos
        
        	MPLS TE Head BFD Over LSP Table
        	**type**\:   :py:class:`HeadInfos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Bfd.HeadInfos>`
        
        .. attribute:: links
        
        	MPLS TE BFD Info
        	**type**\:   :py:class:`Links <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Bfd.Links>`
        
        .. attribute:: summary
        
        	MPLS TE BFD Summary
        	**type**\:   :py:class:`Summary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Bfd.Summary>`
        
        .. attribute:: tail_infos
        
        	MPLS TE Tail BFD Over LSP Table
        	**type**\:   :py:class:`TailInfos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Bfd.TailInfos>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsTeStandby.Bfd, self).__init__()

            self.yang_name = "bfd"
            self.yang_parent_name = "mpls-te-standby"

            self.counters = MplsTeStandby.Bfd.Counters()
            self.counters.parent = self
            self._children_name_map["counters"] = "counters"
            self._children_yang_names.add("counters")

            self.head_infos = MplsTeStandby.Bfd.HeadInfos()
            self.head_infos.parent = self
            self._children_name_map["head_infos"] = "head-infos"
            self._children_yang_names.add("head-infos")

            self.links = MplsTeStandby.Bfd.Links()
            self.links.parent = self
            self._children_name_map["links"] = "links"
            self._children_yang_names.add("links")

            self.summary = MplsTeStandby.Bfd.Summary()
            self.summary.parent = self
            self._children_name_map["summary"] = "summary"
            self._children_yang_names.add("summary")

            self.tail_infos = MplsTeStandby.Bfd.TailInfos()
            self.tail_infos.parent = self
            self._children_name_map["tail_infos"] = "tail-infos"
            self._children_yang_names.add("tail-infos")


        class HeadInfos(Entity):
            """
            MPLS TE Head BFD Over LSP Table
            
            .. attribute:: head_info
            
            	MPLS TE Head End BFD Over LSP Info
            	**type**\: list of    :py:class:`HeadInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Bfd.HeadInfos.HeadInfo>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTeStandby.Bfd.HeadInfos, self).__init__()

                self.yang_name = "head-infos"
                self.yang_parent_name = "bfd"

                self.head_info = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTeStandby.Bfd.HeadInfos, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTeStandby.Bfd.HeadInfos, self).__setattr__(name, value)


            class HeadInfo(Entity):
                """
                MPLS TE Head End BFD Over LSP Info
                
                .. attribute:: tunnel_name  <key>
                
                	Tunnel Name
                	**type**\:  str
                
                	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
                
                .. attribute:: current_lspbfd_info
                
                	Current LSP BFD Info
                	**type**\:   :py:class:`CurrentLspbfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Bfd.HeadInfos.HeadInfo.CurrentLspbfdInfo>`
                
                .. attribute:: destination_address
                
                	Destination Address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: lspbfd_type
                
                	LSP BFD type
                	**type**\:   :py:class:`TeVifBfd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeVifBfd>`
                
                .. attribute:: reoptimized_lspbfd_info
                
                	Reoptimized LSP BFD Info
                	**type**\:   :py:class:`ReoptimizedLspbfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Bfd.HeadInfos.HeadInfo.ReoptimizedLspbfdInfo>`
                
                .. attribute:: standby_lspbfd_info
                
                	Standby LSP BFD Info
                	**type**\:   :py:class:`StandbyLspbfdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Bfd.HeadInfos.HeadInfo.StandbyLspbfdInfo>`
                
                .. attribute:: tunnel_name_xr
                
                	Tunnel name
                	**type**\:  str
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTeStandby.Bfd.HeadInfos.HeadInfo, self).__init__()

                    self.yang_name = "head-info"
                    self.yang_parent_name = "head-infos"

                    self.tunnel_name = YLeaf(YType.str, "tunnel-name")

                    self.destination_address = YLeaf(YType.str, "destination-address")

                    self.lspbfd_type = YLeaf(YType.enumeration, "lspbfd-type")

                    self.tunnel_name_xr = YLeaf(YType.str, "tunnel-name-xr")

                    self.current_lspbfd_info = MplsTeStandby.Bfd.HeadInfos.HeadInfo.CurrentLspbfdInfo()
                    self.current_lspbfd_info.parent = self
                    self._children_name_map["current_lspbfd_info"] = "current-lspbfd-info"
                    self._children_yang_names.add("current-lspbfd-info")

                    self.reoptimized_lspbfd_info = MplsTeStandby.Bfd.HeadInfos.HeadInfo.ReoptimizedLspbfdInfo()
                    self.reoptimized_lspbfd_info.parent = self
                    self._children_name_map["reoptimized_lspbfd_info"] = "reoptimized-lspbfd-info"
                    self._children_yang_names.add("reoptimized-lspbfd-info")

                    self.standby_lspbfd_info = MplsTeStandby.Bfd.HeadInfos.HeadInfo.StandbyLspbfdInfo()
                    self.standby_lspbfd_info.parent = self
                    self._children_name_map["standby_lspbfd_info"] = "standby-lspbfd-info"
                    self._children_yang_names.add("standby-lspbfd-info")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("tunnel_name",
                                    "destination_address",
                                    "lspbfd_type",
                                    "tunnel_name_xr") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTeStandby.Bfd.HeadInfos.HeadInfo, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTeStandby.Bfd.HeadInfos.HeadInfo, self).__setattr__(name, value)


                class CurrentLspbfdInfo(Entity):
                    """
                    Current LSP BFD Info
                    
                    .. attribute:: bfd_session_state
                    
                    	BFD Session State
                    	**type**\:   :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                    
                    .. attribute:: lsp_id
                    
                    	LSP ID
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.Bfd.HeadInfos.HeadInfo.CurrentLspbfdInfo, self).__init__()

                        self.yang_name = "current-lspbfd-info"
                        self.yang_parent_name = "head-info"

                        self.bfd_session_state = YLeaf(YType.enumeration, "bfd-session-state")

                        self.lsp_id = YLeaf(YType.uint16, "lsp-id")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("bfd_session_state",
                                        "lsp_id") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.Bfd.HeadInfos.HeadInfo.CurrentLspbfdInfo, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.Bfd.HeadInfos.HeadInfo.CurrentLspbfdInfo, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.bfd_session_state.is_set or
                            self.lsp_id.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.bfd_session_state.yfilter != YFilter.not_set or
                            self.lsp_id.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "current-lspbfd-info" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.bfd_session_state.is_set or self.bfd_session_state.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.bfd_session_state.get_name_leafdata())
                        if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_id.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "bfd-session-state" or name == "lsp-id"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "bfd-session-state"):
                            self.bfd_session_state = value
                            self.bfd_session_state.value_namespace = name_space
                            self.bfd_session_state.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-id"):
                            self.lsp_id = value
                            self.lsp_id.value_namespace = name_space
                            self.lsp_id.value_namespace_prefix = name_space_prefix


                class StandbyLspbfdInfo(Entity):
                    """
                    Standby LSP BFD Info
                    
                    .. attribute:: bfd_session_state
                    
                    	BFD Session State
                    	**type**\:   :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                    
                    .. attribute:: lsp_id
                    
                    	LSP ID
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.Bfd.HeadInfos.HeadInfo.StandbyLspbfdInfo, self).__init__()

                        self.yang_name = "standby-lspbfd-info"
                        self.yang_parent_name = "head-info"

                        self.bfd_session_state = YLeaf(YType.enumeration, "bfd-session-state")

                        self.lsp_id = YLeaf(YType.uint16, "lsp-id")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("bfd_session_state",
                                        "lsp_id") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.Bfd.HeadInfos.HeadInfo.StandbyLspbfdInfo, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.Bfd.HeadInfos.HeadInfo.StandbyLspbfdInfo, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.bfd_session_state.is_set or
                            self.lsp_id.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.bfd_session_state.yfilter != YFilter.not_set or
                            self.lsp_id.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "standby-lspbfd-info" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.bfd_session_state.is_set or self.bfd_session_state.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.bfd_session_state.get_name_leafdata())
                        if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_id.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "bfd-session-state" or name == "lsp-id"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "bfd-session-state"):
                            self.bfd_session_state = value
                            self.bfd_session_state.value_namespace = name_space
                            self.bfd_session_state.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-id"):
                            self.lsp_id = value
                            self.lsp_id.value_namespace = name_space
                            self.lsp_id.value_namespace_prefix = name_space_prefix


                class ReoptimizedLspbfdInfo(Entity):
                    """
                    Reoptimized LSP BFD Info
                    
                    .. attribute:: bfd_session_state
                    
                    	BFD Session State
                    	**type**\:   :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                    
                    .. attribute:: lsp_id
                    
                    	LSP ID
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.Bfd.HeadInfos.HeadInfo.ReoptimizedLspbfdInfo, self).__init__()

                        self.yang_name = "reoptimized-lspbfd-info"
                        self.yang_parent_name = "head-info"

                        self.bfd_session_state = YLeaf(YType.enumeration, "bfd-session-state")

                        self.lsp_id = YLeaf(YType.uint16, "lsp-id")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("bfd_session_state",
                                        "lsp_id") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.Bfd.HeadInfos.HeadInfo.ReoptimizedLspbfdInfo, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.Bfd.HeadInfos.HeadInfo.ReoptimizedLspbfdInfo, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.bfd_session_state.is_set or
                            self.lsp_id.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.bfd_session_state.yfilter != YFilter.not_set or
                            self.lsp_id.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "reoptimized-lspbfd-info" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.bfd_session_state.is_set or self.bfd_session_state.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.bfd_session_state.get_name_leafdata())
                        if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.lsp_id.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "bfd-session-state" or name == "lsp-id"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "bfd-session-state"):
                            self.bfd_session_state = value
                            self.bfd_session_state.value_namespace = name_space
                            self.bfd_session_state.value_namespace_prefix = name_space_prefix
                        if(value_path == "lsp-id"):
                            self.lsp_id = value
                            self.lsp_id.value_namespace = name_space
                            self.lsp_id.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    return (
                        self.tunnel_name.is_set or
                        self.destination_address.is_set or
                        self.lspbfd_type.is_set or
                        self.tunnel_name_xr.is_set or
                        (self.current_lspbfd_info is not None and self.current_lspbfd_info.has_data()) or
                        (self.reoptimized_lspbfd_info is not None and self.reoptimized_lspbfd_info.has_data()) or
                        (self.standby_lspbfd_info is not None and self.standby_lspbfd_info.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.tunnel_name.yfilter != YFilter.not_set or
                        self.destination_address.yfilter != YFilter.not_set or
                        self.lspbfd_type.yfilter != YFilter.not_set or
                        self.tunnel_name_xr.yfilter != YFilter.not_set or
                        (self.current_lspbfd_info is not None and self.current_lspbfd_info.has_operation()) or
                        (self.reoptimized_lspbfd_info is not None and self.reoptimized_lspbfd_info.has_operation()) or
                        (self.standby_lspbfd_info is not None and self.standby_lspbfd_info.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "head-info" + "[tunnel-name='" + self.tunnel_name.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/bfd/head-infos/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.tunnel_name.is_set or self.tunnel_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_name.get_name_leafdata())
                    if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.destination_address.get_name_leafdata())
                    if (self.lspbfd_type.is_set or self.lspbfd_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.lspbfd_type.get_name_leafdata())
                    if (self.tunnel_name_xr.is_set or self.tunnel_name_xr.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_name_xr.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "current-lspbfd-info"):
                        if (self.current_lspbfd_info is None):
                            self.current_lspbfd_info = MplsTeStandby.Bfd.HeadInfos.HeadInfo.CurrentLspbfdInfo()
                            self.current_lspbfd_info.parent = self
                            self._children_name_map["current_lspbfd_info"] = "current-lspbfd-info"
                        return self.current_lspbfd_info

                    if (child_yang_name == "reoptimized-lspbfd-info"):
                        if (self.reoptimized_lspbfd_info is None):
                            self.reoptimized_lspbfd_info = MplsTeStandby.Bfd.HeadInfos.HeadInfo.ReoptimizedLspbfdInfo()
                            self.reoptimized_lspbfd_info.parent = self
                            self._children_name_map["reoptimized_lspbfd_info"] = "reoptimized-lspbfd-info"
                        return self.reoptimized_lspbfd_info

                    if (child_yang_name == "standby-lspbfd-info"):
                        if (self.standby_lspbfd_info is None):
                            self.standby_lspbfd_info = MplsTeStandby.Bfd.HeadInfos.HeadInfo.StandbyLspbfdInfo()
                            self.standby_lspbfd_info.parent = self
                            self._children_name_map["standby_lspbfd_info"] = "standby-lspbfd-info"
                        return self.standby_lspbfd_info

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "current-lspbfd-info" or name == "reoptimized-lspbfd-info" or name == "standby-lspbfd-info" or name == "tunnel-name" or name == "destination-address" or name == "lspbfd-type" or name == "tunnel-name-xr"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "tunnel-name"):
                        self.tunnel_name = value
                        self.tunnel_name.value_namespace = name_space
                        self.tunnel_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "destination-address"):
                        self.destination_address = value
                        self.destination_address.value_namespace = name_space
                        self.destination_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "lspbfd-type"):
                        self.lspbfd_type = value
                        self.lspbfd_type.value_namespace = name_space
                        self.lspbfd_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-name-xr"):
                        self.tunnel_name_xr = value
                        self.tunnel_name_xr.value_namespace = name_space
                        self.tunnel_name_xr.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.head_info:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.head_info:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "head-infos" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/bfd/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "head-info"):
                    for c in self.head_info:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTeStandby.Bfd.HeadInfos.HeadInfo()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.head_info.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "head-info"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass


        class Links(Entity):
            """
            MPLS TE BFD Info
            
            .. attribute:: link
            
            	MPLS TE BFD Info
            	**type**\: list of    :py:class:`Link <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Bfd.Links.Link>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTeStandby.Bfd.Links, self).__init__()

                self.yang_name = "links"
                self.yang_parent_name = "bfd"

                self.link = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTeStandby.Bfd.Links, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTeStandby.Bfd.Links, self).__setattr__(name, value)


            class Link(Entity):
                """
                MPLS TE BFD Info
                
                .. attribute:: interface_name  <key>
                
                	Interface name
                	**type**\:  str
                
                	**pattern:** (([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){3,4}\\d+\\.\\d+)\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]\*\\d+))\|(([a\-zA\-Z0\-9\_]\*\\d+/){2}([a\-zA\-Z0\-9\_]+))\|([a\-zA\-Z0\-9\_\-]\*\\d+)\|([a\-zA\-Z0\-9\_\-]\*\\d+\\.\\d+)\|(mpls)\|(dwdm)
                
                .. attribute:: neighbor
                
                	Neighbors of the specified link id
                	**type**\: list of    :py:class:`Neighbor <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Bfd.Links.Link.Neighbor>`
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTeStandby.Bfd.Links.Link, self).__init__()

                    self.yang_name = "link"
                    self.yang_parent_name = "links"

                    self.interface_name = YLeaf(YType.str, "interface-name")

                    self.neighbor = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("interface_name") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTeStandby.Bfd.Links.Link, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTeStandby.Bfd.Links.Link, self).__setattr__(name, value)


                class Neighbor(Entity):
                    """
                    Neighbors of the specified link id
                    
                    .. attribute:: is_bfd_up
                    
                    	TRUE if the BFD session is Up on this link
                    	**type**\:  bool
                    
                    .. attribute:: neighbor_address
                    
                    	The neighbor's IP address
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.Bfd.Links.Link.Neighbor, self).__init__()

                        self.yang_name = "neighbor"
                        self.yang_parent_name = "link"

                        self.is_bfd_up = YLeaf(YType.boolean, "is-bfd-up")

                        self.neighbor_address = YLeaf(YType.str, "neighbor-address")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("is_bfd_up",
                                        "neighbor_address") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.Bfd.Links.Link.Neighbor, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.Bfd.Links.Link.Neighbor, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.is_bfd_up.is_set or
                            self.neighbor_address.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.is_bfd_up.yfilter != YFilter.not_set or
                            self.neighbor_address.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "neighbor" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.is_bfd_up.is_set or self.is_bfd_up.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_bfd_up.get_name_leafdata())
                        if (self.neighbor_address.is_set or self.neighbor_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.neighbor_address.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "is-bfd-up" or name == "neighbor-address"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "is-bfd-up"):
                            self.is_bfd_up = value
                            self.is_bfd_up.value_namespace = name_space
                            self.is_bfd_up.value_namespace_prefix = name_space_prefix
                        if(value_path == "neighbor-address"):
                            self.neighbor_address = value
                            self.neighbor_address.value_namespace = name_space
                            self.neighbor_address.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.neighbor:
                        if (c.has_data()):
                            return True
                    return self.interface_name.is_set

                def has_operation(self):
                    for c in self.neighbor:
                        if (c.has_operation()):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        self.interface_name.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "link" + "[interface-name='" + self.interface_name.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/bfd/links/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.interface_name.is_set or self.interface_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.interface_name.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "neighbor"):
                        for c in self.neighbor:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsTeStandby.Bfd.Links.Link.Neighbor()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.neighbor.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "neighbor" or name == "interface-name"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "interface-name"):
                        self.interface_name = value
                        self.interface_name.value_namespace = name_space
                        self.interface_name.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.link:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.link:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "links" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/bfd/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "link"):
                    for c in self.link:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTeStandby.Bfd.Links.Link()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.link.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "link"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass


        class TailInfos(Entity):
            """
            MPLS TE Tail BFD Over LSP Table
            
            .. attribute:: tail_info
            
            	MPLS TE Tail End BFD Over LSP Info
            	**type**\: list of    :py:class:`TailInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Bfd.TailInfos.TailInfo>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTeStandby.Bfd.TailInfos, self).__init__()

                self.yang_name = "tail-infos"
                self.yang_parent_name = "bfd"

                self.tail_info = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTeStandby.Bfd.TailInfos, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTeStandby.Bfd.TailInfos, self).__setattr__(name, value)


            class TailInfo(Entity):
                """
                MPLS TE Tail End BFD Over LSP Info
                
                .. attribute:: bfd_session_state
                
                	BFD Session State
                	**type**\:   :py:class:`TeBfdLspSessionState <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeBfdLspSessionState>`
                
                .. attribute:: ctype
                
                	Ctype
                	**type**\:   :py:class:`Ctype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.Ctype>`
                
                .. attribute:: destination_address
                
                	Destination Address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: extended_tunnel_id
                
                	Extended Tunnel ID
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: lsp_fec
                
                	FEC for the LSP
                	**type**\:   :py:class:`LspFec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Bfd.TailInfos.TailInfo.LspFec>`
                
                .. attribute:: lsp_id
                
                	LSP ID
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: p2mp_id
                
                	P2MP ID
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: signaled_name
                
                	Signaled Name
                	**type**\:  str
                
                .. attribute:: source_address
                
                	Source Address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: tunnel_id
                
                	Tunnel ID
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTeStandby.Bfd.TailInfos.TailInfo, self).__init__()

                    self.yang_name = "tail-info"
                    self.yang_parent_name = "tail-infos"

                    self.bfd_session_state = YLeaf(YType.enumeration, "bfd-session-state")

                    self.ctype = YLeaf(YType.enumeration, "ctype")

                    self.destination_address = YLeaf(YType.str, "destination-address")

                    self.extended_tunnel_id = YLeaf(YType.str, "extended-tunnel-id")

                    self.lsp_id = YLeaf(YType.int32, "lsp-id")

                    self.p2mp_id = YLeaf(YType.int32, "p2mp-id")

                    self.signaled_name = YLeaf(YType.str, "signaled-name")

                    self.source_address = YLeaf(YType.str, "source-address")

                    self.tunnel_id = YLeaf(YType.int32, "tunnel-id")

                    self.lsp_fec = MplsTeStandby.Bfd.TailInfos.TailInfo.LspFec()
                    self.lsp_fec.parent = self
                    self._children_name_map["lsp_fec"] = "lsp-fec"
                    self._children_yang_names.add("lsp-fec")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("bfd_session_state",
                                    "ctype",
                                    "destination_address",
                                    "extended_tunnel_id",
                                    "lsp_id",
                                    "p2mp_id",
                                    "signaled_name",
                                    "source_address",
                                    "tunnel_id") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTeStandby.Bfd.TailInfos.TailInfo, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTeStandby.Bfd.TailInfos.TailInfo, self).__setattr__(name, value)


                class LspFec(Entity):
                    """
                    FEC for the LSP
                    
                    .. attribute:: fec_destination_info
                    
                    	Destination or P2MP ID
                    	**type**\:   :py:class:`FecDestinationInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Bfd.TailInfos.TailInfo.LspFec.FecDestinationInfo>`
                    
                    .. attribute:: fec_extended_tunnel_id
                    
                    	Extended tunnel ID
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: fec_lsp_id
                    
                    	LSP ID
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: fec_source
                    
                    	Tunnel source address
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: fec_tunnel_id
                    
                    	Tunnel ID
                    	**type**\:  int
                    
                    	**range:** 0..65535
                    
                    .. attribute:: fec_vrf
                    
                    	VRF; currently only for GMPLS tunnels
                    	**type**\:  str
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.Bfd.TailInfos.TailInfo.LspFec, self).__init__()

                        self.yang_name = "lsp-fec"
                        self.yang_parent_name = "tail-info"

                        self.fec_extended_tunnel_id = YLeaf(YType.str, "fec-extended-tunnel-id")

                        self.fec_lsp_id = YLeaf(YType.uint16, "fec-lsp-id")

                        self.fec_source = YLeaf(YType.str, "fec-source")

                        self.fec_tunnel_id = YLeaf(YType.uint16, "fec-tunnel-id")

                        self.fec_vrf = YLeaf(YType.str, "fec-vrf")

                        self.fec_destination_info = MplsTeStandby.Bfd.TailInfos.TailInfo.LspFec.FecDestinationInfo()
                        self.fec_destination_info.parent = self
                        self._children_name_map["fec_destination_info"] = "fec-destination-info"
                        self._children_yang_names.add("fec-destination-info")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("fec_extended_tunnel_id",
                                        "fec_lsp_id",
                                        "fec_source",
                                        "fec_tunnel_id",
                                        "fec_vrf") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.Bfd.TailInfos.TailInfo.LspFec, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.Bfd.TailInfos.TailInfo.LspFec, self).__setattr__(name, value)


                    class FecDestinationInfo(Entity):
                        """
                        Destination or P2MP ID
                        
                        .. attribute:: fec_ctype
                        
                        	FEC CType
                        	**type**\:   :py:class:`MplsLibC <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsLibC>`
                        
                        .. attribute:: fec_destination_p2mp_id
                        
                        	P2MP ID
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: p2p_lsp_destination
                        
                        	P2P LSP destination
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.Bfd.TailInfos.TailInfo.LspFec.FecDestinationInfo, self).__init__()

                            self.yang_name = "fec-destination-info"
                            self.yang_parent_name = "lsp-fec"

                            self.fec_ctype = YLeaf(YType.enumeration, "fec-ctype")

                            self.fec_destination_p2mp_id = YLeaf(YType.uint32, "fec-destination-p2mp-id")

                            self.p2p_lsp_destination = YLeaf(YType.str, "p2p-lsp-destination")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("fec_ctype",
                                            "fec_destination_p2mp_id",
                                            "p2p_lsp_destination") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.Bfd.TailInfos.TailInfo.LspFec.FecDestinationInfo, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.Bfd.TailInfos.TailInfo.LspFec.FecDestinationInfo, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.fec_ctype.is_set or
                                self.fec_destination_p2mp_id.is_set or
                                self.p2p_lsp_destination.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.fec_ctype.yfilter != YFilter.not_set or
                                self.fec_destination_p2mp_id.yfilter != YFilter.not_set or
                                self.p2p_lsp_destination.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "fec-destination-info" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/bfd/tail-infos/tail-info/lsp-fec/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.fec_ctype.is_set or self.fec_ctype.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_ctype.get_name_leafdata())
                            if (self.fec_destination_p2mp_id.is_set or self.fec_destination_p2mp_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.fec_destination_p2mp_id.get_name_leafdata())
                            if (self.p2p_lsp_destination.is_set or self.p2p_lsp_destination.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.p2p_lsp_destination.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "fec-ctype" or name == "fec-destination-p2mp-id" or name == "p2p-lsp-destination"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "fec-ctype"):
                                self.fec_ctype = value
                                self.fec_ctype.value_namespace = name_space
                                self.fec_ctype.value_namespace_prefix = name_space_prefix
                            if(value_path == "fec-destination-p2mp-id"):
                                self.fec_destination_p2mp_id = value
                                self.fec_destination_p2mp_id.value_namespace = name_space
                                self.fec_destination_p2mp_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "p2p-lsp-destination"):
                                self.p2p_lsp_destination = value
                                self.p2p_lsp_destination.value_namespace = name_space
                                self.p2p_lsp_destination.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.fec_extended_tunnel_id.is_set or
                            self.fec_lsp_id.is_set or
                            self.fec_source.is_set or
                            self.fec_tunnel_id.is_set or
                            self.fec_vrf.is_set or
                            (self.fec_destination_info is not None and self.fec_destination_info.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.fec_extended_tunnel_id.yfilter != YFilter.not_set or
                            self.fec_lsp_id.yfilter != YFilter.not_set or
                            self.fec_source.yfilter != YFilter.not_set or
                            self.fec_tunnel_id.yfilter != YFilter.not_set or
                            self.fec_vrf.yfilter != YFilter.not_set or
                            (self.fec_destination_info is not None and self.fec_destination_info.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "lsp-fec" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/bfd/tail-infos/tail-info/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.fec_extended_tunnel_id.is_set or self.fec_extended_tunnel_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.fec_extended_tunnel_id.get_name_leafdata())
                        if (self.fec_lsp_id.is_set or self.fec_lsp_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.fec_lsp_id.get_name_leafdata())
                        if (self.fec_source.is_set or self.fec_source.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.fec_source.get_name_leafdata())
                        if (self.fec_tunnel_id.is_set or self.fec_tunnel_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.fec_tunnel_id.get_name_leafdata())
                        if (self.fec_vrf.is_set or self.fec_vrf.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.fec_vrf.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "fec-destination-info"):
                            if (self.fec_destination_info is None):
                                self.fec_destination_info = MplsTeStandby.Bfd.TailInfos.TailInfo.LspFec.FecDestinationInfo()
                                self.fec_destination_info.parent = self
                                self._children_name_map["fec_destination_info"] = "fec-destination-info"
                            return self.fec_destination_info

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "fec-destination-info" or name == "fec-extended-tunnel-id" or name == "fec-lsp-id" or name == "fec-source" or name == "fec-tunnel-id" or name == "fec-vrf"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "fec-extended-tunnel-id"):
                            self.fec_extended_tunnel_id = value
                            self.fec_extended_tunnel_id.value_namespace = name_space
                            self.fec_extended_tunnel_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "fec-lsp-id"):
                            self.fec_lsp_id = value
                            self.fec_lsp_id.value_namespace = name_space
                            self.fec_lsp_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "fec-source"):
                            self.fec_source = value
                            self.fec_source.value_namespace = name_space
                            self.fec_source.value_namespace_prefix = name_space_prefix
                        if(value_path == "fec-tunnel-id"):
                            self.fec_tunnel_id = value
                            self.fec_tunnel_id.value_namespace = name_space
                            self.fec_tunnel_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "fec-vrf"):
                            self.fec_vrf = value
                            self.fec_vrf.value_namespace = name_space
                            self.fec_vrf.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    return (
                        self.bfd_session_state.is_set or
                        self.ctype.is_set or
                        self.destination_address.is_set or
                        self.extended_tunnel_id.is_set or
                        self.lsp_id.is_set or
                        self.p2mp_id.is_set or
                        self.signaled_name.is_set or
                        self.source_address.is_set or
                        self.tunnel_id.is_set or
                        (self.lsp_fec is not None and self.lsp_fec.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.bfd_session_state.yfilter != YFilter.not_set or
                        self.ctype.yfilter != YFilter.not_set or
                        self.destination_address.yfilter != YFilter.not_set or
                        self.extended_tunnel_id.yfilter != YFilter.not_set or
                        self.lsp_id.yfilter != YFilter.not_set or
                        self.p2mp_id.yfilter != YFilter.not_set or
                        self.signaled_name.yfilter != YFilter.not_set or
                        self.source_address.yfilter != YFilter.not_set or
                        self.tunnel_id.yfilter != YFilter.not_set or
                        (self.lsp_fec is not None and self.lsp_fec.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "tail-info" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/bfd/tail-infos/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.bfd_session_state.is_set or self.bfd_session_state.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.bfd_session_state.get_name_leafdata())
                    if (self.ctype.is_set or self.ctype.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.ctype.get_name_leafdata())
                    if (self.destination_address.is_set or self.destination_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.destination_address.get_name_leafdata())
                    if (self.extended_tunnel_id.is_set or self.extended_tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.extended_tunnel_id.get_name_leafdata())
                    if (self.lsp_id.is_set or self.lsp_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.lsp_id.get_name_leafdata())
                    if (self.p2mp_id.is_set or self.p2mp_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.p2mp_id.get_name_leafdata())
                    if (self.signaled_name.is_set or self.signaled_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.signaled_name.get_name_leafdata())
                    if (self.source_address.is_set or self.source_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.source_address.get_name_leafdata())
                    if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.tunnel_id.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "lsp-fec"):
                        if (self.lsp_fec is None):
                            self.lsp_fec = MplsTeStandby.Bfd.TailInfos.TailInfo.LspFec()
                            self.lsp_fec.parent = self
                            self._children_name_map["lsp_fec"] = "lsp-fec"
                        return self.lsp_fec

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "lsp-fec" or name == "bfd-session-state" or name == "ctype" or name == "destination-address" or name == "extended-tunnel-id" or name == "lsp-id" or name == "p2mp-id" or name == "signaled-name" or name == "source-address" or name == "tunnel-id"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "bfd-session-state"):
                        self.bfd_session_state = value
                        self.bfd_session_state.value_namespace = name_space
                        self.bfd_session_state.value_namespace_prefix = name_space_prefix
                    if(value_path == "ctype"):
                        self.ctype = value
                        self.ctype.value_namespace = name_space
                        self.ctype.value_namespace_prefix = name_space_prefix
                    if(value_path == "destination-address"):
                        self.destination_address = value
                        self.destination_address.value_namespace = name_space
                        self.destination_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "extended-tunnel-id"):
                        self.extended_tunnel_id = value
                        self.extended_tunnel_id.value_namespace = name_space
                        self.extended_tunnel_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "lsp-id"):
                        self.lsp_id = value
                        self.lsp_id.value_namespace = name_space
                        self.lsp_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "p2mp-id"):
                        self.p2mp_id = value
                        self.p2mp_id.value_namespace = name_space
                        self.p2mp_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "signaled-name"):
                        self.signaled_name = value
                        self.signaled_name.value_namespace = name_space
                        self.signaled_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "source-address"):
                        self.source_address = value
                        self.source_address.value_namespace = name_space
                        self.source_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "tunnel-id"):
                        self.tunnel_id = value
                        self.tunnel_id.value_namespace = name_space
                        self.tunnel_id.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.tail_info:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.tail_info:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "tail-infos" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/bfd/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "tail-info"):
                    for c in self.tail_info:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTeStandby.Bfd.TailInfos.TailInfo()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.tail_info.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "tail-info"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass


        class Summary(Entity):
            """
            MPLS TE BFD Summary
            
            .. attribute:: head_lsp_count_sbfd_session_created
            
            	Number of head end LSP with SBFD session created
            	**type**\:  int
            
            	**range:** 0..65535
            
            .. attribute:: head_lsp_count_sbfd_up
            
            	Number of head end LSP with SBFD session in up state
            	**type**\:  int
            
            	**range:** 0..65535
            
            .. attribute:: head_lsp_count_session_created
            
            	Number of head end LSP with BFD session created
            	**type**\:  int
            
            	**range:** 0..65535
            
            .. attribute:: head_lsp_count_up
            
            	Number of head end LSP with BFD session in up state
            	**type**\:  int
            
            	**range:** 0..65535
            
            .. attribute:: link_count_bfd_enabled
            
            	Number of link with BFD enabled
            	**type**\:  int
            
            	**range:** 0..65535
            
            .. attribute:: link_count_session_created
            
            	Number of link with BFD session created
            	**type**\:  int
            
            	**range:** 0..65535
            
            .. attribute:: link_count_session_up
            
            	Number of link with BFD session in state Up
            	**type**\:  int
            
            	**range:** 0..65535
            
            .. attribute:: tail_lsp_count_session_created
            
            	Number of tail end LSP with BFD session created
            	**type**\:  int
            
            	**range:** 0..65535
            
            .. attribute:: tail_lsp_count_session_up
            
            	Number of tail end LSP with BFD session in up state
            	**type**\:  int
            
            	**range:** 0..65535
            
            .. attribute:: tunnel_count_bfd_enabled
            
            	Number of tunnel interface with BFD enabled
            	**type**\:  int
            
            	**range:** 0..65535
            
            .. attribute:: tunnel_count_sbfd_enabled
            
            	Number of tunnel interface with SBFD enabled
            	**type**\:  int
            
            	**range:** 0..65535
            
            .. attribute:: tunnel_count_sbfd_session_up
            
            	Number of tunnel with SBFD session in up state
            	**type**\:  int
            
            	**range:** 0..65535
            
            .. attribute:: tunnel_count_session_up
            
            	Number of tunnel with BFD session in up state
            	**type**\:  int
            
            	**range:** 0..65535
            
            .. attribute:: tunnel_count_total
            
            	Total number of tunnel interface
            	**type**\:  int
            
            	**range:** 0..65535
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTeStandby.Bfd.Summary, self).__init__()

                self.yang_name = "summary"
                self.yang_parent_name = "bfd"

                self.head_lsp_count_sbfd_session_created = YLeaf(YType.uint16, "head-lsp-count-sbfd-session-created")

                self.head_lsp_count_sbfd_up = YLeaf(YType.uint16, "head-lsp-count-sbfd-up")

                self.head_lsp_count_session_created = YLeaf(YType.uint16, "head-lsp-count-session-created")

                self.head_lsp_count_up = YLeaf(YType.uint16, "head-lsp-count-up")

                self.link_count_bfd_enabled = YLeaf(YType.uint16, "link-count-bfd-enabled")

                self.link_count_session_created = YLeaf(YType.uint16, "link-count-session-created")

                self.link_count_session_up = YLeaf(YType.uint16, "link-count-session-up")

                self.tail_lsp_count_session_created = YLeaf(YType.uint16, "tail-lsp-count-session-created")

                self.tail_lsp_count_session_up = YLeaf(YType.uint16, "tail-lsp-count-session-up")

                self.tunnel_count_bfd_enabled = YLeaf(YType.uint16, "tunnel-count-bfd-enabled")

                self.tunnel_count_sbfd_enabled = YLeaf(YType.uint16, "tunnel-count-sbfd-enabled")

                self.tunnel_count_sbfd_session_up = YLeaf(YType.uint16, "tunnel-count-sbfd-session-up")

                self.tunnel_count_session_up = YLeaf(YType.uint16, "tunnel-count-session-up")

                self.tunnel_count_total = YLeaf(YType.uint16, "tunnel-count-total")

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("head_lsp_count_sbfd_session_created",
                                "head_lsp_count_sbfd_up",
                                "head_lsp_count_session_created",
                                "head_lsp_count_up",
                                "link_count_bfd_enabled",
                                "link_count_session_created",
                                "link_count_session_up",
                                "tail_lsp_count_session_created",
                                "tail_lsp_count_session_up",
                                "tunnel_count_bfd_enabled",
                                "tunnel_count_sbfd_enabled",
                                "tunnel_count_sbfd_session_up",
                                "tunnel_count_session_up",
                                "tunnel_count_total") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTeStandby.Bfd.Summary, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTeStandby.Bfd.Summary, self).__setattr__(name, value)

            def has_data(self):
                return (
                    self.head_lsp_count_sbfd_session_created.is_set or
                    self.head_lsp_count_sbfd_up.is_set or
                    self.head_lsp_count_session_created.is_set or
                    self.head_lsp_count_up.is_set or
                    self.link_count_bfd_enabled.is_set or
                    self.link_count_session_created.is_set or
                    self.link_count_session_up.is_set or
                    self.tail_lsp_count_session_created.is_set or
                    self.tail_lsp_count_session_up.is_set or
                    self.tunnel_count_bfd_enabled.is_set or
                    self.tunnel_count_sbfd_enabled.is_set or
                    self.tunnel_count_sbfd_session_up.is_set or
                    self.tunnel_count_session_up.is_set or
                    self.tunnel_count_total.is_set)

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    self.head_lsp_count_sbfd_session_created.yfilter != YFilter.not_set or
                    self.head_lsp_count_sbfd_up.yfilter != YFilter.not_set or
                    self.head_lsp_count_session_created.yfilter != YFilter.not_set or
                    self.head_lsp_count_up.yfilter != YFilter.not_set or
                    self.link_count_bfd_enabled.yfilter != YFilter.not_set or
                    self.link_count_session_created.yfilter != YFilter.not_set or
                    self.link_count_session_up.yfilter != YFilter.not_set or
                    self.tail_lsp_count_session_created.yfilter != YFilter.not_set or
                    self.tail_lsp_count_session_up.yfilter != YFilter.not_set or
                    self.tunnel_count_bfd_enabled.yfilter != YFilter.not_set or
                    self.tunnel_count_sbfd_enabled.yfilter != YFilter.not_set or
                    self.tunnel_count_sbfd_session_up.yfilter != YFilter.not_set or
                    self.tunnel_count_session_up.yfilter != YFilter.not_set or
                    self.tunnel_count_total.yfilter != YFilter.not_set)

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "summary" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/bfd/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.head_lsp_count_sbfd_session_created.is_set or self.head_lsp_count_sbfd_session_created.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.head_lsp_count_sbfd_session_created.get_name_leafdata())
                if (self.head_lsp_count_sbfd_up.is_set or self.head_lsp_count_sbfd_up.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.head_lsp_count_sbfd_up.get_name_leafdata())
                if (self.head_lsp_count_session_created.is_set or self.head_lsp_count_session_created.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.head_lsp_count_session_created.get_name_leafdata())
                if (self.head_lsp_count_up.is_set or self.head_lsp_count_up.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.head_lsp_count_up.get_name_leafdata())
                if (self.link_count_bfd_enabled.is_set or self.link_count_bfd_enabled.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.link_count_bfd_enabled.get_name_leafdata())
                if (self.link_count_session_created.is_set or self.link_count_session_created.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.link_count_session_created.get_name_leafdata())
                if (self.link_count_session_up.is_set or self.link_count_session_up.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.link_count_session_up.get_name_leafdata())
                if (self.tail_lsp_count_session_created.is_set or self.tail_lsp_count_session_created.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.tail_lsp_count_session_created.get_name_leafdata())
                if (self.tail_lsp_count_session_up.is_set or self.tail_lsp_count_session_up.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.tail_lsp_count_session_up.get_name_leafdata())
                if (self.tunnel_count_bfd_enabled.is_set or self.tunnel_count_bfd_enabled.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.tunnel_count_bfd_enabled.get_name_leafdata())
                if (self.tunnel_count_sbfd_enabled.is_set or self.tunnel_count_sbfd_enabled.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.tunnel_count_sbfd_enabled.get_name_leafdata())
                if (self.tunnel_count_sbfd_session_up.is_set or self.tunnel_count_sbfd_session_up.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.tunnel_count_sbfd_session_up.get_name_leafdata())
                if (self.tunnel_count_session_up.is_set or self.tunnel_count_session_up.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.tunnel_count_session_up.get_name_leafdata())
                if (self.tunnel_count_total.is_set or self.tunnel_count_total.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.tunnel_count_total.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "head-lsp-count-sbfd-session-created" or name == "head-lsp-count-sbfd-up" or name == "head-lsp-count-session-created" or name == "head-lsp-count-up" or name == "link-count-bfd-enabled" or name == "link-count-session-created" or name == "link-count-session-up" or name == "tail-lsp-count-session-created" or name == "tail-lsp-count-session-up" or name == "tunnel-count-bfd-enabled" or name == "tunnel-count-sbfd-enabled" or name == "tunnel-count-sbfd-session-up" or name == "tunnel-count-session-up" or name == "tunnel-count-total"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "head-lsp-count-sbfd-session-created"):
                    self.head_lsp_count_sbfd_session_created = value
                    self.head_lsp_count_sbfd_session_created.value_namespace = name_space
                    self.head_lsp_count_sbfd_session_created.value_namespace_prefix = name_space_prefix
                if(value_path == "head-lsp-count-sbfd-up"):
                    self.head_lsp_count_sbfd_up = value
                    self.head_lsp_count_sbfd_up.value_namespace = name_space
                    self.head_lsp_count_sbfd_up.value_namespace_prefix = name_space_prefix
                if(value_path == "head-lsp-count-session-created"):
                    self.head_lsp_count_session_created = value
                    self.head_lsp_count_session_created.value_namespace = name_space
                    self.head_lsp_count_session_created.value_namespace_prefix = name_space_prefix
                if(value_path == "head-lsp-count-up"):
                    self.head_lsp_count_up = value
                    self.head_lsp_count_up.value_namespace = name_space
                    self.head_lsp_count_up.value_namespace_prefix = name_space_prefix
                if(value_path == "link-count-bfd-enabled"):
                    self.link_count_bfd_enabled = value
                    self.link_count_bfd_enabled.value_namespace = name_space
                    self.link_count_bfd_enabled.value_namespace_prefix = name_space_prefix
                if(value_path == "link-count-session-created"):
                    self.link_count_session_created = value
                    self.link_count_session_created.value_namespace = name_space
                    self.link_count_session_created.value_namespace_prefix = name_space_prefix
                if(value_path == "link-count-session-up"):
                    self.link_count_session_up = value
                    self.link_count_session_up.value_namespace = name_space
                    self.link_count_session_up.value_namespace_prefix = name_space_prefix
                if(value_path == "tail-lsp-count-session-created"):
                    self.tail_lsp_count_session_created = value
                    self.tail_lsp_count_session_created.value_namespace = name_space
                    self.tail_lsp_count_session_created.value_namespace_prefix = name_space_prefix
                if(value_path == "tail-lsp-count-session-up"):
                    self.tail_lsp_count_session_up = value
                    self.tail_lsp_count_session_up.value_namespace = name_space
                    self.tail_lsp_count_session_up.value_namespace_prefix = name_space_prefix
                if(value_path == "tunnel-count-bfd-enabled"):
                    self.tunnel_count_bfd_enabled = value
                    self.tunnel_count_bfd_enabled.value_namespace = name_space
                    self.tunnel_count_bfd_enabled.value_namespace_prefix = name_space_prefix
                if(value_path == "tunnel-count-sbfd-enabled"):
                    self.tunnel_count_sbfd_enabled = value
                    self.tunnel_count_sbfd_enabled.value_namespace = name_space
                    self.tunnel_count_sbfd_enabled.value_namespace_prefix = name_space_prefix
                if(value_path == "tunnel-count-sbfd-session-up"):
                    self.tunnel_count_sbfd_session_up = value
                    self.tunnel_count_sbfd_session_up.value_namespace = name_space
                    self.tunnel_count_sbfd_session_up.value_namespace_prefix = name_space_prefix
                if(value_path == "tunnel-count-session-up"):
                    self.tunnel_count_session_up = value
                    self.tunnel_count_session_up.value_namespace = name_space
                    self.tunnel_count_session_up.value_namespace_prefix = name_space_prefix
                if(value_path == "tunnel-count-total"):
                    self.tunnel_count_total = value
                    self.tunnel_count_total.value_namespace = name_space
                    self.tunnel_count_total.value_namespace_prefix = name_space_prefix


        class Counters(Entity):
            """
            MPLS TE BFD Counters
            
            .. attribute:: bf_do_lm_counters
            
            	BFD over Links Cumulative Counters
            	**type**\:   :py:class:`BfDoLmCounters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Bfd.Counters.BfDoLmCounters>`
            
            .. attribute:: bfd_over_lsp_head_counters
            
            	BFD over Head\-end LSPs Cumulative Counters
            	**type**\:   :py:class:`BfdOverLspHeadCounters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Bfd.Counters.BfdOverLspHeadCounters>`
            
            .. attribute:: bfd_over_lsp_tail_counters
            
            	BFD over Tail\-end LSPs Cumulative Counters
            	**type**\:   :py:class:`BfdOverLspTailCounters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Bfd.Counters.BfdOverLspTailCounters>`
            
            .. attribute:: last_cleared_timestamp
            
            	The timestamp when these stats are cleared relative to Jan 1, 1970
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: sbfd_over_lsp_head_counters
            
            	SBFD over Head\-end LSPs Cumulative Counters
            	**type**\:   :py:class:`SbfdOverLspHeadCounters <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Bfd.Counters.SbfdOverLspHeadCounters>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTeStandby.Bfd.Counters, self).__init__()

                self.yang_name = "counters"
                self.yang_parent_name = "bfd"

                self.last_cleared_timestamp = YLeaf(YType.uint32, "last-cleared-timestamp")

                self.bf_do_lm_counters = MplsTeStandby.Bfd.Counters.BfDoLmCounters()
                self.bf_do_lm_counters.parent = self
                self._children_name_map["bf_do_lm_counters"] = "bf-do-lm-counters"
                self._children_yang_names.add("bf-do-lm-counters")

                self.bfd_over_lsp_head_counters = MplsTeStandby.Bfd.Counters.BfdOverLspHeadCounters()
                self.bfd_over_lsp_head_counters.parent = self
                self._children_name_map["bfd_over_lsp_head_counters"] = "bfd-over-lsp-head-counters"
                self._children_yang_names.add("bfd-over-lsp-head-counters")

                self.bfd_over_lsp_tail_counters = MplsTeStandby.Bfd.Counters.BfdOverLspTailCounters()
                self.bfd_over_lsp_tail_counters.parent = self
                self._children_name_map["bfd_over_lsp_tail_counters"] = "bfd-over-lsp-tail-counters"
                self._children_yang_names.add("bfd-over-lsp-tail-counters")

                self.sbfd_over_lsp_head_counters = MplsTeStandby.Bfd.Counters.SbfdOverLspHeadCounters()
                self.sbfd_over_lsp_head_counters.parent = self
                self._children_name_map["sbfd_over_lsp_head_counters"] = "sbfd-over-lsp-head-counters"
                self._children_yang_names.add("sbfd-over-lsp-head-counters")

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("last_cleared_timestamp") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTeStandby.Bfd.Counters, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTeStandby.Bfd.Counters, self).__setattr__(name, value)


            class BfdOverLspHeadCounters(Entity):
                """
                BFD over Head\-end LSPs Cumulative Counters
                
                .. attribute:: session_admin_down_events
                
                	The number of BFDOverLSP session admin down events
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: session_create_events
                
                	The number of BFDOverLSP session create events
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: session_create_timeout_events
                
                	The number of BFDOverLSP session create timeout events
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: session_creation_failed_events
                
                	The number of BFDOverLSP session creation failed events
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: session_down_events
                
                	The number of BFDOverLSP session down events
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: session_gracefully_delete_events
                
                	The number of BFDOverLSP session gracefully delete events
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: session_non_gracefully_delete_events
                
                	The number of BFDOverLSP session non gracefully delete events
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: session_replay_events
                
                	The number of BFDOverLSP session replay events
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: session_up_events
                
                	The number of BFDOverLSP session up events
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTeStandby.Bfd.Counters.BfdOverLspHeadCounters, self).__init__()

                    self.yang_name = "bfd-over-lsp-head-counters"
                    self.yang_parent_name = "counters"

                    self.session_admin_down_events = YLeaf(YType.uint32, "session-admin-down-events")

                    self.session_create_events = YLeaf(YType.uint32, "session-create-events")

                    self.session_create_timeout_events = YLeaf(YType.uint32, "session-create-timeout-events")

                    self.session_creation_failed_events = YLeaf(YType.uint32, "session-creation-failed-events")

                    self.session_down_events = YLeaf(YType.uint32, "session-down-events")

                    self.session_gracefully_delete_events = YLeaf(YType.uint32, "session-gracefully-delete-events")

                    self.session_non_gracefully_delete_events = YLeaf(YType.uint32, "session-non-gracefully-delete-events")

                    self.session_replay_events = YLeaf(YType.uint32, "session-replay-events")

                    self.session_up_events = YLeaf(YType.uint32, "session-up-events")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("session_admin_down_events",
                                    "session_create_events",
                                    "session_create_timeout_events",
                                    "session_creation_failed_events",
                                    "session_down_events",
                                    "session_gracefully_delete_events",
                                    "session_non_gracefully_delete_events",
                                    "session_replay_events",
                                    "session_up_events") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTeStandby.Bfd.Counters.BfdOverLspHeadCounters, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTeStandby.Bfd.Counters.BfdOverLspHeadCounters, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.session_admin_down_events.is_set or
                        self.session_create_events.is_set or
                        self.session_create_timeout_events.is_set or
                        self.session_creation_failed_events.is_set or
                        self.session_down_events.is_set or
                        self.session_gracefully_delete_events.is_set or
                        self.session_non_gracefully_delete_events.is_set or
                        self.session_replay_events.is_set or
                        self.session_up_events.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.session_admin_down_events.yfilter != YFilter.not_set or
                        self.session_create_events.yfilter != YFilter.not_set or
                        self.session_create_timeout_events.yfilter != YFilter.not_set or
                        self.session_creation_failed_events.yfilter != YFilter.not_set or
                        self.session_down_events.yfilter != YFilter.not_set or
                        self.session_gracefully_delete_events.yfilter != YFilter.not_set or
                        self.session_non_gracefully_delete_events.yfilter != YFilter.not_set or
                        self.session_replay_events.yfilter != YFilter.not_set or
                        self.session_up_events.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "bfd-over-lsp-head-counters" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/bfd/counters/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.session_admin_down_events.is_set or self.session_admin_down_events.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.session_admin_down_events.get_name_leafdata())
                    if (self.session_create_events.is_set or self.session_create_events.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.session_create_events.get_name_leafdata())
                    if (self.session_create_timeout_events.is_set or self.session_create_timeout_events.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.session_create_timeout_events.get_name_leafdata())
                    if (self.session_creation_failed_events.is_set or self.session_creation_failed_events.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.session_creation_failed_events.get_name_leafdata())
                    if (self.session_down_events.is_set or self.session_down_events.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.session_down_events.get_name_leafdata())
                    if (self.session_gracefully_delete_events.is_set or self.session_gracefully_delete_events.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.session_gracefully_delete_events.get_name_leafdata())
                    if (self.session_non_gracefully_delete_events.is_set or self.session_non_gracefully_delete_events.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.session_non_gracefully_delete_events.get_name_leafdata())
                    if (self.session_replay_events.is_set or self.session_replay_events.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.session_replay_events.get_name_leafdata())
                    if (self.session_up_events.is_set or self.session_up_events.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.session_up_events.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "session-admin-down-events" or name == "session-create-events" or name == "session-create-timeout-events" or name == "session-creation-failed-events" or name == "session-down-events" or name == "session-gracefully-delete-events" or name == "session-non-gracefully-delete-events" or name == "session-replay-events" or name == "session-up-events"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "session-admin-down-events"):
                        self.session_admin_down_events = value
                        self.session_admin_down_events.value_namespace = name_space
                        self.session_admin_down_events.value_namespace_prefix = name_space_prefix
                    if(value_path == "session-create-events"):
                        self.session_create_events = value
                        self.session_create_events.value_namespace = name_space
                        self.session_create_events.value_namespace_prefix = name_space_prefix
                    if(value_path == "session-create-timeout-events"):
                        self.session_create_timeout_events = value
                        self.session_create_timeout_events.value_namespace = name_space
                        self.session_create_timeout_events.value_namespace_prefix = name_space_prefix
                    if(value_path == "session-creation-failed-events"):
                        self.session_creation_failed_events = value
                        self.session_creation_failed_events.value_namespace = name_space
                        self.session_creation_failed_events.value_namespace_prefix = name_space_prefix
                    if(value_path == "session-down-events"):
                        self.session_down_events = value
                        self.session_down_events.value_namespace = name_space
                        self.session_down_events.value_namespace_prefix = name_space_prefix
                    if(value_path == "session-gracefully-delete-events"):
                        self.session_gracefully_delete_events = value
                        self.session_gracefully_delete_events.value_namespace = name_space
                        self.session_gracefully_delete_events.value_namespace_prefix = name_space_prefix
                    if(value_path == "session-non-gracefully-delete-events"):
                        self.session_non_gracefully_delete_events = value
                        self.session_non_gracefully_delete_events.value_namespace = name_space
                        self.session_non_gracefully_delete_events.value_namespace_prefix = name_space_prefix
                    if(value_path == "session-replay-events"):
                        self.session_replay_events = value
                        self.session_replay_events.value_namespace = name_space
                        self.session_replay_events.value_namespace_prefix = name_space_prefix
                    if(value_path == "session-up-events"):
                        self.session_up_events = value
                        self.session_up_events.value_namespace = name_space
                        self.session_up_events.value_namespace_prefix = name_space_prefix


            class SbfdOverLspHeadCounters(Entity):
                """
                SBFD over Head\-end LSPs Cumulative Counters
                
                .. attribute:: session_admin_down_events
                
                	The number of BFDOverLSP session admin down events
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: session_create_events
                
                	The number of BFDOverLSP session create events
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: session_create_timeout_events
                
                	The number of BFDOverLSP session create timeout events
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: session_creation_failed_events
                
                	The number of BFDOverLSP session creation failed events
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: session_down_events
                
                	The number of BFDOverLSP session down events
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: session_gracefully_delete_events
                
                	The number of BFDOverLSP session gracefully delete events
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: session_non_gracefully_delete_events
                
                	The number of BFDOverLSP session non gracefully delete events
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: session_replay_events
                
                	The number of BFDOverLSP session replay events
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: session_up_events
                
                	The number of BFDOverLSP session up events
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTeStandby.Bfd.Counters.SbfdOverLspHeadCounters, self).__init__()

                    self.yang_name = "sbfd-over-lsp-head-counters"
                    self.yang_parent_name = "counters"

                    self.session_admin_down_events = YLeaf(YType.uint32, "session-admin-down-events")

                    self.session_create_events = YLeaf(YType.uint32, "session-create-events")

                    self.session_create_timeout_events = YLeaf(YType.uint32, "session-create-timeout-events")

                    self.session_creation_failed_events = YLeaf(YType.uint32, "session-creation-failed-events")

                    self.session_down_events = YLeaf(YType.uint32, "session-down-events")

                    self.session_gracefully_delete_events = YLeaf(YType.uint32, "session-gracefully-delete-events")

                    self.session_non_gracefully_delete_events = YLeaf(YType.uint32, "session-non-gracefully-delete-events")

                    self.session_replay_events = YLeaf(YType.uint32, "session-replay-events")

                    self.session_up_events = YLeaf(YType.uint32, "session-up-events")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("session_admin_down_events",
                                    "session_create_events",
                                    "session_create_timeout_events",
                                    "session_creation_failed_events",
                                    "session_down_events",
                                    "session_gracefully_delete_events",
                                    "session_non_gracefully_delete_events",
                                    "session_replay_events",
                                    "session_up_events") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTeStandby.Bfd.Counters.SbfdOverLspHeadCounters, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTeStandby.Bfd.Counters.SbfdOverLspHeadCounters, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.session_admin_down_events.is_set or
                        self.session_create_events.is_set or
                        self.session_create_timeout_events.is_set or
                        self.session_creation_failed_events.is_set or
                        self.session_down_events.is_set or
                        self.session_gracefully_delete_events.is_set or
                        self.session_non_gracefully_delete_events.is_set or
                        self.session_replay_events.is_set or
                        self.session_up_events.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.session_admin_down_events.yfilter != YFilter.not_set or
                        self.session_create_events.yfilter != YFilter.not_set or
                        self.session_create_timeout_events.yfilter != YFilter.not_set or
                        self.session_creation_failed_events.yfilter != YFilter.not_set or
                        self.session_down_events.yfilter != YFilter.not_set or
                        self.session_gracefully_delete_events.yfilter != YFilter.not_set or
                        self.session_non_gracefully_delete_events.yfilter != YFilter.not_set or
                        self.session_replay_events.yfilter != YFilter.not_set or
                        self.session_up_events.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "sbfd-over-lsp-head-counters" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/bfd/counters/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.session_admin_down_events.is_set or self.session_admin_down_events.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.session_admin_down_events.get_name_leafdata())
                    if (self.session_create_events.is_set or self.session_create_events.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.session_create_events.get_name_leafdata())
                    if (self.session_create_timeout_events.is_set or self.session_create_timeout_events.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.session_create_timeout_events.get_name_leafdata())
                    if (self.session_creation_failed_events.is_set or self.session_creation_failed_events.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.session_creation_failed_events.get_name_leafdata())
                    if (self.session_down_events.is_set or self.session_down_events.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.session_down_events.get_name_leafdata())
                    if (self.session_gracefully_delete_events.is_set or self.session_gracefully_delete_events.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.session_gracefully_delete_events.get_name_leafdata())
                    if (self.session_non_gracefully_delete_events.is_set or self.session_non_gracefully_delete_events.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.session_non_gracefully_delete_events.get_name_leafdata())
                    if (self.session_replay_events.is_set or self.session_replay_events.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.session_replay_events.get_name_leafdata())
                    if (self.session_up_events.is_set or self.session_up_events.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.session_up_events.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "session-admin-down-events" or name == "session-create-events" or name == "session-create-timeout-events" or name == "session-creation-failed-events" or name == "session-down-events" or name == "session-gracefully-delete-events" or name == "session-non-gracefully-delete-events" or name == "session-replay-events" or name == "session-up-events"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "session-admin-down-events"):
                        self.session_admin_down_events = value
                        self.session_admin_down_events.value_namespace = name_space
                        self.session_admin_down_events.value_namespace_prefix = name_space_prefix
                    if(value_path == "session-create-events"):
                        self.session_create_events = value
                        self.session_create_events.value_namespace = name_space
                        self.session_create_events.value_namespace_prefix = name_space_prefix
                    if(value_path == "session-create-timeout-events"):
                        self.session_create_timeout_events = value
                        self.session_create_timeout_events.value_namespace = name_space
                        self.session_create_timeout_events.value_namespace_prefix = name_space_prefix
                    if(value_path == "session-creation-failed-events"):
                        self.session_creation_failed_events = value
                        self.session_creation_failed_events.value_namespace = name_space
                        self.session_creation_failed_events.value_namespace_prefix = name_space_prefix
                    if(value_path == "session-down-events"):
                        self.session_down_events = value
                        self.session_down_events.value_namespace = name_space
                        self.session_down_events.value_namespace_prefix = name_space_prefix
                    if(value_path == "session-gracefully-delete-events"):
                        self.session_gracefully_delete_events = value
                        self.session_gracefully_delete_events.value_namespace = name_space
                        self.session_gracefully_delete_events.value_namespace_prefix = name_space_prefix
                    if(value_path == "session-non-gracefully-delete-events"):
                        self.session_non_gracefully_delete_events = value
                        self.session_non_gracefully_delete_events.value_namespace = name_space
                        self.session_non_gracefully_delete_events.value_namespace_prefix = name_space_prefix
                    if(value_path == "session-replay-events"):
                        self.session_replay_events = value
                        self.session_replay_events.value_namespace = name_space
                        self.session_replay_events.value_namespace_prefix = name_space_prefix
                    if(value_path == "session-up-events"):
                        self.session_up_events = value
                        self.session_up_events.value_namespace = name_space
                        self.session_up_events.value_namespace_prefix = name_space_prefix


            class BfdOverLspTailCounters(Entity):
                """
                BFD over Tail\-end LSPs Cumulative Counters
                
                .. attribute:: session_admin_down_events
                
                	The number of BFDOverLM session admin down events
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: session_create_events
                
                	The number of BFDOverLM session create events
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: session_creation_failed_events
                
                	The number of BFDOverLM session creation failed events
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: session_down_events
                
                	The number of BFDOverLM session down events
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: session_gracefully_delete_events
                
                	The number of BFDOverLM session gracefully delete events
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: session_non_gracefully_delete_events
                
                	The number of BFDOverLM session non gracefully delete events
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: session_replay_events
                
                	The number of BFDOverLSP session replay events
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: session_up_events
                
                	The number of BFDOverLM session up events
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTeStandby.Bfd.Counters.BfdOverLspTailCounters, self).__init__()

                    self.yang_name = "bfd-over-lsp-tail-counters"
                    self.yang_parent_name = "counters"

                    self.session_admin_down_events = YLeaf(YType.uint32, "session-admin-down-events")

                    self.session_create_events = YLeaf(YType.uint32, "session-create-events")

                    self.session_creation_failed_events = YLeaf(YType.uint32, "session-creation-failed-events")

                    self.session_down_events = YLeaf(YType.uint32, "session-down-events")

                    self.session_gracefully_delete_events = YLeaf(YType.uint32, "session-gracefully-delete-events")

                    self.session_non_gracefully_delete_events = YLeaf(YType.uint32, "session-non-gracefully-delete-events")

                    self.session_replay_events = YLeaf(YType.uint32, "session-replay-events")

                    self.session_up_events = YLeaf(YType.uint32, "session-up-events")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("session_admin_down_events",
                                    "session_create_events",
                                    "session_creation_failed_events",
                                    "session_down_events",
                                    "session_gracefully_delete_events",
                                    "session_non_gracefully_delete_events",
                                    "session_replay_events",
                                    "session_up_events") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTeStandby.Bfd.Counters.BfdOverLspTailCounters, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTeStandby.Bfd.Counters.BfdOverLspTailCounters, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.session_admin_down_events.is_set or
                        self.session_create_events.is_set or
                        self.session_creation_failed_events.is_set or
                        self.session_down_events.is_set or
                        self.session_gracefully_delete_events.is_set or
                        self.session_non_gracefully_delete_events.is_set or
                        self.session_replay_events.is_set or
                        self.session_up_events.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.session_admin_down_events.yfilter != YFilter.not_set or
                        self.session_create_events.yfilter != YFilter.not_set or
                        self.session_creation_failed_events.yfilter != YFilter.not_set or
                        self.session_down_events.yfilter != YFilter.not_set or
                        self.session_gracefully_delete_events.yfilter != YFilter.not_set or
                        self.session_non_gracefully_delete_events.yfilter != YFilter.not_set or
                        self.session_replay_events.yfilter != YFilter.not_set or
                        self.session_up_events.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "bfd-over-lsp-tail-counters" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/bfd/counters/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.session_admin_down_events.is_set or self.session_admin_down_events.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.session_admin_down_events.get_name_leafdata())
                    if (self.session_create_events.is_set or self.session_create_events.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.session_create_events.get_name_leafdata())
                    if (self.session_creation_failed_events.is_set or self.session_creation_failed_events.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.session_creation_failed_events.get_name_leafdata())
                    if (self.session_down_events.is_set or self.session_down_events.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.session_down_events.get_name_leafdata())
                    if (self.session_gracefully_delete_events.is_set or self.session_gracefully_delete_events.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.session_gracefully_delete_events.get_name_leafdata())
                    if (self.session_non_gracefully_delete_events.is_set or self.session_non_gracefully_delete_events.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.session_non_gracefully_delete_events.get_name_leafdata())
                    if (self.session_replay_events.is_set or self.session_replay_events.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.session_replay_events.get_name_leafdata())
                    if (self.session_up_events.is_set or self.session_up_events.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.session_up_events.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "session-admin-down-events" or name == "session-create-events" or name == "session-creation-failed-events" or name == "session-down-events" or name == "session-gracefully-delete-events" or name == "session-non-gracefully-delete-events" or name == "session-replay-events" or name == "session-up-events"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "session-admin-down-events"):
                        self.session_admin_down_events = value
                        self.session_admin_down_events.value_namespace = name_space
                        self.session_admin_down_events.value_namespace_prefix = name_space_prefix
                    if(value_path == "session-create-events"):
                        self.session_create_events = value
                        self.session_create_events.value_namespace = name_space
                        self.session_create_events.value_namespace_prefix = name_space_prefix
                    if(value_path == "session-creation-failed-events"):
                        self.session_creation_failed_events = value
                        self.session_creation_failed_events.value_namespace = name_space
                        self.session_creation_failed_events.value_namespace_prefix = name_space_prefix
                    if(value_path == "session-down-events"):
                        self.session_down_events = value
                        self.session_down_events.value_namespace = name_space
                        self.session_down_events.value_namespace_prefix = name_space_prefix
                    if(value_path == "session-gracefully-delete-events"):
                        self.session_gracefully_delete_events = value
                        self.session_gracefully_delete_events.value_namespace = name_space
                        self.session_gracefully_delete_events.value_namespace_prefix = name_space_prefix
                    if(value_path == "session-non-gracefully-delete-events"):
                        self.session_non_gracefully_delete_events = value
                        self.session_non_gracefully_delete_events.value_namespace = name_space
                        self.session_non_gracefully_delete_events.value_namespace_prefix = name_space_prefix
                    if(value_path == "session-replay-events"):
                        self.session_replay_events = value
                        self.session_replay_events.value_namespace = name_space
                        self.session_replay_events.value_namespace_prefix = name_space_prefix
                    if(value_path == "session-up-events"):
                        self.session_up_events = value
                        self.session_up_events.value_namespace = name_space
                        self.session_up_events.value_namespace_prefix = name_space_prefix


            class BfDoLmCounters(Entity):
                """
                BFD over Links Cumulative Counters
                
                .. attribute:: session_admin_down_events
                
                	The number of BFDOverLM session admin down events
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: session_create_events
                
                	The number of BFDOverLM session create events
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: session_creation_failed_events
                
                	The number of BFDOverLM session creation failed events
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: session_down_events
                
                	The number of BFDOverLM session down events
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: session_gracefully_delete_events
                
                	The number of BFDOverLM session gracefully delete events
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: session_non_gracefully_delete_events
                
                	The number of BFDOverLM session non gracefully delete events
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: session_replay_events
                
                	The number of BFDOverLSP session replay events
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: session_up_events
                
                	The number of BFDOverLM session up events
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTeStandby.Bfd.Counters.BfDoLmCounters, self).__init__()

                    self.yang_name = "bf-do-lm-counters"
                    self.yang_parent_name = "counters"

                    self.session_admin_down_events = YLeaf(YType.uint32, "session-admin-down-events")

                    self.session_create_events = YLeaf(YType.uint32, "session-create-events")

                    self.session_creation_failed_events = YLeaf(YType.uint32, "session-creation-failed-events")

                    self.session_down_events = YLeaf(YType.uint32, "session-down-events")

                    self.session_gracefully_delete_events = YLeaf(YType.uint32, "session-gracefully-delete-events")

                    self.session_non_gracefully_delete_events = YLeaf(YType.uint32, "session-non-gracefully-delete-events")

                    self.session_replay_events = YLeaf(YType.uint32, "session-replay-events")

                    self.session_up_events = YLeaf(YType.uint32, "session-up-events")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("session_admin_down_events",
                                    "session_create_events",
                                    "session_creation_failed_events",
                                    "session_down_events",
                                    "session_gracefully_delete_events",
                                    "session_non_gracefully_delete_events",
                                    "session_replay_events",
                                    "session_up_events") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTeStandby.Bfd.Counters.BfDoLmCounters, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTeStandby.Bfd.Counters.BfDoLmCounters, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.session_admin_down_events.is_set or
                        self.session_create_events.is_set or
                        self.session_creation_failed_events.is_set or
                        self.session_down_events.is_set or
                        self.session_gracefully_delete_events.is_set or
                        self.session_non_gracefully_delete_events.is_set or
                        self.session_replay_events.is_set or
                        self.session_up_events.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.session_admin_down_events.yfilter != YFilter.not_set or
                        self.session_create_events.yfilter != YFilter.not_set or
                        self.session_creation_failed_events.yfilter != YFilter.not_set or
                        self.session_down_events.yfilter != YFilter.not_set or
                        self.session_gracefully_delete_events.yfilter != YFilter.not_set or
                        self.session_non_gracefully_delete_events.yfilter != YFilter.not_set or
                        self.session_replay_events.yfilter != YFilter.not_set or
                        self.session_up_events.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "bf-do-lm-counters" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/bfd/counters/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.session_admin_down_events.is_set or self.session_admin_down_events.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.session_admin_down_events.get_name_leafdata())
                    if (self.session_create_events.is_set or self.session_create_events.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.session_create_events.get_name_leafdata())
                    if (self.session_creation_failed_events.is_set or self.session_creation_failed_events.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.session_creation_failed_events.get_name_leafdata())
                    if (self.session_down_events.is_set or self.session_down_events.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.session_down_events.get_name_leafdata())
                    if (self.session_gracefully_delete_events.is_set or self.session_gracefully_delete_events.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.session_gracefully_delete_events.get_name_leafdata())
                    if (self.session_non_gracefully_delete_events.is_set or self.session_non_gracefully_delete_events.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.session_non_gracefully_delete_events.get_name_leafdata())
                    if (self.session_replay_events.is_set or self.session_replay_events.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.session_replay_events.get_name_leafdata())
                    if (self.session_up_events.is_set or self.session_up_events.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.session_up_events.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "session-admin-down-events" or name == "session-create-events" or name == "session-creation-failed-events" or name == "session-down-events" or name == "session-gracefully-delete-events" or name == "session-non-gracefully-delete-events" or name == "session-replay-events" or name == "session-up-events"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "session-admin-down-events"):
                        self.session_admin_down_events = value
                        self.session_admin_down_events.value_namespace = name_space
                        self.session_admin_down_events.value_namespace_prefix = name_space_prefix
                    if(value_path == "session-create-events"):
                        self.session_create_events = value
                        self.session_create_events.value_namespace = name_space
                        self.session_create_events.value_namespace_prefix = name_space_prefix
                    if(value_path == "session-creation-failed-events"):
                        self.session_creation_failed_events = value
                        self.session_creation_failed_events.value_namespace = name_space
                        self.session_creation_failed_events.value_namespace_prefix = name_space_prefix
                    if(value_path == "session-down-events"):
                        self.session_down_events = value
                        self.session_down_events.value_namespace = name_space
                        self.session_down_events.value_namespace_prefix = name_space_prefix
                    if(value_path == "session-gracefully-delete-events"):
                        self.session_gracefully_delete_events = value
                        self.session_gracefully_delete_events.value_namespace = name_space
                        self.session_gracefully_delete_events.value_namespace_prefix = name_space_prefix
                    if(value_path == "session-non-gracefully-delete-events"):
                        self.session_non_gracefully_delete_events = value
                        self.session_non_gracefully_delete_events.value_namespace = name_space
                        self.session_non_gracefully_delete_events.value_namespace_prefix = name_space_prefix
                    if(value_path == "session-replay-events"):
                        self.session_replay_events = value
                        self.session_replay_events.value_namespace = name_space
                        self.session_replay_events.value_namespace_prefix = name_space_prefix
                    if(value_path == "session-up-events"):
                        self.session_up_events = value
                        self.session_up_events.value_namespace = name_space
                        self.session_up_events.value_namespace_prefix = name_space_prefix

            def has_data(self):
                return (
                    self.last_cleared_timestamp.is_set or
                    (self.bf_do_lm_counters is not None and self.bf_do_lm_counters.has_data()) or
                    (self.bfd_over_lsp_head_counters is not None and self.bfd_over_lsp_head_counters.has_data()) or
                    (self.bfd_over_lsp_tail_counters is not None and self.bfd_over_lsp_tail_counters.has_data()) or
                    (self.sbfd_over_lsp_head_counters is not None and self.sbfd_over_lsp_head_counters.has_data()))

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    self.last_cleared_timestamp.yfilter != YFilter.not_set or
                    (self.bf_do_lm_counters is not None and self.bf_do_lm_counters.has_operation()) or
                    (self.bfd_over_lsp_head_counters is not None and self.bfd_over_lsp_head_counters.has_operation()) or
                    (self.bfd_over_lsp_tail_counters is not None and self.bfd_over_lsp_tail_counters.has_operation()) or
                    (self.sbfd_over_lsp_head_counters is not None and self.sbfd_over_lsp_head_counters.has_operation()))

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "counters" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/bfd/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.last_cleared_timestamp.is_set or self.last_cleared_timestamp.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.last_cleared_timestamp.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "bf-do-lm-counters"):
                    if (self.bf_do_lm_counters is None):
                        self.bf_do_lm_counters = MplsTeStandby.Bfd.Counters.BfDoLmCounters()
                        self.bf_do_lm_counters.parent = self
                        self._children_name_map["bf_do_lm_counters"] = "bf-do-lm-counters"
                    return self.bf_do_lm_counters

                if (child_yang_name == "bfd-over-lsp-head-counters"):
                    if (self.bfd_over_lsp_head_counters is None):
                        self.bfd_over_lsp_head_counters = MplsTeStandby.Bfd.Counters.BfdOverLspHeadCounters()
                        self.bfd_over_lsp_head_counters.parent = self
                        self._children_name_map["bfd_over_lsp_head_counters"] = "bfd-over-lsp-head-counters"
                    return self.bfd_over_lsp_head_counters

                if (child_yang_name == "bfd-over-lsp-tail-counters"):
                    if (self.bfd_over_lsp_tail_counters is None):
                        self.bfd_over_lsp_tail_counters = MplsTeStandby.Bfd.Counters.BfdOverLspTailCounters()
                        self.bfd_over_lsp_tail_counters.parent = self
                        self._children_name_map["bfd_over_lsp_tail_counters"] = "bfd-over-lsp-tail-counters"
                    return self.bfd_over_lsp_tail_counters

                if (child_yang_name == "sbfd-over-lsp-head-counters"):
                    if (self.sbfd_over_lsp_head_counters is None):
                        self.sbfd_over_lsp_head_counters = MplsTeStandby.Bfd.Counters.SbfdOverLspHeadCounters()
                        self.sbfd_over_lsp_head_counters.parent = self
                        self._children_name_map["sbfd_over_lsp_head_counters"] = "sbfd-over-lsp-head-counters"
                    return self.sbfd_over_lsp_head_counters

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "bf-do-lm-counters" or name == "bfd-over-lsp-head-counters" or name == "bfd-over-lsp-tail-counters" or name == "sbfd-over-lsp-head-counters" or name == "last-cleared-timestamp"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "last-cleared-timestamp"):
                    self.last_cleared_timestamp = value
                    self.last_cleared_timestamp.value_namespace = name_space
                    self.last_cleared_timestamp.value_namespace_prefix = name_space_prefix

        def has_data(self):
            return (
                (self.counters is not None and self.counters.has_data()) or
                (self.head_infos is not None and self.head_infos.has_data()) or
                (self.links is not None and self.links.has_data()) or
                (self.summary is not None and self.summary.has_data()) or
                (self.tail_infos is not None and self.tail_infos.has_data()))

        def has_operation(self):
            return (
                self.yfilter != YFilter.not_set or
                (self.counters is not None and self.counters.has_operation()) or
                (self.head_infos is not None and self.head_infos.has_operation()) or
                (self.links is not None and self.links.has_operation()) or
                (self.summary is not None and self.summary.has_operation()) or
                (self.tail_infos is not None and self.tail_infos.has_operation()))

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "bfd" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "counters"):
                if (self.counters is None):
                    self.counters = MplsTeStandby.Bfd.Counters()
                    self.counters.parent = self
                    self._children_name_map["counters"] = "counters"
                return self.counters

            if (child_yang_name == "head-infos"):
                if (self.head_infos is None):
                    self.head_infos = MplsTeStandby.Bfd.HeadInfos()
                    self.head_infos.parent = self
                    self._children_name_map["head_infos"] = "head-infos"
                return self.head_infos

            if (child_yang_name == "links"):
                if (self.links is None):
                    self.links = MplsTeStandby.Bfd.Links()
                    self.links.parent = self
                    self._children_name_map["links"] = "links"
                return self.links

            if (child_yang_name == "summary"):
                if (self.summary is None):
                    self.summary = MplsTeStandby.Bfd.Summary()
                    self.summary.parent = self
                    self._children_name_map["summary"] = "summary"
                return self.summary

            if (child_yang_name == "tail-infos"):
                if (self.tail_infos is None):
                    self.tail_infos = MplsTeStandby.Bfd.TailInfos()
                    self.tail_infos.parent = self
                    self._children_name_map["tail_infos"] = "tail-infos"
                return self.tail_infos

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "counters" or name == "head-infos" or name == "links" or name == "summary" or name == "tail-infos"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class Nsr(Entity):
        """
        MPLS TE NSR information
        
        .. attribute:: detail
        
        	MPLS TE NSR Status information
        	**type**\:   :py:class:`Detail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Nsr.Detail>`
        
        .. attribute:: status
        
        	MPLS TE NSR Status information
        	**type**\:   :py:class:`Status <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Nsr.Status>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsTeStandby.Nsr, self).__init__()

            self.yang_name = "nsr"
            self.yang_parent_name = "mpls-te-standby"

            self.detail = MplsTeStandby.Nsr.Detail()
            self.detail.parent = self
            self._children_name_map["detail"] = "detail"
            self._children_yang_names.add("detail")

            self.status = MplsTeStandby.Nsr.Status()
            self.status.parent = self
            self._children_name_map["status"] = "status"
            self._children_yang_names.add("status")


        class Status(Entity):
            """
            MPLS TE NSR Status information
            
            .. attribute:: role
            
            	Process role
            	**type**\:   :py:class:`TeProcRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProcRole>`
            
            .. attribute:: sync_status_information
            
            	Sync information for the NSR and ISSU
            	**type**\:   :py:class:`SyncStatusInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Nsr.Status.SyncStatusInformation>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTeStandby.Nsr.Status, self).__init__()

                self.yang_name = "status"
                self.yang_parent_name = "nsr"

                self.role = YLeaf(YType.enumeration, "role")

                self.sync_status_information = MplsTeStandby.Nsr.Status.SyncStatusInformation()
                self.sync_status_information.parent = self
                self._children_name_map["sync_status_information"] = "sync-status-information"
                self._children_yang_names.add("sync-status-information")

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("role") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTeStandby.Nsr.Status, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTeStandby.Nsr.Status, self).__setattr__(name, value)


            class SyncStatusInformation(Entity):
                """
                Sync information for the NSR and ISSU
                
                .. attribute:: master_sync_information
                
                	Master sync information
                	**type**\:   :py:class:`MasterSyncInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Nsr.Status.SyncStatusInformation.MasterSyncInformation>`
                
                .. attribute:: slave_sync_information
                
                	Slave sync information
                	**type**\:   :py:class:`SlaveSyncInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Nsr.Status.SyncStatusInformation.SlaveSyncInformation>`
                
                .. attribute:: sync_show_type
                
                	SyncShowType
                	**type**\:   :py:class:`TeSyncStatusShow <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncStatusShow>`
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTeStandby.Nsr.Status.SyncStatusInformation, self).__init__()

                    self.yang_name = "sync-status-information"
                    self.yang_parent_name = "status"

                    self.sync_show_type = YLeaf(YType.enumeration, "sync-show-type")

                    self.master_sync_information = MplsTeStandby.Nsr.Status.SyncStatusInformation.MasterSyncInformation()
                    self.master_sync_information.parent = self
                    self._children_name_map["master_sync_information"] = "master-sync-information"
                    self._children_yang_names.add("master-sync-information")

                    self.slave_sync_information = MplsTeStandby.Nsr.Status.SyncStatusInformation.SlaveSyncInformation()
                    self.slave_sync_information.parent = self
                    self._children_name_map["slave_sync_information"] = "slave-sync-information"
                    self._children_yang_names.add("slave-sync-information")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("sync_show_type") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTeStandby.Nsr.Status.SyncStatusInformation, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTeStandby.Nsr.Status.SyncStatusInformation, self).__setattr__(name, value)


                class SlaveSyncInformation(Entity):
                    """
                    Slave sync information
                    
                    .. attribute:: idt
                    
                    	Sync status IDT information
                    	**type**\:   :py:class:`Idt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.Idt>`
                    
                    .. attribute:: insync_sub_ls_ps
                    
                    	Sub\-LSPs in sync
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: insync_tunnels
                    
                    	Tunnels in sync
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: pending_sub_ls_ps
                    
                    	Sub\-LSPs in sync pending
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: pending_tunnels
                    
                    	Tunnels in sync pending
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2l_pending
                    
                    	Pending sub\-LSPs details
                    	**type**\: list of    :py:class:`S2LPending <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.S2LPending>`
                    
                    .. attribute:: vif_pending
                    
                    	Pending tunnels details
                    	**type**\: list of    :py:class:`VifPending <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.VifPending>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.Nsr.Status.SyncStatusInformation.SlaveSyncInformation, self).__init__()

                        self.yang_name = "slave-sync-information"
                        self.yang_parent_name = "sync-status-information"

                        self.insync_sub_ls_ps = YLeaf(YType.uint32, "insync-sub-ls-ps")

                        self.insync_tunnels = YLeaf(YType.uint32, "insync-tunnels")

                        self.pending_sub_ls_ps = YLeaf(YType.uint32, "pending-sub-ls-ps")

                        self.pending_tunnels = YLeaf(YType.uint32, "pending-tunnels")

                        self.idt = MplsTeStandby.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.Idt()
                        self.idt.parent = self
                        self._children_name_map["idt"] = "idt"
                        self._children_yang_names.add("idt")

                        self.s2l_pending = YList(self)
                        self.vif_pending = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("insync_sub_ls_ps",
                                        "insync_tunnels",
                                        "pending_sub_ls_ps",
                                        "pending_tunnels") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.Nsr.Status.SyncStatusInformation.SlaveSyncInformation, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.Nsr.Status.SyncStatusInformation.SlaveSyncInformation, self).__setattr__(name, value)


                    class Idt(Entity):
                        """
                        Sync status IDT information
                        
                        .. attribute:: current_idt_info
                        
                        	Current IDT information
                        	**type**\:   :py:class:`CurrentIdtInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo>`
                        
                        .. attribute:: previous_idt_status
                        
                        	Previous IDT information
                        	**type**\:   :py:class:`PreviousIdtStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.Idt, self).__init__()

                            self.yang_name = "idt"
                            self.yang_parent_name = "slave-sync-information"

                            self.current_idt_info = MplsTeStandby.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo()
                            self.current_idt_info.parent = self
                            self._children_name_map["current_idt_info"] = "current-idt-info"
                            self._children_yang_names.add("current-idt-info")

                            self.previous_idt_status = MplsTeStandby.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus()
                            self.previous_idt_status.parent = self
                            self._children_name_map["previous_idt_status"] = "previous-idt-status"
                            self._children_yang_names.add("previous-idt-status")


                        class CurrentIdtInfo(Entity):
                            """
                            Current IDT information
                            
                            .. attribute:: declare_time
                            
                            	Declare ready timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: idt_end_time
                            
                            	IDT end timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: idt_start_time
                            
                            	IDT start timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: is_ready_status
                            
                            	Ready status
                            	**type**\:  bool
                            
                            .. attribute:: reason
                            
                            	Not ready reason
                            	**type**\:   :py:class:`TeSyncNotReadyReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncNotReadyReason>`
                            
                            .. attribute:: withdraw_time
                            
                            	Withdraw ready timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo, self).__init__()

                                self.yang_name = "current-idt-info"
                                self.yang_parent_name = "idt"

                                self.declare_time = YLeaf(YType.uint32, "declare-time")

                                self.idt_end_time = YLeaf(YType.uint32, "idt-end-time")

                                self.idt_start_time = YLeaf(YType.uint32, "idt-start-time")

                                self.is_ready_status = YLeaf(YType.boolean, "is-ready-status")

                                self.reason = YLeaf(YType.enumeration, "reason")

                                self.withdraw_time = YLeaf(YType.uint32, "withdraw-time")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("declare_time",
                                                "idt_end_time",
                                                "idt_start_time",
                                                "is_ready_status",
                                                "reason",
                                                "withdraw_time") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.declare_time.is_set or
                                    self.idt_end_time.is_set or
                                    self.idt_start_time.is_set or
                                    self.is_ready_status.is_set or
                                    self.reason.is_set or
                                    self.withdraw_time.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.declare_time.yfilter != YFilter.not_set or
                                    self.idt_end_time.yfilter != YFilter.not_set or
                                    self.idt_start_time.yfilter != YFilter.not_set or
                                    self.is_ready_status.yfilter != YFilter.not_set or
                                    self.reason.yfilter != YFilter.not_set or
                                    self.withdraw_time.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "current-idt-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/nsr/status/sync-status-information/slave-sync-information/idt/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.declare_time.is_set or self.declare_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.declare_time.get_name_leafdata())
                                if (self.idt_end_time.is_set or self.idt_end_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.idt_end_time.get_name_leafdata())
                                if (self.idt_start_time.is_set or self.idt_start_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.idt_start_time.get_name_leafdata())
                                if (self.is_ready_status.is_set or self.is_ready_status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_ready_status.get_name_leafdata())
                                if (self.reason.is_set or self.reason.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reason.get_name_leafdata())
                                if (self.withdraw_time.is_set or self.withdraw_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.withdraw_time.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "declare-time" or name == "idt-end-time" or name == "idt-start-time" or name == "is-ready-status" or name == "reason" or name == "withdraw-time"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "declare-time"):
                                    self.declare_time = value
                                    self.declare_time.value_namespace = name_space
                                    self.declare_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "idt-end-time"):
                                    self.idt_end_time = value
                                    self.idt_end_time.value_namespace = name_space
                                    self.idt_end_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "idt-start-time"):
                                    self.idt_start_time = value
                                    self.idt_start_time.value_namespace = name_space
                                    self.idt_start_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-ready-status"):
                                    self.is_ready_status = value
                                    self.is_ready_status.value_namespace = name_space
                                    self.is_ready_status.value_namespace_prefix = name_space_prefix
                                if(value_path == "reason"):
                                    self.reason = value
                                    self.reason.value_namespace = name_space
                                    self.reason.value_namespace_prefix = name_space_prefix
                                if(value_path == "withdraw-time"):
                                    self.withdraw_time = value
                                    self.withdraw_time.value_namespace = name_space
                                    self.withdraw_time.value_namespace_prefix = name_space_prefix


                        class PreviousIdtStatus(Entity):
                            """
                            Previous IDT information
                            
                            .. attribute:: declare_time
                            
                            	Declare ready timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: idt_end_time
                            
                            	IDT end timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: idt_start_time
                            
                            	IDT start timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: is_ready_status
                            
                            	Ready status
                            	**type**\:  bool
                            
                            .. attribute:: reason
                            
                            	Not ready reason
                            	**type**\:   :py:class:`TeSyncNotReadyReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncNotReadyReason>`
                            
                            .. attribute:: withdraw_time
                            
                            	Withdraw ready timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus, self).__init__()

                                self.yang_name = "previous-idt-status"
                                self.yang_parent_name = "idt"

                                self.declare_time = YLeaf(YType.uint32, "declare-time")

                                self.idt_end_time = YLeaf(YType.uint32, "idt-end-time")

                                self.idt_start_time = YLeaf(YType.uint32, "idt-start-time")

                                self.is_ready_status = YLeaf(YType.boolean, "is-ready-status")

                                self.reason = YLeaf(YType.enumeration, "reason")

                                self.withdraw_time = YLeaf(YType.uint32, "withdraw-time")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("declare_time",
                                                "idt_end_time",
                                                "idt_start_time",
                                                "is_ready_status",
                                                "reason",
                                                "withdraw_time") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.declare_time.is_set or
                                    self.idt_end_time.is_set or
                                    self.idt_start_time.is_set or
                                    self.is_ready_status.is_set or
                                    self.reason.is_set or
                                    self.withdraw_time.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.declare_time.yfilter != YFilter.not_set or
                                    self.idt_end_time.yfilter != YFilter.not_set or
                                    self.idt_start_time.yfilter != YFilter.not_set or
                                    self.is_ready_status.yfilter != YFilter.not_set or
                                    self.reason.yfilter != YFilter.not_set or
                                    self.withdraw_time.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "previous-idt-status" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/nsr/status/sync-status-information/slave-sync-information/idt/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.declare_time.is_set or self.declare_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.declare_time.get_name_leafdata())
                                if (self.idt_end_time.is_set or self.idt_end_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.idt_end_time.get_name_leafdata())
                                if (self.idt_start_time.is_set or self.idt_start_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.idt_start_time.get_name_leafdata())
                                if (self.is_ready_status.is_set or self.is_ready_status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_ready_status.get_name_leafdata())
                                if (self.reason.is_set or self.reason.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reason.get_name_leafdata())
                                if (self.withdraw_time.is_set or self.withdraw_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.withdraw_time.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "declare-time" or name == "idt-end-time" or name == "idt-start-time" or name == "is-ready-status" or name == "reason" or name == "withdraw-time"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "declare-time"):
                                    self.declare_time = value
                                    self.declare_time.value_namespace = name_space
                                    self.declare_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "idt-end-time"):
                                    self.idt_end_time = value
                                    self.idt_end_time.value_namespace = name_space
                                    self.idt_end_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "idt-start-time"):
                                    self.idt_start_time = value
                                    self.idt_start_time.value_namespace = name_space
                                    self.idt_start_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-ready-status"):
                                    self.is_ready_status = value
                                    self.is_ready_status.value_namespace = name_space
                                    self.is_ready_status.value_namespace_prefix = name_space_prefix
                                if(value_path == "reason"):
                                    self.reason = value
                                    self.reason.value_namespace = name_space
                                    self.reason.value_namespace_prefix = name_space_prefix
                                if(value_path == "withdraw-time"):
                                    self.withdraw_time = value
                                    self.withdraw_time.value_namespace = name_space
                                    self.withdraw_time.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                (self.current_idt_info is not None and self.current_idt_info.has_data()) or
                                (self.previous_idt_status is not None and self.previous_idt_status.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.current_idt_info is not None and self.current_idt_info.has_operation()) or
                                (self.previous_idt_status is not None and self.previous_idt_status.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "idt" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/nsr/status/sync-status-information/slave-sync-information/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "current-idt-info"):
                                if (self.current_idt_info is None):
                                    self.current_idt_info = MplsTeStandby.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo()
                                    self.current_idt_info.parent = self
                                    self._children_name_map["current_idt_info"] = "current-idt-info"
                                return self.current_idt_info

                            if (child_yang_name == "previous-idt-status"):
                                if (self.previous_idt_status is None):
                                    self.previous_idt_status = MplsTeStandby.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus()
                                    self.previous_idt_status.parent = self
                                    self._children_name_map["previous_idt_status"] = "previous-idt-status"
                                return self.previous_idt_status

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "current-idt-info" or name == "previous-idt-status"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class VifPending(Entity):
                        """
                        Pending tunnels details
                        
                        .. attribute:: pending_reason
                        
                        	Pending reason
                        	**type**\:   :py:class:`TeSyncPendingReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncPendingReason>`
                        
                        .. attribute:: tunnel_name
                        
                        	Tunnel name
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.VifPending, self).__init__()

                            self.yang_name = "vif-pending"
                            self.yang_parent_name = "slave-sync-information"

                            self.pending_reason = YLeaf(YType.enumeration, "pending-reason")

                            self.tunnel_name = YLeaf(YType.str, "tunnel-name")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("pending_reason",
                                            "tunnel_name") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.VifPending, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.VifPending, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.pending_reason.is_set or
                                self.tunnel_name.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.pending_reason.yfilter != YFilter.not_set or
                                self.tunnel_name.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "vif-pending" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/nsr/status/sync-status-information/slave-sync-information/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.pending_reason.is_set or self.pending_reason.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.pending_reason.get_name_leafdata())
                            if (self.tunnel_name.is_set or self.tunnel_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tunnel_name.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "pending-reason" or name == "tunnel-name"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "pending-reason"):
                                self.pending_reason = value
                                self.pending_reason.value_namespace = name_space
                                self.pending_reason.value_namespace_prefix = name_space_prefix
                            if(value_path == "tunnel-name"):
                                self.tunnel_name = value
                                self.tunnel_name.value_namespace = name_space
                                self.tunnel_name.value_namespace_prefix = name_space_prefix


                    class S2LPending(Entity):
                        """
                        Pending sub\-LSPs details
                        
                        .. attribute:: pending_reason
                        
                        	Pending reason
                        	**type**\:   :py:class:`TeSyncPendingReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncPendingReason>`
                        
                        .. attribute:: s2l_role
                        
                        	S2L role
                        	**type**\:   :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        .. attribute:: signaled_name
                        
                        	Signaled name
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.S2LPending, self).__init__()

                            self.yang_name = "s2l-pending"
                            self.yang_parent_name = "slave-sync-information"

                            self.pending_reason = YLeaf(YType.enumeration, "pending-reason")

                            self.s2l_role = YLeaf(YType.enumeration, "s2l-role")

                            self.signaled_name = YLeaf(YType.str, "signaled-name")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("pending_reason",
                                            "s2l_role",
                                            "signaled_name") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.S2LPending, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.S2LPending, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.pending_reason.is_set or
                                self.s2l_role.is_set or
                                self.signaled_name.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.pending_reason.yfilter != YFilter.not_set or
                                self.s2l_role.yfilter != YFilter.not_set or
                                self.signaled_name.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "s2l-pending" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/nsr/status/sync-status-information/slave-sync-information/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.pending_reason.is_set or self.pending_reason.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.pending_reason.get_name_leafdata())
                            if (self.s2l_role.is_set or self.s2l_role.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_role.get_name_leafdata())
                            if (self.signaled_name.is_set or self.signaled_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.signaled_name.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "pending-reason" or name == "s2l-role" or name == "signaled-name"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "pending-reason"):
                                self.pending_reason = value
                                self.pending_reason.value_namespace = name_space
                                self.pending_reason.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-role"):
                                self.s2l_role = value
                                self.s2l_role.value_namespace = name_space
                                self.s2l_role.value_namespace_prefix = name_space_prefix
                            if(value_path == "signaled-name"):
                                self.signaled_name = value
                                self.signaled_name.value_namespace = name_space
                                self.signaled_name.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.s2l_pending:
                            if (c.has_data()):
                                return True
                        for c in self.vif_pending:
                            if (c.has_data()):
                                return True
                        return (
                            self.insync_sub_ls_ps.is_set or
                            self.insync_tunnels.is_set or
                            self.pending_sub_ls_ps.is_set or
                            self.pending_tunnels.is_set or
                            (self.idt is not None and self.idt.has_data()))

                    def has_operation(self):
                        for c in self.s2l_pending:
                            if (c.has_operation()):
                                return True
                        for c in self.vif_pending:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.insync_sub_ls_ps.yfilter != YFilter.not_set or
                            self.insync_tunnels.yfilter != YFilter.not_set or
                            self.pending_sub_ls_ps.yfilter != YFilter.not_set or
                            self.pending_tunnels.yfilter != YFilter.not_set or
                            (self.idt is not None and self.idt.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "slave-sync-information" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/nsr/status/sync-status-information/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.insync_sub_ls_ps.is_set or self.insync_sub_ls_ps.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.insync_sub_ls_ps.get_name_leafdata())
                        if (self.insync_tunnels.is_set or self.insync_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.insync_tunnels.get_name_leafdata())
                        if (self.pending_sub_ls_ps.is_set or self.pending_sub_ls_ps.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.pending_sub_ls_ps.get_name_leafdata())
                        if (self.pending_tunnels.is_set or self.pending_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.pending_tunnels.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "idt"):
                            if (self.idt is None):
                                self.idt = MplsTeStandby.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.Idt()
                                self.idt.parent = self
                                self._children_name_map["idt"] = "idt"
                            return self.idt

                        if (child_yang_name == "s2l-pending"):
                            for c in self.s2l_pending:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.S2LPending()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.s2l_pending.append(c)
                            return c

                        if (child_yang_name == "vif-pending"):
                            for c in self.vif_pending:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.Nsr.Status.SyncStatusInformation.SlaveSyncInformation.VifPending()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.vif_pending.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "idt" or name == "s2l-pending" or name == "vif-pending" or name == "insync-sub-ls-ps" or name == "insync-tunnels" or name == "pending-sub-ls-ps" or name == "pending-tunnels"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "insync-sub-ls-ps"):
                            self.insync_sub_ls_ps = value
                            self.insync_sub_ls_ps.value_namespace = name_space
                            self.insync_sub_ls_ps.value_namespace_prefix = name_space_prefix
                        if(value_path == "insync-tunnels"):
                            self.insync_tunnels = value
                            self.insync_tunnels.value_namespace = name_space
                            self.insync_tunnels.value_namespace_prefix = name_space_prefix
                        if(value_path == "pending-sub-ls-ps"):
                            self.pending_sub_ls_ps = value
                            self.pending_sub_ls_ps.value_namespace = name_space
                            self.pending_sub_ls_ps.value_namespace_prefix = name_space_prefix
                        if(value_path == "pending-tunnels"):
                            self.pending_tunnels = value
                            self.pending_tunnels.value_namespace = name_space
                            self.pending_tunnels.value_namespace_prefix = name_space_prefix


                class MasterSyncInformation(Entity):
                    """
                    Master sync information
                    
                    .. attribute:: idt
                    
                    	Sync status IDT information
                    	**type**\:   :py:class:`Idt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Nsr.Status.SyncStatusInformation.MasterSyncInformation.Idt>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.Nsr.Status.SyncStatusInformation.MasterSyncInformation, self).__init__()

                        self.yang_name = "master-sync-information"
                        self.yang_parent_name = "sync-status-information"

                        self.idt = MplsTeStandby.Nsr.Status.SyncStatusInformation.MasterSyncInformation.Idt()
                        self.idt.parent = self
                        self._children_name_map["idt"] = "idt"
                        self._children_yang_names.add("idt")


                    class Idt(Entity):
                        """
                        Sync status IDT information
                        
                        .. attribute:: current_idt_info
                        
                        	Current IDT information
                        	**type**\:   :py:class:`CurrentIdtInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Nsr.Status.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo>`
                        
                        .. attribute:: previous_idt_status
                        
                        	Previous IDT information
                        	**type**\:   :py:class:`PreviousIdtStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Nsr.Status.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.Nsr.Status.SyncStatusInformation.MasterSyncInformation.Idt, self).__init__()

                            self.yang_name = "idt"
                            self.yang_parent_name = "master-sync-information"

                            self.current_idt_info = MplsTeStandby.Nsr.Status.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo()
                            self.current_idt_info.parent = self
                            self._children_name_map["current_idt_info"] = "current-idt-info"
                            self._children_yang_names.add("current-idt-info")

                            self.previous_idt_status = MplsTeStandby.Nsr.Status.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus()
                            self.previous_idt_status.parent = self
                            self._children_name_map["previous_idt_status"] = "previous-idt-status"
                            self._children_yang_names.add("previous-idt-status")


                        class CurrentIdtInfo(Entity):
                            """
                            Current IDT information
                            
                            .. attribute:: declare_time
                            
                            	Declare ready timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: idt_end_time
                            
                            	IDT end timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: idt_start_time
                            
                            	IDT start timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: is_ready_status
                            
                            	Ready status
                            	**type**\:  bool
                            
                            .. attribute:: reason
                            
                            	Not ready reason
                            	**type**\:   :py:class:`TeSyncNotReadyReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncNotReadyReason>`
                            
                            .. attribute:: withdraw_time
                            
                            	Withdraw ready timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.Nsr.Status.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo, self).__init__()

                                self.yang_name = "current-idt-info"
                                self.yang_parent_name = "idt"

                                self.declare_time = YLeaf(YType.uint32, "declare-time")

                                self.idt_end_time = YLeaf(YType.uint32, "idt-end-time")

                                self.idt_start_time = YLeaf(YType.uint32, "idt-start-time")

                                self.is_ready_status = YLeaf(YType.boolean, "is-ready-status")

                                self.reason = YLeaf(YType.enumeration, "reason")

                                self.withdraw_time = YLeaf(YType.uint32, "withdraw-time")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("declare_time",
                                                "idt_end_time",
                                                "idt_start_time",
                                                "is_ready_status",
                                                "reason",
                                                "withdraw_time") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.Nsr.Status.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.Nsr.Status.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.declare_time.is_set or
                                    self.idt_end_time.is_set or
                                    self.idt_start_time.is_set or
                                    self.is_ready_status.is_set or
                                    self.reason.is_set or
                                    self.withdraw_time.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.declare_time.yfilter != YFilter.not_set or
                                    self.idt_end_time.yfilter != YFilter.not_set or
                                    self.idt_start_time.yfilter != YFilter.not_set or
                                    self.is_ready_status.yfilter != YFilter.not_set or
                                    self.reason.yfilter != YFilter.not_set or
                                    self.withdraw_time.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "current-idt-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/nsr/status/sync-status-information/master-sync-information/idt/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.declare_time.is_set or self.declare_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.declare_time.get_name_leafdata())
                                if (self.idt_end_time.is_set or self.idt_end_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.idt_end_time.get_name_leafdata())
                                if (self.idt_start_time.is_set or self.idt_start_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.idt_start_time.get_name_leafdata())
                                if (self.is_ready_status.is_set or self.is_ready_status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_ready_status.get_name_leafdata())
                                if (self.reason.is_set or self.reason.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reason.get_name_leafdata())
                                if (self.withdraw_time.is_set or self.withdraw_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.withdraw_time.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "declare-time" or name == "idt-end-time" or name == "idt-start-time" or name == "is-ready-status" or name == "reason" or name == "withdraw-time"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "declare-time"):
                                    self.declare_time = value
                                    self.declare_time.value_namespace = name_space
                                    self.declare_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "idt-end-time"):
                                    self.idt_end_time = value
                                    self.idt_end_time.value_namespace = name_space
                                    self.idt_end_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "idt-start-time"):
                                    self.idt_start_time = value
                                    self.idt_start_time.value_namespace = name_space
                                    self.idt_start_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-ready-status"):
                                    self.is_ready_status = value
                                    self.is_ready_status.value_namespace = name_space
                                    self.is_ready_status.value_namespace_prefix = name_space_prefix
                                if(value_path == "reason"):
                                    self.reason = value
                                    self.reason.value_namespace = name_space
                                    self.reason.value_namespace_prefix = name_space_prefix
                                if(value_path == "withdraw-time"):
                                    self.withdraw_time = value
                                    self.withdraw_time.value_namespace = name_space
                                    self.withdraw_time.value_namespace_prefix = name_space_prefix


                        class PreviousIdtStatus(Entity):
                            """
                            Previous IDT information
                            
                            .. attribute:: declare_time
                            
                            	Declare ready timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: idt_end_time
                            
                            	IDT end timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: idt_start_time
                            
                            	IDT start timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: is_ready_status
                            
                            	Ready status
                            	**type**\:  bool
                            
                            .. attribute:: reason
                            
                            	Not ready reason
                            	**type**\:   :py:class:`TeSyncNotReadyReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncNotReadyReason>`
                            
                            .. attribute:: withdraw_time
                            
                            	Withdraw ready timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.Nsr.Status.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus, self).__init__()

                                self.yang_name = "previous-idt-status"
                                self.yang_parent_name = "idt"

                                self.declare_time = YLeaf(YType.uint32, "declare-time")

                                self.idt_end_time = YLeaf(YType.uint32, "idt-end-time")

                                self.idt_start_time = YLeaf(YType.uint32, "idt-start-time")

                                self.is_ready_status = YLeaf(YType.boolean, "is-ready-status")

                                self.reason = YLeaf(YType.enumeration, "reason")

                                self.withdraw_time = YLeaf(YType.uint32, "withdraw-time")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("declare_time",
                                                "idt_end_time",
                                                "idt_start_time",
                                                "is_ready_status",
                                                "reason",
                                                "withdraw_time") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.Nsr.Status.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.Nsr.Status.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.declare_time.is_set or
                                    self.idt_end_time.is_set or
                                    self.idt_start_time.is_set or
                                    self.is_ready_status.is_set or
                                    self.reason.is_set or
                                    self.withdraw_time.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.declare_time.yfilter != YFilter.not_set or
                                    self.idt_end_time.yfilter != YFilter.not_set or
                                    self.idt_start_time.yfilter != YFilter.not_set or
                                    self.is_ready_status.yfilter != YFilter.not_set or
                                    self.reason.yfilter != YFilter.not_set or
                                    self.withdraw_time.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "previous-idt-status" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/nsr/status/sync-status-information/master-sync-information/idt/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.declare_time.is_set or self.declare_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.declare_time.get_name_leafdata())
                                if (self.idt_end_time.is_set or self.idt_end_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.idt_end_time.get_name_leafdata())
                                if (self.idt_start_time.is_set or self.idt_start_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.idt_start_time.get_name_leafdata())
                                if (self.is_ready_status.is_set or self.is_ready_status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_ready_status.get_name_leafdata())
                                if (self.reason.is_set or self.reason.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reason.get_name_leafdata())
                                if (self.withdraw_time.is_set or self.withdraw_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.withdraw_time.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "declare-time" or name == "idt-end-time" or name == "idt-start-time" or name == "is-ready-status" or name == "reason" or name == "withdraw-time"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "declare-time"):
                                    self.declare_time = value
                                    self.declare_time.value_namespace = name_space
                                    self.declare_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "idt-end-time"):
                                    self.idt_end_time = value
                                    self.idt_end_time.value_namespace = name_space
                                    self.idt_end_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "idt-start-time"):
                                    self.idt_start_time = value
                                    self.idt_start_time.value_namespace = name_space
                                    self.idt_start_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-ready-status"):
                                    self.is_ready_status = value
                                    self.is_ready_status.value_namespace = name_space
                                    self.is_ready_status.value_namespace_prefix = name_space_prefix
                                if(value_path == "reason"):
                                    self.reason = value
                                    self.reason.value_namespace = name_space
                                    self.reason.value_namespace_prefix = name_space_prefix
                                if(value_path == "withdraw-time"):
                                    self.withdraw_time = value
                                    self.withdraw_time.value_namespace = name_space
                                    self.withdraw_time.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                (self.current_idt_info is not None and self.current_idt_info.has_data()) or
                                (self.previous_idt_status is not None and self.previous_idt_status.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.current_idt_info is not None and self.current_idt_info.has_operation()) or
                                (self.previous_idt_status is not None and self.previous_idt_status.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "idt" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/nsr/status/sync-status-information/master-sync-information/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "current-idt-info"):
                                if (self.current_idt_info is None):
                                    self.current_idt_info = MplsTeStandby.Nsr.Status.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo()
                                    self.current_idt_info.parent = self
                                    self._children_name_map["current_idt_info"] = "current-idt-info"
                                return self.current_idt_info

                            if (child_yang_name == "previous-idt-status"):
                                if (self.previous_idt_status is None):
                                    self.previous_idt_status = MplsTeStandby.Nsr.Status.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus()
                                    self.previous_idt_status.parent = self
                                    self._children_name_map["previous_idt_status"] = "previous-idt-status"
                                return self.previous_idt_status

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "current-idt-info" or name == "previous-idt-status"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass

                    def has_data(self):
                        return (self.idt is not None and self.idt.has_data())

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            (self.idt is not None and self.idt.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "master-sync-information" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/nsr/status/sync-status-information/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "idt"):
                            if (self.idt is None):
                                self.idt = MplsTeStandby.Nsr.Status.SyncStatusInformation.MasterSyncInformation.Idt()
                                self.idt.parent = self
                                self._children_name_map["idt"] = "idt"
                            return self.idt

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "idt"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass

                def has_data(self):
                    return (
                        self.sync_show_type.is_set or
                        (self.master_sync_information is not None and self.master_sync_information.has_data()) or
                        (self.slave_sync_information is not None and self.slave_sync_information.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.sync_show_type.yfilter != YFilter.not_set or
                        (self.master_sync_information is not None and self.master_sync_information.has_operation()) or
                        (self.slave_sync_information is not None and self.slave_sync_information.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "sync-status-information" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/nsr/status/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.sync_show_type.is_set or self.sync_show_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.sync_show_type.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "master-sync-information"):
                        if (self.master_sync_information is None):
                            self.master_sync_information = MplsTeStandby.Nsr.Status.SyncStatusInformation.MasterSyncInformation()
                            self.master_sync_information.parent = self
                            self._children_name_map["master_sync_information"] = "master-sync-information"
                        return self.master_sync_information

                    if (child_yang_name == "slave-sync-information"):
                        if (self.slave_sync_information is None):
                            self.slave_sync_information = MplsTeStandby.Nsr.Status.SyncStatusInformation.SlaveSyncInformation()
                            self.slave_sync_information.parent = self
                            self._children_name_map["slave_sync_information"] = "slave-sync-information"
                        return self.slave_sync_information

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "master-sync-information" or name == "slave-sync-information" or name == "sync-show-type"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "sync-show-type"):
                        self.sync_show_type = value
                        self.sync_show_type.value_namespace = name_space
                        self.sync_show_type.value_namespace_prefix = name_space_prefix

            def has_data(self):
                return (
                    self.role.is_set or
                    (self.sync_status_information is not None and self.sync_status_information.has_data()))

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    self.role.yfilter != YFilter.not_set or
                    (self.sync_status_information is not None and self.sync_status_information.has_operation()))

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "status" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/nsr/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.role.is_set or self.role.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.role.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "sync-status-information"):
                    if (self.sync_status_information is None):
                        self.sync_status_information = MplsTeStandby.Nsr.Status.SyncStatusInformation()
                        self.sync_status_information.parent = self
                        self._children_name_map["sync_status_information"] = "sync-status-information"
                    return self.sync_status_information

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "sync-status-information" or name == "role"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "role"):
                    self.role = value
                    self.role.value_namespace = name_space
                    self.role.value_namespace_prefix = name_space_prefix


        class Detail(Entity):
            """
            MPLS TE NSR Status information
            
            .. attribute:: role
            
            	Process role
            	**type**\:   :py:class:`TeProcRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeProcRole>`
            
            .. attribute:: sync_status_information
            
            	Sync information for the NSR and ISSU
            	**type**\:   :py:class:`SyncStatusInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Nsr.Detail.SyncStatusInformation>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTeStandby.Nsr.Detail, self).__init__()

                self.yang_name = "detail"
                self.yang_parent_name = "nsr"

                self.role = YLeaf(YType.enumeration, "role")

                self.sync_status_information = MplsTeStandby.Nsr.Detail.SyncStatusInformation()
                self.sync_status_information.parent = self
                self._children_name_map["sync_status_information"] = "sync-status-information"
                self._children_yang_names.add("sync-status-information")

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("role") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTeStandby.Nsr.Detail, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTeStandby.Nsr.Detail, self).__setattr__(name, value)


            class SyncStatusInformation(Entity):
                """
                Sync information for the NSR and ISSU
                
                .. attribute:: master_sync_information
                
                	Master sync information
                	**type**\:   :py:class:`MasterSyncInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Nsr.Detail.SyncStatusInformation.MasterSyncInformation>`
                
                .. attribute:: slave_sync_information
                
                	Slave sync information
                	**type**\:   :py:class:`SlaveSyncInformation <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation>`
                
                .. attribute:: sync_show_type
                
                	SyncShowType
                	**type**\:   :py:class:`TeSyncStatusShow <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncStatusShow>`
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTeStandby.Nsr.Detail.SyncStatusInformation, self).__init__()

                    self.yang_name = "sync-status-information"
                    self.yang_parent_name = "detail"

                    self.sync_show_type = YLeaf(YType.enumeration, "sync-show-type")

                    self.master_sync_information = MplsTeStandby.Nsr.Detail.SyncStatusInformation.MasterSyncInformation()
                    self.master_sync_information.parent = self
                    self._children_name_map["master_sync_information"] = "master-sync-information"
                    self._children_yang_names.add("master-sync-information")

                    self.slave_sync_information = MplsTeStandby.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation()
                    self.slave_sync_information.parent = self
                    self._children_name_map["slave_sync_information"] = "slave-sync-information"
                    self._children_yang_names.add("slave-sync-information")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("sync_show_type") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTeStandby.Nsr.Detail.SyncStatusInformation, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTeStandby.Nsr.Detail.SyncStatusInformation, self).__setattr__(name, value)


                class SlaveSyncInformation(Entity):
                    """
                    Slave sync information
                    
                    .. attribute:: idt
                    
                    	Sync status IDT information
                    	**type**\:   :py:class:`Idt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.Idt>`
                    
                    .. attribute:: insync_sub_ls_ps
                    
                    	Sub\-LSPs in sync
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: insync_tunnels
                    
                    	Tunnels in sync
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: pending_sub_ls_ps
                    
                    	Sub\-LSPs in sync pending
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: pending_tunnels
                    
                    	Tunnels in sync pending
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: s2l_pending
                    
                    	Pending sub\-LSPs details
                    	**type**\: list of    :py:class:`S2LPending <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.S2LPending>`
                    
                    .. attribute:: vif_pending
                    
                    	Pending tunnels details
                    	**type**\: list of    :py:class:`VifPending <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.VifPending>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation, self).__init__()

                        self.yang_name = "slave-sync-information"
                        self.yang_parent_name = "sync-status-information"

                        self.insync_sub_ls_ps = YLeaf(YType.uint32, "insync-sub-ls-ps")

                        self.insync_tunnels = YLeaf(YType.uint32, "insync-tunnels")

                        self.pending_sub_ls_ps = YLeaf(YType.uint32, "pending-sub-ls-ps")

                        self.pending_tunnels = YLeaf(YType.uint32, "pending-tunnels")

                        self.idt = MplsTeStandby.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.Idt()
                        self.idt.parent = self
                        self._children_name_map["idt"] = "idt"
                        self._children_yang_names.add("idt")

                        self.s2l_pending = YList(self)
                        self.vif_pending = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("insync_sub_ls_ps",
                                        "insync_tunnels",
                                        "pending_sub_ls_ps",
                                        "pending_tunnels") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation, self).__setattr__(name, value)


                    class Idt(Entity):
                        """
                        Sync status IDT information
                        
                        .. attribute:: current_idt_info
                        
                        	Current IDT information
                        	**type**\:   :py:class:`CurrentIdtInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo>`
                        
                        .. attribute:: previous_idt_status
                        
                        	Previous IDT information
                        	**type**\:   :py:class:`PreviousIdtStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.Idt, self).__init__()

                            self.yang_name = "idt"
                            self.yang_parent_name = "slave-sync-information"

                            self.current_idt_info = MplsTeStandby.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo()
                            self.current_idt_info.parent = self
                            self._children_name_map["current_idt_info"] = "current-idt-info"
                            self._children_yang_names.add("current-idt-info")

                            self.previous_idt_status = MplsTeStandby.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus()
                            self.previous_idt_status.parent = self
                            self._children_name_map["previous_idt_status"] = "previous-idt-status"
                            self._children_yang_names.add("previous-idt-status")


                        class CurrentIdtInfo(Entity):
                            """
                            Current IDT information
                            
                            .. attribute:: declare_time
                            
                            	Declare ready timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: idt_end_time
                            
                            	IDT end timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: idt_start_time
                            
                            	IDT start timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: is_ready_status
                            
                            	Ready status
                            	**type**\:  bool
                            
                            .. attribute:: reason
                            
                            	Not ready reason
                            	**type**\:   :py:class:`TeSyncNotReadyReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncNotReadyReason>`
                            
                            .. attribute:: withdraw_time
                            
                            	Withdraw ready timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo, self).__init__()

                                self.yang_name = "current-idt-info"
                                self.yang_parent_name = "idt"

                                self.declare_time = YLeaf(YType.uint32, "declare-time")

                                self.idt_end_time = YLeaf(YType.uint32, "idt-end-time")

                                self.idt_start_time = YLeaf(YType.uint32, "idt-start-time")

                                self.is_ready_status = YLeaf(YType.boolean, "is-ready-status")

                                self.reason = YLeaf(YType.enumeration, "reason")

                                self.withdraw_time = YLeaf(YType.uint32, "withdraw-time")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("declare_time",
                                                "idt_end_time",
                                                "idt_start_time",
                                                "is_ready_status",
                                                "reason",
                                                "withdraw_time") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.declare_time.is_set or
                                    self.idt_end_time.is_set or
                                    self.idt_start_time.is_set or
                                    self.is_ready_status.is_set or
                                    self.reason.is_set or
                                    self.withdraw_time.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.declare_time.yfilter != YFilter.not_set or
                                    self.idt_end_time.yfilter != YFilter.not_set or
                                    self.idt_start_time.yfilter != YFilter.not_set or
                                    self.is_ready_status.yfilter != YFilter.not_set or
                                    self.reason.yfilter != YFilter.not_set or
                                    self.withdraw_time.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "current-idt-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/nsr/detail/sync-status-information/slave-sync-information/idt/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.declare_time.is_set or self.declare_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.declare_time.get_name_leafdata())
                                if (self.idt_end_time.is_set or self.idt_end_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.idt_end_time.get_name_leafdata())
                                if (self.idt_start_time.is_set or self.idt_start_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.idt_start_time.get_name_leafdata())
                                if (self.is_ready_status.is_set or self.is_ready_status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_ready_status.get_name_leafdata())
                                if (self.reason.is_set or self.reason.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reason.get_name_leafdata())
                                if (self.withdraw_time.is_set or self.withdraw_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.withdraw_time.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "declare-time" or name == "idt-end-time" or name == "idt-start-time" or name == "is-ready-status" or name == "reason" or name == "withdraw-time"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "declare-time"):
                                    self.declare_time = value
                                    self.declare_time.value_namespace = name_space
                                    self.declare_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "idt-end-time"):
                                    self.idt_end_time = value
                                    self.idt_end_time.value_namespace = name_space
                                    self.idt_end_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "idt-start-time"):
                                    self.idt_start_time = value
                                    self.idt_start_time.value_namespace = name_space
                                    self.idt_start_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-ready-status"):
                                    self.is_ready_status = value
                                    self.is_ready_status.value_namespace = name_space
                                    self.is_ready_status.value_namespace_prefix = name_space_prefix
                                if(value_path == "reason"):
                                    self.reason = value
                                    self.reason.value_namespace = name_space
                                    self.reason.value_namespace_prefix = name_space_prefix
                                if(value_path == "withdraw-time"):
                                    self.withdraw_time = value
                                    self.withdraw_time.value_namespace = name_space
                                    self.withdraw_time.value_namespace_prefix = name_space_prefix


                        class PreviousIdtStatus(Entity):
                            """
                            Previous IDT information
                            
                            .. attribute:: declare_time
                            
                            	Declare ready timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: idt_end_time
                            
                            	IDT end timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: idt_start_time
                            
                            	IDT start timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: is_ready_status
                            
                            	Ready status
                            	**type**\:  bool
                            
                            .. attribute:: reason
                            
                            	Not ready reason
                            	**type**\:   :py:class:`TeSyncNotReadyReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncNotReadyReason>`
                            
                            .. attribute:: withdraw_time
                            
                            	Withdraw ready timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus, self).__init__()

                                self.yang_name = "previous-idt-status"
                                self.yang_parent_name = "idt"

                                self.declare_time = YLeaf(YType.uint32, "declare-time")

                                self.idt_end_time = YLeaf(YType.uint32, "idt-end-time")

                                self.idt_start_time = YLeaf(YType.uint32, "idt-start-time")

                                self.is_ready_status = YLeaf(YType.boolean, "is-ready-status")

                                self.reason = YLeaf(YType.enumeration, "reason")

                                self.withdraw_time = YLeaf(YType.uint32, "withdraw-time")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("declare_time",
                                                "idt_end_time",
                                                "idt_start_time",
                                                "is_ready_status",
                                                "reason",
                                                "withdraw_time") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.declare_time.is_set or
                                    self.idt_end_time.is_set or
                                    self.idt_start_time.is_set or
                                    self.is_ready_status.is_set or
                                    self.reason.is_set or
                                    self.withdraw_time.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.declare_time.yfilter != YFilter.not_set or
                                    self.idt_end_time.yfilter != YFilter.not_set or
                                    self.idt_start_time.yfilter != YFilter.not_set or
                                    self.is_ready_status.yfilter != YFilter.not_set or
                                    self.reason.yfilter != YFilter.not_set or
                                    self.withdraw_time.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "previous-idt-status" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/nsr/detail/sync-status-information/slave-sync-information/idt/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.declare_time.is_set or self.declare_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.declare_time.get_name_leafdata())
                                if (self.idt_end_time.is_set or self.idt_end_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.idt_end_time.get_name_leafdata())
                                if (self.idt_start_time.is_set or self.idt_start_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.idt_start_time.get_name_leafdata())
                                if (self.is_ready_status.is_set or self.is_ready_status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_ready_status.get_name_leafdata())
                                if (self.reason.is_set or self.reason.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reason.get_name_leafdata())
                                if (self.withdraw_time.is_set or self.withdraw_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.withdraw_time.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "declare-time" or name == "idt-end-time" or name == "idt-start-time" or name == "is-ready-status" or name == "reason" or name == "withdraw-time"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "declare-time"):
                                    self.declare_time = value
                                    self.declare_time.value_namespace = name_space
                                    self.declare_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "idt-end-time"):
                                    self.idt_end_time = value
                                    self.idt_end_time.value_namespace = name_space
                                    self.idt_end_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "idt-start-time"):
                                    self.idt_start_time = value
                                    self.idt_start_time.value_namespace = name_space
                                    self.idt_start_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-ready-status"):
                                    self.is_ready_status = value
                                    self.is_ready_status.value_namespace = name_space
                                    self.is_ready_status.value_namespace_prefix = name_space_prefix
                                if(value_path == "reason"):
                                    self.reason = value
                                    self.reason.value_namespace = name_space
                                    self.reason.value_namespace_prefix = name_space_prefix
                                if(value_path == "withdraw-time"):
                                    self.withdraw_time = value
                                    self.withdraw_time.value_namespace = name_space
                                    self.withdraw_time.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                (self.current_idt_info is not None and self.current_idt_info.has_data()) or
                                (self.previous_idt_status is not None and self.previous_idt_status.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.current_idt_info is not None and self.current_idt_info.has_operation()) or
                                (self.previous_idt_status is not None and self.previous_idt_status.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "idt" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/nsr/detail/sync-status-information/slave-sync-information/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "current-idt-info"):
                                if (self.current_idt_info is None):
                                    self.current_idt_info = MplsTeStandby.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.CurrentIdtInfo()
                                    self.current_idt_info.parent = self
                                    self._children_name_map["current_idt_info"] = "current-idt-info"
                                return self.current_idt_info

                            if (child_yang_name == "previous-idt-status"):
                                if (self.previous_idt_status is None):
                                    self.previous_idt_status = MplsTeStandby.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.Idt.PreviousIdtStatus()
                                    self.previous_idt_status.parent = self
                                    self._children_name_map["previous_idt_status"] = "previous-idt-status"
                                return self.previous_idt_status

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "current-idt-info" or name == "previous-idt-status"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass


                    class VifPending(Entity):
                        """
                        Pending tunnels details
                        
                        .. attribute:: pending_reason
                        
                        	Pending reason
                        	**type**\:   :py:class:`TeSyncPendingReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncPendingReason>`
                        
                        .. attribute:: tunnel_name
                        
                        	Tunnel name
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.VifPending, self).__init__()

                            self.yang_name = "vif-pending"
                            self.yang_parent_name = "slave-sync-information"

                            self.pending_reason = YLeaf(YType.enumeration, "pending-reason")

                            self.tunnel_name = YLeaf(YType.str, "tunnel-name")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("pending_reason",
                                            "tunnel_name") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.VifPending, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.VifPending, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.pending_reason.is_set or
                                self.tunnel_name.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.pending_reason.yfilter != YFilter.not_set or
                                self.tunnel_name.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "vif-pending" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/nsr/detail/sync-status-information/slave-sync-information/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.pending_reason.is_set or self.pending_reason.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.pending_reason.get_name_leafdata())
                            if (self.tunnel_name.is_set or self.tunnel_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tunnel_name.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "pending-reason" or name == "tunnel-name"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "pending-reason"):
                                self.pending_reason = value
                                self.pending_reason.value_namespace = name_space
                                self.pending_reason.value_namespace_prefix = name_space_prefix
                            if(value_path == "tunnel-name"):
                                self.tunnel_name = value
                                self.tunnel_name.value_namespace = name_space
                                self.tunnel_name.value_namespace_prefix = name_space_prefix


                    class S2LPending(Entity):
                        """
                        Pending sub\-LSPs details
                        
                        .. attribute:: pending_reason
                        
                        	Pending reason
                        	**type**\:   :py:class:`TeSyncPendingReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncPendingReason>`
                        
                        .. attribute:: s2l_role
                        
                        	S2L role
                        	**type**\:   :py:class:`MplsTeTunnelRole <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeTunnelRole>`
                        
                        .. attribute:: signaled_name
                        
                        	Signaled name
                        	**type**\:  str
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.S2LPending, self).__init__()

                            self.yang_name = "s2l-pending"
                            self.yang_parent_name = "slave-sync-information"

                            self.pending_reason = YLeaf(YType.enumeration, "pending-reason")

                            self.s2l_role = YLeaf(YType.enumeration, "s2l-role")

                            self.signaled_name = YLeaf(YType.str, "signaled-name")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("pending_reason",
                                            "s2l_role",
                                            "signaled_name") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.S2LPending, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.S2LPending, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.pending_reason.is_set or
                                self.s2l_role.is_set or
                                self.signaled_name.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.pending_reason.yfilter != YFilter.not_set or
                                self.s2l_role.yfilter != YFilter.not_set or
                                self.signaled_name.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "s2l-pending" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/nsr/detail/sync-status-information/slave-sync-information/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.pending_reason.is_set or self.pending_reason.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.pending_reason.get_name_leafdata())
                            if (self.s2l_role.is_set or self.s2l_role.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.s2l_role.get_name_leafdata())
                            if (self.signaled_name.is_set or self.signaled_name.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.signaled_name.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "pending-reason" or name == "s2l-role" or name == "signaled-name"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "pending-reason"):
                                self.pending_reason = value
                                self.pending_reason.value_namespace = name_space
                                self.pending_reason.value_namespace_prefix = name_space_prefix
                            if(value_path == "s2l-role"):
                                self.s2l_role = value
                                self.s2l_role.value_namespace = name_space
                                self.s2l_role.value_namespace_prefix = name_space_prefix
                            if(value_path == "signaled-name"):
                                self.signaled_name = value
                                self.signaled_name.value_namespace = name_space
                                self.signaled_name.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.s2l_pending:
                            if (c.has_data()):
                                return True
                        for c in self.vif_pending:
                            if (c.has_data()):
                                return True
                        return (
                            self.insync_sub_ls_ps.is_set or
                            self.insync_tunnels.is_set or
                            self.pending_sub_ls_ps.is_set or
                            self.pending_tunnels.is_set or
                            (self.idt is not None and self.idt.has_data()))

                    def has_operation(self):
                        for c in self.s2l_pending:
                            if (c.has_operation()):
                                return True
                        for c in self.vif_pending:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.insync_sub_ls_ps.yfilter != YFilter.not_set or
                            self.insync_tunnels.yfilter != YFilter.not_set or
                            self.pending_sub_ls_ps.yfilter != YFilter.not_set or
                            self.pending_tunnels.yfilter != YFilter.not_set or
                            (self.idt is not None and self.idt.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "slave-sync-information" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/nsr/detail/sync-status-information/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.insync_sub_ls_ps.is_set or self.insync_sub_ls_ps.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.insync_sub_ls_ps.get_name_leafdata())
                        if (self.insync_tunnels.is_set or self.insync_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.insync_tunnels.get_name_leafdata())
                        if (self.pending_sub_ls_ps.is_set or self.pending_sub_ls_ps.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.pending_sub_ls_ps.get_name_leafdata())
                        if (self.pending_tunnels.is_set or self.pending_tunnels.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.pending_tunnels.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "idt"):
                            if (self.idt is None):
                                self.idt = MplsTeStandby.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.Idt()
                                self.idt.parent = self
                                self._children_name_map["idt"] = "idt"
                            return self.idt

                        if (child_yang_name == "s2l-pending"):
                            for c in self.s2l_pending:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.S2LPending()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.s2l_pending.append(c)
                            return c

                        if (child_yang_name == "vif-pending"):
                            for c in self.vif_pending:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation.VifPending()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.vif_pending.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "idt" or name == "s2l-pending" or name == "vif-pending" or name == "insync-sub-ls-ps" or name == "insync-tunnels" or name == "pending-sub-ls-ps" or name == "pending-tunnels"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "insync-sub-ls-ps"):
                            self.insync_sub_ls_ps = value
                            self.insync_sub_ls_ps.value_namespace = name_space
                            self.insync_sub_ls_ps.value_namespace_prefix = name_space_prefix
                        if(value_path == "insync-tunnels"):
                            self.insync_tunnels = value
                            self.insync_tunnels.value_namespace = name_space
                            self.insync_tunnels.value_namespace_prefix = name_space_prefix
                        if(value_path == "pending-sub-ls-ps"):
                            self.pending_sub_ls_ps = value
                            self.pending_sub_ls_ps.value_namespace = name_space
                            self.pending_sub_ls_ps.value_namespace_prefix = name_space_prefix
                        if(value_path == "pending-tunnels"):
                            self.pending_tunnels = value
                            self.pending_tunnels.value_namespace = name_space
                            self.pending_tunnels.value_namespace_prefix = name_space_prefix


                class MasterSyncInformation(Entity):
                    """
                    Master sync information
                    
                    .. attribute:: idt
                    
                    	Sync status IDT information
                    	**type**\:   :py:class:`Idt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Nsr.Detail.SyncStatusInformation.MasterSyncInformation.Idt>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.Nsr.Detail.SyncStatusInformation.MasterSyncInformation, self).__init__()

                        self.yang_name = "master-sync-information"
                        self.yang_parent_name = "sync-status-information"

                        self.idt = MplsTeStandby.Nsr.Detail.SyncStatusInformation.MasterSyncInformation.Idt()
                        self.idt.parent = self
                        self._children_name_map["idt"] = "idt"
                        self._children_yang_names.add("idt")


                    class Idt(Entity):
                        """
                        Sync status IDT information
                        
                        .. attribute:: current_idt_info
                        
                        	Current IDT information
                        	**type**\:   :py:class:`CurrentIdtInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Nsr.Detail.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo>`
                        
                        .. attribute:: previous_idt_status
                        
                        	Previous IDT information
                        	**type**\:   :py:class:`PreviousIdtStatus <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.Nsr.Detail.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus>`
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.Nsr.Detail.SyncStatusInformation.MasterSyncInformation.Idt, self).__init__()

                            self.yang_name = "idt"
                            self.yang_parent_name = "master-sync-information"

                            self.current_idt_info = MplsTeStandby.Nsr.Detail.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo()
                            self.current_idt_info.parent = self
                            self._children_name_map["current_idt_info"] = "current-idt-info"
                            self._children_yang_names.add("current-idt-info")

                            self.previous_idt_status = MplsTeStandby.Nsr.Detail.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus()
                            self.previous_idt_status.parent = self
                            self._children_name_map["previous_idt_status"] = "previous-idt-status"
                            self._children_yang_names.add("previous-idt-status")


                        class CurrentIdtInfo(Entity):
                            """
                            Current IDT information
                            
                            .. attribute:: declare_time
                            
                            	Declare ready timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: idt_end_time
                            
                            	IDT end timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: idt_start_time
                            
                            	IDT start timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: is_ready_status
                            
                            	Ready status
                            	**type**\:  bool
                            
                            .. attribute:: reason
                            
                            	Not ready reason
                            	**type**\:   :py:class:`TeSyncNotReadyReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncNotReadyReason>`
                            
                            .. attribute:: withdraw_time
                            
                            	Withdraw ready timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.Nsr.Detail.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo, self).__init__()

                                self.yang_name = "current-idt-info"
                                self.yang_parent_name = "idt"

                                self.declare_time = YLeaf(YType.uint32, "declare-time")

                                self.idt_end_time = YLeaf(YType.uint32, "idt-end-time")

                                self.idt_start_time = YLeaf(YType.uint32, "idt-start-time")

                                self.is_ready_status = YLeaf(YType.boolean, "is-ready-status")

                                self.reason = YLeaf(YType.enumeration, "reason")

                                self.withdraw_time = YLeaf(YType.uint32, "withdraw-time")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("declare_time",
                                                "idt_end_time",
                                                "idt_start_time",
                                                "is_ready_status",
                                                "reason",
                                                "withdraw_time") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.Nsr.Detail.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.Nsr.Detail.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.declare_time.is_set or
                                    self.idt_end_time.is_set or
                                    self.idt_start_time.is_set or
                                    self.is_ready_status.is_set or
                                    self.reason.is_set or
                                    self.withdraw_time.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.declare_time.yfilter != YFilter.not_set or
                                    self.idt_end_time.yfilter != YFilter.not_set or
                                    self.idt_start_time.yfilter != YFilter.not_set or
                                    self.is_ready_status.yfilter != YFilter.not_set or
                                    self.reason.yfilter != YFilter.not_set or
                                    self.withdraw_time.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "current-idt-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/nsr/detail/sync-status-information/master-sync-information/idt/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.declare_time.is_set or self.declare_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.declare_time.get_name_leafdata())
                                if (self.idt_end_time.is_set or self.idt_end_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.idt_end_time.get_name_leafdata())
                                if (self.idt_start_time.is_set or self.idt_start_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.idt_start_time.get_name_leafdata())
                                if (self.is_ready_status.is_set or self.is_ready_status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_ready_status.get_name_leafdata())
                                if (self.reason.is_set or self.reason.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reason.get_name_leafdata())
                                if (self.withdraw_time.is_set or self.withdraw_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.withdraw_time.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "declare-time" or name == "idt-end-time" or name == "idt-start-time" or name == "is-ready-status" or name == "reason" or name == "withdraw-time"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "declare-time"):
                                    self.declare_time = value
                                    self.declare_time.value_namespace = name_space
                                    self.declare_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "idt-end-time"):
                                    self.idt_end_time = value
                                    self.idt_end_time.value_namespace = name_space
                                    self.idt_end_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "idt-start-time"):
                                    self.idt_start_time = value
                                    self.idt_start_time.value_namespace = name_space
                                    self.idt_start_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-ready-status"):
                                    self.is_ready_status = value
                                    self.is_ready_status.value_namespace = name_space
                                    self.is_ready_status.value_namespace_prefix = name_space_prefix
                                if(value_path == "reason"):
                                    self.reason = value
                                    self.reason.value_namespace = name_space
                                    self.reason.value_namespace_prefix = name_space_prefix
                                if(value_path == "withdraw-time"):
                                    self.withdraw_time = value
                                    self.withdraw_time.value_namespace = name_space
                                    self.withdraw_time.value_namespace_prefix = name_space_prefix


                        class PreviousIdtStatus(Entity):
                            """
                            Previous IDT information
                            
                            .. attribute:: declare_time
                            
                            	Declare ready timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: idt_end_time
                            
                            	IDT end timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: idt_start_time
                            
                            	IDT start timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            .. attribute:: is_ready_status
                            
                            	Ready status
                            	**type**\:  bool
                            
                            .. attribute:: reason
                            
                            	Not ready reason
                            	**type**\:   :py:class:`TeSyncNotReadyReason <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeSyncNotReadyReason>`
                            
                            .. attribute:: withdraw_time
                            
                            	Withdraw ready timestampe in seconds
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            	**units**\: second
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.Nsr.Detail.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus, self).__init__()

                                self.yang_name = "previous-idt-status"
                                self.yang_parent_name = "idt"

                                self.declare_time = YLeaf(YType.uint32, "declare-time")

                                self.idt_end_time = YLeaf(YType.uint32, "idt-end-time")

                                self.idt_start_time = YLeaf(YType.uint32, "idt-start-time")

                                self.is_ready_status = YLeaf(YType.boolean, "is-ready-status")

                                self.reason = YLeaf(YType.enumeration, "reason")

                                self.withdraw_time = YLeaf(YType.uint32, "withdraw-time")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("declare_time",
                                                "idt_end_time",
                                                "idt_start_time",
                                                "is_ready_status",
                                                "reason",
                                                "withdraw_time") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.Nsr.Detail.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.Nsr.Detail.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus, self).__setattr__(name, value)

                            def has_data(self):
                                return (
                                    self.declare_time.is_set or
                                    self.idt_end_time.is_set or
                                    self.idt_start_time.is_set or
                                    self.is_ready_status.is_set or
                                    self.reason.is_set or
                                    self.withdraw_time.is_set)

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.declare_time.yfilter != YFilter.not_set or
                                    self.idt_end_time.yfilter != YFilter.not_set or
                                    self.idt_start_time.yfilter != YFilter.not_set or
                                    self.is_ready_status.yfilter != YFilter.not_set or
                                    self.reason.yfilter != YFilter.not_set or
                                    self.withdraw_time.yfilter != YFilter.not_set)

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "previous-idt-status" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/nsr/detail/sync-status-information/master-sync-information/idt/%s" % self.get_segment_path()
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.declare_time.is_set or self.declare_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.declare_time.get_name_leafdata())
                                if (self.idt_end_time.is_set or self.idt_end_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.idt_end_time.get_name_leafdata())
                                if (self.idt_start_time.is_set or self.idt_start_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.idt_start_time.get_name_leafdata())
                                if (self.is_ready_status.is_set or self.is_ready_status.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.is_ready_status.get_name_leafdata())
                                if (self.reason.is_set or self.reason.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.reason.get_name_leafdata())
                                if (self.withdraw_time.is_set or self.withdraw_time.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.withdraw_time.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "declare-time" or name == "idt-end-time" or name == "idt-start-time" or name == "is-ready-status" or name == "reason" or name == "withdraw-time"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "declare-time"):
                                    self.declare_time = value
                                    self.declare_time.value_namespace = name_space
                                    self.declare_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "idt-end-time"):
                                    self.idt_end_time = value
                                    self.idt_end_time.value_namespace = name_space
                                    self.idt_end_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "idt-start-time"):
                                    self.idt_start_time = value
                                    self.idt_start_time.value_namespace = name_space
                                    self.idt_start_time.value_namespace_prefix = name_space_prefix
                                if(value_path == "is-ready-status"):
                                    self.is_ready_status = value
                                    self.is_ready_status.value_namespace = name_space
                                    self.is_ready_status.value_namespace_prefix = name_space_prefix
                                if(value_path == "reason"):
                                    self.reason = value
                                    self.reason.value_namespace = name_space
                                    self.reason.value_namespace_prefix = name_space_prefix
                                if(value_path == "withdraw-time"):
                                    self.withdraw_time = value
                                    self.withdraw_time.value_namespace = name_space
                                    self.withdraw_time.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                (self.current_idt_info is not None and self.current_idt_info.has_data()) or
                                (self.previous_idt_status is not None and self.previous_idt_status.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                (self.current_idt_info is not None and self.current_idt_info.has_operation()) or
                                (self.previous_idt_status is not None and self.previous_idt_status.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "idt" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/nsr/detail/sync-status-information/master-sync-information/%s" % self.get_segment_path()
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "current-idt-info"):
                                if (self.current_idt_info is None):
                                    self.current_idt_info = MplsTeStandby.Nsr.Detail.SyncStatusInformation.MasterSyncInformation.Idt.CurrentIdtInfo()
                                    self.current_idt_info.parent = self
                                    self._children_name_map["current_idt_info"] = "current-idt-info"
                                return self.current_idt_info

                            if (child_yang_name == "previous-idt-status"):
                                if (self.previous_idt_status is None):
                                    self.previous_idt_status = MplsTeStandby.Nsr.Detail.SyncStatusInformation.MasterSyncInformation.Idt.PreviousIdtStatus()
                                    self.previous_idt_status.parent = self
                                    self._children_name_map["previous_idt_status"] = "previous-idt-status"
                                return self.previous_idt_status

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "current-idt-info" or name == "previous-idt-status"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            pass

                    def has_data(self):
                        return (self.idt is not None and self.idt.has_data())

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            (self.idt is not None and self.idt.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "master-sync-information" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/nsr/detail/sync-status-information/%s" % self.get_segment_path()
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "idt"):
                            if (self.idt is None):
                                self.idt = MplsTeStandby.Nsr.Detail.SyncStatusInformation.MasterSyncInformation.Idt()
                                self.idt.parent = self
                                self._children_name_map["idt"] = "idt"
                            return self.idt

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "idt"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass

                def has_data(self):
                    return (
                        self.sync_show_type.is_set or
                        (self.master_sync_information is not None and self.master_sync_information.has_data()) or
                        (self.slave_sync_information is not None and self.slave_sync_information.has_data()))

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.sync_show_type.yfilter != YFilter.not_set or
                        (self.master_sync_information is not None and self.master_sync_information.has_operation()) or
                        (self.slave_sync_information is not None and self.slave_sync_information.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "sync-status-information" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/nsr/detail/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.sync_show_type.is_set or self.sync_show_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.sync_show_type.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "master-sync-information"):
                        if (self.master_sync_information is None):
                            self.master_sync_information = MplsTeStandby.Nsr.Detail.SyncStatusInformation.MasterSyncInformation()
                            self.master_sync_information.parent = self
                            self._children_name_map["master_sync_information"] = "master-sync-information"
                        return self.master_sync_information

                    if (child_yang_name == "slave-sync-information"):
                        if (self.slave_sync_information is None):
                            self.slave_sync_information = MplsTeStandby.Nsr.Detail.SyncStatusInformation.SlaveSyncInformation()
                            self.slave_sync_information.parent = self
                            self._children_name_map["slave_sync_information"] = "slave-sync-information"
                        return self.slave_sync_information

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "master-sync-information" or name == "slave-sync-information" or name == "sync-show-type"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "sync-show-type"):
                        self.sync_show_type = value
                        self.sync_show_type.value_namespace = name_space
                        self.sync_show_type.value_namespace_prefix = name_space_prefix

            def has_data(self):
                return (
                    self.role.is_set or
                    (self.sync_status_information is not None and self.sync_status_information.has_data()))

            def has_operation(self):
                return (
                    self.yfilter != YFilter.not_set or
                    self.role.yfilter != YFilter.not_set or
                    (self.sync_status_information is not None and self.sync_status_information.has_operation()))

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "detail" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/nsr/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.role.is_set or self.role.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.role.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "sync-status-information"):
                    if (self.sync_status_information is None):
                        self.sync_status_information = MplsTeStandby.Nsr.Detail.SyncStatusInformation()
                        self.sync_status_information.parent = self
                        self._children_name_map["sync_status_information"] = "sync-status-information"
                    return self.sync_status_information

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "sync-status-information" or name == "role"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "role"):
                    self.role = value
                    self.role.value_namespace = name_space
                    self.role.value_namespace_prefix = name_space_prefix

        def has_data(self):
            return (
                (self.detail is not None and self.detail.has_data()) or
                (self.status is not None and self.status.has_data()))

        def has_operation(self):
            return (
                self.yfilter != YFilter.not_set or
                (self.detail is not None and self.detail.has_operation()) or
                (self.status is not None and self.status.has_operation()))

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "nsr" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "detail"):
                if (self.detail is None):
                    self.detail = MplsTeStandby.Nsr.Detail()
                    self.detail.parent = self
                    self._children_name_map["detail"] = "detail"
                return self.detail

            if (child_yang_name == "status"):
                if (self.status is None):
                    self.status = MplsTeStandby.Nsr.Status()
                    self.status.parent = self
                    self._children_name_map["status"] = "status"
                return self.status

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "detail" or name == "status"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class AutoTunnelServices(Entity):
        """
        MPLS TE Auto Tunnel Services
        
        .. attribute:: sr_policy_entries
        
        	MPLS TE SR Policy Context table 
        	**type**\:   :py:class:`SrPolicyEntries <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AutoTunnelServices.SrPolicyEntries>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsTeStandby.AutoTunnelServices, self).__init__()

            self.yang_name = "auto-tunnel-services"
            self.yang_parent_name = "mpls-te-standby"

            self.sr_policy_entries = MplsTeStandby.AutoTunnelServices.SrPolicyEntries()
            self.sr_policy_entries.parent = self
            self._children_name_map["sr_policy_entries"] = "sr-policy-entries"
            self._children_yang_names.add("sr-policy-entries")


        class SrPolicyEntries(Entity):
            """
            MPLS TE SR Policy Context table 
            
            .. attribute:: sr_policy_entry
            
            	MPLS TE SR Policy information
            	**type**\: list of    :py:class:`SrPolicyEntry <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry>`
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTeStandby.AutoTunnelServices.SrPolicyEntries, self).__init__()

                self.yang_name = "sr-policy-entries"
                self.yang_parent_name = "auto-tunnel-services"

                self.sr_policy_entry = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in () and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTeStandby.AutoTunnelServices.SrPolicyEntries, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTeStandby.AutoTunnelServices.SrPolicyEntries, self).__setattr__(name, value)


            class SrPolicyEntry(Entity):
                """
                MPLS TE SR Policy information
                
                .. attribute:: client_id  <key>
                
                	Client ID
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: color  <key>
                
                	Color
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: end_point  <key>
                
                	End Point
                	**type**\: one of the below types:
                
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                
                ----
                	**type**\:  str
                
                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                
                
                ----
                .. attribute:: distinguisher  <key>
                
                	SR Policy Distinguisher Value
                	**type**\:  int
                
                	**range:** \-2147483648..2147483647
                
                .. attribute:: allocated_binding_sid
                
                	Allocated Binding SID
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: binding_sid_context_id
                
                	Binding SID Context ID
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: binding_sid_request_pending
                
                	Binding SID Request Pending
                	**type**\:  bool
                
                .. attribute:: client_id_xr
                
                	Client ID
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: client_name
                
                	Client Name
                	**type**\:  str
                
                .. attribute:: color_xr
                
                	Color
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: creation_time
                
                	SR policy structure creation timestamp (clocktime in nsecs)
                	**type**\:  int
                
                	**range:** 0..18446744073709551615
                
                	**units**\: nanosecond
                
                .. attribute:: distinguisher_xr
                
                	SR Policy Distinguisher value
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: end_point_xr
                
                	End Point
                	**type**\:   :py:class:`EndPointXr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.EndPointXr>`
                
                .. attribute:: explicit_path
                
                	Explicit Paths
                	**type**\: list of    :py:class:`ExplicitPath <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.ExplicitPath>`
                
                .. attribute:: ipv6_caps
                
                	IPv6 Capsulation
                	**type**\:  bool
                
                .. attribute:: is_stale
                
                	Is Stale
                	**type**\:  bool
                
                .. attribute:: is_synced
                
                	Is Synced
                	**type**\:  bool
                
                .. attribute:: notify_state_is_active
                
                	Notify State Is Active
                	**type**\:  bool
                
                .. attribute:: notify_time
                
                	Notify Time
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: policy_active
                
                	Policy Active
                	**type**\:  bool
                
                .. attribute:: requested_binding_sid
                
                	Requested Binding SID
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: rewrite_done
                
                	Rewrite Done
                	**type**\:  bool
                
                .. attribute:: rewrite_request_pending
                
                	Rewrite Requeste Pending
                	**type**\:  bool
                
                .. attribute:: sr_policy_id
                
                	SR Policy ID
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTeStandby.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry, self).__init__()

                    self.yang_name = "sr-policy-entry"
                    self.yang_parent_name = "sr-policy-entries"

                    self.client_id = YLeaf(YType.int32, "client-id")

                    self.color = YLeaf(YType.int32, "color")

                    self.end_point = YLeaf(YType.str, "end-point")

                    self.distinguisher = YLeaf(YType.int32, "distinguisher")

                    self.allocated_binding_sid = YLeaf(YType.uint32, "allocated-binding-sid")

                    self.binding_sid_context_id = YLeaf(YType.uint32, "binding-sid-context-id")

                    self.binding_sid_request_pending = YLeaf(YType.boolean, "binding-sid-request-pending")

                    self.client_id_xr = YLeaf(YType.uint32, "client-id-xr")

                    self.client_name = YLeaf(YType.str, "client-name")

                    self.color_xr = YLeaf(YType.uint32, "color-xr")

                    self.creation_time = YLeaf(YType.uint64, "creation-time")

                    self.distinguisher_xr = YLeaf(YType.uint32, "distinguisher-xr")

                    self.ipv6_caps = YLeaf(YType.boolean, "ipv6-caps")

                    self.is_stale = YLeaf(YType.boolean, "is-stale")

                    self.is_synced = YLeaf(YType.boolean, "is-synced")

                    self.notify_state_is_active = YLeaf(YType.boolean, "notify-state-is-active")

                    self.notify_time = YLeaf(YType.uint32, "notify-time")

                    self.policy_active = YLeaf(YType.boolean, "policy-active")

                    self.requested_binding_sid = YLeaf(YType.uint32, "requested-binding-sid")

                    self.rewrite_done = YLeaf(YType.boolean, "rewrite-done")

                    self.rewrite_request_pending = YLeaf(YType.boolean, "rewrite-request-pending")

                    self.sr_policy_id = YLeaf(YType.uint32, "sr-policy-id")

                    self.end_point_xr = MplsTeStandby.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.EndPointXr()
                    self.end_point_xr.parent = self
                    self._children_name_map["end_point_xr"] = "end-point-xr"
                    self._children_yang_names.add("end-point-xr")

                    self.explicit_path = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("client_id",
                                    "color",
                                    "end_point",
                                    "distinguisher",
                                    "allocated_binding_sid",
                                    "binding_sid_context_id",
                                    "binding_sid_request_pending",
                                    "client_id_xr",
                                    "client_name",
                                    "color_xr",
                                    "creation_time",
                                    "distinguisher_xr",
                                    "ipv6_caps",
                                    "is_stale",
                                    "is_synced",
                                    "notify_state_is_active",
                                    "notify_time",
                                    "policy_active",
                                    "requested_binding_sid",
                                    "rewrite_done",
                                    "rewrite_request_pending",
                                    "sr_policy_id") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTeStandby.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTeStandby.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry, self).__setattr__(name, value)


                class EndPointXr(Entity):
                    """
                    End Point
                    
                    .. attribute:: address_family_type
                    
                    	AddressFamilyType
                    	**type**\:   :py:class:`MplsTeAfi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeAfi>`
                    
                    .. attribute:: ipv4_address
                    
                    	IPv4 Address
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: ipv6_address
                    
                    	IPv6 Address
                    	**type**\:  str
                    
                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.EndPointXr, self).__init__()

                        self.yang_name = "end-point-xr"
                        self.yang_parent_name = "sr-policy-entry"

                        self.address_family_type = YLeaf(YType.enumeration, "address-family-type")

                        self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                        self.ipv6_address = YLeaf(YType.str, "ipv6-address")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("address_family_type",
                                        "ipv4_address",
                                        "ipv6_address") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.EndPointXr, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.EndPointXr, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.address_family_type.is_set or
                            self.ipv4_address.is_set or
                            self.ipv6_address.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.address_family_type.yfilter != YFilter.not_set or
                            self.ipv4_address.yfilter != YFilter.not_set or
                            self.ipv6_address.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "end-point-xr" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.address_family_type.is_set or self.address_family_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.address_family_type.get_name_leafdata())
                        if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                        if (self.ipv6_address.is_set or self.ipv6_address.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.ipv6_address.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "address-family-type" or name == "ipv4-address" or name == "ipv6-address"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "address-family-type"):
                            self.address_family_type = value
                            self.address_family_type.value_namespace = name_space
                            self.address_family_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "ipv4-address"):
                            self.ipv4_address = value
                            self.ipv4_address.value_namespace = name_space
                            self.ipv4_address.value_namespace_prefix = name_space_prefix
                        if(value_path == "ipv6-address"):
                            self.ipv6_address = value
                            self.ipv6_address.value_namespace = name_space
                            self.ipv6_address.value_namespace_prefix = name_space_prefix


                class ExplicitPath(Entity):
                    """
                    Explicit Paths
                    
                    .. attribute:: context_id
                    
                    	Explicit Path Context ID
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: hops
                    
                    	Path Hops
                    	**type**\: list of    :py:class:`Hops <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.ExplicitPath.Hops>`
                    
                    .. attribute:: is_stale
                    
                    	Is Stale
                    	**type**\:  bool
                    
                    .. attribute:: is_synced
                    
                    	Is Synced
                    	**type**\:  bool
                    
                    .. attribute:: path_weight
                    
                    	Path Weight
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: programmed_in_fib
                    
                    	Programmed in FIB
                    	**type**\:  bool
                    
                    .. attribute:: tunnel_info
                    
                    	Auto tunnel info
                    	**type**\:   :py:class:`TunnelInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.ExplicitPath.TunnelInfo>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.ExplicitPath, self).__init__()

                        self.yang_name = "explicit-path"
                        self.yang_parent_name = "sr-policy-entry"

                        self.context_id = YLeaf(YType.uint32, "context-id")

                        self.is_stale = YLeaf(YType.boolean, "is-stale")

                        self.is_synced = YLeaf(YType.boolean, "is-synced")

                        self.path_weight = YLeaf(YType.uint32, "path-weight")

                        self.programmed_in_fib = YLeaf(YType.boolean, "programmed-in-fib")

                        self.tunnel_info = MplsTeStandby.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.ExplicitPath.TunnelInfo()
                        self.tunnel_info.parent = self
                        self._children_name_map["tunnel_info"] = "tunnel-info"
                        self._children_yang_names.add("tunnel-info")

                        self.hops = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("context_id",
                                        "is_stale",
                                        "is_synced",
                                        "path_weight",
                                        "programmed_in_fib") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.ExplicitPath, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.ExplicitPath, self).__setattr__(name, value)


                    class TunnelInfo(Entity):
                        """
                        Auto tunnel info
                        
                        .. attribute:: ipv6_caps
                        
                        	IPv6 Capsulation
                        	**type**\:  bool
                        
                        .. attribute:: tunnel_id
                        
                        	Tunnel ID
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: tunnel_up
                        
                        	Tunnel Up
                        	**type**\:  bool
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.ExplicitPath.TunnelInfo, self).__init__()

                            self.yang_name = "tunnel-info"
                            self.yang_parent_name = "explicit-path"

                            self.ipv6_caps = YLeaf(YType.boolean, "ipv6-caps")

                            self.tunnel_id = YLeaf(YType.uint32, "tunnel-id")

                            self.tunnel_up = YLeaf(YType.boolean, "tunnel-up")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("ipv6_caps",
                                            "tunnel_id",
                                            "tunnel_up") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.ExplicitPath.TunnelInfo, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.ExplicitPath.TunnelInfo, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.ipv6_caps.is_set or
                                self.tunnel_id.is_set or
                                self.tunnel_up.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.ipv6_caps.yfilter != YFilter.not_set or
                                self.tunnel_id.yfilter != YFilter.not_set or
                                self.tunnel_up.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "tunnel-info" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.ipv6_caps.is_set or self.ipv6_caps.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ipv6_caps.get_name_leafdata())
                            if (self.tunnel_id.is_set or self.tunnel_id.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tunnel_id.get_name_leafdata())
                            if (self.tunnel_up.is_set or self.tunnel_up.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tunnel_up.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "ipv6-caps" or name == "tunnel-id" or name == "tunnel-up"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "ipv6-caps"):
                                self.ipv6_caps = value
                                self.ipv6_caps.value_namespace = name_space
                                self.ipv6_caps.value_namespace_prefix = name_space_prefix
                            if(value_path == "tunnel-id"):
                                self.tunnel_id = value
                                self.tunnel_id.value_namespace = name_space
                                self.tunnel_id.value_namespace_prefix = name_space_prefix
                            if(value_path == "tunnel-up"):
                                self.tunnel_up = value
                                self.tunnel_up.value_namespace = name_space
                                self.tunnel_up.value_namespace_prefix = name_space_prefix


                    class Hops(Entity):
                        """
                        Path Hops
                        
                        .. attribute:: hop_type
                        
                        	Hop Type
                        	**type**\:   :py:class:`TeAutoTunExpPathHop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAutoTunExpPathHop>`
                        
                        .. attribute:: ipv4_address
                        
                        	IPv4 Address
                        	**type**\:  str
                        
                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                        
                        .. attribute:: mpls_label
                        
                        	MPLS Label
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.ExplicitPath.Hops, self).__init__()

                            self.yang_name = "hops"
                            self.yang_parent_name = "explicit-path"

                            self.hop_type = YLeaf(YType.enumeration, "hop-type")

                            self.ipv4_address = YLeaf(YType.str, "ipv4-address")

                            self.mpls_label = YLeaf(YType.uint32, "mpls-label")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("hop_type",
                                            "ipv4_address",
                                            "mpls_label") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.ExplicitPath.Hops, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.ExplicitPath.Hops, self).__setattr__(name, value)

                        def has_data(self):
                            return (
                                self.hop_type.is_set or
                                self.ipv4_address.is_set or
                                self.mpls_label.is_set)

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.hop_type.yfilter != YFilter.not_set or
                                self.ipv4_address.yfilter != YFilter.not_set or
                                self.mpls_label.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "hops" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.hop_type.is_set or self.hop_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.hop_type.get_name_leafdata())
                            if (self.ipv4_address.is_set or self.ipv4_address.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.ipv4_address.get_name_leafdata())
                            if (self.mpls_label.is_set or self.mpls_label.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.mpls_label.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "hop-type" or name == "ipv4-address" or name == "mpls-label"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "hop-type"):
                                self.hop_type = value
                                self.hop_type.value_namespace = name_space
                                self.hop_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "ipv4-address"):
                                self.ipv4_address = value
                                self.ipv4_address.value_namespace = name_space
                                self.ipv4_address.value_namespace_prefix = name_space_prefix
                            if(value_path == "mpls-label"):
                                self.mpls_label = value
                                self.mpls_label.value_namespace = name_space
                                self.mpls_label.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.hops:
                            if (c.has_data()):
                                return True
                        return (
                            self.context_id.is_set or
                            self.is_stale.is_set or
                            self.is_synced.is_set or
                            self.path_weight.is_set or
                            self.programmed_in_fib.is_set or
                            (self.tunnel_info is not None and self.tunnel_info.has_data()))

                    def has_operation(self):
                        for c in self.hops:
                            if (c.has_operation()):
                                return True
                        return (
                            self.yfilter != YFilter.not_set or
                            self.context_id.yfilter != YFilter.not_set or
                            self.is_stale.yfilter != YFilter.not_set or
                            self.is_synced.yfilter != YFilter.not_set or
                            self.path_weight.yfilter != YFilter.not_set or
                            self.programmed_in_fib.yfilter != YFilter.not_set or
                            (self.tunnel_info is not None and self.tunnel_info.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "explicit-path" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.context_id.is_set or self.context_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.context_id.get_name_leafdata())
                        if (self.is_stale.is_set or self.is_stale.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_stale.get_name_leafdata())
                        if (self.is_synced.is_set or self.is_synced.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.is_synced.get_name_leafdata())
                        if (self.path_weight.is_set or self.path_weight.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.path_weight.get_name_leafdata())
                        if (self.programmed_in_fib.is_set or self.programmed_in_fib.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.programmed_in_fib.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "hops"):
                            for c in self.hops:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.ExplicitPath.Hops()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.hops.append(c)
                            return c

                        if (child_yang_name == "tunnel-info"):
                            if (self.tunnel_info is None):
                                self.tunnel_info = MplsTeStandby.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.ExplicitPath.TunnelInfo()
                                self.tunnel_info.parent = self
                                self._children_name_map["tunnel_info"] = "tunnel-info"
                            return self.tunnel_info

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "hops" or name == "tunnel-info" or name == "context-id" or name == "is-stale" or name == "is-synced" or name == "path-weight" or name == "programmed-in-fib"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "context-id"):
                            self.context_id = value
                            self.context_id.value_namespace = name_space
                            self.context_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-stale"):
                            self.is_stale = value
                            self.is_stale.value_namespace = name_space
                            self.is_stale.value_namespace_prefix = name_space_prefix
                        if(value_path == "is-synced"):
                            self.is_synced = value
                            self.is_synced.value_namespace = name_space
                            self.is_synced.value_namespace_prefix = name_space_prefix
                        if(value_path == "path-weight"):
                            self.path_weight = value
                            self.path_weight.value_namespace = name_space
                            self.path_weight.value_namespace_prefix = name_space_prefix
                        if(value_path == "programmed-in-fib"):
                            self.programmed_in_fib = value
                            self.programmed_in_fib.value_namespace = name_space
                            self.programmed_in_fib.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.explicit_path:
                        if (c.has_data()):
                            return True
                    return (
                        self.client_id.is_set or
                        self.color.is_set or
                        self.end_point.is_set or
                        self.distinguisher.is_set or
                        self.allocated_binding_sid.is_set or
                        self.binding_sid_context_id.is_set or
                        self.binding_sid_request_pending.is_set or
                        self.client_id_xr.is_set or
                        self.client_name.is_set or
                        self.color_xr.is_set or
                        self.creation_time.is_set or
                        self.distinguisher_xr.is_set or
                        self.ipv6_caps.is_set or
                        self.is_stale.is_set or
                        self.is_synced.is_set or
                        self.notify_state_is_active.is_set or
                        self.notify_time.is_set or
                        self.policy_active.is_set or
                        self.requested_binding_sid.is_set or
                        self.rewrite_done.is_set or
                        self.rewrite_request_pending.is_set or
                        self.sr_policy_id.is_set or
                        (self.end_point_xr is not None and self.end_point_xr.has_data()))

                def has_operation(self):
                    for c in self.explicit_path:
                        if (c.has_operation()):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        self.client_id.yfilter != YFilter.not_set or
                        self.color.yfilter != YFilter.not_set or
                        self.end_point.yfilter != YFilter.not_set or
                        self.distinguisher.yfilter != YFilter.not_set or
                        self.allocated_binding_sid.yfilter != YFilter.not_set or
                        self.binding_sid_context_id.yfilter != YFilter.not_set or
                        self.binding_sid_request_pending.yfilter != YFilter.not_set or
                        self.client_id_xr.yfilter != YFilter.not_set or
                        self.client_name.yfilter != YFilter.not_set or
                        self.color_xr.yfilter != YFilter.not_set or
                        self.creation_time.yfilter != YFilter.not_set or
                        self.distinguisher_xr.yfilter != YFilter.not_set or
                        self.ipv6_caps.yfilter != YFilter.not_set or
                        self.is_stale.yfilter != YFilter.not_set or
                        self.is_synced.yfilter != YFilter.not_set or
                        self.notify_state_is_active.yfilter != YFilter.not_set or
                        self.notify_time.yfilter != YFilter.not_set or
                        self.policy_active.yfilter != YFilter.not_set or
                        self.requested_binding_sid.yfilter != YFilter.not_set or
                        self.rewrite_done.yfilter != YFilter.not_set or
                        self.rewrite_request_pending.yfilter != YFilter.not_set or
                        self.sr_policy_id.yfilter != YFilter.not_set or
                        (self.end_point_xr is not None and self.end_point_xr.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "sr-policy-entry" + "[client-id='" + self.client_id.get() + "']" + "[color='" + self.color.get() + "']" + "[end-point='" + self.end_point.get() + "']" + "[distinguisher='" + self.distinguisher.get() + "']" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/auto-tunnel-services/sr-policy-entries/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.client_id.is_set or self.client_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.client_id.get_name_leafdata())
                    if (self.color.is_set or self.color.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.color.get_name_leafdata())
                    if (self.end_point.is_set or self.end_point.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.end_point.get_name_leafdata())
                    if (self.distinguisher.is_set or self.distinguisher.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.distinguisher.get_name_leafdata())
                    if (self.allocated_binding_sid.is_set or self.allocated_binding_sid.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.allocated_binding_sid.get_name_leafdata())
                    if (self.binding_sid_context_id.is_set or self.binding_sid_context_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.binding_sid_context_id.get_name_leafdata())
                    if (self.binding_sid_request_pending.is_set or self.binding_sid_request_pending.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.binding_sid_request_pending.get_name_leafdata())
                    if (self.client_id_xr.is_set or self.client_id_xr.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.client_id_xr.get_name_leafdata())
                    if (self.client_name.is_set or self.client_name.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.client_name.get_name_leafdata())
                    if (self.color_xr.is_set or self.color_xr.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.color_xr.get_name_leafdata())
                    if (self.creation_time.is_set or self.creation_time.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.creation_time.get_name_leafdata())
                    if (self.distinguisher_xr.is_set or self.distinguisher_xr.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.distinguisher_xr.get_name_leafdata())
                    if (self.ipv6_caps.is_set or self.ipv6_caps.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.ipv6_caps.get_name_leafdata())
                    if (self.is_stale.is_set or self.is_stale.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_stale.get_name_leafdata())
                    if (self.is_synced.is_set or self.is_synced.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.is_synced.get_name_leafdata())
                    if (self.notify_state_is_active.is_set or self.notify_state_is_active.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.notify_state_is_active.get_name_leafdata())
                    if (self.notify_time.is_set or self.notify_time.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.notify_time.get_name_leafdata())
                    if (self.policy_active.is_set or self.policy_active.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.policy_active.get_name_leafdata())
                    if (self.requested_binding_sid.is_set or self.requested_binding_sid.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.requested_binding_sid.get_name_leafdata())
                    if (self.rewrite_done.is_set or self.rewrite_done.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.rewrite_done.get_name_leafdata())
                    if (self.rewrite_request_pending.is_set or self.rewrite_request_pending.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.rewrite_request_pending.get_name_leafdata())
                    if (self.sr_policy_id.is_set or self.sr_policy_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.sr_policy_id.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "end-point-xr"):
                        if (self.end_point_xr is None):
                            self.end_point_xr = MplsTeStandby.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.EndPointXr()
                            self.end_point_xr.parent = self
                            self._children_name_map["end_point_xr"] = "end-point-xr"
                        return self.end_point_xr

                    if (child_yang_name == "explicit-path"):
                        for c in self.explicit_path:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsTeStandby.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry.ExplicitPath()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.explicit_path.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "end-point-xr" or name == "explicit-path" or name == "client-id" or name == "color" or name == "end-point" or name == "distinguisher" or name == "allocated-binding-sid" or name == "binding-sid-context-id" or name == "binding-sid-request-pending" or name == "client-id-xr" or name == "client-name" or name == "color-xr" or name == "creation-time" or name == "distinguisher-xr" or name == "ipv6-caps" or name == "is-stale" or name == "is-synced" or name == "notify-state-is-active" or name == "notify-time" or name == "policy-active" or name == "requested-binding-sid" or name == "rewrite-done" or name == "rewrite-request-pending" or name == "sr-policy-id"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "client-id"):
                        self.client_id = value
                        self.client_id.value_namespace = name_space
                        self.client_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "color"):
                        self.color = value
                        self.color.value_namespace = name_space
                        self.color.value_namespace_prefix = name_space_prefix
                    if(value_path == "end-point"):
                        self.end_point = value
                        self.end_point.value_namespace = name_space
                        self.end_point.value_namespace_prefix = name_space_prefix
                    if(value_path == "distinguisher"):
                        self.distinguisher = value
                        self.distinguisher.value_namespace = name_space
                        self.distinguisher.value_namespace_prefix = name_space_prefix
                    if(value_path == "allocated-binding-sid"):
                        self.allocated_binding_sid = value
                        self.allocated_binding_sid.value_namespace = name_space
                        self.allocated_binding_sid.value_namespace_prefix = name_space_prefix
                    if(value_path == "binding-sid-context-id"):
                        self.binding_sid_context_id = value
                        self.binding_sid_context_id.value_namespace = name_space
                        self.binding_sid_context_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "binding-sid-request-pending"):
                        self.binding_sid_request_pending = value
                        self.binding_sid_request_pending.value_namespace = name_space
                        self.binding_sid_request_pending.value_namespace_prefix = name_space_prefix
                    if(value_path == "client-id-xr"):
                        self.client_id_xr = value
                        self.client_id_xr.value_namespace = name_space
                        self.client_id_xr.value_namespace_prefix = name_space_prefix
                    if(value_path == "client-name"):
                        self.client_name = value
                        self.client_name.value_namespace = name_space
                        self.client_name.value_namespace_prefix = name_space_prefix
                    if(value_path == "color-xr"):
                        self.color_xr = value
                        self.color_xr.value_namespace = name_space
                        self.color_xr.value_namespace_prefix = name_space_prefix
                    if(value_path == "creation-time"):
                        self.creation_time = value
                        self.creation_time.value_namespace = name_space
                        self.creation_time.value_namespace_prefix = name_space_prefix
                    if(value_path == "distinguisher-xr"):
                        self.distinguisher_xr = value
                        self.distinguisher_xr.value_namespace = name_space
                        self.distinguisher_xr.value_namespace_prefix = name_space_prefix
                    if(value_path == "ipv6-caps"):
                        self.ipv6_caps = value
                        self.ipv6_caps.value_namespace = name_space
                        self.ipv6_caps.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-stale"):
                        self.is_stale = value
                        self.is_stale.value_namespace = name_space
                        self.is_stale.value_namespace_prefix = name_space_prefix
                    if(value_path == "is-synced"):
                        self.is_synced = value
                        self.is_synced.value_namespace = name_space
                        self.is_synced.value_namespace_prefix = name_space_prefix
                    if(value_path == "notify-state-is-active"):
                        self.notify_state_is_active = value
                        self.notify_state_is_active.value_namespace = name_space
                        self.notify_state_is_active.value_namespace_prefix = name_space_prefix
                    if(value_path == "notify-time"):
                        self.notify_time = value
                        self.notify_time.value_namespace = name_space
                        self.notify_time.value_namespace_prefix = name_space_prefix
                    if(value_path == "policy-active"):
                        self.policy_active = value
                        self.policy_active.value_namespace = name_space
                        self.policy_active.value_namespace_prefix = name_space_prefix
                    if(value_path == "requested-binding-sid"):
                        self.requested_binding_sid = value
                        self.requested_binding_sid.value_namespace = name_space
                        self.requested_binding_sid.value_namespace_prefix = name_space_prefix
                    if(value_path == "rewrite-done"):
                        self.rewrite_done = value
                        self.rewrite_done.value_namespace = name_space
                        self.rewrite_done.value_namespace_prefix = name_space_prefix
                    if(value_path == "rewrite-request-pending"):
                        self.rewrite_request_pending = value
                        self.rewrite_request_pending.value_namespace = name_space
                        self.rewrite_request_pending.value_namespace_prefix = name_space_prefix
                    if(value_path == "sr-policy-id"):
                        self.sr_policy_id = value
                        self.sr_policy_id.value_namespace = name_space
                        self.sr_policy_id.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.sr_policy_entry:
                    if (c.has_data()):
                        return True
                return False

            def has_operation(self):
                for c in self.sr_policy_entry:
                    if (c.has_operation()):
                        return True
                return self.yfilter != YFilter.not_set

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "sr-policy-entries" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/auto-tunnel-services/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "sr-policy-entry"):
                    for c in self.sr_policy_entry:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTeStandby.AutoTunnelServices.SrPolicyEntries.SrPolicyEntry()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.sr_policy_entry.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "sr-policy-entry"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                pass

        def has_data(self):
            return (self.sr_policy_entries is not None and self.sr_policy_entries.has_data())

        def has_operation(self):
            return (
                self.yfilter != YFilter.not_set or
                (self.sr_policy_entries is not None and self.sr_policy_entries.has_operation()))

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "auto-tunnel-services" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "sr-policy-entries"):
                if (self.sr_policy_entries is None):
                    self.sr_policy_entries = MplsTeStandby.AutoTunnelServices.SrPolicyEntries()
                    self.sr_policy_entries.parent = self
                    self._children_name_map["sr_policy_entries"] = "sr-policy-entries"
                return self.sr_policy_entries

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "sr-policy-entries"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class AffinityMap(Entity):
        """
        Affinity name to value mapping
        
        .. attribute:: affinity_map_array
        
        	Affinity map array
        	**type**\: list of    :py:class:`AffinityMapArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AffinityMap.AffinityMapArray>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsTeStandby.AffinityMap, self).__init__()

            self.yang_name = "affinity-map"
            self.yang_parent_name = "mpls-te-standby"

            self.affinity_map_array = YList(self)

        def __setattr__(self, name, value):
            self._check_monkey_patching_error(name, value)
            with _handle_type_error():
                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                        "Please use list append or extend method."
                                        .format(value))
                if isinstance(value, Enum.YLeaf):
                    value = value.name
                if name in () and name in self.__dict__:
                    if isinstance(value, YLeaf):
                        self.__dict__[name].set(value.get())
                    elif isinstance(value, YLeafList):
                        super(MplsTeStandby.AffinityMap, self).__setattr__(name, value)
                    else:
                        self.__dict__[name].set(value)
                else:
                    if hasattr(value, "parent") and name != "parent":
                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                            value.parent = self
                        elif value.parent is None and value.yang_name in self._children_yang_names:
                            value.parent = self
                    super(MplsTeStandby.AffinityMap, self).__setattr__(name, value)


        class AffinityMapArray(Entity):
            """
            Affinity map array
            
            .. attribute:: affinity_bit_position
            
            	Affinity bit position
            	**type**\:  int
            
            	**range:** 0..255
            
            .. attribute:: affinity_extended_value
            
            	EAG value
            	**type**\: list of    :py:class:`AffinityExtendedValue <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.AffinityMap.AffinityMapArray.AffinityExtendedValue>`
            
            .. attribute:: affinity_name
            
            	Affinity name
            	**type**\:  str
            
            .. attribute:: affinity_table_id
            
            	Affinity table id
            	**type**\:   :py:class:`TeAffinityTable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeAffinityTable>`
            
            .. attribute:: affinity_value
            
            	Affinity value
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTeStandby.AffinityMap.AffinityMapArray, self).__init__()

                self.yang_name = "affinity-map-array"
                self.yang_parent_name = "affinity-map"

                self.affinity_bit_position = YLeaf(YType.uint8, "affinity-bit-position")

                self.affinity_name = YLeaf(YType.str, "affinity-name")

                self.affinity_table_id = YLeaf(YType.enumeration, "affinity-table-id")

                self.affinity_value = YLeaf(YType.uint32, "affinity-value")

                self.affinity_extended_value = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("affinity_bit_position",
                                "affinity_name",
                                "affinity_table_id",
                                "affinity_value") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTeStandby.AffinityMap.AffinityMapArray, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTeStandby.AffinityMap.AffinityMapArray, self).__setattr__(name, value)


            class AffinityExtendedValue(Entity):
                """
                EAG value
                
                .. attribute:: entry
                
                	
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTeStandby.AffinityMap.AffinityMapArray.AffinityExtendedValue, self).__init__()

                    self.yang_name = "affinity-extended-value"
                    self.yang_parent_name = "affinity-map-array"

                    self.entry = YLeaf(YType.uint32, "entry")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("entry") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTeStandby.AffinityMap.AffinityMapArray.AffinityExtendedValue, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTeStandby.AffinityMap.AffinityMapArray.AffinityExtendedValue, self).__setattr__(name, value)

                def has_data(self):
                    return self.entry.is_set

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.entry.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "affinity-extended-value" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/affinity-map/affinity-map-array/%s" % self.get_segment_path()
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.entry.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "entry"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "entry"):
                        self.entry = value
                        self.entry.value_namespace = name_space
                        self.entry.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.affinity_extended_value:
                    if (c.has_data()):
                        return True
                return (
                    self.affinity_bit_position.is_set or
                    self.affinity_name.is_set or
                    self.affinity_table_id.is_set or
                    self.affinity_value.is_set)

            def has_operation(self):
                for c in self.affinity_extended_value:
                    if (c.has_operation()):
                        return True
                return (
                    self.yfilter != YFilter.not_set or
                    self.affinity_bit_position.yfilter != YFilter.not_set or
                    self.affinity_name.yfilter != YFilter.not_set or
                    self.affinity_table_id.yfilter != YFilter.not_set or
                    self.affinity_value.yfilter != YFilter.not_set)

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "affinity-map-array" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/affinity-map/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.affinity_bit_position.is_set or self.affinity_bit_position.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.affinity_bit_position.get_name_leafdata())
                if (self.affinity_name.is_set or self.affinity_name.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.affinity_name.get_name_leafdata())
                if (self.affinity_table_id.is_set or self.affinity_table_id.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.affinity_table_id.get_name_leafdata())
                if (self.affinity_value.is_set or self.affinity_value.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.affinity_value.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "affinity-extended-value"):
                    for c in self.affinity_extended_value:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTeStandby.AffinityMap.AffinityMapArray.AffinityExtendedValue()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.affinity_extended_value.append(c)
                    return c

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "affinity-extended-value" or name == "affinity-bit-position" or name == "affinity-name" or name == "affinity-table-id" or name == "affinity-value"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "affinity-bit-position"):
                    self.affinity_bit_position = value
                    self.affinity_bit_position.value_namespace = name_space
                    self.affinity_bit_position.value_namespace_prefix = name_space_prefix
                if(value_path == "affinity-name"):
                    self.affinity_name = value
                    self.affinity_name.value_namespace = name_space
                    self.affinity_name.value_namespace_prefix = name_space_prefix
                if(value_path == "affinity-table-id"):
                    self.affinity_table_id = value
                    self.affinity_table_id.value_namespace = name_space
                    self.affinity_table_id.value_namespace_prefix = name_space_prefix
                if(value_path == "affinity-value"):
                    self.affinity_value = value
                    self.affinity_value.value_namespace = name_space
                    self.affinity_value.value_namespace_prefix = name_space_prefix

        def has_data(self):
            for c in self.affinity_map_array:
                if (c.has_data()):
                    return True
            return False

        def has_operation(self):
            for c in self.affinity_map_array:
                if (c.has_operation()):
                    return True
            return self.yfilter != YFilter.not_set

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "affinity-map" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "affinity-map-array"):
                for c in self.affinity_map_array:
                    segment = c.get_segment_path()
                    if (segment_path == segment):
                        return c
                c = MplsTeStandby.AffinityMap.AffinityMapArray()
                c.parent = self
                local_reference_key = "ydk::seg::%s" % segment_path
                self._local_refs[local_reference_key] = c
                self.affinity_map_array.append(c)
                return c

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "affinity-map-array"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass


    class TopologyBriefs(Entity):
        """
        MPLS\-TE topology brief table
        
        .. attribute:: topology_brief
        
        	A node in MPLS\-TE topoogy brief table
        	**type**\: list of    :py:class:`TopologyBrief <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyBriefs.TopologyBrief>`
        
        

        """

        _prefix = 'mpls-te-oper'
        _revision = '2015-11-09'

        def __init__(self):
            super(MplsTeStandby.TopologyBriefs, self).__init__()

            self.yang_name = "topology-briefs"
            self.yang_parent_name = "mpls-te-standby"

            self.topology_brief = YList(self)

        def __setattr__(self, name, value):
            self._check_monkey_patching_error(name, value)
            with _handle_type_error():
                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                        "Please use list append or extend method."
                                        .format(value))
                if isinstance(value, Enum.YLeaf):
                    value = value.name
                if name in () and name in self.__dict__:
                    if isinstance(value, YLeaf):
                        self.__dict__[name].set(value.get())
                    elif isinstance(value, YLeafList):
                        super(MplsTeStandby.TopologyBriefs, self).__setattr__(name, value)
                    else:
                        self.__dict__[name].set(value)
                else:
                    if hasattr(value, "parent") and name != "parent":
                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                            value.parent = self
                        elif value.parent is None and value.yang_name in self._children_yang_names:
                            value.parent = self
                    super(MplsTeStandby.TopologyBriefs, self).__setattr__(name, value)


        class TopologyBrief(Entity):
            """
            A node in MPLS\-TE topoogy brief table
            
            .. attribute:: protocol  <key>
            
            	IGP protocol type
            	**type**\:   :py:class:`MplsTeIgpProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeIgpProtocol>`
            
            .. attribute:: igp_id  <key>
            
            	IGP instance
            	**type**\:  str
            
            	**pattern:** [\\w\\\-\\.\:,\_@#%$\\+=\\\|;]+
            
            .. attribute:: area  <key>
            
            	IGP area
            	**type**\:  int
            
            	**range:** \-2147483648..2147483647
            
            .. attribute:: topology_node_type  <key>
            
            	Node type
            	**type**\:   :py:class:`MplsTeNode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeNode>`
            
            .. attribute:: igp_node_id  <key>
            
            	IGP Node ID
            	**type**\:  str
            
            .. attribute:: topology_node_link
            
            	This node's link information
            	**type**\: list of    :py:class:`TopologyNodeLink <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink>`
            
            .. attribute:: topology_node_overloaded
            
            	Flag to indicate whether this node is overloaded
            	**type**\:  bool
            
            .. attribute:: topology_node_sid_and_srbg
            
            	This node's SID and SRBG information
            	**type**\:   :py:class:`TopologyNodeSidAndSrbg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeSidAndSrbg>`
            
            .. attribute:: topology_node_te_router_id
            
            	The node's TE router\-id. Not set for network nodes
            	**type**\:  str
            
            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
            
            

            """

            _prefix = 'mpls-te-oper'
            _revision = '2015-11-09'

            def __init__(self):
                super(MplsTeStandby.TopologyBriefs.TopologyBrief, self).__init__()

                self.yang_name = "topology-brief"
                self.yang_parent_name = "topology-briefs"

                self.protocol = YLeaf(YType.enumeration, "protocol")

                self.igp_id = YLeaf(YType.str, "igp-id")

                self.area = YLeaf(YType.int32, "area")

                self.topology_node_type = YLeaf(YType.enumeration, "topology-node-type")

                self.igp_node_id = YLeaf(YType.str, "igp-node-id")

                self.topology_node_overloaded = YLeaf(YType.boolean, "topology-node-overloaded")

                self.topology_node_te_router_id = YLeaf(YType.str, "topology-node-te-router-id")

                self.topology_node_sid_and_srbg = MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeSidAndSrbg()
                self.topology_node_sid_and_srbg.parent = self
                self._children_name_map["topology_node_sid_and_srbg"] = "topology-node-sid-and-srbg"
                self._children_yang_names.add("topology-node-sid-and-srbg")

                self.topology_node_link = YList(self)

            def __setattr__(self, name, value):
                self._check_monkey_patching_error(name, value)
                with _handle_type_error():
                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                            "Please use list append or extend method."
                                            .format(value))
                    if isinstance(value, Enum.YLeaf):
                        value = value.name
                    if name in ("protocol",
                                "igp_id",
                                "area",
                                "topology_node_type",
                                "igp_node_id",
                                "topology_node_overloaded",
                                "topology_node_te_router_id") and name in self.__dict__:
                        if isinstance(value, YLeaf):
                            self.__dict__[name].set(value.get())
                        elif isinstance(value, YLeafList):
                            super(MplsTeStandby.TopologyBriefs.TopologyBrief, self).__setattr__(name, value)
                        else:
                            self.__dict__[name].set(value)
                    else:
                        if hasattr(value, "parent") and name != "parent":
                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                value.parent = self
                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                value.parent = self
                        super(MplsTeStandby.TopologyBriefs.TopologyBrief, self).__setattr__(name, value)


            class TopologyNodeSidAndSrbg(Entity):
                """
                This node's SID and SRBG information
                
                .. attribute:: segment_id
                
                	Segment\-Routing Node\-SID
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: segment_id_local_absolute_value
                
                	Node\-SID local absolute value
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: srgb_size
                
                	Segment\-Routing global block size
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: srgb_start
                
                	Segment\-Routring global block start value
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeSidAndSrbg, self).__init__()

                    self.yang_name = "topology-node-sid-and-srbg"
                    self.yang_parent_name = "topology-brief"

                    self.segment_id = YLeaf(YType.uint32, "segment-id")

                    self.segment_id_local_absolute_value = YLeaf(YType.uint32, "segment-id-local-absolute-value")

                    self.srgb_size = YLeaf(YType.uint32, "srgb-size")

                    self.srgb_start = YLeaf(YType.uint32, "srgb-start")

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("segment_id",
                                    "segment_id_local_absolute_value",
                                    "srgb_size",
                                    "srgb_start") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeSidAndSrbg, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeSidAndSrbg, self).__setattr__(name, value)

                def has_data(self):
                    return (
                        self.segment_id.is_set or
                        self.segment_id_local_absolute_value.is_set or
                        self.srgb_size.is_set or
                        self.srgb_start.is_set)

                def has_operation(self):
                    return (
                        self.yfilter != YFilter.not_set or
                        self.segment_id.yfilter != YFilter.not_set or
                        self.segment_id_local_absolute_value.yfilter != YFilter.not_set or
                        self.srgb_size.yfilter != YFilter.not_set or
                        self.srgb_start.yfilter != YFilter.not_set)

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "topology-node-sid-and-srbg" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.segment_id.is_set or self.segment_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.segment_id.get_name_leafdata())
                    if (self.segment_id_local_absolute_value.is_set or self.segment_id_local_absolute_value.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.segment_id_local_absolute_value.get_name_leafdata())
                    if (self.srgb_size.is_set or self.srgb_size.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.srgb_size.get_name_leafdata())
                    if (self.srgb_start.is_set or self.srgb_start.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.srgb_start.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "segment-id" or name == "segment-id-local-absolute-value" or name == "srgb-size" or name == "srgb-start"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "segment-id"):
                        self.segment_id = value
                        self.segment_id.value_namespace = name_space
                        self.segment_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "segment-id-local-absolute-value"):
                        self.segment_id_local_absolute_value = value
                        self.segment_id_local_absolute_value.value_namespace = name_space
                        self.segment_id_local_absolute_value.value_namespace_prefix = name_space_prefix
                    if(value_path == "srgb-size"):
                        self.srgb_size = value
                        self.srgb_size.value_namespace = name_space
                        self.srgb_size.value_namespace_prefix = name_space_prefix
                    if(value_path == "srgb-start"):
                        self.srgb_start = value
                        self.srgb_start.value_namespace = name_space
                        self.srgb_start.value_namespace_prefix = name_space_prefix


            class TopologyNodeLink(Entity):
                """
                This node's link information
                
                .. attribute:: adjacency_sid
                
                	Adjacency SIDs assigned for adjacency nodes
                	**type**\: list of    :py:class:`AdjacencySid <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.AdjacencySid>`
                
                .. attribute:: odu_link_capabilities
                
                	ODU Link Capabilities
                	**type**\:   :py:class:`OduLinkCapabilities <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities>`
                
                .. attribute:: shared_risk_link_group
                
                	The link's shared risk link groups
                	**type**\: list of    :py:class:`SharedRiskLinkGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.SharedRiskLinkGroup>`
                
                .. attribute:: topology_link_affinity_bits
                
                	Deprecated
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: topology_link_bandwidth
                
                	Bandwidth information for this link
                	**type**\:   :py:class:`TopologyLinkBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth>`
                
                .. attribute:: topology_link_bandwidth_model
                
                	The link's topology bandwidth model
                	**type**\:   :py:class:`IgpteLibBwModel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpteLibBwModel>`
                
                .. attribute:: topology_link_encoding
                
                	The link's encoding
                	**type**\:  int
                
                	**range:** 0..255
                
                .. attribute:: topology_link_extended_affinity_bit
                
                	The link's affinity bits (colors)
                	**type**\: list of    :py:class:`TopologyLinkExtendedAffinityBit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkExtendedAffinityBit>`
                
                .. attribute:: topology_link_fragment_id
                
                	Neighbor's link version counter
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: topology_link_igp_metric
                
                	The link's IGP metric
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: topology_link_interface_address
                
                	Link's local interface address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: topology_link_interface_id
                
                	Link's local interface ID
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: topology_link_neighbor_address
                
                	Link's neighbor interface address
                	**type**\:  str
                
                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                
                .. attribute:: topology_link_neighbor_generation
                
                	Neighbor's link version counter
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: topology_link_neighbor_id
                
                	Link's neighbor interface ID
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: topology_link_neighbor_node_id
                
                	Node id of neighbor
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: topology_link_neighbor_system_id
                
                	System id of neighbor
                	**type**\:  str
                
                .. attribute:: topology_link_switching_capability
                
                	The link's switching capability
                	**type**\:  int
                
                	**range:** 0..255
                
                .. attribute:: topology_link_te_metric
                
                	The link's TE metric
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: topology_link_type
                
                	Link type
                	**type**\:   :py:class:`IgpSubnet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpSubnet>`
                
                .. attribute:: topology_link_uni_delay
                
                	Unidirectional Link Delay in micro\-sec
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'mpls-te-oper'
                _revision = '2015-11-09'

                def __init__(self):
                    super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink, self).__init__()

                    self.yang_name = "topology-node-link"
                    self.yang_parent_name = "topology-brief"

                    self.topology_link_affinity_bits = YLeaf(YType.uint32, "topology-link-affinity-bits")

                    self.topology_link_bandwidth_model = YLeaf(YType.enumeration, "topology-link-bandwidth-model")

                    self.topology_link_encoding = YLeaf(YType.uint8, "topology-link-encoding")

                    self.topology_link_fragment_id = YLeaf(YType.uint32, "topology-link-fragment-id")

                    self.topology_link_igp_metric = YLeaf(YType.uint32, "topology-link-igp-metric")

                    self.topology_link_interface_address = YLeaf(YType.str, "topology-link-interface-address")

                    self.topology_link_interface_id = YLeaf(YType.uint32, "topology-link-interface-id")

                    self.topology_link_neighbor_address = YLeaf(YType.str, "topology-link-neighbor-address")

                    self.topology_link_neighbor_generation = YLeaf(YType.uint32, "topology-link-neighbor-generation")

                    self.topology_link_neighbor_id = YLeaf(YType.uint32, "topology-link-neighbor-id")

                    self.topology_link_neighbor_node_id = YLeaf(YType.uint32, "topology-link-neighbor-node-id")

                    self.topology_link_neighbor_system_id = YLeaf(YType.str, "topology-link-neighbor-system-id")

                    self.topology_link_switching_capability = YLeaf(YType.uint8, "topology-link-switching-capability")

                    self.topology_link_te_metric = YLeaf(YType.uint32, "topology-link-te-metric")

                    self.topology_link_type = YLeaf(YType.enumeration, "topology-link-type")

                    self.topology_link_uni_delay = YLeaf(YType.uint32, "topology-link-uni-delay")

                    self.odu_link_capabilities = MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities()
                    self.odu_link_capabilities.parent = self
                    self._children_name_map["odu_link_capabilities"] = "odu-link-capabilities"
                    self._children_yang_names.add("odu-link-capabilities")

                    self.topology_link_bandwidth = MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth()
                    self.topology_link_bandwidth.parent = self
                    self._children_name_map["topology_link_bandwidth"] = "topology-link-bandwidth"
                    self._children_yang_names.add("topology-link-bandwidth")

                    self.adjacency_sid = YList(self)
                    self.shared_risk_link_group = YList(self)
                    self.topology_link_extended_affinity_bit = YList(self)

                def __setattr__(self, name, value):
                    self._check_monkey_patching_error(name, value)
                    with _handle_type_error():
                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                "Please use list append or extend method."
                                                .format(value))
                        if isinstance(value, Enum.YLeaf):
                            value = value.name
                        if name in ("topology_link_affinity_bits",
                                    "topology_link_bandwidth_model",
                                    "topology_link_encoding",
                                    "topology_link_fragment_id",
                                    "topology_link_igp_metric",
                                    "topology_link_interface_address",
                                    "topology_link_interface_id",
                                    "topology_link_neighbor_address",
                                    "topology_link_neighbor_generation",
                                    "topology_link_neighbor_id",
                                    "topology_link_neighbor_node_id",
                                    "topology_link_neighbor_system_id",
                                    "topology_link_switching_capability",
                                    "topology_link_te_metric",
                                    "topology_link_type",
                                    "topology_link_uni_delay") and name in self.__dict__:
                            if isinstance(value, YLeaf):
                                self.__dict__[name].set(value.get())
                            elif isinstance(value, YLeafList):
                                super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink, self).__setattr__(name, value)
                            else:
                                self.__dict__[name].set(value)
                        else:
                            if hasattr(value, "parent") and name != "parent":
                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                    value.parent = self
                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                    value.parent = self
                            super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink, self).__setattr__(name, value)


                class TopologyLinkBandwidth(Entity):
                    """
                    Bandwidth information for this link
                    
                    .. attribute:: bandwidth_migration_mode
                    
                    	BandwidthMigrationMode
                    	**type**\:   :py:class:`RrrDsteMigrationMode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.RrrDsteMigrationMode>`
                    
                    .. attribute:: topology_link_bandwidth_prestandard
                    
                    	Pre\-standard bandwidth information for this link
                    	**type**\:   :py:class:`TopologyLinkBandwidthPrestandard <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard>`
                    
                    .. attribute:: topology_link_bandwidth_standard
                    
                    	IETF\-standard bandwidth information for this link
                    	**type**\:   :py:class:`TopologyLinkBandwidthStandard <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth, self).__init__()

                        self.yang_name = "topology-link-bandwidth"
                        self.yang_parent_name = "topology-node-link"

                        self.bandwidth_migration_mode = YLeaf(YType.enumeration, "bandwidth-migration-mode")

                        self.topology_link_bandwidth_prestandard = MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard()
                        self.topology_link_bandwidth_prestandard.parent = self
                        self._children_name_map["topology_link_bandwidth_prestandard"] = "topology-link-bandwidth-prestandard"
                        self._children_yang_names.add("topology-link-bandwidth-prestandard")

                        self.topology_link_bandwidth_standard = MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard()
                        self.topology_link_bandwidth_standard.parent = self
                        self._children_name_map["topology_link_bandwidth_standard"] = "topology-link-bandwidth-standard"
                        self._children_yang_names.add("topology-link-bandwidth-standard")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("bandwidth_migration_mode") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth, self).__setattr__(name, value)


                    class TopologyLinkBandwidthPrestandard(Entity):
                        """
                        Pre\-standard bandwidth information for this link
                        
                        .. attribute:: topology_link_prestandard_bandwidth_detail
                        
                        	Detailed bandwidth information for this link
                        	**type**\:   :py:class:`TopologyLinkPrestandardBandwidthDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail>`
                        
                        .. attribute:: topology_link_prestandard_bandwidth_physical
                        
                        	The link's physical bandwidth
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: topology_link_prestandard_bandwidth_reservation_global
                        
                        	The link's reservable global bandwidth
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: topology_link_prestandard_bandwidth_reservation_subpool
                        
                        	The link's reservable subpool bandwidth
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard, self).__init__()

                            self.yang_name = "topology-link-bandwidth-prestandard"
                            self.yang_parent_name = "topology-link-bandwidth"

                            self.topology_link_prestandard_bandwidth_physical = YLeaf(YType.uint32, "topology-link-prestandard-bandwidth-physical")

                            self.topology_link_prestandard_bandwidth_reservation_global = YLeaf(YType.uint32, "topology-link-prestandard-bandwidth-reservation-global")

                            self.topology_link_prestandard_bandwidth_reservation_subpool = YLeaf(YType.uint32, "topology-link-prestandard-bandwidth-reservation-subpool")

                            self.topology_link_prestandard_bandwidth_detail = MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail()
                            self.topology_link_prestandard_bandwidth_detail.parent = self
                            self._children_name_map["topology_link_prestandard_bandwidth_detail"] = "topology-link-prestandard-bandwidth-detail"
                            self._children_yang_names.add("topology-link-prestandard-bandwidth-detail")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("topology_link_prestandard_bandwidth_physical",
                                            "topology_link_prestandard_bandwidth_reservation_global",
                                            "topology_link_prestandard_bandwidth_reservation_subpool") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard, self).__setattr__(name, value)


                        class TopologyLinkPrestandardBandwidthDetail(Entity):
                            """
                            Detailed bandwidth information for this link
                            
                            .. attribute:: topology_link_prestandard_bandwidth_allocated
                            
                            	Link's allocated bandwidth at priority levels  (priority 0 to priority 7)
                            	**type**\: list of    :py:class:`TopologyLinkPrestandardBandwidthAllocated <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAllocated>`
                            
                            .. attribute:: topology_link_prestandard_bandwidth_available_global
                            
                            	Link's available global\-pool bandwidth at  priority levels (priority 0 to priority 7)
                            	**type**\: list of    :py:class:`TopologyLinkPrestandardBandwidthAvailableGlobal <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableGlobal>`
                            
                            .. attribute:: topology_link_prestandard_bandwidth_available_subpool
                            
                            	Link's available sub\-pool bandwidth at priority  levels (priority 0 to priority 7)
                            	**type**\: list of    :py:class:`TopologyLinkPrestandardBandwidthAvailableSubpool <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableSubpool>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail, self).__init__()

                                self.yang_name = "topology-link-prestandard-bandwidth-detail"
                                self.yang_parent_name = "topology-link-bandwidth-prestandard"

                                self.topology_link_prestandard_bandwidth_allocated = YList(self)
                                self.topology_link_prestandard_bandwidth_available_global = YList(self)
                                self.topology_link_prestandard_bandwidth_available_subpool = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in () and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail, self).__setattr__(name, value)


                            class TopologyLinkPrestandardBandwidthAllocated(Entity):
                                """
                                Link's allocated bandwidth at priority levels
                                
                                (priority 0 to priority 7)
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAllocated, self).__init__()

                                    self.yang_name = "topology-link-prestandard-bandwidth-allocated"
                                    self.yang_parent_name = "topology-link-prestandard-bandwidth-detail"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAllocated, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAllocated, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "topology-link-prestandard-bandwidth-allocated" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix


                            class TopologyLinkPrestandardBandwidthAvailableGlobal(Entity):
                                """
                                Link's available global\-pool bandwidth at
                                
                                priority levels (priority 0 to priority 7)
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableGlobal, self).__init__()

                                    self.yang_name = "topology-link-prestandard-bandwidth-available-global"
                                    self.yang_parent_name = "topology-link-prestandard-bandwidth-detail"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableGlobal, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableGlobal, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "topology-link-prestandard-bandwidth-available-global" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix


                            class TopologyLinkPrestandardBandwidthAvailableSubpool(Entity):
                                """
                                Link's available sub\-pool bandwidth at priority
                                
                                levels (priority 0 to priority 7)
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableSubpool, self).__init__()

                                    self.yang_name = "topology-link-prestandard-bandwidth-available-subpool"
                                    self.yang_parent_name = "topology-link-prestandard-bandwidth-detail"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableSubpool, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableSubpool, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "topology-link-prestandard-bandwidth-available-subpool" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.topology_link_prestandard_bandwidth_allocated:
                                    if (c.has_data()):
                                        return True
                                for c in self.topology_link_prestandard_bandwidth_available_global:
                                    if (c.has_data()):
                                        return True
                                for c in self.topology_link_prestandard_bandwidth_available_subpool:
                                    if (c.has_data()):
                                        return True
                                return False

                            def has_operation(self):
                                for c in self.topology_link_prestandard_bandwidth_allocated:
                                    if (c.has_operation()):
                                        return True
                                for c in self.topology_link_prestandard_bandwidth_available_global:
                                    if (c.has_operation()):
                                        return True
                                for c in self.topology_link_prestandard_bandwidth_available_subpool:
                                    if (c.has_operation()):
                                        return True
                                return self.yfilter != YFilter.not_set

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "topology-link-prestandard-bandwidth-detail" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "topology-link-prestandard-bandwidth-allocated"):
                                    for c in self.topology_link_prestandard_bandwidth_allocated:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAllocated()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.topology_link_prestandard_bandwidth_allocated.append(c)
                                    return c

                                if (child_yang_name == "topology-link-prestandard-bandwidth-available-global"):
                                    for c in self.topology_link_prestandard_bandwidth_available_global:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableGlobal()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.topology_link_prestandard_bandwidth_available_global.append(c)
                                    return c

                                if (child_yang_name == "topology-link-prestandard-bandwidth-available-subpool"):
                                    for c in self.topology_link_prestandard_bandwidth_available_subpool:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail.TopologyLinkPrestandardBandwidthAvailableSubpool()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.topology_link_prestandard_bandwidth_available_subpool.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "topology-link-prestandard-bandwidth-allocated" or name == "topology-link-prestandard-bandwidth-available-global" or name == "topology-link-prestandard-bandwidth-available-subpool"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass

                        def has_data(self):
                            return (
                                self.topology_link_prestandard_bandwidth_physical.is_set or
                                self.topology_link_prestandard_bandwidth_reservation_global.is_set or
                                self.topology_link_prestandard_bandwidth_reservation_subpool.is_set or
                                (self.topology_link_prestandard_bandwidth_detail is not None and self.topology_link_prestandard_bandwidth_detail.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.topology_link_prestandard_bandwidth_physical.yfilter != YFilter.not_set or
                                self.topology_link_prestandard_bandwidth_reservation_global.yfilter != YFilter.not_set or
                                self.topology_link_prestandard_bandwidth_reservation_subpool.yfilter != YFilter.not_set or
                                (self.topology_link_prestandard_bandwidth_detail is not None and self.topology_link_prestandard_bandwidth_detail.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "topology-link-bandwidth-prestandard" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.topology_link_prestandard_bandwidth_physical.is_set or self.topology_link_prestandard_bandwidth_physical.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.topology_link_prestandard_bandwidth_physical.get_name_leafdata())
                            if (self.topology_link_prestandard_bandwidth_reservation_global.is_set or self.topology_link_prestandard_bandwidth_reservation_global.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.topology_link_prestandard_bandwidth_reservation_global.get_name_leafdata())
                            if (self.topology_link_prestandard_bandwidth_reservation_subpool.is_set or self.topology_link_prestandard_bandwidth_reservation_subpool.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.topology_link_prestandard_bandwidth_reservation_subpool.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "topology-link-prestandard-bandwidth-detail"):
                                if (self.topology_link_prestandard_bandwidth_detail is None):
                                    self.topology_link_prestandard_bandwidth_detail = MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard.TopologyLinkPrestandardBandwidthDetail()
                                    self.topology_link_prestandard_bandwidth_detail.parent = self
                                    self._children_name_map["topology_link_prestandard_bandwidth_detail"] = "topology-link-prestandard-bandwidth-detail"
                                return self.topology_link_prestandard_bandwidth_detail

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "topology-link-prestandard-bandwidth-detail" or name == "topology-link-prestandard-bandwidth-physical" or name == "topology-link-prestandard-bandwidth-reservation-global" or name == "topology-link-prestandard-bandwidth-reservation-subpool"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "topology-link-prestandard-bandwidth-physical"):
                                self.topology_link_prestandard_bandwidth_physical = value
                                self.topology_link_prestandard_bandwidth_physical.value_namespace = name_space
                                self.topology_link_prestandard_bandwidth_physical.value_namespace_prefix = name_space_prefix
                            if(value_path == "topology-link-prestandard-bandwidth-reservation-global"):
                                self.topology_link_prestandard_bandwidth_reservation_global = value
                                self.topology_link_prestandard_bandwidth_reservation_global.value_namespace = name_space
                                self.topology_link_prestandard_bandwidth_reservation_global.value_namespace_prefix = name_space_prefix
                            if(value_path == "topology-link-prestandard-bandwidth-reservation-subpool"):
                                self.topology_link_prestandard_bandwidth_reservation_subpool = value
                                self.topology_link_prestandard_bandwidth_reservation_subpool.value_namespace = name_space
                                self.topology_link_prestandard_bandwidth_reservation_subpool.value_namespace_prefix = name_space_prefix


                    class TopologyLinkBandwidthStandard(Entity):
                        """
                        IETF\-standard bandwidth information for this
                        link
                        
                        .. attribute:: topo_link_std_bw_detail
                        
                        	Detailed bandwidth information for this link
                        	**type**\:   :py:class:`TopoLinkStdBwDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail>`
                        
                        .. attribute:: topo_link_std_bw_physical
                        
                        	The link's physical bandwidth
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: topo_link_std_bw_res_max
                        
                        	The link's maximum reservable bandwidth
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: topo_link_std_bw_res_pool0
                        
                        	The link's reservable BC0 bandwidth
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: topo_link_std_bw_res_pool1
                        
                        	The link's reservable BC1 bandwidth
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard, self).__init__()

                            self.yang_name = "topology-link-bandwidth-standard"
                            self.yang_parent_name = "topology-link-bandwidth"

                            self.topo_link_std_bw_physical = YLeaf(YType.uint32, "topo-link-std-bw-physical")

                            self.topo_link_std_bw_res_max = YLeaf(YType.uint32, "topo-link-std-bw-res-max")

                            self.topo_link_std_bw_res_pool0 = YLeaf(YType.uint32, "topo-link-std-bw-res-pool0")

                            self.topo_link_std_bw_res_pool1 = YLeaf(YType.uint32, "topo-link-std-bw-res-pool1")

                            self.topo_link_std_bw_detail = MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail()
                            self.topo_link_std_bw_detail.parent = self
                            self._children_name_map["topo_link_std_bw_detail"] = "topo-link-std-bw-detail"
                            self._children_yang_names.add("topo-link-std-bw-detail")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("topo_link_std_bw_physical",
                                            "topo_link_std_bw_res_max",
                                            "topo_link_std_bw_res_pool0",
                                            "topo_link_std_bw_res_pool1") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard, self).__setattr__(name, value)


                        class TopoLinkStdBwDetail(Entity):
                            """
                            Detailed bandwidth information for this link
                            
                            .. attribute:: topo_link_std_bw_allocated
                            
                            	Link's allocated bandwidth per class
                            	**type**\: list of    :py:class:`TopoLinkStdBwAllocated <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAllocated>`
                            
                            .. attribute:: topo_link_std_bw_available
                            
                            	Link's available bandwidth per class
                            	**type**\: list of    :py:class:`TopoLinkStdBwAvailable <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAvailable>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail, self).__init__()

                                self.yang_name = "topo-link-std-bw-detail"
                                self.yang_parent_name = "topology-link-bandwidth-standard"

                                self.topo_link_std_bw_allocated = YList(self)
                                self.topo_link_std_bw_available = YList(self)

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in () and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail, self).__setattr__(name, value)


                            class TopoLinkStdBwAllocated(Entity):
                                """
                                Link's allocated bandwidth per class
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAllocated, self).__init__()

                                    self.yang_name = "topo-link-std-bw-allocated"
                                    self.yang_parent_name = "topo-link-std-bw-detail"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAllocated, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAllocated, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "topo-link-std-bw-allocated" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix


                            class TopoLinkStdBwAvailable(Entity):
                                """
                                Link's available bandwidth per class
                                
                                .. attribute:: entry
                                
                                	
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAvailable, self).__init__()

                                    self.yang_name = "topo-link-std-bw-available"
                                    self.yang_parent_name = "topo-link-std-bw-detail"

                                    self.entry = YLeaf(YType.uint32, "entry")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("entry") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAvailable, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAvailable, self).__setattr__(name, value)

                                def has_data(self):
                                    return self.entry.is_set

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.entry.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "topo-link-std-bw-available" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.entry.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "entry"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "entry"):
                                        self.entry = value
                                        self.entry.value_namespace = name_space
                                        self.entry.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                for c in self.topo_link_std_bw_allocated:
                                    if (c.has_data()):
                                        return True
                                for c in self.topo_link_std_bw_available:
                                    if (c.has_data()):
                                        return True
                                return False

                            def has_operation(self):
                                for c in self.topo_link_std_bw_allocated:
                                    if (c.has_operation()):
                                        return True
                                for c in self.topo_link_std_bw_available:
                                    if (c.has_operation()):
                                        return True
                                return self.yfilter != YFilter.not_set

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "topo-link-std-bw-detail" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "topo-link-std-bw-allocated"):
                                    for c in self.topo_link_std_bw_allocated:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAllocated()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.topo_link_std_bw_allocated.append(c)
                                    return c

                                if (child_yang_name == "topo-link-std-bw-available"):
                                    for c in self.topo_link_std_bw_available:
                                        segment = c.get_segment_path()
                                        if (segment_path == segment):
                                            return c
                                    c = MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail.TopoLinkStdBwAvailable()
                                    c.parent = self
                                    local_reference_key = "ydk::seg::%s" % segment_path
                                    self._local_refs[local_reference_key] = c
                                    self.topo_link_std_bw_available.append(c)
                                    return c

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "topo-link-std-bw-allocated" or name == "topo-link-std-bw-available"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                pass

                        def has_data(self):
                            return (
                                self.topo_link_std_bw_physical.is_set or
                                self.topo_link_std_bw_res_max.is_set or
                                self.topo_link_std_bw_res_pool0.is_set or
                                self.topo_link_std_bw_res_pool1.is_set or
                                (self.topo_link_std_bw_detail is not None and self.topo_link_std_bw_detail.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.topo_link_std_bw_physical.yfilter != YFilter.not_set or
                                self.topo_link_std_bw_res_max.yfilter != YFilter.not_set or
                                self.topo_link_std_bw_res_pool0.yfilter != YFilter.not_set or
                                self.topo_link_std_bw_res_pool1.yfilter != YFilter.not_set or
                                (self.topo_link_std_bw_detail is not None and self.topo_link_std_bw_detail.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "topology-link-bandwidth-standard" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.topo_link_std_bw_physical.is_set or self.topo_link_std_bw_physical.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.topo_link_std_bw_physical.get_name_leafdata())
                            if (self.topo_link_std_bw_res_max.is_set or self.topo_link_std_bw_res_max.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.topo_link_std_bw_res_max.get_name_leafdata())
                            if (self.topo_link_std_bw_res_pool0.is_set or self.topo_link_std_bw_res_pool0.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.topo_link_std_bw_res_pool0.get_name_leafdata())
                            if (self.topo_link_std_bw_res_pool1.is_set or self.topo_link_std_bw_res_pool1.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.topo_link_std_bw_res_pool1.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "topo-link-std-bw-detail"):
                                if (self.topo_link_std_bw_detail is None):
                                    self.topo_link_std_bw_detail = MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard.TopoLinkStdBwDetail()
                                    self.topo_link_std_bw_detail.parent = self
                                    self._children_name_map["topo_link_std_bw_detail"] = "topo-link-std-bw-detail"
                                return self.topo_link_std_bw_detail

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "topo-link-std-bw-detail" or name == "topo-link-std-bw-physical" or name == "topo-link-std-bw-res-max" or name == "topo-link-std-bw-res-pool0" or name == "topo-link-std-bw-res-pool1"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "topo-link-std-bw-physical"):
                                self.topo_link_std_bw_physical = value
                                self.topo_link_std_bw_physical.value_namespace = name_space
                                self.topo_link_std_bw_physical.value_namespace_prefix = name_space_prefix
                            if(value_path == "topo-link-std-bw-res-max"):
                                self.topo_link_std_bw_res_max = value
                                self.topo_link_std_bw_res_max.value_namespace = name_space
                                self.topo_link_std_bw_res_max.value_namespace_prefix = name_space_prefix
                            if(value_path == "topo-link-std-bw-res-pool0"):
                                self.topo_link_std_bw_res_pool0 = value
                                self.topo_link_std_bw_res_pool0.value_namespace = name_space
                                self.topo_link_std_bw_res_pool0.value_namespace_prefix = name_space_prefix
                            if(value_path == "topo-link-std-bw-res-pool1"):
                                self.topo_link_std_bw_res_pool1 = value
                                self.topo_link_std_bw_res_pool1.value_namespace = name_space
                                self.topo_link_std_bw_res_pool1.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        return (
                            self.bandwidth_migration_mode.is_set or
                            (self.topology_link_bandwidth_prestandard is not None and self.topology_link_bandwidth_prestandard.has_data()) or
                            (self.topology_link_bandwidth_standard is not None and self.topology_link_bandwidth_standard.has_data()))

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.bandwidth_migration_mode.yfilter != YFilter.not_set or
                            (self.topology_link_bandwidth_prestandard is not None and self.topology_link_bandwidth_prestandard.has_operation()) or
                            (self.topology_link_bandwidth_standard is not None and self.topology_link_bandwidth_standard.has_operation()))

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "topology-link-bandwidth" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.bandwidth_migration_mode.is_set or self.bandwidth_migration_mode.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.bandwidth_migration_mode.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "topology-link-bandwidth-prestandard"):
                            if (self.topology_link_bandwidth_prestandard is None):
                                self.topology_link_bandwidth_prestandard = MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthPrestandard()
                                self.topology_link_bandwidth_prestandard.parent = self
                                self._children_name_map["topology_link_bandwidth_prestandard"] = "topology-link-bandwidth-prestandard"
                            return self.topology_link_bandwidth_prestandard

                        if (child_yang_name == "topology-link-bandwidth-standard"):
                            if (self.topology_link_bandwidth_standard is None):
                                self.topology_link_bandwidth_standard = MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth.TopologyLinkBandwidthStandard()
                                self.topology_link_bandwidth_standard.parent = self
                                self._children_name_map["topology_link_bandwidth_standard"] = "topology-link-bandwidth-standard"
                            return self.topology_link_bandwidth_standard

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "topology-link-bandwidth-prestandard" or name == "topology-link-bandwidth-standard" or name == "bandwidth-migration-mode"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "bandwidth-migration-mode"):
                            self.bandwidth_migration_mode = value
                            self.bandwidth_migration_mode.value_namespace = name_space
                            self.bandwidth_migration_mode.value_namespace_prefix = name_space_prefix


                class OduLinkCapabilities(Entity):
                    """
                    ODU Link Capabilities
                    
                    .. attribute:: max_lsp_bandwidth
                    
                    	Max LSP Bandwidth per priority in kbit/s
                    	**type**\: list of    :py:class:`MaxLspBandwidth <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.MaxLspBandwidth>`
                    
                    .. attribute:: odu_capability
                    
                    	ODU Capabilities of Link
                    	**type**\: list of    :py:class:`OduCapability <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability>`
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities, self).__init__()

                        self.yang_name = "odu-link-capabilities"
                        self.yang_parent_name = "topology-node-link"

                        self.max_lsp_bandwidth = YList(self)
                        self.odu_capability = YList(self)

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in () and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities, self).__setattr__(name, value)


                    class MaxLspBandwidth(Entity):
                        """
                        Max LSP Bandwidth per priority in kbit/s
                        
                        .. attribute:: entry
                        
                        	
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.MaxLspBandwidth, self).__init__()

                            self.yang_name = "max-lsp-bandwidth"
                            self.yang_parent_name = "odu-link-capabilities"

                            self.entry = YLeaf(YType.uint32, "entry")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("entry") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.MaxLspBandwidth, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.MaxLspBandwidth, self).__setattr__(name, value)

                        def has_data(self):
                            return self.entry.is_set

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.entry.yfilter != YFilter.not_set)

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "max-lsp-bandwidth" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.entry.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "entry"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "entry"):
                                self.entry = value
                                self.entry.value_namespace = name_space
                                self.entry.value_namespace_prefix = name_space_prefix


                    class OduCapability(Entity):
                        """
                        ODU Capabilities of Link
                        
                        .. attribute:: bandwidth_info
                        
                        	Bandwidth related info for this ODU level
                        	**type**\:   :py:class:`BandwidthInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo>`
                        
                        .. attribute:: lcas_capable
                        
                        	True if link LCAS capable for this ODU level
                        	**type**\:  bool
                        
                        .. attribute:: signal_type
                        
                        	Signal Type
                        	**type**\:   :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                        
                        .. attribute:: stage1
                        
                        	ODU Type at stage 1, Not Set for HO ODU
                        	**type**\:   :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                        
                        .. attribute:: stage2
                        
                        	ODU Type at stage 2, Not Set for single stage mulitplexing
                        	**type**\:   :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                        
                        .. attribute:: stage3
                        
                        	ODU Type at stage 3, Not set up to two levels of multiplexing
                        	**type**\:   :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                        
                        .. attribute:: stage4
                        
                        	ODU Type at stage 4, Not set up to three levels of multiplexing
                        	**type**\:   :py:class:`TeOduLevel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduLevel>`
                        
                        .. attribute:: switchable
                        
                        	True if link is switchable for this ODU level
                        	**type**\:  bool
                        
                        .. attribute:: terminable
                        
                        	True if link is terminable for this ODU level
                        	**type**\:  bool
                        
                        .. attribute:: tsg1p25
                        
                        	True if link supports 1.25G TSG for this ODU level
                        	**type**\:  bool
                        
                        .. attribute:: tsg2p5
                        
                        	True if link supports 2.5G TSG for this ODU level
                        	**type**\:  bool
                        
                        .. attribute:: vcat_capable
                        
                        	True if link VCAT capable for this ODU level
                        	**type**\:  bool
                        
                        

                        """

                        _prefix = 'mpls-te-oper'
                        _revision = '2015-11-09'

                        def __init__(self):
                            super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability, self).__init__()

                            self.yang_name = "odu-capability"
                            self.yang_parent_name = "odu-link-capabilities"

                            self.lcas_capable = YLeaf(YType.boolean, "lcas-capable")

                            self.signal_type = YLeaf(YType.enumeration, "signal-type")

                            self.stage1 = YLeaf(YType.enumeration, "stage1")

                            self.stage2 = YLeaf(YType.enumeration, "stage2")

                            self.stage3 = YLeaf(YType.enumeration, "stage3")

                            self.stage4 = YLeaf(YType.enumeration, "stage4")

                            self.switchable = YLeaf(YType.boolean, "switchable")

                            self.terminable = YLeaf(YType.boolean, "terminable")

                            self.tsg1p25 = YLeaf(YType.boolean, "tsg1p25")

                            self.tsg2p5 = YLeaf(YType.boolean, "tsg2p5")

                            self.vcat_capable = YLeaf(YType.boolean, "vcat-capable")

                            self.bandwidth_info = MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo()
                            self.bandwidth_info.parent = self
                            self._children_name_map["bandwidth_info"] = "bandwidth-info"
                            self._children_yang_names.add("bandwidth-info")

                        def __setattr__(self, name, value):
                            self._check_monkey_patching_error(name, value)
                            with _handle_type_error():
                                if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                    raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                        "Please use list append or extend method."
                                                        .format(value))
                                if isinstance(value, Enum.YLeaf):
                                    value = value.name
                                if name in ("lcas_capable",
                                            "signal_type",
                                            "stage1",
                                            "stage2",
                                            "stage3",
                                            "stage4",
                                            "switchable",
                                            "terminable",
                                            "tsg1p25",
                                            "tsg2p5",
                                            "vcat_capable") and name in self.__dict__:
                                    if isinstance(value, YLeaf):
                                        self.__dict__[name].set(value.get())
                                    elif isinstance(value, YLeafList):
                                        super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability, self).__setattr__(name, value)
                                    else:
                                        self.__dict__[name].set(value)
                                else:
                                    if hasattr(value, "parent") and name != "parent":
                                        if hasattr(value, "is_presence_container") and value.is_presence_container:
                                            value.parent = self
                                        elif value.parent is None and value.yang_name in self._children_yang_names:
                                            value.parent = self
                                    super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability, self).__setattr__(name, value)


                        class BandwidthInfo(Entity):
                            """
                            Bandwidth related info for this ODU level
                            
                            .. attribute:: fixed
                            
                            	ODU capability for Fixed ODUs
                            	**type**\:   :py:class:`Fixed <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed>`
                            
                            .. attribute:: flex
                            
                            	ODU capability for Flex ODUs
                            	**type**\:   :py:class:`Flex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex>`
                            
                            .. attribute:: type
                            
                            	type
                            	**type**\:   :py:class:`TeOduCapability <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.TeOduCapability>`
                            
                            

                            """

                            _prefix = 'mpls-te-oper'
                            _revision = '2015-11-09'

                            def __init__(self):
                                super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo, self).__init__()

                                self.yang_name = "bandwidth-info"
                                self.yang_parent_name = "odu-capability"

                                self.type = YLeaf(YType.enumeration, "type")

                                self.fixed = MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed()
                                self.fixed.parent = self
                                self._children_name_map["fixed"] = "fixed"
                                self._children_yang_names.add("fixed")

                                self.flex = MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex()
                                self.flex.parent = self
                                self._children_name_map["flex"] = "flex"
                                self._children_yang_names.add("flex")

                            def __setattr__(self, name, value):
                                self._check_monkey_patching_error(name, value)
                                with _handle_type_error():
                                    if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                        raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                            "Please use list append or extend method."
                                                            .format(value))
                                    if isinstance(value, Enum.YLeaf):
                                        value = value.name
                                    if name in ("type") and name in self.__dict__:
                                        if isinstance(value, YLeaf):
                                            self.__dict__[name].set(value.get())
                                        elif isinstance(value, YLeafList):
                                            super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo, self).__setattr__(name, value)
                                        else:
                                            self.__dict__[name].set(value)
                                    else:
                                        if hasattr(value, "parent") and name != "parent":
                                            if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                value.parent = self
                                            elif value.parent is None and value.yang_name in self._children_yang_names:
                                                value.parent = self
                                        super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo, self).__setattr__(name, value)


                            class Fixed(Entity):
                                """
                                ODU capability for Fixed ODUs
                                
                                .. attribute:: maximum_od_us
                                
                                	Maximum Number of ODUs of this level possible on this link
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                .. attribute:: unreserved_od_us
                                
                                	Maximum Number of ODUs of this level possible on this link
                                	**type**\:  int
                                
                                	**range:** 0..255
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed, self).__init__()

                                    self.yang_name = "fixed"
                                    self.yang_parent_name = "bandwidth-info"

                                    self.maximum_od_us = YLeaf(YType.uint8, "maximum-od-us")

                                    self.unreserved_od_us = YLeaf(YType.uint8, "unreserved-od-us")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("maximum_od_us",
                                                    "unreserved_od_us") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.maximum_od_us.is_set or
                                        self.unreserved_od_us.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.maximum_od_us.yfilter != YFilter.not_set or
                                        self.unreserved_od_us.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "fixed" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.maximum_od_us.is_set or self.maximum_od_us.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.maximum_od_us.get_name_leafdata())
                                    if (self.unreserved_od_us.is_set or self.unreserved_od_us.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.unreserved_od_us.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "maximum-od-us" or name == "unreserved-od-us"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "maximum-od-us"):
                                        self.maximum_od_us = value
                                        self.maximum_od_us.value_namespace = name_space
                                        self.maximum_od_us.value_namespace_prefix = name_space_prefix
                                    if(value_path == "unreserved-od-us"):
                                        self.unreserved_od_us = value
                                        self.unreserved_od_us.value_namespace = name_space
                                        self.unreserved_od_us.value_namespace_prefix = name_space_prefix


                            class Flex(Entity):
                                """
                                ODU capability for Flex ODUs
                                
                                .. attribute:: max_bandwidth
                                
                                	Max kbps Bandwidth of this level possible on this link
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: max_lsp_bandwidth
                                
                                	Per LSP Max kbps Bandwidth of this level possible on this link
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                .. attribute:: unreserved_bandwidth
                                
                                	Unreserved kbps Bandwidth of this level possible on this link
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                	**units**\: kbit/s
                                
                                

                                """

                                _prefix = 'mpls-te-oper'
                                _revision = '2015-11-09'

                                def __init__(self):
                                    super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex, self).__init__()

                                    self.yang_name = "flex"
                                    self.yang_parent_name = "bandwidth-info"

                                    self.max_bandwidth = YLeaf(YType.uint32, "max-bandwidth")

                                    self.max_lsp_bandwidth = YLeaf(YType.uint32, "max-lsp-bandwidth")

                                    self.unreserved_bandwidth = YLeaf(YType.uint32, "unreserved-bandwidth")

                                def __setattr__(self, name, value):
                                    self._check_monkey_patching_error(name, value)
                                    with _handle_type_error():
                                        if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                            raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                                "Please use list append or extend method."
                                                                .format(value))
                                        if isinstance(value, Enum.YLeaf):
                                            value = value.name
                                        if name in ("max_bandwidth",
                                                    "max_lsp_bandwidth",
                                                    "unreserved_bandwidth") and name in self.__dict__:
                                            if isinstance(value, YLeaf):
                                                self.__dict__[name].set(value.get())
                                            elif isinstance(value, YLeafList):
                                                super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex, self).__setattr__(name, value)
                                            else:
                                                self.__dict__[name].set(value)
                                        else:
                                            if hasattr(value, "parent") and name != "parent":
                                                if hasattr(value, "is_presence_container") and value.is_presence_container:
                                                    value.parent = self
                                                elif value.parent is None and value.yang_name in self._children_yang_names:
                                                    value.parent = self
                                            super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex, self).__setattr__(name, value)

                                def has_data(self):
                                    return (
                                        self.max_bandwidth.is_set or
                                        self.max_lsp_bandwidth.is_set or
                                        self.unreserved_bandwidth.is_set)

                                def has_operation(self):
                                    return (
                                        self.yfilter != YFilter.not_set or
                                        self.max_bandwidth.yfilter != YFilter.not_set or
                                        self.max_lsp_bandwidth.yfilter != YFilter.not_set or
                                        self.unreserved_bandwidth.yfilter != YFilter.not_set)

                                def get_segment_path(self):
                                    path_buffer = ""
                                    path_buffer = "flex" + path_buffer

                                    return path_buffer

                                def get_entity_path(self, ancestor):
                                    path_buffer = ""
                                    if (ancestor is None):
                                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                    else:
                                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                    leaf_name_data = LeafDataList()
                                    if (self.max_bandwidth.is_set or self.max_bandwidth.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.max_bandwidth.get_name_leafdata())
                                    if (self.max_lsp_bandwidth.is_set or self.max_lsp_bandwidth.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.max_lsp_bandwidth.get_name_leafdata())
                                    if (self.unreserved_bandwidth.is_set or self.unreserved_bandwidth.yfilter != YFilter.not_set):
                                        leaf_name_data.append(self.unreserved_bandwidth.get_name_leafdata())

                                    entity_path = EntityPath(path_buffer, leaf_name_data)
                                    return entity_path

                                def get_child_by_name(self, child_yang_name, segment_path):
                                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                    if child is not None:
                                        return child

                                    return None

                                def has_leaf_or_child_of_name(self, name):
                                    if(name == "max-bandwidth" or name == "max-lsp-bandwidth" or name == "unreserved-bandwidth"):
                                        return True
                                    return False

                                def set_value(self, value_path, value, name_space, name_space_prefix):
                                    if(value_path == "max-bandwidth"):
                                        self.max_bandwidth = value
                                        self.max_bandwidth.value_namespace = name_space
                                        self.max_bandwidth.value_namespace_prefix = name_space_prefix
                                    if(value_path == "max-lsp-bandwidth"):
                                        self.max_lsp_bandwidth = value
                                        self.max_lsp_bandwidth.value_namespace = name_space
                                        self.max_lsp_bandwidth.value_namespace_prefix = name_space_prefix
                                    if(value_path == "unreserved-bandwidth"):
                                        self.unreserved_bandwidth = value
                                        self.unreserved_bandwidth.value_namespace = name_space
                                        self.unreserved_bandwidth.value_namespace_prefix = name_space_prefix

                            def has_data(self):
                                return (
                                    self.type.is_set or
                                    (self.fixed is not None and self.fixed.has_data()) or
                                    (self.flex is not None and self.flex.has_data()))

                            def has_operation(self):
                                return (
                                    self.yfilter != YFilter.not_set or
                                    self.type.yfilter != YFilter.not_set or
                                    (self.fixed is not None and self.fixed.has_operation()) or
                                    (self.flex is not None and self.flex.has_operation()))

                            def get_segment_path(self):
                                path_buffer = ""
                                path_buffer = "bandwidth-info" + path_buffer

                                return path_buffer

                            def get_entity_path(self, ancestor):
                                path_buffer = ""
                                if (ancestor is None):
                                    raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                                else:
                                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                                leaf_name_data = LeafDataList()
                                if (self.type.is_set or self.type.yfilter != YFilter.not_set):
                                    leaf_name_data.append(self.type.get_name_leafdata())

                                entity_path = EntityPath(path_buffer, leaf_name_data)
                                return entity_path

                            def get_child_by_name(self, child_yang_name, segment_path):
                                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                                if child is not None:
                                    return child

                                if (child_yang_name == "fixed"):
                                    if (self.fixed is None):
                                        self.fixed = MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Fixed()
                                        self.fixed.parent = self
                                        self._children_name_map["fixed"] = "fixed"
                                    return self.fixed

                                if (child_yang_name == "flex"):
                                    if (self.flex is None):
                                        self.flex = MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo.Flex()
                                        self.flex.parent = self
                                        self._children_name_map["flex"] = "flex"
                                    return self.flex

                                return None

                            def has_leaf_or_child_of_name(self, name):
                                if(name == "fixed" or name == "flex" or name == "type"):
                                    return True
                                return False

                            def set_value(self, value_path, value, name_space, name_space_prefix):
                                if(value_path == "type"):
                                    self.type = value
                                    self.type.value_namespace = name_space
                                    self.type.value_namespace_prefix = name_space_prefix

                        def has_data(self):
                            return (
                                self.lcas_capable.is_set or
                                self.signal_type.is_set or
                                self.stage1.is_set or
                                self.stage2.is_set or
                                self.stage3.is_set or
                                self.stage4.is_set or
                                self.switchable.is_set or
                                self.terminable.is_set or
                                self.tsg1p25.is_set or
                                self.tsg2p5.is_set or
                                self.vcat_capable.is_set or
                                (self.bandwidth_info is not None and self.bandwidth_info.has_data()))

                        def has_operation(self):
                            return (
                                self.yfilter != YFilter.not_set or
                                self.lcas_capable.yfilter != YFilter.not_set or
                                self.signal_type.yfilter != YFilter.not_set or
                                self.stage1.yfilter != YFilter.not_set or
                                self.stage2.yfilter != YFilter.not_set or
                                self.stage3.yfilter != YFilter.not_set or
                                self.stage4.yfilter != YFilter.not_set or
                                self.switchable.yfilter != YFilter.not_set or
                                self.terminable.yfilter != YFilter.not_set or
                                self.tsg1p25.yfilter != YFilter.not_set or
                                self.tsg2p5.yfilter != YFilter.not_set or
                                self.vcat_capable.yfilter != YFilter.not_set or
                                (self.bandwidth_info is not None and self.bandwidth_info.has_operation()))

                        def get_segment_path(self):
                            path_buffer = ""
                            path_buffer = "odu-capability" + path_buffer

                            return path_buffer

                        def get_entity_path(self, ancestor):
                            path_buffer = ""
                            if (ancestor is None):
                                raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                            else:
                                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                            leaf_name_data = LeafDataList()
                            if (self.lcas_capable.is_set or self.lcas_capable.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.lcas_capable.get_name_leafdata())
                            if (self.signal_type.is_set or self.signal_type.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.signal_type.get_name_leafdata())
                            if (self.stage1.is_set or self.stage1.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.stage1.get_name_leafdata())
                            if (self.stage2.is_set or self.stage2.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.stage2.get_name_leafdata())
                            if (self.stage3.is_set or self.stage3.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.stage3.get_name_leafdata())
                            if (self.stage4.is_set or self.stage4.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.stage4.get_name_leafdata())
                            if (self.switchable.is_set or self.switchable.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.switchable.get_name_leafdata())
                            if (self.terminable.is_set or self.terminable.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.terminable.get_name_leafdata())
                            if (self.tsg1p25.is_set or self.tsg1p25.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tsg1p25.get_name_leafdata())
                            if (self.tsg2p5.is_set or self.tsg2p5.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.tsg2p5.get_name_leafdata())
                            if (self.vcat_capable.is_set or self.vcat_capable.yfilter != YFilter.not_set):
                                leaf_name_data.append(self.vcat_capable.get_name_leafdata())

                            entity_path = EntityPath(path_buffer, leaf_name_data)
                            return entity_path

                        def get_child_by_name(self, child_yang_name, segment_path):
                            child = self._get_child_by_seg_name([child_yang_name, segment_path])
                            if child is not None:
                                return child

                            if (child_yang_name == "bandwidth-info"):
                                if (self.bandwidth_info is None):
                                    self.bandwidth_info = MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability.BandwidthInfo()
                                    self.bandwidth_info.parent = self
                                    self._children_name_map["bandwidth_info"] = "bandwidth-info"
                                return self.bandwidth_info

                            return None

                        def has_leaf_or_child_of_name(self, name):
                            if(name == "bandwidth-info" or name == "lcas-capable" or name == "signal-type" or name == "stage1" or name == "stage2" or name == "stage3" or name == "stage4" or name == "switchable" or name == "terminable" or name == "tsg1p25" or name == "tsg2p5" or name == "vcat-capable"):
                                return True
                            return False

                        def set_value(self, value_path, value, name_space, name_space_prefix):
                            if(value_path == "lcas-capable"):
                                self.lcas_capable = value
                                self.lcas_capable.value_namespace = name_space
                                self.lcas_capable.value_namespace_prefix = name_space_prefix
                            if(value_path == "signal-type"):
                                self.signal_type = value
                                self.signal_type.value_namespace = name_space
                                self.signal_type.value_namespace_prefix = name_space_prefix
                            if(value_path == "stage1"):
                                self.stage1 = value
                                self.stage1.value_namespace = name_space
                                self.stage1.value_namespace_prefix = name_space_prefix
                            if(value_path == "stage2"):
                                self.stage2 = value
                                self.stage2.value_namespace = name_space
                                self.stage2.value_namespace_prefix = name_space_prefix
                            if(value_path == "stage3"):
                                self.stage3 = value
                                self.stage3.value_namespace = name_space
                                self.stage3.value_namespace_prefix = name_space_prefix
                            if(value_path == "stage4"):
                                self.stage4 = value
                                self.stage4.value_namespace = name_space
                                self.stage4.value_namespace_prefix = name_space_prefix
                            if(value_path == "switchable"):
                                self.switchable = value
                                self.switchable.value_namespace = name_space
                                self.switchable.value_namespace_prefix = name_space_prefix
                            if(value_path == "terminable"):
                                self.terminable = value
                                self.terminable.value_namespace = name_space
                                self.terminable.value_namespace_prefix = name_space_prefix
                            if(value_path == "tsg1p25"):
                                self.tsg1p25 = value
                                self.tsg1p25.value_namespace = name_space
                                self.tsg1p25.value_namespace_prefix = name_space_prefix
                            if(value_path == "tsg2p5"):
                                self.tsg2p5 = value
                                self.tsg2p5.value_namespace = name_space
                                self.tsg2p5.value_namespace_prefix = name_space_prefix
                            if(value_path == "vcat-capable"):
                                self.vcat_capable = value
                                self.vcat_capable.value_namespace = name_space
                                self.vcat_capable.value_namespace_prefix = name_space_prefix

                    def has_data(self):
                        for c in self.max_lsp_bandwidth:
                            if (c.has_data()):
                                return True
                        for c in self.odu_capability:
                            if (c.has_data()):
                                return True
                        return False

                    def has_operation(self):
                        for c in self.max_lsp_bandwidth:
                            if (c.has_operation()):
                                return True
                        for c in self.odu_capability:
                            if (c.has_operation()):
                                return True
                        return self.yfilter != YFilter.not_set

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "odu-link-capabilities" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        if (child_yang_name == "max-lsp-bandwidth"):
                            for c in self.max_lsp_bandwidth:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.MaxLspBandwidth()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.max_lsp_bandwidth.append(c)
                            return c

                        if (child_yang_name == "odu-capability"):
                            for c in self.odu_capability:
                                segment = c.get_segment_path()
                                if (segment_path == segment):
                                    return c
                            c = MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities.OduCapability()
                            c.parent = self
                            local_reference_key = "ydk::seg::%s" % segment_path
                            self._local_refs[local_reference_key] = c
                            self.odu_capability.append(c)
                            return c

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "max-lsp-bandwidth" or name == "odu-capability"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        pass


                class TopologyLinkExtendedAffinityBit(Entity):
                    """
                    The link's affinity bits (colors)
                    
                    .. attribute:: entry
                    
                    	
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkExtendedAffinityBit, self).__init__()

                        self.yang_name = "topology-link-extended-affinity-bit"
                        self.yang_parent_name = "topology-node-link"

                        self.entry = YLeaf(YType.uint32, "entry")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("entry") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkExtendedAffinityBit, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkExtendedAffinityBit, self).__setattr__(name, value)

                    def has_data(self):
                        return self.entry.is_set

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.entry.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "topology-link-extended-affinity-bit" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.entry.is_set or self.entry.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.entry.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "entry"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "entry"):
                            self.entry = value
                            self.entry.value_namespace = name_space
                            self.entry.value_namespace_prefix = name_space_prefix


                class SharedRiskLinkGroup(Entity):
                    """
                    The link's shared risk link groups
                    
                    .. attribute:: shared_risk_group
                    
                    	SRLG number
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: srlg_name
                    
                    	SRLG name
                    	**type**\:  str
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.SharedRiskLinkGroup, self).__init__()

                        self.yang_name = "shared-risk-link-group"
                        self.yang_parent_name = "topology-node-link"

                        self.shared_risk_group = YLeaf(YType.uint32, "shared-risk-group")

                        self.srlg_name = YLeaf(YType.str, "srlg-name")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("shared_risk_group",
                                        "srlg_name") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.SharedRiskLinkGroup, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.SharedRiskLinkGroup, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.shared_risk_group.is_set or
                            self.srlg_name.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.shared_risk_group.yfilter != YFilter.not_set or
                            self.srlg_name.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "shared-risk-link-group" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.shared_risk_group.is_set or self.shared_risk_group.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.shared_risk_group.get_name_leafdata())
                        if (self.srlg_name.is_set or self.srlg_name.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.srlg_name.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "shared-risk-group" or name == "srlg-name"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "shared-risk-group"):
                            self.shared_risk_group = value
                            self.shared_risk_group.value_namespace = name_space
                            self.shared_risk_group.value_namespace_prefix = name_space_prefix
                        if(value_path == "srlg-name"):
                            self.srlg_name = value
                            self.srlg_name.value_namespace = name_space
                            self.srlg_name.value_namespace_prefix = name_space_prefix


                class AdjacencySid(Entity):
                    """
                    Adjacency SIDs assigned for adjacency nodes
                    
                    .. attribute:: adjacency_sid
                    
                    	The adjacency SID assigned for the topology node
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: flag_b
                    
                    	IGP Flag B
                    	**type**\:  bool
                    
                    .. attribute:: flag_f
                    
                    	IGP Flag F
                    	**type**\:  bool
                    
                    .. attribute:: flag_l
                    
                    	IGP Flag L
                    	**type**\:  bool
                    
                    .. attribute:: flag_s
                    
                    	IGP Flag S
                    	**type**\:  bool
                    
                    .. attribute:: flag_v
                    
                    	IGP Flag V
                    	**type**\:  bool
                    
                    .. attribute:: link_type
                    
                    	Link Type
                    	**type**\:   :py:class:`IgpSubnet <ydk.models.cisco_ios_xr.Cisco_IOS_XR_mpls_te_oper.IgpSubnet>`
                    
                    .. attribute:: local_addr
                    
                    	Local Address
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: nbr_node_igpid
                    
                    	The neighbor node's IGP ID
                    	**type**\:  str
                    
                    .. attribute:: nbr_node_te_router_id
                    
                    	The neigbor node's TE router\-id
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    .. attribute:: remote_addr
                    
                    	Remote Address
                    	**type**\:  str
                    
                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                    
                    

                    """

                    _prefix = 'mpls-te-oper'
                    _revision = '2015-11-09'

                    def __init__(self):
                        super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.AdjacencySid, self).__init__()

                        self.yang_name = "adjacency-sid"
                        self.yang_parent_name = "topology-node-link"

                        self.adjacency_sid = YLeaf(YType.uint32, "adjacency-sid")

                        self.flag_b = YLeaf(YType.boolean, "flag-b")

                        self.flag_f = YLeaf(YType.boolean, "flag-f")

                        self.flag_l = YLeaf(YType.boolean, "flag-l")

                        self.flag_s = YLeaf(YType.boolean, "flag-s")

                        self.flag_v = YLeaf(YType.boolean, "flag-v")

                        self.link_type = YLeaf(YType.enumeration, "link-type")

                        self.local_addr = YLeaf(YType.str, "local-addr")

                        self.nbr_node_igpid = YLeaf(YType.str, "nbr-node-igpid")

                        self.nbr_node_te_router_id = YLeaf(YType.str, "nbr-node-te-router-id")

                        self.remote_addr = YLeaf(YType.str, "remote-addr")

                    def __setattr__(self, name, value):
                        self._check_monkey_patching_error(name, value)
                        with _handle_type_error():
                            if name in self.__dict__ and isinstance(self.__dict__[name], YList):
                                raise YPYModelError("Attempt to assign value of '{}' to YList ldata. "
                                                    "Please use list append or extend method."
                                                    .format(value))
                            if isinstance(value, Enum.YLeaf):
                                value = value.name
                            if name in ("adjacency_sid",
                                        "flag_b",
                                        "flag_f",
                                        "flag_l",
                                        "flag_s",
                                        "flag_v",
                                        "link_type",
                                        "local_addr",
                                        "nbr_node_igpid",
                                        "nbr_node_te_router_id",
                                        "remote_addr") and name in self.__dict__:
                                if isinstance(value, YLeaf):
                                    self.__dict__[name].set(value.get())
                                elif isinstance(value, YLeafList):
                                    super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.AdjacencySid, self).__setattr__(name, value)
                                else:
                                    self.__dict__[name].set(value)
                            else:
                                if hasattr(value, "parent") and name != "parent":
                                    if hasattr(value, "is_presence_container") and value.is_presence_container:
                                        value.parent = self
                                    elif value.parent is None and value.yang_name in self._children_yang_names:
                                        value.parent = self
                                super(MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.AdjacencySid, self).__setattr__(name, value)

                    def has_data(self):
                        return (
                            self.adjacency_sid.is_set or
                            self.flag_b.is_set or
                            self.flag_f.is_set or
                            self.flag_l.is_set or
                            self.flag_s.is_set or
                            self.flag_v.is_set or
                            self.link_type.is_set or
                            self.local_addr.is_set or
                            self.nbr_node_igpid.is_set or
                            self.nbr_node_te_router_id.is_set or
                            self.remote_addr.is_set)

                    def has_operation(self):
                        return (
                            self.yfilter != YFilter.not_set or
                            self.adjacency_sid.yfilter != YFilter.not_set or
                            self.flag_b.yfilter != YFilter.not_set or
                            self.flag_f.yfilter != YFilter.not_set or
                            self.flag_l.yfilter != YFilter.not_set or
                            self.flag_s.yfilter != YFilter.not_set or
                            self.flag_v.yfilter != YFilter.not_set or
                            self.link_type.yfilter != YFilter.not_set or
                            self.local_addr.yfilter != YFilter.not_set or
                            self.nbr_node_igpid.yfilter != YFilter.not_set or
                            self.nbr_node_te_router_id.yfilter != YFilter.not_set or
                            self.remote_addr.yfilter != YFilter.not_set)

                    def get_segment_path(self):
                        path_buffer = ""
                        path_buffer = "adjacency-sid" + path_buffer

                        return path_buffer

                    def get_entity_path(self, ancestor):
                        path_buffer = ""
                        if (ancestor is None):
                            raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                        else:
                            path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                        leaf_name_data = LeafDataList()
                        if (self.adjacency_sid.is_set or self.adjacency_sid.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.adjacency_sid.get_name_leafdata())
                        if (self.flag_b.is_set or self.flag_b.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.flag_b.get_name_leafdata())
                        if (self.flag_f.is_set or self.flag_f.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.flag_f.get_name_leafdata())
                        if (self.flag_l.is_set or self.flag_l.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.flag_l.get_name_leafdata())
                        if (self.flag_s.is_set or self.flag_s.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.flag_s.get_name_leafdata())
                        if (self.flag_v.is_set or self.flag_v.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.flag_v.get_name_leafdata())
                        if (self.link_type.is_set or self.link_type.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.link_type.get_name_leafdata())
                        if (self.local_addr.is_set or self.local_addr.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.local_addr.get_name_leafdata())
                        if (self.nbr_node_igpid.is_set or self.nbr_node_igpid.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nbr_node_igpid.get_name_leafdata())
                        if (self.nbr_node_te_router_id.is_set or self.nbr_node_te_router_id.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.nbr_node_te_router_id.get_name_leafdata())
                        if (self.remote_addr.is_set or self.remote_addr.yfilter != YFilter.not_set):
                            leaf_name_data.append(self.remote_addr.get_name_leafdata())

                        entity_path = EntityPath(path_buffer, leaf_name_data)
                        return entity_path

                    def get_child_by_name(self, child_yang_name, segment_path):
                        child = self._get_child_by_seg_name([child_yang_name, segment_path])
                        if child is not None:
                            return child

                        return None

                    def has_leaf_or_child_of_name(self, name):
                        if(name == "adjacency-sid" or name == "flag-b" or name == "flag-f" or name == "flag-l" or name == "flag-s" or name == "flag-v" or name == "link-type" or name == "local-addr" or name == "nbr-node-igpid" or name == "nbr-node-te-router-id" or name == "remote-addr"):
                            return True
                        return False

                    def set_value(self, value_path, value, name_space, name_space_prefix):
                        if(value_path == "adjacency-sid"):
                            self.adjacency_sid = value
                            self.adjacency_sid.value_namespace = name_space
                            self.adjacency_sid.value_namespace_prefix = name_space_prefix
                        if(value_path == "flag-b"):
                            self.flag_b = value
                            self.flag_b.value_namespace = name_space
                            self.flag_b.value_namespace_prefix = name_space_prefix
                        if(value_path == "flag-f"):
                            self.flag_f = value
                            self.flag_f.value_namespace = name_space
                            self.flag_f.value_namespace_prefix = name_space_prefix
                        if(value_path == "flag-l"):
                            self.flag_l = value
                            self.flag_l.value_namespace = name_space
                            self.flag_l.value_namespace_prefix = name_space_prefix
                        if(value_path == "flag-s"):
                            self.flag_s = value
                            self.flag_s.value_namespace = name_space
                            self.flag_s.value_namespace_prefix = name_space_prefix
                        if(value_path == "flag-v"):
                            self.flag_v = value
                            self.flag_v.value_namespace = name_space
                            self.flag_v.value_namespace_prefix = name_space_prefix
                        if(value_path == "link-type"):
                            self.link_type = value
                            self.link_type.value_namespace = name_space
                            self.link_type.value_namespace_prefix = name_space_prefix
                        if(value_path == "local-addr"):
                            self.local_addr = value
                            self.local_addr.value_namespace = name_space
                            self.local_addr.value_namespace_prefix = name_space_prefix
                        if(value_path == "nbr-node-igpid"):
                            self.nbr_node_igpid = value
                            self.nbr_node_igpid.value_namespace = name_space
                            self.nbr_node_igpid.value_namespace_prefix = name_space_prefix
                        if(value_path == "nbr-node-te-router-id"):
                            self.nbr_node_te_router_id = value
                            self.nbr_node_te_router_id.value_namespace = name_space
                            self.nbr_node_te_router_id.value_namespace_prefix = name_space_prefix
                        if(value_path == "remote-addr"):
                            self.remote_addr = value
                            self.remote_addr.value_namespace = name_space
                            self.remote_addr.value_namespace_prefix = name_space_prefix

                def has_data(self):
                    for c in self.adjacency_sid:
                        if (c.has_data()):
                            return True
                    for c in self.shared_risk_link_group:
                        if (c.has_data()):
                            return True
                    for c in self.topology_link_extended_affinity_bit:
                        if (c.has_data()):
                            return True
                    return (
                        self.topology_link_affinity_bits.is_set or
                        self.topology_link_bandwidth_model.is_set or
                        self.topology_link_encoding.is_set or
                        self.topology_link_fragment_id.is_set or
                        self.topology_link_igp_metric.is_set or
                        self.topology_link_interface_address.is_set or
                        self.topology_link_interface_id.is_set or
                        self.topology_link_neighbor_address.is_set or
                        self.topology_link_neighbor_generation.is_set or
                        self.topology_link_neighbor_id.is_set or
                        self.topology_link_neighbor_node_id.is_set or
                        self.topology_link_neighbor_system_id.is_set or
                        self.topology_link_switching_capability.is_set or
                        self.topology_link_te_metric.is_set or
                        self.topology_link_type.is_set or
                        self.topology_link_uni_delay.is_set or
                        (self.odu_link_capabilities is not None and self.odu_link_capabilities.has_data()) or
                        (self.topology_link_bandwidth is not None and self.topology_link_bandwidth.has_data()))

                def has_operation(self):
                    for c in self.adjacency_sid:
                        if (c.has_operation()):
                            return True
                    for c in self.shared_risk_link_group:
                        if (c.has_operation()):
                            return True
                    for c in self.topology_link_extended_affinity_bit:
                        if (c.has_operation()):
                            return True
                    return (
                        self.yfilter != YFilter.not_set or
                        self.topology_link_affinity_bits.yfilter != YFilter.not_set or
                        self.topology_link_bandwidth_model.yfilter != YFilter.not_set or
                        self.topology_link_encoding.yfilter != YFilter.not_set or
                        self.topology_link_fragment_id.yfilter != YFilter.not_set or
                        self.topology_link_igp_metric.yfilter != YFilter.not_set or
                        self.topology_link_interface_address.yfilter != YFilter.not_set or
                        self.topology_link_interface_id.yfilter != YFilter.not_set or
                        self.topology_link_neighbor_address.yfilter != YFilter.not_set or
                        self.topology_link_neighbor_generation.yfilter != YFilter.not_set or
                        self.topology_link_neighbor_id.yfilter != YFilter.not_set or
                        self.topology_link_neighbor_node_id.yfilter != YFilter.not_set or
                        self.topology_link_neighbor_system_id.yfilter != YFilter.not_set or
                        self.topology_link_switching_capability.yfilter != YFilter.not_set or
                        self.topology_link_te_metric.yfilter != YFilter.not_set or
                        self.topology_link_type.yfilter != YFilter.not_set or
                        self.topology_link_uni_delay.yfilter != YFilter.not_set or
                        (self.odu_link_capabilities is not None and self.odu_link_capabilities.has_operation()) or
                        (self.topology_link_bandwidth is not None and self.topology_link_bandwidth.has_operation()))

                def get_segment_path(self):
                    path_buffer = ""
                    path_buffer = "topology-node-link" + path_buffer

                    return path_buffer

                def get_entity_path(self, ancestor):
                    path_buffer = ""
                    if (ancestor is None):
                        raise YPYModelError("ancestor cannot be None as one of the ancestors is a list")
                    else:
                        path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                    leaf_name_data = LeafDataList()
                    if (self.topology_link_affinity_bits.is_set or self.topology_link_affinity_bits.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.topology_link_affinity_bits.get_name_leafdata())
                    if (self.topology_link_bandwidth_model.is_set or self.topology_link_bandwidth_model.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.topology_link_bandwidth_model.get_name_leafdata())
                    if (self.topology_link_encoding.is_set or self.topology_link_encoding.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.topology_link_encoding.get_name_leafdata())
                    if (self.topology_link_fragment_id.is_set or self.topology_link_fragment_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.topology_link_fragment_id.get_name_leafdata())
                    if (self.topology_link_igp_metric.is_set or self.topology_link_igp_metric.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.topology_link_igp_metric.get_name_leafdata())
                    if (self.topology_link_interface_address.is_set or self.topology_link_interface_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.topology_link_interface_address.get_name_leafdata())
                    if (self.topology_link_interface_id.is_set or self.topology_link_interface_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.topology_link_interface_id.get_name_leafdata())
                    if (self.topology_link_neighbor_address.is_set or self.topology_link_neighbor_address.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.topology_link_neighbor_address.get_name_leafdata())
                    if (self.topology_link_neighbor_generation.is_set or self.topology_link_neighbor_generation.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.topology_link_neighbor_generation.get_name_leafdata())
                    if (self.topology_link_neighbor_id.is_set or self.topology_link_neighbor_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.topology_link_neighbor_id.get_name_leafdata())
                    if (self.topology_link_neighbor_node_id.is_set or self.topology_link_neighbor_node_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.topology_link_neighbor_node_id.get_name_leafdata())
                    if (self.topology_link_neighbor_system_id.is_set or self.topology_link_neighbor_system_id.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.topology_link_neighbor_system_id.get_name_leafdata())
                    if (self.topology_link_switching_capability.is_set or self.topology_link_switching_capability.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.topology_link_switching_capability.get_name_leafdata())
                    if (self.topology_link_te_metric.is_set or self.topology_link_te_metric.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.topology_link_te_metric.get_name_leafdata())
                    if (self.topology_link_type.is_set or self.topology_link_type.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.topology_link_type.get_name_leafdata())
                    if (self.topology_link_uni_delay.is_set or self.topology_link_uni_delay.yfilter != YFilter.not_set):
                        leaf_name_data.append(self.topology_link_uni_delay.get_name_leafdata())

                    entity_path = EntityPath(path_buffer, leaf_name_data)
                    return entity_path

                def get_child_by_name(self, child_yang_name, segment_path):
                    child = self._get_child_by_seg_name([child_yang_name, segment_path])
                    if child is not None:
                        return child

                    if (child_yang_name == "adjacency-sid"):
                        for c in self.adjacency_sid:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.AdjacencySid()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.adjacency_sid.append(c)
                        return c

                    if (child_yang_name == "odu-link-capabilities"):
                        if (self.odu_link_capabilities is None):
                            self.odu_link_capabilities = MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.OduLinkCapabilities()
                            self.odu_link_capabilities.parent = self
                            self._children_name_map["odu_link_capabilities"] = "odu-link-capabilities"
                        return self.odu_link_capabilities

                    if (child_yang_name == "shared-risk-link-group"):
                        for c in self.shared_risk_link_group:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.SharedRiskLinkGroup()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.shared_risk_link_group.append(c)
                        return c

                    if (child_yang_name == "topology-link-bandwidth"):
                        if (self.topology_link_bandwidth is None):
                            self.topology_link_bandwidth = MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkBandwidth()
                            self.topology_link_bandwidth.parent = self
                            self._children_name_map["topology_link_bandwidth"] = "topology-link-bandwidth"
                        return self.topology_link_bandwidth

                    if (child_yang_name == "topology-link-extended-affinity-bit"):
                        for c in self.topology_link_extended_affinity_bit:
                            segment = c.get_segment_path()
                            if (segment_path == segment):
                                return c
                        c = MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink.TopologyLinkExtendedAffinityBit()
                        c.parent = self
                        local_reference_key = "ydk::seg::%s" % segment_path
                        self._local_refs[local_reference_key] = c
                        self.topology_link_extended_affinity_bit.append(c)
                        return c

                    return None

                def has_leaf_or_child_of_name(self, name):
                    if(name == "adjacency-sid" or name == "odu-link-capabilities" or name == "shared-risk-link-group" or name == "topology-link-bandwidth" or name == "topology-link-extended-affinity-bit" or name == "topology-link-affinity-bits" or name == "topology-link-bandwidth-model" or name == "topology-link-encoding" or name == "topology-link-fragment-id" or name == "topology-link-igp-metric" or name == "topology-link-interface-address" or name == "topology-link-interface-id" or name == "topology-link-neighbor-address" or name == "topology-link-neighbor-generation" or name == "topology-link-neighbor-id" or name == "topology-link-neighbor-node-id" or name == "topology-link-neighbor-system-id" or name == "topology-link-switching-capability" or name == "topology-link-te-metric" or name == "topology-link-type" or name == "topology-link-uni-delay"):
                        return True
                    return False

                def set_value(self, value_path, value, name_space, name_space_prefix):
                    if(value_path == "topology-link-affinity-bits"):
                        self.topology_link_affinity_bits = value
                        self.topology_link_affinity_bits.value_namespace = name_space
                        self.topology_link_affinity_bits.value_namespace_prefix = name_space_prefix
                    if(value_path == "topology-link-bandwidth-model"):
                        self.topology_link_bandwidth_model = value
                        self.topology_link_bandwidth_model.value_namespace = name_space
                        self.topology_link_bandwidth_model.value_namespace_prefix = name_space_prefix
                    if(value_path == "topology-link-encoding"):
                        self.topology_link_encoding = value
                        self.topology_link_encoding.value_namespace = name_space
                        self.topology_link_encoding.value_namespace_prefix = name_space_prefix
                    if(value_path == "topology-link-fragment-id"):
                        self.topology_link_fragment_id = value
                        self.topology_link_fragment_id.value_namespace = name_space
                        self.topology_link_fragment_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "topology-link-igp-metric"):
                        self.topology_link_igp_metric = value
                        self.topology_link_igp_metric.value_namespace = name_space
                        self.topology_link_igp_metric.value_namespace_prefix = name_space_prefix
                    if(value_path == "topology-link-interface-address"):
                        self.topology_link_interface_address = value
                        self.topology_link_interface_address.value_namespace = name_space
                        self.topology_link_interface_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "topology-link-interface-id"):
                        self.topology_link_interface_id = value
                        self.topology_link_interface_id.value_namespace = name_space
                        self.topology_link_interface_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "topology-link-neighbor-address"):
                        self.topology_link_neighbor_address = value
                        self.topology_link_neighbor_address.value_namespace = name_space
                        self.topology_link_neighbor_address.value_namespace_prefix = name_space_prefix
                    if(value_path == "topology-link-neighbor-generation"):
                        self.topology_link_neighbor_generation = value
                        self.topology_link_neighbor_generation.value_namespace = name_space
                        self.topology_link_neighbor_generation.value_namespace_prefix = name_space_prefix
                    if(value_path == "topology-link-neighbor-id"):
                        self.topology_link_neighbor_id = value
                        self.topology_link_neighbor_id.value_namespace = name_space
                        self.topology_link_neighbor_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "topology-link-neighbor-node-id"):
                        self.topology_link_neighbor_node_id = value
                        self.topology_link_neighbor_node_id.value_namespace = name_space
                        self.topology_link_neighbor_node_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "topology-link-neighbor-system-id"):
                        self.topology_link_neighbor_system_id = value
                        self.topology_link_neighbor_system_id.value_namespace = name_space
                        self.topology_link_neighbor_system_id.value_namespace_prefix = name_space_prefix
                    if(value_path == "topology-link-switching-capability"):
                        self.topology_link_switching_capability = value
                        self.topology_link_switching_capability.value_namespace = name_space
                        self.topology_link_switching_capability.value_namespace_prefix = name_space_prefix
                    if(value_path == "topology-link-te-metric"):
                        self.topology_link_te_metric = value
                        self.topology_link_te_metric.value_namespace = name_space
                        self.topology_link_te_metric.value_namespace_prefix = name_space_prefix
                    if(value_path == "topology-link-type"):
                        self.topology_link_type = value
                        self.topology_link_type.value_namespace = name_space
                        self.topology_link_type.value_namespace_prefix = name_space_prefix
                    if(value_path == "topology-link-uni-delay"):
                        self.topology_link_uni_delay = value
                        self.topology_link_uni_delay.value_namespace = name_space
                        self.topology_link_uni_delay.value_namespace_prefix = name_space_prefix

            def has_data(self):
                for c in self.topology_node_link:
                    if (c.has_data()):
                        return True
                return (
                    self.protocol.is_set or
                    self.igp_id.is_set or
                    self.area.is_set or
                    self.topology_node_type.is_set or
                    self.igp_node_id.is_set or
                    self.topology_node_overloaded.is_set or
                    self.topology_node_te_router_id.is_set or
                    (self.topology_node_sid_and_srbg is not None and self.topology_node_sid_and_srbg.has_data()))

            def has_operation(self):
                for c in self.topology_node_link:
                    if (c.has_operation()):
                        return True
                return (
                    self.yfilter != YFilter.not_set or
                    self.protocol.yfilter != YFilter.not_set or
                    self.igp_id.yfilter != YFilter.not_set or
                    self.area.yfilter != YFilter.not_set or
                    self.topology_node_type.yfilter != YFilter.not_set or
                    self.igp_node_id.yfilter != YFilter.not_set or
                    self.topology_node_overloaded.yfilter != YFilter.not_set or
                    self.topology_node_te_router_id.yfilter != YFilter.not_set or
                    (self.topology_node_sid_and_srbg is not None and self.topology_node_sid_and_srbg.has_operation()))

            def get_segment_path(self):
                path_buffer = ""
                path_buffer = "topology-brief" + "[protocol='" + self.protocol.get() + "']" + "[igp-id='" + self.igp_id.get() + "']" + "[area='" + self.area.get() + "']" + "[topology-node-type='" + self.topology_node_type.get() + "']" + "[igp-node-id='" + self.igp_node_id.get() + "']" + path_buffer

                return path_buffer

            def get_entity_path(self, ancestor):
                path_buffer = ""
                if (ancestor is None):
                    path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/topology-briefs/%s" % self.get_segment_path()
                else:
                    path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

                leaf_name_data = LeafDataList()
                if (self.protocol.is_set or self.protocol.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.protocol.get_name_leafdata())
                if (self.igp_id.is_set or self.igp_id.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.igp_id.get_name_leafdata())
                if (self.area.is_set or self.area.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.area.get_name_leafdata())
                if (self.topology_node_type.is_set or self.topology_node_type.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.topology_node_type.get_name_leafdata())
                if (self.igp_node_id.is_set or self.igp_node_id.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.igp_node_id.get_name_leafdata())
                if (self.topology_node_overloaded.is_set or self.topology_node_overloaded.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.topology_node_overloaded.get_name_leafdata())
                if (self.topology_node_te_router_id.is_set or self.topology_node_te_router_id.yfilter != YFilter.not_set):
                    leaf_name_data.append(self.topology_node_te_router_id.get_name_leafdata())

                entity_path = EntityPath(path_buffer, leaf_name_data)
                return entity_path

            def get_child_by_name(self, child_yang_name, segment_path):
                child = self._get_child_by_seg_name([child_yang_name, segment_path])
                if child is not None:
                    return child

                if (child_yang_name == "topology-node-link"):
                    for c in self.topology_node_link:
                        segment = c.get_segment_path()
                        if (segment_path == segment):
                            return c
                    c = MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeLink()
                    c.parent = self
                    local_reference_key = "ydk::seg::%s" % segment_path
                    self._local_refs[local_reference_key] = c
                    self.topology_node_link.append(c)
                    return c

                if (child_yang_name == "topology-node-sid-and-srbg"):
                    if (self.topology_node_sid_and_srbg is None):
                        self.topology_node_sid_and_srbg = MplsTeStandby.TopologyBriefs.TopologyBrief.TopologyNodeSidAndSrbg()
                        self.topology_node_sid_and_srbg.parent = self
                        self._children_name_map["topology_node_sid_and_srbg"] = "topology-node-sid-and-srbg"
                    return self.topology_node_sid_and_srbg

                return None

            def has_leaf_or_child_of_name(self, name):
                if(name == "topology-node-link" or name == "topology-node-sid-and-srbg" or name == "protocol" or name == "igp-id" or name == "area" or name == "topology-node-type" or name == "igp-node-id" or name == "topology-node-overloaded" or name == "topology-node-te-router-id"):
                    return True
                return False

            def set_value(self, value_path, value, name_space, name_space_prefix):
                if(value_path == "protocol"):
                    self.protocol = value
                    self.protocol.value_namespace = name_space
                    self.protocol.value_namespace_prefix = name_space_prefix
                if(value_path == "igp-id"):
                    self.igp_id = value
                    self.igp_id.value_namespace = name_space
                    self.igp_id.value_namespace_prefix = name_space_prefix
                if(value_path == "area"):
                    self.area = value
                    self.area.value_namespace = name_space
                    self.area.value_namespace_prefix = name_space_prefix
                if(value_path == "topology-node-type"):
                    self.topology_node_type = value
                    self.topology_node_type.value_namespace = name_space
                    self.topology_node_type.value_namespace_prefix = name_space_prefix
                if(value_path == "igp-node-id"):
                    self.igp_node_id = value
                    self.igp_node_id.value_namespace = name_space
                    self.igp_node_id.value_namespace_prefix = name_space_prefix
                if(value_path == "topology-node-overloaded"):
                    self.topology_node_overloaded = value
                    self.topology_node_overloaded.value_namespace = name_space
                    self.topology_node_overloaded.value_namespace_prefix = name_space_prefix
                if(value_path == "topology-node-te-router-id"):
                    self.topology_node_te_router_id = value
                    self.topology_node_te_router_id.value_namespace = name_space
                    self.topology_node_te_router_id.value_namespace_prefix = name_space_prefix

        def has_data(self):
            for c in self.topology_brief:
                if (c.has_data()):
                    return True
            return False

        def has_operation(self):
            for c in self.topology_brief:
                if (c.has_operation()):
                    return True
            return self.yfilter != YFilter.not_set

        def get_segment_path(self):
            path_buffer = ""
            path_buffer = "topology-briefs" + path_buffer

            return path_buffer

        def get_entity_path(self, ancestor):
            path_buffer = ""
            if (ancestor is None):
                path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby/%s" % self.get_segment_path()
            else:
                path_buffer = _get_relative_entity_path(self, ancestor, path_buffer)

            leaf_name_data = LeafDataList()

            entity_path = EntityPath(path_buffer, leaf_name_data)
            return entity_path

        def get_child_by_name(self, child_yang_name, segment_path):
            child = self._get_child_by_seg_name([child_yang_name, segment_path])
            if child is not None:
                return child

            if (child_yang_name == "topology-brief"):
                for c in self.topology_brief:
                    segment = c.get_segment_path()
                    if (segment_path == segment):
                        return c
                c = MplsTeStandby.TopologyBriefs.TopologyBrief()
                c.parent = self
                local_reference_key = "ydk::seg::%s" % segment_path
                self._local_refs[local_reference_key] = c
                self.topology_brief.append(c)
                return c

            return None

        def has_leaf_or_child_of_name(self, name):
            if(name == "topology-brief"):
                return True
            return False

        def set_value(self, value_path, value, name_space, name_space_prefix):
            pass

    def has_data(self):
        return (
            (self.affinity_map is not None and self.affinity_map.has_data()) or
            (self.announce_tunnels_info is not None and self.announce_tunnels_info.has_data()) or
            (self.attribute_sets is not None and self.attribute_sets.has_data()) or
            (self.auto_tunnel is not None and self.auto_tunnel.has_data()) or
            (self.auto_tunnel_services is not None and self.auto_tunnel_services.has_data()) or
            (self.bfd is not None and self.bfd.has_data()) or
            (self.collaborator_timers is not None and self.collaborator_timers.has_data()) or
            (self.diff_serv_te_classes is not None and self.diff_serv_te_classes.has_data()) or
            (self.fast_reroute is not None and self.fast_reroute.has_data()) or
            (self.fib_next_hop_label_routes is not None and self.fib_next_hop_label_routes.has_data()) or
            (self.forwarding_adjacency_destinations is not None and self.forwarding_adjacency_destinations.has_data()) or
            (self.hardware_out_of_resources is not None and self.hardware_out_of_resources.has_data()) or
            (self.igp_area_briefs is not None and self.igp_area_briefs.has_data()) or
            (self.igp_areas is not None and self.igp_areas.has_data()) or
            (self.issu is not None and self.issu.has_data()) or
            (self.lsp_out_of_resources is not None and self.lsp_out_of_resources.has_data()) or
            (self.maximum_tunnels is not None and self.maximum_tunnels.has_data()) or
            (self.nsr is not None and self.nsr.has_data()) or
            (self.open_config is not None and self.open_config.has_data()) or
            (self.p2mp is not None and self.p2mp.has_data()) or
            (self.p2p_p2mp_tunnel is not None and self.p2p_p2mp_tunnel.has_data()) or
            (self.path_protection is not None and self.path_protection.has_data()) or
            (self.signalling_counters is not None and self.signalling_counters.has_data()) or
            (self.soft_preemption is not None and self.soft_preemption.has_data()) or
            (self.topology is not None and self.topology.has_data()) or
            (self.topology_briefs is not None and self.topology_briefs.has_data()) or
            (self.topology_nodes is not None and self.topology_nodes.has_data()) or
            (self.tunnels is not None and self.tunnels.has_data()) or
            (self.wrap_protection is not None and self.wrap_protection.has_data()))

    def has_operation(self):
        return (
            self.yfilter != YFilter.not_set or
            (self.affinity_map is not None and self.affinity_map.has_operation()) or
            (self.announce_tunnels_info is not None and self.announce_tunnels_info.has_operation()) or
            (self.attribute_sets is not None and self.attribute_sets.has_operation()) or
            (self.auto_tunnel is not None and self.auto_tunnel.has_operation()) or
            (self.auto_tunnel_services is not None and self.auto_tunnel_services.has_operation()) or
            (self.bfd is not None and self.bfd.has_operation()) or
            (self.collaborator_timers is not None and self.collaborator_timers.has_operation()) or
            (self.diff_serv_te_classes is not None and self.diff_serv_te_classes.has_operation()) or
            (self.fast_reroute is not None and self.fast_reroute.has_operation()) or
            (self.fib_next_hop_label_routes is not None and self.fib_next_hop_label_routes.has_operation()) or
            (self.forwarding_adjacency_destinations is not None and self.forwarding_adjacency_destinations.has_operation()) or
            (self.hardware_out_of_resources is not None and self.hardware_out_of_resources.has_operation()) or
            (self.igp_area_briefs is not None and self.igp_area_briefs.has_operation()) or
            (self.igp_areas is not None and self.igp_areas.has_operation()) or
            (self.issu is not None and self.issu.has_operation()) or
            (self.lsp_out_of_resources is not None and self.lsp_out_of_resources.has_operation()) or
            (self.maximum_tunnels is not None and self.maximum_tunnels.has_operation()) or
            (self.nsr is not None and self.nsr.has_operation()) or
            (self.open_config is not None and self.open_config.has_operation()) or
            (self.p2mp is not None and self.p2mp.has_operation()) or
            (self.p2p_p2mp_tunnel is not None and self.p2p_p2mp_tunnel.has_operation()) or
            (self.path_protection is not None and self.path_protection.has_operation()) or
            (self.signalling_counters is not None and self.signalling_counters.has_operation()) or
            (self.soft_preemption is not None and self.soft_preemption.has_operation()) or
            (self.topology is not None and self.topology.has_operation()) or
            (self.topology_briefs is not None and self.topology_briefs.has_operation()) or
            (self.topology_nodes is not None and self.topology_nodes.has_operation()) or
            (self.tunnels is not None and self.tunnels.has_operation()) or
            (self.wrap_protection is not None and self.wrap_protection.has_operation()))

    def get_segment_path(self):
        path_buffer = ""
        path_buffer = "Cisco-IOS-XR-mpls-te-oper:mpls-te-standby" + path_buffer

        return path_buffer

    def get_entity_path(self, ancestor):
        path_buffer = ""
        if (not ancestor is None):
            raise YPYModelError("ancestor has to be None for top-level node")

        path_buffer = self.get_segment_path()
        leaf_name_data = LeafDataList()

        entity_path = EntityPath(path_buffer, leaf_name_data)
        return entity_path

    def get_child_by_name(self, child_yang_name, segment_path):
        child = self._get_child_by_seg_name([child_yang_name, segment_path])
        if child is not None:
            return child

        if (child_yang_name == "affinity-map"):
            if (self.affinity_map is None):
                self.affinity_map = MplsTeStandby.AffinityMap()
                self.affinity_map.parent = self
                self._children_name_map["affinity_map"] = "affinity-map"
            return self.affinity_map

        if (child_yang_name == "announce-tunnels-info"):
            if (self.announce_tunnels_info is None):
                self.announce_tunnels_info = MplsTeStandby.AnnounceTunnelsInfo()
                self.announce_tunnels_info.parent = self
                self._children_name_map["announce_tunnels_info"] = "announce-tunnels-info"
            return self.announce_tunnels_info

        if (child_yang_name == "attribute-sets"):
            if (self.attribute_sets is None):
                self.attribute_sets = MplsTeStandby.AttributeSets()
                self.attribute_sets.parent = self
                self._children_name_map["attribute_sets"] = "attribute-sets"
            return self.attribute_sets

        if (child_yang_name == "auto-tunnel"):
            if (self.auto_tunnel is None):
                self.auto_tunnel = MplsTeStandby.AutoTunnel()
                self.auto_tunnel.parent = self
                self._children_name_map["auto_tunnel"] = "auto-tunnel"
            return self.auto_tunnel

        if (child_yang_name == "auto-tunnel-services"):
            if (self.auto_tunnel_services is None):
                self.auto_tunnel_services = MplsTeStandby.AutoTunnelServices()
                self.auto_tunnel_services.parent = self
                self._children_name_map["auto_tunnel_services"] = "auto-tunnel-services"
            return self.auto_tunnel_services

        if (child_yang_name == "bfd"):
            if (self.bfd is None):
                self.bfd = MplsTeStandby.Bfd()
                self.bfd.parent = self
                self._children_name_map["bfd"] = "bfd"
            return self.bfd

        if (child_yang_name == "collaborator-timers"):
            if (self.collaborator_timers is None):
                self.collaborator_timers = MplsTeStandby.CollaboratorTimers()
                self.collaborator_timers.parent = self
                self._children_name_map["collaborator_timers"] = "collaborator-timers"
            return self.collaborator_timers

        if (child_yang_name == "diff-serv-te-classes"):
            if (self.diff_serv_te_classes is None):
                self.diff_serv_te_classes = MplsTeStandby.DiffServTeClasses()
                self.diff_serv_te_classes.parent = self
                self._children_name_map["diff_serv_te_classes"] = "diff-serv-te-classes"
            return self.diff_serv_te_classes

        if (child_yang_name == "fast-reroute"):
            if (self.fast_reroute is None):
                self.fast_reroute = MplsTeStandby.FastReroute()
                self.fast_reroute.parent = self
                self._children_name_map["fast_reroute"] = "fast-reroute"
            return self.fast_reroute

        if (child_yang_name == "fib-next-hop-label-routes"):
            if (self.fib_next_hop_label_routes is None):
                self.fib_next_hop_label_routes = MplsTeStandby.FibNextHopLabelRoutes()
                self.fib_next_hop_label_routes.parent = self
                self._children_name_map["fib_next_hop_label_routes"] = "fib-next-hop-label-routes"
            return self.fib_next_hop_label_routes

        if (child_yang_name == "forwarding-adjacency-destinations"):
            if (self.forwarding_adjacency_destinations is None):
                self.forwarding_adjacency_destinations = MplsTeStandby.ForwardingAdjacencyDestinations()
                self.forwarding_adjacency_destinations.parent = self
                self._children_name_map["forwarding_adjacency_destinations"] = "forwarding-adjacency-destinations"
            return self.forwarding_adjacency_destinations

        if (child_yang_name == "hardware-out-of-resources"):
            if (self.hardware_out_of_resources is None):
                self.hardware_out_of_resources = MplsTeStandby.HardwareOutOfResources()
                self.hardware_out_of_resources.parent = self
                self._children_name_map["hardware_out_of_resources"] = "hardware-out-of-resources"
            return self.hardware_out_of_resources

        if (child_yang_name == "igp-area-briefs"):
            if (self.igp_area_briefs is None):
                self.igp_area_briefs = MplsTeStandby.IgpAreaBriefs()
                self.igp_area_briefs.parent = self
                self._children_name_map["igp_area_briefs"] = "igp-area-briefs"
            return self.igp_area_briefs

        if (child_yang_name == "igp-areas"):
            if (self.igp_areas is None):
                self.igp_areas = MplsTeStandby.IgpAreas()
                self.igp_areas.parent = self
                self._children_name_map["igp_areas"] = "igp-areas"
            return self.igp_areas

        if (child_yang_name == "issu"):
            if (self.issu is None):
                self.issu = MplsTeStandby.Issu()
                self.issu.parent = self
                self._children_name_map["issu"] = "issu"
            return self.issu

        if (child_yang_name == "lsp-out-of-resources"):
            if (self.lsp_out_of_resources is None):
                self.lsp_out_of_resources = MplsTeStandby.LspOutOfResources()
                self.lsp_out_of_resources.parent = self
                self._children_name_map["lsp_out_of_resources"] = "lsp-out-of-resources"
            return self.lsp_out_of_resources

        if (child_yang_name == "maximum-tunnels"):
            if (self.maximum_tunnels is None):
                self.maximum_tunnels = MplsTeStandby.MaximumTunnels()
                self.maximum_tunnels.parent = self
                self._children_name_map["maximum_tunnels"] = "maximum-tunnels"
            return self.maximum_tunnels

        if (child_yang_name == "nsr"):
            if (self.nsr is None):
                self.nsr = MplsTeStandby.Nsr()
                self.nsr.parent = self
                self._children_name_map["nsr"] = "nsr"
            return self.nsr

        if (child_yang_name == "open-config"):
            if (self.open_config is None):
                self.open_config = MplsTeStandby.OpenConfig()
                self.open_config.parent = self
                self._children_name_map["open_config"] = "open-config"
            return self.open_config

        if (child_yang_name == "p2mp"):
            if (self.p2mp is None):
                self.p2mp = MplsTeStandby.P2Mp()
                self.p2mp.parent = self
                self._children_name_map["p2mp"] = "p2mp"
            return self.p2mp

        if (child_yang_name == "p2p-p2mp-tunnel"):
            if (self.p2p_p2mp_tunnel is None):
                self.p2p_p2mp_tunnel = MplsTeStandby.P2PP2MpTunnel()
                self.p2p_p2mp_tunnel.parent = self
                self._children_name_map["p2p_p2mp_tunnel"] = "p2p-p2mp-tunnel"
            return self.p2p_p2mp_tunnel

        if (child_yang_name == "path-protection"):
            if (self.path_protection is None):
                self.path_protection = MplsTeStandby.PathProtection()
                self.path_protection.parent = self
                self._children_name_map["path_protection"] = "path-protection"
            return self.path_protection

        if (child_yang_name == "signalling-counters"):
            if (self.signalling_counters is None):
                self.signalling_counters = MplsTeStandby.SignallingCounters()
                self.signalling_counters.parent = self
                self._children_name_map["signalling_counters"] = "signalling-counters"
            return self.signalling_counters

        if (child_yang_name == "soft-preemption"):
            if (self.soft_preemption is None):
                self.soft_preemption = MplsTeStandby.SoftPreemption()
                self.soft_preemption.parent = self
                self._children_name_map["soft_preemption"] = "soft-preemption"
            return self.soft_preemption

        if (child_yang_name == "topology"):
            if (self.topology is None):
                self.topology = MplsTeStandby.Topology()
                self.topology.parent = self
                self._children_name_map["topology"] = "topology"
            return self.topology

        if (child_yang_name == "topology-briefs"):
            if (self.topology_briefs is None):
                self.topology_briefs = MplsTeStandby.TopologyBriefs()
                self.topology_briefs.parent = self
                self._children_name_map["topology_briefs"] = "topology-briefs"
            return self.topology_briefs

        if (child_yang_name == "topology-nodes"):
            if (self.topology_nodes is None):
                self.topology_nodes = MplsTeStandby.TopologyNodes()
                self.topology_nodes.parent = self
                self._children_name_map["topology_nodes"] = "topology-nodes"
            return self.topology_nodes

        if (child_yang_name == "tunnels"):
            if (self.tunnels is None):
                self.tunnels = MplsTeStandby.Tunnels()
                self.tunnels.parent = self
                self._children_name_map["tunnels"] = "tunnels"
            return self.tunnels

        if (child_yang_name == "wrap-protection"):
            if (self.wrap_protection is None):
                self.wrap_protection = MplsTeStandby.WrapProtection()
                self.wrap_protection.parent = self
                self._children_name_map["wrap_protection"] = "wrap-protection"
            return self.wrap_protection

        return None

    def has_leaf_or_child_of_name(self, name):
        if(name == "affinity-map" or name == "announce-tunnels-info" or name == "attribute-sets" or name == "auto-tunnel" or name == "auto-tunnel-services" or name == "bfd" or name == "collaborator-timers" or name == "diff-serv-te-classes" or name == "fast-reroute" or name == "fib-next-hop-label-routes" or name == "forwarding-adjacency-destinations" or name == "hardware-out-of-resources" or name == "igp-area-briefs" or name == "igp-areas" or name == "issu" or name == "lsp-out-of-resources" or name == "maximum-tunnels" or name == "nsr" or name == "open-config" or name == "p2mp" or name == "p2p-p2mp-tunnel" or name == "path-protection" or name == "signalling-counters" or name == "soft-preemption" or name == "topology" or name == "topology-briefs" or name == "topology-nodes" or name == "tunnels" or name == "wrap-protection"):
            return True
        return False

    def set_value(self, value_path, value, name_space, name_space_prefix):
        pass

    def clone_ptr(self):
        self._top_entity = MplsTeStandby()
        return self._top_entity

